// public class gnu.java.security.provider.DSAKeyFactory

// class file dependencies
// @dep_class 54be5494c58fd4a8 gnu_java_security_provider_DSAKeyFactory
// @dep_class 18d6bda3b179d358 gnu_java_security_provider_GnuDSAPrivateKey
// @dep_class 84d8d4a6e8de7d16 gnu_java_security_provider_GnuDSAPublicKey
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class 1f925cf50bfc0d6c java_lang_ClassNotFoundException
// @dep_class 308333d803f5ab9f java_lang_Error
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class 680cf34d05feb5a1 java_lang_IllegalArgumentException
// @dep_class b7e704701c278e65 java_lang_IllegalStateException
// @dep_class 3746e17e005bda9e java_lang_LinkageError
// @dep_class 2082ebb592ac2255 java_lang_NoClassDefFoundError
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class 4f5534a987354d1d java_lang_RuntimeException
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class 238a2c0aafd74314 java_lang_VMClass
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class 7717ded55c30b7f3 java_math_BigInteger
// @dep_class 692089051f4c8d0b java_security_GeneralSecurityException
// @dep_class 94dda41e9bf6c170 java_security_InvalidKeyException
// @dep_class a467c6cd05d9cc51 java_security_Key
// @dep_class 965d036f0f33fac6 java_security_KeyException
// @dep_class 5208a7db73e048db java_security_KeyFactorySpi
// @dep_class dcdbe4a102f59043 java_security_PrivateKey
// @dep_class 4db3ac05e70e2bf8 java_security_PublicKey
// @dep_class f4f2d6013f72861e java_security_interfaces_DSAParams
// @dep_class d57e7f1f963e5163 java_security_interfaces_DSAPrivateKey
// @dep_class bad97fafc9653a27 java_security_interfaces_DSAPublicKey
// @dep_class 61e0ec33066ad42 java_security_spec_DSAPrivateKeySpec
// @dep_class e16a98c9d4bd4893 java_security_spec_DSAPublicKeySpec
// @dep_class 602c9e525972bdb8 java_security_spec_InvalidKeySpecException
// @dep_class e5bd533daf8dcb9a java_security_spec_KeySpec

// header file dependencies
// @dep_header gnu_java_security_provider_DSAKeyFactory
// @dep_header gnu_java_security_provider_GnuDSAPrivateKey
// @dep_header gnu_java_security_provider_GnuDSAPublicKey
// @dep_header java_lang_Class
// @dep_header java_lang_ClassNotFoundException
// @dep_header java_lang_IllegalArgumentException
// @dep_header java_lang_IllegalStateException
// @dep_header java_lang_NoClassDefFoundError
// @dep_header java_lang_String
// @dep_header java_lang_VMClass
// @dep_header java_lang_VMThrowable
// @dep_header java_math_BigInteger
// @dep_header java_security_InvalidKeyException
// @dep_header java_security_Key
// @dep_header java_security_PrivateKey
// @dep_header java_security_PublicKey
// @dep_header java_security_interfaces_DSAParams
// @dep_header java_security_interfaces_DSAPrivateKey
// @dep_header java_security_interfaces_DSAPublicKey
// @dep_header java_security_spec_DSAPrivateKeySpec
// @dep_header java_security_spec_DSAPublicKeySpec
// @dep_header java_security_spec_InvalidKeySpecException
// @dep_header java_security_spec_KeySpec

#include "jc_defs.h"

#include "gnu/java/security/provider/DSAKeyFactory.h"
#include "gnu/java/security/provider/GnuDSAPrivateKey.h"
#include "gnu/java/security/provider/GnuDSAPublicKey.h"
#include "java/lang/Class.h"
#include "java/lang/ClassNotFoundException.h"
#include "java/lang/IllegalArgumentException.h"
#include "java/lang/IllegalStateException.h"
#include "java/lang/NoClassDefFoundError.h"
#include "java/lang/String.h"
#include "java/lang/VMClass.h"
#include "java/lang/VMThrowable.h"
#include "java/math/BigInteger.h"
#include "java/security/InvalidKeyException.h"
#include "java/security/Key.h"
#include "java/security/PrivateKey.h"
#include "java/security/PublicKey.h"
#include "java/security/interfaces/DSAParams.h"
#include "java/security/interfaces/DSAPrivateKey.h"
#include "java/security/interfaces/DSAPublicKey.h"
#include "java/security/spec/DSAPrivateKeySpec.h"
#include "java/security/spec/DSAPublicKeySpec.h"
#include "java/security/spec/InvalidKeySpecException.h"
#include "java/security/spec/KeySpec.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// static java.lang.Class class$java$security$spec$DSAPublicKeySpec
static _jc_field _jc_gnu_java_security_provider_DSAKeyFactory$field_info$class__24java__24security__24spec__24DSAPublicKeySpec = {
	.name=		"class$java$security$spec$DSAPublicKeySpec",
	.signature=	"Ljava/lang/Class;",
	.class=		&_jc_gnu_java_security_provider_DSAKeyFactory$type,
	.type=		&_jc_java_lang_Class$type,
	.access_flags=	_JC_ACC_STATIC,
	.offset=	_JC_OFFSETOF(_jc_gnu_java_security_provider_DSAKeyFactory$fields_struct, class__24java__24security__24spec__24DSAPublicKeySpec),
};

// static java.lang.Class class$java$security$spec$DSAPrivateKeySpec
static _jc_field _jc_gnu_java_security_provider_DSAKeyFactory$field_info$class__24java__24security__24spec__24DSAPrivateKeySpec = {
	.name=		"class$java$security$spec$DSAPrivateKeySpec",
	.signature=	"Ljava/lang/Class;",
	.class=		&_jc_gnu_java_security_provider_DSAKeyFactory$type,
	.type=		&_jc_java_lang_Class$type,
	.access_flags=	_JC_ACC_STATIC,
	.offset=	_JC_OFFSETOF(_jc_gnu_java_security_provider_DSAKeyFactory$fields_struct, class__24java__24security__24spec__24DSAPrivateKeySpec),
};

// Fields
static _jc_field *const _jc_gnu_java_security_provider_DSAKeyFactory$fields[] = {
	&_jc_gnu_java_security_provider_DSAKeyFactory$field_info$class__24java__24security__24spec__24DSAPrivateKeySpec,
	&_jc_gnu_java_security_provider_DSAKeyFactory$field_info$class__24java__24security__24spec__24DSAPublicKeySpec
};

/************************************************************************
 *			      Static methods				*
 ************************************************************************/

//
// static java.lang.Class 'class'(java.lang.String, boolean)
//

static _jc_trap_info _jc_gnu_java_security_provider_DSAKeyFactory$trap_table$class$c900dc17c9967b78[] = {
	_JC_TRAP(&_jc_java_lang_ClassNotFoundException$type, 1, 2),
};

static const unsigned char _jc_gnu_java_security_provider_DSAKeyFactory$param_ptypes$class$c900dc17c9967b78[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_gnu_java_security_provider_DSAKeyFactory$param_types$class$c900dc17c9967b78[] = {
	&_jc_java_lang_String$type,
	&_jc_boolean$prim$type
};

_jc_method _jc_gnu_java_security_provider_DSAKeyFactory$method_info$class$c900dc17c9967b78 = {
	.name=			"class",
	.signature=		"(Ljava/lang/String;Z)Ljava/lang/Class;",
	.class=			&_jc_gnu_java_security_provider_DSAKeyFactory$type,
	.param_types=		&_jc_gnu_java_security_provider_DSAKeyFactory$param_types$class$c900dc17c9967b78,
	.return_type=		&_jc_java_lang_Class$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSAKeyFactory$param_ptypes$class$c900dc17c9967b78,
	.signature_hash=	_JC_JLONG(0xc900dc17c9967b78),
	.access_flags=		_JC_ACC_STATIC,
	.function=		&_jc_gnu_java_security_provider_DSAKeyFactory$method$class$c900dc17c9967b78,
	.num_parameters=	2,
	.u= { .exec= {
	  .trap_table_len=	1,
	  .trap_table=		_jc_gnu_java_security_provider_DSAKeyFactory$trap_table$class$c900dc17c9967b78,
	} },
};

_jc_java_lang_Class$object * _JC_JCNI_ATTR
_jc_gnu_java_security_provider_DSAKeyFactory$method$class$c900dc17c9967b78(_jc_env *const env, _jc_java_lang_String$object *param0, jboolean param1)
{
	struct _jc_java_lang_String$object *r0;
	struct _jc_java_lang_NoClassDefFoundError$object *volatile r1;
	struct _jc_java_lang_Class$object *r2;
	struct _jc_java_lang_ClassNotFoundException$object *volatile r3;
	struct _jc_java_lang_Throwable$object *volatile r4;
	struct _jc_java_lang_Class$object *r5;
	struct _jc_java_lang_String$object *volatile r6;
	struct _jc_java_lang_VMThrowable$object *volatile r8;
	jboolean z0;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_gnu_java_security_provider_DSAKeyFactory$method_info$class$c900dc17c9967b78, &&label1);

	r0 = param0;
	z0 = param1;
	_JC_TRAP_REGION(catch, 1);
	r2 = _JC_INVOKE_STATIC(env, java_lang_Class, forName$d3b57db3b6a905a3, 1, r0);
	if (z0 != 0)
		goto label0;
	_JC_EXPLICIT_NULL_CHECK(env, r2);
	r5 = _JC_INVOKE_STATIC(env, java_lang_VMClass, getComponentType$092b8e60c26feb25, 0, r2);
	r2 = r5;

label0:
	_JC_CANCEL_TRAPS(env, catch);
	return r2;

label1:
	_JC_TRAP_REGION(catch, 2);
	r3 = _JC_CAUGHT_EXCEPTION(env);
	r1 = _JC_NEW(env, java_lang_NoClassDefFoundError);
	r6 = _JC_NULL;
	_JC_REF_FIELD(env, r1, java_lang_Throwable, cause) = r1;
	r8 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r1);
	_JC_REF_FIELD(env, r1, java_lang_Throwable, vmState) = r8;
	_JC_REF_FIELD(env, r1, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r1, java_lang_Throwable, detailMessage) = r6;
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_Throwable, initCause$997fed19751e1c64, 0, r1, r3);
	_JC_THROW(env, r4);
}

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// public void <init>()
//

static _jc_linenum _jc_gnu_java_security_provider_DSAKeyFactory$linenum_table$_init$52f4ad9f2989aeee[];

static const unsigned char _jc_gnu_java_security_provider_DSAKeyFactory$param_ptypes$_init$52f4ad9f2989aeee[] = { 
_JC_TYPE_VOID };

_jc_method _jc_gnu_java_security_provider_DSAKeyFactory$method_info$_init$52f4ad9f2989aeee = {
	.name=			"<init>",
	.signature=		"()V",
	.class=			&_jc_gnu_java_security_provider_DSAKeyFactory$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSAKeyFactory$param_ptypes$_init$52f4ad9f2989aeee,
	.signature_hash=	_JC_JLONG(0x52f4ad9f2989aeee),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_provider_DSAKeyFactory$method$_init$52f4ad9f2989aeee,
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_gnu_java_security_provider_DSAKeyFactory$linenum_table$_init$52f4ad9f2989aeee
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_DSAKeyFactory, _init$52f4ad9f2989aeee);

void _JC_JCNI_ATTR
_jc_gnu_java_security_provider_DSAKeyFactory$method$_init$52f4ad9f2989aeee(_jc_env *const env, _jc_gnu_java_security_provider_DSAKeyFactory$object *this)
{
	struct _jc_gnu_java_security_provider_DSAKeyFactory$object *r0;

	r0 = this;
	_JC_LINE_NUMBER(67);				// 0
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// protected java.security.PrivateKey engineGeneratePrivate(java.security.spec.KeySpec) throws java.security.spec.InvalidKeySpecException
//

static _jc_linenum _jc_gnu_java_security_provider_DSAKeyFactory$linenum_table$engineGeneratePrivate$5f899f5d07075f18[];

static const unsigned char _jc_gnu_java_security_provider_DSAKeyFactory$param_ptypes$engineGeneratePrivate$5f899f5d07075f18[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_gnu_java_security_provider_DSAKeyFactory$exceptions$engineGeneratePrivate$5f899f5d07075f18[] = {
	&_jc_java_security_spec_InvalidKeySpecException$type
};

static _jc_type *const _jc_gnu_java_security_provider_DSAKeyFactory$param_types$engineGeneratePrivate$5f899f5d07075f18[] = {
	&_jc_java_security_spec_KeySpec$type
};

_jc_method _jc_gnu_java_security_provider_DSAKeyFactory$method_info$engineGeneratePrivate$5f899f5d07075f18 = {
	.name=			"engineGeneratePrivate",
	.signature=		"(Ljava/security/spec/KeySpec;)Ljava/security/PrivateKey;",
	.class=			&_jc_gnu_java_security_provider_DSAKeyFactory$type,
	.param_types=		&_jc_gnu_java_security_provider_DSAKeyFactory$param_types$engineGeneratePrivate$5f899f5d07075f18,
	.return_type=		&_jc_java_security_PrivateKey$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSAKeyFactory$param_ptypes$engineGeneratePrivate$5f899f5d07075f18,
	.signature_hash=	_JC_JLONG(0x5f899f5d07075f18),
	.access_flags=		_JC_ACC_PROTECTED,
	.function=		&_jc_gnu_java_security_provider_DSAKeyFactory$method$engineGeneratePrivate$5f899f5d07075f18,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_provider_DSAKeyFactory$vtable, gnu_java_security_provider_DSAKeyFactory.engineGeneratePrivate$5f899f5d07075f18) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_gnu_java_security_provider_DSAKeyFactory$exceptions$engineGeneratePrivate$5f899f5d07075f18,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_gnu_java_security_provider_DSAKeyFactory$linenum_table$engineGeneratePrivate$5f899f5d07075f18
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_DSAKeyFactory, engineGeneratePrivate$5f899f5d07075f18);

_jc_object * _JC_JCNI_ATTR
_jc_gnu_java_security_provider_DSAKeyFactory$method$engineGeneratePrivate$5f899f5d07075f18(_jc_env *const env, _jc_gnu_java_security_provider_DSAKeyFactory$object *this, _jc_object *param0)
{
	struct _jc_gnu_java_security_provider_DSAKeyFactory$object *r0;
	struct _jc_object *r1;
	struct _jc_java_lang_VMThrowable$object *r10;
	struct _jc_java_security_spec_InvalidKeySpecException$object *r2;
	struct _jc_gnu_java_security_provider_GnuDSAPrivateKey$object *r3;
	struct _jc_java_security_spec_DSAPrivateKeySpec$object *r4;
	struct _jc_java_math_BigInteger$object *r5;
	struct _jc_java_math_BigInteger$object *r6;
	struct _jc_java_math_BigInteger$object *r7;
	struct _jc_java_math_BigInteger$object *r8;
	struct _jc_java_lang_String$object *r9;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(75);				// 0
	z0 = _JC_INSTANCEOF(env, r1, &_jc_java_security_spec_DSAPrivateKeySpec$type);
	if (z0 != 0)
		goto label0;
	_JC_LINE_NUMBER(76);				// 1
	r2 = _JC_NEW(env, java_security_spec_InvalidKeySpecException);
	r9 = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, cause) = r2;
	r10 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r2);
	_JC_REF_FIELD(env, r2, java_lang_Throwable, vmState) = r10;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, detailMessage) = r9;
	_JC_THROW(env, r2);

label0:
	_JC_LINE_NUMBER(77);				// 2
	r3 = _JC_NEW(env, gnu_java_security_provider_GnuDSAPrivateKey);
	r4 = r1;
	r5 = _JC_INVOKE_VIRTUAL(env, java_security_spec_DSAPrivateKeySpec, getX$568a3b7b0d38db21, r4);
	r4 = r1;
	r6 = _JC_INVOKE_VIRTUAL(env, java_security_spec_DSAPrivateKeySpec, getP$612c6062f1779963, r4);
	r4 = r1;
	r7 = _JC_INVOKE_VIRTUAL(env, java_security_spec_DSAPrivateKeySpec, getQ$e08c53541a87120d, r4);
	r4 = r1;
	r8 = _JC_INVOKE_VIRTUAL(env, java_security_spec_DSAPrivateKeySpec, getG$59cffd735b56d8ad, r4);
	_JC_REF_FIELD(env, r3, gnu_java_security_provider_GnuDSAPrivateKey, x) = r5;
	_JC_REF_FIELD(env, r3, gnu_java_security_provider_GnuDSAPrivateKey, p) = r6;
	_JC_REF_FIELD(env, r3, gnu_java_security_provider_GnuDSAPrivateKey, q) = r7;
	_JC_REF_FIELD(env, r3, gnu_java_security_provider_GnuDSAPrivateKey, g) = r8;
	return r3;
}

//
// protected java.security.PublicKey engineGeneratePublic(java.security.spec.KeySpec) throws java.security.spec.InvalidKeySpecException
//

static _jc_linenum _jc_gnu_java_security_provider_DSAKeyFactory$linenum_table$engineGeneratePublic$7ad176effa9fa186[];

static const unsigned char _jc_gnu_java_security_provider_DSAKeyFactory$param_ptypes$engineGeneratePublic$7ad176effa9fa186[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_gnu_java_security_provider_DSAKeyFactory$exceptions$engineGeneratePublic$7ad176effa9fa186[] = {
	&_jc_java_security_spec_InvalidKeySpecException$type
};

static _jc_type *const _jc_gnu_java_security_provider_DSAKeyFactory$param_types$engineGeneratePublic$7ad176effa9fa186[] = {
	&_jc_java_security_spec_KeySpec$type
};

_jc_method _jc_gnu_java_security_provider_DSAKeyFactory$method_info$engineGeneratePublic$7ad176effa9fa186 = {
	.name=			"engineGeneratePublic",
	.signature=		"(Ljava/security/spec/KeySpec;)Ljava/security/PublicKey;",
	.class=			&_jc_gnu_java_security_provider_DSAKeyFactory$type,
	.param_types=		&_jc_gnu_java_security_provider_DSAKeyFactory$param_types$engineGeneratePublic$7ad176effa9fa186,
	.return_type=		&_jc_java_security_PublicKey$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSAKeyFactory$param_ptypes$engineGeneratePublic$7ad176effa9fa186,
	.signature_hash=	_JC_JLONG(0x7ad176effa9fa186),
	.access_flags=		_JC_ACC_PROTECTED,
	.function=		&_jc_gnu_java_security_provider_DSAKeyFactory$method$engineGeneratePublic$7ad176effa9fa186,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_provider_DSAKeyFactory$vtable, gnu_java_security_provider_DSAKeyFactory.engineGeneratePublic$7ad176effa9fa186) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_gnu_java_security_provider_DSAKeyFactory$exceptions$engineGeneratePublic$7ad176effa9fa186,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_gnu_java_security_provider_DSAKeyFactory$linenum_table$engineGeneratePublic$7ad176effa9fa186
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_DSAKeyFactory, engineGeneratePublic$7ad176effa9fa186);

_jc_object * _JC_JCNI_ATTR
_jc_gnu_java_security_provider_DSAKeyFactory$method$engineGeneratePublic$7ad176effa9fa186(_jc_env *const env, _jc_gnu_java_security_provider_DSAKeyFactory$object *this, _jc_object *param0)
{
	struct _jc_gnu_java_security_provider_DSAKeyFactory$object *r0;
	struct _jc_object *r1;
	struct _jc_java_lang_VMThrowable$object *r10;
	struct _jc_java_security_spec_InvalidKeySpecException$object *r2;
	struct _jc_gnu_java_security_provider_GnuDSAPublicKey$object *r3;
	struct _jc_java_security_spec_DSAPublicKeySpec$object *r4;
	struct _jc_java_math_BigInteger$object *r5;
	struct _jc_java_math_BigInteger$object *r6;
	struct _jc_java_math_BigInteger$object *r7;
	struct _jc_java_math_BigInteger$object *r8;
	struct _jc_java_lang_String$object *r9;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(87);				// 0
	z0 = _JC_INSTANCEOF(env, r1, &_jc_java_security_spec_DSAPublicKeySpec$type);
	if (z0 != 0)
		goto label0;
	_JC_LINE_NUMBER(88);				// 1
	r2 = _JC_NEW(env, java_security_spec_InvalidKeySpecException);
	r9 = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, cause) = r2;
	r10 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r2);
	_JC_REF_FIELD(env, r2, java_lang_Throwable, vmState) = r10;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, detailMessage) = r9;
	_JC_THROW(env, r2);

label0:
	_JC_LINE_NUMBER(89);				// 2
	r3 = _JC_NEW(env, gnu_java_security_provider_GnuDSAPublicKey);
	r4 = r1;
	r5 = _JC_INVOKE_VIRTUAL(env, java_security_spec_DSAPublicKeySpec, getY$e067a5f1fb934d2a, r4);
	r4 = r1;
	r6 = _JC_INVOKE_VIRTUAL(env, java_security_spec_DSAPublicKeySpec, getP$612c6062f1779963, r4);
	r4 = r1;
	r7 = _JC_INVOKE_VIRTUAL(env, java_security_spec_DSAPublicKeySpec, getQ$e08c53541a87120d, r4);
	r4 = r1;
	r8 = _JC_INVOKE_VIRTUAL(env, java_security_spec_DSAPublicKeySpec, getG$59cffd735b56d8ad, r4);
	_JC_REF_FIELD(env, r3, gnu_java_security_provider_GnuDSAPublicKey, y) = r5;
	_JC_REF_FIELD(env, r3, gnu_java_security_provider_GnuDSAPublicKey, p) = r6;
	_JC_REF_FIELD(env, r3, gnu_java_security_provider_GnuDSAPublicKey, q) = r7;
	_JC_REF_FIELD(env, r3, gnu_java_security_provider_GnuDSAPublicKey, g) = r8;
	return r3;
}

//
// protected java.security.spec.KeySpec engineGetKeySpec(java.security.Key, java.lang.Class) throws java.security.spec.InvalidKeySpecException
//

static _jc_linenum _jc_gnu_java_security_provider_DSAKeyFactory$linenum_table$engineGetKeySpec$8e11b093f262567f[];

static _jc_trap_info _jc_gnu_java_security_provider_DSAKeyFactory$trap_table$engineGetKeySpec$8e11b093f262567f[] = {
	_JC_TRAP(&_jc_java_lang_ClassNotFoundException$type, 3, 4),
	_JC_TRAP(&_jc_java_lang_ClassNotFoundException$type, 1, 2),
};

static const unsigned char _jc_gnu_java_security_provider_DSAKeyFactory$param_ptypes$engineGetKeySpec$8e11b093f262567f[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_gnu_java_security_provider_DSAKeyFactory$exceptions$engineGetKeySpec$8e11b093f262567f[] = {
	&_jc_java_security_spec_InvalidKeySpecException$type
};

static _jc_type *const _jc_gnu_java_security_provider_DSAKeyFactory$param_types$engineGetKeySpec$8e11b093f262567f[] = {
	&_jc_java_security_Key$type,
	&_jc_java_lang_Class$type
};

_jc_method _jc_gnu_java_security_provider_DSAKeyFactory$method_info$engineGetKeySpec$8e11b093f262567f = {
	.name=			"engineGetKeySpec",
	.signature=		"(Ljava/security/Key;Ljava/lang/Class;)Ljava/security/spec/KeySpec;",
	.class=			&_jc_gnu_java_security_provider_DSAKeyFactory$type,
	.param_types=		&_jc_gnu_java_security_provider_DSAKeyFactory$param_types$engineGetKeySpec$8e11b093f262567f,
	.return_type=		&_jc_java_security_spec_KeySpec$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSAKeyFactory$param_ptypes$engineGetKeySpec$8e11b093f262567f,
	.signature_hash=	_JC_JLONG(0x8e11b093f262567f),
	.access_flags=		_JC_ACC_PROTECTED,
	.function=		&_jc_gnu_java_security_provider_DSAKeyFactory$method$engineGetKeySpec$8e11b093f262567f,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_provider_DSAKeyFactory$vtable, gnu_java_security_provider_DSAKeyFactory.engineGetKeySpec$8e11b093f262567f) / sizeof(void *),
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_gnu_java_security_provider_DSAKeyFactory$exceptions$engineGetKeySpec$8e11b093f262567f,
	.u= { .exec= {
	  .trap_table_len=	2,
	  .trap_table=		_jc_gnu_java_security_provider_DSAKeyFactory$trap_table$engineGetKeySpec$8e11b093f262567f,
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_gnu_java_security_provider_DSAKeyFactory$linenum_table$engineGetKeySpec$8e11b093f262567f
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_DSAKeyFactory, engineGetKeySpec$8e11b093f262567f);

_jc_object * _JC_JCNI_ATTR
_jc_gnu_java_security_provider_DSAKeyFactory$method$engineGetKeySpec$8e11b093f262567f(_jc_env *const env, _jc_gnu_java_security_provider_DSAKeyFactory$object *this, _jc_object *param0, _jc_java_lang_Class$object *param1)
{
	struct _jc_gnu_java_security_provider_DSAKeyFactory$object *r0;
	struct _jc_object *r1;
	struct _jc_java_math_BigInteger$object *r10;
	struct _jc_java_security_spec_DSAPrivateKeySpec$object *r11;
	struct _jc_object *r12;
	struct _jc_java_security_spec_InvalidKeySpecException$object *r13;
	struct _jc_java_lang_String$object *r14;
	struct _jc_java_lang_VMThrowable$object *r15;
	struct _jc_java_lang_String$object *r16;
	struct _jc_java_lang_NoClassDefFoundError$object *volatile r17;
	struct _jc_java_lang_Class$object *r18;
	struct _jc_java_lang_ClassNotFoundException$object *volatile r19;
	struct _jc_java_lang_Class$object *r2;
	struct _jc_java_lang_Class$object *r20;
	struct _jc_java_lang_String$object *volatile r21;
	struct _jc_java_lang_VMThrowable$object *volatile r22;
	struct _jc_java_lang_String$object *r23;
	struct _jc_java_lang_NoClassDefFoundError$object *volatile r24;
	struct _jc_java_lang_Class$object *r25;
	struct _jc_java_lang_ClassNotFoundException$object *volatile r26;
	struct _jc_java_lang_Throwable$object *volatile r27;
	struct _jc_java_lang_Class$object *r28;
	struct _jc_java_lang_String$object *volatile r29;
	struct _jc_java_lang_Class$object *r3;
	struct _jc_java_lang_VMThrowable$object *volatile r30;
	struct _jc_java_lang_IllegalArgumentException$object *volatile r31;
	struct _jc_java_lang_Throwable$object *volatile r32;
	struct _jc_java_lang_IllegalStateException$object *volatile r33;
	struct _jc_java_security_spec_DSAPublicKeySpec$object *r4;
	struct _jc_object *r5;
	struct _jc_java_math_BigInteger$object *r6;
	struct _jc_object *r7;
	struct _jc_java_math_BigInteger$object *r8;
	struct _jc_java_math_BigInteger$object *r9;
	jboolean z0;
	jboolean z1;
	jboolean z2;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_gnu_java_security_provider_DSAKeyFactory$method_info$engineGetKeySpec$8e11b093f262567f, &&label6, &&label0);

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_LINE_NUMBER(99);				// 0
	z0 = _JC_INSTANCEOF(env, r1, &_jc_java_security_interfaces_DSAPublicKey$type);
	if (z0 == 0)
		goto label5;
	r3 = _JC_STATIC_FIELD(env, gnu_java_security_provider_DSAKeyFactory, class__24java__24security__24spec__24DSAPublicKeySpec, 1);
	if (r3 != _JC_NULL)
		goto label4;
	r16 = _JC_STRING(env, "[Ljava.security.spec.DSAPublicKeySpec;");
	_JC_TRAP_REGION(catch, 1);
	r18 = _JC_INVOKE_STATIC(env, java_lang_Class, forName$d3b57db3b6a905a3, 1, r16);
	_JC_EXPLICIT_NULL_CHECK(env, r18);
	r20 = _JC_INVOKE_STATIC(env, java_lang_VMClass, getComponentType$092b8e60c26feb25, 0, r18);
	r3 = r20;
	goto label3;

label0:
	_JC_TRAP_REGION(catch, 2);
	r19 = _JC_CAUGHT_EXCEPTION(env);
	r17 = _JC_NEW(env, java_lang_NoClassDefFoundError);
	r21 = _JC_NULL;
	_JC_REF_FIELD(env, r17, java_lang_Throwable, cause) = r17;
	r22 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r17);
	_JC_REF_FIELD(env, r17, java_lang_Throwable, vmState) = r22;
	_JC_REF_FIELD(env, r17, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r17, java_lang_Throwable, detailMessage) = r21;
	if (r19 != r17)
		goto label1;
	r31 = _JC_NEW(env, java_lang_IllegalArgumentException);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_Throwable, _init$c31b894660454d13, 0, r31, _JC_NULL);
	_JC_THROW(env, r31);

label1:
	r32 = _JC_REF_FIELD(env, r17, java_lang_Throwable, cause);
	if (r32 == r17)
		goto label2;
	r33 = _JC_NEW(env, java_lang_IllegalStateException);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_Throwable, _init$c31b894660454d13, 0, r33, _JC_NULL);
	_JC_THROW(env, r33);

label2:
	_JC_REF_FIELD(env, r17, java_lang_Throwable, cause) = r19;
	_JC_THROW(env, r17);

label3:
	_JC_TRAP_REGION(catch, 2);
	_JC_STATIC_FIELD(env, gnu_java_security_provider_DSAKeyFactory, class__24java__24security__24spec__24DSAPublicKeySpec, 1) = r20;

label4:
	_JC_TRAP_REGION(catch, 2);
	_JC_EXPLICIT_NULL_CHECK(env, r2);
	z1 = _JC_INVOKE_STATIC(env, java_lang_VMClass, isAssignableFrom$c49c4ad8938bda0b, 0, r2, r3);
	if (z1 == 0)
		goto label5;
	_JC_LINE_NUMBER(102);				// 1
	r4 = _JC_NEW(env, java_security_spec_DSAPublicKeySpec);
	r5 = r1;
	r6 = _JC_INVOKE_INTERFACE(env, r5, _JC_JLONG(0xe067a5f1fb934d2a), _jc_object *, (_jc_env *, struct _jc_object *));
	r5 = r1;
	r7 = _JC_INVOKE_INTERFACE(env, r5, _JC_JLONG(0xcf8a9747be586d14), _jc_object *, (_jc_env *, struct _jc_object *));
	r8 = _JC_INVOKE_INTERFACE(env, r7, _JC_JLONG(0x612c6062f1779963), _jc_object *, (_jc_env *, struct _jc_object *));
	r5 = r1;
	r7 = _JC_INVOKE_INTERFACE(env, r5, _JC_JLONG(0xcf8a9747be586d14), _jc_object *, (_jc_env *, struct _jc_object *));
	r9 = _JC_INVOKE_INTERFACE(env, r7, _JC_JLONG(0xe08c53541a87120d), _jc_object *, (_jc_env *, struct _jc_object *));
	r5 = r1;
	r7 = _JC_INVOKE_INTERFACE(env, r5, _JC_JLONG(0xcf8a9747be586d14), _jc_object *, (_jc_env *, struct _jc_object *));
	r10 = _JC_INVOKE_INTERFACE(env, r7, _JC_JLONG(0x59cffd735b56d8ad), _jc_object *, (_jc_env *, struct _jc_object *));
	_JC_REF_FIELD(env, r4, java_security_spec_DSAPublicKeySpec, y) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_security_spec_DSAPublicKeySpec, p) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_security_spec_DSAPublicKeySpec, q) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_security_spec_DSAPublicKeySpec, g) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_security_spec_DSAPublicKeySpec, y) = r6;
	_JC_REF_FIELD(env, r4, java_security_spec_DSAPublicKeySpec, p) = r8;
	_JC_REF_FIELD(env, r4, java_security_spec_DSAPublicKeySpec, q) = r9;
	_JC_REF_FIELD(env, r4, java_security_spec_DSAPublicKeySpec, g) = r10;
	_JC_CANCEL_TRAPS(env, catch);
	return r4;

label5:
	_JC_TRAP_REGION(catch, 2);
	_JC_LINE_NUMBER(107);				// 2
	z0 = _JC_INSTANCEOF(env, r1, &_jc_java_security_interfaces_DSAPrivateKey$type);
	if (z0 == 0)
		goto label9;
	r3 = _JC_STATIC_FIELD(env, gnu_java_security_provider_DSAKeyFactory, class__24java__24security__24spec__24DSAPrivateKeySpec, 1);
	if (r3 != _JC_NULL)
		goto label8;
	r23 = _JC_STRING(env, "[Ljava.security.spec.DSAPrivateKeySpec;");
	_JC_TRAP_REGION(catch, 3);
	r25 = _JC_INVOKE_STATIC(env, java_lang_Class, forName$d3b57db3b6a905a3, 1, r23);
	_JC_EXPLICIT_NULL_CHECK(env, r25);
	r28 = _JC_INVOKE_STATIC(env, java_lang_VMClass, getComponentType$092b8e60c26feb25, 0, r25);
	r3 = r28;
	goto label7;

label6:
	_JC_TRAP_REGION(catch, 4);
	r26 = _JC_CAUGHT_EXCEPTION(env);
	r24 = _JC_NEW(env, java_lang_NoClassDefFoundError);
	r29 = _JC_NULL;
	_JC_REF_FIELD(env, r24, java_lang_Throwable, cause) = r24;
	r30 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r24);
	_JC_REF_FIELD(env, r24, java_lang_Throwable, vmState) = r30;
	_JC_REF_FIELD(env, r24, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r24, java_lang_Throwable, detailMessage) = r29;
	r27 = _JC_INVOKE_NONVIRTUAL(env, java_lang_Throwable, initCause$997fed19751e1c64, 0, r24, r26);
	_JC_THROW(env, r27);

label7:
	_JC_TRAP_REGION(catch, 4);
	_JC_STATIC_FIELD(env, gnu_java_security_provider_DSAKeyFactory, class__24java__24security__24spec__24DSAPrivateKeySpec, 1) = r28;

label8:
	_JC_TRAP_REGION(catch, 4);
	_JC_EXPLICIT_NULL_CHECK(env, r2);
	z2 = _JC_INVOKE_STATIC(env, java_lang_VMClass, isAssignableFrom$c49c4ad8938bda0b, 0, r2, r3);
	if (z2 == 0)
		goto label9;
	_JC_LINE_NUMBER(110);				// 3
	r11 = _JC_NEW(env, java_security_spec_DSAPrivateKeySpec);
	r12 = r1;
	r10 = _JC_INVOKE_INTERFACE(env, r12, _JC_JLONG(0x568a3b7b0d38db21), _jc_object *, (_jc_env *, struct _jc_object *));
	r12 = r1;
	r7 = _JC_INVOKE_INTERFACE(env, r12, _JC_JLONG(0xcf8a9747be586d14), _jc_object *, (_jc_env *, struct _jc_object *));
	r9 = _JC_INVOKE_INTERFACE(env, r7, _JC_JLONG(0x612c6062f1779963), _jc_object *, (_jc_env *, struct _jc_object *));
	r12 = r1;
	r7 = _JC_INVOKE_INTERFACE(env, r12, _JC_JLONG(0xcf8a9747be586d14), _jc_object *, (_jc_env *, struct _jc_object *));
	r8 = _JC_INVOKE_INTERFACE(env, r7, _JC_JLONG(0xe08c53541a87120d), _jc_object *, (_jc_env *, struct _jc_object *));
	r12 = r1;
	r7 = _JC_INVOKE_INTERFACE(env, r12, _JC_JLONG(0xcf8a9747be586d14), _jc_object *, (_jc_env *, struct _jc_object *));
	r6 = _JC_INVOKE_INTERFACE(env, r7, _JC_JLONG(0x59cffd735b56d8ad), _jc_object *, (_jc_env *, struct _jc_object *));
	_JC_REF_FIELD(env, r11, java_security_spec_DSAPrivateKeySpec, x) = _JC_NULL;
	_JC_REF_FIELD(env, r11, java_security_spec_DSAPrivateKeySpec, p) = _JC_NULL;
	_JC_REF_FIELD(env, r11, java_security_spec_DSAPrivateKeySpec, q) = _JC_NULL;
	_JC_REF_FIELD(env, r11, java_security_spec_DSAPrivateKeySpec, g) = _JC_NULL;
	_JC_REF_FIELD(env, r11, java_security_spec_DSAPrivateKeySpec, x) = r10;
	_JC_REF_FIELD(env, r11, java_security_spec_DSAPrivateKeySpec, p) = r9;
	_JC_REF_FIELD(env, r11, java_security_spec_DSAPrivateKeySpec, q) = r8;
	_JC_REF_FIELD(env, r11, java_security_spec_DSAPrivateKeySpec, g) = r6;
	_JC_CANCEL_TRAPS(env, catch);
	return r11;

label9:
	_JC_TRAP_REGION(catch, 4);
	_JC_LINE_NUMBER(115);				// 4
	r13 = _JC_NEW(env, java_security_spec_InvalidKeySpecException);
	r14 = _JC_NULL;
	_JC_REF_FIELD(env, r13, java_lang_Throwable, cause) = r13;
	r15 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r13);
	_JC_REF_FIELD(env, r13, java_lang_Throwable, vmState) = r15;
	_JC_REF_FIELD(env, r13, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r13, java_lang_Throwable, detailMessage) = r14;
	_JC_THROW(env, r13);
}

//
// protected java.security.Key engineTranslateKey(java.security.Key) throws java.security.InvalidKeyException
//

static _jc_linenum _jc_gnu_java_security_provider_DSAKeyFactory$linenum_table$engineTranslateKey$486445c69e67c534[];

static const unsigned char _jc_gnu_java_security_provider_DSAKeyFactory$param_ptypes$engineTranslateKey$486445c69e67c534[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_gnu_java_security_provider_DSAKeyFactory$exceptions$engineTranslateKey$486445c69e67c534[] = {
	&_jc_java_security_InvalidKeyException$type
};

static _jc_type *const _jc_gnu_java_security_provider_DSAKeyFactory$param_types$engineTranslateKey$486445c69e67c534[] = {
	&_jc_java_security_Key$type
};

_jc_method _jc_gnu_java_security_provider_DSAKeyFactory$method_info$engineTranslateKey$486445c69e67c534 = {
	.name=			"engineTranslateKey",
	.signature=		"(Ljava/security/Key;)Ljava/security/Key;",
	.class=			&_jc_gnu_java_security_provider_DSAKeyFactory$type,
	.param_types=		&_jc_gnu_java_security_provider_DSAKeyFactory$param_types$engineTranslateKey$486445c69e67c534,
	.return_type=		&_jc_java_security_Key$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSAKeyFactory$param_ptypes$engineTranslateKey$486445c69e67c534,
	.signature_hash=	_JC_JLONG(0x486445c69e67c534),
	.access_flags=		_JC_ACC_PROTECTED,
	.function=		&_jc_gnu_java_security_provider_DSAKeyFactory$method$engineTranslateKey$486445c69e67c534,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_provider_DSAKeyFactory$vtable, gnu_java_security_provider_DSAKeyFactory.engineTranslateKey$486445c69e67c534) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_gnu_java_security_provider_DSAKeyFactory$exceptions$engineTranslateKey$486445c69e67c534,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	7,
	      .table=	_jc_gnu_java_security_provider_DSAKeyFactory$linenum_table$engineTranslateKey$486445c69e67c534
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_DSAKeyFactory, engineTranslateKey$486445c69e67c534);

_jc_object * _JC_JCNI_ATTR
_jc_gnu_java_security_provider_DSAKeyFactory$method$engineTranslateKey$486445c69e67c534(_jc_env *const env, _jc_gnu_java_security_provider_DSAKeyFactory$object *this, _jc_object *param0)
{
	struct _jc_gnu_java_security_provider_DSAKeyFactory$object *r0;
	struct _jc_object *r1;
	struct _jc_object *r10;
	struct _jc_java_security_InvalidKeyException$object *r11;
	struct _jc_java_lang_String$object *r12;
	struct _jc_java_lang_VMThrowable$object *r13;
	struct _jc_gnu_java_security_provider_GnuDSAPublicKey$object *r2;
	struct _jc_object *r3;
	struct _jc_java_math_BigInteger$object *r4;
	struct _jc_object *r5;
	struct _jc_java_math_BigInteger$object *r6;
	struct _jc_java_math_BigInteger$object *r7;
	struct _jc_java_math_BigInteger$object *r8;
	struct _jc_gnu_java_security_provider_GnuDSAPrivateKey$object *r9;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(120);				// 0
	z0 = _JC_INSTANCEOF(env, r1, &_jc_gnu_java_security_provider_GnuDSAPublicKey$type);
	if (z0 != 0)
		goto label0;
	z0 = _JC_INSTANCEOF(env, r1, &_jc_gnu_java_security_provider_GnuDSAPrivateKey$type);
	if (z0 == 0)
		goto label1;

label0:
	_JC_LINE_NUMBER(121);				// 1
	return r1;

label1:
	_JC_LINE_NUMBER(122);				// 2
	z0 = _JC_INSTANCEOF(env, r1, &_jc_java_security_interfaces_DSAPublicKey$type);
	if (z0 == 0)
		goto label2;
	_JC_LINE_NUMBER(123);				// 3
	r2 = _JC_NEW(env, gnu_java_security_provider_GnuDSAPublicKey);
	r3 = r1;
	r4 = _JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0xe067a5f1fb934d2a), _jc_object *, (_jc_env *, struct _jc_object *));
	r3 = r1;
	r5 = _JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0xcf8a9747be586d14), _jc_object *, (_jc_env *, struct _jc_object *));
	r6 = _JC_INVOKE_INTERFACE(env, r5, _JC_JLONG(0x612c6062f1779963), _jc_object *, (_jc_env *, struct _jc_object *));
	r3 = r1;
	r5 = _JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0xcf8a9747be586d14), _jc_object *, (_jc_env *, struct _jc_object *));
	r7 = _JC_INVOKE_INTERFACE(env, r5, _JC_JLONG(0xe08c53541a87120d), _jc_object *, (_jc_env *, struct _jc_object *));
	r3 = r1;
	r5 = _JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0xcf8a9747be586d14), _jc_object *, (_jc_env *, struct _jc_object *));
	r8 = _JC_INVOKE_INTERFACE(env, r5, _JC_JLONG(0x59cffd735b56d8ad), _jc_object *, (_jc_env *, struct _jc_object *));
	_JC_REF_FIELD(env, r2, gnu_java_security_provider_GnuDSAPublicKey, y) = r4;
	_JC_REF_FIELD(env, r2, gnu_java_security_provider_GnuDSAPublicKey, p) = r6;
	_JC_REF_FIELD(env, r2, gnu_java_security_provider_GnuDSAPublicKey, q) = r7;
	_JC_REF_FIELD(env, r2, gnu_java_security_provider_GnuDSAPublicKey, g) = r8;
	return r2;

label2:
	_JC_LINE_NUMBER(127);				// 4
	z0 = _JC_INSTANCEOF(env, r1, &_jc_java_security_interfaces_DSAPrivateKey$type);
	if (z0 == 0)
		goto label3;
	_JC_LINE_NUMBER(128);				// 5
	r9 = _JC_NEW(env, gnu_java_security_provider_GnuDSAPrivateKey);
	r10 = r1;
	r8 = _JC_INVOKE_INTERFACE(env, r10, _JC_JLONG(0x568a3b7b0d38db21), _jc_object *, (_jc_env *, struct _jc_object *));
	r10 = r1;
	r5 = _JC_INVOKE_INTERFACE(env, r10, _JC_JLONG(0xcf8a9747be586d14), _jc_object *, (_jc_env *, struct _jc_object *));
	r7 = _JC_INVOKE_INTERFACE(env, r5, _JC_JLONG(0x612c6062f1779963), _jc_object *, (_jc_env *, struct _jc_object *));
	r10 = r1;
	r5 = _JC_INVOKE_INTERFACE(env, r10, _JC_JLONG(0xcf8a9747be586d14), _jc_object *, (_jc_env *, struct _jc_object *));
	r6 = _JC_INVOKE_INTERFACE(env, r5, _JC_JLONG(0xe08c53541a87120d), _jc_object *, (_jc_env *, struct _jc_object *));
	r10 = r1;
	r5 = _JC_INVOKE_INTERFACE(env, r10, _JC_JLONG(0xcf8a9747be586d14), _jc_object *, (_jc_env *, struct _jc_object *));
	r4 = _JC_INVOKE_INTERFACE(env, r5, _JC_JLONG(0x59cffd735b56d8ad), _jc_object *, (_jc_env *, struct _jc_object *));
	_JC_REF_FIELD(env, r9, gnu_java_security_provider_GnuDSAPrivateKey, x) = r8;
	_JC_REF_FIELD(env, r9, gnu_java_security_provider_GnuDSAPrivateKey, p) = r7;
	_JC_REF_FIELD(env, r9, gnu_java_security_provider_GnuDSAPrivateKey, q) = r6;
	_JC_REF_FIELD(env, r9, gnu_java_security_provider_GnuDSAPrivateKey, g) = r4;
	return r9;

label3:
	_JC_LINE_NUMBER(132);				// 6
	r11 = _JC_NEW(env, java_security_InvalidKeyException);
	r12 = _JC_NULL;
	_JC_REF_FIELD(env, r11, java_lang_Throwable, cause) = r11;
	r13 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r11);
	_JC_REF_FIELD(env, r11, java_lang_Throwable, vmState) = r13;
	_JC_REF_FIELD(env, r11, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r11, java_lang_Throwable, detailMessage) = r12;
	_JC_THROW(env, r11);
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_gnu_java_security_provider_DSAKeyFactory$methods[] = {
	&_jc_gnu_java_security_provider_DSAKeyFactory$method_info$_init$52f4ad9f2989aeee,
	&_jc_gnu_java_security_provider_DSAKeyFactory$method_info$class$c900dc17c9967b78,
	&_jc_gnu_java_security_provider_DSAKeyFactory$method_info$engineGeneratePrivate$5f899f5d07075f18,
	&_jc_gnu_java_security_provider_DSAKeyFactory$method_info$engineGeneratePublic$7ad176effa9fa186,
	&_jc_gnu_java_security_provider_DSAKeyFactory$method_info$engineGetKeySpec$8e11b093f262567f,
	&_jc_gnu_java_security_provider_DSAKeyFactory$method_info$engineTranslateKey$486445c69e67c534
};

/************************************************************************
 *			  Class fields structure			*
 ************************************************************************/

_jc_gnu_java_security_provider_DSAKeyFactory$fields_struct _jc_gnu_java_security_provider_DSAKeyFactory$class_fields = { };

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_gnu_java_security_provider_DSAKeyFactory$instanceof_hash_bucket_40[] = {
	&_jc_gnu_java_security_provider_DSAKeyFactory$type,
	_JC_NULL
};
static _jc_type *const _jc_gnu_java_security_provider_DSAKeyFactory$instanceof_hash_bucket_91[] = {
	&_jc_java_security_KeyFactorySpi$type,
	_JC_NULL
};
static _jc_type *const _jc_gnu_java_security_provider_DSAKeyFactory$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_gnu_java_security_provider_DSAKeyFactory$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[40]=	_jc_gnu_java_security_provider_DSAKeyFactory$instanceof_hash_bucket_40,
	[91]=	_jc_gnu_java_security_provider_DSAKeyFactory$instanceof_hash_bucket_91,
	[101]=	_jc_gnu_java_security_provider_DSAKeyFactory$instanceof_hash_bucket_101
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_gnu_java_security_provider_DSAKeyFactory$class_depends[] = {
	{ "gnu/java/security/provider/GnuDSAPrivateKey",	_JC_JLONG(0x18d6bda3b179d358) },
	{ "gnu/java/security/provider/GnuDSAPublicKey",	_JC_JLONG(0x84d8d4a6e8de7d16) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/ClassNotFoundException",	_JC_JLONG(0x1f925cf50bfc0d6c) },
	{ "java/lang/Error",	_JC_JLONG(0x308333d803f5ab9f) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/IllegalArgumentException",	_JC_JLONG(0x680cf34d05feb5a1) },
	{ "java/lang/IllegalStateException",	_JC_JLONG(0xb7e704701c278e65) },
	{ "java/lang/LinkageError",	_JC_JLONG(0x3746e17e005bda9e) },
	{ "java/lang/NoClassDefFoundError",	_JC_JLONG(0x2082ebb592ac2255) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/RuntimeException",	_JC_JLONG(0x4f5534a987354d1d) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMClass",	_JC_JLONG(0x238a2c0aafd74314) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/math/BigInteger",	_JC_JLONG(0x7717ded55c30b7f3) },
	{ "java/security/GeneralSecurityException",	_JC_JLONG(0x692089051f4c8d0b) },
	{ "java/security/InvalidKeyException",	_JC_JLONG(0x94dda41e9bf6c170) },
	{ "java/security/Key",	_JC_JLONG(0xa467c6cd05d9cc51) },
	{ "java/security/KeyException",	_JC_JLONG(0x965d036f0f33fac6) },
	{ "java/security/KeyFactorySpi",	_JC_JLONG(0x5208a7db73e048db) },
	{ "java/security/PrivateKey",	_JC_JLONG(0xdcdbe4a102f59043) },
	{ "java/security/PublicKey",	_JC_JLONG(0x4db3ac05e70e2bf8) },
	{ "java/security/interfaces/DSAParams",	_JC_JLONG(0xf4f2d6013f72861e) },
	{ "java/security/interfaces/DSAPrivateKey",	_JC_JLONG(0xd57e7f1f963e5163) },
	{ "java/security/interfaces/DSAPublicKey",	_JC_JLONG(0xbad97fafc9653a27) },
	{ "java/security/spec/DSAPrivateKeySpec",	_JC_JLONG(0x61e0ec33066ad42) },
	{ "java/security/spec/DSAPublicKeySpec",	_JC_JLONG(0xe16a98c9d4bd4893) },
	{ "java/security/spec/InvalidKeySpecException",	_JC_JLONG(0x602c9e525972bdb8) },
	{ "java/security/spec/KeySpec",	_JC_JLONG(0xe5bd533daf8dcb9a) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_gnu_java_security_provider_DSAKeyFactory$vtype _jc_gnu_java_security_provider_DSAKeyFactory$type = {
    .type= {
	.name=			"gnu/java/security/provider/DSAKeyFactory",
	.superclass=		&_jc_java_security_KeyFactorySpi$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		19,
		.hash=			_JC_JLONG(0x54be5494c58fd4a8),
		.source_file=		"DSAKeyFactory.java",
		.instance_size=		sizeof(_jc_gnu_java_security_provider_DSAKeyFactory$refs) + sizeof(_jc_gnu_java_security_provider_DSAKeyFactory$object),
		.num_virtual_refs=	0,
		.num_fields=		sizeof(_jc_gnu_java_security_provider_DSAKeyFactory$fields) / sizeof(*_jc_gnu_java_security_provider_DSAKeyFactory$fields),
		.fields=		_jc_gnu_java_security_provider_DSAKeyFactory$fields,
		.num_methods=		sizeof(_jc_gnu_java_security_provider_DSAKeyFactory$methods) / sizeof(*_jc_gnu_java_security_provider_DSAKeyFactory$methods),
		.methods=		_jc_gnu_java_security_provider_DSAKeyFactory$methods,
		.instanceof_hash_table=	_jc_gnu_java_security_provider_DSAKeyFactory$instanceof_hash_table,
		.class_fields=		&_jc_gnu_java_security_provider_DSAKeyFactory$class_fields,
		.num_class_depends=		sizeof(_jc_gnu_java_security_provider_DSAKeyFactory$class_depends) / sizeof(*_jc_gnu_java_security_provider_DSAKeyFactory$class_depends),
		.class_depends=		_jc_gnu_java_security_provider_DSAKeyFactory$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.java_security_KeyFactorySpi= {
	    .engineGeneratePrivate$5f899f5d07075f18=	// overridden
		&_jc_gnu_java_security_provider_DSAKeyFactory$method$engineGeneratePrivate$5f899f5d07075f18,
	    .engineGeneratePublic$7ad176effa9fa186=		// overridden
		&_jc_gnu_java_security_provider_DSAKeyFactory$method$engineGeneratePublic$7ad176effa9fa186,
	    .engineGetKeySpec$8e11b093f262567f=		// overridden
		&_jc_gnu_java_security_provider_DSAKeyFactory$method$engineGetKeySpec$8e11b093f262567f,
	    .engineTranslateKey$486445c69e67c534=		// overridden
		&_jc_gnu_java_security_provider_DSAKeyFactory$method$engineTranslateKey$486445c69e67c534,
	},
	.gnu_java_security_provider_DSAKeyFactory= {
	    .engineGeneratePrivate$5f899f5d07075f18=
		&_jc_gnu_java_security_provider_DSAKeyFactory$method$engineGeneratePrivate$5f899f5d07075f18,
	    .engineGeneratePublic$7ad176effa9fa186=
		&_jc_gnu_java_security_provider_DSAKeyFactory$method$engineGeneratePublic$7ad176effa9fa186,
	    .engineGetKeySpec$8e11b093f262567f=
		&_jc_gnu_java_security_provider_DSAKeyFactory$method$engineGetKeySpec$8e11b093f262567f,
	    .engineTranslateKey$486445c69e67c534=
		&_jc_gnu_java_security_provider_DSAKeyFactory$method$engineTranslateKey$486445c69e67c534,
	},
    }
};

