// public class gnu.java.security.provider.DSAKeyPairGenerator

// class file dependencies
// @dep_class 3632d111e7aa48f5 gnu_java_security_provider_DSAKeyPairGenerator
// @dep_class 18d6bda3b179d358 gnu_java_security_provider_GnuDSAPrivateKey
// @dep_class 84d8d4a6e8de7d16 gnu_java_security_provider_GnuDSAPublicKey
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class 1f925cf50bfc0d6c java_lang_ClassNotFoundException
// @dep_class 308333d803f5ab9f java_lang_Error
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class 680cf34d05feb5a1 java_lang_IllegalArgumentException
// @dep_class b7e704701c278e65 java_lang_IllegalStateException
// @dep_class 3746e17e005bda9e java_lang_LinkageError
// @dep_class 2082ebb592ac2255 java_lang_NoClassDefFoundError
// @dep_class 9cd7252f79299280 java_lang_Number
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class 4f5534a987354d1d java_lang_RuntimeException
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 53cc8e2333795f04 java_lang_System
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class 238a2c0aafd74314 java_lang_VMClass
// @dep_class 4d1cebae0bdda058 java_lang_VMSystem
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class 7717ded55c30b7f3 java_math_BigInteger
// @dep_class 16c8b8582ba1efb7 java_security_AlgorithmParameterGenerator
// @dep_class d641d91cd6167b5d java_security_AlgorithmParameterGeneratorSpi
// @dep_class 814794c0d977019 java_security_AlgorithmParameters
// @dep_class fe4af2c744a13852 java_security_AlgorithmParametersSpi
// @dep_class 692089051f4c8d0b java_security_GeneralSecurityException
// @dep_class 327edce29f2562dd java_security_InvalidAlgorithmParameterException
// @dep_class 99827f89c0c36c1 java_security_InvalidParameterException
// @dep_class 60b9183ffe1284b3 java_security_KeyPair
// @dep_class 688f793da35179d1 java_security_KeyPairGeneratorSpi
// @dep_class 15c6a62b25a6e96d java_security_SecureRandom
// @dep_class 7c4f88d459397137 java_security_interfaces_DSAKeyPairGenerator
// @dep_class f4f2d6013f72861e java_security_interfaces_DSAParams
// @dep_class ef2e5e8af121478f java_security_spec_AlgorithmParameterSpec
// @dep_class 96064ba9ffd4a2f9 java_security_spec_DSAParameterSpec
// @dep_class 61639c1affc91eab java_util_Random

// header file dependencies
// @dep_header gnu_java_security_provider_DSAKeyPairGenerator
// @dep_header gnu_java_security_provider_GnuDSAPrivateKey
// @dep_header gnu_java_security_provider_GnuDSAPublicKey
// @dep_header java_lang_Class
// @dep_header java_lang_ClassNotFoundException
// @dep_header java_lang_IllegalStateException
// @dep_header java_lang_NoClassDefFoundError
// @dep_header java_lang_String
// @dep_header java_lang_System
// @dep_header java_lang_VMClass
// @dep_header java_lang_VMSystem
// @dep_header java_lang_VMThrowable
// @dep_header java_math_BigInteger
// @dep_header java_security_AlgorithmParameterGenerator
// @dep_header java_security_AlgorithmParameterGeneratorSpi
// @dep_header java_security_AlgorithmParameters
// @dep_header java_security_AlgorithmParametersSpi
// @dep_header java_security_InvalidAlgorithmParameterException
// @dep_header java_security_InvalidParameterException
// @dep_header java_security_KeyPair
// @dep_header java_security_SecureRandom
// @dep_header java_security_interfaces_DSAKeyPairGenerator
// @dep_header java_security_interfaces_DSAParams
// @dep_header java_security_spec_AlgorithmParameterSpec
// @dep_header java_security_spec_DSAParameterSpec

#include "jc_defs.h"

#include "gnu/java/security/provider/DSAKeyPairGenerator.h"
#include "gnu/java/security/provider/GnuDSAPrivateKey.h"
#include "gnu/java/security/provider/GnuDSAPublicKey.h"
#include "java/lang/Class.h"
#include "java/lang/ClassNotFoundException.h"
#include "java/lang/IllegalStateException.h"
#include "java/lang/NoClassDefFoundError.h"
#include "java/lang/String.h"
#include "java/lang/System.h"
#include "java/lang/VMClass.h"
#include "java/lang/VMSystem.h"
#include "java/lang/VMThrowable.h"
#include "java/math/BigInteger.h"
#include "java/security/AlgorithmParameterGenerator.h"
#include "java/security/AlgorithmParameterGeneratorSpi.h"
#include "java/security/AlgorithmParameters.h"
#include "java/security/AlgorithmParametersSpi.h"
#include "java/security/InvalidAlgorithmParameterException.h"
#include "java/security/InvalidParameterException.h"
#include "java/security/KeyPair.h"
#include "java/security/SecureRandom.h"
#include "java/security/interfaces/DSAKeyPairGenerator.h"
#include "java/security/interfaces/DSAParams.h"
#include "java/security/spec/AlgorithmParameterSpec.h"
#include "java/security/spec/DSAParameterSpec.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// int keysize
static _jc_field _jc_gnu_java_security_provider_DSAKeyPairGenerator$field_info$keysize = {
	.name=		"keysize",
	.signature=	"I",
	.class=		&_jc_gnu_java_security_provider_DSAKeyPairGenerator$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	0,
	.offset=	_JC_OFFSETOF(_jc_gnu_java_security_provider_DSAKeyPairGenerator$object, nonrefs.gnu_java_security_provider_DSAKeyPairGenerator.keysize),
};

// java.security.SecureRandom random
static _jc_field _jc_gnu_java_security_provider_DSAKeyPairGenerator$field_info$random = {
	.name=		"random",
	.signature=	"Ljava/security/SecureRandom;",
	.class=		&_jc_gnu_java_security_provider_DSAKeyPairGenerator$type,
	.type=		&_jc_java_security_SecureRandom$type,
	.access_flags=	0,
	.offset=	_JC_OFFSETOF(_jc_gnu_java_security_provider_DSAKeyPairGenerator$object, refs[-1].gnu_java_security_provider_DSAKeyPairGenerator.random),
};

// private java.math.BigInteger q
static _jc_field _jc_gnu_java_security_provider_DSAKeyPairGenerator$field_info$q = {
	.name=		"q",
	.signature=	"Ljava/math/BigInteger;",
	.class=		&_jc_gnu_java_security_provider_DSAKeyPairGenerator$type,
	.type=		&_jc_java_math_BigInteger$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_gnu_java_security_provider_DSAKeyPairGenerator$object, refs[-1].gnu_java_security_provider_DSAKeyPairGenerator.q),
};

// private java.math.BigInteger p
static _jc_field _jc_gnu_java_security_provider_DSAKeyPairGenerator$field_info$p = {
	.name=		"p",
	.signature=	"Ljava/math/BigInteger;",
	.class=		&_jc_gnu_java_security_provider_DSAKeyPairGenerator$type,
	.type=		&_jc_java_math_BigInteger$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_gnu_java_security_provider_DSAKeyPairGenerator$object, refs[-1].gnu_java_security_provider_DSAKeyPairGenerator.p),
};

// private java.math.BigInteger g
static _jc_field _jc_gnu_java_security_provider_DSAKeyPairGenerator$field_info$g = {
	.name=		"g",
	.signature=	"Ljava/math/BigInteger;",
	.class=		&_jc_gnu_java_security_provider_DSAKeyPairGenerator$type,
	.type=		&_jc_java_math_BigInteger$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_gnu_java_security_provider_DSAKeyPairGenerator$object, refs[-1].gnu_java_security_provider_DSAKeyPairGenerator.g),
};

// static java.lang.Class class$java$security$spec$DSAParameterSpec
static _jc_field _jc_gnu_java_security_provider_DSAKeyPairGenerator$field_info$class__24java__24security__24spec__24DSAParameterSpec = {
	.name=		"class$java$security$spec$DSAParameterSpec",
	.signature=	"Ljava/lang/Class;",
	.class=		&_jc_gnu_java_security_provider_DSAKeyPairGenerator$type,
	.type=		&_jc_java_lang_Class$type,
	.access_flags=	_JC_ACC_STATIC,
	.offset=	_JC_OFFSETOF(_jc_gnu_java_security_provider_DSAKeyPairGenerator$fields_struct, class__24java__24security__24spec__24DSAParameterSpec),
};

// Fields
static _jc_field *const _jc_gnu_java_security_provider_DSAKeyPairGenerator$fields[] = {
	&_jc_gnu_java_security_provider_DSAKeyPairGenerator$field_info$class__24java__24security__24spec__24DSAParameterSpec,
	&_jc_gnu_java_security_provider_DSAKeyPairGenerator$field_info$g,
	&_jc_gnu_java_security_provider_DSAKeyPairGenerator$field_info$p,
	&_jc_gnu_java_security_provider_DSAKeyPairGenerator$field_info$q,
	&_jc_gnu_java_security_provider_DSAKeyPairGenerator$field_info$random,
	&_jc_gnu_java_security_provider_DSAKeyPairGenerator$field_info$keysize
};

/************************************************************************
 *			      Static methods				*
 ************************************************************************/

//
// static java.lang.Class 'class'(java.lang.String, boolean)
//

static _jc_trap_info _jc_gnu_java_security_provider_DSAKeyPairGenerator$trap_table$class$c900dc17c9967b78[] = {
	_JC_TRAP(&_jc_java_lang_ClassNotFoundException$type, 1, 2),
};

static const unsigned char _jc_gnu_java_security_provider_DSAKeyPairGenerator$param_ptypes$class$c900dc17c9967b78[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_gnu_java_security_provider_DSAKeyPairGenerator$param_types$class$c900dc17c9967b78[] = {
	&_jc_java_lang_String$type,
	&_jc_boolean$prim$type
};

_jc_method _jc_gnu_java_security_provider_DSAKeyPairGenerator$method_info$class$c900dc17c9967b78 = {
	.name=			"class",
	.signature=		"(Ljava/lang/String;Z)Ljava/lang/Class;",
	.class=			&_jc_gnu_java_security_provider_DSAKeyPairGenerator$type,
	.param_types=		&_jc_gnu_java_security_provider_DSAKeyPairGenerator$param_types$class$c900dc17c9967b78,
	.return_type=		&_jc_java_lang_Class$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSAKeyPairGenerator$param_ptypes$class$c900dc17c9967b78,
	.signature_hash=	_JC_JLONG(0xc900dc17c9967b78),
	.access_flags=		_JC_ACC_STATIC,
	.function=		&_jc_gnu_java_security_provider_DSAKeyPairGenerator$method$class$c900dc17c9967b78,
	.num_parameters=	2,
	.u= { .exec= {
	  .trap_table_len=	1,
	  .trap_table=		_jc_gnu_java_security_provider_DSAKeyPairGenerator$trap_table$class$c900dc17c9967b78,
	} },
};

_jc_java_lang_Class$object * _JC_JCNI_ATTR
_jc_gnu_java_security_provider_DSAKeyPairGenerator$method$class$c900dc17c9967b78(_jc_env *const env, _jc_java_lang_String$object *param0, jboolean param1)
{
	struct _jc_java_lang_String$object *r0;
	struct _jc_java_lang_NoClassDefFoundError$object *volatile r1;
	struct _jc_java_lang_Class$object *r2;
	struct _jc_java_lang_ClassNotFoundException$object *volatile r3;
	struct _jc_java_lang_Throwable$object *volatile r4;
	struct _jc_java_lang_Class$object *r5;
	struct _jc_java_lang_String$object *volatile r6;
	struct _jc_java_lang_VMThrowable$object *volatile r8;
	jboolean z0;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_gnu_java_security_provider_DSAKeyPairGenerator$method_info$class$c900dc17c9967b78, &&label1);

	r0 = param0;
	z0 = param1;
	_JC_TRAP_REGION(catch, 1);
	r2 = _JC_INVOKE_STATIC(env, java_lang_Class, forName$d3b57db3b6a905a3, 1, r0);
	if (z0 != 0)
		goto label0;
	_JC_EXPLICIT_NULL_CHECK(env, r2);
	r5 = _JC_INVOKE_STATIC(env, java_lang_VMClass, getComponentType$092b8e60c26feb25, 0, r2);
	r2 = r5;

label0:
	_JC_CANCEL_TRAPS(env, catch);
	return r2;

label1:
	_JC_TRAP_REGION(catch, 2);
	r3 = _JC_CAUGHT_EXCEPTION(env);
	r1 = _JC_NEW(env, java_lang_NoClassDefFoundError);
	r6 = _JC_NULL;
	_JC_REF_FIELD(env, r1, java_lang_Throwable, cause) = r1;
	r8 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r1);
	_JC_REF_FIELD(env, r1, java_lang_Throwable, vmState) = r8;
	_JC_REF_FIELD(env, r1, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r1, java_lang_Throwable, detailMessage) = r6;
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_Throwable, initCause$997fed19751e1c64, 0, r1, r3);
	_JC_THROW(env, r4);
}

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// void <init>()
//

static _jc_linenum _jc_gnu_java_security_provider_DSAKeyPairGenerator$linenum_table$_init$52f4ad9f2989aeee[];

static const unsigned char _jc_gnu_java_security_provider_DSAKeyPairGenerator$param_ptypes$_init$52f4ad9f2989aeee[] = { 
_JC_TYPE_VOID };

_jc_method _jc_gnu_java_security_provider_DSAKeyPairGenerator$method_info$_init$52f4ad9f2989aeee = {
	.name=			"<init>",
	.signature=		"()V",
	.class=			&_jc_gnu_java_security_provider_DSAKeyPairGenerator$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSAKeyPairGenerator$param_ptypes$_init$52f4ad9f2989aeee,
	.signature_hash=	_JC_JLONG(0x52f4ad9f2989aeee),
	.access_flags=		0,
	.function=		&_jc_gnu_java_security_provider_DSAKeyPairGenerator$method$_init$52f4ad9f2989aeee,
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_gnu_java_security_provider_DSAKeyPairGenerator$linenum_table$_init$52f4ad9f2989aeee
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_DSAKeyPairGenerator, _init$52f4ad9f2989aeee);

void _JC_JCNI_ATTR
_jc_gnu_java_security_provider_DSAKeyPairGenerator$method$_init$52f4ad9f2989aeee(_jc_env *const env, _jc_gnu_java_security_provider_DSAKeyPairGenerator$object *this)
{
	struct _jc_gnu_java_security_provider_DSAKeyPairGenerator$object *r0;

	r0 = this;
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAKeyPairGenerator, q) = _JC_NULL;
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAKeyPairGenerator, p) = _JC_NULL;
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAKeyPairGenerator, g) = _JC_NULL;
	_JC_LINE_NUMBER(65);				// 0
	_JC_PRIM_FIELD(env, r0, gnu_java_security_provider_DSAKeyPairGenerator, keysize) = 1024;
	_JC_LINE_NUMBER(66);				// 1
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public java.security.KeyPair generateKeyPair()
//

static _jc_linenum _jc_gnu_java_security_provider_DSAKeyPairGenerator$linenum_table$generateKeyPair$e0a9411286c772d9[];

static _jc_trap_info _jc_gnu_java_security_provider_DSAKeyPairGenerator$trap_table$generateKeyPair$e0a9411286c772d9[] = {
	_JC_TRAP(&_jc_java_lang_ClassNotFoundException$type, 2, 3),
	_JC_TRAP(&_jc_java_lang_Exception$type, 1, 4),
};

static const unsigned char _jc_gnu_java_security_provider_DSAKeyPairGenerator$param_ptypes$generateKeyPair$e0a9411286c772d9[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_gnu_java_security_provider_DSAKeyPairGenerator$method_info$generateKeyPair$e0a9411286c772d9 = {
	.name=			"generateKeyPair",
	.signature=		"()Ljava/security/KeyPair;",
	.class=			&_jc_gnu_java_security_provider_DSAKeyPairGenerator$type,
	.return_type=		&_jc_java_security_KeyPair$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSAKeyPairGenerator$param_ptypes$generateKeyPair$e0a9411286c772d9,
	.signature_hash=	_JC_JLONG(0xe0a9411286c772d9),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_provider_DSAKeyPairGenerator$method$generateKeyPair$e0a9411286c772d9,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_provider_DSAKeyPairGenerator$vtable, gnu_java_security_provider_DSAKeyPairGenerator.generateKeyPair$e0a9411286c772d9) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .trap_table_len=	2,
	  .trap_table=		_jc_gnu_java_security_provider_DSAKeyPairGenerator$trap_table$generateKeyPair$e0a9411286c772d9,
	  .u= {
	    .linenum= {
	      .len=	10,
	      .table=	_jc_gnu_java_security_provider_DSAKeyPairGenerator$linenum_table$generateKeyPair$e0a9411286c772d9
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_DSAKeyPairGenerator, generateKeyPair$e0a9411286c772d9);

_jc_java_security_KeyPair$object * _JC_JCNI_ATTR
_jc_gnu_java_security_provider_DSAKeyPairGenerator$method$generateKeyPair$e0a9411286c772d9(_jc_env *const env, _jc_gnu_java_security_provider_DSAKeyPairGenerator$object *this)
{
	jlong l0;
	struct _jc_gnu_java_security_provider_DSAKeyPairGenerator$object *r0;
	struct _jc_java_security_AlgorithmParameterGenerator$object *r1;
	struct _jc_gnu_java_security_provider_GnuDSAPublicKey$object *r10;
	struct _jc_java_math_BigInteger$object *r11;
	struct _jc_java_math_BigInteger$object *r12;
	struct _jc_gnu_java_security_provider_GnuDSAPrivateKey$object *r13;
	struct _jc_java_security_AlgorithmParameterGeneratorSpi$object *r14;
	struct _jc_java_security_AlgorithmParameters$object *r15;
	struct _jc_java_security_AlgorithmParametersSpi$object *r16;
	struct _jc_object *r17;
	struct _jc_java_lang_String$object *r18;
	struct _jc_java_lang_NoClassDefFoundError$object *volatile r19;
	struct _jc_java_lang_Class$object *r2;
	struct _jc_java_lang_Class$object *r20;
	struct _jc_java_lang_ClassNotFoundException$object *volatile r21;
	struct _jc_java_lang_Class$object *r22;
	struct _jc_java_lang_String$object *volatile r23;
	struct _jc_java_lang_VMThrowable$object *volatile r24;
	struct _jc_java_lang_IllegalArgumentException$object *volatile r25;
	struct _jc_java_lang_Throwable$object *volatile r26;
	struct _jc_java_lang_IllegalStateException$object *volatile r27;
	struct _jc_java_lang_String$object *volatile r28;
	struct _jc_java_lang_VMThrowable$object *volatile r29;
	struct _jc_java_security_spec_DSAParameterSpec$object *r3;
	struct _jc_java_lang_String$object *volatile r30;
	struct _jc_java_lang_VMThrowable$object *volatile r32;
	struct _jc_java_util_Random$object *r4;
	struct _jc_java_math_BigInteger$object *r5;
	struct _jc_java_lang_Exception$object *r6;
	struct _jc_java_math_BigInteger$object *r7;
	struct _jc_java_math_BigInteger$object *r8;
	struct _jc_java_security_KeyPair$object *r9;
	jboolean z0;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_gnu_java_security_provider_DSAKeyPairGenerator$method_info$generateKeyPair$e0a9411286c772d9, &&label0, &&label5);

	r0 = this;
	_JC_LINE_NUMBER(129);				// 0
	z0 = _JC_INVOKE_NONVIRTUAL(env, gnu_java_security_provider_DSAKeyPairGenerator, getDefaults$99b7305fb9f2001b, 0, r0);
	if (z0 != 0)
		goto label6;
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(131);				// 1
	r1 = _JC_INVOKE_STATIC(env, java_security_AlgorithmParameterGenerator, getInstance$11a809d01019b40a, 0, _JC_STRING(env, "DSA"));
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	r14 = _JC_REF_FIELD(env, r1, java_security_AlgorithmParameterGenerator, paramGenSpi);
	r15 = _JC_INVOKE_VIRTUAL(env, java_security_AlgorithmParameterGeneratorSpi, engineGenerateParameters$c500aa80c3b5d11e, r14);
	_JC_LINE_NUMBER(133);				// 2
	r2 = _JC_STATIC_FIELD(env, gnu_java_security_provider_DSAKeyPairGenerator, class__24java__24security__24spec__24DSAParameterSpec, 1);
	if (r2 != _JC_NULL)
		goto label4;
	r18 = _JC_STRING(env, "[Ljava.security.spec.DSAParameterSpec;");
	_JC_TRAP_REGION(catch, 2);
	r20 = _JC_INVOKE_STATIC(env, java_lang_Class, forName$d3b57db3b6a905a3, 1, r18);
	_JC_EXPLICIT_NULL_CHECK(env, r20);
	r22 = _JC_INVOKE_STATIC(env, java_lang_VMClass, getComponentType$092b8e60c26feb25, 0, r20);
	r2 = r22;
	goto label3;

label0:
	_JC_TRAP_REGION(catch, 3);
	r21 = _JC_CAUGHT_EXCEPTION(env);
	r19 = _JC_NEW(env, java_lang_NoClassDefFoundError);
	r23 = _JC_NULL;
	_JC_REF_FIELD(env, r19, java_lang_Throwable, cause) = r19;
	r24 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r19);
	_JC_REF_FIELD(env, r19, java_lang_Throwable, vmState) = r24;
	_JC_REF_FIELD(env, r19, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r19, java_lang_Throwable, detailMessage) = r23;
	if (r21 != r19)
		goto label1;
	r25 = _JC_NEW(env, java_lang_IllegalArgumentException);
	r28 = _JC_NULL;
	_JC_REF_FIELD(env, r25, java_lang_Throwable, cause) = r25;
	r29 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 1, r25);
	_JC_REF_FIELD(env, r25, java_lang_Throwable, vmState) = r29;
	_JC_REF_FIELD(env, r25, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r25, java_lang_Throwable, detailMessage) = r28;
	_JC_THROW(env, r25);

label1:
	r26 = _JC_REF_FIELD(env, r19, java_lang_Throwable, cause);
	if (r26 == r19)
		goto label2;
	r27 = _JC_NEW(env, java_lang_IllegalStateException);
	r30 = _JC_NULL;
	_JC_REF_FIELD(env, r27, java_lang_Throwable, cause) = r27;
	r32 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 1, r27);
	_JC_REF_FIELD(env, r27, java_lang_Throwable, vmState) = r32;
	_JC_REF_FIELD(env, r27, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r27, java_lang_Throwable, detailMessage) = r30;
	_JC_THROW(env, r27);

label2:
	_JC_REF_FIELD(env, r19, java_lang_Throwable, cause) = r21;
	_JC_THROW(env, r19);

label3:
	_JC_TRAP_REGION(catch, 3);
	_JC_STATIC_FIELD(env, gnu_java_security_provider_DSAKeyPairGenerator, class__24java__24security__24spec__24DSAParameterSpec, 1) = r22;

label4:
	_JC_TRAP_REGION(catch, 3);
	_JC_EXPLICIT_NULL_CHECK(env, r15);
	r16 = _JC_REF_FIELD(env, r15, java_security_AlgorithmParameters, paramSpi);
	r17 = _JC_INVOKE_VIRTUAL(env, java_security_AlgorithmParametersSpi, engineGetParameterSpec$5324b6890b10eccd, r16, r2);
	r3 = _JC_CAST(env, &_jc_java_security_spec_DSAParameterSpec$type, r17);
	_JC_LINE_NUMBER(134);				// 3
	r5 = _JC_INVOKE_VIRTUAL(env, java_security_spec_DSAParameterSpec, getP$612c6062f1779963, r3);
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAKeyPairGenerator, p) = r5;
	_JC_LINE_NUMBER(135);				// 4
	r5 = _JC_INVOKE_VIRTUAL(env, java_security_spec_DSAParameterSpec, getQ$e08c53541a87120d, r3);
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAKeyPairGenerator, q) = r5;
	_JC_LINE_NUMBER(136);				// 5
	r5 = _JC_INVOKE_VIRTUAL(env, java_security_spec_DSAParameterSpec, getG$59cffd735b56d8ad, r3);
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAKeyPairGenerator, g) = r5;
	_JC_TRAP_REGION(catch, 4);
	goto label6;

label5:
	_JC_TRAP_REGION(catch, 4);
	r6 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(138);				// 6
	_JC_CANCEL_TRAPS(env, catch);
	return _JC_NULL;

label6:
	_JC_TRAP_REGION(catch, 4);
	_JC_LINE_NUMBER(142);				// 7
	r5 = _JC_NEW(env, java_math_BigInteger);
	r4 = _JC_NEW(env, java_util_Random);
	_JC_ACTIVE_USE(env, java_lang_System);
	l0 = _JC_INVOKE_STATIC(env, java_lang_VMSystem, currentTimeMillis$f4fdeb31d00e9185, 0);
	_JC_INVOKE_NONVIRTUAL(env, java_util_Random, setSeed$b5af8144ceac8f80, 0, r4, l0);
	_JC_PRIM_FIELD(env, r5, java_math_BigInteger, bitCount) = -1;
	_JC_PRIM_FIELD(env, r5, java_math_BigInteger, bitLength) = -1;
	_JC_PRIM_FIELD(env, r5, java_math_BigInteger, firstNonzeroByteNum) = -2;
	_JC_PRIM_FIELD(env, r5, java_math_BigInteger, lowestSetBit) = -2;
	_JC_INVOKE_NONVIRTUAL(env, java_math_BigInteger, init$883549c549a1f62e, 0, r5, 159, r4);
	_JC_LINE_NUMBER(144);				// 8
	r7 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAKeyPairGenerator, g);
	r8 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAKeyPairGenerator, p);
	r8 = _JC_INVOKE_VIRTUAL(env, java_math_BigInteger, modPow$53dfc6db09e99e77, r7, r5, r8);
	_JC_LINE_NUMBER(146);				// 9
	r9 = _JC_NEW(env, java_security_KeyPair);
	r10 = _JC_NEW(env, gnu_java_security_provider_GnuDSAPublicKey);
	r7 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAKeyPairGenerator, p);
	r11 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAKeyPairGenerator, q);
	r12 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAKeyPairGenerator, g);
	_JC_REF_FIELD(env, r10, gnu_java_security_provider_GnuDSAPublicKey, y) = r8;
	_JC_REF_FIELD(env, r10, gnu_java_security_provider_GnuDSAPublicKey, p) = r7;
	_JC_REF_FIELD(env, r10, gnu_java_security_provider_GnuDSAPublicKey, q) = r11;
	_JC_REF_FIELD(env, r10, gnu_java_security_provider_GnuDSAPublicKey, g) = r12;
	r13 = _JC_NEW(env, gnu_java_security_provider_GnuDSAPrivateKey);
	r12 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAKeyPairGenerator, p);
	r11 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAKeyPairGenerator, q);
	r8 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAKeyPairGenerator, g);
	_JC_REF_FIELD(env, r13, gnu_java_security_provider_GnuDSAPrivateKey, x) = r5;
	_JC_REF_FIELD(env, r13, gnu_java_security_provider_GnuDSAPrivateKey, p) = r12;
	_JC_REF_FIELD(env, r13, gnu_java_security_provider_GnuDSAPrivateKey, q) = r11;
	_JC_REF_FIELD(env, r13, gnu_java_security_provider_GnuDSAPrivateKey, g) = r8;
	_JC_REF_FIELD(env, r9, java_security_KeyPair, publicKey) = r10;
	_JC_REF_FIELD(env, r9, java_security_KeyPair, privateKey) = r13;
	_JC_CANCEL_TRAPS(env, catch);
	return r9;
}

//
// private final boolean getDefaults()
//

static _jc_linenum _jc_gnu_java_security_provider_DSAKeyPairGenerator$linenum_table$getDefaults$99b7305fb9f2001b[];

static const unsigned char _jc_gnu_java_security_provider_DSAKeyPairGenerator$param_ptypes$getDefaults$99b7305fb9f2001b[] = { 
_JC_TYPE_BOOLEAN };

_jc_method _jc_gnu_java_security_provider_DSAKeyPairGenerator$method_info$getDefaults$99b7305fb9f2001b = {
	.name=			"getDefaults",
	.signature=		"()Z",
	.class=			&_jc_gnu_java_security_provider_DSAKeyPairGenerator$type,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSAKeyPairGenerator$param_ptypes$getDefaults$99b7305fb9f2001b,
	.signature_hash=	_JC_JLONG(0x99b7305fb9f2001b),
	.access_flags=		_JC_ACC_PRIVATE|_JC_ACC_FINAL,
	.function=		&_jc_gnu_java_security_provider_DSAKeyPairGenerator$method$getDefaults$99b7305fb9f2001b,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_provider_DSAKeyPairGenerator$vtable, gnu_java_security_provider_DSAKeyPairGenerator.getDefaults$99b7305fb9f2001b) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	14,
	      .table=	_jc_gnu_java_security_provider_DSAKeyPairGenerator$linenum_table$getDefaults$99b7305fb9f2001b
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_DSAKeyPairGenerator, getDefaults$99b7305fb9f2001b);

jboolean _JC_JCNI_ATTR
_jc_gnu_java_security_provider_DSAKeyPairGenerator$method$getDefaults$99b7305fb9f2001b(_jc_env *const env, _jc_gnu_java_security_provider_DSAKeyPairGenerator$object *this)
{
	jint i0;
	jint i1;
	jint i2;
	jint i3;
	jint i4;
	jint i5;
	struct _jc_gnu_java_security_provider_DSAKeyPairGenerator$object *r0;
	struct _jc_java_math_BigInteger$object *r1;
	_jc_int_array *r10;
	struct _jc_java_lang_String$object *r11;
	struct _jc_java_math_BigInteger$object *r12;
	_jc_int_array *r13;
	struct _jc_java_lang_String$object *r14;
	struct _jc_java_math_BigInteger$object *r15;
	_jc_int_array *r16;
	struct _jc_java_lang_String$object *r2;
	struct _jc_java_math_BigInteger$object *r3;
	_jc_int_array *r4;
	struct _jc_java_lang_String$object *r5;
	struct _jc_java_math_BigInteger$object *r6;
	_jc_int_array *r7;
	struct _jc_java_lang_String$object *r8;
	struct _jc_java_math_BigInteger$object *r9;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(154);				// 0
	i0 = _JC_PRIM_FIELD(env, r0, gnu_java_security_provider_DSAKeyPairGenerator, keysize);
	if (i0 != 512)
		goto label0;
	_JC_LINE_NUMBER(155);				// 1
	r1 = _JC_NEW(env, java_math_BigInteger);
	r2 = _JC_STRING(env, "fca682ce8e12caba26efccf7110e526db078b05edecbcd1eb4a208f3ae1617ae01f35b91a47e6df63413c5e12ed0899bcd132acd50d99151bdc43ee737592e17");
	_JC_PRIM_FIELD(env, r1, java_math_BigInteger, bitCount) = -1;
	_JC_PRIM_FIELD(env, r1, java_math_BigInteger, bitLength) = -1;
	_JC_PRIM_FIELD(env, r1, java_math_BigInteger, firstNonzeroByteNum) = -2;
	_JC_PRIM_FIELD(env, r1, java_math_BigInteger, lowestSetBit) = -2;
	r3 = _JC_INVOKE_STATIC(env, java_math_BigInteger, valueOf$d2fb443456417d88, 1, r2, 16);
	i1 = _JC_PRIM_FIELD(env, r3, java_math_BigInteger, ival);
	_JC_PRIM_FIELD(env, r1, java_math_BigInteger, ival) = i1;
	r4 = _JC_REF_FIELD(env, r3, java_math_BigInteger, words);
	_JC_REF_FIELD(env, r1, java_math_BigInteger, words) = r4;
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAKeyPairGenerator, p) = r1;
	_JC_LINE_NUMBER(156);				// 2
	r1 = _JC_NEW(env, java_math_BigInteger);
	r5 = _JC_STRING(env, "962eddcc369cba8ebb260ee6b6a126d9346e38c5");
	_JC_PRIM_FIELD(env, r1, java_math_BigInteger, bitCount) = -1;
	_JC_PRIM_FIELD(env, r1, java_math_BigInteger, bitLength) = -1;
	_JC_PRIM_FIELD(env, r1, java_math_BigInteger, firstNonzeroByteNum) = -2;
	_JC_PRIM_FIELD(env, r1, java_math_BigInteger, lowestSetBit) = -2;
	r6 = _JC_INVOKE_STATIC(env, java_math_BigInteger, valueOf$d2fb443456417d88, 1, r5, 16);
	i2 = _JC_PRIM_FIELD(env, r6, java_math_BigInteger, ival);
	_JC_PRIM_FIELD(env, r1, java_math_BigInteger, ival) = i2;
	r7 = _JC_REF_FIELD(env, r6, java_math_BigInteger, words);
	_JC_REF_FIELD(env, r1, java_math_BigInteger, words) = r7;
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAKeyPairGenerator, q) = r1;
	_JC_LINE_NUMBER(157);				// 3
	r1 = _JC_NEW(env, java_math_BigInteger);
	r8 = _JC_STRING(env, "678471b27a9cf44ee91a49c5147db1a9aaf244f05a434d6486931d2d14271b9e35030b71fd73da179069b32e2935630e1c2062354d0da20a6c416e50be794ca4");
	_JC_PRIM_FIELD(env, r1, java_math_BigInteger, bitCount) = -1;
	_JC_PRIM_FIELD(env, r1, java_math_BigInteger, bitLength) = -1;
	_JC_PRIM_FIELD(env, r1, java_math_BigInteger, firstNonzeroByteNum) = -2;
	_JC_PRIM_FIELD(env, r1, java_math_BigInteger, lowestSetBit) = -2;
	r9 = _JC_INVOKE_STATIC(env, java_math_BigInteger, valueOf$d2fb443456417d88, 1, r8, 16);
	i3 = _JC_PRIM_FIELD(env, r9, java_math_BigInteger, ival);
	_JC_PRIM_FIELD(env, r1, java_math_BigInteger, ival) = i3;
	r10 = _JC_REF_FIELD(env, r9, java_math_BigInteger, words);
	_JC_REF_FIELD(env, r1, java_math_BigInteger, words) = r10;
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAKeyPairGenerator, g) = r1;
	_JC_LINE_NUMBER(158);				// 4
	return 1;

label0:
	_JC_LINE_NUMBER(159);				// 5
	i0 = _JC_PRIM_FIELD(env, r0, gnu_java_security_provider_DSAKeyPairGenerator, keysize);
	if (i0 != 768)
		goto label1;
	_JC_LINE_NUMBER(160);				// 6
	r1 = _JC_NEW(env, java_math_BigInteger);
	r11 = _JC_STRING(env, "e9e642599d355f37c97ffd3567120b8e25c9cd43e927b3a9670fbec5d890141922d2c3b3ad2480093799869d1e846aab49fab0ad26d2ce6a22219d470bce7d777d4a21fbe9c270b57f607002f3cef8393694cf45ee3688c11a8c56ab127a3daf");
	_JC_PRIM_FIELD(env, r1, java_math_BigInteger, bitCount) = -1;
	_JC_PRIM_FIELD(env, r1, java_math_BigInteger, bitLength) = -1;
	_JC_PRIM_FIELD(env, r1, java_math_BigInteger, firstNonzeroByteNum) = -2;
	_JC_PRIM_FIELD(env, r1, java_math_BigInteger, lowestSetBit) = -2;
	r12 = _JC_INVOKE_STATIC(env, java_math_BigInteger, valueOf$d2fb443456417d88, 1, r11, 16);
	i4 = _JC_PRIM_FIELD(env, r12, java_math_BigInteger, ival);
	_JC_PRIM_FIELD(env, r1, java_math_BigInteger, ival) = i4;
	r13 = _JC_REF_FIELD(env, r12, java_math_BigInteger, words);
	_JC_REF_FIELD(env, r1, java_math_BigInteger, words) = r13;
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAKeyPairGenerator, p) = r1;
	_JC_LINE_NUMBER(161);				// 7
	r1 = _JC_NEW(env, java_math_BigInteger);
	r14 = _JC_STRING(env, "9cdbd84c9f1ac2f38d0f80f42ab952e7338bf511");
	_JC_PRIM_FIELD(env, r1, java_math_BigInteger, bitCount) = -1;
	_JC_PRIM_FIELD(env, r1, java_math_BigInteger, bitLength) = -1;
	_JC_PRIM_FIELD(env, r1, java_math_BigInteger, firstNonzeroByteNum) = -2;
	_JC_PRIM_FIELD(env, r1, java_math_BigInteger, lowestSetBit) = -2;
	r15 = _JC_INVOKE_STATIC(env, java_math_BigInteger, valueOf$d2fb443456417d88, 1, r14, 16);
	i5 = _JC_PRIM_FIELD(env, r15, java_math_BigInteger, ival);
	_JC_PRIM_FIELD(env, r1, java_math_BigInteger, ival) = i5;
	r16 = _JC_REF_FIELD(env, r15, java_math_BigInteger, words);
	_JC_REF_FIELD(env, r1, java_math_BigInteger, words) = r16;
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAKeyPairGenerator, q) = r1;
	_JC_LINE_NUMBER(162);				// 8
	r1 = _JC_NEW(env, java_math_BigInteger);
	_JC_INVOKE_NONVIRTUAL(env, java_math_BigInteger, _init$8b03e78e1eb3b29e, 0, r1, _JC_STRING(env, "30470ad5a005fb14ce2d9dcd87e38bc7d1b1c5facbaecbe95f190aa7a31d23c4dbbcbe06174544401a5b2c020965d8c2bd2171d3668445771f74ba084d2029d83c1c158547f3a9f1a2715be23d51ae4d3e5a1f6a7064f316933a346d3f529252"), 16);
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAKeyPairGenerator, g) = r1;
	goto label2;

label1:
	_JC_LINE_NUMBER(163);				// 9
	i0 = _JC_PRIM_FIELD(env, r0, gnu_java_security_provider_DSAKeyPairGenerator, keysize);
	if (i0 != 512)
		goto label2;
	_JC_LINE_NUMBER(164);				// 10
	r1 = _JC_NEW(env, java_math_BigInteger);
	_JC_INVOKE_NONVIRTUAL(env, java_math_BigInteger, _init$8b03e78e1eb3b29e, 0, r1, _JC_STRING(env, "fd7f53811d75122952df4a9c2eece4e7f611b7523cef4400c31e3f80b6512669455d402251fb593d8d58fabfc5f5ba30f6cb9b556cd7813b801d346ff26660b76b9950a5a49f9fe8047b1022c24fbba9d7feb7c61bf83b57e7c6a8a6150f04fb83f6d3c51ec3023554135a169132f675f3ae2b61d72aeff22203199dd14801c7"), 16);
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAKeyPairGenerator, p) = r1;
	_JC_LINE_NUMBER(165);				// 11
	r1 = _JC_NEW(env, java_math_BigInteger);
	_JC_INVOKE_NONVIRTUAL(env, java_math_BigInteger, _init$8b03e78e1eb3b29e, 0, r1, _JC_STRING(env, "9760508f15230bccb292b982a2eb840bf0581cf5"), 16);
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAKeyPairGenerator, q) = r1;
	_JC_LINE_NUMBER(166);				// 12
	r1 = _JC_NEW(env, java_math_BigInteger);
	_JC_INVOKE_NONVIRTUAL(env, java_math_BigInteger, _init$8b03e78e1eb3b29e, 0, r1, _JC_STRING(env, "f7e1a085d69b3ddecbbcab5c36b857b97994afbbfa3aea82f9574c0b3d0782675159578ebad4594fe67107108180b449167123e84c281613b7cf09328cc8a6e13c167a8b547c8d28e0a3ae1e2bb3a675916ea37f0bfa213562f1fb627a01243bcca4f1bea8519089a883dfe15ae59f06928b665e807b552564014c3bfecf492a"), 16);
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAKeyPairGenerator, g) = r1;

label2:
	_JC_LINE_NUMBER(168);				// 13
	return 0;
}

//
// public void initialize(int, java.security.SecureRandom)
//

static _jc_linenum _jc_gnu_java_security_provider_DSAKeyPairGenerator$linenum_table$initialize$8377579c986315b7[];

static const unsigned char _jc_gnu_java_security_provider_DSAKeyPairGenerator$param_ptypes$initialize$8377579c986315b7[] = { 
_JC_TYPE_INT, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_gnu_java_security_provider_DSAKeyPairGenerator$param_types$initialize$8377579c986315b7[] = {
	&_jc_int$prim$type,
	&_jc_java_security_SecureRandom$type
};

_jc_method _jc_gnu_java_security_provider_DSAKeyPairGenerator$method_info$initialize$8377579c986315b7 = {
	.name=			"initialize",
	.signature=		"(ILjava/security/SecureRandom;)V",
	.class=			&_jc_gnu_java_security_provider_DSAKeyPairGenerator$type,
	.param_types=		&_jc_gnu_java_security_provider_DSAKeyPairGenerator$param_types$initialize$8377579c986315b7,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSAKeyPairGenerator$param_ptypes$initialize$8377579c986315b7,
	.signature_hash=	_JC_JLONG(0x8377579c986315b7),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_provider_DSAKeyPairGenerator$method$initialize$8377579c986315b7,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_provider_DSAKeyPairGenerator$vtable, gnu_java_security_provider_DSAKeyPairGenerator.initialize$8377579c986315b7) / sizeof(void *),
	.num_parameters=	2,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_gnu_java_security_provider_DSAKeyPairGenerator$linenum_table$initialize$8377579c986315b7
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_DSAKeyPairGenerator, initialize$8377579c986315b7);

void _JC_JCNI_ATTR
_jc_gnu_java_security_provider_DSAKeyPairGenerator$method$initialize$8377579c986315b7(_jc_env *const env, _jc_gnu_java_security_provider_DSAKeyPairGenerator$object *this, jint param0, _jc_java_security_SecureRandom$object *param1)
{
	jint i0;
	struct _jc_gnu_java_security_provider_DSAKeyPairGenerator$object *r0;
	struct _jc_java_security_SecureRandom$object *r1;

	r0 = this;
	i0 = param0;
	r1 = param1;
	_JC_LINE_NUMBER(73);				// 0
	_JC_PRIM_FIELD(env, r0, gnu_java_security_provider_DSAKeyPairGenerator, keysize) = i0;
	_JC_LINE_NUMBER(74);				// 1
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAKeyPairGenerator, random) = r1;
	_JC_LINE_NUMBER(75);				// 2
	return;
}

//
// public void initialize(int, boolean, java.security.SecureRandom) throws java.security.InvalidParameterException
//

static _jc_linenum _jc_gnu_java_security_provider_DSAKeyPairGenerator$linenum_table$initialize$6a0c329ca5dceb6f[];

static const unsigned char _jc_gnu_java_security_provider_DSAKeyPairGenerator$param_ptypes$initialize$6a0c329ca5dceb6f[] = { 
_JC_TYPE_INT, _JC_TYPE_BOOLEAN, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_gnu_java_security_provider_DSAKeyPairGenerator$exceptions$initialize$6a0c329ca5dceb6f[] = {
	&_jc_java_security_InvalidParameterException$type
};

static _jc_type *const _jc_gnu_java_security_provider_DSAKeyPairGenerator$param_types$initialize$6a0c329ca5dceb6f[] = {
	&_jc_int$prim$type,
	&_jc_boolean$prim$type,
	&_jc_java_security_SecureRandom$type
};

_jc_method _jc_gnu_java_security_provider_DSAKeyPairGenerator$method_info$initialize$6a0c329ca5dceb6f = {
	.name=			"initialize",
	.signature=		"(IZLjava/security/SecureRandom;)V",
	.class=			&_jc_gnu_java_security_provider_DSAKeyPairGenerator$type,
	.param_types=		&_jc_gnu_java_security_provider_DSAKeyPairGenerator$param_types$initialize$6a0c329ca5dceb6f,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSAKeyPairGenerator$param_ptypes$initialize$6a0c329ca5dceb6f,
	.signature_hash=	_JC_JLONG(0x6a0c329ca5dceb6f),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_provider_DSAKeyPairGenerator$method$initialize$6a0c329ca5dceb6f,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_provider_DSAKeyPairGenerator$vtable, gnu_java_security_provider_DSAKeyPairGenerator.initialize$6a0c329ca5dceb6f) / sizeof(void *),
	.num_parameters=	3,
	.num_exceptions=	1,
	.exceptions=		&_jc_gnu_java_security_provider_DSAKeyPairGenerator$exceptions$initialize$6a0c329ca5dceb6f,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	10,
	      .table=	_jc_gnu_java_security_provider_DSAKeyPairGenerator$linenum_table$initialize$6a0c329ca5dceb6f
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_DSAKeyPairGenerator, initialize$6a0c329ca5dceb6f);

void _JC_JCNI_ATTR
_jc_gnu_java_security_provider_DSAKeyPairGenerator$method$initialize$6a0c329ca5dceb6f(_jc_env *const env, _jc_gnu_java_security_provider_DSAKeyPairGenerator$object *this, jint param0, jboolean param1, _jc_java_security_SecureRandom$object *param2)
{
	jint i0;
	jint i1;
	struct _jc_gnu_java_security_provider_DSAKeyPairGenerator$object *r0;
	struct _jc_java_security_SecureRandom$object *r1;
	struct _jc_java_security_InvalidParameterException$object *r2;
	struct _jc_java_lang_String$object *r3;
	struct _jc_java_lang_VMThrowable$object *r4;
	struct _jc_java_lang_String$object *r5;
	struct _jc_java_lang_VMThrowable$object *r7;
	jboolean z0;

	r0 = this;
	i0 = param0;
	z0 = param1;
	r1 = param2;
	_JC_LINE_NUMBER(115);				// 0
	i1 = i0 % 64;
	if (i1 != 0)
		goto label0;
	if (i0 < 512)
		goto label0;
	if (i0 <= 1024)
		goto label1;

label0:
	_JC_LINE_NUMBER(116);				// 1
	r2 = _JC_NEW(env, java_security_InvalidParameterException);
	r3 = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, cause) = r2;
	r4 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r2);
	_JC_REF_FIELD(env, r2, java_lang_Throwable, vmState) = r4;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, detailMessage) = r3;
	_JC_THROW(env, r2);

label1:
	_JC_LINE_NUMBER(118);				// 2
	if (z0 != 0)
		goto label2;
	if (i0 == 512)
		goto label2;
	if (i0 == 768)
		goto label2;
	if (i0 == 1024)
		goto label2;
	_JC_LINE_NUMBER(119);				// 3
	r2 = _JC_NEW(env, java_security_InvalidParameterException);
	r5 = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, cause) = r2;
	r7 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r2);
	_JC_REF_FIELD(env, r2, java_lang_Throwable, vmState) = r7;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, detailMessage) = r5;
	_JC_THROW(env, r2);

label2:
	_JC_LINE_NUMBER(120);				// 4
	_JC_PRIM_FIELD(env, r0, gnu_java_security_provider_DSAKeyPairGenerator, keysize) = i0;
	_JC_LINE_NUMBER(121);				// 5
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAKeyPairGenerator, random) = r1;
	_JC_LINE_NUMBER(122);				// 6
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAKeyPairGenerator, p) = _JC_NULL;
	_JC_LINE_NUMBER(123);				// 7
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAKeyPairGenerator, q) = _JC_NULL;
	_JC_LINE_NUMBER(124);				// 8
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAKeyPairGenerator, g) = _JC_NULL;
	_JC_LINE_NUMBER(125);				// 9
	return;
}

//
// public void initialize(java.security.interfaces.DSAParams, java.security.SecureRandom) throws java.security.InvalidParameterException
//

static _jc_linenum _jc_gnu_java_security_provider_DSAKeyPairGenerator$linenum_table$initialize$575e50e0142c97af[];

static const unsigned char _jc_gnu_java_security_provider_DSAKeyPairGenerator$param_ptypes$initialize$575e50e0142c97af[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_gnu_java_security_provider_DSAKeyPairGenerator$exceptions$initialize$575e50e0142c97af[] = {
	&_jc_java_security_InvalidParameterException$type
};

static _jc_type *const _jc_gnu_java_security_provider_DSAKeyPairGenerator$param_types$initialize$575e50e0142c97af[] = {
	&_jc_java_security_interfaces_DSAParams$type,
	&_jc_java_security_SecureRandom$type
};

_jc_method _jc_gnu_java_security_provider_DSAKeyPairGenerator$method_info$initialize$575e50e0142c97af = {
	.name=			"initialize",
	.signature=		"(Ljava/security/interfaces/DSAParams;Ljava/security/SecureRandom;)V",
	.class=			&_jc_gnu_java_security_provider_DSAKeyPairGenerator$type,
	.param_types=		&_jc_gnu_java_security_provider_DSAKeyPairGenerator$param_types$initialize$575e50e0142c97af,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSAKeyPairGenerator$param_ptypes$initialize$575e50e0142c97af,
	.signature_hash=	_JC_JLONG(0x575e50e0142c97af),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_provider_DSAKeyPairGenerator$method$initialize$575e50e0142c97af,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_provider_DSAKeyPairGenerator$vtable, gnu_java_security_provider_DSAKeyPairGenerator.initialize$575e50e0142c97af) / sizeof(void *),
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_gnu_java_security_provider_DSAKeyPairGenerator$exceptions$initialize$575e50e0142c97af,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	11,
	      .table=	_jc_gnu_java_security_provider_DSAKeyPairGenerator$linenum_table$initialize$575e50e0142c97af
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_DSAKeyPairGenerator, initialize$575e50e0142c97af);

void _JC_JCNI_ATTR
_jc_gnu_java_security_provider_DSAKeyPairGenerator$method$initialize$575e50e0142c97af(_jc_env *const env, _jc_gnu_java_security_provider_DSAKeyPairGenerator$object *this, _jc_object *param0, _jc_java_security_SecureRandom$object *param1)
{
	struct _jc_gnu_java_security_provider_DSAKeyPairGenerator$object *r0;
	struct _jc_object *r1;
	struct _jc_java_lang_VMThrowable$object *r11;
	struct _jc_java_security_SecureRandom$object *r2;
	struct _jc_java_math_BigInteger$object *r3;
	struct _jc_java_security_InvalidParameterException$object *r4;
	struct _jc_java_lang_String$object *r5;
	struct _jc_java_lang_VMThrowable$object *r6;
	struct _jc_java_lang_String$object *r7;
	struct _jc_java_lang_VMThrowable$object *r8;
	struct _jc_java_lang_String$object *r9;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_LINE_NUMBER(94);				// 0
	r3 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0x612c6062f1779963), _jc_object *, (_jc_env *, struct _jc_object *));
	if (r3 == _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(95);				// 1
	r3 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0x612c6062f1779963), _jc_object *, (_jc_env *, struct _jc_object *));
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAKeyPairGenerator, p) = r3;
	goto label1;

label0:
	_JC_LINE_NUMBER(97);				// 2
	r4 = _JC_NEW(env, java_security_InvalidParameterException);
	r5 = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r6 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r6;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r5;
	_JC_THROW(env, r4);

label1:
	_JC_LINE_NUMBER(99);				// 3
	r3 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0xe08c53541a87120d), _jc_object *, (_jc_env *, struct _jc_object *));
	if (r3 == _JC_NULL)
		goto label2;
	_JC_LINE_NUMBER(100);				// 4
	r3 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0xe08c53541a87120d), _jc_object *, (_jc_env *, struct _jc_object *));
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAKeyPairGenerator, q) = r3;
	goto label3;

label2:
	_JC_LINE_NUMBER(102);				// 5
	r4 = _JC_NEW(env, java_security_InvalidParameterException);
	r7 = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r8 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r8;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r7;
	_JC_THROW(env, r4);

label3:
	_JC_LINE_NUMBER(104);				// 6
	r3 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0x59cffd735b56d8ad), _jc_object *, (_jc_env *, struct _jc_object *));
	if (r3 == _JC_NULL)
		goto label4;
	_JC_LINE_NUMBER(105);				// 7
	r3 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0x59cffd735b56d8ad), _jc_object *, (_jc_env *, struct _jc_object *));
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAKeyPairGenerator, g) = r3;
	goto label5;

label4:
	_JC_LINE_NUMBER(107);				// 8
	r4 = _JC_NEW(env, java_security_InvalidParameterException);
	r9 = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r11 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r11;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r9;
	_JC_THROW(env, r4);

label5:
	_JC_LINE_NUMBER(109);				// 9
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAKeyPairGenerator, random) = r2;
	_JC_LINE_NUMBER(110);				// 10
	return;
}

//
// public void initialize(java.security.spec.AlgorithmParameterSpec, java.security.SecureRandom) throws java.security.InvalidAlgorithmParameterException
//

static _jc_linenum _jc_gnu_java_security_provider_DSAKeyPairGenerator$linenum_table$initialize$a73c0ba67824ad04[];

static const unsigned char _jc_gnu_java_security_provider_DSAKeyPairGenerator$param_ptypes$initialize$a73c0ba67824ad04[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_gnu_java_security_provider_DSAKeyPairGenerator$exceptions$initialize$a73c0ba67824ad04[] = {
	&_jc_java_security_InvalidAlgorithmParameterException$type
};

static _jc_type *const _jc_gnu_java_security_provider_DSAKeyPairGenerator$param_types$initialize$a73c0ba67824ad04[] = {
	&_jc_java_security_spec_AlgorithmParameterSpec$type,
	&_jc_java_security_SecureRandom$type
};

_jc_method _jc_gnu_java_security_provider_DSAKeyPairGenerator$method_info$initialize$a73c0ba67824ad04 = {
	.name=			"initialize",
	.signature=		"(Ljava/security/spec/AlgorithmParameterSpec;Ljava/security/SecureRandom;)V",
	.class=			&_jc_gnu_java_security_provider_DSAKeyPairGenerator$type,
	.param_types=		&_jc_gnu_java_security_provider_DSAKeyPairGenerator$param_types$initialize$a73c0ba67824ad04,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSAKeyPairGenerator$param_ptypes$initialize$a73c0ba67824ad04,
	.signature_hash=	_JC_JLONG(0xa73c0ba67824ad04),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_provider_DSAKeyPairGenerator$method$initialize$a73c0ba67824ad04,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_provider_DSAKeyPairGenerator$vtable, gnu_java_security_provider_DSAKeyPairGenerator.initialize$a73c0ba67824ad04) / sizeof(void *),
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_gnu_java_security_provider_DSAKeyPairGenerator$exceptions$initialize$a73c0ba67824ad04,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	8,
	      .table=	_jc_gnu_java_security_provider_DSAKeyPairGenerator$linenum_table$initialize$a73c0ba67824ad04
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_DSAKeyPairGenerator, initialize$a73c0ba67824ad04);

void _JC_JCNI_ATTR
_jc_gnu_java_security_provider_DSAKeyPairGenerator$method$initialize$a73c0ba67824ad04(_jc_env *const env, _jc_gnu_java_security_provider_DSAKeyPairGenerator$object *this, _jc_object *param0, _jc_java_security_SecureRandom$object *param1)
{
	struct _jc_gnu_java_security_provider_DSAKeyPairGenerator$object *r0;
	struct _jc_object *r1;
	struct _jc_java_security_SecureRandom$object *r2;
	struct _jc_java_security_spec_DSAParameterSpec$object *r3;
	struct _jc_java_security_InvalidAlgorithmParameterException$object *r4;
	struct _jc_java_math_BigInteger$object *r5;
	struct _jc_java_lang_String$object *r6;
	struct _jc_java_lang_VMThrowable$object *r8;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_LINE_NUMBER(81);				// 0
	z0 = _JC_INSTANCEOF(env, r1, &_jc_java_security_spec_DSAParameterSpec$type);
	if (z0 != 0)
		goto label0;
	_JC_LINE_NUMBER(82);				// 1
	r4 = _JC_NEW(env, java_security_InvalidAlgorithmParameterException);
	r6 = _JC_STRING(env, "Must be DSAParameterSpec");
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r8 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r8;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r6;
	_JC_THROW(env, r4);

label0:
	_JC_LINE_NUMBER(84);				// 2
	r3 = r1;
	_JC_LINE_NUMBER(85);				// 3
	r5 = _JC_INVOKE_VIRTUAL(env, java_security_spec_DSAParameterSpec, getP$612c6062f1779963, r3);
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAKeyPairGenerator, p) = r5;
	_JC_LINE_NUMBER(86);				// 4
	r5 = _JC_INVOKE_VIRTUAL(env, java_security_spec_DSAParameterSpec, getQ$e08c53541a87120d, r3);
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAKeyPairGenerator, q) = r5;
	_JC_LINE_NUMBER(87);				// 5
	r5 = _JC_INVOKE_VIRTUAL(env, java_security_spec_DSAParameterSpec, getG$59cffd735b56d8ad, r3);
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAKeyPairGenerator, g) = r5;
	_JC_LINE_NUMBER(88);				// 6
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAKeyPairGenerator, random) = r2;
	_JC_LINE_NUMBER(89);				// 7
	return;
}

//
// private final void this()
//

static _jc_linenum _jc_gnu_java_security_provider_DSAKeyPairGenerator$linenum_table$this$adc93fb6bf4cbffa[];

static const unsigned char _jc_gnu_java_security_provider_DSAKeyPairGenerator$param_ptypes$this$adc93fb6bf4cbffa[] = { 
_JC_TYPE_VOID };

_jc_method _jc_gnu_java_security_provider_DSAKeyPairGenerator$method_info$this$adc93fb6bf4cbffa = {
	.name=			"this",
	.signature=		"()V",
	.class=			&_jc_gnu_java_security_provider_DSAKeyPairGenerator$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSAKeyPairGenerator$param_ptypes$this$adc93fb6bf4cbffa,
	.signature_hash=	_JC_JLONG(0xadc93fb6bf4cbffa),
	.access_flags=		_JC_ACC_PRIVATE|_JC_ACC_FINAL,
	.function=		&_jc_gnu_java_security_provider_DSAKeyPairGenerator$method$this$adc93fb6bf4cbffa,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_provider_DSAKeyPairGenerator$vtable, gnu_java_security_provider_DSAKeyPairGenerator.this$adc93fb6bf4cbffa) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_gnu_java_security_provider_DSAKeyPairGenerator$linenum_table$this$adc93fb6bf4cbffa
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_DSAKeyPairGenerator, this$adc93fb6bf4cbffa);

void _JC_JCNI_ATTR
_jc_gnu_java_security_provider_DSAKeyPairGenerator$method$this$adc93fb6bf4cbffa(_jc_env *const env, _jc_gnu_java_security_provider_DSAKeyPairGenerator$object *this)
{
	struct _jc_gnu_java_security_provider_DSAKeyPairGenerator$object *r0;

	r0 = this;
	_JC_LINE_NUMBER(59);				// 0
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAKeyPairGenerator, q) = _JC_NULL;
	_JC_LINE_NUMBER(60);				// 1
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAKeyPairGenerator, p) = _JC_NULL;
	_JC_LINE_NUMBER(61);				// 2
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAKeyPairGenerator, g) = _JC_NULL;
	return;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_gnu_java_security_provider_DSAKeyPairGenerator$methods[] = {
	&_jc_gnu_java_security_provider_DSAKeyPairGenerator$method_info$_init$52f4ad9f2989aeee,
	&_jc_gnu_java_security_provider_DSAKeyPairGenerator$method_info$class$c900dc17c9967b78,
	&_jc_gnu_java_security_provider_DSAKeyPairGenerator$method_info$generateKeyPair$e0a9411286c772d9,
	&_jc_gnu_java_security_provider_DSAKeyPairGenerator$method_info$getDefaults$99b7305fb9f2001b,
	&_jc_gnu_java_security_provider_DSAKeyPairGenerator$method_info$initialize$8377579c986315b7,
	&_jc_gnu_java_security_provider_DSAKeyPairGenerator$method_info$initialize$6a0c329ca5dceb6f,
	&_jc_gnu_java_security_provider_DSAKeyPairGenerator$method_info$initialize$575e50e0142c97af,
	&_jc_gnu_java_security_provider_DSAKeyPairGenerator$method_info$initialize$a73c0ba67824ad04,
	&_jc_gnu_java_security_provider_DSAKeyPairGenerator$method_info$this$adc93fb6bf4cbffa
};

/************************************************************************
 *			  Class fields structure			*
 ************************************************************************/

_jc_gnu_java_security_provider_DSAKeyPairGenerator$fields_struct _jc_gnu_java_security_provider_DSAKeyPairGenerator$class_fields = { };

/************************************************************************
 *			      Interface list				*
 ************************************************************************/

// Directly implemented interfaces
static _jc_type *const _jc_gnu_java_security_provider_DSAKeyPairGenerator$interfaces[] = {
	&_jc_java_security_interfaces_DSAKeyPairGenerator$type
};

/************************************************************************
 *			   Interface hash table				*
 ************************************************************************/

#if _JC_IMETHOD_HASHSIZE != 128
#error "_JC_IMETHOD_HASHSIZE has the wrong value (should be 128)"
#endif

// Interface lookup hash table buckets
static _jc_method *_jc_gnu_java_security_provider_DSAKeyPairGenerator$imethod_hash_bucket_47[] = {
	&_jc_gnu_java_security_provider_DSAKeyPairGenerator$method_info$initialize$575e50e0142c97af,
	_JC_NULL
};
static _jc_method *_jc_gnu_java_security_provider_DSAKeyPairGenerator$imethod_hash_bucket_111[] = {
	&_jc_gnu_java_security_provider_DSAKeyPairGenerator$method_info$initialize$6a0c329ca5dceb6f,
	_JC_NULL
};

// Interface lookup hash table
static _jc_method **_jc_gnu_java_security_provider_DSAKeyPairGenerator$imethod_hash_table[_JC_IMETHOD_HASHSIZE] = {
	[47]=	_jc_gnu_java_security_provider_DSAKeyPairGenerator$imethod_hash_bucket_47,
	[111]=	_jc_gnu_java_security_provider_DSAKeyPairGenerator$imethod_hash_bucket_111
};

// Interface "quick" lookup hash table
static const void *_jc_gnu_java_security_provider_DSAKeyPairGenerator$imethod_quick_table[_JC_IMETHOD_HASHSIZE] = {
	[47]=	&_jc_gnu_java_security_provider_DSAKeyPairGenerator$method$initialize$575e50e0142c97af,
	[111]=	&_jc_gnu_java_security_provider_DSAKeyPairGenerator$method$initialize$6a0c329ca5dceb6f
};

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_gnu_java_security_provider_DSAKeyPairGenerator$instanceof_hash_bucket_55[] = {
	&_jc_java_security_interfaces_DSAKeyPairGenerator$type,
	_JC_NULL
};
static _jc_type *const _jc_gnu_java_security_provider_DSAKeyPairGenerator$instanceof_hash_bucket_81[] = {
	&_jc_java_security_KeyPairGeneratorSpi$type,
	_JC_NULL
};
static _jc_type *const _jc_gnu_java_security_provider_DSAKeyPairGenerator$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};
static _jc_type *const _jc_gnu_java_security_provider_DSAKeyPairGenerator$instanceof_hash_bucket_117[] = {
	&_jc_gnu_java_security_provider_DSAKeyPairGenerator$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_gnu_java_security_provider_DSAKeyPairGenerator$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[55]=	_jc_gnu_java_security_provider_DSAKeyPairGenerator$instanceof_hash_bucket_55,
	[81]=	_jc_gnu_java_security_provider_DSAKeyPairGenerator$instanceof_hash_bucket_81,
	[101]=	_jc_gnu_java_security_provider_DSAKeyPairGenerator$instanceof_hash_bucket_101,
	[117]=	_jc_gnu_java_security_provider_DSAKeyPairGenerator$instanceof_hash_bucket_117
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_gnu_java_security_provider_DSAKeyPairGenerator$class_depends[] = {
	{ "gnu/java/security/provider/GnuDSAPrivateKey",	_JC_JLONG(0x18d6bda3b179d358) },
	{ "gnu/java/security/provider/GnuDSAPublicKey",	_JC_JLONG(0x84d8d4a6e8de7d16) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/ClassNotFoundException",	_JC_JLONG(0x1f925cf50bfc0d6c) },
	{ "java/lang/Error",	_JC_JLONG(0x308333d803f5ab9f) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/IllegalArgumentException",	_JC_JLONG(0x680cf34d05feb5a1) },
	{ "java/lang/IllegalStateException",	_JC_JLONG(0xb7e704701c278e65) },
	{ "java/lang/LinkageError",	_JC_JLONG(0x3746e17e005bda9e) },
	{ "java/lang/NoClassDefFoundError",	_JC_JLONG(0x2082ebb592ac2255) },
	{ "java/lang/Number",	_JC_JLONG(0x9cd7252f79299280) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/RuntimeException",	_JC_JLONG(0x4f5534a987354d1d) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/System",	_JC_JLONG(0x53cc8e2333795f04) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMClass",	_JC_JLONG(0x238a2c0aafd74314) },
	{ "java/lang/VMSystem",	_JC_JLONG(0x4d1cebae0bdda058) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/math/BigInteger",	_JC_JLONG(0x7717ded55c30b7f3) },
	{ "java/security/AlgorithmParameterGenerator",	_JC_JLONG(0x16c8b8582ba1efb7) },
	{ "java/security/AlgorithmParameterGeneratorSpi",	_JC_JLONG(0xd641d91cd6167b5d) },
	{ "java/security/AlgorithmParameters",	_JC_JLONG(0x814794c0d977019) },
	{ "java/security/AlgorithmParametersSpi",	_JC_JLONG(0xfe4af2c744a13852) },
	{ "java/security/GeneralSecurityException",	_JC_JLONG(0x692089051f4c8d0b) },
	{ "java/security/InvalidAlgorithmParameterException",	_JC_JLONG(0x327edce29f2562dd) },
	{ "java/security/InvalidParameterException",	_JC_JLONG(0x99827f89c0c36c1) },
	{ "java/security/KeyPair",	_JC_JLONG(0x60b9183ffe1284b3) },
	{ "java/security/KeyPairGeneratorSpi",	_JC_JLONG(0x688f793da35179d1) },
	{ "java/security/SecureRandom",	_JC_JLONG(0x15c6a62b25a6e96d) },
	{ "java/security/interfaces/DSAKeyPairGenerator",	_JC_JLONG(0x7c4f88d459397137) },
	{ "java/security/interfaces/DSAParams",	_JC_JLONG(0xf4f2d6013f72861e) },
	{ "java/security/spec/AlgorithmParameterSpec",	_JC_JLONG(0xef2e5e8af121478f) },
	{ "java/security/spec/DSAParameterSpec",	_JC_JLONG(0x96064ba9ffd4a2f9) },
	{ "java/util/Random",	_JC_JLONG(0x61639c1affc91eab) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_gnu_java_security_provider_DSAKeyPairGenerator$vtype _jc_gnu_java_security_provider_DSAKeyPairGenerator$type = {
    .type= {
	.name=			"gnu/java/security/provider/DSAKeyPairGenerator",
	.superclass=		&_jc_java_security_KeyPairGeneratorSpi$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.num_interfaces=sizeof(_jc_gnu_java_security_provider_DSAKeyPairGenerator$interfaces) / sizeof(*_jc_gnu_java_security_provider_DSAKeyPairGenerator$interfaces),
	.interfaces=		_jc_gnu_java_security_provider_DSAKeyPairGenerator$interfaces,
	.imethod_hash_table=	_jc_gnu_java_security_provider_DSAKeyPairGenerator$imethod_hash_table,
	.imethod_quick_table=	_jc_gnu_java_security_provider_DSAKeyPairGenerator$imethod_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		22,
		.hash=			_JC_JLONG(0x3632d111e7aa48f5),
		.source_file=		"DSAKeyPairGenerator.java",
		.instance_size=		sizeof(_jc_gnu_java_security_provider_DSAKeyPairGenerator$refs) + sizeof(_jc_gnu_java_security_provider_DSAKeyPairGenerator$object),
		.num_virtual_refs=	4,
		.num_fields=		sizeof(_jc_gnu_java_security_provider_DSAKeyPairGenerator$fields) / sizeof(*_jc_gnu_java_security_provider_DSAKeyPairGenerator$fields),
		.fields=		_jc_gnu_java_security_provider_DSAKeyPairGenerator$fields,
		.num_methods=		sizeof(_jc_gnu_java_security_provider_DSAKeyPairGenerator$methods) / sizeof(*_jc_gnu_java_security_provider_DSAKeyPairGenerator$methods),
		.methods=		_jc_gnu_java_security_provider_DSAKeyPairGenerator$methods,
		.instanceof_hash_table=	_jc_gnu_java_security_provider_DSAKeyPairGenerator$instanceof_hash_table,
		.class_fields=		&_jc_gnu_java_security_provider_DSAKeyPairGenerator$class_fields,
		.num_class_depends=		sizeof(_jc_gnu_java_security_provider_DSAKeyPairGenerator$class_depends) / sizeof(*_jc_gnu_java_security_provider_DSAKeyPairGenerator$class_depends),
		.class_depends=		_jc_gnu_java_security_provider_DSAKeyPairGenerator$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=			// overridden
		&_jc_java_security_KeyPairGeneratorSpi$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.java_security_KeyPairGeneratorSpi= {
	    .clone$b75f2713d6705f70=
		&_jc_java_security_KeyPairGeneratorSpi$method$clone$b75f2713d6705f70,
	    .generateKeyPair$e0a9411286c772d9=		// overridden
		&_jc_gnu_java_security_provider_DSAKeyPairGenerator$method$generateKeyPair$e0a9411286c772d9,
	    .initialize$8377579c986315b7=			// overridden
		&_jc_gnu_java_security_provider_DSAKeyPairGenerator$method$initialize$8377579c986315b7,
	    .initialize$a73c0ba67824ad04=			// overridden
		&_jc_gnu_java_security_provider_DSAKeyPairGenerator$method$initialize$a73c0ba67824ad04,
	},
	.gnu_java_security_provider_DSAKeyPairGenerator= {
	    .generateKeyPair$e0a9411286c772d9=
		&_jc_gnu_java_security_provider_DSAKeyPairGenerator$method$generateKeyPair$e0a9411286c772d9,
	    .getDefaults$99b7305fb9f2001b=
		&_jc_gnu_java_security_provider_DSAKeyPairGenerator$method$getDefaults$99b7305fb9f2001b,
	    .initialize$8377579c986315b7=
		&_jc_gnu_java_security_provider_DSAKeyPairGenerator$method$initialize$8377579c986315b7,
	    .initialize$6a0c329ca5dceb6f=
		&_jc_gnu_java_security_provider_DSAKeyPairGenerator$method$initialize$6a0c329ca5dceb6f,
	    .initialize$575e50e0142c97af=
		&_jc_gnu_java_security_provider_DSAKeyPairGenerator$method$initialize$575e50e0142c97af,
	    .initialize$a73c0ba67824ad04=
		&_jc_gnu_java_security_provider_DSAKeyPairGenerator$method$initialize$a73c0ba67824ad04,
	    .this$adc93fb6bf4cbffa=
		&_jc_gnu_java_security_provider_DSAKeyPairGenerator$method$this$adc93fb6bf4cbffa,
	},
    }
};

