// public class gnu.java.security.provider.DSAParameterGenerator

// class file dependencies
// @dep_class 55d53ae0ac5cc6a gnu_java_security_provider_DSAParameterGenerator
// @dep_class c874a81b06ec8350 gnu_java_security_util_Prime
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 53cc8e2333795f04 java_lang_System
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class 4d1cebae0bdda058 java_lang_VMSystem
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class 7717ded55c30b7f3 java_math_BigInteger
// @dep_class d641d91cd6167b5d java_security_AlgorithmParameterGeneratorSpi
// @dep_class 814794c0d977019 java_security_AlgorithmParameters
// @dep_class fe4af2c744a13852 java_security_AlgorithmParametersSpi
// @dep_class 692089051f4c8d0b java_security_GeneralSecurityException
// @dep_class 327edce29f2562dd java_security_InvalidAlgorithmParameterException
// @dep_class 22e937c2536160b4 java_security_NoSuchAlgorithmException
// @dep_class 81b073051aa30acc java_security_Provider
// @dep_class 15c6a62b25a6e96d java_security_SecureRandom
// @dep_class 89bf77984bd9669e java_security_Security
// @dep_class ef2e5e8af121478f java_security_spec_AlgorithmParameterSpec
// @dep_class 96064ba9ffd4a2f9 java_security_spec_DSAParameterSpec
// @dep_class 6afab99500ae813 java_security_spec_InvalidParameterSpecException
// @dep_class 61639c1affc91eab java_util_Random
// @dep_class c53e1575b095109b java_util_Vector

// header file dependencies
// @dep_header gnu_java_security_provider_DSAParameterGenerator
// @dep_header gnu_java_security_util_Prime
// @dep_header java_lang_Class
// @dep_header java_lang_String
// @dep_header java_lang_System
// @dep_header java_lang_VMSystem
// @dep_header java_lang_VMThrowable
// @dep_header java_math_BigInteger
// @dep_header java_security_AlgorithmParameters
// @dep_header java_security_AlgorithmParametersSpi
// @dep_header java_security_InvalidAlgorithmParameterException
// @dep_header java_security_NoSuchAlgorithmException
// @dep_header java_security_Provider
// @dep_header java_security_SecureRandom
// @dep_header java_security_Security
// @dep_header java_security_spec_AlgorithmParameterSpec
// @dep_header java_security_spec_DSAParameterSpec
// @dep_header java_security_spec_InvalidParameterSpecException
// @dep_header java_util_Vector

#include "jc_defs.h"

#include "gnu/java/security/provider/DSAParameterGenerator.h"
#include "gnu/java/security/util/Prime.h"
#include "java/lang/Class.h"
#include "java/lang/String.h"
#include "java/lang/System.h"
#include "java/lang/VMSystem.h"
#include "java/lang/VMThrowable.h"
#include "java/math/BigInteger.h"
#include "java/security/AlgorithmParameters.h"
#include "java/security/AlgorithmParametersSpi.h"
#include "java/security/InvalidAlgorithmParameterException.h"
#include "java/security/NoSuchAlgorithmException.h"
#include "java/security/Provider.h"
#include "java/security/SecureRandom.h"
#include "java/security/Security.h"
#include "java/security/spec/AlgorithmParameterSpec.h"
#include "java/security/spec/DSAParameterSpec.h"
#include "java/security/spec/InvalidParameterSpecException.h"
#include "java/util/Vector.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// private int size
static _jc_field _jc_gnu_java_security_provider_DSAParameterGenerator$field_info$size = {
	.name=		"size",
	.signature=	"I",
	.class=		&_jc_gnu_java_security_provider_DSAParameterGenerator$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_gnu_java_security_provider_DSAParameterGenerator$object, nonrefs.gnu_java_security_provider_DSAParameterGenerator.size),
};

// private java.security.SecureRandom random
static _jc_field _jc_gnu_java_security_provider_DSAParameterGenerator$field_info$random = {
	.name=		"random",
	.signature=	"Ljava/security/SecureRandom;",
	.class=		&_jc_gnu_java_security_provider_DSAParameterGenerator$type,
	.type=		&_jc_java_security_SecureRandom$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_gnu_java_security_provider_DSAParameterGenerator$object, refs[-1].gnu_java_security_provider_DSAParameterGenerator.random),
};

// Fields
static _jc_field *const _jc_gnu_java_security_provider_DSAParameterGenerator$fields[] = {
	&_jc_gnu_java_security_provider_DSAParameterGenerator$field_info$random,
	&_jc_gnu_java_security_provider_DSAParameterGenerator$field_info$size
};

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// public void <init>()
//

static _jc_linenum _jc_gnu_java_security_provider_DSAParameterGenerator$linenum_table$_init$52f4ad9f2989aeee[];

static const unsigned char _jc_gnu_java_security_provider_DSAParameterGenerator$param_ptypes$_init$52f4ad9f2989aeee[] = { 
_JC_TYPE_VOID };

_jc_method _jc_gnu_java_security_provider_DSAParameterGenerator$method_info$_init$52f4ad9f2989aeee = {
	.name=			"<init>",
	.signature=		"()V",
	.class=			&_jc_gnu_java_security_provider_DSAParameterGenerator$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSAParameterGenerator$param_ptypes$_init$52f4ad9f2989aeee,
	.signature_hash=	_JC_JLONG(0x52f4ad9f2989aeee),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_provider_DSAParameterGenerator$method$_init$52f4ad9f2989aeee,
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_gnu_java_security_provider_DSAParameterGenerator$linenum_table$_init$52f4ad9f2989aeee
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_DSAParameterGenerator, _init$52f4ad9f2989aeee);

void _JC_JCNI_ATTR
_jc_gnu_java_security_provider_DSAParameterGenerator$method$_init$52f4ad9f2989aeee(_jc_env *const env, _jc_gnu_java_security_provider_DSAParameterGenerator$object *this)
{
	struct _jc_gnu_java_security_provider_DSAParameterGenerator$object *r0;

	r0 = this;
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAParameterGenerator, random) = _JC_NULL;
	_JC_LINE_NUMBER(61);				// 0
	_JC_PRIM_FIELD(env, r0, gnu_java_security_provider_DSAParameterGenerator, size) = 1024;
	_JC_LINE_NUMBER(62);				// 1
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public java.security.AlgorithmParameters engineGenerateParameters()
//

static _jc_linenum _jc_gnu_java_security_provider_DSAParameterGenerator$linenum_table$engineGenerateParameters$c500aa80c3b5d11e[];

static _jc_trap_info _jc_gnu_java_security_provider_DSAParameterGenerator$trap_table$engineGenerateParameters$c500aa80c3b5d11e[] = {
	_JC_TRAP(&_jc_java_security_NoSuchAlgorithmException$type, 2, 3),
	_JC_TRAP(&_jc_java_security_NoSuchAlgorithmException$type, 1, 4),
	_JC_TRAP(&_jc_java_security_spec_InvalidParameterSpecException$type, 1, 4),
};

static const unsigned char _jc_gnu_java_security_provider_DSAParameterGenerator$param_ptypes$engineGenerateParameters$c500aa80c3b5d11e[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_gnu_java_security_provider_DSAParameterGenerator$method_info$engineGenerateParameters$c500aa80c3b5d11e = {
	.name=			"engineGenerateParameters",
	.signature=		"()Ljava/security/AlgorithmParameters;",
	.class=			&_jc_gnu_java_security_provider_DSAParameterGenerator$type,
	.return_type=		&_jc_java_security_AlgorithmParameters$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSAParameterGenerator$param_ptypes$engineGenerateParameters$c500aa80c3b5d11e,
	.signature_hash=	_JC_JLONG(0xc500aa80c3b5d11e),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_provider_DSAParameterGenerator$method$engineGenerateParameters$c500aa80c3b5d11e,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_provider_DSAParameterGenerator$vtable, gnu_java_security_provider_DSAParameterGenerator.engineGenerateParameters$c500aa80c3b5d11e) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .trap_table_len=	3,
	  .trap_table=		_jc_gnu_java_security_provider_DSAParameterGenerator$trap_table$engineGenerateParameters$c500aa80c3b5d11e,
	  .u= {
	    .linenum= {
	      .len=	15,
	      .table=	_jc_gnu_java_security_provider_DSAParameterGenerator$linenum_table$engineGenerateParameters$c500aa80c3b5d11e
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_DSAParameterGenerator, engineGenerateParameters$c500aa80c3b5d11e);

_jc_java_security_AlgorithmParameters$object * _JC_JCNI_ATTR
_jc_gnu_java_security_provider_DSAParameterGenerator$method$engineGenerateParameters$c500aa80c3b5d11e(_jc_env *const env, _jc_gnu_java_security_provider_DSAParameterGenerator$object *this)
{
	jint i0;
	jint i1;
	jint volatile i3;
	jint volatile i4;
	jint i5;
	jlong l2;
	struct _jc_gnu_java_security_provider_DSAParameterGenerator$object *r0;
	struct _jc_java_math_BigInteger$object *r1;
	struct _jc_java_security_spec_InvalidParameterSpecException$object *r10;
	struct _jc_java_security_AlgorithmParametersSpi$object *volatile r11;
	struct _jc_java_lang_String$object *volatile r12;
	struct _jc_java_security_Provider$object *volatile r14;
	struct _jc_java_security_AlgorithmParameters$object *volatile r15;
	struct _jc_java_security_NoSuchAlgorithmException$object *volatile r16;
	struct _jc_java_lang_VMThrowable$object *volatile r17;
	struct _jc_java_util_Vector$object *r18;
	_jc_object_array *volatile r19;
	struct _jc_java_math_BigInteger$object *r2;
	struct _jc_java_math_BigInteger$object *r3;
	struct _jc_java_util_Random$object *r4;
	struct _jc_java_math_BigInteger$object *r5;
	struct _jc_java_security_spec_DSAParameterSpec$object *volatile r6;
	struct _jc_java_math_BigInteger$object *r7;
	struct _jc_java_math_BigInteger$object *r8;
	struct _jc_java_security_NoSuchAlgorithmException$object *r9;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_gnu_java_security_provider_DSAParameterGenerator$method_info$engineGenerateParameters$c500aa80c3b5d11e, &&label2, &&label5, &&label6);

	r0 = this;
	_JC_LINE_NUMBER(93);				// 0
	i0 = _JC_PRIM_FIELD(env, r0, gnu_java_security_provider_DSAParameterGenerator, size);
	_JC_LINE_NUMBER(97);				// 1
	r5 = _JC_INVOKE_STATIC(env, java_math_BigInteger, valueOf$f12571683fa5f002, 0, _JC_JLONG(1));
	r1 = _JC_INVOKE_STATIC(env, gnu_java_security_util_Prime, generateRandomPrime$11a496f3dc850602, 0, 159, 160, r5);
	_JC_LINE_NUMBER(100);				// 2
	r5 = _JC_INVOKE_STATIC(env, java_math_BigInteger, valueOf$f12571683fa5f002, 1, _JC_JLONG(1));
	i1 = i0 - 1;
	r3 = _JC_INVOKE_STATIC(env, java_math_BigInteger, valueOf$f12571683fa5f002, 1, _JC_JLONG(1));
	r2 = _JC_INVOKE_STATIC(env, gnu_java_security_util_Prime, generateRandomPrime$5e06bbef4754ac69, 1, r1, r5, i1, i0, r3);
	_JC_LINE_NUMBER(102);				// 3
	r5 = _JC_INVOKE_STATIC(env, java_math_BigInteger, valueOf$f12571683fa5f002, 1, _JC_JLONG(1));
	r3 = _JC_INVOKE_VIRTUAL(env, java_math_BigInteger, subtract$b7315a4e9cf32d2c, r2, r5);
	_JC_LINE_NUMBER(103);				// 4
	r7 = _JC_INVOKE_VIRTUAL(env, java_math_BigInteger, divide$1f8e24b76c912658, r3, r1);
	_JC_LINE_NUMBER(105);				// 5
	r4 = _JC_NEW(env, java_util_Random);
	_JC_ACTIVE_USE(env, java_lang_System);
	l2 = _JC_INVOKE_STATIC(env, java_lang_VMSystem, currentTimeMillis$f4fdeb31d00e9185, 0);
	_JC_INVOKE_NONVIRTUAL(env, java_util_Random, setSeed$b5af8144ceac8f80, 0, r4, l2);
	_JC_LINE_NUMBER(106);				// 6
	r3 = _JC_INVOKE_STATIC(env, java_math_BigInteger, valueOf$f12571683fa5f002, 1, _JC_JLONG(1));

label0:
	_JC_LINE_NUMBER(109);				// 7
	r5 = _JC_INVOKE_STATIC(env, java_math_BigInteger, valueOf$f12571683fa5f002, 1, _JC_JLONG(1));
	r3 = _JC_INVOKE_VIRTUAL(env, java_math_BigInteger, add$72c0c00482f7ce6a, r3, r5);
	_JC_LINE_NUMBER(111);				// 8
	r5 = _JC_INVOKE_VIRTUAL(env, java_math_BigInteger, modPow$53dfc6db09e99e77, r3, r7, r2);
	_JC_LINE_NUMBER(113);				// 9
	r8 = _JC_INVOKE_STATIC(env, java_math_BigInteger, valueOf$f12571683fa5f002, 1, _JC_JLONG(1));
	i1 = _JC_INVOKE_VIRTUAL(env, java_math_BigInteger, compareTo$25060d9459ac57b3, r5, r8);
	if (i1 == 1) {
		_JC_PERIODIC_CHECK(env);
		goto label0;
	}
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(118);				// 10
	r6 = _JC_NEW(env, java_security_spec_DSAParameterSpec);
	_JC_REF_FIELD(env, r6, java_security_spec_DSAParameterSpec, p) = _JC_NULL;
	_JC_REF_FIELD(env, r6, java_security_spec_DSAParameterSpec, q) = _JC_NULL;
	_JC_REF_FIELD(env, r6, java_security_spec_DSAParameterSpec, g) = _JC_NULL;
	_JC_REF_FIELD(env, r6, java_security_spec_DSAParameterSpec, p) = r2;
	_JC_REF_FIELD(env, r6, java_security_spec_DSAParameterSpec, q) = r1;
	_JC_REF_FIELD(env, r6, java_security_spec_DSAParameterSpec, g) = r5;
	_JC_ACTIVE_USE(env, java_security_AlgorithmParameters);
	_JC_LINE_NUMBER(119);				// 11
	r12 = _JC_STRING(env, "DSA");
	_JC_ACTIVE_USE(env, java_security_Security);
	r18 = _JC_STATIC_FIELD(env, java_security_Security, providers, 1);
	i5 = _JC_INVOKE_VIRTUAL(env, java_util_Vector, size$345df5220fc60ade, r18);
	r19 = _JC_NEW_REF_ARRAY(env, java_security_Provider, 1, i5);
	r18 = _JC_STATIC_FIELD(env, java_security_Security, providers, 1);
	_JC_INVOKE_VIRTUAL(env, java_util_Vector, copyInto$cd78d768b3ba4735, r18, r19);
	i3 = 0;
	goto label3;

label1:
	_JC_TRAP_REGION(catch, 2);
	r14 = _JC_REF_ELEMENT(env, r19, i3, 1, 1);
	r15 = _JC_INVOKE_STATIC(env, java_security_AlgorithmParameters, getInstance$6d3303f1afba83cb, 0, r12, r14);
	_JC_TRAP_REGION(catch, 3);
	goto label4;

label2:
	_JC_TRAP_REGION(catch, 3);
	r16 = _JC_CAUGHT_EXCEPTION(env);
	i3 = i3 + 1;

label3:
	_JC_TRAP_REGION(catch, 3);
	i4 = _JC_ARRAY_LENGTH(env, r19);
	if (i3 < i4) {
		_JC_PERIODIC_CHECK(env);
		goto label1;
	}
	r16 = _JC_NEW(env, java_security_NoSuchAlgorithmException);
	_JC_REF_FIELD(env, r16, java_lang_Throwable, cause) = r16;
	r17 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r16);
	_JC_REF_FIELD(env, r16, java_lang_Throwable, vmState) = r17;
	_JC_REF_FIELD(env, r16, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r16, java_lang_Throwable, detailMessage) = r12;
	_JC_THROW(env, r16);

label4:
	_JC_EXPLICIT_NULL_CHECK(env, r15);
	r11 = _JC_REF_FIELD(env, r15, java_security_AlgorithmParameters, paramSpi);
	_JC_INVOKE_VIRTUAL(env, java_security_AlgorithmParametersSpi, engineInit$97ee0e7fb590a770, r11, r6);
	_JC_TRAP_REGION(catch, 4);
	_JC_LINE_NUMBER(121);				// 12
	_JC_CANCEL_TRAPS(env, catch);
	return r15;

label5:
	_JC_TRAP_REGION(catch, 4);
	r9 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(123);				// 13
	_JC_CANCEL_TRAPS(env, catch);
	return _JC_NULL;

label6:
	_JC_TRAP_REGION(catch, 4);
	r10 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(125);				// 14
	_JC_CANCEL_TRAPS(env, catch);
	return _JC_NULL;
}

//
// public void engineInit(int, java.security.SecureRandom)
//

static _jc_linenum _jc_gnu_java_security_provider_DSAParameterGenerator$linenum_table$engineInit$ce17ad6b3fc98d82[];

static const unsigned char _jc_gnu_java_security_provider_DSAParameterGenerator$param_ptypes$engineInit$ce17ad6b3fc98d82[] = { 
_JC_TYPE_INT, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_gnu_java_security_provider_DSAParameterGenerator$param_types$engineInit$ce17ad6b3fc98d82[] = {
	&_jc_int$prim$type,
	&_jc_java_security_SecureRandom$type
};

_jc_method _jc_gnu_java_security_provider_DSAParameterGenerator$method_info$engineInit$ce17ad6b3fc98d82 = {
	.name=			"engineInit",
	.signature=		"(ILjava/security/SecureRandom;)V",
	.class=			&_jc_gnu_java_security_provider_DSAParameterGenerator$type,
	.param_types=		&_jc_gnu_java_security_provider_DSAParameterGenerator$param_types$engineInit$ce17ad6b3fc98d82,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSAParameterGenerator$param_ptypes$engineInit$ce17ad6b3fc98d82,
	.signature_hash=	_JC_JLONG(0xce17ad6b3fc98d82),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_provider_DSAParameterGenerator$method$engineInit$ce17ad6b3fc98d82,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_provider_DSAParameterGenerator$vtable, gnu_java_security_provider_DSAParameterGenerator.engineInit$ce17ad6b3fc98d82) / sizeof(void *),
	.num_parameters=	2,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_gnu_java_security_provider_DSAParameterGenerator$linenum_table$engineInit$ce17ad6b3fc98d82
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_DSAParameterGenerator, engineInit$ce17ad6b3fc98d82);

void _JC_JCNI_ATTR
_jc_gnu_java_security_provider_DSAParameterGenerator$method$engineInit$ce17ad6b3fc98d82(_jc_env *const env, _jc_gnu_java_security_provider_DSAParameterGenerator$object *this, jint param0, _jc_java_security_SecureRandom$object *param1)
{
	jint i0;
	jint i1;
	struct _jc_gnu_java_security_provider_DSAParameterGenerator$object *r0;
	struct _jc_java_security_SecureRandom$object *r1;

	r0 = this;
	i0 = param0;
	r1 = param1;
	_JC_LINE_NUMBER(66);				// 0
	if (i0 < 512)
		goto label0;
	if (i0 > 1024)
		goto label0;
	i1 = i0 % 64;
	if (i1 == 0)
		goto label1;

label0:
	_JC_LINE_NUMBER(68);				// 1
	return;

label1:
	_JC_LINE_NUMBER(69);				// 2
	_JC_PRIM_FIELD(env, r0, gnu_java_security_provider_DSAParameterGenerator, size) = i0;
	_JC_LINE_NUMBER(70);				// 3
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAParameterGenerator, random) = r1;
	_JC_LINE_NUMBER(71);				// 4
	return;
}

//
// public void engineInit(java.security.spec.AlgorithmParameterSpec, java.security.SecureRandom) throws java.security.InvalidAlgorithmParameterException
//

static _jc_linenum _jc_gnu_java_security_provider_DSAParameterGenerator$linenum_table$engineInit$5af33bc7d4d69573[];

static const unsigned char _jc_gnu_java_security_provider_DSAParameterGenerator$param_ptypes$engineInit$5af33bc7d4d69573[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_gnu_java_security_provider_DSAParameterGenerator$exceptions$engineInit$5af33bc7d4d69573[] = {
	&_jc_java_security_InvalidAlgorithmParameterException$type
};

static _jc_type *const _jc_gnu_java_security_provider_DSAParameterGenerator$param_types$engineInit$5af33bc7d4d69573[] = {
	&_jc_java_security_spec_AlgorithmParameterSpec$type,
	&_jc_java_security_SecureRandom$type
};

_jc_method _jc_gnu_java_security_provider_DSAParameterGenerator$method_info$engineInit$5af33bc7d4d69573 = {
	.name=			"engineInit",
	.signature=		"(Ljava/security/spec/AlgorithmParameterSpec;Ljava/security/SecureRandom;)V",
	.class=			&_jc_gnu_java_security_provider_DSAParameterGenerator$type,
	.param_types=		&_jc_gnu_java_security_provider_DSAParameterGenerator$param_types$engineInit$5af33bc7d4d69573,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSAParameterGenerator$param_ptypes$engineInit$5af33bc7d4d69573,
	.signature_hash=	_JC_JLONG(0x5af33bc7d4d69573),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_provider_DSAParameterGenerator$method$engineInit$5af33bc7d4d69573,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_provider_DSAParameterGenerator$vtable, gnu_java_security_provider_DSAParameterGenerator.engineInit$5af33bc7d4d69573) / sizeof(void *),
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_gnu_java_security_provider_DSAParameterGenerator$exceptions$engineInit$5af33bc7d4d69573,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	8,
	      .table=	_jc_gnu_java_security_provider_DSAParameterGenerator$linenum_table$engineInit$5af33bc7d4d69573
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_DSAParameterGenerator, engineInit$5af33bc7d4d69573);

void _JC_JCNI_ATTR
_jc_gnu_java_security_provider_DSAParameterGenerator$method$engineInit$5af33bc7d4d69573(_jc_env *const env, _jc_gnu_java_security_provider_DSAParameterGenerator$object *this, _jc_object *param0, _jc_java_security_SecureRandom$object *param1)
{
	jint i0;
	struct _jc_gnu_java_security_provider_DSAParameterGenerator$object *r0;
	struct _jc_object *r1;
	struct _jc_java_lang_VMThrowable$object *r10;
	struct _jc_java_security_SecureRandom$object *r2;
	struct _jc_java_security_spec_DSAParameterSpec$object *r3;
	struct _jc_java_security_InvalidAlgorithmParameterException$object *r4;
	struct _jc_java_math_BigInteger$object *r5;
	struct _jc_java_lang_String$object *r6;
	struct _jc_java_lang_String$object *r7;
	struct _jc_java_lang_VMThrowable$object *r8;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_LINE_NUMBER(76);				// 0
	z0 = _JC_INSTANCEOF(env, r1, &_jc_java_security_spec_DSAParameterSpec$type);
	if (z0 != 0)
		goto label0;
	_JC_LINE_NUMBER(77);				// 1
	r4 = _JC_NEW(env, java_security_InvalidAlgorithmParameterException);
	r6 = _JC_STRING(env, "Must be DSAParameterSpec");
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r8 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r8;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r6;
	_JC_THROW(env, r4);

label0:
	_JC_LINE_NUMBER(79);				// 2
	r3 = r1;
	_JC_LINE_NUMBER(80);				// 3
	r5 = _JC_INVOKE_VIRTUAL(env, java_security_spec_DSAParameterSpec, getP$612c6062f1779963, r3);
	i0 = _JC_INVOKE_VIRTUAL(env, java_math_BigInteger, bitLength$5238c3f79048adca, r5);
	_JC_LINE_NUMBER(82);				// 4
	if (i0 < 512)
		goto label1;
	if (i0 > 1024)
		goto label1;
	i0 = i0 % 64;
	if (i0 == 0)
		goto label2;

label1:
	_JC_LINE_NUMBER(83);				// 5
	r4 = _JC_NEW(env, java_security_InvalidAlgorithmParameterException);
	r7 = _JC_STRING(env, "Invalid Size");
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r10 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r10;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r7;
	_JC_THROW(env, r4);

label2:
	_JC_LINE_NUMBER(85);				// 6
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAParameterGenerator, random) = r2;
	_JC_LINE_NUMBER(86);				// 7
	return;
}

//
// private final void this()
//

static _jc_linenum _jc_gnu_java_security_provider_DSAParameterGenerator$linenum_table$this$adc93fb6bf4cbffa[];

static const unsigned char _jc_gnu_java_security_provider_DSAParameterGenerator$param_ptypes$this$adc93fb6bf4cbffa[] = { 
_JC_TYPE_VOID };

_jc_method _jc_gnu_java_security_provider_DSAParameterGenerator$method_info$this$adc93fb6bf4cbffa = {
	.name=			"this",
	.signature=		"()V",
	.class=			&_jc_gnu_java_security_provider_DSAParameterGenerator$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSAParameterGenerator$param_ptypes$this$adc93fb6bf4cbffa,
	.signature_hash=	_JC_JLONG(0xadc93fb6bf4cbffa),
	.access_flags=		_JC_ACC_PRIVATE|_JC_ACC_FINAL,
	.function=		&_jc_gnu_java_security_provider_DSAParameterGenerator$method$this$adc93fb6bf4cbffa,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_provider_DSAParameterGenerator$vtable, gnu_java_security_provider_DSAParameterGenerator.this$adc93fb6bf4cbffa) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_gnu_java_security_provider_DSAParameterGenerator$linenum_table$this$adc93fb6bf4cbffa
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_DSAParameterGenerator, this$adc93fb6bf4cbffa);

void _JC_JCNI_ATTR
_jc_gnu_java_security_provider_DSAParameterGenerator$method$this$adc93fb6bf4cbffa(_jc_env *const env, _jc_gnu_java_security_provider_DSAParameterGenerator$object *this)
{
	struct _jc_gnu_java_security_provider_DSAParameterGenerator$object *r0;

	r0 = this;
	_JC_LINE_NUMBER(57);				// 0
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAParameterGenerator, random) = _JC_NULL;
	return;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_gnu_java_security_provider_DSAParameterGenerator$methods[] = {
	&_jc_gnu_java_security_provider_DSAParameterGenerator$method_info$_init$52f4ad9f2989aeee,
	&_jc_gnu_java_security_provider_DSAParameterGenerator$method_info$engineGenerateParameters$c500aa80c3b5d11e,
	&_jc_gnu_java_security_provider_DSAParameterGenerator$method_info$engineInit$ce17ad6b3fc98d82,
	&_jc_gnu_java_security_provider_DSAParameterGenerator$method_info$engineInit$5af33bc7d4d69573,
	&_jc_gnu_java_security_provider_DSAParameterGenerator$method_info$this$adc93fb6bf4cbffa
};

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_gnu_java_security_provider_DSAParameterGenerator$instanceof_hash_bucket_93[] = {
	&_jc_java_security_AlgorithmParameterGeneratorSpi$type,
	_JC_NULL
};
static _jc_type *const _jc_gnu_java_security_provider_DSAParameterGenerator$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};
static _jc_type *const _jc_gnu_java_security_provider_DSAParameterGenerator$instanceof_hash_bucket_106[] = {
	&_jc_gnu_java_security_provider_DSAParameterGenerator$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_gnu_java_security_provider_DSAParameterGenerator$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[93]=	_jc_gnu_java_security_provider_DSAParameterGenerator$instanceof_hash_bucket_93,
	[101]=	_jc_gnu_java_security_provider_DSAParameterGenerator$instanceof_hash_bucket_101,
	[106]=	_jc_gnu_java_security_provider_DSAParameterGenerator$instanceof_hash_bucket_106
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_gnu_java_security_provider_DSAParameterGenerator$class_depends[] = {
	{ "gnu/java/security/util/Prime",	_JC_JLONG(0xc874a81b06ec8350) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/System",	_JC_JLONG(0x53cc8e2333795f04) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMSystem",	_JC_JLONG(0x4d1cebae0bdda058) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/math/BigInteger",	_JC_JLONG(0x7717ded55c30b7f3) },
	{ "java/security/AlgorithmParameterGeneratorSpi",	_JC_JLONG(0xd641d91cd6167b5d) },
	{ "java/security/AlgorithmParameters",	_JC_JLONG(0x814794c0d977019) },
	{ "java/security/AlgorithmParametersSpi",	_JC_JLONG(0xfe4af2c744a13852) },
	{ "java/security/GeneralSecurityException",	_JC_JLONG(0x692089051f4c8d0b) },
	{ "java/security/InvalidAlgorithmParameterException",	_JC_JLONG(0x327edce29f2562dd) },
	{ "java/security/NoSuchAlgorithmException",	_JC_JLONG(0x22e937c2536160b4) },
	{ "java/security/Provider",	_JC_JLONG(0x81b073051aa30acc) },
	{ "java/security/SecureRandom",	_JC_JLONG(0x15c6a62b25a6e96d) },
	{ "java/security/Security",	_JC_JLONG(0x89bf77984bd9669e) },
	{ "java/security/spec/AlgorithmParameterSpec",	_JC_JLONG(0xef2e5e8af121478f) },
	{ "java/security/spec/DSAParameterSpec",	_JC_JLONG(0x96064ba9ffd4a2f9) },
	{ "java/security/spec/InvalidParameterSpecException",	_JC_JLONG(0x6afab99500ae813) },
	{ "java/util/Random",	_JC_JLONG(0x61639c1affc91eab) },
	{ "java/util/Vector",	_JC_JLONG(0xc53e1575b095109b) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_gnu_java_security_provider_DSAParameterGenerator$vtype _jc_gnu_java_security_provider_DSAParameterGenerator$type = {
    .type= {
	.name=			"gnu/java/security/provider/DSAParameterGenerator",
	.superclass=		&_jc_java_security_AlgorithmParameterGeneratorSpi$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		18,
		.hash=			_JC_JLONG(0x55d53ae0ac5cc6a),
		.source_file=		"DSAParameterGenerator.java",
		.instance_size=		sizeof(_jc_gnu_java_security_provider_DSAParameterGenerator$refs) + sizeof(_jc_gnu_java_security_provider_DSAParameterGenerator$object),
		.num_virtual_refs=	1,
		.num_fields=		sizeof(_jc_gnu_java_security_provider_DSAParameterGenerator$fields) / sizeof(*_jc_gnu_java_security_provider_DSAParameterGenerator$fields),
		.fields=		_jc_gnu_java_security_provider_DSAParameterGenerator$fields,
		.num_methods=		sizeof(_jc_gnu_java_security_provider_DSAParameterGenerator$methods) / sizeof(*_jc_gnu_java_security_provider_DSAParameterGenerator$methods),
		.methods=		_jc_gnu_java_security_provider_DSAParameterGenerator$methods,
		.instanceof_hash_table=	_jc_gnu_java_security_provider_DSAParameterGenerator$instanceof_hash_table,
		.num_class_depends=		sizeof(_jc_gnu_java_security_provider_DSAParameterGenerator$class_depends) / sizeof(*_jc_gnu_java_security_provider_DSAParameterGenerator$class_depends),
		.class_depends=		_jc_gnu_java_security_provider_DSAParameterGenerator$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.java_security_AlgorithmParameterGeneratorSpi= {
	    .engineGenerateParameters$c500aa80c3b5d11e=	// overridden
		&_jc_gnu_java_security_provider_DSAParameterGenerator$method$engineGenerateParameters$c500aa80c3b5d11e,
	    .engineInit$ce17ad6b3fc98d82=			// overridden
		&_jc_gnu_java_security_provider_DSAParameterGenerator$method$engineInit$ce17ad6b3fc98d82,
	    .engineInit$5af33bc7d4d69573=			// overridden
		&_jc_gnu_java_security_provider_DSAParameterGenerator$method$engineInit$5af33bc7d4d69573,
	},
	.gnu_java_security_provider_DSAParameterGenerator= {
	    .engineGenerateParameters$c500aa80c3b5d11e=
		&_jc_gnu_java_security_provider_DSAParameterGenerator$method$engineGenerateParameters$c500aa80c3b5d11e,
	    .engineInit$ce17ad6b3fc98d82=
		&_jc_gnu_java_security_provider_DSAParameterGenerator$method$engineInit$ce17ad6b3fc98d82,
	    .engineInit$5af33bc7d4d69573=
		&_jc_gnu_java_security_provider_DSAParameterGenerator$method$engineInit$5af33bc7d4d69573,
	    .this$adc93fb6bf4cbffa=
		&_jc_gnu_java_security_provider_DSAParameterGenerator$method$this$adc93fb6bf4cbffa,
	},
    }
};

