// class gnu.java.security.x509.X509CRLEntry

// class file dependencies
// @dep_class d963c5e3d173e044 gnu_java_security_OID
// @dep_class 78ef52e48159b870 gnu_java_security_der_DERReader
// @dep_class de1638783317796a gnu_java_security_der_DERValue
// @dep_class 4f2d14e7cd25c35a gnu_java_security_x509_GnuPKIExtension
// @dep_class 70edc74efc8796dc gnu_java_security_x509_Util
// @dep_class 2271ec1778434574 gnu_java_security_x509_X509CRLEntry
// @dep_class 9d0b785a9feab044 gnu_java_security_x509_ext_Extension
// @dep_class 317dae12883b24de gnu_java_security_x509_ext_Extension__24Value
// @dep_class 4e0a56550c69d57c java_io_IOException
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class ca631501391a31f1 java_lang_Integer
// @dep_class 505b8a9a6675be0 java_lang_NullPointerException
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class 4f5534a987354d1d java_lang_RuntimeException
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 94d357637b968dda java_lang_StringBuffer
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class 7717ded55c30b7f3 java_math_BigInteger
// @dep_class 692089051f4c8d0b java_security_GeneralSecurityException
// @dep_class 19d465acf62ede69 java_security_cert_CRLException
// @dep_class 4aa1aa15aadaef9a java_security_cert_X509CRLEntry
// @dep_class 823d6f250a58dc54 java_security_cert_X509Extension
// @dep_class 8ea716c64b77f8eb java_util_AbstractCollection
// @dep_class ca427569b5b2f804 java_util_AbstractSet
// @dep_class eae4d0c0e8eb63da java_util_Collection
// @dep_class 9574af3fed58029a java_util_Collections
// @dep_class 2126b28aee607999 java_util_Collections__24UnmodifiableCollection
// @dep_class aec2ea3fc69f0e47 java_util_Collections__24UnmodifiableSet
// @dep_class a85d2a51094e614c java_util_Date
// @dep_class d7cd853200c3e71f java_util_HashMap
// @dep_class 3c285c721478414d java_util_HashSet
// @dep_class be56ff673eefd9d2 java_util_Iterator
// @dep_class 617ac82c0bec2dff java_util_Set

// header file dependencies
// @dep_header gnu_java_security_OID
// @dep_header gnu_java_security_der_DERReader
// @dep_header gnu_java_security_der_DERValue
// @dep_header gnu_java_security_x509_GnuPKIExtension
// @dep_header gnu_java_security_x509_Util
// @dep_header gnu_java_security_x509_X509CRLEntry
// @dep_header gnu_java_security_x509_ext_Extension
// @dep_header gnu_java_security_x509_ext_Extension__24Value
// @dep_header java_io_IOException
// @dep_header java_lang_Class
// @dep_header java_lang_Integer
// @dep_header java_lang_NullPointerException
// @dep_header java_lang_String
// @dep_header java_lang_StringBuffer
// @dep_header java_lang_VMThrowable
// @dep_header java_math_BigInteger
// @dep_header java_security_cert_CRLException
// @dep_header java_security_cert_X509Extension
// @dep_header java_util_Collection
// @dep_header java_util_Collections
// @dep_header java_util_Collections__24UnmodifiableSet
// @dep_header java_util_Date
// @dep_header java_util_HashMap
// @dep_header java_util_HashSet
// @dep_header java_util_Iterator
// @dep_header java_util_Set

#include "jc_defs.h"

#include "gnu/java/security/OID.h"
#include "gnu/java/security/der/DERReader.h"
#include "gnu/java/security/der/DERValue.h"
#include "gnu/java/security/x509/GnuPKIExtension.h"
#include "gnu/java/security/x509/Util.h"
#include "gnu/java/security/x509/X509CRLEntry.h"
#include "gnu/java/security/x509/ext/Extension.h"
#include "gnu/java/security/x509/ext/Extension__24Value.h"
#include "java/io/IOException.h"
#include "java/lang/Class.h"
#include "java/lang/Integer.h"
#include "java/lang/NullPointerException.h"
#include "java/lang/String.h"
#include "java/lang/StringBuffer.h"
#include "java/lang/VMThrowable.h"
#include "java/math/BigInteger.h"
#include "java/security/cert/CRLException.h"
#include "java/security/cert/X509Extension.h"
#include "java/util/Collection.h"
#include "java/util/Collections.h"
#include "java/util/Collections__24UnmodifiableSet.h"
#include "java/util/Date.h"
#include "java/util/HashMap.h"
#include "java/util/HashSet.h"
#include "java/util/Iterator.h"
#include "java/util/Set.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// private static final boolean DEBUG
static const jboolean _jc_gnu_java_security_x509_X509CRLEntry$initial_value$DEBUG = 0;
static _jc_field _jc_gnu_java_security_x509_X509CRLEntry$field_info$DEBUG = {
	.name=		"DEBUG",
	.signature=	"Z",
	.class=		&_jc_gnu_java_security_x509_X509CRLEntry$type,
	.type=		&_jc_boolean$prim$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_gnu_java_security_x509_X509CRLEntry$fields_struct, DEBUG),
	.initial_value=	&_jc_gnu_java_security_x509_X509CRLEntry$initial_value$DEBUG,
};

// private byte[] encoded
static _jc_field _jc_gnu_java_security_x509_X509CRLEntry$field_info$encoded = {
	.name=		"encoded",
	.signature=	"[B",
	.class=		&_jc_gnu_java_security_x509_X509CRLEntry$type,
	.type=		&_jc_byte$array$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_gnu_java_security_x509_X509CRLEntry$object, refs[-1].gnu_java_security_x509_X509CRLEntry.encoded),
};

// private java.math.BigInteger serialNo
static _jc_field _jc_gnu_java_security_x509_X509CRLEntry$field_info$serialNo = {
	.name=		"serialNo",
	.signature=	"Ljava/math/BigInteger;",
	.class=		&_jc_gnu_java_security_x509_X509CRLEntry$type,
	.type=		&_jc_java_math_BigInteger$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_gnu_java_security_x509_X509CRLEntry$object, refs[-1].gnu_java_security_x509_X509CRLEntry.serialNo),
};

// private java.util.Date revocationDate
static _jc_field _jc_gnu_java_security_x509_X509CRLEntry$field_info$revocationDate = {
	.name=		"revocationDate",
	.signature=	"Ljava/util/Date;",
	.class=		&_jc_gnu_java_security_x509_X509CRLEntry$type,
	.type=		&_jc_java_util_Date$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_gnu_java_security_x509_X509CRLEntry$object, refs[-1].gnu_java_security_x509_X509CRLEntry.revocationDate),
};

// private java.util.HashMap extensions
static _jc_field _jc_gnu_java_security_x509_X509CRLEntry$field_info$extensions = {
	.name=		"extensions",
	.signature=	"Ljava/util/HashMap;",
	.class=		&_jc_gnu_java_security_x509_X509CRLEntry$type,
	.type=		&_jc_java_util_HashMap$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_gnu_java_security_x509_X509CRLEntry$object, refs[-1].gnu_java_security_x509_X509CRLEntry.extensions),
};

// Fields
static _jc_field *const _jc_gnu_java_security_x509_X509CRLEntry$fields[] = {
	&_jc_gnu_java_security_x509_X509CRLEntry$field_info$DEBUG,
	&_jc_gnu_java_security_x509_X509CRLEntry$field_info$encoded,
	&_jc_gnu_java_security_x509_X509CRLEntry$field_info$extensions,
	&_jc_gnu_java_security_x509_X509CRLEntry$field_info$revocationDate,
	&_jc_gnu_java_security_x509_X509CRLEntry$field_info$serialNo
};

/************************************************************************
 *			      Static methods				*
 ************************************************************************/

//
// private static final void debug(java.lang.String)
//

static _jc_linenum _jc_gnu_java_security_x509_X509CRLEntry$linenum_table$debug$1e3312c3736b0b51[];

static const unsigned char _jc_gnu_java_security_x509_X509CRLEntry$param_ptypes$debug$1e3312c3736b0b51[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_gnu_java_security_x509_X509CRLEntry$param_types$debug$1e3312c3736b0b51[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_gnu_java_security_x509_X509CRLEntry$method_info$debug$1e3312c3736b0b51 = {
	.name=			"debug",
	.signature=		"(Ljava/lang/String;)V",
	.class=			&_jc_gnu_java_security_x509_X509CRLEntry$type,
	.param_types=		&_jc_gnu_java_security_x509_X509CRLEntry$param_types$debug$1e3312c3736b0b51,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_x509_X509CRLEntry$param_ptypes$debug$1e3312c3736b0b51,
	.signature_hash=	_JC_JLONG(0x1e3312c3736b0b51),
	.access_flags=		_JC_ACC_PRIVATE|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.function=		&_jc_gnu_java_security_x509_X509CRLEntry$method$debug$1e3312c3736b0b51,
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_gnu_java_security_x509_X509CRLEntry$linenum_table$debug$1e3312c3736b0b51
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_x509_X509CRLEntry, debug$1e3312c3736b0b51);

void _JC_JCNI_ATTR
_jc_gnu_java_security_x509_X509CRLEntry$method$debug$1e3312c3736b0b51(_jc_env *const env, _jc_java_lang_String$object *param0)
{
	struct _jc_java_lang_String$object *r0;

	r0 = param0;
	_JC_LINE_NUMBER(78);				// 0
	return;
}

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// void <init>(int, gnu.java.security.der.DERReader) throws java.security.cert.CRLException, java.io.IOException
//

static _jc_linenum _jc_gnu_java_security_x509_X509CRLEntry$linenum_table$_init$218eaec10c312d80[];

static _jc_trap_info _jc_gnu_java_security_x509_X509CRLEntry$trap_table$_init$218eaec10c312d80[] = {
	_JC_TRAP(&_jc_java_io_IOException$type, 1, 2),
	_JC_TRAP(&_jc_java_lang_Exception$type, 1, 2),
};

static const unsigned char _jc_gnu_java_security_x509_X509CRLEntry$param_ptypes$_init$218eaec10c312d80[] = { 
_JC_TYPE_INT, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_gnu_java_security_x509_X509CRLEntry$exceptions$_init$218eaec10c312d80[] = {
	&_jc_java_security_cert_CRLException$type,
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_gnu_java_security_x509_X509CRLEntry$param_types$_init$218eaec10c312d80[] = {
	&_jc_int$prim$type,
	&_jc_gnu_java_security_der_DERReader$type
};

_jc_method _jc_gnu_java_security_x509_X509CRLEntry$method_info$_init$218eaec10c312d80 = {
	.name=			"<init>",
	.signature=		"(ILgnu/java/security/der/DERReader;)V",
	.class=			&_jc_gnu_java_security_x509_X509CRLEntry$type,
	.param_types=		&_jc_gnu_java_security_x509_X509CRLEntry$param_types$_init$218eaec10c312d80,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_x509_X509CRLEntry$param_ptypes$_init$218eaec10c312d80,
	.signature_hash=	_JC_JLONG(0x218eaec10c312d80),
	.access_flags=		0,
	.function=		&_jc_gnu_java_security_x509_X509CRLEntry$method$_init$218eaec10c312d80,
	.num_parameters=	2,
	.num_exceptions=	2,
	.exceptions=		&_jc_gnu_java_security_x509_X509CRLEntry$exceptions$_init$218eaec10c312d80,
	.u= { .exec= {
	  .trap_table_len=	2,
	  .trap_table=		_jc_gnu_java_security_x509_X509CRLEntry$trap_table$_init$218eaec10c312d80,
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_gnu_java_security_x509_X509CRLEntry$linenum_table$_init$218eaec10c312d80
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_x509_X509CRLEntry, _init$218eaec10c312d80);

void _JC_JCNI_ATTR
_jc_gnu_java_security_x509_X509CRLEntry$method$_init$218eaec10c312d80(_jc_env *const env, _jc_gnu_java_security_x509_X509CRLEntry$object *this, jint param0, _jc_gnu_java_security_der_DERReader$object *param1)
{
	jint i0;
	struct _jc_gnu_java_security_x509_X509CRLEntry$object *r0;
	struct _jc_gnu_java_security_der_DERReader$object *r1;
	struct _jc_java_util_HashMap$object *r2;
	struct _jc_java_io_IOException$object *volatile r3;
	struct _jc_java_lang_Exception$object *volatile r4;
	struct _jc_java_security_cert_CRLException$object *volatile r5;
	struct _jc_java_lang_String$object *volatile r6;
	struct _jc_java_lang_VMThrowable$object *volatile r8;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_gnu_java_security_x509_X509CRLEntry$method_info$_init$218eaec10c312d80, &&label0, &&label1);

	r0 = this;
	i0 = param0;
	r1 = param1;
	_JC_LINE_NUMBER(108);				// 0
	r2 = _JC_NEW(env, java_util_HashMap);
	_JC_INVOKE_NONVIRTUAL(env, java_util_HashMap, _init$7cb044ce4fb0ada8, 0, r2, 11, _JC_FCONST(0x3f, 0x40, 0x0, 0x0));
	_JC_REF_FIELD(env, r0, gnu_java_security_x509_X509CRLEntry, extensions) = r2;
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(111);				// 1
	_JC_INVOKE_NONVIRTUAL(env, gnu_java_security_x509_X509CRLEntry, parse$3548474769ac34dd, 0, r0, i0, r1);
	_JC_TRAP_REGION(catch, 2);
	goto label2;

label0:
	_JC_TRAP_REGION(catch, 2);
	r3 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(115);				// 2
	_JC_THROW(env, r3);

label1:
	_JC_TRAP_REGION(catch, 2);
	r4 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(119);				// 3
	r5 = _JC_NEW(env, java_security_cert_CRLException);
	r6 = _JC_INVOKE_VIRTUAL(env, java_lang_Throwable, toString$7ea43b33b80a3070, r4);
	_JC_REF_FIELD(env, r5, java_lang_Throwable, cause) = r5;
	r8 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r5);
	_JC_REF_FIELD(env, r5, java_lang_Throwable, vmState) = r8;
	_JC_REF_FIELD(env, r5, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r5, java_lang_Throwable, detailMessage) = r6;
	_JC_THROW(env, r5);

label2:
	_JC_LINE_NUMBER(121);				// 4
	_JC_CANCEL_TRAPS(env, catch);
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public boolean equals(java.lang.Object)
//

static _jc_linenum _jc_gnu_java_security_x509_X509CRLEntry$linenum_table$equals$8a15e0625571c581[];

static const unsigned char _jc_gnu_java_security_x509_X509CRLEntry$param_ptypes$equals$8a15e0625571c581[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_gnu_java_security_x509_X509CRLEntry$param_types$equals$8a15e0625571c581[] = {
	&_jc_java_lang_Object$type
};

_jc_method _jc_gnu_java_security_x509_X509CRLEntry$method_info$equals$8a15e0625571c581 = {
	.name=			"equals",
	.signature=		"(Ljava/lang/Object;)Z",
	.class=			&_jc_gnu_java_security_x509_X509CRLEntry$type,
	.param_types=		&_jc_gnu_java_security_x509_X509CRLEntry$param_types$equals$8a15e0625571c581,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_x509_X509CRLEntry$param_ptypes$equals$8a15e0625571c581,
	.signature_hash=	_JC_JLONG(0x8a15e0625571c581),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_x509_X509CRLEntry$method$equals$8a15e0625571c581,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_x509_X509CRLEntry$vtable, gnu_java_security_x509_X509CRLEntry.equals$8a15e0625571c581) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_gnu_java_security_x509_X509CRLEntry$linenum_table$equals$8a15e0625571c581
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_x509_X509CRLEntry, equals$8a15e0625571c581);

jboolean _JC_JCNI_ATTR
_jc_gnu_java_security_x509_X509CRLEntry$method$equals$8a15e0625571c581(_jc_env *const env, _jc_gnu_java_security_x509_X509CRLEntry$object *this, _jc_java_lang_Object$object *param0)
{
	struct _jc_gnu_java_security_x509_X509CRLEntry$object *r0;
	struct _jc_java_lang_Object$object *r1;
	struct _jc_gnu_java_security_x509_X509CRLEntry$object *r2;
	struct _jc_java_math_BigInteger$object *r3;
	struct _jc_java_math_BigInteger$object *r4;
	struct _jc_java_util_Date$object *r6;
	struct _jc_java_util_Date$object *r7;
	jboolean z0;
	jboolean z2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(128);				// 0
	z0 = _JC_INSTANCEOF(env, r1, &_jc_gnu_java_security_x509_X509CRLEntry$type);
	if (z0 != 0)
		goto label0;
	_JC_LINE_NUMBER(129);				// 1
	return 0;

label0:
	_JC_LINE_NUMBER(130);				// 2
	z0 = 0;
	r2 = r1;
	r3 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_x509_X509CRLEntry, getSerialNumber$7e3dedaf516a1567, r2);
	r4 = _JC_REF_FIELD(env, r0, gnu_java_security_x509_X509CRLEntry, serialNo);
	z2 = _JC_INVOKE_VIRTUAL(env, java_math_BigInteger, equals$8a15e0625571c581, r3, r4);
	if (z2 == 0)
		goto label1;
	r2 = r1;
	r6 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_x509_X509CRLEntry, getRevocationDate$f4bc39251cfa4263, r2);
	r7 = _JC_REF_FIELD(env, r0, gnu_java_security_x509_X509CRLEntry, revocationDate);
	z2 = _JC_INVOKE_VIRTUAL(env, java_util_Date, equals$8a15e0625571c581, r6, r7);
	if (z2 == 0)
		goto label1;
	z0 = 1;

label1:
	return z0;
}

//
// public java.util.Set getCriticalExtensionOIDs()
//

static _jc_linenum _jc_gnu_java_security_x509_X509CRLEntry$linenum_table$getCriticalExtensionOIDs$13bd73a925085701[];

static const unsigned char _jc_gnu_java_security_x509_X509CRLEntry$param_ptypes$getCriticalExtensionOIDs$13bd73a925085701[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_gnu_java_security_x509_X509CRLEntry$method_info$getCriticalExtensionOIDs$13bd73a925085701 = {
	.name=			"getCriticalExtensionOIDs",
	.signature=		"()Ljava/util/Set;",
	.class=			&_jc_gnu_java_security_x509_X509CRLEntry$type,
	.return_type=		&_jc_java_util_Set$type,
	.param_ptypes=		&_jc_gnu_java_security_x509_X509CRLEntry$param_ptypes$getCriticalExtensionOIDs$13bd73a925085701,
	.signature_hash=	_JC_JLONG(0x13bd73a925085701),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_x509_X509CRLEntry$method$getCriticalExtensionOIDs$13bd73a925085701,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_x509_X509CRLEntry$vtable, gnu_java_security_x509_X509CRLEntry.getCriticalExtensionOIDs$13bd73a925085701) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	7,
	      .table=	_jc_gnu_java_security_x509_X509CRLEntry$linenum_table$getCriticalExtensionOIDs$13bd73a925085701
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_x509_X509CRLEntry, getCriticalExtensionOIDs$13bd73a925085701);

_jc_object * _JC_JCNI_ATTR
_jc_gnu_java_security_x509_X509CRLEntry$method$getCriticalExtensionOIDs$13bd73a925085701(_jc_env *const env, _jc_gnu_java_security_x509_X509CRLEntry$object *this)
{
	struct _jc_gnu_java_security_x509_X509CRLEntry$object *r0;
	struct _jc_java_util_HashSet$object *r1;
	struct _jc_java_util_HashMap$object *r10;
	struct _jc_java_lang_Object$object *r11;
	struct _jc_java_util_HashMap$object *r12;
	struct _jc_java_lang_NullPointerException$object *r13;
	struct _jc_java_lang_String$object *r14;
	struct _jc_java_lang_VMThrowable$object *r16;
	struct _jc_object *r2;
	struct _jc_gnu_java_security_x509_ext_Extension$object *r3;
	struct _jc_java_util_HashMap$object *r4;
	struct _jc_object *r5;
	struct _jc_java_lang_Object$object *r6;
	struct _jc_gnu_java_security_OID$object *r7;
	struct _jc_java_lang_String$object *r8;
	struct _jc_java_util_Collections__24UnmodifiableSet$object *r9;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(181);				// 0
	r1 = _JC_NEW(env, java_util_HashSet);
	r10 = _JC_NEW(env, java_util_HashMap);
	_JC_INVOKE_NONVIRTUAL(env, java_util_HashMap, _init$7cb044ce4fb0ada8, 0, r10, 11, _JC_FCONST(0x3f, 0x40, 0x0, 0x0));
	_JC_REF_FIELD(env, r1, java_util_HashSet, map) = r10;
	_JC_LINE_NUMBER(182);				// 1
	r4 = _JC_REF_FIELD(env, r0, gnu_java_security_x509_X509CRLEntry, extensions);
	r5 = _JC_INVOKE_VIRTUAL(env, java_util_HashMap, values$ff2f8ae502eccb46, r4);
	r2 = _JC_INVOKE_INTERFACE(env, r5, _JC_JLONG(0x3cc91493d50f531c), _jc_object *, (_jc_env *, struct _jc_object *));
	goto label1;

label0:
	_JC_LINE_NUMBER(184);				// 2
	r6 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0x5874f79a1cf66ea), _jc_object *, (_jc_env *, struct _jc_object *));
	r3 = _JC_CAST(env, &_jc_gnu_java_security_x509_ext_Extension$type, r6);
	_JC_LINE_NUMBER(185);				// 3
	z0 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_x509_ext_Extension, isCritical$26e138602d0c5362, r3);
	if (z0 == 0)
		goto label1;
	_JC_LINE_NUMBER(186);				// 4
	r7 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_x509_ext_Extension, getOid$2fbe8757f54d905b, r3);
	r8 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_OID, toString$7ea43b33b80a3070, r7);
	r12 = _JC_REF_FIELD(env, r1, java_util_HashSet, map);
	r11 = _JC_INVOKE_VIRTUAL(env, java_util_HashMap, put$3bd1c078a0faa8da, r12, r8, _JC_STRING(env, ""));
	if (r11 != _JC_NULL)
		goto label1;

label1:
	_JC_LINE_NUMBER(182);				// 5
	z0 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0xfb0bd5e38c59ddcd), jboolean, (_jc_env *, struct _jc_object *));
	if (z0 != 0) {
		_JC_PERIODIC_CHECK(env);
		goto label0;
	}
	_JC_ACTIVE_USE(env, java_util_Collections);
	r9 = _JC_NEW(env, java_util_Collections__24UnmodifiableSet);
	_JC_REF_FIELD(env, r9, java_util_Collections__24UnmodifiableCollection, c) = r1;
	if (r1 != _JC_NULL)
		goto label2;
	r13 = _JC_NEW(env, java_lang_NullPointerException);
	r14 = _JC_NULL;
	_JC_REF_FIELD(env, r13, java_lang_Throwable, cause) = r13;
	r16 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r13);
	_JC_REF_FIELD(env, r13, java_lang_Throwable, vmState) = r16;
	_JC_REF_FIELD(env, r13, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r13, java_lang_Throwable, detailMessage) = r14;
	_JC_THROW(env, r13);

label2:
	_JC_LINE_NUMBER(188);				// 6
	return r9;
}

//
// public byte[] getEncoded() throws java.security.cert.CRLException
//

static _jc_linenum _jc_gnu_java_security_x509_X509CRLEntry$linenum_table$getEncoded$eaf136136217eb89[];

static const unsigned char _jc_gnu_java_security_x509_X509CRLEntry$param_ptypes$getEncoded$eaf136136217eb89[] = { 
_JC_TYPE_REFERENCE };

static _jc_type *const _jc_gnu_java_security_x509_X509CRLEntry$exceptions$getEncoded$eaf136136217eb89[] = {
	&_jc_java_security_cert_CRLException$type
};

_jc_method _jc_gnu_java_security_x509_X509CRLEntry$method_info$getEncoded$eaf136136217eb89 = {
	.name=			"getEncoded",
	.signature=		"()[B",
	.class=			&_jc_gnu_java_security_x509_X509CRLEntry$type,
	.return_type=		&_jc_byte$array$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_x509_X509CRLEntry$param_ptypes$getEncoded$eaf136136217eb89,
	.signature_hash=	_JC_JLONG(0xeaf136136217eb89),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_x509_X509CRLEntry$method$getEncoded$eaf136136217eb89,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_x509_X509CRLEntry$vtable, gnu_java_security_x509_X509CRLEntry.getEncoded$eaf136136217eb89) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_gnu_java_security_x509_X509CRLEntry$exceptions$getEncoded$eaf136136217eb89,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_gnu_java_security_x509_X509CRLEntry$linenum_table$getEncoded$eaf136136217eb89
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_x509_X509CRLEntry, getEncoded$eaf136136217eb89);

_jc_byte_array * _JC_JCNI_ATTR
_jc_gnu_java_security_x509_X509CRLEntry$method$getEncoded$eaf136136217eb89(_jc_env *const env, _jc_gnu_java_security_x509_X509CRLEntry$object *this)
{
	struct _jc_gnu_java_security_x509_X509CRLEntry$object *r0;
	_jc_byte_array *r1;
	struct _jc_java_lang_Object$object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(141);				// 0
	r1 = _JC_REF_FIELD(env, r0, gnu_java_security_x509_X509CRLEntry, encoded);
	r2 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, clone$b75f2713d6705f70, r1);
	r1 = _JC_CAST_FINAL(env, &_jc_byte$array$prim$type, r2);
	return r1;
}

//
// public gnu.java.security.x509.ext.Extension getExtension(gnu.java.security.OID)
//

static _jc_linenum _jc_gnu_java_security_x509_X509CRLEntry$linenum_table$getExtension$5d05f6c6eab904e4[];

static const unsigned char _jc_gnu_java_security_x509_X509CRLEntry$param_ptypes$getExtension$5d05f6c6eab904e4[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_gnu_java_security_x509_X509CRLEntry$param_types$getExtension$5d05f6c6eab904e4[] = {
	&_jc_gnu_java_security_OID$type
};

_jc_method _jc_gnu_java_security_x509_X509CRLEntry$method_info$getExtension$5d05f6c6eab904e4 = {
	.name=			"getExtension",
	.signature=		"(Lgnu/java/security/OID;)Lgnu/java/security/x509/ext/Extension;",
	.class=			&_jc_gnu_java_security_x509_X509CRLEntry$type,
	.param_types=		&_jc_gnu_java_security_x509_X509CRLEntry$param_types$getExtension$5d05f6c6eab904e4,
	.return_type=		&_jc_gnu_java_security_x509_ext_Extension$type,
	.param_ptypes=		&_jc_gnu_java_security_x509_X509CRLEntry$param_ptypes$getExtension$5d05f6c6eab904e4,
	.signature_hash=	_JC_JLONG(0x5d05f6c6eab904e4),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_x509_X509CRLEntry$method$getExtension$5d05f6c6eab904e4,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_x509_X509CRLEntry$vtable, gnu_java_security_x509_X509CRLEntry.getExtension$5d05f6c6eab904e4) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_gnu_java_security_x509_X509CRLEntry$linenum_table$getExtension$5d05f6c6eab904e4
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_x509_X509CRLEntry, getExtension$5d05f6c6eab904e4);

_jc_gnu_java_security_x509_ext_Extension$object * _JC_JCNI_ATTR
_jc_gnu_java_security_x509_X509CRLEntry$method$getExtension$5d05f6c6eab904e4(_jc_env *const env, _jc_gnu_java_security_x509_X509CRLEntry$object *this, _jc_gnu_java_security_OID$object *param0)
{
	struct _jc_gnu_java_security_x509_X509CRLEntry$object *r0;
	struct _jc_gnu_java_security_OID$object *r1;
	struct _jc_java_util_HashMap$object *r2;
	struct _jc_java_lang_Object$object *r3;
	struct _jc_gnu_java_security_x509_ext_Extension$object *r4;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(218);				// 0
	r2 = _JC_REF_FIELD(env, r0, gnu_java_security_x509_X509CRLEntry, extensions);
	r3 = _JC_INVOKE_VIRTUAL(env, java_util_HashMap, get$b30461fc5ea13399, r2, r1);
	r4 = _JC_CAST(env, &_jc_gnu_java_security_x509_ext_Extension$type, r3);
	return r4;
}

//
// public byte[] getExtensionValue(java.lang.String)
//

static _jc_linenum _jc_gnu_java_security_x509_X509CRLEntry$linenum_table$getExtensionValue$4dd9512bdab291e0[];

static const unsigned char _jc_gnu_java_security_x509_X509CRLEntry$param_ptypes$getExtensionValue$4dd9512bdab291e0[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_gnu_java_security_x509_X509CRLEntry$param_types$getExtensionValue$4dd9512bdab291e0[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_gnu_java_security_x509_X509CRLEntry$method_info$getExtensionValue$4dd9512bdab291e0 = {
	.name=			"getExtensionValue",
	.signature=		"(Ljava/lang/String;)[B",
	.class=			&_jc_gnu_java_security_x509_X509CRLEntry$type,
	.param_types=		&_jc_gnu_java_security_x509_X509CRLEntry$param_types$getExtensionValue$4dd9512bdab291e0,
	.return_type=		&_jc_byte$array$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_x509_X509CRLEntry$param_ptypes$getExtensionValue$4dd9512bdab291e0,
	.signature_hash=	_JC_JLONG(0x4dd9512bdab291e0),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_x509_X509CRLEntry$method$getExtensionValue$4dd9512bdab291e0,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_x509_X509CRLEntry$vtable, gnu_java_security_x509_X509CRLEntry.getExtensionValue$4dd9512bdab291e0) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_gnu_java_security_x509_X509CRLEntry$linenum_table$getExtensionValue$4dd9512bdab291e0
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_x509_X509CRLEntry, getExtensionValue$4dd9512bdab291e0);

_jc_byte_array * _JC_JCNI_ATTR
_jc_gnu_java_security_x509_X509CRLEntry$method$getExtensionValue$4dd9512bdab291e0(_jc_env *const env, _jc_gnu_java_security_x509_X509CRLEntry$object *this, _jc_java_lang_String$object *param0)
{
	struct _jc_gnu_java_security_x509_X509CRLEntry$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_gnu_java_security_OID$object *r2;
	struct _jc_gnu_java_security_x509_ext_Extension$object *r3;
	struct _jc_gnu_java_security_x509_ext_Extension__24Value$object *r4;
	_jc_byte_array *r5;
	_jc_int_array *r6;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(205);				// 0
	r2 = _JC_NEW(env, gnu_java_security_OID);
	_JC_PRIM_FIELD(env, r2, gnu_java_security_OID, relative) = 0;
	_JC_REF_FIELD(env, r2, gnu_java_security_OID, strRep) = r1;
	r6 = _JC_INVOKE_STATIC(env, gnu_java_security_OID, fromString$9ddcac0b5ea00f21, 1, r1);
	_JC_REF_FIELD(env, r2, gnu_java_security_OID, components) = r6;
	r3 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_x509_X509CRLEntry, getExtension$5d05f6c6eab904e4, r0, r2);
	_JC_LINE_NUMBER(206);				// 1
	if (r3 == _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(208);				// 2
	r4 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_x509_ext_Extension, getValue$39b683fcca92e349, r3);
	r5 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_x509_ext_Extension__24Value, getEncoded$eaf136136217eb89, r4);
	return r5;

label0:
	_JC_LINE_NUMBER(210);				// 3
	return _JC_NULL;
}

//
// public java.util.Collection getExtensions()
//

static _jc_linenum _jc_gnu_java_security_x509_X509CRLEntry$linenum_table$getExtensions$e635946d32343834[];

static const unsigned char _jc_gnu_java_security_x509_X509CRLEntry$param_ptypes$getExtensions$e635946d32343834[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_gnu_java_security_x509_X509CRLEntry$method_info$getExtensions$e635946d32343834 = {
	.name=			"getExtensions",
	.signature=		"()Ljava/util/Collection;",
	.class=			&_jc_gnu_java_security_x509_X509CRLEntry$type,
	.return_type=		&_jc_java_util_Collection$type,
	.param_ptypes=		&_jc_gnu_java_security_x509_X509CRLEntry$param_ptypes$getExtensions$e635946d32343834,
	.signature_hash=	_JC_JLONG(0xe635946d32343834),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_x509_X509CRLEntry$method$getExtensions$e635946d32343834,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_x509_X509CRLEntry$vtable, gnu_java_security_x509_X509CRLEntry.getExtensions$e635946d32343834) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_gnu_java_security_x509_X509CRLEntry$linenum_table$getExtensions$e635946d32343834
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_x509_X509CRLEntry, getExtensions$e635946d32343834);

_jc_object * _JC_JCNI_ATTR
_jc_gnu_java_security_x509_X509CRLEntry$method$getExtensions$e635946d32343834(_jc_env *const env, _jc_gnu_java_security_x509_X509CRLEntry$object *this)
{
	struct _jc_gnu_java_security_x509_X509CRLEntry$object *r0;
	struct _jc_java_util_HashMap$object *r1;
	struct _jc_object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(223);				// 0
	r1 = _JC_REF_FIELD(env, r0, gnu_java_security_x509_X509CRLEntry, extensions);
	r2 = _JC_INVOKE_VIRTUAL(env, java_util_HashMap, values$ff2f8ae502eccb46, r1);
	return r2;
}

//
// public java.util.Set getNonCriticalExtensionOIDs()
//

static _jc_linenum _jc_gnu_java_security_x509_X509CRLEntry$linenum_table$getNonCriticalExtensionOIDs$eb792be2fbd03dd4[];

static const unsigned char _jc_gnu_java_security_x509_X509CRLEntry$param_ptypes$getNonCriticalExtensionOIDs$eb792be2fbd03dd4[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_gnu_java_security_x509_X509CRLEntry$method_info$getNonCriticalExtensionOIDs$eb792be2fbd03dd4 = {
	.name=			"getNonCriticalExtensionOIDs",
	.signature=		"()Ljava/util/Set;",
	.class=			&_jc_gnu_java_security_x509_X509CRLEntry$type,
	.return_type=		&_jc_java_util_Set$type,
	.param_ptypes=		&_jc_gnu_java_security_x509_X509CRLEntry$param_ptypes$getNonCriticalExtensionOIDs$eb792be2fbd03dd4,
	.signature_hash=	_JC_JLONG(0xeb792be2fbd03dd4),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_x509_X509CRLEntry$method$getNonCriticalExtensionOIDs$eb792be2fbd03dd4,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_x509_X509CRLEntry$vtable, gnu_java_security_x509_X509CRLEntry.getNonCriticalExtensionOIDs$eb792be2fbd03dd4) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	7,
	      .table=	_jc_gnu_java_security_x509_X509CRLEntry$linenum_table$getNonCriticalExtensionOIDs$eb792be2fbd03dd4
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_x509_X509CRLEntry, getNonCriticalExtensionOIDs$eb792be2fbd03dd4);

_jc_object * _JC_JCNI_ATTR
_jc_gnu_java_security_x509_X509CRLEntry$method$getNonCriticalExtensionOIDs$eb792be2fbd03dd4(_jc_env *const env, _jc_gnu_java_security_x509_X509CRLEntry$object *this)
{
	struct _jc_gnu_java_security_x509_X509CRLEntry$object *r0;
	struct _jc_java_util_HashSet$object *r1;
	struct _jc_java_util_HashMap$object *r10;
	struct _jc_java_lang_Object$object *r11;
	struct _jc_java_util_HashMap$object *r12;
	struct _jc_java_lang_NullPointerException$object *r13;
	struct _jc_java_lang_String$object *r14;
	struct _jc_java_lang_VMThrowable$object *r16;
	struct _jc_object *r2;
	struct _jc_gnu_java_security_x509_ext_Extension$object *r3;
	struct _jc_java_util_HashMap$object *r4;
	struct _jc_object *r5;
	struct _jc_java_lang_Object$object *r6;
	struct _jc_gnu_java_security_OID$object *r7;
	struct _jc_java_lang_String$object *r8;
	struct _jc_java_util_Collections__24UnmodifiableSet$object *r9;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(193);				// 0
	r1 = _JC_NEW(env, java_util_HashSet);
	r10 = _JC_NEW(env, java_util_HashMap);
	_JC_INVOKE_NONVIRTUAL(env, java_util_HashMap, _init$7cb044ce4fb0ada8, 0, r10, 11, _JC_FCONST(0x3f, 0x40, 0x0, 0x0));
	_JC_REF_FIELD(env, r1, java_util_HashSet, map) = r10;
	_JC_LINE_NUMBER(194);				// 1
	r4 = _JC_REF_FIELD(env, r0, gnu_java_security_x509_X509CRLEntry, extensions);
	r5 = _JC_INVOKE_VIRTUAL(env, java_util_HashMap, values$ff2f8ae502eccb46, r4);
	r2 = _JC_INVOKE_INTERFACE(env, r5, _JC_JLONG(0x3cc91493d50f531c), _jc_object *, (_jc_env *, struct _jc_object *));
	goto label1;

label0:
	_JC_LINE_NUMBER(196);				// 2
	r6 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0x5874f79a1cf66ea), _jc_object *, (_jc_env *, struct _jc_object *));
	r3 = _JC_CAST(env, &_jc_gnu_java_security_x509_ext_Extension$type, r6);
	_JC_LINE_NUMBER(197);				// 3
	z0 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_x509_ext_Extension, isCritical$26e138602d0c5362, r3);
	if (z0 != 0)
		goto label1;
	_JC_LINE_NUMBER(198);				// 4
	r7 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_x509_ext_Extension, getOid$2fbe8757f54d905b, r3);
	r8 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_OID, toString$7ea43b33b80a3070, r7);
	r12 = _JC_REF_FIELD(env, r1, java_util_HashSet, map);
	r11 = _JC_INVOKE_VIRTUAL(env, java_util_HashMap, put$3bd1c078a0faa8da, r12, r8, _JC_STRING(env, ""));
	if (r11 != _JC_NULL)
		goto label1;

label1:
	_JC_LINE_NUMBER(194);				// 5
	z0 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0xfb0bd5e38c59ddcd), jboolean, (_jc_env *, struct _jc_object *));
	if (z0 != 0) {
		_JC_PERIODIC_CHECK(env);
		goto label0;
	}
	_JC_ACTIVE_USE(env, java_util_Collections);
	r9 = _JC_NEW(env, java_util_Collections__24UnmodifiableSet);
	_JC_REF_FIELD(env, r9, java_util_Collections__24UnmodifiableCollection, c) = r1;
	if (r1 != _JC_NULL)
		goto label2;
	r13 = _JC_NEW(env, java_lang_NullPointerException);
	r14 = _JC_NULL;
	_JC_REF_FIELD(env, r13, java_lang_Throwable, cause) = r13;
	r16 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r13);
	_JC_REF_FIELD(env, r13, java_lang_Throwable, vmState) = r16;
	_JC_REF_FIELD(env, r13, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r13, java_lang_Throwable, detailMessage) = r14;
	_JC_THROW(env, r13);

label2:
	_JC_LINE_NUMBER(200);				// 6
	return r9;
}

//
// public java.util.Date getRevocationDate()
//

static _jc_linenum _jc_gnu_java_security_x509_X509CRLEntry$linenum_table$getRevocationDate$f4bc39251cfa4263[];

static const unsigned char _jc_gnu_java_security_x509_X509CRLEntry$param_ptypes$getRevocationDate$f4bc39251cfa4263[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_gnu_java_security_x509_X509CRLEntry$method_info$getRevocationDate$f4bc39251cfa4263 = {
	.name=			"getRevocationDate",
	.signature=		"()Ljava/util/Date;",
	.class=			&_jc_gnu_java_security_x509_X509CRLEntry$type,
	.return_type=		&_jc_java_util_Date$type,
	.param_ptypes=		&_jc_gnu_java_security_x509_X509CRLEntry$param_ptypes$getRevocationDate$f4bc39251cfa4263,
	.signature_hash=	_JC_JLONG(0xf4bc39251cfa4263),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_x509_X509CRLEntry$method$getRevocationDate$f4bc39251cfa4263,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_x509_X509CRLEntry$vtable, gnu_java_security_x509_X509CRLEntry.getRevocationDate$f4bc39251cfa4263) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_gnu_java_security_x509_X509CRLEntry$linenum_table$getRevocationDate$f4bc39251cfa4263
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_x509_X509CRLEntry, getRevocationDate$f4bc39251cfa4263);

_jc_java_util_Date$object * _JC_JCNI_ATTR
_jc_gnu_java_security_x509_X509CRLEntry$method$getRevocationDate$f4bc39251cfa4263(_jc_env *const env, _jc_gnu_java_security_x509_X509CRLEntry$object *this)
{
	struct _jc_gnu_java_security_x509_X509CRLEntry$object *r0;
	struct _jc_java_util_Date$object *r1;
	struct _jc_java_lang_Object$object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(151);				// 0
	r1 = _JC_REF_FIELD(env, r0, gnu_java_security_x509_X509CRLEntry, revocationDate);
	r2 = _JC_INVOKE_VIRTUAL(env, java_util_Date, clone$b75f2713d6705f70, r1);
	r1 = _JC_CAST(env, &_jc_java_util_Date$type, r2);
	return r1;
}

//
// public java.math.BigInteger getSerialNumber()
//

static _jc_linenum _jc_gnu_java_security_x509_X509CRLEntry$linenum_table$getSerialNumber$7e3dedaf516a1567[];

static const unsigned char _jc_gnu_java_security_x509_X509CRLEntry$param_ptypes$getSerialNumber$7e3dedaf516a1567[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_gnu_java_security_x509_X509CRLEntry$method_info$getSerialNumber$7e3dedaf516a1567 = {
	.name=			"getSerialNumber",
	.signature=		"()Ljava/math/BigInteger;",
	.class=			&_jc_gnu_java_security_x509_X509CRLEntry$type,
	.return_type=		&_jc_java_math_BigInteger$type,
	.param_ptypes=		&_jc_gnu_java_security_x509_X509CRLEntry$param_ptypes$getSerialNumber$7e3dedaf516a1567,
	.signature_hash=	_JC_JLONG(0x7e3dedaf516a1567),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_x509_X509CRLEntry$method$getSerialNumber$7e3dedaf516a1567,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_x509_X509CRLEntry$vtable, gnu_java_security_x509_X509CRLEntry.getSerialNumber$7e3dedaf516a1567) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_gnu_java_security_x509_X509CRLEntry$linenum_table$getSerialNumber$7e3dedaf516a1567
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_x509_X509CRLEntry, getSerialNumber$7e3dedaf516a1567);

_jc_java_math_BigInteger$object * _JC_JCNI_ATTR
_jc_gnu_java_security_x509_X509CRLEntry$method$getSerialNumber$7e3dedaf516a1567(_jc_env *const env, _jc_gnu_java_security_x509_X509CRLEntry$object *this)
{
	struct _jc_gnu_java_security_x509_X509CRLEntry$object *r0;
	struct _jc_java_math_BigInteger$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(146);				// 0
	r1 = _JC_REF_FIELD(env, r0, gnu_java_security_x509_X509CRLEntry, serialNo);
	return r1;
}

//
// public boolean hasExtensions()
//

static _jc_linenum _jc_gnu_java_security_x509_X509CRLEntry$linenum_table$hasExtensions$428c534df57e2d85[];

static const unsigned char _jc_gnu_java_security_x509_X509CRLEntry$param_ptypes$hasExtensions$428c534df57e2d85[] = { 
_JC_TYPE_BOOLEAN };

_jc_method _jc_gnu_java_security_x509_X509CRLEntry$method_info$hasExtensions$428c534df57e2d85 = {
	.name=			"hasExtensions",
	.signature=		"()Z",
	.class=			&_jc_gnu_java_security_x509_X509CRLEntry$type,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_x509_X509CRLEntry$param_ptypes$hasExtensions$428c534df57e2d85,
	.signature_hash=	_JC_JLONG(0x428c534df57e2d85),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_x509_X509CRLEntry$method$hasExtensions$428c534df57e2d85,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_x509_X509CRLEntry$vtable, gnu_java_security_x509_X509CRLEntry.hasExtensions$428c534df57e2d85) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_gnu_java_security_x509_X509CRLEntry$linenum_table$hasExtensions$428c534df57e2d85
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_x509_X509CRLEntry, hasExtensions$428c534df57e2d85);

jboolean _JC_JCNI_ATTR
_jc_gnu_java_security_x509_X509CRLEntry$method$hasExtensions$428c534df57e2d85(_jc_env *const env, _jc_gnu_java_security_x509_X509CRLEntry$object *this)
{
	struct _jc_gnu_java_security_x509_X509CRLEntry$object *r0;
	struct _jc_java_util_HashMap$object *r1;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(156);				// 0
	r1 = _JC_REF_FIELD(env, r0, gnu_java_security_x509_X509CRLEntry, extensions);
	z0 = _JC_INVOKE_VIRTUAL(env, java_util_HashMap, isEmpty$551bea84f4e0f0cb, r1);
	z0 = z0 ^ 1;
	return z0;
}

//
// public boolean hasUnsupportedCriticalExtension()
//

static _jc_linenum _jc_gnu_java_security_x509_X509CRLEntry$linenum_table$hasUnsupportedCriticalExtension$4a5b5363083e1e93[];

static const unsigned char _jc_gnu_java_security_x509_X509CRLEntry$param_ptypes$hasUnsupportedCriticalExtension$4a5b5363083e1e93[] = { 
_JC_TYPE_BOOLEAN };

_jc_method _jc_gnu_java_security_x509_X509CRLEntry$method_info$hasUnsupportedCriticalExtension$4a5b5363083e1e93 = {
	.name=			"hasUnsupportedCriticalExtension",
	.signature=		"()Z",
	.class=			&_jc_gnu_java_security_x509_X509CRLEntry$type,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_x509_X509CRLEntry$param_ptypes$hasUnsupportedCriticalExtension$4a5b5363083e1e93,
	.signature_hash=	_JC_JLONG(0x4a5b5363083e1e93),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_x509_X509CRLEntry$method$hasUnsupportedCriticalExtension$4a5b5363083e1e93,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_x509_X509CRLEntry$vtable, gnu_java_security_x509_X509CRLEntry.hasUnsupportedCriticalExtension$4a5b5363083e1e93) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	6,
	      .table=	_jc_gnu_java_security_x509_X509CRLEntry$linenum_table$hasUnsupportedCriticalExtension$4a5b5363083e1e93
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_x509_X509CRLEntry, hasUnsupportedCriticalExtension$4a5b5363083e1e93);

jboolean _JC_JCNI_ATTR
_jc_gnu_java_security_x509_X509CRLEntry$method$hasUnsupportedCriticalExtension$4a5b5363083e1e93(_jc_env *const env, _jc_gnu_java_security_x509_X509CRLEntry$object *this)
{
	struct _jc_gnu_java_security_x509_X509CRLEntry$object *r0;
	struct _jc_object *r1;
	struct _jc_gnu_java_security_x509_ext_Extension$object *r2;
	struct _jc_java_util_HashMap$object *r3;
	struct _jc_object *r4;
	struct _jc_java_lang_Object$object *r5;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(170);				// 0
	r3 = _JC_REF_FIELD(env, r0, gnu_java_security_x509_X509CRLEntry, extensions);
	r4 = _JC_INVOKE_VIRTUAL(env, java_util_HashMap, values$ff2f8ae502eccb46, r3);
	r1 = _JC_INVOKE_INTERFACE(env, r4, _JC_JLONG(0x3cc91493d50f531c), _jc_object *, (_jc_env *, struct _jc_object *));
	goto label1;

label0:
	_JC_LINE_NUMBER(172);				// 1
	r5 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0x5874f79a1cf66ea), _jc_object *, (_jc_env *, struct _jc_object *));
	r2 = _JC_CAST(env, &_jc_gnu_java_security_x509_ext_Extension$type, r5);
	_JC_LINE_NUMBER(173);				// 2
	z0 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_x509_ext_Extension, isCritical$26e138602d0c5362, r2);
	if (z0 == 0)
		goto label1;
	z0 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_x509_ext_Extension, isSupported$1b887f896243906d, r2);
	if (z0 != 0)
		goto label1;
	_JC_LINE_NUMBER(174);				// 3
	return 1;

label1:
	_JC_LINE_NUMBER(170);				// 4
	z0 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0xfb0bd5e38c59ddcd), jboolean, (_jc_env *, struct _jc_object *));
	if (z0 != 0) {
		_JC_PERIODIC_CHECK(env);
		goto label0;
	}
	_JC_LINE_NUMBER(176);				// 5
	return 0;
}

//
// public int hashCode()
//

static _jc_linenum _jc_gnu_java_security_x509_X509CRLEntry$linenum_table$hashCode$53152098849316df[];

static const unsigned char _jc_gnu_java_security_x509_X509CRLEntry$param_ptypes$hashCode$53152098849316df[] = { 
_JC_TYPE_INT };

_jc_method _jc_gnu_java_security_x509_X509CRLEntry$method_info$hashCode$53152098849316df = {
	.name=			"hashCode",
	.signature=		"()I",
	.class=			&_jc_gnu_java_security_x509_X509CRLEntry$type,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_x509_X509CRLEntry$param_ptypes$hashCode$53152098849316df,
	.signature_hash=	_JC_JLONG(0x53152098849316df),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_x509_X509CRLEntry$method$hashCode$53152098849316df,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_x509_X509CRLEntry$vtable, gnu_java_security_x509_X509CRLEntry.hashCode$53152098849316df) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_gnu_java_security_x509_X509CRLEntry$linenum_table$hashCode$53152098849316df
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_x509_X509CRLEntry, hashCode$53152098849316df);

jint _JC_JCNI_ATTR
_jc_gnu_java_security_x509_X509CRLEntry$method$hashCode$53152098849316df(_jc_env *const env, _jc_gnu_java_security_x509_X509CRLEntry$object *this)
{
	jint i0;
	struct _jc_gnu_java_security_x509_X509CRLEntry$object *r0;
	struct _jc_java_math_BigInteger$object *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(136);				// 0
	r1 = _JC_REF_FIELD(env, r0, gnu_java_security_x509_X509CRLEntry, serialNo);
	i0 = _JC_INVOKE_VIRTUAL(env, java_math_BigInteger, hashCode$53152098849316df, r1);
	return i0;
}

//
// private final void parse(int, gnu.java.security.der.DERReader) throws java.lang.Exception
//

static _jc_linenum _jc_gnu_java_security_x509_X509CRLEntry$linenum_table$parse$3548474769ac34dd[];

static const unsigned char _jc_gnu_java_security_x509_X509CRLEntry$param_ptypes$parse$3548474769ac34dd[] = { 
_JC_TYPE_INT, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_gnu_java_security_x509_X509CRLEntry$exceptions$parse$3548474769ac34dd[] = {
	&_jc_java_lang_Exception$type
};

static _jc_type *const _jc_gnu_java_security_x509_X509CRLEntry$param_types$parse$3548474769ac34dd[] = {
	&_jc_int$prim$type,
	&_jc_gnu_java_security_der_DERReader$type
};

_jc_method _jc_gnu_java_security_x509_X509CRLEntry$method_info$parse$3548474769ac34dd = {
	.name=			"parse",
	.signature=		"(ILgnu/java/security/der/DERReader;)V",
	.class=			&_jc_gnu_java_security_x509_X509CRLEntry$type,
	.param_types=		&_jc_gnu_java_security_x509_X509CRLEntry$param_types$parse$3548474769ac34dd,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_x509_X509CRLEntry$param_ptypes$parse$3548474769ac34dd,
	.signature_hash=	_JC_JLONG(0x3548474769ac34dd),
	.access_flags=		_JC_ACC_PRIVATE|_JC_ACC_FINAL,
	.function=		&_jc_gnu_java_security_x509_X509CRLEntry$method$parse$3548474769ac34dd,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_x509_X509CRLEntry$vtable, gnu_java_security_x509_X509CRLEntry.parse$3548474769ac34dd) / sizeof(void *),
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_gnu_java_security_x509_X509CRLEntry$exceptions$parse$3548474769ac34dd,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	34,
	      .table=	_jc_gnu_java_security_x509_X509CRLEntry$linenum_table$parse$3548474769ac34dd
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_x509_X509CRLEntry, parse$3548474769ac34dd);

void _JC_JCNI_ATTR
_jc_gnu_java_security_x509_X509CRLEntry$method$parse$3548474769ac34dd(_jc_env *const env, _jc_gnu_java_security_x509_X509CRLEntry$object *this, jint param0, _jc_gnu_java_security_der_DERReader$object *param1)
{
	jint i0;
	jint i1;
	jint i10;
	jint i2;
	jint i3;
	jint i4;
	jint i5;
	jint i6;
	jint i7;
	jint i8;
	jint i9;
	struct _jc_gnu_java_security_x509_X509CRLEntry$object *r0;
	struct _jc_gnu_java_security_der_DERReader$object *r1;
	struct _jc_java_util_Date$object *r10;
	struct _jc_java_util_HashMap$object *r11;
	struct _jc_java_lang_String$object *r12;
	struct _jc_java_lang_String$object *r13;
	struct _jc_java_lang_String$object *r14;
	struct _jc_java_lang_String$object *r15;
	struct _jc_gnu_java_security_OID$object *r16;
	struct _jc_java_lang_StringBuffer$object *r17;
	struct _jc_java_lang_String$object *r18;
	struct _jc_java_lang_String$object *r19;
	struct _jc_gnu_java_security_der_DERValue$object *r2;
	struct _jc_java_lang_String$object *r20;
	struct _jc_java_lang_String$object *r21;
	struct _jc_java_lang_StringBuffer$object *r22;
	struct _jc_java_lang_String$object *r23;
	struct _jc_java_lang_String$object *r24;
	struct _jc_java_lang_StringBuffer$object *r25;
	struct _jc_java_lang_String$object *r26;
	struct _jc_java_lang_String$object *r27;
	struct _jc_java_lang_StringBuffer$object *r28;
	struct _jc_java_lang_String$object *r29;
	struct _jc_gnu_java_security_der_DERValue$object *r3;
	struct _jc_java_lang_String$object *r30;
	struct _jc_java_lang_StringBuffer$object *r31;
	struct _jc_java_lang_String$object *r32;
	struct _jc_java_lang_String$object *r33;
	struct _jc_java_lang_StringBuffer$object *r34;
	struct _jc_java_lang_String$object *r35;
	struct _jc_java_lang_String$object *r36;
	struct _jc_java_lang_VMThrowable$object *r37;
	struct _jc_java_lang_VMThrowable$object *r38;
	struct _jc_java_lang_VMThrowable$object *r39;
	struct _jc_gnu_java_security_x509_ext_Extension$object *r4;
	struct _jc_java_lang_VMThrowable$object *r40;
	struct _jc_java_lang_StringBuffer$object *r41;
	struct _jc_java_lang_String$object *r42;
	struct _jc_java_lang_StringBuffer$object *r43;
	struct _jc_java_lang_String$object *r44;
	struct _jc_java_lang_String$object *r45;
	_jc_char_array *r46;
	struct _jc_java_lang_String$object *r47;
	_jc_char_array *r48;
	struct _jc_java_lang_String$object *r49;
	struct _jc_java_lang_StringBuffer$object *r5;
	_jc_char_array *r50;
	struct _jc_java_lang_String$object *r51;
	_jc_char_array *r52;
	struct _jc_java_lang_String$object *r53;
	_jc_char_array *r54;
	struct _jc_java_lang_String$object *r55;
	_jc_char_array *r56;
	struct _jc_java_lang_String$object *r57;
	_jc_char_array *r58;
	struct _jc_java_io_IOException$object *r6;
	_jc_byte_array *r7;
	struct _jc_java_lang_Object$object *r8;
	struct _jc_java_math_BigInteger$object *r9;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	i0 = param0;
	r1 = param1;
	_JC_LINE_NUMBER(232);				// 0
	r2 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_der_DERReader, read$97cabf4c92410204, r1);
	_JC_LINE_NUMBER(233);				// 1
	r5 = _JC_NEW(env, java_lang_StringBuffer);
	r45 = _JC_STRING(env, "start CRL entry   len == ");
	i4 = _JC_PRIM_FIELD(env, r45, java_lang_String, count);
	_JC_PRIM_FIELD(env, r5, java_lang_StringBuffer, count) = i4;
	i4 = _JC_PRIM_FIELD(env, r5, java_lang_StringBuffer, count);
	i4 = i4 + 16;
	r46 = _JC_NEW_PRIM_ARRAY(env, char, 1, i4);
	_JC_REF_FIELD(env, r5, java_lang_StringBuffer, value) = r46;
	i4 = _JC_PRIM_FIELD(env, r5, java_lang_StringBuffer, count);
	r46 = _JC_REF_FIELD(env, r5, java_lang_StringBuffer, value);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, getChars$c684dea7317ff063, 0, r45, 0, i4, r46, 0);
	i1 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_der_DERValue, getLength$b9eaa8ec0a00f23d, r2);
	r18 = _JC_INVOKE_STATIC(env, java_lang_Integer, toString$80d919d12afaaa2b, 0, i1, 10);
	r17 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r5, r18);
	_JC_EXPLICIT_NULL_CHECK(env, r17);
	r19 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r19, r17);
	_JC_LINE_NUMBER(234);				// 2
	z0 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_der_DERValue, isConstructed$a7f1dc7730ad5522, r2);
	if (z0 != 0)
		goto label0;
	_JC_LINE_NUMBER(235);				// 3
	r6 = _JC_NEW(env, java_io_IOException);
	r12 = _JC_STRING(env, "malformed revokedCertificate");
	_JC_REF_FIELD(env, r6, java_lang_Throwable, cause) = r6;
	r37 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r6);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, vmState) = r37;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, detailMessage) = r12;
	_JC_THROW(env, r6);

label0:
	_JC_LINE_NUMBER(236);				// 4
	r7 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_der_DERValue, getEncoded$eaf136136217eb89, r2);
	_JC_REF_FIELD(env, r0, gnu_java_security_x509_X509CRLEntry, encoded) = r7;
	_JC_LINE_NUMBER(239);				// 5
	r5 = _JC_NEW(env, java_lang_StringBuffer);
	r47 = _JC_STRING(env, "encoded entry:\n");
	i5 = _JC_PRIM_FIELD(env, r47, java_lang_String, count);
	_JC_PRIM_FIELD(env, r5, java_lang_StringBuffer, count) = i5;
	i5 = _JC_PRIM_FIELD(env, r5, java_lang_StringBuffer, count);
	i5 = i5 + 16;
	r48 = _JC_NEW_PRIM_ARRAY(env, char, 1, i5);
	_JC_REF_FIELD(env, r5, java_lang_StringBuffer, value) = r48;
	i5 = _JC_PRIM_FIELD(env, r5, java_lang_StringBuffer, count);
	r48 = _JC_REF_FIELD(env, r5, java_lang_StringBuffer, value);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, getChars$c684dea7317ff063, 0, r47, 0, i5, r48, 0);
	r7 = _JC_REF_FIELD(env, r0, gnu_java_security_x509_X509CRLEntry, encoded);
	_JC_ACTIVE_USE(env, gnu_java_security_x509_Util);
	r20 = _JC_STRING(env, ">>>> ");
	i3 = _JC_ARRAY_LENGTH(env, r7);
	r20 = _JC_INVOKE_STATIC(env, gnu_java_security_x509_Util, hexDump$b0dd77499e8b0197, 1, r7, 0, i3, r20);
	r5 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r5, r20);
	r21 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r21, r5);
	_JC_LINE_NUMBER(242);				// 6
	r3 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_der_DERReader, read$97cabf4c92410204, r1);
	_JC_LINE_NUMBER(243);				// 7
	r8 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_der_DERValue, getValue$6f8b281a5ffcc94f, r3);
	r9 = _JC_CAST(env, &_jc_java_math_BigInteger$type, r8);
	_JC_REF_FIELD(env, r0, gnu_java_security_x509_X509CRLEntry, serialNo) = r9;
	_JC_LINE_NUMBER(244);				// 8
	i2 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_der_DERValue, getEncodedLength$20de9dca5414bd6a, r3);
	i2 = 0 + i2;
	_JC_LINE_NUMBER(245);				// 9
	r5 = _JC_NEW(env, java_lang_StringBuffer);
	r49 = _JC_STRING(env, "userCertificate == ");
	i6 = _JC_PRIM_FIELD(env, r49, java_lang_String, count);
	_JC_PRIM_FIELD(env, r5, java_lang_StringBuffer, count) = i6;
	i6 = _JC_PRIM_FIELD(env, r5, java_lang_StringBuffer, count);
	i6 = i6 + 16;
	r50 = _JC_NEW_PRIM_ARRAY(env, char, 1, i6);
	_JC_REF_FIELD(env, r5, java_lang_StringBuffer, value) = r50;
	i6 = _JC_PRIM_FIELD(env, r5, java_lang_StringBuffer, count);
	r50 = _JC_REF_FIELD(env, r5, java_lang_StringBuffer, value);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, getChars$c684dea7317ff063, 0, r49, 0, i6, r50, 0);
	r9 = _JC_REF_FIELD(env, r0, gnu_java_security_x509_X509CRLEntry, serialNo);
	r41 = r5;
	if (r9 != _JC_NULL)
		goto label1;
	r42 = _JC_STRING(env, "null");
	goto label2;

label1:
	r42 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, toString$7ea43b33b80a3070, r9);

label2:
	r41 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r41, r42);
	r5 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r41, _JC_STRING(env, "  current count == "));
	_JC_EXPLICIT_NULL_CHECK(env, r5);
	r23 = _JC_INVOKE_STATIC(env, java_lang_Integer, toString$80d919d12afaaa2b, 1, i2, 10);
	r22 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r5, r23);
	_JC_EXPLICIT_NULL_CHECK(env, r22);
	r24 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r24, r22);
	_JC_LINE_NUMBER(248);				// 10
	r3 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_der_DERReader, read$97cabf4c92410204, r1);
	_JC_LINE_NUMBER(249);				// 11
	r8 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_der_DERValue, getValue$6f8b281a5ffcc94f, r3);
	r10 = _JC_CAST(env, &_jc_java_util_Date$type, r8);
	_JC_REF_FIELD(env, r0, gnu_java_security_x509_X509CRLEntry, revocationDate) = r10;
	_JC_LINE_NUMBER(250);				// 12
	i1 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_der_DERValue, getEncodedLength$20de9dca5414bd6a, r3);
	i2 = i2 + i1;
	_JC_LINE_NUMBER(251);				// 13
	r5 = _JC_NEW(env, java_lang_StringBuffer);
	r51 = _JC_STRING(env, "revocationDate == ");
	i7 = _JC_PRIM_FIELD(env, r51, java_lang_String, count);
	_JC_PRIM_FIELD(env, r5, java_lang_StringBuffer, count) = i7;
	i7 = _JC_PRIM_FIELD(env, r5, java_lang_StringBuffer, count);
	i7 = i7 + 16;
	r52 = _JC_NEW_PRIM_ARRAY(env, char, 1, i7);
	_JC_REF_FIELD(env, r5, java_lang_StringBuffer, value) = r52;
	i7 = _JC_PRIM_FIELD(env, r5, java_lang_StringBuffer, count);
	r52 = _JC_REF_FIELD(env, r5, java_lang_StringBuffer, value);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, getChars$c684dea7317ff063, 0, r51, 0, i7, r52, 0);
	r10 = _JC_REF_FIELD(env, r0, gnu_java_security_x509_X509CRLEntry, revocationDate);
	r43 = r5;
	if (r10 != _JC_NULL)
		goto label3;
	r44 = _JC_STRING(env, "null");
	goto label4;

label3:
	r44 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, toString$7ea43b33b80a3070, r10);

label4:
	r43 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r43, r44);
	r5 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r43, _JC_STRING(env, "  current count == "));
	_JC_EXPLICIT_NULL_CHECK(env, r5);
	r26 = _JC_INVOKE_STATIC(env, java_lang_Integer, toString$80d919d12afaaa2b, 1, i2, 10);
	r25 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r5, r26);
	_JC_EXPLICIT_NULL_CHECK(env, r25);
	r27 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r27, r25);
	_JC_LINE_NUMBER(255);				// 14
	i1 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_der_DERValue, getLength$b9eaa8ec0a00f23d, r2);
	if (i2 >= i1)
		goto label10;
	_JC_LINE_NUMBER(257);				// 15
	if (i0 >= 2)
		goto label5;
	_JC_LINE_NUMBER(258);				// 16
	r6 = _JC_NEW(env, java_io_IOException);
	r13 = _JC_STRING(env, "extra data in CRL entry");
	_JC_REF_FIELD(env, r6, java_lang_Throwable, cause) = r6;
	r38 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r6);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, vmState) = r38;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, detailMessage) = r13;
	_JC_THROW(env, r6);

label5:
	_JC_LINE_NUMBER(259);				// 17
	r3 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_der_DERReader, read$97cabf4c92410204, r1);
	_JC_LINE_NUMBER(260);				// 18
	z0 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_der_DERValue, isConstructed$a7f1dc7730ad5522, r3);
	if (z0 != 0)
		goto label6;
	_JC_LINE_NUMBER(261);				// 19
	r6 = _JC_NEW(env, java_io_IOException);
	r14 = _JC_STRING(env, "malformed Extensions");
	_JC_REF_FIELD(env, r6, java_lang_Throwable, cause) = r6;
	r39 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r6);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, vmState) = r39;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, detailMessage) = r14;
	_JC_THROW(env, r6);

label6:
	_JC_LINE_NUMBER(262);				// 20
	r5 = _JC_NEW(env, java_lang_StringBuffer);
	r53 = _JC_STRING(env, "start Extensions  len == ");
	i8 = _JC_PRIM_FIELD(env, r53, java_lang_String, count);
	_JC_PRIM_FIELD(env, r5, java_lang_StringBuffer, count) = i8;
	i8 = _JC_PRIM_FIELD(env, r5, java_lang_StringBuffer, count);
	i8 = i8 + 16;
	r54 = _JC_NEW_PRIM_ARRAY(env, char, 1, i8);
	_JC_REF_FIELD(env, r5, java_lang_StringBuffer, value) = r54;
	i8 = _JC_PRIM_FIELD(env, r5, java_lang_StringBuffer, count);
	r54 = _JC_REF_FIELD(env, r5, java_lang_StringBuffer, value);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, getChars$c684dea7317ff063, 0, r53, 0, i8, r54, 0);
	i2 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_der_DERValue, getLength$b9eaa8ec0a00f23d, r3);
	r29 = _JC_INVOKE_STATIC(env, java_lang_Integer, toString$80d919d12afaaa2b, 1, i2, 10);
	r28 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r5, r29);
	_JC_EXPLICIT_NULL_CHECK(env, r28);
	r30 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r30, r28);
	_JC_LINE_NUMBER(263);				// 21
	i2 = 0;
	_JC_LINE_NUMBER(264);				// 22
	goto label9;

label7:
	_JC_LINE_NUMBER(266);				// 23
	r2 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_der_DERReader, read$97cabf4c92410204, r1);
	_JC_LINE_NUMBER(267);				// 24
	z0 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_der_DERValue, isConstructed$a7f1dc7730ad5522, r2);
	if (z0 != 0)
		goto label8;
	_JC_LINE_NUMBER(268);				// 25
	r6 = _JC_NEW(env, java_io_IOException);
	r15 = _JC_STRING(env, "malformed Extension");
	_JC_REF_FIELD(env, r6, java_lang_Throwable, cause) = r6;
	r40 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r6);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, vmState) = r40;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, detailMessage) = r15;
	_JC_THROW(env, r6);

label8:
	_JC_LINE_NUMBER(269);				// 26
	r5 = _JC_NEW(env, java_lang_StringBuffer);
	r55 = _JC_STRING(env, "start Extension  len == ");
	i9 = _JC_PRIM_FIELD(env, r55, java_lang_String, count);
	_JC_PRIM_FIELD(env, r5, java_lang_StringBuffer, count) = i9;
	i9 = _JC_PRIM_FIELD(env, r5, java_lang_StringBuffer, count);
	i9 = i9 + 16;
	r56 = _JC_NEW_PRIM_ARRAY(env, char, 1, i9);
	_JC_REF_FIELD(env, r5, java_lang_StringBuffer, value) = r56;
	i9 = _JC_PRIM_FIELD(env, r5, java_lang_StringBuffer, count);
	r56 = _JC_REF_FIELD(env, r5, java_lang_StringBuffer, value);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, getChars$c684dea7317ff063, 0, r55, 0, i9, r56, 0);
	i1 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_der_DERValue, getLength$b9eaa8ec0a00f23d, r2);
	r32 = _JC_INVOKE_STATIC(env, java_lang_Integer, toString$80d919d12afaaa2b, 1, i1, 10);
	r31 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r5, r32);
	_JC_EXPLICIT_NULL_CHECK(env, r31);
	r33 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r33, r31);
	_JC_LINE_NUMBER(270);				// 27
	r4 = _JC_NEW(env, gnu_java_security_x509_ext_Extension);
	r7 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_der_DERValue, getEncoded$eaf136136217eb89, r2);
	_JC_INVOKE_NONVIRTUAL(env, gnu_java_security_x509_ext_Extension, _init$aaa7e255fe505158, 0, r4, r7);
	_JC_LINE_NUMBER(271);				// 28
	r11 = _JC_REF_FIELD(env, r0, gnu_java_security_x509_X509CRLEntry, extensions);
	r16 = _JC_REF_FIELD(env, r4, gnu_java_security_x509_ext_Extension, oid);
	_JC_INVOKE_VIRTUAL(env, java_util_HashMap, put$3bd1c078a0faa8da, r11, r16, r4);
	_JC_LINE_NUMBER(272);				// 29
	i1 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_der_DERValue, getLength$b9eaa8ec0a00f23d, r2);
	_JC_INVOKE_VIRTUAL(env, gnu_java_security_der_DERReader, skip$7ea465b394c979ed, r1, i1);
	_JC_LINE_NUMBER(273);				// 30
	i1 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_der_DERValue, getEncodedLength$20de9dca5414bd6a, r2);
	i2 = i2 + i1;
	_JC_LINE_NUMBER(274);				// 31
	r5 = _JC_NEW(env, java_lang_StringBuffer);
	r57 = _JC_STRING(env, "current count == ");
	i10 = _JC_PRIM_FIELD(env, r57, java_lang_String, count);
	_JC_PRIM_FIELD(env, r5, java_lang_StringBuffer, count) = i10;
	i10 = _JC_PRIM_FIELD(env, r5, java_lang_StringBuffer, count);
	i10 = i10 + 16;
	r58 = _JC_NEW_PRIM_ARRAY(env, char, 1, i10);
	_JC_REF_FIELD(env, r5, java_lang_StringBuffer, value) = r58;
	i10 = _JC_PRIM_FIELD(env, r5, java_lang_StringBuffer, count);
	r58 = _JC_REF_FIELD(env, r5, java_lang_StringBuffer, value);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, getChars$c684dea7317ff063, 0, r57, 0, i10, r58, 0);
	r35 = _JC_INVOKE_STATIC(env, java_lang_Integer, toString$80d919d12afaaa2b, 1, i2, 10);
	r34 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r5, r35);
	_JC_EXPLICIT_NULL_CHECK(env, r34);
	r36 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r36, r34);

label9:
	_JC_LINE_NUMBER(264);				// 32
	i1 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_der_DERValue, getLength$b9eaa8ec0a00f23d, r3);
	if (i2 < i1) {
		_JC_PERIODIC_CHECK(env);
		goto label7;
	}

label10:
	_JC_LINE_NUMBER(277);				// 33
	return;
}

//
// public java.lang.String toString()
//

static _jc_linenum _jc_gnu_java_security_x509_X509CRLEntry$linenum_table$toString$7ea43b33b80a3070[];

static const unsigned char _jc_gnu_java_security_x509_X509CRLEntry$param_ptypes$toString$7ea43b33b80a3070[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_gnu_java_security_x509_X509CRLEntry$method_info$toString$7ea43b33b80a3070 = {
	.name=			"toString",
	.signature=		"()Ljava/lang/String;",
	.class=			&_jc_gnu_java_security_x509_X509CRLEntry$type,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_gnu_java_security_x509_X509CRLEntry$param_ptypes$toString$7ea43b33b80a3070,
	.signature_hash=	_JC_JLONG(0x7ea43b33b80a3070),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_x509_X509CRLEntry$method$toString$7ea43b33b80a3070,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_x509_X509CRLEntry$vtable, gnu_java_security_x509_X509CRLEntry.toString$7ea43b33b80a3070) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_gnu_java_security_x509_X509CRLEntry$linenum_table$toString$7ea43b33b80a3070
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_x509_X509CRLEntry, toString$7ea43b33b80a3070);

_jc_java_lang_String$object * _JC_JCNI_ATTR
_jc_gnu_java_security_x509_X509CRLEntry$method$toString$7ea43b33b80a3070(_jc_env *const env, _jc_gnu_java_security_x509_X509CRLEntry$object *this)
{
	struct _jc_gnu_java_security_x509_X509CRLEntry$object *r0;
	struct _jc_java_lang_StringBuffer$object *r1;
	struct _jc_java_lang_String$object *r10;
	struct _jc_java_math_BigInteger$object *r2;
	struct _jc_java_util_Date$object *r3;
	struct _jc_java_util_HashMap$object *r4;
	struct _jc_java_lang_String$object *r5;
	struct _jc_java_lang_StringBuffer$object *r6;
	struct _jc_java_lang_String$object *r7;
	struct _jc_java_lang_StringBuffer$object *r8;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(161);				// 0
	r1 = _JC_NEW(env, java_lang_StringBuffer);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, _init$c31b894660454d13, 0, r1, _JC_STRING(env, "X509CRLEntry serial="));
	r2 = _JC_REF_FIELD(env, r0, gnu_java_security_x509_X509CRLEntry, serialNo);
	r6 = r1;
	if (r2 != _JC_NULL)
		goto label0;
	r7 = _JC_STRING(env, "null");
	goto label1;

label0:
	r7 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, toString$7ea43b33b80a3070, r2);

label1:
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r6, r7);
	r1 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r6, _JC_STRING(env, " revocation date="));
	r3 = _JC_REF_FIELD(env, r0, gnu_java_security_x509_X509CRLEntry, revocationDate);
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	r8 = r1;
	if (r3 != _JC_NULL)
		goto label2;
	r10 = _JC_STRING(env, "null");
	goto label3;

label2:
	r10 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, toString$7ea43b33b80a3070, r3);

label3:
	r8 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r8, r10);
	r1 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r8, _JC_STRING(env, " ext="));
	r4 = _JC_REF_FIELD(env, r0, gnu_java_security_x509_X509CRLEntry, extensions);
	r1 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$aa87b40433722847, 1, r1, r4);
	r5 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r5, r1);
	return r5;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_gnu_java_security_x509_X509CRLEntry$methods[] = {
	&_jc_gnu_java_security_x509_X509CRLEntry$method_info$_init$218eaec10c312d80,
	&_jc_gnu_java_security_x509_X509CRLEntry$method_info$debug$1e3312c3736b0b51,
	&_jc_gnu_java_security_x509_X509CRLEntry$method_info$equals$8a15e0625571c581,
	&_jc_gnu_java_security_x509_X509CRLEntry$method_info$getCriticalExtensionOIDs$13bd73a925085701,
	&_jc_gnu_java_security_x509_X509CRLEntry$method_info$getEncoded$eaf136136217eb89,
	&_jc_gnu_java_security_x509_X509CRLEntry$method_info$getExtension$5d05f6c6eab904e4,
	&_jc_gnu_java_security_x509_X509CRLEntry$method_info$getExtensionValue$4dd9512bdab291e0,
	&_jc_gnu_java_security_x509_X509CRLEntry$method_info$getExtensions$e635946d32343834,
	&_jc_gnu_java_security_x509_X509CRLEntry$method_info$getNonCriticalExtensionOIDs$eb792be2fbd03dd4,
	&_jc_gnu_java_security_x509_X509CRLEntry$method_info$getRevocationDate$f4bc39251cfa4263,
	&_jc_gnu_java_security_x509_X509CRLEntry$method_info$getSerialNumber$7e3dedaf516a1567,
	&_jc_gnu_java_security_x509_X509CRLEntry$method_info$hasExtensions$428c534df57e2d85,
	&_jc_gnu_java_security_x509_X509CRLEntry$method_info$hasUnsupportedCriticalExtension$4a5b5363083e1e93,
	&_jc_gnu_java_security_x509_X509CRLEntry$method_info$hashCode$53152098849316df,
	&_jc_gnu_java_security_x509_X509CRLEntry$method_info$parse$3548474769ac34dd,
	&_jc_gnu_java_security_x509_X509CRLEntry$method_info$toString$7ea43b33b80a3070
};

/************************************************************************
 *			  Class fields structure			*
 ************************************************************************/

_jc_gnu_java_security_x509_X509CRLEntry$fields_struct _jc_gnu_java_security_x509_X509CRLEntry$class_fields = { };

/************************************************************************
 *			      Interface list				*
 ************************************************************************/

// Directly implemented interfaces
static _jc_type *const _jc_gnu_java_security_x509_X509CRLEntry$interfaces[] = {
	&_jc_gnu_java_security_x509_GnuPKIExtension$type
};

/************************************************************************
 *			   Interface hash table				*
 ************************************************************************/

#if _JC_IMETHOD_HASHSIZE != 128
#error "_JC_IMETHOD_HASHSIZE has the wrong value (should be 128)"
#endif

// Interface lookup hash table buckets
static _jc_method *_jc_gnu_java_security_x509_X509CRLEntry$imethod_hash_bucket_1[] = {
	&_jc_gnu_java_security_x509_X509CRLEntry$method_info$getCriticalExtensionOIDs$13bd73a925085701,
	_JC_NULL
};
static _jc_method *_jc_gnu_java_security_x509_X509CRLEntry$imethod_hash_bucket_19[] = {
	&_jc_gnu_java_security_x509_X509CRLEntry$method_info$hasUnsupportedCriticalExtension$4a5b5363083e1e93,
	_JC_NULL
};
static _jc_method *_jc_gnu_java_security_x509_X509CRLEntry$imethod_hash_bucket_52[] = {
	&_jc_gnu_java_security_x509_X509CRLEntry$method_info$getExtensions$e635946d32343834,
	_JC_NULL
};
static _jc_method *_jc_gnu_java_security_x509_X509CRLEntry$imethod_hash_bucket_84[] = {
	&_jc_gnu_java_security_x509_X509CRLEntry$method_info$getNonCriticalExtensionOIDs$eb792be2fbd03dd4,
	_JC_NULL
};
static _jc_method *_jc_gnu_java_security_x509_X509CRLEntry$imethod_hash_bucket_96[] = {
	&_jc_gnu_java_security_x509_X509CRLEntry$method_info$getExtensionValue$4dd9512bdab291e0,
	_JC_NULL
};
static _jc_method *_jc_gnu_java_security_x509_X509CRLEntry$imethod_hash_bucket_100[] = {
	&_jc_gnu_java_security_x509_X509CRLEntry$method_info$getExtension$5d05f6c6eab904e4,
	_JC_NULL
};

// Interface lookup hash table
static _jc_method **_jc_gnu_java_security_x509_X509CRLEntry$imethod_hash_table[_JC_IMETHOD_HASHSIZE] = {
	[1]=	_jc_gnu_java_security_x509_X509CRLEntry$imethod_hash_bucket_1,
	[19]=	_jc_gnu_java_security_x509_X509CRLEntry$imethod_hash_bucket_19,
	[52]=	_jc_gnu_java_security_x509_X509CRLEntry$imethod_hash_bucket_52,
	[84]=	_jc_gnu_java_security_x509_X509CRLEntry$imethod_hash_bucket_84,
	[96]=	_jc_gnu_java_security_x509_X509CRLEntry$imethod_hash_bucket_96,
	[100]=	_jc_gnu_java_security_x509_X509CRLEntry$imethod_hash_bucket_100
};

// Interface "quick" lookup hash table
static const void *_jc_gnu_java_security_x509_X509CRLEntry$imethod_quick_table[_JC_IMETHOD_HASHSIZE] = {
	[1]=	&_jc_gnu_java_security_x509_X509CRLEntry$method$getCriticalExtensionOIDs$13bd73a925085701,
	[19]=	&_jc_gnu_java_security_x509_X509CRLEntry$method$hasUnsupportedCriticalExtension$4a5b5363083e1e93,
	[52]=	&_jc_gnu_java_security_x509_X509CRLEntry$method$getExtensions$e635946d32343834,
	[84]=	&_jc_gnu_java_security_x509_X509CRLEntry$method$getNonCriticalExtensionOIDs$eb792be2fbd03dd4,
	[96]=	&_jc_gnu_java_security_x509_X509CRLEntry$method$getExtensionValue$4dd9512bdab291e0,
	[100]=	&_jc_gnu_java_security_x509_X509CRLEntry$method$getExtension$5d05f6c6eab904e4
};

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_gnu_java_security_x509_X509CRLEntry$instanceof_hash_bucket_26[] = {
	&_jc_java_security_cert_X509CRLEntry$type,
	_JC_NULL
};
static _jc_type *const _jc_gnu_java_security_x509_X509CRLEntry$instanceof_hash_bucket_84[] = {
	&_jc_java_security_cert_X509Extension$type,
	_JC_NULL
};
static _jc_type *const _jc_gnu_java_security_x509_X509CRLEntry$instanceof_hash_bucket_90[] = {
	&_jc_gnu_java_security_x509_GnuPKIExtension$type,
	_JC_NULL
};
static _jc_type *const _jc_gnu_java_security_x509_X509CRLEntry$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};
static _jc_type *const _jc_gnu_java_security_x509_X509CRLEntry$instanceof_hash_bucket_116[] = {
	&_jc_gnu_java_security_x509_X509CRLEntry$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_gnu_java_security_x509_X509CRLEntry$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[26]=	_jc_gnu_java_security_x509_X509CRLEntry$instanceof_hash_bucket_26,
	[84]=	_jc_gnu_java_security_x509_X509CRLEntry$instanceof_hash_bucket_84,
	[90]=	_jc_gnu_java_security_x509_X509CRLEntry$instanceof_hash_bucket_90,
	[101]=	_jc_gnu_java_security_x509_X509CRLEntry$instanceof_hash_bucket_101,
	[116]=	_jc_gnu_java_security_x509_X509CRLEntry$instanceof_hash_bucket_116
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_gnu_java_security_x509_X509CRLEntry$class_depends[] = {
	{ "gnu/java/security/OID",	_JC_JLONG(0xd963c5e3d173e044) },
	{ "gnu/java/security/der/DERReader",	_JC_JLONG(0x78ef52e48159b870) },
	{ "gnu/java/security/der/DERValue",	_JC_JLONG(0xde1638783317796a) },
	{ "gnu/java/security/x509/GnuPKIExtension",	_JC_JLONG(0x4f2d14e7cd25c35a) },
	{ "gnu/java/security/x509/Util",	_JC_JLONG(0x70edc74efc8796dc) },
	{ "gnu/java/security/x509/ext/Extension",	_JC_JLONG(0x9d0b785a9feab044) },
	{ "gnu/java/security/x509/ext/Extension$Value",	_JC_JLONG(0x317dae12883b24de) },
	{ "java/io/IOException",	_JC_JLONG(0x4e0a56550c69d57c) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/Integer",	_JC_JLONG(0xca631501391a31f1) },
	{ "java/lang/NullPointerException",	_JC_JLONG(0x505b8a9a6675be0) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/RuntimeException",	_JC_JLONG(0x4f5534a987354d1d) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/StringBuffer",	_JC_JLONG(0x94d357637b968dda) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/math/BigInteger",	_JC_JLONG(0x7717ded55c30b7f3) },
	{ "java/security/GeneralSecurityException",	_JC_JLONG(0x692089051f4c8d0b) },
	{ "java/security/cert/CRLException",	_JC_JLONG(0x19d465acf62ede69) },
	{ "java/security/cert/X509CRLEntry",	_JC_JLONG(0x4aa1aa15aadaef9a) },
	{ "java/security/cert/X509Extension",	_JC_JLONG(0x823d6f250a58dc54) },
	{ "java/util/AbstractCollection",	_JC_JLONG(0x8ea716c64b77f8eb) },
	{ "java/util/AbstractSet",	_JC_JLONG(0xca427569b5b2f804) },
	{ "java/util/Collection",	_JC_JLONG(0xeae4d0c0e8eb63da) },
	{ "java/util/Collections",	_JC_JLONG(0x9574af3fed58029a) },
	{ "java/util/Collections$UnmodifiableCollection",	_JC_JLONG(0x2126b28aee607999) },
	{ "java/util/Collections$UnmodifiableSet",	_JC_JLONG(0xaec2ea3fc69f0e47) },
	{ "java/util/Date",	_JC_JLONG(0xa85d2a51094e614c) },
	{ "java/util/HashMap",	_JC_JLONG(0xd7cd853200c3e71f) },
	{ "java/util/HashSet",	_JC_JLONG(0x3c285c721478414d) },
	{ "java/util/Iterator",	_JC_JLONG(0xbe56ff673eefd9d2) },
	{ "java/util/Set",	_JC_JLONG(0x617ac82c0bec2dff) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_gnu_java_security_x509_X509CRLEntry$vtype _jc_gnu_java_security_x509_X509CRLEntry$type = {
    .type= {
	.name=			"gnu/java/security/x509/X509CRLEntry",
	.superclass=		&_jc_java_security_cert_X509CRLEntry$type,
	.access_flags=		0,
	.flags=			_JC_TYPE_REFERENCE,
	.num_interfaces=sizeof(_jc_gnu_java_security_x509_X509CRLEntry$interfaces) / sizeof(*_jc_gnu_java_security_x509_X509CRLEntry$interfaces),
	.interfaces=		_jc_gnu_java_security_x509_X509CRLEntry$interfaces,
	.imethod_hash_table=	_jc_gnu_java_security_x509_X509CRLEntry$imethod_hash_table,
	.imethod_quick_table=	_jc_gnu_java_security_x509_X509CRLEntry$imethod_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		32,
		.hash=			_JC_JLONG(0x2271ec1778434574),
		.source_file=		"X509CRLEntry.java",
		.instance_size=		sizeof(_jc_gnu_java_security_x509_X509CRLEntry$refs) + sizeof(_jc_gnu_java_security_x509_X509CRLEntry$object),
		.num_virtual_refs=	4,
		.num_fields=		sizeof(_jc_gnu_java_security_x509_X509CRLEntry$fields) / sizeof(*_jc_gnu_java_security_x509_X509CRLEntry$fields),
		.fields=		_jc_gnu_java_security_x509_X509CRLEntry$fields,
		.num_methods=		sizeof(_jc_gnu_java_security_x509_X509CRLEntry$methods) / sizeof(*_jc_gnu_java_security_x509_X509CRLEntry$methods),
		.methods=		_jc_gnu_java_security_x509_X509CRLEntry$methods,
		.instanceof_hash_table=	_jc_gnu_java_security_x509_X509CRLEntry$instanceof_hash_table,
		.class_fields=		&_jc_gnu_java_security_x509_X509CRLEntry$class_fields,
		.num_class_depends=		sizeof(_jc_gnu_java_security_x509_X509CRLEntry$class_depends) / sizeof(*_jc_gnu_java_security_x509_X509CRLEntry$class_depends),
		.class_depends=		_jc_gnu_java_security_x509_X509CRLEntry$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=			// overridden
		&_jc_gnu_java_security_x509_X509CRLEntry$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=			// overridden
		&_jc_gnu_java_security_x509_X509CRLEntry$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=			// overridden
		&_jc_gnu_java_security_x509_X509CRLEntry$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.java_security_cert_X509CRLEntry= {
	    .equals$8a15e0625571c581=			// overridden
		&_jc_gnu_java_security_x509_X509CRLEntry$method$equals$8a15e0625571c581,
	    .getEncoded$eaf136136217eb89=			// overridden
		&_jc_gnu_java_security_x509_X509CRLEntry$method$getEncoded$eaf136136217eb89,
	    .getRevocationDate$f4bc39251cfa4263=		// overridden
		&_jc_gnu_java_security_x509_X509CRLEntry$method$getRevocationDate$f4bc39251cfa4263,
	    .getSerialNumber$7e3dedaf516a1567=		// overridden
		&_jc_gnu_java_security_x509_X509CRLEntry$method$getSerialNumber$7e3dedaf516a1567,
	    .hasExtensions$428c534df57e2d85=		// overridden
		&_jc_gnu_java_security_x509_X509CRLEntry$method$hasExtensions$428c534df57e2d85,
	    .hashCode$53152098849316df=			// overridden
		&_jc_gnu_java_security_x509_X509CRLEntry$method$hashCode$53152098849316df,
	    .toString$7ea43b33b80a3070=			// overridden
		&_jc_gnu_java_security_x509_X509CRLEntry$method$toString$7ea43b33b80a3070,
	},
	.gnu_java_security_x509_X509CRLEntry= {
	    .equals$8a15e0625571c581=
		&_jc_gnu_java_security_x509_X509CRLEntry$method$equals$8a15e0625571c581,
	    .getCriticalExtensionOIDs$13bd73a925085701=
		&_jc_gnu_java_security_x509_X509CRLEntry$method$getCriticalExtensionOIDs$13bd73a925085701,
	    .getEncoded$eaf136136217eb89=
		&_jc_gnu_java_security_x509_X509CRLEntry$method$getEncoded$eaf136136217eb89,
	    .getExtension$5d05f6c6eab904e4=
		&_jc_gnu_java_security_x509_X509CRLEntry$method$getExtension$5d05f6c6eab904e4,
	    .getExtensionValue$4dd9512bdab291e0=
		&_jc_gnu_java_security_x509_X509CRLEntry$method$getExtensionValue$4dd9512bdab291e0,
	    .getExtensions$e635946d32343834=
		&_jc_gnu_java_security_x509_X509CRLEntry$method$getExtensions$e635946d32343834,
	    .getNonCriticalExtensionOIDs$eb792be2fbd03dd4=
		&_jc_gnu_java_security_x509_X509CRLEntry$method$getNonCriticalExtensionOIDs$eb792be2fbd03dd4,
	    .getRevocationDate$f4bc39251cfa4263=
		&_jc_gnu_java_security_x509_X509CRLEntry$method$getRevocationDate$f4bc39251cfa4263,
	    .getSerialNumber$7e3dedaf516a1567=
		&_jc_gnu_java_security_x509_X509CRLEntry$method$getSerialNumber$7e3dedaf516a1567,
	    .hasExtensions$428c534df57e2d85=
		&_jc_gnu_java_security_x509_X509CRLEntry$method$hasExtensions$428c534df57e2d85,
	    .hasUnsupportedCriticalExtension$4a5b5363083e1e93=
		&_jc_gnu_java_security_x509_X509CRLEntry$method$hasUnsupportedCriticalExtension$4a5b5363083e1e93,
	    .hashCode$53152098849316df=
		&_jc_gnu_java_security_x509_X509CRLEntry$method$hashCode$53152098849316df,
	    .parse$3548474769ac34dd=
		&_jc_gnu_java_security_x509_X509CRLEntry$method$parse$3548474769ac34dd,
	    .toString$7ea43b33b80a3070=
		&_jc_gnu_java_security_x509_X509CRLEntry$method$toString$7ea43b33b80a3070,
	},
    }
};

