// public class java.io.InputStreamReader

// class file dependencies
// @dep_class 1160ded3f016b6b0 gnu_classpath_SystemProperties
// @dep_class ba039f692ab519ba gnu_java_nio_charset_EncodingHelper
// @dep_class 4e0a56550c69d57c java_io_IOException
// @dep_class 66aea4d152614ac4 java_io_InputStream
// @dep_class 30159d8092563292 java_io_InputStreamReader
// @dep_class 688afb20bd4c4e01 java_io_Reader
// @dep_class 9eea745ee18e1fbc java_io_UnsupportedEncodingException
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class 680cf34d05feb5a1 java_lang_IllegalArgumentException
// @dep_class 505b8a9a6675be0 java_lang_NullPointerException
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class 4f5534a987354d1d java_lang_RuntimeException
// @dep_class d38282f3d5f80887 java_lang_SecurityManager
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 53cc8e2333795f04 java_lang_System
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class c4b275d49bb21d98 java_lang_UnsupportedOperationException
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class 9a9842bb79e9de6a java_nio_Buffer
// @dep_class c56860d6af73feea java_nio_ByteBuffer
// @dep_class 3db7af09889b3d0d java_nio_ByteBufferImpl
// @dep_class 3d4356f2be8683db java_nio_ByteOrder
// @dep_class 98edd00df7d19f1 java_nio_CharBuffer
// @dep_class f2fc5b91811c1d63 java_nio_CharBufferImpl
// @dep_class 935c1c8c4d4ae47f java_nio_charset_Charset
// @dep_class fe28164a0cadaacb java_nio_charset_CharsetDecoder
// @dep_class 50801be894e42472 java_nio_charset_CharsetEncoder
// @dep_class 67d265e617bbfda5 java_nio_charset_CoderResult
// @dep_class d05e2a1e302ececd java_nio_charset_CodingErrorAction
// @dep_class d7cd853200c3e71f java_util_HashMap
// @dep_class 884c3edb343dfb63 java_util_Properties

// header file dependencies
// @dep_header gnu_classpath_SystemProperties
// @dep_header gnu_java_nio_charset_EncodingHelper
// @dep_header java_io_InputStream
// @dep_header java_io_InputStreamReader
// @dep_header java_io_UnsupportedEncodingException
// @dep_header java_lang_Class
// @dep_header java_lang_IllegalArgumentException
// @dep_header java_lang_NullPointerException
// @dep_header java_lang_SecurityManager
// @dep_header java_lang_String
// @dep_header java_lang_System
// @dep_header java_lang_UnsupportedOperationException
// @dep_header java_lang_VMThrowable
// @dep_header java_nio_ByteBufferImpl
// @dep_header java_nio_ByteOrder
// @dep_header java_nio_CharBufferImpl
// @dep_header java_nio_charset_Charset
// @dep_header java_nio_charset_CharsetDecoder
// @dep_header java_nio_charset_CharsetEncoder
// @dep_header java_nio_charset_CoderResult
// @dep_header java_nio_charset_CodingErrorAction
// @dep_header java_util_HashMap
// @dep_header java_util_Properties

#include "jc_defs.h"

#include "gnu/classpath/SystemProperties.h"
#include "gnu/java/nio/charset/EncodingHelper.h"
#include "java/io/InputStream.h"
#include "java/io/InputStreamReader.h"
#include "java/io/UnsupportedEncodingException.h"
#include "java/lang/Class.h"
#include "java/lang/IllegalArgumentException.h"
#include "java/lang/NullPointerException.h"
#include "java/lang/SecurityManager.h"
#include "java/lang/String.h"
#include "java/lang/System.h"
#include "java/lang/UnsupportedOperationException.h"
#include "java/lang/VMThrowable.h"
#include "java/nio/ByteBufferImpl.h"
#include "java/nio/ByteOrder.h"
#include "java/nio/CharBufferImpl.h"
#include "java/nio/charset/Charset.h"
#include "java/nio/charset/CharsetDecoder.h"
#include "java/nio/charset/CharsetEncoder.h"
#include "java/nio/charset/CoderResult.h"
#include "java/nio/charset/CodingErrorAction.h"
#include "java/util/HashMap.h"
#include "java/util/Properties.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// private java.io.InputStream in
static _jc_field _jc_java_io_InputStreamReader$field_info$in = {
	.name=		"in",
	.signature=	"Ljava/io/InputStream;",
	.class=		&_jc_java_io_InputStreamReader$type,
	.type=		&_jc_java_io_InputStream$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_io_InputStreamReader$object, refs[-1].java_io_InputStreamReader.in),
};

// private java.nio.charset.CharsetDecoder decoder
static _jc_field _jc_java_io_InputStreamReader$field_info$decoder = {
	.name=		"decoder",
	.signature=	"Ljava/nio/charset/CharsetDecoder;",
	.class=		&_jc_java_io_InputStreamReader$type,
	.type=		&_jc_java_nio_charset_CharsetDecoder$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_io_InputStreamReader$object, refs[-1].java_io_InputStreamReader.decoder),
};

// private boolean isDone
static _jc_field _jc_java_io_InputStreamReader$field_info$isDone = {
	.name=		"isDone",
	.signature=	"Z",
	.class=		&_jc_java_io_InputStreamReader$type,
	.type=		&_jc_boolean$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_io_InputStreamReader$object, nonrefs.java_io_InputStreamReader.isDone),
};

// private float maxBytesPerChar
static _jc_field _jc_java_io_InputStreamReader$field_info$maxBytesPerChar = {
	.name=		"maxBytesPerChar",
	.signature=	"F",
	.class=		&_jc_java_io_InputStreamReader$type,
	.type=		&_jc_float$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_io_InputStreamReader$object, nonrefs.java_io_InputStreamReader.maxBytesPerChar),
};

// private java.nio.ByteBuffer byteBuffer
static _jc_field _jc_java_io_InputStreamReader$field_info$byteBuffer = {
	.name=		"byteBuffer",
	.signature=	"Ljava/nio/ByteBuffer;",
	.class=		&_jc_java_io_InputStreamReader$type,
	.type=		&_jc_java_nio_ByteBuffer$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_io_InputStreamReader$object, refs[-1].java_io_InputStreamReader.byteBuffer),
};

// private java.lang.String encoding
static _jc_field _jc_java_io_InputStreamReader$field_info$encoding = {
	.name=		"encoding",
	.signature=	"Ljava/lang/String;",
	.class=		&_jc_java_io_InputStreamReader$type,
	.type=		&_jc_java_lang_String$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_io_InputStreamReader$object, refs[-1].java_io_InputStreamReader.encoding),
};

// private char savedSurrogate
static _jc_field _jc_java_io_InputStreamReader$field_info$savedSurrogate = {
	.name=		"savedSurrogate",
	.signature=	"C",
	.class=		&_jc_java_io_InputStreamReader$type,
	.type=		&_jc_char$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_io_InputStreamReader$object, nonrefs.java_io_InputStreamReader.savedSurrogate),
};

// private boolean hasSavedSurrogate
static _jc_field _jc_java_io_InputStreamReader$field_info$hasSavedSurrogate = {
	.name=		"hasSavedSurrogate",
	.signature=	"Z",
	.class=		&_jc_java_io_InputStreamReader$type,
	.type=		&_jc_boolean$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_io_InputStreamReader$object, nonrefs.java_io_InputStreamReader.hasSavedSurrogate),
};

// Fields
static _jc_field *const _jc_java_io_InputStreamReader$fields[] = {
	&_jc_java_io_InputStreamReader$field_info$byteBuffer,
	&_jc_java_io_InputStreamReader$field_info$decoder,
	&_jc_java_io_InputStreamReader$field_info$encoding,
	&_jc_java_io_InputStreamReader$field_info$in,
	&_jc_java_io_InputStreamReader$field_info$maxBytesPerChar,
	&_jc_java_io_InputStreamReader$field_info$savedSurrogate,
	&_jc_java_io_InputStreamReader$field_info$hasSavedSurrogate,
	&_jc_java_io_InputStreamReader$field_info$isDone
};

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// public void <init>(java.io.InputStream)
//

static _jc_linenum _jc_java_io_InputStreamReader$linenum_table$_init$3887600c17c5e554[];

static _jc_trap_info _jc_java_io_InputStreamReader$trap_table$_init$3887600c17c5e554[] = {
	_JC_TRAP(&_jc_java_lang_UnsupportedOperationException$type, 4, 5),
	_JC_TRAP(&_jc_java_lang_RuntimeException$type, 3, 6),
	_JC_TRAP(&_jc_java_lang_RuntimeException$type, 1, 2),
	_JC_TRAP(&_jc_java_io_UnsupportedEncodingException$type, 3, 6),
	_JC_TRAP(&_jc_java_io_UnsupportedEncodingException$type, 1, 2),
};

static const unsigned char _jc_java_io_InputStreamReader$param_ptypes$_init$3887600c17c5e554[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_io_InputStreamReader$param_types$_init$3887600c17c5e554[] = {
	&_jc_java_io_InputStream$type
};

_jc_method _jc_java_io_InputStreamReader$method_info$_init$3887600c17c5e554 = {
	.name=			"<init>",
	.signature=		"(Ljava/io/InputStream;)V",
	.class=			&_jc_java_io_InputStreamReader$type,
	.param_types=		&_jc_java_io_InputStreamReader$param_types$_init$3887600c17c5e554,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_io_InputStreamReader$param_ptypes$_init$3887600c17c5e554,
	.signature_hash=	_JC_JLONG(0x3887600c17c5e554),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_io_InputStreamReader$method$_init$3887600c17c5e554,
	.num_parameters=	1,
	.u= { .exec= {
	  .trap_table_len=	5,
	  .trap_table=		_jc_java_io_InputStreamReader$trap_table$_init$3887600c17c5e554,
	  .u= {
	    .linenum= {
	      .len=	22,
	      .table=	_jc_java_io_InputStreamReader$linenum_table$_init$3887600c17c5e554
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_InputStreamReader, _init$3887600c17c5e554);

void _JC_JCNI_ATTR
_jc_java_io_InputStreamReader$method$_init$3887600c17c5e554(_jc_env *const env, _jc_java_io_InputStreamReader$object *this, _jc_java_io_InputStream$object *param0)
{
	jfloat f0;
	jint i0;
	struct _jc_java_io_InputStreamReader$object *volatile r0;
	struct _jc_java_io_InputStream$object *r1;
	struct _jc_java_lang_String$object *r10;
	struct _jc_java_lang_IllegalArgumentException$object *volatile r11;
	struct _jc_java_lang_String$object *volatile r12;
	struct _jc_java_lang_VMThrowable$object *volatile r13;
	struct _jc_java_lang_IllegalArgumentException$object *volatile r14;
	struct _jc_java_lang_String$object *volatile r15;
	struct _jc_java_lang_VMThrowable$object *volatile r16;
	struct _jc_java_util_HashMap$object *r17;
	struct _jc_java_lang_String$object *r18;
	struct _jc_java_lang_Object$object *r19;
	struct _jc_java_nio_charset_Charset$object *r2;
	struct _jc_java_lang_String$object *r20;
	struct _jc_java_lang_SecurityManager$object *r21;
	struct _jc_java_lang_IllegalArgumentException$object *r22;
	struct _jc_java_lang_String$object *r23;
	struct _jc_java_lang_String$object *r24;
	struct _jc_java_util_Properties$object *r25;
	struct _jc_java_lang_VMThrowable$object *r27;
	struct _jc_java_lang_UnsupportedOperationException$object *r3;
	struct _jc_java_lang_String$object *r4;
	struct _jc_java_nio_charset_CharsetDecoder$object *volatile r5;
	struct _jc_java_nio_charset_CharsetEncoder$object *r6;
	struct _jc_java_nio_charset_CodingErrorAction$object *volatile r7;
	struct _jc_java_lang_RuntimeException$object *r8;
	struct _jc_java_io_UnsupportedEncodingException$object *r9;
	jboolean z0;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_java_io_InputStreamReader$method_info$_init$3887600c17c5e554, &&label5, &&label9, &&label9, &&label10, &&label10);

	r0 = this;
	r1 = param0;
	_JC_REF_FIELD(env, r0, java_io_Reader, lock) = r0;
	_JC_PRIM_FIELD(env, r0, java_io_InputStreamReader, isDone) = 0;
	_JC_PRIM_FIELD(env, r0, java_io_InputStreamReader, hasSavedSurrogate) = 0;
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	_JC_LINE_NUMBER(147);				// 0
	_JC_REF_FIELD(env, r0, java_io_InputStreamReader, in) = r1;
	_JC_TRAP_REGION(catch, 1);
	_JC_ACTIVE_USE(env, java_lang_System);
	_JC_LINE_NUMBER(150);				// 1
	r20 = _JC_STRING(env, "file.encoding");
	r21 = _JC_STATIC_FIELD(env, java_lang_SecurityManager, current, 0);
	if (r21 == _JC_NULL)
		goto label0;
	_JC_INVOKE_VIRTUAL(env, java_lang_SecurityManager, checkPropertyAccess$96b5133fb2013064, r21, r20);
	goto label1;

label0:
	i0 = _JC_PRIM_FIELD(env, r20, java_lang_String, count);
	if (i0 != 0)
		goto label1;
	r22 = _JC_NEW(env, java_lang_IllegalArgumentException);
	r23 = _JC_STRING(env, "key can't be empty");
	_JC_REF_FIELD(env, r22, java_lang_Throwable, cause) = r22;
	r27 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r22);
	_JC_REF_FIELD(env, r22, java_lang_Throwable, vmState) = r27;
	_JC_REF_FIELD(env, r22, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r22, java_lang_Throwable, detailMessage) = r23;
	_JC_THROW(env, r22);

label1:
	_JC_ACTIVE_USE(env, gnu_classpath_SystemProperties);
	r25 = _JC_STATIC_FIELD(env, gnu_classpath_SystemProperties, properties, 1);
	r24 = _JC_INVOKE_VIRTUAL(env, java_util_Properties, getProperty$17fb18205ea95f87, r25, r20);
	_JC_REF_FIELD(env, r0, java_io_InputStreamReader, encoding) = r24;
	_JC_LINE_NUMBER(152);				// 2
	r4 = _JC_REF_FIELD(env, r0, java_io_InputStreamReader, encoding);
	z0 = _JC_INVOKE_STATIC(env, gnu_java_nio_charset_EncodingHelper, isISOLatin1$33892646b213dd41, 0, r4);
	if (z0 == 0)
		goto label2;
	_JC_LINE_NUMBER(154);				// 3
	_JC_REF_FIELD(env, r0, java_io_InputStreamReader, encoding) = _JC_STRING(env, "ISO8859_1");
	_JC_LINE_NUMBER(155);				// 4
	_JC_PRIM_FIELD(env, r0, java_io_InputStreamReader, maxBytesPerChar) = _JC_FCONST(0x3f, 0x80, 0x0, 0x0);
	_JC_LINE_NUMBER(156);				// 5
	_JC_REF_FIELD(env, r0, java_io_InputStreamReader, decoder) = _JC_NULL;
	_JC_TRAP_REGION(catch, 2);
	_JC_LINE_NUMBER(157);				// 6
	_JC_CANCEL_TRAPS(env, catch);
	return;

label2:
	_JC_TRAP_REGION(catch, 3);
	_JC_LINE_NUMBER(159);				// 7
	r4 = _JC_REF_FIELD(env, r0, java_io_InputStreamReader, encoding);
	r2 = _JC_INVOKE_STATIC(env, gnu_java_nio_charset_EncodingHelper, getCharset$22c5a929903ec944, 1, r4);
	_JC_LINE_NUMBER(160);				// 8
	r5 = _JC_INVOKE_VIRTUAL(env, java_nio_charset_Charset, newDecoder$a8155f7e01d3e07a, r2);
	_JC_REF_FIELD(env, r0, java_io_InputStreamReader, decoder) = r5;
	r10 = _JC_REF_FIELD(env, r2, java_nio_charset_Charset, canonicalName);
	r17 = _JC_STATIC_FIELD(env, gnu_java_nio_charset_EncodingHelper, canonicalNames, 1);
	r19 = _JC_INVOKE_VIRTUAL(env, java_util_HashMap, get$b30461fc5ea13399, r17, r10);
	r18 = _JC_CAST_FINAL(env, &_jc_java_lang_String$type, r19);
	if (r18 == _JC_NULL)
		goto label3;
	goto label4;

label3:
	r18 = r10;

label4:
	_JC_LINE_NUMBER(161);				// 9
	_JC_REF_FIELD(env, r0, java_io_InputStreamReader, encoding) = r18;
	_JC_TRAP_REGION(catch, 4);
	_JC_LINE_NUMBER(163);				// 10
	r6 = _JC_INVOKE_VIRTUAL(env, java_nio_charset_Charset, newEncoder$d60e26d796f39211, r2);
	_JC_EXPLICIT_NULL_CHECK(env, r6);
	f0 = _JC_PRIM_FIELD(env, r6, java_nio_charset_CharsetEncoder, maxBytesPerChar);
	_JC_PRIM_FIELD(env, r0, java_io_InputStreamReader, maxBytesPerChar) = f0;
	_JC_TRAP_REGION(catch, 5);
	goto label6;

label5:
	_JC_TRAP_REGION(catch, 5);
	r3 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(165);				// 11
	_JC_PRIM_FIELD(env, r0, java_io_InputStreamReader, maxBytesPerChar) = _JC_FCONST(0x3f, 0x80, 0x0, 0x0);

label6:
	_JC_LINE_NUMBER(167);				// 12
	r5 = _JC_REF_FIELD(env, r0, java_io_InputStreamReader, decoder);
	r7 = _JC_STATIC_FIELD(env, java_nio_charset_CodingErrorAction, REPLACE, 0);
	_JC_EXPLICIT_NULL_CHECK(env, r5);
	if (r7 != _JC_NULL)
		goto label7;
	r11 = _JC_NEW(env, java_lang_IllegalArgumentException);
	r12 = _JC_STRING(env, "Null action");
	_JC_REF_FIELD(env, r11, java_lang_Throwable, cause) = r11;
	r13 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r11);
	_JC_REF_FIELD(env, r11, java_lang_Throwable, vmState) = r13;
	_JC_REF_FIELD(env, r11, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r11, java_lang_Throwable, detailMessage) = r12;
	_JC_THROW(env, r11);

label7:
	_JC_REF_FIELD(env, r5, java_nio_charset_CharsetDecoder, malformedInputAction) = r7;
	_JC_INVOKE_VIRTUAL(env, java_nio_charset_CharsetDecoder, implOnMalformedInput$65752f7959eba607, r5, r7);
	_JC_LINE_NUMBER(168);				// 13
	r5 = _JC_REF_FIELD(env, r0, java_io_InputStreamReader, decoder);
	r7 = _JC_STATIC_FIELD(env, java_nio_charset_CodingErrorAction, REPLACE, 1);
	_JC_EXPLICIT_NULL_CHECK(env, r5);
	if (r7 != _JC_NULL)
		goto label8;
	r14 = _JC_NEW(env, java_lang_IllegalArgumentException);
	r15 = _JC_STRING(env, "Null action");
	_JC_REF_FIELD(env, r14, java_lang_Throwable, cause) = r14;
	r16 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r14);
	_JC_REF_FIELD(env, r14, java_lang_Throwable, vmState) = r16;
	_JC_REF_FIELD(env, r14, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r14, java_lang_Throwable, detailMessage) = r15;
	_JC_THROW(env, r14);

label8:
	_JC_REF_FIELD(env, r5, java_nio_charset_CharsetDecoder, unmappableCharacterAction) = r7;
	_JC_INVOKE_VIRTUAL(env, java_nio_charset_CharsetDecoder, implOnUnmappableCharacter$21114fa5db016cca, r5, r7);
	_JC_LINE_NUMBER(169);				// 14
	r5 = _JC_REF_FIELD(env, r0, java_io_InputStreamReader, decoder);
	_JC_EXPLICIT_NULL_CHECK(env, r5);
	_JC_PRIM_FIELD(env, r5, java_nio_charset_CharsetDecoder, state) = 0;
	_JC_INVOKE_VIRTUAL(env, java_nio_charset_CharsetDecoder, implReset$7614bfe5fe6326d0, r5);
	_JC_TRAP_REGION(catch, 6);
	goto label11;

label9:
	_JC_TRAP_REGION(catch, 6);
	r8 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(171);				// 15
	_JC_REF_FIELD(env, r0, java_io_InputStreamReader, encoding) = _JC_STRING(env, "ISO8859_1");
	_JC_LINE_NUMBER(172);				// 16
	_JC_PRIM_FIELD(env, r0, java_io_InputStreamReader, maxBytesPerChar) = _JC_FCONST(0x3f, 0x80, 0x0, 0x0);
	_JC_LINE_NUMBER(173);				// 17
	_JC_REF_FIELD(env, r0, java_io_InputStreamReader, decoder) = _JC_NULL;
	goto label11;

label10:
	_JC_TRAP_REGION(catch, 6);
	r9 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(175);				// 18
	_JC_REF_FIELD(env, r0, java_io_InputStreamReader, encoding) = _JC_STRING(env, "ISO8859_1");
	_JC_LINE_NUMBER(176);				// 19
	_JC_PRIM_FIELD(env, r0, java_io_InputStreamReader, maxBytesPerChar) = _JC_FCONST(0x3f, 0x80, 0x0, 0x0);
	_JC_LINE_NUMBER(177);				// 20
	_JC_REF_FIELD(env, r0, java_io_InputStreamReader, decoder) = _JC_NULL;

label11:
	_JC_LINE_NUMBER(179);				// 21
	_JC_CANCEL_TRAPS(env, catch);
	return;
}

//
// public void <init>(java.io.InputStream, java.lang.String) throws java.io.UnsupportedEncodingException
//

static _jc_linenum _jc_java_io_InputStreamReader$linenum_table$_init$e001e34d89a02dc4[];

static _jc_trap_info _jc_java_io_InputStreamReader$trap_table$_init$e001e34d89a02dc4[] = {
	_JC_TRAP(&_jc_java_lang_UnsupportedOperationException$type, 2, 3),
	_JC_TRAP(&_jc_java_lang_RuntimeException$type, 1, 4),
};

static const unsigned char _jc_java_io_InputStreamReader$param_ptypes$_init$e001e34d89a02dc4[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_io_InputStreamReader$exceptions$_init$e001e34d89a02dc4[] = {
	&_jc_java_io_UnsupportedEncodingException$type
};

static _jc_type *const _jc_java_io_InputStreamReader$param_types$_init$e001e34d89a02dc4[] = {
	&_jc_java_io_InputStream$type,
	&_jc_java_lang_String$type
};

_jc_method _jc_java_io_InputStreamReader$method_info$_init$e001e34d89a02dc4 = {
	.name=			"<init>",
	.signature=		"(Ljava/io/InputStream;Ljava/lang/String;)V",
	.class=			&_jc_java_io_InputStreamReader$type,
	.param_types=		&_jc_java_io_InputStreamReader$param_types$_init$e001e34d89a02dc4,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_io_InputStreamReader$param_ptypes$_init$e001e34d89a02dc4,
	.signature_hash=	_JC_JLONG(0xe001e34d89a02dc4),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_io_InputStreamReader$method$_init$e001e34d89a02dc4,
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_io_InputStreamReader$exceptions$_init$e001e34d89a02dc4,
	.u= { .exec= {
	  .trap_table_len=	2,
	  .trap_table=		_jc_java_io_InputStreamReader$trap_table$_init$e001e34d89a02dc4,
	  .u= {
	    .linenum= {
	      .len=	20,
	      .table=	_jc_java_io_InputStreamReader$linenum_table$_init$e001e34d89a02dc4
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_InputStreamReader, _init$e001e34d89a02dc4);

void _JC_JCNI_ATTR
_jc_java_io_InputStreamReader$method$_init$e001e34d89a02dc4(_jc_env *const env, _jc_java_io_InputStreamReader$object *this, _jc_java_io_InputStream$object *param0, _jc_java_lang_String$object *param1)
{
	jfloat f0;
	struct _jc_java_io_InputStreamReader$object *volatile r0;
	struct _jc_java_io_InputStream$object *r1;
	struct _jc_java_lang_String$object *volatile r10;
	struct _jc_java_lang_String$object *r11;
	struct _jc_java_lang_VMThrowable$object *r12;
	struct _jc_java_lang_IllegalArgumentException$object *volatile r13;
	struct _jc_java_lang_String$object *volatile r14;
	struct _jc_java_lang_VMThrowable$object *volatile r15;
	struct _jc_java_lang_IllegalArgumentException$object *volatile r16;
	struct _jc_java_lang_String$object *volatile r17;
	struct _jc_java_lang_VMThrowable$object *volatile r18;
	struct _jc_java_lang_String$object *r2;
	struct _jc_java_util_HashMap$object *volatile r20;
	struct _jc_java_lang_String$object *volatile r21;
	struct _jc_java_lang_Object$object *volatile r22;
	struct _jc_java_nio_charset_Charset$object *volatile r3;
	struct _jc_java_lang_UnsupportedOperationException$object *r4;
	struct _jc_java_lang_NullPointerException$object *r5;
	struct _jc_java_nio_charset_CharsetEncoder$object *r6;
	struct _jc_java_nio_charset_CharsetDecoder$object *volatile r7;
	struct _jc_java_nio_charset_CodingErrorAction$object *volatile r8;
	struct _jc_java_lang_RuntimeException$object *r9;
	jboolean z0;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_java_io_InputStreamReader$method_info$_init$e001e34d89a02dc4, &&label3, &&label9);

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_REF_FIELD(env, r0, java_io_Reader, lock) = r0;
	_JC_PRIM_FIELD(env, r0, java_io_InputStreamReader, isDone) = 0;
	_JC_PRIM_FIELD(env, r0, java_io_InputStreamReader, hasSavedSurrogate) = 0;
	_JC_LINE_NUMBER(196);				// 0
	if (r1 == _JC_NULL)
		goto label0;
	if (r2 != _JC_NULL)
		goto label1;

label0:
	_JC_LINE_NUMBER(198);				// 1
	r5 = _JC_NEW(env, java_lang_NullPointerException);
	r11 = _JC_NULL;
	_JC_REF_FIELD(env, r5, java_lang_Throwable, cause) = r5;
	r12 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r5);
	_JC_REF_FIELD(env, r5, java_lang_Throwable, vmState) = r12;
	_JC_REF_FIELD(env, r5, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r5, java_lang_Throwable, detailMessage) = r11;
	_JC_THROW(env, r5);

label1:
	_JC_LINE_NUMBER(200);				// 2
	_JC_REF_FIELD(env, r0, java_io_InputStreamReader, in) = r1;
	_JC_LINE_NUMBER(202);				// 3
	z0 = _JC_INVOKE_STATIC(env, gnu_java_nio_charset_EncodingHelper, isISOLatin1$33892646b213dd41, 0, r2);
	if (z0 == 0)
		goto label2;
	_JC_LINE_NUMBER(204);				// 4
	_JC_REF_FIELD(env, r0, java_io_InputStreamReader, encoding) = _JC_STRING(env, "ISO8859_1");
	_JC_LINE_NUMBER(205);				// 5
	_JC_PRIM_FIELD(env, r0, java_io_InputStreamReader, maxBytesPerChar) = _JC_FCONST(0x3f, 0x80, 0x0, 0x0);
	_JC_LINE_NUMBER(206);				// 6
	_JC_REF_FIELD(env, r0, java_io_InputStreamReader, decoder) = _JC_NULL;
	_JC_LINE_NUMBER(207);				// 7
	_JC_CANCEL_TRAPS(env, catch);
	return;

label2:
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(210);				// 8
	r3 = _JC_INVOKE_STATIC(env, gnu_java_nio_charset_EncodingHelper, getCharset$22c5a929903ec944, 1, r2);
	_JC_TRAP_REGION(catch, 2);
	_JC_LINE_NUMBER(212);				// 9
	r6 = _JC_INVOKE_VIRTUAL(env, java_nio_charset_Charset, newEncoder$d60e26d796f39211, r3);
	_JC_EXPLICIT_NULL_CHECK(env, r6);
	f0 = _JC_PRIM_FIELD(env, r6, java_nio_charset_CharsetEncoder, maxBytesPerChar);
	_JC_PRIM_FIELD(env, r0, java_io_InputStreamReader, maxBytesPerChar) = f0;
	_JC_TRAP_REGION(catch, 3);
	goto label4;

label3:
	_JC_TRAP_REGION(catch, 3);
	r4 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(214);				// 10
	_JC_PRIM_FIELD(env, r0, java_io_InputStreamReader, maxBytesPerChar) = _JC_FCONST(0x3f, 0x80, 0x0, 0x0);

label4:
	_JC_LINE_NUMBER(217);				// 11
	r7 = _JC_INVOKE_VIRTUAL(env, java_nio_charset_Charset, newDecoder$a8155f7e01d3e07a, r3);
	_JC_REF_FIELD(env, r0, java_io_InputStreamReader, decoder) = r7;
	_JC_LINE_NUMBER(218);				// 12
	r7 = _JC_REF_FIELD(env, r0, java_io_InputStreamReader, decoder);
	r8 = _JC_STATIC_FIELD(env, java_nio_charset_CodingErrorAction, REPLACE, 0);
	_JC_EXPLICIT_NULL_CHECK(env, r7);
	if (r8 != _JC_NULL)
		goto label5;
	r13 = _JC_NEW(env, java_lang_IllegalArgumentException);
	r14 = _JC_STRING(env, "Null action");
	_JC_REF_FIELD(env, r13, java_lang_Throwable, cause) = r13;
	r15 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r13);
	_JC_REF_FIELD(env, r13, java_lang_Throwable, vmState) = r15;
	_JC_REF_FIELD(env, r13, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r13, java_lang_Throwable, detailMessage) = r14;
	_JC_THROW(env, r13);

label5:
	_JC_REF_FIELD(env, r7, java_nio_charset_CharsetDecoder, malformedInputAction) = r8;
	_JC_INVOKE_VIRTUAL(env, java_nio_charset_CharsetDecoder, implOnMalformedInput$65752f7959eba607, r7, r8);
	_JC_LINE_NUMBER(219);				// 13
	r7 = _JC_REF_FIELD(env, r0, java_io_InputStreamReader, decoder);
	r8 = _JC_STATIC_FIELD(env, java_nio_charset_CodingErrorAction, REPLACE, 1);
	_JC_EXPLICIT_NULL_CHECK(env, r7);
	if (r8 != _JC_NULL)
		goto label6;
	r16 = _JC_NEW(env, java_lang_IllegalArgumentException);
	r17 = _JC_STRING(env, "Null action");
	_JC_REF_FIELD(env, r16, java_lang_Throwable, cause) = r16;
	r18 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r16);
	_JC_REF_FIELD(env, r16, java_lang_Throwable, vmState) = r18;
	_JC_REF_FIELD(env, r16, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r16, java_lang_Throwable, detailMessage) = r17;
	_JC_THROW(env, r16);

label6:
	_JC_REF_FIELD(env, r7, java_nio_charset_CharsetDecoder, unmappableCharacterAction) = r8;
	_JC_INVOKE_VIRTUAL(env, java_nio_charset_CharsetDecoder, implOnUnmappableCharacter$21114fa5db016cca, r7, r8);
	_JC_LINE_NUMBER(220);				// 14
	r7 = _JC_REF_FIELD(env, r0, java_io_InputStreamReader, decoder);
	_JC_EXPLICIT_NULL_CHECK(env, r7);
	_JC_PRIM_FIELD(env, r7, java_nio_charset_CharsetDecoder, state) = 0;
	_JC_INVOKE_VIRTUAL(env, java_nio_charset_CharsetDecoder, implReset$7614bfe5fe6326d0, r7);
	r10 = _JC_REF_FIELD(env, r3, java_nio_charset_Charset, canonicalName);
	r20 = _JC_STATIC_FIELD(env, gnu_java_nio_charset_EncodingHelper, canonicalNames, 1);
	r22 = _JC_INVOKE_VIRTUAL(env, java_util_HashMap, get$b30461fc5ea13399, r20, r10);
	r21 = _JC_CAST_FINAL(env, &_jc_java_lang_String$type, r22);
	if (r21 == _JC_NULL)
		goto label7;
	goto label8;

label7:
	r21 = r10;

label8:
	_JC_LINE_NUMBER(223);				// 15
	_JC_REF_FIELD(env, r0, java_io_InputStreamReader, encoding) = r21;
	_JC_TRAP_REGION(catch, 4);
	goto label10;

label9:
	_JC_TRAP_REGION(catch, 4);
	r9 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(225);				// 16
	_JC_REF_FIELD(env, r0, java_io_InputStreamReader, encoding) = _JC_STRING(env, "ISO8859_1");
	_JC_LINE_NUMBER(226);				// 17
	_JC_PRIM_FIELD(env, r0, java_io_InputStreamReader, maxBytesPerChar) = _JC_FCONST(0x3f, 0x80, 0x0, 0x0);
	_JC_LINE_NUMBER(227);				// 18
	_JC_REF_FIELD(env, r0, java_io_InputStreamReader, decoder) = _JC_NULL;

label10:
	_JC_LINE_NUMBER(229);				// 19
	_JC_CANCEL_TRAPS(env, catch);
	return;
}

//
// public void <init>(java.io.InputStream, java.nio.charset.Charset)
//

static _jc_linenum _jc_java_io_InputStreamReader$linenum_table$_init$582a58a2b32a5e37[];

static const unsigned char _jc_java_io_InputStreamReader$param_ptypes$_init$582a58a2b32a5e37[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_io_InputStreamReader$param_types$_init$582a58a2b32a5e37[] = {
	&_jc_java_io_InputStream$type,
	&_jc_java_nio_charset_Charset$type
};

_jc_method _jc_java_io_InputStreamReader$method_info$_init$582a58a2b32a5e37 = {
	.name=			"<init>",
	.signature=		"(Ljava/io/InputStream;Ljava/nio/charset/Charset;)V",
	.class=			&_jc_java_io_InputStreamReader$type,
	.param_types=		&_jc_java_io_InputStreamReader$param_types$_init$582a58a2b32a5e37,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_io_InputStreamReader$param_ptypes$_init$582a58a2b32a5e37,
	.signature_hash=	_JC_JLONG(0x582a58a2b32a5e37),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_io_InputStreamReader$method$_init$582a58a2b32a5e37,
	.num_parameters=	2,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	7,
	      .table=	_jc_java_io_InputStreamReader$linenum_table$_init$582a58a2b32a5e37
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_InputStreamReader, _init$582a58a2b32a5e37);

void _JC_JCNI_ATTR
_jc_java_io_InputStreamReader$method$_init$582a58a2b32a5e37(_jc_env *const env, _jc_java_io_InputStreamReader$object *this, _jc_java_io_InputStream$object *param0, _jc_java_nio_charset_Charset$object *param1)
{
	struct _jc_java_io_InputStreamReader$object *r0;
	struct _jc_java_io_InputStream$object *r1;
	struct _jc_java_lang_IllegalArgumentException$object *r10;
	struct _jc_java_lang_String$object *r11;
	struct _jc_java_nio_charset_Charset$object *r2;
	struct _jc_java_nio_charset_CharsetDecoder$object *r3;
	struct _jc_java_nio_charset_CodingErrorAction$object *r4;
	struct _jc_java_lang_String$object *r5;
	struct _jc_java_lang_String$object *r6;
	struct _jc_java_lang_IllegalArgumentException$object *r7;
	struct _jc_java_lang_String$object *r8;
	struct _jc_java_lang_VMThrowable$object *r9;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_REF_FIELD(env, r0, java_io_Reader, lock) = r0;
	_JC_PRIM_FIELD(env, r0, java_io_InputStreamReader, isDone) = 0;
	_JC_PRIM_FIELD(env, r0, java_io_InputStreamReader, hasSavedSurrogate) = 0;
	_JC_LINE_NUMBER(237);				// 0
	_JC_REF_FIELD(env, r0, java_io_InputStreamReader, in) = r1;
	_JC_LINE_NUMBER(238);				// 1
	r3 = _JC_INVOKE_VIRTUAL(env, java_nio_charset_Charset, newDecoder$a8155f7e01d3e07a, r2);
	_JC_REF_FIELD(env, r0, java_io_InputStreamReader, decoder) = r3;
	_JC_LINE_NUMBER(240);				// 2
	r3 = _JC_REF_FIELD(env, r0, java_io_InputStreamReader, decoder);
	r4 = _JC_STATIC_FIELD(env, java_nio_charset_CodingErrorAction, REPLACE, 0);
	_JC_EXPLICIT_NULL_CHECK(env, r3);
	if (r4 != _JC_NULL)
		goto label0;
	r7 = _JC_NEW(env, java_lang_IllegalArgumentException);
	r8 = _JC_STRING(env, "Null action");
	_JC_REF_FIELD(env, r7, java_lang_Throwable, cause) = r7;
	r9 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r7);
	_JC_REF_FIELD(env, r7, java_lang_Throwable, vmState) = r9;
	_JC_REF_FIELD(env, r7, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r7, java_lang_Throwable, detailMessage) = r8;
	_JC_THROW(env, r7);

label0:
	_JC_REF_FIELD(env, r3, java_nio_charset_CharsetDecoder, malformedInputAction) = r4;
	_JC_INVOKE_VIRTUAL(env, java_nio_charset_CharsetDecoder, implOnMalformedInput$65752f7959eba607, r3, r4);
	_JC_LINE_NUMBER(241);				// 3
	r3 = _JC_REF_FIELD(env, r0, java_io_InputStreamReader, decoder);
	r4 = _JC_STATIC_FIELD(env, java_nio_charset_CodingErrorAction, REPLACE, 1);
	_JC_EXPLICIT_NULL_CHECK(env, r3);
	if (r4 != _JC_NULL)
		goto label1;
	r10 = _JC_NEW(env, java_lang_IllegalArgumentException);
	r11 = _JC_STRING(env, "Null action");
	_JC_INVOKE_NONVIRTUAL(env, java_lang_Throwable, _init$c31b894660454d13, 0, r10, r11);
	_JC_THROW(env, r10);

label1:
	_JC_REF_FIELD(env, r3, java_nio_charset_CharsetDecoder, unmappableCharacterAction) = r4;
	_JC_INVOKE_VIRTUAL(env, java_nio_charset_CharsetDecoder, implOnUnmappableCharacter$21114fa5db016cca, r3, r4);
	_JC_LINE_NUMBER(242);				// 4
	r3 = _JC_REF_FIELD(env, r0, java_io_InputStreamReader, decoder);
	_JC_EXPLICIT_NULL_CHECK(env, r3);
	_JC_PRIM_FIELD(env, r3, java_nio_charset_CharsetDecoder, state) = 0;
	_JC_INVOKE_VIRTUAL(env, java_nio_charset_CharsetDecoder, implReset$7614bfe5fe6326d0, r3);
	r6 = _JC_REF_FIELD(env, r2, java_nio_charset_Charset, canonicalName);
	_JC_LINE_NUMBER(243);				// 5
	r5 = _JC_INVOKE_STATIC(env, gnu_java_nio_charset_EncodingHelper, getOldCanonical$8db4e2c4c3ad6515, 0, r6);
	_JC_REF_FIELD(env, r0, java_io_InputStreamReader, encoding) = r5;
	_JC_LINE_NUMBER(244);				// 6
	return;
}

//
// public void <init>(java.io.InputStream, java.nio.charset.CharsetDecoder)
//

static _jc_linenum _jc_java_io_InputStreamReader$linenum_table$_init$295fd1a77cacbea1[];

static _jc_trap_info _jc_java_io_InputStreamReader$trap_table$_init$295fd1a77cacbea1[] = {
	_JC_TRAP(&_jc_java_lang_UnsupportedOperationException$type, 1, 2),
};

static const unsigned char _jc_java_io_InputStreamReader$param_ptypes$_init$295fd1a77cacbea1[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_io_InputStreamReader$param_types$_init$295fd1a77cacbea1[] = {
	&_jc_java_io_InputStream$type,
	&_jc_java_nio_charset_CharsetDecoder$type
};

_jc_method _jc_java_io_InputStreamReader$method_info$_init$295fd1a77cacbea1 = {
	.name=			"<init>",
	.signature=		"(Ljava/io/InputStream;Ljava/nio/charset/CharsetDecoder;)V",
	.class=			&_jc_java_io_InputStreamReader$type,
	.param_types=		&_jc_java_io_InputStreamReader$param_types$_init$295fd1a77cacbea1,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_io_InputStreamReader$param_ptypes$_init$295fd1a77cacbea1,
	.signature_hash=	_JC_JLONG(0x295fd1a77cacbea1),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_io_InputStreamReader$method$_init$295fd1a77cacbea1,
	.num_parameters=	2,
	.u= { .exec= {
	  .trap_table_len=	1,
	  .trap_table=		_jc_java_io_InputStreamReader$trap_table$_init$295fd1a77cacbea1,
	  .u= {
	    .linenum= {
	      .len=	8,
	      .table=	_jc_java_io_InputStreamReader$linenum_table$_init$295fd1a77cacbea1
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_InputStreamReader, _init$295fd1a77cacbea1);

void _JC_JCNI_ATTR
_jc_java_io_InputStreamReader$method$_init$295fd1a77cacbea1(_jc_env *const env, _jc_java_io_InputStreamReader$object *this, _jc_java_io_InputStream$object *param0, _jc_java_nio_charset_CharsetDecoder$object *param1)
{
	jfloat f0;
	struct _jc_java_io_InputStreamReader$object *volatile r0;
	struct _jc_java_io_InputStream$object *r1;
	struct _jc_java_lang_IllegalArgumentException$object *volatile r10;
	struct _jc_java_lang_String$object *volatile r11;
	struct _jc_java_lang_VMThrowable$object *volatile r12;
	struct _jc_java_lang_IllegalArgumentException$object *volatile r13;
	struct _jc_java_lang_String$object *volatile r14;
	struct _jc_java_lang_VMThrowable$object *volatile r16;
	struct _jc_java_nio_charset_CharsetDecoder$object *volatile r2;
	struct _jc_java_lang_UnsupportedOperationException$object *r3;
	struct _jc_java_nio_charset_CharsetEncoder$object *r4;
	struct _jc_java_nio_charset_CodingErrorAction$object *volatile r5;
	struct _jc_java_lang_String$object *volatile r6;
	struct _jc_java_nio_charset_Charset$object *r7;
	struct _jc_java_nio_charset_Charset$object *volatile r8;
	struct _jc_java_lang_String$object *volatile r9;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_java_io_InputStreamReader$method_info$_init$295fd1a77cacbea1, &&label0);

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_REF_FIELD(env, r0, java_io_Reader, lock) = r0;
	_JC_PRIM_FIELD(env, r0, java_io_InputStreamReader, isDone) = 0;
	_JC_PRIM_FIELD(env, r0, java_io_InputStreamReader, hasSavedSurrogate) = 0;
	_JC_LINE_NUMBER(251);				// 0
	_JC_REF_FIELD(env, r0, java_io_InputStreamReader, in) = r1;
	_JC_LINE_NUMBER(252);				// 1
	_JC_REF_FIELD(env, r0, java_io_InputStreamReader, decoder) = r2;
	_JC_TRAP_REGION(catch, 1);
	_JC_EXPLICIT_NULL_CHECK(env, r2);
	r7 = _JC_REF_FIELD(env, r2, java_nio_charset_CharsetDecoder, charset);
	_JC_LINE_NUMBER(255);				// 2
	r4 = _JC_INVOKE_VIRTUAL(env, java_nio_charset_Charset, newEncoder$d60e26d796f39211, r7);
	_JC_EXPLICIT_NULL_CHECK(env, r4);
	f0 = _JC_PRIM_FIELD(env, r4, java_nio_charset_CharsetEncoder, maxBytesPerChar);
	_JC_PRIM_FIELD(env, r0, java_io_InputStreamReader, maxBytesPerChar) = f0;
	_JC_TRAP_REGION(catch, 2);
	goto label1;

label0:
	_JC_TRAP_REGION(catch, 2);
	r3 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(257);				// 3
	_JC_PRIM_FIELD(env, r0, java_io_InputStreamReader, maxBytesPerChar) = _JC_FCONST(0x3f, 0x80, 0x0, 0x0);

label1:
	_JC_LINE_NUMBER(260);				// 4
	r5 = _JC_STATIC_FIELD(env, java_nio_charset_CodingErrorAction, REPLACE, 0);
	_JC_EXPLICIT_NULL_CHECK(env, r2);
	if (r5 != _JC_NULL)
		goto label2;
	r10 = _JC_NEW(env, java_lang_IllegalArgumentException);
	r11 = _JC_STRING(env, "Null action");
	_JC_REF_FIELD(env, r10, java_lang_Throwable, cause) = r10;
	r12 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r10);
	_JC_REF_FIELD(env, r10, java_lang_Throwable, vmState) = r12;
	_JC_REF_FIELD(env, r10, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r10, java_lang_Throwable, detailMessage) = r11;
	_JC_THROW(env, r10);

label2:
	_JC_REF_FIELD(env, r2, java_nio_charset_CharsetDecoder, malformedInputAction) = r5;
	_JC_INVOKE_VIRTUAL(env, java_nio_charset_CharsetDecoder, implOnMalformedInput$65752f7959eba607, r2, r5);
	_JC_LINE_NUMBER(261);				// 5
	r5 = _JC_STATIC_FIELD(env, java_nio_charset_CodingErrorAction, REPLACE, 1);
	if (r5 != _JC_NULL)
		goto label3;
	r13 = _JC_NEW(env, java_lang_IllegalArgumentException);
	r14 = _JC_STRING(env, "Null action");
	_JC_REF_FIELD(env, r13, java_lang_Throwable, cause) = r13;
	r16 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r13);
	_JC_REF_FIELD(env, r13, java_lang_Throwable, vmState) = r16;
	_JC_REF_FIELD(env, r13, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r13, java_lang_Throwable, detailMessage) = r14;
	_JC_THROW(env, r13);

label3:
	_JC_REF_FIELD(env, r2, java_nio_charset_CharsetDecoder, unmappableCharacterAction) = r5;
	_JC_INVOKE_VIRTUAL(env, java_nio_charset_CharsetDecoder, implOnUnmappableCharacter$21114fa5db016cca, r2, r5);
	_JC_PRIM_FIELD(env, r2, java_nio_charset_CharsetDecoder, state) = 0;
	_JC_INVOKE_VIRTUAL(env, java_nio_charset_CharsetDecoder, implReset$7614bfe5fe6326d0, r2);
	r8 = _JC_REF_FIELD(env, r2, java_nio_charset_CharsetDecoder, charset);
	_JC_EXPLICIT_NULL_CHECK(env, r8);
	r9 = _JC_REF_FIELD(env, r8, java_nio_charset_Charset, canonicalName);
	_JC_LINE_NUMBER(263);				// 6
	r6 = _JC_INVOKE_STATIC(env, gnu_java_nio_charset_EncodingHelper, getOldCanonical$8db4e2c4c3ad6515, 0, r9);
	_JC_REF_FIELD(env, r0, java_io_InputStreamReader, encoding) = r6;
	_JC_LINE_NUMBER(264);				// 7
	_JC_CANCEL_TRAPS(env, catch);
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public void close() throws java.io.IOException
//

static _jc_linenum _jc_java_io_InputStreamReader$linenum_table$close$6aba8b329fddcd79[];

static _jc_trap_info _jc_java_io_InputStreamReader$trap_table$close$6aba8b329fddcd79[] = {
	_JC_TRAP(_JC_NULL, 1, 2),
	_JC_TRAP(_JC_NULL, 3, 4),
};

static const unsigned char _jc_java_io_InputStreamReader$param_ptypes$close$6aba8b329fddcd79[] = { 
_JC_TYPE_VOID };

static _jc_type *const _jc_java_io_InputStreamReader$exceptions$close$6aba8b329fddcd79[] = {
	&_jc_java_io_IOException$type
};

_jc_method _jc_java_io_InputStreamReader$method_info$close$6aba8b329fddcd79 = {
	.name=			"close",
	.signature=		"()V",
	.class=			&_jc_java_io_InputStreamReader$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_io_InputStreamReader$param_ptypes$close$6aba8b329fddcd79,
	.signature_hash=	_JC_JLONG(0x6aba8b329fddcd79),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_io_InputStreamReader$method$close$6aba8b329fddcd79,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_io_InputStreamReader$vtable, java_io_InputStreamReader.close$6aba8b329fddcd79) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_io_InputStreamReader$exceptions$close$6aba8b329fddcd79,
	.u= { .exec= {
	  .trap_table_len=	2,
	  .trap_table=		_jc_java_io_InputStreamReader$trap_table$close$6aba8b329fddcd79,
	  .u= {
	    .linenum= {
	      .len=	9,
	      .table=	_jc_java_io_InputStreamReader$linenum_table$close$6aba8b329fddcd79
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_InputStreamReader, close$6aba8b329fddcd79);

void _JC_JCNI_ATTR
_jc_java_io_InputStreamReader$method$close$6aba8b329fddcd79(_jc_env *const env, _jc_java_io_InputStreamReader$object *this)
{
	struct _jc_java_io_InputStreamReader$object *r0;
	struct _jc_java_lang_Throwable$object *volatile r1;
	struct _jc_java_lang_Object$object *volatile r2;
	struct _jc_java_nio_charset_CharsetDecoder$object *r3;
	struct _jc_java_io_InputStream$object *r4;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_java_io_InputStreamReader$method_info$close$6aba8b329fddcd79, &&label0, &&label0);

	r0 = this;
	_JC_LINE_NUMBER(274);				// 0
	goto label1;

label0:
	_JC_TRAP_REGION(catch, 0);
	_JC_PERIODIC_CHECK(env);
	r1 = _JC_CAUGHT_EXCEPTION(env);
	_JC_TRAP_REGION(catch, 1);
	_JC_MONITOR_EXIT(env, r2);
	_JC_TRAP_REGION(catch, 2);
	_JC_THROW(env, r1);

label1:
	_JC_TRAP_REGION(catch, 2);
	r2 = _JC_REF_FIELD(env, r0, java_io_Reader, lock);
	_JC_MONITOR_ENTER(env, r2);
	_JC_TRAP_REGION(catch, 3);
	_JC_LINE_NUMBER(277);				// 1
	r3 = _JC_REF_FIELD(env, r0, java_io_InputStreamReader, decoder);
	if (r3 == _JC_NULL)
		goto label2;
	_JC_LINE_NUMBER(278);				// 2
	r3 = _JC_REF_FIELD(env, r0, java_io_InputStreamReader, decoder);
	_JC_EXPLICIT_NULL_CHECK(env, r3);
	_JC_PRIM_FIELD(env, r3, java_nio_charset_CharsetDecoder, state) = 0;
	_JC_INVOKE_VIRTUAL(env, java_nio_charset_CharsetDecoder, implReset$7614bfe5fe6326d0, r3);

label2:
	_JC_LINE_NUMBER(279);				// 3
	r4 = _JC_REF_FIELD(env, r0, java_io_InputStreamReader, in);
	if (r4 == _JC_NULL)
		goto label3;
	_JC_LINE_NUMBER(280);				// 4
	r4 = _JC_REF_FIELD(env, r0, java_io_InputStreamReader, in);
	_JC_INVOKE_VIRTUAL(env, java_io_InputStream, close$6aba8b329fddcd79, r4);

label3:
	_JC_LINE_NUMBER(281);				// 5
	_JC_REF_FIELD(env, r0, java_io_InputStreamReader, in) = _JC_NULL;
	_JC_LINE_NUMBER(282);				// 6
	_JC_PRIM_FIELD(env, r0, java_io_InputStreamReader, isDone) = 1;
	_JC_LINE_NUMBER(283);				// 7
	_JC_REF_FIELD(env, r0, java_io_InputStreamReader, decoder) = _JC_NULL;
	_JC_MONITOR_EXIT(env, r2);
	_JC_TRAP_REGION(catch, 4);
	_JC_LINE_NUMBER(285);				// 8
	_JC_CANCEL_TRAPS(env, catch);
	return;
}

//
// public java.lang.String getEncoding()
//

static _jc_linenum _jc_java_io_InputStreamReader$linenum_table$getEncoding$03c43fcfdc25c716[];

static const unsigned char _jc_java_io_InputStreamReader$param_ptypes$getEncoding$03c43fcfdc25c716[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_java_io_InputStreamReader$method_info$getEncoding$03c43fcfdc25c716 = {
	.name=			"getEncoding",
	.signature=		"()Ljava/lang/String;",
	.class=			&_jc_java_io_InputStreamReader$type,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_java_io_InputStreamReader$param_ptypes$getEncoding$03c43fcfdc25c716,
	.signature_hash=	_JC_JLONG(0x3c43fcfdc25c716),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_io_InputStreamReader$method$getEncoding$03c43fcfdc25c716,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_io_InputStreamReader$vtable, java_io_InputStreamReader.getEncoding$03c43fcfdc25c716) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_io_InputStreamReader$linenum_table$getEncoding$03c43fcfdc25c716
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_InputStreamReader, getEncoding$03c43fcfdc25c716);

_jc_java_lang_String$object * _JC_JCNI_ATTR
_jc_java_io_InputStreamReader$method$getEncoding$03c43fcfdc25c716(_jc_env *const env, _jc_java_io_InputStreamReader$object *this)
{
	struct _jc_java_io_InputStreamReader$object *r0;
	struct _jc_java_io_InputStream$object *r1;
	struct _jc_java_lang_String$object *r2;

	r0 = this;
	_JC_LINE_NUMBER(296);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_io_InputStreamReader, in);
	if (r1 == _JC_NULL)
		goto label0;
	r2 = _JC_REF_FIELD(env, r0, java_io_InputStreamReader, encoding);
	goto label1;

label0:
	r2 = _JC_NULL;

label1:
	return r2;
}

//
// public int read() throws java.io.IOException
//

static _jc_linenum _jc_java_io_InputStreamReader$linenum_table$read$1a981297cb524963[];

static const unsigned char _jc_java_io_InputStreamReader$param_ptypes$read$1a981297cb524963[] = { 
_JC_TYPE_INT };

static _jc_type *const _jc_java_io_InputStreamReader$exceptions$read$1a981297cb524963[] = {
	&_jc_java_io_IOException$type
};

_jc_method _jc_java_io_InputStreamReader$method_info$read$1a981297cb524963 = {
	.name=			"read",
	.signature=		"()I",
	.class=			&_jc_java_io_InputStreamReader$type,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_java_io_InputStreamReader$param_ptypes$read$1a981297cb524963,
	.signature_hash=	_JC_JLONG(0x1a981297cb524963),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_io_InputStreamReader$method$read$1a981297cb524963,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_io_InputStreamReader$vtable, java_io_InputStreamReader.read$1a981297cb524963) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_io_InputStreamReader$exceptions$read$1a981297cb524963,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_java_io_InputStreamReader$linenum_table$read$1a981297cb524963
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_InputStreamReader, read$1a981297cb524963);

jint _JC_JCNI_ATTR
_jc_java_io_InputStreamReader$method$read$1a981297cb524963(_jc_env *const env, _jc_java_io_InputStreamReader$object *this)
{
	jint i0;
	struct _jc_java_io_InputStreamReader$object *r0;
	_jc_char_array *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(415);				// 0
	r1 = _JC_NEW_PRIM_ARRAY(env, char, 1, 1);
	_JC_LINE_NUMBER(416);				// 1
	i0 = _JC_INVOKE_VIRTUAL(env, java_io_InputStreamReader, read$146ad4b836c4a55b, r0, r1, 0, 1);
	_JC_LINE_NUMBER(417);				// 2
	if (i0 <= 0)
		goto label0;
	i0 = _JC_PRIM_ELEMENT(env, char, r1, 0, 0, 0);
	goto label1;

label0:
	i0 = -1;

label1:
	return i0;
}

//
// public int read(char[], int, int) throws java.io.IOException
//

static _jc_linenum _jc_java_io_InputStreamReader$linenum_table$read$146ad4b836c4a55b[];

static const unsigned char _jc_java_io_InputStreamReader$param_ptypes$read$146ad4b836c4a55b[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_INT, _JC_TYPE_INT };

static _jc_type *const _jc_java_io_InputStreamReader$exceptions$read$146ad4b836c4a55b[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_java_io_InputStreamReader$param_types$read$146ad4b836c4a55b[] = {
	&_jc_char$array$prim$type,
	&_jc_int$prim$type,
	&_jc_int$prim$type
};

_jc_method _jc_java_io_InputStreamReader$method_info$read$146ad4b836c4a55b = {
	.name=			"read",
	.signature=		"([CII)I",
	.class=			&_jc_java_io_InputStreamReader$type,
	.param_types=		&_jc_java_io_InputStreamReader$param_types$read$146ad4b836c4a55b,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_java_io_InputStreamReader$param_ptypes$read$146ad4b836c4a55b,
	.signature_hash=	_JC_JLONG(0x146ad4b836c4a55b),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_io_InputStreamReader$method$read$146ad4b836c4a55b,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_io_InputStreamReader$vtable, java_io_InputStreamReader.read$146ad4b836c4a55b) / sizeof(void *),
	.num_parameters=	3,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_io_InputStreamReader$exceptions$read$146ad4b836c4a55b,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	44,
	      .table=	_jc_java_io_InputStreamReader$linenum_table$read$146ad4b836c4a55b
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_InputStreamReader, read$146ad4b836c4a55b);

jint _JC_JCNI_ATTR
_jc_java_io_InputStreamReader$method$read$146ad4b836c4a55b(_jc_env *const env, _jc_java_io_InputStreamReader$object *this, _jc_char_array *param0, jint param1, jint param2)
{
	jbyte b6;
	jchar c5;
	jdouble d0;
	jdouble d1;
	jfloat f0;
	jint i0;
	jint i1;
	jint i10;
	jint i11;
	jint i12;
	jint i13;
	jint i14;
	jint i15;
	jint i16;
	jint i17;
	jint i18;
	jint i19;
	jint i2;
	jint i20;
	jint i21;
	jint i22;
	jint i23;
	jint i3;
	jint i4;
	jint i8;
	jint i9;
	struct _jc_java_io_InputStreamReader$object *r0;
	_jc_char_array *r1;
	_jc_char_array *r10;
	struct _jc_java_lang_VMThrowable$object *r11;
	struct _jc_java_nio_ByteBufferImpl$object *r12;
	struct _jc_java_nio_ByteOrder$object *r13;
	struct _jc_java_nio_CharBufferImpl$object *r14;
	_jc_byte_array *r2;
	struct _jc_java_nio_charset_CoderResult$object *r3;
	struct _jc_java_io_InputStream$object *r4;
	struct _jc_java_io_IOException$object *r5;
	struct _jc_java_nio_charset_CharsetDecoder$object *r6;
	struct _jc_java_nio_ByteBuffer$object *r7;
	struct _jc_java_lang_String$object *r8;
	struct _jc_java_nio_CharBufferImpl$object *r9;
	jshort s7;
	jboolean z0;
	jboolean z1;
	jboolean z2;
	jboolean z3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	i0 = param1;
	i1 = param2;
	_JC_LINE_NUMBER(333);				// 0
	r4 = _JC_REF_FIELD(env, r0, java_io_InputStreamReader, in);
	if (r4 != _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(334);				// 1
	r5 = _JC_NEW(env, java_io_IOException);
	r8 = _JC_STRING(env, "Reader has been closed");
	_JC_REF_FIELD(env, r5, java_lang_Throwable, cause) = r5;
	r11 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r5);
	_JC_REF_FIELD(env, r5, java_lang_Throwable, vmState) = r11;
	_JC_REF_FIELD(env, r5, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r5, java_lang_Throwable, detailMessage) = r8;
	_JC_THROW(env, r5);

label0:
	_JC_LINE_NUMBER(335);				// 2
	z0 = _JC_PRIM_FIELD(env, r0, java_io_InputStreamReader, isDone);
	if (z0 == 0)
		goto label1;
	_JC_LINE_NUMBER(336);				// 3
	return -1;

label1:
	_JC_LINE_NUMBER(337);				// 4
	r6 = _JC_REF_FIELD(env, r0, java_io_InputStreamReader, decoder);
	if (r6 == _JC_NULL)
		goto label14;
	_JC_LINE_NUMBER(338);				// 5
	d0 = (jdouble)i1;
	f0 = _JC_PRIM_FIELD(env, r0, java_io_InputStreamReader, maxBytesPerChar);
	d1 = (jdouble)f0;
	d1 = d0 * d1;
	i2 = _JC_CAST_FLT2INT(env, jdouble, jint, d1);
	_JC_LINE_NUMBER(339);				// 6
	r2 = _JC_NEW_PRIM_ARRAY(env, byte, 1, i2);
	_JC_LINE_NUMBER(341);				// 7
	i3 = 0;
	_JC_LINE_NUMBER(342);				// 8
	r7 = _JC_REF_FIELD(env, r0, java_io_InputStreamReader, byteBuffer);
	if (r7 == _JC_NULL)
		goto label2;
	_JC_LINE_NUMBER(344);				// 9
	r7 = _JC_REF_FIELD(env, r0, java_io_InputStreamReader, byteBuffer);
	_JC_EXPLICIT_NULL_CHECK(env, r7);
	i10 = _JC_PRIM_FIELD(env, r7, java_nio_Buffer, limit);
	i11 = _JC_PRIM_FIELD(env, r7, java_nio_Buffer, pos);
	i11 = i10 - i11;
	i3 = i11;
	_JC_LINE_NUMBER(345);				// 10
	r7 = _JC_REF_FIELD(env, r0, java_io_InputStreamReader, byteBuffer);
	_JC_INVOKE_VIRTUAL(env, java_nio_ByteBuffer, get$dfa301e8ae375afe, r7, r2, 0, i11);

label2:
	_JC_LINE_NUMBER(348);				// 11
	i4 = i2 - i3;
	if (i4 <= 0)
		goto label4;
	_JC_LINE_NUMBER(350);				// 12
	r4 = _JC_REF_FIELD(env, r0, java_io_InputStreamReader, in);
	i4 = i2 - i3;
	i2 = _JC_INVOKE_VIRTUAL(env, java_io_InputStream, read$e6b6c87b9f256783, r4, r2, i3, i4);
	_JC_LINE_NUMBER(351);				// 13
	if (i2 != -1)
		goto label3;
	_JC_LINE_NUMBER(352);				// 14
	i4 = i3;
	_JC_LINE_NUMBER(353);				// 15
	_JC_PRIM_FIELD(env, r0, java_io_InputStreamReader, isDone) = 1;
	goto label5;

label3:
	_JC_LINE_NUMBER(355);				// 16
	i4 = i2 + i3;
	goto label5;

label4:
	_JC_LINE_NUMBER(357);				// 17
	i4 = i3;

label5:
	_JC_ACTIVE_USE(env, java_nio_ByteBuffer);
	r12 = _JC_NEW(env, java_nio_ByteBufferImpl);
	i13 = _JC_ARRAY_LENGTH(env, r2);
	i12 = 0 + i4;
	_JC_INVOKE_NONVIRTUAL(env, java_nio_Buffer, _init$b5870f7bfece007a, 0, r12, i13, i12, 0, -1);
	r13 = _JC_STATIC_FIELD(env, java_nio_ByteOrder, BIG__5fENDIAN, 0);
	_JC_REF_FIELD(env, r12, java_nio_ByteBuffer, endian) = r13;
	_JC_REF_FIELD(env, r12, java_nio_ByteBuffer, backing__5fbuffer) = r2;
	_JC_PRIM_FIELD(env, r12, java_nio_ByteBuffer, array__5foffset) = 0;
	_JC_PRIM_FIELD(env, r12, java_nio_ByteBufferImpl, readOnly) = 0;
	_JC_LINE_NUMBER(358);				// 18
	_JC_REF_FIELD(env, r0, java_io_InputStreamReader, byteBuffer) = r12;
	_JC_ACTIVE_USE(env, java_nio_CharBuffer);
	r14 = _JC_NEW(env, java_nio_CharBufferImpl);
	i15 = _JC_ARRAY_LENGTH(env, r1);
	i14 = i0 + i1;
	_JC_INVOKE_NONVIRTUAL(env, java_nio_Buffer, _init$b5870f7bfece007a, 0, r14, i15, i14, i0, -1);
	_JC_PRIM_FIELD(env, r14, java_nio_CharBuffer, array__5foffset) = 0;
	_JC_REF_FIELD(env, r14, java_nio_CharBuffer, backing__5fbuffer) = r1;
	_JC_PRIM_FIELD(env, r14, java_nio_CharBuffer, array__5foffset) = 0;
	_JC_PRIM_FIELD(env, r14, java_nio_CharBufferImpl, readOnly) = 0;
	i8 = _JC_PRIM_FIELD(env, r14, java_nio_Buffer, pos);
	_JC_LINE_NUMBER(362);				// 19
	z0 = _JC_PRIM_FIELD(env, r0, java_io_InputStreamReader, hasSavedSurrogate);
	if (z0 == 0)
		goto label6;
	_JC_LINE_NUMBER(363);				// 20
	_JC_PRIM_FIELD(env, r0, java_io_InputStreamReader, hasSavedSurrogate) = 0;
	_JC_LINE_NUMBER(364);				// 21
	c5 = _JC_PRIM_FIELD(env, r0, java_io_InputStreamReader, savedSurrogate);
	_JC_INVOKE_NONVIRTUAL(env, java_nio_CharBufferImpl, put$e31237867feccf8f, 0, r14, c5);

label6:
	_JC_LINE_NUMBER(368);				// 22
	r6 = _JC_REF_FIELD(env, r0, java_io_InputStreamReader, decoder);
	r7 = _JC_REF_FIELD(env, r0, java_io_InputStreamReader, byteBuffer);
	z0 = _JC_PRIM_FIELD(env, r0, java_io_InputStreamReader, isDone);
	r3 = _JC_INVOKE_NONVIRTUAL(env, java_nio_charset_CharsetDecoder, decode$3cb80bc8460c67fd, 1, r6, r7, r14, z0);
	_JC_LINE_NUMBER(369);				// 23
	r6 = _JC_REF_FIELD(env, r0, java_io_InputStreamReader, decoder);
	_JC_EXPLICIT_NULL_CHECK(env, r6);
	_JC_PRIM_FIELD(env, r6, java_nio_charset_CharsetDecoder, state) = 0;
	_JC_INVOKE_VIRTUAL(env, java_nio_charset_CharsetDecoder, implReset$7614bfe5fe6326d0, r6);
	_JC_LINE_NUMBER(371);				// 24
	z0 = _JC_INVOKE_VIRTUAL(env, java_nio_charset_CoderResult, isOverflow$098544571c1cac67, r3);
	if (z0 == 0)
		goto label9;
	z1 = 0;
	i16 = _JC_PRIM_FIELD(env, r14, java_nio_Buffer, limit);
	i17 = _JC_PRIM_FIELD(env, r14, java_nio_Buffer, pos);
	i17 = i16 - i17;
	if (i17 <= 0)
		goto label7;
	z1 = 1;

label7:
	if (z1 == 0)
		goto label9;
	r9 = _JC_NEW(env, java_nio_CharBufferImpl);
	r10 = _JC_NEW_PRIM_ARRAY(env, char, 1, 2);
	_JC_INVOKE_NONVIRTUAL(env, java_nio_Buffer, _init$b5870f7bfece007a, 0, r9, 2, 2, 0, -1);
	_JC_PRIM_FIELD(env, r9, java_nio_CharBuffer, array__5foffset) = 0;
	_JC_REF_FIELD(env, r9, java_nio_CharBuffer, backing__5fbuffer) = r10;
	_JC_PRIM_FIELD(env, r9, java_nio_CharBuffer, array__5foffset) = 0;
	_JC_PRIM_FIELD(env, r9, java_nio_CharBufferImpl, readOnly) = 0;
	_JC_LINE_NUMBER(373);				// 25
	r6 = _JC_REF_FIELD(env, r0, java_io_InputStreamReader, decoder);
	r7 = _JC_REF_FIELD(env, r0, java_io_InputStreamReader, byteBuffer);
	z0 = _JC_PRIM_FIELD(env, r0, java_io_InputStreamReader, isDone);
	_JC_INVOKE_NONVIRTUAL(env, java_nio_charset_CharsetDecoder, decode$3cb80bc8460c67fd, 1, r6, r7, r9, z0);
	i18 = _JC_PRIM_FIELD(env, r9, java_nio_Buffer, pos);
	_JC_PRIM_FIELD(env, r9, java_nio_Buffer, limit) = i18;
	_JC_PRIM_FIELD(env, r9, java_nio_Buffer, pos) = 0;
	_JC_PRIM_FIELD(env, r9, java_nio_Buffer, mark) = -1;
	z2 = 0;
	i19 = _JC_PRIM_FIELD(env, r9, java_nio_Buffer, limit);
	i20 = _JC_PRIM_FIELD(env, r9, java_nio_Buffer, pos);
	i20 = i19 - i20;
	if (i20 <= 0)
		goto label8;
	z2 = 1;

label8:
	_JC_LINE_NUMBER(375);				// 26
	if (z2 == 0)
		goto label9;
	_JC_LINE_NUMBER(377);				// 27
	c5 = _JC_INVOKE_NONVIRTUAL(env, java_nio_CharBufferImpl, get$d7666e09a8742577, 0, r9);
	_JC_INVOKE_NONVIRTUAL(env, java_nio_CharBufferImpl, put$e31237867feccf8f, 0, r14, c5);
	_JC_LINE_NUMBER(378);				// 28
	c5 = _JC_INVOKE_NONVIRTUAL(env, java_nio_CharBufferImpl, get$d7666e09a8742577, 0, r9);
	_JC_PRIM_FIELD(env, r0, java_io_InputStreamReader, savedSurrogate) = c5;
	_JC_LINE_NUMBER(379);				// 29
	_JC_PRIM_FIELD(env, r0, java_io_InputStreamReader, hasSavedSurrogate) = 1;
	_JC_LINE_NUMBER(380);				// 30
	_JC_PRIM_FIELD(env, r0, java_io_InputStreamReader, isDone) = 0;

label9:
	_JC_LINE_NUMBER(384);				// 31
	r7 = _JC_REF_FIELD(env, r0, java_io_InputStreamReader, byteBuffer);
	_JC_EXPLICIT_NULL_CHECK(env, r7);
	z3 = 0;
	i21 = _JC_PRIM_FIELD(env, r7, java_nio_Buffer, limit);
	i22 = _JC_PRIM_FIELD(env, r7, java_nio_Buffer, pos);
	i22 = i21 - i22;
	if (i22 <= 0)
		goto label10;
	z3 = 1;

label10:
	if (z3 == 0)
		goto label11;
	_JC_LINE_NUMBER(385);				// 32
	r7 = _JC_REF_FIELD(env, r0, java_io_InputStreamReader, byteBuffer);
	_JC_INVOKE_VIRTUAL(env, java_nio_ByteBuffer, compact$132d4e1a6cae875d, r7);
	_JC_LINE_NUMBER(386);				// 33
	r7 = _JC_REF_FIELD(env, r0, java_io_InputStreamReader, byteBuffer);
	_JC_EXPLICIT_NULL_CHECK(env, r7);
	i23 = _JC_PRIM_FIELD(env, r7, java_nio_Buffer, pos);
	_JC_PRIM_FIELD(env, r7, java_nio_Buffer, limit) = i23;
	_JC_PRIM_FIELD(env, r7, java_nio_Buffer, pos) = 0;
	_JC_PRIM_FIELD(env, r7, java_nio_Buffer, mark) = -1;
	_JC_LINE_NUMBER(387);				// 34
	_JC_PRIM_FIELD(env, r0, java_io_InputStreamReader, isDone) = 0;
	goto label12;

label11:
	_JC_LINE_NUMBER(389);				// 35
	_JC_REF_FIELD(env, r0, java_io_InputStreamReader, byteBuffer) = _JC_NULL;

label12:
	i9 = _JC_PRIM_FIELD(env, r14, java_nio_Buffer, pos);
	_JC_LINE_NUMBER(391);				// 36
	i4 = i9 - i8;
	_JC_LINE_NUMBER(392);				// 37
	if (i4 > 0)
		goto label13;
	i4 = -1;

label13:
	return i4;

label14:
	_JC_LINE_NUMBER(394);				// 38
	r2 = _JC_NEW_PRIM_ARRAY(env, byte, 1, i1);
	_JC_LINE_NUMBER(395);				// 39
	r4 = _JC_REF_FIELD(env, r0, java_io_InputStreamReader, in);
	i4 = _JC_INVOKE_VIRTUAL(env, java_io_InputStream, read$c38dd905b7fb8654, r4, r2);
	_JC_LINE_NUMBER(396);				// 40
	i3 = 0;
	goto label16;

label15:
	_JC_LINE_NUMBER(397);				// 41
	i2 = i0 + i3;
	b6 = _JC_PRIM_ELEMENT(env, byte, r2, i3, 0, 1);
	s7 = b6 & 255;
	c5 = (jchar)s7;
	_JC_PRIM_ELEMENT(env, char, r1, i2, 1, 1) = c5;
	_JC_LINE_NUMBER(396);				// 42
	i3 = i3 + 1;

label16:
	if (i3 < i4) {
		_JC_PERIODIC_CHECK(env);
		goto label15;
	}
	_JC_LINE_NUMBER(398);				// 43
	return i4;
}

//
// public boolean ready() throws java.io.IOException
//

static _jc_linenum _jc_java_io_InputStreamReader$linenum_table$ready$83ea616797d9c364[];

static const unsigned char _jc_java_io_InputStreamReader$param_ptypes$ready$83ea616797d9c364[] = { 
_JC_TYPE_BOOLEAN };

static _jc_type *const _jc_java_io_InputStreamReader$exceptions$ready$83ea616797d9c364[] = {
	&_jc_java_io_IOException$type
};

_jc_method _jc_java_io_InputStreamReader$method_info$ready$83ea616797d9c364 = {
	.name=			"ready",
	.signature=		"()Z",
	.class=			&_jc_java_io_InputStreamReader$type,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_java_io_InputStreamReader$param_ptypes$ready$83ea616797d9c364,
	.signature_hash=	_JC_JLONG(0x83ea616797d9c364),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_io_InputStreamReader$method$ready$83ea616797d9c364,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_io_InputStreamReader$vtable, java_io_InputStreamReader.ready$83ea616797d9c364) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_io_InputStreamReader$exceptions$ready$83ea616797d9c364,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_java_io_InputStreamReader$linenum_table$ready$83ea616797d9c364
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_InputStreamReader, ready$83ea616797d9c364);

jboolean _JC_JCNI_ATTR
_jc_java_io_InputStreamReader$method$ready$83ea616797d9c364(_jc_env *const env, _jc_java_io_InputStreamReader$object *this)
{
	jint i0;
	struct _jc_java_io_InputStreamReader$object *r0;
	struct _jc_java_io_InputStream$object *r1;
	struct _jc_java_io_IOException$object *r2;
	struct _jc_java_lang_String$object *r3;
	struct _jc_java_lang_VMThrowable$object *r5;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(312);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_io_InputStreamReader, in);
	if (r1 != _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(313);				// 1
	r2 = _JC_NEW(env, java_io_IOException);
	r3 = _JC_STRING(env, "Reader has been closed");
	_JC_REF_FIELD(env, r2, java_lang_Throwable, cause) = r2;
	r5 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r2);
	_JC_REF_FIELD(env, r2, java_lang_Throwable, vmState) = r5;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, detailMessage) = r3;
	_JC_THROW(env, r2);

label0:
	_JC_LINE_NUMBER(315);				// 2
	z0 = 0;
	r1 = _JC_REF_FIELD(env, r0, java_io_InputStreamReader, in);
	i0 = _JC_INVOKE_VIRTUAL(env, java_io_InputStream, available$81975cc608605037, r1);
	if (i0 == 0)
		goto label1;
	z0 = 1;

label1:
	return z0;
}

//
// public long skip(long) throws java.io.IOException
//

static _jc_linenum _jc_java_io_InputStreamReader$linenum_table$skip$4e431136b5c4614a[];

static const unsigned char _jc_java_io_InputStreamReader$param_ptypes$skip$4e431136b5c4614a[] = { 
_JC_TYPE_LONG, _JC_TYPE_LONG };

static _jc_type *const _jc_java_io_InputStreamReader$exceptions$skip$4e431136b5c4614a[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_java_io_InputStreamReader$param_types$skip$4e431136b5c4614a[] = {
	&_jc_long$prim$type
};

_jc_method _jc_java_io_InputStreamReader$method_info$skip$4e431136b5c4614a = {
	.name=			"skip",
	.signature=		"(J)J",
	.class=			&_jc_java_io_InputStreamReader$type,
	.param_types=		&_jc_java_io_InputStreamReader$param_types$skip$4e431136b5c4614a,
	.return_type=		&_jc_long$prim$type,
	.param_ptypes=		&_jc_java_io_InputStreamReader$param_ptypes$skip$4e431136b5c4614a,
	.signature_hash=	_JC_JLONG(0x4e431136b5c4614a),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_io_InputStreamReader$method$skip$4e431136b5c4614a,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_io_InputStreamReader$vtable, java_io_InputStreamReader.skip$4e431136b5c4614a) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_io_InputStreamReader$exceptions$skip$4e431136b5c4614a,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_java_io_InputStreamReader$linenum_table$skip$4e431136b5c4614a
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_InputStreamReader, skip$4e431136b5c4614a);

jlong _JC_JCNI_ATTR
_jc_java_io_InputStreamReader$method$skip$4e431136b5c4614a(_jc_env *const env, _jc_java_io_InputStreamReader$object *this, jlong param0)
{
	jlong l0;
	struct _jc_java_io_InputStreamReader$object *r0;
	struct _jc_java_io_InputStream$object *r1;
	struct _jc_java_io_IOException$object *r2;
	struct _jc_java_lang_String$object *r3;
	struct _jc_java_lang_VMThrowable$object *r5;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	l0 = param0;
	_JC_LINE_NUMBER(433);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_io_InputStreamReader, in);
	if (r1 != _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(434);				// 1
	r2 = _JC_NEW(env, java_io_IOException);
	r3 = _JC_STRING(env, "Reader has been closed");
	_JC_REF_FIELD(env, r2, java_lang_Throwable, cause) = r2;
	r5 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r2);
	_JC_REF_FIELD(env, r2, java_lang_Throwable, vmState) = r5;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, detailMessage) = r3;
	_JC_THROW(env, r2);

label0:
	_JC_LINE_NUMBER(436);				// 2
	l0 = _JC_INVOKE_NONVIRTUAL(env, java_io_Reader, skip$4e431136b5c4614a, 0, r0, l0);
	return l0;
}

//
// private final void this()
//

static _jc_linenum _jc_java_io_InputStreamReader$linenum_table$this$adc93fb6bf4cbffa[];

static const unsigned char _jc_java_io_InputStreamReader$param_ptypes$this$adc93fb6bf4cbffa[] = { 
_JC_TYPE_VOID };

_jc_method _jc_java_io_InputStreamReader$method_info$this$adc93fb6bf4cbffa = {
	.name=			"this",
	.signature=		"()V",
	.class=			&_jc_java_io_InputStreamReader$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_io_InputStreamReader$param_ptypes$this$adc93fb6bf4cbffa,
	.signature_hash=	_JC_JLONG(0xadc93fb6bf4cbffa),
	.access_flags=		_JC_ACC_PRIVATE|_JC_ACC_FINAL,
	.function=		&_jc_java_io_InputStreamReader$method$this$adc93fb6bf4cbffa,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_io_InputStreamReader$vtable, java_io_InputStreamReader.this$adc93fb6bf4cbffa) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_io_InputStreamReader$linenum_table$this$adc93fb6bf4cbffa
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_InputStreamReader, this$adc93fb6bf4cbffa);

void _JC_JCNI_ATTR
_jc_java_io_InputStreamReader$method$this$adc93fb6bf4cbffa(_jc_env *const env, _jc_java_io_InputStreamReader$object *this)
{
	struct _jc_java_io_InputStreamReader$object *r0;

	r0 = this;
	_JC_LINE_NUMBER(113);				// 0
	_JC_PRIM_FIELD(env, r0, java_io_InputStreamReader, isDone) = 0;
	_JC_LINE_NUMBER(135);				// 1
	_JC_PRIM_FIELD(env, r0, java_io_InputStreamReader, hasSavedSurrogate) = 0;
	return;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_java_io_InputStreamReader$methods[] = {
	&_jc_java_io_InputStreamReader$method_info$_init$3887600c17c5e554,
	&_jc_java_io_InputStreamReader$method_info$_init$e001e34d89a02dc4,
	&_jc_java_io_InputStreamReader$method_info$_init$582a58a2b32a5e37,
	&_jc_java_io_InputStreamReader$method_info$_init$295fd1a77cacbea1,
	&_jc_java_io_InputStreamReader$method_info$close$6aba8b329fddcd79,
	&_jc_java_io_InputStreamReader$method_info$getEncoding$03c43fcfdc25c716,
	&_jc_java_io_InputStreamReader$method_info$read$1a981297cb524963,
	&_jc_java_io_InputStreamReader$method_info$read$146ad4b836c4a55b,
	&_jc_java_io_InputStreamReader$method_info$ready$83ea616797d9c364,
	&_jc_java_io_InputStreamReader$method_info$skip$4e431136b5c4614a,
	&_jc_java_io_InputStreamReader$method_info$this$adc93fb6bf4cbffa
};

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_java_io_InputStreamReader$instanceof_hash_bucket_1[] = {
	&_jc_java_io_Reader$type,
	_JC_NULL
};
static _jc_type *const _jc_java_io_InputStreamReader$instanceof_hash_bucket_18[] = {
	&_jc_java_io_InputStreamReader$type,
	_JC_NULL
};
static _jc_type *const _jc_java_io_InputStreamReader$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_java_io_InputStreamReader$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[1]=	_jc_java_io_InputStreamReader$instanceof_hash_bucket_1,
	[18]=	_jc_java_io_InputStreamReader$instanceof_hash_bucket_18,
	[101]=	_jc_java_io_InputStreamReader$instanceof_hash_bucket_101
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_java_io_InputStreamReader$class_depends[] = {
	{ "gnu/classpath/SystemProperties",	_JC_JLONG(0x1160ded3f016b6b0) },
	{ "gnu/java/nio/charset/EncodingHelper",	_JC_JLONG(0xba039f692ab519ba) },
	{ "java/io/IOException",	_JC_JLONG(0x4e0a56550c69d57c) },
	{ "java/io/InputStream",	_JC_JLONG(0x66aea4d152614ac4) },
	{ "java/io/Reader",	_JC_JLONG(0x688afb20bd4c4e01) },
	{ "java/io/UnsupportedEncodingException",	_JC_JLONG(0x9eea745ee18e1fbc) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/IllegalArgumentException",	_JC_JLONG(0x680cf34d05feb5a1) },
	{ "java/lang/NullPointerException",	_JC_JLONG(0x505b8a9a6675be0) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/RuntimeException",	_JC_JLONG(0x4f5534a987354d1d) },
	{ "java/lang/SecurityManager",	_JC_JLONG(0xd38282f3d5f80887) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/System",	_JC_JLONG(0x53cc8e2333795f04) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/UnsupportedOperationException",	_JC_JLONG(0xc4b275d49bb21d98) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/nio/Buffer",	_JC_JLONG(0x9a9842bb79e9de6a) },
	{ "java/nio/ByteBuffer",	_JC_JLONG(0xc56860d6af73feea) },
	{ "java/nio/ByteBufferImpl",	_JC_JLONG(0x3db7af09889b3d0d) },
	{ "java/nio/ByteOrder",	_JC_JLONG(0x3d4356f2be8683db) },
	{ "java/nio/CharBuffer",	_JC_JLONG(0x98edd00df7d19f1) },
	{ "java/nio/CharBufferImpl",	_JC_JLONG(0xf2fc5b91811c1d63) },
	{ "java/nio/charset/Charset",	_JC_JLONG(0x935c1c8c4d4ae47f) },
	{ "java/nio/charset/CharsetDecoder",	_JC_JLONG(0xfe28164a0cadaacb) },
	{ "java/nio/charset/CharsetEncoder",	_JC_JLONG(0x50801be894e42472) },
	{ "java/nio/charset/CoderResult",	_JC_JLONG(0x67d265e617bbfda5) },
	{ "java/nio/charset/CodingErrorAction",	_JC_JLONG(0xd05e2a1e302ececd) },
	{ "java/util/HashMap",	_JC_JLONG(0xd7cd853200c3e71f) },
	{ "java/util/Properties",	_JC_JLONG(0x884c3edb343dfb63) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_java_io_InputStreamReader$vtype _jc_java_io_InputStreamReader$type = {
    .type= {
	.name=			"java/io/InputStreamReader",
	.superclass=		&_jc_java_io_Reader$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		27,
		.hash=			_JC_JLONG(0x30159d8092563292),
		.source_file=		"InputStreamReader.java",
		.instance_size=		sizeof(_jc_java_io_InputStreamReader$refs) + sizeof(_jc_java_io_InputStreamReader$object),
		.num_virtual_refs=	5,
		.num_fields=		sizeof(_jc_java_io_InputStreamReader$fields) / sizeof(*_jc_java_io_InputStreamReader$fields),
		.fields=		_jc_java_io_InputStreamReader$fields,
		.num_methods=		sizeof(_jc_java_io_InputStreamReader$methods) / sizeof(*_jc_java_io_InputStreamReader$methods),
		.methods=		_jc_java_io_InputStreamReader$methods,
		.instanceof_hash_table=	_jc_java_io_InputStreamReader$instanceof_hash_table,
		.num_class_depends=		sizeof(_jc_java_io_InputStreamReader$class_depends) / sizeof(*_jc_java_io_InputStreamReader$class_depends),
		.class_depends=		_jc_java_io_InputStreamReader$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.java_io_Reader= {
	    .close$6aba8b329fddcd79=			// overridden
		&_jc_java_io_InputStreamReader$method$close$6aba8b329fddcd79,
	    .mark$422af117ab27d9db=
		&_jc_java_io_Reader$method$mark$422af117ab27d9db,
	    .markSupported$66435a81b7b2f2dc=
		&_jc_java_io_Reader$method$markSupported$66435a81b7b2f2dc,
	    .read$1a981297cb524963=				// overridden
		&_jc_java_io_InputStreamReader$method$read$1a981297cb524963,
	    .read$3e60100363b78239=
		&_jc_java_io_Reader$method$read$3e60100363b78239,
	    .read$146ad4b836c4a55b=				// overridden
		&_jc_java_io_InputStreamReader$method$read$146ad4b836c4a55b,
	    .ready$83ea616797d9c364=			// overridden
		&_jc_java_io_InputStreamReader$method$ready$83ea616797d9c364,
	    .reset$229a80b3e8394a0f=
		&_jc_java_io_Reader$method$reset$229a80b3e8394a0f,
	    .skip$4e431136b5c4614a=				// overridden
		&_jc_java_io_InputStreamReader$method$skip$4e431136b5c4614a,
	},
	.java_io_InputStreamReader= {
	    .close$6aba8b329fddcd79=
		&_jc_java_io_InputStreamReader$method$close$6aba8b329fddcd79,
	    .getEncoding$03c43fcfdc25c716=
		&_jc_java_io_InputStreamReader$method$getEncoding$03c43fcfdc25c716,
	    .read$1a981297cb524963=
		&_jc_java_io_InputStreamReader$method$read$1a981297cb524963,
	    .read$146ad4b836c4a55b=
		&_jc_java_io_InputStreamReader$method$read$146ad4b836c4a55b,
	    .ready$83ea616797d9c364=
		&_jc_java_io_InputStreamReader$method$ready$83ea616797d9c364,
	    .skip$4e431136b5c4614a=
		&_jc_java_io_InputStreamReader$method$skip$4e431136b5c4614a,
	    .this$adc93fb6bf4cbffa=
		&_jc_java_io_InputStreamReader$method$this$adc93fb6bf4cbffa,
	},
    }
};

