// public abstract class java.net.URLConnection

// class file dependencies
// @dep_class 4e0a56550c69d57c java_io_IOException
// @dep_class 66aea4d152614ac4 java_io_InputStream
// @dep_class 4026d3144d6654d8 java_io_OutputStream
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class 1f925cf50bfc0d6c java_lang_ClassNotFoundException
// @dep_class 308333d803f5ab9f java_lang_Error
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class 29deac5351715967 java_lang_IllegalAccessException
// @dep_class b7e704701c278e65 java_lang_IllegalStateException
// @dep_class b09d021696f0bbb java_lang_InstantiationException
// @dep_class ca631501391a31f1 java_lang_Integer
// @dep_class 505b8a9a6675be0 java_lang_NullPointerException
// @dep_class a9fd317e4e09506e java_lang_NumberFormatException
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class 4f5534a987354d1d java_lang_RuntimeException
// @dep_class d38282f3d5f80887 java_lang_SecurityManager
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 94d357637b968dda java_lang_StringBuffer
// @dep_class 53cc8e2333795f04 java_lang_System
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class 238a2c0aafd74314 java_lang_VMClass
// @dep_class 312e45ed214d432f java_lang_VMObject
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class 4d87ebfc52d36524 java_net_ContentHandler
// @dep_class d6edcb0ef16d42dc java_net_ContentHandlerFactory
// @dep_class c4a254717010d562 java_net_FileNameMap
// @dep_class 662b642c7050afed java_net_MimeTypeMapper
// @dep_class 69345d46f4f40e9c java_net_URL
// @dep_class 1042c111741aa488 java_net_URLConnection
// @dep_class d7e769aebe17520e java_net_URLStreamHandler
// @dep_class d6b86851db4dcf14 java_net_UnknownServiceException
// @dep_class b53f70fa48574edf java_security_AllPermission
// @dep_class 2377c76e79058a72 java_security_Permission
// @dep_class 40ba3f7bd03c5728 java_text_ParsePosition
// @dep_class 73f981130935b8e5 java_text_SimpleDateFormat
// @dep_class 9574af3fed58029a java_util_Collections
// @dep_class a85d2a51094e614c java_util_Date
// @dep_class eeb74ad0fcba58b6 java_util_Locale
// @dep_class e283f7c2e7a7979c java_util_Map

// header file dependencies
// @dep_header java_io_InputStream
// @dep_header java_io_OutputStream
// @dep_header java_lang_Class
// @dep_header java_lang_ClassNotFoundException
// @dep_header java_lang_Error
// @dep_header java_lang_IllegalAccessException
// @dep_header java_lang_IllegalStateException
// @dep_header java_lang_InstantiationException
// @dep_header java_lang_Integer
// @dep_header java_lang_NullPointerException
// @dep_header java_lang_NumberFormatException
// @dep_header java_lang_SecurityManager
// @dep_header java_lang_String
// @dep_header java_lang_StringBuffer
// @dep_header java_lang_System
// @dep_header java_lang_VMClass
// @dep_header java_lang_VMObject
// @dep_header java_lang_VMThrowable
// @dep_header java_net_ContentHandler
// @dep_header java_net_ContentHandlerFactory
// @dep_header java_net_FileNameMap
// @dep_header java_net_MimeTypeMapper
// @dep_header java_net_URL
// @dep_header java_net_URLConnection
// @dep_header java_net_URLStreamHandler
// @dep_header java_net_UnknownServiceException
// @dep_header java_security_AllPermission
// @dep_header java_text_ParsePosition
// @dep_header java_text_SimpleDateFormat
// @dep_header java_util_Collections
// @dep_header java_util_Date
// @dep_header java_util_Locale
// @dep_header java_util_Map

#include "jc_defs.h"

#include "java/io/InputStream.h"
#include "java/io/OutputStream.h"
#include "java/lang/Class.h"
#include "java/lang/ClassNotFoundException.h"
#include "java/lang/Error.h"
#include "java/lang/IllegalAccessException.h"
#include "java/lang/IllegalStateException.h"
#include "java/lang/InstantiationException.h"
#include "java/lang/Integer.h"
#include "java/lang/NullPointerException.h"
#include "java/lang/NumberFormatException.h"
#include "java/lang/SecurityManager.h"
#include "java/lang/String.h"
#include "java/lang/StringBuffer.h"
#include "java/lang/System.h"
#include "java/lang/VMClass.h"
#include "java/lang/VMObject.h"
#include "java/lang/VMThrowable.h"
#include "java/net/ContentHandler.h"
#include "java/net/ContentHandlerFactory.h"
#include "java/net/FileNameMap.h"
#include "java/net/MimeTypeMapper.h"
#include "java/net/URL.h"
#include "java/net/URLConnection.h"
#include "java/net/URLStreamHandler.h"
#include "java/net/UnknownServiceException.h"
#include "java/security/AllPermission.h"
#include "java/text/ParsePosition.h"
#include "java/text/SimpleDateFormat.h"
#include "java/util/Collections.h"
#include "java/util/Date.h"
#include "java/util/Locale.h"
#include "java/util/Map.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// private static java.net.FileNameMap fileNameMap
static _jc_field _jc_java_net_URLConnection$field_info$fileNameMap = {
	.name=		"fileNameMap",
	.signature=	"Ljava/net/FileNameMap;",
	.class=		&_jc_java_net_URLConnection$type,
	.type=		&_jc_java_net_FileNameMap$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_STATIC,
	.offset=	_JC_OFFSETOF(_jc_java_net_URLConnection$fields_struct, fileNameMap),
};

// private static java.net.ContentHandlerFactory factory
static _jc_field _jc_java_net_URLConnection$field_info$factory = {
	.name=		"factory",
	.signature=	"Ljava/net/ContentHandlerFactory;",
	.class=		&_jc_java_net_URLConnection$type,
	.type=		&_jc_java_net_ContentHandlerFactory$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_STATIC,
	.offset=	_JC_OFFSETOF(_jc_java_net_URLConnection$fields_struct, factory),
};

// private static boolean defaultAllowUserInteraction
static _jc_field _jc_java_net_URLConnection$field_info$defaultAllowUserInteraction = {
	.name=		"defaultAllowUserInteraction",
	.signature=	"Z",
	.class=		&_jc_java_net_URLConnection$type,
	.type=		&_jc_boolean$prim$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_STATIC,
	.offset=	_JC_OFFSETOF(_jc_java_net_URLConnection$fields_struct, defaultAllowUserInteraction),
};

// private static boolean defaultUseCaches
static _jc_field _jc_java_net_URLConnection$field_info$defaultUseCaches = {
	.name=		"defaultUseCaches",
	.signature=	"Z",
	.class=		&_jc_java_net_URLConnection$type,
	.type=		&_jc_boolean$prim$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_STATIC,
	.offset=	_JC_OFFSETOF(_jc_java_net_URLConnection$fields_struct, defaultUseCaches),
};

// private static java.text.SimpleDateFormat[] dateFormats
static _jc_field _jc_java_net_URLConnection$field_info$dateFormats = {
	.name=		"dateFormats",
	.signature=	"[Ljava/text/SimpleDateFormat;",
	.class=		&_jc_java_net_URLConnection$type,
	.type=		&_jc_java_text_SimpleDateFormat$array$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_STATIC,
	.offset=	_JC_OFFSETOF(_jc_java_net_URLConnection$fields_struct, dateFormats),
};

// private static boolean dateformats_initialized
static _jc_field _jc_java_net_URLConnection$field_info$dateformats__5finitialized = {
	.name=		"dateformats_initialized",
	.signature=	"Z",
	.class=		&_jc_java_net_URLConnection$type,
	.type=		&_jc_boolean$prim$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_STATIC,
	.offset=	_JC_OFFSETOF(_jc_java_net_URLConnection$fields_struct, dateformats__5finitialized),
};

// protected boolean allowUserInteraction
static _jc_field _jc_java_net_URLConnection$field_info$allowUserInteraction = {
	.name=		"allowUserInteraction",
	.signature=	"Z",
	.class=		&_jc_java_net_URLConnection$type,
	.type=		&_jc_boolean$prim$type,
	.access_flags=	_JC_ACC_PROTECTED,
	.offset=	_JC_OFFSETOF(_jc_java_net_URLConnection$object, nonrefs.java_net_URLConnection.allowUserInteraction),
};

// protected boolean connected
static _jc_field _jc_java_net_URLConnection$field_info$connected = {
	.name=		"connected",
	.signature=	"Z",
	.class=		&_jc_java_net_URLConnection$type,
	.type=		&_jc_boolean$prim$type,
	.access_flags=	_JC_ACC_PROTECTED,
	.offset=	_JC_OFFSETOF(_jc_java_net_URLConnection$object, nonrefs.java_net_URLConnection.connected),
};

// protected boolean doInput
static _jc_field _jc_java_net_URLConnection$field_info$doInput = {
	.name=		"doInput",
	.signature=	"Z",
	.class=		&_jc_java_net_URLConnection$type,
	.type=		&_jc_boolean$prim$type,
	.access_flags=	_JC_ACC_PROTECTED,
	.offset=	_JC_OFFSETOF(_jc_java_net_URLConnection$object, nonrefs.java_net_URLConnection.doInput),
};

// protected boolean doOutput
static _jc_field _jc_java_net_URLConnection$field_info$doOutput = {
	.name=		"doOutput",
	.signature=	"Z",
	.class=		&_jc_java_net_URLConnection$type,
	.type=		&_jc_boolean$prim$type,
	.access_flags=	_JC_ACC_PROTECTED,
	.offset=	_JC_OFFSETOF(_jc_java_net_URLConnection$object, nonrefs.java_net_URLConnection.doOutput),
};

// protected boolean useCaches
static _jc_field _jc_java_net_URLConnection$field_info$useCaches = {
	.name=		"useCaches",
	.signature=	"Z",
	.class=		&_jc_java_net_URLConnection$type,
	.type=		&_jc_boolean$prim$type,
	.access_flags=	_JC_ACC_PROTECTED,
	.offset=	_JC_OFFSETOF(_jc_java_net_URLConnection$object, nonrefs.java_net_URLConnection.useCaches),
};

// protected long ifModifiedSince
static _jc_field _jc_java_net_URLConnection$field_info$ifModifiedSince = {
	.name=		"ifModifiedSince",
	.signature=	"J",
	.class=		&_jc_java_net_URLConnection$type,
	.type=		&_jc_long$prim$type,
	.access_flags=	_JC_ACC_PROTECTED,
	.offset=	_JC_OFFSETOF(_jc_java_net_URLConnection$object, nonrefs.java_net_URLConnection.ifModifiedSince),
};

// protected java.net.URL url
static _jc_field _jc_java_net_URLConnection$field_info$url = {
	.name=		"url",
	.signature=	"Ljava/net/URL;",
	.class=		&_jc_java_net_URLConnection$type,
	.type=		&_jc_java_net_URL$type,
	.access_flags=	_JC_ACC_PROTECTED,
	.offset=	_JC_OFFSETOF(_jc_java_net_URLConnection$object, refs[-1].java_net_URLConnection.url),
};

// private java.text.ParsePosition position
static _jc_field _jc_java_net_URLConnection$field_info$position = {
	.name=		"position",
	.signature=	"Ljava/text/ParsePosition;",
	.class=		&_jc_java_net_URLConnection$type,
	.type=		&_jc_java_text_ParsePosition$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_net_URLConnection$object, refs[-1].java_net_URLConnection.position),
};

// Fields
static _jc_field *const _jc_java_net_URLConnection$fields[] = {
	&_jc_java_net_URLConnection$field_info$dateFormats,
	&_jc_java_net_URLConnection$field_info$factory,
	&_jc_java_net_URLConnection$field_info$fileNameMap,
	&_jc_java_net_URLConnection$field_info$dateformats__5finitialized,
	&_jc_java_net_URLConnection$field_info$defaultAllowUserInteraction,
	&_jc_java_net_URLConnection$field_info$defaultUseCaches,
	&_jc_java_net_URLConnection$field_info$position,
	&_jc_java_net_URLConnection$field_info$url,
	&_jc_java_net_URLConnection$field_info$ifModifiedSince,
	&_jc_java_net_URLConnection$field_info$allowUserInteraction,
	&_jc_java_net_URLConnection$field_info$connected,
	&_jc_java_net_URLConnection$field_info$doInput,
	&_jc_java_net_URLConnection$field_info$doOutput,
	&_jc_java_net_URLConnection$field_info$useCaches
};

/************************************************************************
 *			      Static methods				*
 ************************************************************************/

//
// private static final void <clinit>()
//

static _jc_linenum _jc_java_net_URLConnection$linenum_table$_clinit$a816641e0ba8bfef[];

static const unsigned char _jc_java_net_URLConnection$param_ptypes$_clinit$a816641e0ba8bfef[] = { 
_JC_TYPE_VOID };

_jc_method _jc_java_net_URLConnection$method_info$_clinit$a816641e0ba8bfef = {
	.name=			"<clinit>",
	.signature=		"()V",
	.class=			&_jc_java_net_URLConnection$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_net_URLConnection$param_ptypes$_clinit$a816641e0ba8bfef,
	.signature_hash=	_JC_JLONG(0xa816641e0ba8bfef),
	.access_flags=		_JC_ACC_PRIVATE|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.function=		&_jc_java_net_URLConnection$method$_clinit$a816641e0ba8bfef,
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_net_URLConnection$linenum_table$_clinit$a816641e0ba8bfef
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_net_URLConnection, _clinit$a816641e0ba8bfef);

void _JC_JCNI_ATTR
_jc_java_net_URLConnection$method$_clinit$a816641e0ba8bfef(_jc_env *const env)
{
	_JC_LINE_NUMBER(114);				// 0
	_JC_STATIC_FIELD(env, java_net_URLConnection, defaultUseCaches, 1) = 1;
	return;
}

//
// public static boolean getDefaultAllowUserInteraction()
//

static _jc_linenum _jc_java_net_URLConnection$linenum_table$getDefaultAllowUserInteraction$d09701796dc63f79[];

static const unsigned char _jc_java_net_URLConnection$param_ptypes$getDefaultAllowUserInteraction$d09701796dc63f79[] = { 
_JC_TYPE_BOOLEAN };

_jc_method _jc_java_net_URLConnection$method_info$getDefaultAllowUserInteraction$d09701796dc63f79 = {
	.name=			"getDefaultAllowUserInteraction",
	.signature=		"()Z",
	.class=			&_jc_java_net_URLConnection$type,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_java_net_URLConnection$param_ptypes$getDefaultAllowUserInteraction$d09701796dc63f79,
	.signature_hash=	_JC_JLONG(0xd09701796dc63f79),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_java_net_URLConnection$method$getDefaultAllowUserInteraction$d09701796dc63f79,
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_net_URLConnection$linenum_table$getDefaultAllowUserInteraction$d09701796dc63f79
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_net_URLConnection, getDefaultAllowUserInteraction$d09701796dc63f79);

jboolean _JC_JCNI_ATTR
_jc_java_net_URLConnection$method$getDefaultAllowUserInteraction$d09701796dc63f79(_jc_env *const env)
{
	jboolean z0;

	_JC_LINE_NUMBER(635);				// 0
	z0 = _JC_STATIC_FIELD(env, java_net_URLConnection, defaultAllowUserInteraction, 1);
	return z0;
}

//
// public static java.lang.String getDefaultRequestProperty(java.lang.String)
//

static _jc_linenum _jc_java_net_URLConnection$linenum_table$getDefaultRequestProperty$6df05baba26c88af[];

static const unsigned char _jc_java_net_URLConnection$param_ptypes$getDefaultRequestProperty$6df05baba26c88af[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_net_URLConnection$param_types$getDefaultRequestProperty$6df05baba26c88af[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_java_net_URLConnection$method_info$getDefaultRequestProperty$6df05baba26c88af = {
	.name=			"getDefaultRequestProperty",
	.signature=		"(Ljava/lang/String;)Ljava/lang/String;",
	.class=			&_jc_java_net_URLConnection$type,
	.param_types=		&_jc_java_net_URLConnection$param_types$getDefaultRequestProperty$6df05baba26c88af,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_java_net_URLConnection$param_ptypes$getDefaultRequestProperty$6df05baba26c88af,
	.signature_hash=	_JC_JLONG(0x6df05baba26c88af),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_java_net_URLConnection$method$getDefaultRequestProperty$6df05baba26c88af,
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_net_URLConnection$linenum_table$getDefaultRequestProperty$6df05baba26c88af
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_net_URLConnection, getDefaultRequestProperty$6df05baba26c88af);

_jc_java_lang_String$object * _JC_JCNI_ATTR
_jc_java_net_URLConnection$method$getDefaultRequestProperty$6df05baba26c88af(_jc_env *const env, _jc_java_lang_String$object *param0)
{
	struct _jc_java_lang_String$object *r0;

	r0 = param0;
	_JC_LINE_NUMBER(850);				// 0
	return _JC_NULL;
}

//
// public static synchronized java.net.FileNameMap getFileNameMap()
//

static _jc_linenum _jc_java_net_URLConnection$linenum_table$getFileNameMap$028f6cf2ec1cbb3a[];

static _jc_trap_info _jc_java_net_URLConnection$trap_table$getFileNameMap$028f6cf2ec1cbb3a[] = {
	_JC_TRAP(_JC_NULL, 1, 2),
};

static const unsigned char _jc_java_net_URLConnection$param_ptypes$getFileNameMap$028f6cf2ec1cbb3a[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_java_net_URLConnection$method_info$getFileNameMap$028f6cf2ec1cbb3a = {
	.name=			"getFileNameMap",
	.signature=		"()Ljava/net/FileNameMap;",
	.class=			&_jc_java_net_URLConnection$type,
	.return_type=		&_jc_java_net_FileNameMap$type,
	.param_ptypes=		&_jc_java_net_URLConnection$param_ptypes$getFileNameMap$028f6cf2ec1cbb3a,
	.signature_hash=	_JC_JLONG(0x28f6cf2ec1cbb3a),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC|_JC_ACC_SYNCHRONIZED,
	.function=		&_jc_java_net_URLConnection$method$getFileNameMap$028f6cf2ec1cbb3a,
	.num_parameters=	0,
	.u= { .exec= {
	  .trap_table_len=	1,
	  .trap_table=		_jc_java_net_URLConnection$trap_table$getFileNameMap$028f6cf2ec1cbb3a,
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_java_net_URLConnection$linenum_table$getFileNameMap$028f6cf2ec1cbb3a
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_net_URLConnection, getFileNameMap$028f6cf2ec1cbb3a);

_jc_object * _JC_JCNI_ATTR
_jc_java_net_URLConnection$method$getFileNameMap$028f6cf2ec1cbb3a(_jc_env *const env)
{
	struct _jc_object *r0;
	struct _jc_java_net_MimeTypeMapper$object *r1;
	struct _jc_java_lang_Throwable$object *volatile r2;
	_jc_catch_frame	catch;

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_java_net_URLConnection$method_info$getFileNameMap$028f6cf2ec1cbb3a, &&label1);

	_JC_MONITOR_ENTER(env, &_jc_java_net_URLConnection$class_object);
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(929);				// 0
	r0 = _JC_STATIC_FIELD(env, java_net_URLConnection, fileNameMap, 1);
	if (r0 != _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(930);				// 1
	r1 = _JC_NEW(env, java_net_MimeTypeMapper);
	_JC_STATIC_FIELD(env, java_net_URLConnection, fileNameMap, 1) = r1;

label0:
	_JC_LINE_NUMBER(932);				// 2
	r0 = _JC_STATIC_FIELD(env, java_net_URLConnection, fileNameMap, 1);
	_JC_MONITOR_EXIT(env, &_jc_java_net_URLConnection$class_object);
	_JC_CANCEL_TRAPS(env, catch);
	return r0;

label1:
	_JC_TRAP_REGION(catch, 2);
	r2 = _JC_CAUGHT_EXCEPTION(env);
	_JC_MONITOR_EXIT(env, &_jc_java_net_URLConnection$class_object);
	_JC_THROW(env, r2);
}

//
// public static java.lang.String guessContentTypeFromName(java.lang.String)
//

static _jc_linenum _jc_java_net_URLConnection$linenum_table$guessContentTypeFromName$5f6649de8ef65c32[];

static const unsigned char _jc_java_net_URLConnection$param_ptypes$guessContentTypeFromName$5f6649de8ef65c32[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_net_URLConnection$param_types$guessContentTypeFromName$5f6649de8ef65c32[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_java_net_URLConnection$method_info$guessContentTypeFromName$5f6649de8ef65c32 = {
	.name=			"guessContentTypeFromName",
	.signature=		"(Ljava/lang/String;)Ljava/lang/String;",
	.class=			&_jc_java_net_URLConnection$type,
	.param_types=		&_jc_java_net_URLConnection$param_types$guessContentTypeFromName$5f6649de8ef65c32,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_java_net_URLConnection$param_ptypes$guessContentTypeFromName$5f6649de8ef65c32,
	.signature_hash=	_JC_JLONG(0x5f6649de8ef65c32),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_java_net_URLConnection$method$guessContentTypeFromName$5f6649de8ef65c32,
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_net_URLConnection$linenum_table$guessContentTypeFromName$5f6649de8ef65c32
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_net_URLConnection, guessContentTypeFromName$5f6649de8ef65c32);

_jc_java_lang_String$object * _JC_JCNI_ATTR
_jc_java_net_URLConnection$method$guessContentTypeFromName$5f6649de8ef65c32(_jc_env *const env, _jc_java_lang_String$object *param0)
{
	struct _jc_java_lang_String$object *r0;
	struct _jc_object *r1;
	struct _jc_java_lang_String$object *r2;
	struct _jc_java_util_Locale$object *r4;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = param0;
	_JC_LINE_NUMBER(893);				// 0
	r1 = _JC_INVOKE_STATIC(env, java_net_URLConnection, getFileNameMap$028f6cf2ec1cbb3a, 1);
	_JC_EXPLICIT_NULL_CHECK(env, r0);
	_JC_ACTIVE_USE(env, java_util_Locale);
	r4 = _JC_STATIC_FIELD(env, java_util_Locale, defaultLocale, 1);
	r2 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, toLowerCase$4602ab9e6d63210a, 0, r0, r4);
	r0 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0xb28fdf52e5805261), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_java_lang_String$object *), r2);
	return r0;
}

//
// public static java.lang.String guessContentTypeFromStream(java.io.InputStream) throws java.io.IOException
//

static _jc_linenum _jc_java_net_URLConnection$linenum_table$guessContentTypeFromStream$8b37cbf53ca7ecf8[];

static const unsigned char _jc_java_net_URLConnection$param_ptypes$guessContentTypeFromStream$8b37cbf53ca7ecf8[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_net_URLConnection$exceptions$guessContentTypeFromStream$8b37cbf53ca7ecf8[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_java_net_URLConnection$param_types$guessContentTypeFromStream$8b37cbf53ca7ecf8[] = {
	&_jc_java_io_InputStream$type
};

_jc_method _jc_java_net_URLConnection$method_info$guessContentTypeFromStream$8b37cbf53ca7ecf8 = {
	.name=			"guessContentTypeFromStream",
	.signature=		"(Ljava/io/InputStream;)Ljava/lang/String;",
	.class=			&_jc_java_net_URLConnection$type,
	.param_types=		&_jc_java_net_URLConnection$param_types$guessContentTypeFromStream$8b37cbf53ca7ecf8,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_java_net_URLConnection$param_ptypes$guessContentTypeFromStream$8b37cbf53ca7ecf8,
	.signature_hash=	_JC_JLONG(0x8b37cbf53ca7ecf8),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_java_net_URLConnection$method$guessContentTypeFromStream$8b37cbf53ca7ecf8,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_net_URLConnection$exceptions$guessContentTypeFromStream$8b37cbf53ca7ecf8,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_net_URLConnection$linenum_table$guessContentTypeFromStream$8b37cbf53ca7ecf8
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_net_URLConnection, guessContentTypeFromStream$8b37cbf53ca7ecf8);

_jc_java_lang_String$object * _JC_JCNI_ATTR
_jc_java_net_URLConnection$method$guessContentTypeFromStream$8b37cbf53ca7ecf8(_jc_env *const env, _jc_java_io_InputStream$object *param0)
{
	struct _jc_java_io_InputStream$object *r0;

	r0 = param0;
	_JC_LINE_NUMBER(915);				// 0
	return _JC_STRING(env, "application/octet-stream");
}

//
// private static final synchronized void initializeDateFormats()
//

static _jc_linenum _jc_java_net_URLConnection$linenum_table$initializeDateFormats$f9ce84a1f1f6dd6d[];

static _jc_trap_info _jc_java_net_URLConnection$trap_table$initializeDateFormats$f9ce84a1f1f6dd6d[] = {
	_JC_TRAP(_JC_NULL, 1, 2),
};

static const unsigned char _jc_java_net_URLConnection$param_ptypes$initializeDateFormats$f9ce84a1f1f6dd6d[] = { 
_JC_TYPE_VOID };

_jc_method _jc_java_net_URLConnection$method_info$initializeDateFormats$f9ce84a1f1f6dd6d = {
	.name=			"initializeDateFormats",
	.signature=		"()V",
	.class=			&_jc_java_net_URLConnection$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_net_URLConnection$param_ptypes$initializeDateFormats$f9ce84a1f1f6dd6d,
	.signature_hash=	_JC_JLONG(0xf9ce84a1f1f6dd6d),
	.access_flags=		_JC_ACC_PRIVATE|_JC_ACC_STATIC|_JC_ACC_FINAL|_JC_ACC_SYNCHRONIZED,
	.function=		&_jc_java_net_URLConnection$method$initializeDateFormats$f9ce84a1f1f6dd6d,
	.num_parameters=	0,
	.u= { .exec= {
	  .trap_table_len=	1,
	  .trap_table=		_jc_java_net_URLConnection$trap_table$initializeDateFormats$f9ce84a1f1f6dd6d,
	  .u= {
	    .linenum= {
	      .len=	9,
	      .table=	_jc_java_net_URLConnection$linenum_table$initializeDateFormats$f9ce84a1f1f6dd6d
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_net_URLConnection, initializeDateFormats$f9ce84a1f1f6dd6d);

void _JC_JCNI_ATTR
_jc_java_net_URLConnection$method$initializeDateFormats$f9ce84a1f1f6dd6d(_jc_env *const env)
{
	struct _jc_java_lang_Throwable$object *volatile exception;
	struct _jc_java_util_Locale$object *r0;
	_jc_object_array *r2;
	struct _jc_java_text_SimpleDateFormat$object *r4;
	jboolean z0;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_java_net_URLConnection$method_info$initializeDateFormats$f9ce84a1f1f6dd6d, &&label1);

	_JC_MONITOR_ENTER(env, &_jc_java_net_URLConnection$class_object);
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(1009);				// 0
	z0 = _JC_STATIC_FIELD(env, java_net_URLConnection, dateformats__5finitialized, 1);
	if (z0 == 0)
		goto label0;
	_JC_MONITOR_EXIT(env, &_jc_java_net_URLConnection$class_object);
	_JC_LINE_NUMBER(1010);				// 1
	_JC_CANCEL_TRAPS(env, catch);
	return;

label0:
	_JC_LINE_NUMBER(1012);				// 2
	r0 = _JC_NEW(env, java_util_Locale);
	_JC_INVOKE_NONVIRTUAL(env, java_util_Locale, _init$ab068ddc672b930e, 0, r0, _JC_STRING(env, "En"), _JC_STRING(env, "Us"), _JC_STRING(env, "Unix"));
	_JC_LINE_NUMBER(1013);				// 3
	r2 = _JC_NEW_REF_ARRAY(env, java_text_SimpleDateFormat, 1, 3);
	_JC_STATIC_FIELD(env, java_net_URLConnection, dateFormats, 1) = r2;
	_JC_LINE_NUMBER(1014);				// 4
	r2 = _JC_STATIC_FIELD(env, java_net_URLConnection, dateFormats, 1);
	r4 = _JC_NEW(env, java_text_SimpleDateFormat);
	_JC_INVOKE_NONVIRTUAL(env, java_text_SimpleDateFormat, _init$cc9f9d14d2541299, 0, r4, _JC_STRING(env, "EEE, dd MMM yyyy hh:mm:ss 'GMT'"), r0);
	_JC_ARRAYSTORE_CHECK(env, r2, r4);
	_JC_REF_ELEMENT(env, r2, 0, 0, 0) = r4;
	_JC_LINE_NUMBER(1016);				// 5
	r2 = _JC_STATIC_FIELD(env, java_net_URLConnection, dateFormats, 1);
	r4 = _JC_NEW(env, java_text_SimpleDateFormat);
	_JC_INVOKE_NONVIRTUAL(env, java_text_SimpleDateFormat, _init$cc9f9d14d2541299, 0, r4, _JC_STRING(env, "EEEE, dd-MMM-yy hh:mm:ss 'GMT'"), r0);
	_JC_ARRAYSTORE_CHECK(env, r2, r4);
	_JC_REF_ELEMENT(env, r2, 1, 0, 0) = r4;
	_JC_LINE_NUMBER(1018);				// 6
	r2 = _JC_STATIC_FIELD(env, java_net_URLConnection, dateFormats, 1);
	r4 = _JC_NEW(env, java_text_SimpleDateFormat);
	_JC_INVOKE_NONVIRTUAL(env, java_text_SimpleDateFormat, _init$cc9f9d14d2541299, 0, r4, _JC_STRING(env, "EEE MMM d hh:mm:ss yyyy"), r0);
	_JC_ARRAYSTORE_CHECK(env, r2, r4);
	_JC_REF_ELEMENT(env, r2, 2, 0, 0) = r4;
	_JC_LINE_NUMBER(1019);				// 7
	_JC_STATIC_FIELD(env, java_net_URLConnection, dateformats__5finitialized, 1) = 1;
	_JC_MONITOR_EXIT(env, &_jc_java_net_URLConnection$class_object);
	_JC_LINE_NUMBER(1020);				// 8
	_JC_CANCEL_TRAPS(env, catch);
	return;

label1:
	_JC_TRAP_REGION(catch, 2);
	exception = _JC_CAUGHT_EXCEPTION(env);
	_JC_MONITOR_EXIT(env, &_jc_java_net_URLConnection$class_object);
	_JC_THROW(env, exception);
}

//
// public static synchronized void setContentHandlerFactory(java.net.ContentHandlerFactory)
//

static _jc_linenum _jc_java_net_URLConnection$linenum_table$setContentHandlerFactory$dea1706b9cedd905[];

static _jc_trap_info _jc_java_net_URLConnection$trap_table$setContentHandlerFactory$dea1706b9cedd905[] = {
	_JC_TRAP(_JC_NULL, 1, 2),
};

static const unsigned char _jc_java_net_URLConnection$param_ptypes$setContentHandlerFactory$dea1706b9cedd905[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_net_URLConnection$param_types$setContentHandlerFactory$dea1706b9cedd905[] = {
	&_jc_java_net_ContentHandlerFactory$type
};

_jc_method _jc_java_net_URLConnection$method_info$setContentHandlerFactory$dea1706b9cedd905 = {
	.name=			"setContentHandlerFactory",
	.signature=		"(Ljava/net/ContentHandlerFactory;)V",
	.class=			&_jc_java_net_URLConnection$type,
	.param_types=		&_jc_java_net_URLConnection$param_types$setContentHandlerFactory$dea1706b9cedd905,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_net_URLConnection$param_ptypes$setContentHandlerFactory$dea1706b9cedd905,
	.signature_hash=	_JC_JLONG(0xdea1706b9cedd905),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC|_JC_ACC_SYNCHRONIZED,
	.function=		&_jc_java_net_URLConnection$method$setContentHandlerFactory$dea1706b9cedd905,
	.num_parameters=	1,
	.u= { .exec= {
	  .trap_table_len=	1,
	  .trap_table=		_jc_java_net_URLConnection$trap_table$setContentHandlerFactory$dea1706b9cedd905,
	  .u= {
	    .linenum= {
	      .len=	7,
	      .table=	_jc_java_net_URLConnection$linenum_table$setContentHandlerFactory$dea1706b9cedd905
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_net_URLConnection, setContentHandlerFactory$dea1706b9cedd905);

void _JC_JCNI_ATTR
_jc_java_net_URLConnection$method$setContentHandlerFactory$dea1706b9cedd905(_jc_env *const env, _jc_object *param0)
{
	struct _jc_object *r0;
	struct _jc_object *r1;
	struct _jc_java_lang_Error$object *r2;
	struct _jc_java_lang_Throwable$object *volatile r3;
	struct _jc_java_lang_String$object *r4;
	struct _jc_java_lang_SecurityManager$object *r5;
	struct _jc_java_lang_VMThrowable$object *r7;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_java_net_URLConnection$method_info$setContentHandlerFactory$dea1706b9cedd905, &&label2);

	_JC_MONITOR_ENTER(env, &_jc_java_net_URLConnection$class_object);
	_JC_TRAP_REGION(catch, 1);
	r0 = param0;
	_JC_LINE_NUMBER(867);				// 0
	r1 = _JC_STATIC_FIELD(env, java_net_URLConnection, factory, 1);
	if (r1 == _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(868);				// 1
	r2 = _JC_NEW(env, java_lang_Error);
	r4 = _JC_STRING(env, "ContentHandlerFactory already set");
	_JC_REF_FIELD(env, r2, java_lang_Throwable, cause) = r2;
	r7 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r2);
	_JC_REF_FIELD(env, r2, java_lang_Throwable, vmState) = r7;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, detailMessage) = r4;
	_JC_THROW(env, r2);

label0:
	_JC_ACTIVE_USE(env, java_lang_System);
	_JC_LINE_NUMBER(872);				// 2
	r5 = _JC_STATIC_FIELD(env, java_lang_SecurityManager, current, 0);
	_JC_LINE_NUMBER(873);				// 3
	if (r5 == _JC_NULL)
		goto label1;
	_JC_LINE_NUMBER(874);				// 4
	_JC_INVOKE_VIRTUAL(env, java_lang_SecurityManager, checkSetFactory$2331a9a460e876c1, r5);

label1:
	_JC_LINE_NUMBER(876);				// 5
	_JC_STATIC_FIELD(env, java_net_URLConnection, factory, 1) = r0;
	_JC_MONITOR_EXIT(env, &_jc_java_net_URLConnection$class_object);
	_JC_LINE_NUMBER(877);				// 6
	_JC_CANCEL_TRAPS(env, catch);
	return;

label2:
	_JC_TRAP_REGION(catch, 2);
	r3 = _JC_CAUGHT_EXCEPTION(env);
	_JC_MONITOR_EXIT(env, &_jc_java_net_URLConnection$class_object);
	_JC_THROW(env, r3);
}

//
// public static void setDefaultAllowUserInteraction(boolean)
//

static _jc_linenum _jc_java_net_URLConnection$linenum_table$setDefaultAllowUserInteraction$3984118f13e737a3[];

static const unsigned char _jc_java_net_URLConnection$param_ptypes$setDefaultAllowUserInteraction$3984118f13e737a3[] = { 
_JC_TYPE_BOOLEAN, _JC_TYPE_VOID };

static _jc_type *const _jc_java_net_URLConnection$param_types$setDefaultAllowUserInteraction$3984118f13e737a3[] = {
	&_jc_boolean$prim$type
};

_jc_method _jc_java_net_URLConnection$method_info$setDefaultAllowUserInteraction$3984118f13e737a3 = {
	.name=			"setDefaultAllowUserInteraction",
	.signature=		"(Z)V",
	.class=			&_jc_java_net_URLConnection$type,
	.param_types=		&_jc_java_net_URLConnection$param_types$setDefaultAllowUserInteraction$3984118f13e737a3,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_net_URLConnection$param_ptypes$setDefaultAllowUserInteraction$3984118f13e737a3,
	.signature_hash=	_JC_JLONG(0x3984118f13e737a3),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_java_net_URLConnection$method$setDefaultAllowUserInteraction$3984118f13e737a3,
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_net_URLConnection$linenum_table$setDefaultAllowUserInteraction$3984118f13e737a3
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_net_URLConnection, setDefaultAllowUserInteraction$3984118f13e737a3);

void _JC_JCNI_ATTR
_jc_java_net_URLConnection$method$setDefaultAllowUserInteraction$3984118f13e737a3(_jc_env *const env, jboolean param0)
{
	jboolean z0;

	z0 = param0;
	_JC_LINE_NUMBER(624);				// 0
	_JC_STATIC_FIELD(env, java_net_URLConnection, defaultAllowUserInteraction, 1) = z0;
	_JC_LINE_NUMBER(625);				// 1
	return;
}

//
// public static void setDefaultRequestProperty(java.lang.String, java.lang.String)
//

static _jc_linenum _jc_java_net_URLConnection$linenum_table$setDefaultRequestProperty$93bdfc8df2f7a854[];

static const unsigned char _jc_java_net_URLConnection$param_ptypes$setDefaultRequestProperty$93bdfc8df2f7a854[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_net_URLConnection$param_types$setDefaultRequestProperty$93bdfc8df2f7a854[] = {
	&_jc_java_lang_String$type,
	&_jc_java_lang_String$type
};

_jc_method _jc_java_net_URLConnection$method_info$setDefaultRequestProperty$93bdfc8df2f7a854 = {
	.name=			"setDefaultRequestProperty",
	.signature=		"(Ljava/lang/String;Ljava/lang/String;)V",
	.class=			&_jc_java_net_URLConnection$type,
	.param_types=		&_jc_java_net_URLConnection$param_types$setDefaultRequestProperty$93bdfc8df2f7a854,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_net_URLConnection$param_ptypes$setDefaultRequestProperty$93bdfc8df2f7a854,
	.signature_hash=	_JC_JLONG(0x93bdfc8df2f7a854),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_java_net_URLConnection$method$setDefaultRequestProperty$93bdfc8df2f7a854,
	.num_parameters=	2,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_net_URLConnection$linenum_table$setDefaultRequestProperty$93bdfc8df2f7a854
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_net_URLConnection, setDefaultRequestProperty$93bdfc8df2f7a854);

void _JC_JCNI_ATTR
_jc_java_net_URLConnection$method$setDefaultRequestProperty$93bdfc8df2f7a854(_jc_env *const env, _jc_java_lang_String$object *param0, _jc_java_lang_String$object *param1)
{
	struct _jc_java_lang_String$object *r0;
	struct _jc_java_lang_String$object *r1;

	r0 = param0;
	r1 = param1;
	_JC_LINE_NUMBER(831);				// 0
	return;
}

//
// public static synchronized void setFileNameMap(java.net.FileNameMap)
//

static _jc_linenum _jc_java_net_URLConnection$linenum_table$setFileNameMap$91991f3395343483[];

static _jc_trap_info _jc_java_net_URLConnection$trap_table$setFileNameMap$91991f3395343483[] = {
	_JC_TRAP(_JC_NULL, 1, 2),
};

static const unsigned char _jc_java_net_URLConnection$param_ptypes$setFileNameMap$91991f3395343483[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_net_URLConnection$param_types$setFileNameMap$91991f3395343483[] = {
	&_jc_java_net_FileNameMap$type
};

_jc_method _jc_java_net_URLConnection$method_info$setFileNameMap$91991f3395343483 = {
	.name=			"setFileNameMap",
	.signature=		"(Ljava/net/FileNameMap;)V",
	.class=			&_jc_java_net_URLConnection$type,
	.param_types=		&_jc_java_net_URLConnection$param_types$setFileNameMap$91991f3395343483,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_net_URLConnection$param_ptypes$setFileNameMap$91991f3395343483,
	.signature_hash=	_JC_JLONG(0x91991f3395343483),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC|_JC_ACC_SYNCHRONIZED,
	.function=		&_jc_java_net_URLConnection$method$setFileNameMap$91991f3395343483,
	.num_parameters=	1,
	.u= { .exec= {
	  .trap_table_len=	1,
	  .trap_table=		_jc_java_net_URLConnection$trap_table$setFileNameMap$91991f3395343483,
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_java_net_URLConnection$linenum_table$setFileNameMap$91991f3395343483
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_net_URLConnection, setFileNameMap$91991f3395343483);

void _JC_JCNI_ATTR
_jc_java_net_URLConnection$method$setFileNameMap$91991f3395343483(_jc_env *const env, _jc_object *param0)
{
	struct _jc_object *r0;
	struct _jc_java_lang_Throwable$object *volatile r2;
	struct _jc_java_lang_SecurityManager$object *r3;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_java_net_URLConnection$method_info$setFileNameMap$91991f3395343483, &&label1);

	_JC_MONITOR_ENTER(env, &_jc_java_net_URLConnection$class_object);
	_JC_TRAP_REGION(catch, 1);
	r0 = param0;
	_JC_ACTIVE_USE(env, java_lang_System);
	_JC_LINE_NUMBER(950);				// 0
	r3 = _JC_STATIC_FIELD(env, java_lang_SecurityManager, current, 0);
	_JC_LINE_NUMBER(951);				// 1
	if (r3 == _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(952);				// 2
	_JC_INVOKE_VIRTUAL(env, java_lang_SecurityManager, checkSetFactory$2331a9a460e876c1, r3);

label0:
	_JC_LINE_NUMBER(954);				// 3
	_JC_STATIC_FIELD(env, java_net_URLConnection, fileNameMap, 1) = r0;
	_JC_MONITOR_EXIT(env, &_jc_java_net_URLConnection$class_object);
	_JC_LINE_NUMBER(955);				// 4
	_JC_CANCEL_TRAPS(env, catch);
	return;

label1:
	_JC_TRAP_REGION(catch, 2);
	r2 = _JC_CAUGHT_EXCEPTION(env);
	_JC_MONITOR_EXIT(env, &_jc_java_net_URLConnection$class_object);
	_JC_THROW(env, r2);
}

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// protected void <init>(java.net.URL)
//

static _jc_linenum _jc_java_net_URLConnection$linenum_table$_init$52b89ab562ab928f[];

static const unsigned char _jc_java_net_URLConnection$param_ptypes$_init$52b89ab562ab928f[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_net_URLConnection$param_types$_init$52b89ab562ab928f[] = {
	&_jc_java_net_URL$type
};

_jc_method _jc_java_net_URLConnection$method_info$_init$52b89ab562ab928f = {
	.name=			"<init>",
	.signature=		"(Ljava/net/URL;)V",
	.class=			&_jc_java_net_URLConnection$type,
	.param_types=		&_jc_java_net_URLConnection$param_types$_init$52b89ab562ab928f,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_net_URLConnection$param_ptypes$_init$52b89ab562ab928f,
	.signature_hash=	_JC_JLONG(0x52b89ab562ab928f),
	.access_flags=		_JC_ACC_PROTECTED,
	.function=		&_jc_java_net_URLConnection$method$_init$52b89ab562ab928f,
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_java_net_URLConnection$linenum_table$_init$52b89ab562ab928f
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_net_URLConnection, _init$52b89ab562ab928f);

void _JC_JCNI_ATTR
_jc_java_net_URLConnection$method$_init$52b89ab562ab928f(_jc_env *const env, _jc_java_net_URLConnection$object *this, _jc_java_net_URL$object *param0)
{
	struct _jc_java_net_URLConnection$object *r0;
	struct _jc_java_net_URL$object *r1;
	jboolean z0;

	r0 = this;
	r1 = param0;
	_JC_PRIM_FIELD(env, r0, java_net_URLConnection, doInput) = 1;
	_JC_LINE_NUMBER(180);				// 0
	_JC_REF_FIELD(env, r0, java_net_URLConnection, url) = r1;
	_JC_LINE_NUMBER(181);				// 1
	z0 = _JC_STATIC_FIELD(env, java_net_URLConnection, defaultAllowUserInteraction, 1);
	_JC_PRIM_FIELD(env, r0, java_net_URLConnection, allowUserInteraction) = z0;
	_JC_LINE_NUMBER(182);				// 2
	z0 = _JC_STATIC_FIELD(env, java_net_URLConnection, defaultUseCaches, 1);
	_JC_PRIM_FIELD(env, r0, java_net_URLConnection, useCaches) = z0;
	_JC_LINE_NUMBER(183);				// 3
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public void addRequestProperty(java.lang.String, java.lang.String)
//

static _jc_linenum _jc_java_net_URLConnection$linenum_table$addRequestProperty$d3f7aaf26425e5e6[];

static const unsigned char _jc_java_net_URLConnection$param_ptypes$addRequestProperty$d3f7aaf26425e5e6[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_net_URLConnection$param_types$addRequestProperty$d3f7aaf26425e5e6[] = {
	&_jc_java_lang_String$type,
	&_jc_java_lang_String$type
};

_jc_method _jc_java_net_URLConnection$method_info$addRequestProperty$d3f7aaf26425e5e6 = {
	.name=			"addRequestProperty",
	.signature=		"(Ljava/lang/String;Ljava/lang/String;)V",
	.class=			&_jc_java_net_URLConnection$type,
	.param_types=		&_jc_java_net_URLConnection$param_types$addRequestProperty$d3f7aaf26425e5e6,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_net_URLConnection$param_ptypes$addRequestProperty$d3f7aaf26425e5e6,
	.signature_hash=	_JC_JLONG(0xd3f7aaf26425e5e6),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_net_URLConnection$method$addRequestProperty$d3f7aaf26425e5e6,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_net_URLConnection$vtable, java_net_URLConnection.addRequestProperty$d3f7aaf26425e5e6) / sizeof(void *),
	.num_parameters=	2,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_java_net_URLConnection$linenum_table$addRequestProperty$d3f7aaf26425e5e6
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_net_URLConnection, addRequestProperty$d3f7aaf26425e5e6);

void _JC_JCNI_ATTR
_jc_java_net_URLConnection$method$addRequestProperty$d3f7aaf26425e5e6(_jc_env *const env, _jc_java_net_URLConnection$object *this, _jc_java_lang_String$object *param0, _jc_java_lang_String$object *param1)
{
	struct _jc_java_net_URLConnection$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_java_lang_String$object *r2;
	struct _jc_java_lang_IllegalStateException$object *r3;
	struct _jc_java_lang_NullPointerException$object *r4;
	struct _jc_java_lang_String$object *r5;
	struct _jc_java_lang_String$object *r6;
	struct _jc_java_lang_VMThrowable$object *r7;
	struct _jc_java_lang_VMThrowable$object *r9;
	jboolean z0;

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_LINE_NUMBER(764);				// 0
	z0 = _JC_PRIM_FIELD(env, r0, java_net_URLConnection, connected);
	if (z0 == 0)
		goto label0;
	_JC_LINE_NUMBER(765);				// 1
	r3 = _JC_NEW(env, java_lang_IllegalStateException);
	r5 = _JC_STRING(env, "Already connected");
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r7 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r7;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r5;
	_JC_THROW(env, r3);

label0:
	_JC_LINE_NUMBER(767);				// 2
	if (r1 != _JC_NULL)
		goto label1;
	_JC_LINE_NUMBER(768);				// 3
	r4 = _JC_NEW(env, java_lang_NullPointerException);
	r6 = _JC_STRING(env, "key is null");
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r9 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r9;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r6;
	_JC_THROW(env, r4);

label1:
	_JC_LINE_NUMBER(772);				// 4
	return;
}

//
// public abstract void connect() throws java.io.IOException
//

static const unsigned char _jc_java_net_URLConnection$param_ptypes$connect$47946c90596538d1[] = { 
_JC_TYPE_VOID };

static _jc_type *const _jc_java_net_URLConnection$exceptions$connect$47946c90596538d1[] = {
	&_jc_java_io_IOException$type
};

_jc_method _jc_java_net_URLConnection$method_info$connect$47946c90596538d1 = {
	.name=			"connect",
	.signature=		"()V",
	.class=			&_jc_java_net_URLConnection$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_net_URLConnection$param_ptypes$connect$47946c90596538d1,
	.signature_hash=	_JC_JLONG(0x47946c90596538d1),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.function=		&_jc_java_net_URLConnection$method$connect$47946c90596538d1,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_net_URLConnection$vtable, java_net_URLConnection.connect$47946c90596538d1) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_net_URLConnection$exceptions$connect$47946c90596538d1,
};

void _JC_JCNI_ATTR
_jc_java_net_URLConnection$method$connect$47946c90596538d1(_jc_env *const env, _jc_java_net_URLConnection$object *this)
{
	_JC_ABSTRACT_METHOD(env, &_jc_java_net_URLConnection$method_info$connect$47946c90596538d1);
}

//
// public boolean getAllowUserInteraction()
//

static _jc_linenum _jc_java_net_URLConnection$linenum_table$getAllowUserInteraction$23c7ca0bdbf1bb02[];

static const unsigned char _jc_java_net_URLConnection$param_ptypes$getAllowUserInteraction$23c7ca0bdbf1bb02[] = { 
_JC_TYPE_BOOLEAN };

_jc_method _jc_java_net_URLConnection$method_info$getAllowUserInteraction$23c7ca0bdbf1bb02 = {
	.name=			"getAllowUserInteraction",
	.signature=		"()Z",
	.class=			&_jc_java_net_URLConnection$type,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_java_net_URLConnection$param_ptypes$getAllowUserInteraction$23c7ca0bdbf1bb02,
	.signature_hash=	_JC_JLONG(0x23c7ca0bdbf1bb02),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_net_URLConnection$method$getAllowUserInteraction$23c7ca0bdbf1bb02,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_net_URLConnection$vtable, java_net_URLConnection.getAllowUserInteraction$23c7ca0bdbf1bb02) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_net_URLConnection$linenum_table$getAllowUserInteraction$23c7ca0bdbf1bb02
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_net_URLConnection, getAllowUserInteraction$23c7ca0bdbf1bb02);

jboolean _JC_JCNI_ATTR
_jc_java_net_URLConnection$method$getAllowUserInteraction$23c7ca0bdbf1bb02(_jc_env *const env, _jc_java_net_URLConnection$object *this)
{
	struct _jc_java_net_URLConnection$object *r0;
	jboolean z0;

	r0 = this;
	_JC_LINE_NUMBER(613);				// 0
	z0 = _JC_PRIM_FIELD(env, r0, java_net_URLConnection, allowUserInteraction);
	return z0;
}

//
// public java.lang.Object getContent() throws java.io.IOException
//

static _jc_linenum _jc_java_net_URLConnection$linenum_table$getContent$3271597a0076ff68[];

static const unsigned char _jc_java_net_URLConnection$param_ptypes$getContent$3271597a0076ff68[] = { 
_JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_net_URLConnection$exceptions$getContent$3271597a0076ff68[] = {
	&_jc_java_io_IOException$type
};

_jc_method _jc_java_net_URLConnection$method_info$getContent$3271597a0076ff68 = {
	.name=			"getContent",
	.signature=		"()Ljava/lang/Object;",
	.class=			&_jc_java_net_URLConnection$type,
	.return_type=		&_jc_java_lang_Object$type,
	.param_ptypes=		&_jc_java_net_URLConnection$param_ptypes$getContent$3271597a0076ff68,
	.signature_hash=	_JC_JLONG(0x3271597a0076ff68),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_net_URLConnection$method$getContent$3271597a0076ff68,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_net_URLConnection$vtable, java_net_URLConnection.getContent$3271597a0076ff68) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_net_URLConnection$exceptions$getContent$3271597a0076ff68,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	7,
	      .table=	_jc_java_net_URLConnection$linenum_table$getContent$3271597a0076ff68
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_net_URLConnection, getContent$3271597a0076ff68);

_jc_java_lang_Object$object * _JC_JCNI_ATTR
_jc_java_net_URLConnection$method$getContent$3271597a0076ff68(_jc_env *const env, _jc_java_net_URLConnection$object *this)
{
	struct _jc_java_net_URLConnection$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_java_net_ContentHandler$object *r2;
	struct _jc_java_lang_Object$object *r3;
	struct _jc_java_io_InputStream$object *r4;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(434);				// 0
	z0 = _JC_PRIM_FIELD(env, r0, java_net_URLConnection, connected);
	if (z0 != 0)
		goto label0;
	_JC_LINE_NUMBER(435);				// 1
	_JC_INVOKE_VIRTUAL(env, java_net_URLConnection, connect$47946c90596538d1, r0);

label0:
	_JC_LINE_NUMBER(441);				// 2
	r1 = _JC_INVOKE_VIRTUAL(env, java_net_URLConnection, getContentType$c8e5b99f03eb0f46, r0);
	_JC_LINE_NUMBER(442);				// 3
	r2 = _JC_INVOKE_NONVIRTUAL(env, java_net_URLConnection, getContentHandler$1db852928223c7a8, 0, r0, r1);
	_JC_LINE_NUMBER(444);				// 4
	if (r2 == _JC_NULL)
		goto label1;
	_JC_LINE_NUMBER(445);				// 5
	r3 = _JC_INVOKE_VIRTUAL(env, java_net_ContentHandler, getContent$677478719bf4670d, r2, r0);
	return r3;

label1:
	_JC_LINE_NUMBER(447);				// 6
	r4 = _JC_INVOKE_VIRTUAL(env, java_net_URLConnection, getInputStream$13cf75a12cabb343, r0);
	return r4;
}

//
// public java.lang.Object getContent(java.lang.Class[]) throws java.io.IOException
//

static _jc_linenum _jc_java_net_URLConnection$linenum_table$getContent$7409d222b348f073[];

static const unsigned char _jc_java_net_URLConnection$param_ptypes$getContent$7409d222b348f073[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_net_URLConnection$exceptions$getContent$7409d222b348f073[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_java_net_URLConnection$param_types$getContent$7409d222b348f073[] = {
	&_jc_java_lang_Class$array$type
};

_jc_method _jc_java_net_URLConnection$method_info$getContent$7409d222b348f073 = {
	.name=			"getContent",
	.signature=		"([Ljava/lang/Class;)Ljava/lang/Object;",
	.class=			&_jc_java_net_URLConnection$type,
	.param_types=		&_jc_java_net_URLConnection$param_types$getContent$7409d222b348f073,
	.return_type=		&_jc_java_lang_Object$type,
	.param_ptypes=		&_jc_java_net_URLConnection$param_ptypes$getContent$7409d222b348f073,
	.signature_hash=	_JC_JLONG(0x7409d222b348f073),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_net_URLConnection$method$getContent$7409d222b348f073,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_net_URLConnection$vtable, java_net_URLConnection.getContent$7409d222b348f073) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_net_URLConnection$exceptions$getContent$7409d222b348f073,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_net_URLConnection$linenum_table$getContent$7409d222b348f073
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_net_URLConnection, getContent$7409d222b348f073);

_jc_java_lang_Object$object * _JC_JCNI_ATTR
_jc_java_net_URLConnection$method$getContent$7409d222b348f073(_jc_env *const env, _jc_java_net_URLConnection$object *this, _jc_object_array *param0)
{
	struct _jc_java_net_URLConnection$object *r0;
	_jc_object_array *r1;
	struct _jc_java_lang_Object$object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(464);				// 0
	r2 = _JC_INVOKE_VIRTUAL(env, java_net_URLConnection, getContent$3271597a0076ff68, r0);
	return r2;
}

//
// public java.lang.String getContentEncoding()
//

static _jc_linenum _jc_java_net_URLConnection$linenum_table$getContentEncoding$8906dbb8a85e91ee[];

static const unsigned char _jc_java_net_URLConnection$param_ptypes$getContentEncoding$8906dbb8a85e91ee[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_java_net_URLConnection$method_info$getContentEncoding$8906dbb8a85e91ee = {
	.name=			"getContentEncoding",
	.signature=		"()Ljava/lang/String;",
	.class=			&_jc_java_net_URLConnection$type,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_java_net_URLConnection$param_ptypes$getContentEncoding$8906dbb8a85e91ee,
	.signature_hash=	_JC_JLONG(0x8906dbb8a85e91ee),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_net_URLConnection$method$getContentEncoding$8906dbb8a85e91ee,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_net_URLConnection$vtable, java_net_URLConnection.getContentEncoding$8906dbb8a85e91ee) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_net_URLConnection$linenum_table$getContentEncoding$8906dbb8a85e91ee
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_net_URLConnection, getContentEncoding$8906dbb8a85e91ee);

_jc_java_lang_String$object * _JC_JCNI_ATTR
_jc_java_net_URLConnection$method$getContentEncoding$8906dbb8a85e91ee(_jc_env *const env, _jc_java_net_URLConnection$object *this)
{
	struct _jc_java_net_URLConnection$object *r0;
	struct _jc_java_lang_String$object *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(237);				// 0
	r1 = _JC_INVOKE_VIRTUAL(env, java_net_URLConnection, getHeaderField$0a5e9452a9a469b9, r0, _JC_STRING(env, "content-encoding"));
	return r1;
}

//
// private final java.net.ContentHandler getContentHandler(java.lang.String)
//

static _jc_linenum _jc_java_net_URLConnection$linenum_table$getContentHandler$1db852928223c7a8[];

static _jc_trap_info _jc_java_net_URLConnection$trap_table$getContentHandler$1db852928223c7a8[] = {
	_JC_TRAP(&_jc_java_lang_ClassNotFoundException$type, 1, 2),
	_JC_TRAP(&_jc_java_lang_InstantiationException$type, 1, 2),
	_JC_TRAP(&_jc_java_lang_IllegalAccessException$type, 1, 2),
};

static const unsigned char _jc_java_net_URLConnection$param_ptypes$getContentHandler$1db852928223c7a8[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_net_URLConnection$param_types$getContentHandler$1db852928223c7a8[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_java_net_URLConnection$method_info$getContentHandler$1db852928223c7a8 = {
	.name=			"getContentHandler",
	.signature=		"(Ljava/lang/String;)Ljava/net/ContentHandler;",
	.class=			&_jc_java_net_URLConnection$type,
	.param_types=		&_jc_java_net_URLConnection$param_types$getContentHandler$1db852928223c7a8,
	.return_type=		&_jc_java_net_ContentHandler$type,
	.param_ptypes=		&_jc_java_net_URLConnection$param_ptypes$getContentHandler$1db852928223c7a8,
	.signature_hash=	_JC_JLONG(0x1db852928223c7a8),
	.access_flags=		_JC_ACC_PRIVATE|_JC_ACC_FINAL,
	.function=		&_jc_java_net_URLConnection$method$getContentHandler$1db852928223c7a8,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_net_URLConnection$vtable, java_net_URLConnection.getContentHandler$1db852928223c7a8) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .trap_table_len=	3,
	  .trap_table=		_jc_java_net_URLConnection$trap_table$getContentHandler$1db852928223c7a8,
	  .u= {
	    .linenum= {
	      .len=	16,
	      .table=	_jc_java_net_URLConnection$linenum_table$getContentHandler$1db852928223c7a8
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_net_URLConnection, getContentHandler$1db852928223c7a8);

_jc_java_net_ContentHandler$object * _JC_JCNI_ATTR
_jc_java_net_URLConnection$method$getContentHandler$1db852928223c7a8(_jc_env *const env, _jc_java_net_URLConnection$object *this, _jc_java_lang_String$object *param0)
{
	jint i0;
	jint i1;
	struct _jc_java_net_URLConnection$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_java_lang_String$object *r10;
	struct _jc_java_lang_String$object *r11;
	_jc_char_array *r12;
	struct _jc_java_net_ContentHandler$object *volatile r2;
	struct _jc_java_lang_Class$object *r3;
	struct _jc_java_lang_Object$object *r4;
	struct _jc_object *r5;
	struct _jc_java_lang_StringBuffer$object *r6;
	struct _jc_java_lang_ClassNotFoundException$object *r7;
	struct _jc_java_lang_InstantiationException$object *r8;
	struct _jc_java_lang_IllegalAccessException$object *r9;
	jboolean z0;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_java_net_URLConnection$method_info$getContentHandler$1db852928223c7a8, &&label4, &&label5, &&label6);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(960);				// 0
	if (r1 == _JC_NULL)
		goto label0;
	z0 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, equals$8a15e0625571c581, 0, r1, _JC_STRING(env, ""));
	if (z0 == 0)
		goto label1;

label0:
	_JC_LINE_NUMBER(961);				// 1
	_JC_CANCEL_TRAPS(env, catch);
	return _JC_NULL;

label1:
	_JC_LINE_NUMBER(963);				// 2
	r2 = _JC_NULL;
	_JC_LINE_NUMBER(966);				// 3
	r5 = _JC_STATIC_FIELD(env, java_net_URLConnection, factory, 1);
	if (r5 == _JC_NULL)
		goto label2;
	_JC_LINE_NUMBER(967);				// 4
	r5 = _JC_STATIC_FIELD(env, java_net_URLConnection, factory, 1);
	r2 = _JC_INVOKE_INTERFACE(env, r5, _JC_JLONG(0x5220f97ad4fd572b), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_java_lang_String$object *), r1);

label2:
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(972);				// 5
	r1 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, replace$3c3a4c257e28ba4a, 0, r1, 47, 46);
	i0 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, indexOf$6ec5a1241e692e35, 0, r1, 59, 0);
	_JC_LINE_NUMBER(976);				// 6
	if (i0 < 1)
		goto label3;
	_JC_LINE_NUMBER(977);				// 7
	r1 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, substring$df0d95f5ebfea7dc, 0, r1, 0, i0);

label3:
	_JC_LINE_NUMBER(979);				// 8
	r6 = _JC_NEW(env, java_lang_StringBuffer);
	r11 = _JC_STRING(env, "gnu.java.net.content.");
	i1 = _JC_PRIM_FIELD(env, r11, java_lang_String, count);
	_JC_PRIM_FIELD(env, r6, java_lang_StringBuffer, count) = i1;
	i1 = _JC_PRIM_FIELD(env, r6, java_lang_StringBuffer, count);
	i1 = i1 + 16;
	r12 = _JC_NEW_PRIM_ARRAY(env, char, 1, i1);
	_JC_REF_FIELD(env, r6, java_lang_StringBuffer, value) = r12;
	i1 = _JC_PRIM_FIELD(env, r6, java_lang_StringBuffer, count);
	r12 = _JC_REF_FIELD(env, r6, java_lang_StringBuffer, value);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, getChars$c684dea7317ff063, 0, r11, 0, i1, r12, 0);
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r6, r1);
	r10 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r10, r6);
	r3 = _JC_INVOKE_STATIC(env, java_lang_Class, forName$d3b57db3b6a905a3, 1, r10);
	_JC_LINE_NUMBER(980);				// 9
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_Class, newInstance$548f1ab1530c9482, 1, r3);
	_JC_LINE_NUMBER(982);				// 10
	z0 = _JC_INSTANCEOF(env, r4, &_jc_java_net_ContentHandler$type);
	if (z0 == 0)
		goto label7;
	_JC_LINE_NUMBER(984);				// 11
	r2 = r4;
	_JC_TRAP_REGION(catch, 2);
	_JC_LINE_NUMBER(985);				// 12
	_JC_CANCEL_TRAPS(env, catch);
	return r2;

label4:
	_JC_TRAP_REGION(catch, 2);
	r7 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(988);				// 13
	goto label7;

label5:
	_JC_TRAP_REGION(catch, 2);
	r8 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(992);				// 14
	goto label7;

label6:
	_JC_TRAP_REGION(catch, 2);
	r9 = _JC_CAUGHT_EXCEPTION(env);

label7:
	_JC_TRAP_REGION(catch, 2);
	_JC_LINE_NUMBER(1001);				// 15
	_JC_CANCEL_TRAPS(env, catch);
	return r2;
}

//
// public int getContentLength()
//

static _jc_linenum _jc_java_net_URLConnection$linenum_table$getContentLength$b5dadbc29a008b07[];

static const unsigned char _jc_java_net_URLConnection$param_ptypes$getContentLength$b5dadbc29a008b07[] = { 
_JC_TYPE_INT };

_jc_method _jc_java_net_URLConnection$method_info$getContentLength$b5dadbc29a008b07 = {
	.name=			"getContentLength",
	.signature=		"()I",
	.class=			&_jc_java_net_URLConnection$type,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_java_net_URLConnection$param_ptypes$getContentLength$b5dadbc29a008b07,
	.signature_hash=	_JC_JLONG(0xb5dadbc29a008b07),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_net_URLConnection$method$getContentLength$b5dadbc29a008b07,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_net_URLConnection$vtable, java_net_URLConnection.getContentLength$b5dadbc29a008b07) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_net_URLConnection$linenum_table$getContentLength$b5dadbc29a008b07
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_net_URLConnection, getContentLength$b5dadbc29a008b07);

jint _JC_JCNI_ATTR
_jc_java_net_URLConnection$method$getContentLength$b5dadbc29a008b07(_jc_env *const env, _jc_java_net_URLConnection$object *this)
{
	jint i0;
	struct _jc_java_net_URLConnection$object *r0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(211);				// 0
	i0 = _JC_INVOKE_VIRTUAL(env, java_net_URLConnection, getHeaderFieldInt$ea08618f4c9dea2e, r0, _JC_STRING(env, "content-length"), -1);
	return i0;
}

//
// public java.lang.String getContentType()
//

static _jc_linenum _jc_java_net_URLConnection$linenum_table$getContentType$c8e5b99f03eb0f46[];

static const unsigned char _jc_java_net_URLConnection$param_ptypes$getContentType$c8e5b99f03eb0f46[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_java_net_URLConnection$method_info$getContentType$c8e5b99f03eb0f46 = {
	.name=			"getContentType",
	.signature=		"()Ljava/lang/String;",
	.class=			&_jc_java_net_URLConnection$type,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_java_net_URLConnection$param_ptypes$getContentType$c8e5b99f03eb0f46,
	.signature_hash=	_JC_JLONG(0xc8e5b99f03eb0f46),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_net_URLConnection$method$getContentType$c8e5b99f03eb0f46,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_net_URLConnection$vtable, java_net_URLConnection.getContentType$c8e5b99f03eb0f46) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_net_URLConnection$linenum_table$getContentType$c8e5b99f03eb0f46
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_net_URLConnection, getContentType$c8e5b99f03eb0f46);

_jc_java_lang_String$object * _JC_JCNI_ATTR
_jc_java_net_URLConnection$method$getContentType$c8e5b99f03eb0f46(_jc_env *const env, _jc_java_net_URLConnection$object *this)
{
	struct _jc_java_net_URLConnection$object *r0;
	struct _jc_java_lang_String$object *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(226);				// 0
	r1 = _JC_INVOKE_VIRTUAL(env, java_net_URLConnection, getHeaderField$0a5e9452a9a469b9, r0, _JC_STRING(env, "content-type"));
	return r1;
}

//
// public long getDate()
//

static _jc_linenum _jc_java_net_URLConnection$linenum_table$getDate$318c78d65f032023[];

static const unsigned char _jc_java_net_URLConnection$param_ptypes$getDate$318c78d65f032023[] = { 
_JC_TYPE_LONG };

_jc_method _jc_java_net_URLConnection$method_info$getDate$318c78d65f032023 = {
	.name=			"getDate",
	.signature=		"()J",
	.class=			&_jc_java_net_URLConnection$type,
	.return_type=		&_jc_long$prim$type,
	.param_ptypes=		&_jc_java_net_URLConnection$param_ptypes$getDate$318c78d65f032023,
	.signature_hash=	_JC_JLONG(0x318c78d65f032023),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_net_URLConnection$method$getDate$318c78d65f032023,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_net_URLConnection$vtable, java_net_URLConnection.getDate$318c78d65f032023) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_net_URLConnection$linenum_table$getDate$318c78d65f032023
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_net_URLConnection, getDate$318c78d65f032023);

jlong _JC_JCNI_ATTR
_jc_java_net_URLConnection$method$getDate$318c78d65f032023(_jc_env *const env, _jc_java_net_URLConnection$object *this)
{
	jlong l0;
	struct _jc_java_net_URLConnection$object *r0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(262);				// 0
	l0 = _JC_INVOKE_VIRTUAL(env, java_net_URLConnection, getHeaderFieldDate$3264529c5afce392, r0, _JC_STRING(env, "date"), _JC_JLONG(0));
	return l0;
}

//
// public boolean getDefaultUseCaches()
//

static _jc_linenum _jc_java_net_URLConnection$linenum_table$getDefaultUseCaches$3d125d701e09e9c4[];

static const unsigned char _jc_java_net_URLConnection$param_ptypes$getDefaultUseCaches$3d125d701e09e9c4[] = { 
_JC_TYPE_BOOLEAN };

_jc_method _jc_java_net_URLConnection$method_info$getDefaultUseCaches$3d125d701e09e9c4 = {
	.name=			"getDefaultUseCaches",
	.signature=		"()Z",
	.class=			&_jc_java_net_URLConnection$type,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_java_net_URLConnection$param_ptypes$getDefaultUseCaches$3d125d701e09e9c4,
	.signature_hash=	_JC_JLONG(0x3d125d701e09e9c4),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_net_URLConnection$method$getDefaultUseCaches$3d125d701e09e9c4,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_net_URLConnection$vtable, java_net_URLConnection.getDefaultUseCaches$3d125d701e09e9c4) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_net_URLConnection$linenum_table$getDefaultUseCaches$3d125d701e09e9c4
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_net_URLConnection, getDefaultUseCaches$3d125d701e09e9c4);

jboolean _JC_JCNI_ATTR
_jc_java_net_URLConnection$method$getDefaultUseCaches$3d125d701e09e9c4(_jc_env *const env, _jc_java_net_URLConnection$object *this)
{
	struct _jc_java_net_URLConnection$object *r0;
	jboolean z0;

	r0 = this;
	_JC_LINE_NUMBER(707);				// 0
	z0 = _JC_STATIC_FIELD(env, java_net_URLConnection, defaultUseCaches, 1);
	return z0;
}

//
// public boolean getDoInput()
//

static _jc_linenum _jc_java_net_URLConnection$linenum_table$getDoInput$ca428d04f26e4860[];

static const unsigned char _jc_java_net_URLConnection$param_ptypes$getDoInput$ca428d04f26e4860[] = { 
_JC_TYPE_BOOLEAN };

_jc_method _jc_java_net_URLConnection$method_info$getDoInput$ca428d04f26e4860 = {
	.name=			"getDoInput",
	.signature=		"()Z",
	.class=			&_jc_java_net_URLConnection$type,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_java_net_URLConnection$param_ptypes$getDoInput$ca428d04f26e4860,
	.signature_hash=	_JC_JLONG(0xca428d04f26e4860),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_net_URLConnection$method$getDoInput$ca428d04f26e4860,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_net_URLConnection$vtable, java_net_URLConnection.getDoInput$ca428d04f26e4860) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_net_URLConnection$linenum_table$getDoInput$ca428d04f26e4860
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_net_URLConnection, getDoInput$ca428d04f26e4860);

jboolean _JC_JCNI_ATTR
_jc_java_net_URLConnection$method$getDoInput$ca428d04f26e4860(_jc_env *const env, _jc_java_net_URLConnection$object *this)
{
	struct _jc_java_net_URLConnection$object *r0;
	jboolean z0;

	r0 = this;
	_JC_LINE_NUMBER(559);				// 0
	z0 = _JC_PRIM_FIELD(env, r0, java_net_URLConnection, doInput);
	return z0;
}

//
// public boolean getDoOutput()
//

static _jc_linenum _jc_java_net_URLConnection$linenum_table$getDoOutput$e8fe6558710036d3[];

static const unsigned char _jc_java_net_URLConnection$param_ptypes$getDoOutput$e8fe6558710036d3[] = { 
_JC_TYPE_BOOLEAN };

_jc_method _jc_java_net_URLConnection$method_info$getDoOutput$e8fe6558710036d3 = {
	.name=			"getDoOutput",
	.signature=		"()Z",
	.class=			&_jc_java_net_URLConnection$type,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_java_net_URLConnection$param_ptypes$getDoOutput$e8fe6558710036d3,
	.signature_hash=	_JC_JLONG(0xe8fe6558710036d3),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_net_URLConnection$method$getDoOutput$e8fe6558710036d3,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_net_URLConnection$vtable, java_net_URLConnection.getDoOutput$e8fe6558710036d3) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_net_URLConnection$linenum_table$getDoOutput$e8fe6558710036d3
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_net_URLConnection, getDoOutput$e8fe6558710036d3);

jboolean _JC_JCNI_ATTR
_jc_java_net_URLConnection$method$getDoOutput$e8fe6558710036d3(_jc_env *const env, _jc_java_net_URLConnection$object *this)
{
	struct _jc_java_net_URLConnection$object *r0;
	jboolean z0;

	r0 = this;
	_JC_LINE_NUMBER(587);				// 0
	z0 = _JC_PRIM_FIELD(env, r0, java_net_URLConnection, doOutput);
	return z0;
}

//
// public long getExpiration()
//

static _jc_linenum _jc_java_net_URLConnection$linenum_table$getExpiration$fb904de1908bbfb6[];

static const unsigned char _jc_java_net_URLConnection$param_ptypes$getExpiration$fb904de1908bbfb6[] = { 
_JC_TYPE_LONG };

_jc_method _jc_java_net_URLConnection$method_info$getExpiration$fb904de1908bbfb6 = {
	.name=			"getExpiration",
	.signature=		"()J",
	.class=			&_jc_java_net_URLConnection$type,
	.return_type=		&_jc_long$prim$type,
	.param_ptypes=		&_jc_java_net_URLConnection$param_ptypes$getExpiration$fb904de1908bbfb6,
	.signature_hash=	_JC_JLONG(0xfb904de1908bbfb6),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_net_URLConnection$method$getExpiration$fb904de1908bbfb6,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_net_URLConnection$vtable, java_net_URLConnection.getExpiration$fb904de1908bbfb6) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_net_URLConnection$linenum_table$getExpiration$fb904de1908bbfb6
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_net_URLConnection, getExpiration$fb904de1908bbfb6);

jlong _JC_JCNI_ATTR
_jc_java_net_URLConnection$method$getExpiration$fb904de1908bbfb6(_jc_env *const env, _jc_java_net_URLConnection$object *this)
{
	jlong l0;
	struct _jc_java_net_URLConnection$object *r0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(249);				// 0
	l0 = _JC_INVOKE_VIRTUAL(env, java_net_URLConnection, getHeaderFieldDate$3264529c5afce392, r0, _JC_STRING(env, "expires"), _JC_JLONG(0));
	return l0;
}

//
// public java.lang.String getHeaderField(int)
//

static _jc_linenum _jc_java_net_URLConnection$linenum_table$getHeaderField$90f480508103a444[];

static const unsigned char _jc_java_net_URLConnection$param_ptypes$getHeaderField$90f480508103a444[] = { 
_JC_TYPE_INT, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_net_URLConnection$param_types$getHeaderField$90f480508103a444[] = {
	&_jc_int$prim$type
};

_jc_method _jc_java_net_URLConnection$method_info$getHeaderField$90f480508103a444 = {
	.name=			"getHeaderField",
	.signature=		"(I)Ljava/lang/String;",
	.class=			&_jc_java_net_URLConnection$type,
	.param_types=		&_jc_java_net_URLConnection$param_types$getHeaderField$90f480508103a444,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_java_net_URLConnection$param_ptypes$getHeaderField$90f480508103a444,
	.signature_hash=	_JC_JLONG(0x90f480508103a444),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_net_URLConnection$method$getHeaderField$90f480508103a444,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_net_URLConnection$vtable, java_net_URLConnection.getHeaderField$90f480508103a444) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_net_URLConnection$linenum_table$getHeaderField$90f480508103a444
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_net_URLConnection, getHeaderField$90f480508103a444);

_jc_java_lang_String$object * _JC_JCNI_ATTR
_jc_java_net_URLConnection$method$getHeaderField$90f480508103a444(_jc_env *const env, _jc_java_net_URLConnection$object *this, jint param0)
{
	jint i0;
	struct _jc_java_net_URLConnection$object *r0;

	r0 = this;
	i0 = param0;
	_JC_LINE_NUMBER(290);				// 0
	return _JC_NULL;
}

//
// public java.lang.String getHeaderField(java.lang.String)
//

static _jc_linenum _jc_java_net_URLConnection$linenum_table$getHeaderField$0a5e9452a9a469b9[];

static const unsigned char _jc_java_net_URLConnection$param_ptypes$getHeaderField$0a5e9452a9a469b9[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_net_URLConnection$param_types$getHeaderField$0a5e9452a9a469b9[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_java_net_URLConnection$method_info$getHeaderField$0a5e9452a9a469b9 = {
	.name=			"getHeaderField",
	.signature=		"(Ljava/lang/String;)Ljava/lang/String;",
	.class=			&_jc_java_net_URLConnection$type,
	.param_types=		&_jc_java_net_URLConnection$param_types$getHeaderField$0a5e9452a9a469b9,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_java_net_URLConnection$param_ptypes$getHeaderField$0a5e9452a9a469b9,
	.signature_hash=	_JC_JLONG(0xa5e9452a9a469b9),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_net_URLConnection$method$getHeaderField$0a5e9452a9a469b9,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_net_URLConnection$vtable, java_net_URLConnection.getHeaderField$0a5e9452a9a469b9) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_net_URLConnection$linenum_table$getHeaderField$0a5e9452a9a469b9
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_net_URLConnection, getHeaderField$0a5e9452a9a469b9);

_jc_java_lang_String$object * _JC_JCNI_ATTR
_jc_java_net_URLConnection$method$getHeaderField$0a5e9452a9a469b9(_jc_env *const env, _jc_java_net_URLConnection$object *this, _jc_java_lang_String$object *param0)
{
	struct _jc_java_net_URLConnection$object *r0;
	struct _jc_java_lang_String$object *r1;

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(304);				// 0
	return _JC_NULL;
}

//
// public long getHeaderFieldDate(java.lang.String, long)
//

static _jc_linenum _jc_java_net_URLConnection$linenum_table$getHeaderFieldDate$3264529c5afce392[];

static const unsigned char _jc_java_net_URLConnection$param_ptypes$getHeaderFieldDate$3264529c5afce392[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_LONG, _JC_TYPE_LONG };

static _jc_type *const _jc_java_net_URLConnection$param_types$getHeaderFieldDate$3264529c5afce392[] = {
	&_jc_java_lang_String$type,
	&_jc_long$prim$type
};

_jc_method _jc_java_net_URLConnection$method_info$getHeaderFieldDate$3264529c5afce392 = {
	.name=			"getHeaderFieldDate",
	.signature=		"(Ljava/lang/String;J)J",
	.class=			&_jc_java_net_URLConnection$type,
	.param_types=		&_jc_java_net_URLConnection$param_types$getHeaderFieldDate$3264529c5afce392,
	.return_type=		&_jc_long$prim$type,
	.param_ptypes=		&_jc_java_net_URLConnection$param_ptypes$getHeaderFieldDate$3264529c5afce392,
	.signature_hash=	_JC_JLONG(0x3264529c5afce392),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_net_URLConnection$method$getHeaderFieldDate$3264529c5afce392,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_net_URLConnection$vtable, java_net_URLConnection.getHeaderFieldDate$3264529c5afce392) / sizeof(void *),
	.num_parameters=	2,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	15,
	      .table=	_jc_java_net_URLConnection$linenum_table$getHeaderFieldDate$3264529c5afce392
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_net_URLConnection, getHeaderFieldDate$3264529c5afce392);

jlong _JC_JCNI_ATTR
_jc_java_net_URLConnection$method$getHeaderFieldDate$3264529c5afce392(_jc_env *const env, _jc_java_net_URLConnection$object *this, _jc_java_lang_String$object *param0, jlong param1)
{
	jint i1;
	jint i2;
	jlong l0;
	struct _jc_java_net_URLConnection$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_java_text_ParsePosition$object *r2;
	struct _jc_java_text_SimpleDateFormat$object *r3;
	struct _jc_java_util_Date$object *r4;
	_jc_object_array *r5;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	l0 = param1;
	_JC_LINE_NUMBER(363);				// 0
	z0 = _JC_STATIC_FIELD(env, java_net_URLConnection, dateformats__5finitialized, 1);
	if (z0 != 0)
		goto label0;
	_JC_LINE_NUMBER(364);				// 1
	_JC_INVOKE_STATIC(env, java_net_URLConnection, initializeDateFormats$f9ce84a1f1f6dd6d, 1);

label0:
	_JC_LINE_NUMBER(366);				// 2
	r2 = _JC_REF_FIELD(env, r0, java_net_URLConnection, position);
	if (r2 != _JC_NULL)
		goto label1;
	_JC_LINE_NUMBER(367);				// 3
	r2 = _JC_NEW(env, java_text_ParsePosition);
	_JC_PRIM_FIELD(env, r2, java_text_ParsePosition, index) = 0;
	_JC_PRIM_FIELD(env, r2, java_text_ParsePosition, error__5findex) = -1;
	_JC_REF_FIELD(env, r0, java_net_URLConnection, position) = r2;

label1:
	_JC_LINE_NUMBER(370);				// 4
	r1 = _JC_INVOKE_VIRTUAL(env, java_net_URLConnection, getHeaderField$0a5e9452a9a469b9, r0, r1);
	_JC_LINE_NUMBER(372);				// 5
	if (r1 == _JC_NULL)
		goto label5;
	_JC_LINE_NUMBER(374);				// 6
	i1 = 0;
	goto label4;

label2:
	_JC_LINE_NUMBER(376);				// 7
	r5 = _JC_STATIC_FIELD(env, java_net_URLConnection, dateFormats, 1);
	r3 = _JC_REF_ELEMENT(env, r5, i1, 0, 0);
	_JC_LINE_NUMBER(377);				// 8
	r2 = _JC_REF_FIELD(env, r0, java_net_URLConnection, position);
	_JC_INVOKE_VIRTUAL(env, java_text_ParsePosition, setIndex$a44eec73e9c18719, r2, 0);
	_JC_LINE_NUMBER(378);				// 9
	r2 = _JC_REF_FIELD(env, r0, java_net_URLConnection, position);
	_JC_INVOKE_VIRTUAL(env, java_text_ParsePosition, setErrorIndex$4a9c3468aa509917, r2, 0);
	_JC_LINE_NUMBER(379);				// 10
	r2 = _JC_REF_FIELD(env, r0, java_net_URLConnection, position);
	r4 = _JC_INVOKE_VIRTUAL(env, java_text_SimpleDateFormat, parse$a04056e0f8a18ae2, r3, r1, r2);
	_JC_LINE_NUMBER(380);				// 11
	if (r4 == _JC_NULL)
		goto label3;
	_JC_LINE_NUMBER(381);				// 12
	l0 = _JC_INVOKE_VIRTUAL(env, java_util_Date, getTime$5fabbaa41130db0f, r4);
	return l0;

label3:
	_JC_LINE_NUMBER(374);				// 13
	i1 = i1 + 1;

label4:
	r5 = _JC_STATIC_FIELD(env, java_net_URLConnection, dateFormats, 1);
	i2 = _JC_ARRAY_LENGTH(env, r5);
	if (i1 < i2) {
		_JC_PERIODIC_CHECK(env);
		goto label2;
	}

label5:
	_JC_LINE_NUMBER(385);				// 14
	return l0;
}

//
// public int getHeaderFieldInt(java.lang.String, int)
//

static _jc_linenum _jc_java_net_URLConnection$linenum_table$getHeaderFieldInt$ea08618f4c9dea2e[];

static _jc_trap_info _jc_java_net_URLConnection$trap_table$getHeaderFieldInt$ea08618f4c9dea2e[] = {
	_JC_TRAP(&_jc_java_lang_NumberFormatException$type, 1, 2),
};

static const unsigned char _jc_java_net_URLConnection$param_ptypes$getHeaderFieldInt$ea08618f4c9dea2e[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_INT };

static _jc_type *const _jc_java_net_URLConnection$param_types$getHeaderFieldInt$ea08618f4c9dea2e[] = {
	&_jc_java_lang_String$type,
	&_jc_int$prim$type
};

_jc_method _jc_java_net_URLConnection$method_info$getHeaderFieldInt$ea08618f4c9dea2e = {
	.name=			"getHeaderFieldInt",
	.signature=		"(Ljava/lang/String;I)I",
	.class=			&_jc_java_net_URLConnection$type,
	.param_types=		&_jc_java_net_URLConnection$param_types$getHeaderFieldInt$ea08618f4c9dea2e,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_java_net_URLConnection$param_ptypes$getHeaderFieldInt$ea08618f4c9dea2e,
	.signature_hash=	_JC_JLONG(0xea08618f4c9dea2e),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_net_URLConnection$method$getHeaderFieldInt$ea08618f4c9dea2e,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_net_URLConnection$vtable, java_net_URLConnection.getHeaderFieldInt$ea08618f4c9dea2e) / sizeof(void *),
	.num_parameters=	2,
	.u= { .exec= {
	  .trap_table_len=	1,
	  .trap_table=		_jc_java_net_URLConnection$trap_table$getHeaderFieldInt$ea08618f4c9dea2e,
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_java_net_URLConnection$linenum_table$getHeaderFieldInt$ea08618f4c9dea2e
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_net_URLConnection, getHeaderFieldInt$ea08618f4c9dea2e);

jint _JC_JCNI_ATTR
_jc_java_net_URLConnection$method$getHeaderFieldInt$ea08618f4c9dea2e(_jc_env *const env, _jc_java_net_URLConnection$object *this, _jc_java_lang_String$object *param0, jint param1)
{
	jint volatile i0;
	jint i2;
	struct _jc_java_net_URLConnection$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_java_lang_NumberFormatException$object *r2;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_java_net_URLConnection$method_info$getHeaderFieldInt$ea08618f4c9dea2e, &&label1);

	r0 = this;
	r1 = param0;
	i0 = param1;
	_JC_LINE_NUMBER(334);				// 0
	r1 = _JC_INVOKE_VIRTUAL(env, java_net_URLConnection, getHeaderField$0a5e9452a9a469b9, r0, r1);
	_JC_LINE_NUMBER(336);				// 1
	if (r1 != _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(337);				// 2
	_JC_CANCEL_TRAPS(env, catch);
	return i0;

label0:
	_JC_TRAP_REGION(catch, 1);
	_JC_ACTIVE_USE(env, java_lang_Integer);
	i2 = _JC_INVOKE_STATIC(env, java_lang_Integer, parseInt$09e508ce4e7428b2, 1, r1, 10, 0);
	_JC_TRAP_REGION(catch, 2);
	_JC_LINE_NUMBER(341);				// 3
	_JC_CANCEL_TRAPS(env, catch);
	return i2;

label1:
	_JC_TRAP_REGION(catch, 2);
	r2 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(345);				// 4
	_JC_CANCEL_TRAPS(env, catch);
	return i0;
}

//
// public java.lang.String getHeaderFieldKey(int)
//

static _jc_linenum _jc_java_net_URLConnection$linenum_table$getHeaderFieldKey$c97d2ac41219f3d0[];

static const unsigned char _jc_java_net_URLConnection$param_ptypes$getHeaderFieldKey$c97d2ac41219f3d0[] = { 
_JC_TYPE_INT, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_net_URLConnection$param_types$getHeaderFieldKey$c97d2ac41219f3d0[] = {
	&_jc_int$prim$type
};

_jc_method _jc_java_net_URLConnection$method_info$getHeaderFieldKey$c97d2ac41219f3d0 = {
	.name=			"getHeaderFieldKey",
	.signature=		"(I)Ljava/lang/String;",
	.class=			&_jc_java_net_URLConnection$type,
	.param_types=		&_jc_java_net_URLConnection$param_types$getHeaderFieldKey$c97d2ac41219f3d0,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_java_net_URLConnection$param_ptypes$getHeaderFieldKey$c97d2ac41219f3d0,
	.signature_hash=	_JC_JLONG(0xc97d2ac41219f3d0),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_net_URLConnection$method$getHeaderFieldKey$c97d2ac41219f3d0,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_net_URLConnection$vtable, java_net_URLConnection.getHeaderFieldKey$c97d2ac41219f3d0) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_net_URLConnection$linenum_table$getHeaderFieldKey$c97d2ac41219f3d0
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_net_URLConnection, getHeaderFieldKey$c97d2ac41219f3d0);

_jc_java_lang_String$object * _JC_JCNI_ATTR
_jc_java_net_URLConnection$method$getHeaderFieldKey$c97d2ac41219f3d0(_jc_env *const env, _jc_java_net_URLConnection$object *this, jint param0)
{
	jint i0;
	struct _jc_java_net_URLConnection$object *r0;

	r0 = this;
	i0 = param0;
	_JC_LINE_NUMBER(402);				// 0
	return _JC_NULL;
}

//
// public java.util.Map getHeaderFields()
//

static _jc_linenum _jc_java_net_URLConnection$linenum_table$getHeaderFields$5a6b4289978b84f3[];

static const unsigned char _jc_java_net_URLConnection$param_ptypes$getHeaderFields$5a6b4289978b84f3[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_java_net_URLConnection$method_info$getHeaderFields$5a6b4289978b84f3 = {
	.name=			"getHeaderFields",
	.signature=		"()Ljava/util/Map;",
	.class=			&_jc_java_net_URLConnection$type,
	.return_type=		&_jc_java_util_Map$type,
	.param_ptypes=		&_jc_java_net_URLConnection$param_ptypes$getHeaderFields$5a6b4289978b84f3,
	.signature_hash=	_JC_JLONG(0x5a6b4289978b84f3),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_net_URLConnection$method$getHeaderFields$5a6b4289978b84f3,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_net_URLConnection$vtable, java_net_URLConnection.getHeaderFields$5a6b4289978b84f3) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_net_URLConnection$linenum_table$getHeaderFields$5a6b4289978b84f3
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_net_URLConnection, getHeaderFields$5a6b4289978b84f3);

_jc_object * _JC_JCNI_ATTR
_jc_java_net_URLConnection$method$getHeaderFields$5a6b4289978b84f3(_jc_env *const env, _jc_java_net_URLConnection$object *this)
{
	struct _jc_java_net_URLConnection$object *r0;
	struct _jc_object *r1;

	r0 = this;
	_JC_LINE_NUMBER(317);				// 0
	r1 = _JC_STATIC_FIELD(env, java_util_Collections, EMPTY__5fMAP, 0);
	return r1;
}

//
// public long getIfModifiedSince()
//

static _jc_linenum _jc_java_net_URLConnection$linenum_table$getIfModifiedSince$b6171bfbf998a96b[];

static const unsigned char _jc_java_net_URLConnection$param_ptypes$getIfModifiedSince$b6171bfbf998a96b[] = { 
_JC_TYPE_LONG };

_jc_method _jc_java_net_URLConnection$method_info$getIfModifiedSince$b6171bfbf998a96b = {
	.name=			"getIfModifiedSince",
	.signature=		"()J",
	.class=			&_jc_java_net_URLConnection$type,
	.return_type=		&_jc_long$prim$type,
	.param_ptypes=		&_jc_java_net_URLConnection$param_ptypes$getIfModifiedSince$b6171bfbf998a96b,
	.signature_hash=	_JC_JLONG(0xb6171bfbf998a96b),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_net_URLConnection$method$getIfModifiedSince$b6171bfbf998a96b,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_net_URLConnection$vtable, java_net_URLConnection.getIfModifiedSince$b6171bfbf998a96b) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_net_URLConnection$linenum_table$getIfModifiedSince$b6171bfbf998a96b
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_net_URLConnection, getIfModifiedSince$b6171bfbf998a96b);

jlong _JC_JCNI_ATTR
_jc_java_net_URLConnection$method$getIfModifiedSince$b6171bfbf998a96b(_jc_env *const env, _jc_java_net_URLConnection$object *this)
{
	jlong l0;
	struct _jc_java_net_URLConnection$object *r0;

	r0 = this;
	_JC_LINE_NUMBER(696);				// 0
	l0 = _JC_PRIM_FIELD(env, r0, java_net_URLConnection, ifModifiedSince);
	return l0;
}

//
// public java.io.InputStream getInputStream() throws java.io.IOException
//

static _jc_linenum _jc_java_net_URLConnection$linenum_table$getInputStream$13cf75a12cabb343[];

static const unsigned char _jc_java_net_URLConnection$param_ptypes$getInputStream$13cf75a12cabb343[] = { 
_JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_net_URLConnection$exceptions$getInputStream$13cf75a12cabb343[] = {
	&_jc_java_io_IOException$type
};

_jc_method _jc_java_net_URLConnection$method_info$getInputStream$13cf75a12cabb343 = {
	.name=			"getInputStream",
	.signature=		"()Ljava/io/InputStream;",
	.class=			&_jc_java_net_URLConnection$type,
	.return_type=		&_jc_java_io_InputStream$type,
	.param_ptypes=		&_jc_java_net_URLConnection$param_ptypes$getInputStream$13cf75a12cabb343,
	.signature_hash=	_JC_JLONG(0x13cf75a12cabb343),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_net_URLConnection$method$getInputStream$13cf75a12cabb343,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_net_URLConnection$vtable, java_net_URLConnection.getInputStream$13cf75a12cabb343) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_net_URLConnection$exceptions$getInputStream$13cf75a12cabb343,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_net_URLConnection$linenum_table$getInputStream$13cf75a12cabb343
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_net_URLConnection, getInputStream$13cf75a12cabb343);

_jc_java_io_InputStream$object * _JC_JCNI_ATTR
_jc_java_net_URLConnection$method$getInputStream$13cf75a12cabb343(_jc_env *const env, _jc_java_net_URLConnection$object *this)
{
	struct _jc_java_net_URLConnection$object *r0;
	struct _jc_java_net_UnknownServiceException$object *r1;
	struct _jc_java_lang_StringBuffer$object *r2;
	struct _jc_java_net_URL$object *r3;
	struct _jc_java_lang_String$object *r4;
	struct _jc_java_lang_String$object *r5;
	struct _jc_java_lang_VMThrowable$object *r7;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(501);				// 0
	r1 = _JC_NEW(env, java_net_UnknownServiceException);
	r2 = _JC_NEW(env, java_lang_StringBuffer);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, _init$c31b894660454d13, 0, r2, _JC_STRING(env, "Protocol "));
	r3 = _JC_REF_FIELD(env, r0, java_net_URLConnection, url);
	_JC_EXPLICIT_NULL_CHECK(env, r3);
	r4 = _JC_REF_FIELD(env, r3, java_net_URL, protocol);
	r2 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r2, r4);
	r2 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r2, _JC_STRING(env, " does not support input."));
	r5 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r5, r2);
	_JC_REF_FIELD(env, r1, java_lang_Throwable, cause) = r1;
	r7 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r1);
	_JC_REF_FIELD(env, r1, java_lang_Throwable, vmState) = r7;
	_JC_REF_FIELD(env, r1, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r1, java_lang_Throwable, detailMessage) = r5;
	_JC_THROW(env, r1);
}

//
// public long getLastModified()
//

static _jc_linenum _jc_java_net_URLConnection$linenum_table$getLastModified$104f09ee06ce16cc[];

static const unsigned char _jc_java_net_URLConnection$param_ptypes$getLastModified$104f09ee06ce16cc[] = { 
_JC_TYPE_LONG };

_jc_method _jc_java_net_URLConnection$method_info$getLastModified$104f09ee06ce16cc = {
	.name=			"getLastModified",
	.signature=		"()J",
	.class=			&_jc_java_net_URLConnection$type,
	.return_type=		&_jc_long$prim$type,
	.param_ptypes=		&_jc_java_net_URLConnection$param_ptypes$getLastModified$104f09ee06ce16cc,
	.signature_hash=	_JC_JLONG(0x104f09ee06ce16cc),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_net_URLConnection$method$getLastModified$104f09ee06ce16cc,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_net_URLConnection$vtable, java_net_URLConnection.getLastModified$104f09ee06ce16cc) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_net_URLConnection$linenum_table$getLastModified$104f09ee06ce16cc
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_net_URLConnection, getLastModified$104f09ee06ce16cc);

jlong _JC_JCNI_ATTR
_jc_java_net_URLConnection$method$getLastModified$104f09ee06ce16cc(_jc_env *const env, _jc_java_net_URLConnection$object *this)
{
	jlong l0;
	struct _jc_java_net_URLConnection$object *r0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(274);				// 0
	l0 = _JC_INVOKE_VIRTUAL(env, java_net_URLConnection, getHeaderFieldDate$3264529c5afce392, r0, _JC_STRING(env, "last-modified"), _JC_JLONG(0));
	return l0;
}

//
// public java.io.OutputStream getOutputStream() throws java.io.IOException
//

static _jc_linenum _jc_java_net_URLConnection$linenum_table$getOutputStream$1f50a8d1fe1542e3[];

static const unsigned char _jc_java_net_URLConnection$param_ptypes$getOutputStream$1f50a8d1fe1542e3[] = { 
_JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_net_URLConnection$exceptions$getOutputStream$1f50a8d1fe1542e3[] = {
	&_jc_java_io_IOException$type
};

_jc_method _jc_java_net_URLConnection$method_info$getOutputStream$1f50a8d1fe1542e3 = {
	.name=			"getOutputStream",
	.signature=		"()Ljava/io/OutputStream;",
	.class=			&_jc_java_net_URLConnection$type,
	.return_type=		&_jc_java_io_OutputStream$type,
	.param_ptypes=		&_jc_java_net_URLConnection$param_ptypes$getOutputStream$1f50a8d1fe1542e3,
	.signature_hash=	_JC_JLONG(0x1f50a8d1fe1542e3),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_net_URLConnection$method$getOutputStream$1f50a8d1fe1542e3,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_net_URLConnection$vtable, java_net_URLConnection.getOutputStream$1f50a8d1fe1542e3) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_net_URLConnection$exceptions$getOutputStream$1f50a8d1fe1542e3,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_net_URLConnection$linenum_table$getOutputStream$1f50a8d1fe1542e3
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_net_URLConnection, getOutputStream$1f50a8d1fe1542e3);

_jc_java_io_OutputStream$object * _JC_JCNI_ATTR
_jc_java_net_URLConnection$method$getOutputStream$1f50a8d1fe1542e3(_jc_env *const env, _jc_java_net_URLConnection$object *this)
{
	struct _jc_java_net_URLConnection$object *r0;
	struct _jc_java_net_UnknownServiceException$object *r1;
	struct _jc_java_lang_StringBuffer$object *r2;
	struct _jc_java_net_URL$object *r3;
	struct _jc_java_lang_String$object *r4;
	struct _jc_java_lang_String$object *r5;
	struct _jc_java_lang_VMThrowable$object *r7;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(517);				// 0
	r1 = _JC_NEW(env, java_net_UnknownServiceException);
	r2 = _JC_NEW(env, java_lang_StringBuffer);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, _init$c31b894660454d13, 0, r2, _JC_STRING(env, "Protocol "));
	r3 = _JC_REF_FIELD(env, r0, java_net_URLConnection, url);
	_JC_EXPLICIT_NULL_CHECK(env, r3);
	r4 = _JC_REF_FIELD(env, r3, java_net_URL, protocol);
	r2 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r2, r4);
	r2 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r2, _JC_STRING(env, " does not support output."));
	r5 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r5, r2);
	_JC_REF_FIELD(env, r1, java_lang_Throwable, cause) = r1;
	r7 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r1);
	_JC_REF_FIELD(env, r1, java_lang_Throwable, vmState) = r7;
	_JC_REF_FIELD(env, r1, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r1, java_lang_Throwable, detailMessage) = r5;
	_JC_THROW(env, r1);
}

//
// public java.security.Permission getPermission() throws java.io.IOException
//

static _jc_linenum _jc_java_net_URLConnection$linenum_table$getPermission$5ed14cf5cad2ace7[];

static const unsigned char _jc_java_net_URLConnection$param_ptypes$getPermission$5ed14cf5cad2ace7[] = { 
_JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_net_URLConnection$exceptions$getPermission$5ed14cf5cad2ace7[] = {
	&_jc_java_io_IOException$type
};

_jc_method _jc_java_net_URLConnection$method_info$getPermission$5ed14cf5cad2ace7 = {
	.name=			"getPermission",
	.signature=		"()Ljava/security/Permission;",
	.class=			&_jc_java_net_URLConnection$type,
	.return_type=		&_jc_java_security_Permission$type,
	.param_ptypes=		&_jc_java_net_URLConnection$param_ptypes$getPermission$5ed14cf5cad2ace7,
	.signature_hash=	_JC_JLONG(0x5ed14cf5cad2ace7),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_net_URLConnection$method$getPermission$5ed14cf5cad2ace7,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_net_URLConnection$vtable, java_net_URLConnection.getPermission$5ed14cf5cad2ace7) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_net_URLConnection$exceptions$getPermission$5ed14cf5cad2ace7,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_net_URLConnection$linenum_table$getPermission$5ed14cf5cad2ace7
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_net_URLConnection, getPermission$5ed14cf5cad2ace7);

_jc_java_security_Permission$object * _JC_JCNI_ATTR
_jc_java_net_URLConnection$method$getPermission$5ed14cf5cad2ace7(_jc_env *const env, _jc_java_net_URLConnection$object *this)
{
	struct _jc_java_net_URLConnection$object *r0;
	struct _jc_java_security_AllPermission$object *r1;
	struct _jc_java_lang_String$object *r2;

	r0 = this;
	_JC_LINE_NUMBER(486);				// 0
	r1 = _JC_NEW(env, java_security_AllPermission);
	r2 = _JC_STRING(env, "*");
	_JC_REF_FIELD(env, r1, java_security_Permission, name) = r2;
	return r1;
}

//
// public java.util.Map getRequestProperties()
//

static _jc_linenum _jc_java_net_URLConnection$linenum_table$getRequestProperties$0037e79e75778205[];

static const unsigned char _jc_java_net_URLConnection$param_ptypes$getRequestProperties$0037e79e75778205[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_java_net_URLConnection$method_info$getRequestProperties$0037e79e75778205 = {
	.name=			"getRequestProperties",
	.signature=		"()Ljava/util/Map;",
	.class=			&_jc_java_net_URLConnection$type,
	.return_type=		&_jc_java_util_Map$type,
	.param_ptypes=		&_jc_java_net_URLConnection$param_ptypes$getRequestProperties$0037e79e75778205,
	.signature_hash=	_JC_JLONG(0x37e79e75778205),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_net_URLConnection$method$getRequestProperties$0037e79e75778205,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_net_URLConnection$vtable, java_net_URLConnection.getRequestProperties$0037e79e75778205) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_java_net_URLConnection$linenum_table$getRequestProperties$0037e79e75778205
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_net_URLConnection, getRequestProperties$0037e79e75778205);

_jc_object * _JC_JCNI_ATTR
_jc_java_net_URLConnection$method$getRequestProperties$0037e79e75778205(_jc_env *const env, _jc_java_net_URLConnection$object *this)
{
	struct _jc_java_net_URLConnection$object *r0;
	struct _jc_java_lang_IllegalStateException$object *r1;
	struct _jc_object *r2;
	struct _jc_java_lang_String$object *r3;
	struct _jc_java_lang_VMThrowable$object *r5;
	jboolean z0;

	r0 = this;
	_JC_LINE_NUMBER(807);				// 0
	z0 = _JC_PRIM_FIELD(env, r0, java_net_URLConnection, connected);
	if (z0 == 0)
		goto label0;
	_JC_LINE_NUMBER(808);				// 1
	r1 = _JC_NEW(env, java_lang_IllegalStateException);
	r3 = _JC_STRING(env, "Already connected");
	_JC_REF_FIELD(env, r1, java_lang_Throwable, cause) = r1;
	r5 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r1);
	_JC_REF_FIELD(env, r1, java_lang_Throwable, vmState) = r5;
	_JC_REF_FIELD(env, r1, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r1, java_lang_Throwable, detailMessage) = r3;
	_JC_THROW(env, r1);

label0:
	_JC_LINE_NUMBER(812);				// 2
	r2 = _JC_STATIC_FIELD(env, java_util_Collections, EMPTY__5fMAP, 0);
	return r2;
}

//
// public java.lang.String getRequestProperty(java.lang.String)
//

static _jc_linenum _jc_java_net_URLConnection$linenum_table$getRequestProperty$6125fcf5422d16f7[];

static const unsigned char _jc_java_net_URLConnection$param_ptypes$getRequestProperty$6125fcf5422d16f7[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_net_URLConnection$param_types$getRequestProperty$6125fcf5422d16f7[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_java_net_URLConnection$method_info$getRequestProperty$6125fcf5422d16f7 = {
	.name=			"getRequestProperty",
	.signature=		"(Ljava/lang/String;)Ljava/lang/String;",
	.class=			&_jc_java_net_URLConnection$type,
	.param_types=		&_jc_java_net_URLConnection$param_types$getRequestProperty$6125fcf5422d16f7,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_java_net_URLConnection$param_ptypes$getRequestProperty$6125fcf5422d16f7,
	.signature_hash=	_JC_JLONG(0x6125fcf5422d16f7),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_net_URLConnection$method$getRequestProperty$6125fcf5422d16f7,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_net_URLConnection$vtable, java_net_URLConnection.getRequestProperty$6125fcf5422d16f7) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_java_net_URLConnection$linenum_table$getRequestProperty$6125fcf5422d16f7
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_net_URLConnection, getRequestProperty$6125fcf5422d16f7);

_jc_java_lang_String$object * _JC_JCNI_ATTR
_jc_java_net_URLConnection$method$getRequestProperty$6125fcf5422d16f7(_jc_env *const env, _jc_java_net_URLConnection$object *this, _jc_java_lang_String$object *param0)
{
	struct _jc_java_net_URLConnection$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_java_lang_IllegalStateException$object *r2;
	struct _jc_java_lang_String$object *r3;
	struct _jc_java_lang_VMThrowable$object *r5;
	jboolean z0;

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(788);				// 0
	z0 = _JC_PRIM_FIELD(env, r0, java_net_URLConnection, connected);
	if (z0 == 0)
		goto label0;
	_JC_LINE_NUMBER(789);				// 1
	r2 = _JC_NEW(env, java_lang_IllegalStateException);
	r3 = _JC_STRING(env, "Already connected");
	_JC_REF_FIELD(env, r2, java_lang_Throwable, cause) = r2;
	r5 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r2);
	_JC_REF_FIELD(env, r2, java_lang_Throwable, vmState) = r5;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, detailMessage) = r3;
	_JC_THROW(env, r2);

label0:
	_JC_LINE_NUMBER(793);				// 2
	return _JC_NULL;
}

//
// public java.net.URL getURL()
//

static _jc_linenum _jc_java_net_URLConnection$linenum_table$getURL$f8efe3e882b98c02[];

static const unsigned char _jc_java_net_URLConnection$param_ptypes$getURL$f8efe3e882b98c02[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_java_net_URLConnection$method_info$getURL$f8efe3e882b98c02 = {
	.name=			"getURL",
	.signature=		"()Ljava/net/URL;",
	.class=			&_jc_java_net_URLConnection$type,
	.return_type=		&_jc_java_net_URL$type,
	.param_ptypes=		&_jc_java_net_URLConnection$param_ptypes$getURL$f8efe3e882b98c02,
	.signature_hash=	_JC_JLONG(0xf8efe3e882b98c02),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_net_URLConnection$method$getURL$f8efe3e882b98c02,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_net_URLConnection$vtable, java_net_URLConnection.getURL$f8efe3e882b98c02) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_net_URLConnection$linenum_table$getURL$f8efe3e882b98c02
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_net_URLConnection, getURL$f8efe3e882b98c02);

_jc_java_net_URL$object * _JC_JCNI_ATTR
_jc_java_net_URLConnection$method$getURL$f8efe3e882b98c02(_jc_env *const env, _jc_java_net_URLConnection$object *this)
{
	struct _jc_java_net_URLConnection$object *r0;
	struct _jc_java_net_URL$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(200);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_net_URLConnection, url);
	return r1;
}

//
// public boolean getUseCaches()
//

static _jc_linenum _jc_java_net_URLConnection$linenum_table$getUseCaches$ff96603628f311bf[];

static const unsigned char _jc_java_net_URLConnection$param_ptypes$getUseCaches$ff96603628f311bf[] = { 
_JC_TYPE_BOOLEAN };

_jc_method _jc_java_net_URLConnection$method_info$getUseCaches$ff96603628f311bf = {
	.name=			"getUseCaches",
	.signature=		"()Z",
	.class=			&_jc_java_net_URLConnection$type,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_java_net_URLConnection$param_ptypes$getUseCaches$ff96603628f311bf,
	.signature_hash=	_JC_JLONG(0xff96603628f311bf),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_net_URLConnection$method$getUseCaches$ff96603628f311bf,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_net_URLConnection$vtable, java_net_URLConnection.getUseCaches$ff96603628f311bf) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_net_URLConnection$linenum_table$getUseCaches$ff96603628f311bf
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_net_URLConnection, getUseCaches$ff96603628f311bf);

jboolean _JC_JCNI_ATTR
_jc_java_net_URLConnection$method$getUseCaches$ff96603628f311bf(_jc_env *const env, _jc_java_net_URLConnection$object *this)
{
	struct _jc_java_net_URLConnection$object *r0;
	jboolean z0;

	r0 = this;
	_JC_LINE_NUMBER(662);				// 0
	z0 = _JC_PRIM_FIELD(env, r0, java_net_URLConnection, useCaches);
	return z0;
}

//
// public void setAllowUserInteraction(boolean)
//

static _jc_linenum _jc_java_net_URLConnection$linenum_table$setAllowUserInteraction$81fb57dcd0c165e5[];

static const unsigned char _jc_java_net_URLConnection$param_ptypes$setAllowUserInteraction$81fb57dcd0c165e5[] = { 
_JC_TYPE_BOOLEAN, _JC_TYPE_VOID };

static _jc_type *const _jc_java_net_URLConnection$param_types$setAllowUserInteraction$81fb57dcd0c165e5[] = {
	&_jc_boolean$prim$type
};

_jc_method _jc_java_net_URLConnection$method_info$setAllowUserInteraction$81fb57dcd0c165e5 = {
	.name=			"setAllowUserInteraction",
	.signature=		"(Z)V",
	.class=			&_jc_java_net_URLConnection$type,
	.param_types=		&_jc_java_net_URLConnection$param_types$setAllowUserInteraction$81fb57dcd0c165e5,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_net_URLConnection$param_ptypes$setAllowUserInteraction$81fb57dcd0c165e5,
	.signature_hash=	_JC_JLONG(0x81fb57dcd0c165e5),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_net_URLConnection$method$setAllowUserInteraction$81fb57dcd0c165e5,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_net_URLConnection$vtable, java_net_URLConnection.setAllowUserInteraction$81fb57dcd0c165e5) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_net_URLConnection$linenum_table$setAllowUserInteraction$81fb57dcd0c165e5
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_net_URLConnection, setAllowUserInteraction$81fb57dcd0c165e5);

void _JC_JCNI_ATTR
_jc_java_net_URLConnection$method$setAllowUserInteraction$81fb57dcd0c165e5(_jc_env *const env, _jc_java_net_URLConnection$object *this, jboolean param0)
{
	struct _jc_java_net_URLConnection$object *r0;
	jboolean z0;

	r0 = this;
	z0 = param0;
	_JC_LINE_NUMBER(601);				// 0
	_JC_PRIM_FIELD(env, r0, java_net_URLConnection, allowUserInteraction) = z0;
	_JC_LINE_NUMBER(602);				// 1
	return;
}

//
// public void setDefaultUseCaches(boolean)
//

static _jc_linenum _jc_java_net_URLConnection$linenum_table$setDefaultUseCaches$619f8926c5a2df9f[];

static const unsigned char _jc_java_net_URLConnection$param_ptypes$setDefaultUseCaches$619f8926c5a2df9f[] = { 
_JC_TYPE_BOOLEAN, _JC_TYPE_VOID };

static _jc_type *const _jc_java_net_URLConnection$param_types$setDefaultUseCaches$619f8926c5a2df9f[] = {
	&_jc_boolean$prim$type
};

_jc_method _jc_java_net_URLConnection$method_info$setDefaultUseCaches$619f8926c5a2df9f = {
	.name=			"setDefaultUseCaches",
	.signature=		"(Z)V",
	.class=			&_jc_java_net_URLConnection$type,
	.param_types=		&_jc_java_net_URLConnection$param_types$setDefaultUseCaches$619f8926c5a2df9f,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_net_URLConnection$param_ptypes$setDefaultUseCaches$619f8926c5a2df9f,
	.signature_hash=	_JC_JLONG(0x619f8926c5a2df9f),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_net_URLConnection$method$setDefaultUseCaches$619f8926c5a2df9f,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_net_URLConnection$vtable, java_net_URLConnection.setDefaultUseCaches$619f8926c5a2df9f) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_net_URLConnection$linenum_table$setDefaultUseCaches$619f8926c5a2df9f
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_net_URLConnection, setDefaultUseCaches$619f8926c5a2df9f);

void _JC_JCNI_ATTR
_jc_java_net_URLConnection$method$setDefaultUseCaches$619f8926c5a2df9f(_jc_env *const env, _jc_java_net_URLConnection$object *this, jboolean param0)
{
	struct _jc_java_net_URLConnection$object *r0;
	jboolean z0;

	r0 = this;
	z0 = param0;
	_JC_LINE_NUMBER(718);				// 0
	_JC_STATIC_FIELD(env, java_net_URLConnection, defaultUseCaches, 1) = z0;
	_JC_LINE_NUMBER(719);				// 1
	return;
}

//
// public void setDoInput(boolean)
//

static _jc_linenum _jc_java_net_URLConnection$linenum_table$setDoInput$8a963ce164df6d9a[];

static const unsigned char _jc_java_net_URLConnection$param_ptypes$setDoInput$8a963ce164df6d9a[] = { 
_JC_TYPE_BOOLEAN, _JC_TYPE_VOID };

static _jc_type *const _jc_java_net_URLConnection$param_types$setDoInput$8a963ce164df6d9a[] = {
	&_jc_boolean$prim$type
};

_jc_method _jc_java_net_URLConnection$method_info$setDoInput$8a963ce164df6d9a = {
	.name=			"setDoInput",
	.signature=		"(Z)V",
	.class=			&_jc_java_net_URLConnection$type,
	.param_types=		&_jc_java_net_URLConnection$param_types$setDoInput$8a963ce164df6d9a,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_net_URLConnection$param_ptypes$setDoInput$8a963ce164df6d9a,
	.signature_hash=	_JC_JLONG(0x8a963ce164df6d9a),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_net_URLConnection$method$setDoInput$8a963ce164df6d9a,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_net_URLConnection$vtable, java_net_URLConnection.setDoInput$8a963ce164df6d9a) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_java_net_URLConnection$linenum_table$setDoInput$8a963ce164df6d9a
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_net_URLConnection, setDoInput$8a963ce164df6d9a);

void _JC_JCNI_ATTR
_jc_java_net_URLConnection$method$setDoInput$8a963ce164df6d9a(_jc_env *const env, _jc_java_net_URLConnection$object *this, jboolean param0)
{
	struct _jc_java_net_URLConnection$object *r0;
	struct _jc_java_lang_IllegalStateException$object *r1;
	struct _jc_java_lang_String$object *r2;
	struct _jc_java_lang_VMThrowable$object *r4;
	jboolean z0;
	jboolean z1;

	r0 = this;
	z0 = param0;
	_JC_LINE_NUMBER(544);				// 0
	z1 = _JC_PRIM_FIELD(env, r0, java_net_URLConnection, connected);
	if (z1 == 0)
		goto label0;
	_JC_LINE_NUMBER(545);				// 1
	r1 = _JC_NEW(env, java_lang_IllegalStateException);
	r2 = _JC_STRING(env, "Already connected");
	_JC_REF_FIELD(env, r1, java_lang_Throwable, cause) = r1;
	r4 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r1);
	_JC_REF_FIELD(env, r1, java_lang_Throwable, vmState) = r4;
	_JC_REF_FIELD(env, r1, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r1, java_lang_Throwable, detailMessage) = r2;
	_JC_THROW(env, r1);

label0:
	_JC_LINE_NUMBER(547);				// 2
	_JC_PRIM_FIELD(env, r0, java_net_URLConnection, doInput) = z0;
	_JC_LINE_NUMBER(548);				// 3
	return;
}

//
// public void setDoOutput(boolean)
//

static _jc_linenum _jc_java_net_URLConnection$linenum_table$setDoOutput$8f1cfbf65496d908[];

static const unsigned char _jc_java_net_URLConnection$param_ptypes$setDoOutput$8f1cfbf65496d908[] = { 
_JC_TYPE_BOOLEAN, _JC_TYPE_VOID };

static _jc_type *const _jc_java_net_URLConnection$param_types$setDoOutput$8f1cfbf65496d908[] = {
	&_jc_boolean$prim$type
};

_jc_method _jc_java_net_URLConnection$method_info$setDoOutput$8f1cfbf65496d908 = {
	.name=			"setDoOutput",
	.signature=		"(Z)V",
	.class=			&_jc_java_net_URLConnection$type,
	.param_types=		&_jc_java_net_URLConnection$param_types$setDoOutput$8f1cfbf65496d908,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_net_URLConnection$param_ptypes$setDoOutput$8f1cfbf65496d908,
	.signature_hash=	_JC_JLONG(0x8f1cfbf65496d908),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_net_URLConnection$method$setDoOutput$8f1cfbf65496d908,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_net_URLConnection$vtable, java_net_URLConnection.setDoOutput$8f1cfbf65496d908) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_java_net_URLConnection$linenum_table$setDoOutput$8f1cfbf65496d908
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_net_URLConnection, setDoOutput$8f1cfbf65496d908);

void _JC_JCNI_ATTR
_jc_java_net_URLConnection$method$setDoOutput$8f1cfbf65496d908(_jc_env *const env, _jc_java_net_URLConnection$object *this, jboolean param0)
{
	struct _jc_java_net_URLConnection$object *r0;
	struct _jc_java_lang_IllegalStateException$object *r1;
	struct _jc_java_lang_String$object *r2;
	struct _jc_java_lang_VMThrowable$object *r4;
	jboolean z0;
	jboolean z1;

	r0 = this;
	z0 = param0;
	_JC_LINE_NUMBER(573);				// 0
	z1 = _JC_PRIM_FIELD(env, r0, java_net_URLConnection, connected);
	if (z1 == 0)
		goto label0;
	_JC_LINE_NUMBER(574);				// 1
	r1 = _JC_NEW(env, java_lang_IllegalStateException);
	r2 = _JC_STRING(env, "Already connected");
	_JC_REF_FIELD(env, r1, java_lang_Throwable, cause) = r1;
	r4 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r1);
	_JC_REF_FIELD(env, r1, java_lang_Throwable, vmState) = r4;
	_JC_REF_FIELD(env, r1, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r1, java_lang_Throwable, detailMessage) = r2;
	_JC_THROW(env, r1);

label0:
	_JC_LINE_NUMBER(576);				// 2
	_JC_PRIM_FIELD(env, r0, java_net_URLConnection, doOutput) = z0;
	_JC_LINE_NUMBER(577);				// 3
	return;
}

//
// public void setIfModifiedSince(long)
//

static _jc_linenum _jc_java_net_URLConnection$linenum_table$setIfModifiedSince$e0f7082828db12c6[];

static const unsigned char _jc_java_net_URLConnection$param_ptypes$setIfModifiedSince$e0f7082828db12c6[] = { 
_JC_TYPE_LONG, _JC_TYPE_VOID };

static _jc_type *const _jc_java_net_URLConnection$param_types$setIfModifiedSince$e0f7082828db12c6[] = {
	&_jc_long$prim$type
};

_jc_method _jc_java_net_URLConnection$method_info$setIfModifiedSince$e0f7082828db12c6 = {
	.name=			"setIfModifiedSince",
	.signature=		"(J)V",
	.class=			&_jc_java_net_URLConnection$type,
	.param_types=		&_jc_java_net_URLConnection$param_types$setIfModifiedSince$e0f7082828db12c6,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_net_URLConnection$param_ptypes$setIfModifiedSince$e0f7082828db12c6,
	.signature_hash=	_JC_JLONG(0xe0f7082828db12c6),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_net_URLConnection$method$setIfModifiedSince$e0f7082828db12c6,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_net_URLConnection$vtable, java_net_URLConnection.setIfModifiedSince$e0f7082828db12c6) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_java_net_URLConnection$linenum_table$setIfModifiedSince$e0f7082828db12c6
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_net_URLConnection, setIfModifiedSince$e0f7082828db12c6);

void _JC_JCNI_ATTR
_jc_java_net_URLConnection$method$setIfModifiedSince$e0f7082828db12c6(_jc_env *const env, _jc_java_net_URLConnection$object *this, jlong param0)
{
	jlong l0;
	struct _jc_java_net_URLConnection$object *r0;
	struct _jc_java_lang_IllegalStateException$object *r1;
	struct _jc_java_lang_String$object *r2;
	struct _jc_java_lang_VMThrowable$object *r4;
	jboolean z0;

	r0 = this;
	l0 = param0;
	_JC_LINE_NUMBER(679);				// 0
	z0 = _JC_PRIM_FIELD(env, r0, java_net_URLConnection, connected);
	if (z0 == 0)
		goto label0;
	_JC_LINE_NUMBER(680);				// 1
	r1 = _JC_NEW(env, java_lang_IllegalStateException);
	r2 = _JC_STRING(env, "Already connected");
	_JC_REF_FIELD(env, r1, java_lang_Throwable, cause) = r1;
	r4 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r1);
	_JC_REF_FIELD(env, r1, java_lang_Throwable, vmState) = r4;
	_JC_REF_FIELD(env, r1, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r1, java_lang_Throwable, detailMessage) = r2;
	_JC_THROW(env, r1);

label0:
	_JC_LINE_NUMBER(682);				// 2
	_JC_PRIM_FIELD(env, r0, java_net_URLConnection, ifModifiedSince) = l0;
	_JC_LINE_NUMBER(683);				// 3
	return;
}

//
// public void setRequestProperty(java.lang.String, java.lang.String)
//

static _jc_linenum _jc_java_net_URLConnection$linenum_table$setRequestProperty$56510cec6e2a2add[];

static const unsigned char _jc_java_net_URLConnection$param_ptypes$setRequestProperty$56510cec6e2a2add[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_net_URLConnection$param_types$setRequestProperty$56510cec6e2a2add[] = {
	&_jc_java_lang_String$type,
	&_jc_java_lang_String$type
};

_jc_method _jc_java_net_URLConnection$method_info$setRequestProperty$56510cec6e2a2add = {
	.name=			"setRequestProperty",
	.signature=		"(Ljava/lang/String;Ljava/lang/String;)V",
	.class=			&_jc_java_net_URLConnection$type,
	.param_types=		&_jc_java_net_URLConnection$param_types$setRequestProperty$56510cec6e2a2add,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_net_URLConnection$param_ptypes$setRequestProperty$56510cec6e2a2add,
	.signature_hash=	_JC_JLONG(0x56510cec6e2a2add),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_net_URLConnection$method$setRequestProperty$56510cec6e2a2add,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_net_URLConnection$vtable, java_net_URLConnection.setRequestProperty$56510cec6e2a2add) / sizeof(void *),
	.num_parameters=	2,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_java_net_URLConnection$linenum_table$setRequestProperty$56510cec6e2a2add
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_net_URLConnection, setRequestProperty$56510cec6e2a2add);

void _JC_JCNI_ATTR
_jc_java_net_URLConnection$method$setRequestProperty$56510cec6e2a2add(_jc_env *const env, _jc_java_net_URLConnection$object *this, _jc_java_lang_String$object *param0, _jc_java_lang_String$object *param1)
{
	struct _jc_java_net_URLConnection$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_java_lang_String$object *r2;
	struct _jc_java_lang_IllegalStateException$object *r3;
	struct _jc_java_lang_NullPointerException$object *r4;
	struct _jc_java_lang_String$object *r5;
	struct _jc_java_lang_String$object *r6;
	struct _jc_java_lang_VMThrowable$object *r7;
	struct _jc_java_lang_VMThrowable$object *r9;
	jboolean z0;

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_LINE_NUMBER(737);				// 0
	z0 = _JC_PRIM_FIELD(env, r0, java_net_URLConnection, connected);
	if (z0 == 0)
		goto label0;
	_JC_LINE_NUMBER(738);				// 1
	r3 = _JC_NEW(env, java_lang_IllegalStateException);
	r5 = _JC_STRING(env, "Already connected");
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r7 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r7;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r5;
	_JC_THROW(env, r3);

label0:
	_JC_LINE_NUMBER(740);				// 2
	if (r1 != _JC_NULL)
		goto label1;
	_JC_LINE_NUMBER(741);				// 3
	r4 = _JC_NEW(env, java_lang_NullPointerException);
	r6 = _JC_STRING(env, "key is null");
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r9 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r9;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r6;
	_JC_THROW(env, r4);

label1:
	_JC_LINE_NUMBER(745);				// 4
	return;
}

//
// public void setUseCaches(boolean)
//

static _jc_linenum _jc_java_net_URLConnection$linenum_table$setUseCaches$2ff818bf761e7d51[];

static const unsigned char _jc_java_net_URLConnection$param_ptypes$setUseCaches$2ff818bf761e7d51[] = { 
_JC_TYPE_BOOLEAN, _JC_TYPE_VOID };

static _jc_type *const _jc_java_net_URLConnection$param_types$setUseCaches$2ff818bf761e7d51[] = {
	&_jc_boolean$prim$type
};

_jc_method _jc_java_net_URLConnection$method_info$setUseCaches$2ff818bf761e7d51 = {
	.name=			"setUseCaches",
	.signature=		"(Z)V",
	.class=			&_jc_java_net_URLConnection$type,
	.param_types=		&_jc_java_net_URLConnection$param_types$setUseCaches$2ff818bf761e7d51,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_net_URLConnection$param_ptypes$setUseCaches$2ff818bf761e7d51,
	.signature_hash=	_JC_JLONG(0x2ff818bf761e7d51),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_net_URLConnection$method$setUseCaches$2ff818bf761e7d51,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_net_URLConnection$vtable, java_net_URLConnection.setUseCaches$2ff818bf761e7d51) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_java_net_URLConnection$linenum_table$setUseCaches$2ff818bf761e7d51
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_net_URLConnection, setUseCaches$2ff818bf761e7d51);

void _JC_JCNI_ATTR
_jc_java_net_URLConnection$method$setUseCaches$2ff818bf761e7d51(_jc_env *const env, _jc_java_net_URLConnection$object *this, jboolean param0)
{
	struct _jc_java_net_URLConnection$object *r0;
	struct _jc_java_lang_IllegalStateException$object *r1;
	struct _jc_java_lang_String$object *r2;
	struct _jc_java_lang_VMThrowable$object *r4;
	jboolean z0;
	jboolean z1;

	r0 = this;
	z0 = param0;
	_JC_LINE_NUMBER(648);				// 0
	z1 = _JC_PRIM_FIELD(env, r0, java_net_URLConnection, connected);
	if (z1 == 0)
		goto label0;
	_JC_LINE_NUMBER(649);				// 1
	r1 = _JC_NEW(env, java_lang_IllegalStateException);
	r2 = _JC_STRING(env, "Already connected");
	_JC_REF_FIELD(env, r1, java_lang_Throwable, cause) = r1;
	r4 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r1);
	_JC_REF_FIELD(env, r1, java_lang_Throwable, vmState) = r4;
	_JC_REF_FIELD(env, r1, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r1, java_lang_Throwable, detailMessage) = r2;
	_JC_THROW(env, r1);

label0:
	_JC_LINE_NUMBER(651);				// 2
	_JC_PRIM_FIELD(env, r0, java_net_URLConnection, useCaches) = z0;
	_JC_LINE_NUMBER(652);				// 3
	return;
}

//
// private final void this()
//

static _jc_linenum _jc_java_net_URLConnection$linenum_table$this$adc93fb6bf4cbffa[];

static const unsigned char _jc_java_net_URLConnection$param_ptypes$this$adc93fb6bf4cbffa[] = { 
_JC_TYPE_VOID };

_jc_method _jc_java_net_URLConnection$method_info$this$adc93fb6bf4cbffa = {
	.name=			"this",
	.signature=		"()V",
	.class=			&_jc_java_net_URLConnection$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_net_URLConnection$param_ptypes$this$adc93fb6bf4cbffa,
	.signature_hash=	_JC_JLONG(0xadc93fb6bf4cbffa),
	.access_flags=		_JC_ACC_PRIVATE|_JC_ACC_FINAL,
	.function=		&_jc_java_net_URLConnection$method$this$adc93fb6bf4cbffa,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_net_URLConnection$vtable, java_net_URLConnection.this$adc93fb6bf4cbffa) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_net_URLConnection$linenum_table$this$adc93fb6bf4cbffa
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_net_URLConnection, this$adc93fb6bf4cbffa);

void _JC_JCNI_ATTR
_jc_java_net_URLConnection$method$this$adc93fb6bf4cbffa(_jc_env *const env, _jc_java_net_URLConnection$object *this)
{
	struct _jc_java_net_URLConnection$object *r0;

	r0 = this;
	_JC_LINE_NUMBER(131);				// 0
	_JC_PRIM_FIELD(env, r0, java_net_URLConnection, doInput) = 1;
	return;
}

//
// public java.lang.String toString()
//

static _jc_linenum _jc_java_net_URLConnection$linenum_table$toString$7ea43b33b80a3070[];

static const unsigned char _jc_java_net_URLConnection$param_ptypes$toString$7ea43b33b80a3070[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_java_net_URLConnection$method_info$toString$7ea43b33b80a3070 = {
	.name=			"toString",
	.signature=		"()Ljava/lang/String;",
	.class=			&_jc_java_net_URLConnection$type,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_java_net_URLConnection$param_ptypes$toString$7ea43b33b80a3070,
	.signature_hash=	_JC_JLONG(0x7ea43b33b80a3070),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_net_URLConnection$method$toString$7ea43b33b80a3070,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_net_URLConnection$vtable, java_net_URLConnection.toString$7ea43b33b80a3070) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_net_URLConnection$linenum_table$toString$7ea43b33b80a3070
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_net_URLConnection, toString$7ea43b33b80a3070);

_jc_java_lang_String$object * _JC_JCNI_ATTR
_jc_java_net_URLConnection$method$toString$7ea43b33b80a3070(_jc_env *const env, _jc_java_net_URLConnection$object *this)
{
	struct _jc_java_net_URLConnection$object *r0;
	struct _jc_java_lang_StringBuffer$object *r1;
	struct _jc_java_net_URL$object *r2;
	struct _jc_java_lang_Class$object *r3;
	struct _jc_java_lang_String$object *r4;
	struct _jc_java_net_URLStreamHandler$object *r5;
	struct _jc_java_lang_String$object *r6;
	struct _jc_java_lang_String$object *r7;
	_jc_char_array *r8;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(529);				// 0
	r1 = _JC_NEW(env, java_lang_StringBuffer);
	r8 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r1, java_lang_StringBuffer, value) = r8;
	r3 = _JC_INVOKE_STATIC(env, java_lang_VMObject, getClass$2be11d215bfbfbfe, 0, r0);
	_JC_EXPLICIT_NULL_CHECK(env, r3);
	r4 = _JC_INVOKE_STATIC(env, java_lang_VMClass, getName$7a04fe8e1a654d36, 0, r3);
	r1 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r1, r4);
	r1 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$9450b16e89f0618d, 0, r1, 58);
	r2 = _JC_REF_FIELD(env, r0, java_net_URLConnection, url);
	_JC_EXPLICIT_NULL_CHECK(env, r2);
	r5 = _JC_REF_FIELD(env, r2, java_net_URL, ph);
	r6 = _JC_INVOKE_VIRTUAL(env, java_net_URLStreamHandler, toExternalForm$330af71074ca3ddf, r5, r2);
	r1 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r1, r6);
	r7 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r7, r1);
	return r7;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_java_net_URLConnection$methods[] = {
	&_jc_java_net_URLConnection$method_info$_clinit$a816641e0ba8bfef,
	&_jc_java_net_URLConnection$method_info$_init$52b89ab562ab928f,
	&_jc_java_net_URLConnection$method_info$addRequestProperty$d3f7aaf26425e5e6,
	&_jc_java_net_URLConnection$method_info$connect$47946c90596538d1,
	&_jc_java_net_URLConnection$method_info$getAllowUserInteraction$23c7ca0bdbf1bb02,
	&_jc_java_net_URLConnection$method_info$getContent$3271597a0076ff68,
	&_jc_java_net_URLConnection$method_info$getContent$7409d222b348f073,
	&_jc_java_net_URLConnection$method_info$getContentEncoding$8906dbb8a85e91ee,
	&_jc_java_net_URLConnection$method_info$getContentHandler$1db852928223c7a8,
	&_jc_java_net_URLConnection$method_info$getContentLength$b5dadbc29a008b07,
	&_jc_java_net_URLConnection$method_info$getContentType$c8e5b99f03eb0f46,
	&_jc_java_net_URLConnection$method_info$getDate$318c78d65f032023,
	&_jc_java_net_URLConnection$method_info$getDefaultAllowUserInteraction$d09701796dc63f79,
	&_jc_java_net_URLConnection$method_info$getDefaultRequestProperty$6df05baba26c88af,
	&_jc_java_net_URLConnection$method_info$getDefaultUseCaches$3d125d701e09e9c4,
	&_jc_java_net_URLConnection$method_info$getDoInput$ca428d04f26e4860,
	&_jc_java_net_URLConnection$method_info$getDoOutput$e8fe6558710036d3,
	&_jc_java_net_URLConnection$method_info$getExpiration$fb904de1908bbfb6,
	&_jc_java_net_URLConnection$method_info$getFileNameMap$028f6cf2ec1cbb3a,
	&_jc_java_net_URLConnection$method_info$getHeaderField$90f480508103a444,
	&_jc_java_net_URLConnection$method_info$getHeaderField$0a5e9452a9a469b9,
	&_jc_java_net_URLConnection$method_info$getHeaderFieldDate$3264529c5afce392,
	&_jc_java_net_URLConnection$method_info$getHeaderFieldInt$ea08618f4c9dea2e,
	&_jc_java_net_URLConnection$method_info$getHeaderFieldKey$c97d2ac41219f3d0,
	&_jc_java_net_URLConnection$method_info$getHeaderFields$5a6b4289978b84f3,
	&_jc_java_net_URLConnection$method_info$getIfModifiedSince$b6171bfbf998a96b,
	&_jc_java_net_URLConnection$method_info$getInputStream$13cf75a12cabb343,
	&_jc_java_net_URLConnection$method_info$getLastModified$104f09ee06ce16cc,
	&_jc_java_net_URLConnection$method_info$getOutputStream$1f50a8d1fe1542e3,
	&_jc_java_net_URLConnection$method_info$getPermission$5ed14cf5cad2ace7,
	&_jc_java_net_URLConnection$method_info$getRequestProperties$0037e79e75778205,
	&_jc_java_net_URLConnection$method_info$getRequestProperty$6125fcf5422d16f7,
	&_jc_java_net_URLConnection$method_info$getURL$f8efe3e882b98c02,
	&_jc_java_net_URLConnection$method_info$getUseCaches$ff96603628f311bf,
	&_jc_java_net_URLConnection$method_info$guessContentTypeFromName$5f6649de8ef65c32,
	&_jc_java_net_URLConnection$method_info$guessContentTypeFromStream$8b37cbf53ca7ecf8,
	&_jc_java_net_URLConnection$method_info$initializeDateFormats$f9ce84a1f1f6dd6d,
	&_jc_java_net_URLConnection$method_info$setAllowUserInteraction$81fb57dcd0c165e5,
	&_jc_java_net_URLConnection$method_info$setContentHandlerFactory$dea1706b9cedd905,
	&_jc_java_net_URLConnection$method_info$setDefaultAllowUserInteraction$3984118f13e737a3,
	&_jc_java_net_URLConnection$method_info$setDefaultRequestProperty$93bdfc8df2f7a854,
	&_jc_java_net_URLConnection$method_info$setDefaultUseCaches$619f8926c5a2df9f,
	&_jc_java_net_URLConnection$method_info$setDoInput$8a963ce164df6d9a,
	&_jc_java_net_URLConnection$method_info$setDoOutput$8f1cfbf65496d908,
	&_jc_java_net_URLConnection$method_info$setFileNameMap$91991f3395343483,
	&_jc_java_net_URLConnection$method_info$setIfModifiedSince$e0f7082828db12c6,
	&_jc_java_net_URLConnection$method_info$setRequestProperty$56510cec6e2a2add,
	&_jc_java_net_URLConnection$method_info$setUseCaches$2ff818bf761e7d51,
	&_jc_java_net_URLConnection$method_info$this$adc93fb6bf4cbffa,
	&_jc_java_net_URLConnection$method_info$toString$7ea43b33b80a3070
};

/************************************************************************
 *			  Class fields structure			*
 ************************************************************************/

_jc_java_net_URLConnection$fields_struct _jc_java_net_URLConnection$class_fields = { };

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_java_net_URLConnection$instanceof_hash_bucket_8[] = {
	&_jc_java_net_URLConnection$type,
	_JC_NULL
};
static _jc_type *const _jc_java_net_URLConnection$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_java_net_URLConnection$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[8]=	_jc_java_net_URLConnection$instanceof_hash_bucket_8,
	[101]=	_jc_java_net_URLConnection$instanceof_hash_bucket_101
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_java_net_URLConnection$class_depends[] = {
	{ "java/io/IOException",	_JC_JLONG(0x4e0a56550c69d57c) },
	{ "java/io/InputStream",	_JC_JLONG(0x66aea4d152614ac4) },
	{ "java/io/OutputStream",	_JC_JLONG(0x4026d3144d6654d8) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/ClassNotFoundException",	_JC_JLONG(0x1f925cf50bfc0d6c) },
	{ "java/lang/Error",	_JC_JLONG(0x308333d803f5ab9f) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/IllegalAccessException",	_JC_JLONG(0x29deac5351715967) },
	{ "java/lang/IllegalStateException",	_JC_JLONG(0xb7e704701c278e65) },
	{ "java/lang/InstantiationException",	_JC_JLONG(0xb09d021696f0bbb) },
	{ "java/lang/Integer",	_JC_JLONG(0xca631501391a31f1) },
	{ "java/lang/NullPointerException",	_JC_JLONG(0x505b8a9a6675be0) },
	{ "java/lang/NumberFormatException",	_JC_JLONG(0xa9fd317e4e09506e) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/RuntimeException",	_JC_JLONG(0x4f5534a987354d1d) },
	{ "java/lang/SecurityManager",	_JC_JLONG(0xd38282f3d5f80887) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/StringBuffer",	_JC_JLONG(0x94d357637b968dda) },
	{ "java/lang/System",	_JC_JLONG(0x53cc8e2333795f04) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMClass",	_JC_JLONG(0x238a2c0aafd74314) },
	{ "java/lang/VMObject",	_JC_JLONG(0x312e45ed214d432f) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/net/ContentHandler",	_JC_JLONG(0x4d87ebfc52d36524) },
	{ "java/net/ContentHandlerFactory",	_JC_JLONG(0xd6edcb0ef16d42dc) },
	{ "java/net/FileNameMap",	_JC_JLONG(0xc4a254717010d562) },
	{ "java/net/MimeTypeMapper",	_JC_JLONG(0x662b642c7050afed) },
	{ "java/net/URL",	_JC_JLONG(0x69345d46f4f40e9c) },
	{ "java/net/URLStreamHandler",	_JC_JLONG(0xd7e769aebe17520e) },
	{ "java/net/UnknownServiceException",	_JC_JLONG(0xd6b86851db4dcf14) },
	{ "java/security/AllPermission",	_JC_JLONG(0xb53f70fa48574edf) },
	{ "java/security/Permission",	_JC_JLONG(0x2377c76e79058a72) },
	{ "java/text/ParsePosition",	_JC_JLONG(0x40ba3f7bd03c5728) },
	{ "java/text/SimpleDateFormat",	_JC_JLONG(0x73f981130935b8e5) },
	{ "java/util/Collections",	_JC_JLONG(0x9574af3fed58029a) },
	{ "java/util/Date",	_JC_JLONG(0xa85d2a51094e614c) },
	{ "java/util/Locale",	_JC_JLONG(0xeeb74ad0fcba58b6) },
	{ "java/util/Map",	_JC_JLONG(0xe283f7c2e7a7979c) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_java_net_URLConnection$vtype _jc_java_net_URLConnection$type = {
    .type= {
	.name=			"java/net/URLConnection",
	.superclass=		&_jc_java_lang_Object$type,
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		49,
		.hash=			_JC_JLONG(0x1042c111741aa488),
		.source_file=		"URLConnection.java",
		.instance_size=		sizeof(_jc_java_net_URLConnection$refs) + sizeof(_jc_java_net_URLConnection$object),
		.num_virtual_refs=	2,
		.num_fields=		sizeof(_jc_java_net_URLConnection$fields) / sizeof(*_jc_java_net_URLConnection$fields),
		.fields=		_jc_java_net_URLConnection$fields,
		.num_methods=		sizeof(_jc_java_net_URLConnection$methods) / sizeof(*_jc_java_net_URLConnection$methods),
		.methods=		_jc_java_net_URLConnection$methods,
		.instanceof_hash_table=	_jc_java_net_URLConnection$instanceof_hash_table,
		.class_fields=		&_jc_java_net_URLConnection$class_fields,
		.num_class_depends=		sizeof(_jc_java_net_URLConnection$class_depends) / sizeof(*_jc_java_net_URLConnection$class_depends),
		.class_depends=		_jc_java_net_URLConnection$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=			// overridden
		&_jc_java_net_URLConnection$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.java_net_URLConnection= {
	    .addRequestProperty$d3f7aaf26425e5e6=
		&_jc_java_net_URLConnection$method$addRequestProperty$d3f7aaf26425e5e6,
	    .connect$47946c90596538d1=
		&_jc_java_net_URLConnection$method$connect$47946c90596538d1,
	    .getAllowUserInteraction$23c7ca0bdbf1bb02=
		&_jc_java_net_URLConnection$method$getAllowUserInteraction$23c7ca0bdbf1bb02,
	    .getContent$3271597a0076ff68=
		&_jc_java_net_URLConnection$method$getContent$3271597a0076ff68,
	    .getContent$7409d222b348f073=
		&_jc_java_net_URLConnection$method$getContent$7409d222b348f073,
	    .getContentEncoding$8906dbb8a85e91ee=
		&_jc_java_net_URLConnection$method$getContentEncoding$8906dbb8a85e91ee,
	    .getContentHandler$1db852928223c7a8=
		&_jc_java_net_URLConnection$method$getContentHandler$1db852928223c7a8,
	    .getContentLength$b5dadbc29a008b07=
		&_jc_java_net_URLConnection$method$getContentLength$b5dadbc29a008b07,
	    .getContentType$c8e5b99f03eb0f46=
		&_jc_java_net_URLConnection$method$getContentType$c8e5b99f03eb0f46,
	    .getDate$318c78d65f032023=
		&_jc_java_net_URLConnection$method$getDate$318c78d65f032023,
	    .getDefaultUseCaches$3d125d701e09e9c4=
		&_jc_java_net_URLConnection$method$getDefaultUseCaches$3d125d701e09e9c4,
	    .getDoInput$ca428d04f26e4860=
		&_jc_java_net_URLConnection$method$getDoInput$ca428d04f26e4860,
	    .getDoOutput$e8fe6558710036d3=
		&_jc_java_net_URLConnection$method$getDoOutput$e8fe6558710036d3,
	    .getExpiration$fb904de1908bbfb6=
		&_jc_java_net_URLConnection$method$getExpiration$fb904de1908bbfb6,
	    .getHeaderField$90f480508103a444=
		&_jc_java_net_URLConnection$method$getHeaderField$90f480508103a444,
	    .getHeaderField$0a5e9452a9a469b9=
		&_jc_java_net_URLConnection$method$getHeaderField$0a5e9452a9a469b9,
	    .getHeaderFieldDate$3264529c5afce392=
		&_jc_java_net_URLConnection$method$getHeaderFieldDate$3264529c5afce392,
	    .getHeaderFieldInt$ea08618f4c9dea2e=
		&_jc_java_net_URLConnection$method$getHeaderFieldInt$ea08618f4c9dea2e,
	    .getHeaderFieldKey$c97d2ac41219f3d0=
		&_jc_java_net_URLConnection$method$getHeaderFieldKey$c97d2ac41219f3d0,
	    .getHeaderFields$5a6b4289978b84f3=
		&_jc_java_net_URLConnection$method$getHeaderFields$5a6b4289978b84f3,
	    .getIfModifiedSince$b6171bfbf998a96b=
		&_jc_java_net_URLConnection$method$getIfModifiedSince$b6171bfbf998a96b,
	    .getInputStream$13cf75a12cabb343=
		&_jc_java_net_URLConnection$method$getInputStream$13cf75a12cabb343,
	    .getLastModified$104f09ee06ce16cc=
		&_jc_java_net_URLConnection$method$getLastModified$104f09ee06ce16cc,
	    .getOutputStream$1f50a8d1fe1542e3=
		&_jc_java_net_URLConnection$method$getOutputStream$1f50a8d1fe1542e3,
	    .getPermission$5ed14cf5cad2ace7=
		&_jc_java_net_URLConnection$method$getPermission$5ed14cf5cad2ace7,
	    .getRequestProperties$0037e79e75778205=
		&_jc_java_net_URLConnection$method$getRequestProperties$0037e79e75778205,
	    .getRequestProperty$6125fcf5422d16f7=
		&_jc_java_net_URLConnection$method$getRequestProperty$6125fcf5422d16f7,
	    .getURL$f8efe3e882b98c02=
		&_jc_java_net_URLConnection$method$getURL$f8efe3e882b98c02,
	    .getUseCaches$ff96603628f311bf=
		&_jc_java_net_URLConnection$method$getUseCaches$ff96603628f311bf,
	    .setAllowUserInteraction$81fb57dcd0c165e5=
		&_jc_java_net_URLConnection$method$setAllowUserInteraction$81fb57dcd0c165e5,
	    .setDefaultUseCaches$619f8926c5a2df9f=
		&_jc_java_net_URLConnection$method$setDefaultUseCaches$619f8926c5a2df9f,
	    .setDoInput$8a963ce164df6d9a=
		&_jc_java_net_URLConnection$method$setDoInput$8a963ce164df6d9a,
	    .setDoOutput$8f1cfbf65496d908=
		&_jc_java_net_URLConnection$method$setDoOutput$8f1cfbf65496d908,
	    .setIfModifiedSince$e0f7082828db12c6=
		&_jc_java_net_URLConnection$method$setIfModifiedSince$e0f7082828db12c6,
	    .setRequestProperty$56510cec6e2a2add=
		&_jc_java_net_URLConnection$method$setRequestProperty$56510cec6e2a2add,
	    .setUseCaches$2ff818bf761e7d51=
		&_jc_java_net_URLConnection$method$setUseCaches$2ff818bf761e7d51,
	    .this$adc93fb6bf4cbffa=
		&_jc_java_net_URLConnection$method$this$adc93fb6bf4cbffa,
	    .toString$7ea43b33b80a3070=
		&_jc_java_net_URLConnection$method$toString$7ea43b33b80a3070,
	},
    }
};

