// public abstract class java.nio.ShortBuffer

// class file dependencies
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class d1282e171465288b java_lang_Comparable
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class 680cf34d05feb5a1 java_lang_IllegalArgumentException
// @dep_class 8d71d806a180ad8a java_lang_Math
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class 4f5534a987354d1d java_lang_RuntimeException
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class c4b275d49bb21d98 java_lang_UnsupportedOperationException
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class 9a9842bb79e9de6a java_nio_Buffer
// @dep_class f39bab51256a210e java_nio_BufferOverflowException
// @dep_class 7734c6055a1233d0 java_nio_BufferUnderflowException
// @dep_class 3d4356f2be8683db java_nio_ByteOrder
// @dep_class 42fd78c0e025a665 java_nio_ReadOnlyBufferException
// @dep_class c19d54e04a6b048d java_nio_ShortBuffer
// @dep_class 493cb1035615a764 java_nio_ShortBufferImpl

// header file dependencies
// @dep_header java_lang_Class
// @dep_header java_lang_Comparable
// @dep_header java_lang_IllegalArgumentException
// @dep_header java_lang_Math
// @dep_header java_lang_String
// @dep_header java_lang_VMThrowable
// @dep_header java_nio_BufferOverflowException
// @dep_header java_nio_BufferUnderflowException
// @dep_header java_nio_ByteOrder
// @dep_header java_nio_ReadOnlyBufferException
// @dep_header java_nio_ShortBufferImpl

#include "jc_defs.h"

#include "java/lang/Class.h"
#include "java/lang/Comparable.h"
#include "java/lang/IllegalArgumentException.h"
#include "java/lang/Math.h"
#include "java/lang/String.h"
#include "java/lang/VMThrowable.h"
#include "java/nio/BufferOverflowException.h"
#include "java/nio/BufferUnderflowException.h"
#include "java/nio/ByteOrder.h"
#include "java/nio/ReadOnlyBufferException.h"
#include "java/nio/ShortBufferImpl.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// int array_offset
static _jc_field _jc_java_nio_ShortBuffer$field_info$array__5foffset = {
	.name=		"array_offset",
	.signature=	"I",
	.class=		&_jc_java_nio_ShortBuffer$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	0,
	.offset=	_JC_OFFSETOF(_jc_java_nio_ShortBuffer$object, nonrefs.java_nio_ShortBuffer.array__5foffset),
};

// short[] backing_buffer
static _jc_field _jc_java_nio_ShortBuffer$field_info$backing__5fbuffer = {
	.name=		"backing_buffer",
	.signature=	"[S",
	.class=		&_jc_java_nio_ShortBuffer$type,
	.type=		&_jc_short$array$prim$type,
	.access_flags=	0,
	.offset=	_JC_OFFSETOF(_jc_java_nio_ShortBuffer$object, refs[-1].java_nio_ShortBuffer.backing__5fbuffer),
};

// Fields
static _jc_field *const _jc_java_nio_ShortBuffer$fields[] = {
	&_jc_java_nio_ShortBuffer$field_info$backing__5fbuffer,
	&_jc_java_nio_ShortBuffer$field_info$array__5foffset
};

/************************************************************************
 *			      Static methods				*
 ************************************************************************/

//
// public static java.nio.ShortBuffer allocate(int)
//

static _jc_linenum _jc_java_nio_ShortBuffer$linenum_table$allocate$4b0fe8ff2a159b09[];

static const unsigned char _jc_java_nio_ShortBuffer$param_ptypes$allocate$4b0fe8ff2a159b09[] = { 
_JC_TYPE_INT, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_nio_ShortBuffer$param_types$allocate$4b0fe8ff2a159b09[] = {
	&_jc_int$prim$type
};

_jc_method _jc_java_nio_ShortBuffer$method_info$allocate$4b0fe8ff2a159b09 = {
	.name=			"allocate",
	.signature=		"(I)Ljava/nio/ShortBuffer;",
	.class=			&_jc_java_nio_ShortBuffer$type,
	.param_types=		&_jc_java_nio_ShortBuffer$param_types$allocate$4b0fe8ff2a159b09,
	.return_type=		&_jc_java_nio_ShortBuffer$type,
	.param_ptypes=		&_jc_java_nio_ShortBuffer$param_ptypes$allocate$4b0fe8ff2a159b09,
	.signature_hash=	_JC_JLONG(0x4b0fe8ff2a159b09),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_java_nio_ShortBuffer$method$allocate$4b0fe8ff2a159b09,
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_nio_ShortBuffer$linenum_table$allocate$4b0fe8ff2a159b09
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_nio_ShortBuffer, allocate$4b0fe8ff2a159b09);

_jc_java_nio_ShortBuffer$object * _JC_JCNI_ATTR
_jc_java_nio_ShortBuffer$method$allocate$4b0fe8ff2a159b09(_jc_env *const env, jint param0)
{
	jint i0;
	struct _jc_java_nio_ShortBufferImpl$object *r0;
	_jc_short_array *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	i0 = param0;
	_JC_LINE_NUMBER(61);				// 0
	r0 = _JC_NEW(env, java_nio_ShortBufferImpl);
	r1 = _JC_NEW_PRIM_ARRAY(env, short, 1, i0);
	_JC_INVOKE_NONVIRTUAL(env, java_nio_Buffer, _init$b5870f7bfece007a, 0, r0, i0, i0, 0, -1);
	_JC_PRIM_FIELD(env, r0, java_nio_ShortBuffer, array__5foffset) = 0;
	_JC_REF_FIELD(env, r0, java_nio_ShortBuffer, backing__5fbuffer) = r1;
	_JC_PRIM_FIELD(env, r0, java_nio_ShortBuffer, array__5foffset) = 0;
	_JC_PRIM_FIELD(env, r0, java_nio_ShortBufferImpl, readOnly) = 0;
	return r0;
}

//
// public static final java.nio.ShortBuffer wrap(short[])
//

static _jc_linenum _jc_java_nio_ShortBuffer$linenum_table$wrap$a607b78fe929971e[];

static const unsigned char _jc_java_nio_ShortBuffer$param_ptypes$wrap$a607b78fe929971e[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_nio_ShortBuffer$param_types$wrap$a607b78fe929971e[] = {
	&_jc_short$array$prim$type
};

_jc_method _jc_java_nio_ShortBuffer$method_info$wrap$a607b78fe929971e = {
	.name=			"wrap",
	.signature=		"([S)Ljava/nio/ShortBuffer;",
	.class=			&_jc_java_nio_ShortBuffer$type,
	.param_types=		&_jc_java_nio_ShortBuffer$param_types$wrap$a607b78fe929971e,
	.return_type=		&_jc_java_nio_ShortBuffer$type,
	.param_ptypes=		&_jc_java_nio_ShortBuffer$param_ptypes$wrap$a607b78fe929971e,
	.signature_hash=	_JC_JLONG(0xa607b78fe929971e),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.function=		&_jc_java_nio_ShortBuffer$method$wrap$a607b78fe929971e,
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_nio_ShortBuffer$linenum_table$wrap$a607b78fe929971e
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_nio_ShortBuffer, wrap$a607b78fe929971e);

_jc_java_nio_ShortBuffer$object * _JC_JCNI_ATTR
_jc_java_nio_ShortBuffer$method$wrap$a607b78fe929971e(_jc_env *const env, _jc_short_array *param0)
{
	jint i0;
	jint i2;
	jint i3;
	_jc_short_array *r0;
	struct _jc_java_nio_ShortBufferImpl$object *r3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = param0;
	_JC_LINE_NUMBER(82);				// 0
	i0 = _JC_ARRAY_LENGTH(env, r0);
	r3 = _JC_NEW(env, java_nio_ShortBufferImpl);
	i3 = _JC_ARRAY_LENGTH(env, r0);
	i2 = 0 + i0;
	_JC_INVOKE_NONVIRTUAL(env, java_nio_Buffer, _init$b5870f7bfece007a, 0, r3, i3, i2, 0, -1);
	_JC_PRIM_FIELD(env, r3, java_nio_ShortBuffer, array__5foffset) = 0;
	_JC_REF_FIELD(env, r3, java_nio_ShortBuffer, backing__5fbuffer) = r0;
	_JC_PRIM_FIELD(env, r3, java_nio_ShortBuffer, array__5foffset) = 0;
	_JC_PRIM_FIELD(env, r3, java_nio_ShortBufferImpl, readOnly) = 0;
	return r3;
}

//
// public static final java.nio.ShortBuffer wrap(short[], int, int)
//

static _jc_linenum _jc_java_nio_ShortBuffer$linenum_table$wrap$515222b471e393fc[];

static const unsigned char _jc_java_nio_ShortBuffer$param_ptypes$wrap$515222b471e393fc[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_INT, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_nio_ShortBuffer$param_types$wrap$515222b471e393fc[] = {
	&_jc_short$array$prim$type,
	&_jc_int$prim$type,
	&_jc_int$prim$type
};

_jc_method _jc_java_nio_ShortBuffer$method_info$wrap$515222b471e393fc = {
	.name=			"wrap",
	.signature=		"([SII)Ljava/nio/ShortBuffer;",
	.class=			&_jc_java_nio_ShortBuffer$type,
	.param_types=		&_jc_java_nio_ShortBuffer$param_types$wrap$515222b471e393fc,
	.return_type=		&_jc_java_nio_ShortBuffer$type,
	.param_ptypes=		&_jc_java_nio_ShortBuffer$param_ptypes$wrap$515222b471e393fc,
	.signature_hash=	_JC_JLONG(0x515222b471e393fc),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.function=		&_jc_java_nio_ShortBuffer$method$wrap$515222b471e393fc,
	.num_parameters=	3,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_nio_ShortBuffer$linenum_table$wrap$515222b471e393fc
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_nio_ShortBuffer, wrap$515222b471e393fc);

_jc_java_nio_ShortBuffer$object * _JC_JCNI_ATTR
_jc_java_nio_ShortBuffer$method$wrap$515222b471e393fc(_jc_env *const env, _jc_short_array *param0, jint param1, jint param2)
{
	jint i0;
	jint i1;
	jint i2;
	_jc_short_array *r0;
	struct _jc_java_nio_ShortBufferImpl$object *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = param0;
	i0 = param1;
	i1 = param2;
	_JC_LINE_NUMBER(73);				// 0
	r1 = _JC_NEW(env, java_nio_ShortBufferImpl);
	i2 = _JC_ARRAY_LENGTH(env, r0);
	i1 = i0 + i1;
	_JC_INVOKE_NONVIRTUAL(env, java_nio_Buffer, _init$b5870f7bfece007a, 0, r1, i2, i1, i0, -1);
	_JC_PRIM_FIELD(env, r1, java_nio_ShortBuffer, array__5foffset) = 0;
	_JC_REF_FIELD(env, r1, java_nio_ShortBuffer, backing__5fbuffer) = r0;
	_JC_PRIM_FIELD(env, r1, java_nio_ShortBuffer, array__5foffset) = 0;
	_JC_PRIM_FIELD(env, r1, java_nio_ShortBufferImpl, readOnly) = 0;
	return r1;
}

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// void <init>(int, int, int, int)
//

static _jc_linenum _jc_java_nio_ShortBuffer$linenum_table$_init$b5870f7bfece007a[];

static const unsigned char _jc_java_nio_ShortBuffer$param_ptypes$_init$b5870f7bfece007a[] = { 
_JC_TYPE_INT, _JC_TYPE_INT, _JC_TYPE_INT, _JC_TYPE_INT, _JC_TYPE_VOID };

static _jc_type *const _jc_java_nio_ShortBuffer$param_types$_init$b5870f7bfece007a[] = {
	&_jc_int$prim$type,
	&_jc_int$prim$type,
	&_jc_int$prim$type,
	&_jc_int$prim$type
};

_jc_method _jc_java_nio_ShortBuffer$method_info$_init$b5870f7bfece007a = {
	.name=			"<init>",
	.signature=		"(IIII)V",
	.class=			&_jc_java_nio_ShortBuffer$type,
	.param_types=		&_jc_java_nio_ShortBuffer$param_types$_init$b5870f7bfece007a,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_nio_ShortBuffer$param_ptypes$_init$b5870f7bfece007a,
	.signature_hash=	_JC_JLONG(0xb5870f7bfece007a),
	.access_flags=		0,
	.function=		&_jc_java_nio_ShortBuffer$method$_init$b5870f7bfece007a,
	.num_parameters=	4,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_java_nio_ShortBuffer$linenum_table$_init$b5870f7bfece007a
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_nio_ShortBuffer, _init$b5870f7bfece007a);

void _JC_JCNI_ATTR
_jc_java_nio_ShortBuffer$method$_init$b5870f7bfece007a(_jc_env *const env, _jc_java_nio_ShortBuffer$object *this, jint param0, jint param1, jint param2, jint param3)
{
	jint i0;
	jint i1;
	jint i2;
	jint i3;
	struct _jc_java_nio_ShortBuffer$object *r0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	i0 = param0;
	i1 = param1;
	i2 = param2;
	i3 = param3;
	_JC_LINE_NUMBER(52);				// 0
	_JC_INVOKE_NONVIRTUAL(env, java_nio_Buffer, _init$b5870f7bfece007a, 0, r0, i0, i1, i2, i3);
	_JC_LINE_NUMBER(53);				// 1
	_JC_PRIM_FIELD(env, r0, java_nio_ShortBuffer, array__5foffset) = 0;
	_JC_LINE_NUMBER(54);				// 2
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public final short[] array()
//

static _jc_linenum _jc_java_nio_ShortBuffer$linenum_table$array$29a41ce02f5d6164[];

static const unsigned char _jc_java_nio_ShortBuffer$param_ptypes$array$29a41ce02f5d6164[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_java_nio_ShortBuffer$method_info$array$29a41ce02f5d6164 = {
	.name=			"array",
	.signature=		"()[S",
	.class=			&_jc_java_nio_ShortBuffer$type,
	.return_type=		&_jc_short$array$prim$type,
	.param_ptypes=		&_jc_java_nio_ShortBuffer$param_ptypes$array$29a41ce02f5d6164,
	.signature_hash=	_JC_JLONG(0x29a41ce02f5d6164),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_nio_ShortBuffer$method$array$29a41ce02f5d6164,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_nio_ShortBuffer$vtable, java_nio_ShortBuffer.array$29a41ce02f5d6164) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_java_nio_ShortBuffer$linenum_table$array$29a41ce02f5d6164
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_nio_ShortBuffer, array$29a41ce02f5d6164);

_jc_short_array * _JC_JCNI_ATTR
_jc_java_nio_ShortBuffer$method$array$29a41ce02f5d6164(_jc_env *const env, _jc_java_nio_ShortBuffer$object *this)
{
	struct _jc_java_nio_ShortBuffer$object *r0;
	_jc_short_array *r1;
	struct _jc_java_lang_UnsupportedOperationException$object *r2;
	struct _jc_java_lang_String$object *r3;
	struct _jc_java_lang_VMThrowable$object *r4;
	struct _jc_java_nio_ReadOnlyBufferException$object *r5;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(219);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_nio_ShortBuffer, backing__5fbuffer);
	if (r1 != _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(220);				// 1
	r2 = _JC_NEW(env, java_lang_UnsupportedOperationException);
	r3 = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, cause) = r2;
	r4 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r2);
	_JC_REF_FIELD(env, r2, java_lang_Throwable, vmState) = r4;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, detailMessage) = r3;
	_JC_THROW(env, r2);

label0:
	z0 = _JC_INVOKE_VIRTUAL(env, java_nio_Buffer, isReadOnly$c9d2a7ec56d3b05a, r0);
	if (z0 == 0)
		goto label1;
	r5 = _JC_NEW(env, java_nio_ReadOnlyBufferException);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_Throwable, _init$c31b894660454d13, 0, r5, _JC_NULL);
	_JC_THROW(env, r5);

label1:
	_JC_LINE_NUMBER(224);				// 2
	r1 = _JC_REF_FIELD(env, r0, java_nio_ShortBuffer, backing__5fbuffer);
	return r1;
}

//
// public final int arrayOffset()
//

static _jc_linenum _jc_java_nio_ShortBuffer$linenum_table$arrayOffset$13e3da4ac9e241c7[];

static const unsigned char _jc_java_nio_ShortBuffer$param_ptypes$arrayOffset$13e3da4ac9e241c7[] = { 
_JC_TYPE_INT };

_jc_method _jc_java_nio_ShortBuffer$method_info$arrayOffset$13e3da4ac9e241c7 = {
	.name=			"arrayOffset",
	.signature=		"()I",
	.class=			&_jc_java_nio_ShortBuffer$type,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_java_nio_ShortBuffer$param_ptypes$arrayOffset$13e3da4ac9e241c7,
	.signature_hash=	_JC_JLONG(0x13e3da4ac9e241c7),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_nio_ShortBuffer$method$arrayOffset$13e3da4ac9e241c7,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_nio_ShortBuffer$vtable, java_nio_ShortBuffer.arrayOffset$13e3da4ac9e241c7) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_java_nio_ShortBuffer$linenum_table$arrayOffset$13e3da4ac9e241c7
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_nio_ShortBuffer, arrayOffset$13e3da4ac9e241c7);

jint _JC_JCNI_ATTR
_jc_java_nio_ShortBuffer$method$arrayOffset$13e3da4ac9e241c7(_jc_env *const env, _jc_java_nio_ShortBuffer$object *this)
{
	jint i0;
	struct _jc_java_nio_ShortBuffer$object *r0;
	_jc_short_array *r1;
	struct _jc_java_lang_UnsupportedOperationException$object *r2;
	struct _jc_java_lang_String$object *r3;
	struct _jc_java_lang_VMThrowable$object *r4;
	struct _jc_java_nio_ReadOnlyBufferException$object *r5;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(236);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_nio_ShortBuffer, backing__5fbuffer);
	if (r1 != _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(237);				// 1
	r2 = _JC_NEW(env, java_lang_UnsupportedOperationException);
	r3 = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, cause) = r2;
	r4 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r2);
	_JC_REF_FIELD(env, r2, java_lang_Throwable, vmState) = r4;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, detailMessage) = r3;
	_JC_THROW(env, r2);

label0:
	z0 = _JC_INVOKE_VIRTUAL(env, java_nio_Buffer, isReadOnly$c9d2a7ec56d3b05a, r0);
	if (z0 == 0)
		goto label1;
	r5 = _JC_NEW(env, java_nio_ReadOnlyBufferException);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_Throwable, _init$c31b894660454d13, 0, r5, _JC_NULL);
	_JC_THROW(env, r5);

label1:
	_JC_LINE_NUMBER(241);				// 2
	i0 = _JC_PRIM_FIELD(env, r0, java_nio_ShortBuffer, array__5foffset);
	return i0;
}

//
// public abstract java.nio.ShortBuffer asReadOnlyBuffer()
//

static const unsigned char _jc_java_nio_ShortBuffer$param_ptypes$asReadOnlyBuffer$e16bca61d0ca5b5a[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_java_nio_ShortBuffer$method_info$asReadOnlyBuffer$e16bca61d0ca5b5a = {
	.name=			"asReadOnlyBuffer",
	.signature=		"()Ljava/nio/ShortBuffer;",
	.class=			&_jc_java_nio_ShortBuffer$type,
	.return_type=		&_jc_java_nio_ShortBuffer$type,
	.param_ptypes=		&_jc_java_nio_ShortBuffer$param_ptypes$asReadOnlyBuffer$e16bca61d0ca5b5a,
	.signature_hash=	_JC_JLONG(0xe16bca61d0ca5b5a),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.function=		&_jc_java_nio_ShortBuffer$method$asReadOnlyBuffer$e16bca61d0ca5b5a,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_nio_ShortBuffer$vtable, java_nio_ShortBuffer.asReadOnlyBuffer$e16bca61d0ca5b5a) / sizeof(void *),
	.num_parameters=	0,
};

_jc_java_nio_ShortBuffer$object * _JC_JCNI_ATTR
_jc_java_nio_ShortBuffer$method$asReadOnlyBuffer$e16bca61d0ca5b5a(_jc_env *const env, _jc_java_nio_ShortBuffer$object *this)
{
	_JC_ABSTRACT_METHOD(env, &_jc_java_nio_ShortBuffer$method_info$asReadOnlyBuffer$e16bca61d0ca5b5a);
}

//
// public abstract java.nio.ShortBuffer compact()
//

static const unsigned char _jc_java_nio_ShortBuffer$param_ptypes$compact$074049392a349607[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_java_nio_ShortBuffer$method_info$compact$074049392a349607 = {
	.name=			"compact",
	.signature=		"()Ljava/nio/ShortBuffer;",
	.class=			&_jc_java_nio_ShortBuffer$type,
	.return_type=		&_jc_java_nio_ShortBuffer$type,
	.param_ptypes=		&_jc_java_nio_ShortBuffer$param_ptypes$compact$074049392a349607,
	.signature_hash=	_JC_JLONG(0x74049392a349607),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.function=		&_jc_java_nio_ShortBuffer$method$compact$074049392a349607,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_nio_ShortBuffer$vtable, java_nio_ShortBuffer.compact$074049392a349607) / sizeof(void *),
	.num_parameters=	0,
};

_jc_java_nio_ShortBuffer$object * _JC_JCNI_ATTR
_jc_java_nio_ShortBuffer$method$compact$074049392a349607(_jc_env *const env, _jc_java_nio_ShortBuffer$object *this)
{
	_JC_ABSTRACT_METHOD(env, &_jc_java_nio_ShortBuffer$method_info$compact$074049392a349607);
}

//
// public int compareTo(java.lang.Object)
//

static _jc_linenum _jc_java_nio_ShortBuffer$linenum_table$compareTo$84fc6fc4a23c98a3[];

static const unsigned char _jc_java_nio_ShortBuffer$param_ptypes$compareTo$84fc6fc4a23c98a3[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT };

static _jc_type *const _jc_java_nio_ShortBuffer$param_types$compareTo$84fc6fc4a23c98a3[] = {
	&_jc_java_lang_Object$type
};

_jc_method _jc_java_nio_ShortBuffer$method_info$compareTo$84fc6fc4a23c98a3 = {
	.name=			"compareTo",
	.signature=		"(Ljava/lang/Object;)I",
	.class=			&_jc_java_nio_ShortBuffer$type,
	.param_types=		&_jc_java_nio_ShortBuffer$param_types$compareTo$84fc6fc4a23c98a3,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_java_nio_ShortBuffer$param_ptypes$compareTo$84fc6fc4a23c98a3,
	.signature_hash=	_JC_JLONG(0x84fc6fc4a23c98a3),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_nio_ShortBuffer$method$compareTo$84fc6fc4a23c98a3,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_nio_ShortBuffer$vtable, java_nio_ShortBuffer.compareTo$84fc6fc4a23c98a3) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	11,
	      .table=	_jc_java_nio_ShortBuffer$linenum_table$compareTo$84fc6fc4a23c98a3
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_nio_ShortBuffer, compareTo$84fc6fc4a23c98a3);

jint _JC_JCNI_ATTR
_jc_java_nio_ShortBuffer$method$compareTo$84fc6fc4a23c98a3(_jc_env *const env, _jc_java_nio_ShortBuffer$object *this, _jc_java_lang_Object$object *param0)
{
	jint i0;
	jint i1;
	jint i10;
	jint i11;
	jint i12;
	jint i13;
	jint i14;
	jint i15;
	jint i16;
	jint i18;
	jint i2;
	jint i3;
	jint i6;
	jint i7;
	jint i8;
	jint i9;
	struct _jc_java_nio_ShortBuffer$object *r0;
	struct _jc_java_lang_Object$object *r1;
	struct _jc_java_nio_ShortBuffer$object *r2;
	jshort s4;
	jshort s5;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(290);				// 0
	r2 = _JC_CAST(env, &_jc_java_nio_ShortBuffer$type, r1);
	i9 = _JC_PRIM_FIELD(env, r0, java_nio_Buffer, limit);
	i10 = _JC_PRIM_FIELD(env, r0, java_nio_Buffer, pos);
	i10 = i9 - i10;
	_JC_EXPLICIT_NULL_CHECK(env, r2);
	i11 = _JC_PRIM_FIELD(env, r2, java_nio_Buffer, limit);
	i12 = _JC_PRIM_FIELD(env, r2, java_nio_Buffer, pos);
	i12 = i11 - i12;
	_JC_ACTIVE_USE(env, java_lang_Math);
	if (i10 >= i12)
		goto label0;
	i18 = i10;
	goto label1;

label0:
	i18 = i12;

label1:
	i0 = i18;
	i7 = _JC_PRIM_FIELD(env, r0, java_nio_Buffer, pos);
	i1 = i7;
	i8 = _JC_PRIM_FIELD(env, r2, java_nio_Buffer, pos);
	i2 = i8;
	_JC_LINE_NUMBER(296);				// 1
	i3 = 0;
	goto label6;

label2:
	_JC_LINE_NUMBER(298);				// 2
	i6 = i1;
	i1 = i1 + 1;
	s4 = _JC_INVOKE_VIRTUAL(env, java_nio_ShortBuffer, get$49fa6634224ee1db, r0, i6);
	_JC_LINE_NUMBER(299);				// 3
	i6 = i2;
	i2 = i2 + 1;
	s5 = _JC_INVOKE_VIRTUAL(env, java_nio_ShortBuffer, get$49fa6634224ee1db, r2, i6);
	_JC_LINE_NUMBER(301);				// 4
	if (s4 != s5)
		goto label3;
	_JC_LINE_NUMBER(302);				// 5
	goto label5;

label3:
	_JC_LINE_NUMBER(304);				// 6
	if (s4 >= s5)
		goto label4;
	_JC_LINE_NUMBER(305);				// 7
	return -1;

label4:
	_JC_LINE_NUMBER(307);				// 8
	return 1;

label5:
	_JC_LINE_NUMBER(296);				// 9
	i3 = i3 + 1;

label6:
	if (i3 < i0) {
		_JC_PERIODIC_CHECK(env);
		goto label2;
	}
	i13 = _JC_PRIM_FIELD(env, r0, java_nio_Buffer, limit);
	i14 = _JC_PRIM_FIELD(env, r0, java_nio_Buffer, pos);
	i14 = i13 - i14;
	i15 = _JC_PRIM_FIELD(env, r2, java_nio_Buffer, limit);
	i16 = _JC_PRIM_FIELD(env, r2, java_nio_Buffer, pos);
	i16 = i15 - i16;
	_JC_LINE_NUMBER(310);				// 10
	i6 = i14 - i16;
	return i6;
}

//
// public abstract java.nio.ShortBuffer duplicate()
//

static const unsigned char _jc_java_nio_ShortBuffer$param_ptypes$duplicate$d54be3dbef68fee5[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_java_nio_ShortBuffer$method_info$duplicate$d54be3dbef68fee5 = {
	.name=			"duplicate",
	.signature=		"()Ljava/nio/ShortBuffer;",
	.class=			&_jc_java_nio_ShortBuffer$type,
	.return_type=		&_jc_java_nio_ShortBuffer$type,
	.param_ptypes=		&_jc_java_nio_ShortBuffer$param_ptypes$duplicate$d54be3dbef68fee5,
	.signature_hash=	_JC_JLONG(0xd54be3dbef68fee5),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.function=		&_jc_java_nio_ShortBuffer$method$duplicate$d54be3dbef68fee5,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_nio_ShortBuffer$vtable, java_nio_ShortBuffer.duplicate$d54be3dbef68fee5) / sizeof(void *),
	.num_parameters=	0,
};

_jc_java_nio_ShortBuffer$object * _JC_JCNI_ATTR
_jc_java_nio_ShortBuffer$method$duplicate$d54be3dbef68fee5(_jc_env *const env, _jc_java_nio_ShortBuffer$object *this)
{
	_JC_ABSTRACT_METHOD(env, &_jc_java_nio_ShortBuffer$method_info$duplicate$d54be3dbef68fee5);
}

//
// public boolean equals(java.lang.Object)
//

static _jc_linenum _jc_java_nio_ShortBuffer$linenum_table$equals$8a15e0625571c581[];

static const unsigned char _jc_java_nio_ShortBuffer$param_ptypes$equals$8a15e0625571c581[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_java_nio_ShortBuffer$param_types$equals$8a15e0625571c581[] = {
	&_jc_java_lang_Object$type
};

_jc_method _jc_java_nio_ShortBuffer$method_info$equals$8a15e0625571c581 = {
	.name=			"equals",
	.signature=		"(Ljava/lang/Object;)Z",
	.class=			&_jc_java_nio_ShortBuffer$type,
	.param_types=		&_jc_java_nio_ShortBuffer$param_types$equals$8a15e0625571c581,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_java_nio_ShortBuffer$param_ptypes$equals$8a15e0625571c581,
	.signature_hash=	_JC_JLONG(0x8a15e0625571c581),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_nio_ShortBuffer$method$equals$8a15e0625571c581,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_nio_ShortBuffer$vtable, java_nio_ShortBuffer.equals$8a15e0625571c581) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_java_nio_ShortBuffer$linenum_table$equals$8a15e0625571c581
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_nio_ShortBuffer, equals$8a15e0625571c581);

jboolean _JC_JCNI_ATTR
_jc_java_nio_ShortBuffer$method$equals$8a15e0625571c581(_jc_env *const env, _jc_java_nio_ShortBuffer$object *this, _jc_java_lang_Object$object *param0)
{
	jint i0;
	struct _jc_java_nio_ShortBuffer$object *r0;
	struct _jc_java_lang_Object$object *r1;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(274);				// 0
	z0 = _JC_INSTANCEOF(env, r1, &_jc_java_nio_ShortBuffer$type);
	if (z0 == 0)
		goto label1;
	_JC_LINE_NUMBER(276);				// 1
	z0 = 0;
	i0 = _JC_INVOKE_VIRTUAL(env, java_nio_ShortBuffer, compareTo$84fc6fc4a23c98a3, r0, r1);
	if (i0 != 0)
		goto label0;
	z0 = 1;

label0:
	return z0;

label1:
	_JC_LINE_NUMBER(279);				// 2
	return 0;
}

//
// public abstract short get()
//

static const unsigned char _jc_java_nio_ShortBuffer$param_ptypes$get$d5fdaabd0d770244[] = { 
_JC_TYPE_SHORT };

_jc_method _jc_java_nio_ShortBuffer$method_info$get$d5fdaabd0d770244 = {
	.name=			"get",
	.signature=		"()S",
	.class=			&_jc_java_nio_ShortBuffer$type,
	.return_type=		&_jc_short$prim$type,
	.param_ptypes=		&_jc_java_nio_ShortBuffer$param_ptypes$get$d5fdaabd0d770244,
	.signature_hash=	_JC_JLONG(0xd5fdaabd0d770244),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.function=		&_jc_java_nio_ShortBuffer$method$get$d5fdaabd0d770244,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_nio_ShortBuffer$vtable, java_nio_ShortBuffer.get$d5fdaabd0d770244) / sizeof(void *),
	.num_parameters=	0,
};

jshort _JC_JCNI_ATTR
_jc_java_nio_ShortBuffer$method$get$d5fdaabd0d770244(_jc_env *const env, _jc_java_nio_ShortBuffer$object *this)
{
	_JC_ABSTRACT_METHOD(env, &_jc_java_nio_ShortBuffer$method_info$get$d5fdaabd0d770244);
}

//
// public abstract short get(int)
//

static const unsigned char _jc_java_nio_ShortBuffer$param_ptypes$get$49fa6634224ee1db[] = { 
_JC_TYPE_INT, _JC_TYPE_SHORT };

static _jc_type *const _jc_java_nio_ShortBuffer$param_types$get$49fa6634224ee1db[] = {
	&_jc_int$prim$type
};

_jc_method _jc_java_nio_ShortBuffer$method_info$get$49fa6634224ee1db = {
	.name=			"get",
	.signature=		"(I)S",
	.class=			&_jc_java_nio_ShortBuffer$type,
	.param_types=		&_jc_java_nio_ShortBuffer$param_types$get$49fa6634224ee1db,
	.return_type=		&_jc_short$prim$type,
	.param_ptypes=		&_jc_java_nio_ShortBuffer$param_ptypes$get$49fa6634224ee1db,
	.signature_hash=	_JC_JLONG(0x49fa6634224ee1db),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.function=		&_jc_java_nio_ShortBuffer$method$get$49fa6634224ee1db,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_nio_ShortBuffer$vtable, java_nio_ShortBuffer.get$49fa6634224ee1db) / sizeof(void *),
	.num_parameters=	1,
};

jshort _JC_JCNI_ATTR
_jc_java_nio_ShortBuffer$method$get$49fa6634224ee1db(_jc_env *const env, _jc_java_nio_ShortBuffer$object *this, jint param0)
{
	_JC_ABSTRACT_METHOD(env, &_jc_java_nio_ShortBuffer$method_info$get$49fa6634224ee1db);
}

//
// public java.nio.ShortBuffer get(short[])
//

static _jc_linenum _jc_java_nio_ShortBuffer$linenum_table$get$516577f0b64d25dd[];

static const unsigned char _jc_java_nio_ShortBuffer$param_ptypes$get$516577f0b64d25dd[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_nio_ShortBuffer$param_types$get$516577f0b64d25dd[] = {
	&_jc_short$array$prim$type
};

_jc_method _jc_java_nio_ShortBuffer$method_info$get$516577f0b64d25dd = {
	.name=			"get",
	.signature=		"([S)Ljava/nio/ShortBuffer;",
	.class=			&_jc_java_nio_ShortBuffer$type,
	.param_types=		&_jc_java_nio_ShortBuffer$param_types$get$516577f0b64d25dd,
	.return_type=		&_jc_java_nio_ShortBuffer$type,
	.param_ptypes=		&_jc_java_nio_ShortBuffer$param_ptypes$get$516577f0b64d25dd,
	.signature_hash=	_JC_JLONG(0x516577f0b64d25dd),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_nio_ShortBuffer$method$get$516577f0b64d25dd,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_nio_ShortBuffer$vtable, java_nio_ShortBuffer.get$516577f0b64d25dd) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_nio_ShortBuffer$linenum_table$get$516577f0b64d25dd
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_nio_ShortBuffer, get$516577f0b64d25dd);

_jc_java_nio_ShortBuffer$object * _JC_JCNI_ATTR
_jc_java_nio_ShortBuffer$method$get$516577f0b64d25dd(_jc_env *const env, _jc_java_nio_ShortBuffer$object *this, _jc_short_array *param0)
{
	jint i0;
	struct _jc_java_nio_ShortBuffer$object *r0;
	_jc_short_array *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(125);				// 0
	i0 = _JC_ARRAY_LENGTH(env, r1);
	r0 = _JC_INVOKE_VIRTUAL(env, java_nio_ShortBuffer, get$5f4d4557abecebb5, r0, r1, 0, i0);
	return r0;
}

//
// public java.nio.ShortBuffer get(short[], int, int)
//

static _jc_linenum _jc_java_nio_ShortBuffer$linenum_table$get$5f4d4557abecebb5[];

static const unsigned char _jc_java_nio_ShortBuffer$param_ptypes$get$5f4d4557abecebb5[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_INT, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_nio_ShortBuffer$param_types$get$5f4d4557abecebb5[] = {
	&_jc_short$array$prim$type,
	&_jc_int$prim$type,
	&_jc_int$prim$type
};

_jc_method _jc_java_nio_ShortBuffer$method_info$get$5f4d4557abecebb5 = {
	.name=			"get",
	.signature=		"([SII)Ljava/nio/ShortBuffer;",
	.class=			&_jc_java_nio_ShortBuffer$type,
	.param_types=		&_jc_java_nio_ShortBuffer$param_types$get$5f4d4557abecebb5,
	.return_type=		&_jc_java_nio_ShortBuffer$type,
	.param_ptypes=		&_jc_java_nio_ShortBuffer$param_ptypes$get$5f4d4557abecebb5,
	.signature_hash=	_JC_JLONG(0x5f4d4557abecebb5),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_nio_ShortBuffer$method$get$5f4d4557abecebb5,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_nio_ShortBuffer$vtable, java_nio_ShortBuffer.get$5f4d4557abecebb5) / sizeof(void *),
	.num_parameters=	3,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_java_nio_ShortBuffer$linenum_table$get$5f4d4557abecebb5
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_nio_ShortBuffer, get$5f4d4557abecebb5);

_jc_java_nio_ShortBuffer$object * _JC_JCNI_ATTR
_jc_java_nio_ShortBuffer$method$get$5f4d4557abecebb5(_jc_env *const env, _jc_java_nio_ShortBuffer$object *this, _jc_short_array *param0, jint param1, jint param2)
{
	jint i0;
	jint i1;
	jint i2;
	jint i4;
	jint i5;
	jint i6;
	struct _jc_java_nio_ShortBuffer$object *r0;
	_jc_short_array *r1;
	struct _jc_java_nio_BufferUnderflowException$object *r2;
	struct _jc_java_lang_String$object *r3;
	struct _jc_java_lang_VMThrowable$object *r5;
	jshort s3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	i0 = param1;
	i1 = param2;
	_JC_LINE_NUMBER(103);				// 0
	i2 = _JC_ARRAY_LENGTH(env, r1);
	_JC_INVOKE_STATIC(env, java_nio_Buffer, checkArraySize$d42162f7759dd789, 1, i2, i0, i1);
	i5 = _JC_PRIM_FIELD(env, r0, java_nio_Buffer, limit);
	i6 = _JC_PRIM_FIELD(env, r0, java_nio_Buffer, pos);
	i6 = i5 - i6;
	if (i6 >= i1)
		goto label0;
	r2 = _JC_NEW(env, java_nio_BufferUnderflowException);
	r3 = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, cause) = r2;
	r5 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r2);
	_JC_REF_FIELD(env, r2, java_lang_Throwable, vmState) = r5;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, detailMessage) = r3;
	_JC_THROW(env, r2);

label0:
	_JC_LINE_NUMBER(106);				// 1
	i2 = i0;
	goto label2;

label1:
	_JC_LINE_NUMBER(108);				// 2
	s3 = _JC_INVOKE_VIRTUAL(env, java_nio_ShortBuffer, get$d5fdaabd0d770244, r0);
	_JC_PRIM_ELEMENT(env, short, r1, i2, 1, 1) = s3;
	_JC_LINE_NUMBER(106);				// 3
	i2 = i2 + 1;

label2:
	i4 = i0 + i1;
	if (i2 < i4) {
		_JC_PERIODIC_CHECK(env);
		goto label1;
	}
	_JC_LINE_NUMBER(111);				// 4
	return r0;
}

//
// public final boolean hasArray()
//

static _jc_linenum _jc_java_nio_ShortBuffer$linenum_table$hasArray$a97034f27845dc36[];

static const unsigned char _jc_java_nio_ShortBuffer$param_ptypes$hasArray$a97034f27845dc36[] = { 
_JC_TYPE_BOOLEAN };

_jc_method _jc_java_nio_ShortBuffer$method_info$hasArray$a97034f27845dc36 = {
	.name=			"hasArray",
	.signature=		"()Z",
	.class=			&_jc_java_nio_ShortBuffer$type,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_java_nio_ShortBuffer$param_ptypes$hasArray$a97034f27845dc36,
	.signature_hash=	_JC_JLONG(0xa97034f27845dc36),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_nio_ShortBuffer$method$hasArray$a97034f27845dc36,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_nio_ShortBuffer$vtable, java_nio_ShortBuffer.hasArray$a97034f27845dc36) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_nio_ShortBuffer$linenum_table$hasArray$a97034f27845dc36
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_nio_ShortBuffer, hasArray$a97034f27845dc36);

jboolean _JC_JCNI_ATTR
_jc_java_nio_ShortBuffer$method$hasArray$a97034f27845dc36(_jc_env *const env, _jc_java_nio_ShortBuffer$object *this)
{
	struct _jc_java_nio_ShortBuffer$object *r0;
	_jc_short_array *r1;
	jboolean z0;
	jboolean z1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(206);				// 0
	z0 = 0;
	r1 = _JC_REF_FIELD(env, r0, java_nio_ShortBuffer, backing__5fbuffer);
	if (r1 == _JC_NULL)
		goto label0;
	z1 = _JC_INVOKE_VIRTUAL(env, java_nio_Buffer, isReadOnly$c9d2a7ec56d3b05a, r0);
	if (z1 != 0)
		goto label0;
	z0 = 1;

label0:
	return z0;
}

//
// public int hashCode()
//

static _jc_linenum _jc_java_nio_ShortBuffer$linenum_table$hashCode$53152098849316df[];

static const unsigned char _jc_java_nio_ShortBuffer$param_ptypes$hashCode$53152098849316df[] = { 
_JC_TYPE_INT };

_jc_method _jc_java_nio_ShortBuffer$method_info$hashCode$53152098849316df = {
	.name=			"hashCode",
	.signature=		"()I",
	.class=			&_jc_java_nio_ShortBuffer$type,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_java_nio_ShortBuffer$param_ptypes$hashCode$53152098849316df,
	.signature_hash=	_JC_JLONG(0x53152098849316df),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_nio_ShortBuffer$method$hashCode$53152098849316df,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_nio_ShortBuffer$vtable, java_nio_ShortBuffer.hashCode$53152098849316df) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	7,
	      .table=	_jc_java_nio_ShortBuffer$linenum_table$hashCode$53152098849316df
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_nio_ShortBuffer, hashCode$53152098849316df);

jint _JC_JCNI_ATTR
_jc_java_nio_ShortBuffer$method$hashCode$53152098849316df(_jc_env *const env, _jc_java_nio_ShortBuffer$object *this)
{
	jint i0;
	jint i1;
	jint i2;
	jint i4;
	jint i5;
	jint i6;
	jint i7;
	struct _jc_java_nio_ShortBuffer$object *r0;
	jshort s3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	i5 = _JC_PRIM_FIELD(env, r0, java_nio_Buffer, pos);
	_JC_LINE_NUMBER(259);				// 0
	s3 = _JC_INVOKE_VIRTUAL(env, java_nio_ShortBuffer, get$49fa6634224ee1db, r0, i5);
	i0 = s3 + 31;
	_JC_LINE_NUMBER(260);				// 1
	i1 = 1;
	i6 = _JC_PRIM_FIELD(env, r0, java_nio_Buffer, pos);
	_JC_LINE_NUMBER(261);				// 2
	i2 = i6 + 1;
	goto label1;

label0:
	_JC_LINE_NUMBER(263);				// 3
	i1 = i1 * 31;
	_JC_LINE_NUMBER(264);				// 4
	s3 = _JC_INVOKE_VIRTUAL(env, java_nio_ShortBuffer, get$49fa6634224ee1db, r0, i2);
	i4 = s3 + 30;
	i4 = i4 * i1;
	i0 = i0 + i4;
	_JC_LINE_NUMBER(261);				// 5
	i2 = i2 + 1;

label1:
	i7 = _JC_PRIM_FIELD(env, r0, java_nio_Buffer, limit);
	if (i2 < i7) {
		_JC_PERIODIC_CHECK(env);
		goto label0;
	}
	_JC_LINE_NUMBER(266);				// 6
	return i0;
}

//
// public abstract boolean isDirect()
//

static const unsigned char _jc_java_nio_ShortBuffer$param_ptypes$isDirect$701a988eba5b5121[] = { 
_JC_TYPE_BOOLEAN };

_jc_method _jc_java_nio_ShortBuffer$method_info$isDirect$701a988eba5b5121 = {
	.name=			"isDirect",
	.signature=		"()Z",
	.class=			&_jc_java_nio_ShortBuffer$type,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_java_nio_ShortBuffer$param_ptypes$isDirect$701a988eba5b5121,
	.signature_hash=	_JC_JLONG(0x701a988eba5b5121),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.function=		&_jc_java_nio_ShortBuffer$method$isDirect$701a988eba5b5121,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_nio_ShortBuffer$vtable, java_nio_ShortBuffer.isDirect$701a988eba5b5121) / sizeof(void *),
	.num_parameters=	0,
};

jboolean _JC_JCNI_ATTR
_jc_java_nio_ShortBuffer$method$isDirect$701a988eba5b5121(_jc_env *const env, _jc_java_nio_ShortBuffer$object *this)
{
	_JC_ABSTRACT_METHOD(env, &_jc_java_nio_ShortBuffer$method_info$isDirect$701a988eba5b5121);
}

//
// public abstract java.nio.ByteOrder order()
//

static const unsigned char _jc_java_nio_ShortBuffer$param_ptypes$order$8e403d4eb30b9a07[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_java_nio_ShortBuffer$method_info$order$8e403d4eb30b9a07 = {
	.name=			"order",
	.signature=		"()Ljava/nio/ByteOrder;",
	.class=			&_jc_java_nio_ShortBuffer$type,
	.return_type=		&_jc_java_nio_ByteOrder$type,
	.param_ptypes=		&_jc_java_nio_ShortBuffer$param_ptypes$order$8e403d4eb30b9a07,
	.signature_hash=	_JC_JLONG(0x8e403d4eb30b9a07),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.function=		&_jc_java_nio_ShortBuffer$method$order$8e403d4eb30b9a07,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_nio_ShortBuffer$vtable, java_nio_ShortBuffer.order$8e403d4eb30b9a07) / sizeof(void *),
	.num_parameters=	0,
};

_jc_java_nio_ByteOrder$object * _JC_JCNI_ATTR
_jc_java_nio_ShortBuffer$method$order$8e403d4eb30b9a07(_jc_env *const env, _jc_java_nio_ShortBuffer$object *this)
{
	_JC_ABSTRACT_METHOD(env, &_jc_java_nio_ShortBuffer$method_info$order$8e403d4eb30b9a07);
}

//
// public abstract java.nio.ShortBuffer put(int, short)
//

static const unsigned char _jc_java_nio_ShortBuffer$param_ptypes$put$5001a7dd73e04531[] = { 
_JC_TYPE_INT, _JC_TYPE_SHORT, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_nio_ShortBuffer$param_types$put$5001a7dd73e04531[] = {
	&_jc_int$prim$type,
	&_jc_short$prim$type
};

_jc_method _jc_java_nio_ShortBuffer$method_info$put$5001a7dd73e04531 = {
	.name=			"put",
	.signature=		"(IS)Ljava/nio/ShortBuffer;",
	.class=			&_jc_java_nio_ShortBuffer$type,
	.param_types=		&_jc_java_nio_ShortBuffer$param_types$put$5001a7dd73e04531,
	.return_type=		&_jc_java_nio_ShortBuffer$type,
	.param_ptypes=		&_jc_java_nio_ShortBuffer$param_ptypes$put$5001a7dd73e04531,
	.signature_hash=	_JC_JLONG(0x5001a7dd73e04531),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.function=		&_jc_java_nio_ShortBuffer$method$put$5001a7dd73e04531,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_nio_ShortBuffer$vtable, java_nio_ShortBuffer.put$5001a7dd73e04531) / sizeof(void *),
	.num_parameters=	2,
};

_jc_java_nio_ShortBuffer$object * _JC_JCNI_ATTR
_jc_java_nio_ShortBuffer$method$put$5001a7dd73e04531(_jc_env *const env, _jc_java_nio_ShortBuffer$object *this, jint param0, jshort param1)
{
	_JC_ABSTRACT_METHOD(env, &_jc_java_nio_ShortBuffer$method_info$put$5001a7dd73e04531);
}

//
// public java.nio.ShortBuffer put(java.nio.ShortBuffer)
//

static _jc_linenum _jc_java_nio_ShortBuffer$linenum_table$put$a9fd4d55ccbd29e9[];

static const unsigned char _jc_java_nio_ShortBuffer$param_ptypes$put$a9fd4d55ccbd29e9[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_nio_ShortBuffer$param_types$put$a9fd4d55ccbd29e9[] = {
	&_jc_java_nio_ShortBuffer$type
};

_jc_method _jc_java_nio_ShortBuffer$method_info$put$a9fd4d55ccbd29e9 = {
	.name=			"put",
	.signature=		"(Ljava/nio/ShortBuffer;)Ljava/nio/ShortBuffer;",
	.class=			&_jc_java_nio_ShortBuffer$type,
	.param_types=		&_jc_java_nio_ShortBuffer$param_types$put$a9fd4d55ccbd29e9,
	.return_type=		&_jc_java_nio_ShortBuffer$type,
	.param_ptypes=		&_jc_java_nio_ShortBuffer$param_ptypes$put$a9fd4d55ccbd29e9,
	.signature_hash=	_JC_JLONG(0xa9fd4d55ccbd29e9),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_nio_ShortBuffer$method$put$a9fd4d55ccbd29e9,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_nio_ShortBuffer$vtable, java_nio_ShortBuffer.put$a9fd4d55ccbd29e9) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	7,
	      .table=	_jc_java_nio_ShortBuffer$linenum_table$put$a9fd4d55ccbd29e9
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_nio_ShortBuffer, put$a9fd4d55ccbd29e9);

_jc_java_nio_ShortBuffer$object * _JC_JCNI_ATTR
_jc_java_nio_ShortBuffer$method$put$a9fd4d55ccbd29e9(_jc_env *const env, _jc_java_nio_ShortBuffer$object *this, _jc_java_nio_ShortBuffer$object *param0)
{
	jint i0;
	jint i1;
	jint i2;
	jint i3;
	jint i4;
	jint i5;
	jint i6;
	struct _jc_java_nio_ShortBuffer$object *r0;
	struct _jc_java_nio_ShortBuffer$object *r1;
	_jc_short_array *r2;
	struct _jc_java_lang_IllegalArgumentException$object *r3;
	struct _jc_java_lang_String$object *r4;
	struct _jc_java_lang_VMThrowable$object *r6;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(142);				// 0
	if (r1 != r0)
		goto label0;
	_JC_LINE_NUMBER(143);				// 1
	r3 = _JC_NEW(env, java_lang_IllegalArgumentException);
	r4 = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r6 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r6;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r4;
	_JC_THROW(env, r3);

label0:
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	i1 = _JC_PRIM_FIELD(env, r1, java_nio_Buffer, limit);
	i2 = _JC_PRIM_FIELD(env, r1, java_nio_Buffer, pos);
	i2 = i1 - i2;
	_JC_LINE_NUMBER(145);				// 2
	_JC_INVOKE_NONVIRTUAL(env, java_nio_Buffer, checkForOverflow$b9e028f3489bc38f, 0, r0, i2);
	i3 = _JC_PRIM_FIELD(env, r1, java_nio_Buffer, limit);
	i4 = _JC_PRIM_FIELD(env, r1, java_nio_Buffer, pos);
	i4 = i3 - i4;
	_JC_LINE_NUMBER(147);				// 3
	if (i4 <= 0)
		goto label1;
	i5 = _JC_PRIM_FIELD(env, r1, java_nio_Buffer, limit);
	i6 = _JC_PRIM_FIELD(env, r1, java_nio_Buffer, pos);
	i6 = i5 - i6;
	_JC_LINE_NUMBER(149);				// 4
	r2 = _JC_NEW_PRIM_ARRAY(env, short, 1, i6);
	_JC_LINE_NUMBER(150);				// 5
	_JC_INVOKE_VIRTUAL(env, java_nio_ShortBuffer, get$516577f0b64d25dd, r1, r2);
	i0 = _JC_ARRAY_LENGTH(env, r2);
	_JC_INVOKE_VIRTUAL(env, java_nio_ShortBuffer, put$d0ff77d895f15537, r0, r2, 0, i0);

label1:
	_JC_LINE_NUMBER(154);				// 6
	return r0;
}

//
// public abstract java.nio.ShortBuffer put(short)
//

static const unsigned char _jc_java_nio_ShortBuffer$param_ptypes$put$55738b24277acd0d[] = { 
_JC_TYPE_SHORT, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_nio_ShortBuffer$param_types$put$55738b24277acd0d[] = {
	&_jc_short$prim$type
};

_jc_method _jc_java_nio_ShortBuffer$method_info$put$55738b24277acd0d = {
	.name=			"put",
	.signature=		"(S)Ljava/nio/ShortBuffer;",
	.class=			&_jc_java_nio_ShortBuffer$type,
	.param_types=		&_jc_java_nio_ShortBuffer$param_types$put$55738b24277acd0d,
	.return_type=		&_jc_java_nio_ShortBuffer$type,
	.param_ptypes=		&_jc_java_nio_ShortBuffer$param_ptypes$put$55738b24277acd0d,
	.signature_hash=	_JC_JLONG(0x55738b24277acd0d),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.function=		&_jc_java_nio_ShortBuffer$method$put$55738b24277acd0d,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_nio_ShortBuffer$vtable, java_nio_ShortBuffer.put$55738b24277acd0d) / sizeof(void *),
	.num_parameters=	1,
};

_jc_java_nio_ShortBuffer$object * _JC_JCNI_ATTR
_jc_java_nio_ShortBuffer$method$put$55738b24277acd0d(_jc_env *const env, _jc_java_nio_ShortBuffer$object *this, jshort param0)
{
	_JC_ABSTRACT_METHOD(env, &_jc_java_nio_ShortBuffer$method_info$put$55738b24277acd0d);
}

//
// public final java.nio.ShortBuffer put(short[])
//

static _jc_linenum _jc_java_nio_ShortBuffer$linenum_table$put$e8375b4f079ba9e0[];

static const unsigned char _jc_java_nio_ShortBuffer$param_ptypes$put$e8375b4f079ba9e0[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_nio_ShortBuffer$param_types$put$e8375b4f079ba9e0[] = {
	&_jc_short$array$prim$type
};

_jc_method _jc_java_nio_ShortBuffer$method_info$put$e8375b4f079ba9e0 = {
	.name=			"put",
	.signature=		"([S)Ljava/nio/ShortBuffer;",
	.class=			&_jc_java_nio_ShortBuffer$type,
	.param_types=		&_jc_java_nio_ShortBuffer$param_types$put$e8375b4f079ba9e0,
	.return_type=		&_jc_java_nio_ShortBuffer$type,
	.param_ptypes=		&_jc_java_nio_ShortBuffer$param_ptypes$put$e8375b4f079ba9e0,
	.signature_hash=	_JC_JLONG(0xe8375b4f079ba9e0),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_nio_ShortBuffer$method$put$e8375b4f079ba9e0,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_nio_ShortBuffer$vtable, java_nio_ShortBuffer.put$e8375b4f079ba9e0) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_nio_ShortBuffer$linenum_table$put$e8375b4f079ba9e0
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_nio_ShortBuffer, put$e8375b4f079ba9e0);

_jc_java_nio_ShortBuffer$object * _JC_JCNI_ATTR
_jc_java_nio_ShortBuffer$method$put$e8375b4f079ba9e0(_jc_env *const env, _jc_java_nio_ShortBuffer$object *this, _jc_short_array *param0)
{
	jint i0;
	struct _jc_java_nio_ShortBuffer$object *r0;
	_jc_short_array *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(197);				// 0
	i0 = _JC_ARRAY_LENGTH(env, r1);
	r0 = _JC_INVOKE_VIRTUAL(env, java_nio_ShortBuffer, put$d0ff77d895f15537, r0, r1, 0, i0);
	return r0;
}

//
// public java.nio.ShortBuffer put(short[], int, int)
//

static _jc_linenum _jc_java_nio_ShortBuffer$linenum_table$put$d0ff77d895f15537[];

static const unsigned char _jc_java_nio_ShortBuffer$param_ptypes$put$d0ff77d895f15537[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_INT, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_nio_ShortBuffer$param_types$put$d0ff77d895f15537[] = {
	&_jc_short$array$prim$type,
	&_jc_int$prim$type,
	&_jc_int$prim$type
};

_jc_method _jc_java_nio_ShortBuffer$method_info$put$d0ff77d895f15537 = {
	.name=			"put",
	.signature=		"([SII)Ljava/nio/ShortBuffer;",
	.class=			&_jc_java_nio_ShortBuffer$type,
	.param_types=		&_jc_java_nio_ShortBuffer$param_types$put$d0ff77d895f15537,
	.return_type=		&_jc_java_nio_ShortBuffer$type,
	.param_ptypes=		&_jc_java_nio_ShortBuffer$param_ptypes$put$d0ff77d895f15537,
	.signature_hash=	_JC_JLONG(0xd0ff77d895f15537),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_nio_ShortBuffer$method$put$d0ff77d895f15537,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_nio_ShortBuffer$vtable, java_nio_ShortBuffer.put$d0ff77d895f15537) / sizeof(void *),
	.num_parameters=	3,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_java_nio_ShortBuffer$linenum_table$put$d0ff77d895f15537
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_nio_ShortBuffer, put$d0ff77d895f15537);

_jc_java_nio_ShortBuffer$object * _JC_JCNI_ATTR
_jc_java_nio_ShortBuffer$method$put$d0ff77d895f15537(_jc_env *const env, _jc_java_nio_ShortBuffer$object *this, _jc_short_array *param0, jint param1, jint param2)
{
	jint i0;
	jint i1;
	jint i2;
	jint i4;
	jint i5;
	jint i6;
	struct _jc_java_nio_ShortBuffer$object *r0;
	_jc_short_array *r1;
	struct _jc_java_nio_BufferOverflowException$object *r2;
	struct _jc_java_lang_String$object *r3;
	struct _jc_java_lang_VMThrowable$object *r5;
	jshort s3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	i0 = param1;
	i1 = param2;
	_JC_LINE_NUMBER(176);				// 0
	i2 = _JC_ARRAY_LENGTH(env, r1);
	_JC_INVOKE_STATIC(env, java_nio_Buffer, checkArraySize$d42162f7759dd789, 1, i2, i0, i1);
	i5 = _JC_PRIM_FIELD(env, r0, java_nio_Buffer, limit);
	i6 = _JC_PRIM_FIELD(env, r0, java_nio_Buffer, pos);
	i6 = i5 - i6;
	if (i6 >= i1)
		goto label0;
	r2 = _JC_NEW(env, java_nio_BufferOverflowException);
	r3 = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, cause) = r2;
	r5 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r2);
	_JC_REF_FIELD(env, r2, java_lang_Throwable, vmState) = r5;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, detailMessage) = r3;
	_JC_THROW(env, r2);

label0:
	_JC_LINE_NUMBER(179);				// 1
	i2 = i0;
	goto label2;

label1:
	_JC_LINE_NUMBER(180);				// 2
	s3 = _JC_PRIM_ELEMENT(env, short, r1, i2, 1, 1);
	_JC_INVOKE_VIRTUAL(env, java_nio_ShortBuffer, put$55738b24277acd0d, r0, s3);
	_JC_LINE_NUMBER(179);				// 3
	i2 = i2 + 1;

label2:
	i4 = i0 + i1;
	if (i2 < i4) {
		_JC_PERIODIC_CHECK(env);
		goto label1;
	}
	_JC_LINE_NUMBER(182);				// 4
	return r0;
}

//
// public abstract java.nio.ShortBuffer slice()
//

static const unsigned char _jc_java_nio_ShortBuffer$param_ptypes$slice$7dc0315927f998e1[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_java_nio_ShortBuffer$method_info$slice$7dc0315927f998e1 = {
	.name=			"slice",
	.signature=		"()Ljava/nio/ShortBuffer;",
	.class=			&_jc_java_nio_ShortBuffer$type,
	.return_type=		&_jc_java_nio_ShortBuffer$type,
	.param_ptypes=		&_jc_java_nio_ShortBuffer$param_ptypes$slice$7dc0315927f998e1,
	.signature_hash=	_JC_JLONG(0x7dc0315927f998e1),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.function=		&_jc_java_nio_ShortBuffer$method$slice$7dc0315927f998e1,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_nio_ShortBuffer$vtable, java_nio_ShortBuffer.slice$7dc0315927f998e1) / sizeof(void *),
	.num_parameters=	0,
};

_jc_java_nio_ShortBuffer$object * _JC_JCNI_ATTR
_jc_java_nio_ShortBuffer$method$slice$7dc0315927f998e1(_jc_env *const env, _jc_java_nio_ShortBuffer$object *this)
{
	_JC_ABSTRACT_METHOD(env, &_jc_java_nio_ShortBuffer$method_info$slice$7dc0315927f998e1);
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_java_nio_ShortBuffer$methods[] = {
	&_jc_java_nio_ShortBuffer$method_info$_init$b5870f7bfece007a,
	&_jc_java_nio_ShortBuffer$method_info$allocate$4b0fe8ff2a159b09,
	&_jc_java_nio_ShortBuffer$method_info$array$29a41ce02f5d6164,
	&_jc_java_nio_ShortBuffer$method_info$arrayOffset$13e3da4ac9e241c7,
	&_jc_java_nio_ShortBuffer$method_info$asReadOnlyBuffer$e16bca61d0ca5b5a,
	&_jc_java_nio_ShortBuffer$method_info$compact$074049392a349607,
	&_jc_java_nio_ShortBuffer$method_info$compareTo$84fc6fc4a23c98a3,
	&_jc_java_nio_ShortBuffer$method_info$duplicate$d54be3dbef68fee5,
	&_jc_java_nio_ShortBuffer$method_info$equals$8a15e0625571c581,
	&_jc_java_nio_ShortBuffer$method_info$get$d5fdaabd0d770244,
	&_jc_java_nio_ShortBuffer$method_info$get$49fa6634224ee1db,
	&_jc_java_nio_ShortBuffer$method_info$get$516577f0b64d25dd,
	&_jc_java_nio_ShortBuffer$method_info$get$5f4d4557abecebb5,
	&_jc_java_nio_ShortBuffer$method_info$hasArray$a97034f27845dc36,
	&_jc_java_nio_ShortBuffer$method_info$hashCode$53152098849316df,
	&_jc_java_nio_ShortBuffer$method_info$isDirect$701a988eba5b5121,
	&_jc_java_nio_ShortBuffer$method_info$order$8e403d4eb30b9a07,
	&_jc_java_nio_ShortBuffer$method_info$put$5001a7dd73e04531,
	&_jc_java_nio_ShortBuffer$method_info$put$a9fd4d55ccbd29e9,
	&_jc_java_nio_ShortBuffer$method_info$put$55738b24277acd0d,
	&_jc_java_nio_ShortBuffer$method_info$put$e8375b4f079ba9e0,
	&_jc_java_nio_ShortBuffer$method_info$put$d0ff77d895f15537,
	&_jc_java_nio_ShortBuffer$method_info$slice$7dc0315927f998e1,
	&_jc_java_nio_ShortBuffer$method_info$wrap$a607b78fe929971e,
	&_jc_java_nio_ShortBuffer$method_info$wrap$515222b471e393fc
};

/************************************************************************
 *			      Interface list				*
 ************************************************************************/

// Directly implemented interfaces
static _jc_type *const _jc_java_nio_ShortBuffer$interfaces[] = {
	&_jc_java_lang_Comparable$type
};

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_java_nio_ShortBuffer$instanceof_hash_bucket_11[] = {
	&_jc_java_lang_Comparable$type,
	_JC_NULL
};
static _jc_type *const _jc_java_nio_ShortBuffer$instanceof_hash_bucket_13[] = {
	&_jc_java_nio_ShortBuffer$type,
	_JC_NULL
};
static _jc_type *const _jc_java_nio_ShortBuffer$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};
static _jc_type *const _jc_java_nio_ShortBuffer$instanceof_hash_bucket_106[] = {
	&_jc_java_nio_Buffer$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_java_nio_ShortBuffer$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[11]=	_jc_java_nio_ShortBuffer$instanceof_hash_bucket_11,
	[13]=	_jc_java_nio_ShortBuffer$instanceof_hash_bucket_13,
	[101]=	_jc_java_nio_ShortBuffer$instanceof_hash_bucket_101,
	[106]=	_jc_java_nio_ShortBuffer$instanceof_hash_bucket_106
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_java_nio_ShortBuffer$class_depends[] = {
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/Comparable",	_JC_JLONG(0xd1282e171465288b) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/IllegalArgumentException",	_JC_JLONG(0x680cf34d05feb5a1) },
	{ "java/lang/Math",	_JC_JLONG(0x8d71d806a180ad8a) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/RuntimeException",	_JC_JLONG(0x4f5534a987354d1d) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/UnsupportedOperationException",	_JC_JLONG(0xc4b275d49bb21d98) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/nio/Buffer",	_JC_JLONG(0x9a9842bb79e9de6a) },
	{ "java/nio/BufferOverflowException",	_JC_JLONG(0xf39bab51256a210e) },
	{ "java/nio/BufferUnderflowException",	_JC_JLONG(0x7734c6055a1233d0) },
	{ "java/nio/ByteOrder",	_JC_JLONG(0x3d4356f2be8683db) },
	{ "java/nio/ReadOnlyBufferException",	_JC_JLONG(0x42fd78c0e025a665) },
	{ "java/nio/ShortBufferImpl",	_JC_JLONG(0x493cb1035615a764) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_java_nio_ShortBuffer$vtype _jc_java_nio_ShortBuffer$type = {
    .type= {
	.name=			"java/nio/ShortBuffer",
	.superclass=		&_jc_java_nio_Buffer$type,
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.flags=			_JC_TYPE_REFERENCE,
	.num_interfaces=sizeof(_jc_java_nio_ShortBuffer$interfaces) / sizeof(*_jc_java_nio_ShortBuffer$interfaces),
	.interfaces=		_jc_java_nio_ShortBuffer$interfaces,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		52,
		.hash=			_JC_JLONG(0xc19d54e04a6b048d),
		.source_file=		"ShortBuffer.java",
		.instance_size=		sizeof(_jc_java_nio_ShortBuffer$refs) + sizeof(_jc_java_nio_ShortBuffer$object),
		.num_virtual_refs=	2,
		.num_fields=		sizeof(_jc_java_nio_ShortBuffer$fields) / sizeof(*_jc_java_nio_ShortBuffer$fields),
		.fields=		_jc_java_nio_ShortBuffer$fields,
		.num_methods=		sizeof(_jc_java_nio_ShortBuffer$methods) / sizeof(*_jc_java_nio_ShortBuffer$methods),
		.methods=		_jc_java_nio_ShortBuffer$methods,
		.instanceof_hash_table=	_jc_java_nio_ShortBuffer$instanceof_hash_table,
		.num_class_depends=		sizeof(_jc_java_nio_ShortBuffer$class_depends) / sizeof(*_jc_java_nio_ShortBuffer$class_depends),
		.class_depends=		_jc_java_nio_ShortBuffer$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=			// overridden
		&_jc_java_nio_ShortBuffer$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=			// overridden
		&_jc_java_nio_ShortBuffer$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.java_nio_Buffer= {
	    .capacity$710006e6a48024f9=
		&_jc_java_nio_Buffer$method$capacity$710006e6a48024f9,
	    .checkForOverflow$44062addbf6036c0=
		&_jc_java_nio_Buffer$method$checkForOverflow$44062addbf6036c0,
	    .checkForOverflow$b9e028f3489bc38f=
		&_jc_java_nio_Buffer$method$checkForOverflow$b9e028f3489bc38f,
	    .checkForUnderflow$2290fa79c2e3a54e=
		&_jc_java_nio_Buffer$method$checkForUnderflow$2290fa79c2e3a54e,
	    .checkForUnderflow$936250af93b7fab9=
		&_jc_java_nio_Buffer$method$checkForUnderflow$936250af93b7fab9,
	    .checkIfReadOnly$492fe1ba6468544c=
		&_jc_java_nio_Buffer$method$checkIfReadOnly$492fe1ba6468544c,
	    .checkIndex$6227e414e2a38003=
		&_jc_java_nio_Buffer$method$checkIndex$6227e414e2a38003,
	    .clear$3832557bfec16399=
		&_jc_java_nio_Buffer$method$clear$3832557bfec16399,
	    .flip$ebcf7cfb7f28bce1=
		&_jc_java_nio_Buffer$method$flip$ebcf7cfb7f28bce1,
	    .hasRemaining$ee0f9cba75e6bf5c=
		&_jc_java_nio_Buffer$method$hasRemaining$ee0f9cba75e6bf5c,
	    .isReadOnly$c9d2a7ec56d3b05a=
		&_jc_java_nio_Buffer$method$isReadOnly$c9d2a7ec56d3b05a,
	    .limit$c7d8256de1526bbe=
		&_jc_java_nio_Buffer$method$limit$c7d8256de1526bbe,
	    .limit$a97be2529a541ab1=
		&_jc_java_nio_Buffer$method$limit$a97be2529a541ab1,
	    .mark$a89122115e994b99=
		&_jc_java_nio_Buffer$method$mark$a89122115e994b99,
	    .position$995316fe61682ec8=
		&_jc_java_nio_Buffer$method$position$995316fe61682ec8,
	    .position$290451e9cb4842fa=
		&_jc_java_nio_Buffer$method$position$290451e9cb4842fa,
	    .remaining$47e87ac5e4e58b98=
		&_jc_java_nio_Buffer$method$remaining$47e87ac5e4e58b98,
	    .reset$1b74e684943230b4=
		&_jc_java_nio_Buffer$method$reset$1b74e684943230b4,
	    .rewind$ca8f52a6b64ca83b=
		&_jc_java_nio_Buffer$method$rewind$ca8f52a6b64ca83b,
	    .this$adc93fb6bf4cbffa=
		&_jc_java_nio_Buffer$method$this$adc93fb6bf4cbffa,
	},
	.java_nio_ShortBuffer= {
	    .array$29a41ce02f5d6164=
		&_jc_java_nio_ShortBuffer$method$array$29a41ce02f5d6164,
	    .arrayOffset$13e3da4ac9e241c7=
		&_jc_java_nio_ShortBuffer$method$arrayOffset$13e3da4ac9e241c7,
	    .asReadOnlyBuffer$e16bca61d0ca5b5a=
		&_jc_java_nio_ShortBuffer$method$asReadOnlyBuffer$e16bca61d0ca5b5a,
	    .compact$074049392a349607=
		&_jc_java_nio_ShortBuffer$method$compact$074049392a349607,
	    .compareTo$84fc6fc4a23c98a3=
		&_jc_java_nio_ShortBuffer$method$compareTo$84fc6fc4a23c98a3,
	    .duplicate$d54be3dbef68fee5=
		&_jc_java_nio_ShortBuffer$method$duplicate$d54be3dbef68fee5,
	    .equals$8a15e0625571c581=
		&_jc_java_nio_ShortBuffer$method$equals$8a15e0625571c581,
	    .get$d5fdaabd0d770244=
		&_jc_java_nio_ShortBuffer$method$get$d5fdaabd0d770244,
	    .get$49fa6634224ee1db=
		&_jc_java_nio_ShortBuffer$method$get$49fa6634224ee1db,
	    .get$516577f0b64d25dd=
		&_jc_java_nio_ShortBuffer$method$get$516577f0b64d25dd,
	    .get$5f4d4557abecebb5=
		&_jc_java_nio_ShortBuffer$method$get$5f4d4557abecebb5,
	    .hasArray$a97034f27845dc36=
		&_jc_java_nio_ShortBuffer$method$hasArray$a97034f27845dc36,
	    .hashCode$53152098849316df=
		&_jc_java_nio_ShortBuffer$method$hashCode$53152098849316df,
	    .isDirect$701a988eba5b5121=
		&_jc_java_nio_ShortBuffer$method$isDirect$701a988eba5b5121,
	    .order$8e403d4eb30b9a07=
		&_jc_java_nio_ShortBuffer$method$order$8e403d4eb30b9a07,
	    .put$5001a7dd73e04531=
		&_jc_java_nio_ShortBuffer$method$put$5001a7dd73e04531,
	    .put$a9fd4d55ccbd29e9=
		&_jc_java_nio_ShortBuffer$method$put$a9fd4d55ccbd29e9,
	    .put$55738b24277acd0d=
		&_jc_java_nio_ShortBuffer$method$put$55738b24277acd0d,
	    .put$e8375b4f079ba9e0=
		&_jc_java_nio_ShortBuffer$method$put$e8375b4f079ba9e0,
	    .put$d0ff77d895f15537=
		&_jc_java_nio_ShortBuffer$method$put$d0ff77d895f15537,
	    .slice$7dc0315927f998e1=
		&_jc_java_nio_ShortBuffer$method$slice$7dc0315927f998e1,
	},
    }
};

