// public class java.security.KeyFactory

// class file dependencies
// @dep_class f4ba095546954b36 gnu_java_security_Engine
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class f02ab3ccb490a6d0 java_lang_ClassCastException
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class 680cf34d05feb5a1 java_lang_IllegalArgumentException
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class 4f5534a987354d1d java_lang_RuntimeException
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class ae4a2342b31a268d java_lang_reflect_InvocationTargetException
// @dep_class 692089051f4c8d0b java_security_GeneralSecurityException
// @dep_class 94dda41e9bf6c170 java_security_InvalidKeyException
// @dep_class a467c6cd05d9cc51 java_security_Key
// @dep_class 5d14b6c072276d8f java_security_KeyFactory
// @dep_class 5208a7db73e048db java_security_KeyFactorySpi
// @dep_class 22e937c2536160b4 java_security_NoSuchAlgorithmException
// @dep_class 8dfbf242adab91e java_security_NoSuchProviderException
// @dep_class dcdbe4a102f59043 java_security_PrivateKey
// @dep_class 81b073051aa30acc java_security_Provider
// @dep_class 4db3ac05e70e2bf8 java_security_PublicKey
// @dep_class 89bf77984bd9669e java_security_Security
// @dep_class 602c9e525972bdb8 java_security_spec_InvalidKeySpecException
// @dep_class e5bd533daf8dcb9a java_security_spec_KeySpec
// @dep_class c53e1575b095109b java_util_Vector

// header file dependencies
// @dep_header gnu_java_security_Engine
// @dep_header java_lang_Class
// @dep_header java_lang_ClassCastException
// @dep_header java_lang_IllegalArgumentException
// @dep_header java_lang_String
// @dep_header java_lang_VMThrowable
// @dep_header java_lang_reflect_InvocationTargetException
// @dep_header java_security_InvalidKeyException
// @dep_header java_security_Key
// @dep_header java_security_KeyFactory
// @dep_header java_security_KeyFactorySpi
// @dep_header java_security_NoSuchAlgorithmException
// @dep_header java_security_NoSuchProviderException
// @dep_header java_security_PrivateKey
// @dep_header java_security_Provider
// @dep_header java_security_PublicKey
// @dep_header java_security_Security
// @dep_header java_security_spec_InvalidKeySpecException
// @dep_header java_security_spec_KeySpec
// @dep_header java_util_Vector

#include "jc_defs.h"

#include "gnu/java/security/Engine.h"
#include "java/lang/Class.h"
#include "java/lang/ClassCastException.h"
#include "java/lang/IllegalArgumentException.h"
#include "java/lang/String.h"
#include "java/lang/VMThrowable.h"
#include "java/lang/reflect/InvocationTargetException.h"
#include "java/security/InvalidKeyException.h"
#include "java/security/Key.h"
#include "java/security/KeyFactory.h"
#include "java/security/KeyFactorySpi.h"
#include "java/security/NoSuchAlgorithmException.h"
#include "java/security/NoSuchProviderException.h"
#include "java/security/PrivateKey.h"
#include "java/security/Provider.h"
#include "java/security/PublicKey.h"
#include "java/security/Security.h"
#include "java/security/spec/InvalidKeySpecException.h"
#include "java/security/spec/KeySpec.h"
#include "java/util/Vector.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// private static final java.lang.String KEY_FACTORY
static _jc_field _jc_java_security_KeyFactory$field_info$KEY__5fFACTORY = {
	.name=		"KEY_FACTORY",
	.signature=	"Ljava/lang/String;",
	.class=		&_jc_java_security_KeyFactory$type,
	.type=		&_jc_java_lang_String$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_java_security_KeyFactory$fields_struct, KEY__5fFACTORY),
	.initial_value=	"KeyFactory",
};

// private java.security.KeyFactorySpi keyFacSpi
static _jc_field _jc_java_security_KeyFactory$field_info$keyFacSpi = {
	.name=		"keyFacSpi",
	.signature=	"Ljava/security/KeyFactorySpi;",
	.class=		&_jc_java_security_KeyFactory$type,
	.type=		&_jc_java_security_KeyFactorySpi$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_security_KeyFactory$object, refs[-1].java_security_KeyFactory.keyFacSpi),
};

// private java.security.Provider provider
static _jc_field _jc_java_security_KeyFactory$field_info$provider = {
	.name=		"provider",
	.signature=	"Ljava/security/Provider;",
	.class=		&_jc_java_security_KeyFactory$type,
	.type=		&_jc_java_security_Provider$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_security_KeyFactory$object, refs[-1].java_security_KeyFactory.provider),
};

// private java.lang.String algorithm
static _jc_field _jc_java_security_KeyFactory$field_info$algorithm = {
	.name=		"algorithm",
	.signature=	"Ljava/lang/String;",
	.class=		&_jc_java_security_KeyFactory$type,
	.type=		&_jc_java_lang_String$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_security_KeyFactory$object, refs[-1].java_security_KeyFactory.algorithm),
};

// Fields
static _jc_field *const _jc_java_security_KeyFactory$fields[] = {
	&_jc_java_security_KeyFactory$field_info$KEY__5fFACTORY,
	&_jc_java_security_KeyFactory$field_info$algorithm,
	&_jc_java_security_KeyFactory$field_info$keyFacSpi,
	&_jc_java_security_KeyFactory$field_info$provider
};

/************************************************************************
 *			      Static methods				*
 ************************************************************************/

//
// public static java.security.KeyFactory getInstance(java.lang.String) throws java.security.NoSuchAlgorithmException
//

static _jc_linenum _jc_java_security_KeyFactory$linenum_table$getInstance$328aacb0878c9499[];

static _jc_trap_info _jc_java_security_KeyFactory$trap_table$getInstance$328aacb0878c9499[] = {
	_JC_TRAP(&_jc_java_security_NoSuchAlgorithmException$type, 1, 2),
};

static const unsigned char _jc_java_security_KeyFactory$param_ptypes$getInstance$328aacb0878c9499[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_security_KeyFactory$exceptions$getInstance$328aacb0878c9499[] = {
	&_jc_java_security_NoSuchAlgorithmException$type
};

static _jc_type *const _jc_java_security_KeyFactory$param_types$getInstance$328aacb0878c9499[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_java_security_KeyFactory$method_info$getInstance$328aacb0878c9499 = {
	.name=			"getInstance",
	.signature=		"(Ljava/lang/String;)Ljava/security/KeyFactory;",
	.class=			&_jc_java_security_KeyFactory$type,
	.param_types=		&_jc_java_security_KeyFactory$param_types$getInstance$328aacb0878c9499,
	.return_type=		&_jc_java_security_KeyFactory$type,
	.param_ptypes=		&_jc_java_security_KeyFactory$param_ptypes$getInstance$328aacb0878c9499,
	.signature_hash=	_JC_JLONG(0x328aacb0878c9499),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_java_security_KeyFactory$method$getInstance$328aacb0878c9499,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_security_KeyFactory$exceptions$getInstance$328aacb0878c9499,
	.u= { .exec= {
	  .trap_table_len=	1,
	  .trap_table=		_jc_java_security_KeyFactory$trap_table$getInstance$328aacb0878c9499,
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_java_security_KeyFactory$linenum_table$getInstance$328aacb0878c9499
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_KeyFactory, getInstance$328aacb0878c9499);

_jc_java_security_KeyFactory$object * _JC_JCNI_ATTR
_jc_java_security_KeyFactory$method$getInstance$328aacb0878c9499(_jc_env *const env, _jc_java_lang_String$object *param0)
{
	jint volatile i0;
	jint volatile i1;
	jint i2;
	struct _jc_java_lang_String$object *volatile r0;
	struct _jc_java_security_Provider$object *volatile r2;
	struct _jc_java_security_KeyFactory$object *volatile r3;
	struct _jc_java_security_NoSuchAlgorithmException$object *volatile r4;
	struct _jc_java_lang_VMThrowable$object *volatile r5;
	struct _jc_java_util_Vector$object *r6;
	_jc_object_array *volatile r7;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_java_security_KeyFactory$method_info$getInstance$328aacb0878c9499, &&label1);

	r0 = param0;
	_JC_ACTIVE_USE(env, java_security_Security);
	_JC_LINE_NUMBER(129);				// 0
	r6 = _JC_STATIC_FIELD(env, java_security_Security, providers, 1);
	i2 = _JC_INVOKE_VIRTUAL(env, java_util_Vector, size$345df5220fc60ade, r6);
	r7 = _JC_NEW_REF_ARRAY(env, java_security_Provider, 1, i2);
	r6 = _JC_STATIC_FIELD(env, java_security_Security, providers, 1);
	_JC_INVOKE_VIRTUAL(env, java_util_Vector, copyInto$cd78d768b3ba4735, r6, r7);
	_JC_LINE_NUMBER(130);				// 1
	i0 = 0;
	goto label2;

label0:
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(133);				// 2
	r2 = _JC_REF_ELEMENT(env, r7, i0, 1, 1);
	r3 = _JC_INVOKE_STATIC(env, java_security_KeyFactory, getInstance$d2d620a0afde4c10, 0, r0, r2);
	_JC_TRAP_REGION(catch, 2);
	_JC_CANCEL_TRAPS(env, catch);
	return r3;

label1:
	_JC_TRAP_REGION(catch, 2);
	r4 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(130);				// 3
	i0 = i0 + 1;

label2:
	_JC_TRAP_REGION(catch, 2);
	i1 = _JC_ARRAY_LENGTH(env, r7);
	if (i0 < i1) {
		_JC_PERIODIC_CHECK(env);
		goto label0;
	}
	_JC_LINE_NUMBER(140);				// 4
	r4 = _JC_NEW(env, java_security_NoSuchAlgorithmException);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r5 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r5;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r0;
	_JC_THROW(env, r4);
}

//
// public static java.security.KeyFactory getInstance(java.lang.String, java.lang.String) throws java.security.NoSuchAlgorithmException, java.security.NoSuchProviderException
//

static _jc_linenum _jc_java_security_KeyFactory$linenum_table$getInstance$38881e0268f1e10f[];

static const unsigned char _jc_java_security_KeyFactory$param_ptypes$getInstance$38881e0268f1e10f[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_security_KeyFactory$exceptions$getInstance$38881e0268f1e10f[] = {
	&_jc_java_security_NoSuchAlgorithmException$type,
	&_jc_java_security_NoSuchProviderException$type
};

static _jc_type *const _jc_java_security_KeyFactory$param_types$getInstance$38881e0268f1e10f[] = {
	&_jc_java_lang_String$type,
	&_jc_java_lang_String$type
};

_jc_method _jc_java_security_KeyFactory$method_info$getInstance$38881e0268f1e10f = {
	.name=			"getInstance",
	.signature=		"(Ljava/lang/String;Ljava/lang/String;)Ljava/security/KeyFactory;",
	.class=			&_jc_java_security_KeyFactory$type,
	.param_types=		&_jc_java_security_KeyFactory$param_types$getInstance$38881e0268f1e10f,
	.return_type=		&_jc_java_security_KeyFactory$type,
	.param_ptypes=		&_jc_java_security_KeyFactory$param_ptypes$getInstance$38881e0268f1e10f,
	.signature_hash=	_JC_JLONG(0x38881e0268f1e10f),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_java_security_KeyFactory$method$getInstance$38881e0268f1e10f,
	.num_parameters=	2,
	.num_exceptions=	2,
	.exceptions=		&_jc_java_security_KeyFactory$exceptions$getInstance$38881e0268f1e10f,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	6,
	      .table=	_jc_java_security_KeyFactory$linenum_table$getInstance$38881e0268f1e10f
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_KeyFactory, getInstance$38881e0268f1e10f);

_jc_java_security_KeyFactory$object * _JC_JCNI_ATTR
_jc_java_security_KeyFactory$method$getInstance$38881e0268f1e10f(_jc_env *const env, _jc_java_lang_String$object *param0, _jc_java_lang_String$object *param1)
{
	jint i0;
	struct _jc_java_lang_String$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_java_security_Provider$object *r2;
	struct _jc_java_lang_IllegalArgumentException$object *r3;
	struct _jc_java_security_NoSuchProviderException$object *r4;
	struct _jc_java_security_KeyFactory$object *r5;
	struct _jc_java_lang_String$object *r6;
	struct _jc_java_lang_VMThrowable$object *r7;
	struct _jc_java_lang_VMThrowable$object *r9;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = param0;
	r1 = param1;
	_JC_LINE_NUMBER(161);				// 0
	if (r1 == _JC_NULL)
		goto label0;
	i0 = _JC_PRIM_FIELD(env, r1, java_lang_String, count);
	if (i0 != 0)
		goto label1;

label0:
	_JC_LINE_NUMBER(162);				// 1
	r3 = _JC_NEW(env, java_lang_IllegalArgumentException);
	r6 = _JC_STRING(env, "Illegal provider");
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r7 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r7;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r6;
	_JC_THROW(env, r3);

label1:
	_JC_LINE_NUMBER(164);				// 2
	r2 = _JC_INVOKE_STATIC(env, java_security_Security, getProvider$581ee7d7bc9ae747, 0, r1);
	_JC_LINE_NUMBER(165);				// 3
	if (r2 != _JC_NULL)
		goto label2;
	_JC_LINE_NUMBER(166);				// 4
	r4 = _JC_NEW(env, java_security_NoSuchProviderException);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r9 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r9;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r1;
	_JC_THROW(env, r4);

label2:
	_JC_LINE_NUMBER(168);				// 5
	r5 = _JC_INVOKE_STATIC(env, java_security_KeyFactory, getInstance$d2d620a0afde4c10, 1, r0, r2);
	return r5;
}

//
// public static java.security.KeyFactory getInstance(java.lang.String, java.security.Provider) throws java.security.NoSuchAlgorithmException
//

static _jc_linenum _jc_java_security_KeyFactory$linenum_table$getInstance$d2d620a0afde4c10[];

static _jc_trap_info _jc_java_security_KeyFactory$trap_table$getInstance$d2d620a0afde4c10[] = {
	_JC_TRAP(&_jc_java_lang_reflect_InvocationTargetException$type, 1, 2),
	_JC_TRAP(&_jc_java_lang_ClassCastException$type, 1, 2),
};

static const unsigned char _jc_java_security_KeyFactory$param_ptypes$getInstance$d2d620a0afde4c10[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_security_KeyFactory$exceptions$getInstance$d2d620a0afde4c10[] = {
	&_jc_java_security_NoSuchAlgorithmException$type
};

static _jc_type *const _jc_java_security_KeyFactory$param_types$getInstance$d2d620a0afde4c10[] = {
	&_jc_java_lang_String$type,
	&_jc_java_security_Provider$type
};

_jc_method _jc_java_security_KeyFactory$method_info$getInstance$d2d620a0afde4c10 = {
	.name=			"getInstance",
	.signature=		"(Ljava/lang/String;Ljava/security/Provider;)Ljava/security/KeyFactory;",
	.class=			&_jc_java_security_KeyFactory$type,
	.param_types=		&_jc_java_security_KeyFactory$param_types$getInstance$d2d620a0afde4c10,
	.return_type=		&_jc_java_security_KeyFactory$type,
	.param_ptypes=		&_jc_java_security_KeyFactory$param_ptypes$getInstance$d2d620a0afde4c10,
	.signature_hash=	_JC_JLONG(0xd2d620a0afde4c10),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_java_security_KeyFactory$method$getInstance$d2d620a0afde4c10,
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_security_KeyFactory$exceptions$getInstance$d2d620a0afde4c10,
	.u= { .exec= {
	  .trap_table_len=	2,
	  .trap_table=		_jc_java_security_KeyFactory$trap_table$getInstance$d2d620a0afde4c10,
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_java_security_KeyFactory$linenum_table$getInstance$d2d620a0afde4c10
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_KeyFactory, getInstance$d2d620a0afde4c10);

_jc_java_security_KeyFactory$object * _JC_JCNI_ATTR
_jc_java_security_KeyFactory$method$getInstance$d2d620a0afde4c10(_jc_env *const env, _jc_java_lang_String$object *param0, _jc_java_security_Provider$object *param1)
{
	struct _jc_java_lang_String$object *volatile r0;
	struct _jc_java_security_Provider$object *r1;
	_jc_object_array *r10;
	struct _jc_java_lang_Object$object *r11;
	struct _jc_java_lang_VMThrowable$object *r12;
	struct _jc_java_lang_VMThrowable$object *volatile r13;
	struct _jc_java_lang_VMThrowable$object *volatile r15;
	struct _jc_java_lang_reflect_InvocationTargetException$object *r2;
	struct _jc_java_lang_IllegalArgumentException$object *r3;
	struct _jc_java_security_KeyFactory$object *r4;
	struct _jc_java_security_KeyFactorySpi$object *r5;
	struct _jc_java_security_NoSuchAlgorithmException$object *volatile r6;
	struct _jc_java_lang_ClassCastException$object *r7;
	struct _jc_java_lang_String$object *r8;
	struct _jc_java_lang_String$object *r9;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_java_security_KeyFactory$method_info$getInstance$d2d620a0afde4c10, &&label1, &&label2);

	r0 = param0;
	r1 = param1;
	_JC_LINE_NUMBER(191);				// 0
	if (r1 != _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(192);				// 1
	r3 = _JC_NEW(env, java_lang_IllegalArgumentException);
	r8 = _JC_STRING(env, "Illegal provider");
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r12 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r12;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r8;
	_JC_THROW(env, r3);

label0:
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(196);				// 2
	r4 = _JC_NEW(env, java_security_KeyFactory);
	_JC_ACTIVE_USE(env, gnu_java_security_Engine);
	r9 = _JC_STRING(env, "KeyFactory");
	r10 = _JC_STATIC_FIELD(env, gnu_java_security_Engine, NO__5fARGS, 1);
	r11 = _JC_INVOKE_STATIC(env, gnu_java_security_Engine, getInstance$ec89dfd35c234c64, 1, r9, r0, r1, r10);
	r5 = _JC_CAST(env, &_jc_java_security_KeyFactorySpi$type, r11);
	_JC_REF_FIELD(env, r4, java_security_KeyFactory, keyFacSpi) = r5;
	_JC_REF_FIELD(env, r4, java_security_KeyFactory, provider) = r1;
	_JC_REF_FIELD(env, r4, java_security_KeyFactory, algorithm) = r0;
	_JC_TRAP_REGION(catch, 2);
	_JC_CANCEL_TRAPS(env, catch);
	return r4;

label1:
	_JC_TRAP_REGION(catch, 2);
	r2 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(202);				// 3
	r6 = _JC_NEW(env, java_security_NoSuchAlgorithmException);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, cause) = r6;
	r13 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r6);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, vmState) = r13;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, detailMessage) = r0;
	_JC_THROW(env, r6);

label2:
	_JC_TRAP_REGION(catch, 2);
	r7 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(206);				// 4
	r6 = _JC_NEW(env, java_security_NoSuchAlgorithmException);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, cause) = r6;
	r15 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r6);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, vmState) = r15;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, detailMessage) = r0;
	_JC_THROW(env, r6);
}

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// protected void <init>(java.security.KeyFactorySpi, java.security.Provider, java.lang.String)
//

static _jc_linenum _jc_java_security_KeyFactory$linenum_table$_init$2a6810b899ff0728[];

static const unsigned char _jc_java_security_KeyFactory$param_ptypes$_init$2a6810b899ff0728[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_security_KeyFactory$param_types$_init$2a6810b899ff0728[] = {
	&_jc_java_security_KeyFactorySpi$type,
	&_jc_java_security_Provider$type,
	&_jc_java_lang_String$type
};

_jc_method _jc_java_security_KeyFactory$method_info$_init$2a6810b899ff0728 = {
	.name=			"<init>",
	.signature=		"(Ljava/security/KeyFactorySpi;Ljava/security/Provider;Ljava/lang/String;)V",
	.class=			&_jc_java_security_KeyFactory$type,
	.param_types=		&_jc_java_security_KeyFactory$param_types$_init$2a6810b899ff0728,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_security_KeyFactory$param_ptypes$_init$2a6810b899ff0728,
	.signature_hash=	_JC_JLONG(0x2a6810b899ff0728),
	.access_flags=		_JC_ACC_PROTECTED,
	.function=		&_jc_java_security_KeyFactory$method$_init$2a6810b899ff0728,
	.num_parameters=	3,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_java_security_KeyFactory$linenum_table$_init$2a6810b899ff0728
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_KeyFactory, _init$2a6810b899ff0728);

void _JC_JCNI_ATTR
_jc_java_security_KeyFactory$method$_init$2a6810b899ff0728(_jc_env *const env, _jc_java_security_KeyFactory$object *this, _jc_java_security_KeyFactorySpi$object *param0, _jc_java_security_Provider$object *param1, _jc_java_lang_String$object *param2)
{
	struct _jc_java_security_KeyFactory$object *r0;
	struct _jc_java_security_KeyFactorySpi$object *r1;
	struct _jc_java_security_Provider$object *r2;
	struct _jc_java_lang_String$object *r3;

	r0 = this;
	r1 = param0;
	r2 = param1;
	r3 = param2;
	_JC_LINE_NUMBER(106);				// 0
	_JC_REF_FIELD(env, r0, java_security_KeyFactory, keyFacSpi) = r1;
	_JC_LINE_NUMBER(107);				// 1
	_JC_REF_FIELD(env, r0, java_security_KeyFactory, provider) = r2;
	_JC_LINE_NUMBER(108);				// 2
	_JC_REF_FIELD(env, r0, java_security_KeyFactory, algorithm) = r3;
	_JC_LINE_NUMBER(109);				// 3
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public final java.security.PrivateKey generatePrivate(java.security.spec.KeySpec) throws java.security.spec.InvalidKeySpecException
//

static _jc_linenum _jc_java_security_KeyFactory$linenum_table$generatePrivate$fabffbfc8bbb5a87[];

static const unsigned char _jc_java_security_KeyFactory$param_ptypes$generatePrivate$fabffbfc8bbb5a87[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_security_KeyFactory$exceptions$generatePrivate$fabffbfc8bbb5a87[] = {
	&_jc_java_security_spec_InvalidKeySpecException$type
};

static _jc_type *const _jc_java_security_KeyFactory$param_types$generatePrivate$fabffbfc8bbb5a87[] = {
	&_jc_java_security_spec_KeySpec$type
};

_jc_method _jc_java_security_KeyFactory$method_info$generatePrivate$fabffbfc8bbb5a87 = {
	.name=			"generatePrivate",
	.signature=		"(Ljava/security/spec/KeySpec;)Ljava/security/PrivateKey;",
	.class=			&_jc_java_security_KeyFactory$type,
	.param_types=		&_jc_java_security_KeyFactory$param_types$generatePrivate$fabffbfc8bbb5a87,
	.return_type=		&_jc_java_security_PrivateKey$type,
	.param_ptypes=		&_jc_java_security_KeyFactory$param_ptypes$generatePrivate$fabffbfc8bbb5a87,
	.signature_hash=	_JC_JLONG(0xfabffbfc8bbb5a87),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_security_KeyFactory$method$generatePrivate$fabffbfc8bbb5a87,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_KeyFactory$vtable, java_security_KeyFactory.generatePrivate$fabffbfc8bbb5a87) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_security_KeyFactory$exceptions$generatePrivate$fabffbfc8bbb5a87,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_KeyFactory$linenum_table$generatePrivate$fabffbfc8bbb5a87
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_KeyFactory, generatePrivate$fabffbfc8bbb5a87);

_jc_object * _JC_JCNI_ATTR
_jc_java_security_KeyFactory$method$generatePrivate$fabffbfc8bbb5a87(_jc_env *const env, _jc_java_security_KeyFactory$object *this, _jc_object *param0)
{
	struct _jc_java_security_KeyFactory$object *r0;
	struct _jc_object *r1;
	struct _jc_java_security_KeyFactorySpi$object *r2;
	struct _jc_object *r3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(258);				// 0
	r2 = _JC_REF_FIELD(env, r0, java_security_KeyFactory, keyFacSpi);
	r3 = _JC_INVOKE_VIRTUAL(env, java_security_KeyFactorySpi, engineGeneratePrivate$5f899f5d07075f18, r2, r1);
	return r3;
}

//
// public final java.security.PublicKey generatePublic(java.security.spec.KeySpec) throws java.security.spec.InvalidKeySpecException
//

static _jc_linenum _jc_java_security_KeyFactory$linenum_table$generatePublic$0d2ebb942bf3b511[];

static const unsigned char _jc_java_security_KeyFactory$param_ptypes$generatePublic$0d2ebb942bf3b511[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_security_KeyFactory$exceptions$generatePublic$0d2ebb942bf3b511[] = {
	&_jc_java_security_spec_InvalidKeySpecException$type
};

static _jc_type *const _jc_java_security_KeyFactory$param_types$generatePublic$0d2ebb942bf3b511[] = {
	&_jc_java_security_spec_KeySpec$type
};

_jc_method _jc_java_security_KeyFactory$method_info$generatePublic$0d2ebb942bf3b511 = {
	.name=			"generatePublic",
	.signature=		"(Ljava/security/spec/KeySpec;)Ljava/security/PublicKey;",
	.class=			&_jc_java_security_KeyFactory$type,
	.param_types=		&_jc_java_security_KeyFactory$param_types$generatePublic$0d2ebb942bf3b511,
	.return_type=		&_jc_java_security_PublicKey$type,
	.param_ptypes=		&_jc_java_security_KeyFactory$param_ptypes$generatePublic$0d2ebb942bf3b511,
	.signature_hash=	_JC_JLONG(0xd2ebb942bf3b511),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_security_KeyFactory$method$generatePublic$0d2ebb942bf3b511,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_KeyFactory$vtable, java_security_KeyFactory.generatePublic$0d2ebb942bf3b511) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_security_KeyFactory$exceptions$generatePublic$0d2ebb942bf3b511,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_KeyFactory$linenum_table$generatePublic$0d2ebb942bf3b511
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_KeyFactory, generatePublic$0d2ebb942bf3b511);

_jc_object * _JC_JCNI_ATTR
_jc_java_security_KeyFactory$method$generatePublic$0d2ebb942bf3b511(_jc_env *const env, _jc_java_security_KeyFactory$object *this, _jc_object *param0)
{
	struct _jc_java_security_KeyFactory$object *r0;
	struct _jc_object *r1;
	struct _jc_java_security_KeyFactorySpi$object *r2;
	struct _jc_object *r3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(243);				// 0
	r2 = _JC_REF_FIELD(env, r0, java_security_KeyFactory, keyFacSpi);
	r3 = _JC_INVOKE_VIRTUAL(env, java_security_KeyFactorySpi, engineGeneratePublic$7ad176effa9fa186, r2, r1);
	return r3;
}

//
// public final java.lang.String getAlgorithm()
//

static _jc_linenum _jc_java_security_KeyFactory$linenum_table$getAlgorithm$19abbbc132b9063a[];

static const unsigned char _jc_java_security_KeyFactory$param_ptypes$getAlgorithm$19abbbc132b9063a[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_java_security_KeyFactory$method_info$getAlgorithm$19abbbc132b9063a = {
	.name=			"getAlgorithm",
	.signature=		"()Ljava/lang/String;",
	.class=			&_jc_java_security_KeyFactory$type,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_java_security_KeyFactory$param_ptypes$getAlgorithm$19abbbc132b9063a,
	.signature_hash=	_JC_JLONG(0x19abbbc132b9063a),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_security_KeyFactory$method$getAlgorithm$19abbbc132b9063a,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_KeyFactory$vtable, java_security_KeyFactory.getAlgorithm$19abbbc132b9063a) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_KeyFactory$linenum_table$getAlgorithm$19abbbc132b9063a
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_KeyFactory, getAlgorithm$19abbbc132b9063a);

_jc_java_lang_String$object * _JC_JCNI_ATTR
_jc_java_security_KeyFactory$method$getAlgorithm$19abbbc132b9063a(_jc_env *const env, _jc_java_security_KeyFactory$object *this)
{
	struct _jc_java_security_KeyFactory$object *r0;
	struct _jc_java_lang_String$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(228);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_security_KeyFactory, algorithm);
	return r1;
}

//
// public final java.security.spec.KeySpec getKeySpec(java.security.Key, java.lang.Class) throws java.security.spec.InvalidKeySpecException
//

static _jc_linenum _jc_java_security_KeyFactory$linenum_table$getKeySpec$8b12ca7298337c7a[];

static const unsigned char _jc_java_security_KeyFactory$param_ptypes$getKeySpec$8b12ca7298337c7a[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_security_KeyFactory$exceptions$getKeySpec$8b12ca7298337c7a[] = {
	&_jc_java_security_spec_InvalidKeySpecException$type
};

static _jc_type *const _jc_java_security_KeyFactory$param_types$getKeySpec$8b12ca7298337c7a[] = {
	&_jc_java_security_Key$type,
	&_jc_java_lang_Class$type
};

_jc_method _jc_java_security_KeyFactory$method_info$getKeySpec$8b12ca7298337c7a = {
	.name=			"getKeySpec",
	.signature=		"(Ljava/security/Key;Ljava/lang/Class;)Ljava/security/spec/KeySpec;",
	.class=			&_jc_java_security_KeyFactory$type,
	.param_types=		&_jc_java_security_KeyFactory$param_types$getKeySpec$8b12ca7298337c7a,
	.return_type=		&_jc_java_security_spec_KeySpec$type,
	.param_ptypes=		&_jc_java_security_KeyFactory$param_ptypes$getKeySpec$8b12ca7298337c7a,
	.signature_hash=	_JC_JLONG(0x8b12ca7298337c7a),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_security_KeyFactory$method$getKeySpec$8b12ca7298337c7a,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_KeyFactory$vtable, java_security_KeyFactory.getKeySpec$8b12ca7298337c7a) / sizeof(void *),
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_security_KeyFactory$exceptions$getKeySpec$8b12ca7298337c7a,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_KeyFactory$linenum_table$getKeySpec$8b12ca7298337c7a
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_KeyFactory, getKeySpec$8b12ca7298337c7a);

_jc_object * _JC_JCNI_ATTR
_jc_java_security_KeyFactory$method$getKeySpec$8b12ca7298337c7a(_jc_env *const env, _jc_java_security_KeyFactory$object *this, _jc_object *param0, _jc_java_lang_Class$object *param1)
{
	struct _jc_java_security_KeyFactory$object *r0;
	struct _jc_object *r1;
	struct _jc_java_lang_Class$object *r2;
	struct _jc_java_security_KeyFactorySpi$object *r3;
	struct _jc_object *r4;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_LINE_NUMBER(281);				// 0
	r3 = _JC_REF_FIELD(env, r0, java_security_KeyFactory, keyFacSpi);
	r4 = _JC_INVOKE_VIRTUAL(env, java_security_KeyFactorySpi, engineGetKeySpec$8e11b093f262567f, r3, r1, r2);
	return r4;
}

//
// public final java.security.Provider getProvider()
//

static _jc_linenum _jc_java_security_KeyFactory$linenum_table$getProvider$e8f9c9fb14140d5a[];

static const unsigned char _jc_java_security_KeyFactory$param_ptypes$getProvider$e8f9c9fb14140d5a[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_java_security_KeyFactory$method_info$getProvider$e8f9c9fb14140d5a = {
	.name=			"getProvider",
	.signature=		"()Ljava/security/Provider;",
	.class=			&_jc_java_security_KeyFactory$type,
	.return_type=		&_jc_java_security_Provider$type,
	.param_ptypes=		&_jc_java_security_KeyFactory$param_ptypes$getProvider$e8f9c9fb14140d5a,
	.signature_hash=	_JC_JLONG(0xe8f9c9fb14140d5a),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_security_KeyFactory$method$getProvider$e8f9c9fb14140d5a,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_KeyFactory$vtable, java_security_KeyFactory.getProvider$e8f9c9fb14140d5a) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_KeyFactory$linenum_table$getProvider$e8f9c9fb14140d5a
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_KeyFactory, getProvider$e8f9c9fb14140d5a);

_jc_java_security_Provider$object * _JC_JCNI_ATTR
_jc_java_security_KeyFactory$method$getProvider$e8f9c9fb14140d5a(_jc_env *const env, _jc_java_security_KeyFactory$object *this)
{
	struct _jc_java_security_KeyFactory$object *r0;
	struct _jc_java_security_Provider$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(217);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_security_KeyFactory, provider);
	return r1;
}

//
// public final java.security.Key translateKey(java.security.Key) throws java.security.InvalidKeyException
//

static _jc_linenum _jc_java_security_KeyFactory$linenum_table$translateKey$6a64faacf4eca934[];

static const unsigned char _jc_java_security_KeyFactory$param_ptypes$translateKey$6a64faacf4eca934[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_security_KeyFactory$exceptions$translateKey$6a64faacf4eca934[] = {
	&_jc_java_security_InvalidKeyException$type
};

static _jc_type *const _jc_java_security_KeyFactory$param_types$translateKey$6a64faacf4eca934[] = {
	&_jc_java_security_Key$type
};

_jc_method _jc_java_security_KeyFactory$method_info$translateKey$6a64faacf4eca934 = {
	.name=			"translateKey",
	.signature=		"(Ljava/security/Key;)Ljava/security/Key;",
	.class=			&_jc_java_security_KeyFactory$type,
	.param_types=		&_jc_java_security_KeyFactory$param_types$translateKey$6a64faacf4eca934,
	.return_type=		&_jc_java_security_Key$type,
	.param_ptypes=		&_jc_java_security_KeyFactory$param_ptypes$translateKey$6a64faacf4eca934,
	.signature_hash=	_JC_JLONG(0x6a64faacf4eca934),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_security_KeyFactory$method$translateKey$6a64faacf4eca934,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_KeyFactory$vtable, java_security_KeyFactory.translateKey$6a64faacf4eca934) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_security_KeyFactory$exceptions$translateKey$6a64faacf4eca934,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_KeyFactory$linenum_table$translateKey$6a64faacf4eca934
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_KeyFactory, translateKey$6a64faacf4eca934);

_jc_object * _JC_JCNI_ATTR
_jc_java_security_KeyFactory$method$translateKey$6a64faacf4eca934(_jc_env *const env, _jc_java_security_KeyFactory$object *this, _jc_object *param0)
{
	struct _jc_java_security_KeyFactory$object *r0;
	struct _jc_object *r1;
	struct _jc_java_security_KeyFactorySpi$object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(295);				// 0
	r2 = _JC_REF_FIELD(env, r0, java_security_KeyFactory, keyFacSpi);
	r1 = _JC_INVOKE_VIRTUAL(env, java_security_KeyFactorySpi, engineTranslateKey$486445c69e67c534, r2, r1);
	return r1;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_java_security_KeyFactory$methods[] = {
	&_jc_java_security_KeyFactory$method_info$_init$2a6810b899ff0728,
	&_jc_java_security_KeyFactory$method_info$generatePrivate$fabffbfc8bbb5a87,
	&_jc_java_security_KeyFactory$method_info$generatePublic$0d2ebb942bf3b511,
	&_jc_java_security_KeyFactory$method_info$getAlgorithm$19abbbc132b9063a,
	&_jc_java_security_KeyFactory$method_info$getInstance$328aacb0878c9499,
	&_jc_java_security_KeyFactory$method_info$getInstance$38881e0268f1e10f,
	&_jc_java_security_KeyFactory$method_info$getInstance$d2d620a0afde4c10,
	&_jc_java_security_KeyFactory$method_info$getKeySpec$8b12ca7298337c7a,
	&_jc_java_security_KeyFactory$method_info$getProvider$e8f9c9fb14140d5a,
	&_jc_java_security_KeyFactory$method_info$translateKey$6a64faacf4eca934
};

/************************************************************************
 *			  Class fields structure			*
 ************************************************************************/

_jc_java_security_KeyFactory$fields_struct _jc_java_security_KeyFactory$class_fields = { };

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_java_security_KeyFactory$instanceof_hash_bucket_15[] = {
	&_jc_java_security_KeyFactory$type,
	_JC_NULL
};
static _jc_type *const _jc_java_security_KeyFactory$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_java_security_KeyFactory$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[15]=	_jc_java_security_KeyFactory$instanceof_hash_bucket_15,
	[101]=	_jc_java_security_KeyFactory$instanceof_hash_bucket_101
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_java_security_KeyFactory$class_depends[] = {
	{ "gnu/java/security/Engine",	_JC_JLONG(0xf4ba095546954b36) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/ClassCastException",	_JC_JLONG(0xf02ab3ccb490a6d0) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/IllegalArgumentException",	_JC_JLONG(0x680cf34d05feb5a1) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/RuntimeException",	_JC_JLONG(0x4f5534a987354d1d) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/lang/reflect/InvocationTargetException",	_JC_JLONG(0xae4a2342b31a268d) },
	{ "java/security/GeneralSecurityException",	_JC_JLONG(0x692089051f4c8d0b) },
	{ "java/security/InvalidKeyException",	_JC_JLONG(0x94dda41e9bf6c170) },
	{ "java/security/Key",	_JC_JLONG(0xa467c6cd05d9cc51) },
	{ "java/security/KeyFactorySpi",	_JC_JLONG(0x5208a7db73e048db) },
	{ "java/security/NoSuchAlgorithmException",	_JC_JLONG(0x22e937c2536160b4) },
	{ "java/security/NoSuchProviderException",	_JC_JLONG(0x8dfbf242adab91e) },
	{ "java/security/PrivateKey",	_JC_JLONG(0xdcdbe4a102f59043) },
	{ "java/security/Provider",	_JC_JLONG(0x81b073051aa30acc) },
	{ "java/security/PublicKey",	_JC_JLONG(0x4db3ac05e70e2bf8) },
	{ "java/security/Security",	_JC_JLONG(0x89bf77984bd9669e) },
	{ "java/security/spec/InvalidKeySpecException",	_JC_JLONG(0x602c9e525972bdb8) },
	{ "java/security/spec/KeySpec",	_JC_JLONG(0xe5bd533daf8dcb9a) },
	{ "java/util/Vector",	_JC_JLONG(0xc53e1575b095109b) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_java_security_KeyFactory$vtype _jc_java_security_KeyFactory$type = {
    .type= {
	.name=			"java/security/KeyFactory",
	.superclass=		&_jc_java_lang_Object$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		17,
		.hash=			_JC_JLONG(0x5d14b6c072276d8f),
		.source_file=		"KeyFactory.java",
		.instance_size=		sizeof(_jc_java_security_KeyFactory$refs) + sizeof(_jc_java_security_KeyFactory$object),
		.num_virtual_refs=	3,
		.num_fields=		sizeof(_jc_java_security_KeyFactory$fields) / sizeof(*_jc_java_security_KeyFactory$fields),
		.fields=		_jc_java_security_KeyFactory$fields,
		.num_methods=		sizeof(_jc_java_security_KeyFactory$methods) / sizeof(*_jc_java_security_KeyFactory$methods),
		.methods=		_jc_java_security_KeyFactory$methods,
		.instanceof_hash_table=	_jc_java_security_KeyFactory$instanceof_hash_table,
		.class_fields=		&_jc_java_security_KeyFactory$class_fields,
		.num_class_depends=		sizeof(_jc_java_security_KeyFactory$class_depends) / sizeof(*_jc_java_security_KeyFactory$class_depends),
		.class_depends=		_jc_java_security_KeyFactory$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.java_security_KeyFactory= {
	    .generatePrivate$fabffbfc8bbb5a87=
		&_jc_java_security_KeyFactory$method$generatePrivate$fabffbfc8bbb5a87,
	    .generatePublic$0d2ebb942bf3b511=
		&_jc_java_security_KeyFactory$method$generatePublic$0d2ebb942bf3b511,
	    .getAlgorithm$19abbbc132b9063a=
		&_jc_java_security_KeyFactory$method$getAlgorithm$19abbbc132b9063a,
	    .getKeySpec$8b12ca7298337c7a=
		&_jc_java_security_KeyFactory$method$getKeySpec$8b12ca7298337c7a,
	    .getProvider$e8f9c9fb14140d5a=
		&_jc_java_security_KeyFactory$method$getProvider$e8f9c9fb14140d5a,
	    .translateKey$6a64faacf4eca934=
		&_jc_java_security_KeyFactory$method$translateKey$6a64faacf4eca934,
	},
    }
};

