// public class java.security.KeyStore

// class file dependencies
// @dep_class f4ba095546954b36 gnu_java_security_Engine
// @dep_class 4e0a56550c69d57c java_io_IOException
// @dep_class 66aea4d152614ac4 java_io_InputStream
// @dep_class 4026d3144d6654d8 java_io_OutputStream
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class f02ab3ccb490a6d0 java_lang_ClassCastException
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class 680cf34d05feb5a1 java_lang_IllegalArgumentException
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class 4f5534a987354d1d java_lang_RuntimeException
// @dep_class d38282f3d5f80887 java_lang_SecurityManager
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 94d357637b968dda java_lang_StringBuffer
// @dep_class 53cc8e2333795f04 java_lang_System
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class ae4a2342b31a268d java_lang_reflect_InvocationTargetException
// @dep_class 692089051f4c8d0b java_security_GeneralSecurityException
// @dep_class a467c6cd05d9cc51 java_security_Key
// @dep_class 1f56d8b14978c9d6 java_security_KeyStore
// @dep_class 45b488528f32667c java_security_KeyStoreException
// @dep_class 4760c3113311a807 java_security_KeyStoreSpi
// @dep_class 22e937c2536160b4 java_security_NoSuchAlgorithmException
// @dep_class 8dfbf242adab91e java_security_NoSuchProviderException
// @dep_class 81b073051aa30acc java_security_Provider
// @dep_class 89bf77984bd9669e java_security_Security
// @dep_class 398237d93436ff7e java_security_UnrecoverableKeyException
// @dep_class c98c8192da849b07 java_security_cert_Certificate
// @dep_class ebfb598dd9fa8080 java_security_cert_CertificateException
// @dep_class a85d2a51094e614c java_util_Date
// @dep_class c56a8b1934689c38 java_util_Enumeration
// @dep_class 884c3edb343dfb63 java_util_Properties
// @dep_class c53e1575b095109b java_util_Vector

// header file dependencies
// @dep_header gnu_java_security_Engine
// @dep_header java_io_IOException
// @dep_header java_io_InputStream
// @dep_header java_io_OutputStream
// @dep_header java_lang_Class
// @dep_header java_lang_ClassCastException
// @dep_header java_lang_IllegalArgumentException
// @dep_header java_lang_SecurityManager
// @dep_header java_lang_String
// @dep_header java_lang_StringBuffer
// @dep_header java_lang_System
// @dep_header java_lang_VMThrowable
// @dep_header java_lang_reflect_InvocationTargetException
// @dep_header java_security_Key
// @dep_header java_security_KeyStore
// @dep_header java_security_KeyStoreException
// @dep_header java_security_KeyStoreSpi
// @dep_header java_security_NoSuchAlgorithmException
// @dep_header java_security_NoSuchProviderException
// @dep_header java_security_Provider
// @dep_header java_security_Security
// @dep_header java_security_UnrecoverableKeyException
// @dep_header java_security_cert_Certificate
// @dep_header java_security_cert_CertificateException
// @dep_header java_util_Date
// @dep_header java_util_Enumeration
// @dep_header java_util_Vector

#include "jc_defs.h"

#include "gnu/java/security/Engine.h"
#include "java/io/IOException.h"
#include "java/io/InputStream.h"
#include "java/io/OutputStream.h"
#include "java/lang/Class.h"
#include "java/lang/ClassCastException.h"
#include "java/lang/IllegalArgumentException.h"
#include "java/lang/SecurityManager.h"
#include "java/lang/String.h"
#include "java/lang/StringBuffer.h"
#include "java/lang/System.h"
#include "java/lang/VMThrowable.h"
#include "java/lang/reflect/InvocationTargetException.h"
#include "java/security/Key.h"
#include "java/security/KeyStore.h"
#include "java/security/KeyStoreException.h"
#include "java/security/KeyStoreSpi.h"
#include "java/security/NoSuchAlgorithmException.h"
#include "java/security/NoSuchProviderException.h"
#include "java/security/Provider.h"
#include "java/security/Security.h"
#include "java/security/UnrecoverableKeyException.h"
#include "java/security/cert/Certificate.h"
#include "java/security/cert/CertificateException.h"
#include "java/util/Date.h"
#include "java/util/Enumeration.h"
#include "java/util/Vector.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// private static final java.lang.String KEY_STORE
static _jc_field _jc_java_security_KeyStore$field_info$KEY__5fSTORE = {
	.name=		"KEY_STORE",
	.signature=	"Ljava/lang/String;",
	.class=		&_jc_java_security_KeyStore$type,
	.type=		&_jc_java_lang_String$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_java_security_KeyStore$fields_struct, KEY__5fSTORE),
	.initial_value=	"KeyStore",
};

// private java.security.KeyStoreSpi keyStoreSpi
static _jc_field _jc_java_security_KeyStore$field_info$keyStoreSpi = {
	.name=		"keyStoreSpi",
	.signature=	"Ljava/security/KeyStoreSpi;",
	.class=		&_jc_java_security_KeyStore$type,
	.type=		&_jc_java_security_KeyStoreSpi$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_security_KeyStore$object, refs[-1].java_security_KeyStore.keyStoreSpi),
};

// private java.security.Provider provider
static _jc_field _jc_java_security_KeyStore$field_info$provider = {
	.name=		"provider",
	.signature=	"Ljava/security/Provider;",
	.class=		&_jc_java_security_KeyStore$type,
	.type=		&_jc_java_security_Provider$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_security_KeyStore$object, refs[-1].java_security_KeyStore.provider),
};

// private java.lang.String type
static _jc_field _jc_java_security_KeyStore$field_info$type = {
	.name=		"type",
	.signature=	"Ljava/lang/String;",
	.class=		&_jc_java_security_KeyStore$type,
	.type=		&_jc_java_lang_String$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_security_KeyStore$object, refs[-1].java_security_KeyStore.type),
};

// Fields
static _jc_field *const _jc_java_security_KeyStore$fields[] = {
	&_jc_java_security_KeyStore$field_info$KEY__5fSTORE,
	&_jc_java_security_KeyStore$field_info$keyStoreSpi,
	&_jc_java_security_KeyStore$field_info$provider,
	&_jc_java_security_KeyStore$field_info$type
};

/************************************************************************
 *			      Static methods				*
 ************************************************************************/

//
// public static final java.lang.String getDefaultType()
//

static _jc_linenum _jc_java_security_KeyStore$linenum_table$getDefaultType$e0168af0ff28954a[];

static const unsigned char _jc_java_security_KeyStore$param_ptypes$getDefaultType$e0168af0ff28954a[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_java_security_KeyStore$method_info$getDefaultType$e0168af0ff28954a = {
	.name=			"getDefaultType",
	.signature=		"()Ljava/lang/String;",
	.class=			&_jc_java_security_KeyStore$type,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_java_security_KeyStore$param_ptypes$getDefaultType$e0168af0ff28954a,
	.signature_hash=	_JC_JLONG(0xe0168af0ff28954a),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.function=		&_jc_java_security_KeyStore$method$getDefaultType$e0168af0ff28954a,
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_java_security_KeyStore$linenum_table$getDefaultType$e0168af0ff28954a
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_KeyStore, getDefaultType$e0168af0ff28954a);

_jc_java_lang_String$object * _JC_JCNI_ATTR
_jc_java_security_KeyStore$method$getDefaultType$e0168af0ff28954a(_jc_env *const env)
{
	jint i0;
	struct _jc_java_lang_String$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_java_lang_StringBuffer$object *r2;
	struct _jc_java_lang_String$object *r3;
	struct _jc_java_util_Properties$object *r4;
	struct _jc_java_lang_SecurityManager$object *r5;
	struct _jc_java_lang_String$object *r6;
	struct _jc_java_lang_String$object *r7;
	_jc_char_array *r8;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	_JC_ACTIVE_USE(env, java_security_Security);
	_JC_LINE_NUMBER(221);				// 0
	r1 = _JC_STRING(env, "keystore.type");
	_JC_ACTIVE_USE(env, java_lang_System);
	r5 = _JC_STATIC_FIELD(env, java_lang_SecurityManager, current, 0);
	if (r5 == _JC_NULL)
		goto label0;
	r2 = _JC_NEW(env, java_lang_StringBuffer);
	r7 = _JC_STRING(env, "getProperty.");
	i0 = _JC_PRIM_FIELD(env, r7, java_lang_String, count);
	_JC_PRIM_FIELD(env, r2, java_lang_StringBuffer, count) = i0;
	i0 = _JC_PRIM_FIELD(env, r2, java_lang_StringBuffer, count);
	i0 = i0 + 16;
	r8 = _JC_NEW_PRIM_ARRAY(env, char, 1, i0);
	_JC_REF_FIELD(env, r2, java_lang_StringBuffer, value) = r8;
	i0 = _JC_PRIM_FIELD(env, r2, java_lang_StringBuffer, count);
	r8 = _JC_REF_FIELD(env, r2, java_lang_StringBuffer, value);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, getChars$c684dea7317ff063, 0, r7, 0, i0, r8, 0);
	r2 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r2, r1);
	r6 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r6, r2);
	_JC_INVOKE_VIRTUAL(env, java_lang_SecurityManager, checkSecurityAccess$3e1898ffed69827d, r5, r6);

label0:
	r4 = _JC_STATIC_FIELD(env, java_security_Security, secprops, 1);
	r3 = _JC_INVOKE_VIRTUAL(env, java_util_Properties, getProperty$17fb18205ea95f87, r4, r1);
	r0 = r3;
	_JC_LINE_NUMBER(223);				// 1
	if (r3 != _JC_NULL)
		goto label1;
	_JC_LINE_NUMBER(224);				// 2
	r0 = _JC_STRING(env, "jks");

label1:
	_JC_LINE_NUMBER(226);				// 3
	return r0;
}

//
// public static java.security.KeyStore getInstance(java.lang.String) throws java.security.KeyStoreException
//

static _jc_linenum _jc_java_security_KeyStore$linenum_table$getInstance$2b9c173f301514d9[];

static _jc_trap_info _jc_java_security_KeyStore$trap_table$getInstance$2b9c173f301514d9[] = {
	_JC_TRAP(&_jc_java_security_KeyStoreException$type, 1, 2),
};

static const unsigned char _jc_java_security_KeyStore$param_ptypes$getInstance$2b9c173f301514d9[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_security_KeyStore$exceptions$getInstance$2b9c173f301514d9[] = {
	&_jc_java_security_KeyStoreException$type
};

static _jc_type *const _jc_java_security_KeyStore$param_types$getInstance$2b9c173f301514d9[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_java_security_KeyStore$method_info$getInstance$2b9c173f301514d9 = {
	.name=			"getInstance",
	.signature=		"(Ljava/lang/String;)Ljava/security/KeyStore;",
	.class=			&_jc_java_security_KeyStore$type,
	.param_types=		&_jc_java_security_KeyStore$param_types$getInstance$2b9c173f301514d9,
	.return_type=		&_jc_java_security_KeyStore$type,
	.param_ptypes=		&_jc_java_security_KeyStore$param_ptypes$getInstance$2b9c173f301514d9,
	.signature_hash=	_JC_JLONG(0x2b9c173f301514d9),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_java_security_KeyStore$method$getInstance$2b9c173f301514d9,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_security_KeyStore$exceptions$getInstance$2b9c173f301514d9,
	.u= { .exec= {
	  .trap_table_len=	1,
	  .trap_table=		_jc_java_security_KeyStore$trap_table$getInstance$2b9c173f301514d9,
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_java_security_KeyStore$linenum_table$getInstance$2b9c173f301514d9
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_KeyStore, getInstance$2b9c173f301514d9);

_jc_java_security_KeyStore$object * _JC_JCNI_ATTR
_jc_java_security_KeyStore$method$getInstance$2b9c173f301514d9(_jc_env *const env, _jc_java_lang_String$object *param0)
{
	jint volatile i0;
	jint volatile i1;
	jint i2;
	struct _jc_java_lang_String$object *volatile r0;
	struct _jc_java_security_Provider$object *volatile r2;
	struct _jc_java_security_KeyStore$object *volatile r3;
	struct _jc_java_security_KeyStoreException$object *volatile r4;
	struct _jc_java_lang_VMThrowable$object *volatile r5;
	struct _jc_java_util_Vector$object *r6;
	_jc_object_array *volatile r7;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_java_security_KeyStore$method_info$getInstance$2b9c173f301514d9, &&label1);

	r0 = param0;
	_JC_ACTIVE_USE(env, java_security_Security);
	_JC_LINE_NUMBER(126);				// 0
	r6 = _JC_STATIC_FIELD(env, java_security_Security, providers, 1);
	i2 = _JC_INVOKE_VIRTUAL(env, java_util_Vector, size$345df5220fc60ade, r6);
	r7 = _JC_NEW_REF_ARRAY(env, java_security_Provider, 1, i2);
	r6 = _JC_STATIC_FIELD(env, java_security_Security, providers, 1);
	_JC_INVOKE_VIRTUAL(env, java_util_Vector, copyInto$cd78d768b3ba4735, r6, r7);
	_JC_LINE_NUMBER(128);				// 1
	i0 = 0;
	goto label2;

label0:
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(132);				// 2
	r2 = _JC_REF_ELEMENT(env, r7, i0, 1, 1);
	r3 = _JC_INVOKE_STATIC(env, java_security_KeyStore, getInstance$fb1f41ce03933040, 0, r0, r2);
	_JC_TRAP_REGION(catch, 2);
	_JC_CANCEL_TRAPS(env, catch);
	return r3;

label1:
	_JC_TRAP_REGION(catch, 2);
	r4 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(128);				// 3
	i0 = i0 + 1;

label2:
	_JC_TRAP_REGION(catch, 2);
	i1 = _JC_ARRAY_LENGTH(env, r7);
	if (i0 < i1) {
		_JC_PERIODIC_CHECK(env);
		goto label0;
	}
	_JC_LINE_NUMBER(140);				// 4
	r4 = _JC_NEW(env, java_security_KeyStoreException);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r5 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r5;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r0;
	_JC_THROW(env, r4);
}

//
// public static java.security.KeyStore getInstance(java.lang.String, java.lang.String) throws java.security.KeyStoreException, java.security.NoSuchProviderException
//

static _jc_linenum _jc_java_security_KeyStore$linenum_table$getInstance$4b5d8fb7c9a36975[];

static const unsigned char _jc_java_security_KeyStore$param_ptypes$getInstance$4b5d8fb7c9a36975[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_security_KeyStore$exceptions$getInstance$4b5d8fb7c9a36975[] = {
	&_jc_java_security_KeyStoreException$type,
	&_jc_java_security_NoSuchProviderException$type
};

static _jc_type *const _jc_java_security_KeyStore$param_types$getInstance$4b5d8fb7c9a36975[] = {
	&_jc_java_lang_String$type,
	&_jc_java_lang_String$type
};

_jc_method _jc_java_security_KeyStore$method_info$getInstance$4b5d8fb7c9a36975 = {
	.name=			"getInstance",
	.signature=		"(Ljava/lang/String;Ljava/lang/String;)Ljava/security/KeyStore;",
	.class=			&_jc_java_security_KeyStore$type,
	.param_types=		&_jc_java_security_KeyStore$param_types$getInstance$4b5d8fb7c9a36975,
	.return_type=		&_jc_java_security_KeyStore$type,
	.param_ptypes=		&_jc_java_security_KeyStore$param_ptypes$getInstance$4b5d8fb7c9a36975,
	.signature_hash=	_JC_JLONG(0x4b5d8fb7c9a36975),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_java_security_KeyStore$method$getInstance$4b5d8fb7c9a36975,
	.num_parameters=	2,
	.num_exceptions=	2,
	.exceptions=		&_jc_java_security_KeyStore$exceptions$getInstance$4b5d8fb7c9a36975,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	6,
	      .table=	_jc_java_security_KeyStore$linenum_table$getInstance$4b5d8fb7c9a36975
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_KeyStore, getInstance$4b5d8fb7c9a36975);

_jc_java_security_KeyStore$object * _JC_JCNI_ATTR
_jc_java_security_KeyStore$method$getInstance$4b5d8fb7c9a36975(_jc_env *const env, _jc_java_lang_String$object *param0, _jc_java_lang_String$object *param1)
{
	jint i0;
	struct _jc_java_lang_String$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_java_security_Provider$object *r2;
	struct _jc_java_lang_IllegalArgumentException$object *r3;
	struct _jc_java_security_NoSuchProviderException$object *r4;
	struct _jc_java_security_KeyStore$object *r5;
	struct _jc_java_lang_String$object *r6;
	struct _jc_java_lang_VMThrowable$object *r7;
	struct _jc_java_lang_VMThrowable$object *r9;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = param0;
	r1 = param1;
	_JC_LINE_NUMBER(162);				// 0
	if (r1 == _JC_NULL)
		goto label0;
	i0 = _JC_PRIM_FIELD(env, r1, java_lang_String, count);
	if (i0 != 0)
		goto label1;

label0:
	_JC_LINE_NUMBER(163);				// 1
	r3 = _JC_NEW(env, java_lang_IllegalArgumentException);
	r6 = _JC_STRING(env, "Illegal provider");
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r7 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r7;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r6;
	_JC_THROW(env, r3);

label1:
	_JC_LINE_NUMBER(165);				// 2
	r2 = _JC_INVOKE_STATIC(env, java_security_Security, getProvider$581ee7d7bc9ae747, 0, r1);
	_JC_LINE_NUMBER(166);				// 3
	if (r2 != _JC_NULL)
		goto label2;
	_JC_LINE_NUMBER(167);				// 4
	r4 = _JC_NEW(env, java_security_NoSuchProviderException);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r9 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r9;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r1;
	_JC_THROW(env, r4);

label2:
	_JC_LINE_NUMBER(169);				// 5
	r5 = _JC_INVOKE_STATIC(env, java_security_KeyStore, getInstance$fb1f41ce03933040, 1, r0, r2);
	return r5;
}

//
// public static java.security.KeyStore getInstance(java.lang.String, java.security.Provider) throws java.security.KeyStoreException
//

static _jc_linenum _jc_java_security_KeyStore$linenum_table$getInstance$fb1f41ce03933040[];

static _jc_trap_info _jc_java_security_KeyStore$trap_table$getInstance$fb1f41ce03933040[] = {
	_JC_TRAP(&_jc_java_security_NoSuchAlgorithmException$type, 1, 2),
	_JC_TRAP(&_jc_java_lang_reflect_InvocationTargetException$type, 1, 2),
	_JC_TRAP(&_jc_java_lang_ClassCastException$type, 1, 2),
};

static const unsigned char _jc_java_security_KeyStore$param_ptypes$getInstance$fb1f41ce03933040[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_security_KeyStore$exceptions$getInstance$fb1f41ce03933040[] = {
	&_jc_java_security_KeyStoreException$type
};

static _jc_type *const _jc_java_security_KeyStore$param_types$getInstance$fb1f41ce03933040[] = {
	&_jc_java_lang_String$type,
	&_jc_java_security_Provider$type
};

_jc_method _jc_java_security_KeyStore$method_info$getInstance$fb1f41ce03933040 = {
	.name=			"getInstance",
	.signature=		"(Ljava/lang/String;Ljava/security/Provider;)Ljava/security/KeyStore;",
	.class=			&_jc_java_security_KeyStore$type,
	.param_types=		&_jc_java_security_KeyStore$param_types$getInstance$fb1f41ce03933040,
	.return_type=		&_jc_java_security_KeyStore$type,
	.param_ptypes=		&_jc_java_security_KeyStore$param_ptypes$getInstance$fb1f41ce03933040,
	.signature_hash=	_JC_JLONG(0xfb1f41ce03933040),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_java_security_KeyStore$method$getInstance$fb1f41ce03933040,
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_security_KeyStore$exceptions$getInstance$fb1f41ce03933040,
	.u= { .exec= {
	  .trap_table_len=	3,
	  .trap_table=		_jc_java_security_KeyStore$trap_table$getInstance$fb1f41ce03933040,
	  .u= {
	    .linenum= {
	      .len=	6,
	      .table=	_jc_java_security_KeyStore$linenum_table$getInstance$fb1f41ce03933040
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_KeyStore, getInstance$fb1f41ce03933040);

_jc_java_security_KeyStore$object * _JC_JCNI_ATTR
_jc_java_security_KeyStore$method$getInstance$fb1f41ce03933040(_jc_env *const env, _jc_java_lang_String$object *param0, _jc_java_security_Provider$object *param1)
{
	struct _jc_java_lang_String$object *volatile r0;
	struct _jc_java_security_Provider$object *r1;
	struct _jc_java_lang_String$object *r10;
	_jc_object_array *r11;
	struct _jc_java_lang_Object$object *r12;
	struct _jc_java_lang_VMThrowable$object *r13;
	struct _jc_java_lang_VMThrowable$object *volatile r14;
	struct _jc_java_lang_VMThrowable$object *volatile r15;
	struct _jc_java_lang_VMThrowable$object *volatile r17;
	struct _jc_java_security_NoSuchAlgorithmException$object *r2;
	struct _jc_java_lang_IllegalArgumentException$object *r3;
	struct _jc_java_security_KeyStore$object *r4;
	struct _jc_java_security_KeyStoreSpi$object *r5;
	struct _jc_java_security_KeyStoreException$object *volatile r6;
	struct _jc_java_lang_reflect_InvocationTargetException$object *r7;
	struct _jc_java_lang_ClassCastException$object *r8;
	struct _jc_java_lang_String$object *r9;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_java_security_KeyStore$method_info$getInstance$fb1f41ce03933040, &&label1, &&label2, &&label3);

	r0 = param0;
	r1 = param1;
	_JC_LINE_NUMBER(190);				// 0
	if (r1 != _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(191);				// 1
	r3 = _JC_NEW(env, java_lang_IllegalArgumentException);
	r9 = _JC_STRING(env, "Illegal provider");
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r13 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r13;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r9;
	_JC_THROW(env, r3);

label0:
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(194);				// 2
	r4 = _JC_NEW(env, java_security_KeyStore);
	_JC_ACTIVE_USE(env, gnu_java_security_Engine);
	r10 = _JC_STRING(env, "KeyStore");
	r11 = _JC_STATIC_FIELD(env, gnu_java_security_Engine, NO__5fARGS, 1);
	r12 = _JC_INVOKE_STATIC(env, gnu_java_security_Engine, getInstance$ec89dfd35c234c64, 1, r10, r0, r1, r11);
	r5 = _JC_CAST(env, &_jc_java_security_KeyStoreSpi$type, r12);
	_JC_REF_FIELD(env, r4, java_security_KeyStore, keyStoreSpi) = r5;
	_JC_REF_FIELD(env, r4, java_security_KeyStore, provider) = r1;
	_JC_REF_FIELD(env, r4, java_security_KeyStore, type) = r0;
	_JC_TRAP_REGION(catch, 2);
	_JC_CANCEL_TRAPS(env, catch);
	return r4;

label1:
	_JC_TRAP_REGION(catch, 2);
	r2 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(200);				// 3
	r6 = _JC_NEW(env, java_security_KeyStoreException);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, cause) = r6;
	r14 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r6);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, vmState) = r14;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, detailMessage) = r0;
	_JC_THROW(env, r6);

label2:
	_JC_TRAP_REGION(catch, 2);
	r7 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(204);				// 4
	r6 = _JC_NEW(env, java_security_KeyStoreException);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, cause) = r6;
	r15 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r6);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, vmState) = r15;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, detailMessage) = r0;
	_JC_THROW(env, r6);

label3:
	_JC_TRAP_REGION(catch, 2);
	r8 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(208);				// 5
	r6 = _JC_NEW(env, java_security_KeyStoreException);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, cause) = r6;
	r17 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r6);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, vmState) = r17;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, detailMessage) = r0;
	_JC_THROW(env, r6);
}

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// protected void <init>(java.security.KeyStoreSpi, java.security.Provider, java.lang.String)
//

static _jc_linenum _jc_java_security_KeyStore$linenum_table$_init$88a05dcece0166e3[];

static const unsigned char _jc_java_security_KeyStore$param_ptypes$_init$88a05dcece0166e3[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_security_KeyStore$param_types$_init$88a05dcece0166e3[] = {
	&_jc_java_security_KeyStoreSpi$type,
	&_jc_java_security_Provider$type,
	&_jc_java_lang_String$type
};

_jc_method _jc_java_security_KeyStore$method_info$_init$88a05dcece0166e3 = {
	.name=			"<init>",
	.signature=		"(Ljava/security/KeyStoreSpi;Ljava/security/Provider;Ljava/lang/String;)V",
	.class=			&_jc_java_security_KeyStore$type,
	.param_types=		&_jc_java_security_KeyStore$param_types$_init$88a05dcece0166e3,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_security_KeyStore$param_ptypes$_init$88a05dcece0166e3,
	.signature_hash=	_JC_JLONG(0x88a05dcece0166e3),
	.access_flags=		_JC_ACC_PROTECTED,
	.function=		&_jc_java_security_KeyStore$method$_init$88a05dcece0166e3,
	.num_parameters=	3,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_java_security_KeyStore$linenum_table$_init$88a05dcece0166e3
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_KeyStore, _init$88a05dcece0166e3);

void _JC_JCNI_ATTR
_jc_java_security_KeyStore$method$_init$88a05dcece0166e3(_jc_env *const env, _jc_java_security_KeyStore$object *this, _jc_java_security_KeyStoreSpi$object *param0, _jc_java_security_Provider$object *param1, _jc_java_lang_String$object *param2)
{
	struct _jc_java_security_KeyStore$object *r0;
	struct _jc_java_security_KeyStoreSpi$object *r1;
	struct _jc_java_security_Provider$object *r2;
	struct _jc_java_lang_String$object *r3;

	r0 = this;
	r1 = param0;
	r2 = param1;
	r3 = param2;
	_JC_LINE_NUMBER(106);				// 0
	_JC_REF_FIELD(env, r0, java_security_KeyStore, keyStoreSpi) = r1;
	_JC_LINE_NUMBER(107);				// 1
	_JC_REF_FIELD(env, r0, java_security_KeyStore, provider) = r2;
	_JC_LINE_NUMBER(108);				// 2
	_JC_REF_FIELD(env, r0, java_security_KeyStore, type) = r3;
	_JC_LINE_NUMBER(109);				// 3
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public final java.util.Enumeration aliases() throws java.security.KeyStoreException
//

static _jc_linenum _jc_java_security_KeyStore$linenum_table$aliases$837f5bf476af0985[];

static const unsigned char _jc_java_security_KeyStore$param_ptypes$aliases$837f5bf476af0985[] = { 
_JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_security_KeyStore$exceptions$aliases$837f5bf476af0985[] = {
	&_jc_java_security_KeyStoreException$type
};

_jc_method _jc_java_security_KeyStore$method_info$aliases$837f5bf476af0985 = {
	.name=			"aliases",
	.signature=		"()Ljava/util/Enumeration;",
	.class=			&_jc_java_security_KeyStore$type,
	.return_type=		&_jc_java_util_Enumeration$type,
	.param_ptypes=		&_jc_java_security_KeyStore$param_ptypes$aliases$837f5bf476af0985,
	.signature_hash=	_JC_JLONG(0x837f5bf476af0985),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_security_KeyStore$method$aliases$837f5bf476af0985,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_KeyStore$vtable, java_security_KeyStore.aliases$837f5bf476af0985) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_security_KeyStore$exceptions$aliases$837f5bf476af0985,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_KeyStore$linenum_table$aliases$837f5bf476af0985
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_KeyStore, aliases$837f5bf476af0985);

_jc_object * _JC_JCNI_ATTR
_jc_java_security_KeyStore$method$aliases$837f5bf476af0985(_jc_env *const env, _jc_java_security_KeyStore$object *this)
{
	struct _jc_java_security_KeyStore$object *r0;
	struct _jc_java_security_KeyStoreSpi$object *r1;
	struct _jc_object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(397);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_security_KeyStore, keyStoreSpi);
	r2 = _JC_INVOKE_VIRTUAL(env, java_security_KeyStoreSpi, engineAliases$0955230ea2712d95, r1);
	return r2;
}

//
// public final boolean containsAlias(java.lang.String) throws java.security.KeyStoreException
//

static _jc_linenum _jc_java_security_KeyStore$linenum_table$containsAlias$7bbc1584523b268a[];

static const unsigned char _jc_java_security_KeyStore$param_ptypes$containsAlias$7bbc1584523b268a[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_java_security_KeyStore$exceptions$containsAlias$7bbc1584523b268a[] = {
	&_jc_java_security_KeyStoreException$type
};

static _jc_type *const _jc_java_security_KeyStore$param_types$containsAlias$7bbc1584523b268a[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_java_security_KeyStore$method_info$containsAlias$7bbc1584523b268a = {
	.name=			"containsAlias",
	.signature=		"(Ljava/lang/String;)Z",
	.class=			&_jc_java_security_KeyStore$type,
	.param_types=		&_jc_java_security_KeyStore$param_types$containsAlias$7bbc1584523b268a,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_java_security_KeyStore$param_ptypes$containsAlias$7bbc1584523b268a,
	.signature_hash=	_JC_JLONG(0x7bbc1584523b268a),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_security_KeyStore$method$containsAlias$7bbc1584523b268a,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_KeyStore$vtable, java_security_KeyStore.containsAlias$7bbc1584523b268a) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_security_KeyStore$exceptions$containsAlias$7bbc1584523b268a,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_KeyStore$linenum_table$containsAlias$7bbc1584523b268a
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_KeyStore, containsAlias$7bbc1584523b268a);

jboolean _JC_JCNI_ATTR
_jc_java_security_KeyStore$method$containsAlias$7bbc1584523b268a(_jc_env *const env, _jc_java_security_KeyStore$object *this, _jc_java_lang_String$object *param0)
{
	struct _jc_java_security_KeyStore$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_java_security_KeyStoreSpi$object *r2;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(409);				// 0
	r2 = _JC_REF_FIELD(env, r0, java_security_KeyStore, keyStoreSpi);
	z0 = _JC_INVOKE_VIRTUAL(env, java_security_KeyStoreSpi, engineContainsAlias$01900ee93cf86541, r2, r1);
	return z0;
}

//
// public final void deleteEntry(java.lang.String) throws java.security.KeyStoreException
//

static _jc_linenum _jc_java_security_KeyStore$linenum_table$deleteEntry$8225ee7acd2d79af[];

static const unsigned char _jc_java_security_KeyStore$param_ptypes$deleteEntry$8225ee7acd2d79af[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_security_KeyStore$exceptions$deleteEntry$8225ee7acd2d79af[] = {
	&_jc_java_security_KeyStoreException$type
};

static _jc_type *const _jc_java_security_KeyStore$param_types$deleteEntry$8225ee7acd2d79af[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_java_security_KeyStore$method_info$deleteEntry$8225ee7acd2d79af = {
	.name=			"deleteEntry",
	.signature=		"(Ljava/lang/String;)V",
	.class=			&_jc_java_security_KeyStore$type,
	.param_types=		&_jc_java_security_KeyStore$param_types$deleteEntry$8225ee7acd2d79af,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_security_KeyStore$param_ptypes$deleteEntry$8225ee7acd2d79af,
	.signature_hash=	_JC_JLONG(0x8225ee7acd2d79af),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_security_KeyStore$method$deleteEntry$8225ee7acd2d79af,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_KeyStore$vtable, java_security_KeyStore.deleteEntry$8225ee7acd2d79af) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_security_KeyStore$exceptions$deleteEntry$8225ee7acd2d79af,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_security_KeyStore$linenum_table$deleteEntry$8225ee7acd2d79af
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_KeyStore, deleteEntry$8225ee7acd2d79af);

void _JC_JCNI_ATTR
_jc_java_security_KeyStore$method$deleteEntry$8225ee7acd2d79af(_jc_env *const env, _jc_java_security_KeyStore$object *this, _jc_java_lang_String$object *param0)
{
	struct _jc_java_security_KeyStore$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_java_security_KeyStoreSpi$object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(387);				// 0
	r2 = _JC_REF_FIELD(env, r0, java_security_KeyStore, keyStoreSpi);
	_JC_INVOKE_VIRTUAL(env, java_security_KeyStoreSpi, engineDeleteEntry$bdd78ac8b67a1628, r2, r1);
	_JC_LINE_NUMBER(388);				// 1
	return;
}

//
// public final java.security.cert.Certificate getCertificate(java.lang.String) throws java.security.KeyStoreException
//

static _jc_linenum _jc_java_security_KeyStore$linenum_table$getCertificate$24822578de0106e2[];

static const unsigned char _jc_java_security_KeyStore$param_ptypes$getCertificate$24822578de0106e2[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_security_KeyStore$exceptions$getCertificate$24822578de0106e2[] = {
	&_jc_java_security_KeyStoreException$type
};

static _jc_type *const _jc_java_security_KeyStore$param_types$getCertificate$24822578de0106e2[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_java_security_KeyStore$method_info$getCertificate$24822578de0106e2 = {
	.name=			"getCertificate",
	.signature=		"(Ljava/lang/String;)Ljava/security/cert/Certificate;",
	.class=			&_jc_java_security_KeyStore$type,
	.param_types=		&_jc_java_security_KeyStore$param_types$getCertificate$24822578de0106e2,
	.return_type=		&_jc_java_security_cert_Certificate$type,
	.param_ptypes=		&_jc_java_security_KeyStore$param_ptypes$getCertificate$24822578de0106e2,
	.signature_hash=	_JC_JLONG(0x24822578de0106e2),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_security_KeyStore$method$getCertificate$24822578de0106e2,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_KeyStore$vtable, java_security_KeyStore.getCertificate$24822578de0106e2) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_security_KeyStore$exceptions$getCertificate$24822578de0106e2,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_KeyStore$linenum_table$getCertificate$24822578de0106e2
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_KeyStore, getCertificate$24822578de0106e2);

_jc_java_security_cert_Certificate$object * _JC_JCNI_ATTR
_jc_java_security_KeyStore$method$getCertificate$24822578de0106e2(_jc_env *const env, _jc_java_security_KeyStore$object *this, _jc_java_lang_String$object *param0)
{
	struct _jc_java_security_KeyStore$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_java_security_KeyStoreSpi$object *r2;
	struct _jc_java_security_cert_Certificate$object *r3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(305);				// 0
	r2 = _JC_REF_FIELD(env, r0, java_security_KeyStore, keyStoreSpi);
	r3 = _JC_INVOKE_VIRTUAL(env, java_security_KeyStoreSpi, engineGetCertificate$3326089db6ae391c, r2, r1);
	return r3;
}

//
// public final java.lang.String getCertificateAlias(java.security.cert.Certificate) throws java.security.KeyStoreException
//

static _jc_linenum _jc_java_security_KeyStore$linenum_table$getCertificateAlias$56b4f9296e962f3d[];

static const unsigned char _jc_java_security_KeyStore$param_ptypes$getCertificateAlias$56b4f9296e962f3d[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_security_KeyStore$exceptions$getCertificateAlias$56b4f9296e962f3d[] = {
	&_jc_java_security_KeyStoreException$type
};

static _jc_type *const _jc_java_security_KeyStore$param_types$getCertificateAlias$56b4f9296e962f3d[] = {
	&_jc_java_security_cert_Certificate$type
};

_jc_method _jc_java_security_KeyStore$method_info$getCertificateAlias$56b4f9296e962f3d = {
	.name=			"getCertificateAlias",
	.signature=		"(Ljava/security/cert/Certificate;)Ljava/lang/String;",
	.class=			&_jc_java_security_KeyStore$type,
	.param_types=		&_jc_java_security_KeyStore$param_types$getCertificateAlias$56b4f9296e962f3d,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_java_security_KeyStore$param_ptypes$getCertificateAlias$56b4f9296e962f3d,
	.signature_hash=	_JC_JLONG(0x56b4f9296e962f3d),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_security_KeyStore$method$getCertificateAlias$56b4f9296e962f3d,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_KeyStore$vtable, java_security_KeyStore.getCertificateAlias$56b4f9296e962f3d) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_security_KeyStore$exceptions$getCertificateAlias$56b4f9296e962f3d,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_KeyStore$linenum_table$getCertificateAlias$56b4f9296e962f3d
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_KeyStore, getCertificateAlias$56b4f9296e962f3d);

_jc_java_lang_String$object * _JC_JCNI_ATTR
_jc_java_security_KeyStore$method$getCertificateAlias$56b4f9296e962f3d(_jc_env *const env, _jc_java_security_KeyStore$object *this, _jc_java_security_cert_Certificate$object *param0)
{
	struct _jc_java_security_KeyStore$object *r0;
	struct _jc_java_security_cert_Certificate$object *r1;
	struct _jc_java_security_KeyStoreSpi$object *r2;
	struct _jc_java_lang_String$object *r3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(465);				// 0
	r2 = _JC_REF_FIELD(env, r0, java_security_KeyStore, keyStoreSpi);
	r3 = _JC_INVOKE_VIRTUAL(env, java_security_KeyStoreSpi, engineGetCertificateAlias$e024c390f6ec7600, r2, r1);
	return r3;
}

//
// public final java.security.cert.Certificate[] getCertificateChain(java.lang.String) throws java.security.KeyStoreException
//

static _jc_linenum _jc_java_security_KeyStore$linenum_table$getCertificateChain$66e89eee98ca7bfb[];

static const unsigned char _jc_java_security_KeyStore$param_ptypes$getCertificateChain$66e89eee98ca7bfb[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_security_KeyStore$exceptions$getCertificateChain$66e89eee98ca7bfb[] = {
	&_jc_java_security_KeyStoreException$type
};

static _jc_type *const _jc_java_security_KeyStore$param_types$getCertificateChain$66e89eee98ca7bfb[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_java_security_KeyStore$method_info$getCertificateChain$66e89eee98ca7bfb = {
	.name=			"getCertificateChain",
	.signature=		"(Ljava/lang/String;)[Ljava/security/cert/Certificate;",
	.class=			&_jc_java_security_KeyStore$type,
	.param_types=		&_jc_java_security_KeyStore$param_types$getCertificateChain$66e89eee98ca7bfb,
	.return_type=		&_jc_java_security_cert_Certificate$array$type,
	.param_ptypes=		&_jc_java_security_KeyStore$param_ptypes$getCertificateChain$66e89eee98ca7bfb,
	.signature_hash=	_JC_JLONG(0x66e89eee98ca7bfb),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_security_KeyStore$method$getCertificateChain$66e89eee98ca7bfb,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_KeyStore$vtable, java_security_KeyStore.getCertificateChain$66e89eee98ca7bfb) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_security_KeyStore$exceptions$getCertificateChain$66e89eee98ca7bfb,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_KeyStore$linenum_table$getCertificateChain$66e89eee98ca7bfb
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_KeyStore, getCertificateChain$66e89eee98ca7bfb);

_jc_object_array * _JC_JCNI_ATTR
_jc_java_security_KeyStore$method$getCertificateChain$66e89eee98ca7bfb(_jc_env *const env, _jc_java_security_KeyStore$object *this, _jc_java_lang_String$object *param0)
{
	struct _jc_java_security_KeyStore$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_java_security_KeyStoreSpi$object *r2;
	_jc_object_array *r3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(287);				// 0
	r2 = _JC_REF_FIELD(env, r0, java_security_KeyStore, keyStoreSpi);
	r3 = _JC_INVOKE_VIRTUAL(env, java_security_KeyStoreSpi, engineGetCertificateChain$72fdaeba36a699e5, r2, r1);
	return r3;
}

//
// public final java.util.Date getCreationDate(java.lang.String) throws java.security.KeyStoreException
//

static _jc_linenum _jc_java_security_KeyStore$linenum_table$getCreationDate$afd5de3cce717517[];

static const unsigned char _jc_java_security_KeyStore$param_ptypes$getCreationDate$afd5de3cce717517[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_security_KeyStore$exceptions$getCreationDate$afd5de3cce717517[] = {
	&_jc_java_security_KeyStoreException$type
};

static _jc_type *const _jc_java_security_KeyStore$param_types$getCreationDate$afd5de3cce717517[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_java_security_KeyStore$method_info$getCreationDate$afd5de3cce717517 = {
	.name=			"getCreationDate",
	.signature=		"(Ljava/lang/String;)Ljava/util/Date;",
	.class=			&_jc_java_security_KeyStore$type,
	.param_types=		&_jc_java_security_KeyStore$param_types$getCreationDate$afd5de3cce717517,
	.return_type=		&_jc_java_util_Date$type,
	.param_ptypes=		&_jc_java_security_KeyStore$param_ptypes$getCreationDate$afd5de3cce717517,
	.signature_hash=	_JC_JLONG(0xafd5de3cce717517),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_security_KeyStore$method$getCreationDate$afd5de3cce717517,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_KeyStore$vtable, java_security_KeyStore.getCreationDate$afd5de3cce717517) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_security_KeyStore$exceptions$getCreationDate$afd5de3cce717517,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_KeyStore$linenum_table$getCreationDate$afd5de3cce717517
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_KeyStore, getCreationDate$afd5de3cce717517);

_jc_java_util_Date$object * _JC_JCNI_ATTR
_jc_java_security_KeyStore$method$getCreationDate$afd5de3cce717517(_jc_env *const env, _jc_java_security_KeyStore$object *this, _jc_java_lang_String$object *param0)
{
	struct _jc_java_security_KeyStore$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_java_security_KeyStoreSpi$object *r2;
	struct _jc_java_util_Date$object *r3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(317);				// 0
	r2 = _JC_REF_FIELD(env, r0, java_security_KeyStore, keyStoreSpi);
	r3 = _JC_INVOKE_VIRTUAL(env, java_security_KeyStoreSpi, engineGetCreationDate$6b955e76f165b525, r2, r1);
	return r3;
}

//
// public final java.security.Key getKey(java.lang.String, char[]) throws java.security.KeyStoreException, java.security.NoSuchAlgorithmException, java.security.UnrecoverableKeyException
//

static _jc_linenum _jc_java_security_KeyStore$linenum_table$getKey$d23847fd25d4be35[];

static const unsigned char _jc_java_security_KeyStore$param_ptypes$getKey$d23847fd25d4be35[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_security_KeyStore$exceptions$getKey$d23847fd25d4be35[] = {
	&_jc_java_security_KeyStoreException$type,
	&_jc_java_security_NoSuchAlgorithmException$type,
	&_jc_java_security_UnrecoverableKeyException$type
};

static _jc_type *const _jc_java_security_KeyStore$param_types$getKey$d23847fd25d4be35[] = {
	&_jc_java_lang_String$type,
	&_jc_char$array$prim$type
};

_jc_method _jc_java_security_KeyStore$method_info$getKey$d23847fd25d4be35 = {
	.name=			"getKey",
	.signature=		"(Ljava/lang/String;[C)Ljava/security/Key;",
	.class=			&_jc_java_security_KeyStore$type,
	.param_types=		&_jc_java_security_KeyStore$param_types$getKey$d23847fd25d4be35,
	.return_type=		&_jc_java_security_Key$type,
	.param_ptypes=		&_jc_java_security_KeyStore$param_ptypes$getKey$d23847fd25d4be35,
	.signature_hash=	_JC_JLONG(0xd23847fd25d4be35),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_security_KeyStore$method$getKey$d23847fd25d4be35,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_KeyStore$vtable, java_security_KeyStore.getKey$d23847fd25d4be35) / sizeof(void *),
	.num_parameters=	2,
	.num_exceptions=	3,
	.exceptions=		&_jc_java_security_KeyStore$exceptions$getKey$d23847fd25d4be35,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_KeyStore$linenum_table$getKey$d23847fd25d4be35
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_KeyStore, getKey$d23847fd25d4be35);

_jc_object * _JC_JCNI_ATTR
_jc_java_security_KeyStore$method$getKey$d23847fd25d4be35(_jc_env *const env, _jc_java_security_KeyStore$object *this, _jc_java_lang_String$object *param0, _jc_char_array *param1)
{
	struct _jc_java_security_KeyStore$object *r0;
	struct _jc_java_lang_String$object *r1;
	_jc_char_array *r2;
	struct _jc_java_security_KeyStoreSpi$object *r3;
	struct _jc_object *r4;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_LINE_NUMBER(270);				// 0
	r3 = _JC_REF_FIELD(env, r0, java_security_KeyStore, keyStoreSpi);
	r4 = _JC_INVOKE_VIRTUAL(env, java_security_KeyStoreSpi, engineGetKey$fa47c78db0ac610d, r3, r1, r2);
	return r4;
}

//
// public final java.security.Provider getProvider()
//

static _jc_linenum _jc_java_security_KeyStore$linenum_table$getProvider$e8f9c9fb14140d5a[];

static const unsigned char _jc_java_security_KeyStore$param_ptypes$getProvider$e8f9c9fb14140d5a[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_java_security_KeyStore$method_info$getProvider$e8f9c9fb14140d5a = {
	.name=			"getProvider",
	.signature=		"()Ljava/security/Provider;",
	.class=			&_jc_java_security_KeyStore$type,
	.return_type=		&_jc_java_security_Provider$type,
	.param_ptypes=		&_jc_java_security_KeyStore$param_ptypes$getProvider$e8f9c9fb14140d5a,
	.signature_hash=	_JC_JLONG(0xe8f9c9fb14140d5a),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_security_KeyStore$method$getProvider$e8f9c9fb14140d5a,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_KeyStore$vtable, java_security_KeyStore.getProvider$e8f9c9fb14140d5a) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_KeyStore$linenum_table$getProvider$e8f9c9fb14140d5a
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_KeyStore, getProvider$e8f9c9fb14140d5a);

_jc_java_security_Provider$object * _JC_JCNI_ATTR
_jc_java_security_KeyStore$method$getProvider$e8f9c9fb14140d5a(_jc_env *const env, _jc_java_security_KeyStore$object *this)
{
	struct _jc_java_security_KeyStore$object *r0;
	struct _jc_java_security_Provider$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(239);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_security_KeyStore, provider);
	return r1;
}

//
// public final java.lang.String getType()
//

static _jc_linenum _jc_java_security_KeyStore$linenum_table$getType$1756580bdd350fe6[];

static const unsigned char _jc_java_security_KeyStore$param_ptypes$getType$1756580bdd350fe6[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_java_security_KeyStore$method_info$getType$1756580bdd350fe6 = {
	.name=			"getType",
	.signature=		"()Ljava/lang/String;",
	.class=			&_jc_java_security_KeyStore$type,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_java_security_KeyStore$param_ptypes$getType$1756580bdd350fe6,
	.signature_hash=	_JC_JLONG(0x1756580bdd350fe6),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_security_KeyStore$method$getType$1756580bdd350fe6,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_KeyStore$vtable, java_security_KeyStore.getType$1756580bdd350fe6) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_KeyStore$linenum_table$getType$1756580bdd350fe6
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_KeyStore, getType$1756580bdd350fe6);

_jc_java_lang_String$object * _JC_JCNI_ATTR
_jc_java_security_KeyStore$method$getType$1756580bdd350fe6(_jc_env *const env, _jc_java_security_KeyStore$object *this)
{
	struct _jc_java_security_KeyStore$object *r0;
	struct _jc_java_lang_String$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(249);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_security_KeyStore, type);
	return r1;
}

//
// public final boolean isCertificateEntry(java.lang.String) throws java.security.KeyStoreException
//

static _jc_linenum _jc_java_security_KeyStore$linenum_table$isCertificateEntry$eec714aae49ad096[];

static const unsigned char _jc_java_security_KeyStore$param_ptypes$isCertificateEntry$eec714aae49ad096[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_java_security_KeyStore$exceptions$isCertificateEntry$eec714aae49ad096[] = {
	&_jc_java_security_KeyStoreException$type
};

static _jc_type *const _jc_java_security_KeyStore$param_types$isCertificateEntry$eec714aae49ad096[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_java_security_KeyStore$method_info$isCertificateEntry$eec714aae49ad096 = {
	.name=			"isCertificateEntry",
	.signature=		"(Ljava/lang/String;)Z",
	.class=			&_jc_java_security_KeyStore$type,
	.param_types=		&_jc_java_security_KeyStore$param_types$isCertificateEntry$eec714aae49ad096,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_java_security_KeyStore$param_ptypes$isCertificateEntry$eec714aae49ad096,
	.signature_hash=	_JC_JLONG(0xeec714aae49ad096),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_security_KeyStore$method$isCertificateEntry$eec714aae49ad096,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_KeyStore$vtable, java_security_KeyStore.isCertificateEntry$eec714aae49ad096) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_security_KeyStore$exceptions$isCertificateEntry$eec714aae49ad096,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_KeyStore$linenum_table$isCertificateEntry$eec714aae49ad096
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_KeyStore, isCertificateEntry$eec714aae49ad096);

jboolean _JC_JCNI_ATTR
_jc_java_security_KeyStore$method$isCertificateEntry$eec714aae49ad096(_jc_env *const env, _jc_java_security_KeyStore$object *this, _jc_java_lang_String$object *param0)
{
	struct _jc_java_security_KeyStore$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_java_security_KeyStoreSpi$object *r2;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(447);				// 0
	r2 = _JC_REF_FIELD(env, r0, java_security_KeyStore, keyStoreSpi);
	z0 = _JC_INVOKE_VIRTUAL(env, java_security_KeyStoreSpi, engineIsCertificateEntry$bb05da0b90387721, r2, r1);
	return z0;
}

//
// public final boolean isKeyEntry(java.lang.String) throws java.security.KeyStoreException
//

static _jc_linenum _jc_java_security_KeyStore$linenum_table$isKeyEntry$f78d60d950a2c7d5[];

static const unsigned char _jc_java_security_KeyStore$param_ptypes$isKeyEntry$f78d60d950a2c7d5[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_java_security_KeyStore$exceptions$isKeyEntry$f78d60d950a2c7d5[] = {
	&_jc_java_security_KeyStoreException$type
};

static _jc_type *const _jc_java_security_KeyStore$param_types$isKeyEntry$f78d60d950a2c7d5[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_java_security_KeyStore$method_info$isKeyEntry$f78d60d950a2c7d5 = {
	.name=			"isKeyEntry",
	.signature=		"(Ljava/lang/String;)Z",
	.class=			&_jc_java_security_KeyStore$type,
	.param_types=		&_jc_java_security_KeyStore$param_types$isKeyEntry$f78d60d950a2c7d5,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_java_security_KeyStore$param_ptypes$isKeyEntry$f78d60d950a2c7d5,
	.signature_hash=	_JC_JLONG(0xf78d60d950a2c7d5),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_security_KeyStore$method$isKeyEntry$f78d60d950a2c7d5,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_KeyStore$vtable, java_security_KeyStore.isKeyEntry$f78d60d950a2c7d5) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_security_KeyStore$exceptions$isKeyEntry$f78d60d950a2c7d5,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_KeyStore$linenum_table$isKeyEntry$f78d60d950a2c7d5
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_KeyStore, isKeyEntry$f78d60d950a2c7d5);

jboolean _JC_JCNI_ATTR
_jc_java_security_KeyStore$method$isKeyEntry$f78d60d950a2c7d5(_jc_env *const env, _jc_java_security_KeyStore$object *this, _jc_java_lang_String$object *param0)
{
	struct _jc_java_security_KeyStore$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_java_security_KeyStoreSpi$object *r2;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(432);				// 0
	r2 = _JC_REF_FIELD(env, r0, java_security_KeyStore, keyStoreSpi);
	z0 = _JC_INVOKE_VIRTUAL(env, java_security_KeyStoreSpi, engineIsKeyEntry$61a77d7c1a7691e9, r2, r1);
	return z0;
}

//
// public final void load(java.io.InputStream, char[]) throws java.io.IOException, java.security.NoSuchAlgorithmException, java.security.cert.CertificateException
//

static _jc_linenum _jc_java_security_KeyStore$linenum_table$load$499b35681ac8a878[];

static const unsigned char _jc_java_security_KeyStore$param_ptypes$load$499b35681ac8a878[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_security_KeyStore$exceptions$load$499b35681ac8a878[] = {
	&_jc_java_io_IOException$type,
	&_jc_java_security_NoSuchAlgorithmException$type,
	&_jc_java_security_cert_CertificateException$type
};

static _jc_type *const _jc_java_security_KeyStore$param_types$load$499b35681ac8a878[] = {
	&_jc_java_io_InputStream$type,
	&_jc_char$array$prim$type
};

_jc_method _jc_java_security_KeyStore$method_info$load$499b35681ac8a878 = {
	.name=			"load",
	.signature=		"(Ljava/io/InputStream;[C)V",
	.class=			&_jc_java_security_KeyStore$type,
	.param_types=		&_jc_java_security_KeyStore$param_types$load$499b35681ac8a878,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_security_KeyStore$param_ptypes$load$499b35681ac8a878,
	.signature_hash=	_JC_JLONG(0x499b35681ac8a878),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_security_KeyStore$method$load$499b35681ac8a878,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_KeyStore$vtable, java_security_KeyStore.load$499b35681ac8a878) / sizeof(void *),
	.num_parameters=	2,
	.num_exceptions=	3,
	.exceptions=		&_jc_java_security_KeyStore$exceptions$load$499b35681ac8a878,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_security_KeyStore$linenum_table$load$499b35681ac8a878
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_KeyStore, load$499b35681ac8a878);

void _JC_JCNI_ATTR
_jc_java_security_KeyStore$method$load$499b35681ac8a878(_jc_env *const env, _jc_java_security_KeyStore$object *this, _jc_java_io_InputStream$object *param0, _jc_char_array *param1)
{
	struct _jc_java_security_KeyStore$object *r0;
	struct _jc_java_io_InputStream$object *r1;
	_jc_char_array *r2;
	struct _jc_java_security_KeyStoreSpi$object *r3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_LINE_NUMBER(504);				// 0
	r3 = _JC_REF_FIELD(env, r0, java_security_KeyStore, keyStoreSpi);
	_JC_INVOKE_VIRTUAL(env, java_security_KeyStoreSpi, engineLoad$d8488504f88db514, r3, r1, r2);
	_JC_LINE_NUMBER(505);				// 1
	return;
}

//
// public final void setCertificateEntry(java.lang.String, java.security.cert.Certificate) throws java.security.KeyStoreException
//

static _jc_linenum _jc_java_security_KeyStore$linenum_table$setCertificateEntry$90015ebb95016acb[];

static const unsigned char _jc_java_security_KeyStore$param_ptypes$setCertificateEntry$90015ebb95016acb[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_security_KeyStore$exceptions$setCertificateEntry$90015ebb95016acb[] = {
	&_jc_java_security_KeyStoreException$type
};

static _jc_type *const _jc_java_security_KeyStore$param_types$setCertificateEntry$90015ebb95016acb[] = {
	&_jc_java_lang_String$type,
	&_jc_java_security_cert_Certificate$type
};

_jc_method _jc_java_security_KeyStore$method_info$setCertificateEntry$90015ebb95016acb = {
	.name=			"setCertificateEntry",
	.signature=		"(Ljava/lang/String;Ljava/security/cert/Certificate;)V",
	.class=			&_jc_java_security_KeyStore$type,
	.param_types=		&_jc_java_security_KeyStore$param_types$setCertificateEntry$90015ebb95016acb,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_security_KeyStore$param_ptypes$setCertificateEntry$90015ebb95016acb,
	.signature_hash=	_JC_JLONG(0x90015ebb95016acb),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_security_KeyStore$method$setCertificateEntry$90015ebb95016acb,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_KeyStore$vtable, java_security_KeyStore.setCertificateEntry$90015ebb95016acb) / sizeof(void *),
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_security_KeyStore$exceptions$setCertificateEntry$90015ebb95016acb,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_security_KeyStore$linenum_table$setCertificateEntry$90015ebb95016acb
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_KeyStore, setCertificateEntry$90015ebb95016acb);

void _JC_JCNI_ATTR
_jc_java_security_KeyStore$method$setCertificateEntry$90015ebb95016acb(_jc_env *const env, _jc_java_security_KeyStore$object *this, _jc_java_lang_String$object *param0, _jc_java_security_cert_Certificate$object *param1)
{
	struct _jc_java_security_KeyStore$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_java_security_cert_Certificate$object *r2;
	struct _jc_java_security_KeyStoreSpi$object *r3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_LINE_NUMBER(375);				// 0
	r3 = _JC_REF_FIELD(env, r0, java_security_KeyStore, keyStoreSpi);
	_JC_INVOKE_VIRTUAL(env, java_security_KeyStoreSpi, engineSetCertificateEntry$3735c54f89cf018b, r3, r1, r2);
	_JC_LINE_NUMBER(376);				// 1
	return;
}

//
// public final void setKeyEntry(java.lang.String, java.security.Key, char[], java.security.cert.Certificate[]) throws java.security.KeyStoreException
//

static _jc_linenum _jc_java_security_KeyStore$linenum_table$setKeyEntry$374d2010791c3021[];

static const unsigned char _jc_java_security_KeyStore$param_ptypes$setKeyEntry$374d2010791c3021[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_security_KeyStore$exceptions$setKeyEntry$374d2010791c3021[] = {
	&_jc_java_security_KeyStoreException$type
};

static _jc_type *const _jc_java_security_KeyStore$param_types$setKeyEntry$374d2010791c3021[] = {
	&_jc_java_lang_String$type,
	&_jc_java_security_Key$type,
	&_jc_char$array$prim$type,
	&_jc_java_security_cert_Certificate$array$type
};

_jc_method _jc_java_security_KeyStore$method_info$setKeyEntry$374d2010791c3021 = {
	.name=			"setKeyEntry",
	.signature=		"(Ljava/lang/String;Ljava/security/Key;[C[Ljava/security/cert/Certificate;)V",
	.class=			&_jc_java_security_KeyStore$type,
	.param_types=		&_jc_java_security_KeyStore$param_types$setKeyEntry$374d2010791c3021,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_security_KeyStore$param_ptypes$setKeyEntry$374d2010791c3021,
	.signature_hash=	_JC_JLONG(0x374d2010791c3021),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_security_KeyStore$method$setKeyEntry$374d2010791c3021,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_KeyStore$vtable, java_security_KeyStore.setKeyEntry$374d2010791c3021) / sizeof(void *),
	.num_parameters=	4,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_security_KeyStore$exceptions$setKeyEntry$374d2010791c3021,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_security_KeyStore$linenum_table$setKeyEntry$374d2010791c3021
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_KeyStore, setKeyEntry$374d2010791c3021);

void _JC_JCNI_ATTR
_jc_java_security_KeyStore$method$setKeyEntry$374d2010791c3021(_jc_env *const env, _jc_java_security_KeyStore$object *this, _jc_java_lang_String$object *param0, _jc_object *param1, _jc_char_array *param2, _jc_object_array *param3)
{
	struct _jc_java_security_KeyStore$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_object *r2;
	_jc_char_array *r3;
	_jc_object_array *r4;
	struct _jc_java_security_KeyStoreSpi$object *r5;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	r3 = param2;
	r4 = param3;
	_JC_LINE_NUMBER(338);				// 0
	r5 = _JC_REF_FIELD(env, r0, java_security_KeyStore, keyStoreSpi);
	_JC_INVOKE_VIRTUAL(env, java_security_KeyStoreSpi, engineSetKeyEntry$5c7d9fdd88ec48c8, r5, r1, r2, r3, r4);
	_JC_LINE_NUMBER(339);				// 1
	return;
}

//
// public final void setKeyEntry(java.lang.String, byte[], java.security.cert.Certificate[]) throws java.security.KeyStoreException
//

static _jc_linenum _jc_java_security_KeyStore$linenum_table$setKeyEntry$3e7f547380b6a895[];

static const unsigned char _jc_java_security_KeyStore$param_ptypes$setKeyEntry$3e7f547380b6a895[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_security_KeyStore$exceptions$setKeyEntry$3e7f547380b6a895[] = {
	&_jc_java_security_KeyStoreException$type
};

static _jc_type *const _jc_java_security_KeyStore$param_types$setKeyEntry$3e7f547380b6a895[] = {
	&_jc_java_lang_String$type,
	&_jc_byte$array$prim$type,
	&_jc_java_security_cert_Certificate$array$type
};

_jc_method _jc_java_security_KeyStore$method_info$setKeyEntry$3e7f547380b6a895 = {
	.name=			"setKeyEntry",
	.signature=		"(Ljava/lang/String;[B[Ljava/security/cert/Certificate;)V",
	.class=			&_jc_java_security_KeyStore$type,
	.param_types=		&_jc_java_security_KeyStore$param_types$setKeyEntry$3e7f547380b6a895,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_security_KeyStore$param_ptypes$setKeyEntry$3e7f547380b6a895,
	.signature_hash=	_JC_JLONG(0x3e7f547380b6a895),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_security_KeyStore$method$setKeyEntry$3e7f547380b6a895,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_KeyStore$vtable, java_security_KeyStore.setKeyEntry$3e7f547380b6a895) / sizeof(void *),
	.num_parameters=	3,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_security_KeyStore$exceptions$setKeyEntry$3e7f547380b6a895,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_security_KeyStore$linenum_table$setKeyEntry$3e7f547380b6a895
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_KeyStore, setKeyEntry$3e7f547380b6a895);

void _JC_JCNI_ATTR
_jc_java_security_KeyStore$method$setKeyEntry$3e7f547380b6a895(_jc_env *const env, _jc_java_security_KeyStore$object *this, _jc_java_lang_String$object *param0, _jc_byte_array *param1, _jc_object_array *param2)
{
	struct _jc_java_security_KeyStore$object *r0;
	struct _jc_java_lang_String$object *r1;
	_jc_byte_array *r2;
	_jc_object_array *r3;
	struct _jc_java_security_KeyStoreSpi$object *r4;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	r3 = param2;
	_JC_LINE_NUMBER(358);				// 0
	r4 = _JC_REF_FIELD(env, r0, java_security_KeyStore, keyStoreSpi);
	_JC_INVOKE_VIRTUAL(env, java_security_KeyStoreSpi, engineSetKeyEntry$73fcb51a80b954b9, r4, r1, r2, r3);
	_JC_LINE_NUMBER(359);				// 1
	return;
}

//
// public final int size() throws java.security.KeyStoreException
//

static _jc_linenum _jc_java_security_KeyStore$linenum_table$size$345df5220fc60ade[];

static const unsigned char _jc_java_security_KeyStore$param_ptypes$size$345df5220fc60ade[] = { 
_JC_TYPE_INT };

static _jc_type *const _jc_java_security_KeyStore$exceptions$size$345df5220fc60ade[] = {
	&_jc_java_security_KeyStoreException$type
};

_jc_method _jc_java_security_KeyStore$method_info$size$345df5220fc60ade = {
	.name=			"size",
	.signature=		"()I",
	.class=			&_jc_java_security_KeyStore$type,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_java_security_KeyStore$param_ptypes$size$345df5220fc60ade,
	.signature_hash=	_JC_JLONG(0x345df5220fc60ade),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_security_KeyStore$method$size$345df5220fc60ade,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_KeyStore$vtable, java_security_KeyStore.size$345df5220fc60ade) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_security_KeyStore$exceptions$size$345df5220fc60ade,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_KeyStore$linenum_table$size$345df5220fc60ade
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_KeyStore, size$345df5220fc60ade);

jint _JC_JCNI_ATTR
_jc_java_security_KeyStore$method$size$345df5220fc60ade(_jc_env *const env, _jc_java_security_KeyStore$object *this)
{
	jint i0;
	struct _jc_java_security_KeyStore$object *r0;
	struct _jc_java_security_KeyStoreSpi$object *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(419);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_security_KeyStore, keyStoreSpi);
	i0 = _JC_INVOKE_VIRTUAL(env, java_security_KeyStoreSpi, engineSize$1272b581c4ce840e, r1);
	return i0;
}

//
// public final void store(java.io.OutputStream, char[]) throws java.security.KeyStoreException, java.io.IOException, java.security.NoSuchAlgorithmException, java.security.cert.CertificateException
//

static _jc_linenum _jc_java_security_KeyStore$linenum_table$store$14d0905ec71b819c[];

static const unsigned char _jc_java_security_KeyStore$param_ptypes$store$14d0905ec71b819c[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_security_KeyStore$exceptions$store$14d0905ec71b819c[] = {
	&_jc_java_security_KeyStoreException$type,
	&_jc_java_io_IOException$type,
	&_jc_java_security_NoSuchAlgorithmException$type,
	&_jc_java_security_cert_CertificateException$type
};

static _jc_type *const _jc_java_security_KeyStore$param_types$store$14d0905ec71b819c[] = {
	&_jc_java_io_OutputStream$type,
	&_jc_char$array$prim$type
};

_jc_method _jc_java_security_KeyStore$method_info$store$14d0905ec71b819c = {
	.name=			"store",
	.signature=		"(Ljava/io/OutputStream;[C)V",
	.class=			&_jc_java_security_KeyStore$type,
	.param_types=		&_jc_java_security_KeyStore$param_types$store$14d0905ec71b819c,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_security_KeyStore$param_ptypes$store$14d0905ec71b819c,
	.signature_hash=	_JC_JLONG(0x14d0905ec71b819c),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_security_KeyStore$method$store$14d0905ec71b819c,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_KeyStore$vtable, java_security_KeyStore.store$14d0905ec71b819c) / sizeof(void *),
	.num_parameters=	2,
	.num_exceptions=	4,
	.exceptions=		&_jc_java_security_KeyStore$exceptions$store$14d0905ec71b819c,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_security_KeyStore$linenum_table$store$14d0905ec71b819c
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_KeyStore, store$14d0905ec71b819c);

void _JC_JCNI_ATTR
_jc_java_security_KeyStore$method$store$14d0905ec71b819c(_jc_env *const env, _jc_java_security_KeyStore$object *this, _jc_java_io_OutputStream$object *param0, _jc_char_array *param1)
{
	struct _jc_java_security_KeyStore$object *r0;
	struct _jc_java_io_OutputStream$object *r1;
	_jc_char_array *r2;
	struct _jc_java_security_KeyStoreSpi$object *r3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_LINE_NUMBER(485);				// 0
	r3 = _JC_REF_FIELD(env, r0, java_security_KeyStore, keyStoreSpi);
	_JC_INVOKE_VIRTUAL(env, java_security_KeyStoreSpi, engineStore$4ec5de49f9b16e36, r3, r1, r2);
	_JC_LINE_NUMBER(486);				// 1
	return;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_java_security_KeyStore$methods[] = {
	&_jc_java_security_KeyStore$method_info$_init$88a05dcece0166e3,
	&_jc_java_security_KeyStore$method_info$aliases$837f5bf476af0985,
	&_jc_java_security_KeyStore$method_info$containsAlias$7bbc1584523b268a,
	&_jc_java_security_KeyStore$method_info$deleteEntry$8225ee7acd2d79af,
	&_jc_java_security_KeyStore$method_info$getCertificate$24822578de0106e2,
	&_jc_java_security_KeyStore$method_info$getCertificateAlias$56b4f9296e962f3d,
	&_jc_java_security_KeyStore$method_info$getCertificateChain$66e89eee98ca7bfb,
	&_jc_java_security_KeyStore$method_info$getCreationDate$afd5de3cce717517,
	&_jc_java_security_KeyStore$method_info$getDefaultType$e0168af0ff28954a,
	&_jc_java_security_KeyStore$method_info$getInstance$2b9c173f301514d9,
	&_jc_java_security_KeyStore$method_info$getInstance$4b5d8fb7c9a36975,
	&_jc_java_security_KeyStore$method_info$getInstance$fb1f41ce03933040,
	&_jc_java_security_KeyStore$method_info$getKey$d23847fd25d4be35,
	&_jc_java_security_KeyStore$method_info$getProvider$e8f9c9fb14140d5a,
	&_jc_java_security_KeyStore$method_info$getType$1756580bdd350fe6,
	&_jc_java_security_KeyStore$method_info$isCertificateEntry$eec714aae49ad096,
	&_jc_java_security_KeyStore$method_info$isKeyEntry$f78d60d950a2c7d5,
	&_jc_java_security_KeyStore$method_info$load$499b35681ac8a878,
	&_jc_java_security_KeyStore$method_info$setCertificateEntry$90015ebb95016acb,
	&_jc_java_security_KeyStore$method_info$setKeyEntry$374d2010791c3021,
	&_jc_java_security_KeyStore$method_info$setKeyEntry$3e7f547380b6a895,
	&_jc_java_security_KeyStore$method_info$size$345df5220fc60ade,
	&_jc_java_security_KeyStore$method_info$store$14d0905ec71b819c
};

/************************************************************************
 *			  Class fields structure			*
 ************************************************************************/

_jc_java_security_KeyStore$fields_struct _jc_java_security_KeyStore$class_fields = { };

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_java_security_KeyStore$instanceof_hash_bucket_86[] = {
	&_jc_java_security_KeyStore$type,
	_JC_NULL
};
static _jc_type *const _jc_java_security_KeyStore$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_java_security_KeyStore$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[86]=	_jc_java_security_KeyStore$instanceof_hash_bucket_86,
	[101]=	_jc_java_security_KeyStore$instanceof_hash_bucket_101
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_java_security_KeyStore$class_depends[] = {
	{ "gnu/java/security/Engine",	_JC_JLONG(0xf4ba095546954b36) },
	{ "java/io/IOException",	_JC_JLONG(0x4e0a56550c69d57c) },
	{ "java/io/InputStream",	_JC_JLONG(0x66aea4d152614ac4) },
	{ "java/io/OutputStream",	_JC_JLONG(0x4026d3144d6654d8) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/ClassCastException",	_JC_JLONG(0xf02ab3ccb490a6d0) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/IllegalArgumentException",	_JC_JLONG(0x680cf34d05feb5a1) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/RuntimeException",	_JC_JLONG(0x4f5534a987354d1d) },
	{ "java/lang/SecurityManager",	_JC_JLONG(0xd38282f3d5f80887) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/StringBuffer",	_JC_JLONG(0x94d357637b968dda) },
	{ "java/lang/System",	_JC_JLONG(0x53cc8e2333795f04) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/lang/reflect/InvocationTargetException",	_JC_JLONG(0xae4a2342b31a268d) },
	{ "java/security/GeneralSecurityException",	_JC_JLONG(0x692089051f4c8d0b) },
	{ "java/security/Key",	_JC_JLONG(0xa467c6cd05d9cc51) },
	{ "java/security/KeyStoreException",	_JC_JLONG(0x45b488528f32667c) },
	{ "java/security/KeyStoreSpi",	_JC_JLONG(0x4760c3113311a807) },
	{ "java/security/NoSuchAlgorithmException",	_JC_JLONG(0x22e937c2536160b4) },
	{ "java/security/NoSuchProviderException",	_JC_JLONG(0x8dfbf242adab91e) },
	{ "java/security/Provider",	_JC_JLONG(0x81b073051aa30acc) },
	{ "java/security/Security",	_JC_JLONG(0x89bf77984bd9669e) },
	{ "java/security/UnrecoverableKeyException",	_JC_JLONG(0x398237d93436ff7e) },
	{ "java/security/cert/Certificate",	_JC_JLONG(0xc98c8192da849b07) },
	{ "java/security/cert/CertificateException",	_JC_JLONG(0xebfb598dd9fa8080) },
	{ "java/util/Date",	_JC_JLONG(0xa85d2a51094e614c) },
	{ "java/util/Enumeration",	_JC_JLONG(0xc56a8b1934689c38) },
	{ "java/util/Properties",	_JC_JLONG(0x884c3edb343dfb63) },
	{ "java/util/Vector",	_JC_JLONG(0xc53e1575b095109b) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_java_security_KeyStore$vtype _jc_java_security_KeyStore$type = {
    .type= {
	.name=			"java/security/KeyStore",
	.superclass=		&_jc_java_lang_Object$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		29,
		.hash=			_JC_JLONG(0x1f56d8b14978c9d6),
		.source_file=		"KeyStore.java",
		.instance_size=		sizeof(_jc_java_security_KeyStore$refs) + sizeof(_jc_java_security_KeyStore$object),
		.num_virtual_refs=	3,
		.num_fields=		sizeof(_jc_java_security_KeyStore$fields) / sizeof(*_jc_java_security_KeyStore$fields),
		.fields=		_jc_java_security_KeyStore$fields,
		.num_methods=		sizeof(_jc_java_security_KeyStore$methods) / sizeof(*_jc_java_security_KeyStore$methods),
		.methods=		_jc_java_security_KeyStore$methods,
		.instanceof_hash_table=	_jc_java_security_KeyStore$instanceof_hash_table,
		.class_fields=		&_jc_java_security_KeyStore$class_fields,
		.num_class_depends=		sizeof(_jc_java_security_KeyStore$class_depends) / sizeof(*_jc_java_security_KeyStore$class_depends),
		.class_depends=		_jc_java_security_KeyStore$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.java_security_KeyStore= {
	    .aliases$837f5bf476af0985=
		&_jc_java_security_KeyStore$method$aliases$837f5bf476af0985,
	    .containsAlias$7bbc1584523b268a=
		&_jc_java_security_KeyStore$method$containsAlias$7bbc1584523b268a,
	    .deleteEntry$8225ee7acd2d79af=
		&_jc_java_security_KeyStore$method$deleteEntry$8225ee7acd2d79af,
	    .getCertificate$24822578de0106e2=
		&_jc_java_security_KeyStore$method$getCertificate$24822578de0106e2,
	    .getCertificateAlias$56b4f9296e962f3d=
		&_jc_java_security_KeyStore$method$getCertificateAlias$56b4f9296e962f3d,
	    .getCertificateChain$66e89eee98ca7bfb=
		&_jc_java_security_KeyStore$method$getCertificateChain$66e89eee98ca7bfb,
	    .getCreationDate$afd5de3cce717517=
		&_jc_java_security_KeyStore$method$getCreationDate$afd5de3cce717517,
	    .getKey$d23847fd25d4be35=
		&_jc_java_security_KeyStore$method$getKey$d23847fd25d4be35,
	    .getProvider$e8f9c9fb14140d5a=
		&_jc_java_security_KeyStore$method$getProvider$e8f9c9fb14140d5a,
	    .getType$1756580bdd350fe6=
		&_jc_java_security_KeyStore$method$getType$1756580bdd350fe6,
	    .isCertificateEntry$eec714aae49ad096=
		&_jc_java_security_KeyStore$method$isCertificateEntry$eec714aae49ad096,
	    .isKeyEntry$f78d60d950a2c7d5=
		&_jc_java_security_KeyStore$method$isKeyEntry$f78d60d950a2c7d5,
	    .load$499b35681ac8a878=
		&_jc_java_security_KeyStore$method$load$499b35681ac8a878,
	    .setCertificateEntry$90015ebb95016acb=
		&_jc_java_security_KeyStore$method$setCertificateEntry$90015ebb95016acb,
	    .setKeyEntry$374d2010791c3021=
		&_jc_java_security_KeyStore$method$setKeyEntry$374d2010791c3021,
	    .setKeyEntry$3e7f547380b6a895=
		&_jc_java_security_KeyStore$method$setKeyEntry$3e7f547380b6a895,
	    .size$345df5220fc60ade=
		&_jc_java_security_KeyStore$method$size$345df5220fc60ade,
	    .store$14d0905ec71b819c=
		&_jc_java_security_KeyStore$method$store$14d0905ec71b819c,
	},
    }
};

