// public abstract class java.security.MessageDigest

// class file dependencies
// @dep_class f4ba095546954b36 gnu_java_security_Engine
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class d59353b5e031d754 java_lang_CloneNotSupportedException
// @dep_class 9b667b09132be893 java_lang_Cloneable
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class 680cf34d05feb5a1 java_lang_IllegalArgumentException
// @dep_class ca631501391a31f1 java_lang_Integer
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class 4f5534a987354d1d java_lang_RuntimeException
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 94d357637b968dda java_lang_StringBuffer
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class 238a2c0aafd74314 java_lang_VMClass
// @dep_class 312e45ed214d432f java_lang_VMObject
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class ae4a2342b31a268d java_lang_reflect_InvocationTargetException
// @dep_class 33115937139fdad0 java_security_DigestException
// @dep_class 30d44a22b32e0331 java_security_DummyMessageDigest
// @dep_class 692089051f4c8d0b java_security_GeneralSecurityException
// @dep_class cc2047cad8dcf75e java_security_MessageDigest
// @dep_class 7d8127440fb7dad2 java_security_MessageDigestSpi
// @dep_class 22e937c2536160b4 java_security_NoSuchAlgorithmException
// @dep_class 8dfbf242adab91e java_security_NoSuchProviderException
// @dep_class 81b073051aa30acc java_security_Provider
// @dep_class 89bf77984bd9669e java_security_Security
// @dep_class c53e1575b095109b java_util_Vector

// header file dependencies
// @dep_header gnu_java_security_Engine
// @dep_header java_lang_Class
// @dep_header java_lang_CloneNotSupportedException
// @dep_header java_lang_Cloneable
// @dep_header java_lang_IllegalArgumentException
// @dep_header java_lang_Integer
// @dep_header java_lang_String
// @dep_header java_lang_StringBuffer
// @dep_header java_lang_VMClass
// @dep_header java_lang_VMObject
// @dep_header java_lang_VMThrowable
// @dep_header java_lang_reflect_InvocationTargetException
// @dep_header java_security_DigestException
// @dep_header java_security_DummyMessageDigest
// @dep_header java_security_NoSuchAlgorithmException
// @dep_header java_security_NoSuchProviderException
// @dep_header java_security_Provider
// @dep_header java_security_Security
// @dep_header java_util_Vector

#include "jc_defs.h"

#include "gnu/java/security/Engine.h"
#include "java/lang/Class.h"
#include "java/lang/CloneNotSupportedException.h"
#include "java/lang/Cloneable.h"
#include "java/lang/IllegalArgumentException.h"
#include "java/lang/Integer.h"
#include "java/lang/String.h"
#include "java/lang/StringBuffer.h"
#include "java/lang/VMClass.h"
#include "java/lang/VMObject.h"
#include "java/lang/VMThrowable.h"
#include "java/lang/reflect/InvocationTargetException.h"
#include "java/security/DigestException.h"
#include "java/security/DummyMessageDigest.h"
#include "java/security/NoSuchAlgorithmException.h"
#include "java/security/NoSuchProviderException.h"
#include "java/security/Provider.h"
#include "java/security/Security.h"
#include "java/util/Vector.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// private static final java.lang.String MESSAGE_DIGEST
static _jc_field _jc_java_security_MessageDigest$field_info$MESSAGE__5fDIGEST = {
	.name=		"MESSAGE_DIGEST",
	.signature=	"Ljava/lang/String;",
	.class=		&_jc_java_security_MessageDigest$type,
	.type=		&_jc_java_lang_String$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_java_security_MessageDigest$fields_struct, MESSAGE__5fDIGEST),
	.initial_value=	"MessageDigest",
};

// private java.lang.String algorithm
static _jc_field _jc_java_security_MessageDigest$field_info$algorithm = {
	.name=		"algorithm",
	.signature=	"Ljava/lang/String;",
	.class=		&_jc_java_security_MessageDigest$type,
	.type=		&_jc_java_lang_String$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_security_MessageDigest$object, refs[-1].java_security_MessageDigest.algorithm),
};

// java.security.Provider provider
static _jc_field _jc_java_security_MessageDigest$field_info$provider = {
	.name=		"provider",
	.signature=	"Ljava/security/Provider;",
	.class=		&_jc_java_security_MessageDigest$type,
	.type=		&_jc_java_security_Provider$type,
	.access_flags=	0,
	.offset=	_JC_OFFSETOF(_jc_java_security_MessageDigest$object, refs[-1].java_security_MessageDigest.provider),
};

// private byte[] lastDigest
static _jc_field _jc_java_security_MessageDigest$field_info$lastDigest = {
	.name=		"lastDigest",
	.signature=	"[B",
	.class=		&_jc_java_security_MessageDigest$type,
	.type=		&_jc_byte$array$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_security_MessageDigest$object, refs[-1].java_security_MessageDigest.lastDigest),
};

// Fields
static _jc_field *const _jc_java_security_MessageDigest$fields[] = {
	&_jc_java_security_MessageDigest$field_info$MESSAGE__5fDIGEST,
	&_jc_java_security_MessageDigest$field_info$algorithm,
	&_jc_java_security_MessageDigest$field_info$lastDigest,
	&_jc_java_security_MessageDigest$field_info$provider
};

/************************************************************************
 *			      Static methods				*
 ************************************************************************/

//
// public static java.security.MessageDigest getInstance(java.lang.String) throws java.security.NoSuchAlgorithmException
//

static _jc_linenum _jc_java_security_MessageDigest$linenum_table$getInstance$ecf7339a3fb5ab58[];

static _jc_trap_info _jc_java_security_MessageDigest$trap_table$getInstance$ecf7339a3fb5ab58[] = {
	_JC_TRAP(&_jc_java_security_NoSuchAlgorithmException$type, 1, 2),
};

static const unsigned char _jc_java_security_MessageDigest$param_ptypes$getInstance$ecf7339a3fb5ab58[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_security_MessageDigest$exceptions$getInstance$ecf7339a3fb5ab58[] = {
	&_jc_java_security_NoSuchAlgorithmException$type
};

static _jc_type *const _jc_java_security_MessageDigest$param_types$getInstance$ecf7339a3fb5ab58[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_java_security_MessageDigest$method_info$getInstance$ecf7339a3fb5ab58 = {
	.name=			"getInstance",
	.signature=		"(Ljava/lang/String;)Ljava/security/MessageDigest;",
	.class=			&_jc_java_security_MessageDigest$type,
	.param_types=		&_jc_java_security_MessageDigest$param_types$getInstance$ecf7339a3fb5ab58,
	.return_type=		&_jc_java_security_MessageDigest$type,
	.param_ptypes=		&_jc_java_security_MessageDigest$param_ptypes$getInstance$ecf7339a3fb5ab58,
	.signature_hash=	_JC_JLONG(0xecf7339a3fb5ab58),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_java_security_MessageDigest$method$getInstance$ecf7339a3fb5ab58,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_security_MessageDigest$exceptions$getInstance$ecf7339a3fb5ab58,
	.u= { .exec= {
	  .trap_table_len=	1,
	  .trap_table=		_jc_java_security_MessageDigest$trap_table$getInstance$ecf7339a3fb5ab58,
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_java_security_MessageDigest$linenum_table$getInstance$ecf7339a3fb5ab58
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_MessageDigest, getInstance$ecf7339a3fb5ab58);

_jc_java_security_MessageDigest$object * _JC_JCNI_ATTR
_jc_java_security_MessageDigest$method$getInstance$ecf7339a3fb5ab58(_jc_env *const env, _jc_java_lang_String$object *param0)
{
	jint volatile i0;
	jint volatile i1;
	jint i2;
	struct _jc_java_lang_String$object *volatile r0;
	struct _jc_java_security_Provider$object *volatile r2;
	struct _jc_java_security_MessageDigest$object *volatile r3;
	struct _jc_java_security_NoSuchAlgorithmException$object *volatile r4;
	struct _jc_java_lang_VMThrowable$object *volatile r5;
	struct _jc_java_util_Vector$object *r6;
	_jc_object_array *volatile r7;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_java_security_MessageDigest$method_info$getInstance$ecf7339a3fb5ab58, &&label1);

	r0 = param0;
	_JC_ACTIVE_USE(env, java_security_Security);
	_JC_LINE_NUMBER(134);				// 0
	r6 = _JC_STATIC_FIELD(env, java_security_Security, providers, 1);
	i2 = _JC_INVOKE_VIRTUAL(env, java_util_Vector, size$345df5220fc60ade, r6);
	r7 = _JC_NEW_REF_ARRAY(env, java_security_Provider, 1, i2);
	r6 = _JC_STATIC_FIELD(env, java_security_Security, providers, 1);
	_JC_INVOKE_VIRTUAL(env, java_util_Vector, copyInto$cd78d768b3ba4735, r6, r7);
	_JC_LINE_NUMBER(135);				// 1
	i0 = 0;
	goto label2;

label0:
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(139);				// 2
	r2 = _JC_REF_ELEMENT(env, r7, i0, 1, 1);
	r3 = _JC_INVOKE_STATIC(env, java_security_MessageDigest, getInstance$60ade29cbc652343, 0, r0, r2);
	_JC_TRAP_REGION(catch, 2);
	_JC_CANCEL_TRAPS(env, catch);
	return r3;

label1:
	_JC_TRAP_REGION(catch, 2);
	r4 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(135);				// 3
	i0 = i0 + 1;

label2:
	_JC_TRAP_REGION(catch, 2);
	i1 = _JC_ARRAY_LENGTH(env, r7);
	if (i0 < i1) {
		_JC_PERIODIC_CHECK(env);
		goto label0;
	}
	_JC_LINE_NUMBER(147);				// 4
	r4 = _JC_NEW(env, java_security_NoSuchAlgorithmException);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r5 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r5;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r0;
	_JC_THROW(env, r4);
}

//
// public static java.security.MessageDigest getInstance(java.lang.String, java.lang.String) throws java.security.NoSuchAlgorithmException, java.security.NoSuchProviderException
//

static _jc_linenum _jc_java_security_MessageDigest$linenum_table$getInstance$0501b2a6af823665[];

static const unsigned char _jc_java_security_MessageDigest$param_ptypes$getInstance$0501b2a6af823665[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_security_MessageDigest$exceptions$getInstance$0501b2a6af823665[] = {
	&_jc_java_security_NoSuchAlgorithmException$type,
	&_jc_java_security_NoSuchProviderException$type
};

static _jc_type *const _jc_java_security_MessageDigest$param_types$getInstance$0501b2a6af823665[] = {
	&_jc_java_lang_String$type,
	&_jc_java_lang_String$type
};

_jc_method _jc_java_security_MessageDigest$method_info$getInstance$0501b2a6af823665 = {
	.name=			"getInstance",
	.signature=		"(Ljava/lang/String;Ljava/lang/String;)Ljava/security/MessageDigest;",
	.class=			&_jc_java_security_MessageDigest$type,
	.param_types=		&_jc_java_security_MessageDigest$param_types$getInstance$0501b2a6af823665,
	.return_type=		&_jc_java_security_MessageDigest$type,
	.param_ptypes=		&_jc_java_security_MessageDigest$param_ptypes$getInstance$0501b2a6af823665,
	.signature_hash=	_JC_JLONG(0x501b2a6af823665),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_java_security_MessageDigest$method$getInstance$0501b2a6af823665,
	.num_parameters=	2,
	.num_exceptions=	2,
	.exceptions=		&_jc_java_security_MessageDigest$exceptions$getInstance$0501b2a6af823665,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	6,
	      .table=	_jc_java_security_MessageDigest$linenum_table$getInstance$0501b2a6af823665
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_MessageDigest, getInstance$0501b2a6af823665);

_jc_java_security_MessageDigest$object * _JC_JCNI_ATTR
_jc_java_security_MessageDigest$method$getInstance$0501b2a6af823665(_jc_env *const env, _jc_java_lang_String$object *param0, _jc_java_lang_String$object *param1)
{
	jint i0;
	struct _jc_java_lang_String$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_java_security_Provider$object *r2;
	struct _jc_java_lang_IllegalArgumentException$object *r3;
	struct _jc_java_security_NoSuchProviderException$object *r4;
	struct _jc_java_security_MessageDigest$object *r5;
	struct _jc_java_lang_String$object *r6;
	struct _jc_java_lang_VMThrowable$object *r7;
	struct _jc_java_lang_VMThrowable$object *r9;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = param0;
	r1 = param1;
	_JC_LINE_NUMBER(170);				// 0
	if (r1 == _JC_NULL)
		goto label0;
	i0 = _JC_PRIM_FIELD(env, r1, java_lang_String, count);
	if (i0 != 0)
		goto label1;

label0:
	_JC_LINE_NUMBER(171);				// 1
	r3 = _JC_NEW(env, java_lang_IllegalArgumentException);
	r6 = _JC_STRING(env, "Illegal provider");
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r7 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r7;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r6;
	_JC_THROW(env, r3);

label1:
	_JC_LINE_NUMBER(173);				// 2
	r2 = _JC_INVOKE_STATIC(env, java_security_Security, getProvider$581ee7d7bc9ae747, 0, r1);
	_JC_LINE_NUMBER(174);				// 3
	if (r2 != _JC_NULL)
		goto label2;
	_JC_LINE_NUMBER(175);				// 4
	r4 = _JC_NEW(env, java_security_NoSuchProviderException);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r9 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r9;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r1;
	_JC_THROW(env, r4);

label2:
	_JC_LINE_NUMBER(177);				// 5
	r5 = _JC_INVOKE_STATIC(env, java_security_MessageDigest, getInstance$60ade29cbc652343, 1, r0, r2);
	return r5;
}

//
// public static java.security.MessageDigest getInstance(java.lang.String, java.security.Provider) throws java.security.NoSuchAlgorithmException
//

static _jc_linenum _jc_java_security_MessageDigest$linenum_table$getInstance$60ade29cbc652343[];

static _jc_trap_info _jc_java_security_MessageDigest$trap_table$getInstance$60ade29cbc652343[] = {
	_JC_TRAP(&_jc_java_lang_reflect_InvocationTargetException$type, 1, 2),
};

static const unsigned char _jc_java_security_MessageDigest$param_ptypes$getInstance$60ade29cbc652343[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_security_MessageDigest$exceptions$getInstance$60ade29cbc652343[] = {
	&_jc_java_security_NoSuchAlgorithmException$type
};

static _jc_type *const _jc_java_security_MessageDigest$param_types$getInstance$60ade29cbc652343[] = {
	&_jc_java_lang_String$type,
	&_jc_java_security_Provider$type
};

_jc_method _jc_java_security_MessageDigest$method_info$getInstance$60ade29cbc652343 = {
	.name=			"getInstance",
	.signature=		"(Ljava/lang/String;Ljava/security/Provider;)Ljava/security/MessageDigest;",
	.class=			&_jc_java_security_MessageDigest$type,
	.param_types=		&_jc_java_security_MessageDigest$param_types$getInstance$60ade29cbc652343,
	.return_type=		&_jc_java_security_MessageDigest$type,
	.param_ptypes=		&_jc_java_security_MessageDigest$param_ptypes$getInstance$60ade29cbc652343,
	.signature_hash=	_JC_JLONG(0x60ade29cbc652343),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_java_security_MessageDigest$method$getInstance$60ade29cbc652343,
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_security_MessageDigest$exceptions$getInstance$60ade29cbc652343,
	.u= { .exec= {
	  .trap_table_len=	1,
	  .trap_table=		_jc_java_security_MessageDigest$trap_table$getInstance$60ade29cbc652343,
	  .u= {
	    .linenum= {
	      .len=	12,
	      .table=	_jc_java_security_MessageDigest$linenum_table$getInstance$60ade29cbc652343
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_MessageDigest, getInstance$60ade29cbc652343);

_jc_java_security_MessageDigest$object * _JC_JCNI_ATTR
_jc_java_security_MessageDigest$method$getInstance$60ade29cbc652343(_jc_env *const env, _jc_java_lang_String$object *param0, _jc_java_security_Provider$object *param1)
{
	struct _jc_java_lang_String$object *volatile r0;
	struct _jc_java_security_Provider$object *r1;
	_jc_object_array *r10;
	struct _jc_java_lang_Object$object *r11;
	struct _jc_java_lang_VMThrowable$object *r12;
	struct _jc_java_lang_VMThrowable$object *volatile r13;
	struct _jc_java_lang_VMThrowable$object *r15;
	struct _jc_java_lang_reflect_InvocationTargetException$object *r2;
	struct _jc_java_lang_IllegalArgumentException$object *r3;
	struct _jc_java_security_NoSuchAlgorithmException$object *volatile r4;
	struct _jc_java_security_DummyMessageDigest$object *r5;
	struct _jc_java_security_MessageDigestSpi$object *r6;
	struct _jc_java_security_MessageDigest$object *r7;
	struct _jc_java_lang_String$object *r8;
	struct _jc_java_lang_String$object *r9;
	jboolean z0;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_java_security_MessageDigest$method_info$getInstance$60ade29cbc652343, &&label1);

	r0 = param0;
	r1 = param1;
	_JC_LINE_NUMBER(201);				// 0
	if (r1 != _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(202);				// 1
	r3 = _JC_NEW(env, java_lang_IllegalArgumentException);
	r8 = _JC_STRING(env, "Illegal provider");
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r12 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r12;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r8;
	_JC_THROW(env, r3);

label0:
	_JC_TRAP_REGION(catch, 1);
	_JC_ACTIVE_USE(env, gnu_java_security_Engine);
	_JC_LINE_NUMBER(208);				// 2
	r9 = _JC_STRING(env, "MessageDigest");
	r10 = _JC_STATIC_FIELD(env, gnu_java_security_Engine, NO__5fARGS, 1);
	r11 = _JC_INVOKE_STATIC(env, gnu_java_security_Engine, getInstance$ec89dfd35c234c64, 1, r9, r0, r1, r10);
	_JC_TRAP_REGION(catch, 2);
	goto label2;

label1:
	_JC_TRAP_REGION(catch, 2);
	r2 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(212);				// 3
	r4 = _JC_NEW(env, java_security_NoSuchAlgorithmException);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r13 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r13;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r0;
	_JC_THROW(env, r4);

label2:
	_JC_LINE_NUMBER(215);				// 4
	z0 = _JC_INSTANCEOF(env, r11, &_jc_java_security_MessageDigestSpi$type);
	if (z0 == 0)
		goto label3;
	_JC_LINE_NUMBER(217);				// 5
	r5 = _JC_NEW(env, java_security_DummyMessageDigest);
	r6 = r11;
	_JC_REF_FIELD(env, r5, java_security_MessageDigest, algorithm) = r0;
	_JC_REF_FIELD(env, r5, java_security_MessageDigest, provider) = _JC_NULL;
	_JC_REF_FIELD(env, r5, java_security_DummyMessageDigest, mdSpi) = _JC_NULL;
	_JC_REF_FIELD(env, r5, java_security_DummyMessageDigest, mdSpi) = r6;
	r7 = r5;
	goto label5;

label3:
	_JC_LINE_NUMBER(219);				// 6
	z0 = _JC_INSTANCEOF(env, r11, &_jc_java_security_MessageDigest$type);
	if (z0 == 0)
		goto label4;
	_JC_LINE_NUMBER(221);				// 7
	r7 = r11;
	_JC_LINE_NUMBER(222);				// 8
	_JC_REF_FIELD(env, r7, java_security_MessageDigest, algorithm) = r0;
	goto label5;

label4:
	_JC_LINE_NUMBER(226);				// 9
	r4 = _JC_NEW(env, java_security_NoSuchAlgorithmException);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r15 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r15;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r0;
	_JC_THROW(env, r4);

label5:
	_JC_LINE_NUMBER(228);				// 10
	_JC_REF_FIELD(env, r7, java_security_MessageDigest, provider) = r1;
	_JC_LINE_NUMBER(229);				// 11
	_JC_CANCEL_TRAPS(env, catch);
	return r7;
}

//
// public static boolean isEqual(byte[], byte[])
//

static _jc_linenum _jc_java_security_MessageDigest$linenum_table$isEqual$5767a3521c1cbfe7[];

static const unsigned char _jc_java_security_MessageDigest$param_ptypes$isEqual$5767a3521c1cbfe7[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_java_security_MessageDigest$param_types$isEqual$5767a3521c1cbfe7[] = {
	&_jc_byte$array$prim$type,
	&_jc_byte$array$prim$type
};

_jc_method _jc_java_security_MessageDigest$method_info$isEqual$5767a3521c1cbfe7 = {
	.name=			"isEqual",
	.signature=		"([B[B)Z",
	.class=			&_jc_java_security_MessageDigest$type,
	.param_types=		&_jc_java_security_MessageDigest$param_types$isEqual$5767a3521c1cbfe7,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_java_security_MessageDigest$param_ptypes$isEqual$5767a3521c1cbfe7,
	.signature_hash=	_JC_JLONG(0x5767a3521c1cbfe7),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_java_security_MessageDigest$method$isEqual$5767a3521c1cbfe7,
	.num_parameters=	2,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	7,
	      .table=	_jc_java_security_MessageDigest$linenum_table$isEqual$5767a3521c1cbfe7
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_MessageDigest, isEqual$5767a3521c1cbfe7);

jboolean _JC_JCNI_ATTR
_jc_java_security_MessageDigest$method$isEqual$5767a3521c1cbfe7(_jc_env *const env, _jc_byte_array *param0, _jc_byte_array *param1)
{
	jbyte b4;
	jbyte b5;
	jint i0;
	jint i2;
	_jc_byte_array *r0;
	_jc_byte_array *r1;

	r0 = param0;
	r1 = param1;
	_JC_LINE_NUMBER(336);				// 0
	i0 = _JC_ARRAY_LENGTH(env, r0);
	i2 = _JC_ARRAY_LENGTH(env, r1);
	if (i0 == i2)
		goto label0;
	_JC_LINE_NUMBER(337);				// 1
	return 0;

label0:
	_JC_LINE_NUMBER(339);				// 2
	i2 = _JC_ARRAY_LENGTH(env, r0);
	i0 = i2 - 1;
	goto label3;

label1:
	_JC_LINE_NUMBER(340);				// 3
	b4 = _JC_PRIM_ELEMENT(env, byte, r0, i0, 1, 0);
	b5 = _JC_PRIM_ELEMENT(env, byte, r1, i0, 0, 1);
	if (b4 == b5)
		goto label2;
	_JC_LINE_NUMBER(341);				// 4
	return 0;

label2:
	_JC_LINE_NUMBER(339);				// 5
	i0 = i0 + -1;

label3:
	if (i0 >= 0) {
		_JC_PERIODIC_CHECK(env);
		goto label1;
	}
	_JC_LINE_NUMBER(343);				// 6
	return 1;
}

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// protected void <init>(java.lang.String)
//

static _jc_linenum _jc_java_security_MessageDigest$linenum_table$_init$c31b894660454d13[];

static const unsigned char _jc_java_security_MessageDigest$param_ptypes$_init$c31b894660454d13[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_security_MessageDigest$param_types$_init$c31b894660454d13[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_java_security_MessageDigest$method_info$_init$c31b894660454d13 = {
	.name=			"<init>",
	.signature=		"(Ljava/lang/String;)V",
	.class=			&_jc_java_security_MessageDigest$type,
	.param_types=		&_jc_java_security_MessageDigest$param_types$_init$c31b894660454d13,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_security_MessageDigest$param_ptypes$_init$c31b894660454d13,
	.signature_hash=	_JC_JLONG(0xc31b894660454d13),
	.access_flags=		_JC_ACC_PROTECTED,
	.function=		&_jc_java_security_MessageDigest$method$_init$c31b894660454d13,
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_java_security_MessageDigest$linenum_table$_init$c31b894660454d13
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_MessageDigest, _init$c31b894660454d13);

void _JC_JCNI_ATTR
_jc_java_security_MessageDigest$method$_init$c31b894660454d13(_jc_env *const env, _jc_java_security_MessageDigest$object *this, _jc_java_lang_String$object *param0)
{
	struct _jc_java_security_MessageDigest$object *r0;
	struct _jc_java_lang_String$object *r1;

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(112);				// 0
	_JC_REF_FIELD(env, r0, java_security_MessageDigest, algorithm) = r1;
	_JC_LINE_NUMBER(113);				// 1
	_JC_REF_FIELD(env, r0, java_security_MessageDigest, provider) = _JC_NULL;
	_JC_LINE_NUMBER(114);				// 2
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public java.lang.Object clone() throws java.lang.CloneNotSupportedException
//

static _jc_linenum _jc_java_security_MessageDigest$linenum_table$clone$b75f2713d6705f70[];

static const unsigned char _jc_java_security_MessageDigest$param_ptypes$clone$b75f2713d6705f70[] = { 
_JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_security_MessageDigest$exceptions$clone$b75f2713d6705f70[] = {
	&_jc_java_lang_CloneNotSupportedException$type
};

_jc_method _jc_java_security_MessageDigest$method_info$clone$b75f2713d6705f70 = {
	.name=			"clone",
	.signature=		"()Ljava/lang/Object;",
	.class=			&_jc_java_security_MessageDigest$type,
	.return_type=		&_jc_java_lang_Object$type,
	.param_ptypes=		&_jc_java_security_MessageDigest$param_ptypes$clone$b75f2713d6705f70,
	.signature_hash=	_JC_JLONG(0xb75f2713d6705f70),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_MessageDigest$method$clone$b75f2713d6705f70,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_MessageDigest$vtable, java_security_MessageDigest.clone$b75f2713d6705f70) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_security_MessageDigest$exceptions$clone$b75f2713d6705f70,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_MessageDigest$linenum_table$clone$b75f2713d6705f70
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_MessageDigest, clone$b75f2713d6705f70);

_jc_java_lang_Object$object * _JC_JCNI_ATTR
_jc_java_security_MessageDigest$method$clone$b75f2713d6705f70(_jc_env *const env, _jc_java_security_MessageDigest$object *this)
{
	struct _jc_java_security_MessageDigest$object *r0;
	struct _jc_java_lang_Object$object *r1;
	struct _jc_object *r2;
	struct _jc_java_lang_CloneNotSupportedException$object *r3;
	struct _jc_java_lang_String$object *r4;
	struct _jc_java_lang_VMThrowable$object *r6;
	jboolean z0;

	r0 = this;
	z0 = _JC_INSTANCEOF(env, r0, &_jc_java_lang_Cloneable$type);
	if (z0 == 0)
		goto label0;
	r2 = r0;
	r1 = _JC_INVOKE_STATIC(env, java_lang_VMObject, clone$3943fce805d80b70, 0, r2);
	goto label1;

label0:
	r3 = _JC_NEW(env, java_lang_CloneNotSupportedException);
	r4 = _JC_STRING(env, "Object not cloneable");
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r6 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r6;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r4;
	_JC_THROW(env, r3);

label1:
	_JC_LINE_NUMBER(389);				// 0
	return r1;
}

//
// public byte[] digest()
//

static _jc_linenum _jc_java_security_MessageDigest$linenum_table$digest$24bbd103f8f0384e[];

static const unsigned char _jc_java_security_MessageDigest$param_ptypes$digest$24bbd103f8f0384e[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_java_security_MessageDigest$method_info$digest$24bbd103f8f0384e = {
	.name=			"digest",
	.signature=		"()[B",
	.class=			&_jc_java_security_MessageDigest$type,
	.return_type=		&_jc_byte$array$prim$type,
	.param_ptypes=		&_jc_java_security_MessageDigest$param_ptypes$digest$24bbd103f8f0384e,
	.signature_hash=	_JC_JLONG(0x24bbd103f8f0384e),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_MessageDigest$method$digest$24bbd103f8f0384e,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_MessageDigest$vtable, java_security_MessageDigest.digest$24bbd103f8f0384e) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_MessageDigest$linenum_table$digest$24bbd103f8f0384e
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_MessageDigest, digest$24bbd103f8f0384e);

_jc_byte_array * _JC_JCNI_ATTR
_jc_java_security_MessageDigest$method$digest$24bbd103f8f0384e(_jc_env *const env, _jc_java_security_MessageDigest$object *this)
{
	struct _jc_java_security_MessageDigest$object *r0;
	_jc_byte_array *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(283);				// 0
	r1 = _JC_INVOKE_VIRTUAL(env, java_security_MessageDigestSpi, engineDigest$af4966fb4f066ce0, r0);
	_JC_REF_FIELD(env, r0, java_security_MessageDigest, lastDigest) = r1;
	return r1;
}

//
// public byte[] digest(byte[])
//

static _jc_linenum _jc_java_security_MessageDigest$linenum_table$digest$676ad6c3bfac196b[];

static const unsigned char _jc_java_security_MessageDigest$param_ptypes$digest$676ad6c3bfac196b[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_security_MessageDigest$param_types$digest$676ad6c3bfac196b[] = {
	&_jc_byte$array$prim$type
};

_jc_method _jc_java_security_MessageDigest$method_info$digest$676ad6c3bfac196b = {
	.name=			"digest",
	.signature=		"([B)[B",
	.class=			&_jc_java_security_MessageDigest$type,
	.param_types=		&_jc_java_security_MessageDigest$param_types$digest$676ad6c3bfac196b,
	.return_type=		&_jc_byte$array$prim$type,
	.param_ptypes=		&_jc_java_security_MessageDigest$param_ptypes$digest$676ad6c3bfac196b,
	.signature_hash=	_JC_JLONG(0x676ad6c3bfac196b),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_MessageDigest$method$digest$676ad6c3bfac196b,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_MessageDigest$vtable, java_security_MessageDigest.digest$676ad6c3bfac196b) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_security_MessageDigest$linenum_table$digest$676ad6c3bfac196b
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_MessageDigest, digest$676ad6c3bfac196b);

_jc_byte_array * _JC_JCNI_ATTR
_jc_java_security_MessageDigest$method$digest$676ad6c3bfac196b(_jc_env *const env, _jc_java_security_MessageDigest$object *this, _jc_byte_array *param0)
{
	struct _jc_java_security_MessageDigest$object *r0;
	_jc_byte_array *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(312);				// 0
	_JC_INVOKE_VIRTUAL(env, java_security_MessageDigest, update$3e1f8b534704abb5, r0, r1);
	_JC_LINE_NUMBER(313);				// 1
	r1 = _JC_INVOKE_VIRTUAL(env, java_security_MessageDigest, digest$24bbd103f8f0384e, r0);
	return r1;
}

//
// public int digest(byte[], int, int) throws java.security.DigestException
//

static _jc_linenum _jc_java_security_MessageDigest$linenum_table$digest$5476df4071779ae8[];

static const unsigned char _jc_java_security_MessageDigest$param_ptypes$digest$5476df4071779ae8[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_INT, _JC_TYPE_INT };

static _jc_type *const _jc_java_security_MessageDigest$exceptions$digest$5476df4071779ae8[] = {
	&_jc_java_security_DigestException$type
};

static _jc_type *const _jc_java_security_MessageDigest$param_types$digest$5476df4071779ae8[] = {
	&_jc_byte$array$prim$type,
	&_jc_int$prim$type,
	&_jc_int$prim$type
};

_jc_method _jc_java_security_MessageDigest$method_info$digest$5476df4071779ae8 = {
	.name=			"digest",
	.signature=		"([BII)I",
	.class=			&_jc_java_security_MessageDigest$type,
	.param_types=		&_jc_java_security_MessageDigest$param_types$digest$5476df4071779ae8,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_java_security_MessageDigest$param_ptypes$digest$5476df4071779ae8,
	.signature_hash=	_JC_JLONG(0x5476df4071779ae8),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_MessageDigest$method$digest$5476df4071779ae8,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_MessageDigest$vtable, java_security_MessageDigest.digest$5476df4071779ae8) / sizeof(void *),
	.num_parameters=	3,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_security_MessageDigest$exceptions$digest$5476df4071779ae8,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_MessageDigest$linenum_table$digest$5476df4071779ae8
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_MessageDigest, digest$5476df4071779ae8);

jint _JC_JCNI_ATTR
_jc_java_security_MessageDigest$method$digest$5476df4071779ae8(_jc_env *const env, _jc_java_security_MessageDigest$object *this, _jc_byte_array *param0, jint param1, jint param2)
{
	jint i0;
	jint i1;
	struct _jc_java_security_MessageDigest$object *r0;
	_jc_byte_array *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	i0 = param1;
	i1 = param2;
	_JC_LINE_NUMBER(298);				// 0
	i1 = _JC_INVOKE_VIRTUAL(env, java_security_MessageDigestSpi, engineDigest$f590996905113538, r0, r1, i0, i1);
	return i1;
}

//
// private final java.lang.String digestToString()
//

static _jc_linenum _jc_java_security_MessageDigest$linenum_table$digestToString$f5ef075b7d03da7e[];

static const unsigned char _jc_java_security_MessageDigest$param_ptypes$digestToString$f5ef075b7d03da7e[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_java_security_MessageDigest$method_info$digestToString$f5ef075b7d03da7e = {
	.name=			"digestToString",
	.signature=		"()Ljava/lang/String;",
	.class=			&_jc_java_security_MessageDigest$type,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_java_security_MessageDigest$param_ptypes$digestToString$f5ef075b7d03da7e,
	.signature_hash=	_JC_JLONG(0xf5ef075b7d03da7e),
	.access_flags=		_JC_ACC_PRIVATE|_JC_ACC_FINAL,
	.function=		&_jc_java_security_MessageDigest$method$digestToString$f5ef075b7d03da7e,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_MessageDigest$vtable, java_security_MessageDigest.digestToString$f5ef075b7d03da7e) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	13,
	      .table=	_jc_java_security_MessageDigest$linenum_table$digestToString$f5ef075b7d03da7e
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_MessageDigest, digestToString$f5ef075b7d03da7e);

_jc_java_lang_String$object * _JC_JCNI_ATTR
_jc_java_security_MessageDigest$method$digestToString$f5ef075b7d03da7e(_jc_env *const env, _jc_java_security_MessageDigest$object *this)
{
	jbyte b2;
	jbyte b3;
	jint i0;
	jint i1;
	jint i5;
	struct _jc_java_security_MessageDigest$object *r0;
	_jc_byte_array *r1;
	struct _jc_java_lang_StringBuffer$object *r2;
	struct _jc_java_lang_String$object *r3;
	struct _jc_java_lang_String$object *r4;
	struct _jc_java_lang_String$object *r5;
	_jc_char_array *r6;
	jshort s4;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(394);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_security_MessageDigest, lastDigest);
	_JC_LINE_NUMBER(396);				// 1
	if (r1 != _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(397);				// 2
	return _JC_STRING(env, "incomplete");

label0:
	_JC_LINE_NUMBER(399);				// 3
	r2 = _JC_NEW(env, java_lang_StringBuffer);
	r6 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r2, java_lang_StringBuffer, value) = r6;
	_JC_LINE_NUMBER(400);				// 4
	i0 = _JC_ARRAY_LENGTH(env, r1);
	_JC_LINE_NUMBER(401);				// 5
	i1 = 0;
	goto label6;

label1:
	_JC_LINE_NUMBER(403);				// 6
	b2 = _JC_PRIM_ELEMENT(env, byte, r1, i1, 0, 1);
	_JC_LINE_NUMBER(404);				// 7
	s4 = b2 & 255;
	s4 = _JC_IUSHR(s4, 4);
	b3 = (jbyte)s4;
	_JC_LINE_NUMBER(405);				// 8
	b2 = b2 & 15;
	b2 = (jbyte)b2;
	_JC_LINE_NUMBER(407);				// 9
	if (b3 <= 9)
		goto label2;
	i5 = 87 + b3;
	goto label3;

label2:
	i5 = 48 + b3;

label3:
	_JC_ACTIVE_USE(env, java_lang_String);
	r3 = _JC_INVOKE_STATIC(env, java_lang_Integer, toString$80d919d12afaaa2b, 0, i5, 10);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r2, r3);
	_JC_LINE_NUMBER(408);				// 10
	if (b2 <= 9)
		goto label4;
	i5 = 87 + b2;
	goto label5;

label4:
	i5 = 48 + b2;

label5:
	r4 = _JC_INVOKE_STATIC(env, java_lang_Integer, toString$80d919d12afaaa2b, 1, i5, 10);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r2, r4);
	_JC_LINE_NUMBER(401);				// 11
	i1 = i1 + 1;

label6:
	if (i1 < i0) {
		_JC_PERIODIC_CHECK(env);
		goto label1;
	}
	r5 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r5, r2);
	_JC_LINE_NUMBER(411);				// 12
	return r5;
}

//
// public final java.lang.String getAlgorithm()
//

static _jc_linenum _jc_java_security_MessageDigest$linenum_table$getAlgorithm$19abbbc132b9063a[];

static const unsigned char _jc_java_security_MessageDigest$param_ptypes$getAlgorithm$19abbbc132b9063a[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_java_security_MessageDigest$method_info$getAlgorithm$19abbbc132b9063a = {
	.name=			"getAlgorithm",
	.signature=		"()Ljava/lang/String;",
	.class=			&_jc_java_security_MessageDigest$type,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_java_security_MessageDigest$param_ptypes$getAlgorithm$19abbbc132b9063a,
	.signature_hash=	_JC_JLONG(0x19abbbc132b9063a),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_security_MessageDigest$method$getAlgorithm$19abbbc132b9063a,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_MessageDigest$vtable, java_security_MessageDigest.getAlgorithm$19abbbc132b9063a) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_MessageDigest$linenum_table$getAlgorithm$19abbbc132b9063a
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_MessageDigest, getAlgorithm$19abbbc132b9063a);

_jc_java_lang_String$object * _JC_JCNI_ATTR
_jc_java_security_MessageDigest$method$getAlgorithm$19abbbc132b9063a(_jc_env *const env, _jc_java_security_MessageDigest$object *this)
{
	struct _jc_java_security_MessageDigest$object *r0;
	struct _jc_java_lang_String$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(363);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_security_MessageDigest, algorithm);
	return r1;
}

//
// public final int getDigestLength()
//

static _jc_linenum _jc_java_security_MessageDigest$linenum_table$getDigestLength$d25c09df3a61bf0e[];

static const unsigned char _jc_java_security_MessageDigest$param_ptypes$getDigestLength$d25c09df3a61bf0e[] = { 
_JC_TYPE_INT };

_jc_method _jc_java_security_MessageDigest$method_info$getDigestLength$d25c09df3a61bf0e = {
	.name=			"getDigestLength",
	.signature=		"()I",
	.class=			&_jc_java_security_MessageDigest$type,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_java_security_MessageDigest$param_ptypes$getDigestLength$d25c09df3a61bf0e,
	.signature_hash=	_JC_JLONG(0xd25c09df3a61bf0e),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_security_MessageDigest$method$getDigestLength$d25c09df3a61bf0e,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_MessageDigest$vtable, java_security_MessageDigest.getDigestLength$d25c09df3a61bf0e) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_MessageDigest$linenum_table$getDigestLength$d25c09df3a61bf0e
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_MessageDigest, getDigestLength$d25c09df3a61bf0e);

jint _JC_JCNI_ATTR
_jc_java_security_MessageDigest$method$getDigestLength$d25c09df3a61bf0e(_jc_env *const env, _jc_java_security_MessageDigest$object *this)
{
	jint i0;
	struct _jc_java_security_MessageDigest$object *r0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(377);				// 0
	i0 = _JC_INVOKE_VIRTUAL(env, java_security_MessageDigestSpi, engineGetDigestLength$74fcf1ae739bccab, r0);
	return i0;
}

//
// public final java.security.Provider getProvider()
//

static _jc_linenum _jc_java_security_MessageDigest$linenum_table$getProvider$e8f9c9fb14140d5a[];

static const unsigned char _jc_java_security_MessageDigest$param_ptypes$getProvider$e8f9c9fb14140d5a[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_java_security_MessageDigest$method_info$getProvider$e8f9c9fb14140d5a = {
	.name=			"getProvider",
	.signature=		"()Ljava/security/Provider;",
	.class=			&_jc_java_security_MessageDigest$type,
	.return_type=		&_jc_java_security_Provider$type,
	.param_ptypes=		&_jc_java_security_MessageDigest$param_ptypes$getProvider$e8f9c9fb14140d5a,
	.signature_hash=	_JC_JLONG(0xe8f9c9fb14140d5a),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_security_MessageDigest$method$getProvider$e8f9c9fb14140d5a,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_MessageDigest$vtable, java_security_MessageDigest.getProvider$e8f9c9fb14140d5a) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_MessageDigest$linenum_table$getProvider$e8f9c9fb14140d5a
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_MessageDigest, getProvider$e8f9c9fb14140d5a);

_jc_java_security_Provider$object * _JC_JCNI_ATTR
_jc_java_security_MessageDigest$method$getProvider$e8f9c9fb14140d5a(_jc_env *const env, _jc_java_security_MessageDigest$object *this)
{
	struct _jc_java_security_MessageDigest$object *r0;
	struct _jc_java_security_Provider$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(239);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_security_MessageDigest, provider);
	return r1;
}

//
// public void reset()
//

static _jc_linenum _jc_java_security_MessageDigest$linenum_table$reset$229a80b3e8394a0f[];

static const unsigned char _jc_java_security_MessageDigest$param_ptypes$reset$229a80b3e8394a0f[] = { 
_JC_TYPE_VOID };

_jc_method _jc_java_security_MessageDigest$method_info$reset$229a80b3e8394a0f = {
	.name=			"reset",
	.signature=		"()V",
	.class=			&_jc_java_security_MessageDigest$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_security_MessageDigest$param_ptypes$reset$229a80b3e8394a0f,
	.signature_hash=	_JC_JLONG(0x229a80b3e8394a0f),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_MessageDigest$method$reset$229a80b3e8394a0f,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_MessageDigest$vtable, java_security_MessageDigest.reset$229a80b3e8394a0f) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_security_MessageDigest$linenum_table$reset$229a80b3e8394a0f
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_MessageDigest, reset$229a80b3e8394a0f);

void _JC_JCNI_ATTR
_jc_java_security_MessageDigest$method$reset$229a80b3e8394a0f(_jc_env *const env, _jc_java_security_MessageDigest$object *this)
{
	struct _jc_java_security_MessageDigest$object *r0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(349);				// 0
	_JC_INVOKE_VIRTUAL(env, java_security_MessageDigestSpi, engineReset$216e0febda0be220, r0);
	_JC_LINE_NUMBER(350);				// 1
	return;
}

//
// public java.lang.String toString()
//

static _jc_linenum _jc_java_security_MessageDigest$linenum_table$toString$7ea43b33b80a3070[];

static const unsigned char _jc_java_security_MessageDigest$param_ptypes$toString$7ea43b33b80a3070[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_java_security_MessageDigest$method_info$toString$7ea43b33b80a3070 = {
	.name=			"toString",
	.signature=		"()Ljava/lang/String;",
	.class=			&_jc_java_security_MessageDigest$type,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_java_security_MessageDigest$param_ptypes$toString$7ea43b33b80a3070,
	.signature_hash=	_JC_JLONG(0x7ea43b33b80a3070),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_MessageDigest$method$toString$7ea43b33b80a3070,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_MessageDigest$vtable, java_security_MessageDigest.toString$7ea43b33b80a3070) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_MessageDigest$linenum_table$toString$7ea43b33b80a3070
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_MessageDigest, toString$7ea43b33b80a3070);

_jc_java_lang_String$object * _JC_JCNI_ATTR
_jc_java_security_MessageDigest$method$toString$7ea43b33b80a3070(_jc_env *const env, _jc_java_security_MessageDigest$object *this)
{
	struct _jc_java_security_MessageDigest$object *r0;
	struct _jc_java_lang_StringBuffer$object *r1;
	struct _jc_java_lang_String$object *r2;
	struct _jc_java_lang_Class$object *r3;
	struct _jc_java_lang_String$object *r4;
	struct _jc_java_lang_String$object *r5;
	_jc_char_array *r6;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(323);				// 0
	r1 = _JC_NEW(env, java_lang_StringBuffer);
	r6 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r1, java_lang_StringBuffer, value) = r6;
	r3 = _JC_INVOKE_STATIC(env, java_lang_VMObject, getClass$2be11d215bfbfbfe, 0, r0);
	_JC_EXPLICIT_NULL_CHECK(env, r3);
	r4 = _JC_INVOKE_STATIC(env, java_lang_VMClass, getName$7a04fe8e1a654d36, 0, r3);
	r1 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r1, r4);
	r1 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r1, _JC_STRING(env, " Message Digest <"));
	r2 = _JC_INVOKE_NONVIRTUAL(env, java_security_MessageDigest, digestToString$f5ef075b7d03da7e, 0, r0);
	r1 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r1, r2);
	r1 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$9450b16e89f0618d, 0, r1, 62);
	r5 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r5, r1);
	return r5;
}

//
// public void update(byte)
//

static _jc_linenum _jc_java_security_MessageDigest$linenum_table$update$373bf0a44dde26ba[];

static const unsigned char _jc_java_security_MessageDigest$param_ptypes$update$373bf0a44dde26ba[] = { 
_JC_TYPE_BYTE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_security_MessageDigest$param_types$update$373bf0a44dde26ba[] = {
	&_jc_byte$prim$type
};

_jc_method _jc_java_security_MessageDigest$method_info$update$373bf0a44dde26ba = {
	.name=			"update",
	.signature=		"(B)V",
	.class=			&_jc_java_security_MessageDigest$type,
	.param_types=		&_jc_java_security_MessageDigest$param_types$update$373bf0a44dde26ba,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_security_MessageDigest$param_ptypes$update$373bf0a44dde26ba,
	.signature_hash=	_JC_JLONG(0x373bf0a44dde26ba),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_MessageDigest$method$update$373bf0a44dde26ba,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_MessageDigest$vtable, java_security_MessageDigest.update$373bf0a44dde26ba) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_security_MessageDigest$linenum_table$update$373bf0a44dde26ba
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_MessageDigest, update$373bf0a44dde26ba);

void _JC_JCNI_ATTR
_jc_java_security_MessageDigest$method$update$373bf0a44dde26ba(_jc_env *const env, _jc_java_security_MessageDigest$object *this, jbyte param0)
{
	jbyte b0;
	struct _jc_java_security_MessageDigest$object *r0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	b0 = param0;
	_JC_LINE_NUMBER(249);				// 0
	_JC_INVOKE_VIRTUAL(env, java_security_MessageDigestSpi, engineUpdate$807e0421d3c3a314, r0, b0);
	_JC_LINE_NUMBER(250);				// 1
	return;
}

//
// public void update(byte[])
//

static _jc_linenum _jc_java_security_MessageDigest$linenum_table$update$3e1f8b534704abb5[];

static const unsigned char _jc_java_security_MessageDigest$param_ptypes$update$3e1f8b534704abb5[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_security_MessageDigest$param_types$update$3e1f8b534704abb5[] = {
	&_jc_byte$array$prim$type
};

_jc_method _jc_java_security_MessageDigest$method_info$update$3e1f8b534704abb5 = {
	.name=			"update",
	.signature=		"([B)V",
	.class=			&_jc_java_security_MessageDigest$type,
	.param_types=		&_jc_java_security_MessageDigest$param_types$update$3e1f8b534704abb5,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_security_MessageDigest$param_ptypes$update$3e1f8b534704abb5,
	.signature_hash=	_JC_JLONG(0x3e1f8b534704abb5),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_MessageDigest$method$update$3e1f8b534704abb5,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_MessageDigest$vtable, java_security_MessageDigest.update$3e1f8b534704abb5) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_security_MessageDigest$linenum_table$update$3e1f8b534704abb5
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_MessageDigest, update$3e1f8b534704abb5);

void _JC_JCNI_ATTR
_jc_java_security_MessageDigest$method$update$3e1f8b534704abb5(_jc_env *const env, _jc_java_security_MessageDigest$object *this, _jc_byte_array *param0)
{
	jint i0;
	struct _jc_java_security_MessageDigest$object *r0;
	_jc_byte_array *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(272);				// 0
	i0 = _JC_ARRAY_LENGTH(env, r1);
	_JC_INVOKE_VIRTUAL(env, java_security_MessageDigestSpi, engineUpdate$d2f85b5d32010900, r0, r1, 0, i0);
	_JC_LINE_NUMBER(273);				// 1
	return;
}

//
// public void update(byte[], int, int)
//

static _jc_linenum _jc_java_security_MessageDigest$linenum_table$update$f73f1b3bfa3ea853[];

static const unsigned char _jc_java_security_MessageDigest$param_ptypes$update$f73f1b3bfa3ea853[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_INT, _JC_TYPE_VOID };

static _jc_type *const _jc_java_security_MessageDigest$param_types$update$f73f1b3bfa3ea853[] = {
	&_jc_byte$array$prim$type,
	&_jc_int$prim$type,
	&_jc_int$prim$type
};

_jc_method _jc_java_security_MessageDigest$method_info$update$f73f1b3bfa3ea853 = {
	.name=			"update",
	.signature=		"([BII)V",
	.class=			&_jc_java_security_MessageDigest$type,
	.param_types=		&_jc_java_security_MessageDigest$param_types$update$f73f1b3bfa3ea853,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_security_MessageDigest$param_ptypes$update$f73f1b3bfa3ea853,
	.signature_hash=	_JC_JLONG(0xf73f1b3bfa3ea853),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_MessageDigest$method$update$f73f1b3bfa3ea853,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_MessageDigest$vtable, java_security_MessageDigest.update$f73f1b3bfa3ea853) / sizeof(void *),
	.num_parameters=	3,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_security_MessageDigest$linenum_table$update$f73f1b3bfa3ea853
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_MessageDigest, update$f73f1b3bfa3ea853);

void _JC_JCNI_ATTR
_jc_java_security_MessageDigest$method$update$f73f1b3bfa3ea853(_jc_env *const env, _jc_java_security_MessageDigest$object *this, _jc_byte_array *param0, jint param1, jint param2)
{
	jint i0;
	jint i1;
	struct _jc_java_security_MessageDigest$object *r0;
	_jc_byte_array *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	i0 = param1;
	i1 = param2;
	_JC_LINE_NUMBER(262);				// 0
	_JC_INVOKE_VIRTUAL(env, java_security_MessageDigestSpi, engineUpdate$d2f85b5d32010900, r0, r1, i0, i1);
	_JC_LINE_NUMBER(263);				// 1
	return;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_java_security_MessageDigest$methods[] = {
	&_jc_java_security_MessageDigest$method_info$_init$c31b894660454d13,
	&_jc_java_security_MessageDigest$method_info$clone$b75f2713d6705f70,
	&_jc_java_security_MessageDigest$method_info$digest$24bbd103f8f0384e,
	&_jc_java_security_MessageDigest$method_info$digest$676ad6c3bfac196b,
	&_jc_java_security_MessageDigest$method_info$digest$5476df4071779ae8,
	&_jc_java_security_MessageDigest$method_info$digestToString$f5ef075b7d03da7e,
	&_jc_java_security_MessageDigest$method_info$getAlgorithm$19abbbc132b9063a,
	&_jc_java_security_MessageDigest$method_info$getDigestLength$d25c09df3a61bf0e,
	&_jc_java_security_MessageDigest$method_info$getInstance$ecf7339a3fb5ab58,
	&_jc_java_security_MessageDigest$method_info$getInstance$0501b2a6af823665,
	&_jc_java_security_MessageDigest$method_info$getInstance$60ade29cbc652343,
	&_jc_java_security_MessageDigest$method_info$getProvider$e8f9c9fb14140d5a,
	&_jc_java_security_MessageDigest$method_info$isEqual$5767a3521c1cbfe7,
	&_jc_java_security_MessageDigest$method_info$reset$229a80b3e8394a0f,
	&_jc_java_security_MessageDigest$method_info$toString$7ea43b33b80a3070,
	&_jc_java_security_MessageDigest$method_info$update$373bf0a44dde26ba,
	&_jc_java_security_MessageDigest$method_info$update$3e1f8b534704abb5,
	&_jc_java_security_MessageDigest$method_info$update$f73f1b3bfa3ea853
};

/************************************************************************
 *			  Class fields structure			*
 ************************************************************************/

_jc_java_security_MessageDigest$fields_struct _jc_java_security_MessageDigest$class_fields = { };

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_java_security_MessageDigest$instanceof_hash_bucket_82[] = {
	&_jc_java_security_MessageDigestSpi$type,
	_JC_NULL
};
static _jc_type *const _jc_java_security_MessageDigest$instanceof_hash_bucket_94[] = {
	&_jc_java_security_MessageDigest$type,
	_JC_NULL
};
static _jc_type *const _jc_java_security_MessageDigest$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_java_security_MessageDigest$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[82]=	_jc_java_security_MessageDigest$instanceof_hash_bucket_82,
	[94]=	_jc_java_security_MessageDigest$instanceof_hash_bucket_94,
	[101]=	_jc_java_security_MessageDigest$instanceof_hash_bucket_101
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_java_security_MessageDigest$class_depends[] = {
	{ "gnu/java/security/Engine",	_JC_JLONG(0xf4ba095546954b36) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/CloneNotSupportedException",	_JC_JLONG(0xd59353b5e031d754) },
	{ "java/lang/Cloneable",	_JC_JLONG(0x9b667b09132be893) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/IllegalArgumentException",	_JC_JLONG(0x680cf34d05feb5a1) },
	{ "java/lang/Integer",	_JC_JLONG(0xca631501391a31f1) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/RuntimeException",	_JC_JLONG(0x4f5534a987354d1d) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/StringBuffer",	_JC_JLONG(0x94d357637b968dda) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMClass",	_JC_JLONG(0x238a2c0aafd74314) },
	{ "java/lang/VMObject",	_JC_JLONG(0x312e45ed214d432f) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/lang/reflect/InvocationTargetException",	_JC_JLONG(0xae4a2342b31a268d) },
	{ "java/security/DigestException",	_JC_JLONG(0x33115937139fdad0) },
	{ "java/security/DummyMessageDigest",	_JC_JLONG(0x30d44a22b32e0331) },
	{ "java/security/GeneralSecurityException",	_JC_JLONG(0x692089051f4c8d0b) },
	{ "java/security/MessageDigestSpi",	_JC_JLONG(0x7d8127440fb7dad2) },
	{ "java/security/NoSuchAlgorithmException",	_JC_JLONG(0x22e937c2536160b4) },
	{ "java/security/NoSuchProviderException",	_JC_JLONG(0x8dfbf242adab91e) },
	{ "java/security/Provider",	_JC_JLONG(0x81b073051aa30acc) },
	{ "java/security/Security",	_JC_JLONG(0x89bf77984bd9669e) },
	{ "java/util/Vector",	_JC_JLONG(0xc53e1575b095109b) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_java_security_MessageDigest$vtype _jc_java_security_MessageDigest$type = {
    .type= {
	.name=			"java/security/MessageDigest",
	.superclass=		&_jc_java_security_MessageDigestSpi$type,
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		31,
		.hash=			_JC_JLONG(0xcc2047cad8dcf75e),
		.source_file=		"MessageDigest.java",
		.instance_size=		sizeof(_jc_java_security_MessageDigest$refs) + sizeof(_jc_java_security_MessageDigest$object),
		.num_virtual_refs=	3,
		.num_fields=		sizeof(_jc_java_security_MessageDigest$fields) / sizeof(*_jc_java_security_MessageDigest$fields),
		.fields=		_jc_java_security_MessageDigest$fields,
		.num_methods=		sizeof(_jc_java_security_MessageDigest$methods) / sizeof(*_jc_java_security_MessageDigest$methods),
		.methods=		_jc_java_security_MessageDigest$methods,
		.instanceof_hash_table=	_jc_java_security_MessageDigest$instanceof_hash_table,
		.class_fields=		&_jc_java_security_MessageDigest$class_fields,
		.num_class_depends=		sizeof(_jc_java_security_MessageDigest$class_depends) / sizeof(*_jc_java_security_MessageDigest$class_depends),
		.class_depends=		_jc_java_security_MessageDigest$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=			// overridden
		&_jc_java_security_MessageDigest$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=			// overridden
		&_jc_java_security_MessageDigest$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.java_security_MessageDigestSpi= {
	    .clone$b75f2713d6705f70=			// overridden
		&_jc_java_security_MessageDigest$method$clone$b75f2713d6705f70,
	    .engineDigest$af4966fb4f066ce0=
		&_jc_java_security_MessageDigestSpi$method$engineDigest$af4966fb4f066ce0,
	    .engineDigest$f590996905113538=
		&_jc_java_security_MessageDigestSpi$method$engineDigest$f590996905113538,
	    .engineGetDigestLength$74fcf1ae739bccab=
		&_jc_java_security_MessageDigestSpi$method$engineGetDigestLength$74fcf1ae739bccab,
	    .engineReset$216e0febda0be220=
		&_jc_java_security_MessageDigestSpi$method$engineReset$216e0febda0be220,
	    .engineUpdate$807e0421d3c3a314=
		&_jc_java_security_MessageDigestSpi$method$engineUpdate$807e0421d3c3a314,
	    .engineUpdate$d2f85b5d32010900=
		&_jc_java_security_MessageDigestSpi$method$engineUpdate$d2f85b5d32010900,
	},
	.java_security_MessageDigest= {
	    .clone$b75f2713d6705f70=
		&_jc_java_security_MessageDigest$method$clone$b75f2713d6705f70,
	    .digest$24bbd103f8f0384e=
		&_jc_java_security_MessageDigest$method$digest$24bbd103f8f0384e,
	    .digest$676ad6c3bfac196b=
		&_jc_java_security_MessageDigest$method$digest$676ad6c3bfac196b,
	    .digest$5476df4071779ae8=
		&_jc_java_security_MessageDigest$method$digest$5476df4071779ae8,
	    .digestToString$f5ef075b7d03da7e=
		&_jc_java_security_MessageDigest$method$digestToString$f5ef075b7d03da7e,
	    .getAlgorithm$19abbbc132b9063a=
		&_jc_java_security_MessageDigest$method$getAlgorithm$19abbbc132b9063a,
	    .getDigestLength$d25c09df3a61bf0e=
		&_jc_java_security_MessageDigest$method$getDigestLength$d25c09df3a61bf0e,
	    .getProvider$e8f9c9fb14140d5a=
		&_jc_java_security_MessageDigest$method$getProvider$e8f9c9fb14140d5a,
	    .reset$229a80b3e8394a0f=
		&_jc_java_security_MessageDigest$method$reset$229a80b3e8394a0f,
	    .toString$7ea43b33b80a3070=
		&_jc_java_security_MessageDigest$method$toString$7ea43b33b80a3070,
	    .update$373bf0a44dde26ba=
		&_jc_java_security_MessageDigest$method$update$373bf0a44dde26ba,
	    .update$3e1f8b534704abb5=
		&_jc_java_security_MessageDigest$method$update$3e1f8b534704abb5,
	    .update$f73f1b3bfa3ea853=
		&_jc_java_security_MessageDigest$method$update$f73f1b3bfa3ea853,
	},
    }
};

