// public class java.security.cert.CertificateFactory

// class file dependencies
// @dep_class f4ba095546954b36 gnu_java_security_Engine
// @dep_class 66aea4d152614ac4 java_io_InputStream
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class f02ab3ccb490a6d0 java_lang_ClassCastException
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class 680cf34d05feb5a1 java_lang_IllegalArgumentException
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class 4f5534a987354d1d java_lang_RuntimeException
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class ae4a2342b31a268d java_lang_reflect_InvocationTargetException
// @dep_class 692089051f4c8d0b java_security_GeneralSecurityException
// @dep_class 22e937c2536160b4 java_security_NoSuchAlgorithmException
// @dep_class 8dfbf242adab91e java_security_NoSuchProviderException
// @dep_class 81b073051aa30acc java_security_Provider
// @dep_class 89bf77984bd9669e java_security_Security
// @dep_class 968d6f530411e76e java_security_cert_CRL
// @dep_class 19d465acf62ede69 java_security_cert_CRLException
// @dep_class 88ba88f1f11a1086 java_security_cert_CertPath
// @dep_class c98c8192da849b07 java_security_cert_Certificate
// @dep_class ebfb598dd9fa8080 java_security_cert_CertificateException
// @dep_class 91bb7671288911f1 java_security_cert_CertificateFactory
// @dep_class 52d94d6b40f8d849 java_security_cert_CertificateFactorySpi
// @dep_class eae4d0c0e8eb63da java_util_Collection
// @dep_class be56ff673eefd9d2 java_util_Iterator
// @dep_class 9ee0d92ce1525a4d java_util_List
// @dep_class c53e1575b095109b java_util_Vector

// header file dependencies
// @dep_header gnu_java_security_Engine
// @dep_header java_io_InputStream
// @dep_header java_lang_Class
// @dep_header java_lang_ClassCastException
// @dep_header java_lang_IllegalArgumentException
// @dep_header java_lang_String
// @dep_header java_lang_VMThrowable
// @dep_header java_lang_reflect_InvocationTargetException
// @dep_header java_security_NoSuchAlgorithmException
// @dep_header java_security_NoSuchProviderException
// @dep_header java_security_Provider
// @dep_header java_security_Security
// @dep_header java_security_cert_CRL
// @dep_header java_security_cert_CRLException
// @dep_header java_security_cert_CertPath
// @dep_header java_security_cert_Certificate
// @dep_header java_security_cert_CertificateException
// @dep_header java_security_cert_CertificateFactory
// @dep_header java_security_cert_CertificateFactorySpi
// @dep_header java_util_Collection
// @dep_header java_util_Iterator
// @dep_header java_util_List
// @dep_header java_util_Vector

#include "jc_defs.h"

#include "gnu/java/security/Engine.h"
#include "java/io/InputStream.h"
#include "java/lang/Class.h"
#include "java/lang/ClassCastException.h"
#include "java/lang/IllegalArgumentException.h"
#include "java/lang/String.h"
#include "java/lang/VMThrowable.h"
#include "java/lang/reflect/InvocationTargetException.h"
#include "java/security/NoSuchAlgorithmException.h"
#include "java/security/NoSuchProviderException.h"
#include "java/security/Provider.h"
#include "java/security/Security.h"
#include "java/security/cert/CRL.h"
#include "java/security/cert/CRLException.h"
#include "java/security/cert/CertPath.h"
#include "java/security/cert/Certificate.h"
#include "java/security/cert/CertificateException.h"
#include "java/security/cert/CertificateFactory.h"
#include "java/security/cert/CertificateFactorySpi.h"
#include "java/util/Collection.h"
#include "java/util/Iterator.h"
#include "java/util/List.h"
#include "java/util/Vector.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// private static final java.lang.String CERTIFICATE_FACTORY
static _jc_field _jc_java_security_cert_CertificateFactory$field_info$CERTIFICATE__5fFACTORY = {
	.name=		"CERTIFICATE_FACTORY",
	.signature=	"Ljava/lang/String;",
	.class=		&_jc_java_security_cert_CertificateFactory$type,
	.type=		&_jc_java_lang_String$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_java_security_cert_CertificateFactory$fields_struct, CERTIFICATE__5fFACTORY),
	.initial_value=	"CertificateFactory",
};

// private java.security.cert.CertificateFactorySpi certFacSpi
static _jc_field _jc_java_security_cert_CertificateFactory$field_info$certFacSpi = {
	.name=		"certFacSpi",
	.signature=	"Ljava/security/cert/CertificateFactorySpi;",
	.class=		&_jc_java_security_cert_CertificateFactory$type,
	.type=		&_jc_java_security_cert_CertificateFactorySpi$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_security_cert_CertificateFactory$object, refs[-1].java_security_cert_CertificateFactory.certFacSpi),
};

// private java.security.Provider provider
static _jc_field _jc_java_security_cert_CertificateFactory$field_info$provider = {
	.name=		"provider",
	.signature=	"Ljava/security/Provider;",
	.class=		&_jc_java_security_cert_CertificateFactory$type,
	.type=		&_jc_java_security_Provider$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_security_cert_CertificateFactory$object, refs[-1].java_security_cert_CertificateFactory.provider),
};

// private java.lang.String type
static _jc_field _jc_java_security_cert_CertificateFactory$field_info$type = {
	.name=		"type",
	.signature=	"Ljava/lang/String;",
	.class=		&_jc_java_security_cert_CertificateFactory$type,
	.type=		&_jc_java_lang_String$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_security_cert_CertificateFactory$object, refs[-1].java_security_cert_CertificateFactory.type),
};

// Fields
static _jc_field *const _jc_java_security_cert_CertificateFactory$fields[] = {
	&_jc_java_security_cert_CertificateFactory$field_info$CERTIFICATE__5fFACTORY,
	&_jc_java_security_cert_CertificateFactory$field_info$certFacSpi,
	&_jc_java_security_cert_CertificateFactory$field_info$provider,
	&_jc_java_security_cert_CertificateFactory$field_info$type
};

/************************************************************************
 *			      Static methods				*
 ************************************************************************/

//
// public static final java.security.cert.CertificateFactory getInstance(java.lang.String) throws java.security.cert.CertificateException
//

static _jc_linenum _jc_java_security_cert_CertificateFactory$linenum_table$getInstance$640c30d2dd2d7d5a[];

static _jc_trap_info _jc_java_security_cert_CertificateFactory$trap_table$getInstance$640c30d2dd2d7d5a[] = {
	_JC_TRAP(&_jc_java_security_cert_CertificateException$type, 1, 2),
};

static const unsigned char _jc_java_security_cert_CertificateFactory$param_ptypes$getInstance$640c30d2dd2d7d5a[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_security_cert_CertificateFactory$exceptions$getInstance$640c30d2dd2d7d5a[] = {
	&_jc_java_security_cert_CertificateException$type
};

static _jc_type *const _jc_java_security_cert_CertificateFactory$param_types$getInstance$640c30d2dd2d7d5a[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_java_security_cert_CertificateFactory$method_info$getInstance$640c30d2dd2d7d5a = {
	.name=			"getInstance",
	.signature=		"(Ljava/lang/String;)Ljava/security/cert/CertificateFactory;",
	.class=			&_jc_java_security_cert_CertificateFactory$type,
	.param_types=		&_jc_java_security_cert_CertificateFactory$param_types$getInstance$640c30d2dd2d7d5a,
	.return_type=		&_jc_java_security_cert_CertificateFactory$type,
	.param_ptypes=		&_jc_java_security_cert_CertificateFactory$param_ptypes$getInstance$640c30d2dd2d7d5a,
	.signature_hash=	_JC_JLONG(0x640c30d2dd2d7d5a),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.function=		&_jc_java_security_cert_CertificateFactory$method$getInstance$640c30d2dd2d7d5a,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_security_cert_CertificateFactory$exceptions$getInstance$640c30d2dd2d7d5a,
	.u= { .exec= {
	  .trap_table_len=	1,
	  .trap_table=		_jc_java_security_cert_CertificateFactory$trap_table$getInstance$640c30d2dd2d7d5a,
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_java_security_cert_CertificateFactory$linenum_table$getInstance$640c30d2dd2d7d5a
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_cert_CertificateFactory, getInstance$640c30d2dd2d7d5a);

_jc_java_security_cert_CertificateFactory$object * _JC_JCNI_ATTR
_jc_java_security_cert_CertificateFactory$method$getInstance$640c30d2dd2d7d5a(_jc_env *const env, _jc_java_lang_String$object *param0)
{
	jint volatile i0;
	jint volatile i1;
	jint i2;
	struct _jc_java_lang_String$object *volatile r0;
	struct _jc_java_security_Provider$object *volatile r2;
	struct _jc_java_security_cert_CertificateFactory$object *volatile r3;
	struct _jc_java_security_cert_CertificateException$object *volatile r4;
	struct _jc_java_lang_VMThrowable$object *volatile r5;
	struct _jc_java_util_Vector$object *r6;
	_jc_object_array *volatile r7;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_java_security_cert_CertificateFactory$method_info$getInstance$640c30d2dd2d7d5a, &&label1);

	r0 = param0;
	_JC_ACTIVE_USE(env, java_security_Security);
	_JC_LINE_NUMBER(103);				// 0
	r6 = _JC_STATIC_FIELD(env, java_security_Security, providers, 1);
	i2 = _JC_INVOKE_VIRTUAL(env, java_util_Vector, size$345df5220fc60ade, r6);
	r7 = _JC_NEW_REF_ARRAY(env, java_security_Provider, 1, i2);
	r6 = _JC_STATIC_FIELD(env, java_security_Security, providers, 1);
	_JC_INVOKE_VIRTUAL(env, java_util_Vector, copyInto$cd78d768b3ba4735, r6, r7);
	_JC_LINE_NUMBER(105);				// 1
	i0 = 0;
	goto label2;

label0:
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(109);				// 2
	r2 = _JC_REF_ELEMENT(env, r7, i0, 1, 1);
	r3 = _JC_INVOKE_STATIC(env, java_security_cert_CertificateFactory, getInstance$3c2b54dd699852d3, 0, r0, r2);
	_JC_TRAP_REGION(catch, 2);
	_JC_CANCEL_TRAPS(env, catch);
	return r3;

label1:
	_JC_TRAP_REGION(catch, 2);
	r4 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(105);				// 3
	i0 = i0 + 1;

label2:
	_JC_TRAP_REGION(catch, 2);
	i1 = _JC_ARRAY_LENGTH(env, r7);
	if (i0 < i1) {
		_JC_PERIODIC_CHECK(env);
		goto label0;
	}
	_JC_LINE_NUMBER(117);				// 4
	r4 = _JC_NEW(env, java_security_cert_CertificateException);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r5 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r5;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r0;
	_JC_THROW(env, r4);
}

//
// public static final java.security.cert.CertificateFactory getInstance(java.lang.String, java.lang.String) throws java.security.cert.CertificateException, java.security.NoSuchProviderException
//

static _jc_linenum _jc_java_security_cert_CertificateFactory$linenum_table$getInstance$76d8dd627392a15e[];

static const unsigned char _jc_java_security_cert_CertificateFactory$param_ptypes$getInstance$76d8dd627392a15e[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_security_cert_CertificateFactory$exceptions$getInstance$76d8dd627392a15e[] = {
	&_jc_java_security_cert_CertificateException$type,
	&_jc_java_security_NoSuchProviderException$type
};

static _jc_type *const _jc_java_security_cert_CertificateFactory$param_types$getInstance$76d8dd627392a15e[] = {
	&_jc_java_lang_String$type,
	&_jc_java_lang_String$type
};

_jc_method _jc_java_security_cert_CertificateFactory$method_info$getInstance$76d8dd627392a15e = {
	.name=			"getInstance",
	.signature=		"(Ljava/lang/String;Ljava/lang/String;)Ljava/security/cert/CertificateFactory;",
	.class=			&_jc_java_security_cert_CertificateFactory$type,
	.param_types=		&_jc_java_security_cert_CertificateFactory$param_types$getInstance$76d8dd627392a15e,
	.return_type=		&_jc_java_security_cert_CertificateFactory$type,
	.param_ptypes=		&_jc_java_security_cert_CertificateFactory$param_ptypes$getInstance$76d8dd627392a15e,
	.signature_hash=	_JC_JLONG(0x76d8dd627392a15e),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.function=		&_jc_java_security_cert_CertificateFactory$method$getInstance$76d8dd627392a15e,
	.num_parameters=	2,
	.num_exceptions=	2,
	.exceptions=		&_jc_java_security_cert_CertificateFactory$exceptions$getInstance$76d8dd627392a15e,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_java_security_cert_CertificateFactory$linenum_table$getInstance$76d8dd627392a15e
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_cert_CertificateFactory, getInstance$76d8dd627392a15e);

_jc_java_security_cert_CertificateFactory$object * _JC_JCNI_ATTR
_jc_java_security_cert_CertificateFactory$method$getInstance$76d8dd627392a15e(_jc_env *const env, _jc_java_lang_String$object *param0, _jc_java_lang_String$object *param1)
{
	struct _jc_java_lang_String$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_java_security_Provider$object *r2;
	struct _jc_java_security_NoSuchProviderException$object *r3;
	struct _jc_java_security_cert_CertificateFactory$object *r4;
	struct _jc_java_lang_VMThrowable$object *r6;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = param0;
	r1 = param1;
	_JC_LINE_NUMBER(139);				// 0
	r2 = _JC_INVOKE_STATIC(env, java_security_Security, getProvider$581ee7d7bc9ae747, 0, r1);
	_JC_LINE_NUMBER(140);				// 1
	if (r2 != _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(141);				// 2
	r3 = _JC_NEW(env, java_security_NoSuchProviderException);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r6 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r6;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r1;
	_JC_THROW(env, r3);

label0:
	_JC_LINE_NUMBER(143);				// 3
	r4 = _JC_INVOKE_STATIC(env, java_security_cert_CertificateFactory, getInstance$3c2b54dd699852d3, 1, r0, r2);
	return r4;
}

//
// public static final java.security.cert.CertificateFactory getInstance(java.lang.String, java.security.Provider) throws java.security.cert.CertificateException
//

static _jc_linenum _jc_java_security_cert_CertificateFactory$linenum_table$getInstance$3c2b54dd699852d3[];

static _jc_trap_info _jc_java_security_cert_CertificateFactory$trap_table$getInstance$3c2b54dd699852d3[] = {
	_JC_TRAP(&_jc_java_lang_ClassCastException$type, 1, 2),
	_JC_TRAP(&_jc_java_lang_reflect_InvocationTargetException$type, 1, 2),
	_JC_TRAP(&_jc_java_security_NoSuchAlgorithmException$type, 1, 2),
};

static const unsigned char _jc_java_security_cert_CertificateFactory$param_ptypes$getInstance$3c2b54dd699852d3[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_security_cert_CertificateFactory$exceptions$getInstance$3c2b54dd699852d3[] = {
	&_jc_java_security_cert_CertificateException$type
};

static _jc_type *const _jc_java_security_cert_CertificateFactory$param_types$getInstance$3c2b54dd699852d3[] = {
	&_jc_java_lang_String$type,
	&_jc_java_security_Provider$type
};

_jc_method _jc_java_security_cert_CertificateFactory$method_info$getInstance$3c2b54dd699852d3 = {
	.name=			"getInstance",
	.signature=		"(Ljava/lang/String;Ljava/security/Provider;)Ljava/security/cert/CertificateFactory;",
	.class=			&_jc_java_security_cert_CertificateFactory$type,
	.param_types=		&_jc_java_security_cert_CertificateFactory$param_types$getInstance$3c2b54dd699852d3,
	.return_type=		&_jc_java_security_cert_CertificateFactory$type,
	.param_ptypes=		&_jc_java_security_cert_CertificateFactory$param_ptypes$getInstance$3c2b54dd699852d3,
	.signature_hash=	_JC_JLONG(0x3c2b54dd699852d3),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.function=		&_jc_java_security_cert_CertificateFactory$method$getInstance$3c2b54dd699852d3,
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_security_cert_CertificateFactory$exceptions$getInstance$3c2b54dd699852d3,
	.u= { .exec= {
	  .trap_table_len=	3,
	  .trap_table=		_jc_java_security_cert_CertificateFactory$trap_table$getInstance$3c2b54dd699852d3,
	  .u= {
	    .linenum= {
	      .len=	6,
	      .table=	_jc_java_security_cert_CertificateFactory$linenum_table$getInstance$3c2b54dd699852d3
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_cert_CertificateFactory, getInstance$3c2b54dd699852d3);

_jc_java_security_cert_CertificateFactory$object * _JC_JCNI_ATTR
_jc_java_security_cert_CertificateFactory$method$getInstance$3c2b54dd699852d3(_jc_env *const env, _jc_java_lang_String$object *param0, _jc_java_security_Provider$object *param1)
{
	struct _jc_java_lang_String$object *volatile r0;
	struct _jc_java_security_Provider$object *r1;
	struct _jc_java_lang_String$object *r10;
	_jc_object_array *r11;
	struct _jc_java_lang_Object$object *r12;
	struct _jc_java_lang_VMThrowable$object *r13;
	struct _jc_java_lang_VMThrowable$object *volatile r14;
	struct _jc_java_lang_VMThrowable$object *volatile r15;
	struct _jc_java_lang_VMThrowable$object *volatile r17;
	struct _jc_java_lang_ClassCastException$object *r2;
	struct _jc_java_lang_IllegalArgumentException$object *r3;
	struct _jc_java_security_cert_CertificateFactory$object *r4;
	struct _jc_java_security_cert_CertificateFactorySpi$object *r5;
	struct _jc_java_security_cert_CertificateException$object *volatile r6;
	struct _jc_java_lang_reflect_InvocationTargetException$object *r7;
	struct _jc_java_security_NoSuchAlgorithmException$object *volatile r8;
	struct _jc_java_lang_String$object *r9;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_java_security_cert_CertificateFactory$method_info$getInstance$3c2b54dd699852d3, &&label1, &&label2, &&label3);

	r0 = param0;
	r1 = param1;
	_JC_LINE_NUMBER(161);				// 0
	if (r1 != _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(162);				// 1
	r3 = _JC_NEW(env, java_lang_IllegalArgumentException);
	r9 = _JC_STRING(env, "null provider");
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r13 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r13;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r9;
	_JC_THROW(env, r3);

label0:
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(166);				// 2
	r4 = _JC_NEW(env, java_security_cert_CertificateFactory);
	_JC_ACTIVE_USE(env, gnu_java_security_Engine);
	r10 = _JC_STRING(env, "CertificateFactory");
	r11 = _JC_STATIC_FIELD(env, gnu_java_security_Engine, NO__5fARGS, 1);
	r12 = _JC_INVOKE_STATIC(env, gnu_java_security_Engine, getInstance$ec89dfd35c234c64, 1, r10, r0, r1, r11);
	r5 = _JC_CAST(env, &_jc_java_security_cert_CertificateFactorySpi$type, r12);
	_JC_REF_FIELD(env, r4, java_security_cert_CertificateFactory, certFacSpi) = r5;
	_JC_REF_FIELD(env, r4, java_security_cert_CertificateFactory, provider) = r1;
	_JC_REF_FIELD(env, r4, java_security_cert_CertificateFactory, type) = r0;
	_JC_TRAP_REGION(catch, 2);
	_JC_CANCEL_TRAPS(env, catch);
	return r4;

label1:
	_JC_TRAP_REGION(catch, 2);
	r2 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(172);				// 3
	r6 = _JC_NEW(env, java_security_cert_CertificateException);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, cause) = r6;
	r14 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r6);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, vmState) = r14;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, detailMessage) = r0;
	_JC_THROW(env, r6);

label2:
	_JC_TRAP_REGION(catch, 2);
	r7 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(176);				// 4
	r6 = _JC_NEW(env, java_security_cert_CertificateException);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, cause) = r6;
	r15 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r6);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, vmState) = r15;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, detailMessage) = r0;
	_JC_THROW(env, r6);

label3:
	_JC_TRAP_REGION(catch, 2);
	r8 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(180);				// 5
	r6 = _JC_NEW(env, java_security_cert_CertificateException);
	r0 = _JC_INVOKE_VIRTUAL(env, java_lang_Throwable, getMessage$13aaf240efc902b1, r8);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, cause) = r6;
	r17 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r6);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, vmState) = r17;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, detailMessage) = r0;
	_JC_THROW(env, r6);
}

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// protected void <init>(java.security.cert.CertificateFactorySpi, java.security.Provider, java.lang.String)
//

static _jc_linenum _jc_java_security_cert_CertificateFactory$linenum_table$_init$097f4d18cd603915[];

static const unsigned char _jc_java_security_cert_CertificateFactory$param_ptypes$_init$097f4d18cd603915[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_security_cert_CertificateFactory$param_types$_init$097f4d18cd603915[] = {
	&_jc_java_security_cert_CertificateFactorySpi$type,
	&_jc_java_security_Provider$type,
	&_jc_java_lang_String$type
};

_jc_method _jc_java_security_cert_CertificateFactory$method_info$_init$097f4d18cd603915 = {
	.name=			"<init>",
	.signature=		"(Ljava/security/cert/CertificateFactorySpi;Ljava/security/Provider;Ljava/lang/String;)V",
	.class=			&_jc_java_security_cert_CertificateFactory$type,
	.param_types=		&_jc_java_security_cert_CertificateFactory$param_types$_init$097f4d18cd603915,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_security_cert_CertificateFactory$param_ptypes$_init$097f4d18cd603915,
	.signature_hash=	_JC_JLONG(0x97f4d18cd603915),
	.access_flags=		_JC_ACC_PROTECTED,
	.function=		&_jc_java_security_cert_CertificateFactory$method$_init$097f4d18cd603915,
	.num_parameters=	3,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_java_security_cert_CertificateFactory$linenum_table$_init$097f4d18cd603915
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_cert_CertificateFactory, _init$097f4d18cd603915);

void _JC_JCNI_ATTR
_jc_java_security_cert_CertificateFactory$method$_init$097f4d18cd603915(_jc_env *const env, _jc_java_security_cert_CertificateFactory$object *this, _jc_java_security_cert_CertificateFactorySpi$object *param0, _jc_java_security_Provider$object *param1, _jc_java_lang_String$object *param2)
{
	struct _jc_java_security_cert_CertificateFactory$object *r0;
	struct _jc_java_security_cert_CertificateFactorySpi$object *r1;
	struct _jc_java_security_Provider$object *r2;
	struct _jc_java_lang_String$object *r3;

	r0 = this;
	r1 = param0;
	r2 = param1;
	r3 = param2;
	_JC_LINE_NUMBER(82);				// 0
	_JC_REF_FIELD(env, r0, java_security_cert_CertificateFactory, certFacSpi) = r1;
	_JC_LINE_NUMBER(83);				// 1
	_JC_REF_FIELD(env, r0, java_security_cert_CertificateFactory, provider) = r2;
	_JC_LINE_NUMBER(84);				// 2
	_JC_REF_FIELD(env, r0, java_security_cert_CertificateFactory, type) = r3;
	_JC_LINE_NUMBER(85);				// 3
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public final java.security.cert.CRL generateCRL(java.io.InputStream) throws java.security.cert.CRLException
//

static _jc_linenum _jc_java_security_cert_CertificateFactory$linenum_table$generateCRL$5c3345e15a9075e3[];

static const unsigned char _jc_java_security_cert_CertificateFactory$param_ptypes$generateCRL$5c3345e15a9075e3[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_security_cert_CertificateFactory$exceptions$generateCRL$5c3345e15a9075e3[] = {
	&_jc_java_security_cert_CRLException$type
};

static _jc_type *const _jc_java_security_cert_CertificateFactory$param_types$generateCRL$5c3345e15a9075e3[] = {
	&_jc_java_io_InputStream$type
};

_jc_method _jc_java_security_cert_CertificateFactory$method_info$generateCRL$5c3345e15a9075e3 = {
	.name=			"generateCRL",
	.signature=		"(Ljava/io/InputStream;)Ljava/security/cert/CRL;",
	.class=			&_jc_java_security_cert_CertificateFactory$type,
	.param_types=		&_jc_java_security_cert_CertificateFactory$param_types$generateCRL$5c3345e15a9075e3,
	.return_type=		&_jc_java_security_cert_CRL$type,
	.param_ptypes=		&_jc_java_security_cert_CertificateFactory$param_ptypes$generateCRL$5c3345e15a9075e3,
	.signature_hash=	_JC_JLONG(0x5c3345e15a9075e3),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_security_cert_CertificateFactory$method$generateCRL$5c3345e15a9075e3,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_cert_CertificateFactory$vtable, java_security_cert_CertificateFactory.generateCRL$5c3345e15a9075e3) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_security_cert_CertificateFactory$exceptions$generateCRL$5c3345e15a9075e3,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_cert_CertificateFactory$linenum_table$generateCRL$5c3345e15a9075e3
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_cert_CertificateFactory, generateCRL$5c3345e15a9075e3);

_jc_java_security_cert_CRL$object * _JC_JCNI_ATTR
_jc_java_security_cert_CertificateFactory$method$generateCRL$5c3345e15a9075e3(_jc_env *const env, _jc_java_security_cert_CertificateFactory$object *this, _jc_java_io_InputStream$object *param0)
{
	struct _jc_java_security_cert_CertificateFactory$object *r0;
	struct _jc_java_io_InputStream$object *r1;
	struct _jc_java_security_cert_CertificateFactorySpi$object *r2;
	struct _jc_java_security_cert_CRL$object *r3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(276);				// 0
	r2 = _JC_REF_FIELD(env, r0, java_security_cert_CertificateFactory, certFacSpi);
	r3 = _JC_INVOKE_VIRTUAL(env, java_security_cert_CertificateFactorySpi, engineGenerateCRL$a8cea9131059aae8, r2, r1);
	return r3;
}

//
// public final java.util.Collection generateCRLs(java.io.InputStream) throws java.security.cert.CRLException
//

static _jc_linenum _jc_java_security_cert_CertificateFactory$linenum_table$generateCRLs$62306751616027ff[];

static const unsigned char _jc_java_security_cert_CertificateFactory$param_ptypes$generateCRLs$62306751616027ff[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_security_cert_CertificateFactory$exceptions$generateCRLs$62306751616027ff[] = {
	&_jc_java_security_cert_CRLException$type
};

static _jc_type *const _jc_java_security_cert_CertificateFactory$param_types$generateCRLs$62306751616027ff[] = {
	&_jc_java_io_InputStream$type
};

_jc_method _jc_java_security_cert_CertificateFactory$method_info$generateCRLs$62306751616027ff = {
	.name=			"generateCRLs",
	.signature=		"(Ljava/io/InputStream;)Ljava/util/Collection;",
	.class=			&_jc_java_security_cert_CertificateFactory$type,
	.param_types=		&_jc_java_security_cert_CertificateFactory$param_types$generateCRLs$62306751616027ff,
	.return_type=		&_jc_java_util_Collection$type,
	.param_ptypes=		&_jc_java_security_cert_CertificateFactory$param_ptypes$generateCRLs$62306751616027ff,
	.signature_hash=	_JC_JLONG(0x62306751616027ff),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_security_cert_CertificateFactory$method$generateCRLs$62306751616027ff,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_cert_CertificateFactory$vtable, java_security_cert_CertificateFactory.generateCRLs$62306751616027ff) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_security_cert_CertificateFactory$exceptions$generateCRLs$62306751616027ff,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_cert_CertificateFactory$linenum_table$generateCRLs$62306751616027ff
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_cert_CertificateFactory, generateCRLs$62306751616027ff);

_jc_object * _JC_JCNI_ATTR
_jc_java_security_cert_CertificateFactory$method$generateCRLs$62306751616027ff(_jc_env *const env, _jc_java_security_cert_CertificateFactory$object *this, _jc_java_io_InputStream$object *param0)
{
	struct _jc_java_security_cert_CertificateFactory$object *r0;
	struct _jc_java_io_InputStream$object *r1;
	struct _jc_java_security_cert_CertificateFactorySpi$object *r2;
	struct _jc_object *r3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(297);				// 0
	r2 = _JC_REF_FIELD(env, r0, java_security_cert_CertificateFactory, certFacSpi);
	r3 = _JC_INVOKE_VIRTUAL(env, java_security_cert_CertificateFactorySpi, engineGenerateCRLs$31d87dfacfce17c5, r2, r1);
	return r3;
}

//
// public final java.security.cert.CertPath generateCertPath(java.io.InputStream) throws java.security.cert.CertificateException
//

static _jc_linenum _jc_java_security_cert_CertificateFactory$linenum_table$generateCertPath$c87f5603da022d22[];

static const unsigned char _jc_java_security_cert_CertificateFactory$param_ptypes$generateCertPath$c87f5603da022d22[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_security_cert_CertificateFactory$exceptions$generateCertPath$c87f5603da022d22[] = {
	&_jc_java_security_cert_CertificateException$type
};

static _jc_type *const _jc_java_security_cert_CertificateFactory$param_types$generateCertPath$c87f5603da022d22[] = {
	&_jc_java_io_InputStream$type
};

_jc_method _jc_java_security_cert_CertificateFactory$method_info$generateCertPath$c87f5603da022d22 = {
	.name=			"generateCertPath",
	.signature=		"(Ljava/io/InputStream;)Ljava/security/cert/CertPath;",
	.class=			&_jc_java_security_cert_CertificateFactory$type,
	.param_types=		&_jc_java_security_cert_CertificateFactory$param_types$generateCertPath$c87f5603da022d22,
	.return_type=		&_jc_java_security_cert_CertPath$type,
	.param_ptypes=		&_jc_java_security_cert_CertificateFactory$param_ptypes$generateCertPath$c87f5603da022d22,
	.signature_hash=	_JC_JLONG(0xc87f5603da022d22),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_security_cert_CertificateFactory$method$generateCertPath$c87f5603da022d22,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_cert_CertificateFactory$vtable, java_security_cert_CertificateFactory.generateCertPath$c87f5603da022d22) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_security_cert_CertificateFactory$exceptions$generateCertPath$c87f5603da022d22,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_cert_CertificateFactory$linenum_table$generateCertPath$c87f5603da022d22
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_cert_CertificateFactory, generateCertPath$c87f5603da022d22);

_jc_java_security_cert_CertPath$object * _JC_JCNI_ATTR
_jc_java_security_cert_CertificateFactory$method$generateCertPath$c87f5603da022d22(_jc_env *const env, _jc_java_security_cert_CertificateFactory$object *this, _jc_java_io_InputStream$object *param0)
{
	struct _jc_java_security_cert_CertificateFactory$object *r0;
	struct _jc_java_io_InputStream$object *r1;
	struct _jc_java_security_cert_CertificateFactorySpi$object *r2;
	struct _jc_java_security_cert_CertPath$object *r3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(312);				// 0
	r2 = _JC_REF_FIELD(env, r0, java_security_cert_CertificateFactory, certFacSpi);
	r3 = _JC_INVOKE_VIRTUAL(env, java_security_cert_CertificateFactorySpi, engineGenerateCertPath$f7ecb945a78b5ce2, r2, r1);
	return r3;
}

//
// public final java.security.cert.CertPath generateCertPath(java.io.InputStream, java.lang.String) throws java.security.cert.CertificateException
//

static _jc_linenum _jc_java_security_cert_CertificateFactory$linenum_table$generateCertPath$5ac2da92db72030a[];

static const unsigned char _jc_java_security_cert_CertificateFactory$param_ptypes$generateCertPath$5ac2da92db72030a[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_security_cert_CertificateFactory$exceptions$generateCertPath$5ac2da92db72030a[] = {
	&_jc_java_security_cert_CertificateException$type
};

static _jc_type *const _jc_java_security_cert_CertificateFactory$param_types$generateCertPath$5ac2da92db72030a[] = {
	&_jc_java_io_InputStream$type,
	&_jc_java_lang_String$type
};

_jc_method _jc_java_security_cert_CertificateFactory$method_info$generateCertPath$5ac2da92db72030a = {
	.name=			"generateCertPath",
	.signature=		"(Ljava/io/InputStream;Ljava/lang/String;)Ljava/security/cert/CertPath;",
	.class=			&_jc_java_security_cert_CertificateFactory$type,
	.param_types=		&_jc_java_security_cert_CertificateFactory$param_types$generateCertPath$5ac2da92db72030a,
	.return_type=		&_jc_java_security_cert_CertPath$type,
	.param_ptypes=		&_jc_java_security_cert_CertificateFactory$param_ptypes$generateCertPath$5ac2da92db72030a,
	.signature_hash=	_JC_JLONG(0x5ac2da92db72030a),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_security_cert_CertificateFactory$method$generateCertPath$5ac2da92db72030a,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_cert_CertificateFactory$vtable, java_security_cert_CertificateFactory.generateCertPath$5ac2da92db72030a) / sizeof(void *),
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_security_cert_CertificateFactory$exceptions$generateCertPath$5ac2da92db72030a,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_cert_CertificateFactory$linenum_table$generateCertPath$5ac2da92db72030a
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_cert_CertificateFactory, generateCertPath$5ac2da92db72030a);

_jc_java_security_cert_CertPath$object * _JC_JCNI_ATTR
_jc_java_security_cert_CertificateFactory$method$generateCertPath$5ac2da92db72030a(_jc_env *const env, _jc_java_security_cert_CertificateFactory$object *this, _jc_java_io_InputStream$object *param0, _jc_java_lang_String$object *param1)
{
	struct _jc_java_security_cert_CertificateFactory$object *r0;
	struct _jc_java_io_InputStream$object *r1;
	struct _jc_java_lang_String$object *r2;
	struct _jc_java_security_cert_CertificateFactorySpi$object *r3;
	struct _jc_java_security_cert_CertPath$object *r4;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_LINE_NUMBER(328);				// 0
	r3 = _JC_REF_FIELD(env, r0, java_security_cert_CertificateFactory, certFacSpi);
	r4 = _JC_INVOKE_VIRTUAL(env, java_security_cert_CertificateFactorySpi, engineGenerateCertPath$50e322b071586f88, r3, r1, r2);
	return r4;
}

//
// public final java.security.cert.CertPath generateCertPath(java.util.List) throws java.security.cert.CertificateException
//

static _jc_linenum _jc_java_security_cert_CertificateFactory$linenum_table$generateCertPath$d3ea3ed3e482a067[];

static const unsigned char _jc_java_security_cert_CertificateFactory$param_ptypes$generateCertPath$d3ea3ed3e482a067[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_security_cert_CertificateFactory$exceptions$generateCertPath$d3ea3ed3e482a067[] = {
	&_jc_java_security_cert_CertificateException$type
};

static _jc_type *const _jc_java_security_cert_CertificateFactory$param_types$generateCertPath$d3ea3ed3e482a067[] = {
	&_jc_java_util_List$type
};

_jc_method _jc_java_security_cert_CertificateFactory$method_info$generateCertPath$d3ea3ed3e482a067 = {
	.name=			"generateCertPath",
	.signature=		"(Ljava/util/List;)Ljava/security/cert/CertPath;",
	.class=			&_jc_java_security_cert_CertificateFactory$type,
	.param_types=		&_jc_java_security_cert_CertificateFactory$param_types$generateCertPath$d3ea3ed3e482a067,
	.return_type=		&_jc_java_security_cert_CertPath$type,
	.param_ptypes=		&_jc_java_security_cert_CertificateFactory$param_ptypes$generateCertPath$d3ea3ed3e482a067,
	.signature_hash=	_JC_JLONG(0xd3ea3ed3e482a067),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_security_cert_CertificateFactory$method$generateCertPath$d3ea3ed3e482a067,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_cert_CertificateFactory$vtable, java_security_cert_CertificateFactory.generateCertPath$d3ea3ed3e482a067) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_security_cert_CertificateFactory$exceptions$generateCertPath$d3ea3ed3e482a067,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_cert_CertificateFactory$linenum_table$generateCertPath$d3ea3ed3e482a067
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_cert_CertificateFactory, generateCertPath$d3ea3ed3e482a067);

_jc_java_security_cert_CertPath$object * _JC_JCNI_ATTR
_jc_java_security_cert_CertificateFactory$method$generateCertPath$d3ea3ed3e482a067(_jc_env *const env, _jc_java_security_cert_CertificateFactory$object *this, _jc_object *param0)
{
	struct _jc_java_security_cert_CertificateFactory$object *r0;
	struct _jc_object *r1;
	struct _jc_java_security_cert_CertificateFactorySpi$object *r2;
	struct _jc_java_security_cert_CertPath$object *r3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(344);				// 0
	r2 = _JC_REF_FIELD(env, r0, java_security_cert_CertificateFactory, certFacSpi);
	r3 = _JC_INVOKE_VIRTUAL(env, java_security_cert_CertificateFactorySpi, engineGenerateCertPath$e5e3016f4a0dd657, r2, r1);
	return r3;
}

//
// public final java.security.cert.Certificate generateCertificate(java.io.InputStream) throws java.security.cert.CertificateException
//

static _jc_linenum _jc_java_security_cert_CertificateFactory$linenum_table$generateCertificate$2333c1899f1f1296[];

static const unsigned char _jc_java_security_cert_CertificateFactory$param_ptypes$generateCertificate$2333c1899f1f1296[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_security_cert_CertificateFactory$exceptions$generateCertificate$2333c1899f1f1296[] = {
	&_jc_java_security_cert_CertificateException$type
};

static _jc_type *const _jc_java_security_cert_CertificateFactory$param_types$generateCertificate$2333c1899f1f1296[] = {
	&_jc_java_io_InputStream$type
};

_jc_method _jc_java_security_cert_CertificateFactory$method_info$generateCertificate$2333c1899f1f1296 = {
	.name=			"generateCertificate",
	.signature=		"(Ljava/io/InputStream;)Ljava/security/cert/Certificate;",
	.class=			&_jc_java_security_cert_CertificateFactory$type,
	.param_types=		&_jc_java_security_cert_CertificateFactory$param_types$generateCertificate$2333c1899f1f1296,
	.return_type=		&_jc_java_security_cert_Certificate$type,
	.param_ptypes=		&_jc_java_security_cert_CertificateFactory$param_ptypes$generateCertificate$2333c1899f1f1296,
	.signature_hash=	_JC_JLONG(0x2333c1899f1f1296),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_security_cert_CertificateFactory$method$generateCertificate$2333c1899f1f1296,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_cert_CertificateFactory$vtable, java_security_cert_CertificateFactory.generateCertificate$2333c1899f1f1296) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_security_cert_CertificateFactory$exceptions$generateCertificate$2333c1899f1f1296,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_cert_CertificateFactory$linenum_table$generateCertificate$2333c1899f1f1296
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_cert_CertificateFactory, generateCertificate$2333c1899f1f1296);

_jc_java_security_cert_Certificate$object * _JC_JCNI_ATTR
_jc_java_security_cert_CertificateFactory$method$generateCertificate$2333c1899f1f1296(_jc_env *const env, _jc_java_security_cert_CertificateFactory$object *this, _jc_java_io_InputStream$object *param0)
{
	struct _jc_java_security_cert_CertificateFactory$object *r0;
	struct _jc_java_io_InputStream$object *r1;
	struct _jc_java_security_cert_CertificateFactorySpi$object *r2;
	struct _jc_java_security_cert_Certificate$object *r3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(232);				// 0
	r2 = _JC_REF_FIELD(env, r0, java_security_cert_CertificateFactory, certFacSpi);
	r3 = _JC_INVOKE_VIRTUAL(env, java_security_cert_CertificateFactorySpi, engineGenerateCertificate$135fa48378eab128, r2, r1);
	return r3;
}

//
// public final java.util.Collection generateCertificates(java.io.InputStream) throws java.security.cert.CertificateException
//

static _jc_linenum _jc_java_security_cert_CertificateFactory$linenum_table$generateCertificates$4c102cd2bbf4a2f7[];

static const unsigned char _jc_java_security_cert_CertificateFactory$param_ptypes$generateCertificates$4c102cd2bbf4a2f7[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_security_cert_CertificateFactory$exceptions$generateCertificates$4c102cd2bbf4a2f7[] = {
	&_jc_java_security_cert_CertificateException$type
};

static _jc_type *const _jc_java_security_cert_CertificateFactory$param_types$generateCertificates$4c102cd2bbf4a2f7[] = {
	&_jc_java_io_InputStream$type
};

_jc_method _jc_java_security_cert_CertificateFactory$method_info$generateCertificates$4c102cd2bbf4a2f7 = {
	.name=			"generateCertificates",
	.signature=		"(Ljava/io/InputStream;)Ljava/util/Collection;",
	.class=			&_jc_java_security_cert_CertificateFactory$type,
	.param_types=		&_jc_java_security_cert_CertificateFactory$param_types$generateCertificates$4c102cd2bbf4a2f7,
	.return_type=		&_jc_java_util_Collection$type,
	.param_ptypes=		&_jc_java_security_cert_CertificateFactory$param_ptypes$generateCertificates$4c102cd2bbf4a2f7,
	.signature_hash=	_JC_JLONG(0x4c102cd2bbf4a2f7),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_security_cert_CertificateFactory$method$generateCertificates$4c102cd2bbf4a2f7,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_cert_CertificateFactory$vtable, java_security_cert_CertificateFactory.generateCertificates$4c102cd2bbf4a2f7) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_security_cert_CertificateFactory$exceptions$generateCertificates$4c102cd2bbf4a2f7,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_cert_CertificateFactory$linenum_table$generateCertificates$4c102cd2bbf4a2f7
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_cert_CertificateFactory, generateCertificates$4c102cd2bbf4a2f7);

_jc_object * _JC_JCNI_ATTR
_jc_java_security_cert_CertificateFactory$method$generateCertificates$4c102cd2bbf4a2f7(_jc_env *const env, _jc_java_security_cert_CertificateFactory$object *this, _jc_java_io_InputStream$object *param0)
{
	struct _jc_java_security_cert_CertificateFactory$object *r0;
	struct _jc_java_io_InputStream$object *r1;
	struct _jc_java_security_cert_CertificateFactorySpi$object *r2;
	struct _jc_object *r3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(255);				// 0
	r2 = _JC_REF_FIELD(env, r0, java_security_cert_CertificateFactory, certFacSpi);
	r3 = _JC_INVOKE_VIRTUAL(env, java_security_cert_CertificateFactorySpi, engineGenerateCertificates$6e73f12927e7a3cf, r2, r1);
	return r3;
}

//
// public final java.util.Iterator getCertPathEncodings()
//

static _jc_linenum _jc_java_security_cert_CertificateFactory$linenum_table$getCertPathEncodings$8101500d14bb6eae[];

static const unsigned char _jc_java_security_cert_CertificateFactory$param_ptypes$getCertPathEncodings$8101500d14bb6eae[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_java_security_cert_CertificateFactory$method_info$getCertPathEncodings$8101500d14bb6eae = {
	.name=			"getCertPathEncodings",
	.signature=		"()Ljava/util/Iterator;",
	.class=			&_jc_java_security_cert_CertificateFactory$type,
	.return_type=		&_jc_java_util_Iterator$type,
	.param_ptypes=		&_jc_java_security_cert_CertificateFactory$param_ptypes$getCertPathEncodings$8101500d14bb6eae,
	.signature_hash=	_JC_JLONG(0x8101500d14bb6eae),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_security_cert_CertificateFactory$method$getCertPathEncodings$8101500d14bb6eae,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_cert_CertificateFactory$vtable, java_security_cert_CertificateFactory.getCertPathEncodings$8101500d14bb6eae) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_cert_CertificateFactory$linenum_table$getCertPathEncodings$8101500d14bb6eae
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_cert_CertificateFactory, getCertPathEncodings$8101500d14bb6eae);

_jc_object * _JC_JCNI_ATTR
_jc_java_security_cert_CertificateFactory$method$getCertPathEncodings$8101500d14bb6eae(_jc_env *const env, _jc_java_security_cert_CertificateFactory$object *this)
{
	struct _jc_java_security_cert_CertificateFactory$object *r0;
	struct _jc_java_security_cert_CertificateFactorySpi$object *r1;
	struct _jc_object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(356);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_security_cert_CertificateFactory, certFacSpi);
	r2 = _JC_INVOKE_VIRTUAL(env, java_security_cert_CertificateFactorySpi, engineGetCertPathEncodings$c0f531d8fe8812d6, r1);
	return r2;
}

//
// public final java.security.Provider getProvider()
//

static _jc_linenum _jc_java_security_cert_CertificateFactory$linenum_table$getProvider$e8f9c9fb14140d5a[];

static const unsigned char _jc_java_security_cert_CertificateFactory$param_ptypes$getProvider$e8f9c9fb14140d5a[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_java_security_cert_CertificateFactory$method_info$getProvider$e8f9c9fb14140d5a = {
	.name=			"getProvider",
	.signature=		"()Ljava/security/Provider;",
	.class=			&_jc_java_security_cert_CertificateFactory$type,
	.return_type=		&_jc_java_security_Provider$type,
	.param_ptypes=		&_jc_java_security_cert_CertificateFactory$param_ptypes$getProvider$e8f9c9fb14140d5a,
	.signature_hash=	_JC_JLONG(0xe8f9c9fb14140d5a),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_security_cert_CertificateFactory$method$getProvider$e8f9c9fb14140d5a,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_cert_CertificateFactory$vtable, java_security_cert_CertificateFactory.getProvider$e8f9c9fb14140d5a) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_cert_CertificateFactory$linenum_table$getProvider$e8f9c9fb14140d5a
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_cert_CertificateFactory, getProvider$e8f9c9fb14140d5a);

_jc_java_security_Provider$object * _JC_JCNI_ATTR
_jc_java_security_cert_CertificateFactory$method$getProvider$e8f9c9fb14140d5a(_jc_env *const env, _jc_java_security_cert_CertificateFactory$object *this)
{
	struct _jc_java_security_cert_CertificateFactory$object *r0;
	struct _jc_java_security_Provider$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(194);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_security_cert_CertificateFactory, provider);
	return r1;
}

//
// public final java.lang.String getType()
//

static _jc_linenum _jc_java_security_cert_CertificateFactory$linenum_table$getType$1756580bdd350fe6[];

static const unsigned char _jc_java_security_cert_CertificateFactory$param_ptypes$getType$1756580bdd350fe6[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_java_security_cert_CertificateFactory$method_info$getType$1756580bdd350fe6 = {
	.name=			"getType",
	.signature=		"()Ljava/lang/String;",
	.class=			&_jc_java_security_cert_CertificateFactory$type,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_java_security_cert_CertificateFactory$param_ptypes$getType$1756580bdd350fe6,
	.signature_hash=	_JC_JLONG(0x1756580bdd350fe6),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_security_cert_CertificateFactory$method$getType$1756580bdd350fe6,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_cert_CertificateFactory$vtable, java_security_cert_CertificateFactory.getType$1756580bdd350fe6) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_cert_CertificateFactory$linenum_table$getType$1756580bdd350fe6
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_cert_CertificateFactory, getType$1756580bdd350fe6);

_jc_java_lang_String$object * _JC_JCNI_ATTR
_jc_java_security_cert_CertificateFactory$method$getType$1756580bdd350fe6(_jc_env *const env, _jc_java_security_cert_CertificateFactory$object *this)
{
	struct _jc_java_security_cert_CertificateFactory$object *r0;
	struct _jc_java_lang_String$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(204);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_security_cert_CertificateFactory, type);
	return r1;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_java_security_cert_CertificateFactory$methods[] = {
	&_jc_java_security_cert_CertificateFactory$method_info$_init$097f4d18cd603915,
	&_jc_java_security_cert_CertificateFactory$method_info$generateCRL$5c3345e15a9075e3,
	&_jc_java_security_cert_CertificateFactory$method_info$generateCRLs$62306751616027ff,
	&_jc_java_security_cert_CertificateFactory$method_info$generateCertPath$c87f5603da022d22,
	&_jc_java_security_cert_CertificateFactory$method_info$generateCertPath$5ac2da92db72030a,
	&_jc_java_security_cert_CertificateFactory$method_info$generateCertPath$d3ea3ed3e482a067,
	&_jc_java_security_cert_CertificateFactory$method_info$generateCertificate$2333c1899f1f1296,
	&_jc_java_security_cert_CertificateFactory$method_info$generateCertificates$4c102cd2bbf4a2f7,
	&_jc_java_security_cert_CertificateFactory$method_info$getCertPathEncodings$8101500d14bb6eae,
	&_jc_java_security_cert_CertificateFactory$method_info$getInstance$640c30d2dd2d7d5a,
	&_jc_java_security_cert_CertificateFactory$method_info$getInstance$76d8dd627392a15e,
	&_jc_java_security_cert_CertificateFactory$method_info$getInstance$3c2b54dd699852d3,
	&_jc_java_security_cert_CertificateFactory$method_info$getProvider$e8f9c9fb14140d5a,
	&_jc_java_security_cert_CertificateFactory$method_info$getType$1756580bdd350fe6
};

/************************************************************************
 *			  Class fields structure			*
 ************************************************************************/

_jc_java_security_cert_CertificateFactory$fields_struct _jc_java_security_cert_CertificateFactory$class_fields = { };

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_java_security_cert_CertificateFactory$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};
static _jc_type *const _jc_java_security_cert_CertificateFactory$instanceof_hash_bucket_113[] = {
	&_jc_java_security_cert_CertificateFactory$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_java_security_cert_CertificateFactory$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[101]=	_jc_java_security_cert_CertificateFactory$instanceof_hash_bucket_101,
	[113]=	_jc_java_security_cert_CertificateFactory$instanceof_hash_bucket_113
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_java_security_cert_CertificateFactory$class_depends[] = {
	{ "gnu/java/security/Engine",	_JC_JLONG(0xf4ba095546954b36) },
	{ "java/io/InputStream",	_JC_JLONG(0x66aea4d152614ac4) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/ClassCastException",	_JC_JLONG(0xf02ab3ccb490a6d0) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/IllegalArgumentException",	_JC_JLONG(0x680cf34d05feb5a1) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/RuntimeException",	_JC_JLONG(0x4f5534a987354d1d) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/lang/reflect/InvocationTargetException",	_JC_JLONG(0xae4a2342b31a268d) },
	{ "java/security/GeneralSecurityException",	_JC_JLONG(0x692089051f4c8d0b) },
	{ "java/security/NoSuchAlgorithmException",	_JC_JLONG(0x22e937c2536160b4) },
	{ "java/security/NoSuchProviderException",	_JC_JLONG(0x8dfbf242adab91e) },
	{ "java/security/Provider",	_JC_JLONG(0x81b073051aa30acc) },
	{ "java/security/Security",	_JC_JLONG(0x89bf77984bd9669e) },
	{ "java/security/cert/CRL",	_JC_JLONG(0x968d6f530411e76e) },
	{ "java/security/cert/CRLException",	_JC_JLONG(0x19d465acf62ede69) },
	{ "java/security/cert/CertPath",	_JC_JLONG(0x88ba88f1f11a1086) },
	{ "java/security/cert/Certificate",	_JC_JLONG(0xc98c8192da849b07) },
	{ "java/security/cert/CertificateException",	_JC_JLONG(0xebfb598dd9fa8080) },
	{ "java/security/cert/CertificateFactorySpi",	_JC_JLONG(0x52d94d6b40f8d849) },
	{ "java/util/Collection",	_JC_JLONG(0xeae4d0c0e8eb63da) },
	{ "java/util/Iterator",	_JC_JLONG(0xbe56ff673eefd9d2) },
	{ "java/util/List",	_JC_JLONG(0x9ee0d92ce1525a4d) },
	{ "java/util/Vector",	_JC_JLONG(0xc53e1575b095109b) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_java_security_cert_CertificateFactory$vtype _jc_java_security_cert_CertificateFactory$type = {
    .type= {
	.name=			"java/security/cert/CertificateFactory",
	.superclass=		&_jc_java_lang_Object$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		21,
		.hash=			_JC_JLONG(0x91bb7671288911f1),
		.source_file=		"CertificateFactory.java",
		.instance_size=		sizeof(_jc_java_security_cert_CertificateFactory$refs) + sizeof(_jc_java_security_cert_CertificateFactory$object),
		.num_virtual_refs=	3,
		.num_fields=		sizeof(_jc_java_security_cert_CertificateFactory$fields) / sizeof(*_jc_java_security_cert_CertificateFactory$fields),
		.fields=		_jc_java_security_cert_CertificateFactory$fields,
		.num_methods=		sizeof(_jc_java_security_cert_CertificateFactory$methods) / sizeof(*_jc_java_security_cert_CertificateFactory$methods),
		.methods=		_jc_java_security_cert_CertificateFactory$methods,
		.instanceof_hash_table=	_jc_java_security_cert_CertificateFactory$instanceof_hash_table,
		.class_fields=		&_jc_java_security_cert_CertificateFactory$class_fields,
		.num_class_depends=		sizeof(_jc_java_security_cert_CertificateFactory$class_depends) / sizeof(*_jc_java_security_cert_CertificateFactory$class_depends),
		.class_depends=		_jc_java_security_cert_CertificateFactory$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.java_security_cert_CertificateFactory= {
	    .generateCRL$5c3345e15a9075e3=
		&_jc_java_security_cert_CertificateFactory$method$generateCRL$5c3345e15a9075e3,
	    .generateCRLs$62306751616027ff=
		&_jc_java_security_cert_CertificateFactory$method$generateCRLs$62306751616027ff,
	    .generateCertPath$c87f5603da022d22=
		&_jc_java_security_cert_CertificateFactory$method$generateCertPath$c87f5603da022d22,
	    .generateCertPath$5ac2da92db72030a=
		&_jc_java_security_cert_CertificateFactory$method$generateCertPath$5ac2da92db72030a,
	    .generateCertPath$d3ea3ed3e482a067=
		&_jc_java_security_cert_CertificateFactory$method$generateCertPath$d3ea3ed3e482a067,
	    .generateCertificate$2333c1899f1f1296=
		&_jc_java_security_cert_CertificateFactory$method$generateCertificate$2333c1899f1f1296,
	    .generateCertificates$4c102cd2bbf4a2f7=
		&_jc_java_security_cert_CertificateFactory$method$generateCertificates$4c102cd2bbf4a2f7,
	    .getCertPathEncodings$8101500d14bb6eae=
		&_jc_java_security_cert_CertificateFactory$method$getCertPathEncodings$8101500d14bb6eae,
	    .getProvider$e8f9c9fb14140d5a=
		&_jc_java_security_cert_CertificateFactory$method$getProvider$e8f9c9fb14140d5a,
	    .getType$1756580bdd350fe6=
		&_jc_java_security_cert_CertificateFactory$method$getType$1756580bdd350fe6,
	},
    }
};

