// public class java.security.spec.PSSParameterSpec

// class file dependencies
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class 680cf34d05feb5a1 java_lang_IllegalArgumentException
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class 4f5534a987354d1d java_lang_RuntimeException
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class ef2e5e8af121478f java_security_spec_AlgorithmParameterSpec
// @dep_class e9efdffce7fa36fc java_security_spec_PSSParameterSpec

// header file dependencies
// @dep_header java_lang_Class
// @dep_header java_lang_IllegalArgumentException
// @dep_header java_lang_String
// @dep_header java_lang_VMThrowable
// @dep_header java_security_spec_AlgorithmParameterSpec
// @dep_header java_security_spec_PSSParameterSpec

#include "jc_defs.h"

#include "java/lang/Class.h"
#include "java/lang/IllegalArgumentException.h"
#include "java/lang/String.h"
#include "java/lang/VMThrowable.h"
#include "java/security/spec/AlgorithmParameterSpec.h"
#include "java/security/spec/PSSParameterSpec.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// private int saltLen
static _jc_field _jc_java_security_spec_PSSParameterSpec$field_info$saltLen = {
	.name=		"saltLen",
	.signature=	"I",
	.class=		&_jc_java_security_spec_PSSParameterSpec$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_security_spec_PSSParameterSpec$object, nonrefs.java_security_spec_PSSParameterSpec.saltLen),
};

// Fields
static _jc_field *const _jc_java_security_spec_PSSParameterSpec$fields[] = {
	&_jc_java_security_spec_PSSParameterSpec$field_info$saltLen
};

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// public void <init>(int)
//

static _jc_linenum _jc_java_security_spec_PSSParameterSpec$linenum_table$_init$7f1776288300b98d[];

static const unsigned char _jc_java_security_spec_PSSParameterSpec$param_ptypes$_init$7f1776288300b98d[] = { 
_JC_TYPE_INT, _JC_TYPE_VOID };

static _jc_type *const _jc_java_security_spec_PSSParameterSpec$param_types$_init$7f1776288300b98d[] = {
	&_jc_int$prim$type
};

_jc_method _jc_java_security_spec_PSSParameterSpec$method_info$_init$7f1776288300b98d = {
	.name=			"<init>",
	.signature=		"(I)V",
	.class=			&_jc_java_security_spec_PSSParameterSpec$type,
	.param_types=		&_jc_java_security_spec_PSSParameterSpec$param_types$_init$7f1776288300b98d,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_security_spec_PSSParameterSpec$param_ptypes$_init$7f1776288300b98d,
	.signature_hash=	_JC_JLONG(0x7f1776288300b98d),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_spec_PSSParameterSpec$method$_init$7f1776288300b98d,
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_java_security_spec_PSSParameterSpec$linenum_table$_init$7f1776288300b98d
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_spec_PSSParameterSpec, _init$7f1776288300b98d);

void _JC_JCNI_ATTR
_jc_java_security_spec_PSSParameterSpec$method$_init$7f1776288300b98d(_jc_env *const env, _jc_java_security_spec_PSSParameterSpec$object *this, jint param0)
{
	jint i0;
	struct _jc_java_security_spec_PSSParameterSpec$object *r0;
	struct _jc_java_lang_IllegalArgumentException$object *r1;
	struct _jc_java_lang_String$object *r2;
	struct _jc_java_lang_VMThrowable$object *r4;

	r0 = this;
	i0 = param0;
	_JC_LINE_NUMBER(70);				// 0
	if (i0 >= 0)
		goto label0;
	_JC_LINE_NUMBER(71);				// 1
	r1 = _JC_NEW(env, java_lang_IllegalArgumentException);
	r2 = _JC_NULL;
	_JC_REF_FIELD(env, r1, java_lang_Throwable, cause) = r1;
	r4 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r1);
	_JC_REF_FIELD(env, r1, java_lang_Throwable, vmState) = r4;
	_JC_REF_FIELD(env, r1, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r1, java_lang_Throwable, detailMessage) = r2;
	_JC_THROW(env, r1);

label0:
	_JC_LINE_NUMBER(72);				// 2
	_JC_PRIM_FIELD(env, r0, java_security_spec_PSSParameterSpec, saltLen) = i0;
	_JC_LINE_NUMBER(73);				// 3
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public int getSaltLength()
//

static _jc_linenum _jc_java_security_spec_PSSParameterSpec$linenum_table$getSaltLength$e8414ffe7c61187e[];

static const unsigned char _jc_java_security_spec_PSSParameterSpec$param_ptypes$getSaltLength$e8414ffe7c61187e[] = { 
_JC_TYPE_INT };

_jc_method _jc_java_security_spec_PSSParameterSpec$method_info$getSaltLength$e8414ffe7c61187e = {
	.name=			"getSaltLength",
	.signature=		"()I",
	.class=			&_jc_java_security_spec_PSSParameterSpec$type,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_java_security_spec_PSSParameterSpec$param_ptypes$getSaltLength$e8414ffe7c61187e,
	.signature_hash=	_JC_JLONG(0xe8414ffe7c61187e),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_spec_PSSParameterSpec$method$getSaltLength$e8414ffe7c61187e,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_spec_PSSParameterSpec$vtable, java_security_spec_PSSParameterSpec.getSaltLength$e8414ffe7c61187e) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_spec_PSSParameterSpec$linenum_table$getSaltLength$e8414ffe7c61187e
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_spec_PSSParameterSpec, getSaltLength$e8414ffe7c61187e);

jint _JC_JCNI_ATTR
_jc_java_security_spec_PSSParameterSpec$method$getSaltLength$e8414ffe7c61187e(_jc_env *const env, _jc_java_security_spec_PSSParameterSpec$object *this)
{
	jint i0;
	struct _jc_java_security_spec_PSSParameterSpec$object *r0;

	r0 = this;
	_JC_LINE_NUMBER(88);				// 0
	i0 = _JC_PRIM_FIELD(env, r0, java_security_spec_PSSParameterSpec, saltLen);
	return i0;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_java_security_spec_PSSParameterSpec$methods[] = {
	&_jc_java_security_spec_PSSParameterSpec$method_info$_init$7f1776288300b98d,
	&_jc_java_security_spec_PSSParameterSpec$method_info$getSaltLength$e8414ffe7c61187e
};

/************************************************************************
 *			      Interface list				*
 ************************************************************************/

// Directly implemented interfaces
static _jc_type *const _jc_java_security_spec_PSSParameterSpec$interfaces[] = {
	&_jc_java_security_spec_AlgorithmParameterSpec$type
};

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_java_security_spec_PSSParameterSpec$instanceof_hash_bucket_15[] = {
	&_jc_java_security_spec_AlgorithmParameterSpec$type,
	_JC_NULL
};
static _jc_type *const _jc_java_security_spec_PSSParameterSpec$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};
static _jc_type *const _jc_java_security_spec_PSSParameterSpec$instanceof_hash_bucket_124[] = {
	&_jc_java_security_spec_PSSParameterSpec$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_java_security_spec_PSSParameterSpec$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[15]=	_jc_java_security_spec_PSSParameterSpec$instanceof_hash_bucket_15,
	[101]=	_jc_java_security_spec_PSSParameterSpec$instanceof_hash_bucket_101,
	[124]=	_jc_java_security_spec_PSSParameterSpec$instanceof_hash_bucket_124
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_java_security_spec_PSSParameterSpec$class_depends[] = {
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/IllegalArgumentException",	_JC_JLONG(0x680cf34d05feb5a1) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/RuntimeException",	_JC_JLONG(0x4f5534a987354d1d) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/security/spec/AlgorithmParameterSpec",	_JC_JLONG(0xef2e5e8af121478f) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_java_security_spec_PSSParameterSpec$vtype _jc_java_security_spec_PSSParameterSpec$type = {
    .type= {
	.name=			"java/security/spec/PSSParameterSpec",
	.superclass=		&_jc_java_lang_Object$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.num_interfaces=sizeof(_jc_java_security_spec_PSSParameterSpec$interfaces) / sizeof(*_jc_java_security_spec_PSSParameterSpec$interfaces),
	.interfaces=		_jc_java_security_spec_PSSParameterSpec$interfaces,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		12,
		.hash=			_JC_JLONG(0xe9efdffce7fa36fc),
		.source_file=		"PSSParameterSpec.java",
		.instance_size=		sizeof(_jc_java_security_spec_PSSParameterSpec$refs) + sizeof(_jc_java_security_spec_PSSParameterSpec$object),
		.num_virtual_refs=	0,
		.num_fields=		sizeof(_jc_java_security_spec_PSSParameterSpec$fields) / sizeof(*_jc_java_security_spec_PSSParameterSpec$fields),
		.fields=		_jc_java_security_spec_PSSParameterSpec$fields,
		.num_methods=		sizeof(_jc_java_security_spec_PSSParameterSpec$methods) / sizeof(*_jc_java_security_spec_PSSParameterSpec$methods),
		.methods=		_jc_java_security_spec_PSSParameterSpec$methods,
		.instanceof_hash_table=	_jc_java_security_spec_PSSParameterSpec$instanceof_hash_table,
		.num_class_depends=		sizeof(_jc_java_security_spec_PSSParameterSpec$class_depends) / sizeof(*_jc_java_security_spec_PSSParameterSpec$class_depends),
		.class_depends=		_jc_java_security_spec_PSSParameterSpec$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.java_security_spec_PSSParameterSpec= {
	    .getSaltLength$e8414ffe7c61187e=
		&_jc_java_security_spec_PSSParameterSpec$method$getSaltLength$e8414ffe7c61187e,
	},
    }
};

