// public class java.security.spec.RSAPrivateCrtKeySpec

// class file dependencies
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 7717ded55c30b7f3 java_math_BigInteger
// @dep_class e5bd533daf8dcb9a java_security_spec_KeySpec
// @dep_class 9739dee73a389d94 java_security_spec_RSAPrivateCrtKeySpec
// @dep_class 47d1dcfa807306d7 java_security_spec_RSAPrivateKeySpec

// header file dependencies
// @dep_header java_lang_Class
// @dep_header java_lang_String
// @dep_header java_math_BigInteger
// @dep_header java_security_spec_KeySpec
// @dep_header java_security_spec_RSAPrivateCrtKeySpec

#include "jc_defs.h"

#include "java/lang/Class.h"
#include "java/lang/String.h"
#include "java/math/BigInteger.h"
#include "java/security/spec/KeySpec.h"
#include "java/security/spec/RSAPrivateCrtKeySpec.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// private java.math.BigInteger publicExponent
static _jc_field _jc_java_security_spec_RSAPrivateCrtKeySpec$field_info$publicExponent = {
	.name=		"publicExponent",
	.signature=	"Ljava/math/BigInteger;",
	.class=		&_jc_java_security_spec_RSAPrivateCrtKeySpec$type,
	.type=		&_jc_java_math_BigInteger$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_security_spec_RSAPrivateCrtKeySpec$object, refs[-1].java_security_spec_RSAPrivateCrtKeySpec.publicExponent),
};

// private java.math.BigInteger primeP
static _jc_field _jc_java_security_spec_RSAPrivateCrtKeySpec$field_info$primeP = {
	.name=		"primeP",
	.signature=	"Ljava/math/BigInteger;",
	.class=		&_jc_java_security_spec_RSAPrivateCrtKeySpec$type,
	.type=		&_jc_java_math_BigInteger$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_security_spec_RSAPrivateCrtKeySpec$object, refs[-1].java_security_spec_RSAPrivateCrtKeySpec.primeP),
};

// private java.math.BigInteger primeQ
static _jc_field _jc_java_security_spec_RSAPrivateCrtKeySpec$field_info$primeQ = {
	.name=		"primeQ",
	.signature=	"Ljava/math/BigInteger;",
	.class=		&_jc_java_security_spec_RSAPrivateCrtKeySpec$type,
	.type=		&_jc_java_math_BigInteger$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_security_spec_RSAPrivateCrtKeySpec$object, refs[-1].java_security_spec_RSAPrivateCrtKeySpec.primeQ),
};

// private java.math.BigInteger primeExponentP
static _jc_field _jc_java_security_spec_RSAPrivateCrtKeySpec$field_info$primeExponentP = {
	.name=		"primeExponentP",
	.signature=	"Ljava/math/BigInteger;",
	.class=		&_jc_java_security_spec_RSAPrivateCrtKeySpec$type,
	.type=		&_jc_java_math_BigInteger$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_security_spec_RSAPrivateCrtKeySpec$object, refs[-1].java_security_spec_RSAPrivateCrtKeySpec.primeExponentP),
};

// private java.math.BigInteger primeExponentQ
static _jc_field _jc_java_security_spec_RSAPrivateCrtKeySpec$field_info$primeExponentQ = {
	.name=		"primeExponentQ",
	.signature=	"Ljava/math/BigInteger;",
	.class=		&_jc_java_security_spec_RSAPrivateCrtKeySpec$type,
	.type=		&_jc_java_math_BigInteger$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_security_spec_RSAPrivateCrtKeySpec$object, refs[-1].java_security_spec_RSAPrivateCrtKeySpec.primeExponentQ),
};

// private java.math.BigInteger crtCoefficient
static _jc_field _jc_java_security_spec_RSAPrivateCrtKeySpec$field_info$crtCoefficient = {
	.name=		"crtCoefficient",
	.signature=	"Ljava/math/BigInteger;",
	.class=		&_jc_java_security_spec_RSAPrivateCrtKeySpec$type,
	.type=		&_jc_java_math_BigInteger$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_security_spec_RSAPrivateCrtKeySpec$object, refs[-1].java_security_spec_RSAPrivateCrtKeySpec.crtCoefficient),
};

// Fields
static _jc_field *const _jc_java_security_spec_RSAPrivateCrtKeySpec$fields[] = {
	&_jc_java_security_spec_RSAPrivateCrtKeySpec$field_info$crtCoefficient,
	&_jc_java_security_spec_RSAPrivateCrtKeySpec$field_info$primeExponentP,
	&_jc_java_security_spec_RSAPrivateCrtKeySpec$field_info$primeExponentQ,
	&_jc_java_security_spec_RSAPrivateCrtKeySpec$field_info$primeP,
	&_jc_java_security_spec_RSAPrivateCrtKeySpec$field_info$primeQ,
	&_jc_java_security_spec_RSAPrivateCrtKeySpec$field_info$publicExponent
};

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// public void <init>(java.math.BigInteger, java.math.BigInteger, java.math.BigInteger, java.math.BigInteger, java.math.BigInteger, java.math.BigInteger, java.math.BigInteger, java.math.BigInteger)
//

static _jc_linenum _jc_java_security_spec_RSAPrivateCrtKeySpec$linenum_table$_init$61d41c6df3047b16[];

static const unsigned char _jc_java_security_spec_RSAPrivateCrtKeySpec$param_ptypes$_init$61d41c6df3047b16[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_security_spec_RSAPrivateCrtKeySpec$param_types$_init$61d41c6df3047b16[] = {
	&_jc_java_math_BigInteger$type,
	&_jc_java_math_BigInteger$type,
	&_jc_java_math_BigInteger$type,
	&_jc_java_math_BigInteger$type,
	&_jc_java_math_BigInteger$type,
	&_jc_java_math_BigInteger$type,
	&_jc_java_math_BigInteger$type,
	&_jc_java_math_BigInteger$type
};

_jc_method _jc_java_security_spec_RSAPrivateCrtKeySpec$method_info$_init$61d41c6df3047b16 = {
	.name=			"<init>",
	.signature=		"(Ljava/math/BigInteger;Ljava/math/BigInteger;Ljava/math/BigInteger;Ljava/math/BigInteger;Ljava/math/BigInteger;Ljava/math/BigInteger;Ljava/math/BigInteger;Ljava/math/BigInteger;)V",
	.class=			&_jc_java_security_spec_RSAPrivateCrtKeySpec$type,
	.param_types=		&_jc_java_security_spec_RSAPrivateCrtKeySpec$param_types$_init$61d41c6df3047b16,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_security_spec_RSAPrivateCrtKeySpec$param_ptypes$_init$61d41c6df3047b16,
	.signature_hash=	_JC_JLONG(0x61d41c6df3047b16),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_spec_RSAPrivateCrtKeySpec$method$_init$61d41c6df3047b16,
	.num_parameters=	8,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	7,
	      .table=	_jc_java_security_spec_RSAPrivateCrtKeySpec$linenum_table$_init$61d41c6df3047b16
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_spec_RSAPrivateCrtKeySpec, _init$61d41c6df3047b16);

void _JC_JCNI_ATTR
_jc_java_security_spec_RSAPrivateCrtKeySpec$method$_init$61d41c6df3047b16(_jc_env *const env, _jc_java_security_spec_RSAPrivateCrtKeySpec$object *this, _jc_java_math_BigInteger$object *param0, _jc_java_math_BigInteger$object *param1, _jc_java_math_BigInteger$object *param2, _jc_java_math_BigInteger$object *param3, _jc_java_math_BigInteger$object *param4, _jc_java_math_BigInteger$object *param5, _jc_java_math_BigInteger$object *param6, _jc_java_math_BigInteger$object *param7)
{
	struct _jc_java_security_spec_RSAPrivateCrtKeySpec$object *r0;
	struct _jc_java_math_BigInteger$object *r1;
	struct _jc_java_math_BigInteger$object *r2;
	struct _jc_java_math_BigInteger$object *r3;
	struct _jc_java_math_BigInteger$object *r4;
	struct _jc_java_math_BigInteger$object *r5;
	struct _jc_java_math_BigInteger$object *r6;
	struct _jc_java_math_BigInteger$object *r7;
	struct _jc_java_math_BigInteger$object *r8;

	r0 = this;
	r1 = param0;
	r2 = param1;
	r3 = param2;
	r4 = param3;
	r5 = param4;
	r6 = param5;
	r7 = param6;
	r8 = param7;
	_JC_REF_FIELD(env, r0, java_security_spec_RSAPrivateKeySpec, modulus) = r1;
	_JC_REF_FIELD(env, r0, java_security_spec_RSAPrivateKeySpec, privateExponent) = r3;
	_JC_LINE_NUMBER(83);				// 0
	_JC_REF_FIELD(env, r0, java_security_spec_RSAPrivateCrtKeySpec, publicExponent) = r2;
	_JC_LINE_NUMBER(84);				// 1
	_JC_REF_FIELD(env, r0, java_security_spec_RSAPrivateCrtKeySpec, primeP) = r4;
	_JC_LINE_NUMBER(85);				// 2
	_JC_REF_FIELD(env, r0, java_security_spec_RSAPrivateCrtKeySpec, primeQ) = r5;
	_JC_LINE_NUMBER(86);				// 3
	_JC_REF_FIELD(env, r0, java_security_spec_RSAPrivateCrtKeySpec, primeExponentP) = r6;
	_JC_LINE_NUMBER(87);				// 4
	_JC_REF_FIELD(env, r0, java_security_spec_RSAPrivateCrtKeySpec, primeExponentQ) = r7;
	_JC_LINE_NUMBER(88);				// 5
	_JC_REF_FIELD(env, r0, java_security_spec_RSAPrivateCrtKeySpec, crtCoefficient) = r8;
	_JC_LINE_NUMBER(89);				// 6
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public java.math.BigInteger getCrtCoefficient()
//

static _jc_linenum _jc_java_security_spec_RSAPrivateCrtKeySpec$linenum_table$getCrtCoefficient$3b26e563f0a78fa8[];

static const unsigned char _jc_java_security_spec_RSAPrivateCrtKeySpec$param_ptypes$getCrtCoefficient$3b26e563f0a78fa8[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_java_security_spec_RSAPrivateCrtKeySpec$method_info$getCrtCoefficient$3b26e563f0a78fa8 = {
	.name=			"getCrtCoefficient",
	.signature=		"()Ljava/math/BigInteger;",
	.class=			&_jc_java_security_spec_RSAPrivateCrtKeySpec$type,
	.return_type=		&_jc_java_math_BigInteger$type,
	.param_ptypes=		&_jc_java_security_spec_RSAPrivateCrtKeySpec$param_ptypes$getCrtCoefficient$3b26e563f0a78fa8,
	.signature_hash=	_JC_JLONG(0x3b26e563f0a78fa8),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_spec_RSAPrivateCrtKeySpec$method$getCrtCoefficient$3b26e563f0a78fa8,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_spec_RSAPrivateCrtKeySpec$vtable, java_security_spec_RSAPrivateCrtKeySpec.getCrtCoefficient$3b26e563f0a78fa8) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_spec_RSAPrivateCrtKeySpec$linenum_table$getCrtCoefficient$3b26e563f0a78fa8
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_spec_RSAPrivateCrtKeySpec, getCrtCoefficient$3b26e563f0a78fa8);

_jc_java_math_BigInteger$object * _JC_JCNI_ATTR
_jc_java_security_spec_RSAPrivateCrtKeySpec$method$getCrtCoefficient$3b26e563f0a78fa8(_jc_env *const env, _jc_java_security_spec_RSAPrivateCrtKeySpec$object *this)
{
	struct _jc_java_security_spec_RSAPrivateCrtKeySpec$object *r0;
	struct _jc_java_math_BigInteger$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(148);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_security_spec_RSAPrivateCrtKeySpec, crtCoefficient);
	return r1;
}

//
// public java.math.BigInteger getPrimeExponentP()
//

static _jc_linenum _jc_java_security_spec_RSAPrivateCrtKeySpec$linenum_table$getPrimeExponentP$7b86450f402ae888[];

static const unsigned char _jc_java_security_spec_RSAPrivateCrtKeySpec$param_ptypes$getPrimeExponentP$7b86450f402ae888[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_java_security_spec_RSAPrivateCrtKeySpec$method_info$getPrimeExponentP$7b86450f402ae888 = {
	.name=			"getPrimeExponentP",
	.signature=		"()Ljava/math/BigInteger;",
	.class=			&_jc_java_security_spec_RSAPrivateCrtKeySpec$type,
	.return_type=		&_jc_java_math_BigInteger$type,
	.param_ptypes=		&_jc_java_security_spec_RSAPrivateCrtKeySpec$param_ptypes$getPrimeExponentP$7b86450f402ae888,
	.signature_hash=	_JC_JLONG(0x7b86450f402ae888),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_spec_RSAPrivateCrtKeySpec$method$getPrimeExponentP$7b86450f402ae888,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_spec_RSAPrivateCrtKeySpec$vtable, java_security_spec_RSAPrivateCrtKeySpec.getPrimeExponentP$7b86450f402ae888) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_spec_RSAPrivateCrtKeySpec$linenum_table$getPrimeExponentP$7b86450f402ae888
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_spec_RSAPrivateCrtKeySpec, getPrimeExponentP$7b86450f402ae888);

_jc_java_math_BigInteger$object * _JC_JCNI_ATTR
_jc_java_security_spec_RSAPrivateCrtKeySpec$method$getPrimeExponentP$7b86450f402ae888(_jc_env *const env, _jc_java_security_spec_RSAPrivateCrtKeySpec$object *this)
{
	struct _jc_java_security_spec_RSAPrivateCrtKeySpec$object *r0;
	struct _jc_java_math_BigInteger$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(128);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_security_spec_RSAPrivateCrtKeySpec, primeExponentP);
	return r1;
}

//
// public java.math.BigInteger getPrimeExponentQ()
//

static _jc_linenum _jc_java_security_spec_RSAPrivateCrtKeySpec$linenum_table$getPrimeExponentQ$1768ae9fab37aad8[];

static const unsigned char _jc_java_security_spec_RSAPrivateCrtKeySpec$param_ptypes$getPrimeExponentQ$1768ae9fab37aad8[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_java_security_spec_RSAPrivateCrtKeySpec$method_info$getPrimeExponentQ$1768ae9fab37aad8 = {
	.name=			"getPrimeExponentQ",
	.signature=		"()Ljava/math/BigInteger;",
	.class=			&_jc_java_security_spec_RSAPrivateCrtKeySpec$type,
	.return_type=		&_jc_java_math_BigInteger$type,
	.param_ptypes=		&_jc_java_security_spec_RSAPrivateCrtKeySpec$param_ptypes$getPrimeExponentQ$1768ae9fab37aad8,
	.signature_hash=	_JC_JLONG(0x1768ae9fab37aad8),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_spec_RSAPrivateCrtKeySpec$method$getPrimeExponentQ$1768ae9fab37aad8,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_spec_RSAPrivateCrtKeySpec$vtable, java_security_spec_RSAPrivateCrtKeySpec.getPrimeExponentQ$1768ae9fab37aad8) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_spec_RSAPrivateCrtKeySpec$linenum_table$getPrimeExponentQ$1768ae9fab37aad8
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_spec_RSAPrivateCrtKeySpec, getPrimeExponentQ$1768ae9fab37aad8);

_jc_java_math_BigInteger$object * _JC_JCNI_ATTR
_jc_java_security_spec_RSAPrivateCrtKeySpec$method$getPrimeExponentQ$1768ae9fab37aad8(_jc_env *const env, _jc_java_security_spec_RSAPrivateCrtKeySpec$object *this)
{
	struct _jc_java_security_spec_RSAPrivateCrtKeySpec$object *r0;
	struct _jc_java_math_BigInteger$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(138);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_security_spec_RSAPrivateCrtKeySpec, primeExponentQ);
	return r1;
}

//
// public java.math.BigInteger getPrimeP()
//

static _jc_linenum _jc_java_security_spec_RSAPrivateCrtKeySpec$linenum_table$getPrimeP$9033505b0ccf417d[];

static const unsigned char _jc_java_security_spec_RSAPrivateCrtKeySpec$param_ptypes$getPrimeP$9033505b0ccf417d[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_java_security_spec_RSAPrivateCrtKeySpec$method_info$getPrimeP$9033505b0ccf417d = {
	.name=			"getPrimeP",
	.signature=		"()Ljava/math/BigInteger;",
	.class=			&_jc_java_security_spec_RSAPrivateCrtKeySpec$type,
	.return_type=		&_jc_java_math_BigInteger$type,
	.param_ptypes=		&_jc_java_security_spec_RSAPrivateCrtKeySpec$param_ptypes$getPrimeP$9033505b0ccf417d,
	.signature_hash=	_JC_JLONG(0x9033505b0ccf417d),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_spec_RSAPrivateCrtKeySpec$method$getPrimeP$9033505b0ccf417d,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_spec_RSAPrivateCrtKeySpec$vtable, java_security_spec_RSAPrivateCrtKeySpec.getPrimeP$9033505b0ccf417d) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_spec_RSAPrivateCrtKeySpec$linenum_table$getPrimeP$9033505b0ccf417d
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_spec_RSAPrivateCrtKeySpec, getPrimeP$9033505b0ccf417d);

_jc_java_math_BigInteger$object * _JC_JCNI_ATTR
_jc_java_security_spec_RSAPrivateCrtKeySpec$method$getPrimeP$9033505b0ccf417d(_jc_env *const env, _jc_java_security_spec_RSAPrivateCrtKeySpec$object *this)
{
	struct _jc_java_security_spec_RSAPrivateCrtKeySpec$object *r0;
	struct _jc_java_math_BigInteger$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(108);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_security_spec_RSAPrivateCrtKeySpec, primeP);
	return r1;
}

//
// public java.math.BigInteger getPrimeQ()
//

static _jc_linenum _jc_java_security_spec_RSAPrivateCrtKeySpec$linenum_table$getPrimeQ$bf448ca4ce4c7a9b[];

static const unsigned char _jc_java_security_spec_RSAPrivateCrtKeySpec$param_ptypes$getPrimeQ$bf448ca4ce4c7a9b[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_java_security_spec_RSAPrivateCrtKeySpec$method_info$getPrimeQ$bf448ca4ce4c7a9b = {
	.name=			"getPrimeQ",
	.signature=		"()Ljava/math/BigInteger;",
	.class=			&_jc_java_security_spec_RSAPrivateCrtKeySpec$type,
	.return_type=		&_jc_java_math_BigInteger$type,
	.param_ptypes=		&_jc_java_security_spec_RSAPrivateCrtKeySpec$param_ptypes$getPrimeQ$bf448ca4ce4c7a9b,
	.signature_hash=	_JC_JLONG(0xbf448ca4ce4c7a9b),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_spec_RSAPrivateCrtKeySpec$method$getPrimeQ$bf448ca4ce4c7a9b,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_spec_RSAPrivateCrtKeySpec$vtable, java_security_spec_RSAPrivateCrtKeySpec.getPrimeQ$bf448ca4ce4c7a9b) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_spec_RSAPrivateCrtKeySpec$linenum_table$getPrimeQ$bf448ca4ce4c7a9b
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_spec_RSAPrivateCrtKeySpec, getPrimeQ$bf448ca4ce4c7a9b);

_jc_java_math_BigInteger$object * _JC_JCNI_ATTR
_jc_java_security_spec_RSAPrivateCrtKeySpec$method$getPrimeQ$bf448ca4ce4c7a9b(_jc_env *const env, _jc_java_security_spec_RSAPrivateCrtKeySpec$object *this)
{
	struct _jc_java_security_spec_RSAPrivateCrtKeySpec$object *r0;
	struct _jc_java_math_BigInteger$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(118);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_security_spec_RSAPrivateCrtKeySpec, primeQ);
	return r1;
}

//
// public java.math.BigInteger getPublicExponent()
//

static _jc_linenum _jc_java_security_spec_RSAPrivateCrtKeySpec$linenum_table$getPublicExponent$6a90dc2525ab30b7[];

static const unsigned char _jc_java_security_spec_RSAPrivateCrtKeySpec$param_ptypes$getPublicExponent$6a90dc2525ab30b7[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_java_security_spec_RSAPrivateCrtKeySpec$method_info$getPublicExponent$6a90dc2525ab30b7 = {
	.name=			"getPublicExponent",
	.signature=		"()Ljava/math/BigInteger;",
	.class=			&_jc_java_security_spec_RSAPrivateCrtKeySpec$type,
	.return_type=		&_jc_java_math_BigInteger$type,
	.param_ptypes=		&_jc_java_security_spec_RSAPrivateCrtKeySpec$param_ptypes$getPublicExponent$6a90dc2525ab30b7,
	.signature_hash=	_JC_JLONG(0x6a90dc2525ab30b7),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_spec_RSAPrivateCrtKeySpec$method$getPublicExponent$6a90dc2525ab30b7,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_spec_RSAPrivateCrtKeySpec$vtable, java_security_spec_RSAPrivateCrtKeySpec.getPublicExponent$6a90dc2525ab30b7) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_spec_RSAPrivateCrtKeySpec$linenum_table$getPublicExponent$6a90dc2525ab30b7
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_spec_RSAPrivateCrtKeySpec, getPublicExponent$6a90dc2525ab30b7);

_jc_java_math_BigInteger$object * _JC_JCNI_ATTR
_jc_java_security_spec_RSAPrivateCrtKeySpec$method$getPublicExponent$6a90dc2525ab30b7(_jc_env *const env, _jc_java_security_spec_RSAPrivateCrtKeySpec$object *this)
{
	struct _jc_java_security_spec_RSAPrivateCrtKeySpec$object *r0;
	struct _jc_java_math_BigInteger$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(98);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_security_spec_RSAPrivateCrtKeySpec, publicExponent);
	return r1;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_java_security_spec_RSAPrivateCrtKeySpec$methods[] = {
	&_jc_java_security_spec_RSAPrivateCrtKeySpec$method_info$_init$61d41c6df3047b16,
	&_jc_java_security_spec_RSAPrivateCrtKeySpec$method_info$getCrtCoefficient$3b26e563f0a78fa8,
	&_jc_java_security_spec_RSAPrivateCrtKeySpec$method_info$getPrimeExponentP$7b86450f402ae888,
	&_jc_java_security_spec_RSAPrivateCrtKeySpec$method_info$getPrimeExponentQ$1768ae9fab37aad8,
	&_jc_java_security_spec_RSAPrivateCrtKeySpec$method_info$getPrimeP$9033505b0ccf417d,
	&_jc_java_security_spec_RSAPrivateCrtKeySpec$method_info$getPrimeQ$bf448ca4ce4c7a9b,
	&_jc_java_security_spec_RSAPrivateCrtKeySpec$method_info$getPublicExponent$6a90dc2525ab30b7
};

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_java_security_spec_RSAPrivateCrtKeySpec$instanceof_hash_bucket_20[] = {
	&_jc_java_security_spec_RSAPrivateCrtKeySpec$type,
	_JC_NULL
};
static _jc_type *const _jc_java_security_spec_RSAPrivateCrtKeySpec$instanceof_hash_bucket_26[] = {
	&_jc_java_security_spec_KeySpec$type,
	_JC_NULL
};
static _jc_type *const _jc_java_security_spec_RSAPrivateCrtKeySpec$instanceof_hash_bucket_87[] = {
	&_jc_java_security_spec_RSAPrivateKeySpec$type,
	_JC_NULL
};
static _jc_type *const _jc_java_security_spec_RSAPrivateCrtKeySpec$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_java_security_spec_RSAPrivateCrtKeySpec$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[20]=	_jc_java_security_spec_RSAPrivateCrtKeySpec$instanceof_hash_bucket_20,
	[26]=	_jc_java_security_spec_RSAPrivateCrtKeySpec$instanceof_hash_bucket_26,
	[87]=	_jc_java_security_spec_RSAPrivateCrtKeySpec$instanceof_hash_bucket_87,
	[101]=	_jc_java_security_spec_RSAPrivateCrtKeySpec$instanceof_hash_bucket_101
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_java_security_spec_RSAPrivateCrtKeySpec$class_depends[] = {
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/math/BigInteger",	_JC_JLONG(0x7717ded55c30b7f3) },
	{ "java/security/spec/KeySpec",	_JC_JLONG(0xe5bd533daf8dcb9a) },
	{ "java/security/spec/RSAPrivateKeySpec",	_JC_JLONG(0x47d1dcfa807306d7) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_java_security_spec_RSAPrivateCrtKeySpec$vtype _jc_java_security_spec_RSAPrivateCrtKeySpec$type = {
    .type= {
	.name=			"java/security/spec/RSAPrivateCrtKeySpec",
	.superclass=		&_jc_java_security_spec_RSAPrivateKeySpec$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		19,
		.hash=			_JC_JLONG(0x9739dee73a389d94),
		.source_file=		"RSAPrivateCrtKeySpec.java",
		.instance_size=		sizeof(_jc_java_security_spec_RSAPrivateCrtKeySpec$refs) + sizeof(_jc_java_security_spec_RSAPrivateCrtKeySpec$object),
		.num_virtual_refs=	8,
		.num_fields=		sizeof(_jc_java_security_spec_RSAPrivateCrtKeySpec$fields) / sizeof(*_jc_java_security_spec_RSAPrivateCrtKeySpec$fields),
		.fields=		_jc_java_security_spec_RSAPrivateCrtKeySpec$fields,
		.num_methods=		sizeof(_jc_java_security_spec_RSAPrivateCrtKeySpec$methods) / sizeof(*_jc_java_security_spec_RSAPrivateCrtKeySpec$methods),
		.methods=		_jc_java_security_spec_RSAPrivateCrtKeySpec$methods,
		.instanceof_hash_table=	_jc_java_security_spec_RSAPrivateCrtKeySpec$instanceof_hash_table,
		.num_class_depends=		sizeof(_jc_java_security_spec_RSAPrivateCrtKeySpec$class_depends) / sizeof(*_jc_java_security_spec_RSAPrivateCrtKeySpec$class_depends),
		.class_depends=		_jc_java_security_spec_RSAPrivateCrtKeySpec$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.java_security_spec_RSAPrivateKeySpec= {
	    .getModulus$430be9ccecc735d2=
		&_jc_java_security_spec_RSAPrivateKeySpec$method$getModulus$430be9ccecc735d2,
	    .getPrivateExponent$69e9ffb1613efb43=
		&_jc_java_security_spec_RSAPrivateKeySpec$method$getPrivateExponent$69e9ffb1613efb43,
	},
	.java_security_spec_RSAPrivateCrtKeySpec= {
	    .getCrtCoefficient$3b26e563f0a78fa8=
		&_jc_java_security_spec_RSAPrivateCrtKeySpec$method$getCrtCoefficient$3b26e563f0a78fa8,
	    .getPrimeExponentP$7b86450f402ae888=
		&_jc_java_security_spec_RSAPrivateCrtKeySpec$method$getPrimeExponentP$7b86450f402ae888,
	    .getPrimeExponentQ$1768ae9fab37aad8=
		&_jc_java_security_spec_RSAPrivateCrtKeySpec$method$getPrimeExponentQ$1768ae9fab37aad8,
	    .getPrimeP$9033505b0ccf417d=
		&_jc_java_security_spec_RSAPrivateCrtKeySpec$method$getPrimeP$9033505b0ccf417d,
	    .getPrimeQ$bf448ca4ce4c7a9b=
		&_jc_java_security_spec_RSAPrivateCrtKeySpec$method$getPrimeQ$bf448ca4ce4c7a9b,
	    .getPublicExponent$6a90dc2525ab30b7=
		&_jc_java_security_spec_RSAPrivateCrtKeySpec$method$getPublicExponent$6a90dc2525ab30b7,
	},
    }
};

