// public class java.util.zip.ZipInputStream

// class file dependencies
// @dep_class caf39081f5f70fef java_io_EOFException
// @dep_class 455accfa535f5dfe java_io_FilterInputStream
// @dep_class 4e0a56550c69d57c java_io_IOException
// @dep_class 66aea4d152614ac4 java_io_InputStream
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class ca631501391a31f1 java_lang_Integer
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 94d357637b968dda java_lang_StringBuffer
// @dep_class 53cc8e2333795f04 java_lang_System
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class 4d1cebae0bdda058 java_lang_VMSystem
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class d31dc884497a5da2 java_util_zip_CRC32
// @dep_class 4df3e1cb79f6b935 java_util_zip_Inflater
// @dep_class 5602700a47802920 java_util_zip_InflaterInputStream
// @dep_class a34b4b893bb9fdce java_util_zip_ZipConstants
// @dep_class 1645f313fb808b9f java_util_zip_ZipEntry
// @dep_class cd59cf72c34ef3f3 java_util_zip_ZipException
// @dep_class 6587d25494e415a2 java_util_zip_ZipInputStream

// header file dependencies
// @dep_header java_io_EOFException
// @dep_header java_lang_Class
// @dep_header java_lang_Integer
// @dep_header java_lang_String
// @dep_header java_lang_StringBuffer
// @dep_header java_lang_System
// @dep_header java_lang_VMSystem
// @dep_header java_lang_VMThrowable
// @dep_header java_util_zip_CRC32
// @dep_header java_util_zip_Inflater
// @dep_header java_util_zip_ZipConstants
// @dep_header java_util_zip_ZipEntry
// @dep_header java_util_zip_ZipException
// @dep_header java_util_zip_ZipInputStream

#include "jc_defs.h"

#include "java/io/EOFException.h"
#include "java/lang/Class.h"
#include "java/lang/Integer.h"
#include "java/lang/String.h"
#include "java/lang/StringBuffer.h"
#include "java/lang/System.h"
#include "java/lang/VMSystem.h"
#include "java/lang/VMThrowable.h"
#include "java/util/zip/CRC32.h"
#include "java/util/zip/Inflater.h"
#include "java/util/zip/ZipConstants.h"
#include "java/util/zip/ZipEntry.h"
#include "java/util/zip/ZipException.h"
#include "java/util/zip/ZipInputStream.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// private java.util.zip.CRC32 crc
static _jc_field _jc_java_util_zip_ZipInputStream$field_info$crc = {
	.name=		"crc",
	.signature=	"Ljava/util/zip/CRC32;",
	.class=		&_jc_java_util_zip_ZipInputStream$type,
	.type=		&_jc_java_util_zip_CRC32$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_util_zip_ZipInputStream$object, refs[-1].java_util_zip_ZipInputStream.crc),
};

// private java.util.zip.ZipEntry entry
static _jc_field _jc_java_util_zip_ZipInputStream$field_info$entry = {
	.name=		"entry",
	.signature=	"Ljava/util/zip/ZipEntry;",
	.class=		&_jc_java_util_zip_ZipInputStream$type,
	.type=		&_jc_java_util_zip_ZipEntry$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_util_zip_ZipInputStream$object, refs[-1].java_util_zip_ZipInputStream.entry),
};

// private int csize
static _jc_field _jc_java_util_zip_ZipInputStream$field_info$csize = {
	.name=		"csize",
	.signature=	"I",
	.class=		&_jc_java_util_zip_ZipInputStream$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_util_zip_ZipInputStream$object, nonrefs.java_util_zip_ZipInputStream.csize),
};

// private int size
static _jc_field _jc_java_util_zip_ZipInputStream$field_info$size = {
	.name=		"size",
	.signature=	"I",
	.class=		&_jc_java_util_zip_ZipInputStream$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_util_zip_ZipInputStream$object, nonrefs.java_util_zip_ZipInputStream.size),
};

// private int method
static _jc_field _jc_java_util_zip_ZipInputStream$field_info$method = {
	.name=		"method",
	.signature=	"I",
	.class=		&_jc_java_util_zip_ZipInputStream$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_util_zip_ZipInputStream$object, nonrefs.java_util_zip_ZipInputStream.method),
};

// private int flags
static _jc_field _jc_java_util_zip_ZipInputStream$field_info$flags = {
	.name=		"flags",
	.signature=	"I",
	.class=		&_jc_java_util_zip_ZipInputStream$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_util_zip_ZipInputStream$object, nonrefs.java_util_zip_ZipInputStream.flags),
};

// private int avail
static _jc_field _jc_java_util_zip_ZipInputStream$field_info$avail = {
	.name=		"avail",
	.signature=	"I",
	.class=		&_jc_java_util_zip_ZipInputStream$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_util_zip_ZipInputStream$object, nonrefs.java_util_zip_ZipInputStream.avail),
};

// private boolean entryAtEOF
static _jc_field _jc_java_util_zip_ZipInputStream$field_info$entryAtEOF = {
	.name=		"entryAtEOF",
	.signature=	"Z",
	.class=		&_jc_java_util_zip_ZipInputStream$type,
	.type=		&_jc_boolean$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_util_zip_ZipInputStream$object, nonrefs.java_util_zip_ZipInputStream.entryAtEOF),
};

// Fields
static _jc_field *const _jc_java_util_zip_ZipInputStream$fields[] = {
	&_jc_java_util_zip_ZipInputStream$field_info$crc,
	&_jc_java_util_zip_ZipInputStream$field_info$entry,
	&_jc_java_util_zip_ZipInputStream$field_info$avail,
	&_jc_java_util_zip_ZipInputStream$field_info$csize,
	&_jc_java_util_zip_ZipInputStream$field_info$flags,
	&_jc_java_util_zip_ZipInputStream$field_info$method,
	&_jc_java_util_zip_ZipInputStream$field_info$size,
	&_jc_java_util_zip_ZipInputStream$field_info$entryAtEOF
};

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// public void <init>(java.io.InputStream)
//

static _jc_linenum _jc_java_util_zip_ZipInputStream$linenum_table$_init$3887600c17c5e554[];

static const unsigned char _jc_java_util_zip_ZipInputStream$param_ptypes$_init$3887600c17c5e554[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_util_zip_ZipInputStream$param_types$_init$3887600c17c5e554[] = {
	&_jc_java_io_InputStream$type
};

_jc_method _jc_java_util_zip_ZipInputStream$method_info$_init$3887600c17c5e554 = {
	.name=			"<init>",
	.signature=		"(Ljava/io/InputStream;)V",
	.class=			&_jc_java_util_zip_ZipInputStream$type,
	.param_types=		&_jc_java_util_zip_ZipInputStream$param_types$_init$3887600c17c5e554,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_util_zip_ZipInputStream$param_ptypes$_init$3887600c17c5e554,
	.signature_hash=	_JC_JLONG(0x3887600c17c5e554),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_util_zip_ZipInputStream$method$_init$3887600c17c5e554,
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_util_zip_ZipInputStream$linenum_table$_init$3887600c17c5e554
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_util_zip_ZipInputStream, _init$3887600c17c5e554);

void _JC_JCNI_ATTR
_jc_java_util_zip_ZipInputStream$method$_init$3887600c17c5e554(_jc_env *const env, _jc_java_util_zip_ZipInputStream$object *this, _jc_java_io_InputStream$object *param0)
{
	struct _jc_java_util_zip_ZipInputStream$object *r0;
	struct _jc_java_io_InputStream$object *r1;
	struct _jc_java_util_zip_Inflater$object *r2;
	struct _jc_java_util_zip_CRC32$object *r4;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(72);				// 0
	r2 = _JC_NEW(env, java_util_zip_Inflater);
	_JC_INVOKE_NONVIRTUAL(env, java_util_zip_Inflater, _init$f0a6314ff7de5110, 0, r2, 1);
	_JC_INVOKE_NONVIRTUAL(env, java_util_zip_InflaterInputStream, _init$c297c4a8a618e86d, 0, r0, r1, r2, 4096);
	r4 = _JC_NEW(env, java_util_zip_CRC32);
	_JC_PRIM_FIELD(env, r4, java_util_zip_CRC32, crc) = 0;
	_JC_REF_FIELD(env, r0, java_util_zip_ZipInputStream, crc) = r4;
	_JC_REF_FIELD(env, r0, java_util_zip_ZipInputStream, entry) = _JC_NULL;
	_JC_LINE_NUMBER(73);				// 1
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public int available() throws java.io.IOException
//

static _jc_linenum _jc_java_util_zip_ZipInputStream$linenum_table$available$81975cc608605037[];

static const unsigned char _jc_java_util_zip_ZipInputStream$param_ptypes$available$81975cc608605037[] = { 
_JC_TYPE_INT };

static _jc_type *const _jc_java_util_zip_ZipInputStream$exceptions$available$81975cc608605037[] = {
	&_jc_java_io_IOException$type
};

_jc_method _jc_java_util_zip_ZipInputStream$method_info$available$81975cc608605037 = {
	.name=			"available",
	.signature=		"()I",
	.class=			&_jc_java_util_zip_ZipInputStream$type,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_java_util_zip_ZipInputStream$param_ptypes$available$81975cc608605037,
	.signature_hash=	_JC_JLONG(0x81975cc608605037),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_util_zip_ZipInputStream$method$available$81975cc608605037,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_util_zip_ZipInputStream$vtable, java_util_zip_ZipInputStream.available$81975cc608605037) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_util_zip_ZipInputStream$exceptions$available$81975cc608605037,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_util_zip_ZipInputStream$linenum_table$available$81975cc608605037
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_util_zip_ZipInputStream, available$81975cc608605037);

jint _JC_JCNI_ATTR
_jc_java_util_zip_ZipInputStream$method$available$81975cc608605037(_jc_env *const env, _jc_java_util_zip_ZipInputStream$object *this)
{
	jint i0;
	struct _jc_java_util_zip_ZipInputStream$object *r0;
	jboolean z0;

	r0 = this;
	_JC_LINE_NUMBER(264);				// 0
	z0 = _JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, entryAtEOF);
	i0 = (jint)z0;
	i0 = 1 - i0;
	return i0;
}

//
// public void close() throws java.io.IOException
//

static _jc_linenum _jc_java_util_zip_ZipInputStream$linenum_table$close$6aba8b329fddcd79[];

static const unsigned char _jc_java_util_zip_ZipInputStream$param_ptypes$close$6aba8b329fddcd79[] = { 
_JC_TYPE_VOID };

static _jc_type *const _jc_java_util_zip_ZipInputStream$exceptions$close$6aba8b329fddcd79[] = {
	&_jc_java_io_IOException$type
};

_jc_method _jc_java_util_zip_ZipInputStream$method_info$close$6aba8b329fddcd79 = {
	.name=			"close",
	.signature=		"()V",
	.class=			&_jc_java_util_zip_ZipInputStream$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_util_zip_ZipInputStream$param_ptypes$close$6aba8b329fddcd79,
	.signature_hash=	_JC_JLONG(0x6aba8b329fddcd79),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_util_zip_ZipInputStream$method$close$6aba8b329fddcd79,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_util_zip_ZipInputStream$vtable, java_util_zip_ZipInputStream.close$6aba8b329fddcd79) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_util_zip_ZipInputStream$exceptions$close$6aba8b329fddcd79,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_java_util_zip_ZipInputStream$linenum_table$close$6aba8b329fddcd79
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_util_zip_ZipInputStream, close$6aba8b329fddcd79);

void _JC_JCNI_ATTR
_jc_java_util_zip_ZipInputStream$method$close$6aba8b329fddcd79(_jc_env *const env, _jc_java_util_zip_ZipInputStream$object *this)
{
	struct _jc_java_util_zip_ZipInputStream$object *r0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(356);				// 0
	_JC_INVOKE_NONVIRTUAL(env, java_util_zip_InflaterInputStream, close$6aba8b329fddcd79, 0, r0);
	_JC_LINE_NUMBER(357);				// 1
	_JC_REF_FIELD(env, r0, java_util_zip_ZipInputStream, crc) = _JC_NULL;
	_JC_LINE_NUMBER(358);				// 2
	_JC_REF_FIELD(env, r0, java_util_zip_ZipInputStream, entry) = _JC_NULL;
	_JC_LINE_NUMBER(359);				// 3
	_JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, entryAtEOF) = 1;
	_JC_LINE_NUMBER(360);				// 4
	return;
}

//
// public void closeEntry() throws java.io.IOException
//

static _jc_linenum _jc_java_util_zip_ZipInputStream$linenum_table$closeEntry$9060a01a67213941[];

static const unsigned char _jc_java_util_zip_ZipInputStream$param_ptypes$closeEntry$9060a01a67213941[] = { 
_JC_TYPE_VOID };

static _jc_type *const _jc_java_util_zip_ZipInputStream$exceptions$closeEntry$9060a01a67213941[] = {
	&_jc_java_io_IOException$type
};

_jc_method _jc_java_util_zip_ZipInputStream$method_info$closeEntry$9060a01a67213941 = {
	.name=			"closeEntry",
	.signature=		"()V",
	.class=			&_jc_java_util_zip_ZipInputStream$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_util_zip_ZipInputStream$param_ptypes$closeEntry$9060a01a67213941,
	.signature_hash=	_JC_JLONG(0x9060a01a67213941),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_util_zip_ZipInputStream$method$closeEntry$9060a01a67213941,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_util_zip_ZipInputStream$vtable, java_util_zip_ZipInputStream.closeEntry$9060a01a67213941) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_util_zip_ZipInputStream$exceptions$closeEntry$9060a01a67213941,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	28,
	      .table=	_jc_java_util_zip_ZipInputStream$linenum_table$closeEntry$9060a01a67213941
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_util_zip_ZipInputStream, closeEntry$9060a01a67213941);

void _JC_JCNI_ATTR
_jc_java_util_zip_ZipInputStream$method$closeEntry$9060a01a67213941(_jc_env *const env, _jc_java_util_zip_ZipInputStream$object *this)
{
	jbyte b3;
	jint i0;
	jint i1;
	jlong l2;
	jlong l4;
	struct _jc_java_util_zip_ZipInputStream$object *r0;
	_jc_byte_array *r1;
	struct _jc_java_lang_VMThrowable$object *r10;
	struct _jc_java_lang_VMThrowable$object *r12;
	struct _jc_java_util_zip_CRC32$object *r2;
	struct _jc_java_io_IOException$object *r3;
	struct _jc_java_util_zip_ZipEntry$object *r4;
	struct _jc_java_util_zip_Inflater$object *r5;
	struct _jc_java_io_InputStream$object *r6;
	struct _jc_java_util_zip_ZipException$object *r7;
	struct _jc_java_lang_String$object *r8;
	struct _jc_java_lang_String$object *r9;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(219);				// 0
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_ZipInputStream, crc);
	if (r2 != _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(220);				// 1
	r3 = _JC_NEW(env, java_io_IOException);
	r8 = _JC_STRING(env, "Stream closed.");
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r10 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r10;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r8;
	_JC_THROW(env, r3);

label0:
	_JC_LINE_NUMBER(221);				// 2
	r4 = _JC_REF_FIELD(env, r0, java_util_zip_ZipInputStream, entry);
	if (r4 != _JC_NULL)
		goto label1;
	_JC_LINE_NUMBER(222);				// 3
	return;

label1:
	_JC_LINE_NUMBER(224);				// 4
	i0 = _JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, method);
	if (i0 != 8)
		goto label4;
	_JC_LINE_NUMBER(226);				// 5
	i0 = _JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, flags);
	i0 = i0 & 8;
	if (i0 == 0)
		goto label3;
	_JC_LINE_NUMBER(229);				// 6
	r1 = _JC_NEW_PRIM_ARRAY(env, byte, 1, 2048);

label2:
	_JC_LINE_NUMBER(230);				// 7
	i0 = _JC_INVOKE_VIRTUAL(env, java_io_FilterInputStream, read$c38dd905b7fb8654, r0, r1);
	if (i0 > 0) {
		_JC_PERIODIC_CHECK(env);
		goto label2;
	}
	_JC_LINE_NUMBER(233);				// 8
	return;

label3:
	_JC_LINE_NUMBER(235);				// 9
	i0 = _JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, csize);
	r5 = _JC_REF_FIELD(env, r0, java_util_zip_InflaterInputStream, inf);
	i1 = _JC_INVOKE_VIRTUAL(env, java_util_zip_Inflater, getTotalIn$3504553dfa702134, r5);
	i1 = i0 - i1;
	_JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, csize) = i1;
	_JC_LINE_NUMBER(236);				// 10
	r5 = _JC_REF_FIELD(env, r0, java_util_zip_InflaterInputStream, inf);
	i1 = _JC_INVOKE_VIRTUAL(env, java_util_zip_Inflater, getRemaining$ea62a8f944647e1f, r5);
	_JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, avail) = i1;

label4:
	_JC_LINE_NUMBER(239);				// 11
	i1 = _JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, avail);
	i0 = _JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, csize);
	if (i1 <= i0)
		goto label5;
	i1 = _JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, csize);
	if (i1 < 0)
		goto label5;
	_JC_LINE_NUMBER(240);				// 12
	i1 = _JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, avail);
	i0 = _JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, csize);
	i1 = i1 - i0;
	_JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, avail) = i1;
	goto label9;

label5:
	_JC_LINE_NUMBER(243);				// 13
	i1 = _JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, csize);
	i0 = _JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, avail);
	i1 = i1 - i0;
	_JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, csize) = i1;
	_JC_LINE_NUMBER(244);				// 14
	_JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, avail) = 0;
	_JC_LINE_NUMBER(245);				// 15
	goto label8;

label6:
	_JC_LINE_NUMBER(247);				// 16
	r6 = _JC_REF_FIELD(env, r0, java_io_FilterInputStream, in);
	i1 = _JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, csize);
	l2 = (jlong)i1;
	l2 = l2 & (_JC_JLONG(4294967295));
	l2 = _JC_INVOKE_VIRTUAL(env, java_io_InputStream, skip$4e431136b5c4614a, r6, l2);
	_JC_LINE_NUMBER(248);				// 17
	b3 = _JC_LCMP(l2, _JC_JLONG(0));
	if (b3 > 0)
		goto label7;
	_JC_LINE_NUMBER(249);				// 18
	r7 = _JC_NEW(env, java_util_zip_ZipException);
	r9 = _JC_STRING(env, "zip archive ends early.");
	_JC_REF_FIELD(env, r7, java_lang_Throwable, cause) = r7;
	r12 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r7);
	_JC_REF_FIELD(env, r7, java_lang_Throwable, vmState) = r12;
	_JC_REF_FIELD(env, r7, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r7, java_lang_Throwable, detailMessage) = r9;
	_JC_THROW(env, r7);

label7:
	_JC_LINE_NUMBER(250);				// 19
	i1 = _JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, csize);
	l4 = (jlong)i1;
	l4 = l4 - l2;
	i1 = (jint)l4;
	_JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, csize) = i1;

label8:
	_JC_LINE_NUMBER(245);				// 20
	i1 = _JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, csize);
	if (i1 != 0) {
		_JC_PERIODIC_CHECK(env);
		goto label6;
	}

label9:
	_JC_LINE_NUMBER(254);				// 21
	_JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, size) = 0;
	_JC_LINE_NUMBER(255);				// 22
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_ZipInputStream, crc);
	_JC_INVOKE_VIRTUAL(env, java_util_zip_CRC32, reset$229a80b3e8394a0f, r2);
	_JC_LINE_NUMBER(256);				// 23
	i1 = _JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, method);
	if (i1 != 8)
		goto label10;
	_JC_LINE_NUMBER(257);				// 24
	r5 = _JC_REF_FIELD(env, r0, java_util_zip_InflaterInputStream, inf);
	_JC_INVOKE_VIRTUAL(env, java_util_zip_Inflater, reset$229a80b3e8394a0f, r5);

label10:
	_JC_LINE_NUMBER(258);				// 25
	_JC_REF_FIELD(env, r0, java_util_zip_ZipInputStream, entry) = _JC_NULL;
	_JC_LINE_NUMBER(259);				// 26
	_JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, entryAtEOF) = 1;
	_JC_LINE_NUMBER(260);				// 27
	return;
}

//
// protected java.util.zip.ZipEntry createZipEntry(java.lang.String)
//

static _jc_linenum _jc_java_util_zip_ZipInputStream$linenum_table$createZipEntry$3e6190033d3b6bac[];

static const unsigned char _jc_java_util_zip_ZipInputStream$param_ptypes$createZipEntry$3e6190033d3b6bac[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_util_zip_ZipInputStream$param_types$createZipEntry$3e6190033d3b6bac[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_java_util_zip_ZipInputStream$method_info$createZipEntry$3e6190033d3b6bac = {
	.name=			"createZipEntry",
	.signature=		"(Ljava/lang/String;)Ljava/util/zip/ZipEntry;",
	.class=			&_jc_java_util_zip_ZipInputStream$type,
	.param_types=		&_jc_java_util_zip_ZipInputStream$param_types$createZipEntry$3e6190033d3b6bac,
	.return_type=		&_jc_java_util_zip_ZipEntry$type,
	.param_ptypes=		&_jc_java_util_zip_ZipInputStream$param_ptypes$createZipEntry$3e6190033d3b6bac,
	.signature_hash=	_JC_JLONG(0x3e6190033d3b6bac),
	.access_flags=		_JC_ACC_PROTECTED,
	.function=		&_jc_java_util_zip_ZipInputStream$method$createZipEntry$3e6190033d3b6bac,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_util_zip_ZipInputStream$vtable, java_util_zip_ZipInputStream.createZipEntry$3e6190033d3b6bac) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_util_zip_ZipInputStream$linenum_table$createZipEntry$3e6190033d3b6bac
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_util_zip_ZipInputStream, createZipEntry$3e6190033d3b6bac);

_jc_java_util_zip_ZipEntry$object * _JC_JCNI_ATTR
_jc_java_util_zip_ZipInputStream$method$createZipEntry$3e6190033d3b6bac(_jc_env *const env, _jc_java_util_zip_ZipInputStream$object *this, _jc_java_lang_String$object *param0)
{
	struct _jc_java_util_zip_ZipInputStream$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_java_util_zip_ZipEntry$object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(369);				// 0
	r2 = _JC_NEW(env, java_util_zip_ZipEntry);
	_JC_INVOKE_NONVIRTUAL(env, java_util_zip_ZipEntry, _init$c31b894660454d13, 0, r2, r1);
	return r2;
}

//
// private final void fillBuf() throws java.io.IOException
//

static _jc_linenum _jc_java_util_zip_ZipInputStream$linenum_table$fillBuf$832c8ac6e4b87cb3[];

static const unsigned char _jc_java_util_zip_ZipInputStream$param_ptypes$fillBuf$832c8ac6e4b87cb3[] = { 
_JC_TYPE_VOID };

static _jc_type *const _jc_java_util_zip_ZipInputStream$exceptions$fillBuf$832c8ac6e4b87cb3[] = {
	&_jc_java_io_IOException$type
};

_jc_method _jc_java_util_zip_ZipInputStream$method_info$fillBuf$832c8ac6e4b87cb3 = {
	.name=			"fillBuf",
	.signature=		"()V",
	.class=			&_jc_java_util_zip_ZipInputStream$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_util_zip_ZipInputStream$param_ptypes$fillBuf$832c8ac6e4b87cb3,
	.signature_hash=	_JC_JLONG(0x832c8ac6e4b87cb3),
	.access_flags=		_JC_ACC_PRIVATE|_JC_ACC_FINAL,
	.function=		&_jc_java_util_zip_ZipInputStream$method$fillBuf$832c8ac6e4b87cb3,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_util_zip_ZipInputStream$vtable, java_util_zip_ZipInputStream.fillBuf$832c8ac6e4b87cb3) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_util_zip_ZipInputStream$exceptions$fillBuf$832c8ac6e4b87cb3,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_util_zip_ZipInputStream$linenum_table$fillBuf$832c8ac6e4b87cb3
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_util_zip_ZipInputStream, fillBuf$832c8ac6e4b87cb3);

void _JC_JCNI_ATTR
_jc_java_util_zip_ZipInputStream$method$fillBuf$832c8ac6e4b87cb3(_jc_env *const env, _jc_java_util_zip_ZipInputStream$object *this)
{
	jint i0;
	struct _jc_java_util_zip_ZipInputStream$object *r0;
	struct _jc_java_io_InputStream$object *r1;
	_jc_byte_array *r2;
	_jc_byte_array *r3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(77);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_io_FilterInputStream, in);
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_InflaterInputStream, buf);
	r3 = _JC_REF_FIELD(env, r0, java_util_zip_InflaterInputStream, buf);
	i0 = _JC_ARRAY_LENGTH(env, r3);
	i0 = _JC_INVOKE_VIRTUAL(env, java_io_InputStream, read$e6b6c87b9f256783, r1, r2, 0, i0);
	_JC_PRIM_FIELD(env, r0, java_util_zip_InflaterInputStream, len) = i0;
	_JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, avail) = i0;
	_JC_LINE_NUMBER(78);				// 1
	return;
}

//
// public java.util.zip.ZipEntry getNextEntry() throws java.io.IOException
//

static _jc_linenum _jc_java_util_zip_ZipInputStream$linenum_table$getNextEntry$37c60ebf27303f95[];

static const unsigned char _jc_java_util_zip_ZipInputStream$param_ptypes$getNextEntry$37c60ebf27303f95[] = { 
_JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_util_zip_ZipInputStream$exceptions$getNextEntry$37c60ebf27303f95[] = {
	&_jc_java_io_IOException$type
};

_jc_method _jc_java_util_zip_ZipInputStream$method_info$getNextEntry$37c60ebf27303f95 = {
	.name=			"getNextEntry",
	.signature=		"()Ljava/util/zip/ZipEntry;",
	.class=			&_jc_java_util_zip_ZipInputStream$type,
	.return_type=		&_jc_java_util_zip_ZipEntry$type,
	.param_ptypes=		&_jc_java_util_zip_ZipInputStream$param_ptypes$getNextEntry$37c60ebf27303f95,
	.signature_hash=	_JC_JLONG(0x37c60ebf27303f95),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_util_zip_ZipInputStream$method$getNextEntry$37c60ebf27303f95,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_util_zip_ZipInputStream$vtable, java_util_zip_ZipInputStream.getNextEntry$37c60ebf27303f95) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_util_zip_ZipInputStream$exceptions$getNextEntry$37c60ebf27303f95,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	39,
	      .table=	_jc_java_util_zip_ZipInputStream$linenum_table$getNextEntry$37c60ebf27303f95
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_util_zip_ZipInputStream, getNextEntry$37c60ebf27303f95);

_jc_java_util_zip_ZipEntry$object * _JC_JCNI_ATTR
_jc_java_util_zip_ZipInputStream$method$getNextEntry$37c60ebf27303f95(_jc_env *const env, _jc_java_util_zip_ZipInputStream$object *this)
{
	jint i0;
	jint i1;
	jint i10;
	jint i11;
	jint i12;
	jint i13;
	jint i14;
	jint i15;
	jint i17;
	jint i2;
	jint i3;
	jint i4;
	jint i5;
	jint i7;
	jint i8;
	jint i9;
	jlong l6;
	struct _jc_java_util_zip_ZipInputStream$object *r0;
	_jc_byte_array *r1;
	struct _jc_java_lang_String$object *r10;
	struct _jc_java_lang_String$object *r11;
	struct _jc_java_lang_String$object *r12;
	struct _jc_java_lang_String$object *r13;
	struct _jc_java_lang_VMThrowable$object *r14;
	struct _jc_java_lang_VMThrowable$object *r15;
	struct _jc_java_lang_VMThrowable$object *r16;
	struct _jc_java_lang_String$object *r17;
	_jc_char_array *r18;
	struct _jc_java_lang_String$object *r2;
	struct _jc_java_util_zip_CRC32$object *r3;
	struct _jc_java_io_IOException$object *r4;
	struct _jc_java_util_zip_ZipEntry$object *r5;
	struct _jc_java_util_zip_ZipException$object *r6;
	struct _jc_java_lang_StringBuffer$object *r7;
	_jc_byte_array *r8;
	struct _jc_java_util_zip_Inflater$object *r9;
	jshort s16;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(142);				// 0
	r3 = _JC_REF_FIELD(env, r0, java_util_zip_ZipInputStream, crc);
	if (r3 != _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(143);				// 1
	r4 = _JC_NEW(env, java_io_IOException);
	r10 = _JC_STRING(env, "Stream closed.");
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r14 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r14;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r10;
	_JC_THROW(env, r4);

label0:
	_JC_LINE_NUMBER(144);				// 2
	r5 = _JC_REF_FIELD(env, r0, java_util_zip_ZipInputStream, entry);
	if (r5 == _JC_NULL)
		goto label1;
	_JC_LINE_NUMBER(145);				// 3
	_JC_INVOKE_VIRTUAL(env, java_util_zip_ZipInputStream, closeEntry$9060a01a67213941, r0);

label1:
	_JC_LINE_NUMBER(147);				// 4
	i0 = _JC_INVOKE_NONVIRTUAL(env, java_util_zip_ZipInputStream, readLeInt$e034ce166156a379, 0, r0);
	_JC_LINE_NUMBER(148);				// 5
	if (i0 != 33639248)
		goto label2;
	_JC_LINE_NUMBER(151);				// 6
	_JC_INVOKE_VIRTUAL(env, java_util_zip_ZipInputStream, close$6aba8b329fddcd79, r0);
	_JC_LINE_NUMBER(152);				// 7
	return _JC_NULL;

label2:
	_JC_LINE_NUMBER(154);				// 8
	if (i0 == 67324752)
		goto label3;
	_JC_LINE_NUMBER(155);				// 9
	r6 = _JC_NEW(env, java_util_zip_ZipException);
	r7 = _JC_NEW(env, java_lang_StringBuffer);
	r17 = _JC_STRING(env, "Wrong Local header signature: ");
	i17 = _JC_PRIM_FIELD(env, r17, java_lang_String, count);
	_JC_PRIM_FIELD(env, r7, java_lang_StringBuffer, count) = i17;
	i17 = _JC_PRIM_FIELD(env, r7, java_lang_StringBuffer, count);
	i17 = i17 + 16;
	r18 = _JC_NEW_PRIM_ARRAY(env, char, 1, i17);
	_JC_REF_FIELD(env, r7, java_lang_StringBuffer, value) = r18;
	i17 = _JC_PRIM_FIELD(env, r7, java_lang_StringBuffer, count);
	r18 = _JC_REF_FIELD(env, r7, java_lang_StringBuffer, value);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, getChars$c684dea7317ff063, 0, r17, 0, i17, r18, 0);
	_JC_ACTIVE_USE(env, java_lang_Integer);
	r11 = _JC_INVOKE_STATIC(env, java_lang_Integer, toUnsignedString$0e382aff778c29b9, 1, i0, 4);
	r7 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r7, r11);
	r13 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r13, r7);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, cause) = r6;
	r15 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r6);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, vmState) = r15;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, detailMessage) = r13;
	_JC_THROW(env, r6);

label3:
	_JC_INVOKE_NONVIRTUAL(env, java_util_zip_ZipInputStream, readLeByte$4d38b4eec2855c73, 0, r0);
	_JC_INVOKE_NONVIRTUAL(env, java_util_zip_ZipInputStream, readLeByte$4d38b4eec2855c73, 0, r0);
	i8 = _JC_INVOKE_NONVIRTUAL(env, java_util_zip_ZipInputStream, readLeByte$4d38b4eec2855c73, 0, r0);
	i9 = _JC_INVOKE_NONVIRTUAL(env, java_util_zip_ZipInputStream, readLeByte$4d38b4eec2855c73, 0, r0);
	i9 = i9 << (8 & 0x1f);
	i9 = i8 | i9;
	_JC_LINE_NUMBER(159);				// 10
	_JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, flags) = i9;
	i10 = _JC_INVOKE_NONVIRTUAL(env, java_util_zip_ZipInputStream, readLeByte$4d38b4eec2855c73, 0, r0);
	i11 = _JC_INVOKE_NONVIRTUAL(env, java_util_zip_ZipInputStream, readLeByte$4d38b4eec2855c73, 0, r0);
	i11 = i11 << (8 & 0x1f);
	i11 = i10 | i11;
	_JC_LINE_NUMBER(160);				// 11
	_JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, method) = i11;
	_JC_LINE_NUMBER(161);				// 12
	i0 = _JC_INVOKE_NONVIRTUAL(env, java_util_zip_ZipInputStream, readLeInt$e034ce166156a379, 0, r0);
	_JC_LINE_NUMBER(162);				// 13
	i1 = _JC_INVOKE_NONVIRTUAL(env, java_util_zip_ZipInputStream, readLeInt$e034ce166156a379, 0, r0);
	_JC_LINE_NUMBER(163);				// 14
	i3 = _JC_INVOKE_NONVIRTUAL(env, java_util_zip_ZipInputStream, readLeInt$e034ce166156a379, 0, r0);
	_JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, csize) = i3;
	_JC_LINE_NUMBER(164);				// 15
	i3 = _JC_INVOKE_NONVIRTUAL(env, java_util_zip_ZipInputStream, readLeInt$e034ce166156a379, 0, r0);
	_JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, size) = i3;
	i12 = _JC_INVOKE_NONVIRTUAL(env, java_util_zip_ZipInputStream, readLeByte$4d38b4eec2855c73, 0, r0);
	i13 = _JC_INVOKE_NONVIRTUAL(env, java_util_zip_ZipInputStream, readLeByte$4d38b4eec2855c73, 0, r0);
	i13 = i13 << (8 & 0x1f);
	i13 = i12 | i13;
	i2 = i13;
	i14 = _JC_INVOKE_NONVIRTUAL(env, java_util_zip_ZipInputStream, readLeByte$4d38b4eec2855c73, 0, r0);
	i15 = _JC_INVOKE_NONVIRTUAL(env, java_util_zip_ZipInputStream, readLeByte$4d38b4eec2855c73, 0, r0);
	i15 = i15 << (8 & 0x1f);
	i15 = i14 | i15;
	i3 = i15;
	_JC_LINE_NUMBER(168);				// 16
	i4 = _JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, method);
	if (i4 != 0)
		goto label4;
	i4 = _JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, csize);
	i5 = _JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, size);
	if (i4 == i5)
		goto label4;
	_JC_LINE_NUMBER(169);				// 17
	r6 = _JC_NEW(env, java_util_zip_ZipException);
	r12 = _JC_STRING(env, "Stored, but compressed != uncompressed");
	_JC_REF_FIELD(env, r6, java_lang_Throwable, cause) = r6;
	r16 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r6);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, vmState) = r16;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, detailMessage) = r12;
	_JC_THROW(env, r6);

label4:
	_JC_LINE_NUMBER(172);				// 18
	r1 = _JC_NEW_PRIM_ARRAY(env, byte, 1, i2);
	_JC_LINE_NUMBER(173);				// 19
	_JC_INVOKE_NONVIRTUAL(env, java_util_zip_ZipInputStream, readFully$2c917249902aa549, 0, r0, r1);
	_JC_LINE_NUMBER(174);				// 20
	r2 = _JC_NEW(env, java_lang_String);
	i7 = _JC_ARRAY_LENGTH(env, r1);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$4ff4a7925ef7b06c, 0, r2, r1, 0, i7);
	_JC_LINE_NUMBER(176);				// 21
	r5 = _JC_INVOKE_VIRTUAL(env, java_util_zip_ZipInputStream, createZipEntry$3e6190033d3b6bac, r0, r2);
	_JC_REF_FIELD(env, r0, java_util_zip_ZipInputStream, entry) = r5;
	_JC_LINE_NUMBER(177);				// 22
	_JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, entryAtEOF) = 0;
	_JC_LINE_NUMBER(178);				// 23
	r5 = _JC_REF_FIELD(env, r0, java_util_zip_ZipInputStream, entry);
	i5 = _JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, method);
	_JC_INVOKE_VIRTUAL(env, java_util_zip_ZipEntry, setMethod$87a531d32254a04e, r5, i5);
	_JC_LINE_NUMBER(179);				// 24
	i5 = _JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, flags);
	i5 = i5 & 8;
	if (i5 != 0)
		goto label5;
	_JC_LINE_NUMBER(181);				// 25
	r5 = _JC_REF_FIELD(env, r0, java_util_zip_ZipInputStream, entry);
	l6 = (jlong)i1;
	l6 = l6 & (_JC_JLONG(4294967295));
	_JC_INVOKE_VIRTUAL(env, java_util_zip_ZipEntry, setCrc$6de82408625e4c3f, r5, l6);
	_JC_LINE_NUMBER(182);				// 26
	r5 = _JC_REF_FIELD(env, r0, java_util_zip_ZipInputStream, entry);
	i5 = _JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, size);
	l6 = (jlong)i5;
	l6 = l6 & (_JC_JLONG(4294967295));
	_JC_INVOKE_VIRTUAL(env, java_util_zip_ZipEntry, setSize$a8b03df508d7687d, r5, l6);
	_JC_LINE_NUMBER(183);				// 27
	r5 = _JC_REF_FIELD(env, r0, java_util_zip_ZipInputStream, entry);
	i5 = _JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, csize);
	l6 = (jlong)i5;
	l6 = l6 & (_JC_JLONG(4294967295));
	_JC_INVOKE_VIRTUAL(env, java_util_zip_ZipEntry, setCompressedSize$a291408ca1bb65e7, r5, l6);

label5:
	_JC_LINE_NUMBER(185);				// 28
	r5 = _JC_REF_FIELD(env, r0, java_util_zip_ZipInputStream, entry);
	_JC_EXPLICIT_NULL_CHECK(env, r5);
	_JC_PRIM_FIELD(env, r5, java_util_zip_ZipEntry, dostime) = i0;
	s16 = _JC_PRIM_FIELD(env, r5, java_util_zip_ZipEntry, known);
	s16 = s16 | 8;
	s16 = (jshort)s16;
	_JC_PRIM_FIELD(env, r5, java_util_zip_ZipEntry, known) = s16;
	_JC_LINE_NUMBER(186);				// 29
	if (i3 <= 0)
		goto label6;
	_JC_LINE_NUMBER(188);				// 30
	r1 = _JC_NEW_PRIM_ARRAY(env, byte, 1, i3);
	_JC_LINE_NUMBER(189);				// 31
	_JC_INVOKE_NONVIRTUAL(env, java_util_zip_ZipInputStream, readFully$2c917249902aa549, 0, r0, r1);
	_JC_LINE_NUMBER(190);				// 32
	r5 = _JC_REF_FIELD(env, r0, java_util_zip_ZipInputStream, entry);
	_JC_INVOKE_VIRTUAL(env, java_util_zip_ZipEntry, setExtra$65df321f5653b653, r5, r1);

label6:
	_JC_LINE_NUMBER(193);				// 33
	i5 = _JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, method);
	if (i5 != 8)
		goto label7;
	i5 = _JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, avail);
	if (i5 <= 0)
		goto label7;
	_JC_LINE_NUMBER(195);				// 34
	r1 = _JC_REF_FIELD(env, r0, java_util_zip_InflaterInputStream, buf);
	i5 = _JC_PRIM_FIELD(env, r0, java_util_zip_InflaterInputStream, len);
	i4 = _JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, avail);
	i5 = i5 - i4;
	r8 = _JC_REF_FIELD(env, r0, java_util_zip_InflaterInputStream, buf);
	i4 = _JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, avail);
	_JC_ACTIVE_USE(env, java_lang_System);
	_JC_INVOKE_STATIC(env, java_lang_VMSystem, arraycopy$4286a72d57744cd8, 0, r1, i5, r8, 0, i4);
	_JC_LINE_NUMBER(196);				// 35
	i5 = _JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, avail);
	_JC_PRIM_FIELD(env, r0, java_util_zip_InflaterInputStream, len) = i5;
	_JC_LINE_NUMBER(197);				// 36
	_JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, avail) = 0;
	_JC_LINE_NUMBER(198);				// 37
	r9 = _JC_REF_FIELD(env, r0, java_util_zip_InflaterInputStream, inf);
	r8 = _JC_REF_FIELD(env, r0, java_util_zip_InflaterInputStream, buf);
	i5 = _JC_PRIM_FIELD(env, r0, java_util_zip_InflaterInputStream, len);
	_JC_INVOKE_VIRTUAL(env, java_util_zip_Inflater, setInput$c9c91f0df4009bec, r9, r8, 0, i5);

label7:
	_JC_LINE_NUMBER(200);				// 38
	r5 = _JC_REF_FIELD(env, r0, java_util_zip_ZipInputStream, entry);
	return r5;
}

//
// public int read() throws java.io.IOException
//

static _jc_linenum _jc_java_util_zip_ZipInputStream$linenum_table$read$1a981297cb524963[];

static const unsigned char _jc_java_util_zip_ZipInputStream$param_ptypes$read$1a981297cb524963[] = { 
_JC_TYPE_INT };

static _jc_type *const _jc_java_util_zip_ZipInputStream$exceptions$read$1a981297cb524963[] = {
	&_jc_java_io_IOException$type
};

_jc_method _jc_java_util_zip_ZipInputStream$method_info$read$1a981297cb524963 = {
	.name=			"read",
	.signature=		"()I",
	.class=			&_jc_java_util_zip_ZipInputStream$type,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_java_util_zip_ZipInputStream$param_ptypes$read$1a981297cb524963,
	.signature_hash=	_JC_JLONG(0x1a981297cb524963),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_util_zip_ZipInputStream$method$read$1a981297cb524963,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_util_zip_ZipInputStream$vtable, java_util_zip_ZipInputStream.read$1a981297cb524963) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_util_zip_ZipInputStream$exceptions$read$1a981297cb524963,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_java_util_zip_ZipInputStream$linenum_table$read$1a981297cb524963
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_util_zip_ZipInputStream, read$1a981297cb524963);

jint _JC_JCNI_ATTR
_jc_java_util_zip_ZipInputStream$method$read$1a981297cb524963(_jc_env *const env, _jc_java_util_zip_ZipInputStream$object *this)
{
	jbyte b1;
	jint i0;
	struct _jc_java_util_zip_ZipInputStream$object *r0;
	_jc_byte_array *r1;
	jshort s2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(275);				// 0
	r1 = _JC_NEW_PRIM_ARRAY(env, byte, 1, 1);
	_JC_LINE_NUMBER(276);				// 1
	i0 = _JC_INVOKE_VIRTUAL(env, java_util_zip_ZipInputStream, read$e6b6c87b9f256783, r0, r1, 0, 1);
	if (i0 > 0)
		goto label0;
	_JC_LINE_NUMBER(277);				// 2
	return -1;

label0:
	_JC_LINE_NUMBER(278);				// 3
	b1 = _JC_PRIM_ELEMENT(env, byte, r1, 0, 0, 1);
	s2 = b1 & 255;
	return s2;
}

//
// public int read(byte[], int, int) throws java.io.IOException
//

static _jc_linenum _jc_java_util_zip_ZipInputStream$linenum_table$read$e6b6c87b9f256783[];

static const unsigned char _jc_java_util_zip_ZipInputStream$param_ptypes$read$e6b6c87b9f256783[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_INT, _JC_TYPE_INT };

static _jc_type *const _jc_java_util_zip_ZipInputStream$exceptions$read$e6b6c87b9f256783[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_java_util_zip_ZipInputStream$param_types$read$e6b6c87b9f256783[] = {
	&_jc_byte$array$prim$type,
	&_jc_int$prim$type,
	&_jc_int$prim$type
};

_jc_method _jc_java_util_zip_ZipInputStream$method_info$read$e6b6c87b9f256783 = {
	.name=			"read",
	.signature=		"([BII)I",
	.class=			&_jc_java_util_zip_ZipInputStream$type,
	.param_types=		&_jc_java_util_zip_ZipInputStream$param_types$read$e6b6c87b9f256783,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_java_util_zip_ZipInputStream$param_ptypes$read$e6b6c87b9f256783,
	.signature_hash=	_JC_JLONG(0xe6b6c87b9f256783),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_util_zip_ZipInputStream$method$read$e6b6c87b9f256783,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_util_zip_ZipInputStream$vtable, java_util_zip_ZipInputStream.read$e6b6c87b9f256783) / sizeof(void *),
	.num_parameters=	3,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_util_zip_ZipInputStream$exceptions$read$e6b6c87b9f256783,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	39,
	      .table=	_jc_java_util_zip_ZipInputStream$linenum_table$read$e6b6c87b9f256783
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_util_zip_ZipInputStream, read$e6b6c87b9f256783);

jint _JC_JCNI_ATTR
_jc_java_util_zip_ZipInputStream$method$read$e6b6c87b9f256783(_jc_env *const env, _jc_java_util_zip_ZipInputStream$object *this, _jc_byte_array *param0, jint param1, jint param2)
{
	jbyte b6;
	jint i0;
	jint i1;
	jint i2;
	jint i3;
	jint i7;
	jlong l4;
	jlong l5;
	struct _jc_java_util_zip_ZipInputStream$object *r0;
	_jc_byte_array *r1;
	struct _jc_java_lang_String$object *r10;
	struct _jc_java_lang_String$object *r11;
	struct _jc_java_lang_StringBuffer$object *r12;
	struct _jc_java_lang_String$object *r13;
	struct _jc_java_lang_StringBuffer$object *r14;
	struct _jc_java_lang_String$object *r15;
	struct _jc_java_lang_StringBuffer$object *r16;
	struct _jc_java_lang_String$object *r17;
	struct _jc_java_lang_StringBuffer$object *r18;
	struct _jc_java_lang_String$object *r19;
	struct _jc_java_util_zip_CRC32$object *r2;
	struct _jc_java_lang_String$object *r20;
	struct _jc_java_lang_VMThrowable$object *r21;
	struct _jc_java_lang_VMThrowable$object *r22;
	struct _jc_java_lang_VMThrowable$object *r23;
	struct _jc_java_lang_VMThrowable$object *r24;
	struct _jc_java_lang_VMThrowable$object *r25;
	struct _jc_java_lang_String$object *r26;
	_jc_char_array *r27;
	struct _jc_java_io_IOException$object *r3;
	struct _jc_java_util_zip_ZipEntry$object *r4;
	struct _jc_java_util_zip_Inflater$object *r5;
	struct _jc_java_util_zip_ZipException$object *r6;
	struct _jc_java_lang_StringBuffer$object *r7;
	struct _jc_java_lang_String$object *r8;
	struct _jc_java_lang_String$object *r9;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	i0 = param1;
	i1 = param2;
	_JC_LINE_NUMBER(290);				// 0
	if (i1 != 0)
		goto label0;
	_JC_LINE_NUMBER(291);				// 1
	return 0;

label0:
	_JC_LINE_NUMBER(292);				// 2
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_ZipInputStream, crc);
	if (r2 != _JC_NULL)
		goto label1;
	_JC_LINE_NUMBER(293);				// 3
	r3 = _JC_NEW(env, java_io_IOException);
	r8 = _JC_STRING(env, "Stream closed.");
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r21 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r21;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r8;
	_JC_THROW(env, r3);

label1:
	_JC_LINE_NUMBER(294);				// 4
	r4 = _JC_REF_FIELD(env, r0, java_util_zip_ZipInputStream, entry);
	if (r4 != _JC_NULL)
		goto label2;
	_JC_LINE_NUMBER(295);				// 5
	return -1;

label2:
	_JC_LINE_NUMBER(296);				// 6
	z0 = 0;
	_JC_LINE_NUMBER(297);				// 7
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, method);
	switch (i2) {
	case 0:
		goto label8;
	case 8:
		goto label3;
	default:
		goto label12;
	}

label3:
	_JC_LINE_NUMBER(300);				// 8
	i1 = _JC_INVOKE_NONVIRTUAL(env, java_util_zip_InflaterInputStream, read$e6b6c87b9f256783, 0, r0, r1, i0, i1);
	_JC_LINE_NUMBER(301);				// 9
	if (i1 >= 0)
		goto label12;
	_JC_LINE_NUMBER(303);				// 10
	r5 = _JC_REF_FIELD(env, r0, java_util_zip_InflaterInputStream, inf);
	z0 = _JC_INVOKE_VIRTUAL(env, java_util_zip_Inflater, finished$026d0895e76fe0dc, r5);
	if (z0 != 0)
		goto label4;
	_JC_LINE_NUMBER(304);				// 11
	r6 = _JC_NEW(env, java_util_zip_ZipException);
	r9 = _JC_STRING(env, "Inflater not finished!?");
	_JC_REF_FIELD(env, r6, java_lang_Throwable, cause) = r6;
	r22 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r6);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, vmState) = r22;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, detailMessage) = r9;
	_JC_THROW(env, r6);

label4:
	_JC_LINE_NUMBER(305);				// 12
	r5 = _JC_REF_FIELD(env, r0, java_util_zip_InflaterInputStream, inf);
	i2 = _JC_INVOKE_VIRTUAL(env, java_util_zip_Inflater, getRemaining$ea62a8f944647e1f, r5);
	_JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, avail) = i2;
	_JC_LINE_NUMBER(306);				// 13
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, flags);
	i2 = i2 & 8;
	if (i2 == 0)
		goto label5;
	_JC_LINE_NUMBER(307);				// 14
	_JC_INVOKE_NONVIRTUAL(env, java_util_zip_ZipInputStream, readDataDescr$8cb728d0cee6cc78, 0, r0);

label5:
	_JC_LINE_NUMBER(309);				// 15
	r5 = _JC_REF_FIELD(env, r0, java_util_zip_InflaterInputStream, inf);
	i2 = _JC_INVOKE_VIRTUAL(env, java_util_zip_Inflater, getTotalIn$3504553dfa702134, r5);
	i3 = _JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, csize);
	if (i2 != i3)
		goto label6;
	r5 = _JC_REF_FIELD(env, r0, java_util_zip_InflaterInputStream, inf);
	i3 = _JC_INVOKE_VIRTUAL(env, java_util_zip_Inflater, getTotalOut$44b05177851c8dbc, r5);
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, size);
	if (i3 == i2)
		goto label7;

label6:
	_JC_LINE_NUMBER(311);				// 16
	r6 = _JC_NEW(env, java_util_zip_ZipException);
	r7 = _JC_NEW(env, java_lang_StringBuffer);
	r26 = _JC_STRING(env, "size mismatch: ");
	i7 = _JC_PRIM_FIELD(env, r26, java_lang_String, count);
	_JC_PRIM_FIELD(env, r7, java_lang_StringBuffer, count) = i7;
	i7 = _JC_PRIM_FIELD(env, r7, java_lang_StringBuffer, count);
	i7 = i7 + 16;
	r27 = _JC_NEW_PRIM_ARRAY(env, char, 1, i7);
	_JC_REF_FIELD(env, r7, java_lang_StringBuffer, value) = r27;
	i7 = _JC_PRIM_FIELD(env, r7, java_lang_StringBuffer, count);
	r27 = _JC_REF_FIELD(env, r7, java_lang_StringBuffer, value);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, getChars$c684dea7317ff063, 0, r26, 0, i7, r27, 0);
	i3 = _JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, csize);
	r13 = _JC_INVOKE_STATIC(env, java_lang_Integer, toString$80d919d12afaaa2b, 0, i3, 10);
	r12 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r7, r13);
	r7 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$9450b16e89f0618d, 1, r12, 59);
	i3 = _JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, size);
	_JC_EXPLICIT_NULL_CHECK(env, r7);
	r15 = _JC_INVOKE_STATIC(env, java_lang_Integer, toString$80d919d12afaaa2b, 1, i3, 10);
	r14 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r7, r15);
	r7 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 1, r14, _JC_STRING(env, " <-> "));
	r5 = _JC_REF_FIELD(env, r0, java_util_zip_InflaterInputStream, inf);
	i3 = _JC_INVOKE_VIRTUAL(env, java_util_zip_Inflater, getTotalIn$3504553dfa702134, r5);
	_JC_EXPLICIT_NULL_CHECK(env, r7);
	r17 = _JC_INVOKE_STATIC(env, java_lang_Integer, toString$80d919d12afaaa2b, 1, i3, 10);
	r16 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r7, r17);
	r7 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$9450b16e89f0618d, 1, r16, 59);
	r5 = _JC_REF_FIELD(env, r0, java_util_zip_InflaterInputStream, inf);
	i3 = _JC_INVOKE_VIRTUAL(env, java_util_zip_Inflater, getTotalOut$44b05177851c8dbc, r5);
	_JC_EXPLICIT_NULL_CHECK(env, r7);
	r19 = _JC_INVOKE_STATIC(env, java_lang_Integer, toString$80d919d12afaaa2b, 1, i3, 10);
	r18 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r7, r19);
	_JC_EXPLICIT_NULL_CHECK(env, r18);
	r20 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r20, r18);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, cause) = r6;
	r23 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r6);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, vmState) = r23;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, detailMessage) = r20;
	_JC_THROW(env, r6);

label7:
	_JC_LINE_NUMBER(312);				// 17
	r5 = _JC_REF_FIELD(env, r0, java_util_zip_InflaterInputStream, inf);
	_JC_INVOKE_VIRTUAL(env, java_util_zip_Inflater, reset$229a80b3e8394a0f, r5);
	_JC_LINE_NUMBER(313);				// 18
	z0 = 1;
	_JC_LINE_NUMBER(315);				// 19
	goto label12;

label8:
	_JC_LINE_NUMBER(319);				// 20
	i3 = _JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, csize);
	if (i1 <= i3)
		goto label9;
	i3 = _JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, csize);
	if (i3 < 0)
		goto label9;
	_JC_LINE_NUMBER(320);				// 21
	i1 = _JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, csize);

label9:
	_JC_LINE_NUMBER(322);				// 22
	i1 = _JC_INVOKE_NONVIRTUAL(env, java_util_zip_ZipInputStream, readBuf$23ceead31f683dbf, 0, r0, r1, i0, i1);
	_JC_LINE_NUMBER(323);				// 23
	if (i1 <= 0)
		goto label10;
	_JC_LINE_NUMBER(325);				// 24
	i3 = _JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, csize);
	i3 = i3 - i1;
	_JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, csize) = i3;
	_JC_LINE_NUMBER(326);				// 25
	i3 = _JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, size);
	i3 = i3 - i1;
	_JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, size) = i3;

label10:
	_JC_LINE_NUMBER(329);				// 26
	i3 = _JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, csize);
	if (i3 != 0)
		goto label11;
	_JC_LINE_NUMBER(330);				// 27
	z0 = 1;
	goto label12;

label11:
	_JC_LINE_NUMBER(331);				// 28
	if (i1 >= 0)
		goto label12;
	_JC_LINE_NUMBER(332);				// 29
	r6 = _JC_NEW(env, java_util_zip_ZipException);
	r10 = _JC_STRING(env, "EOF in stored block");
	_JC_REF_FIELD(env, r6, java_lang_Throwable, cause) = r6;
	r24 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r6);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, vmState) = r24;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, detailMessage) = r10;
	_JC_THROW(env, r6);

label12:
	_JC_LINE_NUMBER(336);				// 30
	if (i1 <= 0)
		goto label13;
	_JC_LINE_NUMBER(337);				// 31
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_ZipInputStream, crc);
	_JC_INVOKE_VIRTUAL(env, java_util_zip_CRC32, update$f73f1b3bfa3ea853, r2, r1, i0, i1);

label13:
	_JC_LINE_NUMBER(339);				// 32
	if (z0 == 0)
		goto label15;
	_JC_LINE_NUMBER(341);				// 33
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_ZipInputStream, crc);
	l4 = _JC_INVOKE_VIRTUAL(env, java_util_zip_CRC32, getValue$738f22e2bb5f71e8, r2);
	l4 = l4 & (_JC_JLONG(4294967295));
	r4 = _JC_REF_FIELD(env, r0, java_util_zip_ZipInputStream, entry);
	l5 = _JC_INVOKE_VIRTUAL(env, java_util_zip_ZipEntry, getCrc$c0e561405d09e30b, r4);
	b6 = _JC_LCMP(l4, l5);
	if (b6 == 0)
		goto label14;
	_JC_LINE_NUMBER(342);				// 34
	r6 = _JC_NEW(env, java_util_zip_ZipException);
	r11 = _JC_STRING(env, "CRC mismatch");
	_JC_REF_FIELD(env, r6, java_lang_Throwable, cause) = r6;
	r25 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r6);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, vmState) = r25;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, detailMessage) = r11;
	_JC_THROW(env, r6);

label14:
	_JC_LINE_NUMBER(343);				// 35
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_ZipInputStream, crc);
	_JC_INVOKE_VIRTUAL(env, java_util_zip_CRC32, reset$229a80b3e8394a0f, r2);
	_JC_LINE_NUMBER(344);				// 36
	_JC_REF_FIELD(env, r0, java_util_zip_ZipInputStream, entry) = _JC_NULL;
	_JC_LINE_NUMBER(345);				// 37
	_JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, entryAtEOF) = 1;

label15:
	_JC_LINE_NUMBER(347);				// 38
	return i1;
}

//
// private final int readBuf(byte[], int, int) throws java.io.IOException
//

static _jc_linenum _jc_java_util_zip_ZipInputStream$linenum_table$readBuf$23ceead31f683dbf[];

static const unsigned char _jc_java_util_zip_ZipInputStream$param_ptypes$readBuf$23ceead31f683dbf[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_INT, _JC_TYPE_INT };

static _jc_type *const _jc_java_util_zip_ZipInputStream$exceptions$readBuf$23ceead31f683dbf[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_java_util_zip_ZipInputStream$param_types$readBuf$23ceead31f683dbf[] = {
	&_jc_byte$array$prim$type,
	&_jc_int$prim$type,
	&_jc_int$prim$type
};

_jc_method _jc_java_util_zip_ZipInputStream$method_info$readBuf$23ceead31f683dbf = {
	.name=			"readBuf",
	.signature=		"([BII)I",
	.class=			&_jc_java_util_zip_ZipInputStream$type,
	.param_types=		&_jc_java_util_zip_ZipInputStream$param_types$readBuf$23ceead31f683dbf,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_java_util_zip_ZipInputStream$param_ptypes$readBuf$23ceead31f683dbf,
	.signature_hash=	_JC_JLONG(0x23ceead31f683dbf),
	.access_flags=		_JC_ACC_PRIVATE|_JC_ACC_FINAL,
	.function=		&_jc_java_util_zip_ZipInputStream$method$readBuf$23ceead31f683dbf,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_util_zip_ZipInputStream$vtable, java_util_zip_ZipInputStream.readBuf$23ceead31f683dbf) / sizeof(void *),
	.num_parameters=	3,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_util_zip_ZipInputStream$exceptions$readBuf$23ceead31f683dbf,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	8,
	      .table=	_jc_java_util_zip_ZipInputStream$linenum_table$readBuf$23ceead31f683dbf
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_util_zip_ZipInputStream, readBuf$23ceead31f683dbf);

jint _JC_JCNI_ATTR
_jc_java_util_zip_ZipInputStream$method$readBuf$23ceead31f683dbf(_jc_env *const env, _jc_java_util_zip_ZipInputStream$object *this, _jc_byte_array *param0, jint param1, jint param2)
{
	jint i0;
	jint i1;
	jint i2;
	jint i3;
	jint i4;
	struct _jc_java_util_zip_ZipInputStream$object *r0;
	_jc_byte_array *r1;
	_jc_byte_array *r2;
	struct _jc_java_io_InputStream$object *r4;
	_jc_byte_array *r5;
	_jc_byte_array *r6;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	i0 = param1;
	i1 = param2;
	_JC_LINE_NUMBER(82);				// 0
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, avail);
	if (i2 > 0)
		goto label0;
	r4 = _JC_REF_FIELD(env, r0, java_io_FilterInputStream, in);
	r5 = _JC_REF_FIELD(env, r0, java_util_zip_InflaterInputStream, buf);
	r6 = _JC_REF_FIELD(env, r0, java_util_zip_InflaterInputStream, buf);
	i4 = _JC_ARRAY_LENGTH(env, r6);
	i4 = _JC_INVOKE_VIRTUAL(env, java_io_InputStream, read$e6b6c87b9f256783, r4, r5, 0, i4);
	_JC_PRIM_FIELD(env, r0, java_util_zip_InflaterInputStream, len) = i4;
	_JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, avail) = i4;
	_JC_LINE_NUMBER(85);				// 1
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, avail);
	if (i2 > 0)
		goto label0;
	_JC_LINE_NUMBER(86);				// 2
	return -1;

label0:
	_JC_LINE_NUMBER(88);				// 3
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, avail);
	if (i1 <= i2)
		goto label1;
	_JC_LINE_NUMBER(89);				// 4
	i1 = _JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, avail);

label1:
	_JC_LINE_NUMBER(90);				// 5
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_InflaterInputStream, buf);
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_InflaterInputStream, len);
	i3 = _JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, avail);
	i3 = i2 - i3;
	_JC_ACTIVE_USE(env, java_lang_System);
	_JC_INVOKE_STATIC(env, java_lang_VMSystem, arraycopy$4286a72d57744cd8, 0, r2, i3, r1, i0, i1);
	_JC_LINE_NUMBER(91);				// 6
	i3 = _JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, avail);
	i3 = i3 - i1;
	_JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, avail) = i3;
	_JC_LINE_NUMBER(92);				// 7
	return i1;
}

//
// private final void readDataDescr() throws java.io.IOException
//

static _jc_linenum _jc_java_util_zip_ZipInputStream$linenum_table$readDataDescr$8cb728d0cee6cc78[];

static const unsigned char _jc_java_util_zip_ZipInputStream$param_ptypes$readDataDescr$8cb728d0cee6cc78[] = { 
_JC_TYPE_VOID };

static _jc_type *const _jc_java_util_zip_ZipInputStream$exceptions$readDataDescr$8cb728d0cee6cc78[] = {
	&_jc_java_io_IOException$type
};

_jc_method _jc_java_util_zip_ZipInputStream$method_info$readDataDescr$8cb728d0cee6cc78 = {
	.name=			"readDataDescr",
	.signature=		"()V",
	.class=			&_jc_java_util_zip_ZipInputStream$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_util_zip_ZipInputStream$param_ptypes$readDataDescr$8cb728d0cee6cc78,
	.signature_hash=	_JC_JLONG(0x8cb728d0cee6cc78),
	.access_flags=		_JC_ACC_PRIVATE|_JC_ACC_FINAL,
	.function=		&_jc_java_util_zip_ZipInputStream$method$readDataDescr$8cb728d0cee6cc78,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_util_zip_ZipInputStream$vtable, java_util_zip_ZipInputStream.readDataDescr$8cb728d0cee6cc78) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_util_zip_ZipInputStream$exceptions$readDataDescr$8cb728d0cee6cc78,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	8,
	      .table=	_jc_java_util_zip_ZipInputStream$linenum_table$readDataDescr$8cb728d0cee6cc78
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_util_zip_ZipInputStream, readDataDescr$8cb728d0cee6cc78);

void _JC_JCNI_ATTR
_jc_java_util_zip_ZipInputStream$method$readDataDescr$8cb728d0cee6cc78(_jc_env *const env, _jc_java_util_zip_ZipInputStream$object *this)
{
	jint i0;
	jlong l1;
	struct _jc_java_util_zip_ZipInputStream$object *r0;
	struct _jc_java_util_zip_ZipException$object *r1;
	struct _jc_java_util_zip_ZipEntry$object *r2;
	struct _jc_java_lang_String$object *r3;
	struct _jc_java_lang_VMThrowable$object *r5;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(205);				// 0
	i0 = _JC_INVOKE_NONVIRTUAL(env, java_util_zip_ZipInputStream, readLeInt$e034ce166156a379, 0, r0);
	if (i0 == 134695760)
		goto label0;
	_JC_LINE_NUMBER(206);				// 1
	r1 = _JC_NEW(env, java_util_zip_ZipException);
	r3 = _JC_STRING(env, "Data descriptor signature not found");
	_JC_REF_FIELD(env, r1, java_lang_Throwable, cause) = r1;
	r5 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r1);
	_JC_REF_FIELD(env, r1, java_lang_Throwable, vmState) = r5;
	_JC_REF_FIELD(env, r1, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r1, java_lang_Throwable, detailMessage) = r3;
	_JC_THROW(env, r1);

label0:
	_JC_LINE_NUMBER(207);				// 2
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_ZipInputStream, entry);
	i0 = _JC_INVOKE_NONVIRTUAL(env, java_util_zip_ZipInputStream, readLeInt$e034ce166156a379, 0, r0);
	l1 = (jlong)i0;
	l1 = l1 & (_JC_JLONG(4294967295));
	_JC_INVOKE_VIRTUAL(env, java_util_zip_ZipEntry, setCrc$6de82408625e4c3f, r2, l1);
	_JC_LINE_NUMBER(208);				// 3
	i0 = _JC_INVOKE_NONVIRTUAL(env, java_util_zip_ZipInputStream, readLeInt$e034ce166156a379, 0, r0);
	_JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, csize) = i0;
	_JC_LINE_NUMBER(209);				// 4
	i0 = _JC_INVOKE_NONVIRTUAL(env, java_util_zip_ZipInputStream, readLeInt$e034ce166156a379, 0, r0);
	_JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, size) = i0;
	_JC_LINE_NUMBER(210);				// 5
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_ZipInputStream, entry);
	i0 = _JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, size);
	l1 = (jlong)i0;
	l1 = l1 & (_JC_JLONG(4294967295));
	_JC_INVOKE_VIRTUAL(env, java_util_zip_ZipEntry, setSize$a8b03df508d7687d, r2, l1);
	_JC_LINE_NUMBER(211);				// 6
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_ZipInputStream, entry);
	i0 = _JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, csize);
	l1 = (jlong)i0;
	l1 = l1 & (_JC_JLONG(4294967295));
	_JC_INVOKE_VIRTUAL(env, java_util_zip_ZipEntry, setCompressedSize$a291408ca1bb65e7, r2, l1);
	_JC_LINE_NUMBER(212);				// 7
	return;
}

//
// private final void readFully(byte[]) throws java.io.IOException
//

static _jc_linenum _jc_java_util_zip_ZipInputStream$linenum_table$readFully$2c917249902aa549[];

static const unsigned char _jc_java_util_zip_ZipInputStream$param_ptypes$readFully$2c917249902aa549[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_util_zip_ZipInputStream$exceptions$readFully$2c917249902aa549[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_java_util_zip_ZipInputStream$param_types$readFully$2c917249902aa549[] = {
	&_jc_byte$array$prim$type
};

_jc_method _jc_java_util_zip_ZipInputStream$method_info$readFully$2c917249902aa549 = {
	.name=			"readFully",
	.signature=		"([B)V",
	.class=			&_jc_java_util_zip_ZipInputStream$type,
	.param_types=		&_jc_java_util_zip_ZipInputStream$param_types$readFully$2c917249902aa549,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_util_zip_ZipInputStream$param_ptypes$readFully$2c917249902aa549,
	.signature_hash=	_JC_JLONG(0x2c917249902aa549),
	.access_flags=		_JC_ACC_PRIVATE|_JC_ACC_FINAL,
	.function=		&_jc_java_util_zip_ZipInputStream$method$readFully$2c917249902aa549,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_util_zip_ZipInputStream$vtable, java_util_zip_ZipInputStream.readFully$2c917249902aa549) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_util_zip_ZipInputStream$exceptions$readFully$2c917249902aa549,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	10,
	      .table=	_jc_java_util_zip_ZipInputStream$linenum_table$readFully$2c917249902aa549
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_util_zip_ZipInputStream, readFully$2c917249902aa549);

void _JC_JCNI_ATTR
_jc_java_util_zip_ZipInputStream$method$readFully$2c917249902aa549(_jc_env *const env, _jc_java_util_zip_ZipInputStream$object *this, _jc_byte_array *param0)
{
	jint i0;
	jint i1;
	jint i2;
	struct _jc_java_util_zip_ZipInputStream$object *r0;
	_jc_byte_array *r1;
	struct _jc_java_io_EOFException$object *r2;
	struct _jc_java_lang_String$object *r3;
	struct _jc_java_lang_VMThrowable$object *r5;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(97);				// 0
	i0 = 0;
	_JC_LINE_NUMBER(98);				// 1
	i1 = _JC_ARRAY_LENGTH(env, r1);
	_JC_LINE_NUMBER(99);				// 2
	goto label2;

label0:
	_JC_LINE_NUMBER(101);				// 3
	i2 = _JC_INVOKE_NONVIRTUAL(env, java_util_zip_ZipInputStream, readBuf$23ceead31f683dbf, 0, r0, r1, i0, i1);
	_JC_LINE_NUMBER(102);				// 4
	if (i2 != -1)
		goto label1;
	_JC_LINE_NUMBER(103);				// 5
	r2 = _JC_NEW(env, java_io_EOFException);
	r3 = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, cause) = r2;
	r5 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r2);
	_JC_REF_FIELD(env, r2, java_lang_Throwable, vmState) = r5;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, detailMessage) = r3;
	_JC_THROW(env, r2);

label1:
	_JC_LINE_NUMBER(104);				// 6
	i0 = i0 + i2;
	_JC_LINE_NUMBER(105);				// 7
	i1 = i1 - i2;

label2:
	_JC_LINE_NUMBER(99);				// 8
	if (i1 > 0) {
		_JC_PERIODIC_CHECK(env);
		goto label0;
	}
	_JC_LINE_NUMBER(107);				// 9
	return;
}

//
// private final int readLeByte() throws java.io.IOException
//

static _jc_linenum _jc_java_util_zip_ZipInputStream$linenum_table$readLeByte$4d38b4eec2855c73[];

static const unsigned char _jc_java_util_zip_ZipInputStream$param_ptypes$readLeByte$4d38b4eec2855c73[] = { 
_JC_TYPE_INT };

static _jc_type *const _jc_java_util_zip_ZipInputStream$exceptions$readLeByte$4d38b4eec2855c73[] = {
	&_jc_java_io_IOException$type
};

_jc_method _jc_java_util_zip_ZipInputStream$method_info$readLeByte$4d38b4eec2855c73 = {
	.name=			"readLeByte",
	.signature=		"()I",
	.class=			&_jc_java_util_zip_ZipInputStream$type,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_java_util_zip_ZipInputStream$param_ptypes$readLeByte$4d38b4eec2855c73,
	.signature_hash=	_JC_JLONG(0x4d38b4eec2855c73),
	.access_flags=		_JC_ACC_PRIVATE|_JC_ACC_FINAL,
	.function=		&_jc_java_util_zip_ZipInputStream$method$readLeByte$4d38b4eec2855c73,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_util_zip_ZipInputStream$vtable, java_util_zip_ZipInputStream.readLeByte$4d38b4eec2855c73) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_util_zip_ZipInputStream$exceptions$readLeByte$4d38b4eec2855c73,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_java_util_zip_ZipInputStream$linenum_table$readLeByte$4d38b4eec2855c73
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_util_zip_ZipInputStream, readLeByte$4d38b4eec2855c73);

jint _JC_JCNI_ATTR
_jc_java_util_zip_ZipInputStream$method$readLeByte$4d38b4eec2855c73(_jc_env *const env, _jc_java_util_zip_ZipInputStream$object *this)
{
	jbyte b3;
	jint i0;
	jint i1;
	jint i2;
	jint i5;
	struct _jc_java_util_zip_ZipInputStream$object *r0;
	struct _jc_java_util_zip_ZipException$object *r1;
	_jc_byte_array *r2;
	struct _jc_java_lang_String$object *r3;
	struct _jc_java_lang_VMThrowable$object *r4;
	struct _jc_java_io_InputStream$object *r6;
	_jc_byte_array *r7;
	_jc_byte_array *r8;
	jshort s4;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(111);				// 0
	i0 = _JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, avail);
	if (i0 > 0)
		goto label0;
	r6 = _JC_REF_FIELD(env, r0, java_io_FilterInputStream, in);
	r7 = _JC_REF_FIELD(env, r0, java_util_zip_InflaterInputStream, buf);
	r8 = _JC_REF_FIELD(env, r0, java_util_zip_InflaterInputStream, buf);
	i5 = _JC_ARRAY_LENGTH(env, r8);
	i5 = _JC_INVOKE_VIRTUAL(env, java_io_InputStream, read$e6b6c87b9f256783, r6, r7, 0, i5);
	_JC_PRIM_FIELD(env, r0, java_util_zip_InflaterInputStream, len) = i5;
	_JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, avail) = i5;
	_JC_LINE_NUMBER(114);				// 1
	i0 = _JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, avail);
	if (i0 > 0)
		goto label0;
	_JC_LINE_NUMBER(115);				// 2
	r1 = _JC_NEW(env, java_util_zip_ZipException);
	r3 = _JC_STRING(env, "EOF in header");
	_JC_REF_FIELD(env, r1, java_lang_Throwable, cause) = r1;
	r4 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r1);
	_JC_REF_FIELD(env, r1, java_lang_Throwable, vmState) = r4;
	_JC_REF_FIELD(env, r1, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r1, java_lang_Throwable, detailMessage) = r3;
	_JC_THROW(env, r1);

label0:
	_JC_LINE_NUMBER(117);				// 3
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_InflaterInputStream, buf);
	i1 = _JC_PRIM_FIELD(env, r0, java_util_zip_InflaterInputStream, len);
	i0 = _JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, avail);
	i2 = i0 - 1;
	_JC_PRIM_FIELD(env, r0, java_util_zip_ZipInputStream, avail) = i2;
	i2 = i1 - i0;
	b3 = _JC_PRIM_ELEMENT(env, byte, r2, i2, 1, 1);
	s4 = b3 & 255;
	return s4;
}

//
// private final int readLeInt() throws java.io.IOException
//

static _jc_linenum _jc_java_util_zip_ZipInputStream$linenum_table$readLeInt$e034ce166156a379[];

static const unsigned char _jc_java_util_zip_ZipInputStream$param_ptypes$readLeInt$e034ce166156a379[] = { 
_JC_TYPE_INT };

static _jc_type *const _jc_java_util_zip_ZipInputStream$exceptions$readLeInt$e034ce166156a379[] = {
	&_jc_java_io_IOException$type
};

_jc_method _jc_java_util_zip_ZipInputStream$method_info$readLeInt$e034ce166156a379 = {
	.name=			"readLeInt",
	.signature=		"()I",
	.class=			&_jc_java_util_zip_ZipInputStream$type,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_java_util_zip_ZipInputStream$param_ptypes$readLeInt$e034ce166156a379,
	.signature_hash=	_JC_JLONG(0xe034ce166156a379),
	.access_flags=		_JC_ACC_PRIVATE|_JC_ACC_FINAL,
	.function=		&_jc_java_util_zip_ZipInputStream$method$readLeInt$e034ce166156a379,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_util_zip_ZipInputStream$vtable, java_util_zip_ZipInputStream.readLeInt$e034ce166156a379) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_util_zip_ZipInputStream$exceptions$readLeInt$e034ce166156a379,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_util_zip_ZipInputStream$linenum_table$readLeInt$e034ce166156a379
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_util_zip_ZipInputStream, readLeInt$e034ce166156a379);

jint _JC_JCNI_ATTR
_jc_java_util_zip_ZipInputStream$method$readLeInt$e034ce166156a379(_jc_env *const env, _jc_java_util_zip_ZipInputStream$object *this)
{
	jint i0;
	jint i1;
	jint i2;
	jint i3;
	jint i4;
	struct _jc_java_util_zip_ZipInputStream$object *r0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	i1 = _JC_INVOKE_NONVIRTUAL(env, java_util_zip_ZipInputStream, readLeByte$4d38b4eec2855c73, 0, r0);
	i2 = _JC_INVOKE_NONVIRTUAL(env, java_util_zip_ZipInputStream, readLeByte$4d38b4eec2855c73, 0, r0);
	i2 = i2 << (8 & 0x1f);
	i2 = i1 | i2;
	i3 = _JC_INVOKE_NONVIRTUAL(env, java_util_zip_ZipInputStream, readLeByte$4d38b4eec2855c73, 0, r0);
	i4 = _JC_INVOKE_NONVIRTUAL(env, java_util_zip_ZipInputStream, readLeByte$4d38b4eec2855c73, 0, r0);
	i4 = i4 << (8 & 0x1f);
	i4 = i3 | i4;
	_JC_LINE_NUMBER(133);				// 0
	i0 = i4 << (16 & 0x1f);
	i0 = i2 | i0;
	return i0;
}

//
// private final int readLeShort() throws java.io.IOException
//

static _jc_linenum _jc_java_util_zip_ZipInputStream$linenum_table$readLeShort$c1a6b9f4014ef222[];

static const unsigned char _jc_java_util_zip_ZipInputStream$param_ptypes$readLeShort$c1a6b9f4014ef222[] = { 
_JC_TYPE_INT };

static _jc_type *const _jc_java_util_zip_ZipInputStream$exceptions$readLeShort$c1a6b9f4014ef222[] = {
	&_jc_java_io_IOException$type
};

_jc_method _jc_java_util_zip_ZipInputStream$method_info$readLeShort$c1a6b9f4014ef222 = {
	.name=			"readLeShort",
	.signature=		"()I",
	.class=			&_jc_java_util_zip_ZipInputStream$type,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_java_util_zip_ZipInputStream$param_ptypes$readLeShort$c1a6b9f4014ef222,
	.signature_hash=	_JC_JLONG(0xc1a6b9f4014ef222),
	.access_flags=		_JC_ACC_PRIVATE|_JC_ACC_FINAL,
	.function=		&_jc_java_util_zip_ZipInputStream$method$readLeShort$c1a6b9f4014ef222,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_util_zip_ZipInputStream$vtable, java_util_zip_ZipInputStream.readLeShort$c1a6b9f4014ef222) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_util_zip_ZipInputStream$exceptions$readLeShort$c1a6b9f4014ef222,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_util_zip_ZipInputStream$linenum_table$readLeShort$c1a6b9f4014ef222
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_util_zip_ZipInputStream, readLeShort$c1a6b9f4014ef222);

jint _JC_JCNI_ATTR
_jc_java_util_zip_ZipInputStream$method$readLeShort$c1a6b9f4014ef222(_jc_env *const env, _jc_java_util_zip_ZipInputStream$object *this)
{
	jint i0;
	jint i1;
	struct _jc_java_util_zip_ZipInputStream$object *r0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(125);				// 0
	i0 = _JC_INVOKE_NONVIRTUAL(env, java_util_zip_ZipInputStream, readLeByte$4d38b4eec2855c73, 0, r0);
	i1 = _JC_INVOKE_NONVIRTUAL(env, java_util_zip_ZipInputStream, readLeByte$4d38b4eec2855c73, 0, r0);
	i1 = i1 << (8 & 0x1f);
	i1 = i0 | i1;
	return i1;
}

//
// private final void this()
//

static _jc_linenum _jc_java_util_zip_ZipInputStream$linenum_table$this$adc93fb6bf4cbffa[];

static const unsigned char _jc_java_util_zip_ZipInputStream$param_ptypes$this$adc93fb6bf4cbffa[] = { 
_JC_TYPE_VOID };

_jc_method _jc_java_util_zip_ZipInputStream$method_info$this$adc93fb6bf4cbffa = {
	.name=			"this",
	.signature=		"()V",
	.class=			&_jc_java_util_zip_ZipInputStream$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_util_zip_ZipInputStream$param_ptypes$this$adc93fb6bf4cbffa,
	.signature_hash=	_JC_JLONG(0xadc93fb6bf4cbffa),
	.access_flags=		_JC_ACC_PRIVATE|_JC_ACC_FINAL,
	.function=		&_jc_java_util_zip_ZipInputStream$method$this$adc93fb6bf4cbffa,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_util_zip_ZipInputStream$vtable, java_util_zip_ZipInputStream.this$adc93fb6bf4cbffa) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_util_zip_ZipInputStream$linenum_table$this$adc93fb6bf4cbffa
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_util_zip_ZipInputStream, this$adc93fb6bf4cbffa);

void _JC_JCNI_ATTR
_jc_java_util_zip_ZipInputStream$method$this$adc93fb6bf4cbffa(_jc_env *const env, _jc_java_util_zip_ZipInputStream$object *this)
{
	struct _jc_java_util_zip_ZipInputStream$object *r0;
	struct _jc_java_util_zip_CRC32$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(57);				// 0
	r1 = _JC_NEW(env, java_util_zip_CRC32);
	_JC_PRIM_FIELD(env, r1, java_util_zip_CRC32, crc) = 0;
	_JC_REF_FIELD(env, r0, java_util_zip_ZipInputStream, crc) = r1;
	_JC_LINE_NUMBER(58);				// 1
	_JC_REF_FIELD(env, r0, java_util_zip_ZipInputStream, entry) = _JC_NULL;
	return;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_java_util_zip_ZipInputStream$methods[] = {
	&_jc_java_util_zip_ZipInputStream$method_info$_init$3887600c17c5e554,
	&_jc_java_util_zip_ZipInputStream$method_info$available$81975cc608605037,
	&_jc_java_util_zip_ZipInputStream$method_info$close$6aba8b329fddcd79,
	&_jc_java_util_zip_ZipInputStream$method_info$closeEntry$9060a01a67213941,
	&_jc_java_util_zip_ZipInputStream$method_info$createZipEntry$3e6190033d3b6bac,
	&_jc_java_util_zip_ZipInputStream$method_info$fillBuf$832c8ac6e4b87cb3,
	&_jc_java_util_zip_ZipInputStream$method_info$getNextEntry$37c60ebf27303f95,
	&_jc_java_util_zip_ZipInputStream$method_info$read$1a981297cb524963,
	&_jc_java_util_zip_ZipInputStream$method_info$read$e6b6c87b9f256783,
	&_jc_java_util_zip_ZipInputStream$method_info$readBuf$23ceead31f683dbf,
	&_jc_java_util_zip_ZipInputStream$method_info$readDataDescr$8cb728d0cee6cc78,
	&_jc_java_util_zip_ZipInputStream$method_info$readFully$2c917249902aa549,
	&_jc_java_util_zip_ZipInputStream$method_info$readLeByte$4d38b4eec2855c73,
	&_jc_java_util_zip_ZipInputStream$method_info$readLeInt$e034ce166156a379,
	&_jc_java_util_zip_ZipInputStream$method_info$readLeShort$c1a6b9f4014ef222,
	&_jc_java_util_zip_ZipInputStream$method_info$this$adc93fb6bf4cbffa
};

/************************************************************************
 *			      Interface list				*
 ************************************************************************/

// Directly implemented interfaces
static _jc_type *const _jc_java_util_zip_ZipInputStream$interfaces[] = {
	&_jc_java_util_zip_ZipConstants$type
};

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_java_util_zip_ZipInputStream$instanceof_hash_bucket_32[] = {
	&_jc_java_util_zip_InflaterInputStream$type,
	_JC_NULL
};
static _jc_type *const _jc_java_util_zip_ZipInputStream$instanceof_hash_bucket_34[] = {
	&_jc_java_util_zip_ZipInputStream$type,
	_JC_NULL
};
static _jc_type *const _jc_java_util_zip_ZipInputStream$instanceof_hash_bucket_68[] = {
	&_jc_java_io_InputStream$type,
	_JC_NULL
};
static _jc_type *const _jc_java_util_zip_ZipInputStream$instanceof_hash_bucket_78[] = {
	&_jc_java_util_zip_ZipConstants$type,
	_JC_NULL
};
static _jc_type *const _jc_java_util_zip_ZipInputStream$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};
static _jc_type *const _jc_java_util_zip_ZipInputStream$instanceof_hash_bucket_126[] = {
	&_jc_java_io_FilterInputStream$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_java_util_zip_ZipInputStream$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[32]=	_jc_java_util_zip_ZipInputStream$instanceof_hash_bucket_32,
	[34]=	_jc_java_util_zip_ZipInputStream$instanceof_hash_bucket_34,
	[68]=	_jc_java_util_zip_ZipInputStream$instanceof_hash_bucket_68,
	[78]=	_jc_java_util_zip_ZipInputStream$instanceof_hash_bucket_78,
	[101]=	_jc_java_util_zip_ZipInputStream$instanceof_hash_bucket_101,
	[126]=	_jc_java_util_zip_ZipInputStream$instanceof_hash_bucket_126
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_java_util_zip_ZipInputStream$class_depends[] = {
	{ "java/io/EOFException",	_JC_JLONG(0xcaf39081f5f70fef) },
	{ "java/io/FilterInputStream",	_JC_JLONG(0x455accfa535f5dfe) },
	{ "java/io/IOException",	_JC_JLONG(0x4e0a56550c69d57c) },
	{ "java/io/InputStream",	_JC_JLONG(0x66aea4d152614ac4) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/Integer",	_JC_JLONG(0xca631501391a31f1) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/StringBuffer",	_JC_JLONG(0x94d357637b968dda) },
	{ "java/lang/System",	_JC_JLONG(0x53cc8e2333795f04) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMSystem",	_JC_JLONG(0x4d1cebae0bdda058) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/util/zip/CRC32",	_JC_JLONG(0xd31dc884497a5da2) },
	{ "java/util/zip/Inflater",	_JC_JLONG(0x4df3e1cb79f6b935) },
	{ "java/util/zip/InflaterInputStream",	_JC_JLONG(0x5602700a47802920) },
	{ "java/util/zip/ZipConstants",	_JC_JLONG(0xa34b4b893bb9fdce) },
	{ "java/util/zip/ZipEntry",	_JC_JLONG(0x1645f313fb808b9f) },
	{ "java/util/zip/ZipException",	_JC_JLONG(0xcd59cf72c34ef3f3) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_java_util_zip_ZipInputStream$vtype _jc_java_util_zip_ZipInputStream$type = {
    .type= {
	.name=			"java/util/zip/ZipInputStream",
	.superclass=		&_jc_java_util_zip_InflaterInputStream$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.num_interfaces=sizeof(_jc_java_util_zip_ZipInputStream$interfaces) / sizeof(*_jc_java_util_zip_ZipInputStream$interfaces),
	.interfaces=		_jc_java_util_zip_ZipInputStream$interfaces,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		54,
		.hash=			_JC_JLONG(0x6587d25494e415a2),
		.source_file=		"ZipInputStream.java",
		.instance_size=		sizeof(_jc_java_util_zip_ZipInputStream$refs) + sizeof(_jc_java_util_zip_ZipInputStream$object),
		.num_virtual_refs=	6,
		.num_fields=		sizeof(_jc_java_util_zip_ZipInputStream$fields) / sizeof(*_jc_java_util_zip_ZipInputStream$fields),
		.fields=		_jc_java_util_zip_ZipInputStream$fields,
		.num_methods=		sizeof(_jc_java_util_zip_ZipInputStream$methods) / sizeof(*_jc_java_util_zip_ZipInputStream$methods),
		.methods=		_jc_java_util_zip_ZipInputStream$methods,
		.instanceof_hash_table=	_jc_java_util_zip_ZipInputStream$instanceof_hash_table,
		.num_class_depends=		sizeof(_jc_java_util_zip_ZipInputStream$class_depends) / sizeof(*_jc_java_util_zip_ZipInputStream$class_depends),
		.class_depends=		_jc_java_util_zip_ZipInputStream$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.java_io_InputStream= {
	    .available$81975cc608605037=			// overridden
		&_jc_java_util_zip_ZipInputStream$method$available$81975cc608605037,
	    .close$6aba8b329fddcd79=			// overridden
		&_jc_java_util_zip_ZipInputStream$method$close$6aba8b329fddcd79,
	    .mark$422af117ab27d9db=				// overridden
		&_jc_java_util_zip_InflaterInputStream$method$mark$422af117ab27d9db,
	    .markSupported$66435a81b7b2f2dc=		// overridden
		&_jc_java_util_zip_InflaterInputStream$method$markSupported$66435a81b7b2f2dc,
	    .read$1a981297cb524963=				// overridden
		&_jc_java_util_zip_ZipInputStream$method$read$1a981297cb524963,
	    .read$c38dd905b7fb8654=				// overridden
		&_jc_java_io_FilterInputStream$method$read$c38dd905b7fb8654,
	    .read$e6b6c87b9f256783=				// overridden
		&_jc_java_util_zip_ZipInputStream$method$read$e6b6c87b9f256783,
	    .reset$229a80b3e8394a0f=			// overridden
		&_jc_java_util_zip_InflaterInputStream$method$reset$229a80b3e8394a0f,
	    .skip$4e431136b5c4614a=				// overridden
		&_jc_java_util_zip_InflaterInputStream$method$skip$4e431136b5c4614a,
	},
	.java_io_FilterInputStream= {
	    .available$81975cc608605037=			// overridden
		&_jc_java_util_zip_ZipInputStream$method$available$81975cc608605037,
	    .close$6aba8b329fddcd79=			// overridden
		&_jc_java_util_zip_ZipInputStream$method$close$6aba8b329fddcd79,
	    .mark$422af117ab27d9db=				// overridden
		&_jc_java_util_zip_InflaterInputStream$method$mark$422af117ab27d9db,
	    .markSupported$66435a81b7b2f2dc=		// overridden
		&_jc_java_util_zip_InflaterInputStream$method$markSupported$66435a81b7b2f2dc,
	    .read$1a981297cb524963=				// overridden
		&_jc_java_util_zip_ZipInputStream$method$read$1a981297cb524963,
	    .read$c38dd905b7fb8654=
		&_jc_java_io_FilterInputStream$method$read$c38dd905b7fb8654,
	    .read$e6b6c87b9f256783=				// overridden
		&_jc_java_util_zip_ZipInputStream$method$read$e6b6c87b9f256783,
	    .reset$229a80b3e8394a0f=			// overridden
		&_jc_java_util_zip_InflaterInputStream$method$reset$229a80b3e8394a0f,
	    .skip$4e431136b5c4614a=				// overridden
		&_jc_java_util_zip_InflaterInputStream$method$skip$4e431136b5c4614a,
	},
	.java_util_zip_InflaterInputStream= {
	    .available$81975cc608605037=			// overridden
		&_jc_java_util_zip_ZipInputStream$method$available$81975cc608605037,
	    .close$6aba8b329fddcd79=			// overridden
		&_jc_java_util_zip_ZipInputStream$method$close$6aba8b329fddcd79,
	    .fill$144e1686cbd31ab8=
		&_jc_java_util_zip_InflaterInputStream$method$fill$144e1686cbd31ab8,
	    .mark$422af117ab27d9db=
		&_jc_java_util_zip_InflaterInputStream$method$mark$422af117ab27d9db,
	    .markSupported$66435a81b7b2f2dc=
		&_jc_java_util_zip_InflaterInputStream$method$markSupported$66435a81b7b2f2dc,
	    .read$1a981297cb524963=				// overridden
		&_jc_java_util_zip_ZipInputStream$method$read$1a981297cb524963,
	    .read$e6b6c87b9f256783=				// overridden
		&_jc_java_util_zip_ZipInputStream$method$read$e6b6c87b9f256783,
	    .reset$229a80b3e8394a0f=
		&_jc_java_util_zip_InflaterInputStream$method$reset$229a80b3e8394a0f,
	    .skip$4e431136b5c4614a=
		&_jc_java_util_zip_InflaterInputStream$method$skip$4e431136b5c4614a,
	    .this$adc93fb6bf4cbffa=				// overridden
		&_jc_java_util_zip_ZipInputStream$method$this$adc93fb6bf4cbffa,
	},
	.java_util_zip_ZipInputStream= {
	    .available$81975cc608605037=
		&_jc_java_util_zip_ZipInputStream$method$available$81975cc608605037,
	    .close$6aba8b329fddcd79=
		&_jc_java_util_zip_ZipInputStream$method$close$6aba8b329fddcd79,
	    .closeEntry$9060a01a67213941=
		&_jc_java_util_zip_ZipInputStream$method$closeEntry$9060a01a67213941,
	    .createZipEntry$3e6190033d3b6bac=
		&_jc_java_util_zip_ZipInputStream$method$createZipEntry$3e6190033d3b6bac,
	    .fillBuf$832c8ac6e4b87cb3=
		&_jc_java_util_zip_ZipInputStream$method$fillBuf$832c8ac6e4b87cb3,
	    .getNextEntry$37c60ebf27303f95=
		&_jc_java_util_zip_ZipInputStream$method$getNextEntry$37c60ebf27303f95,
	    .read$1a981297cb524963=
		&_jc_java_util_zip_ZipInputStream$method$read$1a981297cb524963,
	    .read$e6b6c87b9f256783=
		&_jc_java_util_zip_ZipInputStream$method$read$e6b6c87b9f256783,
	    .readBuf$23ceead31f683dbf=
		&_jc_java_util_zip_ZipInputStream$method$readBuf$23ceead31f683dbf,
	    .readDataDescr$8cb728d0cee6cc78=
		&_jc_java_util_zip_ZipInputStream$method$readDataDescr$8cb728d0cee6cc78,
	    .readFully$2c917249902aa549=
		&_jc_java_util_zip_ZipInputStream$method$readFully$2c917249902aa549,
	    .readLeByte$4d38b4eec2855c73=
		&_jc_java_util_zip_ZipInputStream$method$readLeByte$4d38b4eec2855c73,
	    .readLeInt$e034ce166156a379=
		&_jc_java_util_zip_ZipInputStream$method$readLeInt$e034ce166156a379,
	    .readLeShort$c1a6b9f4014ef222=
		&_jc_java_util_zip_ZipInputStream$method$readLeShort$c1a6b9f4014ef222,
	    .this$adc93fb6bf4cbffa=
		&_jc_java_util_zip_ZipInputStream$method$this$adc93fb6bf4cbffa,
	},
    }
};

