// public class javax.crypto.Cipher

// class file dependencies
// @dep_class f4ba095546954b36 gnu_java_security_Engine
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class b7e704701c278e65 java_lang_IllegalStateException
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class 4f5534a987354d1d java_lang_RuntimeException
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 94d357637b968dda java_lang_StringBuffer
// @dep_class 53cc8e2333795f04 java_lang_System
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class 4d1cebae0bdda058 java_lang_VMSystem
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class 814794c0d977019 java_security_AlgorithmParameters
// @dep_class 692089051f4c8d0b java_security_GeneralSecurityException
// @dep_class 327edce29f2562dd java_security_InvalidAlgorithmParameterException
// @dep_class 94dda41e9bf6c170 java_security_InvalidKeyException
// @dep_class a467c6cd05d9cc51 java_security_Key
// @dep_class 965d036f0f33fac6 java_security_KeyException
// @dep_class 22e937c2536160b4 java_security_NoSuchAlgorithmException
// @dep_class 8dfbf242adab91e java_security_NoSuchProviderException
// @dep_class 81b073051aa30acc java_security_Provider
// @dep_class 4db3ac05e70e2bf8 java_security_PublicKey
// @dep_class 15c6a62b25a6e96d java_security_SecureRandom
// @dep_class 89bf77984bd9669e java_security_Security
// @dep_class c98c8192da849b07 java_security_cert_Certificate
// @dep_class 859e5e5544e5909f java_security_cert_X509Certificate
// @dep_class ef2e5e8af121478f java_security_spec_AlgorithmParameterSpec
// @dep_class b106445ca218ee16 java_util_StringTokenizer
// @dep_class c53e1575b095109b java_util_Vector
// @dep_class d214adbc7b3842af javax_crypto_BadPaddingException
// @dep_class 4bdfff9ea145d6ce javax_crypto_Cipher
// @dep_class 4422f11229f63761 javax_crypto_CipherSpi
// @dep_class 9390fe3e28a7a8c5 javax_crypto_ExemptionMechanism
// @dep_class e7376936288e78db javax_crypto_IllegalBlockSizeException
// @dep_class ec431dca39b80623 javax_crypto_NoSuchPaddingException
// @dep_class d79a62a9328ccea1 javax_crypto_ShortBufferException

// header file dependencies
// @dep_header gnu_java_security_Engine
// @dep_header java_lang_Class
// @dep_header java_lang_IllegalStateException
// @dep_header java_lang_String
// @dep_header java_lang_StringBuffer
// @dep_header java_lang_System
// @dep_header java_lang_VMSystem
// @dep_header java_lang_VMThrowable
// @dep_header java_security_AlgorithmParameters
// @dep_header java_security_InvalidAlgorithmParameterException
// @dep_header java_security_InvalidKeyException
// @dep_header java_security_Key
// @dep_header java_security_NoSuchAlgorithmException
// @dep_header java_security_NoSuchProviderException
// @dep_header java_security_Provider
// @dep_header java_security_PublicKey
// @dep_header java_security_SecureRandom
// @dep_header java_security_Security
// @dep_header java_security_cert_X509Certificate
// @dep_header java_security_spec_AlgorithmParameterSpec
// @dep_header java_util_StringTokenizer
// @dep_header java_util_Vector
// @dep_header javax_crypto_BadPaddingException
// @dep_header javax_crypto_Cipher
// @dep_header javax_crypto_CipherSpi
// @dep_header javax_crypto_ExemptionMechanism
// @dep_header javax_crypto_IllegalBlockSizeException
// @dep_header javax_crypto_NoSuchPaddingException
// @dep_header javax_crypto_ShortBufferException

#include "jc_defs.h"

#include "gnu/java/security/Engine.h"
#include "java/lang/Class.h"
#include "java/lang/IllegalStateException.h"
#include "java/lang/String.h"
#include "java/lang/StringBuffer.h"
#include "java/lang/System.h"
#include "java/lang/VMSystem.h"
#include "java/lang/VMThrowable.h"
#include "java/security/AlgorithmParameters.h"
#include "java/security/InvalidAlgorithmParameterException.h"
#include "java/security/InvalidKeyException.h"
#include "java/security/Key.h"
#include "java/security/NoSuchAlgorithmException.h"
#include "java/security/NoSuchProviderException.h"
#include "java/security/Provider.h"
#include "java/security/PublicKey.h"
#include "java/security/SecureRandom.h"
#include "java/security/Security.h"
#include "java/security/cert/X509Certificate.h"
#include "java/security/spec/AlgorithmParameterSpec.h"
#include "java/util/StringTokenizer.h"
#include "java/util/Vector.h"
#include "javax/crypto/BadPaddingException.h"
#include "javax/crypto/Cipher.h"
#include "javax/crypto/CipherSpi.h"
#include "javax/crypto/ExemptionMechanism.h"
#include "javax/crypto/IllegalBlockSizeException.h"
#include "javax/crypto/NoSuchPaddingException.h"
#include "javax/crypto/ShortBufferException.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// private static final java.lang.String SERVICE
static _jc_field _jc_javax_crypto_Cipher$field_info$SERVICE = {
	.name=		"SERVICE",
	.signature=	"Ljava/lang/String;",
	.class=		&_jc_javax_crypto_Cipher$type,
	.type=		&_jc_java_lang_String$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_Cipher$fields_struct, SERVICE),
	.initial_value=	"Cipher",
};

// public static final int DECRYPT_MODE
static const jint _jc_javax_crypto_Cipher$initial_value$DECRYPT__5fMODE = 2;
static _jc_field _jc_javax_crypto_Cipher$field_info$DECRYPT__5fMODE = {
	.name=		"DECRYPT_MODE",
	.signature=	"I",
	.class=		&_jc_javax_crypto_Cipher$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PUBLIC|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_Cipher$fields_struct, DECRYPT__5fMODE),
	.initial_value=	&_jc_javax_crypto_Cipher$initial_value$DECRYPT__5fMODE,
};

// public static final int ENCRYPT_MODE
static const jint _jc_javax_crypto_Cipher$initial_value$ENCRYPT__5fMODE = 1;
static _jc_field _jc_javax_crypto_Cipher$field_info$ENCRYPT__5fMODE = {
	.name=		"ENCRYPT_MODE",
	.signature=	"I",
	.class=		&_jc_javax_crypto_Cipher$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PUBLIC|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_Cipher$fields_struct, ENCRYPT__5fMODE),
	.initial_value=	&_jc_javax_crypto_Cipher$initial_value$ENCRYPT__5fMODE,
};

// public static final int PRIVATE_KEY
static const jint _jc_javax_crypto_Cipher$initial_value$PRIVATE__5fKEY = 2;
static _jc_field _jc_javax_crypto_Cipher$field_info$PRIVATE__5fKEY = {
	.name=		"PRIVATE_KEY",
	.signature=	"I",
	.class=		&_jc_javax_crypto_Cipher$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PUBLIC|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_Cipher$fields_struct, PRIVATE__5fKEY),
	.initial_value=	&_jc_javax_crypto_Cipher$initial_value$PRIVATE__5fKEY,
};

// public static final int PUBLIC_KEY
static const jint _jc_javax_crypto_Cipher$initial_value$PUBLIC__5fKEY = 1;
static _jc_field _jc_javax_crypto_Cipher$field_info$PUBLIC__5fKEY = {
	.name=		"PUBLIC_KEY",
	.signature=	"I",
	.class=		&_jc_javax_crypto_Cipher$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PUBLIC|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_Cipher$fields_struct, PUBLIC__5fKEY),
	.initial_value=	&_jc_javax_crypto_Cipher$initial_value$PUBLIC__5fKEY,
};

// public static final int SECRET_KEY
static const jint _jc_javax_crypto_Cipher$initial_value$SECRET__5fKEY = 3;
static _jc_field _jc_javax_crypto_Cipher$field_info$SECRET__5fKEY = {
	.name=		"SECRET_KEY",
	.signature=	"I",
	.class=		&_jc_javax_crypto_Cipher$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PUBLIC|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_Cipher$fields_struct, SECRET__5fKEY),
	.initial_value=	&_jc_javax_crypto_Cipher$initial_value$SECRET__5fKEY,
};

// public static final int UNWRAP_MODE
static const jint _jc_javax_crypto_Cipher$initial_value$UNWRAP__5fMODE = 4;
static _jc_field _jc_javax_crypto_Cipher$field_info$UNWRAP__5fMODE = {
	.name=		"UNWRAP_MODE",
	.signature=	"I",
	.class=		&_jc_javax_crypto_Cipher$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PUBLIC|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_Cipher$fields_struct, UNWRAP__5fMODE),
	.initial_value=	&_jc_javax_crypto_Cipher$initial_value$UNWRAP__5fMODE,
};

// public static final int WRAP_MODE
static const jint _jc_javax_crypto_Cipher$initial_value$WRAP__5fMODE = 3;
static _jc_field _jc_javax_crypto_Cipher$field_info$WRAP__5fMODE = {
	.name=		"WRAP_MODE",
	.signature=	"I",
	.class=		&_jc_javax_crypto_Cipher$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PUBLIC|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_Cipher$fields_struct, WRAP__5fMODE),
	.initial_value=	&_jc_javax_crypto_Cipher$initial_value$WRAP__5fMODE,
};

// private static final int INITIAL_STATE
static const jint _jc_javax_crypto_Cipher$initial_value$INITIAL__5fSTATE = 0;
static _jc_field _jc_javax_crypto_Cipher$field_info$INITIAL__5fSTATE = {
	.name=		"INITIAL_STATE",
	.signature=	"I",
	.class=		&_jc_javax_crypto_Cipher$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_Cipher$fields_struct, INITIAL__5fSTATE),
	.initial_value=	&_jc_javax_crypto_Cipher$initial_value$INITIAL__5fSTATE,
};

// private javax.crypto.CipherSpi cipherSpi
static _jc_field _jc_javax_crypto_Cipher$field_info$cipherSpi = {
	.name=		"cipherSpi",
	.signature=	"Ljavax/crypto/CipherSpi;",
	.class=		&_jc_javax_crypto_Cipher$type,
	.type=		&_jc_javax_crypto_CipherSpi$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_Cipher$object, refs[-1].javax_crypto_Cipher.cipherSpi),
};

// private java.security.Provider provider
static _jc_field _jc_javax_crypto_Cipher$field_info$provider = {
	.name=		"provider",
	.signature=	"Ljava/security/Provider;",
	.class=		&_jc_javax_crypto_Cipher$type,
	.type=		&_jc_java_security_Provider$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_Cipher$object, refs[-1].javax_crypto_Cipher.provider),
};

// private java.lang.String transformation
static _jc_field _jc_javax_crypto_Cipher$field_info$transformation = {
	.name=		"transformation",
	.signature=	"Ljava/lang/String;",
	.class=		&_jc_javax_crypto_Cipher$type,
	.type=		&_jc_java_lang_String$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_Cipher$object, refs[-1].javax_crypto_Cipher.transformation),
};

// private int state
static _jc_field _jc_javax_crypto_Cipher$field_info$state = {
	.name=		"state",
	.signature=	"I",
	.class=		&_jc_javax_crypto_Cipher$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_Cipher$object, nonrefs.javax_crypto_Cipher.state),
};

// Fields
static _jc_field *const _jc_javax_crypto_Cipher$fields[] = {
	&_jc_javax_crypto_Cipher$field_info$SERVICE,
	&_jc_javax_crypto_Cipher$field_info$DECRYPT__5fMODE,
	&_jc_javax_crypto_Cipher$field_info$ENCRYPT__5fMODE,
	&_jc_javax_crypto_Cipher$field_info$INITIAL__5fSTATE,
	&_jc_javax_crypto_Cipher$field_info$PRIVATE__5fKEY,
	&_jc_javax_crypto_Cipher$field_info$PUBLIC__5fKEY,
	&_jc_javax_crypto_Cipher$field_info$SECRET__5fKEY,
	&_jc_javax_crypto_Cipher$field_info$UNWRAP__5fMODE,
	&_jc_javax_crypto_Cipher$field_info$WRAP__5fMODE,
	&_jc_javax_crypto_Cipher$field_info$cipherSpi,
	&_jc_javax_crypto_Cipher$field_info$provider,
	&_jc_javax_crypto_Cipher$field_info$transformation,
	&_jc_javax_crypto_Cipher$field_info$state
};

/************************************************************************
 *			      Static methods				*
 ************************************************************************/

//
// public static final javax.crypto.Cipher getInstance(java.lang.String) throws java.security.NoSuchAlgorithmException, javax.crypto.NoSuchPaddingException
//

static _jc_linenum _jc_javax_crypto_Cipher$linenum_table$getInstance$3396c173f2120b7e[];

static _jc_trap_info _jc_javax_crypto_Cipher$trap_table$getInstance$3396c173f2120b7e[] = {
	_JC_TRAP(&_jc_java_security_NoSuchAlgorithmException$type, 1, 2),
	_JC_TRAP(&_jc_javax_crypto_NoSuchPaddingException$type, 1, 2),
};

static const unsigned char _jc_javax_crypto_Cipher$param_ptypes$getInstance$3396c173f2120b7e[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_javax_crypto_Cipher$exceptions$getInstance$3396c173f2120b7e[] = {
	&_jc_java_security_NoSuchAlgorithmException$type,
	&_jc_javax_crypto_NoSuchPaddingException$type
};

static _jc_type *const _jc_javax_crypto_Cipher$param_types$getInstance$3396c173f2120b7e[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_javax_crypto_Cipher$method_info$getInstance$3396c173f2120b7e = {
	.name=			"getInstance",
	.signature=		"(Ljava/lang/String;)Ljavax/crypto/Cipher;",
	.class=			&_jc_javax_crypto_Cipher$type,
	.param_types=		&_jc_javax_crypto_Cipher$param_types$getInstance$3396c173f2120b7e,
	.return_type=		&_jc_javax_crypto_Cipher$type,
	.param_ptypes=		&_jc_javax_crypto_Cipher$param_ptypes$getInstance$3396c173f2120b7e,
	.signature_hash=	_JC_JLONG(0x3396c173f2120b7e),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_Cipher$method$getInstance$3396c173f2120b7e,
	.num_parameters=	1,
	.num_exceptions=	2,
	.exceptions=		&_jc_javax_crypto_Cipher$exceptions$getInstance$3396c173f2120b7e,
	.u= { .exec= {
	  .trap_table_len=	2,
	  .trap_table=		_jc_javax_crypto_Cipher$trap_table$getInstance$3396c173f2120b7e,
	  .u= {
	    .linenum= {
	      .len=	11,
	      .table=	_jc_javax_crypto_Cipher$linenum_table$getInstance$3396c173f2120b7e
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_Cipher, getInstance$3396c173f2120b7e);

_jc_javax_crypto_Cipher$object * _JC_JCNI_ATTR
_jc_javax_crypto_Cipher$method$getInstance$3396c173f2120b7e(_jc_env *const env, _jc_java_lang_String$object *param0)
{
	jint volatile i0;
	jint volatile i1;
	jint i2;
	struct _jc_java_lang_String$object *volatile r0;
	struct _jc_javax_crypto_NoSuchPaddingException$object *volatile r2;
	struct _jc_java_lang_String$object *volatile r3;
	struct _jc_java_security_NoSuchAlgorithmException$object *volatile r4;
	struct _jc_java_security_Provider$object *volatile r5;
	struct _jc_javax_crypto_Cipher$object *volatile r6;
	struct _jc_java_lang_VMThrowable$object *volatile r7;
	struct _jc_java_util_Vector$object *r8;
	_jc_object_array *volatile r9;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_javax_crypto_Cipher$method_info$getInstance$3396c173f2120b7e, &&label1, &&label2);

	r0 = param0;
	_JC_ACTIVE_USE(env, java_security_Security);
	_JC_LINE_NUMBER(179);				// 0
	r8 = _JC_STATIC_FIELD(env, java_security_Security, providers, 1);
	i2 = _JC_INVOKE_VIRTUAL(env, java_util_Vector, size$345df5220fc60ade, r8);
	r9 = _JC_NEW_REF_ARRAY(env, java_security_Provider, 1, i2);
	r8 = _JC_STATIC_FIELD(env, java_security_Security, providers, 1);
	_JC_INVOKE_VIRTUAL(env, java_util_Vector, copyInto$cd78d768b3ba4735, r8, r9);
	_JC_LINE_NUMBER(180);				// 1
	r2 = _JC_NULL;
	_JC_LINE_NUMBER(181);				// 2
	r3 = _JC_STRING(env, "");
	_JC_LINE_NUMBER(182);				// 3
	i0 = 0;
	goto label4;

label0:
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(186);				// 4
	r5 = _JC_REF_ELEMENT(env, r9, i0, 1, 1);
	r6 = _JC_INVOKE_STATIC(env, javax_crypto_Cipher, getInstance$91dad1fdea183dd0, 0, r0, r5);
	_JC_TRAP_REGION(catch, 2);
	_JC_CANCEL_TRAPS(env, catch);
	return r6;

label1:
	_JC_TRAP_REGION(catch, 2);
	r4 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(190);				// 5
	r3 = _JC_INVOKE_VIRTUAL(env, java_lang_Throwable, getMessage$13aaf240efc902b1, r4);
	_JC_LINE_NUMBER(191);				// 6
	r2 = _JC_NULL;
	goto label3;

label2:
	_JC_TRAP_REGION(catch, 2);
	r2 = _JC_CAUGHT_EXCEPTION(env);

label3:
	_JC_LINE_NUMBER(182);				// 7
	i0 = i0 + 1;

label4:
	_JC_TRAP_REGION(catch, 2);
	i1 = _JC_ARRAY_LENGTH(env, r9);
	if (i0 < i1) {
		_JC_PERIODIC_CHECK(env);
		goto label0;
	}
	_JC_LINE_NUMBER(198);				// 8
	if (r2 == _JC_NULL)
		goto label5;
	_JC_LINE_NUMBER(200);				// 9
	_JC_THROW(env, r2);

label5:
	_JC_LINE_NUMBER(202);				// 10
	r4 = _JC_NEW(env, java_security_NoSuchAlgorithmException);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r7 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r7;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r3;
	_JC_THROW(env, r4);
}

//
// public static final javax.crypto.Cipher getInstance(java.lang.String, java.lang.String) throws java.security.NoSuchAlgorithmException, java.security.NoSuchProviderException, javax.crypto.NoSuchPaddingException
//

static _jc_linenum _jc_javax_crypto_Cipher$linenum_table$getInstance$2f7ad61b6f79e802[];

static const unsigned char _jc_javax_crypto_Cipher$param_ptypes$getInstance$2f7ad61b6f79e802[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_javax_crypto_Cipher$exceptions$getInstance$2f7ad61b6f79e802[] = {
	&_jc_java_security_NoSuchAlgorithmException$type,
	&_jc_java_security_NoSuchProviderException$type,
	&_jc_javax_crypto_NoSuchPaddingException$type
};

static _jc_type *const _jc_javax_crypto_Cipher$param_types$getInstance$2f7ad61b6f79e802[] = {
	&_jc_java_lang_String$type,
	&_jc_java_lang_String$type
};

_jc_method _jc_javax_crypto_Cipher$method_info$getInstance$2f7ad61b6f79e802 = {
	.name=			"getInstance",
	.signature=		"(Ljava/lang/String;Ljava/lang/String;)Ljavax/crypto/Cipher;",
	.class=			&_jc_javax_crypto_Cipher$type,
	.param_types=		&_jc_javax_crypto_Cipher$param_types$getInstance$2f7ad61b6f79e802,
	.return_type=		&_jc_javax_crypto_Cipher$type,
	.param_ptypes=		&_jc_javax_crypto_Cipher$param_ptypes$getInstance$2f7ad61b6f79e802,
	.signature_hash=	_JC_JLONG(0x2f7ad61b6f79e802),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_Cipher$method$getInstance$2f7ad61b6f79e802,
	.num_parameters=	2,
	.num_exceptions=	3,
	.exceptions=		&_jc_javax_crypto_Cipher$exceptions$getInstance$2f7ad61b6f79e802,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_javax_crypto_Cipher$linenum_table$getInstance$2f7ad61b6f79e802
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_Cipher, getInstance$2f7ad61b6f79e802);

_jc_javax_crypto_Cipher$object * _JC_JCNI_ATTR
_jc_javax_crypto_Cipher$method$getInstance$2f7ad61b6f79e802(_jc_env *const env, _jc_java_lang_String$object *param0, _jc_java_lang_String$object *param1)
{
	struct _jc_java_lang_String$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_java_security_Provider$object *r2;
	struct _jc_java_security_NoSuchProviderException$object *r3;
	struct _jc_javax_crypto_Cipher$object *r4;
	struct _jc_java_lang_VMThrowable$object *r6;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = param0;
	r1 = param1;
	_JC_LINE_NUMBER(223);				// 0
	r2 = _JC_INVOKE_STATIC(env, java_security_Security, getProvider$581ee7d7bc9ae747, 0, r1);
	_JC_LINE_NUMBER(224);				// 1
	if (r2 != _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(226);				// 2
	r3 = _JC_NEW(env, java_security_NoSuchProviderException);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r6 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r6;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r1;
	_JC_THROW(env, r3);

label0:
	_JC_LINE_NUMBER(228);				// 3
	r4 = _JC_INVOKE_STATIC(env, javax_crypto_Cipher, getInstance$91dad1fdea183dd0, 1, r0, r2);
	return r4;
}

//
// public static final javax.crypto.Cipher getInstance(java.lang.String, java.security.Provider) throws java.security.NoSuchAlgorithmException, javax.crypto.NoSuchPaddingException
//

static _jc_linenum _jc_javax_crypto_Cipher$linenum_table$getInstance$91dad1fdea183dd0[];

static _jc_trap_info _jc_javax_crypto_Cipher$trap_table$getInstance$91dad1fdea183dd0[] = {
	_JC_TRAP(&_jc_java_lang_Exception$type, 1, 2),
	_JC_TRAP(&_jc_java_lang_Exception$type, 3, 4),
	_JC_TRAP(&_jc_java_lang_Exception$type, 5, 6),
	_JC_TRAP(&_jc_java_lang_Exception$type, 7, 8),
	_JC_TRAP(&_jc_java_lang_Exception$type, 9, 10),
};

static const unsigned char _jc_javax_crypto_Cipher$param_ptypes$getInstance$91dad1fdea183dd0[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_javax_crypto_Cipher$exceptions$getInstance$91dad1fdea183dd0[] = {
	&_jc_java_security_NoSuchAlgorithmException$type,
	&_jc_javax_crypto_NoSuchPaddingException$type
};

static _jc_type *const _jc_javax_crypto_Cipher$param_types$getInstance$91dad1fdea183dd0[] = {
	&_jc_java_lang_String$type,
	&_jc_java_security_Provider$type
};

_jc_method _jc_javax_crypto_Cipher$method_info$getInstance$91dad1fdea183dd0 = {
	.name=			"getInstance",
	.signature=		"(Ljava/lang/String;Ljava/security/Provider;)Ljavax/crypto/Cipher;",
	.class=			&_jc_javax_crypto_Cipher$type,
	.param_types=		&_jc_javax_crypto_Cipher$param_types$getInstance$91dad1fdea183dd0,
	.return_type=		&_jc_javax_crypto_Cipher$type,
	.param_ptypes=		&_jc_javax_crypto_Cipher$param_ptypes$getInstance$91dad1fdea183dd0,
	.signature_hash=	_JC_JLONG(0x91dad1fdea183dd0),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_Cipher$method$getInstance$91dad1fdea183dd0,
	.num_parameters=	2,
	.num_exceptions=	2,
	.exceptions=		&_jc_javax_crypto_Cipher$exceptions$getInstance$91dad1fdea183dd0,
	.u= { .exec= {
	  .trap_table_len=	5,
	  .trap_table=		_jc_javax_crypto_Cipher$trap_table$getInstance$91dad1fdea183dd0,
	  .u= {
	    .linenum= {
	      .len=	31,
	      .table=	_jc_javax_crypto_Cipher$linenum_table$getInstance$91dad1fdea183dd0
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_Cipher, getInstance$91dad1fdea183dd0);

_jc_javax_crypto_Cipher$object * _JC_JCNI_ATTR
_jc_javax_crypto_Cipher$method$getInstance$91dad1fdea183dd0(_jc_env *const env, _jc_java_lang_String$object *param0, _jc_java_security_Provider$object *param1)
{
	jint i0;
	jint i1;
	jint i3;
	struct _jc_java_lang_String$object *volatile r0;
	struct _jc_java_security_Provider$object *volatile r1;
	struct _jc_java_lang_String$object *volatile r10;
	struct _jc_java_lang_Exception$object *volatile r11;
	struct _jc_java_lang_StringBuffer$object *volatile r12;
	struct _jc_java_lang_Exception$object *volatile r13;
	struct _jc_javax_crypto_NoSuchPaddingException$object *volatile r14;
	struct _jc_java_lang_Exception$object *volatile r15;
	struct _jc_java_lang_String$object *r16;
	struct _jc_java_lang_String$object *r17;
	struct _jc_java_lang_String$object *r18;
	_jc_object_array *r19;
	struct _jc_java_lang_String$object *volatile r2;
	struct _jc_java_lang_Object$object *r20;
	struct _jc_java_lang_String$object *r21;
	_jc_object_array *r22;
	struct _jc_java_lang_Object$object *r23;
	struct _jc_java_lang_String$object *volatile r24;
	struct _jc_java_lang_String$object *volatile r25;
	_jc_object_array *volatile r26;
	struct _jc_java_lang_Object$object *volatile r27;
	struct _jc_java_lang_String$object *volatile r28;
	struct _jc_java_lang_String$object *volatile r29;
	struct _jc_java_lang_Exception$object *volatile r3;
	_jc_object_array *volatile r30;
	struct _jc_java_lang_Object$object *volatile r31;
	struct _jc_java_lang_String$object *volatile r32;
	_jc_object_array *volatile r33;
	struct _jc_java_lang_Object$object *volatile r34;
	struct _jc_java_lang_String$object *volatile r35;
	_jc_char_array *volatile r36;
	_jc_char_array *volatile r37;
	_jc_char_array *volatile r38;
	struct _jc_java_lang_VMThrowable$object *r39;
	struct _jc_javax_crypto_CipherSpi$object *volatile r4;
	struct _jc_java_lang_VMThrowable$object *volatile r40;
	struct _jc_javax_crypto_Cipher$object *volatile r5;
	struct _jc_java_lang_Exception$object *volatile r6;
	struct _jc_java_util_StringTokenizer$object *r7;
	struct _jc_java_security_NoSuchAlgorithmException$object *volatile r8;
	struct _jc_java_lang_String$object *volatile r9;
	jboolean volatile z0;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_javax_crypto_Cipher$method_info$getInstance$91dad1fdea183dd0, &&label0, &&label3, &&label4, &&label6, &&label7);

	r0 = param0;
	r1 = param1;
	_JC_EXPLICIT_NULL_CHECK(env, r0);
	i1 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, indexOf$6ec5a1241e692e35, 0, r0, 47, 0);
	_JC_LINE_NUMBER(250);				// 0
	if (i1 >= 0)
		goto label1;
	_JC_TRAP_REGION(catch, 1);
	_JC_ACTIVE_USE(env, gnu_java_security_Engine);
	_JC_LINE_NUMBER(254);				// 1
	r18 = _JC_STRING(env, "Cipher");
	r19 = _JC_STATIC_FIELD(env, gnu_java_security_Engine, NO__5fARGS, 1);
	r20 = _JC_INVOKE_STATIC(env, gnu_java_security_Engine, getInstance$ec89dfd35c234c64, 1, r18, r0, r1, r19);
	r4 = _JC_CAST(env, &_jc_javax_crypto_CipherSpi$type, r20);
	_JC_LINE_NUMBER(256);				// 2
	r5 = _JC_NEW(env, javax_crypto_Cipher);
	_JC_REF_FIELD(env, r5, javax_crypto_Cipher, cipherSpi) = r4;
	_JC_REF_FIELD(env, r5, javax_crypto_Cipher, provider) = r1;
	_JC_REF_FIELD(env, r5, javax_crypto_Cipher, transformation) = r0;
	_JC_PRIM_FIELD(env, r5, javax_crypto_Cipher, state) = 0;
	_JC_TRAP_REGION(catch, 2);
	_JC_CANCEL_TRAPS(env, catch);
	return r5;

label0:
	_JC_TRAP_REGION(catch, 2);
	r6 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(260);				// 3
	r2 = _JC_INVOKE_VIRTUAL(env, java_lang_Throwable, getMessage$13aaf240efc902b1, r6);
	goto label9;

label1:
	_JC_TRAP_REGION(catch, 2);
	_JC_LINE_NUMBER(265);				// 4
	r7 = _JC_NEW(env, java_util_StringTokenizer);
	r16 = _JC_STRING(env, "/");
	i3 = _JC_PRIM_FIELD(env, r0, java_lang_String, count);
	_JC_PRIM_FIELD(env, r7, java_util_StringTokenizer, len) = i3;
	_JC_REF_FIELD(env, r7, java_util_StringTokenizer, str) = r0;
	_JC_REF_FIELD(env, r7, java_util_StringTokenizer, delim) = r16;
	_JC_PRIM_FIELD(env, r7, java_util_StringTokenizer, retDelims) = 0;
	_JC_PRIM_FIELD(env, r7, java_util_StringTokenizer, pos) = 0;
	_JC_LINE_NUMBER(266);				// 5
	i0 = _JC_INVOKE_NONVIRTUAL(env, java_util_StringTokenizer, countTokens$30e7b65e7ca065d2, 0, r7);
	if (i0 == 3)
		goto label2;
	_JC_LINE_NUMBER(268);				// 6
	r8 = _JC_NEW(env, java_security_NoSuchAlgorithmException);
	r17 = _JC_STRING(env, "badly formed transformation");
	_JC_REF_FIELD(env, r8, java_lang_Throwable, cause) = r8;
	r39 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r8);
	_JC_REF_FIELD(env, r8, java_lang_Throwable, vmState) = r39;
	_JC_REF_FIELD(env, r8, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r8, java_lang_Throwable, detailMessage) = r17;
	_JC_THROW(env, r8);

label2:
	_JC_LINE_NUMBER(270);				// 7
	r2 = _JC_INVOKE_NONVIRTUAL(env, java_util_StringTokenizer, nextToken$706c46e280dd7989, 0, r7);
	_JC_LINE_NUMBER(271);				// 8
	r9 = _JC_INVOKE_NONVIRTUAL(env, java_util_StringTokenizer, nextToken$706c46e280dd7989, 0, r7);
	_JC_LINE_NUMBER(272);				// 9
	r10 = _JC_INVOKE_NONVIRTUAL(env, java_util_StringTokenizer, nextToken$706c46e280dd7989, 0, r7);
	_JC_TRAP_REGION(catch, 3);
	_JC_ACTIVE_USE(env, gnu_java_security_Engine);
	_JC_LINE_NUMBER(275);				// 10
	r21 = _JC_STRING(env, "Cipher");
	r22 = _JC_STATIC_FIELD(env, gnu_java_security_Engine, NO__5fARGS, 1);
	r23 = _JC_INVOKE_STATIC(env, gnu_java_security_Engine, getInstance$ec89dfd35c234c64, 1, r21, r0, r1, r22);
	r4 = _JC_CAST(env, &_jc_javax_crypto_CipherSpi$type, r23);
	_JC_LINE_NUMBER(277);				// 11
	r5 = _JC_NEW(env, javax_crypto_Cipher);
	_JC_REF_FIELD(env, r5, javax_crypto_Cipher, cipherSpi) = r4;
	_JC_REF_FIELD(env, r5, javax_crypto_Cipher, provider) = r1;
	_JC_REF_FIELD(env, r5, javax_crypto_Cipher, transformation) = r0;
	_JC_PRIM_FIELD(env, r5, javax_crypto_Cipher, state) = 0;
	_JC_TRAP_REGION(catch, 4);
	_JC_CANCEL_TRAPS(env, catch);
	return r5;

label3:
	_JC_TRAP_REGION(catch, 4);
	r11 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(281);				// 12
	_JC_INVOKE_VIRTUAL(env, java_lang_Throwable, getMessage$13aaf240efc902b1, r11);
	_JC_TRAP_REGION(catch, 5);
	_JC_LINE_NUMBER(285);				// 13
	r12 = _JC_NEW(env, java_lang_StringBuffer);
	r36 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r12, java_lang_StringBuffer, value) = r36;
	r12 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r12, r2);
	r12 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$9450b16e89f0618d, 0, r12, 47);
	r12 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r12, r9);
	r24 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r24, r12);
	_JC_ACTIVE_USE(env, gnu_java_security_Engine);
	r25 = _JC_STRING(env, "Cipher");
	r26 = _JC_STATIC_FIELD(env, gnu_java_security_Engine, NO__5fARGS, 1);
	r27 = _JC_INVOKE_STATIC(env, gnu_java_security_Engine, getInstance$ec89dfd35c234c64, 1, r25, r24, r1, r26);
	r4 = _JC_CAST(env, &_jc_javax_crypto_CipherSpi$type, r27);
	_JC_LINE_NUMBER(287);				// 14
	_JC_INVOKE_VIRTUAL(env, javax_crypto_CipherSpi, engineSetPadding$f0786715b8053b05, r4, r10);
	_JC_LINE_NUMBER(288);				// 15
	r5 = _JC_NEW(env, javax_crypto_Cipher);
	_JC_REF_FIELD(env, r5, javax_crypto_Cipher, cipherSpi) = r4;
	_JC_REF_FIELD(env, r5, javax_crypto_Cipher, provider) = r1;
	_JC_REF_FIELD(env, r5, javax_crypto_Cipher, transformation) = r0;
	_JC_PRIM_FIELD(env, r5, javax_crypto_Cipher, state) = 0;
	_JC_TRAP_REGION(catch, 6);
	_JC_CANCEL_TRAPS(env, catch);
	return r5;

label4:
	_JC_TRAP_REGION(catch, 6);
	r13 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(292);				// 16
	z0 = _JC_INSTANCEOF(env, r13, &_jc_javax_crypto_NoSuchPaddingException$type);
	if (z0 == 0)
		goto label5;
	_JC_LINE_NUMBER(294);				// 17
	r14 = r13;
	_JC_THROW(env, r14);

label5:
	_JC_LINE_NUMBER(296);				// 18
	_JC_INVOKE_VIRTUAL(env, java_lang_Throwable, getMessage$13aaf240efc902b1, r13);
	_JC_TRAP_REGION(catch, 7);
	_JC_LINE_NUMBER(300);				// 19
	r12 = _JC_NEW(env, java_lang_StringBuffer);
	r37 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r12, java_lang_StringBuffer, value) = r37;
	r12 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r12, r2);
	r12 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r12, _JC_STRING(env, "//"));
	r12 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r12, r10);
	r28 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r28, r12);
	_JC_ACTIVE_USE(env, gnu_java_security_Engine);
	r29 = _JC_STRING(env, "Cipher");
	r30 = _JC_STATIC_FIELD(env, gnu_java_security_Engine, NO__5fARGS, 1);
	r31 = _JC_INVOKE_STATIC(env, gnu_java_security_Engine, getInstance$ec89dfd35c234c64, 1, r29, r28, r1, r30);
	r4 = _JC_CAST(env, &_jc_javax_crypto_CipherSpi$type, r31);
	_JC_LINE_NUMBER(302);				// 20
	_JC_INVOKE_VIRTUAL(env, javax_crypto_CipherSpi, engineSetMode$b02f01dc67848002, r4, r9);
	_JC_LINE_NUMBER(303);				// 21
	r5 = _JC_NEW(env, javax_crypto_Cipher);
	_JC_REF_FIELD(env, r5, javax_crypto_Cipher, cipherSpi) = r4;
	_JC_REF_FIELD(env, r5, javax_crypto_Cipher, provider) = r1;
	_JC_REF_FIELD(env, r5, javax_crypto_Cipher, transformation) = r0;
	_JC_PRIM_FIELD(env, r5, javax_crypto_Cipher, state) = 0;
	_JC_TRAP_REGION(catch, 8);
	_JC_CANCEL_TRAPS(env, catch);
	return r5;

label6:
	_JC_TRAP_REGION(catch, 8);
	r15 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(307);				// 22
	_JC_INVOKE_VIRTUAL(env, java_lang_Throwable, getMessage$13aaf240efc902b1, r15);
	_JC_TRAP_REGION(catch, 9);
	_JC_ACTIVE_USE(env, gnu_java_security_Engine);
	_JC_LINE_NUMBER(311);				// 23
	r32 = _JC_STRING(env, "Cipher");
	r33 = _JC_STATIC_FIELD(env, gnu_java_security_Engine, NO__5fARGS, 1);
	r34 = _JC_INVOKE_STATIC(env, gnu_java_security_Engine, getInstance$ec89dfd35c234c64, 1, r32, r2, r1, r33);
	r4 = _JC_CAST(env, &_jc_javax_crypto_CipherSpi$type, r34);
	_JC_LINE_NUMBER(312);				// 24
	_JC_INVOKE_VIRTUAL(env, javax_crypto_CipherSpi, engineSetMode$b02f01dc67848002, r4, r9);
	_JC_LINE_NUMBER(313);				// 25
	_JC_INVOKE_VIRTUAL(env, javax_crypto_CipherSpi, engineSetPadding$f0786715b8053b05, r4, r10);
	_JC_LINE_NUMBER(314);				// 26
	r5 = _JC_NEW(env, javax_crypto_Cipher);
	_JC_REF_FIELD(env, r5, javax_crypto_Cipher, cipherSpi) = r4;
	_JC_REF_FIELD(env, r5, javax_crypto_Cipher, provider) = r1;
	_JC_REF_FIELD(env, r5, javax_crypto_Cipher, transformation) = r0;
	_JC_PRIM_FIELD(env, r5, javax_crypto_Cipher, state) = 0;
	_JC_TRAP_REGION(catch, 10);
	_JC_CANCEL_TRAPS(env, catch);
	return r5;

label7:
	_JC_TRAP_REGION(catch, 10);
	r3 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(318);				// 27
	z0 = _JC_INSTANCEOF(env, r3, &_jc_javax_crypto_NoSuchPaddingException$type);
	if (z0 == 0)
		goto label8;
	_JC_LINE_NUMBER(320);				// 28
	r14 = r3;
	_JC_THROW(env, r14);

label8:
	_JC_LINE_NUMBER(322);				// 29
	r2 = _JC_INVOKE_VIRTUAL(env, java_lang_Throwable, getMessage$13aaf240efc902b1, r3);

label9:
	_JC_TRAP_REGION(catch, 10);
	_JC_LINE_NUMBER(325);				// 30
	r8 = _JC_NEW(env, java_security_NoSuchAlgorithmException);
	r12 = _JC_NEW(env, java_lang_StringBuffer);
	r38 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r12, java_lang_StringBuffer, value) = r38;
	r12 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r12, r0);
	r12 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r12, _JC_STRING(env, ": "));
	r12 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r12, r2);
	r35 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r35, r12);
	_JC_REF_FIELD(env, r8, java_lang_Throwable, cause) = r8;
	r40 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r8);
	_JC_REF_FIELD(env, r8, java_lang_Throwable, vmState) = r40;
	_JC_REF_FIELD(env, r8, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r8, java_lang_Throwable, detailMessage) = r35;
	_JC_THROW(env, r8);
}

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// protected void <init>(javax.crypto.CipherSpi, java.security.Provider, java.lang.String)
//

static _jc_linenum _jc_javax_crypto_Cipher$linenum_table$_init$0ccf26f10eec763e[];

static const unsigned char _jc_javax_crypto_Cipher$param_ptypes$_init$0ccf26f10eec763e[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_Cipher$param_types$_init$0ccf26f10eec763e[] = {
	&_jc_javax_crypto_CipherSpi$type,
	&_jc_java_security_Provider$type,
	&_jc_java_lang_String$type
};

_jc_method _jc_javax_crypto_Cipher$method_info$_init$0ccf26f10eec763e = {
	.name=			"<init>",
	.signature=		"(Ljavax/crypto/CipherSpi;Ljava/security/Provider;Ljava/lang/String;)V",
	.class=			&_jc_javax_crypto_Cipher$type,
	.param_types=		&_jc_javax_crypto_Cipher$param_types$_init$0ccf26f10eec763e,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_Cipher$param_ptypes$_init$0ccf26f10eec763e,
	.signature_hash=	_JC_JLONG(0xccf26f10eec763e),
	.access_flags=		_JC_ACC_PROTECTED,
	.function=		&_jc_javax_crypto_Cipher$method$_init$0ccf26f10eec763e,
	.num_parameters=	3,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_javax_crypto_Cipher$linenum_table$_init$0ccf26f10eec763e
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_Cipher, _init$0ccf26f10eec763e);

void _JC_JCNI_ATTR
_jc_javax_crypto_Cipher$method$_init$0ccf26f10eec763e(_jc_env *const env, _jc_javax_crypto_Cipher$object *this, _jc_javax_crypto_CipherSpi$object *param0, _jc_java_security_Provider$object *param1, _jc_java_lang_String$object *param2)
{
	struct _jc_javax_crypto_Cipher$object *r0;
	struct _jc_javax_crypto_CipherSpi$object *r1;
	struct _jc_java_security_Provider$object *r2;
	struct _jc_java_lang_String$object *r3;

	r0 = this;
	r1 = param0;
	r2 = param1;
	r3 = param2;
	_JC_LINE_NUMBER(341);				// 0
	_JC_REF_FIELD(env, r0, javax_crypto_Cipher, cipherSpi) = r1;
	_JC_LINE_NUMBER(342);				// 1
	_JC_REF_FIELD(env, r0, javax_crypto_Cipher, provider) = r2;
	_JC_LINE_NUMBER(343);				// 2
	_JC_REF_FIELD(env, r0, javax_crypto_Cipher, transformation) = r3;
	_JC_LINE_NUMBER(344);				// 3
	_JC_PRIM_FIELD(env, r0, javax_crypto_Cipher, state) = 0;
	_JC_LINE_NUMBER(345);				// 4
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public final byte[] doFinal() throws java.lang.IllegalStateException, javax.crypto.IllegalBlockSizeException, javax.crypto.BadPaddingException
//

static _jc_linenum _jc_javax_crypto_Cipher$linenum_table$doFinal$cd6684344483c19a[];

static const unsigned char _jc_javax_crypto_Cipher$param_ptypes$doFinal$cd6684344483c19a[] = { 
_JC_TYPE_REFERENCE };

static _jc_type *const _jc_javax_crypto_Cipher$exceptions$doFinal$cd6684344483c19a[] = {
	&_jc_java_lang_IllegalStateException$type,
	&_jc_javax_crypto_IllegalBlockSizeException$type,
	&_jc_javax_crypto_BadPaddingException$type
};

_jc_method _jc_javax_crypto_Cipher$method_info$doFinal$cd6684344483c19a = {
	.name=			"doFinal",
	.signature=		"()[B",
	.class=			&_jc_javax_crypto_Cipher$type,
	.return_type=		&_jc_byte$array$prim$type,
	.param_ptypes=		&_jc_javax_crypto_Cipher$param_ptypes$doFinal$cd6684344483c19a,
	.signature_hash=	_JC_JLONG(0xcd6684344483c19a),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_Cipher$method$doFinal$cd6684344483c19a,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_Cipher$vtable, javax_crypto_Cipher.doFinal$cd6684344483c19a) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	3,
	.exceptions=		&_jc_javax_crypto_Cipher$exceptions$doFinal$cd6684344483c19a,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_crypto_Cipher$linenum_table$doFinal$cd6684344483c19a
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_Cipher, doFinal$cd6684344483c19a);

_jc_byte_array * _JC_JCNI_ATTR
_jc_javax_crypto_Cipher$method$doFinal$cd6684344483c19a(_jc_env *const env, _jc_javax_crypto_Cipher$object *this)
{
	struct _jc_javax_crypto_Cipher$object *r0;
	_jc_byte_array *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(443);				// 0
	r1 = _JC_NEW_PRIM_ARRAY(env, byte, 1, 0);
	r1 = _JC_INVOKE_NONVIRTUAL(env, javax_crypto_Cipher, doFinal$12da2b94da840b22, 0, r0, r1, 0, 0);
	return r1;
}

//
// public final byte[] doFinal(byte[]) throws java.lang.IllegalStateException, javax.crypto.IllegalBlockSizeException, javax.crypto.BadPaddingException
//

static _jc_linenum _jc_javax_crypto_Cipher$linenum_table$doFinal$b1afee017dcf0da2[];

static const unsigned char _jc_javax_crypto_Cipher$param_ptypes$doFinal$b1afee017dcf0da2[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_javax_crypto_Cipher$exceptions$doFinal$b1afee017dcf0da2[] = {
	&_jc_java_lang_IllegalStateException$type,
	&_jc_javax_crypto_IllegalBlockSizeException$type,
	&_jc_javax_crypto_BadPaddingException$type
};

static _jc_type *const _jc_javax_crypto_Cipher$param_types$doFinal$b1afee017dcf0da2[] = {
	&_jc_byte$array$prim$type
};

_jc_method _jc_javax_crypto_Cipher$method_info$doFinal$b1afee017dcf0da2 = {
	.name=			"doFinal",
	.signature=		"([B)[B",
	.class=			&_jc_javax_crypto_Cipher$type,
	.param_types=		&_jc_javax_crypto_Cipher$param_types$doFinal$b1afee017dcf0da2,
	.return_type=		&_jc_byte$array$prim$type,
	.param_ptypes=		&_jc_javax_crypto_Cipher$param_ptypes$doFinal$b1afee017dcf0da2,
	.signature_hash=	_JC_JLONG(0xb1afee017dcf0da2),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_Cipher$method$doFinal$b1afee017dcf0da2,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_Cipher$vtable, javax_crypto_Cipher.doFinal$b1afee017dcf0da2) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	3,
	.exceptions=		&_jc_javax_crypto_Cipher$exceptions$doFinal$b1afee017dcf0da2,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_crypto_Cipher$linenum_table$doFinal$b1afee017dcf0da2
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_Cipher, doFinal$b1afee017dcf0da2);

_jc_byte_array * _JC_JCNI_ATTR
_jc_javax_crypto_Cipher$method$doFinal$b1afee017dcf0da2(_jc_env *const env, _jc_javax_crypto_Cipher$object *this, _jc_byte_array *param0)
{
	jint i0;
	struct _jc_javax_crypto_Cipher$object *r0;
	_jc_byte_array *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(465);				// 0
	i0 = _JC_ARRAY_LENGTH(env, r1);
	r1 = _JC_INVOKE_NONVIRTUAL(env, javax_crypto_Cipher, doFinal$12da2b94da840b22, 0, r0, r1, 0, i0);
	return r1;
}

//
// public final int doFinal(byte[], int) throws java.lang.IllegalStateException, javax.crypto.IllegalBlockSizeException, javax.crypto.BadPaddingException, javax.crypto.ShortBufferException
//

static _jc_linenum _jc_javax_crypto_Cipher$linenum_table$doFinal$b8462305182b7595[];

static const unsigned char _jc_javax_crypto_Cipher$param_ptypes$doFinal$b8462305182b7595[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_INT };

static _jc_type *const _jc_javax_crypto_Cipher$exceptions$doFinal$b8462305182b7595[] = {
	&_jc_java_lang_IllegalStateException$type,
	&_jc_javax_crypto_IllegalBlockSizeException$type,
	&_jc_javax_crypto_BadPaddingException$type,
	&_jc_javax_crypto_ShortBufferException$type
};

static _jc_type *const _jc_javax_crypto_Cipher$param_types$doFinal$b8462305182b7595[] = {
	&_jc_byte$array$prim$type,
	&_jc_int$prim$type
};

_jc_method _jc_javax_crypto_Cipher$method_info$doFinal$b8462305182b7595 = {
	.name=			"doFinal",
	.signature=		"([BI)I",
	.class=			&_jc_javax_crypto_Cipher$type,
	.param_types=		&_jc_javax_crypto_Cipher$param_types$doFinal$b8462305182b7595,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_javax_crypto_Cipher$param_ptypes$doFinal$b8462305182b7595,
	.signature_hash=	_JC_JLONG(0xb8462305182b7595),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_Cipher$method$doFinal$b8462305182b7595,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_Cipher$vtable, javax_crypto_Cipher.doFinal$b8462305182b7595) / sizeof(void *),
	.num_parameters=	2,
	.num_exceptions=	4,
	.exceptions=		&_jc_javax_crypto_Cipher$exceptions$doFinal$b8462305182b7595,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	6,
	      .table=	_jc_javax_crypto_Cipher$linenum_table$doFinal$b8462305182b7595
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_Cipher, doFinal$b8462305182b7595);

jint _JC_JCNI_ATTR
_jc_javax_crypto_Cipher$method$doFinal$b8462305182b7595(_jc_env *const env, _jc_javax_crypto_Cipher$object *this, _jc_byte_array *param0, jint param1)
{
	jint i0;
	jint i1;
	struct _jc_javax_crypto_Cipher$object *r0;
	_jc_byte_array *r1;
	struct _jc_javax_crypto_CipherSpi$object *r2;
	struct _jc_java_lang_IllegalStateException$object *r3;
	_jc_byte_array *r4;
	struct _jc_java_lang_String$object *r5;
	struct _jc_java_lang_VMThrowable$object *r7;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	i0 = param1;
	_JC_LINE_NUMBER(527);				// 0
	r2 = _JC_REF_FIELD(env, r0, javax_crypto_Cipher, cipherSpi);
	if (r2 != _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(529);				// 1
	return 0;

label0:
	_JC_LINE_NUMBER(531);				// 2
	i1 = _JC_PRIM_FIELD(env, r0, javax_crypto_Cipher, state);
	if (i1 == 1)
		goto label1;
	i1 = _JC_PRIM_FIELD(env, r0, javax_crypto_Cipher, state);
	if (i1 == 2)
		goto label1;
	_JC_LINE_NUMBER(533);				// 3
	r3 = _JC_NEW(env, java_lang_IllegalStateException);
	r5 = _JC_STRING(env, "neither encrypting nor decrypting");
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r7 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r7;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r5;
	_JC_THROW(env, r3);

label1:
	_JC_LINE_NUMBER(535);				// 4
	_JC_PRIM_FIELD(env, r0, javax_crypto_Cipher, state) = 0;
	_JC_LINE_NUMBER(536);				// 5
	r2 = _JC_REF_FIELD(env, r0, javax_crypto_Cipher, cipherSpi);
	r4 = _JC_NEW_PRIM_ARRAY(env, byte, 1, 0);
	i1 = _JC_INVOKE_VIRTUAL(env, javax_crypto_CipherSpi, engineDoFinal$1df4228b1a6d48a9, r2, r4, 0, 0, r1, i0);
	return i1;
}

//
// public final byte[] doFinal(byte[], int, int) throws java.lang.IllegalStateException, javax.crypto.IllegalBlockSizeException, javax.crypto.BadPaddingException
//

static _jc_linenum _jc_javax_crypto_Cipher$linenum_table$doFinal$12da2b94da840b22[];

static const unsigned char _jc_javax_crypto_Cipher$param_ptypes$doFinal$12da2b94da840b22[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_INT, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_javax_crypto_Cipher$exceptions$doFinal$12da2b94da840b22[] = {
	&_jc_java_lang_IllegalStateException$type,
	&_jc_javax_crypto_IllegalBlockSizeException$type,
	&_jc_javax_crypto_BadPaddingException$type
};

static _jc_type *const _jc_javax_crypto_Cipher$param_types$doFinal$12da2b94da840b22[] = {
	&_jc_byte$array$prim$type,
	&_jc_int$prim$type,
	&_jc_int$prim$type
};

_jc_method _jc_javax_crypto_Cipher$method_info$doFinal$12da2b94da840b22 = {
	.name=			"doFinal",
	.signature=		"([BII)[B",
	.class=			&_jc_javax_crypto_Cipher$type,
	.param_types=		&_jc_javax_crypto_Cipher$param_types$doFinal$12da2b94da840b22,
	.return_type=		&_jc_byte$array$prim$type,
	.param_ptypes=		&_jc_javax_crypto_Cipher$param_ptypes$doFinal$12da2b94da840b22,
	.signature_hash=	_JC_JLONG(0x12da2b94da840b22),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_Cipher$method$doFinal$12da2b94da840b22,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_Cipher$vtable, javax_crypto_Cipher.doFinal$12da2b94da840b22) / sizeof(void *),
	.num_parameters=	3,
	.num_exceptions=	3,
	.exceptions=		&_jc_javax_crypto_Cipher$exceptions$doFinal$12da2b94da840b22,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	7,
	      .table=	_jc_javax_crypto_Cipher$linenum_table$doFinal$12da2b94da840b22
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_Cipher, doFinal$12da2b94da840b22);

_jc_byte_array * _JC_JCNI_ATTR
_jc_javax_crypto_Cipher$method$doFinal$12da2b94da840b22(_jc_env *const env, _jc_javax_crypto_Cipher$object *this, _jc_byte_array *param0, jint param1, jint param2)
{
	jint i0;
	jint i1;
	jint i2;
	struct _jc_javax_crypto_Cipher$object *r0;
	_jc_byte_array *r1;
	_jc_byte_array *r2;
	struct _jc_javax_crypto_CipherSpi$object *r3;
	struct _jc_java_lang_IllegalStateException$object *r4;
	struct _jc_java_lang_String$object *r5;
	struct _jc_java_lang_VMThrowable$object *r7;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	i0 = param1;
	i1 = param2;
	_JC_LINE_NUMBER(489);				// 0
	r3 = _JC_REF_FIELD(env, r0, javax_crypto_Cipher, cipherSpi);
	if (r3 != _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(491);				// 1
	r2 = _JC_NEW_PRIM_ARRAY(env, byte, 1, i1);
	_JC_ACTIVE_USE(env, java_lang_System);
	_JC_INVOKE_STATIC(env, java_lang_VMSystem, arraycopy$4286a72d57744cd8, 0, r1, i0, r2, 0, i1);
	_JC_LINE_NUMBER(493);				// 2
	return r2;

label0:
	_JC_LINE_NUMBER(495);				// 3
	i2 = _JC_PRIM_FIELD(env, r0, javax_crypto_Cipher, state);
	if (i2 == 1)
		goto label1;
	i2 = _JC_PRIM_FIELD(env, r0, javax_crypto_Cipher, state);
	if (i2 == 2)
		goto label1;
	_JC_LINE_NUMBER(497);				// 4
	r4 = _JC_NEW(env, java_lang_IllegalStateException);
	r5 = _JC_STRING(env, "neither encrypting nor decrypting");
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r7 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r7;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r5;
	_JC_THROW(env, r4);

label1:
	_JC_LINE_NUMBER(499);				// 5
	_JC_PRIM_FIELD(env, r0, javax_crypto_Cipher, state) = 0;
	_JC_LINE_NUMBER(500);				// 6
	r3 = _JC_REF_FIELD(env, r0, javax_crypto_Cipher, cipherSpi);
	r2 = _JC_INVOKE_VIRTUAL(env, javax_crypto_CipherSpi, engineDoFinal$f48559ba08c386ed, r3, r1, i0, i1);
	return r2;
}

//
// public final int doFinal(byte[], int, int, byte[]) throws java.lang.IllegalStateException, javax.crypto.IllegalBlockSizeException, javax.crypto.BadPaddingException, javax.crypto.ShortBufferException
//

static _jc_linenum _jc_javax_crypto_Cipher$linenum_table$doFinal$b07fbc67dd9e541e[];

static const unsigned char _jc_javax_crypto_Cipher$param_ptypes$doFinal$b07fbc67dd9e541e[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_INT, _JC_TYPE_REFERENCE, _JC_TYPE_INT };

static _jc_type *const _jc_javax_crypto_Cipher$exceptions$doFinal$b07fbc67dd9e541e[] = {
	&_jc_java_lang_IllegalStateException$type,
	&_jc_javax_crypto_IllegalBlockSizeException$type,
	&_jc_javax_crypto_BadPaddingException$type,
	&_jc_javax_crypto_ShortBufferException$type
};

static _jc_type *const _jc_javax_crypto_Cipher$param_types$doFinal$b07fbc67dd9e541e[] = {
	&_jc_byte$array$prim$type,
	&_jc_int$prim$type,
	&_jc_int$prim$type,
	&_jc_byte$array$prim$type
};

_jc_method _jc_javax_crypto_Cipher$method_info$doFinal$b07fbc67dd9e541e = {
	.name=			"doFinal",
	.signature=		"([BII[B)I",
	.class=			&_jc_javax_crypto_Cipher$type,
	.param_types=		&_jc_javax_crypto_Cipher$param_types$doFinal$b07fbc67dd9e541e,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_javax_crypto_Cipher$param_ptypes$doFinal$b07fbc67dd9e541e,
	.signature_hash=	_JC_JLONG(0xb07fbc67dd9e541e),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_Cipher$method$doFinal$b07fbc67dd9e541e,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_Cipher$vtable, javax_crypto_Cipher.doFinal$b07fbc67dd9e541e) / sizeof(void *),
	.num_parameters=	4,
	.num_exceptions=	4,
	.exceptions=		&_jc_javax_crypto_Cipher$exceptions$doFinal$b07fbc67dd9e541e,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_crypto_Cipher$linenum_table$doFinal$b07fbc67dd9e541e
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_Cipher, doFinal$b07fbc67dd9e541e);

jint _JC_JCNI_ATTR
_jc_javax_crypto_Cipher$method$doFinal$b07fbc67dd9e541e(_jc_env *const env, _jc_javax_crypto_Cipher$object *this, _jc_byte_array *param0, jint param1, jint param2, _jc_byte_array *param3)
{
	jint i0;
	jint i1;
	struct _jc_javax_crypto_Cipher$object *r0;
	_jc_byte_array *r1;
	_jc_byte_array *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	i0 = param1;
	i1 = param2;
	r2 = param3;
	_JC_LINE_NUMBER(589);				// 0
	i1 = _JC_INVOKE_NONVIRTUAL(env, javax_crypto_Cipher, doFinal$a67b3f796179b9a3, 0, r0, r1, i0, i1, r2, 0);
	return i1;
}

//
// public final int doFinal(byte[], int, int, byte[], int) throws java.lang.IllegalStateException, javax.crypto.IllegalBlockSizeException, javax.crypto.BadPaddingException, javax.crypto.ShortBufferException
//

static _jc_linenum _jc_javax_crypto_Cipher$linenum_table$doFinal$a67b3f796179b9a3[];

static const unsigned char _jc_javax_crypto_Cipher$param_ptypes$doFinal$a67b3f796179b9a3[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_INT, _JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_INT };

static _jc_type *const _jc_javax_crypto_Cipher$exceptions$doFinal$a67b3f796179b9a3[] = {
	&_jc_java_lang_IllegalStateException$type,
	&_jc_javax_crypto_IllegalBlockSizeException$type,
	&_jc_javax_crypto_BadPaddingException$type,
	&_jc_javax_crypto_ShortBufferException$type
};

static _jc_type *const _jc_javax_crypto_Cipher$param_types$doFinal$a67b3f796179b9a3[] = {
	&_jc_byte$array$prim$type,
	&_jc_int$prim$type,
	&_jc_int$prim$type,
	&_jc_byte$array$prim$type,
	&_jc_int$prim$type
};

_jc_method _jc_javax_crypto_Cipher$method_info$doFinal$a67b3f796179b9a3 = {
	.name=			"doFinal",
	.signature=		"([BII[BI)I",
	.class=			&_jc_javax_crypto_Cipher$type,
	.param_types=		&_jc_javax_crypto_Cipher$param_types$doFinal$a67b3f796179b9a3,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_javax_crypto_Cipher$param_ptypes$doFinal$a67b3f796179b9a3,
	.signature_hash=	_JC_JLONG(0xa67b3f796179b9a3),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_Cipher$method$doFinal$a67b3f796179b9a3,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_Cipher$vtable, javax_crypto_Cipher.doFinal$a67b3f796179b9a3) / sizeof(void *),
	.num_parameters=	5,
	.num_exceptions=	4,
	.exceptions=		&_jc_javax_crypto_Cipher$exceptions$doFinal$a67b3f796179b9a3,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	8,
	      .table=	_jc_javax_crypto_Cipher$linenum_table$doFinal$a67b3f796179b9a3
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_Cipher, doFinal$a67b3f796179b9a3);

jint _JC_JCNI_ATTR
_jc_javax_crypto_Cipher$method$doFinal$a67b3f796179b9a3(_jc_env *const env, _jc_javax_crypto_Cipher$object *this, _jc_byte_array *param0, jint param1, jint param2, _jc_byte_array *param3, jint param4)
{
	jint i0;
	jint i1;
	jint i2;
	jint i3;
	struct _jc_javax_crypto_Cipher$object *r0;
	_jc_byte_array *r1;
	struct _jc_java_lang_VMThrowable$object *r10;
	_jc_byte_array *r2;
	struct _jc_javax_crypto_CipherSpi$object *r3;
	struct _jc_javax_crypto_ShortBufferException$object *r4;
	struct _jc_java_lang_IllegalStateException$object *r5;
	struct _jc_java_lang_String$object *r6;
	struct _jc_java_lang_String$object *r7;
	struct _jc_java_lang_VMThrowable$object *r8;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	i0 = param1;
	i1 = param2;
	r2 = param3;
	i2 = param4;
	_JC_LINE_NUMBER(566);				// 0
	r3 = _JC_REF_FIELD(env, r0, javax_crypto_Cipher, cipherSpi);
	if (r3 != _JC_NULL)
		goto label1;
	_JC_LINE_NUMBER(568);				// 1
	i3 = _JC_ARRAY_LENGTH(env, r2);
	i3 = i3 - i2;
	if (i1 <= i3)
		goto label0;
	_JC_LINE_NUMBER(570);				// 2
	r4 = _JC_NEW(env, javax_crypto_ShortBufferException);
	r7 = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r8 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r8;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r7;
	_JC_THROW(env, r4);

label0:
	_JC_ACTIVE_USE(env, java_lang_System);
	_JC_INVOKE_STATIC(env, java_lang_VMSystem, arraycopy$4286a72d57744cd8, 0, r1, i0, r2, i2, i1);
	_JC_LINE_NUMBER(573);				// 3
	return i1;

label1:
	_JC_LINE_NUMBER(575);				// 4
	i3 = _JC_PRIM_FIELD(env, r0, javax_crypto_Cipher, state);
	if (i3 == 1)
		goto label2;
	i3 = _JC_PRIM_FIELD(env, r0, javax_crypto_Cipher, state);
	if (i3 == 2)
		goto label2;
	_JC_LINE_NUMBER(577);				// 5
	r5 = _JC_NEW(env, java_lang_IllegalStateException);
	r6 = _JC_STRING(env, "neither encrypting nor decrypting");
	_JC_REF_FIELD(env, r5, java_lang_Throwable, cause) = r5;
	r10 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r5);
	_JC_REF_FIELD(env, r5, java_lang_Throwable, vmState) = r10;
	_JC_REF_FIELD(env, r5, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r5, java_lang_Throwable, detailMessage) = r6;
	_JC_THROW(env, r5);

label2:
	_JC_LINE_NUMBER(579);				// 6
	_JC_PRIM_FIELD(env, r0, javax_crypto_Cipher, state) = 0;
	_JC_LINE_NUMBER(580);				// 7
	r3 = _JC_REF_FIELD(env, r0, javax_crypto_Cipher, cipherSpi);
	i3 = _JC_INVOKE_VIRTUAL(env, javax_crypto_CipherSpi, engineDoFinal$1df4228b1a6d48a9, r3, r1, i0, i1, r2, i2);
	return i3;
}

//
// public final java.lang.String getAlgorithm()
//

static _jc_linenum _jc_javax_crypto_Cipher$linenum_table$getAlgorithm$19abbbc132b9063a[];

static const unsigned char _jc_javax_crypto_Cipher$param_ptypes$getAlgorithm$19abbbc132b9063a[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_javax_crypto_Cipher$method_info$getAlgorithm$19abbbc132b9063a = {
	.name=			"getAlgorithm",
	.signature=		"()Ljava/lang/String;",
	.class=			&_jc_javax_crypto_Cipher$type,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_javax_crypto_Cipher$param_ptypes$getAlgorithm$19abbbc132b9063a,
	.signature_hash=	_JC_JLONG(0x19abbbc132b9063a),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_Cipher$method$getAlgorithm$19abbbc132b9063a,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_Cipher$vtable, javax_crypto_Cipher.getAlgorithm$19abbbc132b9063a) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_crypto_Cipher$linenum_table$getAlgorithm$19abbbc132b9063a
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_Cipher, getAlgorithm$19abbbc132b9063a);

_jc_java_lang_String$object * _JC_JCNI_ATTR
_jc_javax_crypto_Cipher$method$getAlgorithm$19abbbc132b9063a(_jc_env *const env, _jc_javax_crypto_Cipher$object *this)
{
	struct _jc_javax_crypto_Cipher$object *r0;
	struct _jc_java_lang_String$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(359);				// 0
	r1 = _JC_REF_FIELD(env, r0, javax_crypto_Cipher, transformation);
	return r1;
}

//
// public final int getBlockSize()
//

static _jc_linenum _jc_javax_crypto_Cipher$linenum_table$getBlockSize$8edb6c820a61ffb7[];

static const unsigned char _jc_javax_crypto_Cipher$param_ptypes$getBlockSize$8edb6c820a61ffb7[] = { 
_JC_TYPE_INT };

_jc_method _jc_javax_crypto_Cipher$method_info$getBlockSize$8edb6c820a61ffb7 = {
	.name=			"getBlockSize",
	.signature=		"()I",
	.class=			&_jc_javax_crypto_Cipher$type,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_javax_crypto_Cipher$param_ptypes$getBlockSize$8edb6c820a61ffb7,
	.signature_hash=	_JC_JLONG(0x8edb6c820a61ffb7),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_Cipher$method$getBlockSize$8edb6c820a61ffb7,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_Cipher$vtable, javax_crypto_Cipher.getBlockSize$8edb6c820a61ffb7) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_javax_crypto_Cipher$linenum_table$getBlockSize$8edb6c820a61ffb7
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_Cipher, getBlockSize$8edb6c820a61ffb7);

jint _JC_JCNI_ATTR
_jc_javax_crypto_Cipher$method$getBlockSize$8edb6c820a61ffb7(_jc_env *const env, _jc_javax_crypto_Cipher$object *this)
{
	jint i0;
	struct _jc_javax_crypto_Cipher$object *r0;
	struct _jc_javax_crypto_CipherSpi$object *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(369);				// 0
	r1 = _JC_REF_FIELD(env, r0, javax_crypto_Cipher, cipherSpi);
	if (r1 == _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(371);				// 1
	r1 = _JC_REF_FIELD(env, r0, javax_crypto_Cipher, cipherSpi);
	i0 = _JC_INVOKE_VIRTUAL(env, javax_crypto_CipherSpi, engineGetBlockSize$d4858c33205171e0, r1);
	return i0;

label0:
	_JC_LINE_NUMBER(373);				// 2
	return 1;
}

//
// public final javax.crypto.ExemptionMechanism getExemptionMechanism()
//

static _jc_linenum _jc_javax_crypto_Cipher$linenum_table$getExemptionMechanism$4c9b606576eb6984[];

static const unsigned char _jc_javax_crypto_Cipher$param_ptypes$getExemptionMechanism$4c9b606576eb6984[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_javax_crypto_Cipher$method_info$getExemptionMechanism$4c9b606576eb6984 = {
	.name=			"getExemptionMechanism",
	.signature=		"()Ljavax/crypto/ExemptionMechanism;",
	.class=			&_jc_javax_crypto_Cipher$type,
	.return_type=		&_jc_javax_crypto_ExemptionMechanism$type,
	.param_ptypes=		&_jc_javax_crypto_Cipher$param_ptypes$getExemptionMechanism$4c9b606576eb6984,
	.signature_hash=	_JC_JLONG(0x4c9b606576eb6984),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_Cipher$method$getExemptionMechanism$4c9b606576eb6984,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_Cipher$vtable, javax_crypto_Cipher.getExemptionMechanism$4c9b606576eb6984) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_crypto_Cipher$linenum_table$getExemptionMechanism$4c9b606576eb6984
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_Cipher, getExemptionMechanism$4c9b606576eb6984);

_jc_javax_crypto_ExemptionMechanism$object * _JC_JCNI_ATTR
_jc_javax_crypto_Cipher$method$getExemptionMechanism$4c9b606576eb6984(_jc_env *const env, _jc_javax_crypto_Cipher$object *this)
{
	struct _jc_javax_crypto_Cipher$object *r0;

	r0 = this;
	_JC_LINE_NUMBER(383);				// 0
	return _JC_NULL;
}

//
// public final byte[] getIV()
//

static _jc_linenum _jc_javax_crypto_Cipher$linenum_table$getIV$4134a0c13b73072e[];

static const unsigned char _jc_javax_crypto_Cipher$param_ptypes$getIV$4134a0c13b73072e[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_javax_crypto_Cipher$method_info$getIV$4134a0c13b73072e = {
	.name=			"getIV",
	.signature=		"()[B",
	.class=			&_jc_javax_crypto_Cipher$type,
	.return_type=		&_jc_byte$array$prim$type,
	.param_ptypes=		&_jc_javax_crypto_Cipher$param_ptypes$getIV$4134a0c13b73072e,
	.signature_hash=	_JC_JLONG(0x4134a0c13b73072e),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_Cipher$method$getIV$4134a0c13b73072e,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_Cipher$vtable, javax_crypto_Cipher.getIV$4134a0c13b73072e) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_javax_crypto_Cipher$linenum_table$getIV$4134a0c13b73072e
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_Cipher, getIV$4134a0c13b73072e);

_jc_byte_array * _JC_JCNI_ATTR
_jc_javax_crypto_Cipher$method$getIV$4134a0c13b73072e(_jc_env *const env, _jc_javax_crypto_Cipher$object *this)
{
	struct _jc_javax_crypto_Cipher$object *r0;
	struct _jc_javax_crypto_CipherSpi$object *r1;
	_jc_byte_array *r3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(394);				// 0
	r1 = _JC_REF_FIELD(env, r0, javax_crypto_Cipher, cipherSpi);
	if (r1 == _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(396);				// 1
	r1 = _JC_REF_FIELD(env, r0, javax_crypto_Cipher, cipherSpi);
	r3 = _JC_INVOKE_VIRTUAL(env, javax_crypto_CipherSpi, engineGetIV$8ecd827504f9a89f, r1);
	return r3;

label0:
	_JC_LINE_NUMBER(398);				// 2
	return _JC_NULL;
}

//
// public final int getOutputSize(int) throws java.lang.IllegalStateException
//

static _jc_linenum _jc_javax_crypto_Cipher$linenum_table$getOutputSize$972045742a73f7e4[];

static const unsigned char _jc_javax_crypto_Cipher$param_ptypes$getOutputSize$972045742a73f7e4[] = { 
_JC_TYPE_INT, _JC_TYPE_INT };

static _jc_type *const _jc_javax_crypto_Cipher$exceptions$getOutputSize$972045742a73f7e4[] = {
	&_jc_java_lang_IllegalStateException$type
};

static _jc_type *const _jc_javax_crypto_Cipher$param_types$getOutputSize$972045742a73f7e4[] = {
	&_jc_int$prim$type
};

_jc_method _jc_javax_crypto_Cipher$method_info$getOutputSize$972045742a73f7e4 = {
	.name=			"getOutputSize",
	.signature=		"(I)I",
	.class=			&_jc_javax_crypto_Cipher$type,
	.param_types=		&_jc_javax_crypto_Cipher$param_types$getOutputSize$972045742a73f7e4,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_javax_crypto_Cipher$param_ptypes$getOutputSize$972045742a73f7e4,
	.signature_hash=	_JC_JLONG(0x972045742a73f7e4),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_Cipher$method$getOutputSize$972045742a73f7e4,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_Cipher$vtable, javax_crypto_Cipher.getOutputSize$972045742a73f7e4) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_crypto_Cipher$exceptions$getOutputSize$972045742a73f7e4,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_javax_crypto_Cipher$linenum_table$getOutputSize$972045742a73f7e4
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_Cipher, getOutputSize$972045742a73f7e4);

jint _JC_JCNI_ATTR
_jc_javax_crypto_Cipher$method$getOutputSize$972045742a73f7e4(_jc_env *const env, _jc_javax_crypto_Cipher$object *this, jint param0)
{
	jint i0;
	jint i1;
	struct _jc_javax_crypto_Cipher$object *r0;
	struct _jc_javax_crypto_CipherSpi$object *r1;
	struct _jc_java_lang_IllegalStateException$object *r2;
	struct _jc_java_lang_String$object *r3;
	struct _jc_java_lang_VMThrowable$object *r5;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	i0 = param0;
	_JC_LINE_NUMBER(604);				// 0
	r1 = _JC_REF_FIELD(env, r0, javax_crypto_Cipher, cipherSpi);
	if (r1 != _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(606);				// 1
	return i0;

label0:
	_JC_LINE_NUMBER(608);				// 2
	i1 = _JC_PRIM_FIELD(env, r0, javax_crypto_Cipher, state);
	if (i1 == 1)
		goto label1;
	i1 = _JC_PRIM_FIELD(env, r0, javax_crypto_Cipher, state);
	if (i1 == 2)
		goto label1;
	_JC_LINE_NUMBER(610);				// 3
	r2 = _JC_NEW(env, java_lang_IllegalStateException);
	r3 = _JC_STRING(env, "neither encrypting nor decrypting");
	_JC_REF_FIELD(env, r2, java_lang_Throwable, cause) = r2;
	r5 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r2);
	_JC_REF_FIELD(env, r2, java_lang_Throwable, vmState) = r5;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, detailMessage) = r3;
	_JC_THROW(env, r2);

label1:
	_JC_LINE_NUMBER(612);				// 4
	r1 = _JC_REF_FIELD(env, r0, javax_crypto_Cipher, cipherSpi);
	i1 = _JC_INVOKE_VIRTUAL(env, javax_crypto_CipherSpi, engineGetOutputSize$e13ccb96d0f1b0bb, r1, i0);
	return i1;
}

//
// public final java.security.AlgorithmParameters getParameters()
//

static _jc_linenum _jc_javax_crypto_Cipher$linenum_table$getParameters$a88c24c7a8311218[];

static const unsigned char _jc_javax_crypto_Cipher$param_ptypes$getParameters$a88c24c7a8311218[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_javax_crypto_Cipher$method_info$getParameters$a88c24c7a8311218 = {
	.name=			"getParameters",
	.signature=		"()Ljava/security/AlgorithmParameters;",
	.class=			&_jc_javax_crypto_Cipher$type,
	.return_type=		&_jc_java_security_AlgorithmParameters$type,
	.param_ptypes=		&_jc_javax_crypto_Cipher$param_ptypes$getParameters$a88c24c7a8311218,
	.signature_hash=	_JC_JLONG(0xa88c24c7a8311218),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_Cipher$method$getParameters$a88c24c7a8311218,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_Cipher$vtable, javax_crypto_Cipher.getParameters$a88c24c7a8311218) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_javax_crypto_Cipher$linenum_table$getParameters$a88c24c7a8311218
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_Cipher, getParameters$a88c24c7a8311218);

_jc_java_security_AlgorithmParameters$object * _JC_JCNI_ATTR
_jc_javax_crypto_Cipher$method$getParameters$a88c24c7a8311218(_jc_env *const env, _jc_javax_crypto_Cipher$object *this)
{
	struct _jc_javax_crypto_Cipher$object *r0;
	struct _jc_javax_crypto_CipherSpi$object *r1;
	struct _jc_java_security_AlgorithmParameters$object *r3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(409);				// 0
	r1 = _JC_REF_FIELD(env, r0, javax_crypto_Cipher, cipherSpi);
	if (r1 == _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(410);				// 1
	r1 = _JC_REF_FIELD(env, r0, javax_crypto_Cipher, cipherSpi);
	r3 = _JC_INVOKE_VIRTUAL(env, javax_crypto_CipherSpi, engineGetParameters$4feb0e256d9d7317, r1);
	return r3;

label0:
	_JC_LINE_NUMBER(412);				// 2
	return _JC_NULL;
}

//
// public final java.security.Provider getProvider()
//

static _jc_linenum _jc_javax_crypto_Cipher$linenum_table$getProvider$e8f9c9fb14140d5a[];

static const unsigned char _jc_javax_crypto_Cipher$param_ptypes$getProvider$e8f9c9fb14140d5a[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_javax_crypto_Cipher$method_info$getProvider$e8f9c9fb14140d5a = {
	.name=			"getProvider",
	.signature=		"()Ljava/security/Provider;",
	.class=			&_jc_javax_crypto_Cipher$type,
	.return_type=		&_jc_java_security_Provider$type,
	.param_ptypes=		&_jc_javax_crypto_Cipher$param_ptypes$getProvider$e8f9c9fb14140d5a,
	.signature_hash=	_JC_JLONG(0xe8f9c9fb14140d5a),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_Cipher$method$getProvider$e8f9c9fb14140d5a,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_Cipher$vtable, javax_crypto_Cipher.getProvider$e8f9c9fb14140d5a) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_crypto_Cipher$linenum_table$getProvider$e8f9c9fb14140d5a
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_Cipher, getProvider$e8f9c9fb14140d5a);

_jc_java_security_Provider$object * _JC_JCNI_ATTR
_jc_javax_crypto_Cipher$method$getProvider$e8f9c9fb14140d5a(_jc_env *const env, _jc_javax_crypto_Cipher$object *this)
{
	struct _jc_javax_crypto_Cipher$object *r0;
	struct _jc_java_security_Provider$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(422);				// 0
	r1 = _JC_REF_FIELD(env, r0, javax_crypto_Cipher, provider);
	return r1;
}

//
// public final void init(int, java.security.Key) throws java.security.InvalidKeyException
//

static _jc_linenum _jc_javax_crypto_Cipher$linenum_table$init$81cdff4db8bca485[];

static const unsigned char _jc_javax_crypto_Cipher$param_ptypes$init$81cdff4db8bca485[] = { 
_JC_TYPE_INT, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_Cipher$exceptions$init$81cdff4db8bca485[] = {
	&_jc_java_security_InvalidKeyException$type
};

static _jc_type *const _jc_javax_crypto_Cipher$param_types$init$81cdff4db8bca485[] = {
	&_jc_int$prim$type,
	&_jc_java_security_Key$type
};

_jc_method _jc_javax_crypto_Cipher$method_info$init$81cdff4db8bca485 = {
	.name=			"init",
	.signature=		"(ILjava/security/Key;)V",
	.class=			&_jc_javax_crypto_Cipher$type,
	.param_types=		&_jc_javax_crypto_Cipher$param_types$init$81cdff4db8bca485,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_Cipher$param_ptypes$init$81cdff4db8bca485,
	.signature_hash=	_JC_JLONG(0x81cdff4db8bca485),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_Cipher$method$init$81cdff4db8bca485,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_Cipher$vtable, javax_crypto_Cipher.init$81cdff4db8bca485) / sizeof(void *),
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_crypto_Cipher$exceptions$init$81cdff4db8bca485,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_javax_crypto_Cipher$linenum_table$init$81cdff4db8bca485
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_Cipher, init$81cdff4db8bca485);

void _JC_JCNI_ATTR
_jc_javax_crypto_Cipher$method$init$81cdff4db8bca485(_jc_env *const env, _jc_javax_crypto_Cipher$object *this, jint param0, _jc_object *param1)
{
	jint i0;
	struct _jc_javax_crypto_Cipher$object *r0;
	struct _jc_object *r1;
	struct _jc_java_security_SecureRandom$object *r2;
	struct _jc_javax_crypto_CipherSpi$object *r3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	i0 = param0;
	r1 = param1;
	_JC_LINE_NUMBER(675);				// 0
	_JC_PRIM_FIELD(env, r0, javax_crypto_Cipher, state) = i0;
	_JC_LINE_NUMBER(676);				// 1
	r3 = _JC_REF_FIELD(env, r0, javax_crypto_Cipher, cipherSpi);
	if (r3 == _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(678);				// 2
	r3 = _JC_REF_FIELD(env, r0, javax_crypto_Cipher, cipherSpi);
	r2 = _JC_NEW(env, java_security_SecureRandom);
	_JC_INVOKE_NONVIRTUAL(env, java_security_SecureRandom, _init$52f4ad9f2989aeee, 0, r2);
	_JC_INVOKE_VIRTUAL(env, javax_crypto_CipherSpi, engineInit$13bd7fdfaabb778a, r3, i0, r1, r2);

label0:
	_JC_LINE_NUMBER(680);				// 3
	return;
}

//
// public final void init(int, java.security.Key, java.security.AlgorithmParameters) throws java.security.InvalidKeyException, java.security.InvalidAlgorithmParameterException
//

static _jc_linenum _jc_javax_crypto_Cipher$linenum_table$init$6179c31d383fade7[];

static const unsigned char _jc_javax_crypto_Cipher$param_ptypes$init$6179c31d383fade7[] = { 
_JC_TYPE_INT, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_Cipher$exceptions$init$6179c31d383fade7[] = {
	&_jc_java_security_InvalidKeyException$type,
	&_jc_java_security_InvalidAlgorithmParameterException$type
};

static _jc_type *const _jc_javax_crypto_Cipher$param_types$init$6179c31d383fade7[] = {
	&_jc_int$prim$type,
	&_jc_java_security_Key$type,
	&_jc_java_security_AlgorithmParameters$type
};

_jc_method _jc_javax_crypto_Cipher$method_info$init$6179c31d383fade7 = {
	.name=			"init",
	.signature=		"(ILjava/security/Key;Ljava/security/AlgorithmParameters;)V",
	.class=			&_jc_javax_crypto_Cipher$type,
	.param_types=		&_jc_javax_crypto_Cipher$param_types$init$6179c31d383fade7,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_Cipher$param_ptypes$init$6179c31d383fade7,
	.signature_hash=	_JC_JLONG(0x6179c31d383fade7),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_Cipher$method$init$6179c31d383fade7,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_Cipher$vtable, javax_crypto_Cipher.init$6179c31d383fade7) / sizeof(void *),
	.num_parameters=	3,
	.num_exceptions=	2,
	.exceptions=		&_jc_javax_crypto_Cipher$exceptions$init$6179c31d383fade7,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_javax_crypto_Cipher$linenum_table$init$6179c31d383fade7
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_Cipher, init$6179c31d383fade7);

void _JC_JCNI_ATTR
_jc_javax_crypto_Cipher$method$init$6179c31d383fade7(_jc_env *const env, _jc_javax_crypto_Cipher$object *this, jint param0, _jc_object *param1, _jc_java_security_AlgorithmParameters$object *param2)
{
	jint i0;
	struct _jc_javax_crypto_Cipher$object *r0;
	struct _jc_object *r1;
	struct _jc_java_security_AlgorithmParameters$object *r2;
	struct _jc_java_security_SecureRandom$object *r3;
	struct _jc_javax_crypto_CipherSpi$object *r8;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	i0 = param0;
	r1 = param1;
	r2 = param2;
	_JC_LINE_NUMBER(830);				// 0
	r3 = _JC_NEW(env, java_security_SecureRandom);
	_JC_INVOKE_NONVIRTUAL(env, java_security_SecureRandom, _init$52f4ad9f2989aeee, 0, r3);
	_JC_PRIM_FIELD(env, r0, javax_crypto_Cipher, state) = i0;
	r8 = _JC_REF_FIELD(env, r0, javax_crypto_Cipher, cipherSpi);
	if (r8 == _JC_NULL)
		goto label0;
	r8 = _JC_REF_FIELD(env, r0, javax_crypto_Cipher, cipherSpi);
	_JC_INVOKE_VIRTUAL(env, javax_crypto_CipherSpi, engineInit$f45402b139c1cc04, r8, i0, r1, r2, r3);

label0:
	_JC_LINE_NUMBER(831);				// 1
	return;
}

//
// public final void init(int, java.security.Key, java.security.AlgorithmParameters, java.security.SecureRandom) throws java.security.InvalidKeyException, java.security.InvalidAlgorithmParameterException
//

static _jc_linenum _jc_javax_crypto_Cipher$linenum_table$init$9de42f5c07f9453c[];

static const unsigned char _jc_javax_crypto_Cipher$param_ptypes$init$9de42f5c07f9453c[] = { 
_JC_TYPE_INT, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_Cipher$exceptions$init$9de42f5c07f9453c[] = {
	&_jc_java_security_InvalidKeyException$type,
	&_jc_java_security_InvalidAlgorithmParameterException$type
};

static _jc_type *const _jc_javax_crypto_Cipher$param_types$init$9de42f5c07f9453c[] = {
	&_jc_int$prim$type,
	&_jc_java_security_Key$type,
	&_jc_java_security_AlgorithmParameters$type,
	&_jc_java_security_SecureRandom$type
};

_jc_method _jc_javax_crypto_Cipher$method_info$init$9de42f5c07f9453c = {
	.name=			"init",
	.signature=		"(ILjava/security/Key;Ljava/security/AlgorithmParameters;Ljava/security/SecureRandom;)V",
	.class=			&_jc_javax_crypto_Cipher$type,
	.param_types=		&_jc_javax_crypto_Cipher$param_types$init$9de42f5c07f9453c,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_Cipher$param_ptypes$init$9de42f5c07f9453c,
	.signature_hash=	_JC_JLONG(0x9de42f5c07f9453c),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_Cipher$method$init$9de42f5c07f9453c,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_Cipher$vtable, javax_crypto_Cipher.init$9de42f5c07f9453c) / sizeof(void *),
	.num_parameters=	4,
	.num_exceptions=	2,
	.exceptions=		&_jc_javax_crypto_Cipher$exceptions$init$9de42f5c07f9453c,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_javax_crypto_Cipher$linenum_table$init$9de42f5c07f9453c
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_Cipher, init$9de42f5c07f9453c);

void _JC_JCNI_ATTR
_jc_javax_crypto_Cipher$method$init$9de42f5c07f9453c(_jc_env *const env, _jc_javax_crypto_Cipher$object *this, jint param0, _jc_object *param1, _jc_java_security_AlgorithmParameters$object *param2, _jc_java_security_SecureRandom$object *param3)
{
	jint i0;
	struct _jc_javax_crypto_Cipher$object *r0;
	struct _jc_object *r1;
	struct _jc_java_security_AlgorithmParameters$object *r2;
	struct _jc_java_security_SecureRandom$object *r3;
	struct _jc_javax_crypto_CipherSpi$object *r4;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	i0 = param0;
	r1 = param1;
	r2 = param2;
	r3 = param3;
	_JC_LINE_NUMBER(893);				// 0
	_JC_PRIM_FIELD(env, r0, javax_crypto_Cipher, state) = i0;
	_JC_LINE_NUMBER(894);				// 1
	r4 = _JC_REF_FIELD(env, r0, javax_crypto_Cipher, cipherSpi);
	if (r4 == _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(896);				// 2
	r4 = _JC_REF_FIELD(env, r0, javax_crypto_Cipher, cipherSpi);
	_JC_INVOKE_VIRTUAL(env, javax_crypto_CipherSpi, engineInit$f45402b139c1cc04, r4, i0, r1, r2, r3);

label0:
	_JC_LINE_NUMBER(898);				// 3
	return;
}

//
// public final void init(int, java.security.Key, java.security.SecureRandom) throws java.security.InvalidKeyException
//

static _jc_linenum _jc_javax_crypto_Cipher$linenum_table$init$f85927523f39766b[];

static const unsigned char _jc_javax_crypto_Cipher$param_ptypes$init$f85927523f39766b[] = { 
_JC_TYPE_INT, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_Cipher$exceptions$init$f85927523f39766b[] = {
	&_jc_java_security_InvalidKeyException$type
};

static _jc_type *const _jc_javax_crypto_Cipher$param_types$init$f85927523f39766b[] = {
	&_jc_int$prim$type,
	&_jc_java_security_Key$type,
	&_jc_java_security_SecureRandom$type
};

_jc_method _jc_javax_crypto_Cipher$method_info$init$f85927523f39766b = {
	.name=			"init",
	.signature=		"(ILjava/security/Key;Ljava/security/SecureRandom;)V",
	.class=			&_jc_javax_crypto_Cipher$type,
	.param_types=		&_jc_javax_crypto_Cipher$param_types$init$f85927523f39766b,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_Cipher$param_ptypes$init$f85927523f39766b,
	.signature_hash=	_JC_JLONG(0xf85927523f39766b),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_Cipher$method$init$f85927523f39766b,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_Cipher$vtable, javax_crypto_Cipher.init$f85927523f39766b) / sizeof(void *),
	.num_parameters=	3,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_crypto_Cipher$exceptions$init$f85927523f39766b,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_javax_crypto_Cipher$linenum_table$init$f85927523f39766b
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_Cipher, init$f85927523f39766b);

void _JC_JCNI_ATTR
_jc_javax_crypto_Cipher$method$init$f85927523f39766b(_jc_env *const env, _jc_javax_crypto_Cipher$object *this, jint param0, _jc_object *param1, _jc_java_security_SecureRandom$object *param2)
{
	jint i0;
	struct _jc_javax_crypto_Cipher$object *r0;
	struct _jc_object *r1;
	struct _jc_java_security_SecureRandom$object *r2;
	struct _jc_javax_crypto_CipherSpi$object *r3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	i0 = param0;
	r1 = param1;
	r2 = param2;
	_JC_LINE_NUMBER(794);				// 0
	_JC_PRIM_FIELD(env, r0, javax_crypto_Cipher, state) = i0;
	_JC_LINE_NUMBER(795);				// 1
	r3 = _JC_REF_FIELD(env, r0, javax_crypto_Cipher, cipherSpi);
	if (r3 == _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(797);				// 2
	r3 = _JC_REF_FIELD(env, r0, javax_crypto_Cipher, cipherSpi);
	_JC_INVOKE_VIRTUAL(env, javax_crypto_CipherSpi, engineInit$13bd7fdfaabb778a, r3, i0, r1, r2);

label0:
	_JC_LINE_NUMBER(799);				// 3
	return;
}

//
// public final void init(int, java.security.Key, java.security.spec.AlgorithmParameterSpec) throws java.security.InvalidKeyException, java.security.InvalidAlgorithmParameterException
//

static _jc_linenum _jc_javax_crypto_Cipher$linenum_table$init$98506c62eefa99c0[];

static const unsigned char _jc_javax_crypto_Cipher$param_ptypes$init$98506c62eefa99c0[] = { 
_JC_TYPE_INT, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_Cipher$exceptions$init$98506c62eefa99c0[] = {
	&_jc_java_security_InvalidKeyException$type,
	&_jc_java_security_InvalidAlgorithmParameterException$type
};

static _jc_type *const _jc_javax_crypto_Cipher$param_types$init$98506c62eefa99c0[] = {
	&_jc_int$prim$type,
	&_jc_java_security_Key$type,
	&_jc_java_security_spec_AlgorithmParameterSpec$type
};

_jc_method _jc_javax_crypto_Cipher$method_info$init$98506c62eefa99c0 = {
	.name=			"init",
	.signature=		"(ILjava/security/Key;Ljava/security/spec/AlgorithmParameterSpec;)V",
	.class=			&_jc_javax_crypto_Cipher$type,
	.param_types=		&_jc_javax_crypto_Cipher$param_types$init$98506c62eefa99c0,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_Cipher$param_ptypes$init$98506c62eefa99c0,
	.signature_hash=	_JC_JLONG(0x98506c62eefa99c0),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_Cipher$method$init$98506c62eefa99c0,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_Cipher$vtable, javax_crypto_Cipher.init$98506c62eefa99c0) / sizeof(void *),
	.num_parameters=	3,
	.num_exceptions=	2,
	.exceptions=		&_jc_javax_crypto_Cipher$exceptions$init$98506c62eefa99c0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_javax_crypto_Cipher$linenum_table$init$98506c62eefa99c0
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_Cipher, init$98506c62eefa99c0);

void _JC_JCNI_ATTR
_jc_javax_crypto_Cipher$method$init$98506c62eefa99c0(_jc_env *const env, _jc_javax_crypto_Cipher$object *this, jint param0, _jc_object *param1, _jc_object *param2)
{
	jint i0;
	struct _jc_javax_crypto_Cipher$object *r0;
	struct _jc_object *r1;
	struct _jc_object *r2;
	struct _jc_java_security_SecureRandom$object *r3;
	struct _jc_javax_crypto_CipherSpi$object *r8;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	i0 = param0;
	r1 = param1;
	r2 = param2;
	_JC_LINE_NUMBER(862);				// 0
	r3 = _JC_NEW(env, java_security_SecureRandom);
	_JC_INVOKE_NONVIRTUAL(env, java_security_SecureRandom, _init$52f4ad9f2989aeee, 0, r3);
	_JC_PRIM_FIELD(env, r0, javax_crypto_Cipher, state) = i0;
	r8 = _JC_REF_FIELD(env, r0, javax_crypto_Cipher, cipherSpi);
	if (r8 == _JC_NULL)
		goto label0;
	r8 = _JC_REF_FIELD(env, r0, javax_crypto_Cipher, cipherSpi);
	_JC_INVOKE_VIRTUAL(env, javax_crypto_CipherSpi, engineInit$2a99829520b831a2, r8, i0, r1, r2, r3);

label0:
	_JC_LINE_NUMBER(863);				// 1
	return;
}

//
// public final void init(int, java.security.Key, java.security.spec.AlgorithmParameterSpec, java.security.SecureRandom) throws java.security.InvalidKeyException, java.security.InvalidAlgorithmParameterException
//

static _jc_linenum _jc_javax_crypto_Cipher$linenum_table$init$fa78b8775e05400b[];

static const unsigned char _jc_javax_crypto_Cipher$param_ptypes$init$fa78b8775e05400b[] = { 
_JC_TYPE_INT, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_Cipher$exceptions$init$fa78b8775e05400b[] = {
	&_jc_java_security_InvalidKeyException$type,
	&_jc_java_security_InvalidAlgorithmParameterException$type
};

static _jc_type *const _jc_javax_crypto_Cipher$param_types$init$fa78b8775e05400b[] = {
	&_jc_int$prim$type,
	&_jc_java_security_Key$type,
	&_jc_java_security_spec_AlgorithmParameterSpec$type,
	&_jc_java_security_SecureRandom$type
};

_jc_method _jc_javax_crypto_Cipher$method_info$init$fa78b8775e05400b = {
	.name=			"init",
	.signature=		"(ILjava/security/Key;Ljava/security/spec/AlgorithmParameterSpec;Ljava/security/SecureRandom;)V",
	.class=			&_jc_javax_crypto_Cipher$type,
	.param_types=		&_jc_javax_crypto_Cipher$param_types$init$fa78b8775e05400b,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_Cipher$param_ptypes$init$fa78b8775e05400b,
	.signature_hash=	_JC_JLONG(0xfa78b8775e05400b),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_Cipher$method$init$fa78b8775e05400b,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_Cipher$vtable, javax_crypto_Cipher.init$fa78b8775e05400b) / sizeof(void *),
	.num_parameters=	4,
	.num_exceptions=	2,
	.exceptions=		&_jc_javax_crypto_Cipher$exceptions$init$fa78b8775e05400b,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_javax_crypto_Cipher$linenum_table$init$fa78b8775e05400b
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_Cipher, init$fa78b8775e05400b);

void _JC_JCNI_ATTR
_jc_javax_crypto_Cipher$method$init$fa78b8775e05400b(_jc_env *const env, _jc_javax_crypto_Cipher$object *this, jint param0, _jc_object *param1, _jc_object *param2, _jc_java_security_SecureRandom$object *param3)
{
	jint i0;
	struct _jc_javax_crypto_Cipher$object *r0;
	struct _jc_object *r1;
	struct _jc_object *r2;
	struct _jc_java_security_SecureRandom$object *r3;
	struct _jc_javax_crypto_CipherSpi$object *r4;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	i0 = param0;
	r1 = param1;
	r2 = param2;
	r3 = param3;
	_JC_LINE_NUMBER(928);				// 0
	_JC_PRIM_FIELD(env, r0, javax_crypto_Cipher, state) = i0;
	_JC_LINE_NUMBER(929);				// 1
	r4 = _JC_REF_FIELD(env, r0, javax_crypto_Cipher, cipherSpi);
	if (r4 == _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(931);				// 2
	r4 = _JC_REF_FIELD(env, r0, javax_crypto_Cipher, cipherSpi);
	_JC_INVOKE_VIRTUAL(env, javax_crypto_CipherSpi, engineInit$2a99829520b831a2, r4, i0, r1, r2, r3);

label0:
	_JC_LINE_NUMBER(933);				// 3
	return;
}

//
// public final void init(int, java.security.cert.Certificate) throws java.security.InvalidKeyException
//

static _jc_linenum _jc_javax_crypto_Cipher$linenum_table$init$20ec894fa448e181[];

static const unsigned char _jc_javax_crypto_Cipher$param_ptypes$init$20ec894fa448e181[] = { 
_JC_TYPE_INT, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_Cipher$exceptions$init$20ec894fa448e181[] = {
	&_jc_java_security_InvalidKeyException$type
};

static _jc_type *const _jc_javax_crypto_Cipher$param_types$init$20ec894fa448e181[] = {
	&_jc_int$prim$type,
	&_jc_java_security_cert_Certificate$type
};

_jc_method _jc_javax_crypto_Cipher$method_info$init$20ec894fa448e181 = {
	.name=			"init",
	.signature=		"(ILjava/security/cert/Certificate;)V",
	.class=			&_jc_javax_crypto_Cipher$type,
	.param_types=		&_jc_javax_crypto_Cipher$param_types$init$20ec894fa448e181,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_Cipher$param_ptypes$init$20ec894fa448e181,
	.signature_hash=	_JC_JLONG(0x20ec894fa448e181),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_Cipher$method$init$20ec894fa448e181,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_Cipher$vtable, javax_crypto_Cipher.init$20ec894fa448e181) / sizeof(void *),
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_crypto_Cipher$exceptions$init$20ec894fa448e181,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_javax_crypto_Cipher$linenum_table$init$20ec894fa448e181
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_Cipher, init$20ec894fa448e181);

void _JC_JCNI_ATTR
_jc_javax_crypto_Cipher$method$init$20ec894fa448e181(_jc_env *const env, _jc_javax_crypto_Cipher$object *this, jint param0, _jc_java_security_cert_Certificate$object *param1)
{
	jint i0;
	struct _jc_javax_crypto_Cipher$object *r0;
	struct _jc_java_security_cert_Certificate$object *r1;
	struct _jc_java_security_SecureRandom$object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	i0 = param0;
	r1 = param1;
	_JC_LINE_NUMBER(648);				// 0
	r2 = _JC_NEW(env, java_security_SecureRandom);
	_JC_INVOKE_NONVIRTUAL(env, java_security_SecureRandom, _init$52f4ad9f2989aeee, 0, r2);
	_JC_INVOKE_NONVIRTUAL(env, javax_crypto_Cipher, init$ad1ca514d65e5d1e, 0, r0, i0, r1, r2);
	_JC_LINE_NUMBER(649);				// 1
	return;
}

//
// public final void init(int, java.security.cert.Certificate, java.security.SecureRandom) throws java.security.InvalidKeyException
//

static _jc_linenum _jc_javax_crypto_Cipher$linenum_table$init$ad1ca514d65e5d1e[];

static const unsigned char _jc_javax_crypto_Cipher$param_ptypes$init$ad1ca514d65e5d1e[] = { 
_JC_TYPE_INT, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_Cipher$exceptions$init$ad1ca514d65e5d1e[] = {
	&_jc_java_security_InvalidKeyException$type
};

static _jc_type *const _jc_javax_crypto_Cipher$param_types$init$ad1ca514d65e5d1e[] = {
	&_jc_int$prim$type,
	&_jc_java_security_cert_Certificate$type,
	&_jc_java_security_SecureRandom$type
};

_jc_method _jc_javax_crypto_Cipher$method_info$init$ad1ca514d65e5d1e = {
	.name=			"init",
	.signature=		"(ILjava/security/cert/Certificate;Ljava/security/SecureRandom;)V",
	.class=			&_jc_javax_crypto_Cipher$type,
	.param_types=		&_jc_javax_crypto_Cipher$param_types$init$ad1ca514d65e5d1e,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_Cipher$param_ptypes$init$ad1ca514d65e5d1e,
	.signature_hash=	_JC_JLONG(0xad1ca514d65e5d1e),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_Cipher$method$init$ad1ca514d65e5d1e,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_Cipher$vtable, javax_crypto_Cipher.init$ad1ca514d65e5d1e) / sizeof(void *),
	.num_parameters=	3,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_crypto_Cipher$exceptions$init$ad1ca514d65e5d1e,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	18,
	      .table=	_jc_javax_crypto_Cipher$linenum_table$init$ad1ca514d65e5d1e
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_Cipher, init$ad1ca514d65e5d1e);

void _JC_JCNI_ATTR
_jc_javax_crypto_Cipher$method$init$ad1ca514d65e5d1e(_jc_env *const env, _jc_javax_crypto_Cipher$object *this, jint param0, _jc_java_security_cert_Certificate$object *param1, _jc_java_security_SecureRandom$object *param2)
{
	jint i0;
	struct _jc_javax_crypto_Cipher$object *r0;
	struct _jc_java_security_cert_Certificate$object *r1;
	struct _jc_java_lang_String$object *r10;
	struct _jc_java_lang_String$object *r11;
	struct _jc_java_lang_String$object *r12;
	struct _jc_java_lang_VMThrowable$object *r13;
	struct _jc_java_lang_VMThrowable$object *r14;
	struct _jc_java_lang_VMThrowable$object *r15;
	struct _jc_java_lang_VMThrowable$object *r16;
	struct _jc_java_lang_VMThrowable$object *r17;
	struct _jc_java_lang_VMThrowable$object *r18;
	struct _jc_java_security_SecureRandom$object *r2;
	struct _jc_javax_crypto_CipherSpi$object *r22;
	_jc_boolean_array *r3;
	struct _jc_java_security_cert_X509Certificate$object *r4;
	struct _jc_java_security_InvalidKeyException$object *r5;
	struct _jc_object *r6;
	struct _jc_java_lang_String$object *r7;
	struct _jc_java_lang_String$object *r8;
	struct _jc_java_lang_String$object *r9;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	i0 = param0;
	r1 = param1;
	r2 = param2;
	_JC_LINE_NUMBER(717);				// 0
	z0 = _JC_INSTANCEOF(env, r1, &_jc_java_security_cert_X509Certificate$type);
	if (z0 == 0)
		goto label8;
	_JC_LINE_NUMBER(719);				// 1
	r4 = r1;
	r3 = _JC_INVOKE_VIRTUAL(env, java_security_cert_X509Certificate, getKeyUsage$fb6f03eeb8910fc8, r4);
	_JC_LINE_NUMBER(720);				// 2
	if (r3 == _JC_NULL)
		goto label8;
	_JC_LINE_NUMBER(722);				// 3
	switch (i0) {
	case 1:
		goto label2;
	case 2:
		goto label0;
	case 3:
		goto label6;
	case 4:
		goto label4;
	default:
		goto label8;
	}

label0:
	_JC_LINE_NUMBER(725);				// 4
	z0 = _JC_PRIM_ELEMENT(env, boolean, r3, 3, 0, 1);
	if (z0 != 0)
		goto label1;
	_JC_LINE_NUMBER(727);				// 5
	r5 = _JC_NEW(env, java_security_InvalidKeyException);
	r7 = _JC_STRING(env, "the certificate's key cannot be used for transforming data");
	_JC_REF_FIELD(env, r5, java_lang_Throwable, cause) = r5;
	r13 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r5);
	_JC_REF_FIELD(env, r5, java_lang_Throwable, vmState) = r13;
	_JC_REF_FIELD(env, r5, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r5, java_lang_Throwable, detailMessage) = r7;
	_JC_THROW(env, r5);

label1:
	_JC_LINE_NUMBER(730);				// 6
	z0 = _JC_PRIM_ELEMENT(env, boolean, r3, 7, 0, 1);
	if (z0 == 0)
		goto label8;
	_JC_LINE_NUMBER(732);				// 7
	r5 = _JC_NEW(env, java_security_InvalidKeyException);
	r8 = _JC_STRING(env, "the certificate's key can only be used for encryption");
	_JC_REF_FIELD(env, r5, java_lang_Throwable, cause) = r5;
	r14 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r5);
	_JC_REF_FIELD(env, r5, java_lang_Throwable, vmState) = r14;
	_JC_REF_FIELD(env, r5, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r5, java_lang_Throwable, detailMessage) = r8;
	_JC_THROW(env, r5);

label2:
	_JC_LINE_NUMBER(738);				// 8
	z0 = _JC_PRIM_ELEMENT(env, boolean, r3, 3, 0, 1);
	if (z0 != 0)
		goto label3;
	_JC_LINE_NUMBER(740);				// 9
	r5 = _JC_NEW(env, java_security_InvalidKeyException);
	r9 = _JC_STRING(env, "the certificate's key cannot be used for transforming data");
	_JC_REF_FIELD(env, r5, java_lang_Throwable, cause) = r5;
	r15 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r5);
	_JC_REF_FIELD(env, r5, java_lang_Throwable, vmState) = r15;
	_JC_REF_FIELD(env, r5, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r5, java_lang_Throwable, detailMessage) = r9;
	_JC_THROW(env, r5);

label3:
	_JC_LINE_NUMBER(743);				// 10
	z0 = _JC_PRIM_ELEMENT(env, boolean, r3, 8, 0, 1);
	if (z0 == 0)
		goto label8;
	_JC_LINE_NUMBER(745);				// 11
	r5 = _JC_NEW(env, java_security_InvalidKeyException);
	r10 = _JC_STRING(env, "the certificate's key can only be used for decryption");
	_JC_REF_FIELD(env, r5, java_lang_Throwable, cause) = r5;
	r16 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r5);
	_JC_REF_FIELD(env, r5, java_lang_Throwable, vmState) = r16;
	_JC_REF_FIELD(env, r5, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r5, java_lang_Throwable, detailMessage) = r10;
	_JC_THROW(env, r5);

label4:
	_JC_LINE_NUMBER(751);				// 12
	z0 = _JC_PRIM_ELEMENT(env, boolean, r3, 2, 0, 1);
	if (z0 == 0)
		goto label5;
	z0 = _JC_PRIM_ELEMENT(env, boolean, r3, 7, 0, 1);
	if (z0 == 0)
		goto label8;

label5:
	_JC_LINE_NUMBER(753);				// 13
	r5 = _JC_NEW(env, java_security_InvalidKeyException);
	r11 = _JC_STRING(env, "the certificate's key cannot be used for key unwrapping");
	_JC_REF_FIELD(env, r5, java_lang_Throwable, cause) = r5;
	r17 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r5);
	_JC_REF_FIELD(env, r5, java_lang_Throwable, vmState) = r17;
	_JC_REF_FIELD(env, r5, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r5, java_lang_Throwable, detailMessage) = r11;
	_JC_THROW(env, r5);

label6:
	_JC_LINE_NUMBER(759);				// 14
	z0 = _JC_PRIM_ELEMENT(env, boolean, r3, 2, 0, 1);
	if (z0 == 0)
		goto label7;
	z0 = _JC_PRIM_ELEMENT(env, boolean, r3, 8, 0, 1);
	if (z0 == 0)
		goto label8;

label7:
	_JC_LINE_NUMBER(761);				// 15
	r5 = _JC_NEW(env, java_security_InvalidKeyException);
	r12 = _JC_STRING(env, "the certificate's key cannot be used for key wrapping");
	_JC_REF_FIELD(env, r5, java_lang_Throwable, cause) = r5;
	r18 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r5);
	_JC_REF_FIELD(env, r5, java_lang_Throwable, vmState) = r18;
	_JC_REF_FIELD(env, r5, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r5, java_lang_Throwable, detailMessage) = r12;
	_JC_THROW(env, r5);

label8:
	_JC_LINE_NUMBER(768);				// 16
	r6 = _JC_INVOKE_VIRTUAL(env, java_security_cert_Certificate, getPublicKey$11feb83e68327d4d, r1);
	_JC_PRIM_FIELD(env, r0, javax_crypto_Cipher, state) = i0;
	r22 = _JC_REF_FIELD(env, r0, javax_crypto_Cipher, cipherSpi);
	if (r22 == _JC_NULL)
		goto label9;
	r22 = _JC_REF_FIELD(env, r0, javax_crypto_Cipher, cipherSpi);
	_JC_INVOKE_VIRTUAL(env, javax_crypto_CipherSpi, engineInit$13bd7fdfaabb778a, r22, i0, r6, r2);

label9:
	_JC_LINE_NUMBER(769);				// 17
	return;
}

//
// public final java.security.Key unwrap(byte[], java.lang.String, int) throws java.lang.IllegalStateException, java.security.InvalidKeyException, java.security.NoSuchAlgorithmException
//

static _jc_linenum _jc_javax_crypto_Cipher$linenum_table$unwrap$d6c73695555d3b1c[];

static const unsigned char _jc_javax_crypto_Cipher$param_ptypes$unwrap$d6c73695555d3b1c[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_javax_crypto_Cipher$exceptions$unwrap$d6c73695555d3b1c[] = {
	&_jc_java_lang_IllegalStateException$type,
	&_jc_java_security_InvalidKeyException$type,
	&_jc_java_security_NoSuchAlgorithmException$type
};

static _jc_type *const _jc_javax_crypto_Cipher$param_types$unwrap$d6c73695555d3b1c[] = {
	&_jc_byte$array$prim$type,
	&_jc_java_lang_String$type,
	&_jc_int$prim$type
};

_jc_method _jc_javax_crypto_Cipher$method_info$unwrap$d6c73695555d3b1c = {
	.name=			"unwrap",
	.signature=		"([BLjava/lang/String;I)Ljava/security/Key;",
	.class=			&_jc_javax_crypto_Cipher$type,
	.param_types=		&_jc_javax_crypto_Cipher$param_types$unwrap$d6c73695555d3b1c,
	.return_type=		&_jc_java_security_Key$type,
	.param_ptypes=		&_jc_javax_crypto_Cipher$param_ptypes$unwrap$d6c73695555d3b1c,
	.signature_hash=	_JC_JLONG(0xd6c73695555d3b1c),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_Cipher$method$unwrap$d6c73695555d3b1c,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_Cipher$vtable, javax_crypto_Cipher.unwrap$d6c73695555d3b1c) / sizeof(void *),
	.num_parameters=	3,
	.num_exceptions=	3,
	.exceptions=		&_jc_javax_crypto_Cipher$exceptions$unwrap$d6c73695555d3b1c,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_javax_crypto_Cipher$linenum_table$unwrap$d6c73695555d3b1c
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_Cipher, unwrap$d6c73695555d3b1c);

_jc_object * _JC_JCNI_ATTR
_jc_javax_crypto_Cipher$method$unwrap$d6c73695555d3b1c(_jc_env *const env, _jc_javax_crypto_Cipher$object *this, _jc_byte_array *param0, _jc_java_lang_String$object *param1, jint param2)
{
	jint i0;
	jint i1;
	struct _jc_javax_crypto_Cipher$object *r0;
	_jc_byte_array *r1;
	struct _jc_java_lang_String$object *r2;
	struct _jc_javax_crypto_CipherSpi$object *r3;
	struct _jc_java_lang_IllegalStateException$object *r4;
	struct _jc_object *r5;
	struct _jc_java_lang_String$object *r6;
	struct _jc_java_lang_VMThrowable$object *r8;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	i0 = param2;
	_JC_LINE_NUMBER(958);				// 0
	r3 = _JC_REF_FIELD(env, r0, javax_crypto_Cipher, cipherSpi);
	if (r3 != _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(960);				// 1
	return _JC_NULL;

label0:
	_JC_LINE_NUMBER(962);				// 2
	i1 = _JC_PRIM_FIELD(env, r0, javax_crypto_Cipher, state);
	if (i1 == 4)
		goto label1;
	_JC_LINE_NUMBER(964);				// 3
	r4 = _JC_NEW(env, java_lang_IllegalStateException);
	r6 = _JC_STRING(env, "instance is not for unwrapping");
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r8 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r8;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r6;
	_JC_THROW(env, r4);

label1:
	_JC_LINE_NUMBER(966);				// 4
	r3 = _JC_REF_FIELD(env, r0, javax_crypto_Cipher, cipherSpi);
	r5 = _JC_INVOKE_VIRTUAL(env, javax_crypto_CipherSpi, engineUnwrap$e3a79fe4b2bdd519, r3, r1, r2, i0);
	return r5;
}

//
// public final byte[] update(byte[]) throws java.lang.IllegalStateException
//

static _jc_linenum _jc_javax_crypto_Cipher$linenum_table$update$2aa81ca64e38adc0[];

static const unsigned char _jc_javax_crypto_Cipher$param_ptypes$update$2aa81ca64e38adc0[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_javax_crypto_Cipher$exceptions$update$2aa81ca64e38adc0[] = {
	&_jc_java_lang_IllegalStateException$type
};

static _jc_type *const _jc_javax_crypto_Cipher$param_types$update$2aa81ca64e38adc0[] = {
	&_jc_byte$array$prim$type
};

_jc_method _jc_javax_crypto_Cipher$method_info$update$2aa81ca64e38adc0 = {
	.name=			"update",
	.signature=		"([B)[B",
	.class=			&_jc_javax_crypto_Cipher$type,
	.param_types=		&_jc_javax_crypto_Cipher$param_types$update$2aa81ca64e38adc0,
	.return_type=		&_jc_byte$array$prim$type,
	.param_ptypes=		&_jc_javax_crypto_Cipher$param_ptypes$update$2aa81ca64e38adc0,
	.signature_hash=	_JC_JLONG(0x2aa81ca64e38adc0),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_Cipher$method$update$2aa81ca64e38adc0,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_Cipher$vtable, javax_crypto_Cipher.update$2aa81ca64e38adc0) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_crypto_Cipher$exceptions$update$2aa81ca64e38adc0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_crypto_Cipher$linenum_table$update$2aa81ca64e38adc0
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_Cipher, update$2aa81ca64e38adc0);

_jc_byte_array * _JC_JCNI_ATTR
_jc_javax_crypto_Cipher$method$update$2aa81ca64e38adc0(_jc_env *const env, _jc_javax_crypto_Cipher$object *this, _jc_byte_array *param0)
{
	jint i0;
	struct _jc_javax_crypto_Cipher$object *r0;
	_jc_byte_array *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(981);				// 0
	i0 = _JC_ARRAY_LENGTH(env, r1);
	r1 = _JC_INVOKE_NONVIRTUAL(env, javax_crypto_Cipher, update$4cdb664eeb721f0a, 0, r0, r1, 0, i0);
	return r1;
}

//
// public final byte[] update(byte[], int, int) throws java.lang.IllegalStateException
//

static _jc_linenum _jc_javax_crypto_Cipher$linenum_table$update$4cdb664eeb721f0a[];

static const unsigned char _jc_javax_crypto_Cipher$param_ptypes$update$4cdb664eeb721f0a[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_INT, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_javax_crypto_Cipher$exceptions$update$4cdb664eeb721f0a[] = {
	&_jc_java_lang_IllegalStateException$type
};

static _jc_type *const _jc_javax_crypto_Cipher$param_types$update$4cdb664eeb721f0a[] = {
	&_jc_byte$array$prim$type,
	&_jc_int$prim$type,
	&_jc_int$prim$type
};

_jc_method _jc_javax_crypto_Cipher$method_info$update$4cdb664eeb721f0a = {
	.name=			"update",
	.signature=		"([BII)[B",
	.class=			&_jc_javax_crypto_Cipher$type,
	.param_types=		&_jc_javax_crypto_Cipher$param_types$update$4cdb664eeb721f0a,
	.return_type=		&_jc_byte$array$prim$type,
	.param_ptypes=		&_jc_javax_crypto_Cipher$param_ptypes$update$4cdb664eeb721f0a,
	.signature_hash=	_JC_JLONG(0x4cdb664eeb721f0a),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_Cipher$method$update$4cdb664eeb721f0a,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_Cipher$vtable, javax_crypto_Cipher.update$4cdb664eeb721f0a) / sizeof(void *),
	.num_parameters=	3,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_crypto_Cipher$exceptions$update$4cdb664eeb721f0a,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	6,
	      .table=	_jc_javax_crypto_Cipher$linenum_table$update$4cdb664eeb721f0a
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_Cipher, update$4cdb664eeb721f0a);

_jc_byte_array * _JC_JCNI_ATTR
_jc_javax_crypto_Cipher$method$update$4cdb664eeb721f0a(_jc_env *const env, _jc_javax_crypto_Cipher$object *this, _jc_byte_array *param0, jint param1, jint param2)
{
	jint i0;
	jint i1;
	jint i2;
	struct _jc_javax_crypto_Cipher$object *r0;
	_jc_byte_array *r1;
	_jc_byte_array *r2;
	struct _jc_javax_crypto_CipherSpi$object *r3;
	struct _jc_java_lang_IllegalStateException$object *r4;
	struct _jc_java_lang_String$object *r5;
	struct _jc_java_lang_VMThrowable$object *r7;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	i0 = param1;
	i1 = param2;
	_JC_LINE_NUMBER(998);				// 0
	r3 = _JC_REF_FIELD(env, r0, javax_crypto_Cipher, cipherSpi);
	if (r3 != _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(1000);				// 1
	r2 = _JC_NEW_PRIM_ARRAY(env, byte, 1, i1);
	_JC_ACTIVE_USE(env, java_lang_System);
	_JC_INVOKE_STATIC(env, java_lang_VMSystem, arraycopy$4286a72d57744cd8, 0, r1, i0, r2, 0, i1);
	_JC_LINE_NUMBER(1002);				// 2
	return r2;

label0:
	_JC_LINE_NUMBER(1004);				// 3
	i2 = _JC_PRIM_FIELD(env, r0, javax_crypto_Cipher, state);
	if (i2 == 1)
		goto label1;
	i2 = _JC_PRIM_FIELD(env, r0, javax_crypto_Cipher, state);
	if (i2 == 2)
		goto label1;
	_JC_LINE_NUMBER(1006);				// 4
	r4 = _JC_NEW(env, java_lang_IllegalStateException);
	r5 = _JC_STRING(env, "cipher is not for encrypting or decrypting");
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r7 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r7;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r5;
	_JC_THROW(env, r4);

label1:
	_JC_LINE_NUMBER(1009);				// 5
	r3 = _JC_REF_FIELD(env, r0, javax_crypto_Cipher, cipherSpi);
	r2 = _JC_INVOKE_VIRTUAL(env, javax_crypto_CipherSpi, engineUpdate$74dc675511b28bcd, r3, r1, i0, i1);
	return r2;
}

//
// public final int update(byte[], int, int, byte[]) throws java.lang.IllegalStateException, javax.crypto.ShortBufferException
//

static _jc_linenum _jc_javax_crypto_Cipher$linenum_table$update$cbdc521fc31216d9[];

static const unsigned char _jc_javax_crypto_Cipher$param_ptypes$update$cbdc521fc31216d9[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_INT, _JC_TYPE_REFERENCE, _JC_TYPE_INT };

static _jc_type *const _jc_javax_crypto_Cipher$exceptions$update$cbdc521fc31216d9[] = {
	&_jc_java_lang_IllegalStateException$type,
	&_jc_javax_crypto_ShortBufferException$type
};

static _jc_type *const _jc_javax_crypto_Cipher$param_types$update$cbdc521fc31216d9[] = {
	&_jc_byte$array$prim$type,
	&_jc_int$prim$type,
	&_jc_int$prim$type,
	&_jc_byte$array$prim$type
};

_jc_method _jc_javax_crypto_Cipher$method_info$update$cbdc521fc31216d9 = {
	.name=			"update",
	.signature=		"([BII[B)I",
	.class=			&_jc_javax_crypto_Cipher$type,
	.param_types=		&_jc_javax_crypto_Cipher$param_types$update$cbdc521fc31216d9,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_javax_crypto_Cipher$param_ptypes$update$cbdc521fc31216d9,
	.signature_hash=	_JC_JLONG(0xcbdc521fc31216d9),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_Cipher$method$update$cbdc521fc31216d9,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_Cipher$vtable, javax_crypto_Cipher.update$cbdc521fc31216d9) / sizeof(void *),
	.num_parameters=	4,
	.num_exceptions=	2,
	.exceptions=		&_jc_javax_crypto_Cipher$exceptions$update$cbdc521fc31216d9,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_crypto_Cipher$linenum_table$update$cbdc521fc31216d9
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_Cipher, update$cbdc521fc31216d9);

jint _JC_JCNI_ATTR
_jc_javax_crypto_Cipher$method$update$cbdc521fc31216d9(_jc_env *const env, _jc_javax_crypto_Cipher$object *this, _jc_byte_array *param0, jint param1, jint param2, _jc_byte_array *param3)
{
	jint i0;
	jint i1;
	struct _jc_javax_crypto_Cipher$object *r0;
	_jc_byte_array *r1;
	_jc_byte_array *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	i0 = param1;
	i1 = param2;
	r2 = param3;
	_JC_LINE_NUMBER(1030);				// 0
	i1 = _JC_INVOKE_NONVIRTUAL(env, javax_crypto_Cipher, update$ae15e2d814f1cdb1, 0, r0, r1, i0, i1, r2, 0);
	return i1;
}

//
// public final int update(byte[], int, int, byte[], int) throws java.lang.IllegalStateException, javax.crypto.ShortBufferException
//

static _jc_linenum _jc_javax_crypto_Cipher$linenum_table$update$ae15e2d814f1cdb1[];

static const unsigned char _jc_javax_crypto_Cipher$param_ptypes$update$ae15e2d814f1cdb1[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_INT, _JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_INT };

static _jc_type *const _jc_javax_crypto_Cipher$exceptions$update$ae15e2d814f1cdb1[] = {
	&_jc_java_lang_IllegalStateException$type,
	&_jc_javax_crypto_ShortBufferException$type
};

static _jc_type *const _jc_javax_crypto_Cipher$param_types$update$ae15e2d814f1cdb1[] = {
	&_jc_byte$array$prim$type,
	&_jc_int$prim$type,
	&_jc_int$prim$type,
	&_jc_byte$array$prim$type,
	&_jc_int$prim$type
};

_jc_method _jc_javax_crypto_Cipher$method_info$update$ae15e2d814f1cdb1 = {
	.name=			"update",
	.signature=		"([BII[BI)I",
	.class=			&_jc_javax_crypto_Cipher$type,
	.param_types=		&_jc_javax_crypto_Cipher$param_types$update$ae15e2d814f1cdb1,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_javax_crypto_Cipher$param_ptypes$update$ae15e2d814f1cdb1,
	.signature_hash=	_JC_JLONG(0xae15e2d814f1cdb1),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_Cipher$method$update$ae15e2d814f1cdb1,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_Cipher$vtable, javax_crypto_Cipher.update$ae15e2d814f1cdb1) / sizeof(void *),
	.num_parameters=	5,
	.num_exceptions=	2,
	.exceptions=		&_jc_javax_crypto_Cipher$exceptions$update$ae15e2d814f1cdb1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	7,
	      .table=	_jc_javax_crypto_Cipher$linenum_table$update$ae15e2d814f1cdb1
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_Cipher, update$ae15e2d814f1cdb1);

jint _JC_JCNI_ATTR
_jc_javax_crypto_Cipher$method$update$ae15e2d814f1cdb1(_jc_env *const env, _jc_javax_crypto_Cipher$object *this, _jc_byte_array *param0, jint param1, jint param2, _jc_byte_array *param3, jint param4)
{
	jint i0;
	jint i1;
	jint i2;
	jint i3;
	struct _jc_javax_crypto_Cipher$object *r0;
	_jc_byte_array *r1;
	struct _jc_java_lang_VMThrowable$object *r10;
	_jc_byte_array *r2;
	struct _jc_javax_crypto_CipherSpi$object *r3;
	struct _jc_javax_crypto_ShortBufferException$object *r4;
	struct _jc_java_lang_IllegalStateException$object *r5;
	struct _jc_java_lang_String$object *r6;
	struct _jc_java_lang_String$object *r7;
	struct _jc_java_lang_VMThrowable$object *r8;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	i0 = param1;
	i1 = param2;
	r2 = param3;
	i2 = param4;
	_JC_LINE_NUMBER(1052);				// 0
	r3 = _JC_REF_FIELD(env, r0, javax_crypto_Cipher, cipherSpi);
	if (r3 != _JC_NULL)
		goto label1;
	_JC_LINE_NUMBER(1054);				// 1
	i3 = _JC_ARRAY_LENGTH(env, r2);
	i3 = i3 - i2;
	if (i1 <= i3)
		goto label0;
	_JC_LINE_NUMBER(1056);				// 2
	r4 = _JC_NEW(env, javax_crypto_ShortBufferException);
	r7 = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r8 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r8;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r7;
	_JC_THROW(env, r4);

label0:
	_JC_ACTIVE_USE(env, java_lang_System);
	_JC_INVOKE_STATIC(env, java_lang_VMSystem, arraycopy$4286a72d57744cd8, 0, r1, i0, r2, i2, i1);
	_JC_LINE_NUMBER(1059);				// 3
	return i1;

label1:
	_JC_LINE_NUMBER(1061);				// 4
	i3 = _JC_PRIM_FIELD(env, r0, javax_crypto_Cipher, state);
	if (i3 == 1)
		goto label2;
	i3 = _JC_PRIM_FIELD(env, r0, javax_crypto_Cipher, state);
	if (i3 == 2)
		goto label2;
	_JC_LINE_NUMBER(1063);				// 5
	r5 = _JC_NEW(env, java_lang_IllegalStateException);
	r6 = _JC_STRING(env, "cipher is not for encrypting or decrypting");
	_JC_REF_FIELD(env, r5, java_lang_Throwable, cause) = r5;
	r10 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r5);
	_JC_REF_FIELD(env, r5, java_lang_Throwable, vmState) = r10;
	_JC_REF_FIELD(env, r5, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r5, java_lang_Throwable, detailMessage) = r6;
	_JC_THROW(env, r5);

label2:
	_JC_LINE_NUMBER(1066);				// 6
	r3 = _JC_REF_FIELD(env, r0, javax_crypto_Cipher, cipherSpi);
	i3 = _JC_INVOKE_VIRTUAL(env, javax_crypto_CipherSpi, engineUpdate$f7271b80b2f47cd3, r3, r1, i0, i1, r2, i2);
	return i3;
}

//
// public final byte[] wrap(java.security.Key) throws java.lang.IllegalStateException, javax.crypto.IllegalBlockSizeException, java.security.InvalidKeyException
//

static _jc_linenum _jc_javax_crypto_Cipher$linenum_table$wrap$03d0b865abb80a1f[];

static const unsigned char _jc_javax_crypto_Cipher$param_ptypes$wrap$03d0b865abb80a1f[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_javax_crypto_Cipher$exceptions$wrap$03d0b865abb80a1f[] = {
	&_jc_java_lang_IllegalStateException$type,
	&_jc_javax_crypto_IllegalBlockSizeException$type,
	&_jc_java_security_InvalidKeyException$type
};

static _jc_type *const _jc_javax_crypto_Cipher$param_types$wrap$03d0b865abb80a1f[] = {
	&_jc_java_security_Key$type
};

_jc_method _jc_javax_crypto_Cipher$method_info$wrap$03d0b865abb80a1f = {
	.name=			"wrap",
	.signature=		"(Ljava/security/Key;)[B",
	.class=			&_jc_javax_crypto_Cipher$type,
	.param_types=		&_jc_javax_crypto_Cipher$param_types$wrap$03d0b865abb80a1f,
	.return_type=		&_jc_byte$array$prim$type,
	.param_ptypes=		&_jc_javax_crypto_Cipher$param_ptypes$wrap$03d0b865abb80a1f,
	.signature_hash=	_JC_JLONG(0x3d0b865abb80a1f),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_Cipher$method$wrap$03d0b865abb80a1f,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_Cipher$vtable, javax_crypto_Cipher.wrap$03d0b865abb80a1f) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	3,
	.exceptions=		&_jc_javax_crypto_Cipher$exceptions$wrap$03d0b865abb80a1f,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_javax_crypto_Cipher$linenum_table$wrap$03d0b865abb80a1f
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_Cipher, wrap$03d0b865abb80a1f);

_jc_byte_array * _JC_JCNI_ATTR
_jc_javax_crypto_Cipher$method$wrap$03d0b865abb80a1f(_jc_env *const env, _jc_javax_crypto_Cipher$object *this, _jc_object *param0)
{
	jint i0;
	struct _jc_javax_crypto_Cipher$object *r0;
	struct _jc_object *r1;
	struct _jc_javax_crypto_CipherSpi$object *r2;
	struct _jc_java_lang_IllegalStateException$object *r3;
	_jc_byte_array *r4;
	struct _jc_java_lang_String$object *r5;
	struct _jc_java_lang_VMThrowable$object *r7;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(1085);				// 0
	r2 = _JC_REF_FIELD(env, r0, javax_crypto_Cipher, cipherSpi);
	if (r2 != _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(1087);				// 1
	return _JC_NULL;

label0:
	_JC_LINE_NUMBER(1089);				// 2
	i0 = _JC_PRIM_FIELD(env, r0, javax_crypto_Cipher, state);
	if (i0 == 3)
		goto label1;
	_JC_LINE_NUMBER(1091);				// 3
	r3 = _JC_NEW(env, java_lang_IllegalStateException);
	r5 = _JC_STRING(env, "instance is not for key wrapping");
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r7 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r7;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r5;
	_JC_THROW(env, r3);

label1:
	_JC_LINE_NUMBER(1093);				// 4
	r2 = _JC_REF_FIELD(env, r0, javax_crypto_Cipher, cipherSpi);
	r4 = _JC_INVOKE_VIRTUAL(env, javax_crypto_CipherSpi, engineWrap$7b40014b1e1e224f, r2, r1);
	return r4;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_javax_crypto_Cipher$methods[] = {
	&_jc_javax_crypto_Cipher$method_info$_init$0ccf26f10eec763e,
	&_jc_javax_crypto_Cipher$method_info$doFinal$cd6684344483c19a,
	&_jc_javax_crypto_Cipher$method_info$doFinal$b1afee017dcf0da2,
	&_jc_javax_crypto_Cipher$method_info$doFinal$b8462305182b7595,
	&_jc_javax_crypto_Cipher$method_info$doFinal$12da2b94da840b22,
	&_jc_javax_crypto_Cipher$method_info$doFinal$b07fbc67dd9e541e,
	&_jc_javax_crypto_Cipher$method_info$doFinal$a67b3f796179b9a3,
	&_jc_javax_crypto_Cipher$method_info$getAlgorithm$19abbbc132b9063a,
	&_jc_javax_crypto_Cipher$method_info$getBlockSize$8edb6c820a61ffb7,
	&_jc_javax_crypto_Cipher$method_info$getExemptionMechanism$4c9b606576eb6984,
	&_jc_javax_crypto_Cipher$method_info$getIV$4134a0c13b73072e,
	&_jc_javax_crypto_Cipher$method_info$getInstance$3396c173f2120b7e,
	&_jc_javax_crypto_Cipher$method_info$getInstance$2f7ad61b6f79e802,
	&_jc_javax_crypto_Cipher$method_info$getInstance$91dad1fdea183dd0,
	&_jc_javax_crypto_Cipher$method_info$getOutputSize$972045742a73f7e4,
	&_jc_javax_crypto_Cipher$method_info$getParameters$a88c24c7a8311218,
	&_jc_javax_crypto_Cipher$method_info$getProvider$e8f9c9fb14140d5a,
	&_jc_javax_crypto_Cipher$method_info$init$81cdff4db8bca485,
	&_jc_javax_crypto_Cipher$method_info$init$6179c31d383fade7,
	&_jc_javax_crypto_Cipher$method_info$init$9de42f5c07f9453c,
	&_jc_javax_crypto_Cipher$method_info$init$f85927523f39766b,
	&_jc_javax_crypto_Cipher$method_info$init$98506c62eefa99c0,
	&_jc_javax_crypto_Cipher$method_info$init$fa78b8775e05400b,
	&_jc_javax_crypto_Cipher$method_info$init$20ec894fa448e181,
	&_jc_javax_crypto_Cipher$method_info$init$ad1ca514d65e5d1e,
	&_jc_javax_crypto_Cipher$method_info$unwrap$d6c73695555d3b1c,
	&_jc_javax_crypto_Cipher$method_info$update$2aa81ca64e38adc0,
	&_jc_javax_crypto_Cipher$method_info$update$4cdb664eeb721f0a,
	&_jc_javax_crypto_Cipher$method_info$update$cbdc521fc31216d9,
	&_jc_javax_crypto_Cipher$method_info$update$ae15e2d814f1cdb1,
	&_jc_javax_crypto_Cipher$method_info$wrap$03d0b865abb80a1f
};

/************************************************************************
 *			  Class fields structure			*
 ************************************************************************/

_jc_javax_crypto_Cipher$fields_struct _jc_javax_crypto_Cipher$class_fields = { };

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_javax_crypto_Cipher$instanceof_hash_bucket_78[] = {
	&_jc_javax_crypto_Cipher$type,
	_JC_NULL
};
static _jc_type *const _jc_javax_crypto_Cipher$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_javax_crypto_Cipher$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[78]=	_jc_javax_crypto_Cipher$instanceof_hash_bucket_78,
	[101]=	_jc_javax_crypto_Cipher$instanceof_hash_bucket_101
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_javax_crypto_Cipher$class_depends[] = {
	{ "gnu/java/security/Engine",	_JC_JLONG(0xf4ba095546954b36) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/IllegalStateException",	_JC_JLONG(0xb7e704701c278e65) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/RuntimeException",	_JC_JLONG(0x4f5534a987354d1d) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/StringBuffer",	_JC_JLONG(0x94d357637b968dda) },
	{ "java/lang/System",	_JC_JLONG(0x53cc8e2333795f04) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMSystem",	_JC_JLONG(0x4d1cebae0bdda058) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/security/AlgorithmParameters",	_JC_JLONG(0x814794c0d977019) },
	{ "java/security/GeneralSecurityException",	_JC_JLONG(0x692089051f4c8d0b) },
	{ "java/security/InvalidAlgorithmParameterException",	_JC_JLONG(0x327edce29f2562dd) },
	{ "java/security/InvalidKeyException",	_JC_JLONG(0x94dda41e9bf6c170) },
	{ "java/security/Key",	_JC_JLONG(0xa467c6cd05d9cc51) },
	{ "java/security/KeyException",	_JC_JLONG(0x965d036f0f33fac6) },
	{ "java/security/NoSuchAlgorithmException",	_JC_JLONG(0x22e937c2536160b4) },
	{ "java/security/NoSuchProviderException",	_JC_JLONG(0x8dfbf242adab91e) },
	{ "java/security/Provider",	_JC_JLONG(0x81b073051aa30acc) },
	{ "java/security/PublicKey",	_JC_JLONG(0x4db3ac05e70e2bf8) },
	{ "java/security/SecureRandom",	_JC_JLONG(0x15c6a62b25a6e96d) },
	{ "java/security/Security",	_JC_JLONG(0x89bf77984bd9669e) },
	{ "java/security/cert/Certificate",	_JC_JLONG(0xc98c8192da849b07) },
	{ "java/security/cert/X509Certificate",	_JC_JLONG(0x859e5e5544e5909f) },
	{ "java/security/spec/AlgorithmParameterSpec",	_JC_JLONG(0xef2e5e8af121478f) },
	{ "java/util/StringTokenizer",	_JC_JLONG(0xb106445ca218ee16) },
	{ "java/util/Vector",	_JC_JLONG(0xc53e1575b095109b) },
	{ "javax/crypto/BadPaddingException",	_JC_JLONG(0xd214adbc7b3842af) },
	{ "javax/crypto/CipherSpi",	_JC_JLONG(0x4422f11229f63761) },
	{ "javax/crypto/ExemptionMechanism",	_JC_JLONG(0x9390fe3e28a7a8c5) },
	{ "javax/crypto/IllegalBlockSizeException",	_JC_JLONG(0xe7376936288e78db) },
	{ "javax/crypto/NoSuchPaddingException",	_JC_JLONG(0xec431dca39b80623) },
	{ "javax/crypto/ShortBufferException",	_JC_JLONG(0xd79a62a9328ccea1) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_javax_crypto_Cipher$vtype _jc_javax_crypto_Cipher$type = {
    .type= {
	.name=			"javax/crypto/Cipher",
	.superclass=		&_jc_java_lang_Object$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		38,
		.hash=			_JC_JLONG(0x4bdfff9ea145d6ce),
		.source_file=		"Cipher.java",
		.instance_size=		sizeof(_jc_javax_crypto_Cipher$refs) + sizeof(_jc_javax_crypto_Cipher$object),
		.num_virtual_refs=	3,
		.num_fields=		sizeof(_jc_javax_crypto_Cipher$fields) / sizeof(*_jc_javax_crypto_Cipher$fields),
		.fields=		_jc_javax_crypto_Cipher$fields,
		.num_methods=		sizeof(_jc_javax_crypto_Cipher$methods) / sizeof(*_jc_javax_crypto_Cipher$methods),
		.methods=		_jc_javax_crypto_Cipher$methods,
		.instanceof_hash_table=	_jc_javax_crypto_Cipher$instanceof_hash_table,
		.class_fields=		&_jc_javax_crypto_Cipher$class_fields,
		.num_class_depends=		sizeof(_jc_javax_crypto_Cipher$class_depends) / sizeof(*_jc_javax_crypto_Cipher$class_depends),
		.class_depends=		_jc_javax_crypto_Cipher$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.javax_crypto_Cipher= {
	    .doFinal$cd6684344483c19a=
		&_jc_javax_crypto_Cipher$method$doFinal$cd6684344483c19a,
	    .doFinal$b1afee017dcf0da2=
		&_jc_javax_crypto_Cipher$method$doFinal$b1afee017dcf0da2,
	    .doFinal$b8462305182b7595=
		&_jc_javax_crypto_Cipher$method$doFinal$b8462305182b7595,
	    .doFinal$12da2b94da840b22=
		&_jc_javax_crypto_Cipher$method$doFinal$12da2b94da840b22,
	    .doFinal$b07fbc67dd9e541e=
		&_jc_javax_crypto_Cipher$method$doFinal$b07fbc67dd9e541e,
	    .doFinal$a67b3f796179b9a3=
		&_jc_javax_crypto_Cipher$method$doFinal$a67b3f796179b9a3,
	    .getAlgorithm$19abbbc132b9063a=
		&_jc_javax_crypto_Cipher$method$getAlgorithm$19abbbc132b9063a,
	    .getBlockSize$8edb6c820a61ffb7=
		&_jc_javax_crypto_Cipher$method$getBlockSize$8edb6c820a61ffb7,
	    .getExemptionMechanism$4c9b606576eb6984=
		&_jc_javax_crypto_Cipher$method$getExemptionMechanism$4c9b606576eb6984,
	    .getIV$4134a0c13b73072e=
		&_jc_javax_crypto_Cipher$method$getIV$4134a0c13b73072e,
	    .getOutputSize$972045742a73f7e4=
		&_jc_javax_crypto_Cipher$method$getOutputSize$972045742a73f7e4,
	    .getParameters$a88c24c7a8311218=
		&_jc_javax_crypto_Cipher$method$getParameters$a88c24c7a8311218,
	    .getProvider$e8f9c9fb14140d5a=
		&_jc_javax_crypto_Cipher$method$getProvider$e8f9c9fb14140d5a,
	    .init$81cdff4db8bca485=
		&_jc_javax_crypto_Cipher$method$init$81cdff4db8bca485,
	    .init$6179c31d383fade7=
		&_jc_javax_crypto_Cipher$method$init$6179c31d383fade7,
	    .init$9de42f5c07f9453c=
		&_jc_javax_crypto_Cipher$method$init$9de42f5c07f9453c,
	    .init$f85927523f39766b=
		&_jc_javax_crypto_Cipher$method$init$f85927523f39766b,
	    .init$98506c62eefa99c0=
		&_jc_javax_crypto_Cipher$method$init$98506c62eefa99c0,
	    .init$fa78b8775e05400b=
		&_jc_javax_crypto_Cipher$method$init$fa78b8775e05400b,
	    .init$20ec894fa448e181=
		&_jc_javax_crypto_Cipher$method$init$20ec894fa448e181,
	    .init$ad1ca514d65e5d1e=
		&_jc_javax_crypto_Cipher$method$init$ad1ca514d65e5d1e,
	    .unwrap$d6c73695555d3b1c=
		&_jc_javax_crypto_Cipher$method$unwrap$d6c73695555d3b1c,
	    .update$2aa81ca64e38adc0=
		&_jc_javax_crypto_Cipher$method$update$2aa81ca64e38adc0,
	    .update$4cdb664eeb721f0a=
		&_jc_javax_crypto_Cipher$method$update$4cdb664eeb721f0a,
	    .update$cbdc521fc31216d9=
		&_jc_javax_crypto_Cipher$method$update$cbdc521fc31216d9,
	    .update$ae15e2d814f1cdb1=
		&_jc_javax_crypto_Cipher$method$update$ae15e2d814f1cdb1,
	    .wrap$03d0b865abb80a1f=
		&_jc_javax_crypto_Cipher$method$wrap$03d0b865abb80a1f,
	},
    }
};

