// public class javax.crypto.EncryptedPrivateKeyInfo

// class file dependencies
// @dep_class d963c5e3d173e044 gnu_java_security_OID
// @dep_class 78ef52e48159b870 gnu_java_security_der_DERReader
// @dep_class de1638783317796a gnu_java_security_der_DERValue
// @dep_class a68cc27886fd8be3 java_io_ByteArrayInputStream
// @dep_class c4d3cc2bda03a338 java_io_ByteArrayOutputStream
// @dep_class 4e0a56550c69d57c java_io_IOException
// @dep_class 4026d3144d6654d8 java_io_OutputStream
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class 680cf34d05feb5a1 java_lang_IllegalArgumentException
// @dep_class 505b8a9a6675be0 java_lang_NullPointerException
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class 4f5534a987354d1d java_lang_RuntimeException
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class 814794c0d977019 java_security_AlgorithmParameters
// @dep_class fe4af2c744a13852 java_security_AlgorithmParametersSpi
// @dep_class 692089051f4c8d0b java_security_GeneralSecurityException
// @dep_class 22e937c2536160b4 java_security_NoSuchAlgorithmException
// @dep_class 81b073051aa30acc java_security_Provider
// @dep_class 89bf77984bd9669e java_security_Security
// @dep_class 76558bda43f0601d java_security_spec_EncodedKeySpec
// @dep_class 602c9e525972bdb8 java_security_spec_InvalidKeySpecException
// @dep_class 1e3298bbc69203d6 java_security_spec_PKCS8EncodedKeySpec
// @dep_class 8ea716c64b77f8eb java_util_AbstractCollection
// @dep_class f5238436362828db java_util_AbstractList
// @dep_class 58038509830ef3f4 java_util_ArrayList
// @dep_class 4bdfff9ea145d6ce javax_crypto_Cipher
// @dep_class d45a7cf540fb9419 javax_crypto_EncryptedPrivateKeyInfo

// header file dependencies
// @dep_header gnu_java_security_OID
// @dep_header gnu_java_security_der_DERReader
// @dep_header gnu_java_security_der_DERValue
// @dep_header java_io_ByteArrayInputStream
// @dep_header java_io_ByteArrayOutputStream
// @dep_header java_io_IOException
// @dep_header java_lang_Class
// @dep_header java_lang_IllegalArgumentException
// @dep_header java_lang_NullPointerException
// @dep_header java_lang_String
// @dep_header java_lang_VMThrowable
// @dep_header java_security_AlgorithmParameters
// @dep_header java_security_AlgorithmParametersSpi
// @dep_header java_security_NoSuchAlgorithmException
// @dep_header java_security_Provider
// @dep_header java_security_Security
// @dep_header java_security_spec_InvalidKeySpecException
// @dep_header java_security_spec_PKCS8EncodedKeySpec
// @dep_header java_util_ArrayList
// @dep_header javax_crypto_Cipher
// @dep_header javax_crypto_EncryptedPrivateKeyInfo

#include "jc_defs.h"

#include "gnu/java/security/OID.h"
#include "gnu/java/security/der/DERReader.h"
#include "gnu/java/security/der/DERValue.h"
#include "java/io/ByteArrayInputStream.h"
#include "java/io/ByteArrayOutputStream.h"
#include "java/io/IOException.h"
#include "java/lang/Class.h"
#include "java/lang/IllegalArgumentException.h"
#include "java/lang/NullPointerException.h"
#include "java/lang/String.h"
#include "java/lang/VMThrowable.h"
#include "java/security/AlgorithmParameters.h"
#include "java/security/AlgorithmParametersSpi.h"
#include "java/security/NoSuchAlgorithmException.h"
#include "java/security/Provider.h"
#include "java/security/Security.h"
#include "java/security/spec/InvalidKeySpecException.h"
#include "java/security/spec/PKCS8EncodedKeySpec.h"
#include "java/util/ArrayList.h"
#include "javax/crypto/Cipher.h"
#include "javax/crypto/EncryptedPrivateKeyInfo.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// private byte[] encryptedData
static _jc_field _jc_javax_crypto_EncryptedPrivateKeyInfo$field_info$encryptedData = {
	.name=		"encryptedData",
	.signature=	"[B",
	.class=		&_jc_javax_crypto_EncryptedPrivateKeyInfo$type,
	.type=		&_jc_byte$array$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_EncryptedPrivateKeyInfo$object, refs[-1].javax_crypto_EncryptedPrivateKeyInfo.encryptedData),
};

// private byte[] encoded
static _jc_field _jc_javax_crypto_EncryptedPrivateKeyInfo$field_info$encoded = {
	.name=		"encoded",
	.signature=	"[B",
	.class=		&_jc_javax_crypto_EncryptedPrivateKeyInfo$type,
	.type=		&_jc_byte$array$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_EncryptedPrivateKeyInfo$object, refs[-1].javax_crypto_EncryptedPrivateKeyInfo.encoded),
};

// private gnu.java.security.OID algOid
static _jc_field _jc_javax_crypto_EncryptedPrivateKeyInfo$field_info$algOid = {
	.name=		"algOid",
	.signature=	"Lgnu/java/security/OID;",
	.class=		&_jc_javax_crypto_EncryptedPrivateKeyInfo$type,
	.type=		&_jc_gnu_java_security_OID$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_EncryptedPrivateKeyInfo$object, refs[-1].javax_crypto_EncryptedPrivateKeyInfo.algOid),
};

// private java.security.AlgorithmParameters params
static _jc_field _jc_javax_crypto_EncryptedPrivateKeyInfo$field_info$params = {
	.name=		"params",
	.signature=	"Ljava/security/AlgorithmParameters;",
	.class=		&_jc_javax_crypto_EncryptedPrivateKeyInfo$type,
	.type=		&_jc_java_security_AlgorithmParameters$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_EncryptedPrivateKeyInfo$object, refs[-1].javax_crypto_EncryptedPrivateKeyInfo.params),
};

// private byte[] encodedParams
static _jc_field _jc_javax_crypto_EncryptedPrivateKeyInfo$field_info$encodedParams = {
	.name=		"encodedParams",
	.signature=	"[B",
	.class=		&_jc_javax_crypto_EncryptedPrivateKeyInfo$type,
	.type=		&_jc_byte$array$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_EncryptedPrivateKeyInfo$object, refs[-1].javax_crypto_EncryptedPrivateKeyInfo.encodedParams),
};

// Fields
static _jc_field *const _jc_javax_crypto_EncryptedPrivateKeyInfo$fields[] = {
	&_jc_javax_crypto_EncryptedPrivateKeyInfo$field_info$algOid,
	&_jc_javax_crypto_EncryptedPrivateKeyInfo$field_info$encoded,
	&_jc_javax_crypto_EncryptedPrivateKeyInfo$field_info$encodedParams,
	&_jc_javax_crypto_EncryptedPrivateKeyInfo$field_info$encryptedData,
	&_jc_javax_crypto_EncryptedPrivateKeyInfo$field_info$params
};

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// public void <init>(java.lang.String, byte[]) throws java.lang.IllegalArgumentException, java.security.NoSuchAlgorithmException, java.lang.NullPointerException
//

static _jc_linenum _jc_javax_crypto_EncryptedPrivateKeyInfo$linenum_table$_init$8978305ea064370f[];

static const unsigned char _jc_javax_crypto_EncryptedPrivateKeyInfo$param_ptypes$_init$8978305ea064370f[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_EncryptedPrivateKeyInfo$exceptions$_init$8978305ea064370f[] = {
	&_jc_java_lang_IllegalArgumentException$type,
	&_jc_java_security_NoSuchAlgorithmException$type,
	&_jc_java_lang_NullPointerException$type
};

static _jc_type *const _jc_javax_crypto_EncryptedPrivateKeyInfo$param_types$_init$8978305ea064370f[] = {
	&_jc_java_lang_String$type,
	&_jc_byte$array$prim$type
};

_jc_method _jc_javax_crypto_EncryptedPrivateKeyInfo$method_info$_init$8978305ea064370f = {
	.name=			"<init>",
	.signature=		"(Ljava/lang/String;[B)V",
	.class=			&_jc_javax_crypto_EncryptedPrivateKeyInfo$type,
	.param_types=		&_jc_javax_crypto_EncryptedPrivateKeyInfo$param_types$_init$8978305ea064370f,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_EncryptedPrivateKeyInfo$param_ptypes$_init$8978305ea064370f,
	.signature_hash=	_JC_JLONG(0x8978305ea064370f),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_javax_crypto_EncryptedPrivateKeyInfo$method$_init$8978305ea064370f,
	.num_parameters=	2,
	.num_exceptions=	3,
	.exceptions=		&_jc_javax_crypto_EncryptedPrivateKeyInfo$exceptions$_init$8978305ea064370f,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_javax_crypto_EncryptedPrivateKeyInfo$linenum_table$_init$8978305ea064370f
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_EncryptedPrivateKeyInfo, _init$8978305ea064370f);

void _JC_JCNI_ATTR
_jc_javax_crypto_EncryptedPrivateKeyInfo$method$_init$8978305ea064370f(_jc_env *const env, _jc_javax_crypto_EncryptedPrivateKeyInfo$object *this, _jc_java_lang_String$object *param0, _jc_byte_array *param1)
{
	jint i0;
	struct _jc_javax_crypto_EncryptedPrivateKeyInfo$object *r0;
	struct _jc_java_lang_String$object *r1;
	_jc_byte_array *r2;
	struct _jc_java_lang_IllegalArgumentException$object *r3;
	struct _jc_gnu_java_security_OID$object *r4;
	struct _jc_java_lang_Object$object *r5;
	struct _jc_java_lang_String$object *r6;
	struct _jc_java_lang_VMThrowable$object *r7;
	_jc_int_array *r8;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_LINE_NUMBER(167);				// 0
	i0 = _JC_ARRAY_LENGTH(env, r2);
	if (i0 != 0)
		goto label0;
	_JC_LINE_NUMBER(169);				// 1
	r3 = _JC_NEW(env, java_lang_IllegalArgumentException);
	r6 = _JC_STRING(env, "0-length encryptedData");
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r7 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r7;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r6;
	_JC_THROW(env, r3);

label0:
	_JC_LINE_NUMBER(171);				// 2
	r4 = _JC_NEW(env, gnu_java_security_OID);
	_JC_PRIM_FIELD(env, r4, gnu_java_security_OID, relative) = 0;
	_JC_REF_FIELD(env, r4, gnu_java_security_OID, strRep) = r1;
	r8 = _JC_INVOKE_STATIC(env, gnu_java_security_OID, fromString$9ddcac0b5ea00f21, 1, r1);
	_JC_REF_FIELD(env, r4, gnu_java_security_OID, components) = r8;
	_JC_REF_FIELD(env, r0, javax_crypto_EncryptedPrivateKeyInfo, algOid) = r4;
	_JC_LINE_NUMBER(172);				// 3
	r5 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, clone$b75f2713d6705f70, r2);
	r2 = _JC_CAST_FINAL(env, &_jc_byte$array$prim$type, r5);
	_JC_REF_FIELD(env, r0, javax_crypto_EncryptedPrivateKeyInfo, encryptedData) = r2;
	_JC_LINE_NUMBER(173);				// 4
	return;
}

//
// public void <init>(java.security.AlgorithmParameters, byte[]) throws java.lang.IllegalArgumentException, java.security.NoSuchAlgorithmException
//

static _jc_linenum _jc_javax_crypto_EncryptedPrivateKeyInfo$linenum_table$_init$7c234efb878f173b[];

static const unsigned char _jc_javax_crypto_EncryptedPrivateKeyInfo$param_ptypes$_init$7c234efb878f173b[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_EncryptedPrivateKeyInfo$exceptions$_init$7c234efb878f173b[] = {
	&_jc_java_lang_IllegalArgumentException$type,
	&_jc_java_security_NoSuchAlgorithmException$type
};

static _jc_type *const _jc_javax_crypto_EncryptedPrivateKeyInfo$param_types$_init$7c234efb878f173b[] = {
	&_jc_java_security_AlgorithmParameters$type,
	&_jc_byte$array$prim$type
};

_jc_method _jc_javax_crypto_EncryptedPrivateKeyInfo$method_info$_init$7c234efb878f173b = {
	.name=			"<init>",
	.signature=		"(Ljava/security/AlgorithmParameters;[B)V",
	.class=			&_jc_javax_crypto_EncryptedPrivateKeyInfo$type,
	.param_types=		&_jc_javax_crypto_EncryptedPrivateKeyInfo$param_types$_init$7c234efb878f173b,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_EncryptedPrivateKeyInfo$param_ptypes$_init$7c234efb878f173b,
	.signature_hash=	_JC_JLONG(0x7c234efb878f173b),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_javax_crypto_EncryptedPrivateKeyInfo$method$_init$7c234efb878f173b,
	.num_parameters=	2,
	.num_exceptions=	2,
	.exceptions=		&_jc_javax_crypto_EncryptedPrivateKeyInfo$exceptions$_init$7c234efb878f173b,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	6,
	      .table=	_jc_javax_crypto_EncryptedPrivateKeyInfo$linenum_table$_init$7c234efb878f173b
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_EncryptedPrivateKeyInfo, _init$7c234efb878f173b);

void _JC_JCNI_ATTR
_jc_javax_crypto_EncryptedPrivateKeyInfo$method$_init$7c234efb878f173b(_jc_env *const env, _jc_javax_crypto_EncryptedPrivateKeyInfo$object *this, _jc_java_security_AlgorithmParameters$object *param0, _jc_byte_array *param1)
{
	jint i0;
	struct _jc_javax_crypto_EncryptedPrivateKeyInfo$object *r0;
	struct _jc_java_security_AlgorithmParameters$object *r1;
	_jc_byte_array *r2;
	struct _jc_java_lang_IllegalArgumentException$object *r3;
	struct _jc_gnu_java_security_OID$object *r4;
	struct _jc_java_lang_Object$object *r5;
	struct _jc_java_lang_String$object *r6;
	struct _jc_java_lang_String$object *r7;
	struct _jc_java_lang_VMThrowable$object *r8;
	_jc_int_array *r9;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_LINE_NUMBER(123);				// 0
	i0 = _JC_ARRAY_LENGTH(env, r2);
	if (i0 != 0)
		goto label0;
	_JC_LINE_NUMBER(125);				// 1
	r3 = _JC_NEW(env, java_lang_IllegalArgumentException);
	r6 = _JC_STRING(env, "0-length encryptedData");
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r8 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r8;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r6;
	_JC_THROW(env, r3);

label0:
	_JC_LINE_NUMBER(127);				// 2
	_JC_REF_FIELD(env, r0, javax_crypto_EncryptedPrivateKeyInfo, params) = r1;
	_JC_LINE_NUMBER(128);				// 3
	r4 = _JC_NEW(env, gnu_java_security_OID);
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	r7 = _JC_REF_FIELD(env, r1, java_security_AlgorithmParameters, algorithm);
	_JC_PRIM_FIELD(env, r4, gnu_java_security_OID, relative) = 0;
	_JC_REF_FIELD(env, r4, gnu_java_security_OID, strRep) = r7;
	r9 = _JC_INVOKE_STATIC(env, gnu_java_security_OID, fromString$9ddcac0b5ea00f21, 1, r7);
	_JC_REF_FIELD(env, r4, gnu_java_security_OID, components) = r9;
	_JC_REF_FIELD(env, r0, javax_crypto_EncryptedPrivateKeyInfo, algOid) = r4;
	_JC_LINE_NUMBER(129);				// 4
	r5 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, clone$b75f2713d6705f70, r2);
	r2 = _JC_CAST_FINAL(env, &_jc_byte$array$prim$type, r5);
	_JC_REF_FIELD(env, r0, javax_crypto_EncryptedPrivateKeyInfo, encryptedData) = r2;
	_JC_LINE_NUMBER(130);				// 5
	return;
}

//
// public void <init>(byte[]) throws java.io.IOException
//

static _jc_linenum _jc_javax_crypto_EncryptedPrivateKeyInfo$linenum_table$_init$aaa7e255fe505158[];

static const unsigned char _jc_javax_crypto_EncryptedPrivateKeyInfo$param_ptypes$_init$aaa7e255fe505158[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_EncryptedPrivateKeyInfo$exceptions$_init$aaa7e255fe505158[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_javax_crypto_EncryptedPrivateKeyInfo$param_types$_init$aaa7e255fe505158[] = {
	&_jc_byte$array$prim$type
};

_jc_method _jc_javax_crypto_EncryptedPrivateKeyInfo$method_info$_init$aaa7e255fe505158 = {
	.name=			"<init>",
	.signature=		"([B)V",
	.class=			&_jc_javax_crypto_EncryptedPrivateKeyInfo$type,
	.param_types=		&_jc_javax_crypto_EncryptedPrivateKeyInfo$param_types$_init$aaa7e255fe505158,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_EncryptedPrivateKeyInfo$param_ptypes$_init$aaa7e255fe505158,
	.signature_hash=	_JC_JLONG(0xaaa7e255fe505158),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_javax_crypto_EncryptedPrivateKeyInfo$method$_init$aaa7e255fe505158,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_crypto_EncryptedPrivateKeyInfo$exceptions$_init$aaa7e255fe505158,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_javax_crypto_EncryptedPrivateKeyInfo$linenum_table$_init$aaa7e255fe505158
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_EncryptedPrivateKeyInfo, _init$aaa7e255fe505158);

void _JC_JCNI_ATTR
_jc_javax_crypto_EncryptedPrivateKeyInfo$method$_init$aaa7e255fe505158(_jc_env *const env, _jc_javax_crypto_EncryptedPrivateKeyInfo$object *this, _jc_byte_array *param0)
{
	struct _jc_javax_crypto_EncryptedPrivateKeyInfo$object *r0;
	_jc_byte_array *r1;
	struct _jc_java_lang_Object$object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(144);				// 0
	r2 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, clone$b75f2713d6705f70, r1);
	r1 = _JC_CAST_FINAL(env, &_jc_byte$array$prim$type, r2);
	_JC_REF_FIELD(env, r0, javax_crypto_EncryptedPrivateKeyInfo, encoded) = r1;
	_JC_LINE_NUMBER(145);				// 1
	_JC_INVOKE_NONVIRTUAL(env, javax_crypto_EncryptedPrivateKeyInfo, decode$51530ddb5bfd9a46, 0, r0);
	_JC_LINE_NUMBER(146);				// 2
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// private final void decode() throws java.io.IOException
//

static _jc_linenum _jc_javax_crypto_EncryptedPrivateKeyInfo$linenum_table$decode$51530ddb5bfd9a46[];

static const unsigned char _jc_javax_crypto_EncryptedPrivateKeyInfo$param_ptypes$decode$51530ddb5bfd9a46[] = { 
_JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_EncryptedPrivateKeyInfo$exceptions$decode$51530ddb5bfd9a46[] = {
	&_jc_java_io_IOException$type
};

_jc_method _jc_javax_crypto_EncryptedPrivateKeyInfo$method_info$decode$51530ddb5bfd9a46 = {
	.name=			"decode",
	.signature=		"()V",
	.class=			&_jc_javax_crypto_EncryptedPrivateKeyInfo$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_EncryptedPrivateKeyInfo$param_ptypes$decode$51530ddb5bfd9a46,
	.signature_hash=	_JC_JLONG(0x51530ddb5bfd9a46),
	.access_flags=		_JC_ACC_PRIVATE|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_EncryptedPrivateKeyInfo$method$decode$51530ddb5bfd9a46,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_EncryptedPrivateKeyInfo$vtable, javax_crypto_EncryptedPrivateKeyInfo.decode$51530ddb5bfd9a46) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_crypto_EncryptedPrivateKeyInfo$exceptions$decode$51530ddb5bfd9a46,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	25,
	      .table=	_jc_javax_crypto_EncryptedPrivateKeyInfo$linenum_table$decode$51530ddb5bfd9a46
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_EncryptedPrivateKeyInfo, decode$51530ddb5bfd9a46);

void _JC_JCNI_ATTR
_jc_javax_crypto_EncryptedPrivateKeyInfo$method$decode$51530ddb5bfd9a46(_jc_env *const env, _jc_javax_crypto_EncryptedPrivateKeyInfo$object *this)
{
	jint i0;
	jint i1;
	jint i2;
	struct _jc_javax_crypto_EncryptedPrivateKeyInfo$object *r0;
	struct _jc_gnu_java_security_der_DERReader$object *r1;
	struct _jc_java_lang_String$object *r10;
	struct _jc_java_lang_String$object *r11;
	struct _jc_java_io_ByteArrayInputStream$object *r12;
	struct _jc_java_lang_VMThrowable$object *r13;
	struct _jc_java_lang_VMThrowable$object *r14;
	struct _jc_java_lang_VMThrowable$object *r15;
	struct _jc_java_lang_VMThrowable$object *r16;
	struct _jc_java_io_ByteArrayOutputStream$object *r17;
	_jc_byte_array *r18;
	struct _jc_gnu_java_security_der_DERValue$object *r2;
	_jc_byte_array *r3;
	struct _jc_java_io_IOException$object *r4;
	struct _jc_gnu_java_security_der_DERValue$object *r5;
	struct _jc_java_lang_Object$object *r6;
	struct _jc_gnu_java_security_OID$object *r7;
	struct _jc_java_lang_String$object *r8;
	struct _jc_java_lang_String$object *r9;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(236);				// 0
	r1 = _JC_NEW(env, gnu_java_security_der_DERReader);
	r3 = _JC_REF_FIELD(env, r0, javax_crypto_EncryptedPrivateKeyInfo, encoded);
	r12 = _JC_NEW(env, java_io_ByteArrayInputStream);
	i2 = _JC_ARRAY_LENGTH(env, r3);
	_JC_INVOKE_NONVIRTUAL(env, java_io_ByteArrayInputStream, _init$4ff4a7925ef7b06c, 0, r12, r3, 0, i2);
	_JC_REF_FIELD(env, r1, gnu_java_security_der_DERReader, in) = r12;
	r17 = _JC_NEW(env, java_io_ByteArrayOutputStream);
	r18 = _JC_NEW_PRIM_ARRAY(env, byte, 1, 2048);
	_JC_REF_FIELD(env, r17, java_io_ByteArrayOutputStream, buf) = r18;
	_JC_PRIM_FIELD(env, r17, java_io_ByteArrayOutputStream, count) = 0;
	_JC_REF_FIELD(env, r1, gnu_java_security_der_DERReader, encBuf) = r17;
	_JC_LINE_NUMBER(237);				// 1
	r2 = _JC_INVOKE_NONVIRTUAL(env, gnu_java_security_der_DERReader, read$97cabf4c92410204, 0, r1);
	_JC_LINE_NUMBER(238);				// 2
	i0 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_der_DERValue, getTag$e94b895ddc57b4b7, r2);
	if (i0 == 16)
		goto label0;
	_JC_LINE_NUMBER(239);				// 3
	r4 = _JC_NEW(env, java_io_IOException);
	r8 = _JC_STRING(env, "malformed EncryptedPrivateKeyInfo");
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r13 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r13;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r8;
	_JC_THROW(env, r4);

label0:
	_JC_LINE_NUMBER(240);				// 4
	r5 = _JC_INVOKE_NONVIRTUAL(env, gnu_java_security_der_DERReader, read$97cabf4c92410204, 0, r1);
	_JC_LINE_NUMBER(241);				// 5
	i0 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_der_DERValue, getTag$e94b895ddc57b4b7, r5);
	if (i0 == 16)
		goto label1;
	_JC_LINE_NUMBER(242);				// 6
	r4 = _JC_NEW(env, java_io_IOException);
	r9 = _JC_STRING(env, "malformed AlgorithmIdentifier");
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r14 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r14;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r9;
	_JC_THROW(env, r4);

label1:
	_JC_LINE_NUMBER(243);				// 7
	i0 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_der_DERValue, getLength$b9eaa8ec0a00f23d, r5);
	_JC_LINE_NUMBER(244);				// 8
	r2 = _JC_INVOKE_NONVIRTUAL(env, gnu_java_security_der_DERReader, read$97cabf4c92410204, 0, r1);
	_JC_LINE_NUMBER(245);				// 9
	i1 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_der_DERValue, getTag$e94b895ddc57b4b7, r2);
	if (i1 == 6)
		goto label2;
	_JC_LINE_NUMBER(246);				// 10
	r4 = _JC_NEW(env, java_io_IOException);
	r10 = _JC_STRING(env, "malformed AlgorithmIdentifier");
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r15 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r15;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r10;
	_JC_THROW(env, r4);

label2:
	_JC_LINE_NUMBER(247);				// 11
	r6 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_der_DERValue, getValue$6f8b281a5ffcc94f, r2);
	r7 = _JC_CAST(env, &_jc_gnu_java_security_OID$type, r6);
	_JC_REF_FIELD(env, r0, javax_crypto_EncryptedPrivateKeyInfo, algOid) = r7;
	_JC_LINE_NUMBER(248);				// 12
	if (i0 != 0)
		goto label3;
	_JC_LINE_NUMBER(250);				// 13
	r5 = _JC_INVOKE_NONVIRTUAL(env, gnu_java_security_der_DERReader, read$97cabf4c92410204, 0, r1);
	_JC_LINE_NUMBER(251);				// 14
	i1 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_der_DERValue, getTag$e94b895ddc57b4b7, r5);
	if (i1 == 0)
		goto label4;
	_JC_LINE_NUMBER(253);				// 15
	r3 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_der_DERValue, getEncoded$eaf136136217eb89, r5);
	_JC_REF_FIELD(env, r0, javax_crypto_EncryptedPrivateKeyInfo, encodedParams) = r3;
	_JC_LINE_NUMBER(254);				// 16
	_JC_INVOKE_NONVIRTUAL(env, gnu_java_security_der_DERReader, read$97cabf4c92410204, 0, r1);
	goto label4;

label3:
	_JC_LINE_NUMBER(257);				// 17
	i1 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_der_DERValue, getEncodedLength$20de9dca5414bd6a, r2);
	i0 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_der_DERValue, getLength$b9eaa8ec0a00f23d, r5);
	if (i1 >= i0)
		goto label4;
	_JC_LINE_NUMBER(259);				// 18
	r5 = _JC_INVOKE_NONVIRTUAL(env, gnu_java_security_der_DERReader, read$97cabf4c92410204, 0, r1);
	_JC_LINE_NUMBER(260);				// 19
	r3 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_der_DERValue, getEncoded$eaf136136217eb89, r5);
	_JC_REF_FIELD(env, r0, javax_crypto_EncryptedPrivateKeyInfo, encodedParams) = r3;

label4:
	_JC_LINE_NUMBER(262);				// 20
	r5 = _JC_INVOKE_NONVIRTUAL(env, gnu_java_security_der_DERReader, read$97cabf4c92410204, 0, r1);
	_JC_LINE_NUMBER(263);				// 21
	i1 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_der_DERValue, getTag$e94b895ddc57b4b7, r5);
	if (i1 == 4)
		goto label5;
	_JC_LINE_NUMBER(264);				// 22
	r4 = _JC_NEW(env, java_io_IOException);
	r11 = _JC_STRING(env, "malformed AlgorithmIdentifier");
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r16 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r16;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r11;
	_JC_THROW(env, r4);

label5:
	_JC_LINE_NUMBER(265);				// 23
	r6 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_der_DERValue, getValue$6f8b281a5ffcc94f, r5);
	r3 = _JC_CAST_FINAL(env, &_jc_byte$array$prim$type, r6);
	_JC_REF_FIELD(env, r0, javax_crypto_EncryptedPrivateKeyInfo, encryptedData) = r3;
	_JC_LINE_NUMBER(266);				// 24
	return;
}

//
// private final void encode() throws java.io.IOException
//

static _jc_linenum _jc_javax_crypto_EncryptedPrivateKeyInfo$linenum_table$encode$af758db7996768c2[];

static const unsigned char _jc_javax_crypto_EncryptedPrivateKeyInfo$param_ptypes$encode$af758db7996768c2[] = { 
_JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_EncryptedPrivateKeyInfo$exceptions$encode$af758db7996768c2[] = {
	&_jc_java_io_IOException$type
};

_jc_method _jc_javax_crypto_EncryptedPrivateKeyInfo$method_info$encode$af758db7996768c2 = {
	.name=			"encode",
	.signature=		"()V",
	.class=			&_jc_javax_crypto_EncryptedPrivateKeyInfo$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_EncryptedPrivateKeyInfo$param_ptypes$encode$af758db7996768c2,
	.signature_hash=	_JC_JLONG(0xaf758db7996768c2),
	.access_flags=		_JC_ACC_PRIVATE|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_EncryptedPrivateKeyInfo$method$encode$af758db7996768c2,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_EncryptedPrivateKeyInfo$vtable, javax_crypto_EncryptedPrivateKeyInfo.encode$af758db7996768c2) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_crypto_EncryptedPrivateKeyInfo$exceptions$encode$af758db7996768c2,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	10,
	      .table=	_jc_javax_crypto_EncryptedPrivateKeyInfo$linenum_table$encode$af758db7996768c2
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_EncryptedPrivateKeyInfo, encode$af758db7996768c2);

void _JC_JCNI_ATTR
_jc_javax_crypto_EncryptedPrivateKeyInfo$method$encode$af758db7996768c2(_jc_env *const env, _jc_javax_crypto_EncryptedPrivateKeyInfo$object *this)
{
	jint i0;
	struct _jc_javax_crypto_EncryptedPrivateKeyInfo$object *r0;
	struct _jc_java_util_ArrayList$object *r1;
	struct _jc_gnu_java_security_der_DERValue$object *r10;
	struct _jc_java_io_ByteArrayInputStream$object *r11;
	_jc_object_array *r12;
	_jc_object_array *r13;
	struct _jc_java_io_ByteArrayOutputStream$object *r14;
	_jc_byte_array *r15;
	struct _jc_java_util_ArrayList$object *r2;
	struct _jc_gnu_java_security_der_DERValue$object *r3;
	struct _jc_gnu_java_security_OID$object *r4;
	struct _jc_java_security_AlgorithmParameters$object *r5;
	_jc_byte_array *r6;
	struct _jc_java_security_AlgorithmParametersSpi$object *r7;
	_jc_byte_array *r8;
	struct _jc_gnu_java_security_der_DERReader$object *r9;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(270);				// 0
	r1 = _JC_NEW(env, java_util_ArrayList);
	r12 = _JC_NEW_REF_ARRAY(env, java_lang_Object, 1, 2);
	_JC_REF_FIELD(env, r1, java_util_ArrayList, data) = r12;
	_JC_LINE_NUMBER(271);				// 1
	r3 = _JC_NEW(env, gnu_java_security_der_DERValue);
	r4 = _JC_REF_FIELD(env, r0, javax_crypto_EncryptedPrivateKeyInfo, algOid);
	_JC_INVOKE_NONVIRTUAL(env, gnu_java_security_der_DERValue, _init$8e22e8011ae1da3a, 0, r3, 6, 0, r4, _JC_NULL);
	_JC_INVOKE_NONVIRTUAL(env, java_util_ArrayList, add$831f06ee5f59c0cc, 0, r1, r3);
	_JC_LINE_NUMBER(272);				// 2
	_JC_INVOKE_VIRTUAL(env, javax_crypto_EncryptedPrivateKeyInfo, getAlgParameters$0923600d443f21c8, r0);
	_JC_LINE_NUMBER(273);				// 3
	r5 = _JC_REF_FIELD(env, r0, javax_crypto_EncryptedPrivateKeyInfo, params);
	if (r5 == _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(275);				// 4
	r5 = _JC_REF_FIELD(env, r0, javax_crypto_EncryptedPrivateKeyInfo, params);
	_JC_EXPLICIT_NULL_CHECK(env, r5);
	r7 = _JC_REF_FIELD(env, r5, java_security_AlgorithmParameters, paramSpi);
	r8 = _JC_INVOKE_VIRTUAL(env, java_security_AlgorithmParametersSpi, engineGetEncoded$c6f5908664ac2899, r7);
	_JC_ACTIVE_USE(env, gnu_java_security_der_DERReader);
	r9 = _JC_NEW(env, gnu_java_security_der_DERReader);
	r11 = _JC_NEW(env, java_io_ByteArrayInputStream);
	i0 = _JC_ARRAY_LENGTH(env, r8);
	_JC_INVOKE_NONVIRTUAL(env, java_io_ByteArrayInputStream, _init$4ff4a7925ef7b06c, 0, r11, r8, 0, i0);
	_JC_REF_FIELD(env, r9, gnu_java_security_der_DERReader, in) = r11;
	r14 = _JC_NEW(env, java_io_ByteArrayOutputStream);
	r15 = _JC_NEW_PRIM_ARRAY(env, byte, 1, 2048);
	_JC_REF_FIELD(env, r14, java_io_ByteArrayOutputStream, buf) = r15;
	_JC_PRIM_FIELD(env, r14, java_io_ByteArrayOutputStream, count) = 0;
	_JC_REF_FIELD(env, r9, gnu_java_security_der_DERReader, encBuf) = r14;
	r10 = _JC_INVOKE_NONVIRTUAL(env, gnu_java_security_der_DERReader, read$97cabf4c92410204, 0, r9);
	_JC_INVOKE_NONVIRTUAL(env, java_util_ArrayList, add$831f06ee5f59c0cc, 0, r1, r10);

label0:
	_JC_LINE_NUMBER(277);				// 5
	r2 = _JC_NEW(env, java_util_ArrayList);
	r13 = _JC_NEW_REF_ARRAY(env, java_lang_Object, 1, 2);
	_JC_REF_FIELD(env, r2, java_util_ArrayList, data) = r13;
	_JC_LINE_NUMBER(278);				// 6
	r3 = _JC_NEW(env, gnu_java_security_der_DERValue);
	_JC_INVOKE_NONVIRTUAL(env, gnu_java_security_der_DERValue, _init$8e22e8011ae1da3a, 0, r3, 48, 0, r1, _JC_NULL);
	_JC_INVOKE_NONVIRTUAL(env, java_util_ArrayList, add$831f06ee5f59c0cc, 0, r2, r3);
	_JC_LINE_NUMBER(279);				// 7
	r3 = _JC_NEW(env, gnu_java_security_der_DERValue);
	r6 = _JC_REF_FIELD(env, r0, javax_crypto_EncryptedPrivateKeyInfo, encryptedData);
	_JC_INVOKE_NONVIRTUAL(env, gnu_java_security_der_DERValue, _init$8e22e8011ae1da3a, 0, r3, 4, 0, r6, _JC_NULL);
	_JC_INVOKE_NONVIRTUAL(env, java_util_ArrayList, add$831f06ee5f59c0cc, 0, r2, r3);
	_JC_LINE_NUMBER(280);				// 8
	r3 = _JC_NEW(env, gnu_java_security_der_DERValue);
	_JC_INVOKE_NONVIRTUAL(env, gnu_java_security_der_DERValue, _init$8e22e8011ae1da3a, 0, r3, 48, 0, r2, _JC_NULL);
	r6 = _JC_INVOKE_NONVIRTUAL(env, gnu_java_security_der_DERValue, getEncoded$eaf136136217eb89, 0, r3);
	_JC_REF_FIELD(env, r0, javax_crypto_EncryptedPrivateKeyInfo, encoded) = r6;
	_JC_LINE_NUMBER(281);				// 9
	return;
}

//
// public java.lang.String getAlgName()
//

static _jc_linenum _jc_javax_crypto_EncryptedPrivateKeyInfo$linenum_table$getAlgName$9251c182bc965747[];

static const unsigned char _jc_javax_crypto_EncryptedPrivateKeyInfo$param_ptypes$getAlgName$9251c182bc965747[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_javax_crypto_EncryptedPrivateKeyInfo$method_info$getAlgName$9251c182bc965747 = {
	.name=			"getAlgName",
	.signature=		"()Ljava/lang/String;",
	.class=			&_jc_javax_crypto_EncryptedPrivateKeyInfo$type,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_javax_crypto_EncryptedPrivateKeyInfo$param_ptypes$getAlgName$9251c182bc965747,
	.signature_hash=	_JC_JLONG(0x9251c182bc965747),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_javax_crypto_EncryptedPrivateKeyInfo$method$getAlgName$9251c182bc965747,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_EncryptedPrivateKeyInfo$vtable, javax_crypto_EncryptedPrivateKeyInfo.getAlgName$9251c182bc965747) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_crypto_EncryptedPrivateKeyInfo$linenum_table$getAlgName$9251c182bc965747
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_EncryptedPrivateKeyInfo, getAlgName$9251c182bc965747);

_jc_java_lang_String$object * _JC_JCNI_ATTR
_jc_javax_crypto_EncryptedPrivateKeyInfo$method$getAlgName$9251c182bc965747(_jc_env *const env, _jc_javax_crypto_EncryptedPrivateKeyInfo$object *this)
{
	struct _jc_javax_crypto_EncryptedPrivateKeyInfo$object *r0;
	struct _jc_gnu_java_security_OID$object *r1;
	struct _jc_java_lang_String$object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(185);				// 0
	r1 = _JC_REF_FIELD(env, r0, javax_crypto_EncryptedPrivateKeyInfo, algOid);
	r2 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_OID, toString$7ea43b33b80a3070, r1);
	return r2;
}

//
// public java.security.AlgorithmParameters getAlgParameters()
//

static _jc_linenum _jc_javax_crypto_EncryptedPrivateKeyInfo$linenum_table$getAlgParameters$0923600d443f21c8[];

static _jc_trap_info _jc_javax_crypto_EncryptedPrivateKeyInfo$trap_table$getAlgParameters$0923600d443f21c8[] = {
	_JC_TRAP(&_jc_java_security_NoSuchAlgorithmException$type, 2, 3),
	_JC_TRAP(&_jc_java_security_NoSuchAlgorithmException$type, 1, 4),
	_JC_TRAP(&_jc_java_io_IOException$type, 1, 4),
};

static const unsigned char _jc_javax_crypto_EncryptedPrivateKeyInfo$param_ptypes$getAlgParameters$0923600d443f21c8[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_javax_crypto_EncryptedPrivateKeyInfo$method_info$getAlgParameters$0923600d443f21c8 = {
	.name=			"getAlgParameters",
	.signature=		"()Ljava/security/AlgorithmParameters;",
	.class=			&_jc_javax_crypto_EncryptedPrivateKeyInfo$type,
	.return_type=		&_jc_java_security_AlgorithmParameters$type,
	.param_ptypes=		&_jc_javax_crypto_EncryptedPrivateKeyInfo$param_ptypes$getAlgParameters$0923600d443f21c8,
	.signature_hash=	_JC_JLONG(0x923600d443f21c8),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_javax_crypto_EncryptedPrivateKeyInfo$method$getAlgParameters$0923600d443f21c8,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_EncryptedPrivateKeyInfo$vtable, javax_crypto_EncryptedPrivateKeyInfo.getAlgParameters$0923600d443f21c8) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .trap_table_len=	3,
	  .trap_table=		_jc_javax_crypto_EncryptedPrivateKeyInfo$trap_table$getAlgParameters$0923600d443f21c8,
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_javax_crypto_EncryptedPrivateKeyInfo$linenum_table$getAlgParameters$0923600d443f21c8
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_EncryptedPrivateKeyInfo, getAlgParameters$0923600d443f21c8);

_jc_java_security_AlgorithmParameters$object * _JC_JCNI_ATTR
_jc_javax_crypto_EncryptedPrivateKeyInfo$method$getAlgParameters$0923600d443f21c8(_jc_env *const env, _jc_javax_crypto_EncryptedPrivateKeyInfo$object *this)
{
	jint volatile i0;
	jint volatile i1;
	struct _jc_javax_crypto_EncryptedPrivateKeyInfo$object *volatile r0;
	struct _jc_java_security_AlgorithmParameters$object *volatile r1;
	struct _jc_java_security_NoSuchAlgorithmException$object *volatile r10;
	struct _jc_java_lang_VMThrowable$object *volatile r12;
	_jc_byte_array *volatile r2;
	struct _jc_java_lang_String$object *volatile r3;
	struct _jc_java_security_NoSuchAlgorithmException$object *r4;
	struct _jc_java_io_IOException$object *r5;
	struct _jc_java_security_AlgorithmParametersSpi$object *volatile r6;
	_jc_object_array *volatile r7;
	struct _jc_java_security_Provider$object *volatile r8;
	struct _jc_java_security_AlgorithmParameters$object *volatile r9;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_javax_crypto_EncryptedPrivateKeyInfo$method_info$getAlgParameters$0923600d443f21c8, &&label1, &&label4, &&label5);

	r0 = this;
	_JC_LINE_NUMBER(190);				// 0
	r1 = _JC_REF_FIELD(env, r0, javax_crypto_EncryptedPrivateKeyInfo, params);
	if (r1 != _JC_NULL)
		goto label6;
	r2 = _JC_REF_FIELD(env, r0, javax_crypto_EncryptedPrivateKeyInfo, encodedParams);
	if (r2 == _JC_NULL)
		goto label6;
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(194);				// 1
	r3 = _JC_INVOKE_VIRTUAL(env, javax_crypto_EncryptedPrivateKeyInfo, getAlgName$9251c182bc965747, r0);
	_JC_ACTIVE_USE(env, java_security_AlgorithmParameters);
	r7 = _JC_INVOKE_STATIC(env, java_security_Security, getProviders$03fdcd7bb40e95b7, 0);
	i0 = 0;
	goto label2;

label0:
	_JC_TRAP_REGION(catch, 2);
	r8 = _JC_REF_ELEMENT(env, r7, i0, 1, 1);
	r9 = _JC_INVOKE_STATIC(env, java_security_AlgorithmParameters, getInstance$6d3303f1afba83cb, 0, r3, r8);
	_JC_TRAP_REGION(catch, 3);
	goto label3;

label1:
	_JC_TRAP_REGION(catch, 3);
	r10 = _JC_CAUGHT_EXCEPTION(env);
	i0 = i0 + 1;

label2:
	_JC_TRAP_REGION(catch, 3);
	i1 = _JC_ARRAY_LENGTH(env, r7);
	if (i0 < i1) {
		_JC_PERIODIC_CHECK(env);
		goto label0;
	}
	r10 = _JC_NEW(env, java_security_NoSuchAlgorithmException);
	_JC_REF_FIELD(env, r10, java_lang_Throwable, cause) = r10;
	r12 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r10);
	_JC_REF_FIELD(env, r10, java_lang_Throwable, vmState) = r12;
	_JC_REF_FIELD(env, r10, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r10, java_lang_Throwable, detailMessage) = r3;
	_JC_THROW(env, r10);

label3:
	_JC_REF_FIELD(env, r0, javax_crypto_EncryptedPrivateKeyInfo, params) = r9;
	_JC_LINE_NUMBER(195);				// 2
	r1 = _JC_REF_FIELD(env, r0, javax_crypto_EncryptedPrivateKeyInfo, params);
	r2 = _JC_REF_FIELD(env, r0, javax_crypto_EncryptedPrivateKeyInfo, encodedParams);
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	r6 = _JC_REF_FIELD(env, r1, java_security_AlgorithmParameters, paramSpi);
	_JC_INVOKE_VIRTUAL(env, java_security_AlgorithmParametersSpi, engineInit$02e0befd93d9fd30, r6, r2);
	_JC_TRAP_REGION(catch, 4);
	goto label6;

label4:
	_JC_TRAP_REGION(catch, 4);
	r4 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(197);				// 3
	goto label6;

label5:
	_JC_TRAP_REGION(catch, 4);
	r5 = _JC_CAUGHT_EXCEPTION(env);

label6:
	_JC_TRAP_REGION(catch, 4);
	_JC_LINE_NUMBER(204);				// 4
	r1 = _JC_REF_FIELD(env, r0, javax_crypto_EncryptedPrivateKeyInfo, params);
	_JC_CANCEL_TRAPS(env, catch);
	return r1;
}

//
// public synchronized byte[] getEncoded() throws java.io.IOException
//

static _jc_linenum _jc_javax_crypto_EncryptedPrivateKeyInfo$linenum_table$getEncoded$eaf136136217eb89[];

static _jc_trap_info _jc_javax_crypto_EncryptedPrivateKeyInfo$trap_table$getEncoded$eaf136136217eb89[] = {
	_JC_TRAP(_JC_NULL, 1, 2),
};

static const unsigned char _jc_javax_crypto_EncryptedPrivateKeyInfo$param_ptypes$getEncoded$eaf136136217eb89[] = { 
_JC_TYPE_REFERENCE };

static _jc_type *const _jc_javax_crypto_EncryptedPrivateKeyInfo$exceptions$getEncoded$eaf136136217eb89[] = {
	&_jc_java_io_IOException$type
};

_jc_method _jc_javax_crypto_EncryptedPrivateKeyInfo$method_info$getEncoded$eaf136136217eb89 = {
	.name=			"getEncoded",
	.signature=		"()[B",
	.class=			&_jc_javax_crypto_EncryptedPrivateKeyInfo$type,
	.return_type=		&_jc_byte$array$prim$type,
	.param_ptypes=		&_jc_javax_crypto_EncryptedPrivateKeyInfo$param_ptypes$getEncoded$eaf136136217eb89,
	.signature_hash=	_JC_JLONG(0xeaf136136217eb89),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_SYNCHRONIZED,
	.function=		&_jc_javax_crypto_EncryptedPrivateKeyInfo$method$getEncoded$eaf136136217eb89,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_EncryptedPrivateKeyInfo$vtable, javax_crypto_EncryptedPrivateKeyInfo.getEncoded$eaf136136217eb89) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_crypto_EncryptedPrivateKeyInfo$exceptions$getEncoded$eaf136136217eb89,
	.u= { .exec= {
	  .trap_table_len=	1,
	  .trap_table=		_jc_javax_crypto_EncryptedPrivateKeyInfo$trap_table$getEncoded$eaf136136217eb89,
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_javax_crypto_EncryptedPrivateKeyInfo$linenum_table$getEncoded$eaf136136217eb89
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_EncryptedPrivateKeyInfo, getEncoded$eaf136136217eb89);

_jc_byte_array * _JC_JCNI_ATTR
_jc_javax_crypto_EncryptedPrivateKeyInfo$method$getEncoded$eaf136136217eb89(_jc_env *const env, _jc_javax_crypto_EncryptedPrivateKeyInfo$object *this)
{
	struct _jc_java_lang_Throwable$object *volatile exception;
	struct _jc_javax_crypto_EncryptedPrivateKeyInfo$object *r0;
	_jc_byte_array *r1;
	struct _jc_java_lang_Object$object *r3;
	struct _jc_javax_crypto_EncryptedPrivateKeyInfo$object *volatile thisRef;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_javax_crypto_EncryptedPrivateKeyInfo$method_info$getEncoded$eaf136136217eb89, &&label1);

	thisRef = this;
	_JC_MONITOR_ENTER(env, thisRef);
	_JC_TRAP_REGION(catch, 1);
	r0 = this;
	_JC_LINE_NUMBER(209);				// 0
	r1 = _JC_REF_FIELD(env, r0, javax_crypto_EncryptedPrivateKeyInfo, encoded);
	if (r1 != _JC_NULL)
		goto label0;
	_JC_INVOKE_NONVIRTUAL(env, javax_crypto_EncryptedPrivateKeyInfo, encode$af758db7996768c2, 0, r0);

label0:
	_JC_LINE_NUMBER(210);				// 1
	r1 = _JC_REF_FIELD(env, r0, javax_crypto_EncryptedPrivateKeyInfo, encoded);
	r3 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, clone$b75f2713d6705f70, r1);
	r1 = _JC_CAST_FINAL(env, &_jc_byte$array$prim$type, r3);
	_JC_MONITOR_EXIT(env, thisRef);
	_JC_CANCEL_TRAPS(env, catch);
	return r1;

label1:
	_JC_TRAP_REGION(catch, 2);
	exception = _JC_CAUGHT_EXCEPTION(env);
	_JC_MONITOR_EXIT(env, thisRef);
	_JC_THROW(env, exception);
}

//
// public byte[] getEncryptedData()
//

static _jc_linenum _jc_javax_crypto_EncryptedPrivateKeyInfo$linenum_table$getEncryptedData$09618c69b3c941c8[];

static const unsigned char _jc_javax_crypto_EncryptedPrivateKeyInfo$param_ptypes$getEncryptedData$09618c69b3c941c8[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_javax_crypto_EncryptedPrivateKeyInfo$method_info$getEncryptedData$09618c69b3c941c8 = {
	.name=			"getEncryptedData",
	.signature=		"()[B",
	.class=			&_jc_javax_crypto_EncryptedPrivateKeyInfo$type,
	.return_type=		&_jc_byte$array$prim$type,
	.param_ptypes=		&_jc_javax_crypto_EncryptedPrivateKeyInfo$param_ptypes$getEncryptedData$09618c69b3c941c8,
	.signature_hash=	_JC_JLONG(0x9618c69b3c941c8),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_javax_crypto_EncryptedPrivateKeyInfo$method$getEncryptedData$09618c69b3c941c8,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_EncryptedPrivateKeyInfo$vtable, javax_crypto_EncryptedPrivateKeyInfo.getEncryptedData$09618c69b3c941c8) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_crypto_EncryptedPrivateKeyInfo$linenum_table$getEncryptedData$09618c69b3c941c8
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_EncryptedPrivateKeyInfo, getEncryptedData$09618c69b3c941c8);

_jc_byte_array * _JC_JCNI_ATTR
_jc_javax_crypto_EncryptedPrivateKeyInfo$method$getEncryptedData$09618c69b3c941c8(_jc_env *const env, _jc_javax_crypto_EncryptedPrivateKeyInfo$object *this)
{
	struct _jc_javax_crypto_EncryptedPrivateKeyInfo$object *r0;
	_jc_byte_array *r1;

	r0 = this;
	_JC_LINE_NUMBER(215);				// 0
	r1 = _JC_REF_FIELD(env, r0, javax_crypto_EncryptedPrivateKeyInfo, encryptedData);
	return r1;
}

//
// public java.security.spec.PKCS8EncodedKeySpec getKeySpec(javax.crypto.Cipher) throws java.security.spec.InvalidKeySpecException
//

static _jc_linenum _jc_javax_crypto_EncryptedPrivateKeyInfo$linenum_table$getKeySpec$4bfef1c8f78793a9[];

static _jc_trap_info _jc_javax_crypto_EncryptedPrivateKeyInfo$trap_table$getKeySpec$4bfef1c8f78793a9[] = {
	_JC_TRAP(&_jc_java_lang_Exception$type, 1, 2),
};

static const unsigned char _jc_javax_crypto_EncryptedPrivateKeyInfo$param_ptypes$getKeySpec$4bfef1c8f78793a9[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_javax_crypto_EncryptedPrivateKeyInfo$exceptions$getKeySpec$4bfef1c8f78793a9[] = {
	&_jc_java_security_spec_InvalidKeySpecException$type
};

static _jc_type *const _jc_javax_crypto_EncryptedPrivateKeyInfo$param_types$getKeySpec$4bfef1c8f78793a9[] = {
	&_jc_javax_crypto_Cipher$type
};

_jc_method _jc_javax_crypto_EncryptedPrivateKeyInfo$method_info$getKeySpec$4bfef1c8f78793a9 = {
	.name=			"getKeySpec",
	.signature=		"(Ljavax/crypto/Cipher;)Ljava/security/spec/PKCS8EncodedKeySpec;",
	.class=			&_jc_javax_crypto_EncryptedPrivateKeyInfo$type,
	.param_types=		&_jc_javax_crypto_EncryptedPrivateKeyInfo$param_types$getKeySpec$4bfef1c8f78793a9,
	.return_type=		&_jc_java_security_spec_PKCS8EncodedKeySpec$type,
	.param_ptypes=		&_jc_javax_crypto_EncryptedPrivateKeyInfo$param_ptypes$getKeySpec$4bfef1c8f78793a9,
	.signature_hash=	_JC_JLONG(0x4bfef1c8f78793a9),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_javax_crypto_EncryptedPrivateKeyInfo$method$getKeySpec$4bfef1c8f78793a9,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_EncryptedPrivateKeyInfo$vtable, javax_crypto_EncryptedPrivateKeyInfo.getKeySpec$4bfef1c8f78793a9) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_crypto_EncryptedPrivateKeyInfo$exceptions$getKeySpec$4bfef1c8f78793a9,
	.u= { .exec= {
	  .trap_table_len=	1,
	  .trap_table=		_jc_javax_crypto_EncryptedPrivateKeyInfo$trap_table$getKeySpec$4bfef1c8f78793a9,
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_javax_crypto_EncryptedPrivateKeyInfo$linenum_table$getKeySpec$4bfef1c8f78793a9
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_EncryptedPrivateKeyInfo, getKeySpec$4bfef1c8f78793a9);

_jc_java_security_spec_PKCS8EncodedKeySpec$object * _JC_JCNI_ATTR
_jc_javax_crypto_EncryptedPrivateKeyInfo$method$getKeySpec$4bfef1c8f78793a9(_jc_env *const env, _jc_javax_crypto_EncryptedPrivateKeyInfo$object *this, _jc_javax_crypto_Cipher$object *param0)
{
	jint i0;
	struct _jc_javax_crypto_EncryptedPrivateKeyInfo$object *r0;
	struct _jc_javax_crypto_Cipher$object *r1;
	struct _jc_java_security_spec_PKCS8EncodedKeySpec$object *r2;
	struct _jc_java_lang_Exception$object *volatile r3;
	_jc_byte_array *r4;
	struct _jc_java_security_spec_InvalidKeySpecException$object *volatile r5;
	struct _jc_java_lang_String$object *volatile r6;
	_jc_byte_array *r7;
	struct _jc_java_lang_VMThrowable$object *volatile r9;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_javax_crypto_EncryptedPrivateKeyInfo$method_info$getKeySpec$4bfef1c8f78793a9, &&label0);

	r0 = this;
	r1 = param0;
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(223);				// 0
	r2 = _JC_NEW(env, java_security_spec_PKCS8EncodedKeySpec);
	r4 = _JC_REF_FIELD(env, r0, javax_crypto_EncryptedPrivateKeyInfo, encryptedData);
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	i0 = _JC_ARRAY_LENGTH(env, r4);
	r7 = _JC_INVOKE_NONVIRTUAL(env, javax_crypto_Cipher, doFinal$12da2b94da840b22, 0, r1, r4, 0, i0);
	_JC_REF_FIELD(env, r2, java_security_spec_EncodedKeySpec, encodedKey) = r7;
	_JC_TRAP_REGION(catch, 2);
	_JC_CANCEL_TRAPS(env, catch);
	return r2;

label0:
	_JC_TRAP_REGION(catch, 2);
	r3 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(227);				// 1
	r5 = _JC_NEW(env, java_security_spec_InvalidKeySpecException);
	r6 = _JC_INVOKE_VIRTUAL(env, java_lang_Throwable, toString$7ea43b33b80a3070, r3);
	_JC_REF_FIELD(env, r5, java_lang_Throwable, cause) = r5;
	r9 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r5);
	_JC_REF_FIELD(env, r5, java_lang_Throwable, vmState) = r9;
	_JC_REF_FIELD(env, r5, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r5, java_lang_Throwable, detailMessage) = r6;
	_JC_THROW(env, r5);
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_javax_crypto_EncryptedPrivateKeyInfo$methods[] = {
	&_jc_javax_crypto_EncryptedPrivateKeyInfo$method_info$_init$8978305ea064370f,
	&_jc_javax_crypto_EncryptedPrivateKeyInfo$method_info$_init$7c234efb878f173b,
	&_jc_javax_crypto_EncryptedPrivateKeyInfo$method_info$_init$aaa7e255fe505158,
	&_jc_javax_crypto_EncryptedPrivateKeyInfo$method_info$decode$51530ddb5bfd9a46,
	&_jc_javax_crypto_EncryptedPrivateKeyInfo$method_info$encode$af758db7996768c2,
	&_jc_javax_crypto_EncryptedPrivateKeyInfo$method_info$getAlgName$9251c182bc965747,
	&_jc_javax_crypto_EncryptedPrivateKeyInfo$method_info$getAlgParameters$0923600d443f21c8,
	&_jc_javax_crypto_EncryptedPrivateKeyInfo$method_info$getEncoded$eaf136136217eb89,
	&_jc_javax_crypto_EncryptedPrivateKeyInfo$method_info$getEncryptedData$09618c69b3c941c8,
	&_jc_javax_crypto_EncryptedPrivateKeyInfo$method_info$getKeySpec$4bfef1c8f78793a9
};

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_javax_crypto_EncryptedPrivateKeyInfo$instanceof_hash_bucket_25[] = {
	&_jc_javax_crypto_EncryptedPrivateKeyInfo$type,
	_JC_NULL
};
static _jc_type *const _jc_javax_crypto_EncryptedPrivateKeyInfo$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_javax_crypto_EncryptedPrivateKeyInfo$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[25]=	_jc_javax_crypto_EncryptedPrivateKeyInfo$instanceof_hash_bucket_25,
	[101]=	_jc_javax_crypto_EncryptedPrivateKeyInfo$instanceof_hash_bucket_101
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_javax_crypto_EncryptedPrivateKeyInfo$class_depends[] = {
	{ "gnu/java/security/OID",	_JC_JLONG(0xd963c5e3d173e044) },
	{ "gnu/java/security/der/DERReader",	_JC_JLONG(0x78ef52e48159b870) },
	{ "gnu/java/security/der/DERValue",	_JC_JLONG(0xde1638783317796a) },
	{ "java/io/ByteArrayInputStream",	_JC_JLONG(0xa68cc27886fd8be3) },
	{ "java/io/ByteArrayOutputStream",	_JC_JLONG(0xc4d3cc2bda03a338) },
	{ "java/io/IOException",	_JC_JLONG(0x4e0a56550c69d57c) },
	{ "java/io/OutputStream",	_JC_JLONG(0x4026d3144d6654d8) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/IllegalArgumentException",	_JC_JLONG(0x680cf34d05feb5a1) },
	{ "java/lang/NullPointerException",	_JC_JLONG(0x505b8a9a6675be0) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/RuntimeException",	_JC_JLONG(0x4f5534a987354d1d) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/security/AlgorithmParameters",	_JC_JLONG(0x814794c0d977019) },
	{ "java/security/AlgorithmParametersSpi",	_JC_JLONG(0xfe4af2c744a13852) },
	{ "java/security/GeneralSecurityException",	_JC_JLONG(0x692089051f4c8d0b) },
	{ "java/security/NoSuchAlgorithmException",	_JC_JLONG(0x22e937c2536160b4) },
	{ "java/security/Provider",	_JC_JLONG(0x81b073051aa30acc) },
	{ "java/security/Security",	_JC_JLONG(0x89bf77984bd9669e) },
	{ "java/security/spec/EncodedKeySpec",	_JC_JLONG(0x76558bda43f0601d) },
	{ "java/security/spec/InvalidKeySpecException",	_JC_JLONG(0x602c9e525972bdb8) },
	{ "java/security/spec/PKCS8EncodedKeySpec",	_JC_JLONG(0x1e3298bbc69203d6) },
	{ "java/util/AbstractCollection",	_JC_JLONG(0x8ea716c64b77f8eb) },
	{ "java/util/AbstractList",	_JC_JLONG(0xf5238436362828db) },
	{ "java/util/ArrayList",	_JC_JLONG(0x58038509830ef3f4) },
	{ "javax/crypto/Cipher",	_JC_JLONG(0x4bdfff9ea145d6ce) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_javax_crypto_EncryptedPrivateKeyInfo$vtype _jc_javax_crypto_EncryptedPrivateKeyInfo$type = {
    .type= {
	.name=			"javax/crypto/EncryptedPrivateKeyInfo",
	.superclass=		&_jc_java_lang_Object$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		18,
		.hash=			_JC_JLONG(0xd45a7cf540fb9419),
		.source_file=		"EncryptedPrivateKeyInfo.java",
		.instance_size=		sizeof(_jc_javax_crypto_EncryptedPrivateKeyInfo$refs) + sizeof(_jc_javax_crypto_EncryptedPrivateKeyInfo$object),
		.num_virtual_refs=	5,
		.num_fields=		sizeof(_jc_javax_crypto_EncryptedPrivateKeyInfo$fields) / sizeof(*_jc_javax_crypto_EncryptedPrivateKeyInfo$fields),
		.fields=		_jc_javax_crypto_EncryptedPrivateKeyInfo$fields,
		.num_methods=		sizeof(_jc_javax_crypto_EncryptedPrivateKeyInfo$methods) / sizeof(*_jc_javax_crypto_EncryptedPrivateKeyInfo$methods),
		.methods=		_jc_javax_crypto_EncryptedPrivateKeyInfo$methods,
		.instanceof_hash_table=	_jc_javax_crypto_EncryptedPrivateKeyInfo$instanceof_hash_table,
		.num_class_depends=		sizeof(_jc_javax_crypto_EncryptedPrivateKeyInfo$class_depends) / sizeof(*_jc_javax_crypto_EncryptedPrivateKeyInfo$class_depends),
		.class_depends=		_jc_javax_crypto_EncryptedPrivateKeyInfo$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.javax_crypto_EncryptedPrivateKeyInfo= {
	    .decode$51530ddb5bfd9a46=
		&_jc_javax_crypto_EncryptedPrivateKeyInfo$method$decode$51530ddb5bfd9a46,
	    .encode$af758db7996768c2=
		&_jc_javax_crypto_EncryptedPrivateKeyInfo$method$encode$af758db7996768c2,
	    .getAlgName$9251c182bc965747=
		&_jc_javax_crypto_EncryptedPrivateKeyInfo$method$getAlgName$9251c182bc965747,
	    .getAlgParameters$0923600d443f21c8=
		&_jc_javax_crypto_EncryptedPrivateKeyInfo$method$getAlgParameters$0923600d443f21c8,
	    .getEncoded$eaf136136217eb89=
		&_jc_javax_crypto_EncryptedPrivateKeyInfo$method$getEncoded$eaf136136217eb89,
	    .getEncryptedData$09618c69b3c941c8=
		&_jc_javax_crypto_EncryptedPrivateKeyInfo$method$getEncryptedData$09618c69b3c941c8,
	    .getKeySpec$4bfef1c8f78793a9=
		&_jc_javax_crypto_EncryptedPrivateKeyInfo$method$getKeySpec$4bfef1c8f78793a9,
	},
    }
};

