// public class javax.crypto.SecretKeyFactory

// class file dependencies
// @dep_class f4ba095546954b36 gnu_java_security_Engine
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class f02ab3ccb490a6d0 java_lang_ClassCastException
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class ae4a2342b31a268d java_lang_reflect_InvocationTargetException
// @dep_class 692089051f4c8d0b java_security_GeneralSecurityException
// @dep_class 94dda41e9bf6c170 java_security_InvalidKeyException
// @dep_class 22e937c2536160b4 java_security_NoSuchAlgorithmException
// @dep_class 8dfbf242adab91e java_security_NoSuchProviderException
// @dep_class 81b073051aa30acc java_security_Provider
// @dep_class 89bf77984bd9669e java_security_Security
// @dep_class 602c9e525972bdb8 java_security_spec_InvalidKeySpecException
// @dep_class e5bd533daf8dcb9a java_security_spec_KeySpec
// @dep_class c53e1575b095109b java_util_Vector
// @dep_class 4d0a282085f24fd7 javax_crypto_SecretKey
// @dep_class e553d1eedad0a1e1 javax_crypto_SecretKeyFactory
// @dep_class d672333b6b908575 javax_crypto_SecretKeyFactorySpi

// header file dependencies
// @dep_header gnu_java_security_Engine
// @dep_header java_lang_Class
// @dep_header java_lang_ClassCastException
// @dep_header java_lang_String
// @dep_header java_lang_VMThrowable
// @dep_header java_lang_reflect_InvocationTargetException
// @dep_header java_security_InvalidKeyException
// @dep_header java_security_NoSuchAlgorithmException
// @dep_header java_security_NoSuchProviderException
// @dep_header java_security_Provider
// @dep_header java_security_Security
// @dep_header java_security_spec_InvalidKeySpecException
// @dep_header java_security_spec_KeySpec
// @dep_header java_util_Vector
// @dep_header javax_crypto_SecretKey
// @dep_header javax_crypto_SecretKeyFactory
// @dep_header javax_crypto_SecretKeyFactorySpi

#include "jc_defs.h"

#include "gnu/java/security/Engine.h"
#include "java/lang/Class.h"
#include "java/lang/ClassCastException.h"
#include "java/lang/String.h"
#include "java/lang/VMThrowable.h"
#include "java/lang/reflect/InvocationTargetException.h"
#include "java/security/InvalidKeyException.h"
#include "java/security/NoSuchAlgorithmException.h"
#include "java/security/NoSuchProviderException.h"
#include "java/security/Provider.h"
#include "java/security/Security.h"
#include "java/security/spec/InvalidKeySpecException.h"
#include "java/security/spec/KeySpec.h"
#include "java/util/Vector.h"
#include "javax/crypto/SecretKey.h"
#include "javax/crypto/SecretKeyFactory.h"
#include "javax/crypto/SecretKeyFactorySpi.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// private static final java.lang.String SERVICE
static _jc_field _jc_javax_crypto_SecretKeyFactory$field_info$SERVICE = {
	.name=		"SERVICE",
	.signature=	"Ljava/lang/String;",
	.class=		&_jc_javax_crypto_SecretKeyFactory$type,
	.type=		&_jc_java_lang_String$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_SecretKeyFactory$fields_struct, SERVICE),
	.initial_value=	"SecretKeyFactory",
};

// private javax.crypto.SecretKeyFactorySpi skfSpi
static _jc_field _jc_javax_crypto_SecretKeyFactory$field_info$skfSpi = {
	.name=		"skfSpi",
	.signature=	"Ljavax/crypto/SecretKeyFactorySpi;",
	.class=		&_jc_javax_crypto_SecretKeyFactory$type,
	.type=		&_jc_javax_crypto_SecretKeyFactorySpi$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_SecretKeyFactory$object, refs[-1].javax_crypto_SecretKeyFactory.skfSpi),
};

// private java.security.Provider provider
static _jc_field _jc_javax_crypto_SecretKeyFactory$field_info$provider = {
	.name=		"provider",
	.signature=	"Ljava/security/Provider;",
	.class=		&_jc_javax_crypto_SecretKeyFactory$type,
	.type=		&_jc_java_security_Provider$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_SecretKeyFactory$object, refs[-1].javax_crypto_SecretKeyFactory.provider),
};

// private java.lang.String algorithm
static _jc_field _jc_javax_crypto_SecretKeyFactory$field_info$algorithm = {
	.name=		"algorithm",
	.signature=	"Ljava/lang/String;",
	.class=		&_jc_javax_crypto_SecretKeyFactory$type,
	.type=		&_jc_java_lang_String$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_SecretKeyFactory$object, refs[-1].javax_crypto_SecretKeyFactory.algorithm),
};

// Fields
static _jc_field *const _jc_javax_crypto_SecretKeyFactory$fields[] = {
	&_jc_javax_crypto_SecretKeyFactory$field_info$SERVICE,
	&_jc_javax_crypto_SecretKeyFactory$field_info$algorithm,
	&_jc_javax_crypto_SecretKeyFactory$field_info$provider,
	&_jc_javax_crypto_SecretKeyFactory$field_info$skfSpi
};

/************************************************************************
 *			      Static methods				*
 ************************************************************************/

//
// public static final javax.crypto.SecretKeyFactory getInstance(java.lang.String) throws java.security.NoSuchAlgorithmException
//

static _jc_linenum _jc_javax_crypto_SecretKeyFactory$linenum_table$getInstance$b9b51741939a258f[];

static _jc_trap_info _jc_javax_crypto_SecretKeyFactory$trap_table$getInstance$b9b51741939a258f[] = {
	_JC_TRAP(&_jc_java_security_NoSuchAlgorithmException$type, 1, 2),
};

static const unsigned char _jc_javax_crypto_SecretKeyFactory$param_ptypes$getInstance$b9b51741939a258f[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_javax_crypto_SecretKeyFactory$exceptions$getInstance$b9b51741939a258f[] = {
	&_jc_java_security_NoSuchAlgorithmException$type
};

static _jc_type *const _jc_javax_crypto_SecretKeyFactory$param_types$getInstance$b9b51741939a258f[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_javax_crypto_SecretKeyFactory$method_info$getInstance$b9b51741939a258f = {
	.name=			"getInstance",
	.signature=		"(Ljava/lang/String;)Ljavax/crypto/SecretKeyFactory;",
	.class=			&_jc_javax_crypto_SecretKeyFactory$type,
	.param_types=		&_jc_javax_crypto_SecretKeyFactory$param_types$getInstance$b9b51741939a258f,
	.return_type=		&_jc_javax_crypto_SecretKeyFactory$type,
	.param_ptypes=		&_jc_javax_crypto_SecretKeyFactory$param_ptypes$getInstance$b9b51741939a258f,
	.signature_hash=	_JC_JLONG(0xb9b51741939a258f),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_SecretKeyFactory$method$getInstance$b9b51741939a258f,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_crypto_SecretKeyFactory$exceptions$getInstance$b9b51741939a258f,
	.u= { .exec= {
	  .trap_table_len=	1,
	  .trap_table=		_jc_javax_crypto_SecretKeyFactory$trap_table$getInstance$b9b51741939a258f,
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_javax_crypto_SecretKeyFactory$linenum_table$getInstance$b9b51741939a258f
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_SecretKeyFactory, getInstance$b9b51741939a258f);

_jc_javax_crypto_SecretKeyFactory$object * _JC_JCNI_ATTR
_jc_javax_crypto_SecretKeyFactory$method$getInstance$b9b51741939a258f(_jc_env *const env, _jc_java_lang_String$object *param0)
{
	jint volatile i0;
	jint volatile i1;
	jint i2;
	struct _jc_java_lang_String$object *volatile r0;
	struct _jc_java_security_Provider$object *volatile r2;
	struct _jc_javax_crypto_SecretKeyFactory$object *volatile r3;
	struct _jc_java_security_NoSuchAlgorithmException$object *volatile r4;
	struct _jc_java_lang_VMThrowable$object *volatile r5;
	struct _jc_java_util_Vector$object *r6;
	_jc_object_array *volatile r7;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_javax_crypto_SecretKeyFactory$method_info$getInstance$b9b51741939a258f, &&label1);

	r0 = param0;
	_JC_ACTIVE_USE(env, java_security_Security);
	_JC_LINE_NUMBER(112);				// 0
	r6 = _JC_STATIC_FIELD(env, java_security_Security, providers, 1);
	i2 = _JC_INVOKE_VIRTUAL(env, java_util_Vector, size$345df5220fc60ade, r6);
	r7 = _JC_NEW_REF_ARRAY(env, java_security_Provider, 1, i2);
	r6 = _JC_STATIC_FIELD(env, java_security_Security, providers, 1);
	_JC_INVOKE_VIRTUAL(env, java_util_Vector, copyInto$cd78d768b3ba4735, r6, r7);
	_JC_LINE_NUMBER(113);				// 1
	i0 = 0;
	goto label2;

label0:
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(117);				// 2
	r2 = _JC_REF_ELEMENT(env, r7, i0, 1, 1);
	r3 = _JC_INVOKE_STATIC(env, javax_crypto_SecretKeyFactory, getInstance$f9ad9f7190aa32fb, 0, r0, r2);
	_JC_TRAP_REGION(catch, 2);
	_JC_CANCEL_TRAPS(env, catch);
	return r3;

label1:
	_JC_TRAP_REGION(catch, 2);
	r4 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(113);				// 3
	i0 = i0 + 1;

label2:
	_JC_TRAP_REGION(catch, 2);
	i1 = _JC_ARRAY_LENGTH(env, r7);
	if (i0 < i1) {
		_JC_PERIODIC_CHECK(env);
		goto label0;
	}
	_JC_LINE_NUMBER(123);				// 4
	r4 = _JC_NEW(env, java_security_NoSuchAlgorithmException);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r5 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r5;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r0;
	_JC_THROW(env, r4);
}

//
// public static final javax.crypto.SecretKeyFactory getInstance(java.lang.String, java.lang.String) throws java.security.NoSuchAlgorithmException, java.security.NoSuchProviderException
//

static _jc_linenum _jc_javax_crypto_SecretKeyFactory$linenum_table$getInstance$d8896ed8c2c0696c[];

static const unsigned char _jc_javax_crypto_SecretKeyFactory$param_ptypes$getInstance$d8896ed8c2c0696c[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_javax_crypto_SecretKeyFactory$exceptions$getInstance$d8896ed8c2c0696c[] = {
	&_jc_java_security_NoSuchAlgorithmException$type,
	&_jc_java_security_NoSuchProviderException$type
};

static _jc_type *const _jc_javax_crypto_SecretKeyFactory$param_types$getInstance$d8896ed8c2c0696c[] = {
	&_jc_java_lang_String$type,
	&_jc_java_lang_String$type
};

_jc_method _jc_javax_crypto_SecretKeyFactory$method_info$getInstance$d8896ed8c2c0696c = {
	.name=			"getInstance",
	.signature=		"(Ljava/lang/String;Ljava/lang/String;)Ljavax/crypto/SecretKeyFactory;",
	.class=			&_jc_javax_crypto_SecretKeyFactory$type,
	.param_types=		&_jc_javax_crypto_SecretKeyFactory$param_types$getInstance$d8896ed8c2c0696c,
	.return_type=		&_jc_javax_crypto_SecretKeyFactory$type,
	.param_ptypes=		&_jc_javax_crypto_SecretKeyFactory$param_ptypes$getInstance$d8896ed8c2c0696c,
	.signature_hash=	_JC_JLONG(0xd8896ed8c2c0696c),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_SecretKeyFactory$method$getInstance$d8896ed8c2c0696c,
	.num_parameters=	2,
	.num_exceptions=	2,
	.exceptions=		&_jc_javax_crypto_SecretKeyFactory$exceptions$getInstance$d8896ed8c2c0696c,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_javax_crypto_SecretKeyFactory$linenum_table$getInstance$d8896ed8c2c0696c
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_SecretKeyFactory, getInstance$d8896ed8c2c0696c);

_jc_javax_crypto_SecretKeyFactory$object * _JC_JCNI_ATTR
_jc_javax_crypto_SecretKeyFactory$method$getInstance$d8896ed8c2c0696c(_jc_env *const env, _jc_java_lang_String$object *param0, _jc_java_lang_String$object *param1)
{
	struct _jc_java_lang_String$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_java_security_Provider$object *r2;
	struct _jc_java_security_NoSuchProviderException$object *r3;
	struct _jc_javax_crypto_SecretKeyFactory$object *r4;
	struct _jc_java_lang_VMThrowable$object *r6;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = param0;
	r1 = param1;
	_JC_LINE_NUMBER(141);				// 0
	r2 = _JC_INVOKE_STATIC(env, java_security_Security, getProvider$581ee7d7bc9ae747, 0, r1);
	_JC_LINE_NUMBER(142);				// 1
	if (r2 != _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(144);				// 2
	r3 = _JC_NEW(env, java_security_NoSuchProviderException);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r6 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r6;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r1;
	_JC_THROW(env, r3);

label0:
	_JC_LINE_NUMBER(146);				// 3
	r4 = _JC_INVOKE_STATIC(env, javax_crypto_SecretKeyFactory, getInstance$f9ad9f7190aa32fb, 1, r0, r2);
	return r4;
}

//
// public static final javax.crypto.SecretKeyFactory getInstance(java.lang.String, java.security.Provider) throws java.security.NoSuchAlgorithmException
//

static _jc_linenum _jc_javax_crypto_SecretKeyFactory$linenum_table$getInstance$f9ad9f7190aa32fb[];

static _jc_trap_info _jc_javax_crypto_SecretKeyFactory$trap_table$getInstance$f9ad9f7190aa32fb[] = {
	_JC_TRAP(&_jc_java_lang_reflect_InvocationTargetException$type, 1, 2),
	_JC_TRAP(&_jc_java_lang_ClassCastException$type, 1, 2),
};

static const unsigned char _jc_javax_crypto_SecretKeyFactory$param_ptypes$getInstance$f9ad9f7190aa32fb[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_javax_crypto_SecretKeyFactory$exceptions$getInstance$f9ad9f7190aa32fb[] = {
	&_jc_java_security_NoSuchAlgorithmException$type
};

static _jc_type *const _jc_javax_crypto_SecretKeyFactory$param_types$getInstance$f9ad9f7190aa32fb[] = {
	&_jc_java_lang_String$type,
	&_jc_java_security_Provider$type
};

_jc_method _jc_javax_crypto_SecretKeyFactory$method_info$getInstance$f9ad9f7190aa32fb = {
	.name=			"getInstance",
	.signature=		"(Ljava/lang/String;Ljava/security/Provider;)Ljavax/crypto/SecretKeyFactory;",
	.class=			&_jc_javax_crypto_SecretKeyFactory$type,
	.param_types=		&_jc_javax_crypto_SecretKeyFactory$param_types$getInstance$f9ad9f7190aa32fb,
	.return_type=		&_jc_javax_crypto_SecretKeyFactory$type,
	.param_ptypes=		&_jc_javax_crypto_SecretKeyFactory$param_ptypes$getInstance$f9ad9f7190aa32fb,
	.signature_hash=	_JC_JLONG(0xf9ad9f7190aa32fb),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_SecretKeyFactory$method$getInstance$f9ad9f7190aa32fb,
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_crypto_SecretKeyFactory$exceptions$getInstance$f9ad9f7190aa32fb,
	.u= { .exec= {
	  .trap_table_len=	2,
	  .trap_table=		_jc_javax_crypto_SecretKeyFactory$trap_table$getInstance$f9ad9f7190aa32fb,
	  .u= {
	    .linenum= {
	      .len=	7,
	      .table=	_jc_javax_crypto_SecretKeyFactory$linenum_table$getInstance$f9ad9f7190aa32fb
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_SecretKeyFactory, getInstance$f9ad9f7190aa32fb);

_jc_javax_crypto_SecretKeyFactory$object * _JC_JCNI_ATTR
_jc_javax_crypto_SecretKeyFactory$method$getInstance$f9ad9f7190aa32fb(_jc_env *const env, _jc_java_lang_String$object *param0, _jc_java_security_Provider$object *param1)
{
	struct _jc_java_lang_String$object *volatile r0;
	struct _jc_java_security_Provider$object *r1;
	struct _jc_java_lang_Object$object *r10;
	struct _jc_java_lang_VMThrowable$object *volatile r11;
	struct _jc_java_lang_VMThrowable$object *volatile r12;
	struct _jc_java_lang_VMThrowable$object *volatile r14;
	struct _jc_javax_crypto_SecretKeyFactory$object *r2;
	struct _jc_java_lang_reflect_InvocationTargetException$object *volatile r3;
	struct _jc_javax_crypto_SecretKeyFactorySpi$object *r4;
	struct _jc_java_lang_Throwable$object *volatile r5;
	struct _jc_java_security_NoSuchAlgorithmException$object *volatile r6;
	struct _jc_java_lang_ClassCastException$object *r7;
	struct _jc_java_lang_String$object *r8;
	_jc_object_array *r9;
	jboolean volatile z0;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_javax_crypto_SecretKeyFactory$method_info$getInstance$f9ad9f7190aa32fb, &&label0, &&label3);

	r0 = param0;
	r1 = param1;
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(164);				// 0
	r2 = _JC_NEW(env, javax_crypto_SecretKeyFactory);
	_JC_ACTIVE_USE(env, gnu_java_security_Engine);
	r8 = _JC_STRING(env, "SecretKeyFactory");
	r9 = _JC_STATIC_FIELD(env, gnu_java_security_Engine, NO__5fARGS, 1);
	r10 = _JC_INVOKE_STATIC(env, gnu_java_security_Engine, getInstance$ec89dfd35c234c64, 1, r8, r0, r1, r9);
	r4 = _JC_CAST(env, &_jc_javax_crypto_SecretKeyFactorySpi$type, r10);
	_JC_REF_FIELD(env, r2, javax_crypto_SecretKeyFactory, skfSpi) = r4;
	_JC_REF_FIELD(env, r2, javax_crypto_SecretKeyFactory, provider) = r1;
	_JC_REF_FIELD(env, r2, javax_crypto_SecretKeyFactory, algorithm) = r0;
	_JC_TRAP_REGION(catch, 2);
	_JC_CANCEL_TRAPS(env, catch);
	return r2;

label0:
	_JC_TRAP_REGION(catch, 2);
	r3 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(170);				// 1
	r5 = _JC_INVOKE_VIRTUAL(env, java_lang_reflect_InvocationTargetException, getCause$d5a96efc8523817a, r3);
	if (r5 != _JC_NULL)
		goto label1;
	_JC_LINE_NUMBER(171);				// 2
	r6 = _JC_NEW(env, java_security_NoSuchAlgorithmException);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, cause) = r6;
	r11 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r6);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, vmState) = r11;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, detailMessage) = r0;
	_JC_THROW(env, r6);

label1:
	_JC_LINE_NUMBER(172);				// 3
	r5 = _JC_INVOKE_VIRTUAL(env, java_lang_reflect_InvocationTargetException, getCause$d5a96efc8523817a, r3);
	z0 = _JC_INSTANCEOF(env, r5, &_jc_java_security_NoSuchAlgorithmException$type);
	if (z0 == 0)
		goto label2;
	_JC_LINE_NUMBER(173);				// 4
	r5 = _JC_INVOKE_VIRTUAL(env, java_lang_reflect_InvocationTargetException, getCause$d5a96efc8523817a, r3);
	r6 = _JC_CAST(env, &_jc_java_security_NoSuchAlgorithmException$type, r5);
	_JC_THROW(env, r6);

label2:
	_JC_LINE_NUMBER(174);				// 5
	r6 = _JC_NEW(env, java_security_NoSuchAlgorithmException);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, cause) = r6;
	r12 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r6);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, vmState) = r12;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, detailMessage) = r0;
	_JC_THROW(env, r6);

label3:
	_JC_TRAP_REGION(catch, 2);
	r7 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(178);				// 6
	r6 = _JC_NEW(env, java_security_NoSuchAlgorithmException);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, cause) = r6;
	r14 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r6);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, vmState) = r14;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, detailMessage) = r0;
	_JC_THROW(env, r6);
}

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// protected void <init>(javax.crypto.SecretKeyFactorySpi, java.security.Provider, java.lang.String)
//

static _jc_linenum _jc_javax_crypto_SecretKeyFactory$linenum_table$_init$6934586dd3cecd60[];

static const unsigned char _jc_javax_crypto_SecretKeyFactory$param_ptypes$_init$6934586dd3cecd60[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_SecretKeyFactory$param_types$_init$6934586dd3cecd60[] = {
	&_jc_javax_crypto_SecretKeyFactorySpi$type,
	&_jc_java_security_Provider$type,
	&_jc_java_lang_String$type
};

_jc_method _jc_javax_crypto_SecretKeyFactory$method_info$_init$6934586dd3cecd60 = {
	.name=			"<init>",
	.signature=		"(Ljavax/crypto/SecretKeyFactorySpi;Ljava/security/Provider;Ljava/lang/String;)V",
	.class=			&_jc_javax_crypto_SecretKeyFactory$type,
	.param_types=		&_jc_javax_crypto_SecretKeyFactory$param_types$_init$6934586dd3cecd60,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_SecretKeyFactory$param_ptypes$_init$6934586dd3cecd60,
	.signature_hash=	_JC_JLONG(0x6934586dd3cecd60),
	.access_flags=		_JC_ACC_PROTECTED,
	.function=		&_jc_javax_crypto_SecretKeyFactory$method$_init$6934586dd3cecd60,
	.num_parameters=	3,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_javax_crypto_SecretKeyFactory$linenum_table$_init$6934586dd3cecd60
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_SecretKeyFactory, _init$6934586dd3cecd60);

void _JC_JCNI_ATTR
_jc_javax_crypto_SecretKeyFactory$method$_init$6934586dd3cecd60(_jc_env *const env, _jc_javax_crypto_SecretKeyFactory$object *this, _jc_javax_crypto_SecretKeyFactorySpi$object *param0, _jc_java_security_Provider$object *param1, _jc_java_lang_String$object *param2)
{
	struct _jc_javax_crypto_SecretKeyFactory$object *r0;
	struct _jc_javax_crypto_SecretKeyFactorySpi$object *r1;
	struct _jc_java_security_Provider$object *r2;
	struct _jc_java_lang_String$object *r3;

	r0 = this;
	r1 = param0;
	r2 = param1;
	r3 = param2;
	_JC_LINE_NUMBER(92);				// 0
	_JC_REF_FIELD(env, r0, javax_crypto_SecretKeyFactory, skfSpi) = r1;
	_JC_LINE_NUMBER(93);				// 1
	_JC_REF_FIELD(env, r0, javax_crypto_SecretKeyFactory, provider) = r2;
	_JC_LINE_NUMBER(94);				// 2
	_JC_REF_FIELD(env, r0, javax_crypto_SecretKeyFactory, algorithm) = r3;
	_JC_LINE_NUMBER(95);				// 3
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public final javax.crypto.SecretKey generateSecret(java.security.spec.KeySpec) throws java.security.spec.InvalidKeySpecException
//

static _jc_linenum _jc_javax_crypto_SecretKeyFactory$linenum_table$generateSecret$aaf9431066935ebb[];

static const unsigned char _jc_javax_crypto_SecretKeyFactory$param_ptypes$generateSecret$aaf9431066935ebb[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_javax_crypto_SecretKeyFactory$exceptions$generateSecret$aaf9431066935ebb[] = {
	&_jc_java_security_spec_InvalidKeySpecException$type
};

static _jc_type *const _jc_javax_crypto_SecretKeyFactory$param_types$generateSecret$aaf9431066935ebb[] = {
	&_jc_java_security_spec_KeySpec$type
};

_jc_method _jc_javax_crypto_SecretKeyFactory$method_info$generateSecret$aaf9431066935ebb = {
	.name=			"generateSecret",
	.signature=		"(Ljava/security/spec/KeySpec;)Ljavax/crypto/SecretKey;",
	.class=			&_jc_javax_crypto_SecretKeyFactory$type,
	.param_types=		&_jc_javax_crypto_SecretKeyFactory$param_types$generateSecret$aaf9431066935ebb,
	.return_type=		&_jc_javax_crypto_SecretKey$type,
	.param_ptypes=		&_jc_javax_crypto_SecretKeyFactory$param_ptypes$generateSecret$aaf9431066935ebb,
	.signature_hash=	_JC_JLONG(0xaaf9431066935ebb),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_SecretKeyFactory$method$generateSecret$aaf9431066935ebb,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_SecretKeyFactory$vtable, javax_crypto_SecretKeyFactory.generateSecret$aaf9431066935ebb) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_crypto_SecretKeyFactory$exceptions$generateSecret$aaf9431066935ebb,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_crypto_SecretKeyFactory$linenum_table$generateSecret$aaf9431066935ebb
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_SecretKeyFactory, generateSecret$aaf9431066935ebb);

_jc_object * _JC_JCNI_ATTR
_jc_javax_crypto_SecretKeyFactory$method$generateSecret$aaf9431066935ebb(_jc_env *const env, _jc_javax_crypto_SecretKeyFactory$object *this, _jc_object *param0)
{
	struct _jc_javax_crypto_SecretKeyFactory$object *r0;
	struct _jc_object *r1;
	struct _jc_javax_crypto_SecretKeyFactorySpi$object *r2;
	struct _jc_object *r3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(196);				// 0
	r2 = _JC_REF_FIELD(env, r0, javax_crypto_SecretKeyFactory, skfSpi);
	r3 = _JC_INVOKE_VIRTUAL(env, javax_crypto_SecretKeyFactorySpi, engineGenerateSecret$8fd98bf1956dbe34, r2, r1);
	return r3;
}

//
// public final java.lang.String getAlgorithm()
//

static _jc_linenum _jc_javax_crypto_SecretKeyFactory$linenum_table$getAlgorithm$19abbbc132b9063a[];

static const unsigned char _jc_javax_crypto_SecretKeyFactory$param_ptypes$getAlgorithm$19abbbc132b9063a[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_javax_crypto_SecretKeyFactory$method_info$getAlgorithm$19abbbc132b9063a = {
	.name=			"getAlgorithm",
	.signature=		"()Ljava/lang/String;",
	.class=			&_jc_javax_crypto_SecretKeyFactory$type,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_javax_crypto_SecretKeyFactory$param_ptypes$getAlgorithm$19abbbc132b9063a,
	.signature_hash=	_JC_JLONG(0x19abbbc132b9063a),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_SecretKeyFactory$method$getAlgorithm$19abbbc132b9063a,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_SecretKeyFactory$vtable, javax_crypto_SecretKeyFactory.getAlgorithm$19abbbc132b9063a) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_crypto_SecretKeyFactory$linenum_table$getAlgorithm$19abbbc132b9063a
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_SecretKeyFactory, getAlgorithm$19abbbc132b9063a);

_jc_java_lang_String$object * _JC_JCNI_ATTR
_jc_javax_crypto_SecretKeyFactory$method$getAlgorithm$19abbbc132b9063a(_jc_env *const env, _jc_javax_crypto_SecretKeyFactory$object *this)
{
	struct _jc_javax_crypto_SecretKeyFactory$object *r0;
	struct _jc_java_lang_String$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(206);				// 0
	r1 = _JC_REF_FIELD(env, r0, javax_crypto_SecretKeyFactory, algorithm);
	return r1;
}

//
// public final java.security.spec.KeySpec getKeySpec(javax.crypto.SecretKey, java.lang.Class) throws java.security.spec.InvalidKeySpecException
//

static _jc_linenum _jc_javax_crypto_SecretKeyFactory$linenum_table$getKeySpec$dd8d216eec3d8497[];

static const unsigned char _jc_javax_crypto_SecretKeyFactory$param_ptypes$getKeySpec$dd8d216eec3d8497[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_javax_crypto_SecretKeyFactory$exceptions$getKeySpec$dd8d216eec3d8497[] = {
	&_jc_java_security_spec_InvalidKeySpecException$type
};

static _jc_type *const _jc_javax_crypto_SecretKeyFactory$param_types$getKeySpec$dd8d216eec3d8497[] = {
	&_jc_javax_crypto_SecretKey$type,
	&_jc_java_lang_Class$type
};

_jc_method _jc_javax_crypto_SecretKeyFactory$method_info$getKeySpec$dd8d216eec3d8497 = {
	.name=			"getKeySpec",
	.signature=		"(Ljavax/crypto/SecretKey;Ljava/lang/Class;)Ljava/security/spec/KeySpec;",
	.class=			&_jc_javax_crypto_SecretKeyFactory$type,
	.param_types=		&_jc_javax_crypto_SecretKeyFactory$param_types$getKeySpec$dd8d216eec3d8497,
	.return_type=		&_jc_java_security_spec_KeySpec$type,
	.param_ptypes=		&_jc_javax_crypto_SecretKeyFactory$param_ptypes$getKeySpec$dd8d216eec3d8497,
	.signature_hash=	_JC_JLONG(0xdd8d216eec3d8497),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_SecretKeyFactory$method$getKeySpec$dd8d216eec3d8497,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_SecretKeyFactory$vtable, javax_crypto_SecretKeyFactory.getKeySpec$dd8d216eec3d8497) / sizeof(void *),
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_crypto_SecretKeyFactory$exceptions$getKeySpec$dd8d216eec3d8497,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_crypto_SecretKeyFactory$linenum_table$getKeySpec$dd8d216eec3d8497
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_SecretKeyFactory, getKeySpec$dd8d216eec3d8497);

_jc_object * _JC_JCNI_ATTR
_jc_javax_crypto_SecretKeyFactory$method$getKeySpec$dd8d216eec3d8497(_jc_env *const env, _jc_javax_crypto_SecretKeyFactory$object *this, _jc_object *param0, _jc_java_lang_Class$object *param1)
{
	struct _jc_javax_crypto_SecretKeyFactory$object *r0;
	struct _jc_object *r1;
	struct _jc_java_lang_Class$object *r2;
	struct _jc_javax_crypto_SecretKeyFactorySpi$object *r3;
	struct _jc_object *r4;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_LINE_NUMBER(221);				// 0
	r3 = _JC_REF_FIELD(env, r0, javax_crypto_SecretKeyFactory, skfSpi);
	r4 = _JC_INVOKE_VIRTUAL(env, javax_crypto_SecretKeyFactorySpi, engineGetKeySpec$d2cdb5eb64c644b0, r3, r1, r2);
	return r4;
}

//
// public final java.security.Provider getProvider()
//

static _jc_linenum _jc_javax_crypto_SecretKeyFactory$linenum_table$getProvider$e8f9c9fb14140d5a[];

static const unsigned char _jc_javax_crypto_SecretKeyFactory$param_ptypes$getProvider$e8f9c9fb14140d5a[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_javax_crypto_SecretKeyFactory$method_info$getProvider$e8f9c9fb14140d5a = {
	.name=			"getProvider",
	.signature=		"()Ljava/security/Provider;",
	.class=			&_jc_javax_crypto_SecretKeyFactory$type,
	.return_type=		&_jc_java_security_Provider$type,
	.param_ptypes=		&_jc_javax_crypto_SecretKeyFactory$param_ptypes$getProvider$e8f9c9fb14140d5a,
	.signature_hash=	_JC_JLONG(0xe8f9c9fb14140d5a),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_SecretKeyFactory$method$getProvider$e8f9c9fb14140d5a,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_SecretKeyFactory$vtable, javax_crypto_SecretKeyFactory.getProvider$e8f9c9fb14140d5a) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_crypto_SecretKeyFactory$linenum_table$getProvider$e8f9c9fb14140d5a
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_SecretKeyFactory, getProvider$e8f9c9fb14140d5a);

_jc_java_security_Provider$object * _JC_JCNI_ATTR
_jc_javax_crypto_SecretKeyFactory$method$getProvider$e8f9c9fb14140d5a(_jc_env *const env, _jc_javax_crypto_SecretKeyFactory$object *this)
{
	struct _jc_javax_crypto_SecretKeyFactory$object *r0;
	struct _jc_java_security_Provider$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(231);				// 0
	r1 = _JC_REF_FIELD(env, r0, javax_crypto_SecretKeyFactory, provider);
	return r1;
}

//
// public final javax.crypto.SecretKey translateKey(javax.crypto.SecretKey) throws java.security.InvalidKeyException
//

static _jc_linenum _jc_javax_crypto_SecretKeyFactory$linenum_table$translateKey$15b5a1b9065abbcb[];

static const unsigned char _jc_javax_crypto_SecretKeyFactory$param_ptypes$translateKey$15b5a1b9065abbcb[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_javax_crypto_SecretKeyFactory$exceptions$translateKey$15b5a1b9065abbcb[] = {
	&_jc_java_security_InvalidKeyException$type
};

static _jc_type *const _jc_javax_crypto_SecretKeyFactory$param_types$translateKey$15b5a1b9065abbcb[] = {
	&_jc_javax_crypto_SecretKey$type
};

_jc_method _jc_javax_crypto_SecretKeyFactory$method_info$translateKey$15b5a1b9065abbcb = {
	.name=			"translateKey",
	.signature=		"(Ljavax/crypto/SecretKey;)Ljavax/crypto/SecretKey;",
	.class=			&_jc_javax_crypto_SecretKeyFactory$type,
	.param_types=		&_jc_javax_crypto_SecretKeyFactory$param_types$translateKey$15b5a1b9065abbcb,
	.return_type=		&_jc_javax_crypto_SecretKey$type,
	.param_ptypes=		&_jc_javax_crypto_SecretKeyFactory$param_ptypes$translateKey$15b5a1b9065abbcb,
	.signature_hash=	_JC_JLONG(0x15b5a1b9065abbcb),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_SecretKeyFactory$method$translateKey$15b5a1b9065abbcb,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_SecretKeyFactory$vtable, javax_crypto_SecretKeyFactory.translateKey$15b5a1b9065abbcb) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_crypto_SecretKeyFactory$exceptions$translateKey$15b5a1b9065abbcb,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_crypto_SecretKeyFactory$linenum_table$translateKey$15b5a1b9065abbcb
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_SecretKeyFactory, translateKey$15b5a1b9065abbcb);

_jc_object * _JC_JCNI_ATTR
_jc_javax_crypto_SecretKeyFactory$method$translateKey$15b5a1b9065abbcb(_jc_env *const env, _jc_javax_crypto_SecretKeyFactory$object *this, _jc_object *param0)
{
	struct _jc_javax_crypto_SecretKeyFactory$object *r0;
	struct _jc_object *r1;
	struct _jc_javax_crypto_SecretKeyFactorySpi$object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(245);				// 0
	r2 = _JC_REF_FIELD(env, r0, javax_crypto_SecretKeyFactory, skfSpi);
	r1 = _JC_INVOKE_VIRTUAL(env, javax_crypto_SecretKeyFactorySpi, engineTranslateKey$84d30673c54d8d42, r2, r1);
	return r1;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_javax_crypto_SecretKeyFactory$methods[] = {
	&_jc_javax_crypto_SecretKeyFactory$method_info$_init$6934586dd3cecd60,
	&_jc_javax_crypto_SecretKeyFactory$method_info$generateSecret$aaf9431066935ebb,
	&_jc_javax_crypto_SecretKeyFactory$method_info$getAlgorithm$19abbbc132b9063a,
	&_jc_javax_crypto_SecretKeyFactory$method_info$getInstance$b9b51741939a258f,
	&_jc_javax_crypto_SecretKeyFactory$method_info$getInstance$d8896ed8c2c0696c,
	&_jc_javax_crypto_SecretKeyFactory$method_info$getInstance$f9ad9f7190aa32fb,
	&_jc_javax_crypto_SecretKeyFactory$method_info$getKeySpec$dd8d216eec3d8497,
	&_jc_javax_crypto_SecretKeyFactory$method_info$getProvider$e8f9c9fb14140d5a,
	&_jc_javax_crypto_SecretKeyFactory$method_info$translateKey$15b5a1b9065abbcb
};

/************************************************************************
 *			  Class fields structure			*
 ************************************************************************/

_jc_javax_crypto_SecretKeyFactory$fields_struct _jc_javax_crypto_SecretKeyFactory$class_fields = { };

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_javax_crypto_SecretKeyFactory$instanceof_hash_bucket_97[] = {
	&_jc_javax_crypto_SecretKeyFactory$type,
	_JC_NULL
};
static _jc_type *const _jc_javax_crypto_SecretKeyFactory$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_javax_crypto_SecretKeyFactory$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[97]=	_jc_javax_crypto_SecretKeyFactory$instanceof_hash_bucket_97,
	[101]=	_jc_javax_crypto_SecretKeyFactory$instanceof_hash_bucket_101
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_javax_crypto_SecretKeyFactory$class_depends[] = {
	{ "gnu/java/security/Engine",	_JC_JLONG(0xf4ba095546954b36) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/ClassCastException",	_JC_JLONG(0xf02ab3ccb490a6d0) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/lang/reflect/InvocationTargetException",	_JC_JLONG(0xae4a2342b31a268d) },
	{ "java/security/GeneralSecurityException",	_JC_JLONG(0x692089051f4c8d0b) },
	{ "java/security/InvalidKeyException",	_JC_JLONG(0x94dda41e9bf6c170) },
	{ "java/security/NoSuchAlgorithmException",	_JC_JLONG(0x22e937c2536160b4) },
	{ "java/security/NoSuchProviderException",	_JC_JLONG(0x8dfbf242adab91e) },
	{ "java/security/Provider",	_JC_JLONG(0x81b073051aa30acc) },
	{ "java/security/Security",	_JC_JLONG(0x89bf77984bd9669e) },
	{ "java/security/spec/InvalidKeySpecException",	_JC_JLONG(0x602c9e525972bdb8) },
	{ "java/security/spec/KeySpec",	_JC_JLONG(0xe5bd533daf8dcb9a) },
	{ "java/util/Vector",	_JC_JLONG(0xc53e1575b095109b) },
	{ "javax/crypto/SecretKey",	_JC_JLONG(0x4d0a282085f24fd7) },
	{ "javax/crypto/SecretKeyFactorySpi",	_JC_JLONG(0xd672333b6b908575) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_javax_crypto_SecretKeyFactory$vtype _jc_javax_crypto_SecretKeyFactory$type = {
    .type= {
	.name=			"javax/crypto/SecretKeyFactory",
	.superclass=		&_jc_java_lang_Object$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		16,
		.hash=			_JC_JLONG(0xe553d1eedad0a1e1),
		.source_file=		"SecretKeyFactory.java",
		.instance_size=		sizeof(_jc_javax_crypto_SecretKeyFactory$refs) + sizeof(_jc_javax_crypto_SecretKeyFactory$object),
		.num_virtual_refs=	3,
		.num_fields=		sizeof(_jc_javax_crypto_SecretKeyFactory$fields) / sizeof(*_jc_javax_crypto_SecretKeyFactory$fields),
		.fields=		_jc_javax_crypto_SecretKeyFactory$fields,
		.num_methods=		sizeof(_jc_javax_crypto_SecretKeyFactory$methods) / sizeof(*_jc_javax_crypto_SecretKeyFactory$methods),
		.methods=		_jc_javax_crypto_SecretKeyFactory$methods,
		.instanceof_hash_table=	_jc_javax_crypto_SecretKeyFactory$instanceof_hash_table,
		.class_fields=		&_jc_javax_crypto_SecretKeyFactory$class_fields,
		.num_class_depends=		sizeof(_jc_javax_crypto_SecretKeyFactory$class_depends) / sizeof(*_jc_javax_crypto_SecretKeyFactory$class_depends),
		.class_depends=		_jc_javax_crypto_SecretKeyFactory$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.javax_crypto_SecretKeyFactory= {
	    .generateSecret$aaf9431066935ebb=
		&_jc_javax_crypto_SecretKeyFactory$method$generateSecret$aaf9431066935ebb,
	    .getAlgorithm$19abbbc132b9063a=
		&_jc_javax_crypto_SecretKeyFactory$method$getAlgorithm$19abbbc132b9063a,
	    .getKeySpec$dd8d216eec3d8497=
		&_jc_javax_crypto_SecretKeyFactory$method$getKeySpec$dd8d216eec3d8497,
	    .getProvider$e8f9c9fb14140d5a=
		&_jc_javax_crypto_SecretKeyFactory$method$getProvider$e8f9c9fb14140d5a,
	    .translateKey$15b5a1b9065abbcb=
		&_jc_javax_crypto_SecretKeyFactory$method$translateKey$15b5a1b9065abbcb,
	},
    }
};

