// public class javax.crypto.spec.DESedeKeySpec

// class file dependencies
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 53cc8e2333795f04 java_lang_System
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class 4d1cebae0bdda058 java_lang_VMSystem
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class 692089051f4c8d0b java_security_GeneralSecurityException
// @dep_class 94dda41e9bf6c170 java_security_InvalidKeyException
// @dep_class 965d036f0f33fac6 java_security_KeyException
// @dep_class e5bd533daf8dcb9a java_security_spec_KeySpec
// @dep_class 7825ceeafd22c984 javax_crypto_spec_DESedeKeySpec

// header file dependencies
// @dep_header java_lang_Class
// @dep_header java_lang_String
// @dep_header java_lang_System
// @dep_header java_lang_VMSystem
// @dep_header java_lang_VMThrowable
// @dep_header java_security_InvalidKeyException
// @dep_header java_security_spec_KeySpec
// @dep_header javax_crypto_spec_DESedeKeySpec

#include "jc_defs.h"

#include "java/lang/Class.h"
#include "java/lang/String.h"
#include "java/lang/System.h"
#include "java/lang/VMSystem.h"
#include "java/lang/VMThrowable.h"
#include "java/security/InvalidKeyException.h"
#include "java/security/spec/KeySpec.h"
#include "javax/crypto/spec/DESedeKeySpec.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// public static final int DES_EDE_KEY_LEN
static const jint _jc_javax_crypto_spec_DESedeKeySpec$initial_value$DES__5fEDE__5fKEY__5fLEN = 24;
static _jc_field _jc_javax_crypto_spec_DESedeKeySpec$field_info$DES__5fEDE__5fKEY__5fLEN = {
	.name=		"DES_EDE_KEY_LEN",
	.signature=	"I",
	.class=		&_jc_javax_crypto_spec_DESedeKeySpec$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PUBLIC|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_spec_DESedeKeySpec$fields_struct, DES__5fEDE__5fKEY__5fLEN),
	.initial_value=	&_jc_javax_crypto_spec_DESedeKeySpec$initial_value$DES__5fEDE__5fKEY__5fLEN,
};

// private byte[] key
static _jc_field _jc_javax_crypto_spec_DESedeKeySpec$field_info$key = {
	.name=		"key",
	.signature=	"[B",
	.class=		&_jc_javax_crypto_spec_DESedeKeySpec$type,
	.type=		&_jc_byte$array$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_spec_DESedeKeySpec$object, refs[-1].javax_crypto_spec_DESedeKeySpec.key),
};

// Fields
static _jc_field *const _jc_javax_crypto_spec_DESedeKeySpec$fields[] = {
	&_jc_javax_crypto_spec_DESedeKeySpec$field_info$DES__5fEDE__5fKEY__5fLEN,
	&_jc_javax_crypto_spec_DESedeKeySpec$field_info$key
};

/************************************************************************
 *			      Static methods				*
 ************************************************************************/

//
// public static boolean isParityAdjusted(byte[], int) throws java.security.InvalidKeyException
//

static _jc_linenum _jc_javax_crypto_spec_DESedeKeySpec$linenum_table$isParityAdjusted$8495d84f2120000f[];

static const unsigned char _jc_javax_crypto_spec_DESedeKeySpec$param_ptypes$isParityAdjusted$8495d84f2120000f[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_javax_crypto_spec_DESedeKeySpec$exceptions$isParityAdjusted$8495d84f2120000f[] = {
	&_jc_java_security_InvalidKeyException$type
};

static _jc_type *const _jc_javax_crypto_spec_DESedeKeySpec$param_types$isParityAdjusted$8495d84f2120000f[] = {
	&_jc_byte$array$prim$type,
	&_jc_int$prim$type
};

_jc_method _jc_javax_crypto_spec_DESedeKeySpec$method_info$isParityAdjusted$8495d84f2120000f = {
	.name=			"isParityAdjusted",
	.signature=		"([BI)Z",
	.class=			&_jc_javax_crypto_spec_DESedeKeySpec$type,
	.param_types=		&_jc_javax_crypto_spec_DESedeKeySpec$param_types$isParityAdjusted$8495d84f2120000f,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_javax_crypto_spec_DESedeKeySpec$param_ptypes$isParityAdjusted$8495d84f2120000f,
	.signature_hash=	_JC_JLONG(0x8495d84f2120000f),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_javax_crypto_spec_DESedeKeySpec$method$isParityAdjusted$8495d84f2120000f,
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_crypto_spec_DESedeKeySpec$exceptions$isParityAdjusted$8495d84f2120000f,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	11,
	      .table=	_jc_javax_crypto_spec_DESedeKeySpec$linenum_table$isParityAdjusted$8495d84f2120000f
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_spec_DESedeKeySpec, isParityAdjusted$8495d84f2120000f);

jboolean _JC_JCNI_ATTR
_jc_javax_crypto_spec_DESedeKeySpec$method$isParityAdjusted$8495d84f2120000f(_jc_env *const env, _jc_byte_array *param0, jint param1)
{
	jbyte b4;
	jint i0;
	jint i1;
	jint i2;
	jint i3;
	_jc_byte_array *r0;
	struct _jc_java_security_InvalidKeyException$object *r1;
	struct _jc_java_lang_String$object *r2;
	struct _jc_java_lang_VMThrowable$object *r4;
	jboolean z0;
	jboolean z1;
	jboolean z2;

	r0 = param0;
	i0 = param1;
	_JC_LINE_NUMBER(120);				// 0
	i2 = _JC_ARRAY_LENGTH(env, r0);
	i2 = i2 - i0;
	if (i2 >= 24)
		goto label0;
	_JC_LINE_NUMBER(122);				// 1
	r1 = _JC_NEW(env, java_security_InvalidKeyException);
	r2 = _JC_STRING(env, "DES-EDE keys must be 24 bytes long");
	_JC_REF_FIELD(env, r1, java_lang_Throwable, cause) = r1;
	r4 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r1);
	_JC_REF_FIELD(env, r1, java_lang_Throwable, vmState) = r4;
	_JC_REF_FIELD(env, r1, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r1, java_lang_Throwable, detailMessage) = r2;
	_JC_THROW(env, r1);

label0:
	_JC_LINE_NUMBER(124);				// 2
	z0 = 0;
	_JC_LINE_NUMBER(126);				// 3
	i1 = 0;
	goto label5;

label1:
	_JC_LINE_NUMBER(128);				// 4
	z1 = 0;
	_JC_LINE_NUMBER(129);				// 5
	i2 = 0;
	goto label4;

label2:
	_JC_LINE_NUMBER(131);				// 6
	z2 = 0;
	i3 = i1 + i0;
	b4 = _JC_PRIM_ELEMENT(env, byte, r0, i3, 1, 1);
	i3 = 1 << (i2 & 0x1f);
	i3 = b4 & i3;
	if (i3 == 0)
		goto label3;
	z2 = 1;

label3:
	z1 = z1 ^ z2;
	_JC_LINE_NUMBER(129);				// 7
	i2 = i2 + 1;

label4:
	if (i2 < 8) {
		_JC_PERIODIC_CHECK(env);
		goto label2;
	}
	_JC_LINE_NUMBER(133);				// 8
	z0 = z0 & z1;
	_JC_LINE_NUMBER(126);				// 9
	i1 = i1 + 1;

label5:
	if (i1 < 24) {
		_JC_PERIODIC_CHECK(env);
		goto label1;
	}
	_JC_LINE_NUMBER(135);				// 10
	return z0;
}

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// public void <init>(byte[]) throws java.security.InvalidKeyException
//

static _jc_linenum _jc_javax_crypto_spec_DESedeKeySpec$linenum_table$_init$aaa7e255fe505158[];

static const unsigned char _jc_javax_crypto_spec_DESedeKeySpec$param_ptypes$_init$aaa7e255fe505158[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_spec_DESedeKeySpec$exceptions$_init$aaa7e255fe505158[] = {
	&_jc_java_security_InvalidKeyException$type
};

static _jc_type *const _jc_javax_crypto_spec_DESedeKeySpec$param_types$_init$aaa7e255fe505158[] = {
	&_jc_byte$array$prim$type
};

_jc_method _jc_javax_crypto_spec_DESedeKeySpec$method_info$_init$aaa7e255fe505158 = {
	.name=			"<init>",
	.signature=		"([B)V",
	.class=			&_jc_javax_crypto_spec_DESedeKeySpec$type,
	.param_types=		&_jc_javax_crypto_spec_DESedeKeySpec$param_types$_init$aaa7e255fe505158,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_spec_DESedeKeySpec$param_ptypes$_init$aaa7e255fe505158,
	.signature_hash=	_JC_JLONG(0xaaa7e255fe505158),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_javax_crypto_spec_DESedeKeySpec$method$_init$aaa7e255fe505158,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_crypto_spec_DESedeKeySpec$exceptions$_init$aaa7e255fe505158,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_crypto_spec_DESedeKeySpec$linenum_table$_init$aaa7e255fe505158
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_spec_DESedeKeySpec, _init$aaa7e255fe505158);

void _JC_JCNI_ATTR
_jc_javax_crypto_spec_DESedeKeySpec$method$_init$aaa7e255fe505158(_jc_env *const env, _jc_javax_crypto_spec_DESedeKeySpec$object *this, _jc_byte_array *param0)
{
	jint i0;
	struct _jc_javax_crypto_spec_DESedeKeySpec$object *r0;
	_jc_byte_array *r1;
	struct _jc_java_security_InvalidKeyException$object *r2;
	_jc_byte_array *r3;
	struct _jc_java_lang_String$object *r4;
	struct _jc_java_lang_VMThrowable$object *r6;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	i0 = _JC_ARRAY_LENGTH(env, r1);
	i0 = i0 - 0;
	if (i0 >= 24)
		goto label0;
	r2 = _JC_NEW(env, java_security_InvalidKeyException);
	r4 = _JC_STRING(env, "DES-EDE keys must be 24 bytes long");
	_JC_REF_FIELD(env, r2, java_lang_Throwable, cause) = r2;
	r6 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r2);
	_JC_REF_FIELD(env, r2, java_lang_Throwable, vmState) = r6;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, detailMessage) = r4;
	_JC_THROW(env, r2);

label0:
	r3 = _JC_NEW_PRIM_ARRAY(env, byte, 1, 24);
	_JC_REF_FIELD(env, r0, javax_crypto_spec_DESedeKeySpec, key) = r3;
	r3 = _JC_REF_FIELD(env, r0, javax_crypto_spec_DESedeKeySpec, key);
	_JC_ACTIVE_USE(env, java_lang_System);
	_JC_INVOKE_STATIC(env, java_lang_VMSystem, arraycopy$4286a72d57744cd8, 0, r1, 0, r3, 0, 24);
	_JC_LINE_NUMBER(81);				// 0
	return;
}

//
// public void <init>(byte[], int) throws java.security.InvalidKeyException
//

static _jc_linenum _jc_javax_crypto_spec_DESedeKeySpec$linenum_table$_init$6b9b44bc28d43597[];

static const unsigned char _jc_javax_crypto_spec_DESedeKeySpec$param_ptypes$_init$6b9b44bc28d43597[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_spec_DESedeKeySpec$exceptions$_init$6b9b44bc28d43597[] = {
	&_jc_java_security_InvalidKeyException$type
};

static _jc_type *const _jc_javax_crypto_spec_DESedeKeySpec$param_types$_init$6b9b44bc28d43597[] = {
	&_jc_byte$array$prim$type,
	&_jc_int$prim$type
};

_jc_method _jc_javax_crypto_spec_DESedeKeySpec$method_info$_init$6b9b44bc28d43597 = {
	.name=			"<init>",
	.signature=		"([BI)V",
	.class=			&_jc_javax_crypto_spec_DESedeKeySpec$type,
	.param_types=		&_jc_javax_crypto_spec_DESedeKeySpec$param_types$_init$6b9b44bc28d43597,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_spec_DESedeKeySpec$param_ptypes$_init$6b9b44bc28d43597,
	.signature_hash=	_JC_JLONG(0x6b9b44bc28d43597),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_javax_crypto_spec_DESedeKeySpec$method$_init$6b9b44bc28d43597,
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_crypto_spec_DESedeKeySpec$exceptions$_init$6b9b44bc28d43597,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_javax_crypto_spec_DESedeKeySpec$linenum_table$_init$6b9b44bc28d43597
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_spec_DESedeKeySpec, _init$6b9b44bc28d43597);

void _JC_JCNI_ATTR
_jc_javax_crypto_spec_DESedeKeySpec$method$_init$6b9b44bc28d43597(_jc_env *const env, _jc_javax_crypto_spec_DESedeKeySpec$object *this, _jc_byte_array *param0, jint param1)
{
	jint i0;
	jint i1;
	struct _jc_javax_crypto_spec_DESedeKeySpec$object *r0;
	_jc_byte_array *r1;
	struct _jc_java_security_InvalidKeyException$object *r2;
	_jc_byte_array *r3;
	struct _jc_java_lang_String$object *r4;
	struct _jc_java_lang_VMThrowable$object *r6;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	i0 = param1;
	_JC_LINE_NUMBER(95);				// 0
	i1 = _JC_ARRAY_LENGTH(env, r1);
	i1 = i1 - i0;
	if (i1 >= 24)
		goto label0;
	_JC_LINE_NUMBER(97);				// 1
	r2 = _JC_NEW(env, java_security_InvalidKeyException);
	r4 = _JC_STRING(env, "DES-EDE keys must be 24 bytes long");
	_JC_REF_FIELD(env, r2, java_lang_Throwable, cause) = r2;
	r6 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r2);
	_JC_REF_FIELD(env, r2, java_lang_Throwable, vmState) = r6;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, detailMessage) = r4;
	_JC_THROW(env, r2);

label0:
	_JC_LINE_NUMBER(99);				// 2
	r3 = _JC_NEW_PRIM_ARRAY(env, byte, 1, 24);
	_JC_REF_FIELD(env, r0, javax_crypto_spec_DESedeKeySpec, key) = r3;
	_JC_LINE_NUMBER(100);				// 3
	r3 = _JC_REF_FIELD(env, r0, javax_crypto_spec_DESedeKeySpec, key);
	_JC_ACTIVE_USE(env, java_lang_System);
	_JC_INVOKE_STATIC(env, java_lang_VMSystem, arraycopy$4286a72d57744cd8, 0, r1, i0, r3, 0, 24);
	_JC_LINE_NUMBER(101);				// 4
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public byte[] getKey()
//

static _jc_linenum _jc_javax_crypto_spec_DESedeKeySpec$linenum_table$getKey$6ddd922de8555435[];

static const unsigned char _jc_javax_crypto_spec_DESedeKeySpec$param_ptypes$getKey$6ddd922de8555435[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_javax_crypto_spec_DESedeKeySpec$method_info$getKey$6ddd922de8555435 = {
	.name=			"getKey",
	.signature=		"()[B",
	.class=			&_jc_javax_crypto_spec_DESedeKeySpec$type,
	.return_type=		&_jc_byte$array$prim$type,
	.param_ptypes=		&_jc_javax_crypto_spec_DESedeKeySpec$param_ptypes$getKey$6ddd922de8555435,
	.signature_hash=	_JC_JLONG(0x6ddd922de8555435),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_javax_crypto_spec_DESedeKeySpec$method$getKey$6ddd922de8555435,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_spec_DESedeKeySpec$vtable, javax_crypto_spec_DESedeKeySpec.getKey$6ddd922de8555435) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_crypto_spec_DESedeKeySpec$linenum_table$getKey$6ddd922de8555435
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_spec_DESedeKeySpec, getKey$6ddd922de8555435);

_jc_byte_array * _JC_JCNI_ATTR
_jc_javax_crypto_spec_DESedeKeySpec$method$getKey$6ddd922de8555435(_jc_env *const env, _jc_javax_crypto_spec_DESedeKeySpec$object *this)
{
	struct _jc_javax_crypto_spec_DESedeKeySpec$object *r0;
	_jc_byte_array *r1;

	r0 = this;
	_JC_LINE_NUMBER(149);				// 0
	r1 = _JC_REF_FIELD(env, r0, javax_crypto_spec_DESedeKeySpec, key);
	return r1;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_javax_crypto_spec_DESedeKeySpec$methods[] = {
	&_jc_javax_crypto_spec_DESedeKeySpec$method_info$_init$aaa7e255fe505158,
	&_jc_javax_crypto_spec_DESedeKeySpec$method_info$_init$6b9b44bc28d43597,
	&_jc_javax_crypto_spec_DESedeKeySpec$method_info$getKey$6ddd922de8555435,
	&_jc_javax_crypto_spec_DESedeKeySpec$method_info$isParityAdjusted$8495d84f2120000f
};

/************************************************************************
 *			  Class fields structure			*
 ************************************************************************/

_jc_javax_crypto_spec_DESedeKeySpec$fields_struct _jc_javax_crypto_spec_DESedeKeySpec$class_fields = { };

/************************************************************************
 *			      Interface list				*
 ************************************************************************/

// Directly implemented interfaces
static _jc_type *const _jc_javax_crypto_spec_DESedeKeySpec$interfaces[] = {
	&_jc_java_security_spec_KeySpec$type
};

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_javax_crypto_spec_DESedeKeySpec$instanceof_hash_bucket_4[] = {
	&_jc_javax_crypto_spec_DESedeKeySpec$type,
	_JC_NULL
};
static _jc_type *const _jc_javax_crypto_spec_DESedeKeySpec$instanceof_hash_bucket_26[] = {
	&_jc_java_security_spec_KeySpec$type,
	_JC_NULL
};
static _jc_type *const _jc_javax_crypto_spec_DESedeKeySpec$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_javax_crypto_spec_DESedeKeySpec$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[4]=	_jc_javax_crypto_spec_DESedeKeySpec$instanceof_hash_bucket_4,
	[26]=	_jc_javax_crypto_spec_DESedeKeySpec$instanceof_hash_bucket_26,
	[101]=	_jc_javax_crypto_spec_DESedeKeySpec$instanceof_hash_bucket_101
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_javax_crypto_spec_DESedeKeySpec$class_depends[] = {
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/System",	_JC_JLONG(0x53cc8e2333795f04) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMSystem",	_JC_JLONG(0x4d1cebae0bdda058) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/security/GeneralSecurityException",	_JC_JLONG(0x692089051f4c8d0b) },
	{ "java/security/InvalidKeyException",	_JC_JLONG(0x94dda41e9bf6c170) },
	{ "java/security/KeyException",	_JC_JLONG(0x965d036f0f33fac6) },
	{ "java/security/spec/KeySpec",	_JC_JLONG(0xe5bd533daf8dcb9a) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_javax_crypto_spec_DESedeKeySpec$vtype _jc_javax_crypto_spec_DESedeKeySpec$type = {
    .type= {
	.name=			"javax/crypto/spec/DESedeKeySpec",
	.superclass=		&_jc_java_lang_Object$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.num_interfaces=sizeof(_jc_javax_crypto_spec_DESedeKeySpec$interfaces) / sizeof(*_jc_javax_crypto_spec_DESedeKeySpec$interfaces),
	.interfaces=		_jc_javax_crypto_spec_DESedeKeySpec$interfaces,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		12,
		.hash=			_JC_JLONG(0x7825ceeafd22c984),
		.source_file=		"DESedeKeySpec.java",
		.instance_size=		sizeof(_jc_javax_crypto_spec_DESedeKeySpec$refs) + sizeof(_jc_javax_crypto_spec_DESedeKeySpec$object),
		.num_virtual_refs=	1,
		.num_fields=		sizeof(_jc_javax_crypto_spec_DESedeKeySpec$fields) / sizeof(*_jc_javax_crypto_spec_DESedeKeySpec$fields),
		.fields=		_jc_javax_crypto_spec_DESedeKeySpec$fields,
		.num_methods=		sizeof(_jc_javax_crypto_spec_DESedeKeySpec$methods) / sizeof(*_jc_javax_crypto_spec_DESedeKeySpec$methods),
		.methods=		_jc_javax_crypto_spec_DESedeKeySpec$methods,
		.instanceof_hash_table=	_jc_javax_crypto_spec_DESedeKeySpec$instanceof_hash_table,
		.class_fields=		&_jc_javax_crypto_spec_DESedeKeySpec$class_fields,
		.num_class_depends=		sizeof(_jc_javax_crypto_spec_DESedeKeySpec$class_depends) / sizeof(*_jc_javax_crypto_spec_DESedeKeySpec$class_depends),
		.class_depends=		_jc_javax_crypto_spec_DESedeKeySpec$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.javax_crypto_spec_DESedeKeySpec= {
	    .getKey$6ddd922de8555435=
		&_jc_javax_crypto_spec_DESedeKeySpec$method$getKey$6ddd922de8555435,
	},
    }
};

