// public class javax.crypto.spec.RC5ParameterSpec

// class file dependencies
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class 680cf34d05feb5a1 java_lang_IllegalArgumentException
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class 4f5534a987354d1d java_lang_RuntimeException
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 53cc8e2333795f04 java_lang_System
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class 4d1cebae0bdda058 java_lang_VMSystem
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class ef2e5e8af121478f java_security_spec_AlgorithmParameterSpec
// @dep_class 595c0bf23b2acb5e javax_crypto_spec_RC5ParameterSpec

// header file dependencies
// @dep_header java_lang_Class
// @dep_header java_lang_IllegalArgumentException
// @dep_header java_lang_String
// @dep_header java_lang_System
// @dep_header java_lang_VMSystem
// @dep_header java_lang_VMThrowable
// @dep_header java_security_spec_AlgorithmParameterSpec
// @dep_header javax_crypto_spec_RC5ParameterSpec

#include "jc_defs.h"

#include "java/lang/Class.h"
#include "java/lang/IllegalArgumentException.h"
#include "java/lang/String.h"
#include "java/lang/System.h"
#include "java/lang/VMSystem.h"
#include "java/lang/VMThrowable.h"
#include "java/security/spec/AlgorithmParameterSpec.h"
#include "javax/crypto/spec/RC5ParameterSpec.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// private byte[] iv
static _jc_field _jc_javax_crypto_spec_RC5ParameterSpec$field_info$iv = {
	.name=		"iv",
	.signature=	"[B",
	.class=		&_jc_javax_crypto_spec_RC5ParameterSpec$type,
	.type=		&_jc_byte$array$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_spec_RC5ParameterSpec$object, refs[-1].javax_crypto_spec_RC5ParameterSpec.iv),
};

// private int rounds
static _jc_field _jc_javax_crypto_spec_RC5ParameterSpec$field_info$rounds = {
	.name=		"rounds",
	.signature=	"I",
	.class=		&_jc_javax_crypto_spec_RC5ParameterSpec$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_spec_RC5ParameterSpec$object, nonrefs.javax_crypto_spec_RC5ParameterSpec.rounds),
};

// private int version
static _jc_field _jc_javax_crypto_spec_RC5ParameterSpec$field_info$version = {
	.name=		"version",
	.signature=	"I",
	.class=		&_jc_javax_crypto_spec_RC5ParameterSpec$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_spec_RC5ParameterSpec$object, nonrefs.javax_crypto_spec_RC5ParameterSpec.version),
};

// private int wordSize
static _jc_field _jc_javax_crypto_spec_RC5ParameterSpec$field_info$wordSize = {
	.name=		"wordSize",
	.signature=	"I",
	.class=		&_jc_javax_crypto_spec_RC5ParameterSpec$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_spec_RC5ParameterSpec$object, nonrefs.javax_crypto_spec_RC5ParameterSpec.wordSize),
};

// Fields
static _jc_field *const _jc_javax_crypto_spec_RC5ParameterSpec$fields[] = {
	&_jc_javax_crypto_spec_RC5ParameterSpec$field_info$iv,
	&_jc_javax_crypto_spec_RC5ParameterSpec$field_info$rounds,
	&_jc_javax_crypto_spec_RC5ParameterSpec$field_info$version,
	&_jc_javax_crypto_spec_RC5ParameterSpec$field_info$wordSize
};

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// public void <init>(int, int, int)
//

static _jc_linenum _jc_javax_crypto_spec_RC5ParameterSpec$linenum_table$_init$bfb53a4355ec1401[];

static const unsigned char _jc_javax_crypto_spec_RC5ParameterSpec$param_ptypes$_init$bfb53a4355ec1401[] = { 
_JC_TYPE_INT, _JC_TYPE_INT, _JC_TYPE_INT, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_spec_RC5ParameterSpec$param_types$_init$bfb53a4355ec1401[] = {
	&_jc_int$prim$type,
	&_jc_int$prim$type,
	&_jc_int$prim$type
};

_jc_method _jc_javax_crypto_spec_RC5ParameterSpec$method_info$_init$bfb53a4355ec1401 = {
	.name=			"<init>",
	.signature=		"(III)V",
	.class=			&_jc_javax_crypto_spec_RC5ParameterSpec$type,
	.param_types=		&_jc_javax_crypto_spec_RC5ParameterSpec$param_types$_init$bfb53a4355ec1401,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_spec_RC5ParameterSpec$param_ptypes$_init$bfb53a4355ec1401,
	.signature_hash=	_JC_JLONG(0xbfb53a4355ec1401),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_javax_crypto_spec_RC5ParameterSpec$method$_init$bfb53a4355ec1401,
	.num_parameters=	3,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_javax_crypto_spec_RC5ParameterSpec$linenum_table$_init$bfb53a4355ec1401
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_spec_RC5ParameterSpec, _init$bfb53a4355ec1401);

void _JC_JCNI_ATTR
_jc_javax_crypto_spec_RC5ParameterSpec$method$_init$bfb53a4355ec1401(_jc_env *const env, _jc_javax_crypto_spec_RC5ParameterSpec$object *this, jint param0, jint param1, jint param2)
{
	jint i0;
	jint i1;
	jint i2;
	struct _jc_javax_crypto_spec_RC5ParameterSpec$object *r0;

	r0 = this;
	i0 = param0;
	i1 = param1;
	i2 = param2;
	_JC_LINE_NUMBER(81);				// 0
	_JC_PRIM_FIELD(env, r0, javax_crypto_spec_RC5ParameterSpec, version) = i0;
	_JC_LINE_NUMBER(82);				// 1
	_JC_PRIM_FIELD(env, r0, javax_crypto_spec_RC5ParameterSpec, rounds) = i1;
	_JC_LINE_NUMBER(83);				// 2
	_JC_PRIM_FIELD(env, r0, javax_crypto_spec_RC5ParameterSpec, wordSize) = i2;
	_JC_LINE_NUMBER(84);				// 3
	return;
}

//
// public void <init>(int, int, int, byte[])
//

static _jc_linenum _jc_javax_crypto_spec_RC5ParameterSpec$linenum_table$_init$72d839214131c6e4[];

static const unsigned char _jc_javax_crypto_spec_RC5ParameterSpec$param_ptypes$_init$72d839214131c6e4[] = { 
_JC_TYPE_INT, _JC_TYPE_INT, _JC_TYPE_INT, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_spec_RC5ParameterSpec$param_types$_init$72d839214131c6e4[] = {
	&_jc_int$prim$type,
	&_jc_int$prim$type,
	&_jc_int$prim$type,
	&_jc_byte$array$prim$type
};

_jc_method _jc_javax_crypto_spec_RC5ParameterSpec$method_info$_init$72d839214131c6e4 = {
	.name=			"<init>",
	.signature=		"(III[B)V",
	.class=			&_jc_javax_crypto_spec_RC5ParameterSpec$type,
	.param_types=		&_jc_javax_crypto_spec_RC5ParameterSpec$param_types$_init$72d839214131c6e4,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_spec_RC5ParameterSpec$param_ptypes$_init$72d839214131c6e4,
	.signature_hash=	_JC_JLONG(0x72d839214131c6e4),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_javax_crypto_spec_RC5ParameterSpec$method$_init$72d839214131c6e4,
	.num_parameters=	4,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_javax_crypto_spec_RC5ParameterSpec$linenum_table$_init$72d839214131c6e4
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_spec_RC5ParameterSpec, _init$72d839214131c6e4);

void _JC_JCNI_ATTR
_jc_javax_crypto_spec_RC5ParameterSpec$method$_init$72d839214131c6e4(_jc_env *const env, _jc_javax_crypto_spec_RC5ParameterSpec$object *this, jint param0, jint param1, jint param2, _jc_byte_array *param3)
{
	jint i0;
	jint i1;
	jint i2;
	struct _jc_javax_crypto_spec_RC5ParameterSpec$object *r0;
	_jc_byte_array *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	i0 = param0;
	i1 = param1;
	i2 = param2;
	r1 = param3;
	_JC_LINE_NUMBER(97);				// 0
	_JC_INVOKE_NONVIRTUAL(env, javax_crypto_spec_RC5ParameterSpec, _init$6b91d988b6c4f745, 0, r0, i0, i1, i2, r1, 0);
	_JC_LINE_NUMBER(98);				// 1
	return;
}

//
// public void <init>(int, int, int, byte[], int)
//

static _jc_linenum _jc_javax_crypto_spec_RC5ParameterSpec$linenum_table$_init$6b91d988b6c4f745[];

static const unsigned char _jc_javax_crypto_spec_RC5ParameterSpec$param_ptypes$_init$6b91d988b6c4f745[] = { 
_JC_TYPE_INT, _JC_TYPE_INT, _JC_TYPE_INT, _JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_spec_RC5ParameterSpec$param_types$_init$6b91d988b6c4f745[] = {
	&_jc_int$prim$type,
	&_jc_int$prim$type,
	&_jc_int$prim$type,
	&_jc_byte$array$prim$type,
	&_jc_int$prim$type
};

_jc_method _jc_javax_crypto_spec_RC5ParameterSpec$method_info$_init$6b91d988b6c4f745 = {
	.name=			"<init>",
	.signature=		"(III[BI)V",
	.class=			&_jc_javax_crypto_spec_RC5ParameterSpec$type,
	.param_types=		&_jc_javax_crypto_spec_RC5ParameterSpec$param_types$_init$6b91d988b6c4f745,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_spec_RC5ParameterSpec$param_ptypes$_init$6b91d988b6c4f745,
	.signature_hash=	_JC_JLONG(0x6b91d988b6c4f745),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_javax_crypto_spec_RC5ParameterSpec$method$_init$6b91d988b6c4f745,
	.num_parameters=	5,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	8,
	      .table=	_jc_javax_crypto_spec_RC5ParameterSpec$linenum_table$_init$6b91d988b6c4f745
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_spec_RC5ParameterSpec, _init$6b91d988b6c4f745);

void _JC_JCNI_ATTR
_jc_javax_crypto_spec_RC5ParameterSpec$method$_init$6b91d988b6c4f745(_jc_env *const env, _jc_javax_crypto_spec_RC5ParameterSpec$object *this, jint param0, jint param1, jint param2, _jc_byte_array *param3, jint param4)
{
	jint i0;
	jint i1;
	jint i2;
	jint i3;
	struct _jc_javax_crypto_spec_RC5ParameterSpec$object *r0;
	_jc_byte_array *r1;
	struct _jc_java_lang_IllegalArgumentException$object *r2;
	_jc_byte_array *r3;
	struct _jc_java_lang_String$object *r4;
	struct _jc_java_lang_String$object *r5;
	struct _jc_java_lang_VMThrowable$object *r6;
	struct _jc_java_lang_VMThrowable$object *r8;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	i0 = param0;
	i1 = param1;
	i2 = param2;
	r1 = param3;
	i3 = param4;
	_JC_PRIM_FIELD(env, r0, javax_crypto_spec_RC5ParameterSpec, version) = i0;
	_JC_PRIM_FIELD(env, r0, javax_crypto_spec_RC5ParameterSpec, rounds) = i1;
	_JC_PRIM_FIELD(env, r0, javax_crypto_spec_RC5ParameterSpec, wordSize) = i2;
	_JC_LINE_NUMBER(114);				// 0
	i2 = i2 / 8;
	i2 = 2 * i2;
	_JC_LINE_NUMBER(115);				// 1
	if (i3 >= 0)
		goto label0;
	_JC_LINE_NUMBER(116);				// 2
	r2 = _JC_NEW(env, java_lang_IllegalArgumentException);
	r5 = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, cause) = r2;
	r6 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r2);
	_JC_REF_FIELD(env, r2, java_lang_Throwable, vmState) = r6;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, detailMessage) = r5;
	_JC_THROW(env, r2);

label0:
	_JC_LINE_NUMBER(117);				// 3
	i1 = _JC_ARRAY_LENGTH(env, r1);
	i1 = i1 - i3;
	if (i1 >= i2)
		goto label1;
	_JC_LINE_NUMBER(119);				// 4
	r2 = _JC_NEW(env, java_lang_IllegalArgumentException);
	r4 = _JC_STRING(env, "IV too short");
	_JC_REF_FIELD(env, r2, java_lang_Throwable, cause) = r2;
	r8 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r2);
	_JC_REF_FIELD(env, r2, java_lang_Throwable, vmState) = r8;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, detailMessage) = r4;
	_JC_THROW(env, r2);

label1:
	_JC_LINE_NUMBER(121);				// 5
	r3 = _JC_NEW_PRIM_ARRAY(env, byte, 1, i2);
	_JC_REF_FIELD(env, r0, javax_crypto_spec_RC5ParameterSpec, iv) = r3;
	_JC_LINE_NUMBER(122);				// 6
	r3 = _JC_REF_FIELD(env, r0, javax_crypto_spec_RC5ParameterSpec, iv);
	_JC_ACTIVE_USE(env, java_lang_System);
	_JC_INVOKE_STATIC(env, java_lang_VMSystem, arraycopy$4286a72d57744cd8, 0, r1, i3, r3, 0, i2);
	_JC_LINE_NUMBER(123);				// 7
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public boolean equals(java.lang.Object)
//

static _jc_linenum _jc_javax_crypto_spec_RC5ParameterSpec$linenum_table$equals$8a15e0625571c581[];

static const unsigned char _jc_javax_crypto_spec_RC5ParameterSpec$param_ptypes$equals$8a15e0625571c581[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_javax_crypto_spec_RC5ParameterSpec$param_types$equals$8a15e0625571c581[] = {
	&_jc_java_lang_Object$type
};

_jc_method _jc_javax_crypto_spec_RC5ParameterSpec$method_info$equals$8a15e0625571c581 = {
	.name=			"equals",
	.signature=		"(Ljava/lang/Object;)Z",
	.class=			&_jc_javax_crypto_spec_RC5ParameterSpec$type,
	.param_types=		&_jc_javax_crypto_spec_RC5ParameterSpec$param_types$equals$8a15e0625571c581,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_javax_crypto_spec_RC5ParameterSpec$param_ptypes$equals$8a15e0625571c581,
	.signature_hash=	_JC_JLONG(0x8a15e0625571c581),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_javax_crypto_spec_RC5ParameterSpec$method$equals$8a15e0625571c581,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_spec_RC5ParameterSpec$vtable, javax_crypto_spec_RC5ParameterSpec.equals$8a15e0625571c581) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	10,
	      .table=	_jc_javax_crypto_spec_RC5ParameterSpec$linenum_table$equals$8a15e0625571c581
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_spec_RC5ParameterSpec, equals$8a15e0625571c581);

jboolean _JC_JCNI_ATTR
_jc_javax_crypto_spec_RC5ParameterSpec$method$equals$8a15e0625571c581(_jc_env *const env, _jc_javax_crypto_spec_RC5ParameterSpec$object *this, _jc_java_lang_Object$object *param0)
{
	jbyte b3;
	jbyte b4;
	jint i0;
	jint i2;
	struct _jc_javax_crypto_spec_RC5ParameterSpec$object *r0;
	struct _jc_java_lang_Object$object *r1;
	_jc_byte_array *r2;
	struct _jc_javax_crypto_spec_RC5ParameterSpec$object *r3;
	_jc_byte_array *r4;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(171);				// 0
	if (r0 != r1)
		goto label0;
	return 1;

label0:
	_JC_LINE_NUMBER(172);				// 1
	r3 = _JC_CAST(env, &_jc_javax_crypto_spec_RC5ParameterSpec$type, r1);
	r2 = _JC_INVOKE_VIRTUAL(env, javax_crypto_spec_RC5ParameterSpec, getIV$4134a0c13b73072e, r3);
	_JC_LINE_NUMBER(173);				// 2
	r4 = _JC_REF_FIELD(env, r0, javax_crypto_spec_RC5ParameterSpec, iv);
	if (r4 == r2)
		goto label7;
	_JC_LINE_NUMBER(175);				// 3
	r4 = _JC_REF_FIELD(env, r0, javax_crypto_spec_RC5ParameterSpec, iv);
	if (r4 == _JC_NULL)
		goto label1;
	if (r2 != _JC_NULL)
		goto label2;

label1:
	return 0;

label2:
	_JC_LINE_NUMBER(176);				// 4
	r4 = _JC_REF_FIELD(env, r0, javax_crypto_spec_RC5ParameterSpec, iv);
	i0 = _JC_ARRAY_LENGTH(env, r4);
	i2 = _JC_ARRAY_LENGTH(env, r2);
	if (i0 == i2)
		goto label3;
	return 0;

label3:
	_JC_LINE_NUMBER(177);				// 5
	i0 = 0;
	goto label6;

label4:
	_JC_LINE_NUMBER(179);				// 6
	r4 = _JC_REF_FIELD(env, r0, javax_crypto_spec_RC5ParameterSpec, iv);
	b3 = _JC_PRIM_ELEMENT(env, byte, r4, i0, 0, 1);
	b4 = _JC_PRIM_ELEMENT(env, byte, r2, i0, 0, 1);
	if (b3 == b4)
		goto label5;
	_JC_LINE_NUMBER(181);				// 7
	return 0;

label5:
	_JC_LINE_NUMBER(177);				// 8
	i0 = i0 + 1;

label6:
	r4 = _JC_REF_FIELD(env, r0, javax_crypto_spec_RC5ParameterSpec, iv);
	i2 = _JC_ARRAY_LENGTH(env, r4);
	if (i0 < i2) {
		_JC_PERIODIC_CHECK(env);
		goto label4;
	}

label7:
	_JC_LINE_NUMBER(185);				// 9
	z0 = 0;
	i2 = _JC_PRIM_FIELD(env, r0, javax_crypto_spec_RC5ParameterSpec, rounds);
	r3 = r1;
	i0 = _JC_INVOKE_VIRTUAL(env, javax_crypto_spec_RC5ParameterSpec, getRounds$3ed9ef928a21204e, r3);
	if (i2 != i0)
		goto label8;
	i2 = _JC_PRIM_FIELD(env, r0, javax_crypto_spec_RC5ParameterSpec, version);
	r3 = r1;
	i0 = _JC_INVOKE_VIRTUAL(env, javax_crypto_spec_RC5ParameterSpec, getVersion$b5e412566904b7c3, r3);
	if (i2 != i0)
		goto label8;
	i2 = _JC_PRIM_FIELD(env, r0, javax_crypto_spec_RC5ParameterSpec, wordSize);
	r3 = r1;
	i0 = _JC_INVOKE_VIRTUAL(env, javax_crypto_spec_RC5ParameterSpec, getWordSize$0d98f34fe9b5820d, r3);
	if (i2 != i0)
		goto label8;
	z0 = 1;

label8:
	return z0;
}

//
// public byte[] getIV()
//

static _jc_linenum _jc_javax_crypto_spec_RC5ParameterSpec$linenum_table$getIV$4134a0c13b73072e[];

static const unsigned char _jc_javax_crypto_spec_RC5ParameterSpec$param_ptypes$getIV$4134a0c13b73072e[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_javax_crypto_spec_RC5ParameterSpec$method_info$getIV$4134a0c13b73072e = {
	.name=			"getIV",
	.signature=		"()[B",
	.class=			&_jc_javax_crypto_spec_RC5ParameterSpec$type,
	.return_type=		&_jc_byte$array$prim$type,
	.param_ptypes=		&_jc_javax_crypto_spec_RC5ParameterSpec$param_ptypes$getIV$4134a0c13b73072e,
	.signature_hash=	_JC_JLONG(0x4134a0c13b73072e),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_javax_crypto_spec_RC5ParameterSpec$method$getIV$4134a0c13b73072e,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_spec_RC5ParameterSpec$vtable, javax_crypto_spec_RC5ParameterSpec.getIV$4134a0c13b73072e) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_crypto_spec_RC5ParameterSpec$linenum_table$getIV$4134a0c13b73072e
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_spec_RC5ParameterSpec, getIV$4134a0c13b73072e);

_jc_byte_array * _JC_JCNI_ATTR
_jc_javax_crypto_spec_RC5ParameterSpec$method$getIV$4134a0c13b73072e(_jc_env *const env, _jc_javax_crypto_spec_RC5ParameterSpec$object *this)
{
	struct _jc_javax_crypto_spec_RC5ParameterSpec$object *r0;
	_jc_byte_array *r1;

	r0 = this;
	_JC_LINE_NUMBER(136);				// 0
	r1 = _JC_REF_FIELD(env, r0, javax_crypto_spec_RC5ParameterSpec, iv);
	return r1;
}

//
// public int getRounds()
//

static _jc_linenum _jc_javax_crypto_spec_RC5ParameterSpec$linenum_table$getRounds$3ed9ef928a21204e[];

static const unsigned char _jc_javax_crypto_spec_RC5ParameterSpec$param_ptypes$getRounds$3ed9ef928a21204e[] = { 
_JC_TYPE_INT };

_jc_method _jc_javax_crypto_spec_RC5ParameterSpec$method_info$getRounds$3ed9ef928a21204e = {
	.name=			"getRounds",
	.signature=		"()I",
	.class=			&_jc_javax_crypto_spec_RC5ParameterSpec$type,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_javax_crypto_spec_RC5ParameterSpec$param_ptypes$getRounds$3ed9ef928a21204e,
	.signature_hash=	_JC_JLONG(0x3ed9ef928a21204e),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_javax_crypto_spec_RC5ParameterSpec$method$getRounds$3ed9ef928a21204e,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_spec_RC5ParameterSpec$vtable, javax_crypto_spec_RC5ParameterSpec.getRounds$3ed9ef928a21204e) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_crypto_spec_RC5ParameterSpec$linenum_table$getRounds$3ed9ef928a21204e
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_spec_RC5ParameterSpec, getRounds$3ed9ef928a21204e);

jint _JC_JCNI_ATTR
_jc_javax_crypto_spec_RC5ParameterSpec$method$getRounds$3ed9ef928a21204e(_jc_env *const env, _jc_javax_crypto_spec_RC5ParameterSpec$object *this)
{
	jint i0;
	struct _jc_javax_crypto_spec_RC5ParameterSpec$object *r0;

	r0 = this;
	_JC_LINE_NUMBER(146);				// 0
	i0 = _JC_PRIM_FIELD(env, r0, javax_crypto_spec_RC5ParameterSpec, rounds);
	return i0;
}

//
// public int getVersion()
//

static _jc_linenum _jc_javax_crypto_spec_RC5ParameterSpec$linenum_table$getVersion$b5e412566904b7c3[];

static const unsigned char _jc_javax_crypto_spec_RC5ParameterSpec$param_ptypes$getVersion$b5e412566904b7c3[] = { 
_JC_TYPE_INT };

_jc_method _jc_javax_crypto_spec_RC5ParameterSpec$method_info$getVersion$b5e412566904b7c3 = {
	.name=			"getVersion",
	.signature=		"()I",
	.class=			&_jc_javax_crypto_spec_RC5ParameterSpec$type,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_javax_crypto_spec_RC5ParameterSpec$param_ptypes$getVersion$b5e412566904b7c3,
	.signature_hash=	_JC_JLONG(0xb5e412566904b7c3),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_javax_crypto_spec_RC5ParameterSpec$method$getVersion$b5e412566904b7c3,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_spec_RC5ParameterSpec$vtable, javax_crypto_spec_RC5ParameterSpec.getVersion$b5e412566904b7c3) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_crypto_spec_RC5ParameterSpec$linenum_table$getVersion$b5e412566904b7c3
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_spec_RC5ParameterSpec, getVersion$b5e412566904b7c3);

jint _JC_JCNI_ATTR
_jc_javax_crypto_spec_RC5ParameterSpec$method$getVersion$b5e412566904b7c3(_jc_env *const env, _jc_javax_crypto_spec_RC5ParameterSpec$object *this)
{
	jint i0;
	struct _jc_javax_crypto_spec_RC5ParameterSpec$object *r0;

	r0 = this;
	_JC_LINE_NUMBER(156);				// 0
	i0 = _JC_PRIM_FIELD(env, r0, javax_crypto_spec_RC5ParameterSpec, version);
	return i0;
}

//
// public int getWordSize()
//

static _jc_linenum _jc_javax_crypto_spec_RC5ParameterSpec$linenum_table$getWordSize$0d98f34fe9b5820d[];

static const unsigned char _jc_javax_crypto_spec_RC5ParameterSpec$param_ptypes$getWordSize$0d98f34fe9b5820d[] = { 
_JC_TYPE_INT };

_jc_method _jc_javax_crypto_spec_RC5ParameterSpec$method_info$getWordSize$0d98f34fe9b5820d = {
	.name=			"getWordSize",
	.signature=		"()I",
	.class=			&_jc_javax_crypto_spec_RC5ParameterSpec$type,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_javax_crypto_spec_RC5ParameterSpec$param_ptypes$getWordSize$0d98f34fe9b5820d,
	.signature_hash=	_JC_JLONG(0xd98f34fe9b5820d),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_javax_crypto_spec_RC5ParameterSpec$method$getWordSize$0d98f34fe9b5820d,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_spec_RC5ParameterSpec$vtable, javax_crypto_spec_RC5ParameterSpec.getWordSize$0d98f34fe9b5820d) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_crypto_spec_RC5ParameterSpec$linenum_table$getWordSize$0d98f34fe9b5820d
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_spec_RC5ParameterSpec, getWordSize$0d98f34fe9b5820d);

jint _JC_JCNI_ATTR
_jc_javax_crypto_spec_RC5ParameterSpec$method$getWordSize$0d98f34fe9b5820d(_jc_env *const env, _jc_javax_crypto_spec_RC5ParameterSpec$object *this)
{
	jint i0;
	struct _jc_javax_crypto_spec_RC5ParameterSpec$object *r0;

	r0 = this;
	_JC_LINE_NUMBER(166);				// 0
	i0 = _JC_PRIM_FIELD(env, r0, javax_crypto_spec_RC5ParameterSpec, wordSize);
	return i0;
}

//
// public int hashCode()
//

static _jc_linenum _jc_javax_crypto_spec_RC5ParameterSpec$linenum_table$hashCode$53152098849316df[];

static const unsigned char _jc_javax_crypto_spec_RC5ParameterSpec$param_ptypes$hashCode$53152098849316df[] = { 
_JC_TYPE_INT };

_jc_method _jc_javax_crypto_spec_RC5ParameterSpec$method_info$hashCode$53152098849316df = {
	.name=			"hashCode",
	.signature=		"()I",
	.class=			&_jc_javax_crypto_spec_RC5ParameterSpec$type,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_javax_crypto_spec_RC5ParameterSpec$param_ptypes$hashCode$53152098849316df,
	.signature_hash=	_JC_JLONG(0x53152098849316df),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_javax_crypto_spec_RC5ParameterSpec$method$hashCode$53152098849316df,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_spec_RC5ParameterSpec$vtable, javax_crypto_spec_RC5ParameterSpec.hashCode$53152098849316df) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	6,
	      .table=	_jc_javax_crypto_spec_RC5ParameterSpec$linenum_table$hashCode$53152098849316df
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_spec_RC5ParameterSpec, hashCode$53152098849316df);

jint _JC_JCNI_ATTR
_jc_javax_crypto_spec_RC5ParameterSpec$method$hashCode$53152098849316df(_jc_env *const env, _jc_javax_crypto_spec_RC5ParameterSpec$object *this)
{
	jbyte b6;
	jint i0;
	jint i1;
	jint i7;
	struct _jc_javax_crypto_spec_RC5ParameterSpec$object *r0;
	_jc_byte_array *r1;

	r0 = this;
	_JC_LINE_NUMBER(192);				// 0
	i1 = _JC_PRIM_FIELD(env, r0, javax_crypto_spec_RC5ParameterSpec, rounds);
	i0 = _JC_PRIM_FIELD(env, r0, javax_crypto_spec_RC5ParameterSpec, version);
	i1 = i1 + i0;
	i0 = _JC_PRIM_FIELD(env, r0, javax_crypto_spec_RC5ParameterSpec, wordSize);
	i0 = i1 + i0;
	_JC_LINE_NUMBER(193);				// 1
	r1 = _JC_REF_FIELD(env, r0, javax_crypto_spec_RC5ParameterSpec, iv);
	if (r1 == _JC_NULL)
		goto label2;
	_JC_LINE_NUMBER(195);				// 2
	i1 = 0;
	goto label1;

label0:
	_JC_LINE_NUMBER(197);				// 3
	r1 = _JC_REF_FIELD(env, r0, javax_crypto_spec_RC5ParameterSpec, iv);
	b6 = _JC_PRIM_ELEMENT(env, byte, r1, i1, 0, 1);
	i0 = i0 + b6;
	_JC_LINE_NUMBER(195);				// 4
	i1 = i1 + 1;

label1:
	r1 = _JC_REF_FIELD(env, r0, javax_crypto_spec_RC5ParameterSpec, iv);
	i7 = _JC_ARRAY_LENGTH(env, r1);
	if (i1 < i7) {
		_JC_PERIODIC_CHECK(env);
		goto label0;
	}

label2:
	_JC_LINE_NUMBER(200);				// 5
	return i0;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_javax_crypto_spec_RC5ParameterSpec$methods[] = {
	&_jc_javax_crypto_spec_RC5ParameterSpec$method_info$_init$bfb53a4355ec1401,
	&_jc_javax_crypto_spec_RC5ParameterSpec$method_info$_init$72d839214131c6e4,
	&_jc_javax_crypto_spec_RC5ParameterSpec$method_info$_init$6b91d988b6c4f745,
	&_jc_javax_crypto_spec_RC5ParameterSpec$method_info$equals$8a15e0625571c581,
	&_jc_javax_crypto_spec_RC5ParameterSpec$method_info$getIV$4134a0c13b73072e,
	&_jc_javax_crypto_spec_RC5ParameterSpec$method_info$getRounds$3ed9ef928a21204e,
	&_jc_javax_crypto_spec_RC5ParameterSpec$method_info$getVersion$b5e412566904b7c3,
	&_jc_javax_crypto_spec_RC5ParameterSpec$method_info$getWordSize$0d98f34fe9b5820d,
	&_jc_javax_crypto_spec_RC5ParameterSpec$method_info$hashCode$53152098849316df
};

/************************************************************************
 *			      Interface list				*
 ************************************************************************/

// Directly implemented interfaces
static _jc_type *const _jc_javax_crypto_spec_RC5ParameterSpec$interfaces[] = {
	&_jc_java_security_spec_AlgorithmParameterSpec$type
};

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_javax_crypto_spec_RC5ParameterSpec$instanceof_hash_bucket_15[] = {
	&_jc_java_security_spec_AlgorithmParameterSpec$type,
	_JC_NULL
};
static _jc_type *const _jc_javax_crypto_spec_RC5ParameterSpec$instanceof_hash_bucket_94[] = {
	&_jc_javax_crypto_spec_RC5ParameterSpec$type,
	_JC_NULL
};
static _jc_type *const _jc_javax_crypto_spec_RC5ParameterSpec$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_javax_crypto_spec_RC5ParameterSpec$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[15]=	_jc_javax_crypto_spec_RC5ParameterSpec$instanceof_hash_bucket_15,
	[94]=	_jc_javax_crypto_spec_RC5ParameterSpec$instanceof_hash_bucket_94,
	[101]=	_jc_javax_crypto_spec_RC5ParameterSpec$instanceof_hash_bucket_101
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_javax_crypto_spec_RC5ParameterSpec$class_depends[] = {
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/IllegalArgumentException",	_JC_JLONG(0x680cf34d05feb5a1) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/RuntimeException",	_JC_JLONG(0x4f5534a987354d1d) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/System",	_JC_JLONG(0x53cc8e2333795f04) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMSystem",	_JC_JLONG(0x4d1cebae0bdda058) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/security/spec/AlgorithmParameterSpec",	_JC_JLONG(0xef2e5e8af121478f) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_javax_crypto_spec_RC5ParameterSpec$vtype _jc_javax_crypto_spec_RC5ParameterSpec$type = {
    .type= {
	.name=			"javax/crypto/spec/RC5ParameterSpec",
	.superclass=		&_jc_java_lang_Object$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.num_interfaces=sizeof(_jc_javax_crypto_spec_RC5ParameterSpec$interfaces) / sizeof(*_jc_javax_crypto_spec_RC5ParameterSpec$interfaces),
	.interfaces=		_jc_javax_crypto_spec_RC5ParameterSpec$interfaces,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		17,
		.hash=			_JC_JLONG(0x595c0bf23b2acb5e),
		.source_file=		"RC5ParameterSpec.java",
		.instance_size=		sizeof(_jc_javax_crypto_spec_RC5ParameterSpec$refs) + sizeof(_jc_javax_crypto_spec_RC5ParameterSpec$object),
		.num_virtual_refs=	1,
		.num_fields=		sizeof(_jc_javax_crypto_spec_RC5ParameterSpec$fields) / sizeof(*_jc_javax_crypto_spec_RC5ParameterSpec$fields),
		.fields=		_jc_javax_crypto_spec_RC5ParameterSpec$fields,
		.num_methods=		sizeof(_jc_javax_crypto_spec_RC5ParameterSpec$methods) / sizeof(*_jc_javax_crypto_spec_RC5ParameterSpec$methods),
		.methods=		_jc_javax_crypto_spec_RC5ParameterSpec$methods,
		.instanceof_hash_table=	_jc_javax_crypto_spec_RC5ParameterSpec$instanceof_hash_table,
		.num_class_depends=		sizeof(_jc_javax_crypto_spec_RC5ParameterSpec$class_depends) / sizeof(*_jc_javax_crypto_spec_RC5ParameterSpec$class_depends),
		.class_depends=		_jc_javax_crypto_spec_RC5ParameterSpec$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=			// overridden
		&_jc_javax_crypto_spec_RC5ParameterSpec$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=			// overridden
		&_jc_javax_crypto_spec_RC5ParameterSpec$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.javax_crypto_spec_RC5ParameterSpec= {
	    .equals$8a15e0625571c581=
		&_jc_javax_crypto_spec_RC5ParameterSpec$method$equals$8a15e0625571c581,
	    .getIV$4134a0c13b73072e=
		&_jc_javax_crypto_spec_RC5ParameterSpec$method$getIV$4134a0c13b73072e,
	    .getRounds$3ed9ef928a21204e=
		&_jc_javax_crypto_spec_RC5ParameterSpec$method$getRounds$3ed9ef928a21204e,
	    .getVersion$b5e412566904b7c3=
		&_jc_javax_crypto_spec_RC5ParameterSpec$method$getVersion$b5e412566904b7c3,
	    .getWordSize$0d98f34fe9b5820d=
		&_jc_javax_crypto_spec_RC5ParameterSpec$method$getWordSize$0d98f34fe9b5820d,
	    .hashCode$53152098849316df=
		&_jc_javax_crypto_spec_RC5ParameterSpec$method$hashCode$53152098849316df,
	},
    }
};

