// public abstract class javax.net.ssl.KeyManagerFactorySpi

// class file dependencies
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 327edce29f2562dd java_security_InvalidAlgorithmParameterException
// @dep_class 1f56d8b14978c9d6 java_security_KeyStore
// @dep_class 45b488528f32667c java_security_KeyStoreException
// @dep_class 22e937c2536160b4 java_security_NoSuchAlgorithmException
// @dep_class 398237d93436ff7e java_security_UnrecoverableKeyException
// @dep_class ae254aeec477c06d javax_net_ssl_KeyManager
// @dep_class 6b3456faafb71978 javax_net_ssl_KeyManagerFactorySpi
// @dep_class 59c25edc381e2cbe javax_net_ssl_ManagerFactoryParameters

// header file dependencies
// @dep_header java_lang_Class
// @dep_header java_lang_String
// @dep_header java_security_InvalidAlgorithmParameterException
// @dep_header java_security_KeyStore
// @dep_header java_security_KeyStoreException
// @dep_header java_security_NoSuchAlgorithmException
// @dep_header java_security_UnrecoverableKeyException
// @dep_header javax_net_ssl_KeyManager
// @dep_header javax_net_ssl_KeyManagerFactorySpi
// @dep_header javax_net_ssl_ManagerFactoryParameters

#include "jc_defs.h"

#include "java/lang/Class.h"
#include "java/lang/String.h"
#include "java/security/InvalidAlgorithmParameterException.h"
#include "java/security/KeyStore.h"
#include "java/security/KeyStoreException.h"
#include "java/security/NoSuchAlgorithmException.h"
#include "java/security/UnrecoverableKeyException.h"
#include "javax/net/ssl/KeyManager.h"
#include "javax/net/ssl/KeyManagerFactorySpi.h"
#include "javax/net/ssl/ManagerFactoryParameters.h"

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// public void <init>()
//

static _jc_linenum _jc_javax_net_ssl_KeyManagerFactorySpi$linenum_table$_init$52f4ad9f2989aeee[];

static const unsigned char _jc_javax_net_ssl_KeyManagerFactorySpi$param_ptypes$_init$52f4ad9f2989aeee[] = { 
_JC_TYPE_VOID };

_jc_method _jc_javax_net_ssl_KeyManagerFactorySpi$method_info$_init$52f4ad9f2989aeee = {
	.name=			"<init>",
	.signature=		"()V",
	.class=			&_jc_javax_net_ssl_KeyManagerFactorySpi$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_net_ssl_KeyManagerFactorySpi$param_ptypes$_init$52f4ad9f2989aeee,
	.signature_hash=	_JC_JLONG(0x52f4ad9f2989aeee),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_javax_net_ssl_KeyManagerFactorySpi$method$_init$52f4ad9f2989aeee,
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_net_ssl_KeyManagerFactorySpi$linenum_table$_init$52f4ad9f2989aeee
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_net_ssl_KeyManagerFactorySpi, _init$52f4ad9f2989aeee);

void _JC_JCNI_ATTR
_jc_javax_net_ssl_KeyManagerFactorySpi$method$_init$52f4ad9f2989aeee(_jc_env *const env, _jc_javax_net_ssl_KeyManagerFactorySpi$object *this)
{
	struct _jc_javax_net_ssl_KeyManagerFactorySpi$object *r0;

	r0 = this;
	_JC_LINE_NUMBER(62);				// 0
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// protected abstract javax.net.ssl.KeyManager[] engineGetKeyManagers()
//

static const unsigned char _jc_javax_net_ssl_KeyManagerFactorySpi$param_ptypes$engineGetKeyManagers$645758138549fcb4[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_javax_net_ssl_KeyManagerFactorySpi$method_info$engineGetKeyManagers$645758138549fcb4 = {
	.name=			"engineGetKeyManagers",
	.signature=		"()[Ljavax/net/ssl/KeyManager;",
	.class=			&_jc_javax_net_ssl_KeyManagerFactorySpi$type,
	.return_type=		&_jc_javax_net_ssl_KeyManager$array$type,
	.param_ptypes=		&_jc_javax_net_ssl_KeyManagerFactorySpi$param_ptypes$engineGetKeyManagers$645758138549fcb4,
	.signature_hash=	_JC_JLONG(0x645758138549fcb4),
	.access_flags=		_JC_ACC_PROTECTED|_JC_ACC_ABSTRACT,
	.function=		&_jc_javax_net_ssl_KeyManagerFactorySpi$method$engineGetKeyManagers$645758138549fcb4,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_net_ssl_KeyManagerFactorySpi$vtable, javax_net_ssl_KeyManagerFactorySpi.engineGetKeyManagers$645758138549fcb4) / sizeof(void *),
	.num_parameters=	0,
};

_jc_object_array * _JC_JCNI_ATTR
_jc_javax_net_ssl_KeyManagerFactorySpi$method$engineGetKeyManagers$645758138549fcb4(_jc_env *const env, _jc_javax_net_ssl_KeyManagerFactorySpi$object *this)
{
	_JC_ABSTRACT_METHOD(env, &_jc_javax_net_ssl_KeyManagerFactorySpi$method_info$engineGetKeyManagers$645758138549fcb4);
}

//
// protected abstract void engineInit(java.security.KeyStore, char[]) throws java.security.KeyStoreException, java.security.NoSuchAlgorithmException, java.security.UnrecoverableKeyException
//

static const unsigned char _jc_javax_net_ssl_KeyManagerFactorySpi$param_ptypes$engineInit$c2175b213ac485fe[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_net_ssl_KeyManagerFactorySpi$exceptions$engineInit$c2175b213ac485fe[] = {
	&_jc_java_security_KeyStoreException$type,
	&_jc_java_security_NoSuchAlgorithmException$type,
	&_jc_java_security_UnrecoverableKeyException$type
};

static _jc_type *const _jc_javax_net_ssl_KeyManagerFactorySpi$param_types$engineInit$c2175b213ac485fe[] = {
	&_jc_java_security_KeyStore$type,
	&_jc_char$array$prim$type
};

_jc_method _jc_javax_net_ssl_KeyManagerFactorySpi$method_info$engineInit$c2175b213ac485fe = {
	.name=			"engineInit",
	.signature=		"(Ljava/security/KeyStore;[C)V",
	.class=			&_jc_javax_net_ssl_KeyManagerFactorySpi$type,
	.param_types=		&_jc_javax_net_ssl_KeyManagerFactorySpi$param_types$engineInit$c2175b213ac485fe,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_net_ssl_KeyManagerFactorySpi$param_ptypes$engineInit$c2175b213ac485fe,
	.signature_hash=	_JC_JLONG(0xc2175b213ac485fe),
	.access_flags=		_JC_ACC_PROTECTED|_JC_ACC_ABSTRACT,
	.function=		&_jc_javax_net_ssl_KeyManagerFactorySpi$method$engineInit$c2175b213ac485fe,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_net_ssl_KeyManagerFactorySpi$vtable, javax_net_ssl_KeyManagerFactorySpi.engineInit$c2175b213ac485fe) / sizeof(void *),
	.num_parameters=	2,
	.num_exceptions=	3,
	.exceptions=		&_jc_javax_net_ssl_KeyManagerFactorySpi$exceptions$engineInit$c2175b213ac485fe,
};

void _JC_JCNI_ATTR
_jc_javax_net_ssl_KeyManagerFactorySpi$method$engineInit$c2175b213ac485fe(_jc_env *const env, _jc_javax_net_ssl_KeyManagerFactorySpi$object *this, _jc_java_security_KeyStore$object *param0, _jc_char_array *param1)
{
	_JC_ABSTRACT_METHOD(env, &_jc_javax_net_ssl_KeyManagerFactorySpi$method_info$engineInit$c2175b213ac485fe);
}

//
// protected abstract void engineInit(javax.net.ssl.ManagerFactoryParameters) throws java.security.InvalidAlgorithmParameterException
//

static const unsigned char _jc_javax_net_ssl_KeyManagerFactorySpi$param_ptypes$engineInit$7d0f73d1c75dca0e[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_net_ssl_KeyManagerFactorySpi$exceptions$engineInit$7d0f73d1c75dca0e[] = {
	&_jc_java_security_InvalidAlgorithmParameterException$type
};

static _jc_type *const _jc_javax_net_ssl_KeyManagerFactorySpi$param_types$engineInit$7d0f73d1c75dca0e[] = {
	&_jc_javax_net_ssl_ManagerFactoryParameters$type
};

_jc_method _jc_javax_net_ssl_KeyManagerFactorySpi$method_info$engineInit$7d0f73d1c75dca0e = {
	.name=			"engineInit",
	.signature=		"(Ljavax/net/ssl/ManagerFactoryParameters;)V",
	.class=			&_jc_javax_net_ssl_KeyManagerFactorySpi$type,
	.param_types=		&_jc_javax_net_ssl_KeyManagerFactorySpi$param_types$engineInit$7d0f73d1c75dca0e,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_net_ssl_KeyManagerFactorySpi$param_ptypes$engineInit$7d0f73d1c75dca0e,
	.signature_hash=	_JC_JLONG(0x7d0f73d1c75dca0e),
	.access_flags=		_JC_ACC_PROTECTED|_JC_ACC_ABSTRACT,
	.function=		&_jc_javax_net_ssl_KeyManagerFactorySpi$method$engineInit$7d0f73d1c75dca0e,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_net_ssl_KeyManagerFactorySpi$vtable, javax_net_ssl_KeyManagerFactorySpi.engineInit$7d0f73d1c75dca0e) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_net_ssl_KeyManagerFactorySpi$exceptions$engineInit$7d0f73d1c75dca0e,
};

void _JC_JCNI_ATTR
_jc_javax_net_ssl_KeyManagerFactorySpi$method$engineInit$7d0f73d1c75dca0e(_jc_env *const env, _jc_javax_net_ssl_KeyManagerFactorySpi$object *this, _jc_object *param0)
{
	_JC_ABSTRACT_METHOD(env, &_jc_javax_net_ssl_KeyManagerFactorySpi$method_info$engineInit$7d0f73d1c75dca0e);
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_javax_net_ssl_KeyManagerFactorySpi$methods[] = {
	&_jc_javax_net_ssl_KeyManagerFactorySpi$method_info$_init$52f4ad9f2989aeee,
	&_jc_javax_net_ssl_KeyManagerFactorySpi$method_info$engineGetKeyManagers$645758138549fcb4,
	&_jc_javax_net_ssl_KeyManagerFactorySpi$method_info$engineInit$c2175b213ac485fe,
	&_jc_javax_net_ssl_KeyManagerFactorySpi$method_info$engineInit$7d0f73d1c75dca0e
};

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_javax_net_ssl_KeyManagerFactorySpi$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};
static _jc_type *const _jc_javax_net_ssl_KeyManagerFactorySpi$instanceof_hash_bucket_120[] = {
	&_jc_javax_net_ssl_KeyManagerFactorySpi$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_javax_net_ssl_KeyManagerFactorySpi$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[101]=	_jc_javax_net_ssl_KeyManagerFactorySpi$instanceof_hash_bucket_101,
	[120]=	_jc_javax_net_ssl_KeyManagerFactorySpi$instanceof_hash_bucket_120
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_javax_net_ssl_KeyManagerFactorySpi$class_depends[] = {
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/security/InvalidAlgorithmParameterException",	_JC_JLONG(0x327edce29f2562dd) },
	{ "java/security/KeyStore",	_JC_JLONG(0x1f56d8b14978c9d6) },
	{ "java/security/KeyStoreException",	_JC_JLONG(0x45b488528f32667c) },
	{ "java/security/NoSuchAlgorithmException",	_JC_JLONG(0x22e937c2536160b4) },
	{ "java/security/UnrecoverableKeyException",	_JC_JLONG(0x398237d93436ff7e) },
	{ "javax/net/ssl/KeyManager",	_JC_JLONG(0xae254aeec477c06d) },
	{ "javax/net/ssl/ManagerFactoryParameters",	_JC_JLONG(0x59c25edc381e2cbe) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_javax_net_ssl_KeyManagerFactorySpi$vtype _jc_javax_net_ssl_KeyManagerFactorySpi$type = {
    .type= {
	.name=			"javax/net/ssl/KeyManagerFactorySpi",
	.superclass=		&_jc_java_lang_Object$type,
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		14,
		.hash=			_JC_JLONG(0x6b3456faafb71978),
		.source_file=		"KeyManagerFactorySpi.java",
		.instance_size=		sizeof(_jc_javax_net_ssl_KeyManagerFactorySpi$refs) + sizeof(_jc_javax_net_ssl_KeyManagerFactorySpi$object),
		.num_virtual_refs=	0,
		.num_methods=		sizeof(_jc_javax_net_ssl_KeyManagerFactorySpi$methods) / sizeof(*_jc_javax_net_ssl_KeyManagerFactorySpi$methods),
		.methods=		_jc_javax_net_ssl_KeyManagerFactorySpi$methods,
		.instanceof_hash_table=	_jc_javax_net_ssl_KeyManagerFactorySpi$instanceof_hash_table,
		.num_class_depends=		sizeof(_jc_javax_net_ssl_KeyManagerFactorySpi$class_depends) / sizeof(*_jc_javax_net_ssl_KeyManagerFactorySpi$class_depends),
		.class_depends=		_jc_javax_net_ssl_KeyManagerFactorySpi$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.javax_net_ssl_KeyManagerFactorySpi= {
	    .engineGetKeyManagers$645758138549fcb4=
		&_jc_javax_net_ssl_KeyManagerFactorySpi$method$engineGetKeyManagers$645758138549fcb4,
	    .engineInit$c2175b213ac485fe=
		&_jc_javax_net_ssl_KeyManagerFactorySpi$method$engineInit$c2175b213ac485fe,
	    .engineInit$7d0f73d1c75dca0e=
		&_jc_javax_net_ssl_KeyManagerFactorySpi$method$engineInit$7d0f73d1c75dca0e,
	},
    }
};

