// public class javax.net.ssl.SSLContext

// class file dependencies
// @dep_class f4ba095546954b36 gnu_java_security_Engine
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class f02ab3ccb490a6d0 java_lang_ClassCastException
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class 680cf34d05feb5a1 java_lang_IllegalArgumentException
// @dep_class b7e704701c278e65 java_lang_IllegalStateException
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class 4f5534a987354d1d java_lang_RuntimeException
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class ae4a2342b31a268d java_lang_reflect_InvocationTargetException
// @dep_class 692089051f4c8d0b java_security_GeneralSecurityException
// @dep_class 97cf2ae63d0fc0df java_security_KeyManagementException
// @dep_class 22e937c2536160b4 java_security_NoSuchAlgorithmException
// @dep_class 8dfbf242adab91e java_security_NoSuchProviderException
// @dep_class 81b073051aa30acc java_security_Provider
// @dep_class 15c6a62b25a6e96d java_security_SecureRandom
// @dep_class 89bf77984bd9669e java_security_Security
// @dep_class c53e1575b095109b java_util_Vector
// @dep_class ae254aeec477c06d javax_net_ssl_KeyManager
// @dep_class a8abca7bf47f5338 javax_net_ssl_SSLContext
// @dep_class 860bb69acbf20f89 javax_net_ssl_SSLContextSpi
// @dep_class be85d5901c8e527f javax_net_ssl_SSLServerSocketFactory
// @dep_class 972ec9ade2b0b2ed javax_net_ssl_SSLSessionContext
// @dep_class eb7a976ef44a2e8c javax_net_ssl_SSLSocketFactory
// @dep_class 2fb5657d3f5b13e2 javax_net_ssl_TrustManager

// header file dependencies
// @dep_header gnu_java_security_Engine
// @dep_header java_lang_Class
// @dep_header java_lang_ClassCastException
// @dep_header java_lang_IllegalArgumentException
// @dep_header java_lang_IllegalStateException
// @dep_header java_lang_String
// @dep_header java_lang_VMThrowable
// @dep_header java_lang_reflect_InvocationTargetException
// @dep_header java_security_KeyManagementException
// @dep_header java_security_NoSuchAlgorithmException
// @dep_header java_security_NoSuchProviderException
// @dep_header java_security_Provider
// @dep_header java_security_SecureRandom
// @dep_header java_security_Security
// @dep_header java_util_Vector
// @dep_header javax_net_ssl_KeyManager
// @dep_header javax_net_ssl_SSLContext
// @dep_header javax_net_ssl_SSLContextSpi
// @dep_header javax_net_ssl_SSLServerSocketFactory
// @dep_header javax_net_ssl_SSLSessionContext
// @dep_header javax_net_ssl_SSLSocketFactory
// @dep_header javax_net_ssl_TrustManager

#include "jc_defs.h"

#include "gnu/java/security/Engine.h"
#include "java/lang/Class.h"
#include "java/lang/ClassCastException.h"
#include "java/lang/IllegalArgumentException.h"
#include "java/lang/IllegalStateException.h"
#include "java/lang/String.h"
#include "java/lang/VMThrowable.h"
#include "java/lang/reflect/InvocationTargetException.h"
#include "java/security/KeyManagementException.h"
#include "java/security/NoSuchAlgorithmException.h"
#include "java/security/NoSuchProviderException.h"
#include "java/security/Provider.h"
#include "java/security/SecureRandom.h"
#include "java/security/Security.h"
#include "java/util/Vector.h"
#include "javax/net/ssl/KeyManager.h"
#include "javax/net/ssl/SSLContext.h"
#include "javax/net/ssl/SSLContextSpi.h"
#include "javax/net/ssl/SSLServerSocketFactory.h"
#include "javax/net/ssl/SSLSessionContext.h"
#include "javax/net/ssl/SSLSocketFactory.h"
#include "javax/net/ssl/TrustManager.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// private static final java.lang.String SSL_CONTEXT
static _jc_field _jc_javax_net_ssl_SSLContext$field_info$SSL__5fCONTEXT = {
	.name=		"SSL_CONTEXT",
	.signature=	"Ljava/lang/String;",
	.class=		&_jc_javax_net_ssl_SSLContext$type,
	.type=		&_jc_java_lang_String$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_javax_net_ssl_SSLContext$fields_struct, SSL__5fCONTEXT),
	.initial_value=	"SSLContext",
};

// private final javax.net.ssl.SSLContextSpi ctxSpi
static _jc_field _jc_javax_net_ssl_SSLContext$field_info$ctxSpi = {
	.name=		"ctxSpi",
	.signature=	"Ljavax/net/ssl/SSLContextSpi;",
	.class=		&_jc_javax_net_ssl_SSLContext$type,
	.type=		&_jc_javax_net_ssl_SSLContextSpi$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_javax_net_ssl_SSLContext$object, refs[-1].javax_net_ssl_SSLContext.ctxSpi),
};

// private final java.security.Provider provider
static _jc_field _jc_javax_net_ssl_SSLContext$field_info$provider = {
	.name=		"provider",
	.signature=	"Ljava/security/Provider;",
	.class=		&_jc_javax_net_ssl_SSLContext$type,
	.type=		&_jc_java_security_Provider$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_javax_net_ssl_SSLContext$object, refs[-1].javax_net_ssl_SSLContext.provider),
};

// private final java.lang.String protocol
static _jc_field _jc_javax_net_ssl_SSLContext$field_info$protocol = {
	.name=		"protocol",
	.signature=	"Ljava/lang/String;",
	.class=		&_jc_javax_net_ssl_SSLContext$type,
	.type=		&_jc_java_lang_String$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_javax_net_ssl_SSLContext$object, refs[-1].javax_net_ssl_SSLContext.protocol),
};

// Fields
static _jc_field *const _jc_javax_net_ssl_SSLContext$fields[] = {
	&_jc_javax_net_ssl_SSLContext$field_info$SSL__5fCONTEXT,
	&_jc_javax_net_ssl_SSLContext$field_info$ctxSpi,
	&_jc_javax_net_ssl_SSLContext$field_info$protocol,
	&_jc_javax_net_ssl_SSLContext$field_info$provider
};

/************************************************************************
 *			      Static methods				*
 ************************************************************************/

//
// public static final javax.net.ssl.SSLContext getInstance(java.lang.String) throws java.security.NoSuchAlgorithmException
//

static _jc_linenum _jc_javax_net_ssl_SSLContext$linenum_table$getInstance$3b8178635c1f1f5b[];

static _jc_trap_info _jc_javax_net_ssl_SSLContext$trap_table$getInstance$3b8178635c1f1f5b[] = {
	_JC_TRAP(&_jc_java_security_NoSuchAlgorithmException$type, 1, 2),
};

static const unsigned char _jc_javax_net_ssl_SSLContext$param_ptypes$getInstance$3b8178635c1f1f5b[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_javax_net_ssl_SSLContext$exceptions$getInstance$3b8178635c1f1f5b[] = {
	&_jc_java_security_NoSuchAlgorithmException$type
};

static _jc_type *const _jc_javax_net_ssl_SSLContext$param_types$getInstance$3b8178635c1f1f5b[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_javax_net_ssl_SSLContext$method_info$getInstance$3b8178635c1f1f5b = {
	.name=			"getInstance",
	.signature=		"(Ljava/lang/String;)Ljavax/net/ssl/SSLContext;",
	.class=			&_jc_javax_net_ssl_SSLContext$type,
	.param_types=		&_jc_javax_net_ssl_SSLContext$param_types$getInstance$3b8178635c1f1f5b,
	.return_type=		&_jc_javax_net_ssl_SSLContext$type,
	.param_ptypes=		&_jc_javax_net_ssl_SSLContext$param_ptypes$getInstance$3b8178635c1f1f5b,
	.signature_hash=	_JC_JLONG(0x3b8178635c1f1f5b),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_net_ssl_SSLContext$method$getInstance$3b8178635c1f1f5b,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_net_ssl_SSLContext$exceptions$getInstance$3b8178635c1f1f5b,
	.u= { .exec= {
	  .trap_table_len=	1,
	  .trap_table=		_jc_javax_net_ssl_SSLContext$trap_table$getInstance$3b8178635c1f1f5b,
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_javax_net_ssl_SSLContext$linenum_table$getInstance$3b8178635c1f1f5b
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_net_ssl_SSLContext, getInstance$3b8178635c1f1f5b);

_jc_javax_net_ssl_SSLContext$object * _JC_JCNI_ATTR
_jc_javax_net_ssl_SSLContext$method$getInstance$3b8178635c1f1f5b(_jc_env *const env, _jc_java_lang_String$object *param0)
{
	jint volatile i0;
	jint volatile i1;
	jint i2;
	struct _jc_java_lang_String$object *volatile r0;
	struct _jc_java_security_Provider$object *volatile r2;
	struct _jc_javax_net_ssl_SSLContext$object *volatile r3;
	struct _jc_java_security_NoSuchAlgorithmException$object *volatile r4;
	struct _jc_java_lang_VMThrowable$object *volatile r5;
	struct _jc_java_util_Vector$object *r6;
	_jc_object_array *volatile r7;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_javax_net_ssl_SSLContext$method_info$getInstance$3b8178635c1f1f5b, &&label1);

	r0 = param0;
	_JC_ACTIVE_USE(env, java_security_Security);
	_JC_LINE_NUMBER(109);				// 0
	r6 = _JC_STATIC_FIELD(env, java_security_Security, providers, 1);
	i2 = _JC_INVOKE_VIRTUAL(env, java_util_Vector, size$345df5220fc60ade, r6);
	r7 = _JC_NEW_REF_ARRAY(env, java_security_Provider, 1, i2);
	r6 = _JC_STATIC_FIELD(env, java_security_Security, providers, 1);
	_JC_INVOKE_VIRTUAL(env, java_util_Vector, copyInto$cd78d768b3ba4735, r6, r7);
	_JC_LINE_NUMBER(110);				// 1
	i0 = 0;
	goto label2;

label0:
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(114);				// 2
	r2 = _JC_REF_ELEMENT(env, r7, i0, 1, 1);
	r3 = _JC_INVOKE_STATIC(env, javax_net_ssl_SSLContext, getInstance$6355e0f0247fa191, 0, r0, r2);
	_JC_TRAP_REGION(catch, 2);
	_JC_CANCEL_TRAPS(env, catch);
	return r3;

label1:
	_JC_TRAP_REGION(catch, 2);
	r4 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(110);				// 3
	i0 = i0 + 1;

label2:
	_JC_TRAP_REGION(catch, 2);
	i1 = _JC_ARRAY_LENGTH(env, r7);
	if (i0 < i1) {
		_JC_PERIODIC_CHECK(env);
		goto label0;
	}
	_JC_LINE_NUMBER(120);				// 4
	r4 = _JC_NEW(env, java_security_NoSuchAlgorithmException);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r5 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r5;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r0;
	_JC_THROW(env, r4);
}

//
// public static final javax.net.ssl.SSLContext getInstance(java.lang.String, java.lang.String) throws java.security.NoSuchAlgorithmException, java.security.NoSuchProviderException
//

static _jc_linenum _jc_javax_net_ssl_SSLContext$linenum_table$getInstance$1534ac94e2c195d6[];

static const unsigned char _jc_javax_net_ssl_SSLContext$param_ptypes$getInstance$1534ac94e2c195d6[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_javax_net_ssl_SSLContext$exceptions$getInstance$1534ac94e2c195d6[] = {
	&_jc_java_security_NoSuchAlgorithmException$type,
	&_jc_java_security_NoSuchProviderException$type
};

static _jc_type *const _jc_javax_net_ssl_SSLContext$param_types$getInstance$1534ac94e2c195d6[] = {
	&_jc_java_lang_String$type,
	&_jc_java_lang_String$type
};

_jc_method _jc_javax_net_ssl_SSLContext$method_info$getInstance$1534ac94e2c195d6 = {
	.name=			"getInstance",
	.signature=		"(Ljava/lang/String;Ljava/lang/String;)Ljavax/net/ssl/SSLContext;",
	.class=			&_jc_javax_net_ssl_SSLContext$type,
	.param_types=		&_jc_javax_net_ssl_SSLContext$param_types$getInstance$1534ac94e2c195d6,
	.return_type=		&_jc_javax_net_ssl_SSLContext$type,
	.param_ptypes=		&_jc_javax_net_ssl_SSLContext$param_ptypes$getInstance$1534ac94e2c195d6,
	.signature_hash=	_JC_JLONG(0x1534ac94e2c195d6),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_net_ssl_SSLContext$method$getInstance$1534ac94e2c195d6,
	.num_parameters=	2,
	.num_exceptions=	2,
	.exceptions=		&_jc_javax_net_ssl_SSLContext$exceptions$getInstance$1534ac94e2c195d6,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	6,
	      .table=	_jc_javax_net_ssl_SSLContext$linenum_table$getInstance$1534ac94e2c195d6
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_net_ssl_SSLContext, getInstance$1534ac94e2c195d6);

_jc_javax_net_ssl_SSLContext$object * _JC_JCNI_ATTR
_jc_javax_net_ssl_SSLContext$method$getInstance$1534ac94e2c195d6(_jc_env *const env, _jc_java_lang_String$object *param0, _jc_java_lang_String$object *param1)
{
	struct _jc_java_lang_String$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_java_security_Provider$object *r2;
	struct _jc_java_lang_IllegalArgumentException$object *r3;
	struct _jc_java_security_NoSuchProviderException$object *r4;
	struct _jc_javax_net_ssl_SSLContext$object *r5;
	struct _jc_java_lang_String$object *r6;
	struct _jc_java_lang_VMThrowable$object *r7;
	struct _jc_java_lang_VMThrowable$object *r9;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = param0;
	r1 = param1;
	_JC_LINE_NUMBER(141);				// 0
	if (r1 != _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(143);				// 1
	r3 = _JC_NEW(env, java_lang_IllegalArgumentException);
	r6 = _JC_STRING(env, "null provider");
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r7 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r7;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r6;
	_JC_THROW(env, r3);

label0:
	_JC_LINE_NUMBER(145);				// 2
	r2 = _JC_INVOKE_STATIC(env, java_security_Security, getProvider$581ee7d7bc9ae747, 0, r1);
	_JC_LINE_NUMBER(146);				// 3
	if (r2 != _JC_NULL)
		goto label1;
	_JC_LINE_NUMBER(148);				// 4
	r4 = _JC_NEW(env, java_security_NoSuchProviderException);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r9 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r9;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r1;
	_JC_THROW(env, r4);

label1:
	_JC_LINE_NUMBER(150);				// 5
	r5 = _JC_INVOKE_STATIC(env, javax_net_ssl_SSLContext, getInstance$6355e0f0247fa191, 1, r0, r2);
	return r5;
}

//
// public static final javax.net.ssl.SSLContext getInstance(java.lang.String, java.security.Provider) throws java.security.NoSuchAlgorithmException
//

static _jc_linenum _jc_javax_net_ssl_SSLContext$linenum_table$getInstance$6355e0f0247fa191[];

static _jc_trap_info _jc_javax_net_ssl_SSLContext$trap_table$getInstance$6355e0f0247fa191[] = {
	_JC_TRAP(&_jc_java_lang_reflect_InvocationTargetException$type, 1, 2),
	_JC_TRAP(&_jc_java_lang_ClassCastException$type, 1, 2),
};

static const unsigned char _jc_javax_net_ssl_SSLContext$param_ptypes$getInstance$6355e0f0247fa191[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_javax_net_ssl_SSLContext$exceptions$getInstance$6355e0f0247fa191[] = {
	&_jc_java_security_NoSuchAlgorithmException$type
};

static _jc_type *const _jc_javax_net_ssl_SSLContext$param_types$getInstance$6355e0f0247fa191[] = {
	&_jc_java_lang_String$type,
	&_jc_java_security_Provider$type
};

_jc_method _jc_javax_net_ssl_SSLContext$method_info$getInstance$6355e0f0247fa191 = {
	.name=			"getInstance",
	.signature=		"(Ljava/lang/String;Ljava/security/Provider;)Ljavax/net/ssl/SSLContext;",
	.class=			&_jc_javax_net_ssl_SSLContext$type,
	.param_types=		&_jc_javax_net_ssl_SSLContext$param_types$getInstance$6355e0f0247fa191,
	.return_type=		&_jc_javax_net_ssl_SSLContext$type,
	.param_ptypes=		&_jc_javax_net_ssl_SSLContext$param_ptypes$getInstance$6355e0f0247fa191,
	.signature_hash=	_JC_JLONG(0x6355e0f0247fa191),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_net_ssl_SSLContext$method$getInstance$6355e0f0247fa191,
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_net_ssl_SSLContext$exceptions$getInstance$6355e0f0247fa191,
	.u= { .exec= {
	  .trap_table_len=	2,
	  .trap_table=		_jc_javax_net_ssl_SSLContext$trap_table$getInstance$6355e0f0247fa191,
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_javax_net_ssl_SSLContext$linenum_table$getInstance$6355e0f0247fa191
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_net_ssl_SSLContext, getInstance$6355e0f0247fa191);

_jc_javax_net_ssl_SSLContext$object * _JC_JCNI_ATTR
_jc_javax_net_ssl_SSLContext$method$getInstance$6355e0f0247fa191(_jc_env *const env, _jc_java_lang_String$object *param0, _jc_java_security_Provider$object *param1)
{
	struct _jc_java_lang_String$object *volatile r0;
	struct _jc_java_security_Provider$object *r1;
	struct _jc_java_lang_Object$object *r10;
	struct _jc_java_lang_VMThrowable$object *volatile r11;
	struct _jc_java_lang_VMThrowable$object *volatile r12;
	struct _jc_java_lang_IllegalArgumentException$object *volatile r13;
	struct _jc_java_lang_Throwable$object *volatile r14;
	struct _jc_java_lang_IllegalStateException$object *volatile r15;
	struct _jc_java_lang_String$object *volatile r16;
	struct _jc_java_lang_VMThrowable$object *volatile r18;
	struct _jc_javax_net_ssl_SSLContext$object *r2;
	struct _jc_java_lang_reflect_InvocationTargetException$object *volatile r3;
	struct _jc_java_security_NoSuchAlgorithmException$object *volatile r4;
	struct _jc_javax_net_ssl_SSLContextSpi$object *r5;
	struct _jc_java_lang_Throwable$object *volatile r6;
	struct _jc_java_lang_ClassCastException$object *volatile r7;
	struct _jc_java_lang_String$object *r8;
	_jc_object_array *r9;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_javax_net_ssl_SSLContext$method_info$getInstance$6355e0f0247fa191, &&label0, &&label3);

	r0 = param0;
	r1 = param1;
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(171);				// 0
	r2 = _JC_NEW(env, javax_net_ssl_SSLContext);
	_JC_ACTIVE_USE(env, gnu_java_security_Engine);
	r8 = _JC_STRING(env, "SSLContext");
	r9 = _JC_STATIC_FIELD(env, gnu_java_security_Engine, NO__5fARGS, 1);
	r10 = _JC_INVOKE_STATIC(env, gnu_java_security_Engine, getInstance$ec89dfd35c234c64, 1, r8, r0, r1, r9);
	r5 = _JC_CAST(env, &_jc_javax_net_ssl_SSLContextSpi$type, r10);
	_JC_REF_FIELD(env, r2, javax_net_ssl_SSLContext, ctxSpi) = r5;
	_JC_REF_FIELD(env, r2, javax_net_ssl_SSLContext, provider) = r1;
	_JC_REF_FIELD(env, r2, javax_net_ssl_SSLContext, protocol) = r0;
	_JC_TRAP_REGION(catch, 2);
	_JC_CANCEL_TRAPS(env, catch);
	return r2;

label0:
	_JC_TRAP_REGION(catch, 2);
	r3 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(177);				// 1
	r4 = _JC_NEW(env, java_security_NoSuchAlgorithmException);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r11 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r11;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r0;
	if (r3 != r4)
		goto label1;
	r13 = _JC_NEW(env, java_lang_IllegalArgumentException);
	r16 = _JC_NULL;
	_JC_REF_FIELD(env, r13, java_lang_Throwable, cause) = r13;
	r18 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 1, r13);
	_JC_REF_FIELD(env, r13, java_lang_Throwable, vmState) = r18;
	_JC_REF_FIELD(env, r13, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r13, java_lang_Throwable, detailMessage) = r16;
	_JC_THROW(env, r13);

label1:
	r14 = _JC_REF_FIELD(env, r4, java_lang_Throwable, cause);
	if (r14 == r4)
		goto label2;
	r15 = _JC_NEW(env, java_lang_IllegalStateException);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_Throwable, _init$c31b894660454d13, 0, r15, _JC_NULL);
	_JC_THROW(env, r15);

label2:
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r3;
	_JC_LINE_NUMBER(178);				// 2
	r4 = r4;
	_JC_THROW(env, r4);

label3:
	_JC_TRAP_REGION(catch, 2);
	r7 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(182);				// 3
	r4 = _JC_NEW(env, java_security_NoSuchAlgorithmException);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r12 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r12;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r0;
	_JC_LINE_NUMBER(183);				// 4
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_Throwable, initCause$997fed19751e1c64, 0, r4, r7);
	r4 = _JC_CAST(env, &_jc_java_security_NoSuchAlgorithmException$type, r6);
	_JC_THROW(env, r4);
}

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// protected void <init>(javax.net.ssl.SSLContextSpi, java.security.Provider, java.lang.String)
//

static _jc_linenum _jc_javax_net_ssl_SSLContext$linenum_table$_init$a52861e00536fb90[];

static const unsigned char _jc_javax_net_ssl_SSLContext$param_ptypes$_init$a52861e00536fb90[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_net_ssl_SSLContext$param_types$_init$a52861e00536fb90[] = {
	&_jc_javax_net_ssl_SSLContextSpi$type,
	&_jc_java_security_Provider$type,
	&_jc_java_lang_String$type
};

_jc_method _jc_javax_net_ssl_SSLContext$method_info$_init$a52861e00536fb90 = {
	.name=			"<init>",
	.signature=		"(Ljavax/net/ssl/SSLContextSpi;Ljava/security/Provider;Ljava/lang/String;)V",
	.class=			&_jc_javax_net_ssl_SSLContext$type,
	.param_types=		&_jc_javax_net_ssl_SSLContext$param_types$_init$a52861e00536fb90,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_net_ssl_SSLContext$param_ptypes$_init$a52861e00536fb90,
	.signature_hash=	_JC_JLONG(0xa52861e00536fb90),
	.access_flags=		_JC_ACC_PROTECTED,
	.function=		&_jc_javax_net_ssl_SSLContext$method$_init$a52861e00536fb90,
	.num_parameters=	3,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_javax_net_ssl_SSLContext$linenum_table$_init$a52861e00536fb90
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_net_ssl_SSLContext, _init$a52861e00536fb90);

void _JC_JCNI_ATTR
_jc_javax_net_ssl_SSLContext$method$_init$a52861e00536fb90(_jc_env *const env, _jc_javax_net_ssl_SSLContext$object *this, _jc_javax_net_ssl_SSLContextSpi$object *param0, _jc_java_security_Provider$object *param1, _jc_java_lang_String$object *param2)
{
	struct _jc_javax_net_ssl_SSLContext$object *r0;
	struct _jc_javax_net_ssl_SSLContextSpi$object *r1;
	struct _jc_java_security_Provider$object *r2;
	struct _jc_java_lang_String$object *r3;

	r0 = this;
	r1 = param0;
	r2 = param1;
	r3 = param2;
	_JC_LINE_NUMBER(89);				// 0
	_JC_REF_FIELD(env, r0, javax_net_ssl_SSLContext, ctxSpi) = r1;
	_JC_LINE_NUMBER(90);				// 1
	_JC_REF_FIELD(env, r0, javax_net_ssl_SSLContext, provider) = r2;
	_JC_LINE_NUMBER(91);				// 2
	_JC_REF_FIELD(env, r0, javax_net_ssl_SSLContext, protocol) = r3;
	_JC_LINE_NUMBER(92);				// 3
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public final javax.net.ssl.SSLSessionContext getClientSessionContext()
//

static _jc_linenum _jc_javax_net_ssl_SSLContext$linenum_table$getClientSessionContext$b3a9bb24a977bd75[];

static const unsigned char _jc_javax_net_ssl_SSLContext$param_ptypes$getClientSessionContext$b3a9bb24a977bd75[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_javax_net_ssl_SSLContext$method_info$getClientSessionContext$b3a9bb24a977bd75 = {
	.name=			"getClientSessionContext",
	.signature=		"()Ljavax/net/ssl/SSLSessionContext;",
	.class=			&_jc_javax_net_ssl_SSLContext$type,
	.return_type=		&_jc_javax_net_ssl_SSLSessionContext$type,
	.param_ptypes=		&_jc_javax_net_ssl_SSLContext$param_ptypes$getClientSessionContext$b3a9bb24a977bd75,
	.signature_hash=	_JC_JLONG(0xb3a9bb24a977bd75),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_net_ssl_SSLContext$method$getClientSessionContext$b3a9bb24a977bd75,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_net_ssl_SSLContext$vtable, javax_net_ssl_SSLContext.getClientSessionContext$b3a9bb24a977bd75) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_net_ssl_SSLContext$linenum_table$getClientSessionContext$b3a9bb24a977bd75
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_net_ssl_SSLContext, getClientSessionContext$b3a9bb24a977bd75);

_jc_object * _JC_JCNI_ATTR
_jc_javax_net_ssl_SSLContext$method$getClientSessionContext$b3a9bb24a977bd75(_jc_env *const env, _jc_javax_net_ssl_SSLContext$object *this)
{
	struct _jc_javax_net_ssl_SSLContext$object *r0;
	struct _jc_javax_net_ssl_SSLContextSpi$object *r1;
	struct _jc_object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(197);				// 0
	r1 = _JC_REF_FIELD(env, r0, javax_net_ssl_SSLContext, ctxSpi);
	r2 = _JC_INVOKE_VIRTUAL(env, javax_net_ssl_SSLContextSpi, engineGetClientSessionContext$b2000fb2b4100822, r1);
	return r2;
}

//
// public final java.lang.String getProtocol()
//

static _jc_linenum _jc_javax_net_ssl_SSLContext$linenum_table$getProtocol$b414d53f1c8ae478[];

static const unsigned char _jc_javax_net_ssl_SSLContext$param_ptypes$getProtocol$b414d53f1c8ae478[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_javax_net_ssl_SSLContext$method_info$getProtocol$b414d53f1c8ae478 = {
	.name=			"getProtocol",
	.signature=		"()Ljava/lang/String;",
	.class=			&_jc_javax_net_ssl_SSLContext$type,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_javax_net_ssl_SSLContext$param_ptypes$getProtocol$b414d53f1c8ae478,
	.signature_hash=	_JC_JLONG(0xb414d53f1c8ae478),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_net_ssl_SSLContext$method$getProtocol$b414d53f1c8ae478,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_net_ssl_SSLContext$vtable, javax_net_ssl_SSLContext.getProtocol$b414d53f1c8ae478) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_net_ssl_SSLContext$linenum_table$getProtocol$b414d53f1c8ae478
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_net_ssl_SSLContext, getProtocol$b414d53f1c8ae478);

_jc_java_lang_String$object * _JC_JCNI_ATTR
_jc_javax_net_ssl_SSLContext$method$getProtocol$b414d53f1c8ae478(_jc_env *const env, _jc_javax_net_ssl_SSLContext$object *this)
{
	struct _jc_javax_net_ssl_SSLContext$object *r0;
	struct _jc_java_lang_String$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(207);				// 0
	r1 = _JC_REF_FIELD(env, r0, javax_net_ssl_SSLContext, protocol);
	return r1;
}

//
// public final java.security.Provider getProvider()
//

static _jc_linenum _jc_javax_net_ssl_SSLContext$linenum_table$getProvider$e8f9c9fb14140d5a[];

static const unsigned char _jc_javax_net_ssl_SSLContext$param_ptypes$getProvider$e8f9c9fb14140d5a[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_javax_net_ssl_SSLContext$method_info$getProvider$e8f9c9fb14140d5a = {
	.name=			"getProvider",
	.signature=		"()Ljava/security/Provider;",
	.class=			&_jc_javax_net_ssl_SSLContext$type,
	.return_type=		&_jc_java_security_Provider$type,
	.param_ptypes=		&_jc_javax_net_ssl_SSLContext$param_ptypes$getProvider$e8f9c9fb14140d5a,
	.signature_hash=	_JC_JLONG(0xe8f9c9fb14140d5a),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_net_ssl_SSLContext$method$getProvider$e8f9c9fb14140d5a,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_net_ssl_SSLContext$vtable, javax_net_ssl_SSLContext.getProvider$e8f9c9fb14140d5a) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_net_ssl_SSLContext$linenum_table$getProvider$e8f9c9fb14140d5a
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_net_ssl_SSLContext, getProvider$e8f9c9fb14140d5a);

_jc_java_security_Provider$object * _JC_JCNI_ATTR
_jc_javax_net_ssl_SSLContext$method$getProvider$e8f9c9fb14140d5a(_jc_env *const env, _jc_javax_net_ssl_SSLContext$object *this)
{
	struct _jc_javax_net_ssl_SSLContext$object *r0;
	struct _jc_java_security_Provider$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(217);				// 0
	r1 = _JC_REF_FIELD(env, r0, javax_net_ssl_SSLContext, provider);
	return r1;
}

//
// public final javax.net.ssl.SSLSessionContext getServerSessionContext()
//

static _jc_linenum _jc_javax_net_ssl_SSLContext$linenum_table$getServerSessionContext$5f5305151719e314[];

static const unsigned char _jc_javax_net_ssl_SSLContext$param_ptypes$getServerSessionContext$5f5305151719e314[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_javax_net_ssl_SSLContext$method_info$getServerSessionContext$5f5305151719e314 = {
	.name=			"getServerSessionContext",
	.signature=		"()Ljavax/net/ssl/SSLSessionContext;",
	.class=			&_jc_javax_net_ssl_SSLContext$type,
	.return_type=		&_jc_javax_net_ssl_SSLSessionContext$type,
	.param_ptypes=		&_jc_javax_net_ssl_SSLContext$param_ptypes$getServerSessionContext$5f5305151719e314,
	.signature_hash=	_JC_JLONG(0x5f5305151719e314),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_net_ssl_SSLContext$method$getServerSessionContext$5f5305151719e314,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_net_ssl_SSLContext$vtable, javax_net_ssl_SSLContext.getServerSessionContext$5f5305151719e314) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_net_ssl_SSLContext$linenum_table$getServerSessionContext$5f5305151719e314
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_net_ssl_SSLContext, getServerSessionContext$5f5305151719e314);

_jc_object * _JC_JCNI_ATTR
_jc_javax_net_ssl_SSLContext$method$getServerSessionContext$5f5305151719e314(_jc_env *const env, _jc_javax_net_ssl_SSLContext$object *this)
{
	struct _jc_javax_net_ssl_SSLContext$object *r0;
	struct _jc_javax_net_ssl_SSLContextSpi$object *r1;
	struct _jc_object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(227);				// 0
	r1 = _JC_REF_FIELD(env, r0, javax_net_ssl_SSLContext, ctxSpi);
	r2 = _JC_INVOKE_VIRTUAL(env, javax_net_ssl_SSLContextSpi, engineGetServerSessionContext$29cc600184bce31b, r1);
	return r2;
}

//
// public final javax.net.ssl.SSLServerSocketFactory getServerSocketFactory()
//

static _jc_linenum _jc_javax_net_ssl_SSLContext$linenum_table$getServerSocketFactory$eb86151495edfc3e[];

static const unsigned char _jc_javax_net_ssl_SSLContext$param_ptypes$getServerSocketFactory$eb86151495edfc3e[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_javax_net_ssl_SSLContext$method_info$getServerSocketFactory$eb86151495edfc3e = {
	.name=			"getServerSocketFactory",
	.signature=		"()Ljavax/net/ssl/SSLServerSocketFactory;",
	.class=			&_jc_javax_net_ssl_SSLContext$type,
	.return_type=		&_jc_javax_net_ssl_SSLServerSocketFactory$type,
	.param_ptypes=		&_jc_javax_net_ssl_SSLContext$param_ptypes$getServerSocketFactory$eb86151495edfc3e,
	.signature_hash=	_JC_JLONG(0xeb86151495edfc3e),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_net_ssl_SSLContext$method$getServerSocketFactory$eb86151495edfc3e,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_net_ssl_SSLContext$vtable, javax_net_ssl_SSLContext.getServerSocketFactory$eb86151495edfc3e) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_net_ssl_SSLContext$linenum_table$getServerSocketFactory$eb86151495edfc3e
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_net_ssl_SSLContext, getServerSocketFactory$eb86151495edfc3e);

_jc_javax_net_ssl_SSLServerSocketFactory$object * _JC_JCNI_ATTR
_jc_javax_net_ssl_SSLContext$method$getServerSocketFactory$eb86151495edfc3e(_jc_env *const env, _jc_javax_net_ssl_SSLContext$object *this)
{
	struct _jc_javax_net_ssl_SSLContext$object *r0;
	struct _jc_javax_net_ssl_SSLContextSpi$object *r1;
	struct _jc_javax_net_ssl_SSLServerSocketFactory$object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(237);				// 0
	r1 = _JC_REF_FIELD(env, r0, javax_net_ssl_SSLContext, ctxSpi);
	r2 = _JC_INVOKE_VIRTUAL(env, javax_net_ssl_SSLContextSpi, engineGetServerSocketFactory$ea765cae88ebe591, r1);
	return r2;
}

//
// public final javax.net.ssl.SSLSocketFactory getSocketFactory()
//

static _jc_linenum _jc_javax_net_ssl_SSLContext$linenum_table$getSocketFactory$ec3052bf27e7156d[];

static const unsigned char _jc_javax_net_ssl_SSLContext$param_ptypes$getSocketFactory$ec3052bf27e7156d[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_javax_net_ssl_SSLContext$method_info$getSocketFactory$ec3052bf27e7156d = {
	.name=			"getSocketFactory",
	.signature=		"()Ljavax/net/ssl/SSLSocketFactory;",
	.class=			&_jc_javax_net_ssl_SSLContext$type,
	.return_type=		&_jc_javax_net_ssl_SSLSocketFactory$type,
	.param_ptypes=		&_jc_javax_net_ssl_SSLContext$param_ptypes$getSocketFactory$ec3052bf27e7156d,
	.signature_hash=	_JC_JLONG(0xec3052bf27e7156d),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_net_ssl_SSLContext$method$getSocketFactory$ec3052bf27e7156d,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_net_ssl_SSLContext$vtable, javax_net_ssl_SSLContext.getSocketFactory$ec3052bf27e7156d) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_net_ssl_SSLContext$linenum_table$getSocketFactory$ec3052bf27e7156d
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_net_ssl_SSLContext, getSocketFactory$ec3052bf27e7156d);

_jc_javax_net_ssl_SSLSocketFactory$object * _JC_JCNI_ATTR
_jc_javax_net_ssl_SSLContext$method$getSocketFactory$ec3052bf27e7156d(_jc_env *const env, _jc_javax_net_ssl_SSLContext$object *this)
{
	struct _jc_javax_net_ssl_SSLContext$object *r0;
	struct _jc_javax_net_ssl_SSLContextSpi$object *r1;
	struct _jc_javax_net_ssl_SSLSocketFactory$object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(247);				// 0
	r1 = _JC_REF_FIELD(env, r0, javax_net_ssl_SSLContext, ctxSpi);
	r2 = _JC_INVOKE_VIRTUAL(env, javax_net_ssl_SSLContextSpi, engineGetSocketFactory$815833768b868fad, r1);
	return r2;
}

//
// public final void init(javax.net.ssl.KeyManager[], javax.net.ssl.TrustManager[], java.security.SecureRandom) throws java.security.KeyManagementException
//

static _jc_linenum _jc_javax_net_ssl_SSLContext$linenum_table$init$1c26e3f86773b499[];

static const unsigned char _jc_javax_net_ssl_SSLContext$param_ptypes$init$1c26e3f86773b499[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_net_ssl_SSLContext$exceptions$init$1c26e3f86773b499[] = {
	&_jc_java_security_KeyManagementException$type
};

static _jc_type *const _jc_javax_net_ssl_SSLContext$param_types$init$1c26e3f86773b499[] = {
	&_jc_javax_net_ssl_KeyManager$array$type,
	&_jc_javax_net_ssl_TrustManager$array$type,
	&_jc_java_security_SecureRandom$type
};

_jc_method _jc_javax_net_ssl_SSLContext$method_info$init$1c26e3f86773b499 = {
	.name=			"init",
	.signature=		"([Ljavax/net/ssl/KeyManager;[Ljavax/net/ssl/TrustManager;Ljava/security/SecureRandom;)V",
	.class=			&_jc_javax_net_ssl_SSLContext$type,
	.param_types=		&_jc_javax_net_ssl_SSLContext$param_types$init$1c26e3f86773b499,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_net_ssl_SSLContext$param_ptypes$init$1c26e3f86773b499,
	.signature_hash=	_JC_JLONG(0x1c26e3f86773b499),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_net_ssl_SSLContext$method$init$1c26e3f86773b499,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_net_ssl_SSLContext$vtable, javax_net_ssl_SSLContext.init$1c26e3f86773b499) / sizeof(void *),
	.num_parameters=	3,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_net_ssl_SSLContext$exceptions$init$1c26e3f86773b499,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_javax_net_ssl_SSLContext$linenum_table$init$1c26e3f86773b499
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_net_ssl_SSLContext, init$1c26e3f86773b499);

void _JC_JCNI_ATTR
_jc_javax_net_ssl_SSLContext$method$init$1c26e3f86773b499(_jc_env *const env, _jc_javax_net_ssl_SSLContext$object *this, _jc_object_array *param0, _jc_object_array *param1, _jc_java_security_SecureRandom$object *param2)
{
	struct _jc_javax_net_ssl_SSLContext$object *r0;
	_jc_object_array *r1;
	_jc_object_array *r2;
	struct _jc_java_security_SecureRandom$object *r3;
	struct _jc_javax_net_ssl_SSLContextSpi$object *r4;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	r3 = param2;
	_JC_LINE_NUMBER(265);				// 0
	r4 = _JC_REF_FIELD(env, r0, javax_net_ssl_SSLContext, ctxSpi);
	_JC_INVOKE_VIRTUAL(env, javax_net_ssl_SSLContextSpi, engineInit$689c9e8c18a70c8f, r4, r1, r2, r3);
	_JC_LINE_NUMBER(266);				// 1
	return;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_javax_net_ssl_SSLContext$methods[] = {
	&_jc_javax_net_ssl_SSLContext$method_info$_init$a52861e00536fb90,
	&_jc_javax_net_ssl_SSLContext$method_info$getClientSessionContext$b3a9bb24a977bd75,
	&_jc_javax_net_ssl_SSLContext$method_info$getInstance$3b8178635c1f1f5b,
	&_jc_javax_net_ssl_SSLContext$method_info$getInstance$1534ac94e2c195d6,
	&_jc_javax_net_ssl_SSLContext$method_info$getInstance$6355e0f0247fa191,
	&_jc_javax_net_ssl_SSLContext$method_info$getProtocol$b414d53f1c8ae478,
	&_jc_javax_net_ssl_SSLContext$method_info$getProvider$e8f9c9fb14140d5a,
	&_jc_javax_net_ssl_SSLContext$method_info$getServerSessionContext$5f5305151719e314,
	&_jc_javax_net_ssl_SSLContext$method_info$getServerSocketFactory$eb86151495edfc3e,
	&_jc_javax_net_ssl_SSLContext$method_info$getSocketFactory$ec3052bf27e7156d,
	&_jc_javax_net_ssl_SSLContext$method_info$init$1c26e3f86773b499
};

/************************************************************************
 *			  Class fields structure			*
 ************************************************************************/

_jc_javax_net_ssl_SSLContext$fields_struct _jc_javax_net_ssl_SSLContext$class_fields = { };

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_javax_net_ssl_SSLContext$instanceof_hash_bucket_56[] = {
	&_jc_javax_net_ssl_SSLContext$type,
	_JC_NULL
};
static _jc_type *const _jc_javax_net_ssl_SSLContext$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_javax_net_ssl_SSLContext$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[56]=	_jc_javax_net_ssl_SSLContext$instanceof_hash_bucket_56,
	[101]=	_jc_javax_net_ssl_SSLContext$instanceof_hash_bucket_101
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_javax_net_ssl_SSLContext$class_depends[] = {
	{ "gnu/java/security/Engine",	_JC_JLONG(0xf4ba095546954b36) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/ClassCastException",	_JC_JLONG(0xf02ab3ccb490a6d0) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/IllegalArgumentException",	_JC_JLONG(0x680cf34d05feb5a1) },
	{ "java/lang/IllegalStateException",	_JC_JLONG(0xb7e704701c278e65) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/RuntimeException",	_JC_JLONG(0x4f5534a987354d1d) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/lang/reflect/InvocationTargetException",	_JC_JLONG(0xae4a2342b31a268d) },
	{ "java/security/GeneralSecurityException",	_JC_JLONG(0x692089051f4c8d0b) },
	{ "java/security/KeyManagementException",	_JC_JLONG(0x97cf2ae63d0fc0df) },
	{ "java/security/NoSuchAlgorithmException",	_JC_JLONG(0x22e937c2536160b4) },
	{ "java/security/NoSuchProviderException",	_JC_JLONG(0x8dfbf242adab91e) },
	{ "java/security/Provider",	_JC_JLONG(0x81b073051aa30acc) },
	{ "java/security/SecureRandom",	_JC_JLONG(0x15c6a62b25a6e96d) },
	{ "java/security/Security",	_JC_JLONG(0x89bf77984bd9669e) },
	{ "java/util/Vector",	_JC_JLONG(0xc53e1575b095109b) },
	{ "javax/net/ssl/KeyManager",	_JC_JLONG(0xae254aeec477c06d) },
	{ "javax/net/ssl/SSLContextSpi",	_JC_JLONG(0x860bb69acbf20f89) },
	{ "javax/net/ssl/SSLServerSocketFactory",	_JC_JLONG(0xbe85d5901c8e527f) },
	{ "javax/net/ssl/SSLSessionContext",	_JC_JLONG(0x972ec9ade2b0b2ed) },
	{ "javax/net/ssl/SSLSocketFactory",	_JC_JLONG(0xeb7a976ef44a2e8c) },
	{ "javax/net/ssl/TrustManager",	_JC_JLONG(0x2fb5657d3f5b13e2) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_javax_net_ssl_SSLContext$vtype _jc_javax_net_ssl_SSLContext$type = {
    .type= {
	.name=			"javax/net/ssl/SSLContext",
	.superclass=		&_jc_java_lang_Object$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		18,
		.hash=			_JC_JLONG(0xa8abca7bf47f5338),
		.source_file=		"SSLContext.java",
		.instance_size=		sizeof(_jc_javax_net_ssl_SSLContext$refs) + sizeof(_jc_javax_net_ssl_SSLContext$object),
		.num_virtual_refs=	3,
		.num_fields=		sizeof(_jc_javax_net_ssl_SSLContext$fields) / sizeof(*_jc_javax_net_ssl_SSLContext$fields),
		.fields=		_jc_javax_net_ssl_SSLContext$fields,
		.num_methods=		sizeof(_jc_javax_net_ssl_SSLContext$methods) / sizeof(*_jc_javax_net_ssl_SSLContext$methods),
		.methods=		_jc_javax_net_ssl_SSLContext$methods,
		.instanceof_hash_table=	_jc_javax_net_ssl_SSLContext$instanceof_hash_table,
		.class_fields=		&_jc_javax_net_ssl_SSLContext$class_fields,
		.num_class_depends=		sizeof(_jc_javax_net_ssl_SSLContext$class_depends) / sizeof(*_jc_javax_net_ssl_SSLContext$class_depends),
		.class_depends=		_jc_javax_net_ssl_SSLContext$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.javax_net_ssl_SSLContext= {
	    .getClientSessionContext$b3a9bb24a977bd75=
		&_jc_javax_net_ssl_SSLContext$method$getClientSessionContext$b3a9bb24a977bd75,
	    .getProtocol$b414d53f1c8ae478=
		&_jc_javax_net_ssl_SSLContext$method$getProtocol$b414d53f1c8ae478,
	    .getProvider$e8f9c9fb14140d5a=
		&_jc_javax_net_ssl_SSLContext$method$getProvider$e8f9c9fb14140d5a,
	    .getServerSessionContext$5f5305151719e314=
		&_jc_javax_net_ssl_SSLContext$method$getServerSessionContext$5f5305151719e314,
	    .getServerSocketFactory$eb86151495edfc3e=
		&_jc_javax_net_ssl_SSLContext$method$getServerSocketFactory$eb86151495edfc3e,
	    .getSocketFactory$ec3052bf27e7156d=
		&_jc_javax_net_ssl_SSLContext$method$getSocketFactory$ec3052bf27e7156d,
	    .init$1c26e3f86773b499=
		&_jc_javax_net_ssl_SSLContext$method$init$1c26e3f86773b499,
	},
    }
};

