
/*
 * Copyright (C) 2003-2005 Archie L. Cobbs and others.
 * All rights reserved.
 * 
 * This file is part of the JC virtual machine software.
 * 
 * JC is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2.1 of the License,
 * or (at your option) any later version.
 * 
 * JC is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General
 * Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with JC in the file "LGPL-2.1"; if not, write to:
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * $Id: cfdump.h,v 1.2 2004/07/05 21:03:29 archiecobbs Exp $
 */

#ifndef _CFDUMP_H_
#define _CFDUMP_H_

#include "libjc.h"
#include <err.h>
#include <assert.h>

/* Flags */
#define DUMP_ENCODE_NAMES	0x0001
#define DUMP_TRANS_CLOSURE	0x0002
#define DUMP_SUPERS_ONLY	0x0004

extern void	do_deps(_jc_env *env, _jc_classfile *cf, int flags);
extern _jc_env	*_jc_support_init(void);

#endif	/* _CFDUMP_H_ */
