// public abstract interface org.ietf.jgss.GSSContext

// class file dependencies
// @dep_class 66aea4d152614ac4 java_io_InputStream
// @dep_class 4026d3144d6654d8 java_io_OutputStream
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 65d1d173dff3e647 org_ietf_jgss_ChannelBinding
// @dep_class 88468c2cc5954400 org_ietf_jgss_GSSContext
// @dep_class e20b9c3808e2155d org_ietf_jgss_GSSCredential
// @dep_class d82ad86895ee19c6 org_ietf_jgss_GSSException
// @dep_class fb9178e39855b48e org_ietf_jgss_GSSName
// @dep_class d50ffb07701ef7d1 org_ietf_jgss_MessageProp
// @dep_class feb3400b12072102 org_ietf_jgss_Oid

// header file dependencies
// @dep_header java_io_InputStream
// @dep_header java_io_OutputStream
// @dep_header java_lang_Class
// @dep_header java_lang_String
// @dep_header org_ietf_jgss_ChannelBinding
// @dep_header org_ietf_jgss_GSSContext
// @dep_header org_ietf_jgss_GSSCredential
// @dep_header org_ietf_jgss_GSSException
// @dep_header org_ietf_jgss_GSSName
// @dep_header org_ietf_jgss_MessageProp
// @dep_header org_ietf_jgss_Oid

#include "jc_defs.h"

#include "java/io/InputStream.h"
#include "java/io/OutputStream.h"
#include "java/lang/Class.h"
#include "java/lang/String.h"
#include "org/ietf/jgss/ChannelBinding.h"
#include "org/ietf/jgss/GSSContext.h"
#include "org/ietf/jgss/GSSCredential.h"
#include "org/ietf/jgss/GSSException.h"
#include "org/ietf/jgss/GSSName.h"
#include "org/ietf/jgss/MessageProp.h"
#include "org/ietf/jgss/Oid.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// public static final int DEFAULT_LIFETIME
static const jint _jc_org_ietf_jgss_GSSContext$initial_value$DEFAULT__5fLIFETIME = 0;
static _jc_field _jc_org_ietf_jgss_GSSContext$field_info$DEFAULT__5fLIFETIME = {
	.name=		"DEFAULT_LIFETIME",
	.signature=	"I",
	.class=		&_jc_org_ietf_jgss_GSSContext$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PUBLIC|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_org_ietf_jgss_GSSContext$fields_struct, DEFAULT__5fLIFETIME),
	.initial_value=	&_jc_org_ietf_jgss_GSSContext$initial_value$DEFAULT__5fLIFETIME,
};

// public static final int INDEFINITE_LIFETIME
static const jint _jc_org_ietf_jgss_GSSContext$initial_value$INDEFINITE__5fLIFETIME = 2147483647;
static _jc_field _jc_org_ietf_jgss_GSSContext$field_info$INDEFINITE__5fLIFETIME = {
	.name=		"INDEFINITE_LIFETIME",
	.signature=	"I",
	.class=		&_jc_org_ietf_jgss_GSSContext$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PUBLIC|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_org_ietf_jgss_GSSContext$fields_struct, INDEFINITE__5fLIFETIME),
	.initial_value=	&_jc_org_ietf_jgss_GSSContext$initial_value$INDEFINITE__5fLIFETIME,
};

// Fields
static _jc_field *const _jc_org_ietf_jgss_GSSContext$fields[] = {
	&_jc_org_ietf_jgss_GSSContext$field_info$DEFAULT__5fLIFETIME,
	&_jc_org_ietf_jgss_GSSContext$field_info$INDEFINITE__5fLIFETIME
};

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public abstract void acceptSecContext(java.io.InputStream, java.io.OutputStream) throws org.ietf.jgss.GSSException
//

static const unsigned char _jc_org_ietf_jgss_GSSContext$param_ptypes$acceptSecContext$42c8e289905846f3[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_org_ietf_jgss_GSSContext$exceptions$acceptSecContext$42c8e289905846f3[] = {
	&_jc_org_ietf_jgss_GSSException$type
};

static _jc_type *const _jc_org_ietf_jgss_GSSContext$param_types$acceptSecContext$42c8e289905846f3[] = {
	&_jc_java_io_InputStream$type,
	&_jc_java_io_OutputStream$type
};

_jc_method _jc_org_ietf_jgss_GSSContext$method_info$acceptSecContext$42c8e289905846f3 = {
	.name=			"acceptSecContext",
	.signature=		"(Ljava/io/InputStream;Ljava/io/OutputStream;)V",
	.class=			&_jc_org_ietf_jgss_GSSContext$type,
	.param_types=		&_jc_org_ietf_jgss_GSSContext$param_types$acceptSecContext$42c8e289905846f3,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_org_ietf_jgss_GSSContext$param_ptypes$acceptSecContext$42c8e289905846f3,
	.signature_hash=	_JC_JLONG(0x42c8e289905846f3),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_org_ietf_jgss_GSSContext$exceptions$acceptSecContext$42c8e289905846f3,
};

//
// public abstract byte[] acceptSecContext(byte[], int, int) throws org.ietf.jgss.GSSException
//

static const unsigned char _jc_org_ietf_jgss_GSSContext$param_ptypes$acceptSecContext$2f51c2fc6b605c4b[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_INT, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_org_ietf_jgss_GSSContext$exceptions$acceptSecContext$2f51c2fc6b605c4b[] = {
	&_jc_org_ietf_jgss_GSSException$type
};

static _jc_type *const _jc_org_ietf_jgss_GSSContext$param_types$acceptSecContext$2f51c2fc6b605c4b[] = {
	&_jc_byte$array$prim$type,
	&_jc_int$prim$type,
	&_jc_int$prim$type
};

_jc_method _jc_org_ietf_jgss_GSSContext$method_info$acceptSecContext$2f51c2fc6b605c4b = {
	.name=			"acceptSecContext",
	.signature=		"([BII)[B",
	.class=			&_jc_org_ietf_jgss_GSSContext$type,
	.param_types=		&_jc_org_ietf_jgss_GSSContext$param_types$acceptSecContext$2f51c2fc6b605c4b,
	.return_type=		&_jc_byte$array$prim$type,
	.param_ptypes=		&_jc_org_ietf_jgss_GSSContext$param_ptypes$acceptSecContext$2f51c2fc6b605c4b,
	.signature_hash=	_JC_JLONG(0x2f51c2fc6b605c4b),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	3,
	.num_exceptions=	1,
	.exceptions=		&_jc_org_ietf_jgss_GSSContext$exceptions$acceptSecContext$2f51c2fc6b605c4b,
};

//
// public abstract void dispose() throws org.ietf.jgss.GSSException
//

static const unsigned char _jc_org_ietf_jgss_GSSContext$param_ptypes$dispose$9d5b5b52b7878138[] = { 
_JC_TYPE_VOID };

static _jc_type *const _jc_org_ietf_jgss_GSSContext$exceptions$dispose$9d5b5b52b7878138[] = {
	&_jc_org_ietf_jgss_GSSException$type
};

_jc_method _jc_org_ietf_jgss_GSSContext$method_info$dispose$9d5b5b52b7878138 = {
	.name=			"dispose",
	.signature=		"()V",
	.class=			&_jc_org_ietf_jgss_GSSContext$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_org_ietf_jgss_GSSContext$param_ptypes$dispose$9d5b5b52b7878138,
	.signature_hash=	_JC_JLONG(0x9d5b5b52b7878138),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_org_ietf_jgss_GSSContext$exceptions$dispose$9d5b5b52b7878138,
};

//
// public abstract byte[] export() throws org.ietf.jgss.GSSException
//

static const unsigned char _jc_org_ietf_jgss_GSSContext$param_ptypes$export$71f4217a6b6773d8[] = { 
_JC_TYPE_REFERENCE };

static _jc_type *const _jc_org_ietf_jgss_GSSContext$exceptions$export$71f4217a6b6773d8[] = {
	&_jc_org_ietf_jgss_GSSException$type
};

_jc_method _jc_org_ietf_jgss_GSSContext$method_info$export$71f4217a6b6773d8 = {
	.name=			"export",
	.signature=		"()[B",
	.class=			&_jc_org_ietf_jgss_GSSContext$type,
	.return_type=		&_jc_byte$array$prim$type,
	.param_ptypes=		&_jc_org_ietf_jgss_GSSContext$param_ptypes$export$71f4217a6b6773d8,
	.signature_hash=	_JC_JLONG(0x71f4217a6b6773d8),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_org_ietf_jgss_GSSContext$exceptions$export$71f4217a6b6773d8,
};

//
// public abstract boolean getAnonymityState()
//

static const unsigned char _jc_org_ietf_jgss_GSSContext$param_ptypes$getAnonymityState$c744d364659ac273[] = { 
_JC_TYPE_BOOLEAN };

_jc_method _jc_org_ietf_jgss_GSSContext$method_info$getAnonymityState$c744d364659ac273 = {
	.name=			"getAnonymityState",
	.signature=		"()Z",
	.class=			&_jc_org_ietf_jgss_GSSContext$type,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_org_ietf_jgss_GSSContext$param_ptypes$getAnonymityState$c744d364659ac273,
	.signature_hash=	_JC_JLONG(0xc744d364659ac273),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract boolean getConfState()
//

static const unsigned char _jc_org_ietf_jgss_GSSContext$param_ptypes$getConfState$30b0b94f356769de[] = { 
_JC_TYPE_BOOLEAN };

_jc_method _jc_org_ietf_jgss_GSSContext$method_info$getConfState$30b0b94f356769de = {
	.name=			"getConfState",
	.signature=		"()Z",
	.class=			&_jc_org_ietf_jgss_GSSContext$type,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_org_ietf_jgss_GSSContext$param_ptypes$getConfState$30b0b94f356769de,
	.signature_hash=	_JC_JLONG(0x30b0b94f356769de),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract boolean getCredDelegState()
//

static const unsigned char _jc_org_ietf_jgss_GSSContext$param_ptypes$getCredDelegState$e947a27a9d6526c8[] = { 
_JC_TYPE_BOOLEAN };

_jc_method _jc_org_ietf_jgss_GSSContext$method_info$getCredDelegState$e947a27a9d6526c8 = {
	.name=			"getCredDelegState",
	.signature=		"()Z",
	.class=			&_jc_org_ietf_jgss_GSSContext$type,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_org_ietf_jgss_GSSContext$param_ptypes$getCredDelegState$e947a27a9d6526c8,
	.signature_hash=	_JC_JLONG(0xe947a27a9d6526c8),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract org.ietf.jgss.GSSCredential getDelegCred() throws org.ietf.jgss.GSSException
//

static const unsigned char _jc_org_ietf_jgss_GSSContext$param_ptypes$getDelegCred$a33043fc8163191f[] = { 
_JC_TYPE_REFERENCE };

static _jc_type *const _jc_org_ietf_jgss_GSSContext$exceptions$getDelegCred$a33043fc8163191f[] = {
	&_jc_org_ietf_jgss_GSSException$type
};

_jc_method _jc_org_ietf_jgss_GSSContext$method_info$getDelegCred$a33043fc8163191f = {
	.name=			"getDelegCred",
	.signature=		"()Lorg/ietf/jgss/GSSCredential;",
	.class=			&_jc_org_ietf_jgss_GSSContext$type,
	.return_type=		&_jc_org_ietf_jgss_GSSCredential$type,
	.param_ptypes=		&_jc_org_ietf_jgss_GSSContext$param_ptypes$getDelegCred$a33043fc8163191f,
	.signature_hash=	_JC_JLONG(0xa33043fc8163191f),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_org_ietf_jgss_GSSContext$exceptions$getDelegCred$a33043fc8163191f,
};

//
// public abstract boolean getIntegState()
//

static const unsigned char _jc_org_ietf_jgss_GSSContext$param_ptypes$getIntegState$74f4bcb5c4195d96[] = { 
_JC_TYPE_BOOLEAN };

_jc_method _jc_org_ietf_jgss_GSSContext$method_info$getIntegState$74f4bcb5c4195d96 = {
	.name=			"getIntegState",
	.signature=		"()Z",
	.class=			&_jc_org_ietf_jgss_GSSContext$type,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_org_ietf_jgss_GSSContext$param_ptypes$getIntegState$74f4bcb5c4195d96,
	.signature_hash=	_JC_JLONG(0x74f4bcb5c4195d96),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract int getLifetime()
//

static const unsigned char _jc_org_ietf_jgss_GSSContext$param_ptypes$getLifetime$477547c8c90a4164[] = { 
_JC_TYPE_INT };

_jc_method _jc_org_ietf_jgss_GSSContext$method_info$getLifetime$477547c8c90a4164 = {
	.name=			"getLifetime",
	.signature=		"()I",
	.class=			&_jc_org_ietf_jgss_GSSContext$type,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_org_ietf_jgss_GSSContext$param_ptypes$getLifetime$477547c8c90a4164,
	.signature_hash=	_JC_JLONG(0x477547c8c90a4164),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract void getMIC(java.io.InputStream, java.io.OutputStream, org.ietf.jgss.MessageProp) throws org.ietf.jgss.GSSException
//

static const unsigned char _jc_org_ietf_jgss_GSSContext$param_ptypes$getMIC$7a65038cd7987ad2[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_org_ietf_jgss_GSSContext$exceptions$getMIC$7a65038cd7987ad2[] = {
	&_jc_org_ietf_jgss_GSSException$type
};

static _jc_type *const _jc_org_ietf_jgss_GSSContext$param_types$getMIC$7a65038cd7987ad2[] = {
	&_jc_java_io_InputStream$type,
	&_jc_java_io_OutputStream$type,
	&_jc_org_ietf_jgss_MessageProp$type
};

_jc_method _jc_org_ietf_jgss_GSSContext$method_info$getMIC$7a65038cd7987ad2 = {
	.name=			"getMIC",
	.signature=		"(Ljava/io/InputStream;Ljava/io/OutputStream;Lorg/ietf/jgss/MessageProp;)V",
	.class=			&_jc_org_ietf_jgss_GSSContext$type,
	.param_types=		&_jc_org_ietf_jgss_GSSContext$param_types$getMIC$7a65038cd7987ad2,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_org_ietf_jgss_GSSContext$param_ptypes$getMIC$7a65038cd7987ad2,
	.signature_hash=	_JC_JLONG(0x7a65038cd7987ad2),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	3,
	.num_exceptions=	1,
	.exceptions=		&_jc_org_ietf_jgss_GSSContext$exceptions$getMIC$7a65038cd7987ad2,
};

//
// public abstract byte[] getMIC(byte[], int, int, org.ietf.jgss.MessageProp) throws org.ietf.jgss.GSSException
//

static const unsigned char _jc_org_ietf_jgss_GSSContext$param_ptypes$getMIC$07d4f1c3847477f2[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_INT, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_org_ietf_jgss_GSSContext$exceptions$getMIC$07d4f1c3847477f2[] = {
	&_jc_org_ietf_jgss_GSSException$type
};

static _jc_type *const _jc_org_ietf_jgss_GSSContext$param_types$getMIC$07d4f1c3847477f2[] = {
	&_jc_byte$array$prim$type,
	&_jc_int$prim$type,
	&_jc_int$prim$type,
	&_jc_org_ietf_jgss_MessageProp$type
};

_jc_method _jc_org_ietf_jgss_GSSContext$method_info$getMIC$07d4f1c3847477f2 = {
	.name=			"getMIC",
	.signature=		"([BIILorg/ietf/jgss/MessageProp;)[B",
	.class=			&_jc_org_ietf_jgss_GSSContext$type,
	.param_types=		&_jc_org_ietf_jgss_GSSContext$param_types$getMIC$07d4f1c3847477f2,
	.return_type=		&_jc_byte$array$prim$type,
	.param_ptypes=		&_jc_org_ietf_jgss_GSSContext$param_ptypes$getMIC$07d4f1c3847477f2,
	.signature_hash=	_JC_JLONG(0x7d4f1c3847477f2),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	4,
	.num_exceptions=	1,
	.exceptions=		&_jc_org_ietf_jgss_GSSContext$exceptions$getMIC$07d4f1c3847477f2,
};

//
// public abstract org.ietf.jgss.Oid getMech() throws org.ietf.jgss.GSSException
//

static const unsigned char _jc_org_ietf_jgss_GSSContext$param_ptypes$getMech$06d5881e565b3c56[] = { 
_JC_TYPE_REFERENCE };

static _jc_type *const _jc_org_ietf_jgss_GSSContext$exceptions$getMech$06d5881e565b3c56[] = {
	&_jc_org_ietf_jgss_GSSException$type
};

_jc_method _jc_org_ietf_jgss_GSSContext$method_info$getMech$06d5881e565b3c56 = {
	.name=			"getMech",
	.signature=		"()Lorg/ietf/jgss/Oid;",
	.class=			&_jc_org_ietf_jgss_GSSContext$type,
	.return_type=		&_jc_org_ietf_jgss_Oid$type,
	.param_ptypes=		&_jc_org_ietf_jgss_GSSContext$param_ptypes$getMech$06d5881e565b3c56,
	.signature_hash=	_JC_JLONG(0x6d5881e565b3c56),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_org_ietf_jgss_GSSContext$exceptions$getMech$06d5881e565b3c56,
};

//
// public abstract boolean getMutualAuthState()
//

static const unsigned char _jc_org_ietf_jgss_GSSContext$param_ptypes$getMutualAuthState$c083c12d00270426[] = { 
_JC_TYPE_BOOLEAN };

_jc_method _jc_org_ietf_jgss_GSSContext$method_info$getMutualAuthState$c083c12d00270426 = {
	.name=			"getMutualAuthState",
	.signature=		"()Z",
	.class=			&_jc_org_ietf_jgss_GSSContext$type,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_org_ietf_jgss_GSSContext$param_ptypes$getMutualAuthState$c083c12d00270426,
	.signature_hash=	_JC_JLONG(0xc083c12d00270426),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract boolean getReplayDetState()
//

static const unsigned char _jc_org_ietf_jgss_GSSContext$param_ptypes$getReplayDetState$1ca526d7699ec2c5[] = { 
_JC_TYPE_BOOLEAN };

_jc_method _jc_org_ietf_jgss_GSSContext$method_info$getReplayDetState$1ca526d7699ec2c5 = {
	.name=			"getReplayDetState",
	.signature=		"()Z",
	.class=			&_jc_org_ietf_jgss_GSSContext$type,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_org_ietf_jgss_GSSContext$param_ptypes$getReplayDetState$1ca526d7699ec2c5,
	.signature_hash=	_JC_JLONG(0x1ca526d7699ec2c5),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract boolean getSequenceDetState()
//

static const unsigned char _jc_org_ietf_jgss_GSSContext$param_ptypes$getSequenceDetState$f93c288298cd8da3[] = { 
_JC_TYPE_BOOLEAN };

_jc_method _jc_org_ietf_jgss_GSSContext$method_info$getSequenceDetState$f93c288298cd8da3 = {
	.name=			"getSequenceDetState",
	.signature=		"()Z",
	.class=			&_jc_org_ietf_jgss_GSSContext$type,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_org_ietf_jgss_GSSContext$param_ptypes$getSequenceDetState$f93c288298cd8da3,
	.signature_hash=	_JC_JLONG(0xf93c288298cd8da3),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract org.ietf.jgss.GSSName getSrcName() throws org.ietf.jgss.GSSException
//

static const unsigned char _jc_org_ietf_jgss_GSSContext$param_ptypes$getSrcName$5b21b97886c43d58[] = { 
_JC_TYPE_REFERENCE };

static _jc_type *const _jc_org_ietf_jgss_GSSContext$exceptions$getSrcName$5b21b97886c43d58[] = {
	&_jc_org_ietf_jgss_GSSException$type
};

_jc_method _jc_org_ietf_jgss_GSSContext$method_info$getSrcName$5b21b97886c43d58 = {
	.name=			"getSrcName",
	.signature=		"()Lorg/ietf/jgss/GSSName;",
	.class=			&_jc_org_ietf_jgss_GSSContext$type,
	.return_type=		&_jc_org_ietf_jgss_GSSName$type,
	.param_ptypes=		&_jc_org_ietf_jgss_GSSContext$param_ptypes$getSrcName$5b21b97886c43d58,
	.signature_hash=	_JC_JLONG(0x5b21b97886c43d58),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_org_ietf_jgss_GSSContext$exceptions$getSrcName$5b21b97886c43d58,
};

//
// public abstract org.ietf.jgss.GSSName getTargName() throws org.ietf.jgss.GSSException
//

static const unsigned char _jc_org_ietf_jgss_GSSContext$param_ptypes$getTargName$1177bdc7aabbd167[] = { 
_JC_TYPE_REFERENCE };

static _jc_type *const _jc_org_ietf_jgss_GSSContext$exceptions$getTargName$1177bdc7aabbd167[] = {
	&_jc_org_ietf_jgss_GSSException$type
};

_jc_method _jc_org_ietf_jgss_GSSContext$method_info$getTargName$1177bdc7aabbd167 = {
	.name=			"getTargName",
	.signature=		"()Lorg/ietf/jgss/GSSName;",
	.class=			&_jc_org_ietf_jgss_GSSContext$type,
	.return_type=		&_jc_org_ietf_jgss_GSSName$type,
	.param_ptypes=		&_jc_org_ietf_jgss_GSSContext$param_ptypes$getTargName$1177bdc7aabbd167,
	.signature_hash=	_JC_JLONG(0x1177bdc7aabbd167),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_org_ietf_jgss_GSSContext$exceptions$getTargName$1177bdc7aabbd167,
};

//
// public abstract int getWrapSizeLimit(int, boolean, int) throws org.ietf.jgss.GSSException
//

static const unsigned char _jc_org_ietf_jgss_GSSContext$param_ptypes$getWrapSizeLimit$3ba0e982ee160f6a[] = { 
_JC_TYPE_INT, _JC_TYPE_BOOLEAN, _JC_TYPE_INT, _JC_TYPE_INT };

static _jc_type *const _jc_org_ietf_jgss_GSSContext$exceptions$getWrapSizeLimit$3ba0e982ee160f6a[] = {
	&_jc_org_ietf_jgss_GSSException$type
};

static _jc_type *const _jc_org_ietf_jgss_GSSContext$param_types$getWrapSizeLimit$3ba0e982ee160f6a[] = {
	&_jc_int$prim$type,
	&_jc_boolean$prim$type,
	&_jc_int$prim$type
};

_jc_method _jc_org_ietf_jgss_GSSContext$method_info$getWrapSizeLimit$3ba0e982ee160f6a = {
	.name=			"getWrapSizeLimit",
	.signature=		"(IZI)I",
	.class=			&_jc_org_ietf_jgss_GSSContext$type,
	.param_types=		&_jc_org_ietf_jgss_GSSContext$param_types$getWrapSizeLimit$3ba0e982ee160f6a,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_org_ietf_jgss_GSSContext$param_ptypes$getWrapSizeLimit$3ba0e982ee160f6a,
	.signature_hash=	_JC_JLONG(0x3ba0e982ee160f6a),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	3,
	.num_exceptions=	1,
	.exceptions=		&_jc_org_ietf_jgss_GSSContext$exceptions$getWrapSizeLimit$3ba0e982ee160f6a,
};

//
// public abstract int initSecContext(java.io.InputStream, java.io.OutputStream) throws org.ietf.jgss.GSSException
//

static const unsigned char _jc_org_ietf_jgss_GSSContext$param_ptypes$initSecContext$78a79aef5edd3fd2[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_INT };

static _jc_type *const _jc_org_ietf_jgss_GSSContext$exceptions$initSecContext$78a79aef5edd3fd2[] = {
	&_jc_org_ietf_jgss_GSSException$type
};

static _jc_type *const _jc_org_ietf_jgss_GSSContext$param_types$initSecContext$78a79aef5edd3fd2[] = {
	&_jc_java_io_InputStream$type,
	&_jc_java_io_OutputStream$type
};

_jc_method _jc_org_ietf_jgss_GSSContext$method_info$initSecContext$78a79aef5edd3fd2 = {
	.name=			"initSecContext",
	.signature=		"(Ljava/io/InputStream;Ljava/io/OutputStream;)I",
	.class=			&_jc_org_ietf_jgss_GSSContext$type,
	.param_types=		&_jc_org_ietf_jgss_GSSContext$param_types$initSecContext$78a79aef5edd3fd2,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_org_ietf_jgss_GSSContext$param_ptypes$initSecContext$78a79aef5edd3fd2,
	.signature_hash=	_JC_JLONG(0x78a79aef5edd3fd2),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_org_ietf_jgss_GSSContext$exceptions$initSecContext$78a79aef5edd3fd2,
};

//
// public abstract byte[] initSecContext(byte[], int, int) throws org.ietf.jgss.GSSException
//

static const unsigned char _jc_org_ietf_jgss_GSSContext$param_ptypes$initSecContext$ff172f567929efe3[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_INT, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_org_ietf_jgss_GSSContext$exceptions$initSecContext$ff172f567929efe3[] = {
	&_jc_org_ietf_jgss_GSSException$type
};

static _jc_type *const _jc_org_ietf_jgss_GSSContext$param_types$initSecContext$ff172f567929efe3[] = {
	&_jc_byte$array$prim$type,
	&_jc_int$prim$type,
	&_jc_int$prim$type
};

_jc_method _jc_org_ietf_jgss_GSSContext$method_info$initSecContext$ff172f567929efe3 = {
	.name=			"initSecContext",
	.signature=		"([BII)[B",
	.class=			&_jc_org_ietf_jgss_GSSContext$type,
	.param_types=		&_jc_org_ietf_jgss_GSSContext$param_types$initSecContext$ff172f567929efe3,
	.return_type=		&_jc_byte$array$prim$type,
	.param_ptypes=		&_jc_org_ietf_jgss_GSSContext$param_ptypes$initSecContext$ff172f567929efe3,
	.signature_hash=	_JC_JLONG(0xff172f567929efe3),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	3,
	.num_exceptions=	1,
	.exceptions=		&_jc_org_ietf_jgss_GSSContext$exceptions$initSecContext$ff172f567929efe3,
};

//
// public abstract boolean isEstablished()
//

static const unsigned char _jc_org_ietf_jgss_GSSContext$param_ptypes$isEstablished$d0e06d57395880bc[] = { 
_JC_TYPE_BOOLEAN };

_jc_method _jc_org_ietf_jgss_GSSContext$method_info$isEstablished$d0e06d57395880bc = {
	.name=			"isEstablished",
	.signature=		"()Z",
	.class=			&_jc_org_ietf_jgss_GSSContext$type,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_org_ietf_jgss_GSSContext$param_ptypes$isEstablished$d0e06d57395880bc,
	.signature_hash=	_JC_JLONG(0xd0e06d57395880bc),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract boolean isInitiator() throws org.ietf.jgss.GSSException
//

static const unsigned char _jc_org_ietf_jgss_GSSContext$param_ptypes$isInitiator$54dc4ec8cca0fbbb[] = { 
_JC_TYPE_BOOLEAN };

static _jc_type *const _jc_org_ietf_jgss_GSSContext$exceptions$isInitiator$54dc4ec8cca0fbbb[] = {
	&_jc_org_ietf_jgss_GSSException$type
};

_jc_method _jc_org_ietf_jgss_GSSContext$method_info$isInitiator$54dc4ec8cca0fbbb = {
	.name=			"isInitiator",
	.signature=		"()Z",
	.class=			&_jc_org_ietf_jgss_GSSContext$type,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_org_ietf_jgss_GSSContext$param_ptypes$isInitiator$54dc4ec8cca0fbbb,
	.signature_hash=	_JC_JLONG(0x54dc4ec8cca0fbbb),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_org_ietf_jgss_GSSContext$exceptions$isInitiator$54dc4ec8cca0fbbb,
};

//
// public abstract boolean isProtReady()
//

static const unsigned char _jc_org_ietf_jgss_GSSContext$param_ptypes$isProtReady$3f5cafdf854861a8[] = { 
_JC_TYPE_BOOLEAN };

_jc_method _jc_org_ietf_jgss_GSSContext$method_info$isProtReady$3f5cafdf854861a8 = {
	.name=			"isProtReady",
	.signature=		"()Z",
	.class=			&_jc_org_ietf_jgss_GSSContext$type,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_org_ietf_jgss_GSSContext$param_ptypes$isProtReady$3f5cafdf854861a8,
	.signature_hash=	_JC_JLONG(0x3f5cafdf854861a8),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract boolean isTransferable() throws org.ietf.jgss.GSSException
//

static const unsigned char _jc_org_ietf_jgss_GSSContext$param_ptypes$isTransferable$e5c1ee4e1d4dea64[] = { 
_JC_TYPE_BOOLEAN };

static _jc_type *const _jc_org_ietf_jgss_GSSContext$exceptions$isTransferable$e5c1ee4e1d4dea64[] = {
	&_jc_org_ietf_jgss_GSSException$type
};

_jc_method _jc_org_ietf_jgss_GSSContext$method_info$isTransferable$e5c1ee4e1d4dea64 = {
	.name=			"isTransferable",
	.signature=		"()Z",
	.class=			&_jc_org_ietf_jgss_GSSContext$type,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_org_ietf_jgss_GSSContext$param_ptypes$isTransferable$e5c1ee4e1d4dea64,
	.signature_hash=	_JC_JLONG(0xe5c1ee4e1d4dea64),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_org_ietf_jgss_GSSContext$exceptions$isTransferable$e5c1ee4e1d4dea64,
};

//
// public abstract void requestAnonymity(boolean) throws org.ietf.jgss.GSSException
//

static const unsigned char _jc_org_ietf_jgss_GSSContext$param_ptypes$requestAnonymity$a03adbb6291fb75c[] = { 
_JC_TYPE_BOOLEAN, _JC_TYPE_VOID };

static _jc_type *const _jc_org_ietf_jgss_GSSContext$exceptions$requestAnonymity$a03adbb6291fb75c[] = {
	&_jc_org_ietf_jgss_GSSException$type
};

static _jc_type *const _jc_org_ietf_jgss_GSSContext$param_types$requestAnonymity$a03adbb6291fb75c[] = {
	&_jc_boolean$prim$type
};

_jc_method _jc_org_ietf_jgss_GSSContext$method_info$requestAnonymity$a03adbb6291fb75c = {
	.name=			"requestAnonymity",
	.signature=		"(Z)V",
	.class=			&_jc_org_ietf_jgss_GSSContext$type,
	.param_types=		&_jc_org_ietf_jgss_GSSContext$param_types$requestAnonymity$a03adbb6291fb75c,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_org_ietf_jgss_GSSContext$param_ptypes$requestAnonymity$a03adbb6291fb75c,
	.signature_hash=	_JC_JLONG(0xa03adbb6291fb75c),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_org_ietf_jgss_GSSContext$exceptions$requestAnonymity$a03adbb6291fb75c,
};

//
// public abstract void requestConf(boolean) throws org.ietf.jgss.GSSException
//

static const unsigned char _jc_org_ietf_jgss_GSSContext$param_ptypes$requestConf$11b9d52f506c7534[] = { 
_JC_TYPE_BOOLEAN, _JC_TYPE_VOID };

static _jc_type *const _jc_org_ietf_jgss_GSSContext$exceptions$requestConf$11b9d52f506c7534[] = {
	&_jc_org_ietf_jgss_GSSException$type
};

static _jc_type *const _jc_org_ietf_jgss_GSSContext$param_types$requestConf$11b9d52f506c7534[] = {
	&_jc_boolean$prim$type
};

_jc_method _jc_org_ietf_jgss_GSSContext$method_info$requestConf$11b9d52f506c7534 = {
	.name=			"requestConf",
	.signature=		"(Z)V",
	.class=			&_jc_org_ietf_jgss_GSSContext$type,
	.param_types=		&_jc_org_ietf_jgss_GSSContext$param_types$requestConf$11b9d52f506c7534,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_org_ietf_jgss_GSSContext$param_ptypes$requestConf$11b9d52f506c7534,
	.signature_hash=	_JC_JLONG(0x11b9d52f506c7534),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_org_ietf_jgss_GSSContext$exceptions$requestConf$11b9d52f506c7534,
};

//
// public abstract void requestCredDeleg(boolean) throws org.ietf.jgss.GSSException
//

static const unsigned char _jc_org_ietf_jgss_GSSContext$param_ptypes$requestCredDeleg$8220b1c831a285b9[] = { 
_JC_TYPE_BOOLEAN, _JC_TYPE_VOID };

static _jc_type *const _jc_org_ietf_jgss_GSSContext$exceptions$requestCredDeleg$8220b1c831a285b9[] = {
	&_jc_org_ietf_jgss_GSSException$type
};

static _jc_type *const _jc_org_ietf_jgss_GSSContext$param_types$requestCredDeleg$8220b1c831a285b9[] = {
	&_jc_boolean$prim$type
};

_jc_method _jc_org_ietf_jgss_GSSContext$method_info$requestCredDeleg$8220b1c831a285b9 = {
	.name=			"requestCredDeleg",
	.signature=		"(Z)V",
	.class=			&_jc_org_ietf_jgss_GSSContext$type,
	.param_types=		&_jc_org_ietf_jgss_GSSContext$param_types$requestCredDeleg$8220b1c831a285b9,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_org_ietf_jgss_GSSContext$param_ptypes$requestCredDeleg$8220b1c831a285b9,
	.signature_hash=	_JC_JLONG(0x8220b1c831a285b9),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_org_ietf_jgss_GSSContext$exceptions$requestCredDeleg$8220b1c831a285b9,
};

//
// public abstract void requestInteg(boolean) throws org.ietf.jgss.GSSException
//

static const unsigned char _jc_org_ietf_jgss_GSSContext$param_ptypes$requestInteg$19ecb54347936d31[] = { 
_JC_TYPE_BOOLEAN, _JC_TYPE_VOID };

static _jc_type *const _jc_org_ietf_jgss_GSSContext$exceptions$requestInteg$19ecb54347936d31[] = {
	&_jc_org_ietf_jgss_GSSException$type
};

static _jc_type *const _jc_org_ietf_jgss_GSSContext$param_types$requestInteg$19ecb54347936d31[] = {
	&_jc_boolean$prim$type
};

_jc_method _jc_org_ietf_jgss_GSSContext$method_info$requestInteg$19ecb54347936d31 = {
	.name=			"requestInteg",
	.signature=		"(Z)V",
	.class=			&_jc_org_ietf_jgss_GSSContext$type,
	.param_types=		&_jc_org_ietf_jgss_GSSContext$param_types$requestInteg$19ecb54347936d31,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_org_ietf_jgss_GSSContext$param_ptypes$requestInteg$19ecb54347936d31,
	.signature_hash=	_JC_JLONG(0x19ecb54347936d31),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_org_ietf_jgss_GSSContext$exceptions$requestInteg$19ecb54347936d31,
};

//
// public abstract void requestLifetime(int) throws org.ietf.jgss.GSSException
//

static const unsigned char _jc_org_ietf_jgss_GSSContext$param_ptypes$requestLifetime$dcb6f0f32fb5e14a[] = { 
_JC_TYPE_INT, _JC_TYPE_VOID };

static _jc_type *const _jc_org_ietf_jgss_GSSContext$exceptions$requestLifetime$dcb6f0f32fb5e14a[] = {
	&_jc_org_ietf_jgss_GSSException$type
};

static _jc_type *const _jc_org_ietf_jgss_GSSContext$param_types$requestLifetime$dcb6f0f32fb5e14a[] = {
	&_jc_int$prim$type
};

_jc_method _jc_org_ietf_jgss_GSSContext$method_info$requestLifetime$dcb6f0f32fb5e14a = {
	.name=			"requestLifetime",
	.signature=		"(I)V",
	.class=			&_jc_org_ietf_jgss_GSSContext$type,
	.param_types=		&_jc_org_ietf_jgss_GSSContext$param_types$requestLifetime$dcb6f0f32fb5e14a,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_org_ietf_jgss_GSSContext$param_ptypes$requestLifetime$dcb6f0f32fb5e14a,
	.signature_hash=	_JC_JLONG(0xdcb6f0f32fb5e14a),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_org_ietf_jgss_GSSContext$exceptions$requestLifetime$dcb6f0f32fb5e14a,
};

//
// public abstract void requestMutualAuth(boolean) throws org.ietf.jgss.GSSException
//

static const unsigned char _jc_org_ietf_jgss_GSSContext$param_ptypes$requestMutualAuth$9a2ed11a8e4b0b00[] = { 
_JC_TYPE_BOOLEAN, _JC_TYPE_VOID };

static _jc_type *const _jc_org_ietf_jgss_GSSContext$exceptions$requestMutualAuth$9a2ed11a8e4b0b00[] = {
	&_jc_org_ietf_jgss_GSSException$type
};

static _jc_type *const _jc_org_ietf_jgss_GSSContext$param_types$requestMutualAuth$9a2ed11a8e4b0b00[] = {
	&_jc_boolean$prim$type
};

_jc_method _jc_org_ietf_jgss_GSSContext$method_info$requestMutualAuth$9a2ed11a8e4b0b00 = {
	.name=			"requestMutualAuth",
	.signature=		"(Z)V",
	.class=			&_jc_org_ietf_jgss_GSSContext$type,
	.param_types=		&_jc_org_ietf_jgss_GSSContext$param_types$requestMutualAuth$9a2ed11a8e4b0b00,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_org_ietf_jgss_GSSContext$param_ptypes$requestMutualAuth$9a2ed11a8e4b0b00,
	.signature_hash=	_JC_JLONG(0x9a2ed11a8e4b0b00),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_org_ietf_jgss_GSSContext$exceptions$requestMutualAuth$9a2ed11a8e4b0b00,
};

//
// public abstract void requestReplayDet(boolean) throws org.ietf.jgss.GSSException
//

static const unsigned char _jc_org_ietf_jgss_GSSContext$param_ptypes$requestReplayDet$2f6c35372f357339[] = { 
_JC_TYPE_BOOLEAN, _JC_TYPE_VOID };

static _jc_type *const _jc_org_ietf_jgss_GSSContext$exceptions$requestReplayDet$2f6c35372f357339[] = {
	&_jc_org_ietf_jgss_GSSException$type
};

static _jc_type *const _jc_org_ietf_jgss_GSSContext$param_types$requestReplayDet$2f6c35372f357339[] = {
	&_jc_boolean$prim$type
};

_jc_method _jc_org_ietf_jgss_GSSContext$method_info$requestReplayDet$2f6c35372f357339 = {
	.name=			"requestReplayDet",
	.signature=		"(Z)V",
	.class=			&_jc_org_ietf_jgss_GSSContext$type,
	.param_types=		&_jc_org_ietf_jgss_GSSContext$param_types$requestReplayDet$2f6c35372f357339,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_org_ietf_jgss_GSSContext$param_ptypes$requestReplayDet$2f6c35372f357339,
	.signature_hash=	_JC_JLONG(0x2f6c35372f357339),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_org_ietf_jgss_GSSContext$exceptions$requestReplayDet$2f6c35372f357339,
};

//
// public abstract void requestSequenceDet(boolean) throws org.ietf.jgss.GSSException
//

static const unsigned char _jc_org_ietf_jgss_GSSContext$param_ptypes$requestSequenceDet$ef10c008b3b9c54d[] = { 
_JC_TYPE_BOOLEAN, _JC_TYPE_VOID };

static _jc_type *const _jc_org_ietf_jgss_GSSContext$exceptions$requestSequenceDet$ef10c008b3b9c54d[] = {
	&_jc_org_ietf_jgss_GSSException$type
};

static _jc_type *const _jc_org_ietf_jgss_GSSContext$param_types$requestSequenceDet$ef10c008b3b9c54d[] = {
	&_jc_boolean$prim$type
};

_jc_method _jc_org_ietf_jgss_GSSContext$method_info$requestSequenceDet$ef10c008b3b9c54d = {
	.name=			"requestSequenceDet",
	.signature=		"(Z)V",
	.class=			&_jc_org_ietf_jgss_GSSContext$type,
	.param_types=		&_jc_org_ietf_jgss_GSSContext$param_types$requestSequenceDet$ef10c008b3b9c54d,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_org_ietf_jgss_GSSContext$param_ptypes$requestSequenceDet$ef10c008b3b9c54d,
	.signature_hash=	_JC_JLONG(0xef10c008b3b9c54d),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_org_ietf_jgss_GSSContext$exceptions$requestSequenceDet$ef10c008b3b9c54d,
};

//
// public abstract void setChannelBinding(org.ietf.jgss.ChannelBinding) throws org.ietf.jgss.GSSException
//

static const unsigned char _jc_org_ietf_jgss_GSSContext$param_ptypes$setChannelBinding$1ec4e304aef17c38[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_org_ietf_jgss_GSSContext$exceptions$setChannelBinding$1ec4e304aef17c38[] = {
	&_jc_org_ietf_jgss_GSSException$type
};

static _jc_type *const _jc_org_ietf_jgss_GSSContext$param_types$setChannelBinding$1ec4e304aef17c38[] = {
	&_jc_org_ietf_jgss_ChannelBinding$type
};

_jc_method _jc_org_ietf_jgss_GSSContext$method_info$setChannelBinding$1ec4e304aef17c38 = {
	.name=			"setChannelBinding",
	.signature=		"(Lorg/ietf/jgss/ChannelBinding;)V",
	.class=			&_jc_org_ietf_jgss_GSSContext$type,
	.param_types=		&_jc_org_ietf_jgss_GSSContext$param_types$setChannelBinding$1ec4e304aef17c38,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_org_ietf_jgss_GSSContext$param_ptypes$setChannelBinding$1ec4e304aef17c38,
	.signature_hash=	_JC_JLONG(0x1ec4e304aef17c38),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_org_ietf_jgss_GSSContext$exceptions$setChannelBinding$1ec4e304aef17c38,
};

//
// public abstract void unwrap(java.io.InputStream, java.io.OutputStream, org.ietf.jgss.MessageProp) throws org.ietf.jgss.GSSException
//

static const unsigned char _jc_org_ietf_jgss_GSSContext$param_ptypes$unwrap$f43f830679bc0de1[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_org_ietf_jgss_GSSContext$exceptions$unwrap$f43f830679bc0de1[] = {
	&_jc_org_ietf_jgss_GSSException$type
};

static _jc_type *const _jc_org_ietf_jgss_GSSContext$param_types$unwrap$f43f830679bc0de1[] = {
	&_jc_java_io_InputStream$type,
	&_jc_java_io_OutputStream$type,
	&_jc_org_ietf_jgss_MessageProp$type
};

_jc_method _jc_org_ietf_jgss_GSSContext$method_info$unwrap$f43f830679bc0de1 = {
	.name=			"unwrap",
	.signature=		"(Ljava/io/InputStream;Ljava/io/OutputStream;Lorg/ietf/jgss/MessageProp;)V",
	.class=			&_jc_org_ietf_jgss_GSSContext$type,
	.param_types=		&_jc_org_ietf_jgss_GSSContext$param_types$unwrap$f43f830679bc0de1,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_org_ietf_jgss_GSSContext$param_ptypes$unwrap$f43f830679bc0de1,
	.signature_hash=	_JC_JLONG(0xf43f830679bc0de1),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	3,
	.num_exceptions=	1,
	.exceptions=		&_jc_org_ietf_jgss_GSSContext$exceptions$unwrap$f43f830679bc0de1,
};

//
// public abstract byte[] unwrap(byte[], int, int, org.ietf.jgss.MessageProp) throws org.ietf.jgss.GSSException
//

static const unsigned char _jc_org_ietf_jgss_GSSContext$param_ptypes$unwrap$f7e97f08619ac296[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_INT, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_org_ietf_jgss_GSSContext$exceptions$unwrap$f7e97f08619ac296[] = {
	&_jc_org_ietf_jgss_GSSException$type
};

static _jc_type *const _jc_org_ietf_jgss_GSSContext$param_types$unwrap$f7e97f08619ac296[] = {
	&_jc_byte$array$prim$type,
	&_jc_int$prim$type,
	&_jc_int$prim$type,
	&_jc_org_ietf_jgss_MessageProp$type
};

_jc_method _jc_org_ietf_jgss_GSSContext$method_info$unwrap$f7e97f08619ac296 = {
	.name=			"unwrap",
	.signature=		"([BIILorg/ietf/jgss/MessageProp;)[B",
	.class=			&_jc_org_ietf_jgss_GSSContext$type,
	.param_types=		&_jc_org_ietf_jgss_GSSContext$param_types$unwrap$f7e97f08619ac296,
	.return_type=		&_jc_byte$array$prim$type,
	.param_ptypes=		&_jc_org_ietf_jgss_GSSContext$param_ptypes$unwrap$f7e97f08619ac296,
	.signature_hash=	_JC_JLONG(0xf7e97f08619ac296),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	4,
	.num_exceptions=	1,
	.exceptions=		&_jc_org_ietf_jgss_GSSContext$exceptions$unwrap$f7e97f08619ac296,
};

//
// public abstract void verifyMIC(java.io.InputStream, java.io.InputStream, org.ietf.jgss.MessageProp) throws org.ietf.jgss.GSSException
//

static const unsigned char _jc_org_ietf_jgss_GSSContext$param_ptypes$verifyMIC$9605e84d24d0622f[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_org_ietf_jgss_GSSContext$exceptions$verifyMIC$9605e84d24d0622f[] = {
	&_jc_org_ietf_jgss_GSSException$type
};

static _jc_type *const _jc_org_ietf_jgss_GSSContext$param_types$verifyMIC$9605e84d24d0622f[] = {
	&_jc_java_io_InputStream$type,
	&_jc_java_io_InputStream$type,
	&_jc_org_ietf_jgss_MessageProp$type
};

_jc_method _jc_org_ietf_jgss_GSSContext$method_info$verifyMIC$9605e84d24d0622f = {
	.name=			"verifyMIC",
	.signature=		"(Ljava/io/InputStream;Ljava/io/InputStream;Lorg/ietf/jgss/MessageProp;)V",
	.class=			&_jc_org_ietf_jgss_GSSContext$type,
	.param_types=		&_jc_org_ietf_jgss_GSSContext$param_types$verifyMIC$9605e84d24d0622f,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_org_ietf_jgss_GSSContext$param_ptypes$verifyMIC$9605e84d24d0622f,
	.signature_hash=	_JC_JLONG(0x9605e84d24d0622f),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	3,
	.num_exceptions=	1,
	.exceptions=		&_jc_org_ietf_jgss_GSSContext$exceptions$verifyMIC$9605e84d24d0622f,
};

//
// public abstract void verifyMIC(byte[], int, int, byte[], int, int, org.ietf.jgss.MessageProp) throws org.ietf.jgss.GSSException
//

static const unsigned char _jc_org_ietf_jgss_GSSContext$param_ptypes$verifyMIC$91c9dee7dadce0e0[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_INT, _JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_INT, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_org_ietf_jgss_GSSContext$exceptions$verifyMIC$91c9dee7dadce0e0[] = {
	&_jc_org_ietf_jgss_GSSException$type
};

static _jc_type *const _jc_org_ietf_jgss_GSSContext$param_types$verifyMIC$91c9dee7dadce0e0[] = {
	&_jc_byte$array$prim$type,
	&_jc_int$prim$type,
	&_jc_int$prim$type,
	&_jc_byte$array$prim$type,
	&_jc_int$prim$type,
	&_jc_int$prim$type,
	&_jc_org_ietf_jgss_MessageProp$type
};

_jc_method _jc_org_ietf_jgss_GSSContext$method_info$verifyMIC$91c9dee7dadce0e0 = {
	.name=			"verifyMIC",
	.signature=		"([BII[BIILorg/ietf/jgss/MessageProp;)V",
	.class=			&_jc_org_ietf_jgss_GSSContext$type,
	.param_types=		&_jc_org_ietf_jgss_GSSContext$param_types$verifyMIC$91c9dee7dadce0e0,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_org_ietf_jgss_GSSContext$param_ptypes$verifyMIC$91c9dee7dadce0e0,
	.signature_hash=	_JC_JLONG(0x91c9dee7dadce0e0),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	7,
	.num_exceptions=	1,
	.exceptions=		&_jc_org_ietf_jgss_GSSContext$exceptions$verifyMIC$91c9dee7dadce0e0,
};

//
// public abstract void wrap(java.io.InputStream, java.io.OutputStream, org.ietf.jgss.MessageProp) throws org.ietf.jgss.GSSException
//

static const unsigned char _jc_org_ietf_jgss_GSSContext$param_ptypes$wrap$2a6c77457b47ad0e[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_org_ietf_jgss_GSSContext$exceptions$wrap$2a6c77457b47ad0e[] = {
	&_jc_org_ietf_jgss_GSSException$type
};

static _jc_type *const _jc_org_ietf_jgss_GSSContext$param_types$wrap$2a6c77457b47ad0e[] = {
	&_jc_java_io_InputStream$type,
	&_jc_java_io_OutputStream$type,
	&_jc_org_ietf_jgss_MessageProp$type
};

_jc_method _jc_org_ietf_jgss_GSSContext$method_info$wrap$2a6c77457b47ad0e = {
	.name=			"wrap",
	.signature=		"(Ljava/io/InputStream;Ljava/io/OutputStream;Lorg/ietf/jgss/MessageProp;)V",
	.class=			&_jc_org_ietf_jgss_GSSContext$type,
	.param_types=		&_jc_org_ietf_jgss_GSSContext$param_types$wrap$2a6c77457b47ad0e,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_org_ietf_jgss_GSSContext$param_ptypes$wrap$2a6c77457b47ad0e,
	.signature_hash=	_JC_JLONG(0x2a6c77457b47ad0e),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	3,
	.num_exceptions=	1,
	.exceptions=		&_jc_org_ietf_jgss_GSSContext$exceptions$wrap$2a6c77457b47ad0e,
};

//
// public abstract byte[] wrap(byte[], int, int, org.ietf.jgss.MessageProp) throws org.ietf.jgss.GSSException
//

static const unsigned char _jc_org_ietf_jgss_GSSContext$param_ptypes$wrap$dfb5764128e81607[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_INT, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_org_ietf_jgss_GSSContext$exceptions$wrap$dfb5764128e81607[] = {
	&_jc_org_ietf_jgss_GSSException$type
};

static _jc_type *const _jc_org_ietf_jgss_GSSContext$param_types$wrap$dfb5764128e81607[] = {
	&_jc_byte$array$prim$type,
	&_jc_int$prim$type,
	&_jc_int$prim$type,
	&_jc_org_ietf_jgss_MessageProp$type
};

_jc_method _jc_org_ietf_jgss_GSSContext$method_info$wrap$dfb5764128e81607 = {
	.name=			"wrap",
	.signature=		"([BIILorg/ietf/jgss/MessageProp;)[B",
	.class=			&_jc_org_ietf_jgss_GSSContext$type,
	.param_types=		&_jc_org_ietf_jgss_GSSContext$param_types$wrap$dfb5764128e81607,
	.return_type=		&_jc_byte$array$prim$type,
	.param_ptypes=		&_jc_org_ietf_jgss_GSSContext$param_ptypes$wrap$dfb5764128e81607,
	.signature_hash=	_JC_JLONG(0xdfb5764128e81607),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	4,
	.num_exceptions=	1,
	.exceptions=		&_jc_org_ietf_jgss_GSSContext$exceptions$wrap$dfb5764128e81607,
};

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_org_ietf_jgss_GSSContext$methods[] = {
	&_jc_org_ietf_jgss_GSSContext$method_info$acceptSecContext$42c8e289905846f3,
	&_jc_org_ietf_jgss_GSSContext$method_info$acceptSecContext$2f51c2fc6b605c4b,
	&_jc_org_ietf_jgss_GSSContext$method_info$dispose$9d5b5b52b7878138,
	&_jc_org_ietf_jgss_GSSContext$method_info$export$71f4217a6b6773d8,
	&_jc_org_ietf_jgss_GSSContext$method_info$getAnonymityState$c744d364659ac273,
	&_jc_org_ietf_jgss_GSSContext$method_info$getConfState$30b0b94f356769de,
	&_jc_org_ietf_jgss_GSSContext$method_info$getCredDelegState$e947a27a9d6526c8,
	&_jc_org_ietf_jgss_GSSContext$method_info$getDelegCred$a33043fc8163191f,
	&_jc_org_ietf_jgss_GSSContext$method_info$getIntegState$74f4bcb5c4195d96,
	&_jc_org_ietf_jgss_GSSContext$method_info$getLifetime$477547c8c90a4164,
	&_jc_org_ietf_jgss_GSSContext$method_info$getMIC$7a65038cd7987ad2,
	&_jc_org_ietf_jgss_GSSContext$method_info$getMIC$07d4f1c3847477f2,
	&_jc_org_ietf_jgss_GSSContext$method_info$getMech$06d5881e565b3c56,
	&_jc_org_ietf_jgss_GSSContext$method_info$getMutualAuthState$c083c12d00270426,
	&_jc_org_ietf_jgss_GSSContext$method_info$getReplayDetState$1ca526d7699ec2c5,
	&_jc_org_ietf_jgss_GSSContext$method_info$getSequenceDetState$f93c288298cd8da3,
	&_jc_org_ietf_jgss_GSSContext$method_info$getSrcName$5b21b97886c43d58,
	&_jc_org_ietf_jgss_GSSContext$method_info$getTargName$1177bdc7aabbd167,
	&_jc_org_ietf_jgss_GSSContext$method_info$getWrapSizeLimit$3ba0e982ee160f6a,
	&_jc_org_ietf_jgss_GSSContext$method_info$initSecContext$78a79aef5edd3fd2,
	&_jc_org_ietf_jgss_GSSContext$method_info$initSecContext$ff172f567929efe3,
	&_jc_org_ietf_jgss_GSSContext$method_info$isEstablished$d0e06d57395880bc,
	&_jc_org_ietf_jgss_GSSContext$method_info$isInitiator$54dc4ec8cca0fbbb,
	&_jc_org_ietf_jgss_GSSContext$method_info$isProtReady$3f5cafdf854861a8,
	&_jc_org_ietf_jgss_GSSContext$method_info$isTransferable$e5c1ee4e1d4dea64,
	&_jc_org_ietf_jgss_GSSContext$method_info$requestAnonymity$a03adbb6291fb75c,
	&_jc_org_ietf_jgss_GSSContext$method_info$requestConf$11b9d52f506c7534,
	&_jc_org_ietf_jgss_GSSContext$method_info$requestCredDeleg$8220b1c831a285b9,
	&_jc_org_ietf_jgss_GSSContext$method_info$requestInteg$19ecb54347936d31,
	&_jc_org_ietf_jgss_GSSContext$method_info$requestLifetime$dcb6f0f32fb5e14a,
	&_jc_org_ietf_jgss_GSSContext$method_info$requestMutualAuth$9a2ed11a8e4b0b00,
	&_jc_org_ietf_jgss_GSSContext$method_info$requestReplayDet$2f6c35372f357339,
	&_jc_org_ietf_jgss_GSSContext$method_info$requestSequenceDet$ef10c008b3b9c54d,
	&_jc_org_ietf_jgss_GSSContext$method_info$setChannelBinding$1ec4e304aef17c38,
	&_jc_org_ietf_jgss_GSSContext$method_info$unwrap$f43f830679bc0de1,
	&_jc_org_ietf_jgss_GSSContext$method_info$unwrap$f7e97f08619ac296,
	&_jc_org_ietf_jgss_GSSContext$method_info$verifyMIC$9605e84d24d0622f,
	&_jc_org_ietf_jgss_GSSContext$method_info$verifyMIC$91c9dee7dadce0e0,
	&_jc_org_ietf_jgss_GSSContext$method_info$wrap$2a6c77457b47ad0e,
	&_jc_org_ietf_jgss_GSSContext$method_info$wrap$dfb5764128e81607
};

/************************************************************************
 *			  Class fields structure			*
 ************************************************************************/

_jc_org_ietf_jgss_GSSContext$fields_struct _jc_org_ietf_jgss_GSSContext$class_fields = { };

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_org_ietf_jgss_GSSContext$instanceof_hash_bucket_0[] = {
	&_jc_org_ietf_jgss_GSSContext$type,
	_JC_NULL
};
static _jc_type *const _jc_org_ietf_jgss_GSSContext$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_org_ietf_jgss_GSSContext$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[0]=	_jc_org_ietf_jgss_GSSContext$instanceof_hash_bucket_0,
	[101]=	_jc_org_ietf_jgss_GSSContext$instanceof_hash_bucket_101
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_org_ietf_jgss_GSSContext$class_depends[] = {
	{ "java/io/InputStream",	_JC_JLONG(0x66aea4d152614ac4) },
	{ "java/io/OutputStream",	_JC_JLONG(0x4026d3144d6654d8) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "org/ietf/jgss/ChannelBinding",	_JC_JLONG(0x65d1d173dff3e647) },
	{ "org/ietf/jgss/GSSCredential",	_JC_JLONG(0xe20b9c3808e2155d) },
	{ "org/ietf/jgss/GSSException",	_JC_JLONG(0xd82ad86895ee19c6) },
	{ "org/ietf/jgss/GSSName",	_JC_JLONG(0xfb9178e39855b48e) },
	{ "org/ietf/jgss/MessageProp",	_JC_JLONG(0xd50ffb07701ef7d1) },
	{ "org/ietf/jgss/Oid",	_JC_JLONG(0xfeb3400b12072102) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_org_ietf_jgss_GSSContext$vtype _jc_org_ietf_jgss_GSSContext$type = {
    .type= {
	.name=			"org/ietf/jgss/GSSContext",
	.superclass=		&_jc_java_lang_Object$type,
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT|_JC_ACC_INTERFACE,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		51,
		.hash=			_JC_JLONG(0x88468c2cc5954400),
		.source_file=		"GSSContext.java",
		.num_virtual_refs=	0,
		.num_fields=		sizeof(_jc_org_ietf_jgss_GSSContext$fields) / sizeof(*_jc_org_ietf_jgss_GSSContext$fields),
		.fields=		_jc_org_ietf_jgss_GSSContext$fields,
		.num_methods=		sizeof(_jc_org_ietf_jgss_GSSContext$methods) / sizeof(*_jc_org_ietf_jgss_GSSContext$methods),
		.methods=		_jc_org_ietf_jgss_GSSContext$methods,
		.instanceof_hash_table=	_jc_org_ietf_jgss_GSSContext$instanceof_hash_table,
		.class_fields=		&_jc_org_ietf_jgss_GSSContext$class_fields,
		.num_class_depends=		sizeof(_jc_org_ietf_jgss_GSSContext$class_depends) / sizeof(*_jc_org_ietf_jgss_GSSContext$class_depends),
		.class_depends=		_jc_org_ietf_jgss_GSSContext$class_depends,
	    }
	}
    }
};

