// public class org.ietf.jgss.Oid

// class file dependencies
// @dep_class a68cc27886fd8be3 java_io_ByteArrayInputStream
// @dep_class c4d3cc2bda03a338 java_io_ByteArrayOutputStream
// @dep_class cc3ce5b592e8a1d java_io_DataInputStream
// @dep_class 455accfa535f5dfe java_io_FilterInputStream
// @dep_class 4e0a56550c69d57c java_io_IOException
// @dep_class 66aea4d152614ac4 java_io_InputStream
// @dep_class 4026d3144d6654d8 java_io_OutputStream
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class ca631501391a31f1 java_lang_Integer
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 94d357637b968dda java_lang_StringBuffer
// @dep_class 53cc8e2333795f04 java_lang_System
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class 4d1cebae0bdda058 java_lang_VMSystem
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class 7717ded55c30b7f3 java_math_BigInteger
// @dep_class 363c8597b4f8d5ff java_util_Arrays
// @dep_class b0f2ff51263ebf06 java_util_ResourceBundle
// @dep_class b106445ca218ee16 java_util_StringTokenizer
// @dep_class d82ad86895ee19c6 org_ietf_jgss_GSSException
// @dep_class feb3400b12072102 org_ietf_jgss_Oid

// header file dependencies
// @dep_header java_io_ByteArrayInputStream
// @dep_header java_io_ByteArrayOutputStream
// @dep_header java_io_DataInputStream
// @dep_header java_io_IOException
// @dep_header java_lang_Class
// @dep_header java_lang_Integer
// @dep_header java_lang_String
// @dep_header java_lang_StringBuffer
// @dep_header java_lang_System
// @dep_header java_lang_VMSystem
// @dep_header java_lang_VMThrowable
// @dep_header java_math_BigInteger
// @dep_header java_util_Arrays
// @dep_header java_util_ResourceBundle
// @dep_header java_util_StringTokenizer
// @dep_header org_ietf_jgss_GSSException
// @dep_header org_ietf_jgss_Oid

#include "jc_defs.h"

#include "java/io/ByteArrayInputStream.h"
#include "java/io/ByteArrayOutputStream.h"
#include "java/io/DataInputStream.h"
#include "java/io/IOException.h"
#include "java/lang/Class.h"
#include "java/lang/Integer.h"
#include "java/lang/String.h"
#include "java/lang/StringBuffer.h"
#include "java/lang/System.h"
#include "java/lang/VMSystem.h"
#include "java/lang/VMThrowable.h"
#include "java/math/BigInteger.h"
#include "java/util/Arrays.h"
#include "java/util/ResourceBundle.h"
#include "java/util/StringTokenizer.h"
#include "org/ietf/jgss/GSSException.h"
#include "org/ietf/jgss/Oid.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// private static final int OBJECT_IDENTIFIER
static const jint _jc_org_ietf_jgss_Oid$initial_value$OBJECT__5fIDENTIFIER = 6;
static _jc_field _jc_org_ietf_jgss_Oid$field_info$OBJECT__5fIDENTIFIER = {
	.name=		"OBJECT_IDENTIFIER",
	.signature=	"I",
	.class=		&_jc_org_ietf_jgss_Oid$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_org_ietf_jgss_Oid$fields_struct, OBJECT__5fIDENTIFIER),
	.initial_value=	&_jc_org_ietf_jgss_Oid$initial_value$OBJECT__5fIDENTIFIER,
};

// private static final int RELATIVE_OID
static const jint _jc_org_ietf_jgss_Oid$initial_value$RELATIVE__5fOID = 13;
static _jc_field _jc_org_ietf_jgss_Oid$field_info$RELATIVE__5fOID = {
	.name=		"RELATIVE_OID",
	.signature=	"I",
	.class=		&_jc_org_ietf_jgss_Oid$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_org_ietf_jgss_Oid$fields_struct, RELATIVE__5fOID),
	.initial_value=	&_jc_org_ietf_jgss_Oid$initial_value$RELATIVE__5fOID,
};

// private final int[] components
static _jc_field _jc_org_ietf_jgss_Oid$field_info$components = {
	.name=		"components",
	.signature=	"[I",
	.class=		&_jc_org_ietf_jgss_Oid$type,
	.type=		&_jc_int$array$prim$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_org_ietf_jgss_Oid$object, refs[-1].org_ietf_jgss_Oid.components),
};

// private byte[] derOid
static _jc_field _jc_org_ietf_jgss_Oid$field_info$derOid = {
	.name=		"derOid",
	.signature=	"[B",
	.class=		&_jc_org_ietf_jgss_Oid$type,
	.type=		&_jc_byte$array$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_org_ietf_jgss_Oid$object, refs[-1].org_ietf_jgss_Oid.derOid),
};

// private java.lang.String strOid
static _jc_field _jc_org_ietf_jgss_Oid$field_info$strOid = {
	.name=		"strOid",
	.signature=	"Ljava/lang/String;",
	.class=		&_jc_org_ietf_jgss_Oid$type,
	.type=		&_jc_java_lang_String$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_org_ietf_jgss_Oid$object, refs[-1].org_ietf_jgss_Oid.strOid),
};

// private boolean relative
static _jc_field _jc_org_ietf_jgss_Oid$field_info$relative = {
	.name=		"relative",
	.signature=	"Z",
	.class=		&_jc_org_ietf_jgss_Oid$type,
	.type=		&_jc_boolean$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_org_ietf_jgss_Oid$object, nonrefs.org_ietf_jgss_Oid.relative),
};

// Fields
static _jc_field *const _jc_org_ietf_jgss_Oid$fields[] = {
	&_jc_org_ietf_jgss_Oid$field_info$OBJECT__5fIDENTIFIER,
	&_jc_org_ietf_jgss_Oid$field_info$RELATIVE__5fOID,
	&_jc_org_ietf_jgss_Oid$field_info$components,
	&_jc_org_ietf_jgss_Oid$field_info$derOid,
	&_jc_org_ietf_jgss_Oid$field_info$strOid,
	&_jc_org_ietf_jgss_Oid$field_info$relative
};

/************************************************************************
 *			      Static methods				*
 ************************************************************************/

//
// private static final void encodeSubId(java.io.OutputStream, int) throws java.io.IOException
//

static _jc_linenum _jc_org_ietf_jgss_Oid$linenum_table$encodeSubId$f18e55a3572fb9d2[];

static const unsigned char _jc_org_ietf_jgss_Oid$param_ptypes$encodeSubId$f18e55a3572fb9d2[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_VOID };

static _jc_type *const _jc_org_ietf_jgss_Oid$exceptions$encodeSubId$f18e55a3572fb9d2[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_org_ietf_jgss_Oid$param_types$encodeSubId$f18e55a3572fb9d2[] = {
	&_jc_java_io_OutputStream$type,
	&_jc_int$prim$type
};

_jc_method _jc_org_ietf_jgss_Oid$method_info$encodeSubId$f18e55a3572fb9d2 = {
	.name=			"encodeSubId",
	.signature=		"(Ljava/io/OutputStream;I)V",
	.class=			&_jc_org_ietf_jgss_Oid$type,
	.param_types=		&_jc_org_ietf_jgss_Oid$param_types$encodeSubId$f18e55a3572fb9d2,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_org_ietf_jgss_Oid$param_ptypes$encodeSubId$f18e55a3572fb9d2,
	.signature_hash=	_JC_JLONG(0xf18e55a3572fb9d2),
	.access_flags=		_JC_ACC_PRIVATE|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.function=		&_jc_org_ietf_jgss_Oid$method$encodeSubId$f18e55a3572fb9d2,
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_org_ietf_jgss_Oid$exceptions$encodeSubId$f18e55a3572fb9d2,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	15,
	      .table=	_jc_org_ietf_jgss_Oid$linenum_table$encodeSubId$f18e55a3572fb9d2
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(org_ietf_jgss_Oid, encodeSubId$f18e55a3572fb9d2);

void _JC_JCNI_ATTR
_jc_org_ietf_jgss_Oid$method$encodeSubId$f18e55a3572fb9d2(_jc_env *const env, _jc_java_io_OutputStream$object *param0, jint param1)
{
	jint i0;
	jint i1;
	struct _jc_java_io_OutputStream$object *r0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = param0;
	i0 = param1;
	_JC_LINE_NUMBER(362);				// 0
	if (i0 >= 128)
		goto label0;
	_JC_LINE_NUMBER(364);				// 1
	_JC_INVOKE_VIRTUAL(env, java_io_OutputStream, write$6377ac6964854eb2, r0, i0);
	goto label3;

label0:
	_JC_LINE_NUMBER(366);				// 2
	if (i0 >= 16384)
		goto label1;
	_JC_LINE_NUMBER(368);				// 3
	i1 = _JC_IUSHR(i0, 7);
	i1 = i1 | 128;
	_JC_INVOKE_VIRTUAL(env, java_io_OutputStream, write$6377ac6964854eb2, r0, i1);
	_JC_LINE_NUMBER(369);				// 4
	i1 = i0 & 127;
	_JC_INVOKE_VIRTUAL(env, java_io_OutputStream, write$6377ac6964854eb2, r0, i1);
	goto label3;

label1:
	_JC_LINE_NUMBER(371);				// 5
	if (i0 >= 2097152)
		goto label2;
	_JC_LINE_NUMBER(373);				// 6
	i1 = _JC_IUSHR(i0, 14);
	i1 = i1 | 128;
	_JC_INVOKE_VIRTUAL(env, java_io_OutputStream, write$6377ac6964854eb2, r0, i1);
	_JC_LINE_NUMBER(374);				// 7
	i1 = _JC_IUSHR(i0, 7);
	i1 = i1 | 128;
	i1 = i1 & 255;
	_JC_INVOKE_VIRTUAL(env, java_io_OutputStream, write$6377ac6964854eb2, r0, i1);
	_JC_LINE_NUMBER(375);				// 8
	i1 = i0 & 127;
	_JC_INVOKE_VIRTUAL(env, java_io_OutputStream, write$6377ac6964854eb2, r0, i1);
	goto label3;

label2:
	_JC_LINE_NUMBER(377);				// 9
	if (i0 >= 268435456)
		goto label3;
	_JC_LINE_NUMBER(379);				// 10
	i1 = _JC_IUSHR(i0, 21);
	i1 = i1 | 128;
	_JC_INVOKE_VIRTUAL(env, java_io_OutputStream, write$6377ac6964854eb2, r0, i1);
	_JC_LINE_NUMBER(380);				// 11
	i1 = _JC_IUSHR(i0, 14);
	i1 = i1 | 128;
	i1 = i1 & 255;
	_JC_INVOKE_VIRTUAL(env, java_io_OutputStream, write$6377ac6964854eb2, r0, i1);
	_JC_LINE_NUMBER(381);				// 12
	i1 = _JC_IUSHR(i0, 7);
	i1 = i1 | 128;
	i1 = i1 & 255;
	_JC_INVOKE_VIRTUAL(env, java_io_OutputStream, write$6377ac6964854eb2, r0, i1);
	_JC_LINE_NUMBER(382);				// 13
	i1 = i0 & 127;
	_JC_INVOKE_VIRTUAL(env, java_io_OutputStream, write$6377ac6964854eb2, r0, i1);

label3:
	_JC_LINE_NUMBER(384);				// 14
	return;
}

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// public void <init>(java.io.InputStream) throws org.ietf.jgss.GSSException
//

static _jc_linenum _jc_org_ietf_jgss_Oid$linenum_table$_init$3887600c17c5e554[];

static _jc_trap_info _jc_org_ietf_jgss_Oid$trap_table$_init$3887600c17c5e554[] = {
	_JC_TRAP(&_jc_java_lang_Exception$type, 3, 4),
	_JC_TRAP(&_jc_java_io_IOException$type, 1, 2),
};

static const unsigned char _jc_org_ietf_jgss_Oid$param_ptypes$_init$3887600c17c5e554[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_org_ietf_jgss_Oid$exceptions$_init$3887600c17c5e554[] = {
	&_jc_org_ietf_jgss_GSSException$type
};

static _jc_type *const _jc_org_ietf_jgss_Oid$param_types$_init$3887600c17c5e554[] = {
	&_jc_java_io_InputStream$type
};

_jc_method _jc_org_ietf_jgss_Oid$method_info$_init$3887600c17c5e554 = {
	.name=			"<init>",
	.signature=		"(Ljava/io/InputStream;)V",
	.class=			&_jc_org_ietf_jgss_Oid$type,
	.param_types=		&_jc_org_ietf_jgss_Oid$param_types$_init$3887600c17c5e554,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_org_ietf_jgss_Oid$param_ptypes$_init$3887600c17c5e554,
	.signature_hash=	_JC_JLONG(0x3887600c17c5e554),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_org_ietf_jgss_Oid$method$_init$3887600c17c5e554,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_org_ietf_jgss_Oid$exceptions$_init$3887600c17c5e554,
	.u= { .exec= {
	  .trap_table_len=	2,
	  .trap_table=		_jc_org_ietf_jgss_Oid$trap_table$_init$3887600c17c5e554,
	  .u= {
	    .linenum= {
	      .len=	34,
	      .table=	_jc_org_ietf_jgss_Oid$linenum_table$_init$3887600c17c5e554
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(org_ietf_jgss_Oid, _init$3887600c17c5e554);

void _JC_JCNI_ATTR
_jc_org_ietf_jgss_Oid$method$_init$3887600c17c5e554(_jc_env *const env, _jc_org_ietf_jgss_Oid$object *this, _jc_java_io_InputStream$object *param0)
{
	jbyte b5;
	jint i0;
	jint i1;
	jint i10;
	jint i11;
	jint i12;
	jint i2;
	jint i3;
	jint i6;
	jint i8;
	jint i9;
	struct _jc_org_ietf_jgss_Oid$object *r0;
	struct _jc_java_io_InputStream$object *r1;
	struct _jc_java_io_InputStream$object *r10;
	struct _jc_java_io_InputStream$object *r11;
	struct _jc_java_lang_String$object *r12;
	struct _jc_java_lang_VMThrowable$object *r13;
	struct _jc_java_lang_String$object *r14;
	struct _jc_java_lang_VMThrowable$object *r15;
	struct _jc_java_lang_String$object *r16;
	struct _jc_java_lang_VMThrowable$object *r17;
	_jc_int_array *r18;
	struct _jc_java_lang_String$object *volatile r19;
	struct _jc_java_io_DataInputStream$object *r2;
	struct _jc_java_lang_Exception$object *r20;
	struct _jc_java_util_ResourceBundle$object *volatile r21;
	struct _jc_java_lang_String$object *volatile r22;
	struct _jc_java_lang_VMThrowable$object *volatile r24;
	_jc_byte_array *r3;
	_jc_int_array *r4;
	struct _jc_java_io_IOException$object *r5;
	struct _jc_java_math_BigInteger$object *r6;
	_jc_int_array *r7;
	struct _jc_org_ietf_jgss_GSSException$object *volatile r8;
	_jc_byte_array *r9;
	jshort s4;
	jshort s7;
	jboolean z0;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_org_ietf_jgss_Oid$method_info$_init$3887600c17c5e554, &&label10, &&label9);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(154);				// 0
	r2 = _JC_NEW(env, java_io_DataInputStream);
	_JC_REF_FIELD(env, r2, java_io_FilterInputStream, in) = r1;
	r9 = _JC_NEW_PRIM_ARRAY(env, byte, 1, 8);
	_JC_REF_FIELD(env, r2, java_io_DataInputStream, buf) = r9;
	_JC_TRAP_REGION(catch, 1);
	r10 = _JC_REF_FIELD(env, r2, java_io_FilterInputStream, in);
	i8 = _JC_INVOKE_VIRTUAL(env, java_io_InputStream, read$1a981297cb524963, r10);
	_JC_LINE_NUMBER(157);				// 1
	i0 = i8 & 31;
	_JC_LINE_NUMBER(158);				// 2
	if (i0 == 6)
		goto label0;
	if (i0 == 13)
		goto label0;
	_JC_LINE_NUMBER(159);				// 3
	r5 = _JC_NEW(env, java_io_IOException);
	r12 = _JC_NULL;
	_JC_REF_FIELD(env, r5, java_lang_Throwable, cause) = r5;
	r13 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r5);
	_JC_REF_FIELD(env, r5, java_lang_Throwable, vmState) = r13;
	_JC_REF_FIELD(env, r5, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r5, java_lang_Throwable, detailMessage) = r12;
	_JC_THROW(env, r5);

label0:
	r11 = _JC_REF_FIELD(env, r2, java_io_FilterInputStream, in);
	i9 = _JC_INVOKE_VIRTUAL(env, java_io_InputStream, read$1a981297cb524963, r11);
	i1 = i9;
	_JC_LINE_NUMBER(161);				// 4
	i3 = i9 & -128;
	if (i3 == 0)
		goto label2;
	_JC_LINE_NUMBER(163);				// 5
	i3 = i9 & 127;
	r3 = _JC_NEW_PRIM_ARRAY(env, byte, 1, i3);
	i10 = _JC_ARRAY_LENGTH(env, r3);
	_JC_INVOKE_NONVIRTUAL(env, java_io_DataInputStream, readFully$63e0ddb7f8315fc6, 0, r2, r3, 0, i10);
	_JC_LINE_NUMBER(165);				// 6
	r6 = _JC_NEW(env, java_math_BigInteger);
	_JC_INVOKE_NONVIRTUAL(env, java_math_BigInteger, _init$85a20918701c98c3, 0, r6, 1, r3);
	r18 = _JC_REF_FIELD(env, r6, java_math_BigInteger, words);
	if (r18 != _JC_NULL)
		goto label1;
	i12 = _JC_PRIM_FIELD(env, r6, java_math_BigInteger, ival);
	i1 = i12;
	goto label2;

label1:
	r18 = _JC_REF_FIELD(env, r6, java_math_BigInteger, words);
	i12 = _JC_PRIM_ELEMENT(env, int, r18, 0, 0, 1);
	i1 = i12;

label2:
	_JC_LINE_NUMBER(167);				// 7
	if (i1 >= 0)
		goto label3;
	_JC_LINE_NUMBER(168);				// 8
	r5 = _JC_NEW(env, java_io_IOException);
	r14 = _JC_NULL;
	_JC_REF_FIELD(env, r5, java_lang_Throwable, cause) = r5;
	r15 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r5);
	_JC_REF_FIELD(env, r5, java_lang_Throwable, vmState) = r15;
	_JC_REF_FIELD(env, r5, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r5, java_lang_Throwable, detailMessage) = r14;
	_JC_THROW(env, r5);

label3:
	_JC_LINE_NUMBER(169);				// 9
	r3 = _JC_NEW_PRIM_ARRAY(env, byte, 1, i1);
	i11 = _JC_ARRAY_LENGTH(env, r3);
	_JC_INVOKE_NONVIRTUAL(env, java_io_DataInputStream, readFully$63e0ddb7f8315fc6, 0, r2, r3, 0, i11);
	_JC_LINE_NUMBER(171);				// 10
	i3 = i1 + 1;
	r4 = _JC_NEW_PRIM_ARRAY(env, int, 1, i3);
	_JC_LINE_NUMBER(172);				// 11
	i2 = 0;
	_JC_LINE_NUMBER(173);				// 12
	i3 = 0;
	_JC_LINE_NUMBER(174);				// 13
	z0 = 0;
	if (i0 != 13)
		goto label4;
	z0 = 1;

label4:
	_JC_PRIM_FIELD(env, r0, org_ietf_jgss_Oid, relative) = z0;
	_JC_LINE_NUMBER(175);				// 14
	z0 = _JC_PRIM_FIELD(env, r0, org_ietf_jgss_Oid, relative);
	if (z0 != 0)
		goto label7;
	if (0 >= i1)
		goto label7;
	_JC_LINE_NUMBER(177);				// 15
	b5 = _JC_PRIM_ELEMENT(env, byte, r3, 0, 0, 1);
	s4 = b5 & 255;
	_JC_LINE_NUMBER(178);				// 16
	i6 = s4 / 40;
	_JC_PRIM_ELEMENT(env, int, r4, 0, 0, 1) = i6;
	_JC_LINE_NUMBER(179);				// 17
	i2 = 2;
	i6 = s4 % 40;
	_JC_PRIM_ELEMENT(env, int, r4, 1, 0, 1) = i6;
	_JC_LINE_NUMBER(180);				// 18
	i3 = 1;
	_JC_LINE_NUMBER(182);				// 19
	goto label7;

label5:
	_JC_LINE_NUMBER(187);				// 20
	i6 = i3;
	i3 = i3 + 1;
	b5 = _JC_PRIM_ELEMENT(env, byte, r3, i6, 0, 1);
	s4 = b5 & 255;
	_JC_LINE_NUMBER(188);				// 21
	i6 = _JC_PRIM_ELEMENT(env, int, r4, i2, 0, 1);
	i6 = i6 << (7 & 0x1f);
	_JC_PRIM_ELEMENT(env, int, r4, i2, 0, 0) = i6;
	_JC_LINE_NUMBER(189);				// 22
	i6 = _JC_PRIM_ELEMENT(env, int, r4, i2, 0, 0);
	s7 = s4 & 127;
	i6 = i6 | s7;
	_JC_PRIM_ELEMENT(env, int, r4, i2, 0, 0) = i6;
	_JC_LINE_NUMBER(190);				// 23
	if (i3 < i1)
		goto label6;
	s7 = s4 & 128;
	if (s7 == 0)
		goto label6;
	_JC_LINE_NUMBER(191);				// 24
	r5 = _JC_NEW(env, java_io_IOException);
	r16 = _JC_NULL;
	_JC_REF_FIELD(env, r5, java_lang_Throwable, cause) = r5;
	r17 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r5);
	_JC_REF_FIELD(env, r5, java_lang_Throwable, vmState) = r17;
	_JC_REF_FIELD(env, r5, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r5, java_lang_Throwable, detailMessage) = r16;
	_JC_THROW(env, r5);

label6:
	_JC_LINE_NUMBER(193);				// 25
	s7 = s4 & 128;
	if (s7 != 0) {
		_JC_PERIODIC_CHECK(env);
		goto label5;
	}
	_JC_LINE_NUMBER(194);				// 26
	i2 = i2 + 1;

label7:
	_JC_LINE_NUMBER(182);				// 27
	if (i3 < i1) {
		_JC_PERIODIC_CHECK(env);
		goto label5;
	}
	_JC_LINE_NUMBER(196);				// 28
	if (i2 != i1)
		goto label8;
	_JC_LINE_NUMBER(197);				// 29
	_JC_REF_FIELD(env, r0, org_ietf_jgss_Oid, components) = r4;
	goto label12;

label8:
	_JC_LINE_NUMBER(200);				// 30
	r7 = _JC_NEW_PRIM_ARRAY(env, int, 1, i2);
	_JC_REF_FIELD(env, r0, org_ietf_jgss_Oid, components) = r7;
	_JC_LINE_NUMBER(201);				// 31
	r7 = _JC_REF_FIELD(env, r0, org_ietf_jgss_Oid, components);
	_JC_ACTIVE_USE(env, java_lang_System);
	_JC_INVOKE_STATIC(env, java_lang_VMSystem, arraycopy$4286a72d57744cd8, 0, r4, 0, r7, 0, i2);
	_JC_TRAP_REGION(catch, 2);
	goto label12;

label9:
	_JC_TRAP_REGION(catch, 2);
	r5 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(206);				// 32
	r8 = _JC_NEW(env, org_ietf_jgss_GSSException);
	r19 = _JC_NULL;
	r22 = _JC_NULL;
	_JC_REF_FIELD(env, r8, java_lang_Throwable, cause) = r8;
	r24 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r8);
	_JC_REF_FIELD(env, r8, java_lang_Throwable, vmState) = r24;
	_JC_REF_FIELD(env, r8, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r8, java_lang_Throwable, detailMessage) = r22;
	_JC_PRIM_FIELD(env, r8, org_ietf_jgss_GSSException, major) = 13;
	_JC_PRIM_FIELD(env, r8, org_ietf_jgss_GSSException, minor) = 0;
	_JC_REF_FIELD(env, r8, org_ietf_jgss_GSSException, minorString) = r19;
	_JC_TRAP_REGION(catch, 3);
	r21 = _JC_INVOKE_STATIC(env, java_util_ResourceBundle, getBundle$7dc7df404e2acab0, 0, _JC_STRING(env, "org/ietf/jgss/MessagesBundle"));
	_JC_REF_FIELD(env, r8, org_ietf_jgss_GSSException, messages) = r21;
	_JC_TRAP_REGION(catch, 4);
	goto label11;

label10:
	_JC_TRAP_REGION(catch, 4);
	r20 = _JC_CAUGHT_EXCEPTION(env);
	_JC_REF_FIELD(env, r8, org_ietf_jgss_GSSException, messages) = _JC_NULL;

label11:
	_JC_THROW(env, r8);

label12:
	_JC_TRAP_REGION(catch, 4);
	_JC_LINE_NUMBER(208);				// 33
	_JC_CANCEL_TRAPS(env, catch);
	return;
}

//
// public void <init>(java.lang.String) throws org.ietf.jgss.GSSException
//

static _jc_linenum _jc_org_ietf_jgss_Oid$linenum_table$_init$c31b894660454d13[];

static _jc_trap_info _jc_org_ietf_jgss_Oid$trap_table$_init$c31b894660454d13[] = {
	_JC_TRAP(&_jc_java_lang_Exception$type, 3, 4),
	_JC_TRAP(&_jc_java_lang_Exception$type, 1, 2),
};

static const unsigned char _jc_org_ietf_jgss_Oid$param_ptypes$_init$c31b894660454d13[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_org_ietf_jgss_Oid$exceptions$_init$c31b894660454d13[] = {
	&_jc_org_ietf_jgss_GSSException$type
};

static _jc_type *const _jc_org_ietf_jgss_Oid$param_types$_init$c31b894660454d13[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_org_ietf_jgss_Oid$method_info$_init$c31b894660454d13 = {
	.name=			"<init>",
	.signature=		"(Ljava/lang/String;)V",
	.class=			&_jc_org_ietf_jgss_Oid$type,
	.param_types=		&_jc_org_ietf_jgss_Oid$param_types$_init$c31b894660454d13,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_org_ietf_jgss_Oid$param_ptypes$_init$c31b894660454d13,
	.signature_hash=	_JC_JLONG(0xc31b894660454d13),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_org_ietf_jgss_Oid$method$_init$c31b894660454d13,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_org_ietf_jgss_Oid$exceptions$_init$c31b894660454d13,
	.u= { .exec= {
	  .trap_table_len=	2,
	  .trap_table=		_jc_org_ietf_jgss_Oid$trap_table$_init$c31b894660454d13,
	  .u= {
	    .linenum= {
	      .len=	10,
	      .table=	_jc_org_ietf_jgss_Oid$linenum_table$_init$c31b894660454d13
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(org_ietf_jgss_Oid, _init$c31b894660454d13);

void _JC_JCNI_ATTR
_jc_org_ietf_jgss_Oid$method$_init$c31b894660454d13(_jc_env *const env, _jc_org_ietf_jgss_Oid$object *this, _jc_java_lang_String$object *param0)
{
	jint i0;
	jint i1;
	jint i2;
	jint i3;
	jint i4;
	struct _jc_org_ietf_jgss_Oid$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_java_lang_String$object *volatile r10;
	struct _jc_java_lang_VMThrowable$object *volatile r12;
	struct _jc_java_util_StringTokenizer$object *r2;
	_jc_int_array *r3;
	struct _jc_java_lang_Exception$object *r4;
	struct _jc_org_ietf_jgss_GSSException$object *volatile r5;
	struct _jc_java_lang_String$object *r6;
	struct _jc_java_lang_String$object *volatile r7;
	struct _jc_java_lang_Exception$object *r8;
	struct _jc_java_util_ResourceBundle$object *volatile r9;
	jboolean z0;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_org_ietf_jgss_Oid$method_info$_init$c31b894660454d13, &&label3, &&label2);

	r0 = this;
	r1 = param0;
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	_JC_LINE_NUMBER(124);				// 0
	_JC_REF_FIELD(env, r0, org_ietf_jgss_Oid, strOid) = r1;
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(127);				// 1
	r2 = _JC_NEW(env, java_util_StringTokenizer);
	r6 = _JC_STRING(env, ".");
	i4 = _JC_PRIM_FIELD(env, r1, java_lang_String, count);
	_JC_PRIM_FIELD(env, r2, java_util_StringTokenizer, len) = i4;
	_JC_REF_FIELD(env, r2, java_util_StringTokenizer, str) = r1;
	_JC_REF_FIELD(env, r2, java_util_StringTokenizer, delim) = r6;
	_JC_PRIM_FIELD(env, r2, java_util_StringTokenizer, retDelims) = 0;
	_JC_PRIM_FIELD(env, r2, java_util_StringTokenizer, pos) = 0;
	_JC_LINE_NUMBER(128);				// 2
	i0 = _JC_INVOKE_NONVIRTUAL(env, java_util_StringTokenizer, countTokens$30e7b65e7ca065d2, 0, r2);
	r3 = _JC_NEW_PRIM_ARRAY(env, int, 1, i0);
	_JC_REF_FIELD(env, r0, org_ietf_jgss_Oid, components) = r3;
	_JC_LINE_NUMBER(129);				// 3
	i0 = 0;
	_JC_LINE_NUMBER(130);				// 4
	goto label1;

label0:
	_JC_LINE_NUMBER(132);				// 5
	r3 = _JC_REF_FIELD(env, r0, org_ietf_jgss_Oid, components);
	i1 = i0;
	i0 = i0 + 1;
	r1 = _JC_INVOKE_NONVIRTUAL(env, java_util_StringTokenizer, nextToken$706c46e280dd7989, 0, r2);
	_JC_ACTIVE_USE(env, java_lang_Integer);
	i3 = _JC_INVOKE_STATIC(env, java_lang_Integer, parseInt$09e508ce4e7428b2, 1, r1, 10, 0);
	_JC_PRIM_ELEMENT(env, int, r3, i1, 0, 1) = i3;

label1:
	_JC_LINE_NUMBER(130);				// 6
	z0 = _JC_INVOKE_NONVIRTUAL(env, java_util_StringTokenizer, hasMoreTokens$f02c6da5d207e800, 0, r2);
	if (z0 == 0)
		goto label5;
	r3 = _JC_REF_FIELD(env, r0, org_ietf_jgss_Oid, components);
	i2 = _JC_ARRAY_LENGTH(env, r3);
	if (i0 < i2) {
		_JC_PERIODIC_CHECK(env);
		goto label0;
	}
	_JC_TRAP_REGION(catch, 2);
	goto label5;

label2:
	_JC_TRAP_REGION(catch, 2);
	r4 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(137);				// 7
	r5 = _JC_NEW(env, org_ietf_jgss_GSSException);
	r7 = _JC_NULL;
	r10 = _JC_NULL;
	_JC_REF_FIELD(env, r5, java_lang_Throwable, cause) = r5;
	r12 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r5);
	_JC_REF_FIELD(env, r5, java_lang_Throwable, vmState) = r12;
	_JC_REF_FIELD(env, r5, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r5, java_lang_Throwable, detailMessage) = r10;
	_JC_PRIM_FIELD(env, r5, org_ietf_jgss_GSSException, major) = 13;
	_JC_PRIM_FIELD(env, r5, org_ietf_jgss_GSSException, minor) = 0;
	_JC_REF_FIELD(env, r5, org_ietf_jgss_GSSException, minorString) = r7;
	_JC_TRAP_REGION(catch, 3);
	r9 = _JC_INVOKE_STATIC(env, java_util_ResourceBundle, getBundle$7dc7df404e2acab0, 0, _JC_STRING(env, "org/ietf/jgss/MessagesBundle"));
	_JC_REF_FIELD(env, r5, org_ietf_jgss_GSSException, messages) = r9;
	_JC_TRAP_REGION(catch, 4);
	goto label4;

label3:
	_JC_TRAP_REGION(catch, 4);
	r8 = _JC_CAUGHT_EXCEPTION(env);
	_JC_REF_FIELD(env, r5, org_ietf_jgss_GSSException, messages) = _JC_NULL;

label4:
	_JC_THROW(env, r5);

label5:
	_JC_TRAP_REGION(catch, 4);
	_JC_LINE_NUMBER(139);				// 8
	_JC_PRIM_FIELD(env, r0, org_ietf_jgss_Oid, relative) = 0;
	_JC_LINE_NUMBER(140);				// 9
	_JC_CANCEL_TRAPS(env, catch);
	return;
}

//
// public void <init>(byte[]) throws org.ietf.jgss.GSSException
//

static _jc_linenum _jc_org_ietf_jgss_Oid$linenum_table$_init$aaa7e255fe505158[];

static const unsigned char _jc_org_ietf_jgss_Oid$param_ptypes$_init$aaa7e255fe505158[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_org_ietf_jgss_Oid$exceptions$_init$aaa7e255fe505158[] = {
	&_jc_org_ietf_jgss_GSSException$type
};

static _jc_type *const _jc_org_ietf_jgss_Oid$param_types$_init$aaa7e255fe505158[] = {
	&_jc_byte$array$prim$type
};

_jc_method _jc_org_ietf_jgss_Oid$method_info$_init$aaa7e255fe505158 = {
	.name=			"<init>",
	.signature=		"([B)V",
	.class=			&_jc_org_ietf_jgss_Oid$type,
	.param_types=		&_jc_org_ietf_jgss_Oid$param_types$_init$aaa7e255fe505158,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_org_ietf_jgss_Oid$param_ptypes$_init$aaa7e255fe505158,
	.signature_hash=	_JC_JLONG(0xaaa7e255fe505158),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_org_ietf_jgss_Oid$method$_init$aaa7e255fe505158,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_org_ietf_jgss_Oid$exceptions$_init$aaa7e255fe505158,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_org_ietf_jgss_Oid$linenum_table$_init$aaa7e255fe505158
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(org_ietf_jgss_Oid, _init$aaa7e255fe505158);

void _JC_JCNI_ATTR
_jc_org_ietf_jgss_Oid$method$_init$aaa7e255fe505158(_jc_env *const env, _jc_org_ietf_jgss_Oid$object *this, _jc_byte_array *param0)
{
	jint i0;
	struct _jc_org_ietf_jgss_Oid$object *r0;
	_jc_byte_array *r1;
	struct _jc_java_io_ByteArrayInputStream$object *r2;
	struct _jc_java_lang_Object$object *r3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(221);				// 0
	r2 = _JC_NEW(env, java_io_ByteArrayInputStream);
	i0 = _JC_ARRAY_LENGTH(env, r1);
	_JC_INVOKE_NONVIRTUAL(env, java_io_ByteArrayInputStream, _init$4ff4a7925ef7b06c, 0, r2, r1, 0, i0);
	_JC_INVOKE_NONVIRTUAL(env, org_ietf_jgss_Oid, _init$3887600c17c5e554, 0, r0, r2);
	_JC_LINE_NUMBER(222);				// 1
	r3 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, clone$b75f2713d6705f70, r1);
	r1 = _JC_CAST_FINAL(env, &_jc_byte$array$prim$type, r3);
	_JC_REF_FIELD(env, r0, org_ietf_jgss_Oid, derOid) = r1;
	_JC_LINE_NUMBER(223);				// 2
	return;
}

//
// void <init>(int[])
//

static _jc_linenum _jc_org_ietf_jgss_Oid$linenum_table$_init$dbf53d65c126dfa3[];

static const unsigned char _jc_org_ietf_jgss_Oid$param_ptypes$_init$dbf53d65c126dfa3[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_org_ietf_jgss_Oid$param_types$_init$dbf53d65c126dfa3[] = {
	&_jc_int$array$prim$type
};

_jc_method _jc_org_ietf_jgss_Oid$method_info$_init$dbf53d65c126dfa3 = {
	.name=			"<init>",
	.signature=		"([I)V",
	.class=			&_jc_org_ietf_jgss_Oid$type,
	.param_types=		&_jc_org_ietf_jgss_Oid$param_types$_init$dbf53d65c126dfa3,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_org_ietf_jgss_Oid$param_ptypes$_init$dbf53d65c126dfa3,
	.signature_hash=	_JC_JLONG(0xdbf53d65c126dfa3),
	.access_flags=		0,
	.function=		&_jc_org_ietf_jgss_Oid$method$_init$dbf53d65c126dfa3,
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_org_ietf_jgss_Oid$linenum_table$_init$dbf53d65c126dfa3
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(org_ietf_jgss_Oid, _init$dbf53d65c126dfa3);

void _JC_JCNI_ATTR
_jc_org_ietf_jgss_Oid$method$_init$dbf53d65c126dfa3(_jc_env *const env, _jc_org_ietf_jgss_Oid$object *this, _jc_int_array *param0)
{
	struct _jc_org_ietf_jgss_Oid$object *r0;
	_jc_int_array *r1;

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(227);				// 0
	_JC_REF_FIELD(env, r0, org_ietf_jgss_Oid, components) = r1;
	_JC_LINE_NUMBER(228);				// 1
	_JC_PRIM_FIELD(env, r0, org_ietf_jgss_Oid, relative) = 0;
	_JC_LINE_NUMBER(229);				// 2
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public boolean containedIn(org.ietf.jgss.Oid[])
//

static _jc_linenum _jc_org_ietf_jgss_Oid$linenum_table$containedIn$bf3b79cb0c898eb3[];

static const unsigned char _jc_org_ietf_jgss_Oid$param_ptypes$containedIn$bf3b79cb0c898eb3[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_org_ietf_jgss_Oid$param_types$containedIn$bf3b79cb0c898eb3[] = {
	&_jc_org_ietf_jgss_Oid$array$type
};

_jc_method _jc_org_ietf_jgss_Oid$method_info$containedIn$bf3b79cb0c898eb3 = {
	.name=			"containedIn",
	.signature=		"([Lorg/ietf/jgss/Oid;)Z",
	.class=			&_jc_org_ietf_jgss_Oid$type,
	.param_types=		&_jc_org_ietf_jgss_Oid$param_types$containedIn$bf3b79cb0c898eb3,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_org_ietf_jgss_Oid$param_ptypes$containedIn$bf3b79cb0c898eb3,
	.signature_hash=	_JC_JLONG(0xbf3b79cb0c898eb3),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_org_ietf_jgss_Oid$method$containedIn$bf3b79cb0c898eb3,
	.vtable_index=		_JC_OFFSETOF(struct _jc_org_ietf_jgss_Oid$vtable, org_ietf_jgss_Oid.containedIn$bf3b79cb0c898eb3) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_org_ietf_jgss_Oid$linenum_table$containedIn$bf3b79cb0c898eb3
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(org_ietf_jgss_Oid, containedIn$bf3b79cb0c898eb3);

jboolean _JC_JCNI_ATTR
_jc_org_ietf_jgss_Oid$method$containedIn$bf3b79cb0c898eb3(_jc_env *const env, _jc_org_ietf_jgss_Oid$object *this, _jc_object_array *param0)
{
	jint i0;
	jint i1;
	struct _jc_org_ietf_jgss_Oid$object *r0;
	_jc_object_array *r1;
	struct _jc_org_ietf_jgss_Oid$object *r2;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(333);				// 0
	i0 = 0;
	goto label2;

label0:
	_JC_LINE_NUMBER(335);				// 1
	r2 = _JC_REF_ELEMENT(env, r1, i0, 0, 1);
	z0 = _JC_INVOKE_VIRTUAL(env, org_ietf_jgss_Oid, equals$8a15e0625571c581, r0, r2);
	if (z0 == 0)
		goto label1;
	_JC_LINE_NUMBER(336);				// 2
	return 1;

label1:
	_JC_LINE_NUMBER(333);				// 3
	i0 = i0 + 1;

label2:
	i1 = _JC_ARRAY_LENGTH(env, r1);
	if (i0 < i1) {
		_JC_PERIODIC_CHECK(env);
		goto label0;
	}
	_JC_LINE_NUMBER(338);				// 4
	return 0;
}

//
// public boolean equals(java.lang.Object)
//

static _jc_linenum _jc_org_ietf_jgss_Oid$linenum_table$equals$8a15e0625571c581[];

static const unsigned char _jc_org_ietf_jgss_Oid$param_ptypes$equals$8a15e0625571c581[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_org_ietf_jgss_Oid$param_types$equals$8a15e0625571c581[] = {
	&_jc_java_lang_Object$type
};

_jc_method _jc_org_ietf_jgss_Oid$method_info$equals$8a15e0625571c581 = {
	.name=			"equals",
	.signature=		"(Ljava/lang/Object;)Z",
	.class=			&_jc_org_ietf_jgss_Oid$type,
	.param_types=		&_jc_org_ietf_jgss_Oid$param_types$equals$8a15e0625571c581,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_org_ietf_jgss_Oid$param_ptypes$equals$8a15e0625571c581,
	.signature_hash=	_JC_JLONG(0x8a15e0625571c581),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_org_ietf_jgss_Oid$method$equals$8a15e0625571c581,
	.vtable_index=		_JC_OFFSETOF(struct _jc_org_ietf_jgss_Oid$vtable, org_ietf_jgss_Oid.equals$8a15e0625571c581) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_org_ietf_jgss_Oid$linenum_table$equals$8a15e0625571c581
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(org_ietf_jgss_Oid, equals$8a15e0625571c581);

jboolean _JC_JCNI_ATTR
_jc_org_ietf_jgss_Oid$method$equals$8a15e0625571c581(_jc_env *const env, _jc_org_ietf_jgss_Oid$object *this, _jc_java_lang_Object$object *param0)
{
	struct _jc_org_ietf_jgss_Oid$object *r0;
	struct _jc_java_lang_Object$object *r1;
	struct _jc_org_ietf_jgss_Oid$object *r2;
	_jc_int_array *r3;
	_jc_int_array *r4;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(343);				// 0
	z0 = _JC_INSTANCEOF(env, r1, &_jc_org_ietf_jgss_Oid$type);
	if (z0 != 0)
		goto label0;
	_JC_LINE_NUMBER(344);				// 1
	return 0;

label0:
	_JC_LINE_NUMBER(345);				// 2
	r2 = r1;
	_JC_LINE_NUMBER(346);				// 3
	r3 = _JC_REF_FIELD(env, r0, org_ietf_jgss_Oid, components);
	r4 = _JC_REF_FIELD(env, r2, org_ietf_jgss_Oid, components);
	z0 = _JC_INVOKE_STATIC(env, java_util_Arrays, equals$d950a88658a4f610, 0, r3, r4);
	return z0;
}

//
// public byte[] getDER() throws org.ietf.jgss.GSSException
//

static _jc_linenum _jc_org_ietf_jgss_Oid$linenum_table$getDER$2dfc6b0a72a54857[];

static _jc_trap_info _jc_org_ietf_jgss_Oid$trap_table$getDER$2dfc6b0a72a54857[] = {
	_JC_TRAP(&_jc_java_lang_Exception$type, 3, 4),
	_JC_TRAP(&_jc_java_io_IOException$type, 1, 2),
};

static const unsigned char _jc_org_ietf_jgss_Oid$param_ptypes$getDER$2dfc6b0a72a54857[] = { 
_JC_TYPE_REFERENCE };

static _jc_type *const _jc_org_ietf_jgss_Oid$exceptions$getDER$2dfc6b0a72a54857[] = {
	&_jc_org_ietf_jgss_GSSException$type
};

_jc_method _jc_org_ietf_jgss_Oid$method_info$getDER$2dfc6b0a72a54857 = {
	.name=			"getDER",
	.signature=		"()[B",
	.class=			&_jc_org_ietf_jgss_Oid$type,
	.return_type=		&_jc_byte$array$prim$type,
	.param_ptypes=		&_jc_org_ietf_jgss_Oid$param_ptypes$getDER$2dfc6b0a72a54857,
	.signature_hash=	_JC_JLONG(0x2dfc6b0a72a54857),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_org_ietf_jgss_Oid$method$getDER$2dfc6b0a72a54857,
	.vtable_index=		_JC_OFFSETOF(struct _jc_org_ietf_jgss_Oid$vtable, org_ietf_jgss_Oid.getDER$2dfc6b0a72a54857) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_org_ietf_jgss_Oid$exceptions$getDER$2dfc6b0a72a54857,
	.u= { .exec= {
	  .trap_table_len=	2,
	  .trap_table=		_jc_org_ietf_jgss_Oid$trap_table$getDER$2dfc6b0a72a54857,
	  .u= {
	    .linenum= {
	      .len=	37,
	      .table=	_jc_org_ietf_jgss_Oid$linenum_table$getDER$2dfc6b0a72a54857
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(org_ietf_jgss_Oid, getDER$2dfc6b0a72a54857);

_jc_byte_array * _JC_JCNI_ATTR
_jc_org_ietf_jgss_Oid$method$getDER$2dfc6b0a72a54857(_jc_env *const env, _jc_org_ietf_jgss_Oid$object *this)
{
	jint i0;
	jint i1;
	jint i2;
	jint i3;
	jint i4;
	struct _jc_org_ietf_jgss_Oid$object *r0;
	struct _jc_java_io_ByteArrayOutputStream$object *r1;
	struct _jc_java_util_ResourceBundle$object *volatile r10;
	struct _jc_java_lang_String$object *volatile r11;
	struct _jc_java_lang_VMThrowable$object *volatile r13;
	_jc_byte_array *r2;
	_jc_int_array *r3;
	struct _jc_java_io_IOException$object *r4;
	struct _jc_org_ietf_jgss_GSSException$object *volatile r5;
	struct _jc_java_lang_Object$object *r6;
	_jc_byte_array *r7;
	struct _jc_java_lang_String$object *volatile r8;
	struct _jc_java_lang_Exception$object *r9;
	jboolean z0;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_org_ietf_jgss_Oid$method_info$getDER$2dfc6b0a72a54857, &&label11, &&label10);

	r0 = this;
	_JC_LINE_NUMBER(265);				// 0
	r2 = _JC_REF_FIELD(env, r0, org_ietf_jgss_Oid, derOid);
	if (r2 != _JC_NULL)
		goto label14;
	_JC_LINE_NUMBER(267);				// 1
	r1 = _JC_NEW(env, java_io_ByteArrayOutputStream);
	r7 = _JC_NEW_PRIM_ARRAY(env, byte, 1, 256);
	_JC_REF_FIELD(env, r1, java_io_ByteArrayOutputStream, buf) = r7;
	_JC_PRIM_FIELD(env, r1, java_io_ByteArrayOutputStream, count) = 0;
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(270);				// 2
	i0 = 0;
	_JC_LINE_NUMBER(271);				// 3
	z0 = _JC_PRIM_FIELD(env, r0, org_ietf_jgss_Oid, relative);
	if (z0 != 0)
		goto label2;
	_JC_LINE_NUMBER(273);				// 4
	r3 = _JC_REF_FIELD(env, r0, org_ietf_jgss_Oid, components);
	i0 = 1;
	i1 = _JC_PRIM_ELEMENT(env, int, r3, 0, 0, 1);
	i1 = i1 * 40;
	i2 = 0;
	r3 = _JC_REF_FIELD(env, r0, org_ietf_jgss_Oid, components);
	i3 = _JC_ARRAY_LENGTH(env, r3);
	if (i3 <= 1)
		goto label0;
	r3 = _JC_REF_FIELD(env, r0, org_ietf_jgss_Oid, components);
	i0 = 2;
	i2 = _JC_PRIM_ELEMENT(env, int, r3, 1, 0, 1);

label0:
	i1 = i1 + i2;
	_JC_LINE_NUMBER(275);				// 5
	_JC_INVOKE_STATIC(env, org_ietf_jgss_Oid, encodeSubId$f18e55a3572fb9d2, 1, r1, i1);
	_JC_LINE_NUMBER(277);				// 6
	goto label2;

label1:
	_JC_LINE_NUMBER(278);				// 7
	r3 = _JC_REF_FIELD(env, r0, org_ietf_jgss_Oid, components);
	i3 = _JC_PRIM_ELEMENT(env, int, r3, i0, 0, 1);
	_JC_INVOKE_STATIC(env, org_ietf_jgss_Oid, encodeSubId$f18e55a3572fb9d2, 1, r1, i3);
	_JC_LINE_NUMBER(277);				// 8
	i0 = i0 + 1;

label2:
	r3 = _JC_REF_FIELD(env, r0, org_ietf_jgss_Oid, components);
	i3 = _JC_ARRAY_LENGTH(env, r3);
	if (i0 < i3) {
		_JC_PERIODIC_CHECK(env);
		goto label1;
	}
	_JC_LINE_NUMBER(279);				// 9
	r2 = _JC_INVOKE_NONVIRTUAL(env, java_io_ByteArrayOutputStream, toByteArray$3292ac9bfdd8d59a, 0, r1);
	_JC_LINE_NUMBER(280);				// 10
	_JC_INVOKE_NONVIRTUAL(env, java_io_ByteArrayOutputStream, reset$229a80b3e8394a0f, 0, r1);
	_JC_LINE_NUMBER(281);				// 11
	z0 = _JC_PRIM_FIELD(env, r0, org_ietf_jgss_Oid, relative);
	if (z0 == 0)
		goto label3;
	_JC_LINE_NUMBER(282);				// 12
	_JC_INVOKE_NONVIRTUAL(env, java_io_ByteArrayOutputStream, write$6377ac6964854eb2, 0, r1, 13);
	goto label4;

label3:
	_JC_LINE_NUMBER(284);				// 13
	_JC_INVOKE_NONVIRTUAL(env, java_io_ByteArrayOutputStream, write$6377ac6964854eb2, 0, r1, 6);

label4:
	_JC_LINE_NUMBER(285);				// 14
	i3 = _JC_ARRAY_LENGTH(env, r2);
	if (i3 >= 128)
		goto label5;
	_JC_LINE_NUMBER(286);				// 15
	i3 = _JC_ARRAY_LENGTH(env, r2);
	_JC_INVOKE_NONVIRTUAL(env, java_io_ByteArrayOutputStream, write$6377ac6964854eb2, 0, r1, i3);
	goto label9;

label5:
	_JC_LINE_NUMBER(287);				// 16
	i3 = _JC_ARRAY_LENGTH(env, r2);
	if (i3 >= 256)
		goto label6;
	_JC_LINE_NUMBER(289);				// 17
	_JC_INVOKE_NONVIRTUAL(env, java_io_ByteArrayOutputStream, write$6377ac6964854eb2, 0, r1, 129);
	_JC_LINE_NUMBER(290);				// 18
	i3 = _JC_ARRAY_LENGTH(env, r2);
	_JC_INVOKE_NONVIRTUAL(env, java_io_ByteArrayOutputStream, write$6377ac6964854eb2, 0, r1, i3);
	goto label9;

label6:
	_JC_LINE_NUMBER(292);				// 19
	i3 = _JC_ARRAY_LENGTH(env, r2);
	if (i3 >= 65536)
		goto label7;
	_JC_LINE_NUMBER(294);				// 20
	_JC_INVOKE_NONVIRTUAL(env, java_io_ByteArrayOutputStream, write$6377ac6964854eb2, 0, r1, 130);
	_JC_LINE_NUMBER(295);				// 21
	i3 = _JC_ARRAY_LENGTH(env, r2);
	i3 = _JC_IUSHR(i3, 8);
	i3 = i3 & 255;
	_JC_INVOKE_NONVIRTUAL(env, java_io_ByteArrayOutputStream, write$6377ac6964854eb2, 0, r1, i3);
	_JC_LINE_NUMBER(296);				// 22
	i3 = _JC_ARRAY_LENGTH(env, r2);
	i3 = i3 & 255;
	_JC_INVOKE_NONVIRTUAL(env, java_io_ByteArrayOutputStream, write$6377ac6964854eb2, 0, r1, i3);
	goto label9;

label7:
	_JC_LINE_NUMBER(298);				// 23
	i3 = _JC_ARRAY_LENGTH(env, r2);
	if (i3 >= 16777216)
		goto label8;
	_JC_LINE_NUMBER(300);				// 24
	_JC_INVOKE_NONVIRTUAL(env, java_io_ByteArrayOutputStream, write$6377ac6964854eb2, 0, r1, 131);
	_JC_LINE_NUMBER(301);				// 25
	i3 = _JC_ARRAY_LENGTH(env, r2);
	i3 = _JC_IUSHR(i3, 16);
	i3 = i3 & 255;
	_JC_INVOKE_NONVIRTUAL(env, java_io_ByteArrayOutputStream, write$6377ac6964854eb2, 0, r1, i3);
	_JC_LINE_NUMBER(302);				// 26
	i3 = _JC_ARRAY_LENGTH(env, r2);
	i3 = _JC_IUSHR(i3, 8);
	i3 = i3 & 255;
	_JC_INVOKE_NONVIRTUAL(env, java_io_ByteArrayOutputStream, write$6377ac6964854eb2, 0, r1, i3);
	_JC_LINE_NUMBER(303);				// 27
	i3 = _JC_ARRAY_LENGTH(env, r2);
	i3 = i3 & 255;
	_JC_INVOKE_NONVIRTUAL(env, java_io_ByteArrayOutputStream, write$6377ac6964854eb2, 0, r1, i3);
	goto label9;

label8:
	_JC_LINE_NUMBER(307);				// 28
	_JC_INVOKE_NONVIRTUAL(env, java_io_ByteArrayOutputStream, write$6377ac6964854eb2, 0, r1, 132);
	_JC_LINE_NUMBER(308);				// 29
	i3 = _JC_ARRAY_LENGTH(env, r2);
	i3 = _JC_IUSHR(i3, 24);
	i3 = i3 & 255;
	_JC_INVOKE_NONVIRTUAL(env, java_io_ByteArrayOutputStream, write$6377ac6964854eb2, 0, r1, i3);
	_JC_LINE_NUMBER(309);				// 30
	i3 = _JC_ARRAY_LENGTH(env, r2);
	i3 = _JC_IUSHR(i3, 16);
	i3 = i3 & 255;
	_JC_INVOKE_NONVIRTUAL(env, java_io_ByteArrayOutputStream, write$6377ac6964854eb2, 0, r1, i3);
	_JC_LINE_NUMBER(310);				// 31
	i3 = _JC_ARRAY_LENGTH(env, r2);
	i3 = _JC_IUSHR(i3, 8);
	i3 = i3 & 255;
	_JC_INVOKE_NONVIRTUAL(env, java_io_ByteArrayOutputStream, write$6377ac6964854eb2, 0, r1, i3);
	_JC_LINE_NUMBER(311);				// 32
	i3 = _JC_ARRAY_LENGTH(env, r2);
	i3 = i3 & 255;
	_JC_INVOKE_NONVIRTUAL(env, java_io_ByteArrayOutputStream, write$6377ac6964854eb2, 0, r1, i3);

label9:
	i4 = _JC_ARRAY_LENGTH(env, r2);
	_JC_INVOKE_NONVIRTUAL(env, java_io_ByteArrayOutputStream, write$306a698343ec27e8, 0, r1, r2, 0, i4);
	_JC_TRAP_REGION(catch, 2);
	_JC_LINE_NUMBER(313);				// 33
	goto label13;

label10:
	_JC_TRAP_REGION(catch, 2);
	r4 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(317);				// 34
	r5 = _JC_NEW(env, org_ietf_jgss_GSSException);
	r8 = _JC_NULL;
	r11 = _JC_NULL;
	_JC_REF_FIELD(env, r5, java_lang_Throwable, cause) = r5;
	r13 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r5);
	_JC_REF_FIELD(env, r5, java_lang_Throwable, vmState) = r13;
	_JC_REF_FIELD(env, r5, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r5, java_lang_Throwable, detailMessage) = r11;
	_JC_PRIM_FIELD(env, r5, org_ietf_jgss_GSSException, major) = 13;
	_JC_PRIM_FIELD(env, r5, org_ietf_jgss_GSSException, minor) = 0;
	_JC_REF_FIELD(env, r5, org_ietf_jgss_GSSException, minorString) = r8;
	_JC_TRAP_REGION(catch, 3);
	r10 = _JC_INVOKE_STATIC(env, java_util_ResourceBundle, getBundle$7dc7df404e2acab0, 0, _JC_STRING(env, "org/ietf/jgss/MessagesBundle"));
	_JC_REF_FIELD(env, r5, org_ietf_jgss_GSSException, messages) = r10;
	_JC_TRAP_REGION(catch, 4);
	goto label12;

label11:
	_JC_TRAP_REGION(catch, 4);
	r9 = _JC_CAUGHT_EXCEPTION(env);
	_JC_REF_FIELD(env, r5, org_ietf_jgss_GSSException, messages) = _JC_NULL;

label12:
	_JC_THROW(env, r5);

label13:
	_JC_TRAP_REGION(catch, 4);
	_JC_LINE_NUMBER(319);				// 35
	r2 = _JC_INVOKE_NONVIRTUAL(env, java_io_ByteArrayOutputStream, toByteArray$3292ac9bfdd8d59a, 0, r1);
	_JC_REF_FIELD(env, r0, org_ietf_jgss_Oid, derOid) = r2;

label14:
	_JC_TRAP_REGION(catch, 4);
	_JC_LINE_NUMBER(321);				// 36
	r2 = _JC_REF_FIELD(env, r0, org_ietf_jgss_Oid, derOid);
	r6 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, clone$b75f2713d6705f70, r2);
	r2 = _JC_CAST_FINAL(env, &_jc_byte$array$prim$type, r6);
	_JC_CANCEL_TRAPS(env, catch);
	return r2;
}

//
// public int hashCode()
//

static _jc_linenum _jc_org_ietf_jgss_Oid$linenum_table$hashCode$53152098849316df[];

static const unsigned char _jc_org_ietf_jgss_Oid$param_ptypes$hashCode$53152098849316df[] = { 
_JC_TYPE_INT };

_jc_method _jc_org_ietf_jgss_Oid$method_info$hashCode$53152098849316df = {
	.name=			"hashCode",
	.signature=		"()I",
	.class=			&_jc_org_ietf_jgss_Oid$type,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_org_ietf_jgss_Oid$param_ptypes$hashCode$53152098849316df,
	.signature_hash=	_JC_JLONG(0x53152098849316df),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_org_ietf_jgss_Oid$method$hashCode$53152098849316df,
	.vtable_index=		_JC_OFFSETOF(struct _jc_org_ietf_jgss_Oid$vtable, org_ietf_jgss_Oid.hashCode$53152098849316df) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_org_ietf_jgss_Oid$linenum_table$hashCode$53152098849316df
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(org_ietf_jgss_Oid, hashCode$53152098849316df);

jint _JC_JCNI_ATTR
_jc_org_ietf_jgss_Oid$method$hashCode$53152098849316df(_jc_env *const env, _jc_org_ietf_jgss_Oid$object *this)
{
	jint i0;
	jint i1;
	jint i2;
	struct _jc_org_ietf_jgss_Oid$object *r0;
	_jc_int_array *r1;

	r0 = this;
	_JC_LINE_NUMBER(351);				// 0
	i0 = 0;
	_JC_LINE_NUMBER(352);				// 1
	i1 = 0;
	goto label1;

label0:
	_JC_LINE_NUMBER(353);				// 2
	r1 = _JC_REF_FIELD(env, r0, org_ietf_jgss_Oid, components);
	i2 = _JC_PRIM_ELEMENT(env, int, r1, i1, 0, 1);
	i0 = i0 + i2;
	_JC_LINE_NUMBER(352);				// 3
	i1 = i1 + 1;

label1:
	r1 = _JC_REF_FIELD(env, r0, org_ietf_jgss_Oid, components);
	i2 = _JC_ARRAY_LENGTH(env, r1);
	if (i1 < i2) {
		_JC_PERIODIC_CHECK(env);
		goto label0;
	}
	_JC_LINE_NUMBER(354);				// 4
	return i0;
}

//
// public java.lang.String toString()
//

static _jc_linenum _jc_org_ietf_jgss_Oid$linenum_table$toString$7ea43b33b80a3070[];

static const unsigned char _jc_org_ietf_jgss_Oid$param_ptypes$toString$7ea43b33b80a3070[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_org_ietf_jgss_Oid$method_info$toString$7ea43b33b80a3070 = {
	.name=			"toString",
	.signature=		"()Ljava/lang/String;",
	.class=			&_jc_org_ietf_jgss_Oid$type,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_org_ietf_jgss_Oid$param_ptypes$toString$7ea43b33b80a3070,
	.signature_hash=	_JC_JLONG(0x7ea43b33b80a3070),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_org_ietf_jgss_Oid$method$toString$7ea43b33b80a3070,
	.vtable_index=		_JC_OFFSETOF(struct _jc_org_ietf_jgss_Oid$vtable, org_ietf_jgss_Oid.toString$7ea43b33b80a3070) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	9,
	      .table=	_jc_org_ietf_jgss_Oid$linenum_table$toString$7ea43b33b80a3070
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(org_ietf_jgss_Oid, toString$7ea43b33b80a3070);

_jc_java_lang_String$object * _JC_JCNI_ATTR
_jc_org_ietf_jgss_Oid$method$toString$7ea43b33b80a3070(_jc_env *const env, _jc_org_ietf_jgss_Oid$object *this)
{
	jint i0;
	jint i1;
	struct _jc_org_ietf_jgss_Oid$object *r0;
	struct _jc_java_lang_StringBuffer$object *r1;
	struct _jc_java_lang_String$object *r2;
	_jc_int_array *r3;
	struct _jc_java_lang_String$object *r4;
	struct _jc_java_lang_String$object *r5;
	_jc_char_array *r6;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(242);				// 0
	r2 = _JC_REF_FIELD(env, r0, org_ietf_jgss_Oid, strOid);
	if (r2 != _JC_NULL)
		goto label3;
	_JC_LINE_NUMBER(244);				// 1
	r1 = _JC_NEW(env, java_lang_StringBuffer);
	r6 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r1, java_lang_StringBuffer, value) = r6;
	_JC_LINE_NUMBER(245);				// 2
	i0 = 0;
	goto label2;

label0:
	_JC_LINE_NUMBER(247);				// 3
	r3 = _JC_REF_FIELD(env, r0, org_ietf_jgss_Oid, components);
	i1 = _JC_PRIM_ELEMENT(env, int, r3, i0, 0, 1);
	_JC_ACTIVE_USE(env, java_lang_String);
	r4 = _JC_INVOKE_STATIC(env, java_lang_Integer, toString$80d919d12afaaa2b, 0, i1, 10);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r1, r4);
	_JC_LINE_NUMBER(248);				// 4
	r3 = _JC_REF_FIELD(env, r0, org_ietf_jgss_Oid, components);
	i1 = _JC_ARRAY_LENGTH(env, r3);
	i1 = i1 - 1;
	if (i0 >= i1)
		goto label1;
	_JC_LINE_NUMBER(249);				// 5
	_JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$9450b16e89f0618d, 0, r1, 46);

label1:
	_JC_LINE_NUMBER(245);				// 6
	i0 = i0 + 1;

label2:
	r3 = _JC_REF_FIELD(env, r0, org_ietf_jgss_Oid, components);
	i1 = _JC_ARRAY_LENGTH(env, r3);
	if (i0 < i1) {
		_JC_PERIODIC_CHECK(env);
		goto label0;
	}
	r5 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r5, r1);
	_JC_LINE_NUMBER(251);				// 7
	_JC_REF_FIELD(env, r0, org_ietf_jgss_Oid, strOid) = r5;

label3:
	_JC_LINE_NUMBER(253);				// 8
	r2 = _JC_REF_FIELD(env, r0, org_ietf_jgss_Oid, strOid);
	return r2;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_org_ietf_jgss_Oid$methods[] = {
	&_jc_org_ietf_jgss_Oid$method_info$_init$3887600c17c5e554,
	&_jc_org_ietf_jgss_Oid$method_info$_init$c31b894660454d13,
	&_jc_org_ietf_jgss_Oid$method_info$_init$aaa7e255fe505158,
	&_jc_org_ietf_jgss_Oid$method_info$_init$dbf53d65c126dfa3,
	&_jc_org_ietf_jgss_Oid$method_info$containedIn$bf3b79cb0c898eb3,
	&_jc_org_ietf_jgss_Oid$method_info$encodeSubId$f18e55a3572fb9d2,
	&_jc_org_ietf_jgss_Oid$method_info$equals$8a15e0625571c581,
	&_jc_org_ietf_jgss_Oid$method_info$getDER$2dfc6b0a72a54857,
	&_jc_org_ietf_jgss_Oid$method_info$hashCode$53152098849316df,
	&_jc_org_ietf_jgss_Oid$method_info$toString$7ea43b33b80a3070
};

/************************************************************************
 *			  Class fields structure			*
 ************************************************************************/

_jc_org_ietf_jgss_Oid$fields_struct _jc_org_ietf_jgss_Oid$class_fields = { };

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_org_ietf_jgss_Oid$instanceof_hash_bucket_2[] = {
	&_jc_org_ietf_jgss_Oid$type,
	_JC_NULL
};
static _jc_type *const _jc_org_ietf_jgss_Oid$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_org_ietf_jgss_Oid$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[2]=	_jc_org_ietf_jgss_Oid$instanceof_hash_bucket_2,
	[101]=	_jc_org_ietf_jgss_Oid$instanceof_hash_bucket_101
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_org_ietf_jgss_Oid$class_depends[] = {
	{ "java/io/ByteArrayInputStream",	_JC_JLONG(0xa68cc27886fd8be3) },
	{ "java/io/ByteArrayOutputStream",	_JC_JLONG(0xc4d3cc2bda03a338) },
	{ "java/io/DataInputStream",	_JC_JLONG(0xcc3ce5b592e8a1d) },
	{ "java/io/FilterInputStream",	_JC_JLONG(0x455accfa535f5dfe) },
	{ "java/io/IOException",	_JC_JLONG(0x4e0a56550c69d57c) },
	{ "java/io/InputStream",	_JC_JLONG(0x66aea4d152614ac4) },
	{ "java/io/OutputStream",	_JC_JLONG(0x4026d3144d6654d8) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/Integer",	_JC_JLONG(0xca631501391a31f1) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/StringBuffer",	_JC_JLONG(0x94d357637b968dda) },
	{ "java/lang/System",	_JC_JLONG(0x53cc8e2333795f04) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMSystem",	_JC_JLONG(0x4d1cebae0bdda058) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/math/BigInteger",	_JC_JLONG(0x7717ded55c30b7f3) },
	{ "java/util/Arrays",	_JC_JLONG(0x363c8597b4f8d5ff) },
	{ "java/util/ResourceBundle",	_JC_JLONG(0xb0f2ff51263ebf06) },
	{ "java/util/StringTokenizer",	_JC_JLONG(0xb106445ca218ee16) },
	{ "org/ietf/jgss/GSSException",	_JC_JLONG(0xd82ad86895ee19c6) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_org_ietf_jgss_Oid$vtype _jc_org_ietf_jgss_Oid$type = {
    .type= {
	.name=			"org/ietf/jgss/Oid",
	.superclass=		&_jc_java_lang_Object$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		16,
		.hash=			_JC_JLONG(0xfeb3400b12072102),
		.source_file=		"Oid.java",
		.instance_size=		sizeof(_jc_org_ietf_jgss_Oid$refs) + sizeof(_jc_org_ietf_jgss_Oid$object),
		.num_virtual_refs=	3,
		.num_fields=		sizeof(_jc_org_ietf_jgss_Oid$fields) / sizeof(*_jc_org_ietf_jgss_Oid$fields),
		.fields=		_jc_org_ietf_jgss_Oid$fields,
		.num_methods=		sizeof(_jc_org_ietf_jgss_Oid$methods) / sizeof(*_jc_org_ietf_jgss_Oid$methods),
		.methods=		_jc_org_ietf_jgss_Oid$methods,
		.instanceof_hash_table=	_jc_org_ietf_jgss_Oid$instanceof_hash_table,
		.class_fields=		&_jc_org_ietf_jgss_Oid$class_fields,
		.num_class_depends=		sizeof(_jc_org_ietf_jgss_Oid$class_depends) / sizeof(*_jc_org_ietf_jgss_Oid$class_depends),
		.class_depends=		_jc_org_ietf_jgss_Oid$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=			// overridden
		&_jc_org_ietf_jgss_Oid$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=			// overridden
		&_jc_org_ietf_jgss_Oid$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=			// overridden
		&_jc_org_ietf_jgss_Oid$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.org_ietf_jgss_Oid= {
	    .containedIn$bf3b79cb0c898eb3=
		&_jc_org_ietf_jgss_Oid$method$containedIn$bf3b79cb0c898eb3,
	    .equals$8a15e0625571c581=
		&_jc_org_ietf_jgss_Oid$method$equals$8a15e0625571c581,
	    .getDER$2dfc6b0a72a54857=
		&_jc_org_ietf_jgss_Oid$method$getDER$2dfc6b0a72a54857,
	    .hashCode$53152098849316df=
		&_jc_org_ietf_jgss_Oid$method$hashCode$53152098849316df,
	    .toString$7ea43b33b80a3070=
		&_jc_org_ietf_jgss_Oid$method$toString$7ea43b33b80a3070,
	},
    }
};

