// public abstract interface polyglot.ast.NodeOps

// class file dependencies
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 9ee0d92ce1525a4d java_util_List
// @dep_class 1c402b4f9747e08 polyglot_ast_Node
// @dep_class 42de7cc460e24a46 polyglot_ast_NodeOps
// @dep_class a433cdcd788f6c37 polyglot_types_Context
// @dep_class 45f755f5298b5b39 polyglot_types_SemanticException
// @dep_class ed171cdaca38ec28 polyglot_types_TypeSystem
// @dep_class bda7215170a25efc polyglot_util_CodeWriter
// @dep_class 3e84230834234fb4 polyglot_visit_AddMemberVisitor
// @dep_class 67d28117807b75a9 polyglot_visit_AmbiguityRemover
// @dep_class 5d560b7b79a8692b polyglot_visit_ConstantFolder
// @dep_class ca5c3925d3e8cf05 polyglot_visit_ExceptionChecker
// @dep_class 534db787197439f0 polyglot_visit_NodeVisitor
// @dep_class 9b5998bb4b90b099 polyglot_visit_PrettyPrinter
// @dep_class 91b74e58638056a5 polyglot_visit_Translator
// @dep_class 50fbc424ac80c744 polyglot_visit_TypeBuilder
// @dep_class 478d58036bde3016 polyglot_visit_TypeChecker

// header file dependencies
// @dep_header java_lang_Class
// @dep_header java_lang_String
// @dep_header java_util_List
// @dep_header polyglot_ast_Node
// @dep_header polyglot_ast_NodeOps
// @dep_header polyglot_types_Context
// @dep_header polyglot_types_SemanticException
// @dep_header polyglot_types_TypeSystem
// @dep_header polyglot_util_CodeWriter
// @dep_header polyglot_visit_AddMemberVisitor
// @dep_header polyglot_visit_AmbiguityRemover
// @dep_header polyglot_visit_ConstantFolder
// @dep_header polyglot_visit_ExceptionChecker
// @dep_header polyglot_visit_Translator
// @dep_header polyglot_visit_TypeBuilder
// @dep_header polyglot_visit_TypeChecker

#include "jc_defs.h"

#include "java/lang/Class.h"
#include "java/lang/String.h"
#include "java/util/List.h"
#include "polyglot/ast/Node.h"
#include "polyglot/ast/NodeOps.h"
#include "polyglot/types/Context.h"
#include "polyglot/types/SemanticException.h"
#include "polyglot/types/TypeSystem.h"
#include "polyglot/util/CodeWriter.h"
#include "polyglot/visit/AddMemberVisitor.h"
#include "polyglot/visit/AmbiguityRemover.h"
#include "polyglot/visit/ConstantFolder.h"
#include "polyglot/visit/ExceptionChecker.h"
#include "polyglot/visit/Translator.h"
#include "polyglot/visit/TypeBuilder.h"
#include "polyglot/visit/TypeChecker.h"

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public abstract void addDecls(polyglot.types.Context)
//

static const unsigned char _jc_polyglot_ast_NodeOps$param_ptypes$addDecls$466c32a4263da0dd[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_ast_NodeOps$param_types$addDecls$466c32a4263da0dd[] = {
	&_jc_polyglot_types_Context$type
};

_jc_method _jc_polyglot_ast_NodeOps$method_info$addDecls$466c32a4263da0dd = {
	.name=			"addDecls",
	.signature=		"(Lpolyglot/types/Context;)V",
	.class=			&_jc_polyglot_ast_NodeOps$type,
	.param_types=		&_jc_polyglot_ast_NodeOps$param_types$addDecls$466c32a4263da0dd,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_ast_NodeOps$param_ptypes$addDecls$466c32a4263da0dd,
	.signature_hash=	_JC_JLONG(0x466c32a4263da0dd),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
};

//
// public abstract polyglot.ast.Node addMembers(polyglot.visit.AddMemberVisitor) throws polyglot.types.SemanticException
//

static const unsigned char _jc_polyglot_ast_NodeOps$param_ptypes$addMembers$b968ee2b48e68bf8[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_ast_NodeOps$exceptions$addMembers$b968ee2b48e68bf8[] = {
	&_jc_polyglot_types_SemanticException$type
};

static _jc_type *const _jc_polyglot_ast_NodeOps$param_types$addMembers$b968ee2b48e68bf8[] = {
	&_jc_polyglot_visit_AddMemberVisitor$type
};

_jc_method _jc_polyglot_ast_NodeOps$method_info$addMembers$b968ee2b48e68bf8 = {
	.name=			"addMembers",
	.signature=		"(Lpolyglot/visit/AddMemberVisitor;)Lpolyglot/ast/Node;",
	.class=			&_jc_polyglot_ast_NodeOps$type,
	.param_types=		&_jc_polyglot_ast_NodeOps$param_types$addMembers$b968ee2b48e68bf8,
	.return_type=		&_jc_polyglot_ast_Node$type,
	.param_ptypes=		&_jc_polyglot_ast_NodeOps$param_ptypes$addMembers$b968ee2b48e68bf8,
	.signature_hash=	_JC_JLONG(0xb968ee2b48e68bf8),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_ast_NodeOps$exceptions$addMembers$b968ee2b48e68bf8,
};

//
// public abstract polyglot.visit.NodeVisitor addMembersEnter(polyglot.visit.AddMemberVisitor) throws polyglot.types.SemanticException
//

static const unsigned char _jc_polyglot_ast_NodeOps$param_ptypes$addMembersEnter$5330305f218d104a[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_ast_NodeOps$exceptions$addMembersEnter$5330305f218d104a[] = {
	&_jc_polyglot_types_SemanticException$type
};

static _jc_type *const _jc_polyglot_ast_NodeOps$param_types$addMembersEnter$5330305f218d104a[] = {
	&_jc_polyglot_visit_AddMemberVisitor$type
};

_jc_method _jc_polyglot_ast_NodeOps$method_info$addMembersEnter$5330305f218d104a = {
	.name=			"addMembersEnter",
	.signature=		"(Lpolyglot/visit/AddMemberVisitor;)Lpolyglot/visit/NodeVisitor;",
	.class=			&_jc_polyglot_ast_NodeOps$type,
	.param_types=		&_jc_polyglot_ast_NodeOps$param_types$addMembersEnter$5330305f218d104a,
	.return_type=		&_jc_polyglot_visit_NodeVisitor$type,
	.param_ptypes=		&_jc_polyglot_ast_NodeOps$param_ptypes$addMembersEnter$5330305f218d104a,
	.signature_hash=	_JC_JLONG(0x5330305f218d104a),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_ast_NodeOps$exceptions$addMembersEnter$5330305f218d104a,
};

//
// public abstract polyglot.ast.Node buildTypes(polyglot.visit.TypeBuilder) throws polyglot.types.SemanticException
//

static const unsigned char _jc_polyglot_ast_NodeOps$param_ptypes$buildTypes$df90664105e3e235[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_ast_NodeOps$exceptions$buildTypes$df90664105e3e235[] = {
	&_jc_polyglot_types_SemanticException$type
};

static _jc_type *const _jc_polyglot_ast_NodeOps$param_types$buildTypes$df90664105e3e235[] = {
	&_jc_polyglot_visit_TypeBuilder$type
};

_jc_method _jc_polyglot_ast_NodeOps$method_info$buildTypes$df90664105e3e235 = {
	.name=			"buildTypes",
	.signature=		"(Lpolyglot/visit/TypeBuilder;)Lpolyglot/ast/Node;",
	.class=			&_jc_polyglot_ast_NodeOps$type,
	.param_types=		&_jc_polyglot_ast_NodeOps$param_types$buildTypes$df90664105e3e235,
	.return_type=		&_jc_polyglot_ast_Node$type,
	.param_ptypes=		&_jc_polyglot_ast_NodeOps$param_ptypes$buildTypes$df90664105e3e235,
	.signature_hash=	_JC_JLONG(0xdf90664105e3e235),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_ast_NodeOps$exceptions$buildTypes$df90664105e3e235,
};

//
// public abstract polyglot.visit.NodeVisitor buildTypesEnter(polyglot.visit.TypeBuilder) throws polyglot.types.SemanticException
//

static const unsigned char _jc_polyglot_ast_NodeOps$param_ptypes$buildTypesEnter$72be41a96a202660[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_ast_NodeOps$exceptions$buildTypesEnter$72be41a96a202660[] = {
	&_jc_polyglot_types_SemanticException$type
};

static _jc_type *const _jc_polyglot_ast_NodeOps$param_types$buildTypesEnter$72be41a96a202660[] = {
	&_jc_polyglot_visit_TypeBuilder$type
};

_jc_method _jc_polyglot_ast_NodeOps$method_info$buildTypesEnter$72be41a96a202660 = {
	.name=			"buildTypesEnter",
	.signature=		"(Lpolyglot/visit/TypeBuilder;)Lpolyglot/visit/NodeVisitor;",
	.class=			&_jc_polyglot_ast_NodeOps$type,
	.param_types=		&_jc_polyglot_ast_NodeOps$param_types$buildTypesEnter$72be41a96a202660,
	.return_type=		&_jc_polyglot_visit_NodeVisitor$type,
	.param_ptypes=		&_jc_polyglot_ast_NodeOps$param_ptypes$buildTypesEnter$72be41a96a202660,
	.signature_hash=	_JC_JLONG(0x72be41a96a202660),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_ast_NodeOps$exceptions$buildTypesEnter$72be41a96a202660,
};

//
// public abstract polyglot.ast.Node disambiguate(polyglot.visit.AmbiguityRemover) throws polyglot.types.SemanticException
//

static const unsigned char _jc_polyglot_ast_NodeOps$param_ptypes$disambiguate$d149e043dfa73b41[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_ast_NodeOps$exceptions$disambiguate$d149e043dfa73b41[] = {
	&_jc_polyglot_types_SemanticException$type
};

static _jc_type *const _jc_polyglot_ast_NodeOps$param_types$disambiguate$d149e043dfa73b41[] = {
	&_jc_polyglot_visit_AmbiguityRemover$type
};

_jc_method _jc_polyglot_ast_NodeOps$method_info$disambiguate$d149e043dfa73b41 = {
	.name=			"disambiguate",
	.signature=		"(Lpolyglot/visit/AmbiguityRemover;)Lpolyglot/ast/Node;",
	.class=			&_jc_polyglot_ast_NodeOps$type,
	.param_types=		&_jc_polyglot_ast_NodeOps$param_types$disambiguate$d149e043dfa73b41,
	.return_type=		&_jc_polyglot_ast_Node$type,
	.param_ptypes=		&_jc_polyglot_ast_NodeOps$param_ptypes$disambiguate$d149e043dfa73b41,
	.signature_hash=	_JC_JLONG(0xd149e043dfa73b41),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_ast_NodeOps$exceptions$disambiguate$d149e043dfa73b41,
};

//
// public abstract polyglot.visit.NodeVisitor disambiguateEnter(polyglot.visit.AmbiguityRemover) throws polyglot.types.SemanticException
//

static const unsigned char _jc_polyglot_ast_NodeOps$param_ptypes$disambiguateEnter$fb826386ba1653d7[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_ast_NodeOps$exceptions$disambiguateEnter$fb826386ba1653d7[] = {
	&_jc_polyglot_types_SemanticException$type
};

static _jc_type *const _jc_polyglot_ast_NodeOps$param_types$disambiguateEnter$fb826386ba1653d7[] = {
	&_jc_polyglot_visit_AmbiguityRemover$type
};

_jc_method _jc_polyglot_ast_NodeOps$method_info$disambiguateEnter$fb826386ba1653d7 = {
	.name=			"disambiguateEnter",
	.signature=		"(Lpolyglot/visit/AmbiguityRemover;)Lpolyglot/visit/NodeVisitor;",
	.class=			&_jc_polyglot_ast_NodeOps$type,
	.param_types=		&_jc_polyglot_ast_NodeOps$param_types$disambiguateEnter$fb826386ba1653d7,
	.return_type=		&_jc_polyglot_visit_NodeVisitor$type,
	.param_ptypes=		&_jc_polyglot_ast_NodeOps$param_ptypes$disambiguateEnter$fb826386ba1653d7,
	.signature_hash=	_JC_JLONG(0xfb826386ba1653d7),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_ast_NodeOps$exceptions$disambiguateEnter$fb826386ba1653d7,
};

//
// public abstract polyglot.types.Context enterScope(polyglot.ast.Node, polyglot.types.Context)
//

static const unsigned char _jc_polyglot_ast_NodeOps$param_ptypes$enterScope$fe7413075884500c[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_ast_NodeOps$param_types$enterScope$fe7413075884500c[] = {
	&_jc_polyglot_ast_Node$type,
	&_jc_polyglot_types_Context$type
};

_jc_method _jc_polyglot_ast_NodeOps$method_info$enterScope$fe7413075884500c = {
	.name=			"enterScope",
	.signature=		"(Lpolyglot/ast/Node;Lpolyglot/types/Context;)Lpolyglot/types/Context;",
	.class=			&_jc_polyglot_ast_NodeOps$type,
	.param_types=		&_jc_polyglot_ast_NodeOps$param_types$enterScope$fe7413075884500c,
	.return_type=		&_jc_polyglot_types_Context$type,
	.param_ptypes=		&_jc_polyglot_ast_NodeOps$param_ptypes$enterScope$fe7413075884500c,
	.signature_hash=	_JC_JLONG(0xfe7413075884500c),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	2,
};

//
// public abstract polyglot.types.Context enterScope(polyglot.types.Context)
//

static const unsigned char _jc_polyglot_ast_NodeOps$param_ptypes$enterScope$fabeac726ca62dc1[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_ast_NodeOps$param_types$enterScope$fabeac726ca62dc1[] = {
	&_jc_polyglot_types_Context$type
};

_jc_method _jc_polyglot_ast_NodeOps$method_info$enterScope$fabeac726ca62dc1 = {
	.name=			"enterScope",
	.signature=		"(Lpolyglot/types/Context;)Lpolyglot/types/Context;",
	.class=			&_jc_polyglot_ast_NodeOps$type,
	.param_types=		&_jc_polyglot_ast_NodeOps$param_types$enterScope$fabeac726ca62dc1,
	.return_type=		&_jc_polyglot_types_Context$type,
	.param_ptypes=		&_jc_polyglot_ast_NodeOps$param_ptypes$enterScope$fabeac726ca62dc1,
	.signature_hash=	_JC_JLONG(0xfabeac726ca62dc1),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
};

//
// public abstract polyglot.ast.Node exceptionCheck(polyglot.visit.ExceptionChecker) throws polyglot.types.SemanticException
//

static const unsigned char _jc_polyglot_ast_NodeOps$param_ptypes$exceptionCheck$7e82ac8adaa6681a[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_ast_NodeOps$exceptions$exceptionCheck$7e82ac8adaa6681a[] = {
	&_jc_polyglot_types_SemanticException$type
};

static _jc_type *const _jc_polyglot_ast_NodeOps$param_types$exceptionCheck$7e82ac8adaa6681a[] = {
	&_jc_polyglot_visit_ExceptionChecker$type
};

_jc_method _jc_polyglot_ast_NodeOps$method_info$exceptionCheck$7e82ac8adaa6681a = {
	.name=			"exceptionCheck",
	.signature=		"(Lpolyglot/visit/ExceptionChecker;)Lpolyglot/ast/Node;",
	.class=			&_jc_polyglot_ast_NodeOps$type,
	.param_types=		&_jc_polyglot_ast_NodeOps$param_types$exceptionCheck$7e82ac8adaa6681a,
	.return_type=		&_jc_polyglot_ast_Node$type,
	.param_ptypes=		&_jc_polyglot_ast_NodeOps$param_ptypes$exceptionCheck$7e82ac8adaa6681a,
	.signature_hash=	_JC_JLONG(0x7e82ac8adaa6681a),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_ast_NodeOps$exceptions$exceptionCheck$7e82ac8adaa6681a,
};

//
// public abstract polyglot.visit.NodeVisitor exceptionCheckEnter(polyglot.visit.ExceptionChecker) throws polyglot.types.SemanticException
//

static const unsigned char _jc_polyglot_ast_NodeOps$param_ptypes$exceptionCheckEnter$4be1ca87c35f7838[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_ast_NodeOps$exceptions$exceptionCheckEnter$4be1ca87c35f7838[] = {
	&_jc_polyglot_types_SemanticException$type
};

static _jc_type *const _jc_polyglot_ast_NodeOps$param_types$exceptionCheckEnter$4be1ca87c35f7838[] = {
	&_jc_polyglot_visit_ExceptionChecker$type
};

_jc_method _jc_polyglot_ast_NodeOps$method_info$exceptionCheckEnter$4be1ca87c35f7838 = {
	.name=			"exceptionCheckEnter",
	.signature=		"(Lpolyglot/visit/ExceptionChecker;)Lpolyglot/visit/NodeVisitor;",
	.class=			&_jc_polyglot_ast_NodeOps$type,
	.param_types=		&_jc_polyglot_ast_NodeOps$param_types$exceptionCheckEnter$4be1ca87c35f7838,
	.return_type=		&_jc_polyglot_visit_NodeVisitor$type,
	.param_ptypes=		&_jc_polyglot_ast_NodeOps$param_ptypes$exceptionCheckEnter$4be1ca87c35f7838,
	.signature_hash=	_JC_JLONG(0x4be1ca87c35f7838),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_ast_NodeOps$exceptions$exceptionCheckEnter$4be1ca87c35f7838,
};

//
// public abstract polyglot.ast.Node foldConstants(polyglot.visit.ConstantFolder)
//

static const unsigned char _jc_polyglot_ast_NodeOps$param_ptypes$foldConstants$fbe0045def0a58b5[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_ast_NodeOps$param_types$foldConstants$fbe0045def0a58b5[] = {
	&_jc_polyglot_visit_ConstantFolder$type
};

_jc_method _jc_polyglot_ast_NodeOps$method_info$foldConstants$fbe0045def0a58b5 = {
	.name=			"foldConstants",
	.signature=		"(Lpolyglot/visit/ConstantFolder;)Lpolyglot/ast/Node;",
	.class=			&_jc_polyglot_ast_NodeOps$type,
	.param_types=		&_jc_polyglot_ast_NodeOps$param_types$foldConstants$fbe0045def0a58b5,
	.return_type=		&_jc_polyglot_ast_Node$type,
	.param_ptypes=		&_jc_polyglot_ast_NodeOps$param_ptypes$foldConstants$fbe0045def0a58b5,
	.signature_hash=	_JC_JLONG(0xfbe0045def0a58b5),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
};

//
// public abstract polyglot.visit.NodeVisitor foldConstantsEnter(polyglot.visit.ConstantFolder)
//

static const unsigned char _jc_polyglot_ast_NodeOps$param_ptypes$foldConstantsEnter$5379229ad3fbc2f1[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_ast_NodeOps$param_types$foldConstantsEnter$5379229ad3fbc2f1[] = {
	&_jc_polyglot_visit_ConstantFolder$type
};

_jc_method _jc_polyglot_ast_NodeOps$method_info$foldConstantsEnter$5379229ad3fbc2f1 = {
	.name=			"foldConstantsEnter",
	.signature=		"(Lpolyglot/visit/ConstantFolder;)Lpolyglot/visit/NodeVisitor;",
	.class=			&_jc_polyglot_ast_NodeOps$type,
	.param_types=		&_jc_polyglot_ast_NodeOps$param_types$foldConstantsEnter$5379229ad3fbc2f1,
	.return_type=		&_jc_polyglot_visit_NodeVisitor$type,
	.param_ptypes=		&_jc_polyglot_ast_NodeOps$param_ptypes$foldConstantsEnter$5379229ad3fbc2f1,
	.signature_hash=	_JC_JLONG(0x5379229ad3fbc2f1),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
};

//
// public abstract void prettyPrint(polyglot.util.CodeWriter, polyglot.visit.PrettyPrinter)
//

static const unsigned char _jc_polyglot_ast_NodeOps$param_ptypes$prettyPrint$323ca37cb40f93d3[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_ast_NodeOps$param_types$prettyPrint$323ca37cb40f93d3[] = {
	&_jc_polyglot_util_CodeWriter$type,
	&_jc_polyglot_visit_PrettyPrinter$type
};

_jc_method _jc_polyglot_ast_NodeOps$method_info$prettyPrint$323ca37cb40f93d3 = {
	.name=			"prettyPrint",
	.signature=		"(Lpolyglot/util/CodeWriter;Lpolyglot/visit/PrettyPrinter;)V",
	.class=			&_jc_polyglot_ast_NodeOps$type,
	.param_types=		&_jc_polyglot_ast_NodeOps$param_types$prettyPrint$323ca37cb40f93d3,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_ast_NodeOps$param_ptypes$prettyPrint$323ca37cb40f93d3,
	.signature_hash=	_JC_JLONG(0x323ca37cb40f93d3),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	2,
};

//
// public abstract java.util.List throwTypes(polyglot.types.TypeSystem)
//

static const unsigned char _jc_polyglot_ast_NodeOps$param_ptypes$throwTypes$7c1f300c448e8fc3[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_ast_NodeOps$param_types$throwTypes$7c1f300c448e8fc3[] = {
	&_jc_polyglot_types_TypeSystem$type
};

_jc_method _jc_polyglot_ast_NodeOps$method_info$throwTypes$7c1f300c448e8fc3 = {
	.name=			"throwTypes",
	.signature=		"(Lpolyglot/types/TypeSystem;)Ljava/util/List;",
	.class=			&_jc_polyglot_ast_NodeOps$type,
	.param_types=		&_jc_polyglot_ast_NodeOps$param_types$throwTypes$7c1f300c448e8fc3,
	.return_type=		&_jc_java_util_List$type,
	.param_ptypes=		&_jc_polyglot_ast_NodeOps$param_ptypes$throwTypes$7c1f300c448e8fc3,
	.signature_hash=	_JC_JLONG(0x7c1f300c448e8fc3),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
};

//
// public abstract void translate(polyglot.util.CodeWriter, polyglot.visit.Translator)
//

static const unsigned char _jc_polyglot_ast_NodeOps$param_ptypes$translate$a71b7acdcea34061[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_ast_NodeOps$param_types$translate$a71b7acdcea34061[] = {
	&_jc_polyglot_util_CodeWriter$type,
	&_jc_polyglot_visit_Translator$type
};

_jc_method _jc_polyglot_ast_NodeOps$method_info$translate$a71b7acdcea34061 = {
	.name=			"translate",
	.signature=		"(Lpolyglot/util/CodeWriter;Lpolyglot/visit/Translator;)V",
	.class=			&_jc_polyglot_ast_NodeOps$type,
	.param_types=		&_jc_polyglot_ast_NodeOps$param_types$translate$a71b7acdcea34061,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_ast_NodeOps$param_ptypes$translate$a71b7acdcea34061,
	.signature_hash=	_JC_JLONG(0xa71b7acdcea34061),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	2,
};

//
// public abstract polyglot.ast.Node typeCheck(polyglot.visit.TypeChecker) throws polyglot.types.SemanticException
//

static const unsigned char _jc_polyglot_ast_NodeOps$param_ptypes$typeCheck$ae9be7fcd0a04a49[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_ast_NodeOps$exceptions$typeCheck$ae9be7fcd0a04a49[] = {
	&_jc_polyglot_types_SemanticException$type
};

static _jc_type *const _jc_polyglot_ast_NodeOps$param_types$typeCheck$ae9be7fcd0a04a49[] = {
	&_jc_polyglot_visit_TypeChecker$type
};

_jc_method _jc_polyglot_ast_NodeOps$method_info$typeCheck$ae9be7fcd0a04a49 = {
	.name=			"typeCheck",
	.signature=		"(Lpolyglot/visit/TypeChecker;)Lpolyglot/ast/Node;",
	.class=			&_jc_polyglot_ast_NodeOps$type,
	.param_types=		&_jc_polyglot_ast_NodeOps$param_types$typeCheck$ae9be7fcd0a04a49,
	.return_type=		&_jc_polyglot_ast_Node$type,
	.param_ptypes=		&_jc_polyglot_ast_NodeOps$param_ptypes$typeCheck$ae9be7fcd0a04a49,
	.signature_hash=	_JC_JLONG(0xae9be7fcd0a04a49),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_ast_NodeOps$exceptions$typeCheck$ae9be7fcd0a04a49,
};

//
// public abstract polyglot.visit.NodeVisitor typeCheckEnter(polyglot.visit.TypeChecker) throws polyglot.types.SemanticException
//

static const unsigned char _jc_polyglot_ast_NodeOps$param_ptypes$typeCheckEnter$550e759e0ec94272[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_ast_NodeOps$exceptions$typeCheckEnter$550e759e0ec94272[] = {
	&_jc_polyglot_types_SemanticException$type
};

static _jc_type *const _jc_polyglot_ast_NodeOps$param_types$typeCheckEnter$550e759e0ec94272[] = {
	&_jc_polyglot_visit_TypeChecker$type
};

_jc_method _jc_polyglot_ast_NodeOps$method_info$typeCheckEnter$550e759e0ec94272 = {
	.name=			"typeCheckEnter",
	.signature=		"(Lpolyglot/visit/TypeChecker;)Lpolyglot/visit/NodeVisitor;",
	.class=			&_jc_polyglot_ast_NodeOps$type,
	.param_types=		&_jc_polyglot_ast_NodeOps$param_types$typeCheckEnter$550e759e0ec94272,
	.return_type=		&_jc_polyglot_visit_NodeVisitor$type,
	.param_ptypes=		&_jc_polyglot_ast_NodeOps$param_ptypes$typeCheckEnter$550e759e0ec94272,
	.signature_hash=	_JC_JLONG(0x550e759e0ec94272),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_ast_NodeOps$exceptions$typeCheckEnter$550e759e0ec94272,
};

//
// public abstract polyglot.ast.Node visitChildren(polyglot.visit.NodeVisitor)
//

static const unsigned char _jc_polyglot_ast_NodeOps$param_ptypes$visitChildren$3886f3a733ef8382[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_ast_NodeOps$param_types$visitChildren$3886f3a733ef8382[] = {
	&_jc_polyglot_visit_NodeVisitor$type
};

_jc_method _jc_polyglot_ast_NodeOps$method_info$visitChildren$3886f3a733ef8382 = {
	.name=			"visitChildren",
	.signature=		"(Lpolyglot/visit/NodeVisitor;)Lpolyglot/ast/Node;",
	.class=			&_jc_polyglot_ast_NodeOps$type,
	.param_types=		&_jc_polyglot_ast_NodeOps$param_types$visitChildren$3886f3a733ef8382,
	.return_type=		&_jc_polyglot_ast_Node$type,
	.param_ptypes=		&_jc_polyglot_ast_NodeOps$param_ptypes$visitChildren$3886f3a733ef8382,
	.signature_hash=	_JC_JLONG(0x3886f3a733ef8382),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
};

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_polyglot_ast_NodeOps$methods[] = {
	&_jc_polyglot_ast_NodeOps$method_info$addDecls$466c32a4263da0dd,
	&_jc_polyglot_ast_NodeOps$method_info$addMembers$b968ee2b48e68bf8,
	&_jc_polyglot_ast_NodeOps$method_info$addMembersEnter$5330305f218d104a,
	&_jc_polyglot_ast_NodeOps$method_info$buildTypes$df90664105e3e235,
	&_jc_polyglot_ast_NodeOps$method_info$buildTypesEnter$72be41a96a202660,
	&_jc_polyglot_ast_NodeOps$method_info$disambiguate$d149e043dfa73b41,
	&_jc_polyglot_ast_NodeOps$method_info$disambiguateEnter$fb826386ba1653d7,
	&_jc_polyglot_ast_NodeOps$method_info$enterScope$fe7413075884500c,
	&_jc_polyglot_ast_NodeOps$method_info$enterScope$fabeac726ca62dc1,
	&_jc_polyglot_ast_NodeOps$method_info$exceptionCheck$7e82ac8adaa6681a,
	&_jc_polyglot_ast_NodeOps$method_info$exceptionCheckEnter$4be1ca87c35f7838,
	&_jc_polyglot_ast_NodeOps$method_info$foldConstants$fbe0045def0a58b5,
	&_jc_polyglot_ast_NodeOps$method_info$foldConstantsEnter$5379229ad3fbc2f1,
	&_jc_polyglot_ast_NodeOps$method_info$prettyPrint$323ca37cb40f93d3,
	&_jc_polyglot_ast_NodeOps$method_info$throwTypes$7c1f300c448e8fc3,
	&_jc_polyglot_ast_NodeOps$method_info$translate$a71b7acdcea34061,
	&_jc_polyglot_ast_NodeOps$method_info$typeCheck$ae9be7fcd0a04a49,
	&_jc_polyglot_ast_NodeOps$method_info$typeCheckEnter$550e759e0ec94272,
	&_jc_polyglot_ast_NodeOps$method_info$visitChildren$3886f3a733ef8382
};

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_polyglot_ast_NodeOps$instanceof_hash_bucket_70[] = {
	&_jc_polyglot_ast_NodeOps$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_ast_NodeOps$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_polyglot_ast_NodeOps$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[70]=	_jc_polyglot_ast_NodeOps$instanceof_hash_bucket_70,
	[101]=	_jc_polyglot_ast_NodeOps$instanceof_hash_bucket_101
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_polyglot_ast_NodeOps$class_depends[] = {
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/util/List",	_JC_JLONG(0x9ee0d92ce1525a4d) },
	{ "polyglot/ast/Node",	_JC_JLONG(0x1c402b4f9747e08) },
	{ "polyglot/types/Context",	_JC_JLONG(0xa433cdcd788f6c37) },
	{ "polyglot/types/SemanticException",	_JC_JLONG(0x45f755f5298b5b39) },
	{ "polyglot/types/TypeSystem",	_JC_JLONG(0xed171cdaca38ec28) },
	{ "polyglot/util/CodeWriter",	_JC_JLONG(0xbda7215170a25efc) },
	{ "polyglot/visit/AddMemberVisitor",	_JC_JLONG(0x3e84230834234fb4) },
	{ "polyglot/visit/AmbiguityRemover",	_JC_JLONG(0x67d28117807b75a9) },
	{ "polyglot/visit/ConstantFolder",	_JC_JLONG(0x5d560b7b79a8692b) },
	{ "polyglot/visit/ExceptionChecker",	_JC_JLONG(0xca5c3925d3e8cf05) },
	{ "polyglot/visit/NodeVisitor",	_JC_JLONG(0x534db787197439f0) },
	{ "polyglot/visit/PrettyPrinter",	_JC_JLONG(0x9b5998bb4b90b099) },
	{ "polyglot/visit/Translator",	_JC_JLONG(0x91b74e58638056a5) },
	{ "polyglot/visit/TypeBuilder",	_JC_JLONG(0x50fbc424ac80c744) },
	{ "polyglot/visit/TypeChecker",	_JC_JLONG(0x478d58036bde3016) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_polyglot_ast_NodeOps$vtype _jc_polyglot_ast_NodeOps$type = {
    .type= {
	.name=			"polyglot/ast/NodeOps",
	.superclass=		&_jc_java_lang_Object$type,
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT|_JC_ACC_INTERFACE,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		30,
		.hash=			_JC_JLONG(0x42de7cc460e24a46),
		.source_file=		"NodeOps.java",
		.num_virtual_refs=	0,
		.num_methods=		sizeof(_jc_polyglot_ast_NodeOps$methods) / sizeof(*_jc_polyglot_ast_NodeOps$methods),
		.methods=		_jc_polyglot_ast_NodeOps$methods,
		.instanceof_hash_table=	_jc_polyglot_ast_NodeOps$instanceof_hash_table,
		.num_class_depends=		sizeof(_jc_polyglot_ast_NodeOps$class_depends) / sizeof(*_jc_polyglot_ast_NodeOps$class_depends),
		.class_depends=		_jc_polyglot_ast_NodeOps$class_depends,
	    }
	}
    }
};

