// public class polyglot.frontend.Compiler

// class file dependencies
// @dep_class 411c07e717eacf69 java_io_FileNotFoundException
// @dep_class 4e0a56550c69d57c java_io_IOException
// @dep_class 99a46305ebacacb5 java_io_PrintStream
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class b0527a7101321261 java_lang_ClassLoader
// @dep_class 1f925cf50bfc0d6c java_lang_ClassNotFoundException
// @dep_class 308333d803f5ab9f java_lang_Error
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class 3746e17e005bda9e java_lang_LinkageError
// @dep_class 2082ebb592ac2255 java_lang_NoClassDefFoundError
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class 4f5534a987354d1d java_lang_RuntimeException
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 94d357637b968dda java_lang_StringBuffer
// @dep_class 53cc8e2333795f04 java_lang_System
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class 8ea716c64b77f8eb java_util_AbstractCollection
// @dep_class ca427569b5b2f804 java_util_AbstractSet
// @dep_class eae4d0c0e8eb63da java_util_Collection
// @dep_class d7cd853200c3e71f java_util_HashMap
// @dep_class 3c285c721478414d java_util_HashSet
// @dep_class be56ff673eefd9d2 java_util_Iterator
// @dep_class 3ea6f1cf85115422 polyglot_frontend_Compiler
// @dep_class fdbc32d4847269bf polyglot_frontend_ExtensionInfo
// @dep_class 39c133c176bc5fd1 polyglot_frontend_FileSource
// @dep_class c0bff66c4ab313ae polyglot_frontend_SourceLoader
// @dep_class c588a9955b794e83 polyglot_main_Options
// @dep_class 50cc35358493eab1 polyglot_types_reflect_ClassFileLoader
// @dep_class 346d846eb3bf9fe4 polyglot_util_ErrorLimitError
// @dep_class ff712c8463bdfdc0 polyglot_util_ErrorQueue
// @dep_class 22b321d488641c54 polyglot_util_InternalCompilerError
// @dep_class 32c9a088c5dac046 polyglot_util_Position
// @dep_class b9dc549f1c7c5c25 polyglot_util_StdErrorQueue

// header file dependencies
// @dep_header java_io_FileNotFoundException
// @dep_header java_io_PrintStream
// @dep_header java_lang_Class
// @dep_header java_lang_ClassLoader
// @dep_header java_lang_ClassNotFoundException
// @dep_header java_lang_NoClassDefFoundError
// @dep_header java_lang_String
// @dep_header java_lang_StringBuffer
// @dep_header java_lang_System
// @dep_header java_lang_VMThrowable
// @dep_header java_util_Collection
// @dep_header java_util_HashMap
// @dep_header java_util_HashSet
// @dep_header java_util_Iterator
// @dep_header polyglot_frontend_Compiler
// @dep_header polyglot_frontend_ExtensionInfo
// @dep_header polyglot_frontend_FileSource
// @dep_header polyglot_frontend_SourceLoader
// @dep_header polyglot_main_Options
// @dep_header polyglot_types_reflect_ClassFileLoader
// @dep_header polyglot_util_ErrorLimitError
// @dep_header polyglot_util_ErrorQueue
// @dep_header polyglot_util_InternalCompilerError
// @dep_header polyglot_util_Position
// @dep_header polyglot_util_StdErrorQueue

#include "jc_defs.h"

#include "java/io/FileNotFoundException.h"
#include "java/io/PrintStream.h"
#include "java/lang/Class.h"
#include "java/lang/ClassLoader.h"
#include "java/lang/ClassNotFoundException.h"
#include "java/lang/NoClassDefFoundError.h"
#include "java/lang/String.h"
#include "java/lang/StringBuffer.h"
#include "java/lang/System.h"
#include "java/lang/VMThrowable.h"
#include "java/util/Collection.h"
#include "java/util/HashMap.h"
#include "java/util/HashSet.h"
#include "java/util/Iterator.h"
#include "polyglot/frontend/Compiler.h"
#include "polyglot/frontend/ExtensionInfo.h"
#include "polyglot/frontend/FileSource.h"
#include "polyglot/frontend/SourceLoader.h"
#include "polyglot/main/Options.h"
#include "polyglot/types/reflect/ClassFileLoader.h"
#include "polyglot/util/ErrorLimitError.h"
#include "polyglot/util/ErrorQueue.h"
#include "polyglot/util/InternalCompilerError.h"
#include "polyglot/util/Position.h"
#include "polyglot/util/StdErrorQueue.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// private polyglot.frontend.ExtensionInfo extensionInfo
static _jc_field _jc_polyglot_frontend_Compiler$field_info$extensionInfo = {
	.name=		"extensionInfo",
	.signature=	"Lpolyglot/frontend/ExtensionInfo;",
	.class=		&_jc_polyglot_frontend_Compiler$type,
	.type=		&_jc_polyglot_frontend_ExtensionInfo$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_polyglot_frontend_Compiler$object, refs[-1].polyglot_frontend_Compiler.extensionInfo),
};

// private polyglot.util.ErrorQueue eq
static _jc_field _jc_polyglot_frontend_Compiler$field_info$eq = {
	.name=		"eq",
	.signature=	"Lpolyglot/util/ErrorQueue;",
	.class=		&_jc_polyglot_frontend_Compiler$type,
	.type=		&_jc_polyglot_util_ErrorQueue$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_polyglot_frontend_Compiler$object, refs[-1].polyglot_frontend_Compiler.eq),
};

// private polyglot.types.reflect.ClassFileLoader loader
static _jc_field _jc_polyglot_frontend_Compiler$field_info$loader = {
	.name=		"loader",
	.signature=	"Lpolyglot/types/reflect/ClassFileLoader;",
	.class=		&_jc_polyglot_frontend_Compiler$type,
	.type=		&_jc_polyglot_types_reflect_ClassFileLoader$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_polyglot_frontend_Compiler$object, refs[-1].polyglot_frontend_Compiler.loader),
};

// private java.util.Collection outputFiles
static _jc_field _jc_polyglot_frontend_Compiler$field_info$outputFiles = {
	.name=		"outputFiles",
	.signature=	"Ljava/util/Collection;",
	.class=		&_jc_polyglot_frontend_Compiler$type,
	.type=		&_jc_java_util_Collection$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_polyglot_frontend_Compiler$object, refs[-1].polyglot_frontend_Compiler.outputFiles),
};

// static java.lang.Class class$polyglot$frontend$Compiler
static _jc_field _jc_polyglot_frontend_Compiler$field_info$class__24polyglot__24frontend__24Compiler = {
	.name=		"class$polyglot$frontend$Compiler",
	.signature=	"Ljava/lang/Class;",
	.class=		&_jc_polyglot_frontend_Compiler$type,
	.type=		&_jc_java_lang_Class$type,
	.access_flags=	_JC_ACC_STATIC,
	.offset=	_JC_OFFSETOF(_jc_polyglot_frontend_Compiler$fields_struct, class__24polyglot__24frontend__24Compiler),
};

// Fields
static _jc_field *const _jc_polyglot_frontend_Compiler$fields[] = {
	&_jc_polyglot_frontend_Compiler$field_info$class__24polyglot__24frontend__24Compiler,
	&_jc_polyglot_frontend_Compiler$field_info$eq,
	&_jc_polyglot_frontend_Compiler$field_info$extensionInfo,
	&_jc_polyglot_frontend_Compiler$field_info$loader,
	&_jc_polyglot_frontend_Compiler$field_info$outputFiles
};

/************************************************************************
 *			      Static methods				*
 ************************************************************************/

//
// static void <clinit>()
//

static _jc_linenum _jc_polyglot_frontend_Compiler$linenum_table$_clinit$a816641e0ba8bfef[];

static _jc_trap_info _jc_polyglot_frontend_Compiler$trap_table$_clinit$a816641e0ba8bfef[] = {
	_JC_TRAP(&_jc_java_lang_ClassNotFoundException$type, 1, 2),
};

static const unsigned char _jc_polyglot_frontend_Compiler$param_ptypes$_clinit$a816641e0ba8bfef[] = { 
_JC_TYPE_VOID };

_jc_method _jc_polyglot_frontend_Compiler$method_info$_clinit$a816641e0ba8bfef = {
	.name=			"<clinit>",
	.signature=		"()V",
	.class=			&_jc_polyglot_frontend_Compiler$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_frontend_Compiler$param_ptypes$_clinit$a816641e0ba8bfef,
	.signature_hash=	_JC_JLONG(0xa816641e0ba8bfef),
	.access_flags=		_JC_ACC_STATIC,
	.function=		&_jc_polyglot_frontend_Compiler$method$_clinit$a816641e0ba8bfef,
	.num_parameters=	0,
	.u= { .exec= {
	  .trap_table_len=	1,
	  .trap_table=		_jc_polyglot_frontend_Compiler$trap_table$_clinit$a816641e0ba8bfef,
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_polyglot_frontend_Compiler$linenum_table$_clinit$a816641e0ba8bfef
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_frontend_Compiler, _clinit$a816641e0ba8bfef);

void _JC_JCNI_ATTR
_jc_polyglot_frontend_Compiler$method$_clinit$a816641e0ba8bfef(_jc_env *const env)
{
	struct _jc_java_lang_Class$object *r0;
	struct _jc_java_lang_ClassLoader$object *r1;
	struct _jc_java_lang_ClassNotFoundException$object *volatile r2;
	struct _jc_polyglot_util_InternalCompilerError$object *volatile r3;
	struct _jc_java_lang_String$object *volatile r4;
	struct _jc_polyglot_util_Position$object *volatile r5;
	struct _jc_java_lang_VMThrowable$object *volatile r7;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_polyglot_frontend_Compiler$method_info$_clinit$a816641e0ba8bfef, &&label2);

	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(141);				// 0
	r0 = _JC_STATIC_FIELD(env, polyglot_frontend_Compiler, class__24polyglot__24frontend__24Compiler, 1);
	if (r0 != _JC_NULL)
		goto label0;
	r0 = _JC_INVOKE_STATIC(env, polyglot_frontend_Compiler, class__24$57cd45dca0be1678, 1, _JC_STRING(env, "polyglot.frontend.Compiler"));
	_JC_STATIC_FIELD(env, polyglot_frontend_Compiler, class__24polyglot__24frontend__24Compiler, 1) = r0;
	goto label1;

label0:
	r0 = _JC_STATIC_FIELD(env, polyglot_frontend_Compiler, class__24polyglot__24frontend__24Compiler, 1);

label1:
	r1 = _JC_INVOKE_NONVIRTUAL(env, java_lang_Class, getClassLoader$2078dc747ca30d6e, 1, r0);
	_JC_LINE_NUMBER(144);				// 1
	_JC_INVOKE_VIRTUAL(env, java_lang_ClassLoader, loadClass$b46bd9590884d859, r1, _JC_STRING(env, "polyglot.util.StdErrorQueue"));
	_JC_TRAP_REGION(catch, 2);
	_JC_LINE_NUMBER(148);				// 2
	goto label3;

label2:
	_JC_TRAP_REGION(catch, 2);
	r2 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(147);				// 3
	r3 = _JC_NEW(env, polyglot_util_InternalCompilerError);
	r4 = _JC_INVOKE_VIRTUAL(env, java_lang_Throwable, getMessage$13aaf240efc902b1, r2);
	r5 = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r7 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r7;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r4;
	_JC_REF_FIELD(env, r3, polyglot_util_InternalCompilerError, pos) = r5;
	_JC_THROW(env, r3);

label3:
	_JC_LINE_NUMBER(149);				// 4
	_JC_CANCEL_TRAPS(env, catch);
	return;
}

//
// static java.lang.Class class$(java.lang.String)
//

static _jc_linenum _jc_polyglot_frontend_Compiler$linenum_table$class__24$57cd45dca0be1678[];

static _jc_trap_info _jc_polyglot_frontend_Compiler$trap_table$class__24$57cd45dca0be1678[] = {
	_JC_TRAP(&_jc_java_lang_ClassNotFoundException$type, 1, 2),
};

static const unsigned char _jc_polyglot_frontend_Compiler$param_ptypes$class__24$57cd45dca0be1678[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_frontend_Compiler$param_types$class__24$57cd45dca0be1678[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_polyglot_frontend_Compiler$method_info$class__24$57cd45dca0be1678 = {
	.name=			"class$",
	.signature=		"(Ljava/lang/String;)Ljava/lang/Class;",
	.class=			&_jc_polyglot_frontend_Compiler$type,
	.param_types=		&_jc_polyglot_frontend_Compiler$param_types$class__24$57cd45dca0be1678,
	.return_type=		&_jc_java_lang_Class$type,
	.param_ptypes=		&_jc_polyglot_frontend_Compiler$param_ptypes$class__24$57cd45dca0be1678,
	.signature_hash=	_JC_JLONG(0x57cd45dca0be1678),
	.access_flags=		_JC_ACC_STATIC,
	.function=		&_jc_polyglot_frontend_Compiler$method$class__24$57cd45dca0be1678,
	.num_parameters=	1,
	.u= { .exec= {
	  .trap_table_len=	1,
	  .trap_table=		_jc_polyglot_frontend_Compiler$trap_table$class__24$57cd45dca0be1678,
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_frontend_Compiler$linenum_table$class__24$57cd45dca0be1678
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_frontend_Compiler, class__24$57cd45dca0be1678);

_jc_java_lang_Class$object * _JC_JCNI_ATTR
_jc_polyglot_frontend_Compiler$method$class__24$57cd45dca0be1678(_jc_env *const env, _jc_java_lang_String$object *param0)
{
	struct _jc_java_lang_String$object *volatile r0;
	struct _jc_java_lang_ClassNotFoundException$object *volatile r1;
	struct _jc_java_lang_Class$object *r2;
	struct _jc_java_lang_NoClassDefFoundError$object *volatile r3;
	struct _jc_java_lang_VMThrowable$object *volatile r5;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_polyglot_frontend_Compiler$method_info$class__24$57cd45dca0be1678, &&label0);

	r0 = param0;
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(141);				// 0
	r2 = _JC_INVOKE_STATIC(env, java_lang_Class, forName$d3b57db3b6a905a3, 1, r0);
	_JC_TRAP_REGION(catch, 2);
	_JC_CANCEL_TRAPS(env, catch);
	return r2;

label0:
	_JC_TRAP_REGION(catch, 2);
	r1 = _JC_CAUGHT_EXCEPTION(env);
	r3 = _JC_NEW(env, java_lang_NoClassDefFoundError);
	r0 = _JC_INVOKE_VIRTUAL(env, java_lang_Throwable, getMessage$13aaf240efc902b1, r1);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r5 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r5;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r0;
	_JC_THROW(env, r3);
}

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// public void <init>(polyglot.frontend.ExtensionInfo)
//

static _jc_linenum _jc_polyglot_frontend_Compiler$linenum_table$_init$b68afe312166e950[];

static const unsigned char _jc_polyglot_frontend_Compiler$param_ptypes$_init$b68afe312166e950[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_frontend_Compiler$param_types$_init$b68afe312166e950[] = {
	&_jc_polyglot_frontend_ExtensionInfo$type
};

_jc_method _jc_polyglot_frontend_Compiler$method_info$_init$b68afe312166e950 = {
	.name=			"<init>",
	.signature=		"(Lpolyglot/frontend/ExtensionInfo;)V",
	.class=			&_jc_polyglot_frontend_Compiler$type,
	.param_types=		&_jc_polyglot_frontend_Compiler$param_types$_init$b68afe312166e950,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_frontend_Compiler$param_ptypes$_init$b68afe312166e950,
	.signature_hash=	_JC_JLONG(0xb68afe312166e950),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_frontend_Compiler$method$_init$b68afe312166e950,
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	7,
	      .table=	_jc_polyglot_frontend_Compiler$linenum_table$_init$b68afe312166e950
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_frontend_Compiler, _init$b68afe312166e950);

void _JC_JCNI_ATTR
_jc_polyglot_frontend_Compiler$method$_init$b68afe312166e950(_jc_env *const env, _jc_polyglot_frontend_Compiler$object *this, _jc_object *param0)
{
	jint i0;
	struct _jc_polyglot_frontend_Compiler$object *r0;
	struct _jc_object *r1;
	struct _jc_java_util_HashSet$object *r2;
	struct _jc_polyglot_main_Options$object *r3;
	struct _jc_java_io_PrintStream$object *r4;
	struct _jc_polyglot_util_StdErrorQueue$object *r5;
	struct _jc_java_lang_String$object *r6;
	struct _jc_polyglot_types_reflect_ClassFileLoader$object *r7;
	struct _jc_java_util_HashMap$object *r8;
	struct _jc_java_util_HashMap$object *r9;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(36);				// 0
	r2 = _JC_NEW(env, java_util_HashSet);
	r8 = _JC_NEW(env, java_util_HashMap);
	_JC_INVOKE_NONVIRTUAL(env, java_util_HashMap, _init$7cb044ce4fb0ada8, 0, r8, 11, _JC_FCONST(0x3f, 0x40, 0x0, 0x0));
	_JC_REF_FIELD(env, r2, java_util_HashSet, map) = r8;
	_JC_REF_FIELD(env, r0, polyglot_frontend_Compiler, outputFiles) = r2;
	_JC_LINE_NUMBER(44);				// 1
	_JC_REF_FIELD(env, r0, polyglot_frontend_Compiler, extensionInfo) = r1;
	_JC_LINE_NUMBER(46);				// 2
	r3 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0x32d244a09dad6c69), _jc_object *, (_jc_env *, struct _jc_object *));
	_JC_LINE_NUMBER(48);				// 3
	r5 = _JC_NEW(env, polyglot_util_StdErrorQueue);
	r4 = _JC_STATIC_FIELD(env, java_lang_System, err, 0);
	i0 = _JC_PRIM_FIELD(env, r3, polyglot_main_Options, error__5fcount);
	r6 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0x20b6c9308360447c), _jc_object *, (_jc_env *, struct _jc_object *));
	_JC_REF_FIELD(env, r5, polyglot_util_StdErrorQueue, err) = r4;
	_JC_PRIM_FIELD(env, r5, polyglot_util_StdErrorQueue, errorCount) = 0;
	_JC_PRIM_FIELD(env, r5, polyglot_util_StdErrorQueue, flushed) = 1;
	_JC_PRIM_FIELD(env, r5, polyglot_util_StdErrorQueue, limit) = i0;
	_JC_REF_FIELD(env, r5, polyglot_util_StdErrorQueue, name) = r6;
	_JC_REF_FIELD(env, r0, polyglot_frontend_Compiler, eq) = r5;
	_JC_LINE_NUMBER(51);				// 4
	r7 = _JC_NEW(env, polyglot_types_reflect_ClassFileLoader);
	r9 = _JC_NEW(env, java_util_HashMap);
	_JC_INVOKE_NONVIRTUAL(env, java_util_HashMap, _init$7cb044ce4fb0ada8, 0, r9, 11, _JC_FCONST(0x3f, 0x40, 0x0, 0x0));
	_JC_REF_FIELD(env, r7, polyglot_types_reflect_ClassFileLoader, jarCache) = r9;
	r9 = _JC_NEW(env, java_util_HashMap);
	_JC_INVOKE_NONVIRTUAL(env, java_util_HashMap, _init$7cb044ce4fb0ada8, 0, r9, 11, _JC_FCONST(0x3f, 0x40, 0x0, 0x0));
	_JC_REF_FIELD(env, r7, polyglot_types_reflect_ClassFileLoader, dirContentsCache) = r9;
	_JC_REF_FIELD(env, r0, polyglot_frontend_Compiler, loader) = r7;
	_JC_LINE_NUMBER(54);				// 5
	_JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0xb6fc3570fb050030), void, (_jc_env *, struct _jc_object *, struct _jc_polyglot_frontend_Compiler$object *), r0);
	_JC_LINE_NUMBER(55);				// 6
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public boolean compile(java.util.Collection)
//

static _jc_linenum _jc_polyglot_frontend_Compiler$linenum_table$compile$0ccd0f4debd703f2[];

static _jc_trap_info _jc_polyglot_frontend_Compiler$trap_table$compile$0ccd0f4debd703f2[] = {
	_JC_TRAP(&_jc_java_io_FileNotFoundException$type, 1, 2),
	_JC_TRAP(&_jc_java_io_IOException$type, 1, 2),
	_JC_TRAP(&_jc_polyglot_util_InternalCompilerError$type, 1, 2),
	_JC_TRAP(&_jc_polyglot_util_ErrorLimitError$type, 1, 3),
};

static const unsigned char _jc_polyglot_frontend_Compiler$param_ptypes$compile$0ccd0f4debd703f2[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_polyglot_frontend_Compiler$param_types$compile$0ccd0f4debd703f2[] = {
	&_jc_java_util_Collection$type
};

_jc_method _jc_polyglot_frontend_Compiler$method_info$compile$0ccd0f4debd703f2 = {
	.name=			"compile",
	.signature=		"(Ljava/util/Collection;)Z",
	.class=			&_jc_polyglot_frontend_Compiler$type,
	.param_types=		&_jc_polyglot_frontend_Compiler$param_types$compile$0ccd0f4debd703f2,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_polyglot_frontend_Compiler$param_ptypes$compile$0ccd0f4debd703f2,
	.signature_hash=	_JC_JLONG(0xccd0f4debd703f2),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_frontend_Compiler$method$compile$0ccd0f4debd703f2,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_frontend_Compiler$vtable, polyglot_frontend_Compiler.compile$0ccd0f4debd703f2) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .trap_table_len=	4,
	  .trap_table=		_jc_polyglot_frontend_Compiler$trap_table$compile$0ccd0f4debd703f2,
	  .u= {
	    .linenum= {
	      .len=	17,
	      .table=	_jc_polyglot_frontend_Compiler$linenum_table$compile$0ccd0f4debd703f2
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_frontend_Compiler, compile$0ccd0f4debd703f2);

jboolean _JC_JCNI_ATTR
_jc_polyglot_frontend_Compiler$method$compile$0ccd0f4debd703f2(_jc_env *const env, _jc_polyglot_frontend_Compiler$object *this, _jc_object *param0)
{
	struct _jc_polyglot_frontend_Compiler$object *volatile r0;
	struct _jc_object *r1;
	struct _jc_object *volatile r10;
	struct _jc_java_io_IOException$object *volatile r11;
	struct _jc_polyglot_util_InternalCompilerError$object *volatile r12;
	struct _jc_polyglot_util_Position$object *volatile r13;
	struct _jc_polyglot_util_ErrorLimitError$object *r14;
	struct _jc_java_lang_String$object *volatile r15;
	_jc_char_array *volatile r16;
	struct _jc_polyglot_frontend_SourceLoader$object *r2;
	struct _jc_object *r3;
	struct _jc_java_lang_String$object *volatile r4;
	struct _jc_polyglot_frontend_FileSource$object *r5;
	struct _jc_java_lang_StringBuffer$object *volatile r6;
	struct _jc_object *r7;
	struct _jc_java_lang_Object$object *r8;
	struct _jc_java_io_FileNotFoundException$object *volatile r9;
	jboolean volatile z0;
	jboolean z1;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_polyglot_frontend_Compiler$method_info$compile$0ccd0f4debd703f2, &&label2, &&label3, &&label4, &&label5);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(69);				// 0
	z0 = 0;
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(73);				// 1
	r7 = _JC_INVOKE_VIRTUAL(env, polyglot_frontend_Compiler, sourceExtension$fc0101b1b3597db8, r0);
	r2 = _JC_INVOKE_INTERFACE(env, r7, _JC_JLONG(0xe3dacb62b9f7eae9), _jc_object *, (_jc_env *, struct _jc_object *));
	_JC_LINE_NUMBER(75);				// 2
	r3 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0x3cc91493d50f531c), _jc_object *, (_jc_env *, struct _jc_object *));

label0:
	z1 = _JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0xfb0bd5e38c59ddcd), jboolean, (_jc_env *, struct _jc_object *));
	if (z1 == 0)
		goto label1;
	_JC_LINE_NUMBER(76);				// 3
	r8 = _JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0x5874f79a1cf66ea), _jc_object *, (_jc_env *, struct _jc_object *));
	r4 = _JC_CAST_FINAL(env, &_jc_java_lang_String$type, r8);
	_JC_LINE_NUMBER(77);				// 4
	r5 = _JC_INVOKE_VIRTUAL(env, polyglot_frontend_SourceLoader, fileSource$7884cd4a1c97af23, r2, r4);
	_JC_LINE_NUMBER(78);				// 5
	r7 = _JC_INVOKE_VIRTUAL(env, polyglot_frontend_Compiler, sourceExtension$fc0101b1b3597db8, r0);
	_JC_INVOKE_INTERFACE(env, r7, _JC_JLONG(0x63f43e200036e3a0), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_polyglot_frontend_Source$object *), r5);
	_JC_PERIODIC_CHECK(env);
	goto label0;

label1:
	_JC_LINE_NUMBER(81);				// 6
	r7 = _JC_INVOKE_VIRTUAL(env, polyglot_frontend_Compiler, sourceExtension$fc0101b1b3597db8, r0);
	z0 = _JC_INVOKE_INTERFACE(env, r7, _JC_JLONG(0xe1c7b5ddc42ec7c1), jboolean, (_jc_env *, struct _jc_object *));
	_JC_TRAP_REGION(catch, 2);
	_JC_LINE_NUMBER(93);				// 7
	goto label6;

label2:
	_JC_TRAP_REGION(catch, 2);
	r9 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(84);				// 8
	r10 = _JC_REF_FIELD(env, r0, polyglot_frontend_Compiler, eq);
	r6 = _JC_NEW(env, java_lang_StringBuffer);
	r16 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r6, java_lang_StringBuffer, value) = r16;
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r6, _JC_STRING(env, "Cannot find source file \""));
	r4 = _JC_INVOKE_VIRTUAL(env, java_lang_Throwable, getMessage$13aaf240efc902b1, r9);
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r6, r4);
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r6, _JC_STRING(env, "\"."));
	r15 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r15, r6);
	_JC_INVOKE_INTERFACE(env, r10, _JC_JLONG(0x7659161d8f442ddb), void, (_jc_env *, struct _jc_object *, jint, struct _jc_java_lang_String$object *), 2, r15);
	_JC_LINE_NUMBER(93);				// 9
	goto label6;

label3:
	_JC_TRAP_REGION(catch, 2);
	r11 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(88);				// 10
	r10 = _JC_REF_FIELD(env, r0, polyglot_frontend_Compiler, eq);
	r4 = _JC_INVOKE_VIRTUAL(env, java_lang_Throwable, getMessage$13aaf240efc902b1, r11);
	_JC_INVOKE_INTERFACE(env, r10, _JC_JLONG(0x7659161d8f442ddb), void, (_jc_env *, struct _jc_object *, jint, struct _jc_java_lang_String$object *), 2, r4);
	_JC_LINE_NUMBER(93);				// 11
	goto label6;

label4:
	_JC_TRAP_REGION(catch, 2);
	r12 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(91);				// 12
	_JC_INVOKE_VIRTUAL(env, java_lang_Throwable, printStackTrace$0c533e6284fdc6db, r12);
	_JC_LINE_NUMBER(92);				// 13
	r10 = _JC_REF_FIELD(env, r0, polyglot_frontend_Compiler, eq);
	r4 = _JC_INVOKE_VIRTUAL(env, polyglot_util_InternalCompilerError, message$323342d7f00d6406, r12);
	r13 = _JC_INVOKE_VIRTUAL(env, polyglot_util_InternalCompilerError, position$bb89333b1e4c840c, r12);
	_JC_INVOKE_INTERFACE(env, r10, _JC_JLONG(0x82679af4bd898d46), void, (_jc_env *, struct _jc_object *, jint, struct _jc_java_lang_String$object *, struct _jc_polyglot_util_Position$object *), 1, r4, r13);
	_JC_TRAP_REGION(catch, 3);
	_JC_LINE_NUMBER(96);				// 14
	goto label6;

label5:
	_JC_TRAP_REGION(catch, 3);
	r14 = _JC_CAUGHT_EXCEPTION(env);

label6:
	_JC_TRAP_REGION(catch, 3);
	_JC_LINE_NUMBER(98);				// 15
	r10 = _JC_REF_FIELD(env, r0, polyglot_frontend_Compiler, eq);
	_JC_INVOKE_INTERFACE(env, r10, _JC_JLONG(0x9dedb7d85e88cf56), void, (_jc_env *, struct _jc_object *));
	_JC_LINE_NUMBER(99);				// 16
	_JC_CANCEL_TRAPS(env, catch);
	return z0;
}

//
// public polyglot.util.ErrorQueue errorQueue()
//

static _jc_linenum _jc_polyglot_frontend_Compiler$linenum_table$errorQueue$6d038e7585ab4339[];

static const unsigned char _jc_polyglot_frontend_Compiler$param_ptypes$errorQueue$6d038e7585ab4339[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_frontend_Compiler$method_info$errorQueue$6d038e7585ab4339 = {
	.name=			"errorQueue",
	.signature=		"()Lpolyglot/util/ErrorQueue;",
	.class=			&_jc_polyglot_frontend_Compiler$type,
	.return_type=		&_jc_polyglot_util_ErrorQueue$type,
	.param_ptypes=		&_jc_polyglot_frontend_Compiler$param_ptypes$errorQueue$6d038e7585ab4339,
	.signature_hash=	_JC_JLONG(0x6d038e7585ab4339),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_frontend_Compiler$method$errorQueue$6d038e7585ab4339,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_frontend_Compiler$vtable, polyglot_frontend_Compiler.errorQueue$6d038e7585ab4339) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_frontend_Compiler$linenum_table$errorQueue$6d038e7585ab4339
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_frontend_Compiler, errorQueue$6d038e7585ab4339);

_jc_object * _JC_JCNI_ATTR
_jc_polyglot_frontend_Compiler$method$errorQueue$6d038e7585ab4339(_jc_env *const env, _jc_polyglot_frontend_Compiler$object *this)
{
	struct _jc_polyglot_frontend_Compiler$object *r0;
	struct _jc_object *r1;

	r0 = this;
	_JC_LINE_NUMBER(129);				// 0
	r1 = _JC_REF_FIELD(env, r0, polyglot_frontend_Compiler, eq);
	return r1;
}

//
// public polyglot.types.reflect.ClassFileLoader loader()
//

static _jc_linenum _jc_polyglot_frontend_Compiler$linenum_table$loader$d748945baa6760b4[];

static const unsigned char _jc_polyglot_frontend_Compiler$param_ptypes$loader$d748945baa6760b4[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_frontend_Compiler$method_info$loader$d748945baa6760b4 = {
	.name=			"loader",
	.signature=		"()Lpolyglot/types/reflect/ClassFileLoader;",
	.class=			&_jc_polyglot_frontend_Compiler$type,
	.return_type=		&_jc_polyglot_types_reflect_ClassFileLoader$type,
	.param_ptypes=		&_jc_polyglot_frontend_Compiler$param_ptypes$loader$d748945baa6760b4,
	.signature_hash=	_JC_JLONG(0xd748945baa6760b4),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_frontend_Compiler$method$loader$d748945baa6760b4,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_frontend_Compiler$vtable, polyglot_frontend_Compiler.loader$d748945baa6760b4) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_frontend_Compiler$linenum_table$loader$d748945baa6760b4
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_frontend_Compiler, loader$d748945baa6760b4);

_jc_polyglot_types_reflect_ClassFileLoader$object * _JC_JCNI_ATTR
_jc_polyglot_frontend_Compiler$method$loader$d748945baa6760b4(_jc_env *const env, _jc_polyglot_frontend_Compiler$object *this)
{
	struct _jc_polyglot_frontend_Compiler$object *r0;
	struct _jc_polyglot_types_reflect_ClassFileLoader$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(104);				// 0
	r1 = _JC_REF_FIELD(env, r0, polyglot_frontend_Compiler, loader);
	return r1;
}

//
// public java.util.Collection outputFiles()
//

static _jc_linenum _jc_polyglot_frontend_Compiler$linenum_table$outputFiles$3911e88355956017[];

static const unsigned char _jc_polyglot_frontend_Compiler$param_ptypes$outputFiles$3911e88355956017[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_frontend_Compiler$method_info$outputFiles$3911e88355956017 = {
	.name=			"outputFiles",
	.signature=		"()Ljava/util/Collection;",
	.class=			&_jc_polyglot_frontend_Compiler$type,
	.return_type=		&_jc_java_util_Collection$type,
	.param_ptypes=		&_jc_polyglot_frontend_Compiler$param_ptypes$outputFiles$3911e88355956017,
	.signature_hash=	_JC_JLONG(0x3911e88355956017),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_frontend_Compiler$method$outputFiles$3911e88355956017,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_frontend_Compiler$vtable, polyglot_frontend_Compiler.outputFiles$3911e88355956017) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_frontend_Compiler$linenum_table$outputFiles$3911e88355956017
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_frontend_Compiler, outputFiles$3911e88355956017);

_jc_object * _JC_JCNI_ATTR
_jc_polyglot_frontend_Compiler$method$outputFiles$3911e88355956017(_jc_env *const env, _jc_polyglot_frontend_Compiler$object *this)
{
	struct _jc_polyglot_frontend_Compiler$object *r0;
	struct _jc_object *r1;

	r0 = this;
	_JC_LINE_NUMBER(59);				// 0
	r1 = _JC_REF_FIELD(env, r0, polyglot_frontend_Compiler, outputFiles);
	return r1;
}

//
// public int outputWidth()
//

static _jc_linenum _jc_polyglot_frontend_Compiler$linenum_table$outputWidth$27644889335135c1[];

static const unsigned char _jc_polyglot_frontend_Compiler$param_ptypes$outputWidth$27644889335135c1[] = { 
_JC_TYPE_INT };

_jc_method _jc_polyglot_frontend_Compiler$method_info$outputWidth$27644889335135c1 = {
	.name=			"outputWidth",
	.signature=		"()I",
	.class=			&_jc_polyglot_frontend_Compiler$type,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_polyglot_frontend_Compiler$param_ptypes$outputWidth$27644889335135c1,
	.signature_hash=	_JC_JLONG(0x27644889335135c1),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_frontend_Compiler$method$outputWidth$27644889335135c1,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_frontend_Compiler$vtable, polyglot_frontend_Compiler.outputWidth$27644889335135c1) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_frontend_Compiler$linenum_table$outputWidth$27644889335135c1
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_frontend_Compiler, outputWidth$27644889335135c1);

jint _JC_JCNI_ATTR
_jc_polyglot_frontend_Compiler$method$outputWidth$27644889335135c1(_jc_env *const env, _jc_polyglot_frontend_Compiler$object *this)
{
	jint i0;
	struct _jc_polyglot_frontend_Compiler$object *r0;
	struct _jc_object *r1;
	struct _jc_polyglot_main_Options$object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(119);				// 0
	r1 = _JC_REF_FIELD(env, r0, polyglot_frontend_Compiler, extensionInfo);
	r2 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0x32d244a09dad6c69), _jc_object *, (_jc_env *, struct _jc_object *));
	i0 = _JC_PRIM_FIELD(env, r2, polyglot_main_Options, output__5fwidth);
	return i0;
}

//
// public boolean serializeClassInfo()
//

static _jc_linenum _jc_polyglot_frontend_Compiler$linenum_table$serializeClassInfo$113d1eee93cb449a[];

static const unsigned char _jc_polyglot_frontend_Compiler$param_ptypes$serializeClassInfo$113d1eee93cb449a[] = { 
_JC_TYPE_BOOLEAN };

_jc_method _jc_polyglot_frontend_Compiler$method_info$serializeClassInfo$113d1eee93cb449a = {
	.name=			"serializeClassInfo",
	.signature=		"()Z",
	.class=			&_jc_polyglot_frontend_Compiler$type,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_polyglot_frontend_Compiler$param_ptypes$serializeClassInfo$113d1eee93cb449a,
	.signature_hash=	_JC_JLONG(0x113d1eee93cb449a),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_frontend_Compiler$method$serializeClassInfo$113d1eee93cb449a,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_frontend_Compiler$vtable, polyglot_frontend_Compiler.serializeClassInfo$113d1eee93cb449a) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_frontend_Compiler$linenum_table$serializeClassInfo$113d1eee93cb449a
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_frontend_Compiler, serializeClassInfo$113d1eee93cb449a);

jboolean _JC_JCNI_ATTR
_jc_polyglot_frontend_Compiler$method$serializeClassInfo$113d1eee93cb449a(_jc_env *const env, _jc_polyglot_frontend_Compiler$object *this)
{
	struct _jc_polyglot_frontend_Compiler$object *r0;
	struct _jc_object *r1;
	struct _jc_polyglot_main_Options$object *r2;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(124);				// 0
	r1 = _JC_REF_FIELD(env, r0, polyglot_frontend_Compiler, extensionInfo);
	r2 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0x32d244a09dad6c69), _jc_object *, (_jc_env *, struct _jc_object *));
	z0 = _JC_PRIM_FIELD(env, r2, polyglot_main_Options, serialize__5ftype__5finfo);
	return z0;
}

//
// public polyglot.frontend.ExtensionInfo sourceExtension()
//

static _jc_linenum _jc_polyglot_frontend_Compiler$linenum_table$sourceExtension$fc0101b1b3597db8[];

static const unsigned char _jc_polyglot_frontend_Compiler$param_ptypes$sourceExtension$fc0101b1b3597db8[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_frontend_Compiler$method_info$sourceExtension$fc0101b1b3597db8 = {
	.name=			"sourceExtension",
	.signature=		"()Lpolyglot/frontend/ExtensionInfo;",
	.class=			&_jc_polyglot_frontend_Compiler$type,
	.return_type=		&_jc_polyglot_frontend_ExtensionInfo$type,
	.param_ptypes=		&_jc_polyglot_frontend_Compiler$param_ptypes$sourceExtension$fc0101b1b3597db8,
	.signature_hash=	_JC_JLONG(0xfc0101b1b3597db8),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_frontend_Compiler$method$sourceExtension$fc0101b1b3597db8,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_frontend_Compiler$vtable, polyglot_frontend_Compiler.sourceExtension$fc0101b1b3597db8) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_frontend_Compiler$linenum_table$sourceExtension$fc0101b1b3597db8
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_frontend_Compiler, sourceExtension$fc0101b1b3597db8);

_jc_object * _JC_JCNI_ATTR
_jc_polyglot_frontend_Compiler$method$sourceExtension$fc0101b1b3597db8(_jc_env *const env, _jc_polyglot_frontend_Compiler$object *this)
{
	struct _jc_polyglot_frontend_Compiler$object *r0;
	struct _jc_object *r1;

	r0 = this;
	_JC_LINE_NUMBER(114);				// 0
	r1 = _JC_REF_FIELD(env, r0, polyglot_frontend_Compiler, extensionInfo);
	return r1;
}

//
// public boolean useFullyQualifiedNames()
//

static _jc_linenum _jc_polyglot_frontend_Compiler$linenum_table$useFullyQualifiedNames$86ab5d9fa7e4da73[];

static const unsigned char _jc_polyglot_frontend_Compiler$param_ptypes$useFullyQualifiedNames$86ab5d9fa7e4da73[] = { 
_JC_TYPE_BOOLEAN };

_jc_method _jc_polyglot_frontend_Compiler$method_info$useFullyQualifiedNames$86ab5d9fa7e4da73 = {
	.name=			"useFullyQualifiedNames",
	.signature=		"()Z",
	.class=			&_jc_polyglot_frontend_Compiler$type,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_polyglot_frontend_Compiler$param_ptypes$useFullyQualifiedNames$86ab5d9fa7e4da73,
	.signature_hash=	_JC_JLONG(0x86ab5d9fa7e4da73),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_frontend_Compiler$method$useFullyQualifiedNames$86ab5d9fa7e4da73,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_frontend_Compiler$vtable, polyglot_frontend_Compiler.useFullyQualifiedNames$86ab5d9fa7e4da73) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_frontend_Compiler$linenum_table$useFullyQualifiedNames$86ab5d9fa7e4da73
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_frontend_Compiler, useFullyQualifiedNames$86ab5d9fa7e4da73);

jboolean _JC_JCNI_ATTR
_jc_polyglot_frontend_Compiler$method$useFullyQualifiedNames$86ab5d9fa7e4da73(_jc_env *const env, _jc_polyglot_frontend_Compiler$object *this)
{
	struct _jc_polyglot_frontend_Compiler$object *r0;
	struct _jc_object *r1;
	struct _jc_polyglot_main_Options$object *r2;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(109);				// 0
	r1 = _JC_REF_FIELD(env, r0, polyglot_frontend_Compiler, extensionInfo);
	r2 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0x32d244a09dad6c69), _jc_object *, (_jc_env *, struct _jc_object *));
	z0 = _JC_PRIM_FIELD(env, r2, polyglot_main_Options, fully__5fqualified__5fnames);
	return z0;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_polyglot_frontend_Compiler$methods[] = {
	&_jc_polyglot_frontend_Compiler$method_info$_clinit$a816641e0ba8bfef,
	&_jc_polyglot_frontend_Compiler$method_info$_init$b68afe312166e950,
	&_jc_polyglot_frontend_Compiler$method_info$class__24$57cd45dca0be1678,
	&_jc_polyglot_frontend_Compiler$method_info$compile$0ccd0f4debd703f2,
	&_jc_polyglot_frontend_Compiler$method_info$errorQueue$6d038e7585ab4339,
	&_jc_polyglot_frontend_Compiler$method_info$loader$d748945baa6760b4,
	&_jc_polyglot_frontend_Compiler$method_info$outputFiles$3911e88355956017,
	&_jc_polyglot_frontend_Compiler$method_info$outputWidth$27644889335135c1,
	&_jc_polyglot_frontend_Compiler$method_info$serializeClassInfo$113d1eee93cb449a,
	&_jc_polyglot_frontend_Compiler$method_info$sourceExtension$fc0101b1b3597db8,
	&_jc_polyglot_frontend_Compiler$method_info$useFullyQualifiedNames$86ab5d9fa7e4da73
};

/************************************************************************
 *			  Class fields structure			*
 ************************************************************************/

_jc_polyglot_frontend_Compiler$fields_struct _jc_polyglot_frontend_Compiler$class_fields = { };

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_polyglot_frontend_Compiler$instanceof_hash_bucket_34[] = {
	&_jc_polyglot_frontend_Compiler$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_frontend_Compiler$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_polyglot_frontend_Compiler$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[34]=	_jc_polyglot_frontend_Compiler$instanceof_hash_bucket_34,
	[101]=	_jc_polyglot_frontend_Compiler$instanceof_hash_bucket_101
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_polyglot_frontend_Compiler$class_depends[] = {
	{ "java/io/FileNotFoundException",	_JC_JLONG(0x411c07e717eacf69) },
	{ "java/io/IOException",	_JC_JLONG(0x4e0a56550c69d57c) },
	{ "java/io/PrintStream",	_JC_JLONG(0x99a46305ebacacb5) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/ClassLoader",	_JC_JLONG(0xb0527a7101321261) },
	{ "java/lang/ClassNotFoundException",	_JC_JLONG(0x1f925cf50bfc0d6c) },
	{ "java/lang/Error",	_JC_JLONG(0x308333d803f5ab9f) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/LinkageError",	_JC_JLONG(0x3746e17e005bda9e) },
	{ "java/lang/NoClassDefFoundError",	_JC_JLONG(0x2082ebb592ac2255) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/RuntimeException",	_JC_JLONG(0x4f5534a987354d1d) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/StringBuffer",	_JC_JLONG(0x94d357637b968dda) },
	{ "java/lang/System",	_JC_JLONG(0x53cc8e2333795f04) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/util/AbstractCollection",	_JC_JLONG(0x8ea716c64b77f8eb) },
	{ "java/util/AbstractSet",	_JC_JLONG(0xca427569b5b2f804) },
	{ "java/util/Collection",	_JC_JLONG(0xeae4d0c0e8eb63da) },
	{ "java/util/HashMap",	_JC_JLONG(0xd7cd853200c3e71f) },
	{ "java/util/HashSet",	_JC_JLONG(0x3c285c721478414d) },
	{ "java/util/Iterator",	_JC_JLONG(0xbe56ff673eefd9d2) },
	{ "polyglot/frontend/ExtensionInfo",	_JC_JLONG(0xfdbc32d4847269bf) },
	{ "polyglot/frontend/FileSource",	_JC_JLONG(0x39c133c176bc5fd1) },
	{ "polyglot/frontend/SourceLoader",	_JC_JLONG(0xc0bff66c4ab313ae) },
	{ "polyglot/main/Options",	_JC_JLONG(0xc588a9955b794e83) },
	{ "polyglot/types/reflect/ClassFileLoader",	_JC_JLONG(0x50cc35358493eab1) },
	{ "polyglot/util/ErrorLimitError",	_JC_JLONG(0x346d846eb3bf9fe4) },
	{ "polyglot/util/ErrorQueue",	_JC_JLONG(0xff712c8463bdfdc0) },
	{ "polyglot/util/InternalCompilerError",	_JC_JLONG(0x22b321d488641c54) },
	{ "polyglot/util/Position",	_JC_JLONG(0x32c9a088c5dac046) },
	{ "polyglot/util/StdErrorQueue",	_JC_JLONG(0xb9dc549f1c7c5c25) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_polyglot_frontend_Compiler$vtype _jc_polyglot_frontend_Compiler$type = {
    .type= {
	.name=			"polyglot/frontend/Compiler",
	.superclass=		&_jc_java_lang_Object$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		19,
		.hash=			_JC_JLONG(0x3ea6f1cf85115422),
		.source_file=		"Compiler.java",
		.instance_size=		sizeof(_jc_polyglot_frontend_Compiler$refs) + sizeof(_jc_polyglot_frontend_Compiler$object),
		.num_virtual_refs=	4,
		.num_fields=		sizeof(_jc_polyglot_frontend_Compiler$fields) / sizeof(*_jc_polyglot_frontend_Compiler$fields),
		.fields=		_jc_polyglot_frontend_Compiler$fields,
		.num_methods=		sizeof(_jc_polyglot_frontend_Compiler$methods) / sizeof(*_jc_polyglot_frontend_Compiler$methods),
		.methods=		_jc_polyglot_frontend_Compiler$methods,
		.instanceof_hash_table=	_jc_polyglot_frontend_Compiler$instanceof_hash_table,
		.class_fields=		&_jc_polyglot_frontend_Compiler$class_fields,
		.num_class_depends=		sizeof(_jc_polyglot_frontend_Compiler$class_depends) / sizeof(*_jc_polyglot_frontend_Compiler$class_depends),
		.class_depends=		_jc_polyglot_frontend_Compiler$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.polyglot_frontend_Compiler= {
	    .compile$0ccd0f4debd703f2=
		&_jc_polyglot_frontend_Compiler$method$compile$0ccd0f4debd703f2,
	    .errorQueue$6d038e7585ab4339=
		&_jc_polyglot_frontend_Compiler$method$errorQueue$6d038e7585ab4339,
	    .loader$d748945baa6760b4=
		&_jc_polyglot_frontend_Compiler$method$loader$d748945baa6760b4,
	    .outputFiles$3911e88355956017=
		&_jc_polyglot_frontend_Compiler$method$outputFiles$3911e88355956017,
	    .outputWidth$27644889335135c1=
		&_jc_polyglot_frontend_Compiler$method$outputWidth$27644889335135c1,
	    .serializeClassInfo$113d1eee93cb449a=
		&_jc_polyglot_frontend_Compiler$method$serializeClassInfo$113d1eee93cb449a,
	    .sourceExtension$fc0101b1b3597db8=
		&_jc_polyglot_frontend_Compiler$method$sourceExtension$fc0101b1b3597db8,
	    .useFullyQualifiedNames$86ab5d9fa7e4da73=
		&_jc_polyglot_frontend_Compiler$method$useFullyQualifiedNames$86ab5d9fa7e4da73,
	},
    }
};

