// public class polyglot.frontend.SourceLoader

// class file dependencies
// @dep_class 1160ded3f016b6b0 gnu_classpath_SystemProperties
// @dep_class 9cef6b66128b04b2 java_io_File
// @dep_class 411c07e717eacf69 java_io_FileNotFoundException
// @dep_class 4e0a56550c69d57c java_io_IOException
// @dep_class 99a46305ebacacb5 java_io_PrintStream
// @dep_class 16eb14cebbd5ebe6 java_io_VMFile
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class 680cf34d05feb5a1 java_lang_IllegalArgumentException
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class 4f5534a987354d1d java_lang_RuntimeException
// @dep_class d38282f3d5f80887 java_lang_SecurityManager
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 94d357637b968dda java_lang_StringBuffer
// @dep_class 53cc8e2333795f04 java_lang_System
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class 8ea716c64b77f8eb java_util_AbstractCollection
// @dep_class f5238436362828db java_util_AbstractList
// @dep_class ca427569b5b2f804 java_util_AbstractSet
// @dep_class eae4d0c0e8eb63da java_util_Collection
// @dep_class 9574af3fed58029a java_util_Collections
// @dep_class 2ccd076083da6c8e java_util_Collections__24SingletonList
// @dep_class d7cd853200c3e71f java_util_HashMap
// @dep_class 3c285c721478414d java_util_HashSet
// @dep_class be56ff673eefd9d2 java_util_Iterator
// @dep_class e283f7c2e7a7979c java_util_Map
// @dep_class 884c3edb343dfb63 java_util_Properties
// @dep_class 617ac82c0bec2dff java_util_Set
// @dep_class fdbc32d4847269bf polyglot_frontend_ExtensionInfo
// @dep_class 39c133c176bc5fd1 polyglot_frontend_FileSource
// @dep_class c0bff66c4ab313ae polyglot_frontend_SourceLoader
// @dep_class cf9f146bdb7bc44d polyglot_main_Report

// header file dependencies
// @dep_header gnu_classpath_SystemProperties
// @dep_header java_io_File
// @dep_header java_io_FileNotFoundException
// @dep_header java_io_PrintStream
// @dep_header java_io_VMFile
// @dep_header java_lang_Class
// @dep_header java_lang_IllegalArgumentException
// @dep_header java_lang_SecurityManager
// @dep_header java_lang_String
// @dep_header java_lang_StringBuffer
// @dep_header java_lang_System
// @dep_header java_lang_VMThrowable
// @dep_header java_util_Collection
// @dep_header java_util_Collections
// @dep_header java_util_Collections__24SingletonList
// @dep_header java_util_HashMap
// @dep_header java_util_HashSet
// @dep_header java_util_Iterator
// @dep_header java_util_Map
// @dep_header java_util_Properties
// @dep_header java_util_Set
// @dep_header polyglot_frontend_ExtensionInfo
// @dep_header polyglot_frontend_FileSource
// @dep_header polyglot_frontend_SourceLoader
// @dep_header polyglot_main_Report

#include "jc_defs.h"

#include "gnu/classpath/SystemProperties.h"
#include "java/io/File.h"
#include "java/io/FileNotFoundException.h"
#include "java/io/PrintStream.h"
#include "java/io/VMFile.h"
#include "java/lang/Class.h"
#include "java/lang/IllegalArgumentException.h"
#include "java/lang/SecurityManager.h"
#include "java/lang/String.h"
#include "java/lang/StringBuffer.h"
#include "java/lang/System.h"
#include "java/lang/VMThrowable.h"
#include "java/util/Collection.h"
#include "java/util/Collections.h"
#include "java/util/Collections__24SingletonList.h"
#include "java/util/HashMap.h"
#include "java/util/HashSet.h"
#include "java/util/Iterator.h"
#include "java/util/Map.h"
#include "java/util/Properties.h"
#include "java/util/Set.h"
#include "polyglot/frontend/ExtensionInfo.h"
#include "polyglot/frontend/FileSource.h"
#include "polyglot/frontend/SourceLoader.h"
#include "polyglot/main/Report.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// polyglot.frontend.ExtensionInfo sourceExt
static _jc_field _jc_polyglot_frontend_SourceLoader$field_info$sourceExt = {
	.name=		"sourceExt",
	.signature=	"Lpolyglot/frontend/ExtensionInfo;",
	.class=		&_jc_polyglot_frontend_SourceLoader$type,
	.type=		&_jc_polyglot_frontend_ExtensionInfo$type,
	.access_flags=	0,
	.offset=	_JC_OFFSETOF(_jc_polyglot_frontend_SourceLoader$object, refs[-1].polyglot_frontend_SourceLoader.sourceExt),
};

// java.util.Collection sourcePath
static _jc_field _jc_polyglot_frontend_SourceLoader$field_info$sourcePath = {
	.name=		"sourcePath",
	.signature=	"Ljava/util/Collection;",
	.class=		&_jc_polyglot_frontend_SourceLoader$type,
	.type=		&_jc_java_util_Collection$type,
	.access_flags=	0,
	.offset=	_JC_OFFSETOF(_jc_polyglot_frontend_SourceLoader$object, refs[-1].polyglot_frontend_SourceLoader.sourcePath),
};

// java.util.Map directoryContentsCache
static _jc_field _jc_polyglot_frontend_SourceLoader$field_info$directoryContentsCache = {
	.name=		"directoryContentsCache",
	.signature=	"Ljava/util/Map;",
	.class=		&_jc_polyglot_frontend_SourceLoader$type,
	.type=		&_jc_java_util_Map$type,
	.access_flags=	0,
	.offset=	_JC_OFFSETOF(_jc_polyglot_frontend_SourceLoader$object, refs[-1].polyglot_frontend_SourceLoader.directoryContentsCache),
};

// static java.io.File current_dir
static _jc_field _jc_polyglot_frontend_SourceLoader$field_info$current__5fdir = {
	.name=		"current_dir",
	.signature=	"Ljava/io/File;",
	.class=		&_jc_polyglot_frontend_SourceLoader$type,
	.type=		&_jc_java_io_File$type,
	.access_flags=	_JC_ACC_STATIC,
	.offset=	_JC_OFFSETOF(_jc_polyglot_frontend_SourceLoader$fields_struct, current__5fdir),
};

// Fields
static _jc_field *const _jc_polyglot_frontend_SourceLoader$fields[] = {
	&_jc_polyglot_frontend_SourceLoader$field_info$current__5fdir,
	&_jc_polyglot_frontend_SourceLoader$field_info$directoryContentsCache,
	&_jc_polyglot_frontend_SourceLoader$field_info$sourceExt,
	&_jc_polyglot_frontend_SourceLoader$field_info$sourcePath
};

/************************************************************************
 *			      Static methods				*
 ************************************************************************/

//
// static void <clinit>()
//

static _jc_linenum _jc_polyglot_frontend_SourceLoader$linenum_table$_clinit$a816641e0ba8bfef[];

static const unsigned char _jc_polyglot_frontend_SourceLoader$param_ptypes$_clinit$a816641e0ba8bfef[] = { 
_JC_TYPE_VOID };

_jc_method _jc_polyglot_frontend_SourceLoader$method_info$_clinit$a816641e0ba8bfef = {
	.name=			"<clinit>",
	.signature=		"()V",
	.class=			&_jc_polyglot_frontend_SourceLoader$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_frontend_SourceLoader$param_ptypes$_clinit$a816641e0ba8bfef,
	.signature_hash=	_JC_JLONG(0xa816641e0ba8bfef),
	.access_flags=		_JC_ACC_STATIC,
	.function=		&_jc_polyglot_frontend_SourceLoader$method$_clinit$a816641e0ba8bfef,
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_frontend_SourceLoader$linenum_table$_clinit$a816641e0ba8bfef
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_frontend_SourceLoader, _clinit$a816641e0ba8bfef);

void _JC_JCNI_ATTR
_jc_polyglot_frontend_SourceLoader$method$_clinit$a816641e0ba8bfef(_jc_env *const env)
{
	_JC_LINE_NUMBER(50);				// 0
	_JC_STATIC_FIELD(env, polyglot_frontend_SourceLoader, current__5fdir, 1) = _JC_NULL;
	return;
}

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// public void <init>(polyglot.frontend.ExtensionInfo, java.util.Collection)
//

static _jc_linenum _jc_polyglot_frontend_SourceLoader$linenum_table$_init$3561e6eb5fac231a[];

static const unsigned char _jc_polyglot_frontend_SourceLoader$param_ptypes$_init$3561e6eb5fac231a[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_frontend_SourceLoader$param_types$_init$3561e6eb5fac231a[] = {
	&_jc_polyglot_frontend_ExtensionInfo$type,
	&_jc_java_util_Collection$type
};

_jc_method _jc_polyglot_frontend_SourceLoader$method_info$_init$3561e6eb5fac231a = {
	.name=			"<init>",
	.signature=		"(Lpolyglot/frontend/ExtensionInfo;Ljava/util/Collection;)V",
	.class=			&_jc_polyglot_frontend_SourceLoader$type,
	.param_types=		&_jc_polyglot_frontend_SourceLoader$param_types$_init$3561e6eb5fac231a,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_frontend_SourceLoader$param_ptypes$_init$3561e6eb5fac231a,
	.signature_hash=	_JC_JLONG(0x3561e6eb5fac231a),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_frontend_SourceLoader$method$_init$3561e6eb5fac231a,
	.num_parameters=	2,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_polyglot_frontend_SourceLoader$linenum_table$_init$3561e6eb5fac231a
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_frontend_SourceLoader, _init$3561e6eb5fac231a);

void _JC_JCNI_ATTR
_jc_polyglot_frontend_SourceLoader$method$_init$3561e6eb5fac231a(_jc_env *const env, _jc_polyglot_frontend_SourceLoader$object *this, _jc_object *param0, _jc_object *param1)
{
	struct _jc_polyglot_frontend_SourceLoader$object *r0;
	struct _jc_object *r1;
	struct _jc_object *r2;
	struct _jc_java_util_HashMap$object *r3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_LINE_NUMBER(21);				// 0
	_JC_REF_FIELD(env, r0, polyglot_frontend_SourceLoader, sourcePath) = r2;
	_JC_LINE_NUMBER(22);				// 1
	_JC_REF_FIELD(env, r0, polyglot_frontend_SourceLoader, sourceExt) = r1;
	_JC_LINE_NUMBER(23);				// 2
	r3 = _JC_NEW(env, java_util_HashMap);
	_JC_INVOKE_NONVIRTUAL(env, java_util_HashMap, _init$7cb044ce4fb0ada8, 0, r3, 11, _JC_FCONST(0x3f, 0x40, 0x0, 0x0));
	_JC_REF_FIELD(env, r0, polyglot_frontend_SourceLoader, directoryContentsCache) = r3;
	_JC_LINE_NUMBER(24);				// 3
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public polyglot.frontend.FileSource classSource(java.lang.String)
//

static _jc_linenum _jc_polyglot_frontend_SourceLoader$linenum_table$classSource$9e78960aad0987c2[];

static const unsigned char _jc_polyglot_frontend_SourceLoader$param_ptypes$classSource$9e78960aad0987c2[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_frontend_SourceLoader$param_types$classSource$9e78960aad0987c2[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_polyglot_frontend_SourceLoader$method_info$classSource$9e78960aad0987c2 = {
	.name=			"classSource",
	.signature=		"(Ljava/lang/String;)Lpolyglot/frontend/FileSource;",
	.class=			&_jc_polyglot_frontend_SourceLoader$type,
	.param_types=		&_jc_polyglot_frontend_SourceLoader$param_types$classSource$9e78960aad0987c2,
	.return_type=		&_jc_polyglot_frontend_FileSource$type,
	.param_ptypes=		&_jc_polyglot_frontend_SourceLoader$param_ptypes$classSource$9e78960aad0987c2,
	.signature_hash=	_JC_JLONG(0x9e78960aad0987c2),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_frontend_SourceLoader$method$classSource$9e78960aad0987c2,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_frontend_SourceLoader$vtable, polyglot_frontend_SourceLoader.classSource$9e78960aad0987c2) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	26,
	      .table=	_jc_polyglot_frontend_SourceLoader$linenum_table$classSource$9e78960aad0987c2
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_frontend_SourceLoader, classSource$9e78960aad0987c2);

_jc_polyglot_frontend_FileSource$object * _JC_JCNI_ATTR
_jc_polyglot_frontend_SourceLoader$method$classSource$9e78960aad0987c2(_jc_env *const env, _jc_polyglot_frontend_SourceLoader$object *this, _jc_java_lang_String$object *param0)
{
	jchar c0;
	jint i1;
	jint i2;
	jint i3;
	jint i4;
	jint i5;
	jint i6;
	struct _jc_polyglot_frontend_SourceLoader$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_object *r10;
	struct _jc_java_lang_Object$object *r11;
	struct _jc_object *r12;
	struct _jc_java_util_HashSet$object *r13;
	struct _jc_java_io_File$object *r14;
	struct _jc_polyglot_frontend_FileSource$object *r15;
	struct _jc_java_lang_String$object *r16;
	struct _jc_java_lang_String$object *r17;
	_jc_char_array *r18;
	struct _jc_java_lang_String$object *r19;
	struct _jc_java_lang_StringBuffer$object *r2;
	struct _jc_java_util_HashMap$object *r20;
	struct _jc_java_lang_String$object *r21;
	_jc_char_array *r22;
	struct _jc_java_lang_Object$object *r23;
	struct _jc_java_util_HashMap$object *r24;
	struct _jc_java_io_File$object *r25;
	struct _jc_java_lang_String$object *r26;
	struct _jc_java_util_Collections__24SingletonList$object *r27;
	struct _jc_java_lang_StringBuffer$object *r28;
	struct _jc_java_lang_String$object *r29;
	struct _jc_java_lang_String$object *r3;
	struct _jc_java_io_PrintStream$object *r30;
	struct _jc_java_lang_String$object *r31;
	struct _jc_java_lang_SecurityManager$object *r32;
	struct _jc_java_lang_IllegalArgumentException$object *r33;
	struct _jc_java_lang_String$object *r34;
	struct _jc_java_lang_String$object *r35;
	struct _jc_java_util_Properties$object *r36;
	struct _jc_java_lang_VMThrowable$object *r38;
	struct _jc_object *r4;
	struct _jc_java_io_File$object *r5;
	struct _jc_object *r6;
	_jc_object_array *r7;
	struct _jc_object *r8;
	struct _jc_java_lang_String$object *r9;
	jboolean z0;
	jboolean z1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(55);				// 0
	r2 = _JC_NEW(env, java_lang_StringBuffer);
	r18 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r2, java_lang_StringBuffer, value) = r18;
	c0 = _JC_STATIC_FIELD(env, java_io_File, separatorChar, 0);
	r3 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, replace$3c3a4c257e28ba4a, 1, r1, 46, c0);
	r2 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r2, r3);
	r2 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r2, _JC_STRING(env, "."));
	r8 = _JC_REF_FIELD(env, r0, polyglot_frontend_SourceLoader, sourceExt);
	r3 = _JC_INVOKE_INTERFACE(env, r8, _JC_JLONG(0xfb12a09d08debe14), _jc_object *, (_jc_env *, struct _jc_object *));
	r2 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r2, r3);
	r16 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r16, r2);
	_JC_LINE_NUMBER(58);				// 1
	r5 = _JC_STATIC_FIELD(env, polyglot_frontend_SourceLoader, current__5fdir, 1);
	if (r5 != _JC_NULL)
		goto label2;
	_JC_LINE_NUMBER(59);				// 2
	r5 = _JC_NEW(env, java_io_File);
	_JC_ACTIVE_USE(env, java_lang_System);
	r31 = _JC_STRING(env, "user.dir");
	r32 = _JC_STATIC_FIELD(env, java_lang_SecurityManager, current, 0);
	if (r32 == _JC_NULL)
		goto label0;
	_JC_INVOKE_VIRTUAL(env, java_lang_SecurityManager, checkPropertyAccess$96b5133fb2013064, r32, r31);
	goto label1;

label0:
	i6 = _JC_PRIM_FIELD(env, r31, java_lang_String, count);
	if (i6 != 0)
		goto label1;
	r33 = _JC_NEW(env, java_lang_IllegalArgumentException);
	r34 = _JC_STRING(env, "key can't be empty");
	_JC_REF_FIELD(env, r33, java_lang_Throwable, cause) = r33;
	r38 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r33);
	_JC_REF_FIELD(env, r33, java_lang_Throwable, vmState) = r38;
	_JC_REF_FIELD(env, r33, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r33, java_lang_Throwable, detailMessage) = r34;
	_JC_THROW(env, r33);

label1:
	_JC_ACTIVE_USE(env, gnu_classpath_SystemProperties);
	r36 = _JC_STATIC_FIELD(env, gnu_classpath_SystemProperties, properties, 1);
	r35 = _JC_INVOKE_VIRTUAL(env, java_util_Properties, getProperty$17fb18205ea95f87, r36, r31);
	r19 = _JC_INVOKE_NONVIRTUAL(env, java_io_File, normalizePath$c82ffbd1adfcec00, 0, r5, r35);
	_JC_REF_FIELD(env, r5, java_io_File, path) = r19;
	_JC_STATIC_FIELD(env, polyglot_frontend_SourceLoader, current__5fdir, 1) = r5;

label2:
	_JC_LINE_NUMBER(62);				// 3
	r10 = _JC_REF_FIELD(env, r0, polyglot_frontend_SourceLoader, sourcePath);
	r4 = _JC_INVOKE_INTERFACE(env, r10, _JC_JLONG(0x3cc91493d50f531c), _jc_object *, (_jc_env *, struct _jc_object *));

label3:
	z0 = _JC_INVOKE_INTERFACE(env, r4, _JC_JLONG(0xfb0bd5e38c59ddcd), jboolean, (_jc_env *, struct _jc_object *));
	if (z0 == 0)
		goto label19;
	_JC_LINE_NUMBER(63);				// 4
	r11 = _JC_INVOKE_INTERFACE(env, r4, _JC_JLONG(0x5874f79a1cf66ea), _jc_object *, (_jc_env *, struct _jc_object *));
	r5 = _JC_CAST(env, &_jc_java_io_File$type, r11);
	_JC_LINE_NUMBER(64);				// 5
	r12 = _JC_REF_FIELD(env, r0, polyglot_frontend_SourceLoader, directoryContentsCache);
	r11 = _JC_INVOKE_INTERFACE(env, r12, _JC_JLONG(0xb30461fc5ea13399), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r5);
	r6 = _JC_CAST(env, &_jc_java_util_Set$type, r11);
	_JC_LINE_NUMBER(65);				// 6
	if (r6 != _JC_NULL)
		goto label6;
	_JC_LINE_NUMBER(66);				// 7
	r13 = _JC_NEW(env, java_util_HashSet);
	r20 = _JC_NEW(env, java_util_HashMap);
	_JC_INVOKE_NONVIRTUAL(env, java_util_HashMap, _init$7cb044ce4fb0ada8, 0, r20, 11, _JC_FCONST(0x3f, 0x40, 0x0, 0x0));
	_JC_REF_FIELD(env, r13, java_util_HashSet, map) = r20;
	r6 = r13;
	_JC_LINE_NUMBER(67);				// 8
	r12 = _JC_REF_FIELD(env, r0, polyglot_frontend_SourceLoader, directoryContentsCache);
	_JC_INVOKE_INTERFACE(env, r12, _JC_JLONG(0x3bd1c078a0faa8da), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *, struct _jc_java_lang_Object$object *), r5, r13);
	_JC_LINE_NUMBER(68);				// 9
	z0 = _JC_INVOKE_VIRTUAL(env, java_io_File, exists$e2d7e73156e7cca3, r5);
	if (z0 == 0)
		goto label6;
	_JC_LINE_NUMBER(69);				// 10
	r7 = _JC_INVOKE_VIRTUAL(env, java_io_File, list$9e09da44f0278aa5, r5);
	_JC_LINE_NUMBER(70);				// 11
	i1 = 0;

label4:
	i2 = _JC_ARRAY_LENGTH(env, r7);
	if (i1 >= i2)
		goto label6;
	_JC_LINE_NUMBER(71);				// 12
	r9 = _JC_REF_ELEMENT(env, r7, i1, 0, 0);
	r24 = _JC_REF_FIELD(env, r13, java_util_HashSet, map);
	r23 = _JC_INVOKE_VIRTUAL(env, java_util_HashMap, put$3bd1c078a0faa8da, r24, r9, _JC_STRING(env, ""));
	if (r23 != _JC_NULL)
		goto label5;

label5:
	_JC_LINE_NUMBER(70);				// 13
	i1 = i1 + 1;
	_JC_PERIODIC_CHECK(env);
	goto label4;

label6:
	_JC_LINE_NUMBER(77);				// 14
	c0 = _JC_STATIC_FIELD(env, java_io_File, separatorChar, 0);
	i3 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, indexOf$6ec5a1241e692e35, 0, r16, c0, 0);
	i2 = i3;
	_JC_LINE_NUMBER(78);				// 15
	if (i3 >= 0)
		goto label7;
	i4 = _JC_PRIM_FIELD(env, r16, java_lang_String, count);
	i2 = i4;

label7:
	_JC_LINE_NUMBER(79);				// 16
	r9 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, substring$df0d95f5ebfea7dc, 0, r16, 0, i2);
	_JC_LINE_NUMBER(81);				// 17
	z0 = _JC_INVOKE_INTERFACE(env, r6, _JC_JLONG(0xd3bd70da40f05cb1), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r9);
	if (z0 == 0) {
		_JC_PERIODIC_CHECK(env);
		goto label3;
	}
	_JC_LINE_NUMBER(86);				// 18
	if (r5 == _JC_NULL)
		goto label8;
	r14 = _JC_STATIC_FIELD(env, polyglot_frontend_SourceLoader, current__5fdir, 0);
	z0 = _JC_INVOKE_VIRTUAL(env, java_io_File, equals$8a15e0625571c581, r5, r14);
	if (z0 == 0)
		goto label8;
	_JC_LINE_NUMBER(87);				// 19
	r14 = _JC_NEW(env, java_io_File);
	r21 = _JC_INVOKE_NONVIRTUAL(env, java_io_File, normalizePath$c82ffbd1adfcec00, 0, r14, r16);
	_JC_REF_FIELD(env, r14, java_io_File, path) = r21;
	r5 = r14;
	goto label11;

label8:
	_JC_LINE_NUMBER(90);				// 20
	r14 = _JC_NEW(env, java_io_File);
	r25 = r14;
	if (r5 != _JC_NULL)
		goto label9;
	r26 = _JC_NULL;
	goto label10;

label9:
	r26 = _JC_REF_FIELD(env, r5, java_io_File, path);

label10:
	_JC_INVOKE_NONVIRTUAL(env, java_io_File, _init$a34354cd9552963f, 0, r25, r26, r16);
	r5 = r14;

label11:
	_JC_LINE_NUMBER(93);				// 21
	z0 = _JC_INVOKE_VIRTUAL(env, java_io_File, exists$e2d7e73156e7cca3, r5);
	if (z0 == 0) {
		_JC_PERIODIC_CHECK(env);
		goto label3;
	}
	_JC_LINE_NUMBER(94);				// 22
	r9 = _JC_STATIC_FIELD(env, polyglot_main_Report, frontend, 0);
	z1 = _JC_STATIC_FIELD(env, polyglot_main_Report, noReporting, 1);
	if (z1 == 0)
		goto label12;
	z0 = 0;
	goto label13;

label12:
	_JC_ACTIVE_USE(env, java_util_Collections);
	r27 = _JC_NEW(env, java_util_Collections__24SingletonList);
	_JC_REF_FIELD(env, r27, java_util_Collections__24SingletonList, element) = r9;
	z1 = _JC_INVOKE_STATIC(env, polyglot_main_Report, should__5freport$316269f2ec4db001, 1, r27, 2);
	z0 = z1;

label13:
	if (z0 == 0)
		goto label18;
	_JC_LINE_NUMBER(95);				// 23
	r2 = _JC_NEW(env, java_lang_StringBuffer);
	r22 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r2, java_lang_StringBuffer, value) = r22;
	r2 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r2, _JC_STRING(env, "Loading "));
	r2 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r2, r1);
	r2 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r2, _JC_STRING(env, " from "));
	r28 = r2;
	if (r5 != _JC_NULL)
		goto label14;
	r29 = _JC_STRING(env, "null");
	goto label15;

label14:
	r29 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, toString$7ea43b33b80a3070, r5);

label15:
	r28 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r28, r29);
	r17 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r17, r28);
	i5 = 1;

label16:
	if (i5 >= 2)
		goto label17;
	r30 = _JC_STATIC_FIELD(env, java_lang_System, err, 0);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, print$21bdbb15afdbea95, r30, _JC_STRING(env, "  "));
	i5 = i5 + 1;
	_JC_PERIODIC_CHECK(env);
	goto label16;

label17:
	r30 = _JC_STATIC_FIELD(env, java_lang_System, err, 0);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, println$f7dbc2aa0f0a9d4f, r30, r17);

label18:
	_JC_LINE_NUMBER(97);				// 24
	r15 = _JC_NEW(env, polyglot_frontend_FileSource);
	_JC_INVOKE_NONVIRTUAL(env, polyglot_frontend_FileSource, _init$538ee07130435a5e, 0, r15, r5);
	return r15;

label19:
	_JC_LINE_NUMBER(102);				// 25
	return _JC_NULL;
}

//
// public polyglot.frontend.FileSource fileSource(java.lang.String) throws java.io.IOException
//

static _jc_linenum _jc_polyglot_frontend_SourceLoader$linenum_table$fileSource$7884cd4a1c97af23[];

static const unsigned char _jc_polyglot_frontend_SourceLoader$param_ptypes$fileSource$7884cd4a1c97af23[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_frontend_SourceLoader$exceptions$fileSource$7884cd4a1c97af23[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_polyglot_frontend_SourceLoader$param_types$fileSource$7884cd4a1c97af23[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_polyglot_frontend_SourceLoader$method_info$fileSource$7884cd4a1c97af23 = {
	.name=			"fileSource",
	.signature=		"(Ljava/lang/String;)Lpolyglot/frontend/FileSource;",
	.class=			&_jc_polyglot_frontend_SourceLoader$type,
	.param_types=		&_jc_polyglot_frontend_SourceLoader$param_types$fileSource$7884cd4a1c97af23,
	.return_type=		&_jc_polyglot_frontend_FileSource$type,
	.param_ptypes=		&_jc_polyglot_frontend_SourceLoader$param_ptypes$fileSource$7884cd4a1c97af23,
	.signature_hash=	_JC_JLONG(0x7884cd4a1c97af23),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_frontend_SourceLoader$method$fileSource$7884cd4a1c97af23,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_frontend_SourceLoader$vtable, polyglot_frontend_SourceLoader.fileSource$7884cd4a1c97af23) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_frontend_SourceLoader$exceptions$fileSource$7884cd4a1c97af23,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	8,
	      .table=	_jc_polyglot_frontend_SourceLoader$linenum_table$fileSource$7884cd4a1c97af23
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_frontend_SourceLoader, fileSource$7884cd4a1c97af23);

_jc_polyglot_frontend_FileSource$object * _JC_JCNI_ATTR
_jc_polyglot_frontend_SourceLoader$method$fileSource$7884cd4a1c97af23(_jc_env *const env, _jc_polyglot_frontend_SourceLoader$object *this, _jc_java_lang_String$object *param0)
{
	jint i0;
	jint i1;
	jint i3;
	struct _jc_polyglot_frontend_SourceLoader$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_java_lang_String$object *r10;
	struct _jc_java_lang_String$object *r11;
	struct _jc_java_lang_String$object *r12;
	struct _jc_java_lang_String$object *r13;
	_jc_char_array *r14;
	_jc_char_array *r15;
	_jc_char_array *r16;
	struct _jc_java_lang_String$object *r17;
	struct _jc_java_lang_SecurityManager$object *r18;
	struct _jc_java_lang_VMThrowable$object *r19;
	struct _jc_java_io_File$object *r2;
	struct _jc_java_lang_VMThrowable$object *r20;
	struct _jc_java_util_Collections__24SingletonList$object *r21;
	struct _jc_java_lang_StringBuffer$object *r22;
	struct _jc_java_lang_String$object *r23;
	struct _jc_java_lang_String$object *r24;
	struct _jc_java_io_PrintStream$object *r26;
	struct _jc_java_io_FileNotFoundException$object *r3;
	struct _jc_java_lang_StringBuffer$object *r4;
	struct _jc_object *r5;
	struct _jc_java_lang_String$object *r6;
	struct _jc_java_io_IOException$object *r7;
	struct _jc_polyglot_frontend_FileSource$object *r8;
	struct _jc_java_lang_String$object *r9;
	jboolean z0;
	jboolean z1;
	jboolean z2;
	jboolean z3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(28);				// 0
	r2 = _JC_NEW(env, java_io_File);
	r12 = _JC_INVOKE_NONVIRTUAL(env, java_io_File, normalizePath$c82ffbd1adfcec00, 0, r2, r1);
	_JC_REF_FIELD(env, r2, java_io_File, path) = r12;
	_JC_ACTIVE_USE(env, java_lang_System);
	r18 = _JC_STATIC_FIELD(env, java_lang_SecurityManager, current, 0);
	if (r18 == _JC_NULL)
		goto label0;
	r17 = _JC_REF_FIELD(env, r2, java_io_File, path);
	_JC_INVOKE_VIRTUAL(env, java_lang_SecurityManager, checkRead$b67431badfc045e6, r18, r17);

label0:
	r13 = _JC_REF_FIELD(env, r2, java_io_File, path);
	z1 = _JC_INVOKE_STATIC(env, java_io_VMFile, exists$518e7ac7ddd01b27, 0, r13);
	_JC_LINE_NUMBER(30);				// 1
	if (z1 != 0)
		goto label1;
	_JC_LINE_NUMBER(31);				// 2
	r3 = _JC_NEW(env, java_io_FileNotFoundException);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r19 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r19;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r1;
	_JC_THROW(env, r3);

label1:
	_JC_LINE_NUMBER(34);				// 3
	r4 = _JC_NEW(env, java_lang_StringBuffer);
	r14 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r4, java_lang_StringBuffer, value) = r14;
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, _JC_STRING(env, "."));
	r5 = _JC_REF_FIELD(env, r0, polyglot_frontend_SourceLoader, sourceExt);
	r6 = _JC_INVOKE_INTERFACE(env, r5, _JC_JLONG(0xfb12a09d08debe14), _jc_object *, (_jc_env *, struct _jc_object *));
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, r6);
	r9 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r9, r4);
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	i0 = _JC_PRIM_FIELD(env, r1, java_lang_String, count);
	i1 = _JC_PRIM_FIELD(env, r9, java_lang_String, count);
	i1 = i0 - i1;
	i0 = _JC_PRIM_FIELD(env, r9, java_lang_String, count);
	z2 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, regionMatches$8a82c88118b60ee6, 0, r1, 0, i1, r9, 0, i0);
	if (z2 != 0)
		goto label2;
	_JC_LINE_NUMBER(35);				// 4
	r7 = _JC_NEW(env, java_io_IOException);
	r4 = _JC_NEW(env, java_lang_StringBuffer);
	r15 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r4, java_lang_StringBuffer, value) = r15;
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, _JC_STRING(env, "Source \""));
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, r1);
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, _JC_STRING(env, "\" does not have the extension \"."));
	r5 = _JC_REF_FIELD(env, r0, polyglot_frontend_SourceLoader, sourceExt);
	r6 = _JC_INVOKE_INTERFACE(env, r5, _JC_JLONG(0xfb12a09d08debe14), _jc_object *, (_jc_env *, struct _jc_object *));
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, r6);
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, _JC_STRING(env, "\"."));
	r10 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r10, r4);
	_JC_REF_FIELD(env, r7, java_lang_Throwable, cause) = r7;
	r20 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r7);
	_JC_REF_FIELD(env, r7, java_lang_Throwable, vmState) = r20;
	_JC_REF_FIELD(env, r7, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r7, java_lang_Throwable, detailMessage) = r10;
	_JC_THROW(env, r7);

label2:
	_JC_LINE_NUMBER(40);				// 5
	r6 = _JC_STATIC_FIELD(env, polyglot_main_Report, frontend, 0);
	z3 = _JC_STATIC_FIELD(env, polyglot_main_Report, noReporting, 1);
	if (z3 == 0)
		goto label3;
	z0 = 0;
	goto label4;

label3:
	_JC_ACTIVE_USE(env, java_util_Collections);
	r21 = _JC_NEW(env, java_util_Collections__24SingletonList);
	_JC_REF_FIELD(env, r21, java_util_Collections__24SingletonList, element) = r6;
	z3 = _JC_INVOKE_STATIC(env, polyglot_main_Report, should__5freport$316269f2ec4db001, 1, r21, 2);
	z0 = z3;

label4:
	if (z0 == 0)
		goto label9;
	_JC_LINE_NUMBER(41);				// 6
	r4 = _JC_NEW(env, java_lang_StringBuffer);
	r16 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r4, java_lang_StringBuffer, value) = r16;
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, _JC_STRING(env, "Loading class from "));
	r22 = r4;
	if (r2 != _JC_NULL)
		goto label5;
	r23 = _JC_STRING(env, "null");
	goto label6;

label5:
	r24 = _JC_REF_FIELD(env, r2, java_io_File, path);
	r23 = r24;

label6:
	r22 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r22, r23);
	r11 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r11, r22);
	i3 = 1;

label7:
	if (i3 >= 2)
		goto label8;
	r26 = _JC_STATIC_FIELD(env, java_lang_System, err, 1);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, print$21bdbb15afdbea95, r26, _JC_STRING(env, "  "));
	i3 = i3 + 1;
	_JC_PERIODIC_CHECK(env);
	goto label7;

label8:
	r26 = _JC_STATIC_FIELD(env, java_lang_System, err, 1);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, println$f7dbc2aa0f0a9d4f, r26, r11);

label9:
	_JC_LINE_NUMBER(43);				// 7
	r8 = _JC_NEW(env, polyglot_frontend_FileSource);
	_JC_INVOKE_NONVIRTUAL(env, polyglot_frontend_FileSource, _init$c31b894660454d13, 0, r8, r1);
	return r8;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_polyglot_frontend_SourceLoader$methods[] = {
	&_jc_polyglot_frontend_SourceLoader$method_info$_clinit$a816641e0ba8bfef,
	&_jc_polyglot_frontend_SourceLoader$method_info$_init$3561e6eb5fac231a,
	&_jc_polyglot_frontend_SourceLoader$method_info$classSource$9e78960aad0987c2,
	&_jc_polyglot_frontend_SourceLoader$method_info$fileSource$7884cd4a1c97af23
};

/************************************************************************
 *			  Class fields structure			*
 ************************************************************************/

_jc_polyglot_frontend_SourceLoader$fields_struct _jc_polyglot_frontend_SourceLoader$class_fields = { };

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_polyglot_frontend_SourceLoader$instanceof_hash_bucket_46[] = {
	&_jc_polyglot_frontend_SourceLoader$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_frontend_SourceLoader$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_polyglot_frontend_SourceLoader$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[46]=	_jc_polyglot_frontend_SourceLoader$instanceof_hash_bucket_46,
	[101]=	_jc_polyglot_frontend_SourceLoader$instanceof_hash_bucket_101
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_polyglot_frontend_SourceLoader$class_depends[] = {
	{ "gnu/classpath/SystemProperties",	_JC_JLONG(0x1160ded3f016b6b0) },
	{ "java/io/File",	_JC_JLONG(0x9cef6b66128b04b2) },
	{ "java/io/FileNotFoundException",	_JC_JLONG(0x411c07e717eacf69) },
	{ "java/io/IOException",	_JC_JLONG(0x4e0a56550c69d57c) },
	{ "java/io/PrintStream",	_JC_JLONG(0x99a46305ebacacb5) },
	{ "java/io/VMFile",	_JC_JLONG(0x16eb14cebbd5ebe6) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/IllegalArgumentException",	_JC_JLONG(0x680cf34d05feb5a1) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/RuntimeException",	_JC_JLONG(0x4f5534a987354d1d) },
	{ "java/lang/SecurityManager",	_JC_JLONG(0xd38282f3d5f80887) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/StringBuffer",	_JC_JLONG(0x94d357637b968dda) },
	{ "java/lang/System",	_JC_JLONG(0x53cc8e2333795f04) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/util/AbstractCollection",	_JC_JLONG(0x8ea716c64b77f8eb) },
	{ "java/util/AbstractList",	_JC_JLONG(0xf5238436362828db) },
	{ "java/util/AbstractSet",	_JC_JLONG(0xca427569b5b2f804) },
	{ "java/util/Collection",	_JC_JLONG(0xeae4d0c0e8eb63da) },
	{ "java/util/Collections",	_JC_JLONG(0x9574af3fed58029a) },
	{ "java/util/Collections$SingletonList",	_JC_JLONG(0x2ccd076083da6c8e) },
	{ "java/util/HashMap",	_JC_JLONG(0xd7cd853200c3e71f) },
	{ "java/util/HashSet",	_JC_JLONG(0x3c285c721478414d) },
	{ "java/util/Iterator",	_JC_JLONG(0xbe56ff673eefd9d2) },
	{ "java/util/Map",	_JC_JLONG(0xe283f7c2e7a7979c) },
	{ "java/util/Properties",	_JC_JLONG(0x884c3edb343dfb63) },
	{ "java/util/Set",	_JC_JLONG(0x617ac82c0bec2dff) },
	{ "polyglot/frontend/ExtensionInfo",	_JC_JLONG(0xfdbc32d4847269bf) },
	{ "polyglot/frontend/FileSource",	_JC_JLONG(0x39c133c176bc5fd1) },
	{ "polyglot/main/Report",	_JC_JLONG(0xcf9f146bdb7bc44d) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_polyglot_frontend_SourceLoader$vtype _jc_polyglot_frontend_SourceLoader$type = {
    .type= {
	.name=			"polyglot/frontend/SourceLoader",
	.superclass=		&_jc_java_lang_Object$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		13,
		.hash=			_JC_JLONG(0xc0bff66c4ab313ae),
		.source_file=		"SourceLoader.java",
		.instance_size=		sizeof(_jc_polyglot_frontend_SourceLoader$refs) + sizeof(_jc_polyglot_frontend_SourceLoader$object),
		.num_virtual_refs=	3,
		.num_fields=		sizeof(_jc_polyglot_frontend_SourceLoader$fields) / sizeof(*_jc_polyglot_frontend_SourceLoader$fields),
		.fields=		_jc_polyglot_frontend_SourceLoader$fields,
		.num_methods=		sizeof(_jc_polyglot_frontend_SourceLoader$methods) / sizeof(*_jc_polyglot_frontend_SourceLoader$methods),
		.methods=		_jc_polyglot_frontend_SourceLoader$methods,
		.instanceof_hash_table=	_jc_polyglot_frontend_SourceLoader$instanceof_hash_table,
		.class_fields=		&_jc_polyglot_frontend_SourceLoader$class_fields,
		.num_class_depends=		sizeof(_jc_polyglot_frontend_SourceLoader$class_depends) / sizeof(*_jc_polyglot_frontend_SourceLoader$class_depends),
		.class_depends=		_jc_polyglot_frontend_SourceLoader$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.polyglot_frontend_SourceLoader= {
	    .classSource$9e78960aad0987c2=
		&_jc_polyglot_frontend_SourceLoader$method$classSource$9e78960aad0987c2,
	    .fileSource$7884cd4a1c97af23=
		&_jc_polyglot_frontend_SourceLoader$method$fileSource$7884cd4a1c97af23,
	},
    }
};

