// public class polyglot.frontend.TargetFactory

// class file dependencies
// @dep_class 73e19fd20ea8f1b1 gnu_java_io_PlatformHelper
// @dep_class 9cef6b66128b04b2 java_io_File
// @dep_class 395e451981c47a9d java_io_FileOutputStream
// @dep_class 3c8cbb55c7a97310 java_io_FileWriter
// @dep_class a4c6ebbb4edda7cb java_io_FilterWriter
// @dep_class 4e0a56550c69d57c java_io_IOException
// @dep_class b2c3042960814a35 java_io_OutputStreamWriter
// @dep_class 99a46305ebacacb5 java_io_PrintStream
// @dep_class 4f1c42e0f315018e java_io_PrintWriter
// @dep_class 16eb14cebbd5ebe6 java_io_VMFile
// @dep_class 4897ee169f60a14f java_io_Writer
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class 505b8a9a6675be0 java_lang_NullPointerException
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class 4f5534a987354d1d java_lang_RuntimeException
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 94d357637b968dda java_lang_StringBuffer
// @dep_class 53cc8e2333795f04 java_lang_System
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class 8ea716c64b77f8eb java_util_AbstractCollection
// @dep_class f5238436362828db java_util_AbstractList
// @dep_class 9574af3fed58029a java_util_Collections
// @dep_class 2ccd076083da6c8e java_util_Collections__24SingletonList
// @dep_class cd88b669bec8f787 polyglot_frontend_Source
// @dep_class c99629f926ef2e3f polyglot_frontend_TargetFactory
// @dep_class cf9f146bdb7bc44d polyglot_main_Report
// @dep_class 22b321d488641c54 polyglot_util_InternalCompilerError
// @dep_class 32c9a088c5dac046 polyglot_util_Position
// @dep_class fb6b7201b85f5416 polyglot_util_UnicodeWriter

// header file dependencies
// @dep_header gnu_java_io_PlatformHelper
// @dep_header java_io_File
// @dep_header java_io_FileOutputStream
// @dep_header java_io_FileWriter
// @dep_header java_io_IOException
// @dep_header java_io_PrintStream
// @dep_header java_io_PrintWriter
// @dep_header java_io_VMFile
// @dep_header java_lang_Class
// @dep_header java_lang_NullPointerException
// @dep_header java_lang_String
// @dep_header java_lang_StringBuffer
// @dep_header java_lang_System
// @dep_header java_lang_VMThrowable
// @dep_header java_util_Collections
// @dep_header java_util_Collections__24SingletonList
// @dep_header polyglot_frontend_Source
// @dep_header polyglot_frontend_TargetFactory
// @dep_header polyglot_main_Report
// @dep_header polyglot_util_InternalCompilerError
// @dep_header polyglot_util_Position
// @dep_header polyglot_util_UnicodeWriter

#include "jc_defs.h"

#include "gnu/java/io/PlatformHelper.h"
#include "java/io/File.h"
#include "java/io/FileOutputStream.h"
#include "java/io/FileWriter.h"
#include "java/io/IOException.h"
#include "java/io/PrintStream.h"
#include "java/io/PrintWriter.h"
#include "java/io/VMFile.h"
#include "java/lang/Class.h"
#include "java/lang/NullPointerException.h"
#include "java/lang/String.h"
#include "java/lang/StringBuffer.h"
#include "java/lang/System.h"
#include "java/lang/VMThrowable.h"
#include "java/util/Collections.h"
#include "java/util/Collections__24SingletonList.h"
#include "polyglot/frontend/Source.h"
#include "polyglot/frontend/TargetFactory.h"
#include "polyglot/main/Report.h"
#include "polyglot/util/InternalCompilerError.h"
#include "polyglot/util/Position.h"
#include "polyglot/util/UnicodeWriter.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// java.io.File outputDirectory
static _jc_field _jc_polyglot_frontend_TargetFactory$field_info$outputDirectory = {
	.name=		"outputDirectory",
	.signature=	"Ljava/io/File;",
	.class=		&_jc_polyglot_frontend_TargetFactory$type,
	.type=		&_jc_java_io_File$type,
	.access_flags=	0,
	.offset=	_JC_OFFSETOF(_jc_polyglot_frontend_TargetFactory$object, refs[-1].polyglot_frontend_TargetFactory.outputDirectory),
};

// java.lang.String outputExtension
static _jc_field _jc_polyglot_frontend_TargetFactory$field_info$outputExtension = {
	.name=		"outputExtension",
	.signature=	"Ljava/lang/String;",
	.class=		&_jc_polyglot_frontend_TargetFactory$type,
	.type=		&_jc_java_lang_String$type,
	.access_flags=	0,
	.offset=	_JC_OFFSETOF(_jc_polyglot_frontend_TargetFactory$object, refs[-1].polyglot_frontend_TargetFactory.outputExtension),
};

// boolean outputStdout
static _jc_field _jc_polyglot_frontend_TargetFactory$field_info$outputStdout = {
	.name=		"outputStdout",
	.signature=	"Z",
	.class=		&_jc_polyglot_frontend_TargetFactory$type,
	.type=		&_jc_boolean$prim$type,
	.access_flags=	0,
	.offset=	_JC_OFFSETOF(_jc_polyglot_frontend_TargetFactory$object, nonrefs.polyglot_frontend_TargetFactory.outputStdout),
};

// Fields
static _jc_field *const _jc_polyglot_frontend_TargetFactory$fields[] = {
	&_jc_polyglot_frontend_TargetFactory$field_info$outputDirectory,
	&_jc_polyglot_frontend_TargetFactory$field_info$outputExtension,
	&_jc_polyglot_frontend_TargetFactory$field_info$outputStdout
};

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// public void <init>(java.io.File, java.lang.String, boolean)
//

static _jc_linenum _jc_polyglot_frontend_TargetFactory$linenum_table$_init$aa8534e7e8807714[];

static const unsigned char _jc_polyglot_frontend_TargetFactory$param_ptypes$_init$aa8534e7e8807714[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_frontend_TargetFactory$param_types$_init$aa8534e7e8807714[] = {
	&_jc_java_io_File$type,
	&_jc_java_lang_String$type,
	&_jc_boolean$prim$type
};

_jc_method _jc_polyglot_frontend_TargetFactory$method_info$_init$aa8534e7e8807714 = {
	.name=			"<init>",
	.signature=		"(Ljava/io/File;Ljava/lang/String;Z)V",
	.class=			&_jc_polyglot_frontend_TargetFactory$type,
	.param_types=		&_jc_polyglot_frontend_TargetFactory$param_types$_init$aa8534e7e8807714,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_frontend_TargetFactory$param_ptypes$_init$aa8534e7e8807714,
	.signature_hash=	_JC_JLONG(0xaa8534e7e8807714),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_frontend_TargetFactory$method$_init$aa8534e7e8807714,
	.num_parameters=	3,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_polyglot_frontend_TargetFactory$linenum_table$_init$aa8534e7e8807714
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_frontend_TargetFactory, _init$aa8534e7e8807714);

void _JC_JCNI_ATTR
_jc_polyglot_frontend_TargetFactory$method$_init$aa8534e7e8807714(_jc_env *const env, _jc_polyglot_frontend_TargetFactory$object *this, _jc_java_io_File$object *param0, _jc_java_lang_String$object *param1, jboolean param2)
{
	struct _jc_polyglot_frontend_TargetFactory$object *r0;
	struct _jc_java_io_File$object *r1;
	struct _jc_java_lang_String$object *r2;
	jboolean z0;

	r0 = this;
	r1 = param0;
	r2 = param1;
	z0 = param2;
	_JC_LINE_NUMBER(19);				// 0
	_JC_REF_FIELD(env, r0, polyglot_frontend_TargetFactory, outputDirectory) = r1;
	_JC_LINE_NUMBER(20);				// 1
	_JC_REF_FIELD(env, r0, polyglot_frontend_TargetFactory, outputExtension) = r2;
	_JC_LINE_NUMBER(21);				// 2
	_JC_PRIM_FIELD(env, r0, polyglot_frontend_TargetFactory, outputStdout) = z0;
	_JC_LINE_NUMBER(22);				// 3
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public java.io.File outputFile(java.lang.String, java.lang.String, polyglot.frontend.Source)
//

static _jc_linenum _jc_polyglot_frontend_TargetFactory$linenum_table$outputFile$d78934d4d9797553[];

static const unsigned char _jc_polyglot_frontend_TargetFactory$param_ptypes$outputFile$d78934d4d9797553[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_frontend_TargetFactory$param_types$outputFile$d78934d4d9797553[] = {
	&_jc_java_lang_String$type,
	&_jc_java_lang_String$type,
	&_jc_polyglot_frontend_Source$type
};

_jc_method _jc_polyglot_frontend_TargetFactory$method_info$outputFile$d78934d4d9797553 = {
	.name=			"outputFile",
	.signature=		"(Ljava/lang/String;Ljava/lang/String;Lpolyglot/frontend/Source;)Ljava/io/File;",
	.class=			&_jc_polyglot_frontend_TargetFactory$type,
	.param_types=		&_jc_polyglot_frontend_TargetFactory$param_types$outputFile$d78934d4d9797553,
	.return_type=		&_jc_java_io_File$type,
	.param_ptypes=		&_jc_polyglot_frontend_TargetFactory$param_ptypes$outputFile$d78934d4d9797553,
	.signature_hash=	_JC_JLONG(0xd78934d4d9797553),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_frontend_TargetFactory$method$outputFile$d78934d4d9797553,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_frontend_TargetFactory$vtable, polyglot_frontend_TargetFactory.outputFile$d78934d4d9797553) / sizeof(void *),
	.num_parameters=	3,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	8,
	      .table=	_jc_polyglot_frontend_TargetFactory$linenum_table$outputFile$d78934d4d9797553
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_frontend_TargetFactory, outputFile$d78934d4d9797553);

_jc_java_io_File$object * _JC_JCNI_ATTR
_jc_polyglot_frontend_TargetFactory$method$outputFile$d78934d4d9797553(_jc_env *const env, _jc_polyglot_frontend_TargetFactory$object *this, _jc_java_lang_String$object *param0, _jc_java_lang_String$object *param1, _jc_polyglot_frontend_Source$object *param2)
{
	jchar c0;
	struct _jc_polyglot_frontend_TargetFactory$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_polyglot_util_Position$object *r10;
	struct _jc_java_lang_String$object *r11;
	struct _jc_java_lang_String$object *r12;
	struct _jc_polyglot_util_Position$object *r13;
	_jc_char_array *r14;
	struct _jc_java_lang_VMThrowable$object *r15;
	struct _jc_java_lang_VMThrowable$object *r16;
	struct _jc_java_io_File$object *r17;
	struct _jc_java_lang_String$object *r2;
	struct _jc_java_lang_String$object *r20;
	struct _jc_polyglot_frontend_Source$object *r3;
	struct _jc_java_lang_StringBuffer$object *r4;
	struct _jc_java_io_File$object *r5;
	struct _jc_polyglot_util_InternalCompilerError$object *r6;
	struct _jc_java_io_File$object *r7;
	struct _jc_java_lang_String$object *r8;
	struct _jc_java_lang_String$object *r9;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	r3 = param2;
	_JC_LINE_NUMBER(59);				// 0
	r5 = _JC_REF_FIELD(env, r0, polyglot_frontend_TargetFactory, outputDirectory);
	if (r5 != _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(60);				// 1
	r6 = _JC_NEW(env, polyglot_util_InternalCompilerError);
	r9 = _JC_STRING(env, "Output directory not set.");
	r10 = _JC_NULL;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, cause) = r6;
	r15 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r6);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, vmState) = r15;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, detailMessage) = r9;
	_JC_REF_FIELD(env, r6, polyglot_util_InternalCompilerError, pos) = r10;
	_JC_THROW(env, r6);

label0:
	_JC_LINE_NUMBER(63);				// 2
	if (r1 != _JC_NULL)
		goto label1;
	_JC_LINE_NUMBER(64);				// 3
	r1 = _JC_STRING(env, "");

label1:
	_JC_LINE_NUMBER(67);				// 4
	r5 = _JC_NEW(env, java_io_File);
	r7 = _JC_REF_FIELD(env, r0, polyglot_frontend_TargetFactory, outputDirectory);
	r4 = _JC_NEW(env, java_lang_StringBuffer);
	r14 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r4, java_lang_StringBuffer, value) = r14;
	c0 = _JC_STATIC_FIELD(env, java_io_File, separatorChar, 1);
	r1 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, replace$3c3a4c257e28ba4a, 0, r1, 46, c0);
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, r1);
	c0 = _JC_STATIC_FIELD(env, java_io_File, separatorChar, 1);
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$9450b16e89f0618d, 0, r4, c0);
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, r2);
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, _JC_STRING(env, "."));
	r2 = _JC_REF_FIELD(env, r0, polyglot_frontend_TargetFactory, outputExtension);
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, r2);
	r11 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r11, r4);
	r17 = r5;
	if (r7 != _JC_NULL)
		goto label2;
	r20 = _JC_NULL;
	goto label3;

label2:
	r20 = _JC_REF_FIELD(env, r7, java_io_File, path);

label3:
	_JC_INVOKE_NONVIRTUAL(env, java_io_File, _init$a34354cd9552963f, 0, r17, r20, r11);
	_JC_LINE_NUMBER(73);				// 5
	if (r3 == _JC_NULL)
		goto label4;
	r8 = _JC_REF_FIELD(env, r5, java_io_File, path);
	r1 = _JC_INVOKE_VIRTUAL(env, polyglot_frontend_Source, path$9f39a268300fd9d2, r3);
	z0 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, equals$8a15e0625571c581, 1, r8, r1);
	if (z0 == 0)
		goto label4;
	_JC_LINE_NUMBER(74);				// 6
	r6 = _JC_NEW(env, polyglot_util_InternalCompilerError);
	r12 = _JC_STRING(env, "The output file is the same as the source file");
	r13 = _JC_NULL;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, cause) = r6;
	r16 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r6);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, vmState) = r16;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, detailMessage) = r12;
	_JC_REF_FIELD(env, r6, polyglot_util_InternalCompilerError, pos) = r13;
	_JC_THROW(env, r6);

label4:
	_JC_LINE_NUMBER(77);				// 7
	return r5;
}

//
// public java.io.File outputFile(java.lang.String, polyglot.frontend.Source)
//

static _jc_linenum _jc_polyglot_frontend_TargetFactory$linenum_table$outputFile$d841c7f40915a70a[];

static const unsigned char _jc_polyglot_frontend_TargetFactory$param_ptypes$outputFile$d841c7f40915a70a[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_frontend_TargetFactory$param_types$outputFile$d841c7f40915a70a[] = {
	&_jc_java_lang_String$type,
	&_jc_polyglot_frontend_Source$type
};

_jc_method _jc_polyglot_frontend_TargetFactory$method_info$outputFile$d841c7f40915a70a = {
	.name=			"outputFile",
	.signature=		"(Ljava/lang/String;Lpolyglot/frontend/Source;)Ljava/io/File;",
	.class=			&_jc_polyglot_frontend_TargetFactory$type,
	.param_types=		&_jc_polyglot_frontend_TargetFactory$param_types$outputFile$d841c7f40915a70a,
	.return_type=		&_jc_java_io_File$type,
	.param_ptypes=		&_jc_polyglot_frontend_TargetFactory$param_ptypes$outputFile$d841c7f40915a70a,
	.signature_hash=	_JC_JLONG(0xd841c7f40915a70a),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_frontend_TargetFactory$method$outputFile$d841c7f40915a70a,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_frontend_TargetFactory$vtable, polyglot_frontend_TargetFactory.outputFile$d841c7f40915a70a) / sizeof(void *),
	.num_parameters=	2,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_polyglot_frontend_TargetFactory$linenum_table$outputFile$d841c7f40915a70a
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_frontend_TargetFactory, outputFile$d841c7f40915a70a);

_jc_java_io_File$object * _JC_JCNI_ATTR
_jc_polyglot_frontend_TargetFactory$method$outputFile$d841c7f40915a70a(_jc_env *const env, _jc_polyglot_frontend_TargetFactory$object *this, _jc_java_lang_String$object *param0, _jc_polyglot_frontend_Source$object *param1)
{
	jint i0;
	jint i1;
	jint i2;
	jint i3;
	jint i5;
	struct _jc_polyglot_frontend_TargetFactory$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_polyglot_frontend_Source$object *r2;
	struct _jc_java_io_File$object *r3;
	struct _jc_java_lang_String$object *r4;
	struct _jc_java_lang_String$object *r5;
	struct _jc_java_lang_String$object *r6;
	struct _jc_java_lang_String$object *r7;
	struct _jc_java_lang_String$object *r8;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_LINE_NUMBER(51);				// 0
	r3 = _JC_NEW(env, java_io_File);
	r4 = _JC_INVOKE_VIRTUAL(env, polyglot_frontend_Source, name$e6acce026cadf81e, r2);
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_io_File, normalizePath$c82ffbd1adfcec00, 0, r3, r4);
	_JC_REF_FIELD(env, r3, java_io_File, path) = r6;
	r5 = _JC_REF_FIELD(env, r3, java_io_File, path);
	_JC_ACTIVE_USE(env, java_io_VMFile);
	i1 = _JC_INVOKE_STATIC(env, gnu_java_io_PlatformHelper, lastIndexOfSeparator$6f4dd247c16f3a97, 0, r5);
	if (i1 != -1)
		goto label0;
	goto label2;

label0:
	z0 = _JC_INVOKE_STATIC(env, gnu_java_io_PlatformHelper, endWithSeparator$b2289d34bd22831a, 1, r5);
	if (z0 == 0)
		goto label1;
	r5 = _JC_STRING(env, "");
	goto label2;

label1:
	r7 = _JC_STATIC_FIELD(env, java_io_File, separator, 1);
	_JC_EXPLICIT_NULL_CHECK(env, r7);
	i3 = _JC_PRIM_FIELD(env, r7, java_lang_String, count);
	i2 = i1 + i3;
	_JC_EXPLICIT_NULL_CHECK(env, r5);
	i5 = _JC_PRIM_FIELD(env, r5, java_lang_String, count);
	r8 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, substring$df0d95f5ebfea7dc, 0, r5, i2, i5);
	r5 = r8;

label2:
	_JC_EXPLICIT_NULL_CHECK(env, r5);
	i0 = _JC_PRIM_FIELD(env, r5, java_lang_String, count);
	i0 = i0 - 1;
	i0 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, lastIndexOf$f519cb8928895c80, 0, r5, 46, i0);
	_JC_LINE_NUMBER(52);				// 1
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, substring$df0d95f5ebfea7dc, 0, r5, 0, i0);
	_JC_LINE_NUMBER(53);				// 2
	r3 = _JC_INVOKE_VIRTUAL(env, polyglot_frontend_TargetFactory, outputFile$d78934d4d9797553, r0, r1, r4, r2);
	return r3;
}

//
// public java.io.Writer outputWriter(java.io.File) throws java.io.IOException
//

static _jc_linenum _jc_polyglot_frontend_TargetFactory$linenum_table$outputWriter$d25a01a68d960754[];

static const unsigned char _jc_polyglot_frontend_TargetFactory$param_ptypes$outputWriter$d25a01a68d960754[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_frontend_TargetFactory$exceptions$outputWriter$d25a01a68d960754[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_polyglot_frontend_TargetFactory$param_types$outputWriter$d25a01a68d960754[] = {
	&_jc_java_io_File$type
};

_jc_method _jc_polyglot_frontend_TargetFactory$method_info$outputWriter$d25a01a68d960754 = {
	.name=			"outputWriter",
	.signature=		"(Ljava/io/File;)Ljava/io/Writer;",
	.class=			&_jc_polyglot_frontend_TargetFactory$type,
	.param_types=		&_jc_polyglot_frontend_TargetFactory$param_types$outputWriter$d25a01a68d960754,
	.return_type=		&_jc_java_io_Writer$type,
	.param_ptypes=		&_jc_polyglot_frontend_TargetFactory$param_ptypes$outputWriter$d25a01a68d960754,
	.signature_hash=	_JC_JLONG(0xd25a01a68d960754),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_frontend_TargetFactory$method$outputWriter$d25a01a68d960754,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_frontend_TargetFactory$vtable, polyglot_frontend_TargetFactory.outputWriter$d25a01a68d960754) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_frontend_TargetFactory$exceptions$outputWriter$d25a01a68d960754,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	8,
	      .table=	_jc_polyglot_frontend_TargetFactory$linenum_table$outputWriter$d25a01a68d960754
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_frontend_TargetFactory, outputWriter$d25a01a68d960754);

_jc_java_io_Writer$object * _JC_JCNI_ATTR
_jc_polyglot_frontend_TargetFactory$method$outputWriter$d25a01a68d960754(_jc_env *const env, _jc_polyglot_frontend_TargetFactory$object *this, _jc_java_io_File$object *param0)
{
	struct _jc_polyglot_frontend_TargetFactory$object *r0;
	struct _jc_java_io_File$object *r1;
	_jc_char_array *r10;
	struct _jc_java_lang_Object$object *r11;
	struct _jc_java_io_FileOutputStream$object *r12;
	struct _jc_java_lang_Object$object *r13;
	struct _jc_java_util_Collections__24SingletonList$object *r14;
	struct _jc_java_lang_StringBuffer$object *r15;
	struct _jc_java_lang_String$object *r16;
	struct _jc_java_io_OutputStreamWriter$object *r17;
	struct _jc_java_io_Writer$object *r18;
	struct _jc_java_lang_NullPointerException$object *r19;
	struct _jc_java_lang_String$object *r2;
	struct _jc_java_lang_String$object *r20;
	struct _jc_java_lang_VMThrowable$object *r22;
	struct _jc_java_io_PrintStream$object *r3;
	struct _jc_java_io_File$object *r4;
	struct _jc_java_lang_StringBuffer$object *r5;
	struct _jc_polyglot_util_UnicodeWriter$object *r6;
	struct _jc_java_io_PrintWriter$object *r7;
	struct _jc_java_io_FileWriter$object *r8;
	struct _jc_java_lang_String$object *r9;
	jboolean z0;
	jboolean z1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(33);				// 0
	r2 = _JC_STATIC_FIELD(env, polyglot_main_Report, frontend, 0);
	z1 = _JC_STATIC_FIELD(env, polyglot_main_Report, noReporting, 1);
	if (z1 == 0)
		goto label0;
	z0 = 0;
	goto label1;

label0:
	_JC_ACTIVE_USE(env, java_util_Collections);
	r14 = _JC_NEW(env, java_util_Collections__24SingletonList);
	_JC_REF_FIELD(env, r14, java_util_Collections__24SingletonList, element) = r2;
	z1 = _JC_INVOKE_STATIC(env, polyglot_main_Report, should__5freport$316269f2ec4db001, 1, r14, 2);
	z0 = z1;

label1:
	if (z0 == 0)
		goto label4;
	_JC_LINE_NUMBER(34);				// 1
	r5 = _JC_NEW(env, java_lang_StringBuffer);
	r10 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r5, java_lang_StringBuffer, value) = r10;
	r5 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r5, _JC_STRING(env, "Opening "));
	r15 = r5;
	if (r1 != _JC_NULL)
		goto label2;
	r16 = _JC_STRING(env, "null");
	goto label3;

label2:
	r16 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, toString$7ea43b33b80a3070, r1);

label3:
	r15 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r15, r16);
	r5 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r15, _JC_STRING(env, " for output."));
	_JC_EXPLICIT_NULL_CHECK(env, r5);
	r9 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r9, r5);
	_JC_INVOKE_STATIC(env, polyglot_main_Report, report$0373120f850dba20, 1, 2, r9);

label4:
	_JC_LINE_NUMBER(36);				// 2
	z0 = _JC_PRIM_FIELD(env, r0, polyglot_frontend_TargetFactory, outputStdout);
	if (z0 == 0)
		goto label6;
	_JC_LINE_NUMBER(37);				// 3
	r6 = _JC_NEW(env, polyglot_util_UnicodeWriter);
	r7 = _JC_NEW(env, java_io_PrintWriter);
	r3 = _JC_STATIC_FIELD(env, java_lang_System, out, 0);
	_JC_REF_FIELD(env, r7, java_io_Writer, lock) = r7;
	r17 = _JC_NEW(env, java_io_OutputStreamWriter);
	_JC_INVOKE_NONVIRTUAL(env, java_io_OutputStreamWriter, _init$8b48f276bbc2c828, 0, r17, r3);
	_JC_REF_FIELD(env, r7, java_io_PrintWriter, out) = r17;
	r18 = _JC_REF_FIELD(env, r7, java_io_PrintWriter, out);
	_JC_REF_FIELD(env, r7, java_io_Writer, lock) = r18;
	r11 = _JC_REF_FIELD(env, r7, java_io_Writer, lock);
	if (r11 != _JC_NULL)
		goto label5;
	r19 = _JC_NEW(env, java_lang_NullPointerException);
	r20 = _JC_NULL;
	_JC_REF_FIELD(env, r19, java_lang_Throwable, cause) = r19;
	r22 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r19);
	_JC_REF_FIELD(env, r19, java_lang_Throwable, vmState) = r22;
	_JC_REF_FIELD(env, r19, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r19, java_lang_Throwable, detailMessage) = r20;
	_JC_THROW(env, r19);

label5:
	_JC_REF_FIELD(env, r6, java_io_Writer, lock) = r11;
	_JC_REF_FIELD(env, r6, java_io_FilterWriter, out) = r7;
	return r6;

label6:
	_JC_LINE_NUMBER(40);				// 4
	r4 = _JC_INVOKE_VIRTUAL(env, java_io_File, getParentFile$89520bb6c5366d5e, r1);
	z0 = _JC_INVOKE_VIRTUAL(env, java_io_File, exists$e2d7e73156e7cca3, r4);
	if (z0 != 0)
		goto label7;
	_JC_LINE_NUMBER(41);				// 5
	r4 = _JC_INVOKE_VIRTUAL(env, java_io_File, getParentFile$89520bb6c5366d5e, r1);
	_JC_LINE_NUMBER(42);				// 6
	_JC_INVOKE_VIRTUAL(env, java_io_File, mkdirs$3bc7913de952b85b, r4);

label7:
	_JC_LINE_NUMBER(45);				// 7
	r6 = _JC_NEW(env, polyglot_util_UnicodeWriter);
	r8 = _JC_NEW(env, java_io_FileWriter);
	r12 = _JC_NEW(env, java_io_FileOutputStream);
	_JC_INVOKE_NONVIRTUAL(env, java_io_FileOutputStream, _init$1a55b883867a95b8, 0, r12, r1, 0);
	_JC_INVOKE_NONVIRTUAL(env, java_io_OutputStreamWriter, _init$8b48f276bbc2c828, 0, r8, r12);
	r13 = _JC_REF_FIELD(env, r8, java_io_Writer, lock);
	_JC_INVOKE_NONVIRTUAL(env, java_io_Writer, _init$3fddd28dadb712ab, 0, r6, r13);
	_JC_REF_FIELD(env, r6, java_io_FilterWriter, out) = r8;
	return r6;
}

//
// public java.io.Writer outputWriter(java.lang.String, java.lang.String, polyglot.frontend.Source) throws java.io.IOException
//

static _jc_linenum _jc_polyglot_frontend_TargetFactory$linenum_table$outputWriter$38df3d82c3b2b709[];

static const unsigned char _jc_polyglot_frontend_TargetFactory$param_ptypes$outputWriter$38df3d82c3b2b709[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_frontend_TargetFactory$exceptions$outputWriter$38df3d82c3b2b709[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_polyglot_frontend_TargetFactory$param_types$outputWriter$38df3d82c3b2b709[] = {
	&_jc_java_lang_String$type,
	&_jc_java_lang_String$type,
	&_jc_polyglot_frontend_Source$type
};

_jc_method _jc_polyglot_frontend_TargetFactory$method_info$outputWriter$38df3d82c3b2b709 = {
	.name=			"outputWriter",
	.signature=		"(Ljava/lang/String;Ljava/lang/String;Lpolyglot/frontend/Source;)Ljava/io/Writer;",
	.class=			&_jc_polyglot_frontend_TargetFactory$type,
	.param_types=		&_jc_polyglot_frontend_TargetFactory$param_types$outputWriter$38df3d82c3b2b709,
	.return_type=		&_jc_java_io_Writer$type,
	.param_ptypes=		&_jc_polyglot_frontend_TargetFactory$param_ptypes$outputWriter$38df3d82c3b2b709,
	.signature_hash=	_JC_JLONG(0x38df3d82c3b2b709),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_frontend_TargetFactory$method$outputWriter$38df3d82c3b2b709,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_frontend_TargetFactory$vtable, polyglot_frontend_TargetFactory.outputWriter$38df3d82c3b2b709) / sizeof(void *),
	.num_parameters=	3,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_frontend_TargetFactory$exceptions$outputWriter$38df3d82c3b2b709,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_frontend_TargetFactory$linenum_table$outputWriter$38df3d82c3b2b709
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_frontend_TargetFactory, outputWriter$38df3d82c3b2b709);

_jc_java_io_Writer$object * _JC_JCNI_ATTR
_jc_polyglot_frontend_TargetFactory$method$outputWriter$38df3d82c3b2b709(_jc_env *const env, _jc_polyglot_frontend_TargetFactory$object *this, _jc_java_lang_String$object *param0, _jc_java_lang_String$object *param1, _jc_polyglot_frontend_Source$object *param2)
{
	struct _jc_polyglot_frontend_TargetFactory$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_java_lang_String$object *r2;
	struct _jc_polyglot_frontend_Source$object *r3;
	struct _jc_java_io_File$object *r4;
	struct _jc_java_io_Writer$object *r5;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	r3 = param2;
	_JC_LINE_NUMBER(28);				// 0
	r4 = _JC_INVOKE_VIRTUAL(env, polyglot_frontend_TargetFactory, outputFile$d78934d4d9797553, r0, r1, r2, r3);
	r5 = _JC_INVOKE_VIRTUAL(env, polyglot_frontend_TargetFactory, outputWriter$d25a01a68d960754, r0, r4);
	return r5;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_polyglot_frontend_TargetFactory$methods[] = {
	&_jc_polyglot_frontend_TargetFactory$method_info$_init$aa8534e7e8807714,
	&_jc_polyglot_frontend_TargetFactory$method_info$outputFile$d78934d4d9797553,
	&_jc_polyglot_frontend_TargetFactory$method_info$outputFile$d841c7f40915a70a,
	&_jc_polyglot_frontend_TargetFactory$method_info$outputWriter$d25a01a68d960754,
	&_jc_polyglot_frontend_TargetFactory$method_info$outputWriter$38df3d82c3b2b709
};

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_polyglot_frontend_TargetFactory$instanceof_hash_bucket_63[] = {
	&_jc_polyglot_frontend_TargetFactory$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_frontend_TargetFactory$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_polyglot_frontend_TargetFactory$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[63]=	_jc_polyglot_frontend_TargetFactory$instanceof_hash_bucket_63,
	[101]=	_jc_polyglot_frontend_TargetFactory$instanceof_hash_bucket_101
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_polyglot_frontend_TargetFactory$class_depends[] = {
	{ "gnu/java/io/PlatformHelper",	_JC_JLONG(0x73e19fd20ea8f1b1) },
	{ "java/io/File",	_JC_JLONG(0x9cef6b66128b04b2) },
	{ "java/io/FileOutputStream",	_JC_JLONG(0x395e451981c47a9d) },
	{ "java/io/FileWriter",	_JC_JLONG(0x3c8cbb55c7a97310) },
	{ "java/io/FilterWriter",	_JC_JLONG(0xa4c6ebbb4edda7cb) },
	{ "java/io/IOException",	_JC_JLONG(0x4e0a56550c69d57c) },
	{ "java/io/OutputStreamWriter",	_JC_JLONG(0xb2c3042960814a35) },
	{ "java/io/PrintStream",	_JC_JLONG(0x99a46305ebacacb5) },
	{ "java/io/PrintWriter",	_JC_JLONG(0x4f1c42e0f315018e) },
	{ "java/io/VMFile",	_JC_JLONG(0x16eb14cebbd5ebe6) },
	{ "java/io/Writer",	_JC_JLONG(0x4897ee169f60a14f) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/NullPointerException",	_JC_JLONG(0x505b8a9a6675be0) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/RuntimeException",	_JC_JLONG(0x4f5534a987354d1d) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/StringBuffer",	_JC_JLONG(0x94d357637b968dda) },
	{ "java/lang/System",	_JC_JLONG(0x53cc8e2333795f04) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/util/AbstractCollection",	_JC_JLONG(0x8ea716c64b77f8eb) },
	{ "java/util/AbstractList",	_JC_JLONG(0xf5238436362828db) },
	{ "java/util/Collections",	_JC_JLONG(0x9574af3fed58029a) },
	{ "java/util/Collections$SingletonList",	_JC_JLONG(0x2ccd076083da6c8e) },
	{ "polyglot/frontend/Source",	_JC_JLONG(0xcd88b669bec8f787) },
	{ "polyglot/main/Report",	_JC_JLONG(0xcf9f146bdb7bc44d) },
	{ "polyglot/util/InternalCompilerError",	_JC_JLONG(0x22b321d488641c54) },
	{ "polyglot/util/Position",	_JC_JLONG(0x32c9a088c5dac046) },
	{ "polyglot/util/UnicodeWriter",	_JC_JLONG(0xfb6b7201b85f5416) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_polyglot_frontend_TargetFactory$vtype _jc_polyglot_frontend_TargetFactory$type = {
    .type= {
	.name=			"polyglot/frontend/TargetFactory",
	.superclass=		&_jc_java_lang_Object$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		15,
		.hash=			_JC_JLONG(0xc99629f926ef2e3f),
		.source_file=		"TargetFactory.java",
		.instance_size=		sizeof(_jc_polyglot_frontend_TargetFactory$refs) + sizeof(_jc_polyglot_frontend_TargetFactory$object),
		.num_virtual_refs=	2,
		.num_fields=		sizeof(_jc_polyglot_frontend_TargetFactory$fields) / sizeof(*_jc_polyglot_frontend_TargetFactory$fields),
		.fields=		_jc_polyglot_frontend_TargetFactory$fields,
		.num_methods=		sizeof(_jc_polyglot_frontend_TargetFactory$methods) / sizeof(*_jc_polyglot_frontend_TargetFactory$methods),
		.methods=		_jc_polyglot_frontend_TargetFactory$methods,
		.instanceof_hash_table=	_jc_polyglot_frontend_TargetFactory$instanceof_hash_table,
		.num_class_depends=		sizeof(_jc_polyglot_frontend_TargetFactory$class_depends) / sizeof(*_jc_polyglot_frontend_TargetFactory$class_depends),
		.class_depends=		_jc_polyglot_frontend_TargetFactory$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.polyglot_frontend_TargetFactory= {
	    .outputFile$d78934d4d9797553=
		&_jc_polyglot_frontend_TargetFactory$method$outputFile$d78934d4d9797553,
	    .outputFile$d841c7f40915a70a=
		&_jc_polyglot_frontend_TargetFactory$method$outputFile$d841c7f40915a70a,
	    .outputWriter$d25a01a68d960754=
		&_jc_polyglot_frontend_TargetFactory$method$outputWriter$d25a01a68d960754,
	    .outputWriter$38df3d82c3b2b709=
		&_jc_polyglot_frontend_TargetFactory$method$outputWriter$38df3d82c3b2b709,
	},
    }
};

