// public class polyglot.types.LoadedClassResolver

// class file dependencies
// @dep_class eb60cf59bc393752 java_io_InvalidClassException
// @dep_class 99a46305ebacacb5 java_io_PrintStream
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class c933004fd5a6148 java_lang_ClassFormatError
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class ca631501391a31f1 java_lang_Integer
// @dep_class a9fd317e4e09506e java_lang_NumberFormatException
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 94d357637b968dda java_lang_StringBuffer
// @dep_class 53cc8e2333795f04 java_lang_System
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class 8ea716c64b77f8eb java_util_AbstractCollection
// @dep_class f5238436362828db java_util_AbstractList
// @dep_class ca427569b5b2f804 java_util_AbstractSet
// @dep_class 58038509830ef3f4 java_util_ArrayList
// @dep_class eae4d0c0e8eb63da java_util_Collection
// @dep_class 9574af3fed58029a java_util_Collections
// @dep_class 2ccd076083da6c8e java_util_Collections__24SingletonList
// @dep_class d7cd853200c3e71f java_util_HashMap
// @dep_class 3c285c721478414d java_util_HashSet
// @dep_class 617ac82c0bec2dff java_util_Set
// @dep_class b106445ca218ee16 java_util_StringTokenizer
// @dep_class cf9f146bdb7bc44d polyglot_main_Report
// @dep_class 4ba1325a7aefecac polyglot_main_Version
// @dep_class 5bedf50c16a6702d polyglot_types_BadSerializationException
// @dep_class c530a50397510e6f polyglot_types_CachingResolver
// @dep_class eec1a4cebd785b9d polyglot_types_ClassResolver
// @dep_class b38560af658974f8 polyglot_types_ClassType
// @dep_class 775d491e1eb77426 polyglot_types_LoadedClassResolver
// @dep_class e5f53252d3bf5dfd polyglot_types_Named
// @dep_class 7e014a610596faf9 polyglot_types_NoClassException
// @dep_class 6bcfbf52304f9e7c polyglot_types_ParsedClassType
// @dep_class 3a3788b16a28392b polyglot_types_Resolver
// @dep_class 45f755f5298b5b39 polyglot_types_SemanticException
// @dep_class 6596051546781098 polyglot_types_Type
// @dep_class ed171cdaca38ec28 polyglot_types_TypeSystem
// @dep_class f394a649a5830bb polyglot_types_reflect_ClassFile
// @dep_class 50cc35358493eab1 polyglot_types_reflect_ClassFileLoader
// @dep_class 32257e81ded29ed1 polyglot_types_reflect_ClassPathLoader
// @dep_class 32f10c9680c602c0 polyglot_util_CollectionUtil
// @dep_class f299688fad53c0b2 polyglot_util_TypeEncoder

// header file dependencies
// @dep_header java_io_InvalidClassException
// @dep_header java_io_PrintStream
// @dep_header java_lang_Class
// @dep_header java_lang_ClassFormatError
// @dep_header java_lang_Integer
// @dep_header java_lang_NumberFormatException
// @dep_header java_lang_String
// @dep_header java_lang_StringBuffer
// @dep_header java_lang_System
// @dep_header java_lang_VMThrowable
// @dep_header java_util_ArrayList
// @dep_header java_util_Collection
// @dep_header java_util_Collections
// @dep_header java_util_Collections__24SingletonList
// @dep_header java_util_HashMap
// @dep_header java_util_HashSet
// @dep_header java_util_Set
// @dep_header java_util_StringTokenizer
// @dep_header polyglot_main_Report
// @dep_header polyglot_main_Version
// @dep_header polyglot_types_BadSerializationException
// @dep_header polyglot_types_CachingResolver
// @dep_header polyglot_types_ClassType
// @dep_header polyglot_types_LoadedClassResolver
// @dep_header polyglot_types_Named
// @dep_header polyglot_types_NoClassException
// @dep_header polyglot_types_ParsedClassType
// @dep_header polyglot_types_Resolver
// @dep_header polyglot_types_Type
// @dep_header polyglot_types_TypeSystem
// @dep_header polyglot_types_reflect_ClassFile
// @dep_header polyglot_types_reflect_ClassFileLoader
// @dep_header polyglot_types_reflect_ClassPathLoader
// @dep_header polyglot_util_CollectionUtil
// @dep_header polyglot_util_TypeEncoder

#include "jc_defs.h"

#include "java/io/InvalidClassException.h"
#include "java/io/PrintStream.h"
#include "java/lang/Class.h"
#include "java/lang/ClassFormatError.h"
#include "java/lang/Integer.h"
#include "java/lang/NumberFormatException.h"
#include "java/lang/String.h"
#include "java/lang/StringBuffer.h"
#include "java/lang/System.h"
#include "java/lang/VMThrowable.h"
#include "java/util/ArrayList.h"
#include "java/util/Collection.h"
#include "java/util/Collections.h"
#include "java/util/Collections__24SingletonList.h"
#include "java/util/HashMap.h"
#include "java/util/HashSet.h"
#include "java/util/Set.h"
#include "java/util/StringTokenizer.h"
#include "polyglot/main/Report.h"
#include "polyglot/main/Version.h"
#include "polyglot/types/BadSerializationException.h"
#include "polyglot/types/CachingResolver.h"
#include "polyglot/types/ClassType.h"
#include "polyglot/types/LoadedClassResolver.h"
#include "polyglot/types/Named.h"
#include "polyglot/types/NoClassException.h"
#include "polyglot/types/ParsedClassType.h"
#include "polyglot/types/Resolver.h"
#include "polyglot/types/Type.h"
#include "polyglot/types/TypeSystem.h"
#include "polyglot/types/reflect/ClassFile.h"
#include "polyglot/types/reflect/ClassFileLoader.h"
#include "polyglot/types/reflect/ClassPathLoader.h"
#include "polyglot/util/CollectionUtil.h"
#include "polyglot/util/TypeEncoder.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// protected static final int NOT_COMPATIBLE
static const jint _jc_polyglot_types_LoadedClassResolver$initial_value$NOT__5fCOMPATIBLE = -1;
static _jc_field _jc_polyglot_types_LoadedClassResolver$field_info$NOT__5fCOMPATIBLE = {
	.name=		"NOT_COMPATIBLE",
	.signature=	"I",
	.class=		&_jc_polyglot_types_LoadedClassResolver$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PROTECTED|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_polyglot_types_LoadedClassResolver$fields_struct, NOT__5fCOMPATIBLE),
	.initial_value=	&_jc_polyglot_types_LoadedClassResolver$initial_value$NOT__5fCOMPATIBLE,
};

// protected static final int MINOR_NOT_COMPATIBLE
static const jint _jc_polyglot_types_LoadedClassResolver$initial_value$MINOR__5fNOT__5fCOMPATIBLE = 1;
static _jc_field _jc_polyglot_types_LoadedClassResolver$field_info$MINOR__5fNOT__5fCOMPATIBLE = {
	.name=		"MINOR_NOT_COMPATIBLE",
	.signature=	"I",
	.class=		&_jc_polyglot_types_LoadedClassResolver$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PROTECTED|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_polyglot_types_LoadedClassResolver$fields_struct, MINOR__5fNOT__5fCOMPATIBLE),
	.initial_value=	&_jc_polyglot_types_LoadedClassResolver$initial_value$MINOR__5fNOT__5fCOMPATIBLE,
};

// protected static final int COMPATIBLE
static const jint _jc_polyglot_types_LoadedClassResolver$initial_value$COMPATIBLE = 0;
static _jc_field _jc_polyglot_types_LoadedClassResolver$field_info$COMPATIBLE = {
	.name=		"COMPATIBLE",
	.signature=	"I",
	.class=		&_jc_polyglot_types_LoadedClassResolver$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PROTECTED|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_polyglot_types_LoadedClassResolver$fields_struct, COMPATIBLE),
	.initial_value=	&_jc_polyglot_types_LoadedClassResolver$initial_value$COMPATIBLE,
};

// polyglot.types.TypeSystem ts
static _jc_field _jc_polyglot_types_LoadedClassResolver$field_info$ts = {
	.name=		"ts",
	.signature=	"Lpolyglot/types/TypeSystem;",
	.class=		&_jc_polyglot_types_LoadedClassResolver$type,
	.type=		&_jc_polyglot_types_TypeSystem$type,
	.access_flags=	0,
	.offset=	_JC_OFFSETOF(_jc_polyglot_types_LoadedClassResolver$object, refs[-1].polyglot_types_LoadedClassResolver.ts),
};

// polyglot.util.TypeEncoder te
static _jc_field _jc_polyglot_types_LoadedClassResolver$field_info$te = {
	.name=		"te",
	.signature=	"Lpolyglot/util/TypeEncoder;",
	.class=		&_jc_polyglot_types_LoadedClassResolver$type,
	.type=		&_jc_polyglot_util_TypeEncoder$type,
	.access_flags=	0,
	.offset=	_JC_OFFSETOF(_jc_polyglot_types_LoadedClassResolver$object, refs[-1].polyglot_types_LoadedClassResolver.te),
};

// polyglot.types.reflect.ClassPathLoader loader
static _jc_field _jc_polyglot_types_LoadedClassResolver$field_info$loader = {
	.name=		"loader",
	.signature=	"Lpolyglot/types/reflect/ClassPathLoader;",
	.class=		&_jc_polyglot_types_LoadedClassResolver$type,
	.type=		&_jc_polyglot_types_reflect_ClassPathLoader$type,
	.access_flags=	0,
	.offset=	_JC_OFFSETOF(_jc_polyglot_types_LoadedClassResolver$object, refs[-1].polyglot_types_LoadedClassResolver.loader),
};

// polyglot.main.Version version
static _jc_field _jc_polyglot_types_LoadedClassResolver$field_info$version = {
	.name=		"version",
	.signature=	"Lpolyglot/main/Version;",
	.class=		&_jc_polyglot_types_LoadedClassResolver$type,
	.type=		&_jc_polyglot_main_Version$type,
	.access_flags=	0,
	.offset=	_JC_OFFSETOF(_jc_polyglot_types_LoadedClassResolver$object, refs[-1].polyglot_types_LoadedClassResolver.version),
};

// java.util.Set nocache
static _jc_field _jc_polyglot_types_LoadedClassResolver$field_info$nocache = {
	.name=		"nocache",
	.signature=	"Ljava/util/Set;",
	.class=		&_jc_polyglot_types_LoadedClassResolver$type,
	.type=		&_jc_java_util_Set$type,
	.access_flags=	0,
	.offset=	_JC_OFFSETOF(_jc_polyglot_types_LoadedClassResolver$object, refs[-1].polyglot_types_LoadedClassResolver.nocache),
};

// boolean allowRawClasses
static _jc_field _jc_polyglot_types_LoadedClassResolver$field_info$allowRawClasses = {
	.name=		"allowRawClasses",
	.signature=	"Z",
	.class=		&_jc_polyglot_types_LoadedClassResolver$type,
	.type=		&_jc_boolean$prim$type,
	.access_flags=	0,
	.offset=	_JC_OFFSETOF(_jc_polyglot_types_LoadedClassResolver$object, nonrefs.polyglot_types_LoadedClassResolver.allowRawClasses),
};

// static final java.util.Collection report_topics
static _jc_field _jc_polyglot_types_LoadedClassResolver$field_info$report__5ftopics = {
	.name=		"report_topics",
	.signature=	"Ljava/util/Collection;",
	.class=		&_jc_polyglot_types_LoadedClassResolver$type,
	.type=		&_jc_java_util_Collection$type,
	.access_flags=	_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_polyglot_types_LoadedClassResolver$fields_struct, report__5ftopics),
};

// Fields
static _jc_field *const _jc_polyglot_types_LoadedClassResolver$fields[] = {
	&_jc_polyglot_types_LoadedClassResolver$field_info$report__5ftopics,
	&_jc_polyglot_types_LoadedClassResolver$field_info$COMPATIBLE,
	&_jc_polyglot_types_LoadedClassResolver$field_info$MINOR__5fNOT__5fCOMPATIBLE,
	&_jc_polyglot_types_LoadedClassResolver$field_info$NOT__5fCOMPATIBLE,
	&_jc_polyglot_types_LoadedClassResolver$field_info$loader,
	&_jc_polyglot_types_LoadedClassResolver$field_info$nocache,
	&_jc_polyglot_types_LoadedClassResolver$field_info$te,
	&_jc_polyglot_types_LoadedClassResolver$field_info$ts,
	&_jc_polyglot_types_LoadedClassResolver$field_info$version,
	&_jc_polyglot_types_LoadedClassResolver$field_info$allowRawClasses
};

/************************************************************************
 *			      Static methods				*
 ************************************************************************/

//
// static void <clinit>()
//

static _jc_linenum _jc_polyglot_types_LoadedClassResolver$linenum_table$_clinit$a816641e0ba8bfef[];

static const unsigned char _jc_polyglot_types_LoadedClassResolver$param_ptypes$_clinit$a816641e0ba8bfef[] = { 
_JC_TYPE_VOID };

_jc_method _jc_polyglot_types_LoadedClassResolver$method_info$_clinit$a816641e0ba8bfef = {
	.name=			"<clinit>",
	.signature=		"()V",
	.class=			&_jc_polyglot_types_LoadedClassResolver$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_types_LoadedClassResolver$param_ptypes$_clinit$a816641e0ba8bfef,
	.signature_hash=	_JC_JLONG(0xa816641e0ba8bfef),
	.access_flags=		_JC_ACC_STATIC,
	.function=		&_jc_polyglot_types_LoadedClassResolver$method$_clinit$a816641e0ba8bfef,
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_types_LoadedClassResolver$linenum_table$_clinit$a816641e0ba8bfef
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_types_LoadedClassResolver, _clinit$a816641e0ba8bfef);

void _JC_JCNI_ATTR
_jc_polyglot_types_LoadedClassResolver$method$_clinit$a816641e0ba8bfef(_jc_env *const env)
{
	struct _jc_java_lang_String$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_java_lang_String$object *r2;
	struct _jc_java_util_ArrayList$object *r3;
	_jc_object_array *r4;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	_JC_LINE_NUMBER(34);				// 0
	r0 = _JC_STATIC_FIELD(env, polyglot_main_Report, types, 0);
	r1 = _JC_STATIC_FIELD(env, polyglot_main_Report, resolver, 1);
	r2 = _JC_STATIC_FIELD(env, polyglot_main_Report, loader, 1);
	_JC_ACTIVE_USE(env, polyglot_util_CollectionUtil);
	r3 = _JC_NEW(env, java_util_ArrayList);
	r4 = _JC_NEW_REF_ARRAY(env, java_lang_Object, 1, 3);
	_JC_REF_FIELD(env, r3, java_util_ArrayList, data) = r4;
	_JC_INVOKE_NONVIRTUAL(env, java_util_ArrayList, add$831f06ee5f59c0cc, 0, r3, r0);
	_JC_INVOKE_NONVIRTUAL(env, java_util_ArrayList, add$831f06ee5f59c0cc, 0, r3, r1);
	_JC_INVOKE_NONVIRTUAL(env, java_util_ArrayList, add$831f06ee5f59c0cc, 0, r3, r2);
	_JC_STATIC_FIELD(env, polyglot_types_LoadedClassResolver, report__5ftopics, 1) = r3;
	return;
}

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// public void <init>(polyglot.types.TypeSystem, java.lang.String, polyglot.types.reflect.ClassFileLoader, polyglot.main.Version, boolean)
//

static _jc_linenum _jc_polyglot_types_LoadedClassResolver$linenum_table$_init$4496cf846523face[];

static const unsigned char _jc_polyglot_types_LoadedClassResolver$param_ptypes$_init$4496cf846523face[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_types_LoadedClassResolver$param_types$_init$4496cf846523face[] = {
	&_jc_polyglot_types_TypeSystem$type,
	&_jc_java_lang_String$type,
	&_jc_polyglot_types_reflect_ClassFileLoader$type,
	&_jc_polyglot_main_Version$type,
	&_jc_boolean$prim$type
};

_jc_method _jc_polyglot_types_LoadedClassResolver$method_info$_init$4496cf846523face = {
	.name=			"<init>",
	.signature=		"(Lpolyglot/types/TypeSystem;Ljava/lang/String;Lpolyglot/types/reflect/ClassFileLoader;Lpolyglot/main/Version;Z)V",
	.class=			&_jc_polyglot_types_LoadedClassResolver$type,
	.param_types=		&_jc_polyglot_types_LoadedClassResolver$param_types$_init$4496cf846523face,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_types_LoadedClassResolver$param_ptypes$_init$4496cf846523face,
	.signature_hash=	_JC_JLONG(0x4496cf846523face),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_types_LoadedClassResolver$method$_init$4496cf846523face,
	.num_parameters=	5,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	7,
	      .table=	_jc_polyglot_types_LoadedClassResolver$linenum_table$_init$4496cf846523face
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_types_LoadedClassResolver, _init$4496cf846523face);

void _JC_JCNI_ATTR
_jc_polyglot_types_LoadedClassResolver$method$_init$4496cf846523face(_jc_env *const env, _jc_polyglot_types_LoadedClassResolver$object *this, _jc_object *param0, _jc_java_lang_String$object *param1, _jc_polyglot_types_reflect_ClassFileLoader$object *param2, _jc_polyglot_main_Version$object *param3, jboolean param4)
{
	struct _jc_polyglot_types_LoadedClassResolver$object *r0;
	struct _jc_object *r1;
	struct _jc_java_lang_String$object *r2;
	struct _jc_polyglot_types_reflect_ClassFileLoader$object *r3;
	struct _jc_polyglot_main_Version$object *r4;
	struct _jc_polyglot_util_TypeEncoder$object *r5;
	struct _jc_polyglot_types_reflect_ClassPathLoader$object *r6;
	struct _jc_java_util_HashSet$object *r7;
	struct _jc_java_util_HashMap$object *r8;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	r3 = param2;
	r4 = param3;
	z0 = param4;
	_JC_LINE_NUMBER(48);				// 0
	_JC_REF_FIELD(env, r0, polyglot_types_LoadedClassResolver, ts) = r1;
	_JC_LINE_NUMBER(49);				// 1
	r5 = _JC_NEW(env, polyglot_util_TypeEncoder);
	_JC_PRIM_FIELD(env, r5, polyglot_util_TypeEncoder, zip) = 1;
	_JC_PRIM_FIELD(env, r5, polyglot_util_TypeEncoder, base64) = 1;
	_JC_PRIM_FIELD(env, r5, polyglot_util_TypeEncoder, test) = 0;
	_JC_REF_FIELD(env, r5, polyglot_util_TypeEncoder, ts) = r1;
	_JC_REF_FIELD(env, r0, polyglot_types_LoadedClassResolver, te) = r5;
	_JC_LINE_NUMBER(50);				// 2
	r6 = _JC_NEW(env, polyglot_types_reflect_ClassPathLoader);
	_JC_INVOKE_NONVIRTUAL(env, polyglot_types_reflect_ClassPathLoader, _init$f2ee4e1d676e9c64, 0, r6, r2, r3);
	_JC_REF_FIELD(env, r0, polyglot_types_LoadedClassResolver, loader) = r6;
	_JC_LINE_NUMBER(51);				// 3
	_JC_REF_FIELD(env, r0, polyglot_types_LoadedClassResolver, version) = r4;
	_JC_LINE_NUMBER(52);				// 4
	r7 = _JC_NEW(env, java_util_HashSet);
	r8 = _JC_NEW(env, java_util_HashMap);
	_JC_INVOKE_NONVIRTUAL(env, java_util_HashMap, _init$7cb044ce4fb0ada8, 0, r8, 11, _JC_FCONST(0x3f, 0x40, 0x0, 0x0));
	_JC_REF_FIELD(env, r7, java_util_HashSet, map) = r8;
	_JC_REF_FIELD(env, r0, polyglot_types_LoadedClassResolver, nocache) = r7;
	_JC_LINE_NUMBER(53);				// 5
	_JC_PRIM_FIELD(env, r0, polyglot_types_LoadedClassResolver, allowRawClasses) = z0;
	_JC_LINE_NUMBER(54);				// 6
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// protected int checkCompilerVersion(java.lang.String)
//

static _jc_linenum _jc_polyglot_types_LoadedClassResolver$linenum_table$checkCompilerVersion$06ae3cf9489417d8[];

static _jc_trap_info _jc_polyglot_types_LoadedClassResolver$trap_table$checkCompilerVersion$06ae3cf9489417d8[] = {
	_JC_TRAP(&_jc_java_lang_NumberFormatException$type, 1, 2),
	_JC_TRAP(&_jc_java_lang_NumberFormatException$type, 3, 4),
};

static const unsigned char _jc_polyglot_types_LoadedClassResolver$param_ptypes$checkCompilerVersion$06ae3cf9489417d8[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT };

static _jc_type *const _jc_polyglot_types_LoadedClassResolver$param_types$checkCompilerVersion$06ae3cf9489417d8[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_polyglot_types_LoadedClassResolver$method_info$checkCompilerVersion$06ae3cf9489417d8 = {
	.name=			"checkCompilerVersion",
	.signature=		"(Ljava/lang/String;)I",
	.class=			&_jc_polyglot_types_LoadedClassResolver$type,
	.param_types=		&_jc_polyglot_types_LoadedClassResolver$param_types$checkCompilerVersion$06ae3cf9489417d8,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_polyglot_types_LoadedClassResolver$param_ptypes$checkCompilerVersion$06ae3cf9489417d8,
	.signature_hash=	_JC_JLONG(0x6ae3cf9489417d8),
	.access_flags=		_JC_ACC_PROTECTED,
	.function=		&_jc_polyglot_types_LoadedClassResolver$method$checkCompilerVersion$06ae3cf9489417d8,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_types_LoadedClassResolver$vtable, polyglot_types_LoadedClassResolver.checkCompilerVersion$06ae3cf9489417d8) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .trap_table_len=	2,
	  .trap_table=		_jc_polyglot_types_LoadedClassResolver$trap_table$checkCompilerVersion$06ae3cf9489417d8,
	  .u= {
	    .linenum= {
	      .len=	13,
	      .table=	_jc_polyglot_types_LoadedClassResolver$linenum_table$checkCompilerVersion$06ae3cf9489417d8
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_types_LoadedClassResolver, checkCompilerVersion$06ae3cf9489417d8);

jint _JC_JCNI_ATTR
_jc_polyglot_types_LoadedClassResolver$method$checkCompilerVersion$06ae3cf9489417d8(_jc_env *const env, _jc_polyglot_types_LoadedClassResolver$object *this, _jc_java_lang_String$object *param0)
{
	jint i0;
	jint i1;
	jint i2;
	jint i3;
	jint i5;
	struct _jc_polyglot_types_LoadedClassResolver$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_java_util_StringTokenizer$object *r2;
	struct _jc_polyglot_main_Version$object *r3;
	struct _jc_java_lang_NumberFormatException$object *r4;
	struct _jc_java_lang_String$object *r5;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_polyglot_types_LoadedClassResolver$method_info$checkCompilerVersion$06ae3cf9489417d8, &&label2, &&label2);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(173);				// 0
	if (r1 != _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(174);				// 1
	_JC_CANCEL_TRAPS(env, catch);
	return -1;

label0:
	_JC_LINE_NUMBER(177);				// 2
	r2 = _JC_NEW(env, java_util_StringTokenizer);
	r5 = _JC_STRING(env, ".");
	i5 = _JC_PRIM_FIELD(env, r1, java_lang_String, count);
	_JC_PRIM_FIELD(env, r2, java_util_StringTokenizer, len) = i5;
	_JC_REF_FIELD(env, r2, java_util_StringTokenizer, str) = r1;
	_JC_REF_FIELD(env, r2, java_util_StringTokenizer, delim) = r5;
	_JC_PRIM_FIELD(env, r2, java_util_StringTokenizer, retDelims) = 0;
	_JC_PRIM_FIELD(env, r2, java_util_StringTokenizer, pos) = 0;
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(181);				// 3
	r1 = _JC_INVOKE_NONVIRTUAL(env, java_util_StringTokenizer, nextToken$706c46e280dd7989, 0, r2);
	_JC_ACTIVE_USE(env, java_lang_Integer);
	i2 = _JC_INVOKE_STATIC(env, java_lang_Integer, parseInt$09e508ce4e7428b2, 1, r1, 10, 0);
	_JC_LINE_NUMBER(182);				// 4
	r3 = _JC_REF_FIELD(env, r0, polyglot_types_LoadedClassResolver, version);
	_JC_LINE_NUMBER(184);				// 5
	i1 = _JC_INVOKE_VIRTUAL(env, polyglot_main_Version, major$11e120a477900a2f, r3);
	if (i2 == i1)
		goto label1;
	_JC_TRAP_REGION(catch, 2);
	_JC_LINE_NUMBER(186);				// 6
	_JC_CANCEL_TRAPS(env, catch);
	return -1;

label1:
	_JC_TRAP_REGION(catch, 3);
	_JC_LINE_NUMBER(189);				// 7
	r1 = _JC_INVOKE_NONVIRTUAL(env, java_util_StringTokenizer, nextToken$706c46e280dd7989, 0, r2);
	i3 = _JC_INVOKE_STATIC(env, java_lang_Integer, parseInt$09e508ce4e7428b2, 1, r1, 10, 0);
	_JC_LINE_NUMBER(191);				// 8
	i0 = _JC_INVOKE_VIRTUAL(env, polyglot_main_Version, minor$206704e7c95168d6, r3);
	if (i3 == i0)
		goto label3;
	_JC_TRAP_REGION(catch, 4);
	_JC_LINE_NUMBER(193);				// 9
	_JC_CANCEL_TRAPS(env, catch);
	return 1;

label2:
	_JC_TRAP_REGION(catch, 4);
	_JC_LINE_NUMBER(198);				// 10
	r4 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(197);				// 11
	_JC_CANCEL_TRAPS(env, catch);
	return -1;

label3:
	_JC_TRAP_REGION(catch, 4);
	_JC_LINE_NUMBER(201);				// 12
	_JC_CANCEL_TRAPS(env, catch);
	return 0;
}

//
// public polyglot.types.Named find(java.lang.String) throws polyglot.types.SemanticException
//

static _jc_linenum _jc_polyglot_types_LoadedClassResolver$linenum_table$find$6acc62ea1c707b3c[];

static const unsigned char _jc_polyglot_types_LoadedClassResolver$param_ptypes$find$6acc62ea1c707b3c[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_LoadedClassResolver$exceptions$find$6acc62ea1c707b3c[] = {
	&_jc_polyglot_types_SemanticException$type
};

static _jc_type *const _jc_polyglot_types_LoadedClassResolver$param_types$find$6acc62ea1c707b3c[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_polyglot_types_LoadedClassResolver$method_info$find$6acc62ea1c707b3c = {
	.name=			"find",
	.signature=		"(Ljava/lang/String;)Lpolyglot/types/Named;",
	.class=			&_jc_polyglot_types_LoadedClassResolver$type,
	.param_types=		&_jc_polyglot_types_LoadedClassResolver$param_types$find$6acc62ea1c707b3c,
	.return_type=		&_jc_polyglot_types_Named$type,
	.param_ptypes=		&_jc_polyglot_types_LoadedClassResolver$param_ptypes$find$6acc62ea1c707b3c,
	.signature_hash=	_JC_JLONG(0x6acc62ea1c707b3c),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_types_LoadedClassResolver$method$find$6acc62ea1c707b3c,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_types_LoadedClassResolver$vtable, polyglot_types_LoadedClassResolver.find$6acc62ea1c707b3c) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_types_LoadedClassResolver$exceptions$find$6acc62ea1c707b3c,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	14,
	      .table=	_jc_polyglot_types_LoadedClassResolver$linenum_table$find$6acc62ea1c707b3c
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_types_LoadedClassResolver, find$6acc62ea1c707b3c);

_jc_object * _JC_JCNI_ATTR
_jc_polyglot_types_LoadedClassResolver$method$find$6acc62ea1c707b3c(_jc_env *const env, _jc_polyglot_types_LoadedClassResolver$object *this, _jc_java_lang_String$object *param0)
{
	jint i0;
	struct _jc_polyglot_types_LoadedClassResolver$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_object *r10;
	struct _jc_polyglot_types_SemanticException$object *r11;
	struct _jc_java_lang_String$object *r12;
	struct _jc_java_lang_String$object *r13;
	struct _jc_java_lang_String$object *r14;
	struct _jc_java_lang_String$object *r15;
	_jc_char_array *r16;
	_jc_char_array *r17;
	_jc_char_array *r18;
	_jc_char_array *r19;
	struct _jc_object *r2;
	struct _jc_java_lang_VMThrowable$object *r20;
	struct _jc_java_lang_String$object *r21;
	struct _jc_java_io_PrintStream$object *r22;
	struct _jc_java_lang_String$object *r23;
	struct _jc_java_util_Collections__24SingletonList$object *r24;
	struct _jc_java_io_PrintStream$object *r25;
	struct _jc_java_lang_StringBuffer$object *r26;
	struct _jc_java_lang_String$object *r27;
	_jc_char_array *r28;
	struct _jc_java_lang_VMThrowable$object *r29;
	struct _jc_polyglot_types_reflect_ClassFile$object *r3;
	struct _jc_java_lang_String$object *r30;
	struct _jc_java_io_PrintStream$object *r31;
	struct _jc_java_lang_String$object *r32;
	struct _jc_java_util_Collections__24SingletonList$object *r33;
	struct _jc_java_lang_StringBuffer$object *r4;
	struct _jc_java_lang_String$object *r5;
	struct _jc_polyglot_types_NoClassException$object *r6;
	struct _jc_polyglot_main_Version$object *r7;
	struct _jc_object *r8;
	struct _jc_object *r9;
	jboolean z0;
	jboolean z1;
	jboolean z2;
	jboolean z3;
	jboolean z4;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(95);				// 0
	r2 = _JC_STATIC_FIELD(env, polyglot_types_LoadedClassResolver, report__5ftopics, 1);
	z0 = _JC_INVOKE_STATIC(env, polyglot_main_Report, should__5freport$316269f2ec4db001, 0, r2, 3);
	if (z0 == 0)
		goto label2;
	_JC_LINE_NUMBER(96);				// 1
	r4 = _JC_NEW(env, java_lang_StringBuffer);
	r16 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r4, java_lang_StringBuffer, value) = r16;
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, _JC_STRING(env, "LoadedCR.find("));
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, r1);
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, _JC_STRING(env, ")"));
	r12 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r12, r4);
	i0 = 1;

label0:
	if (i0 >= 3)
		goto label1;
	r25 = _JC_STATIC_FIELD(env, java_lang_System, err, 0);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, print$21bdbb15afdbea95, r25, _JC_STRING(env, "  "));
	i0 = i0 + 1;
	_JC_PERIODIC_CHECK(env);
	goto label0;

label1:
	r25 = _JC_STATIC_FIELD(env, java_lang_System, err, 0);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, println$f7dbc2aa0f0a9d4f, r25, r12);

label2:
	_JC_LINE_NUMBER(99);				// 2
	r3 = _JC_INVOKE_VIRTUAL(env, polyglot_types_LoadedClassResolver, loadFile$6eba5e5275043e6e, r0, r1);
	_JC_LINE_NUMBER(100);				// 3
	if (r3 != _JC_NULL)
		goto label6;
	_JC_LINE_NUMBER(101);				// 4
	r6 = _JC_NEW(env, polyglot_types_NoClassException);
	r26 = _JC_NEW(env, java_lang_StringBuffer);
	r28 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r26, java_lang_StringBuffer, value) = r28;
	r26 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r26, _JC_STRING(env, "Class \""));
	r26 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r26, r1);
	r26 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r26, _JC_STRING(env, "\" not found."));
	r27 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r27, r26);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, cause) = r6;
	r29 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r6);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, vmState) = r29;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, detailMessage) = r27;
	r30 = _JC_STATIC_FIELD(env, polyglot_main_Report, errors, 0);
	z4 = _JC_STATIC_FIELD(env, polyglot_main_Report, noReporting, 1);
	if (z4 == 0)
		goto label3;
	z3 = 0;
	goto label4;

label3:
	_JC_ACTIVE_USE(env, java_util_Collections);
	r33 = _JC_NEW(env, java_util_Collections__24SingletonList);
	_JC_REF_FIELD(env, r33, java_util_Collections__24SingletonList, element) = r30;
	z4 = _JC_INVOKE_STATIC(env, polyglot_main_Report, should__5freport$316269f2ec4db001, 1, r33, 5);
	z3 = z4;

label4:
	if (z3 == 0)
		goto label5;
	r31 = _JC_STATIC_FIELD(env, java_lang_System, err, 0);
	r32 = _JC_INVOKE_NONVIRTUAL(env, java_lang_Throwable, stackTraceString$42eec01c019ee6b0, 0, r6);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, print$21bdbb15afdbea95, r31, r32);

label5:
	_JC_REF_FIELD(env, r6, polyglot_types_NoClassException, className) = r1;
	_JC_THROW(env, r6);

label6:
	_JC_LINE_NUMBER(105);				// 5
	r7 = _JC_REF_FIELD(env, r0, polyglot_types_LoadedClassResolver, version);
	r5 = _JC_INVOKE_VIRTUAL(env, polyglot_main_Version, name$e6acce026cadf81e, r7);
	r5 = _JC_INVOKE_VIRTUAL(env, polyglot_types_reflect_ClassFile, encodedClassType$6ed3e41f9601f1b9, r3, r5);
	if (r5 == _JC_NULL)
		goto label8;
	_JC_LINE_NUMBER(106);				// 6
	r2 = _JC_STATIC_FIELD(env, polyglot_types_LoadedClassResolver, report__5ftopics, 1);
	z0 = _JC_INVOKE_STATIC(env, polyglot_main_Report, should__5freport$316269f2ec4db001, 0, r2, 4);
	if (z0 == 0)
		goto label7;
	_JC_LINE_NUMBER(107);				// 7
	r4 = _JC_NEW(env, java_lang_StringBuffer);
	r17 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r4, java_lang_StringBuffer, value) = r17;
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, _JC_STRING(env, "Using encoded class type for "));
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, r1);
	r13 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r13, r4);
	_JC_INVOKE_STATIC(env, polyglot_main_Report, report$0373120f850dba20, 1, 4, r13);

label7:
	_JC_LINE_NUMBER(108);				// 8
	r8 = _JC_INVOKE_VIRTUAL(env, polyglot_types_LoadedClassResolver, getEncodedType$2d027e16f96acd78, r0, r3, r1);
	return r8;

label8:
	_JC_LINE_NUMBER(111);				// 9
	z0 = _JC_PRIM_FIELD(env, r0, polyglot_types_LoadedClassResolver, allowRawClasses);
	if (z0 == 0)
		goto label10;
	_JC_LINE_NUMBER(112);				// 10
	r2 = _JC_STATIC_FIELD(env, polyglot_types_LoadedClassResolver, report__5ftopics, 1);
	z0 = _JC_INVOKE_STATIC(env, polyglot_main_Report, should__5freport$316269f2ec4db001, 0, r2, 4);
	if (z0 == 0)
		goto label9;
	_JC_LINE_NUMBER(113);				// 11
	r4 = _JC_NEW(env, java_lang_StringBuffer);
	r18 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r4, java_lang_StringBuffer, value) = r18;
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, _JC_STRING(env, "Using raw class file for "));
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, r1);
	r14 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r14, r4);
	_JC_INVOKE_STATIC(env, polyglot_main_Report, report$0373120f850dba20, 1, 4, r14);

label9:
	_JC_LINE_NUMBER(114);				// 12
	r9 = _JC_REF_FIELD(env, r0, polyglot_types_LoadedClassResolver, ts);
	r10 = _JC_INVOKE_VIRTUAL(env, polyglot_types_reflect_ClassFile, type$9391e49113389823, r3, r9);
	return r10;

label10:
	_JC_LINE_NUMBER(119);				// 13
	r11 = _JC_NEW(env, polyglot_types_SemanticException);
	r4 = _JC_NEW(env, java_lang_StringBuffer);
	r19 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r4, java_lang_StringBuffer, value) = r19;
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, _JC_STRING(env, "Unable to find a suitable definition of \""));
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, r1);
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, _JC_STRING(env, "\". A class file was found,"));
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, _JC_STRING(env, " but it did not contain appropriate information for this"));
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, _JC_STRING(env, " language extension. If the source for this file is written"));
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, _JC_STRING(env, " in the language extension, try recompiling the source code."));
	r15 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r15, r4);
	_JC_REF_FIELD(env, r11, java_lang_Throwable, cause) = r11;
	r20 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r11);
	_JC_REF_FIELD(env, r11, java_lang_Throwable, vmState) = r20;
	_JC_REF_FIELD(env, r11, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r11, java_lang_Throwable, detailMessage) = r15;
	r21 = _JC_STATIC_FIELD(env, polyglot_main_Report, errors, 0);
	z2 = _JC_STATIC_FIELD(env, polyglot_main_Report, noReporting, 1);
	if (z2 == 0)
		goto label11;
	z1 = 0;
	goto label12;

label11:
	_JC_ACTIVE_USE(env, java_util_Collections);
	r24 = _JC_NEW(env, java_util_Collections__24SingletonList);
	_JC_REF_FIELD(env, r24, java_util_Collections__24SingletonList, element) = r21;
	z2 = _JC_INVOKE_STATIC(env, polyglot_main_Report, should__5freport$316269f2ec4db001, 1, r24, 5);
	z1 = z2;

label12:
	if (z1 == 0)
		goto label13;
	r22 = _JC_STATIC_FIELD(env, java_lang_System, err, 0);
	r23 = _JC_INVOKE_NONVIRTUAL(env, java_lang_Throwable, stackTraceString$42eec01c019ee6b0, 0, r11);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, print$21bdbb15afdbea95, r22, r23);

label13:
	_JC_THROW(env, r11);
}

//
// protected polyglot.types.ClassType getEncodedType(polyglot.types.reflect.ClassFile, java.lang.String) throws polyglot.types.SemanticException
//

static _jc_linenum _jc_polyglot_types_LoadedClassResolver$linenum_table$getEncodedType$2d027e16f96acd78[];

static _jc_trap_info _jc_polyglot_types_LoadedClassResolver$trap_table$getEncodedType$2d027e16f96acd78[] = {
	_JC_TRAP(&_jc_java_io_InvalidClassException$type, 1, 2),
};

static const unsigned char _jc_polyglot_types_LoadedClassResolver$param_ptypes$getEncodedType$2d027e16f96acd78[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_LoadedClassResolver$exceptions$getEncodedType$2d027e16f96acd78[] = {
	&_jc_polyglot_types_SemanticException$type
};

static _jc_type *const _jc_polyglot_types_LoadedClassResolver$param_types$getEncodedType$2d027e16f96acd78[] = {
	&_jc_polyglot_types_reflect_ClassFile$type,
	&_jc_java_lang_String$type
};

_jc_method _jc_polyglot_types_LoadedClassResolver$method_info$getEncodedType$2d027e16f96acd78 = {
	.name=			"getEncodedType",
	.signature=		"(Lpolyglot/types/reflect/ClassFile;Ljava/lang/String;)Lpolyglot/types/ClassType;",
	.class=			&_jc_polyglot_types_LoadedClassResolver$type,
	.param_types=		&_jc_polyglot_types_LoadedClassResolver$param_types$getEncodedType$2d027e16f96acd78,
	.return_type=		&_jc_polyglot_types_ClassType$type,
	.param_ptypes=		&_jc_polyglot_types_LoadedClassResolver$param_ptypes$getEncodedType$2d027e16f96acd78,
	.signature_hash=	_JC_JLONG(0x2d027e16f96acd78),
	.access_flags=		_JC_ACC_PROTECTED,
	.function=		&_jc_polyglot_types_LoadedClassResolver$method$getEncodedType$2d027e16f96acd78,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_types_LoadedClassResolver$vtable, polyglot_types_LoadedClassResolver.getEncodedType$2d027e16f96acd78) / sizeof(void *),
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_types_LoadedClassResolver$exceptions$getEncodedType$2d027e16f96acd78,
	.u= { .exec= {
	  .trap_table_len=	1,
	  .trap_table=		_jc_polyglot_types_LoadedClassResolver$trap_table$getEncodedType$2d027e16f96acd78,
	  .u= {
	    .linenum= {
	      .len=	10,
	      .table=	_jc_polyglot_types_LoadedClassResolver$linenum_table$getEncodedType$2d027e16f96acd78
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_types_LoadedClassResolver, getEncodedType$2d027e16f96acd78);

_jc_object * _JC_JCNI_ATTR
_jc_polyglot_types_LoadedClassResolver$method$getEncodedType$2d027e16f96acd78(_jc_env *const env, _jc_polyglot_types_LoadedClassResolver$object *this, _jc_polyglot_types_reflect_ClassFile$object *param0, _jc_java_lang_String$object *param1)
{
	jint i0;
	jint i2;
	struct _jc_polyglot_types_LoadedClassResolver$object *r0;
	struct _jc_polyglot_types_reflect_ClassFile$object *volatile r1;
	struct _jc_object *r10;
	struct _jc_polyglot_types_BadSerializationException$object *volatile r11;
	struct _jc_object *r12;
	struct _jc_object *r13;
	struct _jc_polyglot_types_CachingResolver$object *r14;
	struct _jc_object *r15;
	struct _jc_java_lang_String$object *r16;
	struct _jc_java_lang_String$object *r17;
	_jc_char_array *r18;
	struct _jc_java_lang_String$object *volatile r19;
	struct _jc_java_lang_String$object *r2;
	_jc_char_array *r20;
	struct _jc_java_lang_VMThrowable$object *r21;
	struct _jc_java_lang_String$object *r22;
	struct _jc_java_io_PrintStream$object *r23;
	struct _jc_java_lang_String$object *r24;
	struct _jc_java_lang_VMThrowable$object *volatile r25;
	struct _jc_java_lang_String$object *volatile r26;
	struct _jc_java_io_PrintStream$object *volatile r27;
	struct _jc_java_lang_String$object *volatile r28;
	struct _jc_java_util_Collections__24SingletonList$object *r29;
	struct _jc_object *r3;
	struct _jc_java_util_Collections__24SingletonList$object *volatile r30;
	struct _jc_java_io_PrintStream$object *r32;
	struct _jc_java_io_InvalidClassException$object *r4;
	struct _jc_polyglot_main_Version$object *r5;
	struct _jc_java_lang_String$object *volatile r6;
	struct _jc_polyglot_types_SemanticException$object *r7;
	struct _jc_java_lang_StringBuffer$object *r8;
	struct _jc_polyglot_util_TypeEncoder$object *r9;
	jboolean z0;
	jboolean z1;
	jboolean volatile z2;
	jboolean z3;
	jboolean volatile z4;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_polyglot_types_LoadedClassResolver$method_info$getEncodedType$2d027e16f96acd78, &&label4);

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_LINE_NUMBER(140);				// 0
	r5 = _JC_REF_FIELD(env, r0, polyglot_types_LoadedClassResolver, version);
	r6 = _JC_INVOKE_VIRTUAL(env, polyglot_main_Version, name$e6acce026cadf81e, r5);
	r6 = _JC_INVOKE_VIRTUAL(env, polyglot_types_reflect_ClassFile, compilerVersion$7f0cc0202ac6be09, r1, r6);
	i0 = _JC_INVOKE_VIRTUAL(env, polyglot_types_LoadedClassResolver, checkCompilerVersion$06ae3cf9489417d8, r0, r6);
	_JC_LINE_NUMBER(142);				// 1
	if (i0 != -1)
		goto label3;
	_JC_LINE_NUMBER(143);				// 2
	r7 = _JC_NEW(env, polyglot_types_SemanticException);
	r8 = _JC_NEW(env, java_lang_StringBuffer);
	r18 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r8, java_lang_StringBuffer, value) = r18;
	r8 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r8, _JC_STRING(env, "Unable to find a suitable definition of "));
	r6 = _JC_INVOKE_VIRTUAL(env, polyglot_types_reflect_ClassFile, name$e6acce026cadf81e, r1);
	r8 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r8, r6);
	r8 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r8, _JC_STRING(env, ". Try recompiling or obtaining "));
	r8 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r8, _JC_STRING(env, " a newer version of the class file."));
	r16 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r16, r8);
	_JC_REF_FIELD(env, r7, java_lang_Throwable, cause) = r7;
	r21 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r7);
	_JC_REF_FIELD(env, r7, java_lang_Throwable, vmState) = r21;
	_JC_REF_FIELD(env, r7, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r7, java_lang_Throwable, detailMessage) = r16;
	r22 = _JC_STATIC_FIELD(env, polyglot_main_Report, errors, 0);
	z3 = _JC_STATIC_FIELD(env, polyglot_main_Report, noReporting, 1);
	if (z3 == 0)
		goto label0;
	z1 = 0;
	goto label1;

label0:
	_JC_ACTIVE_USE(env, java_util_Collections);
	r29 = _JC_NEW(env, java_util_Collections__24SingletonList);
	_JC_REF_FIELD(env, r29, java_util_Collections__24SingletonList, element) = r22;
	z3 = _JC_INVOKE_STATIC(env, polyglot_main_Report, should__5freport$316269f2ec4db001, 1, r29, 5);
	z1 = z3;

label1:
	if (z1 == 0)
		goto label2;
	r23 = _JC_STATIC_FIELD(env, java_lang_System, err, 0);
	r24 = _JC_INVOKE_NONVIRTUAL(env, java_lang_Throwable, stackTraceString$42eec01c019ee6b0, 0, r7);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, print$21bdbb15afdbea95, r23, r24);

label2:
	_JC_THROW(env, r7);

label3:
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(153);				// 3
	r9 = _JC_REF_FIELD(env, r0, polyglot_types_LoadedClassResolver, te);
	r5 = _JC_REF_FIELD(env, r0, polyglot_types_LoadedClassResolver, version);
	r6 = _JC_INVOKE_VIRTUAL(env, polyglot_main_Version, name$e6acce026cadf81e, r5);
	r6 = _JC_INVOKE_VIRTUAL(env, polyglot_types_reflect_ClassFile, encodedClassType$6ed3e41f9601f1b9, r1, r6);
	r10 = _JC_INVOKE_VIRTUAL(env, polyglot_util_TypeEncoder, decode$8383d57b54a9bd76, r9, r6);
	r3 = _JC_CAST(env, &_jc_polyglot_types_ClassType$type, r10);
	_JC_TRAP_REGION(catch, 2);
	_JC_LINE_NUMBER(157);				// 4
	goto label8;

label4:
	_JC_TRAP_REGION(catch, 2);
	r4 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(156);				// 5
	r11 = _JC_NEW(env, polyglot_types_BadSerializationException);
	r6 = _JC_INVOKE_VIRTUAL(env, polyglot_types_reflect_ClassFile, name$e6acce026cadf81e, r1);
	r19 = _JC_INVOKE_STATIC(env, polyglot_types_BadSerializationException, message$1726e2bf56cae1f3, 1, r6);
	_JC_REF_FIELD(env, r11, java_lang_Throwable, cause) = r11;
	r25 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r11);
	_JC_REF_FIELD(env, r11, java_lang_Throwable, vmState) = r25;
	_JC_REF_FIELD(env, r11, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r11, java_lang_Throwable, detailMessage) = r19;
	r26 = _JC_STATIC_FIELD(env, polyglot_main_Report, errors, 0);
	z4 = _JC_STATIC_FIELD(env, polyglot_main_Report, noReporting, 1);
	if (z4 == 0)
		goto label5;
	z2 = 0;
	goto label6;

label5:
	_JC_ACTIVE_USE(env, java_util_Collections);
	r30 = _JC_NEW(env, java_util_Collections__24SingletonList);
	_JC_REF_FIELD(env, r30, java_util_Collections__24SingletonList, element) = r26;
	z4 = _JC_INVOKE_STATIC(env, polyglot_main_Report, should__5freport$316269f2ec4db001, 1, r30, 5);
	z2 = z4;

label6:
	if (z2 == 0)
		goto label7;
	r27 = _JC_STATIC_FIELD(env, java_lang_System, err, 0);
	r28 = _JC_INVOKE_NONVIRTUAL(env, java_lang_Throwable, stackTraceString$42eec01c019ee6b0, 0, r11);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, print$21bdbb15afdbea95, r27, r28);

label7:
	_JC_REF_FIELD(env, r11, polyglot_types_BadSerializationException, className) = r6;
	_JC_THROW(env, r11);

label8:
	_JC_LINE_NUMBER(160);				// 6
	r12 = _JC_REF_FIELD(env, r0, polyglot_types_LoadedClassResolver, ts);
	r13 = _JC_INVOKE_INTERFACE(env, r12, _JC_JLONG(0x586051238e5b2287), _jc_object *, (_jc_env *, struct _jc_object *));
	r14 = _JC_CAST(env, &_jc_polyglot_types_CachingResolver$type, r13);
	_JC_INVOKE_VIRTUAL(env, polyglot_types_CachingResolver, install$ccfcff1505013619, r14, r2, r3);
	_JC_LINE_NUMBER(162);				// 7
	r15 = _JC_STATIC_FIELD(env, polyglot_types_LoadedClassResolver, report__5ftopics, 1);
	z0 = _JC_INVOKE_STATIC(env, polyglot_main_Report, should__5freport$316269f2ec4db001, 0, r15, 2);
	if (z0 == 0)
		goto label11;
	_JC_LINE_NUMBER(163);				// 8
	r8 = _JC_NEW(env, java_lang_StringBuffer);
	r20 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r8, java_lang_StringBuffer, value) = r20;
	r8 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r8, _JC_STRING(env, "Returning serialized ClassType for "));
	r6 = _JC_INVOKE_VIRTUAL(env, polyglot_types_reflect_ClassFile, name$e6acce026cadf81e, r1);
	r8 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r8, r6);
	r8 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r8, _JC_STRING(env, "."));
	r17 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r17, r8);
	i2 = 1;

label9:
	if (i2 >= 2)
		goto label10;
	r32 = _JC_STATIC_FIELD(env, java_lang_System, err, 0);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, print$21bdbb15afdbea95, r32, _JC_STRING(env, "  "));
	i2 = i2 + 1;
	_JC_PERIODIC_CHECK(env);
	goto label9;

label10:
	r32 = _JC_STATIC_FIELD(env, java_lang_System, err, 0);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, println$f7dbc2aa0f0a9d4f, r32, r17);

label11:
	_JC_LINE_NUMBER(166);				// 9
	_JC_CANCEL_TRAPS(env, catch);
	return r3;
}

//
// protected polyglot.types.reflect.ClassFile loadFile(java.lang.String)
//

static _jc_linenum _jc_polyglot_types_LoadedClassResolver$linenum_table$loadFile$6eba5e5275043e6e[];

static _jc_trap_info _jc_polyglot_types_LoadedClassResolver$trap_table$loadFile$6eba5e5275043e6e[] = {
	_JC_TRAP(&_jc_java_lang_ClassFormatError$type, 1, 2),
};

static const unsigned char _jc_polyglot_types_LoadedClassResolver$param_ptypes$loadFile$6eba5e5275043e6e[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_LoadedClassResolver$param_types$loadFile$6eba5e5275043e6e[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_polyglot_types_LoadedClassResolver$method_info$loadFile$6eba5e5275043e6e = {
	.name=			"loadFile",
	.signature=		"(Ljava/lang/String;)Lpolyglot/types/reflect/ClassFile;",
	.class=			&_jc_polyglot_types_LoadedClassResolver$type,
	.param_types=		&_jc_polyglot_types_LoadedClassResolver$param_types$loadFile$6eba5e5275043e6e,
	.return_type=		&_jc_polyglot_types_reflect_ClassFile$type,
	.param_ptypes=		&_jc_polyglot_types_LoadedClassResolver$param_ptypes$loadFile$6eba5e5275043e6e,
	.signature_hash=	_JC_JLONG(0x6eba5e5275043e6e),
	.access_flags=		_JC_ACC_PROTECTED,
	.function=		&_jc_polyglot_types_LoadedClassResolver$method$loadFile$6eba5e5275043e6e,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_types_LoadedClassResolver$vtable, polyglot_types_LoadedClassResolver.loadFile$6eba5e5275043e6e) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .trap_table_len=	1,
	  .trap_table=		_jc_polyglot_types_LoadedClassResolver$trap_table$loadFile$6eba5e5275043e6e,
	  .u= {
	    .linenum= {
	      .len=	14,
	      .table=	_jc_polyglot_types_LoadedClassResolver$linenum_table$loadFile$6eba5e5275043e6e
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_types_LoadedClassResolver, loadFile$6eba5e5275043e6e);

_jc_polyglot_types_reflect_ClassFile$object * _JC_JCNI_ATTR
_jc_polyglot_types_LoadedClassResolver$method$loadFile$6eba5e5275043e6e(_jc_env *const env, _jc_polyglot_types_LoadedClassResolver$object *this, _jc_java_lang_String$object *param0)
{
	jint i0;
	jint i1;
	jint volatile i3;
	struct _jc_polyglot_types_LoadedClassResolver$object *volatile r0;
	struct _jc_java_lang_String$object *volatile r1;
	struct _jc_java_lang_String$object *r10;
	struct _jc_java_lang_String$object *volatile r11;
	_jc_char_array *r12;
	_jc_char_array *r13;
	_jc_char_array *volatile r14;
	struct _jc_java_io_PrintStream$object *r15;
	struct _jc_java_io_PrintStream$object *r16;
	struct _jc_java_io_PrintStream$object *volatile r18;
	struct _jc_polyglot_types_reflect_ClassFile$object *r2;
	struct _jc_object *volatile r3;
	struct _jc_polyglot_types_reflect_ClassPathLoader$object *r4;
	struct _jc_object *volatile r5;
	struct _jc_java_lang_StringBuffer$object *volatile r6;
	struct _jc_java_lang_String$object *r7;
	struct _jc_java_lang_ClassFormatError$object *r8;
	struct _jc_java_lang_String$object *r9;
	jboolean volatile z0;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_polyglot_types_LoadedClassResolver$method_info$loadFile$6eba5e5275043e6e, &&label7);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(60);				// 0
	r3 = _JC_REF_FIELD(env, r0, polyglot_types_LoadedClassResolver, nocache);
	z0 = _JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0xd3bd70da40f05cb1), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r1);
	if (z0 == 0)
		goto label0;
	_JC_LINE_NUMBER(61);				// 1
	_JC_CANCEL_TRAPS(env, catch);
	return _JC_NULL;

label0:
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(65);				// 2
	r4 = _JC_REF_FIELD(env, r0, polyglot_types_LoadedClassResolver, loader);
	r2 = _JC_INVOKE_VIRTUAL(env, polyglot_types_reflect_ClassPathLoader, loadClass$88d5dad5c2f76cdd, r4, r1);
	_JC_LINE_NUMBER(67);				// 3
	if (r2 != _JC_NULL)
		goto label3;
	_JC_LINE_NUMBER(68);				// 4
	r5 = _JC_STATIC_FIELD(env, polyglot_types_LoadedClassResolver, report__5ftopics, 1);
	z0 = _JC_INVOKE_STATIC(env, polyglot_main_Report, should__5freport$316269f2ec4db001, 0, r5, 4);
	if (z0 == 0)
		goto label10;
	_JC_LINE_NUMBER(69);				// 5
	r6 = _JC_NEW(env, java_lang_StringBuffer);
	r12 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r6, java_lang_StringBuffer, value) = r12;
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r6, _JC_STRING(env, "Class "));
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r6, r1);
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r6, _JC_STRING(env, " not found in classpath "));
	r4 = _JC_REF_FIELD(env, r0, polyglot_types_LoadedClassResolver, loader);
	r7 = _JC_INVOKE_VIRTUAL(env, polyglot_types_reflect_ClassPathLoader, classpath$41a069155e50d6ff, r4);
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r6, r7);
	r9 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r9, r6);
	i0 = 1;

label1:
	if (i0 >= 4)
		goto label2;
	r15 = _JC_STATIC_FIELD(env, java_lang_System, err, 0);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, print$21bdbb15afdbea95, r15, _JC_STRING(env, "  "));
	i0 = i0 + 1;
	_JC_PERIODIC_CHECK(env);
	goto label1;

label2:
	r15 = _JC_STATIC_FIELD(env, java_lang_System, err, 0);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, println$f7dbc2aa0f0a9d4f, r15, r9);
	goto label10;

label3:
	_JC_LINE_NUMBER(74);				// 6
	r5 = _JC_STATIC_FIELD(env, polyglot_types_LoadedClassResolver, report__5ftopics, 1);
	z0 = _JC_INVOKE_STATIC(env, polyglot_main_Report, should__5freport$316269f2ec4db001, 0, r5, 4);
	if (z0 == 0)
		goto label6;
	_JC_LINE_NUMBER(75);				// 7
	r6 = _JC_NEW(env, java_lang_StringBuffer);
	r13 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r6, java_lang_StringBuffer, value) = r13;
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r6, _JC_STRING(env, "Class "));
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r6, r1);
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r6, _JC_STRING(env, " found in classpath "));
	r4 = _JC_REF_FIELD(env, r0, polyglot_types_LoadedClassResolver, loader);
	r7 = _JC_INVOKE_VIRTUAL(env, polyglot_types_reflect_ClassPathLoader, classpath$41a069155e50d6ff, r4);
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r6, r7);
	r10 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r10, r6);
	i1 = 1;

label4:
	if (i1 >= 4)
		goto label5;
	r16 = _JC_STATIC_FIELD(env, java_lang_System, err, 0);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, print$21bdbb15afdbea95, r16, _JC_STRING(env, "  "));
	i1 = i1 + 1;
	_JC_PERIODIC_CHECK(env);
	goto label4;

label5:
	r16 = _JC_STATIC_FIELD(env, java_lang_System, err, 0);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, println$f7dbc2aa0f0a9d4f, r16, r10);

label6:
	_JC_TRAP_REGION(catch, 2);
	_JC_LINE_NUMBER(78);				// 8
	_JC_CANCEL_TRAPS(env, catch);
	return r2;

label7:
	_JC_TRAP_REGION(catch, 2);
	_JC_LINE_NUMBER(84);				// 9
	r8 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(82);				// 10
	r5 = _JC_STATIC_FIELD(env, polyglot_types_LoadedClassResolver, report__5ftopics, 0);
	z0 = _JC_INVOKE_STATIC(env, polyglot_main_Report, should__5freport$316269f2ec4db001, 0, r5, 4);
	if (z0 == 0)
		goto label10;
	_JC_LINE_NUMBER(83);				// 11
	r6 = _JC_NEW(env, java_lang_StringBuffer);
	r14 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r6, java_lang_StringBuffer, value) = r14;
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r6, _JC_STRING(env, "Class "));
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r6, r1);
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r6, _JC_STRING(env, " format error"));
	r11 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r11, r6);
	i3 = 1;

label8:
	if (i3 >= 4)
		goto label9;
	r18 = _JC_STATIC_FIELD(env, java_lang_System, err, 0);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, print$21bdbb15afdbea95, r18, _JC_STRING(env, "  "));
	i3 = i3 + 1;
	_JC_PERIODIC_CHECK(env);
	goto label8;

label9:
	r18 = _JC_STATIC_FIELD(env, java_lang_System, err, 0);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, println$f7dbc2aa0f0a9d4f, r18, r11);

label10:
	_JC_TRAP_REGION(catch, 2);
	_JC_LINE_NUMBER(86);				// 12
	r3 = _JC_REF_FIELD(env, r0, polyglot_types_LoadedClassResolver, nocache);
	_JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0x831f06ee5f59c0cc), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r1);
	_JC_LINE_NUMBER(88);				// 13
	_JC_CANCEL_TRAPS(env, catch);
	return _JC_NULL;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_polyglot_types_LoadedClassResolver$methods[] = {
	&_jc_polyglot_types_LoadedClassResolver$method_info$_clinit$a816641e0ba8bfef,
	&_jc_polyglot_types_LoadedClassResolver$method_info$_init$4496cf846523face,
	&_jc_polyglot_types_LoadedClassResolver$method_info$checkCompilerVersion$06ae3cf9489417d8,
	&_jc_polyglot_types_LoadedClassResolver$method_info$find$6acc62ea1c707b3c,
	&_jc_polyglot_types_LoadedClassResolver$method_info$getEncodedType$2d027e16f96acd78,
	&_jc_polyglot_types_LoadedClassResolver$method_info$loadFile$6eba5e5275043e6e
};

/************************************************************************
 *			  Class fields structure			*
 ************************************************************************/

_jc_polyglot_types_LoadedClassResolver$fields_struct _jc_polyglot_types_LoadedClassResolver$class_fields = { };

/************************************************************************
 *			   Interface hash table				*
 ************************************************************************/

#if _JC_IMETHOD_HASHSIZE != 128
#error "_JC_IMETHOD_HASHSIZE has the wrong value (should be 128)"
#endif

// Interface lookup hash table buckets
static _jc_method *_jc_polyglot_types_LoadedClassResolver$imethod_hash_bucket_60[] = {
	&_jc_polyglot_types_LoadedClassResolver$method_info$find$6acc62ea1c707b3c,
	_JC_NULL
};

// Interface lookup hash table
static _jc_method **_jc_polyglot_types_LoadedClassResolver$imethod_hash_table[_JC_IMETHOD_HASHSIZE] = {
	[60]=	_jc_polyglot_types_LoadedClassResolver$imethod_hash_bucket_60
};

// Interface "quick" lookup hash table
static const void *_jc_polyglot_types_LoadedClassResolver$imethod_quick_table[_JC_IMETHOD_HASHSIZE] = {
	[60]=	&_jc_polyglot_types_LoadedClassResolver$method$find$6acc62ea1c707b3c
};

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_polyglot_types_LoadedClassResolver$instanceof_hash_bucket_29[] = {
	&_jc_polyglot_types_ClassResolver$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_types_LoadedClassResolver$instanceof_hash_bucket_38[] = {
	&_jc_polyglot_types_LoadedClassResolver$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_types_LoadedClassResolver$instanceof_hash_bucket_43[] = {
	&_jc_polyglot_types_Resolver$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_types_LoadedClassResolver$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_polyglot_types_LoadedClassResolver$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[29]=	_jc_polyglot_types_LoadedClassResolver$instanceof_hash_bucket_29,
	[38]=	_jc_polyglot_types_LoadedClassResolver$instanceof_hash_bucket_38,
	[43]=	_jc_polyglot_types_LoadedClassResolver$instanceof_hash_bucket_43,
	[101]=	_jc_polyglot_types_LoadedClassResolver$instanceof_hash_bucket_101
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_polyglot_types_LoadedClassResolver$class_depends[] = {
	{ "java/io/InvalidClassException",	_JC_JLONG(0xeb60cf59bc393752) },
	{ "java/io/PrintStream",	_JC_JLONG(0x99a46305ebacacb5) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/ClassFormatError",	_JC_JLONG(0xc933004fd5a6148) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/Integer",	_JC_JLONG(0xca631501391a31f1) },
	{ "java/lang/NumberFormatException",	_JC_JLONG(0xa9fd317e4e09506e) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/StringBuffer",	_JC_JLONG(0x94d357637b968dda) },
	{ "java/lang/System",	_JC_JLONG(0x53cc8e2333795f04) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/util/AbstractCollection",	_JC_JLONG(0x8ea716c64b77f8eb) },
	{ "java/util/AbstractList",	_JC_JLONG(0xf5238436362828db) },
	{ "java/util/AbstractSet",	_JC_JLONG(0xca427569b5b2f804) },
	{ "java/util/ArrayList",	_JC_JLONG(0x58038509830ef3f4) },
	{ "java/util/Collection",	_JC_JLONG(0xeae4d0c0e8eb63da) },
	{ "java/util/Collections",	_JC_JLONG(0x9574af3fed58029a) },
	{ "java/util/Collections$SingletonList",	_JC_JLONG(0x2ccd076083da6c8e) },
	{ "java/util/HashMap",	_JC_JLONG(0xd7cd853200c3e71f) },
	{ "java/util/HashSet",	_JC_JLONG(0x3c285c721478414d) },
	{ "java/util/Set",	_JC_JLONG(0x617ac82c0bec2dff) },
	{ "java/util/StringTokenizer",	_JC_JLONG(0xb106445ca218ee16) },
	{ "polyglot/main/Report",	_JC_JLONG(0xcf9f146bdb7bc44d) },
	{ "polyglot/main/Version",	_JC_JLONG(0x4ba1325a7aefecac) },
	{ "polyglot/types/BadSerializationException",	_JC_JLONG(0x5bedf50c16a6702d) },
	{ "polyglot/types/CachingResolver",	_JC_JLONG(0xc530a50397510e6f) },
	{ "polyglot/types/ClassResolver",	_JC_JLONG(0xeec1a4cebd785b9d) },
	{ "polyglot/types/ClassType",	_JC_JLONG(0xb38560af658974f8) },
	{ "polyglot/types/Named",	_JC_JLONG(0xe5f53252d3bf5dfd) },
	{ "polyglot/types/NoClassException",	_JC_JLONG(0x7e014a610596faf9) },
	{ "polyglot/types/ParsedClassType",	_JC_JLONG(0x6bcfbf52304f9e7c) },
	{ "polyglot/types/Resolver",	_JC_JLONG(0x3a3788b16a28392b) },
	{ "polyglot/types/SemanticException",	_JC_JLONG(0x45f755f5298b5b39) },
	{ "polyglot/types/Type",	_JC_JLONG(0x6596051546781098) },
	{ "polyglot/types/TypeSystem",	_JC_JLONG(0xed171cdaca38ec28) },
	{ "polyglot/types/reflect/ClassFile",	_JC_JLONG(0xf394a649a5830bb) },
	{ "polyglot/types/reflect/ClassFileLoader",	_JC_JLONG(0x50cc35358493eab1) },
	{ "polyglot/types/reflect/ClassPathLoader",	_JC_JLONG(0x32257e81ded29ed1) },
	{ "polyglot/util/CollectionUtil",	_JC_JLONG(0x32f10c9680c602c0) },
	{ "polyglot/util/TypeEncoder",	_JC_JLONG(0xf299688fad53c0b2) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_polyglot_types_LoadedClassResolver$vtype _jc_polyglot_types_LoadedClassResolver$type = {
    .type= {
	.name=			"polyglot/types/LoadedClassResolver",
	.superclass=		&_jc_polyglot_types_ClassResolver$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_polyglot_types_LoadedClassResolver$imethod_hash_table,
	.imethod_quick_table=	_jc_polyglot_types_LoadedClassResolver$imethod_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		16,
		.hash=			_JC_JLONG(0x775d491e1eb77426),
		.source_file=		"LoadedClassResolver.java",
		.instance_size=		sizeof(_jc_polyglot_types_LoadedClassResolver$refs) + sizeof(_jc_polyglot_types_LoadedClassResolver$object),
		.num_virtual_refs=	5,
		.num_fields=		sizeof(_jc_polyglot_types_LoadedClassResolver$fields) / sizeof(*_jc_polyglot_types_LoadedClassResolver$fields),
		.fields=		_jc_polyglot_types_LoadedClassResolver$fields,
		.num_methods=		sizeof(_jc_polyglot_types_LoadedClassResolver$methods) / sizeof(*_jc_polyglot_types_LoadedClassResolver$methods),
		.methods=		_jc_polyglot_types_LoadedClassResolver$methods,
		.instanceof_hash_table=	_jc_polyglot_types_LoadedClassResolver$instanceof_hash_table,
		.class_fields=		&_jc_polyglot_types_LoadedClassResolver$class_fields,
		.num_class_depends=		sizeof(_jc_polyglot_types_LoadedClassResolver$class_depends) / sizeof(*_jc_polyglot_types_LoadedClassResolver$class_depends),
		.class_depends=		_jc_polyglot_types_LoadedClassResolver$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.polyglot_types_ClassResolver= {
	    .find$6acc62ea1c707b3c=				// overridden
		&_jc_polyglot_types_LoadedClassResolver$method$find$6acc62ea1c707b3c,
	},
	.polyglot_types_LoadedClassResolver= {
	    .checkCompilerVersion$06ae3cf9489417d8=
		&_jc_polyglot_types_LoadedClassResolver$method$checkCompilerVersion$06ae3cf9489417d8,
	    .find$6acc62ea1c707b3c=
		&_jc_polyglot_types_LoadedClassResolver$method$find$6acc62ea1c707b3c,
	    .getEncodedType$2d027e16f96acd78=
		&_jc_polyglot_types_LoadedClassResolver$method$getEncodedType$2d027e16f96acd78,
	    .loadFile$6eba5e5275043e6e=
		&_jc_polyglot_types_LoadedClassResolver$method$loadFile$6eba5e5275043e6e,
	},
    }
};

