// public abstract interface polyglot.types.MethodInstance

// class file dependencies
// @dep_class 9a35c7173b37e641 java_io_Serializable
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class 9b667b09132be893 java_lang_Cloneable
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 9ee0d92ce1525a4d java_util_List
// @dep_class 88f5c21159e638e6 polyglot_types_CodeInstance
// @dep_class 821eb65d8f2f30f6 polyglot_types_Flags
// @dep_class 7ea7408712d6d898 polyglot_types_MemberInstance
// @dep_class ab0fa5f3ef02c9ee polyglot_types_MethodInstance
// @dep_class bf36f48cfcf511f4 polyglot_types_ProcedureInstance
// @dep_class cfc647d76f91943a polyglot_types_ReferenceType
// @dep_class 45f755f5298b5b39 polyglot_types_SemanticException
// @dep_class 6596051546781098 polyglot_types_Type
// @dep_class b6db228dc0317211 polyglot_types_TypeObject
// @dep_class c1adfaf4637dbc02 polyglot_util_Copy

// header file dependencies
// @dep_header java_io_Serializable
// @dep_header java_lang_Class
// @dep_header java_lang_Cloneable
// @dep_header java_lang_String
// @dep_header java_util_List
// @dep_header polyglot_types_CodeInstance
// @dep_header polyglot_types_Flags
// @dep_header polyglot_types_MemberInstance
// @dep_header polyglot_types_MethodInstance
// @dep_header polyglot_types_ProcedureInstance
// @dep_header polyglot_types_ReferenceType
// @dep_header polyglot_types_SemanticException
// @dep_header polyglot_types_Type
// @dep_header polyglot_types_TypeObject
// @dep_header polyglot_util_Copy

#include "jc_defs.h"

#include "java/io/Serializable.h"
#include "java/lang/Class.h"
#include "java/lang/Cloneable.h"
#include "java/lang/String.h"
#include "java/util/List.h"
#include "polyglot/types/CodeInstance.h"
#include "polyglot/types/Flags.h"
#include "polyglot/types/MemberInstance.h"
#include "polyglot/types/MethodInstance.h"
#include "polyglot/types/ProcedureInstance.h"
#include "polyglot/types/ReferenceType.h"
#include "polyglot/types/SemanticException.h"
#include "polyglot/types/Type.h"
#include "polyglot/types/TypeObject.h"
#include "polyglot/util/Copy.h"

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public abstract boolean canOverride(polyglot.types.MethodInstance)
//

static const unsigned char _jc_polyglot_types_MethodInstance$param_ptypes$canOverride$bc4ab736b18ec84a[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_polyglot_types_MethodInstance$param_types$canOverride$bc4ab736b18ec84a[] = {
	&_jc_polyglot_types_MethodInstance$type
};

_jc_method _jc_polyglot_types_MethodInstance$method_info$canOverride$bc4ab736b18ec84a = {
	.name=			"canOverride",
	.signature=		"(Lpolyglot/types/MethodInstance;)Z",
	.class=			&_jc_polyglot_types_MethodInstance$type,
	.param_types=		&_jc_polyglot_types_MethodInstance$param_types$canOverride$bc4ab736b18ec84a,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_polyglot_types_MethodInstance$param_ptypes$canOverride$bc4ab736b18ec84a,
	.signature_hash=	_JC_JLONG(0xbc4ab736b18ec84a),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
};

//
// public abstract boolean canOverrideImpl(polyglot.types.MethodInstance, boolean) throws polyglot.types.SemanticException
//

static const unsigned char _jc_polyglot_types_MethodInstance$param_ptypes$canOverrideImpl$db6db2c13898460d[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_polyglot_types_MethodInstance$exceptions$canOverrideImpl$db6db2c13898460d[] = {
	&_jc_polyglot_types_SemanticException$type
};

static _jc_type *const _jc_polyglot_types_MethodInstance$param_types$canOverrideImpl$db6db2c13898460d[] = {
	&_jc_polyglot_types_MethodInstance$type,
	&_jc_boolean$prim$type
};

_jc_method _jc_polyglot_types_MethodInstance$method_info$canOverrideImpl$db6db2c13898460d = {
	.name=			"canOverrideImpl",
	.signature=		"(Lpolyglot/types/MethodInstance;Z)Z",
	.class=			&_jc_polyglot_types_MethodInstance$type,
	.param_types=		&_jc_polyglot_types_MethodInstance$param_types$canOverrideImpl$db6db2c13898460d,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_polyglot_types_MethodInstance$param_ptypes$canOverrideImpl$db6db2c13898460d,
	.signature_hash=	_JC_JLONG(0xdb6db2c13898460d),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_types_MethodInstance$exceptions$canOverrideImpl$db6db2c13898460d,
};

//
// public abstract void checkOverride(polyglot.types.MethodInstance) throws polyglot.types.SemanticException
//

static const unsigned char _jc_polyglot_types_MethodInstance$param_ptypes$checkOverride$ddad40bbe25e4afa[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_types_MethodInstance$exceptions$checkOverride$ddad40bbe25e4afa[] = {
	&_jc_polyglot_types_SemanticException$type
};

static _jc_type *const _jc_polyglot_types_MethodInstance$param_types$checkOverride$ddad40bbe25e4afa[] = {
	&_jc_polyglot_types_MethodInstance$type
};

_jc_method _jc_polyglot_types_MethodInstance$method_info$checkOverride$ddad40bbe25e4afa = {
	.name=			"checkOverride",
	.signature=		"(Lpolyglot/types/MethodInstance;)V",
	.class=			&_jc_polyglot_types_MethodInstance$type,
	.param_types=		&_jc_polyglot_types_MethodInstance$param_types$checkOverride$ddad40bbe25e4afa,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_types_MethodInstance$param_ptypes$checkOverride$ddad40bbe25e4afa,
	.signature_hash=	_JC_JLONG(0xddad40bbe25e4afa),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_types_MethodInstance$exceptions$checkOverride$ddad40bbe25e4afa,
};

//
// public abstract polyglot.types.MethodInstance container(polyglot.types.ReferenceType)
//

static const unsigned char _jc_polyglot_types_MethodInstance$param_ptypes$container$c1ea432234783ca7[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_MethodInstance$param_types$container$c1ea432234783ca7[] = {
	&_jc_polyglot_types_ReferenceType$type
};

_jc_method _jc_polyglot_types_MethodInstance$method_info$container$c1ea432234783ca7 = {
	.name=			"container",
	.signature=		"(Lpolyglot/types/ReferenceType;)Lpolyglot/types/MethodInstance;",
	.class=			&_jc_polyglot_types_MethodInstance$type,
	.param_types=		&_jc_polyglot_types_MethodInstance$param_types$container$c1ea432234783ca7,
	.return_type=		&_jc_polyglot_types_MethodInstance$type,
	.param_ptypes=		&_jc_polyglot_types_MethodInstance$param_ptypes$container$c1ea432234783ca7,
	.signature_hash=	_JC_JLONG(0xc1ea432234783ca7),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
};

//
// public abstract polyglot.types.MethodInstance flags(polyglot.types.Flags)
//

static const unsigned char _jc_polyglot_types_MethodInstance$param_ptypes$flags$e76556ea42558b32[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_MethodInstance$param_types$flags$e76556ea42558b32[] = {
	&_jc_polyglot_types_Flags$type
};

_jc_method _jc_polyglot_types_MethodInstance$method_info$flags$e76556ea42558b32 = {
	.name=			"flags",
	.signature=		"(Lpolyglot/types/Flags;)Lpolyglot/types/MethodInstance;",
	.class=			&_jc_polyglot_types_MethodInstance$type,
	.param_types=		&_jc_polyglot_types_MethodInstance$param_types$flags$e76556ea42558b32,
	.return_type=		&_jc_polyglot_types_MethodInstance$type,
	.param_ptypes=		&_jc_polyglot_types_MethodInstance$param_ptypes$flags$e76556ea42558b32,
	.signature_hash=	_JC_JLONG(0xe76556ea42558b32),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
};

//
// public abstract polyglot.types.MethodInstance formalTypes(java.util.List)
//

static const unsigned char _jc_polyglot_types_MethodInstance$param_ptypes$formalTypes$eca2533b771e927e[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_MethodInstance$param_types$formalTypes$eca2533b771e927e[] = {
	&_jc_java_util_List$type
};

_jc_method _jc_polyglot_types_MethodInstance$method_info$formalTypes$eca2533b771e927e = {
	.name=			"formalTypes",
	.signature=		"(Ljava/util/List;)Lpolyglot/types/MethodInstance;",
	.class=			&_jc_polyglot_types_MethodInstance$type,
	.param_types=		&_jc_polyglot_types_MethodInstance$param_types$formalTypes$eca2533b771e927e,
	.return_type=		&_jc_polyglot_types_MethodInstance$type,
	.param_ptypes=		&_jc_polyglot_types_MethodInstance$param_ptypes$formalTypes$eca2533b771e927e,
	.signature_hash=	_JC_JLONG(0xeca2533b771e927e),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
};

//
// public abstract java.util.List implemented()
//

static const unsigned char _jc_polyglot_types_MethodInstance$param_ptypes$implemented$fc18604669032836[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_MethodInstance$method_info$implemented$fc18604669032836 = {
	.name=			"implemented",
	.signature=		"()Ljava/util/List;",
	.class=			&_jc_polyglot_types_MethodInstance$type,
	.return_type=		&_jc_java_util_List$type,
	.param_ptypes=		&_jc_polyglot_types_MethodInstance$param_ptypes$implemented$fc18604669032836,
	.signature_hash=	_JC_JLONG(0xfc18604669032836),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract java.util.List implementedImpl(polyglot.types.ReferenceType)
//

static const unsigned char _jc_polyglot_types_MethodInstance$param_ptypes$implementedImpl$97d9662a0a463b74[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_MethodInstance$param_types$implementedImpl$97d9662a0a463b74[] = {
	&_jc_polyglot_types_ReferenceType$type
};

_jc_method _jc_polyglot_types_MethodInstance$method_info$implementedImpl$97d9662a0a463b74 = {
	.name=			"implementedImpl",
	.signature=		"(Lpolyglot/types/ReferenceType;)Ljava/util/List;",
	.class=			&_jc_polyglot_types_MethodInstance$type,
	.param_types=		&_jc_polyglot_types_MethodInstance$param_types$implementedImpl$97d9662a0a463b74,
	.return_type=		&_jc_java_util_List$type,
	.param_ptypes=		&_jc_polyglot_types_MethodInstance$param_ptypes$implementedImpl$97d9662a0a463b74,
	.signature_hash=	_JC_JLONG(0x97d9662a0a463b74),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
};

//
// public abstract boolean isSameMethod(polyglot.types.MethodInstance)
//

static const unsigned char _jc_polyglot_types_MethodInstance$param_ptypes$isSameMethod$97aea777d432f3ad[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_polyglot_types_MethodInstance$param_types$isSameMethod$97aea777d432f3ad[] = {
	&_jc_polyglot_types_MethodInstance$type
};

_jc_method _jc_polyglot_types_MethodInstance$method_info$isSameMethod$97aea777d432f3ad = {
	.name=			"isSameMethod",
	.signature=		"(Lpolyglot/types/MethodInstance;)Z",
	.class=			&_jc_polyglot_types_MethodInstance$type,
	.param_types=		&_jc_polyglot_types_MethodInstance$param_types$isSameMethod$97aea777d432f3ad,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_polyglot_types_MethodInstance$param_ptypes$isSameMethod$97aea777d432f3ad,
	.signature_hash=	_JC_JLONG(0x97aea777d432f3ad),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
};

//
// public abstract boolean isSameMethodImpl(polyglot.types.MethodInstance)
//

static const unsigned char _jc_polyglot_types_MethodInstance$param_ptypes$isSameMethodImpl$9e7a9789bbac5d5f[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_polyglot_types_MethodInstance$param_types$isSameMethodImpl$9e7a9789bbac5d5f[] = {
	&_jc_polyglot_types_MethodInstance$type
};

_jc_method _jc_polyglot_types_MethodInstance$method_info$isSameMethodImpl$9e7a9789bbac5d5f = {
	.name=			"isSameMethodImpl",
	.signature=		"(Lpolyglot/types/MethodInstance;)Z",
	.class=			&_jc_polyglot_types_MethodInstance$type,
	.param_types=		&_jc_polyglot_types_MethodInstance$param_types$isSameMethodImpl$9e7a9789bbac5d5f,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_polyglot_types_MethodInstance$param_ptypes$isSameMethodImpl$9e7a9789bbac5d5f,
	.signature_hash=	_JC_JLONG(0x9e7a9789bbac5d5f),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
};

//
// public abstract boolean methodCallValid(java.lang.String, java.util.List)
//

static const unsigned char _jc_polyglot_types_MethodInstance$param_ptypes$methodCallValid$748f8edf4f9ca9a1[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_polyglot_types_MethodInstance$param_types$methodCallValid$748f8edf4f9ca9a1[] = {
	&_jc_java_lang_String$type,
	&_jc_java_util_List$type
};

_jc_method _jc_polyglot_types_MethodInstance$method_info$methodCallValid$748f8edf4f9ca9a1 = {
	.name=			"methodCallValid",
	.signature=		"(Ljava/lang/String;Ljava/util/List;)Z",
	.class=			&_jc_polyglot_types_MethodInstance$type,
	.param_types=		&_jc_polyglot_types_MethodInstance$param_types$methodCallValid$748f8edf4f9ca9a1,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_polyglot_types_MethodInstance$param_ptypes$methodCallValid$748f8edf4f9ca9a1,
	.signature_hash=	_JC_JLONG(0x748f8edf4f9ca9a1),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	2,
};

//
// public abstract boolean methodCallValidImpl(java.lang.String, java.util.List)
//

static const unsigned char _jc_polyglot_types_MethodInstance$param_ptypes$methodCallValidImpl$886c7572c14816d4[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_polyglot_types_MethodInstance$param_types$methodCallValidImpl$886c7572c14816d4[] = {
	&_jc_java_lang_String$type,
	&_jc_java_util_List$type
};

_jc_method _jc_polyglot_types_MethodInstance$method_info$methodCallValidImpl$886c7572c14816d4 = {
	.name=			"methodCallValidImpl",
	.signature=		"(Ljava/lang/String;Ljava/util/List;)Z",
	.class=			&_jc_polyglot_types_MethodInstance$type,
	.param_types=		&_jc_polyglot_types_MethodInstance$param_types$methodCallValidImpl$886c7572c14816d4,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_polyglot_types_MethodInstance$param_ptypes$methodCallValidImpl$886c7572c14816d4,
	.signature_hash=	_JC_JLONG(0x886c7572c14816d4),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	2,
};

//
// public abstract java.lang.String name()
//

static const unsigned char _jc_polyglot_types_MethodInstance$param_ptypes$name$e6acce026cadf81e[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_MethodInstance$method_info$name$e6acce026cadf81e = {
	.name=			"name",
	.signature=		"()Ljava/lang/String;",
	.class=			&_jc_polyglot_types_MethodInstance$type,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_polyglot_types_MethodInstance$param_ptypes$name$e6acce026cadf81e,
	.signature_hash=	_JC_JLONG(0xe6acce026cadf81e),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract polyglot.types.MethodInstance name(java.lang.String)
//

static const unsigned char _jc_polyglot_types_MethodInstance$param_ptypes$name$a69a57802df40477[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_MethodInstance$param_types$name$a69a57802df40477[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_polyglot_types_MethodInstance$method_info$name$a69a57802df40477 = {
	.name=			"name",
	.signature=		"(Ljava/lang/String;)Lpolyglot/types/MethodInstance;",
	.class=			&_jc_polyglot_types_MethodInstance$type,
	.param_types=		&_jc_polyglot_types_MethodInstance$param_types$name$a69a57802df40477,
	.return_type=		&_jc_polyglot_types_MethodInstance$type,
	.param_ptypes=		&_jc_polyglot_types_MethodInstance$param_ptypes$name$a69a57802df40477,
	.signature_hash=	_JC_JLONG(0xa69a57802df40477),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
};

//
// public abstract java.util.List overrides()
//

static const unsigned char _jc_polyglot_types_MethodInstance$param_ptypes$overrides$1428452149b2b90e[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_MethodInstance$method_info$overrides$1428452149b2b90e = {
	.name=			"overrides",
	.signature=		"()Ljava/util/List;",
	.class=			&_jc_polyglot_types_MethodInstance$type,
	.return_type=		&_jc_java_util_List$type,
	.param_ptypes=		&_jc_polyglot_types_MethodInstance$param_ptypes$overrides$1428452149b2b90e,
	.signature_hash=	_JC_JLONG(0x1428452149b2b90e),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract java.util.List overridesImpl()
//

static const unsigned char _jc_polyglot_types_MethodInstance$param_ptypes$overridesImpl$442ea651a3f34d7f[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_MethodInstance$method_info$overridesImpl$442ea651a3f34d7f = {
	.name=			"overridesImpl",
	.signature=		"()Ljava/util/List;",
	.class=			&_jc_polyglot_types_MethodInstance$type,
	.return_type=		&_jc_java_util_List$type,
	.param_ptypes=		&_jc_polyglot_types_MethodInstance$param_ptypes$overridesImpl$442ea651a3f34d7f,
	.signature_hash=	_JC_JLONG(0x442ea651a3f34d7f),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract polyglot.types.Type returnType()
//

static const unsigned char _jc_polyglot_types_MethodInstance$param_ptypes$returnType$b7faab75c986bcda[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_MethodInstance$method_info$returnType$b7faab75c986bcda = {
	.name=			"returnType",
	.signature=		"()Lpolyglot/types/Type;",
	.class=			&_jc_polyglot_types_MethodInstance$type,
	.return_type=		&_jc_polyglot_types_Type$type,
	.param_ptypes=		&_jc_polyglot_types_MethodInstance$param_ptypes$returnType$b7faab75c986bcda,
	.signature_hash=	_JC_JLONG(0xb7faab75c986bcda),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract polyglot.types.MethodInstance returnType(polyglot.types.Type)
//

static const unsigned char _jc_polyglot_types_MethodInstance$param_ptypes$returnType$05692a2ecafc36b7[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_MethodInstance$param_types$returnType$05692a2ecafc36b7[] = {
	&_jc_polyglot_types_Type$type
};

_jc_method _jc_polyglot_types_MethodInstance$method_info$returnType$05692a2ecafc36b7 = {
	.name=			"returnType",
	.signature=		"(Lpolyglot/types/Type;)Lpolyglot/types/MethodInstance;",
	.class=			&_jc_polyglot_types_MethodInstance$type,
	.param_types=		&_jc_polyglot_types_MethodInstance$param_types$returnType$05692a2ecafc36b7,
	.return_type=		&_jc_polyglot_types_MethodInstance$type,
	.param_ptypes=		&_jc_polyglot_types_MethodInstance$param_ptypes$returnType$05692a2ecafc36b7,
	.signature_hash=	_JC_JLONG(0x5692a2ecafc36b7),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
};

//
// public abstract polyglot.types.MethodInstance throwTypes(java.util.List)
//

static const unsigned char _jc_polyglot_types_MethodInstance$param_ptypes$throwTypes$fb53699e4aa101c0[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_MethodInstance$param_types$throwTypes$fb53699e4aa101c0[] = {
	&_jc_java_util_List$type
};

_jc_method _jc_polyglot_types_MethodInstance$method_info$throwTypes$fb53699e4aa101c0 = {
	.name=			"throwTypes",
	.signature=		"(Ljava/util/List;)Lpolyglot/types/MethodInstance;",
	.class=			&_jc_polyglot_types_MethodInstance$type,
	.param_types=		&_jc_polyglot_types_MethodInstance$param_types$throwTypes$fb53699e4aa101c0,
	.return_type=		&_jc_polyglot_types_MethodInstance$type,
	.param_ptypes=		&_jc_polyglot_types_MethodInstance$param_ptypes$throwTypes$fb53699e4aa101c0,
	.signature_hash=	_JC_JLONG(0xfb53699e4aa101c0),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
};

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_polyglot_types_MethodInstance$methods[] = {
	&_jc_polyglot_types_MethodInstance$method_info$canOverride$bc4ab736b18ec84a,
	&_jc_polyglot_types_MethodInstance$method_info$canOverrideImpl$db6db2c13898460d,
	&_jc_polyglot_types_MethodInstance$method_info$checkOverride$ddad40bbe25e4afa,
	&_jc_polyglot_types_MethodInstance$method_info$container$c1ea432234783ca7,
	&_jc_polyglot_types_MethodInstance$method_info$flags$e76556ea42558b32,
	&_jc_polyglot_types_MethodInstance$method_info$formalTypes$eca2533b771e927e,
	&_jc_polyglot_types_MethodInstance$method_info$implemented$fc18604669032836,
	&_jc_polyglot_types_MethodInstance$method_info$implementedImpl$97d9662a0a463b74,
	&_jc_polyglot_types_MethodInstance$method_info$isSameMethod$97aea777d432f3ad,
	&_jc_polyglot_types_MethodInstance$method_info$isSameMethodImpl$9e7a9789bbac5d5f,
	&_jc_polyglot_types_MethodInstance$method_info$methodCallValid$748f8edf4f9ca9a1,
	&_jc_polyglot_types_MethodInstance$method_info$methodCallValidImpl$886c7572c14816d4,
	&_jc_polyglot_types_MethodInstance$method_info$name$e6acce026cadf81e,
	&_jc_polyglot_types_MethodInstance$method_info$name$a69a57802df40477,
	&_jc_polyglot_types_MethodInstance$method_info$overrides$1428452149b2b90e,
	&_jc_polyglot_types_MethodInstance$method_info$overridesImpl$442ea651a3f34d7f,
	&_jc_polyglot_types_MethodInstance$method_info$returnType$b7faab75c986bcda,
	&_jc_polyglot_types_MethodInstance$method_info$returnType$05692a2ecafc36b7,
	&_jc_polyglot_types_MethodInstance$method_info$throwTypes$fb53699e4aa101c0
};

/************************************************************************
 *			      Interface list				*
 ************************************************************************/

// Directly implemented interfaces
static _jc_type *const _jc_polyglot_types_MethodInstance$interfaces[] = {
	&_jc_polyglot_types_ProcedureInstance$type
};

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_polyglot_types_MethodInstance$instanceof_hash_bucket_2[] = {
	&_jc_polyglot_util_Copy$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_types_MethodInstance$instanceof_hash_bucket_17[] = {
	&_jc_polyglot_types_TypeObject$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_types_MethodInstance$instanceof_hash_bucket_19[] = {
	&_jc_java_lang_Cloneable$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_types_MethodInstance$instanceof_hash_bucket_24[] = {
	&_jc_polyglot_types_MemberInstance$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_types_MethodInstance$instanceof_hash_bucket_65[] = {
	&_jc_java_io_Serializable$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_types_MethodInstance$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_types_MethodInstance$instanceof_hash_bucket_102[] = {
	&_jc_polyglot_types_CodeInstance$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_types_MethodInstance$instanceof_hash_bucket_110[] = {
	&_jc_polyglot_types_MethodInstance$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_types_MethodInstance$instanceof_hash_bucket_116[] = {
	&_jc_polyglot_types_ProcedureInstance$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_polyglot_types_MethodInstance$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[2]=	_jc_polyglot_types_MethodInstance$instanceof_hash_bucket_2,
	[17]=	_jc_polyglot_types_MethodInstance$instanceof_hash_bucket_17,
	[19]=	_jc_polyglot_types_MethodInstance$instanceof_hash_bucket_19,
	[24]=	_jc_polyglot_types_MethodInstance$instanceof_hash_bucket_24,
	[65]=	_jc_polyglot_types_MethodInstance$instanceof_hash_bucket_65,
	[101]=	_jc_polyglot_types_MethodInstance$instanceof_hash_bucket_101,
	[102]=	_jc_polyglot_types_MethodInstance$instanceof_hash_bucket_102,
	[110]=	_jc_polyglot_types_MethodInstance$instanceof_hash_bucket_110,
	[116]=	_jc_polyglot_types_MethodInstance$instanceof_hash_bucket_116
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_polyglot_types_MethodInstance$class_depends[] = {
	{ "java/io/Serializable",	_JC_JLONG(0x9a35c7173b37e641) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/Cloneable",	_JC_JLONG(0x9b667b09132be893) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/util/List",	_JC_JLONG(0x9ee0d92ce1525a4d) },
	{ "polyglot/types/CodeInstance",	_JC_JLONG(0x88f5c21159e638e6) },
	{ "polyglot/types/Flags",	_JC_JLONG(0x821eb65d8f2f30f6) },
	{ "polyglot/types/MemberInstance",	_JC_JLONG(0x7ea7408712d6d898) },
	{ "polyglot/types/ProcedureInstance",	_JC_JLONG(0xbf36f48cfcf511f4) },
	{ "polyglot/types/ReferenceType",	_JC_JLONG(0xcfc647d76f91943a) },
	{ "polyglot/types/SemanticException",	_JC_JLONG(0x45f755f5298b5b39) },
	{ "polyglot/types/Type",	_JC_JLONG(0x6596051546781098) },
	{ "polyglot/types/TypeObject",	_JC_JLONG(0xb6db228dc0317211) },
	{ "polyglot/util/Copy",	_JC_JLONG(0xc1adfaf4637dbc02) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_polyglot_types_MethodInstance$vtype _jc_polyglot_types_MethodInstance$type = {
    .type= {
	.name=			"polyglot/types/MethodInstance",
	.superclass=		&_jc_java_lang_Object$type,
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT|_JC_ACC_INTERFACE,
	.flags=			_JC_TYPE_REFERENCE,
	.num_interfaces=sizeof(_jc_polyglot_types_MethodInstance$interfaces) / sizeof(*_jc_polyglot_types_MethodInstance$interfaces),
	.interfaces=		_jc_polyglot_types_MethodInstance$interfaces,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		30,
		.hash=			_JC_JLONG(0xab0fa5f3ef02c9ee),
		.source_file=		"MethodInstance.java",
		.num_virtual_refs=	0,
		.num_methods=		sizeof(_jc_polyglot_types_MethodInstance$methods) / sizeof(*_jc_polyglot_types_MethodInstance$methods),
		.methods=		_jc_polyglot_types_MethodInstance$methods,
		.instanceof_hash_table=	_jc_polyglot_types_MethodInstance$instanceof_hash_table,
		.num_class_depends=		sizeof(_jc_polyglot_types_MethodInstance$class_depends) / sizeof(*_jc_polyglot_types_MethodInstance$class_depends),
		.class_depends=		_jc_polyglot_types_MethodInstance$class_depends,
	    }
	}
    }
};

