// public class polyglot.types.reflect.ClassPathLoader

// class file dependencies
// @dep_class 9cef6b66128b04b2 java_io_File
// @dep_class 99a46305ebacacb5 java_io_PrintStream
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class 680cf34d05feb5a1 java_lang_IllegalArgumentException
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class 4f5534a987354d1d java_lang_RuntimeException
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 94d357637b968dda java_lang_StringBuffer
// @dep_class 53cc8e2333795f04 java_lang_System
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class 8ea716c64b77f8eb java_util_AbstractCollection
// @dep_class f5238436362828db java_util_AbstractList
// @dep_class ca427569b5b2f804 java_util_AbstractSet
// @dep_class 58038509830ef3f4 java_util_ArrayList
// @dep_class eae4d0c0e8eb63da java_util_Collection
// @dep_class d7cd853200c3e71f java_util_HashMap
// @dep_class 3c285c721478414d java_util_HashSet
// @dep_class be56ff673eefd9d2 java_util_Iterator
// @dep_class 9ee0d92ce1525a4d java_util_List
// @dep_class b106445ca218ee16 java_util_StringTokenizer
// @dep_class cf9f146bdb7bc44d polyglot_main_Report
// @dep_class f394a649a5830bb polyglot_types_reflect_ClassFile
// @dep_class 50cc35358493eab1 polyglot_types_reflect_ClassFileLoader
// @dep_class 32257e81ded29ed1 polyglot_types_reflect_ClassPathLoader

// header file dependencies
// @dep_header java_io_File
// @dep_header java_io_PrintStream
// @dep_header java_lang_Class
// @dep_header java_lang_IllegalArgumentException
// @dep_header java_lang_String
// @dep_header java_lang_StringBuffer
// @dep_header java_lang_System
// @dep_header java_util_ArrayList
// @dep_header java_util_Collection
// @dep_header java_util_HashMap
// @dep_header java_util_HashSet
// @dep_header java_util_Iterator
// @dep_header java_util_List
// @dep_header java_util_StringTokenizer
// @dep_header polyglot_main_Report
// @dep_header polyglot_types_reflect_ClassFile
// @dep_header polyglot_types_reflect_ClassFileLoader
// @dep_header polyglot_types_reflect_ClassPathLoader

#include "jc_defs.h"

#include "java/io/File.h"
#include "java/io/PrintStream.h"
#include "java/lang/Class.h"
#include "java/lang/IllegalArgumentException.h"
#include "java/lang/String.h"
#include "java/lang/StringBuffer.h"
#include "java/lang/System.h"
#include "java/util/ArrayList.h"
#include "java/util/Collection.h"
#include "java/util/HashMap.h"
#include "java/util/HashSet.h"
#include "java/util/Iterator.h"
#include "java/util/List.h"
#include "java/util/StringTokenizer.h"
#include "polyglot/main/Report.h"
#include "polyglot/types/reflect/ClassFile.h"
#include "polyglot/types/reflect/ClassFileLoader.h"
#include "polyglot/types/reflect/ClassPathLoader.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// java.util.List classpath
static _jc_field _jc_polyglot_types_reflect_ClassPathLoader$field_info$classpath = {
	.name=		"classpath",
	.signature=	"Ljava/util/List;",
	.class=		&_jc_polyglot_types_reflect_ClassPathLoader$type,
	.type=		&_jc_java_util_List$type,
	.access_flags=	0,
	.offset=	_JC_OFFSETOF(_jc_polyglot_types_reflect_ClassPathLoader$object, refs[-1].polyglot_types_reflect_ClassPathLoader.classpath),
};

// polyglot.types.reflect.ClassFileLoader loader
static _jc_field _jc_polyglot_types_reflect_ClassPathLoader$field_info$loader = {
	.name=		"loader",
	.signature=	"Lpolyglot/types/reflect/ClassFileLoader;",
	.class=		&_jc_polyglot_types_reflect_ClassPathLoader$type,
	.type=		&_jc_polyglot_types_reflect_ClassFileLoader$type,
	.access_flags=	0,
	.offset=	_JC_OFFSETOF(_jc_polyglot_types_reflect_ClassPathLoader$object, refs[-1].polyglot_types_reflect_ClassPathLoader.loader),
};

// static java.util.Collection verbose
static _jc_field _jc_polyglot_types_reflect_ClassPathLoader$field_info$verbose = {
	.name=		"verbose",
	.signature=	"Ljava/util/Collection;",
	.class=		&_jc_polyglot_types_reflect_ClassPathLoader$type,
	.type=		&_jc_java_util_Collection$type,
	.access_flags=	_JC_ACC_STATIC,
	.offset=	_JC_OFFSETOF(_jc_polyglot_types_reflect_ClassPathLoader$fields_struct, verbose),
};

// Fields
static _jc_field *const _jc_polyglot_types_reflect_ClassPathLoader$fields[] = {
	&_jc_polyglot_types_reflect_ClassPathLoader$field_info$verbose,
	&_jc_polyglot_types_reflect_ClassPathLoader$field_info$classpath,
	&_jc_polyglot_types_reflect_ClassPathLoader$field_info$loader
};

/************************************************************************
 *			      Static methods				*
 ************************************************************************/

//
// static void <clinit>()
//

static _jc_linenum _jc_polyglot_types_reflect_ClassPathLoader$linenum_table$_clinit$a816641e0ba8bfef[];

static const unsigned char _jc_polyglot_types_reflect_ClassPathLoader$param_ptypes$_clinit$a816641e0ba8bfef[] = { 
_JC_TYPE_VOID };

_jc_method _jc_polyglot_types_reflect_ClassPathLoader$method_info$_clinit$a816641e0ba8bfef = {
	.name=			"<clinit>",
	.signature=		"()V",
	.class=			&_jc_polyglot_types_reflect_ClassPathLoader$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_types_reflect_ClassPathLoader$param_ptypes$_clinit$a816641e0ba8bfef,
	.signature_hash=	_JC_JLONG(0xa816641e0ba8bfef),
	.access_flags=		_JC_ACC_STATIC,
	.function=		&_jc_polyglot_types_reflect_ClassPathLoader$method$_clinit$a816641e0ba8bfef,
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_polyglot_types_reflect_ClassPathLoader$linenum_table$_clinit$a816641e0ba8bfef
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_types_reflect_ClassPathLoader, _clinit$a816641e0ba8bfef);

void _JC_JCNI_ATTR
_jc_polyglot_types_reflect_ClassPathLoader$method$_clinit$a816641e0ba8bfef(_jc_env *const env)
{
	struct _jc_java_util_HashSet$object *r0;
	struct _jc_object *r1;
	struct _jc_java_util_HashMap$object *r4;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	_JC_LINE_NUMBER(63);				// 0
	r0 = _JC_NEW(env, java_util_HashSet);
	r4 = _JC_NEW(env, java_util_HashMap);
	_JC_INVOKE_NONVIRTUAL(env, java_util_HashMap, _init$7cb044ce4fb0ada8, 0, r4, 11, _JC_FCONST(0x3f, 0x40, 0x0, 0x0));
	_JC_REF_FIELD(env, r0, java_util_HashSet, map) = r4;
	_JC_STATIC_FIELD(env, polyglot_types_reflect_ClassPathLoader, verbose, 1) = r0;
	_JC_LINE_NUMBER(64);				// 1
	r1 = _JC_STATIC_FIELD(env, polyglot_types_reflect_ClassPathLoader, verbose, 1);
	_JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0x831f06ee5f59c0cc), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), _JC_STRING(env, "loader"));
	_JC_LINE_NUMBER(65);				// 2
	return;
}

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// public void <init>(java.lang.String, polyglot.types.reflect.ClassFileLoader)
//

static _jc_linenum _jc_polyglot_types_reflect_ClassPathLoader$linenum_table$_init$f2ee4e1d676e9c64[];

static const unsigned char _jc_polyglot_types_reflect_ClassPathLoader$param_ptypes$_init$f2ee4e1d676e9c64[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_types_reflect_ClassPathLoader$param_types$_init$f2ee4e1d676e9c64[] = {
	&_jc_java_lang_String$type,
	&_jc_polyglot_types_reflect_ClassFileLoader$type
};

_jc_method _jc_polyglot_types_reflect_ClassPathLoader$method_info$_init$f2ee4e1d676e9c64 = {
	.name=			"<init>",
	.signature=		"(Ljava/lang/String;Lpolyglot/types/reflect/ClassFileLoader;)V",
	.class=			&_jc_polyglot_types_reflect_ClassPathLoader$type,
	.param_types=		&_jc_polyglot_types_reflect_ClassPathLoader$param_types$_init$f2ee4e1d676e9c64,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_types_reflect_ClassPathLoader$param_ptypes$_init$f2ee4e1d676e9c64,
	.signature_hash=	_JC_JLONG(0xf2ee4e1d676e9c64),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_types_reflect_ClassPathLoader$method$_init$f2ee4e1d676e9c64,
	.num_parameters=	2,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	7,
	      .table=	_jc_polyglot_types_reflect_ClassPathLoader$linenum_table$_init$f2ee4e1d676e9c64
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_types_reflect_ClassPathLoader, _init$f2ee4e1d676e9c64);

void _JC_JCNI_ATTR
_jc_polyglot_types_reflect_ClassPathLoader$method$_init$f2ee4e1d676e9c64(_jc_env *const env, _jc_polyglot_types_reflect_ClassPathLoader$object *this, _jc_java_lang_String$object *param0, _jc_polyglot_types_reflect_ClassFileLoader$object *param1)
{
	jint i1;
	struct _jc_polyglot_types_reflect_ClassPathLoader$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_polyglot_types_reflect_ClassFileLoader$object *r2;
	struct _jc_java_util_ArrayList$object *r3;
	struct _jc_java_lang_String$object *r4;
	struct _jc_java_util_StringTokenizer$object *r5;
	struct _jc_object *r6;
	struct _jc_java_io_File$object *r7;
	struct _jc_java_lang_String$object *r8;
	_jc_object_array *r9;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_LINE_NUMBER(23);				// 0
	r3 = _JC_NEW(env, java_util_ArrayList);
	r9 = _JC_NEW_REF_ARRAY(env, java_lang_Object, 1, 16);
	_JC_REF_FIELD(env, r3, java_util_ArrayList, data) = r9;
	_JC_REF_FIELD(env, r0, polyglot_types_reflect_ClassPathLoader, classpath) = r3;
	_JC_LINE_NUMBER(25);				// 1
	r5 = _JC_NEW(env, java_util_StringTokenizer);
	r4 = _JC_STATIC_FIELD(env, java_io_File, pathSeparator, 0);
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	i1 = _JC_PRIM_FIELD(env, r1, java_lang_String, count);
	_JC_PRIM_FIELD(env, r5, java_util_StringTokenizer, len) = i1;
	_JC_REF_FIELD(env, r5, java_util_StringTokenizer, str) = r1;
	_JC_EXPLICIT_NULL_CHECK(env, r4);
	_JC_REF_FIELD(env, r5, java_util_StringTokenizer, delim) = r4;
	_JC_PRIM_FIELD(env, r5, java_util_StringTokenizer, retDelims) = 0;
	_JC_PRIM_FIELD(env, r5, java_util_StringTokenizer, pos) = 0;

label0:
	_JC_LINE_NUMBER(27);				// 2
	z0 = _JC_INVOKE_NONVIRTUAL(env, java_util_StringTokenizer, hasMoreTokens$f02c6da5d207e800, 0, r5);
	if (z0 == 0)
		goto label1;
	_JC_LINE_NUMBER(28);				// 3
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_util_StringTokenizer, nextToken$706c46e280dd7989, 0, r5);
	_JC_LINE_NUMBER(29);				// 4
	r6 = _JC_REF_FIELD(env, r0, polyglot_types_reflect_ClassPathLoader, classpath);
	r7 = _JC_NEW(env, java_io_File);
	r8 = _JC_INVOKE_NONVIRTUAL(env, java_io_File, normalizePath$c82ffbd1adfcec00, 0, r7, r4);
	_JC_REF_FIELD(env, r7, java_io_File, path) = r8;
	_JC_INVOKE_INTERFACE(env, r6, _JC_JLONG(0x831f06ee5f59c0cc), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r7);
	_JC_PERIODIC_CHECK(env);
	goto label0;

label1:
	_JC_LINE_NUMBER(32);				// 5
	_JC_REF_FIELD(env, r0, polyglot_types_reflect_ClassPathLoader, loader) = r2;
	_JC_LINE_NUMBER(33);				// 6
	return;
}

//
// public void <init>(java.util.List, polyglot.types.reflect.ClassFileLoader)
//

static _jc_linenum _jc_polyglot_types_reflect_ClassPathLoader$linenum_table$_init$c2018ba37c205524[];

static const unsigned char _jc_polyglot_types_reflect_ClassPathLoader$param_ptypes$_init$c2018ba37c205524[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_types_reflect_ClassPathLoader$param_types$_init$c2018ba37c205524[] = {
	&_jc_java_util_List$type,
	&_jc_polyglot_types_reflect_ClassFileLoader$type
};

_jc_method _jc_polyglot_types_reflect_ClassPathLoader$method_info$_init$c2018ba37c205524 = {
	.name=			"<init>",
	.signature=		"(Ljava/util/List;Lpolyglot/types/reflect/ClassFileLoader;)V",
	.class=			&_jc_polyglot_types_reflect_ClassPathLoader$type,
	.param_types=		&_jc_polyglot_types_reflect_ClassPathLoader$param_types$_init$c2018ba37c205524,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_types_reflect_ClassPathLoader$param_ptypes$_init$c2018ba37c205524,
	.signature_hash=	_JC_JLONG(0xc2018ba37c205524),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_types_reflect_ClassPathLoader$method$_init$c2018ba37c205524,
	.num_parameters=	2,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_polyglot_types_reflect_ClassPathLoader$linenum_table$_init$c2018ba37c205524
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_types_reflect_ClassPathLoader, _init$c2018ba37c205524);

void _JC_JCNI_ATTR
_jc_polyglot_types_reflect_ClassPathLoader$method$_init$c2018ba37c205524(_jc_env *const env, _jc_polyglot_types_reflect_ClassPathLoader$object *this, _jc_object *param0, _jc_polyglot_types_reflect_ClassFileLoader$object *param1)
{
	jfloat f0;
	jint i0;
	jint i1;
	struct _jc_polyglot_types_reflect_ClassPathLoader$object *r0;
	struct _jc_object *r1;
	struct _jc_polyglot_types_reflect_ClassFileLoader$object *r2;
	struct _jc_java_util_ArrayList$object *r3;
	struct _jc_java_lang_IllegalArgumentException$object *r4;
	_jc_object_array *r5;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_LINE_NUMBER(18);				// 0
	r3 = _JC_NEW(env, java_util_ArrayList);
	i0 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0x345df5220fc60ade), jint, (_jc_env *, struct _jc_object *));
	f0 = (jfloat)i0;
	f0 = f0 * _JC_FCONST(0x3f, 0x8c, 0xcc, 0xcd);
	i0 = _JC_CAST_FLT2INT(env, jfloat, jint, f0);
	if (i0 >= 0)
		goto label0;
	r4 = _JC_NEW(env, java_lang_IllegalArgumentException);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_Throwable, _init$c31b894660454d13, 0, r4, _JC_NULL);
	_JC_THROW(env, r4);

label0:
	r5 = _JC_NEW_REF_ARRAY(env, java_lang_Object, 1, i0);
	_JC_REF_FIELD(env, r3, java_util_ArrayList, data) = r5;
	i1 = _JC_PRIM_FIELD(env, r3, java_util_ArrayList, size);
	_JC_INVOKE_NONVIRTUAL(env, java_util_ArrayList, addAll$28b94b9c09be8eeb, 0, r3, i1, r1);
	_JC_REF_FIELD(env, r0, polyglot_types_reflect_ClassPathLoader, classpath) = r3;
	_JC_LINE_NUMBER(19);				// 1
	_JC_REF_FIELD(env, r0, polyglot_types_reflect_ClassPathLoader, loader) = r2;
	_JC_LINE_NUMBER(20);				// 2
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public java.lang.String classpath()
//

static _jc_linenum _jc_polyglot_types_reflect_ClassPathLoader$linenum_table$classpath$41a069155e50d6ff[];

static const unsigned char _jc_polyglot_types_reflect_ClassPathLoader$param_ptypes$classpath$41a069155e50d6ff[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_reflect_ClassPathLoader$method_info$classpath$41a069155e50d6ff = {
	.name=			"classpath",
	.signature=		"()Ljava/lang/String;",
	.class=			&_jc_polyglot_types_reflect_ClassPathLoader$type,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_polyglot_types_reflect_ClassPathLoader$param_ptypes$classpath$41a069155e50d6ff,
	.signature_hash=	_JC_JLONG(0x41a069155e50d6ff),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_types_reflect_ClassPathLoader$method$classpath$41a069155e50d6ff,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_types_reflect_ClassPathLoader$vtable, polyglot_types_reflect_ClassPathLoader.classpath$41a069155e50d6ff) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_types_reflect_ClassPathLoader$linenum_table$classpath$41a069155e50d6ff
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_types_reflect_ClassPathLoader, classpath$41a069155e50d6ff);

_jc_java_lang_String$object * _JC_JCNI_ATTR
_jc_polyglot_types_reflect_ClassPathLoader$method$classpath$41a069155e50d6ff(_jc_env *const env, _jc_polyglot_types_reflect_ClassPathLoader$object *this)
{
	struct _jc_polyglot_types_reflect_ClassPathLoader$object *r0;
	struct _jc_object *r1;
	struct _jc_java_lang_String$object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(36);				// 0
	r1 = _JC_REF_FIELD(env, r0, polyglot_types_reflect_ClassPathLoader, classpath);
	r2 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, toString$7ea43b33b80a3070, r1);
	return r2;
}

//
// public polyglot.types.reflect.ClassFile loadClass(java.lang.String)
//

static _jc_linenum _jc_polyglot_types_reflect_ClassPathLoader$linenum_table$loadClass$88d5dad5c2f76cdd[];

static const unsigned char _jc_polyglot_types_reflect_ClassPathLoader$param_ptypes$loadClass$88d5dad5c2f76cdd[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_reflect_ClassPathLoader$param_types$loadClass$88d5dad5c2f76cdd[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_polyglot_types_reflect_ClassPathLoader$method_info$loadClass$88d5dad5c2f76cdd = {
	.name=			"loadClass",
	.signature=		"(Ljava/lang/String;)Lpolyglot/types/reflect/ClassFile;",
	.class=			&_jc_polyglot_types_reflect_ClassPathLoader$type,
	.param_types=		&_jc_polyglot_types_reflect_ClassPathLoader$param_types$loadClass$88d5dad5c2f76cdd,
	.return_type=		&_jc_polyglot_types_reflect_ClassFile$type,
	.param_ptypes=		&_jc_polyglot_types_reflect_ClassPathLoader$param_ptypes$loadClass$88d5dad5c2f76cdd,
	.signature_hash=	_JC_JLONG(0x88d5dad5c2f76cdd),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_types_reflect_ClassPathLoader$method$loadClass$88d5dad5c2f76cdd,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_types_reflect_ClassPathLoader$vtable, polyglot_types_reflect_ClassPathLoader.loadClass$88d5dad5c2f76cdd) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	9,
	      .table=	_jc_polyglot_types_reflect_ClassPathLoader$linenum_table$loadClass$88d5dad5c2f76cdd
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_types_reflect_ClassPathLoader, loadClass$88d5dad5c2f76cdd);

_jc_polyglot_types_reflect_ClassFile$object * _JC_JCNI_ATTR
_jc_polyglot_types_reflect_ClassPathLoader$method$loadClass$88d5dad5c2f76cdd(_jc_env *const env, _jc_polyglot_types_reflect_ClassPathLoader$object *this, _jc_java_lang_String$object *param0)
{
	jint i0;
	jint i2;
	struct _jc_polyglot_types_reflect_ClassPathLoader$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_java_lang_String$object *r10;
	struct _jc_java_lang_String$object *r11;
	_jc_char_array *r12;
	_jc_char_array *r13;
	struct _jc_java_lang_StringBuffer$object *r14;
	struct _jc_java_lang_String$object *r15;
	struct _jc_java_io_PrintStream$object *r16;
	struct _jc_java_io_PrintStream$object *r18;
	struct _jc_object *r2;
	struct _jc_object *r3;
	struct _jc_java_io_File$object *r4;
	struct _jc_polyglot_types_reflect_ClassFile$object *r5;
	struct _jc_java_lang_StringBuffer$object *r6;
	struct _jc_object *r7;
	struct _jc_java_lang_Object$object *r8;
	struct _jc_polyglot_types_reflect_ClassFileLoader$object *r9;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(44);				// 0
	r2 = _JC_STATIC_FIELD(env, polyglot_types_reflect_ClassPathLoader, verbose, 1);
	z0 = _JC_INVOKE_STATIC(env, polyglot_main_Report, should__5freport$316269f2ec4db001, 0, r2, 2);
	if (z0 == 0)
		goto label6;
	_JC_LINE_NUMBER(45);				// 1
	r6 = _JC_NEW(env, java_lang_StringBuffer);
	r12 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r6, java_lang_StringBuffer, value) = r12;
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r6, _JC_STRING(env, "attempting to load class "));
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r6, r1);
	r10 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r10, r6);
	i0 = 1;

label0:
	if (i0 >= 2)
		goto label1;
	r16 = _JC_STATIC_FIELD(env, java_lang_System, err, 0);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, print$21bdbb15afdbea95, r16, _JC_STRING(env, "  "));
	i0 = i0 + 1;
	_JC_PERIODIC_CHECK(env);
	goto label0;

label1:
	r16 = _JC_STATIC_FIELD(env, java_lang_System, err, 0);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, println$f7dbc2aa0f0a9d4f, r16, r10);
	_JC_LINE_NUMBER(46);				// 2
	r6 = _JC_NEW(env, java_lang_StringBuffer);
	r13 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r6, java_lang_StringBuffer, value) = r13;
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r6, _JC_STRING(env, "classpath = "));
	r7 = _JC_REF_FIELD(env, r0, polyglot_types_reflect_ClassPathLoader, classpath);
	r14 = r6;
	if (r7 != _JC_NULL)
		goto label2;
	r15 = _JC_STRING(env, "null");
	goto label3;

label2:
	r15 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, toString$7ea43b33b80a3070, r7);

label3:
	r14 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r14, r15);
	r11 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r11, r14);
	_JC_ACTIVE_USE(env, polyglot_main_Report);
	i2 = 1;

label4:
	if (i2 >= 2)
		goto label5;
	r18 = _JC_STATIC_FIELD(env, java_lang_System, err, 1);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, print$21bdbb15afdbea95, r18, _JC_STRING(env, "  "));
	i2 = i2 + 1;
	_JC_PERIODIC_CHECK(env);
	goto label4;

label5:
	r18 = _JC_STATIC_FIELD(env, java_lang_System, err, 1);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, println$f7dbc2aa0f0a9d4f, r18, r11);

label6:
	_JC_LINE_NUMBER(49);				// 3
	r7 = _JC_REF_FIELD(env, r0, polyglot_types_reflect_ClassPathLoader, classpath);
	r3 = _JC_INVOKE_INTERFACE(env, r7, _JC_JLONG(0x3cc91493d50f531c), _jc_object *, (_jc_env *, struct _jc_object *));

label7:
	z0 = _JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0xfb0bd5e38c59ddcd), jboolean, (_jc_env *, struct _jc_object *));
	if (z0 == 0)
		goto label8;
	_JC_LINE_NUMBER(50);				// 4
	r8 = _JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0x5874f79a1cf66ea), _jc_object *, (_jc_env *, struct _jc_object *));
	r4 = _JC_CAST(env, &_jc_java_io_File$type, r8);
	_JC_LINE_NUMBER(51);				// 5
	r9 = _JC_REF_FIELD(env, r0, polyglot_types_reflect_ClassPathLoader, loader);
	r5 = _JC_INVOKE_VIRTUAL(env, polyglot_types_reflect_ClassFileLoader, loadClass$0a961ff1e687d0e8, r9, r4, r1);
	_JC_LINE_NUMBER(52);				// 6
	if (r5 == _JC_NULL) {
		_JC_PERIODIC_CHECK(env);
		goto label7;
	}
	_JC_LINE_NUMBER(53);				// 7
	return r5;

label8:
	_JC_LINE_NUMBER(57);				// 8
	return _JC_NULL;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_polyglot_types_reflect_ClassPathLoader$methods[] = {
	&_jc_polyglot_types_reflect_ClassPathLoader$method_info$_clinit$a816641e0ba8bfef,
	&_jc_polyglot_types_reflect_ClassPathLoader$method_info$_init$f2ee4e1d676e9c64,
	&_jc_polyglot_types_reflect_ClassPathLoader$method_info$_init$c2018ba37c205524,
	&_jc_polyglot_types_reflect_ClassPathLoader$method_info$classpath$41a069155e50d6ff,
	&_jc_polyglot_types_reflect_ClassPathLoader$method_info$loadClass$88d5dad5c2f76cdd
};

/************************************************************************
 *			  Class fields structure			*
 ************************************************************************/

_jc_polyglot_types_reflect_ClassPathLoader$fields_struct _jc_polyglot_types_reflect_ClassPathLoader$class_fields = { };

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_polyglot_types_reflect_ClassPathLoader$instanceof_hash_bucket_81[] = {
	&_jc_polyglot_types_reflect_ClassPathLoader$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_types_reflect_ClassPathLoader$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_polyglot_types_reflect_ClassPathLoader$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[81]=	_jc_polyglot_types_reflect_ClassPathLoader$instanceof_hash_bucket_81,
	[101]=	_jc_polyglot_types_reflect_ClassPathLoader$instanceof_hash_bucket_101
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_polyglot_types_reflect_ClassPathLoader$class_depends[] = {
	{ "java/io/File",	_JC_JLONG(0x9cef6b66128b04b2) },
	{ "java/io/PrintStream",	_JC_JLONG(0x99a46305ebacacb5) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/IllegalArgumentException",	_JC_JLONG(0x680cf34d05feb5a1) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/RuntimeException",	_JC_JLONG(0x4f5534a987354d1d) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/StringBuffer",	_JC_JLONG(0x94d357637b968dda) },
	{ "java/lang/System",	_JC_JLONG(0x53cc8e2333795f04) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/util/AbstractCollection",	_JC_JLONG(0x8ea716c64b77f8eb) },
	{ "java/util/AbstractList",	_JC_JLONG(0xf5238436362828db) },
	{ "java/util/AbstractSet",	_JC_JLONG(0xca427569b5b2f804) },
	{ "java/util/ArrayList",	_JC_JLONG(0x58038509830ef3f4) },
	{ "java/util/Collection",	_JC_JLONG(0xeae4d0c0e8eb63da) },
	{ "java/util/HashMap",	_JC_JLONG(0xd7cd853200c3e71f) },
	{ "java/util/HashSet",	_JC_JLONG(0x3c285c721478414d) },
	{ "java/util/Iterator",	_JC_JLONG(0xbe56ff673eefd9d2) },
	{ "java/util/List",	_JC_JLONG(0x9ee0d92ce1525a4d) },
	{ "java/util/StringTokenizer",	_JC_JLONG(0xb106445ca218ee16) },
	{ "polyglot/main/Report",	_JC_JLONG(0xcf9f146bdb7bc44d) },
	{ "polyglot/types/reflect/ClassFile",	_JC_JLONG(0xf394a649a5830bb) },
	{ "polyglot/types/reflect/ClassFileLoader",	_JC_JLONG(0x50cc35358493eab1) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_polyglot_types_reflect_ClassPathLoader$vtype _jc_polyglot_types_reflect_ClassPathLoader$type = {
    .type= {
	.name=			"polyglot/types/reflect/ClassPathLoader",
	.superclass=		&_jc_java_lang_Object$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		13,
		.hash=			_JC_JLONG(0x32257e81ded29ed1),
		.source_file=		"ClassPathLoader.java",
		.instance_size=		sizeof(_jc_polyglot_types_reflect_ClassPathLoader$refs) + sizeof(_jc_polyglot_types_reflect_ClassPathLoader$object),
		.num_virtual_refs=	2,
		.num_fields=		sizeof(_jc_polyglot_types_reflect_ClassPathLoader$fields) / sizeof(*_jc_polyglot_types_reflect_ClassPathLoader$fields),
		.fields=		_jc_polyglot_types_reflect_ClassPathLoader$fields,
		.num_methods=		sizeof(_jc_polyglot_types_reflect_ClassPathLoader$methods) / sizeof(*_jc_polyglot_types_reflect_ClassPathLoader$methods),
		.methods=		_jc_polyglot_types_reflect_ClassPathLoader$methods,
		.instanceof_hash_table=	_jc_polyglot_types_reflect_ClassPathLoader$instanceof_hash_table,
		.class_fields=		&_jc_polyglot_types_reflect_ClassPathLoader$class_fields,
		.num_class_depends=		sizeof(_jc_polyglot_types_reflect_ClassPathLoader$class_depends) / sizeof(*_jc_polyglot_types_reflect_ClassPathLoader$class_depends),
		.class_depends=		_jc_polyglot_types_reflect_ClassPathLoader$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.polyglot_types_reflect_ClassPathLoader= {
	    .classpath$41a069155e50d6ff=
		&_jc_polyglot_types_reflect_ClassPathLoader$method$classpath$41a069155e50d6ff,
	    .loadClass$88d5dad5c2f76cdd=
		&_jc_polyglot_types_reflect_ClassPathLoader$method$loadClass$88d5dad5c2f76cdd,
	},
    }
};

