// public class polyglot.util.StdErrorQueue

// class file dependencies
// @dep_class 5fe9816daa9bdb2b gnu_java_nio_channels_FileChannelImpl
// @dep_class 2f32f9b77402a730 java_io_BufferedReader
// @dep_class 9cef6b66128b04b2 java_io_File
// @dep_class c9cb932278ec6eea java_io_FileInputStream
// @dep_class 42380f6d5e9ae354 java_io_FileReader
// @dep_class 4e0a56550c69d57c java_io_IOException
// @dep_class 66aea4d152614ac4 java_io_InputStream
// @dep_class 30159d8092563292 java_io_InputStreamReader
// @dep_class 86bd8cdd2cb89429 java_io_LineNumberReader
// @dep_class 99a46305ebacacb5 java_io_PrintStream
// @dep_class 688afb20bd4c4e01 java_io_Reader
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class 3cdfed1e0ad1a3d6 java_lang_IndexOutOfBoundsException
// @dep_class ca631501391a31f1 java_lang_Integer
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class 4f5534a987354d1d java_lang_RuntimeException
// @dep_class d38282f3d5f80887 java_lang_SecurityManager
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 94d357637b968dda java_lang_StringBuffer
// @dep_class bb7f6fdd2bd0e6b2 java_lang_StringIndexOutOfBoundsException
// @dep_class 53cc8e2333795f04 java_lang_System
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class b106445ca218ee16 java_util_StringTokenizer
// @dep_class 1b61c050315c20e6 polyglot_util_ErrorInfo
// @dep_class 346d846eb3bf9fe4 polyglot_util_ErrorLimitError
// @dep_class ff712c8463bdfdc0 polyglot_util_ErrorQueue
// @dep_class 32c9a088c5dac046 polyglot_util_Position
// @dep_class b9dc549f1c7c5c25 polyglot_util_StdErrorQueue

// header file dependencies
// @dep_header gnu_java_nio_channels_FileChannelImpl
// @dep_header java_io_File
// @dep_header java_io_FileInputStream
// @dep_header java_io_FileReader
// @dep_header java_io_IOException
// @dep_header java_io_LineNumberReader
// @dep_header java_io_PrintStream
// @dep_header java_lang_Class
// @dep_header java_lang_Integer
// @dep_header java_lang_SecurityManager
// @dep_header java_lang_String
// @dep_header java_lang_StringBuffer
// @dep_header java_lang_StringIndexOutOfBoundsException
// @dep_header java_lang_System
// @dep_header java_lang_VMThrowable
// @dep_header java_util_StringTokenizer
// @dep_header polyglot_util_ErrorInfo
// @dep_header polyglot_util_ErrorLimitError
// @dep_header polyglot_util_ErrorQueue
// @dep_header polyglot_util_Position
// @dep_header polyglot_util_StdErrorQueue

#include "jc_defs.h"

#include "gnu/java/nio/channels/FileChannelImpl.h"
#include "java/io/File.h"
#include "java/io/FileInputStream.h"
#include "java/io/FileReader.h"
#include "java/io/IOException.h"
#include "java/io/LineNumberReader.h"
#include "java/io/PrintStream.h"
#include "java/lang/Class.h"
#include "java/lang/Integer.h"
#include "java/lang/SecurityManager.h"
#include "java/lang/String.h"
#include "java/lang/StringBuffer.h"
#include "java/lang/StringIndexOutOfBoundsException.h"
#include "java/lang/System.h"
#include "java/lang/VMThrowable.h"
#include "java/util/StringTokenizer.h"
#include "polyglot/util/ErrorInfo.h"
#include "polyglot/util/ErrorLimitError.h"
#include "polyglot/util/ErrorQueue.h"
#include "polyglot/util/Position.h"
#include "polyglot/util/StdErrorQueue.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// private java.io.PrintStream err
static _jc_field _jc_polyglot_util_StdErrorQueue$field_info$err = {
	.name=		"err",
	.signature=	"Ljava/io/PrintStream;",
	.class=		&_jc_polyglot_util_StdErrorQueue$type,
	.type=		&_jc_java_io_PrintStream$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_polyglot_util_StdErrorQueue$object, refs[-1].polyglot_util_StdErrorQueue.err),
};

// private int errorCount
static _jc_field _jc_polyglot_util_StdErrorQueue$field_info$errorCount = {
	.name=		"errorCount",
	.signature=	"I",
	.class=		&_jc_polyglot_util_StdErrorQueue$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_polyglot_util_StdErrorQueue$object, nonrefs.polyglot_util_StdErrorQueue.errorCount),
};

// private boolean flushed
static _jc_field _jc_polyglot_util_StdErrorQueue$field_info$flushed = {
	.name=		"flushed",
	.signature=	"Z",
	.class=		&_jc_polyglot_util_StdErrorQueue$type,
	.type=		&_jc_boolean$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_polyglot_util_StdErrorQueue$object, nonrefs.polyglot_util_StdErrorQueue.flushed),
};

// private int limit
static _jc_field _jc_polyglot_util_StdErrorQueue$field_info$limit = {
	.name=		"limit",
	.signature=	"I",
	.class=		&_jc_polyglot_util_StdErrorQueue$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_polyglot_util_StdErrorQueue$object, nonrefs.polyglot_util_StdErrorQueue.limit),
};

// private java.lang.String name
static _jc_field _jc_polyglot_util_StdErrorQueue$field_info$name = {
	.name=		"name",
	.signature=	"Ljava/lang/String;",
	.class=		&_jc_polyglot_util_StdErrorQueue$type,
	.type=		&_jc_java_lang_String$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_polyglot_util_StdErrorQueue$object, refs[-1].polyglot_util_StdErrorQueue.name),
};

// Fields
static _jc_field *const _jc_polyglot_util_StdErrorQueue$fields[] = {
	&_jc_polyglot_util_StdErrorQueue$field_info$err,
	&_jc_polyglot_util_StdErrorQueue$field_info$name,
	&_jc_polyglot_util_StdErrorQueue$field_info$errorCount,
	&_jc_polyglot_util_StdErrorQueue$field_info$limit,
	&_jc_polyglot_util_StdErrorQueue$field_info$flushed
};

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// public void <init>(java.io.PrintStream, int, java.lang.String)
//

static _jc_linenum _jc_polyglot_util_StdErrorQueue$linenum_table$_init$7d5386038d104f5d[];

static const unsigned char _jc_polyglot_util_StdErrorQueue$param_ptypes$_init$7d5386038d104f5d[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_util_StdErrorQueue$param_types$_init$7d5386038d104f5d[] = {
	&_jc_java_io_PrintStream$type,
	&_jc_int$prim$type,
	&_jc_java_lang_String$type
};

_jc_method _jc_polyglot_util_StdErrorQueue$method_info$_init$7d5386038d104f5d = {
	.name=			"<init>",
	.signature=		"(Ljava/io/PrintStream;ILjava/lang/String;)V",
	.class=			&_jc_polyglot_util_StdErrorQueue$type,
	.param_types=		&_jc_polyglot_util_StdErrorQueue$param_types$_init$7d5386038d104f5d,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_util_StdErrorQueue$param_ptypes$_init$7d5386038d104f5d,
	.signature_hash=	_JC_JLONG(0x7d5386038d104f5d),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_util_StdErrorQueue$method$_init$7d5386038d104f5d,
	.num_parameters=	3,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	6,
	      .table=	_jc_polyglot_util_StdErrorQueue$linenum_table$_init$7d5386038d104f5d
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_util_StdErrorQueue, _init$7d5386038d104f5d);

void _JC_JCNI_ATTR
_jc_polyglot_util_StdErrorQueue$method$_init$7d5386038d104f5d(_jc_env *const env, _jc_polyglot_util_StdErrorQueue$object *this, _jc_java_io_PrintStream$object *param0, jint param1, _jc_java_lang_String$object *param2)
{
	jint i0;
	struct _jc_polyglot_util_StdErrorQueue$object *r0;
	struct _jc_java_io_PrintStream$object *r1;
	struct _jc_java_lang_String$object *r2;

	r0 = this;
	r1 = param0;
	i0 = param1;
	r2 = param2;
	_JC_LINE_NUMBER(19);				// 0
	_JC_REF_FIELD(env, r0, polyglot_util_StdErrorQueue, err) = r1;
	_JC_LINE_NUMBER(20);				// 1
	_JC_PRIM_FIELD(env, r0, polyglot_util_StdErrorQueue, errorCount) = 0;
	_JC_LINE_NUMBER(21);				// 2
	_JC_PRIM_FIELD(env, r0, polyglot_util_StdErrorQueue, flushed) = 1;
	_JC_LINE_NUMBER(22);				// 3
	_JC_PRIM_FIELD(env, r0, polyglot_util_StdErrorQueue, limit) = i0;
	_JC_LINE_NUMBER(23);				// 4
	_JC_REF_FIELD(env, r0, polyglot_util_StdErrorQueue, name) = r2;
	_JC_LINE_NUMBER(24);				// 5
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public void enqueue(int, java.lang.String)
//

static _jc_linenum _jc_polyglot_util_StdErrorQueue$linenum_table$enqueue$7659161d8f442ddb[];

static const unsigned char _jc_polyglot_util_StdErrorQueue$param_ptypes$enqueue$7659161d8f442ddb[] = { 
_JC_TYPE_INT, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_util_StdErrorQueue$param_types$enqueue$7659161d8f442ddb[] = {
	&_jc_int$prim$type,
	&_jc_java_lang_String$type
};

_jc_method _jc_polyglot_util_StdErrorQueue$method_info$enqueue$7659161d8f442ddb = {
	.name=			"enqueue",
	.signature=		"(ILjava/lang/String;)V",
	.class=			&_jc_polyglot_util_StdErrorQueue$type,
	.param_types=		&_jc_polyglot_util_StdErrorQueue$param_types$enqueue$7659161d8f442ddb,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_util_StdErrorQueue$param_ptypes$enqueue$7659161d8f442ddb,
	.signature_hash=	_JC_JLONG(0x7659161d8f442ddb),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_util_StdErrorQueue$method$enqueue$7659161d8f442ddb,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_util_StdErrorQueue$vtable, polyglot_util_StdErrorQueue.enqueue$7659161d8f442ddb) / sizeof(void *),
	.num_parameters=	2,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_polyglot_util_StdErrorQueue$linenum_table$enqueue$7659161d8f442ddb
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_util_StdErrorQueue, enqueue$7659161d8f442ddb);

void _JC_JCNI_ATTR
_jc_polyglot_util_StdErrorQueue$method$enqueue$7659161d8f442ddb(_jc_env *const env, _jc_polyglot_util_StdErrorQueue$object *this, jint param0, _jc_java_lang_String$object *param1)
{
	jint i0;
	struct _jc_polyglot_util_StdErrorQueue$object *r0;
	struct _jc_java_lang_String$object *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	i0 = param0;
	r1 = param1;
	_JC_LINE_NUMBER(27);				// 0
	_JC_INVOKE_VIRTUAL(env, polyglot_util_StdErrorQueue, enqueue$82679af4bd898d46, r0, i0, r1, _JC_NULL);
	_JC_LINE_NUMBER(28);				// 1
	return;
}

//
// public void enqueue(int, java.lang.String, polyglot.util.Position)
//

static _jc_linenum _jc_polyglot_util_StdErrorQueue$linenum_table$enqueue$82679af4bd898d46[];

static const unsigned char _jc_polyglot_util_StdErrorQueue$param_ptypes$enqueue$82679af4bd898d46[] = { 
_JC_TYPE_INT, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_util_StdErrorQueue$param_types$enqueue$82679af4bd898d46[] = {
	&_jc_int$prim$type,
	&_jc_java_lang_String$type,
	&_jc_polyglot_util_Position$type
};

_jc_method _jc_polyglot_util_StdErrorQueue$method_info$enqueue$82679af4bd898d46 = {
	.name=			"enqueue",
	.signature=		"(ILjava/lang/String;Lpolyglot/util/Position;)V",
	.class=			&_jc_polyglot_util_StdErrorQueue$type,
	.param_types=		&_jc_polyglot_util_StdErrorQueue$param_types$enqueue$82679af4bd898d46,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_util_StdErrorQueue$param_ptypes$enqueue$82679af4bd898d46,
	.signature_hash=	_JC_JLONG(0x82679af4bd898d46),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_util_StdErrorQueue$method$enqueue$82679af4bd898d46,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_util_StdErrorQueue$vtable, polyglot_util_StdErrorQueue.enqueue$82679af4bd898d46) / sizeof(void *),
	.num_parameters=	3,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_polyglot_util_StdErrorQueue$linenum_table$enqueue$82679af4bd898d46
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_util_StdErrorQueue, enqueue$82679af4bd898d46);

void _JC_JCNI_ATTR
_jc_polyglot_util_StdErrorQueue$method$enqueue$82679af4bd898d46(_jc_env *const env, _jc_polyglot_util_StdErrorQueue$object *this, jint param0, _jc_java_lang_String$object *param1, _jc_polyglot_util_Position$object *param2)
{
	jint i0;
	struct _jc_polyglot_util_StdErrorQueue$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_polyglot_util_Position$object *r2;
	struct _jc_polyglot_util_ErrorInfo$object *r3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	i0 = param0;
	r1 = param1;
	r2 = param2;
	_JC_LINE_NUMBER(31);				// 0
	r3 = _JC_NEW(env, polyglot_util_ErrorInfo);
	_JC_PRIM_FIELD(env, r3, polyglot_util_ErrorInfo, kind) = i0;
	_JC_REF_FIELD(env, r3, polyglot_util_ErrorInfo, message) = r1;
	_JC_REF_FIELD(env, r3, polyglot_util_ErrorInfo, position) = r2;
	_JC_INVOKE_VIRTUAL(env, polyglot_util_StdErrorQueue, enqueue$a8bd5ecfa883f67a, r0, r3);
	_JC_LINE_NUMBER(32);				// 1
	return;
}

//
// public void enqueue(polyglot.util.ErrorInfo)
//

static _jc_linenum _jc_polyglot_util_StdErrorQueue$linenum_table$enqueue$a8bd5ecfa883f67a[];

static const unsigned char _jc_polyglot_util_StdErrorQueue$param_ptypes$enqueue$a8bd5ecfa883f67a[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_util_StdErrorQueue$param_types$enqueue$a8bd5ecfa883f67a[] = {
	&_jc_polyglot_util_ErrorInfo$type
};

_jc_method _jc_polyglot_util_StdErrorQueue$method_info$enqueue$a8bd5ecfa883f67a = {
	.name=			"enqueue",
	.signature=		"(Lpolyglot/util/ErrorInfo;)V",
	.class=			&_jc_polyglot_util_StdErrorQueue$type,
	.param_types=		&_jc_polyglot_util_StdErrorQueue$param_types$enqueue$a8bd5ecfa883f67a,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_util_StdErrorQueue$param_ptypes$enqueue$a8bd5ecfa883f67a,
	.signature_hash=	_JC_JLONG(0xa8bd5ecfa883f67a),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_util_StdErrorQueue$method$enqueue$a8bd5ecfa883f67a,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_util_StdErrorQueue$vtable, polyglot_util_StdErrorQueue.enqueue$a8bd5ecfa883f67a) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	32,
	      .table=	_jc_polyglot_util_StdErrorQueue$linenum_table$enqueue$a8bd5ecfa883f67a
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_util_StdErrorQueue, enqueue$a8bd5ecfa883f67a);

void _JC_JCNI_ATTR
_jc_polyglot_util_StdErrorQueue$method$enqueue$a8bd5ecfa883f67a(_jc_env *const env, _jc_polyglot_util_StdErrorQueue$object *this, _jc_polyglot_util_ErrorInfo$object *param0)
{
	jchar c8;
	jint i0;
	jint i1;
	jint i2;
	jint i3;
	jint i4;
	jint i5;
	jint i6;
	jint i7;
	jint i9;
	struct _jc_polyglot_util_StdErrorQueue$object *r0;
	struct _jc_polyglot_util_ErrorInfo$object *r1;
	struct _jc_java_lang_String$object *r10;
	struct _jc_java_lang_String$object *r11;
	struct _jc_java_lang_String$object *r12;
	struct _jc_java_lang_String$object *r13;
	struct _jc_java_lang_String$object *r14;
	_jc_char_array *r15;
	_jc_char_array *r16;
	_jc_char_array *r17;
	_jc_char_array *r18;
	struct _jc_java_lang_String$object *r19;
	struct _jc_java_lang_String$object *r2;
	struct _jc_java_lang_VMThrowable$object *r20;
	struct _jc_java_lang_StringIndexOutOfBoundsException$object *r21;
	_jc_char_array *r22;
	struct _jc_java_lang_StringBuffer$object *r23;
	struct _jc_java_lang_StringBuffer$object *r24;
	struct _jc_java_lang_String$object *r25;
	struct _jc_java_lang_String$object *r26;
	struct _jc_java_lang_VMThrowable$object *r27;
	struct _jc_java_lang_String$object *r28;
	_jc_char_array *r29;
	struct _jc_polyglot_util_Position$object *r3;
	struct _jc_java_lang_String$object *r4;
	struct _jc_java_util_StringTokenizer$object *r5;
	struct _jc_java_lang_StringBuffer$object *r6;
	struct _jc_java_io_PrintStream$object *r7;
	struct _jc_java_lang_String$object *r8;
	struct _jc_polyglot_util_ErrorLimitError$object *r9;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(35);				// 0
	i1 = _JC_INVOKE_VIRTUAL(env, polyglot_util_ErrorInfo, getErrorKind$88a3a6c2c6cb7265, r1);
	if (i1 == 0)
		goto label0;
	_JC_LINE_NUMBER(36);				// 1
	i1 = _JC_PRIM_FIELD(env, r0, polyglot_util_StdErrorQueue, errorCount);
	i1 = i1 + 1;
	_JC_PRIM_FIELD(env, r0, polyglot_util_StdErrorQueue, errorCount) = i1;

label0:
	_JC_LINE_NUMBER(39);				// 2
	_JC_PRIM_FIELD(env, r0, polyglot_util_StdErrorQueue, flushed) = 0;
	_JC_LINE_NUMBER(41);				// 3
	i1 = _JC_INVOKE_VIRTUAL(env, polyglot_util_ErrorInfo, getErrorKind$88a3a6c2c6cb7265, r1);
	if (i1 == 0)
		goto label1;
	r4 = _JC_INVOKE_VIRTUAL(env, polyglot_util_ErrorInfo, getMessage$13aaf240efc902b1, r1);
	goto label2;

label1:
	r6 = _JC_NEW(env, java_lang_StringBuffer);
	r15 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r6, java_lang_StringBuffer, value) = r15;
	r4 = _JC_INVOKE_VIRTUAL(env, polyglot_util_ErrorInfo, getErrorString$aa2623c57c93cc6c, r1);
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r6, r4);
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r6, _JC_STRING(env, " -- "));
	r4 = _JC_INVOKE_VIRTUAL(env, polyglot_util_ErrorInfo, getMessage$13aaf240efc902b1, r1);
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r6, r4);
	r11 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r11, r6);
	r4 = r11;

label2:
	r2 = r4;
	_JC_LINE_NUMBER(45);				// 4
	r3 = _JC_INVOKE_VIRTUAL(env, polyglot_util_ErrorInfo, getPosition$93950f582a09a82d, r1);
	_JC_LINE_NUMBER(47);				// 5
	if (r3 == _JC_NULL)
		goto label3;
	r4 = _JC_INVOKE_VIRTUAL(env, polyglot_util_Position, nameAndLineString$834b34befb17e6ff, r3);
	goto label4;

label3:
	r4 = _JC_REF_FIELD(env, r0, polyglot_util_StdErrorQueue, name);

label4:
	_JC_LINE_NUMBER(88);				// 6
	r7 = _JC_REF_FIELD(env, r0, polyglot_util_StdErrorQueue, err);
	r6 = _JC_NEW(env, java_lang_StringBuffer);
	r16 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r6, java_lang_StringBuffer, value) = r16;
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r6, r4);
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r6, _JC_STRING(env, ":"));
	r12 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r12, r6);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, print$21bdbb15afdbea95, r7, r12);
	_JC_EXPLICIT_NULL_CHECK(env, r4);
	i3 = _JC_PRIM_FIELD(env, r4, java_lang_String, count);
	_JC_LINE_NUMBER(89);				// 7
	i1 = i3 + 1;
	i1 = 0 + i1;
	_JC_LINE_NUMBER(91);				// 8
	i0 = 4;
	_JC_LINE_NUMBER(94);				// 9
	r5 = _JC_NEW(env, java_util_StringTokenizer);
	r10 = _JC_STRING(env, " ");
	_JC_EXPLICIT_NULL_CHECK(env, r2);
	i6 = _JC_PRIM_FIELD(env, r2, java_lang_String, count);
	_JC_PRIM_FIELD(env, r5, java_util_StringTokenizer, len) = i6;
	_JC_REF_FIELD(env, r5, java_util_StringTokenizer, str) = r2;
	_JC_REF_FIELD(env, r5, java_util_StringTokenizer, delim) = r10;
	_JC_PRIM_FIELD(env, r5, java_util_StringTokenizer, retDelims) = 0;
	_JC_PRIM_FIELD(env, r5, java_util_StringTokenizer, pos) = 0;

label5:
	_JC_LINE_NUMBER(96);				// 10
	z0 = _JC_INVOKE_NONVIRTUAL(env, java_util_StringTokenizer, hasMoreTokens$f02c6da5d207e800, 0, r5);
	if (z0 == 0)
		goto label12;
	_JC_LINE_NUMBER(97);				// 11
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_util_StringTokenizer, nextToken$706c46e280dd7989, 0, r5);
	_JC_EXPLICIT_NULL_CHECK(env, r4);
	i7 = _JC_PRIM_FIELD(env, r4, java_lang_String, count);
	if (0 < i7)
		goto label6;
	r21 = _JC_NEW(env, java_lang_StringIndexOutOfBoundsException);
	r23 = _JC_NEW(env, java_lang_StringBuffer);
	r28 = _JC_STRING(env, "String index out of range: ");
	i9 = _JC_PRIM_FIELD(env, r28, java_lang_String, count);
	_JC_PRIM_FIELD(env, r23, java_lang_StringBuffer, count) = i9;
	i9 = _JC_PRIM_FIELD(env, r23, java_lang_StringBuffer, count);
	i9 = i9 + 16;
	r29 = _JC_NEW_PRIM_ARRAY(env, char, 1, i9);
	_JC_REF_FIELD(env, r23, java_lang_StringBuffer, value) = r29;
	i9 = _JC_PRIM_FIELD(env, r23, java_lang_StringBuffer, count);
	r29 = _JC_REF_FIELD(env, r23, java_lang_StringBuffer, value);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, getChars$c684dea7317ff063, 0, r28, 0, i9, r29, 0);
	r25 = _JC_INVOKE_STATIC(env, java_lang_Integer, toString$80d919d12afaaa2b, 0, 0, 10);
	r24 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r23, r25);
	_JC_EXPLICIT_NULL_CHECK(env, r24);
	r26 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r26, r24);
	_JC_REF_FIELD(env, r21, java_lang_Throwable, cause) = r21;
	r27 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r21);
	_JC_REF_FIELD(env, r21, java_lang_Throwable, vmState) = r27;
	_JC_REF_FIELD(env, r21, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r21, java_lang_Throwable, detailMessage) = r26;
	_JC_THROW(env, r21);

label6:
	r22 = _JC_REF_FIELD(env, r4, java_lang_String, value);
	i7 = _JC_PRIM_FIELD(env, r4, java_lang_String, offset);
	i7 = i7 + 0;
	c8 = _JC_PRIM_ELEMENT(env, char, r22, i7, 1, 1);
	_JC_LINE_NUMBER(99);				// 12
	if (c8 != 10)
		goto label7;
	_JC_LINE_NUMBER(100);				// 13
	i0 = 0;
	_JC_LINE_NUMBER(101);				// 14
	i1 = 0;

label7:
	i4 = _JC_PRIM_FIELD(env, r4, java_lang_String, count);
	_JC_LINE_NUMBER(103);				// 15
	i2 = i1 + i4;
	i2 = i2 + 1;
	if (i2 <= 78)
		goto label10;
	_JC_LINE_NUMBER(104);				// 16
	r7 = _JC_REF_FIELD(env, r0, polyglot_util_StdErrorQueue, err);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, println$f7d505993103eeac, r7);
	_JC_LINE_NUMBER(105);				// 17
	i1 = 0;

label8:
	if (i1 >= i0)
		goto label9;
	r7 = _JC_REF_FIELD(env, r0, polyglot_util_StdErrorQueue, err);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, print$21bdbb15afdbea95, r7, _JC_STRING(env, " "));
	i1 = i1 + 1;
	_JC_PERIODIC_CHECK(env);
	goto label8;

label9:
	_JC_LINE_NUMBER(106);				// 18
	i2 = i0;
	goto label11;

label10:
	_JC_LINE_NUMBER(109);				// 19
	r7 = _JC_REF_FIELD(env, r0, polyglot_util_StdErrorQueue, err);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, print$21bdbb15afdbea95, r7, _JC_STRING(env, " "));
	_JC_LINE_NUMBER(110);				// 20
	i2 = i1 + 1;

label11:
	_JC_LINE_NUMBER(113);				// 21
	r7 = _JC_REF_FIELD(env, r0, polyglot_util_StdErrorQueue, err);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, print$21bdbb15afdbea95, r7, r4);
	i5 = _JC_PRIM_FIELD(env, r4, java_lang_String, count);
	_JC_LINE_NUMBER(115);				// 22
	i1 = i2 + i5;
	_JC_PERIODIC_CHECK(env);
	goto label5;

label12:
	_JC_LINE_NUMBER(118);				// 23
	r7 = _JC_REF_FIELD(env, r0, polyglot_util_StdErrorQueue, err);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, println$f7d505993103eeac, r7);
	_JC_LINE_NUMBER(120);				// 24
	if (r3 == _JC_NULL)
		goto label13;
	_JC_LINE_NUMBER(121);				// 25
	_JC_INVOKE_NONVIRTUAL(env, polyglot_util_StdErrorQueue, showError$a610be56f126328c, 0, r0, r3);

label13:
	_JC_LINE_NUMBER(124);				// 26
	i2 = _JC_PRIM_FIELD(env, r0, polyglot_util_StdErrorQueue, errorCount);
	i1 = _JC_PRIM_FIELD(env, r0, polyglot_util_StdErrorQueue, limit);
	if (i2 < i1)
		goto label16;
	_JC_LINE_NUMBER(125);				// 27
	if (r3 == _JC_NULL)
		goto label14;
	r6 = _JC_NEW(env, java_lang_StringBuffer);
	r17 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r6, java_lang_StringBuffer, value) = r17;
	r8 = _JC_INVOKE_VIRTUAL(env, polyglot_util_Position, file$4a28a30360790222, r3);
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r6, r8);
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r6, _JC_STRING(env, ": "));
	r13 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r13, r6);
	r8 = r13;
	goto label15;

label14:
	r8 = _JC_STRING(env, "");

label15:
	_JC_LINE_NUMBER(126);				// 28
	r7 = _JC_REF_FIELD(env, r0, polyglot_util_StdErrorQueue, err);
	r6 = _JC_NEW(env, java_lang_StringBuffer);
	r18 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r6, java_lang_StringBuffer, value) = r18;
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r6, r8);
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r6, _JC_STRING(env, "Too many errors.  Aborting compilation."));
	r14 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r14, r6);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, println$f7dbc2aa0f0a9d4f, r7, r14);
	_JC_LINE_NUMBER(127);				// 29
	_JC_INVOKE_VIRTUAL(env, polyglot_util_StdErrorQueue, flush$9dedb7d85e88cf56, r0);
	_JC_LINE_NUMBER(128);				// 30
	r9 = _JC_NEW(env, polyglot_util_ErrorLimitError);
	r19 = _JC_NULL;
	_JC_REF_FIELD(env, r9, java_lang_Throwable, cause) = r9;
	r20 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r9);
	_JC_REF_FIELD(env, r9, java_lang_Throwable, vmState) = r20;
	_JC_REF_FIELD(env, r9, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r9, java_lang_Throwable, detailMessage) = r19;
	_JC_THROW(env, r9);

label16:
	_JC_LINE_NUMBER(130);				// 31
	return;
}

//
// public int errorCount()
//

static _jc_linenum _jc_polyglot_util_StdErrorQueue$linenum_table$errorCount$98b3ff3101b691a1[];

static const unsigned char _jc_polyglot_util_StdErrorQueue$param_ptypes$errorCount$98b3ff3101b691a1[] = { 
_JC_TYPE_INT };

_jc_method _jc_polyglot_util_StdErrorQueue$method_info$errorCount$98b3ff3101b691a1 = {
	.name=			"errorCount",
	.signature=		"()I",
	.class=			&_jc_polyglot_util_StdErrorQueue$type,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_polyglot_util_StdErrorQueue$param_ptypes$errorCount$98b3ff3101b691a1,
	.signature_hash=	_JC_JLONG(0x98b3ff3101b691a1),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_util_StdErrorQueue$method$errorCount$98b3ff3101b691a1,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_util_StdErrorQueue$vtable, polyglot_util_StdErrorQueue.errorCount$98b3ff3101b691a1) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_util_StdErrorQueue$linenum_table$errorCount$98b3ff3101b691a1
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_util_StdErrorQueue, errorCount$98b3ff3101b691a1);

jint _JC_JCNI_ATTR
_jc_polyglot_util_StdErrorQueue$method$errorCount$98b3ff3101b691a1(_jc_env *const env, _jc_polyglot_util_StdErrorQueue$object *this)
{
	jint i0;
	struct _jc_polyglot_util_StdErrorQueue$object *r0;

	r0 = this;
	_JC_LINE_NUMBER(195);				// 0
	i0 = _JC_PRIM_FIELD(env, r0, polyglot_util_StdErrorQueue, errorCount);
	return i0;
}

//
// public void flush()
//

static _jc_linenum _jc_polyglot_util_StdErrorQueue$linenum_table$flush$9dedb7d85e88cf56[];

static const unsigned char _jc_polyglot_util_StdErrorQueue$param_ptypes$flush$9dedb7d85e88cf56[] = { 
_JC_TYPE_VOID };

_jc_method _jc_polyglot_util_StdErrorQueue$method_info$flush$9dedb7d85e88cf56 = {
	.name=			"flush",
	.signature=		"()V",
	.class=			&_jc_polyglot_util_StdErrorQueue$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_util_StdErrorQueue$param_ptypes$flush$9dedb7d85e88cf56,
	.signature_hash=	_JC_JLONG(0x9dedb7d85e88cf56),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_util_StdErrorQueue$method$flush$9dedb7d85e88cf56,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_util_StdErrorQueue$vtable, polyglot_util_StdErrorQueue.flush$9dedb7d85e88cf56) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_polyglot_util_StdErrorQueue$linenum_table$flush$9dedb7d85e88cf56
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_util_StdErrorQueue, flush$9dedb7d85e88cf56);

void _JC_JCNI_ATTR
_jc_polyglot_util_StdErrorQueue$method$flush$9dedb7d85e88cf56(_jc_env *const env, _jc_polyglot_util_StdErrorQueue$object *this)
{
	jint i0;
	struct _jc_polyglot_util_StdErrorQueue$object *r0;
	struct _jc_java_lang_StringBuffer$object *r1;
	struct _jc_java_io_PrintStream$object *r2;
	struct _jc_java_lang_String$object *r3;
	struct _jc_java_lang_StringBuffer$object *r4;
	struct _jc_java_lang_String$object *r5;
	struct _jc_java_lang_String$object *r6;
	_jc_char_array *r7;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(181);				// 0
	z0 = _JC_PRIM_FIELD(env, r0, polyglot_util_StdErrorQueue, flushed);
	if (z0 != 0)
		goto label3;
	_JC_LINE_NUMBER(182);				// 1
	i0 = _JC_PRIM_FIELD(env, r0, polyglot_util_StdErrorQueue, errorCount);
	if (i0 <= 0)
		goto label2;
	_JC_LINE_NUMBER(183);				// 2
	r2 = _JC_REF_FIELD(env, r0, polyglot_util_StdErrorQueue, err);
	r1 = _JC_NEW(env, java_lang_StringBuffer);
	r7 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r1, java_lang_StringBuffer, value) = r7;
	i0 = _JC_PRIM_FIELD(env, r0, polyglot_util_StdErrorQueue, errorCount);
	_JC_ACTIVE_USE(env, java_lang_String);
	r5 = _JC_INVOKE_STATIC(env, java_lang_Integer, toString$80d919d12afaaa2b, 0, i0, 10);
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r1, r5);
	r1 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 1, r4, _JC_STRING(env, " error"));
	i0 = _JC_PRIM_FIELD(env, r0, polyglot_util_StdErrorQueue, errorCount);
	if (i0 <= 1)
		goto label0;
	r3 = _JC_STRING(env, "s.");
	goto label1;

label0:
	r3 = _JC_STRING(env, ".");

label1:
	r1 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 1, r1, r3);
	r6 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r6, r1);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, println$f7dbc2aa0f0a9d4f, r2, r6);

label2:
	_JC_LINE_NUMBER(186);				// 3
	_JC_PRIM_FIELD(env, r0, polyglot_util_StdErrorQueue, flushed) = 1;

label3:
	_JC_LINE_NUMBER(188);				// 4
	return;
}

//
// public boolean hasErrors()
//

static _jc_linenum _jc_polyglot_util_StdErrorQueue$linenum_table$hasErrors$fdfd8ea0f7f4aa6d[];

static const unsigned char _jc_polyglot_util_StdErrorQueue$param_ptypes$hasErrors$fdfd8ea0f7f4aa6d[] = { 
_JC_TYPE_BOOLEAN };

_jc_method _jc_polyglot_util_StdErrorQueue$method_info$hasErrors$fdfd8ea0f7f4aa6d = {
	.name=			"hasErrors",
	.signature=		"()Z",
	.class=			&_jc_polyglot_util_StdErrorQueue$type,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_polyglot_util_StdErrorQueue$param_ptypes$hasErrors$fdfd8ea0f7f4aa6d,
	.signature_hash=	_JC_JLONG(0xfdfd8ea0f7f4aa6d),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_util_StdErrorQueue$method$hasErrors$fdfd8ea0f7f4aa6d,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_util_StdErrorQueue$vtable, polyglot_util_StdErrorQueue.hasErrors$fdfd8ea0f7f4aa6d) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_util_StdErrorQueue$linenum_table$hasErrors$fdfd8ea0f7f4aa6d
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_util_StdErrorQueue, hasErrors$fdfd8ea0f7f4aa6d);

jboolean _JC_JCNI_ATTR
_jc_polyglot_util_StdErrorQueue$method$hasErrors$fdfd8ea0f7f4aa6d(_jc_env *const env, _jc_polyglot_util_StdErrorQueue$object *this)
{
	jint i0;
	struct _jc_polyglot_util_StdErrorQueue$object *r0;
	jboolean z0;

	r0 = this;
	_JC_LINE_NUMBER(191);				// 0
	i0 = _JC_PRIM_FIELD(env, r0, polyglot_util_StdErrorQueue, errorCount);
	if (i0 <= 0)
		goto label0;
	z0 = 1;
	goto label1;

label0:
	z0 = 0;

label1:
	return z0;
}

//
// protected java.io.Reader reader(polyglot.util.Position) throws java.io.IOException
//

static _jc_linenum _jc_polyglot_util_StdErrorQueue$linenum_table$reader$ab5a720003b971eb[];

static const unsigned char _jc_polyglot_util_StdErrorQueue$param_ptypes$reader$ab5a720003b971eb[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_util_StdErrorQueue$exceptions$reader$ab5a720003b971eb[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_polyglot_util_StdErrorQueue$param_types$reader$ab5a720003b971eb[] = {
	&_jc_polyglot_util_Position$type
};

_jc_method _jc_polyglot_util_StdErrorQueue$method_info$reader$ab5a720003b971eb = {
	.name=			"reader",
	.signature=		"(Lpolyglot/util/Position;)Ljava/io/Reader;",
	.class=			&_jc_polyglot_util_StdErrorQueue$type,
	.param_types=		&_jc_polyglot_util_StdErrorQueue$param_types$reader$ab5a720003b971eb,
	.return_type=		&_jc_java_io_Reader$type,
	.param_ptypes=		&_jc_polyglot_util_StdErrorQueue$param_ptypes$reader$ab5a720003b971eb,
	.signature_hash=	_JC_JLONG(0xab5a720003b971eb),
	.access_flags=		_JC_ACC_PROTECTED,
	.function=		&_jc_polyglot_util_StdErrorQueue$method$reader$ab5a720003b971eb,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_util_StdErrorQueue$vtable, polyglot_util_StdErrorQueue.reader$ab5a720003b971eb) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_util_StdErrorQueue$exceptions$reader$ab5a720003b971eb,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_polyglot_util_StdErrorQueue$linenum_table$reader$ab5a720003b971eb
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_util_StdErrorQueue, reader$ab5a720003b971eb);

_jc_java_io_Reader$object * _JC_JCNI_ATTR
_jc_polyglot_util_StdErrorQueue$method$reader$ab5a720003b971eb(_jc_env *const env, _jc_polyglot_util_StdErrorQueue$object *this, _jc_polyglot_util_Position$object *param0)
{
	jint i0;
	struct _jc_polyglot_util_StdErrorQueue$object *r0;
	struct _jc_polyglot_util_Position$object *r1;
	struct _jc_gnu_java_nio_channels_FileChannelImpl$object *r11;
	struct _jc_java_lang_String$object *r2;
	struct _jc_java_io_FileReader$object *r3;
	struct _jc_java_io_FileInputStream$object *r4;
	struct _jc_java_io_File$object *r5;
	struct _jc_java_lang_String$object *r6;
	struct _jc_java_lang_SecurityManager$object *r8;
	struct _jc_java_lang_String$object *r9;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(133);				// 0
	r2 = _JC_INVOKE_VIRTUAL(env, polyglot_util_Position, file$4a28a30360790222, r1);
	if (r2 == _JC_NULL)
		goto label1;
	i0 = _JC_INVOKE_VIRTUAL(env, polyglot_util_Position, line$cff1e597e2cfa9a2, r1);
	if (i0 == -1)
		goto label1;
	_JC_LINE_NUMBER(134);				// 1
	r3 = _JC_NEW(env, java_io_FileReader);
	r2 = _JC_INVOKE_VIRTUAL(env, polyglot_util_Position, file$4a28a30360790222, r1);
	r4 = _JC_NEW(env, java_io_FileInputStream);
	r5 = _JC_NEW(env, java_io_File);
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_io_File, normalizePath$c82ffbd1adfcec00, 0, r5, r2);
	_JC_REF_FIELD(env, r5, java_io_File, path) = r6;
	_JC_ACTIVE_USE(env, java_lang_System);
	r8 = _JC_STATIC_FIELD(env, java_lang_SecurityManager, current, 0);
	if (r8 == _JC_NULL)
		goto label0;
	r9 = _JC_REF_FIELD(env, r5, java_io_File, path);
	_JC_INVOKE_VIRTUAL(env, java_lang_SecurityManager, checkRead$b67431badfc045e6, r8, r9);

label0:
	_JC_ACTIVE_USE(env, gnu_java_nio_channels_FileChannelImpl);
	r11 = _JC_NEW(env, gnu_java_nio_channels_FileChannelImpl);
	_JC_INVOKE_NONVIRTUAL(env, gnu_java_nio_channels_FileChannelImpl, _init$ced0bc02a90e180e, 0, r11, r5, 1);
	_JC_REF_FIELD(env, r4, java_io_FileInputStream, ch) = r11;
	_JC_INVOKE_NONVIRTUAL(env, java_io_InputStreamReader, _init$3887600c17c5e554, 0, r3, r4);
	return r3;

label1:
	_JC_LINE_NUMBER(136);				// 2
	return _JC_NULL;
}

//
// private void showError(polyglot.util.Position)
//

static _jc_linenum _jc_polyglot_util_StdErrorQueue$linenum_table$showError$a610be56f126328c[];

static _jc_trap_info _jc_polyglot_util_StdErrorQueue$trap_table$showError$a610be56f126328c[] = {
	_JC_TRAP(&_jc_java_io_IOException$type, 1, 2),
	_JC_TRAP(&_jc_java_io_IOException$type, 3, 4),
};

static const unsigned char _jc_polyglot_util_StdErrorQueue$param_ptypes$showError$a610be56f126328c[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_util_StdErrorQueue$param_types$showError$a610be56f126328c[] = {
	&_jc_polyglot_util_Position$type
};

_jc_method _jc_polyglot_util_StdErrorQueue$method_info$showError$a610be56f126328c = {
	.name=			"showError",
	.signature=		"(Lpolyglot/util/Position;)V",
	.class=			&_jc_polyglot_util_StdErrorQueue$type,
	.param_types=		&_jc_polyglot_util_StdErrorQueue$param_types$showError$a610be56f126328c,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_util_StdErrorQueue$param_ptypes$showError$a610be56f126328c,
	.signature_hash=	_JC_JLONG(0xa610be56f126328c),
	.access_flags=		_JC_ACC_PRIVATE,
	.function=		&_jc_polyglot_util_StdErrorQueue$method$showError$a610be56f126328c,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_util_StdErrorQueue$vtable, polyglot_util_StdErrorQueue.showError$a610be56f126328c) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .trap_table_len=	2,
	  .trap_table=		_jc_polyglot_util_StdErrorQueue$trap_table$showError$a610be56f126328c,
	  .u= {
	    .linenum= {
	      .len=	21,
	      .table=	_jc_polyglot_util_StdErrorQueue$linenum_table$showError$a610be56f126328c
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_util_StdErrorQueue, showError$a610be56f126328c);

void _JC_JCNI_ATTR
_jc_polyglot_util_StdErrorQueue$method$showError$a610be56f126328c(_jc_env *const env, _jc_polyglot_util_StdErrorQueue$object *this, _jc_polyglot_util_Position$object *param0)
{
	jchar c4;
	jint i0;
	jint i1;
	jint i2;
	jint i3;
	jint i5;
	struct _jc_polyglot_util_StdErrorQueue$object *r0;
	struct _jc_polyglot_util_Position$object *r1;
	struct _jc_java_lang_StringBuffer$object *r10;
	struct _jc_java_lang_String$object *r11;
	struct _jc_java_lang_String$object *r12;
	struct _jc_java_lang_VMThrowable$object *r13;
	struct _jc_java_lang_String$object *r14;
	_jc_char_array *r15;
	struct _jc_java_io_Reader$object *r2;
	struct _jc_java_io_LineNumberReader$object *r3;
	struct _jc_java_lang_String$object *r4;
	struct _jc_java_io_PrintStream$object *r5;
	struct _jc_java_io_IOException$object *r6;
	struct _jc_java_lang_StringIndexOutOfBoundsException$object *r7;
	_jc_char_array *r8;
	struct _jc_java_lang_StringBuffer$object *r9;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_polyglot_util_StdErrorQueue$method_info$showError$a610be56f126328c, &&label10, &&label10);

	r0 = this;
	r1 = param0;
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(141);				// 0
	r2 = _JC_INVOKE_VIRTUAL(env, polyglot_util_StdErrorQueue, reader$ab5a720003b971eb, r0, r1);
	_JC_LINE_NUMBER(143);				// 1
	if (r2 != _JC_NULL)
		goto label0;
	_JC_TRAP_REGION(catch, 2);
	_JC_LINE_NUMBER(144);				// 2
	_JC_CANCEL_TRAPS(env, catch);
	return;

label0:
	_JC_TRAP_REGION(catch, 3);
	_JC_LINE_NUMBER(147);				// 3
	r3 = _JC_NEW(env, java_io_LineNumberReader);
	_JC_INVOKE_NONVIRTUAL(env, java_io_BufferedReader, _init$92676f6e85ad07a2, 0, r3, r2, 8192);
	_JC_LINE_NUMBER(149);				// 4
	r4 = _JC_NULL;
	_JC_LINE_NUMBER(151);				// 5
	i0 = 0;

label1:
	i1 = _JC_INVOKE_VIRTUAL(env, polyglot_util_Position, line$cff1e597e2cfa9a2, r1);
	if (i0 >= i1)
		goto label2;
	_JC_LINE_NUMBER(152);				// 6
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_io_LineNumberReader, readLine$d32396e6ff161651, 0, r3);
	_JC_LINE_NUMBER(151);				// 7
	i0 = i0 + 1;
	_JC_PERIODIC_CHECK(env);
	goto label1;

label2:
	_JC_LINE_NUMBER(155);				// 8
	_JC_INVOKE_NONVIRTUAL(env, java_io_BufferedReader, close$6aba8b329fddcd79, 0, r3);
	_JC_LINE_NUMBER(157);				// 9
	if (r4 == _JC_NULL)
		goto label11;
	_JC_LINE_NUMBER(158);				// 10
	r5 = _JC_REF_FIELD(env, r0, polyglot_util_StdErrorQueue, err);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, println$f7dbc2aa0f0a9d4f, r5, r4);
	_JC_LINE_NUMBER(160);				// 11
	i1 = _JC_INVOKE_VIRTUAL(env, polyglot_util_Position, column$370206cd3cb25d90, r1);
	if (i1 == -1)
		goto label9;
	_JC_LINE_NUMBER(161);				// 12
	i1 = 0;

label3:
	i0 = _JC_INVOKE_VIRTUAL(env, polyglot_util_Position, column$370206cd3cb25d90, r1);
	if (i1 >= i0)
		goto label8;
	i2 = i1;
	if (i1 < 0)
		goto label4;
	i3 = _JC_PRIM_FIELD(env, r4, java_lang_String, count);
	if (i1 < i3)
		goto label5;

label4:
	r7 = _JC_NEW(env, java_lang_StringIndexOutOfBoundsException);
	r9 = _JC_NEW(env, java_lang_StringBuffer);
	r14 = _JC_STRING(env, "String index out of range: ");
	i5 = _JC_PRIM_FIELD(env, r14, java_lang_String, count);
	_JC_PRIM_FIELD(env, r9, java_lang_StringBuffer, count) = i5;
	i5 = _JC_PRIM_FIELD(env, r9, java_lang_StringBuffer, count);
	i5 = i5 + 16;
	r15 = _JC_NEW_PRIM_ARRAY(env, char, 1, i5);
	_JC_REF_FIELD(env, r9, java_lang_StringBuffer, value) = r15;
	i5 = _JC_PRIM_FIELD(env, r9, java_lang_StringBuffer, count);
	r15 = _JC_REF_FIELD(env, r9, java_lang_StringBuffer, value);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, getChars$c684dea7317ff063, 0, r14, 0, i5, r15, 0);
	r11 = _JC_INVOKE_STATIC(env, java_lang_Integer, toString$80d919d12afaaa2b, 0, i2, 10);
	r10 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r9, r11);
	_JC_EXPLICIT_NULL_CHECK(env, r10);
	r12 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r12, r10);
	_JC_REF_FIELD(env, r7, java_lang_Throwable, cause) = r7;
	r13 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r7);
	_JC_REF_FIELD(env, r7, java_lang_Throwable, vmState) = r13;
	_JC_REF_FIELD(env, r7, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r7, java_lang_Throwable, detailMessage) = r12;
	_JC_THROW(env, r7);

label5:
	r8 = _JC_REF_FIELD(env, r4, java_lang_String, value);
	i3 = _JC_PRIM_FIELD(env, r4, java_lang_String, offset);
	i3 = i3 + i1;
	c4 = _JC_PRIM_ELEMENT(env, char, r8, i3, 1, 1);
	_JC_LINE_NUMBER(162);				// 13
	if (c4 != 9)
		goto label6;
	_JC_LINE_NUMBER(163);				// 14
	r5 = _JC_REF_FIELD(env, r0, polyglot_util_StdErrorQueue, err);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, print$21bdbb15afdbea95, r5, _JC_STRING(env, "\t"));
	goto label7;

label6:
	_JC_LINE_NUMBER(166);				// 15
	r5 = _JC_REF_FIELD(env, r0, polyglot_util_StdErrorQueue, err);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, print$21bdbb15afdbea95, r5, _JC_STRING(env, " "));

label7:
	_JC_LINE_NUMBER(161);				// 16
	i1 = i1 + 1;
	_JC_PERIODIC_CHECK(env);
	goto label3;

label8:
	_JC_LINE_NUMBER(170);				// 17
	r5 = _JC_REF_FIELD(env, r0, polyglot_util_StdErrorQueue, err);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, println$f7dbc2aa0f0a9d4f, r5, _JC_STRING(env, "^"));

label9:
	_JC_LINE_NUMBER(173);				// 18
	r5 = _JC_REF_FIELD(env, r0, polyglot_util_StdErrorQueue, err);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, println$f7d505993103eeac, r5);
	_JC_TRAP_REGION(catch, 4);
	_JC_LINE_NUMBER(177);				// 19
	goto label11;

label10:
	_JC_TRAP_REGION(catch, 4);
	r6 = _JC_CAUGHT_EXCEPTION(env);

label11:
	_JC_TRAP_REGION(catch, 4);
	_JC_LINE_NUMBER(178);				// 20
	_JC_CANCEL_TRAPS(env, catch);
	return;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_polyglot_util_StdErrorQueue$methods[] = {
	&_jc_polyglot_util_StdErrorQueue$method_info$_init$7d5386038d104f5d,
	&_jc_polyglot_util_StdErrorQueue$method_info$enqueue$7659161d8f442ddb,
	&_jc_polyglot_util_StdErrorQueue$method_info$enqueue$82679af4bd898d46,
	&_jc_polyglot_util_StdErrorQueue$method_info$enqueue$a8bd5ecfa883f67a,
	&_jc_polyglot_util_StdErrorQueue$method_info$errorCount$98b3ff3101b691a1,
	&_jc_polyglot_util_StdErrorQueue$method_info$flush$9dedb7d85e88cf56,
	&_jc_polyglot_util_StdErrorQueue$method_info$hasErrors$fdfd8ea0f7f4aa6d,
	&_jc_polyglot_util_StdErrorQueue$method_info$reader$ab5a720003b971eb,
	&_jc_polyglot_util_StdErrorQueue$method_info$showError$a610be56f126328c
};

/************************************************************************
 *			      Interface list				*
 ************************************************************************/

// Directly implemented interfaces
static _jc_type *const _jc_polyglot_util_StdErrorQueue$interfaces[] = {
	&_jc_polyglot_util_ErrorQueue$type
};

/************************************************************************
 *			   Interface hash table				*
 ************************************************************************/

#if _JC_IMETHOD_HASHSIZE != 128
#error "_JC_IMETHOD_HASHSIZE has the wrong value (should be 128)"
#endif

// Interface lookup hash table buckets
static _jc_method *_jc_polyglot_util_StdErrorQueue$imethod_hash_bucket_33[] = {
	&_jc_polyglot_util_StdErrorQueue$method_info$errorCount$98b3ff3101b691a1,
	_JC_NULL
};
static _jc_method *_jc_polyglot_util_StdErrorQueue$imethod_hash_bucket_70[] = {
	&_jc_polyglot_util_StdErrorQueue$method_info$enqueue$82679af4bd898d46,
	_JC_NULL
};
static _jc_method *_jc_polyglot_util_StdErrorQueue$imethod_hash_bucket_86[] = {
	&_jc_polyglot_util_StdErrorQueue$method_info$flush$9dedb7d85e88cf56,
	_JC_NULL
};
static _jc_method *_jc_polyglot_util_StdErrorQueue$imethod_hash_bucket_91[] = {
	&_jc_polyglot_util_StdErrorQueue$method_info$enqueue$7659161d8f442ddb,
	_JC_NULL
};
static _jc_method *_jc_polyglot_util_StdErrorQueue$imethod_hash_bucket_109[] = {
	&_jc_polyglot_util_StdErrorQueue$method_info$hasErrors$fdfd8ea0f7f4aa6d,
	_JC_NULL
};
static _jc_method *_jc_polyglot_util_StdErrorQueue$imethod_hash_bucket_122[] = {
	&_jc_polyglot_util_StdErrorQueue$method_info$enqueue$a8bd5ecfa883f67a,
	_JC_NULL
};

// Interface lookup hash table
static _jc_method **_jc_polyglot_util_StdErrorQueue$imethod_hash_table[_JC_IMETHOD_HASHSIZE] = {
	[33]=	_jc_polyglot_util_StdErrorQueue$imethod_hash_bucket_33,
	[70]=	_jc_polyglot_util_StdErrorQueue$imethod_hash_bucket_70,
	[86]=	_jc_polyglot_util_StdErrorQueue$imethod_hash_bucket_86,
	[91]=	_jc_polyglot_util_StdErrorQueue$imethod_hash_bucket_91,
	[109]=	_jc_polyglot_util_StdErrorQueue$imethod_hash_bucket_109,
	[122]=	_jc_polyglot_util_StdErrorQueue$imethod_hash_bucket_122
};

// Interface "quick" lookup hash table
static const void *_jc_polyglot_util_StdErrorQueue$imethod_quick_table[_JC_IMETHOD_HASHSIZE] = {
	[33]=	&_jc_polyglot_util_StdErrorQueue$method$errorCount$98b3ff3101b691a1,
	[70]=	&_jc_polyglot_util_StdErrorQueue$method$enqueue$82679af4bd898d46,
	[86]=	&_jc_polyglot_util_StdErrorQueue$method$flush$9dedb7d85e88cf56,
	[91]=	&_jc_polyglot_util_StdErrorQueue$method$enqueue$7659161d8f442ddb,
	[109]=	&_jc_polyglot_util_StdErrorQueue$method$hasErrors$fdfd8ea0f7f4aa6d,
	[122]=	&_jc_polyglot_util_StdErrorQueue$method$enqueue$a8bd5ecfa883f67a
};

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_polyglot_util_StdErrorQueue$instanceof_hash_bucket_37[] = {
	&_jc_polyglot_util_StdErrorQueue$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_util_StdErrorQueue$instanceof_hash_bucket_64[] = {
	&_jc_polyglot_util_ErrorQueue$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_util_StdErrorQueue$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_polyglot_util_StdErrorQueue$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[37]=	_jc_polyglot_util_StdErrorQueue$instanceof_hash_bucket_37,
	[64]=	_jc_polyglot_util_StdErrorQueue$instanceof_hash_bucket_64,
	[101]=	_jc_polyglot_util_StdErrorQueue$instanceof_hash_bucket_101
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_polyglot_util_StdErrorQueue$class_depends[] = {
	{ "gnu/java/nio/channels/FileChannelImpl",	_JC_JLONG(0x5fe9816daa9bdb2b) },
	{ "java/io/BufferedReader",	_JC_JLONG(0x2f32f9b77402a730) },
	{ "java/io/File",	_JC_JLONG(0x9cef6b66128b04b2) },
	{ "java/io/FileInputStream",	_JC_JLONG(0xc9cb932278ec6eea) },
	{ "java/io/FileReader",	_JC_JLONG(0x42380f6d5e9ae354) },
	{ "java/io/IOException",	_JC_JLONG(0x4e0a56550c69d57c) },
	{ "java/io/InputStream",	_JC_JLONG(0x66aea4d152614ac4) },
	{ "java/io/InputStreamReader",	_JC_JLONG(0x30159d8092563292) },
	{ "java/io/LineNumberReader",	_JC_JLONG(0x86bd8cdd2cb89429) },
	{ "java/io/PrintStream",	_JC_JLONG(0x99a46305ebacacb5) },
	{ "java/io/Reader",	_JC_JLONG(0x688afb20bd4c4e01) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/IndexOutOfBoundsException",	_JC_JLONG(0x3cdfed1e0ad1a3d6) },
	{ "java/lang/Integer",	_JC_JLONG(0xca631501391a31f1) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/RuntimeException",	_JC_JLONG(0x4f5534a987354d1d) },
	{ "java/lang/SecurityManager",	_JC_JLONG(0xd38282f3d5f80887) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/StringBuffer",	_JC_JLONG(0x94d357637b968dda) },
	{ "java/lang/StringIndexOutOfBoundsException",	_JC_JLONG(0xbb7f6fdd2bd0e6b2) },
	{ "java/lang/System",	_JC_JLONG(0x53cc8e2333795f04) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/util/StringTokenizer",	_JC_JLONG(0xb106445ca218ee16) },
	{ "polyglot/util/ErrorInfo",	_JC_JLONG(0x1b61c050315c20e6) },
	{ "polyglot/util/ErrorLimitError",	_JC_JLONG(0x346d846eb3bf9fe4) },
	{ "polyglot/util/ErrorQueue",	_JC_JLONG(0xff712c8463bdfdc0) },
	{ "polyglot/util/Position",	_JC_JLONG(0x32c9a088c5dac046) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_polyglot_util_StdErrorQueue$vtype _jc_polyglot_util_StdErrorQueue$type = {
    .type= {
	.name=			"polyglot/util/StdErrorQueue",
	.superclass=		&_jc_java_lang_Object$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.num_interfaces=sizeof(_jc_polyglot_util_StdErrorQueue$interfaces) / sizeof(*_jc_polyglot_util_StdErrorQueue$interfaces),
	.interfaces=		_jc_polyglot_util_StdErrorQueue$interfaces,
	.imethod_hash_table=	_jc_polyglot_util_StdErrorQueue$imethod_hash_table,
	.imethod_quick_table=	_jc_polyglot_util_StdErrorQueue$imethod_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		19,
		.hash=			_JC_JLONG(0xb9dc549f1c7c5c25),
		.source_file=		"StdErrorQueue.java",
		.instance_size=		sizeof(_jc_polyglot_util_StdErrorQueue$refs) + sizeof(_jc_polyglot_util_StdErrorQueue$object),
		.num_virtual_refs=	2,
		.num_fields=		sizeof(_jc_polyglot_util_StdErrorQueue$fields) / sizeof(*_jc_polyglot_util_StdErrorQueue$fields),
		.fields=		_jc_polyglot_util_StdErrorQueue$fields,
		.num_methods=		sizeof(_jc_polyglot_util_StdErrorQueue$methods) / sizeof(*_jc_polyglot_util_StdErrorQueue$methods),
		.methods=		_jc_polyglot_util_StdErrorQueue$methods,
		.instanceof_hash_table=	_jc_polyglot_util_StdErrorQueue$instanceof_hash_table,
		.num_class_depends=		sizeof(_jc_polyglot_util_StdErrorQueue$class_depends) / sizeof(*_jc_polyglot_util_StdErrorQueue$class_depends),
		.class_depends=		_jc_polyglot_util_StdErrorQueue$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.polyglot_util_StdErrorQueue= {
	    .enqueue$7659161d8f442ddb=
		&_jc_polyglot_util_StdErrorQueue$method$enqueue$7659161d8f442ddb,
	    .enqueue$82679af4bd898d46=
		&_jc_polyglot_util_StdErrorQueue$method$enqueue$82679af4bd898d46,
	    .enqueue$a8bd5ecfa883f67a=
		&_jc_polyglot_util_StdErrorQueue$method$enqueue$a8bd5ecfa883f67a,
	    .errorCount$98b3ff3101b691a1=
		&_jc_polyglot_util_StdErrorQueue$method$errorCount$98b3ff3101b691a1,
	    .flush$9dedb7d85e88cf56=
		&_jc_polyglot_util_StdErrorQueue$method$flush$9dedb7d85e88cf56,
	    .hasErrors$fdfd8ea0f7f4aa6d=
		&_jc_polyglot_util_StdErrorQueue$method$hasErrors$fdfd8ea0f7f4aa6d,
	    .reader$ab5a720003b971eb=
		&_jc_polyglot_util_StdErrorQueue$method$reader$ab5a720003b971eb,
	    .showError$a610be56f126328c=
		&_jc_polyglot_util_StdErrorQueue$method$showError$a610be56f126328c,
	},
    }
};

