// public class polyglot.util.TypedList

// class file dependencies
// @dep_class 9a35c7173b37e641 java_io_Serializable
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class 680cf34d05feb5a1 java_lang_IllegalArgumentException
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class 4f5534a987354d1d java_lang_RuntimeException
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 94d357637b968dda java_lang_StringBuffer
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class c4b275d49bb21d98 java_lang_UnsupportedOperationException
// @dep_class 238a2c0aafd74314 java_lang_VMClass
// @dep_class 312e45ed214d432f java_lang_VMObject
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class 8ea716c64b77f8eb java_util_AbstractCollection
// @dep_class f5238436362828db java_util_AbstractList
// @dep_class 58038509830ef3f4 java_util_ArrayList
// @dep_class eae4d0c0e8eb63da java_util_Collection
// @dep_class be56ff673eefd9d2 java_util_Iterator
// @dep_class 9ee0d92ce1525a4d java_util_List
// @dep_class 9842856e8b4dbb java_util_ListIterator
// @dep_class 8ddf0f1b6db92e92 polyglot_util_TypedList
// @dep_class 17638e1377601085 polyglot_util_TypedListIterator

// header file dependencies
// @dep_header java_io_Serializable
// @dep_header java_lang_Class
// @dep_header java_lang_IllegalArgumentException
// @dep_header java_lang_String
// @dep_header java_lang_StringBuffer
// @dep_header java_lang_UnsupportedOperationException
// @dep_header java_lang_VMClass
// @dep_header java_lang_VMObject
// @dep_header java_lang_VMThrowable
// @dep_header java_util_ArrayList
// @dep_header java_util_Collection
// @dep_header java_util_Iterator
// @dep_header java_util_List
// @dep_header java_util_ListIterator
// @dep_header polyglot_util_TypedList
// @dep_header polyglot_util_TypedListIterator

#include "jc_defs.h"

#include "java/io/Serializable.h"
#include "java/lang/Class.h"
#include "java/lang/IllegalArgumentException.h"
#include "java/lang/String.h"
#include "java/lang/StringBuffer.h"
#include "java/lang/UnsupportedOperationException.h"
#include "java/lang/VMClass.h"
#include "java/lang/VMObject.h"
#include "java/lang/VMThrowable.h"
#include "java/util/ArrayList.h"
#include "java/util/Collection.h"
#include "java/util/Iterator.h"
#include "java/util/List.h"
#include "java/util/ListIterator.h"
#include "polyglot/util/TypedList.h"
#include "polyglot/util/TypedListIterator.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// static final long serialVersionUID
static const jlong _jc_polyglot_util_TypedList$initial_value$serialVersionUID = _JC_JLONG(-1390984392613203018);
static _jc_field _jc_polyglot_util_TypedList$field_info$serialVersionUID = {
	.name=		"serialVersionUID",
	.signature=	"J",
	.class=		&_jc_polyglot_util_TypedList$type,
	.type=		&_jc_long$prim$type,
	.access_flags=	_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_polyglot_util_TypedList$fields_struct, serialVersionUID),
	.initial_value=	&_jc_polyglot_util_TypedList$initial_value$serialVersionUID,
};

// private java.lang.Class allowed_type
static _jc_field _jc_polyglot_util_TypedList$field_info$allowed__5ftype = {
	.name=		"allowed_type",
	.signature=	"Ljava/lang/Class;",
	.class=		&_jc_polyglot_util_TypedList$type,
	.type=		&_jc_java_lang_Class$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_polyglot_util_TypedList$object, refs[-1].polyglot_util_TypedList.allowed__5ftype),
};

// private boolean immutable
static _jc_field _jc_polyglot_util_TypedList$field_info$immutable = {
	.name=		"immutable",
	.signature=	"Z",
	.class=		&_jc_polyglot_util_TypedList$type,
	.type=		&_jc_boolean$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_polyglot_util_TypedList$object, nonrefs.polyglot_util_TypedList.immutable),
};

// private java.util.List backing_list
static _jc_field _jc_polyglot_util_TypedList$field_info$backing__5flist = {
	.name=		"backing_list",
	.signature=	"Ljava/util/List;",
	.class=		&_jc_polyglot_util_TypedList$type,
	.type=		&_jc_java_util_List$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_polyglot_util_TypedList$object, refs[-1].polyglot_util_TypedList.backing__5flist),
};

// Fields
static _jc_field *const _jc_polyglot_util_TypedList$fields[] = {
	&_jc_polyglot_util_TypedList$field_info$serialVersionUID,
	&_jc_polyglot_util_TypedList$field_info$allowed__5ftype,
	&_jc_polyglot_util_TypedList$field_info$backing__5flist,
	&_jc_polyglot_util_TypedList$field_info$immutable
};

/************************************************************************
 *			      Static methods				*
 ************************************************************************/

//
// public static void check(java.util.List, java.lang.Class)
//

static _jc_linenum _jc_polyglot_util_TypedList$linenum_table$check$0be7ab6614c62cd9[];

static const unsigned char _jc_polyglot_util_TypedList$param_ptypes$check$0be7ab6614c62cd9[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_util_TypedList$param_types$check$0be7ab6614c62cd9[] = {
	&_jc_java_util_List$type,
	&_jc_java_lang_Class$type
};

_jc_method _jc_polyglot_util_TypedList$method_info$check$0be7ab6614c62cd9 = {
	.name=			"check",
	.signature=		"(Ljava/util/List;Ljava/lang/Class;)V",
	.class=			&_jc_polyglot_util_TypedList$type,
	.param_types=		&_jc_polyglot_util_TypedList$param_types$check$0be7ab6614c62cd9,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_util_TypedList$param_ptypes$check$0be7ab6614c62cd9,
	.signature_hash=	_JC_JLONG(0xbe7ab6614c62cd9),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_polyglot_util_TypedList$method$check$0be7ab6614c62cd9,
	.num_parameters=	2,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_polyglot_util_TypedList$linenum_table$check$0be7ab6614c62cd9
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_util_TypedList, check$0be7ab6614c62cd9);

void _JC_JCNI_ATTR
_jc_polyglot_util_TypedList$method$check$0be7ab6614c62cd9(_jc_env *const env, _jc_object *param0, _jc_java_lang_Class$object *param1)
{
	struct _jc_object *r0;
	struct _jc_java_lang_Class$object *r1;
	struct _jc_java_lang_String$object *r10;
	_jc_char_array *r11;
	struct _jc_java_lang_VMThrowable$object *r13;
	struct _jc_object *r2;
	struct _jc_java_lang_Object$object *r3;
	struct _jc_java_lang_StringBuffer$object *r4;
	struct _jc_java_lang_UnsupportedOperationException$object *r5;
	struct _jc_java_lang_Class$object *r6;
	struct _jc_java_lang_Class$object *r7;
	struct _jc_java_lang_String$object *r8;
	struct _jc_java_lang_String$object *r9;
	jboolean z0;
	jboolean z1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = param0;
	r1 = param1;
	_JC_LINE_NUMBER(65);				// 0
	r2 = _JC_INVOKE_INTERFACE(env, r0, _JC_JLONG(0x3cc91493d50f531c), _jc_object *, (_jc_env *, struct _jc_object *));

label0:
	z0 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0xfb0bd5e38c59ddcd), jboolean, (_jc_env *, struct _jc_object *));
	if (z0 == 0)
		goto label1;
	_JC_LINE_NUMBER(66);				// 1
	r3 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0x5874f79a1cf66ea), _jc_object *, (_jc_env *, struct _jc_object *));
	_JC_EXPLICIT_NULL_CHECK(env, r3);
	r6 = _JC_INVOKE_STATIC(env, java_lang_VMObject, getClass$2be11d215bfbfbfe, 0, r3);
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	z1 = _JC_INVOKE_STATIC(env, java_lang_VMClass, isAssignableFrom$c49c4ad8938bda0b, 0, r1, r6);
	_JC_LINE_NUMBER(67);				// 2
	if (z1 != 0) {
		_JC_PERIODIC_CHECK(env);
		goto label0;
	}
	_JC_LINE_NUMBER(68);				// 3
	r5 = _JC_NEW(env, java_lang_UnsupportedOperationException);
	r4 = _JC_NEW(env, java_lang_StringBuffer);
	r11 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r4, java_lang_StringBuffer, value) = r11;
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, _JC_STRING(env, "Tried to add a "));
	r7 = _JC_INVOKE_STATIC(env, java_lang_VMObject, getClass$2be11d215bfbfbfe, 1, r3);
	_JC_EXPLICIT_NULL_CHECK(env, r7);
	r8 = _JC_INVOKE_STATIC(env, java_lang_VMClass, getName$7a04fe8e1a654d36, 1, r7);
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, r8);
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, _JC_STRING(env, " to a list of type "));
	r9 = _JC_INVOKE_STATIC(env, java_lang_VMClass, getName$7a04fe8e1a654d36, 1, r1);
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, r9);
	r10 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r10, r4);
	_JC_REF_FIELD(env, r5, java_lang_Throwable, cause) = r5;
	r13 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r5);
	_JC_REF_FIELD(env, r5, java_lang_Throwable, vmState) = r13;
	_JC_REF_FIELD(env, r5, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r5, java_lang_Throwable, detailMessage) = r10;
	_JC_THROW(env, r5);

label1:
	_JC_LINE_NUMBER(73);				// 4
	return;
}

//
// public static polyglot.util.TypedList copy(java.util.List, java.lang.Class, boolean)
//

static _jc_linenum _jc_polyglot_util_TypedList$linenum_table$copy$71a2e8e56d8c3e66[];

static const unsigned char _jc_polyglot_util_TypedList$param_ptypes$copy$71a2e8e56d8c3e66[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_util_TypedList$param_types$copy$71a2e8e56d8c3e66[] = {
	&_jc_java_util_List$type,
	&_jc_java_lang_Class$type,
	&_jc_boolean$prim$type
};

_jc_method _jc_polyglot_util_TypedList$method_info$copy$71a2e8e56d8c3e66 = {
	.name=			"copy",
	.signature=		"(Ljava/util/List;Ljava/lang/Class;Z)Lpolyglot/util/TypedList;",
	.class=			&_jc_polyglot_util_TypedList$type,
	.param_types=		&_jc_polyglot_util_TypedList$param_types$copy$71a2e8e56d8c3e66,
	.return_type=		&_jc_polyglot_util_TypedList$type,
	.param_ptypes=		&_jc_polyglot_util_TypedList$param_ptypes$copy$71a2e8e56d8c3e66,
	.signature_hash=	_JC_JLONG(0x71a2e8e56d8c3e66),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_polyglot_util_TypedList$method$copy$71a2e8e56d8c3e66,
	.num_parameters=	3,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_util_TypedList$linenum_table$copy$71a2e8e56d8c3e66
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_util_TypedList, copy$71a2e8e56d8c3e66);

_jc_polyglot_util_TypedList$object * _JC_JCNI_ATTR
_jc_polyglot_util_TypedList$method$copy$71a2e8e56d8c3e66(_jc_env *const env, _jc_object *param0, _jc_java_lang_Class$object *param1, jboolean param2)
{
	jfloat f0;
	jint i0;
	jint i1;
	struct _jc_object *r0;
	struct _jc_java_lang_Class$object *r1;
	struct _jc_polyglot_util_TypedList$object *r2;
	struct _jc_java_util_ArrayList$object *r3;
	struct _jc_java_lang_IllegalArgumentException$object *r4;
	_jc_object_array *r5;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = param0;
	r1 = param1;
	z0 = param2;
	_JC_LINE_NUMBER(42);				// 0
	r2 = _JC_NEW(env, polyglot_util_TypedList);
	r3 = _JC_NEW(env, java_util_ArrayList);
	i0 = _JC_INVOKE_INTERFACE(env, r0, _JC_JLONG(0x345df5220fc60ade), jint, (_jc_env *, struct _jc_object *));
	f0 = (jfloat)i0;
	f0 = f0 * _JC_FCONST(0x3f, 0x8c, 0xcc, 0xcd);
	i0 = _JC_CAST_FLT2INT(env, jfloat, jint, f0);
	if (i0 >= 0)
		goto label0;
	r4 = _JC_NEW(env, java_lang_IllegalArgumentException);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_Throwable, _init$c31b894660454d13, 0, r4, _JC_NULL);
	_JC_THROW(env, r4);

label0:
	r5 = _JC_NEW_REF_ARRAY(env, java_lang_Object, 1, i0);
	_JC_REF_FIELD(env, r3, java_util_ArrayList, data) = r5;
	i1 = _JC_PRIM_FIELD(env, r3, java_util_ArrayList, size);
	_JC_INVOKE_NONVIRTUAL(env, java_util_ArrayList, addAll$28b94b9c09be8eeb, 0, r3, i1, r0);
	_JC_PRIM_FIELD(env, r2, polyglot_util_TypedList, immutable) = z0;
	_JC_REF_FIELD(env, r2, polyglot_util_TypedList, allowed__5ftype) = r1;
	_JC_REF_FIELD(env, r2, polyglot_util_TypedList, backing__5flist) = r3;
	return r2;
}

//
// public static polyglot.util.TypedList copyAndCheck(java.util.List, java.lang.Class, boolean)
//

static _jc_linenum _jc_polyglot_util_TypedList$linenum_table$copyAndCheck$1016e6b265d21143[];

static const unsigned char _jc_polyglot_util_TypedList$param_ptypes$copyAndCheck$1016e6b265d21143[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_util_TypedList$param_types$copyAndCheck$1016e6b265d21143[] = {
	&_jc_java_util_List$type,
	&_jc_java_lang_Class$type,
	&_jc_boolean$prim$type
};

_jc_method _jc_polyglot_util_TypedList$method_info$copyAndCheck$1016e6b265d21143 = {
	.name=			"copyAndCheck",
	.signature=		"(Ljava/util/List;Ljava/lang/Class;Z)Lpolyglot/util/TypedList;",
	.class=			&_jc_polyglot_util_TypedList$type,
	.param_types=		&_jc_polyglot_util_TypedList$param_types$copyAndCheck$1016e6b265d21143,
	.return_type=		&_jc_polyglot_util_TypedList$type,
	.param_ptypes=		&_jc_polyglot_util_TypedList$param_ptypes$copyAndCheck$1016e6b265d21143,
	.signature_hash=	_JC_JLONG(0x1016e6b265d21143),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_polyglot_util_TypedList$method$copyAndCheck$1016e6b265d21143,
	.num_parameters=	3,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_polyglot_util_TypedList$linenum_table$copyAndCheck$1016e6b265d21143
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_util_TypedList, copyAndCheck$1016e6b265d21143);

_jc_polyglot_util_TypedList$object * _JC_JCNI_ATTR
_jc_polyglot_util_TypedList$method$copyAndCheck$1016e6b265d21143(_jc_env *const env, _jc_object *param0, _jc_java_lang_Class$object *param1, jboolean param2)
{
	struct _jc_object *r0;
	struct _jc_java_lang_Class$object *r1;
	struct _jc_polyglot_util_TypedList$object *r2;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = param0;
	r1 = param1;
	z0 = param2;
	_JC_LINE_NUMBER(55);				// 0
	if (r1 == _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(56);				// 1
	_JC_INVOKE_STATIC(env, polyglot_util_TypedList, check$0be7ab6614c62cd9, 1, r0, r1);

label0:
	_JC_LINE_NUMBER(57);				// 2
	r2 = _JC_INVOKE_STATIC(env, polyglot_util_TypedList, copy$71a2e8e56d8c3e66, 1, r0, r1, z0);
	return r2;
}

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// public void <init>(java.util.List, java.lang.Class, boolean)
//

static _jc_linenum _jc_polyglot_util_TypedList$linenum_table$_init$07fc2fcb4ae4264f[];

static const unsigned char _jc_polyglot_util_TypedList$param_ptypes$_init$07fc2fcb4ae4264f[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_util_TypedList$param_types$_init$07fc2fcb4ae4264f[] = {
	&_jc_java_util_List$type,
	&_jc_java_lang_Class$type,
	&_jc_boolean$prim$type
};

_jc_method _jc_polyglot_util_TypedList$method_info$_init$07fc2fcb4ae4264f = {
	.name=			"<init>",
	.signature=		"(Ljava/util/List;Ljava/lang/Class;Z)V",
	.class=			&_jc_polyglot_util_TypedList$type,
	.param_types=		&_jc_polyglot_util_TypedList$param_types$_init$07fc2fcb4ae4264f,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_util_TypedList$param_ptypes$_init$07fc2fcb4ae4264f,
	.signature_hash=	_JC_JLONG(0x7fc2fcb4ae4264f),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_util_TypedList$method$_init$07fc2fcb4ae4264f,
	.num_parameters=	3,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_polyglot_util_TypedList$linenum_table$_init$07fc2fcb4ae4264f
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_util_TypedList, _init$07fc2fcb4ae4264f);

void _JC_JCNI_ATTR
_jc_polyglot_util_TypedList$method$_init$07fc2fcb4ae4264f(_jc_env *const env, _jc_polyglot_util_TypedList$object *this, _jc_object *param0, _jc_java_lang_Class$object *param1, jboolean param2)
{
	struct _jc_polyglot_util_TypedList$object *r0;
	struct _jc_object *r1;
	struct _jc_java_lang_Class$object *r2;
	jboolean z0;

	r0 = this;
	r1 = param0;
	r2 = param1;
	z0 = param2;
	_JC_LINE_NUMBER(85);				// 0
	_JC_PRIM_FIELD(env, r0, polyglot_util_TypedList, immutable) = z0;
	_JC_LINE_NUMBER(86);				// 1
	_JC_REF_FIELD(env, r0, polyglot_util_TypedList, allowed__5ftype) = r2;
	_JC_LINE_NUMBER(87);				// 2
	_JC_REF_FIELD(env, r0, polyglot_util_TypedList, backing__5flist) = r1;
	_JC_LINE_NUMBER(88);				// 3
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public void add(int, java.lang.Object)
//

static _jc_linenum _jc_polyglot_util_TypedList$linenum_table$add$9953f092f36e3303[];

static const unsigned char _jc_polyglot_util_TypedList$param_ptypes$add$9953f092f36e3303[] = { 
_JC_TYPE_INT, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_util_TypedList$param_types$add$9953f092f36e3303[] = {
	&_jc_int$prim$type,
	&_jc_java_lang_Object$type
};

_jc_method _jc_polyglot_util_TypedList$method_info$add$9953f092f36e3303 = {
	.name=			"add",
	.signature=		"(ILjava/lang/Object;)V",
	.class=			&_jc_polyglot_util_TypedList$type,
	.param_types=		&_jc_polyglot_util_TypedList$param_types$add$9953f092f36e3303,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_util_TypedList$param_ptypes$add$9953f092f36e3303,
	.signature_hash=	_JC_JLONG(0x9953f092f36e3303),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_util_TypedList$method$add$9953f092f36e3303,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_util_TypedList$vtable, polyglot_util_TypedList.add$9953f092f36e3303) / sizeof(void *),
	.num_parameters=	2,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_polyglot_util_TypedList$linenum_table$add$9953f092f36e3303
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_util_TypedList, add$9953f092f36e3303);

void _JC_JCNI_ATTR
_jc_polyglot_util_TypedList$method$add$9953f092f36e3303(_jc_env *const env, _jc_polyglot_util_TypedList$object *this, jint param0, _jc_java_lang_Object$object *param1)
{
	jint i0;
	struct _jc_polyglot_util_TypedList$object *r0;
	struct _jc_java_lang_Object$object *r1;
	struct _jc_object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	i0 = param0;
	r1 = param1;
	_JC_LINE_NUMBER(107);				// 0
	_JC_INVOKE_NONVIRTUAL(env, polyglot_util_TypedList, tryIns$53769493cc547601, 0, r0, r1);
	_JC_LINE_NUMBER(108);				// 1
	r2 = _JC_REF_FIELD(env, r0, polyglot_util_TypedList, backing__5flist);
	_JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0x9953f092f36e3303), void, (_jc_env *, struct _jc_object *, jint, struct _jc_java_lang_Object$object *), i0, r1);
	_JC_LINE_NUMBER(109);				// 2
	return;
}

//
// public boolean add(java.lang.Object)
//

static _jc_linenum _jc_polyglot_util_TypedList$linenum_table$add$831f06ee5f59c0cc[];

static const unsigned char _jc_polyglot_util_TypedList$param_ptypes$add$831f06ee5f59c0cc[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_polyglot_util_TypedList$param_types$add$831f06ee5f59c0cc[] = {
	&_jc_java_lang_Object$type
};

_jc_method _jc_polyglot_util_TypedList$method_info$add$831f06ee5f59c0cc = {
	.name=			"add",
	.signature=		"(Ljava/lang/Object;)Z",
	.class=			&_jc_polyglot_util_TypedList$type,
	.param_types=		&_jc_polyglot_util_TypedList$param_types$add$831f06ee5f59c0cc,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_polyglot_util_TypedList$param_ptypes$add$831f06ee5f59c0cc,
	.signature_hash=	_JC_JLONG(0x831f06ee5f59c0cc),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_util_TypedList$method$add$831f06ee5f59c0cc,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_util_TypedList$vtable, polyglot_util_TypedList.add$831f06ee5f59c0cc) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_polyglot_util_TypedList$linenum_table$add$831f06ee5f59c0cc
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_util_TypedList, add$831f06ee5f59c0cc);

jboolean _JC_JCNI_ATTR
_jc_polyglot_util_TypedList$method$add$831f06ee5f59c0cc(_jc_env *const env, _jc_polyglot_util_TypedList$object *this, _jc_java_lang_Object$object *param0)
{
	struct _jc_polyglot_util_TypedList$object *r0;
	struct _jc_java_lang_Object$object *r1;
	struct _jc_object *r2;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(111);				// 0
	_JC_INVOKE_NONVIRTUAL(env, polyglot_util_TypedList, tryIns$53769493cc547601, 0, r0, r1);
	_JC_LINE_NUMBER(112);				// 1
	r2 = _JC_REF_FIELD(env, r0, polyglot_util_TypedList, backing__5flist);
	z0 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0x831f06ee5f59c0cc), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r1);
	return z0;
}

//
// public boolean addAll(int, java.util.Collection)
//

static _jc_linenum _jc_polyglot_util_TypedList$linenum_table$addAll$28b94b9c09be8eeb[];

static const unsigned char _jc_polyglot_util_TypedList$param_ptypes$addAll$28b94b9c09be8eeb[] = { 
_JC_TYPE_INT, _JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_polyglot_util_TypedList$param_types$addAll$28b94b9c09be8eeb[] = {
	&_jc_int$prim$type,
	&_jc_java_util_Collection$type
};

_jc_method _jc_polyglot_util_TypedList$method_info$addAll$28b94b9c09be8eeb = {
	.name=			"addAll",
	.signature=		"(ILjava/util/Collection;)Z",
	.class=			&_jc_polyglot_util_TypedList$type,
	.param_types=		&_jc_polyglot_util_TypedList$param_types$addAll$28b94b9c09be8eeb,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_polyglot_util_TypedList$param_ptypes$addAll$28b94b9c09be8eeb,
	.signature_hash=	_JC_JLONG(0x28b94b9c09be8eeb),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_util_TypedList$method$addAll$28b94b9c09be8eeb,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_util_TypedList$vtable, polyglot_util_TypedList.addAll$28b94b9c09be8eeb) / sizeof(void *),
	.num_parameters=	2,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_polyglot_util_TypedList$linenum_table$addAll$28b94b9c09be8eeb
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_util_TypedList, addAll$28b94b9c09be8eeb);

jboolean _JC_JCNI_ATTR
_jc_polyglot_util_TypedList$method$addAll$28b94b9c09be8eeb(_jc_env *const env, _jc_polyglot_util_TypedList$object *this, jint param0, _jc_object *param1)
{
	jint i0;
	struct _jc_polyglot_util_TypedList$object *r0;
	struct _jc_object *r1;
	struct _jc_object *r2;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	i0 = param0;
	r1 = param1;
	_JC_LINE_NUMBER(115);				// 0
	_JC_INVOKE_NONVIRTUAL(env, polyglot_util_TypedList, tryIns$498c284b0eb9c0f5, 0, r0, r1);
	_JC_LINE_NUMBER(116);				// 1
	r2 = _JC_REF_FIELD(env, r0, polyglot_util_TypedList, backing__5flist);
	z0 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0x28b94b9c09be8eeb), jboolean, (_jc_env *, struct _jc_object *, jint, struct _jc_object *), i0, r1);
	return z0;
}

//
// public boolean addAll(java.util.Collection)
//

static _jc_linenum _jc_polyglot_util_TypedList$linenum_table$addAll$77406cdf3002027f[];

static const unsigned char _jc_polyglot_util_TypedList$param_ptypes$addAll$77406cdf3002027f[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_polyglot_util_TypedList$param_types$addAll$77406cdf3002027f[] = {
	&_jc_java_util_Collection$type
};

_jc_method _jc_polyglot_util_TypedList$method_info$addAll$77406cdf3002027f = {
	.name=			"addAll",
	.signature=		"(Ljava/util/Collection;)Z",
	.class=			&_jc_polyglot_util_TypedList$type,
	.param_types=		&_jc_polyglot_util_TypedList$param_types$addAll$77406cdf3002027f,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_polyglot_util_TypedList$param_ptypes$addAll$77406cdf3002027f,
	.signature_hash=	_JC_JLONG(0x77406cdf3002027f),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_util_TypedList$method$addAll$77406cdf3002027f,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_util_TypedList$vtable, polyglot_util_TypedList.addAll$77406cdf3002027f) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_polyglot_util_TypedList$linenum_table$addAll$77406cdf3002027f
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_util_TypedList, addAll$77406cdf3002027f);

jboolean _JC_JCNI_ATTR
_jc_polyglot_util_TypedList$method$addAll$77406cdf3002027f(_jc_env *const env, _jc_polyglot_util_TypedList$object *this, _jc_object *param0)
{
	struct _jc_polyglot_util_TypedList$object *r0;
	struct _jc_object *r1;
	struct _jc_object *r2;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(119);				// 0
	_JC_INVOKE_NONVIRTUAL(env, polyglot_util_TypedList, tryIns$498c284b0eb9c0f5, 0, r0, r1);
	_JC_LINE_NUMBER(120);				// 1
	r2 = _JC_REF_FIELD(env, r0, polyglot_util_TypedList, backing__5flist);
	z0 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0x77406cdf3002027f), jboolean, (_jc_env *, struct _jc_object *, struct _jc_object *), r1);
	return z0;
}

//
// public void clear()
//

static _jc_linenum _jc_polyglot_util_TypedList$linenum_table$clear$0a5acde3ee27a066[];

static const unsigned char _jc_polyglot_util_TypedList$param_ptypes$clear$0a5acde3ee27a066[] = { 
_JC_TYPE_VOID };

_jc_method _jc_polyglot_util_TypedList$method_info$clear$0a5acde3ee27a066 = {
	.name=			"clear",
	.signature=		"()V",
	.class=			&_jc_polyglot_util_TypedList$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_util_TypedList$param_ptypes$clear$0a5acde3ee27a066,
	.signature_hash=	_JC_JLONG(0xa5acde3ee27a066),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_util_TypedList$method$clear$0a5acde3ee27a066,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_util_TypedList$vtable, polyglot_util_TypedList.clear$0a5acde3ee27a066) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_util_TypedList$linenum_table$clear$0a5acde3ee27a066
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_util_TypedList, clear$0a5acde3ee27a066);

void _JC_JCNI_ATTR
_jc_polyglot_util_TypedList$method$clear$0a5acde3ee27a066(_jc_env *const env, _jc_polyglot_util_TypedList$object *this)
{
	struct _jc_polyglot_util_TypedList$object *r0;
	struct _jc_object *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(142);				// 0
	r1 = _JC_REF_FIELD(env, r0, polyglot_util_TypedList, backing__5flist);
	_JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0xa5acde3ee27a066), void, (_jc_env *, struct _jc_object *));
	return;
}

//
// public java.lang.Object clone()
//

static _jc_linenum _jc_polyglot_util_TypedList$linenum_table$clone$b75f2713d6705f70[];

static const unsigned char _jc_polyglot_util_TypedList$param_ptypes$clone$b75f2713d6705f70[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_util_TypedList$method_info$clone$b75f2713d6705f70 = {
	.name=			"clone",
	.signature=		"()Ljava/lang/Object;",
	.class=			&_jc_polyglot_util_TypedList$type,
	.return_type=		&_jc_java_lang_Object$type,
	.param_ptypes=		&_jc_polyglot_util_TypedList$param_ptypes$clone$b75f2713d6705f70,
	.signature_hash=	_JC_JLONG(0xb75f2713d6705f70),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_util_TypedList$method$clone$b75f2713d6705f70,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_util_TypedList$vtable, polyglot_util_TypedList.clone$b75f2713d6705f70) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_util_TypedList$linenum_table$clone$b75f2713d6705f70
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_util_TypedList, clone$b75f2713d6705f70);

_jc_java_lang_Object$object * _JC_JCNI_ATTR
_jc_polyglot_util_TypedList$method$clone$b75f2713d6705f70(_jc_env *const env, _jc_polyglot_util_TypedList$object *this)
{
	struct _jc_polyglot_util_TypedList$object *r0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(104);				// 0
	r0 = _JC_INVOKE_VIRTUAL(env, polyglot_util_TypedList, copy$203627e18f3ed3e7, r0);
	return r0;
}

//
// public boolean contains(java.lang.Object)
//

static _jc_linenum _jc_polyglot_util_TypedList$linenum_table$contains$d3bd70da40f05cb1[];

static const unsigned char _jc_polyglot_util_TypedList$param_ptypes$contains$d3bd70da40f05cb1[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_polyglot_util_TypedList$param_types$contains$d3bd70da40f05cb1[] = {
	&_jc_java_lang_Object$type
};

_jc_method _jc_polyglot_util_TypedList$method_info$contains$d3bd70da40f05cb1 = {
	.name=			"contains",
	.signature=		"(Ljava/lang/Object;)Z",
	.class=			&_jc_polyglot_util_TypedList$type,
	.param_types=		&_jc_polyglot_util_TypedList$param_types$contains$d3bd70da40f05cb1,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_polyglot_util_TypedList$param_ptypes$contains$d3bd70da40f05cb1,
	.signature_hash=	_JC_JLONG(0xd3bd70da40f05cb1),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_util_TypedList$method$contains$d3bd70da40f05cb1,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_util_TypedList$vtable, polyglot_util_TypedList.contains$d3bd70da40f05cb1) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_util_TypedList$linenum_table$contains$d3bd70da40f05cb1
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_util_TypedList, contains$d3bd70da40f05cb1);

jboolean _JC_JCNI_ATTR
_jc_polyglot_util_TypedList$method$contains$d3bd70da40f05cb1(_jc_env *const env, _jc_polyglot_util_TypedList$object *this, _jc_java_lang_Object$object *param0)
{
	struct _jc_polyglot_util_TypedList$object *r0;
	struct _jc_java_lang_Object$object *r1;
	struct _jc_object *r2;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(144);				// 0
	r2 = _JC_REF_FIELD(env, r0, polyglot_util_TypedList, backing__5flist);
	z0 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0xd3bd70da40f05cb1), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r1);
	return z0;
}

//
// public boolean containsAll(java.util.Collection)
//

static _jc_linenum _jc_polyglot_util_TypedList$linenum_table$containsAll$84ec995bc785c34c[];

static const unsigned char _jc_polyglot_util_TypedList$param_ptypes$containsAll$84ec995bc785c34c[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_polyglot_util_TypedList$param_types$containsAll$84ec995bc785c34c[] = {
	&_jc_java_util_Collection$type
};

_jc_method _jc_polyglot_util_TypedList$method_info$containsAll$84ec995bc785c34c = {
	.name=			"containsAll",
	.signature=		"(Ljava/util/Collection;)Z",
	.class=			&_jc_polyglot_util_TypedList$type,
	.param_types=		&_jc_polyglot_util_TypedList$param_types$containsAll$84ec995bc785c34c,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_polyglot_util_TypedList$param_ptypes$containsAll$84ec995bc785c34c,
	.signature_hash=	_JC_JLONG(0x84ec995bc785c34c),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_util_TypedList$method$containsAll$84ec995bc785c34c,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_util_TypedList$vtable, polyglot_util_TypedList.containsAll$84ec995bc785c34c) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_util_TypedList$linenum_table$containsAll$84ec995bc785c34c
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_util_TypedList, containsAll$84ec995bc785c34c);

jboolean _JC_JCNI_ATTR
_jc_polyglot_util_TypedList$method$containsAll$84ec995bc785c34c(_jc_env *const env, _jc_polyglot_util_TypedList$object *this, _jc_object *param0)
{
	struct _jc_polyglot_util_TypedList$object *r0;
	struct _jc_object *r1;
	struct _jc_object *r2;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(146);				// 0
	r2 = _JC_REF_FIELD(env, r0, polyglot_util_TypedList, backing__5flist);
	z0 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0x84ec995bc785c34c), jboolean, (_jc_env *, struct _jc_object *, struct _jc_object *), r1);
	return z0;
}

//
// public polyglot.util.TypedList copy()
//

static _jc_linenum _jc_polyglot_util_TypedList$linenum_table$copy$203627e18f3ed3e7[];

static const unsigned char _jc_polyglot_util_TypedList$param_ptypes$copy$203627e18f3ed3e7[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_util_TypedList$method_info$copy$203627e18f3ed3e7 = {
	.name=			"copy",
	.signature=		"()Lpolyglot/util/TypedList;",
	.class=			&_jc_polyglot_util_TypedList$type,
	.return_type=		&_jc_polyglot_util_TypedList$type,
	.param_ptypes=		&_jc_polyglot_util_TypedList$param_ptypes$copy$203627e18f3ed3e7,
	.signature_hash=	_JC_JLONG(0x203627e18f3ed3e7),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_util_TypedList$method$copy$203627e18f3ed3e7,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_util_TypedList$vtable, polyglot_util_TypedList.copy$203627e18f3ed3e7) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_polyglot_util_TypedList$linenum_table$copy$203627e18f3ed3e7
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_util_TypedList, copy$203627e18f3ed3e7);

_jc_polyglot_util_TypedList$object * _JC_JCNI_ATTR
_jc_polyglot_util_TypedList$method$copy$203627e18f3ed3e7(_jc_env *const env, _jc_polyglot_util_TypedList$object *this)
{
	jfloat f0;
	jint i0;
	jint i1;
	struct _jc_polyglot_util_TypedList$object *r0;
	struct _jc_java_util_ArrayList$object *r1;
	struct _jc_object *r2;
	struct _jc_polyglot_util_TypedList$object *r3;
	struct _jc_java_lang_Class$object *r4;
	struct _jc_java_lang_IllegalArgumentException$object *r5;
	_jc_object_array *r6;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(101);				// 0
	r1 = _JC_NEW(env, java_util_ArrayList);
	r2 = _JC_REF_FIELD(env, r0, polyglot_util_TypedList, backing__5flist);
	i0 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0x345df5220fc60ade), jint, (_jc_env *, struct _jc_object *));
	f0 = (jfloat)i0;
	f0 = f0 * _JC_FCONST(0x3f, 0x8c, 0xcc, 0xcd);
	i0 = _JC_CAST_FLT2INT(env, jfloat, jint, f0);
	if (i0 >= 0)
		goto label0;
	r5 = _JC_NEW(env, java_lang_IllegalArgumentException);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_Throwable, _init$c31b894660454d13, 0, r5, _JC_NULL);
	_JC_THROW(env, r5);

label0:
	r6 = _JC_NEW_REF_ARRAY(env, java_lang_Object, 1, i0);
	_JC_REF_FIELD(env, r1, java_util_ArrayList, data) = r6;
	i1 = _JC_PRIM_FIELD(env, r1, java_util_ArrayList, size);
	_JC_INVOKE_NONVIRTUAL(env, java_util_ArrayList, addAll$28b94b9c09be8eeb, 0, r1, i1, r2);
	_JC_LINE_NUMBER(102);				// 1
	r3 = _JC_NEW(env, polyglot_util_TypedList);
	r4 = _JC_REF_FIELD(env, r0, polyglot_util_TypedList, allowed__5ftype);
	z0 = _JC_PRIM_FIELD(env, r0, polyglot_util_TypedList, immutable);
	_JC_PRIM_FIELD(env, r3, polyglot_util_TypedList, immutable) = z0;
	_JC_REF_FIELD(env, r3, polyglot_util_TypedList, allowed__5ftype) = r4;
	_JC_REF_FIELD(env, r3, polyglot_util_TypedList, backing__5flist) = r1;
	return r3;
}

//
// public boolean equals(java.lang.Object)
//

static _jc_linenum _jc_polyglot_util_TypedList$linenum_table$equals$8a15e0625571c581[];

static const unsigned char _jc_polyglot_util_TypedList$param_ptypes$equals$8a15e0625571c581[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_polyglot_util_TypedList$param_types$equals$8a15e0625571c581[] = {
	&_jc_java_lang_Object$type
};

_jc_method _jc_polyglot_util_TypedList$method_info$equals$8a15e0625571c581 = {
	.name=			"equals",
	.signature=		"(Ljava/lang/Object;)Z",
	.class=			&_jc_polyglot_util_TypedList$type,
	.param_types=		&_jc_polyglot_util_TypedList$param_types$equals$8a15e0625571c581,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_polyglot_util_TypedList$param_ptypes$equals$8a15e0625571c581,
	.signature_hash=	_JC_JLONG(0x8a15e0625571c581),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_util_TypedList$method$equals$8a15e0625571c581,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_util_TypedList$vtable, polyglot_util_TypedList.equals$8a15e0625571c581) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_util_TypedList$linenum_table$equals$8a15e0625571c581
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_util_TypedList, equals$8a15e0625571c581);

jboolean _JC_JCNI_ATTR
_jc_polyglot_util_TypedList$method$equals$8a15e0625571c581(_jc_env *const env, _jc_polyglot_util_TypedList$object *this, _jc_java_lang_Object$object *param0)
{
	struct _jc_polyglot_util_TypedList$object *r0;
	struct _jc_java_lang_Object$object *r1;
	struct _jc_object *r2;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(148);				// 0
	r2 = _JC_REF_FIELD(env, r0, polyglot_util_TypedList, backing__5flist);
	z0 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, equals$8a15e0625571c581, r2, r1);
	return z0;
}

//
// public java.lang.Object get(int)
//

static _jc_linenum _jc_polyglot_util_TypedList$linenum_table$get$a706240e1333824b[];

static const unsigned char _jc_polyglot_util_TypedList$param_ptypes$get$a706240e1333824b[] = { 
_JC_TYPE_INT, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_util_TypedList$param_types$get$a706240e1333824b[] = {
	&_jc_int$prim$type
};

_jc_method _jc_polyglot_util_TypedList$method_info$get$a706240e1333824b = {
	.name=			"get",
	.signature=		"(I)Ljava/lang/Object;",
	.class=			&_jc_polyglot_util_TypedList$type,
	.param_types=		&_jc_polyglot_util_TypedList$param_types$get$a706240e1333824b,
	.return_type=		&_jc_java_lang_Object$type,
	.param_ptypes=		&_jc_polyglot_util_TypedList$param_ptypes$get$a706240e1333824b,
	.signature_hash=	_JC_JLONG(0xa706240e1333824b),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_util_TypedList$method$get$a706240e1333824b,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_util_TypedList$vtable, polyglot_util_TypedList.get$a706240e1333824b) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_util_TypedList$linenum_table$get$a706240e1333824b
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_util_TypedList, get$a706240e1333824b);

_jc_java_lang_Object$object * _JC_JCNI_ATTR
_jc_polyglot_util_TypedList$method$get$a706240e1333824b(_jc_env *const env, _jc_polyglot_util_TypedList$object *this, jint param0)
{
	jint i0;
	struct _jc_polyglot_util_TypedList$object *r0;
	struct _jc_object *r1;
	struct _jc_java_lang_Object$object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	i0 = param0;
	_JC_LINE_NUMBER(150);				// 0
	r1 = _JC_REF_FIELD(env, r0, polyglot_util_TypedList, backing__5flist);
	r2 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0xa706240e1333824b), _jc_object *, (_jc_env *, struct _jc_object *, jint), i0);
	return r2;
}

//
// public java.lang.Class getAllowedType()
//

static _jc_linenum _jc_polyglot_util_TypedList$linenum_table$getAllowedType$0528d70a096ec4c4[];

static const unsigned char _jc_polyglot_util_TypedList$param_ptypes$getAllowedType$0528d70a096ec4c4[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_util_TypedList$method_info$getAllowedType$0528d70a096ec4c4 = {
	.name=			"getAllowedType",
	.signature=		"()Ljava/lang/Class;",
	.class=			&_jc_polyglot_util_TypedList$type,
	.return_type=		&_jc_java_lang_Class$type,
	.param_ptypes=		&_jc_polyglot_util_TypedList$param_ptypes$getAllowedType$0528d70a096ec4c4,
	.signature_hash=	_JC_JLONG(0x528d70a096ec4c4),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_util_TypedList$method$getAllowedType$0528d70a096ec4c4,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_util_TypedList$vtable, polyglot_util_TypedList.getAllowedType$0528d70a096ec4c4) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_util_TypedList$linenum_table$getAllowedType$0528d70a096ec4c4
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_util_TypedList, getAllowedType$0528d70a096ec4c4);

_jc_java_lang_Class$object * _JC_JCNI_ATTR
_jc_polyglot_util_TypedList$method$getAllowedType$0528d70a096ec4c4(_jc_env *const env, _jc_polyglot_util_TypedList$object *this)
{
	struct _jc_polyglot_util_TypedList$object *r0;
	struct _jc_java_lang_Class$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(94);				// 0
	r1 = _JC_REF_FIELD(env, r0, polyglot_util_TypedList, allowed__5ftype);
	return r1;
}

//
// public int hashCode()
//

static _jc_linenum _jc_polyglot_util_TypedList$linenum_table$hashCode$53152098849316df[];

static const unsigned char _jc_polyglot_util_TypedList$param_ptypes$hashCode$53152098849316df[] = { 
_JC_TYPE_INT };

_jc_method _jc_polyglot_util_TypedList$method_info$hashCode$53152098849316df = {
	.name=			"hashCode",
	.signature=		"()I",
	.class=			&_jc_polyglot_util_TypedList$type,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_polyglot_util_TypedList$param_ptypes$hashCode$53152098849316df,
	.signature_hash=	_JC_JLONG(0x53152098849316df),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_util_TypedList$method$hashCode$53152098849316df,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_util_TypedList$vtable, polyglot_util_TypedList.hashCode$53152098849316df) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_util_TypedList$linenum_table$hashCode$53152098849316df
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_util_TypedList, hashCode$53152098849316df);

jint _JC_JCNI_ATTR
_jc_polyglot_util_TypedList$method$hashCode$53152098849316df(_jc_env *const env, _jc_polyglot_util_TypedList$object *this)
{
	jint i0;
	struct _jc_polyglot_util_TypedList$object *r0;
	struct _jc_object *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(152);				// 0
	r1 = _JC_REF_FIELD(env, r0, polyglot_util_TypedList, backing__5flist);
	i0 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, hashCode$53152098849316df, r1);
	return i0;
}

//
// public int indexOf(java.lang.Object)
//

static _jc_linenum _jc_polyglot_util_TypedList$linenum_table$indexOf$59e53868af339edb[];

static const unsigned char _jc_polyglot_util_TypedList$param_ptypes$indexOf$59e53868af339edb[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT };

static _jc_type *const _jc_polyglot_util_TypedList$param_types$indexOf$59e53868af339edb[] = {
	&_jc_java_lang_Object$type
};

_jc_method _jc_polyglot_util_TypedList$method_info$indexOf$59e53868af339edb = {
	.name=			"indexOf",
	.signature=		"(Ljava/lang/Object;)I",
	.class=			&_jc_polyglot_util_TypedList$type,
	.param_types=		&_jc_polyglot_util_TypedList$param_types$indexOf$59e53868af339edb,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_polyglot_util_TypedList$param_ptypes$indexOf$59e53868af339edb,
	.signature_hash=	_JC_JLONG(0x59e53868af339edb),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_util_TypedList$method$indexOf$59e53868af339edb,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_util_TypedList$vtable, polyglot_util_TypedList.indexOf$59e53868af339edb) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_util_TypedList$linenum_table$indexOf$59e53868af339edb
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_util_TypedList, indexOf$59e53868af339edb);

jint _JC_JCNI_ATTR
_jc_polyglot_util_TypedList$method$indexOf$59e53868af339edb(_jc_env *const env, _jc_polyglot_util_TypedList$object *this, _jc_java_lang_Object$object *param0)
{
	jint i0;
	struct _jc_polyglot_util_TypedList$object *r0;
	struct _jc_java_lang_Object$object *r1;
	struct _jc_object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(154);				// 0
	r2 = _JC_REF_FIELD(env, r0, polyglot_util_TypedList, backing__5flist);
	i0 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0x59e53868af339edb), jint, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r1);
	return i0;
}

//
// public boolean isEmpty()
//

static _jc_linenum _jc_polyglot_util_TypedList$linenum_table$isEmpty$551bea84f4e0f0cb[];

static const unsigned char _jc_polyglot_util_TypedList$param_ptypes$isEmpty$551bea84f4e0f0cb[] = { 
_JC_TYPE_BOOLEAN };

_jc_method _jc_polyglot_util_TypedList$method_info$isEmpty$551bea84f4e0f0cb = {
	.name=			"isEmpty",
	.signature=		"()Z",
	.class=			&_jc_polyglot_util_TypedList$type,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_polyglot_util_TypedList$param_ptypes$isEmpty$551bea84f4e0f0cb,
	.signature_hash=	_JC_JLONG(0x551bea84f4e0f0cb),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_util_TypedList$method$isEmpty$551bea84f4e0f0cb,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_util_TypedList$vtable, polyglot_util_TypedList.isEmpty$551bea84f4e0f0cb) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_util_TypedList$linenum_table$isEmpty$551bea84f4e0f0cb
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_util_TypedList, isEmpty$551bea84f4e0f0cb);

jboolean _JC_JCNI_ATTR
_jc_polyglot_util_TypedList$method$isEmpty$551bea84f4e0f0cb(_jc_env *const env, _jc_polyglot_util_TypedList$object *this)
{
	struct _jc_polyglot_util_TypedList$object *r0;
	struct _jc_object *r1;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(156);				// 0
	r1 = _JC_REF_FIELD(env, r0, polyglot_util_TypedList, backing__5flist);
	z0 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0x551bea84f4e0f0cb), jboolean, (_jc_env *, struct _jc_object *));
	return z0;
}

//
// public java.util.Iterator iterator()
//

static _jc_linenum _jc_polyglot_util_TypedList$linenum_table$iterator$3cc91493d50f531c[];

static const unsigned char _jc_polyglot_util_TypedList$param_ptypes$iterator$3cc91493d50f531c[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_util_TypedList$method_info$iterator$3cc91493d50f531c = {
	.name=			"iterator",
	.signature=		"()Ljava/util/Iterator;",
	.class=			&_jc_polyglot_util_TypedList$type,
	.return_type=		&_jc_java_util_Iterator$type,
	.param_ptypes=		&_jc_polyglot_util_TypedList$param_ptypes$iterator$3cc91493d50f531c,
	.signature_hash=	_JC_JLONG(0x3cc91493d50f531c),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_util_TypedList$method$iterator$3cc91493d50f531c,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_util_TypedList$vtable, polyglot_util_TypedList.iterator$3cc91493d50f531c) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_util_TypedList$linenum_table$iterator$3cc91493d50f531c
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_util_TypedList, iterator$3cc91493d50f531c);

_jc_object * _JC_JCNI_ATTR
_jc_polyglot_util_TypedList$method$iterator$3cc91493d50f531c(_jc_env *const env, _jc_polyglot_util_TypedList$object *this)
{
	struct _jc_polyglot_util_TypedList$object *r0;
	struct _jc_object *r1;
	struct _jc_object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(158);				// 0
	r1 = _JC_REF_FIELD(env, r0, polyglot_util_TypedList, backing__5flist);
	r2 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0x3cc91493d50f531c), _jc_object *, (_jc_env *, struct _jc_object *));
	return r2;
}

//
// public int lastIndexOf(java.lang.Object)
//

static _jc_linenum _jc_polyglot_util_TypedList$linenum_table$lastIndexOf$af030ff733adf0f9[];

static const unsigned char _jc_polyglot_util_TypedList$param_ptypes$lastIndexOf$af030ff733adf0f9[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT };

static _jc_type *const _jc_polyglot_util_TypedList$param_types$lastIndexOf$af030ff733adf0f9[] = {
	&_jc_java_lang_Object$type
};

_jc_method _jc_polyglot_util_TypedList$method_info$lastIndexOf$af030ff733adf0f9 = {
	.name=			"lastIndexOf",
	.signature=		"(Ljava/lang/Object;)I",
	.class=			&_jc_polyglot_util_TypedList$type,
	.param_types=		&_jc_polyglot_util_TypedList$param_types$lastIndexOf$af030ff733adf0f9,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_polyglot_util_TypedList$param_ptypes$lastIndexOf$af030ff733adf0f9,
	.signature_hash=	_JC_JLONG(0xaf030ff733adf0f9),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_util_TypedList$method$lastIndexOf$af030ff733adf0f9,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_util_TypedList$vtable, polyglot_util_TypedList.lastIndexOf$af030ff733adf0f9) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_util_TypedList$linenum_table$lastIndexOf$af030ff733adf0f9
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_util_TypedList, lastIndexOf$af030ff733adf0f9);

jint _JC_JCNI_ATTR
_jc_polyglot_util_TypedList$method$lastIndexOf$af030ff733adf0f9(_jc_env *const env, _jc_polyglot_util_TypedList$object *this, _jc_java_lang_Object$object *param0)
{
	jint i0;
	struct _jc_polyglot_util_TypedList$object *r0;
	struct _jc_java_lang_Object$object *r1;
	struct _jc_object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(160);				// 0
	r2 = _JC_REF_FIELD(env, r0, polyglot_util_TypedList, backing__5flist);
	i0 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0xaf030ff733adf0f9), jint, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r1);
	return i0;
}

//
// public java.util.ListIterator listIterator()
//

static _jc_linenum _jc_polyglot_util_TypedList$linenum_table$listIterator$7f39f4d760c285dd[];

static const unsigned char _jc_polyglot_util_TypedList$param_ptypes$listIterator$7f39f4d760c285dd[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_util_TypedList$method_info$listIterator$7f39f4d760c285dd = {
	.name=			"listIterator",
	.signature=		"()Ljava/util/ListIterator;",
	.class=			&_jc_polyglot_util_TypedList$type,
	.return_type=		&_jc_java_util_ListIterator$type,
	.param_ptypes=		&_jc_polyglot_util_TypedList$param_ptypes$listIterator$7f39f4d760c285dd,
	.signature_hash=	_JC_JLONG(0x7f39f4d760c285dd),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_util_TypedList$method$listIterator$7f39f4d760c285dd,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_util_TypedList$vtable, polyglot_util_TypedList.listIterator$7f39f4d760c285dd) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_util_TypedList$linenum_table$listIterator$7f39f4d760c285dd
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_util_TypedList, listIterator$7f39f4d760c285dd);

_jc_object * _JC_JCNI_ATTR
_jc_polyglot_util_TypedList$method$listIterator$7f39f4d760c285dd(_jc_env *const env, _jc_polyglot_util_TypedList$object *this)
{
	struct _jc_polyglot_util_TypedList$object *r0;
	struct _jc_polyglot_util_TypedListIterator$object *r1;
	struct _jc_object *r2;
	struct _jc_object *r3;
	struct _jc_java_lang_Class$object *r4;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(123);				// 0
	r1 = _JC_NEW(env, polyglot_util_TypedListIterator);
	r2 = _JC_REF_FIELD(env, r0, polyglot_util_TypedList, backing__5flist);
	r3 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0x7f39f4d760c285dd), _jc_object *, (_jc_env *, struct _jc_object *));
	r4 = _JC_REF_FIELD(env, r0, polyglot_util_TypedList, allowed__5ftype);
	z0 = _JC_PRIM_FIELD(env, r0, polyglot_util_TypedList, immutable);
	_JC_PRIM_FIELD(env, r1, polyglot_util_TypedListIterator, immutable) = z0;
	_JC_REF_FIELD(env, r1, polyglot_util_TypedListIterator, allowed__5ftype) = r4;
	_JC_REF_FIELD(env, r1, polyglot_util_TypedListIterator, backing__5fiterator) = r3;
	return r1;
}

//
// public java.util.ListIterator listIterator(int)
//

static _jc_linenum _jc_polyglot_util_TypedList$linenum_table$listIterator$5712c48727d9c4a4[];

static const unsigned char _jc_polyglot_util_TypedList$param_ptypes$listIterator$5712c48727d9c4a4[] = { 
_JC_TYPE_INT, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_util_TypedList$param_types$listIterator$5712c48727d9c4a4[] = {
	&_jc_int$prim$type
};

_jc_method _jc_polyglot_util_TypedList$method_info$listIterator$5712c48727d9c4a4 = {
	.name=			"listIterator",
	.signature=		"(I)Ljava/util/ListIterator;",
	.class=			&_jc_polyglot_util_TypedList$type,
	.param_types=		&_jc_polyglot_util_TypedList$param_types$listIterator$5712c48727d9c4a4,
	.return_type=		&_jc_java_util_ListIterator$type,
	.param_ptypes=		&_jc_polyglot_util_TypedList$param_ptypes$listIterator$5712c48727d9c4a4,
	.signature_hash=	_JC_JLONG(0x5712c48727d9c4a4),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_util_TypedList$method$listIterator$5712c48727d9c4a4,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_util_TypedList$vtable, polyglot_util_TypedList.listIterator$5712c48727d9c4a4) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_util_TypedList$linenum_table$listIterator$5712c48727d9c4a4
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_util_TypedList, listIterator$5712c48727d9c4a4);

_jc_object * _JC_JCNI_ATTR
_jc_polyglot_util_TypedList$method$listIterator$5712c48727d9c4a4(_jc_env *const env, _jc_polyglot_util_TypedList$object *this, jint param0)
{
	jint i0;
	struct _jc_polyglot_util_TypedList$object *r0;
	struct _jc_polyglot_util_TypedListIterator$object *r1;
	struct _jc_object *r2;
	struct _jc_object *r3;
	struct _jc_java_lang_Class$object *r4;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	i0 = param0;
	_JC_LINE_NUMBER(128);				// 0
	r1 = _JC_NEW(env, polyglot_util_TypedListIterator);
	r2 = _JC_REF_FIELD(env, r0, polyglot_util_TypedList, backing__5flist);
	r3 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0x5712c48727d9c4a4), _jc_object *, (_jc_env *, struct _jc_object *, jint), i0);
	r4 = _JC_REF_FIELD(env, r0, polyglot_util_TypedList, allowed__5ftype);
	z0 = _JC_PRIM_FIELD(env, r0, polyglot_util_TypedList, immutable);
	_JC_PRIM_FIELD(env, r1, polyglot_util_TypedListIterator, immutable) = z0;
	_JC_REF_FIELD(env, r1, polyglot_util_TypedListIterator, allowed__5ftype) = r4;
	_JC_REF_FIELD(env, r1, polyglot_util_TypedListIterator, backing__5fiterator) = r3;
	return r1;
}

//
// public java.lang.Object remove(int)
//

static _jc_linenum _jc_polyglot_util_TypedList$linenum_table$remove$ce2b087495782dc2[];

static const unsigned char _jc_polyglot_util_TypedList$param_ptypes$remove$ce2b087495782dc2[] = { 
_JC_TYPE_INT, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_util_TypedList$param_types$remove$ce2b087495782dc2[] = {
	&_jc_int$prim$type
};

_jc_method _jc_polyglot_util_TypedList$method_info$remove$ce2b087495782dc2 = {
	.name=			"remove",
	.signature=		"(I)Ljava/lang/Object;",
	.class=			&_jc_polyglot_util_TypedList$type,
	.param_types=		&_jc_polyglot_util_TypedList$param_types$remove$ce2b087495782dc2,
	.return_type=		&_jc_java_lang_Object$type,
	.param_ptypes=		&_jc_polyglot_util_TypedList$param_ptypes$remove$ce2b087495782dc2,
	.signature_hash=	_JC_JLONG(0xce2b087495782dc2),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_util_TypedList$method$remove$ce2b087495782dc2,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_util_TypedList$vtable, polyglot_util_TypedList.remove$ce2b087495782dc2) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_util_TypedList$linenum_table$remove$ce2b087495782dc2
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_util_TypedList, remove$ce2b087495782dc2);

_jc_java_lang_Object$object * _JC_JCNI_ATTR
_jc_polyglot_util_TypedList$method$remove$ce2b087495782dc2(_jc_env *const env, _jc_polyglot_util_TypedList$object *this, jint param0)
{
	jint i0;
	struct _jc_polyglot_util_TypedList$object *r0;
	struct _jc_object *r1;
	struct _jc_java_lang_Object$object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	i0 = param0;
	_JC_LINE_NUMBER(162);				// 0
	r1 = _JC_REF_FIELD(env, r0, polyglot_util_TypedList, backing__5flist);
	r2 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0xce2b087495782dc2), _jc_object *, (_jc_env *, struct _jc_object *, jint), i0);
	return r2;
}

//
// public boolean remove(java.lang.Object)
//

static _jc_linenum _jc_polyglot_util_TypedList$linenum_table$remove$d21babbbb7fafe72[];

static const unsigned char _jc_polyglot_util_TypedList$param_ptypes$remove$d21babbbb7fafe72[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_polyglot_util_TypedList$param_types$remove$d21babbbb7fafe72[] = {
	&_jc_java_lang_Object$type
};

_jc_method _jc_polyglot_util_TypedList$method_info$remove$d21babbbb7fafe72 = {
	.name=			"remove",
	.signature=		"(Ljava/lang/Object;)Z",
	.class=			&_jc_polyglot_util_TypedList$type,
	.param_types=		&_jc_polyglot_util_TypedList$param_types$remove$d21babbbb7fafe72,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_polyglot_util_TypedList$param_ptypes$remove$d21babbbb7fafe72,
	.signature_hash=	_JC_JLONG(0xd21babbbb7fafe72),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_util_TypedList$method$remove$d21babbbb7fafe72,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_util_TypedList$vtable, polyglot_util_TypedList.remove$d21babbbb7fafe72) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_util_TypedList$linenum_table$remove$d21babbbb7fafe72
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_util_TypedList, remove$d21babbbb7fafe72);

jboolean _JC_JCNI_ATTR
_jc_polyglot_util_TypedList$method$remove$d21babbbb7fafe72(_jc_env *const env, _jc_polyglot_util_TypedList$object *this, _jc_java_lang_Object$object *param0)
{
	struct _jc_polyglot_util_TypedList$object *r0;
	struct _jc_java_lang_Object$object *r1;
	struct _jc_object *r2;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(164);				// 0
	r2 = _JC_REF_FIELD(env, r0, polyglot_util_TypedList, backing__5flist);
	z0 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0xd21babbbb7fafe72), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r1);
	return z0;
}

//
// public boolean removeAll(java.util.Collection)
//

static _jc_linenum _jc_polyglot_util_TypedList$linenum_table$removeAll$33b663ddc346139b[];

static const unsigned char _jc_polyglot_util_TypedList$param_ptypes$removeAll$33b663ddc346139b[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_polyglot_util_TypedList$param_types$removeAll$33b663ddc346139b[] = {
	&_jc_java_util_Collection$type
};

_jc_method _jc_polyglot_util_TypedList$method_info$removeAll$33b663ddc346139b = {
	.name=			"removeAll",
	.signature=		"(Ljava/util/Collection;)Z",
	.class=			&_jc_polyglot_util_TypedList$type,
	.param_types=		&_jc_polyglot_util_TypedList$param_types$removeAll$33b663ddc346139b,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_polyglot_util_TypedList$param_ptypes$removeAll$33b663ddc346139b,
	.signature_hash=	_JC_JLONG(0x33b663ddc346139b),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_util_TypedList$method$removeAll$33b663ddc346139b,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_util_TypedList$vtable, polyglot_util_TypedList.removeAll$33b663ddc346139b) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_util_TypedList$linenum_table$removeAll$33b663ddc346139b
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_util_TypedList, removeAll$33b663ddc346139b);

jboolean _JC_JCNI_ATTR
_jc_polyglot_util_TypedList$method$removeAll$33b663ddc346139b(_jc_env *const env, _jc_polyglot_util_TypedList$object *this, _jc_object *param0)
{
	struct _jc_polyglot_util_TypedList$object *r0;
	struct _jc_object *r1;
	struct _jc_object *r2;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(166);				// 0
	r2 = _JC_REF_FIELD(env, r0, polyglot_util_TypedList, backing__5flist);
	z0 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0x33b663ddc346139b), jboolean, (_jc_env *, struct _jc_object *, struct _jc_object *), r1);
	return z0;
}

//
// public boolean retainAll(java.util.Collection)
//

static _jc_linenum _jc_polyglot_util_TypedList$linenum_table$retainAll$f1bc65ece6de3bda[];

static const unsigned char _jc_polyglot_util_TypedList$param_ptypes$retainAll$f1bc65ece6de3bda[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_polyglot_util_TypedList$param_types$retainAll$f1bc65ece6de3bda[] = {
	&_jc_java_util_Collection$type
};

_jc_method _jc_polyglot_util_TypedList$method_info$retainAll$f1bc65ece6de3bda = {
	.name=			"retainAll",
	.signature=		"(Ljava/util/Collection;)Z",
	.class=			&_jc_polyglot_util_TypedList$type,
	.param_types=		&_jc_polyglot_util_TypedList$param_types$retainAll$f1bc65ece6de3bda,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_polyglot_util_TypedList$param_ptypes$retainAll$f1bc65ece6de3bda,
	.signature_hash=	_JC_JLONG(0xf1bc65ece6de3bda),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_util_TypedList$method$retainAll$f1bc65ece6de3bda,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_util_TypedList$vtable, polyglot_util_TypedList.retainAll$f1bc65ece6de3bda) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_util_TypedList$linenum_table$retainAll$f1bc65ece6de3bda
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_util_TypedList, retainAll$f1bc65ece6de3bda);

jboolean _JC_JCNI_ATTR
_jc_polyglot_util_TypedList$method$retainAll$f1bc65ece6de3bda(_jc_env *const env, _jc_polyglot_util_TypedList$object *this, _jc_object *param0)
{
	struct _jc_polyglot_util_TypedList$object *r0;
	struct _jc_object *r1;
	struct _jc_object *r2;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(168);				// 0
	r2 = _JC_REF_FIELD(env, r0, polyglot_util_TypedList, backing__5flist);
	z0 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0xf1bc65ece6de3bda), jboolean, (_jc_env *, struct _jc_object *, struct _jc_object *), r1);
	return z0;
}

//
// public java.lang.Object set(int, java.lang.Object)
//

static _jc_linenum _jc_polyglot_util_TypedList$linenum_table$set$21145a3aa89a3e6d[];

static const unsigned char _jc_polyglot_util_TypedList$param_ptypes$set$21145a3aa89a3e6d[] = { 
_JC_TYPE_INT, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_util_TypedList$param_types$set$21145a3aa89a3e6d[] = {
	&_jc_int$prim$type,
	&_jc_java_lang_Object$type
};

_jc_method _jc_polyglot_util_TypedList$method_info$set$21145a3aa89a3e6d = {
	.name=			"set",
	.signature=		"(ILjava/lang/Object;)Ljava/lang/Object;",
	.class=			&_jc_polyglot_util_TypedList$type,
	.param_types=		&_jc_polyglot_util_TypedList$param_types$set$21145a3aa89a3e6d,
	.return_type=		&_jc_java_lang_Object$type,
	.param_ptypes=		&_jc_polyglot_util_TypedList$param_ptypes$set$21145a3aa89a3e6d,
	.signature_hash=	_JC_JLONG(0x21145a3aa89a3e6d),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_util_TypedList$method$set$21145a3aa89a3e6d,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_util_TypedList$vtable, polyglot_util_TypedList.set$21145a3aa89a3e6d) / sizeof(void *),
	.num_parameters=	2,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_polyglot_util_TypedList$linenum_table$set$21145a3aa89a3e6d
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_util_TypedList, set$21145a3aa89a3e6d);

_jc_java_lang_Object$object * _JC_JCNI_ATTR
_jc_polyglot_util_TypedList$method$set$21145a3aa89a3e6d(_jc_env *const env, _jc_polyglot_util_TypedList$object *this, jint param0, _jc_java_lang_Object$object *param1)
{
	jint i0;
	struct _jc_polyglot_util_TypedList$object *r0;
	struct _jc_java_lang_Object$object *r1;
	struct _jc_object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	i0 = param0;
	r1 = param1;
	_JC_LINE_NUMBER(133);				// 0
	_JC_INVOKE_NONVIRTUAL(env, polyglot_util_TypedList, tryIns$53769493cc547601, 0, r0, r1);
	_JC_LINE_NUMBER(134);				// 1
	r2 = _JC_REF_FIELD(env, r0, polyglot_util_TypedList, backing__5flist);
	r1 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0x21145a3aa89a3e6d), _jc_object *, (_jc_env *, struct _jc_object *, jint, struct _jc_java_lang_Object$object *), i0, r1);
	return r1;
}

//
// public int size()
//

static _jc_linenum _jc_polyglot_util_TypedList$linenum_table$size$345df5220fc60ade[];

static const unsigned char _jc_polyglot_util_TypedList$param_ptypes$size$345df5220fc60ade[] = { 
_JC_TYPE_INT };

_jc_method _jc_polyglot_util_TypedList$method_info$size$345df5220fc60ade = {
	.name=			"size",
	.signature=		"()I",
	.class=			&_jc_polyglot_util_TypedList$type,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_polyglot_util_TypedList$param_ptypes$size$345df5220fc60ade,
	.signature_hash=	_JC_JLONG(0x345df5220fc60ade),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_util_TypedList$method$size$345df5220fc60ade,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_util_TypedList$vtable, polyglot_util_TypedList.size$345df5220fc60ade) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_util_TypedList$linenum_table$size$345df5220fc60ade
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_util_TypedList, size$345df5220fc60ade);

jint _JC_JCNI_ATTR
_jc_polyglot_util_TypedList$method$size$345df5220fc60ade(_jc_env *const env, _jc_polyglot_util_TypedList$object *this)
{
	jint i0;
	struct _jc_polyglot_util_TypedList$object *r0;
	struct _jc_object *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(170);				// 0
	r1 = _JC_REF_FIELD(env, r0, polyglot_util_TypedList, backing__5flist);
	i0 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0x345df5220fc60ade), jint, (_jc_env *, struct _jc_object *));
	return i0;
}

//
// public java.util.List subList(int, int)
//

static _jc_linenum _jc_polyglot_util_TypedList$linenum_table$subList$af8e3c69195dae35[];

static const unsigned char _jc_polyglot_util_TypedList$param_ptypes$subList$af8e3c69195dae35[] = { 
_JC_TYPE_INT, _JC_TYPE_INT, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_util_TypedList$param_types$subList$af8e3c69195dae35[] = {
	&_jc_int$prim$type,
	&_jc_int$prim$type
};

_jc_method _jc_polyglot_util_TypedList$method_info$subList$af8e3c69195dae35 = {
	.name=			"subList",
	.signature=		"(II)Ljava/util/List;",
	.class=			&_jc_polyglot_util_TypedList$type,
	.param_types=		&_jc_polyglot_util_TypedList$param_types$subList$af8e3c69195dae35,
	.return_type=		&_jc_java_util_List$type,
	.param_ptypes=		&_jc_polyglot_util_TypedList$param_ptypes$subList$af8e3c69195dae35,
	.signature_hash=	_JC_JLONG(0xaf8e3c69195dae35),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_util_TypedList$method$subList$af8e3c69195dae35,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_util_TypedList$vtable, polyglot_util_TypedList.subList$af8e3c69195dae35) / sizeof(void *),
	.num_parameters=	2,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_util_TypedList$linenum_table$subList$af8e3c69195dae35
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_util_TypedList, subList$af8e3c69195dae35);

_jc_object * _JC_JCNI_ATTR
_jc_polyglot_util_TypedList$method$subList$af8e3c69195dae35(_jc_env *const env, _jc_polyglot_util_TypedList$object *this, jint param0, jint param1)
{
	jint i0;
	jint i1;
	struct _jc_polyglot_util_TypedList$object *r0;
	struct _jc_polyglot_util_TypedList$object *r1;
	struct _jc_object *r2;
	struct _jc_java_lang_Class$object *r3;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	i0 = param0;
	i1 = param1;
	_JC_LINE_NUMBER(137);				// 0
	r1 = _JC_NEW(env, polyglot_util_TypedList);
	r2 = _JC_REF_FIELD(env, r0, polyglot_util_TypedList, backing__5flist);
	r2 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0xaf8e3c69195dae35), _jc_object *, (_jc_env *, struct _jc_object *, jint, jint), i0, i1);
	r3 = _JC_REF_FIELD(env, r0, polyglot_util_TypedList, allowed__5ftype);
	z0 = _JC_PRIM_FIELD(env, r0, polyglot_util_TypedList, immutable);
	_JC_PRIM_FIELD(env, r1, polyglot_util_TypedList, immutable) = z0;
	_JC_REF_FIELD(env, r1, polyglot_util_TypedList, allowed__5ftype) = r3;
	_JC_REF_FIELD(env, r1, polyglot_util_TypedList, backing__5flist) = r2;
	return r1;
}

//
// public java.lang.Object[] toArray()
//

static _jc_linenum _jc_polyglot_util_TypedList$linenum_table$toArray$408321282fd84959[];

static const unsigned char _jc_polyglot_util_TypedList$param_ptypes$toArray$408321282fd84959[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_util_TypedList$method_info$toArray$408321282fd84959 = {
	.name=			"toArray",
	.signature=		"()[Ljava/lang/Object;",
	.class=			&_jc_polyglot_util_TypedList$type,
	.return_type=		&_jc_java_lang_Object$array$type,
	.param_ptypes=		&_jc_polyglot_util_TypedList$param_ptypes$toArray$408321282fd84959,
	.signature_hash=	_JC_JLONG(0x408321282fd84959),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_util_TypedList$method$toArray$408321282fd84959,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_util_TypedList$vtable, polyglot_util_TypedList.toArray$408321282fd84959) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_util_TypedList$linenum_table$toArray$408321282fd84959
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_util_TypedList, toArray$408321282fd84959);

_jc_object_array * _JC_JCNI_ATTR
_jc_polyglot_util_TypedList$method$toArray$408321282fd84959(_jc_env *const env, _jc_polyglot_util_TypedList$object *this)
{
	struct _jc_polyglot_util_TypedList$object *r0;
	struct _jc_object *r1;
	_jc_object_array *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(172);				// 0
	r1 = _JC_REF_FIELD(env, r0, polyglot_util_TypedList, backing__5flist);
	r2 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0x408321282fd84959), _jc_object *, (_jc_env *, struct _jc_object *));
	return r2;
}

//
// public java.lang.Object[] toArray(java.lang.Object[])
//

static _jc_linenum _jc_polyglot_util_TypedList$linenum_table$toArray$b7264a1d378ca224[];

static const unsigned char _jc_polyglot_util_TypedList$param_ptypes$toArray$b7264a1d378ca224[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_util_TypedList$param_types$toArray$b7264a1d378ca224[] = {
	&_jc_java_lang_Object$array$type
};

_jc_method _jc_polyglot_util_TypedList$method_info$toArray$b7264a1d378ca224 = {
	.name=			"toArray",
	.signature=		"([Ljava/lang/Object;)[Ljava/lang/Object;",
	.class=			&_jc_polyglot_util_TypedList$type,
	.param_types=		&_jc_polyglot_util_TypedList$param_types$toArray$b7264a1d378ca224,
	.return_type=		&_jc_java_lang_Object$array$type,
	.param_ptypes=		&_jc_polyglot_util_TypedList$param_ptypes$toArray$b7264a1d378ca224,
	.signature_hash=	_JC_JLONG(0xb7264a1d378ca224),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_util_TypedList$method$toArray$b7264a1d378ca224,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_util_TypedList$vtable, polyglot_util_TypedList.toArray$b7264a1d378ca224) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_util_TypedList$linenum_table$toArray$b7264a1d378ca224
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_util_TypedList, toArray$b7264a1d378ca224);

_jc_object_array * _JC_JCNI_ATTR
_jc_polyglot_util_TypedList$method$toArray$b7264a1d378ca224(_jc_env *const env, _jc_polyglot_util_TypedList$object *this, _jc_object_array *param0)
{
	struct _jc_polyglot_util_TypedList$object *r0;
	_jc_object_array *r1;
	struct _jc_object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(174);				// 0
	r2 = _JC_REF_FIELD(env, r0, polyglot_util_TypedList, backing__5flist);
	r1 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0xb7264a1d378ca224), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_object_array *), r1);
	return r1;
}

//
// public java.lang.String toString()
//

static _jc_linenum _jc_polyglot_util_TypedList$linenum_table$toString$7ea43b33b80a3070[];

static const unsigned char _jc_polyglot_util_TypedList$param_ptypes$toString$7ea43b33b80a3070[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_util_TypedList$method_info$toString$7ea43b33b80a3070 = {
	.name=			"toString",
	.signature=		"()Ljava/lang/String;",
	.class=			&_jc_polyglot_util_TypedList$type,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_polyglot_util_TypedList$param_ptypes$toString$7ea43b33b80a3070,
	.signature_hash=	_JC_JLONG(0x7ea43b33b80a3070),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_util_TypedList$method$toString$7ea43b33b80a3070,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_util_TypedList$vtable, polyglot_util_TypedList.toString$7ea43b33b80a3070) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_util_TypedList$linenum_table$toString$7ea43b33b80a3070
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_util_TypedList, toString$7ea43b33b80a3070);

_jc_java_lang_String$object * _JC_JCNI_ATTR
_jc_polyglot_util_TypedList$method$toString$7ea43b33b80a3070(_jc_env *const env, _jc_polyglot_util_TypedList$object *this)
{
	struct _jc_polyglot_util_TypedList$object *r0;
	struct _jc_object *r1;
	struct _jc_java_lang_String$object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(176);				// 0
	r1 = _JC_REF_FIELD(env, r0, polyglot_util_TypedList, backing__5flist);
	r2 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, toString$7ea43b33b80a3070, r1);
	return r2;
}

//
// private final void tryIns(java.lang.Object)
//

static _jc_linenum _jc_polyglot_util_TypedList$linenum_table$tryIns$53769493cc547601[];

static const unsigned char _jc_polyglot_util_TypedList$param_ptypes$tryIns$53769493cc547601[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_util_TypedList$param_types$tryIns$53769493cc547601[] = {
	&_jc_java_lang_Object$type
};

_jc_method _jc_polyglot_util_TypedList$method_info$tryIns$53769493cc547601 = {
	.name=			"tryIns",
	.signature=		"(Ljava/lang/Object;)V",
	.class=			&_jc_polyglot_util_TypedList$type,
	.param_types=		&_jc_polyglot_util_TypedList$param_types$tryIns$53769493cc547601,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_util_TypedList$param_ptypes$tryIns$53769493cc547601,
	.signature_hash=	_JC_JLONG(0x53769493cc547601),
	.access_flags=		_JC_ACC_PRIVATE|_JC_ACC_FINAL,
	.function=		&_jc_polyglot_util_TypedList$method$tryIns$53769493cc547601,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_util_TypedList$vtable, polyglot_util_TypedList.tryIns$53769493cc547601) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	6,
	      .table=	_jc_polyglot_util_TypedList$linenum_table$tryIns$53769493cc547601
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_util_TypedList, tryIns$53769493cc547601);

void _JC_JCNI_ATTR
_jc_polyglot_util_TypedList$method$tryIns$53769493cc547601(_jc_env *const env, _jc_polyglot_util_TypedList$object *this, _jc_java_lang_Object$object *param0)
{
	struct _jc_polyglot_util_TypedList$object *r0;
	struct _jc_java_lang_Object$object *r1;
	struct _jc_java_lang_String$object *r10;
	struct _jc_java_lang_String$object *r11;
	_jc_char_array *r12;
	struct _jc_java_lang_VMThrowable$object *r13;
	struct _jc_java_lang_VMThrowable$object *r15;
	struct _jc_java_lang_UnsupportedOperationException$object *r2;
	struct _jc_java_lang_Class$object *r3;
	struct _jc_java_lang_Class$object *r4;
	struct _jc_java_lang_StringBuffer$object *r5;
	struct _jc_java_lang_String$object *r6;
	struct _jc_java_lang_Class$object *r7;
	struct _jc_java_lang_Class$object *r8;
	struct _jc_java_lang_String$object *r9;
	jboolean z0;
	jboolean z1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(179);				// 0
	z0 = _JC_PRIM_FIELD(env, r0, polyglot_util_TypedList, immutable);
	if (z0 == 0)
		goto label0;
	_JC_LINE_NUMBER(180);				// 1
	r2 = _JC_NEW(env, java_lang_UnsupportedOperationException);
	r6 = _JC_STRING(env, "Add to an immutable TypedListIterator");
	_JC_REF_FIELD(env, r2, java_lang_Throwable, cause) = r2;
	r13 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r2);
	_JC_REF_FIELD(env, r2, java_lang_Throwable, vmState) = r13;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, detailMessage) = r6;
	_JC_THROW(env, r2);

label0:
	_JC_LINE_NUMBER(183);				// 2
	r3 = _JC_REF_FIELD(env, r0, polyglot_util_TypedList, allowed__5ftype);
	if (r3 == _JC_NULL)
		goto label1;
	r3 = _JC_REF_FIELD(env, r0, polyglot_util_TypedList, allowed__5ftype);
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	r7 = _JC_INVOKE_STATIC(env, java_lang_VMObject, getClass$2be11d215bfbfbfe, 0, r1);
	_JC_EXPLICIT_NULL_CHECK(env, r3);
	z1 = _JC_INVOKE_STATIC(env, java_lang_VMClass, isAssignableFrom$c49c4ad8938bda0b, 0, r3, r7);
	if (z1 != 0)
		goto label1;
	_JC_LINE_NUMBER(185);				// 3
	r5 = _JC_NEW(env, java_lang_StringBuffer);
	r12 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r5, java_lang_StringBuffer, value) = r12;
	r5 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r5, _JC_STRING(env, "Tried to add a "));
	r8 = _JC_INVOKE_STATIC(env, java_lang_VMObject, getClass$2be11d215bfbfbfe, 1, r1);
	_JC_EXPLICIT_NULL_CHECK(env, r8);
	r9 = _JC_INVOKE_STATIC(env, java_lang_VMClass, getName$7a04fe8e1a654d36, 1, r8);
	r5 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r5, r9);
	r5 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r5, _JC_STRING(env, " to a list of type "));
	r4 = _JC_REF_FIELD(env, r0, polyglot_util_TypedList, allowed__5ftype);
	_JC_EXPLICIT_NULL_CHECK(env, r4);
	r10 = _JC_INVOKE_STATIC(env, java_lang_VMClass, getName$7a04fe8e1a654d36, 1, r4);
	r5 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r5, r10);
	r11 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r11, r5);
	_JC_LINE_NUMBER(187);				// 4
	r2 = _JC_NEW(env, java_lang_UnsupportedOperationException);
	_JC_REF_FIELD(env, r2, java_lang_Throwable, cause) = r2;
	r15 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r2);
	_JC_REF_FIELD(env, r2, java_lang_Throwable, vmState) = r15;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, detailMessage) = r11;
	_JC_THROW(env, r2);

label1:
	_JC_LINE_NUMBER(189);				// 5
	return;
}

//
// private final void tryIns(java.util.Collection)
//

static _jc_linenum _jc_polyglot_util_TypedList$linenum_table$tryIns$498c284b0eb9c0f5[];

static const unsigned char _jc_polyglot_util_TypedList$param_ptypes$tryIns$498c284b0eb9c0f5[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_util_TypedList$param_types$tryIns$498c284b0eb9c0f5[] = {
	&_jc_java_util_Collection$type
};

_jc_method _jc_polyglot_util_TypedList$method_info$tryIns$498c284b0eb9c0f5 = {
	.name=			"tryIns",
	.signature=		"(Ljava/util/Collection;)V",
	.class=			&_jc_polyglot_util_TypedList$type,
	.param_types=		&_jc_polyglot_util_TypedList$param_types$tryIns$498c284b0eb9c0f5,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_util_TypedList$param_ptypes$tryIns$498c284b0eb9c0f5,
	.signature_hash=	_JC_JLONG(0x498c284b0eb9c0f5),
	.access_flags=		_JC_ACC_PRIVATE|_JC_ACC_FINAL,
	.function=		&_jc_polyglot_util_TypedList$method$tryIns$498c284b0eb9c0f5,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_util_TypedList$vtable, polyglot_util_TypedList.tryIns$498c284b0eb9c0f5) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	8,
	      .table=	_jc_polyglot_util_TypedList$linenum_table$tryIns$498c284b0eb9c0f5
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_util_TypedList, tryIns$498c284b0eb9c0f5);

void _JC_JCNI_ATTR
_jc_polyglot_util_TypedList$method$tryIns$498c284b0eb9c0f5(_jc_env *const env, _jc_polyglot_util_TypedList$object *this, _jc_object *param0)
{
	struct _jc_polyglot_util_TypedList$object *r0;
	struct _jc_object *r1;
	struct _jc_java_lang_Class$object *r10;
	struct _jc_java_lang_String$object *r11;
	struct _jc_java_lang_String$object *r12;
	struct _jc_java_lang_String$object *r13;
	_jc_char_array *r14;
	struct _jc_java_lang_VMThrowable$object *r15;
	struct _jc_java_lang_VMThrowable$object *r17;
	struct _jc_object *r2;
	struct _jc_java_lang_Object$object *r3;
	struct _jc_java_lang_UnsupportedOperationException$object *r4;
	struct _jc_java_lang_Class$object *r5;
	struct _jc_java_lang_Class$object *r6;
	struct _jc_java_lang_StringBuffer$object *r7;
	struct _jc_java_lang_String$object *r8;
	struct _jc_java_lang_Class$object *r9;
	jboolean z0;
	jboolean z1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(192);				// 0
	z0 = _JC_PRIM_FIELD(env, r0, polyglot_util_TypedList, immutable);
	if (z0 == 0)
		goto label0;
	_JC_LINE_NUMBER(193);				// 1
	r4 = _JC_NEW(env, java_lang_UnsupportedOperationException);
	r8 = _JC_STRING(env, "Add to an immutable TypedListIterator");
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r15 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r15;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r8;
	_JC_THROW(env, r4);

label0:
	_JC_LINE_NUMBER(196);				// 2
	r2 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0x3cc91493d50f531c), _jc_object *, (_jc_env *, struct _jc_object *));

label1:
	z0 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0xfb0bd5e38c59ddcd), jboolean, (_jc_env *, struct _jc_object *));
	if (z0 == 0)
		goto label2;
	_JC_LINE_NUMBER(197);				// 3
	r3 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0x5874f79a1cf66ea), _jc_object *, (_jc_env *, struct _jc_object *));
	_JC_LINE_NUMBER(198);				// 4
	r5 = _JC_REF_FIELD(env, r0, polyglot_util_TypedList, allowed__5ftype);
	if (r5 == _JC_NULL) {
		_JC_PERIODIC_CHECK(env);
		goto label1;
	}
	r5 = _JC_REF_FIELD(env, r0, polyglot_util_TypedList, allowed__5ftype);
	_JC_EXPLICIT_NULL_CHECK(env, r3);
	r9 = _JC_INVOKE_STATIC(env, java_lang_VMObject, getClass$2be11d215bfbfbfe, 0, r3);
	_JC_EXPLICIT_NULL_CHECK(env, r5);
	z1 = _JC_INVOKE_STATIC(env, java_lang_VMClass, isAssignableFrom$c49c4ad8938bda0b, 0, r5, r9);
	if (z1 != 0) {
		_JC_PERIODIC_CHECK(env);
		goto label1;
	}
	_JC_LINE_NUMBER(200);				// 5
	r7 = _JC_NEW(env, java_lang_StringBuffer);
	r14 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r7, java_lang_StringBuffer, value) = r14;
	r7 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r7, _JC_STRING(env, "Tried to add a "));
	r10 = _JC_INVOKE_STATIC(env, java_lang_VMObject, getClass$2be11d215bfbfbfe, 1, r3);
	_JC_EXPLICIT_NULL_CHECK(env, r10);
	r11 = _JC_INVOKE_STATIC(env, java_lang_VMClass, getName$7a04fe8e1a654d36, 1, r10);
	r7 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r7, r11);
	r7 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r7, _JC_STRING(env, " to a list of type "));
	r6 = _JC_REF_FIELD(env, r0, polyglot_util_TypedList, allowed__5ftype);
	_JC_EXPLICIT_NULL_CHECK(env, r6);
	r12 = _JC_INVOKE_STATIC(env, java_lang_VMClass, getName$7a04fe8e1a654d36, 1, r6);
	r7 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r7, r12);
	r13 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r13, r7);
	_JC_LINE_NUMBER(202);				// 6
	r4 = _JC_NEW(env, java_lang_UnsupportedOperationException);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r17 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r17;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r13;
	_JC_THROW(env, r4);

label2:
	_JC_LINE_NUMBER(205);				// 7
	return;
}

//
// private final void tryMod()
//

static _jc_linenum _jc_polyglot_util_TypedList$linenum_table$tryMod$77a757148daa0c80[];

static const unsigned char _jc_polyglot_util_TypedList$param_ptypes$tryMod$77a757148daa0c80[] = { 
_JC_TYPE_VOID };

_jc_method _jc_polyglot_util_TypedList$method_info$tryMod$77a757148daa0c80 = {
	.name=			"tryMod",
	.signature=		"()V",
	.class=			&_jc_polyglot_util_TypedList$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_util_TypedList$param_ptypes$tryMod$77a757148daa0c80,
	.signature_hash=	_JC_JLONG(0x77a757148daa0c80),
	.access_flags=		_JC_ACC_PRIVATE|_JC_ACC_FINAL,
	.function=		&_jc_polyglot_util_TypedList$method$tryMod$77a757148daa0c80,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_util_TypedList$vtable, polyglot_util_TypedList.tryMod$77a757148daa0c80) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_polyglot_util_TypedList$linenum_table$tryMod$77a757148daa0c80
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_util_TypedList, tryMod$77a757148daa0c80);

void _JC_JCNI_ATTR
_jc_polyglot_util_TypedList$method$tryMod$77a757148daa0c80(_jc_env *const env, _jc_polyglot_util_TypedList$object *this)
{
	struct _jc_polyglot_util_TypedList$object *r0;
	struct _jc_java_lang_UnsupportedOperationException$object *r1;
	struct _jc_java_lang_String$object *r2;
	struct _jc_java_lang_VMThrowable$object *r4;
	jboolean z0;

	r0 = this;
	_JC_LINE_NUMBER(208);				// 0
	z0 = _JC_PRIM_FIELD(env, r0, polyglot_util_TypedList, immutable);
	if (z0 == 0)
		goto label0;
	_JC_LINE_NUMBER(209);				// 1
	r1 = _JC_NEW(env, java_lang_UnsupportedOperationException);
	r2 = _JC_STRING(env, "Change to an immutable TypedListIterator");
	_JC_REF_FIELD(env, r1, java_lang_Throwable, cause) = r1;
	r4 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r1);
	_JC_REF_FIELD(env, r1, java_lang_Throwable, vmState) = r4;
	_JC_REF_FIELD(env, r1, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r1, java_lang_Throwable, detailMessage) = r2;
	_JC_THROW(env, r1);

label0:
	_JC_LINE_NUMBER(211);				// 2
	return;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_polyglot_util_TypedList$methods[] = {
	&_jc_polyglot_util_TypedList$method_info$_init$07fc2fcb4ae4264f,
	&_jc_polyglot_util_TypedList$method_info$add$9953f092f36e3303,
	&_jc_polyglot_util_TypedList$method_info$add$831f06ee5f59c0cc,
	&_jc_polyglot_util_TypedList$method_info$addAll$28b94b9c09be8eeb,
	&_jc_polyglot_util_TypedList$method_info$addAll$77406cdf3002027f,
	&_jc_polyglot_util_TypedList$method_info$check$0be7ab6614c62cd9,
	&_jc_polyglot_util_TypedList$method_info$clear$0a5acde3ee27a066,
	&_jc_polyglot_util_TypedList$method_info$clone$b75f2713d6705f70,
	&_jc_polyglot_util_TypedList$method_info$contains$d3bd70da40f05cb1,
	&_jc_polyglot_util_TypedList$method_info$containsAll$84ec995bc785c34c,
	&_jc_polyglot_util_TypedList$method_info$copy$203627e18f3ed3e7,
	&_jc_polyglot_util_TypedList$method_info$copy$71a2e8e56d8c3e66,
	&_jc_polyglot_util_TypedList$method_info$copyAndCheck$1016e6b265d21143,
	&_jc_polyglot_util_TypedList$method_info$equals$8a15e0625571c581,
	&_jc_polyglot_util_TypedList$method_info$get$a706240e1333824b,
	&_jc_polyglot_util_TypedList$method_info$getAllowedType$0528d70a096ec4c4,
	&_jc_polyglot_util_TypedList$method_info$hashCode$53152098849316df,
	&_jc_polyglot_util_TypedList$method_info$indexOf$59e53868af339edb,
	&_jc_polyglot_util_TypedList$method_info$isEmpty$551bea84f4e0f0cb,
	&_jc_polyglot_util_TypedList$method_info$iterator$3cc91493d50f531c,
	&_jc_polyglot_util_TypedList$method_info$lastIndexOf$af030ff733adf0f9,
	&_jc_polyglot_util_TypedList$method_info$listIterator$7f39f4d760c285dd,
	&_jc_polyglot_util_TypedList$method_info$listIterator$5712c48727d9c4a4,
	&_jc_polyglot_util_TypedList$method_info$remove$ce2b087495782dc2,
	&_jc_polyglot_util_TypedList$method_info$remove$d21babbbb7fafe72,
	&_jc_polyglot_util_TypedList$method_info$removeAll$33b663ddc346139b,
	&_jc_polyglot_util_TypedList$method_info$retainAll$f1bc65ece6de3bda,
	&_jc_polyglot_util_TypedList$method_info$set$21145a3aa89a3e6d,
	&_jc_polyglot_util_TypedList$method_info$size$345df5220fc60ade,
	&_jc_polyglot_util_TypedList$method_info$subList$af8e3c69195dae35,
	&_jc_polyglot_util_TypedList$method_info$toArray$408321282fd84959,
	&_jc_polyglot_util_TypedList$method_info$toArray$b7264a1d378ca224,
	&_jc_polyglot_util_TypedList$method_info$toString$7ea43b33b80a3070,
	&_jc_polyglot_util_TypedList$method_info$tryIns$53769493cc547601,
	&_jc_polyglot_util_TypedList$method_info$tryIns$498c284b0eb9c0f5,
	&_jc_polyglot_util_TypedList$method_info$tryMod$77a757148daa0c80
};

/************************************************************************
 *			  Class fields structure			*
 ************************************************************************/

_jc_polyglot_util_TypedList$fields_struct _jc_polyglot_util_TypedList$class_fields = { };

/************************************************************************
 *			      Interface list				*
 ************************************************************************/

// Directly implemented interfaces
static _jc_type *const _jc_polyglot_util_TypedList$interfaces[] = {
	&_jc_java_util_List$type,
	&_jc_java_io_Serializable$type
};

/************************************************************************
 *			   Interface hash table				*
 ************************************************************************/

#if _JC_IMETHOD_HASHSIZE != 128
#error "_JC_IMETHOD_HASHSIZE has the wrong value (should be 128)"
#endif

// Interface lookup hash table buckets
static _jc_method *_jc_polyglot_util_TypedList$imethod_hash_bucket_1[] = {
	&_jc_polyglot_util_TypedList$method_info$equals$8a15e0625571c581,
	_JC_NULL
};
static _jc_method *_jc_polyglot_util_TypedList$imethod_hash_bucket_3[] = {
	&_jc_polyglot_util_TypedList$method_info$add$9953f092f36e3303,
	_JC_NULL
};
static _jc_method *_jc_polyglot_util_TypedList$imethod_hash_bucket_27[] = {
	&_jc_polyglot_util_TypedList$method_info$removeAll$33b663ddc346139b,
	_JC_NULL
};
static _jc_method *_jc_polyglot_util_TypedList$imethod_hash_bucket_28[] = {
	&_jc_polyglot_util_TypedList$method_info$iterator$3cc91493d50f531c,
	_JC_NULL
};
static _jc_method *_jc_polyglot_util_TypedList$imethod_hash_bucket_36[] = {
	&_jc_polyglot_util_TypedList$method_info$listIterator$5712c48727d9c4a4,
	&_jc_polyglot_util_TypedList$method_info$toArray$b7264a1d378ca224,
	_JC_NULL
};
static _jc_method *_jc_polyglot_util_TypedList$imethod_hash_bucket_49[] = {
	&_jc_polyglot_util_TypedList$method_info$contains$d3bd70da40f05cb1,
	_JC_NULL
};
static _jc_method *_jc_polyglot_util_TypedList$imethod_hash_bucket_53[] = {
	&_jc_polyglot_util_TypedList$method_info$subList$af8e3c69195dae35,
	_JC_NULL
};
static _jc_method *_jc_polyglot_util_TypedList$imethod_hash_bucket_66[] = {
	&_jc_polyglot_util_TypedList$method_info$remove$ce2b087495782dc2,
	_JC_NULL
};
static _jc_method *_jc_polyglot_util_TypedList$imethod_hash_bucket_75[] = {
	&_jc_polyglot_util_TypedList$method_info$get$a706240e1333824b,
	&_jc_polyglot_util_TypedList$method_info$isEmpty$551bea84f4e0f0cb,
	_JC_NULL
};
static _jc_method *_jc_polyglot_util_TypedList$imethod_hash_bucket_76[] = {
	&_jc_polyglot_util_TypedList$method_info$add$831f06ee5f59c0cc,
	&_jc_polyglot_util_TypedList$method_info$containsAll$84ec995bc785c34c,
	_JC_NULL
};
static _jc_method *_jc_polyglot_util_TypedList$imethod_hash_bucket_89[] = {
	&_jc_polyglot_util_TypedList$method_info$toArray$408321282fd84959,
	_JC_NULL
};
static _jc_method *_jc_polyglot_util_TypedList$imethod_hash_bucket_90[] = {
	&_jc_polyglot_util_TypedList$method_info$retainAll$f1bc65ece6de3bda,
	_JC_NULL
};
static _jc_method *_jc_polyglot_util_TypedList$imethod_hash_bucket_91[] = {
	&_jc_polyglot_util_TypedList$method_info$indexOf$59e53868af339edb,
	_JC_NULL
};
static _jc_method *_jc_polyglot_util_TypedList$imethod_hash_bucket_93[] = {
	&_jc_polyglot_util_TypedList$method_info$listIterator$7f39f4d760c285dd,
	_JC_NULL
};
static _jc_method *_jc_polyglot_util_TypedList$imethod_hash_bucket_94[] = {
	&_jc_polyglot_util_TypedList$method_info$size$345df5220fc60ade,
	_JC_NULL
};
static _jc_method *_jc_polyglot_util_TypedList$imethod_hash_bucket_95[] = {
	&_jc_polyglot_util_TypedList$method_info$hashCode$53152098849316df,
	_JC_NULL
};
static _jc_method *_jc_polyglot_util_TypedList$imethod_hash_bucket_102[] = {
	&_jc_polyglot_util_TypedList$method_info$clear$0a5acde3ee27a066,
	_JC_NULL
};
static _jc_method *_jc_polyglot_util_TypedList$imethod_hash_bucket_107[] = {
	&_jc_polyglot_util_TypedList$method_info$addAll$28b94b9c09be8eeb,
	_JC_NULL
};
static _jc_method *_jc_polyglot_util_TypedList$imethod_hash_bucket_109[] = {
	&_jc_polyglot_util_TypedList$method_info$set$21145a3aa89a3e6d,
	_JC_NULL
};
static _jc_method *_jc_polyglot_util_TypedList$imethod_hash_bucket_114[] = {
	&_jc_polyglot_util_TypedList$method_info$remove$d21babbbb7fafe72,
	_JC_NULL
};
static _jc_method *_jc_polyglot_util_TypedList$imethod_hash_bucket_121[] = {
	&_jc_polyglot_util_TypedList$method_info$lastIndexOf$af030ff733adf0f9,
	_JC_NULL
};
static _jc_method *_jc_polyglot_util_TypedList$imethod_hash_bucket_127[] = {
	&_jc_polyglot_util_TypedList$method_info$addAll$77406cdf3002027f,
	_JC_NULL
};

// Interface lookup hash table
static _jc_method **_jc_polyglot_util_TypedList$imethod_hash_table[_JC_IMETHOD_HASHSIZE] = {
	[1]=	_jc_polyglot_util_TypedList$imethod_hash_bucket_1,
	[3]=	_jc_polyglot_util_TypedList$imethod_hash_bucket_3,
	[27]=	_jc_polyglot_util_TypedList$imethod_hash_bucket_27,
	[28]=	_jc_polyglot_util_TypedList$imethod_hash_bucket_28,
	[36]=	_jc_polyglot_util_TypedList$imethod_hash_bucket_36,
	[49]=	_jc_polyglot_util_TypedList$imethod_hash_bucket_49,
	[53]=	_jc_polyglot_util_TypedList$imethod_hash_bucket_53,
	[66]=	_jc_polyglot_util_TypedList$imethod_hash_bucket_66,
	[75]=	_jc_polyglot_util_TypedList$imethod_hash_bucket_75,
	[76]=	_jc_polyglot_util_TypedList$imethod_hash_bucket_76,
	[89]=	_jc_polyglot_util_TypedList$imethod_hash_bucket_89,
	[90]=	_jc_polyglot_util_TypedList$imethod_hash_bucket_90,
	[91]=	_jc_polyglot_util_TypedList$imethod_hash_bucket_91,
	[93]=	_jc_polyglot_util_TypedList$imethod_hash_bucket_93,
	[94]=	_jc_polyglot_util_TypedList$imethod_hash_bucket_94,
	[95]=	_jc_polyglot_util_TypedList$imethod_hash_bucket_95,
	[102]=	_jc_polyglot_util_TypedList$imethod_hash_bucket_102,
	[107]=	_jc_polyglot_util_TypedList$imethod_hash_bucket_107,
	[109]=	_jc_polyglot_util_TypedList$imethod_hash_bucket_109,
	[114]=	_jc_polyglot_util_TypedList$imethod_hash_bucket_114,
	[121]=	_jc_polyglot_util_TypedList$imethod_hash_bucket_121,
	[127]=	_jc_polyglot_util_TypedList$imethod_hash_bucket_127
};

// Interface "quick" lookup hash table
static const void *_jc_polyglot_util_TypedList$imethod_quick_table[_JC_IMETHOD_HASHSIZE] = {
	[1]=	&_jc_polyglot_util_TypedList$method$equals$8a15e0625571c581,
	[3]=	&_jc_polyglot_util_TypedList$method$add$9953f092f36e3303,
	[27]=	&_jc_polyglot_util_TypedList$method$removeAll$33b663ddc346139b,
	[28]=	&_jc_polyglot_util_TypedList$method$iterator$3cc91493d50f531c,
	[49]=	&_jc_polyglot_util_TypedList$method$contains$d3bd70da40f05cb1,
	[53]=	&_jc_polyglot_util_TypedList$method$subList$af8e3c69195dae35,
	[66]=	&_jc_polyglot_util_TypedList$method$remove$ce2b087495782dc2,
	[89]=	&_jc_polyglot_util_TypedList$method$toArray$408321282fd84959,
	[90]=	&_jc_polyglot_util_TypedList$method$retainAll$f1bc65ece6de3bda,
	[91]=	&_jc_polyglot_util_TypedList$method$indexOf$59e53868af339edb,
	[93]=	&_jc_polyglot_util_TypedList$method$listIterator$7f39f4d760c285dd,
	[94]=	&_jc_polyglot_util_TypedList$method$size$345df5220fc60ade,
	[95]=	&_jc_polyglot_util_TypedList$method$hashCode$53152098849316df,
	[102]=	&_jc_polyglot_util_TypedList$method$clear$0a5acde3ee27a066,
	[107]=	&_jc_polyglot_util_TypedList$method$addAll$28b94b9c09be8eeb,
	[109]=	&_jc_polyglot_util_TypedList$method$set$21145a3aa89a3e6d,
	[114]=	&_jc_polyglot_util_TypedList$method$remove$d21babbbb7fafe72,
	[121]=	&_jc_polyglot_util_TypedList$method$lastIndexOf$af030ff733adf0f9,
	[127]=	&_jc_polyglot_util_TypedList$method$addAll$77406cdf3002027f
};

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_polyglot_util_TypedList$instanceof_hash_bucket_18[] = {
	&_jc_polyglot_util_TypedList$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_util_TypedList$instanceof_hash_bucket_65[] = {
	&_jc_java_io_Serializable$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_util_TypedList$instanceof_hash_bucket_77[] = {
	&_jc_java_util_List$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_util_TypedList$instanceof_hash_bucket_90[] = {
	&_jc_java_util_Collection$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_util_TypedList$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_polyglot_util_TypedList$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[18]=	_jc_polyglot_util_TypedList$instanceof_hash_bucket_18,
	[65]=	_jc_polyglot_util_TypedList$instanceof_hash_bucket_65,
	[77]=	_jc_polyglot_util_TypedList$instanceof_hash_bucket_77,
	[90]=	_jc_polyglot_util_TypedList$instanceof_hash_bucket_90,
	[101]=	_jc_polyglot_util_TypedList$instanceof_hash_bucket_101
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_polyglot_util_TypedList$class_depends[] = {
	{ "java/io/Serializable",	_JC_JLONG(0x9a35c7173b37e641) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/IllegalArgumentException",	_JC_JLONG(0x680cf34d05feb5a1) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/RuntimeException",	_JC_JLONG(0x4f5534a987354d1d) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/StringBuffer",	_JC_JLONG(0x94d357637b968dda) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/UnsupportedOperationException",	_JC_JLONG(0xc4b275d49bb21d98) },
	{ "java/lang/VMClass",	_JC_JLONG(0x238a2c0aafd74314) },
	{ "java/lang/VMObject",	_JC_JLONG(0x312e45ed214d432f) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/util/AbstractCollection",	_JC_JLONG(0x8ea716c64b77f8eb) },
	{ "java/util/AbstractList",	_JC_JLONG(0xf5238436362828db) },
	{ "java/util/ArrayList",	_JC_JLONG(0x58038509830ef3f4) },
	{ "java/util/Collection",	_JC_JLONG(0xeae4d0c0e8eb63da) },
	{ "java/util/Iterator",	_JC_JLONG(0xbe56ff673eefd9d2) },
	{ "java/util/List",	_JC_JLONG(0x9ee0d92ce1525a4d) },
	{ "java/util/ListIterator",	_JC_JLONG(0x9842856e8b4dbb) },
	{ "polyglot/util/TypedListIterator",	_JC_JLONG(0x17638e1377601085) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_polyglot_util_TypedList$vtype _jc_polyglot_util_TypedList$type = {
    .type= {
	.name=			"polyglot/util/TypedList",
	.superclass=		&_jc_java_lang_Object$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.num_interfaces=sizeof(_jc_polyglot_util_TypedList$interfaces) / sizeof(*_jc_polyglot_util_TypedList$interfaces),
	.interfaces=		_jc_polyglot_util_TypedList$interfaces,
	.imethod_hash_table=	_jc_polyglot_util_TypedList$imethod_hash_table,
	.imethod_quick_table=	_jc_polyglot_util_TypedList$imethod_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		43,
		.hash=			_JC_JLONG(0x8ddf0f1b6db92e92),
		.source_file=		"TypedList.java",
		.instance_size=		sizeof(_jc_polyglot_util_TypedList$refs) + sizeof(_jc_polyglot_util_TypedList$object),
		.num_virtual_refs=	2,
		.num_fields=		sizeof(_jc_polyglot_util_TypedList$fields) / sizeof(*_jc_polyglot_util_TypedList$fields),
		.fields=		_jc_polyglot_util_TypedList$fields,
		.num_methods=		sizeof(_jc_polyglot_util_TypedList$methods) / sizeof(*_jc_polyglot_util_TypedList$methods),
		.methods=		_jc_polyglot_util_TypedList$methods,
		.instanceof_hash_table=	_jc_polyglot_util_TypedList$instanceof_hash_table,
		.class_fields=		&_jc_polyglot_util_TypedList$class_fields,
		.num_class_depends=		sizeof(_jc_polyglot_util_TypedList$class_depends) / sizeof(*_jc_polyglot_util_TypedList$class_depends),
		.class_depends=		_jc_polyglot_util_TypedList$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=			// overridden
		&_jc_polyglot_util_TypedList$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=			// overridden
		&_jc_polyglot_util_TypedList$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=			// overridden
		&_jc_polyglot_util_TypedList$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=			// overridden
		&_jc_polyglot_util_TypedList$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.polyglot_util_TypedList= {
	    .add$9953f092f36e3303=
		&_jc_polyglot_util_TypedList$method$add$9953f092f36e3303,
	    .add$831f06ee5f59c0cc=
		&_jc_polyglot_util_TypedList$method$add$831f06ee5f59c0cc,
	    .addAll$28b94b9c09be8eeb=
		&_jc_polyglot_util_TypedList$method$addAll$28b94b9c09be8eeb,
	    .addAll$77406cdf3002027f=
		&_jc_polyglot_util_TypedList$method$addAll$77406cdf3002027f,
	    .clear$0a5acde3ee27a066=
		&_jc_polyglot_util_TypedList$method$clear$0a5acde3ee27a066,
	    .clone$b75f2713d6705f70=
		&_jc_polyglot_util_TypedList$method$clone$b75f2713d6705f70,
	    .contains$d3bd70da40f05cb1=
		&_jc_polyglot_util_TypedList$method$contains$d3bd70da40f05cb1,
	    .containsAll$84ec995bc785c34c=
		&_jc_polyglot_util_TypedList$method$containsAll$84ec995bc785c34c,
	    .copy$203627e18f3ed3e7=
		&_jc_polyglot_util_TypedList$method$copy$203627e18f3ed3e7,
	    .equals$8a15e0625571c581=
		&_jc_polyglot_util_TypedList$method$equals$8a15e0625571c581,
	    .get$a706240e1333824b=
		&_jc_polyglot_util_TypedList$method$get$a706240e1333824b,
	    .getAllowedType$0528d70a096ec4c4=
		&_jc_polyglot_util_TypedList$method$getAllowedType$0528d70a096ec4c4,
	    .hashCode$53152098849316df=
		&_jc_polyglot_util_TypedList$method$hashCode$53152098849316df,
	    .indexOf$59e53868af339edb=
		&_jc_polyglot_util_TypedList$method$indexOf$59e53868af339edb,
	    .isEmpty$551bea84f4e0f0cb=
		&_jc_polyglot_util_TypedList$method$isEmpty$551bea84f4e0f0cb,
	    .iterator$3cc91493d50f531c=
		&_jc_polyglot_util_TypedList$method$iterator$3cc91493d50f531c,
	    .lastIndexOf$af030ff733adf0f9=
		&_jc_polyglot_util_TypedList$method$lastIndexOf$af030ff733adf0f9,
	    .listIterator$7f39f4d760c285dd=
		&_jc_polyglot_util_TypedList$method$listIterator$7f39f4d760c285dd,
	    .listIterator$5712c48727d9c4a4=
		&_jc_polyglot_util_TypedList$method$listIterator$5712c48727d9c4a4,
	    .remove$ce2b087495782dc2=
		&_jc_polyglot_util_TypedList$method$remove$ce2b087495782dc2,
	    .remove$d21babbbb7fafe72=
		&_jc_polyglot_util_TypedList$method$remove$d21babbbb7fafe72,
	    .removeAll$33b663ddc346139b=
		&_jc_polyglot_util_TypedList$method$removeAll$33b663ddc346139b,
	    .retainAll$f1bc65ece6de3bda=
		&_jc_polyglot_util_TypedList$method$retainAll$f1bc65ece6de3bda,
	    .set$21145a3aa89a3e6d=
		&_jc_polyglot_util_TypedList$method$set$21145a3aa89a3e6d,
	    .size$345df5220fc60ade=
		&_jc_polyglot_util_TypedList$method$size$345df5220fc60ade,
	    .subList$af8e3c69195dae35=
		&_jc_polyglot_util_TypedList$method$subList$af8e3c69195dae35,
	    .toArray$408321282fd84959=
		&_jc_polyglot_util_TypedList$method$toArray$408321282fd84959,
	    .toArray$b7264a1d378ca224=
		&_jc_polyglot_util_TypedList$method$toArray$b7264a1d378ca224,
	    .toString$7ea43b33b80a3070=
		&_jc_polyglot_util_TypedList$method$toString$7ea43b33b80a3070,
	    .tryIns$53769493cc547601=
		&_jc_polyglot_util_TypedList$method$tryIns$53769493cc547601,
	    .tryIns$498c284b0eb9c0f5=
		&_jc_polyglot_util_TypedList$method$tryIns$498c284b0eb9c0f5,
	    .tryMod$77a757148daa0c80=
		&_jc_polyglot_util_TypedList$method$tryMod$77a757148daa0c80,
	},
    }
};

