// class polyglot.util.typedump.TypeDumper

// class file dependencies
// @dep_class 4e0a56550c69d57c java_io_IOException
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class b0527a7101321261 java_lang_ClassLoader
// @dep_class 1f925cf50bfc0d6c java_lang_ClassNotFoundException
// @dep_class 308333d803f5ab9f java_lang_Error
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class 29deac5351715967 java_lang_IllegalAccessException
// @dep_class 680cf34d05feb5a1 java_lang_IllegalArgumentException
// @dep_class 3746e17e005bda9e java_lang_LinkageError
// @dep_class 72c9d9e8f269fac java_lang_Long
// @dep_class 8d71d806a180ad8a java_lang_Math
// @dep_class 2082ebb592ac2255 java_lang_NoClassDefFoundError
// @dep_class b466c3d2a1fb976d java_lang_NoSuchFieldException
// @dep_class 505b8a9a6675be0 java_lang_NullPointerException
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class affa3b3edb623a4e java_lang_Package
// @dep_class 4f5534a987354d1d java_lang_RuntimeException
// @dep_class 767fc1626c63609e java_lang_SecurityException
// @dep_class d38282f3d5f80887 java_lang_SecurityManager
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 94d357637b968dda java_lang_StringBuffer
// @dep_class 53cc8e2333795f04 java_lang_System
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class 238a2c0aafd74314 java_lang_VMClass
// @dep_class 312e45ed214d432f java_lang_VMObject
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class 2272439d2affe42f java_lang_reflect_AccessibleObject
// @dep_class a19b05adac48346b java_lang_reflect_Field
// @dep_class b413af5dc930e175 java_lang_reflect_Modifier
// @dep_class 217a96fa40004e5 java_lang_reflect_ReflectPermission
// @dep_class d5158e4c9a3bab21 java_security_BasicPermission
// @dep_class 2377c76e79058a72 java_security_Permission
// @dep_class 8ea716c64b77f8eb java_util_AbstractCollection
// @dep_class f5238436362828db java_util_AbstractList
// @dep_class 21dd4c24cb5af7f8 java_util_AbstractList__241
// @dep_class ca427569b5b2f804 java_util_AbstractSet
// @dep_class 363c8597b4f8d5ff java_util_Arrays
// @dep_class 4a2b9f35d0d4bf7d java_util_Arrays__24ArrayList
// @dep_class a85d2a51094e614c java_util_Date
// @dep_class d7cd853200c3e71f java_util_HashMap
// @dep_class 3c285c721478414d java_util_HashSet
// @dep_class e283f7c2e7a7979c java_util_Map
// @dep_class 617ac82c0bec2dff java_util_Set
// @dep_class 6596051546781098 polyglot_types_Type
// @dep_class ed171cdaca38ec28 polyglot_types_TypeSystem
// @dep_class bda7215170a25efc polyglot_util_CodeWriter
// @dep_class f299688fad53c0b2 polyglot_util_TypeEncoder
// @dep_class ce9c276c03241184 polyglot_util_typedump_TypeDumper

// header file dependencies
// @dep_header java_io_IOException
// @dep_header java_lang_Class
// @dep_header java_lang_ClassLoader
// @dep_header java_lang_ClassNotFoundException
// @dep_header java_lang_IllegalAccessException
// @dep_header java_lang_IllegalArgumentException
// @dep_header java_lang_Long
// @dep_header java_lang_Math
// @dep_header java_lang_NoClassDefFoundError
// @dep_header java_lang_NoSuchFieldException
// @dep_header java_lang_NullPointerException
// @dep_header java_lang_Package
// @dep_header java_lang_SecurityException
// @dep_header java_lang_SecurityManager
// @dep_header java_lang_String
// @dep_header java_lang_StringBuffer
// @dep_header java_lang_System
// @dep_header java_lang_VMClass
// @dep_header java_lang_VMObject
// @dep_header java_lang_VMThrowable
// @dep_header java_lang_reflect_Field
// @dep_header java_lang_reflect_Modifier
// @dep_header java_lang_reflect_ReflectPermission
// @dep_header java_util_AbstractList__241
// @dep_header java_util_Arrays
// @dep_header java_util_Arrays__24ArrayList
// @dep_header java_util_Date
// @dep_header java_util_HashMap
// @dep_header java_util_HashSet
// @dep_header java_util_Map
// @dep_header java_util_Set
// @dep_header polyglot_types_Type
// @dep_header polyglot_types_TypeSystem
// @dep_header polyglot_util_CodeWriter
// @dep_header polyglot_util_TypeEncoder
// @dep_header polyglot_util_typedump_TypeDumper

#include "jc_defs.h"

#include "java/io/IOException.h"
#include "java/lang/Class.h"
#include "java/lang/ClassLoader.h"
#include "java/lang/ClassNotFoundException.h"
#include "java/lang/IllegalAccessException.h"
#include "java/lang/IllegalArgumentException.h"
#include "java/lang/Long.h"
#include "java/lang/Math.h"
#include "java/lang/NoClassDefFoundError.h"
#include "java/lang/NoSuchFieldException.h"
#include "java/lang/NullPointerException.h"
#include "java/lang/Package.h"
#include "java/lang/SecurityException.h"
#include "java/lang/SecurityManager.h"
#include "java/lang/String.h"
#include "java/lang/StringBuffer.h"
#include "java/lang/System.h"
#include "java/lang/VMClass.h"
#include "java/lang/VMObject.h"
#include "java/lang/VMThrowable.h"
#include "java/lang/reflect/Field.h"
#include "java/lang/reflect/Modifier.h"
#include "java/lang/reflect/ReflectPermission.h"
#include "java/util/AbstractList__241.h"
#include "java/util/Arrays.h"
#include "java/util/Arrays__24ArrayList.h"
#include "java/util/Date.h"
#include "java/util/HashMap.h"
#include "java/util/HashSet.h"
#include "java/util/Map.h"
#include "java/util/Set.h"
#include "polyglot/types/Type.h"
#include "polyglot/types/TypeSystem.h"
#include "polyglot/util/CodeWriter.h"
#include "polyglot/util/TypeEncoder.h"
#include "polyglot/util/typedump/TypeDumper.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// static java.util.Set dontExpand
static _jc_field _jc_polyglot_util_typedump_TypeDumper$field_info$dontExpand = {
	.name=		"dontExpand",
	.signature=	"Ljava/util/Set;",
	.class=		&_jc_polyglot_util_typedump_TypeDumper$type,
	.type=		&_jc_java_util_Set$type,
	.access_flags=	_JC_ACC_STATIC,
	.offset=	_JC_OFFSETOF(_jc_polyglot_util_typedump_TypeDumper$fields_struct, dontExpand),
};

// polyglot.types.Type theType
static _jc_field _jc_polyglot_util_typedump_TypeDumper$field_info$theType = {
	.name=		"theType",
	.signature=	"Lpolyglot/types/Type;",
	.class=		&_jc_polyglot_util_typedump_TypeDumper$type,
	.type=		&_jc_polyglot_types_Type$type,
	.access_flags=	0,
	.offset=	_JC_OFFSETOF(_jc_polyglot_util_typedump_TypeDumper$object, refs[-1].polyglot_util_typedump_TypeDumper.theType),
};

// java.lang.String rawName
static _jc_field _jc_polyglot_util_typedump_TypeDumper$field_info$rawName = {
	.name=		"rawName",
	.signature=	"Ljava/lang/String;",
	.class=		&_jc_polyglot_util_typedump_TypeDumper$type,
	.type=		&_jc_java_lang_String$type,
	.access_flags=	0,
	.offset=	_JC_OFFSETOF(_jc_polyglot_util_typedump_TypeDumper$object, refs[-1].polyglot_util_typedump_TypeDumper.rawName),
};

// java.lang.String compilerVersion
static _jc_field _jc_polyglot_util_typedump_TypeDumper$field_info$compilerVersion = {
	.name=		"compilerVersion",
	.signature=	"Ljava/lang/String;",
	.class=		&_jc_polyglot_util_typedump_TypeDumper$type,
	.type=		&_jc_java_lang_String$type,
	.access_flags=	0,
	.offset=	_JC_OFFSETOF(_jc_polyglot_util_typedump_TypeDumper$object, refs[-1].polyglot_util_typedump_TypeDumper.compilerVersion),
};

// java.util.Date timestamp
static _jc_field _jc_polyglot_util_typedump_TypeDumper$field_info$timestamp = {
	.name=		"timestamp",
	.signature=	"Ljava/util/Date;",
	.class=		&_jc_polyglot_util_typedump_TypeDumper$type,
	.type=		&_jc_java_util_Date$type,
	.access_flags=	0,
	.offset=	_JC_OFFSETOF(_jc_polyglot_util_typedump_TypeDumper$object, refs[-1].polyglot_util_typedump_TypeDumper.timestamp),
};

// static java.lang.Class class$java$lang$Void
static _jc_field _jc_polyglot_util_typedump_TypeDumper$field_info$class__24java__24lang__24Void = {
	.name=		"class$java$lang$Void",
	.signature=	"Ljava/lang/Class;",
	.class=		&_jc_polyglot_util_typedump_TypeDumper$type,
	.type=		&_jc_java_lang_Class$type,
	.access_flags=	_JC_ACC_STATIC,
	.offset=	_JC_OFFSETOF(_jc_polyglot_util_typedump_TypeDumper$fields_struct, class__24java__24lang__24Void),
};

// static java.lang.Class class$java$lang$Boolean
static _jc_field _jc_polyglot_util_typedump_TypeDumper$field_info$class__24java__24lang__24Boolean = {
	.name=		"class$java$lang$Boolean",
	.signature=	"Ljava/lang/Class;",
	.class=		&_jc_polyglot_util_typedump_TypeDumper$type,
	.type=		&_jc_java_lang_Class$type,
	.access_flags=	_JC_ACC_STATIC,
	.offset=	_JC_OFFSETOF(_jc_polyglot_util_typedump_TypeDumper$fields_struct, class__24java__24lang__24Boolean),
};

// static java.lang.Class class$java$lang$Short
static _jc_field _jc_polyglot_util_typedump_TypeDumper$field_info$class__24java__24lang__24Short = {
	.name=		"class$java$lang$Short",
	.signature=	"Ljava/lang/Class;",
	.class=		&_jc_polyglot_util_typedump_TypeDumper$type,
	.type=		&_jc_java_lang_Class$type,
	.access_flags=	_JC_ACC_STATIC,
	.offset=	_JC_OFFSETOF(_jc_polyglot_util_typedump_TypeDumper$fields_struct, class__24java__24lang__24Short),
};

// static java.lang.Class class$java$lang$Integer
static _jc_field _jc_polyglot_util_typedump_TypeDumper$field_info$class__24java__24lang__24Integer = {
	.name=		"class$java$lang$Integer",
	.signature=	"Ljava/lang/Class;",
	.class=		&_jc_polyglot_util_typedump_TypeDumper$type,
	.type=		&_jc_java_lang_Class$type,
	.access_flags=	_JC_ACC_STATIC,
	.offset=	_JC_OFFSETOF(_jc_polyglot_util_typedump_TypeDumper$fields_struct, class__24java__24lang__24Integer),
};

// static java.lang.Class class$java$lang$Long
static _jc_field _jc_polyglot_util_typedump_TypeDumper$field_info$class__24java__24lang__24Long = {
	.name=		"class$java$lang$Long",
	.signature=	"Ljava/lang/Class;",
	.class=		&_jc_polyglot_util_typedump_TypeDumper$type,
	.type=		&_jc_java_lang_Class$type,
	.access_flags=	_JC_ACC_STATIC,
	.offset=	_JC_OFFSETOF(_jc_polyglot_util_typedump_TypeDumper$fields_struct, class__24java__24lang__24Long),
};

// static java.lang.Class class$java$lang$Float
static _jc_field _jc_polyglot_util_typedump_TypeDumper$field_info$class__24java__24lang__24Float = {
	.name=		"class$java$lang$Float",
	.signature=	"Ljava/lang/Class;",
	.class=		&_jc_polyglot_util_typedump_TypeDumper$type,
	.type=		&_jc_java_lang_Class$type,
	.access_flags=	_JC_ACC_STATIC,
	.offset=	_JC_OFFSETOF(_jc_polyglot_util_typedump_TypeDumper$fields_struct, class__24java__24lang__24Float),
};

// static java.lang.Class class$java$lang$Double
static _jc_field _jc_polyglot_util_typedump_TypeDumper$field_info$class__24java__24lang__24Double = {
	.name=		"class$java$lang$Double",
	.signature=	"Ljava/lang/Class;",
	.class=		&_jc_polyglot_util_typedump_TypeDumper$type,
	.type=		&_jc_java_lang_Class$type,
	.access_flags=	_JC_ACC_STATIC,
	.offset=	_JC_OFFSETOF(_jc_polyglot_util_typedump_TypeDumper$fields_struct, class__24java__24lang__24Double),
};

// static java.lang.Class class$java$lang$Class
static _jc_field _jc_polyglot_util_typedump_TypeDumper$field_info$class__24java__24lang__24Class = {
	.name=		"class$java$lang$Class",
	.signature=	"Ljava/lang/Class;",
	.class=		&_jc_polyglot_util_typedump_TypeDumper$type,
	.type=		&_jc_java_lang_Class$type,
	.access_flags=	_JC_ACC_STATIC,
	.offset=	_JC_OFFSETOF(_jc_polyglot_util_typedump_TypeDumper$fields_struct, class__24java__24lang__24Class),
};

// static java.lang.Class class$java$lang$String
static _jc_field _jc_polyglot_util_typedump_TypeDumper$field_info$class__24java__24lang__24String = {
	.name=		"class$java$lang$String",
	.signature=	"Ljava/lang/Class;",
	.class=		&_jc_polyglot_util_typedump_TypeDumper$type,
	.type=		&_jc_java_lang_Class$type,
	.access_flags=	_JC_ACC_STATIC,
	.offset=	_JC_OFFSETOF(_jc_polyglot_util_typedump_TypeDumper$fields_struct, class__24java__24lang__24String),
};

// static java.lang.Class class$java$lang$Object
static _jc_field _jc_polyglot_util_typedump_TypeDumper$field_info$class__24java__24lang__24Object = {
	.name=		"class$java$lang$Object",
	.signature=	"Ljava/lang/Class;",
	.class=		&_jc_polyglot_util_typedump_TypeDumper$type,
	.type=		&_jc_java_lang_Class$type,
	.access_flags=	_JC_ACC_STATIC,
	.offset=	_JC_OFFSETOF(_jc_polyglot_util_typedump_TypeDumper$fields_struct, class__24java__24lang__24Object),
};

// Fields
static _jc_field *const _jc_polyglot_util_typedump_TypeDumper$fields[] = {
	&_jc_polyglot_util_typedump_TypeDumper$field_info$class__24java__24lang__24Boolean,
	&_jc_polyglot_util_typedump_TypeDumper$field_info$class__24java__24lang__24Class,
	&_jc_polyglot_util_typedump_TypeDumper$field_info$class__24java__24lang__24Double,
	&_jc_polyglot_util_typedump_TypeDumper$field_info$class__24java__24lang__24Float,
	&_jc_polyglot_util_typedump_TypeDumper$field_info$class__24java__24lang__24Integer,
	&_jc_polyglot_util_typedump_TypeDumper$field_info$class__24java__24lang__24Long,
	&_jc_polyglot_util_typedump_TypeDumper$field_info$class__24java__24lang__24Object,
	&_jc_polyglot_util_typedump_TypeDumper$field_info$class__24java__24lang__24Short,
	&_jc_polyglot_util_typedump_TypeDumper$field_info$class__24java__24lang__24String,
	&_jc_polyglot_util_typedump_TypeDumper$field_info$class__24java__24lang__24Void,
	&_jc_polyglot_util_typedump_TypeDumper$field_info$dontExpand,
	&_jc_polyglot_util_typedump_TypeDumper$field_info$compilerVersion,
	&_jc_polyglot_util_typedump_TypeDumper$field_info$rawName,
	&_jc_polyglot_util_typedump_TypeDumper$field_info$theType,
	&_jc_polyglot_util_typedump_TypeDumper$field_info$timestamp
};

/************************************************************************
 *			      Static methods				*
 ************************************************************************/

//
// static void <clinit>()
//

static _jc_linenum _jc_polyglot_util_typedump_TypeDumper$linenum_table$_clinit$a816641e0ba8bfef[];

static const unsigned char _jc_polyglot_util_typedump_TypeDumper$param_ptypes$_clinit$a816641e0ba8bfef[] = { 
_JC_TYPE_VOID };

_jc_method _jc_polyglot_util_typedump_TypeDumper$method_info$_clinit$a816641e0ba8bfef = {
	.name=			"<clinit>",
	.signature=		"()V",
	.class=			&_jc_polyglot_util_typedump_TypeDumper$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_util_typedump_TypeDumper$param_ptypes$_clinit$a816641e0ba8bfef,
	.signature_hash=	_JC_JLONG(0xa816641e0ba8bfef),
	.access_flags=		_JC_ACC_STATIC,
	.function=		&_jc_polyglot_util_typedump_TypeDumper$method$_clinit$a816641e0ba8bfef,
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_polyglot_util_typedump_TypeDumper$linenum_table$_clinit$a816641e0ba8bfef
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_util_typedump_TypeDumper, _clinit$a816641e0ba8bfef);

void _JC_JCNI_ATTR
_jc_polyglot_util_typedump_TypeDumper$method$_clinit$a816641e0ba8bfef(_jc_env *const env)
{
	jint i0;
	jint i1;
	jint i2;
	jint i3;
	jint i4;
	jint i5;
	struct _jc_java_lang_Class$object *r0;
	_jc_object_array *r1;
	struct _jc_java_util_AbstractList__241$object *r10;
	_jc_object_array *r11;
	struct _jc_java_lang_Object$object *r12;
	struct _jc_java_util_HashMap$object *r13;
	struct _jc_java_util_AbstractList$object *r15;
	struct _jc_java_util_HashSet$object *r2;
	struct _jc_java_util_Arrays__24ArrayList$object *r3;
	_jc_object_array *r4;
	struct _jc_java_util_HashMap$object *r5;
	struct _jc_java_lang_NullPointerException$object *r6;
	struct _jc_java_lang_String$object *r7;
	struct _jc_java_lang_VMThrowable$object *r8;
	struct _jc_java_lang_Object$object *r9;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	_JC_LINE_NUMBER(15);				// 0
	r1 = _JC_NEW_REF_ARRAY(env, java_lang_Object, 1, 9);
	r0 = _JC_STATIC_FIELD(env, polyglot_util_typedump_TypeDumper, class__24java__24lang__24Void, 1);
	if (r0 != _JC_NULL)
		goto label0;
	r0 = _JC_INVOKE_STATIC(env, polyglot_util_typedump_TypeDumper, class__24$57cd45dca0be1678, 1, _JC_STRING(env, "java.lang.Void"));
	_JC_STATIC_FIELD(env, polyglot_util_typedump_TypeDumper, class__24java__24lang__24Void, 1) = r0;
	goto label1;

label0:
	r0 = _JC_STATIC_FIELD(env, polyglot_util_typedump_TypeDumper, class__24java__24lang__24Void, 1);

label1:
	_JC_ARRAYSTORE_CHECK(env, r1, r0);
	_JC_REF_ELEMENT(env, r1, 0, 0, 0) = r0;
	r0 = _JC_STATIC_FIELD(env, polyglot_util_typedump_TypeDumper, class__24java__24lang__24Boolean, 1);
	if (r0 != _JC_NULL)
		goto label2;
	r0 = _JC_INVOKE_STATIC(env, polyglot_util_typedump_TypeDumper, class__24$57cd45dca0be1678, 1, _JC_STRING(env, "java.lang.Boolean"));
	_JC_STATIC_FIELD(env, polyglot_util_typedump_TypeDumper, class__24java__24lang__24Boolean, 1) = r0;
	goto label3;

label2:
	r0 = _JC_STATIC_FIELD(env, polyglot_util_typedump_TypeDumper, class__24java__24lang__24Boolean, 1);

label3:
	_JC_ARRAYSTORE_CHECK(env, r1, r0);
	_JC_REF_ELEMENT(env, r1, 1, 0, 0) = r0;
	r0 = _JC_STATIC_FIELD(env, polyglot_util_typedump_TypeDumper, class__24java__24lang__24Short, 1);
	if (r0 != _JC_NULL)
		goto label4;
	r0 = _JC_INVOKE_STATIC(env, polyglot_util_typedump_TypeDumper, class__24$57cd45dca0be1678, 1, _JC_STRING(env, "java.lang.Short"));
	_JC_STATIC_FIELD(env, polyglot_util_typedump_TypeDumper, class__24java__24lang__24Short, 1) = r0;
	goto label5;

label4:
	r0 = _JC_STATIC_FIELD(env, polyglot_util_typedump_TypeDumper, class__24java__24lang__24Short, 1);

label5:
	_JC_ARRAYSTORE_CHECK(env, r1, r0);
	_JC_REF_ELEMENT(env, r1, 2, 0, 0) = r0;
	r0 = _JC_STATIC_FIELD(env, polyglot_util_typedump_TypeDumper, class__24java__24lang__24Integer, 1);
	if (r0 != _JC_NULL)
		goto label6;
	r0 = _JC_INVOKE_STATIC(env, polyglot_util_typedump_TypeDumper, class__24$57cd45dca0be1678, 1, _JC_STRING(env, "java.lang.Integer"));
	_JC_STATIC_FIELD(env, polyglot_util_typedump_TypeDumper, class__24java__24lang__24Integer, 1) = r0;
	goto label7;

label6:
	r0 = _JC_STATIC_FIELD(env, polyglot_util_typedump_TypeDumper, class__24java__24lang__24Integer, 1);

label7:
	_JC_ARRAYSTORE_CHECK(env, r1, r0);
	_JC_REF_ELEMENT(env, r1, 3, 0, 0) = r0;
	r0 = _JC_STATIC_FIELD(env, polyglot_util_typedump_TypeDumper, class__24java__24lang__24Long, 1);
	if (r0 != _JC_NULL)
		goto label8;
	r0 = _JC_INVOKE_STATIC(env, polyglot_util_typedump_TypeDumper, class__24$57cd45dca0be1678, 1, _JC_STRING(env, "java.lang.Long"));
	_JC_STATIC_FIELD(env, polyglot_util_typedump_TypeDumper, class__24java__24lang__24Long, 1) = r0;
	goto label9;

label8:
	r0 = _JC_STATIC_FIELD(env, polyglot_util_typedump_TypeDumper, class__24java__24lang__24Long, 1);

label9:
	_JC_ARRAYSTORE_CHECK(env, r1, r0);
	_JC_REF_ELEMENT(env, r1, 4, 0, 0) = r0;
	r0 = _JC_STATIC_FIELD(env, polyglot_util_typedump_TypeDumper, class__24java__24lang__24Float, 1);
	if (r0 != _JC_NULL)
		goto label10;
	r0 = _JC_INVOKE_STATIC(env, polyglot_util_typedump_TypeDumper, class__24$57cd45dca0be1678, 1, _JC_STRING(env, "java.lang.Float"));
	_JC_STATIC_FIELD(env, polyglot_util_typedump_TypeDumper, class__24java__24lang__24Float, 1) = r0;
	goto label11;

label10:
	r0 = _JC_STATIC_FIELD(env, polyglot_util_typedump_TypeDumper, class__24java__24lang__24Float, 1);

label11:
	_JC_ARRAYSTORE_CHECK(env, r1, r0);
	_JC_REF_ELEMENT(env, r1, 5, 0, 0) = r0;
	r0 = _JC_STATIC_FIELD(env, polyglot_util_typedump_TypeDumper, class__24java__24lang__24Double, 1);
	if (r0 != _JC_NULL)
		goto label12;
	r0 = _JC_INVOKE_STATIC(env, polyglot_util_typedump_TypeDumper, class__24$57cd45dca0be1678, 1, _JC_STRING(env, "java.lang.Double"));
	_JC_STATIC_FIELD(env, polyglot_util_typedump_TypeDumper, class__24java__24lang__24Double, 1) = r0;
	goto label13;

label12:
	r0 = _JC_STATIC_FIELD(env, polyglot_util_typedump_TypeDumper, class__24java__24lang__24Double, 1);

label13:
	_JC_ARRAYSTORE_CHECK(env, r1, r0);
	_JC_REF_ELEMENT(env, r1, 6, 0, 0) = r0;
	r0 = _JC_STATIC_FIELD(env, polyglot_util_typedump_TypeDumper, class__24java__24lang__24Class, 1);
	if (r0 != _JC_NULL)
		goto label14;
	r0 = _JC_INVOKE_STATIC(env, polyglot_util_typedump_TypeDumper, class__24$57cd45dca0be1678, 1, _JC_STRING(env, "java.lang.Class"));
	_JC_STATIC_FIELD(env, polyglot_util_typedump_TypeDumper, class__24java__24lang__24Class, 1) = r0;
	goto label15;

label14:
	r0 = _JC_STATIC_FIELD(env, polyglot_util_typedump_TypeDumper, class__24java__24lang__24Class, 1);

label15:
	_JC_ARRAYSTORE_CHECK(env, r1, r0);
	_JC_REF_ELEMENT(env, r1, 7, 0, 0) = r0;
	r0 = _JC_STATIC_FIELD(env, polyglot_util_typedump_TypeDumper, class__24java__24lang__24String, 1);
	if (r0 != _JC_NULL)
		goto label16;
	r0 = _JC_INVOKE_STATIC(env, polyglot_util_typedump_TypeDumper, class__24$57cd45dca0be1678, 1, _JC_STRING(env, "java.lang.String"));
	_JC_STATIC_FIELD(env, polyglot_util_typedump_TypeDumper, class__24java__24lang__24String, 1) = r0;
	goto label17;

label16:
	r0 = _JC_STATIC_FIELD(env, polyglot_util_typedump_TypeDumper, class__24java__24lang__24String, 1);

label17:
	_JC_ARRAYSTORE_CHECK(env, r1, r0);
	_JC_REF_ELEMENT(env, r1, 8, 0, 0) = r0;
	_JC_LINE_NUMBER(26);				// 1
	r2 = _JC_NEW(env, java_util_HashSet);
	_JC_ACTIVE_USE(env, java_util_Arrays);
	r3 = _JC_NEW(env, java_util_Arrays__24ArrayList);
	if (r1 != _JC_NULL)
		goto label18;
	r6 = _JC_NEW(env, java_lang_NullPointerException);
	r7 = _JC_NULL;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, cause) = r6;
	r8 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r6);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, vmState) = r8;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, detailMessage) = r7;
	_JC_THROW(env, r6);

label18:
	_JC_REF_FIELD(env, r3, java_util_Arrays__24ArrayList, a) = r1;
	r4 = _JC_REF_FIELD(env, r3, java_util_Arrays__24ArrayList, a);
	i1 = _JC_ARRAY_LENGTH(env, r4);
	i0 = 2 * i1;
	_JC_ACTIVE_USE(env, java_lang_Math);
	if (i0 <= 11)
		goto label19;
	i2 = i0;
	goto label20;

label19:
	i2 = 11;

label20:
	r5 = _JC_NEW(env, java_util_HashMap);
	_JC_INVOKE_NONVIRTUAL(env, java_util_HashMap, _init$7cb044ce4fb0ada8, 0, r5, i2, _JC_FCONST(0x3f, 0x40, 0x0, 0x0));
	_JC_REF_FIELD(env, r2, java_util_HashSet, map) = r5;
	r10 = _JC_NEW(env, java_util_AbstractList__241);
	_JC_REF_FIELD(env, r10, java_util_AbstractList__241, this) = r3;
	_JC_PRIM_FIELD(env, r10, java_util_AbstractList__241, pos) = 0;
	r15 = _JC_REF_FIELD(env, r10, java_util_AbstractList__241, this);
	i5 = _JC_INVOKE_VIRTUAL(env, java_util_AbstractCollection, size$345df5220fc60ade, r15);
	_JC_PRIM_FIELD(env, r10, java_util_AbstractList__241, size) = i5;
	_JC_PRIM_FIELD(env, r10, java_util_AbstractList__241, last) = -1;
	r15 = _JC_REF_FIELD(env, r10, java_util_AbstractList__241, this);
	i5 = _JC_PRIM_FIELD(env, r15, java_util_AbstractList, modCount);
	_JC_PRIM_FIELD(env, r10, java_util_AbstractList__241, knownMod) = i5;
	r11 = _JC_REF_FIELD(env, r3, java_util_Arrays__24ArrayList, a);
	i4 = _JC_ARRAY_LENGTH(env, r11);
	i3 = i4;
	goto label22;

label21:
	r9 = _JC_INVOKE_NONVIRTUAL(env, java_util_AbstractList__241, next$05874f79a1cf66ea, 0, r10);
	r13 = _JC_REF_FIELD(env, r2, java_util_HashSet, map);
	r12 = _JC_INVOKE_VIRTUAL(env, java_util_HashMap, put$3bd1c078a0faa8da, r13, r9, _JC_STRING(env, ""));
	if (r12 != _JC_NULL)
		goto label22;

label22:
	i3 = i3 + -1;
	if (i3 >= 0) {
		_JC_PERIODIC_CHECK(env);
		goto label21;
	}
	_JC_STATIC_FIELD(env, polyglot_util_typedump_TypeDumper, dontExpand, 0) = r2;
	_JC_LINE_NUMBER(28);				// 2
	return;
}

//
// static java.lang.Class class$(java.lang.String)
//

static _jc_linenum _jc_polyglot_util_typedump_TypeDumper$linenum_table$class__24$57cd45dca0be1678[];

static _jc_trap_info _jc_polyglot_util_typedump_TypeDumper$trap_table$class__24$57cd45dca0be1678[] = {
	_JC_TRAP(&_jc_java_lang_ClassNotFoundException$type, 1, 2),
};

static const unsigned char _jc_polyglot_util_typedump_TypeDumper$param_ptypes$class__24$57cd45dca0be1678[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_util_typedump_TypeDumper$param_types$class__24$57cd45dca0be1678[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_polyglot_util_typedump_TypeDumper$method_info$class__24$57cd45dca0be1678 = {
	.name=			"class$",
	.signature=		"(Ljava/lang/String;)Ljava/lang/Class;",
	.class=			&_jc_polyglot_util_typedump_TypeDumper$type,
	.param_types=		&_jc_polyglot_util_typedump_TypeDumper$param_types$class__24$57cd45dca0be1678,
	.return_type=		&_jc_java_lang_Class$type,
	.param_ptypes=		&_jc_polyglot_util_typedump_TypeDumper$param_ptypes$class__24$57cd45dca0be1678,
	.signature_hash=	_JC_JLONG(0x57cd45dca0be1678),
	.access_flags=		_JC_ACC_STATIC,
	.function=		&_jc_polyglot_util_typedump_TypeDumper$method$class__24$57cd45dca0be1678,
	.num_parameters=	1,
	.u= { .exec= {
	  .trap_table_len=	1,
	  .trap_table=		_jc_polyglot_util_typedump_TypeDumper$trap_table$class__24$57cd45dca0be1678,
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_util_typedump_TypeDumper$linenum_table$class__24$57cd45dca0be1678
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_util_typedump_TypeDumper, class__24$57cd45dca0be1678);

_jc_java_lang_Class$object * _JC_JCNI_ATTR
_jc_polyglot_util_typedump_TypeDumper$method$class__24$57cd45dca0be1678(_jc_env *const env, _jc_java_lang_String$object *param0)
{
	struct _jc_java_lang_String$object *volatile r0;
	struct _jc_java_lang_ClassNotFoundException$object *volatile r1;
	struct _jc_java_lang_Class$object *r2;
	struct _jc_java_lang_NoClassDefFoundError$object *volatile r3;
	struct _jc_java_lang_VMThrowable$object *volatile r5;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_polyglot_util_typedump_TypeDumper$method_info$class__24$57cd45dca0be1678, &&label0);

	r0 = param0;
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(16);				// 0
	r2 = _JC_INVOKE_STATIC(env, java_lang_Class, forName$d3b57db3b6a905a3, 1, r0);
	_JC_TRAP_REGION(catch, 2);
	_JC_CANCEL_TRAPS(env, catch);
	return r2;

label0:
	_JC_TRAP_REGION(catch, 2);
	r1 = _JC_CAUGHT_EXCEPTION(env);
	r3 = _JC_NEW(env, java_lang_NoClassDefFoundError);
	r0 = _JC_INVOKE_VIRTUAL(env, java_lang_Throwable, getMessage$13aaf240efc902b1, r1);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r5 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r5;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r0;
	_JC_THROW(env, r3);
}

//
// static boolean dontDump(java.lang.Class)
//

static _jc_linenum _jc_polyglot_util_typedump_TypeDumper$linenum_table$dontDump$b51c08815d17eae2[];

static const unsigned char _jc_polyglot_util_typedump_TypeDumper$param_ptypes$dontDump$b51c08815d17eae2[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_polyglot_util_typedump_TypeDumper$param_types$dontDump$b51c08815d17eae2[] = {
	&_jc_java_lang_Class$type
};

_jc_method _jc_polyglot_util_typedump_TypeDumper$method_info$dontDump$b51c08815d17eae2 = {
	.name=			"dontDump",
	.signature=		"(Ljava/lang/Class;)Z",
	.class=			&_jc_polyglot_util_typedump_TypeDumper$type,
	.param_types=		&_jc_polyglot_util_typedump_TypeDumper$param_types$dontDump$b51c08815d17eae2,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_polyglot_util_typedump_TypeDumper$param_ptypes$dontDump$b51c08815d17eae2,
	.signature_hash=	_JC_JLONG(0xb51c08815d17eae2),
	.access_flags=		_JC_ACC_STATIC,
	.function=		&_jc_polyglot_util_typedump_TypeDumper$method$dontDump$b51c08815d17eae2,
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_util_typedump_TypeDumper$linenum_table$dontDump$b51c08815d17eae2
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_util_typedump_TypeDumper, dontDump$b51c08815d17eae2);

jboolean _JC_JCNI_ATTR
_jc_polyglot_util_typedump_TypeDumper$method$dontDump$b51c08815d17eae2(_jc_env *const env, _jc_java_lang_Class$object *param0)
{
	struct _jc_java_lang_Class$object *r0;
	struct _jc_object *r1;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = param0;
	_JC_LINE_NUMBER(134);				// 0
	r1 = _JC_STATIC_FIELD(env, polyglot_util_typedump_TypeDumper, dontExpand, 1);
	z0 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0xd3bd70da40f05cb1), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r0);
	return z0;
}

//
// public static polyglot.util.typedump.TypeDumper load(java.lang.String, polyglot.types.TypeSystem) throws java.lang.ClassNotFoundException, java.lang.NoSuchFieldException, java.io.IOException, java.lang.SecurityException
//

static _jc_linenum _jc_polyglot_util_typedump_TypeDumper$linenum_table$load$6dc50d612bc9d36e[];

static _jc_trap_info _jc_polyglot_util_typedump_TypeDumper$trap_table$load$6dc50d612bc9d36e[] = {
	_JC_TRAP(&_jc_java_lang_IllegalAccessException$type, 1, 2),
};

static const unsigned char _jc_polyglot_util_typedump_TypeDumper$param_ptypes$load$6dc50d612bc9d36e[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_util_typedump_TypeDumper$exceptions$load$6dc50d612bc9d36e[] = {
	&_jc_java_lang_ClassNotFoundException$type,
	&_jc_java_lang_NoSuchFieldException$type,
	&_jc_java_io_IOException$type,
	&_jc_java_lang_SecurityException$type
};

static _jc_type *const _jc_polyglot_util_typedump_TypeDumper$param_types$load$6dc50d612bc9d36e[] = {
	&_jc_java_lang_String$type,
	&_jc_polyglot_types_TypeSystem$type
};

_jc_method _jc_polyglot_util_typedump_TypeDumper$method_info$load$6dc50d612bc9d36e = {
	.name=			"load",
	.signature=		"(Ljava/lang/String;Lpolyglot/types/TypeSystem;)Lpolyglot/util/typedump/TypeDumper;",
	.class=			&_jc_polyglot_util_typedump_TypeDumper$type,
	.param_types=		&_jc_polyglot_util_typedump_TypeDumper$param_types$load$6dc50d612bc9d36e,
	.return_type=		&_jc_polyglot_util_typedump_TypeDumper$type,
	.param_ptypes=		&_jc_polyglot_util_typedump_TypeDumper$param_ptypes$load$6dc50d612bc9d36e,
	.signature_hash=	_JC_JLONG(0x6dc50d612bc9d36e),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_polyglot_util_typedump_TypeDumper$method$load$6dc50d612bc9d36e,
	.num_parameters=	2,
	.num_exceptions=	4,
	.exceptions=		&_jc_polyglot_util_typedump_TypeDumper$exceptions$load$6dc50d612bc9d36e,
	.u= { .exec= {
	  .trap_table_len=	1,
	  .trap_table=		_jc_polyglot_util_typedump_TypeDumper$trap_table$load$6dc50d612bc9d36e,
	  .u= {
	    .linenum= {
	      .len=	8,
	      .table=	_jc_polyglot_util_typedump_TypeDumper$linenum_table$load$6dc50d612bc9d36e
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_util_typedump_TypeDumper, load$6dc50d612bc9d36e);

_jc_polyglot_util_typedump_TypeDumper$object * _JC_JCNI_ATTR
_jc_polyglot_util_typedump_TypeDumper$method$load$6dc50d612bc9d36e(_jc_env *const env, _jc_java_lang_String$object *param0, _jc_object *param1)
{
	jlong l0;
	struct _jc_java_lang_String$object *r0;
	struct _jc_object *r1;
	struct _jc_object *r10;
	struct _jc_java_lang_Long$object *r11;
	struct _jc_java_lang_IllegalAccessException$object *volatile r12;
	struct _jc_java_lang_SecurityException$object *volatile r13;
	struct _jc_java_lang_StringBuffer$object *volatile r14;
	struct _jc_java_lang_String$object *volatile r15;
	_jc_char_array *volatile r16;
	struct _jc_java_lang_VMThrowable$object *volatile r17;
	struct _jc_java_lang_Class$object *r2;
	struct _jc_java_util_Date$object *r23;
	struct _jc_java_lang_reflect_Field$object *r3;
	struct _jc_java_lang_reflect_Field$object *r4;
	struct _jc_java_lang_reflect_Field$object *r5;
	struct _jc_java_lang_String$object *volatile r6;
	struct _jc_polyglot_util_TypeEncoder$object *r7;
	struct _jc_java_lang_Object$object *r8;
	struct _jc_polyglot_util_typedump_TypeDumper$object *r9;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_polyglot_util_typedump_TypeDumper$method_info$load$6dc50d612bc9d36e, &&label0);

	r0 = param0;
	r1 = param1;
	_JC_LINE_NUMBER(46);				// 0
	r2 = _JC_INVOKE_STATIC(env, java_lang_Class, forName$d3b57db3b6a905a3, 1, r0);
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(48);				// 1
	r3 = _JC_INVOKE_NONVIRTUAL(env, java_lang_Class, getDeclaredField$87217072b1ba27f1, 1, r2, _JC_STRING(env, "jlc$CompilerVersion"));
	_JC_LINE_NUMBER(49);				// 2
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_Class, getDeclaredField$87217072b1ba27f1, 0, r2, _JC_STRING(env, "jlc$SourceLastModified"));
	_JC_LINE_NUMBER(50);				// 3
	r5 = _JC_INVOKE_NONVIRTUAL(env, java_lang_Class, getDeclaredField$87217072b1ba27f1, 0, r2, _JC_STRING(env, "jlc$ClassType"));
	_JC_LINE_NUMBER(51);				// 4
	r8 = _JC_INVOKE_NONVIRTUAL(env, java_lang_reflect_Field, get$b30461fc5ea13399, 1, r5, _JC_NULL);
	r6 = _JC_CAST_FINAL(env, &_jc_java_lang_String$type, r8);
	_JC_LINE_NUMBER(52);				// 5
	r7 = _JC_NEW(env, polyglot_util_TypeEncoder);
	_JC_PRIM_FIELD(env, r7, polyglot_util_TypeEncoder, zip) = 1;
	_JC_PRIM_FIELD(env, r7, polyglot_util_TypeEncoder, base64) = 1;
	_JC_PRIM_FIELD(env, r7, polyglot_util_TypeEncoder, test) = 0;
	_JC_REF_FIELD(env, r7, polyglot_util_TypeEncoder, ts) = r1;
	_JC_LINE_NUMBER(53);				// 6
	r9 = _JC_NEW(env, polyglot_util_typedump_TypeDumper);
	r10 = _JC_INVOKE_NONVIRTUAL(env, polyglot_util_TypeEncoder, decode$8383d57b54a9bd76, 0, r7, r6);
	r8 = _JC_INVOKE_NONVIRTUAL(env, java_lang_reflect_Field, get$b30461fc5ea13399, 1, r3, _JC_NULL);
	r6 = _JC_CAST_FINAL(env, &_jc_java_lang_String$type, r8);
	r8 = _JC_INVOKE_NONVIRTUAL(env, java_lang_reflect_Field, get$b30461fc5ea13399, 1, r4, _JC_NULL);
	r11 = _JC_CAST_FINAL(env, &_jc_java_lang_Long$type, r8);
	_JC_REF_FIELD(env, r9, polyglot_util_typedump_TypeDumper, theType) = r10;
	_JC_REF_FIELD(env, r9, polyglot_util_typedump_TypeDumper, rawName) = r0;
	_JC_REF_FIELD(env, r9, polyglot_util_typedump_TypeDumper, compilerVersion) = r6;
	r23 = _JC_NEW(env, java_util_Date);
	_JC_EXPLICIT_NULL_CHECK(env, r11);
	l0 = _JC_PRIM_FIELD(env, r11, java_lang_Long, value);
	_JC_PRIM_FIELD(env, r23, java_util_Date, time) = l0;
	_JC_REF_FIELD(env, r9, polyglot_util_typedump_TypeDumper, timestamp) = r23;
	_JC_TRAP_REGION(catch, 2);
	_JC_CANCEL_TRAPS(env, catch);
	return r9;

label0:
	_JC_TRAP_REGION(catch, 2);
	r12 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(58);				// 7
	r13 = _JC_NEW(env, java_lang_SecurityException);
	r14 = _JC_NEW(env, java_lang_StringBuffer);
	r16 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r14, java_lang_StringBuffer, value) = r16;
	r14 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r14, _JC_STRING(env, "illegal access: "));
	r6 = _JC_INVOKE_VIRTUAL(env, java_lang_Throwable, getMessage$13aaf240efc902b1, r12);
	r14 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r14, r6);
	r15 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r15, r14);
	_JC_REF_FIELD(env, r13, java_lang_Throwable, cause) = r13;
	r17 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r13);
	_JC_REF_FIELD(env, r13, java_lang_Throwable, vmState) = r17;
	_JC_REF_FIELD(env, r13, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r13, java_lang_Throwable, detailMessage) = r15;
	_JC_THROW(env, r13);
}

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// void <init>(java.lang.String, polyglot.types.Type, java.lang.String, java.lang.Long)
//

static _jc_linenum _jc_polyglot_util_typedump_TypeDumper$linenum_table$_init$f9c9831deeb00033[];

static const unsigned char _jc_polyglot_util_typedump_TypeDumper$param_ptypes$_init$f9c9831deeb00033[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_util_typedump_TypeDumper$param_types$_init$f9c9831deeb00033[] = {
	&_jc_java_lang_String$type,
	&_jc_polyglot_types_Type$type,
	&_jc_java_lang_String$type,
	&_jc_java_lang_Long$type
};

_jc_method _jc_polyglot_util_typedump_TypeDumper$method_info$_init$f9c9831deeb00033 = {
	.name=			"<init>",
	.signature=		"(Ljava/lang/String;Lpolyglot/types/Type;Ljava/lang/String;Ljava/lang/Long;)V",
	.class=			&_jc_polyglot_util_typedump_TypeDumper$type,
	.param_types=		&_jc_polyglot_util_typedump_TypeDumper$param_types$_init$f9c9831deeb00033,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_util_typedump_TypeDumper$param_ptypes$_init$f9c9831deeb00033,
	.signature_hash=	_JC_JLONG(0xf9c9831deeb00033),
	.access_flags=		0,
	.function=		&_jc_polyglot_util_typedump_TypeDumper$method$_init$f9c9831deeb00033,
	.num_parameters=	4,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_polyglot_util_typedump_TypeDumper$linenum_table$_init$f9c9831deeb00033
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_util_typedump_TypeDumper, _init$f9c9831deeb00033);

void _JC_JCNI_ATTR
_jc_polyglot_util_typedump_TypeDumper$method$_init$f9c9831deeb00033(_jc_env *const env, _jc_polyglot_util_typedump_TypeDumper$object *this, _jc_java_lang_String$object *param0, _jc_object *param1, _jc_java_lang_String$object *param2, _jc_java_lang_Long$object *param3)
{
	jlong l0;
	struct _jc_polyglot_util_typedump_TypeDumper$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_object *r2;
	struct _jc_java_lang_String$object *r3;
	struct _jc_java_lang_Long$object *r4;
	struct _jc_java_util_Date$object *r5;

	r0 = this;
	r1 = param0;
	r2 = param1;
	r3 = param2;
	r4 = param3;
	_JC_LINE_NUMBER(36);				// 0
	_JC_REF_FIELD(env, r0, polyglot_util_typedump_TypeDumper, theType) = r2;
	_JC_LINE_NUMBER(37);				// 1
	_JC_REF_FIELD(env, r0, polyglot_util_typedump_TypeDumper, rawName) = r1;
	_JC_LINE_NUMBER(38);				// 2
	_JC_REF_FIELD(env, r0, polyglot_util_typedump_TypeDumper, compilerVersion) = r3;
	_JC_LINE_NUMBER(39);				// 3
	r5 = _JC_NEW(env, java_util_Date);
	_JC_EXPLICIT_NULL_CHECK(env, r4);
	l0 = _JC_PRIM_FIELD(env, r4, java_lang_Long, value);
	_JC_PRIM_FIELD(env, r5, java_util_Date, time) = l0;
	_JC_REF_FIELD(env, r0, polyglot_util_typedump_TypeDumper, timestamp) = r5;
	_JC_LINE_NUMBER(40);				// 4
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public void dump(polyglot.util.CodeWriter)
//

static _jc_linenum _jc_polyglot_util_typedump_TypeDumper$linenum_table$dump$30efa1ff09c02470[];

static const unsigned char _jc_polyglot_util_typedump_TypeDumper$param_ptypes$dump$30efa1ff09c02470[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_util_typedump_TypeDumper$param_types$dump$30efa1ff09c02470[] = {
	&_jc_polyglot_util_CodeWriter$type
};

_jc_method _jc_polyglot_util_typedump_TypeDumper$method_info$dump$30efa1ff09c02470 = {
	.name=			"dump",
	.signature=		"(Lpolyglot/util/CodeWriter;)V",
	.class=			&_jc_polyglot_util_typedump_TypeDumper$type,
	.param_types=		&_jc_polyglot_util_typedump_TypeDumper$param_types$dump$30efa1ff09c02470,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_util_typedump_TypeDumper$param_ptypes$dump$30efa1ff09c02470,
	.signature_hash=	_JC_JLONG(0x30efa1ff09c02470),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_util_typedump_TypeDumper$method$dump$30efa1ff09c02470,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_util_typedump_TypeDumper$vtable, polyglot_util_typedump_TypeDumper.dump$30efa1ff09c02470) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	20,
	      .table=	_jc_polyglot_util_typedump_TypeDumper$linenum_table$dump$30efa1ff09c02470
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_util_typedump_TypeDumper, dump$30efa1ff09c02470);

void _JC_JCNI_ATTR
_jc_polyglot_util_typedump_TypeDumper$method$dump$30efa1ff09c02470(_jc_env *const env, _jc_polyglot_util_typedump_TypeDumper$object *this, _jc_polyglot_util_CodeWriter$object *param0)
{
	struct _jc_polyglot_util_typedump_TypeDumper$object *r0;
	struct _jc_polyglot_util_CodeWriter$object *r1;
	struct _jc_java_lang_String$object *r10;
	struct _jc_java_lang_String$object *r11;
	struct _jc_java_lang_String$object *r12;
	_jc_char_array *r13;
	_jc_char_array *r14;
	_jc_char_array *r15;
	_jc_char_array *r16;
	struct _jc_java_util_HashMap$object *r2;
	struct _jc_object *r3;
	struct _jc_object *r4;
	struct _jc_java_lang_StringBuffer$object *r5;
	struct _jc_java_lang_String$object *r6;
	struct _jc_java_util_Date$object *r7;
	struct _jc_java_lang_Class$object *r8;
	struct _jc_java_lang_String$object *r9;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(63);				// 0
	r2 = _JC_NEW(env, java_util_HashMap);
	_JC_INVOKE_NONVIRTUAL(env, java_util_HashMap, _init$7cb044ce4fb0ada8, 0, r2, 11, _JC_FCONST(0x3f, 0x40, 0x0, 0x0));
	_JC_LINE_NUMBER(64);				// 1
	r3 = _JC_REF_FIELD(env, r0, polyglot_util_typedump_TypeDumper, theType);
	r4 = _JC_REF_FIELD(env, r0, polyglot_util_typedump_TypeDumper, theType);
	_JC_INVOKE_NONVIRTUAL(env, java_util_HashMap, put$3bd1c078a0faa8da, 0, r2, r3, r4);
	_JC_LINE_NUMBER(65);				// 2
	r5 = _JC_NEW(env, java_lang_StringBuffer);
	r13 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r5, java_lang_StringBuffer, value) = r13;
	r5 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r5, _JC_STRING(env, "Type "));
	r6 = _JC_REF_FIELD(env, r0, polyglot_util_typedump_TypeDumper, rawName);
	r5 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r5, r6);
	r5 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r5, _JC_STRING(env, " {"));
	r9 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r9, r5);
	_JC_INVOKE_VIRTUAL(env, polyglot_util_CodeWriter, write$741cedc3a0899944, r1, r9);
	_JC_LINE_NUMBER(66);				// 3
	_JC_INVOKE_VIRTUAL(env, polyglot_util_CodeWriter, allowBreak$2840aaf42817e05c, r1, 2);
	_JC_LINE_NUMBER(67);				// 4
	_JC_INVOKE_VIRTUAL(env, polyglot_util_CodeWriter, begin$a70ea64f2a7c5211, r1, 0);
	_JC_LINE_NUMBER(68);				// 5
	r5 = _JC_NEW(env, java_lang_StringBuffer);
	r14 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r5, java_lang_StringBuffer, value) = r14;
	r5 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r5, _JC_STRING(env, "Compiled with polyglot version "));
	r6 = _JC_REF_FIELD(env, r0, polyglot_util_typedump_TypeDumper, compilerVersion);
	r5 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r5, r6);
	r5 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r5, _JC_STRING(env, ".  "));
	r10 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r10, r5);
	_JC_INVOKE_VIRTUAL(env, polyglot_util_CodeWriter, write$741cedc3a0899944, r1, r10);
	_JC_LINE_NUMBER(69);				// 6
	_JC_INVOKE_VIRTUAL(env, polyglot_util_CodeWriter, allowBreak$2840aaf42817e05c, r1, 0);
	_JC_LINE_NUMBER(70);				// 7
	r5 = _JC_NEW(env, java_lang_StringBuffer);
	r15 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r5, java_lang_StringBuffer, value) = r15;
	r5 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r5, _JC_STRING(env, "Last modified: "));
	r7 = _JC_REF_FIELD(env, r0, polyglot_util_typedump_TypeDumper, timestamp);
	r6 = _JC_INVOKE_VIRTUAL(env, java_util_Date, toString$7ea43b33b80a3070, r7);
	r5 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r5, r6);
	r5 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r5, _JC_STRING(env, ".  "));
	r11 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r11, r5);
	_JC_INVOKE_VIRTUAL(env, polyglot_util_CodeWriter, write$741cedc3a0899944, r1, r11);
	_JC_LINE_NUMBER(71);				// 8
	_JC_INVOKE_VIRTUAL(env, polyglot_util_CodeWriter, allowBreak$2840aaf42817e05c, r1, 0);
	_JC_LINE_NUMBER(72);				// 9
	r4 = _JC_REF_FIELD(env, r0, polyglot_util_typedump_TypeDumper, theType);
	r6 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, toString$7ea43b33b80a3070, r4);
	_JC_INVOKE_VIRTUAL(env, polyglot_util_CodeWriter, write$741cedc3a0899944, r1, r6);
	_JC_LINE_NUMBER(73);				// 10
	_JC_INVOKE_VIRTUAL(env, polyglot_util_CodeWriter, allowBreak$2840aaf42817e05c, r1, 4);
	_JC_LINE_NUMBER(74);				// 11
	r5 = _JC_NEW(env, java_lang_StringBuffer);
	r16 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r5, java_lang_StringBuffer, value) = r16;
	r5 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r5, _JC_STRING(env, "<"));
	r4 = _JC_REF_FIELD(env, r0, polyglot_util_typedump_TypeDumper, theType);
	_JC_EXPLICIT_NULL_CHECK(env, r4);
	r8 = _JC_INVOKE_STATIC(env, java_lang_VMObject, getClass$2be11d215bfbfbfe, 0, r4);
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_Class, toString$7ea43b33b80a3070, 1, r8);
	r5 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r5, r6);
	r5 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r5, _JC_STRING(env, ">"));
	r12 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r12, r5);
	_JC_INVOKE_VIRTUAL(env, polyglot_util_CodeWriter, write$741cedc3a0899944, r1, r12);
	_JC_LINE_NUMBER(76);				// 12
	_JC_INVOKE_VIRTUAL(env, polyglot_util_CodeWriter, allowBreak$2840aaf42817e05c, r1, 0);
	_JC_LINE_NUMBER(77);				// 13
	r4 = _JC_REF_FIELD(env, r0, polyglot_util_typedump_TypeDumper, theType);
	_JC_INVOKE_VIRTUAL(env, polyglot_util_typedump_TypeDumper, dumpObject$ba0ace0c360abd4c, r0, r1, r4, r2);
	_JC_LINE_NUMBER(78);				// 14
	_JC_INVOKE_VIRTUAL(env, polyglot_util_CodeWriter, allowBreak$2840aaf42817e05c, r1, 0);
	_JC_LINE_NUMBER(79);				// 15
	_JC_INVOKE_VIRTUAL(env, polyglot_util_CodeWriter, end$d5ec7c830865cdfd, r1);
	_JC_LINE_NUMBER(80);				// 16
	_JC_INVOKE_VIRTUAL(env, polyglot_util_CodeWriter, allowBreak$2840aaf42817e05c, r1, 0);
	_JC_LINE_NUMBER(81);				// 17
	_JC_INVOKE_VIRTUAL(env, polyglot_util_CodeWriter, write$741cedc3a0899944, r1, _JC_STRING(env, "}"));
	_JC_LINE_NUMBER(82);				// 18
	_JC_INVOKE_VIRTUAL(env, polyglot_util_CodeWriter, newline$87c37c893944ffc4, r1, 0);
	_JC_LINE_NUMBER(83);				// 19
	return;
}

//
// protected void dumpObject(polyglot.util.CodeWriter, java.lang.Object, java.util.Map)
//

static _jc_linenum _jc_polyglot_util_typedump_TypeDumper$linenum_table$dumpObject$ba0ace0c360abd4c[];

static _jc_trap_info _jc_polyglot_util_typedump_TypeDumper$trap_table$dumpObject$ba0ace0c360abd4c[] = {
	_JC_TRAP(&_jc_java_lang_ClassNotFoundException$type, 3, 4),
	_JC_TRAP(&_jc_java_lang_IllegalAccessException$type, 2, 5),
	_JC_TRAP(&_jc_java_lang_SecurityException$type, 1, 6),
	_JC_TRAP(_JC_NULL, 1, 6),
	_JC_TRAP(_JC_NULL, 7, 8),
	_JC_TRAP(_JC_NULL, 9, 10),
};

static const unsigned char _jc_polyglot_util_typedump_TypeDumper$param_ptypes$dumpObject$ba0ace0c360abd4c[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_util_typedump_TypeDumper$param_types$dumpObject$ba0ace0c360abd4c[] = {
	&_jc_polyglot_util_CodeWriter$type,
	&_jc_java_lang_Object$type,
	&_jc_java_util_Map$type
};

_jc_method _jc_polyglot_util_typedump_TypeDumper$method_info$dumpObject$ba0ace0c360abd4c = {
	.name=			"dumpObject",
	.signature=		"(Lpolyglot/util/CodeWriter;Ljava/lang/Object;Ljava/util/Map;)V",
	.class=			&_jc_polyglot_util_typedump_TypeDumper$type,
	.param_types=		&_jc_polyglot_util_typedump_TypeDumper$param_types$dumpObject$ba0ace0c360abd4c,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_util_typedump_TypeDumper$param_ptypes$dumpObject$ba0ace0c360abd4c,
	.signature_hash=	_JC_JLONG(0xba0ace0c360abd4c),
	.access_flags=		_JC_ACC_PROTECTED,
	.function=		&_jc_polyglot_util_typedump_TypeDumper$method$dumpObject$ba0ace0c360abd4c,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_util_typedump_TypeDumper$vtable, polyglot_util_typedump_TypeDumper.dumpObject$ba0ace0c360abd4c) / sizeof(void *),
	.num_parameters=	3,
	.u= { .exec= {
	  .trap_table_len=	6,
	  .trap_table=		_jc_polyglot_util_typedump_TypeDumper$trap_table$dumpObject$ba0ace0c360abd4c,
	  .u= {
	    .linenum= {
	      .len=	29,
	      .table=	_jc_polyglot_util_typedump_TypeDumper$linenum_table$dumpObject$ba0ace0c360abd4c
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_util_typedump_TypeDumper, dumpObject$ba0ace0c360abd4c);

void _JC_JCNI_ATTR
_jc_polyglot_util_typedump_TypeDumper$method$dumpObject$ba0ace0c360abd4c(_jc_env *const env, _jc_polyglot_util_typedump_TypeDumper$object *this, _jc_polyglot_util_CodeWriter$object *param0, _jc_java_lang_Object$object *param1, _jc_object *param2)
{
	jint volatile i0;
	jint volatile i1;
	jint volatile i2;
	jint i3;
	jint i4;
	jint i5;
	struct _jc_polyglot_util_typedump_TypeDumper$object *volatile r0;
	struct _jc_polyglot_util_CodeWriter$object *volatile r1;
	struct _jc_java_lang_Object$object *volatile r10;
	struct _jc_java_lang_IllegalAccessException$object *volatile r11;
	struct _jc_java_lang_SecurityException$object *r12;
	struct _jc_java_lang_Class$object *r13;
	struct _jc_java_lang_String$object *volatile r14;
	struct _jc_java_lang_Class$object *volatile r15;
	_jc_object_array *volatile r16;
	struct _jc_java_lang_String$object *volatile r17;
	struct _jc_java_lang_String$object *volatile r18;
	struct _jc_object *volatile r19;
	struct _jc_java_lang_Object$object *volatile r2;
	struct _jc_java_lang_String$object *volatile r20;
	_jc_char_array *volatile r21;
	_jc_char_array *volatile r22;
	_jc_char_array *volatile r23;
	struct _jc_java_lang_String$object *volatile r24;
	struct _jc_java_lang_ClassNotFoundException$object *volatile r25;
	struct _jc_java_lang_Class$object *volatile r26;
	struct _jc_java_lang_NoClassDefFoundError$object *volatile r27;
	struct _jc_java_lang_VMThrowable$object *volatile r28;
	struct _jc_java_lang_SecurityManager$object *r29;
	struct _jc_object *volatile r3;
	struct _jc_java_lang_Package$object *r30;
	struct _jc_java_lang_String$object *r31;
	struct _jc_java_lang_ClassLoader$object *r32;
	struct _jc_java_lang_String$object *r33;
	struct _jc_java_lang_Package$object *r34;
	struct _jc_java_lang_String$object *r35;
	struct _jc_java_lang_String$object *r36;
	struct _jc_java_lang_reflect_AccessibleObject$object *r37;
	struct _jc_java_lang_reflect_ReflectPermission$object *r38;
	struct _jc_java_lang_SecurityManager$object *r39;
	struct _jc_java_lang_Object$object *volatile r4;
	struct _jc_java_lang_String$object *r40;
	struct _jc_java_lang_String$object *r41;
	struct _jc_java_lang_IllegalArgumentException$object *r42;
	struct _jc_java_lang_String$object *r43;
	struct _jc_java_lang_VMThrowable$object *r45;
	struct _jc_java_lang_Throwable$object *volatile r5;
	struct _jc_java_lang_reflect_Field$object *volatile r6;
	struct _jc_java_lang_StringBuffer$object *volatile r7;
	struct _jc_java_lang_String$object *volatile r8;
	struct _jc_java_lang_Class$object *volatile r9;
	jboolean volatile z0;
	jboolean volatile z1;
	jboolean volatile z2;
	jboolean volatile z3;
	jboolean volatile z4;
	jboolean z5;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_polyglot_util_typedump_TypeDumper$method_info$dumpObject$ba0ace0c360abd4c, &&label12, &&label19, &&label22, &&label23, &&label23, &&label23);

	r0 = this;
	r1 = param0;
	r2 = param1;
	r3 = param2;
	_JC_LINE_NUMBER(86);				// 0
	_JC_INVOKE_VIRTUAL(env, polyglot_util_CodeWriter, write$741cedc3a0899944, r1, _JC_STRING(env, " fields {"));
	_JC_LINE_NUMBER(87);				// 1
	_JC_INVOKE_VIRTUAL(env, polyglot_util_CodeWriter, allowBreak$2840aaf42817e05c, r1, 2);
	_JC_LINE_NUMBER(88);				// 2
	_JC_INVOKE_VIRTUAL(env, polyglot_util_CodeWriter, begin$a70ea64f2a7c5211, r1, 0);
	_JC_TRAP_REGION(catch, 1);
	_JC_EXPLICIT_NULL_CHECK(env, r2);
	r13 = _JC_INVOKE_STATIC(env, java_lang_VMObject, getClass$2be11d215bfbfbfe, 0, r2);
	_JC_EXPLICIT_NULL_CHECK(env, r13);
	r29 = _JC_STATIC_FIELD(env, java_lang_SecurityManager, current, 0);
	if (r29 == _JC_NULL)
		goto label4;
	_JC_INVOKE_VIRTUAL(env, java_lang_SecurityManager, checkMemberAccess$16151f919c57d125, r29, r13, 1);
	r32 = _JC_INVOKE_NONVIRTUAL(env, java_lang_Class, getClassLoader$2078dc747ca30d6e, 0, r13);
	if (r32 == _JC_NULL)
		goto label2;
	r35 = _JC_INVOKE_STATIC(env, java_lang_VMClass, getName$7a04fe8e1a654d36, 0, r13);
	_JC_EXPLICIT_NULL_CHECK(env, r35);
	i3 = _JC_PRIM_FIELD(env, r35, java_lang_String, count);
	i3 = i3 - 1;
	i3 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, lastIndexOf$f519cb8928895c80, 0, r35, 46, i3);
	if (i3 != -1)
		goto label0;
	r33 = _JC_STRING(env, "");
	goto label1;

label0:
	r36 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, substring$df0d95f5ebfea7dc, 0, r35, 0, i3);
	r33 = r36;

label1:
	r34 = _JC_INVOKE_VIRTUAL(env, java_lang_ClassLoader, getPackage$563da6df7dbccf87, r32, r33);
	r30 = r34;
	goto label3;

label2:
	r30 = _JC_NULL;

label3:
	if (r30 == _JC_NULL)
		goto label4;
	r31 = _JC_INVOKE_VIRTUAL(env, java_lang_Package, getName$bec186f2ce7e1882, r30);
	_JC_INVOKE_VIRTUAL(env, java_lang_SecurityManager, checkPackageAccess$64ff94abf3ec1b09, r29, r31);

label4:
	r16 = _JC_INVOKE_STATIC(env, java_lang_VMClass, getDeclaredFields$e06e4acebc0033d5, 0, r13, 0);
	_JC_ACTIVE_USE(env, java_lang_reflect_AccessibleObject);
	_JC_ACTIVE_USE(env, java_lang_System);
	r39 = _JC_STATIC_FIELD(env, java_lang_SecurityManager, current, 1);
	if (r39 == _JC_NULL)
		goto label6;
	r38 = _JC_NEW(env, java_lang_reflect_ReflectPermission);
	r40 = _JC_STRING(env, "suppressAccessChecks");
	_JC_REF_FIELD(env, r38, java_security_Permission, name) = r40;
	r41 = _JC_STRING(env, "");
	z5 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, equals$8a15e0625571c581, 0, r41, r40);
	if (z5 == 0)
		goto label5;
	r42 = _JC_NEW(env, java_lang_IllegalArgumentException);
	r43 = _JC_STRING(env, "Empty name");
	_JC_REF_FIELD(env, r42, java_lang_Throwable, cause) = r42;
	r45 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r42);
	_JC_REF_FIELD(env, r42, java_lang_Throwable, vmState) = r45;
	_JC_REF_FIELD(env, r42, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r42, java_lang_Throwable, detailMessage) = r43;
	_JC_THROW(env, r42);

label5:
	_JC_INVOKE_VIRTUAL(env, java_lang_SecurityManager, checkPermission$c9030844da652e90, r39, r38);

label6:
	i4 = 0;
	goto label8;

label7:
	r37 = _JC_REF_ELEMENT(env, r16, i4, 0, 1);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_reflect_AccessibleObject, secureSetAccessible$4c760fdd9c1f3fed, 1, r37, 1);
	i4 = i4 + 1;

label8:
	i5 = _JC_ARRAY_LENGTH(env, r16);
	if (i4 < i5) {
		_JC_PERIODIC_CHECK(env);
		goto label7;
	}
	_JC_LINE_NUMBER(94);				// 3
	i0 = 0;

label9:
	_JC_TRAP_REGION(catch, 1);
	i1 = _JC_ARRAY_LENGTH(env, r16);
	if (i0 >= i1)
		goto label26;
	_JC_LINE_NUMBER(95);				// 4
	r6 = _JC_REF_ELEMENT(env, r16, i0, 1, 0);
	i1 = _JC_INVOKE_NONVIRTUAL(env, java_lang_reflect_Field, getModifiers$d9bdcb51d9f4fabc, 1, r6);
	_JC_ACTIVE_USE(env, java_lang_reflect_Modifier);
	z4 = 0;
	i2 = i1 & 8;
	if (i2 == 0)
		goto label10;
	z4 = 1;

label10:
	if (z4 == 0)
		goto label11;
	_JC_LINE_NUMBER(96);				// 5
	goto label21;

label11:
	_JC_LINE_NUMBER(97);				// 6
	_JC_INVOKE_VIRTUAL(env, polyglot_util_CodeWriter, begin$a70ea64f2a7c5211, r1, 4);
	_JC_LINE_NUMBER(98);				// 7
	r7 = _JC_NEW(env, java_lang_StringBuffer);
	r21 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r7, java_lang_StringBuffer, value) = r21;
	r6 = _JC_REF_ELEMENT(env, r16, i0, 0, 0);
	_JC_EXPLICIT_NULL_CHECK(env, r6);
	r14 = _JC_REF_FIELD(env, r6, java_lang_reflect_Field, name);
	r7 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r7, r14);
	r7 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r7, _JC_STRING(env, ": "));
	r17 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r17, r7);
	_JC_INVOKE_VIRTUAL(env, polyglot_util_CodeWriter, write$741cedc3a0899944, r1, r17);
	_JC_LINE_NUMBER(99);				// 8
	_JC_INVOKE_VIRTUAL(env, polyglot_util_CodeWriter, allowBreak$2840aaf42817e05c, r1, 0);
	_JC_TRAP_REGION(catch, 2);
	_JC_LINE_NUMBER(101);				// 9
	r6 = _JC_REF_ELEMENT(env, r16, i0, 0, 0);
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_reflect_Field, get$b30461fc5ea13399, 1, r6, r2);
	_JC_LINE_NUMBER(102);				// 10
	if (r4 == _JC_NULL)
		goto label18;
	r15 = _JC_INVOKE_STATIC(env, java_lang_VMObject, getClass$2be11d215bfbfbfe, 0, r4);
	_JC_LINE_NUMBER(104);				// 11
	r7 = _JC_NEW(env, java_lang_StringBuffer);
	r22 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r7, java_lang_StringBuffer, value) = r22;
	r7 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r7, _JC_STRING(env, "<"));
	r8 = _JC_INVOKE_NONVIRTUAL(env, java_lang_Class, toString$7ea43b33b80a3070, 1, r15);
	r7 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r7, r8);
	r7 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r7, _JC_STRING(env, ">:"));
	r18 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r18, r7);
	_JC_INVOKE_VIRTUAL(env, polyglot_util_CodeWriter, write$741cedc3a0899944, r1, r18);
	_JC_LINE_NUMBER(105);				// 12
	_JC_INVOKE_VIRTUAL(env, polyglot_util_CodeWriter, allowBreak$2840aaf42817e05c, r1, 0);
	_JC_LINE_NUMBER(106);				// 13
	r8 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, toString$7ea43b33b80a3070, r4);
	_JC_INVOKE_VIRTUAL(env, polyglot_util_CodeWriter, write$741cedc3a0899944, r1, r8);
	_JC_LINE_NUMBER(107);				// 14
	_JC_INVOKE_VIRTUAL(env, polyglot_util_CodeWriter, allowBreak$2840aaf42817e05c, r1, 4);
	_JC_LINE_NUMBER(108);				// 15
	r9 = _JC_STATIC_FIELD(env, polyglot_util_typedump_TypeDumper, class__24java__24lang__24Object, 0);
	if (r9 != _JC_NULL)
		goto label14;
	r24 = _JC_STRING(env, "java.lang.Object");
	_JC_TRAP_REGION(catch, 3);
	r26 = _JC_INVOKE_STATIC(env, java_lang_Class, forName$d3b57db3b6a905a3, 1, r24);
	_JC_TRAP_REGION(catch, 4);
	r9 = r26;
	goto label13;

label12:
	_JC_TRAP_REGION(catch, 4);
	r25 = _JC_CAUGHT_EXCEPTION(env);
	r27 = _JC_NEW(env, java_lang_NoClassDefFoundError);
	r24 = _JC_INVOKE_VIRTUAL(env, java_lang_Throwable, getMessage$13aaf240efc902b1, r25);
	_JC_REF_FIELD(env, r27, java_lang_Throwable, cause) = r27;
	r28 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r27);
	_JC_REF_FIELD(env, r27, java_lang_Throwable, vmState) = r28;
	_JC_REF_FIELD(env, r27, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r27, java_lang_Throwable, detailMessage) = r24;
	_JC_THROW(env, r27);

label13:
	_JC_STATIC_FIELD(env, polyglot_util_typedump_TypeDumper, class__24java__24lang__24Object, 1) = r26;
	goto label15;

label14:
	_JC_TRAP_REGION(catch, 4);
	r9 = _JC_STATIC_FIELD(env, polyglot_util_typedump_TypeDumper, class__24java__24lang__24Object, 1);

label15:
	_JC_EXPLICIT_NULL_CHECK(env, r9);
	z3 = 0;
	if (r9 != r15)
		goto label16;
	z3 = 1;

label16:
	if (z3 != 0)
		goto label20;
	r19 = _JC_STATIC_FIELD(env, polyglot_util_typedump_TypeDumper, dontExpand, 1);
	z2 = _JC_INVOKE_INTERFACE(env, r19, _JC_JLONG(0xd3bd70da40f05cb1), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r15);
	if (z2 != 0)
		goto label20;
	z1 = _JC_INVOKE_STATIC(env, java_lang_VMClass, isArray$c6d74dd754a5148f, 0, r15);
	if (z1 != 0)
		goto label20;
	z0 = _JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0x5db565349ffc17b2), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r4);
	if (z0 == 0)
		goto label17;
	r10 = _JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0xb30461fc5ea13399), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r4);
	if (r10 == r4)
		goto label20;

label17:
	_JC_LINE_NUMBER(113);				// 16
	_JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0x3bd1c078a0faa8da), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *, struct _jc_java_lang_Object$object *), r4, r4);
	_JC_LINE_NUMBER(114);				// 17
	_JC_INVOKE_VIRTUAL(env, polyglot_util_typedump_TypeDumper, dumpObject$ba0ace0c360abd4c, r0, r1, r4, r3);
	goto label20;

label18:
	_JC_TRAP_REGION(catch, 4);
	_JC_LINE_NUMBER(117);				// 18
	_JC_INVOKE_VIRTUAL(env, polyglot_util_CodeWriter, write$741cedc3a0899944, r1, _JC_STRING(env, "null"));
	_JC_TRAP_REGION(catch, 5);
	_JC_LINE_NUMBER(121);				// 19
	goto label20;

label19:
	_JC_TRAP_REGION(catch, 5);
	r11 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(120);				// 20
	r7 = _JC_NEW(env, java_lang_StringBuffer);
	r23 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r7, java_lang_StringBuffer, value) = r23;
	r7 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r7, _JC_STRING(env, "##["));
	r8 = _JC_INVOKE_VIRTUAL(env, java_lang_Throwable, getMessage$13aaf240efc902b1, r11);
	r7 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r7, r8);
	r7 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r7, _JC_STRING(env, "]"));
	r20 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r20, r7);
	_JC_INVOKE_VIRTUAL(env, polyglot_util_CodeWriter, write$741cedc3a0899944, r1, r20);

label20:
	_JC_TRAP_REGION(catch, 5);
	_JC_LINE_NUMBER(122);				// 21
	_JC_INVOKE_VIRTUAL(env, polyglot_util_CodeWriter, end$d5ec7c830865cdfd, r1);
	_JC_LINE_NUMBER(123);				// 22
	_JC_INVOKE_VIRTUAL(env, polyglot_util_CodeWriter, allowBreak$2840aaf42817e05c, r1, 0);

label21:
	_JC_TRAP_REGION(catch, 5);
	_JC_LINE_NUMBER(94);				// 23
	i0 = i0 + 1;
	_JC_PERIODIC_CHECK(env);
	goto label9;

label22:
	_JC_TRAP_REGION(catch, 6);
	_JC_LINE_NUMBER(130);				// 24
	r12 = _JC_CAUGHT_EXCEPTION(env);
	_JC_TRAP_REGION(catch, 7);
	_JC_LINE_NUMBER(126);				// 25
	goto label27;

label23:
	_JC_TRAP_REGION(catch, 8);
	_JC_LINE_NUMBER(130);				// 26
	_JC_PERIODIC_CHECK(env);
	r5 = _JC_CAUGHT_EXCEPTION(env);
	_JC_TRAP_REGION(catch, 9);
	_JC_LINE_NUMBER(127);				// 27
	goto label28;

label24:
	_JC_THROW(env, r5);

label25:
	_JC_LINE_NUMBER(131);				// 28
	_JC_CANCEL_TRAPS(env, catch);
	return;

label26:
	_JC_TRAP_REGION(catch, 10);
	_JC_INVOKE_VIRTUAL(env, polyglot_util_CodeWriter, end$d5ec7c830865cdfd, r1);
	_JC_INVOKE_VIRTUAL(env, polyglot_util_CodeWriter, allowBreak$2840aaf42817e05c, r1, 0);
	_JC_INVOKE_VIRTUAL(env, polyglot_util_CodeWriter, write$741cedc3a0899944, r1, _JC_STRING(env, "}"));
	_JC_PERIODIC_CHECK(env);
	goto label25;

label27:
	_JC_TRAP_REGION(catch, 10);
	_JC_INVOKE_VIRTUAL(env, polyglot_util_CodeWriter, end$d5ec7c830865cdfd, r1);
	_JC_INVOKE_VIRTUAL(env, polyglot_util_CodeWriter, allowBreak$2840aaf42817e05c, r1, 0);
	_JC_INVOKE_VIRTUAL(env, polyglot_util_CodeWriter, write$741cedc3a0899944, r1, _JC_STRING(env, "}"));
	_JC_PERIODIC_CHECK(env);
	goto label25;

label28:
	_JC_TRAP_REGION(catch, 10);
	_JC_INVOKE_VIRTUAL(env, polyglot_util_CodeWriter, end$d5ec7c830865cdfd, r1);
	_JC_INVOKE_VIRTUAL(env, polyglot_util_CodeWriter, allowBreak$2840aaf42817e05c, r1, 0);
	_JC_INVOKE_VIRTUAL(env, polyglot_util_CodeWriter, write$741cedc3a0899944, r1, _JC_STRING(env, "}"));
	_JC_PERIODIC_CHECK(env);
	goto label24;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_polyglot_util_typedump_TypeDumper$methods[] = {
	&_jc_polyglot_util_typedump_TypeDumper$method_info$_clinit$a816641e0ba8bfef,
	&_jc_polyglot_util_typedump_TypeDumper$method_info$_init$f9c9831deeb00033,
	&_jc_polyglot_util_typedump_TypeDumper$method_info$class__24$57cd45dca0be1678,
	&_jc_polyglot_util_typedump_TypeDumper$method_info$dontDump$b51c08815d17eae2,
	&_jc_polyglot_util_typedump_TypeDumper$method_info$dump$30efa1ff09c02470,
	&_jc_polyglot_util_typedump_TypeDumper$method_info$dumpObject$ba0ace0c360abd4c,
	&_jc_polyglot_util_typedump_TypeDumper$method_info$load$6dc50d612bc9d36e
};

/************************************************************************
 *			  Class fields structure			*
 ************************************************************************/

_jc_polyglot_util_typedump_TypeDumper$fields_struct _jc_polyglot_util_typedump_TypeDumper$class_fields = { };

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_polyglot_util_typedump_TypeDumper$instanceof_hash_bucket_4[] = {
	&_jc_polyglot_util_typedump_TypeDumper$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_util_typedump_TypeDumper$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_polyglot_util_typedump_TypeDumper$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[4]=	_jc_polyglot_util_typedump_TypeDumper$instanceof_hash_bucket_4,
	[101]=	_jc_polyglot_util_typedump_TypeDumper$instanceof_hash_bucket_101
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_polyglot_util_typedump_TypeDumper$class_depends[] = {
	{ "java/io/IOException",	_JC_JLONG(0x4e0a56550c69d57c) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/ClassLoader",	_JC_JLONG(0xb0527a7101321261) },
	{ "java/lang/ClassNotFoundException",	_JC_JLONG(0x1f925cf50bfc0d6c) },
	{ "java/lang/Error",	_JC_JLONG(0x308333d803f5ab9f) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/IllegalAccessException",	_JC_JLONG(0x29deac5351715967) },
	{ "java/lang/IllegalArgumentException",	_JC_JLONG(0x680cf34d05feb5a1) },
	{ "java/lang/LinkageError",	_JC_JLONG(0x3746e17e005bda9e) },
	{ "java/lang/Long",	_JC_JLONG(0x72c9d9e8f269fac) },
	{ "java/lang/Math",	_JC_JLONG(0x8d71d806a180ad8a) },
	{ "java/lang/NoClassDefFoundError",	_JC_JLONG(0x2082ebb592ac2255) },
	{ "java/lang/NoSuchFieldException",	_JC_JLONG(0xb466c3d2a1fb976d) },
	{ "java/lang/NullPointerException",	_JC_JLONG(0x505b8a9a6675be0) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/Package",	_JC_JLONG(0xaffa3b3edb623a4e) },
	{ "java/lang/RuntimeException",	_JC_JLONG(0x4f5534a987354d1d) },
	{ "java/lang/SecurityException",	_JC_JLONG(0x767fc1626c63609e) },
	{ "java/lang/SecurityManager",	_JC_JLONG(0xd38282f3d5f80887) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/StringBuffer",	_JC_JLONG(0x94d357637b968dda) },
	{ "java/lang/System",	_JC_JLONG(0x53cc8e2333795f04) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMClass",	_JC_JLONG(0x238a2c0aafd74314) },
	{ "java/lang/VMObject",	_JC_JLONG(0x312e45ed214d432f) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/lang/reflect/AccessibleObject",	_JC_JLONG(0x2272439d2affe42f) },
	{ "java/lang/reflect/Field",	_JC_JLONG(0xa19b05adac48346b) },
	{ "java/lang/reflect/Modifier",	_JC_JLONG(0xb413af5dc930e175) },
	{ "java/lang/reflect/ReflectPermission",	_JC_JLONG(0x217a96fa40004e5) },
	{ "java/security/BasicPermission",	_JC_JLONG(0xd5158e4c9a3bab21) },
	{ "java/security/Permission",	_JC_JLONG(0x2377c76e79058a72) },
	{ "java/util/AbstractCollection",	_JC_JLONG(0x8ea716c64b77f8eb) },
	{ "java/util/AbstractList",	_JC_JLONG(0xf5238436362828db) },
	{ "java/util/AbstractList$1",	_JC_JLONG(0x21dd4c24cb5af7f8) },
	{ "java/util/AbstractSet",	_JC_JLONG(0xca427569b5b2f804) },
	{ "java/util/Arrays",	_JC_JLONG(0x363c8597b4f8d5ff) },
	{ "java/util/Arrays$ArrayList",	_JC_JLONG(0x4a2b9f35d0d4bf7d) },
	{ "java/util/Date",	_JC_JLONG(0xa85d2a51094e614c) },
	{ "java/util/HashMap",	_JC_JLONG(0xd7cd853200c3e71f) },
	{ "java/util/HashSet",	_JC_JLONG(0x3c285c721478414d) },
	{ "java/util/Map",	_JC_JLONG(0xe283f7c2e7a7979c) },
	{ "java/util/Set",	_JC_JLONG(0x617ac82c0bec2dff) },
	{ "polyglot/types/Type",	_JC_JLONG(0x6596051546781098) },
	{ "polyglot/types/TypeSystem",	_JC_JLONG(0xed171cdaca38ec28) },
	{ "polyglot/util/CodeWriter",	_JC_JLONG(0xbda7215170a25efc) },
	{ "polyglot/util/TypeEncoder",	_JC_JLONG(0xf299688fad53c0b2) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_polyglot_util_typedump_TypeDumper$vtype _jc_polyglot_util_typedump_TypeDumper$type = {
    .type= {
	.name=			"polyglot/util/typedump/TypeDumper",
	.superclass=		&_jc_java_lang_Object$type,
	.access_flags=		0,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		13,
		.hash=			_JC_JLONG(0xce9c276c03241184),
		.source_file=		"TypeDumper.java",
		.instance_size=		sizeof(_jc_polyglot_util_typedump_TypeDumper$refs) + sizeof(_jc_polyglot_util_typedump_TypeDumper$object),
		.num_virtual_refs=	4,
		.num_fields=		sizeof(_jc_polyglot_util_typedump_TypeDumper$fields) / sizeof(*_jc_polyglot_util_typedump_TypeDumper$fields),
		.fields=		_jc_polyglot_util_typedump_TypeDumper$fields,
		.num_methods=		sizeof(_jc_polyglot_util_typedump_TypeDumper$methods) / sizeof(*_jc_polyglot_util_typedump_TypeDumper$methods),
		.methods=		_jc_polyglot_util_typedump_TypeDumper$methods,
		.instanceof_hash_table=	_jc_polyglot_util_typedump_TypeDumper$instanceof_hash_table,
		.class_fields=		&_jc_polyglot_util_typedump_TypeDumper$class_fields,
		.num_class_depends=		sizeof(_jc_polyglot_util_typedump_TypeDumper$class_depends) / sizeof(*_jc_polyglot_util_typedump_TypeDumper$class_depends),
		.class_depends=		_jc_polyglot_util_typedump_TypeDumper$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.polyglot_util_typedump_TypeDumper= {
	    .dump$30efa1ff09c02470=
		&_jc_polyglot_util_typedump_TypeDumper$method$dump$30efa1ff09c02470,
	    .dumpObject$ba0ace0c360abd4c=
		&_jc_polyglot_util_typedump_TypeDumper$method$dumpObject$ba0ace0c360abd4c,
	},
    }
};

