// public class polyglot.visit.ReachChecker

// class file dependencies
// @dep_class 99a46305ebacacb5 java_io_PrintStream
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class 9b667b09132be893 java_lang_Cloneable
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class 4f5534a987354d1d java_lang_RuntimeException
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 53cc8e2333795f04 java_lang_System
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class 8ea716c64b77f8eb java_util_AbstractCollection
// @dep_class f5238436362828db java_util_AbstractList
// @dep_class 6d7997e879c41059 java_util_AbstractSequentialList
// @dep_class eae4d0c0e8eb63da java_util_Collection
// @dep_class 9574af3fed58029a java_util_Collections
// @dep_class 2ccd076083da6c8e java_util_Collections__24SingletonList
// @dep_class d7cd853200c3e71f java_util_HashMap
// @dep_class be56ff673eefd9d2 java_util_Iterator
// @dep_class 666417b6279ae396 java_util_LinkedList
// @dep_class 9ee0d92ce1525a4d java_util_List
// @dep_class e283f7c2e7a7979c java_util_Map
// @dep_class 617ac82c0bec2dff java_util_Set
// @dep_class 5eda5b679dfeb2f7 polyglot_ast_Block
// @dep_class 958fcc544dfda930 polyglot_ast_CompoundStmt
// @dep_class 1c402b4f9747e08 polyglot_ast_Node
// @dep_class 56625b3befab19f polyglot_ast_NodeFactory
// @dep_class de1430f3b100a09a polyglot_ast_Stmt
// @dep_class d96ecce1886ee664 polyglot_ast_Term
// @dep_class 42e687805b457724 polyglot_frontend_Job
// @dep_class cf9f146bdb7bc44d polyglot_main_Report
// @dep_class 45f755f5298b5b39 polyglot_types_SemanticException
// @dep_class ed171cdaca38ec28 polyglot_types_TypeSystem
// @dep_class c1adfaf4637dbc02 polyglot_util_Copy
// @dep_class 22b321d488641c54 polyglot_util_InternalCompilerError
// @dep_class 32c9a088c5dac046 polyglot_util_Position
// @dep_class c4ffacca45f5127f polyglot_visit_DataFlow
// @dep_class 146082755586f7f1 polyglot_visit_DataFlow__24Item
// @dep_class 8a4bd51bcd9d71a polyglot_visit_ErrorHandlingVisitor
// @dep_class b6315ac3e2e0e62 polyglot_visit_FlowGraph
// @dep_class d12d97b39a3d4675 polyglot_visit_FlowGraph__24Peer
// @dep_class 2f5b20d380322b22 polyglot_visit_HaltingVisitor
// @dep_class 534db787197439f0 polyglot_visit_NodeVisitor
// @dep_class 45301305bdc4ecb1 polyglot_visit_ReachChecker
// @dep_class 4890c8ee70ad94da polyglot_visit_ReachChecker__24DataFlowItem

// header file dependencies
// @dep_header java_io_PrintStream
// @dep_header java_lang_Class
// @dep_header java_lang_Cloneable
// @dep_header java_lang_String
// @dep_header java_lang_System
// @dep_header java_lang_VMThrowable
// @dep_header java_util_Collection
// @dep_header java_util_Collections
// @dep_header java_util_Collections__24SingletonList
// @dep_header java_util_HashMap
// @dep_header java_util_Iterator
// @dep_header java_util_LinkedList
// @dep_header java_util_List
// @dep_header java_util_Map
// @dep_header java_util_Set
// @dep_header polyglot_ast_Block
// @dep_header polyglot_ast_CompoundStmt
// @dep_header polyglot_ast_Node
// @dep_header polyglot_ast_NodeFactory
// @dep_header polyglot_ast_Stmt
// @dep_header polyglot_ast_Term
// @dep_header polyglot_frontend_Job
// @dep_header polyglot_main_Report
// @dep_header polyglot_types_SemanticException
// @dep_header polyglot_types_TypeSystem
// @dep_header polyglot_util_Copy
// @dep_header polyglot_util_InternalCompilerError
// @dep_header polyglot_util_Position
// @dep_header polyglot_visit_FlowGraph
// @dep_header polyglot_visit_FlowGraph__24Peer
// @dep_header polyglot_visit_ReachChecker
// @dep_header polyglot_visit_ReachChecker__24DataFlowItem

#include "jc_defs.h"

#include "java/io/PrintStream.h"
#include "java/lang/Class.h"
#include "java/lang/Cloneable.h"
#include "java/lang/String.h"
#include "java/lang/System.h"
#include "java/lang/VMThrowable.h"
#include "java/util/Collection.h"
#include "java/util/Collections.h"
#include "java/util/Collections__24SingletonList.h"
#include "java/util/HashMap.h"
#include "java/util/Iterator.h"
#include "java/util/LinkedList.h"
#include "java/util/List.h"
#include "java/util/Map.h"
#include "java/util/Set.h"
#include "polyglot/ast/Block.h"
#include "polyglot/ast/CompoundStmt.h"
#include "polyglot/ast/Node.h"
#include "polyglot/ast/NodeFactory.h"
#include "polyglot/ast/Stmt.h"
#include "polyglot/ast/Term.h"
#include "polyglot/frontend/Job.h"
#include "polyglot/main/Report.h"
#include "polyglot/types/SemanticException.h"
#include "polyglot/types/TypeSystem.h"
#include "polyglot/util/Copy.h"
#include "polyglot/util/InternalCompilerError.h"
#include "polyglot/util/Position.h"
#include "polyglot/visit/FlowGraph.h"
#include "polyglot/visit/FlowGraph__24Peer.h"
#include "polyglot/visit/ReachChecker.h"
#include "polyglot/visit/ReachChecker__24DataFlowItem.h"

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// public void <init>(polyglot.frontend.Job, polyglot.types.TypeSystem, polyglot.ast.NodeFactory)
//

static _jc_linenum _jc_polyglot_visit_ReachChecker$linenum_table$_init$dac7f764f0e12933[];

static const unsigned char _jc_polyglot_visit_ReachChecker$param_ptypes$_init$dac7f764f0e12933[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_visit_ReachChecker$param_types$_init$dac7f764f0e12933[] = {
	&_jc_polyglot_frontend_Job$type,
	&_jc_polyglot_types_TypeSystem$type,
	&_jc_polyglot_ast_NodeFactory$type
};

_jc_method _jc_polyglot_visit_ReachChecker$method_info$_init$dac7f764f0e12933 = {
	.name=			"<init>",
	.signature=		"(Lpolyglot/frontend/Job;Lpolyglot/types/TypeSystem;Lpolyglot/ast/NodeFactory;)V",
	.class=			&_jc_polyglot_visit_ReachChecker$type,
	.param_types=		&_jc_polyglot_visit_ReachChecker$param_types$_init$dac7f764f0e12933,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_visit_ReachChecker$param_ptypes$_init$dac7f764f0e12933,
	.signature_hash=	_JC_JLONG(0xdac7f764f0e12933),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_visit_ReachChecker$method$_init$dac7f764f0e12933,
	.num_parameters=	3,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_visit_ReachChecker$linenum_table$_init$dac7f764f0e12933
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_visit_ReachChecker, _init$dac7f764f0e12933);

void _JC_JCNI_ATTR
_jc_polyglot_visit_ReachChecker$method$_init$dac7f764f0e12933(_jc_env *const env, _jc_polyglot_visit_ReachChecker$object *this, _jc_polyglot_frontend_Job$object *param0, _jc_object *param1, _jc_object *param2)
{
	struct _jc_polyglot_visit_ReachChecker$object *r0;
	struct _jc_polyglot_frontend_Job$object *r1;
	struct _jc_object *r2;
	struct _jc_object *r3;
	struct _jc_java_util_LinkedList$object *r4;

	r0 = this;
	r1 = param0;
	r2 = param1;
	r3 = param2;
	_JC_REF_FIELD(env, r0, polyglot_visit_ErrorHandlingVisitor, job) = r1;
	_JC_REF_FIELD(env, r0, polyglot_visit_ErrorHandlingVisitor, ts) = r2;
	_JC_REF_FIELD(env, r0, polyglot_visit_ErrorHandlingVisitor, nf) = r3;
	_JC_PRIM_FIELD(env, r0, polyglot_visit_DataFlow, forward) = 1;
	_JC_PRIM_FIELD(env, r0, polyglot_visit_DataFlow, dataflowOnEntry) = 1;
	r4 = _JC_NEW(env, java_util_LinkedList);
	_JC_PRIM_FIELD(env, r4, java_util_LinkedList, size) = 0;
	_JC_REF_FIELD(env, r0, polyglot_visit_DataFlow, flowgraphStack) = r4;
	_JC_LINE_NUMBER(30);				// 0
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public void check(polyglot.visit.FlowGraph, polyglot.ast.Term, polyglot.visit.DataFlow$Item, java.util.Map) throws polyglot.types.SemanticException
//

static _jc_linenum _jc_polyglot_visit_ReachChecker$linenum_table$check$3df37c60acd34b0e[];

static const unsigned char _jc_polyglot_visit_ReachChecker$param_ptypes$check$3df37c60acd34b0e[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_visit_ReachChecker$exceptions$check$3df37c60acd34b0e[] = {
	&_jc_polyglot_types_SemanticException$type
};

static _jc_type *const _jc_polyglot_visit_ReachChecker$param_types$check$3df37c60acd34b0e[] = {
	&_jc_polyglot_visit_FlowGraph$type,
	&_jc_polyglot_ast_Term$type,
	&_jc_polyglot_visit_DataFlow__24Item$type,
	&_jc_java_util_Map$type
};

_jc_method _jc_polyglot_visit_ReachChecker$method_info$check$3df37c60acd34b0e = {
	.name=			"check",
	.signature=		"(Lpolyglot/visit/FlowGraph;Lpolyglot/ast/Term;Lpolyglot/visit/DataFlow$Item;Ljava/util/Map;)V",
	.class=			&_jc_polyglot_visit_ReachChecker$type,
	.param_types=		&_jc_polyglot_visit_ReachChecker$param_types$check$3df37c60acd34b0e,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_visit_ReachChecker$param_ptypes$check$3df37c60acd34b0e,
	.signature_hash=	_JC_JLONG(0x3df37c60acd34b0e),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_visit_ReachChecker$method$check$3df37c60acd34b0e,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_visit_ReachChecker$vtable, polyglot_visit_ReachChecker.check$3df37c60acd34b0e) / sizeof(void *),
	.num_parameters=	4,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_visit_ReachChecker$exceptions$check$3df37c60acd34b0e,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_visit_ReachChecker$linenum_table$check$3df37c60acd34b0e
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_visit_ReachChecker, check$3df37c60acd34b0e);

void _JC_JCNI_ATTR
_jc_polyglot_visit_ReachChecker$method$check$3df37c60acd34b0e(_jc_env *const env, _jc_polyglot_visit_ReachChecker$object *this, _jc_polyglot_visit_FlowGraph$object *param0, _jc_object *param1, _jc_polyglot_visit_DataFlow__24Item$object *param2, _jc_object *param3)
{
	struct _jc_polyglot_visit_ReachChecker$object *r0;
	struct _jc_polyglot_visit_FlowGraph$object *r1;
	struct _jc_object *r2;
	struct _jc_polyglot_visit_DataFlow__24Item$object *r3;
	struct _jc_object *r4;
	struct _jc_polyglot_util_InternalCompilerError$object *r5;
	struct _jc_java_lang_String$object *r6;
	struct _jc_polyglot_util_Position$object *r7;
	struct _jc_java_lang_VMThrowable$object *r9;

	r0 = this;
	r1 = param0;
	r2 = param1;
	r3 = param2;
	r4 = param3;
	_JC_LINE_NUMBER(145);				// 0
	r5 = _JC_NEW(env, polyglot_util_InternalCompilerError);
	r6 = _JC_STRING(env, "ReachChecker.check should never be called.");
	r7 = _JC_NULL;
	_JC_REF_FIELD(env, r5, java_lang_Throwable, cause) = r5;
	r9 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r5);
	_JC_REF_FIELD(env, r5, java_lang_Throwable, vmState) = r9;
	_JC_REF_FIELD(env, r5, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r5, java_lang_Throwable, detailMessage) = r6;
	_JC_REF_FIELD(env, r5, polyglot_util_InternalCompilerError, pos) = r7;
	_JC_THROW(env, r5);
}

//
// protected polyglot.ast.Node checkReachability(polyglot.ast.Term) throws polyglot.types.SemanticException
//

static _jc_linenum _jc_polyglot_visit_ReachChecker$linenum_table$checkReachability$4d8a628641057bcc[];

static const unsigned char _jc_polyglot_visit_ReachChecker$param_ptypes$checkReachability$4d8a628641057bcc[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_visit_ReachChecker$exceptions$checkReachability$4d8a628641057bcc[] = {
	&_jc_polyglot_types_SemanticException$type
};

static _jc_type *const _jc_polyglot_visit_ReachChecker$param_types$checkReachability$4d8a628641057bcc[] = {
	&_jc_polyglot_ast_Term$type
};

_jc_method _jc_polyglot_visit_ReachChecker$method_info$checkReachability$4d8a628641057bcc = {
	.name=			"checkReachability",
	.signature=		"(Lpolyglot/ast/Term;)Lpolyglot/ast/Node;",
	.class=			&_jc_polyglot_visit_ReachChecker$type,
	.param_types=		&_jc_polyglot_visit_ReachChecker$param_types$checkReachability$4d8a628641057bcc,
	.return_type=		&_jc_polyglot_ast_Node$type,
	.param_ptypes=		&_jc_polyglot_visit_ReachChecker$param_ptypes$checkReachability$4d8a628641057bcc,
	.signature_hash=	_JC_JLONG(0x4d8a628641057bcc),
	.access_flags=		_JC_ACC_PROTECTED,
	.function=		&_jc_polyglot_visit_ReachChecker$method$checkReachability$4d8a628641057bcc,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_visit_ReachChecker$vtable, polyglot_visit_ReachChecker.checkReachability$4d8a628641057bcc) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_visit_ReachChecker$exceptions$checkReachability$4d8a628641057bcc,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	17,
	      .table=	_jc_polyglot_visit_ReachChecker$linenum_table$checkReachability$4d8a628641057bcc
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_visit_ReachChecker, checkReachability$4d8a628641057bcc);

_jc_object * _JC_JCNI_ATTR
_jc_polyglot_visit_ReachChecker$method$checkReachability$4d8a628641057bcc(_jc_env *const env, _jc_polyglot_visit_ReachChecker$object *this, _jc_object *param0)
{
	struct _jc_polyglot_visit_ReachChecker$object *r0;
	struct _jc_object *r1;
	struct _jc_object *r10;
	struct _jc_object *r11;
	struct _jc_object *r12;
	struct _jc_polyglot_types_SemanticException$object *r13;
	struct _jc_polyglot_util_Position$object *r14;
	struct _jc_java_lang_String$object *r15;
	struct _jc_java_lang_VMThrowable$object *r16;
	struct _jc_java_lang_String$object *r17;
	struct _jc_java_io_PrintStream$object *r18;
	struct _jc_java_lang_String$object *r19;
	struct _jc_polyglot_visit_FlowGraph$object *r2;
	struct _jc_java_util_Collections__24SingletonList$object *r20;
	struct _jc_object *r3;
	struct _jc_object *r4;
	struct _jc_polyglot_visit_FlowGraph__24Peer$object *r5;
	struct _jc_object *r6;
	struct _jc_polyglot_visit_ReachChecker__24DataFlowItem$object *r7;
	struct _jc_java_lang_Object$object *r8;
	struct _jc_polyglot_visit_DataFlow__24Item$object *r9;
	jboolean z0;
	jboolean z1;
	jboolean z2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(90);				// 0
	r2 = _JC_INVOKE_VIRTUAL(env, polyglot_visit_DataFlow, currentFlowGraph$d6cf31facdb0f823, r0);
	_JC_LINE_NUMBER(91);				// 1
	if (r2 == _JC_NULL)
		goto label9;
	_JC_LINE_NUMBER(92);				// 2
	r3 = _JC_INVOKE_VIRTUAL(env, polyglot_visit_FlowGraph, peers$545e437b300aca2b, r2, r1);
	_JC_LINE_NUMBER(93);				// 3
	if (r3 == _JC_NULL)
		goto label9;
	z0 = _JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0x551bea84f4e0f0cb), jboolean, (_jc_env *, struct _jc_object *));
	if (z0 != 0)
		goto label9;
	_JC_LINE_NUMBER(94);				// 4
	r4 = _JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0x3cc91493d50f531c), _jc_object *, (_jc_env *, struct _jc_object *));

label0:
	z0 = _JC_INVOKE_INTERFACE(env, r4, _JC_JLONG(0xfb0bd5e38c59ddcd), jboolean, (_jc_env *, struct _jc_object *));
	if (z0 == 0)
		goto label3;
	_JC_LINE_NUMBER(95);				// 5
	r8 = _JC_INVOKE_INTERFACE(env, r4, _JC_JLONG(0x5874f79a1cf66ea), _jc_object *, (_jc_env *, struct _jc_object *));
	r5 = _JC_CAST(env, &_jc_polyglot_visit_FlowGraph__24Peer$type, r8);
	_JC_LINE_NUMBER(102);				// 6
	r9 = _JC_REF_FIELD(env, r5, polyglot_visit_FlowGraph__24Peer, inItem);
	if (r9 == _JC_NULL)
		goto label1;
	r9 = _JC_REF_FIELD(env, r5, polyglot_visit_FlowGraph__24Peer, inItem);
	r7 = _JC_CAST(env, &_jc_polyglot_visit_ReachChecker__24DataFlowItem$type, r9);
	z0 = _JC_PRIM_FIELD(env, r7, polyglot_visit_ReachChecker__24DataFlowItem, reachable);
	if (z0 == 0)
		goto label1;
	_JC_LINE_NUMBER(103);				// 7
	r1 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0x1b56f401b2f699a4), _jc_object *, (_jc_env *, struct _jc_object *, jboolean), 1);
	return r1;

label1:
	_JC_LINE_NUMBER(106);				// 8
	r10 = _JC_REF_FIELD(env, r5, polyglot_visit_FlowGraph__24Peer, outItems);
	if (r10 == _JC_NULL) {
		_JC_PERIODIC_CHECK(env);
		goto label0;
	}
	_JC_LINE_NUMBER(107);				// 9
	r10 = _JC_REF_FIELD(env, r5, polyglot_visit_FlowGraph__24Peer, outItems);
	r3 = _JC_INVOKE_INTERFACE(env, r10, _JC_JLONG(0xff2f8ae502eccb46), _jc_object *, (_jc_env *, struct _jc_object *));
	r6 = _JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0x3cc91493d50f531c), _jc_object *, (_jc_env *, struct _jc_object *));

label2:
	z0 = _JC_INVOKE_INTERFACE(env, r6, _JC_JLONG(0xfb0bd5e38c59ddcd), jboolean, (_jc_env *, struct _jc_object *));
	if (z0 == 0) {
		_JC_PERIODIC_CHECK(env);
		goto label0;
	}
	_JC_LINE_NUMBER(108);				// 10
	r8 = _JC_INVOKE_INTERFACE(env, r6, _JC_JLONG(0x5874f79a1cf66ea), _jc_object *, (_jc_env *, struct _jc_object *));
	r7 = _JC_CAST(env, &_jc_polyglot_visit_ReachChecker__24DataFlowItem$type, r8);
	_JC_LINE_NUMBER(110);				// 11
	if (r7 == _JC_NULL) {
		_JC_PERIODIC_CHECK(env);
		goto label2;
	}
	z0 = _JC_PRIM_FIELD(env, r7, polyglot_visit_ReachChecker__24DataFlowItem, reachable);
	if (z0 == 0) {
		_JC_PERIODIC_CHECK(env);
		goto label2;
	}
	_JC_LINE_NUMBER(112);				// 12
	r1 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0x1b56f401b2f699a4), _jc_object *, (_jc_env *, struct _jc_object *, jboolean), 1);
	return r1;

label3:
	_JC_LINE_NUMBER(119);				// 13
	r1 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0x1b56f401b2f699a4), _jc_object *, (_jc_env *, struct _jc_object *, jboolean), 0);
	_JC_LINE_NUMBER(126);				// 14
	z0 = _JC_INSTANCEOF(env, r1, &_jc_polyglot_ast_Block$type);
	if (z0 == 0)
		goto label4;
	r11 = r1;
	r12 = _JC_INVOKE_INTERFACE(env, r11, _JC_JLONG(0x23d32fa9f48852f), _jc_object *, (_jc_env *, struct _jc_object *));
	z0 = _JC_INVOKE_INTERFACE(env, r12, _JC_JLONG(0x551bea84f4e0f0cb), jboolean, (_jc_env *, struct _jc_object *));
	if (z0 != 0)
		goto label5;

label4:
	z0 = _JC_INSTANCEOF(env, r1, &_jc_polyglot_ast_Stmt$type);
	if (z0 == 0)
		goto label9;
	z0 = _JC_INSTANCEOF(env, r1, &_jc_polyglot_ast_CompoundStmt$type);
	if (z0 != 0)
		goto label9;

label5:
	_JC_LINE_NUMBER(128);				// 15
	r13 = _JC_NEW(env, polyglot_types_SemanticException);
	r14 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0xbb89333b1e4c840c), _jc_object *, (_jc_env *, struct _jc_object *));
	r15 = _JC_STRING(env, "Unreachable statement.");
	_JC_REF_FIELD(env, r13, java_lang_Throwable, cause) = r13;
	r16 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r13);
	_JC_REF_FIELD(env, r13, java_lang_Throwable, vmState) = r16;
	_JC_REF_FIELD(env, r13, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r13, java_lang_Throwable, detailMessage) = r15;
	_JC_REF_FIELD(env, r13, polyglot_types_SemanticException, position) = r14;
	r17 = _JC_STATIC_FIELD(env, polyglot_main_Report, errors, 0);
	z2 = _JC_STATIC_FIELD(env, polyglot_main_Report, noReporting, 1);
	if (z2 == 0)
		goto label6;
	z1 = 0;
	goto label7;

label6:
	_JC_ACTIVE_USE(env, java_util_Collections);
	r20 = _JC_NEW(env, java_util_Collections__24SingletonList);
	_JC_REF_FIELD(env, r20, java_util_Collections__24SingletonList, element) = r17;
	z2 = _JC_INVOKE_STATIC(env, polyglot_main_Report, should__5freport$316269f2ec4db001, 1, r20, 5);
	z1 = z2;

label7:
	if (z1 == 0)
		goto label8;
	r18 = _JC_STATIC_FIELD(env, java_lang_System, err, 0);
	r19 = _JC_INVOKE_NONVIRTUAL(env, java_lang_Throwable, stackTraceString$42eec01c019ee6b0, 0, r13);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, print$21bdbb15afdbea95, r18, r19);

label8:
	_JC_THROW(env, r13);

label9:
	_JC_LINE_NUMBER(133);				// 16
	return r1;
}

//
// public polyglot.visit.DataFlow$Item confluence(java.util.List, polyglot.ast.Term)
//

static _jc_linenum _jc_polyglot_visit_ReachChecker$linenum_table$confluence$8f9f293f0bd8b7b5[];

static const unsigned char _jc_polyglot_visit_ReachChecker$param_ptypes$confluence$8f9f293f0bd8b7b5[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_visit_ReachChecker$param_types$confluence$8f9f293f0bd8b7b5[] = {
	&_jc_java_util_List$type,
	&_jc_polyglot_ast_Term$type
};

_jc_method _jc_polyglot_visit_ReachChecker$method_info$confluence$8f9f293f0bd8b7b5 = {
	.name=			"confluence",
	.signature=		"(Ljava/util/List;Lpolyglot/ast/Term;)Lpolyglot/visit/DataFlow$Item;",
	.class=			&_jc_polyglot_visit_ReachChecker$type,
	.param_types=		&_jc_polyglot_visit_ReachChecker$param_types$confluence$8f9f293f0bd8b7b5,
	.return_type=		&_jc_polyglot_visit_DataFlow__24Item$type,
	.param_ptypes=		&_jc_polyglot_visit_ReachChecker$param_ptypes$confluence$8f9f293f0bd8b7b5,
	.signature_hash=	_JC_JLONG(0x8f9f293f0bd8b7b5),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_visit_ReachChecker$method$confluence$8f9f293f0bd8b7b5,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_visit_ReachChecker$vtable, polyglot_visit_ReachChecker.confluence$8f9f293f0bd8b7b5) / sizeof(void *),
	.num_parameters=	2,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_polyglot_visit_ReachChecker$linenum_table$confluence$8f9f293f0bd8b7b5
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_visit_ReachChecker, confluence$8f9f293f0bd8b7b5);

_jc_polyglot_visit_DataFlow__24Item$object * _JC_JCNI_ATTR
_jc_polyglot_visit_ReachChecker$method$confluence$8f9f293f0bd8b7b5(_jc_env *const env, _jc_polyglot_visit_ReachChecker$object *this, _jc_object *param0, _jc_object *param1)
{
	struct _jc_polyglot_visit_ReachChecker$object *r0;
	struct _jc_object *r1;
	struct _jc_object *r2;
	struct _jc_object *r3;
	struct _jc_java_lang_Object$object *r4;
	struct _jc_polyglot_visit_ReachChecker__24DataFlowItem$object *r5;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_LINE_NUMBER(72);				// 0
	r3 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0x3cc91493d50f531c), _jc_object *, (_jc_env *, struct _jc_object *));

label0:
	z0 = _JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0xfb0bd5e38c59ddcd), jboolean, (_jc_env *, struct _jc_object *));
	if (z0 == 0)
		goto label1;
	_JC_LINE_NUMBER(73);				// 1
	r4 = _JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0x5874f79a1cf66ea), _jc_object *, (_jc_env *, struct _jc_object *));
	r5 = _JC_CAST(env, &_jc_polyglot_visit_ReachChecker__24DataFlowItem$type, r4);
	z0 = _JC_PRIM_FIELD(env, r5, polyglot_visit_ReachChecker__24DataFlowItem, reachable);
	if (z0 == 0) {
		_JC_PERIODIC_CHECK(env);
		goto label0;
	}
	_JC_LINE_NUMBER(74);				// 2
	r5 = _JC_STATIC_FIELD(env, polyglot_visit_ReachChecker__24DataFlowItem, REACHABLE, 1);
	return r5;

label1:
	_JC_LINE_NUMBER(77);				// 3
	r5 = _JC_STATIC_FIELD(env, polyglot_visit_ReachChecker__24DataFlowItem, NOT__5fREACHABLE, 0);
	return r5;
}

//
// public polyglot.visit.DataFlow$Item createInitialItem(polyglot.visit.FlowGraph)
//

static _jc_linenum _jc_polyglot_visit_ReachChecker$linenum_table$createInitialItem$1a8de5b116761d1a[];

static const unsigned char _jc_polyglot_visit_ReachChecker$param_ptypes$createInitialItem$1a8de5b116761d1a[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_visit_ReachChecker$param_types$createInitialItem$1a8de5b116761d1a[] = {
	&_jc_polyglot_visit_FlowGraph$type
};

_jc_method _jc_polyglot_visit_ReachChecker$method_info$createInitialItem$1a8de5b116761d1a = {
	.name=			"createInitialItem",
	.signature=		"(Lpolyglot/visit/FlowGraph;)Lpolyglot/visit/DataFlow$Item;",
	.class=			&_jc_polyglot_visit_ReachChecker$type,
	.param_types=		&_jc_polyglot_visit_ReachChecker$param_types$createInitialItem$1a8de5b116761d1a,
	.return_type=		&_jc_polyglot_visit_DataFlow__24Item$type,
	.param_ptypes=		&_jc_polyglot_visit_ReachChecker$param_ptypes$createInitialItem$1a8de5b116761d1a,
	.signature_hash=	_JC_JLONG(0x1a8de5b116761d1a),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_visit_ReachChecker$method$createInitialItem$1a8de5b116761d1a,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_visit_ReachChecker$vtable, polyglot_visit_ReachChecker.createInitialItem$1a8de5b116761d1a) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_visit_ReachChecker$linenum_table$createInitialItem$1a8de5b116761d1a
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_visit_ReachChecker, createInitialItem$1a8de5b116761d1a);

_jc_polyglot_visit_DataFlow__24Item$object * _JC_JCNI_ATTR
_jc_polyglot_visit_ReachChecker$method$createInitialItem$1a8de5b116761d1a(_jc_env *const env, _jc_polyglot_visit_ReachChecker$object *this, _jc_polyglot_visit_FlowGraph$object *param0)
{
	struct _jc_polyglot_visit_ReachChecker$object *r0;
	struct _jc_polyglot_visit_FlowGraph$object *r1;
	struct _jc_polyglot_visit_ReachChecker__24DataFlowItem$object *r2;

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(33);				// 0
	r2 = _JC_STATIC_FIELD(env, polyglot_visit_ReachChecker__24DataFlowItem, NOT__5fREACHABLE, 0);
	return r2;
}

//
// public java.util.Map flow(polyglot.visit.DataFlow$Item, polyglot.visit.FlowGraph, polyglot.ast.Term, java.util.Set)
//

static _jc_linenum _jc_polyglot_visit_ReachChecker$linenum_table$flow$98c03f38c33d1829[];

static const unsigned char _jc_polyglot_visit_ReachChecker$param_ptypes$flow$98c03f38c33d1829[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_visit_ReachChecker$param_types$flow$98c03f38c33d1829[] = {
	&_jc_polyglot_visit_DataFlow__24Item$type,
	&_jc_polyglot_visit_FlowGraph$type,
	&_jc_polyglot_ast_Term$type,
	&_jc_java_util_Set$type
};

_jc_method _jc_polyglot_visit_ReachChecker$method_info$flow$98c03f38c33d1829 = {
	.name=			"flow",
	.signature=		"(Lpolyglot/visit/DataFlow$Item;Lpolyglot/visit/FlowGraph;Lpolyglot/ast/Term;Ljava/util/Set;)Ljava/util/Map;",
	.class=			&_jc_polyglot_visit_ReachChecker$type,
	.param_types=		&_jc_polyglot_visit_ReachChecker$param_types$flow$98c03f38c33d1829,
	.return_type=		&_jc_java_util_Map$type,
	.param_ptypes=		&_jc_polyglot_visit_ReachChecker$param_ptypes$flow$98c03f38c33d1829,
	.signature_hash=	_JC_JLONG(0x98c03f38c33d1829),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_visit_ReachChecker$method$flow$98c03f38c33d1829,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_visit_ReachChecker$vtable, polyglot_visit_ReachChecker.flow$98c03f38c33d1829) / sizeof(void *),
	.num_parameters=	4,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_polyglot_visit_ReachChecker$linenum_table$flow$98c03f38c33d1829
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_visit_ReachChecker, flow$98c03f38c33d1829);

_jc_object * _JC_JCNI_ATTR
_jc_polyglot_visit_ReachChecker$method$flow$98c03f38c33d1829(_jc_env *const env, _jc_polyglot_visit_ReachChecker$object *this, _jc_polyglot_visit_DataFlow__24Item$object *param0, _jc_polyglot_visit_FlowGraph$object *param1, _jc_object *param2, _jc_object *param3)
{
	struct _jc_polyglot_visit_ReachChecker$object *r0;
	struct _jc_polyglot_visit_DataFlow__24Item$object *r1;
	struct _jc_java_lang_Object$object *r10;
	struct _jc_polyglot_visit_FlowGraph$object *r2;
	struct _jc_object *r3;
	struct _jc_object *r4;
	struct _jc_object *r5;
	struct _jc_polyglot_visit_ReachChecker__24DataFlowItem$object *r6;
	struct _jc_object *r7;
	struct _jc_java_util_HashMap$object *r8;
	struct _jc_object *r9;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	r3 = param2;
	r4 = param3;
	_JC_LINE_NUMBER(62);				// 0
	r5 = _JC_INVOKE_VIRTUAL(env, polyglot_visit_FlowGraph, entryNode$0dbb1648064148aa, r2);
	if (r3 != r5)
		goto label2;
	_JC_LINE_NUMBER(63);				// 1
	r6 = _JC_STATIC_FIELD(env, polyglot_visit_ReachChecker__24DataFlowItem, REACHABLE, 0);
	r8 = _JC_NEW(env, java_util_HashMap);
	_JC_INVOKE_NONVIRTUAL(env, java_util_HashMap, _init$7cb044ce4fb0ada8, 0, r8, 11, _JC_FCONST(0x3f, 0x40, 0x0, 0x0));
	r9 = _JC_INVOKE_INTERFACE(env, r4, _JC_JLONG(0x3cc91493d50f531c), _jc_object *, (_jc_env *, struct _jc_object *));

label0:
	z0 = _JC_INVOKE_INTERFACE(env, r9, _JC_JLONG(0xfb0bd5e38c59ddcd), jboolean, (_jc_env *, struct _jc_object *));
	if (z0 == 0)
		goto label1;
	r10 = _JC_INVOKE_INTERFACE(env, r9, _JC_JLONG(0x5874f79a1cf66ea), _jc_object *, (_jc_env *, struct _jc_object *));
	_JC_INVOKE_NONVIRTUAL(env, java_util_HashMap, put$3bd1c078a0faa8da, 0, r8, r10, r6);
	_JC_PERIODIC_CHECK(env);
	goto label0;

label1:
	return r8;

label2:
	_JC_LINE_NUMBER(66);				// 2
	r7 = _JC_INVOKE_STATIC(env, polyglot_visit_DataFlow, itemToMap$bdae0ee0dab12064, 1, r1, r4);
	return r7;
}

//
// public polyglot.ast.Node leaveCall(polyglot.ast.Node) throws polyglot.types.SemanticException
//

static _jc_linenum _jc_polyglot_visit_ReachChecker$linenum_table$leaveCall$8ca7dc9ca87da1af[];

static const unsigned char _jc_polyglot_visit_ReachChecker$param_ptypes$leaveCall$8ca7dc9ca87da1af[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_visit_ReachChecker$exceptions$leaveCall$8ca7dc9ca87da1af[] = {
	&_jc_polyglot_types_SemanticException$type
};

static _jc_type *const _jc_polyglot_visit_ReachChecker$param_types$leaveCall$8ca7dc9ca87da1af[] = {
	&_jc_polyglot_ast_Node$type
};

_jc_method _jc_polyglot_visit_ReachChecker$method_info$leaveCall$8ca7dc9ca87da1af = {
	.name=			"leaveCall",
	.signature=		"(Lpolyglot/ast/Node;)Lpolyglot/ast/Node;",
	.class=			&_jc_polyglot_visit_ReachChecker$type,
	.param_types=		&_jc_polyglot_visit_ReachChecker$param_types$leaveCall$8ca7dc9ca87da1af,
	.return_type=		&_jc_polyglot_ast_Node$type,
	.param_ptypes=		&_jc_polyglot_visit_ReachChecker$param_ptypes$leaveCall$8ca7dc9ca87da1af,
	.signature_hash=	_JC_JLONG(0x8ca7dc9ca87da1af),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_visit_ReachChecker$method$leaveCall$8ca7dc9ca87da1af,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_visit_ReachChecker$vtable, polyglot_visit_ReachChecker.leaveCall$8ca7dc9ca87da1af) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_visit_ReachChecker$exceptions$leaveCall$8ca7dc9ca87da1af,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_polyglot_visit_ReachChecker$linenum_table$leaveCall$8ca7dc9ca87da1af
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_visit_ReachChecker, leaveCall$8ca7dc9ca87da1af);

_jc_object * _JC_JCNI_ATTR
_jc_polyglot_visit_ReachChecker$method$leaveCall$8ca7dc9ca87da1af(_jc_env *const env, _jc_polyglot_visit_ReachChecker$object *this, _jc_object *param0)
{
	struct _jc_polyglot_visit_ReachChecker$object *r0;
	struct _jc_object *r1;
	struct _jc_object *r2;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(82);				// 0
	z0 = _JC_INSTANCEOF(env, r1, &_jc_polyglot_ast_Term$type);
	if (z0 == 0)
		goto label0;
	_JC_LINE_NUMBER(83);				// 1
	r2 = r1;
	r1 = _JC_INVOKE_VIRTUAL(env, polyglot_visit_ReachChecker, checkReachability$4d8a628641057bcc, r0, r2);

label0:
	_JC_LINE_NUMBER(86);				// 2
	r1 = _JC_INVOKE_NONVIRTUAL(env, polyglot_visit_DataFlow, leaveCall$8ca7dc9ca87da1af, 0, r0, r1);
	return r1;
}

//
// public void post(polyglot.visit.FlowGraph, polyglot.ast.Term) throws polyglot.types.SemanticException
//

static _jc_linenum _jc_polyglot_visit_ReachChecker$linenum_table$post$e4ac86e2f77f4d49[];

static const unsigned char _jc_polyglot_visit_ReachChecker$param_ptypes$post$e4ac86e2f77f4d49[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_visit_ReachChecker$exceptions$post$e4ac86e2f77f4d49[] = {
	&_jc_polyglot_types_SemanticException$type
};

static _jc_type *const _jc_polyglot_visit_ReachChecker$param_types$post$e4ac86e2f77f4d49[] = {
	&_jc_polyglot_visit_FlowGraph$type,
	&_jc_polyglot_ast_Term$type
};

_jc_method _jc_polyglot_visit_ReachChecker$method_info$post$e4ac86e2f77f4d49 = {
	.name=			"post",
	.signature=		"(Lpolyglot/visit/FlowGraph;Lpolyglot/ast/Term;)V",
	.class=			&_jc_polyglot_visit_ReachChecker$type,
	.param_types=		&_jc_polyglot_visit_ReachChecker$param_types$post$e4ac86e2f77f4d49,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_visit_ReachChecker$param_ptypes$post$e4ac86e2f77f4d49,
	.signature_hash=	_JC_JLONG(0xe4ac86e2f77f4d49),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_visit_ReachChecker$method$post$e4ac86e2f77f4d49,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_visit_ReachChecker$vtable, polyglot_visit_ReachChecker.post$e4ac86e2f77f4d49) / sizeof(void *),
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_visit_ReachChecker$exceptions$post$e4ac86e2f77f4d49,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_polyglot_visit_ReachChecker$linenum_table$post$e4ac86e2f77f4d49
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_visit_ReachChecker, post$e4ac86e2f77f4d49);

void _JC_JCNI_ATTR
_jc_polyglot_visit_ReachChecker$method$post$e4ac86e2f77f4d49(_jc_env *const env, _jc_polyglot_visit_ReachChecker$object *this, _jc_polyglot_visit_FlowGraph$object *param0, _jc_object *param1)
{
	struct _jc_polyglot_visit_ReachChecker$object *r0;
	struct _jc_polyglot_visit_FlowGraph$object *r1;
	struct _jc_object *r2;
	struct _jc_java_lang_String$object *r3;
	struct _jc_java_util_Collections__24SingletonList$object *r4;
	jboolean z0;
	jboolean z1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_LINE_NUMBER(139);				// 0
	r3 = _JC_STATIC_FIELD(env, polyglot_main_Report, cfg, 0);
	z1 = _JC_STATIC_FIELD(env, polyglot_main_Report, noReporting, 1);
	if (z1 == 0)
		goto label0;
	z0 = 0;
	goto label1;

label0:
	_JC_ACTIVE_USE(env, java_util_Collections);
	r4 = _JC_NEW(env, java_util_Collections__24SingletonList);
	_JC_REF_FIELD(env, r4, java_util_Collections__24SingletonList, element) = r3;
	z1 = _JC_INVOKE_STATIC(env, polyglot_main_Report, should__5freport$316269f2ec4db001, 1, r4, 2);
	z0 = z1;

label1:
	if (z0 == 0)
		goto label2;
	_JC_LINE_NUMBER(140);				// 1
	_JC_INVOKE_VIRTUAL(env, polyglot_visit_DataFlow, dumpFlowGraph$fddde570f3074b4d, r0, r1, r2);

label2:
	_JC_LINE_NUMBER(142);				// 2
	return;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_polyglot_visit_ReachChecker$methods[] = {
	&_jc_polyglot_visit_ReachChecker$method_info$_init$dac7f764f0e12933,
	&_jc_polyglot_visit_ReachChecker$method_info$check$3df37c60acd34b0e,
	&_jc_polyglot_visit_ReachChecker$method_info$checkReachability$4d8a628641057bcc,
	&_jc_polyglot_visit_ReachChecker$method_info$confluence$8f9f293f0bd8b7b5,
	&_jc_polyglot_visit_ReachChecker$method_info$createInitialItem$1a8de5b116761d1a,
	&_jc_polyglot_visit_ReachChecker$method_info$flow$98c03f38c33d1829,
	&_jc_polyglot_visit_ReachChecker$method_info$leaveCall$8ca7dc9ca87da1af,
	&_jc_polyglot_visit_ReachChecker$method_info$post$e4ac86e2f77f4d49
};

/************************************************************************
 *			   Interface hash table				*
 ************************************************************************/

#if _JC_IMETHOD_HASHSIZE != 128
#error "_JC_IMETHOD_HASHSIZE has the wrong value (should be 128)"
#endif

// Interface lookup hash table buckets
static _jc_method *_jc_polyglot_visit_ReachChecker$imethod_hash_bucket_73[] = {
	&_jc_polyglot_visit_HaltingVisitor$method_info$copy$2119f530248e04c9,
	_JC_NULL
};

// Interface lookup hash table
static _jc_method **_jc_polyglot_visit_ReachChecker$imethod_hash_table[_JC_IMETHOD_HASHSIZE] = {
	[73]=	_jc_polyglot_visit_ReachChecker$imethod_hash_bucket_73
};

// Interface "quick" lookup hash table
static const void *_jc_polyglot_visit_ReachChecker$imethod_quick_table[_JC_IMETHOD_HASHSIZE] = {
	[73]=	&_jc_polyglot_visit_HaltingVisitor$method$copy$2119f530248e04c9
};

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_polyglot_visit_ReachChecker$instanceof_hash_bucket_2[] = {
	&_jc_polyglot_util_Copy$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_visit_ReachChecker$instanceof_hash_bucket_19[] = {
	&_jc_java_lang_Cloneable$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_visit_ReachChecker$instanceof_hash_bucket_26[] = {
	&_jc_polyglot_visit_ErrorHandlingVisitor$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_visit_ReachChecker$instanceof_hash_bucket_34[] = {
	&_jc_polyglot_visit_HaltingVisitor$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_visit_ReachChecker$instanceof_hash_bucket_49[] = {
	&_jc_polyglot_visit_ReachChecker$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_visit_ReachChecker$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_visit_ReachChecker$instanceof_hash_bucket_112[] = {
	&_jc_polyglot_visit_NodeVisitor$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_visit_ReachChecker$instanceof_hash_bucket_127[] = {
	&_jc_polyglot_visit_DataFlow$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_polyglot_visit_ReachChecker$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[2]=	_jc_polyglot_visit_ReachChecker$instanceof_hash_bucket_2,
	[19]=	_jc_polyglot_visit_ReachChecker$instanceof_hash_bucket_19,
	[26]=	_jc_polyglot_visit_ReachChecker$instanceof_hash_bucket_26,
	[34]=	_jc_polyglot_visit_ReachChecker$instanceof_hash_bucket_34,
	[49]=	_jc_polyglot_visit_ReachChecker$instanceof_hash_bucket_49,
	[101]=	_jc_polyglot_visit_ReachChecker$instanceof_hash_bucket_101,
	[112]=	_jc_polyglot_visit_ReachChecker$instanceof_hash_bucket_112,
	[127]=	_jc_polyglot_visit_ReachChecker$instanceof_hash_bucket_127
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_polyglot_visit_ReachChecker$class_depends[] = {
	{ "java/io/PrintStream",	_JC_JLONG(0x99a46305ebacacb5) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/Cloneable",	_JC_JLONG(0x9b667b09132be893) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/RuntimeException",	_JC_JLONG(0x4f5534a987354d1d) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/System",	_JC_JLONG(0x53cc8e2333795f04) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/util/AbstractCollection",	_JC_JLONG(0x8ea716c64b77f8eb) },
	{ "java/util/AbstractList",	_JC_JLONG(0xf5238436362828db) },
	{ "java/util/AbstractSequentialList",	_JC_JLONG(0x6d7997e879c41059) },
	{ "java/util/Collection",	_JC_JLONG(0xeae4d0c0e8eb63da) },
	{ "java/util/Collections",	_JC_JLONG(0x9574af3fed58029a) },
	{ "java/util/Collections$SingletonList",	_JC_JLONG(0x2ccd076083da6c8e) },
	{ "java/util/HashMap",	_JC_JLONG(0xd7cd853200c3e71f) },
	{ "java/util/Iterator",	_JC_JLONG(0xbe56ff673eefd9d2) },
	{ "java/util/LinkedList",	_JC_JLONG(0x666417b6279ae396) },
	{ "java/util/List",	_JC_JLONG(0x9ee0d92ce1525a4d) },
	{ "java/util/Map",	_JC_JLONG(0xe283f7c2e7a7979c) },
	{ "java/util/Set",	_JC_JLONG(0x617ac82c0bec2dff) },
	{ "polyglot/ast/Block",	_JC_JLONG(0x5eda5b679dfeb2f7) },
	{ "polyglot/ast/CompoundStmt",	_JC_JLONG(0x958fcc544dfda930) },
	{ "polyglot/ast/Node",	_JC_JLONG(0x1c402b4f9747e08) },
	{ "polyglot/ast/NodeFactory",	_JC_JLONG(0x56625b3befab19f) },
	{ "polyglot/ast/Stmt",	_JC_JLONG(0xde1430f3b100a09a) },
	{ "polyglot/ast/Term",	_JC_JLONG(0xd96ecce1886ee664) },
	{ "polyglot/frontend/Job",	_JC_JLONG(0x42e687805b457724) },
	{ "polyglot/main/Report",	_JC_JLONG(0xcf9f146bdb7bc44d) },
	{ "polyglot/types/SemanticException",	_JC_JLONG(0x45f755f5298b5b39) },
	{ "polyglot/types/TypeSystem",	_JC_JLONG(0xed171cdaca38ec28) },
	{ "polyglot/util/Copy",	_JC_JLONG(0xc1adfaf4637dbc02) },
	{ "polyglot/util/InternalCompilerError",	_JC_JLONG(0x22b321d488641c54) },
	{ "polyglot/util/Position",	_JC_JLONG(0x32c9a088c5dac046) },
	{ "polyglot/visit/DataFlow",	_JC_JLONG(0xc4ffacca45f5127f) },
	{ "polyglot/visit/DataFlow$Item",	_JC_JLONG(0x146082755586f7f1) },
	{ "polyglot/visit/ErrorHandlingVisitor",	_JC_JLONG(0x8a4bd51bcd9d71a) },
	{ "polyglot/visit/FlowGraph",	_JC_JLONG(0xb6315ac3e2e0e62) },
	{ "polyglot/visit/FlowGraph$Peer",	_JC_JLONG(0xd12d97b39a3d4675) },
	{ "polyglot/visit/HaltingVisitor",	_JC_JLONG(0x2f5b20d380322b22) },
	{ "polyglot/visit/NodeVisitor",	_JC_JLONG(0x534db787197439f0) },
	{ "polyglot/visit/ReachChecker$DataFlowItem",	_JC_JLONG(0x4890c8ee70ad94da) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Inner class list
static _jc_inner_class _jc_polyglot_visit_ReachChecker$inner_classes[] = {
	{ &_jc_polyglot_visit_ReachChecker__24DataFlowItem$type, _JC_ACC_PROTECTED|_JC_ACC_STATIC },
};

// Class info
_jc_polyglot_visit_ReachChecker$vtype _jc_polyglot_visit_ReachChecker$type = {
    .type= {
	.name=			"polyglot/visit/ReachChecker",
	.superclass=		&_jc_polyglot_visit_DataFlow$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_polyglot_visit_ReachChecker$imethod_hash_table,
	.imethod_quick_table=	_jc_polyglot_visit_ReachChecker$imethod_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		60,
		.hash=			_JC_JLONG(0x45301305bdc4ecb1),
		.source_file=		"ReachChecker.java",
		.instance_size=		sizeof(_jc_polyglot_visit_ReachChecker$refs) + sizeof(_jc_polyglot_visit_ReachChecker$object),
		.num_virtual_refs=	6,
		.num_methods=		sizeof(_jc_polyglot_visit_ReachChecker$methods) / sizeof(*_jc_polyglot_visit_ReachChecker$methods),
		.methods=		_jc_polyglot_visit_ReachChecker$methods,
		.instanceof_hash_table=	_jc_polyglot_visit_ReachChecker$instanceof_hash_table,
		.num_inner_classes=	1,
		.inner_classes=		_jc_polyglot_visit_ReachChecker$inner_classes,
		.num_class_depends=		sizeof(_jc_polyglot_visit_ReachChecker$class_depends) / sizeof(*_jc_polyglot_visit_ReachChecker$class_depends),
		.class_depends=		_jc_polyglot_visit_ReachChecker$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=			// overridden
		&_jc_polyglot_visit_NodeVisitor$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.polyglot_visit_NodeVisitor= {
	    .begin$914d55e002815404=			// overridden
		&_jc_polyglot_visit_ErrorHandlingVisitor$method$begin$914d55e002815404,
	    .enter$a8ce2b9db363b202=
		&_jc_polyglot_visit_NodeVisitor$method$enter$a8ce2b9db363b202,
	    .enter$0698e71b16532e07=			// overridden
		&_jc_polyglot_visit_ErrorHandlingVisitor$method$enter$0698e71b16532e07,
	    .finish$8d1c944274527186=
		&_jc_polyglot_visit_NodeVisitor$method$finish$8d1c944274527186,
	    .finish$ed6d1946240badd4=
		&_jc_polyglot_visit_NodeVisitor$method$finish$ed6d1946240badd4,
	    .leave$d95680aeadf04833=			// overridden
		&_jc_polyglot_visit_DataFlow$method$leave$d95680aeadf04833,
	    .leave$cf18a0cab654af63=
		&_jc_polyglot_visit_NodeVisitor$method$leave$cf18a0cab654af63,
	    .override$1e05b257002785f7=
		&_jc_polyglot_visit_NodeVisitor$method$override$1e05b257002785f7,
	    .override$b414405487168b9b=			// overridden
		&_jc_polyglot_visit_HaltingVisitor$method$override$b414405487168b9b,
	    .toString$7ea43b33b80a3070=
		&_jc_polyglot_visit_NodeVisitor$method$toString$7ea43b33b80a3070,
	    .visitEdge$35f9fc3d698a8550=
		&_jc_polyglot_visit_NodeVisitor$method$visitEdge$35f9fc3d698a8550,
	},
	.polyglot_visit_HaltingVisitor= {
	    .bypass$2362fe5b09e06e51=
		&_jc_polyglot_visit_HaltingVisitor$method$bypass$2362fe5b09e06e51,
	    .bypass$a2413c94f53e8bbe=
		&_jc_polyglot_visit_HaltingVisitor$method$bypass$a2413c94f53e8bbe,
	    .bypassChildren$297f04895f89c850=
		&_jc_polyglot_visit_HaltingVisitor$method$bypassChildren$297f04895f89c850,
	    .copy$2119f530248e04c9=
		&_jc_polyglot_visit_HaltingVisitor$method$copy$2119f530248e04c9,
	    .override$b414405487168b9b=
		&_jc_polyglot_visit_HaltingVisitor$method$override$b414405487168b9b,
	    .visitChildren$8328a2f7ca5ebf6b=
		&_jc_polyglot_visit_HaltingVisitor$method$visitChildren$8328a2f7ca5ebf6b,
	},
	.polyglot_visit_ErrorHandlingVisitor= {
	    .begin$914d55e002815404=
		&_jc_polyglot_visit_ErrorHandlingVisitor$method$begin$914d55e002815404,
	    .catchErrors$22b0599764088ed3=
		&_jc_polyglot_visit_ErrorHandlingVisitor$method$catchErrors$22b0599764088ed3,
	    .enter$0698e71b16532e07=
		&_jc_polyglot_visit_ErrorHandlingVisitor$method$enter$0698e71b16532e07,
	    .enterCall$91bb061343e6f272=			// overridden
		&_jc_polyglot_visit_DataFlow$method$enterCall$91bb061343e6f272,
	    .enterCall$3637fb21939178bc=
		&_jc_polyglot_visit_ErrorHandlingVisitor$method$enterCall$3637fb21939178bc,
	    .errorQueue$6d038e7585ab4339=
		&_jc_polyglot_visit_ErrorHandlingVisitor$method$errorQueue$6d038e7585ab4339,
	    .job$60bb99fb0e87eae0=
		&_jc_polyglot_visit_ErrorHandlingVisitor$method$job$60bb99fb0e87eae0,
	    .leave$d95680aeadf04833=			// overridden
		&_jc_polyglot_visit_DataFlow$method$leave$d95680aeadf04833,
	    .leaveCall$8ca7dc9ca87da1af=			// overridden
		&_jc_polyglot_visit_ReachChecker$method$leaveCall$8ca7dc9ca87da1af,
	    .leaveCall$9236e830bcef4b36=
		&_jc_polyglot_visit_ErrorHandlingVisitor$method$leaveCall$9236e830bcef4b36,
	    .nodeFactory$32826050387dc827=
		&_jc_polyglot_visit_ErrorHandlingVisitor$method$nodeFactory$32826050387dc827,
	    .typeSystem$c9dab312e784024e=
		&_jc_polyglot_visit_ErrorHandlingVisitor$method$typeSystem$c9dab312e784024e,
	},
	.polyglot_visit_DataFlow= {
	    .check$3df37c60acd34b0e=			// overridden
		&_jc_polyglot_visit_ReachChecker$method$check$3df37c60acd34b0e,
	    .confluence$8f9f293f0bd8b7b5=			// overridden
		&_jc_polyglot_visit_ReachChecker$method$confluence$8f9f293f0bd8b7b5,
	    .createInitialItem$1a8de5b116761d1a=		// overridden
		&_jc_polyglot_visit_ReachChecker$method$createInitialItem$1a8de5b116761d1a,
	    .currentFlowGraph$d6cf31facdb0f823=
		&_jc_polyglot_visit_DataFlow$method$currentFlowGraph$d6cf31facdb0f823,
	    .dataflow$53fe777b8aad39b8=
		&_jc_polyglot_visit_DataFlow$method$dataflow$53fe777b8aad39b8,
	    .dataflow$b551a27571898a96=
		&_jc_polyglot_visit_DataFlow$method$dataflow$b551a27571898a96,
	    .dumpFlowGraph$fddde570f3074b4d=
		&_jc_polyglot_visit_DataFlow$method$dumpFlowGraph$fddde570f3074b4d,
	    .enterCall$91bb061343e6f272=
		&_jc_polyglot_visit_DataFlow$method$enterCall$91bb061343e6f272,
	    .flow$98c03f38c33d1829=				// overridden
		&_jc_polyglot_visit_ReachChecker$method$flow$98c03f38c33d1829,
	    .initGraph$1cd351c97638609f=
		&_jc_polyglot_visit_DataFlow$method$initGraph$1cd351c97638609f,
	    .leave$d95680aeadf04833=
		&_jc_polyglot_visit_DataFlow$method$leave$d95680aeadf04833,
	    .leaveCall$8ca7dc9ca87da1af=			// overridden
		&_jc_polyglot_visit_ReachChecker$method$leaveCall$8ca7dc9ca87da1af,
	    .post$e4ac86e2f77f4d49=				// overridden
		&_jc_polyglot_visit_ReachChecker$method$post$e4ac86e2f77f4d49,
	},
	.polyglot_visit_ReachChecker= {
	    .check$3df37c60acd34b0e=
		&_jc_polyglot_visit_ReachChecker$method$check$3df37c60acd34b0e,
	    .checkReachability$4d8a628641057bcc=
		&_jc_polyglot_visit_ReachChecker$method$checkReachability$4d8a628641057bcc,
	    .confluence$8f9f293f0bd8b7b5=
		&_jc_polyglot_visit_ReachChecker$method$confluence$8f9f293f0bd8b7b5,
	    .createInitialItem$1a8de5b116761d1a=
		&_jc_polyglot_visit_ReachChecker$method$createInitialItem$1a8de5b116761d1a,
	    .flow$98c03f38c33d1829=
		&_jc_polyglot_visit_ReachChecker$method$flow$98c03f38c33d1829,
	    .leaveCall$8ca7dc9ca87da1af=
		&_jc_polyglot_visit_ReachChecker$method$leaveCall$8ca7dc9ca87da1af,
	    .post$e4ac86e2f77f4d49=
		&_jc_polyglot_visit_ReachChecker$method$post$e4ac86e2f77f4d49,
	},
    }
};

