// public class soot.baf.toolkits.base.PeepholeOptimizer

// class file dependencies
// @dep_class 1160ded3f016b6b0 gnu_classpath_SystemProperties
// @dep_class 2f32f9b77402a730 java_io_BufferedReader
// @dep_class 4e0a56550c69d57c java_io_IOException
// @dep_class 66aea4d152614ac4 java_io_InputStream
// @dep_class 30159d8092563292 java_io_InputStreamReader
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class b0527a7101321261 java_lang_ClassLoader
// @dep_class be9e852b03cddd0 java_lang_ClassLoader__24StaticData
// @dep_class 1f925cf50bfc0d6c java_lang_ClassNotFoundException
// @dep_class 308333d803f5ab9f java_lang_Error
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class 29deac5351715967 java_lang_IllegalAccessException
// @dep_class 680cf34d05feb5a1 java_lang_IllegalArgumentException
// @dep_class 3cdfed1e0ad1a3d6 java_lang_IndexOutOfBoundsException
// @dep_class b09d021696f0bbb java_lang_InstantiationException
// @dep_class ca631501391a31f1 java_lang_Integer
// @dep_class 3746e17e005bda9e java_lang_LinkageError
// @dep_class 2082ebb592ac2255 java_lang_NoClassDefFoundError
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class 4f5534a987354d1d java_lang_RuntimeException
// @dep_class d38282f3d5f80887 java_lang_SecurityManager
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 94d357637b968dda java_lang_StringBuffer
// @dep_class bb7f6fdd2bd0e6b2 java_lang_StringIndexOutOfBoundsException
// @dep_class 53cc8e2333795f04 java_lang_System
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class 69345d46f4f40e9c java_net_URL
// @dep_class 1042c111741aa488 java_net_URLConnection
// @dep_class d7e769aebe17520e java_net_URLStreamHandler
// @dep_class 8ea716c64b77f8eb java_util_AbstractCollection
// @dep_class f5238436362828db java_util_AbstractList
// @dep_class 6d7997e879c41059 java_util_AbstractSequentialList
// @dep_class 52f944b5de1e20c4 java_util_ConcurrentModificationException
// @dep_class d7cd853200c3e71f java_util_HashMap
// @dep_class 666417b6279ae396 java_util_LinkedList
// @dep_class 2522cc4453ab9d02 java_util_LinkedList__24Entry
// @dep_class 2fe8fa9fb9ea6f9b java_util_LinkedList__24LinkedListItr
// @dep_class e283f7c2e7a7979c java_util_Map
// @dep_class 884c3edb343dfb63 java_util_Properties
// @dep_class 6131d54b9700ca5d soot_Body
// @dep_class a76a7734eb62f430 soot_BodyTransformer
// @dep_class b6d33af8f84fdbc4 soot_G
// @dep_class 6ac5bee50bbabb71 soot_Singletons
// @dep_class 47e789a7286ce13e soot_Singletons__24Global
// @dep_class de5fa3182955e270 soot_Transformer
// @dep_class 6759975ef41a30c9 soot_baf_toolkits_base_Peephole
// @dep_class d118f385c7b8f5ae soot_baf_toolkits_base_PeepholeOptimizer

// header file dependencies
// @dep_header gnu_classpath_SystemProperties
// @dep_header java_io_BufferedReader
// @dep_header java_io_IOException
// @dep_header java_io_InputStream
// @dep_header java_io_InputStreamReader
// @dep_header java_lang_Class
// @dep_header java_lang_ClassLoader
// @dep_header java_lang_ClassLoader__24StaticData
// @dep_header java_lang_ClassNotFoundException
// @dep_header java_lang_IllegalAccessException
// @dep_header java_lang_IllegalArgumentException
// @dep_header java_lang_InstantiationException
// @dep_header java_lang_Integer
// @dep_header java_lang_NoClassDefFoundError
// @dep_header java_lang_SecurityManager
// @dep_header java_lang_String
// @dep_header java_lang_StringBuffer
// @dep_header java_lang_StringIndexOutOfBoundsException
// @dep_header java_lang_System
// @dep_header java_lang_VMThrowable
// @dep_header java_net_URL
// @dep_header java_net_URLConnection
// @dep_header java_net_URLStreamHandler
// @dep_header java_util_ConcurrentModificationException
// @dep_header java_util_HashMap
// @dep_header java_util_LinkedList
// @dep_header java_util_LinkedList__24Entry
// @dep_header java_util_LinkedList__24LinkedListItr
// @dep_header java_util_Map
// @dep_header java_util_Properties
// @dep_header soot_Body
// @dep_header soot_G
// @dep_header soot_Singletons__24Global
// @dep_header soot_baf_toolkits_base_Peephole
// @dep_header soot_baf_toolkits_base_PeepholeOptimizer

#include "jc_defs.h"

#include "gnu/classpath/SystemProperties.h"
#include "java/io/BufferedReader.h"
#include "java/io/IOException.h"
#include "java/io/InputStream.h"
#include "java/io/InputStreamReader.h"
#include "java/lang/Class.h"
#include "java/lang/ClassLoader.h"
#include "java/lang/ClassLoader__24StaticData.h"
#include "java/lang/ClassNotFoundException.h"
#include "java/lang/IllegalAccessException.h"
#include "java/lang/IllegalArgumentException.h"
#include "java/lang/InstantiationException.h"
#include "java/lang/Integer.h"
#include "java/lang/NoClassDefFoundError.h"
#include "java/lang/SecurityManager.h"
#include "java/lang/String.h"
#include "java/lang/StringBuffer.h"
#include "java/lang/StringIndexOutOfBoundsException.h"
#include "java/lang/System.h"
#include "java/lang/VMThrowable.h"
#include "java/net/URL.h"
#include "java/net/URLConnection.h"
#include "java/net/URLStreamHandler.h"
#include "java/util/ConcurrentModificationException.h"
#include "java/util/HashMap.h"
#include "java/util/LinkedList.h"
#include "java/util/LinkedList__24Entry.h"
#include "java/util/LinkedList__24LinkedListItr.h"
#include "java/util/Map.h"
#include "java/util/Properties.h"
#include "soot/Body.h"
#include "soot/G.h"
#include "soot/Singletons__24Global.h"
#include "soot/baf/toolkits/base/Peephole.h"
#include "soot/baf/toolkits/base/PeepholeOptimizer.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// private java.io.InputStream peepholeListingStream
static _jc_field _jc_soot_baf_toolkits_base_PeepholeOptimizer$field_info$peepholeListingStream = {
	.name=		"peepholeListingStream",
	.signature=	"Ljava/io/InputStream;",
	.class=		&_jc_soot_baf_toolkits_base_PeepholeOptimizer$type,
	.type=		&_jc_java_io_InputStream$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_soot_baf_toolkits_base_PeepholeOptimizer$object, refs[-1].soot_baf_toolkits_base_PeepholeOptimizer.peepholeListingStream),
};

// private final java.lang.String packageName
static _jc_field _jc_soot_baf_toolkits_base_PeepholeOptimizer$field_info$packageName = {
	.name=		"packageName",
	.signature=	"Ljava/lang/String;",
	.class=		&_jc_soot_baf_toolkits_base_PeepholeOptimizer$type,
	.type=		&_jc_java_lang_String$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_soot_baf_toolkits_base_PeepholeOptimizer$object, refs[-1].soot_baf_toolkits_base_PeepholeOptimizer.packageName),
};

// private java.util.Map peepholeMap
static _jc_field _jc_soot_baf_toolkits_base_PeepholeOptimizer$field_info$peepholeMap = {
	.name=		"peepholeMap",
	.signature=	"Ljava/util/Map;",
	.class=		&_jc_soot_baf_toolkits_base_PeepholeOptimizer$type,
	.type=		&_jc_java_util_Map$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_soot_baf_toolkits_base_PeepholeOptimizer$object, refs[-1].soot_baf_toolkits_base_PeepholeOptimizer.peepholeMap),
};

// static java.lang.Class class$soot$baf$toolkits$base$PeepholeOptimizer
static _jc_field _jc_soot_baf_toolkits_base_PeepholeOptimizer$field_info$class__24soot__24baf__24toolkits__24base__24PeepholeOptimizer = {
	.name=		"class$soot$baf$toolkits$base$PeepholeOptimizer",
	.signature=	"Ljava/lang/Class;",
	.class=		&_jc_soot_baf_toolkits_base_PeepholeOptimizer$type,
	.type=		&_jc_java_lang_Class$type,
	.access_flags=	_JC_ACC_STATIC,
	.offset=	_JC_OFFSETOF(_jc_soot_baf_toolkits_base_PeepholeOptimizer$fields_struct, class__24soot__24baf__24toolkits__24base__24PeepholeOptimizer),
};

// Fields
static _jc_field *const _jc_soot_baf_toolkits_base_PeepholeOptimizer$fields[] = {
	&_jc_soot_baf_toolkits_base_PeepholeOptimizer$field_info$class__24soot__24baf__24toolkits__24base__24PeepholeOptimizer,
	&_jc_soot_baf_toolkits_base_PeepholeOptimizer$field_info$packageName,
	&_jc_soot_baf_toolkits_base_PeepholeOptimizer$field_info$peepholeListingStream,
	&_jc_soot_baf_toolkits_base_PeepholeOptimizer$field_info$peepholeMap
};

/************************************************************************
 *			      Static methods				*
 ************************************************************************/

//
// static java.lang.Class class$(java.lang.String)
//

static _jc_linenum _jc_soot_baf_toolkits_base_PeepholeOptimizer$linenum_table$class__24$57cd45dca0be1678[];

static _jc_trap_info _jc_soot_baf_toolkits_base_PeepholeOptimizer$trap_table$class__24$57cd45dca0be1678[] = {
	_JC_TRAP(&_jc_java_lang_ClassNotFoundException$type, 1, 2),
};

static const unsigned char _jc_soot_baf_toolkits_base_PeepholeOptimizer$param_ptypes$class__24$57cd45dca0be1678[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_soot_baf_toolkits_base_PeepholeOptimizer$param_types$class__24$57cd45dca0be1678[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_soot_baf_toolkits_base_PeepholeOptimizer$method_info$class__24$57cd45dca0be1678 = {
	.name=			"class$",
	.signature=		"(Ljava/lang/String;)Ljava/lang/Class;",
	.class=			&_jc_soot_baf_toolkits_base_PeepholeOptimizer$type,
	.param_types=		&_jc_soot_baf_toolkits_base_PeepholeOptimizer$param_types$class__24$57cd45dca0be1678,
	.return_type=		&_jc_java_lang_Class$type,
	.param_ptypes=		&_jc_soot_baf_toolkits_base_PeepholeOptimizer$param_ptypes$class__24$57cd45dca0be1678,
	.signature_hash=	_JC_JLONG(0x57cd45dca0be1678),
	.access_flags=		_JC_ACC_STATIC,
	.function=		&_jc_soot_baf_toolkits_base_PeepholeOptimizer$method$class__24$57cd45dca0be1678,
	.num_parameters=	1,
	.u= { .exec= {
	  .trap_table_len=	1,
	  .trap_table=		_jc_soot_baf_toolkits_base_PeepholeOptimizer$trap_table$class__24$57cd45dca0be1678,
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_soot_baf_toolkits_base_PeepholeOptimizer$linenum_table$class__24$57cd45dca0be1678
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_baf_toolkits_base_PeepholeOptimizer, class__24$57cd45dca0be1678);

_jc_java_lang_Class$object * _JC_JCNI_ATTR
_jc_soot_baf_toolkits_base_PeepholeOptimizer$method$class__24$57cd45dca0be1678(_jc_env *const env, _jc_java_lang_String$object *param0)
{
	struct _jc_java_lang_String$object *volatile r0;
	struct _jc_java_lang_ClassNotFoundException$object *volatile r1;
	struct _jc_java_lang_Class$object *r2;
	struct _jc_java_lang_NoClassDefFoundError$object *volatile r3;
	struct _jc_java_lang_VMThrowable$object *volatile r5;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_soot_baf_toolkits_base_PeepholeOptimizer$method_info$class__24$57cd45dca0be1678, &&label0);

	r0 = param0;
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(67);				// 0
	r2 = _JC_INVOKE_STATIC(env, java_lang_Class, forName$d3b57db3b6a905a3, 1, r0);
	_JC_TRAP_REGION(catch, 2);
	_JC_CANCEL_TRAPS(env, catch);
	return r2;

label0:
	_JC_TRAP_REGION(catch, 2);
	r1 = _JC_CAUGHT_EXCEPTION(env);
	r3 = _JC_NEW(env, java_lang_NoClassDefFoundError);
	r0 = _JC_INVOKE_VIRTUAL(env, java_lang_Throwable, getMessage$13aaf240efc902b1, r1);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r5 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r5;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r0;
	_JC_THROW(env, r3);
}

//
// public static soot.baf.toolkits.base.PeepholeOptimizer v()
//

static _jc_linenum _jc_soot_baf_toolkits_base_PeepholeOptimizer$linenum_table$v$6f7c30e5dacfebdd[];

static const unsigned char _jc_soot_baf_toolkits_base_PeepholeOptimizer$param_ptypes$v$6f7c30e5dacfebdd[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_soot_baf_toolkits_base_PeepholeOptimizer$method_info$v$6f7c30e5dacfebdd = {
	.name=			"v",
	.signature=		"()Lsoot/baf/toolkits/base/PeepholeOptimizer;",
	.class=			&_jc_soot_baf_toolkits_base_PeepholeOptimizer$type,
	.return_type=		&_jc_soot_baf_toolkits_base_PeepholeOptimizer$type,
	.param_ptypes=		&_jc_soot_baf_toolkits_base_PeepholeOptimizer$param_ptypes$v$6f7c30e5dacfebdd,
	.signature_hash=	_JC_JLONG(0x6f7c30e5dacfebdd),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_soot_baf_toolkits_base_PeepholeOptimizer$method$v$6f7c30e5dacfebdd,
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_soot_baf_toolkits_base_PeepholeOptimizer$linenum_table$v$6f7c30e5dacfebdd
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_baf_toolkits_base_PeepholeOptimizer, v$6f7c30e5dacfebdd);

_jc_soot_baf_toolkits_base_PeepholeOptimizer$object * _JC_JCNI_ATTR
_jc_soot_baf_toolkits_base_PeepholeOptimizer$method$v$6f7c30e5dacfebdd(_jc_env *const env)
{
	struct _jc_soot_baf_toolkits_base_PeepholeOptimizer$object *r1;
	struct _jc_soot_G$object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	_JC_ACTIVE_USE(env, soot_G);
	_JC_LINE_NUMBER(52);				// 0
	r2 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r1 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, PeepholeOptimizer$bcaa1d046d65a7e7, r2);
	return r1;
}

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// public void <init>(soot.Singletons$Global)
//

static _jc_linenum _jc_soot_baf_toolkits_base_PeepholeOptimizer$linenum_table$_init$bbe94f634b20986f[];

static const unsigned char _jc_soot_baf_toolkits_base_PeepholeOptimizer$param_ptypes$_init$bbe94f634b20986f[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_soot_baf_toolkits_base_PeepholeOptimizer$param_types$_init$bbe94f634b20986f[] = {
	&_jc_soot_Singletons__24Global$type
};

_jc_method _jc_soot_baf_toolkits_base_PeepholeOptimizer$method_info$_init$bbe94f634b20986f = {
	.name=			"<init>",
	.signature=		"(Lsoot/Singletons$Global;)V",
	.class=			&_jc_soot_baf_toolkits_base_PeepholeOptimizer$type,
	.param_types=		&_jc_soot_baf_toolkits_base_PeepholeOptimizer$param_types$_init$bbe94f634b20986f,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_soot_baf_toolkits_base_PeepholeOptimizer$param_ptypes$_init$bbe94f634b20986f,
	.signature_hash=	_JC_JLONG(0xbbe94f634b20986f),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_baf_toolkits_base_PeepholeOptimizer$method$_init$bbe94f634b20986f,
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_soot_baf_toolkits_base_PeepholeOptimizer$linenum_table$_init$bbe94f634b20986f
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_baf_toolkits_base_PeepholeOptimizer, _init$bbe94f634b20986f);

void _JC_JCNI_ATTR
_jc_soot_baf_toolkits_base_PeepholeOptimizer$method$_init$bbe94f634b20986f(_jc_env *const env, _jc_soot_baf_toolkits_base_PeepholeOptimizer$object *this, _jc_soot_Singletons__24Global$object *param0)
{
	struct _jc_soot_baf_toolkits_base_PeepholeOptimizer$object *r0;
	struct _jc_soot_Singletons__24Global$object *r1;
	struct _jc_java_util_HashMap$object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(54);				// 0
	_JC_REF_FIELD(env, r0, soot_baf_toolkits_base_PeepholeOptimizer, peepholeListingStream) = _JC_NULL;
	_JC_LINE_NUMBER(55);				// 1
	_JC_REF_FIELD(env, r0, soot_baf_toolkits_base_PeepholeOptimizer, packageName) = _JC_STRING(env, "soot.baf.toolkits.base");
	_JC_LINE_NUMBER(57);				// 2
	r2 = _JC_NEW(env, java_util_HashMap);
	_JC_INVOKE_NONVIRTUAL(env, java_util_HashMap, _init$7cb044ce4fb0ada8, 0, r2, 11, _JC_FCONST(0x3f, 0x40, 0x0, 0x0));
	_JC_REF_FIELD(env, r0, soot_baf_toolkits_base_PeepholeOptimizer, peepholeMap) = r2;
	_JC_LINE_NUMBER(51);				// 3
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// protected void internalTransform(soot.Body, java.lang.String, java.util.Map)
//

static _jc_linenum _jc_soot_baf_toolkits_base_PeepholeOptimizer$linenum_table$internalTransform$9abd4924859b68a3[];

static _jc_trap_info _jc_soot_baf_toolkits_base_PeepholeOptimizer$trap_table$internalTransform$9abd4924859b68a3[] = {
	_JC_TRAP(&_jc_java_io_IOException$type, 5, 6),
	_JC_TRAP(&_jc_java_io_IOException$type, 3, 4),
	_JC_TRAP(&_jc_java_lang_ClassNotFoundException$type, 1, 2),
	_JC_TRAP(&_jc_java_io_IOException$type, 7, 8),
	_JC_TRAP(&_jc_java_lang_ClassNotFoundException$type, 9, 10),
	_JC_TRAP(&_jc_java_lang_IllegalAccessException$type, 11, 12),
	_JC_TRAP(&_jc_java_lang_InstantiationException$type, 11, 12),
	_JC_TRAP(&_jc_java_io_IOException$type, 13, 14),
};

static const unsigned char _jc_soot_baf_toolkits_base_PeepholeOptimizer$param_ptypes$internalTransform$9abd4924859b68a3[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_soot_baf_toolkits_base_PeepholeOptimizer$param_types$internalTransform$9abd4924859b68a3[] = {
	&_jc_soot_Body$type,
	&_jc_java_lang_String$type,
	&_jc_java_util_Map$type
};

_jc_method _jc_soot_baf_toolkits_base_PeepholeOptimizer$method_info$internalTransform$9abd4924859b68a3 = {
	.name=			"internalTransform",
	.signature=		"(Lsoot/Body;Ljava/lang/String;Ljava/util/Map;)V",
	.class=			&_jc_soot_baf_toolkits_base_PeepholeOptimizer$type,
	.param_types=		&_jc_soot_baf_toolkits_base_PeepholeOptimizer$param_types$internalTransform$9abd4924859b68a3,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_soot_baf_toolkits_base_PeepholeOptimizer$param_ptypes$internalTransform$9abd4924859b68a3,
	.signature_hash=	_JC_JLONG(0x9abd4924859b68a3),
	.access_flags=		_JC_ACC_PROTECTED,
	.function=		&_jc_soot_baf_toolkits_base_PeepholeOptimizer$method$internalTransform$9abd4924859b68a3,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_baf_toolkits_base_PeepholeOptimizer$vtable, soot_baf_toolkits_base_PeepholeOptimizer.internalTransform$9abd4924859b68a3) / sizeof(void *),
	.num_parameters=	3,
	.u= { .exec= {
	  .trap_table_len=	8,
	  .trap_table=		_jc_soot_baf_toolkits_base_PeepholeOptimizer$trap_table$internalTransform$9abd4924859b68a3,
	  .u= {
	    .linenum= {
	      .len=	36,
	      .table=	_jc_soot_baf_toolkits_base_PeepholeOptimizer$linenum_table$internalTransform$9abd4924859b68a3
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_baf_toolkits_base_PeepholeOptimizer, internalTransform$9abd4924859b68a3);

void _JC_JCNI_ATTR
_jc_soot_baf_toolkits_base_PeepholeOptimizer$method$internalTransform$9abd4924859b68a3(_jc_env *const env, _jc_soot_baf_toolkits_base_PeepholeOptimizer$object *this, _jc_soot_Body$object *param0, _jc_java_lang_String$object *param1, _jc_object *param2)
{
	jchar volatile c4;
	jint volatile i0;
	jint volatile i1;
	jint volatile i2;
	jint volatile i3;
	jint volatile i5;
	jint volatile i6;
	_jc_object *n0;
	struct _jc_soot_baf_toolkits_base_PeepholeOptimizer$object *volatile r0;
	struct _jc_soot_Body$object *volatile r1;
	struct _jc_java_lang_RuntimeException$object *volatile r10;
	struct _jc_java_io_BufferedReader$object *volatile r11;
	struct _jc_java_io_InputStreamReader$object *volatile r12;
	struct _jc_java_io_IOException$object *volatile r13;
	struct _jc_java_lang_StringBuffer$object *volatile r14;
	struct _jc_java_lang_Object$object *volatile r15;
	struct _jc_java_lang_Class$object *volatile r16;
	struct _jc_java_lang_String$object *volatile r17;
	struct _jc_object *volatile r18;
	struct _jc_java_lang_InstantiationException$object *volatile r19;
	struct _jc_java_lang_String$object *volatile r2;
	struct _jc_java_lang_String$object *volatile r20;
	struct _jc_java_lang_String$object *volatile r21;
	struct _jc_java_lang_String$object *volatile r22;
	struct _jc_java_util_LinkedList__24Entry$object *volatile r23;
	_jc_char_array *volatile r24;
	struct _jc_java_util_LinkedList__24LinkedListItr$object *volatile r25;
	_jc_char_array *volatile r26;
	struct _jc_java_lang_VMThrowable$object *volatile r27;
	struct _jc_java_lang_VMThrowable$object *volatile r28;
	struct _jc_java_lang_VMThrowable$object *volatile r29;
	struct _jc_object *volatile r3;
	struct _jc_java_lang_VMThrowable$object *volatile r30;
	struct _jc_java_lang_VMThrowable$object *volatile r31;
	struct _jc_java_lang_StringBuffer$object *volatile r32;
	struct _jc_java_lang_String$object *volatile r33;
	struct _jc_java_util_LinkedList__24Entry$object *volatile r34;
	struct _jc_java_lang_String$object *volatile r35;
	struct _jc_java_lang_ClassNotFoundException$object *volatile r36;
	struct _jc_java_lang_Class$object *r37;
	struct _jc_java_lang_NoClassDefFoundError$object *volatile r38;
	struct _jc_java_lang_VMThrowable$object *volatile r39;
	struct _jc_java_lang_Class$object *volatile r4;
	struct _jc_java_lang_String$object *r40;
	struct _jc_java_lang_ClassLoader$object *r41;
	struct _jc_java_io_InputStream$object *volatile r42;
	struct _jc_java_io_IOException$object *r43;
	struct _jc_java_lang_ClassLoader$object *r44;
	struct _jc_java_net_URL$object *r45;
	struct _jc_java_io_InputStream$object *r46;
	struct _jc_java_net_URLStreamHandler$object *r47;
	struct _jc_java_net_URLConnection$object *r48;
	struct _jc_java_util_LinkedList$object *volatile r49;
	struct _jc_java_util_LinkedList$object *volatile r5;
	struct _jc_java_util_ConcurrentModificationException$object *volatile r50;
	struct _jc_java_lang_String$object *volatile r51;
	struct _jc_java_lang_VMThrowable$object *volatile r52;
	struct _jc_java_lang_StringIndexOutOfBoundsException$object *volatile r53;
	_jc_char_array *volatile r54;
	struct _jc_java_lang_StringBuffer$object *volatile r55;
	struct _jc_java_lang_StringBuffer$object *volatile r56;
	struct _jc_java_lang_String$object *volatile r57;
	struct _jc_java_lang_String$object *volatile r58;
	struct _jc_java_lang_VMThrowable$object *volatile r59;
	struct _jc_java_io_IOException$object *r6;
	struct _jc_java_lang_String$object *volatile r60;
	_jc_char_array *volatile r61;
	struct _jc_java_lang_String$object *volatile r62;
	struct _jc_java_lang_SecurityManager$object *volatile r63;
	struct _jc_java_lang_IllegalArgumentException$object *volatile r64;
	struct _jc_java_lang_String$object *volatile r65;
	struct _jc_java_lang_String$object *volatile r66;
	struct _jc_java_util_Properties$object *volatile r67;
	struct _jc_java_lang_VMThrowable$object *volatile r69;
	struct _jc_java_lang_ClassNotFoundException$object *volatile r7;
	struct _jc_java_lang_IllegalAccessException$object *volatile r8;
	struct _jc_java_io_InputStream$object *volatile r9;
	jboolean volatile z0;
	jboolean volatile z1;
	jboolean volatile z2;
	jboolean volatile z3;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_soot_baf_toolkits_base_PeepholeOptimizer$method_info$internalTransform$9abd4924859b68a3, &&label5, &&label5, &&label0, &&label13, &&label23, &&label26, &&label27, &&label30);

	r0 = this;
	r1 = param0;
	r2 = param1;
	r3 = param2;
	_JC_LINE_NUMBER(64);				// 0
	z0 = 1;
	_JC_LINE_NUMBER(67);				// 1
	r4 = _JC_STATIC_FIELD(env, soot_baf_toolkits_base_PeepholeOptimizer, class__24soot__24baf__24toolkits__24base__24PeepholeOptimizer, 1);
	if (r4 != _JC_NULL)
		goto label2;
	r35 = _JC_STRING(env, "soot.baf.toolkits.base.PeepholeOptimizer");
	_JC_TRAP_REGION(catch, 1);
	r37 = _JC_INVOKE_STATIC(env, java_lang_Class, forName$d3b57db3b6a905a3, 1, r35);
	_JC_TRAP_REGION(catch, 2);
	r4 = r37;
	goto label1;

label0:
	_JC_TRAP_REGION(catch, 2);
	r36 = _JC_CAUGHT_EXCEPTION(env);
	r38 = _JC_NEW(env, java_lang_NoClassDefFoundError);
	r35 = _JC_INVOKE_VIRTUAL(env, java_lang_Throwable, getMessage$13aaf240efc902b1, r36);
	_JC_REF_FIELD(env, r38, java_lang_Throwable, cause) = r38;
	r39 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r38);
	_JC_REF_FIELD(env, r38, java_lang_Throwable, vmState) = r39;
	_JC_REF_FIELD(env, r38, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r38, java_lang_Throwable, detailMessage) = r35;
	_JC_THROW(env, r38);

label1:
	_JC_STATIC_FIELD(env, soot_baf_toolkits_base_PeepholeOptimizer, class__24soot__24baf__24toolkits__24base__24PeepholeOptimizer, 1) = r37;
	goto label3;

label2:
	_JC_TRAP_REGION(catch, 2);
	r4 = _JC_STATIC_FIELD(env, soot_baf_toolkits_base_PeepholeOptimizer, class__24soot__24baf__24toolkits__24base__24PeepholeOptimizer, 1);

label3:
	_JC_EXPLICIT_NULL_CHECK(env, r4);
	r40 = _JC_STRING(env, "peephole.dat");
	r40 = _JC_INVOKE_NONVIRTUAL(env, java_lang_Class, resourcePath$4e9ba64ffbafd746, 0, r4, r40);
	r41 = _JC_INVOKE_NONVIRTUAL(env, java_lang_Class, getClassLoader$2078dc747ca30d6e, 0, r4);
	if (r41 != _JC_NULL)
		goto label7;
	_JC_ACTIVE_USE(env, java_lang_ClassLoader);
	_JC_TRAP_REGION(catch, 3);
	r44 = _JC_STATIC_FIELD(env, java_lang_ClassLoader__24StaticData, systemClassLoader, 0);
	r45 = _JC_INVOKE_VIRTUAL(env, java_lang_ClassLoader, getResource$6ac32488847016d3, r44, r40);
	if (r45 != _JC_NULL)
		goto label4;
	n0 = _JC_NULL;
	_JC_TRAP_REGION(catch, 4);
	r42 = n0;
	goto label6;

label4:
	_JC_TRAP_REGION(catch, 5);
	r47 = _JC_REF_FIELD(env, r45, java_net_URL, ph);
	r48 = _JC_INVOKE_VIRTUAL(env, java_net_URLStreamHandler, openConnection$7768e1cfcb90de35, r47, r45);
	r46 = _JC_INVOKE_VIRTUAL(env, java_net_URLConnection, getInputStream$13cf75a12cabb343, r48);
	_JC_TRAP_REGION(catch, 6);
	r42 = r46;
	goto label6;

label5:
	_JC_TRAP_REGION(catch, 6);
	r43 = _JC_CAUGHT_EXCEPTION(env);
	r42 = _JC_NULL;

label6:
	_JC_TRAP_REGION(catch, 6);
	r9 = r42;
	goto label8;

label7:
	_JC_TRAP_REGION(catch, 6);
	r42 = _JC_INVOKE_VIRTUAL(env, java_lang_ClassLoader, getResourceAsStream$2be3834772ba2e81, r41, r40);
	r9 = r42;

label8:
	_JC_REF_FIELD(env, r0, soot_baf_toolkits_base_PeepholeOptimizer, peepholeListingStream) = r9;
	_JC_LINE_NUMBER(68);				// 2
	r9 = _JC_REF_FIELD(env, r0, soot_baf_toolkits_base_PeepholeOptimizer, peepholeListingStream);
	if (r9 != _JC_NULL)
		goto label9;
	_JC_LINE_NUMBER(69);				// 3
	r10 = _JC_NEW(env, java_lang_RuntimeException);
	r20 = _JC_STRING(env, "could not open file peephole.dat!");
	_JC_REF_FIELD(env, r10, java_lang_Throwable, cause) = r10;
	r27 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r10);
	_JC_REF_FIELD(env, r10, java_lang_Throwable, vmState) = r27;
	_JC_REF_FIELD(env, r10, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r10, java_lang_Throwable, detailMessage) = r20;
	_JC_THROW(env, r10);

label9:
	_JC_LINE_NUMBER(70);				// 4
	r11 = _JC_NEW(env, java_io_BufferedReader);
	r12 = _JC_NEW(env, java_io_InputStreamReader);
	r9 = _JC_REF_FIELD(env, r0, soot_baf_toolkits_base_PeepholeOptimizer, peepholeListingStream);
	_JC_INVOKE_NONVIRTUAL(env, java_io_InputStreamReader, _init$3887600c17c5e554, 0, r12, r9);
	_JC_INVOKE_NONVIRTUAL(env, java_io_BufferedReader, _init$92676f6e85ad07a2, 0, r11, r12, 8192);
	_JC_LINE_NUMBER(72);				// 5
	r2 = _JC_NULL;
	_JC_LINE_NUMBER(73);				// 6
	r5 = _JC_NEW(env, java_util_LinkedList);
	_JC_PRIM_FIELD(env, r5, java_util_LinkedList, size) = 0;
	_JC_TRAP_REGION(catch, 7);
	_JC_LINE_NUMBER(75);				// 7
	r2 = _JC_INVOKE_NONVIRTUAL(env, java_io_BufferedReader, readLine$d32396e6ff161651, 0, r11);

label10:
	_JC_LINE_NUMBER(76);				// 8
	if (r2 == _JC_NULL)
		goto label18;
	i0 = _JC_PRIM_FIELD(env, r2, java_lang_String, count);
	_JC_LINE_NUMBER(77);				// 9
	if (i0 <= 0)
		goto label12;
	i3 = _JC_PRIM_FIELD(env, r2, java_lang_String, count);
	if (0 < i3)
		goto label11;
	r53 = _JC_NEW(env, java_lang_StringIndexOutOfBoundsException);
	r55 = _JC_NEW(env, java_lang_StringBuffer);
	r60 = _JC_STRING(env, "String index out of range: ");
	i5 = _JC_PRIM_FIELD(env, r60, java_lang_String, count);
	_JC_PRIM_FIELD(env, r55, java_lang_StringBuffer, count) = i5;
	i5 = _JC_PRIM_FIELD(env, r55, java_lang_StringBuffer, count);
	i5 = i5 + 16;
	r61 = _JC_NEW_PRIM_ARRAY(env, char, 1, i5);
	_JC_REF_FIELD(env, r55, java_lang_StringBuffer, value) = r61;
	i5 = _JC_PRIM_FIELD(env, r55, java_lang_StringBuffer, count);
	r61 = _JC_REF_FIELD(env, r55, java_lang_StringBuffer, value);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, getChars$c684dea7317ff063, 0, r60, 0, i5, r61, 0);
	r57 = _JC_INVOKE_STATIC(env, java_lang_Integer, toString$80d919d12afaaa2b, 0, 0, 10);
	r56 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r55, r57);
	_JC_EXPLICIT_NULL_CHECK(env, r56);
	r58 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r58, r56);
	_JC_REF_FIELD(env, r53, java_lang_Throwable, cause) = r53;
	r59 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r53);
	_JC_REF_FIELD(env, r53, java_lang_Throwable, vmState) = r59;
	_JC_REF_FIELD(env, r53, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r53, java_lang_Throwable, detailMessage) = r58;
	_JC_THROW(env, r53);

label11:
	r54 = _JC_REF_FIELD(env, r2, java_lang_String, value);
	i3 = _JC_PRIM_FIELD(env, r2, java_lang_String, offset);
	i3 = i3 + 0;
	c4 = _JC_PRIM_ELEMENT(env, char, r54, i3, 1, 1);
	_JC_LINE_NUMBER(78);				// 10
	if (c4 == 35)
		goto label12;
	r23 = _JC_NEW(env, java_util_LinkedList__24Entry);
	_JC_REF_FIELD(env, r23, java_util_LinkedList__24Entry, data) = r2;
	_JC_INVOKE_NONVIRTUAL(env, java_util_LinkedList, addLastEntry$0c5f1e760480777a, 0, r5, r23);

label12:
	_JC_LINE_NUMBER(80);				// 11
	r2 = _JC_INVOKE_NONVIRTUAL(env, java_io_BufferedReader, readLine$d32396e6ff161651, 0, r11);
	_JC_PERIODIC_CHECK(env);
	goto label10;

label13:
	_JC_TRAP_REGION(catch, 8);
	_JC_LINE_NUMBER(85);				// 12
	r13 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(83);				// 13
	r10 = _JC_NEW(env, java_lang_RuntimeException);
	r14 = _JC_NEW(env, java_lang_StringBuffer);
	r24 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r14, java_lang_StringBuffer, value) = r24;
	r14 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r14, _JC_STRING(env, "IO error occured while reading file:  "));
	r14 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r14, r2);
	_JC_ACTIVE_USE(env, java_lang_System);
	r62 = _JC_STRING(env, "line.separator");
	r63 = _JC_STATIC_FIELD(env, java_lang_SecurityManager, current, 0);
	if (r63 == _JC_NULL)
		goto label14;
	_JC_INVOKE_VIRTUAL(env, java_lang_SecurityManager, checkPropertyAccess$96b5133fb2013064, r63, r62);
	goto label15;

label14:
	i6 = _JC_PRIM_FIELD(env, r62, java_lang_String, count);
	if (i6 != 0)
		goto label15;
	r64 = _JC_NEW(env, java_lang_IllegalArgumentException);
	r65 = _JC_STRING(env, "key can't be empty");
	_JC_REF_FIELD(env, r64, java_lang_Throwable, cause) = r64;
	r69 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r64);
	_JC_REF_FIELD(env, r64, java_lang_Throwable, vmState) = r69;
	_JC_REF_FIELD(env, r64, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r64, java_lang_Throwable, detailMessage) = r65;
	_JC_THROW(env, r64);

label15:
	_JC_ACTIVE_USE(env, gnu_classpath_SystemProperties);
	r67 = _JC_STATIC_FIELD(env, gnu_classpath_SystemProperties, properties, 1);
	r66 = _JC_INVOKE_VIRTUAL(env, java_util_Properties, getProperty$17fb18205ea95f87, r67, r62);
	r14 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r14, r66);
	r32 = r14;
	if (r13 != _JC_NULL)
		goto label16;
	r33 = _JC_STRING(env, "null");
	goto label17;

label16:
	r33 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, toString$7ea43b33b80a3070, r13);

label17:
	r32 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r32, r33);
	r21 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r21, r32);
	_JC_REF_FIELD(env, r10, java_lang_Throwable, cause) = r10;
	r28 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r10);
	_JC_REF_FIELD(env, r10, java_lang_Throwable, vmState) = r28;
	_JC_REF_FIELD(env, r10, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r10, java_lang_Throwable, detailMessage) = r21;
	_JC_THROW(env, r10);

label18:
	_JC_TRAP_REGION(catch, 8);
	_JC_LINE_NUMBER(88);				// 14
	if (z0 == 0)
		goto label29;
	_JC_LINE_NUMBER(89);				// 15
	z0 = 0;
	_JC_INVOKE_NONVIRTUAL(env, java_util_LinkedList, checkBoundsInclusive$7e8f343864a68961, 0, r5, 0);
	r25 = _JC_NEW(env, java_util_LinkedList__24LinkedListItr);
	_JC_INVOKE_NONVIRTUAL(env, java_util_LinkedList__24LinkedListItr, _init$cccd7d3b32781bf1, 0, r25, r5, 0);

label19:
	i1 = _JC_PRIM_FIELD(env, r25, java_util_LinkedList__24LinkedListItr, knownMod);
	r49 = _JC_REF_FIELD(env, r25, java_util_LinkedList__24LinkedListItr, this);
	i2 = _JC_PRIM_FIELD(env, r49, java_util_AbstractList, modCount);
	if (i1 == i2)
		goto label20;
	r50 = _JC_NEW(env, java_util_ConcurrentModificationException);
	r51 = _JC_NULL;
	_JC_REF_FIELD(env, r50, java_lang_Throwable, cause) = r50;
	r52 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r50);
	_JC_REF_FIELD(env, r50, java_lang_Throwable, vmState) = r52;
	_JC_REF_FIELD(env, r50, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r50, java_lang_Throwable, detailMessage) = r51;
	_JC_THROW(env, r50);

label20:
	z3 = 0;
	r34 = _JC_REF_FIELD(env, r25, java_util_LinkedList__24LinkedListItr, next);
	if (r34 == _JC_NULL)
		goto label21;
	z3 = 1;

label21:
	_JC_LINE_NUMBER(92);				// 16
	if (z3 == 0) {
		_JC_PERIODIC_CHECK(env);
		goto label18;
	}
	_JC_LINE_NUMBER(94);				// 17
	z1 = 1;
	_JC_LINE_NUMBER(95);				// 18
	r15 = _JC_INVOKE_NONVIRTUAL(env, java_util_LinkedList__24LinkedListItr, next$05874f79a1cf66ea, 0, r25);
	r2 = _JC_CAST_FINAL(env, &_jc_java_lang_String$type, r15);

label22:
	_JC_TRAP_REGION(catch, 8);
	_JC_LINE_NUMBER(97);				// 19
	if (z1 == 0) {
		_JC_PERIODIC_CHECK(env);
		goto label19;
	}
	_JC_LINE_NUMBER(98);				// 20
	z1 = 0;
	_JC_LINE_NUMBER(102);				// 21
	r3 = _JC_REF_FIELD(env, r0, soot_baf_toolkits_base_PeepholeOptimizer, peepholeMap);
	r15 = _JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0xb30461fc5ea13399), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r2);
	r16 = _JC_CAST_FINAL(env, &_jc_java_lang_Class$type, r15);
	r4 = r16;
	if (r16 != _JC_NULL)
		goto label25;
	_JC_TRAP_REGION(catch, 9);
	_JC_LINE_NUMBER(104);				// 22
	r14 = _JC_NEW(env, java_lang_StringBuffer);
	r26 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r14, java_lang_StringBuffer, value) = r26;
	r14 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r14, _JC_STRING(env, "soot.baf.toolkits.base."));
	r14 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r14, r2);
	r22 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r22, r14);
	r4 = _JC_INVOKE_STATIC(env, java_lang_Class, forName$d3b57db3b6a905a3, 0, r22);
	_JC_TRAP_REGION(catch, 10);
	_JC_LINE_NUMBER(107);				// 23
	goto label24;

label23:
	_JC_TRAP_REGION(catch, 10);
	r7 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(106);				// 24
	r10 = _JC_NEW(env, java_lang_RuntimeException);
	r17 = _JC_INVOKE_VIRTUAL(env, java_lang_Throwable, toString$7ea43b33b80a3070, r7);
	_JC_REF_FIELD(env, r10, java_lang_Throwable, cause) = r10;
	r29 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r10);
	_JC_REF_FIELD(env, r10, java_lang_Throwable, vmState) = r29;
	_JC_REF_FIELD(env, r10, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r10, java_lang_Throwable, detailMessage) = r17;
	_JC_THROW(env, r10);

label24:
	_JC_LINE_NUMBER(108);				// 25
	r3 = _JC_REF_FIELD(env, r0, soot_baf_toolkits_base_PeepholeOptimizer, peepholeMap);
	_JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0x3bd1c078a0faa8da), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *, struct _jc_java_lang_Object$object *), r2, r4);

label25:
	_JC_TRAP_REGION(catch, 11);
	_JC_LINE_NUMBER(113);				// 26
	r15 = _JC_INVOKE_NONVIRTUAL(env, java_lang_Class, newInstance$548f1ab1530c9482, 1, r4);
	r18 = _JC_CAST(env, &_jc_soot_baf_toolkits_base_Peephole$type, r15);
	_JC_TRAP_REGION(catch, 12);
	_JC_LINE_NUMBER(118);				// 27
	goto label28;

label26:
	_JC_TRAP_REGION(catch, 12);
	r8 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(115);				// 28
	r10 = _JC_NEW(env, java_lang_RuntimeException);
	r17 = _JC_INVOKE_VIRTUAL(env, java_lang_Throwable, toString$7ea43b33b80a3070, r8);
	_JC_REF_FIELD(env, r10, java_lang_Throwable, cause) = r10;
	r30 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r10);
	_JC_REF_FIELD(env, r10, java_lang_Throwable, vmState) = r30;
	_JC_REF_FIELD(env, r10, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r10, java_lang_Throwable, detailMessage) = r17;
	_JC_THROW(env, r10);

label27:
	_JC_TRAP_REGION(catch, 12);
	r19 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(117);				// 29
	r10 = _JC_NEW(env, java_lang_RuntimeException);
	r17 = _JC_INVOKE_VIRTUAL(env, java_lang_Throwable, toString$7ea43b33b80a3070, r19);
	_JC_REF_FIELD(env, r10, java_lang_Throwable, cause) = r10;
	r31 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r10);
	_JC_REF_FIELD(env, r10, java_lang_Throwable, vmState) = r31;
	_JC_REF_FIELD(env, r10, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r10, java_lang_Throwable, detailMessage) = r17;
	_JC_THROW(env, r10);

label28:
	_JC_LINE_NUMBER(119);				// 30
	z2 = _JC_INVOKE_INTERFACE(env, r18, _JC_JLONG(0x26c2d07493ac3443), jboolean, (_jc_env *, struct _jc_object *, struct _jc_soot_Body$object *), r1);
	if (z2 == 0) {
		_JC_PERIODIC_CHECK(env);
		goto label22;
	}
	_JC_LINE_NUMBER(120);				// 31
	z1 = 1;
	_JC_LINE_NUMBER(121);				// 32
	z0 = 1;
	_JC_PERIODIC_CHECK(env);
	goto label22;

label29:
	_JC_TRAP_REGION(catch, 13);
	_JC_LINE_NUMBER(128);				// 33
	r9 = _JC_REF_FIELD(env, r0, soot_baf_toolkits_base_PeepholeOptimizer, peepholeListingStream);
	_JC_INVOKE_VIRTUAL(env, java_io_InputStream, close$6aba8b329fddcd79, r9);
	_JC_TRAP_REGION(catch, 14);
	_JC_LINE_NUMBER(131);				// 34
	goto label31;

label30:
	_JC_TRAP_REGION(catch, 14);
	r6 = _JC_CAUGHT_EXCEPTION(env);

label31:
	_JC_LINE_NUMBER(132);				// 35
	_JC_CANCEL_TRAPS(env, catch);
	return;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_soot_baf_toolkits_base_PeepholeOptimizer$methods[] = {
	&_jc_soot_baf_toolkits_base_PeepholeOptimizer$method_info$_init$bbe94f634b20986f,
	&_jc_soot_baf_toolkits_base_PeepholeOptimizer$method_info$class__24$57cd45dca0be1678,
	&_jc_soot_baf_toolkits_base_PeepholeOptimizer$method_info$internalTransform$9abd4924859b68a3,
	&_jc_soot_baf_toolkits_base_PeepholeOptimizer$method_info$v$6f7c30e5dacfebdd
};

/************************************************************************
 *			  Class fields structure			*
 ************************************************************************/

_jc_soot_baf_toolkits_base_PeepholeOptimizer$fields_struct _jc_soot_baf_toolkits_base_PeepholeOptimizer$class_fields = { };

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_soot_baf_toolkits_base_PeepholeOptimizer$instanceof_hash_bucket_46[] = {
	&_jc_soot_baf_toolkits_base_PeepholeOptimizer$type,
	_JC_NULL
};
static _jc_type *const _jc_soot_baf_toolkits_base_PeepholeOptimizer$instanceof_hash_bucket_48[] = {
	&_jc_soot_BodyTransformer$type,
	_JC_NULL
};
static _jc_type *const _jc_soot_baf_toolkits_base_PeepholeOptimizer$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};
static _jc_type *const _jc_soot_baf_toolkits_base_PeepholeOptimizer$instanceof_hash_bucket_112[] = {
	&_jc_soot_Transformer$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_soot_baf_toolkits_base_PeepholeOptimizer$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[46]=	_jc_soot_baf_toolkits_base_PeepholeOptimizer$instanceof_hash_bucket_46,
	[48]=	_jc_soot_baf_toolkits_base_PeepholeOptimizer$instanceof_hash_bucket_48,
	[101]=	_jc_soot_baf_toolkits_base_PeepholeOptimizer$instanceof_hash_bucket_101,
	[112]=	_jc_soot_baf_toolkits_base_PeepholeOptimizer$instanceof_hash_bucket_112
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_soot_baf_toolkits_base_PeepholeOptimizer$class_depends[] = {
	{ "gnu/classpath/SystemProperties",	_JC_JLONG(0x1160ded3f016b6b0) },
	{ "java/io/BufferedReader",	_JC_JLONG(0x2f32f9b77402a730) },
	{ "java/io/IOException",	_JC_JLONG(0x4e0a56550c69d57c) },
	{ "java/io/InputStream",	_JC_JLONG(0x66aea4d152614ac4) },
	{ "java/io/InputStreamReader",	_JC_JLONG(0x30159d8092563292) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/ClassLoader",	_JC_JLONG(0xb0527a7101321261) },
	{ "java/lang/ClassLoader$StaticData",	_JC_JLONG(0xbe9e852b03cddd0) },
	{ "java/lang/ClassNotFoundException",	_JC_JLONG(0x1f925cf50bfc0d6c) },
	{ "java/lang/Error",	_JC_JLONG(0x308333d803f5ab9f) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/IllegalAccessException",	_JC_JLONG(0x29deac5351715967) },
	{ "java/lang/IllegalArgumentException",	_JC_JLONG(0x680cf34d05feb5a1) },
	{ "java/lang/IndexOutOfBoundsException",	_JC_JLONG(0x3cdfed1e0ad1a3d6) },
	{ "java/lang/InstantiationException",	_JC_JLONG(0xb09d021696f0bbb) },
	{ "java/lang/Integer",	_JC_JLONG(0xca631501391a31f1) },
	{ "java/lang/LinkageError",	_JC_JLONG(0x3746e17e005bda9e) },
	{ "java/lang/NoClassDefFoundError",	_JC_JLONG(0x2082ebb592ac2255) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/RuntimeException",	_JC_JLONG(0x4f5534a987354d1d) },
	{ "java/lang/SecurityManager",	_JC_JLONG(0xd38282f3d5f80887) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/StringBuffer",	_JC_JLONG(0x94d357637b968dda) },
	{ "java/lang/StringIndexOutOfBoundsException",	_JC_JLONG(0xbb7f6fdd2bd0e6b2) },
	{ "java/lang/System",	_JC_JLONG(0x53cc8e2333795f04) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/net/URL",	_JC_JLONG(0x69345d46f4f40e9c) },
	{ "java/net/URLConnection",	_JC_JLONG(0x1042c111741aa488) },
	{ "java/net/URLStreamHandler",	_JC_JLONG(0xd7e769aebe17520e) },
	{ "java/util/AbstractCollection",	_JC_JLONG(0x8ea716c64b77f8eb) },
	{ "java/util/AbstractList",	_JC_JLONG(0xf5238436362828db) },
	{ "java/util/AbstractSequentialList",	_JC_JLONG(0x6d7997e879c41059) },
	{ "java/util/ConcurrentModificationException",	_JC_JLONG(0x52f944b5de1e20c4) },
	{ "java/util/HashMap",	_JC_JLONG(0xd7cd853200c3e71f) },
	{ "java/util/LinkedList",	_JC_JLONG(0x666417b6279ae396) },
	{ "java/util/LinkedList$Entry",	_JC_JLONG(0x2522cc4453ab9d02) },
	{ "java/util/LinkedList$LinkedListItr",	_JC_JLONG(0x2fe8fa9fb9ea6f9b) },
	{ "java/util/Map",	_JC_JLONG(0xe283f7c2e7a7979c) },
	{ "java/util/Properties",	_JC_JLONG(0x884c3edb343dfb63) },
	{ "soot/Body",	_JC_JLONG(0x6131d54b9700ca5d) },
	{ "soot/BodyTransformer",	_JC_JLONG(0xa76a7734eb62f430) },
	{ "soot/G",	_JC_JLONG(0xb6d33af8f84fdbc4) },
	{ "soot/Singletons",	_JC_JLONG(0x6ac5bee50bbabb71) },
	{ "soot/Singletons$Global",	_JC_JLONG(0x47e789a7286ce13e) },
	{ "soot/Transformer",	_JC_JLONG(0xde5fa3182955e270) },
	{ "soot/baf/toolkits/base/Peephole",	_JC_JLONG(0x6759975ef41a30c9) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_soot_baf_toolkits_base_PeepholeOptimizer$vtype _jc_soot_baf_toolkits_base_PeepholeOptimizer$type = {
    .type= {
	.name=			"soot/baf/toolkits/base/PeepholeOptimizer",
	.superclass=		&_jc_soot_BodyTransformer$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		16,
		.hash=			_JC_JLONG(0xd118f385c7b8f5ae),
		.source_file=		"PeepholeOptimizer.java",
		.instance_size=		sizeof(_jc_soot_baf_toolkits_base_PeepholeOptimizer$refs) + sizeof(_jc_soot_baf_toolkits_base_PeepholeOptimizer$object),
		.num_virtual_refs=	3,
		.num_fields=		sizeof(_jc_soot_baf_toolkits_base_PeepholeOptimizer$fields) / sizeof(*_jc_soot_baf_toolkits_base_PeepholeOptimizer$fields),
		.fields=		_jc_soot_baf_toolkits_base_PeepholeOptimizer$fields,
		.num_methods=		sizeof(_jc_soot_baf_toolkits_base_PeepholeOptimizer$methods) / sizeof(*_jc_soot_baf_toolkits_base_PeepholeOptimizer$methods),
		.methods=		_jc_soot_baf_toolkits_base_PeepholeOptimizer$methods,
		.instanceof_hash_table=	_jc_soot_baf_toolkits_base_PeepholeOptimizer$instanceof_hash_table,
		.class_fields=		&_jc_soot_baf_toolkits_base_PeepholeOptimizer$class_fields,
		.num_class_depends=		sizeof(_jc_soot_baf_toolkits_base_PeepholeOptimizer$class_depends) / sizeof(*_jc_soot_baf_toolkits_base_PeepholeOptimizer$class_depends),
		.class_depends=		_jc_soot_baf_toolkits_base_PeepholeOptimizer$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.soot_Transformer= {
	},
	.soot_BodyTransformer= {
	    .internalTransform$9abd4924859b68a3=		// overridden
		&_jc_soot_baf_toolkits_base_PeepholeOptimizer$method$internalTransform$9abd4924859b68a3,
	    .transform$efe210b8710809f9=
		&_jc_soot_BodyTransformer$method$transform$efe210b8710809f9,
	    .transform$6c1afdd3773c7636=
		&_jc_soot_BodyTransformer$method$transform$6c1afdd3773c7636,
	    .transform$fa83af6c18402119=
		&_jc_soot_BodyTransformer$method$transform$fa83af6c18402119,
	},
	.soot_baf_toolkits_base_PeepholeOptimizer= {
	    .internalTransform$9abd4924859b68a3=
		&_jc_soot_baf_toolkits_base_PeepholeOptimizer$method$internalTransform$9abd4924859b68a3,
	},
    }
};

