// public class soot.javaToJimple.PolyglotMethodSource

// class file dependencies
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 94d357637b968dda java_lang_StringBuffer
// @dep_class 8ea716c64b77f8eb java_util_AbstractCollection
// @dep_class f5238436362828db java_util_AbstractList
// @dep_class 58038509830ef3f4 java_util_ArrayList
// @dep_class d7cd853200c3e71f java_util_HashMap
// @dep_class 9ee0d92ce1525a4d java_util_List
// @dep_class e283f7c2e7a7979c java_util_Map
// @dep_class 5eda5b679dfeb2f7 polyglot_ast_Block
// @dep_class 6131d54b9700ca5d soot_Body
// @dep_class 3dae18ed334ad777 soot_BooleanType
// @dep_class b6d33af8f84fdbc4 soot_G
// @dep_class fc12513d0e867dd9 soot_Local
// @dep_class 46c999f340ec4a2f soot_MethodSource
// @dep_class 65aca5ceab69719a soot_Pack
// @dep_class 4582e82e366d3f43 soot_PackManager
// @dep_class 2869754f09a70a54 soot_PatchingChain
// @dep_class 177db6dd531c9085 soot_PhaseOptions
// @dep_class fdbc627922b0ba72 soot_RefLikeType
// @dep_class 2887a1b57cecfb7b soot_RefType
// @dep_class 7120c8047949f8c0 soot_Scene
// @dep_class 6ac5bee50bbabb71 soot_Singletons
// @dep_class 634bd13ff2d8ac70 soot_SootClass
// @dep_class 23c08aae5a0099c4 soot_SootField
// @dep_class bd11c16680505218 soot_SootMethod
// @dep_class f801e5c664424a1 soot_Type
// @dep_class 14c838518d04862c soot_javaToJimple_JimpleBodyBuilder
// @dep_class 8f65caf164849b1 soot_javaToJimple_PolyglotMethodSource
// @dep_class e5651dde6cd08af9 soot_jimple_ArithmeticConstant
// @dep_class bfceec22e8ffee79 soot_jimple_AssignStmt
// @dep_class a4a584ce60f6ce4 soot_jimple_Constant
// @dep_class 19f3fc907e68832c soot_jimple_GotoStmt
// @dep_class 904ca7a05d5fe162 soot_jimple_IfStmt
// @dep_class fade60ef604ad800 soot_jimple_IntConstant
// @dep_class 18f5ef6e837efcef soot_jimple_Jimple
// @dep_class 197add2ebd99cc14 soot_jimple_JimpleBody
// @dep_class a79ed01c5425d753 soot_jimple_NeExpr
// @dep_class fbe3f749c636231 soot_jimple_NopStmt
// @dep_class 8a1af2f5d59b712f soot_jimple_NullConstant
// @dep_class 3bd9379d3ff77f81 soot_jimple_NumericConstant
// @dep_class 481d0bb0a59d7420 soot_jimple_StaticFieldRef
// @dep_class 5f8a86314966eaf4 soot_jimple_StaticInvokeExpr
// @dep_class 51a35a83f0a4f8f1 soot_jimple_StringConstant
// @dep_class d9fed49578ff87c7 soot_jimple_VirtualInvokeExpr
// @dep_class a50c82c4926ca40e soot_util_Chain
// @dep_class f5f751433138bc27 soot_util_Numberer

// header file dependencies
// @dep_header java_lang_Class
// @dep_header java_lang_String
// @dep_header java_lang_StringBuffer
// @dep_header java_util_ArrayList
// @dep_header java_util_HashMap
// @dep_header java_util_List
// @dep_header java_util_Map
// @dep_header polyglot_ast_Block
// @dep_header soot_BooleanType
// @dep_header soot_G
// @dep_header soot_Local
// @dep_header soot_MethodSource
// @dep_header soot_Pack
// @dep_header soot_PackManager
// @dep_header soot_PatchingChain
// @dep_header soot_PhaseOptions
// @dep_header soot_RefType
// @dep_header soot_Scene
// @dep_header soot_SootClass
// @dep_header soot_SootField
// @dep_header soot_SootMethod
// @dep_header soot_javaToJimple_JimpleBodyBuilder
// @dep_header soot_javaToJimple_PolyglotMethodSource
// @dep_header soot_jimple_AssignStmt
// @dep_header soot_jimple_GotoStmt
// @dep_header soot_jimple_IfStmt
// @dep_header soot_jimple_IntConstant
// @dep_header soot_jimple_Jimple
// @dep_header soot_jimple_JimpleBody
// @dep_header soot_jimple_NeExpr
// @dep_header soot_jimple_NopStmt
// @dep_header soot_jimple_NullConstant
// @dep_header soot_jimple_StaticFieldRef
// @dep_header soot_jimple_StaticInvokeExpr
// @dep_header soot_jimple_StringConstant
// @dep_header soot_jimple_VirtualInvokeExpr
// @dep_header soot_util_Chain
// @dep_header soot_util_Numberer

#include "jc_defs.h"

#include "java/lang/Class.h"
#include "java/lang/String.h"
#include "java/lang/StringBuffer.h"
#include "java/util/ArrayList.h"
#include "java/util/HashMap.h"
#include "java/util/List.h"
#include "java/util/Map.h"
#include "polyglot/ast/Block.h"
#include "soot/BooleanType.h"
#include "soot/G.h"
#include "soot/Local.h"
#include "soot/MethodSource.h"
#include "soot/Pack.h"
#include "soot/PackManager.h"
#include "soot/PatchingChain.h"
#include "soot/PhaseOptions.h"
#include "soot/RefType.h"
#include "soot/Scene.h"
#include "soot/SootClass.h"
#include "soot/SootField.h"
#include "soot/SootMethod.h"
#include "soot/javaToJimple/JimpleBodyBuilder.h"
#include "soot/javaToJimple/PolyglotMethodSource.h"
#include "soot/jimple/AssignStmt.h"
#include "soot/jimple/GotoStmt.h"
#include "soot/jimple/IfStmt.h"
#include "soot/jimple/IntConstant.h"
#include "soot/jimple/Jimple.h"
#include "soot/jimple/JimpleBody.h"
#include "soot/jimple/NeExpr.h"
#include "soot/jimple/NopStmt.h"
#include "soot/jimple/NullConstant.h"
#include "soot/jimple/StaticFieldRef.h"
#include "soot/jimple/StaticInvokeExpr.h"
#include "soot/jimple/StringConstant.h"
#include "soot/jimple/VirtualInvokeExpr.h"
#include "soot/util/Chain.h"
#include "soot/util/Numberer.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// private polyglot.ast.Block block
static _jc_field _jc_soot_javaToJimple_PolyglotMethodSource$field_info$block = {
	.name=		"block",
	.signature=	"Lpolyglot/ast/Block;",
	.class=		&_jc_soot_javaToJimple_PolyglotMethodSource$type,
	.type=		&_jc_polyglot_ast_Block$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_soot_javaToJimple_PolyglotMethodSource$object, refs[-1].soot_javaToJimple_PolyglotMethodSource.block),
};

// private java.util.List formals
static _jc_field _jc_soot_javaToJimple_PolyglotMethodSource$field_info$formals = {
	.name=		"formals",
	.signature=	"Ljava/util/List;",
	.class=		&_jc_soot_javaToJimple_PolyglotMethodSource$type,
	.type=		&_jc_java_util_List$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_soot_javaToJimple_PolyglotMethodSource$object, refs[-1].soot_javaToJimple_PolyglotMethodSource.formals),
};

// private java.util.ArrayList fieldInits
static _jc_field _jc_soot_javaToJimple_PolyglotMethodSource$field_info$fieldInits = {
	.name=		"fieldInits",
	.signature=	"Ljava/util/ArrayList;",
	.class=		&_jc_soot_javaToJimple_PolyglotMethodSource$type,
	.type=		&_jc_java_util_ArrayList$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_soot_javaToJimple_PolyglotMethodSource$object, refs[-1].soot_javaToJimple_PolyglotMethodSource.fieldInits),
};

// private java.util.ArrayList staticFieldInits
static _jc_field _jc_soot_javaToJimple_PolyglotMethodSource$field_info$staticFieldInits = {
	.name=		"staticFieldInits",
	.signature=	"Ljava/util/ArrayList;",
	.class=		&_jc_soot_javaToJimple_PolyglotMethodSource$type,
	.type=		&_jc_java_util_ArrayList$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_soot_javaToJimple_PolyglotMethodSource$object, refs[-1].soot_javaToJimple_PolyglotMethodSource.staticFieldInits),
};

// private java.util.ArrayList initializerBlocks
static _jc_field _jc_soot_javaToJimple_PolyglotMethodSource$field_info$initializerBlocks = {
	.name=		"initializerBlocks",
	.signature=	"Ljava/util/ArrayList;",
	.class=		&_jc_soot_javaToJimple_PolyglotMethodSource$type,
	.type=		&_jc_java_util_ArrayList$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_soot_javaToJimple_PolyglotMethodSource$object, refs[-1].soot_javaToJimple_PolyglotMethodSource.initializerBlocks),
};

// private java.util.ArrayList staticInitializerBlocks
static _jc_field _jc_soot_javaToJimple_PolyglotMethodSource$field_info$staticInitializerBlocks = {
	.name=		"staticInitializerBlocks",
	.signature=	"Ljava/util/ArrayList;",
	.class=		&_jc_soot_javaToJimple_PolyglotMethodSource$type,
	.type=		&_jc_java_util_ArrayList$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_soot_javaToJimple_PolyglotMethodSource$object, refs[-1].soot_javaToJimple_PolyglotMethodSource.staticInitializerBlocks),
};

// private soot.Local outerClassThisInit
static _jc_field _jc_soot_javaToJimple_PolyglotMethodSource$field_info$outerClassThisInit = {
	.name=		"outerClassThisInit",
	.signature=	"Lsoot/Local;",
	.class=		&_jc_soot_javaToJimple_PolyglotMethodSource$type,
	.type=		&_jc_soot_Local$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_soot_javaToJimple_PolyglotMethodSource$object, refs[-1].soot_javaToJimple_PolyglotMethodSource.outerClassThisInit),
};

// private java.util.HashMap privateAccessMap
static _jc_field _jc_soot_javaToJimple_PolyglotMethodSource$field_info$privateAccessMap = {
	.name=		"privateAccessMap",
	.signature=	"Ljava/util/HashMap;",
	.class=		&_jc_soot_javaToJimple_PolyglotMethodSource$type,
	.type=		&_jc_java_util_HashMap$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_soot_javaToJimple_PolyglotMethodSource$object, refs[-1].soot_javaToJimple_PolyglotMethodSource.privateAccessMap),
};

// private java.util.HashMap localClassMap
static _jc_field _jc_soot_javaToJimple_PolyglotMethodSource$field_info$localClassMap = {
	.name=		"localClassMap",
	.signature=	"Ljava/util/HashMap;",
	.class=		&_jc_soot_javaToJimple_PolyglotMethodSource$type,
	.type=		&_jc_java_util_HashMap$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_soot_javaToJimple_PolyglotMethodSource$object, refs[-1].soot_javaToJimple_PolyglotMethodSource.localClassMap),
};

// private java.util.HashMap anonClassMap
static _jc_field _jc_soot_javaToJimple_PolyglotMethodSource$field_info$anonClassMap = {
	.name=		"anonClassMap",
	.signature=	"Ljava/util/HashMap;",
	.class=		&_jc_soot_javaToJimple_PolyglotMethodSource$type,
	.type=		&_jc_java_util_HashMap$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_soot_javaToJimple_PolyglotMethodSource$object, refs[-1].soot_javaToJimple_PolyglotMethodSource.anonClassMap),
};

// private boolean hasAssert
static _jc_field _jc_soot_javaToJimple_PolyglotMethodSource$field_info$hasAssert = {
	.name=		"hasAssert",
	.signature=	"Z",
	.class=		&_jc_soot_javaToJimple_PolyglotMethodSource$type,
	.type=		&_jc_boolean$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_soot_javaToJimple_PolyglotMethodSource$object, nonrefs.soot_javaToJimple_PolyglotMethodSource.hasAssert),
};

// private java.util.HashMap finalsMap
static _jc_field _jc_soot_javaToJimple_PolyglotMethodSource$field_info$finalsMap = {
	.name=		"finalsMap",
	.signature=	"Ljava/util/HashMap;",
	.class=		&_jc_soot_javaToJimple_PolyglotMethodSource$type,
	.type=		&_jc_java_util_HashMap$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_soot_javaToJimple_PolyglotMethodSource$object, refs[-1].soot_javaToJimple_PolyglotMethodSource.finalsMap),
};

// private java.util.HashMap newToOuterMap
static _jc_field _jc_soot_javaToJimple_PolyglotMethodSource$field_info$newToOuterMap = {
	.name=		"newToOuterMap",
	.signature=	"Ljava/util/HashMap;",
	.class=		&_jc_soot_javaToJimple_PolyglotMethodSource$type,
	.type=		&_jc_java_util_HashMap$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_soot_javaToJimple_PolyglotMethodSource$object, refs[-1].soot_javaToJimple_PolyglotMethodSource.newToOuterMap),
};

// Fields
static _jc_field *const _jc_soot_javaToJimple_PolyglotMethodSource$fields[] = {
	&_jc_soot_javaToJimple_PolyglotMethodSource$field_info$anonClassMap,
	&_jc_soot_javaToJimple_PolyglotMethodSource$field_info$block,
	&_jc_soot_javaToJimple_PolyglotMethodSource$field_info$fieldInits,
	&_jc_soot_javaToJimple_PolyglotMethodSource$field_info$finalsMap,
	&_jc_soot_javaToJimple_PolyglotMethodSource$field_info$formals,
	&_jc_soot_javaToJimple_PolyglotMethodSource$field_info$initializerBlocks,
	&_jc_soot_javaToJimple_PolyglotMethodSource$field_info$localClassMap,
	&_jc_soot_javaToJimple_PolyglotMethodSource$field_info$newToOuterMap,
	&_jc_soot_javaToJimple_PolyglotMethodSource$field_info$outerClassThisInit,
	&_jc_soot_javaToJimple_PolyglotMethodSource$field_info$privateAccessMap,
	&_jc_soot_javaToJimple_PolyglotMethodSource$field_info$staticFieldInits,
	&_jc_soot_javaToJimple_PolyglotMethodSource$field_info$staticInitializerBlocks,
	&_jc_soot_javaToJimple_PolyglotMethodSource$field_info$hasAssert
};

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// public void <init>()
//

static _jc_linenum _jc_soot_javaToJimple_PolyglotMethodSource$linenum_table$_init$52f4ad9f2989aeee[];

static const unsigned char _jc_soot_javaToJimple_PolyglotMethodSource$param_ptypes$_init$52f4ad9f2989aeee[] = { 
_JC_TYPE_VOID };

_jc_method _jc_soot_javaToJimple_PolyglotMethodSource$method_info$_init$52f4ad9f2989aeee = {
	.name=			"<init>",
	.signature=		"()V",
	.class=			&_jc_soot_javaToJimple_PolyglotMethodSource$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_soot_javaToJimple_PolyglotMethodSource$param_ptypes$_init$52f4ad9f2989aeee,
	.signature_hash=	_JC_JLONG(0x52f4ad9f2989aeee),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_javaToJimple_PolyglotMethodSource$method$_init$52f4ad9f2989aeee,
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_soot_javaToJimple_PolyglotMethodSource$linenum_table$_init$52f4ad9f2989aeee
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_javaToJimple_PolyglotMethodSource, _init$52f4ad9f2989aeee);

void _JC_JCNI_ATTR
_jc_soot_javaToJimple_PolyglotMethodSource$method$_init$52f4ad9f2989aeee(_jc_env *const env, _jc_soot_javaToJimple_PolyglotMethodSource$object *this)
{
	struct _jc_soot_javaToJimple_PolyglotMethodSource$object *r0;

	r0 = this;
	_JC_LINE_NUMBER(18);				// 0
	_JC_PRIM_FIELD(env, r0, soot_javaToJimple_PolyglotMethodSource, hasAssert) = 0;
	_JC_LINE_NUMBER(23);				// 1
	_JC_REF_FIELD(env, r0, soot_javaToJimple_PolyglotMethodSource, block) = _JC_NULL;
	_JC_LINE_NUMBER(24);				// 2
	_JC_REF_FIELD(env, r0, soot_javaToJimple_PolyglotMethodSource, formals) = _JC_NULL;
	_JC_LINE_NUMBER(25);				// 3
	return;
}

//
// public void <init>(polyglot.ast.Block, java.util.List)
//

static _jc_linenum _jc_soot_javaToJimple_PolyglotMethodSource$linenum_table$_init$1836b9c10f8424cb[];

static const unsigned char _jc_soot_javaToJimple_PolyglotMethodSource$param_ptypes$_init$1836b9c10f8424cb[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_soot_javaToJimple_PolyglotMethodSource$param_types$_init$1836b9c10f8424cb[] = {
	&_jc_polyglot_ast_Block$type,
	&_jc_java_util_List$type
};

_jc_method _jc_soot_javaToJimple_PolyglotMethodSource$method_info$_init$1836b9c10f8424cb = {
	.name=			"<init>",
	.signature=		"(Lpolyglot/ast/Block;Ljava/util/List;)V",
	.class=			&_jc_soot_javaToJimple_PolyglotMethodSource$type,
	.param_types=		&_jc_soot_javaToJimple_PolyglotMethodSource$param_types$_init$1836b9c10f8424cb,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_soot_javaToJimple_PolyglotMethodSource$param_ptypes$_init$1836b9c10f8424cb,
	.signature_hash=	_JC_JLONG(0x1836b9c10f8424cb),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_javaToJimple_PolyglotMethodSource$method$_init$1836b9c10f8424cb,
	.num_parameters=	2,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_soot_javaToJimple_PolyglotMethodSource$linenum_table$_init$1836b9c10f8424cb
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_javaToJimple_PolyglotMethodSource, _init$1836b9c10f8424cb);

void _JC_JCNI_ATTR
_jc_soot_javaToJimple_PolyglotMethodSource$method$_init$1836b9c10f8424cb(_jc_env *const env, _jc_soot_javaToJimple_PolyglotMethodSource$object *this, _jc_object *param0, _jc_object *param1)
{
	struct _jc_soot_javaToJimple_PolyglotMethodSource$object *r0;
	struct _jc_object *r1;
	struct _jc_object *r2;

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_LINE_NUMBER(18);				// 0
	_JC_PRIM_FIELD(env, r0, soot_javaToJimple_PolyglotMethodSource, hasAssert) = 0;
	_JC_LINE_NUMBER(28);				// 1
	_JC_REF_FIELD(env, r0, soot_javaToJimple_PolyglotMethodSource, block) = r1;
	_JC_LINE_NUMBER(29);				// 2
	_JC_REF_FIELD(env, r0, soot_javaToJimple_PolyglotMethodSource, formals) = r2;
	_JC_LINE_NUMBER(30);				// 3
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public void addAssertInits(soot.Body)
//

static _jc_linenum _jc_soot_javaToJimple_PolyglotMethodSource$linenum_table$addAssertInits$6d766b1297a0a7f2[];

static const unsigned char _jc_soot_javaToJimple_PolyglotMethodSource$param_ptypes$addAssertInits$6d766b1297a0a7f2[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_soot_javaToJimple_PolyglotMethodSource$param_types$addAssertInits$6d766b1297a0a7f2[] = {
	&_jc_soot_Body$type
};

_jc_method _jc_soot_javaToJimple_PolyglotMethodSource$method_info$addAssertInits$6d766b1297a0a7f2 = {
	.name=			"addAssertInits",
	.signature=		"(Lsoot/Body;)V",
	.class=			&_jc_soot_javaToJimple_PolyglotMethodSource$type,
	.param_types=		&_jc_soot_javaToJimple_PolyglotMethodSource$param_types$addAssertInits$6d766b1297a0a7f2,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_soot_javaToJimple_PolyglotMethodSource$param_ptypes$addAssertInits$6d766b1297a0a7f2,
	.signature_hash=	_JC_JLONG(0x6d766b1297a0a7f2),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_javaToJimple_PolyglotMethodSource$method$addAssertInits$6d766b1297a0a7f2,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_javaToJimple_PolyglotMethodSource$vtable, soot_javaToJimple_PolyglotMethodSource.addAssertInits$6d766b1297a0a7f2) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	55,
	      .table=	_jc_soot_javaToJimple_PolyglotMethodSource$linenum_table$addAssertInits$6d766b1297a0a7f2
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_javaToJimple_PolyglotMethodSource, addAssertInits$6d766b1297a0a7f2);

void _JC_JCNI_ATTR
_jc_soot_javaToJimple_PolyglotMethodSource$method$addAssertInits$6d766b1297a0a7f2(_jc_env *const env, _jc_soot_javaToJimple_PolyglotMethodSource$object *this, _jc_soot_Body$object *param0)
{
	struct _jc_soot_javaToJimple_PolyglotMethodSource$object *r0;
	struct _jc_soot_Body$object *r1;
	struct _jc_java_util_ArrayList$object *r10;
	struct _jc_soot_Scene$object *r100;
	struct _jc_soot_G$object *r101;
	struct _jc_soot_Scene$object *r102;
	struct _jc_soot_G$object *r103;
	struct _jc_soot_util_Numberer$object *r104;
	struct _jc_soot_Scene$object *r105;
	struct _jc_soot_G$object *r106;
	struct _jc_java_lang_String$object *r107;
	struct _jc_soot_RefType$object *r108;
	struct _jc_soot_Scene$object *r109;
	struct _jc_soot_SootMethod$object *r11;
	struct _jc_soot_G$object *r110;
	struct _jc_soot_Scene$object *r111;
	struct _jc_soot_G$object *r112;
	struct _jc_soot_util_Numberer$object *r113;
	struct _jc_soot_Scene$object *r114;
	struct _jc_soot_G$object *r115;
	struct _jc_java_lang_String$object *r116;
	struct _jc_soot_RefType$object *r117;
	struct _jc_soot_Scene$object *r118;
	struct _jc_soot_G$object *r119;
	struct _jc_object *r12;
	struct _jc_soot_Scene$object *r120;
	struct _jc_soot_G$object *r121;
	struct _jc_soot_util_Numberer$object *r122;
	struct _jc_soot_Scene$object *r123;
	struct _jc_soot_G$object *r124;
	struct _jc_java_lang_String$object *r125;
	struct _jc_soot_RefType$object *r126;
	struct _jc_soot_Scene$object *r127;
	struct _jc_soot_G$object *r128;
	struct _jc_soot_Scene$object *r129;
	struct _jc_object *r13;
	struct _jc_soot_G$object *r130;
	struct _jc_soot_util_Numberer$object *r131;
	struct _jc_soot_Scene$object *r132;
	struct _jc_soot_G$object *r133;
	struct _jc_java_lang_String$object *r134;
	struct _jc_soot_RefType$object *r135;
	struct _jc_soot_Scene$object *r136;
	struct _jc_soot_G$object *r137;
	struct _jc_soot_Scene$object *r138;
	struct _jc_soot_G$object *r139;
	struct _jc_object *r14;
	struct _jc_soot_util_Numberer$object *r140;
	struct _jc_soot_Scene$object *r142;
	struct _jc_soot_G$object *r143;
	struct _jc_object *r15;
	struct _jc_object *r16;
	struct _jc_object *r17;
	struct _jc_soot_SootClass$object *r18;
	struct _jc_soot_SootClass$object *r19;
	struct _jc_java_lang_StringBuffer$object *r2;
	struct _jc_java_lang_String$object *r20;
	struct _jc_object *r21;
	struct _jc_soot_PatchingChain$object *r22;
	struct _jc_soot_SootMethod$object *r23;
	struct _jc_java_lang_String$object *r24;
	struct _jc_soot_jimple_Jimple$object *r25;
	struct _jc_soot_G$object *r26;
	struct _jc_soot_jimple_Jimple$object *r27;
	struct _jc_soot_G$object *r28;
	struct _jc_soot_jimple_Jimple$object *r29;
	struct _jc_soot_SootField$object *r3;
	struct _jc_soot_G$object *r30;
	struct _jc_soot_jimple_Jimple$object *r31;
	struct _jc_soot_G$object *r32;
	struct _jc_soot_jimple_NullConstant$object *r33;
	struct _jc_soot_G$object *r34;
	struct _jc_soot_jimple_Jimple$object *r35;
	struct _jc_soot_G$object *r36;
	struct _jc_soot_jimple_Jimple$object *r37;
	struct _jc_soot_G$object *r38;
	struct _jc_soot_jimple_Jimple$object *r39;
	struct _jc_object *r4;
	struct _jc_soot_G$object *r40;
	struct _jc_soot_jimple_StringConstant$object *r41;
	struct _jc_soot_jimple_Jimple$object *r42;
	struct _jc_soot_G$object *r43;
	struct _jc_soot_jimple_Jimple$object *r44;
	struct _jc_soot_G$object *r45;
	struct _jc_soot_jimple_Jimple$object *r46;
	struct _jc_soot_G$object *r47;
	struct _jc_soot_jimple_Jimple$object *r48;
	struct _jc_soot_G$object *r49;
	struct _jc_soot_jimple_StaticFieldRef$object *r5;
	struct _jc_soot_jimple_Jimple$object *r50;
	struct _jc_soot_G$object *r51;
	struct _jc_soot_jimple_Jimple$object *r52;
	struct _jc_soot_G$object *r53;
	struct _jc_soot_jimple_Jimple$object *r54;
	struct _jc_soot_G$object *r55;
	struct _jc_soot_BooleanType$object *r56;
	struct _jc_soot_G$object *r57;
	struct _jc_soot_jimple_Jimple$object *r58;
	struct _jc_soot_G$object *r59;
	struct _jc_object *r6;
	struct _jc_soot_BooleanType$object *r60;
	struct _jc_soot_G$object *r61;
	struct _jc_soot_Scene$object *r62;
	struct _jc_soot_G$object *r63;
	struct _jc_soot_BooleanType$object *r64;
	struct _jc_soot_G$object *r65;
	struct _jc_soot_jimple_Jimple$object *r66;
	struct _jc_soot_G$object *r67;
	struct _jc_soot_jimple_Jimple$object *r68;
	struct _jc_soot_G$object *r69;
	struct _jc_object *r7;
	struct _jc_soot_jimple_Jimple$object *r70;
	struct _jc_soot_G$object *r71;
	struct _jc_soot_jimple_IntConstant$object *r72;
	struct _jc_soot_jimple_Jimple$object *r73;
	struct _jc_soot_G$object *r74;
	struct _jc_soot_jimple_Jimple$object *r75;
	struct _jc_soot_G$object *r76;
	struct _jc_soot_jimple_Jimple$object *r77;
	struct _jc_soot_G$object *r78;
	struct _jc_soot_jimple_IntConstant$object *r79;
	struct _jc_object *r8;
	struct _jc_soot_jimple_Jimple$object *r80;
	struct _jc_soot_G$object *r81;
	struct _jc_soot_jimple_Jimple$object *r82;
	struct _jc_soot_G$object *r83;
	struct _jc_soot_jimple_Jimple$object *r84;
	struct _jc_soot_G$object *r85;
	struct _jc_soot_jimple_IntConstant$object *r86;
	struct _jc_soot_BooleanType$object *r87;
	struct _jc_soot_G$object *r88;
	struct _jc_soot_jimple_Jimple$object *r89;
	struct _jc_object *r9;
	struct _jc_soot_G$object *r90;
	struct _jc_soot_jimple_Jimple$object *r91;
	struct _jc_soot_G$object *r92;
	_jc_char_array *r93;
	_jc_object_array *r94;
	_jc_object_array *r95;
	_jc_object_array *r96;
	_jc_object_array *r97;
	struct _jc_java_lang_String$object *r98;
	struct _jc_soot_RefType$object *r99;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(118);				// 0
	r11 = _JC_INVOKE_VIRTUAL(env, soot_Body, getMethod$04d7c221deab35ce, r1);
	r18 = _JC_INVOKE_VIRTUAL(env, soot_SootMethod, getDeclaringClass$dd2382a1f7813acf, r11);
	r2 = _JC_NEW(env, java_lang_StringBuffer);
	r93 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r2, java_lang_StringBuffer, value) = r93;
	r2 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r2, _JC_STRING(env, "class$"));
	r11 = _JC_INVOKE_VIRTUAL(env, soot_Body, getMethod$04d7c221deab35ce, r1);
	r19 = _JC_INVOKE_VIRTUAL(env, soot_SootMethod, getDeclaringClass$dd2382a1f7813acf, r11);
	r20 = _JC_INVOKE_VIRTUAL(env, soot_SootClass, getName$bec186f2ce7e1882, r19);
	r2 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r2, r20);
	r24 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r24, r2);
	_JC_ACTIVE_USE(env, soot_RefType);
	r98 = _JC_STRING(env, "java.lang.Class");
	_JC_ACTIVE_USE(env, soot_Scene);
	_JC_ACTIVE_USE(env, soot_G);
	r101 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r100 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Scene$3451207662ac1af0, r101);
	r99 = _JC_INVOKE_VIRTUAL(env, soot_Scene, getRefType$edcdead019670553, r100, r98);
	if (r99 != _JC_NULL)
		goto label0;
	r99 = _JC_NEW(env, soot_RefType);
	_JC_PRIM_FIELD(env, r99, soot_Type, number) = 0;
	r106 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r105 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Scene$3451207662ac1af0, r106);
	r104 = _JC_INVOKE_VIRTUAL(env, soot_Scene, getTypeNumberer$1a245dd462a8adec, r105);
	_JC_INVOKE_VIRTUAL(env, soot_util_Numberer, add$5470e142c10db8b0, r104, r99);
	_JC_REF_FIELD(env, r99, soot_RefType, className) = r98;
	r103 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r102 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Scene$3451207662ac1af0, r103);
	_JC_INVOKE_VIRTUAL(env, soot_Scene, addRefType$a902a59089ea90da, r102, r99);

label0:
	r3 = _JC_INVOKE_VIRTUAL(env, soot_SootClass, getField$010546eaafd2cba6, r18, r24, r99);
	_JC_ACTIVE_USE(env, soot_jimple_Jimple);
	_JC_LINE_NUMBER(120);				// 1
	r26 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r25 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Jimple$64ac810fbf3d95ea, r26);
	r107 = _JC_STRING(env, "java.lang.Class");
	r110 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r109 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Scene$3451207662ac1af0, r110);
	r108 = _JC_INVOKE_VIRTUAL(env, soot_Scene, getRefType$edcdead019670553, r109, r107);
	if (r108 != _JC_NULL)
		goto label1;
	r108 = _JC_NEW(env, soot_RefType);
	_JC_PRIM_FIELD(env, r108, soot_Type, number) = 0;
	r115 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r114 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Scene$3451207662ac1af0, r115);
	r113 = _JC_INVOKE_VIRTUAL(env, soot_Scene, getTypeNumberer$1a245dd462a8adec, r114);
	_JC_INVOKE_VIRTUAL(env, soot_util_Numberer, add$5470e142c10db8b0, r113, r108);
	_JC_REF_FIELD(env, r108, soot_RefType, className) = r107;
	r112 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r111 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Scene$3451207662ac1af0, r112);
	_JC_INVOKE_VIRTUAL(env, soot_Scene, addRefType$a902a59089ea90da, r111, r108);

label1:
	r4 = _JC_INVOKE_VIRTUAL(env, soot_jimple_Jimple, newLocal$6ee026e3f2189853, r25, _JC_STRING(env, "$r0"), r108);
	_JC_LINE_NUMBER(122);				// 2
	r21 = _JC_INVOKE_VIRTUAL(env, soot_Body, getLocals$7da76f1336483081, r1);
	_JC_INVOKE_INTERFACE(env, r21, _JC_JLONG(0x831f06ee5f59c0cc), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r4);
	_JC_LINE_NUMBER(124);				// 3
	r28 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r27 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Jimple$64ac810fbf3d95ea, r28);
	r5 = _JC_INVOKE_VIRTUAL(env, soot_jimple_Jimple, newStaticFieldRef$29d3aafc212dcf4a, r27, r3);
	_JC_LINE_NUMBER(126);				// 4
	r30 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r29 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Jimple$64ac810fbf3d95ea, r30);
	r6 = _JC_INVOKE_VIRTUAL(env, soot_jimple_Jimple, newAssignStmt$ded64da0f849f837, r29, r4, r5);
	_JC_LINE_NUMBER(128);				// 5
	r22 = _JC_INVOKE_VIRTUAL(env, soot_Body, getUnits$23294b6006422b2b, r1);
	_JC_INVOKE_VIRTUAL(env, soot_PatchingChain, add$831f06ee5f59c0cc, r22, r6);
	_JC_LINE_NUMBER(131);				// 6
	r32 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r31 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Jimple$64ac810fbf3d95ea, r32);
	_JC_ACTIVE_USE(env, soot_jimple_NullConstant);
	r34 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r33 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, NullConstant$c394ae5636aabe48, r34);
	r7 = _JC_INVOKE_VIRTUAL(env, soot_jimple_Jimple, newNeExpr$ae8ef9e7e920c641, r31, r4, r33);
	_JC_LINE_NUMBER(133);				// 7
	r36 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r35 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Jimple$64ac810fbf3d95ea, r36);
	r8 = _JC_INVOKE_VIRTUAL(env, soot_jimple_Jimple, newNopStmt$8356ab16341ed1fc, r35);
	_JC_LINE_NUMBER(135);				// 8
	r38 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r37 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Jimple$64ac810fbf3d95ea, r38);
	r9 = _JC_INVOKE_VIRTUAL(env, soot_jimple_Jimple, newIfStmt$10c8bb64e61c76e9, r37, r7, r8);
	_JC_LINE_NUMBER(136);				// 9
	r22 = _JC_INVOKE_VIRTUAL(env, soot_Body, getUnits$23294b6006422b2b, r1);
	_JC_INVOKE_VIRTUAL(env, soot_PatchingChain, add$831f06ee5f59c0cc, r22, r9);
	_JC_LINE_NUMBER(139);				// 10
	r40 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r39 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Jimple$64ac810fbf3d95ea, r40);
	r116 = _JC_STRING(env, "java.lang.Class");
	r119 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r118 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Scene$3451207662ac1af0, r119);
	r117 = _JC_INVOKE_VIRTUAL(env, soot_Scene, getRefType$edcdead019670553, r118, r116);
	if (r117 != _JC_NULL)
		goto label2;
	r117 = _JC_NEW(env, soot_RefType);
	_JC_PRIM_FIELD(env, r117, soot_Type, number) = 0;
	r124 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r123 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Scene$3451207662ac1af0, r124);
	r122 = _JC_INVOKE_VIRTUAL(env, soot_Scene, getTypeNumberer$1a245dd462a8adec, r123);
	_JC_INVOKE_VIRTUAL(env, soot_util_Numberer, add$5470e142c10db8b0, r122, r117);
	_JC_REF_FIELD(env, r117, soot_RefType, className) = r116;
	r121 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r120 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Scene$3451207662ac1af0, r121);
	_JC_INVOKE_VIRTUAL(env, soot_Scene, addRefType$a902a59089ea90da, r120, r117);

label2:
	r4 = _JC_INVOKE_VIRTUAL(env, soot_jimple_Jimple, newLocal$6ee026e3f2189853, r39, _JC_STRING(env, "$r1"), r117);
	_JC_LINE_NUMBER(141);				// 11
	r21 = _JC_INVOKE_VIRTUAL(env, soot_Body, getLocals$7da76f1336483081, r1);
	_JC_INVOKE_INTERFACE(env, r21, _JC_JLONG(0x831f06ee5f59c0cc), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r4);
	_JC_LINE_NUMBER(143);				// 12
	r10 = _JC_NEW(env, java_util_ArrayList);
	r94 = _JC_NEW_REF_ARRAY(env, java_lang_Object, 1, 16);
	_JC_REF_FIELD(env, r10, java_util_ArrayList, data) = r94;
	_JC_LINE_NUMBER(144);				// 13
	r125 = _JC_STRING(env, "java.lang.String");
	r128 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r127 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Scene$3451207662ac1af0, r128);
	r126 = _JC_INVOKE_VIRTUAL(env, soot_Scene, getRefType$edcdead019670553, r127, r125);
	if (r126 != _JC_NULL)
		goto label3;
	r126 = _JC_NEW(env, soot_RefType);
	_JC_PRIM_FIELD(env, r126, soot_Type, number) = 0;
	r133 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r132 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Scene$3451207662ac1af0, r133);
	r131 = _JC_INVOKE_VIRTUAL(env, soot_Scene, getTypeNumberer$1a245dd462a8adec, r132);
	_JC_INVOKE_VIRTUAL(env, soot_util_Numberer, add$5470e142c10db8b0, r131, r126);
	_JC_REF_FIELD(env, r126, soot_RefType, className) = r125;
	r130 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r129 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Scene$3451207662ac1af0, r130);
	_JC_INVOKE_VIRTUAL(env, soot_Scene, addRefType$a902a59089ea90da, r129, r126);

label3:
	_JC_INVOKE_NONVIRTUAL(env, java_util_ArrayList, add$831f06ee5f59c0cc, 0, r10, r126);
	_JC_LINE_NUMBER(146);				// 14
	r11 = _JC_INVOKE_VIRTUAL(env, soot_Body, getMethod$04d7c221deab35ce, r1);
	r19 = _JC_INVOKE_VIRTUAL(env, soot_SootMethod, getDeclaringClass$dd2382a1f7813acf, r11);
	r134 = _JC_STRING(env, "java.lang.Class");
	r137 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r136 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Scene$3451207662ac1af0, r137);
	r135 = _JC_INVOKE_VIRTUAL(env, soot_Scene, getRefType$edcdead019670553, r136, r134);
	if (r135 != _JC_NULL)
		goto label4;
	r135 = _JC_NEW(env, soot_RefType);
	_JC_PRIM_FIELD(env, r135, soot_Type, number) = 0;
	r143 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r142 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Scene$3451207662ac1af0, r143);
	r140 = _JC_INVOKE_VIRTUAL(env, soot_Scene, getTypeNumberer$1a245dd462a8adec, r142);
	_JC_INVOKE_VIRTUAL(env, soot_util_Numberer, add$5470e142c10db8b0, r140, r135);
	_JC_REF_FIELD(env, r135, soot_RefType, className) = r134;
	r139 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r138 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Scene$3451207662ac1af0, r139);
	_JC_INVOKE_VIRTUAL(env, soot_Scene, addRefType$a902a59089ea90da, r138, r135);

label4:
	r11 = _JC_INVOKE_VIRTUAL(env, soot_SootClass, getMethod$8a4c24f1e0c98409, r19, _JC_STRING(env, "class$"), r10, r135);
	_JC_LINE_NUMBER(148);				// 15
	r10 = _JC_NEW(env, java_util_ArrayList);
	r95 = _JC_NEW_REF_ARRAY(env, java_lang_Object, 1, 16);
	_JC_REF_FIELD(env, r10, java_util_ArrayList, data) = r95;
	_JC_LINE_NUMBER(149);				// 16
	r23 = _JC_INVOKE_VIRTUAL(env, soot_Body, getMethod$04d7c221deab35ce, r1);
	r19 = _JC_INVOKE_VIRTUAL(env, soot_SootMethod, getDeclaringClass$dd2382a1f7813acf, r23);
	r20 = _JC_INVOKE_VIRTUAL(env, soot_SootClass, getName$bec186f2ce7e1882, r19);
	_JC_ACTIVE_USE(env, soot_jimple_StringConstant);
	r41 = _JC_NEW(env, soot_jimple_StringConstant);
	_JC_REF_FIELD(env, r41, soot_jimple_StringConstant, value) = r20;
	_JC_INVOKE_NONVIRTUAL(env, java_util_ArrayList, add$831f06ee5f59c0cc, 0, r10, r41);
	_JC_LINE_NUMBER(150);				// 17
	r43 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r42 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Jimple$64ac810fbf3d95ea, r43);
	r12 = _JC_INVOKE_VIRTUAL(env, soot_jimple_Jimple, newStaticInvokeExpr$9f5c4d166248f61a, r42, r11, r10);
	_JC_LINE_NUMBER(152);				// 18
	r45 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r44 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Jimple$64ac810fbf3d95ea, r45);
	r6 = _JC_INVOKE_VIRTUAL(env, soot_jimple_Jimple, newAssignStmt$ded64da0f849f837, r44, r4, r12);
	_JC_LINE_NUMBER(154);				// 19
	r22 = _JC_INVOKE_VIRTUAL(env, soot_Body, getUnits$23294b6006422b2b, r1);
	_JC_INVOKE_VIRTUAL(env, soot_PatchingChain, add$831f06ee5f59c0cc, r22, r6);
	_JC_LINE_NUMBER(157);				// 20
	r47 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r46 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Jimple$64ac810fbf3d95ea, r47);
	r6 = _JC_INVOKE_VIRTUAL(env, soot_jimple_Jimple, newAssignStmt$ded64da0f849f837, r46, r5, r4);
	_JC_LINE_NUMBER(159);				// 21
	r22 = _JC_INVOKE_VIRTUAL(env, soot_Body, getUnits$23294b6006422b2b, r1);
	_JC_INVOKE_VIRTUAL(env, soot_PatchingChain, add$831f06ee5f59c0cc, r22, r6);
	_JC_LINE_NUMBER(161);				// 22
	r49 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r48 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Jimple$64ac810fbf3d95ea, r49);
	r13 = _JC_INVOKE_VIRTUAL(env, soot_jimple_Jimple, newNopStmt$8356ab16341ed1fc, r48);
	_JC_LINE_NUMBER(163);				// 23
	r51 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r50 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Jimple$64ac810fbf3d95ea, r51);
	r14 = _JC_INVOKE_VIRTUAL(env, soot_jimple_Jimple, newGotoStmt$149367e4a4827b03, r50, r13);
	_JC_LINE_NUMBER(165);				// 24
	r22 = _JC_INVOKE_VIRTUAL(env, soot_Body, getUnits$23294b6006422b2b, r1);
	_JC_INVOKE_VIRTUAL(env, soot_PatchingChain, add$831f06ee5f59c0cc, r22, r14);
	_JC_LINE_NUMBER(167);				// 25
	r22 = _JC_INVOKE_VIRTUAL(env, soot_Body, getUnits$23294b6006422b2b, r1);
	_JC_INVOKE_VIRTUAL(env, soot_PatchingChain, add$831f06ee5f59c0cc, r22, r8);
	_JC_LINE_NUMBER(169);				// 26
	r53 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r52 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Jimple$64ac810fbf3d95ea, r53);
	r6 = _JC_INVOKE_VIRTUAL(env, soot_jimple_Jimple, newAssignStmt$ded64da0f849f837, r52, r4, r5);
	_JC_LINE_NUMBER(171);				// 27
	r22 = _JC_INVOKE_VIRTUAL(env, soot_Body, getUnits$23294b6006422b2b, r1);
	_JC_INVOKE_VIRTUAL(env, soot_PatchingChain, add$831f06ee5f59c0cc, r22, r6);
	_JC_LINE_NUMBER(173);				// 28
	r22 = _JC_INVOKE_VIRTUAL(env, soot_Body, getUnits$23294b6006422b2b, r1);
	_JC_INVOKE_VIRTUAL(env, soot_PatchingChain, add$831f06ee5f59c0cc, r22, r13);
	_JC_LINE_NUMBER(176);				// 29
	r55 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r54 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Jimple$64ac810fbf3d95ea, r55);
	_JC_ACTIVE_USE(env, soot_BooleanType);
	r57 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r56 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, BooleanType$3bed763c50a785c2, r57);
	r15 = _JC_INVOKE_VIRTUAL(env, soot_jimple_Jimple, newLocal$6ee026e3f2189853, r54, _JC_STRING(env, "$z0"), r56);
	_JC_LINE_NUMBER(177);				// 30
	r21 = _JC_INVOKE_VIRTUAL(env, soot_Body, getLocals$7da76f1336483081, r1);
	_JC_INVOKE_INTERFACE(env, r21, _JC_JLONG(0x831f06ee5f59c0cc), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r15);
	_JC_LINE_NUMBER(178);				// 31
	r59 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r58 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Jimple$64ac810fbf3d95ea, r59);
	r61 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r60 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, BooleanType$3bed763c50a785c2, r61);
	r16 = _JC_INVOKE_VIRTUAL(env, soot_jimple_Jimple, newLocal$6ee026e3f2189853, r58, _JC_STRING(env, "$z1"), r60);
	_JC_LINE_NUMBER(179);				// 32
	r21 = _JC_INVOKE_VIRTUAL(env, soot_Body, getLocals$7da76f1336483081, r1);
	_JC_INVOKE_INTERFACE(env, r21, _JC_JLONG(0x831f06ee5f59c0cc), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r16);
	_JC_LINE_NUMBER(182);				// 33
	r63 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r62 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Scene$3451207662ac1af0, r63);
	r19 = _JC_INVOKE_VIRTUAL(env, soot_Scene, getSootClass$9c5bf81fa0a8b0da, r62, _JC_STRING(env, "java.lang.Class"));
	r10 = _JC_NEW(env, java_util_ArrayList);
	r96 = _JC_NEW_REF_ARRAY(env, java_lang_Object, 1, 16);
	_JC_REF_FIELD(env, r10, java_util_ArrayList, data) = r96;
	r65 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r64 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, BooleanType$3bed763c50a785c2, r65);
	r11 = _JC_INVOKE_VIRTUAL(env, soot_SootClass, getMethod$8a4c24f1e0c98409, r19, _JC_STRING(env, "desiredAssertionStatus"), r10, r64);
	_JC_LINE_NUMBER(183);				// 34
	r67 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r66 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Jimple$64ac810fbf3d95ea, r67);
	r10 = _JC_NEW(env, java_util_ArrayList);
	r97 = _JC_NEW_REF_ARRAY(env, java_lang_Object, 1, 16);
	_JC_REF_FIELD(env, r10, java_util_ArrayList, data) = r97;
	r17 = _JC_INVOKE_VIRTUAL(env, soot_jimple_Jimple, newVirtualInvokeExpr$4a4490367e46214f, r66, r4, r11, r10);
	_JC_LINE_NUMBER(187);				// 35
	r69 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r68 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Jimple$64ac810fbf3d95ea, r69);
	r6 = _JC_INVOKE_VIRTUAL(env, soot_jimple_Jimple, newAssignStmt$ded64da0f849f837, r68, r15, r17);
	_JC_LINE_NUMBER(189);				// 36
	r22 = _JC_INVOKE_VIRTUAL(env, soot_Body, getUnits$23294b6006422b2b, r1);
	_JC_INVOKE_VIRTUAL(env, soot_PatchingChain, add$831f06ee5f59c0cc, r22, r6);
	_JC_LINE_NUMBER(192);				// 37
	r71 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r70 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Jimple$64ac810fbf3d95ea, r71);
	_JC_ACTIVE_USE(env, soot_jimple_IntConstant);
	r72 = _JC_NEW(env, soot_jimple_IntConstant);
	_JC_PRIM_FIELD(env, r72, soot_jimple_IntConstant, value) = 0;
	r7 = _JC_INVOKE_VIRTUAL(env, soot_jimple_Jimple, newNeExpr$ae8ef9e7e920c641, r70, r15, r72);
	_JC_LINE_NUMBER(194);				// 38
	r74 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r73 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Jimple$64ac810fbf3d95ea, r74);
	r13 = _JC_INVOKE_VIRTUAL(env, soot_jimple_Jimple, newNopStmt$8356ab16341ed1fc, r73);
	_JC_LINE_NUMBER(196);				// 39
	r76 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r75 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Jimple$64ac810fbf3d95ea, r76);
	r9 = _JC_INVOKE_VIRTUAL(env, soot_jimple_Jimple, newIfStmt$10c8bb64e61c76e9, r75, r7, r13);
	_JC_LINE_NUMBER(197);				// 40
	r22 = _JC_INVOKE_VIRTUAL(env, soot_Body, getUnits$23294b6006422b2b, r1);
	_JC_INVOKE_VIRTUAL(env, soot_PatchingChain, add$831f06ee5f59c0cc, r22, r9);
	_JC_LINE_NUMBER(200);				// 41
	r78 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r77 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Jimple$64ac810fbf3d95ea, r78);
	r79 = _JC_NEW(env, soot_jimple_IntConstant);
	_JC_PRIM_FIELD(env, r79, soot_jimple_IntConstant, value) = 1;
	r6 = _JC_INVOKE_VIRTUAL(env, soot_jimple_Jimple, newAssignStmt$ded64da0f849f837, r77, r16, r79);
	_JC_LINE_NUMBER(202);				// 42
	r22 = _JC_INVOKE_VIRTUAL(env, soot_Body, getUnits$23294b6006422b2b, r1);
	_JC_INVOKE_VIRTUAL(env, soot_PatchingChain, add$831f06ee5f59c0cc, r22, r6);
	_JC_LINE_NUMBER(204);				// 43
	r81 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r80 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Jimple$64ac810fbf3d95ea, r81);
	r8 = _JC_INVOKE_VIRTUAL(env, soot_jimple_Jimple, newNopStmt$8356ab16341ed1fc, r80);
	_JC_LINE_NUMBER(206);				// 44
	r83 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r82 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Jimple$64ac810fbf3d95ea, r83);
	r14 = _JC_INVOKE_VIRTUAL(env, soot_jimple_Jimple, newGotoStmt$149367e4a4827b03, r82, r8);
	_JC_LINE_NUMBER(208);				// 45
	r22 = _JC_INVOKE_VIRTUAL(env, soot_Body, getUnits$23294b6006422b2b, r1);
	_JC_INVOKE_VIRTUAL(env, soot_PatchingChain, add$831f06ee5f59c0cc, r22, r14);
	_JC_LINE_NUMBER(210);				// 46
	r22 = _JC_INVOKE_VIRTUAL(env, soot_Body, getUnits$23294b6006422b2b, r1);
	_JC_INVOKE_VIRTUAL(env, soot_PatchingChain, add$831f06ee5f59c0cc, r22, r13);
	_JC_LINE_NUMBER(212);				// 47
	r85 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r84 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Jimple$64ac810fbf3d95ea, r85);
	r86 = _JC_NEW(env, soot_jimple_IntConstant);
	_JC_PRIM_FIELD(env, r86, soot_jimple_IntConstant, value) = 0;
	r6 = _JC_INVOKE_VIRTUAL(env, soot_jimple_Jimple, newAssignStmt$ded64da0f849f837, r84, r16, r86);
	_JC_LINE_NUMBER(214);				// 48
	r22 = _JC_INVOKE_VIRTUAL(env, soot_Body, getUnits$23294b6006422b2b, r1);
	_JC_INVOKE_VIRTUAL(env, soot_PatchingChain, add$831f06ee5f59c0cc, r22, r6);
	_JC_LINE_NUMBER(216);				// 49
	r22 = _JC_INVOKE_VIRTUAL(env, soot_Body, getUnits$23294b6006422b2b, r1);
	_JC_INVOKE_VIRTUAL(env, soot_PatchingChain, add$831f06ee5f59c0cc, r22, r8);
	_JC_LINE_NUMBER(219);				// 50
	r23 = _JC_INVOKE_VIRTUAL(env, soot_Body, getMethod$04d7c221deab35ce, r1);
	r19 = _JC_INVOKE_VIRTUAL(env, soot_SootMethod, getDeclaringClass$dd2382a1f7813acf, r23);
	r88 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r87 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, BooleanType$3bed763c50a785c2, r88);
	r3 = _JC_INVOKE_VIRTUAL(env, soot_SootClass, getField$010546eaafd2cba6, r19, _JC_STRING(env, "$assertionsDisabled"), r87);
	_JC_LINE_NUMBER(221);				// 51
	r90 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r89 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Jimple$64ac810fbf3d95ea, r90);
	r5 = _JC_INVOKE_VIRTUAL(env, soot_jimple_Jimple, newStaticFieldRef$29d3aafc212dcf4a, r89, r3);
	_JC_LINE_NUMBER(222);				// 52
	r92 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r91 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Jimple$64ac810fbf3d95ea, r92);
	r6 = _JC_INVOKE_VIRTUAL(env, soot_jimple_Jimple, newAssignStmt$ded64da0f849f837, r91, r5, r16);
	_JC_LINE_NUMBER(223);				// 53
	r22 = _JC_INVOKE_VIRTUAL(env, soot_Body, getUnits$23294b6006422b2b, r1);
	_JC_INVOKE_VIRTUAL(env, soot_PatchingChain, add$831f06ee5f59c0cc, r22, r6);
	_JC_LINE_NUMBER(225);				// 54
	return;
}

//
// public java.util.HashMap getAnonClassMap()
//

static _jc_linenum _jc_soot_javaToJimple_PolyglotMethodSource$linenum_table$getAnonClassMap$a08d4705763dc080[];

static const unsigned char _jc_soot_javaToJimple_PolyglotMethodSource$param_ptypes$getAnonClassMap$a08d4705763dc080[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_soot_javaToJimple_PolyglotMethodSource$method_info$getAnonClassMap$a08d4705763dc080 = {
	.name=			"getAnonClassMap",
	.signature=		"()Ljava/util/HashMap;",
	.class=			&_jc_soot_javaToJimple_PolyglotMethodSource$type,
	.return_type=		&_jc_java_util_HashMap$type,
	.param_ptypes=		&_jc_soot_javaToJimple_PolyglotMethodSource$param_ptypes$getAnonClassMap$a08d4705763dc080,
	.signature_hash=	_JC_JLONG(0xa08d4705763dc080),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_javaToJimple_PolyglotMethodSource$method$getAnonClassMap$a08d4705763dc080,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_javaToJimple_PolyglotMethodSource$vtable, soot_javaToJimple_PolyglotMethodSource.getAnonClassMap$a08d4705763dc080) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_soot_javaToJimple_PolyglotMethodSource$linenum_table$getAnonClassMap$a08d4705763dc080
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_javaToJimple_PolyglotMethodSource, getAnonClassMap$a08d4705763dc080);

_jc_java_util_HashMap$object * _JC_JCNI_ATTR
_jc_soot_javaToJimple_PolyglotMethodSource$method$getAnonClassMap$a08d4705763dc080(_jc_env *const env, _jc_soot_javaToJimple_PolyglotMethodSource$object *this)
{
	struct _jc_soot_javaToJimple_PolyglotMethodSource$object *r0;
	struct _jc_java_util_HashMap$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(103);				// 0
	r1 = _JC_REF_FIELD(env, r0, soot_javaToJimple_PolyglotMethodSource, anonClassMap);
	return r1;
}

//
// public soot.Body getBody(soot.SootMethod, java.lang.String)
//

static _jc_linenum _jc_soot_javaToJimple_PolyglotMethodSource$linenum_table$getBody$01a871f1d690f082[];

static const unsigned char _jc_soot_javaToJimple_PolyglotMethodSource$param_ptypes$getBody$01a871f1d690f082[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_soot_javaToJimple_PolyglotMethodSource$param_types$getBody$01a871f1d690f082[] = {
	&_jc_soot_SootMethod$type,
	&_jc_java_lang_String$type
};

_jc_method _jc_soot_javaToJimple_PolyglotMethodSource$method_info$getBody$01a871f1d690f082 = {
	.name=			"getBody",
	.signature=		"(Lsoot/SootMethod;Ljava/lang/String;)Lsoot/Body;",
	.class=			&_jc_soot_javaToJimple_PolyglotMethodSource$type,
	.param_types=		&_jc_soot_javaToJimple_PolyglotMethodSource$param_types$getBody$01a871f1d690f082,
	.return_type=		&_jc_soot_Body$type,
	.param_ptypes=		&_jc_soot_javaToJimple_PolyglotMethodSource$param_ptypes$getBody$01a871f1d690f082,
	.signature_hash=	_JC_JLONG(0x1a871f1d690f082),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_javaToJimple_PolyglotMethodSource$method$getBody$01a871f1d690f082,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_javaToJimple_PolyglotMethodSource$vtable, soot_javaToJimple_PolyglotMethodSource.getBody$01a871f1d690f082) / sizeof(void *),
	.num_parameters=	2,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_soot_javaToJimple_PolyglotMethodSource$linenum_table$getBody$01a871f1d690f082
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_javaToJimple_PolyglotMethodSource, getBody$01a871f1d690f082);

_jc_soot_Body$object * _JC_JCNI_ATTR
_jc_soot_javaToJimple_PolyglotMethodSource$method$getBody$01a871f1d690f082(_jc_env *const env, _jc_soot_javaToJimple_PolyglotMethodSource$object *this, _jc_soot_SootMethod$object *param0, _jc_java_lang_String$object *param1)
{
	struct _jc_soot_javaToJimple_PolyglotMethodSource$object *r0;
	struct _jc_soot_SootMethod$object *r1;
	struct _jc_object *r10;
	struct _jc_soot_PhaseOptions$object *r12;
	struct _jc_soot_G$object *r13;
	struct _jc_java_lang_String$object *r2;
	struct _jc_soot_javaToJimple_JimpleBodyBuilder$object *r3;
	struct _jc_soot_jimple_JimpleBody$object *r4;
	struct _jc_object *r5;
	struct _jc_object *r6;
	struct _jc_soot_Pack$object *r7;
	struct _jc_soot_PackManager$object *r8;
	struct _jc_soot_G$object *r9;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_LINE_NUMBER(34);				// 0
	r3 = _JC_NEW(env, soot_javaToJimple_JimpleBodyBuilder);
	_JC_INVOKE_NONVIRTUAL(env, soot_javaToJimple_JimpleBodyBuilder, _init$52f4ad9f2989aeee, 0, r3);
	_JC_LINE_NUMBER(35);				// 1
	r5 = _JC_REF_FIELD(env, r0, soot_javaToJimple_PolyglotMethodSource, block);
	r6 = _JC_REF_FIELD(env, r0, soot_javaToJimple_PolyglotMethodSource, formals);
	r4 = _JC_INVOKE_NONVIRTUAL(env, soot_javaToJimple_JimpleBodyBuilder, createJimpleBody$6265d4a80903ebe9, 0, r3, r5, r6, r1);
	_JC_ACTIVE_USE(env, soot_PackManager);
	_JC_ACTIVE_USE(env, soot_G);
	_JC_LINE_NUMBER(38);				// 2
	r9 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r8 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, PackManager$f2bada0037eb90c5, r9);
	r7 = _JC_INVOKE_VIRTUAL(env, soot_PackManager, getPack$6735ab42980f6e31, r8, _JC_STRING(env, "jj"));
	_JC_EXPLICIT_NULL_CHECK(env, r7);
	_JC_ACTIVE_USE(env, soot_PhaseOptions);
	r13 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r12 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, PhaseOptions$d2c6fe46cb681ad2, r13);
	r10 = _JC_INVOKE_VIRTUAL(env, soot_PhaseOptions, getPhaseOptions$b11eaf04f63d7605, r12, r7);
	z0 = _JC_INVOKE_STATIC(env, soot_PhaseOptions, getBoolean$ead81019472b42dd, 1, r10, _JC_STRING(env, "enabled"));
	if (z0 != 0)
		goto label0;
	goto label1;

label0:
	_JC_INVOKE_VIRTUAL(env, soot_Pack, internalApply$8c8b8fe09b775776, r7, r4);

label1:
	_JC_LINE_NUMBER(39);				// 3
	return r4;
}

//
// public java.util.ArrayList getFieldInits()
//

static _jc_linenum _jc_soot_javaToJimple_PolyglotMethodSource$linenum_table$getFieldInits$4f8fee8f6fc75f9d[];

static const unsigned char _jc_soot_javaToJimple_PolyglotMethodSource$param_ptypes$getFieldInits$4f8fee8f6fc75f9d[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_soot_javaToJimple_PolyglotMethodSource$method_info$getFieldInits$4f8fee8f6fc75f9d = {
	.name=			"getFieldInits",
	.signature=		"()Ljava/util/ArrayList;",
	.class=			&_jc_soot_javaToJimple_PolyglotMethodSource$type,
	.return_type=		&_jc_java_util_ArrayList$type,
	.param_ptypes=		&_jc_soot_javaToJimple_PolyglotMethodSource$param_ptypes$getFieldInits$4f8fee8f6fc75f9d,
	.signature_hash=	_JC_JLONG(0x4f8fee8f6fc75f9d),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_javaToJimple_PolyglotMethodSource$method$getFieldInits$4f8fee8f6fc75f9d,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_javaToJimple_PolyglotMethodSource$vtable, soot_javaToJimple_PolyglotMethodSource.getFieldInits$4f8fee8f6fc75f9d) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_soot_javaToJimple_PolyglotMethodSource$linenum_table$getFieldInits$4f8fee8f6fc75f9d
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_javaToJimple_PolyglotMethodSource, getFieldInits$4f8fee8f6fc75f9d);

_jc_java_util_ArrayList$object * _JC_JCNI_ATTR
_jc_soot_javaToJimple_PolyglotMethodSource$method$getFieldInits$4f8fee8f6fc75f9d(_jc_env *const env, _jc_soot_javaToJimple_PolyglotMethodSource$object *this)
{
	struct _jc_soot_javaToJimple_PolyglotMethodSource$object *r0;
	struct _jc_java_util_ArrayList$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(51);				// 0
	r1 = _JC_REF_FIELD(env, r0, soot_javaToJimple_PolyglotMethodSource, fieldInits);
	return r1;
}

//
// public java.util.HashMap getFinalsMap()
//

static _jc_linenum _jc_soot_javaToJimple_PolyglotMethodSource$linenum_table$getFinalsMap$c1b0fd04314bd552[];

static const unsigned char _jc_soot_javaToJimple_PolyglotMethodSource$param_ptypes$getFinalsMap$c1b0fd04314bd552[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_soot_javaToJimple_PolyglotMethodSource$method_info$getFinalsMap$c1b0fd04314bd552 = {
	.name=			"getFinalsMap",
	.signature=		"()Ljava/util/HashMap;",
	.class=			&_jc_soot_javaToJimple_PolyglotMethodSource$type,
	.return_type=		&_jc_java_util_HashMap$type,
	.param_ptypes=		&_jc_soot_javaToJimple_PolyglotMethodSource$param_ptypes$getFinalsMap$c1b0fd04314bd552,
	.signature_hash=	_JC_JLONG(0xc1b0fd04314bd552),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_javaToJimple_PolyglotMethodSource$method$getFinalsMap$c1b0fd04314bd552,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_javaToJimple_PolyglotMethodSource$vtable, soot_javaToJimple_PolyglotMethodSource.getFinalsMap$c1b0fd04314bd552) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_soot_javaToJimple_PolyglotMethodSource$linenum_table$getFinalsMap$c1b0fd04314bd552
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_javaToJimple_PolyglotMethodSource, getFinalsMap$c1b0fd04314bd552);

_jc_java_util_HashMap$object * _JC_JCNI_ATTR
_jc_soot_javaToJimple_PolyglotMethodSource$method$getFinalsMap$c1b0fd04314bd552(_jc_env *const env, _jc_soot_javaToJimple_PolyglotMethodSource$object *this)
{
	struct _jc_soot_javaToJimple_PolyglotMethodSource$object *r0;
	struct _jc_java_util_HashMap$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(232);				// 0
	r1 = _JC_REF_FIELD(env, r0, soot_javaToJimple_PolyglotMethodSource, finalsMap);
	return r1;
}

//
// public java.util.ArrayList getInitializerBlocks()
//

static _jc_linenum _jc_soot_javaToJimple_PolyglotMethodSource$linenum_table$getInitializerBlocks$1d66416ccde921e4[];

static const unsigned char _jc_soot_javaToJimple_PolyglotMethodSource$param_ptypes$getInitializerBlocks$1d66416ccde921e4[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_soot_javaToJimple_PolyglotMethodSource$method_info$getInitializerBlocks$1d66416ccde921e4 = {
	.name=			"getInitializerBlocks",
	.signature=		"()Ljava/util/ArrayList;",
	.class=			&_jc_soot_javaToJimple_PolyglotMethodSource$type,
	.return_type=		&_jc_java_util_ArrayList$type,
	.param_ptypes=		&_jc_soot_javaToJimple_PolyglotMethodSource$param_ptypes$getInitializerBlocks$1d66416ccde921e4,
	.signature_hash=	_JC_JLONG(0x1d66416ccde921e4),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_javaToJimple_PolyglotMethodSource$method$getInitializerBlocks$1d66416ccde921e4,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_javaToJimple_PolyglotMethodSource$vtable, soot_javaToJimple_PolyglotMethodSource.getInitializerBlocks$1d66416ccde921e4) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_soot_javaToJimple_PolyglotMethodSource$linenum_table$getInitializerBlocks$1d66416ccde921e4
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_javaToJimple_PolyglotMethodSource, getInitializerBlocks$1d66416ccde921e4);

_jc_java_util_ArrayList$object * _JC_JCNI_ATTR
_jc_soot_javaToJimple_PolyglotMethodSource$method$getInitializerBlocks$1d66416ccde921e4(_jc_env *const env, _jc_soot_javaToJimple_PolyglotMethodSource$object *this)
{
	struct _jc_soot_javaToJimple_PolyglotMethodSource$object *r0;
	struct _jc_java_util_ArrayList$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(71);				// 0
	r1 = _JC_REF_FIELD(env, r0, soot_javaToJimple_PolyglotMethodSource, initializerBlocks);
	return r1;
}

//
// public java.util.HashMap getLocalClassMap()
//

static _jc_linenum _jc_soot_javaToJimple_PolyglotMethodSource$linenum_table$getLocalClassMap$dbf54bf000bac9ab[];

static const unsigned char _jc_soot_javaToJimple_PolyglotMethodSource$param_ptypes$getLocalClassMap$dbf54bf000bac9ab[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_soot_javaToJimple_PolyglotMethodSource$method_info$getLocalClassMap$dbf54bf000bac9ab = {
	.name=			"getLocalClassMap",
	.signature=		"()Ljava/util/HashMap;",
	.class=			&_jc_soot_javaToJimple_PolyglotMethodSource$type,
	.return_type=		&_jc_java_util_HashMap$type,
	.param_ptypes=		&_jc_soot_javaToJimple_PolyglotMethodSource$param_ptypes$getLocalClassMap$dbf54bf000bac9ab,
	.signature_hash=	_JC_JLONG(0xdbf54bf000bac9ab),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_javaToJimple_PolyglotMethodSource$method$getLocalClassMap$dbf54bf000bac9ab,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_javaToJimple_PolyglotMethodSource$vtable, soot_javaToJimple_PolyglotMethodSource.getLocalClassMap$dbf54bf000bac9ab) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_soot_javaToJimple_PolyglotMethodSource$linenum_table$getLocalClassMap$dbf54bf000bac9ab
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_javaToJimple_PolyglotMethodSource, getLocalClassMap$dbf54bf000bac9ab);

_jc_java_util_HashMap$object * _JC_JCNI_ATTR
_jc_soot_javaToJimple_PolyglotMethodSource$method$getLocalClassMap$dbf54bf000bac9ab(_jc_env *const env, _jc_soot_javaToJimple_PolyglotMethodSource$object *this)
{
	struct _jc_soot_javaToJimple_PolyglotMethodSource$object *r0;
	struct _jc_java_util_HashMap$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(95);				// 0
	r1 = _JC_REF_FIELD(env, r0, soot_javaToJimple_PolyglotMethodSource, localClassMap);
	return r1;
}

//
// public java.util.HashMap getNewToOuterMap()
//

static _jc_linenum _jc_soot_javaToJimple_PolyglotMethodSource$linenum_table$getNewToOuterMap$fc8a419e3350f1bb[];

static const unsigned char _jc_soot_javaToJimple_PolyglotMethodSource$param_ptypes$getNewToOuterMap$fc8a419e3350f1bb[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_soot_javaToJimple_PolyglotMethodSource$method_info$getNewToOuterMap$fc8a419e3350f1bb = {
	.name=			"getNewToOuterMap",
	.signature=		"()Ljava/util/HashMap;",
	.class=			&_jc_soot_javaToJimple_PolyglotMethodSource$type,
	.return_type=		&_jc_java_util_HashMap$type,
	.param_ptypes=		&_jc_soot_javaToJimple_PolyglotMethodSource$param_ptypes$getNewToOuterMap$fc8a419e3350f1bb,
	.signature_hash=	_JC_JLONG(0xfc8a419e3350f1bb),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_javaToJimple_PolyglotMethodSource$method$getNewToOuterMap$fc8a419e3350f1bb,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_javaToJimple_PolyglotMethodSource$vtable, soot_javaToJimple_PolyglotMethodSource.getNewToOuterMap$fc8a419e3350f1bb) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_soot_javaToJimple_PolyglotMethodSource$linenum_table$getNewToOuterMap$fc8a419e3350f1bb
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_javaToJimple_PolyglotMethodSource, getNewToOuterMap$fc8a419e3350f1bb);

_jc_java_util_HashMap$object * _JC_JCNI_ATTR
_jc_soot_javaToJimple_PolyglotMethodSource$method$getNewToOuterMap$fc8a419e3350f1bb(_jc_env *const env, _jc_soot_javaToJimple_PolyglotMethodSource$object *this)
{
	struct _jc_soot_javaToJimple_PolyglotMethodSource$object *r0;
	struct _jc_java_util_HashMap$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(240);				// 0
	r1 = _JC_REF_FIELD(env, r0, soot_javaToJimple_PolyglotMethodSource, newToOuterMap);
	return r1;
}

//
// public soot.Local getOuterClassThisInit()
//

static _jc_linenum _jc_soot_javaToJimple_PolyglotMethodSource$linenum_table$getOuterClassThisInit$b2a175dcbe1d6040[];

static const unsigned char _jc_soot_javaToJimple_PolyglotMethodSource$param_ptypes$getOuterClassThisInit$b2a175dcbe1d6040[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_soot_javaToJimple_PolyglotMethodSource$method_info$getOuterClassThisInit$b2a175dcbe1d6040 = {
	.name=			"getOuterClassThisInit",
	.signature=		"()Lsoot/Local;",
	.class=			&_jc_soot_javaToJimple_PolyglotMethodSource$type,
	.return_type=		&_jc_soot_Local$type,
	.param_ptypes=		&_jc_soot_javaToJimple_PolyglotMethodSource$param_ptypes$getOuterClassThisInit$b2a175dcbe1d6040,
	.signature_hash=	_JC_JLONG(0xb2a175dcbe1d6040),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_javaToJimple_PolyglotMethodSource$method$getOuterClassThisInit$b2a175dcbe1d6040,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_javaToJimple_PolyglotMethodSource$vtable, soot_javaToJimple_PolyglotMethodSource.getOuterClassThisInit$b2a175dcbe1d6040) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_soot_javaToJimple_PolyglotMethodSource$linenum_table$getOuterClassThisInit$b2a175dcbe1d6040
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_javaToJimple_PolyglotMethodSource, getOuterClassThisInit$b2a175dcbe1d6040);

_jc_object * _JC_JCNI_ATTR
_jc_soot_javaToJimple_PolyglotMethodSource$method$getOuterClassThisInit$b2a175dcbe1d6040(_jc_env *const env, _jc_soot_javaToJimple_PolyglotMethodSource$object *this)
{
	struct _jc_soot_javaToJimple_PolyglotMethodSource$object *r0;
	struct _jc_object *r1;

	r0 = this;
	_JC_LINE_NUMBER(79);				// 0
	r1 = _JC_REF_FIELD(env, r0, soot_javaToJimple_PolyglotMethodSource, outerClassThisInit);
	return r1;
}

//
// public java.util.HashMap getPrivateAccessMap()
//

static _jc_linenum _jc_soot_javaToJimple_PolyglotMethodSource$linenum_table$getPrivateAccessMap$d4f71f0f6e18ab15[];

static const unsigned char _jc_soot_javaToJimple_PolyglotMethodSource$param_ptypes$getPrivateAccessMap$d4f71f0f6e18ab15[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_soot_javaToJimple_PolyglotMethodSource$method_info$getPrivateAccessMap$d4f71f0f6e18ab15 = {
	.name=			"getPrivateAccessMap",
	.signature=		"()Ljava/util/HashMap;",
	.class=			&_jc_soot_javaToJimple_PolyglotMethodSource$type,
	.return_type=		&_jc_java_util_HashMap$type,
	.param_ptypes=		&_jc_soot_javaToJimple_PolyglotMethodSource$param_ptypes$getPrivateAccessMap$d4f71f0f6e18ab15,
	.signature_hash=	_JC_JLONG(0xd4f71f0f6e18ab15),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_javaToJimple_PolyglotMethodSource$method$getPrivateAccessMap$d4f71f0f6e18ab15,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_javaToJimple_PolyglotMethodSource$vtable, soot_javaToJimple_PolyglotMethodSource.getPrivateAccessMap$d4f71f0f6e18ab15) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_soot_javaToJimple_PolyglotMethodSource$linenum_table$getPrivateAccessMap$d4f71f0f6e18ab15
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_javaToJimple_PolyglotMethodSource, getPrivateAccessMap$d4f71f0f6e18ab15);

_jc_java_util_HashMap$object * _JC_JCNI_ATTR
_jc_soot_javaToJimple_PolyglotMethodSource$method$getPrivateAccessMap$d4f71f0f6e18ab15(_jc_env *const env, _jc_soot_javaToJimple_PolyglotMethodSource$object *this)
{
	struct _jc_soot_javaToJimple_PolyglotMethodSource$object *r0;
	struct _jc_java_util_HashMap$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(87);				// 0
	r1 = _JC_REF_FIELD(env, r0, soot_javaToJimple_PolyglotMethodSource, privateAccessMap);
	return r1;
}

//
// public java.util.ArrayList getStaticFieldInits()
//

static _jc_linenum _jc_soot_javaToJimple_PolyglotMethodSource$linenum_table$getStaticFieldInits$5460da09a6343b5b[];

static const unsigned char _jc_soot_javaToJimple_PolyglotMethodSource$param_ptypes$getStaticFieldInits$5460da09a6343b5b[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_soot_javaToJimple_PolyglotMethodSource$method_info$getStaticFieldInits$5460da09a6343b5b = {
	.name=			"getStaticFieldInits",
	.signature=		"()Ljava/util/ArrayList;",
	.class=			&_jc_soot_javaToJimple_PolyglotMethodSource$type,
	.return_type=		&_jc_java_util_ArrayList$type,
	.param_ptypes=		&_jc_soot_javaToJimple_PolyglotMethodSource$param_ptypes$getStaticFieldInits$5460da09a6343b5b,
	.signature_hash=	_JC_JLONG(0x5460da09a6343b5b),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_javaToJimple_PolyglotMethodSource$method$getStaticFieldInits$5460da09a6343b5b,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_javaToJimple_PolyglotMethodSource$vtable, soot_javaToJimple_PolyglotMethodSource.getStaticFieldInits$5460da09a6343b5b) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_soot_javaToJimple_PolyglotMethodSource$linenum_table$getStaticFieldInits$5460da09a6343b5b
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_javaToJimple_PolyglotMethodSource, getStaticFieldInits$5460da09a6343b5b);

_jc_java_util_ArrayList$object * _JC_JCNI_ATTR
_jc_soot_javaToJimple_PolyglotMethodSource$method$getStaticFieldInits$5460da09a6343b5b(_jc_env *const env, _jc_soot_javaToJimple_PolyglotMethodSource$object *this)
{
	struct _jc_soot_javaToJimple_PolyglotMethodSource$object *r0;
	struct _jc_java_util_ArrayList$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(55);				// 0
	r1 = _JC_REF_FIELD(env, r0, soot_javaToJimple_PolyglotMethodSource, staticFieldInits);
	return r1;
}

//
// public java.util.ArrayList getStaticInitializerBlocks()
//

static _jc_linenum _jc_soot_javaToJimple_PolyglotMethodSource$linenum_table$getStaticInitializerBlocks$0f326dc0cdb896a6[];

static const unsigned char _jc_soot_javaToJimple_PolyglotMethodSource$param_ptypes$getStaticInitializerBlocks$0f326dc0cdb896a6[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_soot_javaToJimple_PolyglotMethodSource$method_info$getStaticInitializerBlocks$0f326dc0cdb896a6 = {
	.name=			"getStaticInitializerBlocks",
	.signature=		"()Ljava/util/ArrayList;",
	.class=			&_jc_soot_javaToJimple_PolyglotMethodSource$type,
	.return_type=		&_jc_java_util_ArrayList$type,
	.param_ptypes=		&_jc_soot_javaToJimple_PolyglotMethodSource$param_ptypes$getStaticInitializerBlocks$0f326dc0cdb896a6,
	.signature_hash=	_JC_JLONG(0xf326dc0cdb896a6),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_javaToJimple_PolyglotMethodSource$method$getStaticInitializerBlocks$0f326dc0cdb896a6,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_javaToJimple_PolyglotMethodSource$vtable, soot_javaToJimple_PolyglotMethodSource.getStaticInitializerBlocks$0f326dc0cdb896a6) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_soot_javaToJimple_PolyglotMethodSource$linenum_table$getStaticInitializerBlocks$0f326dc0cdb896a6
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_javaToJimple_PolyglotMethodSource, getStaticInitializerBlocks$0f326dc0cdb896a6);

_jc_java_util_ArrayList$object * _JC_JCNI_ATTR
_jc_soot_javaToJimple_PolyglotMethodSource$method$getStaticInitializerBlocks$0f326dc0cdb896a6(_jc_env *const env, _jc_soot_javaToJimple_PolyglotMethodSource$object *this)
{
	struct _jc_soot_javaToJimple_PolyglotMethodSource$object *r0;
	struct _jc_java_util_ArrayList$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(67);				// 0
	r1 = _JC_REF_FIELD(env, r0, soot_javaToJimple_PolyglotMethodSource, staticInitializerBlocks);
	return r1;
}

//
// public boolean hasAssert()
//

static _jc_linenum _jc_soot_javaToJimple_PolyglotMethodSource$linenum_table$hasAssert$205706236dda54ec[];

static const unsigned char _jc_soot_javaToJimple_PolyglotMethodSource$param_ptypes$hasAssert$205706236dda54ec[] = { 
_JC_TYPE_BOOLEAN };

_jc_method _jc_soot_javaToJimple_PolyglotMethodSource$method_info$hasAssert$205706236dda54ec = {
	.name=			"hasAssert",
	.signature=		"()Z",
	.class=			&_jc_soot_javaToJimple_PolyglotMethodSource$type,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_soot_javaToJimple_PolyglotMethodSource$param_ptypes$hasAssert$205706236dda54ec,
	.signature_hash=	_JC_JLONG(0x205706236dda54ec),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_javaToJimple_PolyglotMethodSource$method$hasAssert$205706236dda54ec,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_javaToJimple_PolyglotMethodSource$vtable, soot_javaToJimple_PolyglotMethodSource.hasAssert$205706236dda54ec) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_soot_javaToJimple_PolyglotMethodSource$linenum_table$hasAssert$205706236dda54ec
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_javaToJimple_PolyglotMethodSource, hasAssert$205706236dda54ec);

jboolean _JC_JCNI_ATTR
_jc_soot_javaToJimple_PolyglotMethodSource$method$hasAssert$205706236dda54ec(_jc_env *const env, _jc_soot_javaToJimple_PolyglotMethodSource$object *this)
{
	struct _jc_soot_javaToJimple_PolyglotMethodSource$object *r0;
	jboolean z0;

	r0 = this;
	_JC_LINE_NUMBER(107);				// 0
	z0 = _JC_PRIM_FIELD(env, r0, soot_javaToJimple_PolyglotMethodSource, hasAssert);
	return z0;
}

//
// public void hasAssert(boolean)
//

static _jc_linenum _jc_soot_javaToJimple_PolyglotMethodSource$linenum_table$hasAssert$a08ad54cff0d6f21[];

static const unsigned char _jc_soot_javaToJimple_PolyglotMethodSource$param_ptypes$hasAssert$a08ad54cff0d6f21[] = { 
_JC_TYPE_BOOLEAN, _JC_TYPE_VOID };

static _jc_type *const _jc_soot_javaToJimple_PolyglotMethodSource$param_types$hasAssert$a08ad54cff0d6f21[] = {
	&_jc_boolean$prim$type
};

_jc_method _jc_soot_javaToJimple_PolyglotMethodSource$method_info$hasAssert$a08ad54cff0d6f21 = {
	.name=			"hasAssert",
	.signature=		"(Z)V",
	.class=			&_jc_soot_javaToJimple_PolyglotMethodSource$type,
	.param_types=		&_jc_soot_javaToJimple_PolyglotMethodSource$param_types$hasAssert$a08ad54cff0d6f21,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_soot_javaToJimple_PolyglotMethodSource$param_ptypes$hasAssert$a08ad54cff0d6f21,
	.signature_hash=	_JC_JLONG(0xa08ad54cff0d6f21),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_javaToJimple_PolyglotMethodSource$method$hasAssert$a08ad54cff0d6f21,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_javaToJimple_PolyglotMethodSource$vtable, soot_javaToJimple_PolyglotMethodSource.hasAssert$a08ad54cff0d6f21) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_soot_javaToJimple_PolyglotMethodSource$linenum_table$hasAssert$a08ad54cff0d6f21
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_javaToJimple_PolyglotMethodSource, hasAssert$a08ad54cff0d6f21);

void _JC_JCNI_ATTR
_jc_soot_javaToJimple_PolyglotMethodSource$method$hasAssert$a08ad54cff0d6f21(_jc_env *const env, _jc_soot_javaToJimple_PolyglotMethodSource$object *this, jboolean param0)
{
	struct _jc_soot_javaToJimple_PolyglotMethodSource$object *r0;
	jboolean z0;

	r0 = this;
	z0 = param0;
	_JC_LINE_NUMBER(111);				// 0
	_JC_PRIM_FIELD(env, r0, soot_javaToJimple_PolyglotMethodSource, hasAssert) = z0;
	_JC_LINE_NUMBER(112);				// 1
	return;
}

//
// public void setAnonClassMap(java.util.HashMap)
//

static _jc_linenum _jc_soot_javaToJimple_PolyglotMethodSource$linenum_table$setAnonClassMap$1bc6017713c2e4a7[];

static const unsigned char _jc_soot_javaToJimple_PolyglotMethodSource$param_ptypes$setAnonClassMap$1bc6017713c2e4a7[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_soot_javaToJimple_PolyglotMethodSource$param_types$setAnonClassMap$1bc6017713c2e4a7[] = {
	&_jc_java_util_HashMap$type
};

_jc_method _jc_soot_javaToJimple_PolyglotMethodSource$method_info$setAnonClassMap$1bc6017713c2e4a7 = {
	.name=			"setAnonClassMap",
	.signature=		"(Ljava/util/HashMap;)V",
	.class=			&_jc_soot_javaToJimple_PolyglotMethodSource$type,
	.param_types=		&_jc_soot_javaToJimple_PolyglotMethodSource$param_types$setAnonClassMap$1bc6017713c2e4a7,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_soot_javaToJimple_PolyglotMethodSource$param_ptypes$setAnonClassMap$1bc6017713c2e4a7,
	.signature_hash=	_JC_JLONG(0x1bc6017713c2e4a7),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_javaToJimple_PolyglotMethodSource$method$setAnonClassMap$1bc6017713c2e4a7,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_javaToJimple_PolyglotMethodSource$vtable, soot_javaToJimple_PolyglotMethodSource.setAnonClassMap$1bc6017713c2e4a7) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_soot_javaToJimple_PolyglotMethodSource$linenum_table$setAnonClassMap$1bc6017713c2e4a7
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_javaToJimple_PolyglotMethodSource, setAnonClassMap$1bc6017713c2e4a7);

void _JC_JCNI_ATTR
_jc_soot_javaToJimple_PolyglotMethodSource$method$setAnonClassMap$1bc6017713c2e4a7(_jc_env *const env, _jc_soot_javaToJimple_PolyglotMethodSource$object *this, _jc_java_util_HashMap$object *param0)
{
	struct _jc_soot_javaToJimple_PolyglotMethodSource$object *r0;
	struct _jc_java_util_HashMap$object *r1;

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(99);				// 0
	_JC_REF_FIELD(env, r0, soot_javaToJimple_PolyglotMethodSource, anonClassMap) = r1;
	_JC_LINE_NUMBER(100);				// 1
	return;
}

//
// public void setFieldInits(java.util.ArrayList)
//

static _jc_linenum _jc_soot_javaToJimple_PolyglotMethodSource$linenum_table$setFieldInits$824e346c20f0599a[];

static const unsigned char _jc_soot_javaToJimple_PolyglotMethodSource$param_ptypes$setFieldInits$824e346c20f0599a[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_soot_javaToJimple_PolyglotMethodSource$param_types$setFieldInits$824e346c20f0599a[] = {
	&_jc_java_util_ArrayList$type
};

_jc_method _jc_soot_javaToJimple_PolyglotMethodSource$method_info$setFieldInits$824e346c20f0599a = {
	.name=			"setFieldInits",
	.signature=		"(Ljava/util/ArrayList;)V",
	.class=			&_jc_soot_javaToJimple_PolyglotMethodSource$type,
	.param_types=		&_jc_soot_javaToJimple_PolyglotMethodSource$param_types$setFieldInits$824e346c20f0599a,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_soot_javaToJimple_PolyglotMethodSource$param_ptypes$setFieldInits$824e346c20f0599a,
	.signature_hash=	_JC_JLONG(0x824e346c20f0599a),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_javaToJimple_PolyglotMethodSource$method$setFieldInits$824e346c20f0599a,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_javaToJimple_PolyglotMethodSource$vtable, soot_javaToJimple_PolyglotMethodSource.setFieldInits$824e346c20f0599a) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_soot_javaToJimple_PolyglotMethodSource$linenum_table$setFieldInits$824e346c20f0599a
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_javaToJimple_PolyglotMethodSource, setFieldInits$824e346c20f0599a);

void _JC_JCNI_ATTR
_jc_soot_javaToJimple_PolyglotMethodSource$method$setFieldInits$824e346c20f0599a(_jc_env *const env, _jc_soot_javaToJimple_PolyglotMethodSource$object *this, _jc_java_util_ArrayList$object *param0)
{
	struct _jc_soot_javaToJimple_PolyglotMethodSource$object *r0;
	struct _jc_java_util_ArrayList$object *r1;

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(43);				// 0
	_JC_REF_FIELD(env, r0, soot_javaToJimple_PolyglotMethodSource, fieldInits) = r1;
	_JC_LINE_NUMBER(44);				// 1
	return;
}

//
// public void setFinalsMap(java.util.HashMap)
//

static _jc_linenum _jc_soot_javaToJimple_PolyglotMethodSource$linenum_table$setFinalsMap$81342b1e9313a557[];

static const unsigned char _jc_soot_javaToJimple_PolyglotMethodSource$param_ptypes$setFinalsMap$81342b1e9313a557[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_soot_javaToJimple_PolyglotMethodSource$param_types$setFinalsMap$81342b1e9313a557[] = {
	&_jc_java_util_HashMap$type
};

_jc_method _jc_soot_javaToJimple_PolyglotMethodSource$method_info$setFinalsMap$81342b1e9313a557 = {
	.name=			"setFinalsMap",
	.signature=		"(Ljava/util/HashMap;)V",
	.class=			&_jc_soot_javaToJimple_PolyglotMethodSource$type,
	.param_types=		&_jc_soot_javaToJimple_PolyglotMethodSource$param_types$setFinalsMap$81342b1e9313a557,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_soot_javaToJimple_PolyglotMethodSource$param_ptypes$setFinalsMap$81342b1e9313a557,
	.signature_hash=	_JC_JLONG(0x81342b1e9313a557),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_javaToJimple_PolyglotMethodSource$method$setFinalsMap$81342b1e9313a557,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_javaToJimple_PolyglotMethodSource$vtable, soot_javaToJimple_PolyglotMethodSource.setFinalsMap$81342b1e9313a557) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_soot_javaToJimple_PolyglotMethodSource$linenum_table$setFinalsMap$81342b1e9313a557
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_javaToJimple_PolyglotMethodSource, setFinalsMap$81342b1e9313a557);

void _JC_JCNI_ATTR
_jc_soot_javaToJimple_PolyglotMethodSource$method$setFinalsMap$81342b1e9313a557(_jc_env *const env, _jc_soot_javaToJimple_PolyglotMethodSource$object *this, _jc_java_util_HashMap$object *param0)
{
	struct _jc_soot_javaToJimple_PolyglotMethodSource$object *r0;
	struct _jc_java_util_HashMap$object *r1;

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(228);				// 0
	_JC_REF_FIELD(env, r0, soot_javaToJimple_PolyglotMethodSource, finalsMap) = r1;
	_JC_LINE_NUMBER(229);				// 1
	return;
}

//
// public void setInitializerBlocks(java.util.ArrayList)
//

static _jc_linenum _jc_soot_javaToJimple_PolyglotMethodSource$linenum_table$setInitializerBlocks$2e9afabb47e66c97[];

static const unsigned char _jc_soot_javaToJimple_PolyglotMethodSource$param_ptypes$setInitializerBlocks$2e9afabb47e66c97[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_soot_javaToJimple_PolyglotMethodSource$param_types$setInitializerBlocks$2e9afabb47e66c97[] = {
	&_jc_java_util_ArrayList$type
};

_jc_method _jc_soot_javaToJimple_PolyglotMethodSource$method_info$setInitializerBlocks$2e9afabb47e66c97 = {
	.name=			"setInitializerBlocks",
	.signature=		"(Ljava/util/ArrayList;)V",
	.class=			&_jc_soot_javaToJimple_PolyglotMethodSource$type,
	.param_types=		&_jc_soot_javaToJimple_PolyglotMethodSource$param_types$setInitializerBlocks$2e9afabb47e66c97,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_soot_javaToJimple_PolyglotMethodSource$param_ptypes$setInitializerBlocks$2e9afabb47e66c97,
	.signature_hash=	_JC_JLONG(0x2e9afabb47e66c97),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_javaToJimple_PolyglotMethodSource$method$setInitializerBlocks$2e9afabb47e66c97,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_javaToJimple_PolyglotMethodSource$vtable, soot_javaToJimple_PolyglotMethodSource.setInitializerBlocks$2e9afabb47e66c97) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_soot_javaToJimple_PolyglotMethodSource$linenum_table$setInitializerBlocks$2e9afabb47e66c97
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_javaToJimple_PolyglotMethodSource, setInitializerBlocks$2e9afabb47e66c97);

void _JC_JCNI_ATTR
_jc_soot_javaToJimple_PolyglotMethodSource$method$setInitializerBlocks$2e9afabb47e66c97(_jc_env *const env, _jc_soot_javaToJimple_PolyglotMethodSource$object *this, _jc_java_util_ArrayList$object *param0)
{
	struct _jc_soot_javaToJimple_PolyglotMethodSource$object *r0;
	struct _jc_java_util_ArrayList$object *r1;

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(63);				// 0
	_JC_REF_FIELD(env, r0, soot_javaToJimple_PolyglotMethodSource, initializerBlocks) = r1;
	_JC_LINE_NUMBER(64);				// 1
	return;
}

//
// public void setLocalClassMap(java.util.HashMap)
//

static _jc_linenum _jc_soot_javaToJimple_PolyglotMethodSource$linenum_table$setLocalClassMap$dc3cf8854de198eb[];

static const unsigned char _jc_soot_javaToJimple_PolyglotMethodSource$param_ptypes$setLocalClassMap$dc3cf8854de198eb[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_soot_javaToJimple_PolyglotMethodSource$param_types$setLocalClassMap$dc3cf8854de198eb[] = {
	&_jc_java_util_HashMap$type
};

_jc_method _jc_soot_javaToJimple_PolyglotMethodSource$method_info$setLocalClassMap$dc3cf8854de198eb = {
	.name=			"setLocalClassMap",
	.signature=		"(Ljava/util/HashMap;)V",
	.class=			&_jc_soot_javaToJimple_PolyglotMethodSource$type,
	.param_types=		&_jc_soot_javaToJimple_PolyglotMethodSource$param_types$setLocalClassMap$dc3cf8854de198eb,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_soot_javaToJimple_PolyglotMethodSource$param_ptypes$setLocalClassMap$dc3cf8854de198eb,
	.signature_hash=	_JC_JLONG(0xdc3cf8854de198eb),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_javaToJimple_PolyglotMethodSource$method$setLocalClassMap$dc3cf8854de198eb,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_javaToJimple_PolyglotMethodSource$vtable, soot_javaToJimple_PolyglotMethodSource.setLocalClassMap$dc3cf8854de198eb) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_soot_javaToJimple_PolyglotMethodSource$linenum_table$setLocalClassMap$dc3cf8854de198eb
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_javaToJimple_PolyglotMethodSource, setLocalClassMap$dc3cf8854de198eb);

void _JC_JCNI_ATTR
_jc_soot_javaToJimple_PolyglotMethodSource$method$setLocalClassMap$dc3cf8854de198eb(_jc_env *const env, _jc_soot_javaToJimple_PolyglotMethodSource$object *this, _jc_java_util_HashMap$object *param0)
{
	struct _jc_soot_javaToJimple_PolyglotMethodSource$object *r0;
	struct _jc_java_util_HashMap$object *r1;

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(91);				// 0
	_JC_REF_FIELD(env, r0, soot_javaToJimple_PolyglotMethodSource, localClassMap) = r1;
	_JC_LINE_NUMBER(92);				// 1
	return;
}

//
// public void setNewToOuterMap(java.util.HashMap)
//

static _jc_linenum _jc_soot_javaToJimple_PolyglotMethodSource$linenum_table$setNewToOuterMap$cc15cd5a762907df[];

static const unsigned char _jc_soot_javaToJimple_PolyglotMethodSource$param_ptypes$setNewToOuterMap$cc15cd5a762907df[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_soot_javaToJimple_PolyglotMethodSource$param_types$setNewToOuterMap$cc15cd5a762907df[] = {
	&_jc_java_util_HashMap$type
};

_jc_method _jc_soot_javaToJimple_PolyglotMethodSource$method_info$setNewToOuterMap$cc15cd5a762907df = {
	.name=			"setNewToOuterMap",
	.signature=		"(Ljava/util/HashMap;)V",
	.class=			&_jc_soot_javaToJimple_PolyglotMethodSource$type,
	.param_types=		&_jc_soot_javaToJimple_PolyglotMethodSource$param_types$setNewToOuterMap$cc15cd5a762907df,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_soot_javaToJimple_PolyglotMethodSource$param_ptypes$setNewToOuterMap$cc15cd5a762907df,
	.signature_hash=	_JC_JLONG(0xcc15cd5a762907df),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_javaToJimple_PolyglotMethodSource$method$setNewToOuterMap$cc15cd5a762907df,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_javaToJimple_PolyglotMethodSource$vtable, soot_javaToJimple_PolyglotMethodSource.setNewToOuterMap$cc15cd5a762907df) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_soot_javaToJimple_PolyglotMethodSource$linenum_table$setNewToOuterMap$cc15cd5a762907df
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_javaToJimple_PolyglotMethodSource, setNewToOuterMap$cc15cd5a762907df);

void _JC_JCNI_ATTR
_jc_soot_javaToJimple_PolyglotMethodSource$method$setNewToOuterMap$cc15cd5a762907df(_jc_env *const env, _jc_soot_javaToJimple_PolyglotMethodSource$object *this, _jc_java_util_HashMap$object *param0)
{
	struct _jc_soot_javaToJimple_PolyglotMethodSource$object *r0;
	struct _jc_java_util_HashMap$object *r1;

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(236);				// 0
	_JC_REF_FIELD(env, r0, soot_javaToJimple_PolyglotMethodSource, newToOuterMap) = r1;
	_JC_LINE_NUMBER(237);				// 1
	return;
}

//
// public void setOuterClassThisInit(soot.Local)
//

static _jc_linenum _jc_soot_javaToJimple_PolyglotMethodSource$linenum_table$setOuterClassThisInit$d763e81dfefdd466[];

static const unsigned char _jc_soot_javaToJimple_PolyglotMethodSource$param_ptypes$setOuterClassThisInit$d763e81dfefdd466[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_soot_javaToJimple_PolyglotMethodSource$param_types$setOuterClassThisInit$d763e81dfefdd466[] = {
	&_jc_soot_Local$type
};

_jc_method _jc_soot_javaToJimple_PolyglotMethodSource$method_info$setOuterClassThisInit$d763e81dfefdd466 = {
	.name=			"setOuterClassThisInit",
	.signature=		"(Lsoot/Local;)V",
	.class=			&_jc_soot_javaToJimple_PolyglotMethodSource$type,
	.param_types=		&_jc_soot_javaToJimple_PolyglotMethodSource$param_types$setOuterClassThisInit$d763e81dfefdd466,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_soot_javaToJimple_PolyglotMethodSource$param_ptypes$setOuterClassThisInit$d763e81dfefdd466,
	.signature_hash=	_JC_JLONG(0xd763e81dfefdd466),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_javaToJimple_PolyglotMethodSource$method$setOuterClassThisInit$d763e81dfefdd466,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_javaToJimple_PolyglotMethodSource$vtable, soot_javaToJimple_PolyglotMethodSource.setOuterClassThisInit$d763e81dfefdd466) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_soot_javaToJimple_PolyglotMethodSource$linenum_table$setOuterClassThisInit$d763e81dfefdd466
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_javaToJimple_PolyglotMethodSource, setOuterClassThisInit$d763e81dfefdd466);

void _JC_JCNI_ATTR
_jc_soot_javaToJimple_PolyglotMethodSource$method$setOuterClassThisInit$d763e81dfefdd466(_jc_env *const env, _jc_soot_javaToJimple_PolyglotMethodSource$object *this, _jc_object *param0)
{
	struct _jc_soot_javaToJimple_PolyglotMethodSource$object *r0;
	struct _jc_object *r1;

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(75);				// 0
	_JC_REF_FIELD(env, r0, soot_javaToJimple_PolyglotMethodSource, outerClassThisInit) = r1;
	_JC_LINE_NUMBER(76);				// 1
	return;
}

//
// public void setPrivateAccessMap(java.util.HashMap)
//

static _jc_linenum _jc_soot_javaToJimple_PolyglotMethodSource$linenum_table$setPrivateAccessMap$c8a81ea0538d18a1[];

static const unsigned char _jc_soot_javaToJimple_PolyglotMethodSource$param_ptypes$setPrivateAccessMap$c8a81ea0538d18a1[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_soot_javaToJimple_PolyglotMethodSource$param_types$setPrivateAccessMap$c8a81ea0538d18a1[] = {
	&_jc_java_util_HashMap$type
};

_jc_method _jc_soot_javaToJimple_PolyglotMethodSource$method_info$setPrivateAccessMap$c8a81ea0538d18a1 = {
	.name=			"setPrivateAccessMap",
	.signature=		"(Ljava/util/HashMap;)V",
	.class=			&_jc_soot_javaToJimple_PolyglotMethodSource$type,
	.param_types=		&_jc_soot_javaToJimple_PolyglotMethodSource$param_types$setPrivateAccessMap$c8a81ea0538d18a1,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_soot_javaToJimple_PolyglotMethodSource$param_ptypes$setPrivateAccessMap$c8a81ea0538d18a1,
	.signature_hash=	_JC_JLONG(0xc8a81ea0538d18a1),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_javaToJimple_PolyglotMethodSource$method$setPrivateAccessMap$c8a81ea0538d18a1,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_javaToJimple_PolyglotMethodSource$vtable, soot_javaToJimple_PolyglotMethodSource.setPrivateAccessMap$c8a81ea0538d18a1) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_soot_javaToJimple_PolyglotMethodSource$linenum_table$setPrivateAccessMap$c8a81ea0538d18a1
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_javaToJimple_PolyglotMethodSource, setPrivateAccessMap$c8a81ea0538d18a1);

void _JC_JCNI_ATTR
_jc_soot_javaToJimple_PolyglotMethodSource$method$setPrivateAccessMap$c8a81ea0538d18a1(_jc_env *const env, _jc_soot_javaToJimple_PolyglotMethodSource$object *this, _jc_java_util_HashMap$object *param0)
{
	struct _jc_soot_javaToJimple_PolyglotMethodSource$object *r0;
	struct _jc_java_util_HashMap$object *r1;

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(83);				// 0
	_JC_REF_FIELD(env, r0, soot_javaToJimple_PolyglotMethodSource, privateAccessMap) = r1;
	_JC_LINE_NUMBER(84);				// 1
	return;
}

//
// public void setStaticFieldInits(java.util.ArrayList)
//

static _jc_linenum _jc_soot_javaToJimple_PolyglotMethodSource$linenum_table$setStaticFieldInits$5f93d8031504ee69[];

static const unsigned char _jc_soot_javaToJimple_PolyglotMethodSource$param_ptypes$setStaticFieldInits$5f93d8031504ee69[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_soot_javaToJimple_PolyglotMethodSource$param_types$setStaticFieldInits$5f93d8031504ee69[] = {
	&_jc_java_util_ArrayList$type
};

_jc_method _jc_soot_javaToJimple_PolyglotMethodSource$method_info$setStaticFieldInits$5f93d8031504ee69 = {
	.name=			"setStaticFieldInits",
	.signature=		"(Ljava/util/ArrayList;)V",
	.class=			&_jc_soot_javaToJimple_PolyglotMethodSource$type,
	.param_types=		&_jc_soot_javaToJimple_PolyglotMethodSource$param_types$setStaticFieldInits$5f93d8031504ee69,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_soot_javaToJimple_PolyglotMethodSource$param_ptypes$setStaticFieldInits$5f93d8031504ee69,
	.signature_hash=	_JC_JLONG(0x5f93d8031504ee69),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_javaToJimple_PolyglotMethodSource$method$setStaticFieldInits$5f93d8031504ee69,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_javaToJimple_PolyglotMethodSource$vtable, soot_javaToJimple_PolyglotMethodSource.setStaticFieldInits$5f93d8031504ee69) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_soot_javaToJimple_PolyglotMethodSource$linenum_table$setStaticFieldInits$5f93d8031504ee69
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_javaToJimple_PolyglotMethodSource, setStaticFieldInits$5f93d8031504ee69);

void _JC_JCNI_ATTR
_jc_soot_javaToJimple_PolyglotMethodSource$method$setStaticFieldInits$5f93d8031504ee69(_jc_env *const env, _jc_soot_javaToJimple_PolyglotMethodSource$object *this, _jc_java_util_ArrayList$object *param0)
{
	struct _jc_soot_javaToJimple_PolyglotMethodSource$object *r0;
	struct _jc_java_util_ArrayList$object *r1;

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(47);				// 0
	_JC_REF_FIELD(env, r0, soot_javaToJimple_PolyglotMethodSource, staticFieldInits) = r1;
	_JC_LINE_NUMBER(48);				// 1
	return;
}

//
// public void setStaticInitializerBlocks(java.util.ArrayList)
//

static _jc_linenum _jc_soot_javaToJimple_PolyglotMethodSource$linenum_table$setStaticInitializerBlocks$8dbe3d1e068a8c90[];

static const unsigned char _jc_soot_javaToJimple_PolyglotMethodSource$param_ptypes$setStaticInitializerBlocks$8dbe3d1e068a8c90[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_soot_javaToJimple_PolyglotMethodSource$param_types$setStaticInitializerBlocks$8dbe3d1e068a8c90[] = {
	&_jc_java_util_ArrayList$type
};

_jc_method _jc_soot_javaToJimple_PolyglotMethodSource$method_info$setStaticInitializerBlocks$8dbe3d1e068a8c90 = {
	.name=			"setStaticInitializerBlocks",
	.signature=		"(Ljava/util/ArrayList;)V",
	.class=			&_jc_soot_javaToJimple_PolyglotMethodSource$type,
	.param_types=		&_jc_soot_javaToJimple_PolyglotMethodSource$param_types$setStaticInitializerBlocks$8dbe3d1e068a8c90,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_soot_javaToJimple_PolyglotMethodSource$param_ptypes$setStaticInitializerBlocks$8dbe3d1e068a8c90,
	.signature_hash=	_JC_JLONG(0x8dbe3d1e068a8c90),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_javaToJimple_PolyglotMethodSource$method$setStaticInitializerBlocks$8dbe3d1e068a8c90,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_javaToJimple_PolyglotMethodSource$vtable, soot_javaToJimple_PolyglotMethodSource.setStaticInitializerBlocks$8dbe3d1e068a8c90) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_soot_javaToJimple_PolyglotMethodSource$linenum_table$setStaticInitializerBlocks$8dbe3d1e068a8c90
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_javaToJimple_PolyglotMethodSource, setStaticInitializerBlocks$8dbe3d1e068a8c90);

void _JC_JCNI_ATTR
_jc_soot_javaToJimple_PolyglotMethodSource$method$setStaticInitializerBlocks$8dbe3d1e068a8c90(_jc_env *const env, _jc_soot_javaToJimple_PolyglotMethodSource$object *this, _jc_java_util_ArrayList$object *param0)
{
	struct _jc_soot_javaToJimple_PolyglotMethodSource$object *r0;
	struct _jc_java_util_ArrayList$object *r1;

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(59);				// 0
	_JC_REF_FIELD(env, r0, soot_javaToJimple_PolyglotMethodSource, staticInitializerBlocks) = r1;
	_JC_LINE_NUMBER(60);				// 1
	return;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_soot_javaToJimple_PolyglotMethodSource$methods[] = {
	&_jc_soot_javaToJimple_PolyglotMethodSource$method_info$_init$52f4ad9f2989aeee,
	&_jc_soot_javaToJimple_PolyglotMethodSource$method_info$_init$1836b9c10f8424cb,
	&_jc_soot_javaToJimple_PolyglotMethodSource$method_info$addAssertInits$6d766b1297a0a7f2,
	&_jc_soot_javaToJimple_PolyglotMethodSource$method_info$getAnonClassMap$a08d4705763dc080,
	&_jc_soot_javaToJimple_PolyglotMethodSource$method_info$getBody$01a871f1d690f082,
	&_jc_soot_javaToJimple_PolyglotMethodSource$method_info$getFieldInits$4f8fee8f6fc75f9d,
	&_jc_soot_javaToJimple_PolyglotMethodSource$method_info$getFinalsMap$c1b0fd04314bd552,
	&_jc_soot_javaToJimple_PolyglotMethodSource$method_info$getInitializerBlocks$1d66416ccde921e4,
	&_jc_soot_javaToJimple_PolyglotMethodSource$method_info$getLocalClassMap$dbf54bf000bac9ab,
	&_jc_soot_javaToJimple_PolyglotMethodSource$method_info$getNewToOuterMap$fc8a419e3350f1bb,
	&_jc_soot_javaToJimple_PolyglotMethodSource$method_info$getOuterClassThisInit$b2a175dcbe1d6040,
	&_jc_soot_javaToJimple_PolyglotMethodSource$method_info$getPrivateAccessMap$d4f71f0f6e18ab15,
	&_jc_soot_javaToJimple_PolyglotMethodSource$method_info$getStaticFieldInits$5460da09a6343b5b,
	&_jc_soot_javaToJimple_PolyglotMethodSource$method_info$getStaticInitializerBlocks$0f326dc0cdb896a6,
	&_jc_soot_javaToJimple_PolyglotMethodSource$method_info$hasAssert$205706236dda54ec,
	&_jc_soot_javaToJimple_PolyglotMethodSource$method_info$hasAssert$a08ad54cff0d6f21,
	&_jc_soot_javaToJimple_PolyglotMethodSource$method_info$setAnonClassMap$1bc6017713c2e4a7,
	&_jc_soot_javaToJimple_PolyglotMethodSource$method_info$setFieldInits$824e346c20f0599a,
	&_jc_soot_javaToJimple_PolyglotMethodSource$method_info$setFinalsMap$81342b1e9313a557,
	&_jc_soot_javaToJimple_PolyglotMethodSource$method_info$setInitializerBlocks$2e9afabb47e66c97,
	&_jc_soot_javaToJimple_PolyglotMethodSource$method_info$setLocalClassMap$dc3cf8854de198eb,
	&_jc_soot_javaToJimple_PolyglotMethodSource$method_info$setNewToOuterMap$cc15cd5a762907df,
	&_jc_soot_javaToJimple_PolyglotMethodSource$method_info$setOuterClassThisInit$d763e81dfefdd466,
	&_jc_soot_javaToJimple_PolyglotMethodSource$method_info$setPrivateAccessMap$c8a81ea0538d18a1,
	&_jc_soot_javaToJimple_PolyglotMethodSource$method_info$setStaticFieldInits$5f93d8031504ee69,
	&_jc_soot_javaToJimple_PolyglotMethodSource$method_info$setStaticInitializerBlocks$8dbe3d1e068a8c90
};

/************************************************************************
 *			      Interface list				*
 ************************************************************************/

// Directly implemented interfaces
static _jc_type *const _jc_soot_javaToJimple_PolyglotMethodSource$interfaces[] = {
	&_jc_soot_MethodSource$type
};

/************************************************************************
 *			   Interface hash table				*
 ************************************************************************/

#if _JC_IMETHOD_HASHSIZE != 128
#error "_JC_IMETHOD_HASHSIZE has the wrong value (should be 128)"
#endif

// Interface lookup hash table buckets
static _jc_method *_jc_soot_javaToJimple_PolyglotMethodSource$imethod_hash_bucket_2[] = {
	&_jc_soot_javaToJimple_PolyglotMethodSource$method_info$getBody$01a871f1d690f082,
	_JC_NULL
};

// Interface lookup hash table
static _jc_method **_jc_soot_javaToJimple_PolyglotMethodSource$imethod_hash_table[_JC_IMETHOD_HASHSIZE] = {
	[2]=	_jc_soot_javaToJimple_PolyglotMethodSource$imethod_hash_bucket_2
};

// Interface "quick" lookup hash table
static const void *_jc_soot_javaToJimple_PolyglotMethodSource$imethod_quick_table[_JC_IMETHOD_HASHSIZE] = {
	[2]=	&_jc_soot_javaToJimple_PolyglotMethodSource$method$getBody$01a871f1d690f082
};

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_soot_javaToJimple_PolyglotMethodSource$instanceof_hash_bucket_47[] = {
	&_jc_soot_MethodSource$type,
	_JC_NULL
};
static _jc_type *const _jc_soot_javaToJimple_PolyglotMethodSource$instanceof_hash_bucket_49[] = {
	&_jc_soot_javaToJimple_PolyglotMethodSource$type,
	_JC_NULL
};
static _jc_type *const _jc_soot_javaToJimple_PolyglotMethodSource$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_soot_javaToJimple_PolyglotMethodSource$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[47]=	_jc_soot_javaToJimple_PolyglotMethodSource$instanceof_hash_bucket_47,
	[49]=	_jc_soot_javaToJimple_PolyglotMethodSource$instanceof_hash_bucket_49,
	[101]=	_jc_soot_javaToJimple_PolyglotMethodSource$instanceof_hash_bucket_101
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_soot_javaToJimple_PolyglotMethodSource$class_depends[] = {
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/StringBuffer",	_JC_JLONG(0x94d357637b968dda) },
	{ "java/util/AbstractCollection",	_JC_JLONG(0x8ea716c64b77f8eb) },
	{ "java/util/AbstractList",	_JC_JLONG(0xf5238436362828db) },
	{ "java/util/ArrayList",	_JC_JLONG(0x58038509830ef3f4) },
	{ "java/util/HashMap",	_JC_JLONG(0xd7cd853200c3e71f) },
	{ "java/util/List",	_JC_JLONG(0x9ee0d92ce1525a4d) },
	{ "java/util/Map",	_JC_JLONG(0xe283f7c2e7a7979c) },
	{ "polyglot/ast/Block",	_JC_JLONG(0x5eda5b679dfeb2f7) },
	{ "soot/Body",	_JC_JLONG(0x6131d54b9700ca5d) },
	{ "soot/BooleanType",	_JC_JLONG(0x3dae18ed334ad777) },
	{ "soot/G",	_JC_JLONG(0xb6d33af8f84fdbc4) },
	{ "soot/Local",	_JC_JLONG(0xfc12513d0e867dd9) },
	{ "soot/MethodSource",	_JC_JLONG(0x46c999f340ec4a2f) },
	{ "soot/Pack",	_JC_JLONG(0x65aca5ceab69719a) },
	{ "soot/PackManager",	_JC_JLONG(0x4582e82e366d3f43) },
	{ "soot/PatchingChain",	_JC_JLONG(0x2869754f09a70a54) },
	{ "soot/PhaseOptions",	_JC_JLONG(0x177db6dd531c9085) },
	{ "soot/RefLikeType",	_JC_JLONG(0xfdbc627922b0ba72) },
	{ "soot/RefType",	_JC_JLONG(0x2887a1b57cecfb7b) },
	{ "soot/Scene",	_JC_JLONG(0x7120c8047949f8c0) },
	{ "soot/Singletons",	_JC_JLONG(0x6ac5bee50bbabb71) },
	{ "soot/SootClass",	_JC_JLONG(0x634bd13ff2d8ac70) },
	{ "soot/SootField",	_JC_JLONG(0x23c08aae5a0099c4) },
	{ "soot/SootMethod",	_JC_JLONG(0xbd11c16680505218) },
	{ "soot/Type",	_JC_JLONG(0xf801e5c664424a1) },
	{ "soot/javaToJimple/JimpleBodyBuilder",	_JC_JLONG(0x14c838518d04862c) },
	{ "soot/jimple/ArithmeticConstant",	_JC_JLONG(0xe5651dde6cd08af9) },
	{ "soot/jimple/AssignStmt",	_JC_JLONG(0xbfceec22e8ffee79) },
	{ "soot/jimple/Constant",	_JC_JLONG(0xa4a584ce60f6ce4) },
	{ "soot/jimple/GotoStmt",	_JC_JLONG(0x19f3fc907e68832c) },
	{ "soot/jimple/IfStmt",	_JC_JLONG(0x904ca7a05d5fe162) },
	{ "soot/jimple/IntConstant",	_JC_JLONG(0xfade60ef604ad800) },
	{ "soot/jimple/Jimple",	_JC_JLONG(0x18f5ef6e837efcef) },
	{ "soot/jimple/JimpleBody",	_JC_JLONG(0x197add2ebd99cc14) },
	{ "soot/jimple/NeExpr",	_JC_JLONG(0xa79ed01c5425d753) },
	{ "soot/jimple/NopStmt",	_JC_JLONG(0xfbe3f749c636231) },
	{ "soot/jimple/NullConstant",	_JC_JLONG(0x8a1af2f5d59b712f) },
	{ "soot/jimple/NumericConstant",	_JC_JLONG(0x3bd9379d3ff77f81) },
	{ "soot/jimple/StaticFieldRef",	_JC_JLONG(0x481d0bb0a59d7420) },
	{ "soot/jimple/StaticInvokeExpr",	_JC_JLONG(0x5f8a86314966eaf4) },
	{ "soot/jimple/StringConstant",	_JC_JLONG(0x51a35a83f0a4f8f1) },
	{ "soot/jimple/VirtualInvokeExpr",	_JC_JLONG(0xd9fed49578ff87c7) },
	{ "soot/util/Chain",	_JC_JLONG(0xa50c82c4926ca40e) },
	{ "soot/util/Numberer",	_JC_JLONG(0xf5f751433138bc27) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_soot_javaToJimple_PolyglotMethodSource$vtype _jc_soot_javaToJimple_PolyglotMethodSource$type = {
    .type= {
	.name=			"soot/javaToJimple/PolyglotMethodSource",
	.superclass=		&_jc_java_lang_Object$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.num_interfaces=sizeof(_jc_soot_javaToJimple_PolyglotMethodSource$interfaces) / sizeof(*_jc_soot_javaToJimple_PolyglotMethodSource$interfaces),
	.interfaces=		_jc_soot_javaToJimple_PolyglotMethodSource$interfaces,
	.imethod_hash_table=	_jc_soot_javaToJimple_PolyglotMethodSource$imethod_hash_table,
	.imethod_quick_table=	_jc_soot_javaToJimple_PolyglotMethodSource$imethod_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		35,
		.hash=			_JC_JLONG(0x8f65caf164849b1),
		.source_file=		"PolyglotMethodSource.java",
		.instance_size=		sizeof(_jc_soot_javaToJimple_PolyglotMethodSource$refs) + sizeof(_jc_soot_javaToJimple_PolyglotMethodSource$object),
		.num_virtual_refs=	12,
		.num_fields=		sizeof(_jc_soot_javaToJimple_PolyglotMethodSource$fields) / sizeof(*_jc_soot_javaToJimple_PolyglotMethodSource$fields),
		.fields=		_jc_soot_javaToJimple_PolyglotMethodSource$fields,
		.num_methods=		sizeof(_jc_soot_javaToJimple_PolyglotMethodSource$methods) / sizeof(*_jc_soot_javaToJimple_PolyglotMethodSource$methods),
		.methods=		_jc_soot_javaToJimple_PolyglotMethodSource$methods,
		.instanceof_hash_table=	_jc_soot_javaToJimple_PolyglotMethodSource$instanceof_hash_table,
		.num_class_depends=		sizeof(_jc_soot_javaToJimple_PolyglotMethodSource$class_depends) / sizeof(*_jc_soot_javaToJimple_PolyglotMethodSource$class_depends),
		.class_depends=		_jc_soot_javaToJimple_PolyglotMethodSource$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.soot_javaToJimple_PolyglotMethodSource= {
	    .addAssertInits$6d766b1297a0a7f2=
		&_jc_soot_javaToJimple_PolyglotMethodSource$method$addAssertInits$6d766b1297a0a7f2,
	    .getAnonClassMap$a08d4705763dc080=
		&_jc_soot_javaToJimple_PolyglotMethodSource$method$getAnonClassMap$a08d4705763dc080,
	    .getBody$01a871f1d690f082=
		&_jc_soot_javaToJimple_PolyglotMethodSource$method$getBody$01a871f1d690f082,
	    .getFieldInits$4f8fee8f6fc75f9d=
		&_jc_soot_javaToJimple_PolyglotMethodSource$method$getFieldInits$4f8fee8f6fc75f9d,
	    .getFinalsMap$c1b0fd04314bd552=
		&_jc_soot_javaToJimple_PolyglotMethodSource$method$getFinalsMap$c1b0fd04314bd552,
	    .getInitializerBlocks$1d66416ccde921e4=
		&_jc_soot_javaToJimple_PolyglotMethodSource$method$getInitializerBlocks$1d66416ccde921e4,
	    .getLocalClassMap$dbf54bf000bac9ab=
		&_jc_soot_javaToJimple_PolyglotMethodSource$method$getLocalClassMap$dbf54bf000bac9ab,
	    .getNewToOuterMap$fc8a419e3350f1bb=
		&_jc_soot_javaToJimple_PolyglotMethodSource$method$getNewToOuterMap$fc8a419e3350f1bb,
	    .getOuterClassThisInit$b2a175dcbe1d6040=
		&_jc_soot_javaToJimple_PolyglotMethodSource$method$getOuterClassThisInit$b2a175dcbe1d6040,
	    .getPrivateAccessMap$d4f71f0f6e18ab15=
		&_jc_soot_javaToJimple_PolyglotMethodSource$method$getPrivateAccessMap$d4f71f0f6e18ab15,
	    .getStaticFieldInits$5460da09a6343b5b=
		&_jc_soot_javaToJimple_PolyglotMethodSource$method$getStaticFieldInits$5460da09a6343b5b,
	    .getStaticInitializerBlocks$0f326dc0cdb896a6=
		&_jc_soot_javaToJimple_PolyglotMethodSource$method$getStaticInitializerBlocks$0f326dc0cdb896a6,
	    .hasAssert$205706236dda54ec=
		&_jc_soot_javaToJimple_PolyglotMethodSource$method$hasAssert$205706236dda54ec,
	    .hasAssert$a08ad54cff0d6f21=
		&_jc_soot_javaToJimple_PolyglotMethodSource$method$hasAssert$a08ad54cff0d6f21,
	    .setAnonClassMap$1bc6017713c2e4a7=
		&_jc_soot_javaToJimple_PolyglotMethodSource$method$setAnonClassMap$1bc6017713c2e4a7,
	    .setFieldInits$824e346c20f0599a=
		&_jc_soot_javaToJimple_PolyglotMethodSource$method$setFieldInits$824e346c20f0599a,
	    .setFinalsMap$81342b1e9313a557=
		&_jc_soot_javaToJimple_PolyglotMethodSource$method$setFinalsMap$81342b1e9313a557,
	    .setInitializerBlocks$2e9afabb47e66c97=
		&_jc_soot_javaToJimple_PolyglotMethodSource$method$setInitializerBlocks$2e9afabb47e66c97,
	    .setLocalClassMap$dc3cf8854de198eb=
		&_jc_soot_javaToJimple_PolyglotMethodSource$method$setLocalClassMap$dc3cf8854de198eb,
	    .setNewToOuterMap$cc15cd5a762907df=
		&_jc_soot_javaToJimple_PolyglotMethodSource$method$setNewToOuterMap$cc15cd5a762907df,
	    .setOuterClassThisInit$d763e81dfefdd466=
		&_jc_soot_javaToJimple_PolyglotMethodSource$method$setOuterClassThisInit$d763e81dfefdd466,
	    .setPrivateAccessMap$c8a81ea0538d18a1=
		&_jc_soot_javaToJimple_PolyglotMethodSource$method$setPrivateAccessMap$c8a81ea0538d18a1,
	    .setStaticFieldInits$5f93d8031504ee69=
		&_jc_soot_javaToJimple_PolyglotMethodSource$method$setStaticFieldInits$5f93d8031504ee69,
	    .setStaticInitializerBlocks$8dbe3d1e068a8c90=
		&_jc_soot_javaToJimple_PolyglotMethodSource$method$setStaticInitializerBlocks$8dbe3d1e068a8c90,
	},
    }
};

