// public class soot.jimple.toolkits.annotation.arraycheck.ArrayBoundsChecker

// class file dependencies
// @dep_class 99a46305ebacacb5 java_io_PrintStream
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class 72c9d9e8f269fac java_lang_Long
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 94d357637b968dda java_lang_StringBuffer
// @dep_class 53cc8e2333795f04 java_lang_System
// @dep_class 4d1cebae0bdda058 java_lang_VMSystem
// @dep_class a85d2a51094e614c java_util_Date
// @dep_class be56ff673eefd9d2 java_util_Iterator
// @dep_class 9ee0d92ce1525a4d java_util_List
// @dep_class e283f7c2e7a7979c java_util_Map
// @dep_class 13e7935c8aaa97c9 soot_ArrayType
// @dep_class 6131d54b9700ca5d soot_Body
// @dep_class a76a7734eb62f430 soot_BodyTransformer
// @dep_class b6d33af8f84fdbc4 soot_G
// @dep_class fc12513d0e867dd9 soot_Local
// @dep_class 2869754f09a70a54 soot_PatchingChain
// @dep_class 177db6dd531c9085 soot_PhaseOptions
// @dep_class 7120c8047949f8c0 soot_Scene
// @dep_class 6ac5bee50bbabb71 soot_Singletons
// @dep_class 47e789a7286ce13e soot_Singletons__24Global
// @dep_class 634bd13ff2d8ac70 soot_SootClass
// @dep_class bd11c16680505218 soot_SootMethod
// @dep_class de5fa3182955e270 soot_Transformer
// @dep_class f801e5c664424a1 soot_Type
// @dep_class 277f133500573bf0 soot_Value
// @dep_class be495158d4df40c0 soot_ValueBox
// @dep_class e5651dde6cd08af9 soot_jimple_ArithmeticConstant
// @dep_class 6c885b70485f9bcf soot_jimple_ArrayRef
// @dep_class a4a584ce60f6ce4 soot_jimple_Constant
// @dep_class fade60ef604ad800 soot_jimple_IntConstant
// @dep_class f44409eade05c9fc soot_jimple_InvokeStmt
// @dep_class 18f5ef6e837efcef soot_jimple_Jimple
// @dep_class 3bd9379d3ff77f81 soot_jimple_NumericConstant
// @dep_class 5f8a86314966eaf4 soot_jimple_StaticInvokeExpr
// @dep_class 3650ad26817a710 soot_jimple_Stmt
// @dep_class 52aa5421a5e909b2 soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker
// @dep_class 5c956ac91af250fe soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsCheckerAnalysis
// @dep_class fa23922817735cea soot_jimple_toolkits_annotation_arraycheck_IntContainer
// @dep_class a53ec25e01edf44a soot_jimple_toolkits_annotation_arraycheck_MethodLocal
// @dep_class 6a41f5ea6fee677e soot_jimple_toolkits_annotation_arraycheck_RectangularArrayFinder
// @dep_class ae1dddb7d2686744 soot_jimple_toolkits_annotation_arraycheck_WeightedDirectedSparseGraph
// @dep_class afc01e7a340766a0 soot_jimple_toolkits_annotation_tags_ArrayCheckTag
// @dep_class d089077f46294801 soot_options_ABCOptions
// @dep_class c5a5a246a3f59476 soot_options_Options
// @dep_class 6ddedfee878f127 soot_tagkit_AbstractHost
// @dep_class a5fe62fcd03e5ea4 soot_tagkit_ColorTag
// @dep_class 9cb4881430c5d3aa soot_tagkit_KeyTag
// @dep_class a50c82c4926ca40e soot_util_Chain

// header file dependencies
// @dep_header java_io_PrintStream
// @dep_header java_lang_Class
// @dep_header java_lang_Long
// @dep_header java_lang_String
// @dep_header java_lang_StringBuffer
// @dep_header java_lang_System
// @dep_header java_lang_VMSystem
// @dep_header java_util_Date
// @dep_header java_util_Iterator
// @dep_header java_util_List
// @dep_header java_util_Map
// @dep_header soot_ArrayType
// @dep_header soot_Body
// @dep_header soot_G
// @dep_header soot_Local
// @dep_header soot_PatchingChain
// @dep_header soot_PhaseOptions
// @dep_header soot_Scene
// @dep_header soot_Singletons__24Global
// @dep_header soot_SootClass
// @dep_header soot_SootMethod
// @dep_header soot_Value
// @dep_header soot_ValueBox
// @dep_header soot_jimple_ArrayRef
// @dep_header soot_jimple_IntConstant
// @dep_header soot_jimple_InvokeStmt
// @dep_header soot_jimple_Jimple
// @dep_header soot_jimple_StaticInvokeExpr
// @dep_header soot_jimple_Stmt
// @dep_header soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker
// @dep_header soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsCheckerAnalysis
// @dep_header soot_jimple_toolkits_annotation_arraycheck_IntContainer
// @dep_header soot_jimple_toolkits_annotation_arraycheck_MethodLocal
// @dep_header soot_jimple_toolkits_annotation_arraycheck_RectangularArrayFinder
// @dep_header soot_jimple_toolkits_annotation_arraycheck_WeightedDirectedSparseGraph
// @dep_header soot_jimple_toolkits_annotation_tags_ArrayCheckTag
// @dep_header soot_options_ABCOptions
// @dep_header soot_options_Options
// @dep_header soot_tagkit_ColorTag
// @dep_header soot_tagkit_KeyTag
// @dep_header soot_util_Chain

#include "jc_defs.h"

#include "java/io/PrintStream.h"
#include "java/lang/Class.h"
#include "java/lang/Long.h"
#include "java/lang/String.h"
#include "java/lang/StringBuffer.h"
#include "java/lang/System.h"
#include "java/lang/VMSystem.h"
#include "java/util/Date.h"
#include "java/util/Iterator.h"
#include "java/util/List.h"
#include "java/util/Map.h"
#include "soot/ArrayType.h"
#include "soot/Body.h"
#include "soot/G.h"
#include "soot/Local.h"
#include "soot/PatchingChain.h"
#include "soot/PhaseOptions.h"
#include "soot/Scene.h"
#include "soot/Singletons__24Global.h"
#include "soot/SootClass.h"
#include "soot/SootMethod.h"
#include "soot/Value.h"
#include "soot/ValueBox.h"
#include "soot/jimple/ArrayRef.h"
#include "soot/jimple/IntConstant.h"
#include "soot/jimple/InvokeStmt.h"
#include "soot/jimple/Jimple.h"
#include "soot/jimple/StaticInvokeExpr.h"
#include "soot/jimple/Stmt.h"
#include "soot/jimple/toolkits/annotation/arraycheck/ArrayBoundsChecker.h"
#include "soot/jimple/toolkits/annotation/arraycheck/ArrayBoundsCheckerAnalysis.h"
#include "soot/jimple/toolkits/annotation/arraycheck/IntContainer.h"
#include "soot/jimple/toolkits/annotation/arraycheck/MethodLocal.h"
#include "soot/jimple/toolkits/annotation/arraycheck/RectangularArrayFinder.h"
#include "soot/jimple/toolkits/annotation/arraycheck/WeightedDirectedSparseGraph.h"
#include "soot/jimple/toolkits/annotation/tags/ArrayCheckTag.h"
#include "soot/options/ABCOptions.h"
#include "soot/options/Options.h"
#include "soot/tagkit/ColorTag.h"
#include "soot/tagkit/KeyTag.h"
#include "soot/util/Chain.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// protected boolean takeClassField
static _jc_field _jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$field_info$takeClassField = {
	.name=		"takeClassField",
	.signature=	"Z",
	.class=		&_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$type,
	.type=		&_jc_boolean$prim$type,
	.access_flags=	_JC_ACC_PROTECTED,
	.offset=	_JC_OFFSETOF(_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$object, nonrefs.soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker.takeClassField),
};

// protected boolean takeFieldRef
static _jc_field _jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$field_info$takeFieldRef = {
	.name=		"takeFieldRef",
	.signature=	"Z",
	.class=		&_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$type,
	.type=		&_jc_boolean$prim$type,
	.access_flags=	_JC_ACC_PROTECTED,
	.offset=	_JC_OFFSETOF(_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$object, nonrefs.soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker.takeFieldRef),
};

// protected boolean takeArrayRef
static _jc_field _jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$field_info$takeArrayRef = {
	.name=		"takeArrayRef",
	.signature=	"Z",
	.class=		&_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$type,
	.type=		&_jc_boolean$prim$type,
	.access_flags=	_JC_ACC_PROTECTED,
	.offset=	_JC_OFFSETOF(_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$object, nonrefs.soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker.takeArrayRef),
};

// protected boolean takeCSE
static _jc_field _jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$field_info$takeCSE = {
	.name=		"takeCSE",
	.signature=	"Z",
	.class=		&_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$type,
	.type=		&_jc_boolean$prim$type,
	.access_flags=	_JC_ACC_PROTECTED,
	.offset=	_JC_OFFSETOF(_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$object, nonrefs.soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker.takeCSE),
};

// protected boolean takeRectArray
static _jc_field _jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$field_info$takeRectArray = {
	.name=		"takeRectArray",
	.signature=	"Z",
	.class=		&_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$type,
	.type=		&_jc_boolean$prim$type,
	.access_flags=	_JC_ACC_PROTECTED,
	.offset=	_JC_OFFSETOF(_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$object, nonrefs.soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker.takeRectArray),
};

// protected boolean addColorTags
static _jc_field _jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$field_info$addColorTags = {
	.name=		"addColorTags",
	.signature=	"Z",
	.class=		&_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$type,
	.type=		&_jc_boolean$prim$type,
	.access_flags=	_JC_ACC_PROTECTED,
	.offset=	_JC_OFFSETOF(_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$object, nonrefs.soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker.addColorTags),
};

// Fields
static _jc_field *const _jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$fields[] = {
	&_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$field_info$addColorTags,
	&_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$field_info$takeArrayRef,
	&_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$field_info$takeCSE,
	&_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$field_info$takeClassField,
	&_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$field_info$takeFieldRef,
	&_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$field_info$takeRectArray
};

/************************************************************************
 *			      Static methods				*
 ************************************************************************/

//
// public static soot.jimple.toolkits.annotation.arraycheck.ArrayBoundsChecker v()
//

static _jc_linenum _jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$linenum_table$v$6cb273f617b5a17d[];

static const unsigned char _jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$param_ptypes$v$6cb273f617b5a17d[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$method_info$v$6cb273f617b5a17d = {
	.name=			"v",
	.signature=		"()Lsoot/jimple/toolkits/annotation/arraycheck/ArrayBoundsChecker;",
	.class=			&_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$type,
	.return_type=		&_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$type,
	.param_ptypes=		&_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$param_ptypes$v$6cb273f617b5a17d,
	.signature_hash=	_JC_JLONG(0x6cb273f617b5a17d),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$method$v$6cb273f617b5a17d,
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$linenum_table$v$6cb273f617b5a17d
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker, v$6cb273f617b5a17d);

_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$object * _JC_JCNI_ATTR
_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$method$v$6cb273f617b5a17d(_jc_env *const env)
{
	struct _jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$object *r1;
	struct _jc_soot_G$object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	_JC_ACTIVE_USE(env, soot_G);
	_JC_LINE_NUMBER(41);				// 0
	r2 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r1 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, ArrayBoundsChecker$182d59a1861dbdc5, r2);
	return r1;
}

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// public void <init>(soot.Singletons$Global)
//

static _jc_linenum _jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$linenum_table$_init$bbe94f634b20986f[];

static const unsigned char _jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$param_ptypes$_init$bbe94f634b20986f[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$param_types$_init$bbe94f634b20986f[] = {
	&_jc_soot_Singletons__24Global$type
};

_jc_method _jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$method_info$_init$bbe94f634b20986f = {
	.name=			"<init>",
	.signature=		"(Lsoot/Singletons$Global;)V",
	.class=			&_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$type,
	.param_types=		&_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$param_types$_init$bbe94f634b20986f,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$param_ptypes$_init$bbe94f634b20986f,
	.signature_hash=	_JC_JLONG(0xbbe94f634b20986f),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$method$_init$bbe94f634b20986f,
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	7,
	      .table=	_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$linenum_table$_init$bbe94f634b20986f
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker, _init$bbe94f634b20986f);

void _JC_JCNI_ATTR
_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$method$_init$bbe94f634b20986f(_jc_env *const env, _jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$object *this, _jc_soot_Singletons__24Global$object *param0)
{
	struct _jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$object *r0;
	struct _jc_soot_Singletons__24Global$object *r1;

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(43);				// 0
	_JC_PRIM_FIELD(env, r0, soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker, takeClassField) = 0;
	_JC_LINE_NUMBER(44);				// 1
	_JC_PRIM_FIELD(env, r0, soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker, takeFieldRef) = 0;
	_JC_LINE_NUMBER(45);				// 2
	_JC_PRIM_FIELD(env, r0, soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker, takeArrayRef) = 0;
	_JC_LINE_NUMBER(46);				// 3
	_JC_PRIM_FIELD(env, r0, soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker, takeCSE) = 0;
	_JC_LINE_NUMBER(47);				// 4
	_JC_PRIM_FIELD(env, r0, soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker, takeRectArray) = 0;
	_JC_LINE_NUMBER(48);				// 5
	_JC_PRIM_FIELD(env, r0, soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker, addColorTags) = 0;
	_JC_LINE_NUMBER(40);				// 6
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// private boolean hasArrayLocals(soot.Body)
//

static _jc_linenum _jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$linenum_table$hasArrayLocals$fecefe2e35648963[];

static const unsigned char _jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$param_ptypes$hasArrayLocals$fecefe2e35648963[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$param_types$hasArrayLocals$fecefe2e35648963[] = {
	&_jc_soot_Body$type
};

_jc_method _jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$method_info$hasArrayLocals$fecefe2e35648963 = {
	.name=			"hasArrayLocals",
	.signature=		"(Lsoot/Body;)Z",
	.class=			&_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$type,
	.param_types=		&_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$param_types$hasArrayLocals$fecefe2e35648963,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$param_ptypes$hasArrayLocals$fecefe2e35648963,
	.signature_hash=	_JC_JLONG(0xfecefe2e35648963),
	.access_flags=		_JC_ACC_PRIVATE,
	.function=		&_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$method$hasArrayLocals$fecefe2e35648963,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$vtable, soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker.hasArrayLocals$fecefe2e35648963) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	6,
	      .table=	_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$linenum_table$hasArrayLocals$fecefe2e35648963
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker, hasArrayLocals$fecefe2e35648963);

jboolean _JC_JCNI_ATTR
_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$method$hasArrayLocals$fecefe2e35648963(_jc_env *const env, _jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$object *this, _jc_soot_Body$object *param0)
{
	struct _jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$object *r0;
	struct _jc_soot_Body$object *r1;
	struct _jc_object *r2;
	struct _jc_object *r3;
	struct _jc_object *r4;
	struct _jc_java_lang_Object$object *r5;
	struct _jc_soot_Type$object *r6;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(298);				// 0
	r4 = _JC_INVOKE_VIRTUAL(env, soot_Body, getLocals$7da76f1336483081, r1);
	r2 = _JC_INVOKE_INTERFACE(env, r4, _JC_JLONG(0x3cc91493d50f531c), _jc_object *, (_jc_env *, struct _jc_object *));

label0:
	_JC_LINE_NUMBER(300);				// 1
	z0 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0xfb0bd5e38c59ddcd), jboolean, (_jc_env *, struct _jc_object *));
	if (z0 == 0)
		goto label1;
	_JC_LINE_NUMBER(302);				// 2
	r5 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0x5874f79a1cf66ea), _jc_object *, (_jc_env *, struct _jc_object *));
	r3 = _JC_CAST(env, &_jc_soot_Local$type, r5);
	_JC_LINE_NUMBER(303);				// 3
	r6 = _JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0x847707b1f3b96fef), _jc_object *, (_jc_env *, struct _jc_object *));
	z0 = _JC_INSTANCEOF(env, r6, &_jc_soot_ArrayType$type);
	if (z0 == 0) {
		_JC_PERIODIC_CHECK(env);
		goto label0;
	}
	_JC_LINE_NUMBER(304);				// 4
	return 1;

label1:
	_JC_LINE_NUMBER(307);				// 5
	return 0;
}

//
// protected void internalTransform(soot.Body, java.lang.String, java.util.Map)
//

static _jc_linenum _jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$linenum_table$internalTransform$9abd4924859b68a3[];

static const unsigned char _jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$param_ptypes$internalTransform$9abd4924859b68a3[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$param_types$internalTransform$9abd4924859b68a3[] = {
	&_jc_soot_Body$type,
	&_jc_java_lang_String$type,
	&_jc_java_util_Map$type
};

_jc_method _jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$method_info$internalTransform$9abd4924859b68a3 = {
	.name=			"internalTransform",
	.signature=		"(Lsoot/Body;Ljava/lang/String;Ljava/util/Map;)V",
	.class=			&_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$type,
	.param_types=		&_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$param_types$internalTransform$9abd4924859b68a3,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$param_ptypes$internalTransform$9abd4924859b68a3,
	.signature_hash=	_JC_JLONG(0x9abd4924859b68a3),
	.access_flags=		_JC_ACC_PROTECTED,
	.function=		&_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$method$internalTransform$9abd4924859b68a3,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$vtable, soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker.internalTransform$9abd4924859b68a3) / sizeof(void *),
	.num_parameters=	3,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	95,
	      .table=	_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$linenum_table$internalTransform$9abd4924859b68a3
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker, internalTransform$9abd4924859b68a3);

void _JC_JCNI_ATTR
_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$method$internalTransform$9abd4924859b68a3(_jc_env *const env, _jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$object *this, _jc_soot_Body$object *param0, _jc_java_lang_String$object *param1, _jc_object *param2)
{
	struct {
		struct _jc_soot_options_ABCOptions$refs	refs;
		struct _jc_soot_options_ABCOptions$object	obj;
	} mem0;
	jint i0;
	jlong l1;
	jlong l2;
	jlong l3;
	jlong l4;
	jlong l5;
	jlong l6;
	struct _jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$object *r0;
	struct _jc_soot_Body$object *r1;
	struct _jc_soot_jimple_toolkits_annotation_arraycheck_IntContainer$object *r10;
	struct _jc_object *r102;
	struct _jc_object *r103;
	struct _jc_object *r104;
	struct _jc_java_lang_Object$object *r105;
	struct _jc_soot_Type$object *r106;
	struct _jc_object *r11;
	struct _jc_object *r12;
	struct _jc_object *r13;
	struct _jc_soot_jimple_toolkits_annotation_arraycheck_WeightedDirectedSparseGraph$object *r14;
	struct _jc_soot_SootClass$object *r15;
	struct _jc_object *r16;
	struct _jc_java_io_PrintStream$object *r17;
	struct _jc_java_lang_StringBuffer$object *r18;
	struct _jc_java_lang_Object$object *r19;
	struct _jc_java_lang_String$object *r2;
	struct _jc_object *r20;
	struct _jc_soot_tagkit_ColorTag$object *r21;
	struct _jc_soot_SootMethod$object *r22;
	struct _jc_object *r23;
	struct _jc_soot_tagkit_KeyTag$object *r24;
	struct _jc_object *r25;
	struct _jc_object *r26;
	struct _jc_soot_jimple_toolkits_annotation_tags_ArrayCheckTag$object *r27;
	struct _jc_object *r28;
	struct _jc_soot_Type$object *r29;
	struct _jc_object *r3;
	struct _jc_soot_ArrayType$object *r30;
	struct _jc_soot_jimple_toolkits_annotation_arraycheck_MethodLocal$object *r31;
	struct _jc_object *r32;
	struct _jc_java_util_Date$object *r33;
	struct _jc_soot_G$object *r34;
	struct _jc_soot_G$object *r35;
	struct _jc_soot_G$object *r36;
	struct _jc_object *r37;
	struct _jc_object *r38;
	struct _jc_object *r39;
	struct _jc_soot_options_ABCOptions$object *r4;
	struct _jc_object *r40;
	struct _jc_object *r41;
	struct _jc_object *r42;
	struct _jc_object *r43;
	struct _jc_soot_options_Options$object *r44;
	struct _jc_soot_G$object *r45;
	struct _jc_java_lang_String$object *r46;
	struct _jc_java_lang_String$object *r47;
	struct _jc_object *r48;
	struct _jc_soot_Scene$object *r49;
	struct _jc_soot_SootMethod$object *r5;
	struct _jc_soot_G$object *r50;
	struct _jc_object *r51;
	struct _jc_soot_jimple_Jimple$object *r52;
	struct _jc_soot_G$object *r53;
	struct _jc_soot_jimple_Jimple$object *r54;
	struct _jc_soot_G$object *r55;
	struct _jc_soot_jimple_IntConstant$object *r56;
	struct _jc_soot_jimple_Jimple$object *r57;
	struct _jc_soot_G$object *r58;
	struct _jc_soot_jimple_Jimple$object *r59;
	struct _jc_java_util_Date$object *r6;
	struct _jc_soot_G$object *r60;
	struct _jc_soot_jimple_IntConstant$object *r61;
	struct _jc_soot_jimple_toolkits_annotation_arraycheck_RectangularArrayFinder$object *r62;
	struct _jc_soot_G$object *r63;
	struct _jc_soot_options_Options$object *r64;
	struct _jc_soot_G$object *r65;
	struct _jc_java_lang_StringBuffer$object *r66;
	struct _jc_java_lang_String$object *r67;
	struct _jc_java_lang_StringBuffer$object *r68;
	struct _jc_java_lang_String$object *r69;
	struct _jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsCheckerAnalysis$object *r7;
	struct _jc_java_lang_String$object *r70;
	_jc_char_array *r71;
	_jc_char_array *r72;
	_jc_char_array *r73;
	struct _jc_java_lang_StringBuffer$object *r74;
	struct _jc_java_lang_String$object *r75;
	struct _jc_java_lang_String$object *r76;
	struct _jc_java_lang_String$object *r77;
	struct _jc_java_lang_String$object *r78;
	struct _jc_java_lang_String$object *r79;
	struct _jc_soot_SootMethod$object *r8;
	struct _jc_java_lang_StringBuffer$object *r80;
	struct _jc_java_lang_String$object *r81;
	struct _jc_java_lang_String$object *r82;
	struct _jc_java_lang_Object$object *r83;
	struct _jc_java_lang_String$object *r84;
	struct _jc_java_lang_Object$object *r85;
	struct _jc_java_lang_String$object *r86;
	struct _jc_java_lang_Object$object *r87;
	struct _jc_java_lang_String$object *r88;
	struct _jc_java_lang_Object$object *r89;
	struct _jc_soot_PatchingChain$object *r9;
	struct _jc_java_lang_String$object *r90;
	struct _jc_java_lang_Object$object *r91;
	struct _jc_java_lang_String$object *r92;
	struct _jc_java_lang_Object$object *r93;
	struct _jc_java_lang_String$object *r94;
	struct _jc_java_lang_Object$object *r95;
	struct _jc_java_lang_String$object *r96;
	struct _jc_java_lang_Object$object *r97;
	struct _jc_java_lang_String$object *r98;
	struct _jc_java_lang_Object$object *r99;
	jboolean z0;
	jboolean z1;
	jboolean z10;
	jboolean z11;
	jboolean z12;
	jboolean z13;
	jboolean z14;
	jboolean z2;
	jboolean z3;
	jboolean z4;
	jboolean z5;
	jboolean z6;
	jboolean z7;
	jboolean z8;
	jboolean z9;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	r3 = param2;
	_JC_LINE_NUMBER(52);				// 0
	r4 = _JC_STACK_NEW(env, &mem0, soot_options_ABCOptions);
	_JC_REF_FIELD(env, r4, soot_options_ABCOptions, options) = r3;
	r37 = _JC_REF_FIELD(env, r4, soot_options_ABCOptions, options);
	_JC_ACTIVE_USE(env, soot_PhaseOptions);
	r82 = _JC_STRING(env, "with-all");
	z5 = _JC_INVOKE_INTERFACE(env, r37, _JC_JLONG(0x5db565349ffc17b2), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r82);
	if (z5 == 0)
		goto label0;
	r83 = _JC_INVOKE_INTERFACE(env, r37, _JC_JLONG(0xb30461fc5ea13399), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r82);
	z5 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, equals$8a15e0625571c581, r83, _JC_STRING(env, "true"));
	if (z5 == 0)
		goto label0;
	z5 = 1;
	goto label1;

label0:
	z5 = 0;

label1:
	_JC_LINE_NUMBER(53);				// 1
	if (z5 == 0)
		goto label2;
	_JC_LINE_NUMBER(55);				// 2
	_JC_PRIM_FIELD(env, r0, soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker, takeClassField) = 1;
	_JC_LINE_NUMBER(56);				// 3
	_JC_PRIM_FIELD(env, r0, soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker, takeFieldRef) = 1;
	_JC_LINE_NUMBER(57);				// 4
	_JC_PRIM_FIELD(env, r0, soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker, takeArrayRef) = 1;
	_JC_LINE_NUMBER(58);				// 5
	_JC_PRIM_FIELD(env, r0, soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker, takeCSE) = 1;
	_JC_LINE_NUMBER(59);				// 6
	_JC_PRIM_FIELD(env, r0, soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker, takeRectArray) = 1;
	goto label13;

label2:
	r38 = _JC_REF_FIELD(env, r4, soot_options_ABCOptions, options);
	r84 = _JC_STRING(env, "with-classfield");
	z6 = _JC_INVOKE_INTERFACE(env, r38, _JC_JLONG(0x5db565349ffc17b2), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r84);
	if (z6 == 0)
		goto label3;
	r85 = _JC_INVOKE_INTERFACE(env, r38, _JC_JLONG(0xb30461fc5ea13399), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r84);
	z6 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, equals$8a15e0625571c581, r85, _JC_STRING(env, "true"));
	if (z6 == 0)
		goto label3;
	z6 = 1;
	goto label4;

label3:
	z6 = 0;

label4:
	_JC_LINE_NUMBER(63);				// 7
	_JC_PRIM_FIELD(env, r0, soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker, takeClassField) = z6;
	r39 = _JC_REF_FIELD(env, r4, soot_options_ABCOptions, options);
	r86 = _JC_STRING(env, "with-fieldref");
	z7 = _JC_INVOKE_INTERFACE(env, r39, _JC_JLONG(0x5db565349ffc17b2), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r86);
	if (z7 == 0)
		goto label5;
	r87 = _JC_INVOKE_INTERFACE(env, r39, _JC_JLONG(0xb30461fc5ea13399), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r86);
	z7 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, equals$8a15e0625571c581, r87, _JC_STRING(env, "true"));
	if (z7 == 0)
		goto label5;
	z7 = 1;
	goto label6;

label5:
	z7 = 0;

label6:
	_JC_LINE_NUMBER(64);				// 8
	_JC_PRIM_FIELD(env, r0, soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker, takeFieldRef) = z7;
	r40 = _JC_REF_FIELD(env, r4, soot_options_ABCOptions, options);
	r88 = _JC_STRING(env, "with-arrayref");
	z8 = _JC_INVOKE_INTERFACE(env, r40, _JC_JLONG(0x5db565349ffc17b2), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r88);
	if (z8 == 0)
		goto label7;
	r89 = _JC_INVOKE_INTERFACE(env, r40, _JC_JLONG(0xb30461fc5ea13399), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r88);
	z8 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, equals$8a15e0625571c581, r89, _JC_STRING(env, "true"));
	if (z8 == 0)
		goto label7;
	z8 = 1;
	goto label8;

label7:
	z8 = 0;

label8:
	_JC_LINE_NUMBER(65);				// 9
	_JC_PRIM_FIELD(env, r0, soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker, takeArrayRef) = z8;
	r41 = _JC_REF_FIELD(env, r4, soot_options_ABCOptions, options);
	r90 = _JC_STRING(env, "with-cse");
	z9 = _JC_INVOKE_INTERFACE(env, r41, _JC_JLONG(0x5db565349ffc17b2), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r90);
	if (z9 == 0)
		goto label9;
	r91 = _JC_INVOKE_INTERFACE(env, r41, _JC_JLONG(0xb30461fc5ea13399), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r90);
	z9 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, equals$8a15e0625571c581, r91, _JC_STRING(env, "true"));
	if (z9 == 0)
		goto label9;
	z9 = 1;
	goto label10;

label9:
	z9 = 0;

label10:
	_JC_LINE_NUMBER(66);				// 10
	_JC_PRIM_FIELD(env, r0, soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker, takeCSE) = z9;
	r42 = _JC_REF_FIELD(env, r4, soot_options_ABCOptions, options);
	r92 = _JC_STRING(env, "with-rectarray");
	z10 = _JC_INVOKE_INTERFACE(env, r42, _JC_JLONG(0x5db565349ffc17b2), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r92);
	if (z10 == 0)
		goto label11;
	r93 = _JC_INVOKE_INTERFACE(env, r42, _JC_JLONG(0xb30461fc5ea13399), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r92);
	z10 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, equals$8a15e0625571c581, r93, _JC_STRING(env, "true"));
	if (z10 == 0)
		goto label11;
	z10 = 1;
	goto label12;

label11:
	z10 = 0;

label12:
	_JC_LINE_NUMBER(67);				// 11
	_JC_PRIM_FIELD(env, r0, soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker, takeRectArray) = z10;

label13:
	r43 = _JC_REF_FIELD(env, r4, soot_options_ABCOptions, options);
	r94 = _JC_STRING(env, "add-color-tags");
	z11 = _JC_INVOKE_INTERFACE(env, r43, _JC_JLONG(0x5db565349ffc17b2), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r94);
	if (z11 == 0)
		goto label14;
	r95 = _JC_INVOKE_INTERFACE(env, r43, _JC_JLONG(0xb30461fc5ea13399), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r94);
	z11 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, equals$8a15e0625571c581, r95, _JC_STRING(env, "true"));
	if (z11 == 0)
		goto label14;
	z11 = 1;
	goto label15;

label14:
	z11 = 0;

label15:
	_JC_LINE_NUMBER(70);				// 12
	_JC_PRIM_FIELD(env, r0, soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker, addColorTags) = z11;
	_JC_LINE_NUMBER(73);				// 13
	r5 = _JC_INVOKE_VIRTUAL(env, soot_Body, getMethod$04d7c221deab35ce, r1);
	_JC_LINE_NUMBER(75);				// 14
	r6 = _JC_NEW(env, java_util_Date);
	_JC_ACTIVE_USE(env, java_lang_System);
	l5 = _JC_INVOKE_STATIC(env, java_lang_VMSystem, currentTimeMillis$f4fdeb31d00e9185, 0);
	_JC_PRIM_FIELD(env, r6, java_util_Date, time) = l5;
	_JC_ACTIVE_USE(env, soot_options_Options);
	_JC_ACTIVE_USE(env, soot_G);
	_JC_LINE_NUMBER(77);				// 15
	r45 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r44 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Options$9fd4168abe5957f7, r45);
	z2 = _JC_INVOKE_VIRTUAL(env, soot_options_Options, verbose$e5b65d4727121643, r44);
	if (z2 == 0)
		goto label18;
	_JC_LINE_NUMBER(79);				// 16
	r34 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r17 = _JC_REF_FIELD(env, r34, soot_G, out);
	r18 = _JC_NEW(env, java_lang_StringBuffer);
	r71 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r18, java_lang_StringBuffer, value) = r71;
	r18 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r18, _JC_STRING(env, "[abc] Analyzing array bounds information for "));
	r2 = _JC_INVOKE_VIRTUAL(env, soot_SootMethod, getName$bec186f2ce7e1882, r5);
	r18 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r18, r2);
	r46 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r46, r18);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, println$f7dbc2aa0f0a9d4f, r17, r46);
	_JC_LINE_NUMBER(80);				// 17
	r35 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r17 = _JC_REF_FIELD(env, r35, soot_G, out);
	r18 = _JC_NEW(env, java_lang_StringBuffer);
	r72 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r18, java_lang_StringBuffer, value) = r72;
	r18 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r18, _JC_STRING(env, "[abc] Started on "));
	r74 = r18;
	if (r6 != _JC_NULL)
		goto label16;
	r75 = _JC_STRING(env, "null");
	goto label17;

label16:
	r75 = _JC_INVOKE_NONVIRTUAL(env, java_util_Date, toString$7ea43b33b80a3070, 0, r6);

label17:
	r74 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r74, r75);
	r47 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r47, r74);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, println$f7dbc2aa0f0a9d4f, r17, r47);

label18:
	_JC_LINE_NUMBER(83);				// 18
	r7 = _JC_NULL;
	r104 = _JC_INVOKE_VIRTUAL(env, soot_Body, getLocals$7da76f1336483081, r1);
	r102 = _JC_INVOKE_INTERFACE(env, r104, _JC_JLONG(0x3cc91493d50f531c), _jc_object *, (_jc_env *, struct _jc_object *));

label19:
	z14 = _JC_INVOKE_INTERFACE(env, r102, _JC_JLONG(0xfb0bd5e38c59ddcd), jboolean, (_jc_env *, struct _jc_object *));
	if (z14 == 0)
		goto label20;
	r105 = _JC_INVOKE_INTERFACE(env, r102, _JC_JLONG(0x5874f79a1cf66ea), _jc_object *, (_jc_env *, struct _jc_object *));
	r103 = _JC_CAST(env, &_jc_soot_Local$type, r105);
	r106 = _JC_INVOKE_INTERFACE(env, r103, _JC_JLONG(0x847707b1f3b96fef), _jc_object *, (_jc_env *, struct _jc_object *));
	z14 = _JC_INSTANCEOF(env, r106, &_jc_soot_ArrayType$type);
	if (z14 == 0) {
		_JC_PERIODIC_CHECK(env);
		goto label19;
	}
	z2 = 1;
	goto label21;

label20:
	z2 = 0;

label21:
	_JC_LINE_NUMBER(85);				// 19
	if (z2 == 0)
		goto label22;
	_JC_LINE_NUMBER(87);				// 20
	r7 = _JC_NEW(env, soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsCheckerAnalysis);
	z2 = _JC_PRIM_FIELD(env, r0, soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker, takeClassField);
	z1 = _JC_PRIM_FIELD(env, r0, soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker, takeFieldRef);
	z0 = _JC_PRIM_FIELD(env, r0, soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker, takeArrayRef);
	z3 = _JC_PRIM_FIELD(env, r0, soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker, takeCSE);
	z4 = _JC_PRIM_FIELD(env, r0, soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker, takeRectArray);
	_JC_INVOKE_NONVIRTUAL(env, soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsCheckerAnalysis, _init$1a538018bd100a24, 0, r7, r1, z2, z1, z0, z3, z4);

label22:
	_JC_LINE_NUMBER(97);				// 21
	r8 = _JC_NULL;
	r48 = _JC_REF_FIELD(env, r4, soot_options_ABCOptions, options);
	_JC_ACTIVE_USE(env, soot_PhaseOptions);
	r96 = _JC_STRING(env, "profiling");
	z12 = _JC_INVOKE_INTERFACE(env, r48, _JC_JLONG(0x5db565349ffc17b2), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r96);
	if (z12 == 0)
		goto label23;
	r97 = _JC_INVOKE_INTERFACE(env, r48, _JC_JLONG(0xb30461fc5ea13399), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r96);
	z12 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, equals$8a15e0625571c581, r97, _JC_STRING(env, "true"));
	if (z12 == 0)
		goto label23;
	z12 = 1;
	goto label24;

label23:
	z12 = 0;

label24:
	_JC_LINE_NUMBER(99);				// 22
	if (z12 == 0)
		goto label25;
	_JC_ACTIVE_USE(env, soot_Scene);
	_JC_ACTIVE_USE(env, soot_G);
	_JC_LINE_NUMBER(101);				// 23
	r50 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r49 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Scene$3451207662ac1af0, r50);
	r15 = _JC_INVOKE_VIRTUAL(env, soot_Scene, loadClassAndSupport$72ed099e753d28fd, r49, _JC_STRING(env, "MultiCounter"));
	_JC_LINE_NUMBER(102);				// 24
	r8 = _JC_INVOKE_VIRTUAL(env, soot_SootClass, getMethod$1f7f4a1c0c1ecc50, r15, _JC_STRING(env, "void increase(int)"));

label25:
	_JC_LINE_NUMBER(105);				// 25
	r9 = _JC_INVOKE_VIRTUAL(env, soot_Body, getUnits$23294b6006422b2b, r1);
	_JC_LINE_NUMBER(107);				// 26
	r10 = _JC_NEW(env, soot_jimple_toolkits_annotation_arraycheck_IntContainer);
	_JC_PRIM_FIELD(env, r10, soot_jimple_toolkits_annotation_arraycheck_IntContainer, value) = 0;
	_JC_LINE_NUMBER(109);				// 27
	r11 = _JC_INVOKE_INTERFACE(env, r9, _JC_JLONG(0xe52819c43eac0f77), _jc_object *, (_jc_env *, struct _jc_object *));

label26:
	_JC_LINE_NUMBER(111);				// 28
	z4 = _JC_INVOKE_INTERFACE(env, r11, _JC_JLONG(0xfb0bd5e38c59ddcd), jboolean, (_jc_env *, struct _jc_object *));
	if (z4 == 0)
		goto label43;
	_JC_LINE_NUMBER(113);				// 29
	r19 = _JC_INVOKE_INTERFACE(env, r11, _JC_JLONG(0x5874f79a1cf66ea), _jc_object *, (_jc_env *, struct _jc_object *));
	r12 = _JC_CAST(env, &_jc_soot_jimple_Stmt$type, r19);
	_JC_LINE_NUMBER(115);				// 30
	z4 = _JC_INVOKE_INTERFACE(env, r12, _JC_JLONG(0xf1635e7c1271e21), jboolean, (_jc_env *, struct _jc_object *));
	if (z4 == 0) {
		_JC_PERIODIC_CHECK(env);
		goto label26;
	}
	_JC_LINE_NUMBER(117);				// 31
	r13 = _JC_INVOKE_INTERFACE(env, r12, _JC_JLONG(0xaa71f347c0d6cd93), _jc_object *, (_jc_env *, struct _jc_object *));
	_JC_LINE_NUMBER(120);				// 32
	r19 = _JC_INVOKE_VIRTUAL(env, soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsCheckerAnalysis, getFlowBefore$af587dd021ceb8ac, r7, r12);
	r14 = _JC_CAST(env, &_jc_soot_jimple_toolkits_annotation_arraycheck_WeightedDirectedSparseGraph$type, r19);
	_JC_LINE_NUMBER(123);				// 33
	i0 = _JC_INVOKE_VIRTUAL(env, soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker, interpretGraph$045eda43ea97a5f1, r0, r14, r13, r12, r10);
	_JC_LINE_NUMBER(125);				// 34
	z0 = 1;
	_JC_LINE_NUMBER(126);				// 35
	z1 = 1;
	_JC_LINE_NUMBER(128);				// 36
	if (i0 != 0)
		goto label27;
	_JC_LINE_NUMBER(129);				// 37
	z0 = 1;
	_JC_LINE_NUMBER(130);				// 38
	z1 = 1;
	goto label30;

label27:
	_JC_LINE_NUMBER(132);				// 39
	if (i0 != 1)
		goto label28;
	_JC_LINE_NUMBER(133);				// 40
	z0 = 1;
	_JC_LINE_NUMBER(134);				// 41
	z1 = 0;
	goto label30;

label28:
	_JC_LINE_NUMBER(136);				// 42
	if (i0 != 2)
		goto label29;
	_JC_LINE_NUMBER(137);				// 43
	z0 = 0;
	_JC_LINE_NUMBER(138);				// 44
	z1 = 1;
	goto label30;

label29:
	_JC_LINE_NUMBER(140);				// 45
	if (i0 != 3)
		goto label30;
	_JC_LINE_NUMBER(141);				// 46
	z0 = 0;
	_JC_LINE_NUMBER(142);				// 47
	z1 = 0;

label30:
	_JC_LINE_NUMBER(145);				// 48
	z4 = _JC_PRIM_FIELD(env, r0, soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker, addColorTags);
	if (z4 == 0)
		goto label37;
	_JC_LINE_NUMBER(146);				// 49
	if (i0 != 0)
		goto label31;
	_JC_LINE_NUMBER(147);				// 50
	r20 = _JC_INVOKE_INTERFACE(env, r13, _JC_JLONG(0x417eb362397670fa), _jc_object *, (_jc_env *, struct _jc_object *));
	r21 = _JC_NEW(env, soot_tagkit_ColorTag);
	_JC_PRIM_FIELD(env, r21, soot_tagkit_ColorTag, foreground) = 0;
	_JC_PRIM_FIELD(env, r21, soot_tagkit_ColorTag, red) = 255;
	_JC_PRIM_FIELD(env, r21, soot_tagkit_ColorTag, green) = 0;
	_JC_PRIM_FIELD(env, r21, soot_tagkit_ColorTag, blue) = 0;
	_JC_PRIM_FIELD(env, r21, soot_tagkit_ColorTag, foreground) = 0;
	_JC_INVOKE_INTERFACE(env, r20, _JC_JLONG(0xf92b02979eb63079), void, (_jc_env *, struct _jc_object *, struct _jc_object *), r21);
	goto label34;

label31:
	_JC_LINE_NUMBER(149);				// 51
	if (i0 != 1)
		goto label32;
	_JC_LINE_NUMBER(150);				// 52
	r20 = _JC_INVOKE_INTERFACE(env, r13, _JC_JLONG(0x417eb362397670fa), _jc_object *, (_jc_env *, struct _jc_object *));
	r21 = _JC_NEW(env, soot_tagkit_ColorTag);
	_JC_PRIM_FIELD(env, r21, soot_tagkit_ColorTag, foreground) = 0;
	_JC_PRIM_FIELD(env, r21, soot_tagkit_ColorTag, red) = 255;
	_JC_PRIM_FIELD(env, r21, soot_tagkit_ColorTag, green) = 248;
	_JC_PRIM_FIELD(env, r21, soot_tagkit_ColorTag, blue) = 35;
	_JC_PRIM_FIELD(env, r21, soot_tagkit_ColorTag, foreground) = 0;
	_JC_INVOKE_INTERFACE(env, r20, _JC_JLONG(0xf92b02979eb63079), void, (_jc_env *, struct _jc_object *, struct _jc_object *), r21);
	goto label34;

label32:
	_JC_LINE_NUMBER(152);				// 53
	if (i0 != 2)
		goto label33;
	_JC_LINE_NUMBER(153);				// 54
	r20 = _JC_INVOKE_INTERFACE(env, r13, _JC_JLONG(0x417eb362397670fa), _jc_object *, (_jc_env *, struct _jc_object *));
	r21 = _JC_NEW(env, soot_tagkit_ColorTag);
	_JC_PRIM_FIELD(env, r21, soot_tagkit_ColorTag, foreground) = 0;
	_JC_PRIM_FIELD(env, r21, soot_tagkit_ColorTag, red) = 255;
	_JC_PRIM_FIELD(env, r21, soot_tagkit_ColorTag, green) = 163;
	_JC_PRIM_FIELD(env, r21, soot_tagkit_ColorTag, blue) = 0;
	_JC_PRIM_FIELD(env, r21, soot_tagkit_ColorTag, foreground) = 0;
	_JC_INVOKE_INTERFACE(env, r20, _JC_JLONG(0xf92b02979eb63079), void, (_jc_env *, struct _jc_object *, struct _jc_object *), r21);
	goto label34;

label33:
	_JC_LINE_NUMBER(155);				// 55
	if (i0 != 3)
		goto label34;
	_JC_LINE_NUMBER(156);				// 56
	r20 = _JC_INVOKE_INTERFACE(env, r13, _JC_JLONG(0x417eb362397670fa), _jc_object *, (_jc_env *, struct _jc_object *));
	r21 = _JC_NEW(env, soot_tagkit_ColorTag);
	_JC_PRIM_FIELD(env, r21, soot_tagkit_ColorTag, foreground) = 0;
	_JC_PRIM_FIELD(env, r21, soot_tagkit_ColorTag, red) = 45;
	_JC_PRIM_FIELD(env, r21, soot_tagkit_ColorTag, green) = 255;
	_JC_PRIM_FIELD(env, r21, soot_tagkit_ColorTag, blue) = 84;
	_JC_PRIM_FIELD(env, r21, soot_tagkit_ColorTag, foreground) = 0;
	_JC_INVOKE_INTERFACE(env, r20, _JC_JLONG(0xf92b02979eb63079), void, (_jc_env *, struct _jc_object *, struct _jc_object *), r21);

label34:
	_JC_LINE_NUMBER(158);				// 57
	r22 = _JC_INVOKE_VIRTUAL(env, soot_Body, getMethod$04d7c221deab35ce, r1);
	r15 = _JC_INVOKE_VIRTUAL(env, soot_SootMethod, getDeclaringClass$dd2382a1f7813acf, r22);
	_JC_LINE_NUMBER(159);				// 58
	r23 = _JC_INVOKE_VIRTUAL(env, soot_tagkit_AbstractHost, getTags$72c6cad503d16b00, r15);
	r16 = _JC_INVOKE_INTERFACE(env, r23, _JC_JLONG(0x3cc91493d50f531c), _jc_object *, (_jc_env *, struct _jc_object *));
	_JC_LINE_NUMBER(160);				// 59
	z2 = 0;

label35:
	_JC_LINE_NUMBER(161);				// 60
	z4 = _JC_INVOKE_INTERFACE(env, r16, _JC_JLONG(0xfb0bd5e38c59ddcd), jboolean, (_jc_env *, struct _jc_object *));
	if (z4 == 0)
		goto label36;
	_JC_LINE_NUMBER(162);				// 61
	r19 = _JC_INVOKE_INTERFACE(env, r16, _JC_JLONG(0x5874f79a1cf66ea), _jc_object *, (_jc_env *, struct _jc_object *));
	z4 = _JC_INSTANCEOF(env, r19, &_jc_soot_tagkit_KeyTag$type);
	if (z4 == 0) {
		_JC_PERIODIC_CHECK(env);
		goto label35;
	}
	_JC_LINE_NUMBER(163);				// 62
	z2 = 1;
	_JC_PERIODIC_CHECK(env);
	goto label35;

label36:
	_JC_LINE_NUMBER(166);				// 63
	if (z2 != 0)
		goto label37;
	_JC_LINE_NUMBER(167);				// 64
	r24 = _JC_NEW(env, soot_tagkit_KeyTag);
	r76 = _JC_STRING(env, "ArrayBounds: Unsafe Lower and Unsafe Upper");
	_JC_PRIM_FIELD(env, r24, soot_tagkit_KeyTag, red) = 255;
	_JC_PRIM_FIELD(env, r24, soot_tagkit_KeyTag, green) = 0;
	_JC_PRIM_FIELD(env, r24, soot_tagkit_KeyTag, blue) = 0;
	_JC_REF_FIELD(env, r24, soot_tagkit_KeyTag, key) = r76;
	_JC_INVOKE_VIRTUAL(env, soot_tagkit_AbstractHost, addTag$f92b02979eb63079, r15, r24);
	_JC_LINE_NUMBER(168);				// 65
	r24 = _JC_NEW(env, soot_tagkit_KeyTag);
	r77 = _JC_STRING(env, "ArrayBounds: Unsafe Lower and Safe Upper");
	_JC_PRIM_FIELD(env, r24, soot_tagkit_KeyTag, red) = 255;
	_JC_PRIM_FIELD(env, r24, soot_tagkit_KeyTag, green) = 248;
	_JC_PRIM_FIELD(env, r24, soot_tagkit_KeyTag, blue) = 35;
	_JC_REF_FIELD(env, r24, soot_tagkit_KeyTag, key) = r77;
	_JC_INVOKE_VIRTUAL(env, soot_tagkit_AbstractHost, addTag$f92b02979eb63079, r15, r24);
	_JC_LINE_NUMBER(169);				// 66
	r24 = _JC_NEW(env, soot_tagkit_KeyTag);
	r78 = _JC_STRING(env, "ArrayBounds: Safe Lower and Unsafe Upper");
	_JC_PRIM_FIELD(env, r24, soot_tagkit_KeyTag, red) = 255;
	_JC_PRIM_FIELD(env, r24, soot_tagkit_KeyTag, green) = 163;
	_JC_PRIM_FIELD(env, r24, soot_tagkit_KeyTag, blue) = 0;
	_JC_REF_FIELD(env, r24, soot_tagkit_KeyTag, key) = r78;
	_JC_INVOKE_VIRTUAL(env, soot_tagkit_AbstractHost, addTag$f92b02979eb63079, r15, r24);
	_JC_LINE_NUMBER(170);				// 67
	r24 = _JC_NEW(env, soot_tagkit_KeyTag);
	r79 = _JC_STRING(env, "ArrayBounds: Safe Lower and Safe Upper");
	_JC_PRIM_FIELD(env, r24, soot_tagkit_KeyTag, red) = 45;
	_JC_PRIM_FIELD(env, r24, soot_tagkit_KeyTag, green) = 255;
	_JC_PRIM_FIELD(env, r24, soot_tagkit_KeyTag, blue) = 84;
	_JC_REF_FIELD(env, r24, soot_tagkit_KeyTag, key) = r79;
	_JC_INVOKE_VIRTUAL(env, soot_tagkit_AbstractHost, addTag$f92b02979eb63079, r15, r24);

label37:
	r51 = _JC_REF_FIELD(env, r4, soot_options_ABCOptions, options);
	_JC_ACTIVE_USE(env, soot_PhaseOptions);
	r98 = _JC_STRING(env, "profiling");
	z13 = _JC_INVOKE_INTERFACE(env, r51, _JC_JLONG(0x5db565349ffc17b2), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r98);
	if (z13 == 0)
		goto label38;
	r99 = _JC_INVOKE_INTERFACE(env, r51, _JC_JLONG(0xb30461fc5ea13399), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r98);
	z13 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, equals$8a15e0625571c581, r99, _JC_STRING(env, "true"));
	if (z13 == 0)
		goto label38;
	z13 = 1;
	goto label39;

label38:
	z13 = 0;

label39:
	_JC_LINE_NUMBER(225);				// 68
	if (z13 == 0)
		goto label42;
	_JC_LINE_NUMBER(227);				// 69
	i0 = 0;
	_JC_LINE_NUMBER(228);				// 70
	if (z0 != 0)
		goto label40;
	_JC_LINE_NUMBER(229);				// 71
	i0 = 1;

label40:
	_JC_ACTIVE_USE(env, soot_jimple_Jimple);
	_JC_ACTIVE_USE(env, soot_G);
	_JC_LINE_NUMBER(231);				// 72
	r53 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r52 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Jimple$64ac810fbf3d95ea, r53);
	r55 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r54 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Jimple$64ac810fbf3d95ea, r55);
	_JC_ACTIVE_USE(env, soot_jimple_IntConstant);
	r56 = _JC_NEW(env, soot_jimple_IntConstant);
	_JC_PRIM_FIELD(env, r56, soot_jimple_IntConstant, value) = i0;
	r25 = _JC_INVOKE_VIRTUAL(env, soot_jimple_Jimple, newStaticInvokeExpr$e36929c3b393a813, r54, r8, r56);
	r26 = _JC_INVOKE_VIRTUAL(env, soot_jimple_Jimple, newInvokeStmt$a43cd6df051124b2, r52, r25);
	_JC_INVOKE_INTERFACE(env, r9, _JC_JLONG(0x548f3ac5706b9c61), void, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *, struct _jc_java_lang_Object$object *), r26, r12);
	_JC_LINE_NUMBER(235);				// 73
	i0 = 2;
	_JC_LINE_NUMBER(236);				// 74
	if (z1 != 0)
		goto label41;
	_JC_LINE_NUMBER(237);				// 75
	i0 = 3;

label41:
	_JC_LINE_NUMBER(239);				// 76
	r58 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r57 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Jimple$64ac810fbf3d95ea, r58);
	r60 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r59 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Jimple$64ac810fbf3d95ea, r60);
	r61 = _JC_NEW(env, soot_jimple_IntConstant);
	_JC_PRIM_FIELD(env, r61, soot_jimple_IntConstant, value) = i0;
	r25 = _JC_INVOKE_VIRTUAL(env, soot_jimple_Jimple, newStaticInvokeExpr$e36929c3b393a813, r59, r8, r61);
	r26 = _JC_INVOKE_VIRTUAL(env, soot_jimple_Jimple, newInvokeStmt$a43cd6df051124b2, r57, r25);
	_JC_INVOKE_INTERFACE(env, r9, _JC_JLONG(0x548f3ac5706b9c61), void, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *, struct _jc_java_lang_Object$object *), r26, r12);
	_JC_PERIODIC_CHECK(env);
	goto label26;

label42:
	_JC_LINE_NUMBER(261);				// 77
	r27 = _JC_NEW(env, soot_jimple_toolkits_annotation_tags_ArrayCheckTag);
	_JC_PRIM_FIELD(env, r27, soot_jimple_toolkits_annotation_tags_ArrayCheckTag, lowerCheck) = 1;
	_JC_PRIM_FIELD(env, r27, soot_jimple_toolkits_annotation_tags_ArrayCheckTag, upperCheck) = 1;
	_JC_PRIM_FIELD(env, r27, soot_jimple_toolkits_annotation_tags_ArrayCheckTag, lowerCheck) = z0;
	_JC_PRIM_FIELD(env, r27, soot_jimple_toolkits_annotation_tags_ArrayCheckTag, upperCheck) = z1;
	_JC_LINE_NUMBER(262);				// 78
	_JC_INVOKE_INTERFACE(env, r12, _JC_JLONG(0xf92b02979eb63079), void, (_jc_env *, struct _jc_object *, struct _jc_object *), r27);
	_JC_PERIODIC_CHECK(env);
	goto label26;

label43:
	_JC_LINE_NUMBER(268);				// 79
	z4 = _JC_PRIM_FIELD(env, r0, soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker, addColorTags);
	if (z4 == 0)
		goto label50;
	z4 = _JC_PRIM_FIELD(env, r0, soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker, takeRectArray);
	if (z4 == 0)
		goto label50;
	_JC_ACTIVE_USE(env, soot_jimple_toolkits_annotation_arraycheck_RectangularArrayFinder);
	_JC_ACTIVE_USE(env, soot_G);
	_JC_LINE_NUMBER(269);				// 80
	r63 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r62 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, RectangularArrayFinder$655c84e2fd0a1ba3, r63);
	_JC_LINE_NUMBER(270);				// 81
	r23 = _JC_INVOKE_VIRTUAL(env, soot_Body, getUseAndDefBoxes$8bb1ea57ff514f34, r1);
	r16 = _JC_INVOKE_INTERFACE(env, r23, _JC_JLONG(0x3cc91493d50f531c), _jc_object *, (_jc_env *, struct _jc_object *));

label44:
	z4 = _JC_INVOKE_INTERFACE(env, r16, _JC_JLONG(0xfb0bd5e38c59ddcd), jboolean, (_jc_env *, struct _jc_object *));
	if (z4 == 0)
		goto label50;
	_JC_LINE_NUMBER(271);				// 82
	r19 = _JC_INVOKE_INTERFACE(env, r16, _JC_JLONG(0x5874f79a1cf66ea), _jc_object *, (_jc_env *, struct _jc_object *));
	r20 = _JC_CAST(env, &_jc_soot_ValueBox$type, r19);
	_JC_LINE_NUMBER(272);				// 83
	r28 = _JC_INVOKE_INTERFACE(env, r20, _JC_JLONG(0x5c68332c5d4a9bf9), _jc_object *, (_jc_env *, struct _jc_object *));
	_JC_LINE_NUMBER(273);				// 84
	z4 = _JC_INSTANCEOF(env, r28, &_jc_soot_Local$type);
	if (z4 != 0)
		goto label45;
	_JC_PERIODIC_CHECK(env);
	goto label44;

label45:
	_JC_LINE_NUMBER(274);				// 85
	r29 = _JC_INVOKE_INTERFACE(env, r28, _JC_JLONG(0x847707b1f3b96fef), _jc_object *, (_jc_env *, struct _jc_object *));
	_JC_LINE_NUMBER(275);				// 86
	z4 = _JC_INSTANCEOF(env, r29, &_jc_soot_ArrayType$type);
	if (z4 != 0)
		goto label46;
	_JC_PERIODIC_CHECK(env);
	goto label44;

label46:
	_JC_LINE_NUMBER(276);				// 87
	r30 = r29;
	_JC_LINE_NUMBER(277);				// 88
	i0 = _JC_PRIM_FIELD(env, r30, soot_ArrayType, numDimensions);
	if (i0 > 1)
		goto label47;
	_JC_PERIODIC_CHECK(env);
	goto label44;

label47:
	_JC_LINE_NUMBER(278);				// 89
	r21 = _JC_NEW(env, soot_tagkit_ColorTag);
	r31 = _JC_NEW(env, soot_jimple_toolkits_annotation_arraycheck_MethodLocal);
	r32 = r28;
	_JC_REF_FIELD(env, r31, soot_jimple_toolkits_annotation_arraycheck_MethodLocal, m) = r5;
	_JC_REF_FIELD(env, r31, soot_jimple_toolkits_annotation_arraycheck_MethodLocal, l) = r32;
	z4 = _JC_INVOKE_VIRTUAL(env, soot_jimple_toolkits_annotation_arraycheck_RectangularArrayFinder, isRectangular$e070af4ec2a4e6b5, r62, r31);
	if (z4 == 0)
		goto label48;
	i0 = 1;
	goto label49;

label48:
	i0 = 0;

label49:
	_JC_INVOKE_NONVIRTUAL(env, soot_tagkit_ColorTag, _init$c790c3e482613c6a, 0, r21, i0, 0);
	_JC_INVOKE_INTERFACE(env, r20, _JC_JLONG(0xf92b02979eb63079), void, (_jc_env *, struct _jc_object *, struct _jc_object *), r21);
	_JC_PERIODIC_CHECK(env);
	goto label44;

label50:
	_JC_LINE_NUMBER(285);				// 90
	r33 = _JC_NEW(env, java_util_Date);
	_JC_ACTIVE_USE(env, java_lang_System);
	l6 = _JC_INVOKE_STATIC(env, java_lang_VMSystem, currentTimeMillis$f4fdeb31d00e9185, 0);
	_JC_PRIM_FIELD(env, r33, java_util_Date, time) = l6;
	_JC_ACTIVE_USE(env, soot_options_Options);
	_JC_ACTIVE_USE(env, soot_G);
	_JC_LINE_NUMBER(286);				// 91
	r65 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r64 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Options$9fd4168abe5957f7, r65);
	z4 = _JC_INVOKE_VIRTUAL(env, soot_options_Options, verbose$e5b65d4727121643, r64);
	if (z4 == 0)
		goto label53;
	l3 = _JC_PRIM_FIELD(env, r33, java_util_Date, time);
	l4 = _JC_PRIM_FIELD(env, r6, java_util_Date, time);
	_JC_LINE_NUMBER(288);				// 92
	l2 = l3 - l4;
	_JC_LINE_NUMBER(289);				// 93
	r36 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r17 = _JC_REF_FIELD(env, r36, soot_G, out);
	r18 = _JC_NEW(env, java_lang_StringBuffer);
	r73 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r18, java_lang_StringBuffer, value) = r73;
	r18 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r18, _JC_STRING(env, "[abc] ended on "));
	r80 = r18;
	if (r33 != _JC_NULL)
		goto label51;
	r81 = _JC_STRING(env, "null");
	goto label52;

label51:
	r81 = _JC_INVOKE_NONVIRTUAL(env, java_util_Date, toString$7ea43b33b80a3070, 0, r33);

label52:
	r80 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r80, r81);
	r18 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r80, _JC_STRING(env, ". It took "));
	l1 = l2 / _JC_JLONG(60000);
	_JC_EXPLICIT_NULL_CHECK(env, r18);
	r67 = _JC_INVOKE_STATIC(env, java_lang_Long, toString$6573ff64b9d4aac6, 0, l1, 10);
	r66 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r18, r67);
	r18 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 1, r66, _JC_STRING(env, " min. "));
	l2 = l2 % _JC_JLONG(60000);
	l2 = l2 / _JC_JLONG(1000);
	_JC_EXPLICIT_NULL_CHECK(env, r18);
	r69 = _JC_INVOKE_STATIC(env, java_lang_Long, toString$6573ff64b9d4aac6, 1, l2, 10);
	r68 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r18, r69);
	r18 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 1, r68, _JC_STRING(env, " sec."));
	_JC_EXPLICIT_NULL_CHECK(env, r18);
	r70 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r70, r18);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, println$f7dbc2aa0f0a9d4f, r17, r70);

label53:
	_JC_LINE_NUMBER(294);				// 94
	return;
}

//
// protected int interpretGraph(soot.jimple.toolkits.annotation.arraycheck.WeightedDirectedSparseGraph, soot.jimple.ArrayRef, soot.jimple.Stmt, soot.jimple.toolkits.annotation.arraycheck.IntContainer)
//

static _jc_linenum _jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$linenum_table$interpretGraph$045eda43ea97a5f1[];

static const unsigned char _jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$param_ptypes$interpretGraph$045eda43ea97a5f1[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_INT };

static _jc_type *const _jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$param_types$interpretGraph$045eda43ea97a5f1[] = {
	&_jc_soot_jimple_toolkits_annotation_arraycheck_WeightedDirectedSparseGraph$type,
	&_jc_soot_jimple_ArrayRef$type,
	&_jc_soot_jimple_Stmt$type,
	&_jc_soot_jimple_toolkits_annotation_arraycheck_IntContainer$type
};

_jc_method _jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$method_info$interpretGraph$045eda43ea97a5f1 = {
	.name=			"interpretGraph",
	.signature=		"(Lsoot/jimple/toolkits/annotation/arraycheck/WeightedDirectedSparseGraph;Lsoot/jimple/ArrayRef;Lsoot/jimple/Stmt;Lsoot/jimple/toolkits/annotation/arraycheck/IntContainer;)I",
	.class=			&_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$type,
	.param_types=		&_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$param_types$interpretGraph$045eda43ea97a5f1,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$param_ptypes$interpretGraph$045eda43ea97a5f1,
	.signature_hash=	_JC_JLONG(0x45eda43ea97a5f1),
	.access_flags=		_JC_ACC_PROTECTED,
	.function=		&_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$method$interpretGraph$045eda43ea97a5f1,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$vtable, soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker.interpretGraph$045eda43ea97a5f1) / sizeof(void *),
	.num_parameters=	4,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	28,
	      .table=	_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$linenum_table$interpretGraph$045eda43ea97a5f1
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker, interpretGraph$045eda43ea97a5f1);

jint _JC_JCNI_ATTR
_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$method$interpretGraph$045eda43ea97a5f1(_jc_env *const env, _jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$object *this, _jc_soot_jimple_toolkits_annotation_arraycheck_WeightedDirectedSparseGraph$object *param0, _jc_object *param1, _jc_object *param2, _jc_soot_jimple_toolkits_annotation_arraycheck_IntContainer$object *param3)
{
	jint i0;
	jint i1;
	struct _jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$object *r0;
	struct _jc_soot_jimple_toolkits_annotation_arraycheck_WeightedDirectedSparseGraph$object *r1;
	struct _jc_soot_G$object *r10;
	struct _jc_soot_G$object *r11;
	struct _jc_soot_options_Options$object *r12;
	struct _jc_soot_G$object *r13;
	struct _jc_java_lang_String$object *r14;
	_jc_char_array *r15;
	struct _jc_java_lang_StringBuffer$object *r16;
	struct _jc_java_lang_String$object *r18;
	struct _jc_object *r2;
	struct _jc_object *r3;
	struct _jc_soot_jimple_toolkits_annotation_arraycheck_IntContainer$object *r4;
	struct _jc_java_lang_StringBuffer$object *r5;
	struct _jc_object *r6;
	struct _jc_object *r7;
	struct _jc_java_io_PrintStream$object *r8;
	struct _jc_soot_jimple_IntConstant$object *r9;
	jboolean z0;
	jboolean z1;
	jboolean z2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	r3 = param2;
	r4 = param3;
	_JC_LINE_NUMBER(312);				// 0
	z0 = 1;
	_JC_LINE_NUMBER(313);				// 1
	z1 = 1;
	_JC_ACTIVE_USE(env, soot_options_Options);
	_JC_ACTIVE_USE(env, soot_G);
	_JC_LINE_NUMBER(316);				// 2
	r13 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r12 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Options$9fd4168abe5957f7, r13);
	z2 = _JC_INVOKE_VIRTUAL(env, soot_options_Options, debug$861416ee28c752ac, r12);
	if (z2 == 0)
		goto label2;
	_JC_LINE_NUMBER(318);				// 3
	z2 = _JC_INVOKE_VIRTUAL(env, soot_jimple_toolkits_annotation_arraycheck_WeightedDirectedSparseGraph, makeShortestPathGraph$f4a85291e874666b, r1);
	if (z2 != 0)
		goto label2;
	_JC_LINE_NUMBER(320);				// 4
	r10 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r8 = _JC_REF_FIELD(env, r10, soot_G, out);
	r5 = _JC_NEW(env, java_lang_StringBuffer);
	r15 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r5, java_lang_StringBuffer, value) = r15;
	r16 = r5;
	if (r3 != _JC_NULL)
		goto label0;
	r18 = _JC_STRING(env, "null");
	goto label1;

label0:
	r18 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, toString$7ea43b33b80a3070, r3);

label1:
	r16 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r16, r18);
	r5 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r16, _JC_STRING(env, " :"));
	_JC_EXPLICIT_NULL_CHECK(env, r5);
	r14 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r14, r5);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, println$f7dbc2aa0f0a9d4f, r8, r14);
	_JC_LINE_NUMBER(321);				// 5
	r11 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r8 = _JC_REF_FIELD(env, r11, soot_G, out);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, println$35bcf4b1d68471ab, r8, r1);

label2:
	_JC_LINE_NUMBER(325);				// 6
	r6 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0x413b8e7231f9b918), _jc_object *, (_jc_env *, struct _jc_object *));
	_JC_LINE_NUMBER(326);				// 7
	r7 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0xb4439a30bba7443a), _jc_object *, (_jc_env *, struct _jc_object *));
	_JC_LINE_NUMBER(328);				// 8
	z2 = _JC_INSTANCEOF(env, r7, &_jc_soot_jimple_IntConstant$type);
	if (z2 == 0)
		goto label4;
	_JC_LINE_NUMBER(330);				// 9
	r9 = r7;
	i0 = _JC_PRIM_FIELD(env, r9, soot_jimple_IntConstant, value);
	_JC_LINE_NUMBER(332);				// 10
	z2 = _JC_INVOKE_VIRTUAL(env, soot_jimple_toolkits_annotation_arraycheck_WeightedDirectedSparseGraph, hasEdge$e320143ff44576cb, r1, r6, r4);
	if (z2 == 0)
		goto label3;
	_JC_LINE_NUMBER(334);				// 11
	i1 = _JC_INVOKE_VIRTUAL(env, soot_jimple_toolkits_annotation_arraycheck_WeightedDirectedSparseGraph, edgeWeight$8ab403206bc1ad86, r1, r6, r4);
	_JC_LINE_NUMBER(336);				// 12
	i1 = -i1;
	if (i1 <= i0)
		goto label3;
	_JC_LINE_NUMBER(337);				// 13
	z1 = 0;

label3:
	_JC_LINE_NUMBER(340);				// 14
	if (i0 < 0)
		goto label6;
	_JC_LINE_NUMBER(341);				// 15
	z0 = 0;
	goto label6;

label4:
	_JC_LINE_NUMBER(345);				// 16
	z2 = _JC_INVOKE_VIRTUAL(env, soot_jimple_toolkits_annotation_arraycheck_WeightedDirectedSparseGraph, hasEdge$e320143ff44576cb, r1, r6, r7);
	if (z2 == 0)
		goto label5;
	_JC_LINE_NUMBER(347);				// 17
	i1 = _JC_INVOKE_VIRTUAL(env, soot_jimple_toolkits_annotation_arraycheck_WeightedDirectedSparseGraph, edgeWeight$8ab403206bc1ad86, r1, r6, r7);
	_JC_LINE_NUMBER(348);				// 18
	if (i1 >= 0)
		goto label5;
	_JC_LINE_NUMBER(349);				// 19
	z1 = 0;

label5:
	_JC_LINE_NUMBER(352);				// 20
	z2 = _JC_INVOKE_VIRTUAL(env, soot_jimple_toolkits_annotation_arraycheck_WeightedDirectedSparseGraph, hasEdge$e320143ff44576cb, r1, r7, r4);
	if (z2 == 0)
		goto label6;
	_JC_LINE_NUMBER(354);				// 21
	i1 = _JC_INVOKE_VIRTUAL(env, soot_jimple_toolkits_annotation_arraycheck_WeightedDirectedSparseGraph, edgeWeight$8ab403206bc1ad86, r1, r7, r4);
	_JC_LINE_NUMBER(356);				// 22
	if (i1 > 0)
		goto label6;
	_JC_LINE_NUMBER(357);				// 23
	z0 = 0;

label6:
	_JC_LINE_NUMBER(363);				// 24
	if (z0 == 0)
		goto label7;
	if (z1 == 0)
		goto label7;
	return 0;

label7:
	_JC_LINE_NUMBER(364);				// 25
	if (z0 == 0)
		goto label8;
	if (z1 != 0)
		goto label8;
	return 1;

label8:
	_JC_LINE_NUMBER(365);				// 26
	if (z0 != 0)
		goto label9;
	if (z1 == 0)
		goto label9;
	return 2;

label9:
	_JC_LINE_NUMBER(366);				// 27
	return 3;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$methods[] = {
	&_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$method_info$_init$bbe94f634b20986f,
	&_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$method_info$hasArrayLocals$fecefe2e35648963,
	&_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$method_info$internalTransform$9abd4924859b68a3,
	&_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$method_info$interpretGraph$045eda43ea97a5f1,
	&_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$method_info$v$6cb273f617b5a17d
};

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$instanceof_hash_bucket_48[] = {
	&_jc_soot_BodyTransformer$type,
	_JC_NULL
};
static _jc_type *const _jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$instanceof_hash_bucket_50[] = {
	&_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$type,
	_JC_NULL
};
static _jc_type *const _jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};
static _jc_type *const _jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$instanceof_hash_bucket_112[] = {
	&_jc_soot_Transformer$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[48]=	_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$instanceof_hash_bucket_48,
	[50]=	_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$instanceof_hash_bucket_50,
	[101]=	_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$instanceof_hash_bucket_101,
	[112]=	_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$instanceof_hash_bucket_112
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$class_depends[] = {
	{ "java/io/PrintStream",	_JC_JLONG(0x99a46305ebacacb5) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/Long",	_JC_JLONG(0x72c9d9e8f269fac) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/StringBuffer",	_JC_JLONG(0x94d357637b968dda) },
	{ "java/lang/System",	_JC_JLONG(0x53cc8e2333795f04) },
	{ "java/lang/VMSystem",	_JC_JLONG(0x4d1cebae0bdda058) },
	{ "java/util/Date",	_JC_JLONG(0xa85d2a51094e614c) },
	{ "java/util/Iterator",	_JC_JLONG(0xbe56ff673eefd9d2) },
	{ "java/util/List",	_JC_JLONG(0x9ee0d92ce1525a4d) },
	{ "java/util/Map",	_JC_JLONG(0xe283f7c2e7a7979c) },
	{ "soot/ArrayType",	_JC_JLONG(0x13e7935c8aaa97c9) },
	{ "soot/Body",	_JC_JLONG(0x6131d54b9700ca5d) },
	{ "soot/BodyTransformer",	_JC_JLONG(0xa76a7734eb62f430) },
	{ "soot/G",	_JC_JLONG(0xb6d33af8f84fdbc4) },
	{ "soot/Local",	_JC_JLONG(0xfc12513d0e867dd9) },
	{ "soot/PatchingChain",	_JC_JLONG(0x2869754f09a70a54) },
	{ "soot/PhaseOptions",	_JC_JLONG(0x177db6dd531c9085) },
	{ "soot/Scene",	_JC_JLONG(0x7120c8047949f8c0) },
	{ "soot/Singletons",	_JC_JLONG(0x6ac5bee50bbabb71) },
	{ "soot/Singletons$Global",	_JC_JLONG(0x47e789a7286ce13e) },
	{ "soot/SootClass",	_JC_JLONG(0x634bd13ff2d8ac70) },
	{ "soot/SootMethod",	_JC_JLONG(0xbd11c16680505218) },
	{ "soot/Transformer",	_JC_JLONG(0xde5fa3182955e270) },
	{ "soot/Type",	_JC_JLONG(0xf801e5c664424a1) },
	{ "soot/Value",	_JC_JLONG(0x277f133500573bf0) },
	{ "soot/ValueBox",	_JC_JLONG(0xbe495158d4df40c0) },
	{ "soot/jimple/ArithmeticConstant",	_JC_JLONG(0xe5651dde6cd08af9) },
	{ "soot/jimple/ArrayRef",	_JC_JLONG(0x6c885b70485f9bcf) },
	{ "soot/jimple/Constant",	_JC_JLONG(0xa4a584ce60f6ce4) },
	{ "soot/jimple/IntConstant",	_JC_JLONG(0xfade60ef604ad800) },
	{ "soot/jimple/InvokeStmt",	_JC_JLONG(0xf44409eade05c9fc) },
	{ "soot/jimple/Jimple",	_JC_JLONG(0x18f5ef6e837efcef) },
	{ "soot/jimple/NumericConstant",	_JC_JLONG(0x3bd9379d3ff77f81) },
	{ "soot/jimple/StaticInvokeExpr",	_JC_JLONG(0x5f8a86314966eaf4) },
	{ "soot/jimple/Stmt",	_JC_JLONG(0x3650ad26817a710) },
	{ "soot/jimple/toolkits/annotation/arraycheck/ArrayBoundsCheckerAnalysis",	_JC_JLONG(0x5c956ac91af250fe) },
	{ "soot/jimple/toolkits/annotation/arraycheck/IntContainer",	_JC_JLONG(0xfa23922817735cea) },
	{ "soot/jimple/toolkits/annotation/arraycheck/MethodLocal",	_JC_JLONG(0xa53ec25e01edf44a) },
	{ "soot/jimple/toolkits/annotation/arraycheck/RectangularArrayFinder",	_JC_JLONG(0x6a41f5ea6fee677e) },
	{ "soot/jimple/toolkits/annotation/arraycheck/WeightedDirectedSparseGraph",	_JC_JLONG(0xae1dddb7d2686744) },
	{ "soot/jimple/toolkits/annotation/tags/ArrayCheckTag",	_JC_JLONG(0xafc01e7a340766a0) },
	{ "soot/options/ABCOptions",	_JC_JLONG(0xd089077f46294801) },
	{ "soot/options/Options",	_JC_JLONG(0xc5a5a246a3f59476) },
	{ "soot/tagkit/AbstractHost",	_JC_JLONG(0x6ddedfee878f127) },
	{ "soot/tagkit/ColorTag",	_JC_JLONG(0xa5fe62fcd03e5ea4) },
	{ "soot/tagkit/KeyTag",	_JC_JLONG(0x9cb4881430c5d3aa) },
	{ "soot/util/Chain",	_JC_JLONG(0xa50c82c4926ca40e) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$vtype _jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$type = {
    .type= {
	.name=			"soot/jimple/toolkits/annotation/arraycheck/ArrayBoundsChecker",
	.superclass=		&_jc_soot_BodyTransformer$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		18,
		.hash=			_JC_JLONG(0x52aa5421a5e909b2),
		.source_file=		"ArrayBoundsChecker.java",
		.instance_size=		sizeof(_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$refs) + sizeof(_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$object),
		.num_virtual_refs=	0,
		.num_fields=		sizeof(_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$fields) / sizeof(*_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$fields),
		.fields=		_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$fields,
		.num_methods=		sizeof(_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$methods) / sizeof(*_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$methods),
		.methods=		_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$methods,
		.instanceof_hash_table=	_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$instanceof_hash_table,
		.num_class_depends=		sizeof(_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$class_depends) / sizeof(*_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$class_depends),
		.class_depends=		_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.soot_Transformer= {
	},
	.soot_BodyTransformer= {
	    .internalTransform$9abd4924859b68a3=		// overridden
		&_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$method$internalTransform$9abd4924859b68a3,
	    .transform$efe210b8710809f9=
		&_jc_soot_BodyTransformer$method$transform$efe210b8710809f9,
	    .transform$6c1afdd3773c7636=
		&_jc_soot_BodyTransformer$method$transform$6c1afdd3773c7636,
	    .transform$fa83af6c18402119=
		&_jc_soot_BodyTransformer$method$transform$fa83af6c18402119,
	},
	.soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker= {
	    .hasArrayLocals$fecefe2e35648963=
		&_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$method$hasArrayLocals$fecefe2e35648963,
	    .internalTransform$9abd4924859b68a3=
		&_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$method$internalTransform$9abd4924859b68a3,
	    .interpretGraph$045eda43ea97a5f1=
		&_jc_soot_jimple_toolkits_annotation_arraycheck_ArrayBoundsChecker$method$interpretGraph$045eda43ea97a5f1,
	},
    }
};

