// public class gnu.java.security.provider.DSAParameters

// class file dependencies
// @dep_class 95647318e434aadc gnu_java_io_ASN1ParsingException
// @dep_class c3c7f628c3880116 gnu_java_security_der_DER
// @dep_class 78ef52e48159b870 gnu_java_security_der_DERReader
// @dep_class de1638783317796a gnu_java_security_der_DERValue
// @dep_class 87aa78f6a77ed8b gnu_java_security_der_DERWriter
// @dep_class e2d97b5820c28143 gnu_java_security_provider_DSAParameters
// @dep_class a68cc27886fd8be3 java_io_ByteArrayInputStream
// @dep_class c4d3cc2bda03a338 java_io_ByteArrayOutputStream
// @dep_class 4e0a56550c69d57c java_io_IOException
// @dep_class 4026d3144d6654d8 java_io_OutputStream
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class 1f925cf50bfc0d6c java_lang_ClassNotFoundException
// @dep_class 308333d803f5ab9f java_lang_Error
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class 3746e17e005bda9e java_lang_LinkageError
// @dep_class 2082ebb592ac2255 java_lang_NoClassDefFoundError
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 94d357637b968dda java_lang_StringBuffer
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class 238a2c0aafd74314 java_lang_VMClass
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class 7717ded55c30b7f3 java_math_BigInteger
// @dep_class fe4af2c744a13852 java_security_AlgorithmParametersSpi
// @dep_class 692089051f4c8d0b java_security_GeneralSecurityException
// @dep_class ef2e5e8af121478f java_security_spec_AlgorithmParameterSpec
// @dep_class 96064ba9ffd4a2f9 java_security_spec_DSAParameterSpec
// @dep_class 6afab99500ae813 java_security_spec_InvalidParameterSpecException
// @dep_class 8ea716c64b77f8eb java_util_AbstractCollection
// @dep_class f5238436362828db java_util_AbstractList
// @dep_class 58038509830ef3f4 java_util_ArrayList

// header file dependencies
// @dep_header gnu_java_io_ASN1ParsingException
// @dep_header gnu_java_security_der_DER
// @dep_header gnu_java_security_der_DERReader
// @dep_header gnu_java_security_der_DERValue
// @dep_header gnu_java_security_der_DERWriter
// @dep_header gnu_java_security_provider_DSAParameters
// @dep_header java_io_ByteArrayInputStream
// @dep_header java_io_ByteArrayOutputStream
// @dep_header java_lang_Class
// @dep_header java_lang_ClassNotFoundException
// @dep_header java_lang_NoClassDefFoundError
// @dep_header java_lang_String
// @dep_header java_lang_StringBuffer
// @dep_header java_lang_VMClass
// @dep_header java_lang_VMThrowable
// @dep_header java_math_BigInteger
// @dep_header java_security_spec_AlgorithmParameterSpec
// @dep_header java_security_spec_DSAParameterSpec
// @dep_header java_security_spec_InvalidParameterSpecException
// @dep_header java_util_ArrayList

#include "jc_defs.h"

#include "gnu/java/io/ASN1ParsingException.h"
#include "gnu/java/security/der/DER.h"
#include "gnu/java/security/der/DERReader.h"
#include "gnu/java/security/der/DERValue.h"
#include "gnu/java/security/der/DERWriter.h"
#include "gnu/java/security/provider/DSAParameters.h"
#include "java/io/ByteArrayInputStream.h"
#include "java/io/ByteArrayOutputStream.h"
#include "java/lang/Class.h"
#include "java/lang/ClassNotFoundException.h"
#include "java/lang/NoClassDefFoundError.h"
#include "java/lang/String.h"
#include "java/lang/StringBuffer.h"
#include "java/lang/VMClass.h"
#include "java/lang/VMThrowable.h"
#include "java/math/BigInteger.h"
#include "java/security/spec/AlgorithmParameterSpec.h"
#include "java/security/spec/DSAParameterSpec.h"
#include "java/security/spec/InvalidParameterSpecException.h"
#include "java/util/ArrayList.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// private java.math.BigInteger q
static _jc_field _jc_gnu_java_security_provider_DSAParameters$field_info$q = {
	.name=		"q",
	.signature=	"Ljava/math/BigInteger;",
	.class=		&_jc_gnu_java_security_provider_DSAParameters$type,
	.type=		&_jc_java_math_BigInteger$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_gnu_java_security_provider_DSAParameters$object, refs[-1].gnu_java_security_provider_DSAParameters.q),
};

// private java.math.BigInteger p
static _jc_field _jc_gnu_java_security_provider_DSAParameters$field_info$p = {
	.name=		"p",
	.signature=	"Ljava/math/BigInteger;",
	.class=		&_jc_gnu_java_security_provider_DSAParameters$type,
	.type=		&_jc_java_math_BigInteger$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_gnu_java_security_provider_DSAParameters$object, refs[-1].gnu_java_security_provider_DSAParameters.p),
};

// private java.math.BigInteger g
static _jc_field _jc_gnu_java_security_provider_DSAParameters$field_info$g = {
	.name=		"g",
	.signature=	"Ljava/math/BigInteger;",
	.class=		&_jc_gnu_java_security_provider_DSAParameters$type,
	.type=		&_jc_java_math_BigInteger$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_gnu_java_security_provider_DSAParameters$object, refs[-1].gnu_java_security_provider_DSAParameters.g),
};

// static java.lang.Class class$java$security$spec$DSAParameterSpec
static _jc_field _jc_gnu_java_security_provider_DSAParameters$field_info$class__24java__24security__24spec__24DSAParameterSpec = {
	.name=		"class$java$security$spec$DSAParameterSpec",
	.signature=	"Ljava/lang/Class;",
	.class=		&_jc_gnu_java_security_provider_DSAParameters$type,
	.type=		&_jc_java_lang_Class$type,
	.access_flags=	_JC_ACC_STATIC,
	.offset=	_JC_OFFSETOF(_jc_gnu_java_security_provider_DSAParameters$fields_struct, class__24java__24security__24spec__24DSAParameterSpec),
};

// Fields
static _jc_field *const _jc_gnu_java_security_provider_DSAParameters$fields[] = {
	&_jc_gnu_java_security_provider_DSAParameters$field_info$class__24java__24security__24spec__24DSAParameterSpec,
	&_jc_gnu_java_security_provider_DSAParameters$field_info$g,
	&_jc_gnu_java_security_provider_DSAParameters$field_info$p,
	&_jc_gnu_java_security_provider_DSAParameters$field_info$q
};

/************************************************************************
 *			      Static methods				*
 ************************************************************************/

//
// static java.lang.Class 'class'(java.lang.String, boolean)
//

static _jc_trap_info _jc_gnu_java_security_provider_DSAParameters$trap_table$class$c900dc17c9967b78[] = {
	_JC_TRAP(&_jc_java_lang_ClassNotFoundException$type, 1, 2),
};

static const unsigned char _jc_gnu_java_security_provider_DSAParameters$param_ptypes$class$c900dc17c9967b78[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_gnu_java_security_provider_DSAParameters$param_types$class$c900dc17c9967b78[] = {
	&_jc_java_lang_String$type,
	&_jc_boolean$prim$type
};

_jc_method _jc_gnu_java_security_provider_DSAParameters$method_info$class$c900dc17c9967b78 = {
	.name=			"class",
	.signature=		"(Ljava/lang/String;Z)Ljava/lang/Class;",
	.class=			&_jc_gnu_java_security_provider_DSAParameters$type,
	.param_types=		&_jc_gnu_java_security_provider_DSAParameters$param_types$class$c900dc17c9967b78,
	.return_type=		&_jc_java_lang_Class$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSAParameters$param_ptypes$class$c900dc17c9967b78,
	.signature_hash=	_JC_JLONG(0xc900dc17c9967b78),
	.access_flags=		_JC_ACC_STATIC,
	.function=		&_jc_gnu_java_security_provider_DSAParameters$method$class$c900dc17c9967b78,
	.num_parameters=	2,
	.u= { .exec= {
	  .trap_table_len=	1,
	  .trap_table=		_jc_gnu_java_security_provider_DSAParameters$trap_table$class$c900dc17c9967b78,
	} },
};

_jc_java_lang_Class$object * _JC_JCNI_ATTR
_jc_gnu_java_security_provider_DSAParameters$method$class$c900dc17c9967b78(_jc_env *const env, _jc_java_lang_String$object *param0, jboolean param1)
{
	struct _jc_java_lang_String$object *r0;
	struct _jc_java_lang_NoClassDefFoundError$object *volatile r1;
	struct _jc_java_lang_Class$object *r2;
	struct _jc_java_lang_ClassNotFoundException$object *volatile r3;
	struct _jc_java_lang_Throwable$object *volatile r4;
	struct _jc_java_lang_Class$object *r5;
	struct _jc_java_lang_String$object *volatile r6;
	struct _jc_java_lang_VMThrowable$object *volatile r8;
	jboolean z0;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_gnu_java_security_provider_DSAParameters$method_info$class$c900dc17c9967b78, &&label1);

	r0 = param0;
	z0 = param1;
	_JC_TRAP_REGION(catch, 1);
	r2 = _JC_INVOKE_STATIC(env, java_lang_Class, forName$d3b57db3b6a905a3, 1, r0);
	if (z0 != 0)
		goto label0;
	_JC_EXPLICIT_NULL_CHECK(env, r2);
	r5 = _JC_INVOKE_STATIC(env, java_lang_VMClass, getComponentType$092b8e60c26feb25, 0, r2);
	r2 = r5;

label0:
	_JC_CANCEL_TRAPS(env, catch);
	return r2;

label1:
	_JC_TRAP_REGION(catch, 2);
	r3 = _JC_CAUGHT_EXCEPTION(env);
	r1 = _JC_NEW(env, java_lang_NoClassDefFoundError);
	r6 = _JC_NULL;
	_JC_REF_FIELD(env, r1, java_lang_Throwable, cause) = r1;
	r8 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r1);
	_JC_REF_FIELD(env, r1, java_lang_Throwable, vmState) = r8;
	_JC_REF_FIELD(env, r1, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r1, java_lang_Throwable, detailMessage) = r6;
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_Throwable, initCause$997fed19751e1c64, 0, r1, r3);
	_JC_THROW(env, r4);
}

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// public void <init>()
//

static _jc_linenum _jc_gnu_java_security_provider_DSAParameters$linenum_table$_init$52f4ad9f2989aeee[];

static const unsigned char _jc_gnu_java_security_provider_DSAParameters$param_ptypes$_init$52f4ad9f2989aeee[] = { 
_JC_TYPE_VOID };

_jc_method _jc_gnu_java_security_provider_DSAParameters$method_info$_init$52f4ad9f2989aeee = {
	.name=			"<init>",
	.signature=		"()V",
	.class=			&_jc_gnu_java_security_provider_DSAParameters$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSAParameters$param_ptypes$_init$52f4ad9f2989aeee,
	.signature_hash=	_JC_JLONG(0x52f4ad9f2989aeee),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_provider_DSAParameters$method$_init$52f4ad9f2989aeee,
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_gnu_java_security_provider_DSAParameters$linenum_table$_init$52f4ad9f2989aeee
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_DSAParameters, _init$52f4ad9f2989aeee);

void _JC_JCNI_ATTR
_jc_gnu_java_security_provider_DSAParameters$method$_init$52f4ad9f2989aeee(_jc_env *const env, _jc_gnu_java_security_provider_DSAParameters$object *this)
{
	struct _jc_gnu_java_security_provider_DSAParameters$object *r0;

	r0 = this;
	_JC_LINE_NUMBER(68);				// 0
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public byte[] engineGetEncoded() throws java.io.IOException
//

static _jc_linenum _jc_gnu_java_security_provider_DSAParameters$linenum_table$engineGetEncoded$c6f5908664ac2899[];

static const unsigned char _jc_gnu_java_security_provider_DSAParameters$param_ptypes$engineGetEncoded$c6f5908664ac2899[] = { 
_JC_TYPE_REFERENCE };

static _jc_type *const _jc_gnu_java_security_provider_DSAParameters$exceptions$engineGetEncoded$c6f5908664ac2899[] = {
	&_jc_java_io_IOException$type
};

_jc_method _jc_gnu_java_security_provider_DSAParameters$method_info$engineGetEncoded$c6f5908664ac2899 = {
	.name=			"engineGetEncoded",
	.signature=		"()[B",
	.class=			&_jc_gnu_java_security_provider_DSAParameters$type,
	.return_type=		&_jc_byte$array$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSAParameters$param_ptypes$engineGetEncoded$c6f5908664ac2899,
	.signature_hash=	_JC_JLONG(0xc6f5908664ac2899),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_provider_DSAParameters$method$engineGetEncoded$c6f5908664ac2899,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_provider_DSAParameters$vtable, gnu_java_security_provider_DSAParameters.engineGetEncoded$c6f5908664ac2899) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_gnu_java_security_provider_DSAParameters$exceptions$engineGetEncoded$c6f5908664ac2899,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	7,
	      .table=	_jc_gnu_java_security_provider_DSAParameters$linenum_table$engineGetEncoded$c6f5908664ac2899
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_DSAParameters, engineGetEncoded$c6f5908664ac2899);

_jc_byte_array * _JC_JCNI_ATTR
_jc_gnu_java_security_provider_DSAParameters$method$engineGetEncoded$c6f5908664ac2899(_jc_env *const env, _jc_gnu_java_security_provider_DSAParameters$object *this)
{
	jint i0;
	struct _jc_gnu_java_security_provider_DSAParameters$object *r0;
	struct _jc_java_io_ByteArrayOutputStream$object *r1;
	struct _jc_java_util_ArrayList$object *r2;
	struct _jc_gnu_java_security_der_DERValue$object *r3;
	struct _jc_java_math_BigInteger$object *r4;
	_jc_byte_array *r5;
	_jc_byte_array *r6;
	_jc_object_array *r7;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(127);				// 0
	r1 = _JC_NEW(env, java_io_ByteArrayOutputStream);
	i0 = _JC_STATIC_FIELD(env, java_io_ByteArrayOutputStream, initial__5fbuffer__5fsize, 1);
	r6 = _JC_NEW_PRIM_ARRAY(env, byte, 1, i0);
	_JC_REF_FIELD(env, r1, java_io_ByteArrayOutputStream, buf) = r6;
	_JC_PRIM_FIELD(env, r1, java_io_ByteArrayOutputStream, count) = 0;
	_JC_LINE_NUMBER(128);				// 1
	r2 = _JC_NEW(env, java_util_ArrayList);
	r7 = _JC_NEW_REF_ARRAY(env, java_lang_Object, 1, 3);
	_JC_REF_FIELD(env, r2, java_util_ArrayList, data) = r7;
	_JC_LINE_NUMBER(129);				// 2
	r3 = _JC_NEW(env, gnu_java_security_der_DERValue);
	r4 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAParameters, p);
	_JC_INVOKE_NONVIRTUAL(env, gnu_java_security_der_DERValue, _init$8e22e8011ae1da3a, 0, r3, 2, 0, r4, _JC_NULL);
	_JC_INVOKE_NONVIRTUAL(env, java_util_ArrayList, add$831f06ee5f59c0cc, 0, r2, r3);
	_JC_LINE_NUMBER(130);				// 3
	r3 = _JC_NEW(env, gnu_java_security_der_DERValue);
	r4 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAParameters, q);
	_JC_INVOKE_NONVIRTUAL(env, gnu_java_security_der_DERValue, _init$8e22e8011ae1da3a, 0, r3, 2, 0, r4, _JC_NULL);
	_JC_INVOKE_NONVIRTUAL(env, java_util_ArrayList, add$831f06ee5f59c0cc, 0, r2, r3);
	_JC_LINE_NUMBER(131);				// 4
	r3 = _JC_NEW(env, gnu_java_security_der_DERValue);
	r4 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAParameters, g);
	_JC_INVOKE_NONVIRTUAL(env, gnu_java_security_der_DERValue, _init$8e22e8011ae1da3a, 0, r3, 2, 0, r4, _JC_NULL);
	_JC_INVOKE_NONVIRTUAL(env, java_util_ArrayList, add$831f06ee5f59c0cc, 0, r2, r3);
	_JC_LINE_NUMBER(132);				// 5
	r3 = _JC_NEW(env, gnu_java_security_der_DERValue);
	_JC_INVOKE_NONVIRTUAL(env, gnu_java_security_der_DERValue, _init$8e22e8011ae1da3a, 0, r3, 48, 0, r2, _JC_NULL);
	_JC_INVOKE_STATIC(env, gnu_java_security_der_DERWriter, write$dd9c0500806ff3af, 0, r1, r3);
	_JC_LINE_NUMBER(133);				// 6
	r5 = _JC_INVOKE_NONVIRTUAL(env, java_io_ByteArrayOutputStream, toByteArray$3292ac9bfdd8d59a, 0, r1);
	return r5;
}

//
// public byte[] engineGetEncoded(java.lang.String) throws java.io.IOException
//

static _jc_linenum _jc_gnu_java_security_provider_DSAParameters$linenum_table$engineGetEncoded$e53c01cc263f9e1e[];

static const unsigned char _jc_gnu_java_security_provider_DSAParameters$param_ptypes$engineGetEncoded$e53c01cc263f9e1e[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_gnu_java_security_provider_DSAParameters$exceptions$engineGetEncoded$e53c01cc263f9e1e[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_gnu_java_security_provider_DSAParameters$param_types$engineGetEncoded$e53c01cc263f9e1e[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_gnu_java_security_provider_DSAParameters$method_info$engineGetEncoded$e53c01cc263f9e1e = {
	.name=			"engineGetEncoded",
	.signature=		"(Ljava/lang/String;)[B",
	.class=			&_jc_gnu_java_security_provider_DSAParameters$type,
	.param_types=		&_jc_gnu_java_security_provider_DSAParameters$param_types$engineGetEncoded$e53c01cc263f9e1e,
	.return_type=		&_jc_byte$array$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSAParameters$param_ptypes$engineGetEncoded$e53c01cc263f9e1e,
	.signature_hash=	_JC_JLONG(0xe53c01cc263f9e1e),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_provider_DSAParameters$method$engineGetEncoded$e53c01cc263f9e1e,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_provider_DSAParameters$vtable, gnu_java_security_provider_DSAParameters.engineGetEncoded$e53c01cc263f9e1e) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_gnu_java_security_provider_DSAParameters$exceptions$engineGetEncoded$e53c01cc263f9e1e,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_gnu_java_security_provider_DSAParameters$linenum_table$engineGetEncoded$e53c01cc263f9e1e
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_DSAParameters, engineGetEncoded$e53c01cc263f9e1e);

_jc_byte_array * _JC_JCNI_ATTR
_jc_gnu_java_security_provider_DSAParameters$method$engineGetEncoded$e53c01cc263f9e1e(_jc_env *const env, _jc_gnu_java_security_provider_DSAParameters$object *this, _jc_java_lang_String$object *param0)
{
	struct _jc_gnu_java_security_provider_DSAParameters$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_java_io_IOException$object *r2;
	_jc_byte_array *r3;
	struct _jc_java_lang_String$object *r4;
	struct _jc_java_lang_VMThrowable$object *r6;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(140);				// 0
	z0 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, equals$8a15e0625571c581, 1, r1, _JC_STRING(env, "ASN.1"));
	if (z0 != 0)
		goto label0;
	_JC_LINE_NUMBER(141);				// 1
	r2 = _JC_NEW(env, java_io_IOException);
	r4 = _JC_STRING(env, "Invalid Format: Only accepts ASN.1");
	_JC_REF_FIELD(env, r2, java_lang_Throwable, cause) = r2;
	r6 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r2);
	_JC_REF_FIELD(env, r2, java_lang_Throwable, vmState) = r6;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, detailMessage) = r4;
	_JC_THROW(env, r2);

label0:
	_JC_LINE_NUMBER(142);				// 2
	r3 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_provider_DSAParameters, engineGetEncoded$c6f5908664ac2899, r0);
	return r3;
}

//
// public java.security.spec.AlgorithmParameterSpec engineGetParameterSpec(java.lang.Class) throws java.security.spec.InvalidParameterSpecException
//

static _jc_linenum _jc_gnu_java_security_provider_DSAParameters$linenum_table$engineGetParameterSpec$5324b6890b10eccd[];

static _jc_trap_info _jc_gnu_java_security_provider_DSAParameters$trap_table$engineGetParameterSpec$5324b6890b10eccd[] = {
	_JC_TRAP(&_jc_java_lang_ClassNotFoundException$type, 1, 2),
};

static const unsigned char _jc_gnu_java_security_provider_DSAParameters$param_ptypes$engineGetParameterSpec$5324b6890b10eccd[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_gnu_java_security_provider_DSAParameters$exceptions$engineGetParameterSpec$5324b6890b10eccd[] = {
	&_jc_java_security_spec_InvalidParameterSpecException$type
};

static _jc_type *const _jc_gnu_java_security_provider_DSAParameters$param_types$engineGetParameterSpec$5324b6890b10eccd[] = {
	&_jc_java_lang_Class$type
};

_jc_method _jc_gnu_java_security_provider_DSAParameters$method_info$engineGetParameterSpec$5324b6890b10eccd = {
	.name=			"engineGetParameterSpec",
	.signature=		"(Ljava/lang/Class;)Ljava/security/spec/AlgorithmParameterSpec;",
	.class=			&_jc_gnu_java_security_provider_DSAParameters$type,
	.param_types=		&_jc_gnu_java_security_provider_DSAParameters$param_types$engineGetParameterSpec$5324b6890b10eccd,
	.return_type=		&_jc_java_security_spec_AlgorithmParameterSpec$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSAParameters$param_ptypes$engineGetParameterSpec$5324b6890b10eccd,
	.signature_hash=	_JC_JLONG(0x5324b6890b10eccd),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_provider_DSAParameters$method$engineGetParameterSpec$5324b6890b10eccd,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_provider_DSAParameters$vtable, gnu_java_security_provider_DSAParameters.engineGetParameterSpec$5324b6890b10eccd) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_gnu_java_security_provider_DSAParameters$exceptions$engineGetParameterSpec$5324b6890b10eccd,
	.u= { .exec= {
	  .trap_table_len=	1,
	  .trap_table=		_jc_gnu_java_security_provider_DSAParameters$trap_table$engineGetParameterSpec$5324b6890b10eccd,
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_gnu_java_security_provider_DSAParameters$linenum_table$engineGetParameterSpec$5324b6890b10eccd
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_DSAParameters, engineGetParameterSpec$5324b6890b10eccd);

_jc_object * _JC_JCNI_ATTR
_jc_gnu_java_security_provider_DSAParameters$method$engineGetParameterSpec$5324b6890b10eccd(_jc_env *const env, _jc_gnu_java_security_provider_DSAParameters$object *this, _jc_java_lang_Class$object *param0)
{
	struct _jc_gnu_java_security_provider_DSAParameters$object *r0;
	struct _jc_java_lang_Class$object *r1;
	struct _jc_java_lang_String$object *r10;
	struct _jc_java_lang_NoClassDefFoundError$object *volatile r11;
	struct _jc_java_lang_Class$object *r12;
	struct _jc_java_lang_ClassNotFoundException$object *volatile r13;
	struct _jc_java_lang_Throwable$object *volatile r14;
	struct _jc_java_lang_Class$object *r15;
	struct _jc_java_lang_Class$object *r2;
	struct _jc_java_security_spec_DSAParameterSpec$object *r3;
	struct _jc_java_math_BigInteger$object *r4;
	struct _jc_java_math_BigInteger$object *r5;
	struct _jc_java_math_BigInteger$object *r6;
	struct _jc_java_security_spec_InvalidParameterSpecException$object *r7;
	struct _jc_java_lang_String$object *r8;
	struct _jc_java_lang_VMThrowable$object *r9;
	jboolean z0;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_gnu_java_security_provider_DSAParameters$method_info$engineGetParameterSpec$5324b6890b10eccd, &&label0);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(118);				// 0
	r2 = _JC_STATIC_FIELD(env, gnu_java_security_provider_DSAParameters, class__24java__24security__24spec__24DSAParameterSpec, 1);
	if (r2 != _JC_NULL)
		goto label2;
	r10 = _JC_STRING(env, "[Ljava.security.spec.DSAParameterSpec;");
	_JC_TRAP_REGION(catch, 1);
	r12 = _JC_INVOKE_STATIC(env, java_lang_Class, forName$d3b57db3b6a905a3, 1, r10);
	_JC_EXPLICIT_NULL_CHECK(env, r12);
	r15 = _JC_INVOKE_STATIC(env, java_lang_VMClass, getComponentType$092b8e60c26feb25, 0, r12);
	r2 = r15;
	goto label1;

label0:
	_JC_TRAP_REGION(catch, 2);
	r13 = _JC_CAUGHT_EXCEPTION(env);
	r11 = _JC_NEW(env, java_lang_NoClassDefFoundError);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_Throwable, _init$c31b894660454d13, 0, r11, _JC_NULL);
	r14 = _JC_INVOKE_NONVIRTUAL(env, java_lang_Throwable, initCause$997fed19751e1c64, 0, r11, r13);
	_JC_THROW(env, r14);

label1:
	_JC_TRAP_REGION(catch, 2);
	_JC_STATIC_FIELD(env, gnu_java_security_provider_DSAParameters, class__24java__24security__24spec__24DSAParameterSpec, 1) = r15;

label2:
	_JC_TRAP_REGION(catch, 2);
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	z0 = _JC_INVOKE_STATIC(env, java_lang_VMClass, isAssignableFrom$c49c4ad8938bda0b, 0, r1, r2);
	if (z0 == 0)
		goto label3;
	_JC_LINE_NUMBER(119);				// 1
	r3 = _JC_NEW(env, java_security_spec_DSAParameterSpec);
	r4 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAParameters, p);
	r5 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAParameters, q);
	r6 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAParameters, g);
	_JC_REF_FIELD(env, r3, java_security_spec_DSAParameterSpec, p) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_security_spec_DSAParameterSpec, q) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_security_spec_DSAParameterSpec, g) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_security_spec_DSAParameterSpec, p) = r4;
	_JC_REF_FIELD(env, r3, java_security_spec_DSAParameterSpec, q) = r5;
	_JC_REF_FIELD(env, r3, java_security_spec_DSAParameterSpec, g) = r6;
	_JC_CANCEL_TRAPS(env, catch);
	return r3;

label3:
	_JC_LINE_NUMBER(121);				// 2
	r7 = _JC_NEW(env, java_security_spec_InvalidParameterSpecException);
	r8 = _JC_STRING(env, "Only accepts DSAParameterSpec");
	_JC_REF_FIELD(env, r7, java_lang_Throwable, cause) = r7;
	r9 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r7);
	_JC_REF_FIELD(env, r7, java_lang_Throwable, vmState) = r9;
	_JC_REF_FIELD(env, r7, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r7, java_lang_Throwable, detailMessage) = r8;
	_JC_THROW(env, r7);
}

//
// public void engineInit(java.security.spec.AlgorithmParameterSpec) throws java.security.spec.InvalidParameterSpecException
//

static _jc_linenum _jc_gnu_java_security_provider_DSAParameters$linenum_table$engineInit$97ee0e7fb590a770[];

static const unsigned char _jc_gnu_java_security_provider_DSAParameters$param_ptypes$engineInit$97ee0e7fb590a770[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_gnu_java_security_provider_DSAParameters$exceptions$engineInit$97ee0e7fb590a770[] = {
	&_jc_java_security_spec_InvalidParameterSpecException$type
};

static _jc_type *const _jc_gnu_java_security_provider_DSAParameters$param_types$engineInit$97ee0e7fb590a770[] = {
	&_jc_java_security_spec_AlgorithmParameterSpec$type
};

_jc_method _jc_gnu_java_security_provider_DSAParameters$method_info$engineInit$97ee0e7fb590a770 = {
	.name=			"engineInit",
	.signature=		"(Ljava/security/spec/AlgorithmParameterSpec;)V",
	.class=			&_jc_gnu_java_security_provider_DSAParameters$type,
	.param_types=		&_jc_gnu_java_security_provider_DSAParameters$param_types$engineInit$97ee0e7fb590a770,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSAParameters$param_ptypes$engineInit$97ee0e7fb590a770,
	.signature_hash=	_JC_JLONG(0x97ee0e7fb590a770),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_provider_DSAParameters$method$engineInit$97ee0e7fb590a770,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_provider_DSAParameters$vtable, gnu_java_security_provider_DSAParameters.engineInit$97ee0e7fb590a770) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_gnu_java_security_provider_DSAParameters$exceptions$engineInit$97ee0e7fb590a770,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	7,
	      .table=	_jc_gnu_java_security_provider_DSAParameters$linenum_table$engineInit$97ee0e7fb590a770
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_DSAParameters, engineInit$97ee0e7fb590a770);

void _JC_JCNI_ATTR
_jc_gnu_java_security_provider_DSAParameters$method$engineInit$97ee0e7fb590a770(_jc_env *const env, _jc_gnu_java_security_provider_DSAParameters$object *this, _jc_object *param0)
{
	struct _jc_gnu_java_security_provider_DSAParameters$object *r0;
	struct _jc_object *r1;
	struct _jc_java_security_spec_DSAParameterSpec$object *r2;
	struct _jc_java_math_BigInteger$object *r3;
	struct _jc_java_security_spec_InvalidParameterSpecException$object *r4;
	struct _jc_java_lang_String$object *r5;
	struct _jc_java_lang_VMThrowable$object *r7;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(78);				// 0
	z0 = _JC_INSTANCEOF(env, r1, &_jc_java_security_spec_DSAParameterSpec$type);
	if (z0 == 0)
		goto label0;
	_JC_LINE_NUMBER(79);				// 1
	r2 = r1;
	_JC_LINE_NUMBER(80);				// 2
	r3 = _JC_INVOKE_VIRTUAL(env, java_security_spec_DSAParameterSpec, getP$612c6062f1779963, r2);
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAParameters, p) = r3;
	_JC_LINE_NUMBER(81);				// 3
	r3 = _JC_INVOKE_VIRTUAL(env, java_security_spec_DSAParameterSpec, getQ$e08c53541a87120d, r2);
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAParameters, q) = r3;
	_JC_LINE_NUMBER(82);				// 4
	r3 = _JC_INVOKE_VIRTUAL(env, java_security_spec_DSAParameterSpec, getG$59cffd735b56d8ad, r2);
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAParameters, g) = r3;
	goto label1;

label0:
	_JC_LINE_NUMBER(85);				// 5
	r4 = _JC_NEW(env, java_security_spec_InvalidParameterSpecException);
	r5 = _JC_STRING(env, "Only accepts DSAParameterSpec");
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r7 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r7;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r5;
	_JC_THROW(env, r4);

label1:
	_JC_LINE_NUMBER(86);				// 6
	return;
}

//
// public void engineInit(byte[]) throws java.io.IOException
//

static _jc_linenum _jc_gnu_java_security_provider_DSAParameters$linenum_table$engineInit$02e0befd93d9fd30[];

static _jc_trap_info _jc_gnu_java_security_provider_DSAParameters$trap_table$engineInit$02e0befd93d9fd30[] = {
	_JC_TRAP(&_jc_java_lang_Exception$type, 1, 2),
};

static const unsigned char _jc_gnu_java_security_provider_DSAParameters$param_ptypes$engineInit$02e0befd93d9fd30[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_gnu_java_security_provider_DSAParameters$exceptions$engineInit$02e0befd93d9fd30[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_gnu_java_security_provider_DSAParameters$param_types$engineInit$02e0befd93d9fd30[] = {
	&_jc_byte$array$prim$type
};

_jc_method _jc_gnu_java_security_provider_DSAParameters$method_info$engineInit$02e0befd93d9fd30 = {
	.name=			"engineInit",
	.signature=		"([B)V",
	.class=			&_jc_gnu_java_security_provider_DSAParameters$type,
	.param_types=		&_jc_gnu_java_security_provider_DSAParameters$param_types$engineInit$02e0befd93d9fd30,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSAParameters$param_ptypes$engineInit$02e0befd93d9fd30,
	.signature_hash=	_JC_JLONG(0x2e0befd93d9fd30),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_provider_DSAParameters$method$engineInit$02e0befd93d9fd30,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_provider_DSAParameters$vtable, gnu_java_security_provider_DSAParameters.engineInit$02e0befd93d9fd30) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_gnu_java_security_provider_DSAParameters$exceptions$engineInit$02e0befd93d9fd30,
	.u= { .exec= {
	  .trap_table_len=	1,
	  .trap_table=		_jc_gnu_java_security_provider_DSAParameters$trap_table$engineInit$02e0befd93d9fd30,
	  .u= {
	    .linenum= {
	      .len=	9,
	      .table=	_jc_gnu_java_security_provider_DSAParameters$linenum_table$engineInit$02e0befd93d9fd30
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_DSAParameters, engineInit$02e0befd93d9fd30);

void _JC_JCNI_ATTR
_jc_gnu_java_security_provider_DSAParameters$method$engineInit$02e0befd93d9fd30(_jc_env *const env, _jc_gnu_java_security_provider_DSAParameters$object *this, _jc_byte_array *param0)
{
	jint i0;
	struct _jc_gnu_java_security_provider_DSAParameters$object *r0;
	_jc_byte_array *r1;
	struct _jc_java_lang_String$object *volatile r10;
	struct _jc_java_io_ByteArrayInputStream$object *r11;
	struct _jc_java_lang_VMThrowable$object *r12;
	struct _jc_java_lang_VMThrowable$object *volatile r13;
	struct _jc_java_io_ByteArrayOutputStream$object *r14;
	_jc_byte_array *r15;
	struct _jc_gnu_java_security_der_DERReader$object *r2;
	struct _jc_gnu_java_security_der_DERValue$object *r3;
	struct _jc_java_lang_Exception$object *r4;
	struct _jc_java_lang_Object$object *r5;
	struct _jc_java_lang_Object$object *r6;
	struct _jc_gnu_java_io_ASN1ParsingException$object *volatile r7;
	struct _jc_java_math_BigInteger$object *r8;
	struct _jc_java_lang_String$object *r9;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_gnu_java_security_provider_DSAParameters$method_info$engineInit$02e0befd93d9fd30, &&label1);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(91);				// 0
	r2 = _JC_NEW(env, gnu_java_security_der_DERReader);
	r11 = _JC_NEW(env, java_io_ByteArrayInputStream);
	i0 = _JC_ARRAY_LENGTH(env, r1);
	_JC_INVOKE_NONVIRTUAL(env, java_io_ByteArrayInputStream, _init$4ff4a7925ef7b06c, 0, r11, r1, 0, i0);
	_JC_REF_FIELD(env, r2, gnu_java_security_der_DERReader, in) = r11;
	r14 = _JC_NEW(env, java_io_ByteArrayOutputStream);
	r15 = _JC_NEW_PRIM_ARRAY(env, byte, 1, 2048);
	_JC_REF_FIELD(env, r14, java_io_ByteArrayOutputStream, buf) = r15;
	_JC_PRIM_FIELD(env, r14, java_io_ByteArrayOutputStream, count) = 0;
	_JC_REF_FIELD(env, r2, gnu_java_security_der_DERReader, encBuf) = r14;
	_JC_LINE_NUMBER(92);				// 1
	r3 = _JC_INVOKE_NONVIRTUAL(env, gnu_java_security_der_DERReader, read$97cabf4c92410204, 0, r2);
	_JC_LINE_NUMBER(93);				// 2
	r5 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_der_DERValue, getValue$6f8b281a5ffcc94f, r3);
	r6 = _JC_STATIC_FIELD(env, gnu_java_security_der_DER, CONSTRUCTED__5fVALUE, 0);
	if (r5 == r6)
		goto label0;
	_JC_LINE_NUMBER(94);				// 3
	r7 = _JC_NEW(env, gnu_java_io_ASN1ParsingException);
	r9 = _JC_STRING(env, "badly formed parameters");
	_JC_REF_FIELD(env, r7, java_lang_Throwable, cause) = r7;
	r12 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r7);
	_JC_REF_FIELD(env, r7, java_lang_Throwable, vmState) = r12;
	_JC_REF_FIELD(env, r7, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r7, java_lang_Throwable, detailMessage) = r9;
	_JC_THROW(env, r7);

label0:
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(97);				// 4
	r3 = _JC_INVOKE_NONVIRTUAL(env, gnu_java_security_der_DERReader, read$97cabf4c92410204, 0, r2);
	r6 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_der_DERValue, getValue$6f8b281a5ffcc94f, r3);
	r8 = _JC_CAST(env, &_jc_java_math_BigInteger$type, r6);
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAParameters, p) = r8;
	_JC_LINE_NUMBER(98);				// 5
	r3 = _JC_INVOKE_NONVIRTUAL(env, gnu_java_security_der_DERReader, read$97cabf4c92410204, 0, r2);
	r6 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_der_DERValue, getValue$6f8b281a5ffcc94f, r3);
	r8 = _JC_CAST(env, &_jc_java_math_BigInteger$type, r6);
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAParameters, q) = r8;
	_JC_LINE_NUMBER(99);				// 6
	r3 = _JC_INVOKE_NONVIRTUAL(env, gnu_java_security_der_DERReader, read$97cabf4c92410204, 0, r2);
	r6 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_der_DERValue, getValue$6f8b281a5ffcc94f, r3);
	r8 = _JC_CAST(env, &_jc_java_math_BigInteger$type, r6);
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAParameters, g) = r8;
	_JC_TRAP_REGION(catch, 2);
	goto label2;

label1:
	_JC_TRAP_REGION(catch, 2);
	r4 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(103);				// 7
	r7 = _JC_NEW(env, gnu_java_io_ASN1ParsingException);
	r10 = _JC_STRING(env, "badly formed parameters");
	_JC_REF_FIELD(env, r7, java_lang_Throwable, cause) = r7;
	r13 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r7);
	_JC_REF_FIELD(env, r7, java_lang_Throwable, vmState) = r13;
	_JC_REF_FIELD(env, r7, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r7, java_lang_Throwable, detailMessage) = r10;
	_JC_THROW(env, r7);

label2:
	_JC_LINE_NUMBER(105);				// 8
	_JC_CANCEL_TRAPS(env, catch);
	return;
}

//
// public void engineInit(byte[], java.lang.String) throws java.io.IOException
//

static _jc_linenum _jc_gnu_java_security_provider_DSAParameters$linenum_table$engineInit$931dff8137fe24b0[];

static const unsigned char _jc_gnu_java_security_provider_DSAParameters$param_ptypes$engineInit$931dff8137fe24b0[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_gnu_java_security_provider_DSAParameters$exceptions$engineInit$931dff8137fe24b0[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_gnu_java_security_provider_DSAParameters$param_types$engineInit$931dff8137fe24b0[] = {
	&_jc_byte$array$prim$type,
	&_jc_java_lang_String$type
};

_jc_method _jc_gnu_java_security_provider_DSAParameters$method_info$engineInit$931dff8137fe24b0 = {
	.name=			"engineInit",
	.signature=		"([BLjava/lang/String;)V",
	.class=			&_jc_gnu_java_security_provider_DSAParameters$type,
	.param_types=		&_jc_gnu_java_security_provider_DSAParameters$param_types$engineInit$931dff8137fe24b0,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSAParameters$param_ptypes$engineInit$931dff8137fe24b0,
	.signature_hash=	_JC_JLONG(0x931dff8137fe24b0),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_provider_DSAParameters$method$engineInit$931dff8137fe24b0,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_provider_DSAParameters$vtable, gnu_java_security_provider_DSAParameters.engineInit$931dff8137fe24b0) / sizeof(void *),
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_gnu_java_security_provider_DSAParameters$exceptions$engineInit$931dff8137fe24b0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_gnu_java_security_provider_DSAParameters$linenum_table$engineInit$931dff8137fe24b0
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_DSAParameters, engineInit$931dff8137fe24b0);

void _JC_JCNI_ATTR
_jc_gnu_java_security_provider_DSAParameters$method$engineInit$931dff8137fe24b0(_jc_env *const env, _jc_gnu_java_security_provider_DSAParameters$object *this, _jc_byte_array *param0, _jc_java_lang_String$object *param1)
{
	struct _jc_gnu_java_security_provider_DSAParameters$object *r0;
	_jc_byte_array *r1;
	struct _jc_java_lang_String$object *r2;
	struct _jc_java_io_IOException$object *r3;
	struct _jc_java_lang_String$object *r4;
	struct _jc_java_lang_VMThrowable$object *r6;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_LINE_NUMBER(110);				// 0
	z0 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, equals$8a15e0625571c581, 1, r2, _JC_STRING(env, "ASN.1"));
	if (z0 != 0)
		goto label0;
	_JC_LINE_NUMBER(111);				// 1
	r3 = _JC_NEW(env, java_io_IOException);
	r4 = _JC_STRING(env, "Invalid Format: Only accepts ASN.1");
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r6 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r6;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r4;
	_JC_THROW(env, r3);

label0:
	_JC_LINE_NUMBER(112);				// 2
	_JC_INVOKE_VIRTUAL(env, gnu_java_security_provider_DSAParameters, engineInit$02e0befd93d9fd30, r0, r1);
	_JC_LINE_NUMBER(113);				// 3
	return;
}

//
// public java.lang.String engineToString()
//

static _jc_linenum _jc_gnu_java_security_provider_DSAParameters$linenum_table$engineToString$6f451262668adb9f[];

static const unsigned char _jc_gnu_java_security_provider_DSAParameters$param_ptypes$engineToString$6f451262668adb9f[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_gnu_java_security_provider_DSAParameters$method_info$engineToString$6f451262668adb9f = {
	.name=			"engineToString",
	.signature=		"()Ljava/lang/String;",
	.class=			&_jc_gnu_java_security_provider_DSAParameters$type,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSAParameters$param_ptypes$engineToString$6f451262668adb9f,
	.signature_hash=	_JC_JLONG(0x6f451262668adb9f),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_provider_DSAParameters$method$engineToString$6f451262668adb9f,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_provider_DSAParameters$vtable, gnu_java_security_provider_DSAParameters.engineToString$6f451262668adb9f) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_gnu_java_security_provider_DSAParameters$linenum_table$engineToString$6f451262668adb9f
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_DSAParameters, engineToString$6f451262668adb9f);

_jc_java_lang_String$object * _JC_JCNI_ATTR
_jc_gnu_java_security_provider_DSAParameters$method$engineToString$6f451262668adb9f(_jc_env *const env, _jc_gnu_java_security_provider_DSAParameters$object *this)
{
	struct _jc_gnu_java_security_provider_DSAParameters$object *r0;
	struct _jc_java_lang_StringBuffer$object *r1;
	struct _jc_java_math_BigInteger$object *r2;
	struct _jc_java_lang_String$object *r3;
	struct _jc_java_lang_StringBuffer$object *r4;
	struct _jc_java_lang_String$object *r5;
	struct _jc_java_lang_StringBuffer$object *r6;
	struct _jc_java_lang_String$object *r8;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(147);				// 0
	r1 = _JC_NEW(env, java_lang_StringBuffer);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, _init$c31b894660454d13, 0, r1, _JC_STRING(env, "q: "));
	r2 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAParameters, q);
	r4 = r1;
	if (r2 != _JC_NULL)
		goto label0;
	r5 = _JC_STRING(env, "null");
	goto label1;

label0:
	r5 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, toString$7ea43b33b80a3070, r2);

label1:
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, r5);
	r1 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, _JC_STRING(env, " p: "));
	r2 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAParameters, p);
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	r6 = r1;
	if (r2 != _JC_NULL)
		goto label2;
	r8 = _JC_STRING(env, "null");
	goto label3;

label2:
	r8 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, toString$7ea43b33b80a3070, r2);

label3:
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r6, r8);
	r1 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r6, _JC_STRING(env, " g: "));
	r2 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSAParameters, g);
	r1 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$aa87b40433722847, 1, r1, r2);
	r3 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r3, r1);
	return r3;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_gnu_java_security_provider_DSAParameters$methods[] = {
	&_jc_gnu_java_security_provider_DSAParameters$method_info$_init$52f4ad9f2989aeee,
	&_jc_gnu_java_security_provider_DSAParameters$method_info$class$c900dc17c9967b78,
	&_jc_gnu_java_security_provider_DSAParameters$method_info$engineGetEncoded$c6f5908664ac2899,
	&_jc_gnu_java_security_provider_DSAParameters$method_info$engineGetEncoded$e53c01cc263f9e1e,
	&_jc_gnu_java_security_provider_DSAParameters$method_info$engineGetParameterSpec$5324b6890b10eccd,
	&_jc_gnu_java_security_provider_DSAParameters$method_info$engineInit$97ee0e7fb590a770,
	&_jc_gnu_java_security_provider_DSAParameters$method_info$engineInit$02e0befd93d9fd30,
	&_jc_gnu_java_security_provider_DSAParameters$method_info$engineInit$931dff8137fe24b0,
	&_jc_gnu_java_security_provider_DSAParameters$method_info$engineToString$6f451262668adb9f
};

/************************************************************************
 *			  Class fields structure			*
 ************************************************************************/

_jc_gnu_java_security_provider_DSAParameters$fields_struct _jc_gnu_java_security_provider_DSAParameters$class_fields = { };

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_gnu_java_security_provider_DSAParameters$instanceof_hash_bucket_67[] = {
	&_jc_gnu_java_security_provider_DSAParameters$type,
	_JC_NULL
};
static _jc_type *const _jc_gnu_java_security_provider_DSAParameters$instanceof_hash_bucket_82[] = {
	&_jc_java_security_AlgorithmParametersSpi$type,
	_JC_NULL
};
static _jc_type *const _jc_gnu_java_security_provider_DSAParameters$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_gnu_java_security_provider_DSAParameters$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[67]=	_jc_gnu_java_security_provider_DSAParameters$instanceof_hash_bucket_67,
	[82]=	_jc_gnu_java_security_provider_DSAParameters$instanceof_hash_bucket_82,
	[101]=	_jc_gnu_java_security_provider_DSAParameters$instanceof_hash_bucket_101
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_gnu_java_security_provider_DSAParameters$class_depends[] = {
	{ "gnu/java/io/ASN1ParsingException",	_JC_JLONG(0x95647318e434aadc) },
	{ "gnu/java/security/der/DER",	_JC_JLONG(0xc3c7f628c3880116) },
	{ "gnu/java/security/der/DERReader",	_JC_JLONG(0x78ef52e48159b870) },
	{ "gnu/java/security/der/DERValue",	_JC_JLONG(0xde1638783317796a) },
	{ "gnu/java/security/der/DERWriter",	_JC_JLONG(0x87aa78f6a77ed8b) },
	{ "java/io/ByteArrayInputStream",	_JC_JLONG(0xa68cc27886fd8be3) },
	{ "java/io/ByteArrayOutputStream",	_JC_JLONG(0xc4d3cc2bda03a338) },
	{ "java/io/IOException",	_JC_JLONG(0x4e0a56550c69d57c) },
	{ "java/io/OutputStream",	_JC_JLONG(0x4026d3144d6654d8) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/ClassNotFoundException",	_JC_JLONG(0x1f925cf50bfc0d6c) },
	{ "java/lang/Error",	_JC_JLONG(0x308333d803f5ab9f) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/LinkageError",	_JC_JLONG(0x3746e17e005bda9e) },
	{ "java/lang/NoClassDefFoundError",	_JC_JLONG(0x2082ebb592ac2255) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/StringBuffer",	_JC_JLONG(0x94d357637b968dda) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMClass",	_JC_JLONG(0x238a2c0aafd74314) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/math/BigInteger",	_JC_JLONG(0x7717ded55c30b7f3) },
	{ "java/security/AlgorithmParametersSpi",	_JC_JLONG(0xfe4af2c744a13852) },
	{ "java/security/GeneralSecurityException",	_JC_JLONG(0x692089051f4c8d0b) },
	{ "java/security/spec/AlgorithmParameterSpec",	_JC_JLONG(0xef2e5e8af121478f) },
	{ "java/security/spec/DSAParameterSpec",	_JC_JLONG(0x96064ba9ffd4a2f9) },
	{ "java/security/spec/InvalidParameterSpecException",	_JC_JLONG(0x6afab99500ae813) },
	{ "java/util/AbstractCollection",	_JC_JLONG(0x8ea716c64b77f8eb) },
	{ "java/util/AbstractList",	_JC_JLONG(0xf5238436362828db) },
	{ "java/util/ArrayList",	_JC_JLONG(0x58038509830ef3f4) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_gnu_java_security_provider_DSAParameters$vtype _jc_gnu_java_security_provider_DSAParameters$type = {
    .type= {
	.name=			"gnu/java/security/provider/DSAParameters",
	.superclass=		&_jc_java_security_AlgorithmParametersSpi$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		25,
		.hash=			_JC_JLONG(0xe2d97b5820c28143),
		.source_file=		"DSAParameters.java",
		.instance_size=		sizeof(_jc_gnu_java_security_provider_DSAParameters$refs) + sizeof(_jc_gnu_java_security_provider_DSAParameters$object),
		.num_virtual_refs=	3,
		.num_fields=		sizeof(_jc_gnu_java_security_provider_DSAParameters$fields) / sizeof(*_jc_gnu_java_security_provider_DSAParameters$fields),
		.fields=		_jc_gnu_java_security_provider_DSAParameters$fields,
		.num_methods=		sizeof(_jc_gnu_java_security_provider_DSAParameters$methods) / sizeof(*_jc_gnu_java_security_provider_DSAParameters$methods),
		.methods=		_jc_gnu_java_security_provider_DSAParameters$methods,
		.instanceof_hash_table=	_jc_gnu_java_security_provider_DSAParameters$instanceof_hash_table,
		.class_fields=		&_jc_gnu_java_security_provider_DSAParameters$class_fields,
		.num_class_depends=		sizeof(_jc_gnu_java_security_provider_DSAParameters$class_depends) / sizeof(*_jc_gnu_java_security_provider_DSAParameters$class_depends),
		.class_depends=		_jc_gnu_java_security_provider_DSAParameters$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.java_security_AlgorithmParametersSpi= {
	    .engineGetEncoded$c6f5908664ac2899=		// overridden
		&_jc_gnu_java_security_provider_DSAParameters$method$engineGetEncoded$c6f5908664ac2899,
	    .engineGetEncoded$e53c01cc263f9e1e=		// overridden
		&_jc_gnu_java_security_provider_DSAParameters$method$engineGetEncoded$e53c01cc263f9e1e,
	    .engineGetParameterSpec$5324b6890b10eccd=	// overridden
		&_jc_gnu_java_security_provider_DSAParameters$method$engineGetParameterSpec$5324b6890b10eccd,
	    .engineInit$97ee0e7fb590a770=			// overridden
		&_jc_gnu_java_security_provider_DSAParameters$method$engineInit$97ee0e7fb590a770,
	    .engineInit$02e0befd93d9fd30=			// overridden
		&_jc_gnu_java_security_provider_DSAParameters$method$engineInit$02e0befd93d9fd30,
	    .engineInit$931dff8137fe24b0=			// overridden
		&_jc_gnu_java_security_provider_DSAParameters$method$engineInit$931dff8137fe24b0,
	    .engineToString$6f451262668adb9f=		// overridden
		&_jc_gnu_java_security_provider_DSAParameters$method$engineToString$6f451262668adb9f,
	},
	.gnu_java_security_provider_DSAParameters= {
	    .engineGetEncoded$c6f5908664ac2899=
		&_jc_gnu_java_security_provider_DSAParameters$method$engineGetEncoded$c6f5908664ac2899,
	    .engineGetEncoded$e53c01cc263f9e1e=
		&_jc_gnu_java_security_provider_DSAParameters$method$engineGetEncoded$e53c01cc263f9e1e,
	    .engineGetParameterSpec$5324b6890b10eccd=
		&_jc_gnu_java_security_provider_DSAParameters$method$engineGetParameterSpec$5324b6890b10eccd,
	    .engineInit$97ee0e7fb590a770=
		&_jc_gnu_java_security_provider_DSAParameters$method$engineInit$97ee0e7fb590a770,
	    .engineInit$02e0befd93d9fd30=
		&_jc_gnu_java_security_provider_DSAParameters$method$engineInit$02e0befd93d9fd30,
	    .engineInit$931dff8137fe24b0=
		&_jc_gnu_java_security_provider_DSAParameters$method$engineInit$931dff8137fe24b0,
	    .engineToString$6f451262668adb9f=
		&_jc_gnu_java_security_provider_DSAParameters$method$engineToString$6f451262668adb9f,
	},
    }
};

