// public class gnu.java.security.provider.DSASignature

// class file dependencies
// @dep_class 78ef52e48159b870 gnu_java_security_der_DERReader
// @dep_class de1638783317796a gnu_java_security_der_DERValue
// @dep_class 87aa78f6a77ed8b gnu_java_security_der_DERWriter
// @dep_class 90ec63c67b1c5fac gnu_java_security_provider_DSASignature
// @dep_class a68cc27886fd8be3 java_io_ByteArrayInputStream
// @dep_class c4d3cc2bda03a338 java_io_ByteArrayOutputStream
// @dep_class 4e0a56550c69d57c java_io_IOException
// @dep_class 4026d3144d6654d8 java_io_OutputStream
// @dep_class 42020e4665019671 java_lang_ArithmeticException
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class d59353b5e031d754 java_lang_CloneNotSupportedException
// @dep_class 9b667b09132be893 java_lang_Cloneable
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class 680cf34d05feb5a1 java_lang_IllegalArgumentException
// @dep_class b7e704701c278e65 java_lang_IllegalStateException
// @dep_class 9cd7252f79299280 java_lang_Number
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class 4f5534a987354d1d java_lang_RuntimeException
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 53cc8e2333795f04 java_lang_System
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class 312e45ed214d432f java_lang_VMObject
// @dep_class 4d1cebae0bdda058 java_lang_VMSystem
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class 7717ded55c30b7f3 java_math_BigInteger
// @dep_class 692089051f4c8d0b java_security_GeneralSecurityException
// @dep_class 327edce29f2562dd java_security_InvalidAlgorithmParameterException
// @dep_class 94dda41e9bf6c170 java_security_InvalidKeyException
// @dep_class 99827f89c0c36c1 java_security_InvalidParameterException
// @dep_class 965d036f0f33fac6 java_security_KeyException
// @dep_class cc2047cad8dcf75e java_security_MessageDigest
// @dep_class 22e937c2536160b4 java_security_NoSuchAlgorithmException
// @dep_class dcdbe4a102f59043 java_security_PrivateKey
// @dep_class 81b073051aa30acc java_security_Provider
// @dep_class 4db3ac05e70e2bf8 java_security_PublicKey
// @dep_class 15c6a62b25a6e96d java_security_SecureRandom
// @dep_class 89bf77984bd9669e java_security_Security
// @dep_class 7ce2f2d523fa52ac java_security_SignatureException
// @dep_class 15e444274ebb7a6e java_security_SignatureSpi
// @dep_class f4f2d6013f72861e java_security_interfaces_DSAParams
// @dep_class d57e7f1f963e5163 java_security_interfaces_DSAPrivateKey
// @dep_class bad97fafc9653a27 java_security_interfaces_DSAPublicKey
// @dep_class ef2e5e8af121478f java_security_spec_AlgorithmParameterSpec
// @dep_class 8ea716c64b77f8eb java_util_AbstractCollection
// @dep_class f5238436362828db java_util_AbstractList
// @dep_class 58038509830ef3f4 java_util_ArrayList

// header file dependencies
// @dep_header gnu_java_security_der_DERReader
// @dep_header gnu_java_security_der_DERValue
// @dep_header gnu_java_security_der_DERWriter
// @dep_header gnu_java_security_provider_DSASignature
// @dep_header java_io_ByteArrayInputStream
// @dep_header java_io_ByteArrayOutputStream
// @dep_header java_io_IOException
// @dep_header java_lang_ArithmeticException
// @dep_header java_lang_Class
// @dep_header java_lang_CloneNotSupportedException
// @dep_header java_lang_Cloneable
// @dep_header java_lang_IllegalStateException
// @dep_header java_lang_String
// @dep_header java_lang_System
// @dep_header java_lang_VMObject
// @dep_header java_lang_VMSystem
// @dep_header java_lang_VMThrowable
// @dep_header java_math_BigInteger
// @dep_header java_security_InvalidAlgorithmParameterException
// @dep_header java_security_InvalidKeyException
// @dep_header java_security_InvalidParameterException
// @dep_header java_security_MessageDigest
// @dep_header java_security_NoSuchAlgorithmException
// @dep_header java_security_PrivateKey
// @dep_header java_security_Provider
// @dep_header java_security_PublicKey
// @dep_header java_security_SecureRandom
// @dep_header java_security_Security
// @dep_header java_security_SignatureException
// @dep_header java_security_interfaces_DSAParams
// @dep_header java_security_interfaces_DSAPrivateKey
// @dep_header java_security_interfaces_DSAPublicKey
// @dep_header java_security_spec_AlgorithmParameterSpec
// @dep_header java_util_ArrayList

#include "jc_defs.h"

#include "gnu/java/security/der/DERReader.h"
#include "gnu/java/security/der/DERValue.h"
#include "gnu/java/security/der/DERWriter.h"
#include "gnu/java/security/provider/DSASignature.h"
#include "java/io/ByteArrayInputStream.h"
#include "java/io/ByteArrayOutputStream.h"
#include "java/io/IOException.h"
#include "java/lang/ArithmeticException.h"
#include "java/lang/Class.h"
#include "java/lang/CloneNotSupportedException.h"
#include "java/lang/Cloneable.h"
#include "java/lang/IllegalStateException.h"
#include "java/lang/String.h"
#include "java/lang/System.h"
#include "java/lang/VMObject.h"
#include "java/lang/VMSystem.h"
#include "java/lang/VMThrowable.h"
#include "java/math/BigInteger.h"
#include "java/security/InvalidAlgorithmParameterException.h"
#include "java/security/InvalidKeyException.h"
#include "java/security/InvalidParameterException.h"
#include "java/security/MessageDigest.h"
#include "java/security/NoSuchAlgorithmException.h"
#include "java/security/PrivateKey.h"
#include "java/security/Provider.h"
#include "java/security/PublicKey.h"
#include "java/security/SecureRandom.h"
#include "java/security/Security.h"
#include "java/security/SignatureException.h"
#include "java/security/interfaces/DSAParams.h"
#include "java/security/interfaces/DSAPrivateKey.h"
#include "java/security/interfaces/DSAPublicKey.h"
#include "java/security/spec/AlgorithmParameterSpec.h"
#include "java/util/ArrayList.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// private java.security.interfaces.DSAPublicKey publicKey
static _jc_field _jc_gnu_java_security_provider_DSASignature$field_info$publicKey = {
	.name=		"publicKey",
	.signature=	"Ljava/security/interfaces/DSAPublicKey;",
	.class=		&_jc_gnu_java_security_provider_DSASignature$type,
	.type=		&_jc_java_security_interfaces_DSAPublicKey$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_gnu_java_security_provider_DSASignature$object, refs[-1].gnu_java_security_provider_DSASignature.publicKey),
};

// private java.security.interfaces.DSAPrivateKey privateKey
static _jc_field _jc_gnu_java_security_provider_DSASignature$field_info$privateKey = {
	.name=		"privateKey",
	.signature=	"Ljava/security/interfaces/DSAPrivateKey;",
	.class=		&_jc_gnu_java_security_provider_DSASignature$type,
	.type=		&_jc_java_security_interfaces_DSAPrivateKey$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_gnu_java_security_provider_DSASignature$object, refs[-1].gnu_java_security_provider_DSASignature.privateKey),
};

// private final java.security.MessageDigest digest
static _jc_field _jc_gnu_java_security_provider_DSASignature$field_info$digest = {
	.name=		"digest",
	.signature=	"Ljava/security/MessageDigest;",
	.class=		&_jc_gnu_java_security_provider_DSASignature$type,
	.type=		&_jc_java_security_MessageDigest$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_gnu_java_security_provider_DSASignature$object, refs[-1].gnu_java_security_provider_DSASignature.digest),
};

// private final java.security.SecureRandom random
static _jc_field _jc_gnu_java_security_provider_DSASignature$field_info$random = {
	.name=		"random",
	.signature=	"Ljava/security/SecureRandom;",
	.class=		&_jc_gnu_java_security_provider_DSASignature$type,
	.type=		&_jc_java_security_SecureRandom$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_gnu_java_security_provider_DSASignature$object, refs[-1].gnu_java_security_provider_DSASignature.random),
};

// Fields
static _jc_field *const _jc_gnu_java_security_provider_DSASignature$fields[] = {
	&_jc_gnu_java_security_provider_DSASignature$field_info$digest,
	&_jc_gnu_java_security_provider_DSASignature$field_info$privateKey,
	&_jc_gnu_java_security_provider_DSASignature$field_info$publicKey,
	&_jc_gnu_java_security_provider_DSASignature$field_info$random
};

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// public void <init>() throws java.security.NoSuchAlgorithmException
//

static _jc_linenum _jc_gnu_java_security_provider_DSASignature$linenum_table$_init$52f4ad9f2989aeee[];

static _jc_trap_info _jc_gnu_java_security_provider_DSASignature$trap_table$_init$52f4ad9f2989aeee[] = {
	_JC_TRAP(&_jc_java_security_NoSuchAlgorithmException$type, 1, 2),
};

static const unsigned char _jc_gnu_java_security_provider_DSASignature$param_ptypes$_init$52f4ad9f2989aeee[] = { 
_JC_TYPE_VOID };

static _jc_type *const _jc_gnu_java_security_provider_DSASignature$exceptions$_init$52f4ad9f2989aeee[] = {
	&_jc_java_security_NoSuchAlgorithmException$type
};

_jc_method _jc_gnu_java_security_provider_DSASignature$method_info$_init$52f4ad9f2989aeee = {
	.name=			"<init>",
	.signature=		"()V",
	.class=			&_jc_gnu_java_security_provider_DSASignature$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSASignature$param_ptypes$_init$52f4ad9f2989aeee,
	.signature_hash=	_JC_JLONG(0x52f4ad9f2989aeee),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_provider_DSASignature$method$_init$52f4ad9f2989aeee,
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_gnu_java_security_provider_DSASignature$exceptions$_init$52f4ad9f2989aeee,
	.u= { .exec= {
	  .trap_table_len=	1,
	  .trap_table=		_jc_gnu_java_security_provider_DSASignature$trap_table$_init$52f4ad9f2989aeee,
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_gnu_java_security_provider_DSASignature$linenum_table$_init$52f4ad9f2989aeee
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_DSASignature, _init$52f4ad9f2989aeee);

void _JC_JCNI_ATTR
_jc_gnu_java_security_provider_DSASignature$method$_init$52f4ad9f2989aeee(_jc_env *const env, _jc_gnu_java_security_provider_DSASignature$object *this)
{
	jint volatile i0;
	jint volatile i1;
	struct _jc_gnu_java_security_provider_DSASignature$object *volatile r0;
	struct _jc_java_security_SecureRandom$object *r1;
	struct _jc_java_lang_String$object *volatile r2;
	_jc_object_array *volatile r3;
	struct _jc_java_security_Provider$object *volatile r4;
	struct _jc_java_security_MessageDigest$object *volatile r5;
	struct _jc_java_security_NoSuchAlgorithmException$object *volatile r6;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_gnu_java_security_provider_DSASignature$method_info$_init$52f4ad9f2989aeee, &&label1);

	r0 = this;
	_JC_REF_FIELD(env, r0, java_security_SignatureSpi, appRandom) = _JC_NULL;
	_JC_LINE_NUMBER(74);				// 0
	r1 = _JC_NEW(env, java_security_SecureRandom);
	_JC_INVOKE_NONVIRTUAL(env, java_security_SecureRandom, _init$52f4ad9f2989aeee, 0, r1);
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, random) = r1;
	_JC_ACTIVE_USE(env, java_security_MessageDigest);
	_JC_LINE_NUMBER(75);				// 1
	r2 = _JC_STRING(env, "SHA1");
	r3 = _JC_INVOKE_STATIC(env, java_security_Security, getProviders$03fdcd7bb40e95b7, 0);
	i0 = 0;
	goto label2;

label0:
	_JC_TRAP_REGION(catch, 1);
	r4 = _JC_REF_ELEMENT(env, r3, i0, 1, 1);
	r5 = _JC_INVOKE_STATIC(env, java_security_MessageDigest, getInstance$60ade29cbc652343, 0, r2, r4);
	_JC_TRAP_REGION(catch, 2);
	goto label3;

label1:
	_JC_TRAP_REGION(catch, 2);
	r6 = _JC_CAUGHT_EXCEPTION(env);
	i0 = i0 + 1;

label2:
	_JC_TRAP_REGION(catch, 2);
	i1 = _JC_ARRAY_LENGTH(env, r3);
	if (i0 < i1) {
		_JC_PERIODIC_CHECK(env);
		goto label0;
	}
	r6 = _JC_NEW(env, java_security_NoSuchAlgorithmException);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_Throwable, _init$c31b894660454d13, 0, r6, r2);
	_JC_THROW(env, r6);

label3:
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, digest) = r5;
	_JC_LINE_NUMBER(76);				// 2
	_JC_CANCEL_TRAPS(env, catch);
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public java.lang.Object clone() throws java.lang.CloneNotSupportedException
//

static _jc_linenum _jc_gnu_java_security_provider_DSASignature$linenum_table$clone$b75f2713d6705f70[];

static const unsigned char _jc_gnu_java_security_provider_DSASignature$param_ptypes$clone$b75f2713d6705f70[] = { 
_JC_TYPE_REFERENCE };

static _jc_type *const _jc_gnu_java_security_provider_DSASignature$exceptions$clone$b75f2713d6705f70[] = {
	&_jc_java_lang_CloneNotSupportedException$type
};

_jc_method _jc_gnu_java_security_provider_DSASignature$method_info$clone$b75f2713d6705f70 = {
	.name=			"clone",
	.signature=		"()Ljava/lang/Object;",
	.class=			&_jc_gnu_java_security_provider_DSASignature$type,
	.return_type=		&_jc_java_lang_Object$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSASignature$param_ptypes$clone$b75f2713d6705f70,
	.signature_hash=	_JC_JLONG(0xb75f2713d6705f70),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_provider_DSASignature$method$clone$b75f2713d6705f70,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_provider_DSASignature$vtable, gnu_java_security_provider_DSASignature.clone$b75f2713d6705f70) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_gnu_java_security_provider_DSASignature$exceptions$clone$b75f2713d6705f70,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_gnu_java_security_provider_DSASignature$linenum_table$clone$b75f2713d6705f70
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_DSASignature, clone$b75f2713d6705f70);

_jc_java_lang_Object$object * _JC_JCNI_ATTR
_jc_gnu_java_security_provider_DSASignature$method$clone$b75f2713d6705f70(_jc_env *const env, _jc_gnu_java_security_provider_DSASignature$object *this)
{
	struct _jc_gnu_java_security_provider_DSASignature$object *r0;
	struct _jc_java_lang_Object$object *r1;
	struct _jc_object *r2;
	struct _jc_java_lang_CloneNotSupportedException$object *r3;
	struct _jc_java_lang_String$object *r4;
	struct _jc_java_lang_VMThrowable$object *r6;
	jboolean z0;

	r0 = this;
	z0 = _JC_INSTANCEOF(env, r0, &_jc_java_lang_Cloneable$type);
	if (z0 == 0)
		goto label0;
	r2 = r0;
	r1 = _JC_INVOKE_STATIC(env, java_lang_VMObject, clone$3943fce805d80b70, 0, r2);
	goto label1;

label0:
	r3 = _JC_NEW(env, java_lang_CloneNotSupportedException);
	r4 = _JC_STRING(env, "Object not cloneable");
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r6 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r6;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r4;
	_JC_THROW(env, r3);

label1:
	_JC_LINE_NUMBER(249);				// 0
	return r1;
}

//
// public java.lang.Object engineGetParameter(java.lang.String) throws java.security.InvalidParameterException
//

static _jc_linenum _jc_gnu_java_security_provider_DSASignature$linenum_table$engineGetParameter$c70713ab9f3f12d6[];

static const unsigned char _jc_gnu_java_security_provider_DSASignature$param_ptypes$engineGetParameter$c70713ab9f3f12d6[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_gnu_java_security_provider_DSASignature$exceptions$engineGetParameter$c70713ab9f3f12d6[] = {
	&_jc_java_security_InvalidParameterException$type
};

static _jc_type *const _jc_gnu_java_security_provider_DSASignature$param_types$engineGetParameter$c70713ab9f3f12d6[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_gnu_java_security_provider_DSASignature$method_info$engineGetParameter$c70713ab9f3f12d6 = {
	.name=			"engineGetParameter",
	.signature=		"(Ljava/lang/String;)Ljava/lang/Object;",
	.class=			&_jc_gnu_java_security_provider_DSASignature$type,
	.param_types=		&_jc_gnu_java_security_provider_DSASignature$param_types$engineGetParameter$c70713ab9f3f12d6,
	.return_type=		&_jc_java_lang_Object$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSASignature$param_ptypes$engineGetParameter$c70713ab9f3f12d6,
	.signature_hash=	_JC_JLONG(0xc70713ab9f3f12d6),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_provider_DSASignature$method$engineGetParameter$c70713ab9f3f12d6,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_provider_DSASignature$vtable, gnu_java_security_provider_DSASignature.engineGetParameter$c70713ab9f3f12d6) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_gnu_java_security_provider_DSASignature$exceptions$engineGetParameter$c70713ab9f3f12d6,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_gnu_java_security_provider_DSASignature$linenum_table$engineGetParameter$c70713ab9f3f12d6
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_DSASignature, engineGetParameter$c70713ab9f3f12d6);

_jc_java_lang_Object$object * _JC_JCNI_ATTR
_jc_gnu_java_security_provider_DSASignature$method$engineGetParameter$c70713ab9f3f12d6(_jc_env *const env, _jc_gnu_java_security_provider_DSASignature$object *this, _jc_java_lang_String$object *param0)
{
	struct _jc_gnu_java_security_provider_DSASignature$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_java_security_InvalidParameterException$object *r2;
	struct _jc_java_lang_String$object *r3;
	struct _jc_java_lang_VMThrowable$object *r5;

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(244);				// 0
	r2 = _JC_NEW(env, java_security_InvalidParameterException);
	r3 = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, cause) = r2;
	r5 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r2);
	_JC_REF_FIELD(env, r2, java_lang_Throwable, vmState) = r5;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, detailMessage) = r3;
	_JC_THROW(env, r2);
}

//
// public void engineInitSign(java.security.PrivateKey) throws java.security.InvalidKeyException
//

static _jc_linenum _jc_gnu_java_security_provider_DSASignature$linenum_table$engineInitSign$59481b5a8d200c34[];

static const unsigned char _jc_gnu_java_security_provider_DSASignature$param_ptypes$engineInitSign$59481b5a8d200c34[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_gnu_java_security_provider_DSASignature$exceptions$engineInitSign$59481b5a8d200c34[] = {
	&_jc_java_security_InvalidKeyException$type
};

static _jc_type *const _jc_gnu_java_security_provider_DSASignature$param_types$engineInitSign$59481b5a8d200c34[] = {
	&_jc_java_security_PrivateKey$type
};

_jc_method _jc_gnu_java_security_provider_DSASignature$method_info$engineInitSign$59481b5a8d200c34 = {
	.name=			"engineInitSign",
	.signature=		"(Ljava/security/PrivateKey;)V",
	.class=			&_jc_gnu_java_security_provider_DSASignature$type,
	.param_types=		&_jc_gnu_java_security_provider_DSASignature$param_types$engineInitSign$59481b5a8d200c34,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSASignature$param_ptypes$engineInitSign$59481b5a8d200c34,
	.signature_hash=	_JC_JLONG(0x59481b5a8d200c34),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_provider_DSASignature$method$engineInitSign$59481b5a8d200c34,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_provider_DSASignature$vtable, gnu_java_security_provider_DSASignature.engineInitSign$59481b5a8d200c34) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_gnu_java_security_provider_DSASignature$exceptions$engineInitSign$59481b5a8d200c34,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_gnu_java_security_provider_DSASignature$linenum_table$engineInitSign$59481b5a8d200c34
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_DSASignature, engineInitSign$59481b5a8d200c34);

void _JC_JCNI_ATTR
_jc_gnu_java_security_provider_DSASignature$method$engineInitSign$59481b5a8d200c34(_jc_env *const env, _jc_gnu_java_security_provider_DSASignature$object *this, _jc_object *param0)
{
	struct _jc_gnu_java_security_provider_DSASignature$object *r0;
	struct _jc_object *r1;
	struct _jc_object *r2;
	struct _jc_java_security_InvalidKeyException$object *r3;
	struct _jc_java_lang_String$object *r4;
	struct _jc_java_security_MessageDigest$object *r5;
	struct _jc_java_lang_VMThrowable$object *r7;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(96);				// 0
	z0 = _JC_INSTANCEOF(env, r1, &_jc_java_security_interfaces_DSAPrivateKey$type);
	if (z0 == 0)
		goto label0;
	_JC_LINE_NUMBER(97);				// 1
	r2 = r1;
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, privateKey) = r2;
	goto label1;

label0:
	_JC_LINE_NUMBER(99);				// 2
	r3 = _JC_NEW(env, java_security_InvalidKeyException);
	r4 = _JC_STRING(env, "not a DSA private key");
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r7 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r7;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r4;
	_JC_THROW(env, r3);

label1:
	r5 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, digest);
	_JC_INVOKE_VIRTUAL(env, java_security_MessageDigest, reset$229a80b3e8394a0f, r5);
	_JC_LINE_NUMBER(102);				// 3
	return;
}

//
// public void engineInitSign(java.security.PrivateKey, java.security.SecureRandom) throws java.security.InvalidKeyException
//

static _jc_linenum _jc_gnu_java_security_provider_DSASignature$linenum_table$engineInitSign$82a2f1097d5847be[];

static const unsigned char _jc_gnu_java_security_provider_DSASignature$param_ptypes$engineInitSign$82a2f1097d5847be[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_gnu_java_security_provider_DSASignature$exceptions$engineInitSign$82a2f1097d5847be[] = {
	&_jc_java_security_InvalidKeyException$type
};

static _jc_type *const _jc_gnu_java_security_provider_DSASignature$param_types$engineInitSign$82a2f1097d5847be[] = {
	&_jc_java_security_PrivateKey$type,
	&_jc_java_security_SecureRandom$type
};

_jc_method _jc_gnu_java_security_provider_DSASignature$method_info$engineInitSign$82a2f1097d5847be = {
	.name=			"engineInitSign",
	.signature=		"(Ljava/security/PrivateKey;Ljava/security/SecureRandom;)V",
	.class=			&_jc_gnu_java_security_provider_DSASignature$type,
	.param_types=		&_jc_gnu_java_security_provider_DSASignature$param_types$engineInitSign$82a2f1097d5847be,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSASignature$param_ptypes$engineInitSign$82a2f1097d5847be,
	.signature_hash=	_JC_JLONG(0x82a2f1097d5847be),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_provider_DSASignature$method$engineInitSign$82a2f1097d5847be,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_provider_DSASignature$vtable, gnu_java_security_provider_DSASignature.engineInitSign$82a2f1097d5847be) / sizeof(void *),
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_gnu_java_security_provider_DSASignature$exceptions$engineInitSign$82a2f1097d5847be,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_gnu_java_security_provider_DSASignature$linenum_table$engineInitSign$82a2f1097d5847be
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_DSASignature, engineInitSign$82a2f1097d5847be);

void _JC_JCNI_ATTR
_jc_gnu_java_security_provider_DSASignature$method$engineInitSign$82a2f1097d5847be(_jc_env *const env, _jc_gnu_java_security_provider_DSASignature$object *this, _jc_object *param0, _jc_java_security_SecureRandom$object *param1)
{
	struct _jc_gnu_java_security_provider_DSASignature$object *r0;
	struct _jc_object *r1;
	struct _jc_java_security_SecureRandom$object *r2;
	struct _jc_object *r3;
	struct _jc_java_security_InvalidKeyException$object *r4;
	struct _jc_java_lang_String$object *r5;
	struct _jc_java_security_MessageDigest$object *r6;
	struct _jc_java_lang_VMThrowable$object *r8;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_LINE_NUMBER(108);				// 0
	z0 = _JC_INSTANCEOF(env, r1, &_jc_java_security_interfaces_DSAPrivateKey$type);
	if (z0 == 0)
		goto label0;
	_JC_LINE_NUMBER(109);				// 1
	r3 = r1;
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, privateKey) = r3;
	goto label1;

label0:
	_JC_LINE_NUMBER(111);				// 2
	r4 = _JC_NEW(env, java_security_InvalidKeyException);
	r5 = _JC_STRING(env, "not a DSA private key");
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r8 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r8;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r5;
	_JC_THROW(env, r4);

label1:
	_JC_LINE_NUMBER(113);				// 3
	_JC_REF_FIELD(env, r0, java_security_SignatureSpi, appRandom) = r2;
	r6 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, digest);
	_JC_INVOKE_VIRTUAL(env, java_security_MessageDigest, reset$229a80b3e8394a0f, r6);
	_JC_LINE_NUMBER(115);				// 4
	return;
}

//
// public void engineInitVerify(java.security.PublicKey) throws java.security.InvalidKeyException
//

static _jc_linenum _jc_gnu_java_security_provider_DSASignature$linenum_table$engineInitVerify$1de7286f7aa81902[];

static const unsigned char _jc_gnu_java_security_provider_DSASignature$param_ptypes$engineInitVerify$1de7286f7aa81902[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_gnu_java_security_provider_DSASignature$exceptions$engineInitVerify$1de7286f7aa81902[] = {
	&_jc_java_security_InvalidKeyException$type
};

static _jc_type *const _jc_gnu_java_security_provider_DSASignature$param_types$engineInitVerify$1de7286f7aa81902[] = {
	&_jc_java_security_PublicKey$type
};

_jc_method _jc_gnu_java_security_provider_DSASignature$method_info$engineInitVerify$1de7286f7aa81902 = {
	.name=			"engineInitVerify",
	.signature=		"(Ljava/security/PublicKey;)V",
	.class=			&_jc_gnu_java_security_provider_DSASignature$type,
	.param_types=		&_jc_gnu_java_security_provider_DSASignature$param_types$engineInitVerify$1de7286f7aa81902,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSASignature$param_ptypes$engineInitVerify$1de7286f7aa81902,
	.signature_hash=	_JC_JLONG(0x1de7286f7aa81902),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_provider_DSASignature$method$engineInitVerify$1de7286f7aa81902,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_provider_DSASignature$vtable, gnu_java_security_provider_DSASignature.engineInitVerify$1de7286f7aa81902) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_gnu_java_security_provider_DSASignature$exceptions$engineInitVerify$1de7286f7aa81902,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_gnu_java_security_provider_DSASignature$linenum_table$engineInitVerify$1de7286f7aa81902
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_DSASignature, engineInitVerify$1de7286f7aa81902);

void _JC_JCNI_ATTR
_jc_gnu_java_security_provider_DSASignature$method$engineInitVerify$1de7286f7aa81902(_jc_env *const env, _jc_gnu_java_security_provider_DSASignature$object *this, _jc_object *param0)
{
	struct _jc_gnu_java_security_provider_DSASignature$object *r0;
	struct _jc_object *r1;
	struct _jc_object *r2;
	struct _jc_java_security_InvalidKeyException$object *r3;
	struct _jc_java_security_MessageDigest$object *r4;
	struct _jc_java_lang_String$object *r5;
	struct _jc_java_lang_VMThrowable$object *r7;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(86);				// 0
	z0 = _JC_INSTANCEOF(env, r1, &_jc_java_security_interfaces_DSAPublicKey$type);
	if (z0 == 0)
		goto label0;
	_JC_LINE_NUMBER(87);				// 1
	r2 = r1;
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, publicKey) = r2;
	goto label1;

label0:
	_JC_LINE_NUMBER(89);				// 2
	r3 = _JC_NEW(env, java_security_InvalidKeyException);
	r5 = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r7 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r7;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r5;
	_JC_THROW(env, r3);

label1:
	r4 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, digest);
	_JC_INVOKE_VIRTUAL(env, java_security_MessageDigest, reset$229a80b3e8394a0f, r4);
	_JC_LINE_NUMBER(91);				// 3
	return;
}

//
// public void engineSetParameter(java.lang.String, java.lang.Object) throws java.security.InvalidParameterException
//

static _jc_linenum _jc_gnu_java_security_provider_DSASignature$linenum_table$engineSetParameter$fe653a0781d38e86[];

static const unsigned char _jc_gnu_java_security_provider_DSASignature$param_ptypes$engineSetParameter$fe653a0781d38e86[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_gnu_java_security_provider_DSASignature$exceptions$engineSetParameter$fe653a0781d38e86[] = {
	&_jc_java_security_InvalidParameterException$type
};

static _jc_type *const _jc_gnu_java_security_provider_DSASignature$param_types$engineSetParameter$fe653a0781d38e86[] = {
	&_jc_java_lang_String$type,
	&_jc_java_lang_Object$type
};

_jc_method _jc_gnu_java_security_provider_DSASignature$method_info$engineSetParameter$fe653a0781d38e86 = {
	.name=			"engineSetParameter",
	.signature=		"(Ljava/lang/String;Ljava/lang/Object;)V",
	.class=			&_jc_gnu_java_security_provider_DSASignature$type,
	.param_types=		&_jc_gnu_java_security_provider_DSASignature$param_types$engineSetParameter$fe653a0781d38e86,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSASignature$param_ptypes$engineSetParameter$fe653a0781d38e86,
	.signature_hash=	_JC_JLONG(0xfe653a0781d38e86),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_provider_DSASignature$method$engineSetParameter$fe653a0781d38e86,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_provider_DSASignature$vtable, gnu_java_security_provider_DSASignature.engineSetParameter$fe653a0781d38e86) / sizeof(void *),
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_gnu_java_security_provider_DSASignature$exceptions$engineSetParameter$fe653a0781d38e86,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_gnu_java_security_provider_DSASignature$linenum_table$engineSetParameter$fe653a0781d38e86
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_DSASignature, engineSetParameter$fe653a0781d38e86);

void _JC_JCNI_ATTR
_jc_gnu_java_security_provider_DSASignature$method$engineSetParameter$fe653a0781d38e86(_jc_env *const env, _jc_gnu_java_security_provider_DSASignature$object *this, _jc_java_lang_String$object *param0, _jc_java_lang_Object$object *param1)
{
	struct _jc_gnu_java_security_provider_DSASignature$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_java_lang_Object$object *r2;
	struct _jc_java_security_InvalidParameterException$object *r3;
	struct _jc_java_lang_String$object *r4;
	struct _jc_java_lang_VMThrowable$object *r6;

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_LINE_NUMBER(231);				// 0
	r3 = _JC_NEW(env, java_security_InvalidParameterException);
	r4 = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r6 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r6;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r4;
	_JC_THROW(env, r3);
}

//
// public void engineSetParameter(java.security.spec.AlgorithmParameterSpec) throws java.security.InvalidAlgorithmParameterException
//

static _jc_linenum _jc_gnu_java_security_provider_DSASignature$linenum_table$engineSetParameter$1b6a221a44e2a8cf[];

static const unsigned char _jc_gnu_java_security_provider_DSASignature$param_ptypes$engineSetParameter$1b6a221a44e2a8cf[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_gnu_java_security_provider_DSASignature$exceptions$engineSetParameter$1b6a221a44e2a8cf[] = {
	&_jc_java_security_InvalidAlgorithmParameterException$type
};

static _jc_type *const _jc_gnu_java_security_provider_DSASignature$param_types$engineSetParameter$1b6a221a44e2a8cf[] = {
	&_jc_java_security_spec_AlgorithmParameterSpec$type
};

_jc_method _jc_gnu_java_security_provider_DSASignature$method_info$engineSetParameter$1b6a221a44e2a8cf = {
	.name=			"engineSetParameter",
	.signature=		"(Ljava/security/spec/AlgorithmParameterSpec;)V",
	.class=			&_jc_gnu_java_security_provider_DSASignature$type,
	.param_types=		&_jc_gnu_java_security_provider_DSASignature$param_types$engineSetParameter$1b6a221a44e2a8cf,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSASignature$param_ptypes$engineSetParameter$1b6a221a44e2a8cf,
	.signature_hash=	_JC_JLONG(0x1b6a221a44e2a8cf),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_provider_DSASignature$method$engineSetParameter$1b6a221a44e2a8cf,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_provider_DSASignature$vtable, gnu_java_security_provider_DSASignature.engineSetParameter$1b6a221a44e2a8cf) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_gnu_java_security_provider_DSASignature$exceptions$engineSetParameter$1b6a221a44e2a8cf,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_gnu_java_security_provider_DSASignature$linenum_table$engineSetParameter$1b6a221a44e2a8cf
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_DSASignature, engineSetParameter$1b6a221a44e2a8cf);

void _JC_JCNI_ATTR
_jc_gnu_java_security_provider_DSASignature$method$engineSetParameter$1b6a221a44e2a8cf(_jc_env *const env, _jc_gnu_java_security_provider_DSASignature$object *this, _jc_object *param0)
{
	struct _jc_gnu_java_security_provider_DSASignature$object *r0;
	struct _jc_object *r1;
	struct _jc_java_security_InvalidParameterException$object *r2;
	struct _jc_java_lang_String$object *r3;
	struct _jc_java_lang_VMThrowable$object *r5;

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(237);				// 0
	r2 = _JC_NEW(env, java_security_InvalidParameterException);
	r3 = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, cause) = r2;
	r5 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r2);
	_JC_REF_FIELD(env, r2, java_lang_Throwable, vmState) = r5;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, detailMessage) = r3;
	_JC_THROW(env, r2);
}

//
// public byte[] engineSign() throws java.security.SignatureException
//

static _jc_linenum _jc_gnu_java_security_provider_DSASignature$linenum_table$engineSign$ec82475ff8d6db66[];

static _jc_trap_info _jc_gnu_java_security_provider_DSASignature$trap_table$engineSign$ec82475ff8d6db66[] = {
	_JC_TRAP(&_jc_java_io_IOException$type, 1, 2),
	_JC_TRAP(&_jc_java_lang_ArithmeticException$type, 1, 2),
};

static const unsigned char _jc_gnu_java_security_provider_DSASignature$param_ptypes$engineSign$ec82475ff8d6db66[] = { 
_JC_TYPE_REFERENCE };

static _jc_type *const _jc_gnu_java_security_provider_DSASignature$exceptions$engineSign$ec82475ff8d6db66[] = {
	&_jc_java_security_SignatureException$type
};

_jc_method _jc_gnu_java_security_provider_DSASignature$method_info$engineSign$ec82475ff8d6db66 = {
	.name=			"engineSign",
	.signature=		"()[B",
	.class=			&_jc_gnu_java_security_provider_DSASignature$type,
	.return_type=		&_jc_byte$array$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSASignature$param_ptypes$engineSign$ec82475ff8d6db66,
	.signature_hash=	_JC_JLONG(0xec82475ff8d6db66),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_provider_DSASignature$method$engineSign$ec82475ff8d6db66,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_provider_DSASignature$vtable, gnu_java_security_provider_DSASignature.engineSign$ec82475ff8d6db66) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_gnu_java_security_provider_DSASignature$exceptions$engineSign$ec82475ff8d6db66,
	.u= { .exec= {
	  .trap_table_len=	2,
	  .trap_table=		_jc_gnu_java_security_provider_DSASignature$trap_table$engineSign$ec82475ff8d6db66,
	  .u= {
	    .linenum= {
	      .len=	23,
	      .table=	_jc_gnu_java_security_provider_DSASignature$linenum_table$engineSign$ec82475ff8d6db66
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_DSASignature, engineSign$ec82475ff8d6db66);

_jc_byte_array * _JC_JCNI_ATTR
_jc_gnu_java_security_provider_DSASignature$method$engineSign$ec82475ff8d6db66(_jc_env *const env, _jc_gnu_java_security_provider_DSASignature$object *this)
{
	jint i0;
	struct _jc_gnu_java_security_provider_DSASignature$object *r0;
	struct _jc_java_math_BigInteger$object *r1;
	struct _jc_java_security_SignatureException$object *volatile r10;
	struct _jc_object *r11;
	struct _jc_java_security_SecureRandom$object *r12;
	struct _jc_java_security_MessageDigest$object *r13;
	struct _jc_gnu_java_security_der_DERValue$object *r14;
	struct _jc_java_io_IOException$object *volatile r15;
	struct _jc_java_lang_ArithmeticException$object *volatile r16;
	struct _jc_java_lang_String$object *r17;
	struct _jc_java_math_BigInteger$object *r18;
	struct _jc_java_lang_VMThrowable$object *r19;
	struct _jc_java_math_BigInteger$object *r2;
	_jc_byte_array *r20;
	struct _jc_java_lang_String$object *volatile r21;
	struct _jc_java_lang_VMThrowable$object *volatile r22;
	struct _jc_java_lang_String$object *volatile r23;
	struct _jc_java_lang_VMThrowable$object *volatile r24;
	_jc_object_array *r25;
	struct _jc_java_lang_IllegalArgumentException$object *volatile r26;
	struct _jc_java_lang_Throwable$object *volatile r27;
	struct _jc_java_lang_IllegalStateException$object *volatile r28;
	struct _jc_java_lang_String$object *volatile r29;
	struct _jc_java_math_BigInteger$object *r3;
	struct _jc_java_lang_VMThrowable$object *volatile r30;
	struct _jc_java_lang_String$object *volatile r31;
	struct _jc_java_lang_VMThrowable$object *volatile r32;
	struct _jc_java_lang_IllegalArgumentException$object *volatile r33;
	struct _jc_java_lang_Throwable$object *volatile r34;
	struct _jc_java_lang_IllegalStateException$object *volatile r35;
	struct _jc_java_lang_String$object *volatile r36;
	struct _jc_java_lang_VMThrowable$object *volatile r37;
	struct _jc_java_lang_String$object *volatile r38;
	struct _jc_java_math_BigInteger$object *r4;
	struct _jc_java_lang_VMThrowable$object *volatile r40;
	struct _jc_java_math_BigInteger$object *r5;
	_jc_byte_array *r6;
	struct _jc_java_io_ByteArrayOutputStream$object *r7;
	struct _jc_java_util_ArrayList$object *r8;
	struct _jc_object *r9;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_gnu_java_security_provider_DSASignature$method_info$engineSign$ec82475ff8d6db66, &&label3, &&label6);

	r0 = this;
	_JC_LINE_NUMBER(131);				// 0
	r9 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, privateKey);
	if (r9 != _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(132);				// 1
	r10 = _JC_NEW(env, java_security_SignatureException);
	r17 = _JC_STRING(env, "not initialized for signing");
	_JC_REF_FIELD(env, r10, java_lang_Throwable, cause) = r10;
	r19 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r10);
	_JC_REF_FIELD(env, r10, java_lang_Throwable, vmState) = r19;
	_JC_REF_FIELD(env, r10, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r10, java_lang_Throwable, detailMessage) = r17;
	_JC_THROW(env, r10);

label0:
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(136);				// 2
	r9 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, privateKey);
	r11 = _JC_INVOKE_INTERFACE(env, r9, _JC_JLONG(0xcf8a9747be586d14), _jc_object *, (_jc_env *, struct _jc_object *));
	r1 = _JC_INVOKE_INTERFACE(env, r11, _JC_JLONG(0x59cffd735b56d8ad), _jc_object *, (_jc_env *, struct _jc_object *));
	_JC_LINE_NUMBER(137);				// 3
	r9 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, privateKey);
	r11 = _JC_INVOKE_INTERFACE(env, r9, _JC_JLONG(0xcf8a9747be586d14), _jc_object *, (_jc_env *, struct _jc_object *));
	r2 = _JC_INVOKE_INTERFACE(env, r11, _JC_JLONG(0x612c6062f1779963), _jc_object *, (_jc_env *, struct _jc_object *));
	_JC_LINE_NUMBER(138);				// 4
	r9 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, privateKey);
	r11 = _JC_INVOKE_INTERFACE(env, r9, _JC_JLONG(0xcf8a9747be586d14), _jc_object *, (_jc_env *, struct _jc_object *));
	r3 = _JC_INVOKE_INTERFACE(env, r11, _JC_JLONG(0xe08c53541a87120d), _jc_object *, (_jc_env *, struct _jc_object *));
	_JC_LINE_NUMBER(140);				// 5
	r9 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, privateKey);
	r4 = _JC_INVOKE_INTERFACE(env, r9, _JC_JLONG(0x568a3b7b0d38db21), _jc_object *, (_jc_env *, struct _jc_object *));
	_JC_LINE_NUMBER(142);				// 6
	r5 = _JC_NEW(env, java_math_BigInteger);
	r12 = _JC_REF_FIELD(env, r0, java_security_SignatureSpi, appRandom);
	if (r12 == _JC_NULL)
		goto label1;
	r12 = _JC_REF_FIELD(env, r0, java_security_SignatureSpi, appRandom);
	goto label2;

label1:
	r12 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, random);

label2:
	_JC_PRIM_FIELD(env, r5, java_math_BigInteger, bitCount) = -1;
	_JC_PRIM_FIELD(env, r5, java_math_BigInteger, bitLength) = -1;
	_JC_PRIM_FIELD(env, r5, java_math_BigInteger, firstNonzeroByteNum) = -2;
	_JC_PRIM_FIELD(env, r5, java_math_BigInteger, lowestSetBit) = -2;
	_JC_INVOKE_NONVIRTUAL(env, java_math_BigInteger, init$883549c549a1f62e, 0, r5, 159, r12);
	_JC_LINE_NUMBER(144);				// 7
	r2 = _JC_INVOKE_VIRTUAL(env, java_math_BigInteger, modPow$53dfc6db09e99e77, r1, r5, r2);
	_JC_LINE_NUMBER(145);				// 8
	r1 = _JC_INVOKE_VIRTUAL(env, java_math_BigInteger, mod$c133bf571fc002f1, r2, r3);
	_JC_LINE_NUMBER(147);				// 9
	r13 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, digest);
	r6 = _JC_INVOKE_VIRTUAL(env, java_security_MessageDigest, digest$24bbd103f8f0384e, r13);
	_JC_LINE_NUMBER(148);				// 10
	r2 = _JC_NEW(env, java_math_BigInteger);
	_JC_INVOKE_NONVIRTUAL(env, java_math_BigInteger, _init$85a20918701c98c3, 0, r2, 1, r6);
	_JC_LINE_NUMBER(150);				// 11
	r4 = _JC_INVOKE_VIRTUAL(env, java_math_BigInteger, multiply$cbbaf53ac7ecf4eb, r4, r1);
	r18 = _JC_INVOKE_STATIC(env, java_math_BigInteger, add$0f1977f0088adaa5, 1, r2, r4, 1);
	_JC_LINE_NUMBER(151);				// 12
	r5 = _JC_INVOKE_NONVIRTUAL(env, java_math_BigInteger, modInverse$0a292348e6c1b6de, 0, r5, r3);
	r5 = _JC_INVOKE_VIRTUAL(env, java_math_BigInteger, multiply$cbbaf53ac7ecf4eb, r18, r5);
	r5 = _JC_INVOKE_VIRTUAL(env, java_math_BigInteger, mod$c133bf571fc002f1, r5, r3);
	_JC_LINE_NUMBER(153);				// 13
	r7 = _JC_NEW(env, java_io_ByteArrayOutputStream);
	i0 = _JC_STATIC_FIELD(env, java_io_ByteArrayOutputStream, initial__5fbuffer__5fsize, 1);
	r20 = _JC_NEW_PRIM_ARRAY(env, byte, 1, i0);
	_JC_REF_FIELD(env, r7, java_io_ByteArrayOutputStream, buf) = r20;
	_JC_PRIM_FIELD(env, r7, java_io_ByteArrayOutputStream, count) = 0;
	_JC_LINE_NUMBER(154);				// 14
	r8 = _JC_NEW(env, java_util_ArrayList);
	r25 = _JC_NEW_REF_ARRAY(env, java_lang_Object, 1, 2);
	_JC_REF_FIELD(env, r8, java_util_ArrayList, data) = r25;
	_JC_LINE_NUMBER(155);				// 15
	r14 = _JC_NEW(env, gnu_java_security_der_DERValue);
	_JC_INVOKE_NONVIRTUAL(env, gnu_java_security_der_DERValue, _init$8e22e8011ae1da3a, 0, r14, 2, 0, r1, _JC_NULL);
	_JC_INVOKE_NONVIRTUAL(env, java_util_ArrayList, add$9953f092f36e3303, 0, r8, 0, r14);
	_JC_LINE_NUMBER(156);				// 16
	r14 = _JC_NEW(env, gnu_java_security_der_DERValue);
	_JC_INVOKE_NONVIRTUAL(env, gnu_java_security_der_DERValue, _init$8e22e8011ae1da3a, 0, r14, 2, 0, r5, _JC_NULL);
	_JC_INVOKE_NONVIRTUAL(env, java_util_ArrayList, add$9953f092f36e3303, 0, r8, 1, r14);
	_JC_LINE_NUMBER(157);				// 17
	r14 = _JC_NEW(env, gnu_java_security_der_DERValue);
	_JC_INVOKE_NONVIRTUAL(env, gnu_java_security_der_DERValue, _init$8e22e8011ae1da3a, 0, r14, 48, 0, r8, _JC_NULL);
	_JC_INVOKE_STATIC(env, gnu_java_security_der_DERWriter, write$dd9c0500806ff3af, 0, r7, r14);
	_JC_LINE_NUMBER(158);				// 18
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_io_ByteArrayOutputStream, toByteArray$3292ac9bfdd8d59a, 0, r7);
	_JC_TRAP_REGION(catch, 2);
	_JC_CANCEL_TRAPS(env, catch);
	return r6;

label3:
	_JC_TRAP_REGION(catch, 2);
	r15 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(162);				// 19
	r10 = _JC_NEW(env, java_security_SignatureException);
	r21 = _JC_NULL;
	_JC_REF_FIELD(env, r10, java_lang_Throwable, cause) = r10;
	r22 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r10);
	_JC_REF_FIELD(env, r10, java_lang_Throwable, vmState) = r22;
	_JC_REF_FIELD(env, r10, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r10, java_lang_Throwable, detailMessage) = r21;
	if (r15 != r10)
		goto label4;
	r26 = _JC_NEW(env, java_lang_IllegalArgumentException);
	r29 = _JC_NULL;
	_JC_REF_FIELD(env, r26, java_lang_Throwable, cause) = r26;
	r30 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 1, r26);
	_JC_REF_FIELD(env, r26, java_lang_Throwable, vmState) = r30;
	_JC_REF_FIELD(env, r26, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r26, java_lang_Throwable, detailMessage) = r29;
	_JC_THROW(env, r26);

label4:
	r27 = _JC_REF_FIELD(env, r10, java_lang_Throwable, cause);
	if (r27 == r10)
		goto label5;
	r28 = _JC_NEW(env, java_lang_IllegalStateException);
	r31 = _JC_NULL;
	_JC_REF_FIELD(env, r28, java_lang_Throwable, cause) = r28;
	r32 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 1, r28);
	_JC_REF_FIELD(env, r28, java_lang_Throwable, vmState) = r32;
	_JC_REF_FIELD(env, r28, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r28, java_lang_Throwable, detailMessage) = r31;
	_JC_THROW(env, r28);

label5:
	_JC_REF_FIELD(env, r10, java_lang_Throwable, cause) = r15;
	_JC_LINE_NUMBER(164);				// 20
	_JC_THROW(env, r10);

label6:
	_JC_TRAP_REGION(catch, 2);
	r16 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(168);				// 21
	r10 = _JC_NEW(env, java_security_SignatureException);
	r23 = _JC_NULL;
	_JC_REF_FIELD(env, r10, java_lang_Throwable, cause) = r10;
	r24 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r10);
	_JC_REF_FIELD(env, r10, java_lang_Throwable, vmState) = r24;
	_JC_REF_FIELD(env, r10, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r10, java_lang_Throwable, detailMessage) = r23;
	if (r16 != r10)
		goto label7;
	r33 = _JC_NEW(env, java_lang_IllegalArgumentException);
	r36 = _JC_NULL;
	_JC_REF_FIELD(env, r33, java_lang_Throwable, cause) = r33;
	r37 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 1, r33);
	_JC_REF_FIELD(env, r33, java_lang_Throwable, vmState) = r37;
	_JC_REF_FIELD(env, r33, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r33, java_lang_Throwable, detailMessage) = r36;
	_JC_THROW(env, r33);

label7:
	r34 = _JC_REF_FIELD(env, r10, java_lang_Throwable, cause);
	if (r34 == r10)
		goto label8;
	r35 = _JC_NEW(env, java_lang_IllegalStateException);
	r38 = _JC_NULL;
	_JC_REF_FIELD(env, r35, java_lang_Throwable, cause) = r35;
	r40 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 1, r35);
	_JC_REF_FIELD(env, r35, java_lang_Throwable, vmState) = r40;
	_JC_REF_FIELD(env, r35, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r35, java_lang_Throwable, detailMessage) = r38;
	_JC_THROW(env, r35);

label8:
	_JC_REF_FIELD(env, r10, java_lang_Throwable, cause) = r16;
	_JC_LINE_NUMBER(170);				// 22
	_JC_THROW(env, r10);
}

//
// public int engineSign(byte[], int, int) throws java.security.SignatureException
//

static _jc_linenum _jc_gnu_java_security_provider_DSASignature$linenum_table$engineSign$9742a7a61cf9f5b8[];

static const unsigned char _jc_gnu_java_security_provider_DSASignature$param_ptypes$engineSign$9742a7a61cf9f5b8[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_INT, _JC_TYPE_INT };

static _jc_type *const _jc_gnu_java_security_provider_DSASignature$exceptions$engineSign$9742a7a61cf9f5b8[] = {
	&_jc_java_security_SignatureException$type
};

static _jc_type *const _jc_gnu_java_security_provider_DSASignature$param_types$engineSign$9742a7a61cf9f5b8[] = {
	&_jc_byte$array$prim$type,
	&_jc_int$prim$type,
	&_jc_int$prim$type
};

_jc_method _jc_gnu_java_security_provider_DSASignature$method_info$engineSign$9742a7a61cf9f5b8 = {
	.name=			"engineSign",
	.signature=		"([BII)I",
	.class=			&_jc_gnu_java_security_provider_DSASignature$type,
	.param_types=		&_jc_gnu_java_security_provider_DSASignature$param_types$engineSign$9742a7a61cf9f5b8,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSASignature$param_ptypes$engineSign$9742a7a61cf9f5b8,
	.signature_hash=	_JC_JLONG(0x9742a7a61cf9f5b8),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_provider_DSASignature$method$engineSign$9742a7a61cf9f5b8,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_provider_DSASignature$vtable, gnu_java_security_provider_DSASignature.engineSign$9742a7a61cf9f5b8) / sizeof(void *),
	.num_parameters=	3,
	.num_exceptions=	1,
	.exceptions=		&_jc_gnu_java_security_provider_DSASignature$exceptions$engineSign$9742a7a61cf9f5b8,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_gnu_java_security_provider_DSASignature$linenum_table$engineSign$9742a7a61cf9f5b8
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_DSASignature, engineSign$9742a7a61cf9f5b8);

jint _JC_JCNI_ATTR
_jc_gnu_java_security_provider_DSASignature$method$engineSign$9742a7a61cf9f5b8(_jc_env *const env, _jc_gnu_java_security_provider_DSASignature$object *this, _jc_byte_array *param0, jint param1, jint param2)
{
	jint i0;
	jint i1;
	jint i2;
	struct _jc_gnu_java_security_provider_DSASignature$object *r0;
	_jc_byte_array *r1;
	_jc_byte_array *r2;
	struct _jc_java_security_SignatureException$object *r3;
	struct _jc_java_lang_String$object *r4;
	struct _jc_java_lang_VMThrowable$object *r6;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	i0 = param1;
	i1 = param2;
	_JC_LINE_NUMBER(177);				// 0
	r2 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_provider_DSASignature, engineSign$ec82475ff8d6db66, r0);
	_JC_LINE_NUMBER(178);				// 1
	i2 = _JC_ARRAY_LENGTH(env, r2);
	if (i2 <= i1)
		goto label0;
	_JC_LINE_NUMBER(179);				// 2
	r3 = _JC_NEW(env, java_security_SignatureException);
	r4 = _JC_STRING(env, "output buffer too short");
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r6 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r6;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r4;
	_JC_THROW(env, r3);

label0:
	_JC_LINE_NUMBER(180);				// 3
	i2 = _JC_ARRAY_LENGTH(env, r2);
	_JC_ACTIVE_USE(env, java_lang_System);
	_JC_INVOKE_STATIC(env, java_lang_VMSystem, arraycopy$4286a72d57744cd8, 0, r2, 0, r1, i0, i2);
	_JC_LINE_NUMBER(181);				// 4
	i2 = _JC_ARRAY_LENGTH(env, r2);
	return i2;
}

//
// public void engineUpdate(byte) throws java.security.SignatureException
//

static _jc_linenum _jc_gnu_java_security_provider_DSASignature$linenum_table$engineUpdate$807e0421d3c3a314[];

static const unsigned char _jc_gnu_java_security_provider_DSASignature$param_ptypes$engineUpdate$807e0421d3c3a314[] = { 
_JC_TYPE_BYTE, _JC_TYPE_VOID };

static _jc_type *const _jc_gnu_java_security_provider_DSASignature$exceptions$engineUpdate$807e0421d3c3a314[] = {
	&_jc_java_security_SignatureException$type
};

static _jc_type *const _jc_gnu_java_security_provider_DSASignature$param_types$engineUpdate$807e0421d3c3a314[] = {
	&_jc_byte$prim$type
};

_jc_method _jc_gnu_java_security_provider_DSASignature$method_info$engineUpdate$807e0421d3c3a314 = {
	.name=			"engineUpdate",
	.signature=		"(B)V",
	.class=			&_jc_gnu_java_security_provider_DSASignature$type,
	.param_types=		&_jc_gnu_java_security_provider_DSASignature$param_types$engineUpdate$807e0421d3c3a314,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSASignature$param_ptypes$engineUpdate$807e0421d3c3a314,
	.signature_hash=	_JC_JLONG(0x807e0421d3c3a314),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_provider_DSASignature$method$engineUpdate$807e0421d3c3a314,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_provider_DSASignature$vtable, gnu_java_security_provider_DSASignature.engineUpdate$807e0421d3c3a314) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_gnu_java_security_provider_DSASignature$exceptions$engineUpdate$807e0421d3c3a314,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_gnu_java_security_provider_DSASignature$linenum_table$engineUpdate$807e0421d3c3a314
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_DSASignature, engineUpdate$807e0421d3c3a314);

void _JC_JCNI_ATTR
_jc_gnu_java_security_provider_DSASignature$method$engineUpdate$807e0421d3c3a314(_jc_env *const env, _jc_gnu_java_security_provider_DSASignature$object *this, jbyte param0)
{
	jbyte b0;
	struct _jc_gnu_java_security_provider_DSASignature$object *r0;
	struct _jc_java_security_MessageDigest$object *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	b0 = param0;
	_JC_LINE_NUMBER(120);				// 0
	r1 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, digest);
	_JC_INVOKE_VIRTUAL(env, java_security_MessageDigest, update$373bf0a44dde26ba, r1, b0);
	_JC_LINE_NUMBER(121);				// 1
	return;
}

//
// public void engineUpdate(byte[], int, int) throws java.security.SignatureException
//

static _jc_linenum _jc_gnu_java_security_provider_DSASignature$linenum_table$engineUpdate$d2f85b5d32010900[];

static const unsigned char _jc_gnu_java_security_provider_DSASignature$param_ptypes$engineUpdate$d2f85b5d32010900[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_INT, _JC_TYPE_VOID };

static _jc_type *const _jc_gnu_java_security_provider_DSASignature$exceptions$engineUpdate$d2f85b5d32010900[] = {
	&_jc_java_security_SignatureException$type
};

static _jc_type *const _jc_gnu_java_security_provider_DSASignature$param_types$engineUpdate$d2f85b5d32010900[] = {
	&_jc_byte$array$prim$type,
	&_jc_int$prim$type,
	&_jc_int$prim$type
};

_jc_method _jc_gnu_java_security_provider_DSASignature$method_info$engineUpdate$d2f85b5d32010900 = {
	.name=			"engineUpdate",
	.signature=		"([BII)V",
	.class=			&_jc_gnu_java_security_provider_DSASignature$type,
	.param_types=		&_jc_gnu_java_security_provider_DSASignature$param_types$engineUpdate$d2f85b5d32010900,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSASignature$param_ptypes$engineUpdate$d2f85b5d32010900,
	.signature_hash=	_JC_JLONG(0xd2f85b5d32010900),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_provider_DSASignature$method$engineUpdate$d2f85b5d32010900,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_provider_DSASignature$vtable, gnu_java_security_provider_DSASignature.engineUpdate$d2f85b5d32010900) / sizeof(void *),
	.num_parameters=	3,
	.num_exceptions=	1,
	.exceptions=		&_jc_gnu_java_security_provider_DSASignature$exceptions$engineUpdate$d2f85b5d32010900,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_gnu_java_security_provider_DSASignature$linenum_table$engineUpdate$d2f85b5d32010900
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_DSASignature, engineUpdate$d2f85b5d32010900);

void _JC_JCNI_ATTR
_jc_gnu_java_security_provider_DSASignature$method$engineUpdate$d2f85b5d32010900(_jc_env *const env, _jc_gnu_java_security_provider_DSASignature$object *this, _jc_byte_array *param0, jint param1, jint param2)
{
	jint i0;
	jint i1;
	struct _jc_gnu_java_security_provider_DSASignature$object *r0;
	_jc_byte_array *r1;
	struct _jc_java_security_MessageDigest$object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	i0 = param1;
	i1 = param2;
	_JC_LINE_NUMBER(126);				// 0
	r2 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, digest);
	_JC_INVOKE_VIRTUAL(env, java_security_MessageDigest, update$f73f1b3bfa3ea853, r2, r1, i0, i1);
	_JC_LINE_NUMBER(127);				// 1
	return;
}

//
// public boolean engineVerify(byte[]) throws java.security.SignatureException
//

static _jc_linenum _jc_gnu_java_security_provider_DSASignature$linenum_table$engineVerify$0a8a54ac81f3ea48[];

static _jc_trap_info _jc_gnu_java_security_provider_DSASignature$trap_table$engineVerify$0a8a54ac81f3ea48[] = {
	_JC_TRAP(&_jc_java_io_IOException$type, 1, 2),
};

static const unsigned char _jc_gnu_java_security_provider_DSASignature$param_ptypes$engineVerify$0a8a54ac81f3ea48[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_gnu_java_security_provider_DSASignature$exceptions$engineVerify$0a8a54ac81f3ea48[] = {
	&_jc_java_security_SignatureException$type
};

static _jc_type *const _jc_gnu_java_security_provider_DSASignature$param_types$engineVerify$0a8a54ac81f3ea48[] = {
	&_jc_byte$array$prim$type
};

_jc_method _jc_gnu_java_security_provider_DSASignature$method_info$engineVerify$0a8a54ac81f3ea48 = {
	.name=			"engineVerify",
	.signature=		"([B)Z",
	.class=			&_jc_gnu_java_security_provider_DSASignature$type,
	.param_types=		&_jc_gnu_java_security_provider_DSASignature$param_types$engineVerify$0a8a54ac81f3ea48,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSASignature$param_ptypes$engineVerify$0a8a54ac81f3ea48,
	.signature_hash=	_JC_JLONG(0xa8a54ac81f3ea48),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_provider_DSASignature$method$engineVerify$0a8a54ac81f3ea48,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_provider_DSASignature$vtable, gnu_java_security_provider_DSASignature.engineVerify$0a8a54ac81f3ea48) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_gnu_java_security_provider_DSASignature$exceptions$engineVerify$0a8a54ac81f3ea48,
	.u= { .exec= {
	  .trap_table_len=	1,
	  .trap_table=		_jc_gnu_java_security_provider_DSASignature$trap_table$engineVerify$0a8a54ac81f3ea48,
	  .u= {
	    .linenum= {
	      .len=	21,
	      .table=	_jc_gnu_java_security_provider_DSASignature$linenum_table$engineVerify$0a8a54ac81f3ea48
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_DSASignature, engineVerify$0a8a54ac81f3ea48);

jboolean _JC_JCNI_ATTR
_jc_gnu_java_security_provider_DSASignature$method$engineVerify$0a8a54ac81f3ea48(_jc_env *const env, _jc_gnu_java_security_provider_DSASignature$object *this, _jc_byte_array *param0)
{
	jint i0;
	struct _jc_gnu_java_security_provider_DSASignature$object *r0;
	_jc_byte_array *r1;
	struct _jc_java_math_BigInteger$object *r10;
	struct _jc_java_security_SignatureException$object *volatile r11;
	struct _jc_java_lang_Object$object *r12;
	struct _jc_object *r13;
	struct _jc_object *r14;
	struct _jc_java_security_MessageDigest$object *r15;
	struct _jc_java_io_IOException$object *volatile r16;
	struct _jc_java_lang_String$object *r17;
	struct _jc_java_lang_String$object *volatile r18;
	struct _jc_java_io_ByteArrayInputStream$object *r19;
	struct _jc_gnu_java_security_der_DERReader$object *r2;
	struct _jc_java_lang_VMThrowable$object *r20;
	struct _jc_java_lang_VMThrowable$object *volatile r21;
	struct _jc_java_lang_IllegalArgumentException$object *volatile r22;
	struct _jc_java_lang_Throwable$object *volatile r23;
	struct _jc_java_lang_IllegalStateException$object *volatile r24;
	struct _jc_java_lang_String$object *volatile r25;
	struct _jc_java_lang_VMThrowable$object *volatile r26;
	struct _jc_java_lang_String$object *volatile r27;
	struct _jc_java_lang_VMThrowable$object *volatile r28;
	struct _jc_java_io_ByteArrayOutputStream$object *r29;
	struct _jc_gnu_java_security_der_DERValue$object *r3;
	_jc_byte_array *r30;
	struct _jc_java_math_BigInteger$object *r4;
	struct _jc_java_math_BigInteger$object *r5;
	struct _jc_java_math_BigInteger$object *r6;
	struct _jc_java_math_BigInteger$object *r7;
	struct _jc_java_math_BigInteger$object *r8;
	struct _jc_java_math_BigInteger$object *r9;
	jboolean z0;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_gnu_java_security_provider_DSASignature$method_info$engineVerify$0a8a54ac81f3ea48, &&label2);

	r0 = this;
	r1 = param0;
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(190);				// 0
	r2 = _JC_NEW(env, gnu_java_security_der_DERReader);
	r19 = _JC_NEW(env, java_io_ByteArrayInputStream);
	i0 = _JC_ARRAY_LENGTH(env, r1);
	_JC_INVOKE_NONVIRTUAL(env, java_io_ByteArrayInputStream, _init$4ff4a7925ef7b06c, 0, r19, r1, 0, i0);
	_JC_REF_FIELD(env, r2, gnu_java_security_der_DERReader, in) = r19;
	r29 = _JC_NEW(env, java_io_ByteArrayOutputStream);
	r30 = _JC_NEW_PRIM_ARRAY(env, byte, 1, 2048);
	_JC_REF_FIELD(env, r29, java_io_ByteArrayOutputStream, buf) = r30;
	_JC_PRIM_FIELD(env, r29, java_io_ByteArrayOutputStream, count) = 0;
	_JC_REF_FIELD(env, r2, gnu_java_security_der_DERReader, encBuf) = r29;
	_JC_LINE_NUMBER(191);				// 1
	r3 = _JC_INVOKE_NONVIRTUAL(env, gnu_java_security_der_DERReader, read$97cabf4c92410204, 0, r2);
	_JC_LINE_NUMBER(192);				// 2
	z0 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_der_DERValue, isConstructed$a7f1dc7730ad5522, r3);
	if (z0 != 0)
		goto label0;
	_JC_LINE_NUMBER(193);				// 3
	r11 = _JC_NEW(env, java_security_SignatureException);
	r17 = _JC_STRING(env, "badly formed signature");
	_JC_REF_FIELD(env, r11, java_lang_Throwable, cause) = r11;
	r20 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r11);
	_JC_REF_FIELD(env, r11, java_lang_Throwable, vmState) = r20;
	_JC_REF_FIELD(env, r11, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r11, java_lang_Throwable, detailMessage) = r17;
	_JC_THROW(env, r11);

label0:
	_JC_LINE_NUMBER(194);				// 4
	r3 = _JC_INVOKE_NONVIRTUAL(env, gnu_java_security_der_DERReader, read$97cabf4c92410204, 0, r2);
	r12 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_der_DERValue, getValue$6f8b281a5ffcc94f, r3);
	r4 = _JC_CAST(env, &_jc_java_math_BigInteger$type, r12);
	_JC_LINE_NUMBER(195);				// 5
	r3 = _JC_INVOKE_NONVIRTUAL(env, gnu_java_security_der_DERReader, read$97cabf4c92410204, 0, r2);
	r12 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_der_DERValue, getValue$6f8b281a5ffcc94f, r3);
	r5 = _JC_CAST(env, &_jc_java_math_BigInteger$type, r12);
	_JC_LINE_NUMBER(197);				// 6
	r13 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, publicKey);
	r14 = _JC_INVOKE_INTERFACE(env, r13, _JC_JLONG(0xcf8a9747be586d14), _jc_object *, (_jc_env *, struct _jc_object *));
	r6 = _JC_INVOKE_INTERFACE(env, r14, _JC_JLONG(0x59cffd735b56d8ad), _jc_object *, (_jc_env *, struct _jc_object *));
	_JC_LINE_NUMBER(198);				// 7
	r13 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, publicKey);
	r14 = _JC_INVOKE_INTERFACE(env, r13, _JC_JLONG(0xcf8a9747be586d14), _jc_object *, (_jc_env *, struct _jc_object *));
	r7 = _JC_INVOKE_INTERFACE(env, r14, _JC_JLONG(0x612c6062f1779963), _jc_object *, (_jc_env *, struct _jc_object *));
	_JC_LINE_NUMBER(199);				// 8
	r13 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, publicKey);
	r14 = _JC_INVOKE_INTERFACE(env, r13, _JC_JLONG(0xcf8a9747be586d14), _jc_object *, (_jc_env *, struct _jc_object *));
	r8 = _JC_INVOKE_INTERFACE(env, r14, _JC_JLONG(0xe08c53541a87120d), _jc_object *, (_jc_env *, struct _jc_object *));
	_JC_LINE_NUMBER(201);				// 9
	r13 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, publicKey);
	r9 = _JC_INVOKE_INTERFACE(env, r13, _JC_JLONG(0xe067a5f1fb934d2a), _jc_object *, (_jc_env *, struct _jc_object *));
	_JC_LINE_NUMBER(203);				// 10
	r5 = _JC_INVOKE_VIRTUAL(env, java_math_BigInteger, modInverse$0a292348e6c1b6de, r5, r8);
	_JC_LINE_NUMBER(205);				// 11
	r15 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, digest);
	r1 = _JC_INVOKE_VIRTUAL(env, java_security_MessageDigest, digest$24bbd103f8f0384e, r15);
	_JC_LINE_NUMBER(206);				// 12
	r10 = _JC_NEW(env, java_math_BigInteger);
	_JC_INVOKE_NONVIRTUAL(env, java_math_BigInteger, _init$85a20918701c98c3, 0, r10, 1, r1);
	_JC_LINE_NUMBER(208);				// 13
	r10 = _JC_INVOKE_VIRTUAL(env, java_math_BigInteger, multiply$cbbaf53ac7ecf4eb, r5, r10);
	r10 = _JC_INVOKE_VIRTUAL(env, java_math_BigInteger, mod$c133bf571fc002f1, r10, r8);
	_JC_LINE_NUMBER(210);				// 14
	r5 = _JC_INVOKE_VIRTUAL(env, java_math_BigInteger, multiply$cbbaf53ac7ecf4eb, r4, r5);
	r5 = _JC_INVOKE_VIRTUAL(env, java_math_BigInteger, mod$c133bf571fc002f1, r5, r8);
	_JC_LINE_NUMBER(212);				// 15
	r10 = _JC_INVOKE_VIRTUAL(env, java_math_BigInteger, modPow$53dfc6db09e99e77, r6, r10, r7);
	r9 = _JC_INVOKE_VIRTUAL(env, java_math_BigInteger, modPow$53dfc6db09e99e77, r9, r5, r7);
	r10 = _JC_INVOKE_VIRTUAL(env, java_math_BigInteger, multiply$cbbaf53ac7ecf4eb, r10, r9);
	r10 = _JC_INVOKE_VIRTUAL(env, java_math_BigInteger, mod$c133bf571fc002f1, r10, r7);
	r10 = _JC_INVOKE_VIRTUAL(env, java_math_BigInteger, mod$c133bf571fc002f1, r10, r8);
	_JC_LINE_NUMBER(214);				// 16
	z0 = _JC_INVOKE_VIRTUAL(env, java_math_BigInteger, equals$8a15e0625571c581, r10, r4);
	if (z0 == 0)
		goto label1;
	_JC_TRAP_REGION(catch, 2);
	_JC_LINE_NUMBER(215);				// 17
	_JC_CANCEL_TRAPS(env, catch);
	return 1;

label1:
	_JC_TRAP_REGION(catch, 2);
	_JC_LINE_NUMBER(217);				// 18
	_JC_CANCEL_TRAPS(env, catch);
	return 0;

label2:
	_JC_TRAP_REGION(catch, 2);
	r16 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(221);				// 19
	r11 = _JC_NEW(env, java_security_SignatureException);
	r18 = _JC_STRING(env, "badly formed signature");
	_JC_REF_FIELD(env, r11, java_lang_Throwable, cause) = r11;
	r21 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r11);
	_JC_REF_FIELD(env, r11, java_lang_Throwable, vmState) = r21;
	_JC_REF_FIELD(env, r11, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r11, java_lang_Throwable, detailMessage) = r18;
	if (r16 != r11)
		goto label3;
	r22 = _JC_NEW(env, java_lang_IllegalArgumentException);
	r25 = _JC_NULL;
	_JC_REF_FIELD(env, r22, java_lang_Throwable, cause) = r22;
	r26 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 1, r22);
	_JC_REF_FIELD(env, r22, java_lang_Throwable, vmState) = r26;
	_JC_REF_FIELD(env, r22, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r22, java_lang_Throwable, detailMessage) = r25;
	_JC_THROW(env, r22);

label3:
	r23 = _JC_REF_FIELD(env, r11, java_lang_Throwable, cause);
	if (r23 == r11)
		goto label4;
	r24 = _JC_NEW(env, java_lang_IllegalStateException);
	r27 = _JC_NULL;
	_JC_REF_FIELD(env, r24, java_lang_Throwable, cause) = r24;
	r28 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 1, r24);
	_JC_REF_FIELD(env, r24, java_lang_Throwable, vmState) = r28;
	_JC_REF_FIELD(env, r24, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r24, java_lang_Throwable, detailMessage) = r27;
	_JC_THROW(env, r24);

label4:
	_JC_REF_FIELD(env, r11, java_lang_Throwable, cause) = r16;
	_JC_LINE_NUMBER(223);				// 20
	_JC_THROW(env, r11);
}

//
// private final void init()
//

static _jc_linenum _jc_gnu_java_security_provider_DSASignature$linenum_table$init$d82f2cc8ccf1c754[];

static const unsigned char _jc_gnu_java_security_provider_DSASignature$param_ptypes$init$d82f2cc8ccf1c754[] = { 
_JC_TYPE_VOID };

_jc_method _jc_gnu_java_security_provider_DSASignature$method_info$init$d82f2cc8ccf1c754 = {
	.name=			"init",
	.signature=		"()V",
	.class=			&_jc_gnu_java_security_provider_DSASignature$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSASignature$param_ptypes$init$d82f2cc8ccf1c754,
	.signature_hash=	_JC_JLONG(0xd82f2cc8ccf1c754),
	.access_flags=		_JC_ACC_PRIVATE|_JC_ACC_FINAL,
	.function=		&_jc_gnu_java_security_provider_DSASignature$method$init$d82f2cc8ccf1c754,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_provider_DSASignature$vtable, gnu_java_security_provider_DSASignature.init$d82f2cc8ccf1c754) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_gnu_java_security_provider_DSASignature$linenum_table$init$d82f2cc8ccf1c754
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_DSASignature, init$d82f2cc8ccf1c754);

void _JC_JCNI_ATTR
_jc_gnu_java_security_provider_DSASignature$method$init$d82f2cc8ccf1c754(_jc_env *const env, _jc_gnu_java_security_provider_DSASignature$object *this)
{
	struct _jc_gnu_java_security_provider_DSASignature$object *r0;
	struct _jc_java_security_MessageDigest$object *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(80);				// 0
	r1 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, digest);
	_JC_INVOKE_VIRTUAL(env, java_security_MessageDigest, reset$229a80b3e8394a0f, r1);
	_JC_LINE_NUMBER(81);				// 1
	return;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_gnu_java_security_provider_DSASignature$methods[] = {
	&_jc_gnu_java_security_provider_DSASignature$method_info$_init$52f4ad9f2989aeee,
	&_jc_gnu_java_security_provider_DSASignature$method_info$clone$b75f2713d6705f70,
	&_jc_gnu_java_security_provider_DSASignature$method_info$engineGetParameter$c70713ab9f3f12d6,
	&_jc_gnu_java_security_provider_DSASignature$method_info$engineInitSign$59481b5a8d200c34,
	&_jc_gnu_java_security_provider_DSASignature$method_info$engineInitSign$82a2f1097d5847be,
	&_jc_gnu_java_security_provider_DSASignature$method_info$engineInitVerify$1de7286f7aa81902,
	&_jc_gnu_java_security_provider_DSASignature$method_info$engineSetParameter$fe653a0781d38e86,
	&_jc_gnu_java_security_provider_DSASignature$method_info$engineSetParameter$1b6a221a44e2a8cf,
	&_jc_gnu_java_security_provider_DSASignature$method_info$engineSign$ec82475ff8d6db66,
	&_jc_gnu_java_security_provider_DSASignature$method_info$engineSign$9742a7a61cf9f5b8,
	&_jc_gnu_java_security_provider_DSASignature$method_info$engineUpdate$807e0421d3c3a314,
	&_jc_gnu_java_security_provider_DSASignature$method_info$engineUpdate$d2f85b5d32010900,
	&_jc_gnu_java_security_provider_DSASignature$method_info$engineVerify$0a8a54ac81f3ea48,
	&_jc_gnu_java_security_provider_DSASignature$method_info$init$d82f2cc8ccf1c754
};

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_gnu_java_security_provider_DSASignature$instanceof_hash_bucket_44[] = {
	&_jc_gnu_java_security_provider_DSASignature$type,
	_JC_NULL
};
static _jc_type *const _jc_gnu_java_security_provider_DSASignature$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};
static _jc_type *const _jc_gnu_java_security_provider_DSASignature$instanceof_hash_bucket_110[] = {
	&_jc_java_security_SignatureSpi$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_gnu_java_security_provider_DSASignature$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[44]=	_jc_gnu_java_security_provider_DSASignature$instanceof_hash_bucket_44,
	[101]=	_jc_gnu_java_security_provider_DSASignature$instanceof_hash_bucket_101,
	[110]=	_jc_gnu_java_security_provider_DSASignature$instanceof_hash_bucket_110
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_gnu_java_security_provider_DSASignature$class_depends[] = {
	{ "gnu/java/security/der/DERReader",	_JC_JLONG(0x78ef52e48159b870) },
	{ "gnu/java/security/der/DERValue",	_JC_JLONG(0xde1638783317796a) },
	{ "gnu/java/security/der/DERWriter",	_JC_JLONG(0x87aa78f6a77ed8b) },
	{ "java/io/ByteArrayInputStream",	_JC_JLONG(0xa68cc27886fd8be3) },
	{ "java/io/ByteArrayOutputStream",	_JC_JLONG(0xc4d3cc2bda03a338) },
	{ "java/io/IOException",	_JC_JLONG(0x4e0a56550c69d57c) },
	{ "java/io/OutputStream",	_JC_JLONG(0x4026d3144d6654d8) },
	{ "java/lang/ArithmeticException",	_JC_JLONG(0x42020e4665019671) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/CloneNotSupportedException",	_JC_JLONG(0xd59353b5e031d754) },
	{ "java/lang/Cloneable",	_JC_JLONG(0x9b667b09132be893) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/IllegalArgumentException",	_JC_JLONG(0x680cf34d05feb5a1) },
	{ "java/lang/IllegalStateException",	_JC_JLONG(0xb7e704701c278e65) },
	{ "java/lang/Number",	_JC_JLONG(0x9cd7252f79299280) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/RuntimeException",	_JC_JLONG(0x4f5534a987354d1d) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/System",	_JC_JLONG(0x53cc8e2333795f04) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMObject",	_JC_JLONG(0x312e45ed214d432f) },
	{ "java/lang/VMSystem",	_JC_JLONG(0x4d1cebae0bdda058) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/math/BigInteger",	_JC_JLONG(0x7717ded55c30b7f3) },
	{ "java/security/GeneralSecurityException",	_JC_JLONG(0x692089051f4c8d0b) },
	{ "java/security/InvalidAlgorithmParameterException",	_JC_JLONG(0x327edce29f2562dd) },
	{ "java/security/InvalidKeyException",	_JC_JLONG(0x94dda41e9bf6c170) },
	{ "java/security/InvalidParameterException",	_JC_JLONG(0x99827f89c0c36c1) },
	{ "java/security/KeyException",	_JC_JLONG(0x965d036f0f33fac6) },
	{ "java/security/MessageDigest",	_JC_JLONG(0xcc2047cad8dcf75e) },
	{ "java/security/NoSuchAlgorithmException",	_JC_JLONG(0x22e937c2536160b4) },
	{ "java/security/PrivateKey",	_JC_JLONG(0xdcdbe4a102f59043) },
	{ "java/security/Provider",	_JC_JLONG(0x81b073051aa30acc) },
	{ "java/security/PublicKey",	_JC_JLONG(0x4db3ac05e70e2bf8) },
	{ "java/security/SecureRandom",	_JC_JLONG(0x15c6a62b25a6e96d) },
	{ "java/security/Security",	_JC_JLONG(0x89bf77984bd9669e) },
	{ "java/security/SignatureException",	_JC_JLONG(0x7ce2f2d523fa52ac) },
	{ "java/security/SignatureSpi",	_JC_JLONG(0x15e444274ebb7a6e) },
	{ "java/security/interfaces/DSAParams",	_JC_JLONG(0xf4f2d6013f72861e) },
	{ "java/security/interfaces/DSAPrivateKey",	_JC_JLONG(0xd57e7f1f963e5163) },
	{ "java/security/interfaces/DSAPublicKey",	_JC_JLONG(0xbad97fafc9653a27) },
	{ "java/security/spec/AlgorithmParameterSpec",	_JC_JLONG(0xef2e5e8af121478f) },
	{ "java/util/AbstractCollection",	_JC_JLONG(0x8ea716c64b77f8eb) },
	{ "java/util/AbstractList",	_JC_JLONG(0xf5238436362828db) },
	{ "java/util/ArrayList",	_JC_JLONG(0x58038509830ef3f4) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_gnu_java_security_provider_DSASignature$vtype _jc_gnu_java_security_provider_DSASignature$type = {
    .type= {
	.name=			"gnu/java/security/provider/DSASignature",
	.superclass=		&_jc_java_security_SignatureSpi$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		38,
		.hash=			_JC_JLONG(0x90ec63c67b1c5fac),
		.source_file=		"DSASignature.java",
		.instance_size=		sizeof(_jc_gnu_java_security_provider_DSASignature$refs) + sizeof(_jc_gnu_java_security_provider_DSASignature$object),
		.num_virtual_refs=	5,
		.num_fields=		sizeof(_jc_gnu_java_security_provider_DSASignature$fields) / sizeof(*_jc_gnu_java_security_provider_DSASignature$fields),
		.fields=		_jc_gnu_java_security_provider_DSASignature$fields,
		.num_methods=		sizeof(_jc_gnu_java_security_provider_DSASignature$methods) / sizeof(*_jc_gnu_java_security_provider_DSASignature$methods),
		.methods=		_jc_gnu_java_security_provider_DSASignature$methods,
		.instanceof_hash_table=	_jc_gnu_java_security_provider_DSASignature$instanceof_hash_table,
		.num_class_depends=		sizeof(_jc_gnu_java_security_provider_DSASignature$class_depends) / sizeof(*_jc_gnu_java_security_provider_DSASignature$class_depends),
		.class_depends=		_jc_gnu_java_security_provider_DSASignature$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=			// overridden
		&_jc_gnu_java_security_provider_DSASignature$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.java_security_SignatureSpi= {
	    .clone$b75f2713d6705f70=			// overridden
		&_jc_gnu_java_security_provider_DSASignature$method$clone$b75f2713d6705f70,
	    .engineGetParameter$c70713ab9f3f12d6=		// overridden
		&_jc_gnu_java_security_provider_DSASignature$method$engineGetParameter$c70713ab9f3f12d6,
	    .engineGetParameters$4feb0e256d9d7317=
		&_jc_java_security_SignatureSpi$method$engineGetParameters$4feb0e256d9d7317,
	    .engineInitSign$59481b5a8d200c34=		// overridden
		&_jc_gnu_java_security_provider_DSASignature$method$engineInitSign$59481b5a8d200c34,
	    .engineInitSign$82a2f1097d5847be=		// overridden
		&_jc_gnu_java_security_provider_DSASignature$method$engineInitSign$82a2f1097d5847be,
	    .engineInitVerify$1de7286f7aa81902=		// overridden
		&_jc_gnu_java_security_provider_DSASignature$method$engineInitVerify$1de7286f7aa81902,
	    .engineSetParameter$fe653a0781d38e86=		// overridden
		&_jc_gnu_java_security_provider_DSASignature$method$engineSetParameter$fe653a0781d38e86,
	    .engineSetParameter$1b6a221a44e2a8cf=		// overridden
		&_jc_gnu_java_security_provider_DSASignature$method$engineSetParameter$1b6a221a44e2a8cf,
	    .engineSign$ec82475ff8d6db66=			// overridden
		&_jc_gnu_java_security_provider_DSASignature$method$engineSign$ec82475ff8d6db66,
	    .engineSign$9742a7a61cf9f5b8=			// overridden
		&_jc_gnu_java_security_provider_DSASignature$method$engineSign$9742a7a61cf9f5b8,
	    .engineUpdate$807e0421d3c3a314=			// overridden
		&_jc_gnu_java_security_provider_DSASignature$method$engineUpdate$807e0421d3c3a314,
	    .engineUpdate$d2f85b5d32010900=			// overridden
		&_jc_gnu_java_security_provider_DSASignature$method$engineUpdate$d2f85b5d32010900,
	    .engineVerify$0a8a54ac81f3ea48=			// overridden
		&_jc_gnu_java_security_provider_DSASignature$method$engineVerify$0a8a54ac81f3ea48,
	    .engineVerify$faa9b7bfcc2ddd84=
		&_jc_java_security_SignatureSpi$method$engineVerify$faa9b7bfcc2ddd84,
	},
	.gnu_java_security_provider_DSASignature= {
	    .clone$b75f2713d6705f70=
		&_jc_gnu_java_security_provider_DSASignature$method$clone$b75f2713d6705f70,
	    .engineGetParameter$c70713ab9f3f12d6=
		&_jc_gnu_java_security_provider_DSASignature$method$engineGetParameter$c70713ab9f3f12d6,
	    .engineInitSign$59481b5a8d200c34=
		&_jc_gnu_java_security_provider_DSASignature$method$engineInitSign$59481b5a8d200c34,
	    .engineInitSign$82a2f1097d5847be=
		&_jc_gnu_java_security_provider_DSASignature$method$engineInitSign$82a2f1097d5847be,
	    .engineInitVerify$1de7286f7aa81902=
		&_jc_gnu_java_security_provider_DSASignature$method$engineInitVerify$1de7286f7aa81902,
	    .engineSetParameter$fe653a0781d38e86=
		&_jc_gnu_java_security_provider_DSASignature$method$engineSetParameter$fe653a0781d38e86,
	    .engineSetParameter$1b6a221a44e2a8cf=
		&_jc_gnu_java_security_provider_DSASignature$method$engineSetParameter$1b6a221a44e2a8cf,
	    .engineSign$ec82475ff8d6db66=
		&_jc_gnu_java_security_provider_DSASignature$method$engineSign$ec82475ff8d6db66,
	    .engineSign$9742a7a61cf9f5b8=
		&_jc_gnu_java_security_provider_DSASignature$method$engineSign$9742a7a61cf9f5b8,
	    .engineUpdate$807e0421d3c3a314=
		&_jc_gnu_java_security_provider_DSASignature$method$engineUpdate$807e0421d3c3a314,
	    .engineUpdate$d2f85b5d32010900=
		&_jc_gnu_java_security_provider_DSASignature$method$engineUpdate$d2f85b5d32010900,
	    .engineVerify$0a8a54ac81f3ea48=
		&_jc_gnu_java_security_provider_DSASignature$method$engineVerify$0a8a54ac81f3ea48,
	    .init$d82f2cc8ccf1c754=
		&_jc_gnu_java_security_provider_DSASignature$method$init$d82f2cc8ccf1c754,
	},
    }
};

