// public class gnu.java.security.provider.SHA1PRNG

// class file dependencies
// @dep_class 74cf6a4caac8d5c3 gnu_java_security_provider_SHA1PRNG
// @dep_class 9a35c7173b37e641 java_io_Serializable
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class 308333d803f5ab9f java_lang_Error
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class 642246d728a60038 java_lang_InternalError
// @dep_class 8d71d806a180ad8a java_lang_Math
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 53cc8e2333795f04 java_lang_System
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class 4d1cebae0bdda058 java_lang_VMSystem
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class c7632ae877826bc6 java_lang_VirtualMachineError
// @dep_class 692089051f4c8d0b java_security_GeneralSecurityException
// @dep_class cc2047cad8dcf75e java_security_MessageDigest
// @dep_class 22e937c2536160b4 java_security_NoSuchAlgorithmException
// @dep_class 81b073051aa30acc java_security_Provider
// @dep_class 254ca156f086a0ef java_security_SecureRandomSpi
// @dep_class 89bf77984bd9669e java_security_Security
// @dep_class 61639c1affc91eab java_util_Random

// header file dependencies
// @dep_header gnu_java_security_provider_SHA1PRNG
// @dep_header java_io_Serializable
// @dep_header java_lang_Class
// @dep_header java_lang_InternalError
// @dep_header java_lang_Math
// @dep_header java_lang_String
// @dep_header java_lang_System
// @dep_header java_lang_VMSystem
// @dep_header java_lang_VMThrowable
// @dep_header java_security_MessageDigest
// @dep_header java_security_NoSuchAlgorithmException
// @dep_header java_security_Provider
// @dep_header java_security_Security
// @dep_header java_util_Random

#include "jc_defs.h"

#include "gnu/java/security/provider/SHA1PRNG.h"
#include "java/io/Serializable.h"
#include "java/lang/Class.h"
#include "java/lang/InternalError.h"
#include "java/lang/Math.h"
#include "java/lang/String.h"
#include "java/lang/System.h"
#include "java/lang/VMSystem.h"
#include "java/lang/VMThrowable.h"
#include "java/security/MessageDigest.h"
#include "java/security/NoSuchAlgorithmException.h"
#include "java/security/Provider.h"
#include "java/security/Security.h"
#include "java/util/Random.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// private static final int SEED_SIZE
static const jint _jc_gnu_java_security_provider_SHA1PRNG$initial_value$SEED__5fSIZE = 20;
static _jc_field _jc_gnu_java_security_provider_SHA1PRNG$field_info$SEED__5fSIZE = {
	.name=		"SEED_SIZE",
	.signature=	"I",
	.class=		&_jc_gnu_java_security_provider_SHA1PRNG$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_gnu_java_security_provider_SHA1PRNG$fields_struct, SEED__5fSIZE),
	.initial_value=	&_jc_gnu_java_security_provider_SHA1PRNG$initial_value$SEED__5fSIZE,
};

// private static final int DATA_SIZE
static const jint _jc_gnu_java_security_provider_SHA1PRNG$initial_value$DATA__5fSIZE = 40;
static _jc_field _jc_gnu_java_security_provider_SHA1PRNG$field_info$DATA__5fSIZE = {
	.name=		"DATA_SIZE",
	.signature=	"I",
	.class=		&_jc_gnu_java_security_provider_SHA1PRNG$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_gnu_java_security_provider_SHA1PRNG$fields_struct, DATA__5fSIZE),
	.initial_value=	&_jc_gnu_java_security_provider_SHA1PRNG$initial_value$DATA__5fSIZE,
};

// java.security.MessageDigest digest
static _jc_field _jc_gnu_java_security_provider_SHA1PRNG$field_info$digest = {
	.name=		"digest",
	.signature=	"Ljava/security/MessageDigest;",
	.class=		&_jc_gnu_java_security_provider_SHA1PRNG$type,
	.type=		&_jc_java_security_MessageDigest$type,
	.access_flags=	0,
	.offset=	_JC_OFFSETOF(_jc_gnu_java_security_provider_SHA1PRNG$object, refs[-1].gnu_java_security_provider_SHA1PRNG.digest),
};

// byte[] seed
static _jc_field _jc_gnu_java_security_provider_SHA1PRNG$field_info$seed = {
	.name=		"seed",
	.signature=	"[B",
	.class=		&_jc_gnu_java_security_provider_SHA1PRNG$type,
	.type=		&_jc_byte$array$prim$type,
	.access_flags=	0,
	.offset=	_JC_OFFSETOF(_jc_gnu_java_security_provider_SHA1PRNG$object, refs[-1].gnu_java_security_provider_SHA1PRNG.seed),
};

// byte[] data
static _jc_field _jc_gnu_java_security_provider_SHA1PRNG$field_info$data = {
	.name=		"data",
	.signature=	"[B",
	.class=		&_jc_gnu_java_security_provider_SHA1PRNG$type,
	.type=		&_jc_byte$array$prim$type,
	.access_flags=	0,
	.offset=	_JC_OFFSETOF(_jc_gnu_java_security_provider_SHA1PRNG$object, refs[-1].gnu_java_security_provider_SHA1PRNG.data),
};

// int seedpos
static _jc_field _jc_gnu_java_security_provider_SHA1PRNG$field_info$seedpos = {
	.name=		"seedpos",
	.signature=	"I",
	.class=		&_jc_gnu_java_security_provider_SHA1PRNG$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	0,
	.offset=	_JC_OFFSETOF(_jc_gnu_java_security_provider_SHA1PRNG$object, nonrefs.gnu_java_security_provider_SHA1PRNG.seedpos),
};

// int datapos
static _jc_field _jc_gnu_java_security_provider_SHA1PRNG$field_info$datapos = {
	.name=		"datapos",
	.signature=	"I",
	.class=		&_jc_gnu_java_security_provider_SHA1PRNG$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	0,
	.offset=	_JC_OFFSETOF(_jc_gnu_java_security_provider_SHA1PRNG$object, nonrefs.gnu_java_security_provider_SHA1PRNG.datapos),
};

// private boolean seeded
static _jc_field _jc_gnu_java_security_provider_SHA1PRNG$field_info$seeded = {
	.name=		"seeded",
	.signature=	"Z",
	.class=		&_jc_gnu_java_security_provider_SHA1PRNG$type,
	.type=		&_jc_boolean$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_gnu_java_security_provider_SHA1PRNG$object, nonrefs.gnu_java_security_provider_SHA1PRNG.seeded),
};

// Fields
static _jc_field *const _jc_gnu_java_security_provider_SHA1PRNG$fields[] = {
	&_jc_gnu_java_security_provider_SHA1PRNG$field_info$DATA__5fSIZE,
	&_jc_gnu_java_security_provider_SHA1PRNG$field_info$SEED__5fSIZE,
	&_jc_gnu_java_security_provider_SHA1PRNG$field_info$data,
	&_jc_gnu_java_security_provider_SHA1PRNG$field_info$digest,
	&_jc_gnu_java_security_provider_SHA1PRNG$field_info$seed,
	&_jc_gnu_java_security_provider_SHA1PRNG$field_info$datapos,
	&_jc_gnu_java_security_provider_SHA1PRNG$field_info$seedpos,
	&_jc_gnu_java_security_provider_SHA1PRNG$field_info$seeded
};

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// public void <init>()
//

static _jc_linenum _jc_gnu_java_security_provider_SHA1PRNG$linenum_table$_init$52f4ad9f2989aeee[];

static _jc_trap_info _jc_gnu_java_security_provider_SHA1PRNG$trap_table$_init$52f4ad9f2989aeee[] = {
	_JC_TRAP(&_jc_java_security_NoSuchAlgorithmException$type, 2, 3),
	_JC_TRAP(&_jc_java_security_NoSuchAlgorithmException$type, 1, 4),
};

static const unsigned char _jc_gnu_java_security_provider_SHA1PRNG$param_ptypes$_init$52f4ad9f2989aeee[] = { 
_JC_TYPE_VOID };

_jc_method _jc_gnu_java_security_provider_SHA1PRNG$method_info$_init$52f4ad9f2989aeee = {
	.name=			"<init>",
	.signature=		"()V",
	.class=			&_jc_gnu_java_security_provider_SHA1PRNG$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_SHA1PRNG$param_ptypes$_init$52f4ad9f2989aeee,
	.signature_hash=	_JC_JLONG(0x52f4ad9f2989aeee),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_provider_SHA1PRNG$method$_init$52f4ad9f2989aeee,
	.num_parameters=	0,
	.u= { .exec= {
	  .trap_table_len=	2,
	  .trap_table=		_jc_gnu_java_security_provider_SHA1PRNG$trap_table$_init$52f4ad9f2989aeee,
	  .u= {
	    .linenum= {
	      .len=	7,
	      .table=	_jc_gnu_java_security_provider_SHA1PRNG$linenum_table$_init$52f4ad9f2989aeee
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_SHA1PRNG, _init$52f4ad9f2989aeee);

void _JC_JCNI_ATTR
_jc_gnu_java_security_provider_SHA1PRNG$method$_init$52f4ad9f2989aeee(_jc_env *const env, _jc_gnu_java_security_provider_SHA1PRNG$object *this)
{
	jint volatile i0;
	jint volatile i1;
	struct _jc_gnu_java_security_provider_SHA1PRNG$object *volatile r0;
	struct _jc_java_security_NoSuchAlgorithmException$object *r1;
	struct _jc_java_security_NoSuchAlgorithmException$object *volatile r10;
	struct _jc_java_lang_InternalError$object *volatile r2;
	_jc_byte_array *volatile r3;
	struct _jc_java_lang_String$object *volatile r4;
	struct _jc_java_lang_VMThrowable$object *volatile r5;
	struct _jc_java_lang_String$object *volatile r6;
	_jc_object_array *volatile r7;
	struct _jc_java_security_Provider$object *volatile r8;
	struct _jc_java_security_MessageDigest$object *volatile r9;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_gnu_java_security_provider_SHA1PRNG$method_info$_init$52f4ad9f2989aeee, &&label1, &&label4);

	r0 = this;
	_JC_PRIM_FIELD(env, r0, gnu_java_security_provider_SHA1PRNG, seeded) = 0;
	_JC_TRAP_REGION(catch, 1);
	_JC_ACTIVE_USE(env, java_security_MessageDigest);
	_JC_LINE_NUMBER(70);				// 0
	r6 = _JC_STRING(env, "SHA");
	r7 = _JC_INVOKE_STATIC(env, java_security_Security, getProviders$03fdcd7bb40e95b7, 0);
	i0 = 0;
	goto label2;

label0:
	_JC_TRAP_REGION(catch, 2);
	r8 = _JC_REF_ELEMENT(env, r7, i0, 1, 1);
	r9 = _JC_INVOKE_STATIC(env, java_security_MessageDigest, getInstance$60ade29cbc652343, 0, r6, r8);
	_JC_TRAP_REGION(catch, 3);
	goto label3;

label1:
	_JC_TRAP_REGION(catch, 3);
	r10 = _JC_CAUGHT_EXCEPTION(env);
	i0 = i0 + 1;

label2:
	_JC_TRAP_REGION(catch, 3);
	i1 = _JC_ARRAY_LENGTH(env, r7);
	if (i0 < i1) {
		_JC_PERIODIC_CHECK(env);
		goto label0;
	}
	r10 = _JC_NEW(env, java_security_NoSuchAlgorithmException);
	_JC_REF_FIELD(env, r10, java_lang_Throwable, cause) = r10;
	_JC_INVOKE_NONVIRTUAL(env, java_lang_Throwable, fillInStackTrace$6204b72985f9038d, 0, r10);
	_JC_REF_FIELD(env, r10, java_lang_Throwable, detailMessage) = r6;
	_JC_THROW(env, r10);

label3:
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_SHA1PRNG, digest) = r9;
	_JC_TRAP_REGION(catch, 4);
	goto label5;

label4:
	_JC_TRAP_REGION(catch, 4);
	r1 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(74);				// 1
	r2 = _JC_NEW(env, java_lang_InternalError);
	r4 = _JC_STRING(env, "no SHA implementation found");
	_JC_REF_FIELD(env, r2, java_lang_Throwable, cause) = r2;
	r5 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r2);
	_JC_REF_FIELD(env, r2, java_lang_Throwable, vmState) = r5;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, detailMessage) = r4;
	_JC_THROW(env, r2);

label5:
	_JC_LINE_NUMBER(77);				// 2
	r3 = _JC_NEW_PRIM_ARRAY(env, byte, 1, 20);
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_SHA1PRNG, seed) = r3;
	_JC_LINE_NUMBER(78);				// 3
	_JC_PRIM_FIELD(env, r0, gnu_java_security_provider_SHA1PRNG, seedpos) = 0;
	_JC_LINE_NUMBER(79);				// 4
	r3 = _JC_NEW_PRIM_ARRAY(env, byte, 1, 40);
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_SHA1PRNG, data) = r3;
	_JC_LINE_NUMBER(80);				// 5
	_JC_PRIM_FIELD(env, r0, gnu_java_security_provider_SHA1PRNG, datapos) = 20;
	_JC_LINE_NUMBER(81);				// 6
	_JC_CANCEL_TRAPS(env, catch);
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public byte[] engineGenerateSeed(int)
//

static _jc_linenum _jc_gnu_java_security_provider_SHA1PRNG$linenum_table$engineGenerateSeed$3f2678c95ef54b9d[];

static const unsigned char _jc_gnu_java_security_provider_SHA1PRNG$param_ptypes$engineGenerateSeed$3f2678c95ef54b9d[] = { 
_JC_TYPE_INT, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_gnu_java_security_provider_SHA1PRNG$param_types$engineGenerateSeed$3f2678c95ef54b9d[] = {
	&_jc_int$prim$type
};

_jc_method _jc_gnu_java_security_provider_SHA1PRNG$method_info$engineGenerateSeed$3f2678c95ef54b9d = {
	.name=			"engineGenerateSeed",
	.signature=		"(I)[B",
	.class=			&_jc_gnu_java_security_provider_SHA1PRNG$type,
	.param_types=		&_jc_gnu_java_security_provider_SHA1PRNG$param_types$engineGenerateSeed$3f2678c95ef54b9d,
	.return_type=		&_jc_byte$array$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_SHA1PRNG$param_ptypes$engineGenerateSeed$3f2678c95ef54b9d,
	.signature_hash=	_JC_JLONG(0x3f2678c95ef54b9d),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_provider_SHA1PRNG$method$engineGenerateSeed$3f2678c95ef54b9d,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_provider_SHA1PRNG$vtable, gnu_java_security_provider_SHA1PRNG.engineGenerateSeed$3f2678c95ef54b9d) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_gnu_java_security_provider_SHA1PRNG$linenum_table$engineGenerateSeed$3f2678c95ef54b9d
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_SHA1PRNG, engineGenerateSeed$3f2678c95ef54b9d);

_jc_byte_array * _JC_JCNI_ATTR
_jc_gnu_java_security_provider_SHA1PRNG$method$engineGenerateSeed$3f2678c95ef54b9d(_jc_env *const env, _jc_gnu_java_security_provider_SHA1PRNG$object *this, jint param0)
{
	jint i0;
	struct _jc_gnu_java_security_provider_SHA1PRNG$object *r0;
	_jc_byte_array *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	i0 = param0;
	_JC_LINE_NUMBER(118);				// 0
	r1 = _JC_NEW_PRIM_ARRAY(env, byte, 1, i0);
	_JC_LINE_NUMBER(120);				// 1
	_JC_INVOKE_VIRTUAL(env, gnu_java_security_provider_SHA1PRNG, engineNextBytes$41b3d85f207b40da, r0, r1);
	_JC_LINE_NUMBER(121);				// 2
	return r1;
}

//
// public void engineNextBytes(byte[])
//

static _jc_linenum _jc_gnu_java_security_provider_SHA1PRNG$linenum_table$engineNextBytes$41b3d85f207b40da[];

static const unsigned char _jc_gnu_java_security_provider_SHA1PRNG$param_ptypes$engineNextBytes$41b3d85f207b40da[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_gnu_java_security_provider_SHA1PRNG$param_types$engineNextBytes$41b3d85f207b40da[] = {
	&_jc_byte$array$prim$type
};

_jc_method _jc_gnu_java_security_provider_SHA1PRNG$method_info$engineNextBytes$41b3d85f207b40da = {
	.name=			"engineNextBytes",
	.signature=		"([B)V",
	.class=			&_jc_gnu_java_security_provider_SHA1PRNG$type,
	.param_types=		&_jc_gnu_java_security_provider_SHA1PRNG$param_types$engineNextBytes$41b3d85f207b40da,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_SHA1PRNG$param_ptypes$engineNextBytes$41b3d85f207b40da,
	.signature_hash=	_JC_JLONG(0x41b3d85f207b40da),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_provider_SHA1PRNG$method$engineNextBytes$41b3d85f207b40da,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_provider_SHA1PRNG$vtable, gnu_java_security_provider_SHA1PRNG.engineNextBytes$41b3d85f207b40da) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	14,
	      .table=	_jc_gnu_java_security_provider_SHA1PRNG$linenum_table$engineNextBytes$41b3d85f207b40da
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_SHA1PRNG, engineNextBytes$41b3d85f207b40da);

void _JC_JCNI_ATTR
_jc_gnu_java_security_provider_SHA1PRNG$method$engineNextBytes$41b3d85f207b40da(_jc_env *const env, _jc_gnu_java_security_provider_SHA1PRNG$object *this, _jc_byte_array *param0)
{
	jint i0;
	jint i1;
	jint i2;
	jint i4;
	struct _jc_gnu_java_security_provider_SHA1PRNG$object *r0;
	_jc_byte_array *r1;
	_jc_byte_array *r2;
	_jc_byte_array *r3;
	struct _jc_java_security_MessageDigest$object *r4;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(93);				// 0
	_JC_INVOKE_NONVIRTUAL(env, gnu_java_security_provider_SHA1PRNG, ensureIsSeeded$ffcf98ef7344e986, 0, r0);
	_JC_LINE_NUMBER(94);				// 1
	i0 = 0;
	_JC_LINE_NUMBER(95);				// 2
	goto label4;

label0:
	_JC_LINE_NUMBER(97);				// 3
	i1 = _JC_ARRAY_LENGTH(env, r1);
	i1 = i1 - i0;
	i2 = _JC_PRIM_FIELD(env, r0, gnu_java_security_provider_SHA1PRNG, datapos);
	i2 = 20 - i2;
	_JC_ACTIVE_USE(env, java_lang_Math);
	if (i1 >= i2)
		goto label1;
	i4 = i1;
	goto label2;

label1:
	i4 = i2;

label2:
	_JC_LINE_NUMBER(99);				// 4
	if (i4 <= 0)
		goto label3;
	_JC_LINE_NUMBER(101);				// 5
	r2 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_SHA1PRNG, data);
	i2 = _JC_PRIM_FIELD(env, r0, gnu_java_security_provider_SHA1PRNG, datapos);
	_JC_ACTIVE_USE(env, java_lang_System);
	_JC_INVOKE_STATIC(env, java_lang_VMSystem, arraycopy$4286a72d57744cd8, 0, r2, i2, r1, i0, i4);
	_JC_LINE_NUMBER(102);				// 6
	i2 = _JC_PRIM_FIELD(env, r0, gnu_java_security_provider_SHA1PRNG, datapos);
	i2 = i2 + i4;
	_JC_PRIM_FIELD(env, r0, gnu_java_security_provider_SHA1PRNG, datapos) = i2;
	_JC_LINE_NUMBER(103);				// 7
	i0 = i0 + i4;
	goto label4;

label3:
	_JC_LINE_NUMBER(108);				// 8
	r2 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_SHA1PRNG, seed);
	r3 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_SHA1PRNG, data);
	_JC_ACTIVE_USE(env, java_lang_System);
	_JC_INVOKE_STATIC(env, java_lang_VMSystem, arraycopy$4286a72d57744cd8, 0, r2, 0, r3, 20, 20);
	_JC_LINE_NUMBER(109);				// 9
	r4 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_SHA1PRNG, digest);
	r3 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_SHA1PRNG, data);
	r2 = _JC_INVOKE_VIRTUAL(env, java_security_MessageDigest, digest$676ad6c3bfac196b, r4, r3);
	_JC_LINE_NUMBER(110);				// 10
	r3 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_SHA1PRNG, data);
	_JC_INVOKE_STATIC(env, java_lang_VMSystem, arraycopy$4286a72d57744cd8, 1, r2, 0, r3, 0, 20);
	_JC_LINE_NUMBER(111);				// 11
	_JC_PRIM_FIELD(env, r0, gnu_java_security_provider_SHA1PRNG, datapos) = 0;

label4:
	_JC_LINE_NUMBER(95);				// 12
	i2 = _JC_ARRAY_LENGTH(env, r1);
	if (i0 < i2) {
		_JC_PERIODIC_CHECK(env);
		goto label0;
	}
	_JC_LINE_NUMBER(114);				// 13
	return;
}

//
// public void engineSetSeed(byte[])
//

static _jc_linenum _jc_gnu_java_security_provider_SHA1PRNG$linenum_table$engineSetSeed$d5670365ecc71f53[];

static const unsigned char _jc_gnu_java_security_provider_SHA1PRNG$param_ptypes$engineSetSeed$d5670365ecc71f53[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_gnu_java_security_provider_SHA1PRNG$param_types$engineSetSeed$d5670365ecc71f53[] = {
	&_jc_byte$array$prim$type
};

_jc_method _jc_gnu_java_security_provider_SHA1PRNG$method_info$engineSetSeed$d5670365ecc71f53 = {
	.name=			"engineSetSeed",
	.signature=		"([B)V",
	.class=			&_jc_gnu_java_security_provider_SHA1PRNG$type,
	.param_types=		&_jc_gnu_java_security_provider_SHA1PRNG$param_types$engineSetSeed$d5670365ecc71f53,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_SHA1PRNG$param_ptypes$engineSetSeed$d5670365ecc71f53,
	.signature_hash=	_JC_JLONG(0xd5670365ecc71f53),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_provider_SHA1PRNG$method$engineSetSeed$d5670365ecc71f53,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_provider_SHA1PRNG$vtable, gnu_java_security_provider_SHA1PRNG.engineSetSeed$d5670365ecc71f53) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_gnu_java_security_provider_SHA1PRNG$linenum_table$engineSetSeed$d5670365ecc71f53
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_SHA1PRNG, engineSetSeed$d5670365ecc71f53);

void _JC_JCNI_ATTR
_jc_gnu_java_security_provider_SHA1PRNG$method$engineSetSeed$d5670365ecc71f53(_jc_env *const env, _jc_gnu_java_security_provider_SHA1PRNG$object *this, _jc_byte_array *param0)
{
	jbyte b4;
	jbyte b5;
	jint i0;
	jint i1;
	jint i2;
	struct _jc_gnu_java_security_provider_SHA1PRNG$object *r0;
	_jc_byte_array *r1;
	_jc_byte_array *r3;

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(85);				// 0
	i0 = 0;
	goto label1;

label0:
	_JC_LINE_NUMBER(86);				// 1
	r3 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_SHA1PRNG, seed);
	i1 = _JC_PRIM_FIELD(env, r0, gnu_java_security_provider_SHA1PRNG, seedpos);
	i2 = i1 + 1;
	_JC_PRIM_FIELD(env, r0, gnu_java_security_provider_SHA1PRNG, seedpos) = i2;
	i2 = i1 % 20;
	b4 = _JC_PRIM_ELEMENT(env, byte, r3, i2, 1, 1);
	b5 = _JC_PRIM_ELEMENT(env, byte, r1, i0, 0, 0);
	b5 = b4 ^ b5;
	b5 = (jbyte)b5;
	_JC_PRIM_ELEMENT(env, byte, r3, i2, 0, 0) = b5;
	_JC_LINE_NUMBER(85);				// 2
	i0 = i0 + 1;

label1:
	i2 = _JC_ARRAY_LENGTH(env, r1);
	if (i0 < i2) {
		_JC_PERIODIC_CHECK(env);
		goto label0;
	}
	_JC_LINE_NUMBER(87);				// 3
	i2 = _JC_PRIM_FIELD(env, r0, gnu_java_security_provider_SHA1PRNG, seedpos);
	i2 = i2 % 20;
	_JC_PRIM_FIELD(env, r0, gnu_java_security_provider_SHA1PRNG, seedpos) = i2;
	_JC_LINE_NUMBER(89);				// 4
	return;
}

//
// private final void ensureIsSeeded()
//

static _jc_linenum _jc_gnu_java_security_provider_SHA1PRNG$linenum_table$ensureIsSeeded$ffcf98ef7344e986[];

static const unsigned char _jc_gnu_java_security_provider_SHA1PRNG$param_ptypes$ensureIsSeeded$ffcf98ef7344e986[] = { 
_JC_TYPE_VOID };

_jc_method _jc_gnu_java_security_provider_SHA1PRNG$method_info$ensureIsSeeded$ffcf98ef7344e986 = {
	.name=			"ensureIsSeeded",
	.signature=		"()V",
	.class=			&_jc_gnu_java_security_provider_SHA1PRNG$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_SHA1PRNG$param_ptypes$ensureIsSeeded$ffcf98ef7344e986,
	.signature_hash=	_JC_JLONG(0xffcf98ef7344e986),
	.access_flags=		_JC_ACC_PRIVATE|_JC_ACC_FINAL,
	.function=		&_jc_gnu_java_security_provider_SHA1PRNG$method$ensureIsSeeded$ffcf98ef7344e986,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_provider_SHA1PRNG$vtable, gnu_java_security_provider_SHA1PRNG.ensureIsSeeded$ffcf98ef7344e986) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	6,
	      .table=	_jc_gnu_java_security_provider_SHA1PRNG$linenum_table$ensureIsSeeded$ffcf98ef7344e986
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_SHA1PRNG, ensureIsSeeded$ffcf98ef7344e986);

void _JC_JCNI_ATTR
_jc_gnu_java_security_provider_SHA1PRNG$method$ensureIsSeeded$ffcf98ef7344e986(_jc_env *const env, _jc_gnu_java_security_provider_SHA1PRNG$object *this)
{
	struct _jc_gnu_java_security_provider_SHA1PRNG$object *r0;
	_jc_byte_array *r1;
	struct _jc_java_util_Random$object *r2;
	struct _jc_java_security_MessageDigest$object *r3;
	_jc_byte_array *r4;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(126);				// 0
	z0 = _JC_PRIM_FIELD(env, r0, gnu_java_security_provider_SHA1PRNG, seeded);
	if (z0 != 0)
		goto label0;
	_JC_LINE_NUMBER(128);				// 1
	r2 = _JC_NEW(env, java_util_Random);
	_JC_INVOKE_NONVIRTUAL(env, java_util_Random, setSeed$b5af8144ceac8f80, 0, r2, _JC_JLONG(0));
	r1 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_SHA1PRNG, seed);
	_JC_INVOKE_NONVIRTUAL(env, java_util_Random, nextBytes$3cf04b354db5197f, 0, r2, r1);
	_JC_LINE_NUMBER(130);				// 2
	r3 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_SHA1PRNG, digest);
	r1 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_SHA1PRNG, data);
	r1 = _JC_INVOKE_VIRTUAL(env, java_security_MessageDigest, digest$676ad6c3bfac196b, r3, r1);
	_JC_LINE_NUMBER(131);				// 3
	r4 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_SHA1PRNG, data);
	_JC_ACTIVE_USE(env, java_lang_System);
	_JC_INVOKE_STATIC(env, java_lang_VMSystem, arraycopy$4286a72d57744cd8, 0, r1, 0, r4, 0, 20);
	_JC_LINE_NUMBER(133);				// 4
	_JC_PRIM_FIELD(env, r0, gnu_java_security_provider_SHA1PRNG, seeded) = 1;

label0:
	_JC_LINE_NUMBER(135);				// 5
	return;
}

//
// private final void this()
//

static _jc_linenum _jc_gnu_java_security_provider_SHA1PRNG$linenum_table$this$adc93fb6bf4cbffa[];

static const unsigned char _jc_gnu_java_security_provider_SHA1PRNG$param_ptypes$this$adc93fb6bf4cbffa[] = { 
_JC_TYPE_VOID };

_jc_method _jc_gnu_java_security_provider_SHA1PRNG$method_info$this$adc93fb6bf4cbffa = {
	.name=			"this",
	.signature=		"()V",
	.class=			&_jc_gnu_java_security_provider_SHA1PRNG$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_SHA1PRNG$param_ptypes$this$adc93fb6bf4cbffa,
	.signature_hash=	_JC_JLONG(0xadc93fb6bf4cbffa),
	.access_flags=		_JC_ACC_PRIVATE|_JC_ACC_FINAL,
	.function=		&_jc_gnu_java_security_provider_SHA1PRNG$method$this$adc93fb6bf4cbffa,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_provider_SHA1PRNG$vtable, gnu_java_security_provider_SHA1PRNG.this$adc93fb6bf4cbffa) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_gnu_java_security_provider_SHA1PRNG$linenum_table$this$adc93fb6bf4cbffa
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_SHA1PRNG, this$adc93fb6bf4cbffa);

void _JC_JCNI_ATTR
_jc_gnu_java_security_provider_SHA1PRNG$method$this$adc93fb6bf4cbffa(_jc_env *const env, _jc_gnu_java_security_provider_SHA1PRNG$object *this)
{
	struct _jc_gnu_java_security_provider_SHA1PRNG$object *r0;

	r0 = this;
	_JC_LINE_NUMBER(54);				// 0
	_JC_PRIM_FIELD(env, r0, gnu_java_security_provider_SHA1PRNG, seeded) = 0;
	return;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_gnu_java_security_provider_SHA1PRNG$methods[] = {
	&_jc_gnu_java_security_provider_SHA1PRNG$method_info$_init$52f4ad9f2989aeee,
	&_jc_gnu_java_security_provider_SHA1PRNG$method_info$engineGenerateSeed$3f2678c95ef54b9d,
	&_jc_gnu_java_security_provider_SHA1PRNG$method_info$engineNextBytes$41b3d85f207b40da,
	&_jc_gnu_java_security_provider_SHA1PRNG$method_info$engineSetSeed$d5670365ecc71f53,
	&_jc_gnu_java_security_provider_SHA1PRNG$method_info$ensureIsSeeded$ffcf98ef7344e986,
	&_jc_gnu_java_security_provider_SHA1PRNG$method_info$this$adc93fb6bf4cbffa
};

/************************************************************************
 *			  Class fields structure			*
 ************************************************************************/

_jc_gnu_java_security_provider_SHA1PRNG$fields_struct _jc_gnu_java_security_provider_SHA1PRNG$class_fields = { };

/************************************************************************
 *			      Interface list				*
 ************************************************************************/

// Directly implemented interfaces
static _jc_type *const _jc_gnu_java_security_provider_SHA1PRNG$interfaces[] = {
	&_jc_java_io_Serializable$type
};

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_gnu_java_security_provider_SHA1PRNG$instanceof_hash_bucket_65[] = {
	&_jc_java_io_Serializable$type,
	_JC_NULL
};
static _jc_type *const _jc_gnu_java_security_provider_SHA1PRNG$instanceof_hash_bucket_67[] = {
	&_jc_gnu_java_security_provider_SHA1PRNG$type,
	_JC_NULL
};
static _jc_type *const _jc_gnu_java_security_provider_SHA1PRNG$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};
static _jc_type *const _jc_gnu_java_security_provider_SHA1PRNG$instanceof_hash_bucket_111[] = {
	&_jc_java_security_SecureRandomSpi$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_gnu_java_security_provider_SHA1PRNG$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[65]=	_jc_gnu_java_security_provider_SHA1PRNG$instanceof_hash_bucket_65,
	[67]=	_jc_gnu_java_security_provider_SHA1PRNG$instanceof_hash_bucket_67,
	[101]=	_jc_gnu_java_security_provider_SHA1PRNG$instanceof_hash_bucket_101,
	[111]=	_jc_gnu_java_security_provider_SHA1PRNG$instanceof_hash_bucket_111
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_gnu_java_security_provider_SHA1PRNG$class_depends[] = {
	{ "java/io/Serializable",	_JC_JLONG(0x9a35c7173b37e641) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/Error",	_JC_JLONG(0x308333d803f5ab9f) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/InternalError",	_JC_JLONG(0x642246d728a60038) },
	{ "java/lang/Math",	_JC_JLONG(0x8d71d806a180ad8a) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/System",	_JC_JLONG(0x53cc8e2333795f04) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMSystem",	_JC_JLONG(0x4d1cebae0bdda058) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/lang/VirtualMachineError",	_JC_JLONG(0xc7632ae877826bc6) },
	{ "java/security/GeneralSecurityException",	_JC_JLONG(0x692089051f4c8d0b) },
	{ "java/security/MessageDigest",	_JC_JLONG(0xcc2047cad8dcf75e) },
	{ "java/security/NoSuchAlgorithmException",	_JC_JLONG(0x22e937c2536160b4) },
	{ "java/security/Provider",	_JC_JLONG(0x81b073051aa30acc) },
	{ "java/security/SecureRandomSpi",	_JC_JLONG(0x254ca156f086a0ef) },
	{ "java/security/Security",	_JC_JLONG(0x89bf77984bd9669e) },
	{ "java/util/Random",	_JC_JLONG(0x61639c1affc91eab) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_gnu_java_security_provider_SHA1PRNG$vtype _jc_gnu_java_security_provider_SHA1PRNG$type = {
    .type= {
	.name=			"gnu/java/security/provider/SHA1PRNG",
	.superclass=		&_jc_java_security_SecureRandomSpi$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.num_interfaces=sizeof(_jc_gnu_java_security_provider_SHA1PRNG$interfaces) / sizeof(*_jc_gnu_java_security_provider_SHA1PRNG$interfaces),
	.interfaces=		_jc_gnu_java_security_provider_SHA1PRNG$interfaces,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		19,
		.hash=			_JC_JLONG(0x74cf6a4caac8d5c3),
		.source_file=		"SHA1PRNG.java",
		.instance_size=		sizeof(_jc_gnu_java_security_provider_SHA1PRNG$refs) + sizeof(_jc_gnu_java_security_provider_SHA1PRNG$object),
		.num_virtual_refs=	3,
		.num_fields=		sizeof(_jc_gnu_java_security_provider_SHA1PRNG$fields) / sizeof(*_jc_gnu_java_security_provider_SHA1PRNG$fields),
		.fields=		_jc_gnu_java_security_provider_SHA1PRNG$fields,
		.num_methods=		sizeof(_jc_gnu_java_security_provider_SHA1PRNG$methods) / sizeof(*_jc_gnu_java_security_provider_SHA1PRNG$methods),
		.methods=		_jc_gnu_java_security_provider_SHA1PRNG$methods,
		.instanceof_hash_table=	_jc_gnu_java_security_provider_SHA1PRNG$instanceof_hash_table,
		.class_fields=		&_jc_gnu_java_security_provider_SHA1PRNG$class_fields,
		.num_class_depends=		sizeof(_jc_gnu_java_security_provider_SHA1PRNG$class_depends) / sizeof(*_jc_gnu_java_security_provider_SHA1PRNG$class_depends),
		.class_depends=		_jc_gnu_java_security_provider_SHA1PRNG$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.java_security_SecureRandomSpi= {
	    .engineGenerateSeed$3f2678c95ef54b9d=		// overridden
		&_jc_gnu_java_security_provider_SHA1PRNG$method$engineGenerateSeed$3f2678c95ef54b9d,
	    .engineNextBytes$41b3d85f207b40da=		// overridden
		&_jc_gnu_java_security_provider_SHA1PRNG$method$engineNextBytes$41b3d85f207b40da,
	    .engineSetSeed$d5670365ecc71f53=		// overridden
		&_jc_gnu_java_security_provider_SHA1PRNG$method$engineSetSeed$d5670365ecc71f53,
	},
	.gnu_java_security_provider_SHA1PRNG= {
	    .engineGenerateSeed$3f2678c95ef54b9d=
		&_jc_gnu_java_security_provider_SHA1PRNG$method$engineGenerateSeed$3f2678c95ef54b9d,
	    .engineNextBytes$41b3d85f207b40da=
		&_jc_gnu_java_security_provider_SHA1PRNG$method$engineNextBytes$41b3d85f207b40da,
	    .engineSetSeed$d5670365ecc71f53=
		&_jc_gnu_java_security_provider_SHA1PRNG$method$engineSetSeed$d5670365ecc71f53,
	    .ensureIsSeeded$ffcf98ef7344e986=
		&_jc_gnu_java_security_provider_SHA1PRNG$method$ensureIsSeeded$ffcf98ef7344e986,
	    .this$adc93fb6bf4cbffa=
		&_jc_gnu_java_security_provider_SHA1PRNG$method$this$adc93fb6bf4cbffa,
	},
    }
};

