// public class gnu.java.security.x509.X509CertSelectorImpl

// class file dependencies
// @dep_class 78ef52e48159b870 gnu_java_security_der_DERReader
// @dep_class 420d501e6520fb6c gnu_java_security_x509_X500DistinguishedName
// @dep_class 27084f8baa8d0062 gnu_java_security_x509_X509CertSelectorImpl
// @dep_class a68cc27886fd8be3 java_io_ByteArrayInputStream
// @dep_class c4d3cc2bda03a338 java_io_ByteArrayOutputStream
// @dep_class 4e0a56550c69d57c java_io_IOException
// @dep_class 4026d3144d6654d8 java_io_OutputStream
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class 9b667b09132be893 java_lang_Cloneable
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class 680cf34d05feb5a1 java_lang_IllegalArgumentException
// @dep_class 505b8a9a6675be0 java_lang_NullPointerException
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class 4f5534a987354d1d java_lang_RuntimeException
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class 1ed0accfc254a715 java_security_Principal
// @dep_class c7e244007d8c33f7 java_security_cert_CertSelector
// @dep_class c98c8192da849b07 java_security_cert_Certificate
// @dep_class 859e5e5544e5909f java_security_cert_X509Certificate
// @dep_class 8ea716c64b77f8eb java_util_AbstractCollection
// @dep_class f5238436362828db java_util_AbstractList
// @dep_class 6d7997e879c41059 java_util_AbstractSequentialList
// @dep_class ca427569b5b2f804 java_util_AbstractSet
// @dep_class eae4d0c0e8eb63da java_util_Collection
// @dep_class 9574af3fed58029a java_util_Collections
// @dep_class 2126b28aee607999 java_util_Collections__24UnmodifiableCollection
// @dep_class aec2ea3fc69f0e47 java_util_Collections__24UnmodifiableSet
// @dep_class d7cd853200c3e71f java_util_HashMap
// @dep_class 3c285c721478414d java_util_HashSet
// @dep_class be56ff673eefd9d2 java_util_Iterator
// @dep_class 6e4b267a445acd50 java_util_LinkedHashMap
// @dep_class 666417b6279ae396 java_util_LinkedList
// @dep_class 9ee0d92ce1525a4d java_util_List
// @dep_class e283f7c2e7a7979c java_util_Map
// @dep_class 617ac82c0bec2dff java_util_Set
// @dep_class b62659fbc202d723 javax_security_auth_x500_X500Principal

// header file dependencies
// @dep_header gnu_java_security_der_DERReader
// @dep_header gnu_java_security_x509_X500DistinguishedName
// @dep_header gnu_java_security_x509_X509CertSelectorImpl
// @dep_header java_io_ByteArrayInputStream
// @dep_header java_io_ByteArrayOutputStream
// @dep_header java_io_IOException
// @dep_header java_lang_Class
// @dep_header java_lang_Cloneable
// @dep_header java_lang_IllegalArgumentException
// @dep_header java_lang_NullPointerException
// @dep_header java_lang_String
// @dep_header java_lang_VMThrowable
// @dep_header java_security_Principal
// @dep_header java_security_cert_CertSelector
// @dep_header java_security_cert_X509Certificate
// @dep_header java_util_Collection
// @dep_header java_util_Collections
// @dep_header java_util_Collections__24UnmodifiableSet
// @dep_header java_util_HashSet
// @dep_header java_util_Iterator
// @dep_header java_util_LinkedHashMap
// @dep_header java_util_LinkedList
// @dep_header java_util_List
// @dep_header java_util_Map
// @dep_header java_util_Set
// @dep_header javax_security_auth_x500_X500Principal

#include "jc_defs.h"

#include "gnu/java/security/der/DERReader.h"
#include "gnu/java/security/x509/X500DistinguishedName.h"
#include "gnu/java/security/x509/X509CertSelectorImpl.h"
#include "java/io/ByteArrayInputStream.h"
#include "java/io/ByteArrayOutputStream.h"
#include "java/io/IOException.h"
#include "java/lang/Class.h"
#include "java/lang/Cloneable.h"
#include "java/lang/IllegalArgumentException.h"
#include "java/lang/NullPointerException.h"
#include "java/lang/String.h"
#include "java/lang/VMThrowable.h"
#include "java/security/Principal.h"
#include "java/security/cert/CertSelector.h"
#include "java/security/cert/X509Certificate.h"
#include "java/util/Collection.h"
#include "java/util/Collections.h"
#include "java/util/Collections__24UnmodifiableSet.h"
#include "java/util/HashSet.h"
#include "java/util/Iterator.h"
#include "java/util/LinkedHashMap.h"
#include "java/util/LinkedList.h"
#include "java/util/List.h"
#include "java/util/Map.h"
#include "java/util/Set.h"
#include "javax/security/auth/x500/X500Principal.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// private java.util.Set issuerNames
static _jc_field _jc_gnu_java_security_x509_X509CertSelectorImpl$field_info$issuerNames = {
	.name=		"issuerNames",
	.signature=	"Ljava/util/Set;",
	.class=		&_jc_gnu_java_security_x509_X509CertSelectorImpl$type,
	.type=		&_jc_java_util_Set$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_gnu_java_security_x509_X509CertSelectorImpl$object, refs[-1].gnu_java_security_x509_X509CertSelectorImpl.issuerNames),
};

// private java.util.Set subjectNames
static _jc_field _jc_gnu_java_security_x509_X509CertSelectorImpl$field_info$subjectNames = {
	.name=		"subjectNames",
	.signature=	"Ljava/util/Set;",
	.class=		&_jc_gnu_java_security_x509_X509CertSelectorImpl$type,
	.type=		&_jc_java_util_Set$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_gnu_java_security_x509_X509CertSelectorImpl$object, refs[-1].gnu_java_security_x509_X509CertSelectorImpl.subjectNames),
};

// Fields
static _jc_field *const _jc_gnu_java_security_x509_X509CertSelectorImpl$fields[] = {
	&_jc_gnu_java_security_x509_X509CertSelectorImpl$field_info$issuerNames,
	&_jc_gnu_java_security_x509_X509CertSelectorImpl$field_info$subjectNames
};

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// public void <init>()
//

static _jc_linenum _jc_gnu_java_security_x509_X509CertSelectorImpl$linenum_table$_init$52f4ad9f2989aeee[];

static const unsigned char _jc_gnu_java_security_x509_X509CertSelectorImpl$param_ptypes$_init$52f4ad9f2989aeee[] = { 
_JC_TYPE_VOID };

_jc_method _jc_gnu_java_security_x509_X509CertSelectorImpl$method_info$_init$52f4ad9f2989aeee = {
	.name=			"<init>",
	.signature=		"()V",
	.class=			&_jc_gnu_java_security_x509_X509CertSelectorImpl$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_x509_X509CertSelectorImpl$param_ptypes$_init$52f4ad9f2989aeee,
	.signature_hash=	_JC_JLONG(0x52f4ad9f2989aeee),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_x509_X509CertSelectorImpl$method$_init$52f4ad9f2989aeee,
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_gnu_java_security_x509_X509CertSelectorImpl$linenum_table$_init$52f4ad9f2989aeee
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_x509_X509CertSelectorImpl, _init$52f4ad9f2989aeee);

void _JC_JCNI_ATTR
_jc_gnu_java_security_x509_X509CertSelectorImpl$method$_init$52f4ad9f2989aeee(_jc_env *const env, _jc_gnu_java_security_x509_X509CertSelectorImpl$object *this)
{
	struct _jc_gnu_java_security_x509_X509CertSelectorImpl$object *r0;
	struct _jc_java_util_HashSet$object *r1;
	struct _jc_java_util_HashMap$object *r2;
	struct _jc_java_util_HashMap$object *r5;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(72);				// 0
	r1 = _JC_NEW(env, java_util_HashSet);
	r2 = _JC_NEW(env, java_util_HashMap);
	_JC_INVOKE_NONVIRTUAL(env, java_util_HashMap, _init$7cb044ce4fb0ada8, 0, r2, 11, _JC_FCONST(0x3f, 0x40, 0x0, 0x0));
	_JC_REF_FIELD(env, r1, java_util_HashSet, map) = r2;
	_JC_REF_FIELD(env, r0, gnu_java_security_x509_X509CertSelectorImpl, issuerNames) = r1;
	_JC_LINE_NUMBER(73);				// 1
	r1 = _JC_NEW(env, java_util_HashSet);
	r5 = _JC_NEW(env, java_util_HashMap);
	_JC_INVOKE_NONVIRTUAL(env, java_util_HashMap, _init$7cb044ce4fb0ada8, 0, r5, 11, _JC_FCONST(0x3f, 0x40, 0x0, 0x0));
	_JC_REF_FIELD(env, r1, java_util_HashSet, map) = r5;
	_JC_REF_FIELD(env, r0, gnu_java_security_x509_X509CertSelectorImpl, subjectNames) = r1;
	_JC_LINE_NUMBER(74);				// 2
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public void addIssuerName(java.lang.String)
//

static _jc_linenum _jc_gnu_java_security_x509_X509CertSelectorImpl$linenum_table$addIssuerName$9da6a33e284f4b22[];

static _jc_trap_info _jc_gnu_java_security_x509_X509CertSelectorImpl$trap_table$addIssuerName$9da6a33e284f4b22[] = {
	_JC_TRAP(&_jc_java_io_IOException$type, 1, 2),
};

static const unsigned char _jc_gnu_java_security_x509_X509CertSelectorImpl$param_ptypes$addIssuerName$9da6a33e284f4b22[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_gnu_java_security_x509_X509CertSelectorImpl$param_types$addIssuerName$9da6a33e284f4b22[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_gnu_java_security_x509_X509CertSelectorImpl$method_info$addIssuerName$9da6a33e284f4b22 = {
	.name=			"addIssuerName",
	.signature=		"(Ljava/lang/String;)V",
	.class=			&_jc_gnu_java_security_x509_X509CertSelectorImpl$type,
	.param_types=		&_jc_gnu_java_security_x509_X509CertSelectorImpl$param_types$addIssuerName$9da6a33e284f4b22,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_x509_X509CertSelectorImpl$param_ptypes$addIssuerName$9da6a33e284f4b22,
	.signature_hash=	_JC_JLONG(0x9da6a33e284f4b22),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_x509_X509CertSelectorImpl$method$addIssuerName$9da6a33e284f4b22,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_x509_X509CertSelectorImpl$vtable, gnu_java_security_x509_X509CertSelectorImpl.addIssuerName$9da6a33e284f4b22) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .trap_table_len=	1,
	  .trap_table=		_jc_gnu_java_security_x509_X509CertSelectorImpl$trap_table$addIssuerName$9da6a33e284f4b22,
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_gnu_java_security_x509_X509CertSelectorImpl$linenum_table$addIssuerName$9da6a33e284f4b22
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_x509_X509CertSelectorImpl, addIssuerName$9da6a33e284f4b22);

void _JC_JCNI_ATTR
_jc_gnu_java_security_x509_X509CertSelectorImpl$method$addIssuerName$9da6a33e284f4b22(_jc_env *const env, _jc_gnu_java_security_x509_X509CertSelectorImpl$object *this, _jc_java_lang_String$object *param0)
{
	struct _jc_gnu_java_security_x509_X509CertSelectorImpl$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_gnu_java_security_x509_X500DistinguishedName$object *r2;
	struct _jc_object *r3;
	struct _jc_java_lang_String$object *volatile r4;
	struct _jc_java_io_IOException$object *volatile r5;
	struct _jc_java_lang_IllegalArgumentException$object *volatile r6;
	struct _jc_java_lang_VMThrowable$object *volatile r8;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_gnu_java_security_x509_X509CertSelectorImpl$method_info$addIssuerName$9da6a33e284f4b22, &&label0);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(86);				// 0
	r3 = _JC_REF_FIELD(env, r0, gnu_java_security_x509_X509CertSelectorImpl, issuerNames);
	r2 = _JC_NEW(env, gnu_java_security_x509_X500DistinguishedName);
	_JC_INVOKE_NONVIRTUAL(env, gnu_java_security_x509_X500DistinguishedName, _init$52f4ad9f2989aeee, 0, r2);
	_JC_TRAP_REGION(catch, 1);
	_JC_INVOKE_NONVIRTUAL(env, gnu_java_security_x509_X500DistinguishedName, parseString$c5fa011525652d61, 0, r2, r1);
	_JC_TRAP_REGION(catch, 2);
	goto label1;

label0:
	_JC_TRAP_REGION(catch, 2);
	r5 = _JC_CAUGHT_EXCEPTION(env);
	r6 = _JC_NEW(env, java_lang_IllegalArgumentException);
	r4 = _JC_INVOKE_VIRTUAL(env, java_lang_Throwable, toString$7ea43b33b80a3070, r5);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, cause) = r6;
	r8 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r6);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, vmState) = r8;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, detailMessage) = r4;
	_JC_THROW(env, r6);

label1:
	_JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0x831f06ee5f59c0cc), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r2);
	_JC_LINE_NUMBER(87);				// 1
	_JC_CANCEL_TRAPS(env, catch);
	return;
}

//
// public void addIssuerName(java.security.Principal) throws java.io.IOException
//

static _jc_linenum _jc_gnu_java_security_x509_X509CertSelectorImpl$linenum_table$addIssuerName$cfee6fa2baca6874[];

static _jc_trap_info _jc_gnu_java_security_x509_X509CertSelectorImpl$trap_table$addIssuerName$cfee6fa2baca6874[] = {
	_JC_TRAP(&_jc_java_io_IOException$type, 1, 2),
};

static const unsigned char _jc_gnu_java_security_x509_X509CertSelectorImpl$param_ptypes$addIssuerName$cfee6fa2baca6874[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_gnu_java_security_x509_X509CertSelectorImpl$exceptions$addIssuerName$cfee6fa2baca6874[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_gnu_java_security_x509_X509CertSelectorImpl$param_types$addIssuerName$cfee6fa2baca6874[] = {
	&_jc_java_security_Principal$type
};

_jc_method _jc_gnu_java_security_x509_X509CertSelectorImpl$method_info$addIssuerName$cfee6fa2baca6874 = {
	.name=			"addIssuerName",
	.signature=		"(Ljava/security/Principal;)V",
	.class=			&_jc_gnu_java_security_x509_X509CertSelectorImpl$type,
	.param_types=		&_jc_gnu_java_security_x509_X509CertSelectorImpl$param_types$addIssuerName$cfee6fa2baca6874,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_x509_X509CertSelectorImpl$param_ptypes$addIssuerName$cfee6fa2baca6874,
	.signature_hash=	_JC_JLONG(0xcfee6fa2baca6874),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_x509_X509CertSelectorImpl$method$addIssuerName$cfee6fa2baca6874,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_x509_X509CertSelectorImpl$vtable, gnu_java_security_x509_X509CertSelectorImpl.addIssuerName$cfee6fa2baca6874) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_gnu_java_security_x509_X509CertSelectorImpl$exceptions$addIssuerName$cfee6fa2baca6874,
	.u= { .exec= {
	  .trap_table_len=	1,
	  .trap_table=		_jc_gnu_java_security_x509_X509CertSelectorImpl$trap_table$addIssuerName$cfee6fa2baca6874,
	  .u= {
	    .linenum= {
	      .len=	6,
	      .table=	_jc_gnu_java_security_x509_X509CertSelectorImpl$linenum_table$addIssuerName$cfee6fa2baca6874
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_x509_X509CertSelectorImpl, addIssuerName$cfee6fa2baca6874);

void _JC_JCNI_ATTR
_jc_gnu_java_security_x509_X509CertSelectorImpl$method$addIssuerName$cfee6fa2baca6874(_jc_env *const env, _jc_gnu_java_security_x509_X509CertSelectorImpl$object *this, _jc_object *param0)
{
	jint i0;
	struct _jc_gnu_java_security_x509_X509CertSelectorImpl$object *r0;
	struct _jc_object *r1;
	struct _jc_java_lang_String$object *volatile r10;
	struct _jc_java_io_IOException$object *volatile r11;
	struct _jc_java_lang_IllegalArgumentException$object *volatile r12;
	struct _jc_java_lang_VMThrowable$object *volatile r14;
	struct _jc_object *r2;
	struct _jc_gnu_java_security_x509_X500DistinguishedName$object *r3;
	struct _jc_javax_security_auth_x500_X500Principal$object *r4;
	struct _jc_java_lang_String$object *r5;
	struct _jc_gnu_java_security_der_DERReader$object *r6;
	struct _jc_java_io_ByteArrayInputStream$object *r7;
	_jc_byte_array *r8;
	struct _jc_java_lang_Object$object *r9;
	jboolean z0;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_gnu_java_security_x509_X509CertSelectorImpl$method_info$addIssuerName$cfee6fa2baca6874, &&label3);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(91);				// 0
	z0 = _JC_INSTANCEOF(env, r1, &_jc_gnu_java_security_x509_X500DistinguishedName$type);
	if (z0 == 0)
		goto label0;
	_JC_LINE_NUMBER(92);				// 1
	r2 = _JC_REF_FIELD(env, r0, gnu_java_security_x509_X509CertSelectorImpl, issuerNames);
	_JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0x831f06ee5f59c0cc), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r1);
	goto label5;

label0:
	_JC_LINE_NUMBER(93);				// 2
	z0 = _JC_INSTANCEOF_FINAL(env, r1, &_jc_javax_security_auth_x500_X500Principal$type);
	if (z0 == 0)
		goto label2;
	_JC_LINE_NUMBER(94);				// 3
	r2 = _JC_REF_FIELD(env, r0, gnu_java_security_x509_X509CertSelectorImpl, issuerNames);
	r3 = _JC_NEW(env, gnu_java_security_x509_X500DistinguishedName);
	r4 = r1;
	_JC_EXPLICIT_NULL_CHECK(env, r4);
	r8 = _JC_REF_FIELD(env, r4, javax_security_auth_x500_X500Principal, encoded);
	if (r8 != _JC_NULL)
		goto label1;
	_JC_INVOKE_NONVIRTUAL(env, javax_security_auth_x500_X500Principal, encodeDer$5b724e00f84e3391, 0, r4);

label1:
	r8 = _JC_REF_FIELD(env, r4, javax_security_auth_x500_X500Principal, encoded);
	r9 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, clone$b75f2713d6705f70, r8);
	r8 = _JC_CAST_FINAL(env, &_jc_byte$array$prim$type, r9);
	_JC_INVOKE_NONVIRTUAL(env, gnu_java_security_x509_X500DistinguishedName, _init$52f4ad9f2989aeee, 0, r3);
	r6 = _JC_NEW(env, gnu_java_security_der_DERReader);
	r7 = _JC_NEW(env, java_io_ByteArrayInputStream);
	i0 = _JC_ARRAY_LENGTH(env, r8);
	_JC_INVOKE_NONVIRTUAL(env, java_io_ByteArrayInputStream, _init$4ff4a7925ef7b06c, 0, r7, r8, 0, i0);
	_JC_INVOKE_NONVIRTUAL(env, gnu_java_security_der_DERReader, _init$3887600c17c5e554, 0, r6, r7);
	_JC_INVOKE_NONVIRTUAL(env, gnu_java_security_x509_X500DistinguishedName, parseDer$0657069246be78d9, 0, r3, r6);
	_JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0x831f06ee5f59c0cc), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r3);
	goto label5;

label2:
	_JC_LINE_NUMBER(96);				// 4
	r2 = _JC_REF_FIELD(env, r0, gnu_java_security_x509_X509CertSelectorImpl, issuerNames);
	r3 = _JC_NEW(env, gnu_java_security_x509_X500DistinguishedName);
	r5 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0xbec186f2ce7e1882), _jc_object *, (_jc_env *, struct _jc_object *));
	_JC_INVOKE_NONVIRTUAL(env, gnu_java_security_x509_X500DistinguishedName, _init$52f4ad9f2989aeee, 0, r3);
	_JC_TRAP_REGION(catch, 1);
	_JC_INVOKE_NONVIRTUAL(env, gnu_java_security_x509_X500DistinguishedName, parseString$c5fa011525652d61, 0, r3, r5);
	_JC_TRAP_REGION(catch, 2);
	goto label4;

label3:
	_JC_TRAP_REGION(catch, 2);
	r11 = _JC_CAUGHT_EXCEPTION(env);
	r12 = _JC_NEW(env, java_lang_IllegalArgumentException);
	r10 = _JC_INVOKE_VIRTUAL(env, java_lang_Throwable, toString$7ea43b33b80a3070, r11);
	_JC_REF_FIELD(env, r12, java_lang_Throwable, cause) = r12;
	r14 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r12);
	_JC_REF_FIELD(env, r12, java_lang_Throwable, vmState) = r14;
	_JC_REF_FIELD(env, r12, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r12, java_lang_Throwable, detailMessage) = r10;
	_JC_THROW(env, r12);

label4:
	_JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0x831f06ee5f59c0cc), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r3);

label5:
	_JC_TRAP_REGION(catch, 2);
	_JC_LINE_NUMBER(97);				// 5
	_JC_CANCEL_TRAPS(env, catch);
	return;
}

//
// public void addIssuerName(byte[]) throws java.io.IOException
//

static _jc_linenum _jc_gnu_java_security_x509_X509CertSelectorImpl$linenum_table$addIssuerName$1dbd53c377fac209[];

static const unsigned char _jc_gnu_java_security_x509_X509CertSelectorImpl$param_ptypes$addIssuerName$1dbd53c377fac209[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_gnu_java_security_x509_X509CertSelectorImpl$exceptions$addIssuerName$1dbd53c377fac209[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_gnu_java_security_x509_X509CertSelectorImpl$param_types$addIssuerName$1dbd53c377fac209[] = {
	&_jc_byte$array$prim$type
};

_jc_method _jc_gnu_java_security_x509_X509CertSelectorImpl$method_info$addIssuerName$1dbd53c377fac209 = {
	.name=			"addIssuerName",
	.signature=		"([B)V",
	.class=			&_jc_gnu_java_security_x509_X509CertSelectorImpl$type,
	.param_types=		&_jc_gnu_java_security_x509_X509CertSelectorImpl$param_types$addIssuerName$1dbd53c377fac209,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_x509_X509CertSelectorImpl$param_ptypes$addIssuerName$1dbd53c377fac209,
	.signature_hash=	_JC_JLONG(0x1dbd53c377fac209),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_x509_X509CertSelectorImpl$method$addIssuerName$1dbd53c377fac209,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_x509_X509CertSelectorImpl$vtable, gnu_java_security_x509_X509CertSelectorImpl.addIssuerName$1dbd53c377fac209) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_gnu_java_security_x509_X509CertSelectorImpl$exceptions$addIssuerName$1dbd53c377fac209,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_gnu_java_security_x509_X509CertSelectorImpl$linenum_table$addIssuerName$1dbd53c377fac209
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_x509_X509CertSelectorImpl, addIssuerName$1dbd53c377fac209);

void _JC_JCNI_ATTR
_jc_gnu_java_security_x509_X509CertSelectorImpl$method$addIssuerName$1dbd53c377fac209(_jc_env *const env, _jc_gnu_java_security_x509_X509CertSelectorImpl$object *this, _jc_byte_array *param0)
{
	jint i0;
	struct _jc_gnu_java_security_x509_X509CertSelectorImpl$object *r0;
	_jc_byte_array *r1;
	struct _jc_gnu_java_security_x509_X500DistinguishedName$object *r2;
	struct _jc_object *r3;
	struct _jc_gnu_java_security_der_DERReader$object *r4;
	struct _jc_java_io_ByteArrayInputStream$object *r5;
	struct _jc_java_util_LinkedList$object *r6;
	struct _jc_java_util_LinkedHashMap$object *r7;
	struct _jc_object *r8;
	struct _jc_object *r9;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(81);				// 0
	r3 = _JC_REF_FIELD(env, r0, gnu_java_security_x509_X509CertSelectorImpl, issuerNames);
	r2 = _JC_NEW(env, gnu_java_security_x509_X500DistinguishedName);
	r6 = _JC_NEW(env, java_util_LinkedList);
	_JC_PRIM_FIELD(env, r6, java_util_LinkedList, size) = 0;
	_JC_REF_FIELD(env, r2, gnu_java_security_x509_X500DistinguishedName, components) = r6;
	r7 = _JC_NEW(env, java_util_LinkedHashMap);
	_JC_INVOKE_NONVIRTUAL(env, java_util_HashMap, _init$7cb044ce4fb0ada8, 0, r7, 11, _JC_FCONST(0x3f, 0x40, 0x0, 0x0));
	_JC_PRIM_FIELD(env, r7, java_util_LinkedHashMap, accessOrder) = 0;
	_JC_REF_FIELD(env, r2, gnu_java_security_x509_X500DistinguishedName, currentRdn) = r7;
	r8 = _JC_REF_FIELD(env, r2, gnu_java_security_x509_X500DistinguishedName, components);
	r9 = _JC_REF_FIELD(env, r2, gnu_java_security_x509_X500DistinguishedName, currentRdn);
	_JC_INVOKE_INTERFACE(env, r8, _JC_JLONG(0x831f06ee5f59c0cc), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r9);
	r4 = _JC_NEW(env, gnu_java_security_der_DERReader);
	r5 = _JC_NEW(env, java_io_ByteArrayInputStream);
	i0 = _JC_ARRAY_LENGTH(env, r1);
	_JC_INVOKE_NONVIRTUAL(env, java_io_ByteArrayInputStream, _init$4ff4a7925ef7b06c, 0, r5, r1, 0, i0);
	_JC_INVOKE_NONVIRTUAL(env, gnu_java_security_der_DERReader, _init$3887600c17c5e554, 0, r4, r5);
	_JC_INVOKE_NONVIRTUAL(env, gnu_java_security_x509_X500DistinguishedName, parseDer$0657069246be78d9, 0, r2, r4);
	_JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0x831f06ee5f59c0cc), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r2);
	_JC_LINE_NUMBER(82);				// 1
	return;
}

//
// public void addSubjectName(java.lang.String) throws java.io.IOException
//

static _jc_linenum _jc_gnu_java_security_x509_X509CertSelectorImpl$linenum_table$addSubjectName$24c38f207fc9ceab[];

static _jc_trap_info _jc_gnu_java_security_x509_X509CertSelectorImpl$trap_table$addSubjectName$24c38f207fc9ceab[] = {
	_JC_TRAP(&_jc_java_io_IOException$type, 1, 2),
};

static const unsigned char _jc_gnu_java_security_x509_X509CertSelectorImpl$param_ptypes$addSubjectName$24c38f207fc9ceab[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_gnu_java_security_x509_X509CertSelectorImpl$exceptions$addSubjectName$24c38f207fc9ceab[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_gnu_java_security_x509_X509CertSelectorImpl$param_types$addSubjectName$24c38f207fc9ceab[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_gnu_java_security_x509_X509CertSelectorImpl$method_info$addSubjectName$24c38f207fc9ceab = {
	.name=			"addSubjectName",
	.signature=		"(Ljava/lang/String;)V",
	.class=			&_jc_gnu_java_security_x509_X509CertSelectorImpl$type,
	.param_types=		&_jc_gnu_java_security_x509_X509CertSelectorImpl$param_types$addSubjectName$24c38f207fc9ceab,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_x509_X509CertSelectorImpl$param_ptypes$addSubjectName$24c38f207fc9ceab,
	.signature_hash=	_JC_JLONG(0x24c38f207fc9ceab),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_x509_X509CertSelectorImpl$method$addSubjectName$24c38f207fc9ceab,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_x509_X509CertSelectorImpl$vtable, gnu_java_security_x509_X509CertSelectorImpl.addSubjectName$24c38f207fc9ceab) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_gnu_java_security_x509_X509CertSelectorImpl$exceptions$addSubjectName$24c38f207fc9ceab,
	.u= { .exec= {
	  .trap_table_len=	1,
	  .trap_table=		_jc_gnu_java_security_x509_X509CertSelectorImpl$trap_table$addSubjectName$24c38f207fc9ceab,
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_gnu_java_security_x509_X509CertSelectorImpl$linenum_table$addSubjectName$24c38f207fc9ceab
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_x509_X509CertSelectorImpl, addSubjectName$24c38f207fc9ceab);

void _JC_JCNI_ATTR
_jc_gnu_java_security_x509_X509CertSelectorImpl$method$addSubjectName$24c38f207fc9ceab(_jc_env *const env, _jc_gnu_java_security_x509_X509CertSelectorImpl$object *this, _jc_java_lang_String$object *param0)
{
	struct _jc_gnu_java_security_x509_X509CertSelectorImpl$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_gnu_java_security_x509_X500DistinguishedName$object *r2;
	struct _jc_object *r3;
	struct _jc_java_lang_String$object *volatile r4;
	struct _jc_java_io_IOException$object *volatile r5;
	struct _jc_java_lang_IllegalArgumentException$object *volatile r6;
	struct _jc_java_lang_VMThrowable$object *volatile r8;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_gnu_java_security_x509_X509CertSelectorImpl$method_info$addSubjectName$24c38f207fc9ceab, &&label0);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(111);				// 0
	r3 = _JC_REF_FIELD(env, r0, gnu_java_security_x509_X509CertSelectorImpl, subjectNames);
	r2 = _JC_NEW(env, gnu_java_security_x509_X500DistinguishedName);
	_JC_INVOKE_NONVIRTUAL(env, gnu_java_security_x509_X500DistinguishedName, _init$52f4ad9f2989aeee, 0, r2);
	_JC_TRAP_REGION(catch, 1);
	_JC_INVOKE_NONVIRTUAL(env, gnu_java_security_x509_X500DistinguishedName, parseString$c5fa011525652d61, 0, r2, r1);
	_JC_TRAP_REGION(catch, 2);
	goto label1;

label0:
	_JC_TRAP_REGION(catch, 2);
	r5 = _JC_CAUGHT_EXCEPTION(env);
	r6 = _JC_NEW(env, java_lang_IllegalArgumentException);
	r4 = _JC_INVOKE_VIRTUAL(env, java_lang_Throwable, toString$7ea43b33b80a3070, r5);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, cause) = r6;
	r8 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r6);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, vmState) = r8;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, detailMessage) = r4;
	_JC_THROW(env, r6);

label1:
	_JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0x831f06ee5f59c0cc), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r2);
	_JC_LINE_NUMBER(112);				// 1
	_JC_CANCEL_TRAPS(env, catch);
	return;
}

//
// public void addSubjectName(java.security.Principal) throws java.io.IOException
//

static _jc_linenum _jc_gnu_java_security_x509_X509CertSelectorImpl$linenum_table$addSubjectName$32b1ca46fe872f2e[];

static _jc_trap_info _jc_gnu_java_security_x509_X509CertSelectorImpl$trap_table$addSubjectName$32b1ca46fe872f2e[] = {
	_JC_TRAP(&_jc_java_io_IOException$type, 1, 2),
};

static const unsigned char _jc_gnu_java_security_x509_X509CertSelectorImpl$param_ptypes$addSubjectName$32b1ca46fe872f2e[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_gnu_java_security_x509_X509CertSelectorImpl$exceptions$addSubjectName$32b1ca46fe872f2e[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_gnu_java_security_x509_X509CertSelectorImpl$param_types$addSubjectName$32b1ca46fe872f2e[] = {
	&_jc_java_security_Principal$type
};

_jc_method _jc_gnu_java_security_x509_X509CertSelectorImpl$method_info$addSubjectName$32b1ca46fe872f2e = {
	.name=			"addSubjectName",
	.signature=		"(Ljava/security/Principal;)V",
	.class=			&_jc_gnu_java_security_x509_X509CertSelectorImpl$type,
	.param_types=		&_jc_gnu_java_security_x509_X509CertSelectorImpl$param_types$addSubjectName$32b1ca46fe872f2e,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_x509_X509CertSelectorImpl$param_ptypes$addSubjectName$32b1ca46fe872f2e,
	.signature_hash=	_JC_JLONG(0x32b1ca46fe872f2e),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_x509_X509CertSelectorImpl$method$addSubjectName$32b1ca46fe872f2e,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_x509_X509CertSelectorImpl$vtable, gnu_java_security_x509_X509CertSelectorImpl.addSubjectName$32b1ca46fe872f2e) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_gnu_java_security_x509_X509CertSelectorImpl$exceptions$addSubjectName$32b1ca46fe872f2e,
	.u= { .exec= {
	  .trap_table_len=	1,
	  .trap_table=		_jc_gnu_java_security_x509_X509CertSelectorImpl$trap_table$addSubjectName$32b1ca46fe872f2e,
	  .u= {
	    .linenum= {
	      .len=	6,
	      .table=	_jc_gnu_java_security_x509_X509CertSelectorImpl$linenum_table$addSubjectName$32b1ca46fe872f2e
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_x509_X509CertSelectorImpl, addSubjectName$32b1ca46fe872f2e);

void _JC_JCNI_ATTR
_jc_gnu_java_security_x509_X509CertSelectorImpl$method$addSubjectName$32b1ca46fe872f2e(_jc_env *const env, _jc_gnu_java_security_x509_X509CertSelectorImpl$object *this, _jc_object *param0)
{
	jint i0;
	struct _jc_gnu_java_security_x509_X509CertSelectorImpl$object *r0;
	struct _jc_object *r1;
	struct _jc_java_lang_String$object *volatile r10;
	struct _jc_java_io_IOException$object *volatile r11;
	struct _jc_java_lang_IllegalArgumentException$object *volatile r12;
	struct _jc_java_lang_VMThrowable$object *volatile r14;
	struct _jc_object *r2;
	struct _jc_gnu_java_security_x509_X500DistinguishedName$object *r3;
	struct _jc_javax_security_auth_x500_X500Principal$object *r4;
	struct _jc_java_lang_String$object *r5;
	struct _jc_gnu_java_security_der_DERReader$object *r6;
	struct _jc_java_io_ByteArrayInputStream$object *r7;
	_jc_byte_array *r8;
	struct _jc_java_lang_Object$object *r9;
	jboolean z0;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_gnu_java_security_x509_X509CertSelectorImpl$method_info$addSubjectName$32b1ca46fe872f2e, &&label3);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(116);				// 0
	z0 = _JC_INSTANCEOF(env, r1, &_jc_gnu_java_security_x509_X500DistinguishedName$type);
	if (z0 == 0)
		goto label0;
	_JC_LINE_NUMBER(117);				// 1
	r2 = _JC_REF_FIELD(env, r0, gnu_java_security_x509_X509CertSelectorImpl, subjectNames);
	_JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0x831f06ee5f59c0cc), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r1);
	goto label5;

label0:
	_JC_LINE_NUMBER(118);				// 2
	z0 = _JC_INSTANCEOF_FINAL(env, r1, &_jc_javax_security_auth_x500_X500Principal$type);
	if (z0 == 0)
		goto label2;
	_JC_LINE_NUMBER(119);				// 3
	r2 = _JC_REF_FIELD(env, r0, gnu_java_security_x509_X509CertSelectorImpl, subjectNames);
	r3 = _JC_NEW(env, gnu_java_security_x509_X500DistinguishedName);
	r4 = r1;
	_JC_EXPLICIT_NULL_CHECK(env, r4);
	r8 = _JC_REF_FIELD(env, r4, javax_security_auth_x500_X500Principal, encoded);
	if (r8 != _JC_NULL)
		goto label1;
	_JC_INVOKE_NONVIRTUAL(env, javax_security_auth_x500_X500Principal, encodeDer$5b724e00f84e3391, 0, r4);

label1:
	r8 = _JC_REF_FIELD(env, r4, javax_security_auth_x500_X500Principal, encoded);
	r9 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, clone$b75f2713d6705f70, r8);
	r8 = _JC_CAST_FINAL(env, &_jc_byte$array$prim$type, r9);
	_JC_INVOKE_NONVIRTUAL(env, gnu_java_security_x509_X500DistinguishedName, _init$52f4ad9f2989aeee, 0, r3);
	r6 = _JC_NEW(env, gnu_java_security_der_DERReader);
	r7 = _JC_NEW(env, java_io_ByteArrayInputStream);
	i0 = _JC_ARRAY_LENGTH(env, r8);
	_JC_INVOKE_NONVIRTUAL(env, java_io_ByteArrayInputStream, _init$4ff4a7925ef7b06c, 0, r7, r8, 0, i0);
	_JC_INVOKE_NONVIRTUAL(env, gnu_java_security_der_DERReader, _init$3887600c17c5e554, 0, r6, r7);
	_JC_INVOKE_NONVIRTUAL(env, gnu_java_security_x509_X500DistinguishedName, parseDer$0657069246be78d9, 0, r3, r6);
	_JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0x831f06ee5f59c0cc), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r3);
	goto label5;

label2:
	_JC_LINE_NUMBER(121);				// 4
	r2 = _JC_REF_FIELD(env, r0, gnu_java_security_x509_X509CertSelectorImpl, subjectNames);
	r3 = _JC_NEW(env, gnu_java_security_x509_X500DistinguishedName);
	r5 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0xbec186f2ce7e1882), _jc_object *, (_jc_env *, struct _jc_object *));
	_JC_INVOKE_NONVIRTUAL(env, gnu_java_security_x509_X500DistinguishedName, _init$52f4ad9f2989aeee, 0, r3);
	_JC_TRAP_REGION(catch, 1);
	_JC_INVOKE_NONVIRTUAL(env, gnu_java_security_x509_X500DistinguishedName, parseString$c5fa011525652d61, 0, r3, r5);
	_JC_TRAP_REGION(catch, 2);
	goto label4;

label3:
	_JC_TRAP_REGION(catch, 2);
	r11 = _JC_CAUGHT_EXCEPTION(env);
	r12 = _JC_NEW(env, java_lang_IllegalArgumentException);
	r10 = _JC_INVOKE_VIRTUAL(env, java_lang_Throwable, toString$7ea43b33b80a3070, r11);
	_JC_REF_FIELD(env, r12, java_lang_Throwable, cause) = r12;
	r14 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r12);
	_JC_REF_FIELD(env, r12, java_lang_Throwable, vmState) = r14;
	_JC_REF_FIELD(env, r12, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r12, java_lang_Throwable, detailMessage) = r10;
	_JC_THROW(env, r12);

label4:
	_JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0x831f06ee5f59c0cc), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r3);

label5:
	_JC_TRAP_REGION(catch, 2);
	_JC_LINE_NUMBER(122);				// 5
	_JC_CANCEL_TRAPS(env, catch);
	return;
}

//
// public void addSubjectName(byte[]) throws java.io.IOException
//

static _jc_linenum _jc_gnu_java_security_x509_X509CertSelectorImpl$linenum_table$addSubjectName$e6e7b8a14b4c34a2[];

static const unsigned char _jc_gnu_java_security_x509_X509CertSelectorImpl$param_ptypes$addSubjectName$e6e7b8a14b4c34a2[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_gnu_java_security_x509_X509CertSelectorImpl$exceptions$addSubjectName$e6e7b8a14b4c34a2[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_gnu_java_security_x509_X509CertSelectorImpl$param_types$addSubjectName$e6e7b8a14b4c34a2[] = {
	&_jc_byte$array$prim$type
};

_jc_method _jc_gnu_java_security_x509_X509CertSelectorImpl$method_info$addSubjectName$e6e7b8a14b4c34a2 = {
	.name=			"addSubjectName",
	.signature=		"([B)V",
	.class=			&_jc_gnu_java_security_x509_X509CertSelectorImpl$type,
	.param_types=		&_jc_gnu_java_security_x509_X509CertSelectorImpl$param_types$addSubjectName$e6e7b8a14b4c34a2,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_x509_X509CertSelectorImpl$param_ptypes$addSubjectName$e6e7b8a14b4c34a2,
	.signature_hash=	_JC_JLONG(0xe6e7b8a14b4c34a2),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_x509_X509CertSelectorImpl$method$addSubjectName$e6e7b8a14b4c34a2,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_x509_X509CertSelectorImpl$vtable, gnu_java_security_x509_X509CertSelectorImpl.addSubjectName$e6e7b8a14b4c34a2) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_gnu_java_security_x509_X509CertSelectorImpl$exceptions$addSubjectName$e6e7b8a14b4c34a2,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_gnu_java_security_x509_X509CertSelectorImpl$linenum_table$addSubjectName$e6e7b8a14b4c34a2
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_x509_X509CertSelectorImpl, addSubjectName$e6e7b8a14b4c34a2);

void _JC_JCNI_ATTR
_jc_gnu_java_security_x509_X509CertSelectorImpl$method$addSubjectName$e6e7b8a14b4c34a2(_jc_env *const env, _jc_gnu_java_security_x509_X509CertSelectorImpl$object *this, _jc_byte_array *param0)
{
	jint i0;
	struct _jc_gnu_java_security_x509_X509CertSelectorImpl$object *r0;
	_jc_byte_array *r1;
	struct _jc_gnu_java_security_x509_X500DistinguishedName$object *r2;
	struct _jc_object *r3;
	struct _jc_gnu_java_security_der_DERReader$object *r4;
	struct _jc_java_io_ByteArrayInputStream$object *r5;
	struct _jc_java_util_LinkedList$object *r6;
	struct _jc_java_util_LinkedHashMap$object *r7;
	struct _jc_object *r8;
	struct _jc_object *r9;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(106);				// 0
	r3 = _JC_REF_FIELD(env, r0, gnu_java_security_x509_X509CertSelectorImpl, subjectNames);
	r2 = _JC_NEW(env, gnu_java_security_x509_X500DistinguishedName);
	r6 = _JC_NEW(env, java_util_LinkedList);
	_JC_PRIM_FIELD(env, r6, java_util_LinkedList, size) = 0;
	_JC_REF_FIELD(env, r2, gnu_java_security_x509_X500DistinguishedName, components) = r6;
	r7 = _JC_NEW(env, java_util_LinkedHashMap);
	_JC_INVOKE_NONVIRTUAL(env, java_util_HashMap, _init$7cb044ce4fb0ada8, 0, r7, 11, _JC_FCONST(0x3f, 0x40, 0x0, 0x0));
	_JC_PRIM_FIELD(env, r7, java_util_LinkedHashMap, accessOrder) = 0;
	_JC_REF_FIELD(env, r2, gnu_java_security_x509_X500DistinguishedName, currentRdn) = r7;
	r8 = _JC_REF_FIELD(env, r2, gnu_java_security_x509_X500DistinguishedName, components);
	r9 = _JC_REF_FIELD(env, r2, gnu_java_security_x509_X500DistinguishedName, currentRdn);
	_JC_INVOKE_INTERFACE(env, r8, _JC_JLONG(0x831f06ee5f59c0cc), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r9);
	r4 = _JC_NEW(env, gnu_java_security_der_DERReader);
	r5 = _JC_NEW(env, java_io_ByteArrayInputStream);
	i0 = _JC_ARRAY_LENGTH(env, r1);
	_JC_INVOKE_NONVIRTUAL(env, java_io_ByteArrayInputStream, _init$4ff4a7925ef7b06c, 0, r5, r1, 0, i0);
	_JC_INVOKE_NONVIRTUAL(env, gnu_java_security_der_DERReader, _init$3887600c17c5e554, 0, r4, r5);
	_JC_INVOKE_NONVIRTUAL(env, gnu_java_security_x509_X500DistinguishedName, parseDer$0657069246be78d9, 0, r2, r4);
	_JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0x831f06ee5f59c0cc), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r2);
	_JC_LINE_NUMBER(107);				// 1
	return;
}

//
// public java.lang.Object clone()
//

static _jc_linenum _jc_gnu_java_security_x509_X509CertSelectorImpl$linenum_table$clone$b75f2713d6705f70[];

static const unsigned char _jc_gnu_java_security_x509_X509CertSelectorImpl$param_ptypes$clone$b75f2713d6705f70[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_gnu_java_security_x509_X509CertSelectorImpl$method_info$clone$b75f2713d6705f70 = {
	.name=			"clone",
	.signature=		"()Ljava/lang/Object;",
	.class=			&_jc_gnu_java_security_x509_X509CertSelectorImpl$type,
	.return_type=		&_jc_java_lang_Object$type,
	.param_ptypes=		&_jc_gnu_java_security_x509_X509CertSelectorImpl$param_ptypes$clone$b75f2713d6705f70,
	.signature_hash=	_JC_JLONG(0xb75f2713d6705f70),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_x509_X509CertSelectorImpl$method$clone$b75f2713d6705f70,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_x509_X509CertSelectorImpl$vtable, gnu_java_security_x509_X509CertSelectorImpl.clone$b75f2713d6705f70) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_gnu_java_security_x509_X509CertSelectorImpl$linenum_table$clone$b75f2713d6705f70
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_x509_X509CertSelectorImpl, clone$b75f2713d6705f70);

_jc_java_lang_Object$object * _JC_JCNI_ATTR
_jc_gnu_java_security_x509_X509CertSelectorImpl$method$clone$b75f2713d6705f70(_jc_env *const env, _jc_gnu_java_security_x509_X509CertSelectorImpl$object *this)
{
	struct _jc_gnu_java_security_x509_X509CertSelectorImpl$object *r0;
	struct _jc_gnu_java_security_x509_X509CertSelectorImpl$object *r1;
	struct _jc_object *r2;
	struct _jc_object *r3;
	struct _jc_java_util_HashSet$object *r4;
	struct _jc_java_util_HashMap$object *r5;
	struct _jc_java_util_HashMap$object *r8;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(131);				// 0
	r1 = _JC_NEW(env, gnu_java_security_x509_X509CertSelectorImpl);
	r4 = _JC_NEW(env, java_util_HashSet);
	r5 = _JC_NEW(env, java_util_HashMap);
	_JC_INVOKE_NONVIRTUAL(env, java_util_HashMap, _init$7cb044ce4fb0ada8, 0, r5, 11, _JC_FCONST(0x3f, 0x40, 0x0, 0x0));
	_JC_REF_FIELD(env, r4, java_util_HashSet, map) = r5;
	_JC_REF_FIELD(env, r1, gnu_java_security_x509_X509CertSelectorImpl, issuerNames) = r4;
	r4 = _JC_NEW(env, java_util_HashSet);
	r8 = _JC_NEW(env, java_util_HashMap);
	_JC_INVOKE_NONVIRTUAL(env, java_util_HashMap, _init$7cb044ce4fb0ada8, 0, r8, 11, _JC_FCONST(0x3f, 0x40, 0x0, 0x0));
	_JC_REF_FIELD(env, r4, java_util_HashSet, map) = r8;
	_JC_REF_FIELD(env, r1, gnu_java_security_x509_X509CertSelectorImpl, subjectNames) = r4;
	_JC_LINE_NUMBER(132);				// 1
	r2 = _JC_REF_FIELD(env, r1, gnu_java_security_x509_X509CertSelectorImpl, issuerNames);
	r3 = _JC_REF_FIELD(env, r0, gnu_java_security_x509_X509CertSelectorImpl, issuerNames);
	_JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0x77406cdf3002027f), jboolean, (_jc_env *, struct _jc_object *, struct _jc_object *), r3);
	_JC_LINE_NUMBER(133);				// 2
	r3 = _JC_REF_FIELD(env, r1, gnu_java_security_x509_X509CertSelectorImpl, subjectNames);
	r2 = _JC_REF_FIELD(env, r0, gnu_java_security_x509_X509CertSelectorImpl, subjectNames);
	_JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0x77406cdf3002027f), jboolean, (_jc_env *, struct _jc_object *, struct _jc_object *), r2);
	_JC_LINE_NUMBER(134);				// 3
	return r1;
}

//
// public java.util.Collection getIssuerNames()
//

static _jc_linenum _jc_gnu_java_security_x509_X509CertSelectorImpl$linenum_table$getIssuerNames$d08100b1b6e4c03b[];

static const unsigned char _jc_gnu_java_security_x509_X509CertSelectorImpl$param_ptypes$getIssuerNames$d08100b1b6e4c03b[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_gnu_java_security_x509_X509CertSelectorImpl$method_info$getIssuerNames$d08100b1b6e4c03b = {
	.name=			"getIssuerNames",
	.signature=		"()Ljava/util/Collection;",
	.class=			&_jc_gnu_java_security_x509_X509CertSelectorImpl$type,
	.return_type=		&_jc_java_util_Collection$type,
	.param_ptypes=		&_jc_gnu_java_security_x509_X509CertSelectorImpl$param_ptypes$getIssuerNames$d08100b1b6e4c03b,
	.signature_hash=	_JC_JLONG(0xd08100b1b6e4c03b),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_x509_X509CertSelectorImpl$method$getIssuerNames$d08100b1b6e4c03b,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_x509_X509CertSelectorImpl$vtable, gnu_java_security_x509_X509CertSelectorImpl.getIssuerNames$d08100b1b6e4c03b) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_gnu_java_security_x509_X509CertSelectorImpl$linenum_table$getIssuerNames$d08100b1b6e4c03b
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_x509_X509CertSelectorImpl, getIssuerNames$d08100b1b6e4c03b);

_jc_object * _JC_JCNI_ATTR
_jc_gnu_java_security_x509_X509CertSelectorImpl$method$getIssuerNames$d08100b1b6e4c03b(_jc_env *const env, _jc_gnu_java_security_x509_X509CertSelectorImpl$object *this)
{
	struct _jc_gnu_java_security_x509_X509CertSelectorImpl$object *r0;
	struct _jc_object *r1;
	struct _jc_java_util_Collections__24UnmodifiableSet$object *r2;
	struct _jc_java_lang_NullPointerException$object *r3;
	struct _jc_java_lang_String$object *r4;
	struct _jc_java_lang_VMThrowable$object *r6;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(101);				// 0
	r1 = _JC_REF_FIELD(env, r0, gnu_java_security_x509_X509CertSelectorImpl, issuerNames);
	_JC_ACTIVE_USE(env, java_util_Collections);
	r2 = _JC_NEW(env, java_util_Collections__24UnmodifiableSet);
	_JC_REF_FIELD(env, r2, java_util_Collections__24UnmodifiableCollection, c) = r1;
	if (r1 != _JC_NULL)
		goto label0;
	r3 = _JC_NEW(env, java_lang_NullPointerException);
	r4 = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r6 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r6;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r4;
	_JC_THROW(env, r3);

label0:
	return r2;
}

//
// public java.util.Collection getSubjectNames()
//

static _jc_linenum _jc_gnu_java_security_x509_X509CertSelectorImpl$linenum_table$getSubjectNames$a3d0bd7ae907a713[];

static const unsigned char _jc_gnu_java_security_x509_X509CertSelectorImpl$param_ptypes$getSubjectNames$a3d0bd7ae907a713[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_gnu_java_security_x509_X509CertSelectorImpl$method_info$getSubjectNames$a3d0bd7ae907a713 = {
	.name=			"getSubjectNames",
	.signature=		"()Ljava/util/Collection;",
	.class=			&_jc_gnu_java_security_x509_X509CertSelectorImpl$type,
	.return_type=		&_jc_java_util_Collection$type,
	.param_ptypes=		&_jc_gnu_java_security_x509_X509CertSelectorImpl$param_ptypes$getSubjectNames$a3d0bd7ae907a713,
	.signature_hash=	_JC_JLONG(0xa3d0bd7ae907a713),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_x509_X509CertSelectorImpl$method$getSubjectNames$a3d0bd7ae907a713,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_x509_X509CertSelectorImpl$vtable, gnu_java_security_x509_X509CertSelectorImpl.getSubjectNames$a3d0bd7ae907a713) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_gnu_java_security_x509_X509CertSelectorImpl$linenum_table$getSubjectNames$a3d0bd7ae907a713
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_x509_X509CertSelectorImpl, getSubjectNames$a3d0bd7ae907a713);

_jc_object * _JC_JCNI_ATTR
_jc_gnu_java_security_x509_X509CertSelectorImpl$method$getSubjectNames$a3d0bd7ae907a713(_jc_env *const env, _jc_gnu_java_security_x509_X509CertSelectorImpl$object *this)
{
	struct _jc_gnu_java_security_x509_X509CertSelectorImpl$object *r0;
	struct _jc_object *r1;
	struct _jc_java_util_Collections__24UnmodifiableSet$object *r2;
	struct _jc_java_lang_NullPointerException$object *r3;
	struct _jc_java_lang_String$object *r4;
	struct _jc_java_lang_VMThrowable$object *r6;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(126);				// 0
	r1 = _JC_REF_FIELD(env, r0, gnu_java_security_x509_X509CertSelectorImpl, subjectNames);
	_JC_ACTIVE_USE(env, java_util_Collections);
	r2 = _JC_NEW(env, java_util_Collections__24UnmodifiableSet);
	_JC_REF_FIELD(env, r2, java_util_Collections__24UnmodifiableCollection, c) = r1;
	if (r1 != _JC_NULL)
		goto label0;
	r3 = _JC_NEW(env, java_lang_NullPointerException);
	r4 = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r6 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r6;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r4;
	_JC_THROW(env, r3);

label0:
	return r2;
}

//
// public boolean match(java.security.cert.Certificate)
//

static _jc_linenum _jc_gnu_java_security_x509_X509CertSelectorImpl$linenum_table$match$301cccc2252a47d2[];

static _jc_trap_info _jc_gnu_java_security_x509_X509CertSelectorImpl$trap_table$match$301cccc2252a47d2[] = {
	_JC_TRAP(&_jc_java_io_IOException$type, 4, 5),
	_JC_TRAP(&_jc_java_io_IOException$type, 2, 3),
	_JC_TRAP(&_jc_java_lang_Exception$type, 1, 6),
};

static const unsigned char _jc_gnu_java_security_x509_X509CertSelectorImpl$param_ptypes$match$301cccc2252a47d2[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_gnu_java_security_x509_X509CertSelectorImpl$param_types$match$301cccc2252a47d2[] = {
	&_jc_java_security_cert_Certificate$type
};

_jc_method _jc_gnu_java_security_x509_X509CertSelectorImpl$method_info$match$301cccc2252a47d2 = {
	.name=			"match",
	.signature=		"(Ljava/security/cert/Certificate;)Z",
	.class=			&_jc_gnu_java_security_x509_X509CertSelectorImpl$type,
	.param_types=		&_jc_gnu_java_security_x509_X509CertSelectorImpl$param_types$match$301cccc2252a47d2,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_x509_X509CertSelectorImpl$param_ptypes$match$301cccc2252a47d2,
	.signature_hash=	_JC_JLONG(0x301cccc2252a47d2),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_x509_X509CertSelectorImpl$method$match$301cccc2252a47d2,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_x509_X509CertSelectorImpl$vtable, gnu_java_security_x509_X509CertSelectorImpl.match$301cccc2252a47d2) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .trap_table_len=	3,
	  .trap_table=		_jc_gnu_java_security_x509_X509CertSelectorImpl$trap_table$match$301cccc2252a47d2,
	  .u= {
	    .linenum= {
	      .len=	33,
	      .table=	_jc_gnu_java_security_x509_X509CertSelectorImpl$linenum_table$match$301cccc2252a47d2
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_x509_X509CertSelectorImpl, match$301cccc2252a47d2);

jboolean _JC_JCNI_ATTR
_jc_gnu_java_security_x509_X509CertSelectorImpl$method$match$301cccc2252a47d2(_jc_env *const env, _jc_gnu_java_security_x509_X509CertSelectorImpl$object *this, _jc_java_security_cert_Certificate$object *param0)
{
	jint i0;
	jint i1;
	struct _jc_gnu_java_security_x509_X509CertSelectorImpl$object *r0;
	struct _jc_java_security_cert_Certificate$object *r1;
	struct _jc_java_lang_Object$object *r10;
	struct _jc_java_lang_Exception$object *r11;
	struct _jc_gnu_java_security_der_DERReader$object *r12;
	struct _jc_java_io_ByteArrayInputStream$object *r13;
	struct _jc_gnu_java_security_der_DERReader$object *r14;
	struct _jc_java_io_ByteArrayInputStream$object *r15;
	struct _jc_javax_security_auth_x500_X500Principal$object *r16;
	_jc_byte_array *r17;
	struct _jc_java_lang_Object$object *r18;
	struct _jc_javax_security_auth_x500_X500Principal$object *r19;
	struct _jc_object *r2;
	_jc_byte_array *r20;
	struct _jc_java_lang_Object$object *r21;
	struct _jc_java_lang_String$object *volatile r22;
	struct _jc_java_io_IOException$object *volatile r23;
	struct _jc_java_lang_IllegalArgumentException$object *volatile r24;
	struct _jc_java_lang_VMThrowable$object *volatile r25;
	struct _jc_java_lang_String$object *volatile r26;
	struct _jc_java_io_IOException$object *volatile r27;
	struct _jc_java_lang_IllegalArgumentException$object *volatile r28;
	struct _jc_java_lang_VMThrowable$object *volatile r29;
	struct _jc_object *r3;
	struct _jc_java_util_LinkedList$object *r30;
	struct _jc_java_util_LinkedHashMap$object *r31;
	struct _jc_object *r32;
	struct _jc_object *r33;
	struct _jc_java_util_LinkedList$object *r34;
	struct _jc_java_util_LinkedHashMap$object *r35;
	struct _jc_object *r36;
	struct _jc_object *r37;
	struct _jc_java_util_LinkedList$object *r38;
	struct _jc_java_util_LinkedHashMap$object *r39;
	struct _jc_gnu_java_security_x509_X500DistinguishedName$object *r4;
	struct _jc_object *r40;
	struct _jc_object *r41;
	struct _jc_java_util_LinkedList$object *r42;
	struct _jc_java_util_LinkedHashMap$object *r43;
	struct _jc_object *r44;
	struct _jc_object *r45;
	struct _jc_java_io_ByteArrayOutputStream$object *r46;
	_jc_byte_array *r47;
	struct _jc_java_io_ByteArrayOutputStream$object *r48;
	_jc_byte_array *r49;
	struct _jc_java_security_cert_X509Certificate$object *r5;
	struct _jc_gnu_java_security_x509_X500DistinguishedName$object *r6;
	struct _jc_javax_security_auth_x500_X500Principal$object *r7;
	struct _jc_java_lang_String$object *r8;
	struct _jc_object *r9;
	jboolean volatile z0;
	jboolean volatile z1;
	jboolean volatile z2;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_gnu_java_security_x509_X509CertSelectorImpl$method_info$match$301cccc2252a47d2, &&label13, &&label4, &&label18);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(139);				// 0
	z1 = _JC_INSTANCEOF(env, r1, &_jc_java_security_cert_X509Certificate$type);
	if (z1 != 0)
		goto label0;
	_JC_LINE_NUMBER(140);				// 1
	_JC_CANCEL_TRAPS(env, catch);
	return 0;

label0:
	_JC_LINE_NUMBER(141);				// 2
	z0 = 0;
	_JC_LINE_NUMBER(142);				// 3
	z1 = 0;
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(145);				// 4
	r5 = r1;
	r2 = _JC_INVOKE_VIRTUAL(env, java_security_cert_X509Certificate, getIssuerDN$2337371bab9e73a2, r5);
	_JC_LINE_NUMBER(147);				// 5
	z2 = _JC_INSTANCEOF(env, r2, &_jc_gnu_java_security_x509_X500DistinguishedName$type);
	if (z2 == 0)
		goto label1;
	_JC_LINE_NUMBER(148);				// 6
	r6 = r2;
	goto label5;

label1:
	_JC_LINE_NUMBER(149);				// 7
	z2 = _JC_INSTANCEOF_FINAL(env, r2, &_jc_javax_security_auth_x500_X500Principal$type);
	if (z2 == 0)
		goto label3;
	_JC_LINE_NUMBER(150);				// 8
	r6 = _JC_NEW(env, gnu_java_security_x509_X500DistinguishedName);
	r7 = r2;
	_JC_EXPLICIT_NULL_CHECK(env, r7);
	r16 = r7;
	r17 = _JC_REF_FIELD(env, r7, javax_security_auth_x500_X500Principal, encoded);
	if (r17 != _JC_NULL)
		goto label2;
	_JC_INVOKE_NONVIRTUAL(env, javax_security_auth_x500_X500Principal, encodeDer$5b724e00f84e3391, 0, r7);

label2:
	r17 = _JC_REF_FIELD(env, r16, javax_security_auth_x500_X500Principal, encoded);
	r18 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, clone$b75f2713d6705f70, r17);
	r17 = _JC_CAST_FINAL(env, &_jc_byte$array$prim$type, r18);
	r30 = _JC_NEW(env, java_util_LinkedList);
	_JC_PRIM_FIELD(env, r30, java_util_LinkedList, size) = 0;
	_JC_REF_FIELD(env, r6, gnu_java_security_x509_X500DistinguishedName, components) = r30;
	r31 = _JC_NEW(env, java_util_LinkedHashMap);
	_JC_INVOKE_NONVIRTUAL(env, java_util_HashMap, _init$7cb044ce4fb0ada8, 0, r31, 11, _JC_FCONST(0x3f, 0x40, 0x0, 0x0));
	_JC_PRIM_FIELD(env, r31, java_util_LinkedHashMap, accessOrder) = 0;
	_JC_REF_FIELD(env, r6, gnu_java_security_x509_X500DistinguishedName, currentRdn) = r31;
	r32 = _JC_REF_FIELD(env, r6, gnu_java_security_x509_X500DistinguishedName, components);
	r33 = _JC_REF_FIELD(env, r6, gnu_java_security_x509_X500DistinguishedName, currentRdn);
	_JC_INVOKE_INTERFACE(env, r32, _JC_JLONG(0x831f06ee5f59c0cc), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r33);
	r12 = _JC_NEW(env, gnu_java_security_der_DERReader);
	r13 = _JC_NEW(env, java_io_ByteArrayInputStream);
	i0 = _JC_ARRAY_LENGTH(env, r17);
	_JC_INVOKE_NONVIRTUAL(env, java_io_ByteArrayInputStream, _init$4ff4a7925ef7b06c, 0, r13, r17, 0, i0);
	_JC_REF_FIELD(env, r12, gnu_java_security_der_DERReader, in) = r13;
	r46 = _JC_NEW(env, java_io_ByteArrayOutputStream);
	r47 = _JC_NEW_PRIM_ARRAY(env, byte, 1, 2048);
	_JC_REF_FIELD(env, r46, java_io_ByteArrayOutputStream, buf) = r47;
	_JC_PRIM_FIELD(env, r46, java_io_ByteArrayOutputStream, count) = 0;
	_JC_REF_FIELD(env, r12, gnu_java_security_der_DERReader, encBuf) = r46;
	_JC_INVOKE_NONVIRTUAL(env, gnu_java_security_x509_X500DistinguishedName, parseDer$0657069246be78d9, 0, r6, r12);
	goto label5;

label3:
	_JC_LINE_NUMBER(152);				// 9
	r6 = _JC_NEW(env, gnu_java_security_x509_X500DistinguishedName);
	r8 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0xbec186f2ce7e1882), _jc_object *, (_jc_env *, struct _jc_object *));
	r34 = _JC_NEW(env, java_util_LinkedList);
	_JC_PRIM_FIELD(env, r34, java_util_LinkedList, size) = 0;
	_JC_REF_FIELD(env, r6, gnu_java_security_x509_X500DistinguishedName, components) = r34;
	r35 = _JC_NEW(env, java_util_LinkedHashMap);
	_JC_INVOKE_NONVIRTUAL(env, java_util_HashMap, _init$7cb044ce4fb0ada8, 0, r35, 11, _JC_FCONST(0x3f, 0x40, 0x0, 0x0));
	_JC_PRIM_FIELD(env, r35, java_util_LinkedHashMap, accessOrder) = 0;
	_JC_REF_FIELD(env, r6, gnu_java_security_x509_X500DistinguishedName, currentRdn) = r35;
	r36 = _JC_REF_FIELD(env, r6, gnu_java_security_x509_X500DistinguishedName, components);
	r37 = _JC_REF_FIELD(env, r6, gnu_java_security_x509_X500DistinguishedName, currentRdn);
	_JC_INVOKE_INTERFACE(env, r36, _JC_JLONG(0x831f06ee5f59c0cc), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r37);
	_JC_TRAP_REGION(catch, 2);
	_JC_INVOKE_NONVIRTUAL(env, gnu_java_security_x509_X500DistinguishedName, parseString$c5fa011525652d61, 0, r6, r8);
	_JC_TRAP_REGION(catch, 3);
	goto label5;

label4:
	_JC_TRAP_REGION(catch, 3);
	r23 = _JC_CAUGHT_EXCEPTION(env);
	r24 = _JC_NEW(env, java_lang_IllegalArgumentException);
	r22 = _JC_INVOKE_VIRTUAL(env, java_lang_Throwable, toString$7ea43b33b80a3070, r23);
	_JC_REF_FIELD(env, r24, java_lang_Throwable, cause) = r24;
	r25 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r24);
	_JC_REF_FIELD(env, r24, java_lang_Throwable, vmState) = r25;
	_JC_REF_FIELD(env, r24, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r24, java_lang_Throwable, detailMessage) = r22;
	_JC_THROW(env, r24);

label5:
	_JC_TRAP_REGION(catch, 3);
	_JC_LINE_NUMBER(153);				// 10
	r9 = _JC_REF_FIELD(env, r0, gnu_java_security_x509_X509CertSelectorImpl, issuerNames);
	z2 = _JC_INVOKE_INTERFACE(env, r9, _JC_JLONG(0x551bea84f4e0f0cb), jboolean, (_jc_env *, struct _jc_object *));
	if (z2 == 0)
		goto label6;
	_JC_LINE_NUMBER(154);				// 11
	z0 = 1;
	goto label9;

label6:
	_JC_LINE_NUMBER(157);				// 12
	r9 = _JC_REF_FIELD(env, r0, gnu_java_security_x509_X509CertSelectorImpl, issuerNames);
	r3 = _JC_INVOKE_INTERFACE(env, r9, _JC_JLONG(0x3cc91493d50f531c), _jc_object *, (_jc_env *, struct _jc_object *));
	goto label8;

label7:
	_JC_LINE_NUMBER(159);				// 13
	r10 = _JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0x5874f79a1cf66ea), _jc_object *, (_jc_env *, struct _jc_object *));
	r4 = _JC_CAST(env, &_jc_gnu_java_security_x509_X500DistinguishedName$type, r10);
	_JC_LINE_NUMBER(160);				// 14
	z2 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_x509_X500DistinguishedName, equals$8a15e0625571c581, r6, r4);
	if (z2 == 0)
		goto label8;
	_JC_LINE_NUMBER(162);				// 15
	z0 = 1;
	_JC_LINE_NUMBER(163);				// 16
	goto label9;

label8:
	_JC_LINE_NUMBER(157);				// 17
	z2 = _JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0xfb0bd5e38c59ddcd), jboolean, (_jc_env *, struct _jc_object *));
	if (z2 != 0) {
		_JC_PERIODIC_CHECK(env);
		goto label7;
	}

label9:
	_JC_LINE_NUMBER(168);				// 18
	r5 = r1;
	r2 = _JC_INVOKE_VIRTUAL(env, java_security_cert_X509Certificate, getSubjectDN$6df6a2af6ec26b33, r5);
	_JC_LINE_NUMBER(170);				// 19
	z2 = _JC_INSTANCEOF(env, r2, &_jc_gnu_java_security_x509_X500DistinguishedName$type);
	if (z2 == 0)
		goto label10;
	_JC_LINE_NUMBER(171);				// 20
	r6 = r2;
	goto label14;

label10:
	_JC_LINE_NUMBER(172);				// 21
	z2 = _JC_INSTANCEOF_FINAL(env, r2, &_jc_javax_security_auth_x500_X500Principal$type);
	if (z2 == 0)
		goto label12;
	_JC_LINE_NUMBER(173);				// 22
	r6 = _JC_NEW(env, gnu_java_security_x509_X500DistinguishedName);
	r7 = r2;
	_JC_EXPLICIT_NULL_CHECK(env, r7);
	r19 = r7;
	r20 = _JC_REF_FIELD(env, r7, javax_security_auth_x500_X500Principal, encoded);
	if (r20 != _JC_NULL)
		goto label11;
	_JC_INVOKE_NONVIRTUAL(env, javax_security_auth_x500_X500Principal, encodeDer$5b724e00f84e3391, 0, r7);

label11:
	r20 = _JC_REF_FIELD(env, r19, javax_security_auth_x500_X500Principal, encoded);
	r21 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, clone$b75f2713d6705f70, r20);
	r20 = _JC_CAST_FINAL(env, &_jc_byte$array$prim$type, r21);
	r38 = _JC_NEW(env, java_util_LinkedList);
	_JC_PRIM_FIELD(env, r38, java_util_LinkedList, size) = 0;
	_JC_REF_FIELD(env, r6, gnu_java_security_x509_X500DistinguishedName, components) = r38;
	r39 = _JC_NEW(env, java_util_LinkedHashMap);
	_JC_INVOKE_NONVIRTUAL(env, java_util_HashMap, _init$7cb044ce4fb0ada8, 0, r39, 11, _JC_FCONST(0x3f, 0x40, 0x0, 0x0));
	_JC_PRIM_FIELD(env, r39, java_util_LinkedHashMap, accessOrder) = 0;
	_JC_REF_FIELD(env, r6, gnu_java_security_x509_X500DistinguishedName, currentRdn) = r39;
	r40 = _JC_REF_FIELD(env, r6, gnu_java_security_x509_X500DistinguishedName, components);
	r41 = _JC_REF_FIELD(env, r6, gnu_java_security_x509_X500DistinguishedName, currentRdn);
	_JC_INVOKE_INTERFACE(env, r40, _JC_JLONG(0x831f06ee5f59c0cc), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r41);
	r14 = _JC_NEW(env, gnu_java_security_der_DERReader);
	r15 = _JC_NEW(env, java_io_ByteArrayInputStream);
	i1 = _JC_ARRAY_LENGTH(env, r20);
	_JC_INVOKE_NONVIRTUAL(env, java_io_ByteArrayInputStream, _init$4ff4a7925ef7b06c, 0, r15, r20, 0, i1);
	_JC_REF_FIELD(env, r14, gnu_java_security_der_DERReader, in) = r15;
	r48 = _JC_NEW(env, java_io_ByteArrayOutputStream);
	r49 = _JC_NEW_PRIM_ARRAY(env, byte, 1, 2048);
	_JC_REF_FIELD(env, r48, java_io_ByteArrayOutputStream, buf) = r49;
	_JC_PRIM_FIELD(env, r48, java_io_ByteArrayOutputStream, count) = 0;
	_JC_REF_FIELD(env, r14, gnu_java_security_der_DERReader, encBuf) = r48;
	_JC_INVOKE_NONVIRTUAL(env, gnu_java_security_x509_X500DistinguishedName, parseDer$0657069246be78d9, 0, r6, r14);
	goto label14;

label12:
	_JC_LINE_NUMBER(175);				// 23
	r6 = _JC_NEW(env, gnu_java_security_x509_X500DistinguishedName);
	r8 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0xbec186f2ce7e1882), _jc_object *, (_jc_env *, struct _jc_object *));
	r42 = _JC_NEW(env, java_util_LinkedList);
	_JC_PRIM_FIELD(env, r42, java_util_LinkedList, size) = 0;
	_JC_REF_FIELD(env, r6, gnu_java_security_x509_X500DistinguishedName, components) = r42;
	r43 = _JC_NEW(env, java_util_LinkedHashMap);
	_JC_INVOKE_NONVIRTUAL(env, java_util_HashMap, _init$7cb044ce4fb0ada8, 0, r43, 11, _JC_FCONST(0x3f, 0x40, 0x0, 0x0));
	_JC_PRIM_FIELD(env, r43, java_util_LinkedHashMap, accessOrder) = 0;
	_JC_REF_FIELD(env, r6, gnu_java_security_x509_X500DistinguishedName, currentRdn) = r43;
	r44 = _JC_REF_FIELD(env, r6, gnu_java_security_x509_X500DistinguishedName, components);
	r45 = _JC_REF_FIELD(env, r6, gnu_java_security_x509_X500DistinguishedName, currentRdn);
	_JC_INVOKE_INTERFACE(env, r44, _JC_JLONG(0x831f06ee5f59c0cc), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r45);
	_JC_TRAP_REGION(catch, 4);
	_JC_INVOKE_NONVIRTUAL(env, gnu_java_security_x509_X500DistinguishedName, parseString$c5fa011525652d61, 0, r6, r8);
	_JC_TRAP_REGION(catch, 5);
	goto label14;

label13:
	_JC_TRAP_REGION(catch, 5);
	r27 = _JC_CAUGHT_EXCEPTION(env);
	r28 = _JC_NEW(env, java_lang_IllegalArgumentException);
	r26 = _JC_INVOKE_VIRTUAL(env, java_lang_Throwable, toString$7ea43b33b80a3070, r27);
	_JC_REF_FIELD(env, r28, java_lang_Throwable, cause) = r28;
	r29 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r28);
	_JC_REF_FIELD(env, r28, java_lang_Throwable, vmState) = r29;
	_JC_REF_FIELD(env, r28, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r28, java_lang_Throwable, detailMessage) = r26;
	_JC_THROW(env, r28);

label14:
	_JC_TRAP_REGION(catch, 5);
	_JC_LINE_NUMBER(176);				// 24
	r9 = _JC_REF_FIELD(env, r0, gnu_java_security_x509_X509CertSelectorImpl, subjectNames);
	z2 = _JC_INVOKE_INTERFACE(env, r9, _JC_JLONG(0x551bea84f4e0f0cb), jboolean, (_jc_env *, struct _jc_object *));
	if (z2 == 0)
		goto label15;
	_JC_LINE_NUMBER(177);				// 25
	z1 = 1;
	goto label19;

label15:
	_JC_LINE_NUMBER(180);				// 26
	r9 = _JC_REF_FIELD(env, r0, gnu_java_security_x509_X509CertSelectorImpl, subjectNames);
	r3 = _JC_INVOKE_INTERFACE(env, r9, _JC_JLONG(0x3cc91493d50f531c), _jc_object *, (_jc_env *, struct _jc_object *));
	goto label17;

label16:
	_JC_LINE_NUMBER(182);				// 27
	r10 = _JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0x5874f79a1cf66ea), _jc_object *, (_jc_env *, struct _jc_object *));
	r4 = _JC_CAST(env, &_jc_gnu_java_security_x509_X500DistinguishedName$type, r10);
	_JC_LINE_NUMBER(183);				// 28
	z2 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_x509_X500DistinguishedName, equals$8a15e0625571c581, r6, r4);
	if (z2 == 0)
		goto label17;
	_JC_LINE_NUMBER(185);				// 29
	z1 = 1;
	_JC_LINE_NUMBER(186);				// 30
	goto label19;

label17:
	_JC_LINE_NUMBER(180);				// 31
	z2 = _JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0xfb0bd5e38c59ddcd), jboolean, (_jc_env *, struct _jc_object *));
	if (z2 != 0) {
		_JC_PERIODIC_CHECK(env);
		goto label16;
	}
	_JC_TRAP_REGION(catch, 6);
	goto label19;

label18:
	_JC_TRAP_REGION(catch, 6);
	r11 = _JC_CAUGHT_EXCEPTION(env);

label19:
	_JC_TRAP_REGION(catch, 6);
	_JC_LINE_NUMBER(194);				// 32
	z2 = 0;
	if (z0 == 0)
		goto label20;
	if (z1 == 0)
		goto label20;
	z2 = 1;

label20:
	_JC_CANCEL_TRAPS(env, catch);
	return z2;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_gnu_java_security_x509_X509CertSelectorImpl$methods[] = {
	&_jc_gnu_java_security_x509_X509CertSelectorImpl$method_info$_init$52f4ad9f2989aeee,
	&_jc_gnu_java_security_x509_X509CertSelectorImpl$method_info$addIssuerName$9da6a33e284f4b22,
	&_jc_gnu_java_security_x509_X509CertSelectorImpl$method_info$addIssuerName$cfee6fa2baca6874,
	&_jc_gnu_java_security_x509_X509CertSelectorImpl$method_info$addIssuerName$1dbd53c377fac209,
	&_jc_gnu_java_security_x509_X509CertSelectorImpl$method_info$addSubjectName$24c38f207fc9ceab,
	&_jc_gnu_java_security_x509_X509CertSelectorImpl$method_info$addSubjectName$32b1ca46fe872f2e,
	&_jc_gnu_java_security_x509_X509CertSelectorImpl$method_info$addSubjectName$e6e7b8a14b4c34a2,
	&_jc_gnu_java_security_x509_X509CertSelectorImpl$method_info$clone$b75f2713d6705f70,
	&_jc_gnu_java_security_x509_X509CertSelectorImpl$method_info$getIssuerNames$d08100b1b6e4c03b,
	&_jc_gnu_java_security_x509_X509CertSelectorImpl$method_info$getSubjectNames$a3d0bd7ae907a713,
	&_jc_gnu_java_security_x509_X509CertSelectorImpl$method_info$match$301cccc2252a47d2
};

/************************************************************************
 *			      Interface list				*
 ************************************************************************/

// Directly implemented interfaces
static _jc_type *const _jc_gnu_java_security_x509_X509CertSelectorImpl$interfaces[] = {
	&_jc_java_security_cert_CertSelector$type
};

/************************************************************************
 *			   Interface hash table				*
 ************************************************************************/

#if _JC_IMETHOD_HASHSIZE != 128
#error "_JC_IMETHOD_HASHSIZE has the wrong value (should be 128)"
#endif

// Interface lookup hash table buckets
static _jc_method *_jc_gnu_java_security_x509_X509CertSelectorImpl$imethod_hash_bucket_82[] = {
	&_jc_gnu_java_security_x509_X509CertSelectorImpl$method_info$match$301cccc2252a47d2,
	_JC_NULL
};
static _jc_method *_jc_gnu_java_security_x509_X509CertSelectorImpl$imethod_hash_bucket_112[] = {
	&_jc_gnu_java_security_x509_X509CertSelectorImpl$method_info$clone$b75f2713d6705f70,
	_JC_NULL
};

// Interface lookup hash table
static _jc_method **_jc_gnu_java_security_x509_X509CertSelectorImpl$imethod_hash_table[_JC_IMETHOD_HASHSIZE] = {
	[82]=	_jc_gnu_java_security_x509_X509CertSelectorImpl$imethod_hash_bucket_82,
	[112]=	_jc_gnu_java_security_x509_X509CertSelectorImpl$imethod_hash_bucket_112
};

// Interface "quick" lookup hash table
static const void *_jc_gnu_java_security_x509_X509CertSelectorImpl$imethod_quick_table[_JC_IMETHOD_HASHSIZE] = {
	[82]=	&_jc_gnu_java_security_x509_X509CertSelectorImpl$method$match$301cccc2252a47d2,
	[112]=	&_jc_gnu_java_security_x509_X509CertSelectorImpl$method$clone$b75f2713d6705f70
};

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_gnu_java_security_x509_X509CertSelectorImpl$instanceof_hash_bucket_19[] = {
	&_jc_java_lang_Cloneable$type,
	_JC_NULL
};
static _jc_type *const _jc_gnu_java_security_x509_X509CertSelectorImpl$instanceof_hash_bucket_98[] = {
	&_jc_gnu_java_security_x509_X509CertSelectorImpl$type,
	_JC_NULL
};
static _jc_type *const _jc_gnu_java_security_x509_X509CertSelectorImpl$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};
static _jc_type *const _jc_gnu_java_security_x509_X509CertSelectorImpl$instanceof_hash_bucket_119[] = {
	&_jc_java_security_cert_CertSelector$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_gnu_java_security_x509_X509CertSelectorImpl$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[19]=	_jc_gnu_java_security_x509_X509CertSelectorImpl$instanceof_hash_bucket_19,
	[98]=	_jc_gnu_java_security_x509_X509CertSelectorImpl$instanceof_hash_bucket_98,
	[101]=	_jc_gnu_java_security_x509_X509CertSelectorImpl$instanceof_hash_bucket_101,
	[119]=	_jc_gnu_java_security_x509_X509CertSelectorImpl$instanceof_hash_bucket_119
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_gnu_java_security_x509_X509CertSelectorImpl$class_depends[] = {
	{ "gnu/java/security/der/DERReader",	_JC_JLONG(0x78ef52e48159b870) },
	{ "gnu/java/security/x509/X500DistinguishedName",	_JC_JLONG(0x420d501e6520fb6c) },
	{ "java/io/ByteArrayInputStream",	_JC_JLONG(0xa68cc27886fd8be3) },
	{ "java/io/ByteArrayOutputStream",	_JC_JLONG(0xc4d3cc2bda03a338) },
	{ "java/io/IOException",	_JC_JLONG(0x4e0a56550c69d57c) },
	{ "java/io/OutputStream",	_JC_JLONG(0x4026d3144d6654d8) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/Cloneable",	_JC_JLONG(0x9b667b09132be893) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/IllegalArgumentException",	_JC_JLONG(0x680cf34d05feb5a1) },
	{ "java/lang/NullPointerException",	_JC_JLONG(0x505b8a9a6675be0) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/RuntimeException",	_JC_JLONG(0x4f5534a987354d1d) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/security/Principal",	_JC_JLONG(0x1ed0accfc254a715) },
	{ "java/security/cert/CertSelector",	_JC_JLONG(0xc7e244007d8c33f7) },
	{ "java/security/cert/Certificate",	_JC_JLONG(0xc98c8192da849b07) },
	{ "java/security/cert/X509Certificate",	_JC_JLONG(0x859e5e5544e5909f) },
	{ "java/util/AbstractCollection",	_JC_JLONG(0x8ea716c64b77f8eb) },
	{ "java/util/AbstractList",	_JC_JLONG(0xf5238436362828db) },
	{ "java/util/AbstractSequentialList",	_JC_JLONG(0x6d7997e879c41059) },
	{ "java/util/AbstractSet",	_JC_JLONG(0xca427569b5b2f804) },
	{ "java/util/Collection",	_JC_JLONG(0xeae4d0c0e8eb63da) },
	{ "java/util/Collections",	_JC_JLONG(0x9574af3fed58029a) },
	{ "java/util/Collections$UnmodifiableCollection",	_JC_JLONG(0x2126b28aee607999) },
	{ "java/util/Collections$UnmodifiableSet",	_JC_JLONG(0xaec2ea3fc69f0e47) },
	{ "java/util/HashMap",	_JC_JLONG(0xd7cd853200c3e71f) },
	{ "java/util/HashSet",	_JC_JLONG(0x3c285c721478414d) },
	{ "java/util/Iterator",	_JC_JLONG(0xbe56ff673eefd9d2) },
	{ "java/util/LinkedHashMap",	_JC_JLONG(0x6e4b267a445acd50) },
	{ "java/util/LinkedList",	_JC_JLONG(0x666417b6279ae396) },
	{ "java/util/List",	_JC_JLONG(0x9ee0d92ce1525a4d) },
	{ "java/util/Map",	_JC_JLONG(0xe283f7c2e7a7979c) },
	{ "java/util/Set",	_JC_JLONG(0x617ac82c0bec2dff) },
	{ "javax/security/auth/x500/X500Principal",	_JC_JLONG(0xb62659fbc202d723) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_gnu_java_security_x509_X509CertSelectorImpl$vtype _jc_gnu_java_security_x509_X509CertSelectorImpl$type = {
    .type= {
	.name=			"gnu/java/security/x509/X509CertSelectorImpl",
	.superclass=		&_jc_java_lang_Object$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.num_interfaces=sizeof(_jc_gnu_java_security_x509_X509CertSelectorImpl$interfaces) / sizeof(*_jc_gnu_java_security_x509_X509CertSelectorImpl$interfaces),
	.interfaces=		_jc_gnu_java_security_x509_X509CertSelectorImpl$interfaces,
	.imethod_hash_table=	_jc_gnu_java_security_x509_X509CertSelectorImpl$imethod_hash_table,
	.imethod_quick_table=	_jc_gnu_java_security_x509_X509CertSelectorImpl$imethod_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		21,
		.hash=			_JC_JLONG(0x27084f8baa8d0062),
		.source_file=		"X509CertSelectorImpl.java",
		.instance_size=		sizeof(_jc_gnu_java_security_x509_X509CertSelectorImpl$refs) + sizeof(_jc_gnu_java_security_x509_X509CertSelectorImpl$object),
		.num_virtual_refs=	2,
		.num_fields=		sizeof(_jc_gnu_java_security_x509_X509CertSelectorImpl$fields) / sizeof(*_jc_gnu_java_security_x509_X509CertSelectorImpl$fields),
		.fields=		_jc_gnu_java_security_x509_X509CertSelectorImpl$fields,
		.num_methods=		sizeof(_jc_gnu_java_security_x509_X509CertSelectorImpl$methods) / sizeof(*_jc_gnu_java_security_x509_X509CertSelectorImpl$methods),
		.methods=		_jc_gnu_java_security_x509_X509CertSelectorImpl$methods,
		.instanceof_hash_table=	_jc_gnu_java_security_x509_X509CertSelectorImpl$instanceof_hash_table,
		.num_class_depends=		sizeof(_jc_gnu_java_security_x509_X509CertSelectorImpl$class_depends) / sizeof(*_jc_gnu_java_security_x509_X509CertSelectorImpl$class_depends),
		.class_depends=		_jc_gnu_java_security_x509_X509CertSelectorImpl$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=			// overridden
		&_jc_gnu_java_security_x509_X509CertSelectorImpl$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.gnu_java_security_x509_X509CertSelectorImpl= {
	    .addIssuerName$9da6a33e284f4b22=
		&_jc_gnu_java_security_x509_X509CertSelectorImpl$method$addIssuerName$9da6a33e284f4b22,
	    .addIssuerName$cfee6fa2baca6874=
		&_jc_gnu_java_security_x509_X509CertSelectorImpl$method$addIssuerName$cfee6fa2baca6874,
	    .addIssuerName$1dbd53c377fac209=
		&_jc_gnu_java_security_x509_X509CertSelectorImpl$method$addIssuerName$1dbd53c377fac209,
	    .addSubjectName$24c38f207fc9ceab=
		&_jc_gnu_java_security_x509_X509CertSelectorImpl$method$addSubjectName$24c38f207fc9ceab,
	    .addSubjectName$32b1ca46fe872f2e=
		&_jc_gnu_java_security_x509_X509CertSelectorImpl$method$addSubjectName$32b1ca46fe872f2e,
	    .addSubjectName$e6e7b8a14b4c34a2=
		&_jc_gnu_java_security_x509_X509CertSelectorImpl$method$addSubjectName$e6e7b8a14b4c34a2,
	    .clone$b75f2713d6705f70=
		&_jc_gnu_java_security_x509_X509CertSelectorImpl$method$clone$b75f2713d6705f70,
	    .getIssuerNames$d08100b1b6e4c03b=
		&_jc_gnu_java_security_x509_X509CertSelectorImpl$method$getIssuerNames$d08100b1b6e4c03b,
	    .getSubjectNames$a3d0bd7ae907a713=
		&_jc_gnu_java_security_x509_X509CertSelectorImpl$method$getSubjectNames$a3d0bd7ae907a713,
	    .match$301cccc2252a47d2=
		&_jc_gnu_java_security_x509_X509CertSelectorImpl$method$match$301cccc2252a47d2,
	},
    }
};

