// class java.awt.LightweightDispatcher

// class file dependencies
// @dep_class c4102ec52a5abad9 java_awt_AWTEvent
// @dep_class 4424790ccb65a0a java_awt_Component
// @dep_class a9ec1dfd683af396 java_awt_Container
// @dep_class 6b950b4cca941574 java_awt_Cursor
// @dep_class 8fe2f569ccf34864 java_awt_LightweightDispatcher
// @dep_class 9b5e01730312f9d6 java_awt_Point
// @dep_class 5b797b166d3f258a java_awt_event_InputEvent
// @dep_class 749c37221149979c java_awt_event_MouseEvent
// @dep_class b85c04b87765b2e8 java_awt_peer_ComponentPeer
// @dep_class 9a35c7173b37e641 java_io_Serializable
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 421bce3cdfe6e543 javax_swing_SwingUtilities

// header file dependencies
// @dep_header java_awt_Container
// @dep_header java_awt_Cursor
// @dep_header java_awt_LightweightDispatcher
// @dep_header java_awt_Point
// @dep_header java_awt_event_MouseEvent
// @dep_header java_awt_peer_ComponentPeer
// @dep_header java_io_Serializable
// @dep_header java_lang_Class
// @dep_header java_lang_String
// @dep_header javax_swing_SwingUtilities

#include "jc_defs.h"

#include "java/awt/Container.h"
#include "java/awt/Cursor.h"
#include "java/awt/LightweightDispatcher.h"
#include "java/awt/Point.h"
#include "java/awt/event/MouseEvent.h"
#include "java/awt/peer/ComponentPeer.h"
#include "java/io/Serializable.h"
#include "java/lang/Class.h"
#include "java/lang/String.h"
#include "javax/swing/SwingUtilities.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// private static final long serialVersionUID
static const jlong _jc_java_awt_LightweightDispatcher$initial_value$serialVersionUID = _JC_JLONG(5184291520170872969);
static _jc_field _jc_java_awt_LightweightDispatcher$field_info$serialVersionUID = {
	.name=		"serialVersionUID",
	.signature=	"J",
	.class=		&_jc_java_awt_LightweightDispatcher$type,
	.type=		&_jc_long$prim$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_java_awt_LightweightDispatcher$fields_struct, serialVersionUID),
	.initial_value=	&_jc_java_awt_LightweightDispatcher$initial_value$serialVersionUID,
};

// private java.awt.Container nativeContainer
static _jc_field _jc_java_awt_LightweightDispatcher$field_info$nativeContainer = {
	.name=		"nativeContainer",
	.signature=	"Ljava/awt/Container;",
	.class=		&_jc_java_awt_LightweightDispatcher$type,
	.type=		&_jc_java_awt_Container$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_awt_LightweightDispatcher$object, refs[-1].java_awt_LightweightDispatcher.nativeContainer),
};

// private java.awt.Cursor nativeCursor
static _jc_field _jc_java_awt_LightweightDispatcher$field_info$nativeCursor = {
	.name=		"nativeCursor",
	.signature=	"Ljava/awt/Cursor;",
	.class=		&_jc_java_awt_LightweightDispatcher$type,
	.type=		&_jc_java_awt_Cursor$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_awt_LightweightDispatcher$object, refs[-1].java_awt_LightweightDispatcher.nativeCursor),
};

// private long eventMask
static _jc_field _jc_java_awt_LightweightDispatcher$field_info$eventMask = {
	.name=		"eventMask",
	.signature=	"J",
	.class=		&_jc_java_awt_LightweightDispatcher$type,
	.type=		&_jc_long$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_awt_LightweightDispatcher$object, nonrefs.java_awt_LightweightDispatcher.eventMask),
};

// private transient java.awt.Component mouseEventTarget
static _jc_field _jc_java_awt_LightweightDispatcher$field_info$mouseEventTarget = {
	.name=		"mouseEventTarget",
	.signature=	"Ljava/awt/Component;",
	.class=		&_jc_java_awt_LightweightDispatcher$type,
	.type=		&_jc_java_awt_Component$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_TRANSIENT,
	.offset=	_JC_OFFSETOF(_jc_java_awt_LightweightDispatcher$object, refs[-1].java_awt_LightweightDispatcher.mouseEventTarget),
};

// private transient java.awt.Component pressedComponent
static _jc_field _jc_java_awt_LightweightDispatcher$field_info$pressedComponent = {
	.name=		"pressedComponent",
	.signature=	"Ljava/awt/Component;",
	.class=		&_jc_java_awt_LightweightDispatcher$type,
	.type=		&_jc_java_awt_Component$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_TRANSIENT,
	.offset=	_JC_OFFSETOF(_jc_java_awt_LightweightDispatcher$object, refs[-1].java_awt_LightweightDispatcher.pressedComponent),
};

// private transient java.awt.Component lastComponentEntered
static _jc_field _jc_java_awt_LightweightDispatcher$field_info$lastComponentEntered = {
	.name=		"lastComponentEntered",
	.signature=	"Ljava/awt/Component;",
	.class=		&_jc_java_awt_LightweightDispatcher$type,
	.type=		&_jc_java_awt_Component$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_TRANSIENT,
	.offset=	_JC_OFFSETOF(_jc_java_awt_LightweightDispatcher$object, refs[-1].java_awt_LightweightDispatcher.lastComponentEntered),
};

// private transient java.awt.Component tempComponent
static _jc_field _jc_java_awt_LightweightDispatcher$field_info$tempComponent = {
	.name=		"tempComponent",
	.signature=	"Ljava/awt/Component;",
	.class=		&_jc_java_awt_LightweightDispatcher$type,
	.type=		&_jc_java_awt_Component$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_TRANSIENT,
	.offset=	_JC_OFFSETOF(_jc_java_awt_LightweightDispatcher$object, refs[-1].java_awt_LightweightDispatcher.tempComponent),
};

// private transient int pressCount
static _jc_field _jc_java_awt_LightweightDispatcher$field_info$pressCount = {
	.name=		"pressCount",
	.signature=	"I",
	.class=		&_jc_java_awt_LightweightDispatcher$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_TRANSIENT,
	.offset=	_JC_OFFSETOF(_jc_java_awt_LightweightDispatcher$object, nonrefs.java_awt_LightweightDispatcher.pressCount),
};

// Fields
static _jc_field *const _jc_java_awt_LightweightDispatcher$fields[] = {
	&_jc_java_awt_LightweightDispatcher$field_info$serialVersionUID,
	&_jc_java_awt_LightweightDispatcher$field_info$lastComponentEntered,
	&_jc_java_awt_LightweightDispatcher$field_info$mouseEventTarget,
	&_jc_java_awt_LightweightDispatcher$field_info$nativeContainer,
	&_jc_java_awt_LightweightDispatcher$field_info$nativeCursor,
	&_jc_java_awt_LightweightDispatcher$field_info$pressedComponent,
	&_jc_java_awt_LightweightDispatcher$field_info$tempComponent,
	&_jc_java_awt_LightweightDispatcher$field_info$eventMask,
	&_jc_java_awt_LightweightDispatcher$field_info$pressCount
};

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// void <init>(java.awt.Container)
//

static _jc_linenum _jc_java_awt_LightweightDispatcher$linenum_table$_init$a6b38a8e4e977d83[];

static const unsigned char _jc_java_awt_LightweightDispatcher$param_ptypes$_init$a6b38a8e4e977d83[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_awt_LightweightDispatcher$param_types$_init$a6b38a8e4e977d83[] = {
	&_jc_java_awt_Container$type
};

_jc_method _jc_java_awt_LightweightDispatcher$method_info$_init$a6b38a8e4e977d83 = {
	.name=			"<init>",
	.signature=		"(Ljava/awt/Container;)V",
	.class=			&_jc_java_awt_LightweightDispatcher$type,
	.param_types=		&_jc_java_awt_LightweightDispatcher$param_types$_init$a6b38a8e4e977d83,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_awt_LightweightDispatcher$param_ptypes$_init$a6b38a8e4e977d83,
	.signature_hash=	_JC_JLONG(0xa6b38a8e4e977d83),
	.access_flags=		0,
	.function=		&_jc_java_awt_LightweightDispatcher$method$_init$a6b38a8e4e977d83,
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_awt_LightweightDispatcher$linenum_table$_init$a6b38a8e4e977d83
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_awt_LightweightDispatcher, _init$a6b38a8e4e977d83);

void _JC_JCNI_ATTR
_jc_java_awt_LightweightDispatcher$method$_init$a6b38a8e4e977d83(_jc_env *const env, _jc_java_awt_LightweightDispatcher$object *this, _jc_java_awt_Container$object *param0)
{
	struct _jc_java_awt_LightweightDispatcher$object *r0;
	struct _jc_java_awt_Container$object *r1;

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(1881);				// 0
	_JC_REF_FIELD(env, r0, java_awt_LightweightDispatcher, nativeContainer) = r1;
	_JC_LINE_NUMBER(1882);				// 1
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// void acquireComponentForMouseEvent(java.awt.event.MouseEvent)
//

static _jc_linenum _jc_java_awt_LightweightDispatcher$linenum_table$acquireComponentForMouseEvent$7263a11f36ae7acd[];

static const unsigned char _jc_java_awt_LightweightDispatcher$param_ptypes$acquireComponentForMouseEvent$7263a11f36ae7acd[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_awt_LightweightDispatcher$param_types$acquireComponentForMouseEvent$7263a11f36ae7acd[] = {
	&_jc_java_awt_event_MouseEvent$type
};

_jc_method _jc_java_awt_LightweightDispatcher$method_info$acquireComponentForMouseEvent$7263a11f36ae7acd = {
	.name=			"acquireComponentForMouseEvent",
	.signature=		"(Ljava/awt/event/MouseEvent;)V",
	.class=			&_jc_java_awt_LightweightDispatcher$type,
	.param_types=		&_jc_java_awt_LightweightDispatcher$param_types$acquireComponentForMouseEvent$7263a11f36ae7acd,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_awt_LightweightDispatcher$param_ptypes$acquireComponentForMouseEvent$7263a11f36ae7acd,
	.signature_hash=	_JC_JLONG(0x7263a11f36ae7acd),
	.access_flags=		0,
	.function=		&_jc_java_awt_LightweightDispatcher$method$acquireComponentForMouseEvent$7263a11f36ae7acd,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_awt_LightweightDispatcher$vtable, java_awt_LightweightDispatcher.acquireComponentForMouseEvent$7263a11f36ae7acd) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	38,
	      .table=	_jc_java_awt_LightweightDispatcher$linenum_table$acquireComponentForMouseEvent$7263a11f36ae7acd
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_awt_LightweightDispatcher, acquireComponentForMouseEvent$7263a11f36ae7acd);

void _JC_JCNI_ATTR
_jc_java_awt_LightweightDispatcher$method$acquireComponentForMouseEvent$7263a11f36ae7acd(_jc_env *const env, _jc_java_awt_LightweightDispatcher$object *this, _jc_java_awt_event_MouseEvent$object *param0)
{
	jbyte b6;
	jint i0;
	jint i1;
	jint i2;
	jint i3;
	jint i7;
	jint i8;
	jint i9;
	jlong l4;
	jlong l5;
	struct _jc_java_awt_LightweightDispatcher$object *r0;
	struct _jc_java_awt_event_MouseEvent$object *r1;
	struct _jc_java_awt_Component$object *r10;
	struct _jc_java_awt_Component$object *r11;
	struct _jc_object *r12;
	struct _jc_object *r13;
	struct _jc_java_awt_Component$object *r14;
	struct _jc_java_awt_Container$object *r15;
	struct _jc_java_awt_Container$object *r2;
	struct _jc_java_awt_Component$object *r3;
	struct _jc_java_awt_Point$object *r4;
	struct _jc_java_awt_event_MouseEvent$object *r5;
	struct _jc_java_awt_Container$object *r6;
	struct _jc_java_awt_Component$object *r7;
	struct _jc_java_awt_Component$object *r8;
	struct _jc_java_awt_Component$object *r9;
	jboolean z0;
	jboolean z1;
	jboolean z2;
	jboolean z3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(1886);				// 0
	i0 = _JC_INVOKE_VIRTUAL(env, java_awt_event_MouseEvent, getX$95f81a17f95fa138, r1);
	_JC_LINE_NUMBER(1887);				// 1
	i1 = _JC_INVOKE_VIRTUAL(env, java_awt_event_MouseEvent, getY$848e5d443e3420a7, r1);
	_JC_LINE_NUMBER(1890);				// 2
	r2 = _JC_REF_FIELD(env, r0, java_awt_LightweightDispatcher, nativeContainer);
	_JC_LINE_NUMBER(1891);				// 3
	r3 = _JC_NULL;
	_JC_LINE_NUMBER(1892);				// 4
	r4 = _JC_INVOKE_VIRTUAL(env, java_awt_event_MouseEvent, getPoint$2b27e97e4e2dc494, r1);
	_JC_LINE_NUMBER(1893);				// 5
	goto label6;

label0:
	_JC_LINE_NUMBER(1895);				// 6
	i2 = _JC_PRIM_FIELD(env, r4, java_awt_Point, x);
	i3 = _JC_PRIM_FIELD(env, r4, java_awt_Point, y);
	_JC_ACTIVE_USE(env, javax_swing_SwingUtilities);
	if (r2 == _JC_NULL)
		goto label1;
	z3 = _JC_INVOKE_VIRTUAL(env, java_awt_Component, contains$f53ba8d4dfbc6b2f, r2, i2, i3);
	if (z3 != 0)
		goto label2;

label1:
	r3 = _JC_NULL;
	goto label4;

label2:
	z3 = _JC_INSTANCEOF(env, r2, &_jc_java_awt_Container$type);
	if (z3 != 0)
		goto label3;
	r3 = r2;
	goto label4;

label3:
	r15 = r2;
	r14 = _JC_INVOKE_VIRTUAL(env, java_awt_Container, findComponentAt$24bae73073774705, r15, i2, i3);
	r3 = r14;

label4:
	_JC_LINE_NUMBER(1897);				// 7
	if (r3 == _JC_NULL)
		goto label5;
	l4 = _JC_PRIM_FIELD(env, r3, java_awt_Component, eventMask);
	i3 = _JC_INVOKE_VIRTUAL(env, java_awt_AWTEvent, getID$c4aaaa21bd3c4612, r1);
	l5 = (jlong)i3;
	l5 = l4 & l5;
	b6 = _JC_LCMP(l5, _JC_JLONG(0));
	if (b6 != 0)
		goto label6;

label5:
	_JC_LINE_NUMBER(1899);				// 8
	r3 = _JC_NULL;
	_JC_LINE_NUMBER(1900);				// 9
	i3 = _JC_PRIM_FIELD(env, r4, java_awt_Point, x);
	i2 = _JC_PRIM_FIELD(env, r4, java_awt_Point, y);
	r6 = _JC_REF_FIELD(env, r2, java_awt_Component, parent);
	r4 = _JC_INVOKE_STATIC(env, javax_swing_SwingUtilities, convertPoint$8e4157e2e7332999, 1, r2, i3, i2, r6);
	_JC_LINE_NUMBER(1901);				// 10
	r2 = _JC_REF_FIELD(env, r2, java_awt_Component, parent);

label6:
	_JC_LINE_NUMBER(1893);				// 11
	if (r3 != _JC_NULL)
		goto label7;
	if (r2 != _JC_NULL) {
		_JC_PERIODIC_CHECK(env);
		goto label0;
	}

label7:
	_JC_LINE_NUMBER(1908);				// 12
	r6 = _JC_REF_FIELD(env, r0, java_awt_LightweightDispatcher, nativeContainer);
	if (r3 != r6)
		goto label8;
	_JC_LINE_NUMBER(1909);				// 13
	r3 = _JC_NULL;

label8:
	_JC_LINE_NUMBER(1912);				// 14
	r7 = _JC_REF_FIELD(env, r0, java_awt_LightweightDispatcher, lastComponentEntered);
	if (r7 == _JC_NULL)
		goto label15;
	r7 = _JC_REF_FIELD(env, r0, java_awt_LightweightDispatcher, lastComponentEntered);
	z0 = _JC_INVOKE_VIRTUAL(env, java_awt_Component, isShowing$87487545423a6e74, r7);
	if (z0 == 0)
		goto label15;
	r7 = _JC_REF_FIELD(env, r0, java_awt_LightweightDispatcher, lastComponentEntered);
	if (r7 == r3)
		goto label15;
	_JC_LINE_NUMBER(1918);				// 15
	r7 = _JC_REF_FIELD(env, r0, java_awt_LightweightDispatcher, lastComponentEntered);
	r6 = _JC_REF_FIELD(env, r0, java_awt_LightweightDispatcher, nativeContainer);
	_JC_ACTIVE_USE(env, javax_swing_SwingUtilities);
	r8 = r7;
	r9 = r6;

label9:
	if (r8 == _JC_NULL)
		goto label10;
	if (r9 != _JC_NULL)
		goto label11;

label10:
	z0 = 0;
	goto label13;

label11:
	if (r8 != r9)
		goto label12;
	z0 = 1;
	goto label13;

label12:
	r8 = _JC_INVOKE_VIRTUAL(env, java_awt_Component, getParent$82b78e533907fda5, r8);
	_JC_PERIODIC_CHECK(env);
	goto label9;

label13:
	if (z0 == 0)
		goto label14;
	_JC_LINE_NUMBER(1920);				// 16
	r6 = _JC_REF_FIELD(env, r0, java_awt_LightweightDispatcher, nativeContainer);
	r7 = _JC_REF_FIELD(env, r0, java_awt_LightweightDispatcher, lastComponentEntered);
	r4 = _JC_INVOKE_STATIC(env, javax_swing_SwingUtilities, convertPoint$8e4157e2e7332999, 0, r6, i0, i1, r7);
	_JC_LINE_NUMBER(1923);				// 17
	r5 = _JC_NEW(env, java_awt_event_MouseEvent);
	r7 = _JC_REF_FIELD(env, r0, java_awt_LightweightDispatcher, lastComponentEntered);
	l5 = _JC_INVOKE_VIRTUAL(env, java_awt_event_InputEvent, getWhen$3d8a46a7284dd8d9, r1);
	i3 = _JC_INVOKE_VIRTUAL(env, java_awt_event_InputEvent, getModifiersEx$af0cff90b6920cc8, r1);
	i2 = _JC_PRIM_FIELD(env, r4, java_awt_Point, x);
	i7 = _JC_PRIM_FIELD(env, r4, java_awt_Point, y);
	i8 = _JC_INVOKE_VIRTUAL(env, java_awt_event_MouseEvent, getClickCount$ecb090aca5be7402, r1);
	z0 = _JC_INVOKE_VIRTUAL(env, java_awt_event_MouseEvent, isPopupTrigger$7b1b0f7b8df40097, r1);
	i9 = _JC_INVOKE_VIRTUAL(env, java_awt_event_MouseEvent, getButton$e6a3d03528081a15, r1);
	_JC_INVOKE_NONVIRTUAL(env, java_awt_event_MouseEvent, _init$a87a8bf16ac0c0ff, 0, r5, r7, 505, l5, i3, i2, i7, i8, z0, i9);
	_JC_LINE_NUMBER(1931);				// 18
	r7 = _JC_REF_FIELD(env, r0, java_awt_LightweightDispatcher, lastComponentEntered);
	_JC_REF_FIELD(env, r0, java_awt_LightweightDispatcher, tempComponent) = r7;
	_JC_LINE_NUMBER(1932);				// 19
	_JC_REF_FIELD(env, r0, java_awt_LightweightDispatcher, lastComponentEntered) = _JC_NULL;
	_JC_LINE_NUMBER(1933);				// 20
	r7 = _JC_REF_FIELD(env, r0, java_awt_LightweightDispatcher, tempComponent);
	_JC_EXPLICIT_NULL_CHECK(env, r7);
	_JC_INVOKE_VIRTUAL(env, java_awt_Component, dispatchEventImpl$e1efca98a5741948, r7, r5);
	r12 = _JC_REF_FIELD(env, r7, java_awt_Component, peer);
	if (r12 == _JC_NULL)
		goto label14;
	z1 = _JC_PRIM_FIELD(env, r5, java_awt_AWTEvent, consumed);
	if (z1 != 0)
		goto label14;
	r12 = _JC_REF_FIELD(env, r7, java_awt_Component, peer);
	_JC_INVOKE_INTERFACE(env, r12, _JC_JLONG(0xdb0e2e7973f3405e), void, (_jc_env *, struct _jc_object *, struct _jc_java_awt_AWTEvent$object *), r5);

label14:
	_JC_LINE_NUMBER(1935);				// 21
	_JC_REF_FIELD(env, r0, java_awt_LightweightDispatcher, lastComponentEntered) = _JC_NULL;

label15:
	_JC_LINE_NUMBER(1938);				// 22
	if (r3 == _JC_NULL)
		goto label16;
	_JC_LINE_NUMBER(1940);				// 23
	_JC_REF_FIELD(env, r0, java_awt_LightweightDispatcher, mouseEventTarget) = r3;
	_JC_LINE_NUMBER(1941);				// 24
	z0 = _JC_INVOKE_VIRTUAL(env, java_awt_Component, isLightweight$d6be6d1f4c3614d7, r3);
	if (z0 == 0)
		goto label16;
	z0 = _JC_INVOKE_VIRTUAL(env, java_awt_Component, isShowing$87487545423a6e74, r3);
	if (z0 == 0)
		goto label16;
	r6 = _JC_REF_FIELD(env, r0, java_awt_LightweightDispatcher, nativeContainer);
	if (r3 == r6)
		goto label16;
	r7 = _JC_REF_FIELD(env, r0, java_awt_LightweightDispatcher, lastComponentEntered);
	if (r3 == r7)
		goto label16;
	_JC_LINE_NUMBER(1946);				// 25
	r7 = _JC_REF_FIELD(env, r0, java_awt_LightweightDispatcher, mouseEventTarget);
	_JC_REF_FIELD(env, r0, java_awt_LightweightDispatcher, lastComponentEntered) = r7;
	_JC_LINE_NUMBER(1947);				// 26
	r6 = _JC_REF_FIELD(env, r0, java_awt_LightweightDispatcher, nativeContainer);
	r7 = _JC_REF_FIELD(env, r0, java_awt_LightweightDispatcher, lastComponentEntered);
	r4 = _JC_INVOKE_STATIC(env, javax_swing_SwingUtilities, convertPoint$8e4157e2e7332999, 0, r6, i0, i1, r7);
	_JC_LINE_NUMBER(1949);				// 27
	r5 = _JC_NEW(env, java_awt_event_MouseEvent);
	r7 = _JC_REF_FIELD(env, r0, java_awt_LightweightDispatcher, lastComponentEntered);
	l5 = _JC_INVOKE_VIRTUAL(env, java_awt_event_InputEvent, getWhen$3d8a46a7284dd8d9, r1);
	i9 = _JC_INVOKE_VIRTUAL(env, java_awt_event_InputEvent, getModifiersEx$af0cff90b6920cc8, r1);
	i8 = _JC_PRIM_FIELD(env, r4, java_awt_Point, x);
	i7 = _JC_PRIM_FIELD(env, r4, java_awt_Point, y);
	i3 = _JC_INVOKE_VIRTUAL(env, java_awt_event_MouseEvent, getClickCount$ecb090aca5be7402, r1);
	z0 = _JC_INVOKE_VIRTUAL(env, java_awt_event_MouseEvent, isPopupTrigger$7b1b0f7b8df40097, r1);
	i2 = _JC_INVOKE_VIRTUAL(env, java_awt_event_MouseEvent, getButton$e6a3d03528081a15, r1);
	_JC_INVOKE_NONVIRTUAL(env, java_awt_event_MouseEvent, _init$a87a8bf16ac0c0ff, 0, r5, r7, 504, l5, i9, i8, i7, i3, z0, i2);
	_JC_LINE_NUMBER(1957);				// 28
	r7 = _JC_REF_FIELD(env, r0, java_awt_LightweightDispatcher, lastComponentEntered);
	_JC_EXPLICIT_NULL_CHECK(env, r7);
	_JC_INVOKE_VIRTUAL(env, java_awt_Component, dispatchEventImpl$e1efca98a5741948, r7, r5);
	r13 = _JC_REF_FIELD(env, r7, java_awt_Component, peer);
	if (r13 == _JC_NULL)
		goto label16;
	z2 = _JC_PRIM_FIELD(env, r5, java_awt_AWTEvent, consumed);
	if (z2 != 0)
		goto label16;
	r13 = _JC_REF_FIELD(env, r7, java_awt_Component, peer);
	_JC_INVOKE_INTERFACE(env, r13, _JC_JLONG(0xdb0e2e7973f3405e), void, (_jc_env *, struct _jc_object *, struct _jc_java_awt_AWTEvent$object *), r5);

label16:
	_JC_LINE_NUMBER(1961);				// 29
	i9 = _JC_INVOKE_VIRTUAL(env, java_awt_AWTEvent, getID$c4aaaa21bd3c4612, r1);
	if (i9 == 502)
		goto label18;
	i9 = _JC_INVOKE_VIRTUAL(env, java_awt_AWTEvent, getID$c4aaaa21bd3c4612, r1);
	if (i9 != 501)
		goto label17;
	i9 = _JC_PRIM_FIELD(env, r0, java_awt_LightweightDispatcher, pressCount);
	if (i9 > 0)
		goto label18;

label17:
	i9 = _JC_INVOKE_VIRTUAL(env, java_awt_AWTEvent, getID$c4aaaa21bd3c4612, r1);
	if (i9 != 506)
		goto label26;

label18:
	_JC_LINE_NUMBER(1970);				// 30
	r7 = _JC_REF_FIELD(env, r0, java_awt_LightweightDispatcher, pressedComponent);
	r6 = _JC_REF_FIELD(env, r0, java_awt_LightweightDispatcher, nativeContainer);
	_JC_ACTIVE_USE(env, javax_swing_SwingUtilities);
	r10 = r7;
	r11 = r6;

label19:
	if (r10 == _JC_NULL)
		goto label20;
	if (r11 != _JC_NULL)
		goto label21;

label20:
	z0 = 0;
	goto label23;

label21:
	if (r10 != r11)
		goto label22;
	z0 = 1;
	goto label23;

label22:
	r10 = _JC_INVOKE_VIRTUAL(env, java_awt_Component, getParent$82b78e533907fda5, r10);
	_JC_PERIODIC_CHECK(env);
	goto label19;

label23:
	if (z0 == 0)
		goto label24;
	_JC_LINE_NUMBER(1971);				// 31
	r7 = _JC_REF_FIELD(env, r0, java_awt_LightweightDispatcher, pressedComponent);
	_JC_REF_FIELD(env, r0, java_awt_LightweightDispatcher, mouseEventTarget) = r7;
	goto label26;

label24:
	_JC_LINE_NUMBER(1972);				// 32
	i9 = _JC_INVOKE_VIRTUAL(env, java_awt_AWTEvent, getID$c4aaaa21bd3c4612, r1);
	if (i9 != 500)
		goto label26;
	_JC_LINE_NUMBER(1976);				// 33
	r7 = _JC_REF_FIELD(env, r0, java_awt_LightweightDispatcher, pressedComponent);
	if (r3 == r7)
		goto label25;
	_JC_LINE_NUMBER(1977);				// 34
	_JC_REF_FIELD(env, r0, java_awt_LightweightDispatcher, mouseEventTarget) = _JC_NULL;
	goto label26;

label25:
	_JC_LINE_NUMBER(1978);				// 35
	i9 = _JC_PRIM_FIELD(env, r0, java_awt_LightweightDispatcher, pressCount);
	if (i9 != 0)
		goto label26;
	_JC_LINE_NUMBER(1979);				// 36
	_JC_REF_FIELD(env, r0, java_awt_LightweightDispatcher, pressedComponent) = _JC_NULL;

label26:
	_JC_LINE_NUMBER(1981);				// 37
	return;
}

//
// boolean handleEvent(java.awt.AWTEvent)
//

static _jc_linenum _jc_java_awt_LightweightDispatcher$linenum_table$handleEvent$46affa8d19c0137d[];

static const unsigned char _jc_java_awt_LightweightDispatcher$param_ptypes$handleEvent$46affa8d19c0137d[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_java_awt_LightweightDispatcher$param_types$handleEvent$46affa8d19c0137d[] = {
	&_jc_java_awt_AWTEvent$type
};

_jc_method _jc_java_awt_LightweightDispatcher$method_info$handleEvent$46affa8d19c0137d = {
	.name=			"handleEvent",
	.signature=		"(Ljava/awt/AWTEvent;)Z",
	.class=			&_jc_java_awt_LightweightDispatcher$type,
	.param_types=		&_jc_java_awt_LightweightDispatcher$param_types$handleEvent$46affa8d19c0137d,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_java_awt_LightweightDispatcher$param_ptypes$handleEvent$46affa8d19c0137d,
	.signature_hash=	_JC_JLONG(0x46affa8d19c0137d),
	.access_flags=		0,
	.function=		&_jc_java_awt_LightweightDispatcher$method$handleEvent$46affa8d19c0137d,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_awt_LightweightDispatcher$vtable, java_awt_LightweightDispatcher.handleEvent$46affa8d19c0137d) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	15,
	      .table=	_jc_java_awt_LightweightDispatcher$linenum_table$handleEvent$46affa8d19c0137d
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_awt_LightweightDispatcher, handleEvent$46affa8d19c0137d);

jboolean _JC_JCNI_ATTR
_jc_java_awt_LightweightDispatcher$method$handleEvent$46affa8d19c0137d(_jc_env *const env, _jc_java_awt_LightweightDispatcher$object *this, _jc_java_awt_AWTEvent$object *param0)
{
	jint i0;
	jint i1;
	struct _jc_java_awt_LightweightDispatcher$object *r0;
	struct _jc_java_awt_AWTEvent$object *r1;
	struct _jc_java_awt_event_MouseEvent$object *r2;
	struct _jc_java_awt_Component$object *r3;
	struct _jc_java_awt_Container$object *r4;
	struct _jc_java_awt_Component$object *r5;
	struct _jc_object *r8;
	jboolean z0;
	jboolean z1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(1985);				// 0
	z0 = _JC_INSTANCEOF(env, r1, &_jc_java_awt_event_MouseEvent$type);
	if (z0 == 0)
		goto label4;
	_JC_LINE_NUMBER(1987);				// 1
	r2 = r1;
	_JC_LINE_NUMBER(1989);				// 2
	_JC_INVOKE_VIRTUAL(env, java_awt_LightweightDispatcher, acquireComponentForMouseEvent$7263a11f36ae7acd, r0, r2);
	_JC_LINE_NUMBER(1992);				// 3
	r3 = _JC_REF_FIELD(env, r0, java_awt_LightweightDispatcher, mouseEventTarget);
	if (r3 == _JC_NULL)
		goto label4;
	r3 = _JC_REF_FIELD(env, r0, java_awt_LightweightDispatcher, mouseEventTarget);
	z0 = _JC_INVOKE_VIRTUAL(env, java_awt_Component, isShowing$87487545423a6e74, r3);
	if (z0 == 0)
		goto label4;
	i0 = _JC_INVOKE_VIRTUAL(env, java_awt_AWTEvent, getID$c4aaaa21bd3c4612, r1);
	if (i0 == 504)
		goto label4;
	i0 = _JC_INVOKE_VIRTUAL(env, java_awt_AWTEvent, getID$c4aaaa21bd3c4612, r1);
	if (i0 == 505)
		goto label4;
	_JC_LINE_NUMBER(1997);				// 4
	r4 = _JC_REF_FIELD(env, r0, java_awt_LightweightDispatcher, nativeContainer);
	r3 = _JC_REF_FIELD(env, r0, java_awt_LightweightDispatcher, mouseEventTarget);
	r2 = _JC_INVOKE_STATIC(env, javax_swing_SwingUtilities, convertMouseEvent$3faab491db29b2e8, 0, r4, r2, r3);
	_JC_LINE_NUMBER(2000);				// 5
	r3 = _JC_REF_FIELD(env, r0, java_awt_LightweightDispatcher, mouseEventTarget);
	_JC_EXPLICIT_NULL_CHECK(env, r3);
	_JC_INVOKE_VIRTUAL(env, java_awt_Component, dispatchEventImpl$e1efca98a5741948, r3, r2);
	r8 = _JC_REF_FIELD(env, r3, java_awt_Component, peer);
	if (r8 == _JC_NULL)
		goto label0;
	z1 = _JC_PRIM_FIELD(env, r2, java_awt_AWTEvent, consumed);
	if (z1 != 0)
		goto label0;
	r8 = _JC_REF_FIELD(env, r3, java_awt_Component, peer);
	_JC_INVOKE_INTERFACE(env, r8, _JC_JLONG(0xdb0e2e7973f3405e), void, (_jc_env *, struct _jc_object *, struct _jc_java_awt_AWTEvent$object *), r2);

label0:
	_JC_LINE_NUMBER(2002);				// 6
	i0 = _JC_INVOKE_VIRTUAL(env, java_awt_AWTEvent, getID$c4aaaa21bd3c4612, r1);
	switch (i0) {
	case 501:
		goto label1;
	case 502:
		goto label2;
	default:
		goto label3;
	}

label1:
	_JC_LINE_NUMBER(2005);				// 7
	i0 = _JC_PRIM_FIELD(env, r0, java_awt_LightweightDispatcher, pressCount);
	i1 = i0 + 1;
	_JC_PRIM_FIELD(env, r0, java_awt_LightweightDispatcher, pressCount) = i1;
	if (i0 != 0)
		goto label3;
	_JC_LINE_NUMBER(2006);				// 8
	r3 = _JC_REF_FIELD(env, r0, java_awt_LightweightDispatcher, mouseEventTarget);
	_JC_REF_FIELD(env, r0, java_awt_LightweightDispatcher, pressedComponent) = r3;
	_JC_LINE_NUMBER(2007);				// 9
	goto label3;

label2:
	_JC_LINE_NUMBER(2013);				// 10
	i1 = _JC_PRIM_FIELD(env, r0, java_awt_LightweightDispatcher, pressCount);
	i1 = i1 - 1;
	_JC_PRIM_FIELD(env, r0, java_awt_LightweightDispatcher, pressCount) = i1;
	if (i1 != 0)
		goto label3;
	r3 = _JC_REF_FIELD(env, r0, java_awt_LightweightDispatcher, mouseEventTarget);
	r5 = _JC_REF_FIELD(env, r0, java_awt_LightweightDispatcher, pressedComponent);
	if (r3 == r5)
		goto label3;
	_JC_LINE_NUMBER(2015);				// 11
	_JC_REF_FIELD(env, r0, java_awt_LightweightDispatcher, pressedComponent) = _JC_NULL;

label3:
	_JC_LINE_NUMBER(2018);				// 12
	z0 = _JC_INVOKE_VIRTUAL(env, java_awt_event_InputEvent, isConsumed$98f8b0828fdde4a0, r2);
	if (z0 == 0)
		goto label4;
	_JC_LINE_NUMBER(2019);				// 13
	_JC_INVOKE_VIRTUAL(env, java_awt_AWTEvent, consume$3d554af5733d9795, r1);

label4:
	_JC_LINE_NUMBER(2023);				// 14
	z0 = _JC_INVOKE_VIRTUAL(env, java_awt_AWTEvent, isConsumed$98f8b0828fdde4a0, r1);
	return z0;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_java_awt_LightweightDispatcher$methods[] = {
	&_jc_java_awt_LightweightDispatcher$method_info$_init$a6b38a8e4e977d83,
	&_jc_java_awt_LightweightDispatcher$method_info$acquireComponentForMouseEvent$7263a11f36ae7acd,
	&_jc_java_awt_LightweightDispatcher$method_info$handleEvent$46affa8d19c0137d
};

/************************************************************************
 *			  Class fields structure			*
 ************************************************************************/

_jc_java_awt_LightweightDispatcher$fields_struct _jc_java_awt_LightweightDispatcher$class_fields = { };

/************************************************************************
 *			      Interface list				*
 ************************************************************************/

// Directly implemented interfaces
static _jc_type *const _jc_java_awt_LightweightDispatcher$interfaces[] = {
	&_jc_java_io_Serializable$type
};

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_java_awt_LightweightDispatcher$instanceof_hash_bucket_65[] = {
	&_jc_java_io_Serializable$type,
	_JC_NULL
};
static _jc_type *const _jc_java_awt_LightweightDispatcher$instanceof_hash_bucket_100[] = {
	&_jc_java_awt_LightweightDispatcher$type,
	_JC_NULL
};
static _jc_type *const _jc_java_awt_LightweightDispatcher$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_java_awt_LightweightDispatcher$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[65]=	_jc_java_awt_LightweightDispatcher$instanceof_hash_bucket_65,
	[100]=	_jc_java_awt_LightweightDispatcher$instanceof_hash_bucket_100,
	[101]=	_jc_java_awt_LightweightDispatcher$instanceof_hash_bucket_101
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_java_awt_LightweightDispatcher$class_depends[] = {
	{ "java/awt/AWTEvent",	_JC_JLONG(0xc4102ec52a5abad9) },
	{ "java/awt/Component",	_JC_JLONG(0x4424790ccb65a0a) },
	{ "java/awt/Container",	_JC_JLONG(0xa9ec1dfd683af396) },
	{ "java/awt/Cursor",	_JC_JLONG(0x6b950b4cca941574) },
	{ "java/awt/Point",	_JC_JLONG(0x9b5e01730312f9d6) },
	{ "java/awt/event/InputEvent",	_JC_JLONG(0x5b797b166d3f258a) },
	{ "java/awt/event/MouseEvent",	_JC_JLONG(0x749c37221149979c) },
	{ "java/awt/peer/ComponentPeer",	_JC_JLONG(0xb85c04b87765b2e8) },
	{ "java/io/Serializable",	_JC_JLONG(0x9a35c7173b37e641) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "javax/swing/SwingUtilities",	_JC_JLONG(0x421bce3cdfe6e543) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_java_awt_LightweightDispatcher$vtype _jc_java_awt_LightweightDispatcher$type = {
    .type= {
	.name=			"java/awt/LightweightDispatcher",
	.superclass=		&_jc_java_lang_Object$type,
	.access_flags=		0,
	.flags=			_JC_TYPE_REFERENCE,
	.num_interfaces=sizeof(_jc_java_awt_LightweightDispatcher$interfaces) / sizeof(*_jc_java_awt_LightweightDispatcher$interfaces),
	.interfaces=		_jc_java_awt_LightweightDispatcher$interfaces,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		13,
		.hash=			_JC_JLONG(0x8fe2f569ccf34864),
		.source_file=		"Container.java",
		.instance_size=		sizeof(_jc_java_awt_LightweightDispatcher$refs) + sizeof(_jc_java_awt_LightweightDispatcher$object),
		.num_virtual_refs=	6,
		.num_fields=		sizeof(_jc_java_awt_LightweightDispatcher$fields) / sizeof(*_jc_java_awt_LightweightDispatcher$fields),
		.fields=		_jc_java_awt_LightweightDispatcher$fields,
		.num_methods=		sizeof(_jc_java_awt_LightweightDispatcher$methods) / sizeof(*_jc_java_awt_LightweightDispatcher$methods),
		.methods=		_jc_java_awt_LightweightDispatcher$methods,
		.instanceof_hash_table=	_jc_java_awt_LightweightDispatcher$instanceof_hash_table,
		.class_fields=		&_jc_java_awt_LightweightDispatcher$class_fields,
		.num_class_depends=		sizeof(_jc_java_awt_LightweightDispatcher$class_depends) / sizeof(*_jc_java_awt_LightweightDispatcher$class_depends),
		.class_depends=		_jc_java_awt_LightweightDispatcher$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.java_awt_LightweightDispatcher= {
	    .acquireComponentForMouseEvent$7263a11f36ae7acd=
		&_jc_java_awt_LightweightDispatcher$method$acquireComponentForMouseEvent$7263a11f36ae7acd,
	    .handleEvent$46affa8d19c0137d=
		&_jc_java_awt_LightweightDispatcher$method$handleEvent$46affa8d19c0137d,
	},
    }
};

