// public class java.io.PipedReader

// class file dependencies
// @dep_class 4e0a56550c69d57c java_io_IOException
// @dep_class d6af3ef15ebd119c java_io_InterruptedIOException
// @dep_class 64f43be4fefefe06 java_io_PipedReader
// @dep_class 9164dff74929beb4 java_io_PipedWriter
// @dep_class 688afb20bd4c4e01 java_io_Reader
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class dd778e751571cfa9 java_lang_InterruptedException
// @dep_class 8d71d806a180ad8a java_lang_Math
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 53cc8e2333795f04 java_lang_System
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class 312e45ed214d432f java_lang_VMObject
// @dep_class 4d1cebae0bdda058 java_lang_VMSystem
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable

// header file dependencies
// @dep_header java_io_InterruptedIOException
// @dep_header java_io_PipedReader
// @dep_header java_io_PipedWriter
// @dep_header java_lang_Class
// @dep_header java_lang_InterruptedException
// @dep_header java_lang_Math
// @dep_header java_lang_String
// @dep_header java_lang_System
// @dep_header java_lang_VMObject
// @dep_header java_lang_VMSystem
// @dep_header java_lang_VMThrowable

#include "jc_defs.h"

#include "java/io/InterruptedIOException.h"
#include "java/io/PipedReader.h"
#include "java/io/PipedWriter.h"
#include "java/lang/Class.h"
#include "java/lang/InterruptedException.h"
#include "java/lang/Math.h"
#include "java/lang/String.h"
#include "java/lang/System.h"
#include "java/lang/VMObject.h"
#include "java/lang/VMSystem.h"
#include "java/lang/VMThrowable.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// static final int PIPE_SIZE
static const jint _jc_java_io_PipedReader$initial_value$PIPE__5fSIZE = 2048;
static _jc_field _jc_java_io_PipedReader$field_info$PIPE__5fSIZE = {
	.name=		"PIPE_SIZE",
	.signature=	"I",
	.class=		&_jc_java_io_PipedReader$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_java_io_PipedReader$fields_struct, PIPE__5fSIZE),
	.initial_value=	&_jc_java_io_PipedReader$initial_value$PIPE__5fSIZE,
};

// java.io.PipedWriter source
static _jc_field _jc_java_io_PipedReader$field_info$source = {
	.name=		"source",
	.signature=	"Ljava/io/PipedWriter;",
	.class=		&_jc_java_io_PipedReader$type,
	.type=		&_jc_java_io_PipedWriter$type,
	.access_flags=	0,
	.offset=	_JC_OFFSETOF(_jc_java_io_PipedReader$object, refs[-1].java_io_PipedReader.source),
};

// boolean closed
static _jc_field _jc_java_io_PipedReader$field_info$closed = {
	.name=		"closed",
	.signature=	"Z",
	.class=		&_jc_java_io_PipedReader$type,
	.type=		&_jc_boolean$prim$type,
	.access_flags=	0,
	.offset=	_JC_OFFSETOF(_jc_java_io_PipedReader$object, nonrefs.java_io_PipedReader.closed),
};

// char[] buffer
static _jc_field _jc_java_io_PipedReader$field_info$buffer = {
	.name=		"buffer",
	.signature=	"[C",
	.class=		&_jc_java_io_PipedReader$type,
	.type=		&_jc_char$array$prim$type,
	.access_flags=	0,
	.offset=	_JC_OFFSETOF(_jc_java_io_PipedReader$object, refs[-1].java_io_PipedReader.buffer),
};

// int in
static _jc_field _jc_java_io_PipedReader$field_info$in = {
	.name=		"in",
	.signature=	"I",
	.class=		&_jc_java_io_PipedReader$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	0,
	.offset=	_JC_OFFSETOF(_jc_java_io_PipedReader$object, nonrefs.java_io_PipedReader.in),
};

// int out
static _jc_field _jc_java_io_PipedReader$field_info$out = {
	.name=		"out",
	.signature=	"I",
	.class=		&_jc_java_io_PipedReader$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	0,
	.offset=	_JC_OFFSETOF(_jc_java_io_PipedReader$object, nonrefs.java_io_PipedReader.out),
};

// char[] read_buf
static _jc_field _jc_java_io_PipedReader$field_info$read__5fbuf = {
	.name=		"read_buf",
	.signature=	"[C",
	.class=		&_jc_java_io_PipedReader$type,
	.type=		&_jc_char$array$prim$type,
	.access_flags=	0,
	.offset=	_JC_OFFSETOF(_jc_java_io_PipedReader$object, refs[-1].java_io_PipedReader.read__5fbuf),
};

// Fields
static _jc_field *const _jc_java_io_PipedReader$fields[] = {
	&_jc_java_io_PipedReader$field_info$PIPE__5fSIZE,
	&_jc_java_io_PipedReader$field_info$buffer,
	&_jc_java_io_PipedReader$field_info$read__5fbuf,
	&_jc_java_io_PipedReader$field_info$source,
	&_jc_java_io_PipedReader$field_info$in,
	&_jc_java_io_PipedReader$field_info$out,
	&_jc_java_io_PipedReader$field_info$closed
};

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// public void <init>()
//

static _jc_linenum _jc_java_io_PipedReader$linenum_table$_init$52f4ad9f2989aeee[];

static const unsigned char _jc_java_io_PipedReader$param_ptypes$_init$52f4ad9f2989aeee[] = { 
_JC_TYPE_VOID };

_jc_method _jc_java_io_PipedReader$method_info$_init$52f4ad9f2989aeee = {
	.name=			"<init>",
	.signature=		"()V",
	.class=			&_jc_java_io_PipedReader$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_io_PipedReader$param_ptypes$_init$52f4ad9f2989aeee,
	.signature_hash=	_JC_JLONG(0x52f4ad9f2989aeee),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_io_PipedReader$method$_init$52f4ad9f2989aeee,
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_io_PipedReader$linenum_table$_init$52f4ad9f2989aeee
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_PipedReader, _init$52f4ad9f2989aeee);

void _JC_JCNI_ATTR
_jc_java_io_PipedReader$method$_init$52f4ad9f2989aeee(_jc_env *const env, _jc_java_io_PipedReader$object *this)
{
	struct _jc_java_io_PipedReader$object *r0;
	_jc_char_array *r2;

	r0 = this;
	_JC_REF_FIELD(env, r0, java_io_Reader, lock) = r0;
	r2 = _JC_NEW_PRIM_ARRAY(env, char, 1, 2048);
	_JC_REF_FIELD(env, r0, java_io_PipedReader, buffer) = r2;
	_JC_PRIM_FIELD(env, r0, java_io_PipedReader, in) = -1;
	_JC_PRIM_FIELD(env, r0, java_io_PipedReader, out) = 0;
	r2 = _JC_NEW_PRIM_ARRAY(env, char, 1, 1);
	_JC_REF_FIELD(env, r0, java_io_PipedReader, read__5fbuf) = r2;
	_JC_LINE_NUMBER(104);				// 0
	return;
}

//
// public void <init>(java.io.PipedWriter) throws java.io.IOException
//

static _jc_linenum _jc_java_io_PipedReader$linenum_table$_init$0cb167cb7cfbbc43[];

static const unsigned char _jc_java_io_PipedReader$param_ptypes$_init$0cb167cb7cfbbc43[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_io_PipedReader$exceptions$_init$0cb167cb7cfbbc43[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_java_io_PipedReader$param_types$_init$0cb167cb7cfbbc43[] = {
	&_jc_java_io_PipedWriter$type
};

_jc_method _jc_java_io_PipedReader$method_info$_init$0cb167cb7cfbbc43 = {
	.name=			"<init>",
	.signature=		"(Ljava/io/PipedWriter;)V",
	.class=			&_jc_java_io_PipedReader$type,
	.param_types=		&_jc_java_io_PipedReader$param_types$_init$0cb167cb7cfbbc43,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_io_PipedReader$param_ptypes$_init$0cb167cb7cfbbc43,
	.signature_hash=	_JC_JLONG(0xcb167cb7cfbbc43),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_io_PipedReader$method$_init$0cb167cb7cfbbc43,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_io_PipedReader$exceptions$_init$0cb167cb7cfbbc43,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_io_PipedReader$linenum_table$_init$0cb167cb7cfbbc43
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_PipedReader, _init$0cb167cb7cfbbc43);

void _JC_JCNI_ATTR
_jc_java_io_PipedReader$method$_init$0cb167cb7cfbbc43(_jc_env *const env, _jc_java_io_PipedReader$object *this, _jc_java_io_PipedWriter$object *param0)
{
	struct _jc_java_io_PipedReader$object *r0;
	struct _jc_java_io_PipedWriter$object *r1;
	_jc_char_array *r3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_REF_FIELD(env, r0, java_io_Reader, lock) = r0;
	r3 = _JC_NEW_PRIM_ARRAY(env, char, 1, 2048);
	_JC_REF_FIELD(env, r0, java_io_PipedReader, buffer) = r3;
	_JC_PRIM_FIELD(env, r0, java_io_PipedReader, in) = -1;
	_JC_PRIM_FIELD(env, r0, java_io_PipedReader, out) = 0;
	r3 = _JC_NEW_PRIM_ARRAY(env, char, 1, 1);
	_JC_REF_FIELD(env, r0, java_io_PipedReader, read__5fbuf) = r3;
	_JC_LINE_NUMBER(117);				// 0
	_JC_INVOKE_VIRTUAL(env, java_io_PipedReader, connect$95fe4eda9e9fcf66, r0, r1);
	_JC_LINE_NUMBER(118);				// 1
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public void close() throws java.io.IOException
//

static _jc_linenum _jc_java_io_PipedReader$linenum_table$close$6aba8b329fddcd79[];

static _jc_trap_info _jc_java_io_PipedReader$trap_table$close$6aba8b329fddcd79[] = {
	_JC_TRAP(_JC_NULL, 1, 2),
	_JC_TRAP(_JC_NULL, 3, 4),
};

static const unsigned char _jc_java_io_PipedReader$param_ptypes$close$6aba8b329fddcd79[] = { 
_JC_TYPE_VOID };

static _jc_type *const _jc_java_io_PipedReader$exceptions$close$6aba8b329fddcd79[] = {
	&_jc_java_io_IOException$type
};

_jc_method _jc_java_io_PipedReader$method_info$close$6aba8b329fddcd79 = {
	.name=			"close",
	.signature=		"()V",
	.class=			&_jc_java_io_PipedReader$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_io_PipedReader$param_ptypes$close$6aba8b329fddcd79,
	.signature_hash=	_JC_JLONG(0x6aba8b329fddcd79),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_io_PipedReader$method$close$6aba8b329fddcd79,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_io_PipedReader$vtable, java_io_PipedReader.close$6aba8b329fddcd79) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_io_PipedReader$exceptions$close$6aba8b329fddcd79,
	.u= { .exec= {
	  .trap_table_len=	2,
	  .trap_table=		_jc_java_io_PipedReader$trap_table$close$6aba8b329fddcd79,
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_java_io_PipedReader$linenum_table$close$6aba8b329fddcd79
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_PipedReader, close$6aba8b329fddcd79);

void _JC_JCNI_ATTR
_jc_java_io_PipedReader$method$close$6aba8b329fddcd79(_jc_env *const env, _jc_java_io_PipedReader$object *this)
{
	struct _jc_java_io_PipedReader$object *r0;
	struct _jc_java_lang_Object$object *volatile r1;
	struct _jc_java_lang_Throwable$object *volatile r2;
	struct _jc_java_lang_Object$object *r3;
	_jc_catch_frame	catch;

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_java_io_PipedReader$method_info$close$6aba8b329fddcd79, &&label0, &&label0);

	r0 = this;
	_JC_LINE_NUMBER(353);				// 0
	goto label1;

label0:
	_JC_TRAP_REGION(catch, 0);
	_JC_PERIODIC_CHECK(env);
	r2 = _JC_CAUGHT_EXCEPTION(env);
	_JC_TRAP_REGION(catch, 1);
	_JC_MONITOR_EXIT(env, r1);
	_JC_TRAP_REGION(catch, 2);
	_JC_THROW(env, r2);

label1:
	_JC_TRAP_REGION(catch, 2);
	r3 = _JC_REF_FIELD(env, r0, java_io_Reader, lock);
	r1 = r3;
	_JC_MONITOR_ENTER(env, r3);
	_JC_TRAP_REGION(catch, 3);
	_JC_LINE_NUMBER(355);				// 1
	_JC_PRIM_FIELD(env, r0, java_io_PipedReader, closed) = 1;
	_JC_LINE_NUMBER(357);				// 2
	r3 = _JC_REF_FIELD(env, r0, java_io_Reader, lock);
	_JC_EXPLICIT_NULL_CHECK(env, r3);
	_JC_INVOKE_STATIC(env, java_lang_VMObject, notifyAll$82e8779c36c7e7ef, 0, r3);
	_JC_MONITOR_EXIT(env, r1);
	_JC_TRAP_REGION(catch, 4);
	_JC_LINE_NUMBER(359);				// 3
	_JC_CANCEL_TRAPS(env, catch);
	return;
}

//
// public void connect(java.io.PipedWriter) throws java.io.IOException
//

static _jc_linenum _jc_java_io_PipedReader$linenum_table$connect$95fe4eda9e9fcf66[];

static const unsigned char _jc_java_io_PipedReader$param_ptypes$connect$95fe4eda9e9fcf66[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_io_PipedReader$exceptions$connect$95fe4eda9e9fcf66[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_java_io_PipedReader$param_types$connect$95fe4eda9e9fcf66[] = {
	&_jc_java_io_PipedWriter$type
};

_jc_method _jc_java_io_PipedReader$method_info$connect$95fe4eda9e9fcf66 = {
	.name=			"connect",
	.signature=		"(Ljava/io/PipedWriter;)V",
	.class=			&_jc_java_io_PipedReader$type,
	.param_types=		&_jc_java_io_PipedReader$param_types$connect$95fe4eda9e9fcf66,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_io_PipedReader$param_ptypes$connect$95fe4eda9e9fcf66,
	.signature_hash=	_JC_JLONG(0x95fe4eda9e9fcf66),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_io_PipedReader$method$connect$95fe4eda9e9fcf66,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_io_PipedReader$vtable, java_io_PipedReader.connect$95fe4eda9e9fcf66) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_io_PipedReader$exceptions$connect$95fe4eda9e9fcf66,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_java_io_PipedReader$linenum_table$connect$95fe4eda9e9fcf66
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_PipedReader, connect$95fe4eda9e9fcf66);

void _JC_JCNI_ATTR
_jc_java_io_PipedReader$method$connect$95fe4eda9e9fcf66(_jc_env *const env, _jc_java_io_PipedReader$object *this, _jc_java_io_PipedWriter$object *param0)
{
	struct _jc_java_io_PipedReader$object *r0;
	struct _jc_java_io_PipedWriter$object *r1;
	struct _jc_java_io_PipedWriter$object *r2;
	struct _jc_java_io_PipedReader$object *r3;
	struct _jc_java_io_IOException$object *r4;
	struct _jc_java_lang_String$object *r5;
	struct _jc_java_lang_VMThrowable$object *r7;

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(136);				// 0
	r2 = _JC_REF_FIELD(env, r0, java_io_PipedReader, source);
	if (r2 != _JC_NULL)
		goto label0;
	r3 = _JC_REF_FIELD(env, r1, java_io_PipedWriter, sink);
	if (r3 == _JC_NULL)
		goto label1;

label0:
	_JC_LINE_NUMBER(137);				// 1
	r4 = _JC_NEW(env, java_io_IOException);
	r5 = _JC_STRING(env, "Already connected");
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r7 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r7;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r5;
	_JC_THROW(env, r4);

label1:
	_JC_LINE_NUMBER(139);				// 2
	_JC_REF_FIELD(env, r1, java_io_PipedWriter, sink) = r0;
	_JC_LINE_NUMBER(140);				// 3
	_JC_REF_FIELD(env, r0, java_io_PipedReader, source) = r1;
	_JC_LINE_NUMBER(141);				// 4
	return;
}

//
// public int read() throws java.io.IOException
//

static _jc_linenum _jc_java_io_PipedReader$linenum_table$read$1a981297cb524963[];

static const unsigned char _jc_java_io_PipedReader$param_ptypes$read$1a981297cb524963[] = { 
_JC_TYPE_INT };

static _jc_type *const _jc_java_io_PipedReader$exceptions$read$1a981297cb524963[] = {
	&_jc_java_io_IOException$type
};

_jc_method _jc_java_io_PipedReader$method_info$read$1a981297cb524963 = {
	.name=			"read",
	.signature=		"()I",
	.class=			&_jc_java_io_PipedReader$type,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_java_io_PipedReader$param_ptypes$read$1a981297cb524963,
	.signature_hash=	_JC_JLONG(0x1a981297cb524963),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_io_PipedReader$method$read$1a981297cb524963,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_io_PipedReader$vtable, java_io_PipedReader.read$1a981297cb524963) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_io_PipedReader$exceptions$read$1a981297cb524963,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_io_PipedReader$linenum_table$read$1a981297cb524963
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_PipedReader, read$1a981297cb524963);

jint _JC_JCNI_ATTR
_jc_java_io_PipedReader$method$read$1a981297cb524963(_jc_env *const env, _jc_java_io_PipedReader$object *this)
{
	jint i0;
	struct _jc_java_io_PipedReader$object *r0;
	_jc_char_array *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(231);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_io_PipedReader, read__5fbuf);
	i0 = _JC_INVOKE_VIRTUAL(env, java_io_PipedReader, read$146ad4b836c4a55b, r0, r1, 0, 1);
	_JC_LINE_NUMBER(232);				// 1
	if (i0 == -1)
		goto label0;
	r1 = _JC_REF_FIELD(env, r0, java_io_PipedReader, read__5fbuf);
	i0 = _JC_PRIM_ELEMENT(env, char, r1, 0, 0, 1);
	goto label1;

label0:
	i0 = -1;

label1:
	return i0;
}

//
// public int read(char[], int, int) throws java.io.IOException
//

static _jc_linenum _jc_java_io_PipedReader$linenum_table$read$146ad4b836c4a55b[];

static _jc_trap_info _jc_java_io_PipedReader$trap_table$read$146ad4b836c4a55b[] = {
	_JC_TRAP(_JC_NULL, 1, 2),
	_JC_TRAP(&_jc_java_lang_InterruptedException$type, 7, 8),
	_JC_TRAP(&_jc_java_lang_InterruptedException$type, 4, 5),
	_JC_TRAP(_JC_NULL, 7, 9),
	_JC_TRAP(_JC_NULL, 3, 6),
};

static const unsigned char _jc_java_io_PipedReader$param_ptypes$read$146ad4b836c4a55b[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_INT, _JC_TYPE_INT };

static _jc_type *const _jc_java_io_PipedReader$exceptions$read$146ad4b836c4a55b[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_java_io_PipedReader$param_types$read$146ad4b836c4a55b[] = {
	&_jc_char$array$prim$type,
	&_jc_int$prim$type,
	&_jc_int$prim$type
};

_jc_method _jc_java_io_PipedReader$method_info$read$146ad4b836c4a55b = {
	.name=			"read",
	.signature=		"([CII)I",
	.class=			&_jc_java_io_PipedReader$type,
	.param_types=		&_jc_java_io_PipedReader$param_types$read$146ad4b836c4a55b,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_java_io_PipedReader$param_ptypes$read$146ad4b836c4a55b,
	.signature_hash=	_JC_JLONG(0x146ad4b836c4a55b),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_io_PipedReader$method$read$146ad4b836c4a55b,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_io_PipedReader$vtable, java_io_PipedReader.read$146ad4b836c4a55b) / sizeof(void *),
	.num_parameters=	3,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_io_PipedReader$exceptions$read$146ad4b836c4a55b,
	.u= { .exec= {
	  .trap_table_len=	5,
	  .trap_table=		_jc_java_io_PipedReader$trap_table$read$146ad4b836c4a55b,
	  .u= {
	    .linenum= {
	      .len=	27,
	      .table=	_jc_java_io_PipedReader$linenum_table$read$146ad4b836c4a55b
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_PipedReader, read$146ad4b836c4a55b);

jint _JC_JCNI_ATTR
_jc_java_io_PipedReader$method$read$146ad4b836c4a55b(_jc_env *const env, _jc_java_io_PipedReader$object *this, _jc_char_array *param0, jint param1, jint param2)
{
	jint i0;
	jint i1;
	jint i2;
	jint i3;
	jint i4;
	jint i5;
	jint i7;
	struct _jc_java_io_PipedReader$object *r0;
	_jc_char_array *r1;
	struct _jc_java_lang_String$object *r10;
	struct _jc_java_lang_String$object *r11;
	struct _jc_java_lang_VMThrowable$object *r12;
	struct _jc_java_lang_VMThrowable$object *r13;
	struct _jc_java_lang_String$object *volatile r14;
	struct _jc_java_lang_VMThrowable$object *volatile r15;
	struct _jc_java_lang_Object$object *volatile r2;
	struct _jc_java_lang_Throwable$object *volatile r3;
	struct _jc_java_lang_InterruptedException$object *r4;
	struct _jc_java_lang_Object$object *r5;
	struct _jc_java_io_PipedWriter$object *r6;
	struct _jc_java_io_IOException$object *r7;
	struct _jc_java_io_InterruptedIOException$object *volatile r8;
	_jc_char_array *r9;
	jboolean z0;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_java_io_PipedReader$method_info$read$146ad4b836c4a55b, &&label0, &&label6, &&label6, &&label0, &&label0);

	r0 = this;
	r1 = param0;
	i0 = param1;
	i1 = param2;
	_JC_LINE_NUMBER(257);				// 0
	goto label1;

label0:
	_JC_TRAP_REGION(catch, 0);
	_JC_PERIODIC_CHECK(env);
	r3 = _JC_CAUGHT_EXCEPTION(env);
	_JC_TRAP_REGION(catch, 1);
	_JC_MONITOR_EXIT(env, r2);
	_JC_TRAP_REGION(catch, 2);
	_JC_THROW(env, r3);

label1:
	_JC_TRAP_REGION(catch, 2);
	r5 = _JC_REF_FIELD(env, r0, java_io_Reader, lock);
	r2 = r5;
	_JC_MONITOR_ENTER(env, r5);
	_JC_TRAP_REGION(catch, 3);
	_JC_LINE_NUMBER(259);				// 1
	r6 = _JC_REF_FIELD(env, r0, java_io_PipedReader, source);
	if (r6 != _JC_NULL)
		goto label2;
	_JC_LINE_NUMBER(260);				// 2
	r7 = _JC_NEW(env, java_io_IOException);
	r10 = _JC_STRING(env, "Not connected");
	_JC_REF_FIELD(env, r7, java_lang_Throwable, cause) = r7;
	r12 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r7);
	_JC_REF_FIELD(env, r7, java_lang_Throwable, vmState) = r12;
	_JC_REF_FIELD(env, r7, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r7, java_lang_Throwable, detailMessage) = r10;
	_JC_THROW(env, r7);

label2:
	_JC_LINE_NUMBER(261);				// 3
	z0 = _JC_PRIM_FIELD(env, r0, java_io_PipedReader, closed);
	if (z0 == 0)
		goto label5;
	_JC_LINE_NUMBER(262);				// 4
	r7 = _JC_NEW(env, java_io_IOException);
	r11 = _JC_STRING(env, "Pipe closed");
	_JC_REF_FIELD(env, r7, java_lang_Throwable, cause) = r7;
	r13 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r7);
	_JC_REF_FIELD(env, r7, java_lang_Throwable, vmState) = r13;
	_JC_REF_FIELD(env, r7, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r7, java_lang_Throwable, detailMessage) = r11;
	_JC_THROW(env, r7);

label3:
	_JC_TRAP_REGION(catch, 4);
	_JC_LINE_NUMBER(270);				// 5
	r6 = _JC_REF_FIELD(env, r0, java_io_PipedReader, source);
	z0 = _JC_PRIM_FIELD(env, r6, java_io_PipedWriter, closed);
	if (z0 == 0)
		goto label4;
	_JC_TRAP_REGION(catch, 5);
	_JC_LINE_NUMBER(271);				// 6
	_JC_MONITOR_EXIT(env, r2);
	_JC_TRAP_REGION(catch, 6);
	_JC_CANCEL_TRAPS(env, catch);
	return -1;

label4:
	_JC_TRAP_REGION(catch, 7);
	_JC_LINE_NUMBER(272);				// 7
	r5 = _JC_REF_FIELD(env, r0, java_io_Reader, lock);
	_JC_EXPLICIT_NULL_CHECK(env, r5);
	_JC_INVOKE_STATIC(env, java_lang_VMObject, wait$f4b3db53c17f3f59, 0, r5, _JC_JLONG(0), 0);

label5:
	_JC_TRAP_REGION(catch, 7);
	_JC_LINE_NUMBER(268);				// 8
	i2 = _JC_PRIM_FIELD(env, r0, java_io_PipedReader, in);
	if (i2 < 0) {
		_JC_PERIODIC_CHECK(env);
		goto label3;
	}
	_JC_TRAP_REGION(catch, 8);
	goto label7;

label6:
	_JC_TRAP_REGION(catch, 8);
	r4 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(277);				// 9
	r8 = _JC_NEW(env, java_io_InterruptedIOException);
	r14 = _JC_NULL;
	_JC_REF_FIELD(env, r8, java_lang_Throwable, cause) = r8;
	r15 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r8);
	_JC_REF_FIELD(env, r8, java_lang_Throwable, vmState) = r15;
	_JC_REF_FIELD(env, r8, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r8, java_lang_Throwable, detailMessage) = r14;
	_JC_THROW(env, r8);

label7:
	_JC_LINE_NUMBER(280);				// 10
	i3 = 0;

label8:
	_JC_LINE_NUMBER(287);				// 11
	i2 = _JC_PRIM_FIELD(env, r0, java_io_PipedReader, out);
	i4 = _JC_PRIM_FIELD(env, r0, java_io_PipedReader, in);
	if (i2 >= i4)
		goto label11;
	_JC_LINE_NUMBER(288);				// 12
	i4 = _JC_PRIM_FIELD(env, r0, java_io_PipedReader, in);
	i2 = _JC_PRIM_FIELD(env, r0, java_io_PipedReader, out);
	i4 = i4 - i2;
	_JC_ACTIVE_USE(env, java_lang_Math);
	if (i1 >= i4)
		goto label9;
	i5 = i1;
	goto label10;

label9:
	i5 = i4;

label10:
	i2 = i5;
	goto label14;

label11:
	_JC_LINE_NUMBER(290);				// 13
	r9 = _JC_REF_FIELD(env, r0, java_io_PipedReader, buffer);
	i4 = _JC_ARRAY_LENGTH(env, r9);
	i2 = _JC_PRIM_FIELD(env, r0, java_io_PipedReader, out);
	i4 = i4 - i2;
	_JC_ACTIVE_USE(env, java_lang_Math);
	if (i1 >= i4)
		goto label12;
	i7 = i1;
	goto label13;

label12:
	i7 = i4;

label13:
	i2 = i7;

label14:
	_JC_LINE_NUMBER(292);				// 14
	r9 = _JC_REF_FIELD(env, r0, java_io_PipedReader, buffer);
	i4 = _JC_PRIM_FIELD(env, r0, java_io_PipedReader, out);
	_JC_ACTIVE_USE(env, java_lang_System);
	_JC_INVOKE_STATIC(env, java_lang_VMSystem, arraycopy$4286a72d57744cd8, 0, r9, i4, r1, i0, i2);
	_JC_LINE_NUMBER(293);				// 15
	i0 = i0 + i2;
	_JC_LINE_NUMBER(294);				// 16
	i1 = i1 - i2;
	_JC_LINE_NUMBER(295);				// 17
	i4 = _JC_PRIM_FIELD(env, r0, java_io_PipedReader, out);
	i4 = i4 + i2;
	_JC_PRIM_FIELD(env, r0, java_io_PipedReader, out) = i4;
	_JC_LINE_NUMBER(296);				// 18
	i3 = i3 + i2;
	_JC_LINE_NUMBER(298);				// 19
	i4 = _JC_PRIM_FIELD(env, r0, java_io_PipedReader, out);
	r9 = _JC_REF_FIELD(env, r0, java_io_PipedReader, buffer);
	i2 = _JC_ARRAY_LENGTH(env, r9);
	if (i4 != i2)
		goto label15;
	_JC_LINE_NUMBER(299);				// 20
	_JC_PRIM_FIELD(env, r0, java_io_PipedReader, out) = 0;

label15:
	_JC_LINE_NUMBER(301);				// 21
	i4 = _JC_PRIM_FIELD(env, r0, java_io_PipedReader, out);
	i2 = _JC_PRIM_FIELD(env, r0, java_io_PipedReader, in);
	if (i4 != i2)
		goto label16;
	_JC_LINE_NUMBER(304);				// 22
	_JC_PRIM_FIELD(env, r0, java_io_PipedReader, in) = -1;
	_JC_LINE_NUMBER(305);				// 23
	_JC_PRIM_FIELD(env, r0, java_io_PipedReader, out) = 0;

label16:
	_JC_LINE_NUMBER(309);				// 24
	if (i1 == 0)
		goto label17;
	i4 = _JC_PRIM_FIELD(env, r0, java_io_PipedReader, in);
	if (i4 != -1) {
		_JC_PERIODIC_CHECK(env);
		goto label8;
	}

label17:
	_JC_LINE_NUMBER(313);				// 25
	r5 = _JC_REF_FIELD(env, r0, java_io_Reader, lock);
	_JC_EXPLICIT_NULL_CHECK(env, r5);
	_JC_INVOKE_STATIC(env, java_lang_VMObject, notifyAll$82e8779c36c7e7ef, 0, r5);
	_JC_LINE_NUMBER(314);				// 26
	_JC_MONITOR_EXIT(env, r2);
	_JC_TRAP_REGION(catch, 9);
	_JC_CANCEL_TRAPS(env, catch);
	return i3;
}

//
// public boolean ready() throws java.io.IOException
//

static _jc_linenum _jc_java_io_PipedReader$linenum_table$ready$83ea616797d9c364[];

static _jc_trap_info _jc_java_io_PipedReader$trap_table$ready$83ea616797d9c364[] = {
	_JC_TRAP(_JC_NULL, 1, 2),
	_JC_TRAP(_JC_NULL, 5, 6),
	_JC_TRAP(_JC_NULL, 3, 4),
};

static const unsigned char _jc_java_io_PipedReader$param_ptypes$ready$83ea616797d9c364[] = { 
_JC_TYPE_BOOLEAN };

static _jc_type *const _jc_java_io_PipedReader$exceptions$ready$83ea616797d9c364[] = {
	&_jc_java_io_IOException$type
};

_jc_method _jc_java_io_PipedReader$method_info$ready$83ea616797d9c364 = {
	.name=			"ready",
	.signature=		"()Z",
	.class=			&_jc_java_io_PipedReader$type,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_java_io_PipedReader$param_ptypes$ready$83ea616797d9c364,
	.signature_hash=	_JC_JLONG(0x83ea616797d9c364),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_io_PipedReader$method$ready$83ea616797d9c364,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_io_PipedReader$vtable, java_io_PipedReader.ready$83ea616797d9c364) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_io_PipedReader$exceptions$ready$83ea616797d9c364,
	.u= { .exec= {
	  .trap_table_len=	3,
	  .trap_table=		_jc_java_io_PipedReader$trap_table$ready$83ea616797d9c364,
	  .u= {
	    .linenum= {
	      .len=	9,
	      .table=	_jc_java_io_PipedReader$linenum_table$ready$83ea616797d9c364
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_PipedReader, ready$83ea616797d9c364);

jboolean _JC_JCNI_ATTR
_jc_java_io_PipedReader$method$ready$83ea616797d9c364(_jc_env *const env, _jc_java_io_PipedReader$object *this)
{
	jint i0;
	jint i1;
	struct _jc_java_io_PipedReader$object *r0;
	struct _jc_java_lang_Throwable$object *volatile r1;
	struct _jc_java_lang_Object$object *volatile r2;
	struct _jc_java_io_IOException$object *r3;
	_jc_char_array *r4;
	struct _jc_java_lang_String$object *r5;
	struct _jc_java_lang_VMThrowable$object *r7;
	jboolean z0;
	_jc_catch_frame	catch;

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_java_io_PipedReader$method_info$ready$83ea616797d9c364, &&label0, &&label0, &&label0);

	r0 = this;
	_JC_LINE_NUMBER(327);				// 0
	goto label1;

label0:
	_JC_TRAP_REGION(catch, 0);
	_JC_PERIODIC_CHECK(env);
	r1 = _JC_CAUGHT_EXCEPTION(env);
	_JC_TRAP_REGION(catch, 1);
	_JC_MONITOR_EXIT(env, r2);
	_JC_TRAP_REGION(catch, 2);
	_JC_THROW(env, r1);

label1:
	_JC_TRAP_REGION(catch, 2);
	r2 = _JC_REF_FIELD(env, r0, java_io_Reader, lock);
	_JC_MONITOR_ENTER(env, r2);
	_JC_TRAP_REGION(catch, 3);
	_JC_LINE_NUMBER(329);				// 1
	z0 = _JC_PRIM_FIELD(env, r0, java_io_PipedReader, closed);
	if (z0 == 0)
		goto label2;
	_JC_LINE_NUMBER(330);				// 2
	r3 = _JC_NEW(env, java_io_IOException);
	r5 = _JC_STRING(env, "Pipe closed");
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r7 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r7;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r5;
	_JC_THROW(env, r3);

label2:
	_JC_LINE_NUMBER(332);				// 3
	i0 = _JC_PRIM_FIELD(env, r0, java_io_PipedReader, in);
	if (i0 >= 0)
		goto label3;
	_JC_LINE_NUMBER(333);				// 4
	_JC_MONITOR_EXIT(env, r2);
	_JC_TRAP_REGION(catch, 4);
	_JC_CANCEL_TRAPS(env, catch);
	return 0;

label3:
	_JC_TRAP_REGION(catch, 5);
	_JC_LINE_NUMBER(336);				// 5
	i0 = _JC_PRIM_FIELD(env, r0, java_io_PipedReader, out);
	i1 = _JC_PRIM_FIELD(env, r0, java_io_PipedReader, in);
	if (i0 >= i1)
		goto label4;
	_JC_LINE_NUMBER(337);				// 6
	i1 = _JC_PRIM_FIELD(env, r0, java_io_PipedReader, in);
	i0 = _JC_PRIM_FIELD(env, r0, java_io_PipedReader, out);
	i0 = i1 - i0;
	goto label5;

label4:
	_JC_LINE_NUMBER(339);				// 7
	r4 = _JC_REF_FIELD(env, r0, java_io_PipedReader, buffer);
	i1 = _JC_ARRAY_LENGTH(env, r4);
	i0 = _JC_PRIM_FIELD(env, r0, java_io_PipedReader, out);
	i1 = i1 - i0;
	i0 = _JC_PRIM_FIELD(env, r0, java_io_PipedReader, in);
	i0 = i1 - i0;

label5:
	_JC_LINE_NUMBER(341);				// 8
	z0 = 0;
	if (i0 <= 0)
		goto label6;
	z0 = 1;

label6:
	_JC_MONITOR_EXIT(env, r2);
	_JC_TRAP_REGION(catch, 6);
	_JC_CANCEL_TRAPS(env, catch);
	return z0;
}

//
// void receive(char[], int, int) throws java.io.IOException
//

static _jc_linenum _jc_java_io_PipedReader$linenum_table$receive$147ab5152398659a[];

static _jc_trap_info _jc_java_io_PipedReader$trap_table$receive$147ab5152398659a[] = {
	_JC_TRAP(_JC_NULL, 1, 2),
	_JC_TRAP(&_jc_java_lang_InterruptedException$type, 4, 5),
	_JC_TRAP(_JC_NULL, 3, 6),
};

static const unsigned char _jc_java_io_PipedReader$param_ptypes$receive$147ab5152398659a[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_INT, _JC_TYPE_VOID };

static _jc_type *const _jc_java_io_PipedReader$exceptions$receive$147ab5152398659a[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_java_io_PipedReader$param_types$receive$147ab5152398659a[] = {
	&_jc_char$array$prim$type,
	&_jc_int$prim$type,
	&_jc_int$prim$type
};

_jc_method _jc_java_io_PipedReader$method_info$receive$147ab5152398659a = {
	.name=			"receive",
	.signature=		"([CII)V",
	.class=			&_jc_java_io_PipedReader$type,
	.param_types=		&_jc_java_io_PipedReader$param_types$receive$147ab5152398659a,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_io_PipedReader$param_ptypes$receive$147ab5152398659a,
	.signature_hash=	_JC_JLONG(0x147ab5152398659a),
	.access_flags=		0,
	.function=		&_jc_java_io_PipedReader$method$receive$147ab5152398659a,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_io_PipedReader$vtable, java_io_PipedReader.receive$147ab5152398659a) / sizeof(void *),
	.num_parameters=	3,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_io_PipedReader$exceptions$receive$147ab5152398659a,
	.u= { .exec= {
	  .trap_table_len=	3,
	  .trap_table=		_jc_java_io_PipedReader$trap_table$receive$147ab5152398659a,
	  .u= {
	    .linenum= {
	      .len=	23,
	      .table=	_jc_java_io_PipedReader$linenum_table$receive$147ab5152398659a
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_PipedReader, receive$147ab5152398659a);

void _JC_JCNI_ATTR
_jc_java_io_PipedReader$method$receive$147ab5152398659a(_jc_env *const env, _jc_java_io_PipedReader$object *this, _jc_char_array *param0, jint param1, jint param2)
{
	jint i0;
	jint i1;
	jint i2;
	jint i3;
	jint i4;
	jint i6;
	struct _jc_java_io_PipedReader$object *r0;
	_jc_char_array *r1;
	struct _jc_java_lang_String$object *r10;
	struct _jc_java_lang_VMThrowable$object *r11;
	struct _jc_java_lang_VMThrowable$object *r12;
	struct _jc_java_lang_String$object *volatile r13;
	struct _jc_java_lang_VMThrowable$object *volatile r14;
	struct _jc_java_lang_Object$object *volatile r2;
	struct _jc_java_lang_Throwable$object *volatile r3;
	struct _jc_java_lang_InterruptedException$object *r4;
	struct _jc_java_lang_Object$object *r5;
	struct _jc_java_io_IOException$object *r6;
	struct _jc_java_io_InterruptedIOException$object *volatile r7;
	_jc_char_array *r8;
	struct _jc_java_lang_String$object *r9;
	jboolean z0;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_java_io_PipedReader$method_info$receive$147ab5152398659a, &&label0, &&label4, &&label0);

	r0 = this;
	r1 = param0;
	i0 = param1;
	i1 = param2;
	_JC_LINE_NUMBER(159);				// 0
	goto label1;

label0:
	_JC_TRAP_REGION(catch, 0);
	_JC_PERIODIC_CHECK(env);
	r3 = _JC_CAUGHT_EXCEPTION(env);
	_JC_TRAP_REGION(catch, 1);
	_JC_MONITOR_EXIT(env, r2);
	_JC_TRAP_REGION(catch, 2);
	_JC_THROW(env, r3);

label1:
	_JC_TRAP_REGION(catch, 2);
	r5 = _JC_REF_FIELD(env, r0, java_io_Reader, lock);
	r2 = r5;
	_JC_MONITOR_ENTER(env, r5);
	_JC_TRAP_REGION(catch, 3);
	_JC_LINE_NUMBER(161);				// 1
	z0 = _JC_PRIM_FIELD(env, r0, java_io_PipedReader, closed);
	if (z0 == 0)
		goto label13;
	_JC_LINE_NUMBER(162);				// 2
	r6 = _JC_NEW(env, java_io_IOException);
	r9 = _JC_STRING(env, "Pipe closed");
	_JC_REF_FIELD(env, r6, java_lang_Throwable, cause) = r6;
	r11 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r6);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, vmState) = r11;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, detailMessage) = r9;
	_JC_THROW(env, r6);

label2:
	_JC_LINE_NUMBER(174);				// 3
	r5 = _JC_REF_FIELD(env, r0, java_io_Reader, lock);
	_JC_EXPLICIT_NULL_CHECK(env, r5);
	_JC_INVOKE_STATIC(env, java_lang_VMObject, notifyAll$82e8779c36c7e7ef, 0, r5);
	_JC_LINE_NUMBER(175);				// 4
	r5 = _JC_REF_FIELD(env, r0, java_io_Reader, lock);
	_JC_EXPLICIT_NULL_CHECK(env, r5);
	_JC_INVOKE_STATIC(env, java_lang_VMObject, wait$f4b3db53c17f3f59, 1, r5, _JC_JLONG(0), 0);
	_JC_LINE_NUMBER(177);				// 5
	z0 = _JC_PRIM_FIELD(env, r0, java_io_PipedReader, closed);
	if (z0 == 0)
		goto label3;
	_JC_LINE_NUMBER(178);				// 6
	r6 = _JC_NEW(env, java_io_IOException);
	r10 = _JC_STRING(env, "Pipe closed");
	_JC_REF_FIELD(env, r6, java_lang_Throwable, cause) = r6;
	r12 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r6);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, vmState) = r12;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, detailMessage) = r10;
	_JC_THROW(env, r6);

label3:
	_JC_TRAP_REGION(catch, 4);
	_JC_LINE_NUMBER(171);				// 7
	i2 = _JC_PRIM_FIELD(env, r0, java_io_PipedReader, in);
	i3 = _JC_PRIM_FIELD(env, r0, java_io_PipedReader, out);
	if (i2 == i3) {
		_JC_PERIODIC_CHECK(env);
		goto label2;
	}
	_JC_TRAP_REGION(catch, 5);
	goto label5;

label4:
	_JC_TRAP_REGION(catch, 5);
	r4 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(183);				// 8
	r7 = _JC_NEW(env, java_io_InterruptedIOException);
	r13 = _JC_NULL;
	_JC_REF_FIELD(env, r7, java_lang_Throwable, cause) = r7;
	r14 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r7);
	_JC_REF_FIELD(env, r7, java_lang_Throwable, vmState) = r14;
	_JC_REF_FIELD(env, r7, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r7, java_lang_Throwable, detailMessage) = r13;
	_JC_THROW(env, r7);

label5:
	_JC_LINE_NUMBER(186);				// 9
	i3 = _JC_PRIM_FIELD(env, r0, java_io_PipedReader, in);
	if (i3 >= 0)
		goto label6;
	_JC_LINE_NUMBER(187);				// 10
	_JC_PRIM_FIELD(env, r0, java_io_PipedReader, in) = 0;

label6:
	_JC_LINE_NUMBER(191);				// 11
	i3 = _JC_PRIM_FIELD(env, r0, java_io_PipedReader, in);
	i2 = _JC_PRIM_FIELD(env, r0, java_io_PipedReader, out);
	if (i3 >= i2)
		goto label9;
	_JC_LINE_NUMBER(192);				// 12
	i3 = _JC_PRIM_FIELD(env, r0, java_io_PipedReader, out);
	i2 = _JC_PRIM_FIELD(env, r0, java_io_PipedReader, in);
	i3 = i3 - i2;
	_JC_ACTIVE_USE(env, java_lang_Math);
	if (i1 >= i3)
		goto label7;
	i4 = i1;
	goto label8;

label7:
	i4 = i3;

label8:
	i2 = i4;
	goto label12;

label9:
	_JC_LINE_NUMBER(194);				// 13
	r8 = _JC_REF_FIELD(env, r0, java_io_PipedReader, buffer);
	i3 = _JC_ARRAY_LENGTH(env, r8);
	i2 = _JC_PRIM_FIELD(env, r0, java_io_PipedReader, in);
	i3 = i3 - i2;
	_JC_ACTIVE_USE(env, java_lang_Math);
	if (i1 >= i3)
		goto label10;
	i6 = i1;
	goto label11;

label10:
	i6 = i3;

label11:
	i2 = i6;

label12:
	_JC_LINE_NUMBER(197);				// 14
	r8 = _JC_REF_FIELD(env, r0, java_io_PipedReader, buffer);
	i3 = _JC_PRIM_FIELD(env, r0, java_io_PipedReader, in);
	_JC_ACTIVE_USE(env, java_lang_System);
	_JC_INVOKE_STATIC(env, java_lang_VMSystem, arraycopy$4286a72d57744cd8, 0, r1, i0, r8, i3, i2);
	_JC_LINE_NUMBER(198);				// 15
	i1 = i1 - i2;
	_JC_LINE_NUMBER(199);				// 16
	i0 = i0 + i2;
	_JC_LINE_NUMBER(200);				// 17
	i3 = _JC_PRIM_FIELD(env, r0, java_io_PipedReader, in);
	i3 = i3 + i2;
	_JC_PRIM_FIELD(env, r0, java_io_PipedReader, in) = i3;
	_JC_LINE_NUMBER(201);				// 18
	i3 = _JC_PRIM_FIELD(env, r0, java_io_PipedReader, in);
	r8 = _JC_REF_FIELD(env, r0, java_io_PipedReader, buffer);
	i2 = _JC_ARRAY_LENGTH(env, r8);
	if (i3 != i2)
		goto label13;
	_JC_LINE_NUMBER(202);				// 19
	_JC_PRIM_FIELD(env, r0, java_io_PipedReader, in) = 0;

label13:
	_JC_TRAP_REGION(catch, 5);
	_JC_LINE_NUMBER(167);				// 20
	if (i1 > 0) {
		_JC_PERIODIC_CHECK(env);
		goto label3;
	}
	_JC_LINE_NUMBER(205);				// 21
	r5 = _JC_REF_FIELD(env, r0, java_io_Reader, lock);
	_JC_EXPLICIT_NULL_CHECK(env, r5);
	_JC_INVOKE_STATIC(env, java_lang_VMObject, notifyAll$82e8779c36c7e7ef, 0, r5);
	_JC_MONITOR_EXIT(env, r2);
	_JC_TRAP_REGION(catch, 6);
	_JC_LINE_NUMBER(207);				// 22
	_JC_CANCEL_TRAPS(env, catch);
	return;
}

//
// private final void this()
//

static _jc_linenum _jc_java_io_PipedReader$linenum_table$this$adc93fb6bf4cbffa[];

static const unsigned char _jc_java_io_PipedReader$param_ptypes$this$adc93fb6bf4cbffa[] = { 
_JC_TYPE_VOID };

_jc_method _jc_java_io_PipedReader$method_info$this$adc93fb6bf4cbffa = {
	.name=			"this",
	.signature=		"()V",
	.class=			&_jc_java_io_PipedReader$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_io_PipedReader$param_ptypes$this$adc93fb6bf4cbffa,
	.signature_hash=	_JC_JLONG(0xadc93fb6bf4cbffa),
	.access_flags=		_JC_ACC_PRIVATE|_JC_ACC_FINAL,
	.function=		&_jc_java_io_PipedReader$method$this$adc93fb6bf4cbffa,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_io_PipedReader$vtable, java_io_PipedReader.this$adc93fb6bf4cbffa) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_java_io_PipedReader$linenum_table$this$adc93fb6bf4cbffa
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_PipedReader, this$adc93fb6bf4cbffa);

void _JC_JCNI_ATTR
_jc_java_io_PipedReader$method$this$adc93fb6bf4cbffa(_jc_env *const env, _jc_java_io_PipedReader$object *this)
{
	struct _jc_java_io_PipedReader$object *r0;
	_jc_char_array *r1;

	r0 = this;
	_JC_LINE_NUMBER(79);				// 0
	r1 = _JC_NEW_PRIM_ARRAY(env, char, 1, 2048);
	_JC_REF_FIELD(env, r0, java_io_PipedReader, buffer) = r1;
	_JC_LINE_NUMBER(87);				// 1
	_JC_PRIM_FIELD(env, r0, java_io_PipedReader, in) = -1;
	_JC_LINE_NUMBER(92);				// 2
	_JC_PRIM_FIELD(env, r0, java_io_PipedReader, out) = 0;
	_JC_LINE_NUMBER(95);				// 3
	r1 = _JC_NEW_PRIM_ARRAY(env, char, 1, 1);
	_JC_REF_FIELD(env, r0, java_io_PipedReader, read__5fbuf) = r1;
	return;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_java_io_PipedReader$methods[] = {
	&_jc_java_io_PipedReader$method_info$_init$52f4ad9f2989aeee,
	&_jc_java_io_PipedReader$method_info$_init$0cb167cb7cfbbc43,
	&_jc_java_io_PipedReader$method_info$close$6aba8b329fddcd79,
	&_jc_java_io_PipedReader$method_info$connect$95fe4eda9e9fcf66,
	&_jc_java_io_PipedReader$method_info$read$1a981297cb524963,
	&_jc_java_io_PipedReader$method_info$read$146ad4b836c4a55b,
	&_jc_java_io_PipedReader$method_info$ready$83ea616797d9c364,
	&_jc_java_io_PipedReader$method_info$receive$147ab5152398659a,
	&_jc_java_io_PipedReader$method_info$this$adc93fb6bf4cbffa
};

/************************************************************************
 *			  Class fields structure			*
 ************************************************************************/

_jc_java_io_PipedReader$fields_struct _jc_java_io_PipedReader$class_fields = { };

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_java_io_PipedReader$instanceof_hash_bucket_1[] = {
	&_jc_java_io_Reader$type,
	_JC_NULL
};
static _jc_type *const _jc_java_io_PipedReader$instanceof_hash_bucket_6[] = {
	&_jc_java_io_PipedReader$type,
	_JC_NULL
};
static _jc_type *const _jc_java_io_PipedReader$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_java_io_PipedReader$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[1]=	_jc_java_io_PipedReader$instanceof_hash_bucket_1,
	[6]=	_jc_java_io_PipedReader$instanceof_hash_bucket_6,
	[101]=	_jc_java_io_PipedReader$instanceof_hash_bucket_101
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_java_io_PipedReader$class_depends[] = {
	{ "java/io/IOException",	_JC_JLONG(0x4e0a56550c69d57c) },
	{ "java/io/InterruptedIOException",	_JC_JLONG(0xd6af3ef15ebd119c) },
	{ "java/io/PipedWriter",	_JC_JLONG(0x9164dff74929beb4) },
	{ "java/io/Reader",	_JC_JLONG(0x688afb20bd4c4e01) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/InterruptedException",	_JC_JLONG(0xdd778e751571cfa9) },
	{ "java/lang/Math",	_JC_JLONG(0x8d71d806a180ad8a) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/System",	_JC_JLONG(0x53cc8e2333795f04) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMObject",	_JC_JLONG(0x312e45ed214d432f) },
	{ "java/lang/VMSystem",	_JC_JLONG(0x4d1cebae0bdda058) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_java_io_PipedReader$vtype _jc_java_io_PipedReader$type = {
    .type= {
	.name=			"java/io/PipedReader",
	.superclass=		&_jc_java_io_Reader$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		27,
		.hash=			_JC_JLONG(0x64f43be4fefefe06),
		.source_file=		"PipedReader.java",
		.instance_size=		sizeof(_jc_java_io_PipedReader$refs) + sizeof(_jc_java_io_PipedReader$object),
		.num_virtual_refs=	4,
		.num_fields=		sizeof(_jc_java_io_PipedReader$fields) / sizeof(*_jc_java_io_PipedReader$fields),
		.fields=		_jc_java_io_PipedReader$fields,
		.num_methods=		sizeof(_jc_java_io_PipedReader$methods) / sizeof(*_jc_java_io_PipedReader$methods),
		.methods=		_jc_java_io_PipedReader$methods,
		.instanceof_hash_table=	_jc_java_io_PipedReader$instanceof_hash_table,
		.class_fields=		&_jc_java_io_PipedReader$class_fields,
		.num_class_depends=		sizeof(_jc_java_io_PipedReader$class_depends) / sizeof(*_jc_java_io_PipedReader$class_depends),
		.class_depends=		_jc_java_io_PipedReader$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.java_io_Reader= {
	    .close$6aba8b329fddcd79=			// overridden
		&_jc_java_io_PipedReader$method$close$6aba8b329fddcd79,
	    .mark$422af117ab27d9db=
		&_jc_java_io_Reader$method$mark$422af117ab27d9db,
	    .markSupported$66435a81b7b2f2dc=
		&_jc_java_io_Reader$method$markSupported$66435a81b7b2f2dc,
	    .read$1a981297cb524963=				// overridden
		&_jc_java_io_PipedReader$method$read$1a981297cb524963,
	    .read$3e60100363b78239=
		&_jc_java_io_Reader$method$read$3e60100363b78239,
	    .read$146ad4b836c4a55b=				// overridden
		&_jc_java_io_PipedReader$method$read$146ad4b836c4a55b,
	    .ready$83ea616797d9c364=			// overridden
		&_jc_java_io_PipedReader$method$ready$83ea616797d9c364,
	    .reset$229a80b3e8394a0f=
		&_jc_java_io_Reader$method$reset$229a80b3e8394a0f,
	    .skip$4e431136b5c4614a=
		&_jc_java_io_Reader$method$skip$4e431136b5c4614a,
	},
	.java_io_PipedReader= {
	    .close$6aba8b329fddcd79=
		&_jc_java_io_PipedReader$method$close$6aba8b329fddcd79,
	    .connect$95fe4eda9e9fcf66=
		&_jc_java_io_PipedReader$method$connect$95fe4eda9e9fcf66,
	    .read$1a981297cb524963=
		&_jc_java_io_PipedReader$method$read$1a981297cb524963,
	    .read$146ad4b836c4a55b=
		&_jc_java_io_PipedReader$method$read$146ad4b836c4a55b,
	    .ready$83ea616797d9c364=
		&_jc_java_io_PipedReader$method$ready$83ea616797d9c364,
	    .receive$147ab5152398659a=
		&_jc_java_io_PipedReader$method$receive$147ab5152398659a,
	    .this$adc93fb6bf4cbffa=
		&_jc_java_io_PipedReader$method$this$adc93fb6bf4cbffa,
	},
    }
};

