// public class java.io.RandomAccessFile

// class file dependencies
// @dep_class 5fe9816daa9bdb2b gnu_java_nio_channels_FileChannelImpl
// @dep_class 8b11a73074165ebc java_io_DataInput
// @dep_class cc3ce5b592e8a1d java_io_DataInputStream
// @dep_class 3e88d5663da73a75 java_io_DataOutput
// @dep_class d755b96203d8fbaf java_io_DataOutputStream
// @dep_class caf39081f5f70fef java_io_EOFException
// @dep_class 9cef6b66128b04b2 java_io_File
// @dep_class 410fd3c919444a2c java_io_FileDescriptor
// @dep_class c9cb932278ec6eea java_io_FileInputStream
// @dep_class 411c07e717eacf69 java_io_FileNotFoundException
// @dep_class 395e451981c47a9d java_io_FileOutputStream
// @dep_class 455accfa535f5dfe java_io_FilterInputStream
// @dep_class fddb41323d9c4cee java_io_FilterOutputStream
// @dep_class 4e0a56550c69d57c java_io_IOException
// @dep_class 66aea4d152614ac4 java_io_InputStream
// @dep_class 4026d3144d6654d8 java_io_OutputStream
// @dep_class 2b5131841d8f479 java_io_RandomAccessFile
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class 9c4f2f07f71cb134 java_lang_Double
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class 75223e1a41a9d924 java_lang_Float
// @dep_class 680cf34d05feb5a1 java_lang_IllegalArgumentException
// @dep_class ca631501391a31f1 java_lang_Integer
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class 4f5534a987354d1d java_lang_RuntimeException
// @dep_class d38282f3d5f80887 java_lang_SecurityManager
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 94d357637b968dda java_lang_StringBuffer
// @dep_class bb7f6fdd2bd0e6b2 java_lang_StringIndexOutOfBoundsException
// @dep_class 53cc8e2333795f04 java_lang_System
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class 43adbb439e3f2be3 java_lang_VMDouble
// @dep_class 8a4ea07ff88e78f8 java_lang_VMFloat
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class 881892f7bdabdc26 java_nio_channels_ByteChannel
// @dep_class 389bd38d1c277676 java_nio_channels_ClosedChannelException
// @dep_class 7ba04a8f861500de java_nio_channels_FileChannel
// @dep_class b39240b3676cb59b java_nio_channels_spi_AbstractInterruptibleChannel

// header file dependencies
// @dep_header gnu_java_nio_channels_FileChannelImpl
// @dep_header java_io_DataInput
// @dep_header java_io_DataInputStream
// @dep_header java_io_DataOutput
// @dep_header java_io_DataOutputStream
// @dep_header java_io_EOFException
// @dep_header java_io_File
// @dep_header java_io_FileDescriptor
// @dep_header java_io_FileInputStream
// @dep_header java_io_FileNotFoundException
// @dep_header java_io_FileOutputStream
// @dep_header java_io_RandomAccessFile
// @dep_header java_lang_Class
// @dep_header java_lang_Double
// @dep_header java_lang_Float
// @dep_header java_lang_IllegalArgumentException
// @dep_header java_lang_Integer
// @dep_header java_lang_SecurityManager
// @dep_header java_lang_String
// @dep_header java_lang_StringBuffer
// @dep_header java_lang_StringIndexOutOfBoundsException
// @dep_header java_lang_System
// @dep_header java_lang_VMDouble
// @dep_header java_lang_VMFloat
// @dep_header java_lang_VMThrowable
// @dep_header java_nio_channels_ByteChannel
// @dep_header java_nio_channels_ClosedChannelException

#include "jc_defs.h"

#include "gnu/java/nio/channels/FileChannelImpl.h"
#include "java/io/DataInput.h"
#include "java/io/DataInputStream.h"
#include "java/io/DataOutput.h"
#include "java/io/DataOutputStream.h"
#include "java/io/EOFException.h"
#include "java/io/File.h"
#include "java/io/FileDescriptor.h"
#include "java/io/FileInputStream.h"
#include "java/io/FileNotFoundException.h"
#include "java/io/FileOutputStream.h"
#include "java/io/RandomAccessFile.h"
#include "java/lang/Class.h"
#include "java/lang/Double.h"
#include "java/lang/Float.h"
#include "java/lang/IllegalArgumentException.h"
#include "java/lang/Integer.h"
#include "java/lang/SecurityManager.h"
#include "java/lang/String.h"
#include "java/lang/StringBuffer.h"
#include "java/lang/StringIndexOutOfBoundsException.h"
#include "java/lang/System.h"
#include "java/lang/VMDouble.h"
#include "java/lang/VMFloat.h"
#include "java/lang/VMThrowable.h"
#include "java/nio/channels/ByteChannel.h"
#include "java/nio/channels/ClosedChannelException.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// private gnu.java.nio.channels.FileChannelImpl ch
static _jc_field _jc_java_io_RandomAccessFile$field_info$ch = {
	.name=		"ch",
	.signature=	"Lgnu/java/nio/channels/FileChannelImpl;",
	.class=		&_jc_java_io_RandomAccessFile$type,
	.type=		&_jc_gnu_java_nio_channels_FileChannelImpl$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_io_RandomAccessFile$object, refs[-1].java_io_RandomAccessFile.ch),
};

// private java.io.FileDescriptor fd
static _jc_field _jc_java_io_RandomAccessFile$field_info$fd = {
	.name=		"fd",
	.signature=	"Ljava/io/FileDescriptor;",
	.class=		&_jc_java_io_RandomAccessFile$type,
	.type=		&_jc_java_io_FileDescriptor$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_io_RandomAccessFile$object, refs[-1].java_io_RandomAccessFile.fd),
};

// private java.io.DataOutputStream out
static _jc_field _jc_java_io_RandomAccessFile$field_info$out = {
	.name=		"out",
	.signature=	"Ljava/io/DataOutputStream;",
	.class=		&_jc_java_io_RandomAccessFile$type,
	.type=		&_jc_java_io_DataOutputStream$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_io_RandomAccessFile$object, refs[-1].java_io_RandomAccessFile.out),
};

// private java.io.DataInputStream in
static _jc_field _jc_java_io_RandomAccessFile$field_info$in = {
	.name=		"in",
	.signature=	"Ljava/io/DataInputStream;",
	.class=		&_jc_java_io_RandomAccessFile$type,
	.type=		&_jc_java_io_DataInputStream$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_io_RandomAccessFile$object, refs[-1].java_io_RandomAccessFile.in),
};

// Fields
static _jc_field *const _jc_java_io_RandomAccessFile$fields[] = {
	&_jc_java_io_RandomAccessFile$field_info$ch,
	&_jc_java_io_RandomAccessFile$field_info$fd,
	&_jc_java_io_RandomAccessFile$field_info$in,
	&_jc_java_io_RandomAccessFile$field_info$out
};

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// public void <init>(java.io.File, java.lang.String) throws java.io.FileNotFoundException
//

static _jc_linenum _jc_java_io_RandomAccessFile$linenum_table$_init$3edeb17decd6ae04[];

static const unsigned char _jc_java_io_RandomAccessFile$param_ptypes$_init$3edeb17decd6ae04[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_io_RandomAccessFile$exceptions$_init$3edeb17decd6ae04[] = {
	&_jc_java_io_FileNotFoundException$type
};

static _jc_type *const _jc_java_io_RandomAccessFile$param_types$_init$3edeb17decd6ae04[] = {
	&_jc_java_io_File$type,
	&_jc_java_lang_String$type
};

_jc_method _jc_java_io_RandomAccessFile$method_info$_init$3edeb17decd6ae04 = {
	.name=			"<init>",
	.signature=		"(Ljava/io/File;Ljava/lang/String;)V",
	.class=			&_jc_java_io_RandomAccessFile$type,
	.param_types=		&_jc_java_io_RandomAccessFile$param_types$_init$3edeb17decd6ae04,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_io_RandomAccessFile$param_ptypes$_init$3edeb17decd6ae04,
	.signature_hash=	_JC_JLONG(0x3edeb17decd6ae04),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_io_RandomAccessFile$method$_init$3edeb17decd6ae04,
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_io_RandomAccessFile$exceptions$_init$3edeb17decd6ae04,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	20,
	      .table=	_jc_java_io_RandomAccessFile$linenum_table$_init$3edeb17decd6ae04
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_RandomAccessFile, _init$3edeb17decd6ae04);

void _JC_JCNI_ATTR
_jc_java_io_RandomAccessFile$method$_init$3edeb17decd6ae04(_jc_env *const env, _jc_java_io_RandomAccessFile$object *this, _jc_java_io_File$object *param0, _jc_java_lang_String$object *param1)
{
	jint i0;
	jint i1;
	jint i2;
	struct _jc_java_io_RandomAccessFile$object *r0;
	struct _jc_java_io_File$object *r1;
	struct _jc_java_io_FileInputStream$object *r10;
	struct _jc_java_lang_SecurityManager$object *r11;
	struct _jc_java_lang_String$object *r12;
	struct _jc_gnu_java_nio_channels_FileChannelImpl$object *r13;
	_jc_byte_array *r14;
	struct _jc_java_lang_VMThrowable$object *r15;
	struct _jc_java_io_FileDescriptor$object *r16;
	struct _jc_object *r17;
	struct _jc_gnu_java_nio_channels_FileChannelImpl$object *r18;
	struct _jc_java_lang_SecurityManager$object *r19;
	struct _jc_java_lang_String$object *r2;
	struct _jc_java_lang_String$object *r20;
	_jc_char_array *r21;
	struct _jc_java_lang_StringBuffer$object *r3;
	struct _jc_java_lang_IllegalArgumentException$object *r4;
	struct _jc_gnu_java_nio_channels_FileChannelImpl$object *r5;
	struct _jc_java_io_FileDescriptor$object *r6;
	struct _jc_java_io_DataOutputStream$object *r7;
	struct _jc_java_io_FileOutputStream$object *r8;
	struct _jc_java_io_DataInputStream$object *r9;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_LINE_NUMBER(96);				// 0
	z0 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, equals$8a15e0625571c581, 1, r2, _JC_STRING(env, "r"));
	if (z0 == 0)
		goto label0;
	_JC_LINE_NUMBER(97);				// 1
	i0 = 1;
	goto label4;

label0:
	_JC_LINE_NUMBER(98);				// 2
	z0 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, equals$8a15e0625571c581, 0, r2, _JC_STRING(env, "rw"));
	if (z0 == 0)
		goto label1;
	_JC_LINE_NUMBER(99);				// 3
	i0 = 3;
	goto label4;

label1:
	_JC_LINE_NUMBER(100);				// 4
	z0 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, equals$8a15e0625571c581, 0, r2, _JC_STRING(env, "rws"));
	if (z0 == 0)
		goto label2;
	_JC_LINE_NUMBER(102);				// 5
	i0 = 19;
	goto label4;

label2:
	_JC_LINE_NUMBER(105);				// 6
	z0 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, equals$8a15e0625571c581, 0, r2, _JC_STRING(env, "rwd"));
	if (z0 == 0)
		goto label3;
	_JC_LINE_NUMBER(107);				// 7
	i0 = 35;
	goto label4;

label3:
	_JC_LINE_NUMBER(111);				// 8
	r4 = _JC_NEW(env, java_lang_IllegalArgumentException);
	r3 = _JC_NEW(env, java_lang_StringBuffer);
	r20 = _JC_STRING(env, "invalid mode: ");
	i2 = _JC_PRIM_FIELD(env, r20, java_lang_String, count);
	_JC_PRIM_FIELD(env, r3, java_lang_StringBuffer, count) = i2;
	i2 = _JC_PRIM_FIELD(env, r3, java_lang_StringBuffer, count);
	i2 = i2 + 16;
	r21 = _JC_NEW_PRIM_ARRAY(env, char, 1, i2);
	_JC_REF_FIELD(env, r3, java_lang_StringBuffer, value) = r21;
	i2 = _JC_PRIM_FIELD(env, r3, java_lang_StringBuffer, count);
	r21 = _JC_REF_FIELD(env, r3, java_lang_StringBuffer, value);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, getChars$c684dea7317ff063, 0, r20, 0, i2, r21, 0);
	r3 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r3, r2);
	r12 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r12, r3);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r15 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r15;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r12;
	_JC_THROW(env, r4);

label4:
	_JC_LINE_NUMBER(113);				// 9
	r2 = _JC_INVOKE_VIRTUAL(env, java_io_File, getPath$7dfdcb0b5a7c8226, r1);
	_JC_ACTIVE_USE(env, java_lang_System);
	_JC_LINE_NUMBER(116);				// 10
	r11 = _JC_STATIC_FIELD(env, java_lang_SecurityManager, current, 0);
	_JC_LINE_NUMBER(117);				// 11
	if (r11 == _JC_NULL)
		goto label5;
	_JC_LINE_NUMBER(119);				// 12
	_JC_INVOKE_VIRTUAL(env, java_lang_SecurityManager, checkRead$b67431badfc045e6, r11, r2);
	_JC_LINE_NUMBER(121);				// 13
	i1 = i0 & 2;
	if (i1 == 0)
		goto label5;
	_JC_LINE_NUMBER(122);				// 14
	_JC_INVOKE_VIRTUAL(env, java_lang_SecurityManager, checkWrite$e6d6546cc85f9a98, r11, r2);

label5:
	_JC_ACTIVE_USE(env, gnu_java_nio_channels_FileChannelImpl);
	r13 = _JC_NEW(env, gnu_java_nio_channels_FileChannelImpl);
	_JC_INVOKE_NONVIRTUAL(env, gnu_java_nio_channels_FileChannelImpl, _init$ced0bc02a90e180e, 0, r13, r1, i0);
	_JC_LINE_NUMBER(125);				// 15
	_JC_REF_FIELD(env, r0, java_io_RandomAccessFile, ch) = r13;
	_JC_LINE_NUMBER(126);				// 16
	r6 = _JC_NEW(env, java_io_FileDescriptor);
	r5 = _JC_REF_FIELD(env, r0, java_io_RandomAccessFile, ch);
	_JC_REF_FIELD(env, r6, java_io_FileDescriptor, channel) = r5;
	_JC_REF_FIELD(env, r0, java_io_RandomAccessFile, fd) = r6;
	_JC_LINE_NUMBER(127);				// 17
	r7 = _JC_NEW(env, java_io_DataOutputStream);
	r8 = _JC_NEW(env, java_io_FileOutputStream);
	r6 = _JC_REF_FIELD(env, r0, java_io_RandomAccessFile, fd);
	_JC_INVOKE_NONVIRTUAL(env, java_io_FileOutputStream, _init$0c8bd339d1fd1424, 0, r8, r6);
	_JC_REF_FIELD(env, r7, java_io_FilterOutputStream, out) = r8;
	_JC_PRIM_FIELD(env, r7, java_io_DataOutputStream, written) = 0;
	_JC_REF_FIELD(env, r0, java_io_RandomAccessFile, out) = r7;
	_JC_LINE_NUMBER(128);				// 18
	r9 = _JC_NEW(env, java_io_DataInputStream);
	r10 = _JC_NEW(env, java_io_FileInputStream);
	r6 = _JC_REF_FIELD(env, r0, java_io_RandomAccessFile, fd);
	r16 = r6;
	r19 = _JC_STATIC_FIELD(env, java_lang_SecurityManager, current, 1);
	if (r19 == _JC_NULL)
		goto label6;
	_JC_INVOKE_VIRTUAL(env, java_lang_SecurityManager, checkRead$03eb978f6d6d0148, r19, r6);

label6:
	_JC_REF_FIELD(env, r10, java_io_FileInputStream, fd) = r16;
	r17 = _JC_REF_FIELD(env, r16, java_io_FileDescriptor, channel);
	r18 = _JC_CAST_FINAL(env, &_jc_gnu_java_nio_channels_FileChannelImpl$type, r17);
	_JC_REF_FIELD(env, r10, java_io_FileInputStream, ch) = r18;
	_JC_REF_FIELD(env, r9, java_io_FilterInputStream, in) = r10;
	r14 = _JC_NEW_PRIM_ARRAY(env, byte, 1, 8);
	_JC_REF_FIELD(env, r9, java_io_DataInputStream, buf) = r14;
	_JC_REF_FIELD(env, r0, java_io_RandomAccessFile, in) = r9;
	_JC_LINE_NUMBER(129);				// 19
	return;
}

//
// public void <init>(java.lang.String, java.lang.String) throws java.io.FileNotFoundException
//

static _jc_linenum _jc_java_io_RandomAccessFile$linenum_table$_init$a34354cd9552963f[];

static const unsigned char _jc_java_io_RandomAccessFile$param_ptypes$_init$a34354cd9552963f[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_io_RandomAccessFile$exceptions$_init$a34354cd9552963f[] = {
	&_jc_java_io_FileNotFoundException$type
};

static _jc_type *const _jc_java_io_RandomAccessFile$param_types$_init$a34354cd9552963f[] = {
	&_jc_java_lang_String$type,
	&_jc_java_lang_String$type
};

_jc_method _jc_java_io_RandomAccessFile$method_info$_init$a34354cd9552963f = {
	.name=			"<init>",
	.signature=		"(Ljava/lang/String;Ljava/lang/String;)V",
	.class=			&_jc_java_io_RandomAccessFile$type,
	.param_types=		&_jc_java_io_RandomAccessFile$param_types$_init$a34354cd9552963f,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_io_RandomAccessFile$param_ptypes$_init$a34354cd9552963f,
	.signature_hash=	_JC_JLONG(0xa34354cd9552963f),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_io_RandomAccessFile$method$_init$a34354cd9552963f,
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_io_RandomAccessFile$exceptions$_init$a34354cd9552963f,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_io_RandomAccessFile$linenum_table$_init$a34354cd9552963f
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_RandomAccessFile, _init$a34354cd9552963f);

void _JC_JCNI_ATTR
_jc_java_io_RandomAccessFile$method$_init$a34354cd9552963f(_jc_env *const env, _jc_java_io_RandomAccessFile$object *this, _jc_java_lang_String$object *param0, _jc_java_lang_String$object *param1)
{
	struct _jc_java_io_RandomAccessFile$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_java_lang_String$object *r2;
	struct _jc_java_io_File$object *r3;
	struct _jc_java_lang_String$object *r4;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_LINE_NUMBER(156);				// 0
	r3 = _JC_NEW(env, java_io_File);
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_io_File, normalizePath$c82ffbd1adfcec00, 0, r3, r1);
	_JC_REF_FIELD(env, r3, java_io_File, path) = r4;
	_JC_INVOKE_NONVIRTUAL(env, java_io_RandomAccessFile, _init$3edeb17decd6ae04, 0, r0, r3, r2);
	_JC_LINE_NUMBER(157);				// 1
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public void close() throws java.io.IOException
//

static _jc_linenum _jc_java_io_RandomAccessFile$linenum_table$close$6aba8b329fddcd79[];

static const unsigned char _jc_java_io_RandomAccessFile$param_ptypes$close$6aba8b329fddcd79[] = { 
_JC_TYPE_VOID };

static _jc_type *const _jc_java_io_RandomAccessFile$exceptions$close$6aba8b329fddcd79[] = {
	&_jc_java_io_IOException$type
};

_jc_method _jc_java_io_RandomAccessFile$method_info$close$6aba8b329fddcd79 = {
	.name=			"close",
	.signature=		"()V",
	.class=			&_jc_java_io_RandomAccessFile$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_io_RandomAccessFile$param_ptypes$close$6aba8b329fddcd79,
	.signature_hash=	_JC_JLONG(0x6aba8b329fddcd79),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_io_RandomAccessFile$method$close$6aba8b329fddcd79,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_io_RandomAccessFile$vtable, java_io_RandomAccessFile.close$6aba8b329fddcd79) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_io_RandomAccessFile$exceptions$close$6aba8b329fddcd79,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_io_RandomAccessFile$linenum_table$close$6aba8b329fddcd79
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_RandomAccessFile, close$6aba8b329fddcd79);

void _JC_JCNI_ATTR
_jc_java_io_RandomAccessFile$method$close$6aba8b329fddcd79(_jc_env *const env, _jc_java_io_RandomAccessFile$object *this)
{
	struct _jc_java_io_RandomAccessFile$object *r0;
	struct _jc_gnu_java_nio_channels_FileChannelImpl$object *r1;
	jboolean z0;

	r0 = this;
	_JC_LINE_NUMBER(167);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_io_RandomAccessFile, ch);
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	z0 = _JC_PRIM_FIELD(env, r1, java_nio_channels_spi_AbstractInterruptibleChannel, closed);
	if (z0 != 0)
		goto label0;
	_JC_PRIM_FIELD(env, r1, java_nio_channels_spi_AbstractInterruptibleChannel, closed) = 1;
	_JC_INVOKE_NONVIRTUAL(env, gnu_java_nio_channels_FileChannelImpl, implCloseChannel$230ed5fc012167e2, 0, r1);

label0:
	_JC_LINE_NUMBER(168);				// 1
	return;
}

//
// public final synchronized java.nio.channels.FileChannel getChannel()
//

static _jc_linenum _jc_java_io_RandomAccessFile$linenum_table$getChannel$3c77b5fd77098bfe[];

static _jc_trap_info _jc_java_io_RandomAccessFile$trap_table$getChannel$3c77b5fd77098bfe[] = {
	_JC_TRAP(_JC_NULL, 1, 2),
};

static const unsigned char _jc_java_io_RandomAccessFile$param_ptypes$getChannel$3c77b5fd77098bfe[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_java_io_RandomAccessFile$method_info$getChannel$3c77b5fd77098bfe = {
	.name=			"getChannel",
	.signature=		"()Ljava/nio/channels/FileChannel;",
	.class=			&_jc_java_io_RandomAccessFile$type,
	.return_type=		&_jc_java_nio_channels_FileChannel$type,
	.param_ptypes=		&_jc_java_io_RandomAccessFile$param_ptypes$getChannel$3c77b5fd77098bfe,
	.signature_hash=	_JC_JLONG(0x3c77b5fd77098bfe),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL|_JC_ACC_SYNCHRONIZED,
	.function=		&_jc_java_io_RandomAccessFile$method$getChannel$3c77b5fd77098bfe,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_io_RandomAccessFile$vtable, java_io_RandomAccessFile.getChannel$3c77b5fd77098bfe) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .trap_table_len=	1,
	  .trap_table=		_jc_java_io_RandomAccessFile$trap_table$getChannel$3c77b5fd77098bfe,
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_io_RandomAccessFile$linenum_table$getChannel$3c77b5fd77098bfe
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_RandomAccessFile, getChannel$3c77b5fd77098bfe);

_jc_java_nio_channels_FileChannel$object * _JC_JCNI_ATTR
_jc_java_io_RandomAccessFile$method$getChannel$3c77b5fd77098bfe(_jc_env *const env, _jc_java_io_RandomAccessFile$object *this)
{
	struct _jc_java_lang_Throwable$object *volatile exception;
	struct _jc_java_io_RandomAccessFile$object *r0;
	struct _jc_gnu_java_nio_channels_FileChannelImpl$object *r1;
	struct _jc_java_io_RandomAccessFile$object *volatile thisRef;
	_jc_catch_frame	catch;

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_java_io_RandomAccessFile$method_info$getChannel$3c77b5fd77098bfe, &&label0);

	thisRef = this;
	_JC_MONITOR_ENTER(env, thisRef);
	_JC_TRAP_REGION(catch, 1);
	r0 = this;
	_JC_LINE_NUMBER(989);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_io_RandomAccessFile, ch);
	_JC_MONITOR_EXIT(env, thisRef);
	_JC_CANCEL_TRAPS(env, catch);
	return r1;

label0:
	_JC_TRAP_REGION(catch, 2);
	exception = _JC_CAUGHT_EXCEPTION(env);
	_JC_MONITOR_EXIT(env, thisRef);
	_JC_THROW(env, exception);
}

//
// public final java.io.FileDescriptor getFD() throws java.io.IOException
//

static _jc_linenum _jc_java_io_RandomAccessFile$linenum_table$getFD$7bb9e0bad3483351[];

static _jc_trap_info _jc_java_io_RandomAccessFile$trap_table$getFD$7bb9e0bad3483351[] = {
	_JC_TRAP(_JC_NULL, 1, 2),
	_JC_TRAP(_JC_NULL, 3, 4),
};

static const unsigned char _jc_java_io_RandomAccessFile$param_ptypes$getFD$7bb9e0bad3483351[] = { 
_JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_io_RandomAccessFile$exceptions$getFD$7bb9e0bad3483351[] = {
	&_jc_java_io_IOException$type
};

_jc_method _jc_java_io_RandomAccessFile$method_info$getFD$7bb9e0bad3483351 = {
	.name=			"getFD",
	.signature=		"()Ljava/io/FileDescriptor;",
	.class=			&_jc_java_io_RandomAccessFile$type,
	.return_type=		&_jc_java_io_FileDescriptor$type,
	.param_ptypes=		&_jc_java_io_RandomAccessFile$param_ptypes$getFD$7bb9e0bad3483351,
	.signature_hash=	_JC_JLONG(0x7bb9e0bad3483351),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_io_RandomAccessFile$method$getFD$7bb9e0bad3483351,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_io_RandomAccessFile$vtable, java_io_RandomAccessFile.getFD$7bb9e0bad3483351) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_io_RandomAccessFile$exceptions$getFD$7bb9e0bad3483351,
	.u= { .exec= {
	  .trap_table_len=	2,
	  .trap_table=		_jc_java_io_RandomAccessFile$trap_table$getFD$7bb9e0bad3483351,
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_java_io_RandomAccessFile$linenum_table$getFD$7bb9e0bad3483351
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_RandomAccessFile, getFD$7bb9e0bad3483351);

_jc_java_io_FileDescriptor$object * _JC_JCNI_ATTR
_jc_java_io_RandomAccessFile$method$getFD$7bb9e0bad3483351(_jc_env *const env, _jc_java_io_RandomAccessFile$object *this)
{
	struct _jc_java_io_RandomAccessFile$object *volatile r0;
	struct _jc_java_lang_Throwable$object *volatile r1;
	struct _jc_java_io_FileDescriptor$object *r2;
	struct _jc_gnu_java_nio_channels_FileChannelImpl$object *r3;
	_jc_catch_frame	catch;

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_java_io_RandomAccessFile$method_info$getFD$7bb9e0bad3483351, &&label0, &&label0);

	r0 = this;
	_JC_LINE_NUMBER(180);				// 0
	goto label1;

label0:
	_JC_TRAP_REGION(catch, 0);
	_JC_PERIODIC_CHECK(env);
	r1 = _JC_CAUGHT_EXCEPTION(env);
	_JC_TRAP_REGION(catch, 1);
	_JC_MONITOR_EXIT(env, r0);
	_JC_TRAP_REGION(catch, 2);
	_JC_THROW(env, r1);

label1:
	_JC_TRAP_REGION(catch, 2);
	_JC_MONITOR_ENTER(env, r0);
	_JC_TRAP_REGION(catch, 3);
	_JC_LINE_NUMBER(182);				// 1
	r2 = _JC_REF_FIELD(env, r0, java_io_RandomAccessFile, fd);
	if (r2 != _JC_NULL)
		goto label2;
	_JC_LINE_NUMBER(183);				// 2
	r2 = _JC_NEW(env, java_io_FileDescriptor);
	r3 = _JC_REF_FIELD(env, r0, java_io_RandomAccessFile, ch);
	_JC_REF_FIELD(env, r2, java_io_FileDescriptor, channel) = r3;
	_JC_REF_FIELD(env, r0, java_io_RandomAccessFile, fd) = r2;

label2:
	_JC_LINE_NUMBER(184);				// 3
	r2 = _JC_REF_FIELD(env, r0, java_io_RandomAccessFile, fd);
	_JC_MONITOR_EXIT(env, r0);
	_JC_TRAP_REGION(catch, 4);
	_JC_CANCEL_TRAPS(env, catch);
	return r2;
}

//
// public long getFilePointer() throws java.io.IOException
//

static _jc_linenum _jc_java_io_RandomAccessFile$linenum_table$getFilePointer$cbb05d8f3b9ac770[];

static const unsigned char _jc_java_io_RandomAccessFile$param_ptypes$getFilePointer$cbb05d8f3b9ac770[] = { 
_JC_TYPE_LONG };

static _jc_type *const _jc_java_io_RandomAccessFile$exceptions$getFilePointer$cbb05d8f3b9ac770[] = {
	&_jc_java_io_IOException$type
};

_jc_method _jc_java_io_RandomAccessFile$method_info$getFilePointer$cbb05d8f3b9ac770 = {
	.name=			"getFilePointer",
	.signature=		"()J",
	.class=			&_jc_java_io_RandomAccessFile$type,
	.return_type=		&_jc_long$prim$type,
	.param_ptypes=		&_jc_java_io_RandomAccessFile$param_ptypes$getFilePointer$cbb05d8f3b9ac770,
	.signature_hash=	_JC_JLONG(0xcbb05d8f3b9ac770),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_io_RandomAccessFile$method$getFilePointer$cbb05d8f3b9ac770,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_io_RandomAccessFile$vtable, java_io_RandomAccessFile.getFilePointer$cbb05d8f3b9ac770) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_io_RandomAccessFile$exceptions$getFilePointer$cbb05d8f3b9ac770,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_io_RandomAccessFile$linenum_table$getFilePointer$cbb05d8f3b9ac770
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_RandomAccessFile, getFilePointer$cbb05d8f3b9ac770);

jlong _JC_JCNI_ATTR
_jc_java_io_RandomAccessFile$method$getFilePointer$cbb05d8f3b9ac770(_jc_env *const env, _jc_java_io_RandomAccessFile$object *this)
{
	jlong l0;
	struct _jc_java_io_RandomAccessFile$object *r0;
	struct _jc_gnu_java_nio_channels_FileChannelImpl$object *r1;
	struct _jc_java_nio_channels_ClosedChannelException$object *r2;
	struct _jc_java_lang_String$object *r3;
	struct _jc_java_lang_VMThrowable$object *r5;
	jboolean z0;

	r0 = this;
	_JC_LINE_NUMBER(198);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_io_RandomAccessFile, ch);
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	z0 = _JC_PRIM_FIELD(env, r1, java_nio_channels_spi_AbstractInterruptibleChannel, closed);
	z0 = z0 ^ 1;
	if (z0 != 0)
		goto label0;
	r2 = _JC_NEW(env, java_nio_channels_ClosedChannelException);
	r3 = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, cause) = r2;
	r5 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r2);
	_JC_REF_FIELD(env, r2, java_lang_Throwable, vmState) = r5;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, detailMessage) = r3;
	_JC_THROW(env, r2);

label0:
	l0 = _JC_INVOKE_NONVIRTUAL(env, gnu_java_nio_channels_FileChannelImpl, implPosition$176d7e4a36c17935, 0, r1);
	return l0;
}

//
// public long length() throws java.io.IOException
//

static _jc_linenum _jc_java_io_RandomAccessFile$linenum_table$length$c5778ac730410d75[];

static const unsigned char _jc_java_io_RandomAccessFile$param_ptypes$length$c5778ac730410d75[] = { 
_JC_TYPE_LONG };

static _jc_type *const _jc_java_io_RandomAccessFile$exceptions$length$c5778ac730410d75[] = {
	&_jc_java_io_IOException$type
};

_jc_method _jc_java_io_RandomAccessFile$method_info$length$c5778ac730410d75 = {
	.name=			"length",
	.signature=		"()J",
	.class=			&_jc_java_io_RandomAccessFile$type,
	.return_type=		&_jc_long$prim$type,
	.param_ptypes=		&_jc_java_io_RandomAccessFile$param_ptypes$length$c5778ac730410d75,
	.signature_hash=	_JC_JLONG(0xc5778ac730410d75),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_io_RandomAccessFile$method$length$c5778ac730410d75,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_io_RandomAccessFile$vtable, java_io_RandomAccessFile.length$c5778ac730410d75) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_io_RandomAccessFile$exceptions$length$c5778ac730410d75,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_io_RandomAccessFile$linenum_table$length$c5778ac730410d75
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_RandomAccessFile, length$c5778ac730410d75);

jlong _JC_JCNI_ATTR
_jc_java_io_RandomAccessFile$method$length$c5778ac730410d75(_jc_env *const env, _jc_java_io_RandomAccessFile$object *this)
{
	jlong l0;
	struct _jc_java_io_RandomAccessFile$object *r0;
	struct _jc_gnu_java_nio_channels_FileChannelImpl$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(242);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_io_RandomAccessFile, ch);
	l0 = _JC_INVOKE_NONVIRTUAL(env, gnu_java_nio_channels_FileChannelImpl, size$1239e23bc95a984b, 1, r1);
	return l0;
}

//
// public int read() throws java.io.IOException
//

static _jc_linenum _jc_java_io_RandomAccessFile$linenum_table$read$1a981297cb524963[];

static const unsigned char _jc_java_io_RandomAccessFile$param_ptypes$read$1a981297cb524963[] = { 
_JC_TYPE_INT };

static _jc_type *const _jc_java_io_RandomAccessFile$exceptions$read$1a981297cb524963[] = {
	&_jc_java_io_IOException$type
};

_jc_method _jc_java_io_RandomAccessFile$method_info$read$1a981297cb524963 = {
	.name=			"read",
	.signature=		"()I",
	.class=			&_jc_java_io_RandomAccessFile$type,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_java_io_RandomAccessFile$param_ptypes$read$1a981297cb524963,
	.signature_hash=	_JC_JLONG(0x1a981297cb524963),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_io_RandomAccessFile$method$read$1a981297cb524963,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_io_RandomAccessFile$vtable, java_io_RandomAccessFile.read$1a981297cb524963) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_io_RandomAccessFile$exceptions$read$1a981297cb524963,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_io_RandomAccessFile$linenum_table$read$1a981297cb524963
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_RandomAccessFile, read$1a981297cb524963);

jint _JC_JCNI_ATTR
_jc_java_io_RandomAccessFile$method$read$1a981297cb524963(_jc_env *const env, _jc_java_io_RandomAccessFile$object *this)
{
	jint i0;
	struct _jc_java_io_RandomAccessFile$object *r0;
	struct _jc_java_io_DataInputStream$object *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(255);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_io_RandomAccessFile, in);
	i0 = _JC_INVOKE_VIRTUAL(env, java_io_FilterInputStream, read$1a981297cb524963, r1);
	return i0;
}

//
// public int read(byte[]) throws java.io.IOException
//

static _jc_linenum _jc_java_io_RandomAccessFile$linenum_table$read$c38dd905b7fb8654[];

static const unsigned char _jc_java_io_RandomAccessFile$param_ptypes$read$c38dd905b7fb8654[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT };

static _jc_type *const _jc_java_io_RandomAccessFile$exceptions$read$c38dd905b7fb8654[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_java_io_RandomAccessFile$param_types$read$c38dd905b7fb8654[] = {
	&_jc_byte$array$prim$type
};

_jc_method _jc_java_io_RandomAccessFile$method_info$read$c38dd905b7fb8654 = {
	.name=			"read",
	.signature=		"([B)I",
	.class=			&_jc_java_io_RandomAccessFile$type,
	.param_types=		&_jc_java_io_RandomAccessFile$param_types$read$c38dd905b7fb8654,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_java_io_RandomAccessFile$param_ptypes$read$c38dd905b7fb8654,
	.signature_hash=	_JC_JLONG(0xc38dd905b7fb8654),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_io_RandomAccessFile$method$read$c38dd905b7fb8654,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_io_RandomAccessFile$vtable, java_io_RandomAccessFile.read$c38dd905b7fb8654) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_io_RandomAccessFile$exceptions$read$c38dd905b7fb8654,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_io_RandomAccessFile$linenum_table$read$c38dd905b7fb8654
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_RandomAccessFile, read$c38dd905b7fb8654);

jint _JC_JCNI_ATTR
_jc_java_io_RandomAccessFile$method$read$c38dd905b7fb8654(_jc_env *const env, _jc_java_io_RandomAccessFile$object *this, _jc_byte_array *param0)
{
	jint i1;
	struct _jc_java_io_RandomAccessFile$object *r0;
	_jc_byte_array *r1;
	struct _jc_java_io_DataInputStream$object *r2;
	struct _jc_java_io_InputStream$object *r5;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(271);				// 0
	r2 = _JC_REF_FIELD(env, r0, java_io_RandomAccessFile, in);
	_JC_EXPLICIT_NULL_CHECK(env, r2);
	r5 = _JC_REF_FIELD(env, r2, java_io_FilterInputStream, in);
	i1 = _JC_ARRAY_LENGTH(env, r1);
	i1 = _JC_INVOKE_VIRTUAL(env, java_io_InputStream, read$e6b6c87b9f256783, r5, r1, 0, i1);
	return i1;
}

//
// public int read(byte[], int, int) throws java.io.IOException
//

static _jc_linenum _jc_java_io_RandomAccessFile$linenum_table$read$e6b6c87b9f256783[];

static const unsigned char _jc_java_io_RandomAccessFile$param_ptypes$read$e6b6c87b9f256783[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_INT, _JC_TYPE_INT };

static _jc_type *const _jc_java_io_RandomAccessFile$exceptions$read$e6b6c87b9f256783[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_java_io_RandomAccessFile$param_types$read$e6b6c87b9f256783[] = {
	&_jc_byte$array$prim$type,
	&_jc_int$prim$type,
	&_jc_int$prim$type
};

_jc_method _jc_java_io_RandomAccessFile$method_info$read$e6b6c87b9f256783 = {
	.name=			"read",
	.signature=		"([BII)I",
	.class=			&_jc_java_io_RandomAccessFile$type,
	.param_types=		&_jc_java_io_RandomAccessFile$param_types$read$e6b6c87b9f256783,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_java_io_RandomAccessFile$param_ptypes$read$e6b6c87b9f256783,
	.signature_hash=	_JC_JLONG(0xe6b6c87b9f256783),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_io_RandomAccessFile$method$read$e6b6c87b9f256783,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_io_RandomAccessFile$vtable, java_io_RandomAccessFile.read$e6b6c87b9f256783) / sizeof(void *),
	.num_parameters=	3,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_io_RandomAccessFile$exceptions$read$e6b6c87b9f256783,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_io_RandomAccessFile$linenum_table$read$e6b6c87b9f256783
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_RandomAccessFile, read$e6b6c87b9f256783);

jint _JC_JCNI_ATTR
_jc_java_io_RandomAccessFile$method$read$e6b6c87b9f256783(_jc_env *const env, _jc_java_io_RandomAccessFile$object *this, _jc_byte_array *param0, jint param1, jint param2)
{
	jint i0;
	jint i1;
	jint i3;
	struct _jc_java_io_RandomAccessFile$object *r0;
	_jc_byte_array *r1;
	struct _jc_java_io_DataInputStream$object *r2;
	struct _jc_java_io_InputStream$object *r5;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	i0 = param1;
	i1 = param2;
	_JC_LINE_NUMBER(288);				// 0
	r2 = _JC_REF_FIELD(env, r0, java_io_RandomAccessFile, in);
	_JC_EXPLICIT_NULL_CHECK(env, r2);
	r5 = _JC_REF_FIELD(env, r2, java_io_FilterInputStream, in);
	i3 = _JC_INVOKE_VIRTUAL(env, java_io_InputStream, read$e6b6c87b9f256783, r5, r1, i0, i1);
	return i3;
}

//
// public final boolean readBoolean() throws java.io.IOException
//

static _jc_linenum _jc_java_io_RandomAccessFile$linenum_table$readBoolean$607823a0fe7654c1[];

static const unsigned char _jc_java_io_RandomAccessFile$param_ptypes$readBoolean$607823a0fe7654c1[] = { 
_JC_TYPE_BOOLEAN };

static _jc_type *const _jc_java_io_RandomAccessFile$exceptions$readBoolean$607823a0fe7654c1[] = {
	&_jc_java_io_IOException$type
};

_jc_method _jc_java_io_RandomAccessFile$method_info$readBoolean$607823a0fe7654c1 = {
	.name=			"readBoolean",
	.signature=		"()Z",
	.class=			&_jc_java_io_RandomAccessFile$type,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_java_io_RandomAccessFile$param_ptypes$readBoolean$607823a0fe7654c1,
	.signature_hash=	_JC_JLONG(0x607823a0fe7654c1),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_io_RandomAccessFile$method$readBoolean$607823a0fe7654c1,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_io_RandomAccessFile$vtable, java_io_RandomAccessFile.readBoolean$607823a0fe7654c1) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_io_RandomAccessFile$exceptions$readBoolean$607823a0fe7654c1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_io_RandomAccessFile$linenum_table$readBoolean$607823a0fe7654c1
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_RandomAccessFile, readBoolean$607823a0fe7654c1);

jboolean _JC_JCNI_ATTR
_jc_java_io_RandomAccessFile$method$readBoolean$607823a0fe7654c1(_jc_env *const env, _jc_java_io_RandomAccessFile$object *this)
{
	jint i0;
	struct _jc_java_io_RandomAccessFile$object *r0;
	struct _jc_java_io_DataInputStream$object *r1;
	struct _jc_java_io_InputStream$object *r2;
	struct _jc_java_io_EOFException$object *r3;
	struct _jc_java_lang_String$object *r4;
	struct _jc_java_lang_VMThrowable$object *r6;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(310);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_io_RandomAccessFile, in);
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	r2 = _JC_REF_FIELD(env, r1, java_io_FilterInputStream, in);
	i0 = _JC_INVOKE_VIRTUAL(env, java_io_InputStream, read$1a981297cb524963, r2);
	_JC_ACTIVE_USE(env, java_io_DataInputStream);
	if (i0 >= 0)
		goto label0;
	r3 = _JC_NEW(env, java_io_EOFException);
	r4 = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r6 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r6;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r4;
	_JC_THROW(env, r3);

label0:
	z0 = 0;
	if (i0 == 0)
		goto label1;
	z0 = 1;

label1:
	return z0;
}

//
// public final byte readByte() throws java.io.IOException
//

static _jc_linenum _jc_java_io_RandomAccessFile$linenum_table$readByte$f0077b1d2a79a660[];

static const unsigned char _jc_java_io_RandomAccessFile$param_ptypes$readByte$f0077b1d2a79a660[] = { 
_JC_TYPE_BYTE };

static _jc_type *const _jc_java_io_RandomAccessFile$exceptions$readByte$f0077b1d2a79a660[] = {
	&_jc_java_io_IOException$type
};

_jc_method _jc_java_io_RandomAccessFile$method_info$readByte$f0077b1d2a79a660 = {
	.name=			"readByte",
	.signature=		"()B",
	.class=			&_jc_java_io_RandomAccessFile$type,
	.return_type=		&_jc_byte$prim$type,
	.param_ptypes=		&_jc_java_io_RandomAccessFile$param_ptypes$readByte$f0077b1d2a79a660,
	.signature_hash=	_JC_JLONG(0xf0077b1d2a79a660),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_io_RandomAccessFile$method$readByte$f0077b1d2a79a660,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_io_RandomAccessFile$vtable, java_io_RandomAccessFile.readByte$f0077b1d2a79a660) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_io_RandomAccessFile$exceptions$readByte$f0077b1d2a79a660,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_io_RandomAccessFile$linenum_table$readByte$f0077b1d2a79a660
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_RandomAccessFile, readByte$f0077b1d2a79a660);

jbyte _JC_JCNI_ATTR
_jc_java_io_RandomAccessFile$method$readByte$f0077b1d2a79a660(_jc_env *const env, _jc_java_io_RandomAccessFile$object *this)
{
	jbyte b1;
	jint i0;
	struct _jc_java_io_RandomAccessFile$object *r0;
	struct _jc_java_io_DataInputStream$object *r1;
	struct _jc_java_io_InputStream$object *r2;
	struct _jc_java_io_EOFException$object *r3;
	struct _jc_java_lang_String$object *r4;
	struct _jc_java_lang_VMThrowable$object *r6;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(330);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_io_RandomAccessFile, in);
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	r2 = _JC_REF_FIELD(env, r1, java_io_FilterInputStream, in);
	i0 = _JC_INVOKE_VIRTUAL(env, java_io_InputStream, read$1a981297cb524963, r2);
	_JC_ACTIVE_USE(env, java_io_DataInputStream);
	if (i0 >= 0)
		goto label0;
	r3 = _JC_NEW(env, java_io_EOFException);
	r4 = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r6 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r6;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r4;
	_JC_THROW(env, r3);

label0:
	b1 = (jbyte)i0;
	return b1;
}

//
// public final char readChar() throws java.io.IOException
//

static _jc_linenum _jc_java_io_RandomAccessFile$linenum_table$readChar$1f45f598ccf24d5b[];

static const unsigned char _jc_java_io_RandomAccessFile$param_ptypes$readChar$1f45f598ccf24d5b[] = { 
_JC_TYPE_CHAR };

static _jc_type *const _jc_java_io_RandomAccessFile$exceptions$readChar$1f45f598ccf24d5b[] = {
	&_jc_java_io_IOException$type
};

_jc_method _jc_java_io_RandomAccessFile$method_info$readChar$1f45f598ccf24d5b = {
	.name=			"readChar",
	.signature=		"()C",
	.class=			&_jc_java_io_RandomAccessFile$type,
	.return_type=		&_jc_char$prim$type,
	.param_ptypes=		&_jc_java_io_RandomAccessFile$param_ptypes$readChar$1f45f598ccf24d5b,
	.signature_hash=	_JC_JLONG(0x1f45f598ccf24d5b),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_io_RandomAccessFile$method$readChar$1f45f598ccf24d5b,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_io_RandomAccessFile$vtable, java_io_RandomAccessFile.readChar$1f45f598ccf24d5b) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_io_RandomAccessFile$exceptions$readChar$1f45f598ccf24d5b,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_io_RandomAccessFile$linenum_table$readChar$1f45f598ccf24d5b
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_RandomAccessFile, readChar$1f45f598ccf24d5b);

jchar _JC_JCNI_ATTR
_jc_java_io_RandomAccessFile$method$readChar$1f45f598ccf24d5b(_jc_env *const env, _jc_java_io_RandomAccessFile$object *this)
{
	jbyte b1;
	jchar c4;
	jint i2;
	struct _jc_java_io_RandomAccessFile$object *r0;
	struct _jc_java_io_DataInputStream$object *r1;
	_jc_byte_array *r2;
	jshort s3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(360);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_io_RandomAccessFile, in);
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	r2 = _JC_REF_FIELD(env, r1, java_io_DataInputStream, buf);
	_JC_INVOKE_NONVIRTUAL(env, java_io_DataInputStream, readFully$63e0ddb7f8315fc6, 0, r1, r2, 0, 2);
	r2 = _JC_REF_FIELD(env, r1, java_io_DataInputStream, buf);
	b1 = _JC_PRIM_ELEMENT(env, byte, r2, 0, 0, 1);
	i2 = b1 << (8 & 0x1f);
	b1 = _JC_PRIM_ELEMENT(env, byte, r2, 1, 0, 1);
	s3 = b1 & 255;
	i2 = i2 | s3;
	c4 = (jchar)i2;
	return c4;
}

//
// public final double readDouble() throws java.io.IOException
//

static _jc_linenum _jc_java_io_RandomAccessFile$linenum_table$readDouble$6afd40b36b9672ac[];

static const unsigned char _jc_java_io_RandomAccessFile$param_ptypes$readDouble$6afd40b36b9672ac[] = { 
_JC_TYPE_DOUBLE };

static _jc_type *const _jc_java_io_RandomAccessFile$exceptions$readDouble$6afd40b36b9672ac[] = {
	&_jc_java_io_IOException$type
};

_jc_method _jc_java_io_RandomAccessFile$method_info$readDouble$6afd40b36b9672ac = {
	.name=			"readDouble",
	.signature=		"()D",
	.class=			&_jc_java_io_RandomAccessFile$type,
	.return_type=		&_jc_double$prim$type,
	.param_ptypes=		&_jc_java_io_RandomAccessFile$param_ptypes$readDouble$6afd40b36b9672ac,
	.signature_hash=	_JC_JLONG(0x6afd40b36b9672ac),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_io_RandomAccessFile$method$readDouble$6afd40b36b9672ac,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_io_RandomAccessFile$vtable, java_io_RandomAccessFile.readDouble$6afd40b36b9672ac) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_io_RandomAccessFile$exceptions$readDouble$6afd40b36b9672ac,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_io_RandomAccessFile$linenum_table$readDouble$6afd40b36b9672ac
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_RandomAccessFile, readDouble$6afd40b36b9672ac);

jdouble _JC_JCNI_ATTR
_jc_java_io_RandomAccessFile$method$readDouble$6afd40b36b9672ac(_jc_env *const env, _jc_java_io_RandomAccessFile$object *this)
{
	jdouble d0;
	jlong l1;
	struct _jc_java_io_RandomAccessFile$object *r0;
	struct _jc_java_io_DataInputStream$object *r1;
	_jc_byte_array *r3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(387);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_io_RandomAccessFile, in);
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	r3 = _JC_REF_FIELD(env, r1, java_io_DataInputStream, buf);
	_JC_INVOKE_NONVIRTUAL(env, java_io_DataInputStream, readFully$63e0ddb7f8315fc6, 0, r1, r3, 0, 8);
	r3 = _JC_REF_FIELD(env, r1, java_io_DataInputStream, buf);
	l1 = _JC_INVOKE_STATIC(env, java_io_DataInputStream, convertToLong$9bfb359fdaa63e31, 1, r3);
	_JC_ACTIVE_USE(env, java_lang_Double);
	d0 = _JC_INVOKE_STATIC(env, java_lang_VMDouble, longBitsToDouble$98edc49cf5e749a2, 0, l1);
	return d0;
}

//
// public final float readFloat() throws java.io.IOException
//

static _jc_linenum _jc_java_io_RandomAccessFile$linenum_table$readFloat$91949088cf9525fc[];

static const unsigned char _jc_java_io_RandomAccessFile$param_ptypes$readFloat$91949088cf9525fc[] = { 
_JC_TYPE_FLOAT };

static _jc_type *const _jc_java_io_RandomAccessFile$exceptions$readFloat$91949088cf9525fc[] = {
	&_jc_java_io_IOException$type
};

_jc_method _jc_java_io_RandomAccessFile$method_info$readFloat$91949088cf9525fc = {
	.name=			"readFloat",
	.signature=		"()F",
	.class=			&_jc_java_io_RandomAccessFile$type,
	.return_type=		&_jc_float$prim$type,
	.param_ptypes=		&_jc_java_io_RandomAccessFile$param_ptypes$readFloat$91949088cf9525fc,
	.signature_hash=	_JC_JLONG(0x91949088cf9525fc),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_io_RandomAccessFile$method$readFloat$91949088cf9525fc,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_io_RandomAccessFile$vtable, java_io_RandomAccessFile.readFloat$91949088cf9525fc) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_io_RandomAccessFile$exceptions$readFloat$91949088cf9525fc,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_io_RandomAccessFile$linenum_table$readFloat$91949088cf9525fc
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_RandomAccessFile, readFloat$91949088cf9525fc);

jfloat _JC_JCNI_ATTR
_jc_java_io_RandomAccessFile$method$readFloat$91949088cf9525fc(_jc_env *const env, _jc_java_io_RandomAccessFile$object *this)
{
	jfloat f0;
	jint i1;
	struct _jc_java_io_RandomAccessFile$object *r0;
	struct _jc_java_io_DataInputStream$object *r1;
	_jc_byte_array *r3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(412);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_io_RandomAccessFile, in);
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	r3 = _JC_REF_FIELD(env, r1, java_io_DataInputStream, buf);
	_JC_INVOKE_NONVIRTUAL(env, java_io_DataInputStream, readFully$63e0ddb7f8315fc6, 0, r1, r3, 0, 4);
	r3 = _JC_REF_FIELD(env, r1, java_io_DataInputStream, buf);
	i1 = _JC_INVOKE_STATIC(env, java_io_DataInputStream, convertToInt$bcff18628bcbac61, 1, r3);
	_JC_ACTIVE_USE(env, java_lang_Float);
	f0 = _JC_INVOKE_STATIC(env, java_lang_VMFloat, intBitsToFloat$dbc520b5c53cb7dc, 0, i1);
	return f0;
}

//
// public final void readFully(byte[]) throws java.io.IOException
//

static _jc_linenum _jc_java_io_RandomAccessFile$linenum_table$readFully$2c917249902aa549[];

static const unsigned char _jc_java_io_RandomAccessFile$param_ptypes$readFully$2c917249902aa549[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_io_RandomAccessFile$exceptions$readFully$2c917249902aa549[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_java_io_RandomAccessFile$param_types$readFully$2c917249902aa549[] = {
	&_jc_byte$array$prim$type
};

_jc_method _jc_java_io_RandomAccessFile$method_info$readFully$2c917249902aa549 = {
	.name=			"readFully",
	.signature=		"([B)V",
	.class=			&_jc_java_io_RandomAccessFile$type,
	.param_types=		&_jc_java_io_RandomAccessFile$param_types$readFully$2c917249902aa549,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_io_RandomAccessFile$param_ptypes$readFully$2c917249902aa549,
	.signature_hash=	_JC_JLONG(0x2c917249902aa549),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_io_RandomAccessFile$method$readFully$2c917249902aa549,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_io_RandomAccessFile$vtable, java_io_RandomAccessFile.readFully$2c917249902aa549) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_io_RandomAccessFile$exceptions$readFully$2c917249902aa549,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_io_RandomAccessFile$linenum_table$readFully$2c917249902aa549
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_RandomAccessFile, readFully$2c917249902aa549);

void _JC_JCNI_ATTR
_jc_java_io_RandomAccessFile$method$readFully$2c917249902aa549(_jc_env *const env, _jc_java_io_RandomAccessFile$object *this, _jc_byte_array *param0)
{
	jint i0;
	struct _jc_java_io_RandomAccessFile$object *r0;
	_jc_byte_array *r1;
	struct _jc_java_io_DataInputStream$object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(429);				// 0
	r2 = _JC_REF_FIELD(env, r0, java_io_RandomAccessFile, in);
	_JC_EXPLICIT_NULL_CHECK(env, r2);
	i0 = _JC_ARRAY_LENGTH(env, r1);
	_JC_INVOKE_NONVIRTUAL(env, java_io_DataInputStream, readFully$63e0ddb7f8315fc6, 0, r2, r1, 0, i0);
	_JC_LINE_NUMBER(430);				// 1
	return;
}

//
// public final void readFully(byte[], int, int) throws java.io.IOException
//

static _jc_linenum _jc_java_io_RandomAccessFile$linenum_table$readFully$63e0ddb7f8315fc6[];

static const unsigned char _jc_java_io_RandomAccessFile$param_ptypes$readFully$63e0ddb7f8315fc6[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_INT, _JC_TYPE_VOID };

static _jc_type *const _jc_java_io_RandomAccessFile$exceptions$readFully$63e0ddb7f8315fc6[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_java_io_RandomAccessFile$param_types$readFully$63e0ddb7f8315fc6[] = {
	&_jc_byte$array$prim$type,
	&_jc_int$prim$type,
	&_jc_int$prim$type
};

_jc_method _jc_java_io_RandomAccessFile$method_info$readFully$63e0ddb7f8315fc6 = {
	.name=			"readFully",
	.signature=		"([BII)V",
	.class=			&_jc_java_io_RandomAccessFile$type,
	.param_types=		&_jc_java_io_RandomAccessFile$param_types$readFully$63e0ddb7f8315fc6,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_io_RandomAccessFile$param_ptypes$readFully$63e0ddb7f8315fc6,
	.signature_hash=	_JC_JLONG(0x63e0ddb7f8315fc6),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_io_RandomAccessFile$method$readFully$63e0ddb7f8315fc6,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_io_RandomAccessFile$vtable, java_io_RandomAccessFile.readFully$63e0ddb7f8315fc6) / sizeof(void *),
	.num_parameters=	3,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_io_RandomAccessFile$exceptions$readFully$63e0ddb7f8315fc6,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_io_RandomAccessFile$linenum_table$readFully$63e0ddb7f8315fc6
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_RandomAccessFile, readFully$63e0ddb7f8315fc6);

void _JC_JCNI_ATTR
_jc_java_io_RandomAccessFile$method$readFully$63e0ddb7f8315fc6(_jc_env *const env, _jc_java_io_RandomAccessFile$object *this, _jc_byte_array *param0, jint param1, jint param2)
{
	jint i0;
	jint i1;
	struct _jc_java_io_RandomAccessFile$object *r0;
	_jc_byte_array *r1;
	struct _jc_java_io_DataInputStream$object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	i0 = param1;
	i1 = param2;
	_JC_LINE_NUMBER(452);				// 0
	r2 = _JC_REF_FIELD(env, r0, java_io_RandomAccessFile, in);
	_JC_INVOKE_NONVIRTUAL(env, java_io_DataInputStream, readFully$63e0ddb7f8315fc6, 1, r2, r1, i0, i1);
	_JC_LINE_NUMBER(453);				// 1
	return;
}

//
// public final int readInt() throws java.io.IOException
//

static _jc_linenum _jc_java_io_RandomAccessFile$linenum_table$readInt$029bcbc9fec7ab9a[];

static const unsigned char _jc_java_io_RandomAccessFile$param_ptypes$readInt$029bcbc9fec7ab9a[] = { 
_JC_TYPE_INT };

static _jc_type *const _jc_java_io_RandomAccessFile$exceptions$readInt$029bcbc9fec7ab9a[] = {
	&_jc_java_io_IOException$type
};

_jc_method _jc_java_io_RandomAccessFile$method_info$readInt$029bcbc9fec7ab9a = {
	.name=			"readInt",
	.signature=		"()I",
	.class=			&_jc_java_io_RandomAccessFile$type,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_java_io_RandomAccessFile$param_ptypes$readInt$029bcbc9fec7ab9a,
	.signature_hash=	_JC_JLONG(0x29bcbc9fec7ab9a),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_io_RandomAccessFile$method$readInt$029bcbc9fec7ab9a,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_io_RandomAccessFile$vtable, java_io_RandomAccessFile.readInt$029bcbc9fec7ab9a) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_io_RandomAccessFile$exceptions$readInt$029bcbc9fec7ab9a,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_io_RandomAccessFile$linenum_table$readInt$029bcbc9fec7ab9a
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_RandomAccessFile, readInt$029bcbc9fec7ab9a);

jint _JC_JCNI_ATTR
_jc_java_io_RandomAccessFile$method$readInt$029bcbc9fec7ab9a(_jc_env *const env, _jc_java_io_RandomAccessFile$object *this)
{
	jint i1;
	struct _jc_java_io_RandomAccessFile$object *r0;
	struct _jc_java_io_DataInputStream$object *r1;
	_jc_byte_array *r3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(485);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_io_RandomAccessFile, in);
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	r3 = _JC_REF_FIELD(env, r1, java_io_DataInputStream, buf);
	_JC_INVOKE_NONVIRTUAL(env, java_io_DataInputStream, readFully$63e0ddb7f8315fc6, 0, r1, r3, 0, 4);
	r3 = _JC_REF_FIELD(env, r1, java_io_DataInputStream, buf);
	i1 = _JC_INVOKE_STATIC(env, java_io_DataInputStream, convertToInt$bcff18628bcbac61, 1, r3);
	return i1;
}

//
// public final java.lang.String readLine() throws java.io.IOException
//

static _jc_linenum _jc_java_io_RandomAccessFile$linenum_table$readLine$d32396e6ff161651[];

static const unsigned char _jc_java_io_RandomAccessFile$param_ptypes$readLine$d32396e6ff161651[] = { 
_JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_io_RandomAccessFile$exceptions$readLine$d32396e6ff161651[] = {
	&_jc_java_io_IOException$type
};

_jc_method _jc_java_io_RandomAccessFile$method_info$readLine$d32396e6ff161651 = {
	.name=			"readLine",
	.signature=		"()Ljava/lang/String;",
	.class=			&_jc_java_io_RandomAccessFile$type,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_java_io_RandomAccessFile$param_ptypes$readLine$d32396e6ff161651,
	.signature_hash=	_JC_JLONG(0xd32396e6ff161651),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_io_RandomAccessFile$method$readLine$d32396e6ff161651,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_io_RandomAccessFile$vtable, java_io_RandomAccessFile.readLine$d32396e6ff161651) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_io_RandomAccessFile$exceptions$readLine$d32396e6ff161651,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_io_RandomAccessFile$linenum_table$readLine$d32396e6ff161651
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_RandomAccessFile, readLine$d32396e6ff161651);

_jc_java_lang_String$object * _JC_JCNI_ATTR
_jc_java_io_RandomAccessFile$method$readLine$d32396e6ff161651(_jc_env *const env, _jc_java_io_RandomAccessFile$object *this)
{
	struct _jc_java_io_RandomAccessFile$object *r0;
	struct _jc_java_io_DataInputStream$object *r1;
	struct _jc_java_lang_String$object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(515);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_io_RandomAccessFile, in);
	r2 = _JC_INVOKE_NONVIRTUAL(env, java_io_DataInputStream, readLine$d32396e6ff161651, 1, r1);
	return r2;
}

//
// public final long readLong() throws java.io.IOException
//

static _jc_linenum _jc_java_io_RandomAccessFile$linenum_table$readLong$2cb13656e73083dd[];

static const unsigned char _jc_java_io_RandomAccessFile$param_ptypes$readLong$2cb13656e73083dd[] = { 
_JC_TYPE_LONG };

static _jc_type *const _jc_java_io_RandomAccessFile$exceptions$readLong$2cb13656e73083dd[] = {
	&_jc_java_io_IOException$type
};

_jc_method _jc_java_io_RandomAccessFile$method_info$readLong$2cb13656e73083dd = {
	.name=			"readLong",
	.signature=		"()J",
	.class=			&_jc_java_io_RandomAccessFile$type,
	.return_type=		&_jc_long$prim$type,
	.param_ptypes=		&_jc_java_io_RandomAccessFile$param_ptypes$readLong$2cb13656e73083dd,
	.signature_hash=	_JC_JLONG(0x2cb13656e73083dd),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_io_RandomAccessFile$method$readLong$2cb13656e73083dd,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_io_RandomAccessFile$vtable, java_io_RandomAccessFile.readLong$2cb13656e73083dd) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_io_RandomAccessFile$exceptions$readLong$2cb13656e73083dd,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_io_RandomAccessFile$linenum_table$readLong$2cb13656e73083dd
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_RandomAccessFile, readLong$2cb13656e73083dd);

jlong _JC_JCNI_ATTR
_jc_java_io_RandomAccessFile$method$readLong$2cb13656e73083dd(_jc_env *const env, _jc_java_io_RandomAccessFile$object *this)
{
	jlong l1;
	struct _jc_java_io_RandomAccessFile$object *r0;
	struct _jc_java_io_DataInputStream$object *r1;
	_jc_byte_array *r3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(551);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_io_RandomAccessFile, in);
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	r3 = _JC_REF_FIELD(env, r1, java_io_DataInputStream, buf);
	_JC_INVOKE_NONVIRTUAL(env, java_io_DataInputStream, readFully$63e0ddb7f8315fc6, 0, r1, r3, 0, 8);
	r3 = _JC_REF_FIELD(env, r1, java_io_DataInputStream, buf);
	l1 = _JC_INVOKE_STATIC(env, java_io_DataInputStream, convertToLong$9bfb359fdaa63e31, 1, r3);
	return l1;
}

//
// public final short readShort() throws java.io.IOException
//

static _jc_linenum _jc_java_io_RandomAccessFile$linenum_table$readShort$e2cbe212abc25f7a[];

static const unsigned char _jc_java_io_RandomAccessFile$param_ptypes$readShort$e2cbe212abc25f7a[] = { 
_JC_TYPE_SHORT };

static _jc_type *const _jc_java_io_RandomAccessFile$exceptions$readShort$e2cbe212abc25f7a[] = {
	&_jc_java_io_IOException$type
};

_jc_method _jc_java_io_RandomAccessFile$method_info$readShort$e2cbe212abc25f7a = {
	.name=			"readShort",
	.signature=		"()S",
	.class=			&_jc_java_io_RandomAccessFile$type,
	.return_type=		&_jc_short$prim$type,
	.param_ptypes=		&_jc_java_io_RandomAccessFile$param_ptypes$readShort$e2cbe212abc25f7a,
	.signature_hash=	_JC_JLONG(0xe2cbe212abc25f7a),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_io_RandomAccessFile$method$readShort$e2cbe212abc25f7a,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_io_RandomAccessFile$vtable, java_io_RandomAccessFile.readShort$e2cbe212abc25f7a) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_io_RandomAccessFile$exceptions$readShort$e2cbe212abc25f7a,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_io_RandomAccessFile$linenum_table$readShort$e2cbe212abc25f7a
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_RandomAccessFile, readShort$e2cbe212abc25f7a);

jshort _JC_JCNI_ATTR
_jc_java_io_RandomAccessFile$method$readShort$e2cbe212abc25f7a(_jc_env *const env, _jc_java_io_RandomAccessFile$object *this)
{
	jbyte b1;
	jint i2;
	struct _jc_java_io_RandomAccessFile$object *r0;
	struct _jc_java_io_DataInputStream$object *r1;
	_jc_byte_array *r2;
	jshort s3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(583);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_io_RandomAccessFile, in);
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	r2 = _JC_REF_FIELD(env, r1, java_io_DataInputStream, buf);
	_JC_INVOKE_NONVIRTUAL(env, java_io_DataInputStream, readFully$63e0ddb7f8315fc6, 0, r1, r2, 0, 2);
	r2 = _JC_REF_FIELD(env, r1, java_io_DataInputStream, buf);
	b1 = _JC_PRIM_ELEMENT(env, byte, r2, 0, 0, 1);
	i2 = b1 << (8 & 0x1f);
	b1 = _JC_PRIM_ELEMENT(env, byte, r2, 1, 0, 1);
	s3 = b1 & 255;
	i2 = i2 | s3;
	s3 = (jshort)i2;
	return s3;
}

//
// public final java.lang.String readUTF() throws java.io.IOException
//

static _jc_linenum _jc_java_io_RandomAccessFile$linenum_table$readUTF$79add8d8f65f55bb[];

static const unsigned char _jc_java_io_RandomAccessFile$param_ptypes$readUTF$79add8d8f65f55bb[] = { 
_JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_io_RandomAccessFile$exceptions$readUTF$79add8d8f65f55bb[] = {
	&_jc_java_io_IOException$type
};

_jc_method _jc_java_io_RandomAccessFile$method_info$readUTF$79add8d8f65f55bb = {
	.name=			"readUTF",
	.signature=		"()Ljava/lang/String;",
	.class=			&_jc_java_io_RandomAccessFile$type,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_java_io_RandomAccessFile$param_ptypes$readUTF$79add8d8f65f55bb,
	.signature_hash=	_JC_JLONG(0x79add8d8f65f55bb),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_io_RandomAccessFile$method$readUTF$79add8d8f65f55bb,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_io_RandomAccessFile$vtable, java_io_RandomAccessFile.readUTF$79add8d8f65f55bb) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_io_RandomAccessFile$exceptions$readUTF$79add8d8f65f55bb,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_io_RandomAccessFile$linenum_table$readUTF$79add8d8f65f55bb
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_RandomAccessFile, readUTF$79add8d8f65f55bb);

_jc_java_lang_String$object * _JC_JCNI_ATTR
_jc_java_io_RandomAccessFile$method$readUTF$79add8d8f65f55bb(_jc_env *const env, _jc_java_io_RandomAccessFile$object *this)
{
	jint i0;
	struct _jc_java_io_RandomAccessFile$object *r0;
	struct _jc_java_io_DataInputStream$object *r1;
	_jc_byte_array *r4;
	struct _jc_java_lang_String$object *r5;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(711);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_io_RandomAccessFile, in);
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	_JC_ACTIVE_USE(env, java_io_DataInputStream);
	i0 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0x3fa3a6c504cc2667), jint, (_jc_env *, struct _jc_object *));
	r4 = _JC_NEW_PRIM_ARRAY(env, byte, 1, i0);
	_JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0x63e0ddb7f8315fc6), void, (_jc_env *, struct _jc_object *, struct _jc_byte_array *, jint, jint), r4, 0, i0);
	r5 = _JC_INVOKE_STATIC(env, java_io_DataInputStream, convertFromUTF$eeb20d2887552832, 1, r4);
	return r5;
}

//
// public final int readUnsignedByte() throws java.io.IOException
//

static _jc_linenum _jc_java_io_RandomAccessFile$linenum_table$readUnsignedByte$b813876e99050350[];

static const unsigned char _jc_java_io_RandomAccessFile$param_ptypes$readUnsignedByte$b813876e99050350[] = { 
_JC_TYPE_INT };

static _jc_type *const _jc_java_io_RandomAccessFile$exceptions$readUnsignedByte$b813876e99050350[] = {
	&_jc_java_io_IOException$type
};

_jc_method _jc_java_io_RandomAccessFile$method_info$readUnsignedByte$b813876e99050350 = {
	.name=			"readUnsignedByte",
	.signature=		"()I",
	.class=			&_jc_java_io_RandomAccessFile$type,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_java_io_RandomAccessFile$param_ptypes$readUnsignedByte$b813876e99050350,
	.signature_hash=	_JC_JLONG(0xb813876e99050350),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_io_RandomAccessFile$method$readUnsignedByte$b813876e99050350,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_io_RandomAccessFile$vtable, java_io_RandomAccessFile.readUnsignedByte$b813876e99050350) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_io_RandomAccessFile$exceptions$readUnsignedByte$b813876e99050350,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_io_RandomAccessFile$linenum_table$readUnsignedByte$b813876e99050350
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_RandomAccessFile, readUnsignedByte$b813876e99050350);

jint _JC_JCNI_ATTR
_jc_java_io_RandomAccessFile$method$readUnsignedByte$b813876e99050350(_jc_env *const env, _jc_java_io_RandomAccessFile$object *this)
{
	jint i0;
	jint i1;
	struct _jc_java_io_RandomAccessFile$object *r0;
	struct _jc_java_io_DataInputStream$object *r1;
	struct _jc_java_io_InputStream$object *r2;
	struct _jc_java_io_EOFException$object *r3;
	struct _jc_java_lang_String$object *r4;
	struct _jc_java_lang_VMThrowable$object *r6;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(604);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_io_RandomAccessFile, in);
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	r2 = _JC_REF_FIELD(env, r1, java_io_FilterInputStream, in);
	i0 = _JC_INVOKE_VIRTUAL(env, java_io_InputStream, read$1a981297cb524963, r2);
	_JC_ACTIVE_USE(env, java_io_DataInputStream);
	if (i0 >= 0)
		goto label0;
	r3 = _JC_NEW(env, java_io_EOFException);
	r4 = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r6 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r6;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r4;
	_JC_THROW(env, r3);

label0:
	i1 = i0 & 255;
	return i1;
}

//
// public final int readUnsignedShort() throws java.io.IOException
//

static _jc_linenum _jc_java_io_RandomAccessFile$linenum_table$readUnsignedShort$3fa3a6c504cc2667[];

static const unsigned char _jc_java_io_RandomAccessFile$param_ptypes$readUnsignedShort$3fa3a6c504cc2667[] = { 
_JC_TYPE_INT };

static _jc_type *const _jc_java_io_RandomAccessFile$exceptions$readUnsignedShort$3fa3a6c504cc2667[] = {
	&_jc_java_io_IOException$type
};

_jc_method _jc_java_io_RandomAccessFile$method_info$readUnsignedShort$3fa3a6c504cc2667 = {
	.name=			"readUnsignedShort",
	.signature=		"()I",
	.class=			&_jc_java_io_RandomAccessFile$type,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_java_io_RandomAccessFile$param_ptypes$readUnsignedShort$3fa3a6c504cc2667,
	.signature_hash=	_JC_JLONG(0x3fa3a6c504cc2667),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_io_RandomAccessFile$method$readUnsignedShort$3fa3a6c504cc2667,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_io_RandomAccessFile$vtable, java_io_RandomAccessFile.readUnsignedShort$3fa3a6c504cc2667) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_io_RandomAccessFile$exceptions$readUnsignedShort$3fa3a6c504cc2667,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_io_RandomAccessFile$linenum_table$readUnsignedShort$3fa3a6c504cc2667
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_RandomAccessFile, readUnsignedShort$3fa3a6c504cc2667);

jint _JC_JCNI_ATTR
_jc_java_io_RandomAccessFile$method$readUnsignedShort$3fa3a6c504cc2667(_jc_env *const env, _jc_java_io_RandomAccessFile$object *this)
{
	jbyte b1;
	jint i3;
	struct _jc_java_io_RandomAccessFile$object *r0;
	struct _jc_java_io_DataInputStream$object *r1;
	_jc_byte_array *r2;
	jshort s2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(634);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_io_RandomAccessFile, in);
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	r2 = _JC_REF_FIELD(env, r1, java_io_DataInputStream, buf);
	_JC_INVOKE_NONVIRTUAL(env, java_io_DataInputStream, readFully$63e0ddb7f8315fc6, 0, r1, r2, 0, 2);
	r2 = _JC_REF_FIELD(env, r1, java_io_DataInputStream, buf);
	b1 = _JC_PRIM_ELEMENT(env, byte, r2, 0, 0, 1);
	s2 = b1 & 255;
	i3 = s2 << (8 & 0x1f);
	b1 = _JC_PRIM_ELEMENT(env, byte, r2, 1, 0, 1);
	s2 = b1 & 255;
	i3 = i3 | s2;
	return i3;
}

//
// public void seek(long) throws java.io.IOException
//

static _jc_linenum _jc_java_io_RandomAccessFile$linenum_table$seek$d605bbca03fdd295[];

static const unsigned char _jc_java_io_RandomAccessFile$param_ptypes$seek$d605bbca03fdd295[] = { 
_JC_TYPE_LONG, _JC_TYPE_VOID };

static _jc_type *const _jc_java_io_RandomAccessFile$exceptions$seek$d605bbca03fdd295[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_java_io_RandomAccessFile$param_types$seek$d605bbca03fdd295[] = {
	&_jc_long$prim$type
};

_jc_method _jc_java_io_RandomAccessFile$method_info$seek$d605bbca03fdd295 = {
	.name=			"seek",
	.signature=		"(J)V",
	.class=			&_jc_java_io_RandomAccessFile$type,
	.param_types=		&_jc_java_io_RandomAccessFile$param_types$seek$d605bbca03fdd295,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_io_RandomAccessFile$param_ptypes$seek$d605bbca03fdd295,
	.signature_hash=	_JC_JLONG(0xd605bbca03fdd295),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_io_RandomAccessFile$method$seek$d605bbca03fdd295,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_io_RandomAccessFile$vtable, java_io_RandomAccessFile.seek$d605bbca03fdd295) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_io_RandomAccessFile$exceptions$seek$d605bbca03fdd295,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_io_RandomAccessFile$linenum_table$seek$d605bbca03fdd295
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_RandomAccessFile, seek$d605bbca03fdd295);

void _JC_JCNI_ATTR
_jc_java_io_RandomAccessFile$method$seek$d605bbca03fdd295(_jc_env *const env, _jc_java_io_RandomAccessFile$object *this, jlong param0)
{
	jbyte b1;
	jlong l0;
	struct _jc_java_io_RandomAccessFile$object *r0;
	struct _jc_gnu_java_nio_channels_FileChannelImpl$object *r1;
	struct _jc_java_lang_IllegalArgumentException$object *r2;
	struct _jc_java_nio_channels_ClosedChannelException$object *r3;
	struct _jc_java_lang_String$object *r4;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	l0 = param0;
	_JC_LINE_NUMBER(726);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_io_RandomAccessFile, ch);
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	b1 = _JC_LCMP(l0, _JC_JLONG(0));
	if (b1 >= 0)
		goto label0;
	r2 = _JC_NEW(env, java_lang_IllegalArgumentException);
	r4 = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, cause) = r2;
	_JC_INVOKE_NONVIRTUAL(env, java_lang_Throwable, fillInStackTrace$6204b72985f9038d, 0, r2);
	_JC_REF_FIELD(env, r2, java_lang_Throwable, detailMessage) = r4;
	_JC_THROW(env, r2);

label0:
	z0 = _JC_PRIM_FIELD(env, r1, java_nio_channels_spi_AbstractInterruptibleChannel, closed);
	z0 = z0 ^ 1;
	if (z0 != 0)
		goto label1;
	r3 = _JC_NEW(env, java_nio_channels_ClosedChannelException);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_Throwable, _init$c31b894660454d13, 0, r3, _JC_NULL);
	_JC_THROW(env, r3);

label1:
	_JC_INVOKE_NONVIRTUAL(env, gnu_java_nio_channels_FileChannelImpl, seek$d605bbca03fdd295, 0, r1, l0);
	_JC_LINE_NUMBER(727);				// 1
	return;
}

//
// public void setLength(long) throws java.io.IOException
//

static _jc_linenum _jc_java_io_RandomAccessFile$linenum_table$setLength$90af1264b4ab2b43[];

static const unsigned char _jc_java_io_RandomAccessFile$param_ptypes$setLength$90af1264b4ab2b43[] = { 
_JC_TYPE_LONG, _JC_TYPE_VOID };

static _jc_type *const _jc_java_io_RandomAccessFile$exceptions$setLength$90af1264b4ab2b43[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_java_io_RandomAccessFile$param_types$setLength$90af1264b4ab2b43[] = {
	&_jc_long$prim$type
};

_jc_method _jc_java_io_RandomAccessFile$method_info$setLength$90af1264b4ab2b43 = {
	.name=			"setLength",
	.signature=		"(J)V",
	.class=			&_jc_java_io_RandomAccessFile$type,
	.param_types=		&_jc_java_io_RandomAccessFile$param_types$setLength$90af1264b4ab2b43,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_io_RandomAccessFile$param_ptypes$setLength$90af1264b4ab2b43,
	.signature_hash=	_JC_JLONG(0x90af1264b4ab2b43),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_io_RandomAccessFile$method$setLength$90af1264b4ab2b43,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_io_RandomAccessFile$vtable, java_io_RandomAccessFile.setLength$90af1264b4ab2b43) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_io_RandomAccessFile$exceptions$setLength$90af1264b4ab2b43,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	8,
	      .table=	_jc_java_io_RandomAccessFile$linenum_table$setLength$90af1264b4ab2b43
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_RandomAccessFile, setLength$90af1264b4ab2b43);

void _JC_JCNI_ATTR
_jc_java_io_RandomAccessFile$method$setLength$90af1264b4ab2b43(_jc_env *const env, _jc_java_io_RandomAccessFile$object *this, jlong param0)
{
	jbyte b3;
	jlong l0;
	jlong l1;
	struct _jc_java_io_RandomAccessFile$object *r0;
	struct _jc_gnu_java_nio_channels_FileChannelImpl$object *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	l0 = param0;
	_JC_LINE_NUMBER(222);				// 0
	l1 = _JC_INVOKE_VIRTUAL(env, java_io_RandomAccessFile, length$c5778ac730410d75, r0);
	b3 = _JC_LCMP(l0, l1);
	if (b3 >= 0)
		goto label0;
	_JC_LINE_NUMBER(223);				// 1
	r1 = _JC_REF_FIELD(env, r0, java_io_RandomAccessFile, ch);
	_JC_INVOKE_NONVIRTUAL(env, gnu_java_nio_channels_FileChannelImpl, truncate$1625f8273ff0808e, 1, r1, l0);
	goto label1;

label0:
	_JC_LINE_NUMBER(224);				// 2
	l1 = _JC_INVOKE_VIRTUAL(env, java_io_RandomAccessFile, length$c5778ac730410d75, r0);
	b3 = _JC_LCMP(l0, l1);
	if (b3 <= 0)
		goto label1;
	_JC_LINE_NUMBER(226);				// 3
	l1 = _JC_INVOKE_VIRTUAL(env, java_io_RandomAccessFile, getFilePointer$cbb05d8f3b9ac770, r0);
	_JC_LINE_NUMBER(227);				// 4
	l0 = l0 - _JC_JLONG(1);
	_JC_INVOKE_VIRTUAL(env, java_io_RandomAccessFile, seek$d605bbca03fdd295, r0, l0);
	_JC_LINE_NUMBER(228);				// 5
	_JC_INVOKE_VIRTUAL(env, java_io_RandomAccessFile, write$6377ac6964854eb2, r0, 0);
	_JC_LINE_NUMBER(229);				// 6
	_JC_INVOKE_VIRTUAL(env, java_io_RandomAccessFile, seek$d605bbca03fdd295, r0, l1);

label1:
	_JC_LINE_NUMBER(231);				// 7
	return;
}

//
// public int skipBytes(int) throws java.io.IOException
//

static _jc_linenum _jc_java_io_RandomAccessFile$linenum_table$skipBytes$0e108c4fd154433f[];

static const unsigned char _jc_java_io_RandomAccessFile$param_ptypes$skipBytes$0e108c4fd154433f[] = { 
_JC_TYPE_INT, _JC_TYPE_INT };

static _jc_type *const _jc_java_io_RandomAccessFile$exceptions$skipBytes$0e108c4fd154433f[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_java_io_RandomAccessFile$param_types$skipBytes$0e108c4fd154433f[] = {
	&_jc_int$prim$type
};

_jc_method _jc_java_io_RandomAccessFile$method_info$skipBytes$0e108c4fd154433f = {
	.name=			"skipBytes",
	.signature=		"(I)I",
	.class=			&_jc_java_io_RandomAccessFile$type,
	.param_types=		&_jc_java_io_RandomAccessFile$param_types$skipBytes$0e108c4fd154433f,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_java_io_RandomAccessFile$param_ptypes$skipBytes$0e108c4fd154433f,
	.signature_hash=	_JC_JLONG(0xe108c4fd154433f),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_io_RandomAccessFile$method$skipBytes$0e108c4fd154433f,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_io_RandomAccessFile$vtable, java_io_RandomAccessFile.skipBytes$0e108c4fd154433f) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_io_RandomAccessFile$exceptions$skipBytes$0e108c4fd154433f,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	11,
	      .table=	_jc_java_io_RandomAccessFile$linenum_table$skipBytes$0e108c4fd154433f
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_RandomAccessFile, skipBytes$0e108c4fd154433f);

jint _JC_JCNI_ATTR
_jc_java_io_RandomAccessFile$method$skipBytes$0e108c4fd154433f(_jc_env *const env, _jc_java_io_RandomAccessFile$object *this, jint param0)
{
	jbyte b3;
	jint i0;
	jlong l1;
	jlong l2;
	jlong l4;
	jlong l5;
	struct _jc_java_io_RandomAccessFile$object *r0;
	struct _jc_java_lang_StringBuffer$object *r1;
	struct _jc_java_lang_VMThrowable$object *r10;
	struct _jc_java_nio_channels_ClosedChannelException$object *r11;
	struct _jc_java_lang_String$object *r12;
	struct _jc_java_lang_IllegalArgumentException$object *r2;
	struct _jc_gnu_java_nio_channels_FileChannelImpl$object *r3;
	struct _jc_java_lang_StringBuffer$object *r4;
	struct _jc_java_lang_String$object *r5;
	struct _jc_java_lang_String$object *r6;
	struct _jc_java_lang_VMThrowable$object *r7;
	struct _jc_java_nio_channels_ClosedChannelException$object *r8;
	struct _jc_java_lang_String$object *r9;
	jboolean z0;
	jboolean z1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	i0 = param0;
	_JC_LINE_NUMBER(743);				// 0
	if (i0 >= 0)
		goto label0;
	_JC_LINE_NUMBER(744);				// 1
	r2 = _JC_NEW(env, java_lang_IllegalArgumentException);
	r1 = _JC_NEW(env, java_lang_StringBuffer);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, _init$c31b894660454d13, 0, r1, _JC_STRING(env, "Can't skip negative bytes: "));
	_JC_ACTIVE_USE(env, java_lang_String);
	r5 = _JC_INVOKE_STATIC(env, java_lang_Integer, toString$80d919d12afaaa2b, 0, i0, 10);
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r1, r5);
	_JC_EXPLICIT_NULL_CHECK(env, r4);
	r6 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r6, r4);
	_JC_REF_FIELD(env, r2, java_lang_Throwable, cause) = r2;
	r7 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r2);
	_JC_REF_FIELD(env, r2, java_lang_Throwable, vmState) = r7;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, detailMessage) = r6;
	_JC_THROW(env, r2);

label0:
	_JC_LINE_NUMBER(747);				// 2
	if (i0 != 0)
		goto label1;
	_JC_LINE_NUMBER(748);				// 3
	return 0;

label1:
	_JC_LINE_NUMBER(750);				// 4
	r3 = _JC_REF_FIELD(env, r0, java_io_RandomAccessFile, ch);
	_JC_EXPLICIT_NULL_CHECK(env, r3);
	z0 = _JC_PRIM_FIELD(env, r3, java_nio_channels_spi_AbstractInterruptibleChannel, closed);
	z0 = z0 ^ 1;
	if (z0 != 0)
		goto label2;
	r8 = _JC_NEW(env, java_nio_channels_ClosedChannelException);
	r9 = _JC_NULL;
	_JC_REF_FIELD(env, r8, java_lang_Throwable, cause) = r8;
	r10 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r8);
	_JC_REF_FIELD(env, r8, java_lang_Throwable, vmState) = r10;
	_JC_REF_FIELD(env, r8, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r8, java_lang_Throwable, detailMessage) = r9;
	_JC_THROW(env, r8);

label2:
	l4 = _JC_INVOKE_NONVIRTUAL(env, gnu_java_nio_channels_FileChannelImpl, implPosition$176d7e4a36c17935, 0, r3);
	_JC_LINE_NUMBER(751);				// 5
	l2 = (jlong)i0;
	l1 = l4 + l2;
	_JC_LINE_NUMBER(752);				// 6
	r3 = _JC_REF_FIELD(env, r0, java_io_RandomAccessFile, ch);
	l2 = _JC_INVOKE_NONVIRTUAL(env, gnu_java_nio_channels_FileChannelImpl, size$1239e23bc95a984b, 1, r3);
	_JC_LINE_NUMBER(753);				// 7
	b3 = _JC_LCMP(l1, l2);
	if (b3 <= 0)
		goto label3;
	_JC_LINE_NUMBER(754);				// 8
	l1 = l2;

label3:
	_JC_LINE_NUMBER(755);				// 9
	r3 = _JC_REF_FIELD(env, r0, java_io_RandomAccessFile, ch);
	_JC_INVOKE_NONVIRTUAL(env, gnu_java_nio_channels_FileChannelImpl, position$4d0531f8fc1ec117, 1, r3, l1);
	_JC_LINE_NUMBER(756);				// 10
	r3 = _JC_REF_FIELD(env, r0, java_io_RandomAccessFile, ch);
	_JC_EXPLICIT_NULL_CHECK(env, r3);
	z1 = _JC_PRIM_FIELD(env, r3, java_nio_channels_spi_AbstractInterruptibleChannel, closed);
	z1 = z1 ^ 1;
	if (z1 != 0)
		goto label4;
	r11 = _JC_NEW(env, java_nio_channels_ClosedChannelException);
	r12 = _JC_NULL;
	_JC_REF_FIELD(env, r11, java_lang_Throwable, cause) = r11;
	_JC_INVOKE_NONVIRTUAL(env, java_lang_Throwable, fillInStackTrace$6204b72985f9038d, 0, r11);
	_JC_REF_FIELD(env, r11, java_lang_Throwable, detailMessage) = r12;
	_JC_THROW(env, r11);

label4:
	l5 = _JC_INVOKE_NONVIRTUAL(env, gnu_java_nio_channels_FileChannelImpl, implPosition$176d7e4a36c17935, 0, r3);
	l2 = l5 - l4;
	i0 = (jint)l2;
	return i0;
}

//
// public void write(int) throws java.io.IOException
//

static _jc_linenum _jc_java_io_RandomAccessFile$linenum_table$write$6377ac6964854eb2[];

static const unsigned char _jc_java_io_RandomAccessFile$param_ptypes$write$6377ac6964854eb2[] = { 
_JC_TYPE_INT, _JC_TYPE_VOID };

static _jc_type *const _jc_java_io_RandomAccessFile$exceptions$write$6377ac6964854eb2[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_java_io_RandomAccessFile$param_types$write$6377ac6964854eb2[] = {
	&_jc_int$prim$type
};

_jc_method _jc_java_io_RandomAccessFile$method_info$write$6377ac6964854eb2 = {
	.name=			"write",
	.signature=		"(I)V",
	.class=			&_jc_java_io_RandomAccessFile$type,
	.param_types=		&_jc_java_io_RandomAccessFile$param_types$write$6377ac6964854eb2,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_io_RandomAccessFile$param_ptypes$write$6377ac6964854eb2,
	.signature_hash=	_JC_JLONG(0x6377ac6964854eb2),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_io_RandomAccessFile$method$write$6377ac6964854eb2,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_io_RandomAccessFile$vtable, java_io_RandomAccessFile.write$6377ac6964854eb2) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_io_RandomAccessFile$exceptions$write$6377ac6964854eb2,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_io_RandomAccessFile$linenum_table$write$6377ac6964854eb2
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_RandomAccessFile, write$6377ac6964854eb2);

void _JC_JCNI_ATTR
_jc_java_io_RandomAccessFile$method$write$6377ac6964854eb2(_jc_env *const env, _jc_java_io_RandomAccessFile$object *this, jint param0)
{
	jint i0;
	struct _jc_java_io_RandomAccessFile$object *r0;
	struct _jc_java_io_DataOutputStream$object *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	i0 = param0;
	_JC_LINE_NUMBER(769);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_io_RandomAccessFile, out);
	_JC_INVOKE_VIRTUAL(env, java_io_DataOutputStream, write$6377ac6964854eb2, r1, i0);
	_JC_LINE_NUMBER(770);				// 1
	return;
}

//
// public void write(byte[]) throws java.io.IOException
//

static _jc_linenum _jc_java_io_RandomAccessFile$linenum_table$write$18e189e8fc25f121[];

static const unsigned char _jc_java_io_RandomAccessFile$param_ptypes$write$18e189e8fc25f121[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_io_RandomAccessFile$exceptions$write$18e189e8fc25f121[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_java_io_RandomAccessFile$param_types$write$18e189e8fc25f121[] = {
	&_jc_byte$array$prim$type
};

_jc_method _jc_java_io_RandomAccessFile$method_info$write$18e189e8fc25f121 = {
	.name=			"write",
	.signature=		"([B)V",
	.class=			&_jc_java_io_RandomAccessFile$type,
	.param_types=		&_jc_java_io_RandomAccessFile$param_types$write$18e189e8fc25f121,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_io_RandomAccessFile$param_ptypes$write$18e189e8fc25f121,
	.signature_hash=	_JC_JLONG(0x18e189e8fc25f121),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_io_RandomAccessFile$method$write$18e189e8fc25f121,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_io_RandomAccessFile$vtable, java_io_RandomAccessFile.write$18e189e8fc25f121) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_io_RandomAccessFile$exceptions$write$18e189e8fc25f121,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_io_RandomAccessFile$linenum_table$write$18e189e8fc25f121
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_RandomAccessFile, write$18e189e8fc25f121);

void _JC_JCNI_ATTR
_jc_java_io_RandomAccessFile$method$write$18e189e8fc25f121(_jc_env *const env, _jc_java_io_RandomAccessFile$object *this, _jc_byte_array *param0)
{
	struct _jc_java_io_RandomAccessFile$object *r0;
	_jc_byte_array *r1;
	struct _jc_java_io_DataOutputStream$object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(780);				// 0
	r2 = _JC_REF_FIELD(env, r0, java_io_RandomAccessFile, out);
	_JC_INVOKE_VIRTUAL(env, java_io_FilterOutputStream, write$18e189e8fc25f121, r2, r1);
	_JC_LINE_NUMBER(781);				// 1
	return;
}

//
// public void write(byte[], int, int) throws java.io.IOException
//

static _jc_linenum _jc_java_io_RandomAccessFile$linenum_table$write$306a698343ec27e8[];

static const unsigned char _jc_java_io_RandomAccessFile$param_ptypes$write$306a698343ec27e8[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_INT, _JC_TYPE_VOID };

static _jc_type *const _jc_java_io_RandomAccessFile$exceptions$write$306a698343ec27e8[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_java_io_RandomAccessFile$param_types$write$306a698343ec27e8[] = {
	&_jc_byte$array$prim$type,
	&_jc_int$prim$type,
	&_jc_int$prim$type
};

_jc_method _jc_java_io_RandomAccessFile$method_info$write$306a698343ec27e8 = {
	.name=			"write",
	.signature=		"([BII)V",
	.class=			&_jc_java_io_RandomAccessFile$type,
	.param_types=		&_jc_java_io_RandomAccessFile$param_types$write$306a698343ec27e8,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_io_RandomAccessFile$param_ptypes$write$306a698343ec27e8,
	.signature_hash=	_JC_JLONG(0x306a698343ec27e8),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_io_RandomAccessFile$method$write$306a698343ec27e8,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_io_RandomAccessFile$vtable, java_io_RandomAccessFile.write$306a698343ec27e8) / sizeof(void *),
	.num_parameters=	3,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_io_RandomAccessFile$exceptions$write$306a698343ec27e8,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_io_RandomAccessFile$linenum_table$write$306a698343ec27e8
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_RandomAccessFile, write$306a698343ec27e8);

void _JC_JCNI_ATTR
_jc_java_io_RandomAccessFile$method$write$306a698343ec27e8(_jc_env *const env, _jc_java_io_RandomAccessFile$object *this, _jc_byte_array *param0, jint param1, jint param2)
{
	jint i0;
	jint i1;
	struct _jc_java_io_RandomAccessFile$object *r0;
	_jc_byte_array *r1;
	struct _jc_java_io_DataOutputStream$object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	i0 = param1;
	i1 = param2;
	_JC_LINE_NUMBER(795);				// 0
	r2 = _JC_REF_FIELD(env, r0, java_io_RandomAccessFile, out);
	_JC_INVOKE_VIRTUAL(env, java_io_DataOutputStream, write$306a698343ec27e8, r2, r1, i0, i1);
	_JC_LINE_NUMBER(796);				// 1
	return;
}

//
// public final void writeBoolean(boolean) throws java.io.IOException
//

static _jc_linenum _jc_java_io_RandomAccessFile$linenum_table$writeBoolean$32d3c2568a9bf8d7[];

static const unsigned char _jc_java_io_RandomAccessFile$param_ptypes$writeBoolean$32d3c2568a9bf8d7[] = { 
_JC_TYPE_BOOLEAN, _JC_TYPE_VOID };

static _jc_type *const _jc_java_io_RandomAccessFile$exceptions$writeBoolean$32d3c2568a9bf8d7[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_java_io_RandomAccessFile$param_types$writeBoolean$32d3c2568a9bf8d7[] = {
	&_jc_boolean$prim$type
};

_jc_method _jc_java_io_RandomAccessFile$method_info$writeBoolean$32d3c2568a9bf8d7 = {
	.name=			"writeBoolean",
	.signature=		"(Z)V",
	.class=			&_jc_java_io_RandomAccessFile$type,
	.param_types=		&_jc_java_io_RandomAccessFile$param_types$writeBoolean$32d3c2568a9bf8d7,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_io_RandomAccessFile$param_ptypes$writeBoolean$32d3c2568a9bf8d7,
	.signature_hash=	_JC_JLONG(0x32d3c2568a9bf8d7),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_io_RandomAccessFile$method$writeBoolean$32d3c2568a9bf8d7,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_io_RandomAccessFile$vtable, java_io_RandomAccessFile.writeBoolean$32d3c2568a9bf8d7) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_io_RandomAccessFile$exceptions$writeBoolean$32d3c2568a9bf8d7,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_io_RandomAccessFile$linenum_table$writeBoolean$32d3c2568a9bf8d7
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_RandomAccessFile, writeBoolean$32d3c2568a9bf8d7);

void _JC_JCNI_ATTR
_jc_java_io_RandomAccessFile$method$writeBoolean$32d3c2568a9bf8d7(_jc_env *const env, _jc_java_io_RandomAccessFile$object *this, jboolean param0)
{
	jint i0;
	struct _jc_java_io_RandomAccessFile$object *r0;
	struct _jc_java_io_DataOutputStream$object *r1;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	z0 = param0;
	_JC_LINE_NUMBER(809);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_io_RandomAccessFile, out);
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	i0 = (jint)z0;
	_JC_INVOKE_VIRTUAL(env, java_io_DataOutputStream, write$6377ac6964854eb2, r1, i0);
	_JC_LINE_NUMBER(810);				// 1
	return;
}

//
// public final void writeByte(int) throws java.io.IOException
//

static _jc_linenum _jc_java_io_RandomAccessFile$linenum_table$writeByte$fba627021ccc49a7[];

static const unsigned char _jc_java_io_RandomAccessFile$param_ptypes$writeByte$fba627021ccc49a7[] = { 
_JC_TYPE_INT, _JC_TYPE_VOID };

static _jc_type *const _jc_java_io_RandomAccessFile$exceptions$writeByte$fba627021ccc49a7[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_java_io_RandomAccessFile$param_types$writeByte$fba627021ccc49a7[] = {
	&_jc_int$prim$type
};

_jc_method _jc_java_io_RandomAccessFile$method_info$writeByte$fba627021ccc49a7 = {
	.name=			"writeByte",
	.signature=		"(I)V",
	.class=			&_jc_java_io_RandomAccessFile$type,
	.param_types=		&_jc_java_io_RandomAccessFile$param_types$writeByte$fba627021ccc49a7,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_io_RandomAccessFile$param_ptypes$writeByte$fba627021ccc49a7,
	.signature_hash=	_JC_JLONG(0xfba627021ccc49a7),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_io_RandomAccessFile$method$writeByte$fba627021ccc49a7,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_io_RandomAccessFile$vtable, java_io_RandomAccessFile.writeByte$fba627021ccc49a7) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_io_RandomAccessFile$exceptions$writeByte$fba627021ccc49a7,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_io_RandomAccessFile$linenum_table$writeByte$fba627021ccc49a7
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_RandomAccessFile, writeByte$fba627021ccc49a7);

void _JC_JCNI_ATTR
_jc_java_io_RandomAccessFile$method$writeByte$fba627021ccc49a7(_jc_env *const env, _jc_java_io_RandomAccessFile$object *this, jint param0)
{
	jint i0;
	jint i1;
	struct _jc_java_io_RandomAccessFile$object *r0;
	struct _jc_java_io_DataOutputStream$object *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	i0 = param0;
	_JC_LINE_NUMBER(823);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_io_RandomAccessFile, out);
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	i1 = i0 & 255;
	_JC_INVOKE_VIRTUAL(env, java_io_DataOutputStream, write$6377ac6964854eb2, r1, i1);
	_JC_LINE_NUMBER(824);				// 1
	return;
}

//
// public final void writeBytes(java.lang.String) throws java.io.IOException
//

static _jc_linenum _jc_java_io_RandomAccessFile$linenum_table$writeBytes$5a36a7e449a2b6d7[];

static const unsigned char _jc_java_io_RandomAccessFile$param_ptypes$writeBytes$5a36a7e449a2b6d7[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_io_RandomAccessFile$exceptions$writeBytes$5a36a7e449a2b6d7[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_java_io_RandomAccessFile$param_types$writeBytes$5a36a7e449a2b6d7[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_java_io_RandomAccessFile$method_info$writeBytes$5a36a7e449a2b6d7 = {
	.name=			"writeBytes",
	.signature=		"(Ljava/lang/String;)V",
	.class=			&_jc_java_io_RandomAccessFile$type,
	.param_types=		&_jc_java_io_RandomAccessFile$param_types$writeBytes$5a36a7e449a2b6d7,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_io_RandomAccessFile$param_ptypes$writeBytes$5a36a7e449a2b6d7,
	.signature_hash=	_JC_JLONG(0x5a36a7e449a2b6d7),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_io_RandomAccessFile$method$writeBytes$5a36a7e449a2b6d7,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_io_RandomAccessFile$vtable, java_io_RandomAccessFile.writeBytes$5a36a7e449a2b6d7) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_io_RandomAccessFile$exceptions$writeBytes$5a36a7e449a2b6d7,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_io_RandomAccessFile$linenum_table$writeBytes$5a36a7e449a2b6d7
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_RandomAccessFile, writeBytes$5a36a7e449a2b6d7);

void _JC_JCNI_ATTR
_jc_java_io_RandomAccessFile$method$writeBytes$5a36a7e449a2b6d7(_jc_env *const env, _jc_java_io_RandomAccessFile$object *this, _jc_java_lang_String$object *param0)
{
	jchar c6;
	jint i0;
	jint i2;
	jint i3;
	jint i4;
	jint i5;
	struct _jc_java_io_RandomAccessFile$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_java_io_DataOutputStream$object *r2;
	struct _jc_java_lang_StringIndexOutOfBoundsException$object *r4;
	_jc_char_array *r5;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(930);				// 0
	r2 = _JC_REF_FIELD(env, r0, java_io_RandomAccessFile, out);
	_JC_EXPLICIT_NULL_CHECK(env, r2);
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	i2 = _JC_PRIM_FIELD(env, r1, java_lang_String, count);
	i0 = 0;
	goto label3;

label0:
	i4 = i0;
	if (i0 < 0)
		goto label1;
	i5 = _JC_PRIM_FIELD(env, r1, java_lang_String, count);
	if (i0 < i5)
		goto label2;

label1:
	r4 = _JC_NEW(env, java_lang_StringIndexOutOfBoundsException);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_StringIndexOutOfBoundsException, _init$7f1776288300b98d, 0, r4, i4);
	_JC_THROW(env, r4);

label2:
	r5 = _JC_REF_FIELD(env, r1, java_lang_String, value);
	i5 = _JC_PRIM_FIELD(env, r1, java_lang_String, offset);
	i5 = i5 + i0;
	c6 = _JC_PRIM_ELEMENT(env, char, r5, i5, 1, 1);
	i3 = c6 & 255;
	_JC_INVOKE_VIRTUAL(env, java_io_DataOutputStream, write$6377ac6964854eb2, r2, i3);
	i0 = i0 + 1;

label3:
	if (i0 < i2) {
		_JC_PERIODIC_CHECK(env);
		goto label0;
	}
	_JC_LINE_NUMBER(931);				// 1
	return;
}

//
// public final void writeChar(int) throws java.io.IOException
//

static _jc_linenum _jc_java_io_RandomAccessFile$linenum_table$writeChar$f5b967227ec03e20[];

static const unsigned char _jc_java_io_RandomAccessFile$param_ptypes$writeChar$f5b967227ec03e20[] = { 
_JC_TYPE_INT, _JC_TYPE_VOID };

static _jc_type *const _jc_java_io_RandomAccessFile$exceptions$writeChar$f5b967227ec03e20[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_java_io_RandomAccessFile$param_types$writeChar$f5b967227ec03e20[] = {
	&_jc_int$prim$type
};

_jc_method _jc_java_io_RandomAccessFile$method_info$writeChar$f5b967227ec03e20 = {
	.name=			"writeChar",
	.signature=		"(I)V",
	.class=			&_jc_java_io_RandomAccessFile$type,
	.param_types=		&_jc_java_io_RandomAccessFile$param_types$writeChar$f5b967227ec03e20,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_io_RandomAccessFile$param_ptypes$writeChar$f5b967227ec03e20,
	.signature_hash=	_JC_JLONG(0xf5b967227ec03e20),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_io_RandomAccessFile$method$writeChar$f5b967227ec03e20,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_io_RandomAccessFile$vtable, java_io_RandomAccessFile.writeChar$f5b967227ec03e20) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_io_RandomAccessFile$exceptions$writeChar$f5b967227ec03e20,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_io_RandomAccessFile$linenum_table$writeChar$f5b967227ec03e20
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_RandomAccessFile, writeChar$f5b967227ec03e20);

void _JC_JCNI_ATTR
_jc_java_io_RandomAccessFile$method$writeChar$f5b967227ec03e20(_jc_env *const env, _jc_java_io_RandomAccessFile$object *this, jint param0)
{
	jint i0;
	struct _jc_java_io_RandomAccessFile$object *r0;
	struct _jc_java_io_DataOutputStream$object *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	i0 = param0;
	_JC_LINE_NUMBER(851);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_io_RandomAccessFile, out);
	_JC_INVOKE_NONVIRTUAL(env, java_io_DataOutputStream, writeChar$f5b967227ec03e20, 1, r1, i0);
	_JC_LINE_NUMBER(852);				// 1
	return;
}

//
// public final void writeChars(java.lang.String) throws java.io.IOException
//

static _jc_linenum _jc_java_io_RandomAccessFile$linenum_table$writeChars$f5859b964fbc3b2f[];

static const unsigned char _jc_java_io_RandomAccessFile$param_ptypes$writeChars$f5859b964fbc3b2f[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_io_RandomAccessFile$exceptions$writeChars$f5859b964fbc3b2f[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_java_io_RandomAccessFile$param_types$writeChars$f5859b964fbc3b2f[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_java_io_RandomAccessFile$method_info$writeChars$f5859b964fbc3b2f = {
	.name=			"writeChars",
	.signature=		"(Ljava/lang/String;)V",
	.class=			&_jc_java_io_RandomAccessFile$type,
	.param_types=		&_jc_java_io_RandomAccessFile$param_types$writeChars$f5859b964fbc3b2f,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_io_RandomAccessFile$param_ptypes$writeChars$f5859b964fbc3b2f,
	.signature_hash=	_JC_JLONG(0xf5859b964fbc3b2f),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_io_RandomAccessFile$method$writeChars$f5859b964fbc3b2f,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_io_RandomAccessFile$vtable, java_io_RandomAccessFile.writeChars$f5859b964fbc3b2f) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_io_RandomAccessFile$exceptions$writeChars$f5859b964fbc3b2f,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_io_RandomAccessFile$linenum_table$writeChars$f5859b964fbc3b2f
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_RandomAccessFile, writeChars$f5859b964fbc3b2f);

void _JC_JCNI_ATTR
_jc_java_io_RandomAccessFile$method$writeChars$f5859b964fbc3b2f(_jc_env *const env, _jc_java_io_RandomAccessFile$object *this, _jc_java_lang_String$object *param0)
{
	jchar c5;
	jint i0;
	jint i2;
	jint i3;
	jint i4;
	struct _jc_java_io_RandomAccessFile$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_java_io_DataOutputStream$object *r2;
	struct _jc_java_lang_StringIndexOutOfBoundsException$object *r4;
	_jc_char_array *r5;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(944);				// 0
	r2 = _JC_REF_FIELD(env, r0, java_io_RandomAccessFile, out);
	_JC_EXPLICIT_NULL_CHECK(env, r2);
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	i2 = _JC_PRIM_FIELD(env, r1, java_lang_String, count);
	i0 = 0;
	goto label3;

label0:
	i3 = i0;
	if (i0 < 0)
		goto label1;
	i4 = _JC_PRIM_FIELD(env, r1, java_lang_String, count);
	if (i0 < i4)
		goto label2;

label1:
	r4 = _JC_NEW(env, java_lang_StringIndexOutOfBoundsException);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_StringIndexOutOfBoundsException, _init$7f1776288300b98d, 0, r4, i3);
	_JC_THROW(env, r4);

label2:
	r5 = _JC_REF_FIELD(env, r1, java_lang_String, value);
	i4 = _JC_PRIM_FIELD(env, r1, java_lang_String, offset);
	i4 = i4 + i0;
	c5 = _JC_PRIM_ELEMENT(env, char, r5, i4, 1, 1);
	_JC_INVOKE_NONVIRTUAL(env, java_io_DataOutputStream, writeChar$f5b967227ec03e20, 0, r2, c5);
	i0 = i0 + 1;

label3:
	if (i0 < i2) {
		_JC_PERIODIC_CHECK(env);
		goto label0;
	}
	_JC_LINE_NUMBER(945);				// 1
	return;
}

//
// public final void writeDouble(double) throws java.io.IOException
//

static _jc_linenum _jc_java_io_RandomAccessFile$linenum_table$writeDouble$d99c72d09a4cbd47[];

static const unsigned char _jc_java_io_RandomAccessFile$param_ptypes$writeDouble$d99c72d09a4cbd47[] = { 
_JC_TYPE_DOUBLE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_io_RandomAccessFile$exceptions$writeDouble$d99c72d09a4cbd47[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_java_io_RandomAccessFile$param_types$writeDouble$d99c72d09a4cbd47[] = {
	&_jc_double$prim$type
};

_jc_method _jc_java_io_RandomAccessFile$method_info$writeDouble$d99c72d09a4cbd47 = {
	.name=			"writeDouble",
	.signature=		"(D)V",
	.class=			&_jc_java_io_RandomAccessFile$type,
	.param_types=		&_jc_java_io_RandomAccessFile$param_types$writeDouble$d99c72d09a4cbd47,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_io_RandomAccessFile$param_ptypes$writeDouble$d99c72d09a4cbd47,
	.signature_hash=	_JC_JLONG(0xd99c72d09a4cbd47),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_io_RandomAccessFile$method$writeDouble$d99c72d09a4cbd47,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_io_RandomAccessFile$vtable, java_io_RandomAccessFile.writeDouble$d99c72d09a4cbd47) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_io_RandomAccessFile$exceptions$writeDouble$d99c72d09a4cbd47,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_io_RandomAccessFile$linenum_table$writeDouble$d99c72d09a4cbd47
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_RandomAccessFile, writeDouble$d99c72d09a4cbd47);

void _JC_JCNI_ATTR
_jc_java_io_RandomAccessFile$method$writeDouble$d99c72d09a4cbd47(_jc_env *const env, _jc_java_io_RandomAccessFile$object *this, jdouble param0)
{
	jdouble d0;
	jlong l1;
	struct _jc_java_io_RandomAccessFile$object *r0;
	struct _jc_java_io_DataOutputStream$object *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	d0 = param0;
	_JC_LINE_NUMBER(916);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_io_RandomAccessFile, out);
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	_JC_ACTIVE_USE(env, java_lang_Double);
	l1 = _JC_INVOKE_STATIC(env, java_lang_VMDouble, doubleToLongBits$9027e7a7fafba576, 0, d0);
	_JC_INVOKE_NONVIRTUAL(env, java_io_DataOutputStream, writeLong$abc739829b9abb59, 0, r1, l1);
	_JC_LINE_NUMBER(917);				// 1
	return;
}

//
// public final void writeFloat(float) throws java.io.IOException
//

static _jc_linenum _jc_java_io_RandomAccessFile$linenum_table$writeFloat$1747fde40a3f1453[];

static const unsigned char _jc_java_io_RandomAccessFile$param_ptypes$writeFloat$1747fde40a3f1453[] = { 
_JC_TYPE_FLOAT, _JC_TYPE_VOID };

static _jc_type *const _jc_java_io_RandomAccessFile$exceptions$writeFloat$1747fde40a3f1453[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_java_io_RandomAccessFile$param_types$writeFloat$1747fde40a3f1453[] = {
	&_jc_float$prim$type
};

_jc_method _jc_java_io_RandomAccessFile$method_info$writeFloat$1747fde40a3f1453 = {
	.name=			"writeFloat",
	.signature=		"(F)V",
	.class=			&_jc_java_io_RandomAccessFile$type,
	.param_types=		&_jc_java_io_RandomAccessFile$param_types$writeFloat$1747fde40a3f1453,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_io_RandomAccessFile$param_ptypes$writeFloat$1747fde40a3f1453,
	.signature_hash=	_JC_JLONG(0x1747fde40a3f1453),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_io_RandomAccessFile$method$writeFloat$1747fde40a3f1453,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_io_RandomAccessFile$vtable, java_io_RandomAccessFile.writeFloat$1747fde40a3f1453) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_io_RandomAccessFile$exceptions$writeFloat$1747fde40a3f1453,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_io_RandomAccessFile$linenum_table$writeFloat$1747fde40a3f1453
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_RandomAccessFile, writeFloat$1747fde40a3f1453);

void _JC_JCNI_ATTR
_jc_java_io_RandomAccessFile$method$writeFloat$1747fde40a3f1453(_jc_env *const env, _jc_java_io_RandomAccessFile$object *this, jfloat param0)
{
	jfloat f0;
	jint i1;
	struct _jc_java_io_RandomAccessFile$object *r0;
	struct _jc_java_io_DataOutputStream$object *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	f0 = param0;
	_JC_LINE_NUMBER(896);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_io_RandomAccessFile, out);
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	_JC_ACTIVE_USE(env, java_lang_Float);
	i1 = _JC_INVOKE_STATIC(env, java_lang_VMFloat, floatToIntBits$8b96af62a8cd130d, 0, f0);
	_JC_INVOKE_NONVIRTUAL(env, java_io_DataOutputStream, writeInt$7a3be746a146b137, 0, r1, i1);
	_JC_LINE_NUMBER(897);				// 1
	return;
}

//
// public final void writeInt(int) throws java.io.IOException
//

static _jc_linenum _jc_java_io_RandomAccessFile$linenum_table$writeInt$7a3be746a146b137[];

static const unsigned char _jc_java_io_RandomAccessFile$param_ptypes$writeInt$7a3be746a146b137[] = { 
_JC_TYPE_INT, _JC_TYPE_VOID };

static _jc_type *const _jc_java_io_RandomAccessFile$exceptions$writeInt$7a3be746a146b137[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_java_io_RandomAccessFile$param_types$writeInt$7a3be746a146b137[] = {
	&_jc_int$prim$type
};

_jc_method _jc_java_io_RandomAccessFile$method_info$writeInt$7a3be746a146b137 = {
	.name=			"writeInt",
	.signature=		"(I)V",
	.class=			&_jc_java_io_RandomAccessFile$type,
	.param_types=		&_jc_java_io_RandomAccessFile$param_types$writeInt$7a3be746a146b137,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_io_RandomAccessFile$param_ptypes$writeInt$7a3be746a146b137,
	.signature_hash=	_JC_JLONG(0x7a3be746a146b137),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_io_RandomAccessFile$method$writeInt$7a3be746a146b137,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_io_RandomAccessFile$vtable, java_io_RandomAccessFile.writeInt$7a3be746a146b137) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_io_RandomAccessFile$exceptions$writeInt$7a3be746a146b137,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_io_RandomAccessFile$linenum_table$writeInt$7a3be746a146b137
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_RandomAccessFile, writeInt$7a3be746a146b137);

void _JC_JCNI_ATTR
_jc_java_io_RandomAccessFile$method$writeInt$7a3be746a146b137(_jc_env *const env, _jc_java_io_RandomAccessFile$object *this, jint param0)
{
	jint i0;
	struct _jc_java_io_RandomAccessFile$object *r0;
	struct _jc_java_io_DataOutputStream$object *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	i0 = param0;
	_JC_LINE_NUMBER(864);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_io_RandomAccessFile, out);
	_JC_INVOKE_NONVIRTUAL(env, java_io_DataOutputStream, writeInt$7a3be746a146b137, 1, r1, i0);
	_JC_LINE_NUMBER(865);				// 1
	return;
}

//
// public final void writeLong(long) throws java.io.IOException
//

static _jc_linenum _jc_java_io_RandomAccessFile$linenum_table$writeLong$abc739829b9abb59[];

static const unsigned char _jc_java_io_RandomAccessFile$param_ptypes$writeLong$abc739829b9abb59[] = { 
_JC_TYPE_LONG, _JC_TYPE_VOID };

static _jc_type *const _jc_java_io_RandomAccessFile$exceptions$writeLong$abc739829b9abb59[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_java_io_RandomAccessFile$param_types$writeLong$abc739829b9abb59[] = {
	&_jc_long$prim$type
};

_jc_method _jc_java_io_RandomAccessFile$method_info$writeLong$abc739829b9abb59 = {
	.name=			"writeLong",
	.signature=		"(J)V",
	.class=			&_jc_java_io_RandomAccessFile$type,
	.param_types=		&_jc_java_io_RandomAccessFile$param_types$writeLong$abc739829b9abb59,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_io_RandomAccessFile$param_ptypes$writeLong$abc739829b9abb59,
	.signature_hash=	_JC_JLONG(0xabc739829b9abb59),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_io_RandomAccessFile$method$writeLong$abc739829b9abb59,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_io_RandomAccessFile$vtable, java_io_RandomAccessFile.writeLong$abc739829b9abb59) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_io_RandomAccessFile$exceptions$writeLong$abc739829b9abb59,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_io_RandomAccessFile$linenum_table$writeLong$abc739829b9abb59
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_RandomAccessFile, writeLong$abc739829b9abb59);

void _JC_JCNI_ATTR
_jc_java_io_RandomAccessFile$method$writeLong$abc739829b9abb59(_jc_env *const env, _jc_java_io_RandomAccessFile$object *this, jlong param0)
{
	jlong l0;
	struct _jc_java_io_RandomAccessFile$object *r0;
	struct _jc_java_io_DataOutputStream$object *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	l0 = param0;
	_JC_LINE_NUMBER(877);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_io_RandomAccessFile, out);
	_JC_INVOKE_NONVIRTUAL(env, java_io_DataOutputStream, writeLong$abc739829b9abb59, 1, r1, l0);
	_JC_LINE_NUMBER(878);				// 1
	return;
}

//
// public final void writeShort(int) throws java.io.IOException
//

static _jc_linenum _jc_java_io_RandomAccessFile$linenum_table$writeShort$8ae9f66e0079966f[];

static const unsigned char _jc_java_io_RandomAccessFile$param_ptypes$writeShort$8ae9f66e0079966f[] = { 
_JC_TYPE_INT, _JC_TYPE_VOID };

static _jc_type *const _jc_java_io_RandomAccessFile$exceptions$writeShort$8ae9f66e0079966f[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_java_io_RandomAccessFile$param_types$writeShort$8ae9f66e0079966f[] = {
	&_jc_int$prim$type
};

_jc_method _jc_java_io_RandomAccessFile$method_info$writeShort$8ae9f66e0079966f = {
	.name=			"writeShort",
	.signature=		"(I)V",
	.class=			&_jc_java_io_RandomAccessFile$type,
	.param_types=		&_jc_java_io_RandomAccessFile$param_types$writeShort$8ae9f66e0079966f,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_io_RandomAccessFile$param_ptypes$writeShort$8ae9f66e0079966f,
	.signature_hash=	_JC_JLONG(0x8ae9f66e0079966f),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_io_RandomAccessFile$method$writeShort$8ae9f66e0079966f,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_io_RandomAccessFile$vtable, java_io_RandomAccessFile.writeShort$8ae9f66e0079966f) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_io_RandomAccessFile$exceptions$writeShort$8ae9f66e0079966f,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_io_RandomAccessFile$linenum_table$writeShort$8ae9f66e0079966f
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_RandomAccessFile, writeShort$8ae9f66e0079966f);

void _JC_JCNI_ATTR
_jc_java_io_RandomAccessFile$method$writeShort$8ae9f66e0079966f(_jc_env *const env, _jc_java_io_RandomAccessFile$object *this, jint param0)
{
	jint i0;
	struct _jc_java_io_RandomAccessFile$object *r0;
	struct _jc_java_io_DataOutputStream$object *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	i0 = param0;
	_JC_LINE_NUMBER(837);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_io_RandomAccessFile, out);
	_JC_INVOKE_NONVIRTUAL(env, java_io_DataOutputStream, writeShort$8ae9f66e0079966f, 1, r1, i0);
	_JC_LINE_NUMBER(838);				// 1
	return;
}

//
// public final void writeUTF(java.lang.String) throws java.io.IOException
//

static _jc_linenum _jc_java_io_RandomAccessFile$linenum_table$writeUTF$8e40eaaa736d9ee2[];

static const unsigned char _jc_java_io_RandomAccessFile$param_ptypes$writeUTF$8e40eaaa736d9ee2[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_io_RandomAccessFile$exceptions$writeUTF$8e40eaaa736d9ee2[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_java_io_RandomAccessFile$param_types$writeUTF$8e40eaaa736d9ee2[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_java_io_RandomAccessFile$method_info$writeUTF$8e40eaaa736d9ee2 = {
	.name=			"writeUTF",
	.signature=		"(Ljava/lang/String;)V",
	.class=			&_jc_java_io_RandomAccessFile$type,
	.param_types=		&_jc_java_io_RandomAccessFile$param_types$writeUTF$8e40eaaa736d9ee2,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_io_RandomAccessFile$param_ptypes$writeUTF$8e40eaaa736d9ee2,
	.signature_hash=	_JC_JLONG(0x8e40eaaa736d9ee2),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_io_RandomAccessFile$method$writeUTF$8e40eaaa736d9ee2,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_io_RandomAccessFile$vtable, java_io_RandomAccessFile.writeUTF$8e40eaaa736d9ee2) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_io_RandomAccessFile$exceptions$writeUTF$8e40eaaa736d9ee2,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_io_RandomAccessFile$linenum_table$writeUTF$8e40eaaa736d9ee2
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_io_RandomAccessFile, writeUTF$8e40eaaa736d9ee2);

void _JC_JCNI_ATTR
_jc_java_io_RandomAccessFile$method$writeUTF$8e40eaaa736d9ee2(_jc_env *const env, _jc_java_io_RandomAccessFile$object *this, _jc_java_lang_String$object *param0)
{
	struct _jc_java_io_RandomAccessFile$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_java_io_DataOutputStream$object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(978);				// 0
	r2 = _JC_REF_FIELD(env, r0, java_io_RandomAccessFile, out);
	_JC_INVOKE_NONVIRTUAL(env, java_io_DataOutputStream, writeUTF$8e40eaaa736d9ee2, 1, r2, r1);
	_JC_LINE_NUMBER(979);				// 1
	return;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_java_io_RandomAccessFile$methods[] = {
	&_jc_java_io_RandomAccessFile$method_info$_init$3edeb17decd6ae04,
	&_jc_java_io_RandomAccessFile$method_info$_init$a34354cd9552963f,
	&_jc_java_io_RandomAccessFile$method_info$close$6aba8b329fddcd79,
	&_jc_java_io_RandomAccessFile$method_info$getChannel$3c77b5fd77098bfe,
	&_jc_java_io_RandomAccessFile$method_info$getFD$7bb9e0bad3483351,
	&_jc_java_io_RandomAccessFile$method_info$getFilePointer$cbb05d8f3b9ac770,
	&_jc_java_io_RandomAccessFile$method_info$length$c5778ac730410d75,
	&_jc_java_io_RandomAccessFile$method_info$read$1a981297cb524963,
	&_jc_java_io_RandomAccessFile$method_info$read$c38dd905b7fb8654,
	&_jc_java_io_RandomAccessFile$method_info$read$e6b6c87b9f256783,
	&_jc_java_io_RandomAccessFile$method_info$readBoolean$607823a0fe7654c1,
	&_jc_java_io_RandomAccessFile$method_info$readByte$f0077b1d2a79a660,
	&_jc_java_io_RandomAccessFile$method_info$readChar$1f45f598ccf24d5b,
	&_jc_java_io_RandomAccessFile$method_info$readDouble$6afd40b36b9672ac,
	&_jc_java_io_RandomAccessFile$method_info$readFloat$91949088cf9525fc,
	&_jc_java_io_RandomAccessFile$method_info$readFully$2c917249902aa549,
	&_jc_java_io_RandomAccessFile$method_info$readFully$63e0ddb7f8315fc6,
	&_jc_java_io_RandomAccessFile$method_info$readInt$029bcbc9fec7ab9a,
	&_jc_java_io_RandomAccessFile$method_info$readLine$d32396e6ff161651,
	&_jc_java_io_RandomAccessFile$method_info$readLong$2cb13656e73083dd,
	&_jc_java_io_RandomAccessFile$method_info$readShort$e2cbe212abc25f7a,
	&_jc_java_io_RandomAccessFile$method_info$readUTF$79add8d8f65f55bb,
	&_jc_java_io_RandomAccessFile$method_info$readUnsignedByte$b813876e99050350,
	&_jc_java_io_RandomAccessFile$method_info$readUnsignedShort$3fa3a6c504cc2667,
	&_jc_java_io_RandomAccessFile$method_info$seek$d605bbca03fdd295,
	&_jc_java_io_RandomAccessFile$method_info$setLength$90af1264b4ab2b43,
	&_jc_java_io_RandomAccessFile$method_info$skipBytes$0e108c4fd154433f,
	&_jc_java_io_RandomAccessFile$method_info$write$6377ac6964854eb2,
	&_jc_java_io_RandomAccessFile$method_info$write$18e189e8fc25f121,
	&_jc_java_io_RandomAccessFile$method_info$write$306a698343ec27e8,
	&_jc_java_io_RandomAccessFile$method_info$writeBoolean$32d3c2568a9bf8d7,
	&_jc_java_io_RandomAccessFile$method_info$writeByte$fba627021ccc49a7,
	&_jc_java_io_RandomAccessFile$method_info$writeBytes$5a36a7e449a2b6d7,
	&_jc_java_io_RandomAccessFile$method_info$writeChar$f5b967227ec03e20,
	&_jc_java_io_RandomAccessFile$method_info$writeChars$f5859b964fbc3b2f,
	&_jc_java_io_RandomAccessFile$method_info$writeDouble$d99c72d09a4cbd47,
	&_jc_java_io_RandomAccessFile$method_info$writeFloat$1747fde40a3f1453,
	&_jc_java_io_RandomAccessFile$method_info$writeInt$7a3be746a146b137,
	&_jc_java_io_RandomAccessFile$method_info$writeLong$abc739829b9abb59,
	&_jc_java_io_RandomAccessFile$method_info$writeShort$8ae9f66e0079966f,
	&_jc_java_io_RandomAccessFile$method_info$writeUTF$8e40eaaa736d9ee2
};

/************************************************************************
 *			      Interface list				*
 ************************************************************************/

// Directly implemented interfaces
static _jc_type *const _jc_java_io_RandomAccessFile$interfaces[] = {
	&_jc_java_io_DataOutput$type,
	&_jc_java_io_DataInput$type
};

/************************************************************************
 *			   Interface hash table				*
 ************************************************************************/

#if _JC_IMETHOD_HASHSIZE != 128
#error "_JC_IMETHOD_HASHSIZE has the wrong value (should be 128)"
#endif

// Interface lookup hash table buckets
static _jc_method *_jc_java_io_RandomAccessFile$imethod_hash_bucket_26[] = {
	&_jc_java_io_RandomAccessFile$method_info$readInt$029bcbc9fec7ab9a,
	_JC_NULL
};
static _jc_method *_jc_java_io_RandomAccessFile$imethod_hash_bucket_32[] = {
	&_jc_java_io_RandomAccessFile$method_info$writeChar$f5b967227ec03e20,
	_JC_NULL
};
static _jc_method *_jc_java_io_RandomAccessFile$imethod_hash_bucket_33[] = {
	&_jc_java_io_RandomAccessFile$method_info$write$18e189e8fc25f121,
	_JC_NULL
};
static _jc_method *_jc_java_io_RandomAccessFile$imethod_hash_bucket_39[] = {
	&_jc_java_io_RandomAccessFile$method_info$writeByte$fba627021ccc49a7,
	_JC_NULL
};
static _jc_method *_jc_java_io_RandomAccessFile$imethod_hash_bucket_44[] = {
	&_jc_java_io_RandomAccessFile$method_info$readDouble$6afd40b36b9672ac,
	_JC_NULL
};
static _jc_method *_jc_java_io_RandomAccessFile$imethod_hash_bucket_47[] = {
	&_jc_java_io_RandomAccessFile$method_info$writeChars$f5859b964fbc3b2f,
	_JC_NULL
};
static _jc_method *_jc_java_io_RandomAccessFile$imethod_hash_bucket_50[] = {
	&_jc_java_io_RandomAccessFile$method_info$write$6377ac6964854eb2,
	_JC_NULL
};
static _jc_method *_jc_java_io_RandomAccessFile$imethod_hash_bucket_55[] = {
	&_jc_java_io_RandomAccessFile$method_info$writeInt$7a3be746a146b137,
	_JC_NULL
};
static _jc_method *_jc_java_io_RandomAccessFile$imethod_hash_bucket_59[] = {
	&_jc_java_io_RandomAccessFile$method_info$readUTF$79add8d8f65f55bb,
	_JC_NULL
};
static _jc_method *_jc_java_io_RandomAccessFile$imethod_hash_bucket_63[] = {
	&_jc_java_io_RandomAccessFile$method_info$skipBytes$0e108c4fd154433f,
	_JC_NULL
};
static _jc_method *_jc_java_io_RandomAccessFile$imethod_hash_bucket_65[] = {
	&_jc_java_io_RandomAccessFile$method_info$readBoolean$607823a0fe7654c1,
	_JC_NULL
};
static _jc_method *_jc_java_io_RandomAccessFile$imethod_hash_bucket_70[] = {
	&_jc_java_io_RandomAccessFile$method_info$readFully$63e0ddb7f8315fc6,
	_JC_NULL
};
static _jc_method *_jc_java_io_RandomAccessFile$imethod_hash_bucket_71[] = {
	&_jc_java_io_RandomAccessFile$method_info$writeDouble$d99c72d09a4cbd47,
	_JC_NULL
};
static _jc_method *_jc_java_io_RandomAccessFile$imethod_hash_bucket_73[] = {
	&_jc_java_io_RandomAccessFile$method_info$readFully$2c917249902aa549,
	_JC_NULL
};
static _jc_method *_jc_java_io_RandomAccessFile$imethod_hash_bucket_80[] = {
	&_jc_java_io_RandomAccessFile$method_info$readUnsignedByte$b813876e99050350,
	_JC_NULL
};
static _jc_method *_jc_java_io_RandomAccessFile$imethod_hash_bucket_81[] = {
	&_jc_java_io_RandomAccessFile$method_info$readLine$d32396e6ff161651,
	_JC_NULL
};
static _jc_method *_jc_java_io_RandomAccessFile$imethod_hash_bucket_83[] = {
	&_jc_java_io_RandomAccessFile$method_info$writeFloat$1747fde40a3f1453,
	_JC_NULL
};
static _jc_method *_jc_java_io_RandomAccessFile$imethod_hash_bucket_87[] = {
	&_jc_java_io_RandomAccessFile$method_info$writeBoolean$32d3c2568a9bf8d7,
	&_jc_java_io_RandomAccessFile$method_info$writeBytes$5a36a7e449a2b6d7,
	_JC_NULL
};
static _jc_method *_jc_java_io_RandomAccessFile$imethod_hash_bucket_89[] = {
	&_jc_java_io_RandomAccessFile$method_info$writeLong$abc739829b9abb59,
	_JC_NULL
};
static _jc_method *_jc_java_io_RandomAccessFile$imethod_hash_bucket_91[] = {
	&_jc_java_io_RandomAccessFile$method_info$readChar$1f45f598ccf24d5b,
	_JC_NULL
};
static _jc_method *_jc_java_io_RandomAccessFile$imethod_hash_bucket_93[] = {
	&_jc_java_io_RandomAccessFile$method_info$readLong$2cb13656e73083dd,
	_JC_NULL
};
static _jc_method *_jc_java_io_RandomAccessFile$imethod_hash_bucket_96[] = {
	&_jc_java_io_RandomAccessFile$method_info$readByte$f0077b1d2a79a660,
	_JC_NULL
};
static _jc_method *_jc_java_io_RandomAccessFile$imethod_hash_bucket_98[] = {
	&_jc_java_io_RandomAccessFile$method_info$writeUTF$8e40eaaa736d9ee2,
	_JC_NULL
};
static _jc_method *_jc_java_io_RandomAccessFile$imethod_hash_bucket_103[] = {
	&_jc_java_io_RandomAccessFile$method_info$readUnsignedShort$3fa3a6c504cc2667,
	_JC_NULL
};
static _jc_method *_jc_java_io_RandomAccessFile$imethod_hash_bucket_104[] = {
	&_jc_java_io_RandomAccessFile$method_info$write$306a698343ec27e8,
	_JC_NULL
};
static _jc_method *_jc_java_io_RandomAccessFile$imethod_hash_bucket_111[] = {
	&_jc_java_io_RandomAccessFile$method_info$writeShort$8ae9f66e0079966f,
	_JC_NULL
};
static _jc_method *_jc_java_io_RandomAccessFile$imethod_hash_bucket_122[] = {
	&_jc_java_io_RandomAccessFile$method_info$readShort$e2cbe212abc25f7a,
	_JC_NULL
};
static _jc_method *_jc_java_io_RandomAccessFile$imethod_hash_bucket_124[] = {
	&_jc_java_io_RandomAccessFile$method_info$readFloat$91949088cf9525fc,
	_JC_NULL
};

// Interface lookup hash table
static _jc_method **_jc_java_io_RandomAccessFile$imethod_hash_table[_JC_IMETHOD_HASHSIZE] = {
	[26]=	_jc_java_io_RandomAccessFile$imethod_hash_bucket_26,
	[32]=	_jc_java_io_RandomAccessFile$imethod_hash_bucket_32,
	[33]=	_jc_java_io_RandomAccessFile$imethod_hash_bucket_33,
	[39]=	_jc_java_io_RandomAccessFile$imethod_hash_bucket_39,
	[44]=	_jc_java_io_RandomAccessFile$imethod_hash_bucket_44,
	[47]=	_jc_java_io_RandomAccessFile$imethod_hash_bucket_47,
	[50]=	_jc_java_io_RandomAccessFile$imethod_hash_bucket_50,
	[55]=	_jc_java_io_RandomAccessFile$imethod_hash_bucket_55,
	[59]=	_jc_java_io_RandomAccessFile$imethod_hash_bucket_59,
	[63]=	_jc_java_io_RandomAccessFile$imethod_hash_bucket_63,
	[65]=	_jc_java_io_RandomAccessFile$imethod_hash_bucket_65,
	[70]=	_jc_java_io_RandomAccessFile$imethod_hash_bucket_70,
	[71]=	_jc_java_io_RandomAccessFile$imethod_hash_bucket_71,
	[73]=	_jc_java_io_RandomAccessFile$imethod_hash_bucket_73,
	[80]=	_jc_java_io_RandomAccessFile$imethod_hash_bucket_80,
	[81]=	_jc_java_io_RandomAccessFile$imethod_hash_bucket_81,
	[83]=	_jc_java_io_RandomAccessFile$imethod_hash_bucket_83,
	[87]=	_jc_java_io_RandomAccessFile$imethod_hash_bucket_87,
	[89]=	_jc_java_io_RandomAccessFile$imethod_hash_bucket_89,
	[91]=	_jc_java_io_RandomAccessFile$imethod_hash_bucket_91,
	[93]=	_jc_java_io_RandomAccessFile$imethod_hash_bucket_93,
	[96]=	_jc_java_io_RandomAccessFile$imethod_hash_bucket_96,
	[98]=	_jc_java_io_RandomAccessFile$imethod_hash_bucket_98,
	[103]=	_jc_java_io_RandomAccessFile$imethod_hash_bucket_103,
	[104]=	_jc_java_io_RandomAccessFile$imethod_hash_bucket_104,
	[111]=	_jc_java_io_RandomAccessFile$imethod_hash_bucket_111,
	[122]=	_jc_java_io_RandomAccessFile$imethod_hash_bucket_122,
	[124]=	_jc_java_io_RandomAccessFile$imethod_hash_bucket_124
};

// Interface "quick" lookup hash table
static const void *_jc_java_io_RandomAccessFile$imethod_quick_table[_JC_IMETHOD_HASHSIZE] = {
	[26]=	&_jc_java_io_RandomAccessFile$method$readInt$029bcbc9fec7ab9a,
	[32]=	&_jc_java_io_RandomAccessFile$method$writeChar$f5b967227ec03e20,
	[33]=	&_jc_java_io_RandomAccessFile$method$write$18e189e8fc25f121,
	[39]=	&_jc_java_io_RandomAccessFile$method$writeByte$fba627021ccc49a7,
	[44]=	&_jc_java_io_RandomAccessFile$method$readDouble$6afd40b36b9672ac,
	[47]=	&_jc_java_io_RandomAccessFile$method$writeChars$f5859b964fbc3b2f,
	[50]=	&_jc_java_io_RandomAccessFile$method$write$6377ac6964854eb2,
	[55]=	&_jc_java_io_RandomAccessFile$method$writeInt$7a3be746a146b137,
	[59]=	&_jc_java_io_RandomAccessFile$method$readUTF$79add8d8f65f55bb,
	[63]=	&_jc_java_io_RandomAccessFile$method$skipBytes$0e108c4fd154433f,
	[65]=	&_jc_java_io_RandomAccessFile$method$readBoolean$607823a0fe7654c1,
	[70]=	&_jc_java_io_RandomAccessFile$method$readFully$63e0ddb7f8315fc6,
	[71]=	&_jc_java_io_RandomAccessFile$method$writeDouble$d99c72d09a4cbd47,
	[73]=	&_jc_java_io_RandomAccessFile$method$readFully$2c917249902aa549,
	[80]=	&_jc_java_io_RandomAccessFile$method$readUnsignedByte$b813876e99050350,
	[81]=	&_jc_java_io_RandomAccessFile$method$readLine$d32396e6ff161651,
	[83]=	&_jc_java_io_RandomAccessFile$method$writeFloat$1747fde40a3f1453,
	[89]=	&_jc_java_io_RandomAccessFile$method$writeLong$abc739829b9abb59,
	[91]=	&_jc_java_io_RandomAccessFile$method$readChar$1f45f598ccf24d5b,
	[93]=	&_jc_java_io_RandomAccessFile$method$readLong$2cb13656e73083dd,
	[96]=	&_jc_java_io_RandomAccessFile$method$readByte$f0077b1d2a79a660,
	[98]=	&_jc_java_io_RandomAccessFile$method$writeUTF$8e40eaaa736d9ee2,
	[103]=	&_jc_java_io_RandomAccessFile$method$readUnsignedShort$3fa3a6c504cc2667,
	[104]=	&_jc_java_io_RandomAccessFile$method$write$306a698343ec27e8,
	[111]=	&_jc_java_io_RandomAccessFile$method$writeShort$8ae9f66e0079966f,
	[122]=	&_jc_java_io_RandomAccessFile$method$readShort$e2cbe212abc25f7a,
	[124]=	&_jc_java_io_RandomAccessFile$method$readFloat$91949088cf9525fc
};

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_java_io_RandomAccessFile$instanceof_hash_bucket_60[] = {
	&_jc_java_io_DataInput$type,
	_JC_NULL
};
static _jc_type *const _jc_java_io_RandomAccessFile$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};
static _jc_type *const _jc_java_io_RandomAccessFile$instanceof_hash_bucket_117[] = {
	&_jc_java_io_DataOutput$type,
	_JC_NULL
};
static _jc_type *const _jc_java_io_RandomAccessFile$instanceof_hash_bucket_121[] = {
	&_jc_java_io_RandomAccessFile$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_java_io_RandomAccessFile$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[60]=	_jc_java_io_RandomAccessFile$instanceof_hash_bucket_60,
	[101]=	_jc_java_io_RandomAccessFile$instanceof_hash_bucket_101,
	[117]=	_jc_java_io_RandomAccessFile$instanceof_hash_bucket_117,
	[121]=	_jc_java_io_RandomAccessFile$instanceof_hash_bucket_121
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_java_io_RandomAccessFile$class_depends[] = {
	{ "gnu/java/nio/channels/FileChannelImpl",	_JC_JLONG(0x5fe9816daa9bdb2b) },
	{ "java/io/DataInput",	_JC_JLONG(0x8b11a73074165ebc) },
	{ "java/io/DataInputStream",	_JC_JLONG(0xcc3ce5b592e8a1d) },
	{ "java/io/DataOutput",	_JC_JLONG(0x3e88d5663da73a75) },
	{ "java/io/DataOutputStream",	_JC_JLONG(0xd755b96203d8fbaf) },
	{ "java/io/EOFException",	_JC_JLONG(0xcaf39081f5f70fef) },
	{ "java/io/File",	_JC_JLONG(0x9cef6b66128b04b2) },
	{ "java/io/FileDescriptor",	_JC_JLONG(0x410fd3c919444a2c) },
	{ "java/io/FileInputStream",	_JC_JLONG(0xc9cb932278ec6eea) },
	{ "java/io/FileNotFoundException",	_JC_JLONG(0x411c07e717eacf69) },
	{ "java/io/FileOutputStream",	_JC_JLONG(0x395e451981c47a9d) },
	{ "java/io/FilterInputStream",	_JC_JLONG(0x455accfa535f5dfe) },
	{ "java/io/FilterOutputStream",	_JC_JLONG(0xfddb41323d9c4cee) },
	{ "java/io/IOException",	_JC_JLONG(0x4e0a56550c69d57c) },
	{ "java/io/InputStream",	_JC_JLONG(0x66aea4d152614ac4) },
	{ "java/io/OutputStream",	_JC_JLONG(0x4026d3144d6654d8) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/Double",	_JC_JLONG(0x9c4f2f07f71cb134) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/Float",	_JC_JLONG(0x75223e1a41a9d924) },
	{ "java/lang/IllegalArgumentException",	_JC_JLONG(0x680cf34d05feb5a1) },
	{ "java/lang/Integer",	_JC_JLONG(0xca631501391a31f1) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/RuntimeException",	_JC_JLONG(0x4f5534a987354d1d) },
	{ "java/lang/SecurityManager",	_JC_JLONG(0xd38282f3d5f80887) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/StringBuffer",	_JC_JLONG(0x94d357637b968dda) },
	{ "java/lang/StringIndexOutOfBoundsException",	_JC_JLONG(0xbb7f6fdd2bd0e6b2) },
	{ "java/lang/System",	_JC_JLONG(0x53cc8e2333795f04) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMDouble",	_JC_JLONG(0x43adbb439e3f2be3) },
	{ "java/lang/VMFloat",	_JC_JLONG(0x8a4ea07ff88e78f8) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/nio/channels/ByteChannel",	_JC_JLONG(0x881892f7bdabdc26) },
	{ "java/nio/channels/ClosedChannelException",	_JC_JLONG(0x389bd38d1c277676) },
	{ "java/nio/channels/FileChannel",	_JC_JLONG(0x7ba04a8f861500de) },
	{ "java/nio/channels/spi/AbstractInterruptibleChannel",	_JC_JLONG(0xb39240b3676cb59b) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_java_io_RandomAccessFile$vtype _jc_java_io_RandomAccessFile$type = {
    .type= {
	.name=			"java/io/RandomAccessFile",
	.superclass=		&_jc_java_lang_Object$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.num_interfaces=sizeof(_jc_java_io_RandomAccessFile$interfaces) / sizeof(*_jc_java_io_RandomAccessFile$interfaces),
	.interfaces=		_jc_java_io_RandomAccessFile$interfaces,
	.imethod_hash_table=	_jc_java_io_RandomAccessFile$imethod_hash_table,
	.imethod_quick_table=	_jc_java_io_RandomAccessFile$imethod_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		50,
		.hash=			_JC_JLONG(0x2b5131841d8f479),
		.source_file=		"RandomAccessFile.java",
		.instance_size=		sizeof(_jc_java_io_RandomAccessFile$refs) + sizeof(_jc_java_io_RandomAccessFile$object),
		.num_virtual_refs=	4,
		.num_fields=		sizeof(_jc_java_io_RandomAccessFile$fields) / sizeof(*_jc_java_io_RandomAccessFile$fields),
		.fields=		_jc_java_io_RandomAccessFile$fields,
		.num_methods=		sizeof(_jc_java_io_RandomAccessFile$methods) / sizeof(*_jc_java_io_RandomAccessFile$methods),
		.methods=		_jc_java_io_RandomAccessFile$methods,
		.instanceof_hash_table=	_jc_java_io_RandomAccessFile$instanceof_hash_table,
		.num_class_depends=		sizeof(_jc_java_io_RandomAccessFile$class_depends) / sizeof(*_jc_java_io_RandomAccessFile$class_depends),
		.class_depends=		_jc_java_io_RandomAccessFile$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.java_io_RandomAccessFile= {
	    .close$6aba8b329fddcd79=
		&_jc_java_io_RandomAccessFile$method$close$6aba8b329fddcd79,
	    .getChannel$3c77b5fd77098bfe=
		&_jc_java_io_RandomAccessFile$method$getChannel$3c77b5fd77098bfe,
	    .getFD$7bb9e0bad3483351=
		&_jc_java_io_RandomAccessFile$method$getFD$7bb9e0bad3483351,
	    .getFilePointer$cbb05d8f3b9ac770=
		&_jc_java_io_RandomAccessFile$method$getFilePointer$cbb05d8f3b9ac770,
	    .length$c5778ac730410d75=
		&_jc_java_io_RandomAccessFile$method$length$c5778ac730410d75,
	    .read$1a981297cb524963=
		&_jc_java_io_RandomAccessFile$method$read$1a981297cb524963,
	    .read$c38dd905b7fb8654=
		&_jc_java_io_RandomAccessFile$method$read$c38dd905b7fb8654,
	    .read$e6b6c87b9f256783=
		&_jc_java_io_RandomAccessFile$method$read$e6b6c87b9f256783,
	    .readBoolean$607823a0fe7654c1=
		&_jc_java_io_RandomAccessFile$method$readBoolean$607823a0fe7654c1,
	    .readByte$f0077b1d2a79a660=
		&_jc_java_io_RandomAccessFile$method$readByte$f0077b1d2a79a660,
	    .readChar$1f45f598ccf24d5b=
		&_jc_java_io_RandomAccessFile$method$readChar$1f45f598ccf24d5b,
	    .readDouble$6afd40b36b9672ac=
		&_jc_java_io_RandomAccessFile$method$readDouble$6afd40b36b9672ac,
	    .readFloat$91949088cf9525fc=
		&_jc_java_io_RandomAccessFile$method$readFloat$91949088cf9525fc,
	    .readFully$2c917249902aa549=
		&_jc_java_io_RandomAccessFile$method$readFully$2c917249902aa549,
	    .readFully$63e0ddb7f8315fc6=
		&_jc_java_io_RandomAccessFile$method$readFully$63e0ddb7f8315fc6,
	    .readInt$029bcbc9fec7ab9a=
		&_jc_java_io_RandomAccessFile$method$readInt$029bcbc9fec7ab9a,
	    .readLine$d32396e6ff161651=
		&_jc_java_io_RandomAccessFile$method$readLine$d32396e6ff161651,
	    .readLong$2cb13656e73083dd=
		&_jc_java_io_RandomAccessFile$method$readLong$2cb13656e73083dd,
	    .readShort$e2cbe212abc25f7a=
		&_jc_java_io_RandomAccessFile$method$readShort$e2cbe212abc25f7a,
	    .readUTF$79add8d8f65f55bb=
		&_jc_java_io_RandomAccessFile$method$readUTF$79add8d8f65f55bb,
	    .readUnsignedByte$b813876e99050350=
		&_jc_java_io_RandomAccessFile$method$readUnsignedByte$b813876e99050350,
	    .readUnsignedShort$3fa3a6c504cc2667=
		&_jc_java_io_RandomAccessFile$method$readUnsignedShort$3fa3a6c504cc2667,
	    .seek$d605bbca03fdd295=
		&_jc_java_io_RandomAccessFile$method$seek$d605bbca03fdd295,
	    .setLength$90af1264b4ab2b43=
		&_jc_java_io_RandomAccessFile$method$setLength$90af1264b4ab2b43,
	    .skipBytes$0e108c4fd154433f=
		&_jc_java_io_RandomAccessFile$method$skipBytes$0e108c4fd154433f,
	    .write$6377ac6964854eb2=
		&_jc_java_io_RandomAccessFile$method$write$6377ac6964854eb2,
	    .write$18e189e8fc25f121=
		&_jc_java_io_RandomAccessFile$method$write$18e189e8fc25f121,
	    .write$306a698343ec27e8=
		&_jc_java_io_RandomAccessFile$method$write$306a698343ec27e8,
	    .writeBoolean$32d3c2568a9bf8d7=
		&_jc_java_io_RandomAccessFile$method$writeBoolean$32d3c2568a9bf8d7,
	    .writeByte$fba627021ccc49a7=
		&_jc_java_io_RandomAccessFile$method$writeByte$fba627021ccc49a7,
	    .writeBytes$5a36a7e449a2b6d7=
		&_jc_java_io_RandomAccessFile$method$writeBytes$5a36a7e449a2b6d7,
	    .writeChar$f5b967227ec03e20=
		&_jc_java_io_RandomAccessFile$method$writeChar$f5b967227ec03e20,
	    .writeChars$f5859b964fbc3b2f=
		&_jc_java_io_RandomAccessFile$method$writeChars$f5859b964fbc3b2f,
	    .writeDouble$d99c72d09a4cbd47=
		&_jc_java_io_RandomAccessFile$method$writeDouble$d99c72d09a4cbd47,
	    .writeFloat$1747fde40a3f1453=
		&_jc_java_io_RandomAccessFile$method$writeFloat$1747fde40a3f1453,
	    .writeInt$7a3be746a146b137=
		&_jc_java_io_RandomAccessFile$method$writeInt$7a3be746a146b137,
	    .writeLong$abc739829b9abb59=
		&_jc_java_io_RandomAccessFile$method$writeLong$abc739829b9abb59,
	    .writeShort$8ae9f66e0079966f=
		&_jc_java_io_RandomAccessFile$method$writeShort$8ae9f66e0079966f,
	    .writeUTF$8e40eaaa736d9ee2=
		&_jc_java_io_RandomAccessFile$method$writeUTF$8e40eaaa736d9ee2,
	},
    }
};

