// public class java.security.AlgorithmParameterGenerator

// class file dependencies
// @dep_class f4ba095546954b36 gnu_java_security_Engine
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class f02ab3ccb490a6d0 java_lang_ClassCastException
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class 680cf34d05feb5a1 java_lang_IllegalArgumentException
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class 4f5534a987354d1d java_lang_RuntimeException
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class ae4a2342b31a268d java_lang_reflect_InvocationTargetException
// @dep_class 16c8b8582ba1efb7 java_security_AlgorithmParameterGenerator
// @dep_class d641d91cd6167b5d java_security_AlgorithmParameterGeneratorSpi
// @dep_class 814794c0d977019 java_security_AlgorithmParameters
// @dep_class 692089051f4c8d0b java_security_GeneralSecurityException
// @dep_class 327edce29f2562dd java_security_InvalidAlgorithmParameterException
// @dep_class 22e937c2536160b4 java_security_NoSuchAlgorithmException
// @dep_class 8dfbf242adab91e java_security_NoSuchProviderException
// @dep_class 81b073051aa30acc java_security_Provider
// @dep_class 15c6a62b25a6e96d java_security_SecureRandom
// @dep_class 89bf77984bd9669e java_security_Security
// @dep_class ef2e5e8af121478f java_security_spec_AlgorithmParameterSpec
// @dep_class c53e1575b095109b java_util_Vector

// header file dependencies
// @dep_header gnu_java_security_Engine
// @dep_header java_lang_Class
// @dep_header java_lang_ClassCastException
// @dep_header java_lang_IllegalArgumentException
// @dep_header java_lang_String
// @dep_header java_lang_VMThrowable
// @dep_header java_lang_reflect_InvocationTargetException
// @dep_header java_security_AlgorithmParameterGenerator
// @dep_header java_security_AlgorithmParameterGeneratorSpi
// @dep_header java_security_AlgorithmParameters
// @dep_header java_security_InvalidAlgorithmParameterException
// @dep_header java_security_NoSuchAlgorithmException
// @dep_header java_security_NoSuchProviderException
// @dep_header java_security_Provider
// @dep_header java_security_SecureRandom
// @dep_header java_security_Security
// @dep_header java_security_spec_AlgorithmParameterSpec
// @dep_header java_util_Vector

#include "jc_defs.h"

#include "gnu/java/security/Engine.h"
#include "java/lang/Class.h"
#include "java/lang/ClassCastException.h"
#include "java/lang/IllegalArgumentException.h"
#include "java/lang/String.h"
#include "java/lang/VMThrowable.h"
#include "java/lang/reflect/InvocationTargetException.h"
#include "java/security/AlgorithmParameterGenerator.h"
#include "java/security/AlgorithmParameterGeneratorSpi.h"
#include "java/security/AlgorithmParameters.h"
#include "java/security/InvalidAlgorithmParameterException.h"
#include "java/security/NoSuchAlgorithmException.h"
#include "java/security/NoSuchProviderException.h"
#include "java/security/Provider.h"
#include "java/security/SecureRandom.h"
#include "java/security/Security.h"
#include "java/security/spec/AlgorithmParameterSpec.h"
#include "java/util/Vector.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// private static final java.lang.String ALGORITHM_PARAMETER_GENERATOR
static _jc_field _jc_java_security_AlgorithmParameterGenerator$field_info$ALGORITHM__5fPARAMETER__5fGENERATOR = {
	.name=		"ALGORITHM_PARAMETER_GENERATOR",
	.signature=	"Ljava/lang/String;",
	.class=		&_jc_java_security_AlgorithmParameterGenerator$type,
	.type=		&_jc_java_lang_String$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_java_security_AlgorithmParameterGenerator$fields_struct, ALGORITHM__5fPARAMETER__5fGENERATOR),
	.initial_value=	"AlgorithmParameterGenerator",
};

// private java.security.AlgorithmParameterGeneratorSpi paramGenSpi
static _jc_field _jc_java_security_AlgorithmParameterGenerator$field_info$paramGenSpi = {
	.name=		"paramGenSpi",
	.signature=	"Ljava/security/AlgorithmParameterGeneratorSpi;",
	.class=		&_jc_java_security_AlgorithmParameterGenerator$type,
	.type=		&_jc_java_security_AlgorithmParameterGeneratorSpi$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_security_AlgorithmParameterGenerator$object, refs[-1].java_security_AlgorithmParameterGenerator.paramGenSpi),
};

// private java.security.Provider provider
static _jc_field _jc_java_security_AlgorithmParameterGenerator$field_info$provider = {
	.name=		"provider",
	.signature=	"Ljava/security/Provider;",
	.class=		&_jc_java_security_AlgorithmParameterGenerator$type,
	.type=		&_jc_java_security_Provider$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_security_AlgorithmParameterGenerator$object, refs[-1].java_security_AlgorithmParameterGenerator.provider),
};

// private java.lang.String algorithm
static _jc_field _jc_java_security_AlgorithmParameterGenerator$field_info$algorithm = {
	.name=		"algorithm",
	.signature=	"Ljava/lang/String;",
	.class=		&_jc_java_security_AlgorithmParameterGenerator$type,
	.type=		&_jc_java_lang_String$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_security_AlgorithmParameterGenerator$object, refs[-1].java_security_AlgorithmParameterGenerator.algorithm),
};

// Fields
static _jc_field *const _jc_java_security_AlgorithmParameterGenerator$fields[] = {
	&_jc_java_security_AlgorithmParameterGenerator$field_info$ALGORITHM__5fPARAMETER__5fGENERATOR,
	&_jc_java_security_AlgorithmParameterGenerator$field_info$algorithm,
	&_jc_java_security_AlgorithmParameterGenerator$field_info$paramGenSpi,
	&_jc_java_security_AlgorithmParameterGenerator$field_info$provider
};

/************************************************************************
 *			      Static methods				*
 ************************************************************************/

//
// public static java.security.AlgorithmParameterGenerator getInstance(java.lang.String) throws java.security.NoSuchAlgorithmException
//

static _jc_linenum _jc_java_security_AlgorithmParameterGenerator$linenum_table$getInstance$11a809d01019b40a[];

static _jc_trap_info _jc_java_security_AlgorithmParameterGenerator$trap_table$getInstance$11a809d01019b40a[] = {
	_JC_TRAP(&_jc_java_security_NoSuchAlgorithmException$type, 1, 2),
};

static const unsigned char _jc_java_security_AlgorithmParameterGenerator$param_ptypes$getInstance$11a809d01019b40a[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_security_AlgorithmParameterGenerator$exceptions$getInstance$11a809d01019b40a[] = {
	&_jc_java_security_NoSuchAlgorithmException$type
};

static _jc_type *const _jc_java_security_AlgorithmParameterGenerator$param_types$getInstance$11a809d01019b40a[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_java_security_AlgorithmParameterGenerator$method_info$getInstance$11a809d01019b40a = {
	.name=			"getInstance",
	.signature=		"(Ljava/lang/String;)Ljava/security/AlgorithmParameterGenerator;",
	.class=			&_jc_java_security_AlgorithmParameterGenerator$type,
	.param_types=		&_jc_java_security_AlgorithmParameterGenerator$param_types$getInstance$11a809d01019b40a,
	.return_type=		&_jc_java_security_AlgorithmParameterGenerator$type,
	.param_ptypes=		&_jc_java_security_AlgorithmParameterGenerator$param_ptypes$getInstance$11a809d01019b40a,
	.signature_hash=	_JC_JLONG(0x11a809d01019b40a),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_java_security_AlgorithmParameterGenerator$method$getInstance$11a809d01019b40a,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_security_AlgorithmParameterGenerator$exceptions$getInstance$11a809d01019b40a,
	.u= { .exec= {
	  .trap_table_len=	1,
	  .trap_table=		_jc_java_security_AlgorithmParameterGenerator$trap_table$getInstance$11a809d01019b40a,
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_java_security_AlgorithmParameterGenerator$linenum_table$getInstance$11a809d01019b40a
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_AlgorithmParameterGenerator, getInstance$11a809d01019b40a);

_jc_java_security_AlgorithmParameterGenerator$object * _JC_JCNI_ATTR
_jc_java_security_AlgorithmParameterGenerator$method$getInstance$11a809d01019b40a(_jc_env *const env, _jc_java_lang_String$object *param0)
{
	jint volatile i0;
	jint volatile i1;
	jint i2;
	struct _jc_java_lang_String$object *volatile r0;
	struct _jc_java_security_Provider$object *volatile r2;
	struct _jc_java_security_AlgorithmParameterGenerator$object *volatile r3;
	struct _jc_java_security_NoSuchAlgorithmException$object *volatile r4;
	struct _jc_java_lang_VMThrowable$object *volatile r5;
	struct _jc_java_util_Vector$object *r6;
	_jc_object_array *volatile r7;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_java_security_AlgorithmParameterGenerator$method_info$getInstance$11a809d01019b40a, &&label1);

	r0 = param0;
	_JC_ACTIVE_USE(env, java_security_Security);
	_JC_LINE_NUMBER(138);				// 0
	r6 = _JC_STATIC_FIELD(env, java_security_Security, providers, 1);
	i2 = _JC_INVOKE_VIRTUAL(env, java_util_Vector, size$345df5220fc60ade, r6);
	r7 = _JC_NEW_REF_ARRAY(env, java_security_Provider, 1, i2);
	r6 = _JC_STATIC_FIELD(env, java_security_Security, providers, 1);
	_JC_INVOKE_VIRTUAL(env, java_util_Vector, copyInto$cd78d768b3ba4735, r6, r7);
	_JC_LINE_NUMBER(139);				// 1
	i0 = 0;
	goto label2;

label0:
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(142);				// 2
	r2 = _JC_REF_ELEMENT(env, r7, i0, 1, 1);
	r3 = _JC_INVOKE_STATIC(env, java_security_AlgorithmParameterGenerator, getInstance$54a0e3e9b549c528, 0, r0, r2);
	_JC_TRAP_REGION(catch, 2);
	_JC_CANCEL_TRAPS(env, catch);
	return r3;

label1:
	_JC_TRAP_REGION(catch, 2);
	r4 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(139);				// 3
	i0 = i0 + 1;

label2:
	_JC_TRAP_REGION(catch, 2);
	i1 = _JC_ARRAY_LENGTH(env, r7);
	if (i0 < i1) {
		_JC_PERIODIC_CHECK(env);
		goto label0;
	}
	_JC_LINE_NUMBER(149);				// 4
	r4 = _JC_NEW(env, java_security_NoSuchAlgorithmException);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r5 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r5;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r0;
	_JC_THROW(env, r4);
}

//
// public static java.security.AlgorithmParameterGenerator getInstance(java.lang.String, java.lang.String) throws java.security.NoSuchAlgorithmException, java.security.NoSuchProviderException
//

static _jc_linenum _jc_java_security_AlgorithmParameterGenerator$linenum_table$getInstance$4d1afa1f9cdd8503[];

static const unsigned char _jc_java_security_AlgorithmParameterGenerator$param_ptypes$getInstance$4d1afa1f9cdd8503[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_security_AlgorithmParameterGenerator$exceptions$getInstance$4d1afa1f9cdd8503[] = {
	&_jc_java_security_NoSuchAlgorithmException$type,
	&_jc_java_security_NoSuchProviderException$type
};

static _jc_type *const _jc_java_security_AlgorithmParameterGenerator$param_types$getInstance$4d1afa1f9cdd8503[] = {
	&_jc_java_lang_String$type,
	&_jc_java_lang_String$type
};

_jc_method _jc_java_security_AlgorithmParameterGenerator$method_info$getInstance$4d1afa1f9cdd8503 = {
	.name=			"getInstance",
	.signature=		"(Ljava/lang/String;Ljava/lang/String;)Ljava/security/AlgorithmParameterGenerator;",
	.class=			&_jc_java_security_AlgorithmParameterGenerator$type,
	.param_types=		&_jc_java_security_AlgorithmParameterGenerator$param_types$getInstance$4d1afa1f9cdd8503,
	.return_type=		&_jc_java_security_AlgorithmParameterGenerator$type,
	.param_ptypes=		&_jc_java_security_AlgorithmParameterGenerator$param_ptypes$getInstance$4d1afa1f9cdd8503,
	.signature_hash=	_JC_JLONG(0x4d1afa1f9cdd8503),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_java_security_AlgorithmParameterGenerator$method$getInstance$4d1afa1f9cdd8503,
	.num_parameters=	2,
	.num_exceptions=	2,
	.exceptions=		&_jc_java_security_AlgorithmParameterGenerator$exceptions$getInstance$4d1afa1f9cdd8503,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	6,
	      .table=	_jc_java_security_AlgorithmParameterGenerator$linenum_table$getInstance$4d1afa1f9cdd8503
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_AlgorithmParameterGenerator, getInstance$4d1afa1f9cdd8503);

_jc_java_security_AlgorithmParameterGenerator$object * _JC_JCNI_ATTR
_jc_java_security_AlgorithmParameterGenerator$method$getInstance$4d1afa1f9cdd8503(_jc_env *const env, _jc_java_lang_String$object *param0, _jc_java_lang_String$object *param1)
{
	jint i0;
	struct _jc_java_lang_String$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_java_security_Provider$object *r2;
	struct _jc_java_lang_IllegalArgumentException$object *r3;
	struct _jc_java_security_NoSuchProviderException$object *r4;
	struct _jc_java_security_AlgorithmParameterGenerator$object *r5;
	struct _jc_java_lang_String$object *r6;
	struct _jc_java_lang_VMThrowable$object *r7;
	struct _jc_java_lang_VMThrowable$object *r9;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = param0;
	r1 = param1;
	_JC_LINE_NUMBER(172);				// 0
	if (r1 == _JC_NULL)
		goto label0;
	i0 = _JC_PRIM_FIELD(env, r1, java_lang_String, count);
	if (i0 != 0)
		goto label1;

label0:
	_JC_LINE_NUMBER(173);				// 1
	r3 = _JC_NEW(env, java_lang_IllegalArgumentException);
	r6 = _JC_STRING(env, "Illegal provider");
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r7 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r7;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r6;
	_JC_THROW(env, r3);

label1:
	_JC_LINE_NUMBER(175);				// 2
	r2 = _JC_INVOKE_STATIC(env, java_security_Security, getProvider$581ee7d7bc9ae747, 0, r1);
	_JC_LINE_NUMBER(176);				// 3
	if (r2 != _JC_NULL)
		goto label2;
	_JC_LINE_NUMBER(177);				// 4
	r4 = _JC_NEW(env, java_security_NoSuchProviderException);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r9 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r9;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r1;
	_JC_THROW(env, r4);

label2:
	_JC_LINE_NUMBER(179);				// 5
	r5 = _JC_INVOKE_STATIC(env, java_security_AlgorithmParameterGenerator, getInstance$54a0e3e9b549c528, 1, r0, r2);
	return r5;
}

//
// public static java.security.AlgorithmParameterGenerator getInstance(java.lang.String, java.security.Provider) throws java.security.NoSuchAlgorithmException
//

static _jc_linenum _jc_java_security_AlgorithmParameterGenerator$linenum_table$getInstance$54a0e3e9b549c528[];

static _jc_trap_info _jc_java_security_AlgorithmParameterGenerator$trap_table$getInstance$54a0e3e9b549c528[] = {
	_JC_TRAP(&_jc_java_lang_reflect_InvocationTargetException$type, 1, 2),
	_JC_TRAP(&_jc_java_lang_ClassCastException$type, 1, 2),
};

static const unsigned char _jc_java_security_AlgorithmParameterGenerator$param_ptypes$getInstance$54a0e3e9b549c528[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_security_AlgorithmParameterGenerator$exceptions$getInstance$54a0e3e9b549c528[] = {
	&_jc_java_security_NoSuchAlgorithmException$type
};

static _jc_type *const _jc_java_security_AlgorithmParameterGenerator$param_types$getInstance$54a0e3e9b549c528[] = {
	&_jc_java_lang_String$type,
	&_jc_java_security_Provider$type
};

_jc_method _jc_java_security_AlgorithmParameterGenerator$method_info$getInstance$54a0e3e9b549c528 = {
	.name=			"getInstance",
	.signature=		"(Ljava/lang/String;Ljava/security/Provider;)Ljava/security/AlgorithmParameterGenerator;",
	.class=			&_jc_java_security_AlgorithmParameterGenerator$type,
	.param_types=		&_jc_java_security_AlgorithmParameterGenerator$param_types$getInstance$54a0e3e9b549c528,
	.return_type=		&_jc_java_security_AlgorithmParameterGenerator$type,
	.param_ptypes=		&_jc_java_security_AlgorithmParameterGenerator$param_ptypes$getInstance$54a0e3e9b549c528,
	.signature_hash=	_JC_JLONG(0x54a0e3e9b549c528),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_java_security_AlgorithmParameterGenerator$method$getInstance$54a0e3e9b549c528,
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_security_AlgorithmParameterGenerator$exceptions$getInstance$54a0e3e9b549c528,
	.u= { .exec= {
	  .trap_table_len=	2,
	  .trap_table=		_jc_java_security_AlgorithmParameterGenerator$trap_table$getInstance$54a0e3e9b549c528,
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_java_security_AlgorithmParameterGenerator$linenum_table$getInstance$54a0e3e9b549c528
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_AlgorithmParameterGenerator, getInstance$54a0e3e9b549c528);

_jc_java_security_AlgorithmParameterGenerator$object * _JC_JCNI_ATTR
_jc_java_security_AlgorithmParameterGenerator$method$getInstance$54a0e3e9b549c528(_jc_env *const env, _jc_java_lang_String$object *param0, _jc_java_security_Provider$object *param1)
{
	struct _jc_java_lang_String$object *volatile r0;
	struct _jc_java_security_Provider$object *r1;
	_jc_object_array *r10;
	struct _jc_java_lang_Object$object *r11;
	struct _jc_java_lang_VMThrowable$object *r12;
	struct _jc_java_lang_VMThrowable$object *volatile r13;
	struct _jc_java_lang_VMThrowable$object *volatile r15;
	struct _jc_java_lang_reflect_InvocationTargetException$object *r2;
	struct _jc_java_lang_IllegalArgumentException$object *r3;
	struct _jc_java_security_AlgorithmParameterGenerator$object *r4;
	struct _jc_java_security_AlgorithmParameterGeneratorSpi$object *r5;
	struct _jc_java_security_NoSuchAlgorithmException$object *volatile r6;
	struct _jc_java_lang_ClassCastException$object *r7;
	struct _jc_java_lang_String$object *r8;
	struct _jc_java_lang_String$object *r9;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_java_security_AlgorithmParameterGenerator$method_info$getInstance$54a0e3e9b549c528, &&label1, &&label2);

	r0 = param0;
	r1 = param1;
	_JC_LINE_NUMBER(201);				// 0
	if (r1 != _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(202);				// 1
	r3 = _JC_NEW(env, java_lang_IllegalArgumentException);
	r8 = _JC_STRING(env, "Illegal provider");
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r12 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r12;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r8;
	_JC_THROW(env, r3);

label0:
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(206);				// 2
	r4 = _JC_NEW(env, java_security_AlgorithmParameterGenerator);
	_JC_ACTIVE_USE(env, gnu_java_security_Engine);
	r9 = _JC_STRING(env, "AlgorithmParameterGenerator");
	r10 = _JC_STATIC_FIELD(env, gnu_java_security_Engine, NO__5fARGS, 1);
	r11 = _JC_INVOKE_STATIC(env, gnu_java_security_Engine, getInstance$ec89dfd35c234c64, 1, r9, r0, r1, r10);
	r5 = _JC_CAST(env, &_jc_java_security_AlgorithmParameterGeneratorSpi$type, r11);
	_JC_REF_FIELD(env, r4, java_security_AlgorithmParameterGenerator, paramGenSpi) = r5;
	_JC_REF_FIELD(env, r4, java_security_AlgorithmParameterGenerator, provider) = r1;
	_JC_REF_FIELD(env, r4, java_security_AlgorithmParameterGenerator, algorithm) = r0;
	_JC_TRAP_REGION(catch, 2);
	_JC_CANCEL_TRAPS(env, catch);
	return r4;

label1:
	_JC_TRAP_REGION(catch, 2);
	r2 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(213);				// 3
	r6 = _JC_NEW(env, java_security_NoSuchAlgorithmException);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, cause) = r6;
	r13 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r6);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, vmState) = r13;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, detailMessage) = r0;
	_JC_THROW(env, r6);

label2:
	_JC_TRAP_REGION(catch, 2);
	r7 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(217);				// 4
	r6 = _JC_NEW(env, java_security_NoSuchAlgorithmException);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, cause) = r6;
	r15 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r6);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, vmState) = r15;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, detailMessage) = r0;
	_JC_THROW(env, r6);
}

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// protected void <init>(java.security.AlgorithmParameterGeneratorSpi, java.security.Provider, java.lang.String)
//

static _jc_linenum _jc_java_security_AlgorithmParameterGenerator$linenum_table$_init$505ae2b5870ebd8f[];

static const unsigned char _jc_java_security_AlgorithmParameterGenerator$param_ptypes$_init$505ae2b5870ebd8f[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_security_AlgorithmParameterGenerator$param_types$_init$505ae2b5870ebd8f[] = {
	&_jc_java_security_AlgorithmParameterGeneratorSpi$type,
	&_jc_java_security_Provider$type,
	&_jc_java_lang_String$type
};

_jc_method _jc_java_security_AlgorithmParameterGenerator$method_info$_init$505ae2b5870ebd8f = {
	.name=			"<init>",
	.signature=		"(Ljava/security/AlgorithmParameterGeneratorSpi;Ljava/security/Provider;Ljava/lang/String;)V",
	.class=			&_jc_java_security_AlgorithmParameterGenerator$type,
	.param_types=		&_jc_java_security_AlgorithmParameterGenerator$param_types$_init$505ae2b5870ebd8f,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_security_AlgorithmParameterGenerator$param_ptypes$_init$505ae2b5870ebd8f,
	.signature_hash=	_JC_JLONG(0x505ae2b5870ebd8f),
	.access_flags=		_JC_ACC_PROTECTED,
	.function=		&_jc_java_security_AlgorithmParameterGenerator$method$_init$505ae2b5870ebd8f,
	.num_parameters=	3,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_java_security_AlgorithmParameterGenerator$linenum_table$_init$505ae2b5870ebd8f
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_AlgorithmParameterGenerator, _init$505ae2b5870ebd8f);

void _JC_JCNI_ATTR
_jc_java_security_AlgorithmParameterGenerator$method$_init$505ae2b5870ebd8f(_jc_env *const env, _jc_java_security_AlgorithmParameterGenerator$object *this, _jc_java_security_AlgorithmParameterGeneratorSpi$object *param0, _jc_java_security_Provider$object *param1, _jc_java_lang_String$object *param2)
{
	struct _jc_java_security_AlgorithmParameterGenerator$object *r0;
	struct _jc_java_security_AlgorithmParameterGeneratorSpi$object *r1;
	struct _jc_java_security_Provider$object *r2;
	struct _jc_java_lang_String$object *r3;

	r0 = this;
	r1 = param0;
	r2 = param1;
	r3 = param2;
	_JC_LINE_NUMBER(105);				// 0
	_JC_REF_FIELD(env, r0, java_security_AlgorithmParameterGenerator, paramGenSpi) = r1;
	_JC_LINE_NUMBER(106);				// 1
	_JC_REF_FIELD(env, r0, java_security_AlgorithmParameterGenerator, provider) = r2;
	_JC_LINE_NUMBER(107);				// 2
	_JC_REF_FIELD(env, r0, java_security_AlgorithmParameterGenerator, algorithm) = r3;
	_JC_LINE_NUMBER(108);				// 3
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public final java.security.AlgorithmParameters generateParameters()
//

static _jc_linenum _jc_java_security_AlgorithmParameterGenerator$linenum_table$generateParameters$df0bc34eb57e2e27[];

static const unsigned char _jc_java_security_AlgorithmParameterGenerator$param_ptypes$generateParameters$df0bc34eb57e2e27[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_java_security_AlgorithmParameterGenerator$method_info$generateParameters$df0bc34eb57e2e27 = {
	.name=			"generateParameters",
	.signature=		"()Ljava/security/AlgorithmParameters;",
	.class=			&_jc_java_security_AlgorithmParameterGenerator$type,
	.return_type=		&_jc_java_security_AlgorithmParameters$type,
	.param_ptypes=		&_jc_java_security_AlgorithmParameterGenerator$param_ptypes$generateParameters$df0bc34eb57e2e27,
	.signature_hash=	_JC_JLONG(0xdf0bc34eb57e2e27),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_security_AlgorithmParameterGenerator$method$generateParameters$df0bc34eb57e2e27,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_AlgorithmParameterGenerator$vtable, java_security_AlgorithmParameterGenerator.generateParameters$df0bc34eb57e2e27) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_AlgorithmParameterGenerator$linenum_table$generateParameters$df0bc34eb57e2e27
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_AlgorithmParameterGenerator, generateParameters$df0bc34eb57e2e27);

_jc_java_security_AlgorithmParameters$object * _JC_JCNI_ATTR
_jc_java_security_AlgorithmParameterGenerator$method$generateParameters$df0bc34eb57e2e27(_jc_env *const env, _jc_java_security_AlgorithmParameterGenerator$object *this)
{
	struct _jc_java_security_AlgorithmParameterGenerator$object *r0;
	struct _jc_java_security_AlgorithmParameterGeneratorSpi$object *r1;
	struct _jc_java_security_AlgorithmParameters$object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(300);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_security_AlgorithmParameterGenerator, paramGenSpi);
	r2 = _JC_INVOKE_VIRTUAL(env, java_security_AlgorithmParameterGeneratorSpi, engineGenerateParameters$c500aa80c3b5d11e, r1);
	return r2;
}

//
// public final java.lang.String getAlgorithm()
//

static _jc_linenum _jc_java_security_AlgorithmParameterGenerator$linenum_table$getAlgorithm$19abbbc132b9063a[];

static const unsigned char _jc_java_security_AlgorithmParameterGenerator$param_ptypes$getAlgorithm$19abbbc132b9063a[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_java_security_AlgorithmParameterGenerator$method_info$getAlgorithm$19abbbc132b9063a = {
	.name=			"getAlgorithm",
	.signature=		"()Ljava/lang/String;",
	.class=			&_jc_java_security_AlgorithmParameterGenerator$type,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_java_security_AlgorithmParameterGenerator$param_ptypes$getAlgorithm$19abbbc132b9063a,
	.signature_hash=	_JC_JLONG(0x19abbbc132b9063a),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_security_AlgorithmParameterGenerator$method$getAlgorithm$19abbbc132b9063a,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_AlgorithmParameterGenerator$vtable, java_security_AlgorithmParameterGenerator.getAlgorithm$19abbbc132b9063a) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_AlgorithmParameterGenerator$linenum_table$getAlgorithm$19abbbc132b9063a
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_AlgorithmParameterGenerator, getAlgorithm$19abbbc132b9063a);

_jc_java_lang_String$object * _JC_JCNI_ATTR
_jc_java_security_AlgorithmParameterGenerator$method$getAlgorithm$19abbbc132b9063a(_jc_env *const env, _jc_java_security_AlgorithmParameterGenerator$object *this)
{
	struct _jc_java_security_AlgorithmParameterGenerator$object *r0;
	struct _jc_java_lang_String$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(118);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_security_AlgorithmParameterGenerator, algorithm);
	return r1;
}

//
// public final java.security.Provider getProvider()
//

static _jc_linenum _jc_java_security_AlgorithmParameterGenerator$linenum_table$getProvider$e8f9c9fb14140d5a[];

static const unsigned char _jc_java_security_AlgorithmParameterGenerator$param_ptypes$getProvider$e8f9c9fb14140d5a[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_java_security_AlgorithmParameterGenerator$method_info$getProvider$e8f9c9fb14140d5a = {
	.name=			"getProvider",
	.signature=		"()Ljava/security/Provider;",
	.class=			&_jc_java_security_AlgorithmParameterGenerator$type,
	.return_type=		&_jc_java_security_Provider$type,
	.param_ptypes=		&_jc_java_security_AlgorithmParameterGenerator$param_ptypes$getProvider$e8f9c9fb14140d5a,
	.signature_hash=	_JC_JLONG(0xe8f9c9fb14140d5a),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_security_AlgorithmParameterGenerator$method$getProvider$e8f9c9fb14140d5a,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_AlgorithmParameterGenerator$vtable, java_security_AlgorithmParameterGenerator.getProvider$e8f9c9fb14140d5a) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_AlgorithmParameterGenerator$linenum_table$getProvider$e8f9c9fb14140d5a
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_AlgorithmParameterGenerator, getProvider$e8f9c9fb14140d5a);

_jc_java_security_Provider$object * _JC_JCNI_ATTR
_jc_java_security_AlgorithmParameterGenerator$method$getProvider$e8f9c9fb14140d5a(_jc_env *const env, _jc_java_security_AlgorithmParameterGenerator$object *this)
{
	struct _jc_java_security_AlgorithmParameterGenerator$object *r0;
	struct _jc_java_security_Provider$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(228);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_security_AlgorithmParameterGenerator, provider);
	return r1;
}

//
// public final void init(int)
//

static _jc_linenum _jc_java_security_AlgorithmParameterGenerator$linenum_table$init$bfae065b93f25bd8[];

static const unsigned char _jc_java_security_AlgorithmParameterGenerator$param_ptypes$init$bfae065b93f25bd8[] = { 
_JC_TYPE_INT, _JC_TYPE_VOID };

static _jc_type *const _jc_java_security_AlgorithmParameterGenerator$param_types$init$bfae065b93f25bd8[] = {
	&_jc_int$prim$type
};

_jc_method _jc_java_security_AlgorithmParameterGenerator$method_info$init$bfae065b93f25bd8 = {
	.name=			"init",
	.signature=		"(I)V",
	.class=			&_jc_java_security_AlgorithmParameterGenerator$type,
	.param_types=		&_jc_java_security_AlgorithmParameterGenerator$param_types$init$bfae065b93f25bd8,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_security_AlgorithmParameterGenerator$param_ptypes$init$bfae065b93f25bd8,
	.signature_hash=	_JC_JLONG(0xbfae065b93f25bd8),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_security_AlgorithmParameterGenerator$method$init$bfae065b93f25bd8,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_AlgorithmParameterGenerator$vtable, java_security_AlgorithmParameterGenerator.init$bfae065b93f25bd8) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_security_AlgorithmParameterGenerator$linenum_table$init$bfae065b93f25bd8
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_AlgorithmParameterGenerator, init$bfae065b93f25bd8);

void _JC_JCNI_ATTR
_jc_java_security_AlgorithmParameterGenerator$method$init$bfae065b93f25bd8(_jc_env *const env, _jc_java_security_AlgorithmParameterGenerator$object *this, jint param0)
{
	jint i0;
	struct _jc_java_security_AlgorithmParameterGenerator$object *r0;
	struct _jc_java_security_SecureRandom$object *r1;
	struct _jc_java_security_AlgorithmParameterGeneratorSpi$object *r4;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	i0 = param0;
	_JC_LINE_NUMBER(242);				// 0
	r1 = _JC_NEW(env, java_security_SecureRandom);
	_JC_INVOKE_NONVIRTUAL(env, java_security_SecureRandom, _init$52f4ad9f2989aeee, 0, r1);
	r4 = _JC_REF_FIELD(env, r0, java_security_AlgorithmParameterGenerator, paramGenSpi);
	_JC_INVOKE_VIRTUAL(env, java_security_AlgorithmParameterGeneratorSpi, engineInit$ce17ad6b3fc98d82, r4, i0, r1);
	_JC_LINE_NUMBER(243);				// 1
	return;
}

//
// public final void init(int, java.security.SecureRandom)
//

static _jc_linenum _jc_java_security_AlgorithmParameterGenerator$linenum_table$init$a6cee9d167433657[];

static const unsigned char _jc_java_security_AlgorithmParameterGenerator$param_ptypes$init$a6cee9d167433657[] = { 
_JC_TYPE_INT, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_security_AlgorithmParameterGenerator$param_types$init$a6cee9d167433657[] = {
	&_jc_int$prim$type,
	&_jc_java_security_SecureRandom$type
};

_jc_method _jc_java_security_AlgorithmParameterGenerator$method_info$init$a6cee9d167433657 = {
	.name=			"init",
	.signature=		"(ILjava/security/SecureRandom;)V",
	.class=			&_jc_java_security_AlgorithmParameterGenerator$type,
	.param_types=		&_jc_java_security_AlgorithmParameterGenerator$param_types$init$a6cee9d167433657,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_security_AlgorithmParameterGenerator$param_ptypes$init$a6cee9d167433657,
	.signature_hash=	_JC_JLONG(0xa6cee9d167433657),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_security_AlgorithmParameterGenerator$method$init$a6cee9d167433657,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_AlgorithmParameterGenerator$vtable, java_security_AlgorithmParameterGenerator.init$a6cee9d167433657) / sizeof(void *),
	.num_parameters=	2,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_security_AlgorithmParameterGenerator$linenum_table$init$a6cee9d167433657
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_AlgorithmParameterGenerator, init$a6cee9d167433657);

void _JC_JCNI_ATTR
_jc_java_security_AlgorithmParameterGenerator$method$init$a6cee9d167433657(_jc_env *const env, _jc_java_security_AlgorithmParameterGenerator$object *this, jint param0, _jc_java_security_SecureRandom$object *param1)
{
	jint i0;
	struct _jc_java_security_AlgorithmParameterGenerator$object *r0;
	struct _jc_java_security_SecureRandom$object *r1;
	struct _jc_java_security_AlgorithmParameterGeneratorSpi$object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	i0 = param0;
	r1 = param1;
	_JC_LINE_NUMBER(254);				// 0
	r2 = _JC_REF_FIELD(env, r0, java_security_AlgorithmParameterGenerator, paramGenSpi);
	_JC_INVOKE_VIRTUAL(env, java_security_AlgorithmParameterGeneratorSpi, engineInit$ce17ad6b3fc98d82, r2, i0, r1);
	_JC_LINE_NUMBER(255);				// 1
	return;
}

//
// public final void init(java.security.spec.AlgorithmParameterSpec) throws java.security.InvalidAlgorithmParameterException
//

static _jc_linenum _jc_java_security_AlgorithmParameterGenerator$linenum_table$init$ed37b79a75a6f3d3[];

static const unsigned char _jc_java_security_AlgorithmParameterGenerator$param_ptypes$init$ed37b79a75a6f3d3[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_security_AlgorithmParameterGenerator$exceptions$init$ed37b79a75a6f3d3[] = {
	&_jc_java_security_InvalidAlgorithmParameterException$type
};

static _jc_type *const _jc_java_security_AlgorithmParameterGenerator$param_types$init$ed37b79a75a6f3d3[] = {
	&_jc_java_security_spec_AlgorithmParameterSpec$type
};

_jc_method _jc_java_security_AlgorithmParameterGenerator$method_info$init$ed37b79a75a6f3d3 = {
	.name=			"init",
	.signature=		"(Ljava/security/spec/AlgorithmParameterSpec;)V",
	.class=			&_jc_java_security_AlgorithmParameterGenerator$type,
	.param_types=		&_jc_java_security_AlgorithmParameterGenerator$param_types$init$ed37b79a75a6f3d3,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_security_AlgorithmParameterGenerator$param_ptypes$init$ed37b79a75a6f3d3,
	.signature_hash=	_JC_JLONG(0xed37b79a75a6f3d3),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_security_AlgorithmParameterGenerator$method$init$ed37b79a75a6f3d3,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_AlgorithmParameterGenerator$vtable, java_security_AlgorithmParameterGenerator.init$ed37b79a75a6f3d3) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_security_AlgorithmParameterGenerator$exceptions$init$ed37b79a75a6f3d3,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_security_AlgorithmParameterGenerator$linenum_table$init$ed37b79a75a6f3d3
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_AlgorithmParameterGenerator, init$ed37b79a75a6f3d3);

void _JC_JCNI_ATTR
_jc_java_security_AlgorithmParameterGenerator$method$init$ed37b79a75a6f3d3(_jc_env *const env, _jc_java_security_AlgorithmParameterGenerator$object *this, _jc_object *param0)
{
	struct _jc_java_security_AlgorithmParameterGenerator$object *r0;
	struct _jc_object *r1;
	struct _jc_java_security_SecureRandom$object *r2;
	struct _jc_java_security_AlgorithmParameterGeneratorSpi$object *r6;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(273);				// 0
	r2 = _JC_NEW(env, java_security_SecureRandom);
	_JC_INVOKE_NONVIRTUAL(env, java_security_SecureRandom, _init$52f4ad9f2989aeee, 0, r2);
	r6 = _JC_REF_FIELD(env, r0, java_security_AlgorithmParameterGenerator, paramGenSpi);
	_JC_INVOKE_VIRTUAL(env, java_security_AlgorithmParameterGeneratorSpi, engineInit$5af33bc7d4d69573, r6, r1, r2);
	_JC_LINE_NUMBER(274);				// 1
	return;
}

//
// public final void init(java.security.spec.AlgorithmParameterSpec, java.security.SecureRandom) throws java.security.InvalidAlgorithmParameterException
//

static _jc_linenum _jc_java_security_AlgorithmParameterGenerator$linenum_table$init$befc7893049358cc[];

static const unsigned char _jc_java_security_AlgorithmParameterGenerator$param_ptypes$init$befc7893049358cc[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_security_AlgorithmParameterGenerator$exceptions$init$befc7893049358cc[] = {
	&_jc_java_security_InvalidAlgorithmParameterException$type
};

static _jc_type *const _jc_java_security_AlgorithmParameterGenerator$param_types$init$befc7893049358cc[] = {
	&_jc_java_security_spec_AlgorithmParameterSpec$type,
	&_jc_java_security_SecureRandom$type
};

_jc_method _jc_java_security_AlgorithmParameterGenerator$method_info$init$befc7893049358cc = {
	.name=			"init",
	.signature=		"(Ljava/security/spec/AlgorithmParameterSpec;Ljava/security/SecureRandom;)V",
	.class=			&_jc_java_security_AlgorithmParameterGenerator$type,
	.param_types=		&_jc_java_security_AlgorithmParameterGenerator$param_types$init$befc7893049358cc,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_security_AlgorithmParameterGenerator$param_ptypes$init$befc7893049358cc,
	.signature_hash=	_JC_JLONG(0xbefc7893049358cc),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_security_AlgorithmParameterGenerator$method$init$befc7893049358cc,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_AlgorithmParameterGenerator$vtable, java_security_AlgorithmParameterGenerator.init$befc7893049358cc) / sizeof(void *),
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_security_AlgorithmParameterGenerator$exceptions$init$befc7893049358cc,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_security_AlgorithmParameterGenerator$linenum_table$init$befc7893049358cc
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_AlgorithmParameterGenerator, init$befc7893049358cc);

void _JC_JCNI_ATTR
_jc_java_security_AlgorithmParameterGenerator$method$init$befc7893049358cc(_jc_env *const env, _jc_java_security_AlgorithmParameterGenerator$object *this, _jc_object *param0, _jc_java_security_SecureRandom$object *param1)
{
	struct _jc_java_security_AlgorithmParameterGenerator$object *r0;
	struct _jc_object *r1;
	struct _jc_java_security_SecureRandom$object *r2;
	struct _jc_java_security_AlgorithmParameterGeneratorSpi$object *r3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_LINE_NUMBER(290);				// 0
	r3 = _JC_REF_FIELD(env, r0, java_security_AlgorithmParameterGenerator, paramGenSpi);
	_JC_INVOKE_VIRTUAL(env, java_security_AlgorithmParameterGeneratorSpi, engineInit$5af33bc7d4d69573, r3, r1, r2);
	_JC_LINE_NUMBER(291);				// 1
	return;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_java_security_AlgorithmParameterGenerator$methods[] = {
	&_jc_java_security_AlgorithmParameterGenerator$method_info$_init$505ae2b5870ebd8f,
	&_jc_java_security_AlgorithmParameterGenerator$method_info$generateParameters$df0bc34eb57e2e27,
	&_jc_java_security_AlgorithmParameterGenerator$method_info$getAlgorithm$19abbbc132b9063a,
	&_jc_java_security_AlgorithmParameterGenerator$method_info$getInstance$11a809d01019b40a,
	&_jc_java_security_AlgorithmParameterGenerator$method_info$getInstance$4d1afa1f9cdd8503,
	&_jc_java_security_AlgorithmParameterGenerator$method_info$getInstance$54a0e3e9b549c528,
	&_jc_java_security_AlgorithmParameterGenerator$method_info$getProvider$e8f9c9fb14140d5a,
	&_jc_java_security_AlgorithmParameterGenerator$method_info$init$bfae065b93f25bd8,
	&_jc_java_security_AlgorithmParameterGenerator$method_info$init$a6cee9d167433657,
	&_jc_java_security_AlgorithmParameterGenerator$method_info$init$ed37b79a75a6f3d3,
	&_jc_java_security_AlgorithmParameterGenerator$method_info$init$befc7893049358cc
};

/************************************************************************
 *			  Class fields structure			*
 ************************************************************************/

_jc_java_security_AlgorithmParameterGenerator$fields_struct _jc_java_security_AlgorithmParameterGenerator$class_fields = { };

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_java_security_AlgorithmParameterGenerator$instanceof_hash_bucket_55[] = {
	&_jc_java_security_AlgorithmParameterGenerator$type,
	_JC_NULL
};
static _jc_type *const _jc_java_security_AlgorithmParameterGenerator$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_java_security_AlgorithmParameterGenerator$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[55]=	_jc_java_security_AlgorithmParameterGenerator$instanceof_hash_bucket_55,
	[101]=	_jc_java_security_AlgorithmParameterGenerator$instanceof_hash_bucket_101
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_java_security_AlgorithmParameterGenerator$class_depends[] = {
	{ "gnu/java/security/Engine",	_JC_JLONG(0xf4ba095546954b36) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/ClassCastException",	_JC_JLONG(0xf02ab3ccb490a6d0) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/IllegalArgumentException",	_JC_JLONG(0x680cf34d05feb5a1) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/RuntimeException",	_JC_JLONG(0x4f5534a987354d1d) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/lang/reflect/InvocationTargetException",	_JC_JLONG(0xae4a2342b31a268d) },
	{ "java/security/AlgorithmParameterGeneratorSpi",	_JC_JLONG(0xd641d91cd6167b5d) },
	{ "java/security/AlgorithmParameters",	_JC_JLONG(0x814794c0d977019) },
	{ "java/security/GeneralSecurityException",	_JC_JLONG(0x692089051f4c8d0b) },
	{ "java/security/InvalidAlgorithmParameterException",	_JC_JLONG(0x327edce29f2562dd) },
	{ "java/security/NoSuchAlgorithmException",	_JC_JLONG(0x22e937c2536160b4) },
	{ "java/security/NoSuchProviderException",	_JC_JLONG(0x8dfbf242adab91e) },
	{ "java/security/Provider",	_JC_JLONG(0x81b073051aa30acc) },
	{ "java/security/SecureRandom",	_JC_JLONG(0x15c6a62b25a6e96d) },
	{ "java/security/Security",	_JC_JLONG(0x89bf77984bd9669e) },
	{ "java/security/spec/AlgorithmParameterSpec",	_JC_JLONG(0xef2e5e8af121478f) },
	{ "java/util/Vector",	_JC_JLONG(0xc53e1575b095109b) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_java_security_AlgorithmParameterGenerator$vtype _jc_java_security_AlgorithmParameterGenerator$type = {
    .type= {
	.name=			"java/security/AlgorithmParameterGenerator",
	.superclass=		&_jc_java_lang_Object$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		18,
		.hash=			_JC_JLONG(0x16c8b8582ba1efb7),
		.source_file=		"AlgorithmParameterGenerator.java",
		.instance_size=		sizeof(_jc_java_security_AlgorithmParameterGenerator$refs) + sizeof(_jc_java_security_AlgorithmParameterGenerator$object),
		.num_virtual_refs=	3,
		.num_fields=		sizeof(_jc_java_security_AlgorithmParameterGenerator$fields) / sizeof(*_jc_java_security_AlgorithmParameterGenerator$fields),
		.fields=		_jc_java_security_AlgorithmParameterGenerator$fields,
		.num_methods=		sizeof(_jc_java_security_AlgorithmParameterGenerator$methods) / sizeof(*_jc_java_security_AlgorithmParameterGenerator$methods),
		.methods=		_jc_java_security_AlgorithmParameterGenerator$methods,
		.instanceof_hash_table=	_jc_java_security_AlgorithmParameterGenerator$instanceof_hash_table,
		.class_fields=		&_jc_java_security_AlgorithmParameterGenerator$class_fields,
		.num_class_depends=		sizeof(_jc_java_security_AlgorithmParameterGenerator$class_depends) / sizeof(*_jc_java_security_AlgorithmParameterGenerator$class_depends),
		.class_depends=		_jc_java_security_AlgorithmParameterGenerator$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.java_security_AlgorithmParameterGenerator= {
	    .generateParameters$df0bc34eb57e2e27=
		&_jc_java_security_AlgorithmParameterGenerator$method$generateParameters$df0bc34eb57e2e27,
	    .getAlgorithm$19abbbc132b9063a=
		&_jc_java_security_AlgorithmParameterGenerator$method$getAlgorithm$19abbbc132b9063a,
	    .getProvider$e8f9c9fb14140d5a=
		&_jc_java_security_AlgorithmParameterGenerator$method$getProvider$e8f9c9fb14140d5a,
	    .init$bfae065b93f25bd8=
		&_jc_java_security_AlgorithmParameterGenerator$method$init$bfae065b93f25bd8,
	    .init$a6cee9d167433657=
		&_jc_java_security_AlgorithmParameterGenerator$method$init$a6cee9d167433657,
	    .init$ed37b79a75a6f3d3=
		&_jc_java_security_AlgorithmParameterGenerator$method$init$ed37b79a75a6f3d3,
	    .init$befc7893049358cc=
		&_jc_java_security_AlgorithmParameterGenerator$method$init$befc7893049358cc,
	},
    }
};

