// public abstract class java.security.KeyPairGenerator

// class file dependencies
// @dep_class f4ba095546954b36 gnu_java_security_Engine
// @dep_class 99a46305ebacacb5 java_io_PrintStream
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class 680cf34d05feb5a1 java_lang_IllegalArgumentException
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class 4f5534a987354d1d java_lang_RuntimeException
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 94d357637b968dda java_lang_StringBuffer
// @dep_class 53cc8e2333795f04 java_lang_System
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class c4b275d49bb21d98 java_lang_UnsupportedOperationException
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class ae4a2342b31a268d java_lang_reflect_InvocationTargetException
// @dep_class 724db494f51ba3f5 java_security_DummyKeyPairGenerator
// @dep_class 692089051f4c8d0b java_security_GeneralSecurityException
// @dep_class 327edce29f2562dd java_security_InvalidAlgorithmParameterException
// @dep_class 60b9183ffe1284b3 java_security_KeyPair
// @dep_class a5c9129f3f64f19c java_security_KeyPairGenerator
// @dep_class 688f793da35179d1 java_security_KeyPairGeneratorSpi
// @dep_class 22e937c2536160b4 java_security_NoSuchAlgorithmException
// @dep_class 8dfbf242adab91e java_security_NoSuchProviderException
// @dep_class 81b073051aa30acc java_security_Provider
// @dep_class 15c6a62b25a6e96d java_security_SecureRandom
// @dep_class 89bf77984bd9669e java_security_Security
// @dep_class ef2e5e8af121478f java_security_spec_AlgorithmParameterSpec
// @dep_class c53e1575b095109b java_util_Vector

// header file dependencies
// @dep_header gnu_java_security_Engine
// @dep_header java_io_PrintStream
// @dep_header java_lang_Class
// @dep_header java_lang_IllegalArgumentException
// @dep_header java_lang_String
// @dep_header java_lang_StringBuffer
// @dep_header java_lang_System
// @dep_header java_lang_UnsupportedOperationException
// @dep_header java_lang_VMThrowable
// @dep_header java_lang_reflect_InvocationTargetException
// @dep_header java_security_DummyKeyPairGenerator
// @dep_header java_security_InvalidAlgorithmParameterException
// @dep_header java_security_KeyPair
// @dep_header java_security_NoSuchAlgorithmException
// @dep_header java_security_NoSuchProviderException
// @dep_header java_security_Provider
// @dep_header java_security_SecureRandom
// @dep_header java_security_Security
// @dep_header java_security_spec_AlgorithmParameterSpec
// @dep_header java_util_Vector

#include "jc_defs.h"

#include "gnu/java/security/Engine.h"
#include "java/io/PrintStream.h"
#include "java/lang/Class.h"
#include "java/lang/IllegalArgumentException.h"
#include "java/lang/String.h"
#include "java/lang/StringBuffer.h"
#include "java/lang/System.h"
#include "java/lang/UnsupportedOperationException.h"
#include "java/lang/VMThrowable.h"
#include "java/lang/reflect/InvocationTargetException.h"
#include "java/security/DummyKeyPairGenerator.h"
#include "java/security/InvalidAlgorithmParameterException.h"
#include "java/security/KeyPair.h"
#include "java/security/NoSuchAlgorithmException.h"
#include "java/security/NoSuchProviderException.h"
#include "java/security/Provider.h"
#include "java/security/SecureRandom.h"
#include "java/security/Security.h"
#include "java/security/spec/AlgorithmParameterSpec.h"
#include "java/util/Vector.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// private static final java.lang.String KEY_PAIR_GENERATOR
static _jc_field _jc_java_security_KeyPairGenerator$field_info$KEY__5fPAIR__5fGENERATOR = {
	.name=		"KEY_PAIR_GENERATOR",
	.signature=	"Ljava/lang/String;",
	.class=		&_jc_java_security_KeyPairGenerator$type,
	.type=		&_jc_java_lang_String$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_java_security_KeyPairGenerator$fields_struct, KEY__5fPAIR__5fGENERATOR),
	.initial_value=	"KeyPairGenerator",
};

// java.security.Provider provider
static _jc_field _jc_java_security_KeyPairGenerator$field_info$provider = {
	.name=		"provider",
	.signature=	"Ljava/security/Provider;",
	.class=		&_jc_java_security_KeyPairGenerator$type,
	.type=		&_jc_java_security_Provider$type,
	.access_flags=	0,
	.offset=	_JC_OFFSETOF(_jc_java_security_KeyPairGenerator$object, refs[-1].java_security_KeyPairGenerator.provider),
};

// private java.lang.String algorithm
static _jc_field _jc_java_security_KeyPairGenerator$field_info$algorithm = {
	.name=		"algorithm",
	.signature=	"Ljava/lang/String;",
	.class=		&_jc_java_security_KeyPairGenerator$type,
	.type=		&_jc_java_lang_String$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_security_KeyPairGenerator$object, refs[-1].java_security_KeyPairGenerator.algorithm),
};

// Fields
static _jc_field *const _jc_java_security_KeyPairGenerator$fields[] = {
	&_jc_java_security_KeyPairGenerator$field_info$KEY__5fPAIR__5fGENERATOR,
	&_jc_java_security_KeyPairGenerator$field_info$algorithm,
	&_jc_java_security_KeyPairGenerator$field_info$provider
};

/************************************************************************
 *			      Static methods				*
 ************************************************************************/

//
// public static java.security.KeyPairGenerator getInstance(java.lang.String) throws java.security.NoSuchAlgorithmException
//

static _jc_linenum _jc_java_security_KeyPairGenerator$linenum_table$getInstance$16615c0ccd44bceb[];

static _jc_trap_info _jc_java_security_KeyPairGenerator$trap_table$getInstance$16615c0ccd44bceb[] = {
	_JC_TRAP(&_jc_java_security_NoSuchAlgorithmException$type, 1, 2),
};

static const unsigned char _jc_java_security_KeyPairGenerator$param_ptypes$getInstance$16615c0ccd44bceb[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_security_KeyPairGenerator$exceptions$getInstance$16615c0ccd44bceb[] = {
	&_jc_java_security_NoSuchAlgorithmException$type
};

static _jc_type *const _jc_java_security_KeyPairGenerator$param_types$getInstance$16615c0ccd44bceb[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_java_security_KeyPairGenerator$method_info$getInstance$16615c0ccd44bceb = {
	.name=			"getInstance",
	.signature=		"(Ljava/lang/String;)Ljava/security/KeyPairGenerator;",
	.class=			&_jc_java_security_KeyPairGenerator$type,
	.param_types=		&_jc_java_security_KeyPairGenerator$param_types$getInstance$16615c0ccd44bceb,
	.return_type=		&_jc_java_security_KeyPairGenerator$type,
	.param_ptypes=		&_jc_java_security_KeyPairGenerator$param_ptypes$getInstance$16615c0ccd44bceb,
	.signature_hash=	_JC_JLONG(0x16615c0ccd44bceb),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_java_security_KeyPairGenerator$method$getInstance$16615c0ccd44bceb,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_security_KeyPairGenerator$exceptions$getInstance$16615c0ccd44bceb,
	.u= { .exec= {
	  .trap_table_len=	1,
	  .trap_table=		_jc_java_security_KeyPairGenerator$trap_table$getInstance$16615c0ccd44bceb,
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_java_security_KeyPairGenerator$linenum_table$getInstance$16615c0ccd44bceb
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_KeyPairGenerator, getInstance$16615c0ccd44bceb);

_jc_java_security_KeyPairGenerator$object * _JC_JCNI_ATTR
_jc_java_security_KeyPairGenerator$method$getInstance$16615c0ccd44bceb(_jc_env *const env, _jc_java_lang_String$object *param0)
{
	jint volatile i0;
	jint volatile i1;
	jint i2;
	struct _jc_java_lang_String$object *volatile r0;
	struct _jc_java_security_Provider$object *volatile r2;
	struct _jc_java_security_KeyPairGenerator$object *volatile r3;
	struct _jc_java_security_NoSuchAlgorithmException$object *volatile r4;
	struct _jc_java_lang_VMThrowable$object *volatile r5;
	struct _jc_java_util_Vector$object *r6;
	_jc_object_array *volatile r7;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_java_security_KeyPairGenerator$method_info$getInstance$16615c0ccd44bceb, &&label1);

	r0 = param0;
	_JC_ACTIVE_USE(env, java_security_Security);
	_JC_LINE_NUMBER(170);				// 0
	r6 = _JC_STATIC_FIELD(env, java_security_Security, providers, 1);
	i2 = _JC_INVOKE_VIRTUAL(env, java_util_Vector, size$345df5220fc60ade, r6);
	r7 = _JC_NEW_REF_ARRAY(env, java_security_Provider, 1, i2);
	r6 = _JC_STATIC_FIELD(env, java_security_Security, providers, 1);
	_JC_INVOKE_VIRTUAL(env, java_util_Vector, copyInto$cd78d768b3ba4735, r6, r7);
	_JC_LINE_NUMBER(171);				// 1
	i0 = 0;
	goto label2;

label0:
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(175);				// 2
	r2 = _JC_REF_ELEMENT(env, r7, i0, 1, 1);
	r3 = _JC_INVOKE_STATIC(env, java_security_KeyPairGenerator, getInstance$9e25a470fff18ed2, 0, r0, r2);
	_JC_TRAP_REGION(catch, 2);
	_JC_CANCEL_TRAPS(env, catch);
	return r3;

label1:
	_JC_TRAP_REGION(catch, 2);
	r4 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(171);				// 3
	i0 = i0 + 1;

label2:
	_JC_TRAP_REGION(catch, 2);
	i1 = _JC_ARRAY_LENGTH(env, r7);
	if (i0 < i1) {
		_JC_PERIODIC_CHECK(env);
		goto label0;
	}
	_JC_LINE_NUMBER(183);				// 4
	r4 = _JC_NEW(env, java_security_NoSuchAlgorithmException);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r5 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r5;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r0;
	_JC_THROW(env, r4);
}

//
// public static java.security.KeyPairGenerator getInstance(java.lang.String, java.lang.String) throws java.security.NoSuchAlgorithmException, java.security.NoSuchProviderException
//

static _jc_linenum _jc_java_security_KeyPairGenerator$linenum_table$getInstance$082368ad7058f128[];

static const unsigned char _jc_java_security_KeyPairGenerator$param_ptypes$getInstance$082368ad7058f128[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_security_KeyPairGenerator$exceptions$getInstance$082368ad7058f128[] = {
	&_jc_java_security_NoSuchAlgorithmException$type,
	&_jc_java_security_NoSuchProviderException$type
};

static _jc_type *const _jc_java_security_KeyPairGenerator$param_types$getInstance$082368ad7058f128[] = {
	&_jc_java_lang_String$type,
	&_jc_java_lang_String$type
};

_jc_method _jc_java_security_KeyPairGenerator$method_info$getInstance$082368ad7058f128 = {
	.name=			"getInstance",
	.signature=		"(Ljava/lang/String;Ljava/lang/String;)Ljava/security/KeyPairGenerator;",
	.class=			&_jc_java_security_KeyPairGenerator$type,
	.param_types=		&_jc_java_security_KeyPairGenerator$param_types$getInstance$082368ad7058f128,
	.return_type=		&_jc_java_security_KeyPairGenerator$type,
	.param_ptypes=		&_jc_java_security_KeyPairGenerator$param_ptypes$getInstance$082368ad7058f128,
	.signature_hash=	_JC_JLONG(0x82368ad7058f128),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_java_security_KeyPairGenerator$method$getInstance$082368ad7058f128,
	.num_parameters=	2,
	.num_exceptions=	2,
	.exceptions=		&_jc_java_security_KeyPairGenerator$exceptions$getInstance$082368ad7058f128,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_java_security_KeyPairGenerator$linenum_table$getInstance$082368ad7058f128
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_KeyPairGenerator, getInstance$082368ad7058f128);

_jc_java_security_KeyPairGenerator$object * _JC_JCNI_ATTR
_jc_java_security_KeyPairGenerator$method$getInstance$082368ad7058f128(_jc_env *const env, _jc_java_lang_String$object *param0, _jc_java_lang_String$object *param1)
{
	struct _jc_java_lang_String$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_java_security_Provider$object *r2;
	struct _jc_java_security_NoSuchProviderException$object *r3;
	struct _jc_java_security_KeyPairGenerator$object *r4;
	struct _jc_java_lang_VMThrowable$object *r6;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = param0;
	r1 = param1;
	_JC_LINE_NUMBER(207);				// 0
	r2 = _JC_INVOKE_STATIC(env, java_security_Security, getProvider$581ee7d7bc9ae747, 0, r1);
	_JC_LINE_NUMBER(208);				// 1
	if (r2 != _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(209);				// 2
	r3 = _JC_NEW(env, java_security_NoSuchProviderException);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r6 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r6;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r1;
	_JC_THROW(env, r3);

label0:
	_JC_LINE_NUMBER(211);				// 3
	r4 = _JC_INVOKE_STATIC(env, java_security_KeyPairGenerator, getInstance$9e25a470fff18ed2, 1, r0, r2);
	return r4;
}

//
// public static java.security.KeyPairGenerator getInstance(java.lang.String, java.security.Provider) throws java.security.NoSuchAlgorithmException
//

static _jc_linenum _jc_java_security_KeyPairGenerator$linenum_table$getInstance$9e25a470fff18ed2[];

static _jc_trap_info _jc_java_security_KeyPairGenerator$trap_table$getInstance$9e25a470fff18ed2[] = {
	_JC_TRAP(&_jc_java_lang_reflect_InvocationTargetException$type, 1, 2),
};

static const unsigned char _jc_java_security_KeyPairGenerator$param_ptypes$getInstance$9e25a470fff18ed2[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_security_KeyPairGenerator$exceptions$getInstance$9e25a470fff18ed2[] = {
	&_jc_java_security_NoSuchAlgorithmException$type
};

static _jc_type *const _jc_java_security_KeyPairGenerator$param_types$getInstance$9e25a470fff18ed2[] = {
	&_jc_java_lang_String$type,
	&_jc_java_security_Provider$type
};

_jc_method _jc_java_security_KeyPairGenerator$method_info$getInstance$9e25a470fff18ed2 = {
	.name=			"getInstance",
	.signature=		"(Ljava/lang/String;Ljava/security/Provider;)Ljava/security/KeyPairGenerator;",
	.class=			&_jc_java_security_KeyPairGenerator$type,
	.param_types=		&_jc_java_security_KeyPairGenerator$param_types$getInstance$9e25a470fff18ed2,
	.return_type=		&_jc_java_security_KeyPairGenerator$type,
	.param_ptypes=		&_jc_java_security_KeyPairGenerator$param_ptypes$getInstance$9e25a470fff18ed2,
	.signature_hash=	_JC_JLONG(0x9e25a470fff18ed2),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_java_security_KeyPairGenerator$method$getInstance$9e25a470fff18ed2,
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_security_KeyPairGenerator$exceptions$getInstance$9e25a470fff18ed2,
	.u= { .exec= {
	  .trap_table_len=	1,
	  .trap_table=		_jc_java_security_KeyPairGenerator$trap_table$getInstance$9e25a470fff18ed2,
	  .u= {
	    .linenum= {
	      .len=	12,
	      .table=	_jc_java_security_KeyPairGenerator$linenum_table$getInstance$9e25a470fff18ed2
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_KeyPairGenerator, getInstance$9e25a470fff18ed2);

_jc_java_security_KeyPairGenerator$object * _JC_JCNI_ATTR
_jc_java_security_KeyPairGenerator$method$getInstance$9e25a470fff18ed2(_jc_env *const env, _jc_java_lang_String$object *param0, _jc_java_security_Provider$object *param1)
{
	struct _jc_java_lang_String$object *volatile r0;
	struct _jc_java_security_Provider$object *r1;
	_jc_object_array *r10;
	struct _jc_java_lang_Object$object *r11;
	struct _jc_java_lang_VMThrowable$object *r12;
	struct _jc_java_lang_VMThrowable$object *volatile r14;
	struct _jc_java_lang_reflect_InvocationTargetException$object *r2;
	struct _jc_java_lang_IllegalArgumentException$object *r3;
	struct _jc_java_security_NoSuchAlgorithmException$object *volatile r4;
	struct _jc_java_security_KeyPairGenerator$object *r5;
	struct _jc_java_security_DummyKeyPairGenerator$object *r6;
	struct _jc_java_security_KeyPairGeneratorSpi$object *r7;
	struct _jc_java_lang_String$object *r8;
	struct _jc_java_lang_String$object *r9;
	jboolean z0;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_java_security_KeyPairGenerator$method_info$getInstance$9e25a470fff18ed2, &&label1);

	r0 = param0;
	r1 = param1;
	_JC_LINE_NUMBER(236);				// 0
	if (r1 != _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(237);				// 1
	r3 = _JC_NEW(env, java_lang_IllegalArgumentException);
	r8 = _JC_STRING(env, "Illegal provider");
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r12 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r12;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r8;
	_JC_THROW(env, r3);

label0:
	_JC_TRAP_REGION(catch, 1);
	_JC_ACTIVE_USE(env, gnu_java_security_Engine);
	_JC_LINE_NUMBER(242);				// 2
	r9 = _JC_STRING(env, "KeyPairGenerator");
	r10 = _JC_STATIC_FIELD(env, gnu_java_security_Engine, NO__5fARGS, 1);
	r11 = _JC_INVOKE_STATIC(env, gnu_java_security_Engine, getInstance$ec89dfd35c234c64, 1, r9, r0, r1, r10);
	_JC_TRAP_REGION(catch, 2);
	goto label2;

label1:
	_JC_TRAP_REGION(catch, 2);
	r2 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(246);				// 3
	r4 = _JC_NEW(env, java_security_NoSuchAlgorithmException);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r14 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r14;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r0;
	_JC_THROW(env, r4);

label2:
	_JC_LINE_NUMBER(249);				// 4
	r5 = _JC_NULL;
	_JC_LINE_NUMBER(250);				// 5
	z0 = _JC_INSTANCEOF(env, r11, &_jc_java_security_KeyPairGeneratorSpi$type);
	if (z0 == 0)
		goto label3;
	_JC_LINE_NUMBER(252);				// 6
	r6 = _JC_NEW(env, java_security_DummyKeyPairGenerator);
	r7 = r11;
	_JC_REF_FIELD(env, r6, java_security_KeyPairGenerator, algorithm) = r0;
	_JC_REF_FIELD(env, r6, java_security_KeyPairGenerator, provider) = _JC_NULL;
	_JC_REF_FIELD(env, r6, java_security_DummyKeyPairGenerator, kpgSpi) = _JC_NULL;
	_JC_REF_FIELD(env, r6, java_security_DummyKeyPairGenerator, kpgSpi) = r7;
	r5 = r6;
	goto label4;

label3:
	_JC_LINE_NUMBER(254);				// 7
	z0 = _JC_INSTANCEOF(env, r11, &_jc_java_security_KeyPairGenerator$type);
	if (z0 == 0)
		goto label4;
	_JC_LINE_NUMBER(256);				// 8
	r5 = r11;
	_JC_LINE_NUMBER(257);				// 9
	_JC_REF_FIELD(env, r5, java_security_KeyPairGenerator, algorithm) = r0;

label4:
	_JC_LINE_NUMBER(259);				// 10
	_JC_REF_FIELD(env, r5, java_security_KeyPairGenerator, provider) = r1;
	_JC_LINE_NUMBER(260);				// 11
	_JC_CANCEL_TRAPS(env, catch);
	return r5;
}

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// protected void <init>(java.lang.String)
//

static _jc_linenum _jc_java_security_KeyPairGenerator$linenum_table$_init$c31b894660454d13[];

static const unsigned char _jc_java_security_KeyPairGenerator$param_ptypes$_init$c31b894660454d13[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_security_KeyPairGenerator$param_types$_init$c31b894660454d13[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_java_security_KeyPairGenerator$method_info$_init$c31b894660454d13 = {
	.name=			"<init>",
	.signature=		"(Ljava/lang/String;)V",
	.class=			&_jc_java_security_KeyPairGenerator$type,
	.param_types=		&_jc_java_security_KeyPairGenerator$param_types$_init$c31b894660454d13,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_security_KeyPairGenerator$param_ptypes$_init$c31b894660454d13,
	.signature_hash=	_JC_JLONG(0xc31b894660454d13),
	.access_flags=		_JC_ACC_PROTECTED,
	.function=		&_jc_java_security_KeyPairGenerator$method$_init$c31b894660454d13,
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_java_security_KeyPairGenerator$linenum_table$_init$c31b894660454d13
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_KeyPairGenerator, _init$c31b894660454d13);

void _JC_JCNI_ATTR
_jc_java_security_KeyPairGenerator$method$_init$c31b894660454d13(_jc_env *const env, _jc_java_security_KeyPairGenerator$object *this, _jc_java_lang_String$object *param0)
{
	struct _jc_java_security_KeyPairGenerator$object *r0;
	struct _jc_java_lang_String$object *r1;

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(136);				// 0
	_JC_REF_FIELD(env, r0, java_security_KeyPairGenerator, algorithm) = r1;
	_JC_LINE_NUMBER(137);				// 1
	_JC_REF_FIELD(env, r0, java_security_KeyPairGenerator, provider) = _JC_NULL;
	_JC_LINE_NUMBER(138);				// 2
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public final java.security.KeyPair genKeyPair()
//

static _jc_linenum _jc_java_security_KeyPairGenerator$linenum_table$genKeyPair$3042d7ced6492839[];

static _jc_trap_info _jc_java_security_KeyPairGenerator$trap_table$genKeyPair$3042d7ced6492839[] = {
	_JC_TRAP(&_jc_java_lang_Exception$type, 1, 2),
};

static const unsigned char _jc_java_security_KeyPairGenerator$param_ptypes$genKeyPair$3042d7ced6492839[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_java_security_KeyPairGenerator$method_info$genKeyPair$3042d7ced6492839 = {
	.name=			"genKeyPair",
	.signature=		"()Ljava/security/KeyPair;",
	.class=			&_jc_java_security_KeyPairGenerator$type,
	.return_type=		&_jc_java_security_KeyPair$type,
	.param_ptypes=		&_jc_java_security_KeyPairGenerator$param_ptypes$genKeyPair$3042d7ced6492839,
	.signature_hash=	_JC_JLONG(0x3042d7ced6492839),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_security_KeyPairGenerator$method$genKeyPair$3042d7ced6492839,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_KeyPairGenerator$vtable, java_security_KeyPairGenerator.genKeyPair$3042d7ced6492839) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .trap_table_len=	1,
	  .trap_table=		_jc_java_security_KeyPairGenerator$trap_table$genKeyPair$3042d7ced6492839,
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_java_security_KeyPairGenerator$linenum_table$genKeyPair$3042d7ced6492839
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_KeyPairGenerator, genKeyPair$3042d7ced6492839);

_jc_java_security_KeyPair$object * _JC_JCNI_ATTR
_jc_java_security_KeyPairGenerator$method$genKeyPair$3042d7ced6492839(_jc_env *const env, _jc_java_security_KeyPairGenerator$object *this)
{
	jint volatile i0;
	struct _jc_java_security_KeyPairGenerator$object *r0;
	struct _jc_java_lang_Exception$object *volatile r1;
	struct _jc_java_security_KeyPair$object *r2;
	struct _jc_java_io_PrintStream$object *volatile r3;
	struct _jc_java_lang_StringBuffer$object *volatile r4;
	struct _jc_java_lang_String$object *volatile r5;
	struct _jc_java_lang_StringBuffer$object *volatile r6;
	struct _jc_java_lang_String$object *volatile r7;
	struct _jc_java_lang_String$object *volatile r8;
	_jc_char_array *volatile r9;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_java_security_KeyPairGenerator$method_info$genKeyPair$3042d7ced6492839, &&label0);

	r0 = this;
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(374);				// 0
	r0 = _JC_INVOKE_STATIC(env, java_security_KeyPairGenerator, getInstance$082368ad7058f128, 1, _JC_STRING(env, "DSA"), _JC_STRING(env, "GNU"));
	r2 = _JC_INVOKE_VIRTUAL(env, java_security_KeyPairGenerator, generateKeyPair$e0a9411286c772d9, r0);
	_JC_TRAP_REGION(catch, 2);
	_JC_CANCEL_TRAPS(env, catch);
	return r2;

label0:
	_JC_TRAP_REGION(catch, 2);
	r1 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(378);				// 1
	r3 = _JC_STATIC_FIELD(env, java_lang_System, err, 0);
	r4 = _JC_NEW(env, java_lang_StringBuffer);
	r8 = _JC_STRING(env, "genKeyPair failed: ");
	i0 = _JC_PRIM_FIELD(env, r8, java_lang_String, count);
	_JC_PRIM_FIELD(env, r4, java_lang_StringBuffer, count) = i0;
	i0 = _JC_PRIM_FIELD(env, r4, java_lang_StringBuffer, count);
	i0 = i0 + 16;
	r9 = _JC_NEW_PRIM_ARRAY(env, char, 1, i0);
	_JC_REF_FIELD(env, r4, java_lang_StringBuffer, value) = r9;
	i0 = _JC_PRIM_FIELD(env, r4, java_lang_StringBuffer, count);
	r9 = _JC_REF_FIELD(env, r4, java_lang_StringBuffer, value);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, getChars$c684dea7317ff063, 0, r8, 0, i0, r9, 0);
	if (r1 != _JC_NULL)
		goto label1;
	r7 = _JC_STRING(env, "null");
	goto label2;

label1:
	r7 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, toString$7ea43b33b80a3070, r1);

label2:
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, r7);
	_JC_EXPLICIT_NULL_CHECK(env, r6);
	r5 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r5, r6);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, println$f7dbc2aa0f0a9d4f, r3, r5);
	_JC_LINE_NUMBER(379);				// 2
	_JC_INVOKE_VIRTUAL(env, java_lang_Throwable, printStackTrace$0c533e6284fdc6db, r1);
	_JC_LINE_NUMBER(380);				// 3
	_JC_CANCEL_TRAPS(env, catch);
	return _JC_NULL;
}

//
// public java.security.KeyPair generateKeyPair()
//

static _jc_linenum _jc_java_security_KeyPairGenerator$linenum_table$generateKeyPair$e0a9411286c772d9[];

static const unsigned char _jc_java_security_KeyPairGenerator$param_ptypes$generateKeyPair$e0a9411286c772d9[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_java_security_KeyPairGenerator$method_info$generateKeyPair$e0a9411286c772d9 = {
	.name=			"generateKeyPair",
	.signature=		"()Ljava/security/KeyPair;",
	.class=			&_jc_java_security_KeyPairGenerator$type,
	.return_type=		&_jc_java_security_KeyPair$type,
	.param_ptypes=		&_jc_java_security_KeyPairGenerator$param_ptypes$generateKeyPair$e0a9411286c772d9,
	.signature_hash=	_JC_JLONG(0xe0a9411286c772d9),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_KeyPairGenerator$method$generateKeyPair$e0a9411286c772d9,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_KeyPairGenerator$vtable, java_security_KeyPairGenerator.generateKeyPair$e0a9411286c772d9) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_KeyPairGenerator$linenum_table$generateKeyPair$e0a9411286c772d9
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_KeyPairGenerator, generateKeyPair$e0a9411286c772d9);

_jc_java_security_KeyPair$object * _JC_JCNI_ATTR
_jc_java_security_KeyPairGenerator$method$generateKeyPair$e0a9411286c772d9(_jc_env *const env, _jc_java_security_KeyPairGenerator$object *this)
{
	struct _jc_java_security_KeyPairGenerator$object *r0;
	struct _jc_java_security_KeyPair$object *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(399);				// 0
	r1 = _JC_INVOKE_NONVIRTUAL(env, java_security_KeyPairGenerator, genKeyPair$3042d7ced6492839, 0, r0);
	return r1;
}

//
// public java.lang.String getAlgorithm()
//

static _jc_linenum _jc_java_security_KeyPairGenerator$linenum_table$getAlgorithm$19abbbc132b9063a[];

static const unsigned char _jc_java_security_KeyPairGenerator$param_ptypes$getAlgorithm$19abbbc132b9063a[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_java_security_KeyPairGenerator$method_info$getAlgorithm$19abbbc132b9063a = {
	.name=			"getAlgorithm",
	.signature=		"()Ljava/lang/String;",
	.class=			&_jc_java_security_KeyPairGenerator$type,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_java_security_KeyPairGenerator$param_ptypes$getAlgorithm$19abbbc132b9063a,
	.signature_hash=	_JC_JLONG(0x19abbbc132b9063a),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_KeyPairGenerator$method$getAlgorithm$19abbbc132b9063a,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_KeyPairGenerator$vtable, java_security_KeyPairGenerator.getAlgorithm$19abbbc132b9063a) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_KeyPairGenerator$linenum_table$getAlgorithm$19abbbc132b9063a
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_KeyPairGenerator, getAlgorithm$19abbbc132b9063a);

_jc_java_lang_String$object * _JC_JCNI_ATTR
_jc_java_security_KeyPairGenerator$method$getAlgorithm$19abbbc132b9063a(_jc_env *const env, _jc_java_security_KeyPairGenerator$object *this)
{
	struct _jc_java_security_KeyPairGenerator$object *r0;
	struct _jc_java_lang_String$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(149);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_security_KeyPairGenerator, algorithm);
	return r1;
}

//
// public final java.security.Provider getProvider()
//

static _jc_linenum _jc_java_security_KeyPairGenerator$linenum_table$getProvider$e8f9c9fb14140d5a[];

static const unsigned char _jc_java_security_KeyPairGenerator$param_ptypes$getProvider$e8f9c9fb14140d5a[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_java_security_KeyPairGenerator$method_info$getProvider$e8f9c9fb14140d5a = {
	.name=			"getProvider",
	.signature=		"()Ljava/security/Provider;",
	.class=			&_jc_java_security_KeyPairGenerator$type,
	.return_type=		&_jc_java_security_Provider$type,
	.param_ptypes=		&_jc_java_security_KeyPairGenerator$param_ptypes$getProvider$e8f9c9fb14140d5a,
	.signature_hash=	_JC_JLONG(0xe8f9c9fb14140d5a),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_security_KeyPairGenerator$method$getProvider$e8f9c9fb14140d5a,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_KeyPairGenerator$vtable, java_security_KeyPairGenerator.getProvider$e8f9c9fb14140d5a) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_KeyPairGenerator$linenum_table$getProvider$e8f9c9fb14140d5a
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_KeyPairGenerator, getProvider$e8f9c9fb14140d5a);

_jc_java_security_Provider$object * _JC_JCNI_ATTR
_jc_java_security_KeyPairGenerator$method$getProvider$e8f9c9fb14140d5a(_jc_env *const env, _jc_java_security_KeyPairGenerator$object *this)
{
	struct _jc_java_security_KeyPairGenerator$object *r0;
	struct _jc_java_security_Provider$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(270);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_security_KeyPairGenerator, provider);
	return r1;
}

//
// public void initialize(int)
//

static _jc_linenum _jc_java_security_KeyPairGenerator$linenum_table$initialize$a45bc99b34bf7b2f[];

static const unsigned char _jc_java_security_KeyPairGenerator$param_ptypes$initialize$a45bc99b34bf7b2f[] = { 
_JC_TYPE_INT, _JC_TYPE_VOID };

static _jc_type *const _jc_java_security_KeyPairGenerator$param_types$initialize$a45bc99b34bf7b2f[] = {
	&_jc_int$prim$type
};

_jc_method _jc_java_security_KeyPairGenerator$method_info$initialize$a45bc99b34bf7b2f = {
	.name=			"initialize",
	.signature=		"(I)V",
	.class=			&_jc_java_security_KeyPairGenerator$type,
	.param_types=		&_jc_java_security_KeyPairGenerator$param_types$initialize$a45bc99b34bf7b2f,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_security_KeyPairGenerator$param_ptypes$initialize$a45bc99b34bf7b2f,
	.signature_hash=	_JC_JLONG(0xa45bc99b34bf7b2f),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_KeyPairGenerator$method$initialize$a45bc99b34bf7b2f,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_KeyPairGenerator$vtable, java_security_KeyPairGenerator.initialize$a45bc99b34bf7b2f) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_security_KeyPairGenerator$linenum_table$initialize$a45bc99b34bf7b2f
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_KeyPairGenerator, initialize$a45bc99b34bf7b2f);

void _JC_JCNI_ATTR
_jc_java_security_KeyPairGenerator$method$initialize$a45bc99b34bf7b2f(_jc_env *const env, _jc_java_security_KeyPairGenerator$object *this, jint param0)
{
	jint i0;
	struct _jc_java_security_KeyPairGenerator$object *r0;
	struct _jc_java_security_SecureRandom$object *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	i0 = param0;
	_JC_LINE_NUMBER(287);				// 0
	r1 = _JC_NEW(env, java_security_SecureRandom);
	_JC_INVOKE_NONVIRTUAL(env, java_security_SecureRandom, _init$52f4ad9f2989aeee, 0, r1);
	_JC_INVOKE_VIRTUAL(env, java_security_KeyPairGenerator, initialize$8377579c986315b7, r0, i0, r1);
	_JC_LINE_NUMBER(288);				// 1
	return;
}

//
// public void initialize(int, java.security.SecureRandom)
//

static _jc_linenum _jc_java_security_KeyPairGenerator$linenum_table$initialize$8377579c986315b7[];

static const unsigned char _jc_java_security_KeyPairGenerator$param_ptypes$initialize$8377579c986315b7[] = { 
_JC_TYPE_INT, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_security_KeyPairGenerator$param_types$initialize$8377579c986315b7[] = {
	&_jc_int$prim$type,
	&_jc_java_security_SecureRandom$type
};

_jc_method _jc_java_security_KeyPairGenerator$method_info$initialize$8377579c986315b7 = {
	.name=			"initialize",
	.signature=		"(ILjava/security/SecureRandom;)V",
	.class=			&_jc_java_security_KeyPairGenerator$type,
	.param_types=		&_jc_java_security_KeyPairGenerator$param_types$initialize$8377579c986315b7,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_security_KeyPairGenerator$param_ptypes$initialize$8377579c986315b7,
	.signature_hash=	_JC_JLONG(0x8377579c986315b7),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_KeyPairGenerator$method$initialize$8377579c986315b7,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_KeyPairGenerator$vtable, java_security_KeyPairGenerator.initialize$8377579c986315b7) / sizeof(void *),
	.num_parameters=	2,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_security_KeyPairGenerator$linenum_table$initialize$8377579c986315b7
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_KeyPairGenerator, initialize$8377579c986315b7);

void _JC_JCNI_ATTR
_jc_java_security_KeyPairGenerator$method$initialize$8377579c986315b7(_jc_env *const env, _jc_java_security_KeyPairGenerator$object *this, jint param0, _jc_java_security_SecureRandom$object *param1)
{
	jint i0;
	struct _jc_java_security_KeyPairGenerator$object *r0;
	struct _jc_java_security_SecureRandom$object *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	i0 = param0;
	r1 = param1;
	_JC_LINE_NUMBER(303);				// 0
	_JC_INVOKE_VIRTUAL(env, java_security_KeyPairGenerator, initialize$8377579c986315b7, r0, i0, r1);
	_JC_LINE_NUMBER(304);				// 1
	return;
}

//
// public void initialize(java.security.spec.AlgorithmParameterSpec) throws java.security.InvalidAlgorithmParameterException
//

static _jc_linenum _jc_java_security_KeyPairGenerator$linenum_table$initialize$bc885aeff7e16e0a[];

static const unsigned char _jc_java_security_KeyPairGenerator$param_ptypes$initialize$bc885aeff7e16e0a[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_security_KeyPairGenerator$exceptions$initialize$bc885aeff7e16e0a[] = {
	&_jc_java_security_InvalidAlgorithmParameterException$type
};

static _jc_type *const _jc_java_security_KeyPairGenerator$param_types$initialize$bc885aeff7e16e0a[] = {
	&_jc_java_security_spec_AlgorithmParameterSpec$type
};

_jc_method _jc_java_security_KeyPairGenerator$method_info$initialize$bc885aeff7e16e0a = {
	.name=			"initialize",
	.signature=		"(Ljava/security/spec/AlgorithmParameterSpec;)V",
	.class=			&_jc_java_security_KeyPairGenerator$type,
	.param_types=		&_jc_java_security_KeyPairGenerator$param_types$initialize$bc885aeff7e16e0a,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_security_KeyPairGenerator$param_ptypes$initialize$bc885aeff7e16e0a,
	.signature_hash=	_JC_JLONG(0xbc885aeff7e16e0a),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_KeyPairGenerator$method$initialize$bc885aeff7e16e0a,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_KeyPairGenerator$vtable, java_security_KeyPairGenerator.initialize$bc885aeff7e16e0a) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_security_KeyPairGenerator$exceptions$initialize$bc885aeff7e16e0a,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_security_KeyPairGenerator$linenum_table$initialize$bc885aeff7e16e0a
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_KeyPairGenerator, initialize$bc885aeff7e16e0a);

void _JC_JCNI_ATTR
_jc_java_security_KeyPairGenerator$method$initialize$bc885aeff7e16e0a(_jc_env *const env, _jc_java_security_KeyPairGenerator$object *this, _jc_object *param0)
{
	struct _jc_java_security_KeyPairGenerator$object *r0;
	struct _jc_object *r1;
	struct _jc_java_security_SecureRandom$object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(330);				// 0
	r2 = _JC_NEW(env, java_security_SecureRandom);
	_JC_INVOKE_NONVIRTUAL(env, java_security_SecureRandom, _init$52f4ad9f2989aeee, 0, r2);
	_JC_INVOKE_VIRTUAL(env, java_security_KeyPairGenerator, initialize$a73c0ba67824ad04, r0, r1, r2);
	_JC_LINE_NUMBER(331);				// 1
	return;
}

//
// public void initialize(java.security.spec.AlgorithmParameterSpec, java.security.SecureRandom) throws java.security.InvalidAlgorithmParameterException
//

static const unsigned char _jc_java_security_KeyPairGenerator$param_ptypes$initialize$a73c0ba67824ad04[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_security_KeyPairGenerator$exceptions$initialize$a73c0ba67824ad04[] = {
	&_jc_java_security_InvalidAlgorithmParameterException$type
};

static _jc_type *const _jc_java_security_KeyPairGenerator$param_types$initialize$a73c0ba67824ad04[] = {
	&_jc_java_security_spec_AlgorithmParameterSpec$type,
	&_jc_java_security_SecureRandom$type
};

_jc_method _jc_java_security_KeyPairGenerator$method_info$initialize$a73c0ba67824ad04 = {
	.name=			"initialize",
	.signature=		"(Ljava/security/spec/AlgorithmParameterSpec;Ljava/security/SecureRandom;)V",
	.class=			&_jc_java_security_KeyPairGenerator$type,
	.param_types=		&_jc_java_security_KeyPairGenerator$param_types$initialize$a73c0ba67824ad04,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_security_KeyPairGenerator$param_ptypes$initialize$a73c0ba67824ad04,
	.signature_hash=	_JC_JLONG(0xa73c0ba67824ad04),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_KeyPairGenerator$method$initialize$a73c0ba67824ad04,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_KeyPairGenerator$vtable, java_security_KeyPairGenerator.initialize$a73c0ba67824ad04) / sizeof(void *),
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_security_KeyPairGenerator$exceptions$initialize$a73c0ba67824ad04,
};

void _JC_JCNI_ATTR
_jc_java_security_KeyPairGenerator$method$initialize$a73c0ba67824ad04(_jc_env *const env, _jc_java_security_KeyPairGenerator$object *this, _jc_object *param0, _jc_java_security_SecureRandom$object *param1)
{
	struct _jc_java_security_KeyPairGenerator$object *r0;
	struct _jc_object *r1;
	struct _jc_java_security_SecureRandom$object *r2;
	struct _jc_java_lang_UnsupportedOperationException$object *r3;
	struct _jc_java_lang_String$object *r4;
	struct _jc_java_lang_VMThrowable$object *r6;

	r0 = this;
	r1 = param0;
	r2 = param1;
	r3 = _JC_NEW(env, java_lang_UnsupportedOperationException);
	r4 = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r6 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r6;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r4;
	_JC_THROW(env, r3);
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_java_security_KeyPairGenerator$methods[] = {
	&_jc_java_security_KeyPairGenerator$method_info$_init$c31b894660454d13,
	&_jc_java_security_KeyPairGenerator$method_info$genKeyPair$3042d7ced6492839,
	&_jc_java_security_KeyPairGenerator$method_info$generateKeyPair$e0a9411286c772d9,
	&_jc_java_security_KeyPairGenerator$method_info$getAlgorithm$19abbbc132b9063a,
	&_jc_java_security_KeyPairGenerator$method_info$getInstance$16615c0ccd44bceb,
	&_jc_java_security_KeyPairGenerator$method_info$getInstance$082368ad7058f128,
	&_jc_java_security_KeyPairGenerator$method_info$getInstance$9e25a470fff18ed2,
	&_jc_java_security_KeyPairGenerator$method_info$getProvider$e8f9c9fb14140d5a,
	&_jc_java_security_KeyPairGenerator$method_info$initialize$a45bc99b34bf7b2f,
	&_jc_java_security_KeyPairGenerator$method_info$initialize$8377579c986315b7,
	&_jc_java_security_KeyPairGenerator$method_info$initialize$bc885aeff7e16e0a,
	&_jc_java_security_KeyPairGenerator$method_info$initialize$a73c0ba67824ad04
};

/************************************************************************
 *			  Class fields structure			*
 ************************************************************************/

_jc_java_security_KeyPairGenerator$fields_struct _jc_java_security_KeyPairGenerator$class_fields = { };

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_java_security_KeyPairGenerator$instanceof_hash_bucket_28[] = {
	&_jc_java_security_KeyPairGenerator$type,
	_JC_NULL
};
static _jc_type *const _jc_java_security_KeyPairGenerator$instanceof_hash_bucket_81[] = {
	&_jc_java_security_KeyPairGeneratorSpi$type,
	_JC_NULL
};
static _jc_type *const _jc_java_security_KeyPairGenerator$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_java_security_KeyPairGenerator$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[28]=	_jc_java_security_KeyPairGenerator$instanceof_hash_bucket_28,
	[81]=	_jc_java_security_KeyPairGenerator$instanceof_hash_bucket_81,
	[101]=	_jc_java_security_KeyPairGenerator$instanceof_hash_bucket_101
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_java_security_KeyPairGenerator$class_depends[] = {
	{ "gnu/java/security/Engine",	_JC_JLONG(0xf4ba095546954b36) },
	{ "java/io/PrintStream",	_JC_JLONG(0x99a46305ebacacb5) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/IllegalArgumentException",	_JC_JLONG(0x680cf34d05feb5a1) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/RuntimeException",	_JC_JLONG(0x4f5534a987354d1d) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/StringBuffer",	_JC_JLONG(0x94d357637b968dda) },
	{ "java/lang/System",	_JC_JLONG(0x53cc8e2333795f04) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/UnsupportedOperationException",	_JC_JLONG(0xc4b275d49bb21d98) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/lang/reflect/InvocationTargetException",	_JC_JLONG(0xae4a2342b31a268d) },
	{ "java/security/DummyKeyPairGenerator",	_JC_JLONG(0x724db494f51ba3f5) },
	{ "java/security/GeneralSecurityException",	_JC_JLONG(0x692089051f4c8d0b) },
	{ "java/security/InvalidAlgorithmParameterException",	_JC_JLONG(0x327edce29f2562dd) },
	{ "java/security/KeyPair",	_JC_JLONG(0x60b9183ffe1284b3) },
	{ "java/security/KeyPairGeneratorSpi",	_JC_JLONG(0x688f793da35179d1) },
	{ "java/security/NoSuchAlgorithmException",	_JC_JLONG(0x22e937c2536160b4) },
	{ "java/security/NoSuchProviderException",	_JC_JLONG(0x8dfbf242adab91e) },
	{ "java/security/Provider",	_JC_JLONG(0x81b073051aa30acc) },
	{ "java/security/SecureRandom",	_JC_JLONG(0x15c6a62b25a6e96d) },
	{ "java/security/Security",	_JC_JLONG(0x89bf77984bd9669e) },
	{ "java/security/spec/AlgorithmParameterSpec",	_JC_JLONG(0xef2e5e8af121478f) },
	{ "java/util/Vector",	_JC_JLONG(0xc53e1575b095109b) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_java_security_KeyPairGenerator$vtype _jc_java_security_KeyPairGenerator$type = {
    .type= {
	.name=			"java/security/KeyPairGenerator",
	.superclass=		&_jc_java_security_KeyPairGeneratorSpi$type,
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		23,
		.hash=			_JC_JLONG(0xa5c9129f3f64f19c),
		.source_file=		"KeyPairGenerator.java",
		.instance_size=		sizeof(_jc_java_security_KeyPairGenerator$refs) + sizeof(_jc_java_security_KeyPairGenerator$object),
		.num_virtual_refs=	2,
		.num_fields=		sizeof(_jc_java_security_KeyPairGenerator$fields) / sizeof(*_jc_java_security_KeyPairGenerator$fields),
		.fields=		_jc_java_security_KeyPairGenerator$fields,
		.num_methods=		sizeof(_jc_java_security_KeyPairGenerator$methods) / sizeof(*_jc_java_security_KeyPairGenerator$methods),
		.methods=		_jc_java_security_KeyPairGenerator$methods,
		.instanceof_hash_table=	_jc_java_security_KeyPairGenerator$instanceof_hash_table,
		.class_fields=		&_jc_java_security_KeyPairGenerator$class_fields,
		.num_class_depends=		sizeof(_jc_java_security_KeyPairGenerator$class_depends) / sizeof(*_jc_java_security_KeyPairGenerator$class_depends),
		.class_depends=		_jc_java_security_KeyPairGenerator$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=			// overridden
		&_jc_java_security_KeyPairGeneratorSpi$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.java_security_KeyPairGeneratorSpi= {
	    .clone$b75f2713d6705f70=
		&_jc_java_security_KeyPairGeneratorSpi$method$clone$b75f2713d6705f70,
	    .generateKeyPair$e0a9411286c772d9=		// overridden
		&_jc_java_security_KeyPairGenerator$method$generateKeyPair$e0a9411286c772d9,
	    .initialize$8377579c986315b7=			// overridden
		&_jc_java_security_KeyPairGenerator$method$initialize$8377579c986315b7,
	    .initialize$a73c0ba67824ad04=			// overridden
		&_jc_java_security_KeyPairGenerator$method$initialize$a73c0ba67824ad04,
	},
	.java_security_KeyPairGenerator= {
	    .genKeyPair$3042d7ced6492839=
		&_jc_java_security_KeyPairGenerator$method$genKeyPair$3042d7ced6492839,
	    .generateKeyPair$e0a9411286c772d9=
		&_jc_java_security_KeyPairGenerator$method$generateKeyPair$e0a9411286c772d9,
	    .getAlgorithm$19abbbc132b9063a=
		&_jc_java_security_KeyPairGenerator$method$getAlgorithm$19abbbc132b9063a,
	    .getProvider$e8f9c9fb14140d5a=
		&_jc_java_security_KeyPairGenerator$method$getProvider$e8f9c9fb14140d5a,
	    .initialize$a45bc99b34bf7b2f=
		&_jc_java_security_KeyPairGenerator$method$initialize$a45bc99b34bf7b2f,
	    .initialize$8377579c986315b7=
		&_jc_java_security_KeyPairGenerator$method$initialize$8377579c986315b7,
	    .initialize$bc885aeff7e16e0a=
		&_jc_java_security_KeyPairGenerator$method$initialize$bc885aeff7e16e0a,
	    .initialize$a73c0ba67824ad04=
		&_jc_java_security_KeyPairGenerator$method$initialize$a73c0ba67824ad04,
	},
    }
};

