// public class java.security.ProtectionDomain

// class file dependencies
// @dep_class 1160ded3f016b6b0 gnu_classpath_SystemProperties
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class b0527a7101321261 java_lang_ClassLoader
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class 680cf34d05feb5a1 java_lang_IllegalArgumentException
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class 4f5534a987354d1d java_lang_RuntimeException
// @dep_class d38282f3d5f80887 java_lang_SecurityManager
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 94d357637b968dda java_lang_StringBuffer
// @dep_class 53cc8e2333795f04 java_lang_System
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class 238a2c0aafd74314 java_lang_VMClass
// @dep_class 312e45ed214d432f java_lang_VMObject
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class ae48ca2e0104c4f5 java_security_CodeSource
// @dep_class 2377c76e79058a72 java_security_Permission
// @dep_class c66c17eff6c1d1e6 java_security_PermissionCollection
// @dep_class 22e7d19b890f754a java_security_Policy
// @dep_class 1ed0accfc254a715 java_security_Principal
// @dep_class 7db4f21fb4389f59 java_security_ProtectionDomain
// @dep_class 884c3edb343dfb63 java_util_Properties

// header file dependencies
// @dep_header gnu_classpath_SystemProperties
// @dep_header java_lang_Class
// @dep_header java_lang_ClassLoader
// @dep_header java_lang_IllegalArgumentException
// @dep_header java_lang_SecurityManager
// @dep_header java_lang_String
// @dep_header java_lang_StringBuffer
// @dep_header java_lang_System
// @dep_header java_lang_VMClass
// @dep_header java_lang_VMObject
// @dep_header java_lang_VMThrowable
// @dep_header java_security_CodeSource
// @dep_header java_security_Permission
// @dep_header java_security_PermissionCollection
// @dep_header java_security_Policy
// @dep_header java_security_Principal
// @dep_header java_security_ProtectionDomain
// @dep_header java_util_Properties

#include "jc_defs.h"

#include "gnu/classpath/SystemProperties.h"
#include "java/lang/Class.h"
#include "java/lang/ClassLoader.h"
#include "java/lang/IllegalArgumentException.h"
#include "java/lang/SecurityManager.h"
#include "java/lang/String.h"
#include "java/lang/StringBuffer.h"
#include "java/lang/System.h"
#include "java/lang/VMClass.h"
#include "java/lang/VMObject.h"
#include "java/lang/VMThrowable.h"
#include "java/security/CodeSource.h"
#include "java/security/Permission.h"
#include "java/security/PermissionCollection.h"
#include "java/security/Policy.h"
#include "java/security/Principal.h"
#include "java/security/ProtectionDomain.h"
#include "java/util/Properties.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// private java.security.CodeSource code_source
static _jc_field _jc_java_security_ProtectionDomain$field_info$code__5fsource = {
	.name=		"code_source",
	.signature=	"Ljava/security/CodeSource;",
	.class=		&_jc_java_security_ProtectionDomain$type,
	.type=		&_jc_java_security_CodeSource$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_security_ProtectionDomain$object, refs[-1].java_security_ProtectionDomain.code__5fsource),
};

// private java.security.PermissionCollection perms
static _jc_field _jc_java_security_ProtectionDomain$field_info$perms = {
	.name=		"perms",
	.signature=	"Ljava/security/PermissionCollection;",
	.class=		&_jc_java_security_ProtectionDomain$type,
	.type=		&_jc_java_security_PermissionCollection$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_security_ProtectionDomain$object, refs[-1].java_security_ProtectionDomain.perms),
};

// private java.lang.ClassLoader classloader
static _jc_field _jc_java_security_ProtectionDomain$field_info$classloader = {
	.name=		"classloader",
	.signature=	"Ljava/lang/ClassLoader;",
	.class=		&_jc_java_security_ProtectionDomain$type,
	.type=		&_jc_java_lang_ClassLoader$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_security_ProtectionDomain$object, refs[-1].java_security_ProtectionDomain.classloader),
};

// private java.security.Principal[] principals
static _jc_field _jc_java_security_ProtectionDomain$field_info$principals = {
	.name=		"principals",
	.signature=	"[Ljava/security/Principal;",
	.class=		&_jc_java_security_ProtectionDomain$type,
	.type=		&_jc_java_security_Principal$array$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_security_ProtectionDomain$object, refs[-1].java_security_ProtectionDomain.principals),
};

// private boolean staticBinding
static _jc_field _jc_java_security_ProtectionDomain$field_info$staticBinding = {
	.name=		"staticBinding",
	.signature=	"Z",
	.class=		&_jc_java_security_ProtectionDomain$type,
	.type=		&_jc_boolean$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_security_ProtectionDomain$object, nonrefs.java_security_ProtectionDomain.staticBinding),
};

// Fields
static _jc_field *const _jc_java_security_ProtectionDomain$fields[] = {
	&_jc_java_security_ProtectionDomain$field_info$classloader,
	&_jc_java_security_ProtectionDomain$field_info$code__5fsource,
	&_jc_java_security_ProtectionDomain$field_info$perms,
	&_jc_java_security_ProtectionDomain$field_info$principals,
	&_jc_java_security_ProtectionDomain$field_info$staticBinding
};

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// public void <init>(java.security.CodeSource, java.security.PermissionCollection)
//

static _jc_linenum _jc_java_security_ProtectionDomain$linenum_table$_init$b12b635144056f6c[];

static const unsigned char _jc_java_security_ProtectionDomain$param_ptypes$_init$b12b635144056f6c[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_security_ProtectionDomain$param_types$_init$b12b635144056f6c[] = {
	&_jc_java_security_CodeSource$type,
	&_jc_java_security_PermissionCollection$type
};

_jc_method _jc_java_security_ProtectionDomain$method_info$_init$b12b635144056f6c = {
	.name=			"<init>",
	.signature=		"(Ljava/security/CodeSource;Ljava/security/PermissionCollection;)V",
	.class=			&_jc_java_security_ProtectionDomain$type,
	.param_types=		&_jc_java_security_ProtectionDomain$param_types$_init$b12b635144056f6c,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_security_ProtectionDomain$param_ptypes$_init$b12b635144056f6c,
	.signature_hash=	_JC_JLONG(0xb12b635144056f6c),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_ProtectionDomain$method$_init$b12b635144056f6c,
	.num_parameters=	2,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_security_ProtectionDomain$linenum_table$_init$b12b635144056f6c
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_ProtectionDomain, _init$b12b635144056f6c);

void _JC_JCNI_ATTR
_jc_java_security_ProtectionDomain$method$_init$b12b635144056f6c(_jc_env *const env, _jc_java_security_ProtectionDomain$object *this, _jc_java_security_CodeSource$object *param0, _jc_java_security_PermissionCollection$object *param1)
{
	struct _jc_java_security_ProtectionDomain$object *r0;
	struct _jc_java_security_CodeSource$object *r1;
	struct _jc_java_security_PermissionCollection$object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_LINE_NUMBER(86);				// 0
	_JC_INVOKE_NONVIRTUAL(env, java_security_ProtectionDomain, _init$544e1ecf4bed1a81, 0, r0, r1, r2, _JC_NULL, _JC_NULL, 1);
	_JC_LINE_NUMBER(87);				// 1
	return;
}

//
// public void <init>(java.security.CodeSource, java.security.PermissionCollection, java.lang.ClassLoader, java.security.Principal[])
//

static _jc_linenum _jc_java_security_ProtectionDomain$linenum_table$_init$df4c86d874bb5681[];

static const unsigned char _jc_java_security_ProtectionDomain$param_ptypes$_init$df4c86d874bb5681[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_security_ProtectionDomain$param_types$_init$df4c86d874bb5681[] = {
	&_jc_java_security_CodeSource$type,
	&_jc_java_security_PermissionCollection$type,
	&_jc_java_lang_ClassLoader$type,
	&_jc_java_security_Principal$array$type
};

_jc_method _jc_java_security_ProtectionDomain$method_info$_init$df4c86d874bb5681 = {
	.name=			"<init>",
	.signature=		"(Ljava/security/CodeSource;Ljava/security/PermissionCollection;Ljava/lang/ClassLoader;[Ljava/security/Principal;)V",
	.class=			&_jc_java_security_ProtectionDomain$type,
	.param_types=		&_jc_java_security_ProtectionDomain$param_types$_init$df4c86d874bb5681,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_security_ProtectionDomain$param_ptypes$_init$df4c86d874bb5681,
	.signature_hash=	_JC_JLONG(0xdf4c86d874bb5681),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_ProtectionDomain$method$_init$df4c86d874bb5681,
	.num_parameters=	4,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_security_ProtectionDomain$linenum_table$_init$df4c86d874bb5681
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_ProtectionDomain, _init$df4c86d874bb5681);

void _JC_JCNI_ATTR
_jc_java_security_ProtectionDomain$method$_init$df4c86d874bb5681(_jc_env *const env, _jc_java_security_ProtectionDomain$object *this, _jc_java_security_CodeSource$object *param0, _jc_java_security_PermissionCollection$object *param1, _jc_java_lang_ClassLoader$object *param2, _jc_object_array *param3)
{
	struct _jc_java_security_ProtectionDomain$object *r0;
	struct _jc_java_security_CodeSource$object *r1;
	struct _jc_java_security_PermissionCollection$object *r2;
	struct _jc_java_lang_ClassLoader$object *r3;
	_jc_object_array *r4;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	r3 = param2;
	r4 = param3;
	_JC_LINE_NUMBER(116);				// 0
	_JC_INVOKE_NONVIRTUAL(env, java_security_ProtectionDomain, _init$544e1ecf4bed1a81, 0, r0, r1, r2, r3, r4, 0);
	_JC_LINE_NUMBER(117);				// 1
	return;
}

//
// private void <init>(java.security.CodeSource, java.security.PermissionCollection, java.lang.ClassLoader, java.security.Principal[], boolean)
//

static _jc_linenum _jc_java_security_ProtectionDomain$linenum_table$_init$544e1ecf4bed1a81[];

static const unsigned char _jc_java_security_ProtectionDomain$param_ptypes$_init$544e1ecf4bed1a81[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN, _JC_TYPE_VOID };

static _jc_type *const _jc_java_security_ProtectionDomain$param_types$_init$544e1ecf4bed1a81[] = {
	&_jc_java_security_CodeSource$type,
	&_jc_java_security_PermissionCollection$type,
	&_jc_java_lang_ClassLoader$type,
	&_jc_java_security_Principal$array$type,
	&_jc_boolean$prim$type
};

_jc_method _jc_java_security_ProtectionDomain$method_info$_init$544e1ecf4bed1a81 = {
	.name=			"<init>",
	.signature=		"(Ljava/security/CodeSource;Ljava/security/PermissionCollection;Ljava/lang/ClassLoader;[Ljava/security/Principal;Z)V",
	.class=			&_jc_java_security_ProtectionDomain$type,
	.param_types=		&_jc_java_security_ProtectionDomain$param_types$_init$544e1ecf4bed1a81,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_security_ProtectionDomain$param_ptypes$_init$544e1ecf4bed1a81,
	.signature_hash=	_JC_JLONG(0x544e1ecf4bed1a81),
	.access_flags=		_JC_ACC_PRIVATE,
	.function=		&_jc_java_security_ProtectionDomain$method$_init$544e1ecf4bed1a81,
	.num_parameters=	5,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	8,
	      .table=	_jc_java_security_ProtectionDomain$linenum_table$_init$544e1ecf4bed1a81
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_ProtectionDomain, _init$544e1ecf4bed1a81);

void _JC_JCNI_ATTR
_jc_java_security_ProtectionDomain$method$_init$544e1ecf4bed1a81(_jc_env *const env, _jc_java_security_ProtectionDomain$object *this, _jc_java_security_CodeSource$object *param0, _jc_java_security_PermissionCollection$object *param1, _jc_java_lang_ClassLoader$object *param2, _jc_object_array *param3, jboolean param4)
{
	struct _jc_java_security_ProtectionDomain$object *r0;
	struct _jc_java_security_CodeSource$object *r1;
	struct _jc_java_security_PermissionCollection$object *r2;
	struct _jc_java_lang_ClassLoader$object *r3;
	_jc_object_array *r4;
	struct _jc_java_lang_Object$object *r5;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	r3 = param2;
	r4 = param3;
	z0 = param4;
	_JC_LINE_NUMBER(126);				// 0
	_JC_REF_FIELD(env, r0, java_security_ProtectionDomain, code__5fsource) = r1;
	_JC_LINE_NUMBER(127);				// 1
	if (r2 == _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(129);				// 2
	_JC_REF_FIELD(env, r0, java_security_ProtectionDomain, perms) = r2;
	_JC_LINE_NUMBER(130);				// 3
	r2 = _JC_REF_FIELD(env, r0, java_security_ProtectionDomain, perms);
	_JC_INVOKE_VIRTUAL(env, java_security_PermissionCollection, setReadOnly$b830e19924e04851, r2);

label0:
	_JC_LINE_NUMBER(133);				// 4
	_JC_REF_FIELD(env, r0, java_security_ProtectionDomain, classloader) = r3;
	_JC_LINE_NUMBER(134);				// 5
	if (r4 == _JC_NULL)
		goto label1;
	r5 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, clone$b75f2713d6705f70, r4);
	r4 = _JC_CAST(env, &_jc_java_security_Principal$array$type, r5);
	goto label2;

label1:
	r4 = _JC_NEW_REF_ARRAY(env, java_security_Principal, 1, 0);

label2:
	_JC_REF_FIELD(env, r0, java_security_ProtectionDomain, principals) = r4;
	_JC_LINE_NUMBER(136);				// 6
	_JC_PRIM_FIELD(env, r0, java_security_ProtectionDomain, staticBinding) = z0;
	_JC_LINE_NUMBER(137);				// 7
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public final java.lang.ClassLoader getClassLoader()
//

static _jc_linenum _jc_java_security_ProtectionDomain$linenum_table$getClassLoader$2078dc747ca30d6e[];

static const unsigned char _jc_java_security_ProtectionDomain$param_ptypes$getClassLoader$2078dc747ca30d6e[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_java_security_ProtectionDomain$method_info$getClassLoader$2078dc747ca30d6e = {
	.name=			"getClassLoader",
	.signature=		"()Ljava/lang/ClassLoader;",
	.class=			&_jc_java_security_ProtectionDomain$type,
	.return_type=		&_jc_java_lang_ClassLoader$type,
	.param_ptypes=		&_jc_java_security_ProtectionDomain$param_ptypes$getClassLoader$2078dc747ca30d6e,
	.signature_hash=	_JC_JLONG(0x2078dc747ca30d6e),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_security_ProtectionDomain$method$getClassLoader$2078dc747ca30d6e,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_ProtectionDomain$vtable, java_security_ProtectionDomain.getClassLoader$2078dc747ca30d6e) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_ProtectionDomain$linenum_table$getClassLoader$2078dc747ca30d6e
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_ProtectionDomain, getClassLoader$2078dc747ca30d6e);

_jc_java_lang_ClassLoader$object * _JC_JCNI_ATTR
_jc_java_security_ProtectionDomain$method$getClassLoader$2078dc747ca30d6e(_jc_env *const env, _jc_java_security_ProtectionDomain$object *this)
{
	struct _jc_java_security_ProtectionDomain$object *r0;
	struct _jc_java_lang_ClassLoader$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(159);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_security_ProtectionDomain, classloader);
	return r1;
}

//
// public final java.security.CodeSource getCodeSource()
//

static _jc_linenum _jc_java_security_ProtectionDomain$linenum_table$getCodeSource$c5e8828ac4e55d4f[];

static const unsigned char _jc_java_security_ProtectionDomain$param_ptypes$getCodeSource$c5e8828ac4e55d4f[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_java_security_ProtectionDomain$method_info$getCodeSource$c5e8828ac4e55d4f = {
	.name=			"getCodeSource",
	.signature=		"()Ljava/security/CodeSource;",
	.class=			&_jc_java_security_ProtectionDomain$type,
	.return_type=		&_jc_java_security_CodeSource$type,
	.param_ptypes=		&_jc_java_security_ProtectionDomain$param_ptypes$getCodeSource$c5e8828ac4e55d4f,
	.signature_hash=	_JC_JLONG(0xc5e8828ac4e55d4f),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_security_ProtectionDomain$method$getCodeSource$c5e8828ac4e55d4f,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_ProtectionDomain$vtable, java_security_ProtectionDomain.getCodeSource$c5e8828ac4e55d4f) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_ProtectionDomain$linenum_table$getCodeSource$c5e8828ac4e55d4f
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_ProtectionDomain, getCodeSource$c5e8828ac4e55d4f);

_jc_java_security_CodeSource$object * _JC_JCNI_ATTR
_jc_java_security_ProtectionDomain$method$getCodeSource$c5e8828ac4e55d4f(_jc_env *const env, _jc_java_security_ProtectionDomain$object *this)
{
	struct _jc_java_security_ProtectionDomain$object *r0;
	struct _jc_java_security_CodeSource$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(147);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_security_ProtectionDomain, code__5fsource);
	return r1;
}

//
// public final java.security.PermissionCollection getPermissions()
//

static _jc_linenum _jc_java_security_ProtectionDomain$linenum_table$getPermissions$9ba9c969cc070a80[];

static const unsigned char _jc_java_security_ProtectionDomain$param_ptypes$getPermissions$9ba9c969cc070a80[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_java_security_ProtectionDomain$method_info$getPermissions$9ba9c969cc070a80 = {
	.name=			"getPermissions",
	.signature=		"()Ljava/security/PermissionCollection;",
	.class=			&_jc_java_security_ProtectionDomain$type,
	.return_type=		&_jc_java_security_PermissionCollection$type,
	.param_ptypes=		&_jc_java_security_ProtectionDomain$param_ptypes$getPermissions$9ba9c969cc070a80,
	.signature_hash=	_JC_JLONG(0x9ba9c969cc070a80),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_security_ProtectionDomain$method$getPermissions$9ba9c969cc070a80,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_ProtectionDomain$vtable, java_security_ProtectionDomain.getPermissions$9ba9c969cc070a80) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_ProtectionDomain$linenum_table$getPermissions$9ba9c969cc070a80
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_ProtectionDomain, getPermissions$9ba9c969cc070a80);

_jc_java_security_PermissionCollection$object * _JC_JCNI_ATTR
_jc_java_security_ProtectionDomain$method$getPermissions$9ba9c969cc070a80(_jc_env *const env, _jc_java_security_ProtectionDomain$object *this)
{
	struct _jc_java_security_ProtectionDomain$object *r0;
	struct _jc_java_security_PermissionCollection$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(184);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_security_ProtectionDomain, perms);
	return r1;
}

//
// public final java.security.Principal[] getPrincipals()
//

static _jc_linenum _jc_java_security_ProtectionDomain$linenum_table$getPrincipals$56d665eaf6bc40b3[];

static const unsigned char _jc_java_security_ProtectionDomain$param_ptypes$getPrincipals$56d665eaf6bc40b3[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_java_security_ProtectionDomain$method_info$getPrincipals$56d665eaf6bc40b3 = {
	.name=			"getPrincipals",
	.signature=		"()[Ljava/security/Principal;",
	.class=			&_jc_java_security_ProtectionDomain$type,
	.return_type=		&_jc_java_security_Principal$array$type,
	.param_ptypes=		&_jc_java_security_ProtectionDomain$param_ptypes$getPrincipals$56d665eaf6bc40b3,
	.signature_hash=	_JC_JLONG(0x56d665eaf6bc40b3),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_security_ProtectionDomain$method$getPrincipals$56d665eaf6bc40b3,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_ProtectionDomain$vtable, java_security_ProtectionDomain.getPrincipals$56d665eaf6bc40b3) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_ProtectionDomain$linenum_table$getPrincipals$56d665eaf6bc40b3
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_ProtectionDomain, getPrincipals$56d665eaf6bc40b3);

_jc_object_array * _JC_JCNI_ATTR
_jc_java_security_ProtectionDomain$method$getPrincipals$56d665eaf6bc40b3(_jc_env *const env, _jc_java_security_ProtectionDomain$object *this)
{
	struct _jc_java_security_ProtectionDomain$object *r0;
	_jc_object_array *r1;
	struct _jc_java_lang_Object$object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(171);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_security_ProtectionDomain, principals);
	r2 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, clone$b75f2713d6705f70, r1);
	r1 = _JC_CAST(env, &_jc_java_security_Principal$array$type, r2);
	return r1;
}

//
// public boolean implies(java.security.Permission)
//

static _jc_linenum _jc_java_security_ProtectionDomain$linenum_table$implies$cbacf9d54b2bb917[];

static const unsigned char _jc_java_security_ProtectionDomain$param_ptypes$implies$cbacf9d54b2bb917[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_java_security_ProtectionDomain$param_types$implies$cbacf9d54b2bb917[] = {
	&_jc_java_security_Permission$type
};

_jc_method _jc_java_security_ProtectionDomain$method_info$implies$cbacf9d54b2bb917 = {
	.name=			"implies",
	.signature=		"(Ljava/security/Permission;)Z",
	.class=			&_jc_java_security_ProtectionDomain$type,
	.param_types=		&_jc_java_security_ProtectionDomain$param_types$implies$cbacf9d54b2bb917,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_java_security_ProtectionDomain$param_ptypes$implies$cbacf9d54b2bb917,
	.signature_hash=	_JC_JLONG(0xcbacf9d54b2bb917),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_ProtectionDomain$method$implies$cbacf9d54b2bb917,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_ProtectionDomain$vtable, java_security_ProtectionDomain.implies$cbacf9d54b2bb917) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_java_security_ProtectionDomain$linenum_table$implies$cbacf9d54b2bb917
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_ProtectionDomain, implies$cbacf9d54b2bb917);

jboolean _JC_JCNI_ATTR
_jc_java_security_ProtectionDomain$method$implies$cbacf9d54b2bb917(_jc_env *const env, _jc_java_security_ProtectionDomain$object *this, _jc_java_security_Permission$object *param0)
{
	struct _jc_java_security_ProtectionDomain$object *r0;
	struct _jc_java_security_Permission$object *r1;
	struct _jc_java_security_PermissionCollection$object *r2;
	struct _jc_java_security_Policy$object *r4;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(211);				// 0
	z0 = _JC_PRIM_FIELD(env, r0, java_security_ProtectionDomain, staticBinding);
	if (z0 == 0)
		goto label1;
	_JC_LINE_NUMBER(212);				// 1
	z0 = 0;
	r2 = _JC_REF_FIELD(env, r0, java_security_ProtectionDomain, perms);
	if (r2 == _JC_NULL)
		goto label0;
	r2 = _JC_REF_FIELD(env, r0, java_security_ProtectionDomain, perms);
	z0 = _JC_INVOKE_VIRTUAL(env, java_security_PermissionCollection, implies$cbacf9d54b2bb917, r2, r1);

label0:
	return z0;

label1:
	_JC_LINE_NUMBER(215);				// 2
	r4 = _JC_INVOKE_STATIC(env, java_security_Policy, getCurrentPolicy$e41f85a795d15904, 0);
	z0 = _JC_INVOKE_VIRTUAL(env, java_security_Policy, implies$68cf4a1efd3521d1, r4, r0, r1);
	return z0;
}

//
// public java.lang.String toString()
//

static _jc_linenum _jc_java_security_ProtectionDomain$linenum_table$toString$7ea43b33b80a3070[];

static const unsigned char _jc_java_security_ProtectionDomain$param_ptypes$toString$7ea43b33b80a3070[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_java_security_ProtectionDomain$method_info$toString$7ea43b33b80a3070 = {
	.name=			"toString",
	.signature=		"()Ljava/lang/String;",
	.class=			&_jc_java_security_ProtectionDomain$type,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_java_security_ProtectionDomain$param_ptypes$toString$7ea43b33b80a3070,
	.signature_hash=	_JC_JLONG(0x7ea43b33b80a3070),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_ProtectionDomain$method$toString$7ea43b33b80a3070,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_ProtectionDomain$vtable, java_security_ProtectionDomain.toString$7ea43b33b80a3070) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	28,
	      .table=	_jc_java_security_ProtectionDomain$linenum_table$toString$7ea43b33b80a3070
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_ProtectionDomain, toString$7ea43b33b80a3070);

_jc_java_lang_String$object * _JC_JCNI_ATTR
_jc_java_security_ProtectionDomain$method$toString$7ea43b33b80a3070(_jc_env *const env, _jc_java_security_ProtectionDomain$object *this)
{
	jint i0;
	jint i1;
	jint i2;
	jint i3;
	struct _jc_java_security_ProtectionDomain$object *r0;
	struct _jc_java_lang_StringBuffer$object *r1;
	struct _jc_java_lang_Class$object *r10;
	struct _jc_java_lang_String$object *r11;
	struct _jc_java_lang_String$object *r12;
	struct _jc_java_security_Policy$object *r13;
	struct _jc_java_lang_StringBuffer$object *r14;
	struct _jc_java_lang_String$object *r15;
	struct _jc_java_lang_StringBuffer$object *r16;
	struct _jc_java_lang_String$object *r17;
	struct _jc_java_lang_StringBuffer$object *r18;
	struct _jc_java_lang_String$object *r19;
	struct _jc_object *r2;
	struct _jc_java_lang_StringBuffer$object *r20;
	struct _jc_java_lang_String$object *r21;
	struct _jc_java_lang_StringBuffer$object *r22;
	struct _jc_java_lang_String$object *r23;
	struct _jc_java_lang_String$object *r24;
	struct _jc_java_lang_SecurityManager$object *r25;
	struct _jc_java_lang_IllegalArgumentException$object *r26;
	struct _jc_java_lang_String$object *r27;
	struct _jc_java_lang_String$object *r28;
	struct _jc_java_util_Properties$object *r29;
	struct _jc_java_security_CodeSource$object *r3;
	struct _jc_java_lang_VMThrowable$object *r30;
	struct _jc_java_lang_String$object *r31;
	_jc_char_array *r32;
	struct _jc_java_lang_ClassLoader$object *r4;
	_jc_object_array *r5;
	struct _jc_java_lang_StringBuffer$object *r6;
	struct _jc_java_lang_String$object *r7;
	struct _jc_java_security_Policy$object *r8;
	struct _jc_java_security_PermissionCollection$object *r9;
	jboolean z0;
	jboolean z1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_ACTIVE_USE(env, java_lang_System);
	_JC_LINE_NUMBER(225);				// 0
	r24 = _JC_STRING(env, "line.separator");
	r25 = _JC_STATIC_FIELD(env, java_lang_SecurityManager, current, 0);
	if (r25 == _JC_NULL)
		goto label0;
	_JC_INVOKE_VIRTUAL(env, java_lang_SecurityManager, checkPropertyAccess$96b5133fb2013064, r25, r24);
	goto label1;

label0:
	i2 = _JC_PRIM_FIELD(env, r24, java_lang_String, count);
	if (i2 != 0)
		goto label1;
	r26 = _JC_NEW(env, java_lang_IllegalArgumentException);
	r27 = _JC_STRING(env, "key can't be empty");
	_JC_REF_FIELD(env, r26, java_lang_Throwable, cause) = r26;
	r30 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r26);
	_JC_REF_FIELD(env, r26, java_lang_Throwable, vmState) = r30;
	_JC_REF_FIELD(env, r26, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r26, java_lang_Throwable, detailMessage) = r27;
	_JC_THROW(env, r26);

label1:
	_JC_ACTIVE_USE(env, gnu_classpath_SystemProperties);
	r29 = _JC_STATIC_FIELD(env, gnu_classpath_SystemProperties, properties, 1);
	r28 = _JC_INVOKE_VIRTUAL(env, java_util_Properties, getProperty$17fb18205ea95f87, r29, r24);
	_JC_LINE_NUMBER(226);				// 1
	r1 = _JC_NEW(env, java_lang_StringBuffer);
	r31 = _JC_STRING(env, "ProtectionDomain (");
	i3 = _JC_PRIM_FIELD(env, r31, java_lang_String, count);
	_JC_PRIM_FIELD(env, r1, java_lang_StringBuffer, count) = i3;
	i3 = _JC_PRIM_FIELD(env, r1, java_lang_StringBuffer, count);
	i3 = i3 + 16;
	r32 = _JC_NEW_PRIM_ARRAY(env, char, 1, i3);
	_JC_REF_FIELD(env, r1, java_lang_StringBuffer, value) = r32;
	i3 = _JC_PRIM_FIELD(env, r1, java_lang_StringBuffer, count);
	r32 = _JC_REF_FIELD(env, r1, java_lang_StringBuffer, value);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, getChars$c684dea7317ff063, 0, r31, 0, i3, r32, 0);
	r1 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r1, r28);
	_JC_LINE_NUMBER(228);				// 2
	r3 = _JC_REF_FIELD(env, r0, java_security_ProtectionDomain, code__5fsource);
	if (r3 != _JC_NULL)
		goto label2;
	_JC_LINE_NUMBER(229);				// 3
	_JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r1, _JC_STRING(env, "CodeSource:null"));
	goto label5;

label2:
	_JC_LINE_NUMBER(231);				// 4
	r3 = _JC_REF_FIELD(env, r0, java_security_ProtectionDomain, code__5fsource);
	r14 = r1;
	if (r3 != _JC_NULL)
		goto label3;
	r15 = _JC_STRING(env, "null");
	goto label4;

label3:
	r15 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, toString$7ea43b33b80a3070, r3);

label4:
	_JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r14, r15);

label5:
	_JC_LINE_NUMBER(233);				// 5
	_JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r1, r28);
	_JC_LINE_NUMBER(234);				// 6
	r4 = _JC_REF_FIELD(env, r0, java_security_ProtectionDomain, classloader);
	if (r4 != _JC_NULL)
		goto label6;
	_JC_LINE_NUMBER(235);				// 7
	_JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r1, _JC_STRING(env, "ClassLoader:null"));
	goto label9;

label6:
	_JC_LINE_NUMBER(237);				// 8
	r4 = _JC_REF_FIELD(env, r0, java_security_ProtectionDomain, classloader);
	r16 = r1;
	if (r4 != _JC_NULL)
		goto label7;
	r17 = _JC_STRING(env, "null");
	goto label8;

label7:
	r17 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, toString$7ea43b33b80a3070, r4);

label8:
	_JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r16, r17);

label9:
	_JC_LINE_NUMBER(239);				// 9
	_JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r1, r28);
	_JC_LINE_NUMBER(240);				// 10
	_JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r1, _JC_STRING(env, "Principals:"));
	_JC_LINE_NUMBER(241);				// 11
	r5 = _JC_REF_FIELD(env, r0, java_security_ProtectionDomain, principals);
	if (r5 == _JC_NULL)
		goto label13;
	r5 = _JC_REF_FIELD(env, r0, java_security_ProtectionDomain, principals);
	i0 = _JC_ARRAY_LENGTH(env, r5);
	if (i0 <= 0)
		goto label13;
	_JC_LINE_NUMBER(243);				// 12
	_JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r1, _JC_STRING(env, "["));
	_JC_LINE_NUMBER(245);				// 13
	i0 = 0;
	goto label12;

label10:
	_JC_LINE_NUMBER(247);				// 14
	r5 = _JC_REF_FIELD(env, r0, java_security_ProtectionDomain, principals);
	r2 = _JC_REF_ELEMENT(env, r5, i0, 0, 1);
	_JC_LINE_NUMBER(248);				// 15
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r1, _JC_STRING(env, "'"));
	r7 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0xbec186f2ce7e1882), _jc_object *, (_jc_env *, struct _jc_object *));
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 1, r6, r7);
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r6, _JC_STRING(env, "' of type "));
	r10 = _JC_INVOKE_STATIC(env, java_lang_VMObject, getClass$2be11d215bfbfbfe, 0, r2);
	_JC_EXPLICIT_NULL_CHECK(env, r10);
	r11 = _JC_INVOKE_STATIC(env, java_lang_VMClass, getName$7a04fe8e1a654d36, 0, r10);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r6, r11);
	_JC_LINE_NUMBER(250);				// 16
	r5 = _JC_REF_FIELD(env, r0, java_security_ProtectionDomain, principals);
	i1 = _JC_ARRAY_LENGTH(env, r5);
	i1 = i1 - 1;
	if (i0 >= i1)
		goto label11;
	_JC_LINE_NUMBER(251);				// 17
	_JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r1, _JC_STRING(env, ", "));

label11:
	_JC_LINE_NUMBER(245);				// 18
	i0 = i0 + 1;

label12:
	r5 = _JC_REF_FIELD(env, r0, java_security_ProtectionDomain, principals);
	i1 = _JC_ARRAY_LENGTH(env, r5);
	if (i0 < i1) {
		_JC_PERIODIC_CHECK(env);
		goto label10;
	}
	_JC_LINE_NUMBER(253);				// 19
	_JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r1, _JC_STRING(env, "]"));
	goto label14;

label13:
	_JC_LINE_NUMBER(256);				// 20
	_JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r1, _JC_STRING(env, "none"));

label14:
	_JC_LINE_NUMBER(258);				// 21
	_JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r1, r28);
	_JC_LINE_NUMBER(259);				// 22
	z0 = _JC_PRIM_FIELD(env, r0, java_security_ProtectionDomain, staticBinding);
	if (z0 != 0)
		goto label21;
	_JC_ACTIVE_USE(env, java_security_Policy);
	_JC_LINE_NUMBER(260);				// 23
	z1 = 0;
	r13 = _JC_STATIC_FIELD(env, java_security_Policy, currentPolicy, 1);
	if (r13 == _JC_NULL)
		goto label15;
	z1 = 1;

label15:
	if (z1 == 0)
		goto label18;
	_JC_LINE_NUMBER(261);				// 24
	r8 = _JC_INVOKE_STATIC(env, java_security_Policy, getCurrentPolicy$e41f85a795d15904, 1);
	r9 = _JC_INVOKE_VIRTUAL(env, java_security_Policy, getPermissions$625f81f570e99df0, r8, r0);
	r18 = r1;
	if (r9 != _JC_NULL)
		goto label16;
	r19 = _JC_STRING(env, "null");
	goto label17;

label16:
	r19 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, toString$7ea43b33b80a3070, r9);

label17:
	_JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r18, r19);
	goto label24;

label18:
	_JC_LINE_NUMBER(263);				// 25
	r9 = _JC_REF_FIELD(env, r0, java_security_ProtectionDomain, perms);
	r20 = r1;
	if (r9 != _JC_NULL)
		goto label19;
	r21 = _JC_STRING(env, "null");
	goto label20;

label19:
	r21 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, toString$7ea43b33b80a3070, r9);

label20:
	_JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r20, r21);
	goto label24;

label21:
	_JC_LINE_NUMBER(265);				// 26
	r9 = _JC_REF_FIELD(env, r0, java_security_ProtectionDomain, perms);
	r22 = r1;
	if (r9 != _JC_NULL)
		goto label22;
	r23 = _JC_STRING(env, "null");
	goto label23;

label22:
	r23 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, toString$7ea43b33b80a3070, r9);

label23:
	_JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r22, r23);

label24:
	_JC_LINE_NUMBER(267);				// 27
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r1, r28);
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 1, r6, _JC_STRING(env, ")"));
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r6, r28);
	r12 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r12, r6);
	return r12;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_java_security_ProtectionDomain$methods[] = {
	&_jc_java_security_ProtectionDomain$method_info$_init$b12b635144056f6c,
	&_jc_java_security_ProtectionDomain$method_info$_init$df4c86d874bb5681,
	&_jc_java_security_ProtectionDomain$method_info$_init$544e1ecf4bed1a81,
	&_jc_java_security_ProtectionDomain$method_info$getClassLoader$2078dc747ca30d6e,
	&_jc_java_security_ProtectionDomain$method_info$getCodeSource$c5e8828ac4e55d4f,
	&_jc_java_security_ProtectionDomain$method_info$getPermissions$9ba9c969cc070a80,
	&_jc_java_security_ProtectionDomain$method_info$getPrincipals$56d665eaf6bc40b3,
	&_jc_java_security_ProtectionDomain$method_info$implies$cbacf9d54b2bb917,
	&_jc_java_security_ProtectionDomain$method_info$toString$7ea43b33b80a3070
};

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_java_security_ProtectionDomain$instanceof_hash_bucket_89[] = {
	&_jc_java_security_ProtectionDomain$type,
	_JC_NULL
};
static _jc_type *const _jc_java_security_ProtectionDomain$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_java_security_ProtectionDomain$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[89]=	_jc_java_security_ProtectionDomain$instanceof_hash_bucket_89,
	[101]=	_jc_java_security_ProtectionDomain$instanceof_hash_bucket_101
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_java_security_ProtectionDomain$class_depends[] = {
	{ "gnu/classpath/SystemProperties",	_JC_JLONG(0x1160ded3f016b6b0) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/ClassLoader",	_JC_JLONG(0xb0527a7101321261) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/IllegalArgumentException",	_JC_JLONG(0x680cf34d05feb5a1) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/RuntimeException",	_JC_JLONG(0x4f5534a987354d1d) },
	{ "java/lang/SecurityManager",	_JC_JLONG(0xd38282f3d5f80887) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/StringBuffer",	_JC_JLONG(0x94d357637b968dda) },
	{ "java/lang/System",	_JC_JLONG(0x53cc8e2333795f04) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMClass",	_JC_JLONG(0x238a2c0aafd74314) },
	{ "java/lang/VMObject",	_JC_JLONG(0x312e45ed214d432f) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/security/CodeSource",	_JC_JLONG(0xae48ca2e0104c4f5) },
	{ "java/security/Permission",	_JC_JLONG(0x2377c76e79058a72) },
	{ "java/security/PermissionCollection",	_JC_JLONG(0xc66c17eff6c1d1e6) },
	{ "java/security/Policy",	_JC_JLONG(0x22e7d19b890f754a) },
	{ "java/security/Principal",	_JC_JLONG(0x1ed0accfc254a715) },
	{ "java/util/Properties",	_JC_JLONG(0x884c3edb343dfb63) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_java_security_ProtectionDomain$vtype _jc_java_security_ProtectionDomain$type = {
    .type= {
	.name=			"java/security/ProtectionDomain",
	.superclass=		&_jc_java_lang_Object$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		17,
		.hash=			_JC_JLONG(0x7db4f21fb4389f59),
		.source_file=		"ProtectionDomain.java",
		.instance_size=		sizeof(_jc_java_security_ProtectionDomain$refs) + sizeof(_jc_java_security_ProtectionDomain$object),
		.num_virtual_refs=	4,
		.num_fields=		sizeof(_jc_java_security_ProtectionDomain$fields) / sizeof(*_jc_java_security_ProtectionDomain$fields),
		.fields=		_jc_java_security_ProtectionDomain$fields,
		.num_methods=		sizeof(_jc_java_security_ProtectionDomain$methods) / sizeof(*_jc_java_security_ProtectionDomain$methods),
		.methods=		_jc_java_security_ProtectionDomain$methods,
		.instanceof_hash_table=	_jc_java_security_ProtectionDomain$instanceof_hash_table,
		.num_class_depends=		sizeof(_jc_java_security_ProtectionDomain$class_depends) / sizeof(*_jc_java_security_ProtectionDomain$class_depends),
		.class_depends=		_jc_java_security_ProtectionDomain$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=			// overridden
		&_jc_java_security_ProtectionDomain$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.java_security_ProtectionDomain= {
	    .getClassLoader$2078dc747ca30d6e=
		&_jc_java_security_ProtectionDomain$method$getClassLoader$2078dc747ca30d6e,
	    .getCodeSource$c5e8828ac4e55d4f=
		&_jc_java_security_ProtectionDomain$method$getCodeSource$c5e8828ac4e55d4f,
	    .getPermissions$9ba9c969cc070a80=
		&_jc_java_security_ProtectionDomain$method$getPermissions$9ba9c969cc070a80,
	    .getPrincipals$56d665eaf6bc40b3=
		&_jc_java_security_ProtectionDomain$method$getPrincipals$56d665eaf6bc40b3,
	    .implies$cbacf9d54b2bb917=
		&_jc_java_security_ProtectionDomain$method$implies$cbacf9d54b2bb917,
	    .toString$7ea43b33b80a3070=
		&_jc_java_security_ProtectionDomain$method$toString$7ea43b33b80a3070,
	},
    }
};

