// public class java.security.SecureRandom

// class file dependencies
// @dep_class f4ba095546954b36 gnu_java_security_Engine
// @dep_class 74cf6a4caac8d5c3 gnu_java_security_provider_SHA1PRNG
// @dep_class 9a35c7173b37e641 java_io_Serializable
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class f02ab3ccb490a6d0 java_lang_ClassCastException
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class 680cf34d05feb5a1 java_lang_IllegalArgumentException
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class 4f5534a987354d1d java_lang_RuntimeException
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 53cc8e2333795f04 java_lang_System
// @dep_class fe7096144692ae30 java_lang_ThreadDeath
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class 4d1cebae0bdda058 java_lang_VMSystem
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class ae4a2342b31a268d java_lang_reflect_InvocationTargetException
// @dep_class 692089051f4c8d0b java_security_GeneralSecurityException
// @dep_class 22e937c2536160b4 java_security_NoSuchAlgorithmException
// @dep_class 8dfbf242adab91e java_security_NoSuchProviderException
// @dep_class 81b073051aa30acc java_security_Provider
// @dep_class 15c6a62b25a6e96d java_security_SecureRandom
// @dep_class 254ca156f086a0ef java_security_SecureRandomSpi
// @dep_class 89bf77984bd9669e java_security_Security
// @dep_class c56a8b1934689c38 java_util_Enumeration
// @dep_class 884c3edb343dfb63 java_util_Properties
// @dep_class 61639c1affc91eab java_util_Random
// @dep_class c53e1575b095109b java_util_Vector

// header file dependencies
// @dep_header gnu_java_security_Engine
// @dep_header gnu_java_security_provider_SHA1PRNG
// @dep_header java_io_Serializable
// @dep_header java_lang_Class
// @dep_header java_lang_ClassCastException
// @dep_header java_lang_IllegalArgumentException
// @dep_header java_lang_String
// @dep_header java_lang_System
// @dep_header java_lang_ThreadDeath
// @dep_header java_lang_VMSystem
// @dep_header java_lang_VMThrowable
// @dep_header java_lang_reflect_InvocationTargetException
// @dep_header java_security_NoSuchAlgorithmException
// @dep_header java_security_NoSuchProviderException
// @dep_header java_security_Provider
// @dep_header java_security_SecureRandom
// @dep_header java_security_Security
// @dep_header java_util_Enumeration
// @dep_header java_util_Vector

#include "jc_defs.h"

#include "gnu/java/security/Engine.h"
#include "gnu/java/security/provider/SHA1PRNG.h"
#include "java/io/Serializable.h"
#include "java/lang/Class.h"
#include "java/lang/ClassCastException.h"
#include "java/lang/IllegalArgumentException.h"
#include "java/lang/String.h"
#include "java/lang/System.h"
#include "java/lang/ThreadDeath.h"
#include "java/lang/VMSystem.h"
#include "java/lang/VMThrowable.h"
#include "java/lang/reflect/InvocationTargetException.h"
#include "java/security/NoSuchAlgorithmException.h"
#include "java/security/NoSuchProviderException.h"
#include "java/security/Provider.h"
#include "java/security/SecureRandom.h"
#include "java/security/Security.h"
#include "java/util/Enumeration.h"
#include "java/util/Vector.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// private static final java.lang.String SECURE_RANDOM
static _jc_field _jc_java_security_SecureRandom$field_info$SECURE__5fRANDOM = {
	.name=		"SECURE_RANDOM",
	.signature=	"Ljava/lang/String;",
	.class=		&_jc_java_security_SecureRandom$type,
	.type=		&_jc_java_lang_String$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_java_security_SecureRandom$fields_struct, SECURE__5fRANDOM),
	.initial_value=	"SecureRandom",
};

// private static final long serialVersionUID
static const jlong _jc_java_security_SecureRandom$initial_value$serialVersionUID = _JC_JLONG(4940670005562187);
static _jc_field _jc_java_security_SecureRandom$field_info$serialVersionUID = {
	.name=		"serialVersionUID",
	.signature=	"J",
	.class=		&_jc_java_security_SecureRandom$type,
	.type=		&_jc_long$prim$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_java_security_SecureRandom$fields_struct, serialVersionUID),
	.initial_value=	&_jc_java_security_SecureRandom$initial_value$serialVersionUID,
};

// long counter
static _jc_field _jc_java_security_SecureRandom$field_info$counter = {
	.name=		"counter",
	.signature=	"J",
	.class=		&_jc_java_security_SecureRandom$type,
	.type=		&_jc_long$prim$type,
	.access_flags=	0,
	.offset=	_JC_OFFSETOF(_jc_java_security_SecureRandom$object, nonrefs.java_security_SecureRandom.counter),
};

// java.security.Provider provider
static _jc_field _jc_java_security_SecureRandom$field_info$provider = {
	.name=		"provider",
	.signature=	"Ljava/security/Provider;",
	.class=		&_jc_java_security_SecureRandom$type,
	.type=		&_jc_java_security_Provider$type,
	.access_flags=	0,
	.offset=	_JC_OFFSETOF(_jc_java_security_SecureRandom$object, refs[-1].java_security_SecureRandom.provider),
};

// byte[] randomBytes
static _jc_field _jc_java_security_SecureRandom$field_info$randomBytes = {
	.name=		"randomBytes",
	.signature=	"[B",
	.class=		&_jc_java_security_SecureRandom$type,
	.type=		&_jc_byte$array$prim$type,
	.access_flags=	0,
	.offset=	_JC_OFFSETOF(_jc_java_security_SecureRandom$object, refs[-1].java_security_SecureRandom.randomBytes),
};

// int randomBytesUsed
static _jc_field _jc_java_security_SecureRandom$field_info$randomBytesUsed = {
	.name=		"randomBytesUsed",
	.signature=	"I",
	.class=		&_jc_java_security_SecureRandom$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	0,
	.offset=	_JC_OFFSETOF(_jc_java_security_SecureRandom$object, nonrefs.java_security_SecureRandom.randomBytesUsed),
};

// java.security.SecureRandomSpi secureRandomSpi
static _jc_field _jc_java_security_SecureRandom$field_info$secureRandomSpi = {
	.name=		"secureRandomSpi",
	.signature=	"Ljava/security/SecureRandomSpi;",
	.class=		&_jc_java_security_SecureRandom$type,
	.type=		&_jc_java_security_SecureRandomSpi$type,
	.access_flags=	0,
	.offset=	_JC_OFFSETOF(_jc_java_security_SecureRandom$object, refs[-1].java_security_SecureRandom.secureRandomSpi),
};

// byte[] state
static _jc_field _jc_java_security_SecureRandom$field_info$state = {
	.name=		"state",
	.signature=	"[B",
	.class=		&_jc_java_security_SecureRandom$type,
	.type=		&_jc_byte$array$prim$type,
	.access_flags=	0,
	.offset=	_JC_OFFSETOF(_jc_java_security_SecureRandom$object, refs[-1].java_security_SecureRandom.state),
};

// Fields
static _jc_field *const _jc_java_security_SecureRandom$fields[] = {
	&_jc_java_security_SecureRandom$field_info$SECURE__5fRANDOM,
	&_jc_java_security_SecureRandom$field_info$serialVersionUID,
	&_jc_java_security_SecureRandom$field_info$provider,
	&_jc_java_security_SecureRandom$field_info$randomBytes,
	&_jc_java_security_SecureRandom$field_info$secureRandomSpi,
	&_jc_java_security_SecureRandom$field_info$state,
	&_jc_java_security_SecureRandom$field_info$counter,
	&_jc_java_security_SecureRandom$field_info$randomBytesUsed
};

/************************************************************************
 *			      Static methods				*
 ************************************************************************/

//
// public static java.security.SecureRandom getInstance(java.lang.String) throws java.security.NoSuchAlgorithmException
//

static _jc_linenum _jc_java_security_SecureRandom$linenum_table$getInstance$452ab8480dcd4a6f[];

static _jc_trap_info _jc_java_security_SecureRandom$trap_table$getInstance$452ab8480dcd4a6f[] = {
	_JC_TRAP(&_jc_java_security_NoSuchAlgorithmException$type, 1, 2),
};

static const unsigned char _jc_java_security_SecureRandom$param_ptypes$getInstance$452ab8480dcd4a6f[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_security_SecureRandom$exceptions$getInstance$452ab8480dcd4a6f[] = {
	&_jc_java_security_NoSuchAlgorithmException$type
};

static _jc_type *const _jc_java_security_SecureRandom$param_types$getInstance$452ab8480dcd4a6f[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_java_security_SecureRandom$method_info$getInstance$452ab8480dcd4a6f = {
	.name=			"getInstance",
	.signature=		"(Ljava/lang/String;)Ljava/security/SecureRandom;",
	.class=			&_jc_java_security_SecureRandom$type,
	.param_types=		&_jc_java_security_SecureRandom$param_types$getInstance$452ab8480dcd4a6f,
	.return_type=		&_jc_java_security_SecureRandom$type,
	.param_ptypes=		&_jc_java_security_SecureRandom$param_ptypes$getInstance$452ab8480dcd4a6f,
	.signature_hash=	_JC_JLONG(0x452ab8480dcd4a6f),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_java_security_SecureRandom$method$getInstance$452ab8480dcd4a6f,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_security_SecureRandom$exceptions$getInstance$452ab8480dcd4a6f,
	.u= { .exec= {
	  .trap_table_len=	1,
	  .trap_table=		_jc_java_security_SecureRandom$trap_table$getInstance$452ab8480dcd4a6f,
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_java_security_SecureRandom$linenum_table$getInstance$452ab8480dcd4a6f
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_SecureRandom, getInstance$452ab8480dcd4a6f);

_jc_java_security_SecureRandom$object * _JC_JCNI_ATTR
_jc_java_security_SecureRandom$method$getInstance$452ab8480dcd4a6f(_jc_env *const env, _jc_java_lang_String$object *param0)
{
	jint volatile i0;
	jint volatile i1;
	jint i2;
	struct _jc_java_lang_String$object *volatile r0;
	struct _jc_java_security_Provider$object *volatile r2;
	struct _jc_java_security_SecureRandom$object *volatile r3;
	struct _jc_java_security_NoSuchAlgorithmException$object *volatile r4;
	struct _jc_java_lang_VMThrowable$object *volatile r5;
	struct _jc_java_util_Vector$object *r6;
	_jc_object_array *volatile r7;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_java_security_SecureRandom$method_info$getInstance$452ab8480dcd4a6f, &&label1);

	r0 = param0;
	_JC_ACTIVE_USE(env, java_security_Security);
	_JC_LINE_NUMBER(180);				// 0
	r6 = _JC_STATIC_FIELD(env, java_security_Security, providers, 1);
	i2 = _JC_INVOKE_VIRTUAL(env, java_util_Vector, size$345df5220fc60ade, r6);
	r7 = _JC_NEW_REF_ARRAY(env, java_security_Provider, 1, i2);
	r6 = _JC_STATIC_FIELD(env, java_security_Security, providers, 1);
	_JC_INVOKE_VIRTUAL(env, java_util_Vector, copyInto$cd78d768b3ba4735, r6, r7);
	_JC_LINE_NUMBER(182);				// 1
	i0 = 0;
	goto label2;

label0:
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(186);				// 2
	r2 = _JC_REF_ELEMENT(env, r7, i0, 1, 1);
	r3 = _JC_INVOKE_STATIC(env, java_security_SecureRandom, getInstance$9f36f264f766453b, 0, r0, r2);
	_JC_TRAP_REGION(catch, 2);
	_JC_CANCEL_TRAPS(env, catch);
	return r3;

label1:
	_JC_TRAP_REGION(catch, 2);
	r4 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(182);				// 3
	i0 = i0 + 1;

label2:
	_JC_TRAP_REGION(catch, 2);
	i1 = _JC_ARRAY_LENGTH(env, r7);
	if (i0 < i1) {
		_JC_PERIODIC_CHECK(env);
		goto label0;
	}
	_JC_LINE_NUMBER(195);				// 4
	r4 = _JC_NEW(env, java_security_NoSuchAlgorithmException);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r5 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r5;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r0;
	_JC_THROW(env, r4);
}

//
// public static java.security.SecureRandom getInstance(java.lang.String, java.lang.String) throws java.security.NoSuchAlgorithmException, java.security.NoSuchProviderException
//

static _jc_linenum _jc_java_security_SecureRandom$linenum_table$getInstance$3fb2849395b17e05[];

static const unsigned char _jc_java_security_SecureRandom$param_ptypes$getInstance$3fb2849395b17e05[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_security_SecureRandom$exceptions$getInstance$3fb2849395b17e05[] = {
	&_jc_java_security_NoSuchAlgorithmException$type,
	&_jc_java_security_NoSuchProviderException$type
};

static _jc_type *const _jc_java_security_SecureRandom$param_types$getInstance$3fb2849395b17e05[] = {
	&_jc_java_lang_String$type,
	&_jc_java_lang_String$type
};

_jc_method _jc_java_security_SecureRandom$method_info$getInstance$3fb2849395b17e05 = {
	.name=			"getInstance",
	.signature=		"(Ljava/lang/String;Ljava/lang/String;)Ljava/security/SecureRandom;",
	.class=			&_jc_java_security_SecureRandom$type,
	.param_types=		&_jc_java_security_SecureRandom$param_types$getInstance$3fb2849395b17e05,
	.return_type=		&_jc_java_security_SecureRandom$type,
	.param_ptypes=		&_jc_java_security_SecureRandom$param_ptypes$getInstance$3fb2849395b17e05,
	.signature_hash=	_JC_JLONG(0x3fb2849395b17e05),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_java_security_SecureRandom$method$getInstance$3fb2849395b17e05,
	.num_parameters=	2,
	.num_exceptions=	2,
	.exceptions=		&_jc_java_security_SecureRandom$exceptions$getInstance$3fb2849395b17e05,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	6,
	      .table=	_jc_java_security_SecureRandom$linenum_table$getInstance$3fb2849395b17e05
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_SecureRandom, getInstance$3fb2849395b17e05);

_jc_java_security_SecureRandom$object * _JC_JCNI_ATTR
_jc_java_security_SecureRandom$method$getInstance$3fb2849395b17e05(_jc_env *const env, _jc_java_lang_String$object *param0, _jc_java_lang_String$object *param1)
{
	jint i0;
	struct _jc_java_lang_String$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_java_security_Provider$object *r2;
	struct _jc_java_lang_IllegalArgumentException$object *r3;
	struct _jc_java_security_NoSuchProviderException$object *r4;
	struct _jc_java_security_SecureRandom$object *r5;
	struct _jc_java_lang_String$object *r6;
	struct _jc_java_lang_VMThrowable$object *r7;
	struct _jc_java_lang_VMThrowable$object *r9;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = param0;
	r1 = param1;
	_JC_LINE_NUMBER(216);				// 0
	if (r1 == _JC_NULL)
		goto label0;
	i0 = _JC_PRIM_FIELD(env, r1, java_lang_String, count);
	if (i0 != 0)
		goto label1;

label0:
	_JC_LINE_NUMBER(217);				// 1
	r3 = _JC_NEW(env, java_lang_IllegalArgumentException);
	r6 = _JC_STRING(env, "Illegal provider");
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r7 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r7;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r6;
	_JC_THROW(env, r3);

label1:
	_JC_LINE_NUMBER(219);				// 2
	r2 = _JC_INVOKE_STATIC(env, java_security_Security, getProvider$581ee7d7bc9ae747, 0, r1);
	_JC_LINE_NUMBER(220);				// 3
	if (r2 != _JC_NULL)
		goto label2;
	_JC_LINE_NUMBER(221);				// 4
	r4 = _JC_NEW(env, java_security_NoSuchProviderException);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r9 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r9;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r1;
	_JC_THROW(env, r4);

label2:
	_JC_LINE_NUMBER(223);				// 5
	r5 = _JC_INVOKE_STATIC(env, java_security_SecureRandom, getInstance$9f36f264f766453b, 1, r0, r2);
	return r5;
}

//
// public static java.security.SecureRandom getInstance(java.lang.String, java.security.Provider) throws java.security.NoSuchAlgorithmException
//

static _jc_linenum _jc_java_security_SecureRandom$linenum_table$getInstance$9f36f264f766453b[];

static _jc_trap_info _jc_java_security_SecureRandom$trap_table$getInstance$9f36f264f766453b[] = {
	_JC_TRAP(&_jc_java_lang_reflect_InvocationTargetException$type, 1, 2),
	_JC_TRAP(&_jc_java_lang_ClassCastException$type, 1, 2),
};

static const unsigned char _jc_java_security_SecureRandom$param_ptypes$getInstance$9f36f264f766453b[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_security_SecureRandom$exceptions$getInstance$9f36f264f766453b[] = {
	&_jc_java_security_NoSuchAlgorithmException$type
};

static _jc_type *const _jc_java_security_SecureRandom$param_types$getInstance$9f36f264f766453b[] = {
	&_jc_java_lang_String$type,
	&_jc_java_security_Provider$type
};

_jc_method _jc_java_security_SecureRandom$method_info$getInstance$9f36f264f766453b = {
	.name=			"getInstance",
	.signature=		"(Ljava/lang/String;Ljava/security/Provider;)Ljava/security/SecureRandom;",
	.class=			&_jc_java_security_SecureRandom$type,
	.param_types=		&_jc_java_security_SecureRandom$param_types$getInstance$9f36f264f766453b,
	.return_type=		&_jc_java_security_SecureRandom$type,
	.param_ptypes=		&_jc_java_security_SecureRandom$param_ptypes$getInstance$9f36f264f766453b,
	.signature_hash=	_JC_JLONG(0x9f36f264f766453b),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_java_security_SecureRandom$method$getInstance$9f36f264f766453b,
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_security_SecureRandom$exceptions$getInstance$9f36f264f766453b,
	.u= { .exec= {
	  .trap_table_len=	2,
	  .trap_table=		_jc_java_security_SecureRandom$trap_table$getInstance$9f36f264f766453b,
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_java_security_SecureRandom$linenum_table$getInstance$9f36f264f766453b
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_SecureRandom, getInstance$9f36f264f766453b);

_jc_java_security_SecureRandom$object * _JC_JCNI_ATTR
_jc_java_security_SecureRandom$method$getInstance$9f36f264f766453b(_jc_env *const env, _jc_java_lang_String$object *param0, _jc_java_security_Provider$object *param1)
{
	jlong l0;
	struct _jc_java_lang_String$object *volatile r0;
	struct _jc_java_security_Provider$object *r1;
	_jc_object_array *r10;
	struct _jc_java_lang_Object$object *r11;
	struct _jc_java_lang_VMThrowable$object *r12;
	struct _jc_java_lang_VMThrowable$object *volatile r13;
	struct _jc_java_lang_VMThrowable$object *volatile r15;
	struct _jc_java_lang_reflect_InvocationTargetException$object *r2;
	struct _jc_java_lang_IllegalArgumentException$object *r3;
	struct _jc_java_security_SecureRandom$object *r4;
	struct _jc_java_security_SecureRandomSpi$object *r5;
	struct _jc_java_security_NoSuchAlgorithmException$object *volatile r6;
	struct _jc_java_lang_ClassCastException$object *r7;
	struct _jc_java_lang_String$object *r8;
	struct _jc_java_lang_String$object *r9;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_java_security_SecureRandom$method_info$getInstance$9f36f264f766453b, &&label1, &&label2);

	r0 = param0;
	r1 = param1;
	_JC_LINE_NUMBER(239);				// 0
	if (r1 != _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(240);				// 1
	r3 = _JC_NEW(env, java_lang_IllegalArgumentException);
	r8 = _JC_STRING(env, "Illegal provider");
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r12 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r12;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r8;
	_JC_THROW(env, r3);

label0:
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(243);				// 2
	r4 = _JC_NEW(env, java_security_SecureRandom);
	_JC_ACTIVE_USE(env, gnu_java_security_Engine);
	r9 = _JC_STRING(env, "SecureRandom");
	r10 = _JC_STATIC_FIELD(env, gnu_java_security_Engine, NO__5fARGS, 1);
	r11 = _JC_INVOKE_STATIC(env, gnu_java_security_Engine, getInstance$ec89dfd35c234c64, 1, r9, r0, r1, r10);
	r5 = _JC_CAST(env, &_jc_java_security_SecureRandomSpi$type, r11);
	_JC_ACTIVE_USE(env, java_lang_System);
	l0 = _JC_INVOKE_STATIC(env, java_lang_VMSystem, currentTimeMillis$f4fdeb31d00e9185, 0);
	_JC_INVOKE_NONVIRTUAL(env, java_security_SecureRandom, setSeed$b5af8144ceac8f80, 0, r4, l0);
	_JC_INVOKE_NONVIRTUAL(env, java_security_SecureRandom, this$adc93fb6bf4cbffa, 0, r4);
	_JC_REF_FIELD(env, r4, java_security_SecureRandom, secureRandomSpi) = r5;
	_JC_REF_FIELD(env, r4, java_security_SecureRandom, provider) = r1;
	_JC_TRAP_REGION(catch, 2);
	_JC_CANCEL_TRAPS(env, catch);
	return r4;

label1:
	_JC_TRAP_REGION(catch, 2);
	r2 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(249);				// 3
	r6 = _JC_NEW(env, java_security_NoSuchAlgorithmException);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, cause) = r6;
	r13 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r6);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, vmState) = r13;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, detailMessage) = r0;
	_JC_THROW(env, r6);

label2:
	_JC_TRAP_REGION(catch, 2);
	r7 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(253);				// 4
	r6 = _JC_NEW(env, java_security_NoSuchAlgorithmException);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, cause) = r6;
	r15 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r6);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, vmState) = r15;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, detailMessage) = r0;
	_JC_THROW(env, r6);
}

//
// public static byte[] getSeed(int)
//

static _jc_linenum _jc_java_security_SecureRandom$linenum_table$getSeed$868ee6f6964ba0ce[];

static const unsigned char _jc_java_security_SecureRandom$param_ptypes$getSeed$868ee6f6964ba0ce[] = { 
_JC_TYPE_INT, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_security_SecureRandom$param_types$getSeed$868ee6f6964ba0ce[] = {
	&_jc_int$prim$type
};

_jc_method _jc_java_security_SecureRandom$method_info$getSeed$868ee6f6964ba0ce = {
	.name=			"getSeed",
	.signature=		"(I)[B",
	.class=			&_jc_java_security_SecureRandom$type,
	.param_types=		&_jc_java_security_SecureRandom$param_types$getSeed$868ee6f6964ba0ce,
	.return_type=		&_jc_byte$array$prim$type,
	.param_ptypes=		&_jc_java_security_SecureRandom$param_ptypes$getSeed$868ee6f6964ba0ce,
	.signature_hash=	_JC_JLONG(0x868ee6f6964ba0ce),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_java_security_SecureRandom$method$getSeed$868ee6f6964ba0ce,
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_java_security_SecureRandom$linenum_table$getSeed$868ee6f6964ba0ce
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_SecureRandom, getSeed$868ee6f6964ba0ce);

_jc_byte_array * _JC_JCNI_ATTR
_jc_java_security_SecureRandom$method$getSeed$868ee6f6964ba0ce(_jc_env *const env, jint param0)
{
	jint i0;
	jlong l1;
	_jc_byte_array *r0;
	struct _jc_java_util_Random$object *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	i0 = param0;
	_JC_LINE_NUMBER(361);				// 0
	r0 = _JC_NEW_PRIM_ARRAY(env, byte, 1, i0);
	_JC_LINE_NUMBER(363);				// 1
	r1 = _JC_NEW(env, java_util_Random);
	_JC_ACTIVE_USE(env, java_lang_System);
	l1 = _JC_INVOKE_STATIC(env, java_lang_VMSystem, currentTimeMillis$f4fdeb31d00e9185, 0);
	_JC_INVOKE_NONVIRTUAL(env, java_util_Random, setSeed$b5af8144ceac8f80, 0, r1, l1);
	_JC_INVOKE_NONVIRTUAL(env, java_util_Random, nextBytes$3cf04b354db5197f, 0, r1, r0);
	_JC_LINE_NUMBER(364);				// 2
	return r0;
}

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// public void <init>()
//

static _jc_linenum _jc_java_security_SecureRandom$linenum_table$_init$52f4ad9f2989aeee[];

static _jc_trap_info _jc_java_security_SecureRandom$trap_table$_init$52f4ad9f2989aeee[] = {
	_JC_TRAP(&_jc_java_lang_ThreadDeath$type, 1, 2),
	_JC_TRAP(_JC_NULL, 1, 2),
};

static const unsigned char _jc_java_security_SecureRandom$param_ptypes$_init$52f4ad9f2989aeee[] = { 
_JC_TYPE_VOID };

_jc_method _jc_java_security_SecureRandom$method_info$_init$52f4ad9f2989aeee = {
	.name=			"<init>",
	.signature=		"()V",
	.class=			&_jc_java_security_SecureRandom$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_security_SecureRandom$param_ptypes$_init$52f4ad9f2989aeee,
	.signature_hash=	_JC_JLONG(0x52f4ad9f2989aeee),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_SecureRandom$method$_init$52f4ad9f2989aeee,
	.num_parameters=	0,
	.u= { .exec= {
	  .trap_table_len=	2,
	  .trap_table=		_jc_java_security_SecureRandom$trap_table$_init$52f4ad9f2989aeee,
	  .u= {
	    .linenum= {
	      .len=	15,
	      .table=	_jc_java_security_SecureRandom$linenum_table$_init$52f4ad9f2989aeee
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_SecureRandom, _init$52f4ad9f2989aeee);

void _JC_JCNI_ATTR
_jc_java_security_SecureRandom$method$_init$52f4ad9f2989aeee(_jc_env *const env, _jc_java_security_SecureRandom$object *this)
{
	jint volatile i0;
	jint volatile i1;
	jint volatile i3;
	jint i4;
	jlong l2;
	struct _jc_java_security_SecureRandom$object *volatile r0;
	struct _jc_object *volatile r1;
	struct _jc_java_lang_String$object *volatile r10;
	struct _jc_java_util_Vector$object *r11;
	_jc_object_array *volatile r12;
	struct _jc_java_lang_String$object *volatile r2;
	struct _jc_java_lang_ThreadDeath$object *volatile r3;
	struct _jc_java_security_Provider$object *volatile r4;
	struct _jc_java_lang_Object$object *volatile r5;
	struct _jc_java_lang_Class$object *volatile r6;
	struct _jc_java_security_SecureRandomSpi$object *volatile r7;
	struct _jc_java_lang_Throwable$object *r8;
	struct _jc_gnu_java_security_provider_SHA1PRNG$object *volatile r9;
	jboolean volatile z0;
	jboolean volatile z1;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_java_security_SecureRandom$method_info$_init$52f4ad9f2989aeee, &&label2, &&label3);

	r0 = this;
	_JC_ACTIVE_USE(env, java_lang_System);
	l2 = _JC_INVOKE_STATIC(env, java_lang_VMSystem, currentTimeMillis$f4fdeb31d00e9185, 0);
	_JC_INVOKE_VIRTUAL(env, java_util_Random, setSeed$b5af8144ceac8f80, r0, l2);
	_JC_PRIM_FIELD(env, r0, java_security_SecureRandom, counter) = _JC_JLONG(0);
	_JC_REF_FIELD(env, r0, java_security_SecureRandom, provider) = _JC_NULL;
	_JC_REF_FIELD(env, r0, java_security_SecureRandom, randomBytes) = _JC_NULL;
	_JC_PRIM_FIELD(env, r0, java_security_SecureRandom, randomBytesUsed) = 0;
	_JC_REF_FIELD(env, r0, java_security_SecureRandom, secureRandomSpi) = _JC_NULL;
	_JC_REF_FIELD(env, r0, java_security_SecureRandom, state) = _JC_NULL;
	_JC_ACTIVE_USE(env, java_security_Security);
	_JC_LINE_NUMBER(90);				// 0
	r11 = _JC_STATIC_FIELD(env, java_security_Security, providers, 1);
	i4 = _JC_INVOKE_VIRTUAL(env, java_util_Vector, size$345df5220fc60ade, r11);
	r12 = _JC_NEW_REF_ARRAY(env, java_security_Provider, 1, i4);
	r11 = _JC_STATIC_FIELD(env, java_security_Security, providers, 1);
	_JC_INVOKE_VIRTUAL(env, java_util_Vector, copyInto$cd78d768b3ba4735, r11, r12);
	_JC_LINE_NUMBER(98);				// 1
	i0 = 0;
	goto label5;

label0:
	_JC_TRAP_REGION(catch, 0);
	_JC_LINE_NUMBER(100);				// 2
	r4 = _JC_REF_ELEMENT(env, r12, i0, 1, 1);
	r1 = _JC_INVOKE_VIRTUAL(env, java_util_Properties, propertyNames$53855715b687ac31, r4);
	_JC_LINE_NUMBER(101);				// 3
	goto label4;

label1:
	_JC_TRAP_REGION(catch, 0);
	_JC_LINE_NUMBER(103);				// 4
	r5 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0x9b7c3789fa3ba818), _jc_object *, (_jc_env *, struct _jc_object *));
	r2 = _JC_CAST_FINAL(env, &_jc_java_lang_String$type, r5);
	_JC_EXPLICIT_NULL_CHECK(env, r2);
	r10 = _JC_STRING(env, "SECURERANDOM.");
	i3 = _JC_PRIM_FIELD(env, r10, java_lang_String, count);
	z1 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, regionMatches$8a82c88118b60ee6, 0, r2, 0, 0, r10, 0, i3);
	_JC_LINE_NUMBER(104);				// 5
	if (z1 == 0)
		goto label4;
	_JC_LINE_NUMBER(106);				// 6
	r4 = _JC_REF_ELEMENT(env, r12, i0, 1, 1);
	r2 = _JC_INVOKE_VIRTUAL(env, java_util_Properties, getProperty$17fb18205ea95f87, r4, r2);
	if (r2 == _JC_NULL)
		goto label4;
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(110);				// 7
	r6 = _JC_INVOKE_STATIC(env, java_lang_Class, forName$d3b57db3b6a905a3, 0, r2);
	r5 = _JC_INVOKE_NONVIRTUAL(env, java_lang_Class, newInstance$548f1ab1530c9482, 1, r6);
	r7 = _JC_CAST(env, &_jc_java_security_SecureRandomSpi$type, r5);
	_JC_REF_FIELD(env, r0, java_security_SecureRandom, secureRandomSpi) = r7;
	_JC_LINE_NUMBER(112);				// 8
	r4 = _JC_REF_ELEMENT(env, r12, i0, 0, 0);
	_JC_REF_FIELD(env, r0, java_security_SecureRandom, provider) = r4;
	_JC_TRAP_REGION(catch, 2);
	_JC_LINE_NUMBER(113);				// 9
	_JC_CANCEL_TRAPS(env, catch);
	return;

label2:
	_JC_TRAP_REGION(catch, 2);
	r3 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(117);				// 10
	_JC_THROW(env, r3);

label3:
	_JC_TRAP_REGION(catch, 2);
	r8 = _JC_CAUGHT_EXCEPTION(env);

label4:
	_JC_TRAP_REGION(catch, 2);
	_JC_LINE_NUMBER(101);				// 11
	z0 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0x95fbe58f36adadb0), jboolean, (_jc_env *, struct _jc_object *));
	if (z0 != 0) {
		_JC_PERIODIC_CHECK(env);
		goto label1;
	}
	_JC_LINE_NUMBER(98);				// 12
	i0 = i0 + 1;

label5:
	_JC_TRAP_REGION(catch, 2);
	i1 = _JC_ARRAY_LENGTH(env, r12);
	if (i0 < i1) {
		_JC_PERIODIC_CHECK(env);
		goto label0;
	}
	_JC_LINE_NUMBER(129);				// 13
	r9 = _JC_NEW(env, gnu_java_security_provider_SHA1PRNG);
	_JC_INVOKE_NONVIRTUAL(env, gnu_java_security_provider_SHA1PRNG, _init$52f4ad9f2989aeee, 0, r9);
	_JC_REF_FIELD(env, r0, java_security_SecureRandom, secureRandomSpi) = r9;
	_JC_LINE_NUMBER(130);				// 14
	_JC_CANCEL_TRAPS(env, catch);
	return;
}

//
// protected void <init>(java.security.SecureRandomSpi, java.security.Provider)
//

static _jc_linenum _jc_java_security_SecureRandom$linenum_table$_init$af0ea29065ebe876[];

static const unsigned char _jc_java_security_SecureRandom$param_ptypes$_init$af0ea29065ebe876[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_security_SecureRandom$param_types$_init$af0ea29065ebe876[] = {
	&_jc_java_security_SecureRandomSpi$type,
	&_jc_java_security_Provider$type
};

_jc_method _jc_java_security_SecureRandom$method_info$_init$af0ea29065ebe876 = {
	.name=			"<init>",
	.signature=		"(Ljava/security/SecureRandomSpi;Ljava/security/Provider;)V",
	.class=			&_jc_java_security_SecureRandom$type,
	.param_types=		&_jc_java_security_SecureRandom$param_types$_init$af0ea29065ebe876,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_security_SecureRandom$param_ptypes$_init$af0ea29065ebe876,
	.signature_hash=	_JC_JLONG(0xaf0ea29065ebe876),
	.access_flags=		_JC_ACC_PROTECTED,
	.function=		&_jc_java_security_SecureRandom$method$_init$af0ea29065ebe876,
	.num_parameters=	2,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_java_security_SecureRandom$linenum_table$_init$af0ea29065ebe876
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_SecureRandom, _init$af0ea29065ebe876);

void _JC_JCNI_ATTR
_jc_java_security_SecureRandom$method$_init$af0ea29065ebe876(_jc_env *const env, _jc_java_security_SecureRandom$object *this, _jc_java_security_SecureRandomSpi$object *param0, _jc_java_security_Provider$object *param1)
{
	jlong l0;
	struct _jc_java_security_SecureRandom$object *r0;
	struct _jc_java_security_SecureRandomSpi$object *r1;
	struct _jc_java_security_Provider$object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_ACTIVE_USE(env, java_lang_System);
	l0 = _JC_INVOKE_STATIC(env, java_lang_VMSystem, currentTimeMillis$f4fdeb31d00e9185, 0);
	_JC_INVOKE_VIRTUAL(env, java_util_Random, setSeed$b5af8144ceac8f80, r0, l0);
	_JC_PRIM_FIELD(env, r0, java_security_SecureRandom, counter) = _JC_JLONG(0);
	_JC_REF_FIELD(env, r0, java_security_SecureRandom, provider) = _JC_NULL;
	_JC_REF_FIELD(env, r0, java_security_SecureRandom, randomBytes) = _JC_NULL;
	_JC_PRIM_FIELD(env, r0, java_security_SecureRandom, randomBytesUsed) = 0;
	_JC_REF_FIELD(env, r0, java_security_SecureRandom, secureRandomSpi) = _JC_NULL;
	_JC_REF_FIELD(env, r0, java_security_SecureRandom, state) = _JC_NULL;
	_JC_LINE_NUMBER(161);				// 0
	_JC_REF_FIELD(env, r0, java_security_SecureRandom, secureRandomSpi) = r1;
	_JC_LINE_NUMBER(162);				// 1
	_JC_REF_FIELD(env, r0, java_security_SecureRandom, provider) = r2;
	_JC_LINE_NUMBER(163);				// 2
	return;
}

//
// public void <init>(byte[])
//

static _jc_linenum _jc_java_security_SecureRandom$linenum_table$_init$aaa7e255fe505158[];

static const unsigned char _jc_java_security_SecureRandom$param_ptypes$_init$aaa7e255fe505158[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_security_SecureRandom$param_types$_init$aaa7e255fe505158[] = {
	&_jc_byte$array$prim$type
};

_jc_method _jc_java_security_SecureRandom$method_info$_init$aaa7e255fe505158 = {
	.name=			"<init>",
	.signature=		"([B)V",
	.class=			&_jc_java_security_SecureRandom$type,
	.param_types=		&_jc_java_security_SecureRandom$param_types$_init$aaa7e255fe505158,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_security_SecureRandom$param_ptypes$_init$aaa7e255fe505158,
	.signature_hash=	_JC_JLONG(0xaaa7e255fe505158),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_SecureRandom$method$_init$aaa7e255fe505158,
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_java_security_SecureRandom$linenum_table$_init$aaa7e255fe505158
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_SecureRandom, _init$aaa7e255fe505158);

void _JC_JCNI_ATTR
_jc_java_security_SecureRandom$method$_init$aaa7e255fe505158(_jc_env *const env, _jc_java_security_SecureRandom$object *this, _jc_byte_array *param0)
{
	struct _jc_java_security_SecureRandom$object *r0;
	_jc_byte_array *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(147);				// 0
	_JC_INVOKE_NONVIRTUAL(env, java_security_SecureRandom, _init$52f4ad9f2989aeee, 0, r0);
	_JC_LINE_NUMBER(148);				// 1
	_JC_INVOKE_VIRTUAL(env, java_security_SecureRandom, setSeed$22dc2b8de94444ab, r0, r1);
	_JC_LINE_NUMBER(149);				// 2
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public byte[] generateSeed(int)
//

static _jc_linenum _jc_java_security_SecureRandom$linenum_table$generateSeed$dc69bb79b8ceb184[];

static const unsigned char _jc_java_security_SecureRandom$param_ptypes$generateSeed$dc69bb79b8ceb184[] = { 
_JC_TYPE_INT, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_java_security_SecureRandom$param_types$generateSeed$dc69bb79b8ceb184[] = {
	&_jc_int$prim$type
};

_jc_method _jc_java_security_SecureRandom$method_info$generateSeed$dc69bb79b8ceb184 = {
	.name=			"generateSeed",
	.signature=		"(I)[B",
	.class=			&_jc_java_security_SecureRandom$type,
	.param_types=		&_jc_java_security_SecureRandom$param_types$generateSeed$dc69bb79b8ceb184,
	.return_type=		&_jc_byte$array$prim$type,
	.param_ptypes=		&_jc_java_security_SecureRandom$param_ptypes$generateSeed$dc69bb79b8ceb184,
	.signature_hash=	_JC_JLONG(0xdc69bb79b8ceb184),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_SecureRandom$method$generateSeed$dc69bb79b8ceb184,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_SecureRandom$vtable, java_security_SecureRandom.generateSeed$dc69bb79b8ceb184) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_SecureRandom$linenum_table$generateSeed$dc69bb79b8ceb184
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_SecureRandom, generateSeed$dc69bb79b8ceb184);

_jc_byte_array * _JC_JCNI_ATTR
_jc_java_security_SecureRandom$method$generateSeed$dc69bb79b8ceb184(_jc_env *const env, _jc_java_security_SecureRandom$object *this, jint param0)
{
	jint i0;
	struct _jc_java_security_SecureRandom$object *r0;
	struct _jc_java_security_SecureRandomSpi$object *r1;
	_jc_byte_array *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	i0 = param0;
	_JC_LINE_NUMBER(377);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_security_SecureRandom, secureRandomSpi);
	r2 = _JC_INVOKE_VIRTUAL(env, java_security_SecureRandomSpi, engineGenerateSeed$3f2678c95ef54b9d, r1, i0);
	return r2;
}

//
// public final java.security.Provider getProvider()
//

static _jc_linenum _jc_java_security_SecureRandom$linenum_table$getProvider$e8f9c9fb14140d5a[];

static const unsigned char _jc_java_security_SecureRandom$param_ptypes$getProvider$e8f9c9fb14140d5a[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_java_security_SecureRandom$method_info$getProvider$e8f9c9fb14140d5a = {
	.name=			"getProvider",
	.signature=		"()Ljava/security/Provider;",
	.class=			&_jc_java_security_SecureRandom$type,
	.return_type=		&_jc_java_security_Provider$type,
	.param_ptypes=		&_jc_java_security_SecureRandom$param_ptypes$getProvider$e8f9c9fb14140d5a,
	.signature_hash=	_JC_JLONG(0xe8f9c9fb14140d5a),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_security_SecureRandom$method$getProvider$e8f9c9fb14140d5a,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_SecureRandom$vtable, java_security_SecureRandom.getProvider$e8f9c9fb14140d5a) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_SecureRandom$linenum_table$getProvider$e8f9c9fb14140d5a
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_SecureRandom, getProvider$e8f9c9fb14140d5a);

_jc_java_security_Provider$object * _JC_JCNI_ATTR
_jc_java_security_SecureRandom$method$getProvider$e8f9c9fb14140d5a(_jc_env *const env, _jc_java_security_SecureRandom$object *this)
{
	struct _jc_java_security_SecureRandom$object *r0;
	struct _jc_java_security_Provider$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(267);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_security_SecureRandom, provider);
	return r1;
}

//
// protected final int next(int)
//

static _jc_linenum _jc_java_security_SecureRandom$linenum_table$next$e62cd7126ad5e76f[];

static const unsigned char _jc_java_security_SecureRandom$param_ptypes$next$e62cd7126ad5e76f[] = { 
_JC_TYPE_INT, _JC_TYPE_INT };

static _jc_type *const _jc_java_security_SecureRandom$param_types$next$e62cd7126ad5e76f[] = {
	&_jc_int$prim$type
};

_jc_method _jc_java_security_SecureRandom$method_info$next$e62cd7126ad5e76f = {
	.name=			"next",
	.signature=		"(I)I",
	.class=			&_jc_java_security_SecureRandom$type,
	.param_types=		&_jc_java_security_SecureRandom$param_types$next$e62cd7126ad5e76f,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_java_security_SecureRandom$param_ptypes$next$e62cd7126ad5e76f,
	.signature_hash=	_JC_JLONG(0xe62cd7126ad5e76f),
	.access_flags=		_JC_ACC_PROTECTED|_JC_ACC_FINAL,
	.function=		&_jc_java_security_SecureRandom$method$next$e62cd7126ad5e76f,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_SecureRandom$vtable, java_security_SecureRandom.next$e62cd7126ad5e76f) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	12,
	      .table=	_jc_java_security_SecureRandom$linenum_table$next$e62cd7126ad5e76f
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_SecureRandom, next$e62cd7126ad5e76f);

jint _JC_JCNI_ATTR
_jc_java_security_SecureRandom$method$next$e62cd7126ad5e76f(_jc_env *const env, _jc_java_security_SecureRandom$object *this, jint param0)
{
	jbyte b11;
	jint i0;
	jint i1;
	jint i13;
	jint i2;
	jlong l18;
	jlong l9;
	struct _jc_java_security_SecureRandom$object *r0;
	_jc_byte_array *r1;
	struct _jc_java_security_SecureRandomSpi$object *r2;
	jshort s12;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	i0 = param0;
	_JC_LINE_NUMBER(333);				// 0
	if (i0 != 0)
		goto label0;
	_JC_LINE_NUMBER(334);				// 1
	return 0;

label0:
	_JC_LINE_NUMBER(336);				// 2
	i2 = i0 / 8;
	i1 = i0 % 8;
	i2 = i2 + i1;
	r1 = _JC_NEW_PRIM_ARRAY(env, byte, 1, i2);
	_JC_LINE_NUMBER(338);				// 3
	r2 = _JC_REF_FIELD(env, r0, java_security_SecureRandom, secureRandomSpi);
	_JC_INVOKE_VIRTUAL(env, java_security_SecureRandomSpi, engineNextBytes$41b3d85f207b40da, r2, r1);
	_JC_LINE_NUMBER(339);				// 4
	i2 = _JC_PRIM_FIELD(env, r0, java_security_SecureRandom, randomBytesUsed);
	i1 = _JC_ARRAY_LENGTH(env, r1);
	i2 = i2 + i1;
	_JC_PRIM_FIELD(env, r0, java_security_SecureRandom, randomBytesUsed) = i2;
	_JC_LINE_NUMBER(340);				// 5
	l9 = _JC_PRIM_FIELD(env, r0, java_security_SecureRandom, counter);
	l9 = l9 + _JC_JLONG(1);
	_JC_PRIM_FIELD(env, r0, java_security_SecureRandom, counter) = l9;
	_JC_LINE_NUMBER(342);				// 6
	i1 = 0;
	_JC_LINE_NUMBER(344);				// 7
	i2 = 0;
	goto label2;

label1:
	_JC_LINE_NUMBER(345);				// 8
	b11 = _JC_PRIM_ELEMENT(env, byte, r1, i2, 0, 1);
	s12 = b11 & 255;
	i13 = 8 * i2;
	i13 = s12 << (i13 & 0x1f);
	i1 = i1 | i13;
	_JC_LINE_NUMBER(344);				// 9
	i2 = i2 + 1;

label2:
	i13 = _JC_ARRAY_LENGTH(env, r1);
	if (i2 < i13) {
		_JC_PERIODIC_CHECK(env);
		goto label1;
	}
	_JC_LINE_NUMBER(347);				// 10
	l9 = _JC_JLONG(1) << (i0 & 0x3f);
	l9 = l9 - _JC_JLONG(1);
	_JC_LINE_NUMBER(348);				// 11
	l18 = (jlong)i1;
	l18 = l18 & l9;
	i13 = (jint)l18;
	return i13;
}

//
// public void nextBytes(byte[])
//

static _jc_linenum _jc_java_security_SecureRandom$linenum_table$nextBytes$3cf04b354db5197f[];

static const unsigned char _jc_java_security_SecureRandom$param_ptypes$nextBytes$3cf04b354db5197f[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_security_SecureRandom$param_types$nextBytes$3cf04b354db5197f[] = {
	&_jc_byte$array$prim$type
};

_jc_method _jc_java_security_SecureRandom$method_info$nextBytes$3cf04b354db5197f = {
	.name=			"nextBytes",
	.signature=		"([B)V",
	.class=			&_jc_java_security_SecureRandom$type,
	.param_types=		&_jc_java_security_SecureRandom$param_types$nextBytes$3cf04b354db5197f,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_security_SecureRandom$param_ptypes$nextBytes$3cf04b354db5197f,
	.signature_hash=	_JC_JLONG(0x3cf04b354db5197f),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_SecureRandom$method$nextBytes$3cf04b354db5197f,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_SecureRandom$vtable, java_security_SecureRandom.nextBytes$3cf04b354db5197f) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_java_security_SecureRandom$linenum_table$nextBytes$3cf04b354db5197f
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_SecureRandom, nextBytes$3cf04b354db5197f);

void _JC_JCNI_ATTR
_jc_java_security_SecureRandom$method$nextBytes$3cf04b354db5197f(_jc_env *const env, _jc_java_security_SecureRandom$object *this, _jc_byte_array *param0)
{
	jint i0;
	jint i1;
	jlong l3;
	struct _jc_java_security_SecureRandom$object *r0;
	_jc_byte_array *r1;
	struct _jc_java_security_SecureRandomSpi$object *r4;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(317);				// 0
	i0 = _JC_PRIM_FIELD(env, r0, java_security_SecureRandom, randomBytesUsed);
	i1 = _JC_ARRAY_LENGTH(env, r1);
	i1 = i0 + i1;
	_JC_PRIM_FIELD(env, r0, java_security_SecureRandom, randomBytesUsed) = i1;
	_JC_LINE_NUMBER(318);				// 1
	l3 = _JC_PRIM_FIELD(env, r0, java_security_SecureRandom, counter);
	l3 = l3 + _JC_JLONG(1);
	_JC_PRIM_FIELD(env, r0, java_security_SecureRandom, counter) = l3;
	_JC_LINE_NUMBER(319);				// 2
	r4 = _JC_REF_FIELD(env, r0, java_security_SecureRandom, secureRandomSpi);
	_JC_INVOKE_VIRTUAL(env, java_security_SecureRandomSpi, engineNextBytes$41b3d85f207b40da, r4, r1);
	_JC_LINE_NUMBER(320);				// 3
	return;
}

//
// public void setSeed(long)
//

static _jc_linenum _jc_java_security_SecureRandom$linenum_table$setSeed$b5af8144ceac8f80[];

static const unsigned char _jc_java_security_SecureRandom$param_ptypes$setSeed$b5af8144ceac8f80[] = { 
_JC_TYPE_LONG, _JC_TYPE_VOID };

static _jc_type *const _jc_java_security_SecureRandom$param_types$setSeed$b5af8144ceac8f80[] = {
	&_jc_long$prim$type
};

_jc_method _jc_java_security_SecureRandom$method_info$setSeed$b5af8144ceac8f80 = {
	.name=			"setSeed",
	.signature=		"(J)V",
	.class=			&_jc_java_security_SecureRandom$type,
	.param_types=		&_jc_java_security_SecureRandom$param_types$setSeed$b5af8144ceac8f80,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_security_SecureRandom$param_ptypes$setSeed$b5af8144ceac8f80,
	.signature_hash=	_JC_JLONG(0xb5af8144ceac8f80),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_SecureRandom$method$setSeed$b5af8144ceac8f80,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_SecureRandom$vtable, java_security_SecureRandom.setSeed$b5af8144ceac8f80) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_java_security_SecureRandom$linenum_table$setSeed$b5af8144ceac8f80
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_SecureRandom, setSeed$b5af8144ceac8f80);

void _JC_JCNI_ATTR
_jc_java_security_SecureRandom$method$setSeed$b5af8144ceac8f80(_jc_env *const env, _jc_java_security_SecureRandom$object *this, jlong param0)
{
	jbyte b4;
	jint i3;
	jlong l0;
	jlong l1;
	struct _jc_java_security_SecureRandom$object *r0;
	_jc_byte_array *r1;
	struct _jc_java_security_SecureRandomSpi$object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	l0 = param0;
	_JC_LINE_NUMBER(294);				// 0
	r2 = _JC_REF_FIELD(env, r0, java_security_SecureRandom, secureRandomSpi);
	if (r2 == _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(296);				// 1
	r1 = _JC_NEW_PRIM_ARRAY(env, byte, 1, 8);
	l1 = _JC_LSHR(l0, 56);
	l1 = (_JC_JLONG(255)) & l1;
	i3 = (jint)l1;
	b4 = (jbyte)i3;
	_JC_PRIM_ELEMENT(env, byte, r1, 0, 0, 0) = b4;
	l1 = _JC_LSHR(l0, 48);
	l1 = (_JC_JLONG(255)) & l1;
	i3 = (jint)l1;
	b4 = (jbyte)i3;
	_JC_PRIM_ELEMENT(env, byte, r1, 1, 0, 0) = b4;
	l1 = _JC_LSHR(l0, 40);
	l1 = (_JC_JLONG(255)) & l1;
	i3 = (jint)l1;
	b4 = (jbyte)i3;
	_JC_PRIM_ELEMENT(env, byte, r1, 2, 0, 0) = b4;
	l1 = _JC_LSHR(l0, 32);
	l1 = (_JC_JLONG(255)) & l1;
	i3 = (jint)l1;
	b4 = (jbyte)i3;
	_JC_PRIM_ELEMENT(env, byte, r1, 3, 0, 0) = b4;
	l1 = _JC_LSHR(l0, 24);
	l1 = (_JC_JLONG(255)) & l1;
	i3 = (jint)l1;
	b4 = (jbyte)i3;
	_JC_PRIM_ELEMENT(env, byte, r1, 4, 0, 0) = b4;
	l1 = _JC_LSHR(l0, 16);
	l1 = (_JC_JLONG(255)) & l1;
	i3 = (jint)l1;
	b4 = (jbyte)i3;
	_JC_PRIM_ELEMENT(env, byte, r1, 5, 0, 0) = b4;
	l1 = _JC_LSHR(l0, 8);
	l1 = (_JC_JLONG(255)) & l1;
	i3 = (jint)l1;
	b4 = (jbyte)i3;
	_JC_PRIM_ELEMENT(env, byte, r1, 6, 0, 0) = b4;
	l1 = (_JC_JLONG(255)) & l0;
	i3 = (jint)l1;
	b4 = (jbyte)i3;
	_JC_PRIM_ELEMENT(env, byte, r1, 7, 0, 0) = b4;
	_JC_LINE_NUMBER(305);				// 2
	r2 = _JC_REF_FIELD(env, r0, java_security_SecureRandom, secureRandomSpi);
	_JC_INVOKE_VIRTUAL(env, java_security_SecureRandomSpi, engineSetSeed$d5670365ecc71f53, r2, r1);

label0:
	_JC_LINE_NUMBER(307);				// 3
	return;
}

//
// public void setSeed(byte[])
//

static _jc_linenum _jc_java_security_SecureRandom$linenum_table$setSeed$22dc2b8de94444ab[];

static const unsigned char _jc_java_security_SecureRandom$param_ptypes$setSeed$22dc2b8de94444ab[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_security_SecureRandom$param_types$setSeed$22dc2b8de94444ab[] = {
	&_jc_byte$array$prim$type
};

_jc_method _jc_java_security_SecureRandom$method_info$setSeed$22dc2b8de94444ab = {
	.name=			"setSeed",
	.signature=		"([B)V",
	.class=			&_jc_java_security_SecureRandom$type,
	.param_types=		&_jc_java_security_SecureRandom$param_types$setSeed$22dc2b8de94444ab,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_security_SecureRandom$param_ptypes$setSeed$22dc2b8de94444ab,
	.signature_hash=	_JC_JLONG(0x22dc2b8de94444ab),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_SecureRandom$method$setSeed$22dc2b8de94444ab,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_SecureRandom$vtable, java_security_SecureRandom.setSeed$22dc2b8de94444ab) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_security_SecureRandom$linenum_table$setSeed$22dc2b8de94444ab
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_SecureRandom, setSeed$22dc2b8de94444ab);

void _JC_JCNI_ATTR
_jc_java_security_SecureRandom$method$setSeed$22dc2b8de94444ab(_jc_env *const env, _jc_java_security_SecureRandom$object *this, _jc_byte_array *param0)
{
	struct _jc_java_security_SecureRandom$object *r0;
	_jc_byte_array *r1;
	struct _jc_java_security_SecureRandomSpi$object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(278);				// 0
	r2 = _JC_REF_FIELD(env, r0, java_security_SecureRandom, secureRandomSpi);
	_JC_INVOKE_VIRTUAL(env, java_security_SecureRandomSpi, engineSetSeed$d5670365ecc71f53, r2, r1);
	_JC_LINE_NUMBER(279);				// 1
	return;
}

//
// private final void this()
//

static _jc_linenum _jc_java_security_SecureRandom$linenum_table$this$adc93fb6bf4cbffa[];

static const unsigned char _jc_java_security_SecureRandom$param_ptypes$this$adc93fb6bf4cbffa[] = { 
_JC_TYPE_VOID };

_jc_method _jc_java_security_SecureRandom$method_info$this$adc93fb6bf4cbffa = {
	.name=			"this",
	.signature=		"()V",
	.class=			&_jc_java_security_SecureRandom$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_security_SecureRandom$param_ptypes$this$adc93fb6bf4cbffa,
	.signature_hash=	_JC_JLONG(0xadc93fb6bf4cbffa),
	.access_flags=		_JC_ACC_PRIVATE|_JC_ACC_FINAL,
	.function=		&_jc_java_security_SecureRandom$method$this$adc93fb6bf4cbffa,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_SecureRandom$vtable, java_security_SecureRandom.this$adc93fb6bf4cbffa) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	6,
	      .table=	_jc_java_security_SecureRandom$linenum_table$this$adc93fb6bf4cbffa
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_SecureRandom, this$adc93fb6bf4cbffa);

void _JC_JCNI_ATTR
_jc_java_security_SecureRandom$method$this$adc93fb6bf4cbffa(_jc_env *const env, _jc_java_security_SecureRandom$object *this)
{
	struct _jc_java_security_SecureRandom$object *r0;

	r0 = this;
	_JC_LINE_NUMBER(67);				// 0
	_JC_PRIM_FIELD(env, r0, java_security_SecureRandom, counter) = _JC_JLONG(0);
	_JC_LINE_NUMBER(68);				// 1
	_JC_REF_FIELD(env, r0, java_security_SecureRandom, provider) = _JC_NULL;
	_JC_LINE_NUMBER(69);				// 2
	_JC_REF_FIELD(env, r0, java_security_SecureRandom, randomBytes) = _JC_NULL;
	_JC_LINE_NUMBER(70);				// 3
	_JC_PRIM_FIELD(env, r0, java_security_SecureRandom, randomBytesUsed) = 0;
	_JC_LINE_NUMBER(71);				// 4
	_JC_REF_FIELD(env, r0, java_security_SecureRandom, secureRandomSpi) = _JC_NULL;
	_JC_LINE_NUMBER(72);				// 5
	_JC_REF_FIELD(env, r0, java_security_SecureRandom, state) = _JC_NULL;
	return;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_java_security_SecureRandom$methods[] = {
	&_jc_java_security_SecureRandom$method_info$_init$52f4ad9f2989aeee,
	&_jc_java_security_SecureRandom$method_info$_init$af0ea29065ebe876,
	&_jc_java_security_SecureRandom$method_info$_init$aaa7e255fe505158,
	&_jc_java_security_SecureRandom$method_info$generateSeed$dc69bb79b8ceb184,
	&_jc_java_security_SecureRandom$method_info$getInstance$452ab8480dcd4a6f,
	&_jc_java_security_SecureRandom$method_info$getInstance$3fb2849395b17e05,
	&_jc_java_security_SecureRandom$method_info$getInstance$9f36f264f766453b,
	&_jc_java_security_SecureRandom$method_info$getProvider$e8f9c9fb14140d5a,
	&_jc_java_security_SecureRandom$method_info$getSeed$868ee6f6964ba0ce,
	&_jc_java_security_SecureRandom$method_info$next$e62cd7126ad5e76f,
	&_jc_java_security_SecureRandom$method_info$nextBytes$3cf04b354db5197f,
	&_jc_java_security_SecureRandom$method_info$setSeed$b5af8144ceac8f80,
	&_jc_java_security_SecureRandom$method_info$setSeed$22dc2b8de94444ab,
	&_jc_java_security_SecureRandom$method_info$this$adc93fb6bf4cbffa
};

/************************************************************************
 *			  Class fields structure			*
 ************************************************************************/

_jc_java_security_SecureRandom$fields_struct _jc_java_security_SecureRandom$class_fields = { };

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_java_security_SecureRandom$instanceof_hash_bucket_43[] = {
	&_jc_java_util_Random$type,
	_JC_NULL
};
static _jc_type *const _jc_java_security_SecureRandom$instanceof_hash_bucket_65[] = {
	&_jc_java_io_Serializable$type,
	_JC_NULL
};
static _jc_type *const _jc_java_security_SecureRandom$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};
static _jc_type *const _jc_java_security_SecureRandom$instanceof_hash_bucket_109[] = {
	&_jc_java_security_SecureRandom$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_java_security_SecureRandom$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[43]=	_jc_java_security_SecureRandom$instanceof_hash_bucket_43,
	[65]=	_jc_java_security_SecureRandom$instanceof_hash_bucket_65,
	[101]=	_jc_java_security_SecureRandom$instanceof_hash_bucket_101,
	[109]=	_jc_java_security_SecureRandom$instanceof_hash_bucket_109
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_java_security_SecureRandom$class_depends[] = {
	{ "gnu/java/security/Engine",	_JC_JLONG(0xf4ba095546954b36) },
	{ "gnu/java/security/provider/SHA1PRNG",	_JC_JLONG(0x74cf6a4caac8d5c3) },
	{ "java/io/Serializable",	_JC_JLONG(0x9a35c7173b37e641) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/ClassCastException",	_JC_JLONG(0xf02ab3ccb490a6d0) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/IllegalArgumentException",	_JC_JLONG(0x680cf34d05feb5a1) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/RuntimeException",	_JC_JLONG(0x4f5534a987354d1d) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/System",	_JC_JLONG(0x53cc8e2333795f04) },
	{ "java/lang/ThreadDeath",	_JC_JLONG(0xfe7096144692ae30) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMSystem",	_JC_JLONG(0x4d1cebae0bdda058) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/lang/reflect/InvocationTargetException",	_JC_JLONG(0xae4a2342b31a268d) },
	{ "java/security/GeneralSecurityException",	_JC_JLONG(0x692089051f4c8d0b) },
	{ "java/security/NoSuchAlgorithmException",	_JC_JLONG(0x22e937c2536160b4) },
	{ "java/security/NoSuchProviderException",	_JC_JLONG(0x8dfbf242adab91e) },
	{ "java/security/Provider",	_JC_JLONG(0x81b073051aa30acc) },
	{ "java/security/SecureRandomSpi",	_JC_JLONG(0x254ca156f086a0ef) },
	{ "java/security/Security",	_JC_JLONG(0x89bf77984bd9669e) },
	{ "java/util/Enumeration",	_JC_JLONG(0xc56a8b1934689c38) },
	{ "java/util/Properties",	_JC_JLONG(0x884c3edb343dfb63) },
	{ "java/util/Random",	_JC_JLONG(0x61639c1affc91eab) },
	{ "java/util/Vector",	_JC_JLONG(0xc53e1575b095109b) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_java_security_SecureRandom$vtype _jc_java_security_SecureRandom$type = {
    .type= {
	.name=			"java/security/SecureRandom",
	.superclass=		&_jc_java_util_Random$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		28,
		.hash=			_JC_JLONG(0x15c6a62b25a6e96d),
		.source_file=		"SecureRandom.java",
		.instance_size=		sizeof(_jc_java_security_SecureRandom$refs) + sizeof(_jc_java_security_SecureRandom$object),
		.num_virtual_refs=	4,
		.num_fields=		sizeof(_jc_java_security_SecureRandom$fields) / sizeof(*_jc_java_security_SecureRandom$fields),
		.fields=		_jc_java_security_SecureRandom$fields,
		.num_methods=		sizeof(_jc_java_security_SecureRandom$methods) / sizeof(*_jc_java_security_SecureRandom$methods),
		.methods=		_jc_java_security_SecureRandom$methods,
		.instanceof_hash_table=	_jc_java_security_SecureRandom$instanceof_hash_table,
		.class_fields=		&_jc_java_security_SecureRandom$class_fields,
		.num_class_depends=		sizeof(_jc_java_security_SecureRandom$class_depends) / sizeof(*_jc_java_security_SecureRandom$class_depends),
		.class_depends=		_jc_java_security_SecureRandom$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.java_util_Random= {
	    .next$e62cd7126ad5e76f=				// overridden
		&_jc_java_security_SecureRandom$method$next$e62cd7126ad5e76f,
	    .nextBoolean$1e0a1a70735f7d76=
		&_jc_java_util_Random$method$nextBoolean$1e0a1a70735f7d76,
	    .nextBytes$3cf04b354db5197f=			// overridden
		&_jc_java_security_SecureRandom$method$nextBytes$3cf04b354db5197f,
	    .nextDouble$a3543f18bbe8890a=
		&_jc_java_util_Random$method$nextDouble$a3543f18bbe8890a,
	    .nextFloat$cb52ca2e4a189fab=
		&_jc_java_util_Random$method$nextFloat$cb52ca2e4a189fab,
	    .nextGaussian$2bddf9e41cbc469b=
		&_jc_java_util_Random$method$nextGaussian$2bddf9e41cbc469b,
	    .nextInt$f055752e41a32135=
		&_jc_java_util_Random$method$nextInt$f055752e41a32135,
	    .nextInt$1186d78a0d84626f=
		&_jc_java_util_Random$method$nextInt$1186d78a0d84626f,
	    .nextLong$90bccad4bfdb1461=
		&_jc_java_util_Random$method$nextLong$90bccad4bfdb1461,
	    .setSeed$b5af8144ceac8f80=			// overridden
		&_jc_java_security_SecureRandom$method$setSeed$b5af8144ceac8f80,
	},
	.java_security_SecureRandom= {
	    .generateSeed$dc69bb79b8ceb184=
		&_jc_java_security_SecureRandom$method$generateSeed$dc69bb79b8ceb184,
	    .getProvider$e8f9c9fb14140d5a=
		&_jc_java_security_SecureRandom$method$getProvider$e8f9c9fb14140d5a,
	    .next$e62cd7126ad5e76f=
		&_jc_java_security_SecureRandom$method$next$e62cd7126ad5e76f,
	    .nextBytes$3cf04b354db5197f=
		&_jc_java_security_SecureRandom$method$nextBytes$3cf04b354db5197f,
	    .setSeed$b5af8144ceac8f80=
		&_jc_java_security_SecureRandom$method$setSeed$b5af8144ceac8f80,
	    .setSeed$22dc2b8de94444ab=
		&_jc_java_security_SecureRandom$method$setSeed$22dc2b8de94444ab,
	    .this$adc93fb6bf4cbffa=
		&_jc_java_security_SecureRandom$method$this$adc93fb6bf4cbffa,
	},
    }
};

