// public class java.security.cert.PKIXParameters

// class file dependencies
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class 9b667b09132be893 java_lang_Cloneable
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class 505b8a9a6675be0 java_lang_NullPointerException
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class 4f5534a987354d1d java_lang_RuntimeException
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 94d357637b968dda java_lang_StringBuffer
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class 692089051f4c8d0b java_security_GeneralSecurityException
// @dep_class 327edce29f2562dd java_security_InvalidAlgorithmParameterException
// @dep_class 1f56d8b14978c9d6 java_security_KeyStore
// @dep_class 45b488528f32667c java_security_KeyStoreException
// @dep_class 4760c3113311a807 java_security_KeyStoreSpi
// @dep_class f132f959389432b2 java_security_cert_CertPathParameters
// @dep_class c7e244007d8c33f7 java_security_cert_CertSelector
// @dep_class 3c280e99213305ba java_security_cert_CertStore
// @dep_class c98c8192da849b07 java_security_cert_Certificate
// @dep_class b976c651cf009c14 java_security_cert_PKIXCertPathChecker
// @dep_class a8772e192e80ffa9 java_security_cert_PKIXParameters
// @dep_class a32f58fba5216297 java_security_cert_TrustAnchor
// @dep_class 859e5e5544e5909f java_security_cert_X509Certificate
// @dep_class 8ea716c64b77f8eb java_util_AbstractCollection
// @dep_class f5238436362828db java_util_AbstractList
// @dep_class 6d7997e879c41059 java_util_AbstractSequentialList
// @dep_class ca427569b5b2f804 java_util_AbstractSet
// @dep_class 9574af3fed58029a java_util_Collections
// @dep_class 2126b28aee607999 java_util_Collections__24UnmodifiableCollection
// @dep_class f6337dee44795dd7 java_util_Collections__24UnmodifiableList
// @dep_class 85abf76c7de1ef57 java_util_Collections__24UnmodifiableRandomAccessList
// @dep_class aec2ea3fc69f0e47 java_util_Collections__24UnmodifiableSet
// @dep_class a85d2a51094e614c java_util_Date
// @dep_class c56a8b1934689c38 java_util_Enumeration
// @dep_class d7cd853200c3e71f java_util_HashMap
// @dep_class 3c285c721478414d java_util_HashSet
// @dep_class be56ff673eefd9d2 java_util_Iterator
// @dep_class 666417b6279ae396 java_util_LinkedList
// @dep_class 9ee0d92ce1525a4d java_util_List
// @dep_class 621ddac3c69143cd java_util_RandomAccess
// @dep_class 617ac82c0bec2dff java_util_Set

// header file dependencies
// @dep_header java_lang_Class
// @dep_header java_lang_Cloneable
// @dep_header java_lang_NullPointerException
// @dep_header java_lang_String
// @dep_header java_lang_StringBuffer
// @dep_header java_lang_VMThrowable
// @dep_header java_security_InvalidAlgorithmParameterException
// @dep_header java_security_KeyStore
// @dep_header java_security_KeyStoreException
// @dep_header java_security_KeyStoreSpi
// @dep_header java_security_cert_CertPathParameters
// @dep_header java_security_cert_CertSelector
// @dep_header java_security_cert_CertStore
// @dep_header java_security_cert_PKIXCertPathChecker
// @dep_header java_security_cert_PKIXParameters
// @dep_header java_security_cert_TrustAnchor
// @dep_header java_security_cert_X509Certificate
// @dep_header java_util_Collections
// @dep_header java_util_Collections__24UnmodifiableRandomAccessList
// @dep_header java_util_Collections__24UnmodifiableSet
// @dep_header java_util_Date
// @dep_header java_util_Enumeration
// @dep_header java_util_HashMap
// @dep_header java_util_HashSet
// @dep_header java_util_Iterator
// @dep_header java_util_LinkedList
// @dep_header java_util_List
// @dep_header java_util_RandomAccess
// @dep_header java_util_Set

#include "jc_defs.h"

#include "java/lang/Class.h"
#include "java/lang/Cloneable.h"
#include "java/lang/NullPointerException.h"
#include "java/lang/String.h"
#include "java/lang/StringBuffer.h"
#include "java/lang/VMThrowable.h"
#include "java/security/InvalidAlgorithmParameterException.h"
#include "java/security/KeyStore.h"
#include "java/security/KeyStoreException.h"
#include "java/security/KeyStoreSpi.h"
#include "java/security/cert/CertPathParameters.h"
#include "java/security/cert/CertSelector.h"
#include "java/security/cert/CertStore.h"
#include "java/security/cert/PKIXCertPathChecker.h"
#include "java/security/cert/PKIXParameters.h"
#include "java/security/cert/TrustAnchor.h"
#include "java/security/cert/X509Certificate.h"
#include "java/util/Collections.h"
#include "java/util/Collections__24UnmodifiableRandomAccessList.h"
#include "java/util/Collections__24UnmodifiableSet.h"
#include "java/util/Date.h"
#include "java/util/Enumeration.h"
#include "java/util/HashMap.h"
#include "java/util/HashSet.h"
#include "java/util/Iterator.h"
#include "java/util/LinkedList.h"
#include "java/util/List.h"
#include "java/util/RandomAccess.h"
#include "java/util/Set.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// private final java.util.Set trustAnchors
static _jc_field _jc_java_security_cert_PKIXParameters$field_info$trustAnchors = {
	.name=		"trustAnchors",
	.signature=	"Ljava/util/Set;",
	.class=		&_jc_java_security_cert_PKIXParameters$type,
	.type=		&_jc_java_util_Set$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_java_security_cert_PKIXParameters$object, refs[-1].java_security_cert_PKIXParameters.trustAnchors),
};

// private final java.util.Set initPolicies
static _jc_field _jc_java_security_cert_PKIXParameters$field_info$initPolicies = {
	.name=		"initPolicies",
	.signature=	"Ljava/util/Set;",
	.class=		&_jc_java_security_cert_PKIXParameters$type,
	.type=		&_jc_java_util_Set$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_java_security_cert_PKIXParameters$object, refs[-1].java_security_cert_PKIXParameters.initPolicies),
};

// private final java.util.List certStores
static _jc_field _jc_java_security_cert_PKIXParameters$field_info$certStores = {
	.name=		"certStores",
	.signature=	"Ljava/util/List;",
	.class=		&_jc_java_security_cert_PKIXParameters$type,
	.type=		&_jc_java_util_List$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_java_security_cert_PKIXParameters$object, refs[-1].java_security_cert_PKIXParameters.certStores),
};

// private final java.util.List pathCheckers
static _jc_field _jc_java_security_cert_PKIXParameters$field_info$pathCheckers = {
	.name=		"pathCheckers",
	.signature=	"Ljava/util/List;",
	.class=		&_jc_java_security_cert_PKIXParameters$type,
	.type=		&_jc_java_util_List$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_java_security_cert_PKIXParameters$object, refs[-1].java_security_cert_PKIXParameters.pathCheckers),
};

// private boolean revocationEnabled
static _jc_field _jc_java_security_cert_PKIXParameters$field_info$revocationEnabled = {
	.name=		"revocationEnabled",
	.signature=	"Z",
	.class=		&_jc_java_security_cert_PKIXParameters$type,
	.type=		&_jc_boolean$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_security_cert_PKIXParameters$object, nonrefs.java_security_cert_PKIXParameters.revocationEnabled),
};

// private boolean exPolicyRequired
static _jc_field _jc_java_security_cert_PKIXParameters$field_info$exPolicyRequired = {
	.name=		"exPolicyRequired",
	.signature=	"Z",
	.class=		&_jc_java_security_cert_PKIXParameters$type,
	.type=		&_jc_boolean$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_security_cert_PKIXParameters$object, nonrefs.java_security_cert_PKIXParameters.exPolicyRequired),
};

// private boolean policyMappingInhibited
static _jc_field _jc_java_security_cert_PKIXParameters$field_info$policyMappingInhibited = {
	.name=		"policyMappingInhibited",
	.signature=	"Z",
	.class=		&_jc_java_security_cert_PKIXParameters$type,
	.type=		&_jc_boolean$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_security_cert_PKIXParameters$object, nonrefs.java_security_cert_PKIXParameters.policyMappingInhibited),
};

// private boolean anyPolicyInhibited
static _jc_field _jc_java_security_cert_PKIXParameters$field_info$anyPolicyInhibited = {
	.name=		"anyPolicyInhibited",
	.signature=	"Z",
	.class=		&_jc_java_security_cert_PKIXParameters$type,
	.type=		&_jc_boolean$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_security_cert_PKIXParameters$object, nonrefs.java_security_cert_PKIXParameters.anyPolicyInhibited),
};

// private boolean policyQualRejected
static _jc_field _jc_java_security_cert_PKIXParameters$field_info$policyQualRejected = {
	.name=		"policyQualRejected",
	.signature=	"Z",
	.class=		&_jc_java_security_cert_PKIXParameters$type,
	.type=		&_jc_boolean$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_security_cert_PKIXParameters$object, nonrefs.java_security_cert_PKIXParameters.policyQualRejected),
};

// private java.util.Date date
static _jc_field _jc_java_security_cert_PKIXParameters$field_info$date = {
	.name=		"date",
	.signature=	"Ljava/util/Date;",
	.class=		&_jc_java_security_cert_PKIXParameters$type,
	.type=		&_jc_java_util_Date$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_security_cert_PKIXParameters$object, refs[-1].java_security_cert_PKIXParameters.date),
};

// private java.lang.String sigProvider
static _jc_field _jc_java_security_cert_PKIXParameters$field_info$sigProvider = {
	.name=		"sigProvider",
	.signature=	"Ljava/lang/String;",
	.class=		&_jc_java_security_cert_PKIXParameters$type,
	.type=		&_jc_java_lang_String$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_security_cert_PKIXParameters$object, refs[-1].java_security_cert_PKIXParameters.sigProvider),
};

// private java.security.cert.CertSelector targetConstraints
static _jc_field _jc_java_security_cert_PKIXParameters$field_info$targetConstraints = {
	.name=		"targetConstraints",
	.signature=	"Ljava/security/cert/CertSelector;",
	.class=		&_jc_java_security_cert_PKIXParameters$type,
	.type=		&_jc_java_security_cert_CertSelector$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_security_cert_PKIXParameters$object, refs[-1].java_security_cert_PKIXParameters.targetConstraints),
};

// Fields
static _jc_field *const _jc_java_security_cert_PKIXParameters$fields[] = {
	&_jc_java_security_cert_PKIXParameters$field_info$certStores,
	&_jc_java_security_cert_PKIXParameters$field_info$date,
	&_jc_java_security_cert_PKIXParameters$field_info$initPolicies,
	&_jc_java_security_cert_PKIXParameters$field_info$pathCheckers,
	&_jc_java_security_cert_PKIXParameters$field_info$sigProvider,
	&_jc_java_security_cert_PKIXParameters$field_info$targetConstraints,
	&_jc_java_security_cert_PKIXParameters$field_info$trustAnchors,
	&_jc_java_security_cert_PKIXParameters$field_info$anyPolicyInhibited,
	&_jc_java_security_cert_PKIXParameters$field_info$exPolicyRequired,
	&_jc_java_security_cert_PKIXParameters$field_info$policyMappingInhibited,
	&_jc_java_security_cert_PKIXParameters$field_info$policyQualRejected,
	&_jc_java_security_cert_PKIXParameters$field_info$revocationEnabled
};

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// private void <init>()
//

static _jc_linenum _jc_java_security_cert_PKIXParameters$linenum_table$_init$52f4ad9f2989aeee[];

static const unsigned char _jc_java_security_cert_PKIXParameters$param_ptypes$_init$52f4ad9f2989aeee[] = { 
_JC_TYPE_VOID };

_jc_method _jc_java_security_cert_PKIXParameters$method_info$_init$52f4ad9f2989aeee = {
	.name=			"<init>",
	.signature=		"()V",
	.class=			&_jc_java_security_cert_PKIXParameters$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_security_cert_PKIXParameters$param_ptypes$_init$52f4ad9f2989aeee,
	.signature_hash=	_JC_JLONG(0x52f4ad9f2989aeee),
	.access_flags=		_JC_ACC_PRIVATE,
	.function=		&_jc_java_security_cert_PKIXParameters$method$_init$52f4ad9f2989aeee,
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	10,
	      .table=	_jc_java_security_cert_PKIXParameters$linenum_table$_init$52f4ad9f2989aeee
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_cert_PKIXParameters, _init$52f4ad9f2989aeee);

void _JC_JCNI_ATTR
_jc_java_security_cert_PKIXParameters$method$_init$52f4ad9f2989aeee(_jc_env *const env, _jc_java_security_cert_PKIXParameters$object *this)
{
	struct _jc_java_security_cert_PKIXParameters$object *r0;
	struct _jc_java_util_HashSet$object *r1;
	struct _jc_java_util_LinkedList$object *r2;
	struct _jc_java_util_HashMap$object *r3;
	struct _jc_java_util_HashMap$object *r6;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(159);				// 0
	r1 = _JC_NEW(env, java_util_HashSet);
	r3 = _JC_NEW(env, java_util_HashMap);
	_JC_INVOKE_NONVIRTUAL(env, java_util_HashMap, _init$7cb044ce4fb0ada8, 0, r3, 11, _JC_FCONST(0x3f, 0x40, 0x0, 0x0));
	_JC_REF_FIELD(env, r1, java_util_HashSet, map) = r3;
	_JC_REF_FIELD(env, r0, java_security_cert_PKIXParameters, trustAnchors) = r1;
	_JC_LINE_NUMBER(160);				// 1
	r1 = _JC_NEW(env, java_util_HashSet);
	r6 = _JC_NEW(env, java_util_HashMap);
	_JC_INVOKE_NONVIRTUAL(env, java_util_HashMap, _init$7cb044ce4fb0ada8, 0, r6, 11, _JC_FCONST(0x3f, 0x40, 0x0, 0x0));
	_JC_REF_FIELD(env, r1, java_util_HashSet, map) = r6;
	_JC_REF_FIELD(env, r0, java_security_cert_PKIXParameters, initPolicies) = r1;
	_JC_LINE_NUMBER(161);				// 2
	r2 = _JC_NEW(env, java_util_LinkedList);
	_JC_PRIM_FIELD(env, r2, java_util_LinkedList, size) = 0;
	_JC_REF_FIELD(env, r0, java_security_cert_PKIXParameters, certStores) = r2;
	_JC_LINE_NUMBER(162);				// 3
	r2 = _JC_NEW(env, java_util_LinkedList);
	_JC_PRIM_FIELD(env, r2, java_util_LinkedList, size) = 0;
	_JC_REF_FIELD(env, r0, java_security_cert_PKIXParameters, pathCheckers) = r2;
	_JC_LINE_NUMBER(163);				// 4
	_JC_PRIM_FIELD(env, r0, java_security_cert_PKIXParameters, revocationEnabled) = 1;
	_JC_LINE_NUMBER(164);				// 5
	_JC_PRIM_FIELD(env, r0, java_security_cert_PKIXParameters, exPolicyRequired) = 0;
	_JC_LINE_NUMBER(165);				// 6
	_JC_PRIM_FIELD(env, r0, java_security_cert_PKIXParameters, policyMappingInhibited) = 0;
	_JC_LINE_NUMBER(166);				// 7
	_JC_PRIM_FIELD(env, r0, java_security_cert_PKIXParameters, anyPolicyInhibited) = 0;
	_JC_LINE_NUMBER(167);				// 8
	_JC_PRIM_FIELD(env, r0, java_security_cert_PKIXParameters, policyQualRejected) = 1;
	_JC_LINE_NUMBER(168);				// 9
	return;
}

//
// public void <init>(java.security.KeyStore) throws java.security.KeyStoreException, java.security.InvalidAlgorithmParameterException
//

static _jc_linenum _jc_java_security_cert_PKIXParameters$linenum_table$_init$73a6863676402bf4[];

static const unsigned char _jc_java_security_cert_PKIXParameters$param_ptypes$_init$73a6863676402bf4[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_security_cert_PKIXParameters$exceptions$_init$73a6863676402bf4[] = {
	&_jc_java_security_KeyStoreException$type,
	&_jc_java_security_InvalidAlgorithmParameterException$type
};

static _jc_type *const _jc_java_security_cert_PKIXParameters$param_types$_init$73a6863676402bf4[] = {
	&_jc_java_security_KeyStore$type
};

_jc_method _jc_java_security_cert_PKIXParameters$method_info$_init$73a6863676402bf4 = {
	.name=			"<init>",
	.signature=		"(Ljava/security/KeyStore;)V",
	.class=			&_jc_java_security_cert_PKIXParameters$type,
	.param_types=		&_jc_java_security_cert_PKIXParameters$param_types$_init$73a6863676402bf4,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_security_cert_PKIXParameters$param_ptypes$_init$73a6863676402bf4,
	.signature_hash=	_JC_JLONG(0x73a6863676402bf4),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_cert_PKIXParameters$method$_init$73a6863676402bf4,
	.num_parameters=	1,
	.num_exceptions=	2,
	.exceptions=		&_jc_java_security_cert_PKIXParameters$exceptions$_init$73a6863676402bf4,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	11,
	      .table=	_jc_java_security_cert_PKIXParameters$linenum_table$_init$73a6863676402bf4
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_cert_PKIXParameters, _init$73a6863676402bf4);

void _JC_JCNI_ATTR
_jc_java_security_cert_PKIXParameters$method$_init$73a6863676402bf4(_jc_env *const env, _jc_java_security_cert_PKIXParameters$object *this, _jc_java_security_KeyStore$object *param0)
{
	struct _jc_java_security_cert_PKIXParameters$object *r0;
	struct _jc_java_security_KeyStore$object *r1;
	struct _jc_object *r10;
	struct _jc_java_security_KeyStoreSpi$object *r11;
	struct _jc_java_security_KeyStoreSpi$object *r12;
	struct _jc_java_security_cert_Certificate$object *r13;
	struct _jc_java_lang_VMThrowable$object *r15;
	struct _jc_java_lang_String$object *r2;
	struct _jc_java_lang_Object$object *r3;
	struct _jc_object *r4;
	struct _jc_java_security_cert_TrustAnchor$object *r5;
	struct _jc_java_security_cert_X509Certificate$object *r6;
	struct _jc_java_security_InvalidAlgorithmParameterException$object *r7;
	struct _jc_java_lang_String$object *r8;
	struct _jc_java_security_KeyStoreSpi$object *r9;
	jboolean z0;
	jboolean z1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(121);				// 0
	_JC_INVOKE_NONVIRTUAL(env, java_security_cert_PKIXParameters, _init$52f4ad9f2989aeee, 0, r0);
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	r9 = _JC_REF_FIELD(env, r1, java_security_KeyStore, keyStoreSpi);
	r10 = _JC_INVOKE_VIRTUAL(env, java_security_KeyStoreSpi, engineAliases$0955230ea2712d95, r9);
	_JC_LINE_NUMBER(122);				// 1
	goto label2;

label0:
	_JC_LINE_NUMBER(124);				// 2
	r3 = _JC_INVOKE_INTERFACE(env, r10, _JC_JLONG(0x9b7c3789fa3ba818), _jc_object *, (_jc_env *, struct _jc_object *));
	r2 = _JC_CAST_FINAL(env, &_jc_java_lang_String$type, r3);
	r11 = _JC_REF_FIELD(env, r1, java_security_KeyStore, keyStoreSpi);
	z1 = _JC_INVOKE_VIRTUAL(env, java_security_KeyStoreSpi, engineIsCertificateEntry$bb05da0b90387721, r11, r2);
	_JC_LINE_NUMBER(125);				// 3
	if (z1 != 0)
		goto label1;
	_JC_LINE_NUMBER(126);				// 4
	goto label2;

label1:
	r12 = _JC_REF_FIELD(env, r1, java_security_KeyStore, keyStoreSpi);
	r13 = _JC_INVOKE_VIRTUAL(env, java_security_KeyStoreSpi, engineGetCertificate$3326089db6ae391c, r12, r2);
	_JC_LINE_NUMBER(128);				// 5
	z0 = _JC_INSTANCEOF(env, r13, &_jc_java_security_cert_X509Certificate$type);
	if (z0 == 0)
		goto label2;
	_JC_LINE_NUMBER(129);				// 6
	r4 = _JC_REF_FIELD(env, r0, java_security_cert_PKIXParameters, trustAnchors);
	r5 = _JC_NEW(env, java_security_cert_TrustAnchor);
	r6 = r13;
	_JC_INVOKE_NONVIRTUAL(env, java_security_cert_TrustAnchor, _init$919e41fe54aa1eea, 0, r5, r6, _JC_NULL);
	_JC_INVOKE_INTERFACE(env, r4, _JC_JLONG(0x831f06ee5f59c0cc), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r5);

label2:
	_JC_LINE_NUMBER(122);				// 7
	z0 = _JC_INVOKE_INTERFACE(env, r10, _JC_JLONG(0x95fbe58f36adadb0), jboolean, (_jc_env *, struct _jc_object *));
	if (z0 != 0) {
		_JC_PERIODIC_CHECK(env);
		goto label0;
	}
	_JC_LINE_NUMBER(131);				// 8
	r4 = _JC_REF_FIELD(env, r0, java_security_cert_PKIXParameters, trustAnchors);
	z0 = _JC_INVOKE_INTERFACE(env, r4, _JC_JLONG(0x551bea84f4e0f0cb), jboolean, (_jc_env *, struct _jc_object *));
	if (z0 == 0)
		goto label3;
	_JC_LINE_NUMBER(132);				// 9
	r7 = _JC_NEW(env, java_security_InvalidAlgorithmParameterException);
	r8 = _JC_STRING(env, "no certs in the key store");
	_JC_REF_FIELD(env, r7, java_lang_Throwable, cause) = r7;
	r15 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r7);
	_JC_REF_FIELD(env, r7, java_lang_Throwable, vmState) = r15;
	_JC_REF_FIELD(env, r7, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r7, java_lang_Throwable, detailMessage) = r8;
	_JC_THROW(env, r7);

label3:
	_JC_LINE_NUMBER(133);				// 10
	return;
}

//
// private void <init>(java.security.cert.PKIXParameters)
//

static _jc_linenum _jc_java_security_cert_PKIXParameters$linenum_table$_init$26736bbd04ff3ca1[];

static const unsigned char _jc_java_security_cert_PKIXParameters$param_ptypes$_init$26736bbd04ff3ca1[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_security_cert_PKIXParameters$param_types$_init$26736bbd04ff3ca1[] = {
	&_jc_java_security_cert_PKIXParameters$type
};

_jc_method _jc_java_security_cert_PKIXParameters$method_info$_init$26736bbd04ff3ca1 = {
	.name=			"<init>",
	.signature=		"(Ljava/security/cert/PKIXParameters;)V",
	.class=			&_jc_java_security_cert_PKIXParameters$type,
	.param_types=		&_jc_java_security_cert_PKIXParameters$param_types$_init$26736bbd04ff3ca1,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_security_cert_PKIXParameters$param_ptypes$_init$26736bbd04ff3ca1,
	.signature_hash=	_JC_JLONG(0x26736bbd04ff3ca1),
	.access_flags=		_JC_ACC_PRIVATE,
	.function=		&_jc_java_security_cert_PKIXParameters$method$_init$26736bbd04ff3ca1,
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	14,
	      .table=	_jc_java_security_cert_PKIXParameters$linenum_table$_init$26736bbd04ff3ca1
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_cert_PKIXParameters, _init$26736bbd04ff3ca1);

void _JC_JCNI_ATTR
_jc_java_security_cert_PKIXParameters$method$_init$26736bbd04ff3ca1(_jc_env *const env, _jc_java_security_cert_PKIXParameters$object *this, _jc_java_security_cert_PKIXParameters$object *param0)
{
	struct _jc_java_security_cert_PKIXParameters$object *r0;
	struct _jc_java_security_cert_PKIXParameters$object *r1;
	struct _jc_java_util_Date$object *r10;
	struct _jc_java_lang_String$object *r11;
	struct _jc_object *r13;
	struct _jc_java_lang_Object$object *r15;
	struct _jc_object *r2;
	struct _jc_object *r3;
	struct _jc_object *r6;
	struct _jc_object *r7;
	jboolean z4;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(177);				// 0
	_JC_INVOKE_NONVIRTUAL(env, java_security_cert_PKIXParameters, _init$52f4ad9f2989aeee, 0, r0);
	_JC_LINE_NUMBER(178);				// 1
	r2 = _JC_REF_FIELD(env, r0, java_security_cert_PKIXParameters, trustAnchors);
	r3 = _JC_REF_FIELD(env, r1, java_security_cert_PKIXParameters, trustAnchors);
	_JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0x77406cdf3002027f), jboolean, (_jc_env *, struct _jc_object *, struct _jc_object *), r3);
	_JC_LINE_NUMBER(179);				// 2
	r3 = _JC_REF_FIELD(env, r0, java_security_cert_PKIXParameters, initPolicies);
	r2 = _JC_REF_FIELD(env, r1, java_security_cert_PKIXParameters, initPolicies);
	_JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0x77406cdf3002027f), jboolean, (_jc_env *, struct _jc_object *, struct _jc_object *), r2);
	_JC_LINE_NUMBER(180);				// 3
	r6 = _JC_REF_FIELD(env, r0, java_security_cert_PKIXParameters, certStores);
	r7 = _JC_REF_FIELD(env, r1, java_security_cert_PKIXParameters, certStores);
	_JC_INVOKE_INTERFACE(env, r6, _JC_JLONG(0x77406cdf3002027f), jboolean, (_jc_env *, struct _jc_object *, struct _jc_object *), r7);
	_JC_LINE_NUMBER(181);				// 4
	r7 = _JC_REF_FIELD(env, r0, java_security_cert_PKIXParameters, pathCheckers);
	r6 = _JC_REF_FIELD(env, r1, java_security_cert_PKIXParameters, pathCheckers);
	_JC_INVOKE_INTERFACE(env, r7, _JC_JLONG(0x77406cdf3002027f), jboolean, (_jc_env *, struct _jc_object *, struct _jc_object *), r6);
	_JC_LINE_NUMBER(182);				// 5
	z4 = _JC_PRIM_FIELD(env, r1, java_security_cert_PKIXParameters, revocationEnabled);
	_JC_PRIM_FIELD(env, r0, java_security_cert_PKIXParameters, revocationEnabled) = z4;
	_JC_LINE_NUMBER(183);				// 6
	z4 = _JC_PRIM_FIELD(env, r1, java_security_cert_PKIXParameters, exPolicyRequired);
	_JC_PRIM_FIELD(env, r0, java_security_cert_PKIXParameters, exPolicyRequired) = z4;
	_JC_LINE_NUMBER(184);				// 7
	z4 = _JC_PRIM_FIELD(env, r1, java_security_cert_PKIXParameters, policyMappingInhibited);
	_JC_PRIM_FIELD(env, r0, java_security_cert_PKIXParameters, policyMappingInhibited) = z4;
	_JC_LINE_NUMBER(185);				// 8
	z4 = _JC_PRIM_FIELD(env, r1, java_security_cert_PKIXParameters, anyPolicyInhibited);
	_JC_PRIM_FIELD(env, r0, java_security_cert_PKIXParameters, anyPolicyInhibited) = z4;
	_JC_LINE_NUMBER(186);				// 9
	z4 = _JC_PRIM_FIELD(env, r1, java_security_cert_PKIXParameters, policyQualRejected);
	_JC_PRIM_FIELD(env, r0, java_security_cert_PKIXParameters, policyQualRejected) = z4;
	_JC_LINE_NUMBER(187);				// 10
	r10 = _JC_REF_FIELD(env, r1, java_security_cert_PKIXParameters, date);
	_JC_REF_FIELD(env, r0, java_security_cert_PKIXParameters, date) = r10;
	_JC_LINE_NUMBER(188);				// 11
	r11 = _JC_REF_FIELD(env, r1, java_security_cert_PKIXParameters, sigProvider);
	_JC_REF_FIELD(env, r0, java_security_cert_PKIXParameters, sigProvider) = r11;
	_JC_LINE_NUMBER(189);				// 12
	r13 = _JC_REF_FIELD(env, r1, java_security_cert_PKIXParameters, targetConstraints);
	if (r13 == _JC_NULL)
		goto label0;
	r13 = _JC_REF_FIELD(env, r1, java_security_cert_PKIXParameters, targetConstraints);
	r15 = _JC_INVOKE_INTERFACE(env, r13, _JC_JLONG(0xb75f2713d6705f70), _jc_object *, (_jc_env *, struct _jc_object *));
	r13 = _JC_CAST(env, &_jc_java_security_cert_CertSelector$type, r15);
	goto label1;

label0:
	r13 = _JC_NULL;

label1:
	_JC_REF_FIELD(env, r0, java_security_cert_PKIXParameters, targetConstraints) = r13;
	_JC_LINE_NUMBER(191);				// 13
	return;
}

//
// public void <init>(java.util.Set) throws java.security.InvalidAlgorithmParameterException
//

static _jc_linenum _jc_java_security_cert_PKIXParameters$linenum_table$_init$4239edc3ba8b9760[];

static const unsigned char _jc_java_security_cert_PKIXParameters$param_ptypes$_init$4239edc3ba8b9760[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_security_cert_PKIXParameters$exceptions$_init$4239edc3ba8b9760[] = {
	&_jc_java_security_InvalidAlgorithmParameterException$type
};

static _jc_type *const _jc_java_security_cert_PKIXParameters$param_types$_init$4239edc3ba8b9760[] = {
	&_jc_java_util_Set$type
};

_jc_method _jc_java_security_cert_PKIXParameters$method_info$_init$4239edc3ba8b9760 = {
	.name=			"<init>",
	.signature=		"(Ljava/util/Set;)V",
	.class=			&_jc_java_security_cert_PKIXParameters$type,
	.param_types=		&_jc_java_security_cert_PKIXParameters$param_types$_init$4239edc3ba8b9760,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_security_cert_PKIXParameters$param_ptypes$_init$4239edc3ba8b9760,
	.signature_hash=	_JC_JLONG(0x4239edc3ba8b9760),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_cert_PKIXParameters$method$_init$4239edc3ba8b9760,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_security_cert_PKIXParameters$exceptions$_init$4239edc3ba8b9760,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_java_security_cert_PKIXParameters$linenum_table$_init$4239edc3ba8b9760
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_cert_PKIXParameters, _init$4239edc3ba8b9760);

void _JC_JCNI_ATTR
_jc_java_security_cert_PKIXParameters$method$_init$4239edc3ba8b9760(_jc_env *const env, _jc_java_security_cert_PKIXParameters$object *this, _jc_object *param0)
{
	struct _jc_java_security_cert_PKIXParameters$object *r0;
	struct _jc_object *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(150);				// 0
	_JC_INVOKE_NONVIRTUAL(env, java_security_cert_PKIXParameters, _init$52f4ad9f2989aeee, 0, r0);
	_JC_LINE_NUMBER(151);				// 1
	_JC_INVOKE_VIRTUAL(env, java_security_cert_PKIXParameters, setTrustAnchors$973785f62efb8a35, r0, r1);
	_JC_LINE_NUMBER(152);				// 2
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public void addCertPathChecker(java.security.cert.PKIXCertPathChecker)
//

static _jc_linenum _jc_java_security_cert_PKIXParameters$linenum_table$addCertPathChecker$eea30b9178fc230a[];

static const unsigned char _jc_java_security_cert_PKIXParameters$param_ptypes$addCertPathChecker$eea30b9178fc230a[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_security_cert_PKIXParameters$param_types$addCertPathChecker$eea30b9178fc230a[] = {
	&_jc_java_security_cert_PKIXCertPathChecker$type
};

_jc_method _jc_java_security_cert_PKIXParameters$method_info$addCertPathChecker$eea30b9178fc230a = {
	.name=			"addCertPathChecker",
	.signature=		"(Ljava/security/cert/PKIXCertPathChecker;)V",
	.class=			&_jc_java_security_cert_PKIXParameters$type,
	.param_types=		&_jc_java_security_cert_PKIXParameters$param_types$addCertPathChecker$eea30b9178fc230a,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_security_cert_PKIXParameters$param_ptypes$addCertPathChecker$eea30b9178fc230a,
	.signature_hash=	_JC_JLONG(0xeea30b9178fc230a),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_cert_PKIXParameters$method$addCertPathChecker$eea30b9178fc230a,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_cert_PKIXParameters$vtable, java_security_cert_PKIXParameters.addCertPathChecker$eea30b9178fc230a) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_java_security_cert_PKIXParameters$linenum_table$addCertPathChecker$eea30b9178fc230a
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_cert_PKIXParameters, addCertPathChecker$eea30b9178fc230a);

void _JC_JCNI_ATTR
_jc_java_security_cert_PKIXParameters$method$addCertPathChecker$eea30b9178fc230a(_jc_env *const env, _jc_java_security_cert_PKIXParameters$object *this, _jc_java_security_cert_PKIXCertPathChecker$object *param0)
{
	struct _jc_java_security_cert_PKIXParameters$object *r0;
	struct _jc_java_security_cert_PKIXCertPathChecker$object *r1;
	struct _jc_object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(440);				// 0
	if (r1 == _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(441);				// 1
	r2 = _JC_REF_FIELD(env, r0, java_security_cert_PKIXParameters, pathCheckers);
	_JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0x831f06ee5f59c0cc), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r1);

label0:
	_JC_LINE_NUMBER(442);				// 2
	return;
}

//
// public void addCertStore(java.security.cert.CertStore)
//

static _jc_linenum _jc_java_security_cert_PKIXParameters$linenum_table$addCertStore$01b9214002b461b2[];

static const unsigned char _jc_java_security_cert_PKIXParameters$param_ptypes$addCertStore$01b9214002b461b2[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_security_cert_PKIXParameters$param_types$addCertStore$01b9214002b461b2[] = {
	&_jc_java_security_cert_CertStore$type
};

_jc_method _jc_java_security_cert_PKIXParameters$method_info$addCertStore$01b9214002b461b2 = {
	.name=			"addCertStore",
	.signature=		"(Ljava/security/cert/CertStore;)V",
	.class=			&_jc_java_security_cert_PKIXParameters$type,
	.param_types=		&_jc_java_security_cert_PKIXParameters$param_types$addCertStore$01b9214002b461b2,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_security_cert_PKIXParameters$param_ptypes$addCertStore$01b9214002b461b2,
	.signature_hash=	_JC_JLONG(0x1b9214002b461b2),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_cert_PKIXParameters$method$addCertStore$01b9214002b461b2,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_cert_PKIXParameters$vtable, java_security_cert_PKIXParameters.addCertStore$01b9214002b461b2) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_java_security_cert_PKIXParameters$linenum_table$addCertStore$01b9214002b461b2
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_cert_PKIXParameters, addCertStore$01b9214002b461b2);

void _JC_JCNI_ATTR
_jc_java_security_cert_PKIXParameters$method$addCertStore$01b9214002b461b2(_jc_env *const env, _jc_java_security_cert_PKIXParameters$object *this, _jc_java_security_cert_CertStore$object *param0)
{
	struct _jc_java_security_cert_PKIXParameters$object *r0;
	struct _jc_java_security_cert_CertStore$object *r1;
	struct _jc_object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(270);				// 0
	if (r1 == _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(271);				// 1
	r2 = _JC_REF_FIELD(env, r0, java_security_cert_PKIXParameters, certStores);
	_JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0x831f06ee5f59c0cc), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r1);

label0:
	_JC_LINE_NUMBER(272);				// 2
	return;
}

//
// public java.lang.Object clone()
//

static _jc_linenum _jc_java_security_cert_PKIXParameters$linenum_table$clone$b75f2713d6705f70[];

static const unsigned char _jc_java_security_cert_PKIXParameters$param_ptypes$clone$b75f2713d6705f70[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_java_security_cert_PKIXParameters$method_info$clone$b75f2713d6705f70 = {
	.name=			"clone",
	.signature=		"()Ljava/lang/Object;",
	.class=			&_jc_java_security_cert_PKIXParameters$type,
	.return_type=		&_jc_java_lang_Object$type,
	.param_ptypes=		&_jc_java_security_cert_PKIXParameters$param_ptypes$clone$b75f2713d6705f70,
	.signature_hash=	_JC_JLONG(0xb75f2713d6705f70),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_cert_PKIXParameters$method$clone$b75f2713d6705f70,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_cert_PKIXParameters$vtable, java_security_cert_PKIXParameters.clone$b75f2713d6705f70) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_cert_PKIXParameters$linenum_table$clone$b75f2713d6705f70
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_cert_PKIXParameters, clone$b75f2713d6705f70);

_jc_java_lang_Object$object * _JC_JCNI_ATTR
_jc_java_security_cert_PKIXParameters$method$clone$b75f2713d6705f70(_jc_env *const env, _jc_java_security_cert_PKIXParameters$object *this)
{
	struct _jc_java_security_cert_PKIXParameters$object *r0;
	struct _jc_java_security_cert_PKIXParameters$object *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(525);				// 0
	r1 = _JC_NEW(env, java_security_cert_PKIXParameters);
	_JC_INVOKE_NONVIRTUAL(env, java_security_cert_PKIXParameters, _init$26736bbd04ff3ca1, 0, r1, r0);
	return r1;
}

//
// public java.util.List getCertPathCheckers()
//

static _jc_linenum _jc_java_security_cert_PKIXParameters$linenum_table$getCertPathCheckers$47a73ddb68a3ffcf[];

static const unsigned char _jc_java_security_cert_PKIXParameters$param_ptypes$getCertPathCheckers$47a73ddb68a3ffcf[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_java_security_cert_PKIXParameters$method_info$getCertPathCheckers$47a73ddb68a3ffcf = {
	.name=			"getCertPathCheckers",
	.signature=		"()Ljava/util/List;",
	.class=			&_jc_java_security_cert_PKIXParameters$type,
	.return_type=		&_jc_java_util_List$type,
	.param_ptypes=		&_jc_java_security_cert_PKIXParameters$param_ptypes$getCertPathCheckers$47a73ddb68a3ffcf,
	.signature_hash=	_JC_JLONG(0x47a73ddb68a3ffcf),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_cert_PKIXParameters$method$getCertPathCheckers$47a73ddb68a3ffcf,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_cert_PKIXParameters$vtable, java_security_cert_PKIXParameters.getCertPathCheckers$47a73ddb68a3ffcf) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_cert_PKIXParameters$linenum_table$getCertPathCheckers$47a73ddb68a3ffcf
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_cert_PKIXParameters, getCertPathCheckers$47a73ddb68a3ffcf);

_jc_object * _JC_JCNI_ATTR
_jc_java_security_cert_PKIXParameters$method$getCertPathCheckers$47a73ddb68a3ffcf(_jc_env *const env, _jc_java_security_cert_PKIXParameters$object *this)
{
	struct _jc_java_security_cert_PKIXParameters$object *r0;
	struct _jc_object *r1;
	struct _jc_java_util_Collections__24UnmodifiableRandomAccessList$object *r2;
	struct _jc_java_util_Collections__24UnmodifiableList$object *r3;
	struct _jc_java_lang_NullPointerException$object *r4;
	struct _jc_java_lang_String$object *r5;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(451);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_security_cert_PKIXParameters, pathCheckers);
	_JC_ACTIVE_USE(env, java_util_Collections);
	z0 = _JC_INSTANCEOF(env, r1, &_jc_java_util_RandomAccess$type);
	if (z0 == 0)
		goto label1;
	r2 = _JC_NEW(env, java_util_Collections__24UnmodifiableRandomAccessList);
	_JC_REF_FIELD(env, r2, java_util_Collections__24UnmodifiableCollection, c) = r1;
	if (r1 != _JC_NULL)
		goto label0;
	r4 = _JC_NEW(env, java_lang_NullPointerException);
	r5 = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	_JC_INVOKE_NONVIRTUAL(env, java_lang_Throwable, fillInStackTrace$6204b72985f9038d, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r5;
	_JC_THROW(env, r4);

label0:
	_JC_REF_FIELD(env, r2, java_util_Collections__24UnmodifiableList, list) = r1;
	r1 = r2;
	goto label2;

label1:
	r3 = _JC_NEW(env, java_util_Collections__24UnmodifiableList);
	_JC_INVOKE_NONVIRTUAL(env, java_util_Collections__24UnmodifiableCollection, _init$f10d3ead4f9e91ce, 0, r3, r1);
	_JC_REF_FIELD(env, r3, java_util_Collections__24UnmodifiableList, list) = r1;
	r1 = r3;

label2:
	return r1;
}

//
// public java.util.List getCertStores()
//

static _jc_linenum _jc_java_security_cert_PKIXParameters$linenum_table$getCertStores$be5cd12280ba385a[];

static const unsigned char _jc_java_security_cert_PKIXParameters$param_ptypes$getCertStores$be5cd12280ba385a[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_java_security_cert_PKIXParameters$method_info$getCertStores$be5cd12280ba385a = {
	.name=			"getCertStores",
	.signature=		"()Ljava/util/List;",
	.class=			&_jc_java_security_cert_PKIXParameters$type,
	.return_type=		&_jc_java_util_List$type,
	.param_ptypes=		&_jc_java_security_cert_PKIXParameters$param_ptypes$getCertStores$be5cd12280ba385a,
	.signature_hash=	_JC_JLONG(0xbe5cd12280ba385a),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_cert_PKIXParameters$method$getCertStores$be5cd12280ba385a,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_cert_PKIXParameters$vtable, java_security_cert_PKIXParameters.getCertStores$be5cd12280ba385a) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_cert_PKIXParameters$linenum_table$getCertStores$be5cd12280ba385a
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_cert_PKIXParameters, getCertStores$be5cd12280ba385a);

_jc_object * _JC_JCNI_ATTR
_jc_java_security_cert_PKIXParameters$method$getCertStores$be5cd12280ba385a(_jc_env *const env, _jc_java_security_cert_PKIXParameters$object *this)
{
	struct _jc_java_security_cert_PKIXParameters$object *r0;
	struct _jc_object *r1;
	struct _jc_java_util_Collections__24UnmodifiableRandomAccessList$object *r2;
	struct _jc_java_util_Collections__24UnmodifiableList$object *r3;
	struct _jc_java_lang_NullPointerException$object *r4;
	struct _jc_java_lang_String$object *r5;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(282);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_security_cert_PKIXParameters, certStores);
	_JC_ACTIVE_USE(env, java_util_Collections);
	z0 = _JC_INSTANCEOF(env, r1, &_jc_java_util_RandomAccess$type);
	if (z0 == 0)
		goto label1;
	r2 = _JC_NEW(env, java_util_Collections__24UnmodifiableRandomAccessList);
	_JC_REF_FIELD(env, r2, java_util_Collections__24UnmodifiableCollection, c) = r1;
	if (r1 != _JC_NULL)
		goto label0;
	r4 = _JC_NEW(env, java_lang_NullPointerException);
	r5 = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	_JC_INVOKE_NONVIRTUAL(env, java_lang_Throwable, fillInStackTrace$6204b72985f9038d, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r5;
	_JC_THROW(env, r4);

label0:
	_JC_REF_FIELD(env, r2, java_util_Collections__24UnmodifiableList, list) = r1;
	r1 = r2;
	goto label2;

label1:
	r3 = _JC_NEW(env, java_util_Collections__24UnmodifiableList);
	_JC_INVOKE_NONVIRTUAL(env, java_util_Collections__24UnmodifiableCollection, _init$f10d3ead4f9e91ce, 0, r3, r1);
	_JC_REF_FIELD(env, r3, java_util_Collections__24UnmodifiableList, list) = r1;
	r1 = r3;

label2:
	return r1;
}

//
// public java.util.Date getDate()
//

static _jc_linenum _jc_java_security_cert_PKIXParameters$linenum_table$getDate$802760063d984814[];

static const unsigned char _jc_java_security_cert_PKIXParameters$param_ptypes$getDate$802760063d984814[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_java_security_cert_PKIXParameters$method_info$getDate$802760063d984814 = {
	.name=			"getDate",
	.signature=		"()Ljava/util/Date;",
	.class=			&_jc_java_security_cert_PKIXParameters$type,
	.return_type=		&_jc_java_util_Date$type,
	.param_ptypes=		&_jc_java_security_cert_PKIXParameters$param_ptypes$getDate$802760063d984814,
	.signature_hash=	_JC_JLONG(0x802760063d984814),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_cert_PKIXParameters$method$getDate$802760063d984814,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_cert_PKIXParameters$vtable, java_security_cert_PKIXParameters.getDate$802760063d984814) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_cert_PKIXParameters$linenum_table$getDate$802760063d984814
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_cert_PKIXParameters, getDate$802760063d984814);

_jc_java_util_Date$object * _JC_JCNI_ATTR
_jc_java_security_cert_PKIXParameters$method$getDate$802760063d984814(_jc_env *const env, _jc_java_security_cert_PKIXParameters$object *this)
{
	struct _jc_java_security_cert_PKIXParameters$object *r0;
	struct _jc_java_util_Date$object *r1;
	struct _jc_java_lang_Object$object *r3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(416);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_security_cert_PKIXParameters, date);
	if (r1 == _JC_NULL)
		goto label0;
	r1 = _JC_REF_FIELD(env, r0, java_security_cert_PKIXParameters, date);
	r3 = _JC_INVOKE_VIRTUAL(env, java_util_Date, clone$b75f2713d6705f70, r1);
	r1 = _JC_CAST(env, &_jc_java_util_Date$type, r3);
	goto label1;

label0:
	r1 = _JC_NULL;

label1:
	return r1;
}

//
// public java.util.Set getInitialPolicies()
//

static _jc_linenum _jc_java_security_cert_PKIXParameters$linenum_table$getInitialPolicies$e17910002b5de9e2[];

static const unsigned char _jc_java_security_cert_PKIXParameters$param_ptypes$getInitialPolicies$e17910002b5de9e2[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_java_security_cert_PKIXParameters$method_info$getInitialPolicies$e17910002b5de9e2 = {
	.name=			"getInitialPolicies",
	.signature=		"()Ljava/util/Set;",
	.class=			&_jc_java_security_cert_PKIXParameters$type,
	.return_type=		&_jc_java_util_Set$type,
	.param_ptypes=		&_jc_java_security_cert_PKIXParameters$param_ptypes$getInitialPolicies$e17910002b5de9e2,
	.signature_hash=	_JC_JLONG(0xe17910002b5de9e2),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_cert_PKIXParameters$method$getInitialPolicies$e17910002b5de9e2,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_cert_PKIXParameters$vtable, java_security_cert_PKIXParameters.getInitialPolicies$e17910002b5de9e2) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_cert_PKIXParameters$linenum_table$getInitialPolicies$e17910002b5de9e2
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_cert_PKIXParameters, getInitialPolicies$e17910002b5de9e2);

_jc_object * _JC_JCNI_ATTR
_jc_java_security_cert_PKIXParameters$method$getInitialPolicies$e17910002b5de9e2(_jc_env *const env, _jc_java_security_cert_PKIXParameters$object *this)
{
	struct _jc_java_security_cert_PKIXParameters$object *r0;
	struct _jc_object *r1;
	struct _jc_java_util_Collections__24UnmodifiableSet$object *r2;
	struct _jc_java_lang_NullPointerException$object *r3;
	struct _jc_java_lang_String$object *r4;
	struct _jc_java_lang_VMThrowable$object *r6;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(240);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_security_cert_PKIXParameters, initPolicies);
	_JC_ACTIVE_USE(env, java_util_Collections);
	r2 = _JC_NEW(env, java_util_Collections__24UnmodifiableSet);
	_JC_REF_FIELD(env, r2, java_util_Collections__24UnmodifiableCollection, c) = r1;
	if (r1 != _JC_NULL)
		goto label0;
	r3 = _JC_NEW(env, java_lang_NullPointerException);
	r4 = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r6 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r6;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r4;
	_JC_THROW(env, r3);

label0:
	return r2;
}

//
// public boolean getPolicyQualifiersRejected()
//

static _jc_linenum _jc_java_security_cert_PKIXParameters$linenum_table$getPolicyQualifiersRejected$8168b6896eee8344[];

static const unsigned char _jc_java_security_cert_PKIXParameters$param_ptypes$getPolicyQualifiersRejected$8168b6896eee8344[] = { 
_JC_TYPE_BOOLEAN };

_jc_method _jc_java_security_cert_PKIXParameters$method_info$getPolicyQualifiersRejected$8168b6896eee8344 = {
	.name=			"getPolicyQualifiersRejected",
	.signature=		"()Z",
	.class=			&_jc_java_security_cert_PKIXParameters$type,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_java_security_cert_PKIXParameters$param_ptypes$getPolicyQualifiersRejected$8168b6896eee8344,
	.signature_hash=	_JC_JLONG(0x8168b6896eee8344),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_cert_PKIXParameters$method$getPolicyQualifiersRejected$8168b6896eee8344,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_cert_PKIXParameters$vtable, java_security_cert_PKIXParameters.getPolicyQualifiersRejected$8168b6896eee8344) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_cert_PKIXParameters$linenum_table$getPolicyQualifiersRejected$8168b6896eee8344
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_cert_PKIXParameters, getPolicyQualifiersRejected$8168b6896eee8344);

jboolean _JC_JCNI_ATTR
_jc_java_security_cert_PKIXParameters$method$getPolicyQualifiersRejected$8168b6896eee8344(_jc_env *const env, _jc_java_security_cert_PKIXParameters$object *this)
{
	struct _jc_java_security_cert_PKIXParameters$object *r0;
	jboolean z0;

	r0 = this;
	_JC_LINE_NUMBER(394);				// 0
	z0 = _JC_PRIM_FIELD(env, r0, java_security_cert_PKIXParameters, policyQualRejected);
	return z0;
}

//
// public java.lang.String getSigProvider()
//

static _jc_linenum _jc_java_security_cert_PKIXParameters$linenum_table$getSigProvider$405832a3b76f2e6a[];

static const unsigned char _jc_java_security_cert_PKIXParameters$param_ptypes$getSigProvider$405832a3b76f2e6a[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_java_security_cert_PKIXParameters$method_info$getSigProvider$405832a3b76f2e6a = {
	.name=			"getSigProvider",
	.signature=		"()Ljava/lang/String;",
	.class=			&_jc_java_security_cert_PKIXParameters$type,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_java_security_cert_PKIXParameters$param_ptypes$getSigProvider$405832a3b76f2e6a,
	.signature_hash=	_JC_JLONG(0x405832a3b76f2e6a),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_cert_PKIXParameters$method$getSigProvider$405832a3b76f2e6a,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_cert_PKIXParameters$vtable, java_security_cert_PKIXParameters.getSigProvider$405832a3b76f2e6a) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_cert_PKIXParameters$linenum_table$getSigProvider$405832a3b76f2e6a
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_cert_PKIXParameters, getSigProvider$405832a3b76f2e6a);

_jc_java_lang_String$object * _JC_JCNI_ATTR
_jc_java_security_cert_PKIXParameters$method$getSigProvider$405832a3b76f2e6a(_jc_env *const env, _jc_java_security_cert_PKIXParameters$object *this)
{
	struct _jc_java_security_cert_PKIXParameters$object *r0;
	struct _jc_java_lang_String$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(480);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_security_cert_PKIXParameters, sigProvider);
	return r1;
}

//
// public java.security.cert.CertSelector getTargetCertConstraints()
//

static _jc_linenum _jc_java_security_cert_PKIXParameters$linenum_table$getTargetCertConstraints$6a121acf15434a44[];

static const unsigned char _jc_java_security_cert_PKIXParameters$param_ptypes$getTargetCertConstraints$6a121acf15434a44[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_java_security_cert_PKIXParameters$method_info$getTargetCertConstraints$6a121acf15434a44 = {
	.name=			"getTargetCertConstraints",
	.signature=		"()Ljava/security/cert/CertSelector;",
	.class=			&_jc_java_security_cert_PKIXParameters$type,
	.return_type=		&_jc_java_security_cert_CertSelector$type,
	.param_ptypes=		&_jc_java_security_cert_PKIXParameters$param_ptypes$getTargetCertConstraints$6a121acf15434a44,
	.signature_hash=	_JC_JLONG(0x6a121acf15434a44),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_cert_PKIXParameters$method$getTargetCertConstraints$6a121acf15434a44,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_cert_PKIXParameters$vtable, java_security_cert_PKIXParameters.getTargetCertConstraints$6a121acf15434a44) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_cert_PKIXParameters$linenum_table$getTargetCertConstraints$6a121acf15434a44
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_cert_PKIXParameters, getTargetCertConstraints$6a121acf15434a44);

_jc_object * _JC_JCNI_ATTR
_jc_java_security_cert_PKIXParameters$method$getTargetCertConstraints$6a121acf15434a44(_jc_env *const env, _jc_java_security_cert_PKIXParameters$object *this)
{
	struct _jc_java_security_cert_PKIXParameters$object *r0;
	struct _jc_object *r1;
	struct _jc_java_lang_Object$object *r3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(503);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_security_cert_PKIXParameters, targetConstraints);
	if (r1 == _JC_NULL)
		goto label0;
	r1 = _JC_REF_FIELD(env, r0, java_security_cert_PKIXParameters, targetConstraints);
	r3 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0xb75f2713d6705f70), _jc_object *, (_jc_env *, struct _jc_object *));
	r1 = _JC_CAST(env, &_jc_java_security_cert_CertSelector$type, r3);
	goto label1;

label0:
	r1 = _JC_NULL;

label1:
	return r1;
}

//
// public java.util.Set getTrustAnchors()
//

static _jc_linenum _jc_java_security_cert_PKIXParameters$linenum_table$getTrustAnchors$c05d30658e698a09[];

static const unsigned char _jc_java_security_cert_PKIXParameters$param_ptypes$getTrustAnchors$c05d30658e698a09[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_java_security_cert_PKIXParameters$method_info$getTrustAnchors$c05d30658e698a09 = {
	.name=			"getTrustAnchors",
	.signature=		"()Ljava/util/Set;",
	.class=			&_jc_java_security_cert_PKIXParameters$type,
	.return_type=		&_jc_java_util_Set$type,
	.param_ptypes=		&_jc_java_security_cert_PKIXParameters$param_ptypes$getTrustAnchors$c05d30658e698a09,
	.signature_hash=	_JC_JLONG(0xc05d30658e698a09),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_cert_PKIXParameters$method$getTrustAnchors$c05d30658e698a09,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_cert_PKIXParameters$vtable, java_security_cert_PKIXParameters.getTrustAnchors$c05d30658e698a09) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_cert_PKIXParameters$linenum_table$getTrustAnchors$c05d30658e698a09
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_cert_PKIXParameters, getTrustAnchors$c05d30658e698a09);

_jc_object * _JC_JCNI_ATTR
_jc_java_security_cert_PKIXParameters$method$getTrustAnchors$c05d30658e698a09(_jc_env *const env, _jc_java_security_cert_PKIXParameters$object *this)
{
	struct _jc_java_security_cert_PKIXParameters$object *r0;
	struct _jc_object *r1;
	struct _jc_java_util_Collections__24UnmodifiableSet$object *r2;
	struct _jc_java_lang_NullPointerException$object *r3;
	struct _jc_java_lang_String$object *r4;
	struct _jc_java_lang_VMThrowable$object *r6;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(204);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_security_cert_PKIXParameters, trustAnchors);
	_JC_ACTIVE_USE(env, java_util_Collections);
	r2 = _JC_NEW(env, java_util_Collections__24UnmodifiableSet);
	_JC_REF_FIELD(env, r2, java_util_Collections__24UnmodifiableCollection, c) = r1;
	if (r1 != _JC_NULL)
		goto label0;
	r3 = _JC_NEW(env, java_lang_NullPointerException);
	r4 = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r6 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r6;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r4;
	_JC_THROW(env, r3);

label0:
	return r2;
}

//
// public boolean isAnyPolicyInhibited()
//

static _jc_linenum _jc_java_security_cert_PKIXParameters$linenum_table$isAnyPolicyInhibited$88b480a2c636b590[];

static const unsigned char _jc_java_security_cert_PKIXParameters$param_ptypes$isAnyPolicyInhibited$88b480a2c636b590[] = { 
_JC_TYPE_BOOLEAN };

_jc_method _jc_java_security_cert_PKIXParameters$method_info$isAnyPolicyInhibited$88b480a2c636b590 = {
	.name=			"isAnyPolicyInhibited",
	.signature=		"()Z",
	.class=			&_jc_java_security_cert_PKIXParameters$type,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_java_security_cert_PKIXParameters$param_ptypes$isAnyPolicyInhibited$88b480a2c636b590,
	.signature_hash=	_JC_JLONG(0x88b480a2c636b590),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_cert_PKIXParameters$method$isAnyPolicyInhibited$88b480a2c636b590,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_cert_PKIXParameters$vtable, java_security_cert_PKIXParameters.isAnyPolicyInhibited$88b480a2c636b590) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_cert_PKIXParameters$linenum_table$isAnyPolicyInhibited$88b480a2c636b590
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_cert_PKIXParameters, isAnyPolicyInhibited$88b480a2c636b590);

jboolean _JC_JCNI_ATTR
_jc_java_security_cert_PKIXParameters$method$isAnyPolicyInhibited$88b480a2c636b590(_jc_env *const env, _jc_java_security_cert_PKIXParameters$object *this)
{
	struct _jc_java_security_cert_PKIXParameters$object *r0;
	jboolean z0;

	r0 = this;
	_JC_LINE_NUMBER(373);				// 0
	z0 = _JC_PRIM_FIELD(env, r0, java_security_cert_PKIXParameters, anyPolicyInhibited);
	return z0;
}

//
// public boolean isExplicitPolicyRequired()
//

static _jc_linenum _jc_java_security_cert_PKIXParameters$linenum_table$isExplicitPolicyRequired$4cf5e8accb7f4756[];

static const unsigned char _jc_java_security_cert_PKIXParameters$param_ptypes$isExplicitPolicyRequired$4cf5e8accb7f4756[] = { 
_JC_TYPE_BOOLEAN };

_jc_method _jc_java_security_cert_PKIXParameters$method_info$isExplicitPolicyRequired$4cf5e8accb7f4756 = {
	.name=			"isExplicitPolicyRequired",
	.signature=		"()Z",
	.class=			&_jc_java_security_cert_PKIXParameters$type,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_java_security_cert_PKIXParameters$param_ptypes$isExplicitPolicyRequired$4cf5e8accb7f4756,
	.signature_hash=	_JC_JLONG(0x4cf5e8accb7f4756),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_cert_PKIXParameters$method$isExplicitPolicyRequired$4cf5e8accb7f4756,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_cert_PKIXParameters$vtable, java_security_cert_PKIXParameters.isExplicitPolicyRequired$4cf5e8accb7f4756) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_cert_PKIXParameters$linenum_table$isExplicitPolicyRequired$4cf5e8accb7f4756
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_cert_PKIXParameters, isExplicitPolicyRequired$4cf5e8accb7f4756);

jboolean _JC_JCNI_ATTR
_jc_java_security_cert_PKIXParameters$method$isExplicitPolicyRequired$4cf5e8accb7f4756(_jc_env *const env, _jc_java_security_cert_PKIXParameters$object *this)
{
	struct _jc_java_security_cert_PKIXParameters$object *r0;
	jboolean z0;

	r0 = this;
	_JC_LINE_NUMBER(331);				// 0
	z0 = _JC_PRIM_FIELD(env, r0, java_security_cert_PKIXParameters, exPolicyRequired);
	return z0;
}

//
// public boolean isPolicyMappingInhibited()
//

static _jc_linenum _jc_java_security_cert_PKIXParameters$linenum_table$isPolicyMappingInhibited$30a10962bb056ed7[];

static const unsigned char _jc_java_security_cert_PKIXParameters$param_ptypes$isPolicyMappingInhibited$30a10962bb056ed7[] = { 
_JC_TYPE_BOOLEAN };

_jc_method _jc_java_security_cert_PKIXParameters$method_info$isPolicyMappingInhibited$30a10962bb056ed7 = {
	.name=			"isPolicyMappingInhibited",
	.signature=		"()Z",
	.class=			&_jc_java_security_cert_PKIXParameters$type,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_java_security_cert_PKIXParameters$param_ptypes$isPolicyMappingInhibited$30a10962bb056ed7,
	.signature_hash=	_JC_JLONG(0x30a10962bb056ed7),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_cert_PKIXParameters$method$isPolicyMappingInhibited$30a10962bb056ed7,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_cert_PKIXParameters$vtable, java_security_cert_PKIXParameters.isPolicyMappingInhibited$30a10962bb056ed7) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_cert_PKIXParameters$linenum_table$isPolicyMappingInhibited$30a10962bb056ed7
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_cert_PKIXParameters, isPolicyMappingInhibited$30a10962bb056ed7);

jboolean _JC_JCNI_ATTR
_jc_java_security_cert_PKIXParameters$method$isPolicyMappingInhibited$30a10962bb056ed7(_jc_env *const env, _jc_java_security_cert_PKIXParameters$object *this)
{
	struct _jc_java_security_cert_PKIXParameters$object *r0;
	jboolean z0;

	r0 = this;
	_JC_LINE_NUMBER(352);				// 0
	z0 = _JC_PRIM_FIELD(env, r0, java_security_cert_PKIXParameters, policyMappingInhibited);
	return z0;
}

//
// public boolean isRevocationEnabled()
//

static _jc_linenum _jc_java_security_cert_PKIXParameters$linenum_table$isRevocationEnabled$b8adf96111bc047c[];

static const unsigned char _jc_java_security_cert_PKIXParameters$param_ptypes$isRevocationEnabled$b8adf96111bc047c[] = { 
_JC_TYPE_BOOLEAN };

_jc_method _jc_java_security_cert_PKIXParameters$method_info$isRevocationEnabled$b8adf96111bc047c = {
	.name=			"isRevocationEnabled",
	.signature=		"()Z",
	.class=			&_jc_java_security_cert_PKIXParameters$type,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_java_security_cert_PKIXParameters$param_ptypes$isRevocationEnabled$b8adf96111bc047c,
	.signature_hash=	_JC_JLONG(0xb8adf96111bc047c),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_cert_PKIXParameters$method$isRevocationEnabled$b8adf96111bc047c,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_cert_PKIXParameters$vtable, java_security_cert_PKIXParameters.isRevocationEnabled$b8adf96111bc047c) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_cert_PKIXParameters$linenum_table$isRevocationEnabled$b8adf96111bc047c
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_cert_PKIXParameters, isRevocationEnabled$b8adf96111bc047c);

jboolean _JC_JCNI_ATTR
_jc_java_security_cert_PKIXParameters$method$isRevocationEnabled$b8adf96111bc047c(_jc_env *const env, _jc_java_security_cert_PKIXParameters$object *this)
{
	struct _jc_java_security_cert_PKIXParameters$object *r0;
	jboolean z0;

	r0 = this;
	_JC_LINE_NUMBER(310);				// 0
	z0 = _JC_PRIM_FIELD(env, r0, java_security_cert_PKIXParameters, revocationEnabled);
	return z0;
}

//
// public void setAnyPolicyInhibited(boolean)
//

static _jc_linenum _jc_java_security_cert_PKIXParameters$linenum_table$setAnyPolicyInhibited$de1dc8bd8a6b2e3e[];

static const unsigned char _jc_java_security_cert_PKIXParameters$param_ptypes$setAnyPolicyInhibited$de1dc8bd8a6b2e3e[] = { 
_JC_TYPE_BOOLEAN, _JC_TYPE_VOID };

static _jc_type *const _jc_java_security_cert_PKIXParameters$param_types$setAnyPolicyInhibited$de1dc8bd8a6b2e3e[] = {
	&_jc_boolean$prim$type
};

_jc_method _jc_java_security_cert_PKIXParameters$method_info$setAnyPolicyInhibited$de1dc8bd8a6b2e3e = {
	.name=			"setAnyPolicyInhibited",
	.signature=		"(Z)V",
	.class=			&_jc_java_security_cert_PKIXParameters$type,
	.param_types=		&_jc_java_security_cert_PKIXParameters$param_types$setAnyPolicyInhibited$de1dc8bd8a6b2e3e,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_security_cert_PKIXParameters$param_ptypes$setAnyPolicyInhibited$de1dc8bd8a6b2e3e,
	.signature_hash=	_JC_JLONG(0xde1dc8bd8a6b2e3e),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_cert_PKIXParameters$method$setAnyPolicyInhibited$de1dc8bd8a6b2e3e,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_cert_PKIXParameters$vtable, java_security_cert_PKIXParameters.setAnyPolicyInhibited$de1dc8bd8a6b2e3e) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_security_cert_PKIXParameters$linenum_table$setAnyPolicyInhibited$de1dc8bd8a6b2e3e
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_cert_PKIXParameters, setAnyPolicyInhibited$de1dc8bd8a6b2e3e);

void _JC_JCNI_ATTR
_jc_java_security_cert_PKIXParameters$method$setAnyPolicyInhibited$de1dc8bd8a6b2e3e(_jc_env *const env, _jc_java_security_cert_PKIXParameters$object *this, jboolean param0)
{
	struct _jc_java_security_cert_PKIXParameters$object *r0;
	jboolean z0;

	r0 = this;
	z0 = param0;
	_JC_LINE_NUMBER(383);				// 0
	_JC_PRIM_FIELD(env, r0, java_security_cert_PKIXParameters, anyPolicyInhibited) = z0;
	_JC_LINE_NUMBER(384);				// 1
	return;
}

//
// public void setCertPathCheckers(java.util.List)
//

static _jc_linenum _jc_java_security_cert_PKIXParameters$linenum_table$setCertPathCheckers$f9477fae88cb4089[];

static const unsigned char _jc_java_security_cert_PKIXParameters$param_ptypes$setCertPathCheckers$f9477fae88cb4089[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_security_cert_PKIXParameters$param_types$setCertPathCheckers$f9477fae88cb4089[] = {
	&_jc_java_util_List$type
};

_jc_method _jc_java_security_cert_PKIXParameters$method_info$setCertPathCheckers$f9477fae88cb4089 = {
	.name=			"setCertPathCheckers",
	.signature=		"(Ljava/util/List;)V",
	.class=			&_jc_java_security_cert_PKIXParameters$type,
	.param_types=		&_jc_java_security_cert_PKIXParameters$param_types$setCertPathCheckers$f9477fae88cb4089,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_security_cert_PKIXParameters$param_ptypes$setCertPathCheckers$f9477fae88cb4089,
	.signature_hash=	_JC_JLONG(0xf9477fae88cb4089),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_cert_PKIXParameters$method$setCertPathCheckers$f9477fae88cb4089,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_cert_PKIXParameters$vtable, java_security_cert_PKIXParameters.setCertPathCheckers$f9477fae88cb4089) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	7,
	      .table=	_jc_java_security_cert_PKIXParameters$linenum_table$setCertPathCheckers$f9477fae88cb4089
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_cert_PKIXParameters, setCertPathCheckers$f9477fae88cb4089);

void _JC_JCNI_ATTR
_jc_java_security_cert_PKIXParameters$method$setCertPathCheckers$f9477fae88cb4089(_jc_env *const env, _jc_java_security_cert_PKIXParameters$object *this, _jc_object *param0)
{
	struct _jc_java_security_cert_PKIXParameters$object *r0;
	struct _jc_object *r1;
	struct _jc_object *r2;
	struct _jc_object *r3;
	struct _jc_java_lang_Object$object *r5;
	struct _jc_java_security_cert_PKIXCertPathChecker$object *r6;
	jboolean z1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(464);				// 0
	r3 = _JC_REF_FIELD(env, r0, java_security_cert_PKIXParameters, pathCheckers);
	_JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0xa5acde3ee27a066), void, (_jc_env *, struct _jc_object *));
	_JC_LINE_NUMBER(465);				// 1
	if (r1 != _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(466);				// 2
	return;

label0:
	_JC_LINE_NUMBER(467);				// 3
	r2 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0x3cc91493d50f531c), _jc_object *, (_jc_env *, struct _jc_object *));
	goto label2;

label1:
	_JC_LINE_NUMBER(469);				// 4
	r3 = _JC_REF_FIELD(env, r0, java_security_cert_PKIXParameters, pathCheckers);
	r5 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0x5874f79a1cf66ea), _jc_object *, (_jc_env *, struct _jc_object *));
	r6 = _JC_CAST(env, &_jc_java_security_cert_PKIXCertPathChecker$type, r5);
	_JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0x831f06ee5f59c0cc), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r6);

label2:
	_JC_LINE_NUMBER(467);				// 5
	z1 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0xfb0bd5e38c59ddcd), jboolean, (_jc_env *, struct _jc_object *));
	if (z1 != 0) {
		_JC_PERIODIC_CHECK(env);
		goto label1;
	}
	_JC_LINE_NUMBER(471);				// 6
	return;
}

//
// public void setCertStores(java.util.List)
//

static _jc_linenum _jc_java_security_cert_PKIXParameters$linenum_table$setCertStores$25972ff6264d6a32[];

static const unsigned char _jc_java_security_cert_PKIXParameters$param_ptypes$setCertStores$25972ff6264d6a32[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_security_cert_PKIXParameters$param_types$setCertStores$25972ff6264d6a32[] = {
	&_jc_java_util_List$type
};

_jc_method _jc_java_security_cert_PKIXParameters$method_info$setCertStores$25972ff6264d6a32 = {
	.name=			"setCertStores",
	.signature=		"(Ljava/util/List;)V",
	.class=			&_jc_java_security_cert_PKIXParameters$type,
	.param_types=		&_jc_java_security_cert_PKIXParameters$param_types$setCertStores$25972ff6264d6a32,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_security_cert_PKIXParameters$param_ptypes$setCertStores$25972ff6264d6a32,
	.signature_hash=	_JC_JLONG(0x25972ff6264d6a32),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_cert_PKIXParameters$method$setCertStores$25972ff6264d6a32,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_cert_PKIXParameters$vtable, java_security_cert_PKIXParameters.setCertStores$25972ff6264d6a32) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	7,
	      .table=	_jc_java_security_cert_PKIXParameters$linenum_table$setCertStores$25972ff6264d6a32
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_cert_PKIXParameters, setCertStores$25972ff6264d6a32);

void _JC_JCNI_ATTR
_jc_java_security_cert_PKIXParameters$method$setCertStores$25972ff6264d6a32(_jc_env *const env, _jc_java_security_cert_PKIXParameters$object *this, _jc_object *param0)
{
	struct _jc_java_security_cert_PKIXParameters$object *r0;
	struct _jc_object *r1;
	struct _jc_object *r2;
	struct _jc_object *r3;
	struct _jc_java_lang_Object$object *r5;
	struct _jc_java_security_cert_CertStore$object *r6;
	jboolean z1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(293);				// 0
	r3 = _JC_REF_FIELD(env, r0, java_security_cert_PKIXParameters, certStores);
	_JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0xa5acde3ee27a066), void, (_jc_env *, struct _jc_object *));
	_JC_LINE_NUMBER(294);				// 1
	if (r1 != _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(295);				// 2
	return;

label0:
	_JC_LINE_NUMBER(296);				// 3
	r2 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0x3cc91493d50f531c), _jc_object *, (_jc_env *, struct _jc_object *));
	goto label2;

label1:
	_JC_LINE_NUMBER(298);				// 4
	r3 = _JC_REF_FIELD(env, r0, java_security_cert_PKIXParameters, certStores);
	r5 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0x5874f79a1cf66ea), _jc_object *, (_jc_env *, struct _jc_object *));
	r6 = _JC_CAST(env, &_jc_java_security_cert_CertStore$type, r5);
	_JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0x831f06ee5f59c0cc), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r6);

label2:
	_JC_LINE_NUMBER(296);				// 5
	z1 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0xfb0bd5e38c59ddcd), jboolean, (_jc_env *, struct _jc_object *));
	if (z1 != 0) {
		_JC_PERIODIC_CHECK(env);
		goto label1;
	}
	_JC_LINE_NUMBER(300);				// 6
	return;
}

//
// public void setDate(java.util.Date)
//

static _jc_linenum _jc_java_security_cert_PKIXParameters$linenum_table$setDate$fdbc0baf3c293107[];

static const unsigned char _jc_java_security_cert_PKIXParameters$param_ptypes$setDate$fdbc0baf3c293107[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_security_cert_PKIXParameters$param_types$setDate$fdbc0baf3c293107[] = {
	&_jc_java_util_Date$type
};

_jc_method _jc_java_security_cert_PKIXParameters$method_info$setDate$fdbc0baf3c293107 = {
	.name=			"setDate",
	.signature=		"(Ljava/util/Date;)V",
	.class=			&_jc_java_security_cert_PKIXParameters$type,
	.param_types=		&_jc_java_security_cert_PKIXParameters$param_types$setDate$fdbc0baf3c293107,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_security_cert_PKIXParameters$param_ptypes$setDate$fdbc0baf3c293107,
	.signature_hash=	_JC_JLONG(0xfdbc0baf3c293107),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_cert_PKIXParameters$method$setDate$fdbc0baf3c293107,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_cert_PKIXParameters$vtable, java_security_cert_PKIXParameters.setDate$fdbc0baf3c293107) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_java_security_cert_PKIXParameters$linenum_table$setDate$fdbc0baf3c293107
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_cert_PKIXParameters, setDate$fdbc0baf3c293107);

void _JC_JCNI_ATTR
_jc_java_security_cert_PKIXParameters$method$setDate$fdbc0baf3c293107(_jc_env *const env, _jc_java_security_cert_PKIXParameters$object *this, _jc_java_util_Date$object *param0)
{
	struct _jc_java_security_cert_PKIXParameters$object *r0;
	struct _jc_java_util_Date$object *r1;
	struct _jc_java_lang_Object$object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(427);				// 0
	if (r1 == _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(428);				// 1
	r2 = _JC_INVOKE_VIRTUAL(env, java_util_Date, clone$b75f2713d6705f70, r1);
	r1 = _JC_CAST(env, &_jc_java_util_Date$type, r2);
	_JC_REF_FIELD(env, r0, java_security_cert_PKIXParameters, date) = r1;
	goto label1;

label0:
	_JC_LINE_NUMBER(430);				// 2
	_JC_REF_FIELD(env, r0, java_security_cert_PKIXParameters, date) = _JC_NULL;

label1:
	_JC_LINE_NUMBER(431);				// 3
	return;
}

//
// public void setExplicitPolicyRequired(boolean)
//

static _jc_linenum _jc_java_security_cert_PKIXParameters$linenum_table$setExplicitPolicyRequired$cd81958a01d80602[];

static const unsigned char _jc_java_security_cert_PKIXParameters$param_ptypes$setExplicitPolicyRequired$cd81958a01d80602[] = { 
_JC_TYPE_BOOLEAN, _JC_TYPE_VOID };

static _jc_type *const _jc_java_security_cert_PKIXParameters$param_types$setExplicitPolicyRequired$cd81958a01d80602[] = {
	&_jc_boolean$prim$type
};

_jc_method _jc_java_security_cert_PKIXParameters$method_info$setExplicitPolicyRequired$cd81958a01d80602 = {
	.name=			"setExplicitPolicyRequired",
	.signature=		"(Z)V",
	.class=			&_jc_java_security_cert_PKIXParameters$type,
	.param_types=		&_jc_java_security_cert_PKIXParameters$param_types$setExplicitPolicyRequired$cd81958a01d80602,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_security_cert_PKIXParameters$param_ptypes$setExplicitPolicyRequired$cd81958a01d80602,
	.signature_hash=	_JC_JLONG(0xcd81958a01d80602),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_cert_PKIXParameters$method$setExplicitPolicyRequired$cd81958a01d80602,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_cert_PKIXParameters$vtable, java_security_cert_PKIXParameters.setExplicitPolicyRequired$cd81958a01d80602) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_security_cert_PKIXParameters$linenum_table$setExplicitPolicyRequired$cd81958a01d80602
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_cert_PKIXParameters, setExplicitPolicyRequired$cd81958a01d80602);

void _JC_JCNI_ATTR
_jc_java_security_cert_PKIXParameters$method$setExplicitPolicyRequired$cd81958a01d80602(_jc_env *const env, _jc_java_security_cert_PKIXParameters$object *this, jboolean param0)
{
	struct _jc_java_security_cert_PKIXParameters$object *r0;
	jboolean z0;

	r0 = this;
	z0 = param0;
	_JC_LINE_NUMBER(341);				// 0
	_JC_PRIM_FIELD(env, r0, java_security_cert_PKIXParameters, exPolicyRequired) = z0;
	_JC_LINE_NUMBER(342);				// 1
	return;
}

//
// public void setInitialPolicies(java.util.Set)
//

static _jc_linenum _jc_java_security_cert_PKIXParameters$linenum_table$setInitialPolicies$a8c95f223a1b81cd[];

static const unsigned char _jc_java_security_cert_PKIXParameters$param_ptypes$setInitialPolicies$a8c95f223a1b81cd[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_security_cert_PKIXParameters$param_types$setInitialPolicies$a8c95f223a1b81cd[] = {
	&_jc_java_util_Set$type
};

_jc_method _jc_java_security_cert_PKIXParameters$method_info$setInitialPolicies$a8c95f223a1b81cd = {
	.name=			"setInitialPolicies",
	.signature=		"(Ljava/util/Set;)V",
	.class=			&_jc_java_security_cert_PKIXParameters$type,
	.param_types=		&_jc_java_security_cert_PKIXParameters$param_types$setInitialPolicies$a8c95f223a1b81cd,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_security_cert_PKIXParameters$param_ptypes$setInitialPolicies$a8c95f223a1b81cd,
	.signature_hash=	_JC_JLONG(0xa8c95f223a1b81cd),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_cert_PKIXParameters$method$setInitialPolicies$a8c95f223a1b81cd,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_cert_PKIXParameters$vtable, java_security_cert_PKIXParameters.setInitialPolicies$a8c95f223a1b81cd) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	7,
	      .table=	_jc_java_security_cert_PKIXParameters$linenum_table$setInitialPolicies$a8c95f223a1b81cd
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_cert_PKIXParameters, setInitialPolicies$a8c95f223a1b81cd);

void _JC_JCNI_ATTR
_jc_java_security_cert_PKIXParameters$method$setInitialPolicies$a8c95f223a1b81cd(_jc_env *const env, _jc_java_security_cert_PKIXParameters$object *this, _jc_object *param0)
{
	struct _jc_java_security_cert_PKIXParameters$object *r0;
	struct _jc_object *r1;
	struct _jc_object *r2;
	struct _jc_object *r3;
	struct _jc_java_lang_Object$object *r5;
	struct _jc_java_lang_String$object *r6;
	jboolean z1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(254);				// 0
	r3 = _JC_REF_FIELD(env, r0, java_security_cert_PKIXParameters, initPolicies);
	_JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0xa5acde3ee27a066), void, (_jc_env *, struct _jc_object *));
	_JC_LINE_NUMBER(255);				// 1
	if (r1 != _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(256);				// 2
	return;

label0:
	_JC_LINE_NUMBER(257);				// 3
	r2 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0x3cc91493d50f531c), _jc_object *, (_jc_env *, struct _jc_object *));
	goto label2;

label1:
	_JC_LINE_NUMBER(259);				// 4
	r3 = _JC_REF_FIELD(env, r0, java_security_cert_PKIXParameters, initPolicies);
	r5 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0x5874f79a1cf66ea), _jc_object *, (_jc_env *, struct _jc_object *));
	r6 = _JC_CAST_FINAL(env, &_jc_java_lang_String$type, r5);
	_JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0x831f06ee5f59c0cc), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r6);

label2:
	_JC_LINE_NUMBER(257);				// 5
	z1 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0xfb0bd5e38c59ddcd), jboolean, (_jc_env *, struct _jc_object *));
	if (z1 != 0) {
		_JC_PERIODIC_CHECK(env);
		goto label1;
	}
	_JC_LINE_NUMBER(261);				// 6
	return;
}

//
// public void setPolicyMappingInhibited(boolean)
//

static _jc_linenum _jc_java_security_cert_PKIXParameters$linenum_table$setPolicyMappingInhibited$9a37603ae194e9f6[];

static const unsigned char _jc_java_security_cert_PKIXParameters$param_ptypes$setPolicyMappingInhibited$9a37603ae194e9f6[] = { 
_JC_TYPE_BOOLEAN, _JC_TYPE_VOID };

static _jc_type *const _jc_java_security_cert_PKIXParameters$param_types$setPolicyMappingInhibited$9a37603ae194e9f6[] = {
	&_jc_boolean$prim$type
};

_jc_method _jc_java_security_cert_PKIXParameters$method_info$setPolicyMappingInhibited$9a37603ae194e9f6 = {
	.name=			"setPolicyMappingInhibited",
	.signature=		"(Z)V",
	.class=			&_jc_java_security_cert_PKIXParameters$type,
	.param_types=		&_jc_java_security_cert_PKIXParameters$param_types$setPolicyMappingInhibited$9a37603ae194e9f6,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_security_cert_PKIXParameters$param_ptypes$setPolicyMappingInhibited$9a37603ae194e9f6,
	.signature_hash=	_JC_JLONG(0x9a37603ae194e9f6),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_cert_PKIXParameters$method$setPolicyMappingInhibited$9a37603ae194e9f6,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_cert_PKIXParameters$vtable, java_security_cert_PKIXParameters.setPolicyMappingInhibited$9a37603ae194e9f6) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_security_cert_PKIXParameters$linenum_table$setPolicyMappingInhibited$9a37603ae194e9f6
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_cert_PKIXParameters, setPolicyMappingInhibited$9a37603ae194e9f6);

void _JC_JCNI_ATTR
_jc_java_security_cert_PKIXParameters$method$setPolicyMappingInhibited$9a37603ae194e9f6(_jc_env *const env, _jc_java_security_cert_PKIXParameters$object *this, jboolean param0)
{
	struct _jc_java_security_cert_PKIXParameters$object *r0;
	jboolean z0;

	r0 = this;
	z0 = param0;
	_JC_LINE_NUMBER(362);				// 0
	_JC_PRIM_FIELD(env, r0, java_security_cert_PKIXParameters, policyMappingInhibited) = z0;
	_JC_LINE_NUMBER(363);				// 1
	return;
}

//
// public void setPolicyQualifiersRejected(boolean)
//

static _jc_linenum _jc_java_security_cert_PKIXParameters$linenum_table$setPolicyQualifiersRejected$9c9b1f994f96bc63[];

static const unsigned char _jc_java_security_cert_PKIXParameters$param_ptypes$setPolicyQualifiersRejected$9c9b1f994f96bc63[] = { 
_JC_TYPE_BOOLEAN, _JC_TYPE_VOID };

static _jc_type *const _jc_java_security_cert_PKIXParameters$param_types$setPolicyQualifiersRejected$9c9b1f994f96bc63[] = {
	&_jc_boolean$prim$type
};

_jc_method _jc_java_security_cert_PKIXParameters$method_info$setPolicyQualifiersRejected$9c9b1f994f96bc63 = {
	.name=			"setPolicyQualifiersRejected",
	.signature=		"(Z)V",
	.class=			&_jc_java_security_cert_PKIXParameters$type,
	.param_types=		&_jc_java_security_cert_PKIXParameters$param_types$setPolicyQualifiersRejected$9c9b1f994f96bc63,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_security_cert_PKIXParameters$param_ptypes$setPolicyQualifiersRejected$9c9b1f994f96bc63,
	.signature_hash=	_JC_JLONG(0x9c9b1f994f96bc63),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_cert_PKIXParameters$method$setPolicyQualifiersRejected$9c9b1f994f96bc63,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_cert_PKIXParameters$vtable, java_security_cert_PKIXParameters.setPolicyQualifiersRejected$9c9b1f994f96bc63) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_security_cert_PKIXParameters$linenum_table$setPolicyQualifiersRejected$9c9b1f994f96bc63
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_cert_PKIXParameters, setPolicyQualifiersRejected$9c9b1f994f96bc63);

void _JC_JCNI_ATTR
_jc_java_security_cert_PKIXParameters$method$setPolicyQualifiersRejected$9c9b1f994f96bc63(_jc_env *const env, _jc_java_security_cert_PKIXParameters$object *this, jboolean param0)
{
	struct _jc_java_security_cert_PKIXParameters$object *r0;
	jboolean z0;

	r0 = this;
	z0 = param0;
	_JC_LINE_NUMBER(404);				// 0
	_JC_PRIM_FIELD(env, r0, java_security_cert_PKIXParameters, policyQualRejected) = z0;
	_JC_LINE_NUMBER(405);				// 1
	return;
}

//
// public void setRevocationEnabled(boolean)
//

static _jc_linenum _jc_java_security_cert_PKIXParameters$linenum_table$setRevocationEnabled$c11d0039e448ef66[];

static const unsigned char _jc_java_security_cert_PKIXParameters$param_ptypes$setRevocationEnabled$c11d0039e448ef66[] = { 
_JC_TYPE_BOOLEAN, _JC_TYPE_VOID };

static _jc_type *const _jc_java_security_cert_PKIXParameters$param_types$setRevocationEnabled$c11d0039e448ef66[] = {
	&_jc_boolean$prim$type
};

_jc_method _jc_java_security_cert_PKIXParameters$method_info$setRevocationEnabled$c11d0039e448ef66 = {
	.name=			"setRevocationEnabled",
	.signature=		"(Z)V",
	.class=			&_jc_java_security_cert_PKIXParameters$type,
	.param_types=		&_jc_java_security_cert_PKIXParameters$param_types$setRevocationEnabled$c11d0039e448ef66,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_security_cert_PKIXParameters$param_ptypes$setRevocationEnabled$c11d0039e448ef66,
	.signature_hash=	_JC_JLONG(0xc11d0039e448ef66),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_cert_PKIXParameters$method$setRevocationEnabled$c11d0039e448ef66,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_cert_PKIXParameters$vtable, java_security_cert_PKIXParameters.setRevocationEnabled$c11d0039e448ef66) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_security_cert_PKIXParameters$linenum_table$setRevocationEnabled$c11d0039e448ef66
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_cert_PKIXParameters, setRevocationEnabled$c11d0039e448ef66);

void _JC_JCNI_ATTR
_jc_java_security_cert_PKIXParameters$method$setRevocationEnabled$c11d0039e448ef66(_jc_env *const env, _jc_java_security_cert_PKIXParameters$object *this, jboolean param0)
{
	struct _jc_java_security_cert_PKIXParameters$object *r0;
	jboolean z0;

	r0 = this;
	z0 = param0;
	_JC_LINE_NUMBER(320);				// 0
	_JC_PRIM_FIELD(env, r0, java_security_cert_PKIXParameters, revocationEnabled) = z0;
	_JC_LINE_NUMBER(321);				// 1
	return;
}

//
// public void setSigProvider(java.lang.String)
//

static _jc_linenum _jc_java_security_cert_PKIXParameters$linenum_table$setSigProvider$53db79a26ea9e485[];

static const unsigned char _jc_java_security_cert_PKIXParameters$param_ptypes$setSigProvider$53db79a26ea9e485[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_security_cert_PKIXParameters$param_types$setSigProvider$53db79a26ea9e485[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_java_security_cert_PKIXParameters$method_info$setSigProvider$53db79a26ea9e485 = {
	.name=			"setSigProvider",
	.signature=		"(Ljava/lang/String;)V",
	.class=			&_jc_java_security_cert_PKIXParameters$type,
	.param_types=		&_jc_java_security_cert_PKIXParameters$param_types$setSigProvider$53db79a26ea9e485,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_security_cert_PKIXParameters$param_ptypes$setSigProvider$53db79a26ea9e485,
	.signature_hash=	_JC_JLONG(0x53db79a26ea9e485),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_cert_PKIXParameters$method$setSigProvider$53db79a26ea9e485,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_cert_PKIXParameters$vtable, java_security_cert_PKIXParameters.setSigProvider$53db79a26ea9e485) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_security_cert_PKIXParameters$linenum_table$setSigProvider$53db79a26ea9e485
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_cert_PKIXParameters, setSigProvider$53db79a26ea9e485);

void _JC_JCNI_ATTR
_jc_java_security_cert_PKIXParameters$method$setSigProvider$53db79a26ea9e485(_jc_env *const env, _jc_java_security_cert_PKIXParameters$object *this, _jc_java_lang_String$object *param0)
{
	struct _jc_java_security_cert_PKIXParameters$object *r0;
	struct _jc_java_lang_String$object *r1;

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(491);				// 0
	_JC_REF_FIELD(env, r0, java_security_cert_PKIXParameters, sigProvider) = r1;
	_JC_LINE_NUMBER(492);				// 1
	return;
}

//
// public void setTargetCertConstraints(java.security.cert.CertSelector)
//

static _jc_linenum _jc_java_security_cert_PKIXParameters$linenum_table$setTargetCertConstraints$f916b7f231333dda[];

static const unsigned char _jc_java_security_cert_PKIXParameters$param_ptypes$setTargetCertConstraints$f916b7f231333dda[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_security_cert_PKIXParameters$param_types$setTargetCertConstraints$f916b7f231333dda[] = {
	&_jc_java_security_cert_CertSelector$type
};

_jc_method _jc_java_security_cert_PKIXParameters$method_info$setTargetCertConstraints$f916b7f231333dda = {
	.name=			"setTargetCertConstraints",
	.signature=		"(Ljava/security/cert/CertSelector;)V",
	.class=			&_jc_java_security_cert_PKIXParameters$type,
	.param_types=		&_jc_java_security_cert_PKIXParameters$param_types$setTargetCertConstraints$f916b7f231333dda,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_security_cert_PKIXParameters$param_ptypes$setTargetCertConstraints$f916b7f231333dda,
	.signature_hash=	_JC_JLONG(0xf916b7f231333dda),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_cert_PKIXParameters$method$setTargetCertConstraints$f916b7f231333dda,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_cert_PKIXParameters$vtable, java_security_cert_PKIXParameters.setTargetCertConstraints$f916b7f231333dda) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_security_cert_PKIXParameters$linenum_table$setTargetCertConstraints$f916b7f231333dda
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_cert_PKIXParameters, setTargetCertConstraints$f916b7f231333dda);

void _JC_JCNI_ATTR
_jc_java_security_cert_PKIXParameters$method$setTargetCertConstraints$f916b7f231333dda(_jc_env *const env, _jc_java_security_cert_PKIXParameters$object *this, _jc_object *param0)
{
	struct _jc_java_security_cert_PKIXParameters$object *r0;
	struct _jc_object *r1;
	struct _jc_java_lang_Object$object *r3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(514);				// 0
	if (r1 == _JC_NULL)
		goto label0;
	r3 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0xb75f2713d6705f70), _jc_object *, (_jc_env *, struct _jc_object *));
	r1 = _JC_CAST(env, &_jc_java_security_cert_CertSelector$type, r3);
	goto label1;

label0:
	r1 = _JC_NULL;

label1:
	_JC_REF_FIELD(env, r0, java_security_cert_PKIXParameters, targetConstraints) = r1;
	_JC_LINE_NUMBER(516);				// 1
	return;
}

//
// public void setTrustAnchors(java.util.Set) throws java.security.InvalidAlgorithmParameterException
//

static _jc_linenum _jc_java_security_cert_PKIXParameters$linenum_table$setTrustAnchors$973785f62efb8a35[];

static const unsigned char _jc_java_security_cert_PKIXParameters$param_ptypes$setTrustAnchors$973785f62efb8a35[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_security_cert_PKIXParameters$exceptions$setTrustAnchors$973785f62efb8a35[] = {
	&_jc_java_security_InvalidAlgorithmParameterException$type
};

static _jc_type *const _jc_java_security_cert_PKIXParameters$param_types$setTrustAnchors$973785f62efb8a35[] = {
	&_jc_java_util_Set$type
};

_jc_method _jc_java_security_cert_PKIXParameters$method_info$setTrustAnchors$973785f62efb8a35 = {
	.name=			"setTrustAnchors",
	.signature=		"(Ljava/util/Set;)V",
	.class=			&_jc_java_security_cert_PKIXParameters$type,
	.param_types=		&_jc_java_security_cert_PKIXParameters$param_types$setTrustAnchors$973785f62efb8a35,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_security_cert_PKIXParameters$param_ptypes$setTrustAnchors$973785f62efb8a35,
	.signature_hash=	_JC_JLONG(0x973785f62efb8a35),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_cert_PKIXParameters$method$setTrustAnchors$973785f62efb8a35,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_cert_PKIXParameters$vtable, java_security_cert_PKIXParameters.setTrustAnchors$973785f62efb8a35) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_security_cert_PKIXParameters$exceptions$setTrustAnchors$973785f62efb8a35,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	7,
	      .table=	_jc_java_security_cert_PKIXParameters$linenum_table$setTrustAnchors$973785f62efb8a35
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_cert_PKIXParameters, setTrustAnchors$973785f62efb8a35);

void _JC_JCNI_ATTR
_jc_java_security_cert_PKIXParameters$method$setTrustAnchors$973785f62efb8a35(_jc_env *const env, _jc_java_security_cert_PKIXParameters$object *this, _jc_object *param0)
{
	struct _jc_java_security_cert_PKIXParameters$object *r0;
	struct _jc_object *r1;
	struct _jc_object *r2;
	struct _jc_java_security_InvalidAlgorithmParameterException$object *r3;
	struct _jc_object *r4;
	struct _jc_java_lang_Object$object *r5;
	struct _jc_java_security_cert_TrustAnchor$object *r6;
	struct _jc_java_lang_String$object *r7;
	struct _jc_java_lang_VMThrowable$object *r9;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(222);				// 0
	z0 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0x551bea84f4e0f0cb), jboolean, (_jc_env *, struct _jc_object *));
	if (z0 == 0)
		goto label0;
	_JC_LINE_NUMBER(223);				// 1
	r3 = _JC_NEW(env, java_security_InvalidAlgorithmParameterException);
	r7 = _JC_STRING(env, "no trust anchors");
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r9 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r9;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r7;
	_JC_THROW(env, r3);

label0:
	_JC_LINE_NUMBER(224);				// 2
	r4 = _JC_REF_FIELD(env, r0, java_security_cert_PKIXParameters, trustAnchors);
	_JC_INVOKE_INTERFACE(env, r4, _JC_JLONG(0xa5acde3ee27a066), void, (_jc_env *, struct _jc_object *));
	_JC_LINE_NUMBER(225);				// 3
	r2 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0x3cc91493d50f531c), _jc_object *, (_jc_env *, struct _jc_object *));
	goto label2;

label1:
	_JC_LINE_NUMBER(227);				// 4
	r4 = _JC_REF_FIELD(env, r0, java_security_cert_PKIXParameters, trustAnchors);
	r5 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0x5874f79a1cf66ea), _jc_object *, (_jc_env *, struct _jc_object *));
	r6 = _JC_CAST(env, &_jc_java_security_cert_TrustAnchor$type, r5);
	_JC_INVOKE_INTERFACE(env, r4, _JC_JLONG(0x831f06ee5f59c0cc), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r6);

label2:
	_JC_LINE_NUMBER(225);				// 5
	z0 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0xfb0bd5e38c59ddcd), jboolean, (_jc_env *, struct _jc_object *));
	if (z0 != 0) {
		_JC_PERIODIC_CHECK(env);
		goto label1;
	}
	_JC_LINE_NUMBER(229);				// 6
	return;
}

//
// public java.lang.String toString()
//

static _jc_linenum _jc_java_security_cert_PKIXParameters$linenum_table$toString$7ea43b33b80a3070[];

static const unsigned char _jc_java_security_cert_PKIXParameters$param_ptypes$toString$7ea43b33b80a3070[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_java_security_cert_PKIXParameters$method_info$toString$7ea43b33b80a3070 = {
	.name=			"toString",
	.signature=		"()Ljava/lang/String;",
	.class=			&_jc_java_security_cert_PKIXParameters$type,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_java_security_cert_PKIXParameters$param_ptypes$toString$7ea43b33b80a3070,
	.signature_hash=	_JC_JLONG(0x7ea43b33b80a3070),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_security_cert_PKIXParameters$method$toString$7ea43b33b80a3070,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_security_cert_PKIXParameters$vtable, java_security_cert_PKIXParameters.toString$7ea43b33b80a3070) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_security_cert_PKIXParameters$linenum_table$toString$7ea43b33b80a3070
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_security_cert_PKIXParameters, toString$7ea43b33b80a3070);

_jc_java_lang_String$object * _JC_JCNI_ATTR
_jc_java_security_cert_PKIXParameters$method$toString$7ea43b33b80a3070(_jc_env *const env, _jc_java_security_cert_PKIXParameters$object *this)
{
	struct _jc_java_security_cert_PKIXParameters$object *r0;
	struct _jc_java_lang_StringBuffer$object *r1;
	struct _jc_java_lang_StringBuffer$object *r10;
	struct _jc_java_lang_String$object *r11;
	struct _jc_java_lang_StringBuffer$object *r12;
	struct _jc_java_lang_String$object *r13;
	struct _jc_java_lang_StringBuffer$object *r14;
	struct _jc_java_lang_String$object *r15;
	struct _jc_java_lang_StringBuffer$object *r16;
	struct _jc_java_lang_String$object *r17;
	struct _jc_java_lang_StringBuffer$object *r18;
	struct _jc_java_lang_String$object *r19;
	struct _jc_object *r2;
	struct _jc_java_lang_StringBuffer$object *r20;
	struct _jc_java_lang_String$object *r21;
	struct _jc_java_lang_StringBuffer$object *r22;
	struct _jc_java_lang_String$object *r23;
	struct _jc_java_lang_StringBuffer$object *r24;
	struct _jc_java_lang_String$object *r25;
	struct _jc_java_lang_StringBuffer$object *r26;
	struct _jc_java_lang_String$object *r28;
	struct _jc_java_lang_String$object *r3;
	struct _jc_java_util_Date$object *r4;
	struct _jc_object *r5;
	struct _jc_object *r6;
	struct _jc_java_lang_String$object *r7;
	struct _jc_java_lang_StringBuffer$object *r8;
	struct _jc_java_lang_String$object *r9;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(534);				// 0
	r1 = _JC_NEW(env, java_lang_StringBuffer);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, _init$c31b894660454d13, 0, r1, _JC_STRING(env, "[ Trust Anchors: "));
	r2 = _JC_REF_FIELD(env, r0, java_security_cert_PKIXParameters, trustAnchors);
	r8 = r1;
	if (r2 != _JC_NULL)
		goto label0;
	r9 = _JC_STRING(env, "null");
	goto label1;

label0:
	r9 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, toString$7ea43b33b80a3070, r2);

label1:
	r8 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r8, r9);
	r1 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r8, _JC_STRING(env, "; Initial Policy OIDs="));
	r2 = _JC_REF_FIELD(env, r0, java_security_cert_PKIXParameters, initPolicies);
	if (r2 == _JC_NULL)
		goto label2;
	r2 = _JC_REF_FIELD(env, r0, java_security_cert_PKIXParameters, initPolicies);
	r3 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, toString$7ea43b33b80a3070, r2);
	goto label3;

label2:
	r3 = _JC_STRING(env, "any");

label3:
	r1 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 1, r1, r3);
	r1 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r1, _JC_STRING(env, "; Validity Date="));
	r4 = _JC_REF_FIELD(env, r0, java_security_cert_PKIXParameters, date);
	r10 = r1;
	if (r4 != _JC_NULL)
		goto label4;
	r11 = _JC_STRING(env, "null");
	goto label5;

label4:
	r11 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, toString$7ea43b33b80a3070, r4);

label5:
	r10 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r10, r11);
	r1 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r10, _JC_STRING(env, "; Signature Provider="));
	r3 = _JC_REF_FIELD(env, r0, java_security_cert_PKIXParameters, sigProvider);
	r1 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 1, r1, r3);
	r1 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r1, _JC_STRING(env, "; Default Revocation Enabled="));
	z0 = _JC_PRIM_FIELD(env, r0, java_security_cert_PKIXParameters, revocationEnabled);
	r12 = r1;
	if (z0 == 0)
		goto label6;
	r13 = _JC_STRING(env, "true");
	goto label7;

label6:
	r13 = _JC_STRING(env, "false");

label7:
	r12 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r12, r13);
	r1 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r12, _JC_STRING(env, "; Explicit Policy Required="));
	z0 = _JC_PRIM_FIELD(env, r0, java_security_cert_PKIXParameters, exPolicyRequired);
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	r14 = r1;
	if (z0 == 0)
		goto label8;
	r15 = _JC_STRING(env, "true");
	goto label9;

label8:
	r15 = _JC_STRING(env, "false");

label9:
	r14 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r14, r15);
	r1 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r14, _JC_STRING(env, "; Policy Mapping Inhibited="));
	z0 = _JC_PRIM_FIELD(env, r0, java_security_cert_PKIXParameters, policyMappingInhibited);
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	r16 = r1;
	if (z0 == 0)
		goto label10;
	r17 = _JC_STRING(env, "true");
	goto label11;

label10:
	r17 = _JC_STRING(env, "false");

label11:
	r16 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r16, r17);
	r1 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r16, _JC_STRING(env, "; Any Policy Inhibited="));
	z0 = _JC_PRIM_FIELD(env, r0, java_security_cert_PKIXParameters, anyPolicyInhibited);
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	r18 = r1;
	if (z0 == 0)
		goto label12;
	r19 = _JC_STRING(env, "true");
	goto label13;

label12:
	r19 = _JC_STRING(env, "false");

label13:
	r18 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r18, r19);
	r1 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r18, _JC_STRING(env, "; Policy Qualifiers Rejected="));
	z0 = _JC_PRIM_FIELD(env, r0, java_security_cert_PKIXParameters, policyQualRejected);
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	r20 = r1;
	if (z0 == 0)
		goto label14;
	r21 = _JC_STRING(env, "true");
	goto label15;

label14:
	r21 = _JC_STRING(env, "false");

label15:
	r20 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r20, r21);
	r1 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r20, _JC_STRING(env, "; Target Cert Contstraints="));
	r5 = _JC_REF_FIELD(env, r0, java_security_cert_PKIXParameters, targetConstraints);
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	r22 = r1;
	if (r5 != _JC_NULL)
		goto label16;
	r23 = _JC_STRING(env, "null");
	goto label17;

label16:
	r23 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, toString$7ea43b33b80a3070, r5);

label17:
	r22 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r22, r23);
	r1 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r22, _JC_STRING(env, "; Certification Path Checkers="));
	r6 = _JC_REF_FIELD(env, r0, java_security_cert_PKIXParameters, pathCheckers);
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	r24 = r1;
	if (r6 != _JC_NULL)
		goto label18;
	r25 = _JC_STRING(env, "null");
	goto label19;

label18:
	r25 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, toString$7ea43b33b80a3070, r6);

label19:
	r24 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r24, r25);
	r1 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r24, _JC_STRING(env, "; CertStores="));
	r6 = _JC_REF_FIELD(env, r0, java_security_cert_PKIXParameters, certStores);
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	r26 = r1;
	if (r6 != _JC_NULL)
		goto label20;
	r28 = _JC_STRING(env, "null");
	goto label21;

label20:
	r28 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, toString$7ea43b33b80a3070, r6);

label21:
	r26 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r26, r28);
	r1 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r26, _JC_STRING(env, " ]"));
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	r7 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r7, r1);
	return r7;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_java_security_cert_PKIXParameters$methods[] = {
	&_jc_java_security_cert_PKIXParameters$method_info$_init$52f4ad9f2989aeee,
	&_jc_java_security_cert_PKIXParameters$method_info$_init$73a6863676402bf4,
	&_jc_java_security_cert_PKIXParameters$method_info$_init$26736bbd04ff3ca1,
	&_jc_java_security_cert_PKIXParameters$method_info$_init$4239edc3ba8b9760,
	&_jc_java_security_cert_PKIXParameters$method_info$addCertPathChecker$eea30b9178fc230a,
	&_jc_java_security_cert_PKIXParameters$method_info$addCertStore$01b9214002b461b2,
	&_jc_java_security_cert_PKIXParameters$method_info$clone$b75f2713d6705f70,
	&_jc_java_security_cert_PKIXParameters$method_info$getCertPathCheckers$47a73ddb68a3ffcf,
	&_jc_java_security_cert_PKIXParameters$method_info$getCertStores$be5cd12280ba385a,
	&_jc_java_security_cert_PKIXParameters$method_info$getDate$802760063d984814,
	&_jc_java_security_cert_PKIXParameters$method_info$getInitialPolicies$e17910002b5de9e2,
	&_jc_java_security_cert_PKIXParameters$method_info$getPolicyQualifiersRejected$8168b6896eee8344,
	&_jc_java_security_cert_PKIXParameters$method_info$getSigProvider$405832a3b76f2e6a,
	&_jc_java_security_cert_PKIXParameters$method_info$getTargetCertConstraints$6a121acf15434a44,
	&_jc_java_security_cert_PKIXParameters$method_info$getTrustAnchors$c05d30658e698a09,
	&_jc_java_security_cert_PKIXParameters$method_info$isAnyPolicyInhibited$88b480a2c636b590,
	&_jc_java_security_cert_PKIXParameters$method_info$isExplicitPolicyRequired$4cf5e8accb7f4756,
	&_jc_java_security_cert_PKIXParameters$method_info$isPolicyMappingInhibited$30a10962bb056ed7,
	&_jc_java_security_cert_PKIXParameters$method_info$isRevocationEnabled$b8adf96111bc047c,
	&_jc_java_security_cert_PKIXParameters$method_info$setAnyPolicyInhibited$de1dc8bd8a6b2e3e,
	&_jc_java_security_cert_PKIXParameters$method_info$setCertPathCheckers$f9477fae88cb4089,
	&_jc_java_security_cert_PKIXParameters$method_info$setCertStores$25972ff6264d6a32,
	&_jc_java_security_cert_PKIXParameters$method_info$setDate$fdbc0baf3c293107,
	&_jc_java_security_cert_PKIXParameters$method_info$setExplicitPolicyRequired$cd81958a01d80602,
	&_jc_java_security_cert_PKIXParameters$method_info$setInitialPolicies$a8c95f223a1b81cd,
	&_jc_java_security_cert_PKIXParameters$method_info$setPolicyMappingInhibited$9a37603ae194e9f6,
	&_jc_java_security_cert_PKIXParameters$method_info$setPolicyQualifiersRejected$9c9b1f994f96bc63,
	&_jc_java_security_cert_PKIXParameters$method_info$setRevocationEnabled$c11d0039e448ef66,
	&_jc_java_security_cert_PKIXParameters$method_info$setSigProvider$53db79a26ea9e485,
	&_jc_java_security_cert_PKIXParameters$method_info$setTargetCertConstraints$f916b7f231333dda,
	&_jc_java_security_cert_PKIXParameters$method_info$setTrustAnchors$973785f62efb8a35,
	&_jc_java_security_cert_PKIXParameters$method_info$toString$7ea43b33b80a3070
};

/************************************************************************
 *			      Interface list				*
 ************************************************************************/

// Directly implemented interfaces
static _jc_type *const _jc_java_security_cert_PKIXParameters$interfaces[] = {
	&_jc_java_security_cert_CertPathParameters$type
};

/************************************************************************
 *			   Interface hash table				*
 ************************************************************************/

#if _JC_IMETHOD_HASHSIZE != 128
#error "_JC_IMETHOD_HASHSIZE has the wrong value (should be 128)"
#endif

// Interface lookup hash table buckets
static _jc_method *_jc_java_security_cert_PKIXParameters$imethod_hash_bucket_112[] = {
	&_jc_java_security_cert_PKIXParameters$method_info$clone$b75f2713d6705f70,
	_JC_NULL
};

// Interface lookup hash table
static _jc_method **_jc_java_security_cert_PKIXParameters$imethod_hash_table[_JC_IMETHOD_HASHSIZE] = {
	[112]=	_jc_java_security_cert_PKIXParameters$imethod_hash_bucket_112
};

// Interface "quick" lookup hash table
static const void *_jc_java_security_cert_PKIXParameters$imethod_quick_table[_JC_IMETHOD_HASHSIZE] = {
	[112]=	&_jc_java_security_cert_PKIXParameters$method$clone$b75f2713d6705f70
};

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_java_security_cert_PKIXParameters$instanceof_hash_bucket_19[] = {
	&_jc_java_lang_Cloneable$type,
	_JC_NULL
};
static _jc_type *const _jc_java_security_cert_PKIXParameters$instanceof_hash_bucket_41[] = {
	&_jc_java_security_cert_PKIXParameters$type,
	_JC_NULL
};
static _jc_type *const _jc_java_security_cert_PKIXParameters$instanceof_hash_bucket_50[] = {
	&_jc_java_security_cert_CertPathParameters$type,
	_JC_NULL
};
static _jc_type *const _jc_java_security_cert_PKIXParameters$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_java_security_cert_PKIXParameters$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[19]=	_jc_java_security_cert_PKIXParameters$instanceof_hash_bucket_19,
	[41]=	_jc_java_security_cert_PKIXParameters$instanceof_hash_bucket_41,
	[50]=	_jc_java_security_cert_PKIXParameters$instanceof_hash_bucket_50,
	[101]=	_jc_java_security_cert_PKIXParameters$instanceof_hash_bucket_101
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_java_security_cert_PKIXParameters$class_depends[] = {
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/Cloneable",	_JC_JLONG(0x9b667b09132be893) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/NullPointerException",	_JC_JLONG(0x505b8a9a6675be0) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/RuntimeException",	_JC_JLONG(0x4f5534a987354d1d) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/StringBuffer",	_JC_JLONG(0x94d357637b968dda) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/security/GeneralSecurityException",	_JC_JLONG(0x692089051f4c8d0b) },
	{ "java/security/InvalidAlgorithmParameterException",	_JC_JLONG(0x327edce29f2562dd) },
	{ "java/security/KeyStore",	_JC_JLONG(0x1f56d8b14978c9d6) },
	{ "java/security/KeyStoreException",	_JC_JLONG(0x45b488528f32667c) },
	{ "java/security/KeyStoreSpi",	_JC_JLONG(0x4760c3113311a807) },
	{ "java/security/cert/CertPathParameters",	_JC_JLONG(0xf132f959389432b2) },
	{ "java/security/cert/CertSelector",	_JC_JLONG(0xc7e244007d8c33f7) },
	{ "java/security/cert/CertStore",	_JC_JLONG(0x3c280e99213305ba) },
	{ "java/security/cert/Certificate",	_JC_JLONG(0xc98c8192da849b07) },
	{ "java/security/cert/PKIXCertPathChecker",	_JC_JLONG(0xb976c651cf009c14) },
	{ "java/security/cert/TrustAnchor",	_JC_JLONG(0xa32f58fba5216297) },
	{ "java/security/cert/X509Certificate",	_JC_JLONG(0x859e5e5544e5909f) },
	{ "java/util/AbstractCollection",	_JC_JLONG(0x8ea716c64b77f8eb) },
	{ "java/util/AbstractList",	_JC_JLONG(0xf5238436362828db) },
	{ "java/util/AbstractSequentialList",	_JC_JLONG(0x6d7997e879c41059) },
	{ "java/util/AbstractSet",	_JC_JLONG(0xca427569b5b2f804) },
	{ "java/util/Collections",	_JC_JLONG(0x9574af3fed58029a) },
	{ "java/util/Collections$UnmodifiableCollection",	_JC_JLONG(0x2126b28aee607999) },
	{ "java/util/Collections$UnmodifiableList",	_JC_JLONG(0xf6337dee44795dd7) },
	{ "java/util/Collections$UnmodifiableRandomAccessList",	_JC_JLONG(0x85abf76c7de1ef57) },
	{ "java/util/Collections$UnmodifiableSet",	_JC_JLONG(0xaec2ea3fc69f0e47) },
	{ "java/util/Date",	_JC_JLONG(0xa85d2a51094e614c) },
	{ "java/util/Enumeration",	_JC_JLONG(0xc56a8b1934689c38) },
	{ "java/util/HashMap",	_JC_JLONG(0xd7cd853200c3e71f) },
	{ "java/util/HashSet",	_JC_JLONG(0x3c285c721478414d) },
	{ "java/util/Iterator",	_JC_JLONG(0xbe56ff673eefd9d2) },
	{ "java/util/LinkedList",	_JC_JLONG(0x666417b6279ae396) },
	{ "java/util/List",	_JC_JLONG(0x9ee0d92ce1525a4d) },
	{ "java/util/RandomAccess",	_JC_JLONG(0x621ddac3c69143cd) },
	{ "java/util/Set",	_JC_JLONG(0x617ac82c0bec2dff) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_java_security_cert_PKIXParameters$vtype _jc_java_security_cert_PKIXParameters$type = {
    .type= {
	.name=			"java/security/cert/PKIXParameters",
	.superclass=		&_jc_java_lang_Object$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.num_interfaces=sizeof(_jc_java_security_cert_PKIXParameters$interfaces) / sizeof(*_jc_java_security_cert_PKIXParameters$interfaces),
	.interfaces=		_jc_java_security_cert_PKIXParameters$interfaces,
	.imethod_hash_table=	_jc_java_security_cert_PKIXParameters$imethod_hash_table,
	.imethod_quick_table=	_jc_java_security_cert_PKIXParameters$imethod_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		39,
		.hash=			_JC_JLONG(0xa8772e192e80ffa9),
		.source_file=		"PKIXParameters.java",
		.instance_size=		sizeof(_jc_java_security_cert_PKIXParameters$refs) + sizeof(_jc_java_security_cert_PKIXParameters$object),
		.num_virtual_refs=	7,
		.num_fields=		sizeof(_jc_java_security_cert_PKIXParameters$fields) / sizeof(*_jc_java_security_cert_PKIXParameters$fields),
		.fields=		_jc_java_security_cert_PKIXParameters$fields,
		.num_methods=		sizeof(_jc_java_security_cert_PKIXParameters$methods) / sizeof(*_jc_java_security_cert_PKIXParameters$methods),
		.methods=		_jc_java_security_cert_PKIXParameters$methods,
		.instanceof_hash_table=	_jc_java_security_cert_PKIXParameters$instanceof_hash_table,
		.num_class_depends=		sizeof(_jc_java_security_cert_PKIXParameters$class_depends) / sizeof(*_jc_java_security_cert_PKIXParameters$class_depends),
		.class_depends=		_jc_java_security_cert_PKIXParameters$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=			// overridden
		&_jc_java_security_cert_PKIXParameters$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=			// overridden
		&_jc_java_security_cert_PKIXParameters$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.java_security_cert_PKIXParameters= {
	    .addCertPathChecker$eea30b9178fc230a=
		&_jc_java_security_cert_PKIXParameters$method$addCertPathChecker$eea30b9178fc230a,
	    .addCertStore$01b9214002b461b2=
		&_jc_java_security_cert_PKIXParameters$method$addCertStore$01b9214002b461b2,
	    .clone$b75f2713d6705f70=
		&_jc_java_security_cert_PKIXParameters$method$clone$b75f2713d6705f70,
	    .getCertPathCheckers$47a73ddb68a3ffcf=
		&_jc_java_security_cert_PKIXParameters$method$getCertPathCheckers$47a73ddb68a3ffcf,
	    .getCertStores$be5cd12280ba385a=
		&_jc_java_security_cert_PKIXParameters$method$getCertStores$be5cd12280ba385a,
	    .getDate$802760063d984814=
		&_jc_java_security_cert_PKIXParameters$method$getDate$802760063d984814,
	    .getInitialPolicies$e17910002b5de9e2=
		&_jc_java_security_cert_PKIXParameters$method$getInitialPolicies$e17910002b5de9e2,
	    .getPolicyQualifiersRejected$8168b6896eee8344=
		&_jc_java_security_cert_PKIXParameters$method$getPolicyQualifiersRejected$8168b6896eee8344,
	    .getSigProvider$405832a3b76f2e6a=
		&_jc_java_security_cert_PKIXParameters$method$getSigProvider$405832a3b76f2e6a,
	    .getTargetCertConstraints$6a121acf15434a44=
		&_jc_java_security_cert_PKIXParameters$method$getTargetCertConstraints$6a121acf15434a44,
	    .getTrustAnchors$c05d30658e698a09=
		&_jc_java_security_cert_PKIXParameters$method$getTrustAnchors$c05d30658e698a09,
	    .isAnyPolicyInhibited$88b480a2c636b590=
		&_jc_java_security_cert_PKIXParameters$method$isAnyPolicyInhibited$88b480a2c636b590,
	    .isExplicitPolicyRequired$4cf5e8accb7f4756=
		&_jc_java_security_cert_PKIXParameters$method$isExplicitPolicyRequired$4cf5e8accb7f4756,
	    .isPolicyMappingInhibited$30a10962bb056ed7=
		&_jc_java_security_cert_PKIXParameters$method$isPolicyMappingInhibited$30a10962bb056ed7,
	    .isRevocationEnabled$b8adf96111bc047c=
		&_jc_java_security_cert_PKIXParameters$method$isRevocationEnabled$b8adf96111bc047c,
	    .setAnyPolicyInhibited$de1dc8bd8a6b2e3e=
		&_jc_java_security_cert_PKIXParameters$method$setAnyPolicyInhibited$de1dc8bd8a6b2e3e,
	    .setCertPathCheckers$f9477fae88cb4089=
		&_jc_java_security_cert_PKIXParameters$method$setCertPathCheckers$f9477fae88cb4089,
	    .setCertStores$25972ff6264d6a32=
		&_jc_java_security_cert_PKIXParameters$method$setCertStores$25972ff6264d6a32,
	    .setDate$fdbc0baf3c293107=
		&_jc_java_security_cert_PKIXParameters$method$setDate$fdbc0baf3c293107,
	    .setExplicitPolicyRequired$cd81958a01d80602=
		&_jc_java_security_cert_PKIXParameters$method$setExplicitPolicyRequired$cd81958a01d80602,
	    .setInitialPolicies$a8c95f223a1b81cd=
		&_jc_java_security_cert_PKIXParameters$method$setInitialPolicies$a8c95f223a1b81cd,
	    .setPolicyMappingInhibited$9a37603ae194e9f6=
		&_jc_java_security_cert_PKIXParameters$method$setPolicyMappingInhibited$9a37603ae194e9f6,
	    .setPolicyQualifiersRejected$9c9b1f994f96bc63=
		&_jc_java_security_cert_PKIXParameters$method$setPolicyQualifiersRejected$9c9b1f994f96bc63,
	    .setRevocationEnabled$c11d0039e448ef66=
		&_jc_java_security_cert_PKIXParameters$method$setRevocationEnabled$c11d0039e448ef66,
	    .setSigProvider$53db79a26ea9e485=
		&_jc_java_security_cert_PKIXParameters$method$setSigProvider$53db79a26ea9e485,
	    .setTargetCertConstraints$f916b7f231333dda=
		&_jc_java_security_cert_PKIXParameters$method$setTargetCertConstraints$f916b7f231333dda,
	    .setTrustAnchors$973785f62efb8a35=
		&_jc_java_security_cert_PKIXParameters$method$setTrustAnchors$973785f62efb8a35,
	    .toString$7ea43b33b80a3070=
		&_jc_java_security_cert_PKIXParameters$method$toString$7ea43b33b80a3070,
	},
    }
};

