// class java.util.zip.DeflaterEngine

// class file dependencies
// @dep_class 49615c3d39443a4c java_lang_ArrayIndexOutOfBoundsException
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class 308333d803f5ab9f java_lang_Error
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class b7e704701c278e65 java_lang_IllegalStateException
// @dep_class 3cdfed1e0ad1a3d6 java_lang_IndexOutOfBoundsException
// @dep_class 642246d728a60038 java_lang_InternalError
// @dep_class 8d71d806a180ad8a java_lang_Math
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class 4f5534a987354d1d java_lang_RuntimeException
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 53cc8e2333795f04 java_lang_System
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class 4d1cebae0bdda058 java_lang_VMSystem
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class c7632ae877826bc6 java_lang_VirtualMachineError
// @dep_class e402919c0142085c java_util_zip_Adler32
// @dep_class 2971d0a046066ef5 java_util_zip_DeflaterConstants
// @dep_class 7c1ab2dbe97cdcfa java_util_zip_DeflaterEngine
// @dep_class c8c5fe8075e1d921 java_util_zip_DeflaterHuffman
// @dep_class cec56a9fd2873428 java_util_zip_DeflaterHuffman__24Tree
// @dep_class d277776153c42b2e java_util_zip_DeflaterPending
// @dep_class fc60c3d54c4b913a java_util_zip_PendingBuffer

// header file dependencies
// @dep_header java_lang_ArrayIndexOutOfBoundsException
// @dep_header java_lang_Class
// @dep_header java_lang_IllegalStateException
// @dep_header java_lang_InternalError
// @dep_header java_lang_Math
// @dep_header java_lang_String
// @dep_header java_lang_System
// @dep_header java_lang_VMSystem
// @dep_header java_lang_VMThrowable
// @dep_header java_util_zip_Adler32
// @dep_header java_util_zip_DeflaterConstants
// @dep_header java_util_zip_DeflaterEngine
// @dep_header java_util_zip_DeflaterHuffman
// @dep_header java_util_zip_DeflaterHuffman__24Tree
// @dep_header java_util_zip_DeflaterPending

#include "jc_defs.h"

#include "java/lang/ArrayIndexOutOfBoundsException.h"
#include "java/lang/Class.h"
#include "java/lang/IllegalStateException.h"
#include "java/lang/InternalError.h"
#include "java/lang/Math.h"
#include "java/lang/String.h"
#include "java/lang/System.h"
#include "java/lang/VMSystem.h"
#include "java/lang/VMThrowable.h"
#include "java/util/zip/Adler32.h"
#include "java/util/zip/DeflaterConstants.h"
#include "java/util/zip/DeflaterEngine.h"
#include "java/util/zip/DeflaterHuffman.h"
#include "java/util/zip/DeflaterHuffman__24Tree.h"
#include "java/util/zip/DeflaterPending.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// private static final int TOO_FAR
static const jint _jc_java_util_zip_DeflaterEngine$initial_value$TOO__5fFAR = 4096;
static _jc_field _jc_java_util_zip_DeflaterEngine$field_info$TOO__5fFAR = {
	.name=		"TOO_FAR",
	.signature=	"I",
	.class=		&_jc_java_util_zip_DeflaterEngine$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_java_util_zip_DeflaterEngine$fields_struct, TOO__5fFAR),
	.initial_value=	&_jc_java_util_zip_DeflaterEngine$initial_value$TOO__5fFAR,
};

// private int ins_h
static _jc_field _jc_java_util_zip_DeflaterEngine$field_info$ins__5fh = {
	.name=		"ins_h",
	.signature=	"I",
	.class=		&_jc_java_util_zip_DeflaterEngine$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_util_zip_DeflaterEngine$object, nonrefs.java_util_zip_DeflaterEngine.ins__5fh),
};

// private short[] head
static _jc_field _jc_java_util_zip_DeflaterEngine$field_info$head = {
	.name=		"head",
	.signature=	"[S",
	.class=		&_jc_java_util_zip_DeflaterEngine$type,
	.type=		&_jc_short$array$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_util_zip_DeflaterEngine$object, refs[-1].java_util_zip_DeflaterEngine.head),
};

// private short[] prev
static _jc_field _jc_java_util_zip_DeflaterEngine$field_info$prev = {
	.name=		"prev",
	.signature=	"[S",
	.class=		&_jc_java_util_zip_DeflaterEngine$type,
	.type=		&_jc_short$array$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_util_zip_DeflaterEngine$object, refs[-1].java_util_zip_DeflaterEngine.prev),
};

// private int matchStart
static _jc_field _jc_java_util_zip_DeflaterEngine$field_info$matchStart = {
	.name=		"matchStart",
	.signature=	"I",
	.class=		&_jc_java_util_zip_DeflaterEngine$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_util_zip_DeflaterEngine$object, nonrefs.java_util_zip_DeflaterEngine.matchStart),
};

// private int matchLen
static _jc_field _jc_java_util_zip_DeflaterEngine$field_info$matchLen = {
	.name=		"matchLen",
	.signature=	"I",
	.class=		&_jc_java_util_zip_DeflaterEngine$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_util_zip_DeflaterEngine$object, nonrefs.java_util_zip_DeflaterEngine.matchLen),
};

// private boolean prevAvailable
static _jc_field _jc_java_util_zip_DeflaterEngine$field_info$prevAvailable = {
	.name=		"prevAvailable",
	.signature=	"Z",
	.class=		&_jc_java_util_zip_DeflaterEngine$type,
	.type=		&_jc_boolean$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_util_zip_DeflaterEngine$object, nonrefs.java_util_zip_DeflaterEngine.prevAvailable),
};

// private int blockStart
static _jc_field _jc_java_util_zip_DeflaterEngine$field_info$blockStart = {
	.name=		"blockStart",
	.signature=	"I",
	.class=		&_jc_java_util_zip_DeflaterEngine$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_util_zip_DeflaterEngine$object, nonrefs.java_util_zip_DeflaterEngine.blockStart),
};

// private int strstart
static _jc_field _jc_java_util_zip_DeflaterEngine$field_info$strstart = {
	.name=		"strstart",
	.signature=	"I",
	.class=		&_jc_java_util_zip_DeflaterEngine$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_util_zip_DeflaterEngine$object, nonrefs.java_util_zip_DeflaterEngine.strstart),
};

// private int lookahead
static _jc_field _jc_java_util_zip_DeflaterEngine$field_info$lookahead = {
	.name=		"lookahead",
	.signature=	"I",
	.class=		&_jc_java_util_zip_DeflaterEngine$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_util_zip_DeflaterEngine$object, nonrefs.java_util_zip_DeflaterEngine.lookahead),
};

// private byte[] window
static _jc_field _jc_java_util_zip_DeflaterEngine$field_info$window = {
	.name=		"window",
	.signature=	"[B",
	.class=		&_jc_java_util_zip_DeflaterEngine$type,
	.type=		&_jc_byte$array$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_util_zip_DeflaterEngine$object, refs[-1].java_util_zip_DeflaterEngine.window),
};

// private int strategy
static _jc_field _jc_java_util_zip_DeflaterEngine$field_info$strategy = {
	.name=		"strategy",
	.signature=	"I",
	.class=		&_jc_java_util_zip_DeflaterEngine$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_util_zip_DeflaterEngine$object, nonrefs.java_util_zip_DeflaterEngine.strategy),
};

// private int max_chain
static _jc_field _jc_java_util_zip_DeflaterEngine$field_info$max__5fchain = {
	.name=		"max_chain",
	.signature=	"I",
	.class=		&_jc_java_util_zip_DeflaterEngine$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_util_zip_DeflaterEngine$object, nonrefs.java_util_zip_DeflaterEngine.max__5fchain),
};

// private int max_lazy
static _jc_field _jc_java_util_zip_DeflaterEngine$field_info$max__5flazy = {
	.name=		"max_lazy",
	.signature=	"I",
	.class=		&_jc_java_util_zip_DeflaterEngine$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_util_zip_DeflaterEngine$object, nonrefs.java_util_zip_DeflaterEngine.max__5flazy),
};

// private int niceLength
static _jc_field _jc_java_util_zip_DeflaterEngine$field_info$niceLength = {
	.name=		"niceLength",
	.signature=	"I",
	.class=		&_jc_java_util_zip_DeflaterEngine$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_util_zip_DeflaterEngine$object, nonrefs.java_util_zip_DeflaterEngine.niceLength),
};

// private int goodLength
static _jc_field _jc_java_util_zip_DeflaterEngine$field_info$goodLength = {
	.name=		"goodLength",
	.signature=	"I",
	.class=		&_jc_java_util_zip_DeflaterEngine$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_util_zip_DeflaterEngine$object, nonrefs.java_util_zip_DeflaterEngine.goodLength),
};

// private int comprFunc
static _jc_field _jc_java_util_zip_DeflaterEngine$field_info$comprFunc = {
	.name=		"comprFunc",
	.signature=	"I",
	.class=		&_jc_java_util_zip_DeflaterEngine$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_util_zip_DeflaterEngine$object, nonrefs.java_util_zip_DeflaterEngine.comprFunc),
};

// private byte[] inputBuf
static _jc_field _jc_java_util_zip_DeflaterEngine$field_info$inputBuf = {
	.name=		"inputBuf",
	.signature=	"[B",
	.class=		&_jc_java_util_zip_DeflaterEngine$type,
	.type=		&_jc_byte$array$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_util_zip_DeflaterEngine$object, refs[-1].java_util_zip_DeflaterEngine.inputBuf),
};

// private int totalIn
static _jc_field _jc_java_util_zip_DeflaterEngine$field_info$totalIn = {
	.name=		"totalIn",
	.signature=	"I",
	.class=		&_jc_java_util_zip_DeflaterEngine$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_util_zip_DeflaterEngine$object, nonrefs.java_util_zip_DeflaterEngine.totalIn),
};

// private int inputOff
static _jc_field _jc_java_util_zip_DeflaterEngine$field_info$inputOff = {
	.name=		"inputOff",
	.signature=	"I",
	.class=		&_jc_java_util_zip_DeflaterEngine$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_util_zip_DeflaterEngine$object, nonrefs.java_util_zip_DeflaterEngine.inputOff),
};

// private int inputEnd
static _jc_field _jc_java_util_zip_DeflaterEngine$field_info$inputEnd = {
	.name=		"inputEnd",
	.signature=	"I",
	.class=		&_jc_java_util_zip_DeflaterEngine$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_util_zip_DeflaterEngine$object, nonrefs.java_util_zip_DeflaterEngine.inputEnd),
};

// private java.util.zip.DeflaterPending pending
static _jc_field _jc_java_util_zip_DeflaterEngine$field_info$pending = {
	.name=		"pending",
	.signature=	"Ljava/util/zip/DeflaterPending;",
	.class=		&_jc_java_util_zip_DeflaterEngine$type,
	.type=		&_jc_java_util_zip_DeflaterPending$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_util_zip_DeflaterEngine$object, refs[-1].java_util_zip_DeflaterEngine.pending),
};

// private java.util.zip.DeflaterHuffman huffman
static _jc_field _jc_java_util_zip_DeflaterEngine$field_info$huffman = {
	.name=		"huffman",
	.signature=	"Ljava/util/zip/DeflaterHuffman;",
	.class=		&_jc_java_util_zip_DeflaterEngine$type,
	.type=		&_jc_java_util_zip_DeflaterHuffman$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_util_zip_DeflaterEngine$object, refs[-1].java_util_zip_DeflaterEngine.huffman),
};

// private java.util.zip.Adler32 adler
static _jc_field _jc_java_util_zip_DeflaterEngine$field_info$adler = {
	.name=		"adler",
	.signature=	"Ljava/util/zip/Adler32;",
	.class=		&_jc_java_util_zip_DeflaterEngine$type,
	.type=		&_jc_java_util_zip_Adler32$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_util_zip_DeflaterEngine$object, refs[-1].java_util_zip_DeflaterEngine.adler),
};

// Fields
static _jc_field *const _jc_java_util_zip_DeflaterEngine$fields[] = {
	&_jc_java_util_zip_DeflaterEngine$field_info$TOO__5fFAR,
	&_jc_java_util_zip_DeflaterEngine$field_info$adler,
	&_jc_java_util_zip_DeflaterEngine$field_info$head,
	&_jc_java_util_zip_DeflaterEngine$field_info$huffman,
	&_jc_java_util_zip_DeflaterEngine$field_info$inputBuf,
	&_jc_java_util_zip_DeflaterEngine$field_info$pending,
	&_jc_java_util_zip_DeflaterEngine$field_info$prev,
	&_jc_java_util_zip_DeflaterEngine$field_info$window,
	&_jc_java_util_zip_DeflaterEngine$field_info$blockStart,
	&_jc_java_util_zip_DeflaterEngine$field_info$comprFunc,
	&_jc_java_util_zip_DeflaterEngine$field_info$goodLength,
	&_jc_java_util_zip_DeflaterEngine$field_info$inputEnd,
	&_jc_java_util_zip_DeflaterEngine$field_info$inputOff,
	&_jc_java_util_zip_DeflaterEngine$field_info$ins__5fh,
	&_jc_java_util_zip_DeflaterEngine$field_info$lookahead,
	&_jc_java_util_zip_DeflaterEngine$field_info$matchLen,
	&_jc_java_util_zip_DeflaterEngine$field_info$matchStart,
	&_jc_java_util_zip_DeflaterEngine$field_info$max__5fchain,
	&_jc_java_util_zip_DeflaterEngine$field_info$max__5flazy,
	&_jc_java_util_zip_DeflaterEngine$field_info$niceLength,
	&_jc_java_util_zip_DeflaterEngine$field_info$strategy,
	&_jc_java_util_zip_DeflaterEngine$field_info$strstart,
	&_jc_java_util_zip_DeflaterEngine$field_info$totalIn,
	&_jc_java_util_zip_DeflaterEngine$field_info$prevAvailable
};

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// void <init>(java.util.zip.DeflaterPending)
//

static _jc_linenum _jc_java_util_zip_DeflaterEngine$linenum_table$_init$c47deb6e52e030ad[];

static const unsigned char _jc_java_util_zip_DeflaterEngine$param_ptypes$_init$c47deb6e52e030ad[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_util_zip_DeflaterEngine$param_types$_init$c47deb6e52e030ad[] = {
	&_jc_java_util_zip_DeflaterPending$type
};

_jc_method _jc_java_util_zip_DeflaterEngine$method_info$_init$c47deb6e52e030ad = {
	.name=			"<init>",
	.signature=		"(Ljava/util/zip/DeflaterPending;)V",
	.class=			&_jc_java_util_zip_DeflaterEngine$type,
	.param_types=		&_jc_java_util_zip_DeflaterEngine$param_types$_init$c47deb6e52e030ad,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_util_zip_DeflaterEngine$param_ptypes$_init$c47deb6e52e030ad,
	.signature_hash=	_JC_JLONG(0xc47deb6e52e030ad),
	.access_flags=		0,
	.function=		&_jc_java_util_zip_DeflaterEngine$method$_init$c47deb6e52e030ad,
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	8,
	      .table=	_jc_java_util_zip_DeflaterEngine$linenum_table$_init$c47deb6e52e030ad
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_util_zip_DeflaterEngine, _init$c47deb6e52e030ad);

void _JC_JCNI_ATTR
_jc_java_util_zip_DeflaterEngine$method$_init$c47deb6e52e030ad(_jc_env *const env, _jc_java_util_zip_DeflaterEngine$object *this, _jc_java_util_zip_DeflaterPending$object *param0)
{
	struct _jc_java_util_zip_DeflaterEngine$object *r0;
	struct _jc_java_util_zip_DeflaterPending$object *r1;
	struct _jc_java_util_zip_DeflaterHuffman$object *r2;
	struct _jc_java_util_zip_Adler32$object *r3;
	_jc_byte_array *r4;
	_jc_short_array *r5;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(126);				// 0
	_JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, pending) = r1;
	_JC_LINE_NUMBER(127);				// 1
	r2 = _JC_NEW(env, java_util_zip_DeflaterHuffman);
	_JC_INVOKE_NONVIRTUAL(env, java_util_zip_DeflaterHuffman, _init$c47deb6e52e030ad, 0, r2, r1);
	_JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, huffman) = r2;
	_JC_LINE_NUMBER(128);				// 2
	r3 = _JC_NEW(env, java_util_zip_Adler32);
	_JC_PRIM_FIELD(env, r3, java_util_zip_Adler32, checksum) = 1;
	_JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, adler) = r3;
	_JC_LINE_NUMBER(130);				// 3
	r4 = _JC_NEW_PRIM_ARRAY(env, byte, 1, 65536);
	_JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, window) = r4;
	_JC_LINE_NUMBER(131);				// 4
	r5 = _JC_NEW_PRIM_ARRAY(env, short, 1, 32768);
	_JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, head) = r5;
	_JC_LINE_NUMBER(132);				// 5
	r5 = _JC_NEW_PRIM_ARRAY(env, short, 1, 32768);
	_JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, prev) = r5;
	_JC_LINE_NUMBER(137);				// 6
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart) = 1;
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, blockStart) = 1;
	_JC_LINE_NUMBER(138);				// 7
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public boolean deflate(boolean, boolean)
//

static _jc_linenum _jc_java_util_zip_DeflaterEngine$linenum_table$deflate$520181c945544c4f[];

static const unsigned char _jc_java_util_zip_DeflaterEngine$param_ptypes$deflate$520181c945544c4f[] = { 
_JC_TYPE_BOOLEAN, _JC_TYPE_BOOLEAN, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_java_util_zip_DeflaterEngine$param_types$deflate$520181c945544c4f[] = {
	&_jc_boolean$prim$type,
	&_jc_boolean$prim$type
};

_jc_method _jc_java_util_zip_DeflaterEngine$method_info$deflate$520181c945544c4f = {
	.name=			"deflate",
	.signature=		"(ZZ)Z",
	.class=			&_jc_java_util_zip_DeflaterEngine$type,
	.param_types=		&_jc_java_util_zip_DeflaterEngine$param_types$deflate$520181c945544c4f,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_java_util_zip_DeflaterEngine$param_ptypes$deflate$520181c945544c4f,
	.signature_hash=	_JC_JLONG(0x520181c945544c4f),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_util_zip_DeflaterEngine$method$deflate$520181c945544c4f,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_util_zip_DeflaterEngine$vtable, java_util_zip_DeflaterEngine.deflate$520181c945544c4f) / sizeof(void *),
	.num_parameters=	2,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	12,
	      .table=	_jc_java_util_zip_DeflaterEngine$linenum_table$deflate$520181c945544c4f
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_util_zip_DeflaterEngine, deflate$520181c945544c4f);

jboolean _JC_JCNI_ATTR
_jc_java_util_zip_DeflaterEngine$method$deflate$520181c945544c4f(_jc_env *const env, _jc_java_util_zip_DeflaterEngine$object *this, jboolean param0, jboolean param1)
{
	jint i0;
	jint i1;
	jint i2;
	struct _jc_java_util_zip_DeflaterEngine$object *r0;
	struct _jc_java_lang_InternalError$object *r1;
	struct _jc_java_util_zip_DeflaterPending$object *r2;
	struct _jc_java_lang_String$object *r3;
	struct _jc_java_lang_VMThrowable$object *r4;
	jboolean z0;
	jboolean z1;
	jboolean z2;
	jboolean z4;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	z0 = param0;
	z1 = param1;

label0:
	_JC_LINE_NUMBER(647);				// 0
	_JC_INVOKE_NONVIRTUAL(env, java_util_zip_DeflaterEngine, fillWindow$77cf11d66ae57992, 0, r0);
	_JC_LINE_NUMBER(648);				// 1
	z2 = 0;
	if (z0 == 0)
		goto label1;
	i0 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, inputOff);
	i1 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, inputEnd);
	if (i0 != i1)
		goto label1;
	z2 = 1;

label1:
	_JC_LINE_NUMBER(652);				// 2
	i1 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, comprFunc);
	switch (i1) {
	case 0:
		goto label2;
	case 1:
		goto label3;
	case 2:
		goto label4;
	default:
		goto label5;
	}

label2:
	_JC_LINE_NUMBER(655);				// 3
	z2 = _JC_INVOKE_NONVIRTUAL(env, java_util_zip_DeflaterEngine, deflateStored$f1f36fb4ca70b320, 0, r0, z2, z1);
	_JC_LINE_NUMBER(656);				// 4
	goto label6;

label3:
	_JC_LINE_NUMBER(658);				// 5
	z2 = _JC_INVOKE_NONVIRTUAL(env, java_util_zip_DeflaterEngine, deflateFast$63a2665efd930ca7, 0, r0, z2, z1);
	_JC_LINE_NUMBER(659);				// 6
	goto label6;

label4:
	_JC_LINE_NUMBER(661);				// 7
	z2 = _JC_INVOKE_NONVIRTUAL(env, java_util_zip_DeflaterEngine, deflateSlow$82fdac4aec7d01c4, 0, r0, z2, z1);
	_JC_LINE_NUMBER(662);				// 8
	goto label6;

label5:
	_JC_LINE_NUMBER(664);				// 9
	r1 = _JC_NEW(env, java_lang_InternalError);
	r3 = _JC_NULL;
	_JC_REF_FIELD(env, r1, java_lang_Throwable, cause) = r1;
	r4 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r1);
	_JC_REF_FIELD(env, r1, java_lang_Throwable, vmState) = r4;
	_JC_REF_FIELD(env, r1, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r1, java_lang_Throwable, detailMessage) = r3;
	_JC_THROW(env, r1);

label6:
	_JC_LINE_NUMBER(667);				// 10
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, pending);
	_JC_EXPLICIT_NULL_CHECK(env, r2);
	z4 = 0;
	i2 = _JC_PRIM_FIELD(env, r2, java_util_zip_PendingBuffer, end);
	if (i2 != 0)
		goto label7;
	z4 = 1;

label7:
	if (z4 == 0)
		goto label8;
	if (z2 != 0) {
		_JC_PERIODIC_CHECK(env);
		goto label0;
	}

label8:
	_JC_LINE_NUMBER(670);				// 11
	return z2;
}

//
// private final boolean deflateFast(boolean, boolean)
//

static _jc_linenum _jc_java_util_zip_DeflaterEngine$linenum_table$deflateFast$63a2665efd930ca7[];

static const unsigned char _jc_java_util_zip_DeflaterEngine$param_ptypes$deflateFast$63a2665efd930ca7[] = { 
_JC_TYPE_BOOLEAN, _JC_TYPE_BOOLEAN, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_java_util_zip_DeflaterEngine$param_types$deflateFast$63a2665efd930ca7[] = {
	&_jc_boolean$prim$type,
	&_jc_boolean$prim$type
};

_jc_method _jc_java_util_zip_DeflaterEngine$method_info$deflateFast$63a2665efd930ca7 = {
	.name=			"deflateFast",
	.signature=		"(ZZ)Z",
	.class=			&_jc_java_util_zip_DeflaterEngine$type,
	.param_types=		&_jc_java_util_zip_DeflaterEngine$param_types$deflateFast$63a2665efd930ca7,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_java_util_zip_DeflaterEngine$param_ptypes$deflateFast$63a2665efd930ca7,
	.signature_hash=	_JC_JLONG(0x63a2665efd930ca7),
	.access_flags=		_JC_ACC_PRIVATE|_JC_ACC_FINAL,
	.function=		&_jc_java_util_zip_DeflaterEngine$method$deflateFast$63a2665efd930ca7,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_util_zip_DeflaterEngine$vtable, java_util_zip_DeflaterEngine.deflateFast$63a2665efd930ca7) / sizeof(void *),
	.num_parameters=	2,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	31,
	      .table=	_jc_java_util_zip_DeflaterEngine$linenum_table$deflateFast$63a2665efd930ca7
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_util_zip_DeflaterEngine, deflateFast$63a2665efd930ca7);

jboolean _JC_JCNI_ATTR
_jc_java_util_zip_DeflaterEngine$method$deflateFast$63a2665efd930ca7(_jc_env *const env, _jc_java_util_zip_DeflaterEngine$object *this, jboolean param0, jboolean param1)
{
	jbyte b3;
	jbyte b7;
	jint i0;
	jint i1;
	jint i2;
	jint i5;
	jint i6;
	jint i8;
	struct _jc_java_util_zip_DeflaterEngine$object *r0;
	struct _jc_java_util_zip_DeflaterHuffman$object *r1;
	_jc_byte_array *r2;
	_jc_byte_array *r4;
	jshort s4;
	jboolean z0;
	jboolean z1;
	jboolean z2;
	jboolean z3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	z0 = param0;
	z1 = param1;
	_JC_LINE_NUMBER(461);				// 0
	i0 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, lookahead);
	if (i0 >= 262)
		goto label10;
	if (z0 != 0)
		goto label10;
	_JC_LINE_NUMBER(462);				// 1
	return 0;

label0:
	_JC_LINE_NUMBER(466);				// 2
	i0 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, lookahead);
	if (i0 != 0)
		goto label1;
	_JC_LINE_NUMBER(469);				// 3
	r1 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, huffman);
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, window);
	i0 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, blockStart);
	i1 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, blockStart);
	i2 = i1 - i2;
	_JC_INVOKE_VIRTUAL(env, java_util_zip_DeflaterHuffman, flushBlock$26c7840b1df1248b, r1, r2, i0, i2, z1);
	_JC_LINE_NUMBER(471);				// 4
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, blockStart) = i2;
	_JC_LINE_NUMBER(472);				// 5
	return 0;

label1:
	_JC_LINE_NUMBER(475);				// 6
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	if (i2 <= 65274)
		goto label2;
	_JC_LINE_NUMBER(481);				// 7
	_JC_INVOKE_NONVIRTUAL(env, java_util_zip_DeflaterEngine, slideWindow$558e7b830046acb5, 0, r0);

label2:
	_JC_LINE_NUMBER(485);				// 8
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, lookahead);
	if (i2 < 3)
		goto label7;
	i2 = _JC_INVOKE_NONVIRTUAL(env, java_util_zip_DeflaterEngine, insertString$b2529a8b0b649b46, 0, r0);
	i0 = i2;
	if (i2 == 0)
		goto label7;
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strategy);
	if (i2 == 2)
		goto label7;
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	i2 = i2 - i0;
	if (i2 > 32506)
		goto label7;
	z2 = _JC_INVOKE_NONVIRTUAL(env, java_util_zip_DeflaterEngine, findLongestMatch$0506e2d673e8302b, 0, r0, i0);
	if (z2 == 0)
		goto label7;
	_JC_LINE_NUMBER(500);				// 9
	r1 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, huffman);
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	i1 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, matchStart);
	i2 = i2 - i1;
	i1 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, matchLen);
	_JC_INVOKE_NONVIRTUAL(env, java_util_zip_DeflaterHuffman, tallyDist$d4a2692300c2b499, 1, r1, i2, i1);
	_JC_LINE_NUMBER(502);				// 10
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, lookahead);
	i1 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, matchLen);
	i2 = i2 - i1;
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, lookahead) = i2;
	_JC_LINE_NUMBER(503);				// 11
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, matchLen);
	i1 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, max__5flazy);
	if (i2 > i1)
		goto label5;
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, lookahead);
	if (i2 < 3)
		goto label5;
	_JC_LINE_NUMBER(505);				// 12
	goto label4;

label3:
	_JC_LINE_NUMBER(507);				// 13
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	i2 = i2 + 1;
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart) = i2;
	_JC_LINE_NUMBER(508);				// 14
	_JC_INVOKE_NONVIRTUAL(env, java_util_zip_DeflaterEngine, insertString$b2529a8b0b649b46, 0, r0);

label4:
	_JC_LINE_NUMBER(505);				// 15
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, matchLen);
	i2 = i2 - 1;
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, matchLen) = i2;
	if (i2 > 0) {
		_JC_PERIODIC_CHECK(env);
		goto label3;
	}
	_JC_LINE_NUMBER(510);				// 16
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	i2 = i2 + 1;
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart) = i2;
	goto label6;

label5:
	_JC_LINE_NUMBER(514);				// 17
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	i1 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, matchLen);
	i2 = i2 + i1;
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart) = i2;
	_JC_LINE_NUMBER(515);				// 18
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, lookahead);
	if (i2 < 2)
		goto label6;
	r4 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, window);
	i6 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	b7 = _JC_PRIM_ELEMENT(env, byte, r4, i6, 1, 1);
	i6 = b7 << (5 & 0x1f);
	r4 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, window);
	i8 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	i8 = i8 + 1;
	b7 = _JC_PRIM_ELEMENT(env, byte, r4, i8, 1, 1);
	i8 = i6 ^ b7;
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, ins__5fh) = i8;

label6:
	_JC_LINE_NUMBER(518);				// 19
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, matchLen) = 2;
	_JC_LINE_NUMBER(519);				// 20
	goto label10;

label7:
	_JC_LINE_NUMBER(524);				// 21
	r1 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, huffman);
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, window);
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	b3 = _JC_PRIM_ELEMENT(env, byte, r2, i2, 1, 1);
	s4 = b3 & 255;
	_JC_INVOKE_NONVIRTUAL(env, java_util_zip_DeflaterHuffman, tallyLit$5849b15b22c9b739, 1, r1, s4);
	_JC_LINE_NUMBER(525);				// 22
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	i2 = i2 + 1;
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart) = i2;
	_JC_LINE_NUMBER(526);				// 23
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, lookahead);
	i2 = i2 - 1;
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, lookahead) = i2;
	_JC_LINE_NUMBER(529);				// 24
	r1 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, huffman);
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	z3 = 0;
	i5 = _JC_PRIM_FIELD(env, r1, java_util_zip_DeflaterHuffman, last__5flit);
	if (i5 != 16384)
		goto label8;
	z3 = 1;

label8:
	if (z3 == 0)
		goto label10;
	_JC_LINE_NUMBER(531);				// 25
	z2 = 0;
	if (z1 == 0)
		goto label9;
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, lookahead);
	if (i2 != 0)
		goto label9;
	z2 = 1;

label9:
	_JC_LINE_NUMBER(532);				// 26
	r1 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, huffman);
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, window);
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, blockStart);
	i1 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	i0 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, blockStart);
	i1 = i1 - i0;
	_JC_INVOKE_VIRTUAL(env, java_util_zip_DeflaterHuffman, flushBlock$26c7840b1df1248b, r1, r2, i2, i1, z2);
	_JC_LINE_NUMBER(534);				// 27
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, blockStart) = i2;
	_JC_LINE_NUMBER(535);				// 28
	z2 = z2 ^ 1;
	return z2;

label10:
	_JC_LINE_NUMBER(464);				// 29
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, lookahead);
	if (i2 >= 262) {
		_JC_PERIODIC_CHECK(env);
		goto label0;
	}
	if (z0 != 0) {
		_JC_PERIODIC_CHECK(env);
		goto label0;
	}
	_JC_LINE_NUMBER(538);				// 30
	return 1;
}

//
// private final boolean deflateSlow(boolean, boolean)
//

static _jc_linenum _jc_java_util_zip_DeflaterEngine$linenum_table$deflateSlow$82fdac4aec7d01c4[];

static const unsigned char _jc_java_util_zip_DeflaterEngine$param_ptypes$deflateSlow$82fdac4aec7d01c4[] = { 
_JC_TYPE_BOOLEAN, _JC_TYPE_BOOLEAN, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_java_util_zip_DeflaterEngine$param_types$deflateSlow$82fdac4aec7d01c4[] = {
	&_jc_boolean$prim$type,
	&_jc_boolean$prim$type
};

_jc_method _jc_java_util_zip_DeflaterEngine$method_info$deflateSlow$82fdac4aec7d01c4 = {
	.name=			"deflateSlow",
	.signature=		"(ZZ)Z",
	.class=			&_jc_java_util_zip_DeflaterEngine$type,
	.param_types=		&_jc_java_util_zip_DeflaterEngine$param_types$deflateSlow$82fdac4aec7d01c4,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_java_util_zip_DeflaterEngine$param_ptypes$deflateSlow$82fdac4aec7d01c4,
	.signature_hash=	_JC_JLONG(0x82fdac4aec7d01c4),
	.access_flags=		_JC_ACC_PRIVATE|_JC_ACC_FINAL,
	.function=		&_jc_java_util_zip_DeflaterEngine$method$deflateSlow$82fdac4aec7d01c4,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_util_zip_DeflaterEngine$vtable, java_util_zip_DeflaterEngine.deflateSlow$82fdac4aec7d01c4) / sizeof(void *),
	.num_parameters=	2,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	45,
	      .table=	_jc_java_util_zip_DeflaterEngine$linenum_table$deflateSlow$82fdac4aec7d01c4
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_util_zip_DeflaterEngine, deflateSlow$82fdac4aec7d01c4);

jboolean _JC_JCNI_ATTR
_jc_java_util_zip_DeflaterEngine$method$deflateSlow$82fdac4aec7d01c4(_jc_env *const env, _jc_java_util_zip_DeflaterEngine$object *this, jboolean param0, jboolean param1)
{
	jbyte b3;
	jint i0;
	jint i1;
	jint i2;
	jint i5;
	jint i6;
	struct _jc_java_util_zip_DeflaterEngine$object *r0;
	struct _jc_java_util_zip_DeflaterHuffman$object *r1;
	_jc_byte_array *r2;
	jshort s4;
	jboolean z0;
	jboolean z1;
	jboolean z2;
	jboolean z3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	z0 = param0;
	z1 = param1;
	_JC_LINE_NUMBER(543);				// 0
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, lookahead);
	if (i2 >= 262)
		goto label14;
	if (z0 != 0)
		goto label14;
	_JC_LINE_NUMBER(544);				// 1
	return 0;

label0:
	_JC_LINE_NUMBER(548);				// 2
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, lookahead);
	if (i2 != 0)
		goto label2;
	_JC_LINE_NUMBER(550);				// 3
	z0 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, prevAvailable);
	if (z0 == 0)
		goto label1;
	_JC_LINE_NUMBER(551);				// 4
	r1 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, huffman);
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, window);
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	i2 = i2 - 1;
	b3 = _JC_PRIM_ELEMENT(env, byte, r2, i2, 1, 1);
	s4 = b3 & 255;
	_JC_INVOKE_NONVIRTUAL(env, java_util_zip_DeflaterHuffman, tallyLit$5849b15b22c9b739, 1, r1, s4);

label1:
	_JC_LINE_NUMBER(552);				// 5
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, prevAvailable) = 0;
	_JC_LINE_NUMBER(557);				// 6
	r1 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, huffman);
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, window);
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, blockStart);
	i1 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	i0 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, blockStart);
	i1 = i1 - i0;
	_JC_INVOKE_VIRTUAL(env, java_util_zip_DeflaterHuffman, flushBlock$26c7840b1df1248b, r1, r2, i2, i1, z1);
	_JC_LINE_NUMBER(559);				// 7
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, blockStart) = i2;
	_JC_LINE_NUMBER(560);				// 8
	return 0;

label2:
	_JC_LINE_NUMBER(563);				// 9
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	if (i2 < 65274)
		goto label3;
	_JC_LINE_NUMBER(569);				// 10
	_JC_INVOKE_NONVIRTUAL(env, java_util_zip_DeflaterEngine, slideWindow$558e7b830046acb5, 0, r0);

label3:
	_JC_LINE_NUMBER(572);				// 11
	i0 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, matchStart);
	_JC_LINE_NUMBER(573);				// 12
	i1 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, matchLen);
	_JC_LINE_NUMBER(574);				// 13
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, lookahead);
	if (i2 < 3)
		goto label5;
	_JC_LINE_NUMBER(576);				// 14
	i2 = _JC_INVOKE_NONVIRTUAL(env, java_util_zip_DeflaterEngine, insertString$b2529a8b0b649b46, 0, r0);
	_JC_LINE_NUMBER(577);				// 15
	i5 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strategy);
	if (i5 == 2)
		goto label5;
	if (i2 == 0)
		goto label5;
	i5 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	i5 = i5 - i2;
	if (i5 > 32506)
		goto label5;
	z2 = _JC_INVOKE_NONVIRTUAL(env, java_util_zip_DeflaterEngine, findLongestMatch$0506e2d673e8302b, 0, r0, i2);
	if (z2 == 0)
		goto label5;
	_JC_LINE_NUMBER(584);				// 16
	i5 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, matchLen);
	if (i5 > 5)
		goto label5;
	i5 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strategy);
	if (i5 == 1)
		goto label4;
	i5 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, matchLen);
	if (i5 != 3)
		goto label5;
	i5 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, matchStart);
	i5 = i5 - i2;
	if (i5 <= 4096)
		goto label5;

label4:
	_JC_LINE_NUMBER(588);				// 17
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, matchLen) = 2;

label5:
	_JC_LINE_NUMBER(594);				// 18
	if (i1 < 3)
		goto label8;
	i5 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, matchLen);
	if (i5 > i1)
		goto label8;
	_JC_LINE_NUMBER(604);				// 19
	r1 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, huffman);
	i5 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	i5 = i5 - 1;
	i5 = i5 - i0;
	_JC_INVOKE_NONVIRTUAL(env, java_util_zip_DeflaterHuffman, tallyDist$d4a2692300c2b499, 1, r1, i5, i1);
	_JC_LINE_NUMBER(605);				// 20
	i5 = i1 + -2;

label6:
	_JC_LINE_NUMBER(608);				// 21
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	i2 = i2 + 1;
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart) = i2;
	_JC_LINE_NUMBER(609);				// 22
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, lookahead);
	i2 = i2 - 1;
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, lookahead) = i2;
	_JC_LINE_NUMBER(610);				// 23
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, lookahead);
	if (i2 < 3)
		goto label7;
	_JC_LINE_NUMBER(611);				// 24
	_JC_INVOKE_NONVIRTUAL(env, java_util_zip_DeflaterEngine, insertString$b2529a8b0b649b46, 0, r0);

label7:
	_JC_LINE_NUMBER(613);				// 25
	i5 = i5 + -1;
	if (i5 > 0) {
		_JC_PERIODIC_CHECK(env);
		goto label6;
	}
	_JC_LINE_NUMBER(614);				// 26
	i5 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	i5 = i5 + 1;
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart) = i5;
	_JC_LINE_NUMBER(615);				// 27
	i5 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, lookahead);
	i5 = i5 - 1;
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, lookahead) = i5;
	_JC_LINE_NUMBER(616);				// 28
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, prevAvailable) = 0;
	_JC_LINE_NUMBER(617);				// 29
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, matchLen) = 2;
	goto label10;

label8:
	_JC_LINE_NUMBER(621);				// 30
	z2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, prevAvailable);
	if (z2 == 0)
		goto label9;
	_JC_LINE_NUMBER(622);				// 31
	r1 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, huffman);
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, window);
	i5 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	i5 = i5 - 1;
	b3 = _JC_PRIM_ELEMENT(env, byte, r2, i5, 1, 1);
	s4 = b3 & 255;
	_JC_INVOKE_NONVIRTUAL(env, java_util_zip_DeflaterHuffman, tallyLit$5849b15b22c9b739, 1, r1, s4);

label9:
	_JC_LINE_NUMBER(623);				// 32
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, prevAvailable) = 1;
	_JC_LINE_NUMBER(624);				// 33
	i5 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	i5 = i5 + 1;
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart) = i5;
	_JC_LINE_NUMBER(625);				// 34
	i5 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, lookahead);
	i5 = i5 - 1;
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, lookahead) = i5;

label10:
	_JC_LINE_NUMBER(628);				// 35
	r1 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, huffman);
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	z3 = 0;
	i6 = _JC_PRIM_FIELD(env, r1, java_util_zip_DeflaterHuffman, last__5flit);
	if (i6 != 16384)
		goto label11;
	z3 = 1;

label11:
	if (z3 == 0)
		goto label14;
	_JC_LINE_NUMBER(630);				// 36
	i5 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, blockStart);
	i5 = i5 - i2;
	_JC_LINE_NUMBER(631);				// 37
	z2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, prevAvailable);
	if (z2 == 0)
		goto label12;
	_JC_LINE_NUMBER(632);				// 38
	i5 = i5 + -1;

label12:
	_JC_LINE_NUMBER(633);				// 39
	z2 = 0;
	if (z1 == 0)
		goto label13;
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, lookahead);
	if (i2 != 0)
		goto label13;
	z1 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, prevAvailable);
	if (z1 != 0)
		goto label13;
	z2 = 1;

label13:
	_JC_LINE_NUMBER(634);				// 40
	r1 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, huffman);
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, window);
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, blockStart);
	_JC_INVOKE_VIRTUAL(env, java_util_zip_DeflaterHuffman, flushBlock$26c7840b1df1248b, r1, r2, i2, i5, z2);
	_JC_LINE_NUMBER(635);				// 41
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, blockStart);
	i5 = i2 + i5;
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, blockStart) = i5;
	_JC_LINE_NUMBER(636);				// 42
	z2 = z2 ^ 1;
	return z2;

label14:
	_JC_LINE_NUMBER(546);				// 43
	i5 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, lookahead);
	if (i5 >= 262) {
		_JC_PERIODIC_CHECK(env);
		goto label0;
	}
	if (z0 != 0) {
		_JC_PERIODIC_CHECK(env);
		goto label0;
	}
	_JC_LINE_NUMBER(639);				// 44
	return 1;
}

//
// private final boolean deflateStored(boolean, boolean)
//

static _jc_linenum _jc_java_util_zip_DeflaterEngine$linenum_table$deflateStored$f1f36fb4ca70b320[];

static const unsigned char _jc_java_util_zip_DeflaterEngine$param_ptypes$deflateStored$f1f36fb4ca70b320[] = { 
_JC_TYPE_BOOLEAN, _JC_TYPE_BOOLEAN, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_java_util_zip_DeflaterEngine$param_types$deflateStored$f1f36fb4ca70b320[] = {
	&_jc_boolean$prim$type,
	&_jc_boolean$prim$type
};

_jc_method _jc_java_util_zip_DeflaterEngine$method_info$deflateStored$f1f36fb4ca70b320 = {
	.name=			"deflateStored",
	.signature=		"(ZZ)Z",
	.class=			&_jc_java_util_zip_DeflaterEngine$type,
	.param_types=		&_jc_java_util_zip_DeflaterEngine$param_types$deflateStored$f1f36fb4ca70b320,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_java_util_zip_DeflaterEngine$param_ptypes$deflateStored$f1f36fb4ca70b320,
	.signature_hash=	_JC_JLONG(0xf1f36fb4ca70b320),
	.access_flags=		_JC_ACC_PRIVATE|_JC_ACC_FINAL,
	.function=		&_jc_java_util_zip_DeflaterEngine$method$deflateStored$f1f36fb4ca70b320,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_util_zip_DeflaterEngine$vtable, java_util_zip_DeflaterEngine.deflateStored$f1f36fb4ca70b320) / sizeof(void *),
	.num_parameters=	2,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	13,
	      .table=	_jc_java_util_zip_DeflaterEngine$linenum_table$deflateStored$f1f36fb4ca70b320
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_util_zip_DeflaterEngine, deflateStored$f1f36fb4ca70b320);

jboolean _JC_JCNI_ATTR
_jc_java_util_zip_DeflaterEngine$method$deflateStored$f1f36fb4ca70b320(_jc_env *const env, _jc_java_util_zip_DeflaterEngine$object *this, jboolean param0, jboolean param1)
{
	jint i0;
	jint i3;
	struct _jc_java_util_zip_DeflaterEngine$object *r0;
	struct _jc_java_util_zip_DeflaterHuffman$object *r2;
	_jc_byte_array *r3;
	jboolean z0;
	jboolean z1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	z0 = param0;
	z1 = param1;
	_JC_LINE_NUMBER(428);				// 0
	if (z0 != 0)
		goto label0;
	i0 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, lookahead);
	if (i0 != 0)
		goto label0;
	_JC_LINE_NUMBER(429);				// 1
	return 0;

label0:
	_JC_LINE_NUMBER(431);				// 2
	i0 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	i3 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, lookahead);
	i3 = i0 + i3;
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart) = i3;
	_JC_LINE_NUMBER(432);				// 3
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, lookahead) = 0;
	_JC_LINE_NUMBER(434);				// 4
	i3 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	i0 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, blockStart);
	i0 = i3 - i0;
	_JC_LINE_NUMBER(436);				// 5
	i3 = _JC_STATIC_FIELD(env, java_util_zip_DeflaterConstants, MAX__5fBLOCK__5fSIZE, 0);
	if (i0 >= i3)
		goto label2;
	i3 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, blockStart);
	if (i3 >= 32768)
		goto label1;
	if (i0 >= 32506)
		goto label2;

label1:
	if (z0 == 0)
		goto label4;

label2:
	_JC_LINE_NUMBER(443);				// 6
	i3 = _JC_STATIC_FIELD(env, java_util_zip_DeflaterConstants, MAX__5fBLOCK__5fSIZE, 1);
	if (i0 <= i3)
		goto label3;
	_JC_LINE_NUMBER(445);				// 7
	i0 = _JC_STATIC_FIELD(env, java_util_zip_DeflaterConstants, MAX__5fBLOCK__5fSIZE, 1);
	_JC_LINE_NUMBER(446);				// 8
	z1 = 0;

label3:
	_JC_LINE_NUMBER(452);				// 9
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, huffman);
	r3 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, window);
	i3 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, blockStart);
	_JC_INVOKE_VIRTUAL(env, java_util_zip_DeflaterHuffman, flushStoredBlock$06b7d619bb4161da, r2, r3, i3, i0, z1);
	_JC_LINE_NUMBER(453);				// 10
	i3 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, blockStart);
	i3 = i3 + i0;
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, blockStart) = i3;
	_JC_LINE_NUMBER(454);				// 11
	z1 = z1 ^ 1;
	return z1;

label4:
	_JC_LINE_NUMBER(456);				// 12
	return 1;
}

//
// private final void fillWindow()
//

static _jc_linenum _jc_java_util_zip_DeflaterEngine$linenum_table$fillWindow$77cf11d66ae57992[];

static const unsigned char _jc_java_util_zip_DeflaterEngine$param_ptypes$fillWindow$77cf11d66ae57992[] = { 
_JC_TYPE_VOID };

_jc_method _jc_java_util_zip_DeflaterEngine$method_info$fillWindow$77cf11d66ae57992 = {
	.name=			"fillWindow",
	.signature=		"()V",
	.class=			&_jc_java_util_zip_DeflaterEngine$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_util_zip_DeflaterEngine$param_ptypes$fillWindow$77cf11d66ae57992,
	.signature_hash=	_JC_JLONG(0x77cf11d66ae57992),
	.access_flags=		_JC_ACC_PRIVATE|_JC_ACC_FINAL,
	.function=		&_jc_java_util_zip_DeflaterEngine$method$fillWindow$77cf11d66ae57992,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_util_zip_DeflaterEngine$vtable, java_util_zip_DeflaterEngine.fillWindow$77cf11d66ae57992) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	14,
	      .table=	_jc_java_util_zip_DeflaterEngine$linenum_table$fillWindow$77cf11d66ae57992
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_util_zip_DeflaterEngine, fillWindow$77cf11d66ae57992);

void _JC_JCNI_ATTR
_jc_java_util_zip_DeflaterEngine$method$fillWindow$77cf11d66ae57992(_jc_env *const env, _jc_java_util_zip_DeflaterEngine$object *this)
{
	jbyte b5;
	jint i0;
	jint i1;
	jint i2;
	jint i3;
	jint i4;
	jint i6;
	struct _jc_java_util_zip_DeflaterEngine$object *r0;
	_jc_byte_array *r1;
	_jc_byte_array *r2;
	struct _jc_java_util_zip_Adler32$object *r3;
	_jc_byte_array *r5;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(293);				// 0
	i0 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	if (i0 < 65274)
		goto label2;
	_JC_LINE_NUMBER(294);				// 1
	_JC_INVOKE_NONVIRTUAL(env, java_util_zip_DeflaterEngine, slideWindow$558e7b830046acb5, 0, r0);
	_JC_LINE_NUMBER(299);				// 2
	goto label2;

label0:
	_JC_LINE_NUMBER(301);				// 3
	i0 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, lookahead);
	i0 = 65536 - i0;
	i1 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	i0 = i0 - i1;
	_JC_LINE_NUMBER(303);				// 4
	i1 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, inputEnd);
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, inputOff);
	i2 = i1 - i2;
	if (i0 <= i2)
		goto label1;
	_JC_LINE_NUMBER(304);				// 5
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, inputEnd);
	i1 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, inputOff);
	i0 = i2 - i1;

label1:
	_JC_LINE_NUMBER(306);				// 6
	r1 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, inputBuf);
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, inputOff);
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, window);
	i1 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	i3 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, lookahead);
	i3 = i1 + i3;
	_JC_ACTIVE_USE(env, java_lang_System);
	_JC_INVOKE_STATIC(env, java_lang_VMSystem, arraycopy$4286a72d57744cd8, 0, r1, i2, r2, i3, i0);
	_JC_LINE_NUMBER(308);				// 7
	r3 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, adler);
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, inputBuf);
	i3 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, inputOff);
	_JC_INVOKE_VIRTUAL(env, java_util_zip_Adler32, update$f73f1b3bfa3ea853, r3, r2, i3, i0);
	_JC_LINE_NUMBER(309);				// 8
	i3 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, inputOff);
	i3 = i3 + i0;
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, inputOff) = i3;
	_JC_LINE_NUMBER(310);				// 9
	i3 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, totalIn);
	i3 = i3 + i0;
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, totalIn) = i3;
	_JC_LINE_NUMBER(311);				// 10
	i3 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, lookahead);
	i3 = i3 + i0;
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, lookahead) = i3;

label2:
	_JC_LINE_NUMBER(299);				// 11
	i3 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, lookahead);
	if (i3 >= 262)
		goto label3;
	i3 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, inputOff);
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, inputEnd);
	if (i3 < i2) {
		_JC_PERIODIC_CHECK(env);
		goto label0;
	}

label3:
	_JC_LINE_NUMBER(314);				// 12
	i3 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, lookahead);
	if (i3 < 3)
		goto label4;
	r5 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, window);
	i4 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	b5 = _JC_PRIM_ELEMENT(env, byte, r5, i4, 1, 1);
	i4 = b5 << (5 & 0x1f);
	r5 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, window);
	i6 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	i6 = i6 + 1;
	b5 = _JC_PRIM_ELEMENT(env, byte, r5, i6, 1, 1);
	i6 = i4 ^ b5;
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, ins__5fh) = i6;

label4:
	_JC_LINE_NUMBER(316);				// 13
	return;
}

//
// private final boolean findLongestMatch(int)
//

static _jc_linenum _jc_java_util_zip_DeflaterEngine$linenum_table$findLongestMatch$0506e2d673e8302b[];

static const unsigned char _jc_java_util_zip_DeflaterEngine$param_ptypes$findLongestMatch$0506e2d673e8302b[] = { 
_JC_TYPE_INT, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_java_util_zip_DeflaterEngine$param_types$findLongestMatch$0506e2d673e8302b[] = {
	&_jc_int$prim$type
};

_jc_method _jc_java_util_zip_DeflaterEngine$method_info$findLongestMatch$0506e2d673e8302b = {
	.name=			"findLongestMatch",
	.signature=		"(I)Z",
	.class=			&_jc_java_util_zip_DeflaterEngine$type,
	.param_types=		&_jc_java_util_zip_DeflaterEngine$param_types$findLongestMatch$0506e2d673e8302b,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_java_util_zip_DeflaterEngine$param_ptypes$findLongestMatch$0506e2d673e8302b,
	.signature_hash=	_JC_JLONG(0x506e2d673e8302b),
	.access_flags=		_JC_ACC_PRIVATE|_JC_ACC_FINAL,
	.function=		&_jc_java_util_zip_DeflaterEngine$method$findLongestMatch$0506e2d673e8302b,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_util_zip_DeflaterEngine$vtable, java_util_zip_DeflaterEngine.findLongestMatch$0506e2d673e8302b) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	31,
	      .table=	_jc_java_util_zip_DeflaterEngine$linenum_table$findLongestMatch$0506e2d673e8302b
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_util_zip_DeflaterEngine, findLongestMatch$0506e2d673e8302b);

jboolean _JC_JCNI_ATTR
_jc_java_util_zip_DeflaterEngine$method$findLongestMatch$0506e2d673e8302b(_jc_env *const env, _jc_java_util_zip_DeflaterEngine$object *this, jint param0)
{
	jbyte b11;
	jbyte b12;
	jbyte b8;
	jbyte b9;
	jchar c14;
	jint i0;
	jint i1;
	jint i10;
	jint i15;
	jint i16;
	jint i18;
	jint i2;
	jint i3;
	jint i4;
	jint i5;
	jint i6;
	jint i7;
	struct _jc_java_util_zip_DeflaterEngine$object *r0;
	_jc_short_array *r1;
	_jc_byte_array *r2;
	jshort s13;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	i0 = param0;
	_JC_LINE_NUMBER(329);				// 0
	i1 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, max__5fchain);
	_JC_LINE_NUMBER(330);				// 1
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, niceLength);
	_JC_LINE_NUMBER(331);				// 2
	r1 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, prev);
	_JC_LINE_NUMBER(332);				// 3
	i3 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	_JC_LINE_NUMBER(334);				// 4
	i10 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	i7 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, matchLen);
	i4 = i10 + i7;
	_JC_LINE_NUMBER(335);				// 5
	i10 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, matchLen);
	_JC_ACTIVE_USE(env, java_lang_Math);
	if (i10 <= 2)
		goto label0;
	i15 = i10;
	goto label1;

label0:
	i15 = 2;

label1:
	i5 = i15;
	_JC_LINE_NUMBER(337);				// 6
	i10 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	i10 = i10 - 32506;
	if (i10 <= 0)
		goto label2;
	i16 = i10;
	goto label3;

label2:
	i16 = 0;

label3:
	i6 = i16;
	_JC_LINE_NUMBER(339);				// 7
	i10 = i3 + 258;
	i7 = i10 - 1;
	_JC_LINE_NUMBER(340);				// 8
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, window);
	i10 = i4 - 1;
	b8 = _JC_PRIM_ELEMENT(env, byte, r2, i10, 1, 1);
	_JC_LINE_NUMBER(341);				// 9
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, window);
	b9 = _JC_PRIM_ELEMENT(env, byte, r2, i4, 1, 1);
	_JC_LINE_NUMBER(344);				// 10
	i10 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, goodLength);
	if (i15 < i10)
		goto label4;
	_JC_LINE_NUMBER(345);				// 11
	i1 = _JC_ISHR(i1, 2);

label4:
	_JC_LINE_NUMBER(350);				// 12
	i10 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, lookahead);
	if (i2 <= i10)
		goto label5;
	_JC_LINE_NUMBER(351);				// 13
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, lookahead);

label5:
	_JC_LINE_NUMBER(360);				// 14
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, window);
	i10 = i0 + i5;
	b11 = _JC_PRIM_ELEMENT(env, byte, r2, i10, 1, 1);
	if (b11 != b9)
		goto label11;
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, window);
	i10 = i0 + i5;
	i10 = i10 - 1;
	b11 = _JC_PRIM_ELEMENT(env, byte, r2, i10, 1, 1);
	if (b11 != b8)
		goto label11;
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, window);
	b11 = _JC_PRIM_ELEMENT(env, byte, r2, i0, 1, 1);
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, window);
	b12 = _JC_PRIM_ELEMENT(env, byte, r2, i3, 1, 1);
	if (b11 != b12)
		goto label11;
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, window);
	i10 = i0 + 1;
	b12 = _JC_PRIM_ELEMENT(env, byte, r2, i10, 0, 1);
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, window);
	i10 = i3 + 1;
	b11 = _JC_PRIM_ELEMENT(env, byte, r2, i10, 0, 1);
	if (b12 == b11)
		goto label6;
	_JC_LINE_NUMBER(364);				// 15
	goto label11;

label6:
	_JC_LINE_NUMBER(366);				// 16
	i10 = i0 + 2;
	_JC_LINE_NUMBER(367);				// 17
	i3 = i3 + 2;

label7:
	_JC_LINE_NUMBER(372);				// 18
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, window);
	i3 = i3 + 1;
	b12 = _JC_PRIM_ELEMENT(env, byte, r2, i3, 0, 1);
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, window);
	i10 = i10 + 1;
	b11 = _JC_PRIM_ELEMENT(env, byte, r2, i10, 0, 1);
	if (b12 != b11)
		goto label8;
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, window);
	i3 = i3 + 1;
	b12 = _JC_PRIM_ELEMENT(env, byte, r2, i3, 0, 1);
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, window);
	i10 = i10 + 1;
	b11 = _JC_PRIM_ELEMENT(env, byte, r2, i10, 0, 1);
	if (b12 != b11)
		goto label8;
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, window);
	i3 = i3 + 1;
	b12 = _JC_PRIM_ELEMENT(env, byte, r2, i3, 0, 1);
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, window);
	i10 = i10 + 1;
	b11 = _JC_PRIM_ELEMENT(env, byte, r2, i10, 0, 1);
	if (b12 != b11)
		goto label8;
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, window);
	i3 = i3 + 1;
	b12 = _JC_PRIM_ELEMENT(env, byte, r2, i3, 0, 1);
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, window);
	i10 = i10 + 1;
	b11 = _JC_PRIM_ELEMENT(env, byte, r2, i10, 0, 1);
	if (b12 != b11)
		goto label8;
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, window);
	i3 = i3 + 1;
	b12 = _JC_PRIM_ELEMENT(env, byte, r2, i3, 0, 1);
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, window);
	i10 = i10 + 1;
	b11 = _JC_PRIM_ELEMENT(env, byte, r2, i10, 0, 1);
	if (b12 != b11)
		goto label8;
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, window);
	i3 = i3 + 1;
	b12 = _JC_PRIM_ELEMENT(env, byte, r2, i3, 0, 1);
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, window);
	i10 = i10 + 1;
	b11 = _JC_PRIM_ELEMENT(env, byte, r2, i10, 0, 1);
	if (b12 != b11)
		goto label8;
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, window);
	i3 = i3 + 1;
	b12 = _JC_PRIM_ELEMENT(env, byte, r2, i3, 0, 1);
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, window);
	i10 = i10 + 1;
	b11 = _JC_PRIM_ELEMENT(env, byte, r2, i10, 0, 1);
	if (b12 != b11)
		goto label8;
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, window);
	i3 = i3 + 1;
	b12 = _JC_PRIM_ELEMENT(env, byte, r2, i3, 0, 1);
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, window);
	i10 = i10 + 1;
	b11 = _JC_PRIM_ELEMENT(env, byte, r2, i10, 0, 1);
	if (b12 != b11)
		goto label8;
	if (i3 < i7) {
		_JC_PERIODIC_CHECK(env);
		goto label7;
	}

label8:
	_JC_LINE_NUMBER(382);				// 19
	if (i3 <= i4)
		goto label10;
	_JC_LINE_NUMBER(385);				// 20
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, matchStart) = i0;
	_JC_LINE_NUMBER(386);				// 21
	i4 = i3;
	_JC_LINE_NUMBER(387);				// 22
	i10 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	i5 = i3 - i10;
	_JC_LINE_NUMBER(388);				// 23
	if (i5 < i2)
		goto label9;
	_JC_LINE_NUMBER(389);				// 24
	goto label12;

label9:
	_JC_LINE_NUMBER(391);				// 25
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, window);
	i10 = i3 - 1;
	b8 = _JC_PRIM_ELEMENT(env, byte, r2, i10, 0, 0);
	_JC_LINE_NUMBER(392);				// 26
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, window);
	b9 = _JC_PRIM_ELEMENT(env, byte, r2, i3, 0, 0);

label10:
	_JC_LINE_NUMBER(394);				// 27
	i3 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);

label11:
	_JC_LINE_NUMBER(395);				// 28
	i10 = i0 & 32767;
	s13 = _JC_PRIM_ELEMENT(env, short, r1, i10, 1, 1);
	c14 = (jchar)-1;
	i10 = s13 & c14;
	i0 = i10;
	if (i10 <= i6)
		goto label12;
	i1 = i1 + -1;
	if (i1 != 0) {
		_JC_PERIODIC_CHECK(env);
		goto label5;
	}

label12:
	_JC_LINE_NUMBER(398);				// 29
	i10 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, lookahead);
	_JC_ACTIVE_USE(env, java_lang_Math);
	if (i5 >= i10)
		goto label13;
	i18 = i5;
	goto label14;

label13:
	i18 = i10;

label14:
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, matchLen) = i18;
	_JC_LINE_NUMBER(399);				// 30
	z0 = 0;
	i10 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, matchLen);
	if (i10 < 3)
		goto label15;
	z0 = 1;

label15:
	return z0;
}

//
// public final int getAdler()
//

static _jc_linenum _jc_java_util_zip_DeflaterEngine$linenum_table$getAdler$f60a9c5c8231e2a5[];

static const unsigned char _jc_java_util_zip_DeflaterEngine$param_ptypes$getAdler$f60a9c5c8231e2a5[] = { 
_JC_TYPE_INT };

_jc_method _jc_java_util_zip_DeflaterEngine$method_info$getAdler$f60a9c5c8231e2a5 = {
	.name=			"getAdler",
	.signature=		"()I",
	.class=			&_jc_java_util_zip_DeflaterEngine$type,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_java_util_zip_DeflaterEngine$param_ptypes$getAdler$f60a9c5c8231e2a5,
	.signature_hash=	_JC_JLONG(0xf60a9c5c8231e2a5),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_util_zip_DeflaterEngine$method$getAdler$f60a9c5c8231e2a5,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_util_zip_DeflaterEngine$vtable, java_util_zip_DeflaterEngine.getAdler$f60a9c5c8231e2a5) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_util_zip_DeflaterEngine$linenum_table$getAdler$f60a9c5c8231e2a5
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_util_zip_DeflaterEngine, getAdler$f60a9c5c8231e2a5);

jint _JC_JCNI_ATTR
_jc_java_util_zip_DeflaterEngine$method$getAdler$f60a9c5c8231e2a5(_jc_env *const env, _jc_java_util_zip_DeflaterEngine$object *this)
{
	jint i0;
	jlong l1;
	struct _jc_java_util_zip_DeflaterEngine$object *r0;
	struct _jc_java_util_zip_Adler32$object *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(162);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, adler);
	l1 = _JC_INVOKE_VIRTUAL(env, java_util_zip_Adler32, getValue$738f22e2bb5f71e8, r1);
	i0 = (jint)l1;
	_JC_LINE_NUMBER(163);				// 1
	return i0;
}

//
// public final int getTotalIn()
//

static _jc_linenum _jc_java_util_zip_DeflaterEngine$linenum_table$getTotalIn$3504553dfa702134[];

static const unsigned char _jc_java_util_zip_DeflaterEngine$param_ptypes$getTotalIn$3504553dfa702134[] = { 
_JC_TYPE_INT };

_jc_method _jc_java_util_zip_DeflaterEngine$method_info$getTotalIn$3504553dfa702134 = {
	.name=			"getTotalIn",
	.signature=		"()I",
	.class=			&_jc_java_util_zip_DeflaterEngine$type,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_java_util_zip_DeflaterEngine$param_ptypes$getTotalIn$3504553dfa702134,
	.signature_hash=	_JC_JLONG(0x3504553dfa702134),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_util_zip_DeflaterEngine$method$getTotalIn$3504553dfa702134,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_util_zip_DeflaterEngine$vtable, java_util_zip_DeflaterEngine.getTotalIn$3504553dfa702134) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_util_zip_DeflaterEngine$linenum_table$getTotalIn$3504553dfa702134
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_util_zip_DeflaterEngine, getTotalIn$3504553dfa702134);

jint _JC_JCNI_ATTR
_jc_java_util_zip_DeflaterEngine$method$getTotalIn$3504553dfa702134(_jc_env *const env, _jc_java_util_zip_DeflaterEngine$object *this)
{
	jint i0;
	struct _jc_java_util_zip_DeflaterEngine$object *r0;

	r0 = this;
	_JC_LINE_NUMBER(168);				// 0
	i0 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, totalIn);
	return i0;
}

//
// private final int insertString()
//

static _jc_linenum _jc_java_util_zip_DeflaterEngine$linenum_table$insertString$b2529a8b0b649b46[];

static const unsigned char _jc_java_util_zip_DeflaterEngine$param_ptypes$insertString$b2529a8b0b649b46[] = { 
_JC_TYPE_INT };

_jc_method _jc_java_util_zip_DeflaterEngine$method_info$insertString$b2529a8b0b649b46 = {
	.name=			"insertString",
	.signature=		"()I",
	.class=			&_jc_java_util_zip_DeflaterEngine$type,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_java_util_zip_DeflaterEngine$param_ptypes$insertString$b2529a8b0b649b46,
	.signature_hash=	_JC_JLONG(0xb2529a8b0b649b46),
	.access_flags=		_JC_ACC_PRIVATE|_JC_ACC_FINAL,
	.function=		&_jc_java_util_zip_DeflaterEngine$method$insertString$b2529a8b0b649b46,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_util_zip_DeflaterEngine$vtable, java_util_zip_DeflaterEngine.insertString$b2529a8b0b649b46) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_java_util_zip_DeflaterEngine$linenum_table$insertString$b2529a8b0b649b46
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_util_zip_DeflaterEngine, insertString$b2529a8b0b649b46);

jint _JC_JCNI_ATTR
_jc_java_util_zip_DeflaterEngine$method$insertString$b2529a8b0b649b46(_jc_env *const env, _jc_java_util_zip_DeflaterEngine$object *this)
{
	jbyte b6;
	jchar c13;
	jint i0;
	jint i4;
	struct _jc_java_util_zip_DeflaterEngine$object *r0;
	_jc_byte_array *r1;
	_jc_short_array *r2;
	_jc_short_array *r3;
	jshort s1;
	jshort s10;

	r0 = this;
	_JC_LINE_NUMBER(236);				// 0
	i0 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, ins__5fh);
	i0 = i0 << (5 & 0x1f);
	r1 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, window);
	i4 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	i4 = i4 + 2;
	b6 = _JC_PRIM_ELEMENT(env, byte, r1, i4, 1, 1);
	i4 = i0 ^ b6;
	i0 = i4 & 32767;
	_JC_LINE_NUMBER(250);				// 1
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, prev);
	i4 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	i4 = i4 & 32767;
	r3 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, head);
	s10 = _JC_PRIM_ELEMENT(env, short, r3, i0, 1, 1);
	s1 = s10;
	_JC_PRIM_ELEMENT(env, short, r2, i4, 1, 1) = s10;
	_JC_LINE_NUMBER(251);				// 2
	r3 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, head);
	i4 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	s10 = (jshort)i4;
	_JC_PRIM_ELEMENT(env, short, r3, i0, 0, 0) = s10;
	_JC_LINE_NUMBER(252);				// 3
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, ins__5fh) = i0;
	_JC_LINE_NUMBER(253);				// 4
	c13 = (jchar)-1;
	i4 = s1 & c13;
	return i4;
}

//
// public final boolean needsInput()
//

static _jc_linenum _jc_java_util_zip_DeflaterEngine$linenum_table$needsInput$94da923eb9903f64[];

static const unsigned char _jc_java_util_zip_DeflaterEngine$param_ptypes$needsInput$94da923eb9903f64[] = { 
_JC_TYPE_BOOLEAN };

_jc_method _jc_java_util_zip_DeflaterEngine$method_info$needsInput$94da923eb9903f64 = {
	.name=			"needsInput",
	.signature=		"()Z",
	.class=			&_jc_java_util_zip_DeflaterEngine$type,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_java_util_zip_DeflaterEngine$param_ptypes$needsInput$94da923eb9903f64,
	.signature_hash=	_JC_JLONG(0x94da923eb9903f64),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_util_zip_DeflaterEngine$method$needsInput$94da923eb9903f64,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_util_zip_DeflaterEngine$vtable, java_util_zip_DeflaterEngine.needsInput$94da923eb9903f64) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_util_zip_DeflaterEngine$linenum_table$needsInput$94da923eb9903f64
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_util_zip_DeflaterEngine, needsInput$94da923eb9903f64);

jboolean _JC_JCNI_ATTR
_jc_java_util_zip_DeflaterEngine$method$needsInput$94da923eb9903f64(_jc_env *const env, _jc_java_util_zip_DeflaterEngine$object *this)
{
	jint i0;
	jint i1;
	struct _jc_java_util_zip_DeflaterEngine$object *r0;
	jboolean z0;

	r0 = this;
	_JC_LINE_NUMBER(694);				// 0
	z0 = 0;
	i0 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, inputEnd);
	i1 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, inputOff);
	if (i0 != i1)
		goto label0;
	z0 = 1;

label0:
	return z0;
}

//
// public void reset()
//

static _jc_linenum _jc_java_util_zip_DeflaterEngine$linenum_table$reset$229a80b3e8394a0f[];

static const unsigned char _jc_java_util_zip_DeflaterEngine$param_ptypes$reset$229a80b3e8394a0f[] = { 
_JC_TYPE_VOID };

_jc_method _jc_java_util_zip_DeflaterEngine$method_info$reset$229a80b3e8394a0f = {
	.name=			"reset",
	.signature=		"()V",
	.class=			&_jc_java_util_zip_DeflaterEngine$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_util_zip_DeflaterEngine$param_ptypes$reset$229a80b3e8394a0f,
	.signature_hash=	_JC_JLONG(0x229a80b3e8394a0f),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_util_zip_DeflaterEngine$method$reset$229a80b3e8394a0f,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_util_zip_DeflaterEngine$vtable, java_util_zip_DeflaterEngine.reset$229a80b3e8394a0f) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	14,
	      .table=	_jc_java_util_zip_DeflaterEngine$linenum_table$reset$229a80b3e8394a0f
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_util_zip_DeflaterEngine, reset$229a80b3e8394a0f);

void _JC_JCNI_ATTR
_jc_java_util_zip_DeflaterEngine$method$reset$229a80b3e8394a0f(_jc_env *const env, _jc_java_util_zip_DeflaterEngine$object *this)
{
	jint i0;
	struct _jc_java_util_zip_DeflaterEngine$object *r0;
	struct _jc_java_util_zip_DeflaterHuffman$object *r1;
	struct _jc_java_util_zip_Adler32$object *r2;
	_jc_short_array *r3;
	struct _jc_java_util_zip_DeflaterHuffman__24Tree$object *r5;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(142);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, huffman);
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	_JC_PRIM_FIELD(env, r1, java_util_zip_DeflaterHuffman, last__5flit) = 0;
	_JC_PRIM_FIELD(env, r1, java_util_zip_DeflaterHuffman, extra__5fbits) = 0;
	r5 = _JC_REF_FIELD(env, r1, java_util_zip_DeflaterHuffman, literalTree);
	_JC_INVOKE_VIRTUAL(env, java_util_zip_DeflaterHuffman__24Tree, reset$229a80b3e8394a0f, r5);
	r5 = _JC_REF_FIELD(env, r1, java_util_zip_DeflaterHuffman, distTree);
	_JC_INVOKE_VIRTUAL(env, java_util_zip_DeflaterHuffman__24Tree, reset$229a80b3e8394a0f, r5);
	r5 = _JC_REF_FIELD(env, r1, java_util_zip_DeflaterHuffman, blTree);
	_JC_INVOKE_VIRTUAL(env, java_util_zip_DeflaterHuffman__24Tree, reset$229a80b3e8394a0f, r5);
	_JC_LINE_NUMBER(143);				// 1
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, adler);
	_JC_INVOKE_VIRTUAL(env, java_util_zip_Adler32, reset$229a80b3e8394a0f, r2);
	_JC_LINE_NUMBER(144);				// 2
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart) = 1;
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, blockStart) = 1;
	_JC_LINE_NUMBER(145);				// 3
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, lookahead) = 0;
	_JC_LINE_NUMBER(146);				// 4
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, totalIn) = 0;
	_JC_LINE_NUMBER(147);				// 5
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, prevAvailable) = 0;
	_JC_LINE_NUMBER(148);				// 6
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, matchLen) = 2;
	_JC_LINE_NUMBER(149);				// 7
	i0 = 0;
	goto label1;

label0:
	_JC_LINE_NUMBER(150);				// 8
	r3 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, head);
	_JC_PRIM_ELEMENT(env, short, r3, i0, 0, 0) = 0;
	_JC_LINE_NUMBER(149);				// 9
	i0 = i0 + 1;

label1:
	if (i0 < 32768) {
		_JC_PERIODIC_CHECK(env);
		goto label0;
	}
	_JC_LINE_NUMBER(151);				// 10
	i0 = 0;
	goto label3;

label2:
	_JC_LINE_NUMBER(152);				// 11
	r3 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, prev);
	_JC_PRIM_ELEMENT(env, short, r3, i0, 0, 0) = 0;
	_JC_LINE_NUMBER(151);				// 12
	i0 = i0 + 1;

label3:
	if (i0 < 32768) {
		_JC_PERIODIC_CHECK(env);
		goto label2;
	}
	_JC_LINE_NUMBER(153);				// 13
	return;
}

//
// public final void resetAdler()
//

static _jc_linenum _jc_java_util_zip_DeflaterEngine$linenum_table$resetAdler$7df35c8d7d916c11[];

static const unsigned char _jc_java_util_zip_DeflaterEngine$param_ptypes$resetAdler$7df35c8d7d916c11[] = { 
_JC_TYPE_VOID };

_jc_method _jc_java_util_zip_DeflaterEngine$method_info$resetAdler$7df35c8d7d916c11 = {
	.name=			"resetAdler",
	.signature=		"()V",
	.class=			&_jc_java_util_zip_DeflaterEngine$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_util_zip_DeflaterEngine$param_ptypes$resetAdler$7df35c8d7d916c11,
	.signature_hash=	_JC_JLONG(0x7df35c8d7d916c11),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_util_zip_DeflaterEngine$method$resetAdler$7df35c8d7d916c11,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_util_zip_DeflaterEngine$vtable, java_util_zip_DeflaterEngine.resetAdler$7df35c8d7d916c11) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_util_zip_DeflaterEngine$linenum_table$resetAdler$7df35c8d7d916c11
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_util_zip_DeflaterEngine, resetAdler$7df35c8d7d916c11);

void _JC_JCNI_ATTR
_jc_java_util_zip_DeflaterEngine$method$resetAdler$7df35c8d7d916c11(_jc_env *const env, _jc_java_util_zip_DeflaterEngine$object *this)
{
	struct _jc_java_util_zip_DeflaterEngine$object *r0;
	struct _jc_java_util_zip_Adler32$object *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(157);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, adler);
	_JC_INVOKE_VIRTUAL(env, java_util_zip_Adler32, reset$229a80b3e8394a0f, r1);
	_JC_LINE_NUMBER(158);				// 1
	return;
}

//
// void setDictionary(byte[], int, int)
//

static _jc_linenum _jc_java_util_zip_DeflaterEngine$linenum_table$setDictionary$3418fe5d561b5822[];

static const unsigned char _jc_java_util_zip_DeflaterEngine$param_ptypes$setDictionary$3418fe5d561b5822[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_INT, _JC_TYPE_VOID };

static _jc_type *const _jc_java_util_zip_DeflaterEngine$param_types$setDictionary$3418fe5d561b5822[] = {
	&_jc_byte$array$prim$type,
	&_jc_int$prim$type,
	&_jc_int$prim$type
};

_jc_method _jc_java_util_zip_DeflaterEngine$method_info$setDictionary$3418fe5d561b5822 = {
	.name=			"setDictionary",
	.signature=		"([BII)V",
	.class=			&_jc_java_util_zip_DeflaterEngine$type,
	.param_types=		&_jc_java_util_zip_DeflaterEngine$param_types$setDictionary$3418fe5d561b5822,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_util_zip_DeflaterEngine$param_ptypes$setDictionary$3418fe5d561b5822,
	.signature_hash=	_JC_JLONG(0x3418fe5d561b5822),
	.access_flags=		0,
	.function=		&_jc_java_util_zip_DeflaterEngine$method$setDictionary$3418fe5d561b5822,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_util_zip_DeflaterEngine$vtable, java_util_zip_DeflaterEngine.setDictionary$3418fe5d561b5822) / sizeof(void *),
	.num_parameters=	3,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	15,
	      .table=	_jc_java_util_zip_DeflaterEngine$linenum_table$setDictionary$3418fe5d561b5822
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_util_zip_DeflaterEngine, setDictionary$3418fe5d561b5822);

void _JC_JCNI_ATTR
_jc_java_util_zip_DeflaterEngine$method$setDictionary$3418fe5d561b5822(_jc_env *const env, _jc_java_util_zip_DeflaterEngine$object *this, _jc_byte_array *param0, jint param1, jint param2)
{
	jbyte b4;
	jint i0;
	jint i1;
	jint i2;
	jint i3;
	jint i5;
	struct _jc_java_util_zip_DeflaterEngine$object *r0;
	_jc_byte_array *r1;
	struct _jc_java_util_zip_Adler32$object *r2;
	_jc_byte_array *r3;
	_jc_byte_array *r5;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	i0 = param1;
	i1 = param2;
	_JC_LINE_NUMBER(405);				// 0
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, adler);
	_JC_INVOKE_VIRTUAL(env, java_util_zip_Adler32, update$f73f1b3bfa3ea853, r2, r1, i0, i1);
	_JC_LINE_NUMBER(406);				// 1
	if (i1 >= 3)
		goto label0;
	_JC_LINE_NUMBER(407);				// 2
	return;

label0:
	_JC_LINE_NUMBER(408);				// 3
	if (i1 <= 32506)
		goto label1;
	_JC_LINE_NUMBER(409);				// 4
	i1 = i1 - 32506;
	i0 = i0 + i1;
	_JC_LINE_NUMBER(410);				// 5
	i1 = 32506;

label1:
	_JC_LINE_NUMBER(413);				// 6
	r3 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, window);
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	_JC_ACTIVE_USE(env, java_lang_System);
	_JC_INVOKE_STATIC(env, java_lang_VMSystem, arraycopy$4286a72d57744cd8, 0, r1, i0, r3, i2, i1);
	r5 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, window);
	i3 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	b4 = _JC_PRIM_ELEMENT(env, byte, r5, i3, 1, 1);
	i3 = b4 << (5 & 0x1f);
	r5 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, window);
	i5 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	i5 = i5 + 1;
	b4 = _JC_PRIM_ELEMENT(env, byte, r5, i5, 1, 1);
	i5 = i3 ^ b4;
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, ins__5fh) = i5;
	_JC_LINE_NUMBER(416);				// 7
	i2 = i1 + -1;
	_JC_LINE_NUMBER(417);				// 8
	goto label3;

label2:
	_JC_LINE_NUMBER(419);				// 9
	_JC_INVOKE_NONVIRTUAL(env, java_util_zip_DeflaterEngine, insertString$b2529a8b0b649b46, 0, r0);
	_JC_LINE_NUMBER(420);				// 10
	i1 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	i1 = i1 + 1;
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart) = i1;

label3:
	_JC_LINE_NUMBER(417);				// 11
	i2 = i2 + -1;
	if (i2 > 0) {
		_JC_PERIODIC_CHECK(env);
		goto label2;
	}
	_JC_LINE_NUMBER(422);				// 12
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	i2 = i2 + 2;
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart) = i2;
	_JC_LINE_NUMBER(423);				// 13
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, blockStart) = i2;
	_JC_LINE_NUMBER(424);				// 14
	return;
}

//
// public void setInput(byte[], int, int)
//

static _jc_linenum _jc_java_util_zip_DeflaterEngine$linenum_table$setInput$c9c91f0df4009bec[];

static const unsigned char _jc_java_util_zip_DeflaterEngine$param_ptypes$setInput$c9c91f0df4009bec[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_INT, _JC_TYPE_VOID };

static _jc_type *const _jc_java_util_zip_DeflaterEngine$param_types$setInput$c9c91f0df4009bec[] = {
	&_jc_byte$array$prim$type,
	&_jc_int$prim$type,
	&_jc_int$prim$type
};

_jc_method _jc_java_util_zip_DeflaterEngine$method_info$setInput$c9c91f0df4009bec = {
	.name=			"setInput",
	.signature=		"([BII)V",
	.class=			&_jc_java_util_zip_DeflaterEngine$type,
	.param_types=		&_jc_java_util_zip_DeflaterEngine$param_types$setInput$c9c91f0df4009bec,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_util_zip_DeflaterEngine$param_ptypes$setInput$c9c91f0df4009bec,
	.signature_hash=	_JC_JLONG(0xc9c91f0df4009bec),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_util_zip_DeflaterEngine$method$setInput$c9c91f0df4009bec,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_util_zip_DeflaterEngine$vtable, java_util_zip_DeflaterEngine.setInput$c9c91f0df4009bec) / sizeof(void *),
	.num_parameters=	3,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	9,
	      .table=	_jc_java_util_zip_DeflaterEngine$linenum_table$setInput$c9c91f0df4009bec
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_util_zip_DeflaterEngine, setInput$c9c91f0df4009bec);

void _JC_JCNI_ATTR
_jc_java_util_zip_DeflaterEngine$method$setInput$c9c91f0df4009bec(_jc_env *const env, _jc_java_util_zip_DeflaterEngine$object *this, _jc_byte_array *param0, jint param1, jint param2)
{
	jint i0;
	jint i1;
	jint i2;
	jint i3;
	struct _jc_java_util_zip_DeflaterEngine$object *r0;
	_jc_byte_array *r1;
	struct _jc_java_lang_IllegalStateException$object *r2;
	struct _jc_java_lang_ArrayIndexOutOfBoundsException$object *r3;
	struct _jc_java_lang_String$object *r4;
	struct _jc_java_lang_VMThrowable$object *r5;
	struct _jc_java_lang_String$object *r6;
	struct _jc_java_lang_VMThrowable$object *r8;

	r0 = this;
	r1 = param0;
	i0 = param1;
	i1 = param2;
	_JC_LINE_NUMBER(675);				// 0
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, inputOff);
	i3 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, inputEnd);
	if (i2 >= i3)
		goto label0;
	_JC_LINE_NUMBER(676);				// 1
	r2 = _JC_NEW(env, java_lang_IllegalStateException);
	r4 = _JC_STRING(env, "Old input was not completely processed");
	_JC_REF_FIELD(env, r2, java_lang_Throwable, cause) = r2;
	r5 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r2);
	_JC_REF_FIELD(env, r2, java_lang_Throwable, vmState) = r5;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, detailMessage) = r4;
	_JC_THROW(env, r2);

label0:
	_JC_LINE_NUMBER(679);				// 2
	i1 = i0 + i1;
	_JC_LINE_NUMBER(684);				// 3
	if (i0 < 0)
		goto label1;
	if (i0 > i1)
		goto label1;
	i3 = _JC_ARRAY_LENGTH(env, r1);
	if (i1 <= i3)
		goto label2;

label1:
	_JC_LINE_NUMBER(685);				// 4
	r3 = _JC_NEW(env, java_lang_ArrayIndexOutOfBoundsException);
	r6 = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r8 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r8;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r6;
	_JC_THROW(env, r3);

label2:
	_JC_LINE_NUMBER(687);				// 5
	_JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, inputBuf) = r1;
	_JC_LINE_NUMBER(688);				// 6
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, inputOff) = i0;
	_JC_LINE_NUMBER(689);				// 7
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, inputEnd) = i1;
	_JC_LINE_NUMBER(690);				// 8
	return;
}

//
// public void setLevel(int)
//

static _jc_linenum _jc_java_util_zip_DeflaterEngine$linenum_table$setLevel$c8e64370e88154b2[];

static const unsigned char _jc_java_util_zip_DeflaterEngine$param_ptypes$setLevel$c8e64370e88154b2[] = { 
_JC_TYPE_INT, _JC_TYPE_VOID };

static _jc_type *const _jc_java_util_zip_DeflaterEngine$param_types$setLevel$c8e64370e88154b2[] = {
	&_jc_int$prim$type
};

_jc_method _jc_java_util_zip_DeflaterEngine$method_info$setLevel$c8e64370e88154b2 = {
	.name=			"setLevel",
	.signature=		"(I)V",
	.class=			&_jc_java_util_zip_DeflaterEngine$type,
	.param_types=		&_jc_java_util_zip_DeflaterEngine$param_types$setLevel$c8e64370e88154b2,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_util_zip_DeflaterEngine$param_ptypes$setLevel$c8e64370e88154b2,
	.signature_hash=	_JC_JLONG(0xc8e64370e88154b2),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_util_zip_DeflaterEngine$method$setLevel$c8e64370e88154b2,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_util_zip_DeflaterEngine$vtable, java_util_zip_DeflaterEngine.setLevel$c8e64370e88154b2) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	23,
	      .table=	_jc_java_util_zip_DeflaterEngine$linenum_table$setLevel$c8e64370e88154b2
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_util_zip_DeflaterEngine, setLevel$c8e64370e88154b2);

void _JC_JCNI_ATTR
_jc_java_util_zip_DeflaterEngine$method$setLevel$c8e64370e88154b2(_jc_env *const env, _jc_java_util_zip_DeflaterEngine$object *this, jint param0)
{
	jbyte b4;
	jbyte b7;
	jint i0;
	jint i1;
	jint i2;
	jint i3;
	jint i6;
	jint i8;
	struct _jc_java_util_zip_DeflaterEngine$object *r0;
	_jc_int_array *r1;
	struct _jc_java_util_zip_DeflaterHuffman$object *r2;
	_jc_byte_array *r3;
	_jc_byte_array *r5;
	jshort s5;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	i0 = param0;
	_JC_LINE_NUMBER(178);				// 0
	r1 = _JC_STATIC_FIELD(env, java_util_zip_DeflaterConstants, GOOD__5fLENGTH, 0);
	i1 = _JC_PRIM_ELEMENT(env, int, r1, i0, 1, 1);
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, goodLength) = i1;
	_JC_LINE_NUMBER(179);				// 1
	r1 = _JC_STATIC_FIELD(env, java_util_zip_DeflaterConstants, MAX__5fLAZY, 1);
	i1 = _JC_PRIM_ELEMENT(env, int, r1, i0, 0, 0);
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, max__5flazy) = i1;
	_JC_LINE_NUMBER(180);				// 2
	r1 = _JC_STATIC_FIELD(env, java_util_zip_DeflaterConstants, NICE__5fLENGTH, 1);
	i1 = _JC_PRIM_ELEMENT(env, int, r1, i0, 0, 0);
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, niceLength) = i1;
	_JC_LINE_NUMBER(181);				// 3
	r1 = _JC_STATIC_FIELD(env, java_util_zip_DeflaterConstants, MAX__5fCHAIN, 1);
	i1 = _JC_PRIM_ELEMENT(env, int, r1, i0, 0, 0);
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, max__5fchain) = i1;
	_JC_LINE_NUMBER(183);				// 4
	r1 = _JC_STATIC_FIELD(env, java_util_zip_DeflaterConstants, COMPR__5fFUNC, 1);
	i1 = _JC_PRIM_ELEMENT(env, int, r1, i0, 0, 0);
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, comprFunc);
	if (i1 == i2)
		goto label7;
	_JC_LINE_NUMBER(188);				// 5
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, comprFunc);
	switch (i2) {
	case 0:
		goto label0;
	case 1:
		goto label2;
	case 2:
		goto label3;
	default:
		goto label6;
	}

label0:
	_JC_LINE_NUMBER(191);				// 6
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	i1 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, blockStart);
	if (i2 <= i1)
		goto label1;
	_JC_LINE_NUMBER(193);				// 7
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, huffman);
	r3 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, window);
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, blockStart);
	i1 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	i3 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, blockStart);
	i3 = i1 - i3;
	_JC_INVOKE_VIRTUAL(env, java_util_zip_DeflaterHuffman, flushStoredBlock$06b7d619bb4161da, r2, r3, i2, i3, 0);
	_JC_LINE_NUMBER(195);				// 8
	i3 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, blockStart) = i3;

label1:
	r5 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, window);
	i6 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	b7 = _JC_PRIM_ELEMENT(env, byte, r5, i6, 1, 1);
	i6 = b7 << (5 & 0x1f);
	r5 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, window);
	i8 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	i8 = i8 + 1;
	b7 = _JC_PRIM_ELEMENT(env, byte, r5, i8, 1, 1);
	i8 = i6 ^ b7;
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, ins__5fh) = i8;
	_JC_LINE_NUMBER(198);				// 9
	goto label6;

label2:
	_JC_LINE_NUMBER(200);				// 10
	i3 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, blockStart);
	if (i3 <= i2)
		goto label6;
	_JC_LINE_NUMBER(202);				// 11
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, huffman);
	r3 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, window);
	i3 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, blockStart);
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	i1 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, blockStart);
	i2 = i2 - i1;
	_JC_INVOKE_VIRTUAL(env, java_util_zip_DeflaterHuffman, flushBlock$26c7840b1df1248b, r2, r3, i3, i2, 0);
	_JC_LINE_NUMBER(204);				// 12
	i3 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, blockStart) = i3;
	_JC_LINE_NUMBER(206);				// 13
	goto label6;

label3:
	_JC_LINE_NUMBER(208);				// 14
	z0 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, prevAvailable);
	if (z0 == 0)
		goto label4;
	_JC_LINE_NUMBER(209);				// 15
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, huffman);
	r3 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, window);
	i3 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	i3 = i3 - 1;
	b4 = _JC_PRIM_ELEMENT(env, byte, r3, i3, 1, 1);
	s5 = b4 & 255;
	_JC_INVOKE_NONVIRTUAL(env, java_util_zip_DeflaterHuffman, tallyLit$5849b15b22c9b739, 1, r2, s5);

label4:
	_JC_LINE_NUMBER(210);				// 16
	i3 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, blockStart);
	if (i3 <= i2)
		goto label5;
	_JC_LINE_NUMBER(212);				// 17
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, huffman);
	r3 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, window);
	i3 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, blockStart);
	i2 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	i1 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, blockStart);
	i2 = i2 - i1;
	_JC_INVOKE_VIRTUAL(env, java_util_zip_DeflaterHuffman, flushBlock$26c7840b1df1248b, r2, r3, i3, i2, 0);
	_JC_LINE_NUMBER(214);				// 18
	i3 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, blockStart) = i3;

label5:
	_JC_LINE_NUMBER(216);				// 19
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, prevAvailable) = 0;
	_JC_LINE_NUMBER(217);				// 20
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, matchLen) = 2;

label6:
	_JC_LINE_NUMBER(220);				// 21
	r1 = _JC_STATIC_FIELD(env, java_util_zip_DeflaterConstants, COMPR__5fFUNC, 1);
	i3 = _JC_PRIM_ELEMENT(env, int, r1, i0, 0, 0);
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, comprFunc) = i3;

label7:
	_JC_LINE_NUMBER(222);				// 22
	return;
}

//
// public final void setStrategy(int)
//

static _jc_linenum _jc_java_util_zip_DeflaterEngine$linenum_table$setStrategy$3aa5bc6f9b71ad4e[];

static const unsigned char _jc_java_util_zip_DeflaterEngine$param_ptypes$setStrategy$3aa5bc6f9b71ad4e[] = { 
_JC_TYPE_INT, _JC_TYPE_VOID };

static _jc_type *const _jc_java_util_zip_DeflaterEngine$param_types$setStrategy$3aa5bc6f9b71ad4e[] = {
	&_jc_int$prim$type
};

_jc_method _jc_java_util_zip_DeflaterEngine$method_info$setStrategy$3aa5bc6f9b71ad4e = {
	.name=			"setStrategy",
	.signature=		"(I)V",
	.class=			&_jc_java_util_zip_DeflaterEngine$type,
	.param_types=		&_jc_java_util_zip_DeflaterEngine$param_types$setStrategy$3aa5bc6f9b71ad4e,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_util_zip_DeflaterEngine$param_ptypes$setStrategy$3aa5bc6f9b71ad4e,
	.signature_hash=	_JC_JLONG(0x3aa5bc6f9b71ad4e),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_java_util_zip_DeflaterEngine$method$setStrategy$3aa5bc6f9b71ad4e,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_util_zip_DeflaterEngine$vtable, java_util_zip_DeflaterEngine.setStrategy$3aa5bc6f9b71ad4e) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_util_zip_DeflaterEngine$linenum_table$setStrategy$3aa5bc6f9b71ad4e
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_util_zip_DeflaterEngine, setStrategy$3aa5bc6f9b71ad4e);

void _JC_JCNI_ATTR
_jc_java_util_zip_DeflaterEngine$method$setStrategy$3aa5bc6f9b71ad4e(_jc_env *const env, _jc_java_util_zip_DeflaterEngine$object *this, jint param0)
{
	jint i0;
	struct _jc_java_util_zip_DeflaterEngine$object *r0;

	r0 = this;
	i0 = param0;
	_JC_LINE_NUMBER(173);				// 0
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strategy) = i0;
	_JC_LINE_NUMBER(174);				// 1
	return;
}

//
// private final void slideWindow()
//

static _jc_linenum _jc_java_util_zip_DeflaterEngine$linenum_table$slideWindow$558e7b830046acb5[];

static const unsigned char _jc_java_util_zip_DeflaterEngine$param_ptypes$slideWindow$558e7b830046acb5[] = { 
_JC_TYPE_VOID };

_jc_method _jc_java_util_zip_DeflaterEngine$method_info$slideWindow$558e7b830046acb5 = {
	.name=			"slideWindow",
	.signature=		"()V",
	.class=			&_jc_java_util_zip_DeflaterEngine$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_util_zip_DeflaterEngine$param_ptypes$slideWindow$558e7b830046acb5,
	.signature_hash=	_JC_JLONG(0x558e7b830046acb5),
	.access_flags=		_JC_ACC_PRIVATE|_JC_ACC_FINAL,
	.function=		&_jc_java_util_zip_DeflaterEngine$method$slideWindow$558e7b830046acb5,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_util_zip_DeflaterEngine$vtable, java_util_zip_DeflaterEngine.slideWindow$558e7b830046acb5) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	13,
	      .table=	_jc_java_util_zip_DeflaterEngine$linenum_table$slideWindow$558e7b830046acb5
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_util_zip_DeflaterEngine, slideWindow$558e7b830046acb5);

void _JC_JCNI_ATTR
_jc_java_util_zip_DeflaterEngine$method$slideWindow$558e7b830046acb5(_jc_env *const env, _jc_java_util_zip_DeflaterEngine$object *this)
{
	jchar c3;
	jint i0;
	jint i1;
	jint i4;
	struct _jc_java_util_zip_DeflaterEngine$object *r0;
	_jc_byte_array *r1;
	_jc_byte_array *r2;
	_jc_short_array *r3;
	jshort s2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(258);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, window);
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, window);
	_JC_ACTIVE_USE(env, java_lang_System);
	_JC_INVOKE_STATIC(env, java_lang_VMSystem, arraycopy$4286a72d57744cd8, 0, r1, 32768, r2, 0, 32768);
	_JC_LINE_NUMBER(259);				// 1
	i1 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, matchStart);
	i1 = i1 - 32768;
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, matchStart) = i1;
	_JC_LINE_NUMBER(260);				// 2
	i1 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	i1 = i1 - 32768;
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart) = i1;
	_JC_LINE_NUMBER(261);				// 3
	i1 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, blockStart);
	i1 = i1 - 32768;
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, blockStart) = i1;
	_JC_LINE_NUMBER(266);				// 4
	i0 = 0;
	goto label2;

label0:
	_JC_LINE_NUMBER(268);				// 5
	r3 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, head);
	s2 = _JC_PRIM_ELEMENT(env, short, r3, i0, 0, 0);
	c3 = (jchar)-1;
	i1 = s2 & c3;
	_JC_LINE_NUMBER(269);				// 6
	r3 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, head);
	i4 = i0;
	s2 = 0;
	if (i1 < 32768)
		goto label1;
	i1 = i1 - 32768;
	s2 = (jshort)i1;

label1:
	_JC_PRIM_ELEMENT(env, short, r3, i4, 0, 1) = s2;
	_JC_LINE_NUMBER(266);				// 7
	i0 = i0 + 1;

label2:
	if (i0 < 32768) {
		_JC_PERIODIC_CHECK(env);
		goto label0;
	}
	_JC_LINE_NUMBER(274);				// 8
	i4 = 0;
	goto label5;

label3:
	_JC_LINE_NUMBER(276);				// 9
	r3 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, prev);
	s2 = _JC_PRIM_ELEMENT(env, short, r3, i4, 0, 0);
	c3 = (jchar)-1;
	i1 = s2 & c3;
	_JC_LINE_NUMBER(277);				// 10
	r3 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, prev);
	i0 = i4;
	s2 = 0;
	if (i1 < 32768)
		goto label4;
	i1 = i1 - 32768;
	s2 = (jshort)i1;

label4:
	_JC_PRIM_ELEMENT(env, short, r3, i0, 0, 1) = s2;
	_JC_LINE_NUMBER(274);				// 11
	i4 = i4 + 1;

label5:
	if (i4 < 32768) {
		_JC_PERIODIC_CHECK(env);
		goto label3;
	}
	_JC_LINE_NUMBER(279);				// 12
	return;
}

//
// private final void updateHash()
//

static _jc_linenum _jc_java_util_zip_DeflaterEngine$linenum_table$updateHash$4b1946ed2c96f904[];

static const unsigned char _jc_java_util_zip_DeflaterEngine$param_ptypes$updateHash$4b1946ed2c96f904[] = { 
_JC_TYPE_VOID };

_jc_method _jc_java_util_zip_DeflaterEngine$method_info$updateHash$4b1946ed2c96f904 = {
	.name=			"updateHash",
	.signature=		"()V",
	.class=			&_jc_java_util_zip_DeflaterEngine$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_util_zip_DeflaterEngine$param_ptypes$updateHash$4b1946ed2c96f904,
	.signature_hash=	_JC_JLONG(0x4b1946ed2c96f904),
	.access_flags=		_JC_ACC_PRIVATE|_JC_ACC_FINAL,
	.function=		&_jc_java_util_zip_DeflaterEngine$method$updateHash$4b1946ed2c96f904,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_util_zip_DeflaterEngine$vtable, java_util_zip_DeflaterEngine.updateHash$4b1946ed2c96f904) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_util_zip_DeflaterEngine$linenum_table$updateHash$4b1946ed2c96f904
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_util_zip_DeflaterEngine, updateHash$4b1946ed2c96f904);

void _JC_JCNI_ATTR
_jc_java_util_zip_DeflaterEngine$method$updateHash$4b1946ed2c96f904(_jc_env *const env, _jc_java_util_zip_DeflaterEngine$object *this)
{
	jbyte b1;
	jint i0;
	jint i3;
	struct _jc_java_util_zip_DeflaterEngine$object *r0;
	_jc_byte_array *r1;

	r0 = this;
	_JC_LINE_NUMBER(227);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, window);
	i0 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	b1 = _JC_PRIM_ELEMENT(env, byte, r1, i0, 1, 1);
	i0 = b1 << (5 & 0x1f);
	r1 = _JC_REF_FIELD(env, r0, java_util_zip_DeflaterEngine, window);
	i3 = _JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, strstart);
	i3 = i3 + 1;
	b1 = _JC_PRIM_ELEMENT(env, byte, r1, i3, 1, 1);
	i3 = i0 ^ b1;
	_JC_PRIM_FIELD(env, r0, java_util_zip_DeflaterEngine, ins__5fh) = i3;
	_JC_LINE_NUMBER(228);				// 1
	return;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_java_util_zip_DeflaterEngine$methods[] = {
	&_jc_java_util_zip_DeflaterEngine$method_info$_init$c47deb6e52e030ad,
	&_jc_java_util_zip_DeflaterEngine$method_info$deflate$520181c945544c4f,
	&_jc_java_util_zip_DeflaterEngine$method_info$deflateFast$63a2665efd930ca7,
	&_jc_java_util_zip_DeflaterEngine$method_info$deflateSlow$82fdac4aec7d01c4,
	&_jc_java_util_zip_DeflaterEngine$method_info$deflateStored$f1f36fb4ca70b320,
	&_jc_java_util_zip_DeflaterEngine$method_info$fillWindow$77cf11d66ae57992,
	&_jc_java_util_zip_DeflaterEngine$method_info$findLongestMatch$0506e2d673e8302b,
	&_jc_java_util_zip_DeflaterEngine$method_info$getAdler$f60a9c5c8231e2a5,
	&_jc_java_util_zip_DeflaterEngine$method_info$getTotalIn$3504553dfa702134,
	&_jc_java_util_zip_DeflaterEngine$method_info$insertString$b2529a8b0b649b46,
	&_jc_java_util_zip_DeflaterEngine$method_info$needsInput$94da923eb9903f64,
	&_jc_java_util_zip_DeflaterEngine$method_info$reset$229a80b3e8394a0f,
	&_jc_java_util_zip_DeflaterEngine$method_info$resetAdler$7df35c8d7d916c11,
	&_jc_java_util_zip_DeflaterEngine$method_info$setDictionary$3418fe5d561b5822,
	&_jc_java_util_zip_DeflaterEngine$method_info$setInput$c9c91f0df4009bec,
	&_jc_java_util_zip_DeflaterEngine$method_info$setLevel$c8e64370e88154b2,
	&_jc_java_util_zip_DeflaterEngine$method_info$setStrategy$3aa5bc6f9b71ad4e,
	&_jc_java_util_zip_DeflaterEngine$method_info$slideWindow$558e7b830046acb5,
	&_jc_java_util_zip_DeflaterEngine$method_info$updateHash$4b1946ed2c96f904
};

/************************************************************************
 *			  Class fields structure			*
 ************************************************************************/

_jc_java_util_zip_DeflaterEngine$fields_struct _jc_java_util_zip_DeflaterEngine$class_fields = { };

/************************************************************************
 *			      Interface list				*
 ************************************************************************/

// Directly implemented interfaces
static _jc_type *const _jc_java_util_zip_DeflaterEngine$interfaces[] = {
	&_jc_java_util_zip_DeflaterConstants$type
};

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_java_util_zip_DeflaterEngine$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};
static _jc_type *const _jc_java_util_zip_DeflaterEngine$instanceof_hash_bucket_117[] = {
	&_jc_java_util_zip_DeflaterConstants$type,
	_JC_NULL
};
static _jc_type *const _jc_java_util_zip_DeflaterEngine$instanceof_hash_bucket_122[] = {
	&_jc_java_util_zip_DeflaterEngine$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_java_util_zip_DeflaterEngine$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[101]=	_jc_java_util_zip_DeflaterEngine$instanceof_hash_bucket_101,
	[117]=	_jc_java_util_zip_DeflaterEngine$instanceof_hash_bucket_117,
	[122]=	_jc_java_util_zip_DeflaterEngine$instanceof_hash_bucket_122
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_java_util_zip_DeflaterEngine$class_depends[] = {
	{ "java/lang/ArrayIndexOutOfBoundsException",	_JC_JLONG(0x49615c3d39443a4c) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/Error",	_JC_JLONG(0x308333d803f5ab9f) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/IllegalStateException",	_JC_JLONG(0xb7e704701c278e65) },
	{ "java/lang/IndexOutOfBoundsException",	_JC_JLONG(0x3cdfed1e0ad1a3d6) },
	{ "java/lang/InternalError",	_JC_JLONG(0x642246d728a60038) },
	{ "java/lang/Math",	_JC_JLONG(0x8d71d806a180ad8a) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/RuntimeException",	_JC_JLONG(0x4f5534a987354d1d) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/System",	_JC_JLONG(0x53cc8e2333795f04) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMSystem",	_JC_JLONG(0x4d1cebae0bdda058) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/lang/VirtualMachineError",	_JC_JLONG(0xc7632ae877826bc6) },
	{ "java/util/zip/Adler32",	_JC_JLONG(0xe402919c0142085c) },
	{ "java/util/zip/DeflaterConstants",	_JC_JLONG(0x2971d0a046066ef5) },
	{ "java/util/zip/DeflaterHuffman",	_JC_JLONG(0xc8c5fe8075e1d921) },
	{ "java/util/zip/DeflaterHuffman$Tree",	_JC_JLONG(0xcec56a9fd2873428) },
	{ "java/util/zip/DeflaterPending",	_JC_JLONG(0xd277776153c42b2e) },
	{ "java/util/zip/PendingBuffer",	_JC_JLONG(0xfc60c3d54c4b913a) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_java_util_zip_DeflaterEngine$vtype _jc_java_util_zip_DeflaterEngine$type = {
    .type= {
	.name=			"java/util/zip/DeflaterEngine",
	.superclass=		&_jc_java_lang_Object$type,
	.access_flags=		0,
	.flags=			_JC_TYPE_REFERENCE,
	.num_interfaces=sizeof(_jc_java_util_zip_DeflaterEngine$interfaces) / sizeof(*_jc_java_util_zip_DeflaterEngine$interfaces),
	.interfaces=		_jc_java_util_zip_DeflaterEngine$interfaces,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		29,
		.hash=			_JC_JLONG(0x7c1ab2dbe97cdcfa),
		.source_file=		"DeflaterEngine.java",
		.instance_size=		sizeof(_jc_java_util_zip_DeflaterEngine$refs) + sizeof(_jc_java_util_zip_DeflaterEngine$object),
		.num_virtual_refs=	7,
		.num_fields=		sizeof(_jc_java_util_zip_DeflaterEngine$fields) / sizeof(*_jc_java_util_zip_DeflaterEngine$fields),
		.fields=		_jc_java_util_zip_DeflaterEngine$fields,
		.num_methods=		sizeof(_jc_java_util_zip_DeflaterEngine$methods) / sizeof(*_jc_java_util_zip_DeflaterEngine$methods),
		.methods=		_jc_java_util_zip_DeflaterEngine$methods,
		.instanceof_hash_table=	_jc_java_util_zip_DeflaterEngine$instanceof_hash_table,
		.class_fields=		&_jc_java_util_zip_DeflaterEngine$class_fields,
		.num_class_depends=		sizeof(_jc_java_util_zip_DeflaterEngine$class_depends) / sizeof(*_jc_java_util_zip_DeflaterEngine$class_depends),
		.class_depends=		_jc_java_util_zip_DeflaterEngine$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.java_util_zip_DeflaterEngine= {
	    .deflate$520181c945544c4f=
		&_jc_java_util_zip_DeflaterEngine$method$deflate$520181c945544c4f,
	    .deflateFast$63a2665efd930ca7=
		&_jc_java_util_zip_DeflaterEngine$method$deflateFast$63a2665efd930ca7,
	    .deflateSlow$82fdac4aec7d01c4=
		&_jc_java_util_zip_DeflaterEngine$method$deflateSlow$82fdac4aec7d01c4,
	    .deflateStored$f1f36fb4ca70b320=
		&_jc_java_util_zip_DeflaterEngine$method$deflateStored$f1f36fb4ca70b320,
	    .fillWindow$77cf11d66ae57992=
		&_jc_java_util_zip_DeflaterEngine$method$fillWindow$77cf11d66ae57992,
	    .findLongestMatch$0506e2d673e8302b=
		&_jc_java_util_zip_DeflaterEngine$method$findLongestMatch$0506e2d673e8302b,
	    .getAdler$f60a9c5c8231e2a5=
		&_jc_java_util_zip_DeflaterEngine$method$getAdler$f60a9c5c8231e2a5,
	    .getTotalIn$3504553dfa702134=
		&_jc_java_util_zip_DeflaterEngine$method$getTotalIn$3504553dfa702134,
	    .insertString$b2529a8b0b649b46=
		&_jc_java_util_zip_DeflaterEngine$method$insertString$b2529a8b0b649b46,
	    .needsInput$94da923eb9903f64=
		&_jc_java_util_zip_DeflaterEngine$method$needsInput$94da923eb9903f64,
	    .reset$229a80b3e8394a0f=
		&_jc_java_util_zip_DeflaterEngine$method$reset$229a80b3e8394a0f,
	    .resetAdler$7df35c8d7d916c11=
		&_jc_java_util_zip_DeflaterEngine$method$resetAdler$7df35c8d7d916c11,
	    .setDictionary$3418fe5d561b5822=
		&_jc_java_util_zip_DeflaterEngine$method$setDictionary$3418fe5d561b5822,
	    .setInput$c9c91f0df4009bec=
		&_jc_java_util_zip_DeflaterEngine$method$setInput$c9c91f0df4009bec,
	    .setLevel$c8e64370e88154b2=
		&_jc_java_util_zip_DeflaterEngine$method$setLevel$c8e64370e88154b2,
	    .setStrategy$3aa5bc6f9b71ad4e=
		&_jc_java_util_zip_DeflaterEngine$method$setStrategy$3aa5bc6f9b71ad4e,
	    .slideWindow$558e7b830046acb5=
		&_jc_java_util_zip_DeflaterEngine$method$slideWindow$558e7b830046acb5,
	    .updateHash$4b1946ed2c96f904=
		&_jc_java_util_zip_DeflaterEngine$method$updateHash$4b1946ed2c96f904,
	},
    }
};

