// public class java.util.zip.GZIPInputStream

// class file dependencies
// @dep_class caf39081f5f70fef java_io_EOFException
// @dep_class 455accfa535f5dfe java_io_FilterInputStream
// @dep_class 4e0a56550c69d57c java_io_IOException
// @dep_class 66aea4d152614ac4 java_io_InputStream
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class ca631501391a31f1 java_lang_Integer
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 94d357637b968dda java_lang_StringBuffer
// @dep_class 53cc8e2333795f04 java_lang_System
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class 4d1cebae0bdda058 java_lang_VMSystem
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class d31dc884497a5da2 java_util_zip_CRC32
// @dep_class c51bfb23c49b4e67 java_util_zip_GZIPInputStream
// @dep_class 4df3e1cb79f6b935 java_util_zip_Inflater
// @dep_class 5602700a47802920 java_util_zip_InflaterInputStream

// header file dependencies
// @dep_header java_io_EOFException
// @dep_header java_lang_Class
// @dep_header java_lang_Integer
// @dep_header java_lang_String
// @dep_header java_lang_StringBuffer
// @dep_header java_lang_System
// @dep_header java_lang_VMSystem
// @dep_header java_lang_VMThrowable
// @dep_header java_util_zip_CRC32
// @dep_header java_util_zip_GZIPInputStream
// @dep_header java_util_zip_Inflater

#include "jc_defs.h"

#include "java/io/EOFException.h"
#include "java/lang/Class.h"
#include "java/lang/Integer.h"
#include "java/lang/String.h"
#include "java/lang/StringBuffer.h"
#include "java/lang/System.h"
#include "java/lang/VMSystem.h"
#include "java/lang/VMThrowable.h"
#include "java/util/zip/CRC32.h"
#include "java/util/zip/GZIPInputStream.h"
#include "java/util/zip/Inflater.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// public static final int GZIP_MAGIC
static const jint _jc_java_util_zip_GZIPInputStream$initial_value$GZIP__5fMAGIC = 35615;
static _jc_field _jc_java_util_zip_GZIPInputStream$field_info$GZIP__5fMAGIC = {
	.name=		"GZIP_MAGIC",
	.signature=	"I",
	.class=		&_jc_java_util_zip_GZIPInputStream$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PUBLIC|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_java_util_zip_GZIPInputStream$fields_struct, GZIP__5fMAGIC),
	.initial_value=	&_jc_java_util_zip_GZIPInputStream$initial_value$GZIP__5fMAGIC,
};

// static final int FTEXT
static const jint _jc_java_util_zip_GZIPInputStream$initial_value$FTEXT = 1;
static _jc_field _jc_java_util_zip_GZIPInputStream$field_info$FTEXT = {
	.name=		"FTEXT",
	.signature=	"I",
	.class=		&_jc_java_util_zip_GZIPInputStream$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_java_util_zip_GZIPInputStream$fields_struct, FTEXT),
	.initial_value=	&_jc_java_util_zip_GZIPInputStream$initial_value$FTEXT,
};

// static final int FHCRC
static const jint _jc_java_util_zip_GZIPInputStream$initial_value$FHCRC = 2;
static _jc_field _jc_java_util_zip_GZIPInputStream$field_info$FHCRC = {
	.name=		"FHCRC",
	.signature=	"I",
	.class=		&_jc_java_util_zip_GZIPInputStream$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_java_util_zip_GZIPInputStream$fields_struct, FHCRC),
	.initial_value=	&_jc_java_util_zip_GZIPInputStream$initial_value$FHCRC,
};

// static final int FEXTRA
static const jint _jc_java_util_zip_GZIPInputStream$initial_value$FEXTRA = 4;
static _jc_field _jc_java_util_zip_GZIPInputStream$field_info$FEXTRA = {
	.name=		"FEXTRA",
	.signature=	"I",
	.class=		&_jc_java_util_zip_GZIPInputStream$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_java_util_zip_GZIPInputStream$fields_struct, FEXTRA),
	.initial_value=	&_jc_java_util_zip_GZIPInputStream$initial_value$FEXTRA,
};

// static final int FNAME
static const jint _jc_java_util_zip_GZIPInputStream$initial_value$FNAME = 8;
static _jc_field _jc_java_util_zip_GZIPInputStream$field_info$FNAME = {
	.name=		"FNAME",
	.signature=	"I",
	.class=		&_jc_java_util_zip_GZIPInputStream$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_java_util_zip_GZIPInputStream$fields_struct, FNAME),
	.initial_value=	&_jc_java_util_zip_GZIPInputStream$initial_value$FNAME,
};

// static final int FCOMMENT
static const jint _jc_java_util_zip_GZIPInputStream$initial_value$FCOMMENT = 16;
static _jc_field _jc_java_util_zip_GZIPInputStream$field_info$FCOMMENT = {
	.name=		"FCOMMENT",
	.signature=	"I",
	.class=		&_jc_java_util_zip_GZIPInputStream$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_java_util_zip_GZIPInputStream$fields_struct, FCOMMENT),
	.initial_value=	&_jc_java_util_zip_GZIPInputStream$initial_value$FCOMMENT,
};

// protected java.util.zip.CRC32 crc
static _jc_field _jc_java_util_zip_GZIPInputStream$field_info$crc = {
	.name=		"crc",
	.signature=	"Ljava/util/zip/CRC32;",
	.class=		&_jc_java_util_zip_GZIPInputStream$type,
	.type=		&_jc_java_util_zip_CRC32$type,
	.access_flags=	_JC_ACC_PROTECTED,
	.offset=	_JC_OFFSETOF(_jc_java_util_zip_GZIPInputStream$object, refs[-1].java_util_zip_GZIPInputStream.crc),
};

// protected boolean eos
static _jc_field _jc_java_util_zip_GZIPInputStream$field_info$eos = {
	.name=		"eos",
	.signature=	"Z",
	.class=		&_jc_java_util_zip_GZIPInputStream$type,
	.type=		&_jc_boolean$prim$type,
	.access_flags=	_JC_ACC_PROTECTED,
	.offset=	_JC_OFFSETOF(_jc_java_util_zip_GZIPInputStream$object, nonrefs.java_util_zip_GZIPInputStream.eos),
};

// private boolean readGZIPHeader
static _jc_field _jc_java_util_zip_GZIPInputStream$field_info$readGZIPHeader = {
	.name=		"readGZIPHeader",
	.signature=	"Z",
	.class=		&_jc_java_util_zip_GZIPInputStream$type,
	.type=		&_jc_boolean$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_java_util_zip_GZIPInputStream$object, nonrefs.java_util_zip_GZIPInputStream.readGZIPHeader),
};

// Fields
static _jc_field *const _jc_java_util_zip_GZIPInputStream$fields[] = {
	&_jc_java_util_zip_GZIPInputStream$field_info$FCOMMENT,
	&_jc_java_util_zip_GZIPInputStream$field_info$FEXTRA,
	&_jc_java_util_zip_GZIPInputStream$field_info$FHCRC,
	&_jc_java_util_zip_GZIPInputStream$field_info$FNAME,
	&_jc_java_util_zip_GZIPInputStream$field_info$FTEXT,
	&_jc_java_util_zip_GZIPInputStream$field_info$GZIP__5fMAGIC,
	&_jc_java_util_zip_GZIPInputStream$field_info$crc,
	&_jc_java_util_zip_GZIPInputStream$field_info$eos,
	&_jc_java_util_zip_GZIPInputStream$field_info$readGZIPHeader
};

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// public void <init>(java.io.InputStream) throws java.io.IOException
//

static _jc_linenum _jc_java_util_zip_GZIPInputStream$linenum_table$_init$3887600c17c5e554[];

static const unsigned char _jc_java_util_zip_GZIPInputStream$param_ptypes$_init$3887600c17c5e554[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_java_util_zip_GZIPInputStream$exceptions$_init$3887600c17c5e554[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_java_util_zip_GZIPInputStream$param_types$_init$3887600c17c5e554[] = {
	&_jc_java_io_InputStream$type
};

_jc_method _jc_java_util_zip_GZIPInputStream$method_info$_init$3887600c17c5e554 = {
	.name=			"<init>",
	.signature=		"(Ljava/io/InputStream;)V",
	.class=			&_jc_java_util_zip_GZIPInputStream$type,
	.param_types=		&_jc_java_util_zip_GZIPInputStream$param_types$_init$3887600c17c5e554,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_util_zip_GZIPInputStream$param_ptypes$_init$3887600c17c5e554,
	.signature_hash=	_JC_JLONG(0x3887600c17c5e554),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_util_zip_GZIPInputStream$method$_init$3887600c17c5e554,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_util_zip_GZIPInputStream$exceptions$_init$3887600c17c5e554,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_java_util_zip_GZIPInputStream$linenum_table$_init$3887600c17c5e554
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_util_zip_GZIPInputStream, _init$3887600c17c5e554);

void _JC_JCNI_ATTR
_jc_java_util_zip_GZIPInputStream$method$_init$3887600c17c5e554(_jc_env *const env, _jc_java_util_zip_GZIPInputStream$object *this, _jc_java_io_InputStream$object *param0)
{
	struct _jc_java_util_zip_GZIPInputStream$object *r0;
	struct _jc_java_io_InputStream$object *r1;
	struct _jc_java_util_zip_Inflater$object *r2;
	struct _jc_java_util_zip_CRC32$object *r3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = _JC_NEW(env, java_util_zip_Inflater);
	_JC_INVOKE_NONVIRTUAL(env, java_util_zip_Inflater, _init$f0a6314ff7de5110, 0, r2, 1);
	_JC_INVOKE_NONVIRTUAL(env, java_util_zip_InflaterInputStream, _init$c297c4a8a618e86d, 0, r0, r1, r2, 4096);
	r3 = _JC_NEW(env, java_util_zip_CRC32);
	_JC_PRIM_FIELD(env, r3, java_util_zip_CRC32, crc) = 0;
	_JC_REF_FIELD(env, r0, java_util_zip_GZIPInputStream, crc) = r3;
	_JC_INVOKE_NONVIRTUAL(env, java_util_zip_GZIPInputStream, readHeader$315d703f8609c43e, 0, r0);
	_JC_LINE_NUMBER(113);				// 0
	return;
}

//
// public void <init>(java.io.InputStream, int) throws java.io.IOException
//

static _jc_linenum _jc_java_util_zip_GZIPInputStream$linenum_table$_init$cce795e7dffd722d[];

static const unsigned char _jc_java_util_zip_GZIPInputStream$param_ptypes$_init$cce795e7dffd722d[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_VOID };

static _jc_type *const _jc_java_util_zip_GZIPInputStream$exceptions$_init$cce795e7dffd722d[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_java_util_zip_GZIPInputStream$param_types$_init$cce795e7dffd722d[] = {
	&_jc_java_io_InputStream$type,
	&_jc_int$prim$type
};

_jc_method _jc_java_util_zip_GZIPInputStream$method_info$_init$cce795e7dffd722d = {
	.name=			"<init>",
	.signature=		"(Ljava/io/InputStream;I)V",
	.class=			&_jc_java_util_zip_GZIPInputStream$type,
	.param_types=		&_jc_java_util_zip_GZIPInputStream$param_types$_init$cce795e7dffd722d,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_util_zip_GZIPInputStream$param_ptypes$_init$cce795e7dffd722d,
	.signature_hash=	_JC_JLONG(0xcce795e7dffd722d),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_util_zip_GZIPInputStream$method$_init$cce795e7dffd722d,
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_util_zip_GZIPInputStream$exceptions$_init$cce795e7dffd722d,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_java_util_zip_GZIPInputStream$linenum_table$_init$cce795e7dffd722d
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_util_zip_GZIPInputStream, _init$cce795e7dffd722d);

void _JC_JCNI_ATTR
_jc_java_util_zip_GZIPInputStream$method$_init$cce795e7dffd722d(_jc_env *const env, _jc_java_util_zip_GZIPInputStream$object *this, _jc_java_io_InputStream$object *param0, jint param1)
{
	jint i0;
	struct _jc_java_util_zip_GZIPInputStream$object *r0;
	struct _jc_java_io_InputStream$object *r1;
	struct _jc_java_util_zip_Inflater$object *r2;
	struct _jc_java_util_zip_CRC32$object *r3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	i0 = param1;
	_JC_LINE_NUMBER(129);				// 0
	r2 = _JC_NEW(env, java_util_zip_Inflater);
	_JC_INVOKE_NONVIRTUAL(env, java_util_zip_Inflater, _init$f0a6314ff7de5110, 0, r2, 1);
	_JC_INVOKE_NONVIRTUAL(env, java_util_zip_InflaterInputStream, _init$c297c4a8a618e86d, 0, r0, r1, r2, i0);
	_JC_LINE_NUMBER(130);				// 1
	r3 = _JC_NEW(env, java_util_zip_CRC32);
	_JC_PRIM_FIELD(env, r3, java_util_zip_CRC32, crc) = 0;
	_JC_REF_FIELD(env, r0, java_util_zip_GZIPInputStream, crc) = r3;
	_JC_LINE_NUMBER(131);				// 2
	_JC_INVOKE_NONVIRTUAL(env, java_util_zip_GZIPInputStream, readHeader$315d703f8609c43e, 0, r0);
	_JC_LINE_NUMBER(132);				// 3
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public void close() throws java.io.IOException
//

static _jc_linenum _jc_java_util_zip_GZIPInputStream$linenum_table$close$6aba8b329fddcd79[];

static const unsigned char _jc_java_util_zip_GZIPInputStream$param_ptypes$close$6aba8b329fddcd79[] = { 
_JC_TYPE_VOID };

static _jc_type *const _jc_java_util_zip_GZIPInputStream$exceptions$close$6aba8b329fddcd79[] = {
	&_jc_java_io_IOException$type
};

_jc_method _jc_java_util_zip_GZIPInputStream$method_info$close$6aba8b329fddcd79 = {
	.name=			"close",
	.signature=		"()V",
	.class=			&_jc_java_util_zip_GZIPInputStream$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_util_zip_GZIPInputStream$param_ptypes$close$6aba8b329fddcd79,
	.signature_hash=	_JC_JLONG(0x6aba8b329fddcd79),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_util_zip_GZIPInputStream$method$close$6aba8b329fddcd79,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_util_zip_GZIPInputStream$vtable, java_util_zip_GZIPInputStream.close$6aba8b329fddcd79) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_util_zip_GZIPInputStream$exceptions$close$6aba8b329fddcd79,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_java_util_zip_GZIPInputStream$linenum_table$close$6aba8b329fddcd79
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_util_zip_GZIPInputStream, close$6aba8b329fddcd79);

void _JC_JCNI_ATTR
_jc_java_util_zip_GZIPInputStream$method$close$6aba8b329fddcd79(_jc_env *const env, _jc_java_util_zip_GZIPInputStream$object *this)
{
	struct _jc_java_util_zip_GZIPInputStream$object *r0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(143);				// 0
	_JC_INVOKE_NONVIRTUAL(env, java_util_zip_InflaterInputStream, close$6aba8b329fddcd79, 0, r0);
	_JC_LINE_NUMBER(144);				// 1
	return;
}

//
// public int read(byte[], int, int) throws java.io.IOException
//

static _jc_linenum _jc_java_util_zip_GZIPInputStream$linenum_table$read$e6b6c87b9f256783[];

static const unsigned char _jc_java_util_zip_GZIPInputStream$param_ptypes$read$e6b6c87b9f256783[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_INT, _JC_TYPE_INT };

static _jc_type *const _jc_java_util_zip_GZIPInputStream$exceptions$read$e6b6c87b9f256783[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_java_util_zip_GZIPInputStream$param_types$read$e6b6c87b9f256783[] = {
	&_jc_byte$array$prim$type,
	&_jc_int$prim$type,
	&_jc_int$prim$type
};

_jc_method _jc_java_util_zip_GZIPInputStream$method_info$read$e6b6c87b9f256783 = {
	.name=			"read",
	.signature=		"([BII)I",
	.class=			&_jc_java_util_zip_GZIPInputStream$type,
	.param_types=		&_jc_java_util_zip_GZIPInputStream$param_types$read$e6b6c87b9f256783,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_java_util_zip_GZIPInputStream$param_ptypes$read$e6b6c87b9f256783,
	.signature_hash=	_JC_JLONG(0xe6b6c87b9f256783),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_java_util_zip_GZIPInputStream$method$read$e6b6c87b9f256783,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_util_zip_GZIPInputStream$vtable, java_util_zip_GZIPInputStream.read$e6b6c87b9f256783) / sizeof(void *),
	.num_parameters=	3,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_util_zip_GZIPInputStream$exceptions$read$e6b6c87b9f256783,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	10,
	      .table=	_jc_java_util_zip_GZIPInputStream$linenum_table$read$e6b6c87b9f256783
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_util_zip_GZIPInputStream, read$e6b6c87b9f256783);

jint _JC_JCNI_ATTR
_jc_java_util_zip_GZIPInputStream$method$read$e6b6c87b9f256783(_jc_env *const env, _jc_java_util_zip_GZIPInputStream$object *this, _jc_byte_array *param0, jint param1, jint param2)
{
	jint i0;
	jint i1;
	struct _jc_java_util_zip_GZIPInputStream$object *r0;
	_jc_byte_array *r1;
	struct _jc_java_util_zip_CRC32$object *r2;
	struct _jc_java_util_zip_Inflater$object *r3;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	i0 = param1;
	i1 = param2;
	_JC_LINE_NUMBER(168);				// 0
	z0 = _JC_PRIM_FIELD(env, r0, java_util_zip_GZIPInputStream, readGZIPHeader);
	if (z0 != 0)
		goto label0;
	_JC_LINE_NUMBER(169);				// 1
	_JC_INVOKE_NONVIRTUAL(env, java_util_zip_GZIPInputStream, readHeader$315d703f8609c43e, 0, r0);

label0:
	_JC_LINE_NUMBER(171);				// 2
	z0 = _JC_PRIM_FIELD(env, r0, java_util_zip_GZIPInputStream, eos);
	if (z0 == 0)
		goto label1;
	_JC_LINE_NUMBER(172);				// 3
	return -1;

label1:
	_JC_LINE_NUMBER(179);				// 4
	i1 = _JC_INVOKE_NONVIRTUAL(env, java_util_zip_InflaterInputStream, read$e6b6c87b9f256783, 0, r0, r1, i0, i1);
	_JC_LINE_NUMBER(180);				// 5
	if (i1 <= 0)
		goto label2;
	_JC_LINE_NUMBER(181);				// 6
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_GZIPInputStream, crc);
	_JC_INVOKE_VIRTUAL(env, java_util_zip_CRC32, update$f73f1b3bfa3ea853, r2, r1, i0, i1);

label2:
	_JC_LINE_NUMBER(183);				// 7
	r3 = _JC_REF_FIELD(env, r0, java_util_zip_InflaterInputStream, inf);
	z0 = _JC_INVOKE_VIRTUAL(env, java_util_zip_Inflater, finished$026d0895e76fe0dc, r3);
	if (z0 == 0)
		goto label3;
	_JC_LINE_NUMBER(184);				// 8
	_JC_INVOKE_NONVIRTUAL(env, java_util_zip_GZIPInputStream, readFooter$94f938333ce0ddb6, 0, r0);

label3:
	_JC_LINE_NUMBER(185);				// 9
	return i1;
}

//
// private final void readFooter() throws java.io.IOException
//

static _jc_linenum _jc_java_util_zip_GZIPInputStream$linenum_table$readFooter$94f938333ce0ddb6[];

static const unsigned char _jc_java_util_zip_GZIPInputStream$param_ptypes$readFooter$94f938333ce0ddb6[] = { 
_JC_TYPE_VOID };

static _jc_type *const _jc_java_util_zip_GZIPInputStream$exceptions$readFooter$94f938333ce0ddb6[] = {
	&_jc_java_io_IOException$type
};

_jc_method _jc_java_util_zip_GZIPInputStream$method_info$readFooter$94f938333ce0ddb6 = {
	.name=			"readFooter",
	.signature=		"()V",
	.class=			&_jc_java_util_zip_GZIPInputStream$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_util_zip_GZIPInputStream$param_ptypes$readFooter$94f938333ce0ddb6,
	.signature_hash=	_JC_JLONG(0x94f938333ce0ddb6),
	.access_flags=		_JC_ACC_PRIVATE|_JC_ACC_FINAL,
	.function=		&_jc_java_util_zip_GZIPInputStream$method$readFooter$94f938333ce0ddb6,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_util_zip_GZIPInputStream$vtable, java_util_zip_GZIPInputStream.readFooter$94f938333ce0ddb6) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_util_zip_GZIPInputStream$exceptions$readFooter$94f938333ce0ddb6,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	20,
	      .table=	_jc_java_util_zip_GZIPInputStream$linenum_table$readFooter$94f938333ce0ddb6
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_util_zip_GZIPInputStream, readFooter$94f938333ce0ddb6);

void _JC_JCNI_ATTR
_jc_java_util_zip_GZIPInputStream$method$readFooter$94f938333ce0ddb6(_jc_env *const env, _jc_java_util_zip_GZIPInputStream$object *this)
{
	jbyte b3;
	jint i0;
	jint i1;
	jint i2;
	jint i7;
	jlong l6;
	struct _jc_java_util_zip_GZIPInputStream$object *r0;
	_jc_byte_array *r1;
	struct _jc_java_lang_String$object *r10;
	struct _jc_java_lang_String$object *r11;
	struct _jc_java_lang_String$object *r12;
	struct _jc_java_lang_String$object *r13;
	struct _jc_java_lang_VMThrowable$object *r14;
	struct _jc_java_lang_VMThrowable$object *r15;
	struct _jc_java_lang_VMThrowable$object *r16;
	struct _jc_java_lang_String$object *r17;
	_jc_char_array *r18;
	struct _jc_java_util_zip_Inflater$object *r2;
	_jc_byte_array *r3;
	struct _jc_java_io_InputStream$object *r4;
	struct _jc_java_io_EOFException$object *r5;
	struct _jc_java_util_zip_CRC32$object *r6;
	struct _jc_java_io_IOException$object *r7;
	struct _jc_java_lang_StringBuffer$object *r8;
	struct _jc_java_lang_String$object *r9;
	jshort s4;
	jshort s5;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(323);				// 0
	r1 = _JC_NEW_PRIM_ARRAY(env, byte, 1, 8);
	_JC_LINE_NUMBER(324);				// 1
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_InflaterInputStream, inf);
	i0 = _JC_INVOKE_VIRTUAL(env, java_util_zip_Inflater, getRemaining$ea62a8f944647e1f, r2);
	_JC_LINE_NUMBER(325);				// 2
	if (i0 <= 8)
		goto label0;
	_JC_LINE_NUMBER(326);				// 3
	i0 = 8;

label0:
	_JC_LINE_NUMBER(327);				// 4
	r3 = _JC_REF_FIELD(env, r0, java_util_zip_InflaterInputStream, buf);
	i1 = _JC_PRIM_FIELD(env, r0, java_util_zip_InflaterInputStream, len);
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_InflaterInputStream, inf);
	i2 = _JC_INVOKE_VIRTUAL(env, java_util_zip_Inflater, getRemaining$ea62a8f944647e1f, r2);
	i2 = i1 - i2;
	_JC_ACTIVE_USE(env, java_lang_System);
	_JC_INVOKE_STATIC(env, java_lang_VMSystem, arraycopy$4286a72d57744cd8, 0, r3, i2, r1, 0, i0);
	_JC_LINE_NUMBER(328);				// 5
	i0 = 8 - i0;
	_JC_LINE_NUMBER(329);				// 6
	goto label3;

label1:
	_JC_LINE_NUMBER(331);				// 7
	r4 = _JC_REF_FIELD(env, r0, java_io_FilterInputStream, in);
	i2 = 8 - i0;
	i1 = _JC_INVOKE_VIRTUAL(env, java_io_InputStream, read$e6b6c87b9f256783, r4, r1, i2, i0);
	_JC_LINE_NUMBER(332);				// 8
	if (i1 > 0)
		goto label2;
	_JC_LINE_NUMBER(333);				// 9
	r5 = _JC_NEW(env, java_io_EOFException);
	r9 = _JC_STRING(env, "Early EOF in GZIP footer");
	_JC_REF_FIELD(env, r5, java_lang_Throwable, cause) = r5;
	r14 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r5);
	_JC_REF_FIELD(env, r5, java_lang_Throwable, vmState) = r14;
	_JC_REF_FIELD(env, r5, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r5, java_lang_Throwable, detailMessage) = r9;
	_JC_THROW(env, r5);

label2:
	_JC_LINE_NUMBER(334);				// 10
	i0 = i0 - i1;

label3:
	_JC_LINE_NUMBER(329);				// 11
	if (i0 > 0) {
		_JC_PERIODIC_CHECK(env);
		goto label1;
	}
	_JC_LINE_NUMBER(337);				// 12
	b3 = _JC_PRIM_ELEMENT(env, byte, r1, 0, 0, 0);
	s4 = b3 & 255;
	b3 = _JC_PRIM_ELEMENT(env, byte, r1, 1, 0, 0);
	s5 = b3 & 255;
	i2 = s5 << (8 & 0x1f);
	i2 = s4 | i2;
	b3 = _JC_PRIM_ELEMENT(env, byte, r1, 2, 0, 0);
	s5 = b3 & 255;
	i1 = s5 << (16 & 0x1f);
	i2 = i2 | i1;
	b3 = _JC_PRIM_ELEMENT(env, byte, r1, 3, 0, 0);
	i1 = b3 << (24 & 0x1f);
	i2 = i2 | i1;
	_JC_LINE_NUMBER(339);				// 13
	r6 = _JC_REF_FIELD(env, r0, java_util_zip_GZIPInputStream, crc);
	l6 = _JC_INVOKE_VIRTUAL(env, java_util_zip_CRC32, getValue$738f22e2bb5f71e8, r6);
	i1 = (jint)l6;
	if (i2 == i1)
		goto label4;
	_JC_LINE_NUMBER(340);				// 14
	r7 = _JC_NEW(env, java_io_IOException);
	r8 = _JC_NEW(env, java_lang_StringBuffer);
	r17 = _JC_STRING(env, "GZIP crc sum mismatch, theirs \"");
	i7 = _JC_PRIM_FIELD(env, r17, java_lang_String, count);
	_JC_PRIM_FIELD(env, r8, java_lang_StringBuffer, count) = i7;
	i7 = _JC_PRIM_FIELD(env, r8, java_lang_StringBuffer, count);
	i7 = i7 + 16;
	r18 = _JC_NEW_PRIM_ARRAY(env, char, 1, i7);
	_JC_REF_FIELD(env, r8, java_lang_StringBuffer, value) = r18;
	i7 = _JC_PRIM_FIELD(env, r8, java_lang_StringBuffer, count);
	r18 = _JC_REF_FIELD(env, r8, java_lang_StringBuffer, value);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, getChars$c684dea7317ff063, 0, r17, 0, i7, r18, 0);
	_JC_ACTIVE_USE(env, java_lang_Integer);
	r10 = _JC_INVOKE_STATIC(env, java_lang_Integer, toUnsignedString$0e382aff778c29b9, 1, i2, 4);
	r8 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r8, r10);
	r8 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r8, _JC_STRING(env, "\" and ours \""));
	r6 = _JC_REF_FIELD(env, r0, java_util_zip_GZIPInputStream, crc);
	l6 = _JC_INVOKE_VIRTUAL(env, java_util_zip_CRC32, getValue$738f22e2bb5f71e8, r6);
	i2 = (jint)l6;
	r11 = _JC_INVOKE_STATIC(env, java_lang_Integer, toUnsignedString$0e382aff778c29b9, 1, i2, 4);
	r8 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r8, r11);
	r13 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r13, r8);
	_JC_REF_FIELD(env, r7, java_lang_Throwable, cause) = r7;
	r15 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r7);
	_JC_REF_FIELD(env, r7, java_lang_Throwable, vmState) = r15;
	_JC_REF_FIELD(env, r7, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r7, java_lang_Throwable, detailMessage) = r13;
	_JC_THROW(env, r7);

label4:
	_JC_LINE_NUMBER(345);				// 15
	b3 = _JC_PRIM_ELEMENT(env, byte, r1, 4, 0, 1);
	s5 = b3 & 255;
	b3 = _JC_PRIM_ELEMENT(env, byte, r1, 5, 0, 1);
	s4 = b3 & 255;
	i2 = s4 << (8 & 0x1f);
	i2 = s5 | i2;
	b3 = _JC_PRIM_ELEMENT(env, byte, r1, 6, 0, 1);
	s5 = b3 & 255;
	i1 = s5 << (16 & 0x1f);
	i2 = i2 | i1;
	b3 = _JC_PRIM_ELEMENT(env, byte, r1, 7, 0, 1);
	i1 = b3 << (24 & 0x1f);
	i1 = i2 | i1;
	_JC_LINE_NUMBER(347);				// 16
	r2 = _JC_REF_FIELD(env, r0, java_util_zip_InflaterInputStream, inf);
	i2 = _JC_INVOKE_VIRTUAL(env, java_util_zip_Inflater, getTotalOut$44b05177851c8dbc, r2);
	if (i1 == i2)
		goto label5;
	_JC_LINE_NUMBER(348);				// 17
	r7 = _JC_NEW(env, java_io_IOException);
	r12 = _JC_STRING(env, "Number of bytes mismatch");
	_JC_REF_FIELD(env, r7, java_lang_Throwable, cause) = r7;
	r16 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r7);
	_JC_REF_FIELD(env, r7, java_lang_Throwable, vmState) = r16;
	_JC_REF_FIELD(env, r7, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r7, java_lang_Throwable, detailMessage) = r12;
	_JC_THROW(env, r7);

label5:
	_JC_LINE_NUMBER(353);				// 18
	_JC_PRIM_FIELD(env, r0, java_util_zip_GZIPInputStream, eos) = 1;
	_JC_LINE_NUMBER(354);				// 19
	return;
}

//
// private final void readHeader() throws java.io.IOException
//

static _jc_linenum _jc_java_util_zip_GZIPInputStream$linenum_table$readHeader$315d703f8609c43e[];

static const unsigned char _jc_java_util_zip_GZIPInputStream$param_ptypes$readHeader$315d703f8609c43e[] = { 
_JC_TYPE_VOID };

static _jc_type *const _jc_java_util_zip_GZIPInputStream$exceptions$readHeader$315d703f8609c43e[] = {
	&_jc_java_io_IOException$type
};

_jc_method _jc_java_util_zip_GZIPInputStream$method_info$readHeader$315d703f8609c43e = {
	.name=			"readHeader",
	.signature=		"()V",
	.class=			&_jc_java_util_zip_GZIPInputStream$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_java_util_zip_GZIPInputStream$param_ptypes$readHeader$315d703f8609c43e,
	.signature_hash=	_JC_JLONG(0x315d703f8609c43e),
	.access_flags=		_JC_ACC_PRIVATE|_JC_ACC_FINAL,
	.function=		&_jc_java_util_zip_GZIPInputStream$method$readHeader$315d703f8609c43e,
	.vtable_index=		_JC_OFFSETOF(struct _jc_java_util_zip_GZIPInputStream$vtable, java_util_zip_GZIPInputStream.readHeader$315d703f8609c43e) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_java_util_zip_GZIPInputStream$exceptions$readHeader$315d703f8609c43e,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	62,
	      .table=	_jc_java_util_zip_GZIPInputStream$linenum_table$readHeader$315d703f8609c43e
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(java_util_zip_GZIPInputStream, readHeader$315d703f8609c43e);

void _JC_JCNI_ATTR
_jc_java_util_zip_GZIPInputStream$method$readHeader$315d703f8609c43e(_jc_env *const env, _jc_java_util_zip_GZIPInputStream$object *this)
{
	jchar c4;
	jint i0;
	jint i1;
	jint i10;
	jint i11;
	jint i12;
	jint i13;
	jint i14;
	jint i15;
	jint i16;
	jint i17;
	jint i18;
	jint i19;
	jint i2;
	jint i20;
	jint i21;
	jint i22;
	jint i23;
	jint i24;
	jint i25;
	jint i26;
	jint i27;
	jint i28;
	jint i3;
	jint i5;
	jint i7;
	jint i8;
	jint i9;
	jlong l6;
	struct _jc_java_util_zip_GZIPInputStream$object *r0;
	struct _jc_java_util_zip_CRC32$object *r1;
	struct _jc_java_lang_String$object *r10;
	struct _jc_java_lang_String$object *r11;
	struct _jc_java_lang_String$object *r12;
	struct _jc_java_lang_String$object *r13;
	struct _jc_java_lang_String$object *r14;
	struct _jc_java_lang_String$object *r15;
	struct _jc_java_lang_String$object *r16;
	struct _jc_java_lang_String$object *r17;
	struct _jc_java_lang_String$object *r18;
	struct _jc_java_lang_VMThrowable$object *r19;
	struct _jc_java_io_InputStream$object *r2;
	struct _jc_java_lang_VMThrowable$object *r20;
	struct _jc_java_lang_VMThrowable$object *r21;
	struct _jc_java_lang_VMThrowable$object *r22;
	struct _jc_java_lang_VMThrowable$object *r23;
	struct _jc_java_lang_VMThrowable$object *r24;
	struct _jc_java_lang_VMThrowable$object *r25;
	struct _jc_java_lang_VMThrowable$object *r26;
	struct _jc_java_lang_VMThrowable$object *r27;
	struct _jc_java_lang_VMThrowable$object *r28;
	struct _jc_java_lang_VMThrowable$object *r29;
	struct _jc_java_io_IOException$object *r3;
	struct _jc_java_lang_VMThrowable$object *r30;
	struct _jc_java_lang_VMThrowable$object *r31;
	struct _jc_java_lang_VMThrowable$object *r32;
	_jc_int_array *r33;
	_jc_int_array *r34;
	_jc_int_array *r35;
	_jc_int_array *r36;
	_jc_int_array *r37;
	_jc_int_array *r38;
	_jc_int_array *r39;
	struct _jc_java_io_EOFException$object *r4;
	_jc_int_array *r40;
	_jc_int_array *r41;
	_jc_int_array *r42;
	_jc_int_array *r44;
	struct _jc_java_lang_String$object *r5;
	struct _jc_java_lang_String$object *r6;
	struct _jc_java_lang_String$object *r7;
	struct _jc_java_lang_String$object *r8;
	struct _jc_java_lang_String$object *r9;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(195);				// 0
	r1 = _JC_NEW(env, java_util_zip_CRC32);
	_JC_PRIM_FIELD(env, r1, java_util_zip_CRC32, crc) = 0;
	_JC_LINE_NUMBER(196);				// 1
	r2 = _JC_REF_FIELD(env, r0, java_io_FilterInputStream, in);
	i0 = _JC_INVOKE_VIRTUAL(env, java_io_InputStream, read$1a981297cb524963, r2);
	_JC_LINE_NUMBER(197);				// 2
	if (i0 >= 0)
		goto label0;
	_JC_LINE_NUMBER(199);				// 3
	_JC_PRIM_FIELD(env, r0, java_util_zip_GZIPInputStream, eos) = 1;
	_JC_LINE_NUMBER(200);				// 4
	return;

label0:
	_JC_LINE_NUMBER(202);				// 5
	r2 = _JC_REF_FIELD(env, r0, java_io_FilterInputStream, in);
	i1 = _JC_INVOKE_VIRTUAL(env, java_io_InputStream, read$1a981297cb524963, r2);
	_JC_LINE_NUMBER(203);				// 6
	i3 = i1 << (8 & 0x1f);
	i3 = i0 + i3;
	if (i3 == 35615)
		goto label1;
	_JC_LINE_NUMBER(204);				// 7
	r3 = _JC_NEW(env, java_io_IOException);
	r5 = _JC_STRING(env, "Error in GZIP header, bad magic code");
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r19 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r19;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r5;
	_JC_THROW(env, r3);

label1:
	i8 = _JC_PRIM_FIELD(env, r1, java_util_zip_CRC32, crc);
	i8 = i8 ^ -1;
	r33 = _JC_STATIC_FIELD(env, java_util_zip_CRC32, crc__5ftable, 1);
	i7 = i8 ^ i0;
	i7 = i7 & 255;
	i7 = _JC_PRIM_ELEMENT(env, int, r33, i7, 1, 1);
	i8 = _JC_IUSHR(i8, 8);
	i8 = i7 ^ i8;
	i8 = i8 ^ -1;
	_JC_PRIM_FIELD(env, r1, java_util_zip_CRC32, crc) = i8;
	i10 = _JC_PRIM_FIELD(env, r1, java_util_zip_CRC32, crc);
	i10 = i10 ^ -1;
	r34 = _JC_STATIC_FIELD(env, java_util_zip_CRC32, crc__5ftable, 1);
	i9 = i10 ^ i1;
	i9 = i9 & 255;
	i9 = _JC_PRIM_ELEMENT(env, int, r34, i9, 1, 1);
	i10 = _JC_IUSHR(i10, 8);
	i10 = i9 ^ i10;
	i10 = i10 ^ -1;
	_JC_PRIM_FIELD(env, r1, java_util_zip_CRC32, crc) = i10;
	_JC_LINE_NUMBER(209);				// 8
	r2 = _JC_REF_FIELD(env, r0, java_io_FilterInputStream, in);
	i1 = _JC_INVOKE_VIRTUAL(env, java_io_InputStream, read$1a981297cb524963, r2);
	_JC_LINE_NUMBER(210);				// 9
	if (i1 == 8)
		goto label2;
	_JC_LINE_NUMBER(211);				// 10
	r3 = _JC_NEW(env, java_io_IOException);
	r6 = _JC_STRING(env, "Error in GZIP header, data not in deflate format");
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r20 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r20;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r6;
	_JC_THROW(env, r3);

label2:
	i12 = _JC_PRIM_FIELD(env, r1, java_util_zip_CRC32, crc);
	i12 = i12 ^ -1;
	r35 = _JC_STATIC_FIELD(env, java_util_zip_CRC32, crc__5ftable, 1);
	i11 = i12 ^ i1;
	i11 = i11 & 255;
	i11 = _JC_PRIM_ELEMENT(env, int, r35, i11, 1, 1);
	i12 = _JC_IUSHR(i12, 8);
	i12 = i11 ^ i12;
	i12 = i12 ^ -1;
	_JC_PRIM_FIELD(env, r1, java_util_zip_CRC32, crc) = i12;
	_JC_LINE_NUMBER(215);				// 11
	r2 = _JC_REF_FIELD(env, r0, java_io_FilterInputStream, in);
	i1 = _JC_INVOKE_VIRTUAL(env, java_io_InputStream, read$1a981297cb524963, r2);
	_JC_LINE_NUMBER(216);				// 12
	if (i1 >= 0)
		goto label3;
	_JC_LINE_NUMBER(217);				// 13
	r4 = _JC_NEW(env, java_io_EOFException);
	r7 = _JC_STRING(env, "Early EOF in GZIP header");
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r21 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r21;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r7;
	_JC_THROW(env, r4);

label3:
	i14 = _JC_PRIM_FIELD(env, r1, java_util_zip_CRC32, crc);
	i14 = i14 ^ -1;
	r36 = _JC_STATIC_FIELD(env, java_util_zip_CRC32, crc__5ftable, 1);
	i13 = i14 ^ i1;
	i13 = i13 & 255;
	i13 = _JC_PRIM_ELEMENT(env, int, r36, i13, 1, 1);
	i14 = _JC_IUSHR(i14, 8);
	i14 = i13 ^ i14;
	i14 = i14 ^ -1;
	_JC_PRIM_FIELD(env, r1, java_util_zip_CRC32, crc) = i14;
	_JC_LINE_NUMBER(233);				// 14
	i3 = i1 & 208;
	if (i3 == 0)
		goto label4;
	_JC_LINE_NUMBER(234);				// 15
	r3 = _JC_NEW(env, java_io_IOException);
	r8 = _JC_STRING(env, "Reserved flag bits in GZIP header != 0");
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r22 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r22;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r8;
	_JC_THROW(env, r3);

label4:
	_JC_LINE_NUMBER(237);				// 16
	i0 = 0;
	goto label7;

label5:
	_JC_LINE_NUMBER(239);				// 17
	r2 = _JC_REF_FIELD(env, r0, java_io_FilterInputStream, in);
	i2 = _JC_INVOKE_VIRTUAL(env, java_io_InputStream, read$1a981297cb524963, r2);
	_JC_LINE_NUMBER(240);				// 18
	if (i2 >= 0)
		goto label6;
	_JC_LINE_NUMBER(241);				// 19
	r4 = _JC_NEW(env, java_io_EOFException);
	r9 = _JC_STRING(env, "Early EOF in GZIP header");
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r23 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r23;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r9;
	_JC_THROW(env, r4);

label6:
	i16 = _JC_PRIM_FIELD(env, r1, java_util_zip_CRC32, crc);
	i16 = i16 ^ -1;
	r37 = _JC_STATIC_FIELD(env, java_util_zip_CRC32, crc__5ftable, 1);
	i15 = i16 ^ i2;
	i15 = i15 & 255;
	i15 = _JC_PRIM_ELEMENT(env, int, r37, i15, 1, 1);
	i16 = _JC_IUSHR(i16, 8);
	i16 = i15 ^ i16;
	i16 = i16 ^ -1;
	_JC_PRIM_FIELD(env, r1, java_util_zip_CRC32, crc) = i16;
	_JC_LINE_NUMBER(237);				// 20
	i0 = i0 + 1;

label7:
	if (i0 < 6) {
		_JC_PERIODIC_CHECK(env);
		goto label5;
	}
	_JC_LINE_NUMBER(246);				// 21
	i3 = i1 & 4;
	if (i3 == 0)
		goto label18;
	_JC_LINE_NUMBER(249);				// 22
	i3 = 0;
	goto label10;

label8:
	_JC_LINE_NUMBER(251);				// 23
	r2 = _JC_REF_FIELD(env, r0, java_io_FilterInputStream, in);
	i2 = _JC_INVOKE_VIRTUAL(env, java_io_InputStream, read$1a981297cb524963, r2);
	_JC_LINE_NUMBER(252);				// 24
	if (i2 >= 0)
		goto label9;
	_JC_LINE_NUMBER(253);				// 25
	r4 = _JC_NEW(env, java_io_EOFException);
	r10 = _JC_STRING(env, "Early EOF in GZIP header");
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r24 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r24;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r10;
	_JC_THROW(env, r4);

label9:
	i18 = _JC_PRIM_FIELD(env, r1, java_util_zip_CRC32, crc);
	i18 = i18 ^ -1;
	r38 = _JC_STATIC_FIELD(env, java_util_zip_CRC32, crc__5ftable, 1);
	i17 = i18 ^ i2;
	i17 = i17 & 255;
	i17 = _JC_PRIM_ELEMENT(env, int, r38, i17, 1, 1);
	i18 = _JC_IUSHR(i18, 8);
	i18 = i17 ^ i18;
	i18 = i18 ^ -1;
	_JC_PRIM_FIELD(env, r1, java_util_zip_CRC32, crc) = i18;
	_JC_LINE_NUMBER(249);				// 26
	i3 = i3 + 1;

label10:
	if (i3 < 2) {
		_JC_PERIODIC_CHECK(env);
		goto label8;
	}
	_JC_LINE_NUMBER(256);				// 27
	r2 = _JC_REF_FIELD(env, r0, java_io_FilterInputStream, in);
	i3 = _JC_INVOKE_VIRTUAL(env, java_io_InputStream, read$1a981297cb524963, r2);
	if (i3 < 0)
		goto label11;
	r2 = _JC_REF_FIELD(env, r0, java_io_FilterInputStream, in);
	i3 = _JC_INVOKE_VIRTUAL(env, java_io_InputStream, read$1a981297cb524963, r2);
	if (i3 >= 0)
		goto label12;

label11:
	_JC_LINE_NUMBER(257);				// 28
	r4 = _JC_NEW(env, java_io_EOFException);
	r11 = _JC_STRING(env, "Early EOF in GZIP header");
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r25 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r25;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r11;
	_JC_THROW(env, r4);

label12:
	_JC_LINE_NUMBER(260);				// 29
	r2 = _JC_REF_FIELD(env, r0, java_io_FilterInputStream, in);
	i3 = _JC_INVOKE_VIRTUAL(env, java_io_InputStream, read$1a981297cb524963, r2);
	_JC_LINE_NUMBER(261);				// 30
	r2 = _JC_REF_FIELD(env, r0, java_io_FilterInputStream, in);
	i2 = _JC_INVOKE_VIRTUAL(env, java_io_InputStream, read$1a981297cb524963, r2);
	_JC_LINE_NUMBER(262);				// 31
	if (i3 < 0)
		goto label13;
	if (i2 >= 0)
		goto label14;

label13:
	_JC_LINE_NUMBER(263);				// 32
	r4 = _JC_NEW(env, java_io_EOFException);
	r12 = _JC_STRING(env, "Early EOF in GZIP header");
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r26 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r26;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r12;
	_JC_THROW(env, r4);

label14:
	i20 = _JC_PRIM_FIELD(env, r1, java_util_zip_CRC32, crc);
	i20 = i20 ^ -1;
	r39 = _JC_STATIC_FIELD(env, java_util_zip_CRC32, crc__5ftable, 1);
	i19 = i20 ^ i3;
	i19 = i19 & 255;
	i19 = _JC_PRIM_ELEMENT(env, int, r39, i19, 1, 1);
	i20 = _JC_IUSHR(i20, 8);
	i20 = i19 ^ i20;
	i20 = i20 ^ -1;
	_JC_PRIM_FIELD(env, r1, java_util_zip_CRC32, crc) = i20;
	i22 = _JC_PRIM_FIELD(env, r1, java_util_zip_CRC32, crc);
	i22 = i22 ^ -1;
	r40 = _JC_STATIC_FIELD(env, java_util_zip_CRC32, crc__5ftable, 1);
	i21 = i22 ^ i2;
	i21 = i21 & 255;
	i21 = _JC_PRIM_ELEMENT(env, int, r40, i21, 1, 1);
	i22 = _JC_IUSHR(i22, 8);
	i22 = i21 ^ i22;
	i22 = i22 ^ -1;
	_JC_PRIM_FIELD(env, r1, java_util_zip_CRC32, crc) = i22;
	_JC_LINE_NUMBER(267);				// 33
	i3 = i3 << (8 & 0x1f);
	i2 = i3 | i2;
	_JC_LINE_NUMBER(268);				// 34
	i0 = 0;
	goto label17;

label15:
	_JC_LINE_NUMBER(270);				// 35
	r2 = _JC_REF_FIELD(env, r0, java_io_FilterInputStream, in);
	i3 = _JC_INVOKE_VIRTUAL(env, java_io_InputStream, read$1a981297cb524963, r2);
	_JC_LINE_NUMBER(271);				// 36
	if (i3 >= 0)
		goto label16;
	_JC_LINE_NUMBER(272);				// 37
	r4 = _JC_NEW(env, java_io_EOFException);
	r13 = _JC_STRING(env, "Early EOF in GZIP header");
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r27 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r27;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r13;
	_JC_THROW(env, r4);

label16:
	i24 = _JC_PRIM_FIELD(env, r1, java_util_zip_CRC32, crc);
	i24 = i24 ^ -1;
	r41 = _JC_STATIC_FIELD(env, java_util_zip_CRC32, crc__5ftable, 1);
	i23 = i24 ^ i3;
	i23 = i23 & 255;
	i23 = _JC_PRIM_ELEMENT(env, int, r41, i23, 1, 1);
	i24 = _JC_IUSHR(i24, 8);
	i24 = i23 ^ i24;
	i24 = i24 ^ -1;
	_JC_PRIM_FIELD(env, r1, java_util_zip_CRC32, crc) = i24;
	_JC_LINE_NUMBER(268);				// 38
	i0 = i0 + 1;

label17:
	if (i0 < i2) {
		_JC_PERIODIC_CHECK(env);
		goto label15;
	}

label18:
	_JC_LINE_NUMBER(278);				// 39
	i3 = i1 & 8;
	if (i3 == 0)
		goto label22;
	_JC_LINE_NUMBER(281);				// 40
	goto label20;

label19:
	i26 = _JC_PRIM_FIELD(env, r1, java_util_zip_CRC32, crc);
	i26 = i26 ^ -1;
	r42 = _JC_STATIC_FIELD(env, java_util_zip_CRC32, crc__5ftable, 1);
	i25 = i26 ^ i3;
	i25 = i25 & 255;
	i25 = _JC_PRIM_ELEMENT(env, int, r42, i25, 1, 1);
	i26 = _JC_IUSHR(i26, 8);
	i26 = i25 ^ i26;
	i26 = i26 ^ -1;
	_JC_PRIM_FIELD(env, r1, java_util_zip_CRC32, crc) = i26;

label20:
	r2 = _JC_REF_FIELD(env, r0, java_io_FilterInputStream, in);
	i3 = _JC_INVOKE_VIRTUAL(env, java_io_InputStream, read$1a981297cb524963, r2);
	if (i3 > 0) {
		_JC_PERIODIC_CHECK(env);
		goto label19;
	}
	_JC_LINE_NUMBER(283);				// 41
	if (i3 >= 0)
		goto label21;
	_JC_LINE_NUMBER(284);				// 42
	r4 = _JC_NEW(env, java_io_EOFException);
	r14 = _JC_STRING(env, "Early EOF in GZIP file name");
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r28 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r28;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r14;
	_JC_THROW(env, r4);

label21:
	i28 = _JC_PRIM_FIELD(env, r1, java_util_zip_CRC32, crc);
	i28 = i28 ^ -1;
	r44 = _JC_STATIC_FIELD(env, java_util_zip_CRC32, crc__5ftable, 1);
	i27 = i28 ^ i3;
	i27 = i27 & 255;
	i27 = _JC_PRIM_ELEMENT(env, int, r44, i27, 1, 1);
	i28 = _JC_IUSHR(i28, 8);
	i28 = i27 ^ i28;
	i28 = i28 ^ -1;
	_JC_PRIM_FIELD(env, r1, java_util_zip_CRC32, crc) = i28;

label22:
	_JC_LINE_NUMBER(289);				// 43
	i3 = i1 & 16;
	if (i3 == 0)
		goto label26;
	_JC_LINE_NUMBER(292);				// 44
	goto label24;

label23:
	_JC_LINE_NUMBER(293);				// 45
	_JC_INVOKE_NONVIRTUAL(env, java_util_zip_CRC32, update$469c8c2dea465a16, 0, r1, i3);

label24:
	_JC_LINE_NUMBER(292);				// 46
	r2 = _JC_REF_FIELD(env, r0, java_io_FilterInputStream, in);
	i3 = _JC_INVOKE_VIRTUAL(env, java_io_InputStream, read$1a981297cb524963, r2);
	if (i3 > 0) {
		_JC_PERIODIC_CHECK(env);
		goto label23;
	}
	_JC_LINE_NUMBER(295);				// 47
	if (i3 >= 0)
		goto label25;
	_JC_LINE_NUMBER(296);				// 48
	r4 = _JC_NEW(env, java_io_EOFException);
	r15 = _JC_STRING(env, "Early EOF in GZIP comment");
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r29 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r29;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r15;
	_JC_THROW(env, r4);

label25:
	_JC_LINE_NUMBER(297);				// 49
	_JC_INVOKE_NONVIRTUAL(env, java_util_zip_CRC32, update$469c8c2dea465a16, 0, r1, i3);

label26:
	_JC_LINE_NUMBER(301);				// 50
	i3 = i1 & 2;
	if (i3 == 0)
		goto label29;
	_JC_LINE_NUMBER(304);				// 51
	r2 = _JC_REF_FIELD(env, r0, java_io_FilterInputStream, in);
	i3 = _JC_INVOKE_VIRTUAL(env, java_io_InputStream, read$1a981297cb524963, r2);
	_JC_LINE_NUMBER(305);				// 52
	if (i3 >= 0)
		goto label27;
	_JC_LINE_NUMBER(306);				// 53
	r4 = _JC_NEW(env, java_io_EOFException);
	r16 = _JC_STRING(env, "Early EOF in GZIP header");
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r30 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r30;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r16;
	_JC_THROW(env, r4);

label27:
	_JC_LINE_NUMBER(308);				// 54
	r2 = _JC_REF_FIELD(env, r0, java_io_FilterInputStream, in);
	i2 = _JC_INVOKE_VIRTUAL(env, java_io_InputStream, read$1a981297cb524963, r2);
	_JC_LINE_NUMBER(309);				// 55
	if (i2 >= 0)
		goto label28;
	_JC_LINE_NUMBER(310);				// 56
	r4 = _JC_NEW(env, java_io_EOFException);
	r17 = _JC_STRING(env, "Early EOF in GZIP header");
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r31 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r31;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r17;
	_JC_THROW(env, r4);

label28:
	_JC_LINE_NUMBER(312);				// 57
	i3 = i3 << (8 & 0x1f);
	i3 = i3 | i2;
	i5 = _JC_PRIM_FIELD(env, r1, java_util_zip_CRC32, crc);
	l6 = (jlong)i5;
	l6 = l6 & (_JC_JLONG(4294967295));
	_JC_LINE_NUMBER(313);				// 58
	i2 = (jint)l6;
	c4 = (jchar)-1;
	i2 = i2 & c4;
	if (i3 == i2)
		goto label29;
	_JC_LINE_NUMBER(314);				// 59
	r3 = _JC_NEW(env, java_io_IOException);
	r18 = _JC_STRING(env, "Header CRC value mismatch");
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r32 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r32;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r18;
	_JC_THROW(env, r3);

label29:
	_JC_LINE_NUMBER(317);				// 60
	_JC_PRIM_FIELD(env, r0, java_util_zip_GZIPInputStream, readGZIPHeader) = 1;
	_JC_LINE_NUMBER(319);				// 61
	return;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_java_util_zip_GZIPInputStream$methods[] = {
	&_jc_java_util_zip_GZIPInputStream$method_info$_init$3887600c17c5e554,
	&_jc_java_util_zip_GZIPInputStream$method_info$_init$cce795e7dffd722d,
	&_jc_java_util_zip_GZIPInputStream$method_info$close$6aba8b329fddcd79,
	&_jc_java_util_zip_GZIPInputStream$method_info$read$e6b6c87b9f256783,
	&_jc_java_util_zip_GZIPInputStream$method_info$readFooter$94f938333ce0ddb6,
	&_jc_java_util_zip_GZIPInputStream$method_info$readHeader$315d703f8609c43e
};

/************************************************************************
 *			  Class fields structure			*
 ************************************************************************/

_jc_java_util_zip_GZIPInputStream$fields_struct _jc_java_util_zip_GZIPInputStream$class_fields = { };

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_java_util_zip_GZIPInputStream$instanceof_hash_bucket_32[] = {
	&_jc_java_util_zip_InflaterInputStream$type,
	_JC_NULL
};
static _jc_type *const _jc_java_util_zip_GZIPInputStream$instanceof_hash_bucket_68[] = {
	&_jc_java_io_InputStream$type,
	_JC_NULL
};
static _jc_type *const _jc_java_util_zip_GZIPInputStream$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};
static _jc_type *const _jc_java_util_zip_GZIPInputStream$instanceof_hash_bucket_103[] = {
	&_jc_java_util_zip_GZIPInputStream$type,
	_JC_NULL
};
static _jc_type *const _jc_java_util_zip_GZIPInputStream$instanceof_hash_bucket_126[] = {
	&_jc_java_io_FilterInputStream$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_java_util_zip_GZIPInputStream$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[32]=	_jc_java_util_zip_GZIPInputStream$instanceof_hash_bucket_32,
	[68]=	_jc_java_util_zip_GZIPInputStream$instanceof_hash_bucket_68,
	[101]=	_jc_java_util_zip_GZIPInputStream$instanceof_hash_bucket_101,
	[103]=	_jc_java_util_zip_GZIPInputStream$instanceof_hash_bucket_103,
	[126]=	_jc_java_util_zip_GZIPInputStream$instanceof_hash_bucket_126
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_java_util_zip_GZIPInputStream$class_depends[] = {
	{ "java/io/EOFException",	_JC_JLONG(0xcaf39081f5f70fef) },
	{ "java/io/FilterInputStream",	_JC_JLONG(0x455accfa535f5dfe) },
	{ "java/io/IOException",	_JC_JLONG(0x4e0a56550c69d57c) },
	{ "java/io/InputStream",	_JC_JLONG(0x66aea4d152614ac4) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/Integer",	_JC_JLONG(0xca631501391a31f1) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/StringBuffer",	_JC_JLONG(0x94d357637b968dda) },
	{ "java/lang/System",	_JC_JLONG(0x53cc8e2333795f04) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMSystem",	_JC_JLONG(0x4d1cebae0bdda058) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/util/zip/CRC32",	_JC_JLONG(0xd31dc884497a5da2) },
	{ "java/util/zip/Inflater",	_JC_JLONG(0x4df3e1cb79f6b935) },
	{ "java/util/zip/InflaterInputStream",	_JC_JLONG(0x5602700a47802920) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_java_util_zip_GZIPInputStream$vtype _jc_java_util_zip_GZIPInputStream$type = {
    .type= {
	.name=			"java/util/zip/GZIPInputStream",
	.superclass=		&_jc_java_util_zip_InflaterInputStream$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		43,
		.hash=			_JC_JLONG(0xc51bfb23c49b4e67),
		.source_file=		"GZIPInputStream.java",
		.instance_size=		sizeof(_jc_java_util_zip_GZIPInputStream$refs) + sizeof(_jc_java_util_zip_GZIPInputStream$object),
		.num_virtual_refs=	5,
		.num_fields=		sizeof(_jc_java_util_zip_GZIPInputStream$fields) / sizeof(*_jc_java_util_zip_GZIPInputStream$fields),
		.fields=		_jc_java_util_zip_GZIPInputStream$fields,
		.num_methods=		sizeof(_jc_java_util_zip_GZIPInputStream$methods) / sizeof(*_jc_java_util_zip_GZIPInputStream$methods),
		.methods=		_jc_java_util_zip_GZIPInputStream$methods,
		.instanceof_hash_table=	_jc_java_util_zip_GZIPInputStream$instanceof_hash_table,
		.class_fields=		&_jc_java_util_zip_GZIPInputStream$class_fields,
		.num_class_depends=		sizeof(_jc_java_util_zip_GZIPInputStream$class_depends) / sizeof(*_jc_java_util_zip_GZIPInputStream$class_depends),
		.class_depends=		_jc_java_util_zip_GZIPInputStream$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.java_io_InputStream= {
	    .available$81975cc608605037=			// overridden
		&_jc_java_util_zip_InflaterInputStream$method$available$81975cc608605037,
	    .close$6aba8b329fddcd79=			// overridden
		&_jc_java_util_zip_GZIPInputStream$method$close$6aba8b329fddcd79,
	    .mark$422af117ab27d9db=				// overridden
		&_jc_java_util_zip_InflaterInputStream$method$mark$422af117ab27d9db,
	    .markSupported$66435a81b7b2f2dc=		// overridden
		&_jc_java_util_zip_InflaterInputStream$method$markSupported$66435a81b7b2f2dc,
	    .read$1a981297cb524963=				// overridden
		&_jc_java_util_zip_InflaterInputStream$method$read$1a981297cb524963,
	    .read$c38dd905b7fb8654=				// overridden
		&_jc_java_io_FilterInputStream$method$read$c38dd905b7fb8654,
	    .read$e6b6c87b9f256783=				// overridden
		&_jc_java_util_zip_GZIPInputStream$method$read$e6b6c87b9f256783,
	    .reset$229a80b3e8394a0f=			// overridden
		&_jc_java_util_zip_InflaterInputStream$method$reset$229a80b3e8394a0f,
	    .skip$4e431136b5c4614a=				// overridden
		&_jc_java_util_zip_InflaterInputStream$method$skip$4e431136b5c4614a,
	},
	.java_io_FilterInputStream= {
	    .available$81975cc608605037=			// overridden
		&_jc_java_util_zip_InflaterInputStream$method$available$81975cc608605037,
	    .close$6aba8b329fddcd79=			// overridden
		&_jc_java_util_zip_GZIPInputStream$method$close$6aba8b329fddcd79,
	    .mark$422af117ab27d9db=				// overridden
		&_jc_java_util_zip_InflaterInputStream$method$mark$422af117ab27d9db,
	    .markSupported$66435a81b7b2f2dc=		// overridden
		&_jc_java_util_zip_InflaterInputStream$method$markSupported$66435a81b7b2f2dc,
	    .read$1a981297cb524963=				// overridden
		&_jc_java_util_zip_InflaterInputStream$method$read$1a981297cb524963,
	    .read$c38dd905b7fb8654=
		&_jc_java_io_FilterInputStream$method$read$c38dd905b7fb8654,
	    .read$e6b6c87b9f256783=				// overridden
		&_jc_java_util_zip_GZIPInputStream$method$read$e6b6c87b9f256783,
	    .reset$229a80b3e8394a0f=			// overridden
		&_jc_java_util_zip_InflaterInputStream$method$reset$229a80b3e8394a0f,
	    .skip$4e431136b5c4614a=				// overridden
		&_jc_java_util_zip_InflaterInputStream$method$skip$4e431136b5c4614a,
	},
	.java_util_zip_InflaterInputStream= {
	    .available$81975cc608605037=
		&_jc_java_util_zip_InflaterInputStream$method$available$81975cc608605037,
	    .close$6aba8b329fddcd79=			// overridden
		&_jc_java_util_zip_GZIPInputStream$method$close$6aba8b329fddcd79,
	    .fill$144e1686cbd31ab8=
		&_jc_java_util_zip_InflaterInputStream$method$fill$144e1686cbd31ab8,
	    .mark$422af117ab27d9db=
		&_jc_java_util_zip_InflaterInputStream$method$mark$422af117ab27d9db,
	    .markSupported$66435a81b7b2f2dc=
		&_jc_java_util_zip_InflaterInputStream$method$markSupported$66435a81b7b2f2dc,
	    .read$1a981297cb524963=
		&_jc_java_util_zip_InflaterInputStream$method$read$1a981297cb524963,
	    .read$e6b6c87b9f256783=				// overridden
		&_jc_java_util_zip_GZIPInputStream$method$read$e6b6c87b9f256783,
	    .reset$229a80b3e8394a0f=
		&_jc_java_util_zip_InflaterInputStream$method$reset$229a80b3e8394a0f,
	    .skip$4e431136b5c4614a=
		&_jc_java_util_zip_InflaterInputStream$method$skip$4e431136b5c4614a,
	    .this$adc93fb6bf4cbffa=
		&_jc_java_util_zip_InflaterInputStream$method$this$adc93fb6bf4cbffa,
	},
	.java_util_zip_GZIPInputStream= {
	    .close$6aba8b329fddcd79=
		&_jc_java_util_zip_GZIPInputStream$method$close$6aba8b329fddcd79,
	    .read$e6b6c87b9f256783=
		&_jc_java_util_zip_GZIPInputStream$method$read$e6b6c87b9f256783,
	    .readFooter$94f938333ce0ddb6=
		&_jc_java_util_zip_GZIPInputStream$method$readFooter$94f938333ce0ddb6,
	    .readHeader$315d703f8609c43e=
		&_jc_java_util_zip_GZIPInputStream$method$readHeader$315d703f8609c43e,
	},
    }
};

