// public class javax.crypto.CipherInputStream

// class file dependencies
// @dep_class 455accfa535f5dfe java_io_FilterInputStream
// @dep_class 4e0a56550c69d57c java_io_IOException
// @dep_class 66aea4d152614ac4 java_io_InputStream
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class 8d71d806a180ad8a java_lang_Math
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 53cc8e2333795f04 java_lang_System
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class 4d1cebae0bdda058 java_lang_VMSystem
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class d214adbc7b3842af javax_crypto_BadPaddingException
// @dep_class 4bdfff9ea145d6ce javax_crypto_Cipher
// @dep_class c2486c2f0ee06688 javax_crypto_CipherInputStream
// @dep_class 4422f11229f63761 javax_crypto_CipherSpi
// @dep_class e7376936288e78db javax_crypto_IllegalBlockSizeException
// @dep_class d79a62a9328ccea1 javax_crypto_ShortBufferException

// header file dependencies
// @dep_header java_io_IOException
// @dep_header java_lang_Class
// @dep_header java_lang_Math
// @dep_header java_lang_String
// @dep_header java_lang_System
// @dep_header java_lang_VMSystem
// @dep_header java_lang_VMThrowable
// @dep_header javax_crypto_BadPaddingException
// @dep_header javax_crypto_Cipher
// @dep_header javax_crypto_CipherInputStream
// @dep_header javax_crypto_CipherSpi
// @dep_header javax_crypto_IllegalBlockSizeException
// @dep_header javax_crypto_ShortBufferException

#include "jc_defs.h"

#include "java/io/IOException.h"
#include "java/lang/Class.h"
#include "java/lang/Math.h"
#include "java/lang/String.h"
#include "java/lang/System.h"
#include "java/lang/VMSystem.h"
#include "java/lang/VMThrowable.h"
#include "javax/crypto/BadPaddingException.h"
#include "javax/crypto/Cipher.h"
#include "javax/crypto/CipherInputStream.h"
#include "javax/crypto/CipherSpi.h"
#include "javax/crypto/IllegalBlockSizeException.h"
#include "javax/crypto/ShortBufferException.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// private static final int VIRGIN
static const jint _jc_javax_crypto_CipherInputStream$initial_value$VIRGIN = 0;
static _jc_field _jc_javax_crypto_CipherInputStream$field_info$VIRGIN = {
	.name=		"VIRGIN",
	.signature=	"I",
	.class=		&_jc_javax_crypto_CipherInputStream$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_CipherInputStream$fields_struct, VIRGIN),
	.initial_value=	&_jc_javax_crypto_CipherInputStream$initial_value$VIRGIN,
};

// private static final int LIVING
static const jint _jc_javax_crypto_CipherInputStream$initial_value$LIVING = 1;
static _jc_field _jc_javax_crypto_CipherInputStream$field_info$LIVING = {
	.name=		"LIVING",
	.signature=	"I",
	.class=		&_jc_javax_crypto_CipherInputStream$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_CipherInputStream$fields_struct, LIVING),
	.initial_value=	&_jc_javax_crypto_CipherInputStream$initial_value$LIVING,
};

// private static final int DYING
static const jint _jc_javax_crypto_CipherInputStream$initial_value$DYING = 2;
static _jc_field _jc_javax_crypto_CipherInputStream$field_info$DYING = {
	.name=		"DYING",
	.signature=	"I",
	.class=		&_jc_javax_crypto_CipherInputStream$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_CipherInputStream$fields_struct, DYING),
	.initial_value=	&_jc_javax_crypto_CipherInputStream$initial_value$DYING,
};

// private static final int DEAD
static const jint _jc_javax_crypto_CipherInputStream$initial_value$DEAD = 3;
static _jc_field _jc_javax_crypto_CipherInputStream$field_info$DEAD = {
	.name=		"DEAD",
	.signature=	"I",
	.class=		&_jc_javax_crypto_CipherInputStream$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_CipherInputStream$fields_struct, DEAD),
	.initial_value=	&_jc_javax_crypto_CipherInputStream$initial_value$DEAD,
};

// private javax.crypto.Cipher cipher
static _jc_field _jc_javax_crypto_CipherInputStream$field_info$cipher = {
	.name=		"cipher",
	.signature=	"Ljavax/crypto/Cipher;",
	.class=		&_jc_javax_crypto_CipherInputStream$type,
	.type=		&_jc_javax_crypto_Cipher$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_CipherInputStream$object, refs[-1].javax_crypto_CipherInputStream.cipher),
};

// private byte[] outBuffer
static _jc_field _jc_javax_crypto_CipherInputStream$field_info$outBuffer = {
	.name=		"outBuffer",
	.signature=	"[B",
	.class=		&_jc_javax_crypto_CipherInputStream$type,
	.type=		&_jc_byte$array$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_CipherInputStream$object, refs[-1].javax_crypto_CipherInputStream.outBuffer),
};

// private int outOffset
static _jc_field _jc_javax_crypto_CipherInputStream$field_info$outOffset = {
	.name=		"outOffset",
	.signature=	"I",
	.class=		&_jc_javax_crypto_CipherInputStream$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_CipherInputStream$object, nonrefs.javax_crypto_CipherInputStream.outOffset),
};

// private int outLength
static _jc_field _jc_javax_crypto_CipherInputStream$field_info$outLength = {
	.name=		"outLength",
	.signature=	"I",
	.class=		&_jc_javax_crypto_CipherInputStream$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_CipherInputStream$object, nonrefs.javax_crypto_CipherInputStream.outLength),
};

// private byte[][] inBuffer
static _jc_field _jc_javax_crypto_CipherInputStream$field_info$inBuffer = {
	.name=		"inBuffer",
	.signature=	"[[B",
	.class=		&_jc_javax_crypto_CipherInputStream$type,
	.type=		&_jc_byte$array2$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_CipherInputStream$object, refs[-1].javax_crypto_CipherInputStream.inBuffer),
};

// private int inLength
static _jc_field _jc_javax_crypto_CipherInputStream$field_info$inLength = {
	.name=		"inLength",
	.signature=	"I",
	.class=		&_jc_javax_crypto_CipherInputStream$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_CipherInputStream$object, nonrefs.javax_crypto_CipherInputStream.inLength),
};

// private boolean isStream
static _jc_field _jc_javax_crypto_CipherInputStream$field_info$isStream = {
	.name=		"isStream",
	.signature=	"Z",
	.class=		&_jc_javax_crypto_CipherInputStream$type,
	.type=		&_jc_boolean$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_CipherInputStream$object, nonrefs.javax_crypto_CipherInputStream.isStream),
};

// private int state
static _jc_field _jc_javax_crypto_CipherInputStream$field_info$state = {
	.name=		"state",
	.signature=	"I",
	.class=		&_jc_javax_crypto_CipherInputStream$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_CipherInputStream$object, nonrefs.javax_crypto_CipherInputStream.state),
};

// Fields
static _jc_field *const _jc_javax_crypto_CipherInputStream$fields[] = {
	&_jc_javax_crypto_CipherInputStream$field_info$DEAD,
	&_jc_javax_crypto_CipherInputStream$field_info$DYING,
	&_jc_javax_crypto_CipherInputStream$field_info$LIVING,
	&_jc_javax_crypto_CipherInputStream$field_info$VIRGIN,
	&_jc_javax_crypto_CipherInputStream$field_info$cipher,
	&_jc_javax_crypto_CipherInputStream$field_info$inBuffer,
	&_jc_javax_crypto_CipherInputStream$field_info$outBuffer,
	&_jc_javax_crypto_CipherInputStream$field_info$inLength,
	&_jc_javax_crypto_CipherInputStream$field_info$outLength,
	&_jc_javax_crypto_CipherInputStream$field_info$outOffset,
	&_jc_javax_crypto_CipherInputStream$field_info$state,
	&_jc_javax_crypto_CipherInputStream$field_info$isStream
};

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// protected void <init>(java.io.InputStream)
//

static _jc_linenum _jc_javax_crypto_CipherInputStream$linenum_table$_init$3887600c17c5e554[];

static const unsigned char _jc_javax_crypto_CipherInputStream$param_ptypes$_init$3887600c17c5e554[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_CipherInputStream$param_types$_init$3887600c17c5e554[] = {
	&_jc_java_io_InputStream$type
};

_jc_method _jc_javax_crypto_CipherInputStream$method_info$_init$3887600c17c5e554 = {
	.name=			"<init>",
	.signature=		"(Ljava/io/InputStream;)V",
	.class=			&_jc_javax_crypto_CipherInputStream$type,
	.param_types=		&_jc_javax_crypto_CipherInputStream$param_types$_init$3887600c17c5e554,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_CipherInputStream$param_ptypes$_init$3887600c17c5e554,
	.signature_hash=	_JC_JLONG(0x3887600c17c5e554),
	.access_flags=		_JC_ACC_PROTECTED,
	.function=		&_jc_javax_crypto_CipherInputStream$method$_init$3887600c17c5e554,
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_crypto_CipherInputStream$linenum_table$_init$3887600c17c5e554
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_CipherInputStream, _init$3887600c17c5e554);

void _JC_JCNI_ATTR
_jc_javax_crypto_CipherInputStream$method$_init$3887600c17c5e554(_jc_env *const env, _jc_javax_crypto_CipherInputStream$object *this, _jc_java_io_InputStream$object *param0)
{
	struct _jc_javax_crypto_CipherInputStream$object *r0;
	struct _jc_java_io_InputStream$object *r1;

	r0 = this;
	r1 = param0;
	_JC_REF_FIELD(env, r0, java_io_FilterInputStream, in) = r1;
	_JC_LINE_NUMBER(137);				// 0
	return;
}

//
// public void <init>(java.io.InputStream, javax.crypto.Cipher)
//

static _jc_linenum _jc_javax_crypto_CipherInputStream$linenum_table$_init$bdb07dfd19624f01[];

static const unsigned char _jc_javax_crypto_CipherInputStream$param_ptypes$_init$bdb07dfd19624f01[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_CipherInputStream$param_types$_init$bdb07dfd19624f01[] = {
	&_jc_java_io_InputStream$type,
	&_jc_javax_crypto_Cipher$type
};

_jc_method _jc_javax_crypto_CipherInputStream$method_info$_init$bdb07dfd19624f01 = {
	.name=			"<init>",
	.signature=		"(Ljava/io/InputStream;Ljavax/crypto/Cipher;)V",
	.class=			&_jc_javax_crypto_CipherInputStream$type,
	.param_types=		&_jc_javax_crypto_CipherInputStream$param_types$_init$bdb07dfd19624f01,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_CipherInputStream$param_ptypes$_init$bdb07dfd19624f01,
	.signature_hash=	_JC_JLONG(0xbdb07dfd19624f01),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_javax_crypto_CipherInputStream$method$_init$bdb07dfd19624f01,
	.num_parameters=	2,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	10,
	      .table=	_jc_javax_crypto_CipherInputStream$linenum_table$_init$bdb07dfd19624f01
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_CipherInputStream, _init$bdb07dfd19624f01);

void _JC_JCNI_ATTR
_jc_javax_crypto_CipherInputStream$method$_init$bdb07dfd19624f01(_jc_env *const env, _jc_javax_crypto_CipherInputStream$object *this, _jc_java_io_InputStream$object *param0, _jc_javax_crypto_Cipher$object *param1)
{
	jint i0;
	jint i1;
	jint i2;
	jint i3;
	jint i4;
	struct _jc_javax_crypto_CipherInputStream$object *r0;
	struct _jc_java_io_InputStream$object *r1;
	struct _jc_javax_crypto_Cipher$object *r2;
	_jc_object_array *r3;
	_jc_byte_array *r4;
	struct _jc_javax_crypto_CipherSpi$object *r5;
	struct _jc_javax_crypto_CipherSpi$object *r6;
	struct _jc_javax_crypto_CipherSpi$object *r7;
	struct _jc_javax_crypto_CipherSpi$object *r9;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_REF_FIELD(env, r0, java_io_FilterInputStream, in) = r1;
	_JC_LINE_NUMBER(114);				// 0
	_JC_REF_FIELD(env, r0, javax_crypto_CipherInputStream, cipher) = r2;
	_JC_LINE_NUMBER(115);				// 1
	z0 = 0;
	_JC_EXPLICIT_NULL_CHECK(env, r2);
	r5 = _JC_REF_FIELD(env, r2, javax_crypto_Cipher, cipherSpi);
	if (r5 == _JC_NULL)
		goto label0;
	r5 = _JC_REF_FIELD(env, r2, javax_crypto_Cipher, cipherSpi);
	i1 = _JC_INVOKE_VIRTUAL(env, javax_crypto_CipherSpi, engineGetBlockSize$d4858c33205171e0, r5);
	i0 = i1;
	goto label1;

label0:
	i0 = 1;

label1:
	if (i0 != 1)
		goto label2;
	z0 = 1;

label2:
	_JC_PRIM_FIELD(env, r0, javax_crypto_CipherInputStream, isStream) = z0;
	if (z0 != 0)
		goto label9;
	_JC_LINE_NUMBER(117);				// 2
	r3 = _JC_NEW_PRIM_ARRAY(env, byte, 2, 2);
	_JC_REF_FIELD(env, r0, javax_crypto_CipherInputStream, inBuffer) = r3;
	_JC_LINE_NUMBER(118);				// 3
	r3 = _JC_REF_FIELD(env, r0, javax_crypto_CipherInputStream, inBuffer);
	r6 = _JC_REF_FIELD(env, r2, javax_crypto_Cipher, cipherSpi);
	if (r6 == _JC_NULL)
		goto label3;
	r6 = _JC_REF_FIELD(env, r2, javax_crypto_Cipher, cipherSpi);
	i2 = _JC_INVOKE_VIRTUAL(env, javax_crypto_CipherSpi, engineGetBlockSize$d4858c33205171e0, r6);
	i0 = i2;
	goto label4;

label3:
	i0 = 1;

label4:
	r4 = _JC_NEW_PRIM_ARRAY(env, byte, 1, i0);
	_JC_REF_ELEMENT(env, r3, 0, 0, 0) = r4;
	_JC_LINE_NUMBER(119);				// 4
	r3 = _JC_REF_FIELD(env, r0, javax_crypto_CipherInputStream, inBuffer);
	r7 = _JC_REF_FIELD(env, r2, javax_crypto_Cipher, cipherSpi);
	if (r7 == _JC_NULL)
		goto label5;
	r7 = _JC_REF_FIELD(env, r2, javax_crypto_Cipher, cipherSpi);
	i3 = _JC_INVOKE_VIRTUAL(env, javax_crypto_CipherSpi, engineGetBlockSize$d4858c33205171e0, r7);
	i0 = i3;
	goto label6;

label5:
	i0 = 1;

label6:
	r4 = _JC_NEW_PRIM_ARRAY(env, byte, 1, i0);
	_JC_REF_ELEMENT(env, r3, 1, 0, 0) = r4;
	_JC_LINE_NUMBER(120);				// 5
	_JC_PRIM_FIELD(env, r0, javax_crypto_CipherInputStream, inLength) = 0;
	r9 = _JC_REF_FIELD(env, r2, javax_crypto_Cipher, cipherSpi);
	if (r9 == _JC_NULL)
		goto label7;
	r9 = _JC_REF_FIELD(env, r2, javax_crypto_Cipher, cipherSpi);
	i4 = _JC_INVOKE_VIRTUAL(env, javax_crypto_CipherSpi, engineGetBlockSize$d4858c33205171e0, r9);
	i0 = i4;
	goto label8;

label7:
	i0 = 1;

label8:
	_JC_LINE_NUMBER(121);				// 6
	r4 = _JC_NEW_PRIM_ARRAY(env, byte, 1, i0);
	_JC_REF_FIELD(env, r0, javax_crypto_CipherInputStream, outBuffer) = r4;
	_JC_LINE_NUMBER(122);				// 7
	_JC_PRIM_FIELD(env, r0, javax_crypto_CipherInputStream, outLength) = 0;
	_JC_PRIM_FIELD(env, r0, javax_crypto_CipherInputStream, outOffset) = 0;
	_JC_LINE_NUMBER(123);				// 8
	_JC_PRIM_FIELD(env, r0, javax_crypto_CipherInputStream, state) = 0;

label9:
	_JC_LINE_NUMBER(125);				// 9
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public int available() throws java.io.IOException
//

static _jc_linenum _jc_javax_crypto_CipherInputStream$linenum_table$available$81975cc608605037[];

static const unsigned char _jc_javax_crypto_CipherInputStream$param_ptypes$available$81975cc608605037[] = { 
_JC_TYPE_INT };

static _jc_type *const _jc_javax_crypto_CipherInputStream$exceptions$available$81975cc608605037[] = {
	&_jc_java_io_IOException$type
};

_jc_method _jc_javax_crypto_CipherInputStream$method_info$available$81975cc608605037 = {
	.name=			"available",
	.signature=		"()I",
	.class=			&_jc_javax_crypto_CipherInputStream$type,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_javax_crypto_CipherInputStream$param_ptypes$available$81975cc608605037,
	.signature_hash=	_JC_JLONG(0x81975cc608605037),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_javax_crypto_CipherInputStream$method$available$81975cc608605037,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_CipherInputStream$vtable, javax_crypto_CipherInputStream.available$81975cc608605037) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_crypto_CipherInputStream$exceptions$available$81975cc608605037,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_javax_crypto_CipherInputStream$linenum_table$available$81975cc608605037
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_CipherInputStream, available$81975cc608605037);

jint _JC_JCNI_ATTR
_jc_javax_crypto_CipherInputStream$method$available$81975cc608605037(_jc_env *const env, _jc_javax_crypto_CipherInputStream$object *this)
{
	jint i0;
	jint i1;
	jint i2;
	struct _jc_javax_crypto_CipherInputStream$object *r0;
	struct _jc_java_io_InputStream$object *r2;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(152);				// 0
	z0 = _JC_PRIM_FIELD(env, r0, javax_crypto_CipherInputStream, isStream);
	if (z0 == 0)
		goto label0;
	r2 = _JC_REF_FIELD(env, r0, java_io_FilterInputStream, in);
	i2 = _JC_INVOKE_VIRTUAL(env, java_io_InputStream, available$81975cc608605037, r2);
	_JC_LINE_NUMBER(153);				// 1
	return i2;

label0:
	_JC_LINE_NUMBER(154);				// 2
	i0 = _JC_PRIM_FIELD(env, r0, javax_crypto_CipherInputStream, outLength);
	i1 = _JC_PRIM_FIELD(env, r0, javax_crypto_CipherInputStream, outOffset);
	i1 = i0 - i1;
	return i1;
}

//
// public void close() throws java.io.IOException
//

static _jc_linenum _jc_javax_crypto_CipherInputStream$linenum_table$close$6aba8b329fddcd79[];

static const unsigned char _jc_javax_crypto_CipherInputStream$param_ptypes$close$6aba8b329fddcd79[] = { 
_JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_CipherInputStream$exceptions$close$6aba8b329fddcd79[] = {
	&_jc_java_io_IOException$type
};

_jc_method _jc_javax_crypto_CipherInputStream$method_info$close$6aba8b329fddcd79 = {
	.name=			"close",
	.signature=		"()V",
	.class=			&_jc_javax_crypto_CipherInputStream$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_CipherInputStream$param_ptypes$close$6aba8b329fddcd79,
	.signature_hash=	_JC_JLONG(0x6aba8b329fddcd79),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_javax_crypto_CipherInputStream$method$close$6aba8b329fddcd79,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_CipherInputStream$vtable, javax_crypto_CipherInputStream.close$6aba8b329fddcd79) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_crypto_CipherInputStream$exceptions$close$6aba8b329fddcd79,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_crypto_CipherInputStream$linenum_table$close$6aba8b329fddcd79
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_CipherInputStream, close$6aba8b329fddcd79);

void _JC_JCNI_ATTR
_jc_javax_crypto_CipherInputStream$method$close$6aba8b329fddcd79(_jc_env *const env, _jc_javax_crypto_CipherInputStream$object *this)
{
	struct _jc_javax_crypto_CipherInputStream$object *r0;
	struct _jc_java_io_InputStream$object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r2 = _JC_REF_FIELD(env, r0, java_io_FilterInputStream, in);
	_JC_INVOKE_VIRTUAL(env, java_io_InputStream, close$6aba8b329fddcd79, r2);
	_JC_LINE_NUMBER(166);				// 0
	return;
}

//
// public void mark(int)
//

static _jc_linenum _jc_javax_crypto_CipherInputStream$linenum_table$mark$422af117ab27d9db[];

static const unsigned char _jc_javax_crypto_CipherInputStream$param_ptypes$mark$422af117ab27d9db[] = { 
_JC_TYPE_INT, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_CipherInputStream$param_types$mark$422af117ab27d9db[] = {
	&_jc_int$prim$type
};

_jc_method _jc_javax_crypto_CipherInputStream$method_info$mark$422af117ab27d9db = {
	.name=			"mark",
	.signature=		"(I)V",
	.class=			&_jc_javax_crypto_CipherInputStream$type,
	.param_types=		&_jc_javax_crypto_CipherInputStream$param_types$mark$422af117ab27d9db,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_CipherInputStream$param_ptypes$mark$422af117ab27d9db,
	.signature_hash=	_JC_JLONG(0x422af117ab27d9db),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_javax_crypto_CipherInputStream$method$mark$422af117ab27d9db,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_CipherInputStream$vtable, javax_crypto_CipherInputStream.mark$422af117ab27d9db) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_crypto_CipherInputStream$linenum_table$mark$422af117ab27d9db
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_CipherInputStream, mark$422af117ab27d9db);

void _JC_JCNI_ATTR
_jc_javax_crypto_CipherInputStream$method$mark$422af117ab27d9db(_jc_env *const env, _jc_javax_crypto_CipherInputStream$object *this, jint param0)
{
	jint i0;
	struct _jc_javax_crypto_CipherInputStream$object *r0;

	r0 = this;
	i0 = param0;
	_JC_LINE_NUMBER(299);				// 0
	return;
}

//
// public boolean markSupported()
//

static _jc_linenum _jc_javax_crypto_CipherInputStream$linenum_table$markSupported$66435a81b7b2f2dc[];

static const unsigned char _jc_javax_crypto_CipherInputStream$param_ptypes$markSupported$66435a81b7b2f2dc[] = { 
_JC_TYPE_BOOLEAN };

_jc_method _jc_javax_crypto_CipherInputStream$method_info$markSupported$66435a81b7b2f2dc = {
	.name=			"markSupported",
	.signature=		"()Z",
	.class=			&_jc_javax_crypto_CipherInputStream$type,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_javax_crypto_CipherInputStream$param_ptypes$markSupported$66435a81b7b2f2dc,
	.signature_hash=	_JC_JLONG(0x66435a81b7b2f2dc),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_javax_crypto_CipherInputStream$method$markSupported$66435a81b7b2f2dc,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_CipherInputStream$vtable, javax_crypto_CipherInputStream.markSupported$66435a81b7b2f2dc) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_crypto_CipherInputStream$linenum_table$markSupported$66435a81b7b2f2dc
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_CipherInputStream, markSupported$66435a81b7b2f2dc);

jboolean _JC_JCNI_ATTR
_jc_javax_crypto_CipherInputStream$method$markSupported$66435a81b7b2f2dc(_jc_env *const env, _jc_javax_crypto_CipherInputStream$object *this)
{
	struct _jc_javax_crypto_CipherInputStream$object *r0;

	r0 = this;
	_JC_LINE_NUMBER(289);				// 0
	return 0;
}

//
// private final void nextBlock() throws java.io.IOException
//

static _jc_linenum _jc_javax_crypto_CipherInputStream$linenum_table$nextBlock$3237dc9ebe86727f[];

static _jc_trap_info _jc_javax_crypto_CipherInputStream$trap_table$nextBlock$3237dc9ebe86727f[] = {
	_JC_TRAP(&_jc_javax_crypto_ShortBufferException$type, 1, 2),
	_JC_TRAP(&_jc_javax_crypto_BadPaddingException$type, 1, 2),
	_JC_TRAP(&_jc_javax_crypto_IllegalBlockSizeException$type, 1, 2),
};

static const unsigned char _jc_javax_crypto_CipherInputStream$param_ptypes$nextBlock$3237dc9ebe86727f[] = { 
_JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_CipherInputStream$exceptions$nextBlock$3237dc9ebe86727f[] = {
	&_jc_java_io_IOException$type
};

_jc_method _jc_javax_crypto_CipherInputStream$method_info$nextBlock$3237dc9ebe86727f = {
	.name=			"nextBlock",
	.signature=		"()V",
	.class=			&_jc_javax_crypto_CipherInputStream$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_CipherInputStream$param_ptypes$nextBlock$3237dc9ebe86727f,
	.signature_hash=	_JC_JLONG(0x3237dc9ebe86727f),
	.access_flags=		_JC_ACC_PRIVATE|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_CipherInputStream$method$nextBlock$3237dc9ebe86727f,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_CipherInputStream$vtable, javax_crypto_CipherInputStream.nextBlock$3237dc9ebe86727f) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_crypto_CipherInputStream$exceptions$nextBlock$3237dc9ebe86727f,
	.u= { .exec= {
	  .trap_table_len=	3,
	  .trap_table=		_jc_javax_crypto_CipherInputStream$trap_table$nextBlock$3237dc9ebe86727f,
	  .u= {
	    .linenum= {
	      .len=	32,
	      .table=	_jc_javax_crypto_CipherInputStream$linenum_table$nextBlock$3237dc9ebe86727f
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_CipherInputStream, nextBlock$3237dc9ebe86727f);

void _JC_JCNI_ATTR
_jc_javax_crypto_CipherInputStream$method$nextBlock$3237dc9ebe86727f(_jc_env *const env, _jc_javax_crypto_CipherInputStream$object *this)
{
	jint i0;
	jint i1;
	struct _jc_javax_crypto_CipherInputStream$object *r0;
	_jc_byte_array *r1;
	struct _jc_javax_crypto_BadPaddingException$object *volatile r10;
	struct _jc_javax_crypto_IllegalBlockSizeException$object *volatile r11;
	struct _jc_java_lang_VMThrowable$object *volatile r12;
	struct _jc_java_lang_VMThrowable$object *volatile r13;
	struct _jc_java_lang_VMThrowable$object *volatile r15;
	_jc_object_array *r2;
	_jc_object_array *r3;
	_jc_byte_array *r4;
	struct _jc_java_io_InputStream$object *r5;
	struct _jc_javax_crypto_Cipher$object *r6;
	struct _jc_javax_crypto_ShortBufferException$object *volatile r7;
	struct _jc_java_io_IOException$object *volatile r8;
	struct _jc_java_lang_String$object *volatile r9;
	jboolean z0;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_javax_crypto_CipherInputStream$method_info$nextBlock$3237dc9ebe86727f, &&label9, &&label10, &&label11);

	r0 = this;
	_JC_LINE_NUMBER(314);				// 0
	r2 = _JC_REF_FIELD(env, r0, javax_crypto_CipherInputStream, inBuffer);
	r1 = _JC_REF_ELEMENT(env, r2, 0, 0, 0);
	_JC_LINE_NUMBER(315);				// 1
	r2 = _JC_REF_FIELD(env, r0, javax_crypto_CipherInputStream, inBuffer);
	r3 = _JC_REF_FIELD(env, r0, javax_crypto_CipherInputStream, inBuffer);
	r4 = _JC_REF_ELEMENT(env, r3, 1, 0, 0);
	_JC_REF_ELEMENT(env, r2, 0, 0, 0) = r4;
	_JC_LINE_NUMBER(316);				// 2
	r3 = _JC_REF_FIELD(env, r0, javax_crypto_CipherInputStream, inBuffer);
	_JC_REF_ELEMENT(env, r3, 1, 0, 0) = r1;
	_JC_LINE_NUMBER(317);				// 3
	i0 = 0;
	_JC_LINE_NUMBER(318);				// 4
	z0 = 0;
	_JC_LINE_NUMBER(320);				// 5
	i1 = _JC_PRIM_FIELD(env, r0, javax_crypto_CipherInputStream, state);
	if (i1 == 0)
		goto label0;
	i1 = _JC_PRIM_FIELD(env, r0, javax_crypto_CipherInputStream, state);
	if (i1 != 1)
		goto label2;

label0:
	_JC_LINE_NUMBER(324);				// 6
	r5 = _JC_REF_FIELD(env, r0, java_io_FilterInputStream, in);
	r3 = _JC_REF_FIELD(env, r0, javax_crypto_CipherInputStream, inBuffer);
	r4 = _JC_REF_ELEMENT(env, r3, 1, 0, 0);
	r3 = _JC_REF_FIELD(env, r0, javax_crypto_CipherInputStream, inBuffer);
	r1 = _JC_REF_ELEMENT(env, r3, 1, 0, 0);
	i1 = _JC_ARRAY_LENGTH(env, r1);
	i1 = i1 - i0;
	i1 = _JC_INVOKE_VIRTUAL(env, java_io_InputStream, read$e6b6c87b9f256783, r5, r4, i0, i1);
	_JC_LINE_NUMBER(325);				// 7
	if (i1 != -1)
		goto label1;
	_JC_LINE_NUMBER(327);				// 8
	z0 = 1;
	_JC_LINE_NUMBER(328);				// 9
	goto label2;

label1:
	_JC_LINE_NUMBER(330);				// 10
	i0 = i0 + i1;
	_JC_LINE_NUMBER(332);				// 11
	r3 = _JC_REF_FIELD(env, r0, javax_crypto_CipherInputStream, inBuffer);
	r4 = _JC_REF_ELEMENT(env, r3, 1, 0, 0);
	i1 = _JC_ARRAY_LENGTH(env, r4);
	if (i0 < i1) {
		_JC_PERIODIC_CHECK(env);
		goto label0;
	}

label2:
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(337);				// 12
	i1 = _JC_PRIM_FIELD(env, r0, javax_crypto_CipherInputStream, state);
	switch (i1) {
	case 0:
		goto label3;
	case 1:
		goto label4;
	case 2:
		goto label7;
	default:
		goto label8;
	}

label3:
	_JC_LINE_NUMBER(340);				// 13
	_JC_PRIM_FIELD(env, r0, javax_crypto_CipherInputStream, state) = 1;
	_JC_LINE_NUMBER(341);				// 14
	_JC_INVOKE_NONVIRTUAL(env, javax_crypto_CipherInputStream, nextBlock$3237dc9ebe86727f, 0, r0);
	_JC_LINE_NUMBER(342);				// 15
	goto label12;

label4:
	_JC_LINE_NUMBER(344);				// 16
	if (z0 == 0)
		goto label6;
	_JC_LINE_NUMBER(346);				// 17
	if (i0 <= 0)
		goto label5;
	_JC_LINE_NUMBER(348);				// 18
	r6 = _JC_REF_FIELD(env, r0, javax_crypto_CipherInputStream, cipher);
	r3 = _JC_REF_FIELD(env, r0, javax_crypto_CipherInputStream, inBuffer);
	r4 = _JC_REF_ELEMENT(env, r3, 0, 0, 0);
	i1 = _JC_PRIM_FIELD(env, r0, javax_crypto_CipherInputStream, inLength);
	r1 = _JC_REF_FIELD(env, r0, javax_crypto_CipherInputStream, outBuffer);
	i1 = _JC_INVOKE_NONVIRTUAL(env, javax_crypto_Cipher, update$ae15e2d814f1cdb1, 1, r6, r4, 0, i1, r1, 0);
	_JC_PRIM_FIELD(env, r0, javax_crypto_CipherInputStream, outOffset) = i1;
	_JC_LINE_NUMBER(349);				// 19
	_JC_PRIM_FIELD(env, r0, javax_crypto_CipherInputStream, state) = 2;
	goto label12;

label5:
	_JC_LINE_NUMBER(353);				// 20
	r6 = _JC_REF_FIELD(env, r0, javax_crypto_CipherInputStream, cipher);
	r3 = _JC_REF_FIELD(env, r0, javax_crypto_CipherInputStream, inBuffer);
	r4 = _JC_REF_ELEMENT(env, r3, 0, 0, 0);
	i1 = _JC_PRIM_FIELD(env, r0, javax_crypto_CipherInputStream, inLength);
	r1 = _JC_REF_FIELD(env, r0, javax_crypto_CipherInputStream, outBuffer);
	i1 = _JC_INVOKE_NONVIRTUAL(env, javax_crypto_Cipher, doFinal$a67b3f796179b9a3, 1, r6, r4, 0, i1, r1, 0);
	_JC_PRIM_FIELD(env, r0, javax_crypto_CipherInputStream, outOffset) = i1;
	_JC_LINE_NUMBER(354);				// 21
	_JC_PRIM_FIELD(env, r0, javax_crypto_CipherInputStream, state) = 3;
	goto label12;

label6:
	_JC_LINE_NUMBER(359);				// 22
	r6 = _JC_REF_FIELD(env, r0, javax_crypto_CipherInputStream, cipher);
	r3 = _JC_REF_FIELD(env, r0, javax_crypto_CipherInputStream, inBuffer);
	r4 = _JC_REF_ELEMENT(env, r3, 0, 0, 0);
	i1 = _JC_PRIM_FIELD(env, r0, javax_crypto_CipherInputStream, inLength);
	r1 = _JC_REF_FIELD(env, r0, javax_crypto_CipherInputStream, outBuffer);
	i1 = _JC_INVOKE_NONVIRTUAL(env, javax_crypto_Cipher, update$ae15e2d814f1cdb1, 1, r6, r4, 0, i1, r1, 0);
	_JC_PRIM_FIELD(env, r0, javax_crypto_CipherInputStream, outOffset) = i1;
	_JC_LINE_NUMBER(361);				// 23
	goto label12;

label7:
	_JC_LINE_NUMBER(363);				// 24
	r6 = _JC_REF_FIELD(env, r0, javax_crypto_CipherInputStream, cipher);
	r3 = _JC_REF_FIELD(env, r0, javax_crypto_CipherInputStream, inBuffer);
	r4 = _JC_REF_ELEMENT(env, r3, 0, 0, 0);
	i1 = _JC_PRIM_FIELD(env, r0, javax_crypto_CipherInputStream, inLength);
	r1 = _JC_REF_FIELD(env, r0, javax_crypto_CipherInputStream, outBuffer);
	i1 = _JC_INVOKE_NONVIRTUAL(env, javax_crypto_Cipher, doFinal$a67b3f796179b9a3, 1, r6, r4, 0, i1, r1, 0);
	_JC_PRIM_FIELD(env, r0, javax_crypto_CipherInputStream, outOffset) = i1;
	_JC_LINE_NUMBER(364);				// 25
	_JC_PRIM_FIELD(env, r0, javax_crypto_CipherInputStream, state) = 3;

label8:
	_JC_TRAP_REGION(catch, 2);
	_JC_LINE_NUMBER(366);				// 26
	goto label12;

label9:
	_JC_TRAP_REGION(catch, 2);
	r7 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(371);				// 27
	r8 = _JC_NEW(env, java_io_IOException);
	r9 = _JC_INVOKE_VIRTUAL(env, java_lang_Throwable, toString$7ea43b33b80a3070, r7);
	_JC_REF_FIELD(env, r8, java_lang_Throwable, cause) = r8;
	r12 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r8);
	_JC_REF_FIELD(env, r8, java_lang_Throwable, vmState) = r12;
	_JC_REF_FIELD(env, r8, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r8, java_lang_Throwable, detailMessage) = r9;
	_JC_THROW(env, r8);

label10:
	_JC_TRAP_REGION(catch, 2);
	r10 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(375);				// 28
	r8 = _JC_NEW(env, java_io_IOException);
	r9 = _JC_INVOKE_VIRTUAL(env, java_lang_Throwable, toString$7ea43b33b80a3070, r10);
	_JC_REF_FIELD(env, r8, java_lang_Throwable, cause) = r8;
	r13 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r8);
	_JC_REF_FIELD(env, r8, java_lang_Throwable, vmState) = r13;
	_JC_REF_FIELD(env, r8, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r8, java_lang_Throwable, detailMessage) = r9;
	_JC_THROW(env, r8);

label11:
	_JC_TRAP_REGION(catch, 2);
	r11 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(379);				// 29
	r8 = _JC_NEW(env, java_io_IOException);
	r9 = _JC_INVOKE_VIRTUAL(env, java_lang_Throwable, toString$7ea43b33b80a3070, r11);
	_JC_REF_FIELD(env, r8, java_lang_Throwable, cause) = r8;
	r15 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r8);
	_JC_REF_FIELD(env, r8, java_lang_Throwable, vmState) = r15;
	_JC_REF_FIELD(env, r8, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r8, java_lang_Throwable, detailMessage) = r9;
	_JC_THROW(env, r8);

label12:
	_JC_TRAP_REGION(catch, 2);
	_JC_LINE_NUMBER(381);				// 30
	_JC_PRIM_FIELD(env, r0, javax_crypto_CipherInputStream, inLength) = i0;
	_JC_LINE_NUMBER(382);				// 31
	_JC_CANCEL_TRAPS(env, catch);
	return;
}

//
// public int read() throws java.io.IOException
//

static _jc_linenum _jc_javax_crypto_CipherInputStream$linenum_table$read$1a981297cb524963[];

static _jc_trap_info _jc_javax_crypto_CipherInputStream$trap_table$read$1a981297cb524963[] = {
	_JC_TRAP(&_jc_javax_crypto_ShortBufferException$type, 1, 2),
};

static const unsigned char _jc_javax_crypto_CipherInputStream$param_ptypes$read$1a981297cb524963[] = { 
_JC_TYPE_INT };

static _jc_type *const _jc_javax_crypto_CipherInputStream$exceptions$read$1a981297cb524963[] = {
	&_jc_java_io_IOException$type
};

_jc_method _jc_javax_crypto_CipherInputStream$method_info$read$1a981297cb524963 = {
	.name=			"read",
	.signature=		"()I",
	.class=			&_jc_javax_crypto_CipherInputStream$type,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_javax_crypto_CipherInputStream$param_ptypes$read$1a981297cb524963,
	.signature_hash=	_JC_JLONG(0x1a981297cb524963),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_javax_crypto_CipherInputStream$method$read$1a981297cb524963,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_CipherInputStream$vtable, javax_crypto_CipherInputStream.read$1a981297cb524963) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_crypto_CipherInputStream$exceptions$read$1a981297cb524963,
	.u= { .exec= {
	  .trap_table_len=	1,
	  .trap_table=		_jc_javax_crypto_CipherInputStream$trap_table$read$1a981297cb524963,
	  .u= {
	    .linenum= {
	      .len=	12,
	      .table=	_jc_javax_crypto_CipherInputStream$linenum_table$read$1a981297cb524963
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_CipherInputStream, read$1a981297cb524963);

jint _JC_JCNI_ATTR
_jc_javax_crypto_CipherInputStream$method$read$1a981297cb524963(_jc_env *const env, _jc_javax_crypto_CipherInputStream$object *this)
{
	jbyte b1;
	jint i0;
	jint i3;
	jint i4;
	struct _jc_javax_crypto_CipherInputStream$object *r0;
	_jc_byte_array *r1;
	struct _jc_javax_crypto_ShortBufferException$object *volatile r2;
	struct _jc_javax_crypto_Cipher$object *r3;
	struct _jc_java_io_IOException$object *volatile r4;
	struct _jc_java_lang_String$object *volatile r5;
	struct _jc_java_io_InputStream$object *r6;
	struct _jc_java_lang_VMThrowable$object *volatile r8;
	jshort s2;
	jboolean z0;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_javax_crypto_CipherInputStream$method_info$read$1a981297cb524963, &&label1);

	r0 = this;
	_JC_LINE_NUMBER(177);				// 0
	z0 = _JC_PRIM_FIELD(env, r0, javax_crypto_CipherInputStream, isStream);
	if (z0 == 0)
		goto label3;
	_JC_LINE_NUMBER(179);				// 1
	r1 = _JC_NEW_PRIM_ARRAY(env, byte, 1, 1);
	r6 = _JC_REF_FIELD(env, r0, java_io_FilterInputStream, in);
	i4 = _JC_INVOKE_VIRTUAL(env, java_io_InputStream, read$1a981297cb524963, r6);
	_JC_LINE_NUMBER(181);				// 2
	if (i4 != -1)
		goto label0;
	_JC_LINE_NUMBER(182);				// 3
	_JC_CANCEL_TRAPS(env, catch);
	return -1;

label0:
	_JC_LINE_NUMBER(183);				// 4
	b1 = (jbyte)i4;
	_JC_PRIM_ELEMENT(env, byte, r1, 0, 0, 0) = b1;
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(186);				// 5
	r3 = _JC_REF_FIELD(env, r0, javax_crypto_CipherInputStream, cipher);
	_JC_INVOKE_NONVIRTUAL(env, javax_crypto_Cipher, update$ae15e2d814f1cdb1, 1, r3, r1, 0, 1, r1, 0);
	_JC_TRAP_REGION(catch, 2);
	goto label2;

label1:
	_JC_TRAP_REGION(catch, 2);
	r2 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(190);				// 6
	r4 = _JC_NEW(env, java_io_IOException);
	r5 = _JC_INVOKE_VIRTUAL(env, java_lang_Throwable, getMessage$13aaf240efc902b1, r2);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r8 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r8;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r5;
	_JC_THROW(env, r4);

label2:
	_JC_LINE_NUMBER(192);				// 7
	b1 = _JC_PRIM_ELEMENT(env, byte, r1, 0, 0, 1);
	s2 = b1 & 255;
	_JC_CANCEL_TRAPS(env, catch);
	return s2;

label3:
	_JC_TRAP_REGION(catch, 2);
	_JC_LINE_NUMBER(194);				// 8
	i0 = _JC_PRIM_FIELD(env, r0, javax_crypto_CipherInputStream, state);
	if (i0 != 3)
		goto label4;
	_JC_CANCEL_TRAPS(env, catch);
	return -1;

label4:
	_JC_LINE_NUMBER(195);				// 9
	i0 = _JC_INVOKE_VIRTUAL(env, javax_crypto_CipherInputStream, available$81975cc608605037, r0);
	if (i0 != 0)
		goto label5;
	_JC_INVOKE_NONVIRTUAL(env, javax_crypto_CipherInputStream, nextBlock$3237dc9ebe86727f, 0, r0);

label5:
	_JC_LINE_NUMBER(196);				// 10
	i0 = _JC_PRIM_FIELD(env, r0, javax_crypto_CipherInputStream, state);
	if (i0 != 3)
		goto label6;
	_JC_CANCEL_TRAPS(env, catch);
	return -1;

label6:
	_JC_LINE_NUMBER(197);				// 11
	r1 = _JC_REF_FIELD(env, r0, javax_crypto_CipherInputStream, outBuffer);
	i0 = _JC_PRIM_FIELD(env, r0, javax_crypto_CipherInputStream, outOffset);
	i3 = i0 + 1;
	_JC_PRIM_FIELD(env, r0, javax_crypto_CipherInputStream, outOffset) = i3;
	b1 = _JC_PRIM_ELEMENT(env, byte, r1, i0, 1, 1);
	s2 = b1 & 255;
	_JC_CANCEL_TRAPS(env, catch);
	return s2;
}

//
// public int read(byte[]) throws java.io.IOException
//

static _jc_linenum _jc_javax_crypto_CipherInputStream$linenum_table$read$c38dd905b7fb8654[];

static const unsigned char _jc_javax_crypto_CipherInputStream$param_ptypes$read$c38dd905b7fb8654[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT };

static _jc_type *const _jc_javax_crypto_CipherInputStream$exceptions$read$c38dd905b7fb8654[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_javax_crypto_CipherInputStream$param_types$read$c38dd905b7fb8654[] = {
	&_jc_byte$array$prim$type
};

_jc_method _jc_javax_crypto_CipherInputStream$method_info$read$c38dd905b7fb8654 = {
	.name=			"read",
	.signature=		"([B)I",
	.class=			&_jc_javax_crypto_CipherInputStream$type,
	.param_types=		&_jc_javax_crypto_CipherInputStream$param_types$read$c38dd905b7fb8654,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_javax_crypto_CipherInputStream$param_ptypes$read$c38dd905b7fb8654,
	.signature_hash=	_JC_JLONG(0xc38dd905b7fb8654),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_javax_crypto_CipherInputStream$method$read$c38dd905b7fb8654,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_CipherInputStream$vtable, javax_crypto_CipherInputStream.read$c38dd905b7fb8654) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_crypto_CipherInputStream$exceptions$read$c38dd905b7fb8654,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_crypto_CipherInputStream$linenum_table$read$c38dd905b7fb8654
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_CipherInputStream, read$c38dd905b7fb8654);

jint _JC_JCNI_ATTR
_jc_javax_crypto_CipherInputStream$method$read$c38dd905b7fb8654(_jc_env *const env, _jc_javax_crypto_CipherInputStream$object *this, _jc_byte_array *param0)
{
	jint i0;
	struct _jc_javax_crypto_CipherInputStream$object *r0;
	_jc_byte_array *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(254);				// 0
	i0 = _JC_ARRAY_LENGTH(env, r1);
	i0 = _JC_INVOKE_VIRTUAL(env, javax_crypto_CipherInputStream, read$e6b6c87b9f256783, r0, r1, 0, i0);
	return i0;
}

//
// public int read(byte[], int, int) throws java.io.IOException
//

static _jc_linenum _jc_javax_crypto_CipherInputStream$linenum_table$read$e6b6c87b9f256783[];

static _jc_trap_info _jc_javax_crypto_CipherInputStream$trap_table$read$e6b6c87b9f256783[] = {
	_JC_TRAP(&_jc_javax_crypto_ShortBufferException$type, 1, 2),
};

static const unsigned char _jc_javax_crypto_CipherInputStream$param_ptypes$read$e6b6c87b9f256783[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_INT, _JC_TYPE_INT };

static _jc_type *const _jc_javax_crypto_CipherInputStream$exceptions$read$e6b6c87b9f256783[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_javax_crypto_CipherInputStream$param_types$read$e6b6c87b9f256783[] = {
	&_jc_byte$array$prim$type,
	&_jc_int$prim$type,
	&_jc_int$prim$type
};

_jc_method _jc_javax_crypto_CipherInputStream$method_info$read$e6b6c87b9f256783 = {
	.name=			"read",
	.signature=		"([BII)I",
	.class=			&_jc_javax_crypto_CipherInputStream$type,
	.param_types=		&_jc_javax_crypto_CipherInputStream$param_types$read$e6b6c87b9f256783,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_javax_crypto_CipherInputStream$param_ptypes$read$e6b6c87b9f256783,
	.signature_hash=	_JC_JLONG(0xe6b6c87b9f256783),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_javax_crypto_CipherInputStream$method$read$e6b6c87b9f256783,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_CipherInputStream$vtable, javax_crypto_CipherInputStream.read$e6b6c87b9f256783) / sizeof(void *),
	.num_parameters=	3,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_crypto_CipherInputStream$exceptions$read$e6b6c87b9f256783,
	.u= { .exec= {
	  .trap_table_len=	1,
	  .trap_table=		_jc_javax_crypto_CipherInputStream$trap_table$read$e6b6c87b9f256783,
	  .u= {
	    .linenum= {
	      .len=	17,
	      .table=	_jc_javax_crypto_CipherInputStream$linenum_table$read$e6b6c87b9f256783
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_CipherInputStream, read$e6b6c87b9f256783);

jint _JC_JCNI_ATTR
_jc_javax_crypto_CipherInputStream$method$read$e6b6c87b9f256783(_jc_env *const env, _jc_javax_crypto_CipherInputStream$object *this, _jc_byte_array *param0, jint param1, jint param2)
{
	jint i0;
	jint i1;
	jint i2;
	jint i3;
	jint i4;
	jint i5;
	jint i6;
	jint i8;
	struct _jc_javax_crypto_CipherInputStream$object *r0;
	_jc_byte_array *r1;
	struct _jc_javax_crypto_ShortBufferException$object *volatile r2;
	struct _jc_javax_crypto_Cipher$object *r3;
	struct _jc_java_io_IOException$object *volatile r4;
	struct _jc_java_lang_String$object *volatile r5;
	_jc_byte_array *r6;
	struct _jc_java_io_InputStream$object *r7;
	struct _jc_java_lang_VMThrowable$object *volatile r8;
	jboolean z0;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_javax_crypto_CipherInputStream$method_info$read$e6b6c87b9f256783, &&label0);

	r0 = this;
	r1 = param0;
	i0 = param1;
	i1 = param2;
	_JC_LINE_NUMBER(212);				// 0
	z0 = _JC_PRIM_FIELD(env, r0, javax_crypto_CipherInputStream, isStream);
	if (z0 == 0)
		goto label2;
	r7 = _JC_REF_FIELD(env, r0, java_io_FilterInputStream, in);
	i6 = _JC_INVOKE_VIRTUAL(env, java_io_InputStream, read$e6b6c87b9f256783, r7, r1, i0, i1);
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(217);				// 1
	r3 = _JC_REF_FIELD(env, r0, javax_crypto_CipherInputStream, cipher);
	_JC_INVOKE_NONVIRTUAL(env, javax_crypto_Cipher, update$ae15e2d814f1cdb1, 1, r3, r1, i0, i6, r1, i0);
	_JC_TRAP_REGION(catch, 2);
	goto label1;

label0:
	_JC_TRAP_REGION(catch, 2);
	r2 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(221);				// 2
	r4 = _JC_NEW(env, java_io_IOException);
	r5 = _JC_INVOKE_VIRTUAL(env, java_lang_Throwable, getMessage$13aaf240efc902b1, r2);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r8 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r8;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r5;
	_JC_THROW(env, r4);

label1:
	_JC_LINE_NUMBER(223);				// 3
	_JC_CANCEL_TRAPS(env, catch);
	return i6;

label2:
	_JC_TRAP_REGION(catch, 2);
	_JC_LINE_NUMBER(226);				// 4
	i3 = 0;
	_JC_LINE_NUMBER(227);				// 5
	goto label9;

label3:
	_JC_LINE_NUMBER(229);				// 6
	i2 = _JC_INVOKE_VIRTUAL(env, javax_crypto_CipherInputStream, available$81975cc608605037, r0);
	if (i2 != 0)
		goto label4;
	_JC_LINE_NUMBER(230);				// 7
	_JC_INVOKE_NONVIRTUAL(env, javax_crypto_CipherInputStream, nextBlock$3237dc9ebe86727f, 0, r0);

label4:
	_JC_LINE_NUMBER(231);				// 8
	i2 = _JC_PRIM_FIELD(env, r0, javax_crypto_CipherInputStream, state);
	if (i2 != 3)
		goto label6;
	_JC_LINE_NUMBER(233);				// 9
	if (i3 <= 0)
		goto label5;
	_JC_CANCEL_TRAPS(env, catch);
	return i3;

label5:
	_JC_LINE_NUMBER(234);				// 10
	_JC_CANCEL_TRAPS(env, catch);
	return -1;

label6:
	_JC_LINE_NUMBER(236);				// 11
	i2 = _JC_INVOKE_VIRTUAL(env, javax_crypto_CipherInputStream, available$81975cc608605037, r0);
	i4 = i1 - i3;
	_JC_ACTIVE_USE(env, java_lang_Math);
	if (i2 >= i4)
		goto label7;
	i8 = i2;
	goto label8;

label7:
	i8 = i4;

label8:
	_JC_LINE_NUMBER(237);				// 12
	r6 = _JC_REF_FIELD(env, r0, javax_crypto_CipherInputStream, outBuffer);
	i4 = _JC_PRIM_FIELD(env, r0, javax_crypto_CipherInputStream, outOffset);
	i5 = i3 + i0;
	_JC_ACTIVE_USE(env, java_lang_System);
	_JC_INVOKE_STATIC(env, java_lang_VMSystem, arraycopy$4286a72d57744cd8, 0, r6, i4, r1, i5, i8);
	_JC_LINE_NUMBER(238);				// 13
	i3 = i3 + i8;
	_JC_LINE_NUMBER(239);				// 14
	_JC_PRIM_FIELD(env, r0, javax_crypto_CipherInputStream, outLength) = 0;
	_JC_PRIM_FIELD(env, r0, javax_crypto_CipherInputStream, outOffset) = 0;

label9:
	_JC_LINE_NUMBER(227);				// 15
	if (i3 < i1) {
		_JC_PERIODIC_CHECK(env);
		goto label3;
	}
	_JC_LINE_NUMBER(241);				// 16
	_JC_CANCEL_TRAPS(env, catch);
	return i3;
}

//
// public void reset() throws java.io.IOException
//

static _jc_linenum _jc_javax_crypto_CipherInputStream$linenum_table$reset$229a80b3e8394a0f[];

static const unsigned char _jc_javax_crypto_CipherInputStream$param_ptypes$reset$229a80b3e8394a0f[] = { 
_JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_CipherInputStream$exceptions$reset$229a80b3e8394a0f[] = {
	&_jc_java_io_IOException$type
};

_jc_method _jc_javax_crypto_CipherInputStream$method_info$reset$229a80b3e8394a0f = {
	.name=			"reset",
	.signature=		"()V",
	.class=			&_jc_javax_crypto_CipherInputStream$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_CipherInputStream$param_ptypes$reset$229a80b3e8394a0f,
	.signature_hash=	_JC_JLONG(0x229a80b3e8394a0f),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_javax_crypto_CipherInputStream$method$reset$229a80b3e8394a0f,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_CipherInputStream$vtable, javax_crypto_CipherInputStream.reset$229a80b3e8394a0f) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_crypto_CipherInputStream$exceptions$reset$229a80b3e8394a0f,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_crypto_CipherInputStream$linenum_table$reset$229a80b3e8394a0f
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_CipherInputStream, reset$229a80b3e8394a0f);

void _JC_JCNI_ATTR
_jc_javax_crypto_CipherInputStream$method$reset$229a80b3e8394a0f(_jc_env *const env, _jc_javax_crypto_CipherInputStream$object *this)
{
	struct _jc_javax_crypto_CipherInputStream$object *r0;
	struct _jc_java_io_IOException$object *r1;
	struct _jc_java_lang_String$object *r2;
	struct _jc_java_lang_VMThrowable$object *r4;

	r0 = this;
	_JC_LINE_NUMBER(306);				// 0
	r1 = _JC_NEW(env, java_io_IOException);
	r2 = _JC_STRING(env, "reset not supported");
	_JC_REF_FIELD(env, r1, java_lang_Throwable, cause) = r1;
	r4 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r1);
	_JC_REF_FIELD(env, r1, java_lang_Throwable, vmState) = r4;
	_JC_REF_FIELD(env, r1, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r1, java_lang_Throwable, detailMessage) = r2;
	_JC_THROW(env, r1);
}

//
// public long skip(long) throws java.io.IOException
//

static _jc_linenum _jc_javax_crypto_CipherInputStream$linenum_table$skip$4e431136b5c4614a[];

static const unsigned char _jc_javax_crypto_CipherInputStream$param_ptypes$skip$4e431136b5c4614a[] = { 
_JC_TYPE_LONG, _JC_TYPE_LONG };

static _jc_type *const _jc_javax_crypto_CipherInputStream$exceptions$skip$4e431136b5c4614a[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_javax_crypto_CipherInputStream$param_types$skip$4e431136b5c4614a[] = {
	&_jc_long$prim$type
};

_jc_method _jc_javax_crypto_CipherInputStream$method_info$skip$4e431136b5c4614a = {
	.name=			"skip",
	.signature=		"(J)J",
	.class=			&_jc_javax_crypto_CipherInputStream$type,
	.param_types=		&_jc_javax_crypto_CipherInputStream$param_types$skip$4e431136b5c4614a,
	.return_type=		&_jc_long$prim$type,
	.param_ptypes=		&_jc_javax_crypto_CipherInputStream$param_ptypes$skip$4e431136b5c4614a,
	.signature_hash=	_JC_JLONG(0x4e431136b5c4614a),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_javax_crypto_CipherInputStream$method$skip$4e431136b5c4614a,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_CipherInputStream$vtable, javax_crypto_CipherInputStream.skip$4e431136b5c4614a) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_crypto_CipherInputStream$exceptions$skip$4e431136b5c4614a,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	7,
	      .table=	_jc_javax_crypto_CipherInputStream$linenum_table$skip$4e431136b5c4614a
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_CipherInputStream, skip$4e431136b5c4614a);

jlong _JC_JCNI_ATTR
_jc_javax_crypto_CipherInputStream$method$skip$4e431136b5c4614a(_jc_env *const env, _jc_javax_crypto_CipherInputStream$object *this, jlong param0)
{
	jbyte b3;
	jint i2;
	jlong l0;
	jlong l1;
	jlong l4;
	struct _jc_javax_crypto_CipherInputStream$object *r0;
	struct _jc_java_io_InputStream$object *r2;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	l0 = param0;
	_JC_LINE_NUMBER(267);				// 0
	z0 = _JC_PRIM_FIELD(env, r0, javax_crypto_CipherInputStream, isStream);
	if (z0 == 0)
		goto label0;
	r2 = _JC_REF_FIELD(env, r0, java_io_FilterInputStream, in);
	l4 = _JC_INVOKE_VIRTUAL(env, java_io_InputStream, skip$4e431136b5c4614a, r2, l0);
	_JC_LINE_NUMBER(269);				// 1
	return l4;

label0:
	_JC_LINE_NUMBER(271);				// 2
	l1 = _JC_JLONG(0);
	_JC_LINE_NUMBER(272);				// 3
	b3 = _JC_LCMP(l0, _JC_JLONG(0));
	if (b3 <= 0)
		goto label1;
	i2 = _JC_INVOKE_VIRTUAL(env, javax_crypto_CipherInputStream, available$81975cc608605037, r0);
	if (i2 <= 0)
		goto label1;
	_JC_LINE_NUMBER(274);				// 4
	i2 = _JC_INVOKE_VIRTUAL(env, javax_crypto_CipherInputStream, available$81975cc608605037, r0);
	l1 = (jlong)i2;
	_JC_LINE_NUMBER(275);				// 5
	_JC_PRIM_FIELD(env, r0, javax_crypto_CipherInputStream, outLength) = 0;
	_JC_PRIM_FIELD(env, r0, javax_crypto_CipherInputStream, outOffset) = 0;

label1:
	_JC_LINE_NUMBER(277);				// 6
	return l1;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_javax_crypto_CipherInputStream$methods[] = {
	&_jc_javax_crypto_CipherInputStream$method_info$_init$3887600c17c5e554,
	&_jc_javax_crypto_CipherInputStream$method_info$_init$bdb07dfd19624f01,
	&_jc_javax_crypto_CipherInputStream$method_info$available$81975cc608605037,
	&_jc_javax_crypto_CipherInputStream$method_info$close$6aba8b329fddcd79,
	&_jc_javax_crypto_CipherInputStream$method_info$mark$422af117ab27d9db,
	&_jc_javax_crypto_CipherInputStream$method_info$markSupported$66435a81b7b2f2dc,
	&_jc_javax_crypto_CipherInputStream$method_info$nextBlock$3237dc9ebe86727f,
	&_jc_javax_crypto_CipherInputStream$method_info$read$1a981297cb524963,
	&_jc_javax_crypto_CipherInputStream$method_info$read$c38dd905b7fb8654,
	&_jc_javax_crypto_CipherInputStream$method_info$read$e6b6c87b9f256783,
	&_jc_javax_crypto_CipherInputStream$method_info$reset$229a80b3e8394a0f,
	&_jc_javax_crypto_CipherInputStream$method_info$skip$4e431136b5c4614a
};

/************************************************************************
 *			  Class fields structure			*
 ************************************************************************/

_jc_javax_crypto_CipherInputStream$fields_struct _jc_javax_crypto_CipherInputStream$class_fields = { };

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_javax_crypto_CipherInputStream$instanceof_hash_bucket_8[] = {
	&_jc_javax_crypto_CipherInputStream$type,
	_JC_NULL
};
static _jc_type *const _jc_javax_crypto_CipherInputStream$instanceof_hash_bucket_68[] = {
	&_jc_java_io_InputStream$type,
	_JC_NULL
};
static _jc_type *const _jc_javax_crypto_CipherInputStream$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};
static _jc_type *const _jc_javax_crypto_CipherInputStream$instanceof_hash_bucket_126[] = {
	&_jc_java_io_FilterInputStream$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_javax_crypto_CipherInputStream$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[8]=	_jc_javax_crypto_CipherInputStream$instanceof_hash_bucket_8,
	[68]=	_jc_javax_crypto_CipherInputStream$instanceof_hash_bucket_68,
	[101]=	_jc_javax_crypto_CipherInputStream$instanceof_hash_bucket_101,
	[126]=	_jc_javax_crypto_CipherInputStream$instanceof_hash_bucket_126
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_javax_crypto_CipherInputStream$class_depends[] = {
	{ "java/io/FilterInputStream",	_JC_JLONG(0x455accfa535f5dfe) },
	{ "java/io/IOException",	_JC_JLONG(0x4e0a56550c69d57c) },
	{ "java/io/InputStream",	_JC_JLONG(0x66aea4d152614ac4) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/Math",	_JC_JLONG(0x8d71d806a180ad8a) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/System",	_JC_JLONG(0x53cc8e2333795f04) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMSystem",	_JC_JLONG(0x4d1cebae0bdda058) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "javax/crypto/BadPaddingException",	_JC_JLONG(0xd214adbc7b3842af) },
	{ "javax/crypto/Cipher",	_JC_JLONG(0x4bdfff9ea145d6ce) },
	{ "javax/crypto/CipherSpi",	_JC_JLONG(0x4422f11229f63761) },
	{ "javax/crypto/IllegalBlockSizeException",	_JC_JLONG(0xe7376936288e78db) },
	{ "javax/crypto/ShortBufferException",	_JC_JLONG(0xd79a62a9328ccea1) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_javax_crypto_CipherInputStream$vtype _jc_javax_crypto_CipherInputStream$type = {
    .type= {
	.name=			"javax/crypto/CipherInputStream",
	.superclass=		&_jc_java_io_FilterInputStream$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		39,
		.hash=			_JC_JLONG(0xc2486c2f0ee06688),
		.source_file=		"CipherInputStream.java",
		.instance_size=		sizeof(_jc_javax_crypto_CipherInputStream$refs) + sizeof(_jc_javax_crypto_CipherInputStream$object),
		.num_virtual_refs=	4,
		.num_fields=		sizeof(_jc_javax_crypto_CipherInputStream$fields) / sizeof(*_jc_javax_crypto_CipherInputStream$fields),
		.fields=		_jc_javax_crypto_CipherInputStream$fields,
		.num_methods=		sizeof(_jc_javax_crypto_CipherInputStream$methods) / sizeof(*_jc_javax_crypto_CipherInputStream$methods),
		.methods=		_jc_javax_crypto_CipherInputStream$methods,
		.instanceof_hash_table=	_jc_javax_crypto_CipherInputStream$instanceof_hash_table,
		.class_fields=		&_jc_javax_crypto_CipherInputStream$class_fields,
		.num_class_depends=		sizeof(_jc_javax_crypto_CipherInputStream$class_depends) / sizeof(*_jc_javax_crypto_CipherInputStream$class_depends),
		.class_depends=		_jc_javax_crypto_CipherInputStream$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.java_io_InputStream= {
	    .available$81975cc608605037=			// overridden
		&_jc_javax_crypto_CipherInputStream$method$available$81975cc608605037,
	    .close$6aba8b329fddcd79=			// overridden
		&_jc_javax_crypto_CipherInputStream$method$close$6aba8b329fddcd79,
	    .mark$422af117ab27d9db=				// overridden
		&_jc_javax_crypto_CipherInputStream$method$mark$422af117ab27d9db,
	    .markSupported$66435a81b7b2f2dc=		// overridden
		&_jc_javax_crypto_CipherInputStream$method$markSupported$66435a81b7b2f2dc,
	    .read$1a981297cb524963=				// overridden
		&_jc_javax_crypto_CipherInputStream$method$read$1a981297cb524963,
	    .read$c38dd905b7fb8654=				// overridden
		&_jc_javax_crypto_CipherInputStream$method$read$c38dd905b7fb8654,
	    .read$e6b6c87b9f256783=				// overridden
		&_jc_javax_crypto_CipherInputStream$method$read$e6b6c87b9f256783,
	    .reset$229a80b3e8394a0f=			// overridden
		&_jc_javax_crypto_CipherInputStream$method$reset$229a80b3e8394a0f,
	    .skip$4e431136b5c4614a=				// overridden
		&_jc_javax_crypto_CipherInputStream$method$skip$4e431136b5c4614a,
	},
	.java_io_FilterInputStream= {
	    .available$81975cc608605037=			// overridden
		&_jc_javax_crypto_CipherInputStream$method$available$81975cc608605037,
	    .close$6aba8b329fddcd79=			// overridden
		&_jc_javax_crypto_CipherInputStream$method$close$6aba8b329fddcd79,
	    .mark$422af117ab27d9db=				// overridden
		&_jc_javax_crypto_CipherInputStream$method$mark$422af117ab27d9db,
	    .markSupported$66435a81b7b2f2dc=		// overridden
		&_jc_javax_crypto_CipherInputStream$method$markSupported$66435a81b7b2f2dc,
	    .read$1a981297cb524963=				// overridden
		&_jc_javax_crypto_CipherInputStream$method$read$1a981297cb524963,
	    .read$c38dd905b7fb8654=				// overridden
		&_jc_javax_crypto_CipherInputStream$method$read$c38dd905b7fb8654,
	    .read$e6b6c87b9f256783=				// overridden
		&_jc_javax_crypto_CipherInputStream$method$read$e6b6c87b9f256783,
	    .reset$229a80b3e8394a0f=			// overridden
		&_jc_javax_crypto_CipherInputStream$method$reset$229a80b3e8394a0f,
	    .skip$4e431136b5c4614a=				// overridden
		&_jc_javax_crypto_CipherInputStream$method$skip$4e431136b5c4614a,
	},
	.javax_crypto_CipherInputStream= {
	    .available$81975cc608605037=
		&_jc_javax_crypto_CipherInputStream$method$available$81975cc608605037,
	    .close$6aba8b329fddcd79=
		&_jc_javax_crypto_CipherInputStream$method$close$6aba8b329fddcd79,
	    .mark$422af117ab27d9db=
		&_jc_javax_crypto_CipherInputStream$method$mark$422af117ab27d9db,
	    .markSupported$66435a81b7b2f2dc=
		&_jc_javax_crypto_CipherInputStream$method$markSupported$66435a81b7b2f2dc,
	    .nextBlock$3237dc9ebe86727f=
		&_jc_javax_crypto_CipherInputStream$method$nextBlock$3237dc9ebe86727f,
	    .read$1a981297cb524963=
		&_jc_javax_crypto_CipherInputStream$method$read$1a981297cb524963,
	    .read$c38dd905b7fb8654=
		&_jc_javax_crypto_CipherInputStream$method$read$c38dd905b7fb8654,
	    .read$e6b6c87b9f256783=
		&_jc_javax_crypto_CipherInputStream$method$read$e6b6c87b9f256783,
	    .reset$229a80b3e8394a0f=
		&_jc_javax_crypto_CipherInputStream$method$reset$229a80b3e8394a0f,
	    .skip$4e431136b5c4614a=
		&_jc_javax_crypto_CipherInputStream$method$skip$4e431136b5c4614a,
	},
    }
};

