// public class javax.crypto.CipherOutputStream

// class file dependencies
// @dep_class fddb41323d9c4cee java_io_FilterOutputStream
// @dep_class 4e0a56550c69d57c java_io_IOException
// @dep_class 4026d3144d6654d8 java_io_OutputStream
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class 8d71d806a180ad8a java_lang_Math
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 53cc8e2333795f04 java_lang_System
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class 4d1cebae0bdda058 java_lang_VMSystem
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class 81b073051aa30acc java_security_Provider
// @dep_class d214adbc7b3842af javax_crypto_BadPaddingException
// @dep_class 4bdfff9ea145d6ce javax_crypto_Cipher
// @dep_class dd878b079c781d52 javax_crypto_CipherOutputStream
// @dep_class 4422f11229f63761 javax_crypto_CipherSpi
// @dep_class e7376936288e78db javax_crypto_IllegalBlockSizeException
// @dep_class b2745a2f83ab7f25 javax_crypto_NullCipher
// @dep_class 567ce2b1db0e5e22 javax_crypto_NullCipherImpl
// @dep_class d79a62a9328ccea1 javax_crypto_ShortBufferException

// header file dependencies
// @dep_header java_io_IOException
// @dep_header java_lang_Class
// @dep_header java_lang_Math
// @dep_header java_lang_String
// @dep_header java_lang_System
// @dep_header java_lang_VMSystem
// @dep_header java_lang_VMThrowable
// @dep_header java_security_Provider
// @dep_header javax_crypto_BadPaddingException
// @dep_header javax_crypto_CipherOutputStream
// @dep_header javax_crypto_IllegalBlockSizeException
// @dep_header javax_crypto_NullCipher
// @dep_header javax_crypto_NullCipherImpl
// @dep_header javax_crypto_ShortBufferException

#include "jc_defs.h"

#include "java/io/IOException.h"
#include "java/lang/Class.h"
#include "java/lang/Math.h"
#include "java/lang/String.h"
#include "java/lang/System.h"
#include "java/lang/VMSystem.h"
#include "java/lang/VMThrowable.h"
#include "java/security/Provider.h"
#include "javax/crypto/BadPaddingException.h"
#include "javax/crypto/CipherOutputStream.h"
#include "javax/crypto/IllegalBlockSizeException.h"
#include "javax/crypto/NullCipher.h"
#include "javax/crypto/NullCipherImpl.h"
#include "javax/crypto/ShortBufferException.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// private static final int FIRST_TIME
static const jint _jc_javax_crypto_CipherOutputStream$initial_value$FIRST__5fTIME = 0;
static _jc_field _jc_javax_crypto_CipherOutputStream$field_info$FIRST__5fTIME = {
	.name=		"FIRST_TIME",
	.signature=	"I",
	.class=		&_jc_javax_crypto_CipherOutputStream$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_CipherOutputStream$fields_struct, FIRST__5fTIME),
	.initial_value=	&_jc_javax_crypto_CipherOutputStream$initial_value$FIRST__5fTIME,
};

// private static final int SECOND_TIME
static const jint _jc_javax_crypto_CipherOutputStream$initial_value$SECOND__5fTIME = 1;
static _jc_field _jc_javax_crypto_CipherOutputStream$field_info$SECOND__5fTIME = {
	.name=		"SECOND_TIME",
	.signature=	"I",
	.class=		&_jc_javax_crypto_CipherOutputStream$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_CipherOutputStream$fields_struct, SECOND__5fTIME),
	.initial_value=	&_jc_javax_crypto_CipherOutputStream$initial_value$SECOND__5fTIME,
};

// private static final int SEASONED
static const jint _jc_javax_crypto_CipherOutputStream$initial_value$SEASONED = 2;
static _jc_field _jc_javax_crypto_CipherOutputStream$field_info$SEASONED = {
	.name=		"SEASONED",
	.signature=	"I",
	.class=		&_jc_javax_crypto_CipherOutputStream$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_CipherOutputStream$fields_struct, SEASONED),
	.initial_value=	&_jc_javax_crypto_CipherOutputStream$initial_value$SEASONED,
};

// private javax.crypto.Cipher cipher
static _jc_field _jc_javax_crypto_CipherOutputStream$field_info$cipher = {
	.name=		"cipher",
	.signature=	"Ljavax/crypto/Cipher;",
	.class=		&_jc_javax_crypto_CipherOutputStream$type,
	.type=		&_jc_javax_crypto_Cipher$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_CipherOutputStream$object, refs[-1].javax_crypto_CipherOutputStream.cipher),
};

// private byte[][] inBuffer
static _jc_field _jc_javax_crypto_CipherOutputStream$field_info$inBuffer = {
	.name=		"inBuffer",
	.signature=	"[[B",
	.class=		&_jc_javax_crypto_CipherOutputStream$type,
	.type=		&_jc_byte$array2$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_CipherOutputStream$object, refs[-1].javax_crypto_CipherOutputStream.inBuffer),
};

// private int inLength
static _jc_field _jc_javax_crypto_CipherOutputStream$field_info$inLength = {
	.name=		"inLength",
	.signature=	"I",
	.class=		&_jc_javax_crypto_CipherOutputStream$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_CipherOutputStream$object, nonrefs.javax_crypto_CipherOutputStream.inLength),
};

// private byte[] outBuffer
static _jc_field _jc_javax_crypto_CipherOutputStream$field_info$outBuffer = {
	.name=		"outBuffer",
	.signature=	"[B",
	.class=		&_jc_javax_crypto_CipherOutputStream$type,
	.type=		&_jc_byte$array$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_CipherOutputStream$object, refs[-1].javax_crypto_CipherOutputStream.outBuffer),
};

// private int state
static _jc_field _jc_javax_crypto_CipherOutputStream$field_info$state = {
	.name=		"state",
	.signature=	"I",
	.class=		&_jc_javax_crypto_CipherOutputStream$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_CipherOutputStream$object, nonrefs.javax_crypto_CipherOutputStream.state),
};

// private boolean isStream
static _jc_field _jc_javax_crypto_CipherOutputStream$field_info$isStream = {
	.name=		"isStream",
	.signature=	"Z",
	.class=		&_jc_javax_crypto_CipherOutputStream$type,
	.type=		&_jc_boolean$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_CipherOutputStream$object, nonrefs.javax_crypto_CipherOutputStream.isStream),
};

// Fields
static _jc_field *const _jc_javax_crypto_CipherOutputStream$fields[] = {
	&_jc_javax_crypto_CipherOutputStream$field_info$FIRST__5fTIME,
	&_jc_javax_crypto_CipherOutputStream$field_info$SEASONED,
	&_jc_javax_crypto_CipherOutputStream$field_info$SECOND__5fTIME,
	&_jc_javax_crypto_CipherOutputStream$field_info$cipher,
	&_jc_javax_crypto_CipherOutputStream$field_info$inBuffer,
	&_jc_javax_crypto_CipherOutputStream$field_info$outBuffer,
	&_jc_javax_crypto_CipherOutputStream$field_info$inLength,
	&_jc_javax_crypto_CipherOutputStream$field_info$state,
	&_jc_javax_crypto_CipherOutputStream$field_info$isStream
};

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// protected void <init>(java.io.OutputStream)
//

static _jc_linenum _jc_javax_crypto_CipherOutputStream$linenum_table$_init$8b48f276bbc2c828[];

static const unsigned char _jc_javax_crypto_CipherOutputStream$param_ptypes$_init$8b48f276bbc2c828[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_CipherOutputStream$param_types$_init$8b48f276bbc2c828[] = {
	&_jc_java_io_OutputStream$type
};

_jc_method _jc_javax_crypto_CipherOutputStream$method_info$_init$8b48f276bbc2c828 = {
	.name=			"<init>",
	.signature=		"(Ljava/io/OutputStream;)V",
	.class=			&_jc_javax_crypto_CipherOutputStream$type,
	.param_types=		&_jc_javax_crypto_CipherOutputStream$param_types$_init$8b48f276bbc2c828,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_CipherOutputStream$param_ptypes$_init$8b48f276bbc2c828,
	.signature_hash=	_JC_JLONG(0x8b48f276bbc2c828),
	.access_flags=		_JC_ACC_PROTECTED,
	.function=		&_jc_javax_crypto_CipherOutputStream$method$_init$8b48f276bbc2c828,
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_crypto_CipherOutputStream$linenum_table$_init$8b48f276bbc2c828
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_CipherOutputStream, _init$8b48f276bbc2c828);

void _JC_JCNI_ATTR
_jc_javax_crypto_CipherOutputStream$method$_init$8b48f276bbc2c828(_jc_env *const env, _jc_javax_crypto_CipherOutputStream$object *this, _jc_java_io_OutputStream$object *param0)
{
	struct _jc_javax_crypto_CipherOutputStream$object *r0;
	struct _jc_java_io_OutputStream$object *r1;

	r0 = this;
	r1 = param0;
	_JC_REF_FIELD(env, r0, java_io_FilterOutputStream, out) = r1;
	_JC_LINE_NUMBER(111);				// 0
	return;
}

//
// public void <init>(java.io.OutputStream, javax.crypto.Cipher)
//

static _jc_linenum _jc_javax_crypto_CipherOutputStream$linenum_table$_init$91ab559d46dbb5ca[];

static const unsigned char _jc_javax_crypto_CipherOutputStream$param_ptypes$_init$91ab559d46dbb5ca[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_CipherOutputStream$param_types$_init$91ab559d46dbb5ca[] = {
	&_jc_java_io_OutputStream$type,
	&_jc_javax_crypto_Cipher$type
};

_jc_method _jc_javax_crypto_CipherOutputStream$method_info$_init$91ab559d46dbb5ca = {
	.name=			"<init>",
	.signature=		"(Ljava/io/OutputStream;Ljavax/crypto/Cipher;)V",
	.class=			&_jc_javax_crypto_CipherOutputStream$type,
	.param_types=		&_jc_javax_crypto_CipherOutputStream$param_types$_init$91ab559d46dbb5ca,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_CipherOutputStream$param_ptypes$_init$91ab559d46dbb5ca,
	.signature_hash=	_JC_JLONG(0x91ab559d46dbb5ca),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_javax_crypto_CipherOutputStream$method$_init$91ab559d46dbb5ca,
	.num_parameters=	2,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	10,
	      .table=	_jc_javax_crypto_CipherOutputStream$linenum_table$_init$91ab559d46dbb5ca
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_CipherOutputStream, _init$91ab559d46dbb5ca);

void _JC_JCNI_ATTR
_jc_javax_crypto_CipherOutputStream$method$_init$91ab559d46dbb5ca(_jc_env *const env, _jc_javax_crypto_CipherOutputStream$object *this, _jc_java_io_OutputStream$object *param0, _jc_javax_crypto_Cipher$object *param1)
{
	jint i0;
	jint i1;
	jint i2;
	jint i3;
	struct _jc_javax_crypto_CipherOutputStream$object *r0;
	struct _jc_java_io_OutputStream$object *r1;
	struct _jc_java_security_Provider$object *r10;
	struct _jc_java_lang_String$object *r11;
	struct _jc_javax_crypto_Cipher$object *r2;
	_jc_object_array *r3;
	_jc_byte_array *r4;
	struct _jc_javax_crypto_NullCipher$object *r5;
	struct _jc_javax_crypto_NullCipherImpl$object *r6;
	struct _jc_javax_crypto_CipherSpi$object *r7;
	struct _jc_javax_crypto_CipherSpi$object *r8;
	struct _jc_javax_crypto_CipherSpi$object *r9;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_REF_FIELD(env, r0, java_io_FilterOutputStream, out) = r1;
	_JC_LINE_NUMBER(87);				// 0
	if (r2 == _JC_NULL)
		goto label7;
	_JC_LINE_NUMBER(89);				// 1
	_JC_REF_FIELD(env, r0, javax_crypto_CipherOutputStream, cipher) = r2;
	_JC_LINE_NUMBER(90);				// 2
	z0 = 0;
	r7 = _JC_REF_FIELD(env, r2, javax_crypto_Cipher, cipherSpi);
	if (r7 == _JC_NULL)
		goto label0;
	r7 = _JC_REF_FIELD(env, r2, javax_crypto_Cipher, cipherSpi);
	i1 = _JC_INVOKE_VIRTUAL(env, javax_crypto_CipherSpi, engineGetBlockSize$d4858c33205171e0, r7);
	i0 = i1;
	goto label1;

label0:
	i0 = 1;

label1:
	if (i0 != 1)
		goto label2;
	z0 = 1;

label2:
	_JC_PRIM_FIELD(env, r0, javax_crypto_CipherOutputStream, isStream) = z0;
	if (z0 != 0)
		goto label8;
	_JC_LINE_NUMBER(92);				// 3
	r3 = _JC_NEW_PRIM_ARRAY(env, byte, 2, 2);
	_JC_REF_FIELD(env, r0, javax_crypto_CipherOutputStream, inBuffer) = r3;
	_JC_LINE_NUMBER(93);				// 4
	r3 = _JC_REF_FIELD(env, r0, javax_crypto_CipherOutputStream, inBuffer);
	r8 = _JC_REF_FIELD(env, r2, javax_crypto_Cipher, cipherSpi);
	if (r8 == _JC_NULL)
		goto label3;
	r8 = _JC_REF_FIELD(env, r2, javax_crypto_Cipher, cipherSpi);
	i2 = _JC_INVOKE_VIRTUAL(env, javax_crypto_CipherSpi, engineGetBlockSize$d4858c33205171e0, r8);
	i0 = i2;
	goto label4;

label3:
	i0 = 1;

label4:
	r4 = _JC_NEW_PRIM_ARRAY(env, byte, 1, i0);
	_JC_REF_ELEMENT(env, r3, 0, 0, 0) = r4;
	_JC_LINE_NUMBER(94);				// 5
	r3 = _JC_REF_FIELD(env, r0, javax_crypto_CipherOutputStream, inBuffer);
	r9 = _JC_REF_FIELD(env, r2, javax_crypto_Cipher, cipherSpi);
	if (r9 == _JC_NULL)
		goto label5;
	r9 = _JC_REF_FIELD(env, r2, javax_crypto_Cipher, cipherSpi);
	i3 = _JC_INVOKE_VIRTUAL(env, javax_crypto_CipherSpi, engineGetBlockSize$d4858c33205171e0, r9);
	i0 = i3;
	goto label6;

label5:
	i0 = 1;

label6:
	r4 = _JC_NEW_PRIM_ARRAY(env, byte, 1, i0);
	_JC_REF_ELEMENT(env, r3, 1, 0, 0) = r4;
	_JC_LINE_NUMBER(95);				// 6
	_JC_PRIM_FIELD(env, r0, javax_crypto_CipherOutputStream, inLength) = 0;
	_JC_LINE_NUMBER(96);				// 7
	_JC_PRIM_FIELD(env, r0, javax_crypto_CipherOutputStream, state) = 0;
	goto label8;

label7:
	_JC_LINE_NUMBER(100);				// 8
	r5 = _JC_NEW(env, javax_crypto_NullCipher);
	r6 = _JC_NEW(env, javax_crypto_NullCipherImpl);
	r10 = _JC_NULL;
	r11 = _JC_STRING(env, "NULL");
	_JC_REF_FIELD(env, r5, javax_crypto_Cipher, cipherSpi) = r6;
	_JC_REF_FIELD(env, r5, javax_crypto_Cipher, provider) = r10;
	_JC_REF_FIELD(env, r5, javax_crypto_Cipher, transformation) = r11;
	_JC_PRIM_FIELD(env, r5, javax_crypto_Cipher, state) = 0;
	_JC_REF_FIELD(env, r0, javax_crypto_CipherOutputStream, cipher) = r5;

label8:
	_JC_LINE_NUMBER(101);				// 9
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public void close() throws java.io.IOException
//

static _jc_linenum _jc_javax_crypto_CipherOutputStream$linenum_table$close$6aba8b329fddcd79[];

static _jc_trap_info _jc_javax_crypto_CipherOutputStream$trap_table$close$6aba8b329fddcd79[] = {
	_JC_TRAP(&_jc_javax_crypto_IllegalBlockSizeException$type, 1, 2),
	_JC_TRAP(&_jc_javax_crypto_BadPaddingException$type, 1, 2),
	_JC_TRAP(&_jc_javax_crypto_ShortBufferException$type, 1, 2),
};

static const unsigned char _jc_javax_crypto_CipherOutputStream$param_ptypes$close$6aba8b329fddcd79[] = { 
_JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_CipherOutputStream$exceptions$close$6aba8b329fddcd79[] = {
	&_jc_java_io_IOException$type
};

_jc_method _jc_javax_crypto_CipherOutputStream$method_info$close$6aba8b329fddcd79 = {
	.name=			"close",
	.signature=		"()V",
	.class=			&_jc_javax_crypto_CipherOutputStream$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_CipherOutputStream$param_ptypes$close$6aba8b329fddcd79,
	.signature_hash=	_JC_JLONG(0x6aba8b329fddcd79),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_javax_crypto_CipherOutputStream$method$close$6aba8b329fddcd79,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_CipherOutputStream$vtable, javax_crypto_CipherOutputStream.close$6aba8b329fddcd79) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_crypto_CipherOutputStream$exceptions$close$6aba8b329fddcd79,
	.u= { .exec= {
	  .trap_table_len=	3,
	  .trap_table=		_jc_javax_crypto_CipherOutputStream$trap_table$close$6aba8b329fddcd79,
	  .u= {
	    .linenum= {
	      .len=	11,
	      .table=	_jc_javax_crypto_CipherOutputStream$linenum_table$close$6aba8b329fddcd79
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_CipherOutputStream, close$6aba8b329fddcd79);

void _JC_JCNI_ATTR
_jc_javax_crypto_CipherOutputStream$method$close$6aba8b329fddcd79(_jc_env *const env, _jc_javax_crypto_CipherOutputStream$object *this)
{
	jint i0;
	jint i1;
	jint i2;
	struct _jc_javax_crypto_CipherOutputStream$object *r0;
	struct _jc_javax_crypto_Cipher$object *r1;
	struct _jc_javax_crypto_ShortBufferException$object *volatile r10;
	struct _jc_java_lang_VMThrowable$object *volatile r11;
	struct _jc_java_lang_VMThrowable$object *volatile r12;
	struct _jc_java_lang_VMThrowable$object *volatile r14;
	_jc_object_array *r2;
	_jc_byte_array *r3;
	_jc_byte_array *r4;
	struct _jc_java_io_OutputStream$object *r5;
	struct _jc_javax_crypto_IllegalBlockSizeException$object *volatile r6;
	struct _jc_java_io_IOException$object *volatile r7;
	struct _jc_java_lang_String$object *volatile r8;
	struct _jc_javax_crypto_BadPaddingException$object *volatile r9;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_javax_crypto_CipherOutputStream$method_info$close$6aba8b329fddcd79, &&label1, &&label2, &&label3);

	r0 = this;
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(131);				// 0
	i0 = _JC_PRIM_FIELD(env, r0, javax_crypto_CipherOutputStream, state);
	if (i0 == 0)
		goto label0;
	_JC_LINE_NUMBER(133);				// 1
	r1 = _JC_REF_FIELD(env, r0, javax_crypto_CipherOutputStream, cipher);
	r2 = _JC_REF_FIELD(env, r0, javax_crypto_CipherOutputStream, inBuffer);
	r3 = _JC_REF_ELEMENT(env, r2, 0, 0, 0);
	r2 = _JC_REF_FIELD(env, r0, javax_crypto_CipherOutputStream, inBuffer);
	r4 = _JC_REF_ELEMENT(env, r2, 0, 0, 0);
	i0 = _JC_ARRAY_LENGTH(env, r4);
	r4 = _JC_REF_FIELD(env, r0, javax_crypto_CipherOutputStream, outBuffer);
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	i1 = _JC_INVOKE_NONVIRTUAL(env, javax_crypto_Cipher, update$ae15e2d814f1cdb1, 0, r1, r3, 0, i0, r4, 0);
	_JC_LINE_NUMBER(134);				// 2
	r5 = _JC_REF_FIELD(env, r0, java_io_FilterOutputStream, out);
	r4 = _JC_REF_FIELD(env, r0, javax_crypto_CipherOutputStream, outBuffer);
	_JC_INVOKE_VIRTUAL(env, java_io_OutputStream, write$306a698343ec27e8, r5, r4, 0, i1);

label0:
	_JC_LINE_NUMBER(136);				// 3
	r1 = _JC_REF_FIELD(env, r0, javax_crypto_CipherOutputStream, cipher);
	r2 = _JC_REF_FIELD(env, r0, javax_crypto_CipherOutputStream, inBuffer);
	r4 = _JC_REF_ELEMENT(env, r2, 0, 0, 0);
	i0 = _JC_PRIM_FIELD(env, r0, javax_crypto_CipherOutputStream, inLength);
	r3 = _JC_REF_FIELD(env, r0, javax_crypto_CipherOutputStream, outBuffer);
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	i2 = _JC_INVOKE_NONVIRTUAL(env, javax_crypto_Cipher, doFinal$a67b3f796179b9a3, 0, r1, r4, 0, i0, r3, 0);
	_JC_LINE_NUMBER(137);				// 4
	r5 = _JC_REF_FIELD(env, r0, java_io_FilterOutputStream, out);
	r4 = _JC_REF_FIELD(env, r0, javax_crypto_CipherOutputStream, outBuffer);
	_JC_INVOKE_VIRTUAL(env, java_io_OutputStream, write$306a698343ec27e8, r5, r4, 0, i2);
	_JC_TRAP_REGION(catch, 2);
	goto label4;

label1:
	_JC_TRAP_REGION(catch, 2);
	r6 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(141);				// 5
	r7 = _JC_NEW(env, java_io_IOException);
	r8 = _JC_INVOKE_VIRTUAL(env, java_lang_Throwable, toString$7ea43b33b80a3070, r6);
	_JC_REF_FIELD(env, r7, java_lang_Throwable, cause) = r7;
	r11 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r7);
	_JC_REF_FIELD(env, r7, java_lang_Throwable, vmState) = r11;
	_JC_REF_FIELD(env, r7, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r7, java_lang_Throwable, detailMessage) = r8;
	_JC_THROW(env, r7);

label2:
	_JC_TRAP_REGION(catch, 2);
	r9 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(145);				// 6
	r7 = _JC_NEW(env, java_io_IOException);
	r8 = _JC_INVOKE_VIRTUAL(env, java_lang_Throwable, toString$7ea43b33b80a3070, r9);
	_JC_REF_FIELD(env, r7, java_lang_Throwable, cause) = r7;
	r12 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r7);
	_JC_REF_FIELD(env, r7, java_lang_Throwable, vmState) = r12;
	_JC_REF_FIELD(env, r7, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r7, java_lang_Throwable, detailMessage) = r8;
	_JC_THROW(env, r7);

label3:
	_JC_TRAP_REGION(catch, 2);
	r10 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(149);				// 7
	r7 = _JC_NEW(env, java_io_IOException);
	r8 = _JC_INVOKE_VIRTUAL(env, java_lang_Throwable, toString$7ea43b33b80a3070, r10);
	_JC_REF_FIELD(env, r7, java_lang_Throwable, cause) = r7;
	r14 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r7);
	_JC_REF_FIELD(env, r7, java_lang_Throwable, vmState) = r14;
	_JC_REF_FIELD(env, r7, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r7, java_lang_Throwable, detailMessage) = r8;
	_JC_THROW(env, r7);

label4:
	_JC_LINE_NUMBER(151);				// 8
	r5 = _JC_REF_FIELD(env, r0, java_io_FilterOutputStream, out);
	_JC_INVOKE_VIRTUAL(env, java_io_OutputStream, flush$9dedb7d85e88cf56, r5);
	_JC_LINE_NUMBER(152);				// 9
	r5 = _JC_REF_FIELD(env, r0, java_io_FilterOutputStream, out);
	_JC_INVOKE_VIRTUAL(env, java_io_OutputStream, close$6aba8b329fddcd79, r5);
	_JC_LINE_NUMBER(153);				// 10
	_JC_CANCEL_TRAPS(env, catch);
	return;
}

//
// public void flush() throws java.io.IOException
//

static _jc_linenum _jc_javax_crypto_CipherOutputStream$linenum_table$flush$9dedb7d85e88cf56[];

static const unsigned char _jc_javax_crypto_CipherOutputStream$param_ptypes$flush$9dedb7d85e88cf56[] = { 
_JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_CipherOutputStream$exceptions$flush$9dedb7d85e88cf56[] = {
	&_jc_java_io_IOException$type
};

_jc_method _jc_javax_crypto_CipherOutputStream$method_info$flush$9dedb7d85e88cf56 = {
	.name=			"flush",
	.signature=		"()V",
	.class=			&_jc_javax_crypto_CipherOutputStream$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_CipherOutputStream$param_ptypes$flush$9dedb7d85e88cf56,
	.signature_hash=	_JC_JLONG(0x9dedb7d85e88cf56),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_javax_crypto_CipherOutputStream$method$flush$9dedb7d85e88cf56,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_CipherOutputStream$vtable, javax_crypto_CipherOutputStream.flush$9dedb7d85e88cf56) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_crypto_CipherOutputStream$exceptions$flush$9dedb7d85e88cf56,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_javax_crypto_CipherOutputStream$linenum_table$flush$9dedb7d85e88cf56
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_CipherOutputStream, flush$9dedb7d85e88cf56);

void _JC_JCNI_ATTR
_jc_javax_crypto_CipherOutputStream$method$flush$9dedb7d85e88cf56(_jc_env *const env, _jc_javax_crypto_CipherOutputStream$object *this)
{
	struct _jc_javax_crypto_CipherOutputStream$object *r0;
	struct _jc_java_io_OutputStream$object *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(162);				// 0
	r1 = _JC_REF_FIELD(env, r0, java_io_FilterOutputStream, out);
	_JC_INVOKE_VIRTUAL(env, java_io_OutputStream, flush$9dedb7d85e88cf56, r1);
	_JC_LINE_NUMBER(163);				// 1
	return;
}

//
// private final void process() throws java.io.IOException
//

static _jc_linenum _jc_javax_crypto_CipherOutputStream$linenum_table$process$20c177568351a84e[];

static _jc_trap_info _jc_javax_crypto_CipherOutputStream$trap_table$process$20c177568351a84e[] = {
	_JC_TRAP(&_jc_javax_crypto_ShortBufferException$type, 1, 2),
};

static const unsigned char _jc_javax_crypto_CipherOutputStream$param_ptypes$process$20c177568351a84e[] = { 
_JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_CipherOutputStream$exceptions$process$20c177568351a84e[] = {
	&_jc_java_io_IOException$type
};

_jc_method _jc_javax_crypto_CipherOutputStream$method_info$process$20c177568351a84e = {
	.name=			"process",
	.signature=		"()V",
	.class=			&_jc_javax_crypto_CipherOutputStream$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_CipherOutputStream$param_ptypes$process$20c177568351a84e,
	.signature_hash=	_JC_JLONG(0x20c177568351a84e),
	.access_flags=		_JC_ACC_PRIVATE|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_CipherOutputStream$method$process$20c177568351a84e,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_CipherOutputStream$vtable, javax_crypto_CipherOutputStream.process$20c177568351a84e) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_crypto_CipherOutputStream$exceptions$process$20c177568351a84e,
	.u= { .exec= {
	  .trap_table_len=	1,
	  .trap_table=		_jc_javax_crypto_CipherOutputStream$trap_table$process$20c177568351a84e,
	  .u= {
	    .linenum= {
	      .len=	14,
	      .table=	_jc_javax_crypto_CipherOutputStream$linenum_table$process$20c177568351a84e
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_CipherOutputStream, process$20c177568351a84e);

void _JC_JCNI_ATTR
_jc_javax_crypto_CipherOutputStream$method$process$20c177568351a84e(_jc_env *const env, _jc_javax_crypto_CipherOutputStream$object *this)
{
	jint i0;
	struct _jc_javax_crypto_CipherOutputStream$object *r0;
	_jc_byte_array *r1;
	struct _jc_java_lang_VMThrowable$object *volatile r11;
	_jc_object_array *r2;
	_jc_object_array *r3;
	_jc_byte_array *r4;
	struct _jc_javax_crypto_Cipher$object *r5;
	struct _jc_javax_crypto_ShortBufferException$object *volatile r6;
	struct _jc_java_io_IOException$object *volatile r7;
	struct _jc_java_lang_String$object *volatile r8;
	struct _jc_java_io_OutputStream$object *r9;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_javax_crypto_CipherOutputStream$method_info$process$20c177568351a84e, &&label3);

	r0 = this;
	_JC_LINE_NUMBER(241);				// 0
	i0 = _JC_PRIM_FIELD(env, r0, javax_crypto_CipherOutputStream, state);
	if (i0 != 1)
		goto label0;
	_JC_LINE_NUMBER(243);				// 1
	_JC_PRIM_FIELD(env, r0, javax_crypto_CipherOutputStream, state) = 2;
	goto label1;

label0:
	_JC_LINE_NUMBER(247);				// 2
	r2 = _JC_REF_FIELD(env, r0, javax_crypto_CipherOutputStream, inBuffer);
	r1 = _JC_REF_ELEMENT(env, r2, 0, 0, 0);
	_JC_LINE_NUMBER(248);				// 3
	r2 = _JC_REF_FIELD(env, r0, javax_crypto_CipherOutputStream, inBuffer);
	r3 = _JC_REF_FIELD(env, r0, javax_crypto_CipherOutputStream, inBuffer);
	r4 = _JC_REF_ELEMENT(env, r3, 1, 0, 0);
	_JC_REF_ELEMENT(env, r2, 0, 0, 0) = r4;
	_JC_LINE_NUMBER(249);				// 4
	r3 = _JC_REF_FIELD(env, r0, javax_crypto_CipherOutputStream, inBuffer);
	_JC_REF_ELEMENT(env, r3, 1, 0, 0) = r1;

label1:
	_JC_LINE_NUMBER(251);				// 5
	i0 = _JC_PRIM_FIELD(env, r0, javax_crypto_CipherOutputStream, state);
	if (i0 != 0)
		goto label2;
	_JC_LINE_NUMBER(253);				// 6
	_JC_PRIM_FIELD(env, r0, javax_crypto_CipherOutputStream, inLength) = 0;
	_JC_LINE_NUMBER(254);				// 7
	_JC_PRIM_FIELD(env, r0, javax_crypto_CipherOutputStream, state) = 1;
	_JC_LINE_NUMBER(255);				// 8
	_JC_CANCEL_TRAPS(env, catch);
	return;

label2:
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(259);				// 9
	r5 = _JC_REF_FIELD(env, r0, javax_crypto_CipherOutputStream, cipher);
	r3 = _JC_REF_FIELD(env, r0, javax_crypto_CipherOutputStream, inBuffer);
	r4 = _JC_REF_ELEMENT(env, r3, 0, 0, 0);
	r3 = _JC_REF_FIELD(env, r0, javax_crypto_CipherOutputStream, inBuffer);
	r1 = _JC_REF_ELEMENT(env, r3, 0, 0, 0);
	i0 = _JC_ARRAY_LENGTH(env, r1);
	r1 = _JC_REF_FIELD(env, r0, javax_crypto_CipherOutputStream, outBuffer);
	_JC_EXPLICIT_NULL_CHECK(env, r5);
	_JC_INVOKE_NONVIRTUAL(env, javax_crypto_Cipher, update$ae15e2d814f1cdb1, 0, r5, r4, 0, i0, r1, 0);
	_JC_TRAP_REGION(catch, 2);
	goto label4;

label3:
	_JC_TRAP_REGION(catch, 2);
	r6 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(263);				// 10
	r7 = _JC_NEW(env, java_io_IOException);
	r8 = _JC_INVOKE_VIRTUAL(env, java_lang_Throwable, toString$7ea43b33b80a3070, r6);
	_JC_REF_FIELD(env, r7, java_lang_Throwable, cause) = r7;
	r11 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r7);
	_JC_REF_FIELD(env, r7, java_lang_Throwable, vmState) = r11;
	_JC_REF_FIELD(env, r7, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r7, java_lang_Throwable, detailMessage) = r8;
	_JC_THROW(env, r7);

label4:
	_JC_LINE_NUMBER(265);				// 11
	r9 = _JC_REF_FIELD(env, r0, java_io_FilterOutputStream, out);
	r4 = _JC_REF_FIELD(env, r0, javax_crypto_CipherOutputStream, outBuffer);
	_JC_INVOKE_VIRTUAL(env, java_io_OutputStream, write$18e189e8fc25f121, r9, r4);
	_JC_LINE_NUMBER(266);				// 12
	_JC_PRIM_FIELD(env, r0, javax_crypto_CipherOutputStream, inLength) = 0;
	_JC_LINE_NUMBER(267);				// 13
	_JC_CANCEL_TRAPS(env, catch);
	return;
}

//
// public void write(int) throws java.io.IOException
//

static _jc_linenum _jc_javax_crypto_CipherOutputStream$linenum_table$write$6377ac6964854eb2[];

static _jc_trap_info _jc_javax_crypto_CipherOutputStream$trap_table$write$6377ac6964854eb2[] = {
	_JC_TRAP(&_jc_javax_crypto_ShortBufferException$type, 1, 2),
};

static const unsigned char _jc_javax_crypto_CipherOutputStream$param_ptypes$write$6377ac6964854eb2[] = { 
_JC_TYPE_INT, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_CipherOutputStream$exceptions$write$6377ac6964854eb2[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_javax_crypto_CipherOutputStream$param_types$write$6377ac6964854eb2[] = {
	&_jc_int$prim$type
};

_jc_method _jc_javax_crypto_CipherOutputStream$method_info$write$6377ac6964854eb2 = {
	.name=			"write",
	.signature=		"(I)V",
	.class=			&_jc_javax_crypto_CipherOutputStream$type,
	.param_types=		&_jc_javax_crypto_CipherOutputStream$param_types$write$6377ac6964854eb2,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_CipherOutputStream$param_ptypes$write$6377ac6964854eb2,
	.signature_hash=	_JC_JLONG(0x6377ac6964854eb2),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_javax_crypto_CipherOutputStream$method$write$6377ac6964854eb2,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_CipherOutputStream$vtable, javax_crypto_CipherOutputStream.write$6377ac6964854eb2) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_crypto_CipherOutputStream$exceptions$write$6377ac6964854eb2,
	.u= { .exec= {
	  .trap_table_len=	1,
	  .trap_table=		_jc_javax_crypto_CipherOutputStream$trap_table$write$6377ac6964854eb2,
	  .u= {
	    .linenum= {
	      .len=	10,
	      .table=	_jc_javax_crypto_CipherOutputStream$linenum_table$write$6377ac6964854eb2
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_CipherOutputStream, write$6377ac6964854eb2);

void _JC_JCNI_ATTR
_jc_javax_crypto_CipherOutputStream$method$write$6377ac6964854eb2(_jc_env *const env, _jc_javax_crypto_CipherOutputStream$object *this, jint param0)
{
	jbyte b1;
	jint i0;
	jint i2;
	jint i3;
	struct _jc_javax_crypto_CipherOutputStream$object *r0;
	_jc_byte_array *r1;
	struct _jc_javax_crypto_ShortBufferException$object *volatile r2;
	struct _jc_javax_crypto_Cipher$object *r3;
	struct _jc_java_io_IOException$object *volatile r4;
	struct _jc_java_lang_String$object *volatile r5;
	struct _jc_java_io_OutputStream$object *r6;
	_jc_object_array *r7;
	struct _jc_java_lang_VMThrowable$object *volatile r9;
	jboolean z0;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_javax_crypto_CipherOutputStream$method_info$write$6377ac6964854eb2, &&label0);

	r0 = this;
	i0 = param0;
	_JC_LINE_NUMBER(175);				// 0
	z0 = _JC_PRIM_FIELD(env, r0, javax_crypto_CipherOutputStream, isStream);
	if (z0 == 0)
		goto label2;
	_JC_LINE_NUMBER(177);				// 1
	r1 = _JC_NEW_PRIM_ARRAY(env, byte, 1, 1);
	b1 = (jbyte)i0;
	_JC_PRIM_ELEMENT(env, byte, r1, 0, 0, 0) = b1;
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(180);				// 2
	r3 = _JC_REF_FIELD(env, r0, javax_crypto_CipherOutputStream, cipher);
	_JC_INVOKE_NONVIRTUAL(env, javax_crypto_Cipher, update$ae15e2d814f1cdb1, 1, r3, r1, 0, 1, r1, 0);
	_JC_TRAP_REGION(catch, 2);
	goto label1;

label0:
	_JC_TRAP_REGION(catch, 2);
	r2 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(184);				// 3
	r4 = _JC_NEW(env, java_io_IOException);
	r5 = _JC_INVOKE_VIRTUAL(env, java_lang_Throwable, toString$7ea43b33b80a3070, r2);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r9 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r9;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r5;
	_JC_THROW(env, r4);

label1:
	_JC_LINE_NUMBER(186);				// 4
	r6 = _JC_REF_FIELD(env, r0, java_io_FilterOutputStream, out);
	_JC_INVOKE_VIRTUAL(env, java_io_OutputStream, write$18e189e8fc25f121, r6, r1);
	_JC_LINE_NUMBER(187);				// 5
	_JC_CANCEL_TRAPS(env, catch);
	return;

label2:
	_JC_TRAP_REGION(catch, 2);
	_JC_LINE_NUMBER(189);				// 6
	r7 = _JC_REF_FIELD(env, r0, javax_crypto_CipherOutputStream, inBuffer);
	r1 = _JC_REF_ELEMENT(env, r7, 1, 0, 0);
	i2 = _JC_PRIM_FIELD(env, r0, javax_crypto_CipherOutputStream, inLength);
	i3 = i2 + 1;
	_JC_PRIM_FIELD(env, r0, javax_crypto_CipherOutputStream, inLength) = i3;
	b1 = (jbyte)i0;
	_JC_PRIM_ELEMENT(env, byte, r1, i2, 1, 1) = b1;
	_JC_LINE_NUMBER(190);				// 7
	i3 = _JC_PRIM_FIELD(env, r0, javax_crypto_CipherOutputStream, inLength);
	r7 = _JC_REF_FIELD(env, r0, javax_crypto_CipherOutputStream, inBuffer);
	r1 = _JC_REF_ELEMENT(env, r7, 1, 0, 0);
	i2 = _JC_ARRAY_LENGTH(env, r1);
	if (i3 != i2)
		goto label3;
	_JC_LINE_NUMBER(191);				// 8
	_JC_INVOKE_NONVIRTUAL(env, javax_crypto_CipherOutputStream, process$20c177568351a84e, 0, r0);

label3:
	_JC_LINE_NUMBER(192);				// 9
	_JC_CANCEL_TRAPS(env, catch);
	return;
}

//
// public void write(byte[]) throws java.io.IOException
//

static _jc_linenum _jc_javax_crypto_CipherOutputStream$linenum_table$write$18e189e8fc25f121[];

static const unsigned char _jc_javax_crypto_CipherOutputStream$param_ptypes$write$18e189e8fc25f121[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_CipherOutputStream$exceptions$write$18e189e8fc25f121[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_javax_crypto_CipherOutputStream$param_types$write$18e189e8fc25f121[] = {
	&_jc_byte$array$prim$type
};

_jc_method _jc_javax_crypto_CipherOutputStream$method_info$write$18e189e8fc25f121 = {
	.name=			"write",
	.signature=		"([B)V",
	.class=			&_jc_javax_crypto_CipherOutputStream$type,
	.param_types=		&_jc_javax_crypto_CipherOutputStream$param_types$write$18e189e8fc25f121,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_CipherOutputStream$param_ptypes$write$18e189e8fc25f121,
	.signature_hash=	_JC_JLONG(0x18e189e8fc25f121),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_javax_crypto_CipherOutputStream$method$write$18e189e8fc25f121,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_CipherOutputStream$vtable, javax_crypto_CipherOutputStream.write$18e189e8fc25f121) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_crypto_CipherOutputStream$exceptions$write$18e189e8fc25f121,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_javax_crypto_CipherOutputStream$linenum_table$write$18e189e8fc25f121
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_CipherOutputStream, write$18e189e8fc25f121);

void _JC_JCNI_ATTR
_jc_javax_crypto_CipherOutputStream$method$write$18e189e8fc25f121(_jc_env *const env, _jc_javax_crypto_CipherOutputStream$object *this, _jc_byte_array *param0)
{
	jint i0;
	struct _jc_javax_crypto_CipherOutputStream$object *r0;
	_jc_byte_array *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(204);				// 0
	i0 = _JC_ARRAY_LENGTH(env, r1);
	_JC_INVOKE_VIRTUAL(env, javax_crypto_CipherOutputStream, write$306a698343ec27e8, r0, r1, 0, i0);
	_JC_LINE_NUMBER(205);				// 1
	return;
}

//
// public void write(byte[], int, int) throws java.io.IOException
//

static _jc_linenum _jc_javax_crypto_CipherOutputStream$linenum_table$write$306a698343ec27e8[];

static const unsigned char _jc_javax_crypto_CipherOutputStream$param_ptypes$write$306a698343ec27e8[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_INT, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_CipherOutputStream$exceptions$write$306a698343ec27e8[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_javax_crypto_CipherOutputStream$param_types$write$306a698343ec27e8[] = {
	&_jc_byte$array$prim$type,
	&_jc_int$prim$type,
	&_jc_int$prim$type
};

_jc_method _jc_javax_crypto_CipherOutputStream$method_info$write$306a698343ec27e8 = {
	.name=			"write",
	.signature=		"([BII)V",
	.class=			&_jc_javax_crypto_CipherOutputStream$type,
	.param_types=		&_jc_javax_crypto_CipherOutputStream$param_types$write$306a698343ec27e8,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_CipherOutputStream$param_ptypes$write$306a698343ec27e8,
	.signature_hash=	_JC_JLONG(0x306a698343ec27e8),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_javax_crypto_CipherOutputStream$method$write$306a698343ec27e8,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_CipherOutputStream$vtable, javax_crypto_CipherOutputStream.write$306a698343ec27e8) / sizeof(void *),
	.num_parameters=	3,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_crypto_CipherOutputStream$exceptions$write$306a698343ec27e8,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	13,
	      .table=	_jc_javax_crypto_CipherOutputStream$linenum_table$write$306a698343ec27e8
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_CipherOutputStream, write$306a698343ec27e8);

void _JC_JCNI_ATTR
_jc_javax_crypto_CipherOutputStream$method$write$306a698343ec27e8(_jc_env *const env, _jc_javax_crypto_CipherOutputStream$object *this, _jc_byte_array *param0, jint param1, jint param2)
{
	jint i0;
	jint i1;
	jint i2;
	jint i3;
	jint i4;
	jint i5;
	jint i7;
	struct _jc_javax_crypto_CipherOutputStream$object *r0;
	_jc_byte_array *r1;
	struct _jc_java_io_OutputStream$object *r2;
	struct _jc_javax_crypto_Cipher$object *r3;
	_jc_object_array *r4;
	_jc_byte_array *r5;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	i0 = param1;
	i1 = param2;
	_JC_LINE_NUMBER(219);				// 0
	z0 = _JC_PRIM_FIELD(env, r0, javax_crypto_CipherOutputStream, isStream);
	if (z0 == 0)
		goto label0;
	_JC_LINE_NUMBER(221);				// 1
	r2 = _JC_REF_FIELD(env, r0, java_io_FilterOutputStream, out);
	r3 = _JC_REF_FIELD(env, r0, javax_crypto_CipherOutputStream, cipher);
	r1 = _JC_INVOKE_NONVIRTUAL(env, javax_crypto_Cipher, update$4cdb664eeb721f0a, 1, r3, r1, i0, i1);
	_JC_INVOKE_VIRTUAL(env, java_io_OutputStream, write$18e189e8fc25f121, r2, r1);
	_JC_LINE_NUMBER(222);				// 2
	return;

label0:
	_JC_LINE_NUMBER(224);				// 3
	i2 = 0;
	_JC_LINE_NUMBER(225);				// 4
	goto label4;

label1:
	_JC_LINE_NUMBER(227);				// 5
	r4 = _JC_REF_FIELD(env, r0, javax_crypto_CipherOutputStream, inBuffer);
	r5 = _JC_REF_ELEMENT(env, r4, 1, 0, 0);
	i3 = _JC_ARRAY_LENGTH(env, r5);
	i4 = _JC_PRIM_FIELD(env, r0, javax_crypto_CipherOutputStream, inLength);
	i4 = i3 - i4;
	i3 = i1 - i2;
	_JC_ACTIVE_USE(env, java_lang_Math);
	if (i4 >= i3)
		goto label2;
	i7 = i4;
	goto label3;

label2:
	i7 = i3;

label3:
	_JC_LINE_NUMBER(228);				// 6
	i4 = i0 + i2;
	r4 = _JC_REF_FIELD(env, r0, javax_crypto_CipherOutputStream, inBuffer);
	r5 = _JC_REF_ELEMENT(env, r4, 1, 0, 0);
	i5 = _JC_PRIM_FIELD(env, r0, javax_crypto_CipherOutputStream, inLength);
	_JC_ACTIVE_USE(env, java_lang_System);
	_JC_INVOKE_STATIC(env, java_lang_VMSystem, arraycopy$4286a72d57744cd8, 0, r1, i4, r5, i5, i7);
	_JC_LINE_NUMBER(229);				// 7
	i2 = i2 + i7;
	_JC_LINE_NUMBER(230);				// 8
	i5 = _JC_PRIM_FIELD(env, r0, javax_crypto_CipherOutputStream, inLength);
	i5 = i5 + i7;
	_JC_PRIM_FIELD(env, r0, javax_crypto_CipherOutputStream, inLength) = i5;
	_JC_LINE_NUMBER(231);				// 9
	i5 = _JC_PRIM_FIELD(env, r0, javax_crypto_CipherOutputStream, inLength);
	r4 = _JC_REF_FIELD(env, r0, javax_crypto_CipherOutputStream, inBuffer);
	r5 = _JC_REF_ELEMENT(env, r4, 1, 0, 0);
	i4 = _JC_ARRAY_LENGTH(env, r5);
	if (i5 != i4)
		goto label4;
	_JC_LINE_NUMBER(232);				// 10
	_JC_INVOKE_NONVIRTUAL(env, javax_crypto_CipherOutputStream, process$20c177568351a84e, 0, r0);

label4:
	_JC_LINE_NUMBER(225);				// 11
	if (i2 < i1) {
		_JC_PERIODIC_CHECK(env);
		goto label1;
	}
	_JC_LINE_NUMBER(234);				// 12
	return;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_javax_crypto_CipherOutputStream$methods[] = {
	&_jc_javax_crypto_CipherOutputStream$method_info$_init$8b48f276bbc2c828,
	&_jc_javax_crypto_CipherOutputStream$method_info$_init$91ab559d46dbb5ca,
	&_jc_javax_crypto_CipherOutputStream$method_info$close$6aba8b329fddcd79,
	&_jc_javax_crypto_CipherOutputStream$method_info$flush$9dedb7d85e88cf56,
	&_jc_javax_crypto_CipherOutputStream$method_info$process$20c177568351a84e,
	&_jc_javax_crypto_CipherOutputStream$method_info$write$6377ac6964854eb2,
	&_jc_javax_crypto_CipherOutputStream$method_info$write$18e189e8fc25f121,
	&_jc_javax_crypto_CipherOutputStream$method_info$write$306a698343ec27e8
};

/************************************************************************
 *			  Class fields structure			*
 ************************************************************************/

_jc_javax_crypto_CipherOutputStream$fields_struct _jc_javax_crypto_CipherOutputStream$class_fields = { };

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_javax_crypto_CipherOutputStream$instanceof_hash_bucket_82[] = {
	&_jc_javax_crypto_CipherOutputStream$type,
	_JC_NULL
};
static _jc_type *const _jc_javax_crypto_CipherOutputStream$instanceof_hash_bucket_88[] = {
	&_jc_java_io_OutputStream$type,
	_JC_NULL
};
static _jc_type *const _jc_javax_crypto_CipherOutputStream$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};
static _jc_type *const _jc_javax_crypto_CipherOutputStream$instanceof_hash_bucket_110[] = {
	&_jc_java_io_FilterOutputStream$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_javax_crypto_CipherOutputStream$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[82]=	_jc_javax_crypto_CipherOutputStream$instanceof_hash_bucket_82,
	[88]=	_jc_javax_crypto_CipherOutputStream$instanceof_hash_bucket_88,
	[101]=	_jc_javax_crypto_CipherOutputStream$instanceof_hash_bucket_101,
	[110]=	_jc_javax_crypto_CipherOutputStream$instanceof_hash_bucket_110
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_javax_crypto_CipherOutputStream$class_depends[] = {
	{ "java/io/FilterOutputStream",	_JC_JLONG(0xfddb41323d9c4cee) },
	{ "java/io/IOException",	_JC_JLONG(0x4e0a56550c69d57c) },
	{ "java/io/OutputStream",	_JC_JLONG(0x4026d3144d6654d8) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/Math",	_JC_JLONG(0x8d71d806a180ad8a) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/System",	_JC_JLONG(0x53cc8e2333795f04) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMSystem",	_JC_JLONG(0x4d1cebae0bdda058) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/security/Provider",	_JC_JLONG(0x81b073051aa30acc) },
	{ "javax/crypto/BadPaddingException",	_JC_JLONG(0xd214adbc7b3842af) },
	{ "javax/crypto/Cipher",	_JC_JLONG(0x4bdfff9ea145d6ce) },
	{ "javax/crypto/CipherSpi",	_JC_JLONG(0x4422f11229f63761) },
	{ "javax/crypto/IllegalBlockSizeException",	_JC_JLONG(0xe7376936288e78db) },
	{ "javax/crypto/NullCipher",	_JC_JLONG(0xb2745a2f83ab7f25) },
	{ "javax/crypto/NullCipherImpl",	_JC_JLONG(0x567ce2b1db0e5e22) },
	{ "javax/crypto/ShortBufferException",	_JC_JLONG(0xd79a62a9328ccea1) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_javax_crypto_CipherOutputStream$vtype _jc_javax_crypto_CipherOutputStream$type = {
    .type= {
	.name=			"javax/crypto/CipherOutputStream",
	.superclass=		&_jc_java_io_FilterOutputStream$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		27,
		.hash=			_JC_JLONG(0xdd878b079c781d52),
		.source_file=		"CipherOutputStream.java",
		.instance_size=		sizeof(_jc_javax_crypto_CipherOutputStream$refs) + sizeof(_jc_javax_crypto_CipherOutputStream$object),
		.num_virtual_refs=	4,
		.num_fields=		sizeof(_jc_javax_crypto_CipherOutputStream$fields) / sizeof(*_jc_javax_crypto_CipherOutputStream$fields),
		.fields=		_jc_javax_crypto_CipherOutputStream$fields,
		.num_methods=		sizeof(_jc_javax_crypto_CipherOutputStream$methods) / sizeof(*_jc_javax_crypto_CipherOutputStream$methods),
		.methods=		_jc_javax_crypto_CipherOutputStream$methods,
		.instanceof_hash_table=	_jc_javax_crypto_CipherOutputStream$instanceof_hash_table,
		.class_fields=		&_jc_javax_crypto_CipherOutputStream$class_fields,
		.num_class_depends=		sizeof(_jc_javax_crypto_CipherOutputStream$class_depends) / sizeof(*_jc_javax_crypto_CipherOutputStream$class_depends),
		.class_depends=		_jc_javax_crypto_CipherOutputStream$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.java_io_OutputStream= {
	    .close$6aba8b329fddcd79=			// overridden
		&_jc_javax_crypto_CipherOutputStream$method$close$6aba8b329fddcd79,
	    .flush$9dedb7d85e88cf56=			// overridden
		&_jc_javax_crypto_CipherOutputStream$method$flush$9dedb7d85e88cf56,
	    .write$6377ac6964854eb2=			// overridden
		&_jc_javax_crypto_CipherOutputStream$method$write$6377ac6964854eb2,
	    .write$18e189e8fc25f121=			// overridden
		&_jc_javax_crypto_CipherOutputStream$method$write$18e189e8fc25f121,
	    .write$306a698343ec27e8=			// overridden
		&_jc_javax_crypto_CipherOutputStream$method$write$306a698343ec27e8,
	},
	.java_io_FilterOutputStream= {
	    .close$6aba8b329fddcd79=			// overridden
		&_jc_javax_crypto_CipherOutputStream$method$close$6aba8b329fddcd79,
	    .flush$9dedb7d85e88cf56=			// overridden
		&_jc_javax_crypto_CipherOutputStream$method$flush$9dedb7d85e88cf56,
	    .write$6377ac6964854eb2=			// overridden
		&_jc_javax_crypto_CipherOutputStream$method$write$6377ac6964854eb2,
	    .write$18e189e8fc25f121=			// overridden
		&_jc_javax_crypto_CipherOutputStream$method$write$18e189e8fc25f121,
	    .write$306a698343ec27e8=			// overridden
		&_jc_javax_crypto_CipherOutputStream$method$write$306a698343ec27e8,
	},
	.javax_crypto_CipherOutputStream= {
	    .close$6aba8b329fddcd79=
		&_jc_javax_crypto_CipherOutputStream$method$close$6aba8b329fddcd79,
	    .flush$9dedb7d85e88cf56=
		&_jc_javax_crypto_CipherOutputStream$method$flush$9dedb7d85e88cf56,
	    .process$20c177568351a84e=
		&_jc_javax_crypto_CipherOutputStream$method$process$20c177568351a84e,
	    .write$6377ac6964854eb2=
		&_jc_javax_crypto_CipherOutputStream$method$write$6377ac6964854eb2,
	    .write$18e189e8fc25f121=
		&_jc_javax_crypto_CipherOutputStream$method$write$18e189e8fc25f121,
	    .write$306a698343ec27e8=
		&_jc_javax_crypto_CipherOutputStream$method$write$306a698343ec27e8,
	},
    }
};

