// public class javax.crypto.ExemptionMechanism

// class file dependencies
// @dep_class f4ba095546954b36 gnu_java_security_Engine
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class f02ab3ccb490a6d0 java_lang_ClassCastException
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class b7e704701c278e65 java_lang_IllegalStateException
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class 4f5534a987354d1d java_lang_RuntimeException
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class ae4a2342b31a268d java_lang_reflect_InvocationTargetException
// @dep_class 814794c0d977019 java_security_AlgorithmParameters
// @dep_class 692089051f4c8d0b java_security_GeneralSecurityException
// @dep_class 327edce29f2562dd java_security_InvalidAlgorithmParameterException
// @dep_class 94dda41e9bf6c170 java_security_InvalidKeyException
// @dep_class a467c6cd05d9cc51 java_security_Key
// @dep_class 22e937c2536160b4 java_security_NoSuchAlgorithmException
// @dep_class 8dfbf242adab91e java_security_NoSuchProviderException
// @dep_class 81b073051aa30acc java_security_Provider
// @dep_class 89bf77984bd9669e java_security_Security
// @dep_class ef2e5e8af121478f java_security_spec_AlgorithmParameterSpec
// @dep_class c53e1575b095109b java_util_Vector
// @dep_class 9390fe3e28a7a8c5 javax_crypto_ExemptionMechanism
// @dep_class fe35024cc7ae0d53 javax_crypto_ExemptionMechanismException
// @dep_class ed16a6ca818003e8 javax_crypto_ExemptionMechanismSpi
// @dep_class d79a62a9328ccea1 javax_crypto_ShortBufferException

// header file dependencies
// @dep_header gnu_java_security_Engine
// @dep_header java_lang_Class
// @dep_header java_lang_ClassCastException
// @dep_header java_lang_IllegalStateException
// @dep_header java_lang_String
// @dep_header java_lang_VMThrowable
// @dep_header java_lang_reflect_InvocationTargetException
// @dep_header java_security_AlgorithmParameters
// @dep_header java_security_InvalidAlgorithmParameterException
// @dep_header java_security_InvalidKeyException
// @dep_header java_security_Key
// @dep_header java_security_NoSuchAlgorithmException
// @dep_header java_security_NoSuchProviderException
// @dep_header java_security_Provider
// @dep_header java_security_Security
// @dep_header java_security_spec_AlgorithmParameterSpec
// @dep_header java_util_Vector
// @dep_header javax_crypto_ExemptionMechanism
// @dep_header javax_crypto_ExemptionMechanismException
// @dep_header javax_crypto_ExemptionMechanismSpi
// @dep_header javax_crypto_ShortBufferException

#include "jc_defs.h"

#include "gnu/java/security/Engine.h"
#include "java/lang/Class.h"
#include "java/lang/ClassCastException.h"
#include "java/lang/IllegalStateException.h"
#include "java/lang/String.h"
#include "java/lang/VMThrowable.h"
#include "java/lang/reflect/InvocationTargetException.h"
#include "java/security/AlgorithmParameters.h"
#include "java/security/InvalidAlgorithmParameterException.h"
#include "java/security/InvalidKeyException.h"
#include "java/security/Key.h"
#include "java/security/NoSuchAlgorithmException.h"
#include "java/security/NoSuchProviderException.h"
#include "java/security/Provider.h"
#include "java/security/Security.h"
#include "java/security/spec/AlgorithmParameterSpec.h"
#include "java/util/Vector.h"
#include "javax/crypto/ExemptionMechanism.h"
#include "javax/crypto/ExemptionMechanismException.h"
#include "javax/crypto/ExemptionMechanismSpi.h"
#include "javax/crypto/ShortBufferException.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// private static final java.lang.String SERVICE
static _jc_field _jc_javax_crypto_ExemptionMechanism$field_info$SERVICE = {
	.name=		"SERVICE",
	.signature=	"Ljava/lang/String;",
	.class=		&_jc_javax_crypto_ExemptionMechanism$type,
	.type=		&_jc_java_lang_String$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_ExemptionMechanism$fields_struct, SERVICE),
	.initial_value=	"ExemptionMechanism",
};

// private javax.crypto.ExemptionMechanismSpi emSpi
static _jc_field _jc_javax_crypto_ExemptionMechanism$field_info$emSpi = {
	.name=		"emSpi",
	.signature=	"Ljavax/crypto/ExemptionMechanismSpi;",
	.class=		&_jc_javax_crypto_ExemptionMechanism$type,
	.type=		&_jc_javax_crypto_ExemptionMechanismSpi$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_ExemptionMechanism$object, refs[-1].javax_crypto_ExemptionMechanism.emSpi),
};

// private java.security.Provider provider
static _jc_field _jc_javax_crypto_ExemptionMechanism$field_info$provider = {
	.name=		"provider",
	.signature=	"Ljava/security/Provider;",
	.class=		&_jc_javax_crypto_ExemptionMechanism$type,
	.type=		&_jc_java_security_Provider$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_ExemptionMechanism$object, refs[-1].javax_crypto_ExemptionMechanism.provider),
};

// private java.lang.String mechanism
static _jc_field _jc_javax_crypto_ExemptionMechanism$field_info$mechanism = {
	.name=		"mechanism",
	.signature=	"Ljava/lang/String;",
	.class=		&_jc_javax_crypto_ExemptionMechanism$type,
	.type=		&_jc_java_lang_String$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_ExemptionMechanism$object, refs[-1].javax_crypto_ExemptionMechanism.mechanism),
};

// private boolean virgin
static _jc_field _jc_javax_crypto_ExemptionMechanism$field_info$virgin = {
	.name=		"virgin",
	.signature=	"Z",
	.class=		&_jc_javax_crypto_ExemptionMechanism$type,
	.type=		&_jc_boolean$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_ExemptionMechanism$object, nonrefs.javax_crypto_ExemptionMechanism.virgin),
};

// Fields
static _jc_field *const _jc_javax_crypto_ExemptionMechanism$fields[] = {
	&_jc_javax_crypto_ExemptionMechanism$field_info$SERVICE,
	&_jc_javax_crypto_ExemptionMechanism$field_info$emSpi,
	&_jc_javax_crypto_ExemptionMechanism$field_info$mechanism,
	&_jc_javax_crypto_ExemptionMechanism$field_info$provider,
	&_jc_javax_crypto_ExemptionMechanism$field_info$virgin
};

/************************************************************************
 *			      Static methods				*
 ************************************************************************/

//
// public static final javax.crypto.ExemptionMechanism getInstance(java.lang.String) throws java.security.NoSuchAlgorithmException
//

static _jc_linenum _jc_javax_crypto_ExemptionMechanism$linenum_table$getInstance$2dedc673d1f49019[];

static _jc_trap_info _jc_javax_crypto_ExemptionMechanism$trap_table$getInstance$2dedc673d1f49019[] = {
	_JC_TRAP(&_jc_java_security_NoSuchAlgorithmException$type, 1, 2),
};

static const unsigned char _jc_javax_crypto_ExemptionMechanism$param_ptypes$getInstance$2dedc673d1f49019[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_javax_crypto_ExemptionMechanism$exceptions$getInstance$2dedc673d1f49019[] = {
	&_jc_java_security_NoSuchAlgorithmException$type
};

static _jc_type *const _jc_javax_crypto_ExemptionMechanism$param_types$getInstance$2dedc673d1f49019[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_javax_crypto_ExemptionMechanism$method_info$getInstance$2dedc673d1f49019 = {
	.name=			"getInstance",
	.signature=		"(Ljava/lang/String;)Ljavax/crypto/ExemptionMechanism;",
	.class=			&_jc_javax_crypto_ExemptionMechanism$type,
	.param_types=		&_jc_javax_crypto_ExemptionMechanism$param_types$getInstance$2dedc673d1f49019,
	.return_type=		&_jc_javax_crypto_ExemptionMechanism$type,
	.param_ptypes=		&_jc_javax_crypto_ExemptionMechanism$param_ptypes$getInstance$2dedc673d1f49019,
	.signature_hash=	_JC_JLONG(0x2dedc673d1f49019),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_ExemptionMechanism$method$getInstance$2dedc673d1f49019,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_crypto_ExemptionMechanism$exceptions$getInstance$2dedc673d1f49019,
	.u= { .exec= {
	  .trap_table_len=	1,
	  .trap_table=		_jc_javax_crypto_ExemptionMechanism$trap_table$getInstance$2dedc673d1f49019,
	  .u= {
	    .linenum= {
	      .len=	7,
	      .table=	_jc_javax_crypto_ExemptionMechanism$linenum_table$getInstance$2dedc673d1f49019
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_ExemptionMechanism, getInstance$2dedc673d1f49019);

_jc_javax_crypto_ExemptionMechanism$object * _JC_JCNI_ATTR
_jc_javax_crypto_ExemptionMechanism$method$getInstance$2dedc673d1f49019(_jc_env *const env, _jc_java_lang_String$object *param0)
{
	jint volatile i0;
	jint volatile i1;
	jint i2;
	struct _jc_java_lang_String$object *volatile r0;
	struct _jc_java_lang_String$object *volatile r2;
	struct _jc_java_security_NoSuchAlgorithmException$object *volatile r3;
	struct _jc_java_security_Provider$object *volatile r4;
	struct _jc_javax_crypto_ExemptionMechanism$object *volatile r5;
	struct _jc_java_lang_VMThrowable$object *volatile r6;
	struct _jc_java_util_Vector$object *r7;
	_jc_object_array *volatile r8;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_javax_crypto_ExemptionMechanism$method_info$getInstance$2dedc673d1f49019, &&label1);

	r0 = param0;
	_JC_ACTIVE_USE(env, java_security_Security);
	_JC_LINE_NUMBER(96);				// 0
	r7 = _JC_STATIC_FIELD(env, java_security_Security, providers, 1);
	i2 = _JC_INVOKE_VIRTUAL(env, java_util_Vector, size$345df5220fc60ade, r7);
	r8 = _JC_NEW_REF_ARRAY(env, java_security_Provider, 1, i2);
	r7 = _JC_STATIC_FIELD(env, java_security_Security, providers, 1);
	_JC_INVOKE_VIRTUAL(env, java_util_Vector, copyInto$cd78d768b3ba4735, r7, r8);
	_JC_LINE_NUMBER(97);				// 1
	r2 = _JC_STRING(env, "");
	_JC_LINE_NUMBER(98);				// 2
	i0 = 0;
	goto label2;

label0:
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(102);				// 3
	r4 = _JC_REF_ELEMENT(env, r8, i0, 1, 1);
	r5 = _JC_INVOKE_STATIC(env, javax_crypto_ExemptionMechanism, getInstance$ea2eb780051879eb, 0, r0, r4);
	_JC_TRAP_REGION(catch, 2);
	_JC_CANCEL_TRAPS(env, catch);
	return r5;

label1:
	_JC_TRAP_REGION(catch, 2);
	r3 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(106);				// 4
	r2 = _JC_INVOKE_VIRTUAL(env, java_lang_Throwable, getMessage$13aaf240efc902b1, r3);
	_JC_LINE_NUMBER(98);				// 5
	i0 = i0 + 1;

label2:
	_JC_TRAP_REGION(catch, 2);
	i1 = _JC_ARRAY_LENGTH(env, r8);
	if (i0 < i1) {
		_JC_PERIODIC_CHECK(env);
		goto label0;
	}
	_JC_LINE_NUMBER(109);				// 6
	r3 = _JC_NEW(env, java_security_NoSuchAlgorithmException);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r6 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r6;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r2;
	_JC_THROW(env, r3);
}

//
// public static final javax.crypto.ExemptionMechanism getInstance(java.lang.String, java.lang.String) throws java.security.NoSuchAlgorithmException, java.security.NoSuchProviderException
//

static _jc_linenum _jc_javax_crypto_ExemptionMechanism$linenum_table$getInstance$8f5d22e4be60bf4d[];

static const unsigned char _jc_javax_crypto_ExemptionMechanism$param_ptypes$getInstance$8f5d22e4be60bf4d[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_javax_crypto_ExemptionMechanism$exceptions$getInstance$8f5d22e4be60bf4d[] = {
	&_jc_java_security_NoSuchAlgorithmException$type,
	&_jc_java_security_NoSuchProviderException$type
};

static _jc_type *const _jc_javax_crypto_ExemptionMechanism$param_types$getInstance$8f5d22e4be60bf4d[] = {
	&_jc_java_lang_String$type,
	&_jc_java_lang_String$type
};

_jc_method _jc_javax_crypto_ExemptionMechanism$method_info$getInstance$8f5d22e4be60bf4d = {
	.name=			"getInstance",
	.signature=		"(Ljava/lang/String;Ljava/lang/String;)Ljavax/crypto/ExemptionMechanism;",
	.class=			&_jc_javax_crypto_ExemptionMechanism$type,
	.param_types=		&_jc_javax_crypto_ExemptionMechanism$param_types$getInstance$8f5d22e4be60bf4d,
	.return_type=		&_jc_javax_crypto_ExemptionMechanism$type,
	.param_ptypes=		&_jc_javax_crypto_ExemptionMechanism$param_ptypes$getInstance$8f5d22e4be60bf4d,
	.signature_hash=	_JC_JLONG(0x8f5d22e4be60bf4d),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_ExemptionMechanism$method$getInstance$8f5d22e4be60bf4d,
	.num_parameters=	2,
	.num_exceptions=	2,
	.exceptions=		&_jc_javax_crypto_ExemptionMechanism$exceptions$getInstance$8f5d22e4be60bf4d,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_javax_crypto_ExemptionMechanism$linenum_table$getInstance$8f5d22e4be60bf4d
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_ExemptionMechanism, getInstance$8f5d22e4be60bf4d);

_jc_javax_crypto_ExemptionMechanism$object * _JC_JCNI_ATTR
_jc_javax_crypto_ExemptionMechanism$method$getInstance$8f5d22e4be60bf4d(_jc_env *const env, _jc_java_lang_String$object *param0, _jc_java_lang_String$object *param1)
{
	struct _jc_java_lang_String$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_java_security_Provider$object *r2;
	struct _jc_java_security_NoSuchProviderException$object *r3;
	struct _jc_javax_crypto_ExemptionMechanism$object *r4;
	struct _jc_java_lang_VMThrowable$object *r6;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = param0;
	r1 = param1;
	_JC_LINE_NUMBER(116);				// 0
	r2 = _JC_INVOKE_STATIC(env, java_security_Security, getProvider$581ee7d7bc9ae747, 0, r1);
	_JC_LINE_NUMBER(117);				// 1
	if (r2 != _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(119);				// 2
	r3 = _JC_NEW(env, java_security_NoSuchProviderException);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r6 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r6;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r1;
	_JC_THROW(env, r3);

label0:
	_JC_LINE_NUMBER(121);				// 3
	r4 = _JC_INVOKE_STATIC(env, javax_crypto_ExemptionMechanism, getInstance$ea2eb780051879eb, 1, r0, r2);
	return r4;
}

//
// public static final javax.crypto.ExemptionMechanism getInstance(java.lang.String, java.security.Provider) throws java.security.NoSuchAlgorithmException
//

static _jc_linenum _jc_javax_crypto_ExemptionMechanism$linenum_table$getInstance$ea2eb780051879eb[];

static _jc_trap_info _jc_javax_crypto_ExemptionMechanism$trap_table$getInstance$ea2eb780051879eb[] = {
	_JC_TRAP(&_jc_java_lang_reflect_InvocationTargetException$type, 1, 2),
	_JC_TRAP(&_jc_java_lang_ClassCastException$type, 1, 2),
};

static const unsigned char _jc_javax_crypto_ExemptionMechanism$param_ptypes$getInstance$ea2eb780051879eb[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_javax_crypto_ExemptionMechanism$exceptions$getInstance$ea2eb780051879eb[] = {
	&_jc_java_security_NoSuchAlgorithmException$type
};

static _jc_type *const _jc_javax_crypto_ExemptionMechanism$param_types$getInstance$ea2eb780051879eb[] = {
	&_jc_java_lang_String$type,
	&_jc_java_security_Provider$type
};

_jc_method _jc_javax_crypto_ExemptionMechanism$method_info$getInstance$ea2eb780051879eb = {
	.name=			"getInstance",
	.signature=		"(Ljava/lang/String;Ljava/security/Provider;)Ljavax/crypto/ExemptionMechanism;",
	.class=			&_jc_javax_crypto_ExemptionMechanism$type,
	.param_types=		&_jc_javax_crypto_ExemptionMechanism$param_types$getInstance$ea2eb780051879eb,
	.return_type=		&_jc_javax_crypto_ExemptionMechanism$type,
	.param_ptypes=		&_jc_javax_crypto_ExemptionMechanism$param_ptypes$getInstance$ea2eb780051879eb,
	.signature_hash=	_JC_JLONG(0xea2eb780051879eb),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_ExemptionMechanism$method$getInstance$ea2eb780051879eb,
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_crypto_ExemptionMechanism$exceptions$getInstance$ea2eb780051879eb,
	.u= { .exec= {
	  .trap_table_len=	2,
	  .trap_table=		_jc_javax_crypto_ExemptionMechanism$trap_table$getInstance$ea2eb780051879eb,
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_javax_crypto_ExemptionMechanism$linenum_table$getInstance$ea2eb780051879eb
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_ExemptionMechanism, getInstance$ea2eb780051879eb);

_jc_javax_crypto_ExemptionMechanism$object * _JC_JCNI_ATTR
_jc_javax_crypto_ExemptionMechanism$method$getInstance$ea2eb780051879eb(_jc_env *const env, _jc_java_lang_String$object *param0, _jc_java_security_Provider$object *param1)
{
	struct _jc_java_lang_String$object *volatile r0;
	struct _jc_java_security_Provider$object *r1;
	struct _jc_java_lang_Object$object *r10;
	struct _jc_java_lang_VMThrowable$object *volatile r11;
	struct _jc_java_lang_VMThrowable$object *volatile r12;
	struct _jc_javax_crypto_ExemptionMechanism$object *r2;
	struct _jc_java_lang_reflect_InvocationTargetException$object *volatile r3;
	struct _jc_javax_crypto_ExemptionMechanismSpi$object *r4;
	struct _jc_java_lang_Throwable$object *volatile r5;
	struct _jc_java_security_NoSuchAlgorithmException$object *volatile r6;
	struct _jc_java_lang_ClassCastException$object *r7;
	struct _jc_java_lang_String$object *r8;
	_jc_object_array *r9;
	jboolean volatile z0;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_javax_crypto_ExemptionMechanism$method_info$getInstance$ea2eb780051879eb, &&label0, &&label2);

	r0 = param0;
	r1 = param1;
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(130);				// 0
	r2 = _JC_NEW(env, javax_crypto_ExemptionMechanism);
	_JC_ACTIVE_USE(env, gnu_java_security_Engine);
	r8 = _JC_STRING(env, "ExemptionMechanism");
	r9 = _JC_STATIC_FIELD(env, gnu_java_security_Engine, NO__5fARGS, 1);
	r10 = _JC_INVOKE_STATIC(env, gnu_java_security_Engine, getInstance$ec89dfd35c234c64, 1, r8, r0, r1, r9);
	r4 = _JC_CAST(env, &_jc_javax_crypto_ExemptionMechanismSpi$type, r10);
	_JC_REF_FIELD(env, r2, javax_crypto_ExemptionMechanism, emSpi) = r4;
	_JC_REF_FIELD(env, r2, javax_crypto_ExemptionMechanism, provider) = r1;
	_JC_REF_FIELD(env, r2, javax_crypto_ExemptionMechanism, mechanism) = r0;
	_JC_PRIM_FIELD(env, r2, javax_crypto_ExemptionMechanism, virgin) = 1;
	_JC_TRAP_REGION(catch, 2);
	_JC_CANCEL_TRAPS(env, catch);
	return r2;

label0:
	_JC_TRAP_REGION(catch, 2);
	r3 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(136);				// 1
	r5 = _JC_INVOKE_VIRTUAL(env, java_lang_reflect_InvocationTargetException, getCause$d5a96efc8523817a, r3);
	z0 = _JC_INSTANCEOF(env, r5, &_jc_java_security_NoSuchAlgorithmException$type);
	if (z0 == 0)
		goto label1;
	_JC_LINE_NUMBER(137);				// 2
	r5 = _JC_INVOKE_VIRTUAL(env, java_lang_reflect_InvocationTargetException, getCause$d5a96efc8523817a, r3);
	r6 = _JC_CAST(env, &_jc_java_security_NoSuchAlgorithmException$type, r5);
	_JC_THROW(env, r6);

label1:
	_JC_LINE_NUMBER(139);				// 3
	r6 = _JC_NEW(env, java_security_NoSuchAlgorithmException);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, cause) = r6;
	r11 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r6);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, vmState) = r11;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, detailMessage) = r0;
	_JC_THROW(env, r6);

label2:
	_JC_TRAP_REGION(catch, 2);
	r7 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(143);				// 4
	r6 = _JC_NEW(env, java_security_NoSuchAlgorithmException);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, cause) = r6;
	r12 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r6);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, vmState) = r12;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, detailMessage) = r0;
	_JC_THROW(env, r6);
}

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// protected void <init>(javax.crypto.ExemptionMechanismSpi, java.security.Provider, java.lang.String)
//

static _jc_linenum _jc_javax_crypto_ExemptionMechanism$linenum_table$_init$dd4c80ac69d222df[];

static const unsigned char _jc_javax_crypto_ExemptionMechanism$param_ptypes$_init$dd4c80ac69d222df[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_ExemptionMechanism$param_types$_init$dd4c80ac69d222df[] = {
	&_jc_javax_crypto_ExemptionMechanismSpi$type,
	&_jc_java_security_Provider$type,
	&_jc_java_lang_String$type
};

_jc_method _jc_javax_crypto_ExemptionMechanism$method_info$_init$dd4c80ac69d222df = {
	.name=			"<init>",
	.signature=		"(Ljavax/crypto/ExemptionMechanismSpi;Ljava/security/Provider;Ljava/lang/String;)V",
	.class=			&_jc_javax_crypto_ExemptionMechanism$type,
	.param_types=		&_jc_javax_crypto_ExemptionMechanism$param_types$_init$dd4c80ac69d222df,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_ExemptionMechanism$param_ptypes$_init$dd4c80ac69d222df,
	.signature_hash=	_JC_JLONG(0xdd4c80ac69d222df),
	.access_flags=		_JC_ACC_PROTECTED,
	.function=		&_jc_javax_crypto_ExemptionMechanism$method$_init$dd4c80ac69d222df,
	.num_parameters=	3,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_javax_crypto_ExemptionMechanism$linenum_table$_init$dd4c80ac69d222df
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_ExemptionMechanism, _init$dd4c80ac69d222df);

void _JC_JCNI_ATTR
_jc_javax_crypto_ExemptionMechanism$method$_init$dd4c80ac69d222df(_jc_env *const env, _jc_javax_crypto_ExemptionMechanism$object *this, _jc_javax_crypto_ExemptionMechanismSpi$object *param0, _jc_java_security_Provider$object *param1, _jc_java_lang_String$object *param2)
{
	struct _jc_javax_crypto_ExemptionMechanism$object *r0;
	struct _jc_javax_crypto_ExemptionMechanismSpi$object *r1;
	struct _jc_java_security_Provider$object *r2;
	struct _jc_java_lang_String$object *r3;

	r0 = this;
	r1 = param0;
	r2 = param1;
	r3 = param2;
	_JC_LINE_NUMBER(84);				// 0
	_JC_REF_FIELD(env, r0, javax_crypto_ExemptionMechanism, emSpi) = r1;
	_JC_LINE_NUMBER(85);				// 1
	_JC_REF_FIELD(env, r0, javax_crypto_ExemptionMechanism, provider) = r2;
	_JC_LINE_NUMBER(86);				// 2
	_JC_REF_FIELD(env, r0, javax_crypto_ExemptionMechanism, mechanism) = r3;
	_JC_LINE_NUMBER(87);				// 3
	_JC_PRIM_FIELD(env, r0, javax_crypto_ExemptionMechanism, virgin) = 1;
	_JC_LINE_NUMBER(88);				// 4
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// protected void finalize()
//

static _jc_linenum _jc_javax_crypto_ExemptionMechanism$linenum_table$finalize$660a5b5b608ff21f[];

static const unsigned char _jc_javax_crypto_ExemptionMechanism$param_ptypes$finalize$660a5b5b608ff21f[] = { 
_JC_TYPE_VOID };

_jc_method _jc_javax_crypto_ExemptionMechanism$method_info$finalize$660a5b5b608ff21f = {
	.name=			"finalize",
	.signature=		"()V",
	.class=			&_jc_javax_crypto_ExemptionMechanism$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_ExemptionMechanism$param_ptypes$finalize$660a5b5b608ff21f,
	.signature_hash=	_JC_JLONG(0x660a5b5b608ff21f),
	.access_flags=		_JC_ACC_PROTECTED,
	.function=		&_jc_javax_crypto_ExemptionMechanism$method$finalize$660a5b5b608ff21f,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_ExemptionMechanism$vtable, javax_crypto_ExemptionMechanism.finalize$660a5b5b608ff21f) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_crypto_ExemptionMechanism$linenum_table$finalize$660a5b5b608ff21f
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_ExemptionMechanism, finalize$660a5b5b608ff21f);

void _JC_JCNI_ATTR
_jc_javax_crypto_ExemptionMechanism$method$finalize$660a5b5b608ff21f(_jc_env *const env, _jc_javax_crypto_ExemptionMechanism$object *this)
{
	struct _jc_javax_crypto_ExemptionMechanism$object *r0;

	r0 = this;
	_JC_LINE_NUMBER(228);				// 0
	return;
}

//
// public final byte[] genExemptionBlob() throws java.lang.IllegalStateException, javax.crypto.ExemptionMechanismException
//

static _jc_linenum _jc_javax_crypto_ExemptionMechanism$linenum_table$genExemptionBlob$b80814857fa5af81[];

static const unsigned char _jc_javax_crypto_ExemptionMechanism$param_ptypes$genExemptionBlob$b80814857fa5af81[] = { 
_JC_TYPE_REFERENCE };

static _jc_type *const _jc_javax_crypto_ExemptionMechanism$exceptions$genExemptionBlob$b80814857fa5af81[] = {
	&_jc_java_lang_IllegalStateException$type,
	&_jc_javax_crypto_ExemptionMechanismException$type
};

_jc_method _jc_javax_crypto_ExemptionMechanism$method_info$genExemptionBlob$b80814857fa5af81 = {
	.name=			"genExemptionBlob",
	.signature=		"()[B",
	.class=			&_jc_javax_crypto_ExemptionMechanism$type,
	.return_type=		&_jc_byte$array$prim$type,
	.param_ptypes=		&_jc_javax_crypto_ExemptionMechanism$param_ptypes$genExemptionBlob$b80814857fa5af81,
	.signature_hash=	_JC_JLONG(0xb80814857fa5af81),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_ExemptionMechanism$method$genExemptionBlob$b80814857fa5af81,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_ExemptionMechanism$vtable, javax_crypto_ExemptionMechanism.genExemptionBlob$b80814857fa5af81) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	2,
	.exceptions=		&_jc_javax_crypto_ExemptionMechanism$exceptions$genExemptionBlob$b80814857fa5af81,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_javax_crypto_ExemptionMechanism$linenum_table$genExemptionBlob$b80814857fa5af81
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_ExemptionMechanism, genExemptionBlob$b80814857fa5af81);

_jc_byte_array * _JC_JCNI_ATTR
_jc_javax_crypto_ExemptionMechanism$method$genExemptionBlob$b80814857fa5af81(_jc_env *const env, _jc_javax_crypto_ExemptionMechanism$object *this)
{
	struct _jc_javax_crypto_ExemptionMechanism$object *r0;
	struct _jc_java_lang_IllegalStateException$object *r1;
	struct _jc_javax_crypto_ExemptionMechanismSpi$object *r2;
	_jc_byte_array *r3;
	struct _jc_java_lang_String$object *r4;
	struct _jc_java_lang_VMThrowable$object *r6;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(153);				// 0
	z0 = _JC_PRIM_FIELD(env, r0, javax_crypto_ExemptionMechanism, virgin);
	if (z0 == 0)
		goto label0;
	_JC_LINE_NUMBER(155);				// 1
	r1 = _JC_NEW(env, java_lang_IllegalStateException);
	r4 = _JC_STRING(env, "not initialized");
	_JC_REF_FIELD(env, r1, java_lang_Throwable, cause) = r1;
	r6 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r1);
	_JC_REF_FIELD(env, r1, java_lang_Throwable, vmState) = r6;
	_JC_REF_FIELD(env, r1, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r1, java_lang_Throwable, detailMessage) = r4;
	_JC_THROW(env, r1);

label0:
	_JC_LINE_NUMBER(157);				// 2
	r2 = _JC_REF_FIELD(env, r0, javax_crypto_ExemptionMechanism, emSpi);
	r3 = _JC_INVOKE_VIRTUAL(env, javax_crypto_ExemptionMechanismSpi, engineGenExemptionBlob$08be108bd16d3717, r2);
	return r3;
}

//
// public final int genExemptionBlob(byte[]) throws java.lang.IllegalStateException, javax.crypto.ExemptionMechanismException, javax.crypto.ShortBufferException
//

static _jc_linenum _jc_javax_crypto_ExemptionMechanism$linenum_table$genExemptionBlob$e3e93d9bfcfe73f0[];

static const unsigned char _jc_javax_crypto_ExemptionMechanism$param_ptypes$genExemptionBlob$e3e93d9bfcfe73f0[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT };

static _jc_type *const _jc_javax_crypto_ExemptionMechanism$exceptions$genExemptionBlob$e3e93d9bfcfe73f0[] = {
	&_jc_java_lang_IllegalStateException$type,
	&_jc_javax_crypto_ExemptionMechanismException$type,
	&_jc_javax_crypto_ShortBufferException$type
};

static _jc_type *const _jc_javax_crypto_ExemptionMechanism$param_types$genExemptionBlob$e3e93d9bfcfe73f0[] = {
	&_jc_byte$array$prim$type
};

_jc_method _jc_javax_crypto_ExemptionMechanism$method_info$genExemptionBlob$e3e93d9bfcfe73f0 = {
	.name=			"genExemptionBlob",
	.signature=		"([B)I",
	.class=			&_jc_javax_crypto_ExemptionMechanism$type,
	.param_types=		&_jc_javax_crypto_ExemptionMechanism$param_types$genExemptionBlob$e3e93d9bfcfe73f0,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_javax_crypto_ExemptionMechanism$param_ptypes$genExemptionBlob$e3e93d9bfcfe73f0,
	.signature_hash=	_JC_JLONG(0xe3e93d9bfcfe73f0),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_ExemptionMechanism$method$genExemptionBlob$e3e93d9bfcfe73f0,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_ExemptionMechanism$vtable, javax_crypto_ExemptionMechanism.genExemptionBlob$e3e93d9bfcfe73f0) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	3,
	.exceptions=		&_jc_javax_crypto_ExemptionMechanism$exceptions$genExemptionBlob$e3e93d9bfcfe73f0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_crypto_ExemptionMechanism$linenum_table$genExemptionBlob$e3e93d9bfcfe73f0
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_ExemptionMechanism, genExemptionBlob$e3e93d9bfcfe73f0);

jint _JC_JCNI_ATTR
_jc_javax_crypto_ExemptionMechanism$method$genExemptionBlob$e3e93d9bfcfe73f0(_jc_env *const env, _jc_javax_crypto_ExemptionMechanism$object *this, _jc_byte_array *param0)
{
	jint i0;
	struct _jc_javax_crypto_ExemptionMechanism$object *r0;
	_jc_byte_array *r1;
	struct _jc_java_lang_IllegalStateException$object *r2;
	struct _jc_javax_crypto_ExemptionMechanismSpi$object *r3;
	struct _jc_java_lang_String$object *r4;
	struct _jc_java_lang_VMThrowable$object *r6;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	z0 = _JC_PRIM_FIELD(env, r0, javax_crypto_ExemptionMechanism, virgin);
	if (z0 == 0)
		goto label0;
	r2 = _JC_NEW(env, java_lang_IllegalStateException);
	r4 = _JC_STRING(env, "not initialized");
	_JC_REF_FIELD(env, r2, java_lang_Throwable, cause) = r2;
	r6 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r2);
	_JC_REF_FIELD(env, r2, java_lang_Throwable, vmState) = r6;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, detailMessage) = r4;
	_JC_THROW(env, r2);

label0:
	r3 = _JC_REF_FIELD(env, r0, javax_crypto_ExemptionMechanism, emSpi);
	i0 = _JC_INVOKE_VIRTUAL(env, javax_crypto_ExemptionMechanismSpi, engineGenExemptionBlob$71c3c326f37c8ef2, r3, r1, 0);
	_JC_LINE_NUMBER(164);				// 0
	return i0;
}

//
// public final int genExemptionBlob(byte[], int) throws java.lang.IllegalStateException, javax.crypto.ExemptionMechanismException, javax.crypto.ShortBufferException
//

static _jc_linenum _jc_javax_crypto_ExemptionMechanism$linenum_table$genExemptionBlob$00cce9c2a8c5c5ca[];

static const unsigned char _jc_javax_crypto_ExemptionMechanism$param_ptypes$genExemptionBlob$00cce9c2a8c5c5ca[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_INT };

static _jc_type *const _jc_javax_crypto_ExemptionMechanism$exceptions$genExemptionBlob$00cce9c2a8c5c5ca[] = {
	&_jc_java_lang_IllegalStateException$type,
	&_jc_javax_crypto_ExemptionMechanismException$type,
	&_jc_javax_crypto_ShortBufferException$type
};

static _jc_type *const _jc_javax_crypto_ExemptionMechanism$param_types$genExemptionBlob$00cce9c2a8c5c5ca[] = {
	&_jc_byte$array$prim$type,
	&_jc_int$prim$type
};

_jc_method _jc_javax_crypto_ExemptionMechanism$method_info$genExemptionBlob$00cce9c2a8c5c5ca = {
	.name=			"genExemptionBlob",
	.signature=		"([BI)I",
	.class=			&_jc_javax_crypto_ExemptionMechanism$type,
	.param_types=		&_jc_javax_crypto_ExemptionMechanism$param_types$genExemptionBlob$00cce9c2a8c5c5ca,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_javax_crypto_ExemptionMechanism$param_ptypes$genExemptionBlob$00cce9c2a8c5c5ca,
	.signature_hash=	_JC_JLONG(0xcce9c2a8c5c5ca),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_ExemptionMechanism$method$genExemptionBlob$00cce9c2a8c5c5ca,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_ExemptionMechanism$vtable, javax_crypto_ExemptionMechanism.genExemptionBlob$00cce9c2a8c5c5ca) / sizeof(void *),
	.num_parameters=	2,
	.num_exceptions=	3,
	.exceptions=		&_jc_javax_crypto_ExemptionMechanism$exceptions$genExemptionBlob$00cce9c2a8c5c5ca,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_javax_crypto_ExemptionMechanism$linenum_table$genExemptionBlob$00cce9c2a8c5c5ca
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_ExemptionMechanism, genExemptionBlob$00cce9c2a8c5c5ca);

jint _JC_JCNI_ATTR
_jc_javax_crypto_ExemptionMechanism$method$genExemptionBlob$00cce9c2a8c5c5ca(_jc_env *const env, _jc_javax_crypto_ExemptionMechanism$object *this, _jc_byte_array *param0, jint param1)
{
	jint i0;
	struct _jc_javax_crypto_ExemptionMechanism$object *r0;
	_jc_byte_array *r1;
	struct _jc_java_lang_IllegalStateException$object *r2;
	struct _jc_javax_crypto_ExemptionMechanismSpi$object *r3;
	struct _jc_java_lang_String$object *r4;
	struct _jc_java_lang_VMThrowable$object *r6;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	i0 = param1;
	_JC_LINE_NUMBER(171);				// 0
	z0 = _JC_PRIM_FIELD(env, r0, javax_crypto_ExemptionMechanism, virgin);
	if (z0 == 0)
		goto label0;
	_JC_LINE_NUMBER(173);				// 1
	r2 = _JC_NEW(env, java_lang_IllegalStateException);
	r4 = _JC_STRING(env, "not initialized");
	_JC_REF_FIELD(env, r2, java_lang_Throwable, cause) = r2;
	r6 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r2);
	_JC_REF_FIELD(env, r2, java_lang_Throwable, vmState) = r6;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, detailMessage) = r4;
	_JC_THROW(env, r2);

label0:
	_JC_LINE_NUMBER(175);				// 2
	r3 = _JC_REF_FIELD(env, r0, javax_crypto_ExemptionMechanism, emSpi);
	i0 = _JC_INVOKE_VIRTUAL(env, javax_crypto_ExemptionMechanismSpi, engineGenExemptionBlob$71c3c326f37c8ef2, r3, r1, i0);
	return i0;
}

//
// public final java.lang.String getName()
//

static _jc_linenum _jc_javax_crypto_ExemptionMechanism$linenum_table$getName$bec186f2ce7e1882[];

static const unsigned char _jc_javax_crypto_ExemptionMechanism$param_ptypes$getName$bec186f2ce7e1882[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_javax_crypto_ExemptionMechanism$method_info$getName$bec186f2ce7e1882 = {
	.name=			"getName",
	.signature=		"()Ljava/lang/String;",
	.class=			&_jc_javax_crypto_ExemptionMechanism$type,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_javax_crypto_ExemptionMechanism$param_ptypes$getName$bec186f2ce7e1882,
	.signature_hash=	_JC_JLONG(0xbec186f2ce7e1882),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_ExemptionMechanism$method$getName$bec186f2ce7e1882,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_ExemptionMechanism$vtable, javax_crypto_ExemptionMechanism.getName$bec186f2ce7e1882) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_crypto_ExemptionMechanism$linenum_table$getName$bec186f2ce7e1882
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_ExemptionMechanism, getName$bec186f2ce7e1882);

_jc_java_lang_String$object * _JC_JCNI_ATTR
_jc_javax_crypto_ExemptionMechanism$method$getName$bec186f2ce7e1882(_jc_env *const env, _jc_javax_crypto_ExemptionMechanism$object *this)
{
	struct _jc_javax_crypto_ExemptionMechanism$object *r0;
	struct _jc_java_lang_String$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(180);				// 0
	r1 = _JC_REF_FIELD(env, r0, javax_crypto_ExemptionMechanism, mechanism);
	return r1;
}

//
// public final int getOutputSize(int) throws java.lang.IllegalStateException
//

static _jc_linenum _jc_javax_crypto_ExemptionMechanism$linenum_table$getOutputSize$972045742a73f7e4[];

static const unsigned char _jc_javax_crypto_ExemptionMechanism$param_ptypes$getOutputSize$972045742a73f7e4[] = { 
_JC_TYPE_INT, _JC_TYPE_INT };

static _jc_type *const _jc_javax_crypto_ExemptionMechanism$exceptions$getOutputSize$972045742a73f7e4[] = {
	&_jc_java_lang_IllegalStateException$type
};

static _jc_type *const _jc_javax_crypto_ExemptionMechanism$param_types$getOutputSize$972045742a73f7e4[] = {
	&_jc_int$prim$type
};

_jc_method _jc_javax_crypto_ExemptionMechanism$method_info$getOutputSize$972045742a73f7e4 = {
	.name=			"getOutputSize",
	.signature=		"(I)I",
	.class=			&_jc_javax_crypto_ExemptionMechanism$type,
	.param_types=		&_jc_javax_crypto_ExemptionMechanism$param_types$getOutputSize$972045742a73f7e4,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_javax_crypto_ExemptionMechanism$param_ptypes$getOutputSize$972045742a73f7e4,
	.signature_hash=	_JC_JLONG(0x972045742a73f7e4),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_ExemptionMechanism$method$getOutputSize$972045742a73f7e4,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_ExemptionMechanism$vtable, javax_crypto_ExemptionMechanism.getOutputSize$972045742a73f7e4) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_crypto_ExemptionMechanism$exceptions$getOutputSize$972045742a73f7e4,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_javax_crypto_ExemptionMechanism$linenum_table$getOutputSize$972045742a73f7e4
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_ExemptionMechanism, getOutputSize$972045742a73f7e4);

jint _JC_JCNI_ATTR
_jc_javax_crypto_ExemptionMechanism$method$getOutputSize$972045742a73f7e4(_jc_env *const env, _jc_javax_crypto_ExemptionMechanism$object *this, jint param0)
{
	jint i0;
	struct _jc_javax_crypto_ExemptionMechanism$object *r0;
	struct _jc_java_lang_IllegalStateException$object *r1;
	struct _jc_javax_crypto_ExemptionMechanismSpi$object *r2;
	struct _jc_java_lang_String$object *r3;
	struct _jc_java_lang_VMThrowable$object *r5;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	i0 = param0;
	_JC_LINE_NUMBER(185);				// 0
	z0 = _JC_PRIM_FIELD(env, r0, javax_crypto_ExemptionMechanism, virgin);
	if (z0 == 0)
		goto label0;
	_JC_LINE_NUMBER(187);				// 1
	r1 = _JC_NEW(env, java_lang_IllegalStateException);
	r3 = _JC_STRING(env, "not initialized");
	_JC_REF_FIELD(env, r1, java_lang_Throwable, cause) = r1;
	r5 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r1);
	_JC_REF_FIELD(env, r1, java_lang_Throwable, vmState) = r5;
	_JC_REF_FIELD(env, r1, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r1, java_lang_Throwable, detailMessage) = r3;
	_JC_THROW(env, r1);

label0:
	_JC_LINE_NUMBER(189);				// 2
	r2 = _JC_REF_FIELD(env, r0, javax_crypto_ExemptionMechanism, emSpi);
	i0 = _JC_INVOKE_VIRTUAL(env, javax_crypto_ExemptionMechanismSpi, engineGetOutputSize$e13ccb96d0f1b0bb, r2, i0);
	return i0;
}

//
// public final java.security.Provider getProvider()
//

static _jc_linenum _jc_javax_crypto_ExemptionMechanism$linenum_table$getProvider$e8f9c9fb14140d5a[];

static const unsigned char _jc_javax_crypto_ExemptionMechanism$param_ptypes$getProvider$e8f9c9fb14140d5a[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_javax_crypto_ExemptionMechanism$method_info$getProvider$e8f9c9fb14140d5a = {
	.name=			"getProvider",
	.signature=		"()Ljava/security/Provider;",
	.class=			&_jc_javax_crypto_ExemptionMechanism$type,
	.return_type=		&_jc_java_security_Provider$type,
	.param_ptypes=		&_jc_javax_crypto_ExemptionMechanism$param_ptypes$getProvider$e8f9c9fb14140d5a,
	.signature_hash=	_JC_JLONG(0xe8f9c9fb14140d5a),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_ExemptionMechanism$method$getProvider$e8f9c9fb14140d5a,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_ExemptionMechanism$vtable, javax_crypto_ExemptionMechanism.getProvider$e8f9c9fb14140d5a) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_crypto_ExemptionMechanism$linenum_table$getProvider$e8f9c9fb14140d5a
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_ExemptionMechanism, getProvider$e8f9c9fb14140d5a);

_jc_java_security_Provider$object * _JC_JCNI_ATTR
_jc_javax_crypto_ExemptionMechanism$method$getProvider$e8f9c9fb14140d5a(_jc_env *const env, _jc_javax_crypto_ExemptionMechanism$object *this)
{
	struct _jc_javax_crypto_ExemptionMechanism$object *r0;
	struct _jc_java_security_Provider$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(194);				// 0
	r1 = _JC_REF_FIELD(env, r0, javax_crypto_ExemptionMechanism, provider);
	return r1;
}

//
// public final void init(java.security.Key) throws javax.crypto.ExemptionMechanismException, java.security.InvalidKeyException
//

static _jc_linenum _jc_javax_crypto_ExemptionMechanism$linenum_table$init$a20ac47f1570a2f7[];

static const unsigned char _jc_javax_crypto_ExemptionMechanism$param_ptypes$init$a20ac47f1570a2f7[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_ExemptionMechanism$exceptions$init$a20ac47f1570a2f7[] = {
	&_jc_javax_crypto_ExemptionMechanismException$type,
	&_jc_java_security_InvalidKeyException$type
};

static _jc_type *const _jc_javax_crypto_ExemptionMechanism$param_types$init$a20ac47f1570a2f7[] = {
	&_jc_java_security_Key$type
};

_jc_method _jc_javax_crypto_ExemptionMechanism$method_info$init$a20ac47f1570a2f7 = {
	.name=			"init",
	.signature=		"(Ljava/security/Key;)V",
	.class=			&_jc_javax_crypto_ExemptionMechanism$type,
	.param_types=		&_jc_javax_crypto_ExemptionMechanism$param_types$init$a20ac47f1570a2f7,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_ExemptionMechanism$param_ptypes$init$a20ac47f1570a2f7,
	.signature_hash=	_JC_JLONG(0xa20ac47f1570a2f7),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_ExemptionMechanism$method$init$a20ac47f1570a2f7,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_ExemptionMechanism$vtable, javax_crypto_ExemptionMechanism.init$a20ac47f1570a2f7) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	2,
	.exceptions=		&_jc_javax_crypto_ExemptionMechanism$exceptions$init$a20ac47f1570a2f7,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_javax_crypto_ExemptionMechanism$linenum_table$init$a20ac47f1570a2f7
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_ExemptionMechanism, init$a20ac47f1570a2f7);

void _JC_JCNI_ATTR
_jc_javax_crypto_ExemptionMechanism$method$init$a20ac47f1570a2f7(_jc_env *const env, _jc_javax_crypto_ExemptionMechanism$object *this, _jc_object *param0)
{
	struct _jc_javax_crypto_ExemptionMechanism$object *r0;
	struct _jc_object *r1;
	struct _jc_javax_crypto_ExemptionMechanismSpi$object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(200);				// 0
	r2 = _JC_REF_FIELD(env, r0, javax_crypto_ExemptionMechanism, emSpi);
	_JC_INVOKE_VIRTUAL(env, javax_crypto_ExemptionMechanismSpi, engineInit$183710cc6d343804, r2, r1);
	_JC_LINE_NUMBER(201);				// 1
	_JC_PRIM_FIELD(env, r0, javax_crypto_ExemptionMechanism, virgin) = 0;
	_JC_LINE_NUMBER(202);				// 2
	return;
}

//
// public final void init(java.security.Key, java.security.AlgorithmParameters) throws javax.crypto.ExemptionMechanismException, java.security.InvalidAlgorithmParameterException, java.security.InvalidKeyException
//

static _jc_linenum _jc_javax_crypto_ExemptionMechanism$linenum_table$init$cc5c9d000e940410[];

static const unsigned char _jc_javax_crypto_ExemptionMechanism$param_ptypes$init$cc5c9d000e940410[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_ExemptionMechanism$exceptions$init$cc5c9d000e940410[] = {
	&_jc_javax_crypto_ExemptionMechanismException$type,
	&_jc_java_security_InvalidAlgorithmParameterException$type,
	&_jc_java_security_InvalidKeyException$type
};

static _jc_type *const _jc_javax_crypto_ExemptionMechanism$param_types$init$cc5c9d000e940410[] = {
	&_jc_java_security_Key$type,
	&_jc_java_security_AlgorithmParameters$type
};

_jc_method _jc_javax_crypto_ExemptionMechanism$method_info$init$cc5c9d000e940410 = {
	.name=			"init",
	.signature=		"(Ljava/security/Key;Ljava/security/AlgorithmParameters;)V",
	.class=			&_jc_javax_crypto_ExemptionMechanism$type,
	.param_types=		&_jc_javax_crypto_ExemptionMechanism$param_types$init$cc5c9d000e940410,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_ExemptionMechanism$param_ptypes$init$cc5c9d000e940410,
	.signature_hash=	_JC_JLONG(0xcc5c9d000e940410),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_ExemptionMechanism$method$init$cc5c9d000e940410,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_ExemptionMechanism$vtable, javax_crypto_ExemptionMechanism.init$cc5c9d000e940410) / sizeof(void *),
	.num_parameters=	2,
	.num_exceptions=	3,
	.exceptions=		&_jc_javax_crypto_ExemptionMechanism$exceptions$init$cc5c9d000e940410,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_javax_crypto_ExemptionMechanism$linenum_table$init$cc5c9d000e940410
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_ExemptionMechanism, init$cc5c9d000e940410);

void _JC_JCNI_ATTR
_jc_javax_crypto_ExemptionMechanism$method$init$cc5c9d000e940410(_jc_env *const env, _jc_javax_crypto_ExemptionMechanism$object *this, _jc_object *param0, _jc_java_security_AlgorithmParameters$object *param1)
{
	struct _jc_javax_crypto_ExemptionMechanism$object *r0;
	struct _jc_object *r1;
	struct _jc_java_security_AlgorithmParameters$object *r2;
	struct _jc_javax_crypto_ExemptionMechanismSpi$object *r3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_LINE_NUMBER(208);				// 0
	r3 = _JC_REF_FIELD(env, r0, javax_crypto_ExemptionMechanism, emSpi);
	_JC_INVOKE_VIRTUAL(env, javax_crypto_ExemptionMechanismSpi, engineInit$69ebd1feb23e695c, r3, r1, r2);
	_JC_LINE_NUMBER(209);				// 1
	_JC_PRIM_FIELD(env, r0, javax_crypto_ExemptionMechanism, virgin) = 0;
	_JC_LINE_NUMBER(210);				// 2
	return;
}

//
// public final void init(java.security.Key, java.security.spec.AlgorithmParameterSpec) throws javax.crypto.ExemptionMechanismException, java.security.InvalidAlgorithmParameterException, java.security.InvalidKeyException
//

static _jc_linenum _jc_javax_crypto_ExemptionMechanism$linenum_table$init$24fee54d988e28f1[];

static const unsigned char _jc_javax_crypto_ExemptionMechanism$param_ptypes$init$24fee54d988e28f1[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_ExemptionMechanism$exceptions$init$24fee54d988e28f1[] = {
	&_jc_javax_crypto_ExemptionMechanismException$type,
	&_jc_java_security_InvalidAlgorithmParameterException$type,
	&_jc_java_security_InvalidKeyException$type
};

static _jc_type *const _jc_javax_crypto_ExemptionMechanism$param_types$init$24fee54d988e28f1[] = {
	&_jc_java_security_Key$type,
	&_jc_java_security_spec_AlgorithmParameterSpec$type
};

_jc_method _jc_javax_crypto_ExemptionMechanism$method_info$init$24fee54d988e28f1 = {
	.name=			"init",
	.signature=		"(Ljava/security/Key;Ljava/security/spec/AlgorithmParameterSpec;)V",
	.class=			&_jc_javax_crypto_ExemptionMechanism$type,
	.param_types=		&_jc_javax_crypto_ExemptionMechanism$param_types$init$24fee54d988e28f1,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_ExemptionMechanism$param_ptypes$init$24fee54d988e28f1,
	.signature_hash=	_JC_JLONG(0x24fee54d988e28f1),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_ExemptionMechanism$method$init$24fee54d988e28f1,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_ExemptionMechanism$vtable, javax_crypto_ExemptionMechanism.init$24fee54d988e28f1) / sizeof(void *),
	.num_parameters=	2,
	.num_exceptions=	3,
	.exceptions=		&_jc_javax_crypto_ExemptionMechanism$exceptions$init$24fee54d988e28f1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_javax_crypto_ExemptionMechanism$linenum_table$init$24fee54d988e28f1
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_ExemptionMechanism, init$24fee54d988e28f1);

void _JC_JCNI_ATTR
_jc_javax_crypto_ExemptionMechanism$method$init$24fee54d988e28f1(_jc_env *const env, _jc_javax_crypto_ExemptionMechanism$object *this, _jc_object *param0, _jc_object *param1)
{
	struct _jc_javax_crypto_ExemptionMechanism$object *r0;
	struct _jc_object *r1;
	struct _jc_object *r2;
	struct _jc_javax_crypto_ExemptionMechanismSpi$object *r3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_LINE_NUMBER(216);				// 0
	r3 = _JC_REF_FIELD(env, r0, javax_crypto_ExemptionMechanism, emSpi);
	_JC_INVOKE_VIRTUAL(env, javax_crypto_ExemptionMechanismSpi, engineInit$af0504f670894439, r3, r1, r2);
	_JC_LINE_NUMBER(217);				// 1
	_JC_PRIM_FIELD(env, r0, javax_crypto_ExemptionMechanism, virgin) = 0;
	_JC_LINE_NUMBER(218);				// 2
	return;
}

//
// public final boolean isCryptoAllowed(java.security.Key) throws javax.crypto.ExemptionMechanismException
//

static _jc_linenum _jc_javax_crypto_ExemptionMechanism$linenum_table$isCryptoAllowed$5bbc193ba97e1a6b[];

static const unsigned char _jc_javax_crypto_ExemptionMechanism$param_ptypes$isCryptoAllowed$5bbc193ba97e1a6b[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_javax_crypto_ExemptionMechanism$exceptions$isCryptoAllowed$5bbc193ba97e1a6b[] = {
	&_jc_javax_crypto_ExemptionMechanismException$type
};

static _jc_type *const _jc_javax_crypto_ExemptionMechanism$param_types$isCryptoAllowed$5bbc193ba97e1a6b[] = {
	&_jc_java_security_Key$type
};

_jc_method _jc_javax_crypto_ExemptionMechanism$method_info$isCryptoAllowed$5bbc193ba97e1a6b = {
	.name=			"isCryptoAllowed",
	.signature=		"(Ljava/security/Key;)Z",
	.class=			&_jc_javax_crypto_ExemptionMechanism$type,
	.param_types=		&_jc_javax_crypto_ExemptionMechanism$param_types$isCryptoAllowed$5bbc193ba97e1a6b,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_javax_crypto_ExemptionMechanism$param_ptypes$isCryptoAllowed$5bbc193ba97e1a6b,
	.signature_hash=	_JC_JLONG(0x5bbc193ba97e1a6b),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_ExemptionMechanism$method$isCryptoAllowed$5bbc193ba97e1a6b,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_ExemptionMechanism$vtable, javax_crypto_ExemptionMechanism.isCryptoAllowed$5bbc193ba97e1a6b) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_crypto_ExemptionMechanism$exceptions$isCryptoAllowed$5bbc193ba97e1a6b,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_crypto_ExemptionMechanism$linenum_table$isCryptoAllowed$5bbc193ba97e1a6b
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_ExemptionMechanism, isCryptoAllowed$5bbc193ba97e1a6b);

jboolean _JC_JCNI_ATTR
_jc_javax_crypto_ExemptionMechanism$method$isCryptoAllowed$5bbc193ba97e1a6b(_jc_env *const env, _jc_javax_crypto_ExemptionMechanism$object *this, _jc_object *param0)
{
	struct _jc_javax_crypto_ExemptionMechanism$object *r0;
	struct _jc_object *r1;

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(223);				// 0
	return 1;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_javax_crypto_ExemptionMechanism$methods[] = {
	&_jc_javax_crypto_ExemptionMechanism$method_info$_init$dd4c80ac69d222df,
	&_jc_javax_crypto_ExemptionMechanism$method_info$finalize$660a5b5b608ff21f,
	&_jc_javax_crypto_ExemptionMechanism$method_info$genExemptionBlob$b80814857fa5af81,
	&_jc_javax_crypto_ExemptionMechanism$method_info$genExemptionBlob$e3e93d9bfcfe73f0,
	&_jc_javax_crypto_ExemptionMechanism$method_info$genExemptionBlob$00cce9c2a8c5c5ca,
	&_jc_javax_crypto_ExemptionMechanism$method_info$getInstance$2dedc673d1f49019,
	&_jc_javax_crypto_ExemptionMechanism$method_info$getInstance$8f5d22e4be60bf4d,
	&_jc_javax_crypto_ExemptionMechanism$method_info$getInstance$ea2eb780051879eb,
	&_jc_javax_crypto_ExemptionMechanism$method_info$getName$bec186f2ce7e1882,
	&_jc_javax_crypto_ExemptionMechanism$method_info$getOutputSize$972045742a73f7e4,
	&_jc_javax_crypto_ExemptionMechanism$method_info$getProvider$e8f9c9fb14140d5a,
	&_jc_javax_crypto_ExemptionMechanism$method_info$init$a20ac47f1570a2f7,
	&_jc_javax_crypto_ExemptionMechanism$method_info$init$cc5c9d000e940410,
	&_jc_javax_crypto_ExemptionMechanism$method_info$init$24fee54d988e28f1,
	&_jc_javax_crypto_ExemptionMechanism$method_info$isCryptoAllowed$5bbc193ba97e1a6b
};

/************************************************************************
 *			  Class fields structure			*
 ************************************************************************/

_jc_javax_crypto_ExemptionMechanism$fields_struct _jc_javax_crypto_ExemptionMechanism$class_fields = { };

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_javax_crypto_ExemptionMechanism$instanceof_hash_bucket_69[] = {
	&_jc_javax_crypto_ExemptionMechanism$type,
	_JC_NULL
};
static _jc_type *const _jc_javax_crypto_ExemptionMechanism$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_javax_crypto_ExemptionMechanism$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[69]=	_jc_javax_crypto_ExemptionMechanism$instanceof_hash_bucket_69,
	[101]=	_jc_javax_crypto_ExemptionMechanism$instanceof_hash_bucket_101
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_javax_crypto_ExemptionMechanism$class_depends[] = {
	{ "gnu/java/security/Engine",	_JC_JLONG(0xf4ba095546954b36) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/ClassCastException",	_JC_JLONG(0xf02ab3ccb490a6d0) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/IllegalStateException",	_JC_JLONG(0xb7e704701c278e65) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/RuntimeException",	_JC_JLONG(0x4f5534a987354d1d) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/lang/reflect/InvocationTargetException",	_JC_JLONG(0xae4a2342b31a268d) },
	{ "java/security/AlgorithmParameters",	_JC_JLONG(0x814794c0d977019) },
	{ "java/security/GeneralSecurityException",	_JC_JLONG(0x692089051f4c8d0b) },
	{ "java/security/InvalidAlgorithmParameterException",	_JC_JLONG(0x327edce29f2562dd) },
	{ "java/security/InvalidKeyException",	_JC_JLONG(0x94dda41e9bf6c170) },
	{ "java/security/Key",	_JC_JLONG(0xa467c6cd05d9cc51) },
	{ "java/security/NoSuchAlgorithmException",	_JC_JLONG(0x22e937c2536160b4) },
	{ "java/security/NoSuchProviderException",	_JC_JLONG(0x8dfbf242adab91e) },
	{ "java/security/Provider",	_JC_JLONG(0x81b073051aa30acc) },
	{ "java/security/Security",	_JC_JLONG(0x89bf77984bd9669e) },
	{ "java/security/spec/AlgorithmParameterSpec",	_JC_JLONG(0xef2e5e8af121478f) },
	{ "java/util/Vector",	_JC_JLONG(0xc53e1575b095109b) },
	{ "javax/crypto/ExemptionMechanismException",	_JC_JLONG(0xfe35024cc7ae0d53) },
	{ "javax/crypto/ExemptionMechanismSpi",	_JC_JLONG(0xed16a6ca818003e8) },
	{ "javax/crypto/ShortBufferException",	_JC_JLONG(0xd79a62a9328ccea1) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_javax_crypto_ExemptionMechanism$vtype _jc_javax_crypto_ExemptionMechanism$type = {
    .type= {
	.name=			"javax/crypto/ExemptionMechanism",
	.superclass=		&_jc_java_lang_Object$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		22,
		.hash=			_JC_JLONG(0x9390fe3e28a7a8c5),
		.source_file=		"ExemptionMechanism.java",
		.instance_size=		sizeof(_jc_javax_crypto_ExemptionMechanism$refs) + sizeof(_jc_javax_crypto_ExemptionMechanism$object),
		.num_virtual_refs=	3,
		.num_fields=		sizeof(_jc_javax_crypto_ExemptionMechanism$fields) / sizeof(*_jc_javax_crypto_ExemptionMechanism$fields),
		.fields=		_jc_javax_crypto_ExemptionMechanism$fields,
		.num_methods=		sizeof(_jc_javax_crypto_ExemptionMechanism$methods) / sizeof(*_jc_javax_crypto_ExemptionMechanism$methods),
		.methods=		_jc_javax_crypto_ExemptionMechanism$methods,
		.instanceof_hash_table=	_jc_javax_crypto_ExemptionMechanism$instanceof_hash_table,
		.class_fields=		&_jc_javax_crypto_ExemptionMechanism$class_fields,
		.num_class_depends=		sizeof(_jc_javax_crypto_ExemptionMechanism$class_depends) / sizeof(*_jc_javax_crypto_ExemptionMechanism$class_depends),
		.class_depends=		_jc_javax_crypto_ExemptionMechanism$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=			// overridden
		&_jc_javax_crypto_ExemptionMechanism$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.javax_crypto_ExemptionMechanism= {
	    .finalize$660a5b5b608ff21f=
		&_jc_javax_crypto_ExemptionMechanism$method$finalize$660a5b5b608ff21f,
	    .genExemptionBlob$b80814857fa5af81=
		&_jc_javax_crypto_ExemptionMechanism$method$genExemptionBlob$b80814857fa5af81,
	    .genExemptionBlob$e3e93d9bfcfe73f0=
		&_jc_javax_crypto_ExemptionMechanism$method$genExemptionBlob$e3e93d9bfcfe73f0,
	    .genExemptionBlob$00cce9c2a8c5c5ca=
		&_jc_javax_crypto_ExemptionMechanism$method$genExemptionBlob$00cce9c2a8c5c5ca,
	    .getName$bec186f2ce7e1882=
		&_jc_javax_crypto_ExemptionMechanism$method$getName$bec186f2ce7e1882,
	    .getOutputSize$972045742a73f7e4=
		&_jc_javax_crypto_ExemptionMechanism$method$getOutputSize$972045742a73f7e4,
	    .getProvider$e8f9c9fb14140d5a=
		&_jc_javax_crypto_ExemptionMechanism$method$getProvider$e8f9c9fb14140d5a,
	    .init$a20ac47f1570a2f7=
		&_jc_javax_crypto_ExemptionMechanism$method$init$a20ac47f1570a2f7,
	    .init$cc5c9d000e940410=
		&_jc_javax_crypto_ExemptionMechanism$method$init$cc5c9d000e940410,
	    .init$24fee54d988e28f1=
		&_jc_javax_crypto_ExemptionMechanism$method$init$24fee54d988e28f1,
	    .isCryptoAllowed$5bbc193ba97e1a6b=
		&_jc_javax_crypto_ExemptionMechanism$method$isCryptoAllowed$5bbc193ba97e1a6b,
	},
    }
};

