// public class javax.crypto.KeyAgreement

// class file dependencies
// @dep_class f4ba095546954b36 gnu_java_security_Engine
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class f02ab3ccb490a6d0 java_lang_ClassCastException
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class b7e704701c278e65 java_lang_IllegalStateException
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class 4f5534a987354d1d java_lang_RuntimeException
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class ae4a2342b31a268d java_lang_reflect_InvocationTargetException
// @dep_class 692089051f4c8d0b java_security_GeneralSecurityException
// @dep_class 327edce29f2562dd java_security_InvalidAlgorithmParameterException
// @dep_class 94dda41e9bf6c170 java_security_InvalidKeyException
// @dep_class a467c6cd05d9cc51 java_security_Key
// @dep_class 22e937c2536160b4 java_security_NoSuchAlgorithmException
// @dep_class 8dfbf242adab91e java_security_NoSuchProviderException
// @dep_class 81b073051aa30acc java_security_Provider
// @dep_class 15c6a62b25a6e96d java_security_SecureRandom
// @dep_class 89bf77984bd9669e java_security_Security
// @dep_class ef2e5e8af121478f java_security_spec_AlgorithmParameterSpec
// @dep_class c53e1575b095109b java_util_Vector
// @dep_class 4ff898a61be3baae javax_crypto_KeyAgreement
// @dep_class 980a4e6924ac71eb javax_crypto_KeyAgreementSpi
// @dep_class 4d0a282085f24fd7 javax_crypto_SecretKey
// @dep_class d79a62a9328ccea1 javax_crypto_ShortBufferException

// header file dependencies
// @dep_header gnu_java_security_Engine
// @dep_header java_lang_Class
// @dep_header java_lang_ClassCastException
// @dep_header java_lang_IllegalStateException
// @dep_header java_lang_String
// @dep_header java_lang_VMThrowable
// @dep_header java_lang_reflect_InvocationTargetException
// @dep_header java_security_InvalidAlgorithmParameterException
// @dep_header java_security_InvalidKeyException
// @dep_header java_security_Key
// @dep_header java_security_NoSuchAlgorithmException
// @dep_header java_security_NoSuchProviderException
// @dep_header java_security_Provider
// @dep_header java_security_SecureRandom
// @dep_header java_security_Security
// @dep_header java_security_spec_AlgorithmParameterSpec
// @dep_header java_util_Vector
// @dep_header javax_crypto_KeyAgreement
// @dep_header javax_crypto_KeyAgreementSpi
// @dep_header javax_crypto_SecretKey
// @dep_header javax_crypto_ShortBufferException

#include "jc_defs.h"

#include "gnu/java/security/Engine.h"
#include "java/lang/Class.h"
#include "java/lang/ClassCastException.h"
#include "java/lang/IllegalStateException.h"
#include "java/lang/String.h"
#include "java/lang/VMThrowable.h"
#include "java/lang/reflect/InvocationTargetException.h"
#include "java/security/InvalidAlgorithmParameterException.h"
#include "java/security/InvalidKeyException.h"
#include "java/security/Key.h"
#include "java/security/NoSuchAlgorithmException.h"
#include "java/security/NoSuchProviderException.h"
#include "java/security/Provider.h"
#include "java/security/SecureRandom.h"
#include "java/security/Security.h"
#include "java/security/spec/AlgorithmParameterSpec.h"
#include "java/util/Vector.h"
#include "javax/crypto/KeyAgreement.h"
#include "javax/crypto/KeyAgreementSpi.h"
#include "javax/crypto/SecretKey.h"
#include "javax/crypto/ShortBufferException.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// private static final java.lang.String SERVICE
static _jc_field _jc_javax_crypto_KeyAgreement$field_info$SERVICE = {
	.name=		"SERVICE",
	.signature=	"Ljava/lang/String;",
	.class=		&_jc_javax_crypto_KeyAgreement$type,
	.type=		&_jc_java_lang_String$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_KeyAgreement$fields_struct, SERVICE),
	.initial_value=	"KeyAgreement",
};

// private javax.crypto.KeyAgreementSpi kaSpi
static _jc_field _jc_javax_crypto_KeyAgreement$field_info$kaSpi = {
	.name=		"kaSpi",
	.signature=	"Ljavax/crypto/KeyAgreementSpi;",
	.class=		&_jc_javax_crypto_KeyAgreement$type,
	.type=		&_jc_javax_crypto_KeyAgreementSpi$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_KeyAgreement$object, refs[-1].javax_crypto_KeyAgreement.kaSpi),
};

// private java.security.Provider provider
static _jc_field _jc_javax_crypto_KeyAgreement$field_info$provider = {
	.name=		"provider",
	.signature=	"Ljava/security/Provider;",
	.class=		&_jc_javax_crypto_KeyAgreement$type,
	.type=		&_jc_java_security_Provider$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_KeyAgreement$object, refs[-1].javax_crypto_KeyAgreement.provider),
};

// private java.lang.String algorithm
static _jc_field _jc_javax_crypto_KeyAgreement$field_info$algorithm = {
	.name=		"algorithm",
	.signature=	"Ljava/lang/String;",
	.class=		&_jc_javax_crypto_KeyAgreement$type,
	.type=		&_jc_java_lang_String$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_KeyAgreement$object, refs[-1].javax_crypto_KeyAgreement.algorithm),
};

// private boolean virgin
static _jc_field _jc_javax_crypto_KeyAgreement$field_info$virgin = {
	.name=		"virgin",
	.signature=	"Z",
	.class=		&_jc_javax_crypto_KeyAgreement$type,
	.type=		&_jc_boolean$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_KeyAgreement$object, nonrefs.javax_crypto_KeyAgreement.virgin),
};

// Fields
static _jc_field *const _jc_javax_crypto_KeyAgreement$fields[] = {
	&_jc_javax_crypto_KeyAgreement$field_info$SERVICE,
	&_jc_javax_crypto_KeyAgreement$field_info$algorithm,
	&_jc_javax_crypto_KeyAgreement$field_info$kaSpi,
	&_jc_javax_crypto_KeyAgreement$field_info$provider,
	&_jc_javax_crypto_KeyAgreement$field_info$virgin
};

/************************************************************************
 *			      Static methods				*
 ************************************************************************/

//
// public static final javax.crypto.KeyAgreement getInstance(java.lang.String) throws java.security.NoSuchAlgorithmException
//

static _jc_linenum _jc_javax_crypto_KeyAgreement$linenum_table$getInstance$020cd12426e35ae5[];

static _jc_trap_info _jc_javax_crypto_KeyAgreement$trap_table$getInstance$020cd12426e35ae5[] = {
	_JC_TRAP(&_jc_java_security_NoSuchAlgorithmException$type, 1, 2),
};

static const unsigned char _jc_javax_crypto_KeyAgreement$param_ptypes$getInstance$020cd12426e35ae5[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_javax_crypto_KeyAgreement$exceptions$getInstance$020cd12426e35ae5[] = {
	&_jc_java_security_NoSuchAlgorithmException$type
};

static _jc_type *const _jc_javax_crypto_KeyAgreement$param_types$getInstance$020cd12426e35ae5[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_javax_crypto_KeyAgreement$method_info$getInstance$020cd12426e35ae5 = {
	.name=			"getInstance",
	.signature=		"(Ljava/lang/String;)Ljavax/crypto/KeyAgreement;",
	.class=			&_jc_javax_crypto_KeyAgreement$type,
	.param_types=		&_jc_javax_crypto_KeyAgreement$param_types$getInstance$020cd12426e35ae5,
	.return_type=		&_jc_javax_crypto_KeyAgreement$type,
	.param_ptypes=		&_jc_javax_crypto_KeyAgreement$param_ptypes$getInstance$020cd12426e35ae5,
	.signature_hash=	_JC_JLONG(0x20cd12426e35ae5),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_KeyAgreement$method$getInstance$020cd12426e35ae5,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_crypto_KeyAgreement$exceptions$getInstance$020cd12426e35ae5,
	.u= { .exec= {
	  .trap_table_len=	1,
	  .trap_table=		_jc_javax_crypto_KeyAgreement$trap_table$getInstance$020cd12426e35ae5,
	  .u= {
	    .linenum= {
	      .len=	7,
	      .table=	_jc_javax_crypto_KeyAgreement$linenum_table$getInstance$020cd12426e35ae5
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_KeyAgreement, getInstance$020cd12426e35ae5);

_jc_javax_crypto_KeyAgreement$object * _JC_JCNI_ATTR
_jc_javax_crypto_KeyAgreement$method$getInstance$020cd12426e35ae5(_jc_env *const env, _jc_java_lang_String$object *param0)
{
	jint volatile i0;
	jint volatile i1;
	jint i2;
	struct _jc_java_lang_String$object *volatile r0;
	struct _jc_java_lang_String$object *volatile r2;
	struct _jc_java_security_NoSuchAlgorithmException$object *volatile r3;
	struct _jc_java_security_Provider$object *volatile r4;
	struct _jc_javax_crypto_KeyAgreement$object *volatile r5;
	struct _jc_java_lang_VMThrowable$object *volatile r6;
	struct _jc_java_util_Vector$object *r7;
	_jc_object_array *volatile r8;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_javax_crypto_KeyAgreement$method_info$getInstance$020cd12426e35ae5, &&label1);

	r0 = param0;
	_JC_ACTIVE_USE(env, java_security_Security);
	_JC_LINE_NUMBER(119);				// 0
	r7 = _JC_STATIC_FIELD(env, java_security_Security, providers, 1);
	i2 = _JC_INVOKE_VIRTUAL(env, java_util_Vector, size$345df5220fc60ade, r7);
	r8 = _JC_NEW_REF_ARRAY(env, java_security_Provider, 1, i2);
	r7 = _JC_STATIC_FIELD(env, java_security_Security, providers, 1);
	_JC_INVOKE_VIRTUAL(env, java_util_Vector, copyInto$cd78d768b3ba4735, r7, r8);
	_JC_LINE_NUMBER(120);				// 1
	r2 = r0;
	_JC_LINE_NUMBER(121);				// 2
	i0 = 0;
	goto label2;

label0:
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(125);				// 3
	r4 = _JC_REF_ELEMENT(env, r8, i0, 1, 1);
	r5 = _JC_INVOKE_STATIC(env, javax_crypto_KeyAgreement, getInstance$9097735719e6cac4, 0, r0, r4);
	_JC_TRAP_REGION(catch, 2);
	_JC_CANCEL_TRAPS(env, catch);
	return r5;

label1:
	_JC_TRAP_REGION(catch, 2);
	r3 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(129);				// 4
	r2 = _JC_INVOKE_VIRTUAL(env, java_lang_Throwable, getMessage$13aaf240efc902b1, r3);
	_JC_LINE_NUMBER(121);				// 5
	i0 = i0 + 1;

label2:
	_JC_TRAP_REGION(catch, 2);
	i1 = _JC_ARRAY_LENGTH(env, r8);
	if (i0 < i1) {
		_JC_PERIODIC_CHECK(env);
		goto label0;
	}
	_JC_LINE_NUMBER(132);				// 6
	r3 = _JC_NEW(env, java_security_NoSuchAlgorithmException);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r6 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r6;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r2;
	_JC_THROW(env, r3);
}

//
// public static final javax.crypto.KeyAgreement getInstance(java.lang.String, java.lang.String) throws java.security.NoSuchAlgorithmException, java.security.NoSuchProviderException
//

static _jc_linenum _jc_javax_crypto_KeyAgreement$linenum_table$getInstance$3d73aa7803732a91[];

static const unsigned char _jc_javax_crypto_KeyAgreement$param_ptypes$getInstance$3d73aa7803732a91[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_javax_crypto_KeyAgreement$exceptions$getInstance$3d73aa7803732a91[] = {
	&_jc_java_security_NoSuchAlgorithmException$type,
	&_jc_java_security_NoSuchProviderException$type
};

static _jc_type *const _jc_javax_crypto_KeyAgreement$param_types$getInstance$3d73aa7803732a91[] = {
	&_jc_java_lang_String$type,
	&_jc_java_lang_String$type
};

_jc_method _jc_javax_crypto_KeyAgreement$method_info$getInstance$3d73aa7803732a91 = {
	.name=			"getInstance",
	.signature=		"(Ljava/lang/String;Ljava/lang/String;)Ljavax/crypto/KeyAgreement;",
	.class=			&_jc_javax_crypto_KeyAgreement$type,
	.param_types=		&_jc_javax_crypto_KeyAgreement$param_types$getInstance$3d73aa7803732a91,
	.return_type=		&_jc_javax_crypto_KeyAgreement$type,
	.param_ptypes=		&_jc_javax_crypto_KeyAgreement$param_ptypes$getInstance$3d73aa7803732a91,
	.signature_hash=	_JC_JLONG(0x3d73aa7803732a91),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_KeyAgreement$method$getInstance$3d73aa7803732a91,
	.num_parameters=	2,
	.num_exceptions=	2,
	.exceptions=		&_jc_javax_crypto_KeyAgreement$exceptions$getInstance$3d73aa7803732a91,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_javax_crypto_KeyAgreement$linenum_table$getInstance$3d73aa7803732a91
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_KeyAgreement, getInstance$3d73aa7803732a91);

_jc_javax_crypto_KeyAgreement$object * _JC_JCNI_ATTR
_jc_javax_crypto_KeyAgreement$method$getInstance$3d73aa7803732a91(_jc_env *const env, _jc_java_lang_String$object *param0, _jc_java_lang_String$object *param1)
{
	struct _jc_java_lang_String$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_java_security_Provider$object *r2;
	struct _jc_java_security_NoSuchProviderException$object *r3;
	struct _jc_javax_crypto_KeyAgreement$object *r4;
	struct _jc_java_lang_VMThrowable$object *r6;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = param0;
	r1 = param1;
	_JC_LINE_NUMBER(151);				// 0
	r2 = _JC_INVOKE_STATIC(env, java_security_Security, getProvider$581ee7d7bc9ae747, 0, r1);
	_JC_LINE_NUMBER(152);				// 1
	if (r2 != _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(154);				// 2
	r3 = _JC_NEW(env, java_security_NoSuchProviderException);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r6 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r6;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r1;
	_JC_THROW(env, r3);

label0:
	_JC_LINE_NUMBER(156);				// 3
	r4 = _JC_INVOKE_STATIC(env, javax_crypto_KeyAgreement, getInstance$9097735719e6cac4, 1, r0, r2);
	return r4;
}

//
// public static final javax.crypto.KeyAgreement getInstance(java.lang.String, java.security.Provider) throws java.security.NoSuchAlgorithmException
//

static _jc_linenum _jc_javax_crypto_KeyAgreement$linenum_table$getInstance$9097735719e6cac4[];

static _jc_trap_info _jc_javax_crypto_KeyAgreement$trap_table$getInstance$9097735719e6cac4[] = {
	_JC_TRAP(&_jc_java_lang_reflect_InvocationTargetException$type, 1, 2),
	_JC_TRAP(&_jc_java_lang_ClassCastException$type, 1, 2),
};

static const unsigned char _jc_javax_crypto_KeyAgreement$param_ptypes$getInstance$9097735719e6cac4[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_javax_crypto_KeyAgreement$exceptions$getInstance$9097735719e6cac4[] = {
	&_jc_java_security_NoSuchAlgorithmException$type
};

static _jc_type *const _jc_javax_crypto_KeyAgreement$param_types$getInstance$9097735719e6cac4[] = {
	&_jc_java_lang_String$type,
	&_jc_java_security_Provider$type
};

_jc_method _jc_javax_crypto_KeyAgreement$method_info$getInstance$9097735719e6cac4 = {
	.name=			"getInstance",
	.signature=		"(Ljava/lang/String;Ljava/security/Provider;)Ljavax/crypto/KeyAgreement;",
	.class=			&_jc_javax_crypto_KeyAgreement$type,
	.param_types=		&_jc_javax_crypto_KeyAgreement$param_types$getInstance$9097735719e6cac4,
	.return_type=		&_jc_javax_crypto_KeyAgreement$type,
	.param_ptypes=		&_jc_javax_crypto_KeyAgreement$param_ptypes$getInstance$9097735719e6cac4,
	.signature_hash=	_JC_JLONG(0x9097735719e6cac4),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_KeyAgreement$method$getInstance$9097735719e6cac4,
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_crypto_KeyAgreement$exceptions$getInstance$9097735719e6cac4,
	.u= { .exec= {
	  .trap_table_len=	2,
	  .trap_table=		_jc_javax_crypto_KeyAgreement$trap_table$getInstance$9097735719e6cac4,
	  .u= {
	    .linenum= {
	      .len=	7,
	      .table=	_jc_javax_crypto_KeyAgreement$linenum_table$getInstance$9097735719e6cac4
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_KeyAgreement, getInstance$9097735719e6cac4);

_jc_javax_crypto_KeyAgreement$object * _JC_JCNI_ATTR
_jc_javax_crypto_KeyAgreement$method$getInstance$9097735719e6cac4(_jc_env *const env, _jc_java_lang_String$object *param0, _jc_java_security_Provider$object *param1)
{
	struct _jc_java_lang_String$object *volatile r0;
	struct _jc_java_security_Provider$object *r1;
	struct _jc_java_lang_Object$object *r10;
	struct _jc_java_lang_VMThrowable$object *volatile r11;
	struct _jc_java_lang_VMThrowable$object *volatile r12;
	struct _jc_java_lang_VMThrowable$object *volatile r13;
	struct _jc_javax_crypto_KeyAgreement$object *r2;
	struct _jc_java_lang_reflect_InvocationTargetException$object *volatile r3;
	struct _jc_javax_crypto_KeyAgreementSpi$object *r4;
	struct _jc_java_lang_Throwable$object *volatile r5;
	struct _jc_java_security_NoSuchAlgorithmException$object *volatile r6;
	struct _jc_java_lang_ClassCastException$object *r7;
	struct _jc_java_lang_String$object *r8;
	_jc_object_array *r9;
	jboolean volatile z0;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_javax_crypto_KeyAgreement$method_info$getInstance$9097735719e6cac4, &&label0, &&label3);

	r0 = param0;
	r1 = param1;
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(174);				// 0
	r2 = _JC_NEW(env, javax_crypto_KeyAgreement);
	_JC_ACTIVE_USE(env, gnu_java_security_Engine);
	r8 = _JC_STRING(env, "KeyAgreement");
	r9 = _JC_STATIC_FIELD(env, gnu_java_security_Engine, NO__5fARGS, 1);
	r10 = _JC_INVOKE_STATIC(env, gnu_java_security_Engine, getInstance$ec89dfd35c234c64, 1, r8, r0, r1, r9);
	r4 = _JC_CAST(env, &_jc_javax_crypto_KeyAgreementSpi$type, r10);
	_JC_REF_FIELD(env, r2, javax_crypto_KeyAgreement, kaSpi) = r4;
	_JC_REF_FIELD(env, r2, javax_crypto_KeyAgreement, provider) = r1;
	_JC_REF_FIELD(env, r2, javax_crypto_KeyAgreement, algorithm) = r0;
	_JC_PRIM_FIELD(env, r2, javax_crypto_KeyAgreement, virgin) = 1;
	_JC_TRAP_REGION(catch, 2);
	_JC_CANCEL_TRAPS(env, catch);
	return r2;

label0:
	_JC_TRAP_REGION(catch, 2);
	r3 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(180);				// 1
	r5 = _JC_INVOKE_VIRTUAL(env, java_lang_reflect_InvocationTargetException, getCause$d5a96efc8523817a, r3);
	if (r5 != _JC_NULL)
		goto label1;
	_JC_LINE_NUMBER(181);				// 2
	r6 = _JC_NEW(env, java_security_NoSuchAlgorithmException);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, cause) = r6;
	r11 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r6);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, vmState) = r11;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, detailMessage) = r0;
	_JC_THROW(env, r6);

label1:
	_JC_LINE_NUMBER(182);				// 3
	r5 = _JC_INVOKE_VIRTUAL(env, java_lang_reflect_InvocationTargetException, getCause$d5a96efc8523817a, r3);
	z0 = _JC_INSTANCEOF(env, r5, &_jc_java_security_NoSuchAlgorithmException$type);
	if (z0 == 0)
		goto label2;
	_JC_LINE_NUMBER(183);				// 4
	r5 = _JC_INVOKE_VIRTUAL(env, java_lang_reflect_InvocationTargetException, getCause$d5a96efc8523817a, r3);
	r6 = _JC_CAST(env, &_jc_java_security_NoSuchAlgorithmException$type, r5);
	_JC_THROW(env, r6);

label2:
	_JC_LINE_NUMBER(184);				// 5
	r6 = _JC_NEW(env, java_security_NoSuchAlgorithmException);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, cause) = r6;
	r12 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r6);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, vmState) = r12;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, detailMessage) = r0;
	_JC_THROW(env, r6);

label3:
	_JC_TRAP_REGION(catch, 2);
	r7 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(188);				// 6
	r6 = _JC_NEW(env, java_security_NoSuchAlgorithmException);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, cause) = r6;
	r13 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r6);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, vmState) = r13;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, detailMessage) = r0;
	_JC_THROW(env, r6);
}

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// protected void <init>(javax.crypto.KeyAgreementSpi, java.security.Provider, java.lang.String)
//

static _jc_linenum _jc_javax_crypto_KeyAgreement$linenum_table$_init$c7b12617e8016909[];

static const unsigned char _jc_javax_crypto_KeyAgreement$param_ptypes$_init$c7b12617e8016909[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_KeyAgreement$param_types$_init$c7b12617e8016909[] = {
	&_jc_javax_crypto_KeyAgreementSpi$type,
	&_jc_java_security_Provider$type,
	&_jc_java_lang_String$type
};

_jc_method _jc_javax_crypto_KeyAgreement$method_info$_init$c7b12617e8016909 = {
	.name=			"<init>",
	.signature=		"(Ljavax/crypto/KeyAgreementSpi;Ljava/security/Provider;Ljava/lang/String;)V",
	.class=			&_jc_javax_crypto_KeyAgreement$type,
	.param_types=		&_jc_javax_crypto_KeyAgreement$param_types$_init$c7b12617e8016909,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_KeyAgreement$param_ptypes$_init$c7b12617e8016909,
	.signature_hash=	_JC_JLONG(0xc7b12617e8016909),
	.access_flags=		_JC_ACC_PROTECTED,
	.function=		&_jc_javax_crypto_KeyAgreement$method$_init$c7b12617e8016909,
	.num_parameters=	3,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_javax_crypto_KeyAgreement$linenum_table$_init$c7b12617e8016909
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_KeyAgreement, _init$c7b12617e8016909);

void _JC_JCNI_ATTR
_jc_javax_crypto_KeyAgreement$method$_init$c7b12617e8016909(_jc_env *const env, _jc_javax_crypto_KeyAgreement$object *this, _jc_javax_crypto_KeyAgreementSpi$object *param0, _jc_java_security_Provider$object *param1, _jc_java_lang_String$object *param2)
{
	struct _jc_javax_crypto_KeyAgreement$object *r0;
	struct _jc_javax_crypto_KeyAgreementSpi$object *r1;
	struct _jc_java_security_Provider$object *r2;
	struct _jc_java_lang_String$object *r3;

	r0 = this;
	r1 = param0;
	r2 = param1;
	r3 = param2;
	_JC_LINE_NUMBER(98);				// 0
	_JC_REF_FIELD(env, r0, javax_crypto_KeyAgreement, kaSpi) = r1;
	_JC_LINE_NUMBER(99);				// 1
	_JC_REF_FIELD(env, r0, javax_crypto_KeyAgreement, provider) = r2;
	_JC_LINE_NUMBER(100);				// 2
	_JC_REF_FIELD(env, r0, javax_crypto_KeyAgreement, algorithm) = r3;
	_JC_LINE_NUMBER(101);				// 3
	_JC_PRIM_FIELD(env, r0, javax_crypto_KeyAgreement, virgin) = 1;
	_JC_LINE_NUMBER(102);				// 4
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public final java.security.Key doPhase(java.security.Key, boolean) throws java.lang.IllegalStateException, java.security.InvalidKeyException
//

static _jc_linenum _jc_javax_crypto_KeyAgreement$linenum_table$doPhase$fbba63191ac2b012[];

static const unsigned char _jc_javax_crypto_KeyAgreement$param_ptypes$doPhase$fbba63191ac2b012[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_javax_crypto_KeyAgreement$exceptions$doPhase$fbba63191ac2b012[] = {
	&_jc_java_lang_IllegalStateException$type,
	&_jc_java_security_InvalidKeyException$type
};

static _jc_type *const _jc_javax_crypto_KeyAgreement$param_types$doPhase$fbba63191ac2b012[] = {
	&_jc_java_security_Key$type,
	&_jc_boolean$prim$type
};

_jc_method _jc_javax_crypto_KeyAgreement$method_info$doPhase$fbba63191ac2b012 = {
	.name=			"doPhase",
	.signature=		"(Ljava/security/Key;Z)Ljava/security/Key;",
	.class=			&_jc_javax_crypto_KeyAgreement$type,
	.param_types=		&_jc_javax_crypto_KeyAgreement$param_types$doPhase$fbba63191ac2b012,
	.return_type=		&_jc_java_security_Key$type,
	.param_ptypes=		&_jc_javax_crypto_KeyAgreement$param_ptypes$doPhase$fbba63191ac2b012,
	.signature_hash=	_JC_JLONG(0xfbba63191ac2b012),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_KeyAgreement$method$doPhase$fbba63191ac2b012,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_KeyAgreement$vtable, javax_crypto_KeyAgreement.doPhase$fbba63191ac2b012) / sizeof(void *),
	.num_parameters=	2,
	.num_exceptions=	2,
	.exceptions=		&_jc_javax_crypto_KeyAgreement$exceptions$doPhase$fbba63191ac2b012,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_javax_crypto_KeyAgreement$linenum_table$doPhase$fbba63191ac2b012
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_KeyAgreement, doPhase$fbba63191ac2b012);

_jc_object * _JC_JCNI_ATTR
_jc_javax_crypto_KeyAgreement$method$doPhase$fbba63191ac2b012(_jc_env *const env, _jc_javax_crypto_KeyAgreement$object *this, _jc_object *param0, jboolean param1)
{
	struct _jc_javax_crypto_KeyAgreement$object *r0;
	struct _jc_object *r1;
	struct _jc_java_lang_IllegalStateException$object *r2;
	struct _jc_javax_crypto_KeyAgreementSpi$object *r3;
	struct _jc_java_lang_String$object *r4;
	struct _jc_java_lang_VMThrowable$object *r6;
	jboolean z0;
	jboolean z1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	z0 = param1;
	_JC_LINE_NUMBER(214);				// 0
	z1 = _JC_PRIM_FIELD(env, r0, javax_crypto_KeyAgreement, virgin);
	if (z1 == 0)
		goto label0;
	_JC_LINE_NUMBER(216);				// 1
	r2 = _JC_NEW(env, java_lang_IllegalStateException);
	r4 = _JC_STRING(env, "not initialized");
	_JC_REF_FIELD(env, r2, java_lang_Throwable, cause) = r2;
	r6 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r2);
	_JC_REF_FIELD(env, r2, java_lang_Throwable, vmState) = r6;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, detailMessage) = r4;
	_JC_THROW(env, r2);

label0:
	_JC_LINE_NUMBER(218);				// 2
	r3 = _JC_REF_FIELD(env, r0, javax_crypto_KeyAgreement, kaSpi);
	r1 = _JC_INVOKE_VIRTUAL(env, javax_crypto_KeyAgreementSpi, engineDoPhase$2aeb266111cb1ab6, r3, r1, z0);
	return r1;
}

//
// public final byte[] generateSecret() throws java.lang.IllegalStateException
//

static _jc_linenum _jc_javax_crypto_KeyAgreement$linenum_table$generateSecret$4b58ab82da2a6186[];

static const unsigned char _jc_javax_crypto_KeyAgreement$param_ptypes$generateSecret$4b58ab82da2a6186[] = { 
_JC_TYPE_REFERENCE };

static _jc_type *const _jc_javax_crypto_KeyAgreement$exceptions$generateSecret$4b58ab82da2a6186[] = {
	&_jc_java_lang_IllegalStateException$type
};

_jc_method _jc_javax_crypto_KeyAgreement$method_info$generateSecret$4b58ab82da2a6186 = {
	.name=			"generateSecret",
	.signature=		"()[B",
	.class=			&_jc_javax_crypto_KeyAgreement$type,
	.return_type=		&_jc_byte$array$prim$type,
	.param_ptypes=		&_jc_javax_crypto_KeyAgreement$param_ptypes$generateSecret$4b58ab82da2a6186,
	.signature_hash=	_JC_JLONG(0x4b58ab82da2a6186),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_KeyAgreement$method$generateSecret$4b58ab82da2a6186,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_KeyAgreement$vtable, javax_crypto_KeyAgreement.generateSecret$4b58ab82da2a6186) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_crypto_KeyAgreement$exceptions$generateSecret$4b58ab82da2a6186,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_javax_crypto_KeyAgreement$linenum_table$generateSecret$4b58ab82da2a6186
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_KeyAgreement, generateSecret$4b58ab82da2a6186);

_jc_byte_array * _JC_JCNI_ATTR
_jc_javax_crypto_KeyAgreement$method$generateSecret$4b58ab82da2a6186(_jc_env *const env, _jc_javax_crypto_KeyAgreement$object *this)
{
	struct _jc_javax_crypto_KeyAgreement$object *r0;
	struct _jc_java_lang_IllegalStateException$object *r1;
	struct _jc_javax_crypto_KeyAgreementSpi$object *r2;
	_jc_byte_array *r3;
	struct _jc_java_lang_String$object *r4;
	struct _jc_java_lang_VMThrowable$object *r6;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(231);				// 0
	z0 = _JC_PRIM_FIELD(env, r0, javax_crypto_KeyAgreement, virgin);
	if (z0 == 0)
		goto label0;
	_JC_LINE_NUMBER(233);				// 1
	r1 = _JC_NEW(env, java_lang_IllegalStateException);
	r4 = _JC_STRING(env, "not initialized");
	_JC_REF_FIELD(env, r1, java_lang_Throwable, cause) = r1;
	r6 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r1);
	_JC_REF_FIELD(env, r1, java_lang_Throwable, vmState) = r6;
	_JC_REF_FIELD(env, r1, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r1, java_lang_Throwable, detailMessage) = r4;
	_JC_THROW(env, r1);

label0:
	_JC_LINE_NUMBER(235);				// 2
	r2 = _JC_REF_FIELD(env, r0, javax_crypto_KeyAgreement, kaSpi);
	r3 = _JC_INVOKE_VIRTUAL(env, javax_crypto_KeyAgreementSpi, engineGenerateSecret$0d3a673275543f27, r2);
	return r3;
}

//
// public final javax.crypto.SecretKey generateSecret(java.lang.String) throws java.lang.IllegalStateException, java.security.InvalidKeyException, java.security.NoSuchAlgorithmException
//

static _jc_linenum _jc_javax_crypto_KeyAgreement$linenum_table$generateSecret$f958dc17de78cd9b[];

static const unsigned char _jc_javax_crypto_KeyAgreement$param_ptypes$generateSecret$f958dc17de78cd9b[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_javax_crypto_KeyAgreement$exceptions$generateSecret$f958dc17de78cd9b[] = {
	&_jc_java_lang_IllegalStateException$type,
	&_jc_java_security_InvalidKeyException$type,
	&_jc_java_security_NoSuchAlgorithmException$type
};

static _jc_type *const _jc_javax_crypto_KeyAgreement$param_types$generateSecret$f958dc17de78cd9b[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_javax_crypto_KeyAgreement$method_info$generateSecret$f958dc17de78cd9b = {
	.name=			"generateSecret",
	.signature=		"(Ljava/lang/String;)Ljavax/crypto/SecretKey;",
	.class=			&_jc_javax_crypto_KeyAgreement$type,
	.param_types=		&_jc_javax_crypto_KeyAgreement$param_types$generateSecret$f958dc17de78cd9b,
	.return_type=		&_jc_javax_crypto_SecretKey$type,
	.param_ptypes=		&_jc_javax_crypto_KeyAgreement$param_ptypes$generateSecret$f958dc17de78cd9b,
	.signature_hash=	_JC_JLONG(0xf958dc17de78cd9b),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_KeyAgreement$method$generateSecret$f958dc17de78cd9b,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_KeyAgreement$vtable, javax_crypto_KeyAgreement.generateSecret$f958dc17de78cd9b) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	3,
	.exceptions=		&_jc_javax_crypto_KeyAgreement$exceptions$generateSecret$f958dc17de78cd9b,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_javax_crypto_KeyAgreement$linenum_table$generateSecret$f958dc17de78cd9b
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_KeyAgreement, generateSecret$f958dc17de78cd9b);

_jc_object * _JC_JCNI_ATTR
_jc_javax_crypto_KeyAgreement$method$generateSecret$f958dc17de78cd9b(_jc_env *const env, _jc_javax_crypto_KeyAgreement$object *this, _jc_java_lang_String$object *param0)
{
	struct _jc_javax_crypto_KeyAgreement$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_java_lang_IllegalStateException$object *r2;
	struct _jc_javax_crypto_KeyAgreementSpi$object *r3;
	struct _jc_object *r4;
	struct _jc_java_lang_String$object *r5;
	struct _jc_java_lang_VMThrowable$object *r7;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(278);				// 0
	z0 = _JC_PRIM_FIELD(env, r0, javax_crypto_KeyAgreement, virgin);
	if (z0 == 0)
		goto label0;
	_JC_LINE_NUMBER(280);				// 1
	r2 = _JC_NEW(env, java_lang_IllegalStateException);
	r5 = _JC_STRING(env, "not initialized");
	_JC_REF_FIELD(env, r2, java_lang_Throwable, cause) = r2;
	r7 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r2);
	_JC_REF_FIELD(env, r2, java_lang_Throwable, vmState) = r7;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, detailMessage) = r5;
	_JC_THROW(env, r2);

label0:
	_JC_LINE_NUMBER(282);				// 2
	r3 = _JC_REF_FIELD(env, r0, javax_crypto_KeyAgreement, kaSpi);
	r4 = _JC_INVOKE_VIRTUAL(env, javax_crypto_KeyAgreementSpi, engineGenerateSecret$2352395e15ac97a4, r3, r1);
	return r4;
}

//
// public final int generateSecret(byte[], int) throws java.lang.IllegalStateException, javax.crypto.ShortBufferException
//

static _jc_linenum _jc_javax_crypto_KeyAgreement$linenum_table$generateSecret$f29c38958d3083c3[];

static const unsigned char _jc_javax_crypto_KeyAgreement$param_ptypes$generateSecret$f29c38958d3083c3[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_INT };

static _jc_type *const _jc_javax_crypto_KeyAgreement$exceptions$generateSecret$f29c38958d3083c3[] = {
	&_jc_java_lang_IllegalStateException$type,
	&_jc_javax_crypto_ShortBufferException$type
};

static _jc_type *const _jc_javax_crypto_KeyAgreement$param_types$generateSecret$f29c38958d3083c3[] = {
	&_jc_byte$array$prim$type,
	&_jc_int$prim$type
};

_jc_method _jc_javax_crypto_KeyAgreement$method_info$generateSecret$f29c38958d3083c3 = {
	.name=			"generateSecret",
	.signature=		"([BI)I",
	.class=			&_jc_javax_crypto_KeyAgreement$type,
	.param_types=		&_jc_javax_crypto_KeyAgreement$param_types$generateSecret$f29c38958d3083c3,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_javax_crypto_KeyAgreement$param_ptypes$generateSecret$f29c38958d3083c3,
	.signature_hash=	_JC_JLONG(0xf29c38958d3083c3),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_KeyAgreement$method$generateSecret$f29c38958d3083c3,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_KeyAgreement$vtable, javax_crypto_KeyAgreement.generateSecret$f29c38958d3083c3) / sizeof(void *),
	.num_parameters=	2,
	.num_exceptions=	2,
	.exceptions=		&_jc_javax_crypto_KeyAgreement$exceptions$generateSecret$f29c38958d3083c3,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_javax_crypto_KeyAgreement$linenum_table$generateSecret$f29c38958d3083c3
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_KeyAgreement, generateSecret$f29c38958d3083c3);

jint _JC_JCNI_ATTR
_jc_javax_crypto_KeyAgreement$method$generateSecret$f29c38958d3083c3(_jc_env *const env, _jc_javax_crypto_KeyAgreement$object *this, _jc_byte_array *param0, jint param1)
{
	jint i0;
	struct _jc_javax_crypto_KeyAgreement$object *r0;
	_jc_byte_array *r1;
	struct _jc_java_lang_IllegalStateException$object *r2;
	struct _jc_javax_crypto_KeyAgreementSpi$object *r3;
	struct _jc_java_lang_String$object *r4;
	struct _jc_java_lang_VMThrowable$object *r6;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	i0 = param1;
	_JC_LINE_NUMBER(254);				// 0
	z0 = _JC_PRIM_FIELD(env, r0, javax_crypto_KeyAgreement, virgin);
	if (z0 == 0)
		goto label0;
	_JC_LINE_NUMBER(256);				// 1
	r2 = _JC_NEW(env, java_lang_IllegalStateException);
	r4 = _JC_STRING(env, "not initialized");
	_JC_REF_FIELD(env, r2, java_lang_Throwable, cause) = r2;
	r6 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r2);
	_JC_REF_FIELD(env, r2, java_lang_Throwable, vmState) = r6;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, detailMessage) = r4;
	_JC_THROW(env, r2);

label0:
	_JC_LINE_NUMBER(258);				// 2
	r3 = _JC_REF_FIELD(env, r0, javax_crypto_KeyAgreement, kaSpi);
	i0 = _JC_INVOKE_VIRTUAL(env, javax_crypto_KeyAgreementSpi, engineGenerateSecret$c9abb8eed99c67eb, r3, r1, i0);
	return i0;
}

//
// public final java.lang.String getAlgorithm()
//

static _jc_linenum _jc_javax_crypto_KeyAgreement$linenum_table$getAlgorithm$19abbbc132b9063a[];

static const unsigned char _jc_javax_crypto_KeyAgreement$param_ptypes$getAlgorithm$19abbbc132b9063a[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_javax_crypto_KeyAgreement$method_info$getAlgorithm$19abbbc132b9063a = {
	.name=			"getAlgorithm",
	.signature=		"()Ljava/lang/String;",
	.class=			&_jc_javax_crypto_KeyAgreement$type,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_javax_crypto_KeyAgreement$param_ptypes$getAlgorithm$19abbbc132b9063a,
	.signature_hash=	_JC_JLONG(0x19abbbc132b9063a),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_KeyAgreement$method$getAlgorithm$19abbbc132b9063a,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_KeyAgreement$vtable, javax_crypto_KeyAgreement.getAlgorithm$19abbbc132b9063a) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_crypto_KeyAgreement$linenum_table$getAlgorithm$19abbbc132b9063a
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_KeyAgreement, getAlgorithm$19abbbc132b9063a);

_jc_java_lang_String$object * _JC_JCNI_ATTR
_jc_javax_crypto_KeyAgreement$method$getAlgorithm$19abbbc132b9063a(_jc_env *const env, _jc_javax_crypto_KeyAgreement$object *this)
{
	struct _jc_javax_crypto_KeyAgreement$object *r0;
	struct _jc_java_lang_String$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(292);				// 0
	r1 = _JC_REF_FIELD(env, r0, javax_crypto_KeyAgreement, algorithm);
	return r1;
}

//
// public final java.security.Provider getProvider()
//

static _jc_linenum _jc_javax_crypto_KeyAgreement$linenum_table$getProvider$e8f9c9fb14140d5a[];

static const unsigned char _jc_javax_crypto_KeyAgreement$param_ptypes$getProvider$e8f9c9fb14140d5a[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_javax_crypto_KeyAgreement$method_info$getProvider$e8f9c9fb14140d5a = {
	.name=			"getProvider",
	.signature=		"()Ljava/security/Provider;",
	.class=			&_jc_javax_crypto_KeyAgreement$type,
	.return_type=		&_jc_java_security_Provider$type,
	.param_ptypes=		&_jc_javax_crypto_KeyAgreement$param_ptypes$getProvider$e8f9c9fb14140d5a,
	.signature_hash=	_JC_JLONG(0xe8f9c9fb14140d5a),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_KeyAgreement$method$getProvider$e8f9c9fb14140d5a,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_KeyAgreement$vtable, javax_crypto_KeyAgreement.getProvider$e8f9c9fb14140d5a) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_crypto_KeyAgreement$linenum_table$getProvider$e8f9c9fb14140d5a
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_KeyAgreement, getProvider$e8f9c9fb14140d5a);

_jc_java_security_Provider$object * _JC_JCNI_ATTR
_jc_javax_crypto_KeyAgreement$method$getProvider$e8f9c9fb14140d5a(_jc_env *const env, _jc_javax_crypto_KeyAgreement$object *this)
{
	struct _jc_javax_crypto_KeyAgreement$object *r0;
	struct _jc_java_security_Provider$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(302);				// 0
	r1 = _JC_REF_FIELD(env, r0, javax_crypto_KeyAgreement, provider);
	return r1;
}

//
// public final void init(java.security.Key) throws java.security.InvalidKeyException
//

static _jc_linenum _jc_javax_crypto_KeyAgreement$linenum_table$init$a20ac47f1570a2f7[];

static const unsigned char _jc_javax_crypto_KeyAgreement$param_ptypes$init$a20ac47f1570a2f7[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_KeyAgreement$exceptions$init$a20ac47f1570a2f7[] = {
	&_jc_java_security_InvalidKeyException$type
};

static _jc_type *const _jc_javax_crypto_KeyAgreement$param_types$init$a20ac47f1570a2f7[] = {
	&_jc_java_security_Key$type
};

_jc_method _jc_javax_crypto_KeyAgreement$method_info$init$a20ac47f1570a2f7 = {
	.name=			"init",
	.signature=		"(Ljava/security/Key;)V",
	.class=			&_jc_javax_crypto_KeyAgreement$type,
	.param_types=		&_jc_javax_crypto_KeyAgreement$param_types$init$a20ac47f1570a2f7,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_KeyAgreement$param_ptypes$init$a20ac47f1570a2f7,
	.signature_hash=	_JC_JLONG(0xa20ac47f1570a2f7),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_KeyAgreement$method$init$a20ac47f1570a2f7,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_KeyAgreement$vtable, javax_crypto_KeyAgreement.init$a20ac47f1570a2f7) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_crypto_KeyAgreement$exceptions$init$a20ac47f1570a2f7,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_javax_crypto_KeyAgreement$linenum_table$init$a20ac47f1570a2f7
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_KeyAgreement, init$a20ac47f1570a2f7);

void _JC_JCNI_ATTR
_jc_javax_crypto_KeyAgreement$method$init$a20ac47f1570a2f7(_jc_env *const env, _jc_javax_crypto_KeyAgreement$object *this, _jc_object *param0)
{
	struct _jc_javax_crypto_KeyAgreement$object *r0;
	struct _jc_object *r1;
	struct _jc_java_security_SecureRandom$object *r2;
	struct _jc_javax_crypto_KeyAgreementSpi$object *r6;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(316);				// 0
	r2 = _JC_NEW(env, java_security_SecureRandom);
	_JC_INVOKE_NONVIRTUAL(env, java_security_SecureRandom, _init$52f4ad9f2989aeee, 0, r2);
	r6 = _JC_REF_FIELD(env, r0, javax_crypto_KeyAgreement, kaSpi);
	_JC_INVOKE_VIRTUAL(env, javax_crypto_KeyAgreementSpi, engineInit$f38df8433d97b002, r6, r1, r2);
	_JC_PRIM_FIELD(env, r0, javax_crypto_KeyAgreement, virgin) = 0;
	_JC_LINE_NUMBER(317);				// 1
	return;
}

//
// public final void init(java.security.Key, java.security.SecureRandom) throws java.security.InvalidKeyException
//

static _jc_linenum _jc_javax_crypto_KeyAgreement$linenum_table$init$f32d4b1ad3cca66c[];

static const unsigned char _jc_javax_crypto_KeyAgreement$param_ptypes$init$f32d4b1ad3cca66c[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_KeyAgreement$exceptions$init$f32d4b1ad3cca66c[] = {
	&_jc_java_security_InvalidKeyException$type
};

static _jc_type *const _jc_javax_crypto_KeyAgreement$param_types$init$f32d4b1ad3cca66c[] = {
	&_jc_java_security_Key$type,
	&_jc_java_security_SecureRandom$type
};

_jc_method _jc_javax_crypto_KeyAgreement$method_info$init$f32d4b1ad3cca66c = {
	.name=			"init",
	.signature=		"(Ljava/security/Key;Ljava/security/SecureRandom;)V",
	.class=			&_jc_javax_crypto_KeyAgreement$type,
	.param_types=		&_jc_javax_crypto_KeyAgreement$param_types$init$f32d4b1ad3cca66c,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_KeyAgreement$param_ptypes$init$f32d4b1ad3cca66c,
	.signature_hash=	_JC_JLONG(0xf32d4b1ad3cca66c),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_KeyAgreement$method$init$f32d4b1ad3cca66c,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_KeyAgreement$vtable, javax_crypto_KeyAgreement.init$f32d4b1ad3cca66c) / sizeof(void *),
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_crypto_KeyAgreement$exceptions$init$f32d4b1ad3cca66c,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_javax_crypto_KeyAgreement$linenum_table$init$f32d4b1ad3cca66c
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_KeyAgreement, init$f32d4b1ad3cca66c);

void _JC_JCNI_ATTR
_jc_javax_crypto_KeyAgreement$method$init$f32d4b1ad3cca66c(_jc_env *const env, _jc_javax_crypto_KeyAgreement$object *this, _jc_object *param0, _jc_java_security_SecureRandom$object *param1)
{
	struct _jc_javax_crypto_KeyAgreement$object *r0;
	struct _jc_object *r1;
	struct _jc_java_security_SecureRandom$object *r2;
	struct _jc_javax_crypto_KeyAgreementSpi$object *r3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_LINE_NUMBER(331);				// 0
	r3 = _JC_REF_FIELD(env, r0, javax_crypto_KeyAgreement, kaSpi);
	_JC_INVOKE_VIRTUAL(env, javax_crypto_KeyAgreementSpi, engineInit$f38df8433d97b002, r3, r1, r2);
	_JC_LINE_NUMBER(332);				// 1
	_JC_PRIM_FIELD(env, r0, javax_crypto_KeyAgreement, virgin) = 0;
	_JC_LINE_NUMBER(333);				// 2
	return;
}

//
// public final void init(java.security.Key, java.security.spec.AlgorithmParameterSpec) throws java.security.InvalidAlgorithmParameterException, java.security.InvalidKeyException
//

static _jc_linenum _jc_javax_crypto_KeyAgreement$linenum_table$init$24fee54d988e28f1[];

static const unsigned char _jc_javax_crypto_KeyAgreement$param_ptypes$init$24fee54d988e28f1[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_KeyAgreement$exceptions$init$24fee54d988e28f1[] = {
	&_jc_java_security_InvalidAlgorithmParameterException$type,
	&_jc_java_security_InvalidKeyException$type
};

static _jc_type *const _jc_javax_crypto_KeyAgreement$param_types$init$24fee54d988e28f1[] = {
	&_jc_java_security_Key$type,
	&_jc_java_security_spec_AlgorithmParameterSpec$type
};

_jc_method _jc_javax_crypto_KeyAgreement$method_info$init$24fee54d988e28f1 = {
	.name=			"init",
	.signature=		"(Ljava/security/Key;Ljava/security/spec/AlgorithmParameterSpec;)V",
	.class=			&_jc_javax_crypto_KeyAgreement$type,
	.param_types=		&_jc_javax_crypto_KeyAgreement$param_types$init$24fee54d988e28f1,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_KeyAgreement$param_ptypes$init$24fee54d988e28f1,
	.signature_hash=	_JC_JLONG(0x24fee54d988e28f1),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_KeyAgreement$method$init$24fee54d988e28f1,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_KeyAgreement$vtable, javax_crypto_KeyAgreement.init$24fee54d988e28f1) / sizeof(void *),
	.num_parameters=	2,
	.num_exceptions=	2,
	.exceptions=		&_jc_javax_crypto_KeyAgreement$exceptions$init$24fee54d988e28f1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_javax_crypto_KeyAgreement$linenum_table$init$24fee54d988e28f1
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_KeyAgreement, init$24fee54d988e28f1);

void _JC_JCNI_ATTR
_jc_javax_crypto_KeyAgreement$method$init$24fee54d988e28f1(_jc_env *const env, _jc_javax_crypto_KeyAgreement$object *this, _jc_object *param0, _jc_object *param1)
{
	struct _jc_javax_crypto_KeyAgreement$object *r0;
	struct _jc_object *r1;
	struct _jc_object *r2;
	struct _jc_java_security_SecureRandom$object *r3;
	struct _jc_javax_crypto_KeyAgreementSpi$object *r8;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_LINE_NUMBER(350);				// 0
	r3 = _JC_NEW(env, java_security_SecureRandom);
	_JC_INVOKE_NONVIRTUAL(env, java_security_SecureRandom, _init$52f4ad9f2989aeee, 0, r3);
	r8 = _JC_REF_FIELD(env, r0, javax_crypto_KeyAgreement, kaSpi);
	_JC_INVOKE_VIRTUAL(env, javax_crypto_KeyAgreementSpi, engineInit$e7aed39dc41e0e2b, r8, r1, r2, r3);
	_JC_PRIM_FIELD(env, r0, javax_crypto_KeyAgreement, virgin) = 0;
	_JC_LINE_NUMBER(351);				// 1
	return;
}

//
// public final void init(java.security.Key, java.security.spec.AlgorithmParameterSpec, java.security.SecureRandom) throws java.security.InvalidAlgorithmParameterException, java.security.InvalidKeyException
//

static _jc_linenum _jc_javax_crypto_KeyAgreement$linenum_table$init$a3955f7c3e3e1325[];

static const unsigned char _jc_javax_crypto_KeyAgreement$param_ptypes$init$a3955f7c3e3e1325[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_KeyAgreement$exceptions$init$a3955f7c3e3e1325[] = {
	&_jc_java_security_InvalidAlgorithmParameterException$type,
	&_jc_java_security_InvalidKeyException$type
};

static _jc_type *const _jc_javax_crypto_KeyAgreement$param_types$init$a3955f7c3e3e1325[] = {
	&_jc_java_security_Key$type,
	&_jc_java_security_spec_AlgorithmParameterSpec$type,
	&_jc_java_security_SecureRandom$type
};

_jc_method _jc_javax_crypto_KeyAgreement$method_info$init$a3955f7c3e3e1325 = {
	.name=			"init",
	.signature=		"(Ljava/security/Key;Ljava/security/spec/AlgorithmParameterSpec;Ljava/security/SecureRandom;)V",
	.class=			&_jc_javax_crypto_KeyAgreement$type,
	.param_types=		&_jc_javax_crypto_KeyAgreement$param_types$init$a3955f7c3e3e1325,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_KeyAgreement$param_ptypes$init$a3955f7c3e3e1325,
	.signature_hash=	_JC_JLONG(0xa3955f7c3e3e1325),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_KeyAgreement$method$init$a3955f7c3e3e1325,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_KeyAgreement$vtable, javax_crypto_KeyAgreement.init$a3955f7c3e3e1325) / sizeof(void *),
	.num_parameters=	3,
	.num_exceptions=	2,
	.exceptions=		&_jc_javax_crypto_KeyAgreement$exceptions$init$a3955f7c3e3e1325,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_javax_crypto_KeyAgreement$linenum_table$init$a3955f7c3e3e1325
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_KeyAgreement, init$a3955f7c3e3e1325);

void _JC_JCNI_ATTR
_jc_javax_crypto_KeyAgreement$method$init$a3955f7c3e3e1325(_jc_env *const env, _jc_javax_crypto_KeyAgreement$object *this, _jc_object *param0, _jc_object *param1, _jc_java_security_SecureRandom$object *param2)
{
	struct _jc_javax_crypto_KeyAgreement$object *r0;
	struct _jc_object *r1;
	struct _jc_object *r2;
	struct _jc_java_security_SecureRandom$object *r3;
	struct _jc_javax_crypto_KeyAgreementSpi$object *r4;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	r3 = param2;
	_JC_LINE_NUMBER(369);				// 0
	r4 = _JC_REF_FIELD(env, r0, javax_crypto_KeyAgreement, kaSpi);
	_JC_INVOKE_VIRTUAL(env, javax_crypto_KeyAgreementSpi, engineInit$e7aed39dc41e0e2b, r4, r1, r2, r3);
	_JC_LINE_NUMBER(370);				// 1
	_JC_PRIM_FIELD(env, r0, javax_crypto_KeyAgreement, virgin) = 0;
	_JC_LINE_NUMBER(371);				// 2
	return;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_javax_crypto_KeyAgreement$methods[] = {
	&_jc_javax_crypto_KeyAgreement$method_info$_init$c7b12617e8016909,
	&_jc_javax_crypto_KeyAgreement$method_info$doPhase$fbba63191ac2b012,
	&_jc_javax_crypto_KeyAgreement$method_info$generateSecret$4b58ab82da2a6186,
	&_jc_javax_crypto_KeyAgreement$method_info$generateSecret$f958dc17de78cd9b,
	&_jc_javax_crypto_KeyAgreement$method_info$generateSecret$f29c38958d3083c3,
	&_jc_javax_crypto_KeyAgreement$method_info$getAlgorithm$19abbbc132b9063a,
	&_jc_javax_crypto_KeyAgreement$method_info$getInstance$020cd12426e35ae5,
	&_jc_javax_crypto_KeyAgreement$method_info$getInstance$3d73aa7803732a91,
	&_jc_javax_crypto_KeyAgreement$method_info$getInstance$9097735719e6cac4,
	&_jc_javax_crypto_KeyAgreement$method_info$getProvider$e8f9c9fb14140d5a,
	&_jc_javax_crypto_KeyAgreement$method_info$init$a20ac47f1570a2f7,
	&_jc_javax_crypto_KeyAgreement$method_info$init$f32d4b1ad3cca66c,
	&_jc_javax_crypto_KeyAgreement$method_info$init$24fee54d988e28f1,
	&_jc_javax_crypto_KeyAgreement$method_info$init$a3955f7c3e3e1325
};

/************************************************************************
 *			  Class fields structure			*
 ************************************************************************/

_jc_javax_crypto_KeyAgreement$fields_struct _jc_javax_crypto_KeyAgreement$class_fields = { };

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_javax_crypto_KeyAgreement$instanceof_hash_bucket_46[] = {
	&_jc_javax_crypto_KeyAgreement$type,
	_JC_NULL
};
static _jc_type *const _jc_javax_crypto_KeyAgreement$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_javax_crypto_KeyAgreement$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[46]=	_jc_javax_crypto_KeyAgreement$instanceof_hash_bucket_46,
	[101]=	_jc_javax_crypto_KeyAgreement$instanceof_hash_bucket_101
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_javax_crypto_KeyAgreement$class_depends[] = {
	{ "gnu/java/security/Engine",	_JC_JLONG(0xf4ba095546954b36) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/ClassCastException",	_JC_JLONG(0xf02ab3ccb490a6d0) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/IllegalStateException",	_JC_JLONG(0xb7e704701c278e65) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/RuntimeException",	_JC_JLONG(0x4f5534a987354d1d) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/lang/reflect/InvocationTargetException",	_JC_JLONG(0xae4a2342b31a268d) },
	{ "java/security/GeneralSecurityException",	_JC_JLONG(0x692089051f4c8d0b) },
	{ "java/security/InvalidAlgorithmParameterException",	_JC_JLONG(0x327edce29f2562dd) },
	{ "java/security/InvalidKeyException",	_JC_JLONG(0x94dda41e9bf6c170) },
	{ "java/security/Key",	_JC_JLONG(0xa467c6cd05d9cc51) },
	{ "java/security/NoSuchAlgorithmException",	_JC_JLONG(0x22e937c2536160b4) },
	{ "java/security/NoSuchProviderException",	_JC_JLONG(0x8dfbf242adab91e) },
	{ "java/security/Provider",	_JC_JLONG(0x81b073051aa30acc) },
	{ "java/security/SecureRandom",	_JC_JLONG(0x15c6a62b25a6e96d) },
	{ "java/security/Security",	_JC_JLONG(0x89bf77984bd9669e) },
	{ "java/security/spec/AlgorithmParameterSpec",	_JC_JLONG(0xef2e5e8af121478f) },
	{ "java/util/Vector",	_JC_JLONG(0xc53e1575b095109b) },
	{ "javax/crypto/KeyAgreementSpi",	_JC_JLONG(0x980a4e6924ac71eb) },
	{ "javax/crypto/SecretKey",	_JC_JLONG(0x4d0a282085f24fd7) },
	{ "javax/crypto/ShortBufferException",	_JC_JLONG(0xd79a62a9328ccea1) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_javax_crypto_KeyAgreement$vtype _jc_javax_crypto_KeyAgreement$type = {
    .type= {
	.name=			"javax/crypto/KeyAgreement",
	.superclass=		&_jc_java_lang_Object$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		21,
		.hash=			_JC_JLONG(0x4ff898a61be3baae),
		.source_file=		"KeyAgreement.java",
		.instance_size=		sizeof(_jc_javax_crypto_KeyAgreement$refs) + sizeof(_jc_javax_crypto_KeyAgreement$object),
		.num_virtual_refs=	3,
		.num_fields=		sizeof(_jc_javax_crypto_KeyAgreement$fields) / sizeof(*_jc_javax_crypto_KeyAgreement$fields),
		.fields=		_jc_javax_crypto_KeyAgreement$fields,
		.num_methods=		sizeof(_jc_javax_crypto_KeyAgreement$methods) / sizeof(*_jc_javax_crypto_KeyAgreement$methods),
		.methods=		_jc_javax_crypto_KeyAgreement$methods,
		.instanceof_hash_table=	_jc_javax_crypto_KeyAgreement$instanceof_hash_table,
		.class_fields=		&_jc_javax_crypto_KeyAgreement$class_fields,
		.num_class_depends=		sizeof(_jc_javax_crypto_KeyAgreement$class_depends) / sizeof(*_jc_javax_crypto_KeyAgreement$class_depends),
		.class_depends=		_jc_javax_crypto_KeyAgreement$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.javax_crypto_KeyAgreement= {
	    .doPhase$fbba63191ac2b012=
		&_jc_javax_crypto_KeyAgreement$method$doPhase$fbba63191ac2b012,
	    .generateSecret$4b58ab82da2a6186=
		&_jc_javax_crypto_KeyAgreement$method$generateSecret$4b58ab82da2a6186,
	    .generateSecret$f958dc17de78cd9b=
		&_jc_javax_crypto_KeyAgreement$method$generateSecret$f958dc17de78cd9b,
	    .generateSecret$f29c38958d3083c3=
		&_jc_javax_crypto_KeyAgreement$method$generateSecret$f29c38958d3083c3,
	    .getAlgorithm$19abbbc132b9063a=
		&_jc_javax_crypto_KeyAgreement$method$getAlgorithm$19abbbc132b9063a,
	    .getProvider$e8f9c9fb14140d5a=
		&_jc_javax_crypto_KeyAgreement$method$getProvider$e8f9c9fb14140d5a,
	    .init$a20ac47f1570a2f7=
		&_jc_javax_crypto_KeyAgreement$method$init$a20ac47f1570a2f7,
	    .init$f32d4b1ad3cca66c=
		&_jc_javax_crypto_KeyAgreement$method$init$f32d4b1ad3cca66c,
	    .init$24fee54d988e28f1=
		&_jc_javax_crypto_KeyAgreement$method$init$24fee54d988e28f1,
	    .init$a3955f7c3e3e1325=
		&_jc_javax_crypto_KeyAgreement$method$init$a3955f7c3e3e1325,
	},
    }
};

