// public class javax.crypto.KeyGenerator

// class file dependencies
// @dep_class f4ba095546954b36 gnu_java_security_Engine
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class f02ab3ccb490a6d0 java_lang_ClassCastException
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class ae4a2342b31a268d java_lang_reflect_InvocationTargetException
// @dep_class 692089051f4c8d0b java_security_GeneralSecurityException
// @dep_class 327edce29f2562dd java_security_InvalidAlgorithmParameterException
// @dep_class 22e937c2536160b4 java_security_NoSuchAlgorithmException
// @dep_class 8dfbf242adab91e java_security_NoSuchProviderException
// @dep_class 81b073051aa30acc java_security_Provider
// @dep_class 15c6a62b25a6e96d java_security_SecureRandom
// @dep_class 89bf77984bd9669e java_security_Security
// @dep_class ef2e5e8af121478f java_security_spec_AlgorithmParameterSpec
// @dep_class c53e1575b095109b java_util_Vector
// @dep_class 2fea2074dab125d4 javax_crypto_KeyGenerator
// @dep_class cc7a3e4916c6fcc1 javax_crypto_KeyGeneratorSpi
// @dep_class 4d0a282085f24fd7 javax_crypto_SecretKey

// header file dependencies
// @dep_header gnu_java_security_Engine
// @dep_header java_lang_Class
// @dep_header java_lang_ClassCastException
// @dep_header java_lang_String
// @dep_header java_lang_VMThrowable
// @dep_header java_lang_reflect_InvocationTargetException
// @dep_header java_security_InvalidAlgorithmParameterException
// @dep_header java_security_NoSuchAlgorithmException
// @dep_header java_security_NoSuchProviderException
// @dep_header java_security_Provider
// @dep_header java_security_SecureRandom
// @dep_header java_security_Security
// @dep_header java_security_spec_AlgorithmParameterSpec
// @dep_header java_util_Vector
// @dep_header javax_crypto_KeyGenerator
// @dep_header javax_crypto_KeyGeneratorSpi
// @dep_header javax_crypto_SecretKey

#include "jc_defs.h"

#include "gnu/java/security/Engine.h"
#include "java/lang/Class.h"
#include "java/lang/ClassCastException.h"
#include "java/lang/String.h"
#include "java/lang/VMThrowable.h"
#include "java/lang/reflect/InvocationTargetException.h"
#include "java/security/InvalidAlgorithmParameterException.h"
#include "java/security/NoSuchAlgorithmException.h"
#include "java/security/NoSuchProviderException.h"
#include "java/security/Provider.h"
#include "java/security/SecureRandom.h"
#include "java/security/Security.h"
#include "java/security/spec/AlgorithmParameterSpec.h"
#include "java/util/Vector.h"
#include "javax/crypto/KeyGenerator.h"
#include "javax/crypto/KeyGeneratorSpi.h"
#include "javax/crypto/SecretKey.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// private static final java.lang.String SERVICE
static _jc_field _jc_javax_crypto_KeyGenerator$field_info$SERVICE = {
	.name=		"SERVICE",
	.signature=	"Ljava/lang/String;",
	.class=		&_jc_javax_crypto_KeyGenerator$type,
	.type=		&_jc_java_lang_String$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_KeyGenerator$fields_struct, SERVICE),
	.initial_value=	"KeyGenerator",
};

// private javax.crypto.KeyGeneratorSpi kgSpi
static _jc_field _jc_javax_crypto_KeyGenerator$field_info$kgSpi = {
	.name=		"kgSpi",
	.signature=	"Ljavax/crypto/KeyGeneratorSpi;",
	.class=		&_jc_javax_crypto_KeyGenerator$type,
	.type=		&_jc_javax_crypto_KeyGeneratorSpi$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_KeyGenerator$object, refs[-1].javax_crypto_KeyGenerator.kgSpi),
};

// private java.security.Provider provider
static _jc_field _jc_javax_crypto_KeyGenerator$field_info$provider = {
	.name=		"provider",
	.signature=	"Ljava/security/Provider;",
	.class=		&_jc_javax_crypto_KeyGenerator$type,
	.type=		&_jc_java_security_Provider$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_KeyGenerator$object, refs[-1].javax_crypto_KeyGenerator.provider),
};

// private java.lang.String algorithm
static _jc_field _jc_javax_crypto_KeyGenerator$field_info$algorithm = {
	.name=		"algorithm",
	.signature=	"Ljava/lang/String;",
	.class=		&_jc_javax_crypto_KeyGenerator$type,
	.type=		&_jc_java_lang_String$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_KeyGenerator$object, refs[-1].javax_crypto_KeyGenerator.algorithm),
};

// Fields
static _jc_field *const _jc_javax_crypto_KeyGenerator$fields[] = {
	&_jc_javax_crypto_KeyGenerator$field_info$SERVICE,
	&_jc_javax_crypto_KeyGenerator$field_info$algorithm,
	&_jc_javax_crypto_KeyGenerator$field_info$kgSpi,
	&_jc_javax_crypto_KeyGenerator$field_info$provider
};

/************************************************************************
 *			      Static methods				*
 ************************************************************************/

//
// public static final javax.crypto.KeyGenerator getInstance(java.lang.String) throws java.security.NoSuchAlgorithmException
//

static _jc_linenum _jc_javax_crypto_KeyGenerator$linenum_table$getInstance$59c4a3baf9c92243[];

static _jc_trap_info _jc_javax_crypto_KeyGenerator$trap_table$getInstance$59c4a3baf9c92243[] = {
	_JC_TRAP(&_jc_java_security_NoSuchAlgorithmException$type, 1, 2),
};

static const unsigned char _jc_javax_crypto_KeyGenerator$param_ptypes$getInstance$59c4a3baf9c92243[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_javax_crypto_KeyGenerator$exceptions$getInstance$59c4a3baf9c92243[] = {
	&_jc_java_security_NoSuchAlgorithmException$type
};

static _jc_type *const _jc_javax_crypto_KeyGenerator$param_types$getInstance$59c4a3baf9c92243[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_javax_crypto_KeyGenerator$method_info$getInstance$59c4a3baf9c92243 = {
	.name=			"getInstance",
	.signature=		"(Ljava/lang/String;)Ljavax/crypto/KeyGenerator;",
	.class=			&_jc_javax_crypto_KeyGenerator$type,
	.param_types=		&_jc_javax_crypto_KeyGenerator$param_types$getInstance$59c4a3baf9c92243,
	.return_type=		&_jc_javax_crypto_KeyGenerator$type,
	.param_ptypes=		&_jc_javax_crypto_KeyGenerator$param_ptypes$getInstance$59c4a3baf9c92243,
	.signature_hash=	_JC_JLONG(0x59c4a3baf9c92243),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_KeyGenerator$method$getInstance$59c4a3baf9c92243,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_crypto_KeyGenerator$exceptions$getInstance$59c4a3baf9c92243,
	.u= { .exec= {
	  .trap_table_len=	1,
	  .trap_table=		_jc_javax_crypto_KeyGenerator$trap_table$getInstance$59c4a3baf9c92243,
	  .u= {
	    .linenum= {
	      .len=	7,
	      .table=	_jc_javax_crypto_KeyGenerator$linenum_table$getInstance$59c4a3baf9c92243
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_KeyGenerator, getInstance$59c4a3baf9c92243);

_jc_javax_crypto_KeyGenerator$object * _JC_JCNI_ATTR
_jc_javax_crypto_KeyGenerator$method$getInstance$59c4a3baf9c92243(_jc_env *const env, _jc_java_lang_String$object *param0)
{
	jint volatile i0;
	jint volatile i1;
	jint i2;
	struct _jc_java_lang_String$object *volatile r0;
	struct _jc_java_lang_String$object *volatile r2;
	struct _jc_java_security_NoSuchAlgorithmException$object *volatile r3;
	struct _jc_java_security_Provider$object *volatile r4;
	struct _jc_javax_crypto_KeyGenerator$object *volatile r5;
	struct _jc_java_lang_VMThrowable$object *volatile r6;
	struct _jc_java_util_Vector$object *r7;
	_jc_object_array *volatile r8;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_javax_crypto_KeyGenerator$method_info$getInstance$59c4a3baf9c92243, &&label1);

	r0 = param0;
	_JC_ACTIVE_USE(env, java_security_Security);
	_JC_LINE_NUMBER(111);				// 0
	r7 = _JC_STATIC_FIELD(env, java_security_Security, providers, 1);
	i2 = _JC_INVOKE_VIRTUAL(env, java_util_Vector, size$345df5220fc60ade, r7);
	r8 = _JC_NEW_REF_ARRAY(env, java_security_Provider, 1, i2);
	r7 = _JC_STATIC_FIELD(env, java_security_Security, providers, 1);
	_JC_INVOKE_VIRTUAL(env, java_util_Vector, copyInto$cd78d768b3ba4735, r7, r8);
	_JC_LINE_NUMBER(112);				// 1
	r2 = r0;
	_JC_LINE_NUMBER(113);				// 2
	i0 = 0;
	goto label2;

label0:
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(117);				// 3
	r4 = _JC_REF_ELEMENT(env, r8, i0, 1, 1);
	r5 = _JC_INVOKE_STATIC(env, javax_crypto_KeyGenerator, getInstance$5e0acf207bc49d80, 0, r0, r4);
	_JC_TRAP_REGION(catch, 2);
	_JC_CANCEL_TRAPS(env, catch);
	return r5;

label1:
	_JC_TRAP_REGION(catch, 2);
	r3 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(121);				// 4
	r2 = _JC_INVOKE_VIRTUAL(env, java_lang_Throwable, getMessage$13aaf240efc902b1, r3);
	_JC_LINE_NUMBER(113);				// 5
	i0 = i0 + 1;

label2:
	_JC_TRAP_REGION(catch, 2);
	i1 = _JC_ARRAY_LENGTH(env, r8);
	if (i0 < i1) {
		_JC_PERIODIC_CHECK(env);
		goto label0;
	}
	_JC_LINE_NUMBER(124);				// 6
	r3 = _JC_NEW(env, java_security_NoSuchAlgorithmException);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r6 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r6;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r2;
	_JC_THROW(env, r3);
}

//
// public static final javax.crypto.KeyGenerator getInstance(java.lang.String, java.lang.String) throws java.security.NoSuchAlgorithmException, java.security.NoSuchProviderException
//

static _jc_linenum _jc_javax_crypto_KeyGenerator$linenum_table$getInstance$868815184d6045cc[];

static const unsigned char _jc_javax_crypto_KeyGenerator$param_ptypes$getInstance$868815184d6045cc[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_javax_crypto_KeyGenerator$exceptions$getInstance$868815184d6045cc[] = {
	&_jc_java_security_NoSuchAlgorithmException$type,
	&_jc_java_security_NoSuchProviderException$type
};

static _jc_type *const _jc_javax_crypto_KeyGenerator$param_types$getInstance$868815184d6045cc[] = {
	&_jc_java_lang_String$type,
	&_jc_java_lang_String$type
};

_jc_method _jc_javax_crypto_KeyGenerator$method_info$getInstance$868815184d6045cc = {
	.name=			"getInstance",
	.signature=		"(Ljava/lang/String;Ljava/lang/String;)Ljavax/crypto/KeyGenerator;",
	.class=			&_jc_javax_crypto_KeyGenerator$type,
	.param_types=		&_jc_javax_crypto_KeyGenerator$param_types$getInstance$868815184d6045cc,
	.return_type=		&_jc_javax_crypto_KeyGenerator$type,
	.param_ptypes=		&_jc_javax_crypto_KeyGenerator$param_ptypes$getInstance$868815184d6045cc,
	.signature_hash=	_JC_JLONG(0x868815184d6045cc),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_KeyGenerator$method$getInstance$868815184d6045cc,
	.num_parameters=	2,
	.num_exceptions=	2,
	.exceptions=		&_jc_javax_crypto_KeyGenerator$exceptions$getInstance$868815184d6045cc,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_javax_crypto_KeyGenerator$linenum_table$getInstance$868815184d6045cc
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_KeyGenerator, getInstance$868815184d6045cc);

_jc_javax_crypto_KeyGenerator$object * _JC_JCNI_ATTR
_jc_javax_crypto_KeyGenerator$method$getInstance$868815184d6045cc(_jc_env *const env, _jc_java_lang_String$object *param0, _jc_java_lang_String$object *param1)
{
	struct _jc_java_lang_String$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_java_security_Provider$object *r2;
	struct _jc_java_security_NoSuchProviderException$object *r3;
	struct _jc_javax_crypto_KeyGenerator$object *r4;
	struct _jc_java_lang_VMThrowable$object *r6;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = param0;
	r1 = param1;
	_JC_LINE_NUMBER(141);				// 0
	r2 = _JC_INVOKE_STATIC(env, java_security_Security, getProvider$581ee7d7bc9ae747, 0, r1);
	_JC_LINE_NUMBER(142);				// 1
	if (r2 != _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(144);				// 2
	r3 = _JC_NEW(env, java_security_NoSuchProviderException);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r6 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r6;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r1;
	_JC_THROW(env, r3);

label0:
	_JC_LINE_NUMBER(146);				// 3
	r4 = _JC_INVOKE_STATIC(env, javax_crypto_KeyGenerator, getInstance$5e0acf207bc49d80, 1, r0, r2);
	return r4;
}

//
// public static final javax.crypto.KeyGenerator getInstance(java.lang.String, java.security.Provider) throws java.security.NoSuchAlgorithmException
//

static _jc_linenum _jc_javax_crypto_KeyGenerator$linenum_table$getInstance$5e0acf207bc49d80[];

static _jc_trap_info _jc_javax_crypto_KeyGenerator$trap_table$getInstance$5e0acf207bc49d80[] = {
	_JC_TRAP(&_jc_java_lang_reflect_InvocationTargetException$type, 1, 2),
	_JC_TRAP(&_jc_java_lang_ClassCastException$type, 1, 2),
};

static const unsigned char _jc_javax_crypto_KeyGenerator$param_ptypes$getInstance$5e0acf207bc49d80[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_javax_crypto_KeyGenerator$exceptions$getInstance$5e0acf207bc49d80[] = {
	&_jc_java_security_NoSuchAlgorithmException$type
};

static _jc_type *const _jc_javax_crypto_KeyGenerator$param_types$getInstance$5e0acf207bc49d80[] = {
	&_jc_java_lang_String$type,
	&_jc_java_security_Provider$type
};

_jc_method _jc_javax_crypto_KeyGenerator$method_info$getInstance$5e0acf207bc49d80 = {
	.name=			"getInstance",
	.signature=		"(Ljava/lang/String;Ljava/security/Provider;)Ljavax/crypto/KeyGenerator;",
	.class=			&_jc_javax_crypto_KeyGenerator$type,
	.param_types=		&_jc_javax_crypto_KeyGenerator$param_types$getInstance$5e0acf207bc49d80,
	.return_type=		&_jc_javax_crypto_KeyGenerator$type,
	.param_ptypes=		&_jc_javax_crypto_KeyGenerator$param_ptypes$getInstance$5e0acf207bc49d80,
	.signature_hash=	_JC_JLONG(0x5e0acf207bc49d80),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_KeyGenerator$method$getInstance$5e0acf207bc49d80,
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_crypto_KeyGenerator$exceptions$getInstance$5e0acf207bc49d80,
	.u= { .exec= {
	  .trap_table_len=	2,
	  .trap_table=		_jc_javax_crypto_KeyGenerator$trap_table$getInstance$5e0acf207bc49d80,
	  .u= {
	    .linenum= {
	      .len=	7,
	      .table=	_jc_javax_crypto_KeyGenerator$linenum_table$getInstance$5e0acf207bc49d80
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_KeyGenerator, getInstance$5e0acf207bc49d80);

_jc_javax_crypto_KeyGenerator$object * _JC_JCNI_ATTR
_jc_javax_crypto_KeyGenerator$method$getInstance$5e0acf207bc49d80(_jc_env *const env, _jc_java_lang_String$object *param0, _jc_java_security_Provider$object *param1)
{
	struct _jc_java_lang_String$object *volatile r0;
	struct _jc_java_security_Provider$object *r1;
	struct _jc_java_lang_Object$object *r10;
	struct _jc_java_lang_VMThrowable$object *volatile r11;
	struct _jc_java_lang_VMThrowable$object *volatile r12;
	struct _jc_java_lang_VMThrowable$object *volatile r14;
	struct _jc_javax_crypto_KeyGenerator$object *r2;
	struct _jc_java_lang_reflect_InvocationTargetException$object *volatile r3;
	struct _jc_javax_crypto_KeyGeneratorSpi$object *r4;
	struct _jc_java_lang_Throwable$object *volatile r5;
	struct _jc_java_security_NoSuchAlgorithmException$object *volatile r6;
	struct _jc_java_lang_ClassCastException$object *r7;
	struct _jc_java_lang_String$object *r8;
	_jc_object_array *r9;
	jboolean volatile z0;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_javax_crypto_KeyGenerator$method_info$getInstance$5e0acf207bc49d80, &&label0, &&label3);

	r0 = param0;
	r1 = param1;
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(163);				// 0
	r2 = _JC_NEW(env, javax_crypto_KeyGenerator);
	_JC_ACTIVE_USE(env, gnu_java_security_Engine);
	r8 = _JC_STRING(env, "KeyGenerator");
	r9 = _JC_STATIC_FIELD(env, gnu_java_security_Engine, NO__5fARGS, 1);
	r10 = _JC_INVOKE_STATIC(env, gnu_java_security_Engine, getInstance$ec89dfd35c234c64, 1, r8, r0, r1, r9);
	r4 = _JC_CAST(env, &_jc_javax_crypto_KeyGeneratorSpi$type, r10);
	_JC_REF_FIELD(env, r2, javax_crypto_KeyGenerator, kgSpi) = r4;
	_JC_REF_FIELD(env, r2, javax_crypto_KeyGenerator, provider) = r1;
	_JC_REF_FIELD(env, r2, javax_crypto_KeyGenerator, algorithm) = r0;
	_JC_TRAP_REGION(catch, 2);
	_JC_CANCEL_TRAPS(env, catch);
	return r2;

label0:
	_JC_TRAP_REGION(catch, 2);
	r3 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(169);				// 1
	r5 = _JC_INVOKE_VIRTUAL(env, java_lang_reflect_InvocationTargetException, getCause$d5a96efc8523817a, r3);
	if (r5 != _JC_NULL)
		goto label1;
	_JC_LINE_NUMBER(170);				// 2
	r6 = _JC_NEW(env, java_security_NoSuchAlgorithmException);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, cause) = r6;
	r11 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r6);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, vmState) = r11;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, detailMessage) = r0;
	_JC_THROW(env, r6);

label1:
	_JC_LINE_NUMBER(171);				// 3
	r5 = _JC_INVOKE_VIRTUAL(env, java_lang_reflect_InvocationTargetException, getCause$d5a96efc8523817a, r3);
	z0 = _JC_INSTANCEOF(env, r5, &_jc_java_security_NoSuchAlgorithmException$type);
	if (z0 == 0)
		goto label2;
	_JC_LINE_NUMBER(172);				// 4
	r5 = _JC_INVOKE_VIRTUAL(env, java_lang_reflect_InvocationTargetException, getCause$d5a96efc8523817a, r3);
	r6 = _JC_CAST(env, &_jc_java_security_NoSuchAlgorithmException$type, r5);
	_JC_THROW(env, r6);

label2:
	_JC_LINE_NUMBER(173);				// 5
	r6 = _JC_NEW(env, java_security_NoSuchAlgorithmException);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, cause) = r6;
	r12 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r6);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, vmState) = r12;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, detailMessage) = r0;
	_JC_THROW(env, r6);

label3:
	_JC_TRAP_REGION(catch, 2);
	r7 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(177);				// 6
	r6 = _JC_NEW(env, java_security_NoSuchAlgorithmException);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, cause) = r6;
	r14 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r6);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, vmState) = r14;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, detailMessage) = r0;
	_JC_THROW(env, r6);
}

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// protected void <init>(javax.crypto.KeyGeneratorSpi, java.security.Provider, java.lang.String)
//

static _jc_linenum _jc_javax_crypto_KeyGenerator$linenum_table$_init$67b5fde419d964d1[];

static const unsigned char _jc_javax_crypto_KeyGenerator$param_ptypes$_init$67b5fde419d964d1[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_KeyGenerator$param_types$_init$67b5fde419d964d1[] = {
	&_jc_javax_crypto_KeyGeneratorSpi$type,
	&_jc_java_security_Provider$type,
	&_jc_java_lang_String$type
};

_jc_method _jc_javax_crypto_KeyGenerator$method_info$_init$67b5fde419d964d1 = {
	.name=			"<init>",
	.signature=		"(Ljavax/crypto/KeyGeneratorSpi;Ljava/security/Provider;Ljava/lang/String;)V",
	.class=			&_jc_javax_crypto_KeyGenerator$type,
	.param_types=		&_jc_javax_crypto_KeyGenerator$param_types$_init$67b5fde419d964d1,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_KeyGenerator$param_ptypes$_init$67b5fde419d964d1,
	.signature_hash=	_JC_JLONG(0x67b5fde419d964d1),
	.access_flags=		_JC_ACC_PROTECTED,
	.function=		&_jc_javax_crypto_KeyGenerator$method$_init$67b5fde419d964d1,
	.num_parameters=	3,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_javax_crypto_KeyGenerator$linenum_table$_init$67b5fde419d964d1
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_KeyGenerator, _init$67b5fde419d964d1);

void _JC_JCNI_ATTR
_jc_javax_crypto_KeyGenerator$method$_init$67b5fde419d964d1(_jc_env *const env, _jc_javax_crypto_KeyGenerator$object *this, _jc_javax_crypto_KeyGeneratorSpi$object *param0, _jc_java_security_Provider$object *param1, _jc_java_lang_String$object *param2)
{
	struct _jc_javax_crypto_KeyGenerator$object *r0;
	struct _jc_javax_crypto_KeyGeneratorSpi$object *r1;
	struct _jc_java_security_Provider$object *r2;
	struct _jc_java_lang_String$object *r3;

	r0 = this;
	r1 = param0;
	r2 = param1;
	r3 = param2;
	_JC_LINE_NUMBER(92);				// 0
	_JC_REF_FIELD(env, r0, javax_crypto_KeyGenerator, kgSpi) = r1;
	_JC_LINE_NUMBER(93);				// 1
	_JC_REF_FIELD(env, r0, javax_crypto_KeyGenerator, provider) = r2;
	_JC_LINE_NUMBER(94);				// 2
	_JC_REF_FIELD(env, r0, javax_crypto_KeyGenerator, algorithm) = r3;
	_JC_LINE_NUMBER(95);				// 3
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public final javax.crypto.SecretKey generateKey()
//

static _jc_linenum _jc_javax_crypto_KeyGenerator$linenum_table$generateKey$c62280eb33700d3f[];

static const unsigned char _jc_javax_crypto_KeyGenerator$param_ptypes$generateKey$c62280eb33700d3f[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_javax_crypto_KeyGenerator$method_info$generateKey$c62280eb33700d3f = {
	.name=			"generateKey",
	.signature=		"()Ljavax/crypto/SecretKey;",
	.class=			&_jc_javax_crypto_KeyGenerator$type,
	.return_type=		&_jc_javax_crypto_SecretKey$type,
	.param_ptypes=		&_jc_javax_crypto_KeyGenerator$param_ptypes$generateKey$c62280eb33700d3f,
	.signature_hash=	_JC_JLONG(0xc62280eb33700d3f),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_KeyGenerator$method$generateKey$c62280eb33700d3f,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_KeyGenerator$vtable, javax_crypto_KeyGenerator.generateKey$c62280eb33700d3f) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_crypto_KeyGenerator$linenum_table$generateKey$c62280eb33700d3f
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_KeyGenerator, generateKey$c62280eb33700d3f);

_jc_object * _JC_JCNI_ATTR
_jc_javax_crypto_KeyGenerator$method$generateKey$c62280eb33700d3f(_jc_env *const env, _jc_javax_crypto_KeyGenerator$object *this)
{
	struct _jc_javax_crypto_KeyGenerator$object *r0;
	struct _jc_javax_crypto_KeyGeneratorSpi$object *r1;
	struct _jc_object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(191);				// 0
	r1 = _JC_REF_FIELD(env, r0, javax_crypto_KeyGenerator, kgSpi);
	r2 = _JC_INVOKE_VIRTUAL(env, javax_crypto_KeyGeneratorSpi, engineGenerateKey$d0f4d5ef5e22ea02, r1);
	return r2;
}

//
// public final java.lang.String getAlgorithm()
//

static _jc_linenum _jc_javax_crypto_KeyGenerator$linenum_table$getAlgorithm$19abbbc132b9063a[];

static const unsigned char _jc_javax_crypto_KeyGenerator$param_ptypes$getAlgorithm$19abbbc132b9063a[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_javax_crypto_KeyGenerator$method_info$getAlgorithm$19abbbc132b9063a = {
	.name=			"getAlgorithm",
	.signature=		"()Ljava/lang/String;",
	.class=			&_jc_javax_crypto_KeyGenerator$type,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_javax_crypto_KeyGenerator$param_ptypes$getAlgorithm$19abbbc132b9063a,
	.signature_hash=	_JC_JLONG(0x19abbbc132b9063a),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_KeyGenerator$method$getAlgorithm$19abbbc132b9063a,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_KeyGenerator$vtable, javax_crypto_KeyGenerator.getAlgorithm$19abbbc132b9063a) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_crypto_KeyGenerator$linenum_table$getAlgorithm$19abbbc132b9063a
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_KeyGenerator, getAlgorithm$19abbbc132b9063a);

_jc_java_lang_String$object * _JC_JCNI_ATTR
_jc_javax_crypto_KeyGenerator$method$getAlgorithm$19abbbc132b9063a(_jc_env *const env, _jc_javax_crypto_KeyGenerator$object *this)
{
	struct _jc_javax_crypto_KeyGenerator$object *r0;
	struct _jc_java_lang_String$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(201);				// 0
	r1 = _JC_REF_FIELD(env, r0, javax_crypto_KeyGenerator, algorithm);
	return r1;
}

//
// public final java.security.Provider getProvider()
//

static _jc_linenum _jc_javax_crypto_KeyGenerator$linenum_table$getProvider$e8f9c9fb14140d5a[];

static const unsigned char _jc_javax_crypto_KeyGenerator$param_ptypes$getProvider$e8f9c9fb14140d5a[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_javax_crypto_KeyGenerator$method_info$getProvider$e8f9c9fb14140d5a = {
	.name=			"getProvider",
	.signature=		"()Ljava/security/Provider;",
	.class=			&_jc_javax_crypto_KeyGenerator$type,
	.return_type=		&_jc_java_security_Provider$type,
	.param_ptypes=		&_jc_javax_crypto_KeyGenerator$param_ptypes$getProvider$e8f9c9fb14140d5a,
	.signature_hash=	_JC_JLONG(0xe8f9c9fb14140d5a),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_KeyGenerator$method$getProvider$e8f9c9fb14140d5a,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_KeyGenerator$vtable, javax_crypto_KeyGenerator.getProvider$e8f9c9fb14140d5a) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_crypto_KeyGenerator$linenum_table$getProvider$e8f9c9fb14140d5a
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_KeyGenerator, getProvider$e8f9c9fb14140d5a);

_jc_java_security_Provider$object * _JC_JCNI_ATTR
_jc_javax_crypto_KeyGenerator$method$getProvider$e8f9c9fb14140d5a(_jc_env *const env, _jc_javax_crypto_KeyGenerator$object *this)
{
	struct _jc_javax_crypto_KeyGenerator$object *r0;
	struct _jc_java_security_Provider$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(211);				// 0
	r1 = _JC_REF_FIELD(env, r0, javax_crypto_KeyGenerator, provider);
	return r1;
}

//
// public final void init(int)
//

static _jc_linenum _jc_javax_crypto_KeyGenerator$linenum_table$init$bfae065b93f25bd8[];

static const unsigned char _jc_javax_crypto_KeyGenerator$param_ptypes$init$bfae065b93f25bd8[] = { 
_JC_TYPE_INT, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_KeyGenerator$param_types$init$bfae065b93f25bd8[] = {
	&_jc_int$prim$type
};

_jc_method _jc_javax_crypto_KeyGenerator$method_info$init$bfae065b93f25bd8 = {
	.name=			"init",
	.signature=		"(I)V",
	.class=			&_jc_javax_crypto_KeyGenerator$type,
	.param_types=		&_jc_javax_crypto_KeyGenerator$param_types$init$bfae065b93f25bd8,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_KeyGenerator$param_ptypes$init$bfae065b93f25bd8,
	.signature_hash=	_JC_JLONG(0xbfae065b93f25bd8),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_KeyGenerator$method$init$bfae065b93f25bd8,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_KeyGenerator$vtable, javax_crypto_KeyGenerator.init$bfae065b93f25bd8) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_javax_crypto_KeyGenerator$linenum_table$init$bfae065b93f25bd8
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_KeyGenerator, init$bfae065b93f25bd8);

void _JC_JCNI_ATTR
_jc_javax_crypto_KeyGenerator$method$init$bfae065b93f25bd8(_jc_env *const env, _jc_javax_crypto_KeyGenerator$object *this, jint param0)
{
	jint i0;
	struct _jc_javax_crypto_KeyGenerator$object *r0;
	struct _jc_java_security_SecureRandom$object *r1;
	struct _jc_javax_crypto_KeyGeneratorSpi$object *r4;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	i0 = param0;
	_JC_LINE_NUMBER(255);				// 0
	r1 = _JC_NEW(env, java_security_SecureRandom);
	_JC_INVOKE_NONVIRTUAL(env, java_security_SecureRandom, _init$52f4ad9f2989aeee, 0, r1);
	r4 = _JC_REF_FIELD(env, r0, javax_crypto_KeyGenerator, kgSpi);
	_JC_INVOKE_VIRTUAL(env, javax_crypto_KeyGeneratorSpi, engineInit$ce17ad6b3fc98d82, r4, i0, r1);
	_JC_LINE_NUMBER(256);				// 1
	return;
}

//
// public final void init(int, java.security.SecureRandom)
//

static _jc_linenum _jc_javax_crypto_KeyGenerator$linenum_table$init$a6cee9d167433657[];

static const unsigned char _jc_javax_crypto_KeyGenerator$param_ptypes$init$a6cee9d167433657[] = { 
_JC_TYPE_INT, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_KeyGenerator$param_types$init$a6cee9d167433657[] = {
	&_jc_int$prim$type,
	&_jc_java_security_SecureRandom$type
};

_jc_method _jc_javax_crypto_KeyGenerator$method_info$init$a6cee9d167433657 = {
	.name=			"init",
	.signature=		"(ILjava/security/SecureRandom;)V",
	.class=			&_jc_javax_crypto_KeyGenerator$type,
	.param_types=		&_jc_javax_crypto_KeyGenerator$param_types$init$a6cee9d167433657,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_KeyGenerator$param_ptypes$init$a6cee9d167433657,
	.signature_hash=	_JC_JLONG(0xa6cee9d167433657),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_KeyGenerator$method$init$a6cee9d167433657,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_KeyGenerator$vtable, javax_crypto_KeyGenerator.init$a6cee9d167433657) / sizeof(void *),
	.num_parameters=	2,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_javax_crypto_KeyGenerator$linenum_table$init$a6cee9d167433657
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_KeyGenerator, init$a6cee9d167433657);

void _JC_JCNI_ATTR
_jc_javax_crypto_KeyGenerator$method$init$a6cee9d167433657(_jc_env *const env, _jc_javax_crypto_KeyGenerator$object *this, jint param0, _jc_java_security_SecureRandom$object *param1)
{
	jint i0;
	struct _jc_javax_crypto_KeyGenerator$object *r0;
	struct _jc_java_security_SecureRandom$object *r1;
	struct _jc_javax_crypto_KeyGeneratorSpi$object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	i0 = param0;
	r1 = param1;
	_JC_LINE_NUMBER(269);				// 0
	r2 = _JC_REF_FIELD(env, r0, javax_crypto_KeyGenerator, kgSpi);
	_JC_INVOKE_VIRTUAL(env, javax_crypto_KeyGeneratorSpi, engineInit$ce17ad6b3fc98d82, r2, i0, r1);
	_JC_LINE_NUMBER(270);				// 1
	return;
}

//
// public final void init(java.security.SecureRandom)
//

static _jc_linenum _jc_javax_crypto_KeyGenerator$linenum_table$init$fb88c912b9e1808f[];

static const unsigned char _jc_javax_crypto_KeyGenerator$param_ptypes$init$fb88c912b9e1808f[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_KeyGenerator$param_types$init$fb88c912b9e1808f[] = {
	&_jc_java_security_SecureRandom$type
};

_jc_method _jc_javax_crypto_KeyGenerator$method_info$init$fb88c912b9e1808f = {
	.name=			"init",
	.signature=		"(Ljava/security/SecureRandom;)V",
	.class=			&_jc_javax_crypto_KeyGenerator$type,
	.param_types=		&_jc_javax_crypto_KeyGenerator$param_types$init$fb88c912b9e1808f,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_KeyGenerator$param_ptypes$init$fb88c912b9e1808f,
	.signature_hash=	_JC_JLONG(0xfb88c912b9e1808f),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_KeyGenerator$method$init$fb88c912b9e1808f,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_KeyGenerator$vtable, javax_crypto_KeyGenerator.init$fb88c912b9e1808f) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_javax_crypto_KeyGenerator$linenum_table$init$fb88c912b9e1808f
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_KeyGenerator, init$fb88c912b9e1808f);

void _JC_JCNI_ATTR
_jc_javax_crypto_KeyGenerator$method$init$fb88c912b9e1808f(_jc_env *const env, _jc_javax_crypto_KeyGenerator$object *this, _jc_java_security_SecureRandom$object *param0)
{
	struct _jc_javax_crypto_KeyGenerator$object *r0;
	struct _jc_java_security_SecureRandom$object *r1;
	struct _jc_javax_crypto_KeyGeneratorSpi$object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(281);				// 0
	r2 = _JC_REF_FIELD(env, r0, javax_crypto_KeyGenerator, kgSpi);
	_JC_INVOKE_VIRTUAL(env, javax_crypto_KeyGeneratorSpi, engineInit$3322302d28550a02, r2, r1);
	_JC_LINE_NUMBER(282);				// 1
	return;
}

//
// public final void init(java.security.spec.AlgorithmParameterSpec) throws java.security.InvalidAlgorithmParameterException
//

static _jc_linenum _jc_javax_crypto_KeyGenerator$linenum_table$init$ed37b79a75a6f3d3[];

static const unsigned char _jc_javax_crypto_KeyGenerator$param_ptypes$init$ed37b79a75a6f3d3[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_KeyGenerator$exceptions$init$ed37b79a75a6f3d3[] = {
	&_jc_java_security_InvalidAlgorithmParameterException$type
};

static _jc_type *const _jc_javax_crypto_KeyGenerator$param_types$init$ed37b79a75a6f3d3[] = {
	&_jc_java_security_spec_AlgorithmParameterSpec$type
};

_jc_method _jc_javax_crypto_KeyGenerator$method_info$init$ed37b79a75a6f3d3 = {
	.name=			"init",
	.signature=		"(Ljava/security/spec/AlgorithmParameterSpec;)V",
	.class=			&_jc_javax_crypto_KeyGenerator$type,
	.param_types=		&_jc_javax_crypto_KeyGenerator$param_types$init$ed37b79a75a6f3d3,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_KeyGenerator$param_ptypes$init$ed37b79a75a6f3d3,
	.signature_hash=	_JC_JLONG(0xed37b79a75a6f3d3),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_KeyGenerator$method$init$ed37b79a75a6f3d3,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_KeyGenerator$vtable, javax_crypto_KeyGenerator.init$ed37b79a75a6f3d3) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_crypto_KeyGenerator$exceptions$init$ed37b79a75a6f3d3,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_javax_crypto_KeyGenerator$linenum_table$init$ed37b79a75a6f3d3
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_KeyGenerator, init$ed37b79a75a6f3d3);

void _JC_JCNI_ATTR
_jc_javax_crypto_KeyGenerator$method$init$ed37b79a75a6f3d3(_jc_env *const env, _jc_javax_crypto_KeyGenerator$object *this, _jc_object *param0)
{
	struct _jc_javax_crypto_KeyGenerator$object *r0;
	struct _jc_object *r1;
	struct _jc_java_security_SecureRandom$object *r2;
	struct _jc_javax_crypto_KeyGeneratorSpi$object *r6;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(226);				// 0
	r2 = _JC_NEW(env, java_security_SecureRandom);
	_JC_INVOKE_NONVIRTUAL(env, java_security_SecureRandom, _init$52f4ad9f2989aeee, 0, r2);
	r6 = _JC_REF_FIELD(env, r0, javax_crypto_KeyGenerator, kgSpi);
	_JC_INVOKE_VIRTUAL(env, javax_crypto_KeyGeneratorSpi, engineInit$5af33bc7d4d69573, r6, r1, r2);
	_JC_LINE_NUMBER(227);				// 1
	return;
}

//
// public final void init(java.security.spec.AlgorithmParameterSpec, java.security.SecureRandom) throws java.security.InvalidAlgorithmParameterException
//

static _jc_linenum _jc_javax_crypto_KeyGenerator$linenum_table$init$befc7893049358cc[];

static const unsigned char _jc_javax_crypto_KeyGenerator$param_ptypes$init$befc7893049358cc[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_KeyGenerator$exceptions$init$befc7893049358cc[] = {
	&_jc_java_security_InvalidAlgorithmParameterException$type
};

static _jc_type *const _jc_javax_crypto_KeyGenerator$param_types$init$befc7893049358cc[] = {
	&_jc_java_security_spec_AlgorithmParameterSpec$type,
	&_jc_java_security_SecureRandom$type
};

_jc_method _jc_javax_crypto_KeyGenerator$method_info$init$befc7893049358cc = {
	.name=			"init",
	.signature=		"(Ljava/security/spec/AlgorithmParameterSpec;Ljava/security/SecureRandom;)V",
	.class=			&_jc_javax_crypto_KeyGenerator$type,
	.param_types=		&_jc_javax_crypto_KeyGenerator$param_types$init$befc7893049358cc,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_KeyGenerator$param_ptypes$init$befc7893049358cc,
	.signature_hash=	_JC_JLONG(0xbefc7893049358cc),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_KeyGenerator$method$init$befc7893049358cc,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_KeyGenerator$vtable, javax_crypto_KeyGenerator.init$befc7893049358cc) / sizeof(void *),
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_crypto_KeyGenerator$exceptions$init$befc7893049358cc,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_javax_crypto_KeyGenerator$linenum_table$init$befc7893049358cc
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_KeyGenerator, init$befc7893049358cc);

void _JC_JCNI_ATTR
_jc_javax_crypto_KeyGenerator$method$init$befc7893049358cc(_jc_env *const env, _jc_javax_crypto_KeyGenerator$object *this, _jc_object *param0, _jc_java_security_SecureRandom$object *param1)
{
	struct _jc_javax_crypto_KeyGenerator$object *r0;
	struct _jc_object *r1;
	struct _jc_java_security_SecureRandom$object *r2;
	struct _jc_javax_crypto_KeyGeneratorSpi$object *r3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_LINE_NUMBER(241);				// 0
	r3 = _JC_REF_FIELD(env, r0, javax_crypto_KeyGenerator, kgSpi);
	_JC_INVOKE_VIRTUAL(env, javax_crypto_KeyGeneratorSpi, engineInit$5af33bc7d4d69573, r3, r1, r2);
	_JC_LINE_NUMBER(242);				// 1
	return;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_javax_crypto_KeyGenerator$methods[] = {
	&_jc_javax_crypto_KeyGenerator$method_info$_init$67b5fde419d964d1,
	&_jc_javax_crypto_KeyGenerator$method_info$generateKey$c62280eb33700d3f,
	&_jc_javax_crypto_KeyGenerator$method_info$getAlgorithm$19abbbc132b9063a,
	&_jc_javax_crypto_KeyGenerator$method_info$getInstance$59c4a3baf9c92243,
	&_jc_javax_crypto_KeyGenerator$method_info$getInstance$868815184d6045cc,
	&_jc_javax_crypto_KeyGenerator$method_info$getInstance$5e0acf207bc49d80,
	&_jc_javax_crypto_KeyGenerator$method_info$getProvider$e8f9c9fb14140d5a,
	&_jc_javax_crypto_KeyGenerator$method_info$init$bfae065b93f25bd8,
	&_jc_javax_crypto_KeyGenerator$method_info$init$a6cee9d167433657,
	&_jc_javax_crypto_KeyGenerator$method_info$init$fb88c912b9e1808f,
	&_jc_javax_crypto_KeyGenerator$method_info$init$ed37b79a75a6f3d3,
	&_jc_javax_crypto_KeyGenerator$method_info$init$befc7893049358cc
};

/************************************************************************
 *			  Class fields structure			*
 ************************************************************************/

_jc_javax_crypto_KeyGenerator$fields_struct _jc_javax_crypto_KeyGenerator$class_fields = { };

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_javax_crypto_KeyGenerator$instanceof_hash_bucket_84[] = {
	&_jc_javax_crypto_KeyGenerator$type,
	_JC_NULL
};
static _jc_type *const _jc_javax_crypto_KeyGenerator$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_javax_crypto_KeyGenerator$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[84]=	_jc_javax_crypto_KeyGenerator$instanceof_hash_bucket_84,
	[101]=	_jc_javax_crypto_KeyGenerator$instanceof_hash_bucket_101
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_javax_crypto_KeyGenerator$class_depends[] = {
	{ "gnu/java/security/Engine",	_JC_JLONG(0xf4ba095546954b36) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/ClassCastException",	_JC_JLONG(0xf02ab3ccb490a6d0) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/lang/reflect/InvocationTargetException",	_JC_JLONG(0xae4a2342b31a268d) },
	{ "java/security/GeneralSecurityException",	_JC_JLONG(0x692089051f4c8d0b) },
	{ "java/security/InvalidAlgorithmParameterException",	_JC_JLONG(0x327edce29f2562dd) },
	{ "java/security/NoSuchAlgorithmException",	_JC_JLONG(0x22e937c2536160b4) },
	{ "java/security/NoSuchProviderException",	_JC_JLONG(0x8dfbf242adab91e) },
	{ "java/security/Provider",	_JC_JLONG(0x81b073051aa30acc) },
	{ "java/security/SecureRandom",	_JC_JLONG(0x15c6a62b25a6e96d) },
	{ "java/security/Security",	_JC_JLONG(0x89bf77984bd9669e) },
	{ "java/security/spec/AlgorithmParameterSpec",	_JC_JLONG(0xef2e5e8af121478f) },
	{ "java/util/Vector",	_JC_JLONG(0xc53e1575b095109b) },
	{ "javax/crypto/KeyGeneratorSpi",	_JC_JLONG(0xcc7a3e4916c6fcc1) },
	{ "javax/crypto/SecretKey",	_JC_JLONG(0x4d0a282085f24fd7) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_javax_crypto_KeyGenerator$vtype _jc_javax_crypto_KeyGenerator$type = {
    .type= {
	.name=			"javax/crypto/KeyGenerator",
	.superclass=		&_jc_java_lang_Object$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		19,
		.hash=			_JC_JLONG(0x2fea2074dab125d4),
		.source_file=		"KeyGenerator.java",
		.instance_size=		sizeof(_jc_javax_crypto_KeyGenerator$refs) + sizeof(_jc_javax_crypto_KeyGenerator$object),
		.num_virtual_refs=	3,
		.num_fields=		sizeof(_jc_javax_crypto_KeyGenerator$fields) / sizeof(*_jc_javax_crypto_KeyGenerator$fields),
		.fields=		_jc_javax_crypto_KeyGenerator$fields,
		.num_methods=		sizeof(_jc_javax_crypto_KeyGenerator$methods) / sizeof(*_jc_javax_crypto_KeyGenerator$methods),
		.methods=		_jc_javax_crypto_KeyGenerator$methods,
		.instanceof_hash_table=	_jc_javax_crypto_KeyGenerator$instanceof_hash_table,
		.class_fields=		&_jc_javax_crypto_KeyGenerator$class_fields,
		.num_class_depends=		sizeof(_jc_javax_crypto_KeyGenerator$class_depends) / sizeof(*_jc_javax_crypto_KeyGenerator$class_depends),
		.class_depends=		_jc_javax_crypto_KeyGenerator$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.javax_crypto_KeyGenerator= {
	    .generateKey$c62280eb33700d3f=
		&_jc_javax_crypto_KeyGenerator$method$generateKey$c62280eb33700d3f,
	    .getAlgorithm$19abbbc132b9063a=
		&_jc_javax_crypto_KeyGenerator$method$getAlgorithm$19abbbc132b9063a,
	    .getProvider$e8f9c9fb14140d5a=
		&_jc_javax_crypto_KeyGenerator$method$getProvider$e8f9c9fb14140d5a,
	    .init$bfae065b93f25bd8=
		&_jc_javax_crypto_KeyGenerator$method$init$bfae065b93f25bd8,
	    .init$a6cee9d167433657=
		&_jc_javax_crypto_KeyGenerator$method$init$a6cee9d167433657,
	    .init$fb88c912b9e1808f=
		&_jc_javax_crypto_KeyGenerator$method$init$fb88c912b9e1808f,
	    .init$ed37b79a75a6f3d3=
		&_jc_javax_crypto_KeyGenerator$method$init$ed37b79a75a6f3d3,
	    .init$befc7893049358cc=
		&_jc_javax_crypto_KeyGenerator$method$init$befc7893049358cc,
	},
    }
};

