// public class javax.crypto.Mac

// class file dependencies
// @dep_class f4ba095546954b36 gnu_java_security_Engine
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class f02ab3ccb490a6d0 java_lang_ClassCastException
// @dep_class d59353b5e031d754 java_lang_CloneNotSupportedException
// @dep_class 9b667b09132be893 java_lang_Cloneable
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class 680cf34d05feb5a1 java_lang_IllegalArgumentException
// @dep_class b7e704701c278e65 java_lang_IllegalStateException
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class 4f5534a987354d1d java_lang_RuntimeException
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 94d357637b968dda java_lang_StringBuffer
// @dep_class 53cc8e2333795f04 java_lang_System
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class 4d1cebae0bdda058 java_lang_VMSystem
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class ae4a2342b31a268d java_lang_reflect_InvocationTargetException
// @dep_class 692089051f4c8d0b java_security_GeneralSecurityException
// @dep_class 327edce29f2562dd java_security_InvalidAlgorithmParameterException
// @dep_class 94dda41e9bf6c170 java_security_InvalidKeyException
// @dep_class a467c6cd05d9cc51 java_security_Key
// @dep_class 22e937c2536160b4 java_security_NoSuchAlgorithmException
// @dep_class 8dfbf242adab91e java_security_NoSuchProviderException
// @dep_class 81b073051aa30acc java_security_Provider
// @dep_class 89bf77984bd9669e java_security_Security
// @dep_class ef2e5e8af121478f java_security_spec_AlgorithmParameterSpec
// @dep_class c53e1575b095109b java_util_Vector
// @dep_class 51513444ac2c709c javax_crypto_Mac
// @dep_class b809bfd247d0c389 javax_crypto_MacSpi
// @dep_class d79a62a9328ccea1 javax_crypto_ShortBufferException

// header file dependencies
// @dep_header gnu_java_security_Engine
// @dep_header java_lang_Class
// @dep_header java_lang_ClassCastException
// @dep_header java_lang_CloneNotSupportedException
// @dep_header java_lang_Cloneable
// @dep_header java_lang_IllegalArgumentException
// @dep_header java_lang_IllegalStateException
// @dep_header java_lang_String
// @dep_header java_lang_StringBuffer
// @dep_header java_lang_System
// @dep_header java_lang_VMSystem
// @dep_header java_lang_VMThrowable
// @dep_header java_lang_reflect_InvocationTargetException
// @dep_header java_security_InvalidAlgorithmParameterException
// @dep_header java_security_InvalidKeyException
// @dep_header java_security_Key
// @dep_header java_security_NoSuchAlgorithmException
// @dep_header java_security_NoSuchProviderException
// @dep_header java_security_Provider
// @dep_header java_security_Security
// @dep_header java_security_spec_AlgorithmParameterSpec
// @dep_header java_util_Vector
// @dep_header javax_crypto_Mac
// @dep_header javax_crypto_MacSpi
// @dep_header javax_crypto_ShortBufferException

#include "jc_defs.h"

#include "gnu/java/security/Engine.h"
#include "java/lang/Class.h"
#include "java/lang/ClassCastException.h"
#include "java/lang/CloneNotSupportedException.h"
#include "java/lang/Cloneable.h"
#include "java/lang/IllegalArgumentException.h"
#include "java/lang/IllegalStateException.h"
#include "java/lang/String.h"
#include "java/lang/StringBuffer.h"
#include "java/lang/System.h"
#include "java/lang/VMSystem.h"
#include "java/lang/VMThrowable.h"
#include "java/lang/reflect/InvocationTargetException.h"
#include "java/security/InvalidAlgorithmParameterException.h"
#include "java/security/InvalidKeyException.h"
#include "java/security/Key.h"
#include "java/security/NoSuchAlgorithmException.h"
#include "java/security/NoSuchProviderException.h"
#include "java/security/Provider.h"
#include "java/security/Security.h"
#include "java/security/spec/AlgorithmParameterSpec.h"
#include "java/util/Vector.h"
#include "javax/crypto/Mac.h"
#include "javax/crypto/MacSpi.h"
#include "javax/crypto/ShortBufferException.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// private static final java.lang.String SERVICE
static _jc_field _jc_javax_crypto_Mac$field_info$SERVICE = {
	.name=		"SERVICE",
	.signature=	"Ljava/lang/String;",
	.class=		&_jc_javax_crypto_Mac$type,
	.type=		&_jc_java_lang_String$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_Mac$fields_struct, SERVICE),
	.initial_value=	"Mac",
};

// private javax.crypto.MacSpi macSpi
static _jc_field _jc_javax_crypto_Mac$field_info$macSpi = {
	.name=		"macSpi",
	.signature=	"Ljavax/crypto/MacSpi;",
	.class=		&_jc_javax_crypto_Mac$type,
	.type=		&_jc_javax_crypto_MacSpi$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_Mac$object, refs[-1].javax_crypto_Mac.macSpi),
};

// private java.security.Provider provider
static _jc_field _jc_javax_crypto_Mac$field_info$provider = {
	.name=		"provider",
	.signature=	"Ljava/security/Provider;",
	.class=		&_jc_javax_crypto_Mac$type,
	.type=		&_jc_java_security_Provider$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_Mac$object, refs[-1].javax_crypto_Mac.provider),
};

// private java.lang.String algorithm
static _jc_field _jc_javax_crypto_Mac$field_info$algorithm = {
	.name=		"algorithm",
	.signature=	"Ljava/lang/String;",
	.class=		&_jc_javax_crypto_Mac$type,
	.type=		&_jc_java_lang_String$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_Mac$object, refs[-1].javax_crypto_Mac.algorithm),
};

// private boolean virgin
static _jc_field _jc_javax_crypto_Mac$field_info$virgin = {
	.name=		"virgin",
	.signature=	"Z",
	.class=		&_jc_javax_crypto_Mac$type,
	.type=		&_jc_boolean$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_Mac$object, nonrefs.javax_crypto_Mac.virgin),
};

// Fields
static _jc_field *const _jc_javax_crypto_Mac$fields[] = {
	&_jc_javax_crypto_Mac$field_info$SERVICE,
	&_jc_javax_crypto_Mac$field_info$algorithm,
	&_jc_javax_crypto_Mac$field_info$macSpi,
	&_jc_javax_crypto_Mac$field_info$provider,
	&_jc_javax_crypto_Mac$field_info$virgin
};

/************************************************************************
 *			      Static methods				*
 ************************************************************************/

//
// public static final javax.crypto.Mac getInstance(java.lang.String) throws java.security.NoSuchAlgorithmException
//

static _jc_linenum _jc_javax_crypto_Mac$linenum_table$getInstance$79dbcb4835b7fd4d[];

static _jc_trap_info _jc_javax_crypto_Mac$trap_table$getInstance$79dbcb4835b7fd4d[] = {
	_JC_TRAP(&_jc_java_security_NoSuchAlgorithmException$type, 1, 2),
};

static const unsigned char _jc_javax_crypto_Mac$param_ptypes$getInstance$79dbcb4835b7fd4d[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_javax_crypto_Mac$exceptions$getInstance$79dbcb4835b7fd4d[] = {
	&_jc_java_security_NoSuchAlgorithmException$type
};

static _jc_type *const _jc_javax_crypto_Mac$param_types$getInstance$79dbcb4835b7fd4d[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_javax_crypto_Mac$method_info$getInstance$79dbcb4835b7fd4d = {
	.name=			"getInstance",
	.signature=		"(Ljava/lang/String;)Ljavax/crypto/Mac;",
	.class=			&_jc_javax_crypto_Mac$type,
	.param_types=		&_jc_javax_crypto_Mac$param_types$getInstance$79dbcb4835b7fd4d,
	.return_type=		&_jc_javax_crypto_Mac$type,
	.param_ptypes=		&_jc_javax_crypto_Mac$param_ptypes$getInstance$79dbcb4835b7fd4d,
	.signature_hash=	_JC_JLONG(0x79dbcb4835b7fd4d),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_Mac$method$getInstance$79dbcb4835b7fd4d,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_crypto_Mac$exceptions$getInstance$79dbcb4835b7fd4d,
	.u= { .exec= {
	  .trap_table_len=	1,
	  .trap_table=		_jc_javax_crypto_Mac$trap_table$getInstance$79dbcb4835b7fd4d,
	  .u= {
	    .linenum= {
	      .len=	7,
	      .table=	_jc_javax_crypto_Mac$linenum_table$getInstance$79dbcb4835b7fd4d
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_Mac, getInstance$79dbcb4835b7fd4d);

_jc_javax_crypto_Mac$object * _JC_JCNI_ATTR
_jc_javax_crypto_Mac$method$getInstance$79dbcb4835b7fd4d(_jc_env *const env, _jc_java_lang_String$object *param0)
{
	jint volatile i0;
	jint volatile i1;
	jint i2;
	struct _jc_java_lang_String$object *volatile r0;
	struct _jc_java_lang_String$object *volatile r2;
	struct _jc_java_security_NoSuchAlgorithmException$object *volatile r3;
	struct _jc_java_security_Provider$object *volatile r4;
	struct _jc_javax_crypto_Mac$object *volatile r5;
	struct _jc_java_lang_VMThrowable$object *volatile r6;
	struct _jc_java_util_Vector$object *r7;
	_jc_object_array *volatile r8;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_javax_crypto_Mac$method_info$getInstance$79dbcb4835b7fd4d, &&label1);

	r0 = param0;
	_JC_ACTIVE_USE(env, java_security_Security);
	_JC_LINE_NUMBER(126);				// 0
	r7 = _JC_STATIC_FIELD(env, java_security_Security, providers, 1);
	i2 = _JC_INVOKE_VIRTUAL(env, java_util_Vector, size$345df5220fc60ade, r7);
	r8 = _JC_NEW_REF_ARRAY(env, java_security_Provider, 1, i2);
	r7 = _JC_STATIC_FIELD(env, java_security_Security, providers, 1);
	_JC_INVOKE_VIRTUAL(env, java_util_Vector, copyInto$cd78d768b3ba4735, r7, r8);
	_JC_LINE_NUMBER(127);				// 1
	r2 = _JC_STRING(env, "");
	_JC_LINE_NUMBER(128);				// 2
	i0 = 0;
	goto label2;

label0:
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(132);				// 3
	r4 = _JC_REF_ELEMENT(env, r8, i0, 1, 1);
	r5 = _JC_INVOKE_STATIC(env, javax_crypto_Mac, getInstance$558c03fc000a2c0c, 0, r0, r4);
	_JC_TRAP_REGION(catch, 2);
	_JC_CANCEL_TRAPS(env, catch);
	return r5;

label1:
	_JC_TRAP_REGION(catch, 2);
	r3 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(136);				// 4
	r2 = _JC_INVOKE_VIRTUAL(env, java_lang_Throwable, getMessage$13aaf240efc902b1, r3);
	_JC_LINE_NUMBER(128);				// 5
	i0 = i0 + 1;

label2:
	_JC_TRAP_REGION(catch, 2);
	i1 = _JC_ARRAY_LENGTH(env, r8);
	if (i0 < i1) {
		_JC_PERIODIC_CHECK(env);
		goto label0;
	}
	_JC_LINE_NUMBER(139);				// 6
	r3 = _JC_NEW(env, java_security_NoSuchAlgorithmException);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r6 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r6;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r2;
	_JC_THROW(env, r3);
}

//
// public static final javax.crypto.Mac getInstance(java.lang.String, java.lang.String) throws java.security.NoSuchAlgorithmException, java.security.NoSuchProviderException
//

static _jc_linenum _jc_javax_crypto_Mac$linenum_table$getInstance$2d9aa7ff178c0039[];

static const unsigned char _jc_javax_crypto_Mac$param_ptypes$getInstance$2d9aa7ff178c0039[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_javax_crypto_Mac$exceptions$getInstance$2d9aa7ff178c0039[] = {
	&_jc_java_security_NoSuchAlgorithmException$type,
	&_jc_java_security_NoSuchProviderException$type
};

static _jc_type *const _jc_javax_crypto_Mac$param_types$getInstance$2d9aa7ff178c0039[] = {
	&_jc_java_lang_String$type,
	&_jc_java_lang_String$type
};

_jc_method _jc_javax_crypto_Mac$method_info$getInstance$2d9aa7ff178c0039 = {
	.name=			"getInstance",
	.signature=		"(Ljava/lang/String;Ljava/lang/String;)Ljavax/crypto/Mac;",
	.class=			&_jc_javax_crypto_Mac$type,
	.param_types=		&_jc_javax_crypto_Mac$param_types$getInstance$2d9aa7ff178c0039,
	.return_type=		&_jc_javax_crypto_Mac$type,
	.param_ptypes=		&_jc_javax_crypto_Mac$param_ptypes$getInstance$2d9aa7ff178c0039,
	.signature_hash=	_JC_JLONG(0x2d9aa7ff178c0039),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_Mac$method$getInstance$2d9aa7ff178c0039,
	.num_parameters=	2,
	.num_exceptions=	2,
	.exceptions=		&_jc_javax_crypto_Mac$exceptions$getInstance$2d9aa7ff178c0039,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_javax_crypto_Mac$linenum_table$getInstance$2d9aa7ff178c0039
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_Mac, getInstance$2d9aa7ff178c0039);

_jc_javax_crypto_Mac$object * _JC_JCNI_ATTR
_jc_javax_crypto_Mac$method$getInstance$2d9aa7ff178c0039(_jc_env *const env, _jc_java_lang_String$object *param0, _jc_java_lang_String$object *param1)
{
	struct _jc_java_lang_String$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_java_security_Provider$object *r2;
	struct _jc_java_security_NoSuchProviderException$object *r3;
	struct _jc_javax_crypto_Mac$object *r4;
	struct _jc_java_lang_VMThrowable$object *r6;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = param0;
	r1 = param1;
	_JC_LINE_NUMBER(157);				// 0
	r2 = _JC_INVOKE_STATIC(env, java_security_Security, getProvider$581ee7d7bc9ae747, 0, r1);
	_JC_LINE_NUMBER(158);				// 1
	if (r2 != _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(160);				// 2
	r3 = _JC_NEW(env, java_security_NoSuchProviderException);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r6 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r6;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r1;
	_JC_THROW(env, r3);

label0:
	_JC_LINE_NUMBER(162);				// 3
	r4 = _JC_INVOKE_STATIC(env, javax_crypto_Mac, getInstance$558c03fc000a2c0c, 1, r0, r2);
	return r4;
}

//
// public static final javax.crypto.Mac getInstance(java.lang.String, java.security.Provider) throws java.security.NoSuchAlgorithmException
//

static _jc_linenum _jc_javax_crypto_Mac$linenum_table$getInstance$558c03fc000a2c0c[];

static _jc_trap_info _jc_javax_crypto_Mac$trap_table$getInstance$558c03fc000a2c0c[] = {
	_JC_TRAP(&_jc_java_lang_reflect_InvocationTargetException$type, 1, 2),
	_JC_TRAP(&_jc_java_lang_ClassCastException$type, 1, 2),
};

static const unsigned char _jc_javax_crypto_Mac$param_ptypes$getInstance$558c03fc000a2c0c[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_javax_crypto_Mac$exceptions$getInstance$558c03fc000a2c0c[] = {
	&_jc_java_security_NoSuchAlgorithmException$type
};

static _jc_type *const _jc_javax_crypto_Mac$param_types$getInstance$558c03fc000a2c0c[] = {
	&_jc_java_lang_String$type,
	&_jc_java_security_Provider$type
};

_jc_method _jc_javax_crypto_Mac$method_info$getInstance$558c03fc000a2c0c = {
	.name=			"getInstance",
	.signature=		"(Ljava/lang/String;Ljava/security/Provider;)Ljavax/crypto/Mac;",
	.class=			&_jc_javax_crypto_Mac$type,
	.param_types=		&_jc_javax_crypto_Mac$param_types$getInstance$558c03fc000a2c0c,
	.return_type=		&_jc_javax_crypto_Mac$type,
	.param_ptypes=		&_jc_javax_crypto_Mac$param_ptypes$getInstance$558c03fc000a2c0c,
	.signature_hash=	_JC_JLONG(0x558c03fc000a2c0c),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_Mac$method$getInstance$558c03fc000a2c0c,
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_crypto_Mac$exceptions$getInstance$558c03fc000a2c0c,
	.u= { .exec= {
	  .trap_table_len=	2,
	  .trap_table=		_jc_javax_crypto_Mac$trap_table$getInstance$558c03fc000a2c0c,
	  .u= {
	    .linenum= {
	      .len=	7,
	      .table=	_jc_javax_crypto_Mac$linenum_table$getInstance$558c03fc000a2c0c
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_Mac, getInstance$558c03fc000a2c0c);

_jc_javax_crypto_Mac$object * _JC_JCNI_ATTR
_jc_javax_crypto_Mac$method$getInstance$558c03fc000a2c0c(_jc_env *const env, _jc_java_lang_String$object *param0, _jc_java_security_Provider$object *param1)
{
	struct _jc_java_lang_String$object *volatile r0;
	struct _jc_java_security_Provider$object *r1;
	struct _jc_java_lang_Object$object *r10;
	struct _jc_java_lang_VMThrowable$object *volatile r11;
	struct _jc_java_lang_VMThrowable$object *volatile r12;
	struct _jc_java_lang_VMThrowable$object *volatile r13;
	struct _jc_javax_crypto_Mac$object *r2;
	struct _jc_java_lang_reflect_InvocationTargetException$object *volatile r3;
	struct _jc_javax_crypto_MacSpi$object *r4;
	struct _jc_java_lang_Throwable$object *volatile r5;
	struct _jc_java_security_NoSuchAlgorithmException$object *volatile r6;
	struct _jc_java_lang_ClassCastException$object *r7;
	struct _jc_java_lang_String$object *r8;
	_jc_object_array *r9;
	jboolean volatile z0;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_javax_crypto_Mac$method_info$getInstance$558c03fc000a2c0c, &&label0, &&label3);

	r0 = param0;
	r1 = param1;
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(180);				// 0
	r2 = _JC_NEW(env, javax_crypto_Mac);
	_JC_ACTIVE_USE(env, gnu_java_security_Engine);
	r8 = _JC_STRING(env, "Mac");
	r9 = _JC_STATIC_FIELD(env, gnu_java_security_Engine, NO__5fARGS, 1);
	r10 = _JC_INVOKE_STATIC(env, gnu_java_security_Engine, getInstance$ec89dfd35c234c64, 1, r8, r0, r1, r9);
	r4 = _JC_CAST(env, &_jc_javax_crypto_MacSpi$type, r10);
	_JC_REF_FIELD(env, r2, javax_crypto_Mac, macSpi) = r4;
	_JC_REF_FIELD(env, r2, javax_crypto_Mac, provider) = r1;
	_JC_REF_FIELD(env, r2, javax_crypto_Mac, algorithm) = r0;
	_JC_PRIM_FIELD(env, r2, javax_crypto_Mac, virgin) = 1;
	_JC_TRAP_REGION(catch, 2);
	_JC_CANCEL_TRAPS(env, catch);
	return r2;

label0:
	_JC_TRAP_REGION(catch, 2);
	r3 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(185);				// 1
	r5 = _JC_INVOKE_VIRTUAL(env, java_lang_reflect_InvocationTargetException, getCause$d5a96efc8523817a, r3);
	if (r5 != _JC_NULL)
		goto label1;
	_JC_LINE_NUMBER(186);				// 2
	r6 = _JC_NEW(env, java_security_NoSuchAlgorithmException);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, cause) = r6;
	r11 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r6);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, vmState) = r11;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, detailMessage) = r0;
	_JC_THROW(env, r6);

label1:
	_JC_LINE_NUMBER(187);				// 3
	r5 = _JC_INVOKE_VIRTUAL(env, java_lang_reflect_InvocationTargetException, getCause$d5a96efc8523817a, r3);
	z0 = _JC_INSTANCEOF(env, r5, &_jc_java_security_NoSuchAlgorithmException$type);
	if (z0 == 0)
		goto label2;
	_JC_LINE_NUMBER(188);				// 4
	r5 = _JC_INVOKE_VIRTUAL(env, java_lang_reflect_InvocationTargetException, getCause$d5a96efc8523817a, r3);
	r6 = _JC_CAST(env, &_jc_java_security_NoSuchAlgorithmException$type, r5);
	_JC_THROW(env, r6);

label2:
	_JC_LINE_NUMBER(189);				// 5
	r6 = _JC_NEW(env, java_security_NoSuchAlgorithmException);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, cause) = r6;
	r12 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r6);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, vmState) = r12;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, detailMessage) = r0;
	_JC_THROW(env, r6);

label3:
	_JC_TRAP_REGION(catch, 2);
	r7 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(193);				// 6
	r6 = _JC_NEW(env, java_security_NoSuchAlgorithmException);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, cause) = r6;
	r13 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r6);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, vmState) = r13;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, detailMessage) = r0;
	_JC_THROW(env, r6);
}

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// protected void <init>(javax.crypto.MacSpi, java.security.Provider, java.lang.String)
//

static _jc_linenum _jc_javax_crypto_Mac$linenum_table$_init$52ad21faca65115e[];

static const unsigned char _jc_javax_crypto_Mac$param_ptypes$_init$52ad21faca65115e[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_Mac$param_types$_init$52ad21faca65115e[] = {
	&_jc_javax_crypto_MacSpi$type,
	&_jc_java_security_Provider$type,
	&_jc_java_lang_String$type
};

_jc_method _jc_javax_crypto_Mac$method_info$_init$52ad21faca65115e = {
	.name=			"<init>",
	.signature=		"(Ljavax/crypto/MacSpi;Ljava/security/Provider;Ljava/lang/String;)V",
	.class=			&_jc_javax_crypto_Mac$type,
	.param_types=		&_jc_javax_crypto_Mac$param_types$_init$52ad21faca65115e,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_Mac$param_ptypes$_init$52ad21faca65115e,
	.signature_hash=	_JC_JLONG(0x52ad21faca65115e),
	.access_flags=		_JC_ACC_PROTECTED,
	.function=		&_jc_javax_crypto_Mac$method$_init$52ad21faca65115e,
	.num_parameters=	3,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_javax_crypto_Mac$linenum_table$_init$52ad21faca65115e
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_Mac, _init$52ad21faca65115e);

void _JC_JCNI_ATTR
_jc_javax_crypto_Mac$method$_init$52ad21faca65115e(_jc_env *const env, _jc_javax_crypto_Mac$object *this, _jc_javax_crypto_MacSpi$object *param0, _jc_java_security_Provider$object *param1, _jc_java_lang_String$object *param2)
{
	struct _jc_javax_crypto_Mac$object *r0;
	struct _jc_javax_crypto_MacSpi$object *r1;
	struct _jc_java_security_Provider$object *r2;
	struct _jc_java_lang_String$object *r3;

	r0 = this;
	r1 = param0;
	r2 = param1;
	r3 = param2;
	_JC_LINE_NUMBER(104);				// 0
	_JC_REF_FIELD(env, r0, javax_crypto_Mac, macSpi) = r1;
	_JC_LINE_NUMBER(105);				// 1
	_JC_REF_FIELD(env, r0, javax_crypto_Mac, provider) = r2;
	_JC_LINE_NUMBER(106);				// 2
	_JC_REF_FIELD(env, r0, javax_crypto_Mac, algorithm) = r3;
	_JC_LINE_NUMBER(107);				// 3
	_JC_PRIM_FIELD(env, r0, javax_crypto_Mac, virgin) = 1;
	_JC_LINE_NUMBER(108);				// 4
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public final java.lang.Object clone() throws java.lang.CloneNotSupportedException
//

static _jc_linenum _jc_javax_crypto_Mac$linenum_table$clone$b75f2713d6705f70[];

static const unsigned char _jc_javax_crypto_Mac$param_ptypes$clone$b75f2713d6705f70[] = { 
_JC_TYPE_REFERENCE };

static _jc_type *const _jc_javax_crypto_Mac$exceptions$clone$b75f2713d6705f70[] = {
	&_jc_java_lang_CloneNotSupportedException$type
};

_jc_method _jc_javax_crypto_Mac$method_info$clone$b75f2713d6705f70 = {
	.name=			"clone",
	.signature=		"()Ljava/lang/Object;",
	.class=			&_jc_javax_crypto_Mac$type,
	.return_type=		&_jc_java_lang_Object$type,
	.param_ptypes=		&_jc_javax_crypto_Mac$param_ptypes$clone$b75f2713d6705f70,
	.signature_hash=	_JC_JLONG(0xb75f2713d6705f70),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_Mac$method$clone$b75f2713d6705f70,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_Mac$vtable, javax_crypto_Mac.clone$b75f2713d6705f70) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_crypto_Mac$exceptions$clone$b75f2713d6705f70,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_javax_crypto_Mac$linenum_table$clone$b75f2713d6705f70
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_Mac, clone$b75f2713d6705f70);

_jc_java_lang_Object$object * _JC_JCNI_ATTR
_jc_javax_crypto_Mac$method$clone$b75f2713d6705f70(_jc_env *const env, _jc_javax_crypto_Mac$object *this)
{
	struct _jc_javax_crypto_Mac$object *r0;
	struct _jc_javax_crypto_Mac$object *r1;
	struct _jc_javax_crypto_MacSpi$object *r2;
	struct _jc_java_lang_Object$object *r3;
	struct _jc_java_security_Provider$object *r4;
	struct _jc_java_lang_String$object *r5;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(409);				// 0
	r1 = _JC_NEW(env, javax_crypto_Mac);
	r2 = _JC_REF_FIELD(env, r0, javax_crypto_Mac, macSpi);
	r3 = _JC_INVOKE_VIRTUAL(env, javax_crypto_MacSpi, clone$b75f2713d6705f70, r2);
	r2 = _JC_CAST(env, &_jc_javax_crypto_MacSpi$type, r3);
	r4 = _JC_REF_FIELD(env, r0, javax_crypto_Mac, provider);
	r5 = _JC_REF_FIELD(env, r0, javax_crypto_Mac, algorithm);
	_JC_REF_FIELD(env, r1, javax_crypto_Mac, macSpi) = r2;
	_JC_REF_FIELD(env, r1, javax_crypto_Mac, provider) = r4;
	_JC_REF_FIELD(env, r1, javax_crypto_Mac, algorithm) = r5;
	_JC_PRIM_FIELD(env, r1, javax_crypto_Mac, virgin) = 1;
	_JC_LINE_NUMBER(410);				// 1
	z0 = _JC_PRIM_FIELD(env, r0, javax_crypto_Mac, virgin);
	_JC_PRIM_FIELD(env, r1, javax_crypto_Mac, virgin) = z0;
	_JC_LINE_NUMBER(411);				// 2
	return r1;
}

//
// public final byte[] doFinal() throws java.lang.IllegalStateException
//

static _jc_linenum _jc_javax_crypto_Mac$linenum_table$doFinal$cd6684344483c19a[];

static const unsigned char _jc_javax_crypto_Mac$param_ptypes$doFinal$cd6684344483c19a[] = { 
_JC_TYPE_REFERENCE };

static _jc_type *const _jc_javax_crypto_Mac$exceptions$doFinal$cd6684344483c19a[] = {
	&_jc_java_lang_IllegalStateException$type
};

_jc_method _jc_javax_crypto_Mac$method_info$doFinal$cd6684344483c19a = {
	.name=			"doFinal",
	.signature=		"()[B",
	.class=			&_jc_javax_crypto_Mac$type,
	.return_type=		&_jc_byte$array$prim$type,
	.param_ptypes=		&_jc_javax_crypto_Mac$param_ptypes$doFinal$cd6684344483c19a,
	.signature_hash=	_JC_JLONG(0xcd6684344483c19a),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_Mac$method$doFinal$cd6684344483c19a,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_Mac$vtable, javax_crypto_Mac.doFinal$cd6684344483c19a) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_crypto_Mac$exceptions$doFinal$cd6684344483c19a,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_javax_crypto_Mac$linenum_table$doFinal$cd6684344483c19a
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_Mac, doFinal$cd6684344483c19a);

_jc_byte_array * _JC_JCNI_ATTR
_jc_javax_crypto_Mac$method$doFinal$cd6684344483c19a(_jc_env *const env, _jc_javax_crypto_Mac$object *this)
{
	struct _jc_javax_crypto_Mac$object *r0;
	_jc_byte_array *r1;
	struct _jc_java_lang_IllegalStateException$object *r2;
	struct _jc_javax_crypto_MacSpi$object *r3;
	struct _jc_java_lang_String$object *r4;
	struct _jc_javax_crypto_MacSpi$object *r5;
	struct _jc_java_lang_VMThrowable$object *r7;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(213);				// 0
	z0 = _JC_PRIM_FIELD(env, r0, javax_crypto_Mac, virgin);
	if (z0 == 0)
		goto label0;
	_JC_LINE_NUMBER(215);				// 1
	r2 = _JC_NEW(env, java_lang_IllegalStateException);
	r4 = _JC_STRING(env, "not initialized");
	_JC_REF_FIELD(env, r2, java_lang_Throwable, cause) = r2;
	r7 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r2);
	_JC_REF_FIELD(env, r2, java_lang_Throwable, vmState) = r7;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, detailMessage) = r4;
	_JC_THROW(env, r2);

label0:
	_JC_LINE_NUMBER(217);				// 2
	r3 = _JC_REF_FIELD(env, r0, javax_crypto_Mac, macSpi);
	r1 = _JC_INVOKE_VIRTUAL(env, javax_crypto_MacSpi, engineDoFinal$2694efd5c38c2d35, r3);
	r5 = _JC_REF_FIELD(env, r0, javax_crypto_Mac, macSpi);
	_JC_INVOKE_VIRTUAL(env, javax_crypto_MacSpi, engineReset$216e0febda0be220, r5);
	_JC_LINE_NUMBER(219);				// 3
	return r1;
}

//
// public final byte[] doFinal(byte[]) throws java.lang.IllegalStateException
//

static _jc_linenum _jc_javax_crypto_Mac$linenum_table$doFinal$b1afee017dcf0da2[];

static const unsigned char _jc_javax_crypto_Mac$param_ptypes$doFinal$b1afee017dcf0da2[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_javax_crypto_Mac$exceptions$doFinal$b1afee017dcf0da2[] = {
	&_jc_java_lang_IllegalStateException$type
};

static _jc_type *const _jc_javax_crypto_Mac$param_types$doFinal$b1afee017dcf0da2[] = {
	&_jc_byte$array$prim$type
};

_jc_method _jc_javax_crypto_Mac$method_info$doFinal$b1afee017dcf0da2 = {
	.name=			"doFinal",
	.signature=		"([B)[B",
	.class=			&_jc_javax_crypto_Mac$type,
	.param_types=		&_jc_javax_crypto_Mac$param_types$doFinal$b1afee017dcf0da2,
	.return_type=		&_jc_byte$array$prim$type,
	.param_ptypes=		&_jc_javax_crypto_Mac$param_ptypes$doFinal$b1afee017dcf0da2,
	.signature_hash=	_JC_JLONG(0xb1afee017dcf0da2),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_Mac$method$doFinal$b1afee017dcf0da2,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_Mac$vtable, javax_crypto_Mac.doFinal$b1afee017dcf0da2) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_crypto_Mac$exceptions$doFinal$b1afee017dcf0da2,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_javax_crypto_Mac$linenum_table$doFinal$b1afee017dcf0da2
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_Mac, doFinal$b1afee017dcf0da2);

_jc_byte_array * _JC_JCNI_ATTR
_jc_javax_crypto_Mac$method$doFinal$b1afee017dcf0da2(_jc_env *const env, _jc_javax_crypto_Mac$object *this, _jc_byte_array *param0)
{
	jint i0;
	struct _jc_javax_crypto_Mac$object *r0;
	_jc_byte_array *r1;
	struct _jc_javax_crypto_MacSpi$object *r2;
	struct _jc_javax_crypto_MacSpi$object *r3;
	struct _jc_java_lang_IllegalStateException$object *r4;
	struct _jc_javax_crypto_MacSpi$object *r5;
	struct _jc_java_lang_String$object *r6;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	i0 = _JC_ARRAY_LENGTH(env, r1);
	z0 = _JC_PRIM_FIELD(env, r0, javax_crypto_Mac, virgin);
	if (z0 == 0)
		goto label0;
	r4 = _JC_NEW(env, java_lang_IllegalStateException);
	r6 = _JC_STRING(env, "not initialized");
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	_JC_INVOKE_NONVIRTUAL(env, java_lang_Throwable, fillInStackTrace$6204b72985f9038d, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r6;
	_JC_THROW(env, r4);

label0:
	r5 = _JC_REF_FIELD(env, r0, javax_crypto_Mac, macSpi);
	_JC_INVOKE_VIRTUAL(env, javax_crypto_MacSpi, engineUpdate$d2f85b5d32010900, r5, r1, 0, i0);
	_JC_LINE_NUMBER(238);				// 0
	r2 = _JC_REF_FIELD(env, r0, javax_crypto_Mac, macSpi);
	r1 = _JC_INVOKE_VIRTUAL(env, javax_crypto_MacSpi, engineDoFinal$2694efd5c38c2d35, r2);
	r3 = _JC_REF_FIELD(env, r0, javax_crypto_Mac, macSpi);
	_JC_INVOKE_VIRTUAL(env, javax_crypto_MacSpi, engineReset$216e0febda0be220, r3);
	_JC_LINE_NUMBER(240);				// 1
	return r1;
}

//
// public final void doFinal(byte[], int) throws java.lang.IllegalStateException, javax.crypto.ShortBufferException
//

static _jc_linenum _jc_javax_crypto_Mac$linenum_table$doFinal$2de5daa34b64db85[];

static const unsigned char _jc_javax_crypto_Mac$param_ptypes$doFinal$2de5daa34b64db85[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_Mac$exceptions$doFinal$2de5daa34b64db85[] = {
	&_jc_java_lang_IllegalStateException$type,
	&_jc_javax_crypto_ShortBufferException$type
};

static _jc_type *const _jc_javax_crypto_Mac$param_types$doFinal$2de5daa34b64db85[] = {
	&_jc_byte$array$prim$type,
	&_jc_int$prim$type
};

_jc_method _jc_javax_crypto_Mac$method_info$doFinal$2de5daa34b64db85 = {
	.name=			"doFinal",
	.signature=		"([BI)V",
	.class=			&_jc_javax_crypto_Mac$type,
	.param_types=		&_jc_javax_crypto_Mac$param_types$doFinal$2de5daa34b64db85,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_Mac$param_ptypes$doFinal$2de5daa34b64db85,
	.signature_hash=	_JC_JLONG(0x2de5daa34b64db85),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_Mac$method$doFinal$2de5daa34b64db85,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_Mac$vtable, javax_crypto_Mac.doFinal$2de5daa34b64db85) / sizeof(void *),
	.num_parameters=	2,
	.num_exceptions=	2,
	.exceptions=		&_jc_javax_crypto_Mac$exceptions$doFinal$2de5daa34b64db85,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	6,
	      .table=	_jc_javax_crypto_Mac$linenum_table$doFinal$2de5daa34b64db85
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_Mac, doFinal$2de5daa34b64db85);

void _JC_JCNI_ATTR
_jc_javax_crypto_Mac$method$doFinal$2de5daa34b64db85(_jc_env *const env, _jc_javax_crypto_Mac$object *this, _jc_byte_array *param0, jint param1)
{
	jint i0;
	jint i1;
	jint i2;
	jint i3;
	struct _jc_javax_crypto_Mac$object *r0;
	_jc_byte_array *r1;
	struct _jc_java_lang_VMThrowable$object *r10;
	struct _jc_java_lang_String$object *r11;
	struct _jc_java_lang_VMThrowable$object *r13;
	_jc_byte_array *r2;
	struct _jc_java_lang_IllegalStateException$object *r3;
	struct _jc_javax_crypto_ShortBufferException$object *r4;
	struct _jc_javax_crypto_MacSpi$object *r5;
	struct _jc_java_lang_String$object *r6;
	struct _jc_javax_crypto_MacSpi$object *r7;
	struct _jc_javax_crypto_MacSpi$object *r8;
	struct _jc_javax_crypto_MacSpi$object *r9;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	i0 = param1;
	_JC_LINE_NUMBER(262);				// 0
	z0 = _JC_PRIM_FIELD(env, r0, javax_crypto_Mac, virgin);
	if (z0 == 0)
		goto label0;
	_JC_LINE_NUMBER(264);				// 1
	r3 = _JC_NEW(env, java_lang_IllegalStateException);
	r6 = _JC_STRING(env, "not initialized");
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r10 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r10;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r6;
	_JC_THROW(env, r3);

label0:
	_JC_LINE_NUMBER(266);				// 2
	i1 = _JC_ARRAY_LENGTH(env, r1);
	i1 = i1 - i0;
	r7 = _JC_REF_FIELD(env, r0, javax_crypto_Mac, macSpi);
	i2 = _JC_INVOKE_VIRTUAL(env, javax_crypto_MacSpi, engineGetMacLength$97fefa34434baf52, r7);
	if (i1 >= i2)
		goto label1;
	_JC_LINE_NUMBER(268);				// 3
	r4 = _JC_NEW(env, javax_crypto_ShortBufferException);
	r11 = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r13 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r13;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r11;
	_JC_THROW(env, r4);

label1:
	_JC_LINE_NUMBER(270);				// 4
	r5 = _JC_REF_FIELD(env, r0, javax_crypto_Mac, macSpi);
	r2 = _JC_INVOKE_VIRTUAL(env, javax_crypto_MacSpi, engineDoFinal$2694efd5c38c2d35, r5);
	r8 = _JC_REF_FIELD(env, r0, javax_crypto_Mac, macSpi);
	i3 = _JC_INVOKE_VIRTUAL(env, javax_crypto_MacSpi, engineGetMacLength$97fefa34434baf52, r8);
	_JC_ACTIVE_USE(env, java_lang_System);
	_JC_INVOKE_STATIC(env, java_lang_VMSystem, arraycopy$4286a72d57744cd8, 0, r2, 0, r1, i0, i3);
	r9 = _JC_REF_FIELD(env, r0, javax_crypto_Mac, macSpi);
	_JC_INVOKE_VIRTUAL(env, javax_crypto_MacSpi, engineReset$216e0febda0be220, r9);
	_JC_LINE_NUMBER(273);				// 5
	return;
}

//
// public final java.lang.String getAlgorithm()
//

static _jc_linenum _jc_javax_crypto_Mac$linenum_table$getAlgorithm$19abbbc132b9063a[];

static const unsigned char _jc_javax_crypto_Mac$param_ptypes$getAlgorithm$19abbbc132b9063a[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_javax_crypto_Mac$method_info$getAlgorithm$19abbbc132b9063a = {
	.name=			"getAlgorithm",
	.signature=		"()Ljava/lang/String;",
	.class=			&_jc_javax_crypto_Mac$type,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_javax_crypto_Mac$param_ptypes$getAlgorithm$19abbbc132b9063a,
	.signature_hash=	_JC_JLONG(0x19abbbc132b9063a),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_Mac$method$getAlgorithm$19abbbc132b9063a,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_Mac$vtable, javax_crypto_Mac.getAlgorithm$19abbbc132b9063a) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_crypto_Mac$linenum_table$getAlgorithm$19abbbc132b9063a
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_Mac, getAlgorithm$19abbbc132b9063a);

_jc_java_lang_String$object * _JC_JCNI_ATTR
_jc_javax_crypto_Mac$method$getAlgorithm$19abbbc132b9063a(_jc_env *const env, _jc_javax_crypto_Mac$object *this)
{
	struct _jc_javax_crypto_Mac$object *r0;
	struct _jc_java_lang_String$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(282);				// 0
	r1 = _JC_REF_FIELD(env, r0, javax_crypto_Mac, algorithm);
	return r1;
}

//
// public final int getMacLength()
//

static _jc_linenum _jc_javax_crypto_Mac$linenum_table$getMacLength$f690f80a825b26ef[];

static const unsigned char _jc_javax_crypto_Mac$param_ptypes$getMacLength$f690f80a825b26ef[] = { 
_JC_TYPE_INT };

_jc_method _jc_javax_crypto_Mac$method_info$getMacLength$f690f80a825b26ef = {
	.name=			"getMacLength",
	.signature=		"()I",
	.class=			&_jc_javax_crypto_Mac$type,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_javax_crypto_Mac$param_ptypes$getMacLength$f690f80a825b26ef,
	.signature_hash=	_JC_JLONG(0xf690f80a825b26ef),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_Mac$method$getMacLength$f690f80a825b26ef,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_Mac$vtable, javax_crypto_Mac.getMacLength$f690f80a825b26ef) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_crypto_Mac$linenum_table$getMacLength$f690f80a825b26ef
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_Mac, getMacLength$f690f80a825b26ef);

jint _JC_JCNI_ATTR
_jc_javax_crypto_Mac$method$getMacLength$f690f80a825b26ef(_jc_env *const env, _jc_javax_crypto_Mac$object *this)
{
	jint i0;
	struct _jc_javax_crypto_Mac$object *r0;
	struct _jc_javax_crypto_MacSpi$object *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(295);				// 0
	r1 = _JC_REF_FIELD(env, r0, javax_crypto_Mac, macSpi);
	i0 = _JC_INVOKE_VIRTUAL(env, javax_crypto_MacSpi, engineGetMacLength$97fefa34434baf52, r1);
	return i0;
}

//
// public final java.security.Provider getProvider()
//

static _jc_linenum _jc_javax_crypto_Mac$linenum_table$getProvider$e8f9c9fb14140d5a[];

static const unsigned char _jc_javax_crypto_Mac$param_ptypes$getProvider$e8f9c9fb14140d5a[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_javax_crypto_Mac$method_info$getProvider$e8f9c9fb14140d5a = {
	.name=			"getProvider",
	.signature=		"()Ljava/security/Provider;",
	.class=			&_jc_javax_crypto_Mac$type,
	.return_type=		&_jc_java_security_Provider$type,
	.param_ptypes=		&_jc_javax_crypto_Mac$param_ptypes$getProvider$e8f9c9fb14140d5a,
	.signature_hash=	_JC_JLONG(0xe8f9c9fb14140d5a),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_Mac$method$getProvider$e8f9c9fb14140d5a,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_Mac$vtable, javax_crypto_Mac.getProvider$e8f9c9fb14140d5a) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_crypto_Mac$linenum_table$getProvider$e8f9c9fb14140d5a
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_Mac, getProvider$e8f9c9fb14140d5a);

_jc_java_security_Provider$object * _JC_JCNI_ATTR
_jc_javax_crypto_Mac$method$getProvider$e8f9c9fb14140d5a(_jc_env *const env, _jc_javax_crypto_Mac$object *this)
{
	struct _jc_javax_crypto_Mac$object *r0;
	struct _jc_java_security_Provider$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(305);				// 0
	r1 = _JC_REF_FIELD(env, r0, javax_crypto_Mac, provider);
	return r1;
}

//
// public final void init(java.security.Key) throws java.security.InvalidKeyException
//

static _jc_linenum _jc_javax_crypto_Mac$linenum_table$init$a20ac47f1570a2f7[];

static _jc_trap_info _jc_javax_crypto_Mac$trap_table$init$a20ac47f1570a2f7[] = {
	_JC_TRAP(&_jc_java_security_InvalidAlgorithmParameterException$type, 1, 2),
};

static const unsigned char _jc_javax_crypto_Mac$param_ptypes$init$a20ac47f1570a2f7[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_Mac$exceptions$init$a20ac47f1570a2f7[] = {
	&_jc_java_security_InvalidKeyException$type
};

static _jc_type *const _jc_javax_crypto_Mac$param_types$init$a20ac47f1570a2f7[] = {
	&_jc_java_security_Key$type
};

_jc_method _jc_javax_crypto_Mac$method_info$init$a20ac47f1570a2f7 = {
	.name=			"init",
	.signature=		"(Ljava/security/Key;)V",
	.class=			&_jc_javax_crypto_Mac$type,
	.param_types=		&_jc_javax_crypto_Mac$param_types$init$a20ac47f1570a2f7,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_Mac$param_ptypes$init$a20ac47f1570a2f7,
	.signature_hash=	_JC_JLONG(0xa20ac47f1570a2f7),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_Mac$method$init$a20ac47f1570a2f7,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_Mac$vtable, javax_crypto_Mac.init$a20ac47f1570a2f7) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_crypto_Mac$exceptions$init$a20ac47f1570a2f7,
	.u= { .exec= {
	  .trap_table_len=	1,
	  .trap_table=		_jc_javax_crypto_Mac$trap_table$init$a20ac47f1570a2f7,
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_javax_crypto_Mac$linenum_table$init$a20ac47f1570a2f7
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_Mac, init$a20ac47f1570a2f7);

void _JC_JCNI_ATTR
_jc_javax_crypto_Mac$method$init$a20ac47f1570a2f7(_jc_env *const env, _jc_javax_crypto_Mac$object *this, _jc_object *param0)
{
	struct _jc_javax_crypto_Mac$object *volatile r0;
	struct _jc_object *r1;
	struct _jc_java_lang_VMThrowable$object *volatile r11;
	struct _jc_java_security_InvalidAlgorithmParameterException$object *r2;
	struct _jc_java_lang_IllegalArgumentException$object *volatile r3;
	struct _jc_java_lang_StringBuffer$object *volatile r4;
	struct _jc_java_lang_String$object *volatile r5;
	struct _jc_java_lang_String$object *volatile r6;
	struct _jc_object *r7;
	struct _jc_javax_crypto_MacSpi$object *r8;
	_jc_char_array *volatile r9;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_javax_crypto_Mac$method_info$init$a20ac47f1570a2f7, &&label0);

	r0 = this;
	r1 = param0;
	_JC_TRAP_REGION(catch, 1);
	r7 = _JC_NULL;
	r8 = _JC_REF_FIELD(env, r0, javax_crypto_Mac, macSpi);
	_JC_INVOKE_VIRTUAL(env, javax_crypto_MacSpi, engineInit$af0504f670894439, r8, r1, r7);
	_JC_PRIM_FIELD(env, r0, javax_crypto_Mac, virgin) = 0;
	_JC_TRAP_REGION(catch, 2);
	_JC_LINE_NUMBER(319);				// 0
	goto label1;

label0:
	_JC_TRAP_REGION(catch, 2);
	r2 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(323);				// 1
	r3 = _JC_NEW(env, java_lang_IllegalArgumentException);
	r4 = _JC_NEW(env, java_lang_StringBuffer);
	r9 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r4, java_lang_StringBuffer, value) = r9;
	r5 = _JC_REF_FIELD(env, r0, javax_crypto_Mac, algorithm);
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, r5);
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, _JC_STRING(env, " needs parameters"));
	r6 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r6, r4);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r11 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r11;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r6;
	_JC_THROW(env, r3);

label1:
	_JC_LINE_NUMBER(325);				// 2
	_JC_CANCEL_TRAPS(env, catch);
	return;
}

//
// public final void init(java.security.Key, java.security.spec.AlgorithmParameterSpec) throws java.security.InvalidAlgorithmParameterException, java.security.InvalidKeyException
//

static _jc_linenum _jc_javax_crypto_Mac$linenum_table$init$24fee54d988e28f1[];

static const unsigned char _jc_javax_crypto_Mac$param_ptypes$init$24fee54d988e28f1[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_Mac$exceptions$init$24fee54d988e28f1[] = {
	&_jc_java_security_InvalidAlgorithmParameterException$type,
	&_jc_java_security_InvalidKeyException$type
};

static _jc_type *const _jc_javax_crypto_Mac$param_types$init$24fee54d988e28f1[] = {
	&_jc_java_security_Key$type,
	&_jc_java_security_spec_AlgorithmParameterSpec$type
};

_jc_method _jc_javax_crypto_Mac$method_info$init$24fee54d988e28f1 = {
	.name=			"init",
	.signature=		"(Ljava/security/Key;Ljava/security/spec/AlgorithmParameterSpec;)V",
	.class=			&_jc_javax_crypto_Mac$type,
	.param_types=		&_jc_javax_crypto_Mac$param_types$init$24fee54d988e28f1,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_Mac$param_ptypes$init$24fee54d988e28f1,
	.signature_hash=	_JC_JLONG(0x24fee54d988e28f1),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_Mac$method$init$24fee54d988e28f1,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_Mac$vtable, javax_crypto_Mac.init$24fee54d988e28f1) / sizeof(void *),
	.num_parameters=	2,
	.num_exceptions=	2,
	.exceptions=		&_jc_javax_crypto_Mac$exceptions$init$24fee54d988e28f1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_javax_crypto_Mac$linenum_table$init$24fee54d988e28f1
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_Mac, init$24fee54d988e28f1);

void _JC_JCNI_ATTR
_jc_javax_crypto_Mac$method$init$24fee54d988e28f1(_jc_env *const env, _jc_javax_crypto_Mac$object *this, _jc_object *param0, _jc_object *param1)
{
	struct _jc_javax_crypto_Mac$object *r0;
	struct _jc_object *r1;
	struct _jc_object *r2;
	struct _jc_javax_crypto_MacSpi$object *r3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_LINE_NUMBER(340);				// 0
	r3 = _JC_REF_FIELD(env, r0, javax_crypto_Mac, macSpi);
	_JC_INVOKE_VIRTUAL(env, javax_crypto_MacSpi, engineInit$af0504f670894439, r3, r1, r2);
	_JC_LINE_NUMBER(341);				// 1
	_JC_PRIM_FIELD(env, r0, javax_crypto_Mac, virgin) = 0;
	_JC_LINE_NUMBER(342);				// 2
	return;
}

//
// public final void reset()
//

static _jc_linenum _jc_javax_crypto_Mac$linenum_table$reset$229a80b3e8394a0f[];

static const unsigned char _jc_javax_crypto_Mac$param_ptypes$reset$229a80b3e8394a0f[] = { 
_JC_TYPE_VOID };

_jc_method _jc_javax_crypto_Mac$method_info$reset$229a80b3e8394a0f = {
	.name=			"reset",
	.signature=		"()V",
	.class=			&_jc_javax_crypto_Mac$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_Mac$param_ptypes$reset$229a80b3e8394a0f,
	.signature_hash=	_JC_JLONG(0x229a80b3e8394a0f),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_Mac$method$reset$229a80b3e8394a0f,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_Mac$vtable, javax_crypto_Mac.reset$229a80b3e8394a0f) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_javax_crypto_Mac$linenum_table$reset$229a80b3e8394a0f
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_Mac, reset$229a80b3e8394a0f);

void _JC_JCNI_ATTR
_jc_javax_crypto_Mac$method$reset$229a80b3e8394a0f(_jc_env *const env, _jc_javax_crypto_Mac$object *this)
{
	struct _jc_javax_crypto_Mac$object *r0;
	struct _jc_javax_crypto_MacSpi$object *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(350);				// 0
	r1 = _JC_REF_FIELD(env, r0, javax_crypto_Mac, macSpi);
	_JC_INVOKE_VIRTUAL(env, javax_crypto_MacSpi, engineReset$216e0febda0be220, r1);
	_JC_LINE_NUMBER(351);				// 1
	return;
}

//
// public final void update(byte) throws java.lang.IllegalStateException
//

static _jc_linenum _jc_javax_crypto_Mac$linenum_table$update$373bf0a44dde26ba[];

static const unsigned char _jc_javax_crypto_Mac$param_ptypes$update$373bf0a44dde26ba[] = { 
_JC_TYPE_BYTE, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_Mac$exceptions$update$373bf0a44dde26ba[] = {
	&_jc_java_lang_IllegalStateException$type
};

static _jc_type *const _jc_javax_crypto_Mac$param_types$update$373bf0a44dde26ba[] = {
	&_jc_byte$prim$type
};

_jc_method _jc_javax_crypto_Mac$method_info$update$373bf0a44dde26ba = {
	.name=			"update",
	.signature=		"(B)V",
	.class=			&_jc_javax_crypto_Mac$type,
	.param_types=		&_jc_javax_crypto_Mac$param_types$update$373bf0a44dde26ba,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_Mac$param_ptypes$update$373bf0a44dde26ba,
	.signature_hash=	_JC_JLONG(0x373bf0a44dde26ba),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_Mac$method$update$373bf0a44dde26ba,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_Mac$vtable, javax_crypto_Mac.update$373bf0a44dde26ba) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_crypto_Mac$exceptions$update$373bf0a44dde26ba,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_javax_crypto_Mac$linenum_table$update$373bf0a44dde26ba
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_Mac, update$373bf0a44dde26ba);

void _JC_JCNI_ATTR
_jc_javax_crypto_Mac$method$update$373bf0a44dde26ba(_jc_env *const env, _jc_javax_crypto_Mac$object *this, jbyte param0)
{
	jbyte b0;
	struct _jc_javax_crypto_Mac$object *r0;
	struct _jc_java_lang_IllegalStateException$object *r1;
	struct _jc_javax_crypto_MacSpi$object *r2;
	struct _jc_java_lang_String$object *r3;
	struct _jc_java_lang_VMThrowable$object *r5;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	b0 = param0;
	_JC_LINE_NUMBER(362);				// 0
	z0 = _JC_PRIM_FIELD(env, r0, javax_crypto_Mac, virgin);
	if (z0 == 0)
		goto label0;
	_JC_LINE_NUMBER(364);				// 1
	r1 = _JC_NEW(env, java_lang_IllegalStateException);
	r3 = _JC_STRING(env, "not initialized");
	_JC_REF_FIELD(env, r1, java_lang_Throwable, cause) = r1;
	r5 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r1);
	_JC_REF_FIELD(env, r1, java_lang_Throwable, vmState) = r5;
	_JC_REF_FIELD(env, r1, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r1, java_lang_Throwable, detailMessage) = r3;
	_JC_THROW(env, r1);

label0:
	_JC_LINE_NUMBER(366);				// 2
	r2 = _JC_REF_FIELD(env, r0, javax_crypto_Mac, macSpi);
	_JC_INVOKE_VIRTUAL(env, javax_crypto_MacSpi, engineUpdate$807e0421d3c3a314, r2, b0);
	_JC_LINE_NUMBER(367);				// 3
	return;
}

//
// public final void update(byte[]) throws java.lang.IllegalStateException
//

static _jc_linenum _jc_javax_crypto_Mac$linenum_table$update$3e1f8b534704abb5[];

static const unsigned char _jc_javax_crypto_Mac$param_ptypes$update$3e1f8b534704abb5[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_Mac$exceptions$update$3e1f8b534704abb5[] = {
	&_jc_java_lang_IllegalStateException$type
};

static _jc_type *const _jc_javax_crypto_Mac$param_types$update$3e1f8b534704abb5[] = {
	&_jc_byte$array$prim$type
};

_jc_method _jc_javax_crypto_Mac$method_info$update$3e1f8b534704abb5 = {
	.name=			"update",
	.signature=		"([B)V",
	.class=			&_jc_javax_crypto_Mac$type,
	.param_types=		&_jc_javax_crypto_Mac$param_types$update$3e1f8b534704abb5,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_Mac$param_ptypes$update$3e1f8b534704abb5,
	.signature_hash=	_JC_JLONG(0x3e1f8b534704abb5),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_Mac$method$update$3e1f8b534704abb5,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_Mac$vtable, javax_crypto_Mac.update$3e1f8b534704abb5) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_crypto_Mac$exceptions$update$3e1f8b534704abb5,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_javax_crypto_Mac$linenum_table$update$3e1f8b534704abb5
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_Mac, update$3e1f8b534704abb5);

void _JC_JCNI_ATTR
_jc_javax_crypto_Mac$method$update$3e1f8b534704abb5(_jc_env *const env, _jc_javax_crypto_Mac$object *this, _jc_byte_array *param0)
{
	jint i0;
	struct _jc_javax_crypto_Mac$object *r0;
	_jc_byte_array *r1;
	struct _jc_java_lang_IllegalStateException$object *r2;
	struct _jc_javax_crypto_MacSpi$object *r3;
	struct _jc_java_lang_String$object *r4;
	struct _jc_java_lang_VMThrowable$object *r6;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(378);				// 0
	i0 = _JC_ARRAY_LENGTH(env, r1);
	z0 = _JC_PRIM_FIELD(env, r0, javax_crypto_Mac, virgin);
	if (z0 == 0)
		goto label0;
	r2 = _JC_NEW(env, java_lang_IllegalStateException);
	r4 = _JC_STRING(env, "not initialized");
	_JC_REF_FIELD(env, r2, java_lang_Throwable, cause) = r2;
	r6 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r2);
	_JC_REF_FIELD(env, r2, java_lang_Throwable, vmState) = r6;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, detailMessage) = r4;
	_JC_THROW(env, r2);

label0:
	r3 = _JC_REF_FIELD(env, r0, javax_crypto_Mac, macSpi);
	_JC_INVOKE_VIRTUAL(env, javax_crypto_MacSpi, engineUpdate$d2f85b5d32010900, r3, r1, 0, i0);
	_JC_LINE_NUMBER(379);				// 1
	return;
}

//
// public final void update(byte[], int, int) throws java.lang.IllegalStateException
//

static _jc_linenum _jc_javax_crypto_Mac$linenum_table$update$f73f1b3bfa3ea853[];

static const unsigned char _jc_javax_crypto_Mac$param_ptypes$update$f73f1b3bfa3ea853[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_INT, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_Mac$exceptions$update$f73f1b3bfa3ea853[] = {
	&_jc_java_lang_IllegalStateException$type
};

static _jc_type *const _jc_javax_crypto_Mac$param_types$update$f73f1b3bfa3ea853[] = {
	&_jc_byte$array$prim$type,
	&_jc_int$prim$type,
	&_jc_int$prim$type
};

_jc_method _jc_javax_crypto_Mac$method_info$update$f73f1b3bfa3ea853 = {
	.name=			"update",
	.signature=		"([BII)V",
	.class=			&_jc_javax_crypto_Mac$type,
	.param_types=		&_jc_javax_crypto_Mac$param_types$update$f73f1b3bfa3ea853,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_Mac$param_ptypes$update$f73f1b3bfa3ea853,
	.signature_hash=	_JC_JLONG(0xf73f1b3bfa3ea853),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_crypto_Mac$method$update$f73f1b3bfa3ea853,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_Mac$vtable, javax_crypto_Mac.update$f73f1b3bfa3ea853) / sizeof(void *),
	.num_parameters=	3,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_crypto_Mac$exceptions$update$f73f1b3bfa3ea853,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_javax_crypto_Mac$linenum_table$update$f73f1b3bfa3ea853
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_Mac, update$f73f1b3bfa3ea853);

void _JC_JCNI_ATTR
_jc_javax_crypto_Mac$method$update$f73f1b3bfa3ea853(_jc_env *const env, _jc_javax_crypto_Mac$object *this, _jc_byte_array *param0, jint param1, jint param2)
{
	jint i0;
	jint i1;
	struct _jc_javax_crypto_Mac$object *r0;
	_jc_byte_array *r1;
	struct _jc_java_lang_IllegalStateException$object *r2;
	struct _jc_javax_crypto_MacSpi$object *r3;
	struct _jc_java_lang_String$object *r4;
	struct _jc_java_lang_VMThrowable$object *r6;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	i0 = param1;
	i1 = param2;
	_JC_LINE_NUMBER(393);				// 0
	z0 = _JC_PRIM_FIELD(env, r0, javax_crypto_Mac, virgin);
	if (z0 == 0)
		goto label0;
	_JC_LINE_NUMBER(395);				// 1
	r2 = _JC_NEW(env, java_lang_IllegalStateException);
	r4 = _JC_STRING(env, "not initialized");
	_JC_REF_FIELD(env, r2, java_lang_Throwable, cause) = r2;
	r6 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r2);
	_JC_REF_FIELD(env, r2, java_lang_Throwable, vmState) = r6;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, detailMessage) = r4;
	_JC_THROW(env, r2);

label0:
	_JC_LINE_NUMBER(397);				// 2
	r3 = _JC_REF_FIELD(env, r0, javax_crypto_Mac, macSpi);
	_JC_INVOKE_VIRTUAL(env, javax_crypto_MacSpi, engineUpdate$d2f85b5d32010900, r3, r1, i0, i1);
	_JC_LINE_NUMBER(398);				// 3
	return;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_javax_crypto_Mac$methods[] = {
	&_jc_javax_crypto_Mac$method_info$_init$52ad21faca65115e,
	&_jc_javax_crypto_Mac$method_info$clone$b75f2713d6705f70,
	&_jc_javax_crypto_Mac$method_info$doFinal$cd6684344483c19a,
	&_jc_javax_crypto_Mac$method_info$doFinal$b1afee017dcf0da2,
	&_jc_javax_crypto_Mac$method_info$doFinal$2de5daa34b64db85,
	&_jc_javax_crypto_Mac$method_info$getAlgorithm$19abbbc132b9063a,
	&_jc_javax_crypto_Mac$method_info$getInstance$79dbcb4835b7fd4d,
	&_jc_javax_crypto_Mac$method_info$getInstance$2d9aa7ff178c0039,
	&_jc_javax_crypto_Mac$method_info$getInstance$558c03fc000a2c0c,
	&_jc_javax_crypto_Mac$method_info$getMacLength$f690f80a825b26ef,
	&_jc_javax_crypto_Mac$method_info$getProvider$e8f9c9fb14140d5a,
	&_jc_javax_crypto_Mac$method_info$init$a20ac47f1570a2f7,
	&_jc_javax_crypto_Mac$method_info$init$24fee54d988e28f1,
	&_jc_javax_crypto_Mac$method_info$reset$229a80b3e8394a0f,
	&_jc_javax_crypto_Mac$method_info$update$373bf0a44dde26ba,
	&_jc_javax_crypto_Mac$method_info$update$3e1f8b534704abb5,
	&_jc_javax_crypto_Mac$method_info$update$f73f1b3bfa3ea853
};

/************************************************************************
 *			  Class fields structure			*
 ************************************************************************/

_jc_javax_crypto_Mac$fields_struct _jc_javax_crypto_Mac$class_fields = { };

/************************************************************************
 *			      Interface list				*
 ************************************************************************/

// Directly implemented interfaces
static _jc_type *const _jc_javax_crypto_Mac$interfaces[] = {
	&_jc_java_lang_Cloneable$type
};

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_javax_crypto_Mac$instanceof_hash_bucket_19[] = {
	&_jc_java_lang_Cloneable$type,
	_JC_NULL
};
static _jc_type *const _jc_javax_crypto_Mac$instanceof_hash_bucket_28[] = {
	&_jc_javax_crypto_Mac$type,
	_JC_NULL
};
static _jc_type *const _jc_javax_crypto_Mac$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_javax_crypto_Mac$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[19]=	_jc_javax_crypto_Mac$instanceof_hash_bucket_19,
	[28]=	_jc_javax_crypto_Mac$instanceof_hash_bucket_28,
	[101]=	_jc_javax_crypto_Mac$instanceof_hash_bucket_101
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_javax_crypto_Mac$class_depends[] = {
	{ "gnu/java/security/Engine",	_JC_JLONG(0xf4ba095546954b36) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/ClassCastException",	_JC_JLONG(0xf02ab3ccb490a6d0) },
	{ "java/lang/CloneNotSupportedException",	_JC_JLONG(0xd59353b5e031d754) },
	{ "java/lang/Cloneable",	_JC_JLONG(0x9b667b09132be893) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/IllegalArgumentException",	_JC_JLONG(0x680cf34d05feb5a1) },
	{ "java/lang/IllegalStateException",	_JC_JLONG(0xb7e704701c278e65) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/RuntimeException",	_JC_JLONG(0x4f5534a987354d1d) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/StringBuffer",	_JC_JLONG(0x94d357637b968dda) },
	{ "java/lang/System",	_JC_JLONG(0x53cc8e2333795f04) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMSystem",	_JC_JLONG(0x4d1cebae0bdda058) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/lang/reflect/InvocationTargetException",	_JC_JLONG(0xae4a2342b31a268d) },
	{ "java/security/GeneralSecurityException",	_JC_JLONG(0x692089051f4c8d0b) },
	{ "java/security/InvalidAlgorithmParameterException",	_JC_JLONG(0x327edce29f2562dd) },
	{ "java/security/InvalidKeyException",	_JC_JLONG(0x94dda41e9bf6c170) },
	{ "java/security/Key",	_JC_JLONG(0xa467c6cd05d9cc51) },
	{ "java/security/NoSuchAlgorithmException",	_JC_JLONG(0x22e937c2536160b4) },
	{ "java/security/NoSuchProviderException",	_JC_JLONG(0x8dfbf242adab91e) },
	{ "java/security/Provider",	_JC_JLONG(0x81b073051aa30acc) },
	{ "java/security/Security",	_JC_JLONG(0x89bf77984bd9669e) },
	{ "java/security/spec/AlgorithmParameterSpec",	_JC_JLONG(0xef2e5e8af121478f) },
	{ "java/util/Vector",	_JC_JLONG(0xc53e1575b095109b) },
	{ "javax/crypto/MacSpi",	_JC_JLONG(0xb809bfd247d0c389) },
	{ "javax/crypto/ShortBufferException",	_JC_JLONG(0xd79a62a9328ccea1) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_javax_crypto_Mac$vtype _jc_javax_crypto_Mac$type = {
    .type= {
	.name=			"javax/crypto/Mac",
	.superclass=		&_jc_java_lang_Object$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.num_interfaces=sizeof(_jc_javax_crypto_Mac$interfaces) / sizeof(*_jc_javax_crypto_Mac$interfaces),
	.interfaces=		_jc_javax_crypto_Mac$interfaces,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		24,
		.hash=			_JC_JLONG(0x51513444ac2c709c),
		.source_file=		"Mac.java",
		.instance_size=		sizeof(_jc_javax_crypto_Mac$refs) + sizeof(_jc_javax_crypto_Mac$object),
		.num_virtual_refs=	3,
		.num_fields=		sizeof(_jc_javax_crypto_Mac$fields) / sizeof(*_jc_javax_crypto_Mac$fields),
		.fields=		_jc_javax_crypto_Mac$fields,
		.num_methods=		sizeof(_jc_javax_crypto_Mac$methods) / sizeof(*_jc_javax_crypto_Mac$methods),
		.methods=		_jc_javax_crypto_Mac$methods,
		.instanceof_hash_table=	_jc_javax_crypto_Mac$instanceof_hash_table,
		.class_fields=		&_jc_javax_crypto_Mac$class_fields,
		.num_class_depends=		sizeof(_jc_javax_crypto_Mac$class_depends) / sizeof(*_jc_javax_crypto_Mac$class_depends),
		.class_depends=		_jc_javax_crypto_Mac$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=			// overridden
		&_jc_javax_crypto_Mac$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.javax_crypto_Mac= {
	    .clone$b75f2713d6705f70=
		&_jc_javax_crypto_Mac$method$clone$b75f2713d6705f70,
	    .doFinal$cd6684344483c19a=
		&_jc_javax_crypto_Mac$method$doFinal$cd6684344483c19a,
	    .doFinal$b1afee017dcf0da2=
		&_jc_javax_crypto_Mac$method$doFinal$b1afee017dcf0da2,
	    .doFinal$2de5daa34b64db85=
		&_jc_javax_crypto_Mac$method$doFinal$2de5daa34b64db85,
	    .getAlgorithm$19abbbc132b9063a=
		&_jc_javax_crypto_Mac$method$getAlgorithm$19abbbc132b9063a,
	    .getMacLength$f690f80a825b26ef=
		&_jc_javax_crypto_Mac$method$getMacLength$f690f80a825b26ef,
	    .getProvider$e8f9c9fb14140d5a=
		&_jc_javax_crypto_Mac$method$getProvider$e8f9c9fb14140d5a,
	    .init$a20ac47f1570a2f7=
		&_jc_javax_crypto_Mac$method$init$a20ac47f1570a2f7,
	    .init$24fee54d988e28f1=
		&_jc_javax_crypto_Mac$method$init$24fee54d988e28f1,
	    .reset$229a80b3e8394a0f=
		&_jc_javax_crypto_Mac$method$reset$229a80b3e8394a0f,
	    .update$373bf0a44dde26ba=
		&_jc_javax_crypto_Mac$method$update$373bf0a44dde26ba,
	    .update$3e1f8b534704abb5=
		&_jc_javax_crypto_Mac$method$update$3e1f8b534704abb5,
	    .update$f73f1b3bfa3ea853=
		&_jc_javax_crypto_Mac$method$update$f73f1b3bfa3ea853,
	},
    }
};

