// public class javax.crypto.spec.RC2ParameterSpec

// class file dependencies
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class 680cf34d05feb5a1 java_lang_IllegalArgumentException
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class 4f5534a987354d1d java_lang_RuntimeException
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 53cc8e2333795f04 java_lang_System
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class 4d1cebae0bdda058 java_lang_VMSystem
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class ef2e5e8af121478f java_security_spec_AlgorithmParameterSpec
// @dep_class 6ec0a11777fc9640 javax_crypto_spec_RC2ParameterSpec

// header file dependencies
// @dep_header java_lang_Class
// @dep_header java_lang_IllegalArgumentException
// @dep_header java_lang_String
// @dep_header java_lang_System
// @dep_header java_lang_VMSystem
// @dep_header java_lang_VMThrowable
// @dep_header java_security_spec_AlgorithmParameterSpec
// @dep_header javax_crypto_spec_RC2ParameterSpec

#include "jc_defs.h"

#include "java/lang/Class.h"
#include "java/lang/IllegalArgumentException.h"
#include "java/lang/String.h"
#include "java/lang/System.h"
#include "java/lang/VMSystem.h"
#include "java/lang/VMThrowable.h"
#include "java/security/spec/AlgorithmParameterSpec.h"
#include "javax/crypto/spec/RC2ParameterSpec.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// private static final int RC2_IV_LENGTH
static const jint _jc_javax_crypto_spec_RC2ParameterSpec$initial_value$RC2__5fIV__5fLENGTH = 8;
static _jc_field _jc_javax_crypto_spec_RC2ParameterSpec$field_info$RC2__5fIV__5fLENGTH = {
	.name=		"RC2_IV_LENGTH",
	.signature=	"I",
	.class=		&_jc_javax_crypto_spec_RC2ParameterSpec$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_spec_RC2ParameterSpec$fields_struct, RC2__5fIV__5fLENGTH),
	.initial_value=	&_jc_javax_crypto_spec_RC2ParameterSpec$initial_value$RC2__5fIV__5fLENGTH,
};

// private int effectiveKeyBits
static _jc_field _jc_javax_crypto_spec_RC2ParameterSpec$field_info$effectiveKeyBits = {
	.name=		"effectiveKeyBits",
	.signature=	"I",
	.class=		&_jc_javax_crypto_spec_RC2ParameterSpec$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_spec_RC2ParameterSpec$object, nonrefs.javax_crypto_spec_RC2ParameterSpec.effectiveKeyBits),
};

// private byte[] iv
static _jc_field _jc_javax_crypto_spec_RC2ParameterSpec$field_info$iv = {
	.name=		"iv",
	.signature=	"[B",
	.class=		&_jc_javax_crypto_spec_RC2ParameterSpec$type,
	.type=		&_jc_byte$array$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_javax_crypto_spec_RC2ParameterSpec$object, refs[-1].javax_crypto_spec_RC2ParameterSpec.iv),
};

// Fields
static _jc_field *const _jc_javax_crypto_spec_RC2ParameterSpec$fields[] = {
	&_jc_javax_crypto_spec_RC2ParameterSpec$field_info$RC2__5fIV__5fLENGTH,
	&_jc_javax_crypto_spec_RC2ParameterSpec$field_info$iv,
	&_jc_javax_crypto_spec_RC2ParameterSpec$field_info$effectiveKeyBits
};

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// public void <init>(int)
//

static _jc_linenum _jc_javax_crypto_spec_RC2ParameterSpec$linenum_table$_init$7f1776288300b98d[];

static const unsigned char _jc_javax_crypto_spec_RC2ParameterSpec$param_ptypes$_init$7f1776288300b98d[] = { 
_JC_TYPE_INT, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_spec_RC2ParameterSpec$param_types$_init$7f1776288300b98d[] = {
	&_jc_int$prim$type
};

_jc_method _jc_javax_crypto_spec_RC2ParameterSpec$method_info$_init$7f1776288300b98d = {
	.name=			"<init>",
	.signature=		"(I)V",
	.class=			&_jc_javax_crypto_spec_RC2ParameterSpec$type,
	.param_types=		&_jc_javax_crypto_spec_RC2ParameterSpec$param_types$_init$7f1776288300b98d,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_spec_RC2ParameterSpec$param_ptypes$_init$7f1776288300b98d,
	.signature_hash=	_JC_JLONG(0x7f1776288300b98d),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_javax_crypto_spec_RC2ParameterSpec$method$_init$7f1776288300b98d,
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_javax_crypto_spec_RC2ParameterSpec$linenum_table$_init$7f1776288300b98d
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_spec_RC2ParameterSpec, _init$7f1776288300b98d);

void _JC_JCNI_ATTR
_jc_javax_crypto_spec_RC2ParameterSpec$method$_init$7f1776288300b98d(_jc_env *const env, _jc_javax_crypto_spec_RC2ParameterSpec$object *this, jint param0)
{
	jint i0;
	struct _jc_javax_crypto_spec_RC2ParameterSpec$object *r0;

	r0 = this;
	i0 = param0;
	_JC_LINE_NUMBER(77);				// 0
	_JC_PRIM_FIELD(env, r0, javax_crypto_spec_RC2ParameterSpec, effectiveKeyBits) = i0;
	_JC_LINE_NUMBER(78);				// 1
	return;
}

//
// public void <init>(int, byte[])
//

static _jc_linenum _jc_javax_crypto_spec_RC2ParameterSpec$linenum_table$_init$85a20918701c98c3[];

static const unsigned char _jc_javax_crypto_spec_RC2ParameterSpec$param_ptypes$_init$85a20918701c98c3[] = { 
_JC_TYPE_INT, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_spec_RC2ParameterSpec$param_types$_init$85a20918701c98c3[] = {
	&_jc_int$prim$type,
	&_jc_byte$array$prim$type
};

_jc_method _jc_javax_crypto_spec_RC2ParameterSpec$method_info$_init$85a20918701c98c3 = {
	.name=			"<init>",
	.signature=		"(I[B)V",
	.class=			&_jc_javax_crypto_spec_RC2ParameterSpec$type,
	.param_types=		&_jc_javax_crypto_spec_RC2ParameterSpec$param_types$_init$85a20918701c98c3,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_spec_RC2ParameterSpec$param_ptypes$_init$85a20918701c98c3,
	.signature_hash=	_JC_JLONG(0x85a20918701c98c3),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_javax_crypto_spec_RC2ParameterSpec$method$_init$85a20918701c98c3,
	.num_parameters=	2,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_javax_crypto_spec_RC2ParameterSpec$linenum_table$_init$85a20918701c98c3
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_spec_RC2ParameterSpec, _init$85a20918701c98c3);

void _JC_JCNI_ATTR
_jc_javax_crypto_spec_RC2ParameterSpec$method$_init$85a20918701c98c3(_jc_env *const env, _jc_javax_crypto_spec_RC2ParameterSpec$object *this, jint param0, _jc_byte_array *param1)
{
	jint i0;
	struct _jc_javax_crypto_spec_RC2ParameterSpec$object *r0;
	_jc_byte_array *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	i0 = param0;
	r1 = param1;
	_JC_LINE_NUMBER(89);				// 0
	_JC_INVOKE_NONVIRTUAL(env, javax_crypto_spec_RC2ParameterSpec, _init$c24aea43a39f620a, 0, r0, i0, r1, 0);
	_JC_LINE_NUMBER(90);				// 1
	return;
}

//
// public void <init>(int, byte[], int)
//

static _jc_linenum _jc_javax_crypto_spec_RC2ParameterSpec$linenum_table$_init$c24aea43a39f620a[];

static const unsigned char _jc_javax_crypto_spec_RC2ParameterSpec$param_ptypes$_init$c24aea43a39f620a[] = { 
_JC_TYPE_INT, _JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_crypto_spec_RC2ParameterSpec$param_types$_init$c24aea43a39f620a[] = {
	&_jc_int$prim$type,
	&_jc_byte$array$prim$type,
	&_jc_int$prim$type
};

_jc_method _jc_javax_crypto_spec_RC2ParameterSpec$method_info$_init$c24aea43a39f620a = {
	.name=			"<init>",
	.signature=		"(I[BI)V",
	.class=			&_jc_javax_crypto_spec_RC2ParameterSpec$type,
	.param_types=		&_jc_javax_crypto_spec_RC2ParameterSpec$param_types$_init$c24aea43a39f620a,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_crypto_spec_RC2ParameterSpec$param_ptypes$_init$c24aea43a39f620a,
	.signature_hash=	_JC_JLONG(0xc24aea43a39f620a),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_javax_crypto_spec_RC2ParameterSpec$method$_init$c24aea43a39f620a,
	.num_parameters=	3,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	6,
	      .table=	_jc_javax_crypto_spec_RC2ParameterSpec$linenum_table$_init$c24aea43a39f620a
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_spec_RC2ParameterSpec, _init$c24aea43a39f620a);

void _JC_JCNI_ATTR
_jc_javax_crypto_spec_RC2ParameterSpec$method$_init$c24aea43a39f620a(_jc_env *const env, _jc_javax_crypto_spec_RC2ParameterSpec$object *this, jint param0, _jc_byte_array *param1, jint param2)
{
	jint i0;
	jint i1;
	jint i2;
	struct _jc_javax_crypto_spec_RC2ParameterSpec$object *r0;
	_jc_byte_array *r1;
	struct _jc_java_lang_IllegalArgumentException$object *r2;
	_jc_byte_array *r3;
	struct _jc_java_lang_String$object *r4;
	struct _jc_java_lang_VMThrowable$object *r6;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	i0 = param0;
	r1 = param1;
	i1 = param2;
	_JC_LINE_NUMBER(102);				// 0
	i2 = _JC_ARRAY_LENGTH(env, r1);
	i2 = i2 - i1;
	if (i2 >= 8)
		goto label0;
	_JC_LINE_NUMBER(104);				// 1
	r2 = _JC_NEW(env, java_lang_IllegalArgumentException);
	r4 = _JC_STRING(env, "IV too short");
	_JC_REF_FIELD(env, r2, java_lang_Throwable, cause) = r2;
	r6 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r2);
	_JC_REF_FIELD(env, r2, java_lang_Throwable, vmState) = r6;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, detailMessage) = r4;
	_JC_THROW(env, r2);

label0:
	_JC_LINE_NUMBER(106);				// 2
	_JC_PRIM_FIELD(env, r0, javax_crypto_spec_RC2ParameterSpec, effectiveKeyBits) = i0;
	_JC_LINE_NUMBER(107);				// 3
	r3 = _JC_NEW_PRIM_ARRAY(env, byte, 1, 8);
	_JC_REF_FIELD(env, r0, javax_crypto_spec_RC2ParameterSpec, iv) = r3;
	_JC_LINE_NUMBER(108);				// 4
	r3 = _JC_REF_FIELD(env, r0, javax_crypto_spec_RC2ParameterSpec, iv);
	_JC_ACTIVE_USE(env, java_lang_System);
	_JC_INVOKE_STATIC(env, java_lang_VMSystem, arraycopy$4286a72d57744cd8, 0, r1, i1, r3, 0, 8);
	_JC_LINE_NUMBER(109);				// 5
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public boolean equals(java.lang.Object)
//

static _jc_linenum _jc_javax_crypto_spec_RC2ParameterSpec$linenum_table$equals$8a15e0625571c581[];

static const unsigned char _jc_javax_crypto_spec_RC2ParameterSpec$param_ptypes$equals$8a15e0625571c581[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_javax_crypto_spec_RC2ParameterSpec$param_types$equals$8a15e0625571c581[] = {
	&_jc_java_lang_Object$type
};

_jc_method _jc_javax_crypto_spec_RC2ParameterSpec$method_info$equals$8a15e0625571c581 = {
	.name=			"equals",
	.signature=		"(Ljava/lang/Object;)Z",
	.class=			&_jc_javax_crypto_spec_RC2ParameterSpec$type,
	.param_types=		&_jc_javax_crypto_spec_RC2ParameterSpec$param_types$equals$8a15e0625571c581,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_javax_crypto_spec_RC2ParameterSpec$param_ptypes$equals$8a15e0625571c581,
	.signature_hash=	_JC_JLONG(0x8a15e0625571c581),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_javax_crypto_spec_RC2ParameterSpec$method$equals$8a15e0625571c581,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_spec_RC2ParameterSpec$vtable, javax_crypto_spec_RC2ParameterSpec.equals$8a15e0625571c581) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	10,
	      .table=	_jc_javax_crypto_spec_RC2ParameterSpec$linenum_table$equals$8a15e0625571c581
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_spec_RC2ParameterSpec, equals$8a15e0625571c581);

jboolean _JC_JCNI_ATTR
_jc_javax_crypto_spec_RC2ParameterSpec$method$equals$8a15e0625571c581(_jc_env *const env, _jc_javax_crypto_spec_RC2ParameterSpec$object *this, _jc_java_lang_Object$object *param0)
{
	jbyte b3;
	jbyte b4;
	jint i0;
	jint i2;
	struct _jc_javax_crypto_spec_RC2ParameterSpec$object *r0;
	struct _jc_java_lang_Object$object *r1;
	_jc_byte_array *r2;
	struct _jc_javax_crypto_spec_RC2ParameterSpec$object *r3;
	_jc_byte_array *r4;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(137);				// 0
	if (r0 != r1)
		goto label0;
	return 1;

label0:
	_JC_LINE_NUMBER(138);				// 1
	r3 = _JC_CAST(env, &_jc_javax_crypto_spec_RC2ParameterSpec$type, r1);
	r2 = _JC_INVOKE_VIRTUAL(env, javax_crypto_spec_RC2ParameterSpec, getIV$4134a0c13b73072e, r3);
	_JC_LINE_NUMBER(139);				// 2
	r4 = _JC_REF_FIELD(env, r0, javax_crypto_spec_RC2ParameterSpec, iv);
	if (r4 == r2)
		goto label7;
	_JC_LINE_NUMBER(141);				// 3
	r4 = _JC_REF_FIELD(env, r0, javax_crypto_spec_RC2ParameterSpec, iv);
	if (r4 == _JC_NULL)
		goto label1;
	if (r2 != _JC_NULL)
		goto label2;

label1:
	return 0;

label2:
	_JC_LINE_NUMBER(142);				// 4
	r4 = _JC_REF_FIELD(env, r0, javax_crypto_spec_RC2ParameterSpec, iv);
	i0 = _JC_ARRAY_LENGTH(env, r4);
	i2 = _JC_ARRAY_LENGTH(env, r2);
	if (i0 == i2)
		goto label3;
	return 0;

label3:
	_JC_LINE_NUMBER(143);				// 5
	i0 = 0;
	goto label6;

label4:
	_JC_LINE_NUMBER(145);				// 6
	r4 = _JC_REF_FIELD(env, r0, javax_crypto_spec_RC2ParameterSpec, iv);
	b3 = _JC_PRIM_ELEMENT(env, byte, r4, i0, 0, 0);
	b4 = _JC_PRIM_ELEMENT(env, byte, r2, i0, 0, 1);
	if (b3 == b4)
		goto label5;
	_JC_LINE_NUMBER(147);				// 7
	return 0;

label5:
	_JC_LINE_NUMBER(143);				// 8
	i0 = i0 + 1;

label6:
	r4 = _JC_REF_FIELD(env, r0, javax_crypto_spec_RC2ParameterSpec, iv);
	i2 = _JC_ARRAY_LENGTH(env, r4);
	if (i0 < i2) {
		_JC_PERIODIC_CHECK(env);
		goto label4;
	}

label7:
	_JC_LINE_NUMBER(151);				// 9
	z0 = 0;
	i2 = _JC_PRIM_FIELD(env, r0, javax_crypto_spec_RC2ParameterSpec, effectiveKeyBits);
	r3 = r1;
	i0 = _JC_INVOKE_VIRTUAL(env, javax_crypto_spec_RC2ParameterSpec, getEffectiveKeyBits$56e1f090fd9daafa, r3);
	if (i2 != i0)
		goto label8;
	z0 = 1;

label8:
	return z0;
}

//
// public int getEffectiveKeyBits()
//

static _jc_linenum _jc_javax_crypto_spec_RC2ParameterSpec$linenum_table$getEffectiveKeyBits$56e1f090fd9daafa[];

static const unsigned char _jc_javax_crypto_spec_RC2ParameterSpec$param_ptypes$getEffectiveKeyBits$56e1f090fd9daafa[] = { 
_JC_TYPE_INT };

_jc_method _jc_javax_crypto_spec_RC2ParameterSpec$method_info$getEffectiveKeyBits$56e1f090fd9daafa = {
	.name=			"getEffectiveKeyBits",
	.signature=		"()I",
	.class=			&_jc_javax_crypto_spec_RC2ParameterSpec$type,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_javax_crypto_spec_RC2ParameterSpec$param_ptypes$getEffectiveKeyBits$56e1f090fd9daafa,
	.signature_hash=	_JC_JLONG(0x56e1f090fd9daafa),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_javax_crypto_spec_RC2ParameterSpec$method$getEffectiveKeyBits$56e1f090fd9daafa,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_spec_RC2ParameterSpec$vtable, javax_crypto_spec_RC2ParameterSpec.getEffectiveKeyBits$56e1f090fd9daafa) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_crypto_spec_RC2ParameterSpec$linenum_table$getEffectiveKeyBits$56e1f090fd9daafa
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_spec_RC2ParameterSpec, getEffectiveKeyBits$56e1f090fd9daafa);

jint _JC_JCNI_ATTR
_jc_javax_crypto_spec_RC2ParameterSpec$method$getEffectiveKeyBits$56e1f090fd9daafa(_jc_env *const env, _jc_javax_crypto_spec_RC2ParameterSpec$object *this)
{
	jint i0;
	struct _jc_javax_crypto_spec_RC2ParameterSpec$object *r0;

	r0 = this;
	_JC_LINE_NUMBER(121);				// 0
	i0 = _JC_PRIM_FIELD(env, r0, javax_crypto_spec_RC2ParameterSpec, effectiveKeyBits);
	return i0;
}

//
// public byte[] getIV()
//

static _jc_linenum _jc_javax_crypto_spec_RC2ParameterSpec$linenum_table$getIV$4134a0c13b73072e[];

static const unsigned char _jc_javax_crypto_spec_RC2ParameterSpec$param_ptypes$getIV$4134a0c13b73072e[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_javax_crypto_spec_RC2ParameterSpec$method_info$getIV$4134a0c13b73072e = {
	.name=			"getIV",
	.signature=		"()[B",
	.class=			&_jc_javax_crypto_spec_RC2ParameterSpec$type,
	.return_type=		&_jc_byte$array$prim$type,
	.param_ptypes=		&_jc_javax_crypto_spec_RC2ParameterSpec$param_ptypes$getIV$4134a0c13b73072e,
	.signature_hash=	_JC_JLONG(0x4134a0c13b73072e),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_javax_crypto_spec_RC2ParameterSpec$method$getIV$4134a0c13b73072e,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_spec_RC2ParameterSpec$vtable, javax_crypto_spec_RC2ParameterSpec.getIV$4134a0c13b73072e) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_crypto_spec_RC2ParameterSpec$linenum_table$getIV$4134a0c13b73072e
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_spec_RC2ParameterSpec, getIV$4134a0c13b73072e);

_jc_byte_array * _JC_JCNI_ATTR
_jc_javax_crypto_spec_RC2ParameterSpec$method$getIV$4134a0c13b73072e(_jc_env *const env, _jc_javax_crypto_spec_RC2ParameterSpec$object *this)
{
	struct _jc_javax_crypto_spec_RC2ParameterSpec$object *r0;
	_jc_byte_array *r1;

	r0 = this;
	_JC_LINE_NUMBER(132);				// 0
	r1 = _JC_REF_FIELD(env, r0, javax_crypto_spec_RC2ParameterSpec, iv);
	return r1;
}

//
// public int hashCode()
//

static _jc_linenum _jc_javax_crypto_spec_RC2ParameterSpec$linenum_table$hashCode$53152098849316df[];

static const unsigned char _jc_javax_crypto_spec_RC2ParameterSpec$param_ptypes$hashCode$53152098849316df[] = { 
_JC_TYPE_INT };

_jc_method _jc_javax_crypto_spec_RC2ParameterSpec$method_info$hashCode$53152098849316df = {
	.name=			"hashCode",
	.signature=		"()I",
	.class=			&_jc_javax_crypto_spec_RC2ParameterSpec$type,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_javax_crypto_spec_RC2ParameterSpec$param_ptypes$hashCode$53152098849316df,
	.signature_hash=	_JC_JLONG(0x53152098849316df),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_javax_crypto_spec_RC2ParameterSpec$method$hashCode$53152098849316df,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_crypto_spec_RC2ParameterSpec$vtable, javax_crypto_spec_RC2ParameterSpec.hashCode$53152098849316df) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	6,
	      .table=	_jc_javax_crypto_spec_RC2ParameterSpec$linenum_table$hashCode$53152098849316df
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_crypto_spec_RC2ParameterSpec, hashCode$53152098849316df);

jint _JC_JCNI_ATTR
_jc_javax_crypto_spec_RC2ParameterSpec$method$hashCode$53152098849316df(_jc_env *const env, _jc_javax_crypto_spec_RC2ParameterSpec$object *this)
{
	jbyte b2;
	jint i0;
	jint i1;
	struct _jc_javax_crypto_spec_RC2ParameterSpec$object *r0;
	_jc_byte_array *r1;

	r0 = this;
	_JC_LINE_NUMBER(156);				// 0
	i0 = _JC_PRIM_FIELD(env, r0, javax_crypto_spec_RC2ParameterSpec, effectiveKeyBits);
	_JC_LINE_NUMBER(157);				// 1
	r1 = _JC_REF_FIELD(env, r0, javax_crypto_spec_RC2ParameterSpec, iv);
	if (r1 == _JC_NULL)
		goto label2;
	_JC_LINE_NUMBER(159);				// 2
	i1 = 0;
	goto label1;

label0:
	_JC_LINE_NUMBER(161);				// 3
	r1 = _JC_REF_FIELD(env, r0, javax_crypto_spec_RC2ParameterSpec, iv);
	b2 = _JC_PRIM_ELEMENT(env, byte, r1, i1, 0, 0);
	i0 = i0 + b2;
	_JC_LINE_NUMBER(159);				// 4
	i1 = i1 + 1;

label1:
	if (i1 < 8) {
		_JC_PERIODIC_CHECK(env);
		goto label0;
	}

label2:
	_JC_LINE_NUMBER(164);				// 5
	return i0;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_javax_crypto_spec_RC2ParameterSpec$methods[] = {
	&_jc_javax_crypto_spec_RC2ParameterSpec$method_info$_init$7f1776288300b98d,
	&_jc_javax_crypto_spec_RC2ParameterSpec$method_info$_init$85a20918701c98c3,
	&_jc_javax_crypto_spec_RC2ParameterSpec$method_info$_init$c24aea43a39f620a,
	&_jc_javax_crypto_spec_RC2ParameterSpec$method_info$equals$8a15e0625571c581,
	&_jc_javax_crypto_spec_RC2ParameterSpec$method_info$getEffectiveKeyBits$56e1f090fd9daafa,
	&_jc_javax_crypto_spec_RC2ParameterSpec$method_info$getIV$4134a0c13b73072e,
	&_jc_javax_crypto_spec_RC2ParameterSpec$method_info$hashCode$53152098849316df
};

/************************************************************************
 *			  Class fields structure			*
 ************************************************************************/

_jc_javax_crypto_spec_RC2ParameterSpec$fields_struct _jc_javax_crypto_spec_RC2ParameterSpec$class_fields = { };

/************************************************************************
 *			      Interface list				*
 ************************************************************************/

// Directly implemented interfaces
static _jc_type *const _jc_javax_crypto_spec_RC2ParameterSpec$interfaces[] = {
	&_jc_java_security_spec_AlgorithmParameterSpec$type
};

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_javax_crypto_spec_RC2ParameterSpec$instanceof_hash_bucket_15[] = {
	&_jc_java_security_spec_AlgorithmParameterSpec$type,
	_JC_NULL
};
static _jc_type *const _jc_javax_crypto_spec_RC2ParameterSpec$instanceof_hash_bucket_64[] = {
	&_jc_javax_crypto_spec_RC2ParameterSpec$type,
	_JC_NULL
};
static _jc_type *const _jc_javax_crypto_spec_RC2ParameterSpec$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_javax_crypto_spec_RC2ParameterSpec$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[15]=	_jc_javax_crypto_spec_RC2ParameterSpec$instanceof_hash_bucket_15,
	[64]=	_jc_javax_crypto_spec_RC2ParameterSpec$instanceof_hash_bucket_64,
	[101]=	_jc_javax_crypto_spec_RC2ParameterSpec$instanceof_hash_bucket_101
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_javax_crypto_spec_RC2ParameterSpec$class_depends[] = {
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/IllegalArgumentException",	_JC_JLONG(0x680cf34d05feb5a1) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/RuntimeException",	_JC_JLONG(0x4f5534a987354d1d) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/System",	_JC_JLONG(0x53cc8e2333795f04) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMSystem",	_JC_JLONG(0x4d1cebae0bdda058) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/security/spec/AlgorithmParameterSpec",	_JC_JLONG(0xef2e5e8af121478f) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_javax_crypto_spec_RC2ParameterSpec$vtype _jc_javax_crypto_spec_RC2ParameterSpec$type = {
    .type= {
	.name=			"javax/crypto/spec/RC2ParameterSpec",
	.superclass=		&_jc_java_lang_Object$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.num_interfaces=sizeof(_jc_javax_crypto_spec_RC2ParameterSpec$interfaces) / sizeof(*_jc_javax_crypto_spec_RC2ParameterSpec$interfaces),
	.interfaces=		_jc_javax_crypto_spec_RC2ParameterSpec$interfaces,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		15,
		.hash=			_JC_JLONG(0x6ec0a11777fc9640),
		.source_file=		"RC2ParameterSpec.java",
		.instance_size=		sizeof(_jc_javax_crypto_spec_RC2ParameterSpec$refs) + sizeof(_jc_javax_crypto_spec_RC2ParameterSpec$object),
		.num_virtual_refs=	1,
		.num_fields=		sizeof(_jc_javax_crypto_spec_RC2ParameterSpec$fields) / sizeof(*_jc_javax_crypto_spec_RC2ParameterSpec$fields),
		.fields=		_jc_javax_crypto_spec_RC2ParameterSpec$fields,
		.num_methods=		sizeof(_jc_javax_crypto_spec_RC2ParameterSpec$methods) / sizeof(*_jc_javax_crypto_spec_RC2ParameterSpec$methods),
		.methods=		_jc_javax_crypto_spec_RC2ParameterSpec$methods,
		.instanceof_hash_table=	_jc_javax_crypto_spec_RC2ParameterSpec$instanceof_hash_table,
		.class_fields=		&_jc_javax_crypto_spec_RC2ParameterSpec$class_fields,
		.num_class_depends=		sizeof(_jc_javax_crypto_spec_RC2ParameterSpec$class_depends) / sizeof(*_jc_javax_crypto_spec_RC2ParameterSpec$class_depends),
		.class_depends=		_jc_javax_crypto_spec_RC2ParameterSpec$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=			// overridden
		&_jc_javax_crypto_spec_RC2ParameterSpec$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=			// overridden
		&_jc_javax_crypto_spec_RC2ParameterSpec$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.javax_crypto_spec_RC2ParameterSpec= {
	    .equals$8a15e0625571c581=
		&_jc_javax_crypto_spec_RC2ParameterSpec$method$equals$8a15e0625571c581,
	    .getEffectiveKeyBits$56e1f090fd9daafa=
		&_jc_javax_crypto_spec_RC2ParameterSpec$method$getEffectiveKeyBits$56e1f090fd9daafa,
	    .getIV$4134a0c13b73072e=
		&_jc_javax_crypto_spec_RC2ParameterSpec$method$getIV$4134a0c13b73072e,
	    .hashCode$53152098849316df=
		&_jc_javax_crypto_spec_RC2ParameterSpec$method$hashCode$53152098849316df,
	},
    }
};

