// public class javax.net.ssl.KeyManagerFactory

// class file dependencies
// @dep_class f4ba095546954b36 gnu_java_security_Engine
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class f02ab3ccb490a6d0 java_lang_ClassCastException
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class 680cf34d05feb5a1 java_lang_IllegalArgumentException
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class 4f5534a987354d1d java_lang_RuntimeException
// @dep_class 767fc1626c63609e java_lang_SecurityException
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class ae4a2342b31a268d java_lang_reflect_InvocationTargetException
// @dep_class 93cafe227fbda1e java_security_AccessController
// @dep_class 692089051f4c8d0b java_security_GeneralSecurityException
// @dep_class 327edce29f2562dd java_security_InvalidAlgorithmParameterException
// @dep_class 1f56d8b14978c9d6 java_security_KeyStore
// @dep_class 45b488528f32667c java_security_KeyStoreException
// @dep_class 22e937c2536160b4 java_security_NoSuchAlgorithmException
// @dep_class 8dfbf242adab91e java_security_NoSuchProviderException
// @dep_class 81b073051aa30acc java_security_Provider
// @dep_class 89bf77984bd9669e java_security_Security
// @dep_class 398237d93436ff7e java_security_UnrecoverableKeyException
// @dep_class a0b5b25c3d44fe32 java_security_VMAccessController
// @dep_class c53e1575b095109b java_util_Vector
// @dep_class ae254aeec477c06d javax_net_ssl_KeyManager
// @dep_class 46d5f8bd00c9233f javax_net_ssl_KeyManagerFactory
// @dep_class acd8756afabc6543 javax_net_ssl_KeyManagerFactory__241
// @dep_class 6b3456faafb71978 javax_net_ssl_KeyManagerFactorySpi
// @dep_class 59c25edc381e2cbe javax_net_ssl_ManagerFactoryParameters

// header file dependencies
// @dep_header gnu_java_security_Engine
// @dep_header java_lang_Class
// @dep_header java_lang_ClassCastException
// @dep_header java_lang_IllegalArgumentException
// @dep_header java_lang_SecurityException
// @dep_header java_lang_String
// @dep_header java_lang_VMThrowable
// @dep_header java_lang_reflect_InvocationTargetException
// @dep_header java_security_AccessController
// @dep_header java_security_InvalidAlgorithmParameterException
// @dep_header java_security_KeyStore
// @dep_header java_security_KeyStoreException
// @dep_header java_security_NoSuchAlgorithmException
// @dep_header java_security_NoSuchProviderException
// @dep_header java_security_Provider
// @dep_header java_security_Security
// @dep_header java_security_UnrecoverableKeyException
// @dep_header java_security_VMAccessController
// @dep_header java_util_Vector
// @dep_header javax_net_ssl_KeyManager
// @dep_header javax_net_ssl_KeyManagerFactory
// @dep_header javax_net_ssl_KeyManagerFactory__241
// @dep_header javax_net_ssl_KeyManagerFactorySpi
// @dep_header javax_net_ssl_ManagerFactoryParameters

#include "jc_defs.h"

#include "gnu/java/security/Engine.h"
#include "java/lang/Class.h"
#include "java/lang/ClassCastException.h"
#include "java/lang/IllegalArgumentException.h"
#include "java/lang/SecurityException.h"
#include "java/lang/String.h"
#include "java/lang/VMThrowable.h"
#include "java/lang/reflect/InvocationTargetException.h"
#include "java/security/AccessController.h"
#include "java/security/InvalidAlgorithmParameterException.h"
#include "java/security/KeyStore.h"
#include "java/security/KeyStoreException.h"
#include "java/security/NoSuchAlgorithmException.h"
#include "java/security/NoSuchProviderException.h"
#include "java/security/Provider.h"
#include "java/security/Security.h"
#include "java/security/UnrecoverableKeyException.h"
#include "java/security/VMAccessController.h"
#include "java/util/Vector.h"
#include "javax/net/ssl/KeyManager.h"
#include "javax/net/ssl/KeyManagerFactory.h"
#include "javax/net/ssl/KeyManagerFactory__241.h"
#include "javax/net/ssl/KeyManagerFactorySpi.h"
#include "javax/net/ssl/ManagerFactoryParameters.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// private static final java.lang.String KEY_MANAGER_FACTORY
static _jc_field _jc_javax_net_ssl_KeyManagerFactory$field_info$KEY__5fMANAGER__5fFACTORY = {
	.name=		"KEY_MANAGER_FACTORY",
	.signature=	"Ljava/lang/String;",
	.class=		&_jc_javax_net_ssl_KeyManagerFactory$type,
	.type=		&_jc_java_lang_String$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_javax_net_ssl_KeyManagerFactory$fields_struct, KEY__5fMANAGER__5fFACTORY),
	.initial_value=	"KeyManagerFactory",
};

// private static final java.lang.String DEFAULT_ALGORITHM
static _jc_field _jc_javax_net_ssl_KeyManagerFactory$field_info$DEFAULT__5fALGORITHM = {
	.name=		"DEFAULT_ALGORITHM",
	.signature=	"Ljava/lang/String;",
	.class=		&_jc_javax_net_ssl_KeyManagerFactory$type,
	.type=		&_jc_java_lang_String$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_javax_net_ssl_KeyManagerFactory$fields_struct, DEFAULT__5fALGORITHM),
	.initial_value=	"JessieX509",
};

// private final javax.net.ssl.KeyManagerFactorySpi kmfSpi
static _jc_field _jc_javax_net_ssl_KeyManagerFactory$field_info$kmfSpi = {
	.name=		"kmfSpi",
	.signature=	"Ljavax/net/ssl/KeyManagerFactorySpi;",
	.class=		&_jc_javax_net_ssl_KeyManagerFactory$type,
	.type=		&_jc_javax_net_ssl_KeyManagerFactorySpi$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_javax_net_ssl_KeyManagerFactory$object, refs[-1].javax_net_ssl_KeyManagerFactory.kmfSpi),
};

// private final java.security.Provider provider
static _jc_field _jc_javax_net_ssl_KeyManagerFactory$field_info$provider = {
	.name=		"provider",
	.signature=	"Ljava/security/Provider;",
	.class=		&_jc_javax_net_ssl_KeyManagerFactory$type,
	.type=		&_jc_java_security_Provider$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_javax_net_ssl_KeyManagerFactory$object, refs[-1].javax_net_ssl_KeyManagerFactory.provider),
};

// private final java.lang.String algorithm
static _jc_field _jc_javax_net_ssl_KeyManagerFactory$field_info$algorithm = {
	.name=		"algorithm",
	.signature=	"Ljava/lang/String;",
	.class=		&_jc_javax_net_ssl_KeyManagerFactory$type,
	.type=		&_jc_java_lang_String$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_javax_net_ssl_KeyManagerFactory$object, refs[-1].javax_net_ssl_KeyManagerFactory.algorithm),
};

// Fields
static _jc_field *const _jc_javax_net_ssl_KeyManagerFactory$fields[] = {
	&_jc_javax_net_ssl_KeyManagerFactory$field_info$DEFAULT__5fALGORITHM,
	&_jc_javax_net_ssl_KeyManagerFactory$field_info$KEY__5fMANAGER__5fFACTORY,
	&_jc_javax_net_ssl_KeyManagerFactory$field_info$algorithm,
	&_jc_javax_net_ssl_KeyManagerFactory$field_info$kmfSpi,
	&_jc_javax_net_ssl_KeyManagerFactory$field_info$provider
};

/************************************************************************
 *			      Static methods				*
 ************************************************************************/

//
// public static final java.lang.String getDefaultAlgorithm()
//

static _jc_linenum _jc_javax_net_ssl_KeyManagerFactory$linenum_table$getDefaultAlgorithm$2a434a91fa4a7731[];

static _jc_trap_info _jc_javax_net_ssl_KeyManagerFactory$trap_table$getDefaultAlgorithm$2a434a91fa4a7731[] = {
	_JC_TRAP(_JC_NULL, 4, 5),
	_JC_TRAP(_JC_NULL, 2, 3),
	_JC_TRAP(&_jc_java_lang_SecurityException$type, 1, 6),
};

static const unsigned char _jc_javax_net_ssl_KeyManagerFactory$param_ptypes$getDefaultAlgorithm$2a434a91fa4a7731[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_javax_net_ssl_KeyManagerFactory$method_info$getDefaultAlgorithm$2a434a91fa4a7731 = {
	.name=			"getDefaultAlgorithm",
	.signature=		"()Ljava/lang/String;",
	.class=			&_jc_javax_net_ssl_KeyManagerFactory$type,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_javax_net_ssl_KeyManagerFactory$param_ptypes$getDefaultAlgorithm$2a434a91fa4a7731,
	.signature_hash=	_JC_JLONG(0x2a434a91fa4a7731),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_net_ssl_KeyManagerFactory$method$getDefaultAlgorithm$2a434a91fa4a7731,
	.num_parameters=	0,
	.u= { .exec= {
	  .trap_table_len=	3,
	  .trap_table=		_jc_javax_net_ssl_KeyManagerFactory$trap_table$getDefaultAlgorithm$2a434a91fa4a7731,
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_javax_net_ssl_KeyManagerFactory$linenum_table$getDefaultAlgorithm$2a434a91fa4a7731
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_net_ssl_KeyManagerFactory, getDefaultAlgorithm$2a434a91fa4a7731);

_jc_java_lang_String$object * _JC_JCNI_ATTR
_jc_javax_net_ssl_KeyManagerFactory$method$getDefaultAlgorithm$2a434a91fa4a7731(_jc_env *const env)
{
	struct {
		struct _jc_javax_net_ssl_KeyManagerFactory__241$refs	refs;
		struct _jc_javax_net_ssl_KeyManagerFactory__241$object	obj;
	} mem0;
	struct _jc_java_lang_String$object *volatile r0;
	struct _jc_javax_net_ssl_KeyManagerFactory__241$object *r1;
	struct _jc_java_lang_SecurityException$object *r2;
	struct _jc_java_lang_Throwable$object *volatile r4;
	struct _jc_java_lang_String$object *r6;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_javax_net_ssl_KeyManagerFactory$method_info$getDefaultAlgorithm$2a434a91fa4a7731, &&label0, &&label0, &&label5);

	_JC_LINE_NUMBER(113);				// 0
	r0 = _JC_NULL;
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(116);				// 1
	r1 = _JC_STACK_NEW(env, &mem0, javax_net_ssl_KeyManagerFactory__241);
	_JC_ACTIVE_USE(env, java_security_AccessController);
	_JC_INVOKE_STATIC(env, java_security_VMAccessController, pushContext$a0b89666ea22e118, 0, _JC_NULL);
	_JC_TRAP_REGION(catch, 2);
	r6 = _JC_INVOKE_STATIC(env, java_security_Security, getProperty$17fb18205ea95f87, 0, _JC_STRING(env, "ssl.KeyManagerFactory.algorithm"));
	goto label2;

label0:
	_JC_TRAP_REGION(catch, 3);
	_JC_PERIODIC_CHECK(env);
	r4 = _JC_CAUGHT_EXCEPTION(env);
	_JC_TRAP_REGION(catch, 4);
	goto label3;

label1:
	_JC_THROW(env, r4);

label2:
	_JC_TRAP_REGION(catch, 5);
	_JC_INVOKE_STATIC(env, java_security_VMAccessController, popContext$22a28106f09f995b, 1);
	goto label4;

label3:
	_JC_TRAP_REGION(catch, 5);
	_JC_INVOKE_STATIC(env, java_security_VMAccessController, popContext$22a28106f09f995b, 0);
	_JC_PERIODIC_CHECK(env);
	goto label1;

label4:
	r0 = _JC_CAST_FINAL(env, &_jc_java_lang_String$type, r6);
	_JC_TRAP_REGION(catch, 6);
	goto label6;

label5:
	_JC_TRAP_REGION(catch, 6);
	r2 = _JC_CAUGHT_EXCEPTION(env);

label6:
	_JC_LINE_NUMBER(129);				// 2
	if (r0 != _JC_NULL)
		goto label7;
	_JC_LINE_NUMBER(130);				// 3
	r0 = _JC_STRING(env, "JessieX509");

label7:
	_JC_LINE_NUMBER(131);				// 4
	_JC_CANCEL_TRAPS(env, catch);
	return r0;
}

//
// public static final javax.net.ssl.KeyManagerFactory getInstance(java.lang.String) throws java.security.NoSuchAlgorithmException
//

static _jc_linenum _jc_javax_net_ssl_KeyManagerFactory$linenum_table$getInstance$6b074959d28041c0[];

static _jc_trap_info _jc_javax_net_ssl_KeyManagerFactory$trap_table$getInstance$6b074959d28041c0[] = {
	_JC_TRAP(&_jc_java_security_NoSuchAlgorithmException$type, 1, 2),
};

static const unsigned char _jc_javax_net_ssl_KeyManagerFactory$param_ptypes$getInstance$6b074959d28041c0[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_javax_net_ssl_KeyManagerFactory$exceptions$getInstance$6b074959d28041c0[] = {
	&_jc_java_security_NoSuchAlgorithmException$type
};

static _jc_type *const _jc_javax_net_ssl_KeyManagerFactory$param_types$getInstance$6b074959d28041c0[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_javax_net_ssl_KeyManagerFactory$method_info$getInstance$6b074959d28041c0 = {
	.name=			"getInstance",
	.signature=		"(Ljava/lang/String;)Ljavax/net/ssl/KeyManagerFactory;",
	.class=			&_jc_javax_net_ssl_KeyManagerFactory$type,
	.param_types=		&_jc_javax_net_ssl_KeyManagerFactory$param_types$getInstance$6b074959d28041c0,
	.return_type=		&_jc_javax_net_ssl_KeyManagerFactory$type,
	.param_ptypes=		&_jc_javax_net_ssl_KeyManagerFactory$param_ptypes$getInstance$6b074959d28041c0,
	.signature_hash=	_JC_JLONG(0x6b074959d28041c0),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_net_ssl_KeyManagerFactory$method$getInstance$6b074959d28041c0,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_net_ssl_KeyManagerFactory$exceptions$getInstance$6b074959d28041c0,
	.u= { .exec= {
	  .trap_table_len=	1,
	  .trap_table=		_jc_javax_net_ssl_KeyManagerFactory$trap_table$getInstance$6b074959d28041c0,
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_javax_net_ssl_KeyManagerFactory$linenum_table$getInstance$6b074959d28041c0
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_net_ssl_KeyManagerFactory, getInstance$6b074959d28041c0);

_jc_javax_net_ssl_KeyManagerFactory$object * _JC_JCNI_ATTR
_jc_javax_net_ssl_KeyManagerFactory$method$getInstance$6b074959d28041c0(_jc_env *const env, _jc_java_lang_String$object *param0)
{
	jint volatile i0;
	jint volatile i1;
	jint i2;
	struct _jc_java_lang_String$object *volatile r0;
	struct _jc_java_security_Provider$object *volatile r2;
	struct _jc_javax_net_ssl_KeyManagerFactory$object *volatile r3;
	struct _jc_java_security_NoSuchAlgorithmException$object *volatile r4;
	struct _jc_java_lang_VMThrowable$object *volatile r5;
	struct _jc_java_util_Vector$object *r6;
	_jc_object_array *volatile r7;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_javax_net_ssl_KeyManagerFactory$method_info$getInstance$6b074959d28041c0, &&label1);

	r0 = param0;
	_JC_ACTIVE_USE(env, java_security_Security);
	_JC_LINE_NUMBER(146);				// 0
	r6 = _JC_STATIC_FIELD(env, java_security_Security, providers, 1);
	i2 = _JC_INVOKE_VIRTUAL(env, java_util_Vector, size$345df5220fc60ade, r6);
	r7 = _JC_NEW_REF_ARRAY(env, java_security_Provider, 1, i2);
	r6 = _JC_STATIC_FIELD(env, java_security_Security, providers, 1);
	_JC_INVOKE_VIRTUAL(env, java_util_Vector, copyInto$cd78d768b3ba4735, r6, r7);
	_JC_LINE_NUMBER(147);				// 1
	i0 = 0;
	goto label2;

label0:
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(151);				// 2
	r2 = _JC_REF_ELEMENT(env, r7, i0, 1, 1);
	r3 = _JC_INVOKE_STATIC(env, javax_net_ssl_KeyManagerFactory, getInstance$ea07f0aebf066ff5, 0, r0, r2);
	_JC_TRAP_REGION(catch, 2);
	_JC_CANCEL_TRAPS(env, catch);
	return r3;

label1:
	_JC_TRAP_REGION(catch, 2);
	r4 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(147);				// 3
	i0 = i0 + 1;

label2:
	_JC_TRAP_REGION(catch, 2);
	i1 = _JC_ARRAY_LENGTH(env, r7);
	if (i0 < i1) {
		_JC_PERIODIC_CHECK(env);
		goto label0;
	}
	_JC_LINE_NUMBER(157);				// 4
	r4 = _JC_NEW(env, java_security_NoSuchAlgorithmException);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r5 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r5;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r0;
	_JC_THROW(env, r4);
}

//
// public static final javax.net.ssl.KeyManagerFactory getInstance(java.lang.String, java.lang.String) throws java.security.NoSuchAlgorithmException, java.security.NoSuchProviderException
//

static _jc_linenum _jc_javax_net_ssl_KeyManagerFactory$linenum_table$getInstance$eebbd21c476e398f[];

static const unsigned char _jc_javax_net_ssl_KeyManagerFactory$param_ptypes$getInstance$eebbd21c476e398f[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_javax_net_ssl_KeyManagerFactory$exceptions$getInstance$eebbd21c476e398f[] = {
	&_jc_java_security_NoSuchAlgorithmException$type,
	&_jc_java_security_NoSuchProviderException$type
};

static _jc_type *const _jc_javax_net_ssl_KeyManagerFactory$param_types$getInstance$eebbd21c476e398f[] = {
	&_jc_java_lang_String$type,
	&_jc_java_lang_String$type
};

_jc_method _jc_javax_net_ssl_KeyManagerFactory$method_info$getInstance$eebbd21c476e398f = {
	.name=			"getInstance",
	.signature=		"(Ljava/lang/String;Ljava/lang/String;)Ljavax/net/ssl/KeyManagerFactory;",
	.class=			&_jc_javax_net_ssl_KeyManagerFactory$type,
	.param_types=		&_jc_javax_net_ssl_KeyManagerFactory$param_types$getInstance$eebbd21c476e398f,
	.return_type=		&_jc_javax_net_ssl_KeyManagerFactory$type,
	.param_ptypes=		&_jc_javax_net_ssl_KeyManagerFactory$param_ptypes$getInstance$eebbd21c476e398f,
	.signature_hash=	_JC_JLONG(0xeebbd21c476e398f),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_net_ssl_KeyManagerFactory$method$getInstance$eebbd21c476e398f,
	.num_parameters=	2,
	.num_exceptions=	2,
	.exceptions=		&_jc_javax_net_ssl_KeyManagerFactory$exceptions$getInstance$eebbd21c476e398f,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	6,
	      .table=	_jc_javax_net_ssl_KeyManagerFactory$linenum_table$getInstance$eebbd21c476e398f
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_net_ssl_KeyManagerFactory, getInstance$eebbd21c476e398f);

_jc_javax_net_ssl_KeyManagerFactory$object * _JC_JCNI_ATTR
_jc_javax_net_ssl_KeyManagerFactory$method$getInstance$eebbd21c476e398f(_jc_env *const env, _jc_java_lang_String$object *param0, _jc_java_lang_String$object *param1)
{
	struct _jc_java_lang_String$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_java_security_Provider$object *r2;
	struct _jc_java_lang_IllegalArgumentException$object *r3;
	struct _jc_java_security_NoSuchProviderException$object *r4;
	struct _jc_javax_net_ssl_KeyManagerFactory$object *r5;
	struct _jc_java_lang_String$object *r6;
	struct _jc_java_lang_VMThrowable$object *r7;
	struct _jc_java_lang_VMThrowable$object *r9;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = param0;
	r1 = param1;
	_JC_LINE_NUMBER(176);				// 0
	if (r1 != _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(177);				// 1
	r3 = _JC_NEW(env, java_lang_IllegalArgumentException);
	r6 = _JC_STRING(env, "provider is null");
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r7 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r7;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r6;
	_JC_THROW(env, r3);

label0:
	_JC_LINE_NUMBER(178);				// 2
	r2 = _JC_INVOKE_STATIC(env, java_security_Security, getProvider$581ee7d7bc9ae747, 0, r1);
	_JC_LINE_NUMBER(179);				// 3
	if (r2 != _JC_NULL)
		goto label1;
	_JC_LINE_NUMBER(180);				// 4
	r4 = _JC_NEW(env, java_security_NoSuchProviderException);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r9 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r9;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r1;
	_JC_THROW(env, r4);

label1:
	_JC_LINE_NUMBER(181);				// 5
	r5 = _JC_INVOKE_STATIC(env, javax_net_ssl_KeyManagerFactory, getInstance$ea07f0aebf066ff5, 1, r0, r2);
	return r5;
}

//
// public static final javax.net.ssl.KeyManagerFactory getInstance(java.lang.String, java.security.Provider) throws java.security.NoSuchAlgorithmException
//

static _jc_linenum _jc_javax_net_ssl_KeyManagerFactory$linenum_table$getInstance$ea07f0aebf066ff5[];

static _jc_trap_info _jc_javax_net_ssl_KeyManagerFactory$trap_table$getInstance$ea07f0aebf066ff5[] = {
	_JC_TRAP(&_jc_java_lang_reflect_InvocationTargetException$type, 1, 2),
	_JC_TRAP(&_jc_java_lang_ClassCastException$type, 1, 2),
};

static const unsigned char _jc_javax_net_ssl_KeyManagerFactory$param_ptypes$getInstance$ea07f0aebf066ff5[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_javax_net_ssl_KeyManagerFactory$exceptions$getInstance$ea07f0aebf066ff5[] = {
	&_jc_java_security_NoSuchAlgorithmException$type
};

static _jc_type *const _jc_javax_net_ssl_KeyManagerFactory$param_types$getInstance$ea07f0aebf066ff5[] = {
	&_jc_java_lang_String$type,
	&_jc_java_security_Provider$type
};

_jc_method _jc_javax_net_ssl_KeyManagerFactory$method_info$getInstance$ea07f0aebf066ff5 = {
	.name=			"getInstance",
	.signature=		"(Ljava/lang/String;Ljava/security/Provider;)Ljavax/net/ssl/KeyManagerFactory;",
	.class=			&_jc_javax_net_ssl_KeyManagerFactory$type,
	.param_types=		&_jc_javax_net_ssl_KeyManagerFactory$param_types$getInstance$ea07f0aebf066ff5,
	.return_type=		&_jc_javax_net_ssl_KeyManagerFactory$type,
	.param_ptypes=		&_jc_javax_net_ssl_KeyManagerFactory$param_ptypes$getInstance$ea07f0aebf066ff5,
	.signature_hash=	_JC_JLONG(0xea07f0aebf066ff5),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_net_ssl_KeyManagerFactory$method$getInstance$ea07f0aebf066ff5,
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_net_ssl_KeyManagerFactory$exceptions$getInstance$ea07f0aebf066ff5,
	.u= { .exec= {
	  .trap_table_len=	2,
	  .trap_table=		_jc_javax_net_ssl_KeyManagerFactory$trap_table$getInstance$ea07f0aebf066ff5,
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_javax_net_ssl_KeyManagerFactory$linenum_table$getInstance$ea07f0aebf066ff5
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_net_ssl_KeyManagerFactory, getInstance$ea07f0aebf066ff5);

_jc_javax_net_ssl_KeyManagerFactory$object * _JC_JCNI_ATTR
_jc_javax_net_ssl_KeyManagerFactory$method$getInstance$ea07f0aebf066ff5(_jc_env *const env, _jc_java_lang_String$object *param0, _jc_java_security_Provider$object *param1)
{
	struct _jc_java_lang_String$object *volatile r0;
	struct _jc_java_security_Provider$object *r1;
	_jc_object_array *r10;
	struct _jc_java_lang_Object$object *r11;
	struct _jc_java_lang_VMThrowable$object *r12;
	struct _jc_java_lang_VMThrowable$object *volatile r13;
	struct _jc_java_lang_VMThrowable$object *volatile r15;
	struct _jc_java_lang_reflect_InvocationTargetException$object *r2;
	struct _jc_java_lang_IllegalArgumentException$object *r3;
	struct _jc_javax_net_ssl_KeyManagerFactory$object *r4;
	struct _jc_javax_net_ssl_KeyManagerFactorySpi$object *r5;
	struct _jc_java_security_NoSuchAlgorithmException$object *volatile r6;
	struct _jc_java_lang_ClassCastException$object *r7;
	struct _jc_java_lang_String$object *r8;
	struct _jc_java_lang_String$object *r9;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_javax_net_ssl_KeyManagerFactory$method_info$getInstance$ea07f0aebf066ff5, &&label1, &&label2);

	r0 = param0;
	r1 = param1;
	_JC_LINE_NUMBER(198);				// 0
	if (r1 != _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(199);				// 1
	r3 = _JC_NEW(env, java_lang_IllegalArgumentException);
	r8 = _JC_STRING(env, "provider is null");
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r12 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r12;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r8;
	_JC_THROW(env, r3);

label0:
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(202);				// 2
	r4 = _JC_NEW(env, javax_net_ssl_KeyManagerFactory);
	_JC_ACTIVE_USE(env, gnu_java_security_Engine);
	r9 = _JC_STRING(env, "KeyManagerFactory");
	r10 = _JC_STATIC_FIELD(env, gnu_java_security_Engine, NO__5fARGS, 1);
	r11 = _JC_INVOKE_STATIC(env, gnu_java_security_Engine, getInstance$ec89dfd35c234c64, 1, r9, r0, r1, r10);
	r5 = _JC_CAST(env, &_jc_javax_net_ssl_KeyManagerFactorySpi$type, r11);
	_JC_REF_FIELD(env, r4, javax_net_ssl_KeyManagerFactory, kmfSpi) = r5;
	_JC_REF_FIELD(env, r4, javax_net_ssl_KeyManagerFactory, provider) = r1;
	_JC_REF_FIELD(env, r4, javax_net_ssl_KeyManagerFactory, algorithm) = r0;
	_JC_TRAP_REGION(catch, 2);
	_JC_CANCEL_TRAPS(env, catch);
	return r4;

label1:
	_JC_TRAP_REGION(catch, 2);
	r2 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(208);				// 3
	r6 = _JC_NEW(env, java_security_NoSuchAlgorithmException);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, cause) = r6;
	r13 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r6);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, vmState) = r13;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, detailMessage) = r0;
	_JC_THROW(env, r6);

label2:
	_JC_TRAP_REGION(catch, 2);
	r7 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(212);				// 4
	r6 = _JC_NEW(env, java_security_NoSuchAlgorithmException);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, cause) = r6;
	r15 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r6);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, vmState) = r15;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, detailMessage) = r0;
	_JC_THROW(env, r6);
}

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// protected void <init>(javax.net.ssl.KeyManagerFactorySpi, java.security.Provider, java.lang.String)
//

static _jc_linenum _jc_javax_net_ssl_KeyManagerFactory$linenum_table$_init$6f08fd15d8727000[];

static const unsigned char _jc_javax_net_ssl_KeyManagerFactory$param_ptypes$_init$6f08fd15d8727000[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_net_ssl_KeyManagerFactory$param_types$_init$6f08fd15d8727000[] = {
	&_jc_javax_net_ssl_KeyManagerFactorySpi$type,
	&_jc_java_security_Provider$type,
	&_jc_java_lang_String$type
};

_jc_method _jc_javax_net_ssl_KeyManagerFactory$method_info$_init$6f08fd15d8727000 = {
	.name=			"<init>",
	.signature=		"(Ljavax/net/ssl/KeyManagerFactorySpi;Ljava/security/Provider;Ljava/lang/String;)V",
	.class=			&_jc_javax_net_ssl_KeyManagerFactory$type,
	.param_types=		&_jc_javax_net_ssl_KeyManagerFactory$param_types$_init$6f08fd15d8727000,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_net_ssl_KeyManagerFactory$param_ptypes$_init$6f08fd15d8727000,
	.signature_hash=	_JC_JLONG(0x6f08fd15d8727000),
	.access_flags=		_JC_ACC_PROTECTED,
	.function=		&_jc_javax_net_ssl_KeyManagerFactory$method$_init$6f08fd15d8727000,
	.num_parameters=	3,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_javax_net_ssl_KeyManagerFactory$linenum_table$_init$6f08fd15d8727000
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_net_ssl_KeyManagerFactory, _init$6f08fd15d8727000);

void _JC_JCNI_ATTR
_jc_javax_net_ssl_KeyManagerFactory$method$_init$6f08fd15d8727000(_jc_env *const env, _jc_javax_net_ssl_KeyManagerFactory$object *this, _jc_javax_net_ssl_KeyManagerFactorySpi$object *param0, _jc_java_security_Provider$object *param1, _jc_java_lang_String$object *param2)
{
	struct _jc_javax_net_ssl_KeyManagerFactory$object *r0;
	struct _jc_javax_net_ssl_KeyManagerFactorySpi$object *r1;
	struct _jc_java_security_Provider$object *r2;
	struct _jc_java_lang_String$object *r3;

	r0 = this;
	r1 = param0;
	r2 = param1;
	r3 = param2;
	_JC_LINE_NUMBER(95);				// 0
	_JC_REF_FIELD(env, r0, javax_net_ssl_KeyManagerFactory, kmfSpi) = r1;
	_JC_LINE_NUMBER(96);				// 1
	_JC_REF_FIELD(env, r0, javax_net_ssl_KeyManagerFactory, provider) = r2;
	_JC_LINE_NUMBER(97);				// 2
	_JC_REF_FIELD(env, r0, javax_net_ssl_KeyManagerFactory, algorithm) = r3;
	_JC_LINE_NUMBER(98);				// 3
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public final java.lang.String getAlgorithm()
//

static _jc_linenum _jc_javax_net_ssl_KeyManagerFactory$linenum_table$getAlgorithm$19abbbc132b9063a[];

static const unsigned char _jc_javax_net_ssl_KeyManagerFactory$param_ptypes$getAlgorithm$19abbbc132b9063a[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_javax_net_ssl_KeyManagerFactory$method_info$getAlgorithm$19abbbc132b9063a = {
	.name=			"getAlgorithm",
	.signature=		"()Ljava/lang/String;",
	.class=			&_jc_javax_net_ssl_KeyManagerFactory$type,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_javax_net_ssl_KeyManagerFactory$param_ptypes$getAlgorithm$19abbbc132b9063a,
	.signature_hash=	_JC_JLONG(0x19abbbc132b9063a),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_net_ssl_KeyManagerFactory$method$getAlgorithm$19abbbc132b9063a,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_net_ssl_KeyManagerFactory$vtable, javax_net_ssl_KeyManagerFactory.getAlgorithm$19abbbc132b9063a) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_net_ssl_KeyManagerFactory$linenum_table$getAlgorithm$19abbbc132b9063a
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_net_ssl_KeyManagerFactory, getAlgorithm$19abbbc132b9063a);

_jc_java_lang_String$object * _JC_JCNI_ATTR
_jc_javax_net_ssl_KeyManagerFactory$method$getAlgorithm$19abbbc132b9063a(_jc_env *const env, _jc_javax_net_ssl_KeyManagerFactory$object *this)
{
	struct _jc_javax_net_ssl_KeyManagerFactory$object *r0;
	struct _jc_java_lang_String$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(226);				// 0
	r1 = _JC_REF_FIELD(env, r0, javax_net_ssl_KeyManagerFactory, algorithm);
	return r1;
}

//
// public final javax.net.ssl.KeyManager[] getKeyManagers()
//

static _jc_linenum _jc_javax_net_ssl_KeyManagerFactory$linenum_table$getKeyManagers$4d127bd6eaa54b43[];

static const unsigned char _jc_javax_net_ssl_KeyManagerFactory$param_ptypes$getKeyManagers$4d127bd6eaa54b43[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_javax_net_ssl_KeyManagerFactory$method_info$getKeyManagers$4d127bd6eaa54b43 = {
	.name=			"getKeyManagers",
	.signature=		"()[Ljavax/net/ssl/KeyManager;",
	.class=			&_jc_javax_net_ssl_KeyManagerFactory$type,
	.return_type=		&_jc_javax_net_ssl_KeyManager$array$type,
	.param_ptypes=		&_jc_javax_net_ssl_KeyManagerFactory$param_ptypes$getKeyManagers$4d127bd6eaa54b43,
	.signature_hash=	_JC_JLONG(0x4d127bd6eaa54b43),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_net_ssl_KeyManagerFactory$method$getKeyManagers$4d127bd6eaa54b43,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_net_ssl_KeyManagerFactory$vtable, javax_net_ssl_KeyManagerFactory.getKeyManagers$4d127bd6eaa54b43) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_net_ssl_KeyManagerFactory$linenum_table$getKeyManagers$4d127bd6eaa54b43
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_net_ssl_KeyManagerFactory, getKeyManagers$4d127bd6eaa54b43);

_jc_object_array * _JC_JCNI_ATTR
_jc_javax_net_ssl_KeyManagerFactory$method$getKeyManagers$4d127bd6eaa54b43(_jc_env *const env, _jc_javax_net_ssl_KeyManagerFactory$object *this)
{
	struct _jc_javax_net_ssl_KeyManagerFactory$object *r0;
	struct _jc_javax_net_ssl_KeyManagerFactorySpi$object *r1;
	_jc_object_array *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(237);				// 0
	r1 = _JC_REF_FIELD(env, r0, javax_net_ssl_KeyManagerFactory, kmfSpi);
	r2 = _JC_INVOKE_VIRTUAL(env, javax_net_ssl_KeyManagerFactorySpi, engineGetKeyManagers$645758138549fcb4, r1);
	return r2;
}

//
// public final java.security.Provider getProvider()
//

static _jc_linenum _jc_javax_net_ssl_KeyManagerFactory$linenum_table$getProvider$e8f9c9fb14140d5a[];

static const unsigned char _jc_javax_net_ssl_KeyManagerFactory$param_ptypes$getProvider$e8f9c9fb14140d5a[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_javax_net_ssl_KeyManagerFactory$method_info$getProvider$e8f9c9fb14140d5a = {
	.name=			"getProvider",
	.signature=		"()Ljava/security/Provider;",
	.class=			&_jc_javax_net_ssl_KeyManagerFactory$type,
	.return_type=		&_jc_java_security_Provider$type,
	.param_ptypes=		&_jc_javax_net_ssl_KeyManagerFactory$param_ptypes$getProvider$e8f9c9fb14140d5a,
	.signature_hash=	_JC_JLONG(0xe8f9c9fb14140d5a),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_net_ssl_KeyManagerFactory$method$getProvider$e8f9c9fb14140d5a,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_net_ssl_KeyManagerFactory$vtable, javax_net_ssl_KeyManagerFactory.getProvider$e8f9c9fb14140d5a) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_net_ssl_KeyManagerFactory$linenum_table$getProvider$e8f9c9fb14140d5a
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_net_ssl_KeyManagerFactory, getProvider$e8f9c9fb14140d5a);

_jc_java_security_Provider$object * _JC_JCNI_ATTR
_jc_javax_net_ssl_KeyManagerFactory$method$getProvider$e8f9c9fb14140d5a(_jc_env *const env, _jc_javax_net_ssl_KeyManagerFactory$object *this)
{
	struct _jc_javax_net_ssl_KeyManagerFactory$object *r0;
	struct _jc_java_security_Provider$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(247);				// 0
	r1 = _JC_REF_FIELD(env, r0, javax_net_ssl_KeyManagerFactory, provider);
	return r1;
}

//
// public final void init(java.security.KeyStore, char[]) throws java.security.KeyStoreException, java.security.NoSuchAlgorithmException, java.security.UnrecoverableKeyException
//

static _jc_linenum _jc_javax_net_ssl_KeyManagerFactory$linenum_table$init$bed1e62c89299809[];

static const unsigned char _jc_javax_net_ssl_KeyManagerFactory$param_ptypes$init$bed1e62c89299809[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_net_ssl_KeyManagerFactory$exceptions$init$bed1e62c89299809[] = {
	&_jc_java_security_KeyStoreException$type,
	&_jc_java_security_NoSuchAlgorithmException$type,
	&_jc_java_security_UnrecoverableKeyException$type
};

static _jc_type *const _jc_javax_net_ssl_KeyManagerFactory$param_types$init$bed1e62c89299809[] = {
	&_jc_java_security_KeyStore$type,
	&_jc_char$array$prim$type
};

_jc_method _jc_javax_net_ssl_KeyManagerFactory$method_info$init$bed1e62c89299809 = {
	.name=			"init",
	.signature=		"(Ljava/security/KeyStore;[C)V",
	.class=			&_jc_javax_net_ssl_KeyManagerFactory$type,
	.param_types=		&_jc_javax_net_ssl_KeyManagerFactory$param_types$init$bed1e62c89299809,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_net_ssl_KeyManagerFactory$param_ptypes$init$bed1e62c89299809,
	.signature_hash=	_JC_JLONG(0xbed1e62c89299809),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_net_ssl_KeyManagerFactory$method$init$bed1e62c89299809,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_net_ssl_KeyManagerFactory$vtable, javax_net_ssl_KeyManagerFactory.init$bed1e62c89299809) / sizeof(void *),
	.num_parameters=	2,
	.num_exceptions=	3,
	.exceptions=		&_jc_javax_net_ssl_KeyManagerFactory$exceptions$init$bed1e62c89299809,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_javax_net_ssl_KeyManagerFactory$linenum_table$init$bed1e62c89299809
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_net_ssl_KeyManagerFactory, init$bed1e62c89299809);

void _JC_JCNI_ATTR
_jc_javax_net_ssl_KeyManagerFactory$method$init$bed1e62c89299809(_jc_env *const env, _jc_javax_net_ssl_KeyManagerFactory$object *this, _jc_java_security_KeyStore$object *param0, _jc_char_array *param1)
{
	struct _jc_javax_net_ssl_KeyManagerFactory$object *r0;
	struct _jc_java_security_KeyStore$object *r1;
	_jc_char_array *r2;
	struct _jc_javax_net_ssl_KeyManagerFactorySpi$object *r3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_LINE_NUMBER(278);				// 0
	r3 = _JC_REF_FIELD(env, r0, javax_net_ssl_KeyManagerFactory, kmfSpi);
	_JC_INVOKE_VIRTUAL(env, javax_net_ssl_KeyManagerFactorySpi, engineInit$c2175b213ac485fe, r3, r1, r2);
	_JC_LINE_NUMBER(279);				// 1
	return;
}

//
// public final void init(javax.net.ssl.ManagerFactoryParameters) throws java.security.InvalidAlgorithmParameterException
//

static _jc_linenum _jc_javax_net_ssl_KeyManagerFactory$linenum_table$init$2cb4129406ef255f[];

static const unsigned char _jc_javax_net_ssl_KeyManagerFactory$param_ptypes$init$2cb4129406ef255f[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_net_ssl_KeyManagerFactory$exceptions$init$2cb4129406ef255f[] = {
	&_jc_java_security_InvalidAlgorithmParameterException$type
};

static _jc_type *const _jc_javax_net_ssl_KeyManagerFactory$param_types$init$2cb4129406ef255f[] = {
	&_jc_javax_net_ssl_ManagerFactoryParameters$type
};

_jc_method _jc_javax_net_ssl_KeyManagerFactory$method_info$init$2cb4129406ef255f = {
	.name=			"init",
	.signature=		"(Ljavax/net/ssl/ManagerFactoryParameters;)V",
	.class=			&_jc_javax_net_ssl_KeyManagerFactory$type,
	.param_types=		&_jc_javax_net_ssl_KeyManagerFactory$param_types$init$2cb4129406ef255f,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_net_ssl_KeyManagerFactory$param_ptypes$init$2cb4129406ef255f,
	.signature_hash=	_JC_JLONG(0x2cb4129406ef255f),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_net_ssl_KeyManagerFactory$method$init$2cb4129406ef255f,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_net_ssl_KeyManagerFactory$vtable, javax_net_ssl_KeyManagerFactory.init$2cb4129406ef255f) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_net_ssl_KeyManagerFactory$exceptions$init$2cb4129406ef255f,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_javax_net_ssl_KeyManagerFactory$linenum_table$init$2cb4129406ef255f
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_net_ssl_KeyManagerFactory, init$2cb4129406ef255f);

void _JC_JCNI_ATTR
_jc_javax_net_ssl_KeyManagerFactory$method$init$2cb4129406ef255f(_jc_env *const env, _jc_javax_net_ssl_KeyManagerFactory$object *this, _jc_object *param0)
{
	struct _jc_javax_net_ssl_KeyManagerFactory$object *r0;
	struct _jc_object *r1;
	struct _jc_javax_net_ssl_KeyManagerFactorySpi$object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(261);				// 0
	r2 = _JC_REF_FIELD(env, r0, javax_net_ssl_KeyManagerFactory, kmfSpi);
	_JC_INVOKE_VIRTUAL(env, javax_net_ssl_KeyManagerFactorySpi, engineInit$7d0f73d1c75dca0e, r2, r1);
	_JC_LINE_NUMBER(262);				// 1
	return;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_javax_net_ssl_KeyManagerFactory$methods[] = {
	&_jc_javax_net_ssl_KeyManagerFactory$method_info$_init$6f08fd15d8727000,
	&_jc_javax_net_ssl_KeyManagerFactory$method_info$getAlgorithm$19abbbc132b9063a,
	&_jc_javax_net_ssl_KeyManagerFactory$method_info$getDefaultAlgorithm$2a434a91fa4a7731,
	&_jc_javax_net_ssl_KeyManagerFactory$method_info$getInstance$6b074959d28041c0,
	&_jc_javax_net_ssl_KeyManagerFactory$method_info$getInstance$eebbd21c476e398f,
	&_jc_javax_net_ssl_KeyManagerFactory$method_info$getInstance$ea07f0aebf066ff5,
	&_jc_javax_net_ssl_KeyManagerFactory$method_info$getKeyManagers$4d127bd6eaa54b43,
	&_jc_javax_net_ssl_KeyManagerFactory$method_info$getProvider$e8f9c9fb14140d5a,
	&_jc_javax_net_ssl_KeyManagerFactory$method_info$init$bed1e62c89299809,
	&_jc_javax_net_ssl_KeyManagerFactory$method_info$init$2cb4129406ef255f
};

/************************************************************************
 *			  Class fields structure			*
 ************************************************************************/

_jc_javax_net_ssl_KeyManagerFactory$fields_struct _jc_javax_net_ssl_KeyManagerFactory$class_fields = { };

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_javax_net_ssl_KeyManagerFactory$instanceof_hash_bucket_63[] = {
	&_jc_javax_net_ssl_KeyManagerFactory$type,
	_JC_NULL
};
static _jc_type *const _jc_javax_net_ssl_KeyManagerFactory$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_javax_net_ssl_KeyManagerFactory$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[63]=	_jc_javax_net_ssl_KeyManagerFactory$instanceof_hash_bucket_63,
	[101]=	_jc_javax_net_ssl_KeyManagerFactory$instanceof_hash_bucket_101
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_javax_net_ssl_KeyManagerFactory$class_depends[] = {
	{ "gnu/java/security/Engine",	_JC_JLONG(0xf4ba095546954b36) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/ClassCastException",	_JC_JLONG(0xf02ab3ccb490a6d0) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/IllegalArgumentException",	_JC_JLONG(0x680cf34d05feb5a1) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/RuntimeException",	_JC_JLONG(0x4f5534a987354d1d) },
	{ "java/lang/SecurityException",	_JC_JLONG(0x767fc1626c63609e) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/lang/reflect/InvocationTargetException",	_JC_JLONG(0xae4a2342b31a268d) },
	{ "java/security/AccessController",	_JC_JLONG(0x93cafe227fbda1e) },
	{ "java/security/GeneralSecurityException",	_JC_JLONG(0x692089051f4c8d0b) },
	{ "java/security/InvalidAlgorithmParameterException",	_JC_JLONG(0x327edce29f2562dd) },
	{ "java/security/KeyStore",	_JC_JLONG(0x1f56d8b14978c9d6) },
	{ "java/security/KeyStoreException",	_JC_JLONG(0x45b488528f32667c) },
	{ "java/security/NoSuchAlgorithmException",	_JC_JLONG(0x22e937c2536160b4) },
	{ "java/security/NoSuchProviderException",	_JC_JLONG(0x8dfbf242adab91e) },
	{ "java/security/Provider",	_JC_JLONG(0x81b073051aa30acc) },
	{ "java/security/Security",	_JC_JLONG(0x89bf77984bd9669e) },
	{ "java/security/UnrecoverableKeyException",	_JC_JLONG(0x398237d93436ff7e) },
	{ "java/security/VMAccessController",	_JC_JLONG(0xa0b5b25c3d44fe32) },
	{ "java/util/Vector",	_JC_JLONG(0xc53e1575b095109b) },
	{ "javax/net/ssl/KeyManager",	_JC_JLONG(0xae254aeec477c06d) },
	{ "javax/net/ssl/KeyManagerFactory$1",	_JC_JLONG(0xacd8756afabc6543) },
	{ "javax/net/ssl/KeyManagerFactorySpi",	_JC_JLONG(0x6b3456faafb71978) },
	{ "javax/net/ssl/ManagerFactoryParameters",	_JC_JLONG(0x59c25edc381e2cbe) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_javax_net_ssl_KeyManagerFactory$vtype _jc_javax_net_ssl_KeyManagerFactory$type = {
    .type= {
	.name=			"javax/net/ssl/KeyManagerFactory",
	.superclass=		&_jc_java_lang_Object$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		16,
		.hash=			_JC_JLONG(0x46d5f8bd00c9233f),
		.source_file=		"KeyManagerFactory.java",
		.instance_size=		sizeof(_jc_javax_net_ssl_KeyManagerFactory$refs) + sizeof(_jc_javax_net_ssl_KeyManagerFactory$object),
		.num_virtual_refs=	3,
		.num_fields=		sizeof(_jc_javax_net_ssl_KeyManagerFactory$fields) / sizeof(*_jc_javax_net_ssl_KeyManagerFactory$fields),
		.fields=		_jc_javax_net_ssl_KeyManagerFactory$fields,
		.num_methods=		sizeof(_jc_javax_net_ssl_KeyManagerFactory$methods) / sizeof(*_jc_javax_net_ssl_KeyManagerFactory$methods),
		.methods=		_jc_javax_net_ssl_KeyManagerFactory$methods,
		.instanceof_hash_table=	_jc_javax_net_ssl_KeyManagerFactory$instanceof_hash_table,
		.class_fields=		&_jc_javax_net_ssl_KeyManagerFactory$class_fields,
		.num_class_depends=		sizeof(_jc_javax_net_ssl_KeyManagerFactory$class_depends) / sizeof(*_jc_javax_net_ssl_KeyManagerFactory$class_depends),
		.class_depends=		_jc_javax_net_ssl_KeyManagerFactory$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.javax_net_ssl_KeyManagerFactory= {
	    .getAlgorithm$19abbbc132b9063a=
		&_jc_javax_net_ssl_KeyManagerFactory$method$getAlgorithm$19abbbc132b9063a,
	    .getKeyManagers$4d127bd6eaa54b43=
		&_jc_javax_net_ssl_KeyManagerFactory$method$getKeyManagers$4d127bd6eaa54b43,
	    .getProvider$e8f9c9fb14140d5a=
		&_jc_javax_net_ssl_KeyManagerFactory$method$getProvider$e8f9c9fb14140d5a,
	    .init$bed1e62c89299809=
		&_jc_javax_net_ssl_KeyManagerFactory$method$init$bed1e62c89299809,
	    .init$2cb4129406ef255f=
		&_jc_javax_net_ssl_KeyManagerFactory$method$init$2cb4129406ef255f,
	},
    }
};

