// public abstract class javax.xml.validation.SchemaFactory

// class file dependencies
// @dep_class 9cef6b66128b04b2 java_io_File
// @dep_class 4e0a56550c69d57c java_io_IOException
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class 680cf34d05feb5a1 java_lang_IllegalArgumentException
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class 4f5534a987354d1d java_lang_RuntimeException
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class 69345d46f4f40e9c java_net_URL
// @dep_class d7e769aebe17520e java_net_URLStreamHandler
// @dep_class f00134c65c375beb javax_xml_transform_Source
// @dep_class 6487f50fbc3e7405 javax_xml_transform_stream_StreamSource
// @dep_class 1ae5342d33750dd0 javax_xml_validation_Schema
// @dep_class 2269e9f7e1e9bcc0 javax_xml_validation_SchemaFactory
// @dep_class 6d4f4a198c2e3f1c org_w3c_dom_ls_LSResourceResolver
// @dep_class e5ec7637b0794311 org_xml_sax_ErrorHandler
// @dep_class c045a3d7d4ce55f1 org_xml_sax_SAXException
// @dep_class 367865d8b307be5f org_xml_sax_SAXNotRecognizedException
// @dep_class 6a215b87e89c25b9 org_xml_sax_SAXNotSupportedException

// header file dependencies
// @dep_header java_io_File
// @dep_header java_io_IOException
// @dep_header java_lang_Class
// @dep_header java_lang_IllegalArgumentException
// @dep_header java_lang_String
// @dep_header java_lang_VMThrowable
// @dep_header java_net_URL
// @dep_header java_net_URLStreamHandler
// @dep_header javax_xml_transform_Source
// @dep_header javax_xml_transform_stream_StreamSource
// @dep_header javax_xml_validation_Schema
// @dep_header javax_xml_validation_SchemaFactory
// @dep_header org_w3c_dom_ls_LSResourceResolver
// @dep_header org_xml_sax_ErrorHandler
// @dep_header org_xml_sax_SAXNotRecognizedException
// @dep_header org_xml_sax_SAXNotSupportedException

#include "jc_defs.h"

#include "java/io/File.h"
#include "java/io/IOException.h"
#include "java/lang/Class.h"
#include "java/lang/IllegalArgumentException.h"
#include "java/lang/String.h"
#include "java/lang/VMThrowable.h"
#include "java/net/URL.h"
#include "java/net/URLStreamHandler.h"
#include "javax/xml/transform/Source.h"
#include "javax/xml/transform/stream/StreamSource.h"
#include "javax/xml/validation/Schema.h"
#include "javax/xml/validation/SchemaFactory.h"
#include "org/w3c/dom/ls/LSResourceResolver.h"
#include "org/xml/sax/ErrorHandler.h"
#include "org/xml/sax/SAXNotRecognizedException.h"
#include "org/xml/sax/SAXNotSupportedException.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// org.xml.sax.ErrorHandler errorHandler
static _jc_field _jc_javax_xml_validation_SchemaFactory$field_info$errorHandler = {
	.name=		"errorHandler",
	.signature=	"Lorg/xml/sax/ErrorHandler;",
	.class=		&_jc_javax_xml_validation_SchemaFactory$type,
	.type=		&_jc_org_xml_sax_ErrorHandler$type,
	.access_flags=	0,
	.offset=	_JC_OFFSETOF(_jc_javax_xml_validation_SchemaFactory$object, refs[-1].javax_xml_validation_SchemaFactory.errorHandler),
};

// Fields
static _jc_field *const _jc_javax_xml_validation_SchemaFactory$fields[] = {
	&_jc_javax_xml_validation_SchemaFactory$field_info$errorHandler
};

/************************************************************************
 *			      Static methods				*
 ************************************************************************/

//
// public static final javax.xml.validation.SchemaFactory newInstance(java.lang.String)
//

static _jc_linenum _jc_javax_xml_validation_SchemaFactory$linenum_table$newInstance$729a943383bee37c[];

static const unsigned char _jc_javax_xml_validation_SchemaFactory$param_ptypes$newInstance$729a943383bee37c[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_javax_xml_validation_SchemaFactory$param_types$newInstance$729a943383bee37c[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_javax_xml_validation_SchemaFactory$method_info$newInstance$729a943383bee37c = {
	.name=			"newInstance",
	.signature=		"(Ljava/lang/String;)Ljavax/xml/validation/SchemaFactory;",
	.class=			&_jc_javax_xml_validation_SchemaFactory$type,
	.param_types=		&_jc_javax_xml_validation_SchemaFactory$param_types$newInstance$729a943383bee37c,
	.return_type=		&_jc_javax_xml_validation_SchemaFactory$type,
	.param_ptypes=		&_jc_javax_xml_validation_SchemaFactory$param_ptypes$newInstance$729a943383bee37c,
	.signature_hash=	_JC_JLONG(0x729a943383bee37c),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.function=		&_jc_javax_xml_validation_SchemaFactory$method$newInstance$729a943383bee37c,
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_xml_validation_SchemaFactory$linenum_table$newInstance$729a943383bee37c
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_xml_validation_SchemaFactory, newInstance$729a943383bee37c);

_jc_javax_xml_validation_SchemaFactory$object * _JC_JCNI_ATTR
_jc_javax_xml_validation_SchemaFactory$method$newInstance$729a943383bee37c(_jc_env *const env, _jc_java_lang_String$object *param0)
{
	struct _jc_java_lang_String$object *r0;
	struct _jc_java_lang_IllegalArgumentException$object *r1;
	struct _jc_java_lang_VMThrowable$object *r3;

	r0 = param0;
	_JC_LINE_NUMBER(74);				// 0
	r1 = _JC_NEW(env, java_lang_IllegalArgumentException);
	_JC_REF_FIELD(env, r1, java_lang_Throwable, cause) = r1;
	r3 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r1);
	_JC_REF_FIELD(env, r1, java_lang_Throwable, vmState) = r3;
	_JC_REF_FIELD(env, r1, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r1, java_lang_Throwable, detailMessage) = r0;
	_JC_THROW(env, r1);
}

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// protected void <init>()
//

static _jc_linenum _jc_javax_xml_validation_SchemaFactory$linenum_table$_init$52f4ad9f2989aeee[];

static const unsigned char _jc_javax_xml_validation_SchemaFactory$param_ptypes$_init$52f4ad9f2989aeee[] = { 
_JC_TYPE_VOID };

_jc_method _jc_javax_xml_validation_SchemaFactory$method_info$_init$52f4ad9f2989aeee = {
	.name=			"<init>",
	.signature=		"()V",
	.class=			&_jc_javax_xml_validation_SchemaFactory$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_xml_validation_SchemaFactory$param_ptypes$_init$52f4ad9f2989aeee,
	.signature_hash=	_JC_JLONG(0x52f4ad9f2989aeee),
	.access_flags=		_JC_ACC_PROTECTED,
	.function=		&_jc_javax_xml_validation_SchemaFactory$method$_init$52f4ad9f2989aeee,
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_xml_validation_SchemaFactory$linenum_table$_init$52f4ad9f2989aeee
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_xml_validation_SchemaFactory, _init$52f4ad9f2989aeee);

void _JC_JCNI_ATTR
_jc_javax_xml_validation_SchemaFactory$method$_init$52f4ad9f2989aeee(_jc_env *const env, _jc_javax_xml_validation_SchemaFactory$object *this)
{
	struct _jc_javax_xml_validation_SchemaFactory$object *r0;

	r0 = this;
	_JC_LINE_NUMBER(63);				// 0
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public org.xml.sax.ErrorHandler getErrorHandler()
//

static _jc_linenum _jc_javax_xml_validation_SchemaFactory$linenum_table$getErrorHandler$8ed4b273998fa229[];

static const unsigned char _jc_javax_xml_validation_SchemaFactory$param_ptypes$getErrorHandler$8ed4b273998fa229[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_javax_xml_validation_SchemaFactory$method_info$getErrorHandler$8ed4b273998fa229 = {
	.name=			"getErrorHandler",
	.signature=		"()Lorg/xml/sax/ErrorHandler;",
	.class=			&_jc_javax_xml_validation_SchemaFactory$type,
	.return_type=		&_jc_org_xml_sax_ErrorHandler$type,
	.param_ptypes=		&_jc_javax_xml_validation_SchemaFactory$param_ptypes$getErrorHandler$8ed4b273998fa229,
	.signature_hash=	_JC_JLONG(0x8ed4b273998fa229),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_javax_xml_validation_SchemaFactory$method$getErrorHandler$8ed4b273998fa229,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_xml_validation_SchemaFactory$vtable, javax_xml_validation_SchemaFactory.getErrorHandler$8ed4b273998fa229) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_xml_validation_SchemaFactory$linenum_table$getErrorHandler$8ed4b273998fa229
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_xml_validation_SchemaFactory, getErrorHandler$8ed4b273998fa229);

_jc_object * _JC_JCNI_ATTR
_jc_javax_xml_validation_SchemaFactory$method$getErrorHandler$8ed4b273998fa229(_jc_env *const env, _jc_javax_xml_validation_SchemaFactory$object *this)
{
	struct _jc_javax_xml_validation_SchemaFactory$object *r0;
	struct _jc_object *r1;

	r0 = this;
	_JC_LINE_NUMBER(110);				// 0
	r1 = _JC_REF_FIELD(env, r0, javax_xml_validation_SchemaFactory, errorHandler);
	return r1;
}

//
// public boolean getFeature(java.lang.String) throws org.xml.sax.SAXNotRecognizedException, org.xml.sax.SAXNotSupportedException
//

static _jc_linenum _jc_javax_xml_validation_SchemaFactory$linenum_table$getFeature$1f81e149fe4bca3b[];

static const unsigned char _jc_javax_xml_validation_SchemaFactory$param_ptypes$getFeature$1f81e149fe4bca3b[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_javax_xml_validation_SchemaFactory$exceptions$getFeature$1f81e149fe4bca3b[] = {
	&_jc_org_xml_sax_SAXNotRecognizedException$type,
	&_jc_org_xml_sax_SAXNotSupportedException$type
};

static _jc_type *const _jc_javax_xml_validation_SchemaFactory$param_types$getFeature$1f81e149fe4bca3b[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_javax_xml_validation_SchemaFactory$method_info$getFeature$1f81e149fe4bca3b = {
	.name=			"getFeature",
	.signature=		"(Ljava/lang/String;)Z",
	.class=			&_jc_javax_xml_validation_SchemaFactory$type,
	.param_types=		&_jc_javax_xml_validation_SchemaFactory$param_types$getFeature$1f81e149fe4bca3b,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_javax_xml_validation_SchemaFactory$param_ptypes$getFeature$1f81e149fe4bca3b,
	.signature_hash=	_JC_JLONG(0x1f81e149fe4bca3b),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_javax_xml_validation_SchemaFactory$method$getFeature$1f81e149fe4bca3b,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_xml_validation_SchemaFactory$vtable, javax_xml_validation_SchemaFactory.getFeature$1f81e149fe4bca3b) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	2,
	.exceptions=		&_jc_javax_xml_validation_SchemaFactory$exceptions$getFeature$1f81e149fe4bca3b,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_xml_validation_SchemaFactory$linenum_table$getFeature$1f81e149fe4bca3b
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_xml_validation_SchemaFactory, getFeature$1f81e149fe4bca3b);

jboolean _JC_JCNI_ATTR
_jc_javax_xml_validation_SchemaFactory$method$getFeature$1f81e149fe4bca3b(_jc_env *const env, _jc_javax_xml_validation_SchemaFactory$object *this, _jc_java_lang_String$object *param0)
{
	struct _jc_javax_xml_validation_SchemaFactory$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_org_xml_sax_SAXNotRecognizedException$object *r2;
	struct _jc_java_lang_VMThrowable$object *r4;

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(87);				// 0
	r2 = _JC_NEW(env, org_xml_sax_SAXNotRecognizedException);
	_JC_REF_FIELD(env, r2, java_lang_Throwable, cause) = r2;
	r4 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r2);
	_JC_REF_FIELD(env, r2, java_lang_Throwable, vmState) = r4;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, detailMessage) = r1;
	_JC_REF_FIELD(env, r2, org_xml_sax_SAXException, exception) = _JC_NULL;
	_JC_THROW(env, r2);
}

//
// public java.lang.Object getProperty(java.lang.String) throws org.xml.sax.SAXNotRecognizedException, org.xml.sax.SAXNotSupportedException
//

static _jc_linenum _jc_javax_xml_validation_SchemaFactory$linenum_table$getProperty$ad67146a826fdaf8[];

static const unsigned char _jc_javax_xml_validation_SchemaFactory$param_ptypes$getProperty$ad67146a826fdaf8[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_javax_xml_validation_SchemaFactory$exceptions$getProperty$ad67146a826fdaf8[] = {
	&_jc_org_xml_sax_SAXNotRecognizedException$type,
	&_jc_org_xml_sax_SAXNotSupportedException$type
};

static _jc_type *const _jc_javax_xml_validation_SchemaFactory$param_types$getProperty$ad67146a826fdaf8[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_javax_xml_validation_SchemaFactory$method_info$getProperty$ad67146a826fdaf8 = {
	.name=			"getProperty",
	.signature=		"(Ljava/lang/String;)Ljava/lang/Object;",
	.class=			&_jc_javax_xml_validation_SchemaFactory$type,
	.param_types=		&_jc_javax_xml_validation_SchemaFactory$param_types$getProperty$ad67146a826fdaf8,
	.return_type=		&_jc_java_lang_Object$type,
	.param_ptypes=		&_jc_javax_xml_validation_SchemaFactory$param_ptypes$getProperty$ad67146a826fdaf8,
	.signature_hash=	_JC_JLONG(0xad67146a826fdaf8),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_javax_xml_validation_SchemaFactory$method$getProperty$ad67146a826fdaf8,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_xml_validation_SchemaFactory$vtable, javax_xml_validation_SchemaFactory.getProperty$ad67146a826fdaf8) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	2,
	.exceptions=		&_jc_javax_xml_validation_SchemaFactory$exceptions$getProperty$ad67146a826fdaf8,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_xml_validation_SchemaFactory$linenum_table$getProperty$ad67146a826fdaf8
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_xml_validation_SchemaFactory, getProperty$ad67146a826fdaf8);

_jc_java_lang_Object$object * _JC_JCNI_ATTR
_jc_javax_xml_validation_SchemaFactory$method$getProperty$ad67146a826fdaf8(_jc_env *const env, _jc_javax_xml_validation_SchemaFactory$object *this, _jc_java_lang_String$object *param0)
{
	struct _jc_javax_xml_validation_SchemaFactory$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_org_xml_sax_SAXNotRecognizedException$object *r2;
	struct _jc_java_lang_VMThrowable$object *r4;

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(99);				// 0
	r2 = _JC_NEW(env, org_xml_sax_SAXNotRecognizedException);
	_JC_REF_FIELD(env, r2, java_lang_Throwable, cause) = r2;
	r4 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r2);
	_JC_REF_FIELD(env, r2, java_lang_Throwable, vmState) = r4;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, detailMessage) = r1;
	_JC_REF_FIELD(env, r2, org_xml_sax_SAXException, exception) = _JC_NULL;
	_JC_THROW(env, r2);
}

//
// public abstract org.w3c.dom.ls.LSResourceResolver getResourceResolver()
//

static const unsigned char _jc_javax_xml_validation_SchemaFactory$param_ptypes$getResourceResolver$367b0cf4cb257c85[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_javax_xml_validation_SchemaFactory$method_info$getResourceResolver$367b0cf4cb257c85 = {
	.name=			"getResourceResolver",
	.signature=		"()Lorg/w3c/dom/ls/LSResourceResolver;",
	.class=			&_jc_javax_xml_validation_SchemaFactory$type,
	.return_type=		&_jc_org_w3c_dom_ls_LSResourceResolver$type,
	.param_ptypes=		&_jc_javax_xml_validation_SchemaFactory$param_ptypes$getResourceResolver$367b0cf4cb257c85,
	.signature_hash=	_JC_JLONG(0x367b0cf4cb257c85),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.function=		&_jc_javax_xml_validation_SchemaFactory$method$getResourceResolver$367b0cf4cb257c85,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_xml_validation_SchemaFactory$vtable, javax_xml_validation_SchemaFactory.getResourceResolver$367b0cf4cb257c85) / sizeof(void *),
	.num_parameters=	0,
};

_jc_object * _JC_JCNI_ATTR
_jc_javax_xml_validation_SchemaFactory$method$getResourceResolver$367b0cf4cb257c85(_jc_env *const env, _jc_javax_xml_validation_SchemaFactory$object *this)
{
	_JC_ABSTRACT_METHOD(env, &_jc_javax_xml_validation_SchemaFactory$method_info$getResourceResolver$367b0cf4cb257c85);
}

//
// public abstract boolean isSchemaLanguageSupported(java.lang.String)
//

static const unsigned char _jc_javax_xml_validation_SchemaFactory$param_ptypes$isSchemaLanguageSupported$e6e721e54298b14a[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_javax_xml_validation_SchemaFactory$param_types$isSchemaLanguageSupported$e6e721e54298b14a[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_javax_xml_validation_SchemaFactory$method_info$isSchemaLanguageSupported$e6e721e54298b14a = {
	.name=			"isSchemaLanguageSupported",
	.signature=		"(Ljava/lang/String;)Z",
	.class=			&_jc_javax_xml_validation_SchemaFactory$type,
	.param_types=		&_jc_javax_xml_validation_SchemaFactory$param_types$isSchemaLanguageSupported$e6e721e54298b14a,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_javax_xml_validation_SchemaFactory$param_ptypes$isSchemaLanguageSupported$e6e721e54298b14a,
	.signature_hash=	_JC_JLONG(0xe6e721e54298b14a),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.function=		&_jc_javax_xml_validation_SchemaFactory$method$isSchemaLanguageSupported$e6e721e54298b14a,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_xml_validation_SchemaFactory$vtable, javax_xml_validation_SchemaFactory.isSchemaLanguageSupported$e6e721e54298b14a) / sizeof(void *),
	.num_parameters=	1,
};

jboolean _JC_JCNI_ATTR
_jc_javax_xml_validation_SchemaFactory$method$isSchemaLanguageSupported$e6e721e54298b14a(_jc_env *const env, _jc_javax_xml_validation_SchemaFactory$object *this, _jc_java_lang_String$object *param0)
{
	_JC_ABSTRACT_METHOD(env, &_jc_javax_xml_validation_SchemaFactory$method_info$isSchemaLanguageSupported$e6e721e54298b14a);
}

//
// public abstract javax.xml.validation.Schema newSchema() throws org.xml.sax.SAXException
//

static const unsigned char _jc_javax_xml_validation_SchemaFactory$param_ptypes$newSchema$2cf1afb714f75fc9[] = { 
_JC_TYPE_REFERENCE };

static _jc_type *const _jc_javax_xml_validation_SchemaFactory$exceptions$newSchema$2cf1afb714f75fc9[] = {
	&_jc_org_xml_sax_SAXException$type
};

_jc_method _jc_javax_xml_validation_SchemaFactory$method_info$newSchema$2cf1afb714f75fc9 = {
	.name=			"newSchema",
	.signature=		"()Ljavax/xml/validation/Schema;",
	.class=			&_jc_javax_xml_validation_SchemaFactory$type,
	.return_type=		&_jc_javax_xml_validation_Schema$type,
	.param_ptypes=		&_jc_javax_xml_validation_SchemaFactory$param_ptypes$newSchema$2cf1afb714f75fc9,
	.signature_hash=	_JC_JLONG(0x2cf1afb714f75fc9),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.function=		&_jc_javax_xml_validation_SchemaFactory$method$newSchema$2cf1afb714f75fc9,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_xml_validation_SchemaFactory$vtable, javax_xml_validation_SchemaFactory.newSchema$2cf1afb714f75fc9) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_xml_validation_SchemaFactory$exceptions$newSchema$2cf1afb714f75fc9,
};

_jc_javax_xml_validation_Schema$object * _JC_JCNI_ATTR
_jc_javax_xml_validation_SchemaFactory$method$newSchema$2cf1afb714f75fc9(_jc_env *const env, _jc_javax_xml_validation_SchemaFactory$object *this)
{
	_JC_ABSTRACT_METHOD(env, &_jc_javax_xml_validation_SchemaFactory$method_info$newSchema$2cf1afb714f75fc9);
}

//
// public javax.xml.validation.Schema newSchema(java.io.File) throws org.xml.sax.SAXException
//

static _jc_linenum _jc_javax_xml_validation_SchemaFactory$linenum_table$newSchema$1fa2fea28ee153e2[];

static _jc_trap_info _jc_javax_xml_validation_SchemaFactory$trap_table$newSchema$1fa2fea28ee153e2[] = {
	_JC_TRAP(&_jc_java_io_IOException$type, 1, 2),
};

static const unsigned char _jc_javax_xml_validation_SchemaFactory$param_ptypes$newSchema$1fa2fea28ee153e2[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_javax_xml_validation_SchemaFactory$exceptions$newSchema$1fa2fea28ee153e2[] = {
	&_jc_org_xml_sax_SAXException$type
};

static _jc_type *const _jc_javax_xml_validation_SchemaFactory$param_types$newSchema$1fa2fea28ee153e2[] = {
	&_jc_java_io_File$type
};

_jc_method _jc_javax_xml_validation_SchemaFactory$method_info$newSchema$1fa2fea28ee153e2 = {
	.name=			"newSchema",
	.signature=		"(Ljava/io/File;)Ljavax/xml/validation/Schema;",
	.class=			&_jc_javax_xml_validation_SchemaFactory$type,
	.param_types=		&_jc_javax_xml_validation_SchemaFactory$param_types$newSchema$1fa2fea28ee153e2,
	.return_type=		&_jc_javax_xml_validation_Schema$type,
	.param_ptypes=		&_jc_javax_xml_validation_SchemaFactory$param_ptypes$newSchema$1fa2fea28ee153e2,
	.signature_hash=	_JC_JLONG(0x1fa2fea28ee153e2),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_javax_xml_validation_SchemaFactory$method$newSchema$1fa2fea28ee153e2,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_xml_validation_SchemaFactory$vtable, javax_xml_validation_SchemaFactory.newSchema$1fa2fea28ee153e2) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_xml_validation_SchemaFactory$exceptions$newSchema$1fa2fea28ee153e2,
	.u= { .exec= {
	  .trap_table_len=	1,
	  .trap_table=		_jc_javax_xml_validation_SchemaFactory$trap_table$newSchema$1fa2fea28ee153e2,
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_xml_validation_SchemaFactory$linenum_table$newSchema$1fa2fea28ee153e2
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_xml_validation_SchemaFactory, newSchema$1fa2fea28ee153e2);

_jc_javax_xml_validation_Schema$object * _JC_JCNI_ATTR
_jc_javax_xml_validation_SchemaFactory$method$newSchema$1fa2fea28ee153e2(_jc_env *const env, _jc_javax_xml_validation_SchemaFactory$object *this, _jc_java_io_File$object *param0)
{
	struct _jc_javax_xml_validation_SchemaFactory$object *r0;
	struct _jc_java_io_File$object *r1;
	struct _jc_javax_xml_transform_stream_StreamSource$object *r2;
	struct _jc_javax_xml_validation_Schema$object *r3;
	struct _jc_java_io_IOException$object *volatile r4;
	struct _jc_java_net_URL$object *r5;
	struct _jc_java_lang_String$object *volatile r6;
	struct _jc_java_lang_RuntimeException$object *volatile r7;
	struct _jc_java_net_URLStreamHandler$object *r8;
	struct _jc_java_lang_String$object *r9;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_javax_xml_validation_SchemaFactory$method_info$newSchema$1fa2fea28ee153e2, &&label0);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(139);				// 0
	r2 = _JC_NEW(env, javax_xml_transform_stream_StreamSource);
	_JC_TRAP_REGION(catch, 1);
	r5 = _JC_INVOKE_VIRTUAL(env, java_io_File, toURL$617222bd5a975952, r1);
	_JC_EXPLICIT_NULL_CHECK(env, r5);
	r8 = _JC_REF_FIELD(env, r5, java_net_URL, ph);
	r9 = _JC_INVOKE_VIRTUAL(env, java_net_URLStreamHandler, toExternalForm$330af71074ca3ddf, r8, r5);
	_JC_REF_FIELD(env, r2, javax_xml_transform_stream_StreamSource, systemId) = r9;
	_JC_TRAP_REGION(catch, 2);
	goto label1;

label0:
	_JC_TRAP_REGION(catch, 2);
	r4 = _JC_CAUGHT_EXCEPTION(env);
	r7 = _JC_NEW(env, java_lang_RuntimeException);
	r6 = _JC_INVOKE_VIRTUAL(env, java_lang_Throwable, getMessage$13aaf240efc902b1, r4);
	_JC_REF_FIELD(env, r7, java_lang_Throwable, cause) = r7;
	_JC_INVOKE_NONVIRTUAL(env, java_lang_Throwable, fillInStackTrace$6204b72985f9038d, 0, r7);
	_JC_REF_FIELD(env, r7, java_lang_Throwable, detailMessage) = r6;
	_JC_REF_FIELD(env, r7, java_lang_Throwable, cause) = r4;
	_JC_THROW(env, r7);

label1:
	r3 = _JC_INVOKE_VIRTUAL(env, javax_xml_validation_SchemaFactory, newSchema$20c33329c3c98fc5, r0, r2);
	_JC_CANCEL_TRAPS(env, catch);
	return r3;
}

//
// public javax.xml.validation.Schema newSchema(java.net.URL) throws org.xml.sax.SAXException
//

static _jc_linenum _jc_javax_xml_validation_SchemaFactory$linenum_table$newSchema$715c64e60866c835[];

static const unsigned char _jc_javax_xml_validation_SchemaFactory$param_ptypes$newSchema$715c64e60866c835[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_javax_xml_validation_SchemaFactory$exceptions$newSchema$715c64e60866c835[] = {
	&_jc_org_xml_sax_SAXException$type
};

static _jc_type *const _jc_javax_xml_validation_SchemaFactory$param_types$newSchema$715c64e60866c835[] = {
	&_jc_java_net_URL$type
};

_jc_method _jc_javax_xml_validation_SchemaFactory$method_info$newSchema$715c64e60866c835 = {
	.name=			"newSchema",
	.signature=		"(Ljava/net/URL;)Ljavax/xml/validation/Schema;",
	.class=			&_jc_javax_xml_validation_SchemaFactory$type,
	.param_types=		&_jc_javax_xml_validation_SchemaFactory$param_types$newSchema$715c64e60866c835,
	.return_type=		&_jc_javax_xml_validation_Schema$type,
	.param_ptypes=		&_jc_javax_xml_validation_SchemaFactory$param_ptypes$newSchema$715c64e60866c835,
	.signature_hash=	_JC_JLONG(0x715c64e60866c835),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_javax_xml_validation_SchemaFactory$method$newSchema$715c64e60866c835,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_xml_validation_SchemaFactory$vtable, javax_xml_validation_SchemaFactory.newSchema$715c64e60866c835) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_xml_validation_SchemaFactory$exceptions$newSchema$715c64e60866c835,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_xml_validation_SchemaFactory$linenum_table$newSchema$715c64e60866c835
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_xml_validation_SchemaFactory, newSchema$715c64e60866c835);

_jc_javax_xml_validation_Schema$object * _JC_JCNI_ATTR
_jc_javax_xml_validation_SchemaFactory$method$newSchema$715c64e60866c835(_jc_env *const env, _jc_javax_xml_validation_SchemaFactory$object *this, _jc_java_net_URL$object *param0)
{
	struct _jc_javax_xml_validation_SchemaFactory$object *r0;
	struct _jc_java_net_URL$object *r1;
	struct _jc_javax_xml_transform_stream_StreamSource$object *r2;
	struct _jc_javax_xml_validation_Schema$object *r3;
	struct _jc_java_net_URLStreamHandler$object *r4;
	struct _jc_java_lang_String$object *r5;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(149);				// 0
	r2 = _JC_NEW(env, javax_xml_transform_stream_StreamSource);
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	r4 = _JC_REF_FIELD(env, r1, java_net_URL, ph);
	r5 = _JC_INVOKE_VIRTUAL(env, java_net_URLStreamHandler, toExternalForm$330af71074ca3ddf, r4, r1);
	_JC_REF_FIELD(env, r2, javax_xml_transform_stream_StreamSource, systemId) = r5;
	r3 = _JC_INVOKE_VIRTUAL(env, javax_xml_validation_SchemaFactory, newSchema$20c33329c3c98fc5, r0, r2);
	return r3;
}

//
// public javax.xml.validation.Schema newSchema(javax.xml.transform.Source) throws org.xml.sax.SAXException
//

static _jc_linenum _jc_javax_xml_validation_SchemaFactory$linenum_table$newSchema$20c33329c3c98fc5[];

static const unsigned char _jc_javax_xml_validation_SchemaFactory$param_ptypes$newSchema$20c33329c3c98fc5[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_javax_xml_validation_SchemaFactory$exceptions$newSchema$20c33329c3c98fc5[] = {
	&_jc_org_xml_sax_SAXException$type
};

static _jc_type *const _jc_javax_xml_validation_SchemaFactory$param_types$newSchema$20c33329c3c98fc5[] = {
	&_jc_javax_xml_transform_Source$type
};

_jc_method _jc_javax_xml_validation_SchemaFactory$method_info$newSchema$20c33329c3c98fc5 = {
	.name=			"newSchema",
	.signature=		"(Ljavax/xml/transform/Source;)Ljavax/xml/validation/Schema;",
	.class=			&_jc_javax_xml_validation_SchemaFactory$type,
	.param_types=		&_jc_javax_xml_validation_SchemaFactory$param_types$newSchema$20c33329c3c98fc5,
	.return_type=		&_jc_javax_xml_validation_Schema$type,
	.param_ptypes=		&_jc_javax_xml_validation_SchemaFactory$param_ptypes$newSchema$20c33329c3c98fc5,
	.signature_hash=	_JC_JLONG(0x20c33329c3c98fc5),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_javax_xml_validation_SchemaFactory$method$newSchema$20c33329c3c98fc5,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_xml_validation_SchemaFactory$vtable, javax_xml_validation_SchemaFactory.newSchema$20c33329c3c98fc5) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_xml_validation_SchemaFactory$exceptions$newSchema$20c33329c3c98fc5,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_xml_validation_SchemaFactory$linenum_table$newSchema$20c33329c3c98fc5
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_xml_validation_SchemaFactory, newSchema$20c33329c3c98fc5);

_jc_javax_xml_validation_Schema$object * _JC_JCNI_ATTR
_jc_javax_xml_validation_SchemaFactory$method$newSchema$20c33329c3c98fc5(_jc_env *const env, _jc_javax_xml_validation_SchemaFactory$object *this, _jc_object *param0)
{
	struct _jc_javax_xml_validation_SchemaFactory$object *r0;
	struct _jc_object *r1;
	_jc_object_array *r2;
	struct _jc_javax_xml_validation_Schema$object *r3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(129);				// 0
	r2 = _JC_NEW_REF_ARRAY(env, javax_xml_transform_Source, 1, 1);
	_JC_ARRAYSTORE_CHECK(env, r2, r1);
	_JC_REF_ELEMENT(env, r2, 0, 0, 0) = r1;
	r3 = _JC_INVOKE_VIRTUAL(env, javax_xml_validation_SchemaFactory, newSchema$633e646920400264, r0, r2);
	return r3;
}

//
// public abstract javax.xml.validation.Schema newSchema(javax.xml.transform.Source[]) throws org.xml.sax.SAXException
//

static const unsigned char _jc_javax_xml_validation_SchemaFactory$param_ptypes$newSchema$633e646920400264[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_javax_xml_validation_SchemaFactory$exceptions$newSchema$633e646920400264[] = {
	&_jc_org_xml_sax_SAXException$type
};

static _jc_type *const _jc_javax_xml_validation_SchemaFactory$param_types$newSchema$633e646920400264[] = {
	&_jc_javax_xml_transform_Source$array$type
};

_jc_method _jc_javax_xml_validation_SchemaFactory$method_info$newSchema$633e646920400264 = {
	.name=			"newSchema",
	.signature=		"([Ljavax/xml/transform/Source;)Ljavax/xml/validation/Schema;",
	.class=			&_jc_javax_xml_validation_SchemaFactory$type,
	.param_types=		&_jc_javax_xml_validation_SchemaFactory$param_types$newSchema$633e646920400264,
	.return_type=		&_jc_javax_xml_validation_Schema$type,
	.param_ptypes=		&_jc_javax_xml_validation_SchemaFactory$param_ptypes$newSchema$633e646920400264,
	.signature_hash=	_JC_JLONG(0x633e646920400264),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.function=		&_jc_javax_xml_validation_SchemaFactory$method$newSchema$633e646920400264,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_xml_validation_SchemaFactory$vtable, javax_xml_validation_SchemaFactory.newSchema$633e646920400264) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_javax_xml_validation_SchemaFactory$exceptions$newSchema$633e646920400264,
};

_jc_javax_xml_validation_Schema$object * _JC_JCNI_ATTR
_jc_javax_xml_validation_SchemaFactory$method$newSchema$633e646920400264(_jc_env *const env, _jc_javax_xml_validation_SchemaFactory$object *this, _jc_object_array *param0)
{
	_JC_ABSTRACT_METHOD(env, &_jc_javax_xml_validation_SchemaFactory$method_info$newSchema$633e646920400264);
}

//
// public void setErrorHandler(org.xml.sax.ErrorHandler)
//

static _jc_linenum _jc_javax_xml_validation_SchemaFactory$linenum_table$setErrorHandler$ca242a9f880820cc[];

static const unsigned char _jc_javax_xml_validation_SchemaFactory$param_ptypes$setErrorHandler$ca242a9f880820cc[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_xml_validation_SchemaFactory$param_types$setErrorHandler$ca242a9f880820cc[] = {
	&_jc_org_xml_sax_ErrorHandler$type
};

_jc_method _jc_javax_xml_validation_SchemaFactory$method_info$setErrorHandler$ca242a9f880820cc = {
	.name=			"setErrorHandler",
	.signature=		"(Lorg/xml/sax/ErrorHandler;)V",
	.class=			&_jc_javax_xml_validation_SchemaFactory$type,
	.param_types=		&_jc_javax_xml_validation_SchemaFactory$param_types$setErrorHandler$ca242a9f880820cc,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_xml_validation_SchemaFactory$param_ptypes$setErrorHandler$ca242a9f880820cc,
	.signature_hash=	_JC_JLONG(0xca242a9f880820cc),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_javax_xml_validation_SchemaFactory$method$setErrorHandler$ca242a9f880820cc,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_xml_validation_SchemaFactory$vtable, javax_xml_validation_SchemaFactory.setErrorHandler$ca242a9f880820cc) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_javax_xml_validation_SchemaFactory$linenum_table$setErrorHandler$ca242a9f880820cc
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_xml_validation_SchemaFactory, setErrorHandler$ca242a9f880820cc);

void _JC_JCNI_ATTR
_jc_javax_xml_validation_SchemaFactory$method$setErrorHandler$ca242a9f880820cc(_jc_env *const env, _jc_javax_xml_validation_SchemaFactory$object *this, _jc_object *param0)
{
	struct _jc_javax_xml_validation_SchemaFactory$object *r0;
	struct _jc_object *r1;

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(115);				// 0
	_JC_REF_FIELD(env, r0, javax_xml_validation_SchemaFactory, errorHandler) = r1;
	_JC_LINE_NUMBER(116);				// 1
	return;
}

//
// public void setFeature(java.lang.String, boolean) throws org.xml.sax.SAXNotRecognizedException, org.xml.sax.SAXNotSupportedException
//

static _jc_linenum _jc_javax_xml_validation_SchemaFactory$linenum_table$setFeature$907897e626165cee[];

static const unsigned char _jc_javax_xml_validation_SchemaFactory$param_ptypes$setFeature$907897e626165cee[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_xml_validation_SchemaFactory$exceptions$setFeature$907897e626165cee[] = {
	&_jc_org_xml_sax_SAXNotRecognizedException$type,
	&_jc_org_xml_sax_SAXNotSupportedException$type
};

static _jc_type *const _jc_javax_xml_validation_SchemaFactory$param_types$setFeature$907897e626165cee[] = {
	&_jc_java_lang_String$type,
	&_jc_boolean$prim$type
};

_jc_method _jc_javax_xml_validation_SchemaFactory$method_info$setFeature$907897e626165cee = {
	.name=			"setFeature",
	.signature=		"(Ljava/lang/String;Z)V",
	.class=			&_jc_javax_xml_validation_SchemaFactory$type,
	.param_types=		&_jc_javax_xml_validation_SchemaFactory$param_types$setFeature$907897e626165cee,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_xml_validation_SchemaFactory$param_ptypes$setFeature$907897e626165cee,
	.signature_hash=	_JC_JLONG(0x907897e626165cee),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_javax_xml_validation_SchemaFactory$method$setFeature$907897e626165cee,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_xml_validation_SchemaFactory$vtable, javax_xml_validation_SchemaFactory.setFeature$907897e626165cee) / sizeof(void *),
	.num_parameters=	2,
	.num_exceptions=	2,
	.exceptions=		&_jc_javax_xml_validation_SchemaFactory$exceptions$setFeature$907897e626165cee,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_xml_validation_SchemaFactory$linenum_table$setFeature$907897e626165cee
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_xml_validation_SchemaFactory, setFeature$907897e626165cee);

void _JC_JCNI_ATTR
_jc_javax_xml_validation_SchemaFactory$method$setFeature$907897e626165cee(_jc_env *const env, _jc_javax_xml_validation_SchemaFactory$object *this, _jc_java_lang_String$object *param0, jboolean param1)
{
	struct _jc_javax_xml_validation_SchemaFactory$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_org_xml_sax_SAXNotRecognizedException$object *r2;
	struct _jc_java_lang_VMThrowable$object *r4;
	jboolean z0;

	r0 = this;
	r1 = param0;
	z0 = param1;
	_JC_LINE_NUMBER(93);				// 0
	r2 = _JC_NEW(env, org_xml_sax_SAXNotRecognizedException);
	_JC_REF_FIELD(env, r2, java_lang_Throwable, cause) = r2;
	r4 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r2);
	_JC_REF_FIELD(env, r2, java_lang_Throwable, vmState) = r4;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, detailMessage) = r1;
	_JC_REF_FIELD(env, r2, org_xml_sax_SAXException, exception) = _JC_NULL;
	_JC_THROW(env, r2);
}

//
// public void setProperty(java.lang.String, java.lang.Object) throws org.xml.sax.SAXNotRecognizedException, org.xml.sax.SAXNotSupportedException
//

static _jc_linenum _jc_javax_xml_validation_SchemaFactory$linenum_table$setProperty$a4769aed759cc4ba[];

static const unsigned char _jc_javax_xml_validation_SchemaFactory$param_ptypes$setProperty$a4769aed759cc4ba[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_xml_validation_SchemaFactory$exceptions$setProperty$a4769aed759cc4ba[] = {
	&_jc_org_xml_sax_SAXNotRecognizedException$type,
	&_jc_org_xml_sax_SAXNotSupportedException$type
};

static _jc_type *const _jc_javax_xml_validation_SchemaFactory$param_types$setProperty$a4769aed759cc4ba[] = {
	&_jc_java_lang_String$type,
	&_jc_java_lang_Object$type
};

_jc_method _jc_javax_xml_validation_SchemaFactory$method_info$setProperty$a4769aed759cc4ba = {
	.name=			"setProperty",
	.signature=		"(Ljava/lang/String;Ljava/lang/Object;)V",
	.class=			&_jc_javax_xml_validation_SchemaFactory$type,
	.param_types=		&_jc_javax_xml_validation_SchemaFactory$param_types$setProperty$a4769aed759cc4ba,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_xml_validation_SchemaFactory$param_ptypes$setProperty$a4769aed759cc4ba,
	.signature_hash=	_JC_JLONG(0xa4769aed759cc4ba),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_javax_xml_validation_SchemaFactory$method$setProperty$a4769aed759cc4ba,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_xml_validation_SchemaFactory$vtable, javax_xml_validation_SchemaFactory.setProperty$a4769aed759cc4ba) / sizeof(void *),
	.num_parameters=	2,
	.num_exceptions=	2,
	.exceptions=		&_jc_javax_xml_validation_SchemaFactory$exceptions$setProperty$a4769aed759cc4ba,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_javax_xml_validation_SchemaFactory$linenum_table$setProperty$a4769aed759cc4ba
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(javax_xml_validation_SchemaFactory, setProperty$a4769aed759cc4ba);

void _JC_JCNI_ATTR
_jc_javax_xml_validation_SchemaFactory$method$setProperty$a4769aed759cc4ba(_jc_env *const env, _jc_javax_xml_validation_SchemaFactory$object *this, _jc_java_lang_String$object *param0, _jc_java_lang_Object$object *param1)
{
	struct _jc_javax_xml_validation_SchemaFactory$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_java_lang_Object$object *r2;
	struct _jc_org_xml_sax_SAXNotRecognizedException$object *r3;
	struct _jc_java_lang_VMThrowable$object *r5;

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_LINE_NUMBER(105);				// 0
	r3 = _JC_NEW(env, org_xml_sax_SAXNotRecognizedException);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r5 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r5;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r1;
	_JC_REF_FIELD(env, r3, org_xml_sax_SAXException, exception) = _JC_NULL;
	_JC_THROW(env, r3);
}

//
// public abstract void setResourceResolver(org.w3c.dom.ls.LSResourceResolver)
//

static const unsigned char _jc_javax_xml_validation_SchemaFactory$param_ptypes$setResourceResolver$6fff270aa30debdd[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_javax_xml_validation_SchemaFactory$param_types$setResourceResolver$6fff270aa30debdd[] = {
	&_jc_org_w3c_dom_ls_LSResourceResolver$type
};

_jc_method _jc_javax_xml_validation_SchemaFactory$method_info$setResourceResolver$6fff270aa30debdd = {
	.name=			"setResourceResolver",
	.signature=		"(Lorg/w3c/dom/ls/LSResourceResolver;)V",
	.class=			&_jc_javax_xml_validation_SchemaFactory$type,
	.param_types=		&_jc_javax_xml_validation_SchemaFactory$param_types$setResourceResolver$6fff270aa30debdd,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_javax_xml_validation_SchemaFactory$param_ptypes$setResourceResolver$6fff270aa30debdd,
	.signature_hash=	_JC_JLONG(0x6fff270aa30debdd),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.function=		&_jc_javax_xml_validation_SchemaFactory$method$setResourceResolver$6fff270aa30debdd,
	.vtable_index=		_JC_OFFSETOF(struct _jc_javax_xml_validation_SchemaFactory$vtable, javax_xml_validation_SchemaFactory.setResourceResolver$6fff270aa30debdd) / sizeof(void *),
	.num_parameters=	1,
};

void _JC_JCNI_ATTR
_jc_javax_xml_validation_SchemaFactory$method$setResourceResolver$6fff270aa30debdd(_jc_env *const env, _jc_javax_xml_validation_SchemaFactory$object *this, _jc_object *param0)
{
	_JC_ABSTRACT_METHOD(env, &_jc_javax_xml_validation_SchemaFactory$method_info$setResourceResolver$6fff270aa30debdd);
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_javax_xml_validation_SchemaFactory$methods[] = {
	&_jc_javax_xml_validation_SchemaFactory$method_info$_init$52f4ad9f2989aeee,
	&_jc_javax_xml_validation_SchemaFactory$method_info$getErrorHandler$8ed4b273998fa229,
	&_jc_javax_xml_validation_SchemaFactory$method_info$getFeature$1f81e149fe4bca3b,
	&_jc_javax_xml_validation_SchemaFactory$method_info$getProperty$ad67146a826fdaf8,
	&_jc_javax_xml_validation_SchemaFactory$method_info$getResourceResolver$367b0cf4cb257c85,
	&_jc_javax_xml_validation_SchemaFactory$method_info$isSchemaLanguageSupported$e6e721e54298b14a,
	&_jc_javax_xml_validation_SchemaFactory$method_info$newInstance$729a943383bee37c,
	&_jc_javax_xml_validation_SchemaFactory$method_info$newSchema$2cf1afb714f75fc9,
	&_jc_javax_xml_validation_SchemaFactory$method_info$newSchema$1fa2fea28ee153e2,
	&_jc_javax_xml_validation_SchemaFactory$method_info$newSchema$715c64e60866c835,
	&_jc_javax_xml_validation_SchemaFactory$method_info$newSchema$20c33329c3c98fc5,
	&_jc_javax_xml_validation_SchemaFactory$method_info$newSchema$633e646920400264,
	&_jc_javax_xml_validation_SchemaFactory$method_info$setErrorHandler$ca242a9f880820cc,
	&_jc_javax_xml_validation_SchemaFactory$method_info$setFeature$907897e626165cee,
	&_jc_javax_xml_validation_SchemaFactory$method_info$setProperty$a4769aed759cc4ba,
	&_jc_javax_xml_validation_SchemaFactory$method_info$setResourceResolver$6fff270aa30debdd
};

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_javax_xml_validation_SchemaFactory$instanceof_hash_bucket_64[] = {
	&_jc_javax_xml_validation_SchemaFactory$type,
	_JC_NULL
};
static _jc_type *const _jc_javax_xml_validation_SchemaFactory$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_javax_xml_validation_SchemaFactory$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[64]=	_jc_javax_xml_validation_SchemaFactory$instanceof_hash_bucket_64,
	[101]=	_jc_javax_xml_validation_SchemaFactory$instanceof_hash_bucket_101
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_javax_xml_validation_SchemaFactory$class_depends[] = {
	{ "java/io/File",	_JC_JLONG(0x9cef6b66128b04b2) },
	{ "java/io/IOException",	_JC_JLONG(0x4e0a56550c69d57c) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/IllegalArgumentException",	_JC_JLONG(0x680cf34d05feb5a1) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/RuntimeException",	_JC_JLONG(0x4f5534a987354d1d) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/net/URL",	_JC_JLONG(0x69345d46f4f40e9c) },
	{ "java/net/URLStreamHandler",	_JC_JLONG(0xd7e769aebe17520e) },
	{ "javax/xml/transform/Source",	_JC_JLONG(0xf00134c65c375beb) },
	{ "javax/xml/transform/stream/StreamSource",	_JC_JLONG(0x6487f50fbc3e7405) },
	{ "javax/xml/validation/Schema",	_JC_JLONG(0x1ae5342d33750dd0) },
	{ "org/w3c/dom/ls/LSResourceResolver",	_JC_JLONG(0x6d4f4a198c2e3f1c) },
	{ "org/xml/sax/ErrorHandler",	_JC_JLONG(0xe5ec7637b0794311) },
	{ "org/xml/sax/SAXException",	_JC_JLONG(0xc045a3d7d4ce55f1) },
	{ "org/xml/sax/SAXNotRecognizedException",	_JC_JLONG(0x367865d8b307be5f) },
	{ "org/xml/sax/SAXNotSupportedException",	_JC_JLONG(0x6a215b87e89c25b9) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_javax_xml_validation_SchemaFactory$vtype _jc_javax_xml_validation_SchemaFactory$type = {
    .type= {
	.name=			"javax/xml/validation/SchemaFactory",
	.superclass=		&_jc_java_lang_Object$type,
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		25,
		.hash=			_JC_JLONG(0x2269e9f7e1e9bcc0),
		.source_file=		"SchemaFactory.java",
		.instance_size=		sizeof(_jc_javax_xml_validation_SchemaFactory$refs) + sizeof(_jc_javax_xml_validation_SchemaFactory$object),
		.num_virtual_refs=	1,
		.num_fields=		sizeof(_jc_javax_xml_validation_SchemaFactory$fields) / sizeof(*_jc_javax_xml_validation_SchemaFactory$fields),
		.fields=		_jc_javax_xml_validation_SchemaFactory$fields,
		.num_methods=		sizeof(_jc_javax_xml_validation_SchemaFactory$methods) / sizeof(*_jc_javax_xml_validation_SchemaFactory$methods),
		.methods=		_jc_javax_xml_validation_SchemaFactory$methods,
		.instanceof_hash_table=	_jc_javax_xml_validation_SchemaFactory$instanceof_hash_table,
		.num_class_depends=		sizeof(_jc_javax_xml_validation_SchemaFactory$class_depends) / sizeof(*_jc_javax_xml_validation_SchemaFactory$class_depends),
		.class_depends=		_jc_javax_xml_validation_SchemaFactory$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.javax_xml_validation_SchemaFactory= {
	    .getErrorHandler$8ed4b273998fa229=
		&_jc_javax_xml_validation_SchemaFactory$method$getErrorHandler$8ed4b273998fa229,
	    .getFeature$1f81e149fe4bca3b=
		&_jc_javax_xml_validation_SchemaFactory$method$getFeature$1f81e149fe4bca3b,
	    .getProperty$ad67146a826fdaf8=
		&_jc_javax_xml_validation_SchemaFactory$method$getProperty$ad67146a826fdaf8,
	    .getResourceResolver$367b0cf4cb257c85=
		&_jc_javax_xml_validation_SchemaFactory$method$getResourceResolver$367b0cf4cb257c85,
	    .isSchemaLanguageSupported$e6e721e54298b14a=
		&_jc_javax_xml_validation_SchemaFactory$method$isSchemaLanguageSupported$e6e721e54298b14a,
	    .newSchema$2cf1afb714f75fc9=
		&_jc_javax_xml_validation_SchemaFactory$method$newSchema$2cf1afb714f75fc9,
	    .newSchema$1fa2fea28ee153e2=
		&_jc_javax_xml_validation_SchemaFactory$method$newSchema$1fa2fea28ee153e2,
	    .newSchema$715c64e60866c835=
		&_jc_javax_xml_validation_SchemaFactory$method$newSchema$715c64e60866c835,
	    .newSchema$20c33329c3c98fc5=
		&_jc_javax_xml_validation_SchemaFactory$method$newSchema$20c33329c3c98fc5,
	    .newSchema$633e646920400264=
		&_jc_javax_xml_validation_SchemaFactory$method$newSchema$633e646920400264,
	    .setErrorHandler$ca242a9f880820cc=
		&_jc_javax_xml_validation_SchemaFactory$method$setErrorHandler$ca242a9f880820cc,
	    .setFeature$907897e626165cee=
		&_jc_javax_xml_validation_SchemaFactory$method$setFeature$907897e626165cee,
	    .setProperty$a4769aed759cc4ba=
		&_jc_javax_xml_validation_SchemaFactory$method$setProperty$a4769aed759cc4ba,
	    .setResourceResolver$6fff270aa30debdd=
		&_jc_javax_xml_validation_SchemaFactory$method$setResourceResolver$6fff270aa30debdd,
	},
    }
};

