// public abstract class polyglot.frontend.Job

// class file dependencies
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class 680cf34d05feb5a1 java_lang_IllegalArgumentException
// @dep_class ca631501391a31f1 java_lang_Integer
// @dep_class 9cd7252f79299280 java_lang_Number
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class 4f5534a987354d1d java_lang_RuntimeException
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 94d357637b968dda java_lang_StringBuffer
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class 8ea716c64b77f8eb java_util_AbstractCollection
// @dep_class f5238436362828db java_util_AbstractList
// @dep_class 58038509830ef3f4 java_util_ArrayList
// @dep_class d7cd853200c3e71f java_util_HashMap
// @dep_class 9ee0d92ce1525a4d java_util_List
// @dep_class e283f7c2e7a7979c java_util_Map
// @dep_class 1c402b4f9747e08 polyglot_ast_Node
// @dep_class e0a64384fd8897ef polyglot_frontend_BarrierPass
// @dep_class 3ea6f1cf85115422 polyglot_frontend_Compiler
// @dep_class fdbc32d4847269bf polyglot_frontend_ExtensionInfo
// @dep_class 42e687805b457724 polyglot_frontend_Job
// @dep_class e5d1de4e75576eba polyglot_frontend_JobExt
// @dep_class 82f7472f39b4803b polyglot_frontend_Pass
// @dep_class 3218faf4b567e7d9 polyglot_frontend_Pass__24ID
// @dep_class cd88b669bec8f787 polyglot_frontend_Source
// @dep_class 6b393ef3f88ef5d0 polyglot_frontend_SourceJob
// @dep_class a433cdcd788f6c37 polyglot_types_Context
// @dep_class bda7215170a25efc polyglot_util_CodeWriter
// @dep_class 22b321d488641c54 polyglot_util_InternalCompilerError
// @dep_class 32c9a088c5dac046 polyglot_util_Position

// header file dependencies
// @dep_header java_lang_Class
// @dep_header java_lang_IllegalArgumentException
// @dep_header java_lang_Integer
// @dep_header java_lang_String
// @dep_header java_lang_StringBuffer
// @dep_header java_lang_VMThrowable
// @dep_header java_util_ArrayList
// @dep_header java_util_HashMap
// @dep_header java_util_List
// @dep_header java_util_Map
// @dep_header polyglot_ast_Node
// @dep_header polyglot_frontend_BarrierPass
// @dep_header polyglot_frontend_Compiler
// @dep_header polyglot_frontend_ExtensionInfo
// @dep_header polyglot_frontend_JobExt
// @dep_header polyglot_frontend_Pass
// @dep_header polyglot_frontend_Pass__24ID
// @dep_header polyglot_frontend_Source
// @dep_header polyglot_frontend_SourceJob
// @dep_header polyglot_types_Context
// @dep_header polyglot_util_CodeWriter
// @dep_header polyglot_util_InternalCompilerError
// @dep_header polyglot_util_Position

#include "jc_defs.h"

#include "java/lang/Class.h"
#include "java/lang/IllegalArgumentException.h"
#include "java/lang/Integer.h"
#include "java/lang/String.h"
#include "java/lang/StringBuffer.h"
#include "java/lang/VMThrowable.h"
#include "java/util/ArrayList.h"
#include "java/util/HashMap.h"
#include "java/util/List.h"
#include "java/util/Map.h"
#include "polyglot/ast/Node.h"
#include "polyglot/frontend/BarrierPass.h"
#include "polyglot/frontend/Compiler.h"
#include "polyglot/frontend/ExtensionInfo.h"
#include "polyglot/frontend/JobExt.h"
#include "polyglot/frontend/Pass.h"
#include "polyglot/frontend/Pass__24ID.h"
#include "polyglot/frontend/Source.h"
#include "polyglot/frontend/SourceJob.h"
#include "polyglot/types/Context.h"
#include "polyglot/util/CodeWriter.h"
#include "polyglot/util/InternalCompilerError.h"
#include "polyglot/util/Position.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// protected polyglot.frontend.JobExt ext
static _jc_field _jc_polyglot_frontend_Job$field_info$ext = {
	.name=		"ext",
	.signature=	"Lpolyglot/frontend/JobExt;",
	.class=		&_jc_polyglot_frontend_Job$type,
	.type=		&_jc_polyglot_frontend_JobExt$type,
	.access_flags=	_JC_ACC_PROTECTED,
	.offset=	_JC_OFFSETOF(_jc_polyglot_frontend_Job$object, refs[-1].polyglot_frontend_Job.ext),
};

// protected polyglot.frontend.ExtensionInfo lang
static _jc_field _jc_polyglot_frontend_Job$field_info$lang = {
	.name=		"lang",
	.signature=	"Lpolyglot/frontend/ExtensionInfo;",
	.class=		&_jc_polyglot_frontend_Job$type,
	.type=		&_jc_polyglot_frontend_ExtensionInfo$type,
	.access_flags=	_JC_ACC_PROTECTED,
	.offset=	_JC_OFFSETOF(_jc_polyglot_frontend_Job$object, refs[-1].polyglot_frontend_Job.lang),
};

// protected polyglot.ast.Node ast
static _jc_field _jc_polyglot_frontend_Job$field_info$ast = {
	.name=		"ast",
	.signature=	"Lpolyglot/ast/Node;",
	.class=		&_jc_polyglot_frontend_Job$type,
	.type=		&_jc_polyglot_ast_Node$type,
	.access_flags=	_JC_ACC_PROTECTED,
	.offset=	_JC_OFFSETOF(_jc_polyglot_frontend_Job$object, refs[-1].polyglot_frontend_Job.ast),
};

// protected java.util.ArrayList passes
static _jc_field _jc_polyglot_frontend_Job$field_info$passes = {
	.name=		"passes",
	.signature=	"Ljava/util/ArrayList;",
	.class=		&_jc_polyglot_frontend_Job$type,
	.type=		&_jc_java_util_ArrayList$type,
	.access_flags=	_JC_ACC_PROTECTED,
	.offset=	_JC_OFFSETOF(_jc_polyglot_frontend_Job$object, refs[-1].polyglot_frontend_Job.passes),
};

// protected int nextPass
static _jc_field _jc_polyglot_frontend_Job$field_info$nextPass = {
	.name=		"nextPass",
	.signature=	"I",
	.class=		&_jc_polyglot_frontend_Job$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PROTECTED,
	.offset=	_JC_OFFSETOF(_jc_polyglot_frontend_Job$object, nonrefs.polyglot_frontend_Job.nextPass),
};

// protected boolean isRunning
static _jc_field _jc_polyglot_frontend_Job$field_info$isRunning = {
	.name=		"isRunning",
	.signature=	"Z",
	.class=		&_jc_polyglot_frontend_Job$type,
	.type=		&_jc_boolean$prim$type,
	.access_flags=	_JC_ACC_PROTECTED,
	.offset=	_JC_OFFSETOF(_jc_polyglot_frontend_Job$object, nonrefs.polyglot_frontend_Job.isRunning),
};

// protected boolean status
static _jc_field _jc_polyglot_frontend_Job$field_info$status = {
	.name=		"status",
	.signature=	"Z",
	.class=		&_jc_polyglot_frontend_Job$type,
	.type=		&_jc_boolean$prim$type,
	.access_flags=	_JC_ACC_PROTECTED,
	.offset=	_JC_OFFSETOF(_jc_polyglot_frontend_Job$object, nonrefs.polyglot_frontend_Job.status),
};

// protected java.util.Map passMap
static _jc_field _jc_polyglot_frontend_Job$field_info$passMap = {
	.name=		"passMap",
	.signature=	"Ljava/util/Map;",
	.class=		&_jc_polyglot_frontend_Job$type,
	.type=		&_jc_java_util_Map$type,
	.access_flags=	_JC_ACC_PROTECTED,
	.offset=	_JC_OFFSETOF(_jc_polyglot_frontend_Job$object, refs[-1].polyglot_frontend_Job.passMap),
};

// Fields
static _jc_field *const _jc_polyglot_frontend_Job$fields[] = {
	&_jc_polyglot_frontend_Job$field_info$ast,
	&_jc_polyglot_frontend_Job$field_info$ext,
	&_jc_polyglot_frontend_Job$field_info$lang,
	&_jc_polyglot_frontend_Job$field_info$passMap,
	&_jc_polyglot_frontend_Job$field_info$passes,
	&_jc_polyglot_frontend_Job$field_info$nextPass,
	&_jc_polyglot_frontend_Job$field_info$isRunning,
	&_jc_polyglot_frontend_Job$field_info$status
};

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// public void <init>(polyglot.frontend.ExtensionInfo, polyglot.frontend.JobExt, polyglot.ast.Node)
//

static _jc_linenum _jc_polyglot_frontend_Job$linenum_table$_init$d36ef28164fff869[];

static const unsigned char _jc_polyglot_frontend_Job$param_ptypes$_init$d36ef28164fff869[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_frontend_Job$param_types$_init$d36ef28164fff869[] = {
	&_jc_polyglot_frontend_ExtensionInfo$type,
	&_jc_polyglot_frontend_JobExt$type,
	&_jc_polyglot_ast_Node$type
};

_jc_method _jc_polyglot_frontend_Job$method_info$_init$d36ef28164fff869 = {
	.name=			"<init>",
	.signature=		"(Lpolyglot/frontend/ExtensionInfo;Lpolyglot/frontend/JobExt;Lpolyglot/ast/Node;)V",
	.class=			&_jc_polyglot_frontend_Job$type,
	.param_types=		&_jc_polyglot_frontend_Job$param_types$_init$d36ef28164fff869,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_frontend_Job$param_ptypes$_init$d36ef28164fff869,
	.signature_hash=	_JC_JLONG(0xd36ef28164fff869),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_frontend_Job$method$_init$d36ef28164fff869,
	.num_parameters=	3,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	9,
	      .table=	_jc_polyglot_frontend_Job$linenum_table$_init$d36ef28164fff869
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_frontend_Job, _init$d36ef28164fff869);

void _JC_JCNI_ATTR
_jc_polyglot_frontend_Job$method$_init$d36ef28164fff869(_jc_env *const env, _jc_polyglot_frontend_Job$object *this, _jc_object *param0, _jc_object *param1, _jc_object *param2)
{
	struct _jc_polyglot_frontend_Job$object *r0;
	struct _jc_object *r1;
	struct _jc_object *r2;
	struct _jc_object *r3;

	r0 = this;
	r1 = param0;
	r2 = param1;
	r3 = param2;
	_JC_LINE_NUMBER(43);				// 0
	_JC_REF_FIELD(env, r0, polyglot_frontend_Job, lang) = r1;
	_JC_LINE_NUMBER(44);				// 1
	_JC_REF_FIELD(env, r0, polyglot_frontend_Job, ext) = r2;
	_JC_LINE_NUMBER(45);				// 2
	_JC_REF_FIELD(env, r0, polyglot_frontend_Job, ast) = r3;
	_JC_LINE_NUMBER(47);				// 3
	_JC_REF_FIELD(env, r0, polyglot_frontend_Job, passes) = _JC_NULL;
	_JC_LINE_NUMBER(48);				// 4
	_JC_REF_FIELD(env, r0, polyglot_frontend_Job, passMap) = _JC_NULL;
	_JC_LINE_NUMBER(49);				// 5
	_JC_PRIM_FIELD(env, r0, polyglot_frontend_Job, nextPass) = 0;
	_JC_LINE_NUMBER(50);				// 6
	_JC_PRIM_FIELD(env, r0, polyglot_frontend_Job, isRunning) = 0;
	_JC_LINE_NUMBER(51);				// 7
	_JC_PRIM_FIELD(env, r0, polyglot_frontend_Job, status) = 1;
	_JC_LINE_NUMBER(52);				// 8
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public polyglot.ast.Node ast()
//

static _jc_linenum _jc_polyglot_frontend_Job$linenum_table$ast$e418a55a83097dd0[];

static const unsigned char _jc_polyglot_frontend_Job$param_ptypes$ast$e418a55a83097dd0[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_frontend_Job$method_info$ast$e418a55a83097dd0 = {
	.name=			"ast",
	.signature=		"()Lpolyglot/ast/Node;",
	.class=			&_jc_polyglot_frontend_Job$type,
	.return_type=		&_jc_polyglot_ast_Node$type,
	.param_ptypes=		&_jc_polyglot_frontend_Job$param_ptypes$ast$e418a55a83097dd0,
	.signature_hash=	_JC_JLONG(0xe418a55a83097dd0),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_frontend_Job$method$ast$e418a55a83097dd0,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_frontend_Job$vtable, polyglot_frontend_Job.ast$e418a55a83097dd0) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_frontend_Job$linenum_table$ast$e418a55a83097dd0
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_frontend_Job, ast$e418a55a83097dd0);

_jc_object * _JC_JCNI_ATTR
_jc_polyglot_frontend_Job$method$ast$e418a55a83097dd0(_jc_env *const env, _jc_polyglot_frontend_Job$object *this)
{
	struct _jc_polyglot_frontend_Job$object *r0;
	struct _jc_object *r1;

	r0 = this;
	_JC_LINE_NUMBER(85);				// 0
	r1 = _JC_REF_FIELD(env, r0, polyglot_frontend_Job, ast);
	return r1;
}

//
// public void ast(polyglot.ast.Node)
//

static _jc_linenum _jc_polyglot_frontend_Job$linenum_table$ast$e24c452e7703a64f[];

static const unsigned char _jc_polyglot_frontend_Job$param_ptypes$ast$e24c452e7703a64f[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_frontend_Job$param_types$ast$e24c452e7703a64f[] = {
	&_jc_polyglot_ast_Node$type
};

_jc_method _jc_polyglot_frontend_Job$method_info$ast$e24c452e7703a64f = {
	.name=			"ast",
	.signature=		"(Lpolyglot/ast/Node;)V",
	.class=			&_jc_polyglot_frontend_Job$type,
	.param_types=		&_jc_polyglot_frontend_Job$param_types$ast$e24c452e7703a64f,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_frontend_Job$param_ptypes$ast$e24c452e7703a64f,
	.signature_hash=	_JC_JLONG(0xe24c452e7703a64f),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_frontend_Job$method$ast$e24c452e7703a64f,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_frontend_Job$vtable, polyglot_frontend_Job.ast$e24c452e7703a64f) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_polyglot_frontend_Job$linenum_table$ast$e24c452e7703a64f
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_frontend_Job, ast$e24c452e7703a64f);

void _JC_JCNI_ATTR
_jc_polyglot_frontend_Job$method$ast$e24c452e7703a64f(_jc_env *const env, _jc_polyglot_frontend_Job$object *this, _jc_object *param0)
{
	struct _jc_polyglot_frontend_Job$object *r0;
	struct _jc_object *r1;

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(90);				// 0
	_JC_REF_FIELD(env, r0, polyglot_frontend_Job, ast) = r1;
	_JC_LINE_NUMBER(91);				// 1
	return;
}

//
// public polyglot.frontend.Compiler compiler()
//

static _jc_linenum _jc_polyglot_frontend_Job$linenum_table$compiler$a83a951e175ae03a[];

static const unsigned char _jc_polyglot_frontend_Job$param_ptypes$compiler$a83a951e175ae03a[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_frontend_Job$method_info$compiler$a83a951e175ae03a = {
	.name=			"compiler",
	.signature=		"()Lpolyglot/frontend/Compiler;",
	.class=			&_jc_polyglot_frontend_Job$type,
	.return_type=		&_jc_polyglot_frontend_Compiler$type,
	.param_ptypes=		&_jc_polyglot_frontend_Job$param_ptypes$compiler$a83a951e175ae03a,
	.signature_hash=	_JC_JLONG(0xa83a951e175ae03a),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_frontend_Job$method$compiler$a83a951e175ae03a,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_frontend_Job$vtable, polyglot_frontend_Job.compiler$a83a951e175ae03a) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_frontend_Job$linenum_table$compiler$a83a951e175ae03a
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_frontend_Job, compiler$a83a951e175ae03a);

_jc_polyglot_frontend_Compiler$object * _JC_JCNI_ATTR
_jc_polyglot_frontend_Job$method$compiler$a83a951e175ae03a(_jc_env *const env, _jc_polyglot_frontend_Job$object *this)
{
	struct _jc_polyglot_frontend_Job$object *r0;
	struct _jc_object *r1;
	struct _jc_polyglot_frontend_Compiler$object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(286);				// 0
	r1 = _JC_REF_FIELD(env, r0, polyglot_frontend_Job, lang);
	r2 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0xa83a951e175ae03a), _jc_object *, (_jc_env *, struct _jc_object *));
	return r2;
}

//
// public boolean completed()
//

static _jc_linenum _jc_polyglot_frontend_Job$linenum_table$completed$0cd53b1aa4c5889f[];

static const unsigned char _jc_polyglot_frontend_Job$param_ptypes$completed$0cd53b1aa4c5889f[] = { 
_JC_TYPE_BOOLEAN };

_jc_method _jc_polyglot_frontend_Job$method_info$completed$0cd53b1aa4c5889f = {
	.name=			"completed",
	.signature=		"()Z",
	.class=			&_jc_polyglot_frontend_Job$type,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_polyglot_frontend_Job$param_ptypes$completed$0cd53b1aa4c5889f,
	.signature_hash=	_JC_JLONG(0xcd53b1aa4c5889f),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_frontend_Job$method$completed$0cd53b1aa4c5889f,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_frontend_Job$vtable, polyglot_frontend_Job.completed$0cd53b1aa4c5889f) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_frontend_Job$linenum_table$completed$0cd53b1aa4c5889f
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_frontend_Job, completed$0cd53b1aa4c5889f);

jboolean _JC_JCNI_ATTR
_jc_polyglot_frontend_Job$method$completed$0cd53b1aa4c5889f(_jc_env *const env, _jc_polyglot_frontend_Job$object *this)
{
	struct _jc_polyglot_frontend_Job$object *r0;
	struct _jc_object *r1;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(168);				// 0
	r1 = _JC_INVOKE_VIRTUAL(env, polyglot_frontend_Job, pendingPasses$a0468f4ba2edfb82, r0);
	z0 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0x551bea84f4e0f0cb), jboolean, (_jc_env *, struct _jc_object *));
	return z0;
}

//
// public boolean completed(polyglot.frontend.Pass$ID)
//

static _jc_linenum _jc_polyglot_frontend_Job$linenum_table$completed$d55c401dfbe7e859[];

static const unsigned char _jc_polyglot_frontend_Job$param_ptypes$completed$d55c401dfbe7e859[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_polyglot_frontend_Job$param_types$completed$d55c401dfbe7e859[] = {
	&_jc_polyglot_frontend_Pass__24ID$type
};

_jc_method _jc_polyglot_frontend_Job$method_info$completed$d55c401dfbe7e859 = {
	.name=			"completed",
	.signature=		"(Lpolyglot/frontend/Pass$ID;)Z",
	.class=			&_jc_polyglot_frontend_Job$type,
	.param_types=		&_jc_polyglot_frontend_Job$param_types$completed$d55c401dfbe7e859,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_polyglot_frontend_Job$param_ptypes$completed$d55c401dfbe7e859,
	.signature_hash=	_JC_JLONG(0xd55c401dfbe7e859),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_frontend_Job$method$completed$d55c401dfbe7e859,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_frontend_Job$vtable, polyglot_frontend_Job.completed$d55c401dfbe7e859) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_polyglot_frontend_Job$linenum_table$completed$d55c401dfbe7e859
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_frontend_Job, completed$d55c401dfbe7e859);

jboolean _JC_JCNI_ATTR
_jc_polyglot_frontend_Job$method$completed$d55c401dfbe7e859(_jc_env *const env, _jc_polyglot_frontend_Job$object *this, _jc_polyglot_frontend_Pass__24ID$object *param0)
{
	jint i0;
	jint i1;
	struct _jc_polyglot_frontend_Job$object *r0;
	struct _jc_polyglot_frontend_Pass__24ID$object *r1;
	struct _jc_java_lang_Integer$object *r2;
	struct _jc_java_lang_Object$object *r4;
	struct _jc_object *r6;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r6 = _JC_REF_FIELD(env, r0, polyglot_frontend_Job, passMap);
	if (r6 != _JC_NULL)
		goto label0;
	_JC_INVOKE_VIRTUAL(env, polyglot_frontend_Job, init$d82f2cc8ccf1c754, r0);

label0:
	r6 = _JC_REF_FIELD(env, r0, polyglot_frontend_Job, passMap);
	_JC_LINE_NUMBER(195);				// 0
	r4 = _JC_INVOKE_INTERFACE(env, r6, _JC_JLONG(0xb30461fc5ea13399), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r1);
	r2 = _JC_CAST_FINAL(env, &_jc_java_lang_Integer$type, r4);
	_JC_LINE_NUMBER(196);				// 1
	if (r2 == _JC_NULL)
		goto label1;
	i1 = _JC_PRIM_FIELD(env, r2, java_lang_Integer, value);
	i0 = _JC_PRIM_FIELD(env, r0, polyglot_frontend_Job, nextPass);
	if (i1 >= i0)
		goto label1;
	z0 = 1;
	goto label2;

label1:
	z0 = 0;

label2:
	return z0;
}

//
// public java.util.List completedPasses()
//

static _jc_linenum _jc_polyglot_frontend_Job$linenum_table$completedPasses$3c8fd81612bf41f0[];

static const unsigned char _jc_polyglot_frontend_Job$param_ptypes$completedPasses$3c8fd81612bf41f0[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_frontend_Job$method_info$completedPasses$3c8fd81612bf41f0 = {
	.name=			"completedPasses",
	.signature=		"()Ljava/util/List;",
	.class=			&_jc_polyglot_frontend_Job$type,
	.return_type=		&_jc_java_util_List$type,
	.param_ptypes=		&_jc_polyglot_frontend_Job$param_ptypes$completedPasses$3c8fd81612bf41f0,
	.signature_hash=	_JC_JLONG(0x3c8fd81612bf41f0),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_frontend_Job$method$completedPasses$3c8fd81612bf41f0,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_frontend_Job$vtable, polyglot_frontend_Job.completedPasses$3c8fd81612bf41f0) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_frontend_Job$linenum_table$completedPasses$3c8fd81612bf41f0
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_frontend_Job, completedPasses$3c8fd81612bf41f0);

_jc_object * _JC_JCNI_ATTR
_jc_polyglot_frontend_Job$method$completedPasses$3c8fd81612bf41f0(_jc_env *const env, _jc_polyglot_frontend_Job$object *this)
{
	jint i0;
	struct _jc_polyglot_frontend_Job$object *r0;
	struct _jc_object *r1;
	struct _jc_java_util_ArrayList$object *r3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r3 = _JC_REF_FIELD(env, r0, polyglot_frontend_Job, passes);
	if (r3 != _JC_NULL)
		goto label0;
	_JC_INVOKE_VIRTUAL(env, polyglot_frontend_Job, init$d82f2cc8ccf1c754, r0);

label0:
	r3 = _JC_REF_FIELD(env, r0, polyglot_frontend_Job, passes);
	_JC_LINE_NUMBER(178);				// 0
	i0 = _JC_PRIM_FIELD(env, r0, polyglot_frontend_Job, nextPass);
	r1 = _JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0xaf8e3c69195dae35), _jc_object *, (_jc_env *, struct _jc_object *, jint, jint), 0, i0);
	return r1;
}

//
// public polyglot.types.Context context()
//

static _jc_linenum _jc_polyglot_frontend_Job$linenum_table$context$4c5ebe4f0ff1c15f[];

static const unsigned char _jc_polyglot_frontend_Job$param_ptypes$context$4c5ebe4f0ff1c15f[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_frontend_Job$method_info$context$4c5ebe4f0ff1c15f = {
	.name=			"context",
	.signature=		"()Lpolyglot/types/Context;",
	.class=			&_jc_polyglot_frontend_Job$type,
	.return_type=		&_jc_polyglot_types_Context$type,
	.param_ptypes=		&_jc_polyglot_frontend_Job$param_ptypes$context$4c5ebe4f0ff1c15f,
	.signature_hash=	_JC_JLONG(0x4c5ebe4f0ff1c15f),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_frontend_Job$method$context$4c5ebe4f0ff1c15f,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_frontend_Job$vtable, polyglot_frontend_Job.context$4c5ebe4f0ff1c15f) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_frontend_Job$linenum_table$context$4c5ebe4f0ff1c15f
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_frontend_Job, context$4c5ebe4f0ff1c15f);

_jc_object * _JC_JCNI_ATTR
_jc_polyglot_frontend_Job$method$context$4c5ebe4f0ff1c15f(_jc_env *const env, _jc_polyglot_frontend_Job$object *this)
{
	struct _jc_polyglot_frontend_Job$object *r0;

	r0 = this;
	_JC_LINE_NUMBER(104);				// 0
	return _JC_NULL;
}

//
// public void dump(polyglot.util.CodeWriter)
//

static _jc_linenum _jc_polyglot_frontend_Job$linenum_table$dump$30efa1ff09c02470[];

static const unsigned char _jc_polyglot_frontend_Job$param_ptypes$dump$30efa1ff09c02470[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_frontend_Job$param_types$dump$30efa1ff09c02470[] = {
	&_jc_polyglot_util_CodeWriter$type
};

_jc_method _jc_polyglot_frontend_Job$method_info$dump$30efa1ff09c02470 = {
	.name=			"dump",
	.signature=		"(Lpolyglot/util/CodeWriter;)V",
	.class=			&_jc_polyglot_frontend_Job$type,
	.param_types=		&_jc_polyglot_frontend_Job$param_types$dump$30efa1ff09c02470,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_frontend_Job$param_ptypes$dump$30efa1ff09c02470,
	.signature_hash=	_JC_JLONG(0x30efa1ff09c02470),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_frontend_Job$method$dump$30efa1ff09c02470,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_frontend_Job$vtable, polyglot_frontend_Job.dump$30efa1ff09c02470) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_polyglot_frontend_Job$linenum_table$dump$30efa1ff09c02470
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_frontend_Job, dump$30efa1ff09c02470);

void _JC_JCNI_ATTR
_jc_polyglot_frontend_Job$method$dump$30efa1ff09c02470(_jc_env *const env, _jc_polyglot_frontend_Job$object *this, _jc_polyglot_util_CodeWriter$object *param0)
{
	struct _jc_polyglot_frontend_Job$object *r0;
	struct _jc_polyglot_util_CodeWriter$object *r1;
	struct _jc_object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(94);				// 0
	r2 = _JC_REF_FIELD(env, r0, polyglot_frontend_Job, ast);
	if (r2 == _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(95);				// 1
	r2 = _JC_REF_FIELD(env, r0, polyglot_frontend_Job, ast);
	_JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0x30efa1ff09c02470), void, (_jc_env *, struct _jc_object *, struct _jc_polyglot_util_CodeWriter$object *), r1);

label0:
	_JC_LINE_NUMBER(97);				// 2
	return;
}

//
// public polyglot.frontend.JobExt ext()
//

static _jc_linenum _jc_polyglot_frontend_Job$linenum_table$ext$98b499814cc8ad11[];

static const unsigned char _jc_polyglot_frontend_Job$param_ptypes$ext$98b499814cc8ad11[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_frontend_Job$method_info$ext$98b499814cc8ad11 = {
	.name=			"ext",
	.signature=		"()Lpolyglot/frontend/JobExt;",
	.class=			&_jc_polyglot_frontend_Job$type,
	.return_type=		&_jc_polyglot_frontend_JobExt$type,
	.param_ptypes=		&_jc_polyglot_frontend_Job$param_ptypes$ext$98b499814cc8ad11,
	.signature_hash=	_JC_JLONG(0x98b499814cc8ad11),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_frontend_Job$method$ext$98b499814cc8ad11,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_frontend_Job$vtable, polyglot_frontend_Job.ext$98b499814cc8ad11) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_frontend_Job$linenum_table$ext$98b499814cc8ad11
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_frontend_Job, ext$98b499814cc8ad11);

_jc_object * _JC_JCNI_ATTR
_jc_polyglot_frontend_Job$method$ext$98b499814cc8ad11(_jc_env *const env, _jc_polyglot_frontend_Job$object *this)
{
	struct _jc_polyglot_frontend_Job$object *r0;
	struct _jc_object *r1;

	r0 = this;
	_JC_LINE_NUMBER(55);				// 0
	r1 = _JC_REF_FIELD(env, r0, polyglot_frontend_Job, ext);
	return r1;
}

//
// public polyglot.frontend.ExtensionInfo extensionInfo()
//

static _jc_linenum _jc_polyglot_frontend_Job$linenum_table$extensionInfo$b7bb1008805e481e[];

static const unsigned char _jc_polyglot_frontend_Job$param_ptypes$extensionInfo$b7bb1008805e481e[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_frontend_Job$method_info$extensionInfo$b7bb1008805e481e = {
	.name=			"extensionInfo",
	.signature=		"()Lpolyglot/frontend/ExtensionInfo;",
	.class=			&_jc_polyglot_frontend_Job$type,
	.return_type=		&_jc_polyglot_frontend_ExtensionInfo$type,
	.param_ptypes=		&_jc_polyglot_frontend_Job$param_ptypes$extensionInfo$b7bb1008805e481e,
	.signature_hash=	_JC_JLONG(0xb7bb1008805e481e),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_frontend_Job$method$extensionInfo$b7bb1008805e481e,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_frontend_Job$vtable, polyglot_frontend_Job.extensionInfo$b7bb1008805e481e) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_frontend_Job$linenum_table$extensionInfo$b7bb1008805e481e
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_frontend_Job, extensionInfo$b7bb1008805e481e);

_jc_object * _JC_JCNI_ATTR
_jc_polyglot_frontend_Job$method$extensionInfo$b7bb1008805e481e(_jc_env *const env, _jc_polyglot_frontend_Job$object *this)
{
	struct _jc_polyglot_frontend_Job$object *r0;
	struct _jc_object *r1;

	r0 = this;
	_JC_LINE_NUMBER(282);				// 0
	r1 = _JC_REF_FIELD(env, r0, polyglot_frontend_Job, lang);
	return r1;
}

//
// public void finishPass(polyglot.frontend.Pass, boolean)
//

static _jc_linenum _jc_polyglot_frontend_Job$linenum_table$finishPass$6e35714761d5fd2b[];

static const unsigned char _jc_polyglot_frontend_Job$param_ptypes$finishPass$6e35714761d5fd2b[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_frontend_Job$param_types$finishPass$6e35714761d5fd2b[] = {
	&_jc_polyglot_frontend_Pass$type,
	&_jc_boolean$prim$type
};

_jc_method _jc_polyglot_frontend_Job$method_info$finishPass$6e35714761d5fd2b = {
	.name=			"finishPass",
	.signature=		"(Lpolyglot/frontend/Pass;Z)V",
	.class=			&_jc_polyglot_frontend_Job$type,
	.param_types=		&_jc_polyglot_frontend_Job$param_types$finishPass$6e35714761d5fd2b,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_frontend_Job$param_ptypes$finishPass$6e35714761d5fd2b,
	.signature_hash=	_JC_JLONG(0x6e35714761d5fd2b),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_frontend_Job$method$finishPass$6e35714761d5fd2b,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_frontend_Job$vtable, polyglot_frontend_Job.finishPass$6e35714761d5fd2b) / sizeof(void *),
	.num_parameters=	2,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	8,
	      .table=	_jc_polyglot_frontend_Job$linenum_table$finishPass$6e35714761d5fd2b
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_frontend_Job, finishPass$6e35714761d5fd2b);

void _JC_JCNI_ATTR
_jc_polyglot_frontend_Job$method$finishPass$6e35714761d5fd2b(_jc_env *const env, _jc_polyglot_frontend_Job$object *this, _jc_object *param0, jboolean param1)
{
	jint i0;
	jint i1;
	struct _jc_polyglot_frontend_Job$object *r0;
	struct _jc_object *r1;
	struct _jc_java_lang_VMThrowable$object *r10;
	struct _jc_java_util_ArrayList$object *r11;
	struct _jc_java_lang_StringBuffer$object *r12;
	struct _jc_java_lang_String$object *r14;
	struct _jc_object *r2;
	struct _jc_object *r3;
	struct _jc_java_lang_Object$object *r4;
	struct _jc_polyglot_util_InternalCompilerError$object *r5;
	struct _jc_java_lang_StringBuffer$object *r6;
	struct _jc_java_lang_String$object *r7;
	struct _jc_polyglot_util_Position$object *r8;
	_jc_char_array *r9;
	jboolean z0;
	jboolean z1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	z0 = param1;
	r11 = _JC_REF_FIELD(env, r0, polyglot_frontend_Job, passes);
	if (r11 != _JC_NULL)
		goto label0;
	_JC_INVOKE_VIRTUAL(env, polyglot_frontend_Job, init$d82f2cc8ccf1c754, r0);

label0:
	r11 = _JC_REF_FIELD(env, r0, polyglot_frontend_Job, passes);
	r2 = r11;
	_JC_LINE_NUMBER(266);				// 0
	z1 = _JC_PRIM_FIELD(env, r0, polyglot_frontend_Job, status);
	z1 = z1 & z0;
	_JC_PRIM_FIELD(env, r0, polyglot_frontend_Job, status) = z1;
	_JC_LINE_NUMBER(268);				// 1
	i0 = _JC_PRIM_FIELD(env, r0, polyglot_frontend_Job, nextPass);

label1:
	i1 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0x345df5220fc60ade), jint, (_jc_env *, struct _jc_object *));
	if (i0 >= i1)
		goto label3;
	_JC_LINE_NUMBER(269);				// 2
	r4 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0xa706240e1333824b), _jc_object *, (_jc_env *, struct _jc_object *, jint), i0);
	r3 = _JC_CAST(env, &_jc_polyglot_frontend_Pass$type, r4);
	_JC_LINE_NUMBER(271);				// 3
	if (r3 != r1)
		goto label2;
	_JC_LINE_NUMBER(272);				// 4
	i1 = i0 + 1;
	_JC_PRIM_FIELD(env, r0, polyglot_frontend_Job, nextPass) = i1;
	_JC_LINE_NUMBER(273);				// 5
	return;

label2:
	_JC_LINE_NUMBER(268);				// 6
	i0 = i0 + 1;
	_JC_PERIODIC_CHECK(env);
	goto label1;

label3:
	_JC_LINE_NUMBER(277);				// 7
	r5 = _JC_NEW(env, polyglot_util_InternalCompilerError);
	r6 = _JC_NEW(env, java_lang_StringBuffer);
	r9 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r6, java_lang_StringBuffer, value) = r9;
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r6, _JC_STRING(env, "Pass "));
	r12 = r6;
	if (r1 != _JC_NULL)
		goto label4;
	r14 = _JC_STRING(env, "null");
	goto label5;

label4:
	r14 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, toString$7ea43b33b80a3070, r1);

label5:
	r12 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r12, r14);
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r12, _JC_STRING(env, " was not a pending "));
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 1, r6, _JC_STRING(env, "pass."));
	r7 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r7, r6);
	r8 = _JC_NULL;
	_JC_REF_FIELD(env, r5, java_lang_Throwable, cause) = r5;
	r10 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r5);
	_JC_REF_FIELD(env, r5, java_lang_Throwable, vmState) = r10;
	_JC_REF_FIELD(env, r5, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r5, java_lang_Throwable, detailMessage) = r7;
	_JC_REF_FIELD(env, r5, polyglot_util_InternalCompilerError, pos) = r8;
	_JC_THROW(env, r5);
}

//
// protected abstract java.util.List getPasses()
//

static const unsigned char _jc_polyglot_frontend_Job$param_ptypes$getPasses$e5b4184d264aa29f[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_frontend_Job$method_info$getPasses$e5b4184d264aa29f = {
	.name=			"getPasses",
	.signature=		"()Ljava/util/List;",
	.class=			&_jc_polyglot_frontend_Job$type,
	.return_type=		&_jc_java_util_List$type,
	.param_ptypes=		&_jc_polyglot_frontend_Job$param_ptypes$getPasses$e5b4184d264aa29f,
	.signature_hash=	_JC_JLONG(0xe5b4184d264aa29f),
	.access_flags=		_JC_ACC_PROTECTED|_JC_ACC_ABSTRACT,
	.function=		&_jc_polyglot_frontend_Job$method$getPasses$e5b4184d264aa29f,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_frontend_Job$vtable, polyglot_frontend_Job.getPasses$e5b4184d264aa29f) / sizeof(void *),
	.num_parameters=	0,
};

_jc_object * _JC_JCNI_ATTR
_jc_polyglot_frontend_Job$method$getPasses$e5b4184d264aa29f(_jc_env *const env, _jc_polyglot_frontend_Job$object *this)
{
	_JC_ABSTRACT_METHOD(env, &_jc_polyglot_frontend_Job$method_info$getPasses$e5b4184d264aa29f);
}

//
// public polyglot.frontend.Pass getPreviousTo(polyglot.frontend.Pass$ID)
//

static _jc_linenum _jc_polyglot_frontend_Job$linenum_table$getPreviousTo$d03a68acce5eb8ad[];

static const unsigned char _jc_polyglot_frontend_Job$param_ptypes$getPreviousTo$d03a68acce5eb8ad[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_frontend_Job$param_types$getPreviousTo$d03a68acce5eb8ad[] = {
	&_jc_polyglot_frontend_Pass__24ID$type
};

_jc_method _jc_polyglot_frontend_Job$method_info$getPreviousTo$d03a68acce5eb8ad = {
	.name=			"getPreviousTo",
	.signature=		"(Lpolyglot/frontend/Pass$ID;)Lpolyglot/frontend/Pass;",
	.class=			&_jc_polyglot_frontend_Job$type,
	.param_types=		&_jc_polyglot_frontend_Job$param_types$getPreviousTo$d03a68acce5eb8ad,
	.return_type=		&_jc_polyglot_frontend_Pass$type,
	.param_ptypes=		&_jc_polyglot_frontend_Job$param_ptypes$getPreviousTo$d03a68acce5eb8ad,
	.signature_hash=	_JC_JLONG(0xd03a68acce5eb8ad),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_frontend_Job$method$getPreviousTo$d03a68acce5eb8ad,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_frontend_Job$vtable, polyglot_frontend_Job.getPreviousTo$d03a68acce5eb8ad) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	6,
	      .table=	_jc_polyglot_frontend_Job$linenum_table$getPreviousTo$d03a68acce5eb8ad
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_frontend_Job, getPreviousTo$d03a68acce5eb8ad);

_jc_object * _JC_JCNI_ATTR
_jc_polyglot_frontend_Job$method$getPreviousTo$d03a68acce5eb8ad(_jc_env *const env, _jc_polyglot_frontend_Job$object *this, _jc_polyglot_frontend_Pass__24ID$object *param0)
{
	jint i0;
	jint i1;
	jint i2;
	struct _jc_polyglot_frontend_Job$object *r0;
	struct _jc_polyglot_frontend_Pass__24ID$object *r1;
	struct _jc_java_lang_VMThrowable$object *r10;
	struct _jc_object *r11;
	struct _jc_java_util_ArrayList$object *r12;
	struct _jc_java_lang_StringBuffer$object *r13;
	struct _jc_java_lang_String$object *r15;
	struct _jc_java_lang_Integer$object *r2;
	struct _jc_java_lang_Object$object *r3;
	struct _jc_object *r4;
	struct _jc_polyglot_util_InternalCompilerError$object *r5;
	struct _jc_java_lang_StringBuffer$object *r6;
	struct _jc_java_lang_String$object *r7;
	struct _jc_polyglot_util_Position$object *r8;
	_jc_char_array *r9;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r11 = _JC_REF_FIELD(env, r0, polyglot_frontend_Job, passMap);
	if (r11 != _JC_NULL)
		goto label0;
	_JC_INVOKE_VIRTUAL(env, polyglot_frontend_Job, init$d82f2cc8ccf1c754, r0);

label0:
	r11 = _JC_REF_FIELD(env, r0, polyglot_frontend_Job, passMap);
	_JC_LINE_NUMBER(225);				// 0
	r3 = _JC_INVOKE_INTERFACE(env, r11, _JC_JLONG(0xb30461fc5ea13399), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r1);
	r2 = _JC_CAST_FINAL(env, &_jc_java_lang_Integer$type, r3);
	_JC_LINE_NUMBER(227);				// 1
	if (r2 == _JC_NULL)
		goto label3;
	i1 = _JC_PRIM_FIELD(env, r2, java_lang_Integer, value);
	_JC_LINE_NUMBER(228);				// 2
	if (i1 != 0)
		goto label1;
	_JC_LINE_NUMBER(229);				// 3
	return _JC_NULL;

label1:
	r12 = _JC_REF_FIELD(env, r0, polyglot_frontend_Job, passes);
	if (r12 != _JC_NULL)
		goto label2;
	_JC_INVOKE_VIRTUAL(env, polyglot_frontend_Job, init$d82f2cc8ccf1c754, r0);

label2:
	r12 = _JC_REF_FIELD(env, r0, polyglot_frontend_Job, passes);
	i2 = _JC_PRIM_FIELD(env, r2, java_lang_Integer, value);
	_JC_LINE_NUMBER(230);				// 4
	i0 = i2 - 1;
	r3 = _JC_INVOKE_INTERFACE(env, r12, _JC_JLONG(0xa706240e1333824b), _jc_object *, (_jc_env *, struct _jc_object *, jint), i0);
	r4 = _JC_CAST(env, &_jc_polyglot_frontend_Pass$type, r3);
	return r4;

label3:
	_JC_LINE_NUMBER(233);				// 5
	r5 = _JC_NEW(env, polyglot_util_InternalCompilerError);
	r6 = _JC_NEW(env, java_lang_StringBuffer);
	r9 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r6, java_lang_StringBuffer, value) = r9;
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r6, _JC_STRING(env, "No pass named \""));
	r13 = r6;
	if (r1 != _JC_NULL)
		goto label4;
	r15 = _JC_STRING(env, "null");
	goto label5;

label4:
	r15 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, toString$7ea43b33b80a3070, r1);

label5:
	r13 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r13, r15);
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r13, _JC_STRING(env, "\"."));
	_JC_EXPLICIT_NULL_CHECK(env, r6);
	r7 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r7, r6);
	r8 = _JC_NULL;
	_JC_REF_FIELD(env, r5, java_lang_Throwable, cause) = r5;
	r10 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r5);
	_JC_REF_FIELD(env, r5, java_lang_Throwable, vmState) = r10;
	_JC_REF_FIELD(env, r5, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r5, java_lang_Throwable, detailMessage) = r7;
	_JC_REF_FIELD(env, r5, polyglot_util_InternalCompilerError, pos) = r8;
	_JC_THROW(env, r5);
}

//
// protected void init()
//

static _jc_linenum _jc_polyglot_frontend_Job$linenum_table$init$d82f2cc8ccf1c754[];

static const unsigned char _jc_polyglot_frontend_Job$param_ptypes$init$d82f2cc8ccf1c754[] = { 
_JC_TYPE_VOID };

_jc_method _jc_polyglot_frontend_Job$method_info$init$d82f2cc8ccf1c754 = {
	.name=			"init",
	.signature=		"()V",
	.class=			&_jc_polyglot_frontend_Job$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_frontend_Job$param_ptypes$init$d82f2cc8ccf1c754,
	.signature_hash=	_JC_JLONG(0xd82f2cc8ccf1c754),
	.access_flags=		_JC_ACC_PROTECTED,
	.function=		&_jc_polyglot_frontend_Job$method$init$d82f2cc8ccf1c754,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_frontend_Job$vtable, polyglot_frontend_Job.init$d82f2cc8ccf1c754) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	7,
	      .table=	_jc_polyglot_frontend_Job$linenum_table$init$d82f2cc8ccf1c754
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_frontend_Job, init$d82f2cc8ccf1c754);

void _JC_JCNI_ATTR
_jc_polyglot_frontend_Job$method$init$d82f2cc8ccf1c754(_jc_env *const env, _jc_polyglot_frontend_Job$object *this)
{
	jfloat f0;
	jint i0;
	jint i1;
	jint i2;
	jint i3;
	struct _jc_polyglot_frontend_Job$object *r0;
	struct _jc_java_util_ArrayList$object *r1;
	_jc_object_array *r10;
	struct _jc_java_lang_String$object *r11;
	struct _jc_java_lang_VMThrowable$object *r13;
	struct _jc_object *r2;
	struct _jc_object *r3;
	struct _jc_java_util_HashMap$object *r4;
	struct _jc_java_lang_Object$object *r5;
	struct _jc_object *r6;
	struct _jc_polyglot_frontend_Pass__24ID$object *r7;
	struct _jc_java_lang_Integer$object *r8;
	struct _jc_java_lang_IllegalArgumentException$object *r9;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(156);				// 0
	r1 = _JC_NEW(env, java_util_ArrayList);
	r3 = _JC_INVOKE_VIRTUAL(env, polyglot_frontend_Job, getPasses$e5b4184d264aa29f, r0);
	i2 = _JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0x345df5220fc60ade), jint, (_jc_env *, struct _jc_object *));
	f0 = (jfloat)i2;
	f0 = f0 * _JC_FCONST(0x3f, 0x8c, 0xcc, 0xcd);
	i2 = _JC_CAST_FLT2INT(env, jfloat, jint, f0);
	if (i2 >= 0)
		goto label0;
	r9 = _JC_NEW(env, java_lang_IllegalArgumentException);
	r11 = _JC_NULL;
	_JC_REF_FIELD(env, r9, java_lang_Throwable, cause) = r9;
	r13 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r9);
	_JC_REF_FIELD(env, r9, java_lang_Throwable, vmState) = r13;
	_JC_REF_FIELD(env, r9, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r9, java_lang_Throwable, detailMessage) = r11;
	_JC_THROW(env, r9);

label0:
	r10 = _JC_NEW_REF_ARRAY(env, java_lang_Object, 1, i2);
	_JC_REF_FIELD(env, r1, java_util_ArrayList, data) = r10;
	i3 = _JC_PRIM_FIELD(env, r1, java_util_ArrayList, size);
	_JC_INVOKE_NONVIRTUAL(env, java_util_ArrayList, addAll$28b94b9c09be8eeb, 0, r1, i3, r3);
	_JC_REF_FIELD(env, r0, polyglot_frontend_Job, passes) = r1;
	_JC_LINE_NUMBER(157);				// 1
	r4 = _JC_NEW(env, java_util_HashMap);
	_JC_INVOKE_NONVIRTUAL(env, java_util_HashMap, _init$7cb044ce4fb0ada8, 0, r4, 11, _JC_FCONST(0x3f, 0x40, 0x0, 0x0));
	_JC_REF_FIELD(env, r0, polyglot_frontend_Job, passMap) = r4;
	_JC_LINE_NUMBER(158);				// 2
	i0 = 0;

label1:
	r1 = _JC_REF_FIELD(env, r0, polyglot_frontend_Job, passes);
	i1 = _JC_INVOKE_VIRTUAL(env, java_util_ArrayList, size$345df5220fc60ade, r1);
	if (i0 >= i1)
		goto label2;
	_JC_LINE_NUMBER(159);				// 3
	r1 = _JC_REF_FIELD(env, r0, polyglot_frontend_Job, passes);
	r5 = _JC_INVOKE_VIRTUAL(env, java_util_ArrayList, get$a706240e1333824b, r1, i0);
	r2 = _JC_CAST(env, &_jc_polyglot_frontend_Pass$type, r5);
	_JC_LINE_NUMBER(160);				// 4
	r6 = _JC_REF_FIELD(env, r0, polyglot_frontend_Job, passMap);
	r7 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0x7164413dcc582d5e), _jc_object *, (_jc_env *, struct _jc_object *));
	r8 = _JC_NEW(env, java_lang_Integer);
	_JC_PRIM_FIELD(env, r8, java_lang_Integer, value) = i0;
	_JC_INVOKE_INTERFACE(env, r6, _JC_JLONG(0x3bd1c078a0faa8da), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *, struct _jc_java_lang_Object$object *), r7, r8);
	_JC_LINE_NUMBER(158);				// 5
	i0 = i0 + 1;
	_JC_PERIODIC_CHECK(env);
	goto label1;

label2:
	_JC_LINE_NUMBER(162);				// 6
	return;
}

//
// public boolean isRunning()
//

static _jc_linenum _jc_polyglot_frontend_Job$linenum_table$isRunning$ef11d3e5a2d3e7f2[];

static const unsigned char _jc_polyglot_frontend_Job$param_ptypes$isRunning$ef11d3e5a2d3e7f2[] = { 
_JC_TYPE_BOOLEAN };

_jc_method _jc_polyglot_frontend_Job$method_info$isRunning$ef11d3e5a2d3e7f2 = {
	.name=			"isRunning",
	.signature=		"()Z",
	.class=			&_jc_polyglot_frontend_Job$type,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_polyglot_frontend_Job$param_ptypes$isRunning$ef11d3e5a2d3e7f2,
	.signature_hash=	_JC_JLONG(0xef11d3e5a2d3e7f2),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_frontend_Job$method$isRunning$ef11d3e5a2d3e7f2,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_frontend_Job$vtable, polyglot_frontend_Job.isRunning$ef11d3e5a2d3e7f2) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_frontend_Job$linenum_table$isRunning$ef11d3e5a2d3e7f2
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_frontend_Job, isRunning$ef11d3e5a2d3e7f2);

jboolean _JC_JCNI_ATTR
_jc_polyglot_frontend_Job$method$isRunning$ef11d3e5a2d3e7f2(_jc_env *const env, _jc_polyglot_frontend_Job$object *this)
{
	struct _jc_polyglot_frontend_Job$object *r0;
	jboolean z0;

	r0 = this;
	_JC_LINE_NUMBER(80);				// 0
	z0 = _JC_PRIM_FIELD(env, r0, polyglot_frontend_Job, isRunning);
	return z0;
}

//
// public polyglot.frontend.BarrierPass lastBarrier()
//

static _jc_linenum _jc_polyglot_frontend_Job$linenum_table$lastBarrier$79738068276053c7[];

static const unsigned char _jc_polyglot_frontend_Job$param_ptypes$lastBarrier$79738068276053c7[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_frontend_Job$method_info$lastBarrier$79738068276053c7 = {
	.name=			"lastBarrier",
	.signature=		"()Lpolyglot/frontend/BarrierPass;",
	.class=			&_jc_polyglot_frontend_Job$type,
	.return_type=		&_jc_polyglot_frontend_BarrierPass$type,
	.param_ptypes=		&_jc_polyglot_frontend_Job$param_ptypes$lastBarrier$79738068276053c7,
	.signature_hash=	_JC_JLONG(0x79738068276053c7),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_frontend_Job$method$lastBarrier$79738068276053c7,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_frontend_Job$vtable, polyglot_frontend_Job.lastBarrier$79738068276053c7) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	6,
	      .table=	_jc_polyglot_frontend_Job$linenum_table$lastBarrier$79738068276053c7
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_frontend_Job, lastBarrier$79738068276053c7);

_jc_polyglot_frontend_BarrierPass$object * _JC_JCNI_ATTR
_jc_polyglot_frontend_Job$method$lastBarrier$79738068276053c7(_jc_env *const env, _jc_polyglot_frontend_Job$object *this)
{
	jint i0;
	struct _jc_polyglot_frontend_Job$object *r0;
	struct _jc_object *r1;
	struct _jc_java_util_ArrayList$object *r2;
	struct _jc_java_lang_Object$object *r3;
	struct _jc_polyglot_frontend_BarrierPass$object *r4;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(64);				// 0
	i0 = _JC_PRIM_FIELD(env, r0, polyglot_frontend_Job, nextPass);
	i0 = i0 - 1;

label0:
	if (i0 < 0)
		goto label2;
	_JC_LINE_NUMBER(65);				// 1
	r2 = _JC_REF_FIELD(env, r0, polyglot_frontend_Job, passes);
	r3 = _JC_INVOKE_VIRTUAL(env, java_util_ArrayList, get$a706240e1333824b, r2, i0);
	r1 = _JC_CAST(env, &_jc_polyglot_frontend_Pass$type, r3);
	_JC_LINE_NUMBER(67);				// 2
	z0 = _JC_INSTANCEOF(env, r1, &_jc_polyglot_frontend_BarrierPass$type);
	if (z0 == 0)
		goto label1;
	_JC_LINE_NUMBER(68);				// 3
	r4 = r1;
	return r4;

label1:
	_JC_LINE_NUMBER(64);				// 4
	i0 = i0 + -1;
	_JC_PERIODIC_CHECK(env);
	goto label0;

label2:
	_JC_LINE_NUMBER(72);				// 5
	return _JC_NULL;
}

//
// public polyglot.frontend.Pass nextPass()
//

static _jc_linenum _jc_polyglot_frontend_Job$linenum_table$nextPass$242b83848bd0f6be[];

static const unsigned char _jc_polyglot_frontend_Job$param_ptypes$nextPass$242b83848bd0f6be[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_frontend_Job$method_info$nextPass$242b83848bd0f6be = {
	.name=			"nextPass",
	.signature=		"()Lpolyglot/frontend/Pass;",
	.class=			&_jc_polyglot_frontend_Job$type,
	.return_type=		&_jc_polyglot_frontend_Pass$type,
	.param_ptypes=		&_jc_polyglot_frontend_Job$param_ptypes$nextPass$242b83848bd0f6be,
	.signature_hash=	_JC_JLONG(0x242b83848bd0f6be),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_frontend_Job$method$nextPass$242b83848bd0f6be,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_frontend_Job$vtable, polyglot_frontend_Job.nextPass$242b83848bd0f6be) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_polyglot_frontend_Job$linenum_table$nextPass$242b83848bd0f6be
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_frontend_Job, nextPass$242b83848bd0f6be);

_jc_object * _JC_JCNI_ATTR
_jc_polyglot_frontend_Job$method$nextPass$242b83848bd0f6be(_jc_env *const env, _jc_polyglot_frontend_Job$object *this)
{
	jint i0;
	jint i1;
	struct _jc_polyglot_frontend_Job$object *r0;
	struct _jc_object *r1;
	struct _jc_java_lang_Object$object *r3;
	struct _jc_java_util_ArrayList$object *r4;
	struct _jc_java_util_ArrayList$object *r6;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(241);				// 0
	i0 = _JC_PRIM_FIELD(env, r0, polyglot_frontend_Job, nextPass);
	r4 = _JC_REF_FIELD(env, r0, polyglot_frontend_Job, passes);
	if (r4 != _JC_NULL)
		goto label0;
	_JC_INVOKE_VIRTUAL(env, polyglot_frontend_Job, init$d82f2cc8ccf1c754, r0);

label0:
	r4 = _JC_REF_FIELD(env, r0, polyglot_frontend_Job, passes);
	i1 = _JC_INVOKE_INTERFACE(env, r4, _JC_JLONG(0x345df5220fc60ade), jint, (_jc_env *, struct _jc_object *));
	if (i0 >= i1)
		goto label2;
	r6 = _JC_REF_FIELD(env, r0, polyglot_frontend_Job, passes);
	if (r6 != _JC_NULL)
		goto label1;
	_JC_INVOKE_VIRTUAL(env, polyglot_frontend_Job, init$d82f2cc8ccf1c754, r0);

label1:
	r6 = _JC_REF_FIELD(env, r0, polyglot_frontend_Job, passes);
	_JC_LINE_NUMBER(242);				// 1
	i1 = _JC_PRIM_FIELD(env, r0, polyglot_frontend_Job, nextPass);
	r3 = _JC_INVOKE_INTERFACE(env, r6, _JC_JLONG(0xa706240e1333824b), _jc_object *, (_jc_env *, struct _jc_object *, jint), i1);
	r1 = _JC_CAST(env, &_jc_polyglot_frontend_Pass$type, r3);
	_JC_LINE_NUMBER(243);				// 2
	return r1;

label2:
	_JC_LINE_NUMBER(246);				// 3
	return _JC_NULL;
}

//
// public polyglot.frontend.Pass passByID(polyglot.frontend.Pass$ID)
//

static _jc_linenum _jc_polyglot_frontend_Job$linenum_table$passByID$f75fa2587317c0ff[];

static const unsigned char _jc_polyglot_frontend_Job$param_ptypes$passByID$f75fa2587317c0ff[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_frontend_Job$param_types$passByID$f75fa2587317c0ff[] = {
	&_jc_polyglot_frontend_Pass__24ID$type
};

_jc_method _jc_polyglot_frontend_Job$method_info$passByID$f75fa2587317c0ff = {
	.name=			"passByID",
	.signature=		"(Lpolyglot/frontend/Pass$ID;)Lpolyglot/frontend/Pass;",
	.class=			&_jc_polyglot_frontend_Job$type,
	.param_types=		&_jc_polyglot_frontend_Job$param_types$passByID$f75fa2587317c0ff,
	.return_type=		&_jc_polyglot_frontend_Pass$type,
	.param_ptypes=		&_jc_polyglot_frontend_Job$param_ptypes$passByID$f75fa2587317c0ff,
	.signature_hash=	_JC_JLONG(0xf75fa2587317c0ff),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_frontend_Job$method$passByID$f75fa2587317c0ff,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_frontend_Job$vtable, polyglot_frontend_Job.passByID$f75fa2587317c0ff) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_polyglot_frontend_Job$linenum_table$passByID$f75fa2587317c0ff
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_frontend_Job, passByID$f75fa2587317c0ff);

_jc_object * _JC_JCNI_ATTR
_jc_polyglot_frontend_Job$method$passByID$f75fa2587317c0ff(_jc_env *const env, _jc_polyglot_frontend_Job$object *this, _jc_polyglot_frontend_Pass__24ID$object *param0)
{
	jint i0;
	struct _jc_polyglot_frontend_Job$object *r0;
	struct _jc_polyglot_frontend_Pass__24ID$object *r1;
	struct _jc_java_lang_VMThrowable$object *r10;
	struct _jc_object *r11;
	struct _jc_java_util_ArrayList$object *r12;
	struct _jc_java_lang_StringBuffer$object *r13;
	struct _jc_java_lang_String$object *r15;
	struct _jc_java_lang_Integer$object *r2;
	struct _jc_java_lang_StringBuffer$object *r3;
	struct _jc_java_lang_Object$object *r4;
	struct _jc_object *r5;
	struct _jc_polyglot_util_InternalCompilerError$object *r6;
	struct _jc_java_lang_String$object *r7;
	struct _jc_polyglot_util_Position$object *r8;
	_jc_char_array *r9;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r11 = _JC_REF_FIELD(env, r0, polyglot_frontend_Job, passMap);
	if (r11 != _JC_NULL)
		goto label0;
	_JC_INVOKE_VIRTUAL(env, polyglot_frontend_Job, init$d82f2cc8ccf1c754, r0);

label0:
	r11 = _JC_REF_FIELD(env, r0, polyglot_frontend_Job, passMap);
	_JC_LINE_NUMBER(211);				// 0
	r4 = _JC_INVOKE_INTERFACE(env, r11, _JC_JLONG(0xb30461fc5ea13399), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r1);
	r2 = _JC_CAST_FINAL(env, &_jc_java_lang_Integer$type, r4);
	_JC_LINE_NUMBER(213);				// 1
	if (r2 == _JC_NULL)
		goto label2;
	r12 = _JC_REF_FIELD(env, r0, polyglot_frontend_Job, passes);
	if (r12 != _JC_NULL)
		goto label1;
	_JC_INVOKE_VIRTUAL(env, polyglot_frontend_Job, init$d82f2cc8ccf1c754, r0);

label1:
	r12 = _JC_REF_FIELD(env, r0, polyglot_frontend_Job, passes);
	i0 = _JC_PRIM_FIELD(env, r2, java_lang_Integer, value);
	_JC_LINE_NUMBER(214);				// 2
	r4 = _JC_INVOKE_INTERFACE(env, r12, _JC_JLONG(0xa706240e1333824b), _jc_object *, (_jc_env *, struct _jc_object *, jint), i0);
	r5 = _JC_CAST(env, &_jc_polyglot_frontend_Pass$type, r4);
	return r5;

label2:
	_JC_LINE_NUMBER(217);				// 3
	r6 = _JC_NEW(env, polyglot_util_InternalCompilerError);
	r3 = _JC_NEW(env, java_lang_StringBuffer);
	r9 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r3, java_lang_StringBuffer, value) = r9;
	r3 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r3, _JC_STRING(env, "No pass named \""));
	r13 = r3;
	if (r1 != _JC_NULL)
		goto label3;
	r15 = _JC_STRING(env, "null");
	goto label4;

label3:
	r15 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, toString$7ea43b33b80a3070, r1);

label4:
	r13 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r13, r15);
	r3 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r13, _JC_STRING(env, "\"."));
	_JC_EXPLICIT_NULL_CHECK(env, r3);
	r7 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r7, r3);
	r8 = _JC_NULL;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, cause) = r6;
	r10 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r6);
	_JC_REF_FIELD(env, r6, java_lang_Throwable, vmState) = r10;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r6, java_lang_Throwable, detailMessage) = r7;
	_JC_REF_FIELD(env, r6, polyglot_util_InternalCompilerError, pos) = r8;
	_JC_THROW(env, r6);
}

//
// private java.util.Map passMap()
//

static _jc_linenum _jc_polyglot_frontend_Job$linenum_table$passMap$41c4d5193eaae4dc[];

static const unsigned char _jc_polyglot_frontend_Job$param_ptypes$passMap$41c4d5193eaae4dc[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_frontend_Job$method_info$passMap$41c4d5193eaae4dc = {
	.name=			"passMap",
	.signature=		"()Ljava/util/Map;",
	.class=			&_jc_polyglot_frontend_Job$type,
	.return_type=		&_jc_java_util_Map$type,
	.param_ptypes=		&_jc_polyglot_frontend_Job$param_ptypes$passMap$41c4d5193eaae4dc,
	.signature_hash=	_JC_JLONG(0x41c4d5193eaae4dc),
	.access_flags=		_JC_ACC_PRIVATE,
	.function=		&_jc_polyglot_frontend_Job$method$passMap$41c4d5193eaae4dc,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_frontend_Job$vtable, polyglot_frontend_Job.passMap$41c4d5193eaae4dc) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_polyglot_frontend_Job$linenum_table$passMap$41c4d5193eaae4dc
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_frontend_Job, passMap$41c4d5193eaae4dc);

_jc_object * _JC_JCNI_ATTR
_jc_polyglot_frontend_Job$method$passMap$41c4d5193eaae4dc(_jc_env *const env, _jc_polyglot_frontend_Job$object *this)
{
	struct _jc_polyglot_frontend_Job$object *r0;
	struct _jc_object *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(145);				// 0
	r1 = _JC_REF_FIELD(env, r0, polyglot_frontend_Job, passMap);
	if (r1 != _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(146);				// 1
	_JC_INVOKE_VIRTUAL(env, polyglot_frontend_Job, init$d82f2cc8ccf1c754, r0);

label0:
	_JC_LINE_NUMBER(148);				// 2
	r1 = _JC_REF_FIELD(env, r0, polyglot_frontend_Job, passMap);
	return r1;
}

//
// public final java.util.List passes()
//

static _jc_linenum _jc_polyglot_frontend_Job$linenum_table$passes$0a380e70860f4564[];

static const unsigned char _jc_polyglot_frontend_Job$param_ptypes$passes$0a380e70860f4564[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_frontend_Job$method_info$passes$0a380e70860f4564 = {
	.name=			"passes",
	.signature=		"()Ljava/util/List;",
	.class=			&_jc_polyglot_frontend_Job$type,
	.return_type=		&_jc_java_util_List$type,
	.param_ptypes=		&_jc_polyglot_frontend_Job$param_ptypes$passes$0a380e70860f4564,
	.signature_hash=	_JC_JLONG(0xa380e70860f4564),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.function=		&_jc_polyglot_frontend_Job$method$passes$0a380e70860f4564,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_frontend_Job$vtable, polyglot_frontend_Job.passes$0a380e70860f4564) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_polyglot_frontend_Job$linenum_table$passes$0a380e70860f4564
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_frontend_Job, passes$0a380e70860f4564);

_jc_object * _JC_JCNI_ATTR
_jc_polyglot_frontend_Job$method$passes$0a380e70860f4564(_jc_env *const env, _jc_polyglot_frontend_Job$object *this)
{
	struct _jc_polyglot_frontend_Job$object *r0;
	struct _jc_java_util_ArrayList$object *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(137);				// 0
	r1 = _JC_REF_FIELD(env, r0, polyglot_frontend_Job, passes);
	if (r1 != _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(138);				// 1
	_JC_INVOKE_VIRTUAL(env, polyglot_frontend_Job, init$d82f2cc8ccf1c754, r0);

label0:
	_JC_LINE_NUMBER(141);				// 2
	r1 = _JC_REF_FIELD(env, r0, polyglot_frontend_Job, passes);
	return r1;
}

//
// public boolean pending(polyglot.frontend.Pass$ID)
//

static _jc_linenum _jc_polyglot_frontend_Job$linenum_table$pending$6a24976c1df5356a[];

static const unsigned char _jc_polyglot_frontend_Job$param_ptypes$pending$6a24976c1df5356a[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_polyglot_frontend_Job$param_types$pending$6a24976c1df5356a[] = {
	&_jc_polyglot_frontend_Pass__24ID$type
};

_jc_method _jc_polyglot_frontend_Job$method_info$pending$6a24976c1df5356a = {
	.name=			"pending",
	.signature=		"(Lpolyglot/frontend/Pass$ID;)Z",
	.class=			&_jc_polyglot_frontend_Job$type,
	.param_types=		&_jc_polyglot_frontend_Job$param_types$pending$6a24976c1df5356a,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_polyglot_frontend_Job$param_ptypes$pending$6a24976c1df5356a,
	.signature_hash=	_JC_JLONG(0x6a24976c1df5356a),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_frontend_Job$method$pending$6a24976c1df5356a,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_frontend_Job$vtable, polyglot_frontend_Job.pending$6a24976c1df5356a) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_polyglot_frontend_Job$linenum_table$pending$6a24976c1df5356a
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_frontend_Job, pending$6a24976c1df5356a);

jboolean _JC_JCNI_ATTR
_jc_polyglot_frontend_Job$method$pending$6a24976c1df5356a(_jc_env *const env, _jc_polyglot_frontend_Job$object *this, _jc_polyglot_frontend_Pass__24ID$object *param0)
{
	jint i0;
	jint i1;
	struct _jc_polyglot_frontend_Job$object *r0;
	struct _jc_polyglot_frontend_Pass__24ID$object *r1;
	struct _jc_java_lang_Integer$object *r2;
	struct _jc_java_lang_Object$object *r4;
	struct _jc_object *r6;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r6 = _JC_REF_FIELD(env, r0, polyglot_frontend_Job, passMap);
	if (r6 != _JC_NULL)
		goto label0;
	_JC_INVOKE_VIRTUAL(env, polyglot_frontend_Job, init$d82f2cc8ccf1c754, r0);

label0:
	r6 = _JC_REF_FIELD(env, r0, polyglot_frontend_Job, passMap);
	_JC_LINE_NUMBER(203);				// 0
	r4 = _JC_INVOKE_INTERFACE(env, r6, _JC_JLONG(0xb30461fc5ea13399), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r1);
	r2 = _JC_CAST_FINAL(env, &_jc_java_lang_Integer$type, r4);
	_JC_LINE_NUMBER(204);				// 1
	if (r2 == _JC_NULL)
		goto label1;
	i1 = _JC_PRIM_FIELD(env, r2, java_lang_Integer, value);
	i0 = _JC_PRIM_FIELD(env, r0, polyglot_frontend_Job, nextPass);
	if (i1 < i0)
		goto label1;
	z0 = 1;
	goto label2;

label1:
	z0 = 0;

label2:
	return z0;
}

//
// public java.util.List pendingPasses()
//

static _jc_linenum _jc_polyglot_frontend_Job$linenum_table$pendingPasses$a0468f4ba2edfb82[];

static const unsigned char _jc_polyglot_frontend_Job$param_ptypes$pendingPasses$a0468f4ba2edfb82[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_frontend_Job$method_info$pendingPasses$a0468f4ba2edfb82 = {
	.name=			"pendingPasses",
	.signature=		"()Ljava/util/List;",
	.class=			&_jc_polyglot_frontend_Job$type,
	.return_type=		&_jc_java_util_List$type,
	.param_ptypes=		&_jc_polyglot_frontend_Job$param_ptypes$pendingPasses$a0468f4ba2edfb82,
	.signature_hash=	_JC_JLONG(0xa0468f4ba2edfb82),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_frontend_Job$method$pendingPasses$a0468f4ba2edfb82,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_frontend_Job$vtable, polyglot_frontend_Job.pendingPasses$a0468f4ba2edfb82) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_frontend_Job$linenum_table$pendingPasses$a0468f4ba2edfb82
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_frontend_Job, pendingPasses$a0468f4ba2edfb82);

_jc_object * _JC_JCNI_ATTR
_jc_polyglot_frontend_Job$method$pendingPasses$a0468f4ba2edfb82(_jc_env *const env, _jc_polyglot_frontend_Job$object *this)
{
	jint i0;
	jint i1;
	struct _jc_polyglot_frontend_Job$object *r0;
	struct _jc_object *r1;
	struct _jc_java_util_ArrayList$object *r2;
	struct _jc_java_util_ArrayList$object *r4;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r4 = _JC_REF_FIELD(env, r0, polyglot_frontend_Job, passes);
	if (r4 != _JC_NULL)
		goto label0;
	_JC_INVOKE_VIRTUAL(env, polyglot_frontend_Job, init$d82f2cc8ccf1c754, r0);

label0:
	r4 = _JC_REF_FIELD(env, r0, polyglot_frontend_Job, passes);
	_JC_LINE_NUMBER(188);				// 0
	i0 = _JC_PRIM_FIELD(env, r0, polyglot_frontend_Job, nextPass);
	r2 = _JC_REF_FIELD(env, r0, polyglot_frontend_Job, passes);
	i1 = _JC_INVOKE_VIRTUAL(env, java_util_ArrayList, size$345df5220fc60ade, r2);
	r1 = _JC_INVOKE_INTERFACE(env, r4, _JC_JLONG(0xaf8e3c69195dae35), _jc_object *, (_jc_env *, struct _jc_object *, jint, jint), i0, i1);
	return r1;
}

//
// public void setIsRunning(boolean)
//

static _jc_linenum _jc_polyglot_frontend_Job$linenum_table$setIsRunning$4f285dcdec8e3bcf[];

static const unsigned char _jc_polyglot_frontend_Job$param_ptypes$setIsRunning$4f285dcdec8e3bcf[] = { 
_JC_TYPE_BOOLEAN, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_frontend_Job$param_types$setIsRunning$4f285dcdec8e3bcf[] = {
	&_jc_boolean$prim$type
};

_jc_method _jc_polyglot_frontend_Job$method_info$setIsRunning$4f285dcdec8e3bcf = {
	.name=			"setIsRunning",
	.signature=		"(Z)V",
	.class=			&_jc_polyglot_frontend_Job$type,
	.param_types=		&_jc_polyglot_frontend_Job$param_types$setIsRunning$4f285dcdec8e3bcf,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_frontend_Job$param_ptypes$setIsRunning$4f285dcdec8e3bcf,
	.signature_hash=	_JC_JLONG(0x4f285dcdec8e3bcf),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_frontend_Job$method$setIsRunning$4f285dcdec8e3bcf,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_frontend_Job$vtable, polyglot_frontend_Job.setIsRunning$4f285dcdec8e3bcf) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_polyglot_frontend_Job$linenum_table$setIsRunning$4f285dcdec8e3bcf
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_frontend_Job, setIsRunning$4f285dcdec8e3bcf);

void _JC_JCNI_ATTR
_jc_polyglot_frontend_Job$method$setIsRunning$4f285dcdec8e3bcf(_jc_env *const env, _jc_polyglot_frontend_Job$object *this, jboolean param0)
{
	struct _jc_polyglot_frontend_Job$object *r0;
	jboolean z0;

	r0 = this;
	z0 = param0;
	_JC_LINE_NUMBER(76);				// 0
	_JC_PRIM_FIELD(env, r0, polyglot_frontend_Job, isRunning) = z0;
	_JC_LINE_NUMBER(77);				// 1
	return;
}

//
// public polyglot.frontend.Source source()
//

static _jc_linenum _jc_polyglot_frontend_Job$linenum_table$source$998a5a64aa67515f[];

static const unsigned char _jc_polyglot_frontend_Job$param_ptypes$source$998a5a64aa67515f[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_frontend_Job$method_info$source$998a5a64aa67515f = {
	.name=			"source",
	.signature=		"()Lpolyglot/frontend/Source;",
	.class=			&_jc_polyglot_frontend_Job$type,
	.return_type=		&_jc_polyglot_frontend_Source$type,
	.param_ptypes=		&_jc_polyglot_frontend_Job$param_ptypes$source$998a5a64aa67515f,
	.signature_hash=	_JC_JLONG(0x998a5a64aa67515f),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_frontend_Job$method$source$998a5a64aa67515f,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_frontend_Job$vtable, polyglot_frontend_Job.source$998a5a64aa67515f) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_frontend_Job$linenum_table$source$998a5a64aa67515f
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_frontend_Job, source$998a5a64aa67515f);

_jc_polyglot_frontend_Source$object * _JC_JCNI_ATTR
_jc_polyglot_frontend_Job$method$source$998a5a64aa67515f(_jc_env *const env, _jc_polyglot_frontend_Job$object *this)
{
	struct _jc_polyglot_frontend_Job$object *r0;
	struct _jc_polyglot_frontend_SourceJob$object *r1;
	struct _jc_polyglot_frontend_Source$object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(121);				// 0
	r1 = _JC_INVOKE_VIRTUAL(env, polyglot_frontend_Job, sourceJob$2fc26d39f6f66cf4, r0);
	r2 = _JC_INVOKE_VIRTUAL(env, polyglot_frontend_SourceJob, source$998a5a64aa67515f, r1);
	return r2;
}

//
// public abstract polyglot.frontend.SourceJob sourceJob()
//

static const unsigned char _jc_polyglot_frontend_Job$param_ptypes$sourceJob$2fc26d39f6f66cf4[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_frontend_Job$method_info$sourceJob$2fc26d39f6f66cf4 = {
	.name=			"sourceJob",
	.signature=		"()Lpolyglot/frontend/SourceJob;",
	.class=			&_jc_polyglot_frontend_Job$type,
	.return_type=		&_jc_polyglot_frontend_SourceJob$type,
	.param_ptypes=		&_jc_polyglot_frontend_Job$param_ptypes$sourceJob$2fc26d39f6f66cf4,
	.signature_hash=	_JC_JLONG(0x2fc26d39f6f66cf4),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.function=		&_jc_polyglot_frontend_Job$method$sourceJob$2fc26d39f6f66cf4,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_frontend_Job$vtable, polyglot_frontend_Job.sourceJob$2fc26d39f6f66cf4) / sizeof(void *),
	.num_parameters=	0,
};

_jc_polyglot_frontend_SourceJob$object * _JC_JCNI_ATTR
_jc_polyglot_frontend_Job$method$sourceJob$2fc26d39f6f66cf4(_jc_env *const env, _jc_polyglot_frontend_Job$object *this)
{
	_JC_ABSTRACT_METHOD(env, &_jc_polyglot_frontend_Job$method_info$sourceJob$2fc26d39f6f66cf4);
}

//
// public polyglot.ast.Node spawn(polyglot.types.Context, polyglot.ast.Node, polyglot.frontend.Pass$ID, polyglot.frontend.Pass$ID)
//

static _jc_linenum _jc_polyglot_frontend_Job$linenum_table$spawn$6e341889f32c0ece[];

static const unsigned char _jc_polyglot_frontend_Job$param_ptypes$spawn$6e341889f32c0ece[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_frontend_Job$param_types$spawn$6e341889f32c0ece[] = {
	&_jc_polyglot_types_Context$type,
	&_jc_polyglot_ast_Node$type,
	&_jc_polyglot_frontend_Pass__24ID$type,
	&_jc_polyglot_frontend_Pass__24ID$type
};

_jc_method _jc_polyglot_frontend_Job$method_info$spawn$6e341889f32c0ece = {
	.name=			"spawn",
	.signature=		"(Lpolyglot/types/Context;Lpolyglot/ast/Node;Lpolyglot/frontend/Pass$ID;Lpolyglot/frontend/Pass$ID;)Lpolyglot/ast/Node;",
	.class=			&_jc_polyglot_frontend_Job$type,
	.param_types=		&_jc_polyglot_frontend_Job$param_types$spawn$6e341889f32c0ece,
	.return_type=		&_jc_polyglot_ast_Node$type,
	.param_ptypes=		&_jc_polyglot_frontend_Job$param_ptypes$spawn$6e341889f32c0ece,
	.signature_hash=	_JC_JLONG(0x6e341889f32c0ece),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_frontend_Job$method$spawn$6e341889f32c0ece,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_frontend_Job$vtable, polyglot_frontend_Job.spawn$6e341889f32c0ece) / sizeof(void *),
	.num_parameters=	4,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_frontend_Job$linenum_table$spawn$6e341889f32c0ece
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_frontend_Job, spawn$6e341889f32c0ece);

_jc_object * _JC_JCNI_ATTR
_jc_polyglot_frontend_Job$method$spawn$6e341889f32c0ece(_jc_env *const env, _jc_polyglot_frontend_Job$object *this, _jc_object *param0, _jc_object *param1, _jc_polyglot_frontend_Pass__24ID$object *param2, _jc_polyglot_frontend_Pass__24ID$object *param3)
{
	struct _jc_polyglot_frontend_Job$object *r0;
	struct _jc_object *r1;
	struct _jc_object *r2;
	struct _jc_polyglot_frontend_Pass__24ID$object *r3;
	struct _jc_polyglot_frontend_Pass__24ID$object *r4;
	struct _jc_object *r5;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	r3 = param2;
	r4 = param3;
	_JC_LINE_NUMBER(300);				// 0
	r5 = _JC_REF_FIELD(env, r0, polyglot_frontend_Job, lang);
	r2 = _JC_INVOKE_INTERFACE(env, r5, _JC_JLONG(0x2bec112129a69fa5), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_object *, struct _jc_object *, struct _jc_polyglot_frontend_Job$object *, struct _jc_polyglot_frontend_Pass__24ID$object *, struct _jc_polyglot_frontend_Pass__24ID$object *), r1, r2, r0, r3, r4);
	return r2;
}

//
// public boolean status()
//

static _jc_linenum _jc_polyglot_frontend_Job$linenum_table$status$a7965a4a16b6895e[];

static const unsigned char _jc_polyglot_frontend_Job$param_ptypes$status$a7965a4a16b6895e[] = { 
_JC_TYPE_BOOLEAN };

_jc_method _jc_polyglot_frontend_Job$method_info$status$a7965a4a16b6895e = {
	.name=			"status",
	.signature=		"()Z",
	.class=			&_jc_polyglot_frontend_Job$type,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_polyglot_frontend_Job$param_ptypes$status$a7965a4a16b6895e,
	.signature_hash=	_JC_JLONG(0xa7965a4a16b6895e),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_frontend_Job$method$status$a7965a4a16b6895e,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_frontend_Job$vtable, polyglot_frontend_Job.status$a7965a4a16b6895e) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_frontend_Job$linenum_table$status$a7965a4a16b6895e
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_frontend_Job, status$a7965a4a16b6895e);

jboolean _JC_JCNI_ATTR
_jc_polyglot_frontend_Job$method$status$a7965a4a16b6895e(_jc_env *const env, _jc_polyglot_frontend_Job$object *this)
{
	struct _jc_polyglot_frontend_Job$object *r0;
	jboolean z0;

	r0 = this;
	_JC_LINE_NUMBER(252);				// 0
	z0 = _JC_PRIM_FIELD(env, r0, polyglot_frontend_Job, status);
	return z0;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_polyglot_frontend_Job$methods[] = {
	&_jc_polyglot_frontend_Job$method_info$_init$d36ef28164fff869,
	&_jc_polyglot_frontend_Job$method_info$ast$e418a55a83097dd0,
	&_jc_polyglot_frontend_Job$method_info$ast$e24c452e7703a64f,
	&_jc_polyglot_frontend_Job$method_info$compiler$a83a951e175ae03a,
	&_jc_polyglot_frontend_Job$method_info$completed$0cd53b1aa4c5889f,
	&_jc_polyglot_frontend_Job$method_info$completed$d55c401dfbe7e859,
	&_jc_polyglot_frontend_Job$method_info$completedPasses$3c8fd81612bf41f0,
	&_jc_polyglot_frontend_Job$method_info$context$4c5ebe4f0ff1c15f,
	&_jc_polyglot_frontend_Job$method_info$dump$30efa1ff09c02470,
	&_jc_polyglot_frontend_Job$method_info$ext$98b499814cc8ad11,
	&_jc_polyglot_frontend_Job$method_info$extensionInfo$b7bb1008805e481e,
	&_jc_polyglot_frontend_Job$method_info$finishPass$6e35714761d5fd2b,
	&_jc_polyglot_frontend_Job$method_info$getPasses$e5b4184d264aa29f,
	&_jc_polyglot_frontend_Job$method_info$getPreviousTo$d03a68acce5eb8ad,
	&_jc_polyglot_frontend_Job$method_info$init$d82f2cc8ccf1c754,
	&_jc_polyglot_frontend_Job$method_info$isRunning$ef11d3e5a2d3e7f2,
	&_jc_polyglot_frontend_Job$method_info$lastBarrier$79738068276053c7,
	&_jc_polyglot_frontend_Job$method_info$nextPass$242b83848bd0f6be,
	&_jc_polyglot_frontend_Job$method_info$passByID$f75fa2587317c0ff,
	&_jc_polyglot_frontend_Job$method_info$passMap$41c4d5193eaae4dc,
	&_jc_polyglot_frontend_Job$method_info$passes$0a380e70860f4564,
	&_jc_polyglot_frontend_Job$method_info$pending$6a24976c1df5356a,
	&_jc_polyglot_frontend_Job$method_info$pendingPasses$a0468f4ba2edfb82,
	&_jc_polyglot_frontend_Job$method_info$setIsRunning$4f285dcdec8e3bcf,
	&_jc_polyglot_frontend_Job$method_info$source$998a5a64aa67515f,
	&_jc_polyglot_frontend_Job$method_info$sourceJob$2fc26d39f6f66cf4,
	&_jc_polyglot_frontend_Job$method_info$spawn$6e341889f32c0ece,
	&_jc_polyglot_frontend_Job$method_info$status$a7965a4a16b6895e
};

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_polyglot_frontend_Job$instanceof_hash_bucket_36[] = {
	&_jc_polyglot_frontend_Job$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_frontend_Job$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_polyglot_frontend_Job$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[36]=	_jc_polyglot_frontend_Job$instanceof_hash_bucket_36,
	[101]=	_jc_polyglot_frontend_Job$instanceof_hash_bucket_101
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_polyglot_frontend_Job$class_depends[] = {
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/IllegalArgumentException",	_JC_JLONG(0x680cf34d05feb5a1) },
	{ "java/lang/Integer",	_JC_JLONG(0xca631501391a31f1) },
	{ "java/lang/Number",	_JC_JLONG(0x9cd7252f79299280) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/RuntimeException",	_JC_JLONG(0x4f5534a987354d1d) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/StringBuffer",	_JC_JLONG(0x94d357637b968dda) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/util/AbstractCollection",	_JC_JLONG(0x8ea716c64b77f8eb) },
	{ "java/util/AbstractList",	_JC_JLONG(0xf5238436362828db) },
	{ "java/util/ArrayList",	_JC_JLONG(0x58038509830ef3f4) },
	{ "java/util/HashMap",	_JC_JLONG(0xd7cd853200c3e71f) },
	{ "java/util/List",	_JC_JLONG(0x9ee0d92ce1525a4d) },
	{ "java/util/Map",	_JC_JLONG(0xe283f7c2e7a7979c) },
	{ "polyglot/ast/Node",	_JC_JLONG(0x1c402b4f9747e08) },
	{ "polyglot/frontend/BarrierPass",	_JC_JLONG(0xe0a64384fd8897ef) },
	{ "polyglot/frontend/Compiler",	_JC_JLONG(0x3ea6f1cf85115422) },
	{ "polyglot/frontend/ExtensionInfo",	_JC_JLONG(0xfdbc32d4847269bf) },
	{ "polyglot/frontend/JobExt",	_JC_JLONG(0xe5d1de4e75576eba) },
	{ "polyglot/frontend/Pass",	_JC_JLONG(0x82f7472f39b4803b) },
	{ "polyglot/frontend/Pass$ID",	_JC_JLONG(0x3218faf4b567e7d9) },
	{ "polyglot/frontend/Source",	_JC_JLONG(0xcd88b669bec8f787) },
	{ "polyglot/frontend/SourceJob",	_JC_JLONG(0x6b393ef3f88ef5d0) },
	{ "polyglot/types/Context",	_JC_JLONG(0xa433cdcd788f6c37) },
	{ "polyglot/util/CodeWriter",	_JC_JLONG(0xbda7215170a25efc) },
	{ "polyglot/util/InternalCompilerError",	_JC_JLONG(0x22b321d488641c54) },
	{ "polyglot/util/Position",	_JC_JLONG(0x32c9a088c5dac046) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_polyglot_frontend_Job$vtype _jc_polyglot_frontend_Job$type = {
    .type= {
	.name=			"polyglot/frontend/Job",
	.superclass=		&_jc_java_lang_Object$type,
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		38,
		.hash=			_JC_JLONG(0x42e687805b457724),
		.source_file=		"Job.java",
		.instance_size=		sizeof(_jc_polyglot_frontend_Job$refs) + sizeof(_jc_polyglot_frontend_Job$object),
		.num_virtual_refs=	5,
		.num_fields=		sizeof(_jc_polyglot_frontend_Job$fields) / sizeof(*_jc_polyglot_frontend_Job$fields),
		.fields=		_jc_polyglot_frontend_Job$fields,
		.num_methods=		sizeof(_jc_polyglot_frontend_Job$methods) / sizeof(*_jc_polyglot_frontend_Job$methods),
		.methods=		_jc_polyglot_frontend_Job$methods,
		.instanceof_hash_table=	_jc_polyglot_frontend_Job$instanceof_hash_table,
		.num_class_depends=		sizeof(_jc_polyglot_frontend_Job$class_depends) / sizeof(*_jc_polyglot_frontend_Job$class_depends),
		.class_depends=		_jc_polyglot_frontend_Job$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.polyglot_frontend_Job= {
	    .ast$e418a55a83097dd0=
		&_jc_polyglot_frontend_Job$method$ast$e418a55a83097dd0,
	    .ast$e24c452e7703a64f=
		&_jc_polyglot_frontend_Job$method$ast$e24c452e7703a64f,
	    .compiler$a83a951e175ae03a=
		&_jc_polyglot_frontend_Job$method$compiler$a83a951e175ae03a,
	    .completed$0cd53b1aa4c5889f=
		&_jc_polyglot_frontend_Job$method$completed$0cd53b1aa4c5889f,
	    .completed$d55c401dfbe7e859=
		&_jc_polyglot_frontend_Job$method$completed$d55c401dfbe7e859,
	    .completedPasses$3c8fd81612bf41f0=
		&_jc_polyglot_frontend_Job$method$completedPasses$3c8fd81612bf41f0,
	    .context$4c5ebe4f0ff1c15f=
		&_jc_polyglot_frontend_Job$method$context$4c5ebe4f0ff1c15f,
	    .dump$30efa1ff09c02470=
		&_jc_polyglot_frontend_Job$method$dump$30efa1ff09c02470,
	    .ext$98b499814cc8ad11=
		&_jc_polyglot_frontend_Job$method$ext$98b499814cc8ad11,
	    .extensionInfo$b7bb1008805e481e=
		&_jc_polyglot_frontend_Job$method$extensionInfo$b7bb1008805e481e,
	    .finishPass$6e35714761d5fd2b=
		&_jc_polyglot_frontend_Job$method$finishPass$6e35714761d5fd2b,
	    .getPasses$e5b4184d264aa29f=
		&_jc_polyglot_frontend_Job$method$getPasses$e5b4184d264aa29f,
	    .getPreviousTo$d03a68acce5eb8ad=
		&_jc_polyglot_frontend_Job$method$getPreviousTo$d03a68acce5eb8ad,
	    .init$d82f2cc8ccf1c754=
		&_jc_polyglot_frontend_Job$method$init$d82f2cc8ccf1c754,
	    .isRunning$ef11d3e5a2d3e7f2=
		&_jc_polyglot_frontend_Job$method$isRunning$ef11d3e5a2d3e7f2,
	    .lastBarrier$79738068276053c7=
		&_jc_polyglot_frontend_Job$method$lastBarrier$79738068276053c7,
	    .nextPass$242b83848bd0f6be=
		&_jc_polyglot_frontend_Job$method$nextPass$242b83848bd0f6be,
	    .passByID$f75fa2587317c0ff=
		&_jc_polyglot_frontend_Job$method$passByID$f75fa2587317c0ff,
	    .passMap$41c4d5193eaae4dc=
		&_jc_polyglot_frontend_Job$method$passMap$41c4d5193eaae4dc,
	    .passes$0a380e70860f4564=
		&_jc_polyglot_frontend_Job$method$passes$0a380e70860f4564,
	    .pending$6a24976c1df5356a=
		&_jc_polyglot_frontend_Job$method$pending$6a24976c1df5356a,
	    .pendingPasses$a0468f4ba2edfb82=
		&_jc_polyglot_frontend_Job$method$pendingPasses$a0468f4ba2edfb82,
	    .setIsRunning$4f285dcdec8e3bcf=
		&_jc_polyglot_frontend_Job$method$setIsRunning$4f285dcdec8e3bcf,
	    .source$998a5a64aa67515f=
		&_jc_polyglot_frontend_Job$method$source$998a5a64aa67515f,
	    .sourceJob$2fc26d39f6f66cf4=
		&_jc_polyglot_frontend_Job$method$sourceJob$2fc26d39f6f66cf4,
	    .spawn$6e341889f32c0ece=
		&_jc_polyglot_frontend_Job$method$spawn$6e341889f32c0ece,
	    .status$a7965a4a16b6895e=
		&_jc_polyglot_frontend_Job$method$status$a7965a4a16b6895e,
	},
    }
};

