// public abstract class polyglot.parse.BaseParser

// class file dependencies
// @dep_class 4e0a56550c69d57c java_io_IOException
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class 8ea716c64b77f8eb java_util_AbstractCollection
// @dep_class f5238436362828db java_util_AbstractList
// @dep_class 9ee0d92ce1525a4d java_util_List
// @dep_class 72209734bd9cc6c1 java_util_Stack
// @dep_class c53e1575b095109b java_util_Vector
// @dep_class 413b2e03dcc84ee9 java__5fcup_runtime_Symbol
// @dep_class 9182b5460122e5e8 java__5fcup_runtime_lr__5fparser
// @dep_class 7ee42950435f22ee polyglot_ast_AmbExpr
// @dep_class 490b53c7cc348bb5 polyglot_ast_AmbPrefix
// @dep_class ee38bfb92996b470 polyglot_ast_AmbQualifierNode
// @dep_class c8423c3fc34ddf41 polyglot_ast_AmbReceiver
// @dep_class f88dca636c2c226e polyglot_ast_AmbTypeNode
// @dep_class 339d14b46377685b polyglot_ast_ArrayTypeNode
// @dep_class 6d0ea1efc315a28 polyglot_ast_CanonicalTypeNode
// @dep_class a33c697a7834ba70 polyglot_ast_Expr
// @dep_class 4fe86535a8e5abae polyglot_ast_Field
// @dep_class 1c402b4f9747e08 polyglot_ast_Node
// @dep_class 56625b3befab19f polyglot_ast_NodeFactory
// @dep_class 3409dc0ecff2f246 polyglot_ast_Prefix
// @dep_class b124f6ed57f4caf2 polyglot_ast_QualifierNode
// @dep_class e8c4a965abb2860a polyglot_ast_Receiver
// @dep_class dfe962b6d2ff7e27 polyglot_ast_TypeNode
// @dep_class 616f43199b90e9f2 polyglot_lex_Lexer
// @dep_class 28b2d50426072b60 polyglot_lex_Token
// @dep_class bb05fbad007ed762 polyglot_parse_BaseParser
// @dep_class e329cd839509c30c polyglot_parse_VarDeclarator
// @dep_class 412788f7d4254477 polyglot_types_ArrayType
// @dep_class 69408a3a6c3b3df4 polyglot_types_Qualifier
// @dep_class 6596051546781098 polyglot_types_Type
// @dep_class ed171cdaca38ec28 polyglot_types_TypeSystem
// @dep_class ff712c8463bdfdc0 polyglot_util_ErrorQueue
// @dep_class 32c9a088c5dac046 polyglot_util_Position

// header file dependencies
// @dep_header java_io_IOException
// @dep_header java_lang_Class
// @dep_header java_lang_String
// @dep_header java_lang_VMThrowable
// @dep_header java_util_List
// @dep_header java_util_Stack
// @dep_header java__5fcup_runtime_Symbol
// @dep_header polyglot_ast_AmbExpr
// @dep_header polyglot_ast_AmbPrefix
// @dep_header polyglot_ast_AmbQualifierNode
// @dep_header polyglot_ast_AmbReceiver
// @dep_header polyglot_ast_AmbTypeNode
// @dep_header polyglot_ast_ArrayTypeNode
// @dep_header polyglot_ast_CanonicalTypeNode
// @dep_header polyglot_ast_Expr
// @dep_header polyglot_ast_Field
// @dep_header polyglot_ast_Node
// @dep_header polyglot_ast_NodeFactory
// @dep_header polyglot_ast_Prefix
// @dep_header polyglot_ast_QualifierNode
// @dep_header polyglot_ast_Receiver
// @dep_header polyglot_ast_TypeNode
// @dep_header polyglot_lex_Lexer
// @dep_header polyglot_lex_Token
// @dep_header polyglot_parse_BaseParser
// @dep_header polyglot_parse_VarDeclarator
// @dep_header polyglot_types_ArrayType
// @dep_header polyglot_types_Qualifier
// @dep_header polyglot_types_Type
// @dep_header polyglot_types_TypeSystem
// @dep_header polyglot_util_ErrorQueue
// @dep_header polyglot_util_Position

#include "jc_defs.h"

#include "java/io/IOException.h"
#include "java/lang/Class.h"
#include "java/lang/String.h"
#include "java/lang/VMThrowable.h"
#include "java/util/List.h"
#include "java/util/Stack.h"
#include "java__5fcup/runtime/Symbol.h"
#include "polyglot/ast/AmbExpr.h"
#include "polyglot/ast/AmbPrefix.h"
#include "polyglot/ast/AmbQualifierNode.h"
#include "polyglot/ast/AmbReceiver.h"
#include "polyglot/ast/AmbTypeNode.h"
#include "polyglot/ast/ArrayTypeNode.h"
#include "polyglot/ast/CanonicalTypeNode.h"
#include "polyglot/ast/Expr.h"
#include "polyglot/ast/Field.h"
#include "polyglot/ast/Node.h"
#include "polyglot/ast/NodeFactory.h"
#include "polyglot/ast/Prefix.h"
#include "polyglot/ast/QualifierNode.h"
#include "polyglot/ast/Receiver.h"
#include "polyglot/ast/TypeNode.h"
#include "polyglot/lex/Lexer.h"
#include "polyglot/lex/Token.h"
#include "polyglot/parse/BaseParser.h"
#include "polyglot/parse/VarDeclarator.h"
#include "polyglot/types/ArrayType.h"
#include "polyglot/types/Qualifier.h"
#include "polyglot/types/Type.h"
#include "polyglot/types/TypeSystem.h"
#include "polyglot/util/ErrorQueue.h"
#include "polyglot/util/Position.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// public final polyglot.lex.Lexer lexer
static _jc_field _jc_polyglot_parse_BaseParser$field_info$lexer = {
	.name=		"lexer",
	.signature=	"Lpolyglot/lex/Lexer;",
	.class=		&_jc_polyglot_parse_BaseParser$type,
	.type=		&_jc_polyglot_lex_Lexer$type,
	.access_flags=	_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_polyglot_parse_BaseParser$object, refs[-1].polyglot_parse_BaseParser.lexer),
};

// public final polyglot.util.ErrorQueue eq
static _jc_field _jc_polyglot_parse_BaseParser$field_info$eq = {
	.name=		"eq",
	.signature=	"Lpolyglot/util/ErrorQueue;",
	.class=		&_jc_polyglot_parse_BaseParser$type,
	.type=		&_jc_polyglot_util_ErrorQueue$type,
	.access_flags=	_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_polyglot_parse_BaseParser$object, refs[-1].polyglot_parse_BaseParser.eq),
};

// public final polyglot.types.TypeSystem ts
static _jc_field _jc_polyglot_parse_BaseParser$field_info$ts = {
	.name=		"ts",
	.signature=	"Lpolyglot/types/TypeSystem;",
	.class=		&_jc_polyglot_parse_BaseParser$type,
	.type=		&_jc_polyglot_types_TypeSystem$type,
	.access_flags=	_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_polyglot_parse_BaseParser$object, refs[-1].polyglot_parse_BaseParser.ts),
};

// public final polyglot.ast.NodeFactory nf
static _jc_field _jc_polyglot_parse_BaseParser$field_info$nf = {
	.name=		"nf",
	.signature=	"Lpolyglot/ast/NodeFactory;",
	.class=		&_jc_polyglot_parse_BaseParser$type,
	.type=		&_jc_polyglot_ast_NodeFactory$type,
	.access_flags=	_JC_ACC_PUBLIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_polyglot_parse_BaseParser$object, refs[-1].polyglot_parse_BaseParser.nf),
};

// protected polyglot.util.Position prev_pos
static _jc_field _jc_polyglot_parse_BaseParser$field_info$prev__5fpos = {
	.name=		"prev_pos",
	.signature=	"Lpolyglot/util/Position;",
	.class=		&_jc_polyglot_parse_BaseParser$type,
	.type=		&_jc_polyglot_util_Position$type,
	.access_flags=	_JC_ACC_PROTECTED,
	.offset=	_JC_OFFSETOF(_jc_polyglot_parse_BaseParser$object, refs[-1].polyglot_parse_BaseParser.prev__5fpos),
};

// protected polyglot.util.Position position
static _jc_field _jc_polyglot_parse_BaseParser$field_info$position = {
	.name=		"position",
	.signature=	"Lpolyglot/util/Position;",
	.class=		&_jc_polyglot_parse_BaseParser$type,
	.type=		&_jc_polyglot_util_Position$type,
	.access_flags=	_JC_ACC_PROTECTED,
	.offset=	_JC_OFFSETOF(_jc_polyglot_parse_BaseParser$object, refs[-1].polyglot_parse_BaseParser.position),
};

// Fields
static _jc_field *const _jc_polyglot_parse_BaseParser$fields[] = {
	&_jc_polyglot_parse_BaseParser$field_info$eq,
	&_jc_polyglot_parse_BaseParser$field_info$lexer,
	&_jc_polyglot_parse_BaseParser$field_info$nf,
	&_jc_polyglot_parse_BaseParser$field_info$position,
	&_jc_polyglot_parse_BaseParser$field_info$prev__5fpos,
	&_jc_polyglot_parse_BaseParser$field_info$ts
};

/************************************************************************
 *			      Static methods				*
 ************************************************************************/

//
// public static polyglot.util.Position pos(java.util.List)
//

static _jc_linenum _jc_polyglot_parse_BaseParser$linenum_table$pos$6ae606c7fda4c3f6[];

static const unsigned char _jc_polyglot_parse_BaseParser$param_ptypes$pos$6ae606c7fda4c3f6[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_parse_BaseParser$param_types$pos$6ae606c7fda4c3f6[] = {
	&_jc_java_util_List$type
};

_jc_method _jc_polyglot_parse_BaseParser$method_info$pos$6ae606c7fda4c3f6 = {
	.name=			"pos",
	.signature=		"(Ljava/util/List;)Lpolyglot/util/Position;",
	.class=			&_jc_polyglot_parse_BaseParser$type,
	.param_types=		&_jc_polyglot_parse_BaseParser$param_types$pos$6ae606c7fda4c3f6,
	.return_type=		&_jc_polyglot_util_Position$type,
	.param_ptypes=		&_jc_polyglot_parse_BaseParser$param_ptypes$pos$6ae606c7fda4c3f6,
	.signature_hash=	_JC_JLONG(0x6ae606c7fda4c3f6),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_polyglot_parse_BaseParser$method$pos$6ae606c7fda4c3f6,
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	8,
	      .table=	_jc_polyglot_parse_BaseParser$linenum_table$pos$6ae606c7fda4c3f6
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_parse_BaseParser, pos$6ae606c7fda4c3f6);

_jc_polyglot_util_Position$object * _JC_JCNI_ATTR
_jc_polyglot_parse_BaseParser$method$pos$6ae606c7fda4c3f6(_jc_env *const env, _jc_object *param0)
{
	struct _jc_object *r0;
	struct _jc_java_lang_Object$object *r1;
	struct _jc_object *r2;
	struct _jc_polyglot_util_Position$object *r3;
	struct _jc_polyglot_lex_Token$object *r4;
	struct _jc_object *r5;
	struct _jc_polyglot_util_Position$object *r6;
	struct _jc_polyglot_util_Position$object *r7;
	struct _jc_polyglot_util_Position$object *r9;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = param0;
	_JC_LINE_NUMBER(105);				// 0
	if (r0 == _JC_NULL)
		goto label0;
	z0 = _JC_INVOKE_INTERFACE(env, r0, _JC_JLONG(0x551bea84f4e0f0cb), jboolean, (_jc_env *, struct _jc_object *));
	if (z0 == 0)
		goto label1;

label0:
	_JC_LINE_NUMBER(107);				// 1
	return _JC_NULL;

label1:
	_JC_LINE_NUMBER(110);				// 2
	r1 = _JC_INVOKE_INTERFACE(env, r0, _JC_JLONG(0xa706240e1333824b), _jc_object *, (_jc_env *, struct _jc_object *, jint), 0);
	_JC_LINE_NUMBER(112);				// 3
	z0 = _JC_INSTANCEOF(env, r1, &_jc_polyglot_ast_Node$type);
	if (z0 == 0)
		goto label4;
	r2 = r1;
	if (r2 != _JC_NULL)
		goto label2;
	r3 = _JC_NULL;
	goto label3;

label2:
	r6 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0xbb89333b1e4c840c), _jc_object *, (_jc_env *, struct _jc_object *));
	r3 = r6;

label3:
	return r3;

label4:
	_JC_LINE_NUMBER(113);				// 4
	z0 = _JC_INSTANCEOF(env, r1, &_jc_polyglot_lex_Token$type);
	if (z0 == 0)
		goto label7;
	r4 = r1;
	if (r4 != _JC_NULL)
		goto label5;
	r3 = _JC_NULL;
	goto label6;

label5:
	r7 = _JC_INVOKE_VIRTUAL(env, polyglot_lex_Token, getPosition$93950f582a09a82d, r4);
	r3 = r7;

label6:
	return r3;

label7:
	_JC_LINE_NUMBER(114);				// 5
	z0 = _JC_INSTANCEOF(env, r1, &_jc_polyglot_types_Type$type);
	if (z0 == 0)
		goto label10;
	r5 = r1;
	if (r5 != _JC_NULL)
		goto label8;
	r3 = _JC_NULL;
	goto label9;

label8:
	r9 = _JC_INVOKE_INTERFACE(env, r5, _JC_JLONG(0xbb89333b1e4c840c), _jc_object *, (_jc_env *, struct _jc_object *));
	r3 = r9;

label9:
	return r3;

label10:
	_JC_LINE_NUMBER(115);				// 6
	z0 = _JC_INSTANCEOF(env, r1, &_jc_java_util_List$type);
	if (z0 == 0)
		goto label11;
	r0 = r1;
	r3 = _JC_INVOKE_STATIC(env, polyglot_parse_BaseParser, pos$6ae606c7fda4c3f6, 1, r0);
	return r3;

label11:
	_JC_LINE_NUMBER(117);				// 7
	return _JC_NULL;
}

//
// public static polyglot.util.Position pos(polyglot.ast.Node)
//

static _jc_linenum _jc_polyglot_parse_BaseParser$linenum_table$pos$b42c13efbbc9d455[];

static const unsigned char _jc_polyglot_parse_BaseParser$param_ptypes$pos$b42c13efbbc9d455[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_parse_BaseParser$param_types$pos$b42c13efbbc9d455[] = {
	&_jc_polyglot_ast_Node$type
};

_jc_method _jc_polyglot_parse_BaseParser$method_info$pos$b42c13efbbc9d455 = {
	.name=			"pos",
	.signature=		"(Lpolyglot/ast/Node;)Lpolyglot/util/Position;",
	.class=			&_jc_polyglot_parse_BaseParser$type,
	.param_types=		&_jc_polyglot_parse_BaseParser$param_types$pos$b42c13efbbc9d455,
	.return_type=		&_jc_polyglot_util_Position$type,
	.param_ptypes=		&_jc_polyglot_parse_BaseParser$param_ptypes$pos$b42c13efbbc9d455,
	.signature_hash=	_JC_JLONG(0xb42c13efbbc9d455),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_polyglot_parse_BaseParser$method$pos$b42c13efbbc9d455,
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_polyglot_parse_BaseParser$linenum_table$pos$b42c13efbbc9d455
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_parse_BaseParser, pos$b42c13efbbc9d455);

_jc_polyglot_util_Position$object * _JC_JCNI_ATTR
_jc_polyglot_parse_BaseParser$method$pos$b42c13efbbc9d455(_jc_env *const env, _jc_object *param0)
{
	struct _jc_object *r0;
	struct _jc_polyglot_util_Position$object *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = param0;
	_JC_LINE_NUMBER(134);				// 0
	if (r0 != _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(136);				// 1
	return _JC_NULL;

label0:
	_JC_LINE_NUMBER(138);				// 2
	r1 = _JC_INVOKE_INTERFACE(env, r0, _JC_JLONG(0xbb89333b1e4c840c), _jc_object *, (_jc_env *, struct _jc_object *));
	return r1;
}

//
// public static polyglot.util.Position pos(polyglot.lex.Token)
//

static _jc_linenum _jc_polyglot_parse_BaseParser$linenum_table$pos$549cebdeb8108ac0[];

static const unsigned char _jc_polyglot_parse_BaseParser$param_ptypes$pos$549cebdeb8108ac0[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_parse_BaseParser$param_types$pos$549cebdeb8108ac0[] = {
	&_jc_polyglot_lex_Token$type
};

_jc_method _jc_polyglot_parse_BaseParser$method_info$pos$549cebdeb8108ac0 = {
	.name=			"pos",
	.signature=		"(Lpolyglot/lex/Token;)Lpolyglot/util/Position;",
	.class=			&_jc_polyglot_parse_BaseParser$type,
	.param_types=		&_jc_polyglot_parse_BaseParser$param_types$pos$549cebdeb8108ac0,
	.return_type=		&_jc_polyglot_util_Position$type,
	.param_ptypes=		&_jc_polyglot_parse_BaseParser$param_ptypes$pos$549cebdeb8108ac0,
	.signature_hash=	_JC_JLONG(0x549cebdeb8108ac0),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_polyglot_parse_BaseParser$method$pos$549cebdeb8108ac0,
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_polyglot_parse_BaseParser$linenum_table$pos$549cebdeb8108ac0
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_parse_BaseParser, pos$549cebdeb8108ac0);

_jc_polyglot_util_Position$object * _JC_JCNI_ATTR
_jc_polyglot_parse_BaseParser$method$pos$549cebdeb8108ac0(_jc_env *const env, _jc_polyglot_lex_Token$object *param0)
{
	struct _jc_polyglot_lex_Token$object *r0;
	struct _jc_polyglot_util_Position$object *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = param0;
	_JC_LINE_NUMBER(87);				// 0
	if (r0 != _JC_NULL)
		goto label0;
	return _JC_NULL;

label0:
	_JC_LINE_NUMBER(88);				// 1
	r1 = _JC_INVOKE_VIRTUAL(env, polyglot_lex_Token, getPosition$93950f582a09a82d, r0);
	return r1;
}

//
// public static polyglot.util.Position pos(polyglot.parse.VarDeclarator)
//

static _jc_linenum _jc_polyglot_parse_BaseParser$linenum_table$pos$f817290d1ed9d153[];

static const unsigned char _jc_polyglot_parse_BaseParser$param_ptypes$pos$f817290d1ed9d153[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_parse_BaseParser$param_types$pos$f817290d1ed9d153[] = {
	&_jc_polyglot_parse_VarDeclarator$type
};

_jc_method _jc_polyglot_parse_BaseParser$method_info$pos$f817290d1ed9d153 = {
	.name=			"pos",
	.signature=		"(Lpolyglot/parse/VarDeclarator;)Lpolyglot/util/Position;",
	.class=			&_jc_polyglot_parse_BaseParser$type,
	.param_types=		&_jc_polyglot_parse_BaseParser$param_types$pos$f817290d1ed9d153,
	.return_type=		&_jc_polyglot_util_Position$type,
	.param_ptypes=		&_jc_polyglot_parse_BaseParser$param_ptypes$pos$f817290d1ed9d153,
	.signature_hash=	_JC_JLONG(0xf817290d1ed9d153),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_polyglot_parse_BaseParser$method$pos$f817290d1ed9d153,
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_polyglot_parse_BaseParser$linenum_table$pos$f817290d1ed9d153
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_parse_BaseParser, pos$f817290d1ed9d153);

_jc_polyglot_util_Position$object * _JC_JCNI_ATTR
_jc_polyglot_parse_BaseParser$method$pos$f817290d1ed9d153(_jc_env *const env, _jc_polyglot_parse_VarDeclarator$object *param0)
{
	struct _jc_polyglot_parse_VarDeclarator$object *r0;
	struct _jc_polyglot_util_Position$object *r1;

	r0 = param0;
	_JC_LINE_NUMBER(125);				// 0
	if (r0 != _JC_NULL)
		goto label0;
	return _JC_NULL;

label0:
	_JC_LINE_NUMBER(126);				// 1
	r1 = _JC_REF_FIELD(env, r0, polyglot_parse_VarDeclarator, pos);
	return r1;
}

//
// public static polyglot.util.Position pos(polyglot.types.Type)
//

static _jc_linenum _jc_polyglot_parse_BaseParser$linenum_table$pos$f930bfa683da28a2[];

static const unsigned char _jc_polyglot_parse_BaseParser$param_ptypes$pos$f930bfa683da28a2[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_parse_BaseParser$param_types$pos$f930bfa683da28a2[] = {
	&_jc_polyglot_types_Type$type
};

_jc_method _jc_polyglot_parse_BaseParser$method_info$pos$f930bfa683da28a2 = {
	.name=			"pos",
	.signature=		"(Lpolyglot/types/Type;)Lpolyglot/util/Position;",
	.class=			&_jc_polyglot_parse_BaseParser$type,
	.param_types=		&_jc_polyglot_parse_BaseParser$param_types$pos$f930bfa683da28a2,
	.return_type=		&_jc_polyglot_util_Position$type,
	.param_ptypes=		&_jc_polyglot_parse_BaseParser$param_ptypes$pos$f930bfa683da28a2,
	.signature_hash=	_JC_JLONG(0xf930bfa683da28a2),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_polyglot_parse_BaseParser$method$pos$f930bfa683da28a2,
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_polyglot_parse_BaseParser$linenum_table$pos$f930bfa683da28a2
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_parse_BaseParser, pos$f930bfa683da28a2);

_jc_polyglot_util_Position$object * _JC_JCNI_ATTR
_jc_polyglot_parse_BaseParser$method$pos$f930bfa683da28a2(_jc_env *const env, _jc_object *param0)
{
	struct _jc_object *r0;
	struct _jc_polyglot_util_Position$object *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = param0;
	_JC_LINE_NUMBER(96);				// 0
	if (r0 != _JC_NULL)
		goto label0;
	return _JC_NULL;

label0:
	_JC_LINE_NUMBER(97);				// 1
	r1 = _JC_INVOKE_INTERFACE(env, r0, _JC_JLONG(0xbb89333b1e4c840c), _jc_object *, (_jc_env *, struct _jc_object *));
	return r1;
}

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// public void <init>(polyglot.lex.Lexer, polyglot.types.TypeSystem, polyglot.ast.NodeFactory, polyglot.util.ErrorQueue)
//

static _jc_linenum _jc_polyglot_parse_BaseParser$linenum_table$_init$45e4d872e3394688[];

static const unsigned char _jc_polyglot_parse_BaseParser$param_ptypes$_init$45e4d872e3394688[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_parse_BaseParser$param_types$_init$45e4d872e3394688[] = {
	&_jc_polyglot_lex_Lexer$type,
	&_jc_polyglot_types_TypeSystem$type,
	&_jc_polyglot_ast_NodeFactory$type,
	&_jc_polyglot_util_ErrorQueue$type
};

_jc_method _jc_polyglot_parse_BaseParser$method_info$_init$45e4d872e3394688 = {
	.name=			"<init>",
	.signature=		"(Lpolyglot/lex/Lexer;Lpolyglot/types/TypeSystem;Lpolyglot/ast/NodeFactory;Lpolyglot/util/ErrorQueue;)V",
	.class=			&_jc_polyglot_parse_BaseParser$type,
	.param_types=		&_jc_polyglot_parse_BaseParser$param_types$_init$45e4d872e3394688,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_parse_BaseParser$param_ptypes$_init$45e4d872e3394688,
	.signature_hash=	_JC_JLONG(0x45e4d872e3394688),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_parse_BaseParser$method$_init$45e4d872e3394688,
	.num_parameters=	4,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	7,
	      .table=	_jc_polyglot_parse_BaseParser$linenum_table$_init$45e4d872e3394688
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_parse_BaseParser, _init$45e4d872e3394688);

void _JC_JCNI_ATTR
_jc_polyglot_parse_BaseParser$method$_init$45e4d872e3394688(_jc_env *const env, _jc_polyglot_parse_BaseParser$object *this, _jc_object *param0, _jc_object *param1, _jc_object *param2, _jc_object *param3)
{
	struct _jc_polyglot_parse_BaseParser$object *r0;
	struct _jc_object *r1;
	struct _jc_object *r2;
	struct _jc_object *r3;
	struct _jc_object *r4;
	struct _jc_polyglot_util_Position$object *r5;
	struct _jc_java_util_Stack$object *r6;
	_jc_object_array *r7;

	r0 = this;
	r1 = param0;
	r2 = param1;
	r3 = param2;
	r4 = param3;
	_JC_PRIM_FIELD(env, r0, java__5fcup_runtime_lr__5fparser, __5fdone__5fparsing) = 0;
	r6 = _JC_NEW(env, java_util_Stack);
	r7 = _JC_NEW_REF_ARRAY(env, java_lang_Object, 1, 10);
	_JC_REF_FIELD(env, r6, java_util_Vector, elementData) = r7;
	_JC_PRIM_FIELD(env, r6, java_util_Vector, capacityIncrement) = 0;
	_JC_REF_FIELD(env, r0, java__5fcup_runtime_lr__5fparser, stack) = r6;
	_JC_LINE_NUMBER(21);				// 0
	_JC_REF_FIELD(env, r0, polyglot_parse_BaseParser, lexer) = r1;
	_JC_LINE_NUMBER(22);				// 1
	_JC_REF_FIELD(env, r0, polyglot_parse_BaseParser, eq) = r4;
	_JC_LINE_NUMBER(23);				// 2
	_JC_REF_FIELD(env, r0, polyglot_parse_BaseParser, ts) = r2;
	_JC_LINE_NUMBER(24);				// 3
	_JC_REF_FIELD(env, r0, polyglot_parse_BaseParser, nf) = r3;
	_JC_LINE_NUMBER(25);				// 4
	r5 = _JC_STATIC_FIELD(env, polyglot_util_Position, COMPILER__5fGENERATED, 0);
	_JC_REF_FIELD(env, r0, polyglot_parse_BaseParser, prev__5fpos) = r5;
	_JC_LINE_NUMBER(26);				// 5
	r5 = _JC_STATIC_FIELD(env, polyglot_util_Position, COMPILER__5fGENERATED, 1);
	_JC_REF_FIELD(env, r0, polyglot_parse_BaseParser, position) = r5;
	_JC_LINE_NUMBER(27);				// 6
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public polyglot.ast.TypeNode array(polyglot.ast.TypeNode, int) throws java.lang.Exception
//

static _jc_linenum _jc_polyglot_parse_BaseParser$linenum_table$array$a1877cd5102af918[];

static const unsigned char _jc_polyglot_parse_BaseParser$param_ptypes$array$a1877cd5102af918[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_parse_BaseParser$exceptions$array$a1877cd5102af918[] = {
	&_jc_java_lang_Exception$type
};

static _jc_type *const _jc_polyglot_parse_BaseParser$param_types$array$a1877cd5102af918[] = {
	&_jc_polyglot_ast_TypeNode$type,
	&_jc_int$prim$type
};

_jc_method _jc_polyglot_parse_BaseParser$method_info$array$a1877cd5102af918 = {
	.name=			"array",
	.signature=		"(Lpolyglot/ast/TypeNode;I)Lpolyglot/ast/TypeNode;",
	.class=			&_jc_polyglot_parse_BaseParser$type,
	.param_types=		&_jc_polyglot_parse_BaseParser$param_types$array$a1877cd5102af918,
	.return_type=		&_jc_polyglot_ast_TypeNode$type,
	.param_ptypes=		&_jc_polyglot_parse_BaseParser$param_ptypes$array$a1877cd5102af918,
	.signature_hash=	_JC_JLONG(0xa1877cd5102af918),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_parse_BaseParser$method$array$a1877cd5102af918,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_parse_BaseParser$vtable, polyglot_parse_BaseParser.array$a1877cd5102af918) / sizeof(void *),
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_parse_BaseParser$exceptions$array$a1877cd5102af918,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	6,
	      .table=	_jc_polyglot_parse_BaseParser$linenum_table$array$a1877cd5102af918
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_parse_BaseParser, array$a1877cd5102af918);

_jc_object * _JC_JCNI_ATTR
_jc_polyglot_parse_BaseParser$method$array$a1877cd5102af918(_jc_env *const env, _jc_polyglot_parse_BaseParser$object *this, _jc_object *param0, jint param1)
{
	jint i0;
	struct _jc_polyglot_parse_BaseParser$object *r0;
	struct _jc_object *r1;
	struct _jc_polyglot_util_Position$object *r11;
	struct _jc_object *r2;
	struct _jc_object *r3;
	struct _jc_object *r4;
	struct _jc_polyglot_util_Position$object *r5;
	struct _jc_object *r6;
	struct _jc_object *r7;
	struct _jc_object *r8;
	struct _jc_polyglot_util_Position$object *r9;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	i0 = param1;
	_JC_LINE_NUMBER(147);				// 0
	if (i0 <= 0)
		goto label5;
	_JC_LINE_NUMBER(149);				// 1
	z0 = _JC_INSTANCEOF(env, r1, &_jc_polyglot_ast_CanonicalTypeNode$type);
	if (z0 == 0)
		goto label2;
	_JC_LINE_NUMBER(151);				// 2
	r3 = r1;
	r2 = _JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0xb7282830a20ab2a3), _jc_object *, (_jc_env *, struct _jc_object *));
	_JC_LINE_NUMBER(152);				// 3
	r4 = _JC_REF_FIELD(env, r0, polyglot_parse_BaseParser, nf);
	if (r1 != _JC_NULL)
		goto label0;
	r5 = _JC_NULL;
	goto label1;

label0:
	r9 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0xbb89333b1e4c840c), _jc_object *, (_jc_env *, struct _jc_object *));
	r5 = r9;

label1:
	r6 = _JC_REF_FIELD(env, r0, polyglot_parse_BaseParser, ts);
	r7 = _JC_INVOKE_INTERFACE(env, r6, _JC_JLONG(0xbddcfdf10cebaed0), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_object *, jint), r2, i0);
	r3 = _JC_INVOKE_INTERFACE(env, r4, _JC_JLONG(0x890196a84d160f7e), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_polyglot_util_Position$object *, struct _jc_object *), r5, r7);
	return r3;

label2:
	_JC_LINE_NUMBER(154);				// 4
	r4 = _JC_REF_FIELD(env, r0, polyglot_parse_BaseParser, nf);
	if (r1 != _JC_NULL)
		goto label3;
	r5 = _JC_NULL;
	goto label4;

label3:
	r11 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0xbb89333b1e4c840c), _jc_object *, (_jc_env *, struct _jc_object *));
	r5 = r11;

label4:
	i0 = i0 - 1;
	r1 = _JC_INVOKE_VIRTUAL(env, polyglot_parse_BaseParser, array$a1877cd5102af918, r0, r1, i0);
	r8 = _JC_INVOKE_INTERFACE(env, r4, _JC_JLONG(0x48e0ba1bf755eeec), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_polyglot_util_Position$object *, struct _jc_object *), r5, r1);
	return r8;

label5:
	_JC_LINE_NUMBER(158);				// 5
	return r1;
}

//
// public void die() throws java.lang.Exception
//

static _jc_linenum _jc_polyglot_parse_BaseParser$linenum_table$die$e8cd32d55f5e0014[];

static const unsigned char _jc_polyglot_parse_BaseParser$param_ptypes$die$e8cd32d55f5e0014[] = { 
_JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_parse_BaseParser$exceptions$die$e8cd32d55f5e0014[] = {
	&_jc_java_lang_Exception$type
};

_jc_method _jc_polyglot_parse_BaseParser$method_info$die$e8cd32d55f5e0014 = {
	.name=			"die",
	.signature=		"()V",
	.class=			&_jc_polyglot_parse_BaseParser$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_parse_BaseParser$param_ptypes$die$e8cd32d55f5e0014,
	.signature_hash=	_JC_JLONG(0xe8cd32d55f5e0014),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_parse_BaseParser$method$die$e8cd32d55f5e0014,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_parse_BaseParser$vtable, polyglot_parse_BaseParser.die$e8cd32d55f5e0014) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_parse_BaseParser$exceptions$die$e8cd32d55f5e0014,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_parse_BaseParser$linenum_table$die$e8cd32d55f5e0014
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_parse_BaseParser, die$e8cd32d55f5e0014);

void _JC_JCNI_ATTR
_jc_polyglot_parse_BaseParser$method$die$e8cd32d55f5e0014(_jc_env *const env, _jc_polyglot_parse_BaseParser$object *this)
{
	struct _jc_polyglot_parse_BaseParser$object *r0;
	struct _jc_java_lang_Exception$object *r1;
	struct _jc_java_lang_String$object *r2;
	struct _jc_java_lang_VMThrowable$object *r4;

	r0 = this;
	_JC_LINE_NUMBER(79);				// 0
	r1 = _JC_NEW(env, java_lang_Exception);
	r2 = _JC_STRING(env, "Couldn't repair and continue parse");
	_JC_REF_FIELD(env, r1, java_lang_Throwable, cause) = r1;
	r4 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r1);
	_JC_REF_FIELD(env, r1, java_lang_Throwable, vmState) = r4;
	_JC_REF_FIELD(env, r1, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r1, java_lang_Throwable, detailMessage) = r2;
	_JC_THROW(env, r1);
}

//
// public void die(java.lang.String, polyglot.util.Position) throws java.lang.Exception
//

static _jc_linenum _jc_polyglot_parse_BaseParser$linenum_table$die$26185bdff07702dd[];

static const unsigned char _jc_polyglot_parse_BaseParser$param_ptypes$die$26185bdff07702dd[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_parse_BaseParser$exceptions$die$26185bdff07702dd[] = {
	&_jc_java_lang_Exception$type
};

static _jc_type *const _jc_polyglot_parse_BaseParser$param_types$die$26185bdff07702dd[] = {
	&_jc_java_lang_String$type,
	&_jc_polyglot_util_Position$type
};

_jc_method _jc_polyglot_parse_BaseParser$method_info$die$26185bdff07702dd = {
	.name=			"die",
	.signature=		"(Ljava/lang/String;Lpolyglot/util/Position;)V",
	.class=			&_jc_polyglot_parse_BaseParser$type,
	.param_types=		&_jc_polyglot_parse_BaseParser$param_types$die$26185bdff07702dd,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_parse_BaseParser$param_ptypes$die$26185bdff07702dd,
	.signature_hash=	_JC_JLONG(0x26185bdff07702dd),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_parse_BaseParser$method$die$26185bdff07702dd,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_parse_BaseParser$vtable, polyglot_parse_BaseParser.die$26185bdff07702dd) / sizeof(void *),
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_parse_BaseParser$exceptions$die$26185bdff07702dd,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_polyglot_parse_BaseParser$linenum_table$die$26185bdff07702dd
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_parse_BaseParser, die$26185bdff07702dd);

void _JC_JCNI_ATTR
_jc_polyglot_parse_BaseParser$method$die$26185bdff07702dd(_jc_env *const env, _jc_polyglot_parse_BaseParser$object *this, _jc_java_lang_String$object *param0, _jc_polyglot_util_Position$object *param1)
{
	struct _jc_polyglot_parse_BaseParser$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_polyglot_util_Position$object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_LINE_NUMBER(63);				// 0
	_JC_INVOKE_VIRTUAL(env, polyglot_parse_BaseParser, report__5ffatal__5ferror$5ee52bbba05fbca8, r0, r1, r2);
	_JC_LINE_NUMBER(64);				// 1
	return;
}

//
// public void die(polyglot.util.Position) throws java.lang.Exception
//

static _jc_linenum _jc_polyglot_parse_BaseParser$linenum_table$die$2a04cd99f4266314[];

static const unsigned char _jc_polyglot_parse_BaseParser$param_ptypes$die$2a04cd99f4266314[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_parse_BaseParser$exceptions$die$2a04cd99f4266314[] = {
	&_jc_java_lang_Exception$type
};

static _jc_type *const _jc_polyglot_parse_BaseParser$param_types$die$2a04cd99f4266314[] = {
	&_jc_polyglot_util_Position$type
};

_jc_method _jc_polyglot_parse_BaseParser$method_info$die$2a04cd99f4266314 = {
	.name=			"die",
	.signature=		"(Lpolyglot/util/Position;)V",
	.class=			&_jc_polyglot_parse_BaseParser$type,
	.param_types=		&_jc_polyglot_parse_BaseParser$param_types$die$2a04cd99f4266314,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_parse_BaseParser$param_ptypes$die$2a04cd99f4266314,
	.signature_hash=	_JC_JLONG(0x2a04cd99f4266314),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_parse_BaseParser$method$die$2a04cd99f4266314,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_parse_BaseParser$vtable, polyglot_parse_BaseParser.die$2a04cd99f4266314) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_parse_BaseParser$exceptions$die$2a04cd99f4266314,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_polyglot_parse_BaseParser$linenum_table$die$2a04cd99f4266314
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_parse_BaseParser, die$2a04cd99f4266314);

void _JC_JCNI_ATTR
_jc_polyglot_parse_BaseParser$method$die$2a04cd99f4266314(_jc_env *const env, _jc_polyglot_parse_BaseParser$object *this, _jc_polyglot_util_Position$object *param0)
{
	struct _jc_polyglot_parse_BaseParser$object *r0;
	struct _jc_polyglot_util_Position$object *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(71);				// 0
	_JC_INVOKE_VIRTUAL(env, polyglot_parse_BaseParser, report__5ffatal__5ferror$5ee52bbba05fbca8, r0, _JC_STRING(env, "Syntax error."), r1);
	_JC_LINE_NUMBER(72);				// 1
	return;
}

//
// protected polyglot.ast.QualifierNode exprToQualifier(polyglot.ast.Expr) throws java.lang.Exception
//

static _jc_linenum _jc_polyglot_parse_BaseParser$linenum_table$exprToQualifier$3feb7c91fcf83f5e[];

static const unsigned char _jc_polyglot_parse_BaseParser$param_ptypes$exprToQualifier$3feb7c91fcf83f5e[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_parse_BaseParser$exceptions$exprToQualifier$3feb7c91fcf83f5e[] = {
	&_jc_java_lang_Exception$type
};

static _jc_type *const _jc_polyglot_parse_BaseParser$param_types$exprToQualifier$3feb7c91fcf83f5e[] = {
	&_jc_polyglot_ast_Expr$type
};

_jc_method _jc_polyglot_parse_BaseParser$method_info$exprToQualifier$3feb7c91fcf83f5e = {
	.name=			"exprToQualifier",
	.signature=		"(Lpolyglot/ast/Expr;)Lpolyglot/ast/QualifierNode;",
	.class=			&_jc_polyglot_parse_BaseParser$type,
	.param_types=		&_jc_polyglot_parse_BaseParser$param_types$exprToQualifier$3feb7c91fcf83f5e,
	.return_type=		&_jc_polyglot_ast_QualifierNode$type,
	.param_ptypes=		&_jc_polyglot_parse_BaseParser$param_ptypes$exprToQualifier$3feb7c91fcf83f5e,
	.signature_hash=	_JC_JLONG(0x3feb7c91fcf83f5e),
	.access_flags=		_JC_ACC_PROTECTED,
	.function=		&_jc_polyglot_parse_BaseParser$method$exprToQualifier$3feb7c91fcf83f5e,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_parse_BaseParser$vtable, polyglot_parse_BaseParser.exprToQualifier$3feb7c91fcf83f5e) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_parse_BaseParser$exceptions$exprToQualifier$3feb7c91fcf83f5e,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	9,
	      .table=	_jc_polyglot_parse_BaseParser$linenum_table$exprToQualifier$3feb7c91fcf83f5e
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_parse_BaseParser, exprToQualifier$3feb7c91fcf83f5e);

_jc_object * _JC_JCNI_ATTR
_jc_polyglot_parse_BaseParser$method$exprToQualifier$3feb7c91fcf83f5e(_jc_env *const env, _jc_polyglot_parse_BaseParser$object *this, _jc_object *param0)
{
	struct _jc_polyglot_parse_BaseParser$object *r0;
	struct _jc_object *r1;
	struct _jc_polyglot_util_Position$object *r10;
	struct _jc_polyglot_util_Position$object *r11;
	struct _jc_polyglot_util_Position$object *r13;
	struct _jc_object *r2;
	struct _jc_object *r3;
	struct _jc_object *r4;
	struct _jc_polyglot_util_Position$object *r5;
	struct _jc_java_lang_String$object *r6;
	struct _jc_object *r7;
	struct _jc_object *r8;
	struct _jc_object *r9;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(241);				// 0
	z0 = _JC_INSTANCEOF(env, r1, &_jc_polyglot_ast_AmbExpr$type);
	if (z0 == 0)
		goto label2;
	_JC_LINE_NUMBER(243);				// 1
	r2 = r1;
	_JC_LINE_NUMBER(244);				// 2
	r4 = _JC_REF_FIELD(env, r0, polyglot_parse_BaseParser, nf);
	if (r1 != _JC_NULL)
		goto label0;
	r5 = _JC_NULL;
	goto label1;

label0:
	r10 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0xbb89333b1e4c840c), _jc_object *, (_jc_env *, struct _jc_object *));
	r5 = r10;

label1:
	r6 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0xe6acce026cadf81e), _jc_object *, (_jc_env *, struct _jc_object *));
	r7 = _JC_INVOKE_INTERFACE(env, r4, _JC_JLONG(0x3597228dd5d66acc), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_polyglot_util_Position$object *, struct _jc_java_lang_String$object *), r5, r6);
	return r7;

label2:
	_JC_LINE_NUMBER(247);				// 3
	z0 = _JC_INSTANCEOF(env, r1, &_jc_polyglot_ast_Field$type);
	if (z0 == 0)
		goto label5;
	_JC_LINE_NUMBER(249);				// 4
	r8 = r1;
	_JC_LINE_NUMBER(250);				// 5
	r3 = _JC_INVOKE_INTERFACE(env, r8, _JC_JLONG(0x7a4a7568efda79d), _jc_object *, (_jc_env *, struct _jc_object *));
	_JC_LINE_NUMBER(251);				// 6
	r4 = _JC_REF_FIELD(env, r0, polyglot_parse_BaseParser, nf);
	if (r1 != _JC_NULL)
		goto label3;
	r5 = _JC_NULL;
	goto label4;

label3:
	r11 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0xbb89333b1e4c840c), _jc_object *, (_jc_env *, struct _jc_object *));
	r5 = r11;

label4:
	r9 = _JC_INVOKE_VIRTUAL(env, polyglot_parse_BaseParser, prefixToQualifier$0ac9a911c9db29c8, r0, r3);
	r6 = _JC_INVOKE_INTERFACE(env, r8, _JC_JLONG(0xe6acce026cadf81e), _jc_object *, (_jc_env *, struct _jc_object *));
	r7 = _JC_INVOKE_INTERFACE(env, r4, _JC_JLONG(0xd31dd8979b61fb53), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_polyglot_util_Position$object *, struct _jc_object *, struct _jc_java_lang_String$object *), r5, r9, r6);
	return r7;

label5:
	if (r1 != _JC_NULL)
		goto label6;
	r5 = _JC_NULL;
	goto label7;

label6:
	r13 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0xbb89333b1e4c840c), _jc_object *, (_jc_env *, struct _jc_object *));
	r5 = r13;

label7:
	_JC_LINE_NUMBER(255);				// 7
	_JC_INVOKE_VIRTUAL(env, polyglot_parse_BaseParser, die$2a04cd99f4266314, r0, r5);
	_JC_LINE_NUMBER(256);				// 8
	return _JC_NULL;
}

//
// public polyglot.ast.TypeNode exprToType(polyglot.ast.Expr) throws java.lang.Exception
//

static _jc_linenum _jc_polyglot_parse_BaseParser$linenum_table$exprToType$46d40b31072a20b6[];

static const unsigned char _jc_polyglot_parse_BaseParser$param_ptypes$exprToType$46d40b31072a20b6[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_parse_BaseParser$exceptions$exprToType$46d40b31072a20b6[] = {
	&_jc_java_lang_Exception$type
};

static _jc_type *const _jc_polyglot_parse_BaseParser$param_types$exprToType$46d40b31072a20b6[] = {
	&_jc_polyglot_ast_Expr$type
};

_jc_method _jc_polyglot_parse_BaseParser$method_info$exprToType$46d40b31072a20b6 = {
	.name=			"exprToType",
	.signature=		"(Lpolyglot/ast/Expr;)Lpolyglot/ast/TypeNode;",
	.class=			&_jc_polyglot_parse_BaseParser$type,
	.param_types=		&_jc_polyglot_parse_BaseParser$param_types$exprToType$46d40b31072a20b6,
	.return_type=		&_jc_polyglot_ast_TypeNode$type,
	.param_ptypes=		&_jc_polyglot_parse_BaseParser$param_ptypes$exprToType$46d40b31072a20b6,
	.signature_hash=	_JC_JLONG(0x46d40b31072a20b6),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_parse_BaseParser$method$exprToType$46d40b31072a20b6,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_parse_BaseParser$vtable, polyglot_parse_BaseParser.exprToType$46d40b31072a20b6) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_parse_BaseParser$exceptions$exprToType$46d40b31072a20b6,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	9,
	      .table=	_jc_polyglot_parse_BaseParser$linenum_table$exprToType$46d40b31072a20b6
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_parse_BaseParser, exprToType$46d40b31072a20b6);

_jc_object * _JC_JCNI_ATTR
_jc_polyglot_parse_BaseParser$method$exprToType$46d40b31072a20b6(_jc_env *const env, _jc_polyglot_parse_BaseParser$object *this, _jc_object *param0)
{
	struct _jc_polyglot_parse_BaseParser$object *r0;
	struct _jc_object *r1;
	struct _jc_polyglot_util_Position$object *r10;
	struct _jc_polyglot_util_Position$object *r11;
	struct _jc_polyglot_util_Position$object *r13;
	struct _jc_object *r2;
	struct _jc_object *r3;
	struct _jc_object *r4;
	struct _jc_polyglot_util_Position$object *r5;
	struct _jc_java_lang_String$object *r6;
	struct _jc_object *r7;
	struct _jc_object *r8;
	struct _jc_object *r9;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(265);				// 0
	z0 = _JC_INSTANCEOF(env, r1, &_jc_polyglot_ast_AmbExpr$type);
	if (z0 == 0)
		goto label2;
	_JC_LINE_NUMBER(267);				// 1
	r2 = r1;
	_JC_LINE_NUMBER(268);				// 2
	r4 = _JC_REF_FIELD(env, r0, polyglot_parse_BaseParser, nf);
	if (r1 != _JC_NULL)
		goto label0;
	r5 = _JC_NULL;
	goto label1;

label0:
	r10 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0xbb89333b1e4c840c), _jc_object *, (_jc_env *, struct _jc_object *));
	r5 = r10;

label1:
	r6 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0xe6acce026cadf81e), _jc_object *, (_jc_env *, struct _jc_object *));
	r7 = _JC_INVOKE_INTERFACE(env, r4, _JC_JLONG(0xd16ef84e3f5624af), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_polyglot_util_Position$object *, struct _jc_java_lang_String$object *), r5, r6);
	return r7;

label2:
	_JC_LINE_NUMBER(271);				// 3
	z0 = _JC_INSTANCEOF(env, r1, &_jc_polyglot_ast_Field$type);
	if (z0 == 0)
		goto label5;
	_JC_LINE_NUMBER(273);				// 4
	r8 = r1;
	_JC_LINE_NUMBER(274);				// 5
	r3 = _JC_INVOKE_INTERFACE(env, r8, _JC_JLONG(0x7a4a7568efda79d), _jc_object *, (_jc_env *, struct _jc_object *));
	_JC_LINE_NUMBER(275);				// 6
	r4 = _JC_REF_FIELD(env, r0, polyglot_parse_BaseParser, nf);
	if (r1 != _JC_NULL)
		goto label3;
	r5 = _JC_NULL;
	goto label4;

label3:
	r11 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0xbb89333b1e4c840c), _jc_object *, (_jc_env *, struct _jc_object *));
	r5 = r11;

label4:
	r9 = _JC_INVOKE_VIRTUAL(env, polyglot_parse_BaseParser, prefixToQualifier$0ac9a911c9db29c8, r0, r3);
	r6 = _JC_INVOKE_INTERFACE(env, r8, _JC_JLONG(0xe6acce026cadf81e), _jc_object *, (_jc_env *, struct _jc_object *));
	r7 = _JC_INVOKE_INTERFACE(env, r4, _JC_JLONG(0xb00280966cac4cbb), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_polyglot_util_Position$object *, struct _jc_object *, struct _jc_java_lang_String$object *), r5, r9, r6);
	return r7;

label5:
	if (r1 != _JC_NULL)
		goto label6;
	r5 = _JC_NULL;
	goto label7;

label6:
	r13 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0xbb89333b1e4c840c), _jc_object *, (_jc_env *, struct _jc_object *));
	r5 = r13;

label7:
	_JC_LINE_NUMBER(278);				// 7
	_JC_INVOKE_VIRTUAL(env, polyglot_parse_BaseParser, die$2a04cd99f4266314, r0, r5);
	_JC_LINE_NUMBER(279);				// 8
	return _JC_NULL;
}

//
// public java_cup.runtime.Symbol nextSymbol() throws java.io.IOException
//

static _jc_linenum _jc_polyglot_parse_BaseParser$linenum_table$nextSymbol$3f54f2881e423074[];

static const unsigned char _jc_polyglot_parse_BaseParser$param_ptypes$nextSymbol$3f54f2881e423074[] = { 
_JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_parse_BaseParser$exceptions$nextSymbol$3f54f2881e423074[] = {
	&_jc_java_io_IOException$type
};

_jc_method _jc_polyglot_parse_BaseParser$method_info$nextSymbol$3f54f2881e423074 = {
	.name=			"nextSymbol",
	.signature=		"()Ljava_cup/runtime/Symbol;",
	.class=			&_jc_polyglot_parse_BaseParser$type,
	.return_type=		&_jc_java__5fcup_runtime_Symbol$type,
	.param_ptypes=		&_jc_polyglot_parse_BaseParser$param_ptypes$nextSymbol$3f54f2881e423074,
	.signature_hash=	_JC_JLONG(0x3f54f2881e423074),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_parse_BaseParser$method$nextSymbol$3f54f2881e423074,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_parse_BaseParser$vtable, polyglot_parse_BaseParser.nextSymbol$3f54f2881e423074) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_parse_BaseParser$exceptions$nextSymbol$3f54f2881e423074,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_polyglot_parse_BaseParser$linenum_table$nextSymbol$3f54f2881e423074
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_parse_BaseParser, nextSymbol$3f54f2881e423074);

_jc_java__5fcup_runtime_Symbol$object * _JC_JCNI_ATTR
_jc_polyglot_parse_BaseParser$method$nextSymbol$3f54f2881e423074(_jc_env *const env, _jc_polyglot_parse_BaseParser$object *this)
{
	struct _jc_polyglot_parse_BaseParser$object *r0;
	struct _jc_polyglot_lex_Token$object *r1;
	struct _jc_object *r2;
	struct _jc_polyglot_util_Position$object *r3;
	struct _jc_java__5fcup_runtime_Symbol$object *r5;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(35);				// 0
	r2 = _JC_REF_FIELD(env, r0, polyglot_parse_BaseParser, lexer);
	r1 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0x724fe336a652ae63), _jc_object *, (_jc_env *, struct _jc_object *));
	_JC_LINE_NUMBER(37);				// 1
	r3 = _JC_REF_FIELD(env, r0, polyglot_parse_BaseParser, prev__5fpos);
	_JC_REF_FIELD(env, r0, polyglot_parse_BaseParser, position) = r3;
	_JC_LINE_NUMBER(38);				// 2
	r3 = _JC_INVOKE_VIRTUAL(env, polyglot_lex_Token, getPosition$93950f582a09a82d, r1);
	_JC_REF_FIELD(env, r0, polyglot_parse_BaseParser, prev__5fpos) = r3;
	_JC_LINE_NUMBER(39);				// 3
	r5 = _JC_INVOKE_VIRTUAL(env, polyglot_lex_Token, symbol$4d0189d5e9737af4, r1);
	return r5;
}

//
// public polyglot.util.Position position()
//

static _jc_linenum _jc_polyglot_parse_BaseParser$linenum_table$position$bb89333b1e4c840c[];

static const unsigned char _jc_polyglot_parse_BaseParser$param_ptypes$position$bb89333b1e4c840c[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_parse_BaseParser$method_info$position$bb89333b1e4c840c = {
	.name=			"position",
	.signature=		"()Lpolyglot/util/Position;",
	.class=			&_jc_polyglot_parse_BaseParser$type,
	.return_type=		&_jc_polyglot_util_Position$type,
	.param_ptypes=		&_jc_polyglot_parse_BaseParser$param_ptypes$position$bb89333b1e4c840c,
	.signature_hash=	_JC_JLONG(0xbb89333b1e4c840c),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_parse_BaseParser$method$position$bb89333b1e4c840c,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_parse_BaseParser$vtable, polyglot_parse_BaseParser.position$bb89333b1e4c840c) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_parse_BaseParser$linenum_table$position$bb89333b1e4c840c
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_parse_BaseParser, position$bb89333b1e4c840c);

_jc_polyglot_util_Position$object * _JC_JCNI_ATTR
_jc_polyglot_parse_BaseParser$method$position$bb89333b1e4c840c(_jc_env *const env, _jc_polyglot_parse_BaseParser$object *this)
{
	struct _jc_polyglot_parse_BaseParser$object *r0;
	struct _jc_polyglot_util_Position$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(43);				// 0
	r1 = _JC_REF_FIELD(env, r0, polyglot_parse_BaseParser, position);
	return r1;
}

//
// protected polyglot.ast.QualifierNode prefixToQualifier(polyglot.ast.Prefix) throws java.lang.Exception
//

static _jc_linenum _jc_polyglot_parse_BaseParser$linenum_table$prefixToQualifier$0ac9a911c9db29c8[];

static const unsigned char _jc_polyglot_parse_BaseParser$param_ptypes$prefixToQualifier$0ac9a911c9db29c8[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_parse_BaseParser$exceptions$prefixToQualifier$0ac9a911c9db29c8[] = {
	&_jc_java_lang_Exception$type
};

static _jc_type *const _jc_polyglot_parse_BaseParser$param_types$prefixToQualifier$0ac9a911c9db29c8[] = {
	&_jc_polyglot_ast_Prefix$type
};

_jc_method _jc_polyglot_parse_BaseParser$method_info$prefixToQualifier$0ac9a911c9db29c8 = {
	.name=			"prefixToQualifier",
	.signature=		"(Lpolyglot/ast/Prefix;)Lpolyglot/ast/QualifierNode;",
	.class=			&_jc_polyglot_parse_BaseParser$type,
	.param_types=		&_jc_polyglot_parse_BaseParser$param_types$prefixToQualifier$0ac9a911c9db29c8,
	.return_type=		&_jc_polyglot_ast_QualifierNode$type,
	.param_ptypes=		&_jc_polyglot_parse_BaseParser$param_ptypes$prefixToQualifier$0ac9a911c9db29c8,
	.signature_hash=	_JC_JLONG(0xac9a911c9db29c8),
	.access_flags=		_JC_ACC_PROTECTED,
	.function=		&_jc_polyglot_parse_BaseParser$method$prefixToQualifier$0ac9a911c9db29c8,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_parse_BaseParser$vtable, polyglot_parse_BaseParser.prefixToQualifier$0ac9a911c9db29c8) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_parse_BaseParser$exceptions$prefixToQualifier$0ac9a911c9db29c8,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	16,
	      .table=	_jc_polyglot_parse_BaseParser$linenum_table$prefixToQualifier$0ac9a911c9db29c8
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_parse_BaseParser, prefixToQualifier$0ac9a911c9db29c8);

_jc_object * _JC_JCNI_ATTR
_jc_polyglot_parse_BaseParser$method$prefixToQualifier$0ac9a911c9db29c8(_jc_env *const env, _jc_polyglot_parse_BaseParser$object *this, _jc_object *param0)
{
	struct _jc_polyglot_parse_BaseParser$object *r0;
	struct _jc_object *r1;
	struct _jc_object *r10;
	struct _jc_object *r11;
	struct _jc_polyglot_util_Position$object *r12;
	struct _jc_polyglot_util_Position$object *r13;
	struct _jc_polyglot_util_Position$object *r14;
	struct _jc_polyglot_util_Position$object *r15;
	struct _jc_polyglot_util_Position$object *r17;
	struct _jc_object *r2;
	struct _jc_object *r3;
	struct _jc_object *r4;
	struct _jc_object *r5;
	struct _jc_object *r6;
	struct _jc_object *r7;
	struct _jc_polyglot_util_Position$object *r8;
	struct _jc_java_lang_String$object *r9;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(167);				// 0
	z0 = _JC_INSTANCEOF(env, r1, &_jc_polyglot_ast_TypeNode$type);
	if (z0 == 0)
		goto label0;
	_JC_LINE_NUMBER(169);				// 1
	r3 = r1;
	r4 = _JC_INVOKE_VIRTUAL(env, polyglot_parse_BaseParser, typeToQualifier$a761c9754e2009de, r0, r3);
	return r4;

label0:
	_JC_LINE_NUMBER(172);				// 2
	z0 = _JC_INSTANCEOF(env, r1, &_jc_polyglot_ast_Expr$type);
	if (z0 == 0)
		goto label1;
	_JC_LINE_NUMBER(174);				// 3
	r5 = r1;
	r4 = _JC_INVOKE_VIRTUAL(env, polyglot_parse_BaseParser, exprToQualifier$3feb7c91fcf83f5e, r0, r5);
	return r4;

label1:
	_JC_LINE_NUMBER(177);				// 4
	z0 = _JC_INSTANCEOF(env, r1, &_jc_polyglot_ast_AmbReceiver$type);
	if (z0 == 0)
		goto label7;
	_JC_LINE_NUMBER(179);				// 5
	r2 = r1;
	_JC_LINE_NUMBER(181);				// 6
	r6 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0x1fc55a8ef2322880), _jc_object *, (_jc_env *, struct _jc_object *));
	if (r6 == _JC_NULL)
		goto label4;
	_JC_LINE_NUMBER(183);				// 7
	r7 = _JC_REF_FIELD(env, r0, polyglot_parse_BaseParser, nf);
	if (r1 != _JC_NULL)
		goto label2;
	r8 = _JC_NULL;
	goto label3;

label2:
	r12 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0xbb89333b1e4c840c), _jc_object *, (_jc_env *, struct _jc_object *));
	r8 = r12;

label3:
	r6 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0x1fc55a8ef2322880), _jc_object *, (_jc_env *, struct _jc_object *));
	r4 = _JC_INVOKE_VIRTUAL(env, polyglot_parse_BaseParser, prefixToQualifier$0ac9a911c9db29c8, r0, r6);
	r9 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0xe6acce026cadf81e), _jc_object *, (_jc_env *, struct _jc_object *));
	r10 = _JC_INVOKE_INTERFACE(env, r7, _JC_JLONG(0xd31dd8979b61fb53), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_polyglot_util_Position$object *, struct _jc_object *, struct _jc_java_lang_String$object *), r8, r4, r9);
	return r10;

label4:
	_JC_LINE_NUMBER(189);				// 8
	r7 = _JC_REF_FIELD(env, r0, polyglot_parse_BaseParser, nf);
	if (r1 != _JC_NULL)
		goto label5;
	r8 = _JC_NULL;
	goto label6;

label5:
	r13 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0xbb89333b1e4c840c), _jc_object *, (_jc_env *, struct _jc_object *));
	r8 = r13;

label6:
	r9 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0xe6acce026cadf81e), _jc_object *, (_jc_env *, struct _jc_object *));
	r10 = _JC_INVOKE_INTERFACE(env, r7, _JC_JLONG(0x3597228dd5d66acc), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_polyglot_util_Position$object *, struct _jc_java_lang_String$object *), r8, r9);
	return r10;

label7:
	_JC_LINE_NUMBER(193);				// 9
	z0 = _JC_INSTANCEOF(env, r1, &_jc_polyglot_ast_AmbPrefix$type);
	if (z0 == 0)
		goto label13;
	_JC_LINE_NUMBER(195);				// 10
	r11 = r1;
	_JC_LINE_NUMBER(197);				// 11
	r6 = _JC_INVOKE_INTERFACE(env, r11, _JC_JLONG(0x1fc55a8ef2322880), _jc_object *, (_jc_env *, struct _jc_object *));
	if (r6 == _JC_NULL)
		goto label10;
	_JC_LINE_NUMBER(199);				// 12
	r7 = _JC_REF_FIELD(env, r0, polyglot_parse_BaseParser, nf);
	if (r1 != _JC_NULL)
		goto label8;
	r8 = _JC_NULL;
	goto label9;

label8:
	r14 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0xbb89333b1e4c840c), _jc_object *, (_jc_env *, struct _jc_object *));
	r8 = r14;

label9:
	r6 = _JC_INVOKE_INTERFACE(env, r11, _JC_JLONG(0x1fc55a8ef2322880), _jc_object *, (_jc_env *, struct _jc_object *));
	r4 = _JC_INVOKE_VIRTUAL(env, polyglot_parse_BaseParser, prefixToQualifier$0ac9a911c9db29c8, r0, r6);
	r9 = _JC_INVOKE_INTERFACE(env, r11, _JC_JLONG(0xe6acce026cadf81e), _jc_object *, (_jc_env *, struct _jc_object *));
	r10 = _JC_INVOKE_INTERFACE(env, r7, _JC_JLONG(0xd31dd8979b61fb53), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_polyglot_util_Position$object *, struct _jc_object *, struct _jc_java_lang_String$object *), r8, r4, r9);
	return r10;

label10:
	_JC_LINE_NUMBER(205);				// 13
	r7 = _JC_REF_FIELD(env, r0, polyglot_parse_BaseParser, nf);
	if (r1 != _JC_NULL)
		goto label11;
	r8 = _JC_NULL;
	goto label12;

label11:
	r15 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0xbb89333b1e4c840c), _jc_object *, (_jc_env *, struct _jc_object *));
	r8 = r15;

label12:
	r9 = _JC_INVOKE_INTERFACE(env, r11, _JC_JLONG(0xe6acce026cadf81e), _jc_object *, (_jc_env *, struct _jc_object *));
	r10 = _JC_INVOKE_INTERFACE(env, r7, _JC_JLONG(0x3597228dd5d66acc), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_polyglot_util_Position$object *, struct _jc_java_lang_String$object *), r8, r9);
	return r10;

label13:
	if (r1 != _JC_NULL)
		goto label14;
	r8 = _JC_NULL;
	goto label15;

label14:
	r17 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0xbb89333b1e4c840c), _jc_object *, (_jc_env *, struct _jc_object *));
	r8 = r17;

label15:
	_JC_LINE_NUMBER(209);				// 14
	_JC_INVOKE_VIRTUAL(env, polyglot_parse_BaseParser, die$2a04cd99f4266314, r0, r8);
	_JC_LINE_NUMBER(210);				// 15
	return _JC_NULL;
}

//
// public void report_fatal_error(java.lang.String, java.lang.Object) throws java.lang.Exception
//

static _jc_linenum _jc_polyglot_parse_BaseParser$linenum_table$report__5ffatal__5ferror$5ee52bbba05fbca8[];

static const unsigned char _jc_polyglot_parse_BaseParser$param_ptypes$report__5ffatal__5ferror$5ee52bbba05fbca8[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_parse_BaseParser$exceptions$report__5ffatal__5ferror$5ee52bbba05fbca8[] = {
	&_jc_java_lang_Exception$type
};

static _jc_type *const _jc_polyglot_parse_BaseParser$param_types$report__5ffatal__5ferror$5ee52bbba05fbca8[] = {
	&_jc_java_lang_String$type,
	&_jc_java_lang_Object$type
};

_jc_method _jc_polyglot_parse_BaseParser$method_info$report__5ffatal__5ferror$5ee52bbba05fbca8 = {
	.name=			"report_fatal_error",
	.signature=		"(Ljava/lang/String;Ljava/lang/Object;)V",
	.class=			&_jc_polyglot_parse_BaseParser$type,
	.param_types=		&_jc_polyglot_parse_BaseParser$param_types$report__5ffatal__5ferror$5ee52bbba05fbca8,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_parse_BaseParser$param_ptypes$report__5ffatal__5ferror$5ee52bbba05fbca8,
	.signature_hash=	_JC_JLONG(0x5ee52bbba05fbca8),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_parse_BaseParser$method$report__5ffatal__5ferror$5ee52bbba05fbca8,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_parse_BaseParser$vtable, polyglot_parse_BaseParser.report__5ffatal__5ferror$5ee52bbba05fbca8) / sizeof(void *),
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_parse_BaseParser$exceptions$report__5ffatal__5ferror$5ee52bbba05fbca8,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_polyglot_parse_BaseParser$linenum_table$report__5ffatal__5ferror$5ee52bbba05fbca8
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_parse_BaseParser, report__5ffatal__5ferror$5ee52bbba05fbca8);

void _JC_JCNI_ATTR
_jc_polyglot_parse_BaseParser$method$report__5ffatal__5ferror$5ee52bbba05fbca8(_jc_env *const env, _jc_polyglot_parse_BaseParser$object *this, _jc_java_lang_String$object *param0, _jc_java_lang_Object$object *param1)
{
	struct _jc_polyglot_parse_BaseParser$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_java_lang_Object$object *r2;
	struct _jc_object *r3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_LINE_NUMBER(52);				// 0
	_JC_INVOKE_VIRTUAL(env, java__5fcup_runtime_lr__5fparser, report__5ferror$c13b2b37bffb6487, r0, r1, r2);
	_JC_LINE_NUMBER(53);				// 1
	r3 = _JC_REF_FIELD(env, r0, polyglot_parse_BaseParser, eq);
	_JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0x7659161d8f442ddb), void, (_jc_env *, struct _jc_object *, jint, struct _jc_java_lang_String$object *), 4, _JC_STRING(env, "Unable to recover from previous errors."));
	_JC_LINE_NUMBER(55);				// 2
	_JC_INVOKE_VIRTUAL(env, polyglot_parse_BaseParser, die$e8cd32d55f5e0014, r0);
	_JC_LINE_NUMBER(56);				// 3
	return;
}

//
// protected polyglot.ast.QualifierNode typeToQualifier(polyglot.ast.TypeNode) throws java.lang.Exception
//

static _jc_linenum _jc_polyglot_parse_BaseParser$linenum_table$typeToQualifier$a761c9754e2009de[];

static const unsigned char _jc_polyglot_parse_BaseParser$param_ptypes$typeToQualifier$a761c9754e2009de[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_parse_BaseParser$exceptions$typeToQualifier$a761c9754e2009de[] = {
	&_jc_java_lang_Exception$type
};

static _jc_type *const _jc_polyglot_parse_BaseParser$param_types$typeToQualifier$a761c9754e2009de[] = {
	&_jc_polyglot_ast_TypeNode$type
};

_jc_method _jc_polyglot_parse_BaseParser$method_info$typeToQualifier$a761c9754e2009de = {
	.name=			"typeToQualifier",
	.signature=		"(Lpolyglot/ast/TypeNode;)Lpolyglot/ast/QualifierNode;",
	.class=			&_jc_polyglot_parse_BaseParser$type,
	.param_types=		&_jc_polyglot_parse_BaseParser$param_types$typeToQualifier$a761c9754e2009de,
	.return_type=		&_jc_polyglot_ast_QualifierNode$type,
	.param_ptypes=		&_jc_polyglot_parse_BaseParser$param_ptypes$typeToQualifier$a761c9754e2009de,
	.signature_hash=	_JC_JLONG(0xa761c9754e2009de),
	.access_flags=		_JC_ACC_PROTECTED,
	.function=		&_jc_polyglot_parse_BaseParser$method$typeToQualifier$a761c9754e2009de,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_parse_BaseParser$vtable, polyglot_parse_BaseParser.typeToQualifier$a761c9754e2009de) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_parse_BaseParser$exceptions$typeToQualifier$a761c9754e2009de,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	7,
	      .table=	_jc_polyglot_parse_BaseParser$linenum_table$typeToQualifier$a761c9754e2009de
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_parse_BaseParser, typeToQualifier$a761c9754e2009de);

_jc_object * _JC_JCNI_ATTR
_jc_polyglot_parse_BaseParser$method$typeToQualifier$a761c9754e2009de(_jc_env *const env, _jc_polyglot_parse_BaseParser$object *this, _jc_object *param0)
{
	struct _jc_polyglot_parse_BaseParser$object *r0;
	struct _jc_object *r1;
	struct _jc_polyglot_util_Position$object *r10;
	struct _jc_polyglot_util_Position$object *r12;
	struct _jc_object *r2;
	struct _jc_object *r3;
	struct _jc_object *r4;
	struct _jc_polyglot_util_Position$object *r5;
	struct _jc_object *r6;
	struct _jc_java_lang_String$object *r7;
	struct _jc_object *r8;
	struct _jc_polyglot_util_Position$object *r9;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(218);				// 0
	z0 = _JC_INSTANCEOF(env, r1, &_jc_polyglot_ast_AmbTypeNode$type);
	if (z0 == 0)
		goto label5;
	_JC_LINE_NUMBER(220);				// 1
	r2 = r1;
	_JC_LINE_NUMBER(222);				// 2
	r3 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0x6dc7ae4d27ad6a5), _jc_object *, (_jc_env *, struct _jc_object *));
	if (r3 == _JC_NULL)
		goto label2;
	_JC_LINE_NUMBER(224);				// 3
	r4 = _JC_REF_FIELD(env, r0, polyglot_parse_BaseParser, nf);
	if (r1 != _JC_NULL)
		goto label0;
	r5 = _JC_NULL;
	goto label1;

label0:
	r9 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0xbb89333b1e4c840c), _jc_object *, (_jc_env *, struct _jc_object *));
	r5 = r9;

label1:
	r6 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0xf92c265b563b32a), _jc_object *, (_jc_env *, struct _jc_object *));
	r7 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0xe6acce026cadf81e), _jc_object *, (_jc_env *, struct _jc_object *));
	r8 = _JC_INVOKE_INTERFACE(env, r4, _JC_JLONG(0xd31dd8979b61fb53), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_polyglot_util_Position$object *, struct _jc_object *, struct _jc_java_lang_String$object *), r5, r6, r7);
	return r8;

label2:
	_JC_LINE_NUMBER(228);				// 4
	r4 = _JC_REF_FIELD(env, r0, polyglot_parse_BaseParser, nf);
	if (r1 != _JC_NULL)
		goto label3;
	r5 = _JC_NULL;
	goto label4;

label3:
	r10 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0xbb89333b1e4c840c), _jc_object *, (_jc_env *, struct _jc_object *));
	r5 = r10;

label4:
	r7 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0xe6acce026cadf81e), _jc_object *, (_jc_env *, struct _jc_object *));
	r8 = _JC_INVOKE_INTERFACE(env, r4, _JC_JLONG(0x3597228dd5d66acc), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_polyglot_util_Position$object *, struct _jc_java_lang_String$object *), r5, r7);
	return r8;

label5:
	if (r1 != _JC_NULL)
		goto label6;
	r5 = _JC_NULL;
	goto label7;

label6:
	r12 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0xbb89333b1e4c840c), _jc_object *, (_jc_env *, struct _jc_object *));
	r5 = r12;

label7:
	_JC_LINE_NUMBER(232);				// 5
	_JC_INVOKE_VIRTUAL(env, polyglot_parse_BaseParser, die$2a04cd99f4266314, r0, r5);
	_JC_LINE_NUMBER(233);				// 6
	return _JC_NULL;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_polyglot_parse_BaseParser$methods[] = {
	&_jc_polyglot_parse_BaseParser$method_info$_init$45e4d872e3394688,
	&_jc_polyglot_parse_BaseParser$method_info$array$a1877cd5102af918,
	&_jc_polyglot_parse_BaseParser$method_info$die$e8cd32d55f5e0014,
	&_jc_polyglot_parse_BaseParser$method_info$die$26185bdff07702dd,
	&_jc_polyglot_parse_BaseParser$method_info$die$2a04cd99f4266314,
	&_jc_polyglot_parse_BaseParser$method_info$exprToQualifier$3feb7c91fcf83f5e,
	&_jc_polyglot_parse_BaseParser$method_info$exprToType$46d40b31072a20b6,
	&_jc_polyglot_parse_BaseParser$method_info$nextSymbol$3f54f2881e423074,
	&_jc_polyglot_parse_BaseParser$method_info$pos$6ae606c7fda4c3f6,
	&_jc_polyglot_parse_BaseParser$method_info$pos$b42c13efbbc9d455,
	&_jc_polyglot_parse_BaseParser$method_info$pos$549cebdeb8108ac0,
	&_jc_polyglot_parse_BaseParser$method_info$pos$f817290d1ed9d153,
	&_jc_polyglot_parse_BaseParser$method_info$pos$f930bfa683da28a2,
	&_jc_polyglot_parse_BaseParser$method_info$position$bb89333b1e4c840c,
	&_jc_polyglot_parse_BaseParser$method_info$prefixToQualifier$0ac9a911c9db29c8,
	&_jc_polyglot_parse_BaseParser$method_info$report__5ffatal__5ferror$5ee52bbba05fbca8,
	&_jc_polyglot_parse_BaseParser$method_info$typeToQualifier$a761c9754e2009de
};

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_polyglot_parse_BaseParser$instanceof_hash_bucket_98[] = {
	&_jc_polyglot_parse_BaseParser$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_parse_BaseParser$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_parse_BaseParser$instanceof_hash_bucket_104[] = {
	&_jc_java__5fcup_runtime_lr__5fparser$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_polyglot_parse_BaseParser$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[98]=	_jc_polyglot_parse_BaseParser$instanceof_hash_bucket_98,
	[101]=	_jc_polyglot_parse_BaseParser$instanceof_hash_bucket_101,
	[104]=	_jc_polyglot_parse_BaseParser$instanceof_hash_bucket_104
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_polyglot_parse_BaseParser$class_depends[] = {
	{ "java/io/IOException",	_JC_JLONG(0x4e0a56550c69d57c) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/util/AbstractCollection",	_JC_JLONG(0x8ea716c64b77f8eb) },
	{ "java/util/AbstractList",	_JC_JLONG(0xf5238436362828db) },
	{ "java/util/List",	_JC_JLONG(0x9ee0d92ce1525a4d) },
	{ "java/util/Stack",	_JC_JLONG(0x72209734bd9cc6c1) },
	{ "java/util/Vector",	_JC_JLONG(0xc53e1575b095109b) },
	{ "java_cup/runtime/Symbol",	_JC_JLONG(0x413b2e03dcc84ee9) },
	{ "java_cup/runtime/lr_parser",	_JC_JLONG(0x9182b5460122e5e8) },
	{ "polyglot/ast/AmbExpr",	_JC_JLONG(0x7ee42950435f22ee) },
	{ "polyglot/ast/AmbPrefix",	_JC_JLONG(0x490b53c7cc348bb5) },
	{ "polyglot/ast/AmbQualifierNode",	_JC_JLONG(0xee38bfb92996b470) },
	{ "polyglot/ast/AmbReceiver",	_JC_JLONG(0xc8423c3fc34ddf41) },
	{ "polyglot/ast/AmbTypeNode",	_JC_JLONG(0xf88dca636c2c226e) },
	{ "polyglot/ast/ArrayTypeNode",	_JC_JLONG(0x339d14b46377685b) },
	{ "polyglot/ast/CanonicalTypeNode",	_JC_JLONG(0x6d0ea1efc315a28) },
	{ "polyglot/ast/Expr",	_JC_JLONG(0xa33c697a7834ba70) },
	{ "polyglot/ast/Field",	_JC_JLONG(0x4fe86535a8e5abae) },
	{ "polyglot/ast/Node",	_JC_JLONG(0x1c402b4f9747e08) },
	{ "polyglot/ast/NodeFactory",	_JC_JLONG(0x56625b3befab19f) },
	{ "polyglot/ast/Prefix",	_JC_JLONG(0x3409dc0ecff2f246) },
	{ "polyglot/ast/QualifierNode",	_JC_JLONG(0xb124f6ed57f4caf2) },
	{ "polyglot/ast/Receiver",	_JC_JLONG(0xe8c4a965abb2860a) },
	{ "polyglot/ast/TypeNode",	_JC_JLONG(0xdfe962b6d2ff7e27) },
	{ "polyglot/lex/Lexer",	_JC_JLONG(0x616f43199b90e9f2) },
	{ "polyglot/lex/Token",	_JC_JLONG(0x28b2d50426072b60) },
	{ "polyglot/parse/VarDeclarator",	_JC_JLONG(0xe329cd839509c30c) },
	{ "polyglot/types/ArrayType",	_JC_JLONG(0x412788f7d4254477) },
	{ "polyglot/types/Qualifier",	_JC_JLONG(0x69408a3a6c3b3df4) },
	{ "polyglot/types/Type",	_JC_JLONG(0x6596051546781098) },
	{ "polyglot/types/TypeSystem",	_JC_JLONG(0xed171cdaca38ec28) },
	{ "polyglot/util/ErrorQueue",	_JC_JLONG(0xff712c8463bdfdc0) },
	{ "polyglot/util/Position",	_JC_JLONG(0x32c9a088c5dac046) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_polyglot_parse_BaseParser$vtype _jc_polyglot_parse_BaseParser$type = {
    .type= {
	.name=			"polyglot/parse/BaseParser",
	.superclass=		&_jc_java__5fcup_runtime_lr__5fparser$type,
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		59,
		.hash=			_JC_JLONG(0xbb05fbad007ed762),
		.source_file=		"BaseParser.java",
		.instance_size=		sizeof(_jc_polyglot_parse_BaseParser$refs) + sizeof(_jc_polyglot_parse_BaseParser$object),
		.num_virtual_refs=	13,
		.num_fields=		sizeof(_jc_polyglot_parse_BaseParser$fields) / sizeof(*_jc_polyglot_parse_BaseParser$fields),
		.fields=		_jc_polyglot_parse_BaseParser$fields,
		.num_methods=		sizeof(_jc_polyglot_parse_BaseParser$methods) / sizeof(*_jc_polyglot_parse_BaseParser$methods),
		.methods=		_jc_polyglot_parse_BaseParser$methods,
		.instanceof_hash_table=	_jc_polyglot_parse_BaseParser$instanceof_hash_table,
		.num_class_depends=		sizeof(_jc_polyglot_parse_BaseParser$class_depends) / sizeof(*_jc_polyglot_parse_BaseParser$class_depends),
		.class_depends=		_jc_polyglot_parse_BaseParser$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.java__5fcup_runtime_lr__5fparser= {
	    .EOF__5fsym$2594b7dcd1c40e9d=
		&_jc_java__5fcup_runtime_lr__5fparser$method$EOF__5fsym$2594b7dcd1c40e9d,
	    .action__5ftable$7fbffe7593aaf4e9=
		&_jc_java__5fcup_runtime_lr__5fparser$method$action__5ftable$7fbffe7593aaf4e9,
	    .advance__5flookahead$26f31b2ce14bfb23=
		&_jc_java__5fcup_runtime_lr__5fparser$method$advance__5flookahead$26f31b2ce14bfb23,
	    .cur__5ferr__5ftoken$a00b429a9c464eb8=
		&_jc_java__5fcup_runtime_lr__5fparser$method$cur__5ferr__5ftoken$a00b429a9c464eb8,
	    .debug__5fmessage$687361e14bf6cef6=
		&_jc_java__5fcup_runtime_lr__5fparser$method$debug__5fmessage$687361e14bf6cef6,
	    .debug__5fparse$6a90a9170637a27c=
		&_jc_java__5fcup_runtime_lr__5fparser$method$debug__5fparse$6a90a9170637a27c,
	    .debug__5freduce$fd8d0ea28d1151ec=
		&_jc_java__5fcup_runtime_lr__5fparser$method$debug__5freduce$fd8d0ea28d1151ec,
	    .debug__5fshift$be113ec90ec3f080=
		&_jc_java__5fcup_runtime_lr__5fparser$method$debug__5fshift$be113ec90ec3f080,
	    .debug__5fstack$1ba8e824569ab783=
		&_jc_java__5fcup_runtime_lr__5fparser$method$debug__5fstack$1ba8e824569ab783,
	    .do__5faction$c83f594c0a8a9230=
		&_jc_java__5fcup_runtime_lr__5fparser$method$do__5faction$c83f594c0a8a9230,
	    .done__5fparsing$bfb800a056f33984=
		&_jc_java__5fcup_runtime_lr__5fparser$method$done__5fparsing$bfb800a056f33984,
	    .dump__5fstack$6958edcef8f338fd=
		&_jc_java__5fcup_runtime_lr__5fparser$method$dump__5fstack$6958edcef8f338fd,
	    .error__5frecovery$6ef390fce03bc30b=
		&_jc_java__5fcup_runtime_lr__5fparser$method$error__5frecovery$6ef390fce03bc30b,
	    .error__5fsym$1989f68e9f3b9b5b=
		&_jc_java__5fcup_runtime_lr__5fparser$method$error__5fsym$1989f68e9f3b9b5b,
	    .error__5fsync__5fsize$3ad9f31c7129b8f8=
		&_jc_java__5fcup_runtime_lr__5fparser$method$error__5fsync__5fsize$3ad9f31c7129b8f8,
	    .find__5frecovery__5fconfig$45ec603cf88a9c1a=
		&_jc_java__5fcup_runtime_lr__5fparser$method$find__5frecovery__5fconfig$45ec603cf88a9c1a,
	    .getScanner$d924fea919428f45=
		&_jc_java__5fcup_runtime_lr__5fparser$method$getScanner$d924fea919428f45,
	    .get__5faction$3171191eb0a08f00=
		&_jc_java__5fcup_runtime_lr__5fparser$method$get__5faction$3171191eb0a08f00,
	    .get__5freduce$7758163f1f038f01=
		&_jc_java__5fcup_runtime_lr__5fparser$method$get__5freduce$7758163f1f038f01,
	    .init__5factions$8b2c6279f730982e=
		&_jc_java__5fcup_runtime_lr__5fparser$method$init__5factions$8b2c6279f730982e,
	    .parse$3cc2797c75a04510=
		&_jc_java__5fcup_runtime_lr__5fparser$method$parse$3cc2797c75a04510,
	    .parse__5flookahead$4d858ae2811adfe0=
		&_jc_java__5fcup_runtime_lr__5fparser$method$parse__5flookahead$4d858ae2811adfe0,
	    .production__5ftable$b420a0c07fc6189b=
		&_jc_java__5fcup_runtime_lr__5fparser$method$production__5ftable$b420a0c07fc6189b,
	    .read__5flookahead$374566f049080c96=
		&_jc_java__5fcup_runtime_lr__5fparser$method$read__5flookahead$374566f049080c96,
	    .reduce__5ftable$e3ba52693a2cdaa0=
		&_jc_java__5fcup_runtime_lr__5fparser$method$reduce__5ftable$e3ba52693a2cdaa0,
	    .report__5ferror$c13b2b37bffb6487=
		&_jc_java__5fcup_runtime_lr__5fparser$method$report__5ferror$c13b2b37bffb6487,
	    .report__5ffatal__5ferror$5ee52bbba05fbca8=	// overridden
		&_jc_polyglot_parse_BaseParser$method$report__5ffatal__5ferror$5ee52bbba05fbca8,
	    .restart__5flookahead$d475314d12a2596a=
		&_jc_java__5fcup_runtime_lr__5fparser$method$restart__5flookahead$d475314d12a2596a,
	    .scan$555066150c344a35=
		&_jc_java__5fcup_runtime_lr__5fparser$method$scan$555066150c344a35,
	    .setScanner$7f1d5896f223d8de=
		&_jc_java__5fcup_runtime_lr__5fparser$method$setScanner$7f1d5896f223d8de,
	    .shift__5funder__5ferror$849d7007b49a748c=
		&_jc_java__5fcup_runtime_lr__5fparser$method$shift__5funder__5ferror$849d7007b49a748c,
	    .start__5fproduction$ba12d3658207c8f8=
		&_jc_java__5fcup_runtime_lr__5fparser$method$start__5fproduction$ba12d3658207c8f8,
	    .start__5fstate$7265abf345bc7623=
		&_jc_java__5fcup_runtime_lr__5fparser$method$start__5fstate$7265abf345bc7623,
	    .syntax__5ferror$8c1fe99e77942369=
		&_jc_java__5fcup_runtime_lr__5fparser$method$syntax__5ferror$8c1fe99e77942369,
	    .try__5fparse__5fahead$94327faf896f5470=
		&_jc_java__5fcup_runtime_lr__5fparser$method$try__5fparse__5fahead$94327faf896f5470,
	    .unrecovered__5fsyntax__5ferror$7037af2563909777=
		&_jc_java__5fcup_runtime_lr__5fparser$method$unrecovered__5fsyntax__5ferror$7037af2563909777,
	    .user__5finit$4b40ccc9e06a232b=
		&_jc_java__5fcup_runtime_lr__5fparser$method$user__5finit$4b40ccc9e06a232b,
	},
	.polyglot_parse_BaseParser= {
	    .array$a1877cd5102af918=
		&_jc_polyglot_parse_BaseParser$method$array$a1877cd5102af918,
	    .die$e8cd32d55f5e0014=
		&_jc_polyglot_parse_BaseParser$method$die$e8cd32d55f5e0014,
	    .die$26185bdff07702dd=
		&_jc_polyglot_parse_BaseParser$method$die$26185bdff07702dd,
	    .die$2a04cd99f4266314=
		&_jc_polyglot_parse_BaseParser$method$die$2a04cd99f4266314,
	    .exprToQualifier$3feb7c91fcf83f5e=
		&_jc_polyglot_parse_BaseParser$method$exprToQualifier$3feb7c91fcf83f5e,
	    .exprToType$46d40b31072a20b6=
		&_jc_polyglot_parse_BaseParser$method$exprToType$46d40b31072a20b6,
	    .nextSymbol$3f54f2881e423074=
		&_jc_polyglot_parse_BaseParser$method$nextSymbol$3f54f2881e423074,
	    .position$bb89333b1e4c840c=
		&_jc_polyglot_parse_BaseParser$method$position$bb89333b1e4c840c,
	    .prefixToQualifier$0ac9a911c9db29c8=
		&_jc_polyglot_parse_BaseParser$method$prefixToQualifier$0ac9a911c9db29c8,
	    .report__5ffatal__5ferror$5ee52bbba05fbca8=
		&_jc_polyglot_parse_BaseParser$method$report__5ffatal__5ferror$5ee52bbba05fbca8,
	    .typeToQualifier$a761c9754e2009de=
		&_jc_polyglot_parse_BaseParser$method$typeToQualifier$a761c9754e2009de,
	},
    }
};

