// public abstract interface polyglot.types.Context

// class file dependencies
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class 9b667b09132be893 java_lang_Cloneable
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 9ee0d92ce1525a4d java_util_List
// @dep_class b38560af658974f8 polyglot_types_ClassType
// @dep_class 88f5c21159e638e6 polyglot_types_CodeInstance
// @dep_class a433cdcd788f6c37 polyglot_types_Context
// @dep_class d4beb04c35c42bde polyglot_types_FieldInstance
// @dep_class e82fd79d93315427 polyglot_types_ImportTable
// @dep_class 143a5bf23e0f6584 polyglot_types_LocalInstance
// @dep_class ab0fa5f3ef02c9ee polyglot_types_MethodInstance
// @dep_class e5f53252d3bf5dfd polyglot_types_Named
// @dep_class 6bcfbf52304f9e7c polyglot_types_ParsedClassType
// @dep_class 3a3788b16a28392b polyglot_types_Resolver
// @dep_class 45f755f5298b5b39 polyglot_types_SemanticException
// @dep_class ed171cdaca38ec28 polyglot_types_TypeSystem
// @dep_class 15458040aa58b488 polyglot_types_VarInstance
// @dep_class c1adfaf4637dbc02 polyglot_util_Copy

// header file dependencies
// @dep_header java_lang_Class
// @dep_header java_lang_Cloneable
// @dep_header java_lang_String
// @dep_header java_util_List
// @dep_header polyglot_types_ClassType
// @dep_header polyglot_types_CodeInstance
// @dep_header polyglot_types_Context
// @dep_header polyglot_types_FieldInstance
// @dep_header polyglot_types_ImportTable
// @dep_header polyglot_types_LocalInstance
// @dep_header polyglot_types_MethodInstance
// @dep_header polyglot_types_Named
// @dep_header polyglot_types_ParsedClassType
// @dep_header polyglot_types_Resolver
// @dep_header polyglot_types_SemanticException
// @dep_header polyglot_types_TypeSystem
// @dep_header polyglot_types_VarInstance
// @dep_header polyglot_util_Copy

#include "jc_defs.h"

#include "java/lang/Class.h"
#include "java/lang/Cloneable.h"
#include "java/lang/String.h"
#include "java/util/List.h"
#include "polyglot/types/ClassType.h"
#include "polyglot/types/CodeInstance.h"
#include "polyglot/types/Context.h"
#include "polyglot/types/FieldInstance.h"
#include "polyglot/types/ImportTable.h"
#include "polyglot/types/LocalInstance.h"
#include "polyglot/types/MethodInstance.h"
#include "polyglot/types/Named.h"
#include "polyglot/types/ParsedClassType.h"
#include "polyglot/types/Resolver.h"
#include "polyglot/types/SemanticException.h"
#include "polyglot/types/TypeSystem.h"
#include "polyglot/types/VarInstance.h"
#include "polyglot/util/Copy.h"

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public abstract void addMethod(polyglot.types.MethodInstance)
//

static const unsigned char _jc_polyglot_types_Context$param_ptypes$addMethod$be4bfa29b8b5fe0c[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_types_Context$param_types$addMethod$be4bfa29b8b5fe0c[] = {
	&_jc_polyglot_types_MethodInstance$type
};

_jc_method _jc_polyglot_types_Context$method_info$addMethod$be4bfa29b8b5fe0c = {
	.name=			"addMethod",
	.signature=		"(Lpolyglot/types/MethodInstance;)V",
	.class=			&_jc_polyglot_types_Context$type,
	.param_types=		&_jc_polyglot_types_Context$param_types$addMethod$be4bfa29b8b5fe0c,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_types_Context$param_ptypes$addMethod$be4bfa29b8b5fe0c,
	.signature_hash=	_JC_JLONG(0xbe4bfa29b8b5fe0c),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
};

//
// public abstract void addNamed(polyglot.types.Named)
//

static const unsigned char _jc_polyglot_types_Context$param_ptypes$addNamed$f8c7b86f74362f53[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_types_Context$param_types$addNamed$f8c7b86f74362f53[] = {
	&_jc_polyglot_types_Named$type
};

_jc_method _jc_polyglot_types_Context$method_info$addNamed$f8c7b86f74362f53 = {
	.name=			"addNamed",
	.signature=		"(Lpolyglot/types/Named;)V",
	.class=			&_jc_polyglot_types_Context$type,
	.param_types=		&_jc_polyglot_types_Context$param_types$addNamed$f8c7b86f74362f53,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_types_Context$param_ptypes$addNamed$f8c7b86f74362f53,
	.signature_hash=	_JC_JLONG(0xf8c7b86f74362f53),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
};

//
// public abstract void addVariable(polyglot.types.VarInstance)
//

static const unsigned char _jc_polyglot_types_Context$param_ptypes$addVariable$38c2d9ced4540003[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_types_Context$param_types$addVariable$38c2d9ced4540003[] = {
	&_jc_polyglot_types_VarInstance$type
};

_jc_method _jc_polyglot_types_Context$method_info$addVariable$38c2d9ced4540003 = {
	.name=			"addVariable",
	.signature=		"(Lpolyglot/types/VarInstance;)V",
	.class=			&_jc_polyglot_types_Context$type,
	.param_types=		&_jc_polyglot_types_Context$param_types$addVariable$38c2d9ced4540003,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_types_Context$param_ptypes$addVariable$38c2d9ced4540003,
	.signature_hash=	_JC_JLONG(0x38c2d9ced4540003),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
};

//
// public abstract polyglot.types.ClassType currentClass()
//

static const unsigned char _jc_polyglot_types_Context$param_ptypes$currentClass$748b64ab2bd4ad4e[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_Context$method_info$currentClass$748b64ab2bd4ad4e = {
	.name=			"currentClass",
	.signature=		"()Lpolyglot/types/ClassType;",
	.class=			&_jc_polyglot_types_Context$type,
	.return_type=		&_jc_polyglot_types_ClassType$type,
	.param_ptypes=		&_jc_polyglot_types_Context$param_ptypes$currentClass$748b64ab2bd4ad4e,
	.signature_hash=	_JC_JLONG(0x748b64ab2bd4ad4e),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract polyglot.types.ParsedClassType currentClassScope()
//

static const unsigned char _jc_polyglot_types_Context$param_ptypes$currentClassScope$2bf983d57f3296d8[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_Context$method_info$currentClassScope$2bf983d57f3296d8 = {
	.name=			"currentClassScope",
	.signature=		"()Lpolyglot/types/ParsedClassType;",
	.class=			&_jc_polyglot_types_Context$type,
	.return_type=		&_jc_polyglot_types_ParsedClassType$type,
	.param_ptypes=		&_jc_polyglot_types_Context$param_ptypes$currentClassScope$2bf983d57f3296d8,
	.signature_hash=	_JC_JLONG(0x2bf983d57f3296d8),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract polyglot.types.CodeInstance currentCode()
//

static const unsigned char _jc_polyglot_types_Context$param_ptypes$currentCode$6932b765f06a5ffa[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_Context$method_info$currentCode$6932b765f06a5ffa = {
	.name=			"currentCode",
	.signature=		"()Lpolyglot/types/CodeInstance;",
	.class=			&_jc_polyglot_types_Context$type,
	.return_type=		&_jc_polyglot_types_CodeInstance$type,
	.param_ptypes=		&_jc_polyglot_types_Context$param_ptypes$currentCode$6932b765f06a5ffa,
	.signature_hash=	_JC_JLONG(0x6932b765f06a5ffa),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract polyglot.types.FieldInstance findField(java.lang.String) throws polyglot.types.SemanticException
//

static const unsigned char _jc_polyglot_types_Context$param_ptypes$findField$df62741d065eeaed[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_Context$exceptions$findField$df62741d065eeaed[] = {
	&_jc_polyglot_types_SemanticException$type
};

static _jc_type *const _jc_polyglot_types_Context$param_types$findField$df62741d065eeaed[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_polyglot_types_Context$method_info$findField$df62741d065eeaed = {
	.name=			"findField",
	.signature=		"(Ljava/lang/String;)Lpolyglot/types/FieldInstance;",
	.class=			&_jc_polyglot_types_Context$type,
	.param_types=		&_jc_polyglot_types_Context$param_types$findField$df62741d065eeaed,
	.return_type=		&_jc_polyglot_types_FieldInstance$type,
	.param_ptypes=		&_jc_polyglot_types_Context$param_ptypes$findField$df62741d065eeaed,
	.signature_hash=	_JC_JLONG(0xdf62741d065eeaed),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_types_Context$exceptions$findField$df62741d065eeaed,
};

//
// public abstract polyglot.types.ClassType findFieldScope(java.lang.String) throws polyglot.types.SemanticException
//

static const unsigned char _jc_polyglot_types_Context$param_ptypes$findFieldScope$56d80887e5fef3f6[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_Context$exceptions$findFieldScope$56d80887e5fef3f6[] = {
	&_jc_polyglot_types_SemanticException$type
};

static _jc_type *const _jc_polyglot_types_Context$param_types$findFieldScope$56d80887e5fef3f6[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_polyglot_types_Context$method_info$findFieldScope$56d80887e5fef3f6 = {
	.name=			"findFieldScope",
	.signature=		"(Ljava/lang/String;)Lpolyglot/types/ClassType;",
	.class=			&_jc_polyglot_types_Context$type,
	.param_types=		&_jc_polyglot_types_Context$param_types$findFieldScope$56d80887e5fef3f6,
	.return_type=		&_jc_polyglot_types_ClassType$type,
	.param_ptypes=		&_jc_polyglot_types_Context$param_ptypes$findFieldScope$56d80887e5fef3f6,
	.signature_hash=	_JC_JLONG(0x56d80887e5fef3f6),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_types_Context$exceptions$findFieldScope$56d80887e5fef3f6,
};

//
// public abstract polyglot.types.LocalInstance findLocal(java.lang.String) throws polyglot.types.SemanticException
//

static const unsigned char _jc_polyglot_types_Context$param_ptypes$findLocal$5564e9b764498cf2[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_Context$exceptions$findLocal$5564e9b764498cf2[] = {
	&_jc_polyglot_types_SemanticException$type
};

static _jc_type *const _jc_polyglot_types_Context$param_types$findLocal$5564e9b764498cf2[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_polyglot_types_Context$method_info$findLocal$5564e9b764498cf2 = {
	.name=			"findLocal",
	.signature=		"(Ljava/lang/String;)Lpolyglot/types/LocalInstance;",
	.class=			&_jc_polyglot_types_Context$type,
	.param_types=		&_jc_polyglot_types_Context$param_types$findLocal$5564e9b764498cf2,
	.return_type=		&_jc_polyglot_types_LocalInstance$type,
	.param_ptypes=		&_jc_polyglot_types_Context$param_ptypes$findLocal$5564e9b764498cf2,
	.signature_hash=	_JC_JLONG(0x5564e9b764498cf2),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_types_Context$exceptions$findLocal$5564e9b764498cf2,
};

//
// public abstract polyglot.types.MethodInstance findMethod(java.lang.String, java.util.List) throws polyglot.types.SemanticException
//

static const unsigned char _jc_polyglot_types_Context$param_ptypes$findMethod$993d2a3fc9bf4666[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_Context$exceptions$findMethod$993d2a3fc9bf4666[] = {
	&_jc_polyglot_types_SemanticException$type
};

static _jc_type *const _jc_polyglot_types_Context$param_types$findMethod$993d2a3fc9bf4666[] = {
	&_jc_java_lang_String$type,
	&_jc_java_util_List$type
};

_jc_method _jc_polyglot_types_Context$method_info$findMethod$993d2a3fc9bf4666 = {
	.name=			"findMethod",
	.signature=		"(Ljava/lang/String;Ljava/util/List;)Lpolyglot/types/MethodInstance;",
	.class=			&_jc_polyglot_types_Context$type,
	.param_types=		&_jc_polyglot_types_Context$param_types$findMethod$993d2a3fc9bf4666,
	.return_type=		&_jc_polyglot_types_MethodInstance$type,
	.param_ptypes=		&_jc_polyglot_types_Context$param_ptypes$findMethod$993d2a3fc9bf4666,
	.signature_hash=	_JC_JLONG(0x993d2a3fc9bf4666),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_types_Context$exceptions$findMethod$993d2a3fc9bf4666,
};

//
// public abstract polyglot.types.ClassType findMethodScope(java.lang.String) throws polyglot.types.SemanticException
//

static const unsigned char _jc_polyglot_types_Context$param_ptypes$findMethodScope$825daa1a3a308d7f[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_Context$exceptions$findMethodScope$825daa1a3a308d7f[] = {
	&_jc_polyglot_types_SemanticException$type
};

static _jc_type *const _jc_polyglot_types_Context$param_types$findMethodScope$825daa1a3a308d7f[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_polyglot_types_Context$method_info$findMethodScope$825daa1a3a308d7f = {
	.name=			"findMethodScope",
	.signature=		"(Ljava/lang/String;)Lpolyglot/types/ClassType;",
	.class=			&_jc_polyglot_types_Context$type,
	.param_types=		&_jc_polyglot_types_Context$param_types$findMethodScope$825daa1a3a308d7f,
	.return_type=		&_jc_polyglot_types_ClassType$type,
	.param_ptypes=		&_jc_polyglot_types_Context$param_ptypes$findMethodScope$825daa1a3a308d7f,
	.signature_hash=	_JC_JLONG(0x825daa1a3a308d7f),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_types_Context$exceptions$findMethodScope$825daa1a3a308d7f,
};

//
// public abstract polyglot.types.VarInstance findVariable(java.lang.String) throws polyglot.types.SemanticException
//

static const unsigned char _jc_polyglot_types_Context$param_ptypes$findVariable$65743938992cca89[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_Context$exceptions$findVariable$65743938992cca89[] = {
	&_jc_polyglot_types_SemanticException$type
};

static _jc_type *const _jc_polyglot_types_Context$param_types$findVariable$65743938992cca89[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_polyglot_types_Context$method_info$findVariable$65743938992cca89 = {
	.name=			"findVariable",
	.signature=		"(Ljava/lang/String;)Lpolyglot/types/VarInstance;",
	.class=			&_jc_polyglot_types_Context$type,
	.param_types=		&_jc_polyglot_types_Context$param_types$findVariable$65743938992cca89,
	.return_type=		&_jc_polyglot_types_VarInstance$type,
	.param_ptypes=		&_jc_polyglot_types_Context$param_ptypes$findVariable$65743938992cca89,
	.signature_hash=	_JC_JLONG(0x65743938992cca89),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_types_Context$exceptions$findVariable$65743938992cca89,
};

//
// public abstract polyglot.types.VarInstance findVariableSilent(java.lang.String)
//

static const unsigned char _jc_polyglot_types_Context$param_ptypes$findVariableSilent$22b243a18d1556cb[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_Context$param_types$findVariableSilent$22b243a18d1556cb[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_polyglot_types_Context$method_info$findVariableSilent$22b243a18d1556cb = {
	.name=			"findVariableSilent",
	.signature=		"(Ljava/lang/String;)Lpolyglot/types/VarInstance;",
	.class=			&_jc_polyglot_types_Context$type,
	.param_types=		&_jc_polyglot_types_Context$param_types$findVariableSilent$22b243a18d1556cb,
	.return_type=		&_jc_polyglot_types_VarInstance$type,
	.param_ptypes=		&_jc_polyglot_types_Context$param_ptypes$findVariableSilent$22b243a18d1556cb,
	.signature_hash=	_JC_JLONG(0x22b243a18d1556cb),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
};

//
// public abstract polyglot.types.ImportTable importTable()
//

static const unsigned char _jc_polyglot_types_Context$param_ptypes$importTable$06160fe11581c90d[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_Context$method_info$importTable$06160fe11581c90d = {
	.name=			"importTable",
	.signature=		"()Lpolyglot/types/ImportTable;",
	.class=			&_jc_polyglot_types_Context$type,
	.return_type=		&_jc_polyglot_types_ImportTable$type,
	.param_ptypes=		&_jc_polyglot_types_Context$param_ptypes$importTable$06160fe11581c90d,
	.signature_hash=	_JC_JLONG(0x6160fe11581c90d),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract boolean inCode()
//

static const unsigned char _jc_polyglot_types_Context$param_ptypes$inCode$d47fa6936ef3d1b7[] = { 
_JC_TYPE_BOOLEAN };

_jc_method _jc_polyglot_types_Context$method_info$inCode$d47fa6936ef3d1b7 = {
	.name=			"inCode",
	.signature=		"()Z",
	.class=			&_jc_polyglot_types_Context$type,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_polyglot_types_Context$param_ptypes$inCode$d47fa6936ef3d1b7,
	.signature_hash=	_JC_JLONG(0xd47fa6936ef3d1b7),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract boolean inStaticContext()
//

static const unsigned char _jc_polyglot_types_Context$param_ptypes$inStaticContext$67cceb384c2fa9ba[] = { 
_JC_TYPE_BOOLEAN };

_jc_method _jc_polyglot_types_Context$method_info$inStaticContext$67cceb384c2fa9ba = {
	.name=			"inStaticContext",
	.signature=		"()Z",
	.class=			&_jc_polyglot_types_Context$type,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_polyglot_types_Context$param_ptypes$inStaticContext$67cceb384c2fa9ba,
	.signature_hash=	_JC_JLONG(0x67cceb384c2fa9ba),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract boolean isLocal(java.lang.String)
//

static const unsigned char _jc_polyglot_types_Context$param_ptypes$isLocal$2beca92f3a6d7386[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_polyglot_types_Context$param_types$isLocal$2beca92f3a6d7386[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_polyglot_types_Context$method_info$isLocal$2beca92f3a6d7386 = {
	.name=			"isLocal",
	.signature=		"(Ljava/lang/String;)Z",
	.class=			&_jc_polyglot_types_Context$type,
	.param_types=		&_jc_polyglot_types_Context$param_types$isLocal$2beca92f3a6d7386,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_polyglot_types_Context$param_ptypes$isLocal$2beca92f3a6d7386,
	.signature_hash=	_JC_JLONG(0x2beca92f3a6d7386),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
};

//
// public abstract polyglot.types.Resolver outerResolver()
//

static const unsigned char _jc_polyglot_types_Context$param_ptypes$outerResolver$c3b8862722e90950[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_Context$method_info$outerResolver$c3b8862722e90950 = {
	.name=			"outerResolver",
	.signature=		"()Lpolyglot/types/Resolver;",
	.class=			&_jc_polyglot_types_Context$type,
	.return_type=		&_jc_polyglot_types_Resolver$type,
	.param_ptypes=		&_jc_polyglot_types_Context$param_ptypes$outerResolver$c3b8862722e90950,
	.signature_hash=	_JC_JLONG(0xc3b8862722e90950),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract polyglot.types.Context pop()
//

static const unsigned char _jc_polyglot_types_Context$param_ptypes$pop$42c6db6839dd477a[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_Context$method_info$pop$42c6db6839dd477a = {
	.name=			"pop",
	.signature=		"()Lpolyglot/types/Context;",
	.class=			&_jc_polyglot_types_Context$type,
	.return_type=		&_jc_polyglot_types_Context$type,
	.param_ptypes=		&_jc_polyglot_types_Context$param_ptypes$pop$42c6db6839dd477a,
	.signature_hash=	_JC_JLONG(0x42c6db6839dd477a),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract polyglot.types.Context pushBlock()
//

static const unsigned char _jc_polyglot_types_Context$param_ptypes$pushBlock$66de990be886728f[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_Context$method_info$pushBlock$66de990be886728f = {
	.name=			"pushBlock",
	.signature=		"()Lpolyglot/types/Context;",
	.class=			&_jc_polyglot_types_Context$type,
	.return_type=		&_jc_polyglot_types_Context$type,
	.param_ptypes=		&_jc_polyglot_types_Context$param_ptypes$pushBlock$66de990be886728f,
	.signature_hash=	_JC_JLONG(0x66de990be886728f),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract polyglot.types.Context pushClass(polyglot.types.ParsedClassType, polyglot.types.ClassType)
//

static const unsigned char _jc_polyglot_types_Context$param_ptypes$pushClass$fe7e236ea467e1e6[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_Context$param_types$pushClass$fe7e236ea467e1e6[] = {
	&_jc_polyglot_types_ParsedClassType$type,
	&_jc_polyglot_types_ClassType$type
};

_jc_method _jc_polyglot_types_Context$method_info$pushClass$fe7e236ea467e1e6 = {
	.name=			"pushClass",
	.signature=		"(Lpolyglot/types/ParsedClassType;Lpolyglot/types/ClassType;)Lpolyglot/types/Context;",
	.class=			&_jc_polyglot_types_Context$type,
	.param_types=		&_jc_polyglot_types_Context$param_types$pushClass$fe7e236ea467e1e6,
	.return_type=		&_jc_polyglot_types_Context$type,
	.param_ptypes=		&_jc_polyglot_types_Context$param_ptypes$pushClass$fe7e236ea467e1e6,
	.signature_hash=	_JC_JLONG(0xfe7e236ea467e1e6),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	2,
};

//
// public abstract polyglot.types.Context pushCode(polyglot.types.CodeInstance)
//

static const unsigned char _jc_polyglot_types_Context$param_ptypes$pushCode$47afe118b41eb5c9[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_Context$param_types$pushCode$47afe118b41eb5c9[] = {
	&_jc_polyglot_types_CodeInstance$type
};

_jc_method _jc_polyglot_types_Context$method_info$pushCode$47afe118b41eb5c9 = {
	.name=			"pushCode",
	.signature=		"(Lpolyglot/types/CodeInstance;)Lpolyglot/types/Context;",
	.class=			&_jc_polyglot_types_Context$type,
	.param_types=		&_jc_polyglot_types_Context$param_types$pushCode$47afe118b41eb5c9,
	.return_type=		&_jc_polyglot_types_Context$type,
	.param_ptypes=		&_jc_polyglot_types_Context$param_ptypes$pushCode$47afe118b41eb5c9,
	.signature_hash=	_JC_JLONG(0x47afe118b41eb5c9),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
};

//
// public abstract polyglot.types.Context pushSource(polyglot.types.ImportTable)
//

static const unsigned char _jc_polyglot_types_Context$param_ptypes$pushSource$fba4b26fbc5ca28e[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_Context$param_types$pushSource$fba4b26fbc5ca28e[] = {
	&_jc_polyglot_types_ImportTable$type
};

_jc_method _jc_polyglot_types_Context$method_info$pushSource$fba4b26fbc5ca28e = {
	.name=			"pushSource",
	.signature=		"(Lpolyglot/types/ImportTable;)Lpolyglot/types/Context;",
	.class=			&_jc_polyglot_types_Context$type,
	.param_types=		&_jc_polyglot_types_Context$param_types$pushSource$fba4b26fbc5ca28e,
	.return_type=		&_jc_polyglot_types_Context$type,
	.param_ptypes=		&_jc_polyglot_types_Context$param_ptypes$pushSource$fba4b26fbc5ca28e,
	.signature_hash=	_JC_JLONG(0xfba4b26fbc5ca28e),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
};

//
// public abstract polyglot.types.Context pushStatic()
//

static const unsigned char _jc_polyglot_types_Context$param_ptypes$pushStatic$9ca4cae3fc68d502[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_Context$method_info$pushStatic$9ca4cae3fc68d502 = {
	.name=			"pushStatic",
	.signature=		"()Lpolyglot/types/Context;",
	.class=			&_jc_polyglot_types_Context$type,
	.return_type=		&_jc_polyglot_types_Context$type,
	.param_ptypes=		&_jc_polyglot_types_Context$param_ptypes$pushStatic$9ca4cae3fc68d502,
	.signature_hash=	_JC_JLONG(0x9ca4cae3fc68d502),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract polyglot.types.TypeSystem typeSystem()
//

static const unsigned char _jc_polyglot_types_Context$param_ptypes$typeSystem$c9dab312e784024e[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_Context$method_info$typeSystem$c9dab312e784024e = {
	.name=			"typeSystem",
	.signature=		"()Lpolyglot/types/TypeSystem;",
	.class=			&_jc_polyglot_types_Context$type,
	.return_type=		&_jc_polyglot_types_TypeSystem$type,
	.param_ptypes=		&_jc_polyglot_types_Context$param_ptypes$typeSystem$c9dab312e784024e,
	.signature_hash=	_JC_JLONG(0xc9dab312e784024e),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_polyglot_types_Context$methods[] = {
	&_jc_polyglot_types_Context$method_info$addMethod$be4bfa29b8b5fe0c,
	&_jc_polyglot_types_Context$method_info$addNamed$f8c7b86f74362f53,
	&_jc_polyglot_types_Context$method_info$addVariable$38c2d9ced4540003,
	&_jc_polyglot_types_Context$method_info$currentClass$748b64ab2bd4ad4e,
	&_jc_polyglot_types_Context$method_info$currentClassScope$2bf983d57f3296d8,
	&_jc_polyglot_types_Context$method_info$currentCode$6932b765f06a5ffa,
	&_jc_polyglot_types_Context$method_info$findField$df62741d065eeaed,
	&_jc_polyglot_types_Context$method_info$findFieldScope$56d80887e5fef3f6,
	&_jc_polyglot_types_Context$method_info$findLocal$5564e9b764498cf2,
	&_jc_polyglot_types_Context$method_info$findMethod$993d2a3fc9bf4666,
	&_jc_polyglot_types_Context$method_info$findMethodScope$825daa1a3a308d7f,
	&_jc_polyglot_types_Context$method_info$findVariable$65743938992cca89,
	&_jc_polyglot_types_Context$method_info$findVariableSilent$22b243a18d1556cb,
	&_jc_polyglot_types_Context$method_info$importTable$06160fe11581c90d,
	&_jc_polyglot_types_Context$method_info$inCode$d47fa6936ef3d1b7,
	&_jc_polyglot_types_Context$method_info$inStaticContext$67cceb384c2fa9ba,
	&_jc_polyglot_types_Context$method_info$isLocal$2beca92f3a6d7386,
	&_jc_polyglot_types_Context$method_info$outerResolver$c3b8862722e90950,
	&_jc_polyglot_types_Context$method_info$pop$42c6db6839dd477a,
	&_jc_polyglot_types_Context$method_info$pushBlock$66de990be886728f,
	&_jc_polyglot_types_Context$method_info$pushClass$fe7e236ea467e1e6,
	&_jc_polyglot_types_Context$method_info$pushCode$47afe118b41eb5c9,
	&_jc_polyglot_types_Context$method_info$pushSource$fba4b26fbc5ca28e,
	&_jc_polyglot_types_Context$method_info$pushStatic$9ca4cae3fc68d502,
	&_jc_polyglot_types_Context$method_info$typeSystem$c9dab312e784024e
};

/************************************************************************
 *			      Interface list				*
 ************************************************************************/

// Directly implemented interfaces
static _jc_type *const _jc_polyglot_types_Context$interfaces[] = {
	&_jc_polyglot_types_Resolver$type,
	&_jc_polyglot_util_Copy$type
};

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_polyglot_types_Context$instanceof_hash_bucket_2[] = {
	&_jc_polyglot_util_Copy$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_types_Context$instanceof_hash_bucket_19[] = {
	&_jc_java_lang_Cloneable$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_types_Context$instanceof_hash_bucket_43[] = {
	&_jc_polyglot_types_Resolver$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_types_Context$instanceof_hash_bucket_55[] = {
	&_jc_polyglot_types_Context$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_types_Context$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_polyglot_types_Context$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[2]=	_jc_polyglot_types_Context$instanceof_hash_bucket_2,
	[19]=	_jc_polyglot_types_Context$instanceof_hash_bucket_19,
	[43]=	_jc_polyglot_types_Context$instanceof_hash_bucket_43,
	[55]=	_jc_polyglot_types_Context$instanceof_hash_bucket_55,
	[101]=	_jc_polyglot_types_Context$instanceof_hash_bucket_101
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_polyglot_types_Context$class_depends[] = {
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/Cloneable",	_JC_JLONG(0x9b667b09132be893) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/util/List",	_JC_JLONG(0x9ee0d92ce1525a4d) },
	{ "polyglot/types/ClassType",	_JC_JLONG(0xb38560af658974f8) },
	{ "polyglot/types/CodeInstance",	_JC_JLONG(0x88f5c21159e638e6) },
	{ "polyglot/types/FieldInstance",	_JC_JLONG(0xd4beb04c35c42bde) },
	{ "polyglot/types/ImportTable",	_JC_JLONG(0xe82fd79d93315427) },
	{ "polyglot/types/LocalInstance",	_JC_JLONG(0x143a5bf23e0f6584) },
	{ "polyglot/types/MethodInstance",	_JC_JLONG(0xab0fa5f3ef02c9ee) },
	{ "polyglot/types/Named",	_JC_JLONG(0xe5f53252d3bf5dfd) },
	{ "polyglot/types/ParsedClassType",	_JC_JLONG(0x6bcfbf52304f9e7c) },
	{ "polyglot/types/Resolver",	_JC_JLONG(0x3a3788b16a28392b) },
	{ "polyglot/types/SemanticException",	_JC_JLONG(0x45f755f5298b5b39) },
	{ "polyglot/types/TypeSystem",	_JC_JLONG(0xed171cdaca38ec28) },
	{ "polyglot/types/VarInstance",	_JC_JLONG(0x15458040aa58b488) },
	{ "polyglot/util/Copy",	_JC_JLONG(0xc1adfaf4637dbc02) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_polyglot_types_Context$vtype _jc_polyglot_types_Context$type = {
    .type= {
	.name=			"polyglot/types/Context",
	.superclass=		&_jc_java_lang_Object$type,
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT|_JC_ACC_INTERFACE,
	.flags=			_JC_TYPE_REFERENCE,
	.num_interfaces=sizeof(_jc_polyglot_types_Context$interfaces) / sizeof(*_jc_polyglot_types_Context$interfaces),
	.interfaces=		_jc_polyglot_types_Context$interfaces,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		36,
		.hash=			_JC_JLONG(0xa433cdcd788f6c37),
		.source_file=		"Context.java",
		.num_virtual_refs=	0,
		.num_methods=		sizeof(_jc_polyglot_types_Context$methods) / sizeof(*_jc_polyglot_types_Context$methods),
		.methods=		_jc_polyglot_types_Context$methods,
		.instanceof_hash_table=	_jc_polyglot_types_Context$instanceof_hash_table,
		.num_class_depends=		sizeof(_jc_polyglot_types_Context$class_depends) / sizeof(*_jc_polyglot_types_Context$class_depends),
		.class_depends=		_jc_polyglot_types_Context$class_depends,
	    }
	}
    }
};

