// public class polyglot.types.SourceClassResolver

// class file dependencies
// @dep_class 99a46305ebacacb5 java_io_PrintStream
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 94d357637b968dda java_lang_StringBuffer
// @dep_class 53cc8e2333795f04 java_lang_System
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class 8ea716c64b77f8eb java_util_AbstractCollection
// @dep_class f5238436362828db java_util_AbstractList
// @dep_class eae4d0c0e8eb63da java_util_Collection
// @dep_class 9574af3fed58029a java_util_Collections
// @dep_class 2ccd076083da6c8e java_util_Collections__24SingletonList
// @dep_class a85d2a51094e614c java_util_Date
// @dep_class 3ea6f1cf85115422 polyglot_frontend_Compiler
// @dep_class fdbc32d4847269bf polyglot_frontend_ExtensionInfo
// @dep_class 39c133c176bc5fd1 polyglot_frontend_FileSource
// @dep_class cd88b669bec8f787 polyglot_frontend_Source
// @dep_class c0bff66c4ab313ae polyglot_frontend_SourceLoader
// @dep_class cf9f146bdb7bc44d polyglot_main_Report
// @dep_class 4ba1325a7aefecac polyglot_main_Version
// @dep_class 5bedf50c16a6702d polyglot_types_BadSerializationException
// @dep_class eec1a4cebd785b9d polyglot_types_ClassResolver
// @dep_class b38560af658974f8 polyglot_types_ClassType
// @dep_class 775d491e1eb77426 polyglot_types_LoadedClassResolver
// @dep_class e5f53252d3bf5dfd polyglot_types_Named
// @dep_class 7e014a610596faf9 polyglot_types_NoClassException
// @dep_class 6bcfbf52304f9e7c polyglot_types_ParsedClassType
// @dep_class 3a3788b16a28392b polyglot_types_Resolver
// @dep_class 45f755f5298b5b39 polyglot_types_SemanticException
// @dep_class a81fa73809a6780b polyglot_types_SourceClassResolver
// @dep_class 4fb97851ac3ef2dd polyglot_types_TableResolver
// @dep_class ed171cdaca38ec28 polyglot_types_TypeSystem
// @dep_class f394a649a5830bb polyglot_types_reflect_ClassFile
// @dep_class 50cc35358493eab1 polyglot_types_reflect_ClassFileLoader

// header file dependencies
// @dep_header java_io_PrintStream
// @dep_header java_lang_Class
// @dep_header java_lang_String
// @dep_header java_lang_StringBuffer
// @dep_header java_lang_System
// @dep_header java_lang_VMThrowable
// @dep_header java_util_Collection
// @dep_header java_util_Collections
// @dep_header java_util_Collections__24SingletonList
// @dep_header java_util_Date
// @dep_header polyglot_frontend_Compiler
// @dep_header polyglot_frontend_ExtensionInfo
// @dep_header polyglot_frontend_FileSource
// @dep_header polyglot_frontend_SourceLoader
// @dep_header polyglot_main_Report
// @dep_header polyglot_main_Version
// @dep_header polyglot_types_BadSerializationException
// @dep_header polyglot_types_ClassType
// @dep_header polyglot_types_Named
// @dep_header polyglot_types_NoClassException
// @dep_header polyglot_types_ParsedClassType
// @dep_header polyglot_types_Resolver
// @dep_header polyglot_types_SourceClassResolver
// @dep_header polyglot_types_TableResolver
// @dep_header polyglot_types_TypeSystem
// @dep_header polyglot_types_reflect_ClassFile
// @dep_header polyglot_types_reflect_ClassFileLoader

#include "jc_defs.h"

#include "java/io/PrintStream.h"
#include "java/lang/Class.h"
#include "java/lang/String.h"
#include "java/lang/StringBuffer.h"
#include "java/lang/System.h"
#include "java/lang/VMThrowable.h"
#include "java/util/Collection.h"
#include "java/util/Collections.h"
#include "java/util/Collections__24SingletonList.h"
#include "java/util/Date.h"
#include "polyglot/frontend/Compiler.h"
#include "polyglot/frontend/ExtensionInfo.h"
#include "polyglot/frontend/FileSource.h"
#include "polyglot/frontend/SourceLoader.h"
#include "polyglot/main/Report.h"
#include "polyglot/main/Version.h"
#include "polyglot/types/BadSerializationException.h"
#include "polyglot/types/ClassType.h"
#include "polyglot/types/Named.h"
#include "polyglot/types/NoClassException.h"
#include "polyglot/types/ParsedClassType.h"
#include "polyglot/types/Resolver.h"
#include "polyglot/types/SourceClassResolver.h"
#include "polyglot/types/TableResolver.h"
#include "polyglot/types/TypeSystem.h"
#include "polyglot/types/reflect/ClassFile.h"
#include "polyglot/types/reflect/ClassFileLoader.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// polyglot.frontend.Compiler compiler
static _jc_field _jc_polyglot_types_SourceClassResolver$field_info$compiler = {
	.name=		"compiler",
	.signature=	"Lpolyglot/frontend/Compiler;",
	.class=		&_jc_polyglot_types_SourceClassResolver$type,
	.type=		&_jc_polyglot_frontend_Compiler$type,
	.access_flags=	0,
	.offset=	_JC_OFFSETOF(_jc_polyglot_types_SourceClassResolver$object, refs[-1].polyglot_types_SourceClassResolver.compiler),
};

// polyglot.frontend.ExtensionInfo ext
static _jc_field _jc_polyglot_types_SourceClassResolver$field_info$ext = {
	.name=		"ext",
	.signature=	"Lpolyglot/frontend/ExtensionInfo;",
	.class=		&_jc_polyglot_types_SourceClassResolver$type,
	.type=		&_jc_polyglot_frontend_ExtensionInfo$type,
	.access_flags=	0,
	.offset=	_JC_OFFSETOF(_jc_polyglot_types_SourceClassResolver$object, refs[-1].polyglot_types_SourceClassResolver.ext),
};

// Fields
static _jc_field *const _jc_polyglot_types_SourceClassResolver$fields[] = {
	&_jc_polyglot_types_SourceClassResolver$field_info$compiler,
	&_jc_polyglot_types_SourceClassResolver$field_info$ext
};

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// public void <init>(polyglot.frontend.Compiler, polyglot.frontend.ExtensionInfo, java.lang.String, polyglot.types.reflect.ClassFileLoader, boolean)
//

static _jc_linenum _jc_polyglot_types_SourceClassResolver$linenum_table$_init$bcfadaa1eb77075d[];

static const unsigned char _jc_polyglot_types_SourceClassResolver$param_ptypes$_init$bcfadaa1eb77075d[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_types_SourceClassResolver$param_types$_init$bcfadaa1eb77075d[] = {
	&_jc_polyglot_frontend_Compiler$type,
	&_jc_polyglot_frontend_ExtensionInfo$type,
	&_jc_java_lang_String$type,
	&_jc_polyglot_types_reflect_ClassFileLoader$type,
	&_jc_boolean$prim$type
};

_jc_method _jc_polyglot_types_SourceClassResolver$method_info$_init$bcfadaa1eb77075d = {
	.name=			"<init>",
	.signature=		"(Lpolyglot/frontend/Compiler;Lpolyglot/frontend/ExtensionInfo;Ljava/lang/String;Lpolyglot/types/reflect/ClassFileLoader;Z)V",
	.class=			&_jc_polyglot_types_SourceClassResolver$type,
	.param_types=		&_jc_polyglot_types_SourceClassResolver$param_types$_init$bcfadaa1eb77075d,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_types_SourceClassResolver$param_ptypes$_init$bcfadaa1eb77075d,
	.signature_hash=	_JC_JLONG(0xbcfadaa1eb77075d),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_types_SourceClassResolver$method$_init$bcfadaa1eb77075d,
	.num_parameters=	5,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_polyglot_types_SourceClassResolver$linenum_table$_init$bcfadaa1eb77075d
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_types_SourceClassResolver, _init$bcfadaa1eb77075d);

void _JC_JCNI_ATTR
_jc_polyglot_types_SourceClassResolver$method$_init$bcfadaa1eb77075d(_jc_env *const env, _jc_polyglot_types_SourceClassResolver$object *this, _jc_polyglot_frontend_Compiler$object *param0, _jc_object *param1, _jc_java_lang_String$object *param2, _jc_polyglot_types_reflect_ClassFileLoader$object *param3, jboolean param4)
{
	struct _jc_polyglot_types_SourceClassResolver$object *r0;
	struct _jc_polyglot_frontend_Compiler$object *r1;
	struct _jc_object *r2;
	struct _jc_java_lang_String$object *r3;
	struct _jc_polyglot_types_reflect_ClassFileLoader$object *r4;
	struct _jc_object *r5;
	struct _jc_polyglot_main_Version$object *r6;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	r3 = param2;
	r4 = param3;
	z0 = param4;
	_JC_LINE_NUMBER(93);				// 0
	r5 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0xc9dab312e784024e), _jc_object *, (_jc_env *, struct _jc_object *));
	r6 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0xc1f93b24c1ce6d92), _jc_object *, (_jc_env *, struct _jc_object *));
	_JC_INVOKE_NONVIRTUAL(env, polyglot_types_LoadedClassResolver, _init$4496cf846523face, 0, r0, r5, r3, r4, r6, z0);
	_JC_LINE_NUMBER(94);				// 1
	_JC_REF_FIELD(env, r0, polyglot_types_SourceClassResolver, compiler) = r1;
	_JC_LINE_NUMBER(95);				// 2
	_JC_REF_FIELD(env, r0, polyglot_types_SourceClassResolver, ext) = r2;
	_JC_LINE_NUMBER(96);				// 3
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public polyglot.types.Named find(java.lang.String) throws polyglot.types.SemanticException
//

static _jc_linenum _jc_polyglot_types_SourceClassResolver$linenum_table$find$6acc62ea1c707b3c[];

static _jc_trap_info _jc_polyglot_types_SourceClassResolver$trap_table$find$6acc62ea1c707b3c[] = {
	_JC_TRAP(&_jc_polyglot_types_BadSerializationException$type, 1, 2),
	_JC_TRAP(&_jc_polyglot_types_SemanticException$type, 1, 2),
};

static const unsigned char _jc_polyglot_types_SourceClassResolver$param_ptypes$find$6acc62ea1c707b3c[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_SourceClassResolver$exceptions$find$6acc62ea1c707b3c[] = {
	&_jc_polyglot_types_SemanticException$type
};

static _jc_type *const _jc_polyglot_types_SourceClassResolver$param_types$find$6acc62ea1c707b3c[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_polyglot_types_SourceClassResolver$method_info$find$6acc62ea1c707b3c = {
	.name=			"find",
	.signature=		"(Ljava/lang/String;)Lpolyglot/types/Named;",
	.class=			&_jc_polyglot_types_SourceClassResolver$type,
	.param_types=		&_jc_polyglot_types_SourceClassResolver$param_types$find$6acc62ea1c707b3c,
	.return_type=		&_jc_polyglot_types_Named$type,
	.param_ptypes=		&_jc_polyglot_types_SourceClassResolver$param_ptypes$find$6acc62ea1c707b3c,
	.signature_hash=	_JC_JLONG(0x6acc62ea1c707b3c),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_types_SourceClassResolver$method$find$6acc62ea1c707b3c,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_types_SourceClassResolver$vtable, polyglot_types_SourceClassResolver.find$6acc62ea1c707b3c) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_types_SourceClassResolver$exceptions$find$6acc62ea1c707b3c,
	.u= { .exec= {
	  .trap_table_len=	2,
	  .trap_table=		_jc_polyglot_types_SourceClassResolver$trap_table$find$6acc62ea1c707b3c,
	  .u= {
	    .linenum= {
	      .len=	48,
	      .table=	_jc_polyglot_types_SourceClassResolver$linenum_table$find$6acc62ea1c707b3c
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_types_SourceClassResolver, find$6acc62ea1c707b3c);

_jc_object * _JC_JCNI_ATTR
_jc_polyglot_types_SourceClassResolver$method$find$6acc62ea1c707b3c(_jc_env *const env, _jc_polyglot_types_SourceClassResolver$object *this, _jc_java_lang_String$object *param0)
{
	jbyte b3;
	jint i10;
	jint i11;
	jint volatile i12;
	jint volatile i13;
	jint volatile i14;
	jint i2;
	jint i4;
	jint i5;
	jint i6;
	jint i7;
	jint i8;
	jint i9;
	jlong l0;
	jlong l1;
	struct _jc_polyglot_types_SourceClassResolver$object *volatile r0;
	struct _jc_java_lang_String$object *volatile r1;
	struct _jc_polyglot_frontend_FileSource$object *volatile r10;
	struct _jc_java_util_Date$object *r11;
	struct _jc_object *r12;
	struct _jc_polyglot_types_BadSerializationException$object *volatile r13;
	struct _jc_polyglot_types_SemanticException$object *volatile r14;
	struct _jc_object *volatile r15;
	struct _jc_object *volatile r16;
	struct _jc_object *volatile r17;
	struct _jc_polyglot_types_NoClassException$object *volatile r18;
	struct _jc_java_lang_String$object *r19;
	struct _jc_object *volatile r2;
	struct _jc_java_lang_String$object *r20;
	struct _jc_java_lang_String$object *r21;
	struct _jc_java_lang_String$object *r22;
	struct _jc_java_lang_String$object *r23;
	struct _jc_java_lang_String$object *r24;
	struct _jc_java_lang_String$object *r25;
	struct _jc_java_lang_String$object *r26;
	struct _jc_java_lang_String$object *volatile r27;
	struct _jc_java_lang_String$object *volatile r28;
	struct _jc_java_lang_String$object *volatile r29;
	struct _jc_polyglot_types_reflect_ClassFile$object *r3;
	struct _jc_java_lang_String$object *volatile r30;
	_jc_char_array *r31;
	_jc_char_array *r32;
	_jc_char_array *r33;
	_jc_char_array *r34;
	_jc_char_array *r35;
	_jc_char_array *r36;
	_jc_char_array *r37;
	_jc_char_array *r38;
	_jc_char_array *volatile r39;
	struct _jc_java_lang_StringBuffer$object *volatile r4;
	_jc_char_array *volatile r40;
	_jc_char_array *volatile r41;
	_jc_char_array *volatile r42;
	struct _jc_java_lang_VMThrowable$object *volatile r43;
	struct _jc_java_lang_String$object *volatile r44;
	struct _jc_java_io_PrintStream$object *volatile r45;
	struct _jc_java_lang_String$object *volatile r46;
	struct _jc_java_lang_StringBuffer$object *r47;
	struct _jc_java_lang_String$object *r48;
	struct _jc_java_util_Collections__24SingletonList$object *volatile r49;
	struct _jc_java_lang_String$object *volatile r5;
	struct _jc_java_io_PrintStream$object *r50;
	struct _jc_java_io_PrintStream$object *r51;
	struct _jc_java_io_PrintStream$object *r52;
	struct _jc_java_io_PrintStream$object *r53;
	struct _jc_java_io_PrintStream$object *r54;
	struct _jc_java_io_PrintStream$object *r55;
	struct _jc_java_io_PrintStream$object *r56;
	struct _jc_java_io_PrintStream$object *r57;
	struct _jc_java_io_PrintStream$object *volatile r58;
	struct _jc_java_io_PrintStream$object *volatile r59;
	struct _jc_polyglot_types_reflect_ClassFile$object *volatile r6;
	struct _jc_java_io_PrintStream$object *volatile r60;
	struct _jc_java_lang_StringBuffer$object *volatile r61;
	struct _jc_java_lang_String$object *volatile r62;
	_jc_char_array *volatile r63;
	struct _jc_java_lang_VMThrowable$object *volatile r64;
	struct _jc_java_lang_String$object *volatile r65;
	struct _jc_java_io_PrintStream$object *volatile r66;
	struct _jc_java_lang_String$object *volatile r67;
	struct _jc_java_util_Collections__24SingletonList$object *volatile r68;
	struct _jc_polyglot_main_Version$object *r7;
	struct _jc_object *volatile r8;
	struct _jc_polyglot_frontend_SourceLoader$object *r9;
	jboolean volatile z0;
	jboolean volatile z1;
	jboolean volatile z2;
	jboolean volatile z3;
	jboolean volatile z4;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_polyglot_types_SourceClassResolver$method_info$find$6acc62ea1c707b3c, &&label31, &&label32);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(102);				// 0
	r2 = _JC_STATIC_FIELD(env, polyglot_types_LoadedClassResolver, report__5ftopics, 1);
	z0 = _JC_INVOKE_STATIC(env, polyglot_main_Report, should__5freport$316269f2ec4db001, 0, r2, 3);
	if (z0 == 0)
		goto label2;
	_JC_LINE_NUMBER(103);				// 1
	r4 = _JC_NEW(env, java_lang_StringBuffer);
	r31 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r4, java_lang_StringBuffer, value) = r31;
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, _JC_STRING(env, "SourceCR.find("));
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, r1);
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, _JC_STRING(env, ")"));
	r19 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r19, r4);
	i4 = 1;

label0:
	if (i4 >= 3)
		goto label1;
	r50 = _JC_STATIC_FIELD(env, java_lang_System, err, 0);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, print$21bdbb15afdbea95, r50, _JC_STRING(env, "  "));
	i4 = i4 + 1;
	_JC_PERIODIC_CHECK(env);
	goto label0;

label1:
	r50 = _JC_STATIC_FIELD(env, java_lang_System, err, 0);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, println$f7dbc2aa0f0a9d4f, r50, r19);

label2:
	_JC_LINE_NUMBER(106);				// 2
	r3 = _JC_NULL;
	_JC_LINE_NUMBER(110);				// 3
	r6 = _JC_INVOKE_VIRTUAL(env, polyglot_types_LoadedClassResolver, loadFile$6eba5e5275043e6e, r0, r1);
	_JC_LINE_NUMBER(111);				// 4
	if (r6 == _JC_NULL)
		goto label6;
	_JC_LINE_NUMBER(113);				// 5
	r7 = _JC_REF_FIELD(env, r0, polyglot_types_LoadedClassResolver, version);
	r5 = _JC_INVOKE_VIRTUAL(env, polyglot_main_Version, name$e6acce026cadf81e, r7);
	r5 = _JC_INVOKE_VIRTUAL(env, polyglot_types_reflect_ClassFile, encodedClassType$6ed3e41f9601f1b9, r6, r5);
	if (r5 == _JC_NULL)
		goto label6;
	_JC_LINE_NUMBER(114);				// 6
	r2 = _JC_STATIC_FIELD(env, polyglot_types_LoadedClassResolver, report__5ftopics, 1);
	z0 = _JC_INVOKE_STATIC(env, polyglot_main_Report, should__5freport$316269f2ec4db001, 0, r2, 4);
	if (z0 == 0)
		goto label5;
	_JC_LINE_NUMBER(115);				// 7
	r4 = _JC_NEW(env, java_lang_StringBuffer);
	r32 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r4, java_lang_StringBuffer, value) = r32;
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, _JC_STRING(env, "Class "));
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, r1);
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, _JC_STRING(env, " has encoded type info"));
	r20 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r20, r4);
	i5 = 1;

label3:
	if (i5 >= 4)
		goto label4;
	r51 = _JC_STATIC_FIELD(env, java_lang_System, err, 0);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, print$21bdbb15afdbea95, r51, _JC_STRING(env, "  "));
	i5 = i5 + 1;
	_JC_PERIODIC_CHECK(env);
	goto label3;

label4:
	r51 = _JC_STATIC_FIELD(env, java_lang_System, err, 0);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, println$f7dbc2aa0f0a9d4f, r51, r20);

label5:
	_JC_LINE_NUMBER(116);				// 8
	r3 = r6;

label6:
	_JC_LINE_NUMBER(121);				// 9
	r8 = _JC_REF_FIELD(env, r0, polyglot_types_SourceClassResolver, ext);
	r9 = _JC_INVOKE_INTERFACE(env, r8, _JC_JLONG(0xe3dacb62b9f7eae9), _jc_object *, (_jc_env *, struct _jc_object *));
	r10 = _JC_INVOKE_VIRTUAL(env, polyglot_frontend_SourceLoader, classSource$9e78960aad0987c2, r9, r1);
	_JC_LINE_NUMBER(122);				// 10
	r2 = _JC_STATIC_FIELD(env, polyglot_types_LoadedClassResolver, report__5ftopics, 1);
	z0 = _JC_INVOKE_STATIC(env, polyglot_main_Report, should__5freport$316269f2ec4db001, 0, r2, 4);
	if (z0 == 0)
		goto label14;
	_JC_LINE_NUMBER(123);				// 11
	if (r10 != _JC_NULL)
		goto label9;
	_JC_LINE_NUMBER(124);				// 12
	r4 = _JC_NEW(env, java_lang_StringBuffer);
	r33 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r4, java_lang_StringBuffer, value) = r33;
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, _JC_STRING(env, "Class "));
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, r1);
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, _JC_STRING(env, " not found in source file"));
	r21 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r21, r4);
	i6 = 1;

label7:
	if (i6 >= 4)
		goto label8;
	r52 = _JC_STATIC_FIELD(env, java_lang_System, err, 0);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, print$21bdbb15afdbea95, r52, _JC_STRING(env, "  "));
	i6 = i6 + 1;
	_JC_PERIODIC_CHECK(env);
	goto label7;

label8:
	r52 = _JC_STATIC_FIELD(env, java_lang_System, err, 0);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, println$f7dbc2aa0f0a9d4f, r52, r21);
	goto label14;

label9:
	_JC_LINE_NUMBER(126);				// 13
	r4 = _JC_NEW(env, java_lang_StringBuffer);
	r34 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r4, java_lang_StringBuffer, value) = r34;
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, _JC_STRING(env, "Class "));
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, r1);
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, _JC_STRING(env, " found in source "));
	r47 = r4;
	if (r10 != _JC_NULL)
		goto label10;
	r48 = _JC_STRING(env, "null");
	goto label11;

label10:
	r48 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, toString$7ea43b33b80a3070, r10);

label11:
	r47 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r47, r48);
	r22 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r22, r47);
	i7 = 1;

label12:
	if (i7 >= 4)
		goto label13;
	r53 = _JC_STATIC_FIELD(env, java_lang_System, err, 0);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, print$21bdbb15afdbea95, r53, _JC_STRING(env, "  "));
	i7 = i7 + 1;
	_JC_PERIODIC_CHECK(env);
	goto label12;

label13:
	r53 = _JC_STATIC_FIELD(env, java_lang_System, err, 0);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, println$f7dbc2aa0f0a9d4f, r53, r22);

label14:
	_JC_LINE_NUMBER(130);				// 14
	if (r3 != _JC_NULL)
		goto label15;
	if (r10 == _JC_NULL)
		goto label19;

label15:
	_JC_LINE_NUMBER(131);				// 15
	r2 = _JC_STATIC_FIELD(env, polyglot_types_LoadedClassResolver, report__5ftopics, 0);
	z0 = _JC_INVOKE_STATIC(env, polyglot_main_Report, should__5freport$316269f2ec4db001, 0, r2, 4);
	if (z0 == 0)
		goto label18;
	_JC_LINE_NUMBER(132);				// 16
	r4 = _JC_NEW(env, java_lang_StringBuffer);
	r35 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r4, java_lang_StringBuffer, value) = r35;
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, _JC_STRING(env, "Not using raw class file for "));
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, r1);
	r23 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r23, r4);
	i8 = 1;

label16:
	if (i8 >= 4)
		goto label17;
	r54 = _JC_STATIC_FIELD(env, java_lang_System, err, 0);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, print$21bdbb15afdbea95, r54, _JC_STRING(env, "  "));
	i8 = i8 + 1;
	_JC_PERIODIC_CHECK(env);
	goto label16;

label17:
	r54 = _JC_STATIC_FIELD(env, java_lang_System, err, 0);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, println$f7dbc2aa0f0a9d4f, r54, r23);

label18:
	_JC_LINE_NUMBER(133);				// 17
	r6 = _JC_NULL;

label19:
	_JC_LINE_NUMBER(138);				// 18
	if (r3 == _JC_NULL)
		goto label27;
	if (r10 == _JC_NULL)
		goto label27;
	_JC_LINE_NUMBER(139);				// 19
	r7 = _JC_REF_FIELD(env, r0, polyglot_types_LoadedClassResolver, version);
	r5 = _JC_INVOKE_VIRTUAL(env, polyglot_main_Version, name$e6acce026cadf81e, r7);
	l0 = _JC_INVOKE_VIRTUAL(env, polyglot_types_reflect_ClassFile, sourceLastModified$09502e095e3b4ccd, r3, r5);
	_JC_LINE_NUMBER(140);				// 20
	r11 = _JC_INVOKE_VIRTUAL(env, polyglot_frontend_Source, lastModified$75be6b283d1a0c69, r10);
	l1 = _JC_INVOKE_VIRTUAL(env, java_util_Date, getTime$5fabbaa41130db0f, r11);
	_JC_LINE_NUMBER(142);				// 21
	r7 = _JC_REF_FIELD(env, r0, polyglot_types_LoadedClassResolver, version);
	r5 = _JC_INVOKE_VIRTUAL(env, polyglot_main_Version, name$e6acce026cadf81e, r7);
	r5 = _JC_INVOKE_VIRTUAL(env, polyglot_types_reflect_ClassFile, compilerVersion$7f0cc0202ac6be09, r3, r5);
	i2 = _JC_INVOKE_VIRTUAL(env, polyglot_types_LoadedClassResolver, checkCompilerVersion$06ae3cf9489417d8, r0, r5);
	_JC_LINE_NUMBER(144);				// 22
	b3 = _JC_LCMP(l0, l1);
	if (b3 >= 0)
		goto label23;
	_JC_LINE_NUMBER(145);				// 23
	r2 = _JC_STATIC_FIELD(env, polyglot_types_LoadedClassResolver, report__5ftopics, 1);
	z0 = _JC_INVOKE_STATIC(env, polyglot_main_Report, should__5freport$316269f2ec4db001, 0, r2, 3);
	if (z0 == 0)
		goto label22;
	_JC_LINE_NUMBER(146);				// 24
	r4 = _JC_NEW(env, java_lang_StringBuffer);
	r36 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r4, java_lang_StringBuffer, value) = r36;
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, _JC_STRING(env, "Source file version is newer than compiled for "));
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, r1);
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, _JC_STRING(env, "."));
	r24 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r24, r4);
	i9 = 1;

label20:
	if (i9 >= 3)
		goto label21;
	r55 = _JC_STATIC_FIELD(env, java_lang_System, err, 0);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, print$21bdbb15afdbea95, r55, _JC_STRING(env, "  "));
	i9 = i9 + 1;
	_JC_PERIODIC_CHECK(env);
	goto label20;

label21:
	r55 = _JC_STATIC_FIELD(env, java_lang_System, err, 0);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, println$f7dbc2aa0f0a9d4f, r55, r24);

label22:
	_JC_LINE_NUMBER(148);				// 25
	r3 = _JC_NULL;
	goto label27;

label23:
	_JC_LINE_NUMBER(150);				// 26
	if (i2 == 0)
		goto label27;
	_JC_LINE_NUMBER(152);				// 27
	r2 = _JC_STATIC_FIELD(env, polyglot_types_LoadedClassResolver, report__5ftopics, 1);
	z0 = _JC_INVOKE_STATIC(env, polyglot_main_Report, should__5freport$316269f2ec4db001, 0, r2, 3);
	if (z0 == 0)
		goto label26;
	_JC_LINE_NUMBER(153);				// 28
	r4 = _JC_NEW(env, java_lang_StringBuffer);
	r37 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r4, java_lang_StringBuffer, value) = r37;
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, _JC_STRING(env, "Incompatible source file version for "));
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, r1);
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, _JC_STRING(env, "."));
	r25 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r25, r4);
	i10 = 1;

label24:
	if (i10 >= 3)
		goto label25;
	r56 = _JC_STATIC_FIELD(env, java_lang_System, err, 0);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, print$21bdbb15afdbea95, r56, _JC_STRING(env, "  "));
	i10 = i10 + 1;
	_JC_PERIODIC_CHECK(env);
	goto label24;

label25:
	r56 = _JC_STATIC_FIELD(env, java_lang_System, err, 0);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, println$f7dbc2aa0f0a9d4f, r56, r25);

label26:
	_JC_LINE_NUMBER(154);				// 29
	r3 = _JC_NULL;

label27:
	_JC_LINE_NUMBER(158);				// 30
	if (r3 == _JC_NULL)
		goto label35;
	_JC_LINE_NUMBER(159);				// 31
	r2 = _JC_STATIC_FIELD(env, polyglot_types_LoadedClassResolver, report__5ftopics, 0);
	z0 = _JC_INVOKE_STATIC(env, polyglot_main_Report, should__5freport$316269f2ec4db001, 0, r2, 4);
	if (z0 == 0)
		goto label30;
	_JC_LINE_NUMBER(160);				// 32
	r4 = _JC_NEW(env, java_lang_StringBuffer);
	r38 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r4, java_lang_StringBuffer, value) = r38;
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, _JC_STRING(env, "Using encoded class type for "));
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, r1);
	r26 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r26, r4);
	i11 = 1;

label28:
	if (i11 >= 4)
		goto label29;
	r57 = _JC_STATIC_FIELD(env, java_lang_System, err, 0);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, print$21bdbb15afdbea95, r57, _JC_STRING(env, "  "));
	i11 = i11 + 1;
	_JC_PERIODIC_CHECK(env);
	goto label28;

label29:
	r57 = _JC_STATIC_FIELD(env, java_lang_System, err, 0);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, println$f7dbc2aa0f0a9d4f, r57, r26);

label30:
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(162);				// 33
	r12 = _JC_INVOKE_VIRTUAL(env, polyglot_types_LoadedClassResolver, getEncodedType$2d027e16f96acd78, r0, r3, r1);
	_JC_TRAP_REGION(catch, 2);
	_JC_CANCEL_TRAPS(env, catch);
	return r12;

label31:
	_JC_TRAP_REGION(catch, 2);
	r13 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(165);				// 34
	_JC_THROW(env, r13);

label32:
	_JC_TRAP_REGION(catch, 2);
	r14 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(168);				// 35
	r2 = _JC_STATIC_FIELD(env, polyglot_types_LoadedClassResolver, report__5ftopics, 0);
	z0 = _JC_INVOKE_STATIC(env, polyglot_main_Report, should__5freport$316269f2ec4db001, 0, r2, 4);
	if (z0 == 0)
		goto label35;
	_JC_LINE_NUMBER(169);				// 36
	r4 = _JC_NEW(env, java_lang_StringBuffer);
	r39 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r4, java_lang_StringBuffer, value) = r39;
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, _JC_STRING(env, "Could not load encoded class "));
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, r1);
	r27 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r27, r4);
	i12 = 1;

label33:
	if (i12 >= 4)
		goto label34;
	r58 = _JC_STATIC_FIELD(env, java_lang_System, err, 0);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, print$21bdbb15afdbea95, r58, _JC_STRING(env, "  "));
	i12 = i12 + 1;
	_JC_PERIODIC_CHECK(env);
	goto label33;

label34:
	r58 = _JC_STATIC_FIELD(env, java_lang_System, err, 0);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, println$f7dbc2aa0f0a9d4f, r58, r27);

label35:
	_JC_TRAP_REGION(catch, 2);
	_JC_LINE_NUMBER(176);				// 37
	if (r6 == _JC_NULL)
		goto label39;
	z0 = _JC_PRIM_FIELD(env, r0, polyglot_types_LoadedClassResolver, allowRawClasses);
	if (z0 == 0)
		goto label39;
	_JC_LINE_NUMBER(177);				// 38
	r2 = _JC_STATIC_FIELD(env, polyglot_types_LoadedClassResolver, report__5ftopics, 1);
	z0 = _JC_INVOKE_STATIC(env, polyglot_main_Report, should__5freport$316269f2ec4db001, 0, r2, 4);
	if (z0 == 0)
		goto label38;
	_JC_LINE_NUMBER(178);				// 39
	r4 = _JC_NEW(env, java_lang_StringBuffer);
	r40 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r4, java_lang_StringBuffer, value) = r40;
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, _JC_STRING(env, "Using raw class file for "));
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, r1);
	r28 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r28, r4);
	i13 = 1;

label36:
	if (i13 >= 4)
		goto label37;
	r59 = _JC_STATIC_FIELD(env, java_lang_System, err, 0);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, print$21bdbb15afdbea95, r59, _JC_STRING(env, "  "));
	i13 = i13 + 1;
	_JC_PERIODIC_CHECK(env);
	goto label36;

label37:
	r59 = _JC_STATIC_FIELD(env, java_lang_System, err, 0);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, println$f7dbc2aa0f0a9d4f, r59, r28);

label38:
	_JC_LINE_NUMBER(179);				// 40
	r15 = _JC_REF_FIELD(env, r0, polyglot_types_LoadedClassResolver, ts);
	r16 = _JC_INVOKE_VIRTUAL(env, polyglot_types_reflect_ClassFile, type$9391e49113389823, r6, r15);
	_JC_CANCEL_TRAPS(env, catch);
	return r16;

label39:
	_JC_LINE_NUMBER(182);				// 41
	if (r10 == _JC_NULL)
		goto label43;
	_JC_LINE_NUMBER(183);				// 42
	r2 = _JC_STATIC_FIELD(env, polyglot_types_LoadedClassResolver, report__5ftopics, 0);
	z0 = _JC_INVOKE_STATIC(env, polyglot_main_Report, should__5freport$316269f2ec4db001, 0, r2, 4);
	if (z0 == 0)
		goto label42;
	_JC_LINE_NUMBER(184);				// 43
	r4 = _JC_NEW(env, java_lang_StringBuffer);
	r41 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r4, java_lang_StringBuffer, value) = r41;
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, _JC_STRING(env, "Using source file for "));
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, r1);
	r29 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r29, r4);
	i14 = 1;

label40:
	if (i14 >= 4)
		goto label41;
	r60 = _JC_STATIC_FIELD(env, java_lang_System, err, 0);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, print$21bdbb15afdbea95, r60, _JC_STRING(env, "  "));
	i14 = i14 + 1;
	_JC_PERIODIC_CHECK(env);
	goto label40;

label41:
	r60 = _JC_STATIC_FIELD(env, java_lang_System, err, 0);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, println$f7dbc2aa0f0a9d4f, r60, r29);

label42:
	_JC_LINE_NUMBER(185);				// 44
	r17 = _JC_INVOKE_VIRTUAL(env, polyglot_types_SourceClassResolver, getTypeFromSource$461c201b25d9ed0f, r0, r10, r1);
	_JC_CANCEL_TRAPS(env, catch);
	return r17;

label43:
	_JC_LINE_NUMBER(188);				// 45
	if (r6 == _JC_NULL)
		goto label47;
	z0 = _JC_PRIM_FIELD(env, r0, polyglot_types_LoadedClassResolver, allowRawClasses);
	if (z0 != 0)
		goto label47;
	_JC_LINE_NUMBER(191);				// 46
	r14 = _JC_NEW(env, polyglot_types_SemanticException);
	r4 = _JC_NEW(env, java_lang_StringBuffer);
	r42 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r4, java_lang_StringBuffer, value) = r42;
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, _JC_STRING(env, "Class \""));
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, r1);
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, _JC_STRING(env, "\" not found."));
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, _JC_STRING(env, " A class file was found, but it did not contain appropriate"));
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, _JC_STRING(env, " information for the Polyglot-based compiler "));
	r8 = _JC_REF_FIELD(env, r0, polyglot_types_SourceClassResolver, ext);
	r5 = _JC_INVOKE_INTERFACE(env, r8, _JC_JLONG(0x20b6c9308360447c), _jc_object *, (_jc_env *, struct _jc_object *));
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, r5);
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, _JC_STRING(env, ". Try using "));
	r8 = _JC_REF_FIELD(env, r0, polyglot_types_SourceClassResolver, ext);
	r5 = _JC_INVOKE_INTERFACE(env, r8, _JC_JLONG(0x20b6c9308360447c), _jc_object *, (_jc_env *, struct _jc_object *));
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, r5);
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r4, _JC_STRING(env, " to recompile the source code."));
	r30 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r30, r4);
	_JC_REF_FIELD(env, r14, java_lang_Throwable, cause) = r14;
	r43 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r14);
	_JC_REF_FIELD(env, r14, java_lang_Throwable, vmState) = r43;
	_JC_REF_FIELD(env, r14, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r14, java_lang_Throwable, detailMessage) = r30;
	r44 = _JC_STATIC_FIELD(env, polyglot_main_Report, errors, 0);
	z2 = _JC_STATIC_FIELD(env, polyglot_main_Report, noReporting, 1);
	if (z2 == 0)
		goto label44;
	z1 = 0;
	goto label45;

label44:
	_JC_ACTIVE_USE(env, java_util_Collections);
	r49 = _JC_NEW(env, java_util_Collections__24SingletonList);
	_JC_REF_FIELD(env, r49, java_util_Collections__24SingletonList, element) = r44;
	z2 = _JC_INVOKE_STATIC(env, polyglot_main_Report, should__5freport$316269f2ec4db001, 1, r49, 5);
	z1 = z2;

label45:
	if (z1 == 0)
		goto label46;
	r45 = _JC_STATIC_FIELD(env, java_lang_System, err, 0);
	r46 = _JC_INVOKE_NONVIRTUAL(env, java_lang_Throwable, stackTraceString$42eec01c019ee6b0, 0, r14);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, print$21bdbb15afdbea95, r45, r46);

label46:
	_JC_THROW(env, r14);

label47:
	_JC_LINE_NUMBER(197);				// 47
	r18 = _JC_NEW(env, polyglot_types_NoClassException);
	r61 = _JC_NEW(env, java_lang_StringBuffer);
	r63 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r61, java_lang_StringBuffer, value) = r63;
	r61 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r61, _JC_STRING(env, "Class \""));
	r61 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r61, r1);
	r61 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r61, _JC_STRING(env, "\" not found."));
	r62 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r62, r61);
	_JC_REF_FIELD(env, r18, java_lang_Throwable, cause) = r18;
	r64 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r18);
	_JC_REF_FIELD(env, r18, java_lang_Throwable, vmState) = r64;
	_JC_REF_FIELD(env, r18, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r18, java_lang_Throwable, detailMessage) = r62;
	r65 = _JC_STATIC_FIELD(env, polyglot_main_Report, errors, 0);
	z4 = _JC_STATIC_FIELD(env, polyglot_main_Report, noReporting, 1);
	if (z4 == 0)
		goto label48;
	z3 = 0;
	goto label49;

label48:
	_JC_ACTIVE_USE(env, java_util_Collections);
	r68 = _JC_NEW(env, java_util_Collections__24SingletonList);
	_JC_REF_FIELD(env, r68, java_util_Collections__24SingletonList, element) = r65;
	z4 = _JC_INVOKE_STATIC(env, polyglot_main_Report, should__5freport$316269f2ec4db001, 1, r68, 5);
	z3 = z4;

label49:
	if (z3 == 0)
		goto label50;
	r66 = _JC_STATIC_FIELD(env, java_lang_System, err, 0);
	r67 = _JC_INVOKE_NONVIRTUAL(env, java_lang_Throwable, stackTraceString$42eec01c019ee6b0, 0, r18);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, print$21bdbb15afdbea95, r66, r67);

label50:
	_JC_REF_FIELD(env, r18, polyglot_types_NoClassException, className) = r1;
	_JC_THROW(env, r18);
}

//
// protected polyglot.types.Named getTypeFromSource(polyglot.frontend.FileSource, java.lang.String) throws polyglot.types.SemanticException
//

static _jc_linenum _jc_polyglot_types_SourceClassResolver$linenum_table$getTypeFromSource$461c201b25d9ed0f[];

static const unsigned char _jc_polyglot_types_SourceClassResolver$param_ptypes$getTypeFromSource$461c201b25d9ed0f[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_SourceClassResolver$exceptions$getTypeFromSource$461c201b25d9ed0f[] = {
	&_jc_polyglot_types_SemanticException$type
};

static _jc_type *const _jc_polyglot_types_SourceClassResolver$param_types$getTypeFromSource$461c201b25d9ed0f[] = {
	&_jc_polyglot_frontend_FileSource$type,
	&_jc_java_lang_String$type
};

_jc_method _jc_polyglot_types_SourceClassResolver$method_info$getTypeFromSource$461c201b25d9ed0f = {
	.name=			"getTypeFromSource",
	.signature=		"(Lpolyglot/frontend/FileSource;Ljava/lang/String;)Lpolyglot/types/Named;",
	.class=			&_jc_polyglot_types_SourceClassResolver$type,
	.param_types=		&_jc_polyglot_types_SourceClassResolver$param_types$getTypeFromSource$461c201b25d9ed0f,
	.return_type=		&_jc_polyglot_types_Named$type,
	.param_ptypes=		&_jc_polyglot_types_SourceClassResolver$param_ptypes$getTypeFromSource$461c201b25d9ed0f,
	.signature_hash=	_JC_JLONG(0x461c201b25d9ed0f),
	.access_flags=		_JC_ACC_PROTECTED,
	.function=		&_jc_polyglot_types_SourceClassResolver$method$getTypeFromSource$461c201b25d9ed0f,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_types_SourceClassResolver$vtable, polyglot_types_SourceClassResolver.getTypeFromSource$461c201b25d9ed0f) / sizeof(void *),
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_types_SourceClassResolver$exceptions$getTypeFromSource$461c201b25d9ed0f,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_polyglot_types_SourceClassResolver$linenum_table$getTypeFromSource$461c201b25d9ed0f
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_types_SourceClassResolver, getTypeFromSource$461c201b25d9ed0f);

_jc_object * _JC_JCNI_ATTR
_jc_polyglot_types_SourceClassResolver$method$getTypeFromSource$461c201b25d9ed0f(_jc_env *const env, _jc_polyglot_types_SourceClassResolver$object *this, _jc_polyglot_frontend_FileSource$object *param0, _jc_java_lang_String$object *param1)
{
	struct _jc_polyglot_types_SourceClassResolver$object *r0;
	struct _jc_polyglot_frontend_FileSource$object *r1;
	struct _jc_java_lang_String$object *r2;
	struct _jc_object *r3;
	struct _jc_object *r4;
	struct _jc_polyglot_types_TableResolver$object *r5;
	struct _jc_object *r6;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_LINE_NUMBER(207);				// 0
	r3 = _JC_REF_FIELD(env, r0, polyglot_types_SourceClassResolver, ext);
	_JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0x373071cdee84f946), jboolean, (_jc_env *, struct _jc_object *, struct _jc_polyglot_frontend_FileSource$object *), r1);
	_JC_LINE_NUMBER(212);				// 1
	r4 = _JC_REF_FIELD(env, r0, polyglot_types_LoadedClassResolver, ts);
	r5 = _JC_INVOKE_INTERFACE(env, r4, _JC_JLONG(0x94bd2877fd169eca), _jc_object *, (_jc_env *, struct _jc_object *));
	r6 = _JC_INVOKE_VIRTUAL(env, polyglot_types_TableResolver, find$6acc62ea1c707b3c, r5, r2);
	return r6;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_polyglot_types_SourceClassResolver$methods[] = {
	&_jc_polyglot_types_SourceClassResolver$method_info$_init$bcfadaa1eb77075d,
	&_jc_polyglot_types_SourceClassResolver$method_info$find$6acc62ea1c707b3c,
	&_jc_polyglot_types_SourceClassResolver$method_info$getTypeFromSource$461c201b25d9ed0f
};

/************************************************************************
 *			   Interface hash table				*
 ************************************************************************/

#if _JC_IMETHOD_HASHSIZE != 128
#error "_JC_IMETHOD_HASHSIZE has the wrong value (should be 128)"
#endif

// Interface lookup hash table buckets
static _jc_method *_jc_polyglot_types_SourceClassResolver$imethod_hash_bucket_60[] = {
	&_jc_polyglot_types_SourceClassResolver$method_info$find$6acc62ea1c707b3c,
	_JC_NULL
};

// Interface lookup hash table
static _jc_method **_jc_polyglot_types_SourceClassResolver$imethod_hash_table[_JC_IMETHOD_HASHSIZE] = {
	[60]=	_jc_polyglot_types_SourceClassResolver$imethod_hash_bucket_60
};

// Interface "quick" lookup hash table
static const void *_jc_polyglot_types_SourceClassResolver$imethod_quick_table[_JC_IMETHOD_HASHSIZE] = {
	[60]=	&_jc_polyglot_types_SourceClassResolver$method$find$6acc62ea1c707b3c
};

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_polyglot_types_SourceClassResolver$instanceof_hash_bucket_11[] = {
	&_jc_polyglot_types_SourceClassResolver$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_types_SourceClassResolver$instanceof_hash_bucket_29[] = {
	&_jc_polyglot_types_ClassResolver$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_types_SourceClassResolver$instanceof_hash_bucket_38[] = {
	&_jc_polyglot_types_LoadedClassResolver$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_types_SourceClassResolver$instanceof_hash_bucket_43[] = {
	&_jc_polyglot_types_Resolver$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_types_SourceClassResolver$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_polyglot_types_SourceClassResolver$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[11]=	_jc_polyglot_types_SourceClassResolver$instanceof_hash_bucket_11,
	[29]=	_jc_polyglot_types_SourceClassResolver$instanceof_hash_bucket_29,
	[38]=	_jc_polyglot_types_SourceClassResolver$instanceof_hash_bucket_38,
	[43]=	_jc_polyglot_types_SourceClassResolver$instanceof_hash_bucket_43,
	[101]=	_jc_polyglot_types_SourceClassResolver$instanceof_hash_bucket_101
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_polyglot_types_SourceClassResolver$class_depends[] = {
	{ "java/io/PrintStream",	_JC_JLONG(0x99a46305ebacacb5) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/StringBuffer",	_JC_JLONG(0x94d357637b968dda) },
	{ "java/lang/System",	_JC_JLONG(0x53cc8e2333795f04) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/util/AbstractCollection",	_JC_JLONG(0x8ea716c64b77f8eb) },
	{ "java/util/AbstractList",	_JC_JLONG(0xf5238436362828db) },
	{ "java/util/Collection",	_JC_JLONG(0xeae4d0c0e8eb63da) },
	{ "java/util/Collections",	_JC_JLONG(0x9574af3fed58029a) },
	{ "java/util/Collections$SingletonList",	_JC_JLONG(0x2ccd076083da6c8e) },
	{ "java/util/Date",	_JC_JLONG(0xa85d2a51094e614c) },
	{ "polyglot/frontend/Compiler",	_JC_JLONG(0x3ea6f1cf85115422) },
	{ "polyglot/frontend/ExtensionInfo",	_JC_JLONG(0xfdbc32d4847269bf) },
	{ "polyglot/frontend/FileSource",	_JC_JLONG(0x39c133c176bc5fd1) },
	{ "polyglot/frontend/Source",	_JC_JLONG(0xcd88b669bec8f787) },
	{ "polyglot/frontend/SourceLoader",	_JC_JLONG(0xc0bff66c4ab313ae) },
	{ "polyglot/main/Report",	_JC_JLONG(0xcf9f146bdb7bc44d) },
	{ "polyglot/main/Version",	_JC_JLONG(0x4ba1325a7aefecac) },
	{ "polyglot/types/BadSerializationException",	_JC_JLONG(0x5bedf50c16a6702d) },
	{ "polyglot/types/ClassResolver",	_JC_JLONG(0xeec1a4cebd785b9d) },
	{ "polyglot/types/ClassType",	_JC_JLONG(0xb38560af658974f8) },
	{ "polyglot/types/LoadedClassResolver",	_JC_JLONG(0x775d491e1eb77426) },
	{ "polyglot/types/Named",	_JC_JLONG(0xe5f53252d3bf5dfd) },
	{ "polyglot/types/NoClassException",	_JC_JLONG(0x7e014a610596faf9) },
	{ "polyglot/types/ParsedClassType",	_JC_JLONG(0x6bcfbf52304f9e7c) },
	{ "polyglot/types/Resolver",	_JC_JLONG(0x3a3788b16a28392b) },
	{ "polyglot/types/SemanticException",	_JC_JLONG(0x45f755f5298b5b39) },
	{ "polyglot/types/TableResolver",	_JC_JLONG(0x4fb97851ac3ef2dd) },
	{ "polyglot/types/TypeSystem",	_JC_JLONG(0xed171cdaca38ec28) },
	{ "polyglot/types/reflect/ClassFile",	_JC_JLONG(0xf394a649a5830bb) },
	{ "polyglot/types/reflect/ClassFileLoader",	_JC_JLONG(0x50cc35358493eab1) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_polyglot_types_SourceClassResolver$vtype _jc_polyglot_types_SourceClassResolver$type = {
    .type= {
	.name=			"polyglot/types/SourceClassResolver",
	.superclass=		&_jc_polyglot_types_LoadedClassResolver$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_polyglot_types_SourceClassResolver$imethod_hash_table,
	.imethod_quick_table=	_jc_polyglot_types_SourceClassResolver$imethod_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		18,
		.hash=			_JC_JLONG(0xa81fa73809a6780b),
		.source_file=		"SourceClassResolver.java",
		.instance_size=		sizeof(_jc_polyglot_types_SourceClassResolver$refs) + sizeof(_jc_polyglot_types_SourceClassResolver$object),
		.num_virtual_refs=	7,
		.num_fields=		sizeof(_jc_polyglot_types_SourceClassResolver$fields) / sizeof(*_jc_polyglot_types_SourceClassResolver$fields),
		.fields=		_jc_polyglot_types_SourceClassResolver$fields,
		.num_methods=		sizeof(_jc_polyglot_types_SourceClassResolver$methods) / sizeof(*_jc_polyglot_types_SourceClassResolver$methods),
		.methods=		_jc_polyglot_types_SourceClassResolver$methods,
		.instanceof_hash_table=	_jc_polyglot_types_SourceClassResolver$instanceof_hash_table,
		.num_class_depends=		sizeof(_jc_polyglot_types_SourceClassResolver$class_depends) / sizeof(*_jc_polyglot_types_SourceClassResolver$class_depends),
		.class_depends=		_jc_polyglot_types_SourceClassResolver$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.polyglot_types_ClassResolver= {
	    .find$6acc62ea1c707b3c=				// overridden
		&_jc_polyglot_types_SourceClassResolver$method$find$6acc62ea1c707b3c,
	},
	.polyglot_types_LoadedClassResolver= {
	    .checkCompilerVersion$06ae3cf9489417d8=
		&_jc_polyglot_types_LoadedClassResolver$method$checkCompilerVersion$06ae3cf9489417d8,
	    .find$6acc62ea1c707b3c=				// overridden
		&_jc_polyglot_types_SourceClassResolver$method$find$6acc62ea1c707b3c,
	    .getEncodedType$2d027e16f96acd78=
		&_jc_polyglot_types_LoadedClassResolver$method$getEncodedType$2d027e16f96acd78,
	    .loadFile$6eba5e5275043e6e=
		&_jc_polyglot_types_LoadedClassResolver$method$loadFile$6eba5e5275043e6e,
	},
	.polyglot_types_SourceClassResolver= {
	    .find$6acc62ea1c707b3c=
		&_jc_polyglot_types_SourceClassResolver$method$find$6acc62ea1c707b3c,
	    .getTypeFromSource$461c201b25d9ed0f=
		&_jc_polyglot_types_SourceClassResolver$method$getTypeFromSource$461c201b25d9ed0f,
	},
    }
};

