// public abstract interface polyglot.types.TypeSystem

// class file dependencies
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class eae4d0c0e8eb63da java_util_Collection
// @dep_class 9ee0d92ce1525a4d java_util_List
// @dep_class 617ac82c0bec2dff java_util_Set
// @dep_class fdbc32d4847269bf polyglot_frontend_ExtensionInfo
// @dep_class cd88b669bec8f787 polyglot_frontend_Source
// @dep_class 412788f7d4254477 polyglot_types_ArrayType
// @dep_class b38560af658974f8 polyglot_types_ClassType
// @dep_class fc9c35c3fb8d6af7 polyglot_types_ConstructorInstance
// @dep_class a433cdcd788f6c37 polyglot_types_Context
// @dep_class d4beb04c35c42bde polyglot_types_FieldInstance
// @dep_class 821eb65d8f2f30f6 polyglot_types_Flags
// @dep_class e82fd79d93315427 polyglot_types_ImportTable
// @dep_class b7281cf8e3a14f14 polyglot_types_InitializerInstance
// @dep_class 3efd9ad11091f77 polyglot_types_LazyClassInitializer
// @dep_class 775d491e1eb77426 polyglot_types_LoadedClassResolver
// @dep_class 143a5bf23e0f6584 polyglot_types_LocalInstance
// @dep_class 7ea7408712d6d898 polyglot_types_MemberInstance
// @dep_class ab0fa5f3ef02c9ee polyglot_types_MethodInstance
// @dep_class 54fedc5d44752cc6 polyglot_types_NullType
// @dep_class 15df1cfa12c16381 polyglot_types_Package
// @dep_class 6bcfbf52304f9e7c polyglot_types_ParsedClassType
// @dep_class c9050be6d71cb6f4 polyglot_types_PrimitiveType
// @dep_class bf36f48cfcf511f4 polyglot_types_ProcedureInstance
// @dep_class cfc647d76f91943a polyglot_types_ReferenceType
// @dep_class 3a3788b16a28392b polyglot_types_Resolver
// @dep_class 45f755f5298b5b39 polyglot_types_SemanticException
// @dep_class 4fb97851ac3ef2dd polyglot_types_TableResolver
// @dep_class 6596051546781098 polyglot_types_Type
// @dep_class b6db228dc0317211 polyglot_types_TypeObject
// @dep_class ed171cdaca38ec28 polyglot_types_TypeSystem
// @dep_class 837b374dbc40bb7c polyglot_types_UnknownQualifier
// @dep_class 38eab2c3a16b0aaa polyglot_types_UnknownType
// @dep_class 32c9a088c5dac046 polyglot_util_Position

// header file dependencies
// @dep_header java_lang_Class
// @dep_header java_lang_String
// @dep_header java_util_Collection
// @dep_header java_util_List
// @dep_header java_util_Set
// @dep_header polyglot_frontend_ExtensionInfo
// @dep_header polyglot_frontend_Source
// @dep_header polyglot_types_ArrayType
// @dep_header polyglot_types_ClassType
// @dep_header polyglot_types_ConstructorInstance
// @dep_header polyglot_types_Context
// @dep_header polyglot_types_FieldInstance
// @dep_header polyglot_types_Flags
// @dep_header polyglot_types_ImportTable
// @dep_header polyglot_types_InitializerInstance
// @dep_header polyglot_types_LazyClassInitializer
// @dep_header polyglot_types_LoadedClassResolver
// @dep_header polyglot_types_LocalInstance
// @dep_header polyglot_types_MemberInstance
// @dep_header polyglot_types_MethodInstance
// @dep_header polyglot_types_NullType
// @dep_header polyglot_types_Package
// @dep_header polyglot_types_ParsedClassType
// @dep_header polyglot_types_PrimitiveType
// @dep_header polyglot_types_ProcedureInstance
// @dep_header polyglot_types_ReferenceType
// @dep_header polyglot_types_Resolver
// @dep_header polyglot_types_SemanticException
// @dep_header polyglot_types_TableResolver
// @dep_header polyglot_types_Type
// @dep_header polyglot_types_TypeObject
// @dep_header polyglot_types_TypeSystem
// @dep_header polyglot_types_UnknownQualifier
// @dep_header polyglot_types_UnknownType
// @dep_header polyglot_util_Position

#include "jc_defs.h"

#include "java/lang/Class.h"
#include "java/lang/String.h"
#include "java/util/Collection.h"
#include "java/util/List.h"
#include "java/util/Set.h"
#include "polyglot/frontend/ExtensionInfo.h"
#include "polyglot/frontend/Source.h"
#include "polyglot/types/ArrayType.h"
#include "polyglot/types/ClassType.h"
#include "polyglot/types/ConstructorInstance.h"
#include "polyglot/types/Context.h"
#include "polyglot/types/FieldInstance.h"
#include "polyglot/types/Flags.h"
#include "polyglot/types/ImportTable.h"
#include "polyglot/types/InitializerInstance.h"
#include "polyglot/types/LazyClassInitializer.h"
#include "polyglot/types/LoadedClassResolver.h"
#include "polyglot/types/LocalInstance.h"
#include "polyglot/types/MemberInstance.h"
#include "polyglot/types/MethodInstance.h"
#include "polyglot/types/NullType.h"
#include "polyglot/types/Package.h"
#include "polyglot/types/ParsedClassType.h"
#include "polyglot/types/PrimitiveType.h"
#include "polyglot/types/ProcedureInstance.h"
#include "polyglot/types/ReferenceType.h"
#include "polyglot/types/Resolver.h"
#include "polyglot/types/SemanticException.h"
#include "polyglot/types/TableResolver.h"
#include "polyglot/types/Type.h"
#include "polyglot/types/TypeObject.h"
#include "polyglot/types/TypeSystem.h"
#include "polyglot/types/UnknownQualifier.h"
#include "polyglot/types/UnknownType.h"
#include "polyglot/util/Position.h"

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public abstract polyglot.types.Flags Abstract()
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$Abstract$3101ad867f932e1a[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_TypeSystem$method_info$Abstract$3101ad867f932e1a = {
	.name=			"Abstract",
	.signature=		"()Lpolyglot/types/Flags;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.return_type=		&_jc_polyglot_types_Flags$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$Abstract$3101ad867f932e1a,
	.signature_hash=	_JC_JLONG(0x3101ad867f932e1a),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract polyglot.types.ClassType ArithmeticException()
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$ArithmeticException$9bf6bfa3c57decc7[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_TypeSystem$method_info$ArithmeticException$9bf6bfa3c57decc7 = {
	.name=			"ArithmeticException",
	.signature=		"()Lpolyglot/types/ClassType;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.return_type=		&_jc_polyglot_types_ClassType$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$ArithmeticException$9bf6bfa3c57decc7,
	.signature_hash=	_JC_JLONG(0x9bf6bfa3c57decc7),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract polyglot.types.ClassType ArrayStoreException()
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$ArrayStoreException$45acc4fa10932146[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_TypeSystem$method_info$ArrayStoreException$45acc4fa10932146 = {
	.name=			"ArrayStoreException",
	.signature=		"()Lpolyglot/types/ClassType;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.return_type=		&_jc_polyglot_types_ClassType$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$ArrayStoreException$45acc4fa10932146,
	.signature_hash=	_JC_JLONG(0x45acc4fa10932146),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract polyglot.types.PrimitiveType Boolean()
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$Boolean$e145ff993ae016c7[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_TypeSystem$method_info$Boolean$e145ff993ae016c7 = {
	.name=			"Boolean",
	.signature=		"()Lpolyglot/types/PrimitiveType;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.return_type=		&_jc_polyglot_types_PrimitiveType$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$Boolean$e145ff993ae016c7,
	.signature_hash=	_JC_JLONG(0xe145ff993ae016c7),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract polyglot.types.PrimitiveType Byte()
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$Byte$700d58be98f69608[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_TypeSystem$method_info$Byte$700d58be98f69608 = {
	.name=			"Byte",
	.signature=		"()Lpolyglot/types/PrimitiveType;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.return_type=		&_jc_polyglot_types_PrimitiveType$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$Byte$700d58be98f69608,
	.signature_hash=	_JC_JLONG(0x700d58be98f69608),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract polyglot.types.PrimitiveType Char()
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$Char$fe585fe6a86121d3[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_TypeSystem$method_info$Char$fe585fe6a86121d3 = {
	.name=			"Char",
	.signature=		"()Lpolyglot/types/PrimitiveType;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.return_type=		&_jc_polyglot_types_PrimitiveType$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$Char$fe585fe6a86121d3,
	.signature_hash=	_JC_JLONG(0xfe585fe6a86121d3),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract polyglot.types.ClassType Class()
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$Class$ea0d791b2a835795[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_TypeSystem$method_info$Class$ea0d791b2a835795 = {
	.name=			"Class",
	.signature=		"()Lpolyglot/types/ClassType;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.return_type=		&_jc_polyglot_types_ClassType$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$Class$ea0d791b2a835795,
	.signature_hash=	_JC_JLONG(0xea0d791b2a835795),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract polyglot.types.ClassType ClassCastException()
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$ClassCastException$e111cc89eefc1d95[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_TypeSystem$method_info$ClassCastException$e111cc89eefc1d95 = {
	.name=			"ClassCastException",
	.signature=		"()Lpolyglot/types/ClassType;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.return_type=		&_jc_polyglot_types_ClassType$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$ClassCastException$e111cc89eefc1d95,
	.signature_hash=	_JC_JLONG(0xe111cc89eefc1d95),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract polyglot.types.ClassType Cloneable()
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$Cloneable$817a23e5b7bd7581[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_TypeSystem$method_info$Cloneable$817a23e5b7bd7581 = {
	.name=			"Cloneable",
	.signature=		"()Lpolyglot/types/ClassType;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.return_type=		&_jc_polyglot_types_ClassType$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$Cloneable$817a23e5b7bd7581,
	.signature_hash=	_JC_JLONG(0x817a23e5b7bd7581),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract polyglot.types.PrimitiveType Double()
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$Double$bec60fc1578ebadb[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_TypeSystem$method_info$Double$bec60fc1578ebadb = {
	.name=			"Double",
	.signature=		"()Lpolyglot/types/PrimitiveType;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.return_type=		&_jc_polyglot_types_PrimitiveType$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$Double$bec60fc1578ebadb,
	.signature_hash=	_JC_JLONG(0xbec60fc1578ebadb),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract polyglot.types.ClassType Error()
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$Error$dad7fad2e2e7038f[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_TypeSystem$method_info$Error$dad7fad2e2e7038f = {
	.name=			"Error",
	.signature=		"()Lpolyglot/types/ClassType;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.return_type=		&_jc_polyglot_types_ClassType$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$Error$dad7fad2e2e7038f,
	.signature_hash=	_JC_JLONG(0xdad7fad2e2e7038f),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract polyglot.types.ClassType Exception()
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$Exception$f5caa9f3aa67024b[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_TypeSystem$method_info$Exception$f5caa9f3aa67024b = {
	.name=			"Exception",
	.signature=		"()Lpolyglot/types/ClassType;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.return_type=		&_jc_polyglot_types_ClassType$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$Exception$f5caa9f3aa67024b,
	.signature_hash=	_JC_JLONG(0xf5caa9f3aa67024b),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract polyglot.types.Flags Final()
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$Final$6c770ed071867d68[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_TypeSystem$method_info$Final$6c770ed071867d68 = {
	.name=			"Final",
	.signature=		"()Lpolyglot/types/Flags;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.return_type=		&_jc_polyglot_types_Flags$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$Final$6c770ed071867d68,
	.signature_hash=	_JC_JLONG(0x6c770ed071867d68),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract polyglot.types.PrimitiveType Float()
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$Float$993d0c4b6fff7e75[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_TypeSystem$method_info$Float$993d0c4b6fff7e75 = {
	.name=			"Float",
	.signature=		"()Lpolyglot/types/PrimitiveType;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.return_type=		&_jc_polyglot_types_PrimitiveType$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$Float$993d0c4b6fff7e75,
	.signature_hash=	_JC_JLONG(0x993d0c4b6fff7e75),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract polyglot.types.PrimitiveType Int()
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$Int$dc8a8335063a64fa[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_TypeSystem$method_info$Int$dc8a8335063a64fa = {
	.name=			"Int",
	.signature=		"()Lpolyglot/types/PrimitiveType;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.return_type=		&_jc_polyglot_types_PrimitiveType$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$Int$dc8a8335063a64fa,
	.signature_hash=	_JC_JLONG(0xdc8a8335063a64fa),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract polyglot.types.Flags Interface()
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$Interface$d1d258d4e63ede53[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_TypeSystem$method_info$Interface$d1d258d4e63ede53 = {
	.name=			"Interface",
	.signature=		"()Lpolyglot/types/Flags;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.return_type=		&_jc_polyglot_types_Flags$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$Interface$d1d258d4e63ede53,
	.signature_hash=	_JC_JLONG(0xd1d258d4e63ede53),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract polyglot.types.PrimitiveType Long()
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$Long$3f9115aad1b16e63[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_TypeSystem$method_info$Long$3f9115aad1b16e63 = {
	.name=			"Long",
	.signature=		"()Lpolyglot/types/PrimitiveType;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.return_type=		&_jc_polyglot_types_PrimitiveType$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$Long$3f9115aad1b16e63,
	.signature_hash=	_JC_JLONG(0x3f9115aad1b16e63),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract polyglot.types.Flags Native()
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$Native$d03574bca3c26117[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_TypeSystem$method_info$Native$d03574bca3c26117 = {
	.name=			"Native",
	.signature=		"()Lpolyglot/types/Flags;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.return_type=		&_jc_polyglot_types_Flags$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$Native$d03574bca3c26117,
	.signature_hash=	_JC_JLONG(0xd03574bca3c26117),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract polyglot.types.Flags NoFlags()
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$NoFlags$5bce1b106ba9c92d[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_TypeSystem$method_info$NoFlags$5bce1b106ba9c92d = {
	.name=			"NoFlags",
	.signature=		"()Lpolyglot/types/Flags;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.return_type=		&_jc_polyglot_types_Flags$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$NoFlags$5bce1b106ba9c92d,
	.signature_hash=	_JC_JLONG(0x5bce1b106ba9c92d),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract polyglot.types.NullType Null()
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$Null$85a398d001b1dd37[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_TypeSystem$method_info$Null$85a398d001b1dd37 = {
	.name=			"Null",
	.signature=		"()Lpolyglot/types/NullType;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.return_type=		&_jc_polyglot_types_NullType$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$Null$85a398d001b1dd37,
	.signature_hash=	_JC_JLONG(0x85a398d001b1dd37),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract polyglot.types.ClassType NullPointerException()
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$NullPointerException$e0d8e3e38ae6c92e[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_TypeSystem$method_info$NullPointerException$e0d8e3e38ae6c92e = {
	.name=			"NullPointerException",
	.signature=		"()Lpolyglot/types/ClassType;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.return_type=		&_jc_polyglot_types_ClassType$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$NullPointerException$e0d8e3e38ae6c92e,
	.signature_hash=	_JC_JLONG(0xe0d8e3e38ae6c92e),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract polyglot.types.ClassType Object()
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$Object$8b7e0d7b96abda0e[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_TypeSystem$method_info$Object$8b7e0d7b96abda0e = {
	.name=			"Object",
	.signature=		"()Lpolyglot/types/ClassType;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.return_type=		&_jc_polyglot_types_ClassType$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$Object$8b7e0d7b96abda0e,
	.signature_hash=	_JC_JLONG(0x8b7e0d7b96abda0e),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract polyglot.types.ClassType OutOfBoundsException()
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$OutOfBoundsException$e12abf8d2553b892[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_TypeSystem$method_info$OutOfBoundsException$e12abf8d2553b892 = {
	.name=			"OutOfBoundsException",
	.signature=		"()Lpolyglot/types/ClassType;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.return_type=		&_jc_polyglot_types_ClassType$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$OutOfBoundsException$e12abf8d2553b892,
	.signature_hash=	_JC_JLONG(0xe12abf8d2553b892),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract polyglot.types.Flags Private()
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$Private$0f04beb4fadb389b[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_TypeSystem$method_info$Private$0f04beb4fadb389b = {
	.name=			"Private",
	.signature=		"()Lpolyglot/types/Flags;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.return_type=		&_jc_polyglot_types_Flags$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$Private$0f04beb4fadb389b,
	.signature_hash=	_JC_JLONG(0xf04beb4fadb389b),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract polyglot.types.Flags Protected()
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$Protected$cc85b80cb44fc771[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_TypeSystem$method_info$Protected$cc85b80cb44fc771 = {
	.name=			"Protected",
	.signature=		"()Lpolyglot/types/Flags;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.return_type=		&_jc_polyglot_types_Flags$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$Protected$cc85b80cb44fc771,
	.signature_hash=	_JC_JLONG(0xcc85b80cb44fc771),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract polyglot.types.Flags Public()
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$Public$6e2fa630de91f274[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_TypeSystem$method_info$Public$6e2fa630de91f274 = {
	.name=			"Public",
	.signature=		"()Lpolyglot/types/Flags;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.return_type=		&_jc_polyglot_types_Flags$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$Public$6e2fa630de91f274,
	.signature_hash=	_JC_JLONG(0x6e2fa630de91f274),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract polyglot.types.ClassType RuntimeException()
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$RuntimeException$1a907c556c157cbb[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_TypeSystem$method_info$RuntimeException$1a907c556c157cbb = {
	.name=			"RuntimeException",
	.signature=		"()Lpolyglot/types/ClassType;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.return_type=		&_jc_polyglot_types_ClassType$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$RuntimeException$1a907c556c157cbb,
	.signature_hash=	_JC_JLONG(0x1a907c556c157cbb),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract polyglot.types.ClassType Serializable()
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$Serializable$34e9f2c2ef0c2dc3[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_TypeSystem$method_info$Serializable$34e9f2c2ef0c2dc3 = {
	.name=			"Serializable",
	.signature=		"()Lpolyglot/types/ClassType;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.return_type=		&_jc_polyglot_types_ClassType$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$Serializable$34e9f2c2ef0c2dc3,
	.signature_hash=	_JC_JLONG(0x34e9f2c2ef0c2dc3),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract polyglot.types.PrimitiveType Short()
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$Short$c523e949e25678d7[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_TypeSystem$method_info$Short$c523e949e25678d7 = {
	.name=			"Short",
	.signature=		"()Lpolyglot/types/PrimitiveType;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.return_type=		&_jc_polyglot_types_PrimitiveType$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$Short$c523e949e25678d7,
	.signature_hash=	_JC_JLONG(0xc523e949e25678d7),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract polyglot.types.Flags Static()
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$Static$89d0513bab2bd4ef[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_TypeSystem$method_info$Static$89d0513bab2bd4ef = {
	.name=			"Static",
	.signature=		"()Lpolyglot/types/Flags;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.return_type=		&_jc_polyglot_types_Flags$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$Static$89d0513bab2bd4ef,
	.signature_hash=	_JC_JLONG(0x89d0513bab2bd4ef),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract polyglot.types.Flags StrictFP()
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$StrictFP$a4f5b34502a86c37[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_TypeSystem$method_info$StrictFP$a4f5b34502a86c37 = {
	.name=			"StrictFP",
	.signature=		"()Lpolyglot/types/Flags;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.return_type=		&_jc_polyglot_types_Flags$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$StrictFP$a4f5b34502a86c37,
	.signature_hash=	_JC_JLONG(0xa4f5b34502a86c37),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract polyglot.types.ClassType String()
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$String$8051b0f541e1a5b2[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_TypeSystem$method_info$String$8051b0f541e1a5b2 = {
	.name=			"String",
	.signature=		"()Lpolyglot/types/ClassType;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.return_type=		&_jc_polyglot_types_ClassType$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$String$8051b0f541e1a5b2,
	.signature_hash=	_JC_JLONG(0x8051b0f541e1a5b2),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract polyglot.types.Flags Synchronized()
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$Synchronized$4af0343d7561610b[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_TypeSystem$method_info$Synchronized$4af0343d7561610b = {
	.name=			"Synchronized",
	.signature=		"()Lpolyglot/types/Flags;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.return_type=		&_jc_polyglot_types_Flags$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$Synchronized$4af0343d7561610b,
	.signature_hash=	_JC_JLONG(0x4af0343d7561610b),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract polyglot.types.ClassType Throwable()
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$Throwable$ae911753a19c6860[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_TypeSystem$method_info$Throwable$ae911753a19c6860 = {
	.name=			"Throwable",
	.signature=		"()Lpolyglot/types/ClassType;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.return_type=		&_jc_polyglot_types_ClassType$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$Throwable$ae911753a19c6860,
	.signature_hash=	_JC_JLONG(0xae911753a19c6860),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract polyglot.types.Flags Transient()
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$Transient$f7e6bc0f49a075b1[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_TypeSystem$method_info$Transient$f7e6bc0f49a075b1 = {
	.name=			"Transient",
	.signature=		"()Lpolyglot/types/Flags;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.return_type=		&_jc_polyglot_types_Flags$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$Transient$f7e6bc0f49a075b1,
	.signature_hash=	_JC_JLONG(0xf7e6bc0f49a075b1),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract polyglot.types.PrimitiveType Void()
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$Void$7ba97b6f0a7b5de6[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_TypeSystem$method_info$Void$7ba97b6f0a7b5de6 = {
	.name=			"Void",
	.signature=		"()Lpolyglot/types/PrimitiveType;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.return_type=		&_jc_polyglot_types_PrimitiveType$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$Void$7ba97b6f0a7b5de6,
	.signature_hash=	_JC_JLONG(0x7ba97b6f0a7b5de6),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract polyglot.types.Flags Volatile()
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$Volatile$6082c870acd57f5c[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_TypeSystem$method_info$Volatile$6082c870acd57f5c = {
	.name=			"Volatile",
	.signature=		"()Lpolyglot/types/Flags;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.return_type=		&_jc_polyglot_types_Flags$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$Volatile$6082c870acd57f5c,
	.signature_hash=	_JC_JLONG(0x6082c870acd57f5c),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract polyglot.types.ArrayType arrayOf(polyglot.types.Type)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$arrayOf$d0330f9cad7d3f34[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$arrayOf$d0330f9cad7d3f34[] = {
	&_jc_polyglot_types_Type$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$arrayOf$d0330f9cad7d3f34 = {
	.name=			"arrayOf",
	.signature=		"(Lpolyglot/types/Type;)Lpolyglot/types/ArrayType;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$arrayOf$d0330f9cad7d3f34,
	.return_type=		&_jc_polyglot_types_ArrayType$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$arrayOf$d0330f9cad7d3f34,
	.signature_hash=	_JC_JLONG(0xd0330f9cad7d3f34),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
};

//
// public abstract polyglot.types.ArrayType arrayOf(polyglot.types.Type, int)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$arrayOf$bddcfdf10cebaed0[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$arrayOf$bddcfdf10cebaed0[] = {
	&_jc_polyglot_types_Type$type,
	&_jc_int$prim$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$arrayOf$bddcfdf10cebaed0 = {
	.name=			"arrayOf",
	.signature=		"(Lpolyglot/types/Type;I)Lpolyglot/types/ArrayType;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$arrayOf$bddcfdf10cebaed0,
	.return_type=		&_jc_polyglot_types_ArrayType$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$arrayOf$bddcfdf10cebaed0,
	.signature_hash=	_JC_JLONG(0xbddcfdf10cebaed0),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	2,
};

//
// public abstract polyglot.types.ArrayType arrayOf(polyglot.util.Position, polyglot.types.Type)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$arrayOf$e447f59ddb1c2994[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$arrayOf$e447f59ddb1c2994[] = {
	&_jc_polyglot_util_Position$type,
	&_jc_polyglot_types_Type$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$arrayOf$e447f59ddb1c2994 = {
	.name=			"arrayOf",
	.signature=		"(Lpolyglot/util/Position;Lpolyglot/types/Type;)Lpolyglot/types/ArrayType;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$arrayOf$e447f59ddb1c2994,
	.return_type=		&_jc_polyglot_types_ArrayType$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$arrayOf$e447f59ddb1c2994,
	.signature_hash=	_JC_JLONG(0xe447f59ddb1c2994),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	2,
};

//
// public abstract polyglot.types.ArrayType arrayOf(polyglot.util.Position, polyglot.types.Type, int)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$arrayOf$3540da06ad9084cd[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$arrayOf$3540da06ad9084cd[] = {
	&_jc_polyglot_util_Position$type,
	&_jc_polyglot_types_Type$type,
	&_jc_int$prim$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$arrayOf$3540da06ad9084cd = {
	.name=			"arrayOf",
	.signature=		"(Lpolyglot/util/Position;Lpolyglot/types/Type;I)Lpolyglot/types/ArrayType;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$arrayOf$3540da06ad9084cd,
	.return_type=		&_jc_polyglot_types_ArrayType$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$arrayOf$3540da06ad9084cd,
	.signature_hash=	_JC_JLONG(0x3540da06ad9084cd),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	3,
};

//
// public abstract boolean callValid(polyglot.types.ProcedureInstance, java.util.List)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$callValid$de9a9752966ad9e4[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$callValid$de9a9752966ad9e4[] = {
	&_jc_polyglot_types_ProcedureInstance$type,
	&_jc_java_util_List$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$callValid$de9a9752966ad9e4 = {
	.name=			"callValid",
	.signature=		"(Lpolyglot/types/ProcedureInstance;Ljava/util/List;)Z",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$callValid$de9a9752966ad9e4,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$callValid$de9a9752966ad9e4,
	.signature_hash=	_JC_JLONG(0xde9a9752966ad9e4),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	2,
};

//
// public abstract boolean canCoerceToString(polyglot.types.Type, polyglot.types.Context)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$canCoerceToString$beefd6098a6b6703[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$canCoerceToString$beefd6098a6b6703[] = {
	&_jc_polyglot_types_Type$type,
	&_jc_polyglot_types_Context$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$canCoerceToString$beefd6098a6b6703 = {
	.name=			"canCoerceToString",
	.signature=		"(Lpolyglot/types/Type;Lpolyglot/types/Context;)Z",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$canCoerceToString$beefd6098a6b6703,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$canCoerceToString$beefd6098a6b6703,
	.signature_hash=	_JC_JLONG(0xbeefd6098a6b6703),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	2,
};

//
// public abstract boolean canOverride(polyglot.types.MethodInstance, polyglot.types.MethodInstance)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$canOverride$299577304c1e1440[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$canOverride$299577304c1e1440[] = {
	&_jc_polyglot_types_MethodInstance$type,
	&_jc_polyglot_types_MethodInstance$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$canOverride$299577304c1e1440 = {
	.name=			"canOverride",
	.signature=		"(Lpolyglot/types/MethodInstance;Lpolyglot/types/MethodInstance;)Z",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$canOverride$299577304c1e1440,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$canOverride$299577304c1e1440,
	.signature_hash=	_JC_JLONG(0x299577304c1e1440),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	2,
};

//
// public abstract void checkAccessFlags(polyglot.types.Flags) throws polyglot.types.SemanticException
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$checkAccessFlags$0085d5a8bdfa8c68[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_types_TypeSystem$exceptions$checkAccessFlags$0085d5a8bdfa8c68[] = {
	&_jc_polyglot_types_SemanticException$type
};

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$checkAccessFlags$0085d5a8bdfa8c68[] = {
	&_jc_polyglot_types_Flags$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$checkAccessFlags$0085d5a8bdfa8c68 = {
	.name=			"checkAccessFlags",
	.signature=		"(Lpolyglot/types/Flags;)V",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$checkAccessFlags$0085d5a8bdfa8c68,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$checkAccessFlags$0085d5a8bdfa8c68,
	.signature_hash=	_JC_JLONG(0x85d5a8bdfa8c68),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_types_TypeSystem$exceptions$checkAccessFlags$0085d5a8bdfa8c68,
};

//
// public abstract void checkClassConformance(polyglot.types.ClassType) throws polyglot.types.SemanticException
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$checkClassConformance$0e954ff57832dbe3[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_types_TypeSystem$exceptions$checkClassConformance$0e954ff57832dbe3[] = {
	&_jc_polyglot_types_SemanticException$type
};

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$checkClassConformance$0e954ff57832dbe3[] = {
	&_jc_polyglot_types_ClassType$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$checkClassConformance$0e954ff57832dbe3 = {
	.name=			"checkClassConformance",
	.signature=		"(Lpolyglot/types/ClassType;)V",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$checkClassConformance$0e954ff57832dbe3,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$checkClassConformance$0e954ff57832dbe3,
	.signature_hash=	_JC_JLONG(0xe954ff57832dbe3),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_types_TypeSystem$exceptions$checkClassConformance$0e954ff57832dbe3,
};

//
// public abstract void checkConstructorFlags(polyglot.types.Flags) throws polyglot.types.SemanticException
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$checkConstructorFlags$aaa4492f9c8743e3[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_types_TypeSystem$exceptions$checkConstructorFlags$aaa4492f9c8743e3[] = {
	&_jc_polyglot_types_SemanticException$type
};

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$checkConstructorFlags$aaa4492f9c8743e3[] = {
	&_jc_polyglot_types_Flags$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$checkConstructorFlags$aaa4492f9c8743e3 = {
	.name=			"checkConstructorFlags",
	.signature=		"(Lpolyglot/types/Flags;)V",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$checkConstructorFlags$aaa4492f9c8743e3,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$checkConstructorFlags$aaa4492f9c8743e3,
	.signature_hash=	_JC_JLONG(0xaaa4492f9c8743e3),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_types_TypeSystem$exceptions$checkConstructorFlags$aaa4492f9c8743e3,
};

//
// public abstract void checkCycles(polyglot.types.ReferenceType) throws polyglot.types.SemanticException
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$checkCycles$0f94998c861cf640[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_types_TypeSystem$exceptions$checkCycles$0f94998c861cf640[] = {
	&_jc_polyglot_types_SemanticException$type
};

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$checkCycles$0f94998c861cf640[] = {
	&_jc_polyglot_types_ReferenceType$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$checkCycles$0f94998c861cf640 = {
	.name=			"checkCycles",
	.signature=		"(Lpolyglot/types/ReferenceType;)V",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$checkCycles$0f94998c861cf640,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$checkCycles$0f94998c861cf640,
	.signature_hash=	_JC_JLONG(0xf94998c861cf640),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_types_TypeSystem$exceptions$checkCycles$0f94998c861cf640,
};

//
// public abstract void checkFieldFlags(polyglot.types.Flags) throws polyglot.types.SemanticException
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$checkFieldFlags$2ffd6a70995bb6b2[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_types_TypeSystem$exceptions$checkFieldFlags$2ffd6a70995bb6b2[] = {
	&_jc_polyglot_types_SemanticException$type
};

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$checkFieldFlags$2ffd6a70995bb6b2[] = {
	&_jc_polyglot_types_Flags$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$checkFieldFlags$2ffd6a70995bb6b2 = {
	.name=			"checkFieldFlags",
	.signature=		"(Lpolyglot/types/Flags;)V",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$checkFieldFlags$2ffd6a70995bb6b2,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$checkFieldFlags$2ffd6a70995bb6b2,
	.signature_hash=	_JC_JLONG(0x2ffd6a70995bb6b2),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_types_TypeSystem$exceptions$checkFieldFlags$2ffd6a70995bb6b2,
};

//
// public abstract void checkInitializerFlags(polyglot.types.Flags) throws polyglot.types.SemanticException
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$checkInitializerFlags$253c2f981ef370fa[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_types_TypeSystem$exceptions$checkInitializerFlags$253c2f981ef370fa[] = {
	&_jc_polyglot_types_SemanticException$type
};

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$checkInitializerFlags$253c2f981ef370fa[] = {
	&_jc_polyglot_types_Flags$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$checkInitializerFlags$253c2f981ef370fa = {
	.name=			"checkInitializerFlags",
	.signature=		"(Lpolyglot/types/Flags;)V",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$checkInitializerFlags$253c2f981ef370fa,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$checkInitializerFlags$253c2f981ef370fa,
	.signature_hash=	_JC_JLONG(0x253c2f981ef370fa),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_types_TypeSystem$exceptions$checkInitializerFlags$253c2f981ef370fa,
};

//
// public abstract void checkLocalClassFlags(polyglot.types.Flags) throws polyglot.types.SemanticException
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$checkLocalClassFlags$8cdf364732f77b69[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_types_TypeSystem$exceptions$checkLocalClassFlags$8cdf364732f77b69[] = {
	&_jc_polyglot_types_SemanticException$type
};

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$checkLocalClassFlags$8cdf364732f77b69[] = {
	&_jc_polyglot_types_Flags$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$checkLocalClassFlags$8cdf364732f77b69 = {
	.name=			"checkLocalClassFlags",
	.signature=		"(Lpolyglot/types/Flags;)V",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$checkLocalClassFlags$8cdf364732f77b69,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$checkLocalClassFlags$8cdf364732f77b69,
	.signature_hash=	_JC_JLONG(0x8cdf364732f77b69),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_types_TypeSystem$exceptions$checkLocalClassFlags$8cdf364732f77b69,
};

//
// public abstract void checkLocalFlags(polyglot.types.Flags) throws polyglot.types.SemanticException
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$checkLocalFlags$13d5f051e59c2ac4[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_types_TypeSystem$exceptions$checkLocalFlags$13d5f051e59c2ac4[] = {
	&_jc_polyglot_types_SemanticException$type
};

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$checkLocalFlags$13d5f051e59c2ac4[] = {
	&_jc_polyglot_types_Flags$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$checkLocalFlags$13d5f051e59c2ac4 = {
	.name=			"checkLocalFlags",
	.signature=		"(Lpolyglot/types/Flags;)V",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$checkLocalFlags$13d5f051e59c2ac4,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$checkLocalFlags$13d5f051e59c2ac4,
	.signature_hash=	_JC_JLONG(0x13d5f051e59c2ac4),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_types_TypeSystem$exceptions$checkLocalFlags$13d5f051e59c2ac4,
};

//
// public abstract void checkMemberClassFlags(polyglot.types.Flags) throws polyglot.types.SemanticException
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$checkMemberClassFlags$dda2772c9e4c01a5[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_types_TypeSystem$exceptions$checkMemberClassFlags$dda2772c9e4c01a5[] = {
	&_jc_polyglot_types_SemanticException$type
};

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$checkMemberClassFlags$dda2772c9e4c01a5[] = {
	&_jc_polyglot_types_Flags$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$checkMemberClassFlags$dda2772c9e4c01a5 = {
	.name=			"checkMemberClassFlags",
	.signature=		"(Lpolyglot/types/Flags;)V",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$checkMemberClassFlags$dda2772c9e4c01a5,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$checkMemberClassFlags$dda2772c9e4c01a5,
	.signature_hash=	_JC_JLONG(0xdda2772c9e4c01a5),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_types_TypeSystem$exceptions$checkMemberClassFlags$dda2772c9e4c01a5,
};

//
// public abstract void checkMethodFlags(polyglot.types.Flags) throws polyglot.types.SemanticException
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$checkMethodFlags$ddd95058711ce2fe[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_types_TypeSystem$exceptions$checkMethodFlags$ddd95058711ce2fe[] = {
	&_jc_polyglot_types_SemanticException$type
};

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$checkMethodFlags$ddd95058711ce2fe[] = {
	&_jc_polyglot_types_Flags$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$checkMethodFlags$ddd95058711ce2fe = {
	.name=			"checkMethodFlags",
	.signature=		"(Lpolyglot/types/Flags;)V",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$checkMethodFlags$ddd95058711ce2fe,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$checkMethodFlags$ddd95058711ce2fe,
	.signature_hash=	_JC_JLONG(0xddd95058711ce2fe),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_types_TypeSystem$exceptions$checkMethodFlags$ddd95058711ce2fe,
};

//
// public abstract void checkOverride(polyglot.types.MethodInstance, polyglot.types.MethodInstance) throws polyglot.types.SemanticException
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$checkOverride$0eb36c1e19564da9[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_types_TypeSystem$exceptions$checkOverride$0eb36c1e19564da9[] = {
	&_jc_polyglot_types_SemanticException$type
};

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$checkOverride$0eb36c1e19564da9[] = {
	&_jc_polyglot_types_MethodInstance$type,
	&_jc_polyglot_types_MethodInstance$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$checkOverride$0eb36c1e19564da9 = {
	.name=			"checkOverride",
	.signature=		"(Lpolyglot/types/MethodInstance;Lpolyglot/types/MethodInstance;)V",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$checkOverride$0eb36c1e19564da9,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$checkOverride$0eb36c1e19564da9,
	.signature_hash=	_JC_JLONG(0xeb36c1e19564da9),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_types_TypeSystem$exceptions$checkOverride$0eb36c1e19564da9,
};

//
// public abstract void checkTopLevelClassFlags(polyglot.types.Flags) throws polyglot.types.SemanticException
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$checkTopLevelClassFlags$b0de1bf09031bfc3[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_types_TypeSystem$exceptions$checkTopLevelClassFlags$b0de1bf09031bfc3[] = {
	&_jc_polyglot_types_SemanticException$type
};

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$checkTopLevelClassFlags$b0de1bf09031bfc3[] = {
	&_jc_polyglot_types_Flags$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$checkTopLevelClassFlags$b0de1bf09031bfc3 = {
	.name=			"checkTopLevelClassFlags",
	.signature=		"(Lpolyglot/types/Flags;)V",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$checkTopLevelClassFlags$b0de1bf09031bfc3,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$checkTopLevelClassFlags$b0de1bf09031bfc3,
	.signature_hash=	_JC_JLONG(0xb0de1bf09031bfc3),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_types_TypeSystem$exceptions$checkTopLevelClassFlags$b0de1bf09031bfc3,
};

//
// public abstract polyglot.types.Resolver classContextResolver(polyglot.types.ClassType)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$classContextResolver$cd4ffbc34624d5db[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$classContextResolver$cd4ffbc34624d5db[] = {
	&_jc_polyglot_types_ClassType$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$classContextResolver$cd4ffbc34624d5db = {
	.name=			"classContextResolver",
	.signature=		"(Lpolyglot/types/ClassType;)Lpolyglot/types/Resolver;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$classContextResolver$cd4ffbc34624d5db,
	.return_type=		&_jc_polyglot_types_Resolver$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$classContextResolver$cd4ffbc34624d5db,
	.signature_hash=	_JC_JLONG(0xcd4ffbc34624d5db),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
};

//
// public abstract polyglot.types.ConstructorInstance constructorInstance(polyglot.util.Position, polyglot.types.ClassType, polyglot.types.Flags, java.util.List, java.util.List)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$constructorInstance$7684c1b47d4498f7[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$constructorInstance$7684c1b47d4498f7[] = {
	&_jc_polyglot_util_Position$type,
	&_jc_polyglot_types_ClassType$type,
	&_jc_polyglot_types_Flags$type,
	&_jc_java_util_List$type,
	&_jc_java_util_List$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$constructorInstance$7684c1b47d4498f7 = {
	.name=			"constructorInstance",
	.signature=		"(Lpolyglot/util/Position;Lpolyglot/types/ClassType;Lpolyglot/types/Flags;Ljava/util/List;Ljava/util/List;)Lpolyglot/types/ConstructorInstance;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$constructorInstance$7684c1b47d4498f7,
	.return_type=		&_jc_polyglot_types_ConstructorInstance$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$constructorInstance$7684c1b47d4498f7,
	.signature_hash=	_JC_JLONG(0x7684c1b47d4498f7),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	5,
};

//
// public abstract polyglot.types.ParsedClassType createClassType()
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$createClassType$d3c10e33a2ff34fc[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_TypeSystem$method_info$createClassType$d3c10e33a2ff34fc = {
	.name=			"createClassType",
	.signature=		"()Lpolyglot/types/ParsedClassType;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.return_type=		&_jc_polyglot_types_ParsedClassType$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$createClassType$d3c10e33a2ff34fc,
	.signature_hash=	_JC_JLONG(0xd3c10e33a2ff34fc),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract polyglot.types.ParsedClassType createClassType(polyglot.frontend.Source)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$createClassType$8e020e197fa9d6f9[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$createClassType$8e020e197fa9d6f9[] = {
	&_jc_polyglot_frontend_Source$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$createClassType$8e020e197fa9d6f9 = {
	.name=			"createClassType",
	.signature=		"(Lpolyglot/frontend/Source;)Lpolyglot/types/ParsedClassType;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$createClassType$8e020e197fa9d6f9,
	.return_type=		&_jc_polyglot_types_ParsedClassType$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$createClassType$8e020e197fa9d6f9,
	.signature_hash=	_JC_JLONG(0x8e020e197fa9d6f9),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
};

//
// public abstract polyglot.types.ParsedClassType createClassType(polyglot.types.LazyClassInitializer)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$createClassType$f5da6f1b6db11064[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$createClassType$f5da6f1b6db11064[] = {
	&_jc_polyglot_types_LazyClassInitializer$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$createClassType$f5da6f1b6db11064 = {
	.name=			"createClassType",
	.signature=		"(Lpolyglot/types/LazyClassInitializer;)Lpolyglot/types/ParsedClassType;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$createClassType$f5da6f1b6db11064,
	.return_type=		&_jc_polyglot_types_ParsedClassType$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$createClassType$f5da6f1b6db11064,
	.signature_hash=	_JC_JLONG(0xf5da6f1b6db11064),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
};

//
// public abstract polyglot.types.ParsedClassType createClassType(polyglot.types.LazyClassInitializer, polyglot.frontend.Source)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$createClassType$dbac273b5af99738[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$createClassType$dbac273b5af99738[] = {
	&_jc_polyglot_types_LazyClassInitializer$type,
	&_jc_polyglot_frontend_Source$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$createClassType$dbac273b5af99738 = {
	.name=			"createClassType",
	.signature=		"(Lpolyglot/types/LazyClassInitializer;Lpolyglot/frontend/Source;)Lpolyglot/types/ParsedClassType;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$createClassType$dbac273b5af99738,
	.return_type=		&_jc_polyglot_types_ParsedClassType$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$createClassType$dbac273b5af99738,
	.signature_hash=	_JC_JLONG(0xdbac273b5af99738),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	2,
};

//
// public abstract polyglot.types.Context createContext()
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$createContext$a533e01ab4704d58[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_TypeSystem$method_info$createContext$a533e01ab4704d58 = {
	.name=			"createContext",
	.signature=		"()Lpolyglot/types/Context;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.return_type=		&_jc_polyglot_types_Context$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$createContext$a533e01ab4704d58,
	.signature_hash=	_JC_JLONG(0xa533e01ab4704d58),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract polyglot.types.Flags createNewFlag(java.lang.String, polyglot.types.Flags)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$createNewFlag$b192005dcbb768ef[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$createNewFlag$b192005dcbb768ef[] = {
	&_jc_java_lang_String$type,
	&_jc_polyglot_types_Flags$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$createNewFlag$b192005dcbb768ef = {
	.name=			"createNewFlag",
	.signature=		"(Ljava/lang/String;Lpolyglot/types/Flags;)Lpolyglot/types/Flags;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$createNewFlag$b192005dcbb768ef,
	.return_type=		&_jc_polyglot_types_Flags$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$createNewFlag$b192005dcbb768ef,
	.signature_hash=	_JC_JLONG(0xb192005dcbb768ef),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	2,
};

//
// public abstract polyglot.types.LazyClassInitializer defaultClassInitializer()
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$defaultClassInitializer$fe905bd408f21160[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_TypeSystem$method_info$defaultClassInitializer$fe905bd408f21160 = {
	.name=			"defaultClassInitializer",
	.signature=		"()Lpolyglot/types/LazyClassInitializer;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.return_type=		&_jc_polyglot_types_LazyClassInitializer$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$defaultClassInitializer$fe905bd408f21160,
	.signature_hash=	_JC_JLONG(0xfe905bd408f21160),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract polyglot.types.ConstructorInstance defaultConstructor(polyglot.util.Position, polyglot.types.ClassType)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$defaultConstructor$3dfe98e49b83079a[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$defaultConstructor$3dfe98e49b83079a[] = {
	&_jc_polyglot_util_Position$type,
	&_jc_polyglot_types_ClassType$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$defaultConstructor$3dfe98e49b83079a = {
	.name=			"defaultConstructor",
	.signature=		"(Lpolyglot/util/Position;Lpolyglot/types/ClassType;)Lpolyglot/types/ConstructorInstance;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$defaultConstructor$3dfe98e49b83079a,
	.return_type=		&_jc_polyglot_types_ConstructorInstance$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$defaultConstructor$3dfe98e49b83079a,
	.signature_hash=	_JC_JLONG(0x3dfe98e49b83079a),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	2,
};

//
// public abstract java.util.List defaultPackageImports()
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$defaultPackageImports$e5c552b6d8e94472[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_TypeSystem$method_info$defaultPackageImports$e5c552b6d8e94472 = {
	.name=			"defaultPackageImports",
	.signature=		"()Ljava/util/List;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.return_type=		&_jc_java_util_List$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$defaultPackageImports$e5c552b6d8e94472,
	.signature_hash=	_JC_JLONG(0xe5c552b6d8e94472),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract boolean descendsFrom(polyglot.types.Type, polyglot.types.Type)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$descendsFrom$cefafaeacf05eaec[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$descendsFrom$cefafaeacf05eaec[] = {
	&_jc_polyglot_types_Type$type,
	&_jc_polyglot_types_Type$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$descendsFrom$cefafaeacf05eaec = {
	.name=			"descendsFrom",
	.signature=		"(Lpolyglot/types/Type;Lpolyglot/types/Type;)Z",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$descendsFrom$cefafaeacf05eaec,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$descendsFrom$cefafaeacf05eaec,
	.signature_hash=	_JC_JLONG(0xcefafaeacf05eaec),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	2,
};

//
// public abstract boolean equals(polyglot.types.TypeObject, polyglot.types.TypeObject)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$equals$79f5e97cb0290662[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$equals$79f5e97cb0290662[] = {
	&_jc_polyglot_types_TypeObject$type,
	&_jc_polyglot_types_TypeObject$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$equals$79f5e97cb0290662 = {
	.name=			"equals",
	.signature=		"(Lpolyglot/types/TypeObject;Lpolyglot/types/TypeObject;)Z",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$equals$79f5e97cb0290662,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$equals$79f5e97cb0290662,
	.signature_hash=	_JC_JLONG(0x79f5e97cb0290662),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	2,
};

//
// public abstract polyglot.types.FieldInstance fieldInstance(polyglot.util.Position, polyglot.types.ReferenceType, polyglot.types.Flags, polyglot.types.Type, java.lang.String)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$fieldInstance$1d2f4914e8b7c9f6[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$fieldInstance$1d2f4914e8b7c9f6[] = {
	&_jc_polyglot_util_Position$type,
	&_jc_polyglot_types_ReferenceType$type,
	&_jc_polyglot_types_Flags$type,
	&_jc_polyglot_types_Type$type,
	&_jc_java_lang_String$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$fieldInstance$1d2f4914e8b7c9f6 = {
	.name=			"fieldInstance",
	.signature=		"(Lpolyglot/util/Position;Lpolyglot/types/ReferenceType;Lpolyglot/types/Flags;Lpolyglot/types/Type;Ljava/lang/String;)Lpolyglot/types/FieldInstance;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$fieldInstance$1d2f4914e8b7c9f6,
	.return_type=		&_jc_polyglot_types_FieldInstance$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$fieldInstance$1d2f4914e8b7c9f6,
	.signature_hash=	_JC_JLONG(0x1d2f4914e8b7c9f6),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	5,
};

//
// public abstract polyglot.types.ConstructorInstance findConstructor(polyglot.types.ClassType, java.util.List, polyglot.types.Context) throws polyglot.types.SemanticException
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$findConstructor$498f90825a815cb3[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_TypeSystem$exceptions$findConstructor$498f90825a815cb3[] = {
	&_jc_polyglot_types_SemanticException$type
};

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$findConstructor$498f90825a815cb3[] = {
	&_jc_polyglot_types_ClassType$type,
	&_jc_java_util_List$type,
	&_jc_polyglot_types_Context$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$findConstructor$498f90825a815cb3 = {
	.name=			"findConstructor",
	.signature=		"(Lpolyglot/types/ClassType;Ljava/util/List;Lpolyglot/types/Context;)Lpolyglot/types/ConstructorInstance;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$findConstructor$498f90825a815cb3,
	.return_type=		&_jc_polyglot_types_ConstructorInstance$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$findConstructor$498f90825a815cb3,
	.signature_hash=	_JC_JLONG(0x498f90825a815cb3),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	3,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_types_TypeSystem$exceptions$findConstructor$498f90825a815cb3,
};

//
// public abstract polyglot.types.FieldInstance findField(polyglot.types.ReferenceType, java.lang.String) throws polyglot.types.SemanticException
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$findField$c60eaca9cacff8b0[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_TypeSystem$exceptions$findField$c60eaca9cacff8b0[] = {
	&_jc_polyglot_types_SemanticException$type
};

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$findField$c60eaca9cacff8b0[] = {
	&_jc_polyglot_types_ReferenceType$type,
	&_jc_java_lang_String$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$findField$c60eaca9cacff8b0 = {
	.name=			"findField",
	.signature=		"(Lpolyglot/types/ReferenceType;Ljava/lang/String;)Lpolyglot/types/FieldInstance;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$findField$c60eaca9cacff8b0,
	.return_type=		&_jc_polyglot_types_FieldInstance$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$findField$c60eaca9cacff8b0,
	.signature_hash=	_JC_JLONG(0xc60eaca9cacff8b0),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_types_TypeSystem$exceptions$findField$c60eaca9cacff8b0,
};

//
// public abstract polyglot.types.FieldInstance findField(polyglot.types.ReferenceType, java.lang.String, polyglot.types.Context) throws polyglot.types.SemanticException
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$findField$5589def512e4cb79[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_TypeSystem$exceptions$findField$5589def512e4cb79[] = {
	&_jc_polyglot_types_SemanticException$type
};

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$findField$5589def512e4cb79[] = {
	&_jc_polyglot_types_ReferenceType$type,
	&_jc_java_lang_String$type,
	&_jc_polyglot_types_Context$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$findField$5589def512e4cb79 = {
	.name=			"findField",
	.signature=		"(Lpolyglot/types/ReferenceType;Ljava/lang/String;Lpolyglot/types/Context;)Lpolyglot/types/FieldInstance;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$findField$5589def512e4cb79,
	.return_type=		&_jc_polyglot_types_FieldInstance$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$findField$5589def512e4cb79,
	.signature_hash=	_JC_JLONG(0x5589def512e4cb79),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	3,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_types_TypeSystem$exceptions$findField$5589def512e4cb79,
};

//
// public abstract polyglot.types.ClassType findMemberClass(polyglot.types.ClassType, java.lang.String) throws polyglot.types.SemanticException
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$findMemberClass$dc3b01d44352b553[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_TypeSystem$exceptions$findMemberClass$dc3b01d44352b553[] = {
	&_jc_polyglot_types_SemanticException$type
};

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$findMemberClass$dc3b01d44352b553[] = {
	&_jc_polyglot_types_ClassType$type,
	&_jc_java_lang_String$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$findMemberClass$dc3b01d44352b553 = {
	.name=			"findMemberClass",
	.signature=		"(Lpolyglot/types/ClassType;Ljava/lang/String;)Lpolyglot/types/ClassType;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$findMemberClass$dc3b01d44352b553,
	.return_type=		&_jc_polyglot_types_ClassType$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$findMemberClass$dc3b01d44352b553,
	.signature_hash=	_JC_JLONG(0xdc3b01d44352b553),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_types_TypeSystem$exceptions$findMemberClass$dc3b01d44352b553,
};

//
// public abstract polyglot.types.ClassType findMemberClass(polyglot.types.ClassType, java.lang.String, polyglot.types.Context) throws polyglot.types.SemanticException
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$findMemberClass$f79ea4417433867d[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_TypeSystem$exceptions$findMemberClass$f79ea4417433867d[] = {
	&_jc_polyglot_types_SemanticException$type
};

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$findMemberClass$f79ea4417433867d[] = {
	&_jc_polyglot_types_ClassType$type,
	&_jc_java_lang_String$type,
	&_jc_polyglot_types_Context$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$findMemberClass$f79ea4417433867d = {
	.name=			"findMemberClass",
	.signature=		"(Lpolyglot/types/ClassType;Ljava/lang/String;Lpolyglot/types/Context;)Lpolyglot/types/ClassType;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$findMemberClass$f79ea4417433867d,
	.return_type=		&_jc_polyglot_types_ClassType$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$findMemberClass$f79ea4417433867d,
	.signature_hash=	_JC_JLONG(0xf79ea4417433867d),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	3,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_types_TypeSystem$exceptions$findMemberClass$f79ea4417433867d,
};

//
// public abstract polyglot.types.MethodInstance findMethod(polyglot.types.ReferenceType, java.lang.String, java.util.List, polyglot.types.Context) throws polyglot.types.SemanticException
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$findMethod$4002275a6822a129[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_TypeSystem$exceptions$findMethod$4002275a6822a129[] = {
	&_jc_polyglot_types_SemanticException$type
};

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$findMethod$4002275a6822a129[] = {
	&_jc_polyglot_types_ReferenceType$type,
	&_jc_java_lang_String$type,
	&_jc_java_util_List$type,
	&_jc_polyglot_types_Context$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$findMethod$4002275a6822a129 = {
	.name=			"findMethod",
	.signature=		"(Lpolyglot/types/ReferenceType;Ljava/lang/String;Ljava/util/List;Lpolyglot/types/Context;)Lpolyglot/types/MethodInstance;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$findMethod$4002275a6822a129,
	.return_type=		&_jc_polyglot_types_MethodInstance$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$findMethod$4002275a6822a129,
	.signature_hash=	_JC_JLONG(0x4002275a6822a129),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	4,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_types_TypeSystem$exceptions$findMethod$4002275a6822a129,
};

//
// public abstract polyglot.types.Flags flagsForBits(int)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$flagsForBits$62f24019375a1a4f[] = { 
_JC_TYPE_INT, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$flagsForBits$62f24019375a1a4f[] = {
	&_jc_int$prim$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$flagsForBits$62f24019375a1a4f = {
	.name=			"flagsForBits",
	.signature=		"(I)Lpolyglot/types/Flags;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$flagsForBits$62f24019375a1a4f,
	.return_type=		&_jc_polyglot_types_Flags$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$flagsForBits$62f24019375a1a4f,
	.signature_hash=	_JC_JLONG(0x62f24019375a1a4f),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
};

//
// public abstract java.lang.String getTransformedClassName(polyglot.types.ClassType)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$getTransformedClassName$8baa8ccdbc44d970[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$getTransformedClassName$8baa8ccdbc44d970[] = {
	&_jc_polyglot_types_ClassType$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$getTransformedClassName$8baa8ccdbc44d970 = {
	.name=			"getTransformedClassName",
	.signature=		"(Lpolyglot/types/ClassType;)Ljava/lang/String;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$getTransformedClassName$8baa8ccdbc44d970,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$getTransformedClassName$8baa8ccdbc44d970,
	.signature_hash=	_JC_JLONG(0x8baa8ccdbc44d970),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
};

//
// public abstract java.util.Set getTypeEncoderRootSet(polyglot.types.Type)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$getTypeEncoderRootSet$217745370d0376f7[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$getTypeEncoderRootSet$217745370d0376f7[] = {
	&_jc_polyglot_types_Type$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$getTypeEncoderRootSet$217745370d0376f7 = {
	.name=			"getTypeEncoderRootSet",
	.signature=		"(Lpolyglot/types/Type;)Ljava/util/Set;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$getTypeEncoderRootSet$217745370d0376f7,
	.return_type=		&_jc_java_util_Set$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$getTypeEncoderRootSet$217745370d0376f7,
	.signature_hash=	_JC_JLONG(0x217745370d0376f7),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
};

//
// public abstract boolean hasEnclosingInstance(polyglot.types.ClassType, polyglot.types.ClassType)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$hasEnclosingInstance$086b90c4939d0f1e[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$hasEnclosingInstance$086b90c4939d0f1e[] = {
	&_jc_polyglot_types_ClassType$type,
	&_jc_polyglot_types_ClassType$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$hasEnclosingInstance$086b90c4939d0f1e = {
	.name=			"hasEnclosingInstance",
	.signature=		"(Lpolyglot/types/ClassType;Lpolyglot/types/ClassType;)Z",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$hasEnclosingInstance$086b90c4939d0f1e,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$hasEnclosingInstance$086b90c4939d0f1e,
	.signature_hash=	_JC_JLONG(0x86b90c4939d0f1e),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	2,
};

//
// public abstract boolean hasFormals(polyglot.types.ProcedureInstance, java.util.List)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$hasFormals$71a60fe7c6ef5443[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$hasFormals$71a60fe7c6ef5443[] = {
	&_jc_polyglot_types_ProcedureInstance$type,
	&_jc_java_util_List$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$hasFormals$71a60fe7c6ef5443 = {
	.name=			"hasFormals",
	.signature=		"(Lpolyglot/types/ProcedureInstance;Ljava/util/List;)Z",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$hasFormals$71a60fe7c6ef5443,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$hasFormals$71a60fe7c6ef5443,
	.signature_hash=	_JC_JLONG(0x71a60fe7c6ef5443),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	2,
};

//
// public abstract boolean hasMethod(polyglot.types.ReferenceType, polyglot.types.MethodInstance)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$hasMethod$3ab9f49ce4ae6c98[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$hasMethod$3ab9f49ce4ae6c98[] = {
	&_jc_polyglot_types_ReferenceType$type,
	&_jc_polyglot_types_MethodInstance$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$hasMethod$3ab9f49ce4ae6c98 = {
	.name=			"hasMethod",
	.signature=		"(Lpolyglot/types/ReferenceType;Lpolyglot/types/MethodInstance;)Z",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$hasMethod$3ab9f49ce4ae6c98,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$hasMethod$3ab9f49ce4ae6c98,
	.signature_hash=	_JC_JLONG(0x3ab9f49ce4ae6c98),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	2,
};

//
// public abstract java.util.List implemented(polyglot.types.MethodInstance)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$implemented$c1254b124f05dec0[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$implemented$c1254b124f05dec0[] = {
	&_jc_polyglot_types_MethodInstance$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$implemented$c1254b124f05dec0 = {
	.name=			"implemented",
	.signature=		"(Lpolyglot/types/MethodInstance;)Ljava/util/List;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$implemented$c1254b124f05dec0,
	.return_type=		&_jc_java_util_List$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$implemented$c1254b124f05dec0,
	.signature_hash=	_JC_JLONG(0xc1254b124f05dec0),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
};

//
// public abstract polyglot.types.ImportTable importTable(java.lang.String, polyglot.types.Package)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$importTable$8c4f22564e76d25c[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$importTable$8c4f22564e76d25c[] = {
	&_jc_java_lang_String$type,
	&_jc_polyglot_types_Package$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$importTable$8c4f22564e76d25c = {
	.name=			"importTable",
	.signature=		"(Ljava/lang/String;Lpolyglot/types/Package;)Lpolyglot/types/ImportTable;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$importTable$8c4f22564e76d25c,
	.return_type=		&_jc_polyglot_types_ImportTable$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$importTable$8c4f22564e76d25c,
	.signature_hash=	_JC_JLONG(0x8c4f22564e76d25c),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	2,
};

//
// public abstract polyglot.types.ImportTable importTable(polyglot.types.Package)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$importTable$837e97a93e0f0df6[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$importTable$837e97a93e0f0df6[] = {
	&_jc_polyglot_types_Package$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$importTable$837e97a93e0f0df6 = {
	.name=			"importTable",
	.signature=		"(Lpolyglot/types/Package;)Lpolyglot/types/ImportTable;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$importTable$837e97a93e0f0df6,
	.return_type=		&_jc_polyglot_types_ImportTable$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$importTable$837e97a93e0f0df6,
	.signature_hash=	_JC_JLONG(0x837e97a93e0f0df6),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
};

//
// public abstract void initialize(polyglot.types.LoadedClassResolver, polyglot.frontend.ExtensionInfo) throws polyglot.types.SemanticException
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$initialize$187f958ee5f2c7a6[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_types_TypeSystem$exceptions$initialize$187f958ee5f2c7a6[] = {
	&_jc_polyglot_types_SemanticException$type
};

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$initialize$187f958ee5f2c7a6[] = {
	&_jc_polyglot_types_LoadedClassResolver$type,
	&_jc_polyglot_frontend_ExtensionInfo$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$initialize$187f958ee5f2c7a6 = {
	.name=			"initialize",
	.signature=		"(Lpolyglot/types/LoadedClassResolver;Lpolyglot/frontend/ExtensionInfo;)V",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$initialize$187f958ee5f2c7a6,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$initialize$187f958ee5f2c7a6,
	.signature_hash=	_JC_JLONG(0x187f958ee5f2c7a6),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_types_TypeSystem$exceptions$initialize$187f958ee5f2c7a6,
};

//
// public abstract polyglot.types.InitializerInstance initializerInstance(polyglot.util.Position, polyglot.types.ClassType, polyglot.types.Flags)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$initializerInstance$6bbe261c550cb6bd[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$initializerInstance$6bbe261c550cb6bd[] = {
	&_jc_polyglot_util_Position$type,
	&_jc_polyglot_types_ClassType$type,
	&_jc_polyglot_types_Flags$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$initializerInstance$6bbe261c550cb6bd = {
	.name=			"initializerInstance",
	.signature=		"(Lpolyglot/util/Position;Lpolyglot/types/ClassType;Lpolyglot/types/Flags;)Lpolyglot/types/InitializerInstance;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$initializerInstance$6bbe261c550cb6bd,
	.return_type=		&_jc_polyglot_types_InitializerInstance$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$initializerInstance$6bbe261c550cb6bd,
	.signature_hash=	_JC_JLONG(0x6bbe261c550cb6bd),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	3,
};

//
// public abstract java.util.List interfaces(polyglot.types.ReferenceType)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$interfaces$4a1efa0eca144c5a[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$interfaces$4a1efa0eca144c5a[] = {
	&_jc_polyglot_types_ReferenceType$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$interfaces$4a1efa0eca144c5a = {
	.name=			"interfaces",
	.signature=		"(Lpolyglot/types/ReferenceType;)Ljava/util/List;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$interfaces$4a1efa0eca144c5a,
	.return_type=		&_jc_java_util_List$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$interfaces$4a1efa0eca144c5a,
	.signature_hash=	_JC_JLONG(0x4a1efa0eca144c5a),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
};

//
// public abstract boolean isAccessible(polyglot.types.MemberInstance, polyglot.types.Context)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$isAccessible$3199cebbb975fe35[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$isAccessible$3199cebbb975fe35[] = {
	&_jc_polyglot_types_MemberInstance$type,
	&_jc_polyglot_types_Context$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$isAccessible$3199cebbb975fe35 = {
	.name=			"isAccessible",
	.signature=		"(Lpolyglot/types/MemberInstance;Lpolyglot/types/Context;)Z",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$isAccessible$3199cebbb975fe35,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$isAccessible$3199cebbb975fe35,
	.signature_hash=	_JC_JLONG(0x3199cebbb975fe35),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	2,
};

//
// public abstract boolean isCanonical(polyglot.types.Type)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$isCanonical$5493db755eb69bbd[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$isCanonical$5493db755eb69bbd[] = {
	&_jc_polyglot_types_Type$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$isCanonical$5493db755eb69bbd = {
	.name=			"isCanonical",
	.signature=		"(Lpolyglot/types/Type;)Z",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$isCanonical$5493db755eb69bbd,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$isCanonical$5493db755eb69bbd,
	.signature_hash=	_JC_JLONG(0x5493db755eb69bbd),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
};

//
// public abstract boolean isCastValid(polyglot.types.Type, polyglot.types.Type)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$isCastValid$04c7e65fd2241289[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$isCastValid$04c7e65fd2241289[] = {
	&_jc_polyglot_types_Type$type,
	&_jc_polyglot_types_Type$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$isCastValid$04c7e65fd2241289 = {
	.name=			"isCastValid",
	.signature=		"(Lpolyglot/types/Type;Lpolyglot/types/Type;)Z",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$isCastValid$04c7e65fd2241289,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$isCastValid$04c7e65fd2241289,
	.signature_hash=	_JC_JLONG(0x4c7e65fd2241289),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	2,
};

//
// public abstract boolean isEnclosed(polyglot.types.ClassType, polyglot.types.ClassType)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$isEnclosed$e1ba7d0c23a479c4[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$isEnclosed$e1ba7d0c23a479c4[] = {
	&_jc_polyglot_types_ClassType$type,
	&_jc_polyglot_types_ClassType$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$isEnclosed$e1ba7d0c23a479c4 = {
	.name=			"isEnclosed",
	.signature=		"(Lpolyglot/types/ClassType;Lpolyglot/types/ClassType;)Z",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$isEnclosed$e1ba7d0c23a479c4,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$isEnclosed$e1ba7d0c23a479c4,
	.signature_hash=	_JC_JLONG(0xe1ba7d0c23a479c4),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	2,
};

//
// public abstract boolean isImplicitCastValid(polyglot.types.Type, polyglot.types.Type)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$isImplicitCastValid$b55faf8945936508[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$isImplicitCastValid$b55faf8945936508[] = {
	&_jc_polyglot_types_Type$type,
	&_jc_polyglot_types_Type$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$isImplicitCastValid$b55faf8945936508 = {
	.name=			"isImplicitCastValid",
	.signature=		"(Lpolyglot/types/Type;Lpolyglot/types/Type;)Z",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$isImplicitCastValid$b55faf8945936508,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$isImplicitCastValid$b55faf8945936508,
	.signature_hash=	_JC_JLONG(0xb55faf8945936508),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	2,
};

//
// public abstract boolean isSameMethod(polyglot.types.MethodInstance, polyglot.types.MethodInstance)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$isSameMethod$c6137fbdedf88ada[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$isSameMethod$c6137fbdedf88ada[] = {
	&_jc_polyglot_types_MethodInstance$type,
	&_jc_polyglot_types_MethodInstance$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$isSameMethod$c6137fbdedf88ada = {
	.name=			"isSameMethod",
	.signature=		"(Lpolyglot/types/MethodInstance;Lpolyglot/types/MethodInstance;)Z",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$isSameMethod$c6137fbdedf88ada,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$isSameMethod$c6137fbdedf88ada,
	.signature_hash=	_JC_JLONG(0xc6137fbdedf88ada),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	2,
};

//
// public abstract boolean isSubtype(polyglot.types.Type, polyglot.types.Type)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$isSubtype$0c0cd3ff32298348[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$isSubtype$0c0cd3ff32298348[] = {
	&_jc_polyglot_types_Type$type,
	&_jc_polyglot_types_Type$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$isSubtype$0c0cd3ff32298348 = {
	.name=			"isSubtype",
	.signature=		"(Lpolyglot/types/Type;Lpolyglot/types/Type;)Z",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$isSubtype$0c0cd3ff32298348,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$isSubtype$0c0cd3ff32298348,
	.signature_hash=	_JC_JLONG(0xc0cd3ff32298348),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	2,
};

//
// public abstract boolean isThrowable(polyglot.types.Type)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$isThrowable$7ed057fb2e2f2333[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$isThrowable$7ed057fb2e2f2333[] = {
	&_jc_polyglot_types_Type$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$isThrowable$7ed057fb2e2f2333 = {
	.name=			"isThrowable",
	.signature=		"(Lpolyglot/types/Type;)Z",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$isThrowable$7ed057fb2e2f2333,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$isThrowable$7ed057fb2e2f2333,
	.signature_hash=	_JC_JLONG(0x7ed057fb2e2f2333),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
};

//
// public abstract boolean isUncheckedException(polyglot.types.Type)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$isUncheckedException$79771ed25a1996ff[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$isUncheckedException$79771ed25a1996ff[] = {
	&_jc_polyglot_types_Type$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$isUncheckedException$79771ed25a1996ff = {
	.name=			"isUncheckedException",
	.signature=		"(Lpolyglot/types/Type;)Z",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$isUncheckedException$79771ed25a1996ff,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$isUncheckedException$79771ed25a1996ff,
	.signature_hash=	_JC_JLONG(0x79771ed25a1996ff),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
};

//
// public abstract polyglot.types.Type leastCommonAncestor(polyglot.types.Type, polyglot.types.Type) throws polyglot.types.SemanticException
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$leastCommonAncestor$3a6a56b1aeb15457[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_TypeSystem$exceptions$leastCommonAncestor$3a6a56b1aeb15457[] = {
	&_jc_polyglot_types_SemanticException$type
};

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$leastCommonAncestor$3a6a56b1aeb15457[] = {
	&_jc_polyglot_types_Type$type,
	&_jc_polyglot_types_Type$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$leastCommonAncestor$3a6a56b1aeb15457 = {
	.name=			"leastCommonAncestor",
	.signature=		"(Lpolyglot/types/Type;Lpolyglot/types/Type;)Lpolyglot/types/Type;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$leastCommonAncestor$3a6a56b1aeb15457,
	.return_type=		&_jc_polyglot_types_Type$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$leastCommonAncestor$3a6a56b1aeb15457,
	.signature_hash=	_JC_JLONG(0x3a6a56b1aeb15457),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_types_TypeSystem$exceptions$leastCommonAncestor$3a6a56b1aeb15457,
};

//
// public abstract polyglot.types.LoadedClassResolver loadedResolver()
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$loadedResolver$33f62c55158fac8a[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_TypeSystem$method_info$loadedResolver$33f62c55158fac8a = {
	.name=			"loadedResolver",
	.signature=		"()Lpolyglot/types/LoadedClassResolver;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.return_type=		&_jc_polyglot_types_LoadedClassResolver$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$loadedResolver$33f62c55158fac8a,
	.signature_hash=	_JC_JLONG(0x33f62c55158fac8a),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract polyglot.types.LocalInstance localInstance(polyglot.util.Position, polyglot.types.Flags, polyglot.types.Type, java.lang.String)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$localInstance$794feb8c474b0888[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$localInstance$794feb8c474b0888[] = {
	&_jc_polyglot_util_Position$type,
	&_jc_polyglot_types_Flags$type,
	&_jc_polyglot_types_Type$type,
	&_jc_java_lang_String$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$localInstance$794feb8c474b0888 = {
	.name=			"localInstance",
	.signature=		"(Lpolyglot/util/Position;Lpolyglot/types/Flags;Lpolyglot/types/Type;Ljava/lang/String;)Lpolyglot/types/LocalInstance;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$localInstance$794feb8c474b0888,
	.return_type=		&_jc_polyglot_types_LocalInstance$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$localInstance$794feb8c474b0888,
	.signature_hash=	_JC_JLONG(0x794feb8c474b0888),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	4,
};

//
// public abstract boolean methodCallValid(polyglot.types.MethodInstance, java.lang.String, java.util.List)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$methodCallValid$35e9ce2747204749[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$methodCallValid$35e9ce2747204749[] = {
	&_jc_polyglot_types_MethodInstance$type,
	&_jc_java_lang_String$type,
	&_jc_java_util_List$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$methodCallValid$35e9ce2747204749 = {
	.name=			"methodCallValid",
	.signature=		"(Lpolyglot/types/MethodInstance;Ljava/lang/String;Ljava/util/List;)Z",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$methodCallValid$35e9ce2747204749,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$methodCallValid$35e9ce2747204749,
	.signature_hash=	_JC_JLONG(0x35e9ce2747204749),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	3,
};

//
// public abstract polyglot.types.MethodInstance methodInstance(polyglot.util.Position, polyglot.types.ReferenceType, polyglot.types.Flags, polyglot.types.Type, java.lang.String, java.util.List, java.util.List)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$methodInstance$929942af4f3ecf0b[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$methodInstance$929942af4f3ecf0b[] = {
	&_jc_polyglot_util_Position$type,
	&_jc_polyglot_types_ReferenceType$type,
	&_jc_polyglot_types_Flags$type,
	&_jc_polyglot_types_Type$type,
	&_jc_java_lang_String$type,
	&_jc_java_util_List$type,
	&_jc_java_util_List$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$methodInstance$929942af4f3ecf0b = {
	.name=			"methodInstance",
	.signature=		"(Lpolyglot/util/Position;Lpolyglot/types/ReferenceType;Lpolyglot/types/Flags;Lpolyglot/types/Type;Ljava/lang/String;Ljava/util/List;Ljava/util/List;)Lpolyglot/types/MethodInstance;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$methodInstance$929942af4f3ecf0b,
	.return_type=		&_jc_polyglot_types_MethodInstance$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$methodInstance$929942af4f3ecf0b,
	.signature_hash=	_JC_JLONG(0x929942af4f3ecf0b),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	7,
};

//
// public abstract boolean moreSpecific(polyglot.types.ProcedureInstance, polyglot.types.ProcedureInstance)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$moreSpecific$7065597f0019c5be[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$moreSpecific$7065597f0019c5be[] = {
	&_jc_polyglot_types_ProcedureInstance$type,
	&_jc_polyglot_types_ProcedureInstance$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$moreSpecific$7065597f0019c5be = {
	.name=			"moreSpecific",
	.signature=		"(Lpolyglot/types/ProcedureInstance;Lpolyglot/types/ProcedureInstance;)Z",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$moreSpecific$7065597f0019c5be,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$moreSpecific$7065597f0019c5be,
	.signature_hash=	_JC_JLONG(0x7065597f0019c5be),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	2,
};

//
// public abstract boolean numericConversionValid(polyglot.types.Type, long)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$numericConversionValid$df6e126c77192059[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_LONG, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$numericConversionValid$df6e126c77192059[] = {
	&_jc_polyglot_types_Type$type,
	&_jc_long$prim$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$numericConversionValid$df6e126c77192059 = {
	.name=			"numericConversionValid",
	.signature=		"(Lpolyglot/types/Type;J)Z",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$numericConversionValid$df6e126c77192059,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$numericConversionValid$df6e126c77192059,
	.signature_hash=	_JC_JLONG(0xdf6e126c77192059),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	2,
};

//
// public abstract boolean numericConversionValid(polyglot.types.Type, java.lang.Object)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$numericConversionValid$4be4240e4d894b2c[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$numericConversionValid$4be4240e4d894b2c[] = {
	&_jc_polyglot_types_Type$type,
	&_jc_java_lang_Object$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$numericConversionValid$4be4240e4d894b2c = {
	.name=			"numericConversionValid",
	.signature=		"(Lpolyglot/types/Type;Ljava/lang/Object;)Z",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$numericConversionValid$4be4240e4d894b2c,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$numericConversionValid$4be4240e4d894b2c,
	.signature_hash=	_JC_JLONG(0x4be4240e4d894b2c),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	2,
};

//
// public abstract java.util.List overrides(polyglot.types.MethodInstance)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$overrides$37b646b0e06504dc[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$overrides$37b646b0e06504dc[] = {
	&_jc_polyglot_types_MethodInstance$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$overrides$37b646b0e06504dc = {
	.name=			"overrides",
	.signature=		"(Lpolyglot/types/MethodInstance;)Ljava/util/List;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$overrides$37b646b0e06504dc,
	.return_type=		&_jc_java_util_List$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$overrides$37b646b0e06504dc,
	.signature_hash=	_JC_JLONG(0x37b646b0e06504dc),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
};

//
// public abstract polyglot.types.Resolver packageContextResolver(polyglot.types.Resolver, polyglot.types.Package)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$packageContextResolver$33817d16c1f298dc[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$packageContextResolver$33817d16c1f298dc[] = {
	&_jc_polyglot_types_Resolver$type,
	&_jc_polyglot_types_Package$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$packageContextResolver$33817d16c1f298dc = {
	.name=			"packageContextResolver",
	.signature=		"(Lpolyglot/types/Resolver;Lpolyglot/types/Package;)Lpolyglot/types/Resolver;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$packageContextResolver$33817d16c1f298dc,
	.return_type=		&_jc_polyglot_types_Resolver$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$packageContextResolver$33817d16c1f298dc,
	.signature_hash=	_JC_JLONG(0x33817d16c1f298dc),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	2,
};

//
// public abstract polyglot.types.Package packageForName(java.lang.String)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$packageForName$7e2f10249d3a88f5[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$packageForName$7e2f10249d3a88f5[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$packageForName$7e2f10249d3a88f5 = {
	.name=			"packageForName",
	.signature=		"(Ljava/lang/String;)Lpolyglot/types/Package;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$packageForName$7e2f10249d3a88f5,
	.return_type=		&_jc_polyglot_types_Package$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$packageForName$7e2f10249d3a88f5,
	.signature_hash=	_JC_JLONG(0x7e2f10249d3a88f5),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
};

//
// public abstract polyglot.types.Package packageForName(polyglot.types.Package, java.lang.String)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$packageForName$d2712cec27e74a0e[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$packageForName$d2712cec27e74a0e[] = {
	&_jc_polyglot_types_Package$type,
	&_jc_java_lang_String$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$packageForName$d2712cec27e74a0e = {
	.name=			"packageForName",
	.signature=		"(Lpolyglot/types/Package;Ljava/lang/String;)Lpolyglot/types/Package;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$packageForName$d2712cec27e74a0e,
	.return_type=		&_jc_polyglot_types_Package$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$packageForName$d2712cec27e74a0e,
	.signature_hash=	_JC_JLONG(0xd2712cec27e74a0e),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	2,
};

//
// public abstract polyglot.types.TableResolver parsedResolver()
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$parsedResolver$94bd2877fd169eca[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_TypeSystem$method_info$parsedResolver$94bd2877fd169eca = {
	.name=			"parsedResolver",
	.signature=		"()Lpolyglot/types/TableResolver;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.return_type=		&_jc_polyglot_types_TableResolver$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$parsedResolver$94bd2877fd169eca,
	.signature_hash=	_JC_JLONG(0x94bd2877fd169eca),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract java.lang.Object placeHolder(polyglot.types.TypeObject)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$placeHolder$6ef55db28fce69ed[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$placeHolder$6ef55db28fce69ed[] = {
	&_jc_polyglot_types_TypeObject$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$placeHolder$6ef55db28fce69ed = {
	.name=			"placeHolder",
	.signature=		"(Lpolyglot/types/TypeObject;)Ljava/lang/Object;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$placeHolder$6ef55db28fce69ed,
	.return_type=		&_jc_java_lang_Object$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$placeHolder$6ef55db28fce69ed,
	.signature_hash=	_JC_JLONG(0x6ef55db28fce69ed),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
};

//
// public abstract java.lang.Object placeHolder(polyglot.types.TypeObject, java.util.Set)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$placeHolder$d2d678113d2bd6b1[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$placeHolder$d2d678113d2bd6b1[] = {
	&_jc_polyglot_types_TypeObject$type,
	&_jc_java_util_Set$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$placeHolder$d2d678113d2bd6b1 = {
	.name=			"placeHolder",
	.signature=		"(Lpolyglot/types/TypeObject;Ljava/util/Set;)Ljava/lang/Object;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$placeHolder$d2d678113d2bd6b1,
	.return_type=		&_jc_java_lang_Object$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$placeHolder$d2d678113d2bd6b1,
	.signature_hash=	_JC_JLONG(0xd2d678113d2bd6b1),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	2,
};

//
// public abstract polyglot.types.PrimitiveType primitiveForName(java.lang.String) throws polyglot.types.SemanticException
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$primitiveForName$b16b6dbe08475994[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_TypeSystem$exceptions$primitiveForName$b16b6dbe08475994[] = {
	&_jc_polyglot_types_SemanticException$type
};

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$primitiveForName$b16b6dbe08475994[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$primitiveForName$b16b6dbe08475994 = {
	.name=			"primitiveForName",
	.signature=		"(Ljava/lang/String;)Lpolyglot/types/PrimitiveType;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$primitiveForName$b16b6dbe08475994,
	.return_type=		&_jc_polyglot_types_PrimitiveType$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$primitiveForName$b16b6dbe08475994,
	.signature_hash=	_JC_JLONG(0xb16b6dbe08475994),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_types_TypeSystem$exceptions$primitiveForName$b16b6dbe08475994,
};

//
// public abstract polyglot.types.PrimitiveType promote(polyglot.types.Type) throws polyglot.types.SemanticException
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$promote$95ba7679935dc2e6[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_TypeSystem$exceptions$promote$95ba7679935dc2e6[] = {
	&_jc_polyglot_types_SemanticException$type
};

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$promote$95ba7679935dc2e6[] = {
	&_jc_polyglot_types_Type$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$promote$95ba7679935dc2e6 = {
	.name=			"promote",
	.signature=		"(Lpolyglot/types/Type;)Lpolyglot/types/PrimitiveType;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$promote$95ba7679935dc2e6,
	.return_type=		&_jc_polyglot_types_PrimitiveType$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$promote$95ba7679935dc2e6,
	.signature_hash=	_JC_JLONG(0x95ba7679935dc2e6),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_types_TypeSystem$exceptions$promote$95ba7679935dc2e6,
};

//
// public abstract polyglot.types.PrimitiveType promote(polyglot.types.Type, polyglot.types.Type) throws polyglot.types.SemanticException
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$promote$1a31ee4d901308a0[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_TypeSystem$exceptions$promote$1a31ee4d901308a0[] = {
	&_jc_polyglot_types_SemanticException$type
};

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$promote$1a31ee4d901308a0[] = {
	&_jc_polyglot_types_Type$type,
	&_jc_polyglot_types_Type$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$promote$1a31ee4d901308a0 = {
	.name=			"promote",
	.signature=		"(Lpolyglot/types/Type;Lpolyglot/types/Type;)Lpolyglot/types/PrimitiveType;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$promote$1a31ee4d901308a0,
	.return_type=		&_jc_polyglot_types_PrimitiveType$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$promote$1a31ee4d901308a0,
	.signature_hash=	_JC_JLONG(0x1a31ee4d901308a0),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_types_TypeSystem$exceptions$promote$1a31ee4d901308a0,
};

//
// public abstract polyglot.types.Type staticTarget(polyglot.types.Type)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$staticTarget$a948cd1a186495b2[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$staticTarget$a948cd1a186495b2[] = {
	&_jc_polyglot_types_Type$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$staticTarget$a948cd1a186495b2 = {
	.name=			"staticTarget",
	.signature=		"(Lpolyglot/types/Type;)Lpolyglot/types/Type;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$staticTarget$a948cd1a186495b2,
	.return_type=		&_jc_polyglot_types_Type$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$staticTarget$a948cd1a186495b2,
	.signature_hash=	_JC_JLONG(0xa948cd1a186495b2),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
};

//
// public abstract polyglot.types.Type superType(polyglot.types.ReferenceType)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$superType$2d885b8a0820cc78[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$superType$2d885b8a0820cc78[] = {
	&_jc_polyglot_types_ReferenceType$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$superType$2d885b8a0820cc78 = {
	.name=			"superType",
	.signature=		"(Lpolyglot/types/ReferenceType;)Lpolyglot/types/Type;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$superType$2d885b8a0820cc78,
	.return_type=		&_jc_polyglot_types_Type$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$superType$2d885b8a0820cc78,
	.signature_hash=	_JC_JLONG(0x2d885b8a0820cc78),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
};

//
// public abstract polyglot.types.Resolver systemResolver()
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$systemResolver$586051238e5b2287[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_TypeSystem$method_info$systemResolver$586051238e5b2287 = {
	.name=			"systemResolver",
	.signature=		"()Lpolyglot/types/Resolver;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.return_type=		&_jc_polyglot_types_Resolver$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$systemResolver$586051238e5b2287,
	.signature_hash=	_JC_JLONG(0x586051238e5b2287),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract boolean throwsSubset(polyglot.types.ProcedureInstance, polyglot.types.ProcedureInstance)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$throwsSubset$def0240a60893ab4[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$throwsSubset$def0240a60893ab4[] = {
	&_jc_polyglot_types_ProcedureInstance$type,
	&_jc_polyglot_types_ProcedureInstance$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$throwsSubset$def0240a60893ab4 = {
	.name=			"throwsSubset",
	.signature=		"(Lpolyglot/types/ProcedureInstance;Lpolyglot/types/ProcedureInstance;)Z",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$throwsSubset$def0240a60893ab4,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$throwsSubset$def0240a60893ab4,
	.signature_hash=	_JC_JLONG(0xdef0240a60893ab4),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	2,
};

//
// public abstract java.lang.String translateArray(polyglot.types.Resolver, polyglot.types.ArrayType)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$translateArray$ddbdf40f8c8e0122[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$translateArray$ddbdf40f8c8e0122[] = {
	&_jc_polyglot_types_Resolver$type,
	&_jc_polyglot_types_ArrayType$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$translateArray$ddbdf40f8c8e0122 = {
	.name=			"translateArray",
	.signature=		"(Lpolyglot/types/Resolver;Lpolyglot/types/ArrayType;)Ljava/lang/String;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$translateArray$ddbdf40f8c8e0122,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$translateArray$ddbdf40f8c8e0122,
	.signature_hash=	_JC_JLONG(0xddbdf40f8c8e0122),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	2,
};

//
// public abstract java.lang.String translateClass(polyglot.types.Resolver, polyglot.types.ClassType)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$translateClass$b83b8fb92606a2db[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$translateClass$b83b8fb92606a2db[] = {
	&_jc_polyglot_types_Resolver$type,
	&_jc_polyglot_types_ClassType$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$translateClass$b83b8fb92606a2db = {
	.name=			"translateClass",
	.signature=		"(Lpolyglot/types/Resolver;Lpolyglot/types/ClassType;)Ljava/lang/String;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$translateClass$b83b8fb92606a2db,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$translateClass$b83b8fb92606a2db,
	.signature_hash=	_JC_JLONG(0xb83b8fb92606a2db),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	2,
};

//
// public abstract java.lang.String translatePackage(polyglot.types.Resolver, polyglot.types.Package)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$translatePackage$60299e48523a5498[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$translatePackage$60299e48523a5498[] = {
	&_jc_polyglot_types_Resolver$type,
	&_jc_polyglot_types_Package$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$translatePackage$60299e48523a5498 = {
	.name=			"translatePackage",
	.signature=		"(Lpolyglot/types/Resolver;Lpolyglot/types/Package;)Ljava/lang/String;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$translatePackage$60299e48523a5498,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$translatePackage$60299e48523a5498,
	.signature_hash=	_JC_JLONG(0x60299e48523a5498),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	2,
};

//
// public abstract java.lang.String translatePrimitive(polyglot.types.Resolver, polyglot.types.PrimitiveType)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$translatePrimitive$4c4e113cec1c5329[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$translatePrimitive$4c4e113cec1c5329[] = {
	&_jc_polyglot_types_Resolver$type,
	&_jc_polyglot_types_PrimitiveType$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$translatePrimitive$4c4e113cec1c5329 = {
	.name=			"translatePrimitive",
	.signature=		"(Lpolyglot/types/Resolver;Lpolyglot/types/PrimitiveType;)Ljava/lang/String;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$translatePrimitive$4c4e113cec1c5329,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$translatePrimitive$4c4e113cec1c5329,
	.signature_hash=	_JC_JLONG(0x4c4e113cec1c5329),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	2,
};

//
// public abstract polyglot.types.ClassType typeForName(java.lang.String) throws polyglot.types.SemanticException
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$typeForName$12d0583e9fc84e4c[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_TypeSystem$exceptions$typeForName$12d0583e9fc84e4c[] = {
	&_jc_polyglot_types_SemanticException$type
};

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$typeForName$12d0583e9fc84e4c[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$typeForName$12d0583e9fc84e4c = {
	.name=			"typeForName",
	.signature=		"(Ljava/lang/String;)Lpolyglot/types/ClassType;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$typeForName$12d0583e9fc84e4c,
	.return_type=		&_jc_polyglot_types_ClassType$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$typeForName$12d0583e9fc84e4c,
	.signature_hash=	_JC_JLONG(0x12d0583e9fc84e4c),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_types_TypeSystem$exceptions$typeForName$12d0583e9fc84e4c,
};

//
// public abstract java.util.Collection uncheckedExceptions()
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$uncheckedExceptions$1baaaf3743629fbe[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_TypeSystem$method_info$uncheckedExceptions$1baaaf3743629fbe = {
	.name=			"uncheckedExceptions",
	.signature=		"()Ljava/util/Collection;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.return_type=		&_jc_java_util_Collection$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$uncheckedExceptions$1baaaf3743629fbe,
	.signature_hash=	_JC_JLONG(0x1baaaf3743629fbe),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	0,
};

//
// public abstract polyglot.types.UnknownQualifier unknownQualifier(polyglot.util.Position)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$unknownQualifier$d823abdddcbb4c23[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$unknownQualifier$d823abdddcbb4c23[] = {
	&_jc_polyglot_util_Position$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$unknownQualifier$d823abdddcbb4c23 = {
	.name=			"unknownQualifier",
	.signature=		"(Lpolyglot/util/Position;)Lpolyglot/types/UnknownQualifier;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$unknownQualifier$d823abdddcbb4c23,
	.return_type=		&_jc_polyglot_types_UnknownQualifier$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$unknownQualifier$d823abdddcbb4c23,
	.signature_hash=	_JC_JLONG(0xd823abdddcbb4c23),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
};

//
// public abstract polyglot.types.UnknownType unknownType(polyglot.util.Position)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$unknownType$18be8b07e5cdcd25[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$unknownType$18be8b07e5cdcd25[] = {
	&_jc_polyglot_util_Position$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$unknownType$18be8b07e5cdcd25 = {
	.name=			"unknownType",
	.signature=		"(Lpolyglot/util/Position;)Lpolyglot/types/UnknownType;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$unknownType$18be8b07e5cdcd25,
	.return_type=		&_jc_polyglot_types_UnknownType$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$unknownType$18be8b07e5cdcd25,
	.signature_hash=	_JC_JLONG(0x18be8b07e5cdcd25),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
};

//
// public abstract java.lang.String wrapperTypeString(polyglot.types.PrimitiveType)
//

static const unsigned char _jc_polyglot_types_TypeSystem$param_ptypes$wrapperTypeString$53023fa665717e23[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_TypeSystem$param_types$wrapperTypeString$53023fa665717e23[] = {
	&_jc_polyglot_types_PrimitiveType$type
};

_jc_method _jc_polyglot_types_TypeSystem$method_info$wrapperTypeString$53023fa665717e23 = {
	.name=			"wrapperTypeString",
	.signature=		"(Lpolyglot/types/PrimitiveType;)Ljava/lang/String;",
	.class=			&_jc_polyglot_types_TypeSystem$type,
	.param_types=		&_jc_polyglot_types_TypeSystem$param_types$wrapperTypeString$53023fa665717e23,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_polyglot_types_TypeSystem$param_ptypes$wrapperTypeString$53023fa665717e23,
	.signature_hash=	_JC_JLONG(0x53023fa665717e23),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT,
	.num_parameters=	1,
};

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_polyglot_types_TypeSystem$methods[] = {
	&_jc_polyglot_types_TypeSystem$method_info$Abstract$3101ad867f932e1a,
	&_jc_polyglot_types_TypeSystem$method_info$ArithmeticException$9bf6bfa3c57decc7,
	&_jc_polyglot_types_TypeSystem$method_info$ArrayStoreException$45acc4fa10932146,
	&_jc_polyglot_types_TypeSystem$method_info$Boolean$e145ff993ae016c7,
	&_jc_polyglot_types_TypeSystem$method_info$Byte$700d58be98f69608,
	&_jc_polyglot_types_TypeSystem$method_info$Char$fe585fe6a86121d3,
	&_jc_polyglot_types_TypeSystem$method_info$Class$ea0d791b2a835795,
	&_jc_polyglot_types_TypeSystem$method_info$ClassCastException$e111cc89eefc1d95,
	&_jc_polyglot_types_TypeSystem$method_info$Cloneable$817a23e5b7bd7581,
	&_jc_polyglot_types_TypeSystem$method_info$Double$bec60fc1578ebadb,
	&_jc_polyglot_types_TypeSystem$method_info$Error$dad7fad2e2e7038f,
	&_jc_polyglot_types_TypeSystem$method_info$Exception$f5caa9f3aa67024b,
	&_jc_polyglot_types_TypeSystem$method_info$Final$6c770ed071867d68,
	&_jc_polyglot_types_TypeSystem$method_info$Float$993d0c4b6fff7e75,
	&_jc_polyglot_types_TypeSystem$method_info$Int$dc8a8335063a64fa,
	&_jc_polyglot_types_TypeSystem$method_info$Interface$d1d258d4e63ede53,
	&_jc_polyglot_types_TypeSystem$method_info$Long$3f9115aad1b16e63,
	&_jc_polyglot_types_TypeSystem$method_info$Native$d03574bca3c26117,
	&_jc_polyglot_types_TypeSystem$method_info$NoFlags$5bce1b106ba9c92d,
	&_jc_polyglot_types_TypeSystem$method_info$Null$85a398d001b1dd37,
	&_jc_polyglot_types_TypeSystem$method_info$NullPointerException$e0d8e3e38ae6c92e,
	&_jc_polyglot_types_TypeSystem$method_info$Object$8b7e0d7b96abda0e,
	&_jc_polyglot_types_TypeSystem$method_info$OutOfBoundsException$e12abf8d2553b892,
	&_jc_polyglot_types_TypeSystem$method_info$Private$0f04beb4fadb389b,
	&_jc_polyglot_types_TypeSystem$method_info$Protected$cc85b80cb44fc771,
	&_jc_polyglot_types_TypeSystem$method_info$Public$6e2fa630de91f274,
	&_jc_polyglot_types_TypeSystem$method_info$RuntimeException$1a907c556c157cbb,
	&_jc_polyglot_types_TypeSystem$method_info$Serializable$34e9f2c2ef0c2dc3,
	&_jc_polyglot_types_TypeSystem$method_info$Short$c523e949e25678d7,
	&_jc_polyglot_types_TypeSystem$method_info$Static$89d0513bab2bd4ef,
	&_jc_polyglot_types_TypeSystem$method_info$StrictFP$a4f5b34502a86c37,
	&_jc_polyglot_types_TypeSystem$method_info$String$8051b0f541e1a5b2,
	&_jc_polyglot_types_TypeSystem$method_info$Synchronized$4af0343d7561610b,
	&_jc_polyglot_types_TypeSystem$method_info$Throwable$ae911753a19c6860,
	&_jc_polyglot_types_TypeSystem$method_info$Transient$f7e6bc0f49a075b1,
	&_jc_polyglot_types_TypeSystem$method_info$Void$7ba97b6f0a7b5de6,
	&_jc_polyglot_types_TypeSystem$method_info$Volatile$6082c870acd57f5c,
	&_jc_polyglot_types_TypeSystem$method_info$arrayOf$d0330f9cad7d3f34,
	&_jc_polyglot_types_TypeSystem$method_info$arrayOf$bddcfdf10cebaed0,
	&_jc_polyglot_types_TypeSystem$method_info$arrayOf$e447f59ddb1c2994,
	&_jc_polyglot_types_TypeSystem$method_info$arrayOf$3540da06ad9084cd,
	&_jc_polyglot_types_TypeSystem$method_info$callValid$de9a9752966ad9e4,
	&_jc_polyglot_types_TypeSystem$method_info$canCoerceToString$beefd6098a6b6703,
	&_jc_polyglot_types_TypeSystem$method_info$canOverride$299577304c1e1440,
	&_jc_polyglot_types_TypeSystem$method_info$checkAccessFlags$0085d5a8bdfa8c68,
	&_jc_polyglot_types_TypeSystem$method_info$checkClassConformance$0e954ff57832dbe3,
	&_jc_polyglot_types_TypeSystem$method_info$checkConstructorFlags$aaa4492f9c8743e3,
	&_jc_polyglot_types_TypeSystem$method_info$checkCycles$0f94998c861cf640,
	&_jc_polyglot_types_TypeSystem$method_info$checkFieldFlags$2ffd6a70995bb6b2,
	&_jc_polyglot_types_TypeSystem$method_info$checkInitializerFlags$253c2f981ef370fa,
	&_jc_polyglot_types_TypeSystem$method_info$checkLocalClassFlags$8cdf364732f77b69,
	&_jc_polyglot_types_TypeSystem$method_info$checkLocalFlags$13d5f051e59c2ac4,
	&_jc_polyglot_types_TypeSystem$method_info$checkMemberClassFlags$dda2772c9e4c01a5,
	&_jc_polyglot_types_TypeSystem$method_info$checkMethodFlags$ddd95058711ce2fe,
	&_jc_polyglot_types_TypeSystem$method_info$checkOverride$0eb36c1e19564da9,
	&_jc_polyglot_types_TypeSystem$method_info$checkTopLevelClassFlags$b0de1bf09031bfc3,
	&_jc_polyglot_types_TypeSystem$method_info$classContextResolver$cd4ffbc34624d5db,
	&_jc_polyglot_types_TypeSystem$method_info$constructorInstance$7684c1b47d4498f7,
	&_jc_polyglot_types_TypeSystem$method_info$createClassType$d3c10e33a2ff34fc,
	&_jc_polyglot_types_TypeSystem$method_info$createClassType$8e020e197fa9d6f9,
	&_jc_polyglot_types_TypeSystem$method_info$createClassType$f5da6f1b6db11064,
	&_jc_polyglot_types_TypeSystem$method_info$createClassType$dbac273b5af99738,
	&_jc_polyglot_types_TypeSystem$method_info$createContext$a533e01ab4704d58,
	&_jc_polyglot_types_TypeSystem$method_info$createNewFlag$b192005dcbb768ef,
	&_jc_polyglot_types_TypeSystem$method_info$defaultClassInitializer$fe905bd408f21160,
	&_jc_polyglot_types_TypeSystem$method_info$defaultConstructor$3dfe98e49b83079a,
	&_jc_polyglot_types_TypeSystem$method_info$defaultPackageImports$e5c552b6d8e94472,
	&_jc_polyglot_types_TypeSystem$method_info$descendsFrom$cefafaeacf05eaec,
	&_jc_polyglot_types_TypeSystem$method_info$equals$79f5e97cb0290662,
	&_jc_polyglot_types_TypeSystem$method_info$fieldInstance$1d2f4914e8b7c9f6,
	&_jc_polyglot_types_TypeSystem$method_info$findConstructor$498f90825a815cb3,
	&_jc_polyglot_types_TypeSystem$method_info$findField$c60eaca9cacff8b0,
	&_jc_polyglot_types_TypeSystem$method_info$findField$5589def512e4cb79,
	&_jc_polyglot_types_TypeSystem$method_info$findMemberClass$dc3b01d44352b553,
	&_jc_polyglot_types_TypeSystem$method_info$findMemberClass$f79ea4417433867d,
	&_jc_polyglot_types_TypeSystem$method_info$findMethod$4002275a6822a129,
	&_jc_polyglot_types_TypeSystem$method_info$flagsForBits$62f24019375a1a4f,
	&_jc_polyglot_types_TypeSystem$method_info$getTransformedClassName$8baa8ccdbc44d970,
	&_jc_polyglot_types_TypeSystem$method_info$getTypeEncoderRootSet$217745370d0376f7,
	&_jc_polyglot_types_TypeSystem$method_info$hasEnclosingInstance$086b90c4939d0f1e,
	&_jc_polyglot_types_TypeSystem$method_info$hasFormals$71a60fe7c6ef5443,
	&_jc_polyglot_types_TypeSystem$method_info$hasMethod$3ab9f49ce4ae6c98,
	&_jc_polyglot_types_TypeSystem$method_info$implemented$c1254b124f05dec0,
	&_jc_polyglot_types_TypeSystem$method_info$importTable$8c4f22564e76d25c,
	&_jc_polyglot_types_TypeSystem$method_info$importTable$837e97a93e0f0df6,
	&_jc_polyglot_types_TypeSystem$method_info$initialize$187f958ee5f2c7a6,
	&_jc_polyglot_types_TypeSystem$method_info$initializerInstance$6bbe261c550cb6bd,
	&_jc_polyglot_types_TypeSystem$method_info$interfaces$4a1efa0eca144c5a,
	&_jc_polyglot_types_TypeSystem$method_info$isAccessible$3199cebbb975fe35,
	&_jc_polyglot_types_TypeSystem$method_info$isCanonical$5493db755eb69bbd,
	&_jc_polyglot_types_TypeSystem$method_info$isCastValid$04c7e65fd2241289,
	&_jc_polyglot_types_TypeSystem$method_info$isEnclosed$e1ba7d0c23a479c4,
	&_jc_polyglot_types_TypeSystem$method_info$isImplicitCastValid$b55faf8945936508,
	&_jc_polyglot_types_TypeSystem$method_info$isSameMethod$c6137fbdedf88ada,
	&_jc_polyglot_types_TypeSystem$method_info$isSubtype$0c0cd3ff32298348,
	&_jc_polyglot_types_TypeSystem$method_info$isThrowable$7ed057fb2e2f2333,
	&_jc_polyglot_types_TypeSystem$method_info$isUncheckedException$79771ed25a1996ff,
	&_jc_polyglot_types_TypeSystem$method_info$leastCommonAncestor$3a6a56b1aeb15457,
	&_jc_polyglot_types_TypeSystem$method_info$loadedResolver$33f62c55158fac8a,
	&_jc_polyglot_types_TypeSystem$method_info$localInstance$794feb8c474b0888,
	&_jc_polyglot_types_TypeSystem$method_info$methodCallValid$35e9ce2747204749,
	&_jc_polyglot_types_TypeSystem$method_info$methodInstance$929942af4f3ecf0b,
	&_jc_polyglot_types_TypeSystem$method_info$moreSpecific$7065597f0019c5be,
	&_jc_polyglot_types_TypeSystem$method_info$numericConversionValid$df6e126c77192059,
	&_jc_polyglot_types_TypeSystem$method_info$numericConversionValid$4be4240e4d894b2c,
	&_jc_polyglot_types_TypeSystem$method_info$overrides$37b646b0e06504dc,
	&_jc_polyglot_types_TypeSystem$method_info$packageContextResolver$33817d16c1f298dc,
	&_jc_polyglot_types_TypeSystem$method_info$packageForName$7e2f10249d3a88f5,
	&_jc_polyglot_types_TypeSystem$method_info$packageForName$d2712cec27e74a0e,
	&_jc_polyglot_types_TypeSystem$method_info$parsedResolver$94bd2877fd169eca,
	&_jc_polyglot_types_TypeSystem$method_info$placeHolder$6ef55db28fce69ed,
	&_jc_polyglot_types_TypeSystem$method_info$placeHolder$d2d678113d2bd6b1,
	&_jc_polyglot_types_TypeSystem$method_info$primitiveForName$b16b6dbe08475994,
	&_jc_polyglot_types_TypeSystem$method_info$promote$95ba7679935dc2e6,
	&_jc_polyglot_types_TypeSystem$method_info$promote$1a31ee4d901308a0,
	&_jc_polyglot_types_TypeSystem$method_info$staticTarget$a948cd1a186495b2,
	&_jc_polyglot_types_TypeSystem$method_info$superType$2d885b8a0820cc78,
	&_jc_polyglot_types_TypeSystem$method_info$systemResolver$586051238e5b2287,
	&_jc_polyglot_types_TypeSystem$method_info$throwsSubset$def0240a60893ab4,
	&_jc_polyglot_types_TypeSystem$method_info$translateArray$ddbdf40f8c8e0122,
	&_jc_polyglot_types_TypeSystem$method_info$translateClass$b83b8fb92606a2db,
	&_jc_polyglot_types_TypeSystem$method_info$translatePackage$60299e48523a5498,
	&_jc_polyglot_types_TypeSystem$method_info$translatePrimitive$4c4e113cec1c5329,
	&_jc_polyglot_types_TypeSystem$method_info$typeForName$12d0583e9fc84e4c,
	&_jc_polyglot_types_TypeSystem$method_info$uncheckedExceptions$1baaaf3743629fbe,
	&_jc_polyglot_types_TypeSystem$method_info$unknownQualifier$d823abdddcbb4c23,
	&_jc_polyglot_types_TypeSystem$method_info$unknownType$18be8b07e5cdcd25,
	&_jc_polyglot_types_TypeSystem$method_info$wrapperTypeString$53023fa665717e23
};

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_polyglot_types_TypeSystem$instanceof_hash_bucket_40[] = {
	&_jc_polyglot_types_TypeSystem$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_types_TypeSystem$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_polyglot_types_TypeSystem$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[40]=	_jc_polyglot_types_TypeSystem$instanceof_hash_bucket_40,
	[101]=	_jc_polyglot_types_TypeSystem$instanceof_hash_bucket_101
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_polyglot_types_TypeSystem$class_depends[] = {
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/util/Collection",	_JC_JLONG(0xeae4d0c0e8eb63da) },
	{ "java/util/List",	_JC_JLONG(0x9ee0d92ce1525a4d) },
	{ "java/util/Set",	_JC_JLONG(0x617ac82c0bec2dff) },
	{ "polyglot/frontend/ExtensionInfo",	_JC_JLONG(0xfdbc32d4847269bf) },
	{ "polyglot/frontend/Source",	_JC_JLONG(0xcd88b669bec8f787) },
	{ "polyglot/types/ArrayType",	_JC_JLONG(0x412788f7d4254477) },
	{ "polyglot/types/ClassType",	_JC_JLONG(0xb38560af658974f8) },
	{ "polyglot/types/ConstructorInstance",	_JC_JLONG(0xfc9c35c3fb8d6af7) },
	{ "polyglot/types/Context",	_JC_JLONG(0xa433cdcd788f6c37) },
	{ "polyglot/types/FieldInstance",	_JC_JLONG(0xd4beb04c35c42bde) },
	{ "polyglot/types/Flags",	_JC_JLONG(0x821eb65d8f2f30f6) },
	{ "polyglot/types/ImportTable",	_JC_JLONG(0xe82fd79d93315427) },
	{ "polyglot/types/InitializerInstance",	_JC_JLONG(0xb7281cf8e3a14f14) },
	{ "polyglot/types/LazyClassInitializer",	_JC_JLONG(0x3efd9ad11091f77) },
	{ "polyglot/types/LoadedClassResolver",	_JC_JLONG(0x775d491e1eb77426) },
	{ "polyglot/types/LocalInstance",	_JC_JLONG(0x143a5bf23e0f6584) },
	{ "polyglot/types/MemberInstance",	_JC_JLONG(0x7ea7408712d6d898) },
	{ "polyglot/types/MethodInstance",	_JC_JLONG(0xab0fa5f3ef02c9ee) },
	{ "polyglot/types/NullType",	_JC_JLONG(0x54fedc5d44752cc6) },
	{ "polyglot/types/Package",	_JC_JLONG(0x15df1cfa12c16381) },
	{ "polyglot/types/ParsedClassType",	_JC_JLONG(0x6bcfbf52304f9e7c) },
	{ "polyglot/types/PrimitiveType",	_JC_JLONG(0xc9050be6d71cb6f4) },
	{ "polyglot/types/ProcedureInstance",	_JC_JLONG(0xbf36f48cfcf511f4) },
	{ "polyglot/types/ReferenceType",	_JC_JLONG(0xcfc647d76f91943a) },
	{ "polyglot/types/Resolver",	_JC_JLONG(0x3a3788b16a28392b) },
	{ "polyglot/types/SemanticException",	_JC_JLONG(0x45f755f5298b5b39) },
	{ "polyglot/types/TableResolver",	_JC_JLONG(0x4fb97851ac3ef2dd) },
	{ "polyglot/types/Type",	_JC_JLONG(0x6596051546781098) },
	{ "polyglot/types/TypeObject",	_JC_JLONG(0xb6db228dc0317211) },
	{ "polyglot/types/UnknownQualifier",	_JC_JLONG(0x837b374dbc40bb7c) },
	{ "polyglot/types/UnknownType",	_JC_JLONG(0x38eab2c3a16b0aaa) },
	{ "polyglot/util/Position",	_JC_JLONG(0x32c9a088c5dac046) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_polyglot_types_TypeSystem$vtype _jc_polyglot_types_TypeSystem$type = {
    .type= {
	.name=			"polyglot/types/TypeSystem",
	.superclass=		&_jc_java_lang_Object$type,
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_ABSTRACT|_JC_ACC_INTERFACE,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		139,
		.hash=			_JC_JLONG(0xed171cdaca38ec28),
		.source_file=		"TypeSystem.java",
		.num_virtual_refs=	0,
		.num_methods=		sizeof(_jc_polyglot_types_TypeSystem$methods) / sizeof(*_jc_polyglot_types_TypeSystem$methods),
		.methods=		_jc_polyglot_types_TypeSystem$methods,
		.instanceof_hash_table=	_jc_polyglot_types_TypeSystem$instanceof_hash_table,
		.num_class_depends=		sizeof(_jc_polyglot_types_TypeSystem$class_depends) / sizeof(*_jc_polyglot_types_TypeSystem$class_depends),
		.class_depends=		_jc_polyglot_types_TypeSystem$class_depends,
	    }
	}
    }
};

