// class polyglot.types.reflect.Method

// class file dependencies
// @dep_class cc3ce5b592e8a1d java_io_DataInputStream
// @dep_class 455accfa535f5dfe java_io_FilterInputStream
// @dep_class 4e0a56550c69d57c java_io_IOException
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class c933004fd5a6148 java_lang_ClassFormatError
// @dep_class 308333d803f5ab9f java_lang_Error
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class 3cdfed1e0ad1a3d6 java_lang_IndexOutOfBoundsException
// @dep_class ca631501391a31f1 java_lang_Integer
// @dep_class 3746e17e005bda9e java_lang_LinkageError
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class 4f5534a987354d1d java_lang_RuntimeException
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 94d357637b968dda java_lang_StringBuffer
// @dep_class bb7f6fdd2bd0e6b2 java_lang_StringIndexOutOfBoundsException
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class 8ea716c64b77f8eb java_util_AbstractCollection
// @dep_class f5238436362828db java_util_AbstractList
// @dep_class 58038509830ef3f4 java_util_ArrayList
// @dep_class 9ee0d92ce1525a4d java_util_List
// @dep_class b38560af658974f8 polyglot_types_ClassType
// @dep_class fc9c35c3fb8d6af7 polyglot_types_ConstructorInstance
// @dep_class 821eb65d8f2f30f6 polyglot_types_Flags
// @dep_class ab0fa5f3ef02c9ee polyglot_types_MethodInstance
// @dep_class 6596051546781098 polyglot_types_Type
// @dep_class ed171cdaca38ec28 polyglot_types_TypeSystem
// @dep_class d931fb91b452174 polyglot_types_reflect_Attribute
// @dep_class f394a649a5830bb polyglot_types_reflect_ClassFile
// @dep_class 209b8df6d16abcfb polyglot_types_reflect_Constant
// @dep_class a0635b021c46faf6 polyglot_types_reflect_Exceptions
// @dep_class 78cd51360123a1f9 polyglot_types_reflect_Method
// @dep_class 32c9a088c5dac046 polyglot_util_Position

// header file dependencies
// @dep_header java_io_DataInputStream
// @dep_header java_io_IOException
// @dep_header java_lang_Class
// @dep_header java_lang_ClassFormatError
// @dep_header java_lang_Integer
// @dep_header java_lang_String
// @dep_header java_lang_StringBuffer
// @dep_header java_lang_StringIndexOutOfBoundsException
// @dep_header java_lang_VMThrowable
// @dep_header java_util_ArrayList
// @dep_header java_util_List
// @dep_header polyglot_types_ClassType
// @dep_header polyglot_types_ConstructorInstance
// @dep_header polyglot_types_Flags
// @dep_header polyglot_types_MethodInstance
// @dep_header polyglot_types_Type
// @dep_header polyglot_types_TypeSystem
// @dep_header polyglot_types_reflect_ClassFile
// @dep_header polyglot_types_reflect_Constant
// @dep_header polyglot_types_reflect_Exceptions
// @dep_header polyglot_types_reflect_Method
// @dep_header polyglot_util_Position

#include "jc_defs.h"

#include "java/io/DataInputStream.h"
#include "java/io/IOException.h"
#include "java/lang/Class.h"
#include "java/lang/ClassFormatError.h"
#include "java/lang/Integer.h"
#include "java/lang/String.h"
#include "java/lang/StringBuffer.h"
#include "java/lang/StringIndexOutOfBoundsException.h"
#include "java/lang/VMThrowable.h"
#include "java/util/ArrayList.h"
#include "java/util/List.h"
#include "polyglot/types/ClassType.h"
#include "polyglot/types/ConstructorInstance.h"
#include "polyglot/types/Flags.h"
#include "polyglot/types/MethodInstance.h"
#include "polyglot/types/Type.h"
#include "polyglot/types/TypeSystem.h"
#include "polyglot/types/reflect/ClassFile.h"
#include "polyglot/types/reflect/Constant.h"
#include "polyglot/types/reflect/Exceptions.h"
#include "polyglot/types/reflect/Method.h"
#include "polyglot/util/Position.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// polyglot.types.reflect.ClassFile clazz
static _jc_field _jc_polyglot_types_reflect_Method$field_info$clazz = {
	.name=		"clazz",
	.signature=	"Lpolyglot/types/reflect/ClassFile;",
	.class=		&_jc_polyglot_types_reflect_Method$type,
	.type=		&_jc_polyglot_types_reflect_ClassFile$type,
	.access_flags=	0,
	.offset=	_JC_OFFSETOF(_jc_polyglot_types_reflect_Method$object, refs[-1].polyglot_types_reflect_Method.clazz),
};

// int modifiers
static _jc_field _jc_polyglot_types_reflect_Method$field_info$modifiers = {
	.name=		"modifiers",
	.signature=	"I",
	.class=		&_jc_polyglot_types_reflect_Method$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	0,
	.offset=	_JC_OFFSETOF(_jc_polyglot_types_reflect_Method$object, nonrefs.polyglot_types_reflect_Method.modifiers),
};

// int name
static _jc_field _jc_polyglot_types_reflect_Method$field_info$name = {
	.name=		"name",
	.signature=	"I",
	.class=		&_jc_polyglot_types_reflect_Method$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	0,
	.offset=	_JC_OFFSETOF(_jc_polyglot_types_reflect_Method$object, nonrefs.polyglot_types_reflect_Method.name),
};

// int type
static _jc_field _jc_polyglot_types_reflect_Method$field_info$type = {
	.name=		"type",
	.signature=	"I",
	.class=		&_jc_polyglot_types_reflect_Method$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	0,
	.offset=	_JC_OFFSETOF(_jc_polyglot_types_reflect_Method$object, nonrefs.polyglot_types_reflect_Method.type),
};

// polyglot.types.reflect.Attribute[] attrs
static _jc_field _jc_polyglot_types_reflect_Method$field_info$attrs = {
	.name=		"attrs",
	.signature=	"[Lpolyglot/types/reflect/Attribute;",
	.class=		&_jc_polyglot_types_reflect_Method$type,
	.type=		&_jc_polyglot_types_reflect_Attribute$array$type,
	.access_flags=	0,
	.offset=	_JC_OFFSETOF(_jc_polyglot_types_reflect_Method$object, refs[-1].polyglot_types_reflect_Method.attrs),
};

// polyglot.types.reflect.Exceptions exceptions
static _jc_field _jc_polyglot_types_reflect_Method$field_info$exceptions = {
	.name=		"exceptions",
	.signature=	"Lpolyglot/types/reflect/Exceptions;",
	.class=		&_jc_polyglot_types_reflect_Method$type,
	.type=		&_jc_polyglot_types_reflect_Exceptions$type,
	.access_flags=	0,
	.offset=	_JC_OFFSETOF(_jc_polyglot_types_reflect_Method$object, refs[-1].polyglot_types_reflect_Method.exceptions),
};

// Fields
static _jc_field *const _jc_polyglot_types_reflect_Method$fields[] = {
	&_jc_polyglot_types_reflect_Method$field_info$attrs,
	&_jc_polyglot_types_reflect_Method$field_info$clazz,
	&_jc_polyglot_types_reflect_Method$field_info$exceptions,
	&_jc_polyglot_types_reflect_Method$field_info$modifiers,
	&_jc_polyglot_types_reflect_Method$field_info$name,
	&_jc_polyglot_types_reflect_Method$field_info$type
};

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// void <init>(java.io.DataInputStream, polyglot.types.reflect.ClassFile) throws java.io.IOException
//

static _jc_linenum _jc_polyglot_types_reflect_Method$linenum_table$_init$b1ea5c53786ab2c1[];

static const unsigned char _jc_polyglot_types_reflect_Method$param_ptypes$_init$b1ea5c53786ab2c1[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_types_reflect_Method$exceptions$_init$b1ea5c53786ab2c1[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_polyglot_types_reflect_Method$param_types$_init$b1ea5c53786ab2c1[] = {
	&_jc_java_io_DataInputStream$type,
	&_jc_polyglot_types_reflect_ClassFile$type
};

_jc_method _jc_polyglot_types_reflect_Method$method_info$_init$b1ea5c53786ab2c1 = {
	.name=			"<init>",
	.signature=		"(Ljava/io/DataInputStream;Lpolyglot/types/reflect/ClassFile;)V",
	.class=			&_jc_polyglot_types_reflect_Method$type,
	.param_types=		&_jc_polyglot_types_reflect_Method$param_types$_init$b1ea5c53786ab2c1,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_types_reflect_Method$param_ptypes$_init$b1ea5c53786ab2c1,
	.signature_hash=	_JC_JLONG(0xb1ea5c53786ab2c1),
	.access_flags=		0,
	.function=		&_jc_polyglot_types_reflect_Method$method$_init$b1ea5c53786ab2c1,
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_types_reflect_Method$exceptions$_init$b1ea5c53786ab2c1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	13,
	      .table=	_jc_polyglot_types_reflect_Method$linenum_table$_init$b1ea5c53786ab2c1
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_types_reflect_Method, _init$b1ea5c53786ab2c1);

void _JC_JCNI_ATTR
_jc_polyglot_types_reflect_Method$method$_init$b1ea5c53786ab2c1(_jc_env *const env, _jc_polyglot_types_reflect_Method$object *this, _jc_java_io_DataInputStream$object *param0, _jc_polyglot_types_reflect_ClassFile$object *param1)
{
	jbyte b11;
	jbyte b14;
	jbyte b5;
	jbyte b8;
	jint i0;
	jint i10;
	jint i13;
	jint i16;
	jint i2;
	jint i3;
	jint i4;
	jint i7;
	jlong l1;
	struct _jc_polyglot_types_reflect_Method$object *r0;
	struct _jc_java_io_DataInputStream$object *r1;
	_jc_byte_array *r10;
	_jc_byte_array *r11;
	_jc_byte_array *r12;
	_jc_byte_array *r13;
	_jc_byte_array *r14;
	struct _jc_polyglot_types_reflect_ClassFile$object *r2;
	struct _jc_polyglot_types_reflect_Constant$object *r3;
	_jc_object_array *r4;
	_jc_object_array *r5;
	struct _jc_java_lang_String$object *r6;
	struct _jc_polyglot_types_reflect_Exceptions$object *r7;
	struct _jc_java_lang_Object$object *r8;
	_jc_byte_array *r9;
	jshort s12;
	jshort s15;
	jshort s6;
	jshort s9;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_LINE_NUMBER(42);				// 0
	_JC_REF_FIELD(env, r0, polyglot_types_reflect_Method, clazz) = r2;
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	r9 = _JC_REF_FIELD(env, r1, java_io_DataInputStream, buf);
	_JC_INVOKE_NONVIRTUAL(env, java_io_DataInputStream, readFully$63e0ddb7f8315fc6, 0, r1, r9, 0, 2);
	r9 = _JC_REF_FIELD(env, r1, java_io_DataInputStream, buf);
	b5 = _JC_PRIM_ELEMENT(env, byte, r9, 0, 0, 1);
	s6 = b5 & 255;
	i7 = s6 << (8 & 0x1f);
	b5 = _JC_PRIM_ELEMENT(env, byte, r9, 1, 0, 1);
	s6 = b5 & 255;
	i7 = i7 | s6;
	_JC_LINE_NUMBER(44);				// 1
	_JC_PRIM_FIELD(env, r0, polyglot_types_reflect_Method, modifiers) = i7;
	r10 = _JC_REF_FIELD(env, r1, java_io_DataInputStream, buf);
	_JC_INVOKE_NONVIRTUAL(env, java_io_DataInputStream, readFully$63e0ddb7f8315fc6, 0, r1, r10, 0, 2);
	r10 = _JC_REF_FIELD(env, r1, java_io_DataInputStream, buf);
	b8 = _JC_PRIM_ELEMENT(env, byte, r10, 0, 0, 1);
	s9 = b8 & 255;
	i10 = s9 << (8 & 0x1f);
	b8 = _JC_PRIM_ELEMENT(env, byte, r10, 1, 0, 1);
	s9 = b8 & 255;
	i10 = i10 | s9;
	_JC_LINE_NUMBER(46);				// 2
	_JC_PRIM_FIELD(env, r0, polyglot_types_reflect_Method, name) = i10;
	r11 = _JC_REF_FIELD(env, r1, java_io_DataInputStream, buf);
	_JC_INVOKE_NONVIRTUAL(env, java_io_DataInputStream, readFully$63e0ddb7f8315fc6, 0, r1, r11, 0, 2);
	r11 = _JC_REF_FIELD(env, r1, java_io_DataInputStream, buf);
	b11 = _JC_PRIM_ELEMENT(env, byte, r11, 0, 0, 1);
	s12 = b11 & 255;
	i13 = s12 << (8 & 0x1f);
	b11 = _JC_PRIM_ELEMENT(env, byte, r11, 1, 0, 1);
	s12 = b11 & 255;
	i13 = i13 | s12;
	_JC_LINE_NUMBER(47);				// 3
	_JC_PRIM_FIELD(env, r0, polyglot_types_reflect_Method, type) = i13;
	r12 = _JC_REF_FIELD(env, r1, java_io_DataInputStream, buf);
	_JC_INVOKE_NONVIRTUAL(env, java_io_DataInputStream, readFully$63e0ddb7f8315fc6, 0, r1, r12, 0, 2);
	r12 = _JC_REF_FIELD(env, r1, java_io_DataInputStream, buf);
	b14 = _JC_PRIM_ELEMENT(env, byte, r12, 0, 0, 1);
	s15 = b14 & 255;
	i16 = s15 << (8 & 0x1f);
	b14 = _JC_PRIM_ELEMENT(env, byte, r12, 1, 0, 1);
	s15 = b14 & 255;
	i16 = i16 | s15;
	i2 = i16;
	_JC_LINE_NUMBER(51);				// 4
	r4 = _JC_NEW_REF_ARRAY(env, polyglot_types_reflect_Attribute, 1, i16);
	_JC_REF_FIELD(env, r0, polyglot_types_reflect_Method, attrs) = r4;
	_JC_LINE_NUMBER(53);				// 5
	i0 = 0;

label0:
	if (i0 >= i2)
		goto label3;
	r13 = _JC_REF_FIELD(env, r1, java_io_DataInputStream, buf);
	_JC_INVOKE_NONVIRTUAL(env, java_io_DataInputStream, readFully$63e0ddb7f8315fc6, 0, r1, r13, 0, 2);
	r13 = _JC_REF_FIELD(env, r1, java_io_DataInputStream, buf);
	i3 = _JC_INVOKE_STATIC(env, java_io_DataInputStream, convertToUnsignedShort$3daa6058b01cd5e6, 1, r13);
	r14 = _JC_REF_FIELD(env, r1, java_io_DataInputStream, buf);
	_JC_INVOKE_NONVIRTUAL(env, java_io_DataInputStream, readFully$63e0ddb7f8315fc6, 0, r1, r14, 0, 4);
	r14 = _JC_REF_FIELD(env, r1, java_io_DataInputStream, buf);
	i4 = _JC_INVOKE_STATIC(env, java_io_DataInputStream, convertToInt$bcff18628bcbac61, 1, r14);
	_JC_LINE_NUMBER(57);				// 6
	r5 = _JC_REF_FIELD(env, r2, polyglot_types_reflect_ClassFile, constants);
	r3 = _JC_REF_ELEMENT(env, r5, i3, 1, 1);
	_JC_LINE_NUMBER(59);				// 7
	if (r3 == _JC_NULL)
		goto label1;
	r6 = _JC_STRING(env, "Exceptions");
	r8 = _JC_REF_FIELD(env, r3, polyglot_types_reflect_Constant, value);
	z0 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, equals$8a15e0625571c581, 0, r6, r8);
	if (z0 == 0)
		goto label1;
	_JC_LINE_NUMBER(60);				// 8
	r7 = _JC_NEW(env, polyglot_types_reflect_Exceptions);
	_JC_INVOKE_NONVIRTUAL(env, polyglot_types_reflect_Exceptions, _init$265bd2c7200cac08, 0, r7, r2, r1, i3, i4);
	_JC_REF_FIELD(env, r0, polyglot_types_reflect_Method, exceptions) = r7;
	_JC_LINE_NUMBER(61);				// 9
	r4 = _JC_REF_FIELD(env, r0, polyglot_types_reflect_Method, attrs);
	r7 = _JC_REF_FIELD(env, r0, polyglot_types_reflect_Method, exceptions);
	_JC_ARRAYSTORE_CHECK(env, r4, r7);
	_JC_REF_ELEMENT(env, r4, i0, 0, 1) = r7;
	goto label2;

label1:
	_JC_LINE_NUMBER(64);				// 10
	l1 = (jlong)i4;
	_JC_INVOKE_VIRTUAL(env, java_io_FilterInputStream, skip$4e431136b5c4614a, r1, l1);

label2:
	_JC_LINE_NUMBER(53);				// 11
	i0 = i0 + 1;
	_JC_PERIODIC_CHECK(env);
	goto label0;

label3:
	_JC_LINE_NUMBER(67);				// 12
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// polyglot.types.ConstructorInstance constructorInstance(polyglot.types.TypeSystem, polyglot.types.ClassType)
//

static _jc_linenum _jc_polyglot_types_reflect_Method$linenum_table$constructorInstance$dc6da5893b14e49d[];

static const unsigned char _jc_polyglot_types_reflect_Method$param_ptypes$constructorInstance$dc6da5893b14e49d[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_reflect_Method$param_types$constructorInstance$dc6da5893b14e49d[] = {
	&_jc_polyglot_types_TypeSystem$type,
	&_jc_polyglot_types_ClassType$type
};

_jc_method _jc_polyglot_types_reflect_Method$method_info$constructorInstance$dc6da5893b14e49d = {
	.name=			"constructorInstance",
	.signature=		"(Lpolyglot/types/TypeSystem;Lpolyglot/types/ClassType;)Lpolyglot/types/ConstructorInstance;",
	.class=			&_jc_polyglot_types_reflect_Method$type,
	.param_types=		&_jc_polyglot_types_reflect_Method$param_types$constructorInstance$dc6da5893b14e49d,
	.return_type=		&_jc_polyglot_types_ConstructorInstance$type,
	.param_ptypes=		&_jc_polyglot_types_reflect_Method$param_ptypes$constructorInstance$dc6da5893b14e49d,
	.signature_hash=	_JC_JLONG(0xdc6da5893b14e49d),
	.access_flags=		0,
	.function=		&_jc_polyglot_types_reflect_Method$method$constructorInstance$dc6da5893b14e49d,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_types_reflect_Method$vtable, polyglot_types_reflect_Method.constructorInstance$dc6da5893b14e49d) / sizeof(void *),
	.num_parameters=	2,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_polyglot_types_reflect_Method$linenum_table$constructorInstance$dc6da5893b14e49d
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_types_reflect_Method, constructorInstance$dc6da5893b14e49d);

_jc_object * _JC_JCNI_ATTR
_jc_polyglot_types_reflect_Method$method$constructorInstance$dc6da5893b14e49d(_jc_env *const env, _jc_polyglot_types_reflect_Method$object *this, _jc_object *param0, _jc_object *param1)
{
	struct _jc_polyglot_types_reflect_Method$object *r0;
	struct _jc_object *r1;
	struct _jc_object *r2;
	struct _jc_object *r3;
	struct _jc_polyglot_util_Position$object *r4;
	struct _jc_polyglot_types_Flags$object *r5;
	struct _jc_object *r6;
	struct _jc_object *r7;
	struct _jc_object *r8;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_LINE_NUMBER(102);				// 0
	r3 = _JC_INVOKE_VIRTUAL(env, polyglot_types_reflect_Method, methodInstance$229af93934f7bca6, r0, r1, r2);
	_JC_LINE_NUMBER(103);				// 1
	r4 = _JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0xbb89333b1e4c840c), _jc_object *, (_jc_env *, struct _jc_object *));
	r5 = _JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0xbdfb01ac8f620c5e), _jc_object *, (_jc_env *, struct _jc_object *));
	r6 = _JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0x6f0aa0e3b93c141a), _jc_object *, (_jc_env *, struct _jc_object *));
	r7 = _JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0x19d4055fb505052c), _jc_object *, (_jc_env *, struct _jc_object *));
	r8 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0x7684c1b47d4498f7), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_polyglot_util_Position$object *, struct _jc_object *, struct _jc_polyglot_types_Flags$object *, struct _jc_object *, struct _jc_object *), r4, r2, r5, r6, r7);
	return r8;
}

//
// polyglot.types.MethodInstance methodInstance(polyglot.types.TypeSystem, polyglot.types.ClassType)
//

static _jc_linenum _jc_polyglot_types_reflect_Method$linenum_table$methodInstance$229af93934f7bca6[];

static const unsigned char _jc_polyglot_types_reflect_Method$param_ptypes$methodInstance$229af93934f7bca6[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_types_reflect_Method$param_types$methodInstance$229af93934f7bca6[] = {
	&_jc_polyglot_types_TypeSystem$type,
	&_jc_polyglot_types_ClassType$type
};

_jc_method _jc_polyglot_types_reflect_Method$method_info$methodInstance$229af93934f7bca6 = {
	.name=			"methodInstance",
	.signature=		"(Lpolyglot/types/TypeSystem;Lpolyglot/types/ClassType;)Lpolyglot/types/MethodInstance;",
	.class=			&_jc_polyglot_types_reflect_Method$type,
	.param_types=		&_jc_polyglot_types_reflect_Method$param_types$methodInstance$229af93934f7bca6,
	.return_type=		&_jc_polyglot_types_MethodInstance$type,
	.param_ptypes=		&_jc_polyglot_types_reflect_Method$param_ptypes$methodInstance$229af93934f7bca6,
	.signature_hash=	_JC_JLONG(0x229af93934f7bca6),
	.access_flags=		0,
	.function=		&_jc_polyglot_types_reflect_Method$method$methodInstance$229af93934f7bca6,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_types_reflect_Method$vtable, polyglot_types_reflect_Method.methodInstance$229af93934f7bca6) / sizeof(void *),
	.num_parameters=	2,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	14,
	      .table=	_jc_polyglot_types_reflect_Method$linenum_table$methodInstance$229af93934f7bca6
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_types_reflect_Method, methodInstance$229af93934f7bca6);

_jc_object * _JC_JCNI_ATTR
_jc_polyglot_types_reflect_Method$method$methodInstance$229af93934f7bca6(_jc_env *const env, _jc_polyglot_types_reflect_Method$object *this, _jc_object *param0, _jc_object *param1)
{
	jchar c4;
	jint i0;
	jint i1;
	jint i2;
	jint i3;
	jint i5;
	struct _jc_polyglot_types_reflect_Method$object *r0;
	struct _jc_object *r1;
	struct _jc_polyglot_types_reflect_Constant$object *r10;
	struct _jc_java_lang_ClassFormatError$object *r11;
	struct _jc_java_lang_String$object *r12;
	struct _jc_polyglot_types_reflect_Exceptions$object *r13;
	_jc_int_array *r14;
	struct _jc_object *r15;
	struct _jc_polyglot_util_Position$object *r16;
	struct _jc_polyglot_types_Flags$object *r17;
	struct _jc_object *r18;
	struct _jc_java_lang_Object$object *r19;
	struct _jc_object *r2;
	struct _jc_java_lang_Object$object *r20;
	struct _jc_java_lang_String$object *r21;
	struct _jc_java_lang_String$object *r22;
	struct _jc_java_lang_VMThrowable$object *r23;
	_jc_object_array *r24;
	struct _jc_java_lang_StringIndexOutOfBoundsException$object *r25;
	_jc_char_array *r26;
	struct _jc_java_lang_StringBuffer$object *r27;
	struct _jc_java_lang_StringBuffer$object *r28;
	struct _jc_java_lang_String$object *r29;
	struct _jc_java_lang_String$object *r3;
	struct _jc_java_lang_String$object *r30;
	struct _jc_java_lang_VMThrowable$object *r31;
	struct _jc_java_lang_String$object *r32;
	_jc_char_array *r33;
	struct _jc_java_lang_String$object *r4;
	struct _jc_object *r5;
	struct _jc_object *r6;
	struct _jc_java_util_ArrayList$object *r7;
	struct _jc_polyglot_types_reflect_ClassFile$object *r8;
	_jc_object_array *r9;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_LINE_NUMBER(74);				// 0
	r8 = _JC_REF_FIELD(env, r0, polyglot_types_reflect_Method, clazz);
	r9 = _JC_REF_FIELD(env, r8, polyglot_types_reflect_ClassFile, constants);
	i0 = _JC_PRIM_FIELD(env, r0, polyglot_types_reflect_Method, name);
	r10 = _JC_REF_ELEMENT(env, r9, i0, 1, 1);
	_JC_EXPLICIT_NULL_CHECK(env, r10);
	r19 = _JC_REF_FIELD(env, r10, polyglot_types_reflect_Constant, value);
	r3 = _JC_CAST_FINAL(env, &_jc_java_lang_String$type, r19);
	_JC_LINE_NUMBER(75);				// 1
	r8 = _JC_REF_FIELD(env, r0, polyglot_types_reflect_Method, clazz);
	r9 = _JC_REF_FIELD(env, r8, polyglot_types_reflect_ClassFile, constants);
	i0 = _JC_PRIM_FIELD(env, r0, polyglot_types_reflect_Method, type);
	r10 = _JC_REF_ELEMENT(env, r9, i0, 1, 1);
	_JC_EXPLICIT_NULL_CHECK(env, r10);
	r20 = _JC_REF_FIELD(env, r10, polyglot_types_reflect_Constant, value);
	r4 = _JC_CAST_FINAL(env, &_jc_java_lang_String$type, r20);
	_JC_EXPLICIT_NULL_CHECK(env, r4);
	i3 = _JC_PRIM_FIELD(env, r4, java_lang_String, count);
	if (0 < i3)
		goto label0;
	r25 = _JC_NEW(env, java_lang_StringIndexOutOfBoundsException);
	r27 = _JC_NEW(env, java_lang_StringBuffer);
	r32 = _JC_STRING(env, "String index out of range: ");
	i5 = _JC_PRIM_FIELD(env, r32, java_lang_String, count);
	_JC_PRIM_FIELD(env, r27, java_lang_StringBuffer, count) = i5;
	i5 = _JC_PRIM_FIELD(env, r27, java_lang_StringBuffer, count);
	i5 = i5 + 16;
	r33 = _JC_NEW_PRIM_ARRAY(env, char, 1, i5);
	_JC_REF_FIELD(env, r27, java_lang_StringBuffer, value) = r33;
	i5 = _JC_PRIM_FIELD(env, r27, java_lang_StringBuffer, count);
	r33 = _JC_REF_FIELD(env, r27, java_lang_StringBuffer, value);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, getChars$c684dea7317ff063, 0, r32, 0, i5, r33, 0);
	r29 = _JC_INVOKE_STATIC(env, java_lang_Integer, toString$80d919d12afaaa2b, 0, 0, 10);
	r28 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r27, r29);
	_JC_EXPLICIT_NULL_CHECK(env, r28);
	r30 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r30, r28);
	_JC_REF_FIELD(env, r25, java_lang_Throwable, cause) = r25;
	r31 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r25);
	_JC_REF_FIELD(env, r25, java_lang_Throwable, vmState) = r31;
	_JC_REF_FIELD(env, r25, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r25, java_lang_Throwable, detailMessage) = r30;
	_JC_THROW(env, r25);

label0:
	r26 = _JC_REF_FIELD(env, r4, java_lang_String, value);
	i3 = _JC_PRIM_FIELD(env, r4, java_lang_String, offset);
	i3 = i3 + 0;
	c4 = _JC_PRIM_ELEMENT(env, char, r26, i3, 1, 1);
	_JC_LINE_NUMBER(77);				// 2
	if (c4 == 40)
		goto label1;
	_JC_LINE_NUMBER(78);				// 3
	r11 = _JC_NEW(env, java_lang_ClassFormatError);
	r21 = _JC_STRING(env, "Bad method type descriptor.");
	_JC_REF_FIELD(env, r11, java_lang_Throwable, cause) = r11;
	r23 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r11);
	_JC_REF_FIELD(env, r11, java_lang_Throwable, vmState) = r23;
	_JC_REF_FIELD(env, r11, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r11, java_lang_Throwable, detailMessage) = r21;
	_JC_THROW(env, r11);

label1:
	_JC_LINE_NUMBER(81);				// 4
	i0 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, indexOf$6ec5a1241e692e35, 0, r4, 41, 1);
	_JC_LINE_NUMBER(82);				// 5
	r8 = _JC_REF_FIELD(env, r0, polyglot_types_reflect_Method, clazz);
	r12 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, substring$df0d95f5ebfea7dc, 0, r4, 1, i0);
	r5 = _JC_INVOKE_VIRTUAL(env, polyglot_types_reflect_ClassFile, typeListForString$ba0d4bddef1b3f07, r8, r1, r12);
	_JC_LINE_NUMBER(83);				// 6
	r8 = _JC_REF_FIELD(env, r0, polyglot_types_reflect_Method, clazz);
	i0 = i0 + 1;
	i2 = _JC_PRIM_FIELD(env, r4, java_lang_String, count);
	r22 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, substring$df0d95f5ebfea7dc, 0, r4, i0, i2);
	r6 = _JC_INVOKE_VIRTUAL(env, polyglot_types_reflect_ClassFile, typeForString$43445b1efe4eb593, r8, r1, r22);
	_JC_LINE_NUMBER(85);				// 7
	r7 = _JC_NEW(env, java_util_ArrayList);
	r24 = _JC_NEW_REF_ARRAY(env, java_lang_Object, 1, 16);
	_JC_REF_FIELD(env, r7, java_util_ArrayList, data) = r24;
	_JC_LINE_NUMBER(87);				// 8
	r13 = _JC_REF_FIELD(env, r0, polyglot_types_reflect_Method, exceptions);
	if (r13 == _JC_NULL)
		goto label3;
	_JC_LINE_NUMBER(88);				// 9
	i0 = 0;

label2:
	r13 = _JC_REF_FIELD(env, r0, polyglot_types_reflect_Method, exceptions);
	r14 = _JC_REF_FIELD(env, r13, polyglot_types_reflect_Exceptions, exceptions);
	i1 = _JC_ARRAY_LENGTH(env, r14);
	if (i0 >= i1)
		goto label3;
	_JC_LINE_NUMBER(89);				// 10
	r8 = _JC_REF_FIELD(env, r0, polyglot_types_reflect_Method, clazz);
	r13 = _JC_REF_FIELD(env, r0, polyglot_types_reflect_Method, exceptions);
	r14 = _JC_REF_FIELD(env, r13, polyglot_types_reflect_Exceptions, exceptions);
	i1 = _JC_PRIM_ELEMENT(env, int, r14, i0, 0, 1);
	r4 = _JC_INVOKE_VIRTUAL(env, polyglot_types_reflect_ClassFile, classNameCP$87f430f1f0e1a43c, r8, i1);
	_JC_LINE_NUMBER(90);				// 11
	r8 = _JC_REF_FIELD(env, r0, polyglot_types_reflect_Method, clazz);
	r15 = _JC_INVOKE_VIRTUAL(env, polyglot_types_reflect_ClassFile, typeForName$019e484d30e082d1, r8, r1, r4);
	_JC_INVOKE_NONVIRTUAL(env, java_util_ArrayList, add$831f06ee5f59c0cc, 0, r7, r15);
	_JC_LINE_NUMBER(88);				// 12
	i0 = i0 + 1;
	_JC_PERIODIC_CHECK(env);
	goto label2;

label3:
	_JC_LINE_NUMBER(94);				// 13
	r16 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0xbb89333b1e4c840c), _jc_object *, (_jc_env *, struct _jc_object *));
	i1 = _JC_PRIM_FIELD(env, r0, polyglot_types_reflect_Method, modifiers);
	r17 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0x62f24019375a1a4f), _jc_object *, (_jc_env *, struct _jc_object *, jint), i1);
	r18 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0x929942af4f3ecf0b), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_polyglot_util_Position$object *, struct _jc_object *, struct _jc_polyglot_types_Flags$object *, struct _jc_object *, struct _jc_java_lang_String$object *, struct _jc_object *, struct _jc_object *), r16, r2, r17, r6, r3, r5, r7);
	return r18;
}

//
// java.lang.String name()
//

static _jc_linenum _jc_polyglot_types_reflect_Method$linenum_table$name$e6acce026cadf81e[];

static const unsigned char _jc_polyglot_types_reflect_Method$param_ptypes$name$e6acce026cadf81e[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_types_reflect_Method$method_info$name$e6acce026cadf81e = {
	.name=			"name",
	.signature=		"()Ljava/lang/String;",
	.class=			&_jc_polyglot_types_reflect_Method$type,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_polyglot_types_reflect_Method$param_ptypes$name$e6acce026cadf81e,
	.signature_hash=	_JC_JLONG(0xe6acce026cadf81e),
	.access_flags=		0,
	.function=		&_jc_polyglot_types_reflect_Method$method$name$e6acce026cadf81e,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_types_reflect_Method$vtable, polyglot_types_reflect_Method.name$e6acce026cadf81e) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_types_reflect_Method$linenum_table$name$e6acce026cadf81e
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_types_reflect_Method, name$e6acce026cadf81e);

_jc_java_lang_String$object * _JC_JCNI_ATTR
_jc_polyglot_types_reflect_Method$method$name$e6acce026cadf81e(_jc_env *const env, _jc_polyglot_types_reflect_Method$object *this)
{
	jint i0;
	struct _jc_polyglot_types_reflect_Method$object *r0;
	struct _jc_polyglot_types_reflect_ClassFile$object *r1;
	_jc_object_array *r2;
	struct _jc_polyglot_types_reflect_Constant$object *r3;
	struct _jc_java_lang_String$object *r5;
	struct _jc_java_lang_Object$object *r7;

	r0 = this;
	_JC_LINE_NUMBER(70);				// 0
	r1 = _JC_REF_FIELD(env, r0, polyglot_types_reflect_Method, clazz);
	r2 = _JC_REF_FIELD(env, r1, polyglot_types_reflect_ClassFile, constants);
	i0 = _JC_PRIM_FIELD(env, r0, polyglot_types_reflect_Method, name);
	r3 = _JC_REF_ELEMENT(env, r2, i0, 1, 1);
	_JC_EXPLICIT_NULL_CHECK(env, r3);
	r7 = _JC_REF_FIELD(env, r3, polyglot_types_reflect_Constant, value);
	r5 = _JC_CAST_FINAL(env, &_jc_java_lang_String$type, r7);
	return r5;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_polyglot_types_reflect_Method$methods[] = {
	&_jc_polyglot_types_reflect_Method$method_info$_init$b1ea5c53786ab2c1,
	&_jc_polyglot_types_reflect_Method$method_info$constructorInstance$dc6da5893b14e49d,
	&_jc_polyglot_types_reflect_Method$method_info$methodInstance$229af93934f7bca6,
	&_jc_polyglot_types_reflect_Method$method_info$name$e6acce026cadf81e
};

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_polyglot_types_reflect_Method$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_types_reflect_Method$instanceof_hash_bucket_121[] = {
	&_jc_polyglot_types_reflect_Method$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_polyglot_types_reflect_Method$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[101]=	_jc_polyglot_types_reflect_Method$instanceof_hash_bucket_101,
	[121]=	_jc_polyglot_types_reflect_Method$instanceof_hash_bucket_121
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_polyglot_types_reflect_Method$class_depends[] = {
	{ "java/io/DataInputStream",	_JC_JLONG(0xcc3ce5b592e8a1d) },
	{ "java/io/FilterInputStream",	_JC_JLONG(0x455accfa535f5dfe) },
	{ "java/io/IOException",	_JC_JLONG(0x4e0a56550c69d57c) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/ClassFormatError",	_JC_JLONG(0xc933004fd5a6148) },
	{ "java/lang/Error",	_JC_JLONG(0x308333d803f5ab9f) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/IndexOutOfBoundsException",	_JC_JLONG(0x3cdfed1e0ad1a3d6) },
	{ "java/lang/Integer",	_JC_JLONG(0xca631501391a31f1) },
	{ "java/lang/LinkageError",	_JC_JLONG(0x3746e17e005bda9e) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/RuntimeException",	_JC_JLONG(0x4f5534a987354d1d) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/StringBuffer",	_JC_JLONG(0x94d357637b968dda) },
	{ "java/lang/StringIndexOutOfBoundsException",	_JC_JLONG(0xbb7f6fdd2bd0e6b2) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/util/AbstractCollection",	_JC_JLONG(0x8ea716c64b77f8eb) },
	{ "java/util/AbstractList",	_JC_JLONG(0xf5238436362828db) },
	{ "java/util/ArrayList",	_JC_JLONG(0x58038509830ef3f4) },
	{ "java/util/List",	_JC_JLONG(0x9ee0d92ce1525a4d) },
	{ "polyglot/types/ClassType",	_JC_JLONG(0xb38560af658974f8) },
	{ "polyglot/types/ConstructorInstance",	_JC_JLONG(0xfc9c35c3fb8d6af7) },
	{ "polyglot/types/Flags",	_JC_JLONG(0x821eb65d8f2f30f6) },
	{ "polyglot/types/MethodInstance",	_JC_JLONG(0xab0fa5f3ef02c9ee) },
	{ "polyglot/types/Type",	_JC_JLONG(0x6596051546781098) },
	{ "polyglot/types/TypeSystem",	_JC_JLONG(0xed171cdaca38ec28) },
	{ "polyglot/types/reflect/Attribute",	_JC_JLONG(0xd931fb91b452174) },
	{ "polyglot/types/reflect/ClassFile",	_JC_JLONG(0xf394a649a5830bb) },
	{ "polyglot/types/reflect/Constant",	_JC_JLONG(0x209b8df6d16abcfb) },
	{ "polyglot/types/reflect/Exceptions",	_JC_JLONG(0xa0635b021c46faf6) },
	{ "polyglot/util/Position",	_JC_JLONG(0x32c9a088c5dac046) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_polyglot_types_reflect_Method$vtype _jc_polyglot_types_reflect_Method$type = {
    .type= {
	.name=			"polyglot/types/reflect/Method",
	.superclass=		&_jc_java_lang_Object$type,
	.access_flags=		0,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		14,
		.hash=			_JC_JLONG(0x78cd51360123a1f9),
		.source_file=		"Method.java",
		.instance_size=		sizeof(_jc_polyglot_types_reflect_Method$refs) + sizeof(_jc_polyglot_types_reflect_Method$object),
		.num_virtual_refs=	3,
		.num_fields=		sizeof(_jc_polyglot_types_reflect_Method$fields) / sizeof(*_jc_polyglot_types_reflect_Method$fields),
		.fields=		_jc_polyglot_types_reflect_Method$fields,
		.num_methods=		sizeof(_jc_polyglot_types_reflect_Method$methods) / sizeof(*_jc_polyglot_types_reflect_Method$methods),
		.methods=		_jc_polyglot_types_reflect_Method$methods,
		.instanceof_hash_table=	_jc_polyglot_types_reflect_Method$instanceof_hash_table,
		.num_class_depends=		sizeof(_jc_polyglot_types_reflect_Method$class_depends) / sizeof(*_jc_polyglot_types_reflect_Method$class_depends),
		.class_depends=		_jc_polyglot_types_reflect_Method$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.polyglot_types_reflect_Method= {
	    .constructorInstance$dc6da5893b14e49d=
		&_jc_polyglot_types_reflect_Method$method$constructorInstance$dc6da5893b14e49d,
	    .methodInstance$229af93934f7bca6=
		&_jc_polyglot_types_reflect_Method$method$methodInstance$229af93934f7bca6,
	    .name$e6acce026cadf81e=
		&_jc_polyglot_types_reflect_Method$method$name$e6acce026cadf81e,
	},
    }
};

