// public class polyglot.util.TypeEncoder

// class file dependencies
// @dep_class a68cc27886fd8be3 java_io_ByteArrayInputStream
// @dep_class c4d3cc2bda03a338 java_io_ByteArrayOutputStream
// @dep_class d755b96203d8fbaf java_io_DataOutputStream
// @dep_class fddb41323d9c4cee java_io_FilterOutputStream
// @dep_class 4e0a56550c69d57c java_io_IOException
// @dep_class eb60cf59bc393752 java_io_InvalidClassException
// @dep_class c0cf85234045e123 java_io_ObjectInputStream
// @dep_class 75762bf0985d508e java_io_ObjectOutputStream
// @dep_class 4026d3144d6654d8 java_io_OutputStream
// @dep_class 99a46305ebacacb5 java_io_PrintStream
// @dep_class f3b2acfda592b4df java_io_SerializablePermission
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class 1f925cf50bfc0d6c java_lang_ClassNotFoundException
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class ca631501391a31f1 java_lang_Integer
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class 4f5534a987354d1d java_lang_RuntimeException
// @dep_class d38282f3d5f80887 java_lang_SecurityManager
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 94d357637b968dda java_lang_StringBuffer
// @dep_class 53cc8e2333795f04 java_lang_System
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class 8ea716c64b77f8eb java_util_AbstractCollection
// @dep_class f5238436362828db java_util_AbstractList
// @dep_class 9574af3fed58029a java_util_Collections
// @dep_class 2ccd076083da6c8e java_util_Collections__24SingletonList
// @dep_class d7cd853200c3e71f java_util_HashMap
// @dep_class d31dc884497a5da2 java_util_zip_CRC32
// @dep_class c51bfb23c49b4e67 java_util_zip_GZIPInputStream
// @dep_class 5a888c733ac5af5d java_util_zip_GZIPOutputStream
// @dep_class 4df3e1cb79f6b935 java_util_zip_Inflater
// @dep_class 5602700a47802920 java_util_zip_InflaterInputStream
// @dep_class cf9f146bdb7bc44d polyglot_main_Report
// @dep_class 6596051546781098 polyglot_types_Type
// @dep_class ed171cdaca38ec28 polyglot_types_TypeSystem
// @dep_class b6f081692ba67eb4 polyglot_util_Base64
// @dep_class 22b321d488641c54 polyglot_util_InternalCompilerError
// @dep_class 32c9a088c5dac046 polyglot_util_Position
// @dep_class f299688fad53c0b2 polyglot_util_TypeEncoder
// @dep_class a972375aaa3e5415 polyglot_util_TypeInputStream
// @dep_class 705e5da5ef1a1275 polyglot_util_TypeOutputStream

// header file dependencies
// @dep_header java_io_ByteArrayInputStream
// @dep_header java_io_ByteArrayOutputStream
// @dep_header java_io_DataOutputStream
// @dep_header java_io_InvalidClassException
// @dep_header java_io_PrintStream
// @dep_header java_io_SerializablePermission
// @dep_header java_lang_Class
// @dep_header java_lang_ClassNotFoundException
// @dep_header java_lang_Integer
// @dep_header java_lang_SecurityManager
// @dep_header java_lang_String
// @dep_header java_lang_StringBuffer
// @dep_header java_lang_System
// @dep_header java_lang_VMThrowable
// @dep_header java_util_Collections
// @dep_header java_util_Collections__24SingletonList
// @dep_header java_util_HashMap
// @dep_header java_util_zip_CRC32
// @dep_header java_util_zip_GZIPInputStream
// @dep_header java_util_zip_GZIPOutputStream
// @dep_header java_util_zip_Inflater
// @dep_header polyglot_main_Report
// @dep_header polyglot_types_Type
// @dep_header polyglot_types_TypeSystem
// @dep_header polyglot_util_Base64
// @dep_header polyglot_util_InternalCompilerError
// @dep_header polyglot_util_Position
// @dep_header polyglot_util_TypeEncoder
// @dep_header polyglot_util_TypeInputStream
// @dep_header polyglot_util_TypeOutputStream

#include "jc_defs.h"

#include "java/io/ByteArrayInputStream.h"
#include "java/io/ByteArrayOutputStream.h"
#include "java/io/DataOutputStream.h"
#include "java/io/InvalidClassException.h"
#include "java/io/PrintStream.h"
#include "java/io/SerializablePermission.h"
#include "java/lang/Class.h"
#include "java/lang/ClassNotFoundException.h"
#include "java/lang/Integer.h"
#include "java/lang/SecurityManager.h"
#include "java/lang/String.h"
#include "java/lang/StringBuffer.h"
#include "java/lang/System.h"
#include "java/lang/VMThrowable.h"
#include "java/util/Collections.h"
#include "java/util/Collections__24SingletonList.h"
#include "java/util/HashMap.h"
#include "java/util/zip/CRC32.h"
#include "java/util/zip/GZIPInputStream.h"
#include "java/util/zip/GZIPOutputStream.h"
#include "java/util/zip/Inflater.h"
#include "polyglot/main/Report.h"
#include "polyglot/types/Type.h"
#include "polyglot/types/TypeSystem.h"
#include "polyglot/util/Base64.h"
#include "polyglot/util/InternalCompilerError.h"
#include "polyglot/util/Position.h"
#include "polyglot/util/TypeEncoder.h"
#include "polyglot/util/TypeInputStream.h"
#include "polyglot/util/TypeOutputStream.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// protected polyglot.types.TypeSystem ts
static _jc_field _jc_polyglot_util_TypeEncoder$field_info$ts = {
	.name=		"ts",
	.signature=	"Lpolyglot/types/TypeSystem;",
	.class=		&_jc_polyglot_util_TypeEncoder$type,
	.type=		&_jc_polyglot_types_TypeSystem$type,
	.access_flags=	_JC_ACC_PROTECTED,
	.offset=	_JC_OFFSETOF(_jc_polyglot_util_TypeEncoder$object, refs[-1].polyglot_util_TypeEncoder.ts),
};

// protected final boolean zip
static _jc_field _jc_polyglot_util_TypeEncoder$field_info$zip = {
	.name=		"zip",
	.signature=	"Z",
	.class=		&_jc_polyglot_util_TypeEncoder$type,
	.type=		&_jc_boolean$prim$type,
	.access_flags=	_JC_ACC_PROTECTED|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_polyglot_util_TypeEncoder$object, nonrefs.polyglot_util_TypeEncoder.zip),
};

// protected final boolean base64
static _jc_field _jc_polyglot_util_TypeEncoder$field_info$base64 = {
	.name=		"base64",
	.signature=	"Z",
	.class=		&_jc_polyglot_util_TypeEncoder$type,
	.type=		&_jc_boolean$prim$type,
	.access_flags=	_JC_ACC_PROTECTED|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_polyglot_util_TypeEncoder$object, nonrefs.polyglot_util_TypeEncoder.base64),
};

// protected final boolean test
static _jc_field _jc_polyglot_util_TypeEncoder$field_info$test = {
	.name=		"test",
	.signature=	"Z",
	.class=		&_jc_polyglot_util_TypeEncoder$type,
	.type=		&_jc_boolean$prim$type,
	.access_flags=	_JC_ACC_PROTECTED|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_polyglot_util_TypeEncoder$object, nonrefs.polyglot_util_TypeEncoder.test),
};

// Fields
static _jc_field *const _jc_polyglot_util_TypeEncoder$fields[] = {
	&_jc_polyglot_util_TypeEncoder$field_info$ts,
	&_jc_polyglot_util_TypeEncoder$field_info$base64,
	&_jc_polyglot_util_TypeEncoder$field_info$test,
	&_jc_polyglot_util_TypeEncoder$field_info$zip
};

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// public void <init>(polyglot.types.TypeSystem)
//

static _jc_linenum _jc_polyglot_util_TypeEncoder$linenum_table$_init$964314195388e7c0[];

static const unsigned char _jc_polyglot_util_TypeEncoder$param_ptypes$_init$964314195388e7c0[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_util_TypeEncoder$param_types$_init$964314195388e7c0[] = {
	&_jc_polyglot_types_TypeSystem$type
};

_jc_method _jc_polyglot_util_TypeEncoder$method_info$_init$964314195388e7c0 = {
	.name=			"<init>",
	.signature=		"(Lpolyglot/types/TypeSystem;)V",
	.class=			&_jc_polyglot_util_TypeEncoder$type,
	.param_types=		&_jc_polyglot_util_TypeEncoder$param_types$_init$964314195388e7c0,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_util_TypeEncoder$param_ptypes$_init$964314195388e7c0,
	.signature_hash=	_JC_JLONG(0x964314195388e7c0),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_util_TypeEncoder$method$_init$964314195388e7c0,
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_polyglot_util_TypeEncoder$linenum_table$_init$964314195388e7c0
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_util_TypeEncoder, _init$964314195388e7c0);

void _JC_JCNI_ATTR
_jc_polyglot_util_TypeEncoder$method$_init$964314195388e7c0(_jc_env *const env, _jc_polyglot_util_TypeEncoder$object *this, _jc_object *param0)
{
	struct _jc_polyglot_util_TypeEncoder$object *r0;
	struct _jc_object *r1;

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(27);				// 0
	_JC_PRIM_FIELD(env, r0, polyglot_util_TypeEncoder, zip) = 1;
	_JC_LINE_NUMBER(28);				// 1
	_JC_PRIM_FIELD(env, r0, polyglot_util_TypeEncoder, base64) = 1;
	_JC_LINE_NUMBER(29);				// 2
	_JC_PRIM_FIELD(env, r0, polyglot_util_TypeEncoder, test) = 0;
	_JC_LINE_NUMBER(33);				// 3
	_JC_REF_FIELD(env, r0, polyglot_util_TypeEncoder, ts) = r1;
	_JC_LINE_NUMBER(34);				// 4
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public polyglot.types.Type decode(java.lang.String) throws java.io.InvalidClassException
//

static _jc_linenum _jc_polyglot_util_TypeEncoder$linenum_table$decode$8383d57b54a9bd76[];

static _jc_trap_info _jc_polyglot_util_TypeEncoder$trap_table$decode$8383d57b54a9bd76[] = {
	_JC_TRAP(&_jc_java_io_InvalidClassException$type, 1, 2),
	_JC_TRAP(&_jc_java_io_IOException$type, 1, 2),
	_JC_TRAP(&_jc_java_lang_ClassNotFoundException$type, 1, 2),
};

static const unsigned char _jc_polyglot_util_TypeEncoder$param_ptypes$decode$8383d57b54a9bd76[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_util_TypeEncoder$exceptions$decode$8383d57b54a9bd76[] = {
	&_jc_java_io_InvalidClassException$type
};

static _jc_type *const _jc_polyglot_util_TypeEncoder$param_types$decode$8383d57b54a9bd76[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_polyglot_util_TypeEncoder$method_info$decode$8383d57b54a9bd76 = {
	.name=			"decode",
	.signature=		"(Ljava/lang/String;)Lpolyglot/types/Type;",
	.class=			&_jc_polyglot_util_TypeEncoder$type,
	.param_types=		&_jc_polyglot_util_TypeEncoder$param_types$decode$8383d57b54a9bd76,
	.return_type=		&_jc_polyglot_types_Type$type,
	.param_ptypes=		&_jc_polyglot_util_TypeEncoder$param_ptypes$decode$8383d57b54a9bd76,
	.signature_hash=	_JC_JLONG(0x8383d57b54a9bd76),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_util_TypeEncoder$method$decode$8383d57b54a9bd76,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_util_TypeEncoder$vtable, polyglot_util_TypeEncoder.decode$8383d57b54a9bd76) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_util_TypeEncoder$exceptions$decode$8383d57b54a9bd76,
	.u= { .exec= {
	  .trap_table_len=	3,
	  .trap_table=		_jc_polyglot_util_TypeEncoder$trap_table$decode$8383d57b54a9bd76,
	  .u= {
	    .linenum= {
	      .len=	6,
	      .table=	_jc_polyglot_util_TypeEncoder$linenum_table$decode$8383d57b54a9bd76
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_util_TypeEncoder, decode$8383d57b54a9bd76);

_jc_object * _JC_JCNI_ATTR
_jc_polyglot_util_TypeEncoder$method$decode$8383d57b54a9bd76(_jc_env *const env, _jc_polyglot_util_TypeEncoder$object *this, _jc_java_lang_String$object *param0)
{
	jint i0;
	struct _jc_polyglot_util_TypeEncoder$object *r0;
	struct _jc_java_lang_String$object *volatile r1;
	struct _jc_object *r10;
	struct _jc_java_io_IOException$object *volatile r11;
	struct _jc_polyglot_util_InternalCompilerError$object *volatile r12;
	struct _jc_java_lang_StringBuffer$object *volatile r13;
	struct _jc_java_lang_ClassNotFoundException$object *volatile r14;
	struct _jc_java_lang_String$object *volatile r15;
	struct _jc_polyglot_util_Position$object *volatile r16;
	struct _jc_java_lang_String$object *volatile r17;
	struct _jc_polyglot_util_Position$object *volatile r18;
	_jc_char_array *volatile r19;
	_jc_byte_array *r2;
	_jc_char_array *volatile r20;
	struct _jc_java_lang_VMThrowable$object *volatile r21;
	struct _jc_java_lang_VMThrowable$object *volatile r22;
	struct _jc_java_util_HashMap$object *r23;
	struct _jc_java_util_zip_Inflater$object *r24;
	struct _jc_java_util_zip_CRC32$object *r25;
	struct _jc_java_io_SerializablePermission$object *r26;
	struct _jc_java_lang_SecurityManager$object *r27;
	struct _jc_java_lang_String$object *r29;
	struct _jc_java_util_zip_GZIPInputStream$object *r3;
	struct _jc_java_io_ByteArrayInputStream$object *r4;
	struct _jc_polyglot_util_TypeInputStream$object *r5;
	struct _jc_java_io_InvalidClassException$object *volatile r6;
	_jc_char_array *r7;
	struct _jc_object *r8;
	struct _jc_java_lang_Object$object *r9;
	jboolean z0;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_polyglot_util_TypeEncoder$method_info$decode$8383d57b54a9bd76, &&label1, &&label2, &&label3);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(102);				// 0
	r7 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, toCharArray$3b7296c2ffa2db79, 1, r1);
	r2 = _JC_INVOKE_STATIC(env, polyglot_util_Base64, decode$01e9cb82d83e32e6, 0, r7);
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(114);				// 1
	r5 = _JC_NEW(env, polyglot_util_TypeInputStream);
	r3 = _JC_NEW(env, java_util_zip_GZIPInputStream);
	r4 = _JC_NEW(env, java_io_ByteArrayInputStream);
	i0 = _JC_ARRAY_LENGTH(env, r2);
	_JC_INVOKE_NONVIRTUAL(env, java_io_ByteArrayInputStream, _init$4ff4a7925ef7b06c, 0, r4, r2, 0, i0);
	r24 = _JC_NEW(env, java_util_zip_Inflater);
	_JC_INVOKE_NONVIRTUAL(env, java_util_zip_Inflater, _init$f0a6314ff7de5110, 0, r24, 1);
	_JC_INVOKE_NONVIRTUAL(env, java_util_zip_InflaterInputStream, _init$c297c4a8a618e86d, 0, r3, r4, r24, 4096);
	r25 = _JC_NEW(env, java_util_zip_CRC32);
	_JC_PRIM_FIELD(env, r25, java_util_zip_CRC32, crc) = 0;
	_JC_REF_FIELD(env, r3, java_util_zip_GZIPInputStream, crc) = r25;
	_JC_INVOKE_NONVIRTUAL(env, java_util_zip_GZIPInputStream, readHeader$315d703f8609c43e, 0, r3);
	r8 = _JC_REF_FIELD(env, r0, polyglot_util_TypeEncoder, ts);
	_JC_INVOKE_NONVIRTUAL(env, java_io_ObjectInputStream, _init$3887600c17c5e554, 0, r5, r3);
	_JC_ACTIVE_USE(env, java_lang_System);
	r27 = _JC_STATIC_FIELD(env, java_lang_SecurityManager, current, 0);
	if (r27 == _JC_NULL)
		goto label0;
	r26 = _JC_NEW(env, java_io_SerializablePermission);
	r29 = _JC_STRING(env, "enableSubstitution");
	_JC_INVOKE_NONVIRTUAL(env, java_io_SerializablePermission, _init$a34354cd9552963f, 0, r26, r29, _JC_NULL);
	_JC_INVOKE_VIRTUAL(env, java_lang_SecurityManager, checkPermission$c9030844da652e90, r27, r26);

label0:
	z0 = _JC_PRIM_FIELD(env, r5, java_io_ObjectInputStream, resolveEnabled);
	_JC_PRIM_FIELD(env, r5, java_io_ObjectInputStream, resolveEnabled) = 1;
	_JC_REF_FIELD(env, r5, polyglot_util_TypeInputStream, ts) = r8;
	r23 = _JC_NEW(env, java_util_HashMap);
	_JC_INVOKE_NONVIRTUAL(env, java_util_HashMap, _init$7cb044ce4fb0ada8, 0, r23, 11, _JC_FCONST(0x3f, 0x40, 0x0, 0x0));
	_JC_REF_FIELD(env, r5, polyglot_util_TypeInputStream, cache) = r23;
	_JC_LINE_NUMBER(120);				// 2
	r9 = _JC_INVOKE_NONVIRTUAL(env, java_io_ObjectInputStream, readObject$3164017efc5b1161, 0, r5);
	r10 = _JC_CAST(env, &_jc_polyglot_types_Type$type, r9);
	_JC_TRAP_REGION(catch, 2);
	_JC_CANCEL_TRAPS(env, catch);
	return r10;

label1:
	_JC_TRAP_REGION(catch, 2);
	r6 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(123);				// 3
	_JC_THROW(env, r6);

label2:
	_JC_TRAP_REGION(catch, 2);
	r11 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(126);				// 4
	r12 = _JC_NEW(env, polyglot_util_InternalCompilerError);
	r13 = _JC_NEW(env, java_lang_StringBuffer);
	r19 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r13, java_lang_StringBuffer, value) = r19;
	r13 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r13, _JC_STRING(env, "IOException thrown while decoding serialized type info: "));
	r1 = _JC_INVOKE_VIRTUAL(env, java_lang_Throwable, getMessage$13aaf240efc902b1, r11);
	r13 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r13, r1);
	r15 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r15, r13);
	r16 = _JC_NULL;
	_JC_REF_FIELD(env, r12, java_lang_Throwable, cause) = r12;
	r21 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r12);
	_JC_REF_FIELD(env, r12, java_lang_Throwable, vmState) = r21;
	_JC_REF_FIELD(env, r12, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r12, java_lang_Throwable, detailMessage) = r15;
	_JC_REF_FIELD(env, r12, java_lang_Throwable, cause) = r11;
	_JC_REF_FIELD(env, r12, polyglot_util_InternalCompilerError, pos) = r16;
	_JC_THROW(env, r12);

label3:
	_JC_TRAP_REGION(catch, 2);
	r14 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(130);				// 5
	r12 = _JC_NEW(env, polyglot_util_InternalCompilerError);
	r13 = _JC_NEW(env, java_lang_StringBuffer);
	r20 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r13, java_lang_StringBuffer, value) = r20;
	r13 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r13, _JC_STRING(env, "Unable to find one of the classes for the serialized type info: "));
	r1 = _JC_INVOKE_VIRTUAL(env, java_lang_Throwable, getMessage$13aaf240efc902b1, r14);
	r13 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r13, r1);
	r17 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r17, r13);
	r18 = _JC_NULL;
	_JC_REF_FIELD(env, r12, java_lang_Throwable, cause) = r12;
	r22 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r12);
	_JC_REF_FIELD(env, r12, java_lang_Throwable, vmState) = r22;
	_JC_REF_FIELD(env, r12, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r12, java_lang_Throwable, detailMessage) = r17;
	_JC_REF_FIELD(env, r12, java_lang_Throwable, cause) = r14;
	_JC_REF_FIELD(env, r12, polyglot_util_InternalCompilerError, pos) = r18;
	_JC_THROW(env, r12);
}

//
// public java.lang.String encode(polyglot.types.Type) throws java.io.IOException
//

static _jc_linenum _jc_polyglot_util_TypeEncoder$linenum_table$encode$5a76d9ae1ffe7939[];

static const unsigned char _jc_polyglot_util_TypeEncoder$param_ptypes$encode$5a76d9ae1ffe7939[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_util_TypeEncoder$exceptions$encode$5a76d9ae1ffe7939[] = {
	&_jc_java_io_IOException$type
};

static _jc_type *const _jc_polyglot_util_TypeEncoder$param_types$encode$5a76d9ae1ffe7939[] = {
	&_jc_polyglot_types_Type$type
};

_jc_method _jc_polyglot_util_TypeEncoder$method_info$encode$5a76d9ae1ffe7939 = {
	.name=			"encode",
	.signature=		"(Lpolyglot/types/Type;)Ljava/lang/String;",
	.class=			&_jc_polyglot_util_TypeEncoder$type,
	.param_types=		&_jc_polyglot_util_TypeEncoder$param_types$encode$5a76d9ae1ffe7939,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_polyglot_util_TypeEncoder$param_ptypes$encode$5a76d9ae1ffe7939,
	.signature_hash=	_JC_JLONG(0x5a76d9ae1ffe7939),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_util_TypeEncoder$method$encode$5a76d9ae1ffe7939,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_util_TypeEncoder$vtable, polyglot_util_TypeEncoder.encode$5a76d9ae1ffe7939) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_util_TypeEncoder$exceptions$encode$5a76d9ae1ffe7939,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	12,
	      .table=	_jc_polyglot_util_TypeEncoder$linenum_table$encode$5a76d9ae1ffe7939
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_util_TypeEncoder, encode$5a76d9ae1ffe7939);

_jc_java_lang_String$object * _JC_JCNI_ATTR
_jc_polyglot_util_TypeEncoder$method$encode$5a76d9ae1ffe7939(_jc_env *const env, _jc_polyglot_util_TypeEncoder$object *this, _jc_object *param0)
{
	jint i0;
	jint i1;
	jint i2;
	jint i3;
	jint i5;
	struct _jc_polyglot_util_TypeEncoder$object *r0;
	struct _jc_object *r1;
	struct _jc_java_lang_String$object *r10;
	struct _jc_java_lang_String$object *r11;
	struct _jc_java_lang_StringBuffer$object *r12;
	struct _jc_java_lang_String$object *r13;
	struct _jc_java_lang_String$object *r14;
	struct _jc_java_lang_StringBuffer$object *r15;
	struct _jc_java_lang_String$object *r16;
	struct _jc_java_lang_String$object *r17;
	_jc_char_array *r18;
	struct _jc_java_io_DataOutputStream$object *r19;
	struct _jc_java_lang_String$object *r2;
	struct _jc_java_io_DataOutputStream$object *r20;
	struct _jc_java_io_DataOutputStream$object *r21;
	_jc_char_array *r22;
	_jc_char_array *r23;
	_jc_byte_array *r24;
	struct _jc_java_util_Collections__24SingletonList$object *r25;
	struct _jc_java_lang_StringBuffer$object *r26;
	struct _jc_java_lang_String$object *r27;
	struct _jc_java_util_Collections__24SingletonList$object *r28;
	struct _jc_java_util_Collections__24SingletonList$object *r29;
	struct _jc_java_io_ByteArrayOutputStream$object *r3;
	struct _jc_java_io_PrintStream$object *r31;
	struct _jc_polyglot_util_TypeOutputStream$object *r4;
	_jc_byte_array *r5;
	struct _jc_java_lang_StringBuffer$object *r6;
	struct _jc_java_util_zip_GZIPOutputStream$object *r7;
	struct _jc_object *r8;
	_jc_char_array *r9;
	jboolean z0;
	jboolean z1;
	jboolean z2;
	jboolean z3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(41);				// 0
	r2 = _JC_STATIC_FIELD(env, polyglot_main_Report, serialize, 0);
	z1 = _JC_STATIC_FIELD(env, polyglot_main_Report, noReporting, 1);
	if (z1 == 0)
		goto label0;
	z0 = 0;
	goto label1;

label0:
	_JC_ACTIVE_USE(env, java_util_Collections);
	r25 = _JC_NEW(env, java_util_Collections__24SingletonList);
	_JC_REF_FIELD(env, r25, java_util_Collections__24SingletonList, element) = r2;
	z1 = _JC_INVOKE_STATIC(env, polyglot_main_Report, should__5freport$316269f2ec4db001, 1, r25, 1);
	z0 = z1;

label1:
	if (z0 == 0)
		goto label6;
	_JC_LINE_NUMBER(42);				// 1
	r6 = _JC_NEW(env, java_lang_StringBuffer);
	r18 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r6, java_lang_StringBuffer, value) = r18;
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r6, _JC_STRING(env, "Encoding type "));
	r26 = r6;
	if (r1 != _JC_NULL)
		goto label2;
	r27 = _JC_STRING(env, "null");
	goto label3;

label2:
	r27 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, toString$7ea43b33b80a3070, r1);

label3:
	r26 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r26, r27);
	r11 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r11, r26);
	i5 = 1;

label4:
	if (i5 >= 1)
		goto label5;
	r31 = _JC_STATIC_FIELD(env, java_lang_System, err, 0);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, print$21bdbb15afdbea95, r31, _JC_STRING(env, "  "));
	i5 = i5 + 1;
	_JC_PERIODIC_CHECK(env);
	goto label4;

label5:
	r31 = _JC_STATIC_FIELD(env, java_lang_System, err, 0);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, println$f7dbc2aa0f0a9d4f, r31, r11);

label6:
	_JC_LINE_NUMBER(45);				// 2
	r3 = _JC_NEW(env, java_io_ByteArrayOutputStream);
	i2 = _JC_STATIC_FIELD(env, java_io_ByteArrayOutputStream, initial__5fbuffer__5fsize, 1);
	r24 = _JC_NEW_PRIM_ARRAY(env, byte, 1, i2);
	_JC_REF_FIELD(env, r3, java_io_ByteArrayOutputStream, buf) = r24;
	_JC_PRIM_FIELD(env, r3, java_io_ByteArrayOutputStream, count) = 0;
	_JC_LINE_NUMBER(48);				// 3
	r4 = _JC_NEW(env, polyglot_util_TypeOutputStream);
	r7 = _JC_NEW(env, java_util_zip_GZIPOutputStream);
	_JC_INVOKE_NONVIRTUAL(env, java_util_zip_GZIPOutputStream, _init$782fe41f0aefd897, 0, r7, r3, 4096);
	r8 = _JC_REF_FIELD(env, r0, polyglot_util_TypeEncoder, ts);
	_JC_INVOKE_NONVIRTUAL(env, polyglot_util_TypeOutputStream, _init$f0f7c9948b7544c2, 0, r4, r7, r8, r1);
	_JC_LINE_NUMBER(54);				// 4
	_JC_INVOKE_NONVIRTUAL(env, java_io_ObjectOutputStream, writeObject$5923dd5f1924d80b, 0, r4, r1);
	_JC_INVOKE_NONVIRTUAL(env, java_io_ObjectOutputStream, drain$96e48c7d0691592e, 0, r4);
	r19 = _JC_REF_FIELD(env, r4, java_io_ObjectOutputStream, realOutput);
	_JC_INVOKE_VIRTUAL(env, java_io_DataOutputStream, flush$9dedb7d85e88cf56, r19);
	_JC_INVOKE_NONVIRTUAL(env, java_io_ObjectOutputStream, drain$96e48c7d0691592e, 0, r4);
	r21 = _JC_REF_FIELD(env, r4, java_io_ObjectOutputStream, realOutput);
	_JC_INVOKE_VIRTUAL(env, java_io_DataOutputStream, flush$9dedb7d85e88cf56, r21);
	r20 = _JC_REF_FIELD(env, r4, java_io_ObjectOutputStream, realOutput);
	_JC_INVOKE_VIRTUAL(env, java_io_FilterOutputStream, close$6aba8b329fddcd79, r20);
	_JC_LINE_NUMBER(58);				// 5
	r5 = _JC_INVOKE_NONVIRTUAL(env, java_io_ByteArrayOutputStream, toByteArray$3292ac9bfdd8d59a, 0, r3);
	_JC_LINE_NUMBER(60);				// 6
	r2 = _JC_STATIC_FIELD(env, polyglot_main_Report, serialize, 0);
	z2 = _JC_STATIC_FIELD(env, polyglot_main_Report, noReporting, 1);
	if (z2 == 0)
		goto label7;
	z0 = 0;
	goto label8;

label7:
	_JC_ACTIVE_USE(env, java_util_Collections);
	r28 = _JC_NEW(env, java_util_Collections__24SingletonList);
	_JC_REF_FIELD(env, r28, java_util_Collections__24SingletonList, element) = r2;
	z2 = _JC_INVOKE_STATIC(env, polyglot_main_Report, should__5freport$316269f2ec4db001, 1, r28, 2);
	z0 = z2;

label8:
	if (z0 == 0)
		goto label9;
	_JC_LINE_NUMBER(61);				// 7
	r6 = _JC_NEW(env, java_lang_StringBuffer);
	r22 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r6, java_lang_StringBuffer, value) = r22;
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r6, _JC_STRING(env, "Size of serialization (with zipping) is "));
	i0 = _JC_ARRAY_LENGTH(env, r5);
	_JC_ACTIVE_USE(env, java_lang_String);
	r13 = _JC_INVOKE_STATIC(env, java_lang_Integer, toString$80d919d12afaaa2b, 0, i0, 10);
	r12 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r6, r13);
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 1, r12, _JC_STRING(env, " bytes"));
	_JC_EXPLICIT_NULL_CHECK(env, r6);
	r14 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r14, r6);
	_JC_INVOKE_STATIC(env, polyglot_main_Report, report$0373120f850dba20, 1, 2, r14);

label9:
	_JC_LINE_NUMBER(67);				// 8
	r2 = _JC_NEW(env, java_lang_String);
	r9 = _JC_INVOKE_STATIC(env, polyglot_util_Base64, encode$2740c4c13cb6ae53, 0, r5);
	i3 = _JC_ARRAY_LENGTH(env, r9);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$4ec5349c38f5c9aa, 0, r2, r9, 0, i3, 0);
	_JC_LINE_NUMBER(76);				// 9
	r10 = _JC_STATIC_FIELD(env, polyglot_main_Report, serialize, 1);
	z3 = _JC_STATIC_FIELD(env, polyglot_main_Report, noReporting, 1);
	if (z3 == 0)
		goto label10;
	z0 = 0;
	goto label11;

label10:
	_JC_ACTIVE_USE(env, java_util_Collections);
	r29 = _JC_NEW(env, java_util_Collections__24SingletonList);
	_JC_REF_FIELD(env, r29, java_util_Collections__24SingletonList, element) = r10;
	z3 = _JC_INVOKE_STATIC(env, polyglot_main_Report, should__5freport$316269f2ec4db001, 1, r29, 2);
	z0 = z3;

label11:
	if (z0 == 0)
		goto label12;
	_JC_LINE_NUMBER(77);				// 10
	r6 = _JC_NEW(env, java_lang_StringBuffer);
	r23 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r6, java_lang_StringBuffer, value) = r23;
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r6, _JC_STRING(env, "Size of serialization after conversion to string is "));
	i1 = _JC_PRIM_FIELD(env, r2, java_lang_String, count);
	r16 = _JC_INVOKE_STATIC(env, java_lang_Integer, toString$80d919d12afaaa2b, 0, i1, 10);
	r15 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r6, r16);
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 1, r15, _JC_STRING(env, " characters"));
	_JC_EXPLICIT_NULL_CHECK(env, r6);
	r17 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r17, r6);
	_JC_INVOKE_STATIC(env, polyglot_main_Report, report$0373120f850dba20, 1, 2, r17);

label12:
	_JC_LINE_NUMBER(93);				// 11
	return r2;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_polyglot_util_TypeEncoder$methods[] = {
	&_jc_polyglot_util_TypeEncoder$method_info$_init$964314195388e7c0,
	&_jc_polyglot_util_TypeEncoder$method_info$decode$8383d57b54a9bd76,
	&_jc_polyglot_util_TypeEncoder$method_info$encode$5a76d9ae1ffe7939
};

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_polyglot_util_TypeEncoder$instanceof_hash_bucket_50[] = {
	&_jc_polyglot_util_TypeEncoder$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_util_TypeEncoder$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_polyglot_util_TypeEncoder$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[50]=	_jc_polyglot_util_TypeEncoder$instanceof_hash_bucket_50,
	[101]=	_jc_polyglot_util_TypeEncoder$instanceof_hash_bucket_101
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_polyglot_util_TypeEncoder$class_depends[] = {
	{ "java/io/ByteArrayInputStream",	_JC_JLONG(0xa68cc27886fd8be3) },
	{ "java/io/ByteArrayOutputStream",	_JC_JLONG(0xc4d3cc2bda03a338) },
	{ "java/io/DataOutputStream",	_JC_JLONG(0xd755b96203d8fbaf) },
	{ "java/io/FilterOutputStream",	_JC_JLONG(0xfddb41323d9c4cee) },
	{ "java/io/IOException",	_JC_JLONG(0x4e0a56550c69d57c) },
	{ "java/io/InvalidClassException",	_JC_JLONG(0xeb60cf59bc393752) },
	{ "java/io/ObjectInputStream",	_JC_JLONG(0xc0cf85234045e123) },
	{ "java/io/ObjectOutputStream",	_JC_JLONG(0x75762bf0985d508e) },
	{ "java/io/OutputStream",	_JC_JLONG(0x4026d3144d6654d8) },
	{ "java/io/PrintStream",	_JC_JLONG(0x99a46305ebacacb5) },
	{ "java/io/SerializablePermission",	_JC_JLONG(0xf3b2acfda592b4df) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/ClassNotFoundException",	_JC_JLONG(0x1f925cf50bfc0d6c) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/Integer",	_JC_JLONG(0xca631501391a31f1) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/RuntimeException",	_JC_JLONG(0x4f5534a987354d1d) },
	{ "java/lang/SecurityManager",	_JC_JLONG(0xd38282f3d5f80887) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/StringBuffer",	_JC_JLONG(0x94d357637b968dda) },
	{ "java/lang/System",	_JC_JLONG(0x53cc8e2333795f04) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/util/AbstractCollection",	_JC_JLONG(0x8ea716c64b77f8eb) },
	{ "java/util/AbstractList",	_JC_JLONG(0xf5238436362828db) },
	{ "java/util/Collections",	_JC_JLONG(0x9574af3fed58029a) },
	{ "java/util/Collections$SingletonList",	_JC_JLONG(0x2ccd076083da6c8e) },
	{ "java/util/HashMap",	_JC_JLONG(0xd7cd853200c3e71f) },
	{ "java/util/zip/CRC32",	_JC_JLONG(0xd31dc884497a5da2) },
	{ "java/util/zip/GZIPInputStream",	_JC_JLONG(0xc51bfb23c49b4e67) },
	{ "java/util/zip/GZIPOutputStream",	_JC_JLONG(0x5a888c733ac5af5d) },
	{ "java/util/zip/Inflater",	_JC_JLONG(0x4df3e1cb79f6b935) },
	{ "java/util/zip/InflaterInputStream",	_JC_JLONG(0x5602700a47802920) },
	{ "polyglot/main/Report",	_JC_JLONG(0xcf9f146bdb7bc44d) },
	{ "polyglot/types/Type",	_JC_JLONG(0x6596051546781098) },
	{ "polyglot/types/TypeSystem",	_JC_JLONG(0xed171cdaca38ec28) },
	{ "polyglot/util/Base64",	_JC_JLONG(0xb6f081692ba67eb4) },
	{ "polyglot/util/InternalCompilerError",	_JC_JLONG(0x22b321d488641c54) },
	{ "polyglot/util/Position",	_JC_JLONG(0x32c9a088c5dac046) },
	{ "polyglot/util/TypeInputStream",	_JC_JLONG(0xa972375aaa3e5415) },
	{ "polyglot/util/TypeOutputStream",	_JC_JLONG(0x705e5da5ef1a1275) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_polyglot_util_TypeEncoder$vtype _jc_polyglot_util_TypeEncoder$type = {
    .type= {
	.name=			"polyglot/util/TypeEncoder",
	.superclass=		&_jc_java_lang_Object$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		13,
		.hash=			_JC_JLONG(0xf299688fad53c0b2),
		.source_file=		"TypeEncoder.java",
		.instance_size=		sizeof(_jc_polyglot_util_TypeEncoder$refs) + sizeof(_jc_polyglot_util_TypeEncoder$object),
		.num_virtual_refs=	1,
		.num_fields=		sizeof(_jc_polyglot_util_TypeEncoder$fields) / sizeof(*_jc_polyglot_util_TypeEncoder$fields),
		.fields=		_jc_polyglot_util_TypeEncoder$fields,
		.num_methods=		sizeof(_jc_polyglot_util_TypeEncoder$methods) / sizeof(*_jc_polyglot_util_TypeEncoder$methods),
		.methods=		_jc_polyglot_util_TypeEncoder$methods,
		.instanceof_hash_table=	_jc_polyglot_util_TypeEncoder$instanceof_hash_table,
		.num_class_depends=		sizeof(_jc_polyglot_util_TypeEncoder$class_depends) / sizeof(*_jc_polyglot_util_TypeEncoder$class_depends),
		.class_depends=		_jc_polyglot_util_TypeEncoder$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.polyglot_util_TypeEncoder= {
	    .decode$8383d57b54a9bd76=
		&_jc_polyglot_util_TypeEncoder$method$decode$8383d57b54a9bd76,
	    .encode$5a76d9ae1ffe7939=
		&_jc_polyglot_util_TypeEncoder$method$encode$5a76d9ae1ffe7939,
	},
    }
};

