// public class polyglot.visit.AscriptionVisitor

// class file dependencies
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class 9b667b09132be893 java_lang_Cloneable
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class a33c697a7834ba70 polyglot_ast_Expr
// @dep_class 1c402b4f9747e08 polyglot_ast_Node
// @dep_class 56625b3befab19f polyglot_ast_NodeFactory
// @dep_class 42e687805b457724 polyglot_frontend_Job
// @dep_class 45f755f5298b5b39 polyglot_types_SemanticException
// @dep_class 6596051546781098 polyglot_types_Type
// @dep_class ed171cdaca38ec28 polyglot_types_TypeSystem
// @dep_class c1adfaf4637dbc02 polyglot_util_Copy
// @dep_class 4f8e2af057551681 polyglot_visit_AscriptionVisitor
// @dep_class 5c18e1d62fddfa29 polyglot_visit_ContextVisitor
// @dep_class 8a4bd51bcd9d71a polyglot_visit_ErrorHandlingVisitor
// @dep_class 2f5b20d380322b22 polyglot_visit_HaltingVisitor
// @dep_class 534db787197439f0 polyglot_visit_NodeVisitor

// header file dependencies
// @dep_header java_lang_Class
// @dep_header java_lang_Cloneable
// @dep_header java_lang_String
// @dep_header polyglot_ast_Expr
// @dep_header polyglot_ast_Node
// @dep_header polyglot_ast_NodeFactory
// @dep_header polyglot_frontend_Job
// @dep_header polyglot_types_SemanticException
// @dep_header polyglot_types_Type
// @dep_header polyglot_types_TypeSystem
// @dep_header polyglot_util_Copy
// @dep_header polyglot_visit_AscriptionVisitor

#include "jc_defs.h"

#include "java/lang/Class.h"
#include "java/lang/Cloneable.h"
#include "java/lang/String.h"
#include "polyglot/ast/Expr.h"
#include "polyglot/ast/Node.h"
#include "polyglot/ast/NodeFactory.h"
#include "polyglot/frontend/Job.h"
#include "polyglot/types/SemanticException.h"
#include "polyglot/types/Type.h"
#include "polyglot/types/TypeSystem.h"
#include "polyglot/util/Copy.h"
#include "polyglot/visit/AscriptionVisitor.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// polyglot.types.Type type
static _jc_field _jc_polyglot_visit_AscriptionVisitor$field_info$type = {
	.name=		"type",
	.signature=	"Lpolyglot/types/Type;",
	.class=		&_jc_polyglot_visit_AscriptionVisitor$type,
	.type=		&_jc_polyglot_types_Type$type,
	.access_flags=	0,
	.offset=	_JC_OFFSETOF(_jc_polyglot_visit_AscriptionVisitor$object, refs[-1].polyglot_visit_AscriptionVisitor.type),
};

// polyglot.visit.AscriptionVisitor outer
static _jc_field _jc_polyglot_visit_AscriptionVisitor$field_info$outer = {
	.name=		"outer",
	.signature=	"Lpolyglot/visit/AscriptionVisitor;",
	.class=		&_jc_polyglot_visit_AscriptionVisitor$type,
	.type=		&_jc_polyglot_visit_AscriptionVisitor$type,
	.access_flags=	0,
	.offset=	_JC_OFFSETOF(_jc_polyglot_visit_AscriptionVisitor$object, refs[-1].polyglot_visit_AscriptionVisitor.outer),
};

// Fields
static _jc_field *const _jc_polyglot_visit_AscriptionVisitor$fields[] = {
	&_jc_polyglot_visit_AscriptionVisitor$field_info$outer,
	&_jc_polyglot_visit_AscriptionVisitor$field_info$type
};

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// public void <init>(polyglot.frontend.Job, polyglot.types.TypeSystem, polyglot.ast.NodeFactory)
//

static _jc_linenum _jc_polyglot_visit_AscriptionVisitor$linenum_table$_init$dac7f764f0e12933[];

static const unsigned char _jc_polyglot_visit_AscriptionVisitor$param_ptypes$_init$dac7f764f0e12933[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_visit_AscriptionVisitor$param_types$_init$dac7f764f0e12933[] = {
	&_jc_polyglot_frontend_Job$type,
	&_jc_polyglot_types_TypeSystem$type,
	&_jc_polyglot_ast_NodeFactory$type
};

_jc_method _jc_polyglot_visit_AscriptionVisitor$method_info$_init$dac7f764f0e12933 = {
	.name=			"<init>",
	.signature=		"(Lpolyglot/frontend/Job;Lpolyglot/types/TypeSystem;Lpolyglot/ast/NodeFactory;)V",
	.class=			&_jc_polyglot_visit_AscriptionVisitor$type,
	.param_types=		&_jc_polyglot_visit_AscriptionVisitor$param_types$_init$dac7f764f0e12933,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_visit_AscriptionVisitor$param_ptypes$_init$dac7f764f0e12933,
	.signature_hash=	_JC_JLONG(0xdac7f764f0e12933),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_visit_AscriptionVisitor$method$_init$dac7f764f0e12933,
	.num_parameters=	3,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_polyglot_visit_AscriptionVisitor$linenum_table$_init$dac7f764f0e12933
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_visit_AscriptionVisitor, _init$dac7f764f0e12933);

void _JC_JCNI_ATTR
_jc_polyglot_visit_AscriptionVisitor$method$_init$dac7f764f0e12933(_jc_env *const env, _jc_polyglot_visit_AscriptionVisitor$object *this, _jc_polyglot_frontend_Job$object *param0, _jc_object *param1, _jc_object *param2)
{
	struct _jc_polyglot_visit_AscriptionVisitor$object *r0;
	struct _jc_polyglot_frontend_Job$object *r1;
	struct _jc_object *r2;
	struct _jc_object *r3;

	r0 = this;
	r1 = param0;
	r2 = param1;
	r3 = param2;
	_JC_REF_FIELD(env, r0, polyglot_visit_ErrorHandlingVisitor, job) = r1;
	_JC_REF_FIELD(env, r0, polyglot_visit_ErrorHandlingVisitor, ts) = r2;
	_JC_REF_FIELD(env, r0, polyglot_visit_ErrorHandlingVisitor, nf) = r3;
	_JC_REF_FIELD(env, r0, polyglot_visit_ContextVisitor, outer) = _JC_NULL;
	_JC_REF_FIELD(env, r0, polyglot_visit_ContextVisitor, context) = _JC_NULL;
	_JC_LINE_NUMBER(35);				// 0
	_JC_REF_FIELD(env, r0, polyglot_visit_AscriptionVisitor, type) = _JC_NULL;
	_JC_LINE_NUMBER(36);				// 1
	_JC_REF_FIELD(env, r0, polyglot_visit_AscriptionVisitor, outer) = _JC_NULL;
	_JC_LINE_NUMBER(37);				// 2
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public polyglot.ast.Expr ascribe(polyglot.ast.Expr, polyglot.types.Type) throws polyglot.types.SemanticException
//

static _jc_linenum _jc_polyglot_visit_AscriptionVisitor$linenum_table$ascribe$51a47bc56f6458ea[];

static const unsigned char _jc_polyglot_visit_AscriptionVisitor$param_ptypes$ascribe$51a47bc56f6458ea[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_visit_AscriptionVisitor$exceptions$ascribe$51a47bc56f6458ea[] = {
	&_jc_polyglot_types_SemanticException$type
};

static _jc_type *const _jc_polyglot_visit_AscriptionVisitor$param_types$ascribe$51a47bc56f6458ea[] = {
	&_jc_polyglot_ast_Expr$type,
	&_jc_polyglot_types_Type$type
};

_jc_method _jc_polyglot_visit_AscriptionVisitor$method_info$ascribe$51a47bc56f6458ea = {
	.name=			"ascribe",
	.signature=		"(Lpolyglot/ast/Expr;Lpolyglot/types/Type;)Lpolyglot/ast/Expr;",
	.class=			&_jc_polyglot_visit_AscriptionVisitor$type,
	.param_types=		&_jc_polyglot_visit_AscriptionVisitor$param_types$ascribe$51a47bc56f6458ea,
	.return_type=		&_jc_polyglot_ast_Expr$type,
	.param_ptypes=		&_jc_polyglot_visit_AscriptionVisitor$param_ptypes$ascribe$51a47bc56f6458ea,
	.signature_hash=	_JC_JLONG(0x51a47bc56f6458ea),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_visit_AscriptionVisitor$method$ascribe$51a47bc56f6458ea,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_visit_AscriptionVisitor$vtable, polyglot_visit_AscriptionVisitor.ascribe$51a47bc56f6458ea) / sizeof(void *),
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_visit_AscriptionVisitor$exceptions$ascribe$51a47bc56f6458ea,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_visit_AscriptionVisitor$linenum_table$ascribe$51a47bc56f6458ea
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_visit_AscriptionVisitor, ascribe$51a47bc56f6458ea);

_jc_object * _JC_JCNI_ATTR
_jc_polyglot_visit_AscriptionVisitor$method$ascribe$51a47bc56f6458ea(_jc_env *const env, _jc_polyglot_visit_AscriptionVisitor$object *this, _jc_object *param0, _jc_object *param1)
{
	struct _jc_polyglot_visit_AscriptionVisitor$object *r0;
	struct _jc_object *r1;
	struct _jc_object *r2;

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_LINE_NUMBER(91);				// 0
	return r1;
}

//
// public polyglot.visit.NodeVisitor enterCall(polyglot.ast.Node, polyglot.ast.Node) throws polyglot.types.SemanticException
//

static _jc_linenum _jc_polyglot_visit_AscriptionVisitor$linenum_table$enterCall$3637fb21939178bc[];

static const unsigned char _jc_polyglot_visit_AscriptionVisitor$param_ptypes$enterCall$3637fb21939178bc[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_visit_AscriptionVisitor$exceptions$enterCall$3637fb21939178bc[] = {
	&_jc_polyglot_types_SemanticException$type
};

static _jc_type *const _jc_polyglot_visit_AscriptionVisitor$param_types$enterCall$3637fb21939178bc[] = {
	&_jc_polyglot_ast_Node$type,
	&_jc_polyglot_ast_Node$type
};

_jc_method _jc_polyglot_visit_AscriptionVisitor$method_info$enterCall$3637fb21939178bc = {
	.name=			"enterCall",
	.signature=		"(Lpolyglot/ast/Node;Lpolyglot/ast/Node;)Lpolyglot/visit/NodeVisitor;",
	.class=			&_jc_polyglot_visit_AscriptionVisitor$type,
	.param_types=		&_jc_polyglot_visit_AscriptionVisitor$param_types$enterCall$3637fb21939178bc,
	.return_type=		&_jc_polyglot_visit_NodeVisitor$type,
	.param_ptypes=		&_jc_polyglot_visit_AscriptionVisitor$param_ptypes$enterCall$3637fb21939178bc,
	.signature_hash=	_JC_JLONG(0x3637fb21939178bc),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_visit_AscriptionVisitor$method$enterCall$3637fb21939178bc,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_visit_AscriptionVisitor$vtable, polyglot_visit_AscriptionVisitor.enterCall$3637fb21939178bc) / sizeof(void *),
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_visit_AscriptionVisitor$exceptions$enterCall$3637fb21939178bc,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	7,
	      .table=	_jc_polyglot_visit_AscriptionVisitor$linenum_table$enterCall$3637fb21939178bc
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_visit_AscriptionVisitor, enterCall$3637fb21939178bc);

_jc_polyglot_visit_NodeVisitor$object * _JC_JCNI_ATTR
_jc_polyglot_visit_AscriptionVisitor$method$enterCall$3637fb21939178bc(_jc_env *const env, _jc_polyglot_visit_AscriptionVisitor$object *this, _jc_object *param0, _jc_object *param1)
{
	struct _jc_polyglot_visit_AscriptionVisitor$object *r0;
	struct _jc_object *r1;
	struct _jc_object *r2;
	struct _jc_object *r3;
	struct _jc_polyglot_visit_AscriptionVisitor$object *r4;
	struct _jc_object *r5;
	struct _jc_java_lang_Object$object *r6;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_LINE_NUMBER(60);				// 0
	r3 = _JC_NULL;
	_JC_LINE_NUMBER(62);				// 1
	if (r1 == _JC_NULL)
		goto label0;
	z0 = _JC_INSTANCEOF(env, r2, &_jc_polyglot_ast_Expr$type);
	if (z0 == 0)
		goto label0;
	_JC_LINE_NUMBER(63);				// 2
	r5 = r2;
	r3 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0x83ae3a389d7a41bf), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_object *, struct _jc_polyglot_visit_AscriptionVisitor$object *), r5, r0);

label0:
	_JC_LINE_NUMBER(66);				// 3
	r6 = _JC_INVOKE_VIRTUAL(env, polyglot_visit_HaltingVisitor, copy$2119f530248e04c9, r0);
	r4 = _JC_CAST(env, &_jc_polyglot_visit_AscriptionVisitor$type, r6);
	_JC_LINE_NUMBER(67);				// 4
	_JC_REF_FIELD(env, r4, polyglot_visit_AscriptionVisitor, outer) = r0;
	_JC_LINE_NUMBER(68);				// 5
	_JC_REF_FIELD(env, r4, polyglot_visit_AscriptionVisitor, type) = r3;
	_JC_LINE_NUMBER(70);				// 6
	return r4;
}

//
// public polyglot.ast.Node leaveCall(polyglot.ast.Node, polyglot.ast.Node, polyglot.visit.NodeVisitor) throws polyglot.types.SemanticException
//

static _jc_linenum _jc_polyglot_visit_AscriptionVisitor$linenum_table$leaveCall$9236e830bcef4b36[];

static const unsigned char _jc_polyglot_visit_AscriptionVisitor$param_ptypes$leaveCall$9236e830bcef4b36[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_visit_AscriptionVisitor$exceptions$leaveCall$9236e830bcef4b36[] = {
	&_jc_polyglot_types_SemanticException$type
};

static _jc_type *const _jc_polyglot_visit_AscriptionVisitor$param_types$leaveCall$9236e830bcef4b36[] = {
	&_jc_polyglot_ast_Node$type,
	&_jc_polyglot_ast_Node$type,
	&_jc_polyglot_visit_NodeVisitor$type
};

_jc_method _jc_polyglot_visit_AscriptionVisitor$method_info$leaveCall$9236e830bcef4b36 = {
	.name=			"leaveCall",
	.signature=		"(Lpolyglot/ast/Node;Lpolyglot/ast/Node;Lpolyglot/visit/NodeVisitor;)Lpolyglot/ast/Node;",
	.class=			&_jc_polyglot_visit_AscriptionVisitor$type,
	.param_types=		&_jc_polyglot_visit_AscriptionVisitor$param_types$leaveCall$9236e830bcef4b36,
	.return_type=		&_jc_polyglot_ast_Node$type,
	.param_ptypes=		&_jc_polyglot_visit_AscriptionVisitor$param_ptypes$leaveCall$9236e830bcef4b36,
	.signature_hash=	_JC_JLONG(0x9236e830bcef4b36),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_visit_AscriptionVisitor$method$leaveCall$9236e830bcef4b36,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_visit_AscriptionVisitor$vtable, polyglot_visit_AscriptionVisitor.leaveCall$9236e830bcef4b36) / sizeof(void *),
	.num_parameters=	3,
	.num_exceptions=	1,
	.exceptions=		&_jc_polyglot_visit_AscriptionVisitor$exceptions$leaveCall$9236e830bcef4b36,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_polyglot_visit_AscriptionVisitor$linenum_table$leaveCall$9236e830bcef4b36
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_visit_AscriptionVisitor, leaveCall$9236e830bcef4b36);

_jc_object * _JC_JCNI_ATTR
_jc_polyglot_visit_AscriptionVisitor$method$leaveCall$9236e830bcef4b36(_jc_env *const env, _jc_polyglot_visit_AscriptionVisitor$object *this, _jc_object *param0, _jc_object *param1, _jc_polyglot_visit_NodeVisitor$object *param2)
{
	struct _jc_polyglot_visit_AscriptionVisitor$object *r0;
	struct _jc_object *r1;
	struct _jc_object *r2;
	struct _jc_polyglot_visit_NodeVisitor$object *r3;
	struct _jc_object *r4;
	struct _jc_object *r5;
	struct _jc_polyglot_visit_AscriptionVisitor$object *r6;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	r3 = param2;
	_JC_LINE_NUMBER(102);				// 0
	z0 = _JC_INSTANCEOF(env, r2, &_jc_polyglot_ast_Expr$type);
	if (z0 == 0)
		goto label0;
	_JC_LINE_NUMBER(103);				// 1
	r4 = r2;
	_JC_LINE_NUMBER(104);				// 2
	r6 = _JC_CAST(env, &_jc_polyglot_visit_AscriptionVisitor$type, r3);
	r5 = _JC_REF_FIELD(env, r6, polyglot_visit_AscriptionVisitor, type);
	_JC_LINE_NUMBER(105);				// 3
	r4 = _JC_INVOKE_VIRTUAL(env, polyglot_visit_AscriptionVisitor, ascribe$51a47bc56f6458ea, r0, r4, r5);
	return r4;

label0:
	_JC_LINE_NUMBER(108);				// 4
	return r2;
}

//
// public polyglot.visit.AscriptionVisitor pop()
//

static _jc_linenum _jc_polyglot_visit_AscriptionVisitor$linenum_table$pop$61515fcefaa8b11d[];

static const unsigned char _jc_polyglot_visit_AscriptionVisitor$param_ptypes$pop$61515fcefaa8b11d[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_visit_AscriptionVisitor$method_info$pop$61515fcefaa8b11d = {
	.name=			"pop",
	.signature=		"()Lpolyglot/visit/AscriptionVisitor;",
	.class=			&_jc_polyglot_visit_AscriptionVisitor$type,
	.return_type=		&_jc_polyglot_visit_AscriptionVisitor$type,
	.param_ptypes=		&_jc_polyglot_visit_AscriptionVisitor$param_ptypes$pop$61515fcefaa8b11d,
	.signature_hash=	_JC_JLONG(0x61515fcefaa8b11d),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_visit_AscriptionVisitor$method$pop$61515fcefaa8b11d,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_visit_AscriptionVisitor$vtable, polyglot_visit_AscriptionVisitor.pop$61515fcefaa8b11d) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_visit_AscriptionVisitor$linenum_table$pop$61515fcefaa8b11d
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_visit_AscriptionVisitor, pop$61515fcefaa8b11d);

_jc_polyglot_visit_AscriptionVisitor$object * _JC_JCNI_ATTR
_jc_polyglot_visit_AscriptionVisitor$method$pop$61515fcefaa8b11d(_jc_env *const env, _jc_polyglot_visit_AscriptionVisitor$object *this)
{
	struct _jc_polyglot_visit_AscriptionVisitor$object *r0;

	r0 = this;
	_JC_LINE_NUMBER(43);				// 0
	r0 = _JC_REF_FIELD(env, r0, polyglot_visit_AscriptionVisitor, outer);
	return r0;
}

//
// public polyglot.types.Type toType()
//

static _jc_linenum _jc_polyglot_visit_AscriptionVisitor$linenum_table$toType$4dd5ac4b101dcd1f[];

static const unsigned char _jc_polyglot_visit_AscriptionVisitor$param_ptypes$toType$4dd5ac4b101dcd1f[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_visit_AscriptionVisitor$method_info$toType$4dd5ac4b101dcd1f = {
	.name=			"toType",
	.signature=		"()Lpolyglot/types/Type;",
	.class=			&_jc_polyglot_visit_AscriptionVisitor$type,
	.return_type=		&_jc_polyglot_types_Type$type,
	.param_ptypes=		&_jc_polyglot_visit_AscriptionVisitor$param_ptypes$toType$4dd5ac4b101dcd1f,
	.signature_hash=	_JC_JLONG(0x4dd5ac4b101dcd1f),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_visit_AscriptionVisitor$method$toType$4dd5ac4b101dcd1f,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_visit_AscriptionVisitor$vtable, polyglot_visit_AscriptionVisitor.toType$4dd5ac4b101dcd1f) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_visit_AscriptionVisitor$linenum_table$toType$4dd5ac4b101dcd1f
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_visit_AscriptionVisitor, toType$4dd5ac4b101dcd1f);

_jc_object * _JC_JCNI_ATTR
_jc_polyglot_visit_AscriptionVisitor$method$toType$4dd5ac4b101dcd1f(_jc_env *const env, _jc_polyglot_visit_AscriptionVisitor$object *this)
{
	struct _jc_polyglot_visit_AscriptionVisitor$object *r0;
	struct _jc_object *r1;

	r0 = this;
	_JC_LINE_NUMBER(50);				// 0
	r1 = _JC_REF_FIELD(env, r0, polyglot_visit_AscriptionVisitor, type);
	return r1;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_polyglot_visit_AscriptionVisitor$methods[] = {
	&_jc_polyglot_visit_AscriptionVisitor$method_info$_init$dac7f764f0e12933,
	&_jc_polyglot_visit_AscriptionVisitor$method_info$ascribe$51a47bc56f6458ea,
	&_jc_polyglot_visit_AscriptionVisitor$method_info$enterCall$3637fb21939178bc,
	&_jc_polyglot_visit_AscriptionVisitor$method_info$leaveCall$9236e830bcef4b36,
	&_jc_polyglot_visit_AscriptionVisitor$method_info$pop$61515fcefaa8b11d,
	&_jc_polyglot_visit_AscriptionVisitor$method_info$toType$4dd5ac4b101dcd1f
};

/************************************************************************
 *			   Interface hash table				*
 ************************************************************************/

#if _JC_IMETHOD_HASHSIZE != 128
#error "_JC_IMETHOD_HASHSIZE has the wrong value (should be 128)"
#endif

// Interface lookup hash table buckets
static _jc_method *_jc_polyglot_visit_AscriptionVisitor$imethod_hash_bucket_73[] = {
	&_jc_polyglot_visit_HaltingVisitor$method_info$copy$2119f530248e04c9,
	_JC_NULL
};

// Interface lookup hash table
static _jc_method **_jc_polyglot_visit_AscriptionVisitor$imethod_hash_table[_JC_IMETHOD_HASHSIZE] = {
	[73]=	_jc_polyglot_visit_AscriptionVisitor$imethod_hash_bucket_73
};

// Interface "quick" lookup hash table
static const void *_jc_polyglot_visit_AscriptionVisitor$imethod_quick_table[_JC_IMETHOD_HASHSIZE] = {
	[73]=	&_jc_polyglot_visit_HaltingVisitor$method$copy$2119f530248e04c9
};

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_polyglot_visit_AscriptionVisitor$instanceof_hash_bucket_1[] = {
	&_jc_polyglot_visit_AscriptionVisitor$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_visit_AscriptionVisitor$instanceof_hash_bucket_2[] = {
	&_jc_polyglot_util_Copy$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_visit_AscriptionVisitor$instanceof_hash_bucket_19[] = {
	&_jc_java_lang_Cloneable$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_visit_AscriptionVisitor$instanceof_hash_bucket_26[] = {
	&_jc_polyglot_visit_ErrorHandlingVisitor$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_visit_AscriptionVisitor$instanceof_hash_bucket_34[] = {
	&_jc_polyglot_visit_HaltingVisitor$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_visit_AscriptionVisitor$instanceof_hash_bucket_41[] = {
	&_jc_polyglot_visit_ContextVisitor$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_visit_AscriptionVisitor$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_visit_AscriptionVisitor$instanceof_hash_bucket_112[] = {
	&_jc_polyglot_visit_NodeVisitor$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_polyglot_visit_AscriptionVisitor$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[1]=	_jc_polyglot_visit_AscriptionVisitor$instanceof_hash_bucket_1,
	[2]=	_jc_polyglot_visit_AscriptionVisitor$instanceof_hash_bucket_2,
	[19]=	_jc_polyglot_visit_AscriptionVisitor$instanceof_hash_bucket_19,
	[26]=	_jc_polyglot_visit_AscriptionVisitor$instanceof_hash_bucket_26,
	[34]=	_jc_polyglot_visit_AscriptionVisitor$instanceof_hash_bucket_34,
	[41]=	_jc_polyglot_visit_AscriptionVisitor$instanceof_hash_bucket_41,
	[101]=	_jc_polyglot_visit_AscriptionVisitor$instanceof_hash_bucket_101,
	[112]=	_jc_polyglot_visit_AscriptionVisitor$instanceof_hash_bucket_112
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_polyglot_visit_AscriptionVisitor$class_depends[] = {
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/Cloneable",	_JC_JLONG(0x9b667b09132be893) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "polyglot/ast/Expr",	_JC_JLONG(0xa33c697a7834ba70) },
	{ "polyglot/ast/Node",	_JC_JLONG(0x1c402b4f9747e08) },
	{ "polyglot/ast/NodeFactory",	_JC_JLONG(0x56625b3befab19f) },
	{ "polyglot/frontend/Job",	_JC_JLONG(0x42e687805b457724) },
	{ "polyglot/types/SemanticException",	_JC_JLONG(0x45f755f5298b5b39) },
	{ "polyglot/types/Type",	_JC_JLONG(0x6596051546781098) },
	{ "polyglot/types/TypeSystem",	_JC_JLONG(0xed171cdaca38ec28) },
	{ "polyglot/util/Copy",	_JC_JLONG(0xc1adfaf4637dbc02) },
	{ "polyglot/visit/ContextVisitor",	_JC_JLONG(0x5c18e1d62fddfa29) },
	{ "polyglot/visit/ErrorHandlingVisitor",	_JC_JLONG(0x8a4bd51bcd9d71a) },
	{ "polyglot/visit/HaltingVisitor",	_JC_JLONG(0x2f5b20d380322b22) },
	{ "polyglot/visit/NodeVisitor",	_JC_JLONG(0x534db787197439f0) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_polyglot_visit_AscriptionVisitor$vtype _jc_polyglot_visit_AscriptionVisitor$type = {
    .type= {
	.name=			"polyglot/visit/AscriptionVisitor",
	.superclass=		&_jc_polyglot_visit_ContextVisitor$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_polyglot_visit_AscriptionVisitor$imethod_hash_table,
	.imethod_quick_table=	_jc_polyglot_visit_AscriptionVisitor$imethod_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		54,
		.hash=			_JC_JLONG(0x4f8e2af057551681),
		.source_file=		"AscriptionVisitor.java",
		.instance_size=		sizeof(_jc_polyglot_visit_AscriptionVisitor$refs) + sizeof(_jc_polyglot_visit_AscriptionVisitor$object),
		.num_virtual_refs=	9,
		.num_fields=		sizeof(_jc_polyglot_visit_AscriptionVisitor$fields) / sizeof(*_jc_polyglot_visit_AscriptionVisitor$fields),
		.fields=		_jc_polyglot_visit_AscriptionVisitor$fields,
		.num_methods=		sizeof(_jc_polyglot_visit_AscriptionVisitor$methods) / sizeof(*_jc_polyglot_visit_AscriptionVisitor$methods),
		.methods=		_jc_polyglot_visit_AscriptionVisitor$methods,
		.instanceof_hash_table=	_jc_polyglot_visit_AscriptionVisitor$instanceof_hash_table,
		.num_class_depends=		sizeof(_jc_polyglot_visit_AscriptionVisitor$class_depends) / sizeof(*_jc_polyglot_visit_AscriptionVisitor$class_depends),
		.class_depends=		_jc_polyglot_visit_AscriptionVisitor$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=			// overridden
		&_jc_polyglot_visit_NodeVisitor$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.polyglot_visit_NodeVisitor= {
	    .begin$914d55e002815404=			// overridden
		&_jc_polyglot_visit_ContextVisitor$method$begin$914d55e002815404,
	    .enter$a8ce2b9db363b202=
		&_jc_polyglot_visit_NodeVisitor$method$enter$a8ce2b9db363b202,
	    .enter$0698e71b16532e07=			// overridden
		&_jc_polyglot_visit_ContextVisitor$method$enter$0698e71b16532e07,
	    .finish$8d1c944274527186=
		&_jc_polyglot_visit_NodeVisitor$method$finish$8d1c944274527186,
	    .finish$ed6d1946240badd4=
		&_jc_polyglot_visit_NodeVisitor$method$finish$ed6d1946240badd4,
	    .leave$d95680aeadf04833=			// overridden
		&_jc_polyglot_visit_ContextVisitor$method$leave$d95680aeadf04833,
	    .leave$cf18a0cab654af63=
		&_jc_polyglot_visit_NodeVisitor$method$leave$cf18a0cab654af63,
	    .override$1e05b257002785f7=
		&_jc_polyglot_visit_NodeVisitor$method$override$1e05b257002785f7,
	    .override$b414405487168b9b=			// overridden
		&_jc_polyglot_visit_HaltingVisitor$method$override$b414405487168b9b,
	    .toString$7ea43b33b80a3070=
		&_jc_polyglot_visit_NodeVisitor$method$toString$7ea43b33b80a3070,
	    .visitEdge$35f9fc3d698a8550=
		&_jc_polyglot_visit_NodeVisitor$method$visitEdge$35f9fc3d698a8550,
	},
	.polyglot_visit_HaltingVisitor= {
	    .bypass$2362fe5b09e06e51=
		&_jc_polyglot_visit_HaltingVisitor$method$bypass$2362fe5b09e06e51,
	    .bypass$a2413c94f53e8bbe=
		&_jc_polyglot_visit_HaltingVisitor$method$bypass$a2413c94f53e8bbe,
	    .bypassChildren$297f04895f89c850=
		&_jc_polyglot_visit_HaltingVisitor$method$bypassChildren$297f04895f89c850,
	    .copy$2119f530248e04c9=
		&_jc_polyglot_visit_HaltingVisitor$method$copy$2119f530248e04c9,
	    .override$b414405487168b9b=
		&_jc_polyglot_visit_HaltingVisitor$method$override$b414405487168b9b,
	    .visitChildren$8328a2f7ca5ebf6b=
		&_jc_polyglot_visit_HaltingVisitor$method$visitChildren$8328a2f7ca5ebf6b,
	},
	.polyglot_visit_ErrorHandlingVisitor= {
	    .begin$914d55e002815404=			// overridden
		&_jc_polyglot_visit_ContextVisitor$method$begin$914d55e002815404,
	    .catchErrors$22b0599764088ed3=			// overridden
		&_jc_polyglot_visit_ContextVisitor$method$catchErrors$22b0599764088ed3,
	    .enter$0698e71b16532e07=			// overridden
		&_jc_polyglot_visit_ContextVisitor$method$enter$0698e71b16532e07,
	    .enterCall$91bb061343e6f272=
		&_jc_polyglot_visit_ErrorHandlingVisitor$method$enterCall$91bb061343e6f272,
	    .enterCall$3637fb21939178bc=			// overridden
		&_jc_polyglot_visit_AscriptionVisitor$method$enterCall$3637fb21939178bc,
	    .errorQueue$6d038e7585ab4339=
		&_jc_polyglot_visit_ErrorHandlingVisitor$method$errorQueue$6d038e7585ab4339,
	    .job$60bb99fb0e87eae0=
		&_jc_polyglot_visit_ErrorHandlingVisitor$method$job$60bb99fb0e87eae0,
	    .leave$d95680aeadf04833=			// overridden
		&_jc_polyglot_visit_ContextVisitor$method$leave$d95680aeadf04833,
	    .leaveCall$8ca7dc9ca87da1af=
		&_jc_polyglot_visit_ErrorHandlingVisitor$method$leaveCall$8ca7dc9ca87da1af,
	    .leaveCall$9236e830bcef4b36=			// overridden
		&_jc_polyglot_visit_AscriptionVisitor$method$leaveCall$9236e830bcef4b36,
	    .nodeFactory$32826050387dc827=
		&_jc_polyglot_visit_ErrorHandlingVisitor$method$nodeFactory$32826050387dc827,
	    .typeSystem$c9dab312e784024e=
		&_jc_polyglot_visit_ErrorHandlingVisitor$method$typeSystem$c9dab312e784024e,
	},
	.polyglot_visit_ContextVisitor= {
	    .addDecls$7e6d704a2663a180=
		&_jc_polyglot_visit_ContextVisitor$method$addDecls$7e6d704a2663a180,
	    .begin$914d55e002815404=
		&_jc_polyglot_visit_ContextVisitor$method$begin$914d55e002815404,
	    .catchErrors$22b0599764088ed3=
		&_jc_polyglot_visit_ContextVisitor$method$catchErrors$22b0599764088ed3,
	    .context$4c5ebe4f0ff1c15f=
		&_jc_polyglot_visit_ContextVisitor$method$context$4c5ebe4f0ff1c15f,
	    .context$ae4cf76234cc86e6=
		&_jc_polyglot_visit_ContextVisitor$method$context$ae4cf76234cc86e6,
	    .enter$0698e71b16532e07=
		&_jc_polyglot_visit_ContextVisitor$method$enter$0698e71b16532e07,
	    .enterScope$cb89e4d264f28f1f=
		&_jc_polyglot_visit_ContextVisitor$method$enterScope$cb89e4d264f28f1f,
	    .leave$d95680aeadf04833=
		&_jc_polyglot_visit_ContextVisitor$method$leave$d95680aeadf04833,
	    .superEnter$1d3c88af6d844130=
		&_jc_polyglot_visit_ContextVisitor$method$superEnter$1d3c88af6d844130,
	},
	.polyglot_visit_AscriptionVisitor= {
	    .ascribe$51a47bc56f6458ea=
		&_jc_polyglot_visit_AscriptionVisitor$method$ascribe$51a47bc56f6458ea,
	    .enterCall$3637fb21939178bc=
		&_jc_polyglot_visit_AscriptionVisitor$method$enterCall$3637fb21939178bc,
	    .leaveCall$9236e830bcef4b36=
		&_jc_polyglot_visit_AscriptionVisitor$method$leaveCall$9236e830bcef4b36,
	    .pop$61515fcefaa8b11d=
		&_jc_polyglot_visit_AscriptionVisitor$method$pop$61515fcefaa8b11d,
	    .toType$4dd5ac4b101dcd1f=
		&_jc_polyglot_visit_AscriptionVisitor$method$toType$4dd5ac4b101dcd1f,
	},
    }
};

