// public class polyglot.visit.ClassSerializer

// class file dependencies
// @dep_class 4e0a56550c69d57c java_io_IOException
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class ca631501391a31f1 java_lang_Integer
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 94d357637b968dda java_lang_StringBuffer
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class a85d2a51094e614c java_util_Date
// @dep_class 6d0ea1efc315a28 polyglot_ast_CanonicalTypeNode
// @dep_class b4472f169efc874e polyglot_ast_ClassBody
// @dep_class 1dd06ab52424cd00 polyglot_ast_ClassDecl
// @dep_class 797e2651f43d6015 polyglot_ast_ClassMember
// @dep_class a33c697a7834ba70 polyglot_ast_Expr
// @dep_class 3e5dc0670fa8c08c polyglot_ast_FieldDecl
// @dep_class 54f56503db424b65 polyglot_ast_IntLit
// @dep_class 2930cd94f99deb68 polyglot_ast_IntLit__24Kind
// @dep_class 1c402b4f9747e08 polyglot_ast_Node
// @dep_class 56625b3befab19f polyglot_ast_NodeFactory
// @dep_class 95e3a5ad05b642e8 polyglot_ast_StringLit
// @dep_class 4ba1325a7aefecac polyglot_main_Version
// @dep_class b38560af658974f8 polyglot_types_ClassType
// @dep_class d4beb04c35c42bde polyglot_types_FieldInstance
// @dep_class 821eb65d8f2f30f6 polyglot_types_Flags
// @dep_class b7281cf8e3a14f14 polyglot_types_InitializerInstance
// @dep_class 6bcfbf52304f9e7c polyglot_types_ParsedClassType
// @dep_class c9050be6d71cb6f4 polyglot_types_PrimitiveType
// @dep_class 6596051546781098 polyglot_types_Type
// @dep_class ed171cdaca38ec28 polyglot_types_TypeSystem
// @dep_class ff712c8463bdfdc0 polyglot_util_ErrorQueue
// @dep_class 32c9a088c5dac046 polyglot_util_Position
// @dep_class f299688fad53c0b2 polyglot_util_TypeEncoder
// @dep_class e58a5b7c83230169 polyglot_visit_ClassSerializer
// @dep_class 534db787197439f0 polyglot_visit_NodeVisitor

// header file dependencies
// @dep_header java_io_IOException
// @dep_header java_lang_Class
// @dep_header java_lang_Integer
// @dep_header java_lang_String
// @dep_header java_lang_StringBuffer
// @dep_header java_util_Date
// @dep_header polyglot_ast_CanonicalTypeNode
// @dep_header polyglot_ast_ClassBody
// @dep_header polyglot_ast_ClassDecl
// @dep_header polyglot_ast_ClassMember
// @dep_header polyglot_ast_Expr
// @dep_header polyglot_ast_FieldDecl
// @dep_header polyglot_ast_IntLit
// @dep_header polyglot_ast_IntLit__24Kind
// @dep_header polyglot_ast_Node
// @dep_header polyglot_ast_NodeFactory
// @dep_header polyglot_ast_StringLit
// @dep_header polyglot_main_Version
// @dep_header polyglot_types_ClassType
// @dep_header polyglot_types_FieldInstance
// @dep_header polyglot_types_Flags
// @dep_header polyglot_types_InitializerInstance
// @dep_header polyglot_types_ParsedClassType
// @dep_header polyglot_types_PrimitiveType
// @dep_header polyglot_types_Type
// @dep_header polyglot_types_TypeSystem
// @dep_header polyglot_util_ErrorQueue
// @dep_header polyglot_util_Position
// @dep_header polyglot_util_TypeEncoder
// @dep_header polyglot_visit_ClassSerializer

#include "jc_defs.h"

#include "java/io/IOException.h"
#include "java/lang/Class.h"
#include "java/lang/Integer.h"
#include "java/lang/String.h"
#include "java/lang/StringBuffer.h"
#include "java/util/Date.h"
#include "polyglot/ast/CanonicalTypeNode.h"
#include "polyglot/ast/ClassBody.h"
#include "polyglot/ast/ClassDecl.h"
#include "polyglot/ast/ClassMember.h"
#include "polyglot/ast/Expr.h"
#include "polyglot/ast/FieldDecl.h"
#include "polyglot/ast/IntLit.h"
#include "polyglot/ast/IntLit__24Kind.h"
#include "polyglot/ast/Node.h"
#include "polyglot/ast/NodeFactory.h"
#include "polyglot/ast/StringLit.h"
#include "polyglot/main/Version.h"
#include "polyglot/types/ClassType.h"
#include "polyglot/types/FieldInstance.h"
#include "polyglot/types/Flags.h"
#include "polyglot/types/InitializerInstance.h"
#include "polyglot/types/ParsedClassType.h"
#include "polyglot/types/PrimitiveType.h"
#include "polyglot/types/Type.h"
#include "polyglot/types/TypeSystem.h"
#include "polyglot/util/ErrorQueue.h"
#include "polyglot/util/Position.h"
#include "polyglot/util/TypeEncoder.h"
#include "polyglot/visit/ClassSerializer.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// protected polyglot.util.TypeEncoder te
static _jc_field _jc_polyglot_visit_ClassSerializer$field_info$te = {
	.name=		"te",
	.signature=	"Lpolyglot/util/TypeEncoder;",
	.class=		&_jc_polyglot_visit_ClassSerializer$type,
	.type=		&_jc_polyglot_util_TypeEncoder$type,
	.access_flags=	_JC_ACC_PROTECTED,
	.offset=	_JC_OFFSETOF(_jc_polyglot_visit_ClassSerializer$object, refs[-1].polyglot_visit_ClassSerializer.te),
};

// protected polyglot.util.ErrorQueue eq
static _jc_field _jc_polyglot_visit_ClassSerializer$field_info$eq = {
	.name=		"eq",
	.signature=	"Lpolyglot/util/ErrorQueue;",
	.class=		&_jc_polyglot_visit_ClassSerializer$type,
	.type=		&_jc_polyglot_util_ErrorQueue$type,
	.access_flags=	_JC_ACC_PROTECTED,
	.offset=	_JC_OFFSETOF(_jc_polyglot_visit_ClassSerializer$object, refs[-1].polyglot_visit_ClassSerializer.eq),
};

// protected java.util.Date date
static _jc_field _jc_polyglot_visit_ClassSerializer$field_info$date = {
	.name=		"date",
	.signature=	"Ljava/util/Date;",
	.class=		&_jc_polyglot_visit_ClassSerializer$type,
	.type=		&_jc_java_util_Date$type,
	.access_flags=	_JC_ACC_PROTECTED,
	.offset=	_JC_OFFSETOF(_jc_polyglot_visit_ClassSerializer$object, refs[-1].polyglot_visit_ClassSerializer.date),
};

// protected polyglot.types.TypeSystem ts
static _jc_field _jc_polyglot_visit_ClassSerializer$field_info$ts = {
	.name=		"ts",
	.signature=	"Lpolyglot/types/TypeSystem;",
	.class=		&_jc_polyglot_visit_ClassSerializer$type,
	.type=		&_jc_polyglot_types_TypeSystem$type,
	.access_flags=	_JC_ACC_PROTECTED,
	.offset=	_JC_OFFSETOF(_jc_polyglot_visit_ClassSerializer$object, refs[-1].polyglot_visit_ClassSerializer.ts),
};

// protected polyglot.ast.NodeFactory nf
static _jc_field _jc_polyglot_visit_ClassSerializer$field_info$nf = {
	.name=		"nf",
	.signature=	"Lpolyglot/ast/NodeFactory;",
	.class=		&_jc_polyglot_visit_ClassSerializer$type,
	.type=		&_jc_polyglot_ast_NodeFactory$type,
	.access_flags=	_JC_ACC_PROTECTED,
	.offset=	_JC_OFFSETOF(_jc_polyglot_visit_ClassSerializer$object, refs[-1].polyglot_visit_ClassSerializer.nf),
};

// protected polyglot.main.Version ver
static _jc_field _jc_polyglot_visit_ClassSerializer$field_info$ver = {
	.name=		"ver",
	.signature=	"Lpolyglot/main/Version;",
	.class=		&_jc_polyglot_visit_ClassSerializer$type,
	.type=		&_jc_polyglot_main_Version$type,
	.access_flags=	_JC_ACC_PROTECTED,
	.offset=	_JC_OFFSETOF(_jc_polyglot_visit_ClassSerializer$object, refs[-1].polyglot_visit_ClassSerializer.ver),
};

// Fields
static _jc_field *const _jc_polyglot_visit_ClassSerializer$fields[] = {
	&_jc_polyglot_visit_ClassSerializer$field_info$date,
	&_jc_polyglot_visit_ClassSerializer$field_info$eq,
	&_jc_polyglot_visit_ClassSerializer$field_info$nf,
	&_jc_polyglot_visit_ClassSerializer$field_info$te,
	&_jc_polyglot_visit_ClassSerializer$field_info$ts,
	&_jc_polyglot_visit_ClassSerializer$field_info$ver
};

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// public void <init>(polyglot.types.TypeSystem, polyglot.ast.NodeFactory, java.util.Date, polyglot.util.ErrorQueue, polyglot.main.Version)
//

static _jc_linenum _jc_polyglot_visit_ClassSerializer$linenum_table$_init$db31203d1cd8df6a[];

static const unsigned char _jc_polyglot_visit_ClassSerializer$param_ptypes$_init$db31203d1cd8df6a[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_visit_ClassSerializer$param_types$_init$db31203d1cd8df6a[] = {
	&_jc_polyglot_types_TypeSystem$type,
	&_jc_polyglot_ast_NodeFactory$type,
	&_jc_java_util_Date$type,
	&_jc_polyglot_util_ErrorQueue$type,
	&_jc_polyglot_main_Version$type
};

_jc_method _jc_polyglot_visit_ClassSerializer$method_info$_init$db31203d1cd8df6a = {
	.name=			"<init>",
	.signature=		"(Lpolyglot/types/TypeSystem;Lpolyglot/ast/NodeFactory;Ljava/util/Date;Lpolyglot/util/ErrorQueue;Lpolyglot/main/Version;)V",
	.class=			&_jc_polyglot_visit_ClassSerializer$type,
	.param_types=		&_jc_polyglot_visit_ClassSerializer$param_types$_init$db31203d1cd8df6a,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_visit_ClassSerializer$param_ptypes$_init$db31203d1cd8df6a,
	.signature_hash=	_JC_JLONG(0xdb31203d1cd8df6a),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_visit_ClassSerializer$method$_init$db31203d1cd8df6a,
	.num_parameters=	5,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	7,
	      .table=	_jc_polyglot_visit_ClassSerializer$linenum_table$_init$db31203d1cd8df6a
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_visit_ClassSerializer, _init$db31203d1cd8df6a);

void _JC_JCNI_ATTR
_jc_polyglot_visit_ClassSerializer$method$_init$db31203d1cd8df6a(_jc_env *const env, _jc_polyglot_visit_ClassSerializer$object *this, _jc_object *param0, _jc_object *param1, _jc_java_util_Date$object *param2, _jc_object *param3, _jc_polyglot_main_Version$object *param4)
{
	struct _jc_polyglot_visit_ClassSerializer$object *r0;
	struct _jc_object *r1;
	struct _jc_object *r2;
	struct _jc_java_util_Date$object *r3;
	struct _jc_object *r4;
	struct _jc_polyglot_main_Version$object *r5;
	struct _jc_polyglot_util_TypeEncoder$object *r6;

	r0 = this;
	r1 = param0;
	r2 = param1;
	r3 = param2;
	r4 = param3;
	r5 = param4;
	_JC_LINE_NUMBER(25);				// 0
	_JC_REF_FIELD(env, r0, polyglot_visit_ClassSerializer, ts) = r1;
	_JC_LINE_NUMBER(26);				// 1
	_JC_REF_FIELD(env, r0, polyglot_visit_ClassSerializer, nf) = r2;
	_JC_LINE_NUMBER(27);				// 2
	r6 = _JC_NEW(env, polyglot_util_TypeEncoder);
	_JC_PRIM_FIELD(env, r6, polyglot_util_TypeEncoder, zip) = 1;
	_JC_PRIM_FIELD(env, r6, polyglot_util_TypeEncoder, base64) = 1;
	_JC_PRIM_FIELD(env, r6, polyglot_util_TypeEncoder, test) = 0;
	_JC_REF_FIELD(env, r6, polyglot_util_TypeEncoder, ts) = r1;
	_JC_REF_FIELD(env, r0, polyglot_visit_ClassSerializer, te) = r6;
	_JC_LINE_NUMBER(28);				// 3
	_JC_REF_FIELD(env, r0, polyglot_visit_ClassSerializer, eq) = r4;
	_JC_LINE_NUMBER(29);				// 4
	_JC_REF_FIELD(env, r0, polyglot_visit_ClassSerializer, date) = r3;
	_JC_LINE_NUMBER(30);				// 5
	_JC_REF_FIELD(env, r0, polyglot_visit_ClassSerializer, ver) = r5;
	_JC_LINE_NUMBER(31);				// 6
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public polyglot.ast.Node leave(polyglot.ast.Node, polyglot.ast.Node, polyglot.visit.NodeVisitor)
//

static _jc_linenum _jc_polyglot_visit_ClassSerializer$linenum_table$leave$cf18a0cab654af63[];

static _jc_trap_info _jc_polyglot_visit_ClassSerializer$trap_table$leave$cf18a0cab654af63[] = {
	_JC_TRAP(&_jc_java_io_IOException$type, 1, 2),
	_JC_TRAP(&_jc_java_io_IOException$type, 3, 4),
	_JC_TRAP(&_jc_java_io_IOException$type, 5, 6),
};

static const unsigned char _jc_polyglot_visit_ClassSerializer$param_ptypes$leave$cf18a0cab654af63[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_visit_ClassSerializer$param_types$leave$cf18a0cab654af63[] = {
	&_jc_polyglot_ast_Node$type,
	&_jc_polyglot_ast_Node$type,
	&_jc_polyglot_visit_NodeVisitor$type
};

_jc_method _jc_polyglot_visit_ClassSerializer$method_info$leave$cf18a0cab654af63 = {
	.name=			"leave",
	.signature=		"(Lpolyglot/ast/Node;Lpolyglot/ast/Node;Lpolyglot/visit/NodeVisitor;)Lpolyglot/ast/Node;",
	.class=			&_jc_polyglot_visit_ClassSerializer$type,
	.param_types=		&_jc_polyglot_visit_ClassSerializer$param_types$leave$cf18a0cab654af63,
	.return_type=		&_jc_polyglot_ast_Node$type,
	.param_ptypes=		&_jc_polyglot_visit_ClassSerializer$param_ptypes$leave$cf18a0cab654af63,
	.signature_hash=	_JC_JLONG(0xcf18a0cab654af63),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_visit_ClassSerializer$method$leave$cf18a0cab654af63,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_visit_ClassSerializer$vtable, polyglot_visit_ClassSerializer.leave$cf18a0cab654af63) / sizeof(void *),
	.num_parameters=	3,
	.u= { .exec= {
	  .trap_table_len=	3,
	  .trap_table=		_jc_polyglot_visit_ClassSerializer$trap_table$leave$cf18a0cab654af63,
	  .u= {
	    .linenum= {
	      .len=	41,
	      .table=	_jc_polyglot_visit_ClassSerializer$linenum_table$leave$cf18a0cab654af63
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_visit_ClassSerializer, leave$cf18a0cab654af63);

_jc_object * _JC_JCNI_ATTR
_jc_polyglot_visit_ClassSerializer$method$leave$cf18a0cab654af63(_jc_env *const env, _jc_polyglot_visit_ClassSerializer$object *this, _jc_object *param0, _jc_object *param1, _jc_polyglot_visit_NodeVisitor$object *param2)
{
	jint i1;
	jlong l0;
	struct _jc_polyglot_visit_ClassSerializer$object *volatile r0;
	struct _jc_object *r1;
	struct _jc_java_lang_String$object *r10;
	struct _jc_polyglot_util_Position$object *r11;
	struct _jc_object *r12;
	struct _jc_object *r13;
	struct _jc_object *r14;
	struct _jc_polyglot_main_Version$object *r15;
	struct _jc_object *volatile r16;
	struct _jc_polyglot_types_Flags$object *r17;
	struct _jc_object *r18;
	struct _jc_object *r19;
	struct _jc_object *volatile r2;
	struct _jc_object *r20;
	struct _jc_java_lang_String$object *r21;
	struct _jc_object *r22;
	struct _jc_polyglot_util_Position$object *r23;
	struct _jc_object *r24;
	struct _jc_polyglot_util_Position$object *r25;
	struct _jc_object *r26;
	struct _jc_object *r27;
	struct _jc_object *r28;
	struct _jc_object *r29;
	struct _jc_polyglot_visit_NodeVisitor$object *r3;
	struct _jc_java_util_Date$object *r30;
	struct _jc_object *r31;
	struct _jc_polyglot_ast_IntLit__24Kind$object *r32;
	struct _jc_object *r33;
	struct _jc_polyglot_util_TypeEncoder$object *r34;
	struct _jc_java_io_IOException$object *r35;
	struct _jc_java_lang_String$object *r36;
	struct _jc_java_lang_String$object *r37;
	struct _jc_java_lang_String$object *r38;
	struct _jc_java_lang_StringBuffer$object *r39;
	struct _jc_object *r4;
	struct _jc_java_lang_String$object *r40;
	struct _jc_java_lang_StringBuffer$object *r41;
	struct _jc_java_lang_String$object *r42;
	struct _jc_java_lang_StringBuffer$object *r43;
	struct _jc_java_lang_String$object *r44;
	struct _jc_java_lang_String$object *r45;
	struct _jc_java_lang_String$object *r46;
	struct _jc_java_lang_String$object *r47;
	struct _jc_java_lang_String$object *r48;
	_jc_char_array *r49;
	struct _jc_object *r5;
	_jc_char_array *r50;
	_jc_char_array *r51;
	_jc_char_array *r52;
	_jc_char_array *r53;
	_jc_char_array *r54;
	_jc_char_array *r55;
	struct _jc_object *r6;
	struct _jc_java_lang_String$object *r7;
	struct _jc_java_lang_StringBuffer$object *r8;
	struct _jc_polyglot_types_Flags$object *r9;
	jboolean z0;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_polyglot_visit_ClassSerializer$method_info$leave$cf18a0cab654af63, &&label4, &&label4, &&label4);

	r0 = this;
	r1 = param0;
	r2 = param1;
	r3 = param2;
	_JC_LINE_NUMBER(43);				// 0
	z0 = _JC_INSTANCEOF(env, r2, &_jc_polyglot_ast_ClassDecl$type);
	if (z0 != 0)
		goto label0;
	_JC_LINE_NUMBER(44);				// 1
	_JC_CANCEL_TRAPS(env, catch);
	return r2;

label0:
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(48);				// 2
	r4 = r2;
	_JC_LINE_NUMBER(49);				// 3
	r5 = _JC_INVOKE_INTERFACE(env, r4, _JC_JLONG(0x83b48a9cf9400739), _jc_object *, (_jc_env *, struct _jc_object *));
	_JC_LINE_NUMBER(50);				// 4
	r6 = _JC_INVOKE_INTERFACE(env, r4, _JC_JLONG(0x6c86d4f8302af557), _jc_object *, (_jc_env *, struct _jc_object *));
	_JC_LINE_NUMBER(55);				// 5
	_JC_INVOKE_INTERFACE(env, r6, _JC_JLONG(0xa0de450b63dde99e), _jc_object *, (_jc_env *, struct _jc_object *));
	_JC_LINE_NUMBER(56);				// 6
	_JC_INVOKE_INTERFACE(env, r6, _JC_JLONG(0x3035483ac14e90a3), _jc_object *, (_jc_env *, struct _jc_object *));
	_JC_LINE_NUMBER(57);				// 7
	_JC_INVOKE_INTERFACE(env, r6, _JC_JLONG(0xbf5d9ddf9f6db0b5), _jc_object *, (_jc_env *, struct _jc_object *));
	_JC_LINE_NUMBER(58);				// 8
	_JC_INVOKE_INTERFACE(env, r6, _JC_JLONG(0xb865ec1114c5eee2), _jc_object *, (_jc_env *, struct _jc_object *));
	_JC_LINE_NUMBER(59);				// 9
	_JC_INVOKE_INTERFACE(env, r6, _JC_JLONG(0x21fb0f87e8a38197), _jc_object *, (_jc_env *, struct _jc_object *));
	_JC_LINE_NUMBER(61);				// 10
	z0 = _JC_INVOKE_INTERFACE(env, r6, _JC_JLONG(0x8151bb95733bc24d), jboolean, (_jc_env *, struct _jc_object *));
	if (z0 != 0)
		goto label1;
	z0 = _JC_INVOKE_INTERFACE(env, r6, _JC_JLONG(0x809aeb741c9e4c32), jboolean, (_jc_env *, struct _jc_object *));
	if (z0 != 0)
		goto label1;
	_JC_TRAP_REGION(catch, 2);
	_JC_LINE_NUMBER(62);				// 11
	_JC_CANCEL_TRAPS(env, catch);
	return r2;

label1:
	_JC_TRAP_REGION(catch, 3);
	_JC_LINE_NUMBER(66);				// 12
	r15 = _JC_REF_FIELD(env, r0, polyglot_visit_ClassSerializer, ver);
	r7 = _JC_INVOKE_VIRTUAL(env, polyglot_main_Version, name$e6acce026cadf81e, r15);
	_JC_LINE_NUMBER(69);				// 13
	r8 = _JC_NEW(env, java_lang_StringBuffer);
	r49 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r8, java_lang_StringBuffer, value) = r49;
	r8 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r8, _JC_STRING(env, "jlc$CompilerVersion$"));
	r8 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r8, r7);
	r36 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r36, r8);
	r12 = _JC_INVOKE_INTERFACE(env, r6, _JC_JLONG(0x1b4dae10440afb3f), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_java_lang_String$object *), r36);
	if (r12 != _JC_NULL)
		goto label2;
	r8 = _JC_NEW(env, java_lang_StringBuffer);
	r50 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r8, java_lang_StringBuffer, value) = r50;
	r8 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r8, _JC_STRING(env, "jlc$SourceLastModified$"));
	r8 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r8, r7);
	r37 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r37, r8);
	r12 = _JC_INVOKE_INTERFACE(env, r6, _JC_JLONG(0x1b4dae10440afb3f), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_java_lang_String$object *), r37);
	if (r12 != _JC_NULL)
		goto label2;
	r8 = _JC_NEW(env, java_lang_StringBuffer);
	r51 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r8, java_lang_StringBuffer, value) = r51;
	r8 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r8, _JC_STRING(env, "jlc$ClassType$"));
	r8 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r8, r7);
	r38 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r38, r8);
	r12 = _JC_INVOKE_INTERFACE(env, r6, _JC_JLONG(0x1b4dae10440afb3f), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_java_lang_String$object *), r38);
	if (r12 == _JC_NULL)
		goto label3;

label2:
	_JC_LINE_NUMBER(73);				// 14
	r16 = _JC_REF_FIELD(env, r0, polyglot_visit_ClassSerializer, eq);
	_JC_INVOKE_INTERFACE(env, r16, _JC_JLONG(0x7659161d8f442ddb), void, (_jc_env *, struct _jc_object *, jint, struct _jc_java_lang_String$object *), 5, _JC_STRING(env, "Cannot serialize class information more than once."));
	_JC_TRAP_REGION(catch, 4);
	_JC_LINE_NUMBER(77);				// 15
	_JC_CANCEL_TRAPS(env, catch);
	return r2;

label3:
	_JC_TRAP_REGION(catch, 5);
	_JC_LINE_NUMBER(80);				// 16
	r9 = _JC_STATIC_FIELD(env, polyglot_types_Flags, PUBLIC, 0);
	r17 = _JC_STATIC_FIELD(env, polyglot_types_Flags, STATIC, 1);
	r17 = _JC_INVOKE_VIRTUAL(env, polyglot_types_Flags, set$341469a7d92d898a, r9, r17);
	r9 = _JC_STATIC_FIELD(env, polyglot_types_Flags, FINAL, 1);
	r9 = _JC_INVOKE_VIRTUAL(env, polyglot_types_Flags, set$341469a7d92d898a, r17, r9);
	_JC_LINE_NUMBER(87);				// 17
	r8 = _JC_NEW(env, java_lang_StringBuffer);
	r52 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r8, java_lang_StringBuffer, value) = r52;
	r15 = _JC_REF_FIELD(env, r0, polyglot_visit_ClassSerializer, ver);
	i1 = _JC_INVOKE_VIRTUAL(env, polyglot_main_Version, major$11e120a477900a2f, r15);
	r40 = _JC_INVOKE_STATIC(env, java_lang_Integer, toString$80d919d12afaaa2b, 0, i1, 10);
	r39 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r8, r40);
	r8 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 1, r39, _JC_STRING(env, "."));
	r15 = _JC_REF_FIELD(env, r0, polyglot_visit_ClassSerializer, ver);
	i1 = _JC_INVOKE_VIRTUAL(env, polyglot_main_Version, minor$206704e7c95168d6, r15);
	_JC_EXPLICIT_NULL_CHECK(env, r8);
	r42 = _JC_INVOKE_STATIC(env, java_lang_Integer, toString$80d919d12afaaa2b, 1, i1, 10);
	r41 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r8, r42);
	r8 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 1, r41, _JC_STRING(env, "."));
	r15 = _JC_REF_FIELD(env, r0, polyglot_visit_ClassSerializer, ver);
	i1 = _JC_INVOKE_VIRTUAL(env, polyglot_main_Version, patch__5flevel$c3db817585344b9f, r15);
	_JC_EXPLICIT_NULL_CHECK(env, r8);
	r44 = _JC_INVOKE_STATIC(env, java_lang_Integer, toString$80d919d12afaaa2b, 1, i1, 10);
	r43 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r8, r44);
	_JC_EXPLICIT_NULL_CHECK(env, r43);
	r45 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r45, r43);
	_JC_LINE_NUMBER(91);				// 18
	r11 = _JC_STATIC_FIELD(env, polyglot_util_Position, COMPILER__5fGENERATED, 0);
	_JC_LINE_NUMBER(93);				// 19
	r18 = _JC_REF_FIELD(env, r0, polyglot_visit_ClassSerializer, ts);
	r19 = _JC_REF_FIELD(env, r0, polyglot_visit_ClassSerializer, ts);
	r20 = _JC_INVOKE_INTERFACE(env, r19, _JC_JLONG(0x8051b0f541e1a5b2), _jc_object *, (_jc_env *, struct _jc_object *));
	r8 = _JC_NEW(env, java_lang_StringBuffer);
	r53 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r8, java_lang_StringBuffer, value) = r53;
	r8 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r8, _JC_STRING(env, "jlc$CompilerVersion$"));
	r8 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r8, r7);
	r46 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r46, r8);
	r12 = _JC_INVOKE_INTERFACE(env, r18, _JC_JLONG(0x1d2f4914e8b7c9f6), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_polyglot_util_Position$object *, struct _jc_object *, struct _jc_polyglot_types_Flags$object *, struct _jc_object *, struct _jc_java_lang_String$object *), r11, r6, r9, r20, r46);
	_JC_LINE_NUMBER(96);				// 20
	r19 = _JC_REF_FIELD(env, r0, polyglot_visit_ClassSerializer, ts);
	r17 = _JC_STATIC_FIELD(env, polyglot_types_Flags, STATIC, 1);
	r13 = _JC_INVOKE_INTERFACE(env, r19, _JC_JLONG(0x6bbe261c550cb6bd), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_polyglot_util_Position$object *, struct _jc_object *, struct _jc_polyglot_types_Flags$object *), r11, r6, r17);
	_JC_LINE_NUMBER(97);				// 21
	r22 = _JC_REF_FIELD(env, r0, polyglot_visit_ClassSerializer, nf);
	r23 = _JC_INVOKE_INTERFACE(env, r12, _JC_JLONG(0xbb89333b1e4c840c), _jc_object *, (_jc_env *, struct _jc_object *));
	r17 = _JC_INVOKE_INTERFACE(env, r12, _JC_JLONG(0xbdfb01ac8f620c5e), _jc_object *, (_jc_env *, struct _jc_object *));
	r24 = _JC_REF_FIELD(env, r0, polyglot_visit_ClassSerializer, nf);
	r25 = _JC_INVOKE_INTERFACE(env, r12, _JC_JLONG(0xbb89333b1e4c840c), _jc_object *, (_jc_env *, struct _jc_object *));
	r26 = _JC_INVOKE_INTERFACE(env, r12, _JC_JLONG(0xb7282830a20ab2a3), _jc_object *, (_jc_env *, struct _jc_object *));
	r27 = _JC_INVOKE_INTERFACE(env, r24, _JC_JLONG(0x890196a84d160f7e), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_polyglot_util_Position$object *, struct _jc_object *), r25, r26);
	r21 = _JC_INVOKE_INTERFACE(env, r12, _JC_JLONG(0xe6acce026cadf81e), _jc_object *, (_jc_env *, struct _jc_object *));
	r24 = _JC_REF_FIELD(env, r0, polyglot_visit_ClassSerializer, nf);
	r28 = _JC_INVOKE_INTERFACE(env, r24, _JC_JLONG(0x61345b0024c6b103), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_polyglot_util_Position$object *, struct _jc_java_lang_String$object *), r11, r45);
	r19 = _JC_REF_FIELD(env, r0, polyglot_visit_ClassSerializer, ts);
	r20 = _JC_INVOKE_INTERFACE(env, r19, _JC_JLONG(0x8051b0f541e1a5b2), _jc_object *, (_jc_env *, struct _jc_object *));
	r29 = _JC_INVOKE_INTERFACE(env, r28, _JC_JLONG(0x94f55d0c5048b093), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_object *), r20);
	r14 = _JC_INVOKE_INTERFACE(env, r22, _JC_JLONG(0xd174bb6ab03d7dfc), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_polyglot_util_Position$object *, struct _jc_polyglot_types_Flags$object *, struct _jc_object *, struct _jc_java_lang_String$object *, struct _jc_object *), r23, r17, r27, r21, r29);
	_JC_LINE_NUMBER(102);				// 22
	r14 = _JC_INVOKE_INTERFACE(env, r14, _JC_JLONG(0x3699b5f40a4eefba), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_object *), r12);
	_JC_LINE_NUMBER(103);				// 23
	r14 = _JC_INVOKE_INTERFACE(env, r14, _JC_JLONG(0x5328abed651ba165), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_object *), r13);
	_JC_LINE_NUMBER(104);				// 24
	r5 = _JC_INVOKE_INTERFACE(env, r5, _JC_JLONG(0xfffe520e693336fa), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_object *), r14);
	_JC_LINE_NUMBER(107);				// 25
	r30 = _JC_REF_FIELD(env, r0, polyglot_visit_ClassSerializer, date);
	l0 = _JC_INVOKE_VIRTUAL(env, java_util_Date, getTime$5fabbaa41130db0f, r30);
	_JC_LINE_NUMBER(109);				// 26
	r19 = _JC_REF_FIELD(env, r0, polyglot_visit_ClassSerializer, ts);
	r18 = _JC_REF_FIELD(env, r0, polyglot_visit_ClassSerializer, ts);
	r31 = _JC_INVOKE_INTERFACE(env, r18, _JC_JLONG(0x3f9115aad1b16e63), _jc_object *, (_jc_env *, struct _jc_object *));
	r8 = _JC_NEW(env, java_lang_StringBuffer);
	r54 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r8, java_lang_StringBuffer, value) = r54;
	r8 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r8, _JC_STRING(env, "jlc$SourceLastModified$"));
	r8 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r8, r7);
	r47 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r47, r8);
	r12 = _JC_INVOKE_INTERFACE(env, r19, _JC_JLONG(0x1d2f4914e8b7c9f6), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_polyglot_util_Position$object *, struct _jc_object *, struct _jc_polyglot_types_Flags$object *, struct _jc_object *, struct _jc_java_lang_String$object *), r11, r6, r9, r31, r47);
	_JC_LINE_NUMBER(112);				// 27
	r19 = _JC_REF_FIELD(env, r0, polyglot_visit_ClassSerializer, ts);
	r17 = _JC_STATIC_FIELD(env, polyglot_types_Flags, STATIC, 1);
	r13 = _JC_INVOKE_INTERFACE(env, r19, _JC_JLONG(0x6bbe261c550cb6bd), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_polyglot_util_Position$object *, struct _jc_object *, struct _jc_polyglot_types_Flags$object *), r11, r6, r17);
	_JC_LINE_NUMBER(113);				// 28
	r24 = _JC_REF_FIELD(env, r0, polyglot_visit_ClassSerializer, nf);
	r25 = _JC_INVOKE_INTERFACE(env, r12, _JC_JLONG(0xbb89333b1e4c840c), _jc_object *, (_jc_env *, struct _jc_object *));
	r17 = _JC_INVOKE_INTERFACE(env, r12, _JC_JLONG(0xbdfb01ac8f620c5e), _jc_object *, (_jc_env *, struct _jc_object *));
	r22 = _JC_REF_FIELD(env, r0, polyglot_visit_ClassSerializer, nf);
	r23 = _JC_INVOKE_INTERFACE(env, r12, _JC_JLONG(0xbb89333b1e4c840c), _jc_object *, (_jc_env *, struct _jc_object *));
	r26 = _JC_INVOKE_INTERFACE(env, r12, _JC_JLONG(0xb7282830a20ab2a3), _jc_object *, (_jc_env *, struct _jc_object *));
	r27 = _JC_INVOKE_INTERFACE(env, r22, _JC_JLONG(0x890196a84d160f7e), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_polyglot_util_Position$object *, struct _jc_object *), r23, r26);
	r21 = _JC_INVOKE_INTERFACE(env, r12, _JC_JLONG(0xe6acce026cadf81e), _jc_object *, (_jc_env *, struct _jc_object *));
	r22 = _JC_REF_FIELD(env, r0, polyglot_visit_ClassSerializer, nf);
	r32 = _JC_STATIC_FIELD(env, polyglot_ast_IntLit, LONG, 0);
	r33 = _JC_INVOKE_INTERFACE(env, r22, _JC_JLONG(0x5d2c08bba9e4ebd), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_polyglot_util_Position$object *, struct _jc_polyglot_ast_IntLit__24Kind$object *, jlong), r11, r32, l0);
	r19 = _JC_REF_FIELD(env, r0, polyglot_visit_ClassSerializer, ts);
	r31 = _JC_INVOKE_INTERFACE(env, r19, _JC_JLONG(0x3f9115aad1b16e63), _jc_object *, (_jc_env *, struct _jc_object *));
	r29 = _JC_INVOKE_INTERFACE(env, r33, _JC_JLONG(0x94f55d0c5048b093), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_object *), r31);
	r14 = _JC_INVOKE_INTERFACE(env, r24, _JC_JLONG(0xd174bb6ab03d7dfc), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_polyglot_util_Position$object *, struct _jc_polyglot_types_Flags$object *, struct _jc_object *, struct _jc_java_lang_String$object *, struct _jc_object *), r25, r17, r27, r21, r29);
	_JC_LINE_NUMBER(118);				// 29
	r14 = _JC_INVOKE_INTERFACE(env, r14, _JC_JLONG(0x3699b5f40a4eefba), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_object *), r12);
	_JC_LINE_NUMBER(119);				// 30
	r14 = _JC_INVOKE_INTERFACE(env, r14, _JC_JLONG(0x5328abed651ba165), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_object *), r13);
	_JC_LINE_NUMBER(120);				// 31
	r5 = _JC_INVOKE_INTERFACE(env, r5, _JC_JLONG(0xfffe520e693336fa), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_object *), r14);
	_JC_LINE_NUMBER(123);				// 32
	r19 = _JC_REF_FIELD(env, r0, polyglot_visit_ClassSerializer, ts);
	r18 = _JC_REF_FIELD(env, r0, polyglot_visit_ClassSerializer, ts);
	r20 = _JC_INVOKE_INTERFACE(env, r18, _JC_JLONG(0x8051b0f541e1a5b2), _jc_object *, (_jc_env *, struct _jc_object *));
	r8 = _JC_NEW(env, java_lang_StringBuffer);
	r55 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r8, java_lang_StringBuffer, value) = r55;
	r8 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r8, _JC_STRING(env, "jlc$ClassType$"));
	r8 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r8, r7);
	r48 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r48, r8);
	r12 = _JC_INVOKE_INTERFACE(env, r19, _JC_JLONG(0x1d2f4914e8b7c9f6), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_polyglot_util_Position$object *, struct _jc_object *, struct _jc_polyglot_types_Flags$object *, struct _jc_object *, struct _jc_java_lang_String$object *), r11, r6, r9, r20, r48);
	_JC_LINE_NUMBER(126);				// 33
	r19 = _JC_REF_FIELD(env, r0, polyglot_visit_ClassSerializer, ts);
	r17 = _JC_STATIC_FIELD(env, polyglot_types_Flags, STATIC, 1);
	r13 = _JC_INVOKE_INTERFACE(env, r19, _JC_JLONG(0x6bbe261c550cb6bd), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_polyglot_util_Position$object *, struct _jc_object *, struct _jc_polyglot_types_Flags$object *), r11, r6, r17);
	_JC_LINE_NUMBER(127);				// 34
	r24 = _JC_REF_FIELD(env, r0, polyglot_visit_ClassSerializer, nf);
	r25 = _JC_INVOKE_INTERFACE(env, r12, _JC_JLONG(0xbb89333b1e4c840c), _jc_object *, (_jc_env *, struct _jc_object *));
	r17 = _JC_INVOKE_INTERFACE(env, r12, _JC_JLONG(0xbdfb01ac8f620c5e), _jc_object *, (_jc_env *, struct _jc_object *));
	r22 = _JC_REF_FIELD(env, r0, polyglot_visit_ClassSerializer, nf);
	r23 = _JC_INVOKE_INTERFACE(env, r12, _JC_JLONG(0xbb89333b1e4c840c), _jc_object *, (_jc_env *, struct _jc_object *));
	r26 = _JC_INVOKE_INTERFACE(env, r12, _JC_JLONG(0xb7282830a20ab2a3), _jc_object *, (_jc_env *, struct _jc_object *));
	r27 = _JC_INVOKE_INTERFACE(env, r22, _JC_JLONG(0x890196a84d160f7e), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_polyglot_util_Position$object *, struct _jc_object *), r23, r26);
	r21 = _JC_INVOKE_INTERFACE(env, r12, _JC_JLONG(0xe6acce026cadf81e), _jc_object *, (_jc_env *, struct _jc_object *));
	r22 = _JC_REF_FIELD(env, r0, polyglot_visit_ClassSerializer, nf);
	r34 = _JC_REF_FIELD(env, r0, polyglot_visit_ClassSerializer, te);
	r10 = _JC_INVOKE_VIRTUAL(env, polyglot_util_TypeEncoder, encode$5a76d9ae1ffe7939, r34, r6);
	r28 = _JC_INVOKE_INTERFACE(env, r22, _JC_JLONG(0x61345b0024c6b103), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_polyglot_util_Position$object *, struct _jc_java_lang_String$object *), r11, r10);
	r19 = _JC_REF_FIELD(env, r0, polyglot_visit_ClassSerializer, ts);
	r20 = _JC_INVOKE_INTERFACE(env, r19, _JC_JLONG(0x8051b0f541e1a5b2), _jc_object *, (_jc_env *, struct _jc_object *));
	r29 = _JC_INVOKE_INTERFACE(env, r28, _JC_JLONG(0x94f55d0c5048b093), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_object *), r20);
	r14 = _JC_INVOKE_INTERFACE(env, r24, _JC_JLONG(0xd174bb6ab03d7dfc), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_polyglot_util_Position$object *, struct _jc_polyglot_types_Flags$object *, struct _jc_object *, struct _jc_java_lang_String$object *, struct _jc_object *), r25, r17, r27, r21, r29);
	_JC_LINE_NUMBER(132);				// 35
	r14 = _JC_INVOKE_INTERFACE(env, r14, _JC_JLONG(0x3699b5f40a4eefba), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_object *), r12);
	_JC_LINE_NUMBER(133);				// 36
	r14 = _JC_INVOKE_INTERFACE(env, r14, _JC_JLONG(0x5328abed651ba165), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_object *), r13);
	_JC_LINE_NUMBER(134);				// 37
	r5 = _JC_INVOKE_INTERFACE(env, r5, _JC_JLONG(0xfffe520e693336fa), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_object *), r14);
	_JC_LINE_NUMBER(136);				// 38
	r4 = _JC_INVOKE_INTERFACE(env, r4, _JC_JLONG(0xd13ef59027c252af), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_object *), r5);
	_JC_TRAP_REGION(catch, 6);
	_JC_CANCEL_TRAPS(env, catch);
	return r4;

label4:
	_JC_TRAP_REGION(catch, 6);
	r35 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(139);				// 39
	r16 = _JC_REF_FIELD(env, r0, polyglot_visit_ClassSerializer, eq);
	_JC_INVOKE_INTERFACE(env, r16, _JC_JLONG(0x7659161d8f442ddb), void, (_jc_env *, struct _jc_object *, jint, struct _jc_java_lang_String$object *), 2, _JC_STRING(env, "Unable to serialize class information."));
	_JC_LINE_NUMBER(141);				// 40
	_JC_CANCEL_TRAPS(env, catch);
	return r2;
}

//
// public polyglot.ast.Node override(polyglot.ast.Node)
//

static _jc_linenum _jc_polyglot_visit_ClassSerializer$linenum_table$override$1e05b257002785f7[];

static const unsigned char _jc_polyglot_visit_ClassSerializer$param_ptypes$override$1e05b257002785f7[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_visit_ClassSerializer$param_types$override$1e05b257002785f7[] = {
	&_jc_polyglot_ast_Node$type
};

_jc_method _jc_polyglot_visit_ClassSerializer$method_info$override$1e05b257002785f7 = {
	.name=			"override",
	.signature=		"(Lpolyglot/ast/Node;)Lpolyglot/ast/Node;",
	.class=			&_jc_polyglot_visit_ClassSerializer$type,
	.param_types=		&_jc_polyglot_visit_ClassSerializer$param_types$override$1e05b257002785f7,
	.return_type=		&_jc_polyglot_ast_Node$type,
	.param_ptypes=		&_jc_polyglot_visit_ClassSerializer$param_ptypes$override$1e05b257002785f7,
	.signature_hash=	_JC_JLONG(0x1e05b257002785f7),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_visit_ClassSerializer$method$override$1e05b257002785f7,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_visit_ClassSerializer$vtable, polyglot_visit_ClassSerializer.override$1e05b257002785f7) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_polyglot_visit_ClassSerializer$linenum_table$override$1e05b257002785f7
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_visit_ClassSerializer, override$1e05b257002785f7);

_jc_object * _JC_JCNI_ATTR
_jc_polyglot_visit_ClassSerializer$method$override$1e05b257002785f7(_jc_env *const env, _jc_polyglot_visit_ClassSerializer$object *this, _jc_object *param0)
{
	struct _jc_polyglot_visit_ClassSerializer$object *r0;
	struct _jc_object *r1;
	jboolean z0;

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(35);				// 0
	z0 = _JC_INSTANCEOF(env, r1, &_jc_polyglot_ast_ClassMember$type);
	if (z0 == 0)
		goto label0;
	z0 = _JC_INSTANCEOF(env, r1, &_jc_polyglot_ast_ClassDecl$type);
	if (z0 != 0)
		goto label0;
	_JC_LINE_NUMBER(36);				// 1
	return r1;

label0:
	_JC_LINE_NUMBER(39);				// 2
	return _JC_NULL;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_polyglot_visit_ClassSerializer$methods[] = {
	&_jc_polyglot_visit_ClassSerializer$method_info$_init$db31203d1cd8df6a,
	&_jc_polyglot_visit_ClassSerializer$method_info$leave$cf18a0cab654af63,
	&_jc_polyglot_visit_ClassSerializer$method_info$override$1e05b257002785f7
};

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_polyglot_visit_ClassSerializer$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_visit_ClassSerializer$instanceof_hash_bucket_105[] = {
	&_jc_polyglot_visit_ClassSerializer$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_visit_ClassSerializer$instanceof_hash_bucket_112[] = {
	&_jc_polyglot_visit_NodeVisitor$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_polyglot_visit_ClassSerializer$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[101]=	_jc_polyglot_visit_ClassSerializer$instanceof_hash_bucket_101,
	[105]=	_jc_polyglot_visit_ClassSerializer$instanceof_hash_bucket_105,
	[112]=	_jc_polyglot_visit_ClassSerializer$instanceof_hash_bucket_112
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_polyglot_visit_ClassSerializer$class_depends[] = {
	{ "java/io/IOException",	_JC_JLONG(0x4e0a56550c69d57c) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/Integer",	_JC_JLONG(0xca631501391a31f1) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/StringBuffer",	_JC_JLONG(0x94d357637b968dda) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/util/Date",	_JC_JLONG(0xa85d2a51094e614c) },
	{ "polyglot/ast/CanonicalTypeNode",	_JC_JLONG(0x6d0ea1efc315a28) },
	{ "polyglot/ast/ClassBody",	_JC_JLONG(0xb4472f169efc874e) },
	{ "polyglot/ast/ClassDecl",	_JC_JLONG(0x1dd06ab52424cd00) },
	{ "polyglot/ast/ClassMember",	_JC_JLONG(0x797e2651f43d6015) },
	{ "polyglot/ast/Expr",	_JC_JLONG(0xa33c697a7834ba70) },
	{ "polyglot/ast/FieldDecl",	_JC_JLONG(0x3e5dc0670fa8c08c) },
	{ "polyglot/ast/IntLit",	_JC_JLONG(0x54f56503db424b65) },
	{ "polyglot/ast/IntLit$Kind",	_JC_JLONG(0x2930cd94f99deb68) },
	{ "polyglot/ast/Node",	_JC_JLONG(0x1c402b4f9747e08) },
	{ "polyglot/ast/NodeFactory",	_JC_JLONG(0x56625b3befab19f) },
	{ "polyglot/ast/StringLit",	_JC_JLONG(0x95e3a5ad05b642e8) },
	{ "polyglot/main/Version",	_JC_JLONG(0x4ba1325a7aefecac) },
	{ "polyglot/types/ClassType",	_JC_JLONG(0xb38560af658974f8) },
	{ "polyglot/types/FieldInstance",	_JC_JLONG(0xd4beb04c35c42bde) },
	{ "polyglot/types/Flags",	_JC_JLONG(0x821eb65d8f2f30f6) },
	{ "polyglot/types/InitializerInstance",	_JC_JLONG(0xb7281cf8e3a14f14) },
	{ "polyglot/types/ParsedClassType",	_JC_JLONG(0x6bcfbf52304f9e7c) },
	{ "polyglot/types/PrimitiveType",	_JC_JLONG(0xc9050be6d71cb6f4) },
	{ "polyglot/types/Type",	_JC_JLONG(0x6596051546781098) },
	{ "polyglot/types/TypeSystem",	_JC_JLONG(0xed171cdaca38ec28) },
	{ "polyglot/util/ErrorQueue",	_JC_JLONG(0xff712c8463bdfdc0) },
	{ "polyglot/util/Position",	_JC_JLONG(0x32c9a088c5dac046) },
	{ "polyglot/util/TypeEncoder",	_JC_JLONG(0xf299688fad53c0b2) },
	{ "polyglot/visit/NodeVisitor",	_JC_JLONG(0x534db787197439f0) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_polyglot_visit_ClassSerializer$vtype _jc_polyglot_visit_ClassSerializer$type = {
    .type= {
	.name=			"polyglot/visit/ClassSerializer",
	.superclass=		&_jc_polyglot_visit_NodeVisitor$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		24,
		.hash=			_JC_JLONG(0xe58a5b7c83230169),
		.source_file=		"ClassSerializer.java",
		.instance_size=		sizeof(_jc_polyglot_visit_ClassSerializer$refs) + sizeof(_jc_polyglot_visit_ClassSerializer$object),
		.num_virtual_refs=	6,
		.num_fields=		sizeof(_jc_polyglot_visit_ClassSerializer$fields) / sizeof(*_jc_polyglot_visit_ClassSerializer$fields),
		.fields=		_jc_polyglot_visit_ClassSerializer$fields,
		.num_methods=		sizeof(_jc_polyglot_visit_ClassSerializer$methods) / sizeof(*_jc_polyglot_visit_ClassSerializer$methods),
		.methods=		_jc_polyglot_visit_ClassSerializer$methods,
		.instanceof_hash_table=	_jc_polyglot_visit_ClassSerializer$instanceof_hash_table,
		.num_class_depends=		sizeof(_jc_polyglot_visit_ClassSerializer$class_depends) / sizeof(*_jc_polyglot_visit_ClassSerializer$class_depends),
		.class_depends=		_jc_polyglot_visit_ClassSerializer$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=			// overridden
		&_jc_polyglot_visit_NodeVisitor$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.polyglot_visit_NodeVisitor= {
	    .begin$914d55e002815404=
		&_jc_polyglot_visit_NodeVisitor$method$begin$914d55e002815404,
	    .enter$a8ce2b9db363b202=
		&_jc_polyglot_visit_NodeVisitor$method$enter$a8ce2b9db363b202,
	    .enter$0698e71b16532e07=
		&_jc_polyglot_visit_NodeVisitor$method$enter$0698e71b16532e07,
	    .finish$8d1c944274527186=
		&_jc_polyglot_visit_NodeVisitor$method$finish$8d1c944274527186,
	    .finish$ed6d1946240badd4=
		&_jc_polyglot_visit_NodeVisitor$method$finish$ed6d1946240badd4,
	    .leave$d95680aeadf04833=
		&_jc_polyglot_visit_NodeVisitor$method$leave$d95680aeadf04833,
	    .leave$cf18a0cab654af63=			// overridden
		&_jc_polyglot_visit_ClassSerializer$method$leave$cf18a0cab654af63,
	    .override$1e05b257002785f7=			// overridden
		&_jc_polyglot_visit_ClassSerializer$method$override$1e05b257002785f7,
	    .override$b414405487168b9b=
		&_jc_polyglot_visit_NodeVisitor$method$override$b414405487168b9b,
	    .toString$7ea43b33b80a3070=
		&_jc_polyglot_visit_NodeVisitor$method$toString$7ea43b33b80a3070,
	    .visitEdge$35f9fc3d698a8550=
		&_jc_polyglot_visit_NodeVisitor$method$visitEdge$35f9fc3d698a8550,
	},
	.polyglot_visit_ClassSerializer= {
	    .leave$cf18a0cab654af63=
		&_jc_polyglot_visit_ClassSerializer$method$leave$cf18a0cab654af63,
	    .override$1e05b257002785f7=
		&_jc_polyglot_visit_ClassSerializer$method$override$1e05b257002785f7,
	},
    }
};

