// public class polyglot.visit.FlattenVisitor

// class file dependencies
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class ca631501391a31f1 java_lang_Integer
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 94d357637b968dda java_lang_StringBuffer
// @dep_class 8ea716c64b77f8eb java_util_AbstractCollection
// @dep_class f5238436362828db java_util_AbstractList
// @dep_class 6d7997e879c41059 java_util_AbstractSequentialList
// @dep_class 666417b6279ae396 java_util_LinkedList
// @dep_class 9ee0d92ce1525a4d java_util_List
// @dep_class 528a1e885893fafb polyglot_ast_Assign
// @dep_class 5eda5b679dfeb2f7 polyglot_ast_Block
// @dep_class 6d0ea1efc315a28 polyglot_ast_CanonicalTypeNode
// @dep_class dabf1f0efcc72d0a polyglot_ast_ConstructorCall
// @dep_class 2286a4785e8dc2 polyglot_ast_Eval
// @dep_class a33c697a7834ba70 polyglot_ast_Expr
// @dep_class 3e5dc0670fa8c08c polyglot_ast_FieldDecl
// @dep_class cbd56ac2ea46c2ea polyglot_ast_Lit
// @dep_class 363bd895d3e0630c polyglot_ast_Local
// @dep_class 9d6588c1cb1a2f31 polyglot_ast_LocalDecl
// @dep_class 1c402b4f9747e08 polyglot_ast_Node
// @dep_class 56625b3befab19f polyglot_ast_NodeFactory
// @dep_class c1d83578c0371206 polyglot_ast_Special
// @dep_class de1430f3b100a09a polyglot_ast_Stmt
// @dep_class 821eb65d8f2f30f6 polyglot_types_Flags
// @dep_class 143a5bf23e0f6584 polyglot_types_LocalInstance
// @dep_class 6596051546781098 polyglot_types_Type
// @dep_class ed171cdaca38ec28 polyglot_types_TypeSystem
// @dep_class 32c9a088c5dac046 polyglot_util_Position
// @dep_class 3a8a58ab836c0c23 polyglot_visit_FlattenVisitor
// @dep_class 534db787197439f0 polyglot_visit_NodeVisitor

// header file dependencies
// @dep_header java_lang_Class
// @dep_header java_lang_Integer
// @dep_header java_lang_String
// @dep_header java_lang_StringBuffer
// @dep_header java_util_LinkedList
// @dep_header java_util_List
// @dep_header polyglot_ast_Assign
// @dep_header polyglot_ast_Block
// @dep_header polyglot_ast_CanonicalTypeNode
// @dep_header polyglot_ast_ConstructorCall
// @dep_header polyglot_ast_Eval
// @dep_header polyglot_ast_Expr
// @dep_header polyglot_ast_FieldDecl
// @dep_header polyglot_ast_Lit
// @dep_header polyglot_ast_Local
// @dep_header polyglot_ast_LocalDecl
// @dep_header polyglot_ast_Node
// @dep_header polyglot_ast_NodeFactory
// @dep_header polyglot_ast_Special
// @dep_header polyglot_ast_Stmt
// @dep_header polyglot_types_Flags
// @dep_header polyglot_types_LocalInstance
// @dep_header polyglot_types_Type
// @dep_header polyglot_types_TypeSystem
// @dep_header polyglot_util_Position
// @dep_header polyglot_visit_FlattenVisitor

#include "jc_defs.h"

#include "java/lang/Class.h"
#include "java/lang/Integer.h"
#include "java/lang/String.h"
#include "java/lang/StringBuffer.h"
#include "java/util/LinkedList.h"
#include "java/util/List.h"
#include "polyglot/ast/Assign.h"
#include "polyglot/ast/Block.h"
#include "polyglot/ast/CanonicalTypeNode.h"
#include "polyglot/ast/ConstructorCall.h"
#include "polyglot/ast/Eval.h"
#include "polyglot/ast/Expr.h"
#include "polyglot/ast/FieldDecl.h"
#include "polyglot/ast/Lit.h"
#include "polyglot/ast/Local.h"
#include "polyglot/ast/LocalDecl.h"
#include "polyglot/ast/Node.h"
#include "polyglot/ast/NodeFactory.h"
#include "polyglot/ast/Special.h"
#include "polyglot/ast/Stmt.h"
#include "polyglot/types/Flags.h"
#include "polyglot/types/LocalInstance.h"
#include "polyglot/types/Type.h"
#include "polyglot/types/TypeSystem.h"
#include "polyglot/util/Position.h"
#include "polyglot/visit/FlattenVisitor.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// protected polyglot.types.TypeSystem ts
static _jc_field _jc_polyglot_visit_FlattenVisitor$field_info$ts = {
	.name=		"ts",
	.signature=	"Lpolyglot/types/TypeSystem;",
	.class=		&_jc_polyglot_visit_FlattenVisitor$type,
	.type=		&_jc_polyglot_types_TypeSystem$type,
	.access_flags=	_JC_ACC_PROTECTED,
	.offset=	_JC_OFFSETOF(_jc_polyglot_visit_FlattenVisitor$object, refs[-1].polyglot_visit_FlattenVisitor.ts),
};

// protected polyglot.ast.NodeFactory nf
static _jc_field _jc_polyglot_visit_FlattenVisitor$field_info$nf = {
	.name=		"nf",
	.signature=	"Lpolyglot/ast/NodeFactory;",
	.class=		&_jc_polyglot_visit_FlattenVisitor$type,
	.type=		&_jc_polyglot_ast_NodeFactory$type,
	.access_flags=	_JC_ACC_PROTECTED,
	.offset=	_JC_OFFSETOF(_jc_polyglot_visit_FlattenVisitor$object, refs[-1].polyglot_visit_FlattenVisitor.nf),
};

// protected java.util.LinkedList stack
static _jc_field _jc_polyglot_visit_FlattenVisitor$field_info$stack = {
	.name=		"stack",
	.signature=	"Ljava/util/LinkedList;",
	.class=		&_jc_polyglot_visit_FlattenVisitor$type,
	.type=		&_jc_java_util_LinkedList$type,
	.access_flags=	_JC_ACC_PROTECTED,
	.offset=	_JC_OFFSETOF(_jc_polyglot_visit_FlattenVisitor$object, refs[-1].polyglot_visit_FlattenVisitor.stack),
};

// protected static int count
static _jc_field _jc_polyglot_visit_FlattenVisitor$field_info$count = {
	.name=		"count",
	.signature=	"I",
	.class=		&_jc_polyglot_visit_FlattenVisitor$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PROTECTED|_JC_ACC_STATIC,
	.offset=	_JC_OFFSETOF(_jc_polyglot_visit_FlattenVisitor$fields_struct, count),
};

// protected polyglot.ast.Node noFlatten
static _jc_field _jc_polyglot_visit_FlattenVisitor$field_info$noFlatten = {
	.name=		"noFlatten",
	.signature=	"Lpolyglot/ast/Node;",
	.class=		&_jc_polyglot_visit_FlattenVisitor$type,
	.type=		&_jc_polyglot_ast_Node$type,
	.access_flags=	_JC_ACC_PROTECTED,
	.offset=	_JC_OFFSETOF(_jc_polyglot_visit_FlattenVisitor$object, refs[-1].polyglot_visit_FlattenVisitor.noFlatten),
};

// Fields
static _jc_field *const _jc_polyglot_visit_FlattenVisitor$fields[] = {
	&_jc_polyglot_visit_FlattenVisitor$field_info$count,
	&_jc_polyglot_visit_FlattenVisitor$field_info$nf,
	&_jc_polyglot_visit_FlattenVisitor$field_info$noFlatten,
	&_jc_polyglot_visit_FlattenVisitor$field_info$stack,
	&_jc_polyglot_visit_FlattenVisitor$field_info$ts
};

/************************************************************************
 *			      Static methods				*
 ************************************************************************/

//
// static void <clinit>()
//

static _jc_linenum _jc_polyglot_visit_FlattenVisitor$linenum_table$_clinit$a816641e0ba8bfef[];

static const unsigned char _jc_polyglot_visit_FlattenVisitor$param_ptypes$_clinit$a816641e0ba8bfef[] = { 
_JC_TYPE_VOID };

_jc_method _jc_polyglot_visit_FlattenVisitor$method_info$_clinit$a816641e0ba8bfef = {
	.name=			"<clinit>",
	.signature=		"()V",
	.class=			&_jc_polyglot_visit_FlattenVisitor$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_visit_FlattenVisitor$param_ptypes$_clinit$a816641e0ba8bfef,
	.signature_hash=	_JC_JLONG(0xa816641e0ba8bfef),
	.access_flags=		_JC_ACC_STATIC,
	.function=		&_jc_polyglot_visit_FlattenVisitor$method$_clinit$a816641e0ba8bfef,
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_visit_FlattenVisitor$linenum_table$_clinit$a816641e0ba8bfef
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_visit_FlattenVisitor, _clinit$a816641e0ba8bfef);

void _JC_JCNI_ATTR
_jc_polyglot_visit_FlattenVisitor$method$_clinit$a816641e0ba8bfef(_jc_env *const env)
{
	_JC_LINE_NUMBER(31);				// 0
	_JC_STATIC_FIELD(env, polyglot_visit_FlattenVisitor, count, 1) = 0;
	return;
}

//
// protected static java.lang.String newID()
//

static _jc_linenum _jc_polyglot_visit_FlattenVisitor$linenum_table$newID$87051e1cf288e0d9[];

static const unsigned char _jc_polyglot_visit_FlattenVisitor$param_ptypes$newID$87051e1cf288e0d9[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_visit_FlattenVisitor$method_info$newID$87051e1cf288e0d9 = {
	.name=			"newID",
	.signature=		"()Ljava/lang/String;",
	.class=			&_jc_polyglot_visit_FlattenVisitor$type,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_polyglot_visit_FlattenVisitor$param_ptypes$newID$87051e1cf288e0d9,
	.signature_hash=	_JC_JLONG(0x87051e1cf288e0d9),
	.access_flags=		_JC_ACC_PROTECTED|_JC_ACC_STATIC,
	.function=		&_jc_polyglot_visit_FlattenVisitor$method$newID$87051e1cf288e0d9,
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_visit_FlattenVisitor$linenum_table$newID$87051e1cf288e0d9
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_visit_FlattenVisitor, newID$87051e1cf288e0d9);

_jc_java_lang_String$object * _JC_JCNI_ATTR
_jc_polyglot_visit_FlattenVisitor$method$newID$87051e1cf288e0d9(_jc_env *const env)
{
	jint i0;
	jint i1;
	struct _jc_java_lang_StringBuffer$object *r0;
	struct _jc_java_lang_StringBuffer$object *r1;
	struct _jc_java_lang_String$object *r2;
	struct _jc_java_lang_String$object *r3;
	_jc_char_array *r4;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	_JC_LINE_NUMBER(34);				// 0
	r0 = _JC_NEW(env, java_lang_StringBuffer);
	r4 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r0, java_lang_StringBuffer, value) = r4;
	r0 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r0, _JC_STRING(env, "flat$$$"));
	i0 = _JC_STATIC_FIELD(env, polyglot_visit_FlattenVisitor, count, 1);
	i1 = i0 + 1;
	_JC_STATIC_FIELD(env, polyglot_visit_FlattenVisitor, count, 1) = i1;
	_JC_ACTIVE_USE(env, java_lang_String);
	r2 = _JC_INVOKE_STATIC(env, java_lang_Integer, toString$80d919d12afaaa2b, 0, i0, 10);
	r1 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r0, r2);
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	r3 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r3, r1);
	return r3;
}

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// public void <init>(polyglot.types.TypeSystem, polyglot.ast.NodeFactory)
//

static _jc_linenum _jc_polyglot_visit_FlattenVisitor$linenum_table$_init$5f44ce139b44c505[];

static const unsigned char _jc_polyglot_visit_FlattenVisitor$param_ptypes$_init$5f44ce139b44c505[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_visit_FlattenVisitor$param_types$_init$5f44ce139b44c505[] = {
	&_jc_polyglot_types_TypeSystem$type,
	&_jc_polyglot_ast_NodeFactory$type
};

_jc_method _jc_polyglot_visit_FlattenVisitor$method_info$_init$5f44ce139b44c505 = {
	.name=			"<init>",
	.signature=		"(Lpolyglot/types/TypeSystem;Lpolyglot/ast/NodeFactory;)V",
	.class=			&_jc_polyglot_visit_FlattenVisitor$type,
	.param_types=		&_jc_polyglot_visit_FlattenVisitor$param_types$_init$5f44ce139b44c505,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_visit_FlattenVisitor$param_ptypes$_init$5f44ce139b44c505,
	.signature_hash=	_JC_JLONG(0x5f44ce139b44c505),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_visit_FlattenVisitor$method$_init$5f44ce139b44c505,
	.num_parameters=	2,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_polyglot_visit_FlattenVisitor$linenum_table$_init$5f44ce139b44c505
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_visit_FlattenVisitor, _init$5f44ce139b44c505);

void _JC_JCNI_ATTR
_jc_polyglot_visit_FlattenVisitor$method$_init$5f44ce139b44c505(_jc_env *const env, _jc_polyglot_visit_FlattenVisitor$object *this, _jc_object *param0, _jc_object *param1)
{
	struct _jc_polyglot_visit_FlattenVisitor$object *r0;
	struct _jc_object *r1;
	struct _jc_object *r2;
	struct _jc_java_util_LinkedList$object *r3;

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_LINE_NUMBER(37);				// 0
	_JC_REF_FIELD(env, r0, polyglot_visit_FlattenVisitor, noFlatten) = _JC_NULL;
	_JC_LINE_NUMBER(18);				// 1
	_JC_REF_FIELD(env, r0, polyglot_visit_FlattenVisitor, ts) = r1;
	_JC_LINE_NUMBER(19);				// 2
	_JC_REF_FIELD(env, r0, polyglot_visit_FlattenVisitor, nf) = r2;
	_JC_LINE_NUMBER(20);				// 3
	r3 = _JC_NEW(env, java_util_LinkedList);
	_JC_PRIM_FIELD(env, r3, java_util_LinkedList, size) = 0;
	_JC_REF_FIELD(env, r0, polyglot_visit_FlattenVisitor, stack) = r3;
	_JC_LINE_NUMBER(21);				// 4
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public polyglot.visit.NodeVisitor enter(polyglot.ast.Node)
//

static _jc_linenum _jc_polyglot_visit_FlattenVisitor$linenum_table$enter$a8ce2b9db363b202[];

static const unsigned char _jc_polyglot_visit_FlattenVisitor$param_ptypes$enter$a8ce2b9db363b202[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_visit_FlattenVisitor$param_types$enter$a8ce2b9db363b202[] = {
	&_jc_polyglot_ast_Node$type
};

_jc_method _jc_polyglot_visit_FlattenVisitor$method_info$enter$a8ce2b9db363b202 = {
	.name=			"enter",
	.signature=		"(Lpolyglot/ast/Node;)Lpolyglot/visit/NodeVisitor;",
	.class=			&_jc_polyglot_visit_FlattenVisitor$type,
	.param_types=		&_jc_polyglot_visit_FlattenVisitor$param_types$enter$a8ce2b9db363b202,
	.return_type=		&_jc_polyglot_visit_NodeVisitor$type,
	.param_ptypes=		&_jc_polyglot_visit_FlattenVisitor$param_ptypes$enter$a8ce2b9db363b202,
	.signature_hash=	_JC_JLONG(0xa8ce2b9db363b202),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_visit_FlattenVisitor$method$enter$a8ce2b9db363b202,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_visit_FlattenVisitor$vtable, polyglot_visit_FlattenVisitor.enter$a8ce2b9db363b202) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	6,
	      .table=	_jc_polyglot_visit_FlattenVisitor$linenum_table$enter$a8ce2b9db363b202
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_visit_FlattenVisitor, enter$a8ce2b9db363b202);

_jc_polyglot_visit_NodeVisitor$object * _JC_JCNI_ATTR
_jc_polyglot_visit_FlattenVisitor$method$enter$a8ce2b9db363b202(_jc_env *const env, _jc_polyglot_visit_FlattenVisitor$object *this, _jc_object *param0)
{
	struct _jc_polyglot_visit_FlattenVisitor$object *r0;
	struct _jc_object *r1;
	struct _jc_java_util_LinkedList$object *r2;
	struct _jc_object *r3;
	struct _jc_java_util_LinkedList$object *r4;
	struct _jc_object *r5;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(44);				// 0
	z0 = _JC_INSTANCEOF(env, r1, &_jc_polyglot_ast_Block$type);
	if (z0 == 0)
		goto label0;
	_JC_LINE_NUMBER(45);				// 1
	r4 = _JC_REF_FIELD(env, r0, polyglot_visit_FlattenVisitor, stack);
	r2 = _JC_NEW(env, java_util_LinkedList);
	_JC_PRIM_FIELD(env, r2, java_util_LinkedList, size) = 0;
	_JC_INVOKE_VIRTUAL(env, java_util_LinkedList, addFirst$741a4005ae77c7b8, r4, r2);

label0:
	_JC_LINE_NUMBER(48);				// 2
	z0 = _JC_INSTANCEOF(env, r1, &_jc_polyglot_ast_Eval$type);
	if (z0 == 0)
		goto label1;
	_JC_LINE_NUMBER(51);				// 3
	r3 = r1;
	_JC_LINE_NUMBER(52);				// 4
	r5 = _JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0x48490938b684419c), _jc_object *, (_jc_env *, struct _jc_object *));
	_JC_REF_FIELD(env, r0, polyglot_visit_FlattenVisitor, noFlatten) = r5;

label1:
	_JC_LINE_NUMBER(55);				// 5
	return r0;
}

//
// public polyglot.ast.Node leave(polyglot.ast.Node, polyglot.ast.Node, polyglot.visit.NodeVisitor)
//

static _jc_linenum _jc_polyglot_visit_FlattenVisitor$linenum_table$leave$cf18a0cab654af63[];

static const unsigned char _jc_polyglot_visit_FlattenVisitor$param_ptypes$leave$cf18a0cab654af63[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_visit_FlattenVisitor$param_types$leave$cf18a0cab654af63[] = {
	&_jc_polyglot_ast_Node$type,
	&_jc_polyglot_ast_Node$type,
	&_jc_polyglot_visit_NodeVisitor$type
};

_jc_method _jc_polyglot_visit_FlattenVisitor$method_info$leave$cf18a0cab654af63 = {
	.name=			"leave",
	.signature=		"(Lpolyglot/ast/Node;Lpolyglot/ast/Node;Lpolyglot/visit/NodeVisitor;)Lpolyglot/ast/Node;",
	.class=			&_jc_polyglot_visit_FlattenVisitor$type,
	.param_types=		&_jc_polyglot_visit_FlattenVisitor$param_types$leave$cf18a0cab654af63,
	.return_type=		&_jc_polyglot_ast_Node$type,
	.param_ptypes=		&_jc_polyglot_visit_FlattenVisitor$param_ptypes$leave$cf18a0cab654af63,
	.signature_hash=	_JC_JLONG(0xcf18a0cab654af63),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_visit_FlattenVisitor$method$leave$cf18a0cab654af63,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_visit_FlattenVisitor$vtable, polyglot_visit_FlattenVisitor.leave$cf18a0cab654af63) / sizeof(void *),
	.num_parameters=	3,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	24,
	      .table=	_jc_polyglot_visit_FlattenVisitor$linenum_table$leave$cf18a0cab654af63
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_visit_FlattenVisitor, leave$cf18a0cab654af63);

_jc_object * _JC_JCNI_ATTR
_jc_polyglot_visit_FlattenVisitor$method$leave$cf18a0cab654af63(_jc_env *const env, _jc_polyglot_visit_FlattenVisitor$object *this, _jc_object *param0, _jc_object *param1, _jc_polyglot_visit_NodeVisitor$object *param2)
{
	struct _jc_polyglot_visit_FlattenVisitor$object *r0;
	struct _jc_object *r1;
	struct _jc_java_util_LinkedList$object *r11;
	struct _jc_java_lang_Object$object *r12;
	struct _jc_object *r13;
	struct _jc_object *r18;
	struct _jc_object *r19;
	struct _jc_object *r2;
	struct _jc_polyglot_util_Position$object *r20;
	struct _jc_object *r21;
	struct _jc_polyglot_util_Position$object *r22;
	struct _jc_object *r23;
	struct _jc_object *r24;
	struct _jc_object *r25;
	struct _jc_object *r29;
	struct _jc_polyglot_visit_NodeVisitor$object *r3;
	struct _jc_object *r36;
	struct _jc_object *r4;
	struct _jc_java_lang_String$object *r5;
	struct _jc_polyglot_types_Flags$object *r6;
	struct _jc_object *r7;
	struct _jc_object *r9;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	r3 = param2;
	_JC_LINE_NUMBER(62);				// 0
	r1 = _JC_REF_FIELD(env, r0, polyglot_visit_FlattenVisitor, noFlatten);
	if (r2 != r1)
		goto label0;
	_JC_LINE_NUMBER(63);				// 1
	_JC_REF_FIELD(env, r0, polyglot_visit_FlattenVisitor, noFlatten) = _JC_NULL;
	_JC_LINE_NUMBER(64);				// 2
	return r2;

label0:
	_JC_LINE_NUMBER(67);				// 3
	z0 = _JC_INSTANCEOF(env, r2, &_jc_polyglot_ast_Block$type);
	if (z0 == 0)
		goto label1;
	_JC_LINE_NUMBER(68);				// 4
	r11 = _JC_REF_FIELD(env, r0, polyglot_visit_FlattenVisitor, stack);
	r12 = _JC_INVOKE_VIRTUAL(env, java_util_LinkedList, removeFirst$539049aa2de97f0d, r11);
	r4 = _JC_CAST(env, &_jc_java_util_List$type, r12);
	_JC_LINE_NUMBER(69);				// 5
	r13 = r2;
	r13 = _JC_INVOKE_INTERFACE(env, r13, _JC_JLONG(0x8697e05da61358e0), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_object *), r4);
	return r13;

label1:
	_JC_LINE_NUMBER(71);				// 6
	z0 = _JC_INSTANCEOF(env, r2, &_jc_polyglot_ast_Stmt$type);
	if (z0 == 0)
		goto label2;
	z0 = _JC_INSTANCEOF(env, r2, &_jc_polyglot_ast_LocalDecl$type);
	if (z0 != 0)
		goto label2;
	_JC_LINE_NUMBER(72);				// 7
	r11 = _JC_REF_FIELD(env, r0, polyglot_visit_FlattenVisitor, stack);
	r12 = _JC_INVOKE_VIRTUAL(env, java_util_LinkedList, getFirst$3c77317eb8e36d24, r11);
	r4 = _JC_CAST(env, &_jc_java_util_List$type, r12);
	_JC_LINE_NUMBER(73);				// 8
	_JC_INVOKE_INTERFACE(env, r4, _JC_JLONG(0x831f06ee5f59c0cc), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r2);
	_JC_LINE_NUMBER(74);				// 9
	return r2;

label2:
	_JC_LINE_NUMBER(76);				// 10
	z0 = _JC_INSTANCEOF(env, r2, &_jc_polyglot_ast_Expr$type);
	if (z0 == 0)
		goto label4;
	z0 = _JC_INSTANCEOF(env, r2, &_jc_polyglot_ast_Lit$type);
	if (z0 != 0)
		goto label4;
	z0 = _JC_INSTANCEOF(env, r2, &_jc_polyglot_ast_Special$type);
	if (z0 != 0)
		goto label4;
	z0 = _JC_INSTANCEOF(env, r2, &_jc_polyglot_ast_Local$type);
	if (z0 != 0)
		goto label4;
	_JC_LINE_NUMBER(79);				// 11
	r18 = r2;
	_JC_LINE_NUMBER(81);				// 12
	z0 = _JC_INSTANCEOF(env, r18, &_jc_polyglot_ast_Assign$type);
	if (z0 == 0)
		goto label3;
	_JC_LINE_NUMBER(82);				// 13
	return r2;

label3:
	_JC_LINE_NUMBER(88);				// 14
	r5 = _JC_INVOKE_STATIC(env, polyglot_visit_FlattenVisitor, newID$87051e1cf288e0d9, 1);
	_JC_LINE_NUMBER(89);				// 15
	r19 = _JC_REF_FIELD(env, r0, polyglot_visit_FlattenVisitor, nf);
	r20 = _JC_INVOKE_INTERFACE(env, r18, _JC_JLONG(0xbb89333b1e4c840c), _jc_object *, (_jc_env *, struct _jc_object *));
	r6 = _JC_STATIC_FIELD(env, polyglot_types_Flags, FINAL, 0);
	r21 = _JC_REF_FIELD(env, r0, polyglot_visit_FlattenVisitor, nf);
	r22 = _JC_INVOKE_INTERFACE(env, r18, _JC_JLONG(0xbb89333b1e4c840c), _jc_object *, (_jc_env *, struct _jc_object *));
	r23 = _JC_INVOKE_INTERFACE(env, r18, _JC_JLONG(0xb7282830a20ab2a3), _jc_object *, (_jc_env *, struct _jc_object *));
	r24 = _JC_INVOKE_INTERFACE(env, r21, _JC_JLONG(0x890196a84d160f7e), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_polyglot_util_Position$object *, struct _jc_object *), r22, r23);
	r7 = _JC_INVOKE_INTERFACE(env, r19, _JC_JLONG(0xcc053a8af6e965f9), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_polyglot_util_Position$object *, struct _jc_polyglot_types_Flags$object *, struct _jc_object *, struct _jc_java_lang_String$object *, struct _jc_object *), r20, r6, r24, r5, r18);
	_JC_LINE_NUMBER(93);				// 16
	r25 = _JC_REF_FIELD(env, r0, polyglot_visit_FlattenVisitor, ts);
	r22 = _JC_INVOKE_INTERFACE(env, r18, _JC_JLONG(0xbb89333b1e4c840c), _jc_object *, (_jc_env *, struct _jc_object *));
	r6 = _JC_STATIC_FIELD(env, polyglot_types_Flags, FINAL, 1);
	r23 = _JC_INVOKE_INTERFACE(env, r18, _JC_JLONG(0xb7282830a20ab2a3), _jc_object *, (_jc_env *, struct _jc_object *));
	r29 = _JC_INVOKE_INTERFACE(env, r25, _JC_JLONG(0x794feb8c474b0888), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_polyglot_util_Position$object *, struct _jc_polyglot_types_Flags$object *, struct _jc_object *, struct _jc_java_lang_String$object *), r22, r6, r23, r5);
	r7 = _JC_INVOKE_INTERFACE(env, r7, _JC_JLONG(0xd5ba59d2582e4cee), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_object *), r29);
	_JC_LINE_NUMBER(96);				// 17
	r11 = _JC_REF_FIELD(env, r0, polyglot_visit_FlattenVisitor, stack);
	r12 = _JC_INVOKE_VIRTUAL(env, java_util_LinkedList, getFirst$3c77317eb8e36d24, r11);
	r4 = _JC_CAST(env, &_jc_java_util_List$type, r12);
	_JC_LINE_NUMBER(97);				// 18
	_JC_INVOKE_INTERFACE(env, r4, _JC_JLONG(0x831f06ee5f59c0cc), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r7);
	_JC_LINE_NUMBER(100);				// 19
	r21 = _JC_REF_FIELD(env, r0, polyglot_visit_FlattenVisitor, nf);
	r22 = _JC_INVOKE_INTERFACE(env, r18, _JC_JLONG(0xbb89333b1e4c840c), _jc_object *, (_jc_env *, struct _jc_object *));
	r9 = _JC_INVOKE_INTERFACE(env, r21, _JC_JLONG(0x281789c8b62f305b), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_polyglot_util_Position$object *, struct _jc_java_lang_String$object *), r22, r5);
	_JC_LINE_NUMBER(101);				// 20
	r23 = _JC_INVOKE_INTERFACE(env, r18, _JC_JLONG(0xb7282830a20ab2a3), _jc_object *, (_jc_env *, struct _jc_object *));
	r36 = _JC_INVOKE_INTERFACE(env, r9, _JC_JLONG(0x94f55d0c5048b093), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_object *), r23);
	r9 = _JC_CAST(env, &_jc_polyglot_ast_Local$type, r36);
	_JC_LINE_NUMBER(102);				// 21
	r25 = _JC_REF_FIELD(env, r0, polyglot_visit_FlattenVisitor, ts);
	r22 = _JC_INVOKE_INTERFACE(env, r18, _JC_JLONG(0xbb89333b1e4c840c), _jc_object *, (_jc_env *, struct _jc_object *));
	r6 = _JC_STATIC_FIELD(env, polyglot_types_Flags, FINAL, 1);
	r23 = _JC_INVOKE_INTERFACE(env, r18, _JC_JLONG(0xb7282830a20ab2a3), _jc_object *, (_jc_env *, struct _jc_object *));
	r29 = _JC_INVOKE_INTERFACE(env, r25, _JC_JLONG(0x794feb8c474b0888), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_polyglot_util_Position$object *, struct _jc_polyglot_types_Flags$object *, struct _jc_object *, struct _jc_java_lang_String$object *), r22, r6, r23, r5);
	r9 = _JC_INVOKE_INTERFACE(env, r9, _JC_JLONG(0x94459a12d550efb2), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_object *), r29);
	_JC_LINE_NUMBER(104);				// 22
	return r9;

label4:
	_JC_LINE_NUMBER(107);				// 23
	return r2;
}

//
// public polyglot.ast.Node override(polyglot.ast.Node)
//

static _jc_linenum _jc_polyglot_visit_FlattenVisitor$linenum_table$override$1e05b257002785f7[];

static const unsigned char _jc_polyglot_visit_FlattenVisitor$param_ptypes$override$1e05b257002785f7[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_visit_FlattenVisitor$param_types$override$1e05b257002785f7[] = {
	&_jc_polyglot_ast_Node$type
};

_jc_method _jc_polyglot_visit_FlattenVisitor$method_info$override$1e05b257002785f7 = {
	.name=			"override",
	.signature=		"(Lpolyglot/ast/Node;)Lpolyglot/ast/Node;",
	.class=			&_jc_polyglot_visit_FlattenVisitor$type,
	.param_types=		&_jc_polyglot_visit_FlattenVisitor$param_types$override$1e05b257002785f7,
	.return_type=		&_jc_polyglot_ast_Node$type,
	.param_ptypes=		&_jc_polyglot_visit_FlattenVisitor$param_ptypes$override$1e05b257002785f7,
	.signature_hash=	_JC_JLONG(0x1e05b257002785f7),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_visit_FlattenVisitor$method$override$1e05b257002785f7,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_visit_FlattenVisitor$vtable, polyglot_visit_FlattenVisitor.override$1e05b257002785f7) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_polyglot_visit_FlattenVisitor$linenum_table$override$1e05b257002785f7
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_visit_FlattenVisitor, override$1e05b257002785f7);

_jc_object * _JC_JCNI_ATTR
_jc_polyglot_visit_FlattenVisitor$method$override$1e05b257002785f7(_jc_env *const env, _jc_polyglot_visit_FlattenVisitor$object *this, _jc_object *param0)
{
	struct _jc_polyglot_visit_FlattenVisitor$object *r0;
	struct _jc_object *r1;
	jboolean z0;

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(24);				// 0
	z0 = _JC_INSTANCEOF(env, r1, &_jc_polyglot_ast_FieldDecl$type);
	if (z0 != 0)
		goto label0;
	z0 = _JC_INSTANCEOF(env, r1, &_jc_polyglot_ast_ConstructorCall$type);
	if (z0 == 0)
		goto label1;

label0:
	_JC_LINE_NUMBER(25);				// 1
	return r1;

label1:
	_JC_LINE_NUMBER(28);				// 2
	return _JC_NULL;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_polyglot_visit_FlattenVisitor$methods[] = {
	&_jc_polyglot_visit_FlattenVisitor$method_info$_clinit$a816641e0ba8bfef,
	&_jc_polyglot_visit_FlattenVisitor$method_info$_init$5f44ce139b44c505,
	&_jc_polyglot_visit_FlattenVisitor$method_info$enter$a8ce2b9db363b202,
	&_jc_polyglot_visit_FlattenVisitor$method_info$leave$cf18a0cab654af63,
	&_jc_polyglot_visit_FlattenVisitor$method_info$newID$87051e1cf288e0d9,
	&_jc_polyglot_visit_FlattenVisitor$method_info$override$1e05b257002785f7
};

/************************************************************************
 *			  Class fields structure			*
 ************************************************************************/

_jc_polyglot_visit_FlattenVisitor$fields_struct _jc_polyglot_visit_FlattenVisitor$class_fields = { };

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_polyglot_visit_FlattenVisitor$instanceof_hash_bucket_35[] = {
	&_jc_polyglot_visit_FlattenVisitor$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_visit_FlattenVisitor$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_visit_FlattenVisitor$instanceof_hash_bucket_112[] = {
	&_jc_polyglot_visit_NodeVisitor$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_polyglot_visit_FlattenVisitor$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[35]=	_jc_polyglot_visit_FlattenVisitor$instanceof_hash_bucket_35,
	[101]=	_jc_polyglot_visit_FlattenVisitor$instanceof_hash_bucket_101,
	[112]=	_jc_polyglot_visit_FlattenVisitor$instanceof_hash_bucket_112
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_polyglot_visit_FlattenVisitor$class_depends[] = {
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/Integer",	_JC_JLONG(0xca631501391a31f1) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/StringBuffer",	_JC_JLONG(0x94d357637b968dda) },
	{ "java/util/AbstractCollection",	_JC_JLONG(0x8ea716c64b77f8eb) },
	{ "java/util/AbstractList",	_JC_JLONG(0xf5238436362828db) },
	{ "java/util/AbstractSequentialList",	_JC_JLONG(0x6d7997e879c41059) },
	{ "java/util/LinkedList",	_JC_JLONG(0x666417b6279ae396) },
	{ "java/util/List",	_JC_JLONG(0x9ee0d92ce1525a4d) },
	{ "polyglot/ast/Assign",	_JC_JLONG(0x528a1e885893fafb) },
	{ "polyglot/ast/Block",	_JC_JLONG(0x5eda5b679dfeb2f7) },
	{ "polyglot/ast/CanonicalTypeNode",	_JC_JLONG(0x6d0ea1efc315a28) },
	{ "polyglot/ast/ConstructorCall",	_JC_JLONG(0xdabf1f0efcc72d0a) },
	{ "polyglot/ast/Eval",	_JC_JLONG(0x2286a4785e8dc2) },
	{ "polyglot/ast/Expr",	_JC_JLONG(0xa33c697a7834ba70) },
	{ "polyglot/ast/FieldDecl",	_JC_JLONG(0x3e5dc0670fa8c08c) },
	{ "polyglot/ast/Lit",	_JC_JLONG(0xcbd56ac2ea46c2ea) },
	{ "polyglot/ast/Local",	_JC_JLONG(0x363bd895d3e0630c) },
	{ "polyglot/ast/LocalDecl",	_JC_JLONG(0x9d6588c1cb1a2f31) },
	{ "polyglot/ast/Node",	_JC_JLONG(0x1c402b4f9747e08) },
	{ "polyglot/ast/NodeFactory",	_JC_JLONG(0x56625b3befab19f) },
	{ "polyglot/ast/Special",	_JC_JLONG(0xc1d83578c0371206) },
	{ "polyglot/ast/Stmt",	_JC_JLONG(0xde1430f3b100a09a) },
	{ "polyglot/types/Flags",	_JC_JLONG(0x821eb65d8f2f30f6) },
	{ "polyglot/types/LocalInstance",	_JC_JLONG(0x143a5bf23e0f6584) },
	{ "polyglot/types/Type",	_JC_JLONG(0x6596051546781098) },
	{ "polyglot/types/TypeSystem",	_JC_JLONG(0xed171cdaca38ec28) },
	{ "polyglot/util/Position",	_JC_JLONG(0x32c9a088c5dac046) },
	{ "polyglot/visit/NodeVisitor",	_JC_JLONG(0x534db787197439f0) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_polyglot_visit_FlattenVisitor$vtype _jc_polyglot_visit_FlattenVisitor$type = {
    .type= {
	.name=			"polyglot/visit/FlattenVisitor",
	.superclass=		&_jc_polyglot_visit_NodeVisitor$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		25,
		.hash=			_JC_JLONG(0x3a8a58ab836c0c23),
		.source_file=		"FlattenVisitor.java",
		.instance_size=		sizeof(_jc_polyglot_visit_FlattenVisitor$refs) + sizeof(_jc_polyglot_visit_FlattenVisitor$object),
		.num_virtual_refs=	4,
		.num_fields=		sizeof(_jc_polyglot_visit_FlattenVisitor$fields) / sizeof(*_jc_polyglot_visit_FlattenVisitor$fields),
		.fields=		_jc_polyglot_visit_FlattenVisitor$fields,
		.num_methods=		sizeof(_jc_polyglot_visit_FlattenVisitor$methods) / sizeof(*_jc_polyglot_visit_FlattenVisitor$methods),
		.methods=		_jc_polyglot_visit_FlattenVisitor$methods,
		.instanceof_hash_table=	_jc_polyglot_visit_FlattenVisitor$instanceof_hash_table,
		.class_fields=		&_jc_polyglot_visit_FlattenVisitor$class_fields,
		.num_class_depends=		sizeof(_jc_polyglot_visit_FlattenVisitor$class_depends) / sizeof(*_jc_polyglot_visit_FlattenVisitor$class_depends),
		.class_depends=		_jc_polyglot_visit_FlattenVisitor$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=			// overridden
		&_jc_polyglot_visit_NodeVisitor$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.polyglot_visit_NodeVisitor= {
	    .begin$914d55e002815404=
		&_jc_polyglot_visit_NodeVisitor$method$begin$914d55e002815404,
	    .enter$a8ce2b9db363b202=			// overridden
		&_jc_polyglot_visit_FlattenVisitor$method$enter$a8ce2b9db363b202,
	    .enter$0698e71b16532e07=
		&_jc_polyglot_visit_NodeVisitor$method$enter$0698e71b16532e07,
	    .finish$8d1c944274527186=
		&_jc_polyglot_visit_NodeVisitor$method$finish$8d1c944274527186,
	    .finish$ed6d1946240badd4=
		&_jc_polyglot_visit_NodeVisitor$method$finish$ed6d1946240badd4,
	    .leave$d95680aeadf04833=
		&_jc_polyglot_visit_NodeVisitor$method$leave$d95680aeadf04833,
	    .leave$cf18a0cab654af63=			// overridden
		&_jc_polyglot_visit_FlattenVisitor$method$leave$cf18a0cab654af63,
	    .override$1e05b257002785f7=			// overridden
		&_jc_polyglot_visit_FlattenVisitor$method$override$1e05b257002785f7,
	    .override$b414405487168b9b=
		&_jc_polyglot_visit_NodeVisitor$method$override$b414405487168b9b,
	    .toString$7ea43b33b80a3070=
		&_jc_polyglot_visit_NodeVisitor$method$toString$7ea43b33b80a3070,
	    .visitEdge$35f9fc3d698a8550=
		&_jc_polyglot_visit_NodeVisitor$method$visitEdge$35f9fc3d698a8550,
	},
	.polyglot_visit_FlattenVisitor= {
	    .enter$a8ce2b9db363b202=
		&_jc_polyglot_visit_FlattenVisitor$method$enter$a8ce2b9db363b202,
	    .leave$cf18a0cab654af63=
		&_jc_polyglot_visit_FlattenVisitor$method$leave$cf18a0cab654af63,
	    .override$1e05b257002785f7=
		&_jc_polyglot_visit_FlattenVisitor$method$override$1e05b257002785f7,
	},
    }
};

