// public class polyglot.visit.Translator

// class file dependencies
// @dep_class 9cef6b66128b04b2 java_io_File
// @dep_class 4e0a56550c69d57c java_io_IOException
// @dep_class 4897ee169f60a14f java_io_Writer
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class d59353b5e031d754 java_lang_CloneNotSupportedException
// @dep_class 9b667b09132be893 java_lang_Cloneable
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class 4f5534a987354d1d java_lang_RuntimeException
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 94d357637b968dda java_lang_StringBuffer
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class 238a2c0aafd74314 java_lang_VMClass
// @dep_class 312e45ed214d432f java_lang_VMObject
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class 8ea716c64b77f8eb java_util_AbstractCollection
// @dep_class f5238436362828db java_util_AbstractList
// @dep_class 6d7997e879c41059 java_util_AbstractSequentialList
// @dep_class eae4d0c0e8eb63da java_util_Collection
// @dep_class be56ff673eefd9d2 java_util_Iterator
// @dep_class 666417b6279ae396 java_util_LinkedList
// @dep_class 2522cc4453ab9d02 java_util_LinkedList__24Entry
// @dep_class 9ee0d92ce1525a4d java_util_List
// @dep_class e1faa924d53ccbd6 polyglot_ast_Import
// @dep_class 653c77643765390d polyglot_ast_JL
// @dep_class 1c402b4f9747e08 polyglot_ast_Node
// @dep_class 56625b3befab19f polyglot_ast_NodeFactory
// @dep_class 5a97e30dbcca371b polyglot_ast_PackageNode
// @dep_class 79aa0375a207249e polyglot_ast_SourceCollection
// @dep_class cc4102d52764e835 polyglot_ast_SourceFile
// @dep_class bafb0341dee3e659 polyglot_ast_TopLevelDecl
// @dep_class 3ea6f1cf85115422 polyglot_frontend_Compiler
// @dep_class 42e687805b457724 polyglot_frontend_Job
// @dep_class cd88b669bec8f787 polyglot_frontend_Source
// @dep_class c99629f926ef2e3f polyglot_frontend_TargetFactory
// @dep_class b38560af658974f8 polyglot_types_ClassType
// @dep_class a433cdcd788f6c37 polyglot_types_Context
// @dep_class 821eb65d8f2f30f6 polyglot_types_Flags
// @dep_class 15df1cfa12c16381 polyglot_types_Package
// @dep_class ed171cdaca38ec28 polyglot_types_TypeSystem
// @dep_class bc2875222b1ccf02 polyglot_util_AllowBreak
// @dep_class c47ea105a198c856 polyglot_util_BlockItem
// @dep_class bda7215170a25efc polyglot_util_CodeWriter
// @dep_class c1adfaf4637dbc02 polyglot_util_Copy
// @dep_class ff712c8463bdfdc0 polyglot_util_ErrorQueue
// @dep_class 22b321d488641c54 polyglot_util_InternalCompilerError
// @dep_class 77b6315f0d7667d7 polyglot_util_Item
// @dep_class e65ad0113d489ab4 polyglot_util_Newline
// @dep_class 32c9a088c5dac046 polyglot_util_Position
// @dep_class 9b5998bb4b90b099 polyglot_visit_PrettyPrinter
// @dep_class 91b74e58638056a5 polyglot_visit_Translator

// header file dependencies
// @dep_header java_io_File
// @dep_header java_io_IOException
// @dep_header java_io_Writer
// @dep_header java_lang_Class
// @dep_header java_lang_CloneNotSupportedException
// @dep_header java_lang_Cloneable
// @dep_header java_lang_String
// @dep_header java_lang_StringBuffer
// @dep_header java_lang_VMClass
// @dep_header java_lang_VMObject
// @dep_header java_lang_VMThrowable
// @dep_header java_util_Collection
// @dep_header java_util_Iterator
// @dep_header java_util_LinkedList
// @dep_header java_util_LinkedList__24Entry
// @dep_header java_util_List
// @dep_header polyglot_ast_Import
// @dep_header polyglot_ast_JL
// @dep_header polyglot_ast_Node
// @dep_header polyglot_ast_NodeFactory
// @dep_header polyglot_ast_PackageNode
// @dep_header polyglot_ast_SourceCollection
// @dep_header polyglot_ast_SourceFile
// @dep_header polyglot_ast_TopLevelDecl
// @dep_header polyglot_frontend_Compiler
// @dep_header polyglot_frontend_Job
// @dep_header polyglot_frontend_Source
// @dep_header polyglot_frontend_TargetFactory
// @dep_header polyglot_types_ClassType
// @dep_header polyglot_types_Context
// @dep_header polyglot_types_Flags
// @dep_header polyglot_types_Package
// @dep_header polyglot_types_TypeSystem
// @dep_header polyglot_util_BlockItem
// @dep_header polyglot_util_CodeWriter
// @dep_header polyglot_util_Copy
// @dep_header polyglot_util_ErrorQueue
// @dep_header polyglot_util_InternalCompilerError
// @dep_header polyglot_util_Newline
// @dep_header polyglot_util_Position
// @dep_header polyglot_visit_Translator

#include "jc_defs.h"

#include "java/io/File.h"
#include "java/io/IOException.h"
#include "java/io/Writer.h"
#include "java/lang/Class.h"
#include "java/lang/CloneNotSupportedException.h"
#include "java/lang/Cloneable.h"
#include "java/lang/String.h"
#include "java/lang/StringBuffer.h"
#include "java/lang/VMClass.h"
#include "java/lang/VMObject.h"
#include "java/lang/VMThrowable.h"
#include "java/util/Collection.h"
#include "java/util/Iterator.h"
#include "java/util/LinkedList.h"
#include "java/util/LinkedList__24Entry.h"
#include "java/util/List.h"
#include "polyglot/ast/Import.h"
#include "polyglot/ast/JL.h"
#include "polyglot/ast/Node.h"
#include "polyglot/ast/NodeFactory.h"
#include "polyglot/ast/PackageNode.h"
#include "polyglot/ast/SourceCollection.h"
#include "polyglot/ast/SourceFile.h"
#include "polyglot/ast/TopLevelDecl.h"
#include "polyglot/frontend/Compiler.h"
#include "polyglot/frontend/Job.h"
#include "polyglot/frontend/Source.h"
#include "polyglot/frontend/TargetFactory.h"
#include "polyglot/types/ClassType.h"
#include "polyglot/types/Context.h"
#include "polyglot/types/Flags.h"
#include "polyglot/types/Package.h"
#include "polyglot/types/TypeSystem.h"
#include "polyglot/util/BlockItem.h"
#include "polyglot/util/CodeWriter.h"
#include "polyglot/util/Copy.h"
#include "polyglot/util/ErrorQueue.h"
#include "polyglot/util/InternalCompilerError.h"
#include "polyglot/util/Newline.h"
#include "polyglot/util/Position.h"
#include "polyglot/visit/Translator.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// protected polyglot.frontend.Job job
static _jc_field _jc_polyglot_visit_Translator$field_info$job = {
	.name=		"job",
	.signature=	"Lpolyglot/frontend/Job;",
	.class=		&_jc_polyglot_visit_Translator$type,
	.type=		&_jc_polyglot_frontend_Job$type,
	.access_flags=	_JC_ACC_PROTECTED,
	.offset=	_JC_OFFSETOF(_jc_polyglot_visit_Translator$object, refs[-1].polyglot_visit_Translator.job),
};

// protected polyglot.ast.NodeFactory nf
static _jc_field _jc_polyglot_visit_Translator$field_info$nf = {
	.name=		"nf",
	.signature=	"Lpolyglot/ast/NodeFactory;",
	.class=		&_jc_polyglot_visit_Translator$type,
	.type=		&_jc_polyglot_ast_NodeFactory$type,
	.access_flags=	_JC_ACC_PROTECTED,
	.offset=	_JC_OFFSETOF(_jc_polyglot_visit_Translator$object, refs[-1].polyglot_visit_Translator.nf),
};

// protected polyglot.frontend.TargetFactory tf
static _jc_field _jc_polyglot_visit_Translator$field_info$tf = {
	.name=		"tf",
	.signature=	"Lpolyglot/frontend/TargetFactory;",
	.class=		&_jc_polyglot_visit_Translator$type,
	.type=		&_jc_polyglot_frontend_TargetFactory$type,
	.access_flags=	_JC_ACC_PROTECTED,
	.offset=	_JC_OFFSETOF(_jc_polyglot_visit_Translator$object, refs[-1].polyglot_visit_Translator.tf),
};

// protected polyglot.types.TypeSystem ts
static _jc_field _jc_polyglot_visit_Translator$field_info$ts = {
	.name=		"ts",
	.signature=	"Lpolyglot/types/TypeSystem;",
	.class=		&_jc_polyglot_visit_Translator$type,
	.type=		&_jc_polyglot_types_TypeSystem$type,
	.access_flags=	_JC_ACC_PROTECTED,
	.offset=	_JC_OFFSETOF(_jc_polyglot_visit_Translator$object, refs[-1].polyglot_visit_Translator.ts),
};

// protected polyglot.types.Context context
static _jc_field _jc_polyglot_visit_Translator$field_info$context = {
	.name=		"context",
	.signature=	"Lpolyglot/types/Context;",
	.class=		&_jc_polyglot_visit_Translator$type,
	.type=		&_jc_polyglot_types_Context$type,
	.access_flags=	_JC_ACC_PROTECTED,
	.offset=	_JC_OFFSETOF(_jc_polyglot_visit_Translator$object, refs[-1].polyglot_visit_Translator.context),
};

// protected polyglot.types.ClassType outerClass
static _jc_field _jc_polyglot_visit_Translator$field_info$outerClass = {
	.name=		"outerClass",
	.signature=	"Lpolyglot/types/ClassType;",
	.class=		&_jc_polyglot_visit_Translator$type,
	.type=		&_jc_polyglot_types_ClassType$type,
	.access_flags=	_JC_ACC_PROTECTED,
	.offset=	_JC_OFFSETOF(_jc_polyglot_visit_Translator$object, refs[-1].polyglot_visit_Translator.outerClass),
};

// Fields
static _jc_field *const _jc_polyglot_visit_Translator$fields[] = {
	&_jc_polyglot_visit_Translator$field_info$context,
	&_jc_polyglot_visit_Translator$field_info$job,
	&_jc_polyglot_visit_Translator$field_info$nf,
	&_jc_polyglot_visit_Translator$field_info$outerClass,
	&_jc_polyglot_visit_Translator$field_info$tf,
	&_jc_polyglot_visit_Translator$field_info$ts
};

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// public void <init>(polyglot.frontend.Job, polyglot.types.TypeSystem, polyglot.ast.NodeFactory, polyglot.frontend.TargetFactory)
//

static _jc_linenum _jc_polyglot_visit_Translator$linenum_table$_init$56c0d1f8d1b49d93[];

static const unsigned char _jc_polyglot_visit_Translator$param_ptypes$_init$56c0d1f8d1b49d93[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_visit_Translator$param_types$_init$56c0d1f8d1b49d93[] = {
	&_jc_polyglot_frontend_Job$type,
	&_jc_polyglot_types_TypeSystem$type,
	&_jc_polyglot_ast_NodeFactory$type,
	&_jc_polyglot_frontend_TargetFactory$type
};

_jc_method _jc_polyglot_visit_Translator$method_info$_init$56c0d1f8d1b49d93 = {
	.name=			"<init>",
	.signature=		"(Lpolyglot/frontend/Job;Lpolyglot/types/TypeSystem;Lpolyglot/ast/NodeFactory;Lpolyglot/frontend/TargetFactory;)V",
	.class=			&_jc_polyglot_visit_Translator$type,
	.param_types=		&_jc_polyglot_visit_Translator$param_types$_init$56c0d1f8d1b49d93,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_visit_Translator$param_ptypes$_init$56c0d1f8d1b49d93,
	.signature_hash=	_JC_JLONG(0x56c0d1f8d1b49d93),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_visit_Translator$method$_init$56c0d1f8d1b49d93,
	.num_parameters=	4,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	9,
	      .table=	_jc_polyglot_visit_Translator$linenum_table$_init$56c0d1f8d1b49d93
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_visit_Translator, _init$56c0d1f8d1b49d93);

void _JC_JCNI_ATTR
_jc_polyglot_visit_Translator$method$_init$56c0d1f8d1b49d93(_jc_env *const env, _jc_polyglot_visit_Translator$object *this, _jc_polyglot_frontend_Job$object *param0, _jc_object *param1, _jc_object *param2, _jc_polyglot_frontend_TargetFactory$object *param3)
{
	struct _jc_polyglot_visit_Translator$object *r0;
	struct _jc_polyglot_frontend_Job$object *r1;
	struct _jc_object *r2;
	struct _jc_object *r3;
	struct _jc_polyglot_frontend_TargetFactory$object *r4;
	struct _jc_object *r5;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	r3 = param2;
	r4 = param3;
	_JC_PRIM_FIELD(env, r0, polyglot_visit_PrettyPrinter, appendSemicolon) = 1;
	_JC_PRIM_FIELD(env, r0, polyglot_visit_PrettyPrinter, printType) = 1;
	_JC_LINE_NUMBER(56);				// 0
	_JC_REF_FIELD(env, r0, polyglot_visit_Translator, outerClass) = _JC_NULL;
	_JC_LINE_NUMBER(65);				// 1
	_JC_REF_FIELD(env, r0, polyglot_visit_Translator, job) = r1;
	_JC_LINE_NUMBER(66);				// 2
	_JC_REF_FIELD(env, r0, polyglot_visit_Translator, nf) = r3;
	_JC_LINE_NUMBER(67);				// 3
	_JC_REF_FIELD(env, r0, polyglot_visit_Translator, tf) = r4;
	_JC_LINE_NUMBER(68);				// 4
	_JC_REF_FIELD(env, r0, polyglot_visit_Translator, ts) = r2;
	_JC_LINE_NUMBER(69);				// 5
	r5 = _JC_INVOKE_VIRTUAL(env, polyglot_frontend_Job, context$4c5ebe4f0ff1c15f, r1);
	_JC_REF_FIELD(env, r0, polyglot_visit_Translator, context) = r5;
	_JC_LINE_NUMBER(71);				// 6
	r5 = _JC_REF_FIELD(env, r0, polyglot_visit_Translator, context);
	if (r5 != _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(72);				// 7
	r5 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0xa533e01ab4704d58), _jc_object *, (_jc_env *, struct _jc_object *));
	_JC_REF_FIELD(env, r0, polyglot_visit_Translator, context) = r5;

label0:
	_JC_LINE_NUMBER(74);				// 8
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public polyglot.types.Context context()
//

static _jc_linenum _jc_polyglot_visit_Translator$linenum_table$context$4c5ebe4f0ff1c15f[];

static const unsigned char _jc_polyglot_visit_Translator$param_ptypes$context$4c5ebe4f0ff1c15f[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_visit_Translator$method_info$context$4c5ebe4f0ff1c15f = {
	.name=			"context",
	.signature=		"()Lpolyglot/types/Context;",
	.class=			&_jc_polyglot_visit_Translator$type,
	.return_type=		&_jc_polyglot_types_Context$type,
	.param_ptypes=		&_jc_polyglot_visit_Translator$param_ptypes$context$4c5ebe4f0ff1c15f,
	.signature_hash=	_JC_JLONG(0x4c5ebe4f0ff1c15f),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_visit_Translator$method$context$4c5ebe4f0ff1c15f,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_visit_Translator$vtable, polyglot_visit_Translator.context$4c5ebe4f0ff1c15f) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_visit_Translator$linenum_table$context$4c5ebe4f0ff1c15f
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_visit_Translator, context$4c5ebe4f0ff1c15f);

_jc_object * _JC_JCNI_ATTR
_jc_polyglot_visit_Translator$method$context$4c5ebe4f0ff1c15f(_jc_env *const env, _jc_polyglot_visit_Translator$object *this)
{
	struct _jc_polyglot_visit_Translator$object *r0;
	struct _jc_object *r1;

	r0 = this;
	_JC_LINE_NUMBER(126);				// 0
	r1 = _JC_REF_FIELD(env, r0, polyglot_visit_Translator, context);
	return r1;
}

//
// public polyglot.visit.Translator context(polyglot.types.Context)
//

static _jc_linenum _jc_polyglot_visit_Translator$linenum_table$context$ffa1e34312c710b6[];

static const unsigned char _jc_polyglot_visit_Translator$param_ptypes$context$ffa1e34312c710b6[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_visit_Translator$param_types$context$ffa1e34312c710b6[] = {
	&_jc_polyglot_types_Context$type
};

_jc_method _jc_polyglot_visit_Translator$method_info$context$ffa1e34312c710b6 = {
	.name=			"context",
	.signature=		"(Lpolyglot/types/Context;)Lpolyglot/visit/Translator;",
	.class=			&_jc_polyglot_visit_Translator$type,
	.param_types=		&_jc_polyglot_visit_Translator$param_types$context$ffa1e34312c710b6,
	.return_type=		&_jc_polyglot_visit_Translator$type,
	.param_ptypes=		&_jc_polyglot_visit_Translator$param_ptypes$context$ffa1e34312c710b6,
	.signature_hash=	_JC_JLONG(0xffa1e34312c710b6),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_visit_Translator$method$context$ffa1e34312c710b6,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_visit_Translator$vtable, polyglot_visit_Translator.context$ffa1e34312c710b6) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_polyglot_visit_Translator$linenum_table$context$ffa1e34312c710b6
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_visit_Translator, context$ffa1e34312c710b6);

_jc_polyglot_visit_Translator$object * _JC_JCNI_ATTR
_jc_polyglot_visit_Translator$method$context$ffa1e34312c710b6(_jc_env *const env, _jc_polyglot_visit_Translator$object *this, _jc_object *param0)
{
	struct _jc_polyglot_visit_Translator$object *r0;
	struct _jc_object *r1;
	struct _jc_object *r3;
	struct _jc_java_lang_Object$object *r4;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(86);				// 0
	r3 = _JC_REF_FIELD(env, r0, polyglot_visit_Translator, context);
	if (r1 != r3)
		goto label0;
	_JC_LINE_NUMBER(87);				// 1
	return r0;

label0:
	_JC_LINE_NUMBER(89);				// 2
	r4 = _JC_INVOKE_VIRTUAL(env, polyglot_visit_Translator, copy$2119f530248e04c9, r0);
	r0 = _JC_CAST(env, &_jc_polyglot_visit_Translator$type, r4);
	_JC_LINE_NUMBER(90);				// 3
	_JC_REF_FIELD(env, r0, polyglot_visit_Translator, context) = r1;
	_JC_LINE_NUMBER(91);				// 4
	return r0;
}

//
// public java.lang.Object copy()
//

static _jc_linenum _jc_polyglot_visit_Translator$linenum_table$copy$2119f530248e04c9[];

static _jc_trap_info _jc_polyglot_visit_Translator$trap_table$copy$2119f530248e04c9[] = {
	_JC_TRAP(&_jc_java_lang_CloneNotSupportedException$type, 1, 2),
};

static const unsigned char _jc_polyglot_visit_Translator$param_ptypes$copy$2119f530248e04c9[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_visit_Translator$method_info$copy$2119f530248e04c9 = {
	.name=			"copy",
	.signature=		"()Ljava/lang/Object;",
	.class=			&_jc_polyglot_visit_Translator$type,
	.return_type=		&_jc_java_lang_Object$type,
	.param_ptypes=		&_jc_polyglot_visit_Translator$param_ptypes$copy$2119f530248e04c9,
	.signature_hash=	_JC_JLONG(0x2119f530248e04c9),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_visit_Translator$method$copy$2119f530248e04c9,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_visit_Translator$vtable, polyglot_visit_Translator.copy$2119f530248e04c9) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .trap_table_len=	1,
	  .trap_table=		_jc_polyglot_visit_Translator$trap_table$copy$2119f530248e04c9,
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_polyglot_visit_Translator$linenum_table$copy$2119f530248e04c9
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_visit_Translator, copy$2119f530248e04c9);

_jc_java_lang_Object$object * _JC_JCNI_ATTR
_jc_polyglot_visit_Translator$method$copy$2119f530248e04c9(_jc_env *const env, _jc_polyglot_visit_Translator$object *this)
{
	struct _jc_polyglot_visit_Translator$object *r0;
	struct _jc_java_lang_CloneNotSupportedException$object *r1;
	struct _jc_polyglot_util_InternalCompilerError$object *volatile r2;
	struct _jc_java_lang_String$object *volatile r3;
	struct _jc_polyglot_util_Position$object *volatile r4;
	struct _jc_java_lang_VMThrowable$object *volatile r5;
	struct _jc_java_lang_Object$object *r6;
	struct _jc_object *r7;
	struct _jc_java_lang_CloneNotSupportedException$object *r8;
	struct _jc_java_lang_String$object *r9;
	jboolean z0;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_polyglot_visit_Translator$method_info$copy$2119f530248e04c9, &&label2);

	r0 = this;
	_JC_TRAP_REGION(catch, 1);
	z0 = _JC_INSTANCEOF(env, r0, &_jc_java_lang_Cloneable$type);
	if (z0 == 0)
		goto label0;
	r7 = r0;
	r6 = _JC_INVOKE_STATIC(env, java_lang_VMObject, clone$3943fce805d80b70, 0, r7);
	goto label1;

label0:
	r8 = _JC_NEW(env, java_lang_CloneNotSupportedException);
	r9 = _JC_STRING(env, "Object not cloneable");
	_JC_INVOKE_NONVIRTUAL(env, java_lang_Throwable, _init$c31b894660454d13, 0, r8, r9);
	_JC_THROW(env, r8);

label1:
	_JC_TRAP_REGION(catch, 2);
	_JC_LINE_NUMBER(97);				// 0
	_JC_CANCEL_TRAPS(env, catch);
	return r6;

label2:
	_JC_TRAP_REGION(catch, 2);
	r1 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(100);				// 1
	r2 = _JC_NEW(env, polyglot_util_InternalCompilerError);
	r3 = _JC_STRING(env, "Java clone() weirdness.");
	r4 = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, cause) = r2;
	r5 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r2);
	_JC_REF_FIELD(env, r2, java_lang_Throwable, vmState) = r5;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, detailMessage) = r3;
	_JC_REF_FIELD(env, r2, polyglot_util_InternalCompilerError, pos) = r4;
	_JC_THROW(env, r2);
}

//
// protected java.util.List exports(polyglot.ast.SourceFile)
//

static _jc_linenum _jc_polyglot_visit_Translator$linenum_table$exports$f6d52b102c5c058e[];

static const unsigned char _jc_polyglot_visit_Translator$param_ptypes$exports$f6d52b102c5c058e[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_polyglot_visit_Translator$param_types$exports$f6d52b102c5c058e[] = {
	&_jc_polyglot_ast_SourceFile$type
};

_jc_method _jc_polyglot_visit_Translator$method_info$exports$f6d52b102c5c058e = {
	.name=			"exports",
	.signature=		"(Lpolyglot/ast/SourceFile;)Ljava/util/List;",
	.class=			&_jc_polyglot_visit_Translator$type,
	.param_types=		&_jc_polyglot_visit_Translator$param_types$exports$f6d52b102c5c058e,
	.return_type=		&_jc_java_util_List$type,
	.param_ptypes=		&_jc_polyglot_visit_Translator$param_ptypes$exports$f6d52b102c5c058e,
	.signature_hash=	_JC_JLONG(0xf6d52b102c5c058e),
	.access_flags=		_JC_ACC_PROTECTED,
	.function=		&_jc_polyglot_visit_Translator$method$exports$f6d52b102c5c058e,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_visit_Translator$vtable, polyglot_visit_Translator.exports$f6d52b102c5c058e) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	6,
	      .table=	_jc_polyglot_visit_Translator$linenum_table$exports$f6d52b102c5c058e
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_visit_Translator, exports$f6d52b102c5c058e);

_jc_object * _JC_JCNI_ATTR
_jc_polyglot_visit_Translator$method$exports$f6d52b102c5c058e(_jc_env *const env, _jc_polyglot_visit_Translator$object *this, _jc_object *param0)
{
	struct _jc_polyglot_visit_Translator$object *r0;
	struct _jc_object *r1;
	struct _jc_java_util_LinkedList$object *r2;
	struct _jc_object *r3;
	struct _jc_object *r4;
	struct _jc_object *r5;
	struct _jc_java_lang_Object$object *r6;
	struct _jc_polyglot_types_Flags$object *r7;
	struct _jc_java_util_LinkedList__24Entry$object *r8;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(288);				// 0
	r2 = _JC_NEW(env, java_util_LinkedList);
	_JC_PRIM_FIELD(env, r2, java_util_LinkedList, size) = 0;
	_JC_LINE_NUMBER(290);				// 1
	r5 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0xf47960398a001327), _jc_object *, (_jc_env *, struct _jc_object *));
	r3 = _JC_INVOKE_INTERFACE(env, r5, _JC_JLONG(0x3cc91493d50f531c), _jc_object *, (_jc_env *, struct _jc_object *));

label0:
	z0 = _JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0xfb0bd5e38c59ddcd), jboolean, (_jc_env *, struct _jc_object *));
	if (z0 == 0)
		goto label1;
	_JC_LINE_NUMBER(291);				// 2
	r6 = _JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0x5874f79a1cf66ea), _jc_object *, (_jc_env *, struct _jc_object *));
	r4 = _JC_CAST(env, &_jc_polyglot_ast_TopLevelDecl$type, r6);
	_JC_LINE_NUMBER(293);				// 3
	r7 = _JC_INVOKE_INTERFACE(env, r4, _JC_JLONG(0xbdfb01ac8f620c5e), _jc_object *, (_jc_env *, struct _jc_object *));
	z0 = _JC_INVOKE_VIRTUAL(env, polyglot_types_Flags, isPublic$bc4f14961e6f9c56, r7);
	if (z0 == 0) {
		_JC_PERIODIC_CHECK(env);
		goto label0;
	}
	r8 = _JC_NEW(env, java_util_LinkedList__24Entry);
	_JC_REF_FIELD(env, r8, java_util_LinkedList__24Entry, data) = r4;
	_JC_INVOKE_NONVIRTUAL(env, java_util_LinkedList, addLastEntry$0c5f1e760480777a, 0, r2, r8);
	_JC_LINE_NUMBER(294);				// 4
	_JC_PERIODIC_CHECK(env);
	goto label0;

label1:
	_JC_LINE_NUMBER(298);				// 5
	return r2;
}

//
// public polyglot.frontend.Job job()
//

static _jc_linenum _jc_polyglot_visit_Translator$linenum_table$job$60bb99fb0e87eae0[];

static const unsigned char _jc_polyglot_visit_Translator$param_ptypes$job$60bb99fb0e87eae0[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_visit_Translator$method_info$job$60bb99fb0e87eae0 = {
	.name=			"job",
	.signature=		"()Lpolyglot/frontend/Job;",
	.class=			&_jc_polyglot_visit_Translator$type,
	.return_type=		&_jc_polyglot_frontend_Job$type,
	.param_ptypes=		&_jc_polyglot_visit_Translator$param_ptypes$job$60bb99fb0e87eae0,
	.signature_hash=	_JC_JLONG(0x60bb99fb0e87eae0),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_visit_Translator$method$job$60bb99fb0e87eae0,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_visit_Translator$vtable, polyglot_visit_Translator.job$60bb99fb0e87eae0) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_visit_Translator$linenum_table$job$60bb99fb0e87eae0
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_visit_Translator, job$60bb99fb0e87eae0);

_jc_polyglot_frontend_Job$object * _JC_JCNI_ATTR
_jc_polyglot_visit_Translator$method$job$60bb99fb0e87eae0(_jc_env *const env, _jc_polyglot_visit_Translator$object *this)
{
	struct _jc_polyglot_visit_Translator$object *r0;
	struct _jc_polyglot_frontend_Job$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(80);				// 0
	r1 = _JC_REF_FIELD(env, r0, polyglot_visit_Translator, job);
	return r1;
}

//
// public polyglot.ast.NodeFactory nodeFactory()
//

static _jc_linenum _jc_polyglot_visit_Translator$linenum_table$nodeFactory$32826050387dc827[];

static const unsigned char _jc_polyglot_visit_Translator$param_ptypes$nodeFactory$32826050387dc827[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_visit_Translator$method_info$nodeFactory$32826050387dc827 = {
	.name=			"nodeFactory",
	.signature=		"()Lpolyglot/ast/NodeFactory;",
	.class=			&_jc_polyglot_visit_Translator$type,
	.return_type=		&_jc_polyglot_ast_NodeFactory$type,
	.param_ptypes=		&_jc_polyglot_visit_Translator$param_ptypes$nodeFactory$32826050387dc827,
	.signature_hash=	_JC_JLONG(0x32826050387dc827),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_visit_Translator$method$nodeFactory$32826050387dc827,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_visit_Translator$vtable, polyglot_visit_Translator.nodeFactory$32826050387dc827) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_visit_Translator$linenum_table$nodeFactory$32826050387dc827
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_visit_Translator, nodeFactory$32826050387dc827);

_jc_object * _JC_JCNI_ATTR
_jc_polyglot_visit_Translator$method$nodeFactory$32826050387dc827(_jc_env *const env, _jc_polyglot_visit_Translator$object *this)
{
	struct _jc_polyglot_visit_Translator$object *r0;
	struct _jc_object *r1;

	r0 = this;
	_JC_LINE_NUMBER(131);				// 0
	r1 = _JC_REF_FIELD(env, r0, polyglot_visit_Translator, nf);
	return r1;
}

//
// public polyglot.types.ClassType outerClass()
//

static _jc_linenum _jc_polyglot_visit_Translator$linenum_table$outerClass$675b9793fb1d7d4d[];

static const unsigned char _jc_polyglot_visit_Translator$param_ptypes$outerClass$675b9793fb1d7d4d[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_visit_Translator$method_info$outerClass$675b9793fb1d7d4d = {
	.name=			"outerClass",
	.signature=		"()Lpolyglot/types/ClassType;",
	.class=			&_jc_polyglot_visit_Translator$type,
	.return_type=		&_jc_polyglot_types_ClassType$type,
	.param_ptypes=		&_jc_polyglot_visit_Translator$param_ptypes$outerClass$675b9793fb1d7d4d,
	.signature_hash=	_JC_JLONG(0x675b9793fb1d7d4d),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_visit_Translator$method$outerClass$675b9793fb1d7d4d,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_visit_Translator$vtable, polyglot_visit_Translator.outerClass$675b9793fb1d7d4d) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_visit_Translator$linenum_table$outerClass$675b9793fb1d7d4d
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_visit_Translator, outerClass$675b9793fb1d7d4d);

_jc_object * _JC_JCNI_ATTR
_jc_polyglot_visit_Translator$method$outerClass$675b9793fb1d7d4d(_jc_env *const env, _jc_polyglot_visit_Translator$object *this)
{
	struct _jc_polyglot_visit_Translator$object *r0;
	struct _jc_object *r1;

	r0 = this;
	_JC_LINE_NUMBER(111);				// 0
	r1 = _JC_REF_FIELD(env, r0, polyglot_visit_Translator, outerClass);
	return r1;
}

//
// public void print(polyglot.ast.Node, polyglot.ast.Node, polyglot.util.CodeWriter)
//

static _jc_linenum _jc_polyglot_visit_Translator$linenum_table$print$be8fd119cbff90e9[];

static const unsigned char _jc_polyglot_visit_Translator$param_ptypes$print$be8fd119cbff90e9[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_visit_Translator$param_types$print$be8fd119cbff90e9[] = {
	&_jc_polyglot_ast_Node$type,
	&_jc_polyglot_ast_Node$type,
	&_jc_polyglot_util_CodeWriter$type
};

_jc_method _jc_polyglot_visit_Translator$method_info$print$be8fd119cbff90e9 = {
	.name=			"print",
	.signature=		"(Lpolyglot/ast/Node;Lpolyglot/ast/Node;Lpolyglot/util/CodeWriter;)V",
	.class=			&_jc_polyglot_visit_Translator$type,
	.param_types=		&_jc_polyglot_visit_Translator$param_types$print$be8fd119cbff90e9,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_visit_Translator$param_ptypes$print$be8fd119cbff90e9,
	.signature_hash=	_JC_JLONG(0xbe8fd119cbff90e9),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_visit_Translator$method$print$be8fd119cbff90e9,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_visit_Translator$vtable, polyglot_visit_Translator.print$be8fd119cbff90e9) / sizeof(void *),
	.num_parameters=	3,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	8,
	      .table=	_jc_polyglot_visit_Translator$linenum_table$print$be8fd119cbff90e9
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_visit_Translator, print$be8fd119cbff90e9);

void _JC_JCNI_ATTR
_jc_polyglot_visit_Translator$method$print$be8fd119cbff90e9(_jc_env *const env, _jc_polyglot_visit_Translator$object *this, _jc_object *param0, _jc_object *param1, _jc_polyglot_util_CodeWriter$object *param2)
{
	struct _jc_polyglot_visit_Translator$object *r0;
	struct _jc_object *r1;
	struct _jc_object *r2;
	struct _jc_polyglot_util_CodeWriter$object *r3;
	struct _jc_object *r4;
	struct _jc_polyglot_visit_Translator$object *r5;
	struct _jc_object *r7;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	r3 = param2;
	_JC_LINE_NUMBER(142);				// 0
	if (r1 == _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(143);				// 1
	r4 = _JC_REF_FIELD(env, r0, polyglot_visit_Translator, context);
	r4 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0xfabeac726ca62dc1), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_object *), r4);
	_JC_LINE_NUMBER(144);				// 2
	r5 = _JC_INVOKE_VIRTUAL(env, polyglot_visit_Translator, context$ffa1e34312c710b6, r0, r4);
	goto label1;

label0:
	_JC_LINE_NUMBER(147);				// 3
	r5 = r0;

label1:
	_JC_LINE_NUMBER(150);				// 4
	r7 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0x63197ba171bd0e94), _jc_object *, (_jc_env *, struct _jc_object *));
	_JC_INVOKE_INTERFACE(env, r7, _JC_JLONG(0xa71b7acdcea34061), void, (_jc_env *, struct _jc_object *, struct _jc_polyglot_util_CodeWriter$object *, struct _jc_polyglot_visit_Translator$object *), r3, r5);
	_JC_LINE_NUMBER(152);				// 5
	if (r1 == _JC_NULL)
		goto label2;
	_JC_LINE_NUMBER(153);				// 6
	r4 = _JC_REF_FIELD(env, r0, polyglot_visit_Translator, context);
	_JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0x466c32a4263da0dd), void, (_jc_env *, struct _jc_object *, struct _jc_object *), r4);

label2:
	_JC_LINE_NUMBER(155);				// 7
	return;
}

//
// public void setOuterClass(polyglot.types.ClassType)
//

static _jc_linenum _jc_polyglot_visit_Translator$linenum_table$setOuterClass$7228bd09ffd2ce90[];

static const unsigned char _jc_polyglot_visit_Translator$param_ptypes$setOuterClass$7228bd09ffd2ce90[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_visit_Translator$param_types$setOuterClass$7228bd09ffd2ce90[] = {
	&_jc_polyglot_types_ClassType$type
};

_jc_method _jc_polyglot_visit_Translator$method_info$setOuterClass$7228bd09ffd2ce90 = {
	.name=			"setOuterClass",
	.signature=		"(Lpolyglot/types/ClassType;)V",
	.class=			&_jc_polyglot_visit_Translator$type,
	.param_types=		&_jc_polyglot_visit_Translator$param_types$setOuterClass$7228bd09ffd2ce90,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_visit_Translator$param_ptypes$setOuterClass$7228bd09ffd2ce90,
	.signature_hash=	_JC_JLONG(0x7228bd09ffd2ce90),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_visit_Translator$method$setOuterClass$7228bd09ffd2ce90,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_visit_Translator$vtable, polyglot_visit_Translator.setOuterClass$7228bd09ffd2ce90) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_polyglot_visit_Translator$linenum_table$setOuterClass$7228bd09ffd2ce90
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_visit_Translator, setOuterClass$7228bd09ffd2ce90);

void _JC_JCNI_ATTR
_jc_polyglot_visit_Translator$method$setOuterClass$7228bd09ffd2ce90(_jc_env *const env, _jc_polyglot_visit_Translator$object *this, _jc_object *param0)
{
	struct _jc_polyglot_visit_Translator$object *r0;
	struct _jc_object *r1;

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(116);				// 0
	_JC_REF_FIELD(env, r0, polyglot_visit_Translator, outerClass) = r1;
	_JC_LINE_NUMBER(117);				// 1
	return;
}

//
// public java.lang.String toString()
//

static _jc_linenum _jc_polyglot_visit_Translator$linenum_table$toString$7ea43b33b80a3070[];

static const unsigned char _jc_polyglot_visit_Translator$param_ptypes$toString$7ea43b33b80a3070[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_visit_Translator$method_info$toString$7ea43b33b80a3070 = {
	.name=			"toString",
	.signature=		"()Ljava/lang/String;",
	.class=			&_jc_polyglot_visit_Translator$type,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_polyglot_visit_Translator$param_ptypes$toString$7ea43b33b80a3070,
	.signature_hash=	_JC_JLONG(0x7ea43b33b80a3070),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_visit_Translator$method$toString$7ea43b33b80a3070,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_visit_Translator$vtable, polyglot_visit_Translator.toString$7ea43b33b80a3070) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_visit_Translator$linenum_table$toString$7ea43b33b80a3070
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_visit_Translator, toString$7ea43b33b80a3070);

_jc_java_lang_String$object * _JC_JCNI_ATTR
_jc_polyglot_visit_Translator$method$toString$7ea43b33b80a3070(_jc_env *const env, _jc_polyglot_visit_Translator$object *this)
{
	struct _jc_polyglot_visit_Translator$object *r0;

	r0 = this;
	_JC_LINE_NUMBER(302);				// 0
	return _JC_STRING(env, "Translator");
}

//
// public boolean translate(polyglot.ast.Node)
//

static _jc_linenum _jc_polyglot_visit_Translator$linenum_table$translate$75cb5e42bb1fc04b[];

static const unsigned char _jc_polyglot_visit_Translator$param_ptypes$translate$75cb5e42bb1fc04b[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_polyglot_visit_Translator$param_types$translate$75cb5e42bb1fc04b[] = {
	&_jc_polyglot_ast_Node$type
};

_jc_method _jc_polyglot_visit_Translator$method_info$translate$75cb5e42bb1fc04b = {
	.name=			"translate",
	.signature=		"(Lpolyglot/ast/Node;)Z",
	.class=			&_jc_polyglot_visit_Translator$type,
	.param_types=		&_jc_polyglot_visit_Translator$param_types$translate$75cb5e42bb1fc04b,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_polyglot_visit_Translator$param_ptypes$translate$75cb5e42bb1fc04b,
	.signature_hash=	_JC_JLONG(0x75cb5e42bb1fc04b),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_visit_Translator$method$translate$75cb5e42bb1fc04b,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_visit_Translator$vtable, polyglot_visit_Translator.translate$75cb5e42bb1fc04b) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	11,
	      .table=	_jc_polyglot_visit_Translator$linenum_table$translate$75cb5e42bb1fc04b
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_visit_Translator, translate$75cb5e42bb1fc04b);

jboolean _JC_JCNI_ATTR
_jc_polyglot_visit_Translator$method$translate$75cb5e42bb1fc04b(_jc_env *const env, _jc_polyglot_visit_Translator$object *this, _jc_object *param0)
{
	struct _jc_polyglot_visit_Translator$object *r0;
	struct _jc_object *r1;
	struct _jc_java_lang_String$object *r10;
	struct _jc_java_lang_String$object *r11;
	struct _jc_polyglot_util_Position$object *r12;
	_jc_char_array *r13;
	struct _jc_java_lang_VMThrowable$object *r15;
	struct _jc_object *r2;
	struct _jc_object *r3;
	struct _jc_object *r4;
	struct _jc_object *r5;
	struct _jc_java_lang_Object$object *r6;
	struct _jc_polyglot_util_InternalCompilerError$object *r7;
	struct _jc_java_lang_StringBuffer$object *r8;
	struct _jc_java_lang_Class$object *r9;
	jboolean z0;
	jboolean z1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(159);				// 0
	z0 = _JC_INSTANCEOF(env, r1, &_jc_polyglot_ast_SourceFile$type);
	if (z0 == 0)
		goto label0;
	_JC_LINE_NUMBER(160);				// 1
	r2 = r1;
	_JC_LINE_NUMBER(161);				// 2
	z0 = _JC_INVOKE_VIRTUAL(env, polyglot_visit_Translator, translateSource$3a4c8df0ac409962, r0, r2);
	return z0;

label0:
	_JC_LINE_NUMBER(163);				// 3
	z0 = _JC_INSTANCEOF(env, r1, &_jc_polyglot_ast_SourceCollection$type);
	if (z0 == 0)
		goto label3;
	_JC_LINE_NUMBER(164);				// 4
	r4 = r1;
	_JC_LINE_NUMBER(166);				// 5
	z0 = 1;
	_JC_LINE_NUMBER(168);				// 6
	r5 = _JC_INVOKE_INTERFACE(env, r4, _JC_JLONG(0xc7962ae651ac0609), _jc_object *, (_jc_env *, struct _jc_object *));
	r3 = _JC_INVOKE_INTERFACE(env, r5, _JC_JLONG(0x3cc91493d50f531c), _jc_object *, (_jc_env *, struct _jc_object *));

label1:
	z1 = _JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0xfb0bd5e38c59ddcd), jboolean, (_jc_env *, struct _jc_object *));
	if (z1 == 0)
		goto label2;
	_JC_LINE_NUMBER(169);				// 7
	r6 = _JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0x5874f79a1cf66ea), _jc_object *, (_jc_env *, struct _jc_object *));
	r2 = _JC_CAST(env, &_jc_polyglot_ast_SourceFile$type, r6);
	_JC_LINE_NUMBER(170);				// 8
	z1 = _JC_INVOKE_VIRTUAL(env, polyglot_visit_Translator, translateSource$3a4c8df0ac409962, r0, r2);
	z0 = z0 & z1;
	_JC_PERIODIC_CHECK(env);
	goto label1;

label2:
	_JC_LINE_NUMBER(173);				// 9
	return z0;

label3:
	_JC_LINE_NUMBER(176);				// 10
	r7 = _JC_NEW(env, polyglot_util_InternalCompilerError);
	r8 = _JC_NEW(env, java_lang_StringBuffer);
	r13 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r8, java_lang_StringBuffer, value) = r13;
	r8 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r8, _JC_STRING(env, "AST root must be a SourceFile; found a "));
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	r9 = _JC_INVOKE_STATIC(env, java_lang_VMObject, getClass$2be11d215bfbfbfe, 0, r1);
	_JC_EXPLICIT_NULL_CHECK(env, r9);
	r10 = _JC_INVOKE_STATIC(env, java_lang_VMClass, getName$7a04fe8e1a654d36, 0, r9);
	r8 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r8, r10);
	r11 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r11, r8);
	r12 = _JC_NULL;
	_JC_REF_FIELD(env, r7, java_lang_Throwable, cause) = r7;
	r15 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r7);
	_JC_REF_FIELD(env, r7, java_lang_Throwable, vmState) = r15;
	_JC_REF_FIELD(env, r7, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r7, java_lang_Throwable, detailMessage) = r11;
	_JC_REF_FIELD(env, r7, polyglot_util_InternalCompilerError, pos) = r12;
	_JC_THROW(env, r7);
}

//
// protected boolean translateSource(polyglot.ast.SourceFile)
//

static _jc_linenum _jc_polyglot_visit_Translator$linenum_table$translateSource$3a4c8df0ac409962[];

static _jc_trap_info _jc_polyglot_visit_Translator$trap_table$translateSource$3a4c8df0ac409962[] = {
	_JC_TRAP(&_jc_java_io_IOException$type, 1, 2),
};

static const unsigned char _jc_polyglot_visit_Translator$param_ptypes$translateSource$3a4c8df0ac409962[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_polyglot_visit_Translator$param_types$translateSource$3a4c8df0ac409962[] = {
	&_jc_polyglot_ast_SourceFile$type
};

_jc_method _jc_polyglot_visit_Translator$method_info$translateSource$3a4c8df0ac409962 = {
	.name=			"translateSource",
	.signature=		"(Lpolyglot/ast/SourceFile;)Z",
	.class=			&_jc_polyglot_visit_Translator$type,
	.param_types=		&_jc_polyglot_visit_Translator$param_types$translateSource$3a4c8df0ac409962,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_polyglot_visit_Translator$param_ptypes$translateSource$3a4c8df0ac409962,
	.signature_hash=	_JC_JLONG(0x3a4c8df0ac409962),
	.access_flags=		_JC_ACC_PROTECTED,
	.function=		&_jc_polyglot_visit_Translator$method$translateSource$3a4c8df0ac409962,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_visit_Translator$vtable, polyglot_visit_Translator.translateSource$3a4c8df0ac409962) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .trap_table_len=	1,
	  .trap_table=		_jc_polyglot_visit_Translator$trap_table$translateSource$3a4c8df0ac409962,
	  .u= {
	    .linenum= {
	      .len=	39,
	      .table=	_jc_polyglot_visit_Translator$linenum_table$translateSource$3a4c8df0ac409962
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_visit_Translator, translateSource$3a4c8df0ac409962);

jboolean _JC_JCNI_ATTR
_jc_polyglot_visit_Translator$method$translateSource$3a4c8df0ac409962(_jc_env *const env, _jc_polyglot_visit_Translator$object *this, _jc_object *param0)
{
	jint i0;
	jint i1;
	jint i2;
	jint i3;
	_jc_object *n0;
	_jc_object *n1;
	struct _jc_polyglot_visit_Translator$object *volatile r0;
	struct _jc_object *r1;
	struct _jc_java_io_Writer$object *r10;
	struct _jc_polyglot_util_CodeWriter$object *r11;
	struct _jc_object *r12;
	struct _jc_object *r13;
	struct _jc_polyglot_frontend_Job$object *volatile r14;
	struct _jc_polyglot_frontend_Compiler$object *volatile r15;
	struct _jc_object *r16;
	struct _jc_object *r17;
	struct _jc_polyglot_frontend_Source$object *r18;
	struct _jc_java_lang_Object$object *r19;
	struct _jc_polyglot_frontend_TargetFactory$object *r2;
	struct _jc_polyglot_types_Flags$object *r20;
	struct _jc_object *r21;
	struct _jc_polyglot_visit_Translator$object *r22;
	struct _jc_java_io_IOException$object *volatile r23;
	struct _jc_object *volatile r24;
	struct _jc_java_lang_StringBuffer$object *volatile r25;
	struct _jc_java_lang_String$object *volatile r26;
	_jc_char_array *volatile r27;
	struct _jc_polyglot_util_Newline$object *r28;
	struct _jc_polyglot_util_BlockItem$object *r29;
	struct _jc_object *r3;
	struct _jc_java_lang_String$object *r30;
	struct _jc_java_lang_String$object *r31;
	struct _jc_polyglot_util_BlockItem$object *r32;
	struct _jc_polyglot_util_BlockItem$object *r33;
	struct _jc_polyglot_util_BlockItem$object *r34;
	struct _jc_polyglot_util_BlockItem$object *r35;
	struct _jc_object *r4;
	struct _jc_java_lang_String$object *r5;
	struct _jc_object *r6;
	struct _jc_object *r7;
	struct _jc_java_io_File$object *r8;
	struct _jc_java_lang_String$object *volatile r9;
	jboolean z0;
	jboolean z1;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_polyglot_visit_Translator$method_info$translateSource$3a4c8df0ac409962, &&label7);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(183);				// 0
	_JC_INVOKE_VIRTUAL(env, polyglot_visit_Translator, typeSystem$c9dab312e784024e, r0);
	_JC_LINE_NUMBER(184);				// 1
	_JC_INVOKE_VIRTUAL(env, polyglot_visit_Translator, nodeFactory$32826050387dc827, r0);
	_JC_LINE_NUMBER(185);				// 2
	r2 = _JC_REF_FIELD(env, r0, polyglot_visit_Translator, tf);
	_JC_LINE_NUMBER(186);				// 3
	r14 = _JC_REF_FIELD(env, r0, polyglot_visit_Translator, job);
	r15 = _JC_INVOKE_VIRTUAL(env, polyglot_frontend_Job, compiler$a83a951e175ae03a, r14);
	i0 = _JC_INVOKE_VIRTUAL(env, polyglot_frontend_Compiler, outputWidth$27644889335135c1, r15);
	_JC_LINE_NUMBER(187);				// 4
	r14 = _JC_REF_FIELD(env, r0, polyglot_visit_Translator, job);
	r15 = _JC_INVOKE_VIRTUAL(env, polyglot_frontend_Job, compiler$a83a951e175ae03a, r14);
	r3 = _JC_INVOKE_VIRTUAL(env, polyglot_frontend_Compiler, outputFiles$3911e88355956017, r15);
	_JC_LINE_NUMBER(194);				// 5
	r4 = _JC_INVOKE_VIRTUAL(env, polyglot_visit_Translator, exports$f6d52b102c5c058e, r0, r1);
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(201);				// 6
	r5 = _JC_STRING(env, "");
	_JC_LINE_NUMBER(203);				// 7
	r16 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0x64bd8daed7a6995d), _jc_object *, (_jc_env *, struct _jc_object *));
	if (r16 == _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(204);				// 8
	r16 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0x64bd8daed7a6995d), _jc_object *, (_jc_env *, struct _jc_object *));
	r6 = _JC_INVOKE_INTERFACE(env, r16, _JC_JLONG(0x2a2aa1010d61af28), _jc_object *, (_jc_env *, struct _jc_object *));
	_JC_LINE_NUMBER(205);				// 9
	r5 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, toString$7ea43b33b80a3070, r6);

label0:
	_JC_LINE_NUMBER(208);				// 10
	r17 = _JC_REF_FIELD(env, r0, polyglot_visit_Translator, context);
	r17 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0xfabeac726ca62dc1), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_object *), r17);
	_JC_LINE_NUMBER(210);				// 11
	r7 = _JC_NULL;
	_JC_LINE_NUMBER(212);				// 12
	i1 = _JC_INVOKE_INTERFACE(env, r4, _JC_JLONG(0x345df5220fc60ade), jint, (_jc_env *, struct _jc_object *));
	if (i1 != 0)
		goto label1;
	_JC_LINE_NUMBER(214);				// 13
	r18 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0x998a5a64aa67515f), _jc_object *, (_jc_env *, struct _jc_object *));
	r8 = _JC_INVOKE_VIRTUAL(env, polyglot_frontend_TargetFactory, outputFile$d841c7f40915a70a, r2, r5, r18);
	goto label2;

label1:
	_JC_LINE_NUMBER(217);				// 14
	r19 = _JC_INVOKE_INTERFACE(env, r4, _JC_JLONG(0xa706240e1333824b), _jc_object *, (_jc_env *, struct _jc_object *, jint), 0);
	r7 = _JC_CAST(env, &_jc_polyglot_ast_TopLevelDecl$type, r19);
	_JC_LINE_NUMBER(218);				// 15
	r9 = _JC_INVOKE_INTERFACE(env, r7, _JC_JLONG(0xe6acce026cadf81e), _jc_object *, (_jc_env *, struct _jc_object *));
	r18 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0x998a5a64aa67515f), _jc_object *, (_jc_env *, struct _jc_object *));
	r8 = _JC_INVOKE_VIRTUAL(env, polyglot_frontend_TargetFactory, outputFile$d78934d4d9797553, r2, r5, r9, r18);

label2:
	_JC_LINE_NUMBER(221);				// 16
	r9 = _JC_INVOKE_VIRTUAL(env, java_io_File, getPath$7dfdcb0b5a7c8226, r8);
	_JC_EXPLICIT_NULL_CHECK(env, r9);
	r31 = _JC_STRING(env, "$");
	i2 = _JC_PRIM_FIELD(env, r9, java_lang_String, count);
	i3 = _JC_PRIM_FIELD(env, r31, java_lang_String, count);
	i3 = i2 - i3;
	i2 = _JC_PRIM_FIELD(env, r31, java_lang_String, count);
	z1 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, regionMatches$8a82c88118b60ee6, 0, r9, 0, i3, r31, 0, i2);
	_JC_LINE_NUMBER(222);				// 17
	if (z1 != 0)
		goto label3;
	r9 = _JC_INVOKE_VIRTUAL(env, java_io_File, getPath$7dfdcb0b5a7c8226, r8);
	_JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0x831f06ee5f59c0cc), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r9);

label3:
	_JC_LINE_NUMBER(223);				// 18
	r10 = _JC_INVOKE_VIRTUAL(env, polyglot_frontend_TargetFactory, outputWriter$d25a01a68d960754, r2, r8);
	_JC_LINE_NUMBER(224);				// 19
	r11 = _JC_NEW(env, polyglot_util_CodeWriter);
	_JC_REF_FIELD(env, r11, polyglot_util_CodeWriter, output) = r10;
	_JC_PRIM_FIELD(env, r11, polyglot_util_CodeWriter, width) = i0;
	r32 = _JC_NEW(env, polyglot_util_BlockItem);
	r33 = _JC_NULL;
	_JC_PRIM_FIELD(env, r32, polyglot_util_Item, min__5fwidth) = -1;
	_JC_PRIM_FIELD(env, r32, polyglot_util_Item, min__5findent) = -1;
	_JC_PRIM_FIELD(env, r32, polyglot_util_Item, min__5fpos__5fwidth) = -1;
	_JC_PRIM_FIELD(env, r32, polyglot_util_Item, cb__5finit) = 0;
	_JC_REF_FIELD(env, r32, polyglot_util_Item, next) = _JC_NULL;
	_JC_PRIM_FIELD(env, r32, polyglot_util_BlockItem, self__5fcontains__5fbrks__5finit) = 0;
	_JC_REF_FIELD(env, r32, polyglot_util_BlockItem, parent) = r33;
	n0 = _JC_NULL;
	_JC_REF_FIELD(env, r32, polyglot_util_BlockItem, last) = n0;
	_JC_REF_FIELD(env, r32, polyglot_util_BlockItem, first) = n0;
	_JC_PRIM_FIELD(env, r32, polyglot_util_BlockItem, indent) = 0;
	_JC_REF_FIELD(env, r11, polyglot_util_CodeWriter, input) = r32;
	_JC_REF_FIELD(env, r11, polyglot_util_CodeWriter, current) = r32;
	_JC_LINE_NUMBER(226);				// 20
	_JC_INVOKE_VIRTUAL(env, polyglot_visit_Translator, writeHeader$7006aebec4b242cc, r0, r1, r11);
	_JC_LINE_NUMBER(228);				// 21
	r4 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0xf47960398a001327), _jc_object *, (_jc_env *, struct _jc_object *));
	r12 = _JC_INVOKE_INTERFACE(env, r4, _JC_JLONG(0x3cc91493d50f531c), _jc_object *, (_jc_env *, struct _jc_object *));

label4:
	z0 = _JC_INVOKE_INTERFACE(env, r12, _JC_JLONG(0xfb0bd5e38c59ddcd), jboolean, (_jc_env *, struct _jc_object *));
	if (z0 == 0)
		goto label6;
	_JC_LINE_NUMBER(229);				// 22
	r19 = _JC_INVOKE_INTERFACE(env, r12, _JC_JLONG(0x5874f79a1cf66ea), _jc_object *, (_jc_env *, struct _jc_object *));
	r13 = _JC_CAST(env, &_jc_polyglot_ast_TopLevelDecl$type, r19);
	_JC_LINE_NUMBER(231);				// 23
	r20 = _JC_INVOKE_INTERFACE(env, r13, _JC_JLONG(0xbdfb01ac8f620c5e), _jc_object *, (_jc_env *, struct _jc_object *));
	z0 = _JC_INVOKE_VIRTUAL(env, polyglot_types_Flags, isPublic$bc4f14961e6f9c56, r20);
	if (z0 == 0)
		goto label5;
	if (r13 == r7)
		goto label5;
	_JC_LINE_NUMBER(234);				// 24
	_JC_INVOKE_NONVIRTUAL(env, polyglot_util_CodeWriter, flush$fcb1369224b7ab00, 0, r11);
	_JC_LINE_NUMBER(235);				// 25
	_JC_INVOKE_VIRTUAL(env, java_io_Writer, close$6aba8b329fddcd79, r10);
	_JC_LINE_NUMBER(237);				// 26
	r9 = _JC_INVOKE_INTERFACE(env, r13, _JC_JLONG(0xe6acce026cadf81e), _jc_object *, (_jc_env *, struct _jc_object *));
	r18 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0x998a5a64aa67515f), _jc_object *, (_jc_env *, struct _jc_object *));
	r8 = _JC_INVOKE_VIRTUAL(env, polyglot_frontend_TargetFactory, outputFile$d78934d4d9797553, r2, r5, r9, r18);
	_JC_LINE_NUMBER(238);				// 27
	r9 = _JC_INVOKE_VIRTUAL(env, java_io_File, getPath$7dfdcb0b5a7c8226, r8);
	_JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0x831f06ee5f59c0cc), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r9);
	_JC_LINE_NUMBER(239);				// 28
	r10 = _JC_INVOKE_VIRTUAL(env, polyglot_frontend_TargetFactory, outputWriter$d25a01a68d960754, r2, r8);
	_JC_LINE_NUMBER(240);				// 29
	r11 = _JC_NEW(env, polyglot_util_CodeWriter);
	_JC_REF_FIELD(env, r11, polyglot_util_CodeWriter, output) = r10;
	_JC_PRIM_FIELD(env, r11, polyglot_util_CodeWriter, width) = i0;
	r34 = _JC_NEW(env, polyglot_util_BlockItem);
	r35 = _JC_NULL;
	_JC_PRIM_FIELD(env, r34, polyglot_util_Item, min__5fwidth) = -1;
	_JC_PRIM_FIELD(env, r34, polyglot_util_Item, min__5findent) = -1;
	_JC_PRIM_FIELD(env, r34, polyglot_util_Item, min__5fpos__5fwidth) = -1;
	_JC_PRIM_FIELD(env, r34, polyglot_util_Item, cb__5finit) = 0;
	_JC_REF_FIELD(env, r34, polyglot_util_Item, next) = _JC_NULL;
	_JC_PRIM_FIELD(env, r34, polyglot_util_BlockItem, self__5fcontains__5fbrks__5finit) = 0;
	_JC_REF_FIELD(env, r34, polyglot_util_BlockItem, parent) = r35;
	n1 = _JC_NULL;
	_JC_REF_FIELD(env, r34, polyglot_util_BlockItem, last) = n1;
	_JC_REF_FIELD(env, r34, polyglot_util_BlockItem, first) = n1;
	_JC_PRIM_FIELD(env, r34, polyglot_util_BlockItem, indent) = 0;
	_JC_REF_FIELD(env, r11, polyglot_util_CodeWriter, input) = r34;
	_JC_REF_FIELD(env, r11, polyglot_util_CodeWriter, current) = r34;
	_JC_LINE_NUMBER(242);				// 30
	_JC_INVOKE_VIRTUAL(env, polyglot_visit_Translator, writeHeader$7006aebec4b242cc, r0, r1, r11);

label5:
	_JC_LINE_NUMBER(245);				// 31
	r21 = _JC_INVOKE_INTERFACE(env, r13, _JC_JLONG(0x63197ba171bd0e94), _jc_object *, (_jc_env *, struct _jc_object *));
	r22 = _JC_INVOKE_VIRTUAL(env, polyglot_visit_Translator, context$ffa1e34312c710b6, r0, r17);
	_JC_INVOKE_INTERFACE(env, r21, _JC_JLONG(0xa71b7acdcea34061), void, (_jc_env *, struct _jc_object *, struct _jc_polyglot_util_CodeWriter$object *, struct _jc_polyglot_visit_Translator$object *), r11, r22);
	_JC_LINE_NUMBER(247);				// 32
	z0 = _JC_INVOKE_INTERFACE(env, r12, _JC_JLONG(0xfb0bd5e38c59ddcd), jboolean, (_jc_env *, struct _jc_object *));
	if (z0 == 0) {
		_JC_PERIODIC_CHECK(env);
		goto label4;
	}
	r29 = _JC_REF_FIELD(env, r11, polyglot_util_CodeWriter, current);
	r28 = _JC_NEW(env, polyglot_util_Newline);
	r30 = _JC_STRING(env, "");
	_JC_PRIM_FIELD(env, r28, polyglot_util_Item, min__5fwidth) = -1;
	_JC_PRIM_FIELD(env, r28, polyglot_util_Item, min__5findent) = -1;
	_JC_PRIM_FIELD(env, r28, polyglot_util_Item, min__5fpos__5fwidth) = -1;
	_JC_PRIM_FIELD(env, r28, polyglot_util_Item, cb__5finit) = 0;
	_JC_REF_FIELD(env, r28, polyglot_util_Item, next) = _JC_NULL;
	_JC_PRIM_FIELD(env, r28, polyglot_util_AllowBreak, broken) = 1;
	_JC_PRIM_FIELD(env, r28, polyglot_util_AllowBreak, indent) = 0;
	_JC_REF_FIELD(env, r28, polyglot_util_AllowBreak, alt) = r30;
	_JC_INVOKE_VIRTUAL(env, polyglot_util_BlockItem, add$4c1a4b240ebd457c, r29, r28);
	_JC_LINE_NUMBER(248);				// 33
	_JC_PERIODIC_CHECK(env);
	goto label4;

label6:
	_JC_LINE_NUMBER(252);				// 34
	_JC_INVOKE_NONVIRTUAL(env, polyglot_util_CodeWriter, flush$fcb1369224b7ab00, 0, r11);
	_JC_LINE_NUMBER(253);				// 35
	_JC_INVOKE_VIRTUAL(env, java_io_Writer, close$6aba8b329fddcd79, r10);
	_JC_TRAP_REGION(catch, 2);
	_JC_LINE_NUMBER(254);				// 36
	_JC_CANCEL_TRAPS(env, catch);
	return 1;

label7:
	_JC_TRAP_REGION(catch, 2);
	r23 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(257);				// 37
	r14 = _JC_REF_FIELD(env, r0, polyglot_visit_Translator, job);
	r15 = _JC_INVOKE_VIRTUAL(env, polyglot_frontend_Job, compiler$a83a951e175ae03a, r14);
	r24 = _JC_INVOKE_VIRTUAL(env, polyglot_frontend_Compiler, errorQueue$6d038e7585ab4339, r15);
	r25 = _JC_NEW(env, java_lang_StringBuffer);
	r27 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r25, java_lang_StringBuffer, value) = r27;
	r25 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r25, _JC_STRING(env, "I/O error while translating: "));
	r9 = _JC_INVOKE_VIRTUAL(env, java_lang_Throwable, getMessage$13aaf240efc902b1, r23);
	r25 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r25, r9);
	r26 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r26, r25);
	_JC_INVOKE_INTERFACE(env, r24, _JC_JLONG(0x7659161d8f442ddb), void, (_jc_env *, struct _jc_object *, jint, struct _jc_java_lang_String$object *), 2, r26);
	_JC_LINE_NUMBER(259);				// 38
	_JC_CANCEL_TRAPS(env, catch);
	return 0;
}

//
// public polyglot.types.TypeSystem typeSystem()
//

static _jc_linenum _jc_polyglot_visit_Translator$linenum_table$typeSystem$c9dab312e784024e[];

static const unsigned char _jc_polyglot_visit_Translator$param_ptypes$typeSystem$c9dab312e784024e[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_polyglot_visit_Translator$method_info$typeSystem$c9dab312e784024e = {
	.name=			"typeSystem",
	.signature=		"()Lpolyglot/types/TypeSystem;",
	.class=			&_jc_polyglot_visit_Translator$type,
	.return_type=		&_jc_polyglot_types_TypeSystem$type,
	.param_ptypes=		&_jc_polyglot_visit_Translator$param_ptypes$typeSystem$c9dab312e784024e,
	.signature_hash=	_JC_JLONG(0xc9dab312e784024e),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_polyglot_visit_Translator$method$typeSystem$c9dab312e784024e,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_visit_Translator$vtable, polyglot_visit_Translator.typeSystem$c9dab312e784024e) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_polyglot_visit_Translator$linenum_table$typeSystem$c9dab312e784024e
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_visit_Translator, typeSystem$c9dab312e784024e);

_jc_object * _JC_JCNI_ATTR
_jc_polyglot_visit_Translator$method$typeSystem$c9dab312e784024e(_jc_env *const env, _jc_polyglot_visit_Translator$object *this)
{
	struct _jc_polyglot_visit_Translator$object *r0;
	struct _jc_object *r1;

	r0 = this;
	_JC_LINE_NUMBER(121);				// 0
	r1 = _JC_REF_FIELD(env, r0, polyglot_visit_Translator, ts);
	return r1;
}

//
// protected void writeHeader(polyglot.ast.SourceFile, polyglot.util.CodeWriter)
//

static _jc_linenum _jc_polyglot_visit_Translator$linenum_table$writeHeader$7006aebec4b242cc[];

static const unsigned char _jc_polyglot_visit_Translator$param_ptypes$writeHeader$7006aebec4b242cc[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_polyglot_visit_Translator$param_types$writeHeader$7006aebec4b242cc[] = {
	&_jc_polyglot_ast_SourceFile$type,
	&_jc_polyglot_util_CodeWriter$type
};

_jc_method _jc_polyglot_visit_Translator$method_info$writeHeader$7006aebec4b242cc = {
	.name=			"writeHeader",
	.signature=		"(Lpolyglot/ast/SourceFile;Lpolyglot/util/CodeWriter;)V",
	.class=			&_jc_polyglot_visit_Translator$type,
	.param_types=		&_jc_polyglot_visit_Translator$param_types$writeHeader$7006aebec4b242cc,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_polyglot_visit_Translator$param_ptypes$writeHeader$7006aebec4b242cc,
	.signature_hash=	_JC_JLONG(0x7006aebec4b242cc),
	.access_flags=		_JC_ACC_PROTECTED,
	.function=		&_jc_polyglot_visit_Translator$method$writeHeader$7006aebec4b242cc,
	.vtable_index=		_JC_OFFSETOF(struct _jc_polyglot_visit_Translator$vtable, polyglot_visit_Translator.writeHeader$7006aebec4b242cc) / sizeof(void *),
	.num_parameters=	2,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	14,
	      .table=	_jc_polyglot_visit_Translator$linenum_table$writeHeader$7006aebec4b242cc
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(polyglot_visit_Translator, writeHeader$7006aebec4b242cc);

void _JC_JCNI_ATTR
_jc_polyglot_visit_Translator$method$writeHeader$7006aebec4b242cc(_jc_env *const env, _jc_polyglot_visit_Translator$object *this, _jc_object *param0, _jc_polyglot_util_CodeWriter$object *param1)
{
	struct _jc_polyglot_visit_Translator$object *r0;
	struct _jc_object *r1;
	struct _jc_polyglot_util_CodeWriter$object *r2;
	struct _jc_object *r3;
	struct _jc_object *r4;
	struct _jc_object *r5;
	struct _jc_object *r7;
	struct _jc_object *r8;
	struct _jc_java_lang_Object$object *r9;
	jboolean z0;
	jboolean z1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_LINE_NUMBER(265);				// 0
	r5 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0x64bd8daed7a6995d), _jc_object *, (_jc_env *, struct _jc_object *));
	if (r5 == _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(266);				// 1
	_JC_INVOKE_VIRTUAL(env, polyglot_util_CodeWriter, write$741cedc3a0899944, r2, _JC_STRING(env, "package "));
	_JC_LINE_NUMBER(267);				// 2
	r5 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0x64bd8daed7a6995d), _jc_object *, (_jc_env *, struct _jc_object *));
	r7 = _JC_INVOKE_INTERFACE(env, r5, _JC_JLONG(0x63197ba171bd0e94), _jc_object *, (_jc_env *, struct _jc_object *));
	_JC_INVOKE_INTERFACE(env, r7, _JC_JLONG(0xa71b7acdcea34061), void, (_jc_env *, struct _jc_object *, struct _jc_polyglot_util_CodeWriter$object *, struct _jc_polyglot_visit_Translator$object *), r2, r0);
	_JC_LINE_NUMBER(268);				// 3
	_JC_INVOKE_VIRTUAL(env, polyglot_util_CodeWriter, write$741cedc3a0899944, r2, _JC_STRING(env, ";"));
	_JC_LINE_NUMBER(269);				// 4
	_JC_INVOKE_VIRTUAL(env, polyglot_util_CodeWriter, newline$87c37c893944ffc4, r2, 0);
	_JC_LINE_NUMBER(270);				// 5
	_JC_INVOKE_VIRTUAL(env, polyglot_util_CodeWriter, newline$87c37c893944ffc4, r2, 0);

label0:
	_JC_LINE_NUMBER(273);				// 6
	z0 = 0;
	_JC_LINE_NUMBER(275);				// 7
	r8 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0xb6078c2cf656e471), _jc_object *, (_jc_env *, struct _jc_object *));
	r3 = _JC_INVOKE_INTERFACE(env, r8, _JC_JLONG(0x3cc91493d50f531c), _jc_object *, (_jc_env *, struct _jc_object *));

label1:
	z1 = _JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0xfb0bd5e38c59ddcd), jboolean, (_jc_env *, struct _jc_object *));
	if (z1 == 0)
		goto label2;
	_JC_LINE_NUMBER(276);				// 8
	r9 = _JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0x5874f79a1cf66ea), _jc_object *, (_jc_env *, struct _jc_object *));
	r4 = _JC_CAST(env, &_jc_polyglot_ast_Import$type, r9);
	_JC_LINE_NUMBER(277);				// 9
	r7 = _JC_INVOKE_INTERFACE(env, r4, _JC_JLONG(0x63197ba171bd0e94), _jc_object *, (_jc_env *, struct _jc_object *));
	_JC_INVOKE_INTERFACE(env, r7, _JC_JLONG(0xa71b7acdcea34061), void, (_jc_env *, struct _jc_object *, struct _jc_polyglot_util_CodeWriter$object *, struct _jc_polyglot_visit_Translator$object *), r2, r0);
	_JC_LINE_NUMBER(278);				// 10
	z0 = 1;
	_JC_PERIODIC_CHECK(env);
	goto label1;

label2:
	_JC_LINE_NUMBER(281);				// 11
	if (z0 == 0)
		goto label3;
	_JC_LINE_NUMBER(282);				// 12
	_JC_INVOKE_VIRTUAL(env, polyglot_util_CodeWriter, newline$87c37c893944ffc4, r2, 0);

label3:
	_JC_LINE_NUMBER(284);				// 13
	return;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_polyglot_visit_Translator$methods[] = {
	&_jc_polyglot_visit_Translator$method_info$_init$56c0d1f8d1b49d93,
	&_jc_polyglot_visit_Translator$method_info$context$4c5ebe4f0ff1c15f,
	&_jc_polyglot_visit_Translator$method_info$context$ffa1e34312c710b6,
	&_jc_polyglot_visit_Translator$method_info$copy$2119f530248e04c9,
	&_jc_polyglot_visit_Translator$method_info$exports$f6d52b102c5c058e,
	&_jc_polyglot_visit_Translator$method_info$job$60bb99fb0e87eae0,
	&_jc_polyglot_visit_Translator$method_info$nodeFactory$32826050387dc827,
	&_jc_polyglot_visit_Translator$method_info$outerClass$675b9793fb1d7d4d,
	&_jc_polyglot_visit_Translator$method_info$print$be8fd119cbff90e9,
	&_jc_polyglot_visit_Translator$method_info$setOuterClass$7228bd09ffd2ce90,
	&_jc_polyglot_visit_Translator$method_info$toString$7ea43b33b80a3070,
	&_jc_polyglot_visit_Translator$method_info$translate$75cb5e42bb1fc04b,
	&_jc_polyglot_visit_Translator$method_info$translateSource$3a4c8df0ac409962,
	&_jc_polyglot_visit_Translator$method_info$typeSystem$c9dab312e784024e,
	&_jc_polyglot_visit_Translator$method_info$writeHeader$7006aebec4b242cc
};

/************************************************************************
 *			      Interface list				*
 ************************************************************************/

// Directly implemented interfaces
static _jc_type *const _jc_polyglot_visit_Translator$interfaces[] = {
	&_jc_polyglot_util_Copy$type
};

/************************************************************************
 *			   Interface hash table				*
 ************************************************************************/

#if _JC_IMETHOD_HASHSIZE != 128
#error "_JC_IMETHOD_HASHSIZE has the wrong value (should be 128)"
#endif

// Interface lookup hash table buckets
static _jc_method *_jc_polyglot_visit_Translator$imethod_hash_bucket_73[] = {
	&_jc_polyglot_visit_Translator$method_info$copy$2119f530248e04c9,
	_JC_NULL
};

// Interface lookup hash table
static _jc_method **_jc_polyglot_visit_Translator$imethod_hash_table[_JC_IMETHOD_HASHSIZE] = {
	[73]=	_jc_polyglot_visit_Translator$imethod_hash_bucket_73
};

// Interface "quick" lookup hash table
static const void *_jc_polyglot_visit_Translator$imethod_quick_table[_JC_IMETHOD_HASHSIZE] = {
	[73]=	&_jc_polyglot_visit_Translator$method$copy$2119f530248e04c9
};

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_polyglot_visit_Translator$instanceof_hash_bucket_2[] = {
	&_jc_polyglot_util_Copy$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_visit_Translator$instanceof_hash_bucket_19[] = {
	&_jc_java_lang_Cloneable$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_visit_Translator$instanceof_hash_bucket_25[] = {
	&_jc_polyglot_visit_PrettyPrinter$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_visit_Translator$instanceof_hash_bucket_37[] = {
	&_jc_polyglot_visit_Translator$type,
	_JC_NULL
};
static _jc_type *const _jc_polyglot_visit_Translator$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_polyglot_visit_Translator$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[2]=	_jc_polyglot_visit_Translator$instanceof_hash_bucket_2,
	[19]=	_jc_polyglot_visit_Translator$instanceof_hash_bucket_19,
	[25]=	_jc_polyglot_visit_Translator$instanceof_hash_bucket_25,
	[37]=	_jc_polyglot_visit_Translator$instanceof_hash_bucket_37,
	[101]=	_jc_polyglot_visit_Translator$instanceof_hash_bucket_101
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_polyglot_visit_Translator$class_depends[] = {
	{ "java/io/File",	_JC_JLONG(0x9cef6b66128b04b2) },
	{ "java/io/IOException",	_JC_JLONG(0x4e0a56550c69d57c) },
	{ "java/io/Writer",	_JC_JLONG(0x4897ee169f60a14f) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/CloneNotSupportedException",	_JC_JLONG(0xd59353b5e031d754) },
	{ "java/lang/Cloneable",	_JC_JLONG(0x9b667b09132be893) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/RuntimeException",	_JC_JLONG(0x4f5534a987354d1d) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/StringBuffer",	_JC_JLONG(0x94d357637b968dda) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMClass",	_JC_JLONG(0x238a2c0aafd74314) },
	{ "java/lang/VMObject",	_JC_JLONG(0x312e45ed214d432f) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/util/AbstractCollection",	_JC_JLONG(0x8ea716c64b77f8eb) },
	{ "java/util/AbstractList",	_JC_JLONG(0xf5238436362828db) },
	{ "java/util/AbstractSequentialList",	_JC_JLONG(0x6d7997e879c41059) },
	{ "java/util/Collection",	_JC_JLONG(0xeae4d0c0e8eb63da) },
	{ "java/util/Iterator",	_JC_JLONG(0xbe56ff673eefd9d2) },
	{ "java/util/LinkedList",	_JC_JLONG(0x666417b6279ae396) },
	{ "java/util/LinkedList$Entry",	_JC_JLONG(0x2522cc4453ab9d02) },
	{ "java/util/List",	_JC_JLONG(0x9ee0d92ce1525a4d) },
	{ "polyglot/ast/Import",	_JC_JLONG(0xe1faa924d53ccbd6) },
	{ "polyglot/ast/JL",	_JC_JLONG(0x653c77643765390d) },
	{ "polyglot/ast/Node",	_JC_JLONG(0x1c402b4f9747e08) },
	{ "polyglot/ast/NodeFactory",	_JC_JLONG(0x56625b3befab19f) },
	{ "polyglot/ast/PackageNode",	_JC_JLONG(0x5a97e30dbcca371b) },
	{ "polyglot/ast/SourceCollection",	_JC_JLONG(0x79aa0375a207249e) },
	{ "polyglot/ast/SourceFile",	_JC_JLONG(0xcc4102d52764e835) },
	{ "polyglot/ast/TopLevelDecl",	_JC_JLONG(0xbafb0341dee3e659) },
	{ "polyglot/frontend/Compiler",	_JC_JLONG(0x3ea6f1cf85115422) },
	{ "polyglot/frontend/Job",	_JC_JLONG(0x42e687805b457724) },
	{ "polyglot/frontend/Source",	_JC_JLONG(0xcd88b669bec8f787) },
	{ "polyglot/frontend/TargetFactory",	_JC_JLONG(0xc99629f926ef2e3f) },
	{ "polyglot/types/ClassType",	_JC_JLONG(0xb38560af658974f8) },
	{ "polyglot/types/Context",	_JC_JLONG(0xa433cdcd788f6c37) },
	{ "polyglot/types/Flags",	_JC_JLONG(0x821eb65d8f2f30f6) },
	{ "polyglot/types/Package",	_JC_JLONG(0x15df1cfa12c16381) },
	{ "polyglot/types/TypeSystem",	_JC_JLONG(0xed171cdaca38ec28) },
	{ "polyglot/util/AllowBreak",	_JC_JLONG(0xbc2875222b1ccf02) },
	{ "polyglot/util/BlockItem",	_JC_JLONG(0xc47ea105a198c856) },
	{ "polyglot/util/CodeWriter",	_JC_JLONG(0xbda7215170a25efc) },
	{ "polyglot/util/Copy",	_JC_JLONG(0xc1adfaf4637dbc02) },
	{ "polyglot/util/ErrorQueue",	_JC_JLONG(0xff712c8463bdfdc0) },
	{ "polyglot/util/InternalCompilerError",	_JC_JLONG(0x22b321d488641c54) },
	{ "polyglot/util/Item",	_JC_JLONG(0x77b6315f0d7667d7) },
	{ "polyglot/util/Newline",	_JC_JLONG(0xe65ad0113d489ab4) },
	{ "polyglot/util/Position",	_JC_JLONG(0x32c9a088c5dac046) },
	{ "polyglot/visit/PrettyPrinter",	_JC_JLONG(0x9b5998bb4b90b099) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_polyglot_visit_Translator$vtype _jc_polyglot_visit_Translator$type = {
    .type= {
	.name=			"polyglot/visit/Translator",
	.superclass=		&_jc_polyglot_visit_PrettyPrinter$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.num_interfaces=sizeof(_jc_polyglot_visit_Translator$interfaces) / sizeof(*_jc_polyglot_visit_Translator$interfaces),
	.interfaces=		_jc_polyglot_visit_Translator$interfaces,
	.imethod_hash_table=	_jc_polyglot_visit_Translator$imethod_hash_table,
	.imethod_quick_table=	_jc_polyglot_visit_Translator$imethod_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		31,
		.hash=			_JC_JLONG(0x91b74e58638056a5),
		.source_file=		"Translator.java",
		.instance_size=		sizeof(_jc_polyglot_visit_Translator$refs) + sizeof(_jc_polyglot_visit_Translator$object),
		.num_virtual_refs=	6,
		.num_fields=		sizeof(_jc_polyglot_visit_Translator$fields) / sizeof(*_jc_polyglot_visit_Translator$fields),
		.fields=		_jc_polyglot_visit_Translator$fields,
		.num_methods=		sizeof(_jc_polyglot_visit_Translator$methods) / sizeof(*_jc_polyglot_visit_Translator$methods),
		.methods=		_jc_polyglot_visit_Translator$methods,
		.instanceof_hash_table=	_jc_polyglot_visit_Translator$instanceof_hash_table,
		.num_class_depends=		sizeof(_jc_polyglot_visit_Translator$class_depends) / sizeof(*_jc_polyglot_visit_Translator$class_depends),
		.class_depends=		_jc_polyglot_visit_Translator$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=			// overridden
		&_jc_polyglot_visit_Translator$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.polyglot_visit_PrettyPrinter= {
	    .appendSemicolon$ef52943abec52244=
		&_jc_polyglot_visit_PrettyPrinter$method$appendSemicolon$ef52943abec52244,
	    .appendSemicolon$3eee72f89e285cad=
		&_jc_polyglot_visit_PrettyPrinter$method$appendSemicolon$3eee72f89e285cad,
	    .print$be8fd119cbff90e9=			// overridden
		&_jc_polyglot_visit_Translator$method$print$be8fd119cbff90e9,
	    .printAst$501fe41e7ed32dd4=
		&_jc_polyglot_visit_PrettyPrinter$method$printAst$501fe41e7ed32dd4,
	    .printType$a652b156b81ce22a=
		&_jc_polyglot_visit_PrettyPrinter$method$printType$a652b156b81ce22a,
	    .printType$9f92289ce5818d49=
		&_jc_polyglot_visit_PrettyPrinter$method$printType$9f92289ce5818d49,
	},
	.polyglot_visit_Translator= {
	    .context$4c5ebe4f0ff1c15f=
		&_jc_polyglot_visit_Translator$method$context$4c5ebe4f0ff1c15f,
	    .context$ffa1e34312c710b6=
		&_jc_polyglot_visit_Translator$method$context$ffa1e34312c710b6,
	    .copy$2119f530248e04c9=
		&_jc_polyglot_visit_Translator$method$copy$2119f530248e04c9,
	    .exports$f6d52b102c5c058e=
		&_jc_polyglot_visit_Translator$method$exports$f6d52b102c5c058e,
	    .job$60bb99fb0e87eae0=
		&_jc_polyglot_visit_Translator$method$job$60bb99fb0e87eae0,
	    .nodeFactory$32826050387dc827=
		&_jc_polyglot_visit_Translator$method$nodeFactory$32826050387dc827,
	    .outerClass$675b9793fb1d7d4d=
		&_jc_polyglot_visit_Translator$method$outerClass$675b9793fb1d7d4d,
	    .print$be8fd119cbff90e9=
		&_jc_polyglot_visit_Translator$method$print$be8fd119cbff90e9,
	    .setOuterClass$7228bd09ffd2ce90=
		&_jc_polyglot_visit_Translator$method$setOuterClass$7228bd09ffd2ce90,
	    .toString$7ea43b33b80a3070=
		&_jc_polyglot_visit_Translator$method$toString$7ea43b33b80a3070,
	    .translate$75cb5e42bb1fc04b=
		&_jc_polyglot_visit_Translator$method$translate$75cb5e42bb1fc04b,
	    .translateSource$3a4c8df0ac409962=
		&_jc_polyglot_visit_Translator$method$translateSource$3a4c8df0ac409962,
	    .typeSystem$c9dab312e784024e=
		&_jc_polyglot_visit_Translator$method$typeSystem$c9dab312e784024e,
	    .writeHeader$7006aebec4b242cc=
		&_jc_polyglot_visit_Translator$method$writeHeader$7006aebec4b242cc,
	},
    }
};

