// public class soot.javaToJimple.Util

// class file dependencies
// @dep_class 99a46305ebacacb5 java_io_PrintStream
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class 4f5534a987354d1d java_lang_RuntimeException
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 94d357637b968dda java_lang_StringBuffer
// @dep_class 53cc8e2333795f04 java_lang_System
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class 1c402b4f9747e08 polyglot_ast_Node
// @dep_class 412788f7d4254477 polyglot_types_ArrayType
// @dep_class b38560af658974f8 polyglot_types_ClassType
// @dep_class 821eb65d8f2f30f6 polyglot_types_Flags
// @dep_class 6596051546781098 polyglot_types_Type
// @dep_class 32c9a088c5dac046 polyglot_util_Position
// @dep_class 13e7935c8aaa97c9 soot_ArrayType
// @dep_class 3dae18ed334ad777 soot_BooleanType
// @dep_class 2c7486b453945971 soot_ByteType
// @dep_class 804042b6713f0ed4 soot_CharType
// @dep_class f1367e60bd9c6d0a soot_DoubleType
// @dep_class ee3bc988001dd8c6 soot_FloatType
// @dep_class b6d33af8f84fdbc4 soot_G
// @dep_class fb57d8c2db7c3ab3 soot_IntType
// @dep_class aa1b631a0256e062 soot_LongType
// @dep_class f0a1b2286e398082 soot_NullType
// @dep_class d6846479002a370b soot_PrimType
// @dep_class fdbc627922b0ba72 soot_RefLikeType
// @dep_class 2887a1b57cecfb7b soot_RefType
// @dep_class 7120c8047949f8c0 soot_Scene
// @dep_class 9e6e4afb464dbc7 soot_ShortType
// @dep_class 6ac5bee50bbabb71 soot_Singletons
// @dep_class f801e5c664424a1 soot_Type
// @dep_class fddfad630263b66b soot_VoidType
// @dep_class fb501b85de60e3ab soot_javaToJimple_Util
// @dep_class e0215bb69aa8dac3 soot_javaToJimple_jj_DPosition
// @dep_class c5a5a246a3f59476 soot_options_Options
// @dep_class 81a85e00bf60ba4c soot_tagkit_Host
// @dep_class 4f112a0e13b029d9 soot_tagkit_PositionTag
// @dep_class 801ded4adf91a761 soot_tagkit_SourceLineNumberTag
// @dep_class b45e923b919717d3 soot_tagkit_SourceLnPosTag
// @dep_class 50f5695cb4eac404 soot_tagkit_SourcePositionTag
// @dep_class f5f751433138bc27 soot_util_Numberer

// header file dependencies
// @dep_header java_io_PrintStream
// @dep_header java_lang_Class
// @dep_header java_lang_RuntimeException
// @dep_header java_lang_String
// @dep_header java_lang_StringBuffer
// @dep_header java_lang_System
// @dep_header java_lang_VMThrowable
// @dep_header polyglot_ast_Node
// @dep_header polyglot_types_ArrayType
// @dep_header polyglot_types_ClassType
// @dep_header polyglot_types_Flags
// @dep_header polyglot_types_Type
// @dep_header soot_ArrayType
// @dep_header soot_BooleanType
// @dep_header soot_ByteType
// @dep_header soot_CharType
// @dep_header soot_DoubleType
// @dep_header soot_FloatType
// @dep_header soot_G
// @dep_header soot_IntType
// @dep_header soot_LongType
// @dep_header soot_NullType
// @dep_header soot_RefType
// @dep_header soot_Scene
// @dep_header soot_ShortType
// @dep_header soot_VoidType
// @dep_header soot_javaToJimple_Util
// @dep_header soot_javaToJimple_jj_DPosition
// @dep_header soot_options_Options
// @dep_header soot_tagkit_Host
// @dep_header soot_tagkit_SourceLineNumberTag
// @dep_header soot_tagkit_SourceLnPosTag
// @dep_header soot_tagkit_SourcePositionTag
// @dep_header soot_util_Numberer

#include "jc_defs.h"

#include "java/io/PrintStream.h"
#include "java/lang/Class.h"
#include "java/lang/RuntimeException.h"
#include "java/lang/String.h"
#include "java/lang/StringBuffer.h"
#include "java/lang/System.h"
#include "java/lang/VMThrowable.h"
#include "polyglot/ast/Node.h"
#include "polyglot/types/ArrayType.h"
#include "polyglot/types/ClassType.h"
#include "polyglot/types/Flags.h"
#include "polyglot/types/Type.h"
#include "soot/ArrayType.h"
#include "soot/BooleanType.h"
#include "soot/ByteType.h"
#include "soot/CharType.h"
#include "soot/DoubleType.h"
#include "soot/FloatType.h"
#include "soot/G.h"
#include "soot/IntType.h"
#include "soot/LongType.h"
#include "soot/NullType.h"
#include "soot/RefType.h"
#include "soot/Scene.h"
#include "soot/ShortType.h"
#include "soot/VoidType.h"
#include "soot/javaToJimple/Util.h"
#include "soot/javaToJimple/jj/DPosition.h"
#include "soot/options/Options.h"
#include "soot/tagkit/Host.h"
#include "soot/tagkit/SourceLineNumberTag.h"
#include "soot/tagkit/SourceLnPosTag.h"
#include "soot/tagkit/SourcePositionTag.h"
#include "soot/util/Numberer.h"

/************************************************************************
 *			      Static methods				*
 ************************************************************************/

//
// public static void addLineTag(soot.tagkit.Host, int, int)
//

static _jc_linenum _jc_soot_javaToJimple_Util$linenum_table$addLineTag$be7e39b51a0702a2[];

static const unsigned char _jc_soot_javaToJimple_Util$param_ptypes$addLineTag$be7e39b51a0702a2[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_INT, _JC_TYPE_VOID };

static _jc_type *const _jc_soot_javaToJimple_Util$param_types$addLineTag$be7e39b51a0702a2[] = {
	&_jc_soot_tagkit_Host$type,
	&_jc_int$prim$type,
	&_jc_int$prim$type
};

_jc_method _jc_soot_javaToJimple_Util$method_info$addLineTag$be7e39b51a0702a2 = {
	.name=			"addLineTag",
	.signature=		"(Lsoot/tagkit/Host;II)V",
	.class=			&_jc_soot_javaToJimple_Util$type,
	.param_types=		&_jc_soot_javaToJimple_Util$param_types$addLineTag$be7e39b51a0702a2,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_soot_javaToJimple_Util$param_ptypes$addLineTag$be7e39b51a0702a2,
	.signature_hash=	_JC_JLONG(0xbe7e39b51a0702a2),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_soot_javaToJimple_Util$method$addLineTag$be7e39b51a0702a2,
	.num_parameters=	3,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_soot_javaToJimple_Util$linenum_table$addLineTag$be7e39b51a0702a2
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_javaToJimple_Util, addLineTag$be7e39b51a0702a2);

void _JC_JCNI_ATTR
_jc_soot_javaToJimple_Util$method$addLineTag$be7e39b51a0702a2(_jc_env *const env, _jc_object *param0, jint param1, jint param2)
{
	jint i0;
	jint i1;
	struct _jc_object *r0;
	struct _jc_soot_tagkit_SourceLineNumberTag$object *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = param0;
	i0 = param1;
	i1 = param2;
	_JC_LINE_NUMBER(82);				// 0
	r1 = _JC_NEW(env, soot_tagkit_SourceLineNumberTag);
	_JC_PRIM_FIELD(env, r1, soot_tagkit_SourceLineNumberTag, startLineNumber) = i0;
	_JC_PRIM_FIELD(env, r1, soot_tagkit_SourceLineNumberTag, endLineNumber) = i1;
	_JC_INVOKE_INTERFACE(env, r0, _JC_JLONG(0xf92b02979eb63079), void, (_jc_env *, struct _jc_object *, struct _jc_object *), r1);
	_JC_LINE_NUMBER(84);				// 1
	return;
}

//
// public static void addLineTag(soot.tagkit.Host, polyglot.ast.Node)
//

static _jc_linenum _jc_soot_javaToJimple_Util$linenum_table$addLineTag$1708d233fe0fbae7[];

static const unsigned char _jc_soot_javaToJimple_Util$param_ptypes$addLineTag$1708d233fe0fbae7[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_soot_javaToJimple_Util$param_types$addLineTag$1708d233fe0fbae7[] = {
	&_jc_soot_tagkit_Host$type,
	&_jc_polyglot_ast_Node$type
};

_jc_method _jc_soot_javaToJimple_Util$method_info$addLineTag$1708d233fe0fbae7 = {
	.name=			"addLineTag",
	.signature=		"(Lsoot/tagkit/Host;Lpolyglot/ast/Node;)V",
	.class=			&_jc_soot_javaToJimple_Util$type,
	.param_types=		&_jc_soot_javaToJimple_Util$param_types$addLineTag$1708d233fe0fbae7,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_soot_javaToJimple_Util$param_ptypes$addLineTag$1708d233fe0fbae7,
	.signature_hash=	_JC_JLONG(0x1708d233fe0fbae7),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_soot_javaToJimple_Util$method$addLineTag$1708d233fe0fbae7,
	.num_parameters=	2,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	6,
	      .table=	_jc_soot_javaToJimple_Util$linenum_table$addLineTag$1708d233fe0fbae7
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_javaToJimple_Util, addLineTag$1708d233fe0fbae7);

void _JC_JCNI_ATTR
_jc_soot_javaToJimple_Util$method$addLineTag$1708d233fe0fbae7(_jc_env *const env, _jc_object *param0, _jc_object *param1)
{
	jint i0;
	jint i1;
	struct _jc_object *r0;
	struct _jc_object *r1;
	struct _jc_soot_javaToJimple_jj_DPosition$object *r2;
	struct _jc_soot_tagkit_SourceLineNumberTag$object *r3;
	struct _jc_polyglot_util_Position$object *r4;
	struct _jc_soot_options_Options$object *r5;
	struct _jc_soot_G$object *r6;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = param0;
	r1 = param1;
	_JC_ACTIVE_USE(env, soot_options_Options);
	_JC_ACTIVE_USE(env, soot_G);
	_JC_LINE_NUMBER(65);				// 0
	r6 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r5 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Options$9fd4168abe5957f7, r6);
	z0 = _JC_INVOKE_VIRTUAL(env, soot_options_Options, keep__5fline__5fnumber$c741becd57cdeba0, r5);
	if (z0 == 0)
		goto label0;
	_JC_LINE_NUMBER(66);				// 1
	r4 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0xbb89333b1e4c840c), _jc_object *, (_jc_env *, struct _jc_object *));
	if (r4 == _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(67);				// 2
	r4 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0xbb89333b1e4c840c), _jc_object *, (_jc_env *, struct _jc_object *));
	z0 = _JC_INSTANCEOF(env, r4, &_jc_soot_javaToJimple_jj_DPosition$type);
	if (z0 == 0)
		goto label0;
	_JC_LINE_NUMBER(68);				// 3
	r4 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0xbb89333b1e4c840c), _jc_object *, (_jc_env *, struct _jc_object *));
	r2 = _JC_CAST(env, &_jc_soot_javaToJimple_jj_DPosition$type, r4);
	_JC_LINE_NUMBER(69);				// 4
	r3 = _JC_NEW(env, soot_tagkit_SourceLineNumberTag);
	i0 = _JC_INVOKE_VIRTUAL(env, polyglot_util_Position, line$cff1e597e2cfa9a2, r2);
	i1 = _JC_INVOKE_VIRTUAL(env, polyglot_util_Position, line$cff1e597e2cfa9a2, r2);
	_JC_PRIM_FIELD(env, r3, soot_tagkit_SourceLineNumberTag, startLineNumber) = i0;
	_JC_PRIM_FIELD(env, r3, soot_tagkit_SourceLineNumberTag, endLineNumber) = i1;
	_JC_INVOKE_INTERFACE(env, r0, _JC_JLONG(0xf92b02979eb63079), void, (_jc_env *, struct _jc_object *, struct _jc_object *), r3);

label0:
	_JC_LINE_NUMBER(75);				// 5
	return;
}

//
// public static void addLnPosTags(soot.tagkit.Host, int, int, int, int)
//

static _jc_linenum _jc_soot_javaToJimple_Util$linenum_table$addLnPosTags$d688fb6975e31f57[];

static const unsigned char _jc_soot_javaToJimple_Util$param_ptypes$addLnPosTags$d688fb6975e31f57[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_INT, _JC_TYPE_INT, _JC_TYPE_INT, _JC_TYPE_VOID };

static _jc_type *const _jc_soot_javaToJimple_Util$param_types$addLnPosTags$d688fb6975e31f57[] = {
	&_jc_soot_tagkit_Host$type,
	&_jc_int$prim$type,
	&_jc_int$prim$type,
	&_jc_int$prim$type,
	&_jc_int$prim$type
};

_jc_method _jc_soot_javaToJimple_Util$method_info$addLnPosTags$d688fb6975e31f57 = {
	.name=			"addLnPosTags",
	.signature=		"(Lsoot/tagkit/Host;IIII)V",
	.class=			&_jc_soot_javaToJimple_Util$type,
	.param_types=		&_jc_soot_javaToJimple_Util$param_types$addLnPosTags$d688fb6975e31f57,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_soot_javaToJimple_Util$param_ptypes$addLnPosTags$d688fb6975e31f57,
	.signature_hash=	_JC_JLONG(0xd688fb6975e31f57),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_soot_javaToJimple_Util$method$addLnPosTags$d688fb6975e31f57,
	.num_parameters=	5,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_soot_javaToJimple_Util$linenum_table$addLnPosTags$d688fb6975e31f57
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_javaToJimple_Util, addLnPosTags$d688fb6975e31f57);

void _JC_JCNI_ATTR
_jc_soot_javaToJimple_Util$method$addLnPosTags$d688fb6975e31f57(_jc_env *const env, _jc_object *param0, jint param1, jint param2, jint param3, jint param4)
{
	jint i0;
	jint i1;
	jint i2;
	jint i3;
	struct _jc_object *r0;
	struct _jc_soot_tagkit_SourceLnPosTag$object *r1;
	struct _jc_soot_options_Options$object *r2;
	struct _jc_soot_G$object *r3;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = param0;
	i0 = param1;
	i1 = param2;
	i2 = param3;
	i3 = param4;
	_JC_ACTIVE_USE(env, soot_options_Options);
	_JC_ACTIVE_USE(env, soot_G);
	_JC_LINE_NUMBER(15);				// 0
	r3 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r2 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Options$9fd4168abe5957f7, r3);
	z0 = _JC_INVOKE_VIRTUAL(env, soot_options_Options, keep__5fline__5fnumber$c741becd57cdeba0, r2);
	if (z0 == 0)
		goto label0;
	_JC_LINE_NUMBER(16);				// 1
	r1 = _JC_NEW(env, soot_tagkit_SourceLnPosTag);
	_JC_PRIM_FIELD(env, r1, soot_tagkit_SourceLnPosTag, startLn) = i0;
	_JC_PRIM_FIELD(env, r1, soot_tagkit_SourceLnPosTag, endLn) = i1;
	_JC_PRIM_FIELD(env, r1, soot_tagkit_SourceLnPosTag, startPos) = i2;
	_JC_PRIM_FIELD(env, r1, soot_tagkit_SourceLnPosTag, endPos) = i3;
	_JC_INVOKE_INTERFACE(env, r0, _JC_JLONG(0xf92b02979eb63079), void, (_jc_env *, struct _jc_object *, struct _jc_object *), r1);

label0:
	_JC_LINE_NUMBER(20);				// 2
	return;
}

//
// public static void addLnPosTags(soot.tagkit.Host, polyglot.util.Position)
//

static _jc_linenum _jc_soot_javaToJimple_Util$linenum_table$addLnPosTags$dd6f10fd39b4041c[];

static const unsigned char _jc_soot_javaToJimple_Util$param_ptypes$addLnPosTags$dd6f10fd39b4041c[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_soot_javaToJimple_Util$param_types$addLnPosTags$dd6f10fd39b4041c[] = {
	&_jc_soot_tagkit_Host$type,
	&_jc_polyglot_util_Position$type
};

_jc_method _jc_soot_javaToJimple_Util$method_info$addLnPosTags$dd6f10fd39b4041c = {
	.name=			"addLnPosTags",
	.signature=		"(Lsoot/tagkit/Host;Lpolyglot/util/Position;)V",
	.class=			&_jc_soot_javaToJimple_Util$type,
	.param_types=		&_jc_soot_javaToJimple_Util$param_types$addLnPosTags$dd6f10fd39b4041c,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_soot_javaToJimple_Util$param_ptypes$addLnPosTags$dd6f10fd39b4041c,
	.signature_hash=	_JC_JLONG(0xdd6f10fd39b4041c),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_soot_javaToJimple_Util$method$addLnPosTags$dd6f10fd39b4041c,
	.num_parameters=	2,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_soot_javaToJimple_Util$linenum_table$addLnPosTags$dd6f10fd39b4041c
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_javaToJimple_Util, addLnPosTags$dd6f10fd39b4041c);

void _JC_JCNI_ATTR
_jc_soot_javaToJimple_Util$method$addLnPosTags$dd6f10fd39b4041c(_jc_env *const env, _jc_object *param0, _jc_polyglot_util_Position$object *param1)
{
	jint i0;
	jint i1;
	jint i2;
	jint i3;
	struct _jc_object *r0;
	struct _jc_polyglot_util_Position$object *r1;
	struct _jc_soot_javaToJimple_jj_DPosition$object *r2;
	struct _jc_soot_tagkit_SourceLnPosTag$object *r3;
	struct _jc_soot_options_Options$object *r4;
	struct _jc_soot_G$object *r5;
	jboolean z0;
	jboolean z1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = param0;
	r1 = param1;
	_JC_LINE_NUMBER(6);				// 0
	if (r1 == _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(7);				// 1
	z0 = _JC_INSTANCEOF(env, r1, &_jc_soot_javaToJimple_jj_DPosition$type);
	if (z0 == 0)
		goto label0;
	_JC_LINE_NUMBER(8);				// 2
	r2 = r1;
	_JC_LINE_NUMBER(9);				// 3
	i0 = _JC_INVOKE_VIRTUAL(env, polyglot_util_Position, line$cff1e597e2cfa9a2, r2);
	i1 = _JC_INVOKE_VIRTUAL(env, soot_javaToJimple_jj_DPosition, endLine$cc49f347e361c33f, r2);
	i2 = _JC_INVOKE_VIRTUAL(env, polyglot_util_Position, column$370206cd3cb25d90, r2);
	i3 = _JC_INVOKE_VIRTUAL(env, soot_javaToJimple_jj_DPosition, endCol$cef98fd6ba768cd6, r2);
	_JC_ACTIVE_USE(env, soot_options_Options);
	_JC_ACTIVE_USE(env, soot_G);
	r5 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r4 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Options$9fd4168abe5957f7, r5);
	z1 = _JC_INVOKE_VIRTUAL(env, soot_options_Options, keep__5fline__5fnumber$c741becd57cdeba0, r4);
	if (z1 == 0)
		goto label0;
	r3 = _JC_NEW(env, soot_tagkit_SourceLnPosTag);
	_JC_PRIM_FIELD(env, r3, soot_tagkit_SourceLnPosTag, startLn) = i0;
	_JC_PRIM_FIELD(env, r3, soot_tagkit_SourceLnPosTag, endLn) = i1;
	_JC_PRIM_FIELD(env, r3, soot_tagkit_SourceLnPosTag, startPos) = i2;
	_JC_PRIM_FIELD(env, r3, soot_tagkit_SourceLnPosTag, endPos) = i3;
	_JC_INVOKE_INTERFACE(env, r0, _JC_JLONG(0xf92b02979eb63079), void, (_jc_env *, struct _jc_object *, struct _jc_object *), r3);

label0:
	_JC_LINE_NUMBER(12);				// 4
	return;
}

//
// public static void addMethodLineTag(soot.tagkit.Host, int, int)
//

static _jc_linenum _jc_soot_javaToJimple_Util$linenum_table$addMethodLineTag$4e40b7597398e67c[];

static const unsigned char _jc_soot_javaToJimple_Util$param_ptypes$addMethodLineTag$4e40b7597398e67c[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_INT, _JC_TYPE_VOID };

static _jc_type *const _jc_soot_javaToJimple_Util$param_types$addMethodLineTag$4e40b7597398e67c[] = {
	&_jc_soot_tagkit_Host$type,
	&_jc_int$prim$type,
	&_jc_int$prim$type
};

_jc_method _jc_soot_javaToJimple_Util$method_info$addMethodLineTag$4e40b7597398e67c = {
	.name=			"addMethodLineTag",
	.signature=		"(Lsoot/tagkit/Host;II)V",
	.class=			&_jc_soot_javaToJimple_Util$type,
	.param_types=		&_jc_soot_javaToJimple_Util$param_types$addMethodLineTag$4e40b7597398e67c,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_soot_javaToJimple_Util$param_ptypes$addMethodLineTag$4e40b7597398e67c,
	.signature_hash=	_JC_JLONG(0x4e40b7597398e67c),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_soot_javaToJimple_Util$method$addMethodLineTag$4e40b7597398e67c,
	.num_parameters=	3,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_soot_javaToJimple_Util$linenum_table$addMethodLineTag$4e40b7597398e67c
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_javaToJimple_Util, addMethodLineTag$4e40b7597398e67c);

void _JC_JCNI_ATTR
_jc_soot_javaToJimple_Util$method$addMethodLineTag$4e40b7597398e67c(_jc_env *const env, _jc_object *param0, jint param1, jint param2)
{
	jint i0;
	jint i1;
	struct _jc_object *r0;
	struct _jc_soot_tagkit_SourceLineNumberTag$object *r1;
	struct _jc_soot_options_Options$object *r2;
	struct _jc_soot_G$object *r3;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = param0;
	i0 = param1;
	i1 = param2;
	_JC_ACTIVE_USE(env, soot_options_Options);
	_JC_ACTIVE_USE(env, soot_G);
	_JC_LINE_NUMBER(55);				// 0
	r3 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r2 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Options$9fd4168abe5957f7, r3);
	z0 = _JC_INVOKE_VIRTUAL(env, soot_options_Options, keep__5fline__5fnumber$c741becd57cdeba0, r2);
	if (z0 == 0)
		goto label0;
	_JC_LINE_NUMBER(56);				// 1
	r1 = _JC_NEW(env, soot_tagkit_SourceLineNumberTag);
	_JC_PRIM_FIELD(env, r1, soot_tagkit_SourceLineNumberTag, startLineNumber) = i0;
	_JC_PRIM_FIELD(env, r1, soot_tagkit_SourceLineNumberTag, endLineNumber) = i1;
	_JC_INVOKE_INTERFACE(env, r0, _JC_JLONG(0xf92b02979eb63079), void, (_jc_env *, struct _jc_object *, struct _jc_object *), r1);

label0:
	_JC_LINE_NUMBER(58);				// 2
	return;
}

//
// public static void addMethodPosTag(soot.tagkit.Host, int, int)
//

static _jc_linenum _jc_soot_javaToJimple_Util$linenum_table$addMethodPosTag$f7344d9686748d51[];

static const unsigned char _jc_soot_javaToJimple_Util$param_ptypes$addMethodPosTag$f7344d9686748d51[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_INT, _JC_TYPE_VOID };

static _jc_type *const _jc_soot_javaToJimple_Util$param_types$addMethodPosTag$f7344d9686748d51[] = {
	&_jc_soot_tagkit_Host$type,
	&_jc_int$prim$type,
	&_jc_int$prim$type
};

_jc_method _jc_soot_javaToJimple_Util$method_info$addMethodPosTag$f7344d9686748d51 = {
	.name=			"addMethodPosTag",
	.signature=		"(Lsoot/tagkit/Host;II)V",
	.class=			&_jc_soot_javaToJimple_Util$type,
	.param_types=		&_jc_soot_javaToJimple_Util$param_types$addMethodPosTag$f7344d9686748d51,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_soot_javaToJimple_Util$param_ptypes$addMethodPosTag$f7344d9686748d51,
	.signature_hash=	_JC_JLONG(0xf7344d9686748d51),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_soot_javaToJimple_Util$method$addMethodPosTag$f7344d9686748d51,
	.num_parameters=	3,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_soot_javaToJimple_Util$linenum_table$addMethodPosTag$f7344d9686748d51
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_javaToJimple_Util, addMethodPosTag$f7344d9686748d51);

void _JC_JCNI_ATTR
_jc_soot_javaToJimple_Util$method$addMethodPosTag$f7344d9686748d51(_jc_env *const env, _jc_object *param0, jint param1, jint param2)
{
	jint i0;
	jint i1;
	struct _jc_object *r0;
	struct _jc_soot_tagkit_SourcePositionTag$object *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = param0;
	i0 = param1;
	i1 = param2;
	_JC_LINE_NUMBER(43);				// 0
	r1 = _JC_NEW(env, soot_tagkit_SourcePositionTag);
	_JC_PRIM_FIELD(env, r1, soot_tagkit_PositionTag, startOffset) = i0;
	_JC_PRIM_FIELD(env, r1, soot_tagkit_PositionTag, endOffset) = i1;
	_JC_INVOKE_INTERFACE(env, r0, _JC_JLONG(0xf92b02979eb63079), void, (_jc_env *, struct _jc_object *, struct _jc_object *), r1);
	_JC_LINE_NUMBER(44);				// 1
	return;
}

//
// public static void addPosTag(soot.tagkit.Host, int, int)
//

static _jc_linenum _jc_soot_javaToJimple_Util$linenum_table$addPosTag$326ceab370f8ba8e[];

static const unsigned char _jc_soot_javaToJimple_Util$param_ptypes$addPosTag$326ceab370f8ba8e[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_INT, _JC_TYPE_VOID };

static _jc_type *const _jc_soot_javaToJimple_Util$param_types$addPosTag$326ceab370f8ba8e[] = {
	&_jc_soot_tagkit_Host$type,
	&_jc_int$prim$type,
	&_jc_int$prim$type
};

_jc_method _jc_soot_javaToJimple_Util$method_info$addPosTag$326ceab370f8ba8e = {
	.name=			"addPosTag",
	.signature=		"(Lsoot/tagkit/Host;II)V",
	.class=			&_jc_soot_javaToJimple_Util$type,
	.param_types=		&_jc_soot_javaToJimple_Util$param_types$addPosTag$326ceab370f8ba8e,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_soot_javaToJimple_Util$param_ptypes$addPosTag$326ceab370f8ba8e,
	.signature_hash=	_JC_JLONG(0x326ceab370f8ba8e),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_soot_javaToJimple_Util$method$addPosTag$326ceab370f8ba8e,
	.num_parameters=	3,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_soot_javaToJimple_Util$linenum_table$addPosTag$326ceab370f8ba8e
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_javaToJimple_Util, addPosTag$326ceab370f8ba8e);

void _JC_JCNI_ATTR
_jc_soot_javaToJimple_Util$method$addPosTag$326ceab370f8ba8e(_jc_env *const env, _jc_object *param0, jint param1, jint param2)
{
	jint i0;
	jint i1;
	struct _jc_object *r0;
	struct _jc_soot_tagkit_SourcePositionTag$object *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = param0;
	i0 = param1;
	i1 = param2;
	_JC_LINE_NUMBER(51);				// 0
	r1 = _JC_NEW(env, soot_tagkit_SourcePositionTag);
	_JC_PRIM_FIELD(env, r1, soot_tagkit_PositionTag, startOffset) = i0;
	_JC_PRIM_FIELD(env, r1, soot_tagkit_PositionTag, endOffset) = i1;
	_JC_INVOKE_INTERFACE(env, r0, _JC_JLONG(0xf92b02979eb63079), void, (_jc_env *, struct _jc_object *, struct _jc_object *), r1);
	_JC_LINE_NUMBER(52);				// 1
	return;
}

//
// public static void addPosTag(soot.tagkit.Host, polyglot.util.Position)
//

static _jc_linenum _jc_soot_javaToJimple_Util$linenum_table$addPosTag$547ae130ace9a22e[];

static const unsigned char _jc_soot_javaToJimple_Util$param_ptypes$addPosTag$547ae130ace9a22e[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_soot_javaToJimple_Util$param_types$addPosTag$547ae130ace9a22e[] = {
	&_jc_soot_tagkit_Host$type,
	&_jc_polyglot_util_Position$type
};

_jc_method _jc_soot_javaToJimple_Util$method_info$addPosTag$547ae130ace9a22e = {
	.name=			"addPosTag",
	.signature=		"(Lsoot/tagkit/Host;Lpolyglot/util/Position;)V",
	.class=			&_jc_soot_javaToJimple_Util$type,
	.param_types=		&_jc_soot_javaToJimple_Util$param_types$addPosTag$547ae130ace9a22e,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_soot_javaToJimple_Util$param_ptypes$addPosTag$547ae130ace9a22e,
	.signature_hash=	_JC_JLONG(0x547ae130ace9a22e),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_soot_javaToJimple_Util$method$addPosTag$547ae130ace9a22e,
	.num_parameters=	2,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	6,
	      .table=	_jc_soot_javaToJimple_Util$linenum_table$addPosTag$547ae130ace9a22e
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_javaToJimple_Util, addPosTag$547ae130ace9a22e);

void _JC_JCNI_ATTR
_jc_soot_javaToJimple_Util$method$addPosTag$547ae130ace9a22e(_jc_env *const env, _jc_object *param0, _jc_polyglot_util_Position$object *param1)
{
	jint i0;
	jint i1;
	struct _jc_object *r0;
	struct _jc_polyglot_util_Position$object *r1;
	struct _jc_soot_javaToJimple_jj_DPosition$object *r2;
	struct _jc_java_io_PrintStream$object *r3;
	struct _jc_soot_tagkit_SourcePositionTag$object *r4;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = param0;
	r1 = param1;
	_JC_LINE_NUMBER(26);				// 0
	if (r1 == _JC_NULL)
		goto label1;
	_JC_LINE_NUMBER(27);				// 1
	z0 = _JC_INSTANCEOF(env, r1, &_jc_soot_javaToJimple_jj_DPosition$type);
	if (z0 == 0)
		goto label0;
	_JC_LINE_NUMBER(28);				// 2
	r2 = r1;
	_JC_LINE_NUMBER(33);				// 3
	i0 = _JC_INVOKE_VIRTUAL(env, polyglot_util_Position, column$370206cd3cb25d90, r2);
	i1 = _JC_INVOKE_VIRTUAL(env, soot_javaToJimple_jj_DPosition, endCol$cef98fd6ba768cd6, r2);
	r4 = _JC_NEW(env, soot_tagkit_SourcePositionTag);
	_JC_PRIM_FIELD(env, r4, soot_tagkit_PositionTag, startOffset) = i0;
	_JC_PRIM_FIELD(env, r4, soot_tagkit_PositionTag, endOffset) = i1;
	_JC_INVOKE_INTERFACE(env, r0, _JC_JLONG(0xf92b02979eb63079), void, (_jc_env *, struct _jc_object *, struct _jc_object *), r4);
	goto label1;

label0:
	_JC_LINE_NUMBER(36);				// 4
	r3 = _JC_STATIC_FIELD(env, java_lang_System, out, 0);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, println$f7dbc2aa0f0a9d4f, r3, _JC_STRING(env, "not a dpos"));

label1:
	_JC_LINE_NUMBER(39);				// 5
	return;
}

//
// public static int getModifier(polyglot.types.Flags)
//

static _jc_linenum _jc_soot_javaToJimple_Util$linenum_table$getModifier$ca4fd8a4fb7aa448[];

static const unsigned char _jc_soot_javaToJimple_Util$param_ptypes$getModifier$ca4fd8a4fb7aa448[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT };

static _jc_type *const _jc_soot_javaToJimple_Util$param_types$getModifier$ca4fd8a4fb7aa448[] = {
	&_jc_polyglot_types_Flags$type
};

_jc_method _jc_soot_javaToJimple_Util$method_info$getModifier$ca4fd8a4fb7aa448 = {
	.name=			"getModifier",
	.signature=		"(Lpolyglot/types/Flags;)I",
	.class=			&_jc_soot_javaToJimple_Util$type,
	.param_types=		&_jc_soot_javaToJimple_Util$param_types$getModifier$ca4fd8a4fb7aa448,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_soot_javaToJimple_Util$param_ptypes$getModifier$ca4fd8a4fb7aa448,
	.signature_hash=	_JC_JLONG(0xca4fd8a4fb7aa448),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_soot_javaToJimple_Util$method$getModifier$ca4fd8a4fb7aa448,
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	24,
	      .table=	_jc_soot_javaToJimple_Util$linenum_table$getModifier$ca4fd8a4fb7aa448
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_javaToJimple_Util, getModifier$ca4fd8a4fb7aa448);

jint _JC_JCNI_ATTR
_jc_soot_javaToJimple_Util$method$getModifier$ca4fd8a4fb7aa448(_jc_env *const env, _jc_polyglot_types_Flags$object *param0)
{
	jint i0;
	struct _jc_polyglot_types_Flags$object *r0;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = param0;
	_JC_LINE_NUMBER(168);				// 0
	i0 = 0;
	_JC_LINE_NUMBER(170);				// 1
	z0 = _JC_INVOKE_VIRTUAL(env, polyglot_types_Flags, isPublic$bc4f14961e6f9c56, r0);
	if (z0 == 0)
		goto label0;
	_JC_LINE_NUMBER(171);				// 2
	i0 = 1;

label0:
	_JC_LINE_NUMBER(173);				// 3
	z0 = _JC_INVOKE_VIRTUAL(env, polyglot_types_Flags, isPrivate$bc896a9207a5cba9, r0);
	if (z0 == 0)
		goto label1;
	_JC_LINE_NUMBER(174);				// 4
	i0 = i0 | 2;

label1:
	_JC_LINE_NUMBER(176);				// 5
	z0 = _JC_INVOKE_VIRTUAL(env, polyglot_types_Flags, isProtected$2cd48624411257d2, r0);
	if (z0 == 0)
		goto label2;
	_JC_LINE_NUMBER(177);				// 6
	i0 = i0 | 4;

label2:
	_JC_LINE_NUMBER(179);				// 7
	z0 = _JC_INVOKE_VIRTUAL(env, polyglot_types_Flags, isFinal$dc02e0af6a941bef, r0);
	if (z0 == 0)
		goto label3;
	_JC_LINE_NUMBER(180);				// 8
	i0 = i0 | 16;

label3:
	_JC_LINE_NUMBER(182);				// 9
	z0 = _JC_INVOKE_VIRTUAL(env, polyglot_types_Flags, isStatic$2120409ecc5f4bb3, r0);
	if (z0 == 0)
		goto label4;
	_JC_LINE_NUMBER(183);				// 10
	i0 = i0 | 8;

label4:
	_JC_LINE_NUMBER(185);				// 11
	z0 = _JC_INVOKE_VIRTUAL(env, polyglot_types_Flags, isNative$983fbf9b5ce5d2ad, r0);
	if (z0 == 0)
		goto label5;
	_JC_LINE_NUMBER(186);				// 12
	i0 = i0 | 256;

label5:
	_JC_LINE_NUMBER(188);				// 13
	z0 = _JC_INVOKE_VIRTUAL(env, polyglot_types_Flags, isAbstract$46940a12d66c3893, r0);
	if (z0 == 0)
		goto label6;
	_JC_LINE_NUMBER(189);				// 14
	i0 = i0 | 1024;

label6:
	_JC_LINE_NUMBER(191);				// 15
	z0 = _JC_INVOKE_VIRTUAL(env, polyglot_types_Flags, isVolatile$2595d9c078e327c3, r0);
	if (z0 == 0)
		goto label7;
	_JC_LINE_NUMBER(192);				// 16
	i0 = i0 | 64;

label7:
	_JC_LINE_NUMBER(194);				// 17
	z0 = _JC_INVOKE_VIRTUAL(env, polyglot_types_Flags, isTransient$982b6c1991c06842, r0);
	if (z0 == 0)
		goto label8;
	_JC_LINE_NUMBER(195);				// 18
	i0 = i0 | 128;

label8:
	_JC_LINE_NUMBER(197);				// 19
	z0 = _JC_INVOKE_VIRTUAL(env, polyglot_types_Flags, isSynchronized$29fb971beacfea2d, r0);
	if (z0 == 0)
		goto label9;
	_JC_LINE_NUMBER(198);				// 20
	i0 = i0 | 32;

label9:
	_JC_LINE_NUMBER(200);				// 21
	z0 = _JC_INVOKE_VIRTUAL(env, polyglot_types_Flags, isInterface$6d755c7513b25ee7, r0);
	if (z0 == 0)
		goto label10;
	_JC_LINE_NUMBER(201);				// 22
	i0 = i0 | 512;

label10:
	_JC_LINE_NUMBER(204);				// 23
	return i0;
}

//
// public static soot.Type getSootType(polyglot.types.Type)
//

static _jc_linenum _jc_soot_javaToJimple_Util$linenum_table$getSootType$38f4460e17ab2846[];

static const unsigned char _jc_soot_javaToJimple_Util$param_ptypes$getSootType$38f4460e17ab2846[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_soot_javaToJimple_Util$param_types$getSootType$38f4460e17ab2846[] = {
	&_jc_polyglot_types_Type$type
};

_jc_method _jc_soot_javaToJimple_Util$method_info$getSootType$38f4460e17ab2846 = {
	.name=			"getSootType",
	.signature=		"(Lpolyglot/types/Type;)Lsoot/Type;",
	.class=			&_jc_soot_javaToJimple_Util$type,
	.param_types=		&_jc_soot_javaToJimple_Util$param_types$getSootType$38f4460e17ab2846,
	.return_type=		&_jc_soot_Type$type,
	.param_ptypes=		&_jc_soot_javaToJimple_Util$param_ptypes$getSootType$38f4460e17ab2846,
	.signature_hash=	_JC_JLONG(0x38f4460e17ab2846),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_soot_javaToJimple_Util$method$getSootType$38f4460e17ab2846,
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	40,
	      .table=	_jc_soot_javaToJimple_Util$linenum_table$getSootType$38f4460e17ab2846
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_javaToJimple_Util, getSootType$38f4460e17ab2846);

_jc_soot_Type$object * _JC_JCNI_ATTR
_jc_soot_javaToJimple_Util$method$getSootType$38f4460e17ab2846(_jc_env *const env, _jc_object *param0)
{
	jint i0;
	jint i1;
	jint i2;
	jint i3;
	jint i4;
	jint i5;
	struct _jc_object *r0;
	struct _jc_object *r1;
	struct _jc_soot_G$object *r10;
	struct _jc_soot_BooleanType$object *r11;
	struct _jc_soot_G$object *r12;
	struct _jc_soot_ByteType$object *r13;
	struct _jc_soot_G$object *r14;
	struct _jc_soot_CharType$object *r15;
	struct _jc_soot_G$object *r16;
	struct _jc_soot_DoubleType$object *r17;
	struct _jc_soot_G$object *r18;
	struct _jc_soot_FloatType$object *r19;
	struct _jc_soot_Type$object *r2;
	struct _jc_soot_G$object *r20;
	struct _jc_soot_LongType$object *r21;
	struct _jc_soot_G$object *r22;
	struct _jc_soot_ShortType$object *r23;
	struct _jc_soot_G$object *r24;
	struct _jc_soot_NullType$object *r25;
	struct _jc_soot_G$object *r26;
	struct _jc_soot_VoidType$object *r27;
	struct _jc_soot_G$object *r28;
	struct _jc_java_lang_String$object *r29;
	struct _jc_object *r3;
	struct _jc_java_lang_String$object *r30;
	struct _jc_java_lang_VMThrowable$object *r31;
	struct _jc_soot_RefType$object *r32;
	struct _jc_soot_Scene$object *r33;
	struct _jc_soot_G$object *r34;
	struct _jc_soot_Scene$object *r35;
	struct _jc_soot_G$object *r36;
	struct _jc_soot_util_Numberer$object *r37;
	struct _jc_soot_Scene$object *r38;
	struct _jc_soot_G$object *r39;
	struct _jc_object *r4;
	_jc_char_array *r40;
	struct _jc_soot_Type$object *r41;
	struct _jc_soot_Type$object *r42;
	struct _jc_soot_ArrayType$object *r43;
	struct _jc_soot_ArrayType$object *r44;
	struct _jc_java_lang_RuntimeException$object *r45;
	struct _jc_java_lang_String$object *r46;
	struct _jc_java_lang_VMThrowable$object *r47;
	struct _jc_soot_util_Numberer$object *r48;
	struct _jc_java_lang_String$object *r5;
	struct _jc_soot_Scene$object *r50;
	struct _jc_soot_G$object *r51;
	struct _jc_java_lang_StringBuffer$object *r6;
	struct _jc_java_lang_RuntimeException$object *r7;
	struct _jc_java_lang_String$object *r8;
	struct _jc_soot_IntType$object *r9;
	jboolean z0;
	jboolean z1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = param0;
	_JC_LINE_NUMBER(93);				// 0
	z0 = _JC_INVOKE_INTERFACE(env, r0, _JC_JLONG(0x7106a413920790c), jboolean, (_jc_env *, struct _jc_object *));
	if (z0 == 0)
		goto label0;
	_JC_ACTIVE_USE(env, soot_IntType);
	_JC_ACTIVE_USE(env, soot_G);
	_JC_LINE_NUMBER(94);				// 1
	r10 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r9 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, IntType$fba9c0d0bd3157da, r10);
	r2 = r9;
	goto label22;

label0:
	_JC_LINE_NUMBER(96);				// 2
	z0 = _JC_INVOKE_INTERFACE(env, r0, _JC_JLONG(0x4b2723f8d8db24eb), jboolean, (_jc_env *, struct _jc_object *));
	if (z0 == 0)
		goto label7;
	_JC_LINE_NUMBER(98);				// 3
	r3 = _JC_CAST(env, &_jc_polyglot_types_ArrayType$type, r0);
	r1 = _JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0x724dcfa2ca05fd02), _jc_object *, (_jc_env *, struct _jc_object *));

label1:
	_JC_LINE_NUMBER(99);				// 4
	z0 = _JC_INSTANCEOF(env, r1, &_jc_polyglot_types_ArrayType$type);
	if (z0 == 0)
		goto label2;
	_JC_LINE_NUMBER(100);				// 5
	r3 = r1;
	r1 = _JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0x724dcfa2ca05fd02), _jc_object *, (_jc_env *, struct _jc_object *));
	_JC_PERIODIC_CHECK(env);
	goto label1;

label2:
	_JC_LINE_NUMBER(102);				// 6
	r2 = _JC_INVOKE_STATIC(env, soot_javaToJimple_Util, getSootType$38f4460e17ab2846, 0, r1);
	_JC_LINE_NUMBER(103);				// 7
	r3 = r0;
	i0 = _JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0x55abcb9479d428ef), jint, (_jc_env *, struct _jc_object *));
	_JC_ACTIVE_USE(env, soot_ArrayType);
	_JC_LINE_NUMBER(106);				// 8
	r41 = r2;
	if (i0 != 1)
		goto label3;
	r42 = r2;
	goto label4;

label3:
	i5 = i0 - 1;
	r42 = _JC_INVOKE_STATIC(env, soot_ArrayType, v$829e9246ed532f24, 1, r2, i5);

label4:
	r43 = _JC_INVOKE_VIRTUAL(env, soot_Type, getArrayType$4b65c22ff74f3837, r42);
	if (r43 != _JC_NULL)
		goto label6;
	r43 = _JC_NEW(env, soot_ArrayType);
	r44 = r43;
	_JC_PRIM_FIELD(env, r43, soot_Type, number) = 0;
	_JC_ACTIVE_USE(env, soot_Scene);
	_JC_ACTIVE_USE(env, soot_G);
	r51 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r50 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Scene$3451207662ac1af0, r51);
	r48 = _JC_INVOKE_VIRTUAL(env, soot_Scene, getTypeNumberer$1a245dd462a8adec, r50);
	_JC_INVOKE_VIRTUAL(env, soot_util_Numberer, add$5470e142c10db8b0, r48, r43);
	z1 = _JC_INSTANCEOF(env, r41, &_jc_soot_PrimType$type);
	if (z1 != 0)
		goto label5;
	z1 = _JC_INSTANCEOF(env, r41, &_jc_soot_RefType$type);
	if (z1 != 0)
		goto label5;
	r45 = _JC_NEW(env, java_lang_RuntimeException);
	r46 = _JC_STRING(env, "oops");
	_JC_REF_FIELD(env, r45, java_lang_Throwable, cause) = r45;
	r47 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r45);
	_JC_REF_FIELD(env, r45, java_lang_Throwable, vmState) = r47;
	_JC_REF_FIELD(env, r45, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r45, java_lang_Throwable, detailMessage) = r46;
	_JC_THROW(env, r45);

label5:
	_JC_REF_FIELD(env, r44, soot_ArrayType, baseType) = r41;
	_JC_PRIM_FIELD(env, r44, soot_ArrayType, numDimensions) = i0;
	_JC_INVOKE_VIRTUAL(env, soot_Type, setArrayType$39da61b141afddaa, r42, r43);

label6:
	r2 = r43;
	goto label22;

label7:
	_JC_LINE_NUMBER(108);				// 9
	z0 = _JC_INVOKE_INTERFACE(env, r0, _JC_JLONG(0xbb46b048d513d08c), jboolean, (_jc_env *, struct _jc_object *));
	if (z0 == 0)
		goto label8;
	_JC_ACTIVE_USE(env, soot_BooleanType);
	_JC_ACTIVE_USE(env, soot_G);
	_JC_LINE_NUMBER(109);				// 10
	r12 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r11 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, BooleanType$3bed763c50a785c2, r12);
	r2 = r11;
	goto label22;

label8:
	_JC_LINE_NUMBER(111);				// 11
	z0 = _JC_INVOKE_INTERFACE(env, r0, _JC_JLONG(0x754d9be8bb0e5001), jboolean, (_jc_env *, struct _jc_object *));
	if (z0 == 0)
		goto label9;
	_JC_ACTIVE_USE(env, soot_ByteType);
	_JC_ACTIVE_USE(env, soot_G);
	_JC_LINE_NUMBER(112);				// 12
	r14 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r13 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, ByteType$d401a7fe3c404ceb, r14);
	r2 = r13;
	goto label22;

label9:
	_JC_LINE_NUMBER(114);				// 13
	z0 = _JC_INVOKE_INTERFACE(env, r0, _JC_JLONG(0x218c3fbfc6db86ac), jboolean, (_jc_env *, struct _jc_object *));
	if (z0 == 0)
		goto label10;
	_JC_ACTIVE_USE(env, soot_CharType);
	_JC_ACTIVE_USE(env, soot_G);
	_JC_LINE_NUMBER(115);				// 14
	r16 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r15 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, CharType$dadf89737f75904b, r16);
	r2 = r15;
	goto label22;

label10:
	_JC_LINE_NUMBER(117);				// 15
	z0 = _JC_INVOKE_INTERFACE(env, r0, _JC_JLONG(0xd573a964d71ecd90), jboolean, (_jc_env *, struct _jc_object *));
	if (z0 == 0)
		goto label11;
	_JC_ACTIVE_USE(env, soot_DoubleType);
	_JC_ACTIVE_USE(env, soot_G);
	_JC_LINE_NUMBER(118);				// 16
	r18 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r17 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, DoubleType$d70415f0ba52f1d2, r18);
	r2 = r17;
	goto label22;

label11:
	_JC_LINE_NUMBER(120);				// 17
	z0 = _JC_INVOKE_INTERFACE(env, r0, _JC_JLONG(0xc1a4fdca9786bcf1), jboolean, (_jc_env *, struct _jc_object *));
	if (z0 == 0)
		goto label12;
	_JC_ACTIVE_USE(env, soot_FloatType);
	_JC_ACTIVE_USE(env, soot_G);
	_JC_LINE_NUMBER(121);				// 18
	r20 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r19 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, FloatType$0d674e2782ceaa03, r20);
	r2 = r19;
	goto label22;

label12:
	_JC_LINE_NUMBER(123);				// 19
	z0 = _JC_INVOKE_INTERFACE(env, r0, _JC_JLONG(0xd5b711947d97b3de), jboolean, (_jc_env *, struct _jc_object *));
	if (z0 == 0)
		goto label13;
	_JC_ACTIVE_USE(env, soot_LongType);
	_JC_ACTIVE_USE(env, soot_G);
	_JC_LINE_NUMBER(124);				// 20
	r22 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r21 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, LongType$9480a47b3623782e, r22);
	r2 = r21;
	goto label22;

label13:
	_JC_LINE_NUMBER(126);				// 21
	z0 = _JC_INVOKE_INTERFACE(env, r0, _JC_JLONG(0xf32aa6645ce5d5c3), jboolean, (_jc_env *, struct _jc_object *));
	if (z0 == 0)
		goto label14;
	_JC_ACTIVE_USE(env, soot_ShortType);
	_JC_ACTIVE_USE(env, soot_G);
	_JC_LINE_NUMBER(127);				// 22
	r24 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r23 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, ShortType$b41fcd2b331e1ff1, r24);
	r2 = r23;
	goto label22;

label14:
	_JC_LINE_NUMBER(129);				// 23
	z0 = _JC_INVOKE_INTERFACE(env, r0, _JC_JLONG(0x2aac8ad2f249e371), jboolean, (_jc_env *, struct _jc_object *));
	if (z0 == 0)
		goto label15;
	_JC_ACTIVE_USE(env, soot_NullType);
	_JC_ACTIVE_USE(env, soot_G);
	_JC_LINE_NUMBER(130);				// 24
	r26 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r25 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, NullType$3cc38aec29af1de4, r26);
	r2 = r25;
	goto label22;

label15:
	_JC_LINE_NUMBER(132);				// 25
	z0 = _JC_INVOKE_INTERFACE(env, r0, _JC_JLONG(0x4cd81185be491028), jboolean, (_jc_env *, struct _jc_object *));
	if (z0 == 0)
		goto label16;
	_JC_ACTIVE_USE(env, soot_VoidType);
	_JC_ACTIVE_USE(env, soot_G);
	_JC_LINE_NUMBER(133);				// 26
	r28 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r27 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, VoidType$21c085ef23cd9c2b, r28);
	r2 = r27;
	goto label22;

label16:
	_JC_LINE_NUMBER(135);				// 27
	z0 = _JC_INVOKE_INTERFACE(env, r0, _JC_JLONG(0x5de673498ae1923d), jboolean, (_jc_env *, struct _jc_object *));
	if (z0 == 0)
		goto label21;
	_JC_LINE_NUMBER(136);				// 28
	r4 = _JC_CAST(env, &_jc_polyglot_types_ClassType$type, r0);
	_JC_LINE_NUMBER(138);				// 29
	z0 = _JC_INVOKE_INTERFACE(env, r4, _JC_JLONG(0x4f9e4620bc3c97f5), jboolean, (_jc_env *, struct _jc_object *));
	if (z0 == 0)
		goto label18;
	_JC_LINE_NUMBER(139);				// 30
	z0 = _JC_INVOKE_INTERFACE(env, r4, _JC_JLONG(0xc1fe7d2ef959558b), jboolean, (_jc_env *, struct _jc_object *));
	if (z0 == 0)
		goto label17;

label17:
	_JC_LINE_NUMBER(141);				// 31
	r5 = _JC_INVOKE_INTERFACE(env, r4, _JC_JLONG(0x7479c1d5dda35b23), _jc_object *, (_jc_env *, struct _jc_object *));
	_JC_LINE_NUMBER(142);				// 32
	r6 = _JC_NEW(env, java_lang_StringBuffer);
	i4 = _JC_PRIM_FIELD(env, r5, java_lang_String, count);
	_JC_PRIM_FIELD(env, r6, java_lang_StringBuffer, count) = i4;
	i4 = _JC_PRIM_FIELD(env, r6, java_lang_StringBuffer, count);
	i4 = i4 + 16;
	r40 = _JC_NEW_PRIM_ARRAY(env, char, 1, i4);
	_JC_REF_FIELD(env, r6, java_lang_StringBuffer, value) = r40;
	i4 = _JC_PRIM_FIELD(env, r6, java_lang_StringBuffer, count);
	r40 = _JC_REF_FIELD(env, r6, java_lang_StringBuffer, value);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, getChars$c684dea7317ff063, 0, r5, 0, i4, r40, 0);
	r30 = _JC_STRING(env, ".");
	i2 = _JC_PRIM_FIELD(env, r5, java_lang_String, count);
	i3 = _JC_PRIM_FIELD(env, r30, java_lang_String, count);
	i3 = i2 - i3;
	i3 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, lastIndexOf$70e02b478c559157, 0, r5, r30, i3);
	_JC_LINE_NUMBER(144);				// 33
	if (i3 == -1)
		goto label19;
	_JC_LINE_NUMBER(145);				// 34
	i1 = i3 + 1;
	_JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, replace$e5d439bc3281103e, 0, r6, i3, i1, _JC_STRING(env, "$"));
	r29 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r29, r6);
	r5 = r29;
	_JC_LINE_NUMBER(146);				// 35
	goto label19;

label18:
	_JC_LINE_NUMBER(151);				// 36
	r5 = _JC_INVOKE_INTERFACE(env, r4, _JC_JLONG(0x7479c1d5dda35b23), _jc_object *, (_jc_env *, struct _jc_object *));

label19:
	_JC_ACTIVE_USE(env, soot_RefType);
	_JC_ACTIVE_USE(env, soot_Scene);
	_JC_ACTIVE_USE(env, soot_G);
	r34 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r33 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Scene$3451207662ac1af0, r34);
	r32 = _JC_INVOKE_VIRTUAL(env, soot_Scene, getRefType$edcdead019670553, r33, r5);
	if (r32 != _JC_NULL)
		goto label20;
	r32 = _JC_NEW(env, soot_RefType);
	_JC_PRIM_FIELD(env, r32, soot_Type, number) = 0;
	r39 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r38 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Scene$3451207662ac1af0, r39);
	r37 = _JC_INVOKE_VIRTUAL(env, soot_Scene, getTypeNumberer$1a245dd462a8adec, r38);
	_JC_INVOKE_VIRTUAL(env, soot_util_Numberer, add$5470e142c10db8b0, r37, r32);
	_JC_REF_FIELD(env, r32, soot_RefType, className) = r5;
	r36 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r35 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Scene$3451207662ac1af0, r36);
	_JC_INVOKE_VIRTUAL(env, soot_Scene, addRefType$a902a59089ea90da, r35, r32);

label20:
	r2 = r32;
	_JC_LINE_NUMBER(154);				// 37
	goto label22;

label21:
	_JC_LINE_NUMBER(157);				// 38
	r7 = _JC_NEW(env, java_lang_RuntimeException);
	r8 = _JC_STRING(env, "Unknown Type");
	_JC_REF_FIELD(env, r7, java_lang_Throwable, cause) = r7;
	r31 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r7);
	_JC_REF_FIELD(env, r7, java_lang_Throwable, vmState) = r31;
	_JC_REF_FIELD(env, r7, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r7, java_lang_Throwable, detailMessage) = r8;
	_JC_THROW(env, r7);

label22:
	_JC_LINE_NUMBER(159);				// 39
	return r2;
}

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// public void <init>()
//

static _jc_linenum _jc_soot_javaToJimple_Util$linenum_table$_init$52f4ad9f2989aeee[];

static const unsigned char _jc_soot_javaToJimple_Util$param_ptypes$_init$52f4ad9f2989aeee[] = { 
_JC_TYPE_VOID };

_jc_method _jc_soot_javaToJimple_Util$method_info$_init$52f4ad9f2989aeee = {
	.name=			"<init>",
	.signature=		"()V",
	.class=			&_jc_soot_javaToJimple_Util$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_soot_javaToJimple_Util$param_ptypes$_init$52f4ad9f2989aeee,
	.signature_hash=	_JC_JLONG(0x52f4ad9f2989aeee),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_javaToJimple_Util$method$_init$52f4ad9f2989aeee,
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_soot_javaToJimple_Util$linenum_table$_init$52f4ad9f2989aeee
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_javaToJimple_Util, _init$52f4ad9f2989aeee);

void _JC_JCNI_ATTR
_jc_soot_javaToJimple_Util$method$_init$52f4ad9f2989aeee(_jc_env *const env, _jc_soot_javaToJimple_Util$object *this)
{
	struct _jc_soot_javaToJimple_Util$object *r0;

	r0 = this;
	_JC_LINE_NUMBER(3);				// 0
	return;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_soot_javaToJimple_Util$methods[] = {
	&_jc_soot_javaToJimple_Util$method_info$_init$52f4ad9f2989aeee,
	&_jc_soot_javaToJimple_Util$method_info$addLineTag$be7e39b51a0702a2,
	&_jc_soot_javaToJimple_Util$method_info$addLineTag$1708d233fe0fbae7,
	&_jc_soot_javaToJimple_Util$method_info$addLnPosTags$d688fb6975e31f57,
	&_jc_soot_javaToJimple_Util$method_info$addLnPosTags$dd6f10fd39b4041c,
	&_jc_soot_javaToJimple_Util$method_info$addMethodLineTag$4e40b7597398e67c,
	&_jc_soot_javaToJimple_Util$method_info$addMethodPosTag$f7344d9686748d51,
	&_jc_soot_javaToJimple_Util$method_info$addPosTag$326ceab370f8ba8e,
	&_jc_soot_javaToJimple_Util$method_info$addPosTag$547ae130ace9a22e,
	&_jc_soot_javaToJimple_Util$method_info$getModifier$ca4fd8a4fb7aa448,
	&_jc_soot_javaToJimple_Util$method_info$getSootType$38f4460e17ab2846
};

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_soot_javaToJimple_Util$instanceof_hash_bucket_43[] = {
	&_jc_soot_javaToJimple_Util$type,
	_JC_NULL
};
static _jc_type *const _jc_soot_javaToJimple_Util$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_soot_javaToJimple_Util$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[43]=	_jc_soot_javaToJimple_Util$instanceof_hash_bucket_43,
	[101]=	_jc_soot_javaToJimple_Util$instanceof_hash_bucket_101
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_soot_javaToJimple_Util$class_depends[] = {
	{ "java/io/PrintStream",	_JC_JLONG(0x99a46305ebacacb5) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/RuntimeException",	_JC_JLONG(0x4f5534a987354d1d) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/StringBuffer",	_JC_JLONG(0x94d357637b968dda) },
	{ "java/lang/System",	_JC_JLONG(0x53cc8e2333795f04) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "polyglot/ast/Node",	_JC_JLONG(0x1c402b4f9747e08) },
	{ "polyglot/types/ArrayType",	_JC_JLONG(0x412788f7d4254477) },
	{ "polyglot/types/ClassType",	_JC_JLONG(0xb38560af658974f8) },
	{ "polyglot/types/Flags",	_JC_JLONG(0x821eb65d8f2f30f6) },
	{ "polyglot/types/Type",	_JC_JLONG(0x6596051546781098) },
	{ "polyglot/util/Position",	_JC_JLONG(0x32c9a088c5dac046) },
	{ "soot/ArrayType",	_JC_JLONG(0x13e7935c8aaa97c9) },
	{ "soot/BooleanType",	_JC_JLONG(0x3dae18ed334ad777) },
	{ "soot/ByteType",	_JC_JLONG(0x2c7486b453945971) },
	{ "soot/CharType",	_JC_JLONG(0x804042b6713f0ed4) },
	{ "soot/DoubleType",	_JC_JLONG(0xf1367e60bd9c6d0a) },
	{ "soot/FloatType",	_JC_JLONG(0xee3bc988001dd8c6) },
	{ "soot/G",	_JC_JLONG(0xb6d33af8f84fdbc4) },
	{ "soot/IntType",	_JC_JLONG(0xfb57d8c2db7c3ab3) },
	{ "soot/LongType",	_JC_JLONG(0xaa1b631a0256e062) },
	{ "soot/NullType",	_JC_JLONG(0xf0a1b2286e398082) },
	{ "soot/PrimType",	_JC_JLONG(0xd6846479002a370b) },
	{ "soot/RefLikeType",	_JC_JLONG(0xfdbc627922b0ba72) },
	{ "soot/RefType",	_JC_JLONG(0x2887a1b57cecfb7b) },
	{ "soot/Scene",	_JC_JLONG(0x7120c8047949f8c0) },
	{ "soot/ShortType",	_JC_JLONG(0x9e6e4afb464dbc7) },
	{ "soot/Singletons",	_JC_JLONG(0x6ac5bee50bbabb71) },
	{ "soot/Type",	_JC_JLONG(0xf801e5c664424a1) },
	{ "soot/VoidType",	_JC_JLONG(0xfddfad630263b66b) },
	{ "soot/javaToJimple/jj/DPosition",	_JC_JLONG(0xe0215bb69aa8dac3) },
	{ "soot/options/Options",	_JC_JLONG(0xc5a5a246a3f59476) },
	{ "soot/tagkit/Host",	_JC_JLONG(0x81a85e00bf60ba4c) },
	{ "soot/tagkit/PositionTag",	_JC_JLONG(0x4f112a0e13b029d9) },
	{ "soot/tagkit/SourceLineNumberTag",	_JC_JLONG(0x801ded4adf91a761) },
	{ "soot/tagkit/SourceLnPosTag",	_JC_JLONG(0xb45e923b919717d3) },
	{ "soot/tagkit/SourcePositionTag",	_JC_JLONG(0x50f5695cb4eac404) },
	{ "soot/util/Numberer",	_JC_JLONG(0xf5f751433138bc27) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_soot_javaToJimple_Util$vtype _jc_soot_javaToJimple_Util$type = {
    .type= {
	.name=			"soot/javaToJimple/Util",
	.superclass=		&_jc_java_lang_Object$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		11,
		.hash=			_JC_JLONG(0xfb501b85de60e3ab),
		.source_file=		"Util.java",
		.instance_size=		sizeof(_jc_soot_javaToJimple_Util$refs) + sizeof(_jc_soot_javaToJimple_Util$object),
		.num_virtual_refs=	0,
		.num_methods=		sizeof(_jc_soot_javaToJimple_Util$methods) / sizeof(*_jc_soot_javaToJimple_Util$methods),
		.methods=		_jc_soot_javaToJimple_Util$methods,
		.instanceof_hash_table=	_jc_soot_javaToJimple_Util$instanceof_hash_table,
		.num_class_depends=		sizeof(_jc_soot_javaToJimple_Util$class_depends) / sizeof(*_jc_soot_javaToJimple_Util$class_depends),
		.class_depends=		_jc_soot_javaToJimple_Util$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.soot_javaToJimple_Util= {
	},
    }
};

