// public class soot.jimple.toolkits.callgraph.ReachableMethods

// class file dependencies
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 8ea716c64b77f8eb java_util_AbstractCollection
// @dep_class f5238436362828db java_util_AbstractList
// @dep_class ca427569b5b2f804 java_util_AbstractSet
// @dep_class 58038509830ef3f4 java_util_ArrayList
// @dep_class eae4d0c0e8eb63da java_util_Collection
// @dep_class d7cd853200c3e71f java_util_HashMap
// @dep_class 3c285c721478414d java_util_HashSet
// @dep_class be56ff673eefd9d2 java_util_Iterator
// @dep_class 9ee0d92ce1525a4d java_util_List
// @dep_class 617ac82c0bec2dff java_util_Set
// @dep_class 1dd6244faf0063d9 soot_jimple_toolkits_callgraph_CallGraph
// @dep_class ce9c62c38d34205d soot_jimple_toolkits_callgraph_Edge
// @dep_class aca1790a167ce631 soot_jimple_toolkits_callgraph_Filter
// @dep_class e11397553ff352db soot_jimple_toolkits_callgraph_MethodOrMethodContext
// @dep_class 5f8ac62e0dc34c07 soot_jimple_toolkits_callgraph_ReachableMethods
// @dep_class 1361f0b081a2224 soot_jimple_toolkits_callgraph_Targets
// @dep_class e0a17cfc325c0311 soot_util_queue_ChunkedQueue
// @dep_class dfc99826de09e7ed soot_util_queue_QueueReader

// header file dependencies
// @dep_header java_lang_Class
// @dep_header java_lang_String
// @dep_header java_util_ArrayList
// @dep_header java_util_Collection
// @dep_header java_util_HashMap
// @dep_header java_util_HashSet
// @dep_header java_util_Iterator
// @dep_header java_util_List
// @dep_header java_util_Set
// @dep_header soot_jimple_toolkits_callgraph_CallGraph
// @dep_header soot_jimple_toolkits_callgraph_Edge
// @dep_header soot_jimple_toolkits_callgraph_Filter
// @dep_header soot_jimple_toolkits_callgraph_MethodOrMethodContext
// @dep_header soot_jimple_toolkits_callgraph_ReachableMethods
// @dep_header soot_jimple_toolkits_callgraph_Targets
// @dep_header soot_util_queue_ChunkedQueue
// @dep_header soot_util_queue_QueueReader

#include "jc_defs.h"

#include "java/lang/Class.h"
#include "java/lang/String.h"
#include "java/util/ArrayList.h"
#include "java/util/Collection.h"
#include "java/util/HashMap.h"
#include "java/util/HashSet.h"
#include "java/util/Iterator.h"
#include "java/util/List.h"
#include "java/util/Set.h"
#include "soot/jimple/toolkits/callgraph/CallGraph.h"
#include "soot/jimple/toolkits/callgraph/Edge.h"
#include "soot/jimple/toolkits/callgraph/Filter.h"
#include "soot/jimple/toolkits/callgraph/MethodOrMethodContext.h"
#include "soot/jimple/toolkits/callgraph/ReachableMethods.h"
#include "soot/jimple/toolkits/callgraph/Targets.h"
#include "soot/util/queue/ChunkedQueue.h"
#include "soot/util/queue/QueueReader.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// private soot.jimple.toolkits.callgraph.CallGraph cg
static _jc_field _jc_soot_jimple_toolkits_callgraph_ReachableMethods$field_info$cg = {
	.name=		"cg",
	.signature=	"Lsoot/jimple/toolkits/callgraph/CallGraph;",
	.class=		&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$type,
	.type=		&_jc_soot_jimple_toolkits_callgraph_CallGraph$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_soot_jimple_toolkits_callgraph_ReachableMethods$object, refs[-1].soot_jimple_toolkits_callgraph_ReachableMethods.cg),
};

// private java.util.List entryPoints
static _jc_field _jc_soot_jimple_toolkits_callgraph_ReachableMethods$field_info$entryPoints = {
	.name=		"entryPoints",
	.signature=	"Ljava/util/List;",
	.class=		&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$type,
	.type=		&_jc_java_util_List$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_soot_jimple_toolkits_callgraph_ReachableMethods$object, refs[-1].soot_jimple_toolkits_callgraph_ReachableMethods.entryPoints),
};

// private java.util.Iterator edgeSource
static _jc_field _jc_soot_jimple_toolkits_callgraph_ReachableMethods$field_info$edgeSource = {
	.name=		"edgeSource",
	.signature=	"Ljava/util/Iterator;",
	.class=		&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$type,
	.type=		&_jc_java_util_Iterator$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_soot_jimple_toolkits_callgraph_ReachableMethods$object, refs[-1].soot_jimple_toolkits_callgraph_ReachableMethods.edgeSource),
};

// private soot.util.queue.ChunkedQueue reachables
static _jc_field _jc_soot_jimple_toolkits_callgraph_ReachableMethods$field_info$reachables = {
	.name=		"reachables",
	.signature=	"Lsoot/util/queue/ChunkedQueue;",
	.class=		&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$type,
	.type=		&_jc_soot_util_queue_ChunkedQueue$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_soot_jimple_toolkits_callgraph_ReachableMethods$object, refs[-1].soot_jimple_toolkits_callgraph_ReachableMethods.reachables),
};

// private java.util.Set set
static _jc_field _jc_soot_jimple_toolkits_callgraph_ReachableMethods$field_info$set = {
	.name=		"set",
	.signature=	"Ljava/util/Set;",
	.class=		&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$type,
	.type=		&_jc_java_util_Set$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_soot_jimple_toolkits_callgraph_ReachableMethods$object, refs[-1].soot_jimple_toolkits_callgraph_ReachableMethods.set),
};

// private soot.util.queue.QueueReader unprocessedMethods
static _jc_field _jc_soot_jimple_toolkits_callgraph_ReachableMethods$field_info$unprocessedMethods = {
	.name=		"unprocessedMethods",
	.signature=	"Lsoot/util/queue/QueueReader;",
	.class=		&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$type,
	.type=		&_jc_soot_util_queue_QueueReader$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_soot_jimple_toolkits_callgraph_ReachableMethods$object, refs[-1].soot_jimple_toolkits_callgraph_ReachableMethods.unprocessedMethods),
};

// private soot.util.queue.QueueReader allReachables
static _jc_field _jc_soot_jimple_toolkits_callgraph_ReachableMethods$field_info$allReachables = {
	.name=		"allReachables",
	.signature=	"Lsoot/util/queue/QueueReader;",
	.class=		&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$type,
	.type=		&_jc_soot_util_queue_QueueReader$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_soot_jimple_toolkits_callgraph_ReachableMethods$object, refs[-1].soot_jimple_toolkits_callgraph_ReachableMethods.allReachables),
};

// private soot.jimple.toolkits.callgraph.Filter filter
static _jc_field _jc_soot_jimple_toolkits_callgraph_ReachableMethods$field_info$filter = {
	.name=		"filter",
	.signature=	"Lsoot/jimple/toolkits/callgraph/Filter;",
	.class=		&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$type,
	.type=		&_jc_soot_jimple_toolkits_callgraph_Filter$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_soot_jimple_toolkits_callgraph_ReachableMethods$object, refs[-1].soot_jimple_toolkits_callgraph_ReachableMethods.filter),
};

// Fields
static _jc_field *const _jc_soot_jimple_toolkits_callgraph_ReachableMethods$fields[] = {
	&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$field_info$allReachables,
	&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$field_info$cg,
	&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$field_info$edgeSource,
	&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$field_info$entryPoints,
	&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$field_info$filter,
	&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$field_info$reachables,
	&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$field_info$set,
	&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$field_info$unprocessedMethods
};

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// public void <init>(soot.jimple.toolkits.callgraph.CallGraph, java.util.Collection)
//

static _jc_linenum _jc_soot_jimple_toolkits_callgraph_ReachableMethods$linenum_table$_init$1bd07d3affa43bdd[];

static const unsigned char _jc_soot_jimple_toolkits_callgraph_ReachableMethods$param_ptypes$_init$1bd07d3affa43bdd[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_soot_jimple_toolkits_callgraph_ReachableMethods$param_types$_init$1bd07d3affa43bdd[] = {
	&_jc_soot_jimple_toolkits_callgraph_CallGraph$type,
	&_jc_java_util_Collection$type
};

_jc_method _jc_soot_jimple_toolkits_callgraph_ReachableMethods$method_info$_init$1bd07d3affa43bdd = {
	.name=			"<init>",
	.signature=		"(Lsoot/jimple/toolkits/callgraph/CallGraph;Ljava/util/Collection;)V",
	.class=			&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$type,
	.param_types=		&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$param_types$_init$1bd07d3affa43bdd,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$param_ptypes$_init$1bd07d3affa43bdd,
	.signature_hash=	_JC_JLONG(0x1bd07d3affa43bdd),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$method$_init$1bd07d3affa43bdd,
	.num_parameters=	2,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_soot_jimple_toolkits_callgraph_ReachableMethods$linenum_table$_init$1bd07d3affa43bdd
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_jimple_toolkits_callgraph_ReachableMethods, _init$1bd07d3affa43bdd);

void _JC_JCNI_ATTR
_jc_soot_jimple_toolkits_callgraph_ReachableMethods$method$_init$1bd07d3affa43bdd(_jc_env *const env, _jc_soot_jimple_toolkits_callgraph_ReachableMethods$object *this, _jc_soot_jimple_toolkits_callgraph_CallGraph$object *param0, _jc_object *param1)
{
	struct _jc_soot_jimple_toolkits_callgraph_ReachableMethods$object *r0;
	struct _jc_soot_jimple_toolkits_callgraph_CallGraph$object *r1;
	struct _jc_object *r2;
	struct _jc_object *r3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_LINE_NUMBER(53);				// 0
	r3 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0x3cc91493d50f531c), _jc_object *, (_jc_env *, struct _jc_object *));
	_JC_INVOKE_NONVIRTUAL(env, soot_jimple_toolkits_callgraph_ReachableMethods, _init$29022616f93f1ef6, 0, r0, r1, r3, _JC_NULL);
	_JC_LINE_NUMBER(54);				// 1
	return;
}

//
// public void <init>(soot.jimple.toolkits.callgraph.CallGraph, java.util.Iterator)
//

static _jc_linenum _jc_soot_jimple_toolkits_callgraph_ReachableMethods$linenum_table$_init$47d5d1c657e8bbbb[];

static const unsigned char _jc_soot_jimple_toolkits_callgraph_ReachableMethods$param_ptypes$_init$47d5d1c657e8bbbb[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_soot_jimple_toolkits_callgraph_ReachableMethods$param_types$_init$47d5d1c657e8bbbb[] = {
	&_jc_soot_jimple_toolkits_callgraph_CallGraph$type,
	&_jc_java_util_Iterator$type
};

_jc_method _jc_soot_jimple_toolkits_callgraph_ReachableMethods$method_info$_init$47d5d1c657e8bbbb = {
	.name=			"<init>",
	.signature=		"(Lsoot/jimple/toolkits/callgraph/CallGraph;Ljava/util/Iterator;)V",
	.class=			&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$type,
	.param_types=		&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$param_types$_init$47d5d1c657e8bbbb,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$param_ptypes$_init$47d5d1c657e8bbbb,
	.signature_hash=	_JC_JLONG(0x47d5d1c657e8bbbb),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$method$_init$47d5d1c657e8bbbb,
	.num_parameters=	2,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_soot_jimple_toolkits_callgraph_ReachableMethods$linenum_table$_init$47d5d1c657e8bbbb
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_jimple_toolkits_callgraph_ReachableMethods, _init$47d5d1c657e8bbbb);

void _JC_JCNI_ATTR
_jc_soot_jimple_toolkits_callgraph_ReachableMethods$method$_init$47d5d1c657e8bbbb(_jc_env *const env, _jc_soot_jimple_toolkits_callgraph_ReachableMethods$object *this, _jc_soot_jimple_toolkits_callgraph_CallGraph$object *param0, _jc_object *param1)
{
	struct _jc_soot_jimple_toolkits_callgraph_ReachableMethods$object *r0;
	struct _jc_soot_jimple_toolkits_callgraph_CallGraph$object *r1;
	struct _jc_object *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_LINE_NUMBER(42);				// 0
	_JC_INVOKE_NONVIRTUAL(env, soot_jimple_toolkits_callgraph_ReachableMethods, _init$29022616f93f1ef6, 0, r0, r1, r2, _JC_NULL);
	_JC_LINE_NUMBER(43);				// 1
	return;
}

//
// public void <init>(soot.jimple.toolkits.callgraph.CallGraph, java.util.Iterator, soot.jimple.toolkits.callgraph.Filter)
//

static _jc_linenum _jc_soot_jimple_toolkits_callgraph_ReachableMethods$linenum_table$_init$29022616f93f1ef6[];

static const unsigned char _jc_soot_jimple_toolkits_callgraph_ReachableMethods$param_ptypes$_init$29022616f93f1ef6[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_soot_jimple_toolkits_callgraph_ReachableMethods$param_types$_init$29022616f93f1ef6[] = {
	&_jc_soot_jimple_toolkits_callgraph_CallGraph$type,
	&_jc_java_util_Iterator$type,
	&_jc_soot_jimple_toolkits_callgraph_Filter$type
};

_jc_method _jc_soot_jimple_toolkits_callgraph_ReachableMethods$method_info$_init$29022616f93f1ef6 = {
	.name=			"<init>",
	.signature=		"(Lsoot/jimple/toolkits/callgraph/CallGraph;Ljava/util/Iterator;Lsoot/jimple/toolkits/callgraph/Filter;)V",
	.class=			&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$type,
	.param_types=		&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$param_types$_init$29022616f93f1ef6,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$param_ptypes$_init$29022616f93f1ef6,
	.signature_hash=	_JC_JLONG(0x29022616f93f1ef6),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$method$_init$29022616f93f1ef6,
	.num_parameters=	3,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	10,
	      .table=	_jc_soot_jimple_toolkits_callgraph_ReachableMethods$linenum_table$_init$29022616f93f1ef6
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_jimple_toolkits_callgraph_ReachableMethods, _init$29022616f93f1ef6);

void _JC_JCNI_ATTR
_jc_soot_jimple_toolkits_callgraph_ReachableMethods$method$_init$29022616f93f1ef6(_jc_env *const env, _jc_soot_jimple_toolkits_callgraph_ReachableMethods$object *this, _jc_soot_jimple_toolkits_callgraph_CallGraph$object *param0, _jc_object *param1, _jc_soot_jimple_toolkits_callgraph_Filter$object *param2)
{
	jint i0;
	jint i1;
	struct _jc_soot_jimple_toolkits_callgraph_ReachableMethods$object *r0;
	struct _jc_soot_jimple_toolkits_callgraph_CallGraph$object *r1;
	struct _jc_soot_util_queue_QueueReader$object *r10;
	_jc_object_array *r11;
	struct _jc_soot_util_queue_QueueReader$object *r12;
	_jc_object_array *r13;
	struct _jc_object *r14;
	struct _jc_java_lang_Object$object *r15;
	struct _jc_object *r16;
	struct _jc_object *r17;
	struct _jc_soot_util_queue_ChunkedQueue$object *r18;
	_jc_object_array *r19;
	struct _jc_object *r2;
	struct _jc_soot_jimple_toolkits_callgraph_Filter$object *r3;
	struct _jc_java_util_ArrayList$object *r4;
	struct _jc_soot_util_queue_ChunkedQueue$object *r5;
	struct _jc_java_util_HashSet$object *r6;
	struct _jc_soot_util_queue_QueueReader$object *r7;
	struct _jc_java_util_HashMap$object *r8;
	_jc_object_array *r9;
	jboolean z0;
	jboolean z1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	r3 = param2;
	_JC_LINE_NUMBER(34);				// 0
	r4 = _JC_NEW(env, java_util_ArrayList);
	r19 = _JC_NEW_REF_ARRAY(env, java_lang_Object, 1, 16);
	_JC_REF_FIELD(env, r4, java_util_ArrayList, data) = r19;
	_JC_REF_FIELD(env, r0, soot_jimple_toolkits_callgraph_ReachableMethods, entryPoints) = r4;
	_JC_LINE_NUMBER(36);				// 1
	r5 = _JC_NEW(env, soot_util_queue_ChunkedQueue);
	r9 = _JC_NEW_REF_ARRAY(env, java_lang_Object, 1, 60);
	_JC_REF_FIELD(env, r5, soot_util_queue_ChunkedQueue, q) = r9;
	_JC_PRIM_FIELD(env, r5, soot_util_queue_ChunkedQueue, index) = 0;
	_JC_REF_FIELD(env, r0, soot_jimple_toolkits_callgraph_ReachableMethods, reachables) = r5;
	_JC_LINE_NUMBER(37);				// 2
	r6 = _JC_NEW(env, java_util_HashSet);
	r8 = _JC_NEW(env, java_util_HashMap);
	_JC_INVOKE_NONVIRTUAL(env, java_util_HashMap, _init$7cb044ce4fb0ada8, 0, r8, 11, _JC_FCONST(0x3f, 0x40, 0x0, 0x0));
	_JC_REF_FIELD(env, r6, java_util_HashSet, map) = r8;
	_JC_REF_FIELD(env, r0, soot_jimple_toolkits_callgraph_ReachableMethods, set) = r6;
	_JC_LINE_NUMBER(39);				// 3
	r5 = _JC_REF_FIELD(env, r0, soot_jimple_toolkits_callgraph_ReachableMethods, reachables);
	_JC_EXPLICIT_NULL_CHECK(env, r5);
	r10 = _JC_NEW(env, soot_util_queue_QueueReader);
	r11 = _JC_REF_FIELD(env, r5, soot_util_queue_ChunkedQueue, q);
	i0 = _JC_PRIM_FIELD(env, r5, soot_util_queue_ChunkedQueue, index);
	_JC_REF_FIELD(env, r10, soot_util_queue_QueueReader, q) = r11;
	_JC_PRIM_FIELD(env, r10, soot_util_queue_QueueReader, index) = i0;
	_JC_REF_FIELD(env, r0, soot_jimple_toolkits_callgraph_ReachableMethods, allReachables) = r10;
	_JC_LINE_NUMBER(45);				// 4
	_JC_REF_FIELD(env, r0, soot_jimple_toolkits_callgraph_ReachableMethods, filter) = r3;
	_JC_LINE_NUMBER(46);				// 5
	_JC_REF_FIELD(env, r0, soot_jimple_toolkits_callgraph_ReachableMethods, cg) = r1;
	r14 = r2;

label0:
	z0 = _JC_INVOKE_INTERFACE(env, r14, _JC_JLONG(0xfb0bd5e38c59ddcd), jboolean, (_jc_env *, struct _jc_object *));
	if (z0 == 0)
		goto label1;
	r15 = _JC_INVOKE_INTERFACE(env, r14, _JC_JLONG(0x5874f79a1cf66ea), _jc_object *, (_jc_env *, struct _jc_object *));
	r16 = _JC_CAST(env, &_jc_soot_jimple_toolkits_callgraph_MethodOrMethodContext$type, r15);
	r17 = _JC_REF_FIELD(env, r0, soot_jimple_toolkits_callgraph_ReachableMethods, set);
	z1 = _JC_INVOKE_INTERFACE(env, r17, _JC_JLONG(0x831f06ee5f59c0cc), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r16);
	if (z1 == 0) {
		_JC_PERIODIC_CHECK(env);
		goto label0;
	}
	r18 = _JC_REF_FIELD(env, r0, soot_jimple_toolkits_callgraph_ReachableMethods, reachables);
	_JC_INVOKE_NONVIRTUAL(env, soot_util_queue_ChunkedQueue, add$75d6bd5079bf5583, 1, r18, r16);
	_JC_PERIODIC_CHECK(env);
	goto label0;

label1:
	_JC_LINE_NUMBER(48);				// 6
	r5 = _JC_REF_FIELD(env, r0, soot_jimple_toolkits_callgraph_ReachableMethods, reachables);
	_JC_EXPLICIT_NULL_CHECK(env, r5);
	r12 = _JC_NEW(env, soot_util_queue_QueueReader);
	r13 = _JC_REF_FIELD(env, r5, soot_util_queue_ChunkedQueue, q);
	i1 = _JC_PRIM_FIELD(env, r5, soot_util_queue_ChunkedQueue, index);
	_JC_REF_FIELD(env, r12, soot_util_queue_QueueReader, q) = r13;
	_JC_PRIM_FIELD(env, r12, soot_util_queue_QueueReader, index) = i1;
	_JC_REF_FIELD(env, r0, soot_jimple_toolkits_callgraph_ReachableMethods, unprocessedMethods) = r12;
	_JC_LINE_NUMBER(49);				// 7
	r7 = _JC_INVOKE_VIRTUAL(env, soot_jimple_toolkits_callgraph_CallGraph, listener$6c88d190272b7f47, r1);
	_JC_REF_FIELD(env, r0, soot_jimple_toolkits_callgraph_ReachableMethods, edgeSource) = r7;
	_JC_LINE_NUMBER(50);				// 8
	if (r3 == _JC_NULL)
		goto label2;
	r2 = _JC_REF_FIELD(env, r0, soot_jimple_toolkits_callgraph_ReachableMethods, edgeSource);
	r2 = _JC_INVOKE_VIRTUAL(env, soot_jimple_toolkits_callgraph_Filter, wrap$0d5127e4f14ef9f7, r3, r2);
	_JC_REF_FIELD(env, r0, soot_jimple_toolkits_callgraph_ReachableMethods, edgeSource) = r2;

label2:
	_JC_LINE_NUMBER(51);				// 9
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// private void addMethod(soot.jimple.toolkits.callgraph.MethodOrMethodContext)
//

static _jc_linenum _jc_soot_jimple_toolkits_callgraph_ReachableMethods$linenum_table$addMethod$d93f9fcf807b559b[];

static const unsigned char _jc_soot_jimple_toolkits_callgraph_ReachableMethods$param_ptypes$addMethod$d93f9fcf807b559b[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_soot_jimple_toolkits_callgraph_ReachableMethods$param_types$addMethod$d93f9fcf807b559b[] = {
	&_jc_soot_jimple_toolkits_callgraph_MethodOrMethodContext$type
};

_jc_method _jc_soot_jimple_toolkits_callgraph_ReachableMethods$method_info$addMethod$d93f9fcf807b559b = {
	.name=			"addMethod",
	.signature=		"(Lsoot/jimple/toolkits/callgraph/MethodOrMethodContext;)V",
	.class=			&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$type,
	.param_types=		&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$param_types$addMethod$d93f9fcf807b559b,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$param_ptypes$addMethod$d93f9fcf807b559b,
	.signature_hash=	_JC_JLONG(0xd93f9fcf807b559b),
	.access_flags=		_JC_ACC_PRIVATE,
	.function=		&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$method$addMethod$d93f9fcf807b559b,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_jimple_toolkits_callgraph_ReachableMethods$vtable, soot_jimple_toolkits_callgraph_ReachableMethods.addMethod$d93f9fcf807b559b) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_soot_jimple_toolkits_callgraph_ReachableMethods$linenum_table$addMethod$d93f9fcf807b559b
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_jimple_toolkits_callgraph_ReachableMethods, addMethod$d93f9fcf807b559b);

void _JC_JCNI_ATTR
_jc_soot_jimple_toolkits_callgraph_ReachableMethods$method$addMethod$d93f9fcf807b559b(_jc_env *const env, _jc_soot_jimple_toolkits_callgraph_ReachableMethods$object *this, _jc_object *param0)
{
	struct _jc_soot_jimple_toolkits_callgraph_ReachableMethods$object *r0;
	struct _jc_object *r1;
	struct _jc_object *r2;
	struct _jc_soot_util_queue_ChunkedQueue$object *r3;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(60);				// 0
	r2 = _JC_REF_FIELD(env, r0, soot_jimple_toolkits_callgraph_ReachableMethods, set);
	z0 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0x831f06ee5f59c0cc), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r1);
	if (z0 == 0)
		goto label0;
	_JC_LINE_NUMBER(61);				// 1
	r3 = _JC_REF_FIELD(env, r0, soot_jimple_toolkits_callgraph_ReachableMethods, reachables);
	_JC_INVOKE_NONVIRTUAL(env, soot_util_queue_ChunkedQueue, add$75d6bd5079bf5583, 1, r3, r1);

label0:
	_JC_LINE_NUMBER(63);				// 2
	return;
}

//
// private void addMethods(java.util.Iterator)
//

static _jc_linenum _jc_soot_jimple_toolkits_callgraph_ReachableMethods$linenum_table$addMethods$96544f9973619dcd[];

static const unsigned char _jc_soot_jimple_toolkits_callgraph_ReachableMethods$param_ptypes$addMethods$96544f9973619dcd[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_soot_jimple_toolkits_callgraph_ReachableMethods$param_types$addMethods$96544f9973619dcd[] = {
	&_jc_java_util_Iterator$type
};

_jc_method _jc_soot_jimple_toolkits_callgraph_ReachableMethods$method_info$addMethods$96544f9973619dcd = {
	.name=			"addMethods",
	.signature=		"(Ljava/util/Iterator;)V",
	.class=			&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$type,
	.param_types=		&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$param_types$addMethods$96544f9973619dcd,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$param_ptypes$addMethods$96544f9973619dcd,
	.signature_hash=	_JC_JLONG(0x96544f9973619dcd),
	.access_flags=		_JC_ACC_PRIVATE,
	.function=		&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$method$addMethods$96544f9973619dcd,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_jimple_toolkits_callgraph_ReachableMethods$vtable, soot_jimple_toolkits_callgraph_ReachableMethods.addMethods$96544f9973619dcd) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_soot_jimple_toolkits_callgraph_ReachableMethods$linenum_table$addMethods$96544f9973619dcd
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_jimple_toolkits_callgraph_ReachableMethods, addMethods$96544f9973619dcd);

void _JC_JCNI_ATTR
_jc_soot_jimple_toolkits_callgraph_ReachableMethods$method$addMethods$96544f9973619dcd(_jc_env *const env, _jc_soot_jimple_toolkits_callgraph_ReachableMethods$object *this, _jc_object *param0)
{
	struct _jc_soot_jimple_toolkits_callgraph_ReachableMethods$object *r0;
	struct _jc_object *r1;
	struct _jc_java_lang_Object$object *r2;
	struct _jc_object *r3;
	struct _jc_object *r6;
	struct _jc_soot_util_queue_ChunkedQueue$object *r7;
	jboolean z0;
	jboolean z1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;

label0:
	_JC_LINE_NUMBER(56);				// 0
	z0 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0xfb0bd5e38c59ddcd), jboolean, (_jc_env *, struct _jc_object *));
	if (z0 == 0)
		goto label1;
	_JC_LINE_NUMBER(57);				// 1
	r2 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0x5874f79a1cf66ea), _jc_object *, (_jc_env *, struct _jc_object *));
	r3 = _JC_CAST(env, &_jc_soot_jimple_toolkits_callgraph_MethodOrMethodContext$type, r2);
	r6 = _JC_REF_FIELD(env, r0, soot_jimple_toolkits_callgraph_ReachableMethods, set);
	z1 = _JC_INVOKE_INTERFACE(env, r6, _JC_JLONG(0x831f06ee5f59c0cc), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r3);
	if (z1 == 0) {
		_JC_PERIODIC_CHECK(env);
		goto label0;
	}
	r7 = _JC_REF_FIELD(env, r0, soot_jimple_toolkits_callgraph_ReachableMethods, reachables);
	_JC_INVOKE_NONVIRTUAL(env, soot_util_queue_ChunkedQueue, add$75d6bd5079bf5583, 1, r7, r3);
	_JC_PERIODIC_CHECK(env);
	goto label0;

label1:
	_JC_LINE_NUMBER(58);				// 2
	return;
}

//
// public boolean contains(soot.jimple.toolkits.callgraph.MethodOrMethodContext)
//

static _jc_linenum _jc_soot_jimple_toolkits_callgraph_ReachableMethods$linenum_table$contains$c5496c14a38f43fa[];

static const unsigned char _jc_soot_jimple_toolkits_callgraph_ReachableMethods$param_ptypes$contains$c5496c14a38f43fa[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_soot_jimple_toolkits_callgraph_ReachableMethods$param_types$contains$c5496c14a38f43fa[] = {
	&_jc_soot_jimple_toolkits_callgraph_MethodOrMethodContext$type
};

_jc_method _jc_soot_jimple_toolkits_callgraph_ReachableMethods$method_info$contains$c5496c14a38f43fa = {
	.name=			"contains",
	.signature=		"(Lsoot/jimple/toolkits/callgraph/MethodOrMethodContext;)Z",
	.class=			&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$type,
	.param_types=		&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$param_types$contains$c5496c14a38f43fa,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$param_ptypes$contains$c5496c14a38f43fa,
	.signature_hash=	_JC_JLONG(0xc5496c14a38f43fa),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$method$contains$c5496c14a38f43fa,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_jimple_toolkits_callgraph_ReachableMethods$vtable, soot_jimple_toolkits_callgraph_ReachableMethods.contains$c5496c14a38f43fa) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_soot_jimple_toolkits_callgraph_ReachableMethods$linenum_table$contains$c5496c14a38f43fa
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_jimple_toolkits_callgraph_ReachableMethods, contains$c5496c14a38f43fa);

jboolean _JC_JCNI_ATTR
_jc_soot_jimple_toolkits_callgraph_ReachableMethods$method$contains$c5496c14a38f43fa(_jc_env *const env, _jc_soot_jimple_toolkits_callgraph_ReachableMethods$object *this, _jc_object *param0)
{
	struct _jc_soot_jimple_toolkits_callgraph_ReachableMethods$object *r0;
	struct _jc_object *r1;
	struct _jc_object *r2;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(95);				// 0
	r2 = _JC_REF_FIELD(env, r0, soot_jimple_toolkits_callgraph_ReachableMethods, set);
	z0 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0xd3bd70da40f05cb1), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r1);
	return z0;
}

//
// public soot.util.queue.QueueReader listener()
//

static _jc_linenum _jc_soot_jimple_toolkits_callgraph_ReachableMethods$linenum_table$listener$6c88d190272b7f47[];

static const unsigned char _jc_soot_jimple_toolkits_callgraph_ReachableMethods$param_ptypes$listener$6c88d190272b7f47[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_soot_jimple_toolkits_callgraph_ReachableMethods$method_info$listener$6c88d190272b7f47 = {
	.name=			"listener",
	.signature=		"()Lsoot/util/queue/QueueReader;",
	.class=			&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$type,
	.return_type=		&_jc_soot_util_queue_QueueReader$type,
	.param_ptypes=		&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$param_ptypes$listener$6c88d190272b7f47,
	.signature_hash=	_JC_JLONG(0x6c88d190272b7f47),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$method$listener$6c88d190272b7f47,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_jimple_toolkits_callgraph_ReachableMethods$vtable, soot_jimple_toolkits_callgraph_ReachableMethods.listener$6c88d190272b7f47) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_soot_jimple_toolkits_callgraph_ReachableMethods$linenum_table$listener$6c88d190272b7f47
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_jimple_toolkits_callgraph_ReachableMethods, listener$6c88d190272b7f47);

_jc_soot_util_queue_QueueReader$object * _JC_JCNI_ATTR
_jc_soot_jimple_toolkits_callgraph_ReachableMethods$method$listener$6c88d190272b7f47(_jc_env *const env, _jc_soot_jimple_toolkits_callgraph_ReachableMethods$object *this)
{
	jint i0;
	struct _jc_soot_jimple_toolkits_callgraph_ReachableMethods$object *r0;
	struct _jc_soot_util_queue_QueueReader$object *r1;
	struct _jc_soot_util_queue_QueueReader$object *r2;
	_jc_object_array *r3;

	r0 = this;
	_JC_LINE_NUMBER(84);				// 0
	r1 = _JC_REF_FIELD(env, r0, soot_jimple_toolkits_callgraph_ReachableMethods, allReachables);
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	r2 = _JC_NEW(env, soot_util_queue_QueueReader);
	r3 = _JC_REF_FIELD(env, r1, soot_util_queue_QueueReader, q);
	i0 = _JC_PRIM_FIELD(env, r1, soot_util_queue_QueueReader, index);
	_JC_REF_FIELD(env, r2, soot_util_queue_QueueReader, q) = r3;
	_JC_PRIM_FIELD(env, r2, soot_util_queue_QueueReader, index) = i0;
	r1 = r2;
	return r1;
}

//
// public soot.util.queue.QueueReader newListener()
//

static _jc_linenum _jc_soot_jimple_toolkits_callgraph_ReachableMethods$linenum_table$newListener$faa22950086d1ce9[];

static const unsigned char _jc_soot_jimple_toolkits_callgraph_ReachableMethods$param_ptypes$newListener$faa22950086d1ce9[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_soot_jimple_toolkits_callgraph_ReachableMethods$method_info$newListener$faa22950086d1ce9 = {
	.name=			"newListener",
	.signature=		"()Lsoot/util/queue/QueueReader;",
	.class=			&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$type,
	.return_type=		&_jc_soot_util_queue_QueueReader$type,
	.param_ptypes=		&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$param_ptypes$newListener$faa22950086d1ce9,
	.signature_hash=	_JC_JLONG(0xfaa22950086d1ce9),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$method$newListener$faa22950086d1ce9,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_jimple_toolkits_callgraph_ReachableMethods$vtable, soot_jimple_toolkits_callgraph_ReachableMethods.newListener$faa22950086d1ce9) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_soot_jimple_toolkits_callgraph_ReachableMethods$linenum_table$newListener$faa22950086d1ce9
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_jimple_toolkits_callgraph_ReachableMethods, newListener$faa22950086d1ce9);

_jc_soot_util_queue_QueueReader$object * _JC_JCNI_ATTR
_jc_soot_jimple_toolkits_callgraph_ReachableMethods$method$newListener$faa22950086d1ce9(_jc_env *const env, _jc_soot_jimple_toolkits_callgraph_ReachableMethods$object *this)
{
	jint i0;
	struct _jc_soot_jimple_toolkits_callgraph_ReachableMethods$object *r0;
	struct _jc_soot_util_queue_ChunkedQueue$object *r1;
	struct _jc_soot_util_queue_QueueReader$object *r2;
	_jc_object_array *r3;

	r0 = this;
	_JC_LINE_NUMBER(91);				// 0
	r1 = _JC_REF_FIELD(env, r0, soot_jimple_toolkits_callgraph_ReachableMethods, reachables);
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	r2 = _JC_NEW(env, soot_util_queue_QueueReader);
	r3 = _JC_REF_FIELD(env, r1, soot_util_queue_ChunkedQueue, q);
	i0 = _JC_PRIM_FIELD(env, r1, soot_util_queue_ChunkedQueue, index);
	_JC_REF_FIELD(env, r2, soot_util_queue_QueueReader, q) = r3;
	_JC_PRIM_FIELD(env, r2, soot_util_queue_QueueReader, index) = i0;
	return r2;
}

//
// public int size()
//

static _jc_linenum _jc_soot_jimple_toolkits_callgraph_ReachableMethods$linenum_table$size$345df5220fc60ade[];

static const unsigned char _jc_soot_jimple_toolkits_callgraph_ReachableMethods$param_ptypes$size$345df5220fc60ade[] = { 
_JC_TYPE_INT };

_jc_method _jc_soot_jimple_toolkits_callgraph_ReachableMethods$method_info$size$345df5220fc60ade = {
	.name=			"size",
	.signature=		"()I",
	.class=			&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$type,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$param_ptypes$size$345df5220fc60ade,
	.signature_hash=	_JC_JLONG(0x345df5220fc60ade),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$method$size$345df5220fc60ade,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_jimple_toolkits_callgraph_ReachableMethods$vtable, soot_jimple_toolkits_callgraph_ReachableMethods.size$345df5220fc60ade) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_soot_jimple_toolkits_callgraph_ReachableMethods$linenum_table$size$345df5220fc60ade
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_jimple_toolkits_callgraph_ReachableMethods, size$345df5220fc60ade);

jint _JC_JCNI_ATTR
_jc_soot_jimple_toolkits_callgraph_ReachableMethods$method$size$345df5220fc60ade(_jc_env *const env, _jc_soot_jimple_toolkits_callgraph_ReachableMethods$object *this)
{
	jint i0;
	struct _jc_soot_jimple_toolkits_callgraph_ReachableMethods$object *r0;
	struct _jc_object *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(99);				// 0
	r1 = _JC_REF_FIELD(env, r0, soot_jimple_toolkits_callgraph_ReachableMethods, set);
	i0 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0x345df5220fc60ade), jint, (_jc_env *, struct _jc_object *));
	return i0;
}

//
// public void update()
//

static _jc_linenum _jc_soot_jimple_toolkits_callgraph_ReachableMethods$linenum_table$update$1bc19abd93504b5c[];

static const unsigned char _jc_soot_jimple_toolkits_callgraph_ReachableMethods$param_ptypes$update$1bc19abd93504b5c[] = { 
_JC_TYPE_VOID };

_jc_method _jc_soot_jimple_toolkits_callgraph_ReachableMethods$method_info$update$1bc19abd93504b5c = {
	.name=			"update",
	.signature=		"()V",
	.class=			&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$param_ptypes$update$1bc19abd93504b5c,
	.signature_hash=	_JC_JLONG(0x1bc19abd93504b5c),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$method$update$1bc19abd93504b5c,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_jimple_toolkits_callgraph_ReachableMethods$vtable, soot_jimple_toolkits_callgraph_ReachableMethods.update$1bc19abd93504b5c) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	9,
	      .table=	_jc_soot_jimple_toolkits_callgraph_ReachableMethods$linenum_table$update$1bc19abd93504b5c
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_jimple_toolkits_callgraph_ReachableMethods, update$1bc19abd93504b5c);

void _JC_JCNI_ATTR
_jc_soot_jimple_toolkits_callgraph_ReachableMethods$method$update$1bc19abd93504b5c(_jc_env *const env, _jc_soot_jimple_toolkits_callgraph_ReachableMethods$object *this)
{
	struct _jc_soot_jimple_toolkits_callgraph_ReachableMethods$object *r0;
	struct _jc_soot_jimple_toolkits_callgraph_Edge$object *r1;
	struct _jc_object *r10;
	struct _jc_object *r11;
	struct _jc_object *r14;
	struct _jc_soot_util_queue_ChunkedQueue$object *r15;
	struct _jc_object *r2;
	struct _jc_java_lang_Object$object *r3;
	struct _jc_object *r4;
	struct _jc_object *r5;
	struct _jc_soot_util_queue_QueueReader$object *r6;
	struct _jc_soot_jimple_toolkits_callgraph_CallGraph$object *r7;
	struct _jc_soot_jimple_toolkits_callgraph_Filter$object *r8;
	struct _jc_soot_jimple_toolkits_callgraph_Targets$object *r9;
	jboolean z0;
	jboolean z1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;

label0:
	_JC_LINE_NUMBER(68);				// 0
	r2 = _JC_REF_FIELD(env, r0, soot_jimple_toolkits_callgraph_ReachableMethods, edgeSource);
	r3 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0x5874f79a1cf66ea), _jc_object *, (_jc_env *, struct _jc_object *));
	r1 = _JC_CAST_FINAL(env, &_jc_soot_jimple_toolkits_callgraph_Edge$type, r3);
	_JC_LINE_NUMBER(69);				// 1
	if (r1 != _JC_NULL)
		goto label1;
	goto label2;

label1:
	_JC_LINE_NUMBER(70);				// 2
	r4 = _JC_REF_FIELD(env, r0, soot_jimple_toolkits_callgraph_ReachableMethods, set);
	r10 = _JC_REF_FIELD(env, r1, soot_jimple_toolkits_callgraph_Edge, src);
	z0 = _JC_INVOKE_INTERFACE(env, r4, _JC_JLONG(0xd3bd70da40f05cb1), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r10);
	if (z0 == 0) {
		_JC_PERIODIC_CHECK(env);
		goto label0;
	}
	r11 = _JC_REF_FIELD(env, r1, soot_jimple_toolkits_callgraph_Edge, tgt);
	r14 = _JC_REF_FIELD(env, r0, soot_jimple_toolkits_callgraph_ReachableMethods, set);
	z1 = _JC_INVOKE_INTERFACE(env, r14, _JC_JLONG(0x831f06ee5f59c0cc), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r11);
	if (z1 == 0) {
		_JC_PERIODIC_CHECK(env);
		goto label0;
	}
	r15 = _JC_REF_FIELD(env, r0, soot_jimple_toolkits_callgraph_ReachableMethods, reachables);
	_JC_INVOKE_NONVIRTUAL(env, soot_util_queue_ChunkedQueue, add$75d6bd5079bf5583, 1, r15, r11);
	_JC_PERIODIC_CHECK(env);
	goto label0;

label2:
	_JC_LINE_NUMBER(73);				// 3
	r6 = _JC_REF_FIELD(env, r0, soot_jimple_toolkits_callgraph_ReachableMethods, unprocessedMethods);
	r3 = _JC_INVOKE_NONVIRTUAL(env, soot_util_queue_QueueReader, next$05874f79a1cf66ea, 1, r6);
	r5 = _JC_CAST(env, &_jc_soot_jimple_toolkits_callgraph_MethodOrMethodContext$type, r3);
	_JC_LINE_NUMBER(74);				// 4
	if (r5 != _JC_NULL)
		goto label3;
	goto label5;

label3:
	_JC_LINE_NUMBER(75);				// 5
	r7 = _JC_REF_FIELD(env, r0, soot_jimple_toolkits_callgraph_ReachableMethods, cg);
	r2 = _JC_INVOKE_VIRTUAL(env, soot_jimple_toolkits_callgraph_CallGraph, edgesOutOf$397fd50f27d40ae7, r7, r5);
	_JC_LINE_NUMBER(76);				// 6
	r8 = _JC_REF_FIELD(env, r0, soot_jimple_toolkits_callgraph_ReachableMethods, filter);
	if (r8 == _JC_NULL)
		goto label4;
	r8 = _JC_REF_FIELD(env, r0, soot_jimple_toolkits_callgraph_ReachableMethods, filter);
	r2 = _JC_INVOKE_VIRTUAL(env, soot_jimple_toolkits_callgraph_Filter, wrap$0d5127e4f14ef9f7, r8, r2);

label4:
	_JC_LINE_NUMBER(77);				// 7
	r9 = _JC_NEW(env, soot_jimple_toolkits_callgraph_Targets);
	_JC_REF_FIELD(env, r9, soot_jimple_toolkits_callgraph_Targets, edges) = r2;
	_JC_INVOKE_NONVIRTUAL(env, soot_jimple_toolkits_callgraph_ReachableMethods, addMethods$96544f9973619dcd, 0, r0, r9);
	_JC_PERIODIC_CHECK(env);
	goto label2;

label5:
	_JC_LINE_NUMBER(79);				// 8
	return;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_soot_jimple_toolkits_callgraph_ReachableMethods$methods[] = {
	&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$method_info$_init$1bd07d3affa43bdd,
	&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$method_info$_init$47d5d1c657e8bbbb,
	&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$method_info$_init$29022616f93f1ef6,
	&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$method_info$addMethod$d93f9fcf807b559b,
	&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$method_info$addMethods$96544f9973619dcd,
	&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$method_info$contains$c5496c14a38f43fa,
	&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$method_info$listener$6c88d190272b7f47,
	&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$method_info$newListener$faa22950086d1ce9,
	&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$method_info$size$345df5220fc60ade,
	&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$method_info$update$1bc19abd93504b5c
};

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_soot_jimple_toolkits_callgraph_ReachableMethods$instanceof_hash_bucket_7[] = {
	&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$type,
	_JC_NULL
};
static _jc_type *const _jc_soot_jimple_toolkits_callgraph_ReachableMethods$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_soot_jimple_toolkits_callgraph_ReachableMethods$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[7]=	_jc_soot_jimple_toolkits_callgraph_ReachableMethods$instanceof_hash_bucket_7,
	[101]=	_jc_soot_jimple_toolkits_callgraph_ReachableMethods$instanceof_hash_bucket_101
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_soot_jimple_toolkits_callgraph_ReachableMethods$class_depends[] = {
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/util/AbstractCollection",	_JC_JLONG(0x8ea716c64b77f8eb) },
	{ "java/util/AbstractList",	_JC_JLONG(0xf5238436362828db) },
	{ "java/util/AbstractSet",	_JC_JLONG(0xca427569b5b2f804) },
	{ "java/util/ArrayList",	_JC_JLONG(0x58038509830ef3f4) },
	{ "java/util/Collection",	_JC_JLONG(0xeae4d0c0e8eb63da) },
	{ "java/util/HashMap",	_JC_JLONG(0xd7cd853200c3e71f) },
	{ "java/util/HashSet",	_JC_JLONG(0x3c285c721478414d) },
	{ "java/util/Iterator",	_JC_JLONG(0xbe56ff673eefd9d2) },
	{ "java/util/List",	_JC_JLONG(0x9ee0d92ce1525a4d) },
	{ "java/util/Set",	_JC_JLONG(0x617ac82c0bec2dff) },
	{ "soot/jimple/toolkits/callgraph/CallGraph",	_JC_JLONG(0x1dd6244faf0063d9) },
	{ "soot/jimple/toolkits/callgraph/Edge",	_JC_JLONG(0xce9c62c38d34205d) },
	{ "soot/jimple/toolkits/callgraph/Filter",	_JC_JLONG(0xaca1790a167ce631) },
	{ "soot/jimple/toolkits/callgraph/MethodOrMethodContext",	_JC_JLONG(0xe11397553ff352db) },
	{ "soot/jimple/toolkits/callgraph/Targets",	_JC_JLONG(0x1361f0b081a2224) },
	{ "soot/util/queue/ChunkedQueue",	_JC_JLONG(0xe0a17cfc325c0311) },
	{ "soot/util/queue/QueueReader",	_JC_JLONG(0xdfc99826de09e7ed) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_soot_jimple_toolkits_callgraph_ReachableMethods$vtype _jc_soot_jimple_toolkits_callgraph_ReachableMethods$type = {
    .type= {
	.name=			"soot/jimple/toolkits/callgraph/ReachableMethods",
	.superclass=		&_jc_java_lang_Object$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		18,
		.hash=			_JC_JLONG(0x5f8ac62e0dc34c07),
		.source_file=		"ReachableMethods.java",
		.instance_size=		sizeof(_jc_soot_jimple_toolkits_callgraph_ReachableMethods$refs) + sizeof(_jc_soot_jimple_toolkits_callgraph_ReachableMethods$object),
		.num_virtual_refs=	8,
		.num_fields=		sizeof(_jc_soot_jimple_toolkits_callgraph_ReachableMethods$fields) / sizeof(*_jc_soot_jimple_toolkits_callgraph_ReachableMethods$fields),
		.fields=		_jc_soot_jimple_toolkits_callgraph_ReachableMethods$fields,
		.num_methods=		sizeof(_jc_soot_jimple_toolkits_callgraph_ReachableMethods$methods) / sizeof(*_jc_soot_jimple_toolkits_callgraph_ReachableMethods$methods),
		.methods=		_jc_soot_jimple_toolkits_callgraph_ReachableMethods$methods,
		.instanceof_hash_table=	_jc_soot_jimple_toolkits_callgraph_ReachableMethods$instanceof_hash_table,
		.num_class_depends=		sizeof(_jc_soot_jimple_toolkits_callgraph_ReachableMethods$class_depends) / sizeof(*_jc_soot_jimple_toolkits_callgraph_ReachableMethods$class_depends),
		.class_depends=		_jc_soot_jimple_toolkits_callgraph_ReachableMethods$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.soot_jimple_toolkits_callgraph_ReachableMethods= {
	    .addMethod$d93f9fcf807b559b=
		&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$method$addMethod$d93f9fcf807b559b,
	    .addMethods$96544f9973619dcd=
		&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$method$addMethods$96544f9973619dcd,
	    .contains$c5496c14a38f43fa=
		&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$method$contains$c5496c14a38f43fa,
	    .listener$6c88d190272b7f47=
		&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$method$listener$6c88d190272b7f47,
	    .newListener$faa22950086d1ce9=
		&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$method$newListener$faa22950086d1ce9,
	    .size$345df5220fc60ade=
		&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$method$size$345df5220fc60ade,
	    .update$1bc19abd93504b5c=
		&_jc_soot_jimple_toolkits_callgraph_ReachableMethods$method$update$1bc19abd93504b5c,
	},
    }
};

