// public class soot.shimple.internal.analysis.DominatorTree

// class file dependencies
// @dep_class 99a46305ebacacb5 java_io_PrintStream
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class 4f5534a987354d1d java_lang_RuntimeException
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 94d357637b968dda java_lang_StringBuffer
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class 8ea716c64b77f8eb java_util_AbstractCollection
// @dep_class f5238436362828db java_util_AbstractList
// @dep_class 58038509830ef3f4 java_util_ArrayList
// @dep_class eae4d0c0e8eb63da java_util_Collection
// @dep_class d7cd853200c3e71f java_util_HashMap
// @dep_class be56ff673eefd9d2 java_util_Iterator
// @dep_class 9ee0d92ce1525a4d java_util_List
// @dep_class 6131d54b9700ca5d soot_Body
// @dep_class b6d33af8f84fdbc4 soot_G
// @dep_class 6ac5bee50bbabb71 soot_Singletons
// @dep_class bd11c16680505218 soot_SootMethod
// @dep_class c5a5a246a3f59476 soot_options_Options
// @dep_class f1bd878a4874fcce soot_shimple_internal_analysis_DominanceFrontier
// @dep_class 435307d811e497d8 soot_shimple_internal_analysis_DominatorNode
// @dep_class b0e8c3835eb9bdae soot_shimple_internal_analysis_DominatorTree
// @dep_class d5d9fd40a0d98b0a soot_shimple_internal_analysis_DominatorsFinder
// @dep_class b252d9c4153bf27b soot_toolkits_graph_Block
// @dep_class 340ee84e9e1f189d soot_toolkits_graph_BlockGraph
// @dep_class 1d20f632cfd945d1 soot_toolkits_graph_DirectedGraph

// header file dependencies
// @dep_header java_io_PrintStream
// @dep_header java_lang_Class
// @dep_header java_lang_RuntimeException
// @dep_header java_lang_String
// @dep_header java_lang_StringBuffer
// @dep_header java_lang_VMThrowable
// @dep_header java_util_ArrayList
// @dep_header java_util_Collection
// @dep_header java_util_HashMap
// @dep_header java_util_Iterator
// @dep_header java_util_List
// @dep_header soot_Body
// @dep_header soot_G
// @dep_header soot_SootMethod
// @dep_header soot_options_Options
// @dep_header soot_shimple_internal_analysis_DominanceFrontier
// @dep_header soot_shimple_internal_analysis_DominatorNode
// @dep_header soot_shimple_internal_analysis_DominatorTree
// @dep_header soot_shimple_internal_analysis_DominatorsFinder
// @dep_header soot_toolkits_graph_Block
// @dep_header soot_toolkits_graph_BlockGraph
// @dep_header soot_toolkits_graph_DirectedGraph

#include "jc_defs.h"

#include "java/io/PrintStream.h"
#include "java/lang/Class.h"
#include "java/lang/RuntimeException.h"
#include "java/lang/String.h"
#include "java/lang/StringBuffer.h"
#include "java/lang/VMThrowable.h"
#include "java/util/ArrayList.h"
#include "java/util/Collection.h"
#include "java/util/HashMap.h"
#include "java/util/Iterator.h"
#include "java/util/List.h"
#include "soot/Body.h"
#include "soot/G.h"
#include "soot/SootMethod.h"
#include "soot/options/Options.h"
#include "soot/shimple/internal/analysis/DominanceFrontier.h"
#include "soot/shimple/internal/analysis/DominatorNode.h"
#include "soot/shimple/internal/analysis/DominatorTree.h"
#include "soot/shimple/internal/analysis/DominatorsFinder.h"
#include "soot/toolkits/graph/Block.h"
#include "soot/toolkits/graph/BlockGraph.h"
#include "soot/toolkits/graph/DirectedGraph.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// private soot.toolkits.graph.BlockGraph graph
static _jc_field _jc_soot_shimple_internal_analysis_DominatorTree$field_info$graph = {
	.name=		"graph",
	.signature=	"Lsoot/toolkits/graph/BlockGraph;",
	.class=		&_jc_soot_shimple_internal_analysis_DominatorTree$type,
	.type=		&_jc_soot_toolkits_graph_BlockGraph$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_soot_shimple_internal_analysis_DominatorTree$object, refs[-1].soot_shimple_internal_analysis_DominatorTree.graph),
};

// private soot.shimple.internal.analysis.DominatorsFinder dominators
static _jc_field _jc_soot_shimple_internal_analysis_DominatorTree$field_info$dominators = {
	.name=		"dominators",
	.signature=	"Lsoot/shimple/internal/analysis/DominatorsFinder;",
	.class=		&_jc_soot_shimple_internal_analysis_DominatorTree$type,
	.type=		&_jc_soot_shimple_internal_analysis_DominatorsFinder$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_soot_shimple_internal_analysis_DominatorTree$object, refs[-1].soot_shimple_internal_analysis_DominatorTree.dominators),
};

// private java.util.ArrayList heads
static _jc_field _jc_soot_shimple_internal_analysis_DominatorTree$field_info$heads = {
	.name=		"heads",
	.signature=	"Ljava/util/ArrayList;",
	.class=		&_jc_soot_shimple_internal_analysis_DominatorTree$type,
	.type=		&_jc_java_util_ArrayList$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_soot_shimple_internal_analysis_DominatorTree$object, refs[-1].soot_shimple_internal_analysis_DominatorTree.heads),
};

// private java.util.ArrayList tails
static _jc_field _jc_soot_shimple_internal_analysis_DominatorTree$field_info$tails = {
	.name=		"tails",
	.signature=	"Ljava/util/ArrayList;",
	.class=		&_jc_soot_shimple_internal_analysis_DominatorTree$type,
	.type=		&_jc_java_util_ArrayList$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_soot_shimple_internal_analysis_DominatorTree$object, refs[-1].soot_shimple_internal_analysis_DominatorTree.tails),
};

// private java.util.HashMap blockToNode
static _jc_field _jc_soot_shimple_internal_analysis_DominatorTree$field_info$blockToNode = {
	.name=		"blockToNode",
	.signature=	"Ljava/util/HashMap;",
	.class=		&_jc_soot_shimple_internal_analysis_DominatorTree$type,
	.type=		&_jc_java_util_HashMap$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_soot_shimple_internal_analysis_DominatorTree$object, refs[-1].soot_shimple_internal_analysis_DominatorTree.blockToNode),
};

// Fields
static _jc_field *const _jc_soot_shimple_internal_analysis_DominatorTree$fields[] = {
	&_jc_soot_shimple_internal_analysis_DominatorTree$field_info$blockToNode,
	&_jc_soot_shimple_internal_analysis_DominatorTree$field_info$dominators,
	&_jc_soot_shimple_internal_analysis_DominatorTree$field_info$graph,
	&_jc_soot_shimple_internal_analysis_DominatorTree$field_info$heads,
	&_jc_soot_shimple_internal_analysis_DominatorTree$field_info$tails
};

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// public void <init>(soot.toolkits.graph.BlockGraph)
//

static _jc_linenum _jc_soot_shimple_internal_analysis_DominatorTree$linenum_table$_init$6d442eef553ff081[];

static const unsigned char _jc_soot_shimple_internal_analysis_DominatorTree$param_ptypes$_init$6d442eef553ff081[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_soot_shimple_internal_analysis_DominatorTree$param_types$_init$6d442eef553ff081[] = {
	&_jc_soot_toolkits_graph_BlockGraph$type
};

_jc_method _jc_soot_shimple_internal_analysis_DominatorTree$method_info$_init$6d442eef553ff081 = {
	.name=			"<init>",
	.signature=		"(Lsoot/toolkits/graph/BlockGraph;)V",
	.class=			&_jc_soot_shimple_internal_analysis_DominatorTree$type,
	.param_types=		&_jc_soot_shimple_internal_analysis_DominatorTree$param_types$_init$6d442eef553ff081,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_soot_shimple_internal_analysis_DominatorTree$param_ptypes$_init$6d442eef553ff081,
	.signature_hash=	_JC_JLONG(0x6d442eef553ff081),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_shimple_internal_analysis_DominatorTree$method$_init$6d442eef553ff081,
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_soot_shimple_internal_analysis_DominatorTree$linenum_table$_init$6d442eef553ff081
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_shimple_internal_analysis_DominatorTree, _init$6d442eef553ff081);

void _JC_JCNI_ATTR
_jc_soot_shimple_internal_analysis_DominatorTree$method$_init$6d442eef553ff081(_jc_env *const env, _jc_soot_shimple_internal_analysis_DominatorTree$object *this, _jc_soot_toolkits_graph_BlockGraph$object *param0)
{
	struct _jc_soot_shimple_internal_analysis_DominatorTree$object *r0;
	struct _jc_soot_toolkits_graph_BlockGraph$object *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(51);				// 0
	_JC_INVOKE_NONVIRTUAL(env, soot_shimple_internal_analysis_DominatorTree, _init$33c8d16cb6714abf, 0, r0, r1, 0);
	_JC_LINE_NUMBER(52);				// 1
	return;
}

//
// public void <init>(soot.toolkits.graph.BlockGraph, boolean)
//

static _jc_linenum _jc_soot_shimple_internal_analysis_DominatorTree$linenum_table$_init$33c8d16cb6714abf[];

static const unsigned char _jc_soot_shimple_internal_analysis_DominatorTree$param_ptypes$_init$33c8d16cb6714abf[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN, _JC_TYPE_VOID };

static _jc_type *const _jc_soot_shimple_internal_analysis_DominatorTree$param_types$_init$33c8d16cb6714abf[] = {
	&_jc_soot_toolkits_graph_BlockGraph$type,
	&_jc_boolean$prim$type
};

_jc_method _jc_soot_shimple_internal_analysis_DominatorTree$method_info$_init$33c8d16cb6714abf = {
	.name=			"<init>",
	.signature=		"(Lsoot/toolkits/graph/BlockGraph;Z)V",
	.class=			&_jc_soot_shimple_internal_analysis_DominatorTree$type,
	.param_types=		&_jc_soot_shimple_internal_analysis_DominatorTree$param_types$_init$33c8d16cb6714abf,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_soot_shimple_internal_analysis_DominatorTree$param_ptypes$_init$33c8d16cb6714abf,
	.signature_hash=	_JC_JLONG(0x33c8d16cb6714abf),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_shimple_internal_analysis_DominatorTree$method$_init$33c8d16cb6714abf,
	.num_parameters=	2,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	11,
	      .table=	_jc_soot_shimple_internal_analysis_DominatorTree$linenum_table$_init$33c8d16cb6714abf
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_shimple_internal_analysis_DominatorTree, _init$33c8d16cb6714abf);

void _JC_JCNI_ATTR
_jc_soot_shimple_internal_analysis_DominatorTree$method$_init$33c8d16cb6714abf(_jc_env *const env, _jc_soot_shimple_internal_analysis_DominatorTree$object *this, _jc_soot_toolkits_graph_BlockGraph$object *param0, jboolean param1)
{
	struct _jc_soot_shimple_internal_analysis_DominatorTree$object *r0;
	struct _jc_soot_toolkits_graph_BlockGraph$object *r1;
	struct _jc_soot_G$object *r10;
	struct _jc_soot_options_Options$object *r11;
	struct _jc_soot_G$object *r12;
	struct _jc_java_lang_String$object *r13;
	_jc_char_array *r14;
	_jc_object_array *r15;
	_jc_object_array *r16;
	struct _jc_java_lang_StringBuffer$object *r2;
	struct _jc_java_io_PrintStream$object *r3;
	struct _jc_soot_Body$object *r4;
	struct _jc_soot_SootMethod$object *r5;
	struct _jc_java_lang_String$object *r6;
	struct _jc_soot_shimple_internal_analysis_DominatorsFinder$object *r7;
	struct _jc_java_util_ArrayList$object *r8;
	struct _jc_java_util_HashMap$object *r9;
	jboolean z0;
	jboolean z1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	z0 = param1;
	_JC_ACTIVE_USE(env, soot_options_Options);
	_JC_ACTIVE_USE(env, soot_G);
	_JC_LINE_NUMBER(56);				// 0
	r12 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r11 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Options$9fd4168abe5957f7, r12);
	z1 = _JC_INVOKE_VIRTUAL(env, soot_options_Options, verbose$e5b65d4727121643, r11);
	if (z1 == 0)
		goto label0;
	_JC_LINE_NUMBER(57);				// 1
	r10 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r3 = _JC_REF_FIELD(env, r10, soot_G, out);
	r2 = _JC_NEW(env, java_lang_StringBuffer);
	r14 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r2, java_lang_StringBuffer, value) = r14;
	r2 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r2, _JC_STRING(env, "["));
	r4 = _JC_INVOKE_VIRTUAL(env, soot_toolkits_graph_BlockGraph, getBody$7a3bcdfd41311eec, r1);
	r5 = _JC_INVOKE_VIRTUAL(env, soot_Body, getMethod$04d7c221deab35ce, r4);
	r6 = _JC_INVOKE_VIRTUAL(env, soot_SootMethod, getName$bec186f2ce7e1882, r5);
	r2 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r2, r6);
	r2 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r2, _JC_STRING(env, "]     Constructing DominatorTree..."));
	r13 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r13, r2);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, println$f7dbc2aa0f0a9d4f, r3, r13);

label0:
	_JC_LINE_NUMBER(60);				// 2
	_JC_REF_FIELD(env, r0, soot_shimple_internal_analysis_DominatorTree, graph) = r1;
	_JC_LINE_NUMBER(62);				// 3
	r7 = _JC_NEW(env, soot_shimple_internal_analysis_DominatorsFinder);
	_JC_INVOKE_NONVIRTUAL(env, soot_shimple_internal_analysis_DominatorsFinder, _init$6d442eef553ff081, 0, r7, r1);
	_JC_REF_FIELD(env, r0, soot_shimple_internal_analysis_DominatorTree, dominators) = r7;
	_JC_LINE_NUMBER(64);				// 4
	r8 = _JC_NEW(env, java_util_ArrayList);
	r15 = _JC_NEW_REF_ARRAY(env, java_lang_Object, 1, 16);
	_JC_REF_FIELD(env, r8, java_util_ArrayList, data) = r15;
	_JC_REF_FIELD(env, r0, soot_shimple_internal_analysis_DominatorTree, heads) = r8;
	_JC_LINE_NUMBER(65);				// 5
	r8 = _JC_NEW(env, java_util_ArrayList);
	r16 = _JC_NEW_REF_ARRAY(env, java_lang_Object, 1, 16);
	_JC_REF_FIELD(env, r8, java_util_ArrayList, data) = r16;
	_JC_REF_FIELD(env, r0, soot_shimple_internal_analysis_DominatorTree, tails) = r8;
	_JC_LINE_NUMBER(67);				// 6
	r9 = _JC_NEW(env, java_util_HashMap);
	_JC_INVOKE_NONVIRTUAL(env, java_util_HashMap, _init$7cb044ce4fb0ada8, 0, r9, 11, _JC_FCONST(0x3f, 0x40, 0x0, 0x0));
	_JC_REF_FIELD(env, r0, soot_shimple_internal_analysis_DominatorTree, blockToNode) = r9;
	_JC_LINE_NUMBER(69);				// 7
	_JC_INVOKE_VIRTUAL(env, soot_shimple_internal_analysis_DominatorTree, buildTree$61dc0404bc002a9e, r0);
	_JC_LINE_NUMBER(71);				// 8
	if (z0 == 0)
		goto label1;
	_JC_LINE_NUMBER(72);				// 9
	_JC_INVOKE_VIRTUAL(env, soot_shimple_internal_analysis_DominatorTree, buildFrontier$5d52140f63810cc1, r0);

label1:
	_JC_LINE_NUMBER(73);				// 10
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public void buildFrontier()
//

static _jc_linenum _jc_soot_shimple_internal_analysis_DominatorTree$linenum_table$buildFrontier$5d52140f63810cc1[];

static const unsigned char _jc_soot_shimple_internal_analysis_DominatorTree$param_ptypes$buildFrontier$5d52140f63810cc1[] = { 
_JC_TYPE_VOID };

_jc_method _jc_soot_shimple_internal_analysis_DominatorTree$method_info$buildFrontier$5d52140f63810cc1 = {
	.name=			"buildFrontier",
	.signature=		"()V",
	.class=			&_jc_soot_shimple_internal_analysis_DominatorTree$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_soot_shimple_internal_analysis_DominatorTree$param_ptypes$buildFrontier$5d52140f63810cc1,
	.signature_hash=	_JC_JLONG(0x5d52140f63810cc1),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_shimple_internal_analysis_DominatorTree$method$buildFrontier$5d52140f63810cc1,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_shimple_internal_analysis_DominatorTree$vtable, soot_shimple_internal_analysis_DominatorTree.buildFrontier$5d52140f63810cc1) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_soot_shimple_internal_analysis_DominatorTree$linenum_table$buildFrontier$5d52140f63810cc1
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_shimple_internal_analysis_DominatorTree, buildFrontier$5d52140f63810cc1);

void _JC_JCNI_ATTR
_jc_soot_shimple_internal_analysis_DominatorTree$method$buildFrontier$5d52140f63810cc1(_jc_env *const env, _jc_soot_shimple_internal_analysis_DominatorTree$object *this)
{
	struct _jc_soot_shimple_internal_analysis_DominatorTree$object *r0;
	struct _jc_soot_shimple_internal_analysis_DominanceFrontier$object *r1;
	struct _jc_java_util_ArrayList$object *r2;
	struct _jc_object *r3;
	struct _jc_java_lang_Object$object *r4;
	struct _jc_soot_shimple_internal_analysis_DominatorNode$object *r5;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(219);				// 0
	r1 = _JC_NEW(env, soot_shimple_internal_analysis_DominanceFrontier);
	r2 = _JC_REF_FIELD(env, r0, soot_shimple_internal_analysis_DominatorTree, heads);
	r3 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0x3cc91493d50f531c), _jc_object *, (_jc_env *, struct _jc_object *));

label0:
	z0 = _JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0xfb0bd5e38c59ddcd), jboolean, (_jc_env *, struct _jc_object *));
	if (z0 == 0)
		goto label1;
	r4 = _JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0x5874f79a1cf66ea), _jc_object *, (_jc_env *, struct _jc_object *));
	r5 = _JC_CAST(env, &_jc_soot_shimple_internal_analysis_DominatorNode$type, r4);
	_JC_INVOKE_NONVIRTUAL(env, soot_shimple_internal_analysis_DominanceFrontier, bottomUpDispatch$9de283e0f4160d5d, 0, r1, r5);
	_JC_PERIODIC_CHECK(env);
	goto label0;

label1:
	_JC_LINE_NUMBER(220);				// 1
	return;
}

//
// public void buildTree()
//

static _jc_linenum _jc_soot_shimple_internal_analysis_DominatorTree$linenum_table$buildTree$61dc0404bc002a9e[];

static const unsigned char _jc_soot_shimple_internal_analysis_DominatorTree$param_ptypes$buildTree$61dc0404bc002a9e[] = { 
_JC_TYPE_VOID };

_jc_method _jc_soot_shimple_internal_analysis_DominatorTree$method_info$buildTree$61dc0404bc002a9e = {
	.name=			"buildTree",
	.signature=		"()V",
	.class=			&_jc_soot_shimple_internal_analysis_DominatorTree$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_soot_shimple_internal_analysis_DominatorTree$param_ptypes$buildTree$61dc0404bc002a9e,
	.signature_hash=	_JC_JLONG(0x61dc0404bc002a9e),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_shimple_internal_analysis_DominatorTree$method$buildTree$61dc0404bc002a9e,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_shimple_internal_analysis_DominatorTree$vtable, soot_shimple_internal_analysis_DominatorTree.buildTree$61dc0404bc002a9e) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	16,
	      .table=	_jc_soot_shimple_internal_analysis_DominatorTree$linenum_table$buildTree$61dc0404bc002a9e
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_shimple_internal_analysis_DominatorTree, buildTree$61dc0404bc002a9e);

void _JC_JCNI_ATTR
_jc_soot_shimple_internal_analysis_DominatorTree$method$buildTree$61dc0404bc002a9e(_jc_env *const env, _jc_soot_shimple_internal_analysis_DominatorTree$object *this)
{
	struct _jc_soot_shimple_internal_analysis_DominatorTree$object *r0;
	struct _jc_object *r1;
	struct _jc_soot_toolkits_graph_Block$object *r2;
	struct _jc_soot_shimple_internal_analysis_DominatorNode$object *r3;
	struct _jc_soot_shimple_internal_analysis_DominatorNode$object *r4;
	struct _jc_soot_toolkits_graph_BlockGraph$object *r5;
	struct _jc_java_lang_Object$object *r6;
	struct _jc_java_util_ArrayList$object *r7;
	struct _jc_java_util_HashMap$object *r8;
	struct _jc_object *r9;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(121);				// 0
	r5 = _JC_REF_FIELD(env, r0, soot_shimple_internal_analysis_DominatorTree, graph);
	r1 = _JC_INVOKE_VIRTUAL(env, soot_toolkits_graph_BlockGraph, iterator$3cc91493d50f531c, r5);

label0:
	_JC_LINE_NUMBER(125);				// 1
	z0 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0xfb0bd5e38c59ddcd), jboolean, (_jc_env *, struct _jc_object *));
	if (z0 == 0)
		goto label2;
	_JC_LINE_NUMBER(126);				// 2
	r6 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0x5874f79a1cf66ea), _jc_object *, (_jc_env *, struct _jc_object *));
	r2 = _JC_CAST(env, &_jc_soot_toolkits_graph_Block$type, r6);
	_JC_LINE_NUMBER(128);				// 3
	r3 = _JC_INVOKE_VIRTUAL(env, soot_shimple_internal_analysis_DominatorTree, fetchNode$7f3811411a7aeec1, r0, r2);
	_JC_LINE_NUMBER(129);				// 4
	r4 = _JC_INVOKE_VIRTUAL(env, soot_shimple_internal_analysis_DominatorTree, fetchParent$6b55e389762a6856, r0, r2);
	_JC_LINE_NUMBER(131);				// 5
	if (r4 != _JC_NULL)
		goto label1;
	_JC_LINE_NUMBER(132);				// 6
	r7 = _JC_REF_FIELD(env, r0, soot_shimple_internal_analysis_DominatorTree, heads);
	_JC_INVOKE_VIRTUAL(env, java_util_ArrayList, add$831f06ee5f59c0cc, r7, r3);
	_JC_PERIODIC_CHECK(env);
	goto label0;

label1:
	_JC_LINE_NUMBER(135);				// 7
	_JC_INVOKE_VIRTUAL(env, soot_shimple_internal_analysis_DominatorNode, addChild$e2a3f2ed22be4d12, r4, r3);
	_JC_LINE_NUMBER(136);				// 8
	_JC_INVOKE_VIRTUAL(env, soot_shimple_internal_analysis_DominatorNode, setParent$5ea7cb4b0c30fe8f, r3, r4);
	_JC_PERIODIC_CHECK(env);
	goto label0;

label2:
	_JC_LINE_NUMBER(143);				// 9
	r8 = _JC_REF_FIELD(env, r0, soot_shimple_internal_analysis_DominatorTree, blockToNode);
	r9 = _JC_INVOKE_VIRTUAL(env, java_util_HashMap, values$ff2f8ae502eccb46, r8);
	r1 = _JC_INVOKE_INTERFACE(env, r9, _JC_JLONG(0x3cc91493d50f531c), _jc_object *, (_jc_env *, struct _jc_object *));

label3:
	_JC_LINE_NUMBER(145);				// 10
	z0 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0xfb0bd5e38c59ddcd), jboolean, (_jc_env *, struct _jc_object *));
	if (z0 == 0)
		goto label4;
	_JC_LINE_NUMBER(146);				// 11
	r6 = _JC_INVOKE_INTERFACE(env, r1, _JC_JLONG(0x5874f79a1cf66ea), _jc_object *, (_jc_env *, struct _jc_object *));
	r4 = _JC_CAST(env, &_jc_soot_shimple_internal_analysis_DominatorNode$type, r6);
	_JC_LINE_NUMBER(148);				// 12
	_JC_INVOKE_VIRTUAL(env, soot_shimple_internal_analysis_DominatorNode, setDominatorTree$1d7fad7c87576ea5, r4, r0);
	_JC_LINE_NUMBER(150);				// 13
	z0 = _JC_INVOKE_VIRTUAL(env, soot_shimple_internal_analysis_DominatorNode, isTail$ddf2d0788c1ab7cf, r4);
	if (z0 == 0) {
		_JC_PERIODIC_CHECK(env);
		goto label3;
	}
	_JC_LINE_NUMBER(151);				// 14
	r7 = _JC_REF_FIELD(env, r0, soot_shimple_internal_analysis_DominatorTree, tails);
	_JC_INVOKE_VIRTUAL(env, java_util_ArrayList, add$831f06ee5f59c0cc, r7, r4);
	_JC_PERIODIC_CHECK(env);
	goto label3;

label4:
	_JC_LINE_NUMBER(155);				// 15
	return;
}

//
// public soot.shimple.internal.analysis.DominatorNode fetchNode(soot.toolkits.graph.Block)
//

static _jc_linenum _jc_soot_shimple_internal_analysis_DominatorTree$linenum_table$fetchNode$7f3811411a7aeec1[];

static const unsigned char _jc_soot_shimple_internal_analysis_DominatorTree$param_ptypes$fetchNode$7f3811411a7aeec1[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_soot_shimple_internal_analysis_DominatorTree$param_types$fetchNode$7f3811411a7aeec1[] = {
	&_jc_soot_toolkits_graph_Block$type
};

_jc_method _jc_soot_shimple_internal_analysis_DominatorTree$method_info$fetchNode$7f3811411a7aeec1 = {
	.name=			"fetchNode",
	.signature=		"(Lsoot/toolkits/graph/Block;)Lsoot/shimple/internal/analysis/DominatorNode;",
	.class=			&_jc_soot_shimple_internal_analysis_DominatorTree$type,
	.param_types=		&_jc_soot_shimple_internal_analysis_DominatorTree$param_types$fetchNode$7f3811411a7aeec1,
	.return_type=		&_jc_soot_shimple_internal_analysis_DominatorNode$type,
	.param_ptypes=		&_jc_soot_shimple_internal_analysis_DominatorTree$param_ptypes$fetchNode$7f3811411a7aeec1,
	.signature_hash=	_JC_JLONG(0x7f3811411a7aeec1),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_shimple_internal_analysis_DominatorTree$method$fetchNode$7f3811411a7aeec1,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_shimple_internal_analysis_DominatorTree$vtable, soot_shimple_internal_analysis_DominatorTree.fetchNode$7f3811411a7aeec1) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_soot_shimple_internal_analysis_DominatorTree$linenum_table$fetchNode$7f3811411a7aeec1
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_shimple_internal_analysis_DominatorTree, fetchNode$7f3811411a7aeec1);

_jc_soot_shimple_internal_analysis_DominatorNode$object * _JC_JCNI_ATTR
_jc_soot_shimple_internal_analysis_DominatorTree$method$fetchNode$7f3811411a7aeec1(_jc_env *const env, _jc_soot_shimple_internal_analysis_DominatorTree$object *this, _jc_soot_toolkits_graph_Block$object *param0)
{
	struct _jc_soot_shimple_internal_analysis_DominatorTree$object *r0;
	struct _jc_soot_toolkits_graph_Block$object *r1;
	struct _jc_soot_shimple_internal_analysis_DominatorNode$object *r2;
	struct _jc_java_util_HashMap$object *r3;
	struct _jc_java_lang_Object$object *r4;
	struct _jc_java_util_ArrayList$object *r5;
	_jc_object_array *r6;
	_jc_object_array *r7;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(169);				// 0
	r3 = _JC_REF_FIELD(env, r0, soot_shimple_internal_analysis_DominatorTree, blockToNode);
	z0 = _JC_INVOKE_VIRTUAL(env, java_util_HashMap, containsKey$5db565349ffc17b2, r3, r1);
	if (z0 == 0)
		goto label0;
	_JC_LINE_NUMBER(170);				// 1
	r3 = _JC_REF_FIELD(env, r0, soot_shimple_internal_analysis_DominatorTree, blockToNode);
	r4 = _JC_INVOKE_VIRTUAL(env, java_util_HashMap, get$b30461fc5ea13399, r3, r1);
	r2 = _JC_CAST(env, &_jc_soot_shimple_internal_analysis_DominatorNode$type, r4);
	goto label1;

label0:
	_JC_LINE_NUMBER(173);				// 2
	r2 = _JC_NEW(env, soot_shimple_internal_analysis_DominatorNode);
	_JC_REF_FIELD(env, r2, soot_shimple_internal_analysis_DominatorNode, block) = r1;
	r5 = _JC_NEW(env, java_util_ArrayList);
	r6 = _JC_NEW_REF_ARRAY(env, java_lang_Object, 1, 16);
	_JC_REF_FIELD(env, r5, java_util_ArrayList, data) = r6;
	_JC_REF_FIELD(env, r2, soot_shimple_internal_analysis_DominatorNode, children) = r5;
	_JC_PRIM_FIELD(env, r2, soot_shimple_internal_analysis_DominatorNode, frontierKnown) = 0;
	r5 = _JC_NEW(env, java_util_ArrayList);
	r7 = _JC_NEW_REF_ARRAY(env, java_lang_Object, 1, 16);
	_JC_REF_FIELD(env, r5, java_util_ArrayList, data) = r7;
	_JC_REF_FIELD(env, r2, soot_shimple_internal_analysis_DominatorNode, dominanceFrontier) = r5;
	_JC_LINE_NUMBER(174);				// 3
	r3 = _JC_REF_FIELD(env, r0, soot_shimple_internal_analysis_DominatorTree, blockToNode);
	_JC_INVOKE_VIRTUAL(env, java_util_HashMap, put$3bd1c078a0faa8da, r3, r1, r2);

label1:
	_JC_LINE_NUMBER(177);				// 4
	return r2;
}

//
// protected soot.shimple.internal.analysis.DominatorNode fetchParent(soot.toolkits.graph.Block)
//

static _jc_linenum _jc_soot_shimple_internal_analysis_DominatorTree$linenum_table$fetchParent$6b55e389762a6856[];

static const unsigned char _jc_soot_shimple_internal_analysis_DominatorTree$param_ptypes$fetchParent$6b55e389762a6856[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_soot_shimple_internal_analysis_DominatorTree$param_types$fetchParent$6b55e389762a6856[] = {
	&_jc_soot_toolkits_graph_Block$type
};

_jc_method _jc_soot_shimple_internal_analysis_DominatorTree$method_info$fetchParent$6b55e389762a6856 = {
	.name=			"fetchParent",
	.signature=		"(Lsoot/toolkits/graph/Block;)Lsoot/shimple/internal/analysis/DominatorNode;",
	.class=			&_jc_soot_shimple_internal_analysis_DominatorTree$type,
	.param_types=		&_jc_soot_shimple_internal_analysis_DominatorTree$param_types$fetchParent$6b55e389762a6856,
	.return_type=		&_jc_soot_shimple_internal_analysis_DominatorNode$type,
	.param_ptypes=		&_jc_soot_shimple_internal_analysis_DominatorTree$param_ptypes$fetchParent$6b55e389762a6856,
	.signature_hash=	_JC_JLONG(0x6b55e389762a6856),
	.access_flags=		_JC_ACC_PROTECTED,
	.function=		&_jc_soot_shimple_internal_analysis_DominatorTree$method$fetchParent$6b55e389762a6856,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_shimple_internal_analysis_DominatorTree$vtable, soot_shimple_internal_analysis_DominatorTree.fetchParent$6b55e389762a6856) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	16,
	      .table=	_jc_soot_shimple_internal_analysis_DominatorTree$linenum_table$fetchParent$6b55e389762a6856
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_shimple_internal_analysis_DominatorTree, fetchParent$6b55e389762a6856);

_jc_soot_shimple_internal_analysis_DominatorNode$object * _JC_JCNI_ATTR
_jc_soot_shimple_internal_analysis_DominatorTree$method$fetchParent$6b55e389762a6856(_jc_env *const env, _jc_soot_shimple_internal_analysis_DominatorTree$object *this, _jc_soot_toolkits_graph_Block$object *param0)
{
	struct _jc_soot_shimple_internal_analysis_DominatorTree$object *r0;
	struct _jc_soot_toolkits_graph_Block$object *r1;
	struct _jc_java_lang_String$object *r10;
	struct _jc_java_lang_VMThrowable$object *r12;
	struct _jc_object *r2;
	struct _jc_object *r3;
	struct _jc_soot_shimple_internal_analysis_DominatorNode$object *r4;
	struct _jc_soot_toolkits_graph_Block$object *r5;
	struct _jc_soot_toolkits_graph_BlockGraph$object *r6;
	struct _jc_soot_shimple_internal_analysis_DominatorsFinder$object *r7;
	struct _jc_java_lang_Object$object *r8;
	struct _jc_java_lang_RuntimeException$object *r9;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(190);				// 0
	r6 = _JC_REF_FIELD(env, r0, soot_shimple_internal_analysis_DominatorTree, graph);
	r2 = _JC_INVOKE_VIRTUAL(env, soot_toolkits_graph_BlockGraph, getHeads$e2893bcf27fe8f99, r6);
	z0 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0xd3bd70da40f05cb1), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r1);
	if (z0 == 0)
		goto label0;
	_JC_LINE_NUMBER(191);				// 1
	return _JC_NULL;

label0:
	_JC_LINE_NUMBER(193);				// 2
	r7 = _JC_REF_FIELD(env, r0, soot_shimple_internal_analysis_DominatorTree, dominators);
	r2 = _JC_INVOKE_VIRTUAL(env, soot_shimple_internal_analysis_DominatorsFinder, getDominators$7a175d9aece4d06e, r7, r1);
	_JC_LINE_NUMBER(194);				// 3
	r3 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0x3cc91493d50f531c), _jc_object *, (_jc_env *, struct _jc_object *));
	_JC_LINE_NUMBER(195);				// 4
	r4 = _JC_NULL;

label1:
	_JC_LINE_NUMBER(197);				// 5
	if (r4 != _JC_NULL)
		goto label3;
	z0 = _JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0xfb0bd5e38c59ddcd), jboolean, (_jc_env *, struct _jc_object *));
	if (z0 == 0)
		goto label3;
	_JC_LINE_NUMBER(198);				// 6
	r8 = _JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0x5874f79a1cf66ea), _jc_object *, (_jc_env *, struct _jc_object *));
	r5 = _JC_CAST(env, &_jc_soot_toolkits_graph_Block$type, r8);
	_JC_LINE_NUMBER(201);				// 7
	if (r5 != r1)
		goto label2;
	_JC_LINE_NUMBER(202);				// 8
	_JC_PERIODIC_CHECK(env);
	goto label1;

label2:
	_JC_LINE_NUMBER(204);				// 9
	r7 = _JC_REF_FIELD(env, r0, soot_shimple_internal_analysis_DominatorTree, dominators);
	r2 = _JC_INVOKE_VIRTUAL(env, soot_shimple_internal_analysis_DominatorsFinder, getDominators$7a175d9aece4d06e, r7, r1);
	_JC_LINE_NUMBER(205);				// 10
	_JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0xd21babbbb7fafe72), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r1);
	_JC_LINE_NUMBER(207);				// 11
	r7 = _JC_REF_FIELD(env, r0, soot_shimple_internal_analysis_DominatorTree, dominators);
	z0 = _JC_INVOKE_VIRTUAL(env, soot_shimple_internal_analysis_DominatorsFinder, isDominatedByAll$83266715d960591f, r7, r5, r2);
	if (z0 == 0) {
		_JC_PERIODIC_CHECK(env);
		goto label1;
	}
	_JC_LINE_NUMBER(208);				// 12
	r4 = _JC_INVOKE_VIRTUAL(env, soot_shimple_internal_analysis_DominatorTree, fetchNode$7f3811411a7aeec1, r0, r5);
	_JC_PERIODIC_CHECK(env);
	goto label1;

label3:
	_JC_LINE_NUMBER(211);				// 13
	if (r4 != _JC_NULL)
		goto label4;
	_JC_LINE_NUMBER(212);				// 14
	r9 = _JC_NEW(env, java_lang_RuntimeException);
	r10 = _JC_STRING(env, "Assertion failed.");
	_JC_REF_FIELD(env, r9, java_lang_Throwable, cause) = r9;
	r12 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r9);
	_JC_REF_FIELD(env, r9, java_lang_Throwable, vmState) = r12;
	_JC_REF_FIELD(env, r9, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r9, java_lang_Throwable, detailMessage) = r10;
	_JC_THROW(env, r9);

label4:
	_JC_LINE_NUMBER(214);				// 15
	return r4;
}

//
// public soot.toolkits.graph.BlockGraph getGraph()
//

static _jc_linenum _jc_soot_shimple_internal_analysis_DominatorTree$linenum_table$getGraph$de4dabf91036934c[];

static const unsigned char _jc_soot_shimple_internal_analysis_DominatorTree$param_ptypes$getGraph$de4dabf91036934c[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_soot_shimple_internal_analysis_DominatorTree$method_info$getGraph$de4dabf91036934c = {
	.name=			"getGraph",
	.signature=		"()Lsoot/toolkits/graph/BlockGraph;",
	.class=			&_jc_soot_shimple_internal_analysis_DominatorTree$type,
	.return_type=		&_jc_soot_toolkits_graph_BlockGraph$type,
	.param_ptypes=		&_jc_soot_shimple_internal_analysis_DominatorTree$param_ptypes$getGraph$de4dabf91036934c,
	.signature_hash=	_JC_JLONG(0xde4dabf91036934c),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_shimple_internal_analysis_DominatorTree$method$getGraph$de4dabf91036934c,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_shimple_internal_analysis_DominatorTree$vtable, soot_shimple_internal_analysis_DominatorTree.getGraph$de4dabf91036934c) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_soot_shimple_internal_analysis_DominatorTree$linenum_table$getGraph$de4dabf91036934c
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_shimple_internal_analysis_DominatorTree, getGraph$de4dabf91036934c);

_jc_soot_toolkits_graph_BlockGraph$object * _JC_JCNI_ATTR
_jc_soot_shimple_internal_analysis_DominatorTree$method$getGraph$de4dabf91036934c(_jc_env *const env, _jc_soot_shimple_internal_analysis_DominatorTree$object *this)
{
	struct _jc_soot_shimple_internal_analysis_DominatorTree$object *r0;
	struct _jc_soot_toolkits_graph_BlockGraph$object *r1;

	r0 = this;
	_JC_LINE_NUMBER(77);				// 0
	r1 = _JC_REF_FIELD(env, r0, soot_shimple_internal_analysis_DominatorTree, graph);
	return r1;
}

//
// public java.util.List getHeads()
//

static _jc_linenum _jc_soot_shimple_internal_analysis_DominatorTree$linenum_table$getHeads$e2893bcf27fe8f99[];

static const unsigned char _jc_soot_shimple_internal_analysis_DominatorTree$param_ptypes$getHeads$e2893bcf27fe8f99[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_soot_shimple_internal_analysis_DominatorTree$method_info$getHeads$e2893bcf27fe8f99 = {
	.name=			"getHeads",
	.signature=		"()Ljava/util/List;",
	.class=			&_jc_soot_shimple_internal_analysis_DominatorTree$type,
	.return_type=		&_jc_java_util_List$type,
	.param_ptypes=		&_jc_soot_shimple_internal_analysis_DominatorTree$param_ptypes$getHeads$e2893bcf27fe8f99,
	.signature_hash=	_JC_JLONG(0xe2893bcf27fe8f99),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_shimple_internal_analysis_DominatorTree$method$getHeads$e2893bcf27fe8f99,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_shimple_internal_analysis_DominatorTree$vtable, soot_shimple_internal_analysis_DominatorTree.getHeads$e2893bcf27fe8f99) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_soot_shimple_internal_analysis_DominatorTree$linenum_table$getHeads$e2893bcf27fe8f99
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_shimple_internal_analysis_DominatorTree, getHeads$e2893bcf27fe8f99);

_jc_object * _JC_JCNI_ATTR
_jc_soot_shimple_internal_analysis_DominatorTree$method$getHeads$e2893bcf27fe8f99(_jc_env *const env, _jc_soot_shimple_internal_analysis_DominatorTree$object *this)
{
	struct _jc_soot_shimple_internal_analysis_DominatorTree$object *r0;
	struct _jc_java_util_ArrayList$object *r1;
	struct _jc_java_lang_Object$object *r2;
	struct _jc_object *r3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(82);				// 0
	r1 = _JC_REF_FIELD(env, r0, soot_shimple_internal_analysis_DominatorTree, heads);
	r2 = _JC_INVOKE_VIRTUAL(env, java_util_ArrayList, clone$b75f2713d6705f70, r1);
	r3 = _JC_CAST(env, &_jc_java_util_List$type, r2);
	return r3;
}

//
// public java.util.List getPredsOf(java.lang.Object)
//

static _jc_linenum _jc_soot_shimple_internal_analysis_DominatorTree$linenum_table$getPredsOf$1d1efff5d341523f[];

static const unsigned char _jc_soot_shimple_internal_analysis_DominatorTree$param_ptypes$getPredsOf$1d1efff5d341523f[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_soot_shimple_internal_analysis_DominatorTree$param_types$getPredsOf$1d1efff5d341523f[] = {
	&_jc_java_lang_Object$type
};

_jc_method _jc_soot_shimple_internal_analysis_DominatorTree$method_info$getPredsOf$1d1efff5d341523f = {
	.name=			"getPredsOf",
	.signature=		"(Ljava/lang/Object;)Ljava/util/List;",
	.class=			&_jc_soot_shimple_internal_analysis_DominatorTree$type,
	.param_types=		&_jc_soot_shimple_internal_analysis_DominatorTree$param_types$getPredsOf$1d1efff5d341523f,
	.return_type=		&_jc_java_util_List$type,
	.param_ptypes=		&_jc_soot_shimple_internal_analysis_DominatorTree$param_ptypes$getPredsOf$1d1efff5d341523f,
	.signature_hash=	_JC_JLONG(0x1d1efff5d341523f),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_shimple_internal_analysis_DominatorTree$method$getPredsOf$1d1efff5d341523f,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_shimple_internal_analysis_DominatorTree$vtable, soot_shimple_internal_analysis_DominatorTree.getPredsOf$1d1efff5d341523f) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_soot_shimple_internal_analysis_DominatorTree$linenum_table$getPredsOf$1d1efff5d341523f
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_shimple_internal_analysis_DominatorTree, getPredsOf$1d1efff5d341523f);

_jc_object * _JC_JCNI_ATTR
_jc_soot_shimple_internal_analysis_DominatorTree$method$getPredsOf$1d1efff5d341523f(_jc_env *const env, _jc_soot_shimple_internal_analysis_DominatorTree$object *this, _jc_java_lang_Object$object *param0)
{
	struct _jc_soot_shimple_internal_analysis_DominatorTree$object *r0;
	struct _jc_java_lang_Object$object *r1;
	struct _jc_java_util_ArrayList$object *r2;
	struct _jc_soot_shimple_internal_analysis_DominatorNode$object *r3;
	_jc_object_array *r4;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(92);				// 0
	r2 = _JC_NEW(env, java_util_ArrayList);
	r4 = _JC_NEW_REF_ARRAY(env, java_lang_Object, 1, 16);
	_JC_REF_FIELD(env, r2, java_util_ArrayList, data) = r4;
	_JC_LINE_NUMBER(93);				// 1
	r3 = _JC_CAST(env, &_jc_soot_shimple_internal_analysis_DominatorNode$type, r1);
	r3 = _JC_INVOKE_VIRTUAL(env, soot_shimple_internal_analysis_DominatorNode, getParent$ae1a08f58485e1c7, r3);
	_JC_INVOKE_NONVIRTUAL(env, java_util_ArrayList, add$831f06ee5f59c0cc, 0, r2, r3);
	_JC_LINE_NUMBER(95);				// 2
	return r2;
}

//
// public java.util.List getSuccsOf(java.lang.Object)
//

static _jc_linenum _jc_soot_shimple_internal_analysis_DominatorTree$linenum_table$getSuccsOf$51ae3c0a375c9961[];

static const unsigned char _jc_soot_shimple_internal_analysis_DominatorTree$param_ptypes$getSuccsOf$51ae3c0a375c9961[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_soot_shimple_internal_analysis_DominatorTree$param_types$getSuccsOf$51ae3c0a375c9961[] = {
	&_jc_java_lang_Object$type
};

_jc_method _jc_soot_shimple_internal_analysis_DominatorTree$method_info$getSuccsOf$51ae3c0a375c9961 = {
	.name=			"getSuccsOf",
	.signature=		"(Ljava/lang/Object;)Ljava/util/List;",
	.class=			&_jc_soot_shimple_internal_analysis_DominatorTree$type,
	.param_types=		&_jc_soot_shimple_internal_analysis_DominatorTree$param_types$getSuccsOf$51ae3c0a375c9961,
	.return_type=		&_jc_java_util_List$type,
	.param_ptypes=		&_jc_soot_shimple_internal_analysis_DominatorTree$param_ptypes$getSuccsOf$51ae3c0a375c9961,
	.signature_hash=	_JC_JLONG(0x51ae3c0a375c9961),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_shimple_internal_analysis_DominatorTree$method$getSuccsOf$51ae3c0a375c9961,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_shimple_internal_analysis_DominatorTree$vtable, soot_shimple_internal_analysis_DominatorTree.getSuccsOf$51ae3c0a375c9961) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_soot_shimple_internal_analysis_DominatorTree$linenum_table$getSuccsOf$51ae3c0a375c9961
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_shimple_internal_analysis_DominatorTree, getSuccsOf$51ae3c0a375c9961);

_jc_object * _JC_JCNI_ATTR
_jc_soot_shimple_internal_analysis_DominatorTree$method$getSuccsOf$51ae3c0a375c9961(_jc_env *const env, _jc_soot_shimple_internal_analysis_DominatorTree$object *this, _jc_java_lang_Object$object *param0)
{
	struct _jc_soot_shimple_internal_analysis_DominatorTree$object *r0;
	struct _jc_java_lang_Object$object *r1;
	struct _jc_soot_shimple_internal_analysis_DominatorNode$object *r2;
	struct _jc_object *r3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(100);				// 0
	r2 = _JC_CAST(env, &_jc_soot_shimple_internal_analysis_DominatorNode$type, r1);
	r3 = _JC_INVOKE_VIRTUAL(env, soot_shimple_internal_analysis_DominatorNode, getChildren$597e59fdd9c40f40, r2);
	return r3;
}

//
// public java.util.List getTails()
//

static _jc_linenum _jc_soot_shimple_internal_analysis_DominatorTree$linenum_table$getTails$a9060bae945c433f[];

static const unsigned char _jc_soot_shimple_internal_analysis_DominatorTree$param_ptypes$getTails$a9060bae945c433f[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_soot_shimple_internal_analysis_DominatorTree$method_info$getTails$a9060bae945c433f = {
	.name=			"getTails",
	.signature=		"()Ljava/util/List;",
	.class=			&_jc_soot_shimple_internal_analysis_DominatorTree$type,
	.return_type=		&_jc_java_util_List$type,
	.param_ptypes=		&_jc_soot_shimple_internal_analysis_DominatorTree$param_ptypes$getTails$a9060bae945c433f,
	.signature_hash=	_JC_JLONG(0xa9060bae945c433f),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_shimple_internal_analysis_DominatorTree$method$getTails$a9060bae945c433f,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_shimple_internal_analysis_DominatorTree$vtable, soot_shimple_internal_analysis_DominatorTree.getTails$a9060bae945c433f) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_soot_shimple_internal_analysis_DominatorTree$linenum_table$getTails$a9060bae945c433f
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_shimple_internal_analysis_DominatorTree, getTails$a9060bae945c433f);

_jc_object * _JC_JCNI_ATTR
_jc_soot_shimple_internal_analysis_DominatorTree$method$getTails$a9060bae945c433f(_jc_env *const env, _jc_soot_shimple_internal_analysis_DominatorTree$object *this)
{
	struct _jc_soot_shimple_internal_analysis_DominatorTree$object *r0;
	struct _jc_java_util_ArrayList$object *r1;
	struct _jc_java_lang_Object$object *r2;
	struct _jc_object *r3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(87);				// 0
	r1 = _JC_REF_FIELD(env, r0, soot_shimple_internal_analysis_DominatorTree, tails);
	r2 = _JC_INVOKE_VIRTUAL(env, java_util_ArrayList, clone$b75f2713d6705f70, r1);
	r3 = _JC_CAST(env, &_jc_java_util_List$type, r2);
	return r3;
}

//
// public java.util.Iterator iterator()
//

static _jc_linenum _jc_soot_shimple_internal_analysis_DominatorTree$linenum_table$iterator$3cc91493d50f531c[];

static const unsigned char _jc_soot_shimple_internal_analysis_DominatorTree$param_ptypes$iterator$3cc91493d50f531c[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_soot_shimple_internal_analysis_DominatorTree$method_info$iterator$3cc91493d50f531c = {
	.name=			"iterator",
	.signature=		"()Ljava/util/Iterator;",
	.class=			&_jc_soot_shimple_internal_analysis_DominatorTree$type,
	.return_type=		&_jc_java_util_Iterator$type,
	.param_ptypes=		&_jc_soot_shimple_internal_analysis_DominatorTree$param_ptypes$iterator$3cc91493d50f531c,
	.signature_hash=	_JC_JLONG(0x3cc91493d50f531c),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_shimple_internal_analysis_DominatorTree$method$iterator$3cc91493d50f531c,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_shimple_internal_analysis_DominatorTree$vtable, soot_shimple_internal_analysis_DominatorTree.iterator$3cc91493d50f531c) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_soot_shimple_internal_analysis_DominatorTree$linenum_table$iterator$3cc91493d50f531c
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_shimple_internal_analysis_DominatorTree, iterator$3cc91493d50f531c);

_jc_object * _JC_JCNI_ATTR
_jc_soot_shimple_internal_analysis_DominatorTree$method$iterator$3cc91493d50f531c(_jc_env *const env, _jc_soot_shimple_internal_analysis_DominatorTree$object *this)
{
	struct _jc_soot_shimple_internal_analysis_DominatorTree$object *r0;
	struct _jc_java_util_HashMap$object *r1;
	struct _jc_object *r2;
	struct _jc_object *r3;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(105);				// 0
	r1 = _JC_REF_FIELD(env, r0, soot_shimple_internal_analysis_DominatorTree, blockToNode);
	r2 = _JC_INVOKE_VIRTUAL(env, java_util_HashMap, values$ff2f8ae502eccb46, r1);
	r3 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0x3cc91493d50f531c), _jc_object *, (_jc_env *, struct _jc_object *));
	return r3;
}

//
// public int size()
//

static _jc_linenum _jc_soot_shimple_internal_analysis_DominatorTree$linenum_table$size$345df5220fc60ade[];

static const unsigned char _jc_soot_shimple_internal_analysis_DominatorTree$param_ptypes$size$345df5220fc60ade[] = { 
_JC_TYPE_INT };

_jc_method _jc_soot_shimple_internal_analysis_DominatorTree$method_info$size$345df5220fc60ade = {
	.name=			"size",
	.signature=		"()I",
	.class=			&_jc_soot_shimple_internal_analysis_DominatorTree$type,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_soot_shimple_internal_analysis_DominatorTree$param_ptypes$size$345df5220fc60ade,
	.signature_hash=	_JC_JLONG(0x345df5220fc60ade),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_shimple_internal_analysis_DominatorTree$method$size$345df5220fc60ade,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_shimple_internal_analysis_DominatorTree$vtable, soot_shimple_internal_analysis_DominatorTree.size$345df5220fc60ade) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_soot_shimple_internal_analysis_DominatorTree$linenum_table$size$345df5220fc60ade
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_shimple_internal_analysis_DominatorTree, size$345df5220fc60ade);

jint _JC_JCNI_ATTR
_jc_soot_shimple_internal_analysis_DominatorTree$method$size$345df5220fc60ade(_jc_env *const env, _jc_soot_shimple_internal_analysis_DominatorTree$object *this)
{
	jint i0;
	struct _jc_soot_shimple_internal_analysis_DominatorTree$object *r0;
	struct _jc_java_util_HashMap$object *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_LINE_NUMBER(110);				// 0
	r1 = _JC_REF_FIELD(env, r0, soot_shimple_internal_analysis_DominatorTree, blockToNode);
	i0 = _JC_INVOKE_VIRTUAL(env, java_util_HashMap, size$345df5220fc60ade, r1);
	return i0;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_soot_shimple_internal_analysis_DominatorTree$methods[] = {
	&_jc_soot_shimple_internal_analysis_DominatorTree$method_info$_init$6d442eef553ff081,
	&_jc_soot_shimple_internal_analysis_DominatorTree$method_info$_init$33c8d16cb6714abf,
	&_jc_soot_shimple_internal_analysis_DominatorTree$method_info$buildFrontier$5d52140f63810cc1,
	&_jc_soot_shimple_internal_analysis_DominatorTree$method_info$buildTree$61dc0404bc002a9e,
	&_jc_soot_shimple_internal_analysis_DominatorTree$method_info$fetchNode$7f3811411a7aeec1,
	&_jc_soot_shimple_internal_analysis_DominatorTree$method_info$fetchParent$6b55e389762a6856,
	&_jc_soot_shimple_internal_analysis_DominatorTree$method_info$getGraph$de4dabf91036934c,
	&_jc_soot_shimple_internal_analysis_DominatorTree$method_info$getHeads$e2893bcf27fe8f99,
	&_jc_soot_shimple_internal_analysis_DominatorTree$method_info$getPredsOf$1d1efff5d341523f,
	&_jc_soot_shimple_internal_analysis_DominatorTree$method_info$getSuccsOf$51ae3c0a375c9961,
	&_jc_soot_shimple_internal_analysis_DominatorTree$method_info$getTails$a9060bae945c433f,
	&_jc_soot_shimple_internal_analysis_DominatorTree$method_info$iterator$3cc91493d50f531c,
	&_jc_soot_shimple_internal_analysis_DominatorTree$method_info$size$345df5220fc60ade
};

/************************************************************************
 *			      Interface list				*
 ************************************************************************/

// Directly implemented interfaces
static _jc_type *const _jc_soot_shimple_internal_analysis_DominatorTree$interfaces[] = {
	&_jc_soot_toolkits_graph_DirectedGraph$type
};

/************************************************************************
 *			   Interface hash table				*
 ************************************************************************/

#if _JC_IMETHOD_HASHSIZE != 128
#error "_JC_IMETHOD_HASHSIZE has the wrong value (should be 128)"
#endif

// Interface lookup hash table buckets
static _jc_method *_jc_soot_shimple_internal_analysis_DominatorTree$imethod_hash_bucket_25[] = {
	&_jc_soot_shimple_internal_analysis_DominatorTree$method_info$getHeads$e2893bcf27fe8f99,
	_JC_NULL
};
static _jc_method *_jc_soot_shimple_internal_analysis_DominatorTree$imethod_hash_bucket_28[] = {
	&_jc_soot_shimple_internal_analysis_DominatorTree$method_info$iterator$3cc91493d50f531c,
	_JC_NULL
};
static _jc_method *_jc_soot_shimple_internal_analysis_DominatorTree$imethod_hash_bucket_63[] = {
	&_jc_soot_shimple_internal_analysis_DominatorTree$method_info$getPredsOf$1d1efff5d341523f,
	&_jc_soot_shimple_internal_analysis_DominatorTree$method_info$getTails$a9060bae945c433f,
	_JC_NULL
};
static _jc_method *_jc_soot_shimple_internal_analysis_DominatorTree$imethod_hash_bucket_94[] = {
	&_jc_soot_shimple_internal_analysis_DominatorTree$method_info$size$345df5220fc60ade,
	_JC_NULL
};
static _jc_method *_jc_soot_shimple_internal_analysis_DominatorTree$imethod_hash_bucket_97[] = {
	&_jc_soot_shimple_internal_analysis_DominatorTree$method_info$getSuccsOf$51ae3c0a375c9961,
	_JC_NULL
};

// Interface lookup hash table
static _jc_method **_jc_soot_shimple_internal_analysis_DominatorTree$imethod_hash_table[_JC_IMETHOD_HASHSIZE] = {
	[25]=	_jc_soot_shimple_internal_analysis_DominatorTree$imethod_hash_bucket_25,
	[28]=	_jc_soot_shimple_internal_analysis_DominatorTree$imethod_hash_bucket_28,
	[63]=	_jc_soot_shimple_internal_analysis_DominatorTree$imethod_hash_bucket_63,
	[94]=	_jc_soot_shimple_internal_analysis_DominatorTree$imethod_hash_bucket_94,
	[97]=	_jc_soot_shimple_internal_analysis_DominatorTree$imethod_hash_bucket_97
};

// Interface "quick" lookup hash table
static const void *_jc_soot_shimple_internal_analysis_DominatorTree$imethod_quick_table[_JC_IMETHOD_HASHSIZE] = {
	[25]=	&_jc_soot_shimple_internal_analysis_DominatorTree$method$getHeads$e2893bcf27fe8f99,
	[28]=	&_jc_soot_shimple_internal_analysis_DominatorTree$method$iterator$3cc91493d50f531c,
	[94]=	&_jc_soot_shimple_internal_analysis_DominatorTree$method$size$345df5220fc60ade,
	[97]=	&_jc_soot_shimple_internal_analysis_DominatorTree$method$getSuccsOf$51ae3c0a375c9961
};

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_soot_shimple_internal_analysis_DominatorTree$instanceof_hash_bucket_46[] = {
	&_jc_soot_shimple_internal_analysis_DominatorTree$type,
	_JC_NULL
};
static _jc_type *const _jc_soot_shimple_internal_analysis_DominatorTree$instanceof_hash_bucket_81[] = {
	&_jc_soot_toolkits_graph_DirectedGraph$type,
	_JC_NULL
};
static _jc_type *const _jc_soot_shimple_internal_analysis_DominatorTree$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_soot_shimple_internal_analysis_DominatorTree$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[46]=	_jc_soot_shimple_internal_analysis_DominatorTree$instanceof_hash_bucket_46,
	[81]=	_jc_soot_shimple_internal_analysis_DominatorTree$instanceof_hash_bucket_81,
	[101]=	_jc_soot_shimple_internal_analysis_DominatorTree$instanceof_hash_bucket_101
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_soot_shimple_internal_analysis_DominatorTree$class_depends[] = {
	{ "java/io/PrintStream",	_JC_JLONG(0x99a46305ebacacb5) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/RuntimeException",	_JC_JLONG(0x4f5534a987354d1d) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/StringBuffer",	_JC_JLONG(0x94d357637b968dda) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/util/AbstractCollection",	_JC_JLONG(0x8ea716c64b77f8eb) },
	{ "java/util/AbstractList",	_JC_JLONG(0xf5238436362828db) },
	{ "java/util/ArrayList",	_JC_JLONG(0x58038509830ef3f4) },
	{ "java/util/Collection",	_JC_JLONG(0xeae4d0c0e8eb63da) },
	{ "java/util/HashMap",	_JC_JLONG(0xd7cd853200c3e71f) },
	{ "java/util/Iterator",	_JC_JLONG(0xbe56ff673eefd9d2) },
	{ "java/util/List",	_JC_JLONG(0x9ee0d92ce1525a4d) },
	{ "soot/Body",	_JC_JLONG(0x6131d54b9700ca5d) },
	{ "soot/G",	_JC_JLONG(0xb6d33af8f84fdbc4) },
	{ "soot/Singletons",	_JC_JLONG(0x6ac5bee50bbabb71) },
	{ "soot/SootMethod",	_JC_JLONG(0xbd11c16680505218) },
	{ "soot/options/Options",	_JC_JLONG(0xc5a5a246a3f59476) },
	{ "soot/shimple/internal/analysis/DominanceFrontier",	_JC_JLONG(0xf1bd878a4874fcce) },
	{ "soot/shimple/internal/analysis/DominatorNode",	_JC_JLONG(0x435307d811e497d8) },
	{ "soot/shimple/internal/analysis/DominatorsFinder",	_JC_JLONG(0xd5d9fd40a0d98b0a) },
	{ "soot/toolkits/graph/Block",	_JC_JLONG(0xb252d9c4153bf27b) },
	{ "soot/toolkits/graph/BlockGraph",	_JC_JLONG(0x340ee84e9e1f189d) },
	{ "soot/toolkits/graph/DirectedGraph",	_JC_JLONG(0x1d20f632cfd945d1) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_soot_shimple_internal_analysis_DominatorTree$vtype _jc_soot_shimple_internal_analysis_DominatorTree$type = {
    .type= {
	.name=			"soot/shimple/internal/analysis/DominatorTree",
	.superclass=		&_jc_java_lang_Object$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.num_interfaces=sizeof(_jc_soot_shimple_internal_analysis_DominatorTree$interfaces) / sizeof(*_jc_soot_shimple_internal_analysis_DominatorTree$interfaces),
	.interfaces=		_jc_soot_shimple_internal_analysis_DominatorTree$interfaces,
	.imethod_hash_table=	_jc_soot_shimple_internal_analysis_DominatorTree$imethod_hash_table,
	.imethod_quick_table=	_jc_soot_shimple_internal_analysis_DominatorTree$imethod_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		22,
		.hash=			_JC_JLONG(0xb0e8c3835eb9bdae),
		.source_file=		"DominatorTree.java",
		.instance_size=		sizeof(_jc_soot_shimple_internal_analysis_DominatorTree$refs) + sizeof(_jc_soot_shimple_internal_analysis_DominatorTree$object),
		.num_virtual_refs=	5,
		.num_fields=		sizeof(_jc_soot_shimple_internal_analysis_DominatorTree$fields) / sizeof(*_jc_soot_shimple_internal_analysis_DominatorTree$fields),
		.fields=		_jc_soot_shimple_internal_analysis_DominatorTree$fields,
		.num_methods=		sizeof(_jc_soot_shimple_internal_analysis_DominatorTree$methods) / sizeof(*_jc_soot_shimple_internal_analysis_DominatorTree$methods),
		.methods=		_jc_soot_shimple_internal_analysis_DominatorTree$methods,
		.instanceof_hash_table=	_jc_soot_shimple_internal_analysis_DominatorTree$instanceof_hash_table,
		.num_class_depends=		sizeof(_jc_soot_shimple_internal_analysis_DominatorTree$class_depends) / sizeof(*_jc_soot_shimple_internal_analysis_DominatorTree$class_depends),
		.class_depends=		_jc_soot_shimple_internal_analysis_DominatorTree$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.soot_shimple_internal_analysis_DominatorTree= {
	    .buildFrontier$5d52140f63810cc1=
		&_jc_soot_shimple_internal_analysis_DominatorTree$method$buildFrontier$5d52140f63810cc1,
	    .buildTree$61dc0404bc002a9e=
		&_jc_soot_shimple_internal_analysis_DominatorTree$method$buildTree$61dc0404bc002a9e,
	    .fetchNode$7f3811411a7aeec1=
		&_jc_soot_shimple_internal_analysis_DominatorTree$method$fetchNode$7f3811411a7aeec1,
	    .fetchParent$6b55e389762a6856=
		&_jc_soot_shimple_internal_analysis_DominatorTree$method$fetchParent$6b55e389762a6856,
	    .getGraph$de4dabf91036934c=
		&_jc_soot_shimple_internal_analysis_DominatorTree$method$getGraph$de4dabf91036934c,
	    .getHeads$e2893bcf27fe8f99=
		&_jc_soot_shimple_internal_analysis_DominatorTree$method$getHeads$e2893bcf27fe8f99,
	    .getPredsOf$1d1efff5d341523f=
		&_jc_soot_shimple_internal_analysis_DominatorTree$method$getPredsOf$1d1efff5d341523f,
	    .getSuccsOf$51ae3c0a375c9961=
		&_jc_soot_shimple_internal_analysis_DominatorTree$method$getSuccsOf$51ae3c0a375c9961,
	    .getTails$a9060bae945c433f=
		&_jc_soot_shimple_internal_analysis_DominatorTree$method$getTails$a9060bae945c433f,
	    .iterator$3cc91493d50f531c=
		&_jc_soot_shimple_internal_analysis_DominatorTree$method$iterator$3cc91493d50f531c,
	    .size$345df5220fc60ade=
		&_jc_soot_shimple_internal_analysis_DominatorTree$method$size$345df5220fc60ade,
	},
    }
};

