// public class soot.tools.CFGViewer

// class file dependencies
// @dep_class 99a46305ebacacb5 java_io_PrintStream
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class 9c4f2f07f71cb134 java_lang_Double
// @dep_class ca631501391a31f1 java_lang_Integer
// @dep_class 9cd7252f79299280 java_lang_Number
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 94d357637b968dda java_lang_StringBuffer
// @dep_class 43adbb439e3f2be3 java_lang_VMDouble
// @dep_class 576421c2c18f78c4 java_util_Hashtable
// @dep_class be56ff673eefd9d2 java_util_Iterator
// @dep_class 9ee0d92ce1525a4d java_util_List
// @dep_class 617ac82c0bec2dff java_util_Set
// @dep_class 6131d54b9700ca5d soot_Body
// @dep_class b6d33af8f84fdbc4 soot_G
// @dep_class 7120c8047949f8c0 soot_Scene
// @dep_class 6ac5bee50bbabb71 soot_Singletons
// @dep_class 634bd13ff2d8ac70 soot_SootClass
// @dep_class bd11c16680505218 soot_SootMethod
// @dep_class 167d99cb511db03a soot_shimple_Shimple
// @dep_class 6038dc4777a2c906 soot_shimple_ShimpleBody
// @dep_class 340ee84e9e1f189d soot_toolkits_graph_BlockGraph
// @dep_class 1d20f632cfd945d1 soot_toolkits_graph_DirectedGraph
// @dep_class 91abf680ebee56a3 soot_toolkits_graph_UnitGraph
// @dep_class b804c6411dc35cf2 soot_tools_CFGViewer
// @dep_class 7f783bb998510b3d soot_util_dot_DotGraph
// @dep_class 28f908b461b109d0 soot_util_dot_DotGraphAttribute
// @dep_class 71029e81ee1c3f7e soot_util_dot_DotGraphEdge
// @dep_class a2e76a2eb2c5cf4 soot_util_dot_DotGraphNode
// @dep_class af4bddab63ed936d soot_util_dot_DotGraphUtility

// header file dependencies
// @dep_header java_io_PrintStream
// @dep_header java_lang_Class
// @dep_header java_lang_Double
// @dep_header java_lang_Integer
// @dep_header java_lang_String
// @dep_header java_lang_StringBuffer
// @dep_header java_lang_VMDouble
// @dep_header java_util_Hashtable
// @dep_header java_util_Iterator
// @dep_header java_util_List
// @dep_header java_util_Set
// @dep_header soot_G
// @dep_header soot_Scene
// @dep_header soot_SootClass
// @dep_header soot_SootMethod
// @dep_header soot_shimple_Shimple
// @dep_header soot_shimple_ShimpleBody
// @dep_header soot_toolkits_graph_BlockGraph
// @dep_header soot_toolkits_graph_DirectedGraph
// @dep_header soot_toolkits_graph_UnitGraph
// @dep_header soot_tools_CFGViewer
// @dep_header soot_util_dot_DotGraph
// @dep_header soot_util_dot_DotGraphAttribute
// @dep_header soot_util_dot_DotGraphEdge
// @dep_header soot_util_dot_DotGraphNode
// @dep_header soot_util_dot_DotGraphUtility

#include "jc_defs.h"

#include "java/io/PrintStream.h"
#include "java/lang/Class.h"
#include "java/lang/Double.h"
#include "java/lang/Integer.h"
#include "java/lang/String.h"
#include "java/lang/StringBuffer.h"
#include "java/lang/VMDouble.h"
#include "java/util/Hashtable.h"
#include "java/util/Iterator.h"
#include "java/util/List.h"
#include "java/util/Set.h"
#include "soot/G.h"
#include "soot/Scene.h"
#include "soot/SootClass.h"
#include "soot/SootMethod.h"
#include "soot/shimple/Shimple.h"
#include "soot/shimple/ShimpleBody.h"
#include "soot/toolkits/graph/BlockGraph.h"
#include "soot/toolkits/graph/DirectedGraph.h"
#include "soot/toolkits/graph/UnitGraph.h"
#include "soot/tools/CFGViewer.h"
#include "soot/util/dot/DotGraph.h"
#include "soot/util/dot/DotGraphAttribute.h"
#include "soot/util/dot/DotGraphEdge.h"
#include "soot/util/dot/DotGraphNode.h"
#include "soot/util/dot/DotGraphUtility.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// public static final int UNITGRAPH
static const jint _jc_soot_tools_CFGViewer$initial_value$UNITGRAPH = 0;
static _jc_field _jc_soot_tools_CFGViewer$field_info$UNITGRAPH = {
	.name=		"UNITGRAPH",
	.signature=	"I",
	.class=		&_jc_soot_tools_CFGViewer$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PUBLIC|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_soot_tools_CFGViewer$fields_struct, UNITGRAPH),
	.initial_value=	&_jc_soot_tools_CFGViewer$initial_value$UNITGRAPH,
};

// public static final int BLOCKGRAPH
static const jint _jc_soot_tools_CFGViewer$initial_value$BLOCKGRAPH = 1;
static _jc_field _jc_soot_tools_CFGViewer$field_info$BLOCKGRAPH = {
	.name=		"BLOCKGRAPH",
	.signature=	"I",
	.class=		&_jc_soot_tools_CFGViewer$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PUBLIC|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_soot_tools_CFGViewer$fields_struct, BLOCKGRAPH),
	.initial_value=	&_jc_soot_tools_CFGViewer$initial_value$BLOCKGRAPH,
};

// public static final int ARRAYBLOCK
static const jint _jc_soot_tools_CFGViewer$initial_value$ARRAYBLOCK = 2;
static _jc_field _jc_soot_tools_CFGViewer$field_info$ARRAYBLOCK = {
	.name=		"ARRAYBLOCK",
	.signature=	"I",
	.class=		&_jc_soot_tools_CFGViewer$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PUBLIC|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_soot_tools_CFGViewer$fields_struct, ARRAYBLOCK),
	.initial_value=	&_jc_soot_tools_CFGViewer$initial_value$ARRAYBLOCK,
};

// public int graphtype
static _jc_field _jc_soot_tools_CFGViewer$field_info$graphtype = {
	.name=		"graphtype",
	.signature=	"I",
	.class=		&_jc_soot_tools_CFGViewer$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PUBLIC,
	.offset=	_JC_OFFSETOF(_jc_soot_tools_CFGViewer$object, nonrefs.soot_tools_CFGViewer.graphtype),
};

// public java.lang.String clsname
static _jc_field _jc_soot_tools_CFGViewer$field_info$clsname = {
	.name=		"clsname",
	.signature=	"Ljava/lang/String;",
	.class=		&_jc_soot_tools_CFGViewer$type,
	.type=		&_jc_java_lang_String$type,
	.access_flags=	_JC_ACC_PUBLIC,
	.offset=	_JC_OFFSETOF(_jc_soot_tools_CFGViewer$object, refs[-1].soot_tools_CFGViewer.clsname),
};

// public java.lang.String methname
static _jc_field _jc_soot_tools_CFGViewer$field_info$methname = {
	.name=		"methname",
	.signature=	"Ljava/lang/String;",
	.class=		&_jc_soot_tools_CFGViewer$type,
	.type=		&_jc_java_lang_String$type,
	.access_flags=	_JC_ACC_PUBLIC,
	.offset=	_JC_OFFSETOF(_jc_soot_tools_CFGViewer$object, refs[-1].soot_tools_CFGViewer.methname),
};

// public boolean isBrief
static _jc_field _jc_soot_tools_CFGViewer$field_info$isBrief = {
	.name=		"isBrief",
	.signature=	"Z",
	.class=		&_jc_soot_tools_CFGViewer$type,
	.type=		&_jc_boolean$prim$type,
	.access_flags=	_JC_ACC_PUBLIC,
	.offset=	_JC_OFFSETOF(_jc_soot_tools_CFGViewer$object, nonrefs.soot_tools_CFGViewer.isBrief),
};

// private int meth_count
static _jc_field _jc_soot_tools_CFGViewer$field_info$meth__5fcount = {
	.name=		"meth_count",
	.signature=	"I",
	.class=		&_jc_soot_tools_CFGViewer$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_soot_tools_CFGViewer$object, nonrefs.soot_tools_CFGViewer.meth__5fcount),
};

// public boolean onepage
static _jc_field _jc_soot_tools_CFGViewer$field_info$onepage = {
	.name=		"onepage",
	.signature=	"Z",
	.class=		&_jc_soot_tools_CFGViewer$type,
	.type=		&_jc_boolean$prim$type,
	.access_flags=	_JC_ACC_PUBLIC,
	.offset=	_JC_OFFSETOF(_jc_soot_tools_CFGViewer$object, nonrefs.soot_tools_CFGViewer.onepage),
};

// public static boolean shimple
static _jc_field _jc_soot_tools_CFGViewer$field_info$shimple = {
	.name=		"shimple",
	.signature=	"Z",
	.class=		&_jc_soot_tools_CFGViewer$type,
	.type=		&_jc_boolean$prim$type,
	.access_flags=	_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.offset=	_JC_OFFSETOF(_jc_soot_tools_CFGViewer$fields_struct, shimple),
};

// public static boolean viaShimple
static _jc_field _jc_soot_tools_CFGViewer$field_info$viaShimple = {
	.name=		"viaShimple",
	.signature=	"Z",
	.class=		&_jc_soot_tools_CFGViewer$type,
	.type=		&_jc_boolean$prim$type,
	.access_flags=	_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.offset=	_JC_OFFSETOF(_jc_soot_tools_CFGViewer$fields_struct, viaShimple),
};

// public static boolean complete
static _jc_field _jc_soot_tools_CFGViewer$field_info$complete = {
	.name=		"complete",
	.signature=	"Z",
	.class=		&_jc_soot_tools_CFGViewer$type,
	.type=		&_jc_boolean$prim$type,
	.access_flags=	_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.offset=	_JC_OFFSETOF(_jc_soot_tools_CFGViewer$fields_struct, complete),
};

// private int nodecount
static _jc_field _jc_soot_tools_CFGViewer$field_info$nodecount = {
	.name=		"nodecount",
	.signature=	"I",
	.class=		&_jc_soot_tools_CFGViewer$type,
	.type=		&_jc_int$prim$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_soot_tools_CFGViewer$object, nonrefs.soot_tools_CFGViewer.nodecount),
};

// Fields
static _jc_field *const _jc_soot_tools_CFGViewer$fields[] = {
	&_jc_soot_tools_CFGViewer$field_info$ARRAYBLOCK,
	&_jc_soot_tools_CFGViewer$field_info$BLOCKGRAPH,
	&_jc_soot_tools_CFGViewer$field_info$UNITGRAPH,
	&_jc_soot_tools_CFGViewer$field_info$complete,
	&_jc_soot_tools_CFGViewer$field_info$shimple,
	&_jc_soot_tools_CFGViewer$field_info$viaShimple,
	&_jc_soot_tools_CFGViewer$field_info$clsname,
	&_jc_soot_tools_CFGViewer$field_info$methname,
	&_jc_soot_tools_CFGViewer$field_info$graphtype,
	&_jc_soot_tools_CFGViewer$field_info$meth__5fcount,
	&_jc_soot_tools_CFGViewer$field_info$nodecount,
	&_jc_soot_tools_CFGViewer$field_info$isBrief,
	&_jc_soot_tools_CFGViewer$field_info$onepage
};

/************************************************************************
 *			      Static methods				*
 ************************************************************************/

//
// static void <clinit>()
//

static _jc_linenum _jc_soot_tools_CFGViewer$linenum_table$_clinit$a816641e0ba8bfef[];

static const unsigned char _jc_soot_tools_CFGViewer$param_ptypes$_clinit$a816641e0ba8bfef[] = { 
_JC_TYPE_VOID };

_jc_method _jc_soot_tools_CFGViewer$method_info$_clinit$a816641e0ba8bfef = {
	.name=			"<clinit>",
	.signature=		"()V",
	.class=			&_jc_soot_tools_CFGViewer$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_soot_tools_CFGViewer$param_ptypes$_clinit$a816641e0ba8bfef,
	.signature_hash=	_JC_JLONG(0xa816641e0ba8bfef),
	.access_flags=		_JC_ACC_STATIC,
	.function=		&_jc_soot_tools_CFGViewer$method$_clinit$a816641e0ba8bfef,
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_soot_tools_CFGViewer$linenum_table$_clinit$a816641e0ba8bfef
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_tools_CFGViewer, _clinit$a816641e0ba8bfef);

void _JC_JCNI_ATTR
_jc_soot_tools_CFGViewer$method$_clinit$a816641e0ba8bfef(_jc_env *const env)
{
	_JC_LINE_NUMBER(63);				// 0
	_JC_STATIC_FIELD(env, soot_tools_CFGViewer, shimple, 1) = 0;
	_JC_LINE_NUMBER(65);				// 1
	_JC_STATIC_FIELD(env, soot_tools_CFGViewer, viaShimple, 1) = 0;
	_JC_LINE_NUMBER(68);				// 2
	_JC_STATIC_FIELD(env, soot_tools_CFGViewer, complete, 1) = 0;
	return;
}

//
// public static void main(java.lang.String[])
//

static _jc_linenum _jc_soot_tools_CFGViewer$linenum_table$main$bc98a92695db8a73[];

static const unsigned char _jc_soot_tools_CFGViewer$param_ptypes$main$bc98a92695db8a73[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_soot_tools_CFGViewer$param_types$main$bc98a92695db8a73[] = {
	&_jc_java_lang_String$array$type
};

_jc_method _jc_soot_tools_CFGViewer$method_info$main$bc98a92695db8a73 = {
	.name=			"main",
	.signature=		"([Ljava/lang/String;)V",
	.class=			&_jc_soot_tools_CFGViewer$type,
	.param_types=		&_jc_soot_tools_CFGViewer$param_types$main$bc98a92695db8a73,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_soot_tools_CFGViewer$param_ptypes$main$bc98a92695db8a73,
	.signature_hash=	_JC_JLONG(0xbc98a92695db8a73),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_soot_tools_CFGViewer$method$main$bc98a92695db8a73,
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_soot_tools_CFGViewer$linenum_table$main$bc98a92695db8a73
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_tools_CFGViewer, main$bc98a92695db8a73);

void _JC_JCNI_ATTR
_jc_soot_tools_CFGViewer$method$main$bc98a92695db8a73(_jc_env *const env, _jc_object_array *param0)
{
	_jc_object_array *r0;
	struct _jc_soot_tools_CFGViewer$object *r1;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = param0;
	_JC_LINE_NUMBER(72);				// 0
	r1 = _JC_NEW(env, soot_tools_CFGViewer);
	_JC_PRIM_FIELD(env, r1, soot_tools_CFGViewer, graphtype) = 0;
	_JC_PRIM_FIELD(env, r1, soot_tools_CFGViewer, isBrief) = 0;
	_JC_PRIM_FIELD(env, r1, soot_tools_CFGViewer, meth__5fcount) = 0;
	_JC_PRIM_FIELD(env, r1, soot_tools_CFGViewer, onepage) = 1;
	_JC_PRIM_FIELD(env, r1, soot_tools_CFGViewer, nodecount) = 0;
	_JC_INVOKE_NONVIRTUAL(env, soot_tools_CFGViewer, run$e3a65dc5d69f6eeb, 0, r1, r0);
	_JC_LINE_NUMBER(73);				// 1
	return;
}

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// public void <init>()
//

static _jc_linenum _jc_soot_tools_CFGViewer$linenum_table$_init$52f4ad9f2989aeee[];

static const unsigned char _jc_soot_tools_CFGViewer$param_ptypes$_init$52f4ad9f2989aeee[] = { 
_JC_TYPE_VOID };

_jc_method _jc_soot_tools_CFGViewer$method_info$_init$52f4ad9f2989aeee = {
	.name=			"<init>",
	.signature=		"()V",
	.class=			&_jc_soot_tools_CFGViewer$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_soot_tools_CFGViewer$param_ptypes$_init$52f4ad9f2989aeee,
	.signature_hash=	_JC_JLONG(0x52f4ad9f2989aeee),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_tools_CFGViewer$method$_init$52f4ad9f2989aeee,
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_soot_tools_CFGViewer$linenum_table$_init$52f4ad9f2989aeee
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_tools_CFGViewer, _init$52f4ad9f2989aeee);

void _JC_JCNI_ATTR
_jc_soot_tools_CFGViewer$method$_init$52f4ad9f2989aeee(_jc_env *const env, _jc_soot_tools_CFGViewer$object *this)
{
	struct _jc_soot_tools_CFGViewer$object *r0;

	r0 = this;
	_JC_LINE_NUMBER(50);				// 0
	_JC_PRIM_FIELD(env, r0, soot_tools_CFGViewer, graphtype) = 0;
	_JC_LINE_NUMBER(55);				// 1
	_JC_PRIM_FIELD(env, r0, soot_tools_CFGViewer, isBrief) = 0;
	_JC_LINE_NUMBER(57);				// 2
	_JC_PRIM_FIELD(env, r0, soot_tools_CFGViewer, meth__5fcount) = 0;
	_JC_LINE_NUMBER(60);				// 3
	_JC_PRIM_FIELD(env, r0, soot_tools_CFGViewer, onepage) = 1;
	_JC_LINE_NUMBER(183);				// 4
	_JC_PRIM_FIELD(env, r0, soot_tools_CFGViewer, nodecount) = 0;
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// private int getNodeOrder(java.util.Hashtable, java.lang.Object)
//

static _jc_linenum _jc_soot_tools_CFGViewer$linenum_table$getNodeOrder$9a2ce70edc5fa440[];

static const unsigned char _jc_soot_tools_CFGViewer$param_ptypes$getNodeOrder$9a2ce70edc5fa440[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_INT };

static _jc_type *const _jc_soot_tools_CFGViewer$param_types$getNodeOrder$9a2ce70edc5fa440[] = {
	&_jc_java_util_Hashtable$type,
	&_jc_java_lang_Object$type
};

_jc_method _jc_soot_tools_CFGViewer$method_info$getNodeOrder$9a2ce70edc5fa440 = {
	.name=			"getNodeOrder",
	.signature=		"(Ljava/util/Hashtable;Ljava/lang/Object;)I",
	.class=			&_jc_soot_tools_CFGViewer$type,
	.param_types=		&_jc_soot_tools_CFGViewer$param_types$getNodeOrder$9a2ce70edc5fa440,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_soot_tools_CFGViewer$param_ptypes$getNodeOrder$9a2ce70edc5fa440,
	.signature_hash=	_JC_JLONG(0x9a2ce70edc5fa440),
	.access_flags=		_JC_ACC_PRIVATE,
	.function=		&_jc_soot_tools_CFGViewer$method$getNodeOrder$9a2ce70edc5fa440,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_tools_CFGViewer$vtable, soot_tools_CFGViewer.getNodeOrder$9a2ce70edc5fa440) / sizeof(void *),
	.num_parameters=	2,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_soot_tools_CFGViewer$linenum_table$getNodeOrder$9a2ce70edc5fa440
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_tools_CFGViewer, getNodeOrder$9a2ce70edc5fa440);

jint _JC_JCNI_ATTR
_jc_soot_tools_CFGViewer$method$getNodeOrder$9a2ce70edc5fa440(_jc_env *const env, _jc_soot_tools_CFGViewer$object *this, _jc_java_util_Hashtable$object *param0, _jc_java_lang_Object$object *param1)
{
	jint i0;
	jint i1;
	jint i2;
	struct _jc_soot_tools_CFGViewer$object *r0;
	struct _jc_java_util_Hashtable$object *r1;
	struct _jc_java_lang_Object$object *r2;
	struct _jc_java_lang_Integer$object *r3;
	struct _jc_java_lang_Object$object *r4;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_LINE_NUMBER(256);				// 0
	r4 = _JC_INVOKE_VIRTUAL(env, java_util_Hashtable, get$b30461fc5ea13399, r1, r2);
	r3 = _JC_CAST_FINAL(env, &_jc_java_lang_Integer$type, r4);
	_JC_LINE_NUMBER(257);				// 1
	if (r3 != _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(258);				// 2
	r3 = _JC_NEW(env, java_lang_Integer);
	i0 = _JC_PRIM_FIELD(env, r0, soot_tools_CFGViewer, nodecount);
	i1 = i0 + 1;
	_JC_PRIM_FIELD(env, r0, soot_tools_CFGViewer, nodecount) = i1;
	_JC_PRIM_FIELD(env, r3, java_lang_Integer, value) = i0;
	_JC_LINE_NUMBER(259);				// 3
	_JC_INVOKE_VIRTUAL(env, java_util_Hashtable, put$3bd1c078a0faa8da, r1, r2, r3);

label0:
	i2 = _JC_PRIM_FIELD(env, r3, java_lang_Integer, value);
	_JC_LINE_NUMBER(261);				// 4
	return i2;
}

//
// private java.lang.String makeNodeName(int)
//

static _jc_linenum _jc_soot_tools_CFGViewer$linenum_table$makeNodeName$721eb6e2a0588e3d[];

static const unsigned char _jc_soot_tools_CFGViewer$param_ptypes$makeNodeName$721eb6e2a0588e3d[] = { 
_JC_TYPE_INT, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_soot_tools_CFGViewer$param_types$makeNodeName$721eb6e2a0588e3d[] = {
	&_jc_int$prim$type
};

_jc_method _jc_soot_tools_CFGViewer$method_info$makeNodeName$721eb6e2a0588e3d = {
	.name=			"makeNodeName",
	.signature=		"(I)Ljava/lang/String;",
	.class=			&_jc_soot_tools_CFGViewer$type,
	.param_types=		&_jc_soot_tools_CFGViewer$param_types$makeNodeName$721eb6e2a0588e3d,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_soot_tools_CFGViewer$param_ptypes$makeNodeName$721eb6e2a0588e3d,
	.signature_hash=	_JC_JLONG(0x721eb6e2a0588e3d),
	.access_flags=		_JC_ACC_PRIVATE,
	.function=		&_jc_soot_tools_CFGViewer$method$makeNodeName$721eb6e2a0588e3d,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_tools_CFGViewer$vtable, soot_tools_CFGViewer.makeNodeName$721eb6e2a0588e3d) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_soot_tools_CFGViewer$linenum_table$makeNodeName$721eb6e2a0588e3d
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_tools_CFGViewer, makeNodeName$721eb6e2a0588e3d);

_jc_java_lang_String$object * _JC_JCNI_ATTR
_jc_soot_tools_CFGViewer$method$makeNodeName$721eb6e2a0588e3d(_jc_env *const env, _jc_soot_tools_CFGViewer$object *this, jint param0)
{
	jint i0;
	struct _jc_soot_tools_CFGViewer$object *r0;
	struct _jc_java_lang_StringBuffer$object *r1;
	struct _jc_java_lang_StringBuffer$object *r2;
	struct _jc_java_lang_String$object *r3;
	struct _jc_java_lang_String$object *r4;
	_jc_char_array *r5;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	i0 = param0;
	_JC_LINE_NUMBER(265);				// 0
	r1 = _JC_NEW(env, java_lang_StringBuffer);
	r5 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r1, java_lang_StringBuffer, value) = r5;
	r1 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r1, _JC_STRING(env, "N"));
	_JC_ACTIVE_USE(env, java_lang_String);
	r3 = _JC_INVOKE_STATIC(env, java_lang_Integer, toString$80d919d12afaaa2b, 0, i0, 10);
	r2 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r1, r3);
	_JC_EXPLICIT_NULL_CHECK(env, r2);
	r4 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r4, r2);
	return r4;
}

//
// private void parse_options(java.lang.String[])
//

static _jc_linenum _jc_soot_tools_CFGViewer$linenum_table$parse__5foptions$a2a3fd2bd75d43fa[];

static const unsigned char _jc_soot_tools_CFGViewer$param_ptypes$parse__5foptions$a2a3fd2bd75d43fa[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_soot_tools_CFGViewer$param_types$parse__5foptions$a2a3fd2bd75d43fa[] = {
	&_jc_java_lang_String$array$type
};

_jc_method _jc_soot_tools_CFGViewer$method_info$parse__5foptions$a2a3fd2bd75d43fa = {
	.name=			"parse_options",
	.signature=		"([Ljava/lang/String;)V",
	.class=			&_jc_soot_tools_CFGViewer$type,
	.param_types=		&_jc_soot_tools_CFGViewer$param_types$parse__5foptions$a2a3fd2bd75d43fa,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_soot_tools_CFGViewer$param_ptypes$parse__5foptions$a2a3fd2bd75d43fa,
	.signature_hash=	_JC_JLONG(0xa2a3fd2bd75d43fa),
	.access_flags=		_JC_ACC_PRIVATE,
	.function=		&_jc_soot_tools_CFGViewer$method$parse__5foptions$a2a3fd2bd75d43fa,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_tools_CFGViewer$vtable, soot_tools_CFGViewer.parse__5foptions$a2a3fd2bd75d43fa) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	26,
	      .table=	_jc_soot_tools_CFGViewer$linenum_table$parse__5foptions$a2a3fd2bd75d43fa
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_tools_CFGViewer, parse__5foptions$a2a3fd2bd75d43fa);

void _JC_JCNI_ATTR
_jc_soot_tools_CFGViewer$method$parse__5foptions$a2a3fd2bd75d43fa(_jc_env *const env, _jc_soot_tools_CFGViewer$object *this, _jc_object_array *param0)
{
	jint i0;
	jint i1;
	jint i2;
	jint i3;
	jint i5;
	struct _jc_soot_tools_CFGViewer$object *r0;
	_jc_object_array *r1;
	struct _jc_java_lang_String$object *r2;
	struct _jc_soot_Scene$object *r3;
	struct _jc_soot_G$object *r4;
	struct _jc_java_lang_String$object *r5;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(125);				// 0
	i0 = 0;
	i1 = _JC_ARRAY_LENGTH(env, r1);

label0:
	if (i0 >= i1)
		goto label12;
	_JC_LINE_NUMBER(126);				// 1
	r2 = _JC_REF_ELEMENT(env, r1, i0, 0, 0);
	z0 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, equals$8a15e0625571c581, 1, r2, _JC_STRING(env, "--unit"));
	if (z0 == 0)
		goto label1;
	_JC_LINE_NUMBER(127);				// 2
	_JC_PRIM_FIELD(env, r0, soot_tools_CFGViewer, graphtype) = 0;
	goto label11;

label1:
	_JC_LINE_NUMBER(128);				// 3
	r2 = _JC_REF_ELEMENT(env, r1, i0, 0, 0);
	z0 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, equals$8a15e0625571c581, 1, r2, _JC_STRING(env, "--block"));
	if (z0 == 0)
		goto label2;
	_JC_LINE_NUMBER(129);				// 4
	_JC_PRIM_FIELD(env, r0, soot_tools_CFGViewer, graphtype) = 1;
	goto label11;

label2:
	_JC_LINE_NUMBER(130);				// 5
	r2 = _JC_REF_ELEMENT(env, r1, i0, 0, 0);
	z0 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, equals$8a15e0625571c581, 1, r2, _JC_STRING(env, "--array"));
	if (z0 == 0)
		goto label3;
	_JC_LINE_NUMBER(131);				// 6
	_JC_PRIM_FIELD(env, r0, soot_tools_CFGViewer, graphtype) = 2;
	goto label11;

label3:
	_JC_LINE_NUMBER(132);				// 7
	r2 = _JC_REF_ELEMENT(env, r1, i0, 0, 0);
	z0 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, equals$8a15e0625571c581, 1, r2, _JC_STRING(env, "--brief"));
	if (z0 == 0)
		goto label4;
	_JC_LINE_NUMBER(133);				// 8
	_JC_PRIM_FIELD(env, r0, soot_tools_CFGViewer, isBrief) = 1;
	goto label11;

label4:
	_JC_LINE_NUMBER(134);				// 9
	r2 = _JC_REF_ELEMENT(env, r1, i0, 0, 0);
	z0 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, equals$8a15e0625571c581, 1, r2, _JC_STRING(env, "--soot-classpath"));
	if (z0 == 0)
		goto label5;
	_JC_ACTIVE_USE(env, soot_Scene);
	_JC_ACTIVE_USE(env, soot_G);
	_JC_LINE_NUMBER(135);				// 10
	r4 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r3 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Scene$3451207662ac1af0, r4);
	i0 = i0 + 1;
	r2 = _JC_REF_ELEMENT(env, r1, i0, 0, 1);
	_JC_INVOKE_VIRTUAL(env, soot_Scene, setSootClassPath$84d0b2aea2356411, r3, r2);
	goto label11;

label5:
	_JC_LINE_NUMBER(136);				// 11
	r2 = _JC_REF_ELEMENT(env, r1, i0, 0, 0);
	z0 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, equals$8a15e0625571c581, 1, r2, _JC_STRING(env, "--multipages"));
	if (z0 == 0)
		goto label6;
	_JC_LINE_NUMBER(137);				// 12
	_JC_PRIM_FIELD(env, r0, soot_tools_CFGViewer, onepage) = 0;
	goto label11;

label6:
	_JC_LINE_NUMBER(138);				// 13
	r2 = _JC_REF_ELEMENT(env, r1, i0, 0, 0);
	z0 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, equals$8a15e0625571c581, 1, r2, _JC_STRING(env, "--shimple"));
	if (z0 == 0)
		goto label7;
	_JC_LINE_NUMBER(139);				// 14
	_JC_STATIC_FIELD(env, soot_tools_CFGViewer, shimple, 0) = 1;
	goto label11;

label7:
	_JC_LINE_NUMBER(140);				// 15
	r2 = _JC_REF_ELEMENT(env, r1, i0, 0, 0);
	z0 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, equals$8a15e0625571c581, 1, r2, _JC_STRING(env, "--via-shimple"));
	if (z0 == 0)
		goto label8;
	_JC_LINE_NUMBER(141);				// 16
	_JC_STATIC_FIELD(env, soot_tools_CFGViewer, viaShimple, 0) = 1;
	goto label11;

label8:
	_JC_LINE_NUMBER(142);				// 17
	r2 = _JC_REF_ELEMENT(env, r1, i0, 0, 0);
	z0 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, equals$8a15e0625571c581, 1, r2, _JC_STRING(env, "--complete"));
	if (z0 == 0)
		goto label9;
	_JC_LINE_NUMBER(143);				// 18
	_JC_STATIC_FIELD(env, soot_tools_CFGViewer, complete, 0) = 1;
	goto label11;

label9:
	_JC_LINE_NUMBER(145);				// 19
	r2 = _JC_REF_ELEMENT(env, r1, i0, 0, 0);
	_JC_EXPLICIT_NULL_CHECK(env, r2);
	i3 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, indexOf$6ec5a1241e692e35, 0, r2, 58, 0);
	_JC_LINE_NUMBER(146);				// 20
	if (i3 != -1)
		goto label10;
	_JC_LINE_NUMBER(147);				// 21
	r2 = _JC_REF_ELEMENT(env, r1, i0, 0, 0);
	_JC_REF_FIELD(env, r0, soot_tools_CFGViewer, clsname) = r2;
	goto label11;

label10:
	_JC_LINE_NUMBER(149);				// 22
	r2 = _JC_REF_ELEMENT(env, r1, i0, 0, 0);
	r2 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, substring$df0d95f5ebfea7dc, 1, r2, 0, i3);
	_JC_REF_FIELD(env, r0, soot_tools_CFGViewer, clsname) = r2;
	_JC_LINE_NUMBER(150);				// 23
	r2 = _JC_REF_ELEMENT(env, r1, i0, 0, 0);
	i2 = i3 + 1;
	_JC_EXPLICIT_NULL_CHECK(env, r2);
	i5 = _JC_PRIM_FIELD(env, r2, java_lang_String, count);
	r5 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, substring$df0d95f5ebfea7dc, 0, r2, i2, i5);
	_JC_REF_FIELD(env, r0, soot_tools_CFGViewer, methname) = r5;

label11:
	_JC_LINE_NUMBER(125);				// 24
	i0 = i0 + 1;
	_JC_PERIODIC_CHECK(env);
	goto label0;

label12:
	_JC_LINE_NUMBER(154);				// 25
	return;
}

//
// protected void print_cfg(soot.Body)
//

static _jc_linenum _jc_soot_tools_CFGViewer$linenum_table$print__5fcfg$39a20ff4fbfd8523[];

static const unsigned char _jc_soot_tools_CFGViewer$param_ptypes$print__5fcfg$39a20ff4fbfd8523[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_soot_tools_CFGViewer$param_types$print__5fcfg$39a20ff4fbfd8523[] = {
	&_jc_soot_Body$type
};

_jc_method _jc_soot_tools_CFGViewer$method_info$print__5fcfg$39a20ff4fbfd8523 = {
	.name=			"print_cfg",
	.signature=		"(Lsoot/Body;)V",
	.class=			&_jc_soot_tools_CFGViewer$type,
	.param_types=		&_jc_soot_tools_CFGViewer$param_types$print__5fcfg$39a20ff4fbfd8523,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_soot_tools_CFGViewer$param_ptypes$print__5fcfg$39a20ff4fbfd8523,
	.signature_hash=	_JC_JLONG(0x39a20ff4fbfd8523),
	.access_flags=		_JC_ACC_PROTECTED,
	.function=		&_jc_soot_tools_CFGViewer$method$print__5fcfg$39a20ff4fbfd8523,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_tools_CFGViewer$vtable, soot_tools_CFGViewer.print__5fcfg$39a20ff4fbfd8523) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	15,
	      .table=	_jc_soot_tools_CFGViewer$linenum_table$print__5fcfg$39a20ff4fbfd8523
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_tools_CFGViewer, print__5fcfg$39a20ff4fbfd8523);

void _JC_JCNI_ATTR
_jc_soot_tools_CFGViewer$method$print__5fcfg$39a20ff4fbfd8523(_jc_env *const env, _jc_soot_tools_CFGViewer$object *this, _jc_soot_Body$object *param0)
{
	jint i0;
	jint i1;
	struct _jc_soot_tools_CFGViewer$object *r0;
	struct _jc_soot_Body$object *r1;
	struct _jc_java_lang_String$object *r10;
	struct _jc_java_lang_String$object *r11;
	struct _jc_java_lang_String$object *r12;
	_jc_char_array *r13;
	_jc_char_array *r14;
	struct _jc_soot_SootMethod$object *r2;
	struct _jc_soot_SootClass$object *r3;
	struct _jc_object *r4;
	struct _jc_java_lang_String$object *r5;
	struct _jc_soot_toolkits_graph_UnitGraph$object *r6;
	struct _jc_soot_toolkits_graph_BlockGraph$object *r7;
	struct _jc_java_lang_StringBuffer$object *r8;
	struct _jc_java_lang_StringBuffer$object *r9;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(157);				// 0
	r2 = _JC_INVOKE_VIRTUAL(env, soot_Body, getMethod$04d7c221deab35ce, r1);
	_JC_LINE_NUMBER(158);				// 1
	r3 = _JC_INVOKE_VIRTUAL(env, soot_SootMethod, getDeclaringClass$dd2382a1f7813acf, r2);
	_JC_LINE_NUMBER(160);				// 2
	r4 = _JC_NULL;
	_JC_LINE_NUMBER(162);				// 3
	i0 = _JC_PRIM_FIELD(env, r0, soot_tools_CFGViewer, graphtype);
	switch (i0) {
	case 0:
		goto label0;
	case 1:
		goto label1;
	case 2:
		goto label3;
	default:
		goto label4;
	}

label0:
	_JC_LINE_NUMBER(164);				// 4
	r6 = _JC_NEW(env, soot_toolkits_graph_UnitGraph);
	z0 = _JC_STATIC_FIELD(env, soot_tools_CFGViewer, complete, 1);
	_JC_INVOKE_NONVIRTUAL(env, soot_toolkits_graph_UnitGraph, _init$cbdd23ded79122e1, 0, r6, r1, z0, 0);
	r4 = r6;
	_JC_LINE_NUMBER(165);				// 5
	goto label4;

label1:
	_JC_LINE_NUMBER(167);				// 6
	z0 = _JC_STATIC_FIELD(env, soot_tools_CFGViewer, complete, 1);
	if (z0 == 0)
		goto label2;
	_JC_LINE_NUMBER(168);				// 7
	r7 = _JC_NEW(env, soot_toolkits_graph_BlockGraph);
	_JC_INVOKE_NONVIRTUAL(env, soot_toolkits_graph_BlockGraph, _init$67b6b7337f17103f, 0, r7, r1, 0);
	r4 = r7;
	goto label4;

label2:
	_JC_LINE_NUMBER(170);				// 8
	r7 = _JC_NEW(env, soot_toolkits_graph_BlockGraph);
	_JC_INVOKE_NONVIRTUAL(env, soot_toolkits_graph_BlockGraph, _init$67b6b7337f17103f, 0, r7, r1, 1);
	r4 = r7;
	_JC_LINE_NUMBER(171);				// 9
	goto label4;

label3:
	_JC_LINE_NUMBER(173);				// 10
	r7 = _JC_NEW(env, soot_toolkits_graph_BlockGraph);
	_JC_INVOKE_NONVIRTUAL(env, soot_toolkits_graph_BlockGraph, _init$67b6b7337f17103f, 0, r7, r1, 99);
	r4 = r7;

label4:
	_JC_LINE_NUMBER(177);				// 11
	r8 = _JC_NEW(env, java_lang_StringBuffer);
	r13 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r8, java_lang_StringBuffer, value) = r13;
	r5 = _JC_INVOKE_VIRTUAL(env, soot_SootMethod, getName$bec186f2ce7e1882, r2);
	r8 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r8, r5);
	r8 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r8, _JC_STRING(env, "-"));
	i0 = _JC_PRIM_FIELD(env, r0, soot_tools_CFGViewer, meth__5fcount);
	i1 = i0 + 1;
	_JC_PRIM_FIELD(env, r0, soot_tools_CFGViewer, meth__5fcount) = i1;
	_JC_ACTIVE_USE(env, java_lang_String);
	r10 = _JC_INVOKE_STATIC(env, java_lang_Integer, toString$80d919d12afaaa2b, 0, i0, 10);
	r9 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r8, r10);
	_JC_EXPLICIT_NULL_CHECK(env, r9);
	r11 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r11, r9);
	_JC_LINE_NUMBER(178);				// 12
	r8 = _JC_NEW(env, java_lang_StringBuffer);
	r14 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r8, java_lang_StringBuffer, value) = r14;
	r5 = _JC_INVOKE_VIRTUAL(env, soot_SootClass, getName$bec186f2ce7e1882, r3);
	r8 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r8, r5);
	r8 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r8, _JC_STRING(env, ":"));
	r5 = _JC_INVOKE_VIRTUAL(env, soot_SootMethod, getName$bec186f2ce7e1882, r2);
	r8 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r8, r5);
	r12 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r12, r8);
	_JC_LINE_NUMBER(179);				// 13
	_JC_INVOKE_VIRTUAL(env, soot_tools_CFGViewer, toDotFile$37a5b91149bee0fb, r0, r11, r4, r12);
	_JC_LINE_NUMBER(180);				// 14
	return;
}

//
// public void run(java.lang.String[])
//

static _jc_linenum _jc_soot_tools_CFGViewer$linenum_table$run$e3a65dc5d69f6eeb[];

static const unsigned char _jc_soot_tools_CFGViewer$param_ptypes$run$e3a65dc5d69f6eeb[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_soot_tools_CFGViewer$param_types$run$e3a65dc5d69f6eeb[] = {
	&_jc_java_lang_String$array$type
};

_jc_method _jc_soot_tools_CFGViewer$method_info$run$e3a65dc5d69f6eeb = {
	.name=			"run",
	.signature=		"([Ljava/lang/String;)V",
	.class=			&_jc_soot_tools_CFGViewer$type,
	.param_types=		&_jc_soot_tools_CFGViewer$param_types$run$e3a65dc5d69f6eeb,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_soot_tools_CFGViewer$param_ptypes$run$e3a65dc5d69f6eeb,
	.signature_hash=	_JC_JLONG(0xe3a65dc5d69f6eeb),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_tools_CFGViewer$method$run$e3a65dc5d69f6eeb,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_tools_CFGViewer$vtable, soot_tools_CFGViewer.run$e3a65dc5d69f6eeb) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	18,
	      .table=	_jc_soot_tools_CFGViewer$linenum_table$run$e3a65dc5d69f6eeb
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_tools_CFGViewer, run$e3a65dc5d69f6eeb);

void _JC_JCNI_ATTR
_jc_soot_tools_CFGViewer$method$run$e3a65dc5d69f6eeb(_jc_env *const env, _jc_soot_tools_CFGViewer$object *this, _jc_object_array *param0)
{
	jint i0;
	struct _jc_soot_tools_CFGViewer$object *r0;
	_jc_object_array *r1;
	struct _jc_soot_Scene$object *r10;
	struct _jc_soot_G$object *r11;
	struct _jc_soot_shimple_Shimple$object *r12;
	struct _jc_soot_G$object *r13;
	struct _jc_soot_shimple_Shimple$object *r15;
	struct _jc_soot_G$object *r16;
	struct _jc_soot_SootClass$object *r2;
	struct _jc_object *r3;
	struct _jc_soot_SootMethod$object *r4;
	struct _jc_soot_Body$object *r5;
	struct _jc_java_lang_String$object *r6;
	struct _jc_java_lang_Object$object *r7;
	struct _jc_java_lang_String$object *r8;
	struct _jc_soot_shimple_ShimpleBody$object *r9;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(78);				// 0
	i0 = _JC_ARRAY_LENGTH(env, r1);
	if (i0 != 0)
		goto label0;
	_JC_LINE_NUMBER(79);				// 1
	_JC_INVOKE_NONVIRTUAL(env, soot_tools_CFGViewer, usage$266c6b1a7945f7f7, 0, r0);
	_JC_LINE_NUMBER(80);				// 2
	return;

label0:
	_JC_LINE_NUMBER(84);				// 3
	_JC_INVOKE_NONVIRTUAL(env, soot_tools_CFGViewer, parse__5foptions$a2a3fd2bd75d43fa, 0, r0, r1);
	_JC_ACTIVE_USE(env, soot_Scene);
	_JC_ACTIVE_USE(env, soot_G);
	_JC_LINE_NUMBER(87);				// 4
	r11 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r10 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Scene$3451207662ac1af0, r11);
	r6 = _JC_REF_FIELD(env, r0, soot_tools_CFGViewer, clsname);
	r2 = _JC_INVOKE_VIRTUAL(env, soot_Scene, loadClassAndSupport$72ed099e753d28fd, r10, r6);
	_JC_LINE_NUMBER(88);				// 5
	_JC_INVOKE_VIRTUAL(env, soot_SootClass, setApplicationClass$9c1e20d500dc295b, r2);
	_JC_LINE_NUMBER(91);				// 6
	r3 = _JC_INVOKE_VIRTUAL(env, soot_SootClass, methodIterator$685c73a73d0b4550, r2);

label1:
	_JC_LINE_NUMBER(92);				// 7
	z0 = _JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0xfb0bd5e38c59ddcd), jboolean, (_jc_env *, struct _jc_object *));
	if (z0 == 0)
		goto label6;
	_JC_LINE_NUMBER(93);				// 8
	r7 = _JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0x5874f79a1cf66ea), _jc_object *, (_jc_env *, struct _jc_object *));
	r4 = _JC_CAST(env, &_jc_soot_SootMethod$type, r7);
	_JC_LINE_NUMBER(95);				// 9
	r6 = _JC_REF_FIELD(env, r0, soot_tools_CFGViewer, methname);
	if (r6 == _JC_NULL)
		goto label2;
	r6 = _JC_REF_FIELD(env, r0, soot_tools_CFGViewer, methname);
	r8 = _JC_INVOKE_VIRTUAL(env, soot_SootMethod, getName$bec186f2ce7e1882, r4);
	z0 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, equals$8a15e0625571c581, 1, r6, r8);
	if (z0 == 0) {
		_JC_PERIODIC_CHECK(env);
		goto label1;
	}

label2:
	_JC_LINE_NUMBER(97);				// 10
	z0 = _JC_INVOKE_VIRTUAL(env, soot_SootMethod, isConcrete$4526a8d855965339, r4);
	if (z0 == 0) {
		_JC_PERIODIC_CHECK(env);
		goto label1;
	}
	_JC_LINE_NUMBER(98);				// 11
	r5 = _JC_INVOKE_VIRTUAL(env, soot_SootMethod, retrieveActiveBody$311919cf9b17e442, r4);
	_JC_LINE_NUMBER(100);				// 12
	z0 = _JC_STATIC_FIELD(env, soot_tools_CFGViewer, shimple, 1);
	if (z0 != 0)
		goto label3;
	z0 = _JC_STATIC_FIELD(env, soot_tools_CFGViewer, viaShimple, 1);
	if (z0 == 0)
		goto label4;

label3:
	_JC_ACTIVE_USE(env, soot_shimple_Shimple);
	_JC_ACTIVE_USE(env, soot_G);
	_JC_LINE_NUMBER(101);				// 13
	r13 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r12 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Shimple$fbfa41e9632c484b, r13);
	r5 = _JC_INVOKE_VIRTUAL(env, soot_shimple_Shimple, newBody$4d88d5b694aa9803, r12, r5);

label4:
	_JC_LINE_NUMBER(103);				// 14
	z0 = _JC_STATIC_FIELD(env, soot_tools_CFGViewer, viaShimple, 1);
	if (z0 == 0)
		goto label5;
	z0 = _JC_STATIC_FIELD(env, soot_tools_CFGViewer, shimple, 1);
	if (z0 != 0)
		goto label5;
	_JC_ACTIVE_USE(env, soot_shimple_Shimple);
	_JC_ACTIVE_USE(env, soot_G);
	_JC_LINE_NUMBER(104);				// 15
	r16 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r15 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Shimple$fbfa41e9632c484b, r16);
	r9 = _JC_CAST(env, &_jc_soot_shimple_ShimpleBody$type, r5);
	r5 = _JC_INVOKE_VIRTUAL(env, soot_shimple_Shimple, newJimpleBody$539e753c556a51fc, r15, r9);

label5:
	_JC_LINE_NUMBER(106);				// 16
	_JC_INVOKE_VIRTUAL(env, soot_tools_CFGViewer, print__5fcfg$39a20ff4fbfd8523, r0, r5);
	_JC_PERIODIC_CHECK(env);
	goto label1;

label6:
	_JC_LINE_NUMBER(110);				// 17
	return;
}

//
// public void toDotFile(java.lang.String, soot.toolkits.graph.DirectedGraph, java.lang.String)
//

static _jc_linenum _jc_soot_tools_CFGViewer$linenum_table$toDotFile$37a5b91149bee0fb[];

static const unsigned char _jc_soot_tools_CFGViewer$param_ptypes$toDotFile$37a5b91149bee0fb[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_soot_tools_CFGViewer$param_types$toDotFile$37a5b91149bee0fb[] = {
	&_jc_java_lang_String$type,
	&_jc_soot_toolkits_graph_DirectedGraph$type,
	&_jc_java_lang_String$type
};

_jc_method _jc_soot_tools_CFGViewer$method_info$toDotFile$37a5b91149bee0fb = {
	.name=			"toDotFile",
	.signature=		"(Ljava/lang/String;Lsoot/toolkits/graph/DirectedGraph;Ljava/lang/String;)V",
	.class=			&_jc_soot_tools_CFGViewer$type,
	.param_types=		&_jc_soot_tools_CFGViewer$param_types$toDotFile$37a5b91149bee0fb,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_soot_tools_CFGViewer$param_ptypes$toDotFile$37a5b91149bee0fb,
	.signature_hash=	_JC_JLONG(0x37a5b91149bee0fb),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_tools_CFGViewer$method$toDotFile$37a5b91149bee0fb,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_tools_CFGViewer$vtable, soot_tools_CFGViewer.toDotFile$37a5b91149bee0fb) / sizeof(void *),
	.num_parameters=	3,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	33,
	      .table=	_jc_soot_tools_CFGViewer$linenum_table$toDotFile$37a5b91149bee0fb
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_tools_CFGViewer, toDotFile$37a5b91149bee0fb);

void _JC_JCNI_ATTR
_jc_soot_tools_CFGViewer$method$toDotFile$37a5b91149bee0fb(_jc_env *const env, _jc_soot_tools_CFGViewer$object *this, _jc_java_lang_String$object *param0, _jc_object *param1, _jc_java_lang_String$object *param2)
{
	jint i0;
	struct _jc_soot_tools_CFGViewer$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_soot_util_dot_DotGraphNode$object *r10;
	struct _jc_object *r11;
	struct _jc_object *r12;
	struct _jc_java_lang_StringBuffer$object *r13;
	struct _jc_java_lang_StringBuffer$object *r14;
	struct _jc_java_lang_String$object *r15;
	struct _jc_java_lang_String$object *r16;
	_jc_char_array *r17;
	struct _jc_java_lang_StringBuffer$object *r18;
	struct _jc_java_lang_StringBuffer$object *r19;
	struct _jc_object *r2;
	struct _jc_java_lang_String$object *r20;
	struct _jc_java_lang_String$object *r21;
	_jc_char_array *r22;
	struct _jc_java_lang_StringBuffer$object *r23;
	struct _jc_java_lang_StringBuffer$object *r24;
	struct _jc_java_lang_String$object *r25;
	struct _jc_java_lang_String$object *r26;
	_jc_char_array *r27;
	struct _jc_java_lang_StringBuffer$object *r28;
	struct _jc_java_lang_StringBuffer$object *r29;
	struct _jc_java_lang_String$object *r3;
	struct _jc_java_lang_String$object *r30;
	struct _jc_java_lang_String$object *r31;
	_jc_char_array *r32;
	struct _jc_java_lang_StringBuffer$object *r33;
	struct _jc_java_lang_StringBuffer$object *r34;
	struct _jc_java_lang_String$object *r35;
	struct _jc_java_lang_String$object *r36;
	_jc_char_array *r37;
	struct _jc_soot_util_dot_DotGraphNode$object *r38;
	struct _jc_soot_util_dot_DotGraphNode$object *r39;
	struct _jc_java_util_Hashtable$object *r4;
	struct _jc_soot_util_dot_DotGraphEdge$object *r40;
	struct _jc_object *r41;
	struct _jc_java_lang_StringBuffer$object *r42;
	struct _jc_java_lang_StringBuffer$object *r43;
	struct _jc_java_lang_String$object *r44;
	struct _jc_java_lang_StringBuffer$object *r45;
	struct _jc_java_lang_String$object *r46;
	struct _jc_java_lang_String$object *r47;
	_jc_char_array *r48;
	struct _jc_java_lang_String$object *r49;
	struct _jc_soot_util_dot_DotGraph$object *r5;
	struct _jc_soot_util_dot_DotGraphAttribute$object *r50;
	struct _jc_object *r51;
	struct _jc_java_lang_String$object *r52;
	struct _jc_java_lang_StringBuffer$object *r53;
	struct _jc_java_lang_String$object *r54;
	_jc_char_array *r55;
	struct _jc_java_lang_String$object *r56;
	struct _jc_soot_util_dot_DotGraphAttribute$object *r57;
	struct _jc_object *r58;
	struct _jc_object *r6;
	struct _jc_java_lang_Object$object *r7;
	struct _jc_object *r8;
	struct _jc_java_lang_Object$object *r9;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	r3 = param2;
	_JC_LINE_NUMBER(196);				// 0
	_JC_PRIM_FIELD(env, r0, soot_tools_CFGViewer, nodecount) = 0;
	_JC_LINE_NUMBER(197);				// 1
	r4 = _JC_NEW(env, java_util_Hashtable);
	i0 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0x345df5220fc60ade), jint, (_jc_env *, struct _jc_object *));
	_JC_INVOKE_NONVIRTUAL(env, java_util_Hashtable, _init$7cb044ce4fb0ada8, 0, r4, i0, _JC_FCONST(0x3f, 0x40, 0x0, 0x0));
	_JC_LINE_NUMBER(200);				// 2
	r5 = _JC_NEW(env, soot_util_dot_DotGraph);
	_JC_INVOKE_NONVIRTUAL(env, soot_util_dot_DotGraph, _init$c31b894660454d13, 0, r5, r1);
	_JC_LINE_NUMBER(202);				// 3
	z0 = _JC_PRIM_FIELD(env, r0, soot_tools_CFGViewer, onepage);
	if (z0 != 0)
		goto label0;
	r42 = _JC_NEW(env, java_lang_StringBuffer);
	r48 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r42, java_lang_StringBuffer, value) = r48;
	r42 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r42, _JC_STRING(env, "\""));
	_JC_ACTIVE_USE(env, java_lang_Double);
	r44 = _JC_INVOKE_STATIC(env, java_lang_VMDouble, toString$854f8a9e26dc66fd, 0, _JC_DCONST(0x40, 0x21, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0), 0);
	r43 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r42, r44);
	r42 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 1, r43, _JC_STRING(env, ", "));
	_JC_EXPLICIT_NULL_CHECK(env, r42);
	r46 = _JC_INVOKE_STATIC(env, java_lang_VMDouble, toString$854f8a9e26dc66fd, 1, _JC_DCONST(0x40, 0x26, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0), 0);
	r45 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r42, r46);
	r42 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 1, r45, _JC_STRING(env, "\""));
	_JC_EXPLICIT_NULL_CHECK(env, r42);
	r47 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r47, r42);
	r49 = _JC_STRING(env, "page");
	r51 = _JC_REF_FIELD(env, r5, soot_util_dot_DotGraph, attributes);
	r50 = _JC_NEW(env, soot_util_dot_DotGraphAttribute);
	_JC_REF_FIELD(env, r50, soot_util_dot_DotGraphAttribute, id) = r49;
	_JC_REF_FIELD(env, r50, soot_util_dot_DotGraphAttribute, value) = r47;
	_JC_INVOKE_INTERFACE(env, r51, _JC_JLONG(0x831f06ee5f59c0cc), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r50);

label0:
	_JC_LINE_NUMBER(206);				// 4
	z0 = _JC_PRIM_FIELD(env, r0, soot_tools_CFGViewer, isBrief);
	if (z0 == 0)
		goto label1;
	_JC_LINE_NUMBER(207);				// 5
	_JC_INVOKE_NONVIRTUAL(env, soot_util_dot_DotGraph, setNodeShape$2363998f6a04dcb6, 0, r5, _JC_STRING(env, "circle"));
	goto label2;

label1:
	_JC_LINE_NUMBER(209);				// 6
	_JC_INVOKE_NONVIRTUAL(env, soot_util_dot_DotGraph, setNodeShape$2363998f6a04dcb6, 0, r5, _JC_STRING(env, "box"));

label2:
	r52 = _JC_INVOKE_STATIC(env, soot_util_dot_DotGraphUtility, replaceQuotes$5bc55a16219742c1, 0, r3);
	r52 = _JC_INVOKE_STATIC(env, soot_util_dot_DotGraphUtility, replaceReturns$aa928e5c8e2e45c0, 1, r52);
	r53 = _JC_NEW(env, java_lang_StringBuffer);
	r55 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r53, java_lang_StringBuffer, value) = r55;
	r53 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r53, _JC_STRING(env, "\""));
	r53 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r53, r52);
	r53 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r53, _JC_STRING(env, "\""));
	r54 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r54, r53);
	r56 = _JC_STRING(env, "label");
	r58 = _JC_REF_FIELD(env, r5, soot_util_dot_DotGraph, attributes);
	r57 = _JC_NEW(env, soot_util_dot_DotGraphAttribute);
	_JC_REF_FIELD(env, r57, soot_util_dot_DotGraphAttribute, id) = r56;
	_JC_REF_FIELD(env, r57, soot_util_dot_DotGraphAttribute, value) = r54;
	_JC_INVOKE_INTERFACE(env, r58, _JC_JLONG(0x831f06ee5f59c0cc), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r57);
	_JC_LINE_NUMBER(213);				// 7
	r6 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0x3cc91493d50f531c), _jc_object *, (_jc_env *, struct _jc_object *));

label3:
	_JC_LINE_NUMBER(214);				// 8
	z0 = _JC_INVOKE_INTERFACE(env, r6, _JC_JLONG(0xfb0bd5e38c59ddcd), jboolean, (_jc_env *, struct _jc_object *));
	if (z0 == 0)
		goto label5;
	_JC_LINE_NUMBER(215);				// 9
	r7 = _JC_INVOKE_INTERFACE(env, r6, _JC_JLONG(0x5874f79a1cf66ea), _jc_object *, (_jc_env *, struct _jc_object *));
	_JC_LINE_NUMBER(217);				// 10
	r11 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0x51ae3c0a375c9961), _jc_object *, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r7);
	r8 = _JC_INVOKE_INTERFACE(env, r11, _JC_JLONG(0x3cc91493d50f531c), _jc_object *, (_jc_env *, struct _jc_object *));

label4:
	_JC_LINE_NUMBER(218);				// 11
	z0 = _JC_INVOKE_INTERFACE(env, r8, _JC_JLONG(0xfb0bd5e38c59ddcd), jboolean, (_jc_env *, struct _jc_object *));
	if (z0 == 0) {
		_JC_PERIODIC_CHECK(env);
		goto label3;
	}
	_JC_LINE_NUMBER(219);				// 12
	r9 = _JC_INVOKE_INTERFACE(env, r8, _JC_JLONG(0x5874f79a1cf66ea), _jc_object *, (_jc_env *, struct _jc_object *));
	_JC_LINE_NUMBER(221);				// 13
	i0 = _JC_INVOKE_NONVIRTUAL(env, soot_tools_CFGViewer, getNodeOrder$9a2ce70edc5fa440, 0, r0, r4, r7);
	r13 = _JC_NEW(env, java_lang_StringBuffer);
	r17 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r13, java_lang_StringBuffer, value) = r17;
	r13 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r13, _JC_STRING(env, "N"));
	_JC_ACTIVE_USE(env, java_lang_String);
	r15 = _JC_INVOKE_STATIC(env, java_lang_Integer, toString$80d919d12afaaa2b, 0, i0, 10);
	r14 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r13, r15);
	_JC_EXPLICIT_NULL_CHECK(env, r14);
	r16 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r16, r14);
	i0 = _JC_INVOKE_NONVIRTUAL(env, soot_tools_CFGViewer, getNodeOrder$9a2ce70edc5fa440, 0, r0, r4, r9);
	r18 = _JC_NEW(env, java_lang_StringBuffer);
	r22 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r18, java_lang_StringBuffer, value) = r22;
	r18 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r18, _JC_STRING(env, "N"));
	r20 = _JC_INVOKE_STATIC(env, java_lang_Integer, toString$80d919d12afaaa2b, 1, i0, 10);
	r19 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r18, r20);
	_JC_EXPLICIT_NULL_CHECK(env, r19);
	r21 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r21, r19);
	r38 = _JC_INVOKE_NONVIRTUAL(env, soot_util_dot_DotGraph, drawNode$9d1b337724adca75, 0, r5, r16);
	r39 = _JC_INVOKE_NONVIRTUAL(env, soot_util_dot_DotGraph, drawNode$9d1b337724adca75, 0, r5, r21);
	r40 = _JC_NEW(env, soot_util_dot_DotGraphEdge);
	_JC_REF_FIELD(env, r40, soot_util_dot_DotGraphEdge, start) = r38;
	_JC_REF_FIELD(env, r40, soot_util_dot_DotGraphEdge, end) = r39;
	_JC_PRIM_FIELD(env, r40, soot_util_dot_DotGraphEdge, isDirected) = 1;
	r41 = _JC_REF_FIELD(env, r5, soot_util_dot_DotGraph, drawElements);
	_JC_INVOKE_INTERFACE(env, r41, _JC_JLONG(0x831f06ee5f59c0cc), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r40);
	_JC_PERIODIC_CHECK(env);
	goto label4;

label5:
	_JC_LINE_NUMBER(227);				// 14
	r11 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0xe2893bcf27fe8f99), _jc_object *, (_jc_env *, struct _jc_object *));
	r8 = _JC_INVOKE_INTERFACE(env, r11, _JC_JLONG(0x3cc91493d50f531c), _jc_object *, (_jc_env *, struct _jc_object *));

label6:
	_JC_LINE_NUMBER(228);				// 15
	z0 = _JC_INVOKE_INTERFACE(env, r8, _JC_JLONG(0xfb0bd5e38c59ddcd), jboolean, (_jc_env *, struct _jc_object *));
	if (z0 == 0)
		goto label7;
	_JC_LINE_NUMBER(229);				// 16
	r9 = _JC_INVOKE_INTERFACE(env, r8, _JC_JLONG(0x5874f79a1cf66ea), _jc_object *, (_jc_env *, struct _jc_object *));
	_JC_LINE_NUMBER(230);				// 17
	i0 = _JC_INVOKE_NONVIRTUAL(env, soot_tools_CFGViewer, getNodeOrder$9a2ce70edc5fa440, 0, r0, r4, r9);
	r23 = _JC_NEW(env, java_lang_StringBuffer);
	r27 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r23, java_lang_StringBuffer, value) = r27;
	r23 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r23, _JC_STRING(env, "N"));
	_JC_ACTIVE_USE(env, java_lang_String);
	r25 = _JC_INVOKE_STATIC(env, java_lang_Integer, toString$80d919d12afaaa2b, 0, i0, 10);
	r24 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r23, r25);
	_JC_EXPLICIT_NULL_CHECK(env, r24);
	r26 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r26, r24);
	r10 = _JC_INVOKE_NONVIRTUAL(env, soot_util_dot_DotGraph, getNode$86e5518af2aae757, 0, r5, r26);
	_JC_LINE_NUMBER(231);				// 18
	_JC_INVOKE_VIRTUAL(env, soot_util_dot_DotGraphNode, setStyle$dde4933900b25e7b, r10, _JC_STRING(env, "filled"));
	_JC_PERIODIC_CHECK(env);
	goto label6;

label7:
	_JC_LINE_NUMBER(234);				// 19
	r11 = _JC_INVOKE_INTERFACE(env, r2, _JC_JLONG(0xa9060bae945c433f), _jc_object *, (_jc_env *, struct _jc_object *));
	r8 = _JC_INVOKE_INTERFACE(env, r11, _JC_JLONG(0x3cc91493d50f531c), _jc_object *, (_jc_env *, struct _jc_object *));

label8:
	_JC_LINE_NUMBER(235);				// 20
	z0 = _JC_INVOKE_INTERFACE(env, r8, _JC_JLONG(0xfb0bd5e38c59ddcd), jboolean, (_jc_env *, struct _jc_object *));
	if (z0 == 0)
		goto label9;
	_JC_LINE_NUMBER(236);				// 21
	r9 = _JC_INVOKE_INTERFACE(env, r8, _JC_JLONG(0x5874f79a1cf66ea), _jc_object *, (_jc_env *, struct _jc_object *));
	_JC_LINE_NUMBER(237);				// 22
	i0 = _JC_INVOKE_NONVIRTUAL(env, soot_tools_CFGViewer, getNodeOrder$9a2ce70edc5fa440, 0, r0, r4, r9);
	r28 = _JC_NEW(env, java_lang_StringBuffer);
	r32 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r28, java_lang_StringBuffer, value) = r32;
	r28 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r28, _JC_STRING(env, "N"));
	_JC_ACTIVE_USE(env, java_lang_String);
	r30 = _JC_INVOKE_STATIC(env, java_lang_Integer, toString$80d919d12afaaa2b, 0, i0, 10);
	r29 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r28, r30);
	_JC_EXPLICIT_NULL_CHECK(env, r29);
	r31 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r31, r29);
	r10 = _JC_INVOKE_NONVIRTUAL(env, soot_util_dot_DotGraph, getNode$86e5518af2aae757, 0, r5, r31);
	_JC_LINE_NUMBER(238);				// 23
	_JC_INVOKE_VIRTUAL(env, soot_util_dot_DotGraphNode, setStyle$dde4933900b25e7b, r10, _JC_STRING(env, "filled"));
	_JC_PERIODIC_CHECK(env);
	goto label8;

label9:
	_JC_LINE_NUMBER(242);				// 24
	z0 = _JC_PRIM_FIELD(env, r0, soot_tools_CFGViewer, isBrief);
	if (z0 != 0)
		goto label11;
	_JC_LINE_NUMBER(243);				// 25
	r12 = _JC_INVOKE_NONVIRTUAL(env, java_util_Hashtable, keySet$de7ce456e8d4e55b, 0, r4);
	r8 = _JC_INVOKE_INTERFACE(env, r12, _JC_JLONG(0x3cc91493d50f531c), _jc_object *, (_jc_env *, struct _jc_object *));

label10:
	_JC_LINE_NUMBER(244);				// 26
	z0 = _JC_INVOKE_INTERFACE(env, r8, _JC_JLONG(0xfb0bd5e38c59ddcd), jboolean, (_jc_env *, struct _jc_object *));
	if (z0 == 0)
		goto label11;
	_JC_LINE_NUMBER(245);				// 27
	r9 = _JC_INVOKE_INTERFACE(env, r8, _JC_JLONG(0x5874f79a1cf66ea), _jc_object *, (_jc_env *, struct _jc_object *));
	_JC_LINE_NUMBER(246);				// 28
	i0 = _JC_INVOKE_NONVIRTUAL(env, soot_tools_CFGViewer, getNodeOrder$9a2ce70edc5fa440, 0, r0, r4, r9);
	r33 = _JC_NEW(env, java_lang_StringBuffer);
	r37 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r33, java_lang_StringBuffer, value) = r37;
	r33 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r33, _JC_STRING(env, "N"));
	_JC_ACTIVE_USE(env, java_lang_String);
	r35 = _JC_INVOKE_STATIC(env, java_lang_Integer, toString$80d919d12afaaa2b, 0, i0, 10);
	r34 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r33, r35);
	_JC_EXPLICIT_NULL_CHECK(env, r34);
	r36 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r36, r34);
	_JC_LINE_NUMBER(247);				// 29
	r10 = _JC_INVOKE_NONVIRTUAL(env, soot_util_dot_DotGraph, getNode$86e5518af2aae757, 0, r5, r36);
	_JC_LINE_NUMBER(248);				// 30
	r3 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, toString$7ea43b33b80a3070, r9);
	_JC_INVOKE_VIRTUAL(env, soot_util_dot_DotGraphNode, setLabel$cc08d442c8afc167, r10, r3);
	_JC_PERIODIC_CHECK(env);
	goto label10;

label11:
	_JC_LINE_NUMBER(252);				// 31
	_JC_INVOKE_NONVIRTUAL(env, soot_util_dot_DotGraph, plot$2959ae20ed8bafce, 0, r5);
	_JC_LINE_NUMBER(253);				// 32
	return;
}

//
// private void usage()
//

static _jc_linenum _jc_soot_tools_CFGViewer$linenum_table$usage$266c6b1a7945f7f7[];

static const unsigned char _jc_soot_tools_CFGViewer$param_ptypes$usage$266c6b1a7945f7f7[] = { 
_JC_TYPE_VOID };

_jc_method _jc_soot_tools_CFGViewer$method_info$usage$266c6b1a7945f7f7 = {
	.name=			"usage",
	.signature=		"()V",
	.class=			&_jc_soot_tools_CFGViewer$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_soot_tools_CFGViewer$param_ptypes$usage$266c6b1a7945f7f7,
	.signature_hash=	_JC_JLONG(0x266c6b1a7945f7f7),
	.access_flags=		_JC_ACC_PRIVATE,
	.function=		&_jc_soot_tools_CFGViewer$method$usage$266c6b1a7945f7f7,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_tools_CFGViewer$vtable, soot_tools_CFGViewer.usage$266c6b1a7945f7f7) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	9,
	      .table=	_jc_soot_tools_CFGViewer$linenum_table$usage$266c6b1a7945f7f7
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_tools_CFGViewer, usage$266c6b1a7945f7f7);

void _JC_JCNI_ATTR
_jc_soot_tools_CFGViewer$method$usage$266c6b1a7945f7f7(_jc_env *const env, _jc_soot_tools_CFGViewer$object *this)
{
	struct _jc_soot_tools_CFGViewer$object *r0;
	struct _jc_soot_G$object *r10;
	struct _jc_java_io_PrintStream$object *r2;
	struct _jc_soot_G$object *r3;
	struct _jc_soot_G$object *r4;
	struct _jc_soot_G$object *r5;
	struct _jc_soot_G$object *r6;
	struct _jc_soot_G$object *r7;
	struct _jc_soot_G$object *r8;
	struct _jc_soot_G$object *r9;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	_JC_ACTIVE_USE(env, soot_G);
	_JC_LINE_NUMBER(113);				// 0
	r3 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r2 = _JC_REF_FIELD(env, r3, soot_G, out);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, println$f7dbc2aa0f0a9d4f, r2, _JC_STRING(env, "Usage:"));
	_JC_LINE_NUMBER(114);				// 1
	r4 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r2 = _JC_REF_FIELD(env, r4, soot_G, out);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, println$f7dbc2aa0f0a9d4f, r2, _JC_STRING(env, "   java soot.util.CFGViewer [options] class[:method]"));
	_JC_LINE_NUMBER(115);				// 2
	r5 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r2 = _JC_REF_FIELD(env, r5, soot_G, out);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, println$f7dbc2aa0f0a9d4f, r2, _JC_STRING(env, "   options:"));
	_JC_LINE_NUMBER(116);				// 3
	r6 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r2 = _JC_REF_FIELD(env, r6, soot_G, out);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, println$f7dbc2aa0f0a9d4f, r2, _JC_STRING(env, "       --unit|block|array : produces the unit(default)/block graph."));
	_JC_LINE_NUMBER(117);				// 4
	r7 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r2 = _JC_REF_FIELD(env, r7, soot_G, out);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, println$f7dbc2aa0f0a9d4f, r2, _JC_STRING(env, "       --brief : uses the unit/block index as the label."));
	_JC_LINE_NUMBER(118);				// 5
	r8 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r2 = _JC_REF_FIELD(env, r8, soot_G, out);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, println$f7dbc2aa0f0a9d4f, r2, _JC_STRING(env, "       --soot-classpath PATHs : specifies the soot class pathes."));
	_JC_LINE_NUMBER(119);				// 6
	r9 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r2 = _JC_REF_FIELD(env, r9, soot_G, out);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, println$f7dbc2aa0f0a9d4f, r2, _JC_STRING(env, "       --multipages : produces the dot file sets multi pages (8.5x11)."));
	_JC_LINE_NUMBER(120);				// 7
	r10 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r2 = _JC_REF_FIELD(env, r10, soot_G, out);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, println$f7dbc2aa0f0a9d4f, r2, _JC_STRING(env, "                      By default, the graph is in one page."));
	_JC_LINE_NUMBER(121);				// 8
	return;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_soot_tools_CFGViewer$methods[] = {
	&_jc_soot_tools_CFGViewer$method_info$_clinit$a816641e0ba8bfef,
	&_jc_soot_tools_CFGViewer$method_info$_init$52f4ad9f2989aeee,
	&_jc_soot_tools_CFGViewer$method_info$getNodeOrder$9a2ce70edc5fa440,
	&_jc_soot_tools_CFGViewer$method_info$main$bc98a92695db8a73,
	&_jc_soot_tools_CFGViewer$method_info$makeNodeName$721eb6e2a0588e3d,
	&_jc_soot_tools_CFGViewer$method_info$parse__5foptions$a2a3fd2bd75d43fa,
	&_jc_soot_tools_CFGViewer$method_info$print__5fcfg$39a20ff4fbfd8523,
	&_jc_soot_tools_CFGViewer$method_info$run$e3a65dc5d69f6eeb,
	&_jc_soot_tools_CFGViewer$method_info$toDotFile$37a5b91149bee0fb,
	&_jc_soot_tools_CFGViewer$method_info$usage$266c6b1a7945f7f7
};

/************************************************************************
 *			  Class fields structure			*
 ************************************************************************/

_jc_soot_tools_CFGViewer$fields_struct _jc_soot_tools_CFGViewer$class_fields = { };

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_soot_tools_CFGViewer$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};
static _jc_type *const _jc_soot_tools_CFGViewer$instanceof_hash_bucket_114[] = {
	&_jc_soot_tools_CFGViewer$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_soot_tools_CFGViewer$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[101]=	_jc_soot_tools_CFGViewer$instanceof_hash_bucket_101,
	[114]=	_jc_soot_tools_CFGViewer$instanceof_hash_bucket_114
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_soot_tools_CFGViewer$class_depends[] = {
	{ "java/io/PrintStream",	_JC_JLONG(0x99a46305ebacacb5) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/Double",	_JC_JLONG(0x9c4f2f07f71cb134) },
	{ "java/lang/Integer",	_JC_JLONG(0xca631501391a31f1) },
	{ "java/lang/Number",	_JC_JLONG(0x9cd7252f79299280) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/StringBuffer",	_JC_JLONG(0x94d357637b968dda) },
	{ "java/lang/VMDouble",	_JC_JLONG(0x43adbb439e3f2be3) },
	{ "java/util/Hashtable",	_JC_JLONG(0x576421c2c18f78c4) },
	{ "java/util/Iterator",	_JC_JLONG(0xbe56ff673eefd9d2) },
	{ "java/util/List",	_JC_JLONG(0x9ee0d92ce1525a4d) },
	{ "java/util/Set",	_JC_JLONG(0x617ac82c0bec2dff) },
	{ "soot/Body",	_JC_JLONG(0x6131d54b9700ca5d) },
	{ "soot/G",	_JC_JLONG(0xb6d33af8f84fdbc4) },
	{ "soot/Scene",	_JC_JLONG(0x7120c8047949f8c0) },
	{ "soot/Singletons",	_JC_JLONG(0x6ac5bee50bbabb71) },
	{ "soot/SootClass",	_JC_JLONG(0x634bd13ff2d8ac70) },
	{ "soot/SootMethod",	_JC_JLONG(0xbd11c16680505218) },
	{ "soot/shimple/Shimple",	_JC_JLONG(0x167d99cb511db03a) },
	{ "soot/shimple/ShimpleBody",	_JC_JLONG(0x6038dc4777a2c906) },
	{ "soot/toolkits/graph/BlockGraph",	_JC_JLONG(0x340ee84e9e1f189d) },
	{ "soot/toolkits/graph/DirectedGraph",	_JC_JLONG(0x1d20f632cfd945d1) },
	{ "soot/toolkits/graph/UnitGraph",	_JC_JLONG(0x91abf680ebee56a3) },
	{ "soot/util/dot/DotGraph",	_JC_JLONG(0x7f783bb998510b3d) },
	{ "soot/util/dot/DotGraphAttribute",	_JC_JLONG(0x28f908b461b109d0) },
	{ "soot/util/dot/DotGraphEdge",	_JC_JLONG(0x71029e81ee1c3f7e) },
	{ "soot/util/dot/DotGraphNode",	_JC_JLONG(0xa2e76a2eb2c5cf4) },
	{ "soot/util/dot/DotGraphUtility",	_JC_JLONG(0xaf4bddab63ed936d) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_soot_tools_CFGViewer$vtype _jc_soot_tools_CFGViewer$type = {
    .type= {
	.name=			"soot/tools/CFGViewer",
	.superclass=		&_jc_java_lang_Object$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		18,
		.hash=			_JC_JLONG(0xb804c6411dc35cf2),
		.source_file=		"CFGViewer.java",
		.instance_size=		sizeof(_jc_soot_tools_CFGViewer$refs) + sizeof(_jc_soot_tools_CFGViewer$object),
		.num_virtual_refs=	2,
		.num_fields=		sizeof(_jc_soot_tools_CFGViewer$fields) / sizeof(*_jc_soot_tools_CFGViewer$fields),
		.fields=		_jc_soot_tools_CFGViewer$fields,
		.num_methods=		sizeof(_jc_soot_tools_CFGViewer$methods) / sizeof(*_jc_soot_tools_CFGViewer$methods),
		.methods=		_jc_soot_tools_CFGViewer$methods,
		.instanceof_hash_table=	_jc_soot_tools_CFGViewer$instanceof_hash_table,
		.class_fields=		&_jc_soot_tools_CFGViewer$class_fields,
		.num_class_depends=		sizeof(_jc_soot_tools_CFGViewer$class_depends) / sizeof(*_jc_soot_tools_CFGViewer$class_depends),
		.class_depends=		_jc_soot_tools_CFGViewer$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.soot_tools_CFGViewer= {
	    .getNodeOrder$9a2ce70edc5fa440=
		&_jc_soot_tools_CFGViewer$method$getNodeOrder$9a2ce70edc5fa440,
	    .makeNodeName$721eb6e2a0588e3d=
		&_jc_soot_tools_CFGViewer$method$makeNodeName$721eb6e2a0588e3d,
	    .parse__5foptions$a2a3fd2bd75d43fa=
		&_jc_soot_tools_CFGViewer$method$parse__5foptions$a2a3fd2bd75d43fa,
	    .print__5fcfg$39a20ff4fbfd8523=
		&_jc_soot_tools_CFGViewer$method$print__5fcfg$39a20ff4fbfd8523,
	    .run$e3a65dc5d69f6eeb=
		&_jc_soot_tools_CFGViewer$method$run$e3a65dc5d69f6eeb,
	    .toDotFile$37a5b91149bee0fb=
		&_jc_soot_tools_CFGViewer$method$toDotFile$37a5b91149bee0fb,
	    .usage$266c6b1a7945f7f7=
		&_jc_soot_tools_CFGViewer$method$usage$266c6b1a7945f7f7,
	},
    }
};

