// public class soot.util.DeterministicHashMap

// class file dependencies
// @dep_class 9a35c7173b37e641 java_io_Serializable
// @dep_class 764eb76bc6714ae3 java_lang_Class
// @dep_class 9b667b09132be893 java_lang_Cloneable
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class 1c4f1fc002fc96e5 java_lang_Object
// @dep_class 4f5534a987354d1d java_lang_RuntimeException
// @dep_class c25a545561a18c38 java_lang_String
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class c4b275d49bb21d98 java_lang_UnsupportedOperationException
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class 8ea716c64b77f8eb java_util_AbstractCollection
// @dep_class c7382c60132d0b2c java_util_AbstractMap
// @dep_class ca427569b5b2f804 java_util_AbstractSet
// @dep_class eae4d0c0e8eb63da java_util_Collection
// @dep_class d7cd853200c3e71f java_util_HashMap
// @dep_class e283f7c2e7a7979c java_util_Map
// @dep_class 617ac82c0bec2dff java_util_Set
// @dep_class c3934e18893865c2 soot_util_DeterministicHashMap
// @dep_class 1c7d0f313dc80173 soot_util_TrustingMonotonicArraySet

// header file dependencies
// @dep_header java_io_Serializable
// @dep_header java_lang_Class
// @dep_header java_lang_Cloneable
// @dep_header java_lang_String
// @dep_header java_lang_UnsupportedOperationException
// @dep_header java_lang_VMThrowable
// @dep_header java_util_Collection
// @dep_header java_util_Map
// @dep_header java_util_Set
// @dep_header soot_util_DeterministicHashMap
// @dep_header soot_util_TrustingMonotonicArraySet

#include "jc_defs.h"

#include "java/io/Serializable.h"
#include "java/lang/Class.h"
#include "java/lang/Cloneable.h"
#include "java/lang/String.h"
#include "java/lang/UnsupportedOperationException.h"
#include "java/lang/VMThrowable.h"
#include "java/util/Collection.h"
#include "java/util/Map.h"
#include "java/util/Set.h"
#include "soot/util/DeterministicHashMap.h"
#include "soot/util/TrustingMonotonicArraySet.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// java.util.Set keys
static _jc_field _jc_soot_util_DeterministicHashMap$field_info$keys = {
	.name=		"keys",
	.signature=	"Ljava/util/Set;",
	.class=		&_jc_soot_util_DeterministicHashMap$type,
	.type=		&_jc_java_util_Set$type,
	.access_flags=	0,
	.offset=	_JC_OFFSETOF(_jc_soot_util_DeterministicHashMap$object, refs[-1].soot_util_DeterministicHashMap.keys),
};

// Fields
static _jc_field *const _jc_soot_util_DeterministicHashMap$fields[] = {
	&_jc_soot_util_DeterministicHashMap$field_info$keys
};

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// public void <init>(int)
//

static _jc_linenum _jc_soot_util_DeterministicHashMap$linenum_table$_init$7f1776288300b98d[];

static const unsigned char _jc_soot_util_DeterministicHashMap$param_ptypes$_init$7f1776288300b98d[] = { 
_JC_TYPE_INT, _JC_TYPE_VOID };

static _jc_type *const _jc_soot_util_DeterministicHashMap$param_types$_init$7f1776288300b98d[] = {
	&_jc_int$prim$type
};

_jc_method _jc_soot_util_DeterministicHashMap$method_info$_init$7f1776288300b98d = {
	.name=			"<init>",
	.signature=		"(I)V",
	.class=			&_jc_soot_util_DeterministicHashMap$type,
	.param_types=		&_jc_soot_util_DeterministicHashMap$param_types$_init$7f1776288300b98d,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_soot_util_DeterministicHashMap$param_ptypes$_init$7f1776288300b98d,
	.signature_hash=	_JC_JLONG(0x7f1776288300b98d),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_util_DeterministicHashMap$method$_init$7f1776288300b98d,
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	2,
	      .table=	_jc_soot_util_DeterministicHashMap$linenum_table$_init$7f1776288300b98d
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_util_DeterministicHashMap, _init$7f1776288300b98d);

void _JC_JCNI_ATTR
_jc_soot_util_DeterministicHashMap$method$_init$7f1776288300b98d(_jc_env *const env, _jc_soot_util_DeterministicHashMap$object *this, jint param0)
{
	jint i0;
	struct _jc_soot_util_DeterministicHashMap$object *r0;
	struct _jc_soot_util_TrustingMonotonicArraySet$object *r1;
	_jc_object_array *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	i0 = param0;
	_JC_INVOKE_NONVIRTUAL(env, java_util_HashMap, _init$7cb044ce4fb0ada8, 0, r0, i0, _JC_FCONST(0x3f, 0x40, 0x0, 0x0));
	_JC_LINE_NUMBER(39);				// 0
	r1 = _JC_NEW(env, soot_util_TrustingMonotonicArraySet);
	_JC_PRIM_FIELD(env, r1, soot_util_TrustingMonotonicArraySet, maxElements) = 8;
	r2 = _JC_NEW_REF_ARRAY(env, java_lang_Object, 1, 8);
	_JC_REF_FIELD(env, r1, soot_util_TrustingMonotonicArraySet, elements) = r2;
	_JC_PRIM_FIELD(env, r1, soot_util_TrustingMonotonicArraySet, numElements) = 0;
	_JC_REF_FIELD(env, r0, soot_util_DeterministicHashMap, keys) = r1;
	_JC_LINE_NUMBER(45);				// 1
	return;
}

//
// public void <init>(int, float)
//

static _jc_linenum _jc_soot_util_DeterministicHashMap$linenum_table$_init$7cb044ce4fb0ada8[];

static const unsigned char _jc_soot_util_DeterministicHashMap$param_ptypes$_init$7cb044ce4fb0ada8[] = { 
_JC_TYPE_INT, _JC_TYPE_FLOAT, _JC_TYPE_VOID };

static _jc_type *const _jc_soot_util_DeterministicHashMap$param_types$_init$7cb044ce4fb0ada8[] = {
	&_jc_int$prim$type,
	&_jc_float$prim$type
};

_jc_method _jc_soot_util_DeterministicHashMap$method_info$_init$7cb044ce4fb0ada8 = {
	.name=			"<init>",
	.signature=		"(IF)V",
	.class=			&_jc_soot_util_DeterministicHashMap$type,
	.param_types=		&_jc_soot_util_DeterministicHashMap$param_types$_init$7cb044ce4fb0ada8,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_soot_util_DeterministicHashMap$param_ptypes$_init$7cb044ce4fb0ada8,
	.signature_hash=	_JC_JLONG(0x7cb044ce4fb0ada8),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_util_DeterministicHashMap$method$_init$7cb044ce4fb0ada8,
	.num_parameters=	2,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_soot_util_DeterministicHashMap$linenum_table$_init$7cb044ce4fb0ada8
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_util_DeterministicHashMap, _init$7cb044ce4fb0ada8);

void _JC_JCNI_ATTR
_jc_soot_util_DeterministicHashMap$method$_init$7cb044ce4fb0ada8(_jc_env *const env, _jc_soot_util_DeterministicHashMap$object *this, jint param0, jfloat param1)
{
	jfloat f0;
	jint i0;
	struct _jc_soot_util_DeterministicHashMap$object *r0;
	struct _jc_soot_util_TrustingMonotonicArraySet$object *r1;
	_jc_object_array *r2;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	i0 = param0;
	f0 = param1;
	_JC_LINE_NUMBER(50);				// 0
	_JC_INVOKE_NONVIRTUAL(env, java_util_HashMap, _init$7cb044ce4fb0ada8, 0, r0, i0, f0);
	_JC_LINE_NUMBER(39);				// 1
	r1 = _JC_NEW(env, soot_util_TrustingMonotonicArraySet);
	_JC_PRIM_FIELD(env, r1, soot_util_TrustingMonotonicArraySet, maxElements) = 8;
	r2 = _JC_NEW_REF_ARRAY(env, java_lang_Object, 1, 8);
	_JC_REF_FIELD(env, r1, soot_util_TrustingMonotonicArraySet, elements) = r2;
	_JC_PRIM_FIELD(env, r1, soot_util_TrustingMonotonicArraySet, numElements) = 0;
	_JC_REF_FIELD(env, r0, soot_util_DeterministicHashMap, keys) = r1;
	_JC_LINE_NUMBER(51);				// 2
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public java.util.Collection entries()
//

static _jc_linenum _jc_soot_util_DeterministicHashMap$linenum_table$entries$d8e4daf9891fd963[];

static const unsigned char _jc_soot_util_DeterministicHashMap$param_ptypes$entries$d8e4daf9891fd963[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_soot_util_DeterministicHashMap$method_info$entries$d8e4daf9891fd963 = {
	.name=			"entries",
	.signature=		"()Ljava/util/Collection;",
	.class=			&_jc_soot_util_DeterministicHashMap$type,
	.return_type=		&_jc_java_util_Collection$type,
	.param_ptypes=		&_jc_soot_util_DeterministicHashMap$param_ptypes$entries$d8e4daf9891fd963,
	.signature_hash=	_JC_JLONG(0xd8e4daf9891fd963),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_util_DeterministicHashMap$method$entries$d8e4daf9891fd963,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_util_DeterministicHashMap$vtable, soot_util_DeterministicHashMap.entries$d8e4daf9891fd963) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_soot_util_DeterministicHashMap$linenum_table$entries$d8e4daf9891fd963
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_util_DeterministicHashMap, entries$d8e4daf9891fd963);

_jc_object * _JC_JCNI_ATTR
_jc_soot_util_DeterministicHashMap$method$entries$d8e4daf9891fd963(_jc_env *const env, _jc_soot_util_DeterministicHashMap$object *this)
{
	struct _jc_soot_util_DeterministicHashMap$object *r0;
	struct _jc_java_lang_UnsupportedOperationException$object *r1;
	struct _jc_java_lang_String$object *r2;
	struct _jc_java_lang_VMThrowable$object *r4;

	r0 = this;
	_JC_LINE_NUMBER(65);				// 0
	r1 = _JC_NEW(env, java_lang_UnsupportedOperationException);
	r2 = _JC_NULL;
	_JC_REF_FIELD(env, r1, java_lang_Throwable, cause) = r1;
	r4 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r1);
	_JC_REF_FIELD(env, r1, java_lang_Throwable, vmState) = r4;
	_JC_REF_FIELD(env, r1, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r1, java_lang_Throwable, detailMessage) = r2;
	_JC_THROW(env, r1);
}

//
// public java.util.Set keySet()
//

static _jc_linenum _jc_soot_util_DeterministicHashMap$linenum_table$keySet$de7ce456e8d4e55b[];

static const unsigned char _jc_soot_util_DeterministicHashMap$param_ptypes$keySet$de7ce456e8d4e55b[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_soot_util_DeterministicHashMap$method_info$keySet$de7ce456e8d4e55b = {
	.name=			"keySet",
	.signature=		"()Ljava/util/Set;",
	.class=			&_jc_soot_util_DeterministicHashMap$type,
	.return_type=		&_jc_java_util_Set$type,
	.param_ptypes=		&_jc_soot_util_DeterministicHashMap$param_ptypes$keySet$de7ce456e8d4e55b,
	.signature_hash=	_JC_JLONG(0xde7ce456e8d4e55b),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_util_DeterministicHashMap$method$keySet$de7ce456e8d4e55b,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_util_DeterministicHashMap$vtable, soot_util_DeterministicHashMap.keySet$de7ce456e8d4e55b) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_soot_util_DeterministicHashMap$linenum_table$keySet$de7ce456e8d4e55b
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_util_DeterministicHashMap, keySet$de7ce456e8d4e55b);

_jc_object * _JC_JCNI_ATTR
_jc_soot_util_DeterministicHashMap$method$keySet$de7ce456e8d4e55b(_jc_env *const env, _jc_soot_util_DeterministicHashMap$object *this)
{
	struct _jc_soot_util_DeterministicHashMap$object *r0;
	struct _jc_object *r1;

	r0 = this;
	_JC_LINE_NUMBER(77);				// 0
	r1 = _JC_REF_FIELD(env, r0, soot_util_DeterministicHashMap, keys);
	return r1;
}

//
// public java.lang.Object put(java.lang.Object, java.lang.Object)
//

static _jc_linenum _jc_soot_util_DeterministicHashMap$linenum_table$put$3bd1c078a0faa8da[];

static const unsigned char _jc_soot_util_DeterministicHashMap$param_ptypes$put$3bd1c078a0faa8da[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_soot_util_DeterministicHashMap$param_types$put$3bd1c078a0faa8da[] = {
	&_jc_java_lang_Object$type,
	&_jc_java_lang_Object$type
};

_jc_method _jc_soot_util_DeterministicHashMap$method_info$put$3bd1c078a0faa8da = {
	.name=			"put",
	.signature=		"(Ljava/lang/Object;Ljava/lang/Object;)Ljava/lang/Object;",
	.class=			&_jc_soot_util_DeterministicHashMap$type,
	.param_types=		&_jc_soot_util_DeterministicHashMap$param_types$put$3bd1c078a0faa8da,
	.return_type=		&_jc_java_lang_Object$type,
	.param_ptypes=		&_jc_soot_util_DeterministicHashMap$param_ptypes$put$3bd1c078a0faa8da,
	.signature_hash=	_JC_JLONG(0x3bd1c078a0faa8da),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_util_DeterministicHashMap$method$put$3bd1c078a0faa8da,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_util_DeterministicHashMap$vtable, soot_util_DeterministicHashMap.put$3bd1c078a0faa8da) / sizeof(void *),
	.num_parameters=	2,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	3,
	      .table=	_jc_soot_util_DeterministicHashMap$linenum_table$put$3bd1c078a0faa8da
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_util_DeterministicHashMap, put$3bd1c078a0faa8da);

_jc_java_lang_Object$object * _JC_JCNI_ATTR
_jc_soot_util_DeterministicHashMap$method$put$3bd1c078a0faa8da(_jc_env *const env, _jc_soot_util_DeterministicHashMap$object *this, _jc_java_lang_Object$object *param0, _jc_java_lang_Object$object *param1)
{
	struct _jc_soot_util_DeterministicHashMap$object *r0;
	struct _jc_java_lang_Object$object *r1;
	struct _jc_java_lang_Object$object *r2;
	struct _jc_object *r3;
	jboolean z0;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_LINE_NUMBER(56);				// 0
	z0 = _JC_INVOKE_VIRTUAL(env, java_util_HashMap, containsKey$5db565349ffc17b2, r0, r1);
	if (z0 != 0)
		goto label0;
	_JC_LINE_NUMBER(57);				// 1
	r3 = _JC_REF_FIELD(env, r0, soot_util_DeterministicHashMap, keys);
	_JC_INVOKE_INTERFACE(env, r3, _JC_JLONG(0x831f06ee5f59c0cc), jboolean, (_jc_env *, struct _jc_object *, struct _jc_java_lang_Object$object *), r1);

label0:
	_JC_LINE_NUMBER(59);				// 2
	r2 = _JC_INVOKE_NONVIRTUAL(env, java_util_HashMap, put$3bd1c078a0faa8da, 0, r0, r1, r2);
	return r2;
}

//
// public java.lang.Object remove(java.lang.Object)
//

static _jc_linenum _jc_soot_util_DeterministicHashMap$linenum_table$remove$9efb7487051fd088[];

static const unsigned char _jc_soot_util_DeterministicHashMap$param_ptypes$remove$9efb7487051fd088[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_soot_util_DeterministicHashMap$param_types$remove$9efb7487051fd088[] = {
	&_jc_java_lang_Object$type
};

_jc_method _jc_soot_util_DeterministicHashMap$method_info$remove$9efb7487051fd088 = {
	.name=			"remove",
	.signature=		"(Ljava/lang/Object;)Ljava/lang/Object;",
	.class=			&_jc_soot_util_DeterministicHashMap$type,
	.param_types=		&_jc_soot_util_DeterministicHashMap$param_types$remove$9efb7487051fd088,
	.return_type=		&_jc_java_lang_Object$type,
	.param_ptypes=		&_jc_soot_util_DeterministicHashMap$param_ptypes$remove$9efb7487051fd088,
	.signature_hash=	_JC_JLONG(0x9efb7487051fd088),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_util_DeterministicHashMap$method$remove$9efb7487051fd088,
	.vtable_index=		_JC_OFFSETOF(struct _jc_soot_util_DeterministicHashMap$vtable, soot_util_DeterministicHashMap.remove$9efb7487051fd088) / sizeof(void *),
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_soot_util_DeterministicHashMap$linenum_table$remove$9efb7487051fd088
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_util_DeterministicHashMap, remove$9efb7487051fd088);

_jc_java_lang_Object$object * _JC_JCNI_ATTR
_jc_soot_util_DeterministicHashMap$method$remove$9efb7487051fd088(_jc_env *const env, _jc_soot_util_DeterministicHashMap$object *this, _jc_java_lang_Object$object *param0)
{
	struct _jc_soot_util_DeterministicHashMap$object *r0;
	struct _jc_java_lang_Object$object *r1;
	struct _jc_java_lang_UnsupportedOperationException$object *r2;
	struct _jc_java_lang_String$object *r3;
	struct _jc_java_lang_VMThrowable$object *r5;

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(71);				// 0
	r2 = _JC_NEW(env, java_lang_UnsupportedOperationException);
	r3 = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, cause) = r2;
	r5 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r2);
	_JC_REF_FIELD(env, r2, java_lang_Throwable, vmState) = r5;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, detailMessage) = r3;
	_JC_THROW(env, r2);
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_soot_util_DeterministicHashMap$methods[] = {
	&_jc_soot_util_DeterministicHashMap$method_info$_init$7f1776288300b98d,
	&_jc_soot_util_DeterministicHashMap$method_info$_init$7cb044ce4fb0ada8,
	&_jc_soot_util_DeterministicHashMap$method_info$entries$d8e4daf9891fd963,
	&_jc_soot_util_DeterministicHashMap$method_info$keySet$de7ce456e8d4e55b,
	&_jc_soot_util_DeterministicHashMap$method_info$put$3bd1c078a0faa8da,
	&_jc_soot_util_DeterministicHashMap$method_info$remove$9efb7487051fd088
};

/************************************************************************
 *			   Interface hash table				*
 ************************************************************************/

#if _JC_IMETHOD_HASHSIZE != 128
#error "_JC_IMETHOD_HASHSIZE has the wrong value (should be 128)"
#endif

// Interface lookup hash table buckets
static _jc_method *_jc_soot_util_DeterministicHashMap$imethod_hash_bucket_1[] = {
	&_jc_java_util_AbstractMap$method_info$equals$8a15e0625571c581,
	_JC_NULL
};
static _jc_method *_jc_soot_util_DeterministicHashMap$imethod_hash_bucket_8[] = {
	&_jc_soot_util_DeterministicHashMap$method_info$remove$9efb7487051fd088,
	_JC_NULL
};
static _jc_method *_jc_soot_util_DeterministicHashMap$imethod_hash_bucket_25[] = {
	&_jc_java_util_HashMap$method_info$get$b30461fc5ea13399,
	_JC_NULL
};
static _jc_method *_jc_soot_util_DeterministicHashMap$imethod_hash_bucket_31[] = {
	&_jc_java_util_HashMap$method_info$entrySet$e1cf6e695274e51f,
	_JC_NULL
};
static _jc_method *_jc_soot_util_DeterministicHashMap$imethod_hash_bucket_50[] = {
	&_jc_java_util_HashMap$method_info$containsKey$5db565349ffc17b2,
	_JC_NULL
};
static _jc_method *_jc_soot_util_DeterministicHashMap$imethod_hash_bucket_70[] = {
	&_jc_java_util_HashMap$method_info$values$ff2f8ae502eccb46,
	_JC_NULL
};
static _jc_method *_jc_soot_util_DeterministicHashMap$imethod_hash_bucket_75[] = {
	&_jc_java_util_HashMap$method_info$isEmpty$551bea84f4e0f0cb,
	_JC_NULL
};
static _jc_method *_jc_soot_util_DeterministicHashMap$imethod_hash_bucket_90[] = {
	&_jc_soot_util_DeterministicHashMap$method_info$put$3bd1c078a0faa8da,
	&_jc_java_util_HashMap$method_info$putAll$71b4845a7ea10b5a,
	_JC_NULL
};
static _jc_method *_jc_soot_util_DeterministicHashMap$imethod_hash_bucket_91[] = {
	&_jc_soot_util_DeterministicHashMap$method_info$keySet$de7ce456e8d4e55b,
	_JC_NULL
};
static _jc_method *_jc_soot_util_DeterministicHashMap$imethod_hash_bucket_94[] = {
	&_jc_java_util_HashMap$method_info$size$345df5220fc60ade,
	_JC_NULL
};
static _jc_method *_jc_soot_util_DeterministicHashMap$imethod_hash_bucket_95[] = {
	&_jc_java_util_AbstractMap$method_info$hashCode$53152098849316df,
	_JC_NULL
};
static _jc_method *_jc_soot_util_DeterministicHashMap$imethod_hash_bucket_101[] = {
	&_jc_java_util_HashMap$method_info$containsValue$950e93c8bd77e765,
	_JC_NULL
};
static _jc_method *_jc_soot_util_DeterministicHashMap$imethod_hash_bucket_102[] = {
	&_jc_java_util_HashMap$method_info$clear$0a5acde3ee27a066,
	_JC_NULL
};

// Interface lookup hash table
static _jc_method **_jc_soot_util_DeterministicHashMap$imethod_hash_table[_JC_IMETHOD_HASHSIZE] = {
	[1]=	_jc_soot_util_DeterministicHashMap$imethod_hash_bucket_1,
	[8]=	_jc_soot_util_DeterministicHashMap$imethod_hash_bucket_8,
	[25]=	_jc_soot_util_DeterministicHashMap$imethod_hash_bucket_25,
	[31]=	_jc_soot_util_DeterministicHashMap$imethod_hash_bucket_31,
	[50]=	_jc_soot_util_DeterministicHashMap$imethod_hash_bucket_50,
	[70]=	_jc_soot_util_DeterministicHashMap$imethod_hash_bucket_70,
	[75]=	_jc_soot_util_DeterministicHashMap$imethod_hash_bucket_75,
	[90]=	_jc_soot_util_DeterministicHashMap$imethod_hash_bucket_90,
	[91]=	_jc_soot_util_DeterministicHashMap$imethod_hash_bucket_91,
	[94]=	_jc_soot_util_DeterministicHashMap$imethod_hash_bucket_94,
	[95]=	_jc_soot_util_DeterministicHashMap$imethod_hash_bucket_95,
	[101]=	_jc_soot_util_DeterministicHashMap$imethod_hash_bucket_101,
	[102]=	_jc_soot_util_DeterministicHashMap$imethod_hash_bucket_102
};

// Interface "quick" lookup hash table
static const void *_jc_soot_util_DeterministicHashMap$imethod_quick_table[_JC_IMETHOD_HASHSIZE] = {
	[1]=	&_jc_java_util_AbstractMap$method$equals$8a15e0625571c581,
	[8]=	&_jc_soot_util_DeterministicHashMap$method$remove$9efb7487051fd088,
	[25]=	&_jc_java_util_HashMap$method$get$b30461fc5ea13399,
	[31]=	&_jc_java_util_HashMap$method$entrySet$e1cf6e695274e51f,
	[50]=	&_jc_java_util_HashMap$method$containsKey$5db565349ffc17b2,
	[70]=	&_jc_java_util_HashMap$method$values$ff2f8ae502eccb46,
	[75]=	&_jc_java_util_HashMap$method$isEmpty$551bea84f4e0f0cb,
	[91]=	&_jc_soot_util_DeterministicHashMap$method$keySet$de7ce456e8d4e55b,
	[94]=	&_jc_java_util_HashMap$method$size$345df5220fc60ade,
	[95]=	&_jc_java_util_AbstractMap$method$hashCode$53152098849316df,
	[101]=	&_jc_java_util_HashMap$method$containsValue$950e93c8bd77e765,
	[102]=	&_jc_java_util_HashMap$method$clear$0a5acde3ee27a066
};

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_soot_util_DeterministicHashMap$instanceof_hash_bucket_19[] = {
	&_jc_java_lang_Cloneable$type,
	_JC_NULL
};
static _jc_type *const _jc_soot_util_DeterministicHashMap$instanceof_hash_bucket_28[] = {
	&_jc_java_util_Map$type,
	_JC_NULL
};
static _jc_type *const _jc_soot_util_DeterministicHashMap$instanceof_hash_bucket_31[] = {
	&_jc_java_util_HashMap$type,
	_JC_NULL
};
static _jc_type *const _jc_soot_util_DeterministicHashMap$instanceof_hash_bucket_44[] = {
	&_jc_java_util_AbstractMap$type,
	_JC_NULL
};
static _jc_type *const _jc_soot_util_DeterministicHashMap$instanceof_hash_bucket_65[] = {
	&_jc_java_io_Serializable$type,
	_JC_NULL
};
static _jc_type *const _jc_soot_util_DeterministicHashMap$instanceof_hash_bucket_66[] = {
	&_jc_soot_util_DeterministicHashMap$type,
	_JC_NULL
};
static _jc_type *const _jc_soot_util_DeterministicHashMap$instanceof_hash_bucket_101[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_soot_util_DeterministicHashMap$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[19]=	_jc_soot_util_DeterministicHashMap$instanceof_hash_bucket_19,
	[28]=	_jc_soot_util_DeterministicHashMap$instanceof_hash_bucket_28,
	[31]=	_jc_soot_util_DeterministicHashMap$instanceof_hash_bucket_31,
	[44]=	_jc_soot_util_DeterministicHashMap$instanceof_hash_bucket_44,
	[65]=	_jc_soot_util_DeterministicHashMap$instanceof_hash_bucket_65,
	[66]=	_jc_soot_util_DeterministicHashMap$instanceof_hash_bucket_66,
	[101]=	_jc_soot_util_DeterministicHashMap$instanceof_hash_bucket_101
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_soot_util_DeterministicHashMap$class_depends[] = {
	{ "java/io/Serializable",	_JC_JLONG(0x9a35c7173b37e641) },
	{ "java/lang/Class",	_JC_JLONG(0x764eb76bc6714ae3) },
	{ "java/lang/Cloneable",	_JC_JLONG(0x9b667b09132be893) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/Object",	_JC_JLONG(0x1c4f1fc002fc96e5) },
	{ "java/lang/RuntimeException",	_JC_JLONG(0x4f5534a987354d1d) },
	{ "java/lang/String",	_JC_JLONG(0xc25a545561a18c38) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/UnsupportedOperationException",	_JC_JLONG(0xc4b275d49bb21d98) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/util/AbstractCollection",	_JC_JLONG(0x8ea716c64b77f8eb) },
	{ "java/util/AbstractMap",	_JC_JLONG(0xc7382c60132d0b2c) },
	{ "java/util/AbstractSet",	_JC_JLONG(0xca427569b5b2f804) },
	{ "java/util/Collection",	_JC_JLONG(0xeae4d0c0e8eb63da) },
	{ "java/util/HashMap",	_JC_JLONG(0xd7cd853200c3e71f) },
	{ "java/util/Map",	_JC_JLONG(0xe283f7c2e7a7979c) },
	{ "java/util/Set",	_JC_JLONG(0x617ac82c0bec2dff) },
	{ "soot/util/TrustingMonotonicArraySet",	_JC_JLONG(0x1c7d0f313dc80173) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_soot_util_DeterministicHashMap$vtype _jc_soot_util_DeterministicHashMap$type = {
    .type= {
	.name=			"soot/util/DeterministicHashMap",
	.superclass=		&_jc_java_util_HashMap$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_soot_util_DeterministicHashMap$imethod_hash_table,
	.imethod_quick_table=	_jc_soot_util_DeterministicHashMap$imethod_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		52,
		.hash=			_JC_JLONG(0xc3934e18893865c2),
		.source_file=		"DeterministicHashMap.java",
		.instance_size=		sizeof(_jc_soot_util_DeterministicHashMap$refs) + sizeof(_jc_soot_util_DeterministicHashMap$object),
		.num_virtual_refs=	5,
		.num_fields=		sizeof(_jc_soot_util_DeterministicHashMap$fields) / sizeof(*_jc_soot_util_DeterministicHashMap$fields),
		.fields=		_jc_soot_util_DeterministicHashMap$fields,
		.num_methods=		sizeof(_jc_soot_util_DeterministicHashMap$methods) / sizeof(*_jc_soot_util_DeterministicHashMap$methods),
		.methods=		_jc_soot_util_DeterministicHashMap$methods,
		.instanceof_hash_table=	_jc_soot_util_DeterministicHashMap$instanceof_hash_table,
		.num_class_depends=		sizeof(_jc_soot_util_DeterministicHashMap$class_depends) / sizeof(*_jc_soot_util_DeterministicHashMap$class_depends),
		.class_depends=		_jc_soot_util_DeterministicHashMap$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=			// overridden
		&_jc_java_util_HashMap$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=			// overridden
		&_jc_java_util_AbstractMap$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=			// overridden
		&_jc_java_util_AbstractMap$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=			// overridden
		&_jc_java_util_AbstractMap$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.java_util_AbstractMap= {
	    .clear$0a5acde3ee27a066=			// overridden
		&_jc_java_util_HashMap$method$clear$0a5acde3ee27a066,
	    .clone$b75f2713d6705f70=			// overridden
		&_jc_java_util_HashMap$method$clone$b75f2713d6705f70,
	    .containsKey$5db565349ffc17b2=			// overridden
		&_jc_java_util_HashMap$method$containsKey$5db565349ffc17b2,
	    .containsValue$950e93c8bd77e765=		// overridden
		&_jc_java_util_HashMap$method$containsValue$950e93c8bd77e765,
	    .entrySet$e1cf6e695274e51f=			// overridden
		&_jc_java_util_HashMap$method$entrySet$e1cf6e695274e51f,
	    .equals$8a15e0625571c581=
		&_jc_java_util_AbstractMap$method$equals$8a15e0625571c581,
	    .get$b30461fc5ea13399=				// overridden
		&_jc_java_util_HashMap$method$get$b30461fc5ea13399,
	    .hashCode$53152098849316df=
		&_jc_java_util_AbstractMap$method$hashCode$53152098849316df,
	    .isEmpty$551bea84f4e0f0cb=			// overridden
		&_jc_java_util_HashMap$method$isEmpty$551bea84f4e0f0cb,
	    .keySet$de7ce456e8d4e55b=			// overridden
		&_jc_soot_util_DeterministicHashMap$method$keySet$de7ce456e8d4e55b,
	    .put$3bd1c078a0faa8da=				// overridden
		&_jc_soot_util_DeterministicHashMap$method$put$3bd1c078a0faa8da,
	    .putAll$71b4845a7ea10b5a=			// overridden
		&_jc_java_util_HashMap$method$putAll$71b4845a7ea10b5a,
	    .remove$9efb7487051fd088=			// overridden
		&_jc_soot_util_DeterministicHashMap$method$remove$9efb7487051fd088,
	    .size$345df5220fc60ade=				// overridden
		&_jc_java_util_HashMap$method$size$345df5220fc60ade,
	    .toString$7ea43b33b80a3070=
		&_jc_java_util_AbstractMap$method$toString$7ea43b33b80a3070,
	    .values$ff2f8ae502eccb46=			// overridden
		&_jc_java_util_HashMap$method$values$ff2f8ae502eccb46,
	},
	.java_util_HashMap= {
	    .addEntry$668da564143d61f5=
		&_jc_java_util_HashMap$method$addEntry$668da564143d61f5,
	    .clear$0a5acde3ee27a066=
		&_jc_java_util_HashMap$method$clear$0a5acde3ee27a066,
	    .clone$b75f2713d6705f70=
		&_jc_java_util_HashMap$method$clone$b75f2713d6705f70,
	    .containsKey$5db565349ffc17b2=
		&_jc_java_util_HashMap$method$containsKey$5db565349ffc17b2,
	    .containsValue$950e93c8bd77e765=
		&_jc_java_util_HashMap$method$containsValue$950e93c8bd77e765,
	    .entrySet$e1cf6e695274e51f=
		&_jc_java_util_HashMap$method$entrySet$e1cf6e695274e51f,
	    .get$b30461fc5ea13399=
		&_jc_java_util_HashMap$method$get$b30461fc5ea13399,
	    .getEntry$235dac1128435b17=
		&_jc_java_util_HashMap$method$getEntry$235dac1128435b17,
	    .hash$459d4acbac3950f2=
		&_jc_java_util_HashMap$method$hash$459d4acbac3950f2,
	    .isEmpty$551bea84f4e0f0cb=
		&_jc_java_util_HashMap$method$isEmpty$551bea84f4e0f0cb,
	    .iterator$4d686e9a30f23c2b=
		&_jc_java_util_HashMap$method$iterator$4d686e9a30f23c2b,
	    .keySet$de7ce456e8d4e55b=			// overridden
		&_jc_soot_util_DeterministicHashMap$method$keySet$de7ce456e8d4e55b,
	    .put$3bd1c078a0faa8da=				// overridden
		&_jc_soot_util_DeterministicHashMap$method$put$3bd1c078a0faa8da,
	    .putAll$71b4845a7ea10b5a=
		&_jc_java_util_HashMap$method$putAll$71b4845a7ea10b5a,
	    .putAllInternal$82874ea4bc56b28b=
		&_jc_java_util_HashMap$method$putAllInternal$82874ea4bc56b28b,
	    .readObject$a94c095c21a0b9e8=
		&_jc_java_util_HashMap$method$readObject$a94c095c21a0b9e8,
	    .rehash$fc379f1473a26c39=
		&_jc_java_util_HashMap$method$rehash$fc379f1473a26c39,
	    .remove$9efb7487051fd088=			// overridden
		&_jc_soot_util_DeterministicHashMap$method$remove$9efb7487051fd088,
	    .size$345df5220fc60ade=
		&_jc_java_util_HashMap$method$size$345df5220fc60ade,
	    .values$ff2f8ae502eccb46=
		&_jc_java_util_HashMap$method$values$ff2f8ae502eccb46,
	    .writeObject$6755db4c37bbfbcf=
		&_jc_java_util_HashMap$method$writeObject$6755db4c37bbfbcf,
	},
	.soot_util_DeterministicHashMap= {
	    .entries$d8e4daf9891fd963=
		&_jc_soot_util_DeterministicHashMap$method$entries$d8e4daf9891fd963,
	    .keySet$de7ce456e8d4e55b=
		&_jc_soot_util_DeterministicHashMap$method$keySet$de7ce456e8d4e55b,
	    .put$3bd1c078a0faa8da=
		&_jc_soot_util_DeterministicHashMap$method$put$3bd1c078a0faa8da,
	    .remove$9efb7487051fd088=
		&_jc_soot_util_DeterministicHashMap$method$remove$9efb7487051fd088,
	},
    }
};

